# common settings for library
set_lib_name         GF180MCUC
set_dotlib_name      GF180MCUC.lib
set_verilog_name     GF180MCUC.v
set_cell_name_suffix GF180MCUC_
set_cell_name_prefix _V1
set_voltage_unit V
set_capacitance_unit pF
set_resistance_unit Ohm
set_current_unit mA
set_leakage_power_unit pW 
set_energy_unit fJ 
set_time_unit ns
set_vdd_name VDD
set_vss_name VSS
set_pwell_name VPW
set_nwell_name VNW
# characterization conditions 
set_process typ
set_temperature 25
set_vdd_voltage 5
set_vss_voltage 0
set_pwell_voltage 0
set_nwell_voltage 5
set_logic_threshold_high 0.8
set_logic_threshold_low 0.2
set_logic_high_to_low_threshold 0.5
set_logic_low_to_high_threshold 0.5
set_work_dir work
set_simulator /usr/bin/ngspice 
set_run_sim true
set_mt_sim true
set_supress_message false
set_supress_sim_message false
set_supress_debug_message true
set_energy_meas_low_threshold 0.01
set_energy_meas_high_threshold 0.99
set_energy_meas_time_extent 10
set_operating_conditions PVT_3P5V_25C
# initialize workspace
initialize

## add circuit
add_cell -n AOAOOAI21123 -l AOAOOAI21123 -i E2 E1 E D1 D C B A1 A -o Y -f Y=(!E2&!E1&!E&!D1&!D&!C&!B&!A1&!A|E2&!E1&!E&!D1&!D&!C&!B&!A1&!A|E2&E1&!E&!D1&!D&!C&!B&!A1&!A|!E2&E1&!E&!D1&!D&!C&!B&!A1&!A|!E2&E1&E&!D1&!D&!C&!B&!A1&!A|E2&E1&E&!D1&!D&!C&!B&!A1&!A|E2&!E1&E&!D1&!D&!C&!B&!A1&!A|!E2&!E1&E&!D1&!D&!C&!B&!A1&!A|!E2&!E1&!E&D1&!D&!C&!B&!A1&!A|!E2&!E1&!E&D1&D&!C&!B&!A1&!A|!E2&!E1&!E&!D1&D&!C&!B&!A1&!A|!E2&!E1&!E&!D1&D&C&!B&!A1&!A|!E2&!E1&!E&D1&D&C&!B&!A1&!A|!E2&!E1&!E&D1&!D&C&!B&!A1&!A|!E2&!E1&E&!D1&!D&C&!B&!A1&!A|E2&!E1&E&!D1&!D&C&!B&!A1&!A|E2&E1&E&!D1&!D&C&!B&!A1&!A|!E2&E1&E&!D1&!D&C&!B&!A1&!A|!E2&E1&!E&!D1&!D&C&!B&!A1&!A|E2&E1&!E&!D1&!D&C&!B&!A1&!A|E2&!E1&!E&!D1&!D&C&!B&!A1&!A|!E2&!E1&!E&!D1&!D&C&!B&!A1&!A|!E2&!E1&!E&!D1&!D&C&B&!A1&!A|!E2&!E1&!E&D1&!D&C&B&!A1&!A|!E2&!E1&!E&D1&D&C&B&!A1&!A|!E2&!E1&!E&!D1&D&C&B&!A1&!A|!E2&!E1&!E&!D1&D&!C&B&!A1&!A|!E2&!E1&!E&D1&D&!C&B&!A1&!A|!E2&!E1&!E&D1&!D&!C&B&!A1&!A|!E2&!E1&E&!D1&!D&!C&B&!A1&!A|E2&!E1&E&!D1&!D&!C&B&!A1&!A|E2&E1&E&!D1&!D&!C&B&!A1&!A|!E2&E1&E&!D1&!D&!C&B&!A1&!A|!E2&E1&!E&!D1&!D&!C&B&!A1&!A|E2&E1&!E&!D1&!D&!C&B&!A1&!A|E2&!E1&!E&!D1&!D&!C&B&!A1&!A|!E2&!E1&!E&!D1&!D&!C&B&!A1&!A|!E2&!E1&!E&!D1&!D&!C&B&A1&!A|E2&!E1&!E&!D1&!D&!C&B&A1&!A|E2&E1&!E&!D1&!D&!C&B&A1&!A|!E2&E1&!E&!D1&!D&!C&B&A1&!A|!E2&E1&E&!D1&!D&!C&B&A1&!A|E2&E1&E&!D1&!D&!C&B&A1&!A|E2&!E1&E&!D1&!D&!C&B&A1&!A|!E2&!E1&E&!D1&!D&!C&B&A1&!A|!E2&!E1&!E&D1&!D&!C&B&A1&!A|!E2&!E1&!E&D1&D&!C&B&A1&!A|!E2&!E1&!E&!D1&D&!C&B&A1&!A|!E2&!E1&!E&!D1&D&C&B&A1&!A|!E2&!E1&!E&D1&D&C&B&A1&!A|!E2&!E1&!E&D1&!D&C&B&A1&!A|!E2&!E1&!E&!D1&!D&C&B&A1&!A|!E2&!E1&!E&!D1&!D&C&!B&A1&!A|E2&!E1&!E&!D1&!D&C&!B&A1&!A|E2&E1&!E&!D1&!D&C&!B&A1&!A|!E2&E1&!E&!D1&!D&C&!B&A1&!A|!E2&E1&E&!D1&!D&C&!B&A1&!A|E2&E1&E&!D1&!D&C&!B&A1&!A|E2&!E1&E&!D1&!D&C&!B&A1&!A|!E2&!E1&E&!D1&!D&C&!B&A1&!A|!E2&!E1&!E&D1&!D&C&!B&A1&!A|!E2&!E1&!E&D1&D&C&!B&A1&!A|!E2&!E1&!E&!D1&D&C&!B&A1&!A|!E2&!E1&!E&!D1&D&!C&!B&A1&!A|!E2&!E1&!E&D1&D&!C&!B&A1&!A|!E2&!E1&!E&D1&!D&!C&!B&A1&!A|!E2&!E1&E&!D1&!D&!C&!B&A1&!A|E2&!E1&E&!D1&!D&!C&!B&A1&!A|E2&E1&E&!D1&!D&!C&!B&A1&!A|!E2&E1&E&!D1&!D&!C&!B&A1&!A|!E2&E1&!E&!D1&!D&!C&!B&A1&!A|E2&E1&!E&!D1&!D&!C&!B&A1&!A|E2&!E1&!E&!D1&!D&!C&!B&A1&!A|!E2&!E1&!E&!D1&!D&!C&!B&A1&!A|!E2&!E1&!E&!D1&!D&!C&!B&A1&A|E2&!E1&!E&!D1&!D&!C&!B&A1&A|E2&E1&!E&!D1&!D&!C&!B&A1&A|!E2&E1&!E&!D1&!D&!C&!B&A1&A|!E2&E1&E&!D1&!D&!C&!B&A1&A|E2&E1&E&!D1&!D&!C&!B&A1&A|E2&!E1&E&!D1&!D&!C&!B&A1&A|!E2&!E1&E&!D1&!D&!C&!B&A1&A|!E2&!E1&!E&D1&!D&!C&!B&A1&A|!E2&!E1&!E&D1&D&!C&!B&A1&A|!E2&!E1&!E&!D1&D&!C&!B&A1&A|!E2&!E1&!E&!D1&D&C&!B&A1&A|!E2&!E1&!E&D1&D&C&!B&A1&A|!E2&!E1&!E&D1&!D&C&!B&A1&A|!E2&!E1&!E&!D1&!D&C&!B&A1&A|!E2&!E1&!E&!D1&!D&C&B&A1&A|!E2&!E1&!E&D1&!D&C&B&A1&A|!E2&!E1&!E&D1&D&C&B&A1&A|!E2&!E1&!E&!D1&D&C&B&A1&A|!E2&!E1&!E&!D1&D&!C&B&A1&A|!E2&!E1&!E&D1&D&!C&B&A1&A|!E2&!E1&!E&D1&!D&!C&B&A1&A|!E2&!E1&E&!D1&!D&!C&B&A1&A|E2&!E1&E&!D1&!D&!C&B&A1&A|E2&E1&E&!D1&!D&!C&B&A1&A|!E2&E1&E&!D1&!D&!C&B&A1&A|!E2&E1&!E&!D1&!D&!C&B&A1&A|E2&E1&!E&!D1&!D&!C&B&A1&A|E2&!E1&!E&!D1&!D&!C&B&A1&A|!E2&!E1&!E&!D1&!D&!C&B&A1&A|!E2&!E1&!E&!D1&!D&!C&B&!A1&A|E2&!E1&!E&!D1&!D&!C&B&!A1&A|E2&E1&!E&!D1&!D&!C&B&!A1&A|!E2&E1&!E&!D1&!D&!C&B&!A1&A|!E2&E1&E&!D1&!D&!C&B&!A1&A|E2&E1&E&!D1&!D&!C&B&!A1&A|E2&!E1&E&!D1&!D&!C&B&!A1&A|!E2&!E1&E&!D1&!D&!C&B&!A1&A|!E2&!E1&!E&D1&!D&!C&B&!A1&A|!E2&!E1&!E&D1&D&!C&B&!A1&A|!E2&!E1&!E&!D1&D&!C&B&!A1&A|!E2&!E1&!E&!D1&D&C&B&!A1&A|!E2&!E1&!E&D1&D&C&B&!A1&A|!E2&!E1&!E&D1&!D&C&B&!A1&A|!E2&!E1&!E&!D1&!D&C&B&!A1&A|!E2&!E1&!E&!D1&!D&C&!B&!A1&A|E2&!E1&!E&!D1&!D&C&!B&!A1&A|E2&E1&!E&!D1&!D&C&!B&!A1&A|!E2&E1&!E&!D1&!D&C&!B&!A1&A|!E2&E1&E&!D1&!D&C&!B&!A1&A|E2&E1&E&!D1&!D&C&!B&!A1&A|E2&!E1&E&!D1&!D&C&!B&!A1&A|!E2&!E1&E&!D1&!D&C&!B&!A1&A|!E2&!E1&!E&D1&!D&C&!B&!A1&A|!E2&!E1&!E&D1&D&C&!B&!A1&A|!E2&!E1&!E&!D1&D&C&!B&!A1&A|!E2&!E1&!E&!D1&D&!C&!B&!A1&A|!E2&!E1&!E&D1&D&!C&!B&!A1&A|!E2&!E1&!E&D1&!D&!C&!B&!A1&A|!E2&!E1&E&!D1&!D&!C&!B&!A1&A|E2&!E1&E&!D1&!D&!C&!B&!A1&A|E2&E1&E&!D1&!D&!C&!B&!A1&A|!E2&E1&E&!D1&!D&!C&!B&!A1&A|!E2&E1&!E&!D1&!D&!C&!B&!A1&A|E2&E1&!E&!D1&!D&!C&!B&!A1&A|E2&!E1&!E&!D1&!D&!C&!B&!A1&A|!E2&!E1&!E&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOOAI21123.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOAOAI212111 -l OAAOAOAI212111 -i F E D C1 C B A1 A -o Y -f Y=!(F&E&!D&!C1&!C&!B&!A1&!A|F&E&D&!C1&!C&!B&!A1&!A|F&E&D&C1&!C&!B&!A1&!A|F&E&!D&C1&!C&!B&!A1&!A|F&E&!D&C1&C&!B&!A1&!A|F&E&D&C1&C&!B&!A1&!A|F&!E&D&C1&C&!B&!A1&!A|F&E&D&!C1&C&!B&!A1&!A|F&E&!D&!C1&C&!B&!A1&!A|F&E&!D&!C1&C&B&!A1&!A|F&E&D&!C1&C&B&!A1&!A|F&!E&D&C1&C&B&!A1&!A|F&E&D&C1&C&B&!A1&!A|F&E&!D&C1&C&B&!A1&!A|F&E&!D&C1&!C&B&!A1&!A|F&E&D&C1&!C&B&!A1&!A|F&E&D&!C1&!C&B&!A1&!A|F&E&!D&!C1&!C&B&!A1&!A|F&E&!D&!C1&!C&B&A1&!A|F&E&D&!C1&!C&B&A1&!A|F&!E&D&!C1&!C&B&A1&!A|F&!E&D&C1&!C&B&A1&!A|F&E&D&C1&!C&B&A1&!A|F&E&!D&C1&!C&B&A1&!A|F&E&!D&C1&C&B&A1&!A|F&E&D&C1&C&B&A1&!A|F&!E&D&C1&C&B&A1&!A|F&!E&D&!C1&C&B&A1&!A|F&E&D&!C1&C&B&A1&!A|F&E&!D&!C1&C&B&A1&!A|F&E&!D&!C1&C&!B&A1&!A|F&E&D&!C1&C&!B&A1&!A|F&!E&D&C1&C&!B&A1&!A|F&E&D&C1&C&!B&A1&!A|F&E&!D&C1&C&!B&A1&!A|F&E&!D&C1&!C&!B&A1&!A|F&E&D&C1&!C&!B&A1&!A|F&E&D&!C1&!C&!B&A1&!A|F&E&!D&!C1&!C&!B&A1&!A|F&E&!D&!C1&!C&!B&A1&A|F&E&D&!C1&!C&!B&A1&A|F&E&D&C1&!C&!B&A1&A|F&E&!D&C1&!C&!B&A1&A|F&E&!D&C1&C&!B&A1&A|F&E&D&C1&C&!B&A1&A|F&!E&D&C1&C&!B&A1&A|F&E&D&!C1&C&!B&A1&A|F&E&!D&!C1&C&!B&A1&A|F&E&!D&!C1&C&B&A1&A|F&E&D&!C1&C&B&A1&A|F&!E&D&!C1&C&B&A1&A|F&!E&D&C1&C&B&A1&A|F&E&D&C1&C&B&A1&A|F&E&!D&C1&C&B&A1&A|F&E&!D&C1&!C&B&A1&A|F&E&D&C1&!C&B&A1&A|F&!E&D&C1&!C&B&A1&A|F&!E&D&!C1&!C&B&A1&A|F&E&D&!C1&!C&B&A1&A|F&E&!D&!C1&!C&B&A1&A|F&E&!D&!C1&!C&B&!A1&A|F&E&D&!C1&!C&B&!A1&A|F&!E&D&!C1&!C&B&!A1&A|F&!E&D&C1&!C&B&!A1&A|F&E&D&C1&!C&B&!A1&A|F&E&!D&C1&!C&B&!A1&A|F&E&!D&C1&C&B&!A1&A|F&E&D&C1&C&B&!A1&A|F&!E&D&C1&C&B&!A1&A|F&!E&D&!C1&C&B&!A1&A|F&E&D&!C1&C&B&!A1&A|F&E&!D&!C1&C&B&!A1&A|F&E&!D&!C1&C&!B&!A1&A|F&E&D&!C1&C&!B&!A1&A|F&!E&D&C1&C&!B&!A1&A|F&E&D&C1&C&!B&!A1&A|F&E&!D&C1&C&!B&!A1&A|F&E&!D&C1&!C&!B&!A1&A|F&E&D&C1&!C&!B&!A1&A|F&E&D&!C1&!C&!B&!A1&A|F&E&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOAOAI212111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAOI221211 -l AAOOAOI221211 -i F E D1 D C B1 B A1 A -o Y -f Y=(!F&!E&!D1&!D&!C&!B1&!B&!A1&!A|!F&E&!D1&!D&!C&!B1&!B&!A1&!A|!F&E&D1&!D&!C&!B1&!B&!A1&!A|!F&!E&D1&!D&!C&!B1&!B&!A1&!A|!F&!E&D1&D&!C&!B1&!B&!A1&!A|!F&E&D1&D&!C&!B1&!B&!A1&!A|!F&E&!D1&D&!C&!B1&!B&!A1&!A|!F&!E&!D1&D&!C&!B1&!B&!A1&!A|!F&!E&!D1&D&C&!B1&!B&!A1&!A|!F&!E&D1&D&C&!B1&!B&!A1&!A|!F&!E&D1&!D&C&!B1&!B&!A1&!A|!F&E&!D1&!D&C&!B1&!B&!A1&!A|!F&!E&!D1&!D&C&!B1&!B&!A1&!A|!F&!E&!D1&!D&C&B1&!B&!A1&!A|!F&E&!D1&!D&C&B1&!B&!A1&!A|!F&!E&D1&!D&C&B1&!B&!A1&!A|!F&!E&D1&D&C&B1&!B&!A1&!A|!F&!E&!D1&D&C&B1&!B&!A1&!A|!F&!E&!D1&D&!C&B1&!B&!A1&!A|!F&E&!D1&D&!C&B1&!B&!A1&!A|!F&E&D1&D&!C&B1&!B&!A1&!A|!F&!E&D1&D&!C&B1&!B&!A1&!A|!F&!E&D1&!D&!C&B1&!B&!A1&!A|!F&E&D1&!D&!C&B1&!B&!A1&!A|!F&E&!D1&!D&!C&B1&!B&!A1&!A|!F&!E&!D1&!D&!C&B1&!B&!A1&!A|!F&!E&!D1&!D&!C&B1&B&!A1&!A|!F&E&!D1&!D&!C&B1&B&!A1&!A|!F&!E&D1&!D&!C&B1&B&!A1&!A|!F&!E&D1&D&!C&B1&B&!A1&!A|!F&!E&!D1&D&!C&B1&B&!A1&!A|!F&!E&!D1&D&C&B1&B&!A1&!A|!F&!E&D1&D&C&B1&B&!A1&!A|!F&!E&D1&!D&C&B1&B&!A1&!A|!F&E&!D1&!D&C&B1&B&!A1&!A|!F&!E&!D1&!D&C&B1&B&!A1&!A|!F&!E&!D1&!D&C&!B1&B&!A1&!A|!F&E&!D1&!D&C&!B1&B&!A1&!A|!F&!E&D1&!D&C&!B1&B&!A1&!A|!F&!E&D1&D&C&!B1&B&!A1&!A|!F&!E&!D1&D&C&!B1&B&!A1&!A|!F&!E&!D1&D&!C&!B1&B&!A1&!A|!F&E&!D1&D&!C&!B1&B&!A1&!A|!F&E&D1&D&!C&!B1&B&!A1&!A|!F&!E&D1&D&!C&!B1&B&!A1&!A|!F&!E&D1&!D&!C&!B1&B&!A1&!A|!F&E&D1&!D&!C&!B1&B&!A1&!A|!F&E&!D1&!D&!C&!B1&B&!A1&!A|!F&!E&!D1&!D&!C&!B1&B&!A1&!A|!F&!E&!D1&!D&!C&!B1&B&A1&!A|!F&E&!D1&!D&!C&!B1&B&A1&!A|!F&E&D1&!D&!C&!B1&B&A1&!A|!F&!E&D1&!D&!C&!B1&B&A1&!A|!F&!E&D1&D&!C&!B1&B&A1&!A|!F&E&D1&D&!C&!B1&B&A1&!A|!F&E&!D1&D&!C&!B1&B&A1&!A|!F&!E&!D1&D&!C&!B1&B&A1&!A|!F&!E&!D1&D&C&!B1&B&A1&!A|!F&!E&D1&D&C&!B1&B&A1&!A|!F&!E&D1&!D&C&!B1&B&A1&!A|!F&E&!D1&!D&C&!B1&B&A1&!A|!F&!E&!D1&!D&C&!B1&B&A1&!A|!F&!E&!D1&!D&C&B1&B&A1&!A|!F&E&!D1&!D&C&B1&B&A1&!A|!F&!E&D1&!D&C&B1&B&A1&!A|!F&!E&D1&D&C&B1&B&A1&!A|!F&!E&!D1&D&C&B1&B&A1&!A|!F&!E&!D1&D&!C&B1&B&A1&!A|!F&!E&D1&D&!C&B1&B&A1&!A|!F&!E&D1&!D&!C&B1&B&A1&!A|!F&E&!D1&!D&!C&B1&B&A1&!A|!F&!E&!D1&!D&!C&B1&B&A1&!A|!F&!E&!D1&!D&!C&B1&!B&A1&!A|!F&E&!D1&!D&!C&B1&!B&A1&!A|!F&E&D1&!D&!C&B1&!B&A1&!A|!F&!E&D1&!D&!C&B1&!B&A1&!A|!F&!E&D1&D&!C&B1&!B&A1&!A|!F&E&D1&D&!C&B1&!B&A1&!A|!F&E&!D1&D&!C&B1&!B&A1&!A|!F&!E&!D1&D&!C&B1&!B&A1&!A|!F&!E&!D1&D&C&B1&!B&A1&!A|!F&!E&D1&D&C&B1&!B&A1&!A|!F&!E&D1&!D&C&B1&!B&A1&!A|!F&E&!D1&!D&C&B1&!B&A1&!A|!F&!E&!D1&!D&C&B1&!B&A1&!A|!F&!E&!D1&!D&C&!B1&!B&A1&!A|!F&E&!D1&!D&C&!B1&!B&A1&!A|!F&!E&D1&!D&C&!B1&!B&A1&!A|!F&!E&D1&D&C&!B1&!B&A1&!A|!F&!E&!D1&D&C&!B1&!B&A1&!A|!F&!E&!D1&D&!C&!B1&!B&A1&!A|!F&E&!D1&D&!C&!B1&!B&A1&!A|!F&E&D1&D&!C&!B1&!B&A1&!A|!F&!E&D1&D&!C&!B1&!B&A1&!A|!F&!E&D1&!D&!C&!B1&!B&A1&!A|!F&E&D1&!D&!C&!B1&!B&A1&!A|!F&E&!D1&!D&!C&!B1&!B&A1&!A|!F&!E&!D1&!D&!C&!B1&!B&A1&!A|!F&!E&!D1&!D&!C&!B1&!B&A1&A|!F&E&!D1&!D&!C&!B1&!B&A1&A|!F&!E&D1&!D&!C&!B1&!B&A1&A|!F&!E&D1&D&!C&!B1&!B&A1&A|!F&!E&!D1&D&!C&!B1&!B&A1&A|!F&!E&!D1&D&C&!B1&!B&A1&A|!F&!E&D1&D&C&!B1&!B&A1&A|!F&!E&D1&!D&C&!B1&!B&A1&A|!F&E&!D1&!D&C&!B1&!B&A1&A|!F&!E&!D1&!D&C&!B1&!B&A1&A|!F&!E&!D1&!D&C&B1&!B&A1&A|!F&E&!D1&!D&C&B1&!B&A1&A|!F&!E&D1&!D&C&B1&!B&A1&A|!F&!E&D1&D&C&B1&!B&A1&A|!F&!E&!D1&D&C&B1&!B&A1&A|!F&!E&!D1&D&!C&B1&!B&A1&A|!F&!E&D1&D&!C&B1&!B&A1&A|!F&!E&D1&!D&!C&B1&!B&A1&A|!F&E&!D1&!D&!C&B1&!B&A1&A|!F&!E&!D1&!D&!C&B1&!B&A1&A|!F&!E&!D1&!D&!C&B1&B&A1&A|!F&E&!D1&!D&!C&B1&B&A1&A|!F&!E&D1&!D&!C&B1&B&A1&A|!F&!E&D1&D&!C&B1&B&A1&A|!F&!E&!D1&D&!C&B1&B&A1&A|!F&!E&!D1&D&C&B1&B&A1&A|!F&!E&D1&D&C&B1&B&A1&A|!F&!E&D1&!D&C&B1&B&A1&A|!F&E&!D1&!D&C&B1&B&A1&A|!F&!E&!D1&!D&C&B1&B&A1&A|!F&!E&!D1&!D&C&!B1&B&A1&A|!F&E&!D1&!D&C&!B1&B&A1&A|!F&!E&D1&!D&C&!B1&B&A1&A|!F&!E&D1&D&C&!B1&B&A1&A|!F&!E&!D1&D&C&!B1&B&A1&A|!F&!E&!D1&D&!C&!B1&B&A1&A|!F&!E&D1&D&!C&!B1&B&A1&A|!F&!E&D1&!D&!C&!B1&B&A1&A|!F&E&!D1&!D&!C&!B1&B&A1&A|!F&!E&!D1&!D&!C&!B1&B&A1&A|!F&!E&!D1&!D&!C&!B1&B&!A1&A|!F&E&!D1&!D&!C&!B1&B&!A1&A|!F&E&D1&!D&!C&!B1&B&!A1&A|!F&!E&D1&!D&!C&!B1&B&!A1&A|!F&!E&D1&D&!C&!B1&B&!A1&A|!F&E&D1&D&!C&!B1&B&!A1&A|!F&E&!D1&D&!C&!B1&B&!A1&A|!F&!E&!D1&D&!C&!B1&B&!A1&A|!F&!E&!D1&D&C&!B1&B&!A1&A|!F&!E&D1&D&C&!B1&B&!A1&A|!F&!E&D1&!D&C&!B1&B&!A1&A|!F&E&!D1&!D&C&!B1&B&!A1&A|!F&!E&!D1&!D&C&!B1&B&!A1&A|!F&!E&!D1&!D&C&B1&B&!A1&A|!F&E&!D1&!D&C&B1&B&!A1&A|!F&!E&D1&!D&C&B1&B&!A1&A|!F&!E&D1&D&C&B1&B&!A1&A|!F&!E&!D1&D&C&B1&B&!A1&A|!F&!E&!D1&D&!C&B1&B&!A1&A|!F&!E&D1&D&!C&B1&B&!A1&A|!F&!E&D1&!D&!C&B1&B&!A1&A|!F&E&!D1&!D&!C&B1&B&!A1&A|!F&!E&!D1&!D&!C&B1&B&!A1&A|!F&!E&!D1&!D&!C&B1&!B&!A1&A|!F&E&!D1&!D&!C&B1&!B&!A1&A|!F&E&D1&!D&!C&B1&!B&!A1&A|!F&!E&D1&!D&!C&B1&!B&!A1&A|!F&!E&D1&D&!C&B1&!B&!A1&A|!F&E&D1&D&!C&B1&!B&!A1&A|!F&E&!D1&D&!C&B1&!B&!A1&A|!F&!E&!D1&D&!C&B1&!B&!A1&A|!F&!E&!D1&D&C&B1&!B&!A1&A|!F&!E&D1&D&C&B1&!B&!A1&A|!F&!E&D1&!D&C&B1&!B&!A1&A|!F&E&!D1&!D&C&B1&!B&!A1&A|!F&!E&!D1&!D&C&B1&!B&!A1&A|!F&!E&!D1&!D&C&!B1&!B&!A1&A|!F&E&!D1&!D&C&!B1&!B&!A1&A|!F&!E&D1&!D&C&!B1&!B&!A1&A|!F&!E&D1&D&C&!B1&!B&!A1&A|!F&!E&!D1&D&C&!B1&!B&!A1&A|!F&!E&!D1&D&!C&!B1&!B&!A1&A|!F&E&!D1&D&!C&!B1&!B&!A1&A|!F&E&D1&D&!C&!B1&!B&!A1&A|!F&!E&D1&D&!C&!B1&!B&!A1&A|!F&!E&D1&!D&!C&!B1&!B&!A1&A|!F&E&D1&!D&!C&!B1&!B&!A1&A|!F&E&!D1&!D&!C&!B1&!B&!A1&A|!F&!E&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAOI221211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAI212 -l AOOAI212 -i C1 C B A1 A -o Y -f Y=!(!C1&C&B&!A1&!A|C1&C&B&!A1&!A|C1&!C&B&!A1&!A|C1&!C&B&A1&!A|C1&C&B&A1&!A|!C1&C&B&A1&!A|C1&!C&!B&A1&A|C1&C&!B&A1&A|!C1&C&!B&A1&A|!C1&C&B&A1&A|C1&C&B&A1&A|C1&!C&B&A1&A|C1&!C&B&!A1&A|C1&C&B&!A1&A|!C1&C&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAI212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAAOI22122 -l AAOAAAOI22122 -i E1 E D1 D C B1 B A1 A -o Y -f Y=(!E1&!E&!D1&!D&!C&!B1&!B&!A1&!A|E1&!E&!D1&!D&!C&!B1&!B&!A1&!A|!E1&E&!D1&!D&!C&!B1&!B&!A1&!A|!E1&E&D1&!D&!C&!B1&!B&!A1&!A|E1&!E&D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&D1&!D&!C&!B1&!B&!A1&!A|!E1&E&!D1&D&!C&!B1&!B&!A1&!A|E1&!E&!D1&D&!C&!B1&!B&!A1&!A|!E1&!E&!D1&D&!C&!B1&!B&!A1&!A|!E1&!E&!D1&D&C&!B1&!B&!A1&!A|E1&!E&!D1&D&C&!B1&!B&!A1&!A|!E1&E&!D1&D&C&!B1&!B&!A1&!A|!E1&!E&D1&!D&C&!B1&!B&!A1&!A|E1&!E&D1&!D&C&!B1&!B&!A1&!A|!E1&E&D1&!D&C&!B1&!B&!A1&!A|!E1&E&!D1&!D&C&!B1&!B&!A1&!A|E1&!E&!D1&!D&C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&C&B1&!B&!A1&!A|E1&!E&!D1&!D&C&B1&!B&!A1&!A|!E1&E&!D1&!D&C&B1&!B&!A1&!A|!E1&E&D1&!D&C&B1&!B&!A1&!A|E1&!E&D1&!D&C&B1&!B&!A1&!A|!E1&!E&D1&!D&C&B1&!B&!A1&!A|!E1&E&!D1&D&C&B1&!B&!A1&!A|E1&!E&!D1&D&C&B1&!B&!A1&!A|!E1&!E&!D1&D&C&B1&!B&!A1&!A|!E1&!E&!D1&D&!C&B1&!B&!A1&!A|E1&!E&!D1&D&!C&B1&!B&!A1&!A|!E1&E&!D1&D&!C&B1&!B&!A1&!A|!E1&!E&D1&!D&!C&B1&!B&!A1&!A|E1&!E&D1&!D&!C&B1&!B&!A1&!A|!E1&E&D1&!D&!C&B1&!B&!A1&!A|!E1&E&!D1&!D&!C&B1&!B&!A1&!A|E1&!E&!D1&!D&!C&B1&!B&!A1&!A|!E1&!E&!D1&!D&!C&B1&!B&!A1&!A|!E1&!E&!D1&!D&!C&B1&B&!A1&!A|E1&!E&!D1&!D&!C&B1&B&!A1&!A|!E1&E&!D1&!D&!C&B1&B&!A1&!A|!E1&E&D1&!D&!C&B1&B&!A1&!A|E1&!E&D1&!D&!C&B1&B&!A1&!A|!E1&!E&D1&!D&!C&B1&B&!A1&!A|!E1&E&!D1&D&!C&B1&B&!A1&!A|E1&!E&!D1&D&!C&B1&B&!A1&!A|!E1&!E&!D1&D&!C&B1&B&!A1&!A|!E1&!E&!D1&!D&C&!B1&B&!A1&!A|E1&!E&!D1&!D&C&!B1&B&!A1&!A|!E1&E&!D1&!D&C&!B1&B&!A1&!A|!E1&E&D1&!D&C&!B1&B&!A1&!A|E1&!E&D1&!D&C&!B1&B&!A1&!A|!E1&!E&D1&!D&C&!B1&B&!A1&!A|!E1&E&!D1&D&C&!B1&B&!A1&!A|E1&!E&!D1&D&C&!B1&B&!A1&!A|!E1&!E&!D1&D&C&!B1&B&!A1&!A|!E1&!E&!D1&D&!C&!B1&B&!A1&!A|E1&!E&!D1&D&!C&!B1&B&!A1&!A|!E1&E&!D1&D&!C&!B1&B&!A1&!A|!E1&!E&D1&!D&!C&!B1&B&!A1&!A|E1&!E&D1&!D&!C&!B1&B&!A1&!A|!E1&E&D1&!D&!C&!B1&B&!A1&!A|!E1&E&!D1&!D&!C&!B1&B&!A1&!A|E1&!E&!D1&!D&!C&!B1&B&!A1&!A|!E1&!E&!D1&!D&!C&!B1&B&!A1&!A|!E1&!E&!D1&!D&!C&!B1&B&A1&!A|E1&!E&!D1&!D&!C&!B1&B&A1&!A|!E1&E&!D1&!D&!C&!B1&B&A1&!A|!E1&E&D1&!D&!C&!B1&B&A1&!A|E1&!E&D1&!D&!C&!B1&B&A1&!A|!E1&!E&D1&!D&!C&!B1&B&A1&!A|!E1&E&!D1&D&!C&!B1&B&A1&!A|E1&!E&!D1&D&!C&!B1&B&A1&!A|!E1&!E&!D1&D&!C&!B1&B&A1&!A|!E1&!E&!D1&D&C&!B1&B&A1&!A|E1&!E&!D1&D&C&!B1&B&A1&!A|!E1&E&!D1&D&C&!B1&B&A1&!A|!E1&!E&D1&!D&C&!B1&B&A1&!A|E1&!E&D1&!D&C&!B1&B&A1&!A|!E1&E&D1&!D&C&!B1&B&A1&!A|!E1&E&!D1&!D&C&!B1&B&A1&!A|E1&!E&!D1&!D&C&!B1&B&A1&!A|!E1&!E&!D1&!D&C&!B1&B&A1&!A|!E1&!E&!D1&D&!C&B1&B&A1&!A|E1&!E&!D1&D&!C&B1&B&A1&!A|!E1&E&!D1&D&!C&B1&B&A1&!A|!E1&!E&D1&!D&!C&B1&B&A1&!A|E1&!E&D1&!D&!C&B1&B&A1&!A|!E1&E&D1&!D&!C&B1&B&A1&!A|!E1&E&!D1&!D&!C&B1&B&A1&!A|E1&!E&!D1&!D&!C&B1&B&A1&!A|!E1&!E&!D1&!D&!C&B1&B&A1&!A|!E1&!E&!D1&!D&!C&B1&!B&A1&!A|E1&!E&!D1&!D&!C&B1&!B&A1&!A|!E1&E&!D1&!D&!C&B1&!B&A1&!A|!E1&E&D1&!D&!C&B1&!B&A1&!A|E1&!E&D1&!D&!C&B1&!B&A1&!A|!E1&!E&D1&!D&!C&B1&!B&A1&!A|!E1&E&!D1&D&!C&B1&!B&A1&!A|E1&!E&!D1&D&!C&B1&!B&A1&!A|!E1&!E&!D1&D&!C&B1&!B&A1&!A|!E1&!E&!D1&D&C&B1&!B&A1&!A|E1&!E&!D1&D&C&B1&!B&A1&!A|!E1&E&!D1&D&C&B1&!B&A1&!A|!E1&!E&D1&!D&C&B1&!B&A1&!A|E1&!E&D1&!D&C&B1&!B&A1&!A|!E1&E&D1&!D&C&B1&!B&A1&!A|!E1&E&!D1&!D&C&B1&!B&A1&!A|E1&!E&!D1&!D&C&B1&!B&A1&!A|!E1&!E&!D1&!D&C&B1&!B&A1&!A|!E1&!E&!D1&!D&C&!B1&!B&A1&!A|E1&!E&!D1&!D&C&!B1&!B&A1&!A|!E1&E&!D1&!D&C&!B1&!B&A1&!A|!E1&E&D1&!D&C&!B1&!B&A1&!A|E1&!E&D1&!D&C&!B1&!B&A1&!A|!E1&!E&D1&!D&C&!B1&!B&A1&!A|!E1&E&!D1&D&C&!B1&!B&A1&!A|E1&!E&!D1&D&C&!B1&!B&A1&!A|!E1&!E&!D1&D&C&!B1&!B&A1&!A|!E1&!E&!D1&D&!C&!B1&!B&A1&!A|E1&!E&!D1&D&!C&!B1&!B&A1&!A|!E1&E&!D1&D&!C&!B1&!B&A1&!A|!E1&!E&D1&!D&!C&!B1&!B&A1&!A|E1&!E&D1&!D&!C&!B1&!B&A1&!A|!E1&E&D1&!D&!C&!B1&!B&A1&!A|!E1&E&!D1&!D&!C&!B1&!B&A1&!A|E1&!E&!D1&!D&!C&!B1&!B&A1&!A|!E1&!E&!D1&!D&!C&!B1&!B&A1&!A|!E1&!E&!D1&!D&!C&!B1&!B&A1&A|E1&!E&!D1&!D&!C&!B1&!B&A1&A|!E1&E&!D1&!D&!C&!B1&!B&A1&A|!E1&E&D1&!D&!C&!B1&!B&A1&A|E1&!E&D1&!D&!C&!B1&!B&A1&A|!E1&!E&D1&!D&!C&!B1&!B&A1&A|!E1&E&!D1&D&!C&!B1&!B&A1&A|E1&!E&!D1&D&!C&!B1&!B&A1&A|!E1&!E&!D1&D&!C&!B1&!B&A1&A|!E1&!E&!D1&D&!C&B1&!B&A1&A|E1&!E&!D1&D&!C&B1&!B&A1&A|!E1&E&!D1&D&!C&B1&!B&A1&A|!E1&!E&D1&!D&!C&B1&!B&A1&A|E1&!E&D1&!D&!C&B1&!B&A1&A|!E1&E&D1&!D&!C&B1&!B&A1&A|!E1&E&!D1&!D&!C&B1&!B&A1&A|E1&!E&!D1&!D&!C&B1&!B&A1&A|!E1&!E&!D1&!D&!C&B1&!B&A1&A|!E1&!E&!D1&!D&!C&B1&B&A1&A|E1&!E&!D1&!D&!C&B1&B&A1&A|!E1&E&!D1&!D&!C&B1&B&A1&A|!E1&E&D1&!D&!C&B1&B&A1&A|E1&!E&D1&!D&!C&B1&B&A1&A|!E1&!E&D1&!D&!C&B1&B&A1&A|!E1&E&!D1&D&!C&B1&B&A1&A|E1&!E&!D1&D&!C&B1&B&A1&A|!E1&!E&!D1&D&!C&B1&B&A1&A|!E1&!E&!D1&D&!C&!B1&B&A1&A|E1&!E&!D1&D&!C&!B1&B&A1&A|!E1&E&!D1&D&!C&!B1&B&A1&A|!E1&!E&D1&!D&!C&!B1&B&A1&A|E1&!E&D1&!D&!C&!B1&B&A1&A|!E1&E&D1&!D&!C&!B1&B&A1&A|!E1&E&!D1&!D&!C&!B1&B&A1&A|E1&!E&!D1&!D&!C&!B1&B&A1&A|!E1&!E&!D1&!D&!C&!B1&B&A1&A|!E1&!E&!D1&!D&!C&!B1&B&!A1&A|E1&!E&!D1&!D&!C&!B1&B&!A1&A|!E1&E&!D1&!D&!C&!B1&B&!A1&A|!E1&E&D1&!D&!C&!B1&B&!A1&A|E1&!E&D1&!D&!C&!B1&B&!A1&A|!E1&!E&D1&!D&!C&!B1&B&!A1&A|!E1&E&!D1&D&!C&!B1&B&!A1&A|E1&!E&!D1&D&!C&!B1&B&!A1&A|!E1&!E&!D1&D&!C&!B1&B&!A1&A|!E1&!E&!D1&D&C&!B1&B&!A1&A|E1&!E&!D1&D&C&!B1&B&!A1&A|!E1&E&!D1&D&C&!B1&B&!A1&A|!E1&!E&D1&!D&C&!B1&B&!A1&A|E1&!E&D1&!D&C&!B1&B&!A1&A|!E1&E&D1&!D&C&!B1&B&!A1&A|!E1&E&!D1&!D&C&!B1&B&!A1&A|E1&!E&!D1&!D&C&!B1&B&!A1&A|!E1&!E&!D1&!D&C&!B1&B&!A1&A|!E1&!E&!D1&D&!C&B1&B&!A1&A|E1&!E&!D1&D&!C&B1&B&!A1&A|!E1&E&!D1&D&!C&B1&B&!A1&A|!E1&!E&D1&!D&!C&B1&B&!A1&A|E1&!E&D1&!D&!C&B1&B&!A1&A|!E1&E&D1&!D&!C&B1&B&!A1&A|!E1&E&!D1&!D&!C&B1&B&!A1&A|E1&!E&!D1&!D&!C&B1&B&!A1&A|!E1&!E&!D1&!D&!C&B1&B&!A1&A|!E1&!E&!D1&!D&!C&B1&!B&!A1&A|E1&!E&!D1&!D&!C&B1&!B&!A1&A|!E1&E&!D1&!D&!C&B1&!B&!A1&A|!E1&E&D1&!D&!C&B1&!B&!A1&A|E1&!E&D1&!D&!C&B1&!B&!A1&A|!E1&!E&D1&!D&!C&B1&!B&!A1&A|!E1&E&!D1&D&!C&B1&!B&!A1&A|E1&!E&!D1&D&!C&B1&!B&!A1&A|!E1&!E&!D1&D&!C&B1&!B&!A1&A|!E1&!E&!D1&D&C&B1&!B&!A1&A|E1&!E&!D1&D&C&B1&!B&!A1&A|!E1&E&!D1&D&C&B1&!B&!A1&A|!E1&!E&D1&!D&C&B1&!B&!A1&A|E1&!E&D1&!D&C&B1&!B&!A1&A|!E1&E&D1&!D&C&B1&!B&!A1&A|!E1&E&!D1&!D&C&B1&!B&!A1&A|E1&!E&!D1&!D&C&B1&!B&!A1&A|!E1&!E&!D1&!D&C&B1&!B&!A1&A|!E1&!E&!D1&!D&C&!B1&!B&!A1&A|E1&!E&!D1&!D&C&!B1&!B&!A1&A|!E1&E&!D1&!D&C&!B1&!B&!A1&A|!E1&E&D1&!D&C&!B1&!B&!A1&A|E1&!E&D1&!D&C&!B1&!B&!A1&A|!E1&!E&D1&!D&C&!B1&!B&!A1&A|!E1&E&!D1&D&C&!B1&!B&!A1&A|E1&!E&!D1&D&C&!B1&!B&!A1&A|!E1&!E&!D1&D&C&!B1&!B&!A1&A|!E1&!E&!D1&D&!C&!B1&!B&!A1&A|E1&!E&!D1&D&!C&!B1&!B&!A1&A|!E1&E&!D1&D&!C&!B1&!B&!A1&A|!E1&!E&D1&!D&!C&!B1&!B&!A1&A|E1&!E&D1&!D&!C&!B1&!B&!A1&A|!E1&E&D1&!D&!C&!B1&!B&!A1&A|!E1&E&!D1&!D&!C&!B1&!B&!A1&A|E1&!E&!D1&!D&!C&!B1&!B&!A1&A|!E1&!E&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAAOI22122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAI2214 -l AAOOAI2214 -i D3 D2 D1 D C B1 B A1 A -o Y -f Y=(!D3&!D2&!D1&!D&!C&!B1&!B&!A1&!A|D3&!D2&!D1&!D&!C&!B1&!B&!A1&!A|D3&D2&!D1&!D&!C&!B1&!B&!A1&!A|!D3&D2&!D1&!D&!C&!B1&!B&!A1&!A|!D3&D2&D1&!D&!C&!B1&!B&!A1&!A|D3&D2&D1&!D&!C&!B1&!B&!A1&!A|D3&!D2&D1&!D&!C&!B1&!B&!A1&!A|!D3&!D2&D1&!D&!C&!B1&!B&!A1&!A|!D3&!D2&D1&D&!C&!B1&!B&!A1&!A|D3&!D2&D1&D&!C&!B1&!B&!A1&!A|D3&D2&D1&D&!C&!B1&!B&!A1&!A|!D3&D2&D1&D&!C&!B1&!B&!A1&!A|!D3&D2&!D1&D&!C&!B1&!B&!A1&!A|D3&D2&!D1&D&!C&!B1&!B&!A1&!A|D3&!D2&!D1&D&!C&!B1&!B&!A1&!A|!D3&!D2&!D1&D&!C&!B1&!B&!A1&!A|!D3&!D2&!D1&!D&C&!B1&!B&!A1&!A|!D3&!D2&!D1&!D&C&B1&!B&!A1&!A|!D3&!D2&!D1&D&!C&B1&!B&!A1&!A|D3&!D2&!D1&D&!C&B1&!B&!A1&!A|D3&D2&!D1&D&!C&B1&!B&!A1&!A|!D3&D2&!D1&D&!C&B1&!B&!A1&!A|!D3&D2&D1&D&!C&B1&!B&!A1&!A|D3&D2&D1&D&!C&B1&!B&!A1&!A|D3&!D2&D1&D&!C&B1&!B&!A1&!A|!D3&!D2&D1&D&!C&B1&!B&!A1&!A|!D3&!D2&D1&!D&!C&B1&!B&!A1&!A|D3&!D2&D1&!D&!C&B1&!B&!A1&!A|D3&D2&D1&!D&!C&B1&!B&!A1&!A|!D3&D2&D1&!D&!C&B1&!B&!A1&!A|!D3&D2&!D1&!D&!C&B1&!B&!A1&!A|D3&D2&!D1&!D&!C&B1&!B&!A1&!A|D3&!D2&!D1&!D&!C&B1&!B&!A1&!A|!D3&!D2&!D1&!D&!C&B1&!B&!A1&!A|!D3&!D2&!D1&!D&!C&B1&B&!A1&!A|!D3&!D2&!D1&!D&C&B1&B&!A1&!A|!D3&!D2&!D1&!D&C&!B1&B&!A1&!A|!D3&!D2&!D1&D&!C&!B1&B&!A1&!A|D3&!D2&!D1&D&!C&!B1&B&!A1&!A|D3&D2&!D1&D&!C&!B1&B&!A1&!A|!D3&D2&!D1&D&!C&!B1&B&!A1&!A|!D3&D2&D1&D&!C&!B1&B&!A1&!A|D3&D2&D1&D&!C&!B1&B&!A1&!A|D3&!D2&D1&D&!C&!B1&B&!A1&!A|!D3&!D2&D1&D&!C&!B1&B&!A1&!A|!D3&!D2&D1&!D&!C&!B1&B&!A1&!A|D3&!D2&D1&!D&!C&!B1&B&!A1&!A|D3&D2&D1&!D&!C&!B1&B&!A1&!A|!D3&D2&D1&!D&!C&!B1&B&!A1&!A|!D3&D2&!D1&!D&!C&!B1&B&!A1&!A|D3&D2&!D1&!D&!C&!B1&B&!A1&!A|D3&!D2&!D1&!D&!C&!B1&B&!A1&!A|!D3&!D2&!D1&!D&!C&!B1&B&!A1&!A|!D3&!D2&!D1&!D&!C&!B1&B&A1&!A|D3&!D2&!D1&!D&!C&!B1&B&A1&!A|D3&D2&!D1&!D&!C&!B1&B&A1&!A|!D3&D2&!D1&!D&!C&!B1&B&A1&!A|!D3&D2&D1&!D&!C&!B1&B&A1&!A|D3&D2&D1&!D&!C&!B1&B&A1&!A|D3&!D2&D1&!D&!C&!B1&B&A1&!A|!D3&!D2&D1&!D&!C&!B1&B&A1&!A|!D3&!D2&D1&D&!C&!B1&B&A1&!A|D3&!D2&D1&D&!C&!B1&B&A1&!A|D3&D2&D1&D&!C&!B1&B&A1&!A|!D3&D2&D1&D&!C&!B1&B&A1&!A|!D3&D2&!D1&D&!C&!B1&B&A1&!A|D3&D2&!D1&D&!C&!B1&B&A1&!A|D3&!D2&!D1&D&!C&!B1&B&A1&!A|!D3&!D2&!D1&D&!C&!B1&B&A1&!A|!D3&!D2&!D1&!D&C&!B1&B&A1&!A|!D3&!D2&!D1&!D&C&B1&B&A1&!A|!D3&!D2&!D1&!D&!C&B1&B&A1&!A|!D3&!D2&!D1&!D&!C&B1&!B&A1&!A|D3&!D2&!D1&!D&!C&B1&!B&A1&!A|D3&D2&!D1&!D&!C&B1&!B&A1&!A|!D3&D2&!D1&!D&!C&B1&!B&A1&!A|!D3&D2&D1&!D&!C&B1&!B&A1&!A|D3&D2&D1&!D&!C&B1&!B&A1&!A|D3&!D2&D1&!D&!C&B1&!B&A1&!A|!D3&!D2&D1&!D&!C&B1&!B&A1&!A|!D3&!D2&D1&D&!C&B1&!B&A1&!A|D3&!D2&D1&D&!C&B1&!B&A1&!A|D3&D2&D1&D&!C&B1&!B&A1&!A|!D3&D2&D1&D&!C&B1&!B&A1&!A|!D3&D2&!D1&D&!C&B1&!B&A1&!A|D3&D2&!D1&D&!C&B1&!B&A1&!A|D3&!D2&!D1&D&!C&B1&!B&A1&!A|!D3&!D2&!D1&D&!C&B1&!B&A1&!A|!D3&!D2&!D1&!D&C&B1&!B&A1&!A|!D3&!D2&!D1&!D&C&!B1&!B&A1&!A|!D3&!D2&!D1&D&!C&!B1&!B&A1&!A|D3&!D2&!D1&D&!C&!B1&!B&A1&!A|D3&D2&!D1&D&!C&!B1&!B&A1&!A|!D3&D2&!D1&D&!C&!B1&!B&A1&!A|!D3&D2&D1&D&!C&!B1&!B&A1&!A|D3&D2&D1&D&!C&!B1&!B&A1&!A|D3&!D2&D1&D&!C&!B1&!B&A1&!A|!D3&!D2&D1&D&!C&!B1&!B&A1&!A|!D3&!D2&D1&!D&!C&!B1&!B&A1&!A|D3&!D2&D1&!D&!C&!B1&!B&A1&!A|D3&D2&D1&!D&!C&!B1&!B&A1&!A|!D3&D2&D1&!D&!C&!B1&!B&A1&!A|!D3&D2&!D1&!D&!C&!B1&!B&A1&!A|D3&D2&!D1&!D&!C&!B1&!B&A1&!A|D3&!D2&!D1&!D&!C&!B1&!B&A1&!A|!D3&!D2&!D1&!D&!C&!B1&!B&A1&!A|!D3&!D2&!D1&!D&!C&!B1&!B&A1&A|!D3&!D2&!D1&!D&C&!B1&!B&A1&A|!D3&!D2&!D1&!D&C&B1&!B&A1&A|!D3&!D2&!D1&!D&!C&B1&!B&A1&A|!D3&!D2&!D1&!D&!C&B1&B&A1&A|!D3&!D2&!D1&!D&C&B1&B&A1&A|!D3&!D2&!D1&!D&C&!B1&B&A1&A|!D3&!D2&!D1&!D&!C&!B1&B&A1&A|!D3&!D2&!D1&!D&!C&!B1&B&!A1&A|D3&!D2&!D1&!D&!C&!B1&B&!A1&A|D3&D2&!D1&!D&!C&!B1&B&!A1&A|!D3&D2&!D1&!D&!C&!B1&B&!A1&A|!D3&D2&D1&!D&!C&!B1&B&!A1&A|D3&D2&D1&!D&!C&!B1&B&!A1&A|D3&!D2&D1&!D&!C&!B1&B&!A1&A|!D3&!D2&D1&!D&!C&!B1&B&!A1&A|!D3&!D2&D1&D&!C&!B1&B&!A1&A|D3&!D2&D1&D&!C&!B1&B&!A1&A|D3&D2&D1&D&!C&!B1&B&!A1&A|!D3&D2&D1&D&!C&!B1&B&!A1&A|!D3&D2&!D1&D&!C&!B1&B&!A1&A|D3&D2&!D1&D&!C&!B1&B&!A1&A|D3&!D2&!D1&D&!C&!B1&B&!A1&A|!D3&!D2&!D1&D&!C&!B1&B&!A1&A|!D3&!D2&!D1&!D&C&!B1&B&!A1&A|!D3&!D2&!D1&!D&C&B1&B&!A1&A|!D3&!D2&!D1&!D&!C&B1&B&!A1&A|!D3&!D2&!D1&!D&!C&B1&!B&!A1&A|D3&!D2&!D1&!D&!C&B1&!B&!A1&A|D3&D2&!D1&!D&!C&B1&!B&!A1&A|!D3&D2&!D1&!D&!C&B1&!B&!A1&A|!D3&D2&D1&!D&!C&B1&!B&!A1&A|D3&D2&D1&!D&!C&B1&!B&!A1&A|D3&!D2&D1&!D&!C&B1&!B&!A1&A|!D3&!D2&D1&!D&!C&B1&!B&!A1&A|!D3&!D2&D1&D&!C&B1&!B&!A1&A|D3&!D2&D1&D&!C&B1&!B&!A1&A|D3&D2&D1&D&!C&B1&!B&!A1&A|!D3&D2&D1&D&!C&B1&!B&!A1&A|!D3&D2&!D1&D&!C&B1&!B&!A1&A|D3&D2&!D1&D&!C&B1&!B&!A1&A|D3&!D2&!D1&D&!C&B1&!B&!A1&A|!D3&!D2&!D1&D&!C&B1&!B&!A1&A|!D3&!D2&!D1&!D&C&B1&!B&!A1&A|!D3&!D2&!D1&!D&C&!B1&!B&!A1&A|!D3&!D2&!D1&D&!C&!B1&!B&!A1&A|D3&!D2&!D1&D&!C&!B1&!B&!A1&A|D3&D2&!D1&D&!C&!B1&!B&!A1&A|!D3&D2&!D1&D&!C&!B1&!B&!A1&A|!D3&D2&D1&D&!C&!B1&!B&!A1&A|D3&D2&D1&D&!C&!B1&!B&!A1&A|D3&!D2&D1&D&!C&!B1&!B&!A1&A|!D3&!D2&D1&D&!C&!B1&!B&!A1&A|!D3&!D2&D1&!D&!C&!B1&!B&!A1&A|D3&!D2&D1&!D&!C&!B1&!B&!A1&A|D3&D2&D1&!D&!C&!B1&!B&!A1&A|!D3&D2&D1&!D&!C&!B1&!B&!A1&A|!D3&D2&!D1&!D&!C&!B1&!B&!A1&A|D3&D2&!D1&!D&!C&!B1&!B&!A1&A|D3&!D2&!D1&!D&!C&!B1&!B&!A1&A|!D3&!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAI2214.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOI322 -l OOAAOI322 -i C1 C B1 B A2 A1 A -o Y -f Y=(!C1&!C&!B1&!B&!A2&!A1&!A|C1&!C&!B1&!B&!A2&!A1&!A|!C1&C&!B1&!B&!A2&!A1&!A|!C1&C&B1&!B&!A2&!A1&!A|C1&!C&B1&!B&!A2&!A1&!A|!C1&!C&B1&!B&!A2&!A1&!A|!C1&!C&B1&B&!A2&!A1&!A|C1&!C&B1&B&!A2&!A1&!A|!C1&C&B1&B&!A2&!A1&!A|!C1&C&!B1&B&!A2&!A1&!A|C1&!C&!B1&B&!A2&!A1&!A|!C1&!C&!B1&B&!A2&!A1&!A|!C1&C&!B1&!B&A2&!A1&!A|C1&!C&!B1&!B&A2&!A1&!A|!C1&!C&!B1&!B&A2&!A1&!A|!C1&!C&!B1&!B&A2&A1&!A|C1&!C&!B1&!B&A2&A1&!A|!C1&C&!B1&!B&A2&A1&!A|!C1&C&!B1&!B&!A2&A1&!A|C1&!C&!B1&!B&!A2&A1&!A|!C1&!C&!B1&!B&!A2&A1&!A|!C1&!C&!B1&!B&!A2&A1&A|C1&!C&!B1&!B&!A2&A1&A|!C1&C&!B1&!B&!A2&A1&A|!C1&C&!B1&!B&A2&A1&A|C1&!C&!B1&!B&A2&A1&A|!C1&!C&!B1&!B&A2&A1&A|!C1&!C&!B1&!B&A2&!A1&A|C1&!C&!B1&!B&A2&!A1&A|!C1&C&!B1&!B&A2&!A1&A|!C1&C&!B1&!B&!A2&!A1&A|C1&!C&!B1&!B&!A2&!A1&A|!C1&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOI322.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOAOI32111 -l OAOAOI32111 -i E D C B1 B A2 A1 A -o Y -f Y=(!E&!D&!C&!B1&!B&!A2&!A1&!A|!E&D&!C&!B1&!B&!A2&!A1&!A|!E&!D&C&!B1&!B&!A2&!A1&!A|!E&!D&C&B1&!B&!A2&!A1&!A|!E&D&!C&B1&!B&!A2&!A1&!A|!E&!D&!C&B1&!B&!A2&!A1&!A|!E&!D&!C&B1&B&!A2&!A1&!A|!E&D&!C&B1&B&!A2&!A1&!A|!E&!D&C&B1&B&!A2&!A1&!A|!E&!D&C&!B1&B&!A2&!A1&!A|!E&D&!C&!B1&B&!A2&!A1&!A|!E&!D&!C&!B1&B&!A2&!A1&!A|!E&!D&!C&!B1&B&A2&!A1&!A|!E&D&!C&!B1&B&A2&!A1&!A|!E&!D&C&!B1&B&A2&!A1&!A|!E&!D&C&B1&B&A2&!A1&!A|!E&!D&!C&B1&B&A2&!A1&!A|!E&!D&!C&B1&!B&A2&!A1&!A|!E&D&!C&B1&!B&A2&!A1&!A|!E&!D&C&B1&!B&A2&!A1&!A|!E&!D&C&!B1&!B&A2&!A1&!A|!E&D&!C&!B1&!B&A2&!A1&!A|!E&!D&!C&!B1&!B&A2&!A1&!A|!E&!D&!C&!B1&!B&A2&A1&!A|!E&D&!C&!B1&!B&A2&A1&!A|!E&!D&C&!B1&!B&A2&A1&!A|!E&!D&C&B1&!B&A2&A1&!A|!E&D&!C&B1&!B&A2&A1&!A|!E&!D&!C&B1&!B&A2&A1&!A|!E&!D&!C&B1&B&A2&A1&!A|!E&!D&C&B1&B&A2&A1&!A|!E&!D&C&!B1&B&A2&A1&!A|!E&D&!C&!B1&B&A2&A1&!A|!E&!D&!C&!B1&B&A2&A1&!A|!E&!D&!C&!B1&B&!A2&A1&!A|!E&D&!C&!B1&B&!A2&A1&!A|!E&!D&C&!B1&B&!A2&A1&!A|!E&!D&C&B1&B&!A2&A1&!A|!E&!D&!C&B1&B&!A2&A1&!A|!E&!D&!C&B1&!B&!A2&A1&!A|!E&D&!C&B1&!B&!A2&A1&!A|!E&!D&C&B1&!B&!A2&A1&!A|!E&!D&C&!B1&!B&!A2&A1&!A|!E&D&!C&!B1&!B&!A2&A1&!A|!E&!D&!C&!B1&!B&!A2&A1&!A|!E&!D&!C&!B1&!B&!A2&A1&A|!E&D&!C&!B1&!B&!A2&A1&A|!E&!D&C&!B1&!B&!A2&A1&A|!E&!D&C&B1&!B&!A2&A1&A|!E&D&!C&B1&!B&!A2&A1&A|!E&!D&!C&B1&!B&!A2&A1&A|!E&!D&!C&B1&B&!A2&A1&A|!E&!D&C&B1&B&!A2&A1&A|!E&!D&C&!B1&B&!A2&A1&A|!E&D&!C&!B1&B&!A2&A1&A|!E&!D&!C&!B1&B&!A2&A1&A|!E&!D&!C&!B1&B&A2&A1&A|!E&D&!C&!B1&B&A2&A1&A|!E&!D&C&!B1&B&A2&A1&A|!E&!D&C&B1&B&A2&A1&A|!E&!D&!C&B1&B&A2&A1&A|!E&!D&!C&B1&!B&A2&A1&A|!E&D&!C&B1&!B&A2&A1&A|!E&!D&C&B1&!B&A2&A1&A|!E&!D&C&!B1&!B&A2&A1&A|!E&D&!C&!B1&!B&A2&A1&A|!E&!D&!C&!B1&!B&A2&A1&A|!E&!D&!C&!B1&!B&A2&!A1&A|!E&D&!C&!B1&!B&A2&!A1&A|!E&!D&C&!B1&!B&A2&!A1&A|!E&!D&C&B1&!B&A2&!A1&A|!E&D&!C&B1&!B&A2&!A1&A|!E&!D&!C&B1&!B&A2&!A1&A|!E&!D&!C&B1&B&A2&!A1&A|!E&!D&C&B1&B&A2&!A1&A|!E&!D&C&!B1&B&A2&!A1&A|!E&D&!C&!B1&B&A2&!A1&A|!E&!D&!C&!B1&B&A2&!A1&A|!E&!D&!C&!B1&B&!A2&!A1&A|!E&D&!C&!B1&B&!A2&!A1&A|!E&!D&C&!B1&B&!A2&!A1&A|!E&!D&C&B1&B&!A2&!A1&A|!E&!D&!C&B1&B&!A2&!A1&A|!E&!D&!C&B1&!B&!A2&!A1&A|!E&D&!C&B1&!B&!A2&!A1&A|!E&!D&C&B1&!B&!A2&!A1&A|!E&!D&C&!B1&!B&!A2&!A1&A|!E&D&!C&!B1&!B&!A2&!A1&A|!E&!D&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOAOI32111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOI32 -l AAOI32 -i B1 B A2 A1 A -o Y -f Y=!(B1&B&!A2&!A1&!A|B1&B&A2&!A1&!A|B1&B&A2&A1&!A|B1&B&!A2&A1&!A|B1&B&!A2&A1&A|!B1&B&A2&A1&A|B1&B&A2&A1&A|B1&!B&A2&A1&A|!B1&!B&A2&A1&A|B1&B&A2&!A1&A|B1&B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOI32.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOI3131 -l AOOAOI3131 -i D C2 C1 C B A2 A1 A -o Y -f Y=(!D&!C2&!C1&!C&!B&!A2&!A1&!A|!D&C2&!C1&!C&!B&!A2&!A1&!A|!D&C2&C1&!C&!B&!A2&!A1&!A|!D&!C2&C1&!C&!B&!A2&!A1&!A|!D&!C2&C1&C&!B&!A2&!A1&!A|!D&C2&C1&C&!B&!A2&!A1&!A|!D&C2&!C1&C&!B&!A2&!A1&!A|!D&!C2&!C1&C&!B&!A2&!A1&!A|!D&!C2&!C1&!C&B&!A2&!A1&!A|!D&!C2&!C1&!C&B&A2&!A1&!A|!D&!C2&!C1&C&!B&A2&!A1&!A|!D&C2&!C1&C&!B&A2&!A1&!A|!D&C2&C1&C&!B&A2&!A1&!A|!D&!C2&C1&C&!B&A2&!A1&!A|!D&!C2&C1&!C&!B&A2&!A1&!A|!D&C2&C1&!C&!B&A2&!A1&!A|!D&C2&!C1&!C&!B&A2&!A1&!A|!D&!C2&!C1&!C&!B&A2&!A1&!A|!D&!C2&!C1&!C&!B&A2&A1&!A|!D&C2&!C1&!C&!B&A2&A1&!A|!D&C2&C1&!C&!B&A2&A1&!A|!D&!C2&C1&!C&!B&A2&A1&!A|!D&!C2&C1&C&!B&A2&A1&!A|!D&C2&C1&C&!B&A2&A1&!A|!D&C2&!C1&C&!B&A2&A1&!A|!D&!C2&!C1&C&!B&A2&A1&!A|!D&!C2&!C1&!C&B&A2&A1&!A|!D&!C2&!C1&!C&B&!A2&A1&!A|!D&!C2&!C1&C&!B&!A2&A1&!A|!D&C2&!C1&C&!B&!A2&A1&!A|!D&C2&C1&C&!B&!A2&A1&!A|!D&!C2&C1&C&!B&!A2&A1&!A|!D&!C2&C1&!C&!B&!A2&A1&!A|!D&C2&C1&!C&!B&!A2&A1&!A|!D&C2&!C1&!C&!B&!A2&A1&!A|!D&!C2&!C1&!C&!B&!A2&A1&!A|!D&!C2&!C1&!C&!B&!A2&A1&A|!D&C2&!C1&!C&!B&!A2&A1&A|!D&C2&C1&!C&!B&!A2&A1&A|!D&!C2&C1&!C&!B&!A2&A1&A|!D&!C2&C1&C&!B&!A2&A1&A|!D&C2&C1&C&!B&!A2&A1&A|!D&C2&!C1&C&!B&!A2&A1&A|!D&!C2&!C1&C&!B&!A2&A1&A|!D&!C2&!C1&!C&B&!A2&A1&A|!D&!C2&!C1&!C&B&A2&A1&A|!D&!C2&!C1&!C&!B&A2&A1&A|!D&!C2&!C1&!C&!B&A2&!A1&A|!D&C2&!C1&!C&!B&A2&!A1&A|!D&C2&C1&!C&!B&A2&!A1&A|!D&!C2&C1&!C&!B&A2&!A1&A|!D&!C2&C1&C&!B&A2&!A1&A|!D&C2&C1&C&!B&A2&!A1&A|!D&C2&!C1&C&!B&A2&!A1&A|!D&!C2&!C1&C&!B&A2&!A1&A|!D&!C2&!C1&!C&B&A2&!A1&A|!D&!C2&!C1&!C&B&!A2&!A1&A|!D&!C2&!C1&C&!B&!A2&!A1&A|!D&C2&!C1&C&!B&!A2&!A1&A|!D&C2&C1&C&!B&!A2&!A1&A|!D&!C2&C1&C&!B&!A2&!A1&A|!D&!C2&C1&!C&!B&!A2&!A1&A|!D&C2&C1&!C&!B&!A2&!A1&A|!D&C2&!C1&!C&!B&!A2&!A1&A|!D&!C2&!C1&!C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOI3131.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOI3321 -l OOAOI3321 -i D C1 C B2 B1 B A2 A1 A -o Y -f Y=(!D&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D&C1&C&!B2&!B1&!B&!A2&!A1&!A|!D&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!D&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D&C1&C&B2&!B1&!B&!A2&!A1&!A|!D&C1&!C&B2&!B1&!B&!A2&!A1&!A|!D&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!D&!C1&!C&B2&B1&!B&!A2&!A1&!A|!D&C1&!C&B2&B1&!B&!A2&!A1&!A|!D&C1&C&B2&B1&!B&!A2&!A1&!A|!D&!C1&C&B2&B1&!B&!A2&!A1&!A|!D&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D&C1&C&!B2&B1&!B&!A2&!A1&!A|!D&C1&!C&!B2&B1&!B&!A2&!A1&!A|!D&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!D&!C1&!C&!B2&B1&B&!A2&!A1&!A|!D&C1&!C&!B2&B1&B&!A2&!A1&!A|!D&C1&C&!B2&B1&B&!A2&!A1&!A|!D&!C1&C&!B2&B1&B&!A2&!A1&!A|!D&!C1&C&B2&B1&B&!A2&!A1&!A|!D&C1&C&B2&B1&B&!A2&!A1&!A|!D&C1&!C&B2&B1&B&!A2&!A1&!A|!D&!C1&!C&B2&B1&B&!A2&!A1&!A|!D&!C1&!C&B2&!B1&B&!A2&!A1&!A|!D&C1&!C&B2&!B1&B&!A2&!A1&!A|!D&C1&C&B2&!B1&B&!A2&!A1&!A|!D&!C1&C&B2&!B1&B&!A2&!A1&!A|!D&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D&C1&C&!B2&!B1&B&!A2&!A1&!A|!D&C1&!C&!B2&!B1&B&!A2&!A1&!A|!D&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!D&!C1&!C&!B2&!B1&B&A2&!A1&!A|!D&C1&!C&!B2&!B1&B&A2&!A1&!A|!D&!C1&C&!B2&!B1&B&A2&!A1&!A|!D&!C1&C&B2&!B1&B&A2&!A1&!A|!D&C1&!C&B2&!B1&B&A2&!A1&!A|!D&!C1&!C&B2&!B1&B&A2&!A1&!A|!D&!C1&!C&B2&B1&B&A2&!A1&!A|!D&C1&!C&B2&B1&B&A2&!A1&!A|!D&!C1&C&B2&B1&B&A2&!A1&!A|!D&!C1&C&!B2&B1&B&A2&!A1&!A|!D&C1&!C&!B2&B1&B&A2&!A1&!A|!D&!C1&!C&!B2&B1&B&A2&!A1&!A|!D&!C1&!C&!B2&B1&!B&A2&!A1&!A|!D&C1&!C&!B2&B1&!B&A2&!A1&!A|!D&!C1&C&!B2&B1&!B&A2&!A1&!A|!D&!C1&C&B2&B1&!B&A2&!A1&!A|!D&C1&!C&B2&B1&!B&A2&!A1&!A|!D&!C1&!C&B2&B1&!B&A2&!A1&!A|!D&!C1&!C&B2&!B1&!B&A2&!A1&!A|!D&C1&!C&B2&!B1&!B&A2&!A1&!A|!D&!C1&C&B2&!B1&!B&A2&!A1&!A|!D&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D&C1&C&!B2&!B1&!B&A2&!A1&!A|!D&C1&!C&!B2&!B1&!B&A2&!A1&!A|!D&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!D&!C1&!C&!B2&!B1&!B&A2&A1&!A|!D&C1&!C&!B2&!B1&!B&A2&A1&!A|!D&C1&C&!B2&!B1&!B&A2&A1&!A|!D&!C1&C&!B2&!B1&!B&A2&A1&!A|!D&!C1&C&B2&!B1&!B&A2&A1&!A|!D&C1&!C&B2&!B1&!B&A2&A1&!A|!D&!C1&!C&B2&!B1&!B&A2&A1&!A|!D&!C1&!C&B2&B1&!B&A2&A1&!A|!D&C1&!C&B2&B1&!B&A2&A1&!A|!D&!C1&C&B2&B1&!B&A2&A1&!A|!D&!C1&C&!B2&B1&!B&A2&A1&!A|!D&C1&!C&!B2&B1&!B&A2&A1&!A|!D&!C1&!C&!B2&B1&!B&A2&A1&!A|!D&!C1&!C&!B2&B1&B&A2&A1&!A|!D&C1&!C&!B2&B1&B&A2&A1&!A|!D&!C1&C&!B2&B1&B&A2&A1&!A|!D&!C1&C&B2&B1&B&A2&A1&!A|!D&C1&!C&B2&B1&B&A2&A1&!A|!D&!C1&!C&B2&B1&B&A2&A1&!A|!D&!C1&!C&B2&!B1&B&A2&A1&!A|!D&C1&!C&B2&!B1&B&A2&A1&!A|!D&!C1&C&B2&!B1&B&A2&A1&!A|!D&!C1&C&!B2&!B1&B&A2&A1&!A|!D&C1&!C&!B2&!B1&B&A2&A1&!A|!D&!C1&!C&!B2&!B1&B&A2&A1&!A|!D&!C1&!C&!B2&!B1&B&!A2&A1&!A|!D&C1&!C&!B2&!B1&B&!A2&A1&!A|!D&!C1&C&!B2&!B1&B&!A2&A1&!A|!D&!C1&C&B2&!B1&B&!A2&A1&!A|!D&C1&!C&B2&!B1&B&!A2&A1&!A|!D&!C1&!C&B2&!B1&B&!A2&A1&!A|!D&!C1&!C&B2&B1&B&!A2&A1&!A|!D&C1&!C&B2&B1&B&!A2&A1&!A|!D&!C1&C&B2&B1&B&!A2&A1&!A|!D&!C1&C&!B2&B1&B&!A2&A1&!A|!D&C1&!C&!B2&B1&B&!A2&A1&!A|!D&!C1&!C&!B2&B1&B&!A2&A1&!A|!D&!C1&!C&!B2&B1&!B&!A2&A1&!A|!D&C1&!C&!B2&B1&!B&!A2&A1&!A|!D&!C1&C&!B2&B1&!B&!A2&A1&!A|!D&!C1&C&B2&B1&!B&!A2&A1&!A|!D&C1&!C&B2&B1&!B&!A2&A1&!A|!D&!C1&!C&B2&B1&!B&!A2&A1&!A|!D&!C1&!C&B2&!B1&!B&!A2&A1&!A|!D&C1&!C&B2&!B1&!B&!A2&A1&!A|!D&!C1&C&B2&!B1&!B&!A2&A1&!A|!D&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D&C1&C&!B2&!B1&!B&!A2&A1&!A|!D&C1&!C&!B2&!B1&!B&!A2&A1&!A|!D&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!D&!C1&!C&!B2&!B1&!B&!A2&A1&A|!D&C1&!C&!B2&!B1&!B&!A2&A1&A|!D&C1&C&!B2&!B1&!B&!A2&A1&A|!D&!C1&C&!B2&!B1&!B&!A2&A1&A|!D&!C1&C&B2&!B1&!B&!A2&A1&A|!D&C1&!C&B2&!B1&!B&!A2&A1&A|!D&!C1&!C&B2&!B1&!B&!A2&A1&A|!D&!C1&!C&B2&B1&!B&!A2&A1&A|!D&C1&!C&B2&B1&!B&!A2&A1&A|!D&!C1&C&B2&B1&!B&!A2&A1&A|!D&!C1&C&!B2&B1&!B&!A2&A1&A|!D&C1&!C&!B2&B1&!B&!A2&A1&A|!D&!C1&!C&!B2&B1&!B&!A2&A1&A|!D&!C1&!C&!B2&B1&B&!A2&A1&A|!D&C1&!C&!B2&B1&B&!A2&A1&A|!D&!C1&C&!B2&B1&B&!A2&A1&A|!D&!C1&C&B2&B1&B&!A2&A1&A|!D&C1&!C&B2&B1&B&!A2&A1&A|!D&!C1&!C&B2&B1&B&!A2&A1&A|!D&!C1&!C&B2&!B1&B&!A2&A1&A|!D&C1&!C&B2&!B1&B&!A2&A1&A|!D&!C1&C&B2&!B1&B&!A2&A1&A|!D&!C1&C&!B2&!B1&B&!A2&A1&A|!D&C1&!C&!B2&!B1&B&!A2&A1&A|!D&!C1&!C&!B2&!B1&B&!A2&A1&A|!D&!C1&!C&!B2&!B1&B&A2&A1&A|!D&C1&!C&!B2&!B1&B&A2&A1&A|!D&!C1&C&!B2&!B1&B&A2&A1&A|!D&!C1&C&B2&!B1&B&A2&A1&A|!D&C1&!C&B2&!B1&B&A2&A1&A|!D&!C1&!C&B2&!B1&B&A2&A1&A|!D&!C1&!C&B2&B1&B&A2&A1&A|!D&C1&!C&B2&B1&B&A2&A1&A|!D&!C1&C&B2&B1&B&A2&A1&A|!D&!C1&C&!B2&B1&B&A2&A1&A|!D&C1&!C&!B2&B1&B&A2&A1&A|!D&!C1&!C&!B2&B1&B&A2&A1&A|!D&!C1&!C&!B2&B1&!B&A2&A1&A|!D&C1&!C&!B2&B1&!B&A2&A1&A|!D&!C1&C&!B2&B1&!B&A2&A1&A|!D&!C1&C&B2&B1&!B&A2&A1&A|!D&C1&!C&B2&B1&!B&A2&A1&A|!D&!C1&!C&B2&B1&!B&A2&A1&A|!D&!C1&!C&B2&!B1&!B&A2&A1&A|!D&C1&!C&B2&!B1&!B&A2&A1&A|!D&!C1&C&B2&!B1&!B&A2&A1&A|!D&!C1&C&!B2&!B1&!B&A2&A1&A|!D&C1&C&!B2&!B1&!B&A2&A1&A|!D&C1&!C&!B2&!B1&!B&A2&A1&A|!D&!C1&!C&!B2&!B1&!B&A2&A1&A|!D&!C1&!C&!B2&!B1&!B&A2&!A1&A|!D&C1&!C&!B2&!B1&!B&A2&!A1&A|!D&C1&C&!B2&!B1&!B&A2&!A1&A|!D&!C1&C&!B2&!B1&!B&A2&!A1&A|!D&!C1&C&B2&!B1&!B&A2&!A1&A|!D&C1&!C&B2&!B1&!B&A2&!A1&A|!D&!C1&!C&B2&!B1&!B&A2&!A1&A|!D&!C1&!C&B2&B1&!B&A2&!A1&A|!D&C1&!C&B2&B1&!B&A2&!A1&A|!D&!C1&C&B2&B1&!B&A2&!A1&A|!D&!C1&C&!B2&B1&!B&A2&!A1&A|!D&C1&!C&!B2&B1&!B&A2&!A1&A|!D&!C1&!C&!B2&B1&!B&A2&!A1&A|!D&!C1&!C&!B2&B1&B&A2&!A1&A|!D&C1&!C&!B2&B1&B&A2&!A1&A|!D&!C1&C&!B2&B1&B&A2&!A1&A|!D&!C1&C&B2&B1&B&A2&!A1&A|!D&C1&!C&B2&B1&B&A2&!A1&A|!D&!C1&!C&B2&B1&B&A2&!A1&A|!D&!C1&!C&B2&!B1&B&A2&!A1&A|!D&C1&!C&B2&!B1&B&A2&!A1&A|!D&!C1&C&B2&!B1&B&A2&!A1&A|!D&!C1&C&!B2&!B1&B&A2&!A1&A|!D&C1&!C&!B2&!B1&B&A2&!A1&A|!D&!C1&!C&!B2&!B1&B&A2&!A1&A|!D&!C1&!C&!B2&!B1&B&!A2&!A1&A|!D&C1&!C&!B2&!B1&B&!A2&!A1&A|!D&!C1&C&!B2&!B1&B&!A2&!A1&A|!D&!C1&C&B2&!B1&B&!A2&!A1&A|!D&C1&!C&B2&!B1&B&!A2&!A1&A|!D&!C1&!C&B2&!B1&B&!A2&!A1&A|!D&!C1&!C&B2&B1&B&!A2&!A1&A|!D&C1&!C&B2&B1&B&!A2&!A1&A|!D&!C1&C&B2&B1&B&!A2&!A1&A|!D&!C1&C&!B2&B1&B&!A2&!A1&A|!D&C1&!C&!B2&B1&B&!A2&!A1&A|!D&!C1&!C&!B2&B1&B&!A2&!A1&A|!D&!C1&!C&!B2&B1&!B&!A2&!A1&A|!D&C1&!C&!B2&B1&!B&!A2&!A1&A|!D&!C1&C&!B2&B1&!B&!A2&!A1&A|!D&!C1&C&B2&B1&!B&!A2&!A1&A|!D&C1&!C&B2&B1&!B&!A2&!A1&A|!D&!C1&!C&B2&B1&!B&!A2&!A1&A|!D&!C1&!C&B2&!B1&!B&!A2&!A1&A|!D&C1&!C&B2&!B1&!B&!A2&!A1&A|!D&!C1&C&B2&!B1&!B&!A2&!A1&A|!D&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D&C1&C&!B2&!B1&!B&!A2&!A1&A|!D&C1&!C&!B2&!B1&!B&!A2&!A1&A|!D&!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOI3321.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAOAI221111 -l AAOAOAI221111 -i F E D C B1 B A1 A -o Y -f Y=!(F&E&!D&!C&!B1&!B&!A1&!A|F&E&D&!C&!B1&!B&!A1&!A|F&!E&D&C&!B1&!B&!A1&!A|F&E&D&C&!B1&!B&!A1&!A|F&E&!D&C&!B1&!B&!A1&!A|F&E&!D&C&B1&!B&!A1&!A|F&E&D&C&B1&!B&!A1&!A|F&!E&D&C&B1&!B&!A1&!A|F&E&D&!C&B1&!B&!A1&!A|F&E&!D&!C&B1&!B&!A1&!A|F&E&!D&!C&B1&B&!A1&!A|F&E&D&!C&B1&B&!A1&!A|F&!E&D&!C&B1&B&!A1&!A|F&!E&D&C&B1&B&!A1&!A|F&E&D&C&B1&B&!A1&!A|F&E&!D&C&B1&B&!A1&!A|F&E&!D&C&!B1&B&!A1&!A|F&E&D&C&!B1&B&!A1&!A|F&!E&D&C&!B1&B&!A1&!A|F&E&D&!C&!B1&B&!A1&!A|F&E&!D&!C&!B1&B&!A1&!A|F&E&!D&!C&!B1&B&A1&!A|F&E&D&!C&!B1&B&A1&!A|F&!E&D&C&!B1&B&A1&!A|F&E&D&C&!B1&B&A1&!A|F&E&!D&C&!B1&B&A1&!A|F&E&!D&C&B1&B&A1&!A|F&E&D&C&B1&B&A1&!A|F&!E&D&C&B1&B&A1&!A|F&!E&D&!C&B1&B&A1&!A|F&E&D&!C&B1&B&A1&!A|F&E&!D&!C&B1&B&A1&!A|F&E&!D&!C&B1&!B&A1&!A|F&E&D&!C&B1&!B&A1&!A|F&!E&D&C&B1&!B&A1&!A|F&E&D&C&B1&!B&A1&!A|F&E&!D&C&B1&!B&A1&!A|F&E&!D&C&!B1&!B&A1&!A|F&E&D&C&!B1&!B&A1&!A|F&!E&D&C&!B1&!B&A1&!A|F&E&D&!C&!B1&!B&A1&!A|F&E&!D&!C&!B1&!B&A1&!A|F&E&!D&!C&!B1&!B&A1&A|F&E&D&!C&!B1&!B&A1&A|F&!E&D&!C&!B1&!B&A1&A|F&!E&D&C&!B1&!B&A1&A|F&E&D&C&!B1&!B&A1&A|F&E&!D&C&!B1&!B&A1&A|F&E&!D&C&B1&!B&A1&A|F&E&D&C&B1&!B&A1&A|F&!E&D&C&B1&!B&A1&A|F&!E&D&!C&B1&!B&A1&A|F&E&D&!C&B1&!B&A1&A|F&E&!D&!C&B1&!B&A1&A|F&E&!D&!C&B1&B&A1&A|F&E&D&!C&B1&B&A1&A|F&!E&D&!C&B1&B&A1&A|F&!E&D&C&B1&B&A1&A|F&E&D&C&B1&B&A1&A|F&E&!D&C&B1&B&A1&A|F&E&!D&C&!B1&B&A1&A|F&E&D&C&!B1&B&A1&A|F&!E&D&C&!B1&B&A1&A|F&!E&D&!C&!B1&B&A1&A|F&E&D&!C&!B1&B&A1&A|F&E&!D&!C&!B1&B&A1&A|F&E&!D&!C&!B1&B&!A1&A|F&E&D&!C&!B1&B&!A1&A|F&!E&D&C&!B1&B&!A1&A|F&E&D&C&!B1&B&!A1&A|F&E&!D&C&!B1&B&!A1&A|F&E&!D&C&B1&B&!A1&A|F&E&D&C&B1&B&!A1&A|F&!E&D&C&B1&B&!A1&A|F&!E&D&!C&B1&B&!A1&A|F&E&D&!C&B1&B&!A1&A|F&E&!D&!C&B1&B&!A1&A|F&E&!D&!C&B1&!B&!A1&A|F&E&D&!C&B1&!B&!A1&A|F&!E&D&C&B1&!B&!A1&A|F&E&D&C&B1&!B&!A1&A|F&E&!D&C&B1&!B&!A1&A|F&E&!D&C&!B1&!B&!A1&A|F&E&D&C&!B1&!B&!A1&A|F&!E&D&C&!B1&!B&!A1&A|F&E&D&!C&!B1&!B&!A1&A|F&E&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAOAI221111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOAI3111 -l OAOAI3111 -i D C B A2 A1 A -o Y -f Y=!(D&C&!B&!A2&!A1&!A|D&C&B&!A2&!A1&!A|D&!C&B&A2&!A1&!A|D&C&B&A2&!A1&!A|D&C&!B&A2&!A1&!A|D&C&!B&A2&A1&!A|D&C&B&A2&A1&!A|D&!C&B&A2&A1&!A|D&!C&B&!A2&A1&!A|D&C&B&!A2&A1&!A|D&C&!B&!A2&A1&!A|D&C&!B&!A2&A1&A|D&C&B&!A2&A1&A|D&!C&B&!A2&A1&A|D&!C&B&A2&A1&A|D&C&B&A2&A1&A|D&C&!B&A2&A1&A|D&C&!B&A2&!A1&A|D&C&B&A2&!A1&A|D&!C&B&A2&!A1&A|D&!C&B&!A2&!A1&A|D&C&B&!A2&!A1&A|D&C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOAI3111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOI222 -l OAAOI222 -i C1 C B1 B A1 A -o Y -f Y=!(C1&C&!B1&!B&!A1&!A|C1&C&B1&!B&!A1&!A|C1&C&B1&B&!A1&!A|C1&C&!B1&B&!A1&!A|C1&C&!B1&B&A1&!A|!C1&C&B1&B&A1&!A|C1&C&B1&B&A1&!A|C1&!C&B1&B&A1&!A|!C1&!C&B1&B&A1&!A|C1&C&B1&!B&A1&!A|C1&C&!B1&!B&A1&!A|C1&C&!B1&!B&A1&A|C1&C&B1&!B&A1&A|!C1&!C&B1&B&A1&A|C1&!C&B1&B&A1&A|C1&C&B1&B&A1&A|!C1&C&B1&B&A1&A|C1&C&!B1&B&A1&A|C1&C&!B1&B&!A1&A|!C1&C&B1&B&!A1&A|C1&C&B1&B&!A1&A|C1&!C&B1&B&!A1&A|!C1&!C&B1&B&!A1&A|C1&C&B1&!B&!A1&A|C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOI222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAI233 -l AOOAI233 -i C2 C1 C B2 B1 B A1 A -o Y -f Y=(!C2&!C1&!C&!B2&!B1&!B&!A1&!A|C2&!C1&!C&!B2&!B1&!B&!A1&!A|C2&C1&!C&!B2&!B1&!B&!A1&!A|!C2&C1&!C&!B2&!B1&!B&!A1&!A|!C2&C1&C&!B2&!B1&!B&!A1&!A|C2&C1&C&!B2&!B1&!B&!A1&!A|C2&!C1&C&!B2&!B1&!B&!A1&!A|!C2&!C1&C&!B2&!B1&!B&!A1&!A|!C2&!C1&!C&B2&!B1&!B&!A1&!A|!C2&!C1&!C&B2&B1&!B&!A1&!A|!C2&!C1&!C&!B2&B1&!B&!A1&!A|!C2&!C1&!C&!B2&B1&B&!A1&!A|!C2&!C1&!C&B2&B1&B&!A1&!A|!C2&!C1&!C&B2&!B1&B&!A1&!A|!C2&!C1&!C&!B2&!B1&B&!A1&!A|!C2&!C1&!C&!B2&!B1&B&A1&!A|!C2&!C1&!C&B2&!B1&B&A1&!A|!C2&!C1&!C&B2&B1&B&A1&!A|!C2&!C1&!C&!B2&B1&B&A1&!A|!C2&!C1&!C&!B2&B1&!B&A1&!A|!C2&!C1&!C&B2&B1&!B&A1&!A|!C2&!C1&!C&B2&!B1&!B&A1&!A|!C2&!C1&C&!B2&!B1&!B&A1&!A|C2&!C1&C&!B2&!B1&!B&A1&!A|C2&C1&C&!B2&!B1&!B&A1&!A|!C2&C1&C&!B2&!B1&!B&A1&!A|!C2&C1&!C&!B2&!B1&!B&A1&!A|C2&C1&!C&!B2&!B1&!B&A1&!A|C2&!C1&!C&!B2&!B1&!B&A1&!A|!C2&!C1&!C&!B2&!B1&!B&A1&!A|!C2&!C1&!C&!B2&!B1&!B&A1&A|!C2&!C1&!C&B2&!B1&!B&A1&A|!C2&!C1&!C&B2&B1&!B&A1&A|!C2&!C1&!C&!B2&B1&!B&A1&A|!C2&!C1&!C&!B2&B1&B&A1&A|!C2&!C1&!C&B2&B1&B&A1&A|!C2&!C1&!C&B2&!B1&B&A1&A|!C2&!C1&!C&!B2&!B1&B&A1&A|!C2&!C1&!C&!B2&!B1&B&!A1&A|!C2&!C1&!C&B2&!B1&B&!A1&A|!C2&!C1&!C&B2&B1&B&!A1&A|!C2&!C1&!C&!B2&B1&B&!A1&A|!C2&!C1&!C&!B2&B1&!B&!A1&A|!C2&!C1&!C&B2&B1&!B&!A1&A|!C2&!C1&!C&B2&!B1&!B&!A1&A|!C2&!C1&C&!B2&!B1&!B&!A1&A|C2&!C1&C&!B2&!B1&!B&!A1&A|C2&C1&C&!B2&!B1&!B&!A1&A|!C2&C1&C&!B2&!B1&!B&!A1&A|!C2&C1&!C&!B2&!B1&!B&!A1&A|C2&C1&!C&!B2&!B1&!B&!A1&A|C2&!C1&!C&!B2&!B1&!B&!A1&A|!C2&!C1&!C&!B2&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAI233.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOAI21212 -l OAAOAI21212 -i E1 E D C1 C B A1 A -o Y -f Z=(E1&E&D&C1&C&!B&!A1&!A|E1&E&D&C1&C&B&!A1&!A|E1&E&D&!C1&!C&B&A1&!A|E1&E&D&C1&!C&B&A1&!A|E1&E&D&C1&C&B&A1&!A|E1&E&D&!C1&C&B&A1&!A|E1&E&D&C1&C&!B&A1&!A|E1&E&D&C1&C&!B&A1&A|E1&E&D&!C1&C&B&A1&A|E1&E&D&C1&C&B&A1&A|E1&E&D&C1&!C&B&A1&A|E1&E&D&!C1&!C&B&A1&A|E1&E&D&!C1&!C&B&!A1&A|E1&E&D&C1&!C&B&!A1&A|E1&E&D&C1&C&B&!A1&A|E1&E&D&!C1&C&B&!A1&A|E1&E&D&C1&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOAI21212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOAI211211 -l AOAAOAI211211 -i F E D1 D C B A1 A -o Y -f Y=!(F&E&!D1&!D&!C&!B&!A1&!A|F&E&D1&!D&!C&!B&!A1&!A|F&!E&D1&D&!C&!B&!A1&!A|F&E&D1&D&!C&!B&!A1&!A|F&E&!D1&D&!C&!B&!A1&!A|F&E&!D1&D&C&!B&!A1&!A|F&E&D1&D&C&!B&!A1&!A|F&!E&D1&D&C&!B&!A1&!A|F&E&D1&!D&C&!B&!A1&!A|F&E&!D1&!D&C&!B&!A1&!A|F&!E&!D1&!D&C&B&!A1&!A|F&E&!D1&!D&C&B&!A1&!A|F&E&D1&!D&C&B&!A1&!A|F&!E&D1&!D&C&B&!A1&!A|F&!E&D1&D&C&B&!A1&!A|F&E&D1&D&C&B&!A1&!A|F&E&!D1&D&C&B&!A1&!A|F&!E&!D1&D&C&B&!A1&!A|F&E&!D1&D&!C&B&!A1&!A|F&E&D1&D&!C&B&!A1&!A|F&!E&D1&D&!C&B&!A1&!A|F&E&D1&!D&!C&B&!A1&!A|F&E&!D1&!D&!C&B&!A1&!A|F&E&!D1&!D&!C&B&A1&!A|F&E&D1&!D&!C&B&A1&!A|F&!E&D1&D&!C&B&A1&!A|F&E&D1&D&!C&B&A1&!A|F&E&!D1&D&!C&B&A1&!A|F&!E&!D1&D&C&B&A1&!A|F&E&!D1&D&C&B&A1&!A|F&E&D1&D&C&B&A1&!A|F&!E&D1&D&C&B&A1&!A|F&!E&D1&!D&C&B&A1&!A|F&E&D1&!D&C&B&A1&!A|F&E&!D1&!D&C&B&A1&!A|F&!E&!D1&!D&C&B&A1&!A|F&E&!D1&!D&C&!B&A1&!A|F&E&D1&!D&C&!B&A1&!A|F&!E&D1&D&C&!B&A1&!A|F&E&D1&D&C&!B&A1&!A|F&E&!D1&D&C&!B&A1&!A|F&E&!D1&D&!C&!B&A1&!A|F&E&D1&D&!C&!B&A1&!A|F&!E&D1&D&!C&!B&A1&!A|F&E&D1&!D&!C&!B&A1&!A|F&E&!D1&!D&!C&!B&A1&!A|F&E&!D1&!D&!C&!B&A1&A|F&E&D1&!D&!C&!B&A1&A|F&!E&D1&D&!C&!B&A1&A|F&E&D1&D&!C&!B&A1&A|F&E&!D1&D&!C&!B&A1&A|F&!E&!D1&D&C&!B&A1&A|F&E&!D1&D&C&!B&A1&A|F&E&D1&D&C&!B&A1&A|F&!E&D1&D&C&!B&A1&A|F&!E&D1&!D&C&!B&A1&A|F&E&D1&!D&C&!B&A1&A|F&E&!D1&!D&C&!B&A1&A|F&!E&!D1&!D&C&!B&A1&A|F&!E&!D1&!D&C&B&A1&A|F&E&!D1&!D&C&B&A1&A|F&E&D1&!D&C&B&A1&A|F&!E&D1&!D&C&B&A1&A|F&!E&D1&D&C&B&A1&A|F&E&D1&D&C&B&A1&A|F&E&!D1&D&C&B&A1&A|F&!E&!D1&D&C&B&A1&A|F&E&!D1&D&!C&B&A1&A|F&E&D1&D&!C&B&A1&A|F&!E&D1&D&!C&B&A1&A|F&E&D1&!D&!C&B&A1&A|F&E&!D1&!D&!C&B&A1&A|F&E&!D1&!D&!C&B&!A1&A|F&E&D1&!D&!C&B&!A1&A|F&!E&D1&D&!C&B&!A1&A|F&E&D1&D&!C&B&!A1&A|F&E&!D1&D&!C&B&!A1&A|F&!E&!D1&D&C&B&!A1&A|F&E&!D1&D&C&B&!A1&A|F&E&D1&D&C&B&!A1&A|F&!E&D1&D&C&B&!A1&A|F&!E&D1&!D&C&B&!A1&A|F&E&D1&!D&C&B&!A1&A|F&E&!D1&!D&C&B&!A1&A|F&!E&!D1&!D&C&B&!A1&A|F&E&!D1&!D&C&!B&!A1&A|F&E&D1&!D&C&!B&!A1&A|F&!E&D1&D&C&!B&!A1&A|F&E&D1&D&C&!B&!A1&A|F&E&!D1&D&C&!B&!A1&A|F&E&!D1&D&!C&!B&!A1&A|F&E&D1&D&!C&!B&!A1&A|F&!E&D1&D&!C&!B&!A1&A|F&E&D1&!D&!C&!B&!A1&A|F&E&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOAI211211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOI3311 -l OOAOI3311 -i D C B2 B1 B A2 A1 A -o Y -f Y=(!D&!C&!B2&!B1&!B&!A2&!A1&!A|!D&C&!B2&!B1&!B&!A2&!A1&!A|!D&C&B2&!B1&!B&!A2&!A1&!A|!D&!C&B2&!B1&!B&!A2&!A1&!A|!D&!C&B2&B1&!B&!A2&!A1&!A|!D&C&B2&B1&!B&!A2&!A1&!A|!D&C&!B2&B1&!B&!A2&!A1&!A|!D&!C&!B2&B1&!B&!A2&!A1&!A|!D&!C&!B2&B1&B&!A2&!A1&!A|!D&C&!B2&B1&B&!A2&!A1&!A|!D&C&B2&B1&B&!A2&!A1&!A|!D&!C&B2&B1&B&!A2&!A1&!A|!D&!C&B2&!B1&B&!A2&!A1&!A|!D&C&B2&!B1&B&!A2&!A1&!A|!D&C&!B2&!B1&B&!A2&!A1&!A|!D&!C&!B2&!B1&B&!A2&!A1&!A|!D&!C&!B2&!B1&B&A2&!A1&!A|!D&!C&B2&!B1&B&A2&!A1&!A|!D&!C&B2&B1&B&A2&!A1&!A|!D&!C&!B2&B1&B&A2&!A1&!A|!D&!C&!B2&B1&!B&A2&!A1&!A|!D&!C&B2&B1&!B&A2&!A1&!A|!D&!C&B2&!B1&!B&A2&!A1&!A|!D&C&!B2&!B1&!B&A2&!A1&!A|!D&!C&!B2&!B1&!B&A2&!A1&!A|!D&!C&!B2&!B1&!B&A2&A1&!A|!D&C&!B2&!B1&!B&A2&A1&!A|!D&!C&B2&!B1&!B&A2&A1&!A|!D&!C&B2&B1&!B&A2&A1&!A|!D&!C&!B2&B1&!B&A2&A1&!A|!D&!C&!B2&B1&B&A2&A1&!A|!D&!C&B2&B1&B&A2&A1&!A|!D&!C&B2&!B1&B&A2&A1&!A|!D&!C&!B2&!B1&B&A2&A1&!A|!D&!C&!B2&!B1&B&!A2&A1&!A|!D&!C&B2&!B1&B&!A2&A1&!A|!D&!C&B2&B1&B&!A2&A1&!A|!D&!C&!B2&B1&B&!A2&A1&!A|!D&!C&!B2&B1&!B&!A2&A1&!A|!D&!C&B2&B1&!B&!A2&A1&!A|!D&!C&B2&!B1&!B&!A2&A1&!A|!D&C&!B2&!B1&!B&!A2&A1&!A|!D&!C&!B2&!B1&!B&!A2&A1&!A|!D&!C&!B2&!B1&!B&!A2&A1&A|!D&C&!B2&!B1&!B&!A2&A1&A|!D&!C&B2&!B1&!B&!A2&A1&A|!D&!C&B2&B1&!B&!A2&A1&A|!D&!C&!B2&B1&!B&!A2&A1&A|!D&!C&!B2&B1&B&!A2&A1&A|!D&!C&B2&B1&B&!A2&A1&A|!D&!C&B2&!B1&B&!A2&A1&A|!D&!C&!B2&!B1&B&!A2&A1&A|!D&!C&!B2&!B1&B&A2&A1&A|!D&!C&B2&!B1&B&A2&A1&A|!D&!C&B2&B1&B&A2&A1&A|!D&!C&!B2&B1&B&A2&A1&A|!D&!C&!B2&B1&!B&A2&A1&A|!D&!C&B2&B1&!B&A2&A1&A|!D&!C&B2&!B1&!B&A2&A1&A|!D&C&!B2&!B1&!B&A2&A1&A|!D&!C&!B2&!B1&!B&A2&A1&A|!D&!C&!B2&!B1&!B&A2&!A1&A|!D&C&!B2&!B1&!B&A2&!A1&A|!D&!C&B2&!B1&!B&A2&!A1&A|!D&!C&B2&B1&!B&A2&!A1&A|!D&!C&!B2&B1&!B&A2&!A1&A|!D&!C&!B2&B1&B&A2&!A1&A|!D&!C&B2&B1&B&A2&!A1&A|!D&!C&B2&!B1&B&A2&!A1&A|!D&!C&!B2&!B1&B&A2&!A1&A|!D&!C&!B2&!B1&B&!A2&!A1&A|!D&!C&B2&!B1&B&!A2&!A1&A|!D&!C&B2&B1&B&!A2&!A1&A|!D&!C&!B2&B1&B&!A2&!A1&A|!D&!C&!B2&B1&!B&!A2&!A1&A|!D&!C&B2&B1&!B&!A2&!A1&A|!D&!C&B2&!B1&!B&!A2&!A1&A|!D&C&!B2&!B1&!B&!A2&!A1&A|!D&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOI3311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOI21231 -l AOOAAOI21231 -i E D2 D1 D C1 C B A1 A -o Y -f Y=(!E&!D2&!D1&!D&!C1&!C&!B&!A1&!A|!E&D2&!D1&!D&!C1&!C&!B&!A1&!A|!E&D2&D1&!D&!C1&!C&!B&!A1&!A|!E&!D2&D1&!D&!C1&!C&!B&!A1&!A|!E&!D2&D1&D&!C1&!C&!B&!A1&!A|!E&D2&!D1&D&!C1&!C&!B&!A1&!A|!E&!D2&!D1&D&!C1&!C&!B&!A1&!A|!E&!D2&!D1&D&C1&!C&!B&!A1&!A|!E&D2&!D1&D&C1&!C&!B&!A1&!A|!E&!D2&D1&D&C1&!C&!B&!A1&!A|!E&!D2&D1&!D&C1&!C&!B&!A1&!A|!E&D2&D1&!D&C1&!C&!B&!A1&!A|!E&D2&!D1&!D&C1&!C&!B&!A1&!A|!E&!D2&!D1&!D&C1&!C&!B&!A1&!A|!E&!D2&!D1&!D&C1&C&!B&!A1&!A|!E&D2&!D1&!D&C1&C&!B&!A1&!A|!E&D2&D1&!D&C1&C&!B&!A1&!A|!E&!D2&D1&!D&C1&C&!B&!A1&!A|!E&!D2&D1&D&C1&C&!B&!A1&!A|!E&D2&!D1&D&C1&C&!B&!A1&!A|!E&!D2&!D1&D&C1&C&!B&!A1&!A|!E&!D2&!D1&D&!C1&C&!B&!A1&!A|!E&D2&!D1&D&!C1&C&!B&!A1&!A|!E&!D2&D1&D&!C1&C&!B&!A1&!A|!E&!D2&D1&!D&!C1&C&!B&!A1&!A|!E&D2&D1&!D&!C1&C&!B&!A1&!A|!E&D2&!D1&!D&!C1&C&!B&!A1&!A|!E&!D2&!D1&!D&!C1&C&!B&!A1&!A|!E&!D2&!D1&D&!C1&!C&B&!A1&!A|!E&D2&!D1&D&!C1&!C&B&!A1&!A|!E&!D2&D1&D&!C1&!C&B&!A1&!A|!E&!D2&D1&!D&!C1&!C&B&!A1&!A|!E&D2&D1&!D&!C1&!C&B&!A1&!A|!E&D2&!D1&!D&!C1&!C&B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&B&A1&!A|!E&D2&!D1&!D&!C1&!C&B&A1&!A|!E&D2&D1&!D&!C1&!C&B&A1&!A|!E&!D2&D1&!D&!C1&!C&B&A1&!A|!E&!D2&D1&D&!C1&!C&B&A1&!A|!E&D2&!D1&D&!C1&!C&B&A1&!A|!E&!D2&!D1&D&!C1&!C&B&A1&!A|!E&!D2&!D1&!D&!C1&C&!B&A1&!A|!E&D2&!D1&!D&!C1&C&!B&A1&!A|!E&D2&D1&!D&!C1&C&!B&A1&!A|!E&!D2&D1&!D&!C1&C&!B&A1&!A|!E&!D2&D1&D&!C1&C&!B&A1&!A|!E&D2&!D1&D&!C1&C&!B&A1&!A|!E&!D2&!D1&D&!C1&C&!B&A1&!A|!E&!D2&!D1&D&C1&C&!B&A1&!A|!E&D2&!D1&D&C1&C&!B&A1&!A|!E&!D2&D1&D&C1&C&!B&A1&!A|!E&!D2&D1&!D&C1&C&!B&A1&!A|!E&D2&D1&!D&C1&C&!B&A1&!A|!E&D2&!D1&!D&C1&C&!B&A1&!A|!E&!D2&!D1&!D&C1&C&!B&A1&!A|!E&!D2&!D1&!D&C1&!C&!B&A1&!A|!E&D2&!D1&!D&C1&!C&!B&A1&!A|!E&D2&D1&!D&C1&!C&!B&A1&!A|!E&!D2&D1&!D&C1&!C&!B&A1&!A|!E&!D2&D1&D&C1&!C&!B&A1&!A|!E&D2&!D1&D&C1&!C&!B&A1&!A|!E&!D2&!D1&D&C1&!C&!B&A1&!A|!E&!D2&!D1&D&!C1&!C&!B&A1&!A|!E&D2&!D1&D&!C1&!C&!B&A1&!A|!E&!D2&D1&D&!C1&!C&!B&A1&!A|!E&!D2&D1&!D&!C1&!C&!B&A1&!A|!E&D2&D1&!D&!C1&!C&!B&A1&!A|!E&D2&!D1&!D&!C1&!C&!B&A1&!A|!E&!D2&!D1&!D&!C1&!C&!B&A1&!A|!E&!D2&!D1&!D&!C1&!C&!B&A1&A|!E&D2&!D1&!D&!C1&!C&!B&A1&A|!E&D2&D1&!D&!C1&!C&!B&A1&A|!E&!D2&D1&!D&!C1&!C&!B&A1&A|!E&!D2&D1&D&!C1&!C&!B&A1&A|!E&D2&!D1&D&!C1&!C&!B&A1&A|!E&!D2&!D1&D&!C1&!C&!B&A1&A|!E&!D2&!D1&D&!C1&!C&B&A1&A|!E&D2&!D1&D&!C1&!C&B&A1&A|!E&!D2&D1&D&!C1&!C&B&A1&A|!E&!D2&D1&!D&!C1&!C&B&A1&A|!E&D2&D1&!D&!C1&!C&B&A1&A|!E&D2&!D1&!D&!C1&!C&B&A1&A|!E&!D2&!D1&!D&!C1&!C&B&A1&A|!E&!D2&!D1&!D&!C1&!C&B&!A1&A|!E&D2&!D1&!D&!C1&!C&B&!A1&A|!E&D2&D1&!D&!C1&!C&B&!A1&A|!E&!D2&D1&!D&!C1&!C&B&!A1&A|!E&!D2&D1&D&!C1&!C&B&!A1&A|!E&D2&!D1&D&!C1&!C&B&!A1&A|!E&!D2&!D1&D&!C1&!C&B&!A1&A|!E&!D2&!D1&!D&!C1&C&!B&!A1&A|!E&D2&!D1&!D&!C1&C&!B&!A1&A|!E&D2&D1&!D&!C1&C&!B&!A1&A|!E&!D2&D1&!D&!C1&C&!B&!A1&A|!E&!D2&D1&D&!C1&C&!B&!A1&A|!E&D2&!D1&D&!C1&C&!B&!A1&A|!E&!D2&!D1&D&!C1&C&!B&!A1&A|!E&!D2&!D1&D&C1&C&!B&!A1&A|!E&D2&!D1&D&C1&C&!B&!A1&A|!E&!D2&D1&D&C1&C&!B&!A1&A|!E&!D2&D1&!D&C1&C&!B&!A1&A|!E&D2&D1&!D&C1&C&!B&!A1&A|!E&D2&!D1&!D&C1&C&!B&!A1&A|!E&!D2&!D1&!D&C1&C&!B&!A1&A|!E&!D2&!D1&!D&C1&!C&!B&!A1&A|!E&D2&!D1&!D&C1&!C&!B&!A1&A|!E&D2&D1&!D&C1&!C&!B&!A1&A|!E&!D2&D1&!D&C1&!C&!B&!A1&A|!E&!D2&D1&D&C1&!C&!B&!A1&A|!E&D2&!D1&D&C1&!C&!B&!A1&A|!E&!D2&!D1&D&C1&!C&!B&!A1&A|!E&!D2&!D1&D&!C1&!C&!B&!A1&A|!E&D2&!D1&D&!C1&!C&!B&!A1&A|!E&!D2&D1&D&!C1&!C&!B&!A1&A|!E&!D2&D1&!D&!C1&!C&!B&!A1&A|!E&D2&D1&!D&!C1&!C&!B&!A1&A|!E&D2&!D1&!D&!C1&!C&!B&!A1&A|!E&!D2&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOI21231.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOI2221 -l OOAOI2221 -i D C1 C B1 B A1 A -o Y -f Y=(!D&!C1&!C&!B1&!B&!A1&!A|!D&C1&!C&!B1&!B&!A1&!A|!D&C1&C&!B1&!B&!A1&!A|!D&!C1&C&!B1&!B&!A1&!A|!D&!C1&C&B1&!B&!A1&!A|!D&C1&C&B1&!B&!A1&!A|!D&C1&!C&B1&!B&!A1&!A|!D&!C1&!C&B1&!B&!A1&!A|!D&!C1&!C&B1&B&!A1&!A|!D&C1&!C&B1&B&!A1&!A|!D&C1&C&B1&B&!A1&!A|!D&!C1&C&B1&B&!A1&!A|!D&!C1&C&!B1&B&!A1&!A|!D&C1&C&!B1&B&!A1&!A|!D&C1&!C&!B1&B&!A1&!A|!D&!C1&!C&!B1&B&!A1&!A|!D&!C1&!C&!B1&B&A1&!A|!D&C1&!C&!B1&B&A1&!A|!D&!C1&C&!B1&B&A1&!A|!D&!C1&C&B1&B&A1&!A|!D&C1&!C&B1&B&A1&!A|!D&!C1&!C&B1&B&A1&!A|!D&!C1&!C&B1&!B&A1&!A|!D&C1&!C&B1&!B&A1&!A|!D&!C1&C&B1&!B&A1&!A|!D&!C1&C&!B1&!B&A1&!A|!D&C1&C&!B1&!B&A1&!A|!D&C1&!C&!B1&!B&A1&!A|!D&!C1&!C&!B1&!B&A1&!A|!D&!C1&!C&!B1&!B&A1&A|!D&C1&!C&!B1&!B&A1&A|!D&C1&C&!B1&!B&A1&A|!D&!C1&C&!B1&!B&A1&A|!D&!C1&C&B1&!B&A1&A|!D&C1&!C&B1&!B&A1&A|!D&!C1&!C&B1&!B&A1&A|!D&!C1&!C&B1&B&A1&A|!D&C1&!C&B1&B&A1&A|!D&!C1&C&B1&B&A1&A|!D&!C1&C&!B1&B&A1&A|!D&C1&!C&!B1&B&A1&A|!D&!C1&!C&!B1&B&A1&A|!D&!C1&!C&!B1&B&!A1&A|!D&C1&!C&!B1&B&!A1&A|!D&!C1&C&!B1&B&!A1&A|!D&!C1&C&B1&B&!A1&A|!D&C1&!C&B1&B&!A1&A|!D&!C1&!C&B1&B&!A1&A|!D&!C1&!C&B1&!B&!A1&A|!D&C1&!C&B1&!B&!A1&A|!D&!C1&C&B1&!B&!A1&A|!D&!C1&C&!B1&!B&!A1&A|!D&C1&C&!B1&!B&!A1&A|!D&C1&!C&!B1&!B&!A1&A|!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOI2221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAAOI22132 -l AAOAAAOI22132 -i E1 E D2 D1 D C B1 B A1 A -o Y -f Y=!(E1&E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|E1&E&D2&!D1&!D&!C&!B1&!B&!A1&!A|E1&E&D2&D1&!D&!C&!B1&!B&!A1&!A|E1&E&!D2&D1&!D&!C&!B1&!B&!A1&!A|E1&E&!D2&D1&D&!C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&!C&!B1&!B&!A1&!A|E1&E&D2&D1&D&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&!C&!B1&!B&!A1&!A|!E1&!E&D2&D1&D&!C&!B1&!B&!A1&!A|E1&E&D2&!D1&D&!C&!B1&!B&!A1&!A|E1&E&!D2&!D1&D&!C&!B1&!B&!A1&!A|E1&E&!D2&!D1&D&C&!B1&!B&!A1&!A|E1&E&D2&!D1&D&C&!B1&!B&!A1&!A|!E1&!E&D2&D1&D&C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&C&!B1&!B&!A1&!A|E1&E&D2&D1&D&C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&C&!B1&!B&!A1&!A|E1&E&!D2&D1&D&C&!B1&!B&!A1&!A|E1&E&!D2&D1&!D&C&!B1&!B&!A1&!A|E1&E&D2&D1&!D&C&!B1&!B&!A1&!A|E1&E&D2&!D1&!D&C&!B1&!B&!A1&!A|E1&E&!D2&!D1&!D&C&!B1&!B&!A1&!A|E1&E&!D2&!D1&!D&C&B1&!B&!A1&!A|E1&E&D2&!D1&!D&C&B1&!B&!A1&!A|E1&E&D2&D1&!D&C&B1&!B&!A1&!A|E1&E&!D2&D1&!D&C&B1&!B&!A1&!A|E1&E&!D2&D1&D&C&B1&!B&!A1&!A|!E1&E&D2&D1&D&C&B1&!B&!A1&!A|E1&E&D2&D1&D&C&B1&!B&!A1&!A|E1&!E&D2&D1&D&C&B1&!B&!A1&!A|!E1&!E&D2&D1&D&C&B1&!B&!A1&!A|E1&E&D2&!D1&D&C&B1&!B&!A1&!A|E1&E&!D2&!D1&D&C&B1&!B&!A1&!A|E1&E&!D2&!D1&D&!C&B1&!B&!A1&!A|E1&E&D2&!D1&D&!C&B1&!B&!A1&!A|!E1&!E&D2&D1&D&!C&B1&!B&!A1&!A|E1&!E&D2&D1&D&!C&B1&!B&!A1&!A|E1&E&D2&D1&D&!C&B1&!B&!A1&!A|!E1&E&D2&D1&D&!C&B1&!B&!A1&!A|E1&E&!D2&D1&D&!C&B1&!B&!A1&!A|E1&E&!D2&D1&!D&!C&B1&!B&!A1&!A|E1&E&D2&D1&!D&!C&B1&!B&!A1&!A|E1&E&D2&!D1&!D&!C&B1&!B&!A1&!A|E1&E&!D2&!D1&!D&!C&B1&!B&!A1&!A|E1&E&!D2&!D1&!D&!C&B1&B&!A1&!A|E1&E&D2&!D1&!D&!C&B1&B&!A1&!A|E1&E&D2&D1&!D&!C&B1&B&!A1&!A|E1&E&!D2&D1&!D&!C&B1&B&!A1&!A|E1&E&!D2&D1&D&!C&B1&B&!A1&!A|!E1&E&D2&D1&D&!C&B1&B&!A1&!A|E1&E&D2&D1&D&!C&B1&B&!A1&!A|E1&!E&D2&D1&D&!C&B1&B&!A1&!A|!E1&!E&D2&D1&D&!C&B1&B&!A1&!A|E1&E&D2&!D1&D&!C&B1&B&!A1&!A|E1&E&!D2&!D1&D&!C&B1&B&!A1&!A|!E1&!E&!D2&!D1&D&C&B1&B&!A1&!A|E1&!E&!D2&!D1&D&C&B1&B&!A1&!A|E1&E&!D2&!D1&D&C&B1&B&!A1&!A|!E1&E&!D2&!D1&D&C&B1&B&!A1&!A|!E1&E&D2&!D1&D&C&B1&B&!A1&!A|E1&E&D2&!D1&D&C&B1&B&!A1&!A|E1&!E&D2&!D1&D&C&B1&B&!A1&!A|!E1&!E&D2&!D1&D&C&B1&B&!A1&!A|!E1&!E&D2&D1&D&C&B1&B&!A1&!A|E1&!E&D2&D1&D&C&B1&B&!A1&!A|E1&E&D2&D1&D&C&B1&B&!A1&!A|!E1&E&D2&D1&D&C&B1&B&!A1&!A|!E1&E&!D2&D1&D&C&B1&B&!A1&!A|E1&E&!D2&D1&D&C&B1&B&!A1&!A|E1&!E&!D2&D1&D&C&B1&B&!A1&!A|!E1&!E&!D2&D1&D&C&B1&B&!A1&!A|!E1&!E&!D2&D1&!D&C&B1&B&!A1&!A|E1&!E&!D2&D1&!D&C&B1&B&!A1&!A|E1&E&!D2&D1&!D&C&B1&B&!A1&!A|!E1&E&!D2&D1&!D&C&B1&B&!A1&!A|!E1&E&D2&D1&!D&C&B1&B&!A1&!A|E1&E&D2&D1&!D&C&B1&B&!A1&!A|E1&!E&D2&D1&!D&C&B1&B&!A1&!A|!E1&!E&D2&D1&!D&C&B1&B&!A1&!A|!E1&!E&D2&!D1&!D&C&B1&B&!A1&!A|E1&!E&D2&!D1&!D&C&B1&B&!A1&!A|E1&E&D2&!D1&!D&C&B1&B&!A1&!A|!E1&E&D2&!D1&!D&C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C&B1&B&!A1&!A|E1&E&!D2&!D1&!D&C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C&B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&C&B1&B&!A1&!A|E1&E&!D2&!D1&!D&C&!B1&B&!A1&!A|E1&E&D2&!D1&!D&C&!B1&B&!A1&!A|E1&E&D2&D1&!D&C&!B1&B&!A1&!A|E1&E&!D2&D1&!D&C&!B1&B&!A1&!A|E1&E&!D2&D1&D&C&!B1&B&!A1&!A|!E1&E&D2&D1&D&C&!B1&B&!A1&!A|E1&E&D2&D1&D&C&!B1&B&!A1&!A|E1&!E&D2&D1&D&C&!B1&B&!A1&!A|!E1&!E&D2&D1&D&C&!B1&B&!A1&!A|E1&E&D2&!D1&D&C&!B1&B&!A1&!A|E1&E&!D2&!D1&D&C&!B1&B&!A1&!A|E1&E&!D2&!D1&D&!C&!B1&B&!A1&!A|E1&E&D2&!D1&D&!C&!B1&B&!A1&!A|!E1&!E&D2&D1&D&!C&!B1&B&!A1&!A|E1&!E&D2&D1&D&!C&!B1&B&!A1&!A|E1&E&D2&D1&D&!C&!B1&B&!A1&!A|!E1&E&D2&D1&D&!C&!B1&B&!A1&!A|E1&E&!D2&D1&D&!C&!B1&B&!A1&!A|E1&E&!D2&D1&!D&!C&!B1&B&!A1&!A|E1&E&D2&D1&!D&!C&!B1&B&!A1&!A|E1&E&D2&!D1&!D&!C&!B1&B&!A1&!A|E1&E&!D2&!D1&!D&!C&!B1&B&!A1&!A|E1&E&!D2&!D1&!D&!C&!B1&B&A1&!A|E1&E&D2&!D1&!D&!C&!B1&B&A1&!A|E1&E&D2&D1&!D&!C&!B1&B&A1&!A|E1&E&!D2&D1&!D&!C&!B1&B&A1&!A|E1&E&!D2&D1&D&!C&!B1&B&A1&!A|!E1&E&D2&D1&D&!C&!B1&B&A1&!A|E1&E&D2&D1&D&!C&!B1&B&A1&!A|E1&!E&D2&D1&D&!C&!B1&B&A1&!A|!E1&!E&D2&D1&D&!C&!B1&B&A1&!A|E1&E&D2&!D1&D&!C&!B1&B&A1&!A|E1&E&!D2&!D1&D&!C&!B1&B&A1&!A|E1&E&!D2&!D1&D&C&!B1&B&A1&!A|E1&E&D2&!D1&D&C&!B1&B&A1&!A|!E1&!E&D2&D1&D&C&!B1&B&A1&!A|E1&!E&D2&D1&D&C&!B1&B&A1&!A|E1&E&D2&D1&D&C&!B1&B&A1&!A|!E1&E&D2&D1&D&C&!B1&B&A1&!A|E1&E&!D2&D1&D&C&!B1&B&A1&!A|E1&E&!D2&D1&!D&C&!B1&B&A1&!A|E1&E&D2&D1&!D&C&!B1&B&A1&!A|E1&E&D2&!D1&!D&C&!B1&B&A1&!A|E1&E&!D2&!D1&!D&C&!B1&B&A1&!A|!E1&!E&!D2&!D1&!D&C&B1&B&A1&!A|E1&!E&!D2&!D1&!D&C&B1&B&A1&!A|E1&E&!D2&!D1&!D&C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&C&B1&B&A1&!A|!E1&E&D2&!D1&!D&C&B1&B&A1&!A|E1&E&D2&!D1&!D&C&B1&B&A1&!A|E1&!E&D2&!D1&!D&C&B1&B&A1&!A|!E1&!E&D2&!D1&!D&C&B1&B&A1&!A|!E1&!E&D2&D1&!D&C&B1&B&A1&!A|E1&!E&D2&D1&!D&C&B1&B&A1&!A|E1&E&D2&D1&!D&C&B1&B&A1&!A|!E1&E&D2&D1&!D&C&B1&B&A1&!A|!E1&E&!D2&D1&!D&C&B1&B&A1&!A|E1&E&!D2&D1&!D&C&B1&B&A1&!A|E1&!E&!D2&D1&!D&C&B1&B&A1&!A|!E1&!E&!D2&D1&!D&C&B1&B&A1&!A|!E1&!E&!D2&D1&D&C&B1&B&A1&!A|E1&!E&!D2&D1&D&C&B1&B&A1&!A|E1&E&!D2&D1&D&C&B1&B&A1&!A|!E1&E&!D2&D1&D&C&B1&B&A1&!A|!E1&E&D2&D1&D&C&B1&B&A1&!A|E1&E&D2&D1&D&C&B1&B&A1&!A|E1&!E&D2&D1&D&C&B1&B&A1&!A|!E1&!E&D2&D1&D&C&B1&B&A1&!A|!E1&!E&D2&!D1&D&C&B1&B&A1&!A|E1&!E&D2&!D1&D&C&B1&B&A1&!A|E1&E&D2&!D1&D&C&B1&B&A1&!A|!E1&E&D2&!D1&D&C&B1&B&A1&!A|!E1&E&!D2&!D1&D&C&B1&B&A1&!A|E1&E&!D2&!D1&D&C&B1&B&A1&!A|E1&!E&!D2&!D1&D&C&B1&B&A1&!A|!E1&!E&!D2&!D1&D&C&B1&B&A1&!A|E1&E&!D2&!D1&D&!C&B1&B&A1&!A|E1&E&D2&!D1&D&!C&B1&B&A1&!A|!E1&!E&D2&D1&D&!C&B1&B&A1&!A|E1&!E&D2&D1&D&!C&B1&B&A1&!A|E1&E&D2&D1&D&!C&B1&B&A1&!A|!E1&E&D2&D1&D&!C&B1&B&A1&!A|E1&E&!D2&D1&D&!C&B1&B&A1&!A|E1&E&!D2&D1&!D&!C&B1&B&A1&!A|E1&E&D2&D1&!D&!C&B1&B&A1&!A|E1&E&D2&!D1&!D&!C&B1&B&A1&!A|E1&E&!D2&!D1&!D&!C&B1&B&A1&!A|E1&E&!D2&!D1&!D&!C&B1&!B&A1&!A|E1&E&D2&!D1&!D&!C&B1&!B&A1&!A|E1&E&D2&D1&!D&!C&B1&!B&A1&!A|E1&E&!D2&D1&!D&!C&B1&!B&A1&!A|E1&E&!D2&D1&D&!C&B1&!B&A1&!A|!E1&E&D2&D1&D&!C&B1&!B&A1&!A|E1&E&D2&D1&D&!C&B1&!B&A1&!A|E1&!E&D2&D1&D&!C&B1&!B&A1&!A|!E1&!E&D2&D1&D&!C&B1&!B&A1&!A|E1&E&D2&!D1&D&!C&B1&!B&A1&!A|E1&E&!D2&!D1&D&!C&B1&!B&A1&!A|E1&E&!D2&!D1&D&C&B1&!B&A1&!A|E1&E&D2&!D1&D&C&B1&!B&A1&!A|!E1&!E&D2&D1&D&C&B1&!B&A1&!A|E1&!E&D2&D1&D&C&B1&!B&A1&!A|E1&E&D2&D1&D&C&B1&!B&A1&!A|!E1&E&D2&D1&D&C&B1&!B&A1&!A|E1&E&!D2&D1&D&C&B1&!B&A1&!A|E1&E&!D2&D1&!D&C&B1&!B&A1&!A|E1&E&D2&D1&!D&C&B1&!B&A1&!A|E1&E&D2&!D1&!D&C&B1&!B&A1&!A|E1&E&!D2&!D1&!D&C&B1&!B&A1&!A|E1&E&!D2&!D1&!D&C&!B1&!B&A1&!A|E1&E&D2&!D1&!D&C&!B1&!B&A1&!A|E1&E&D2&D1&!D&C&!B1&!B&A1&!A|E1&E&!D2&D1&!D&C&!B1&!B&A1&!A|E1&E&!D2&D1&D&C&!B1&!B&A1&!A|!E1&E&D2&D1&D&C&!B1&!B&A1&!A|E1&E&D2&D1&D&C&!B1&!B&A1&!A|E1&!E&D2&D1&D&C&!B1&!B&A1&!A|!E1&!E&D2&D1&D&C&!B1&!B&A1&!A|E1&E&D2&!D1&D&C&!B1&!B&A1&!A|E1&E&!D2&!D1&D&C&!B1&!B&A1&!A|E1&E&!D2&!D1&D&!C&!B1&!B&A1&!A|E1&E&D2&!D1&D&!C&!B1&!B&A1&!A|!E1&!E&D2&D1&D&!C&!B1&!B&A1&!A|E1&!E&D2&D1&D&!C&!B1&!B&A1&!A|E1&E&D2&D1&D&!C&!B1&!B&A1&!A|!E1&E&D2&D1&D&!C&!B1&!B&A1&!A|E1&E&!D2&D1&D&!C&!B1&!B&A1&!A|E1&E&!D2&D1&!D&!C&!B1&!B&A1&!A|E1&E&D2&D1&!D&!C&!B1&!B&A1&!A|E1&E&D2&!D1&!D&!C&!B1&!B&A1&!A|E1&E&!D2&!D1&!D&!C&!B1&!B&A1&!A|E1&E&!D2&!D1&!D&!C&!B1&!B&A1&A|E1&E&D2&!D1&!D&!C&!B1&!B&A1&A|E1&E&D2&D1&!D&!C&!B1&!B&A1&A|E1&E&!D2&D1&!D&!C&!B1&!B&A1&A|E1&E&!D2&D1&D&!C&!B1&!B&A1&A|!E1&E&D2&D1&D&!C&!B1&!B&A1&A|E1&E&D2&D1&D&!C&!B1&!B&A1&A|E1&!E&D2&D1&D&!C&!B1&!B&A1&A|!E1&!E&D2&D1&D&!C&!B1&!B&A1&A|E1&E&D2&!D1&D&!C&!B1&!B&A1&A|E1&E&!D2&!D1&D&!C&!B1&!B&A1&A|!E1&!E&!D2&!D1&D&C&!B1&!B&A1&A|E1&!E&!D2&!D1&D&C&!B1&!B&A1&A|E1&E&!D2&!D1&D&C&!B1&!B&A1&A|!E1&E&!D2&!D1&D&C&!B1&!B&A1&A|!E1&E&D2&!D1&D&C&!B1&!B&A1&A|E1&E&D2&!D1&D&C&!B1&!B&A1&A|E1&!E&D2&!D1&D&C&!B1&!B&A1&A|!E1&!E&D2&!D1&D&C&!B1&!B&A1&A|!E1&!E&D2&D1&D&C&!B1&!B&A1&A|E1&!E&D2&D1&D&C&!B1&!B&A1&A|E1&E&D2&D1&D&C&!B1&!B&A1&A|!E1&E&D2&D1&D&C&!B1&!B&A1&A|!E1&E&!D2&D1&D&C&!B1&!B&A1&A|E1&E&!D2&D1&D&C&!B1&!B&A1&A|E1&!E&!D2&D1&D&C&!B1&!B&A1&A|!E1&!E&!D2&D1&D&C&!B1&!B&A1&A|!E1&!E&!D2&D1&!D&C&!B1&!B&A1&A|E1&!E&!D2&D1&!D&C&!B1&!B&A1&A|E1&E&!D2&D1&!D&C&!B1&!B&A1&A|!E1&E&!D2&D1&!D&C&!B1&!B&A1&A|!E1&E&D2&D1&!D&C&!B1&!B&A1&A|E1&E&D2&D1&!D&C&!B1&!B&A1&A|E1&!E&D2&D1&!D&C&!B1&!B&A1&A|!E1&!E&D2&D1&!D&C&!B1&!B&A1&A|!E1&!E&D2&!D1&!D&C&!B1&!B&A1&A|E1&!E&D2&!D1&!D&C&!B1&!B&A1&A|E1&E&D2&!D1&!D&C&!B1&!B&A1&A|!E1&E&D2&!D1&!D&C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&C&!B1&!B&A1&A|E1&E&!D2&!D1&!D&C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&C&!B1&!B&A1&A|!E1&!E&!D2&!D1&!D&C&!B1&!B&A1&A|!E1&!E&!D2&!D1&!D&C&B1&!B&A1&A|E1&!E&!D2&!D1&!D&C&B1&!B&A1&A|E1&E&!D2&!D1&!D&C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&C&B1&!B&A1&A|!E1&E&D2&!D1&!D&C&B1&!B&A1&A|E1&E&D2&!D1&!D&C&B1&!B&A1&A|E1&!E&D2&!D1&!D&C&B1&!B&A1&A|!E1&!E&D2&!D1&!D&C&B1&!B&A1&A|!E1&!E&D2&D1&!D&C&B1&!B&A1&A|E1&!E&D2&D1&!D&C&B1&!B&A1&A|E1&E&D2&D1&!D&C&B1&!B&A1&A|!E1&E&D2&D1&!D&C&B1&!B&A1&A|!E1&E&!D2&D1&!D&C&B1&!B&A1&A|E1&E&!D2&D1&!D&C&B1&!B&A1&A|E1&!E&!D2&D1&!D&C&B1&!B&A1&A|!E1&!E&!D2&D1&!D&C&B1&!B&A1&A|!E1&!E&!D2&D1&D&C&B1&!B&A1&A|E1&!E&!D2&D1&D&C&B1&!B&A1&A|E1&E&!D2&D1&D&C&B1&!B&A1&A|!E1&E&!D2&D1&D&C&B1&!B&A1&A|!E1&E&D2&D1&D&C&B1&!B&A1&A|E1&E&D2&D1&D&C&B1&!B&A1&A|E1&!E&D2&D1&D&C&B1&!B&A1&A|!E1&!E&D2&D1&D&C&B1&!B&A1&A|!E1&!E&D2&!D1&D&C&B1&!B&A1&A|E1&!E&D2&!D1&D&C&B1&!B&A1&A|E1&E&D2&!D1&D&C&B1&!B&A1&A|!E1&E&D2&!D1&D&C&B1&!B&A1&A|!E1&E&!D2&!D1&D&C&B1&!B&A1&A|E1&E&!D2&!D1&D&C&B1&!B&A1&A|E1&!E&!D2&!D1&D&C&B1&!B&A1&A|!E1&!E&!D2&!D1&D&C&B1&!B&A1&A|E1&E&!D2&!D1&D&!C&B1&!B&A1&A|E1&E&D2&!D1&D&!C&B1&!B&A1&A|!E1&!E&D2&D1&D&!C&B1&!B&A1&A|E1&!E&D2&D1&D&!C&B1&!B&A1&A|E1&E&D2&D1&D&!C&B1&!B&A1&A|!E1&E&D2&D1&D&!C&B1&!B&A1&A|E1&E&!D2&D1&D&!C&B1&!B&A1&A|E1&E&!D2&D1&!D&!C&B1&!B&A1&A|E1&E&D2&D1&!D&!C&B1&!B&A1&A|E1&E&D2&!D1&!D&!C&B1&!B&A1&A|E1&E&!D2&!D1&!D&!C&B1&!B&A1&A|E1&E&!D2&!D1&!D&!C&B1&B&A1&A|E1&E&D2&!D1&!D&!C&B1&B&A1&A|E1&E&D2&D1&!D&!C&B1&B&A1&A|E1&E&!D2&D1&!D&!C&B1&B&A1&A|E1&E&!D2&D1&D&!C&B1&B&A1&A|!E1&E&D2&D1&D&!C&B1&B&A1&A|E1&E&D2&D1&D&!C&B1&B&A1&A|E1&!E&D2&D1&D&!C&B1&B&A1&A|!E1&!E&D2&D1&D&!C&B1&B&A1&A|E1&E&D2&!D1&D&!C&B1&B&A1&A|E1&E&!D2&!D1&D&!C&B1&B&A1&A|!E1&!E&!D2&!D1&D&C&B1&B&A1&A|E1&!E&!D2&!D1&D&C&B1&B&A1&A|E1&E&!D2&!D1&D&C&B1&B&A1&A|!E1&E&!D2&!D1&D&C&B1&B&A1&A|!E1&E&D2&!D1&D&C&B1&B&A1&A|E1&E&D2&!D1&D&C&B1&B&A1&A|E1&!E&D2&!D1&D&C&B1&B&A1&A|!E1&!E&D2&!D1&D&C&B1&B&A1&A|!E1&!E&D2&D1&D&C&B1&B&A1&A|E1&!E&D2&D1&D&C&B1&B&A1&A|E1&E&D2&D1&D&C&B1&B&A1&A|!E1&E&D2&D1&D&C&B1&B&A1&A|!E1&E&!D2&D1&D&C&B1&B&A1&A|E1&E&!D2&D1&D&C&B1&B&A1&A|E1&!E&!D2&D1&D&C&B1&B&A1&A|!E1&!E&!D2&D1&D&C&B1&B&A1&A|!E1&!E&!D2&D1&!D&C&B1&B&A1&A|E1&!E&!D2&D1&!D&C&B1&B&A1&A|E1&E&!D2&D1&!D&C&B1&B&A1&A|!E1&E&!D2&D1&!D&C&B1&B&A1&A|!E1&E&D2&D1&!D&C&B1&B&A1&A|E1&E&D2&D1&!D&C&B1&B&A1&A|E1&!E&D2&D1&!D&C&B1&B&A1&A|!E1&!E&D2&D1&!D&C&B1&B&A1&A|!E1&!E&D2&!D1&!D&C&B1&B&A1&A|E1&!E&D2&!D1&!D&C&B1&B&A1&A|E1&E&D2&!D1&!D&C&B1&B&A1&A|!E1&E&D2&!D1&!D&C&B1&B&A1&A|!E1&E&!D2&!D1&!D&C&B1&B&A1&A|E1&E&!D2&!D1&!D&C&B1&B&A1&A|E1&!E&!D2&!D1&!D&C&B1&B&A1&A|!E1&!E&!D2&!D1&!D&C&B1&B&A1&A|!E1&!E&!D2&!D1&!D&C&!B1&B&A1&A|E1&!E&!D2&!D1&!D&C&!B1&B&A1&A|E1&E&!D2&!D1&!D&C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&C&!B1&B&A1&A|!E1&E&D2&!D1&!D&C&!B1&B&A1&A|E1&E&D2&!D1&!D&C&!B1&B&A1&A|E1&!E&D2&!D1&!D&C&!B1&B&A1&A|!E1&!E&D2&!D1&!D&C&!B1&B&A1&A|!E1&!E&D2&D1&!D&C&!B1&B&A1&A|E1&!E&D2&D1&!D&C&!B1&B&A1&A|E1&E&D2&D1&!D&C&!B1&B&A1&A|!E1&E&D2&D1&!D&C&!B1&B&A1&A|!E1&E&!D2&D1&!D&C&!B1&B&A1&A|E1&E&!D2&D1&!D&C&!B1&B&A1&A|E1&!E&!D2&D1&!D&C&!B1&B&A1&A|!E1&!E&!D2&D1&!D&C&!B1&B&A1&A|!E1&!E&!D2&D1&D&C&!B1&B&A1&A|E1&!E&!D2&D1&D&C&!B1&B&A1&A|E1&E&!D2&D1&D&C&!B1&B&A1&A|!E1&E&!D2&D1&D&C&!B1&B&A1&A|!E1&E&D2&D1&D&C&!B1&B&A1&A|E1&E&D2&D1&D&C&!B1&B&A1&A|E1&!E&D2&D1&D&C&!B1&B&A1&A|!E1&!E&D2&D1&D&C&!B1&B&A1&A|!E1&!E&D2&!D1&D&C&!B1&B&A1&A|E1&!E&D2&!D1&D&C&!B1&B&A1&A|E1&E&D2&!D1&D&C&!B1&B&A1&A|!E1&E&D2&!D1&D&C&!B1&B&A1&A|!E1&E&!D2&!D1&D&C&!B1&B&A1&A|E1&E&!D2&!D1&D&C&!B1&B&A1&A|E1&!E&!D2&!D1&D&C&!B1&B&A1&A|!E1&!E&!D2&!D1&D&C&!B1&B&A1&A|E1&E&!D2&!D1&D&!C&!B1&B&A1&A|E1&E&D2&!D1&D&!C&!B1&B&A1&A|!E1&!E&D2&D1&D&!C&!B1&B&A1&A|E1&!E&D2&D1&D&!C&!B1&B&A1&A|E1&E&D2&D1&D&!C&!B1&B&A1&A|!E1&E&D2&D1&D&!C&!B1&B&A1&A|E1&E&!D2&D1&D&!C&!B1&B&A1&A|E1&E&!D2&D1&!D&!C&!B1&B&A1&A|E1&E&D2&D1&!D&!C&!B1&B&A1&A|E1&E&D2&!D1&!D&!C&!B1&B&A1&A|E1&E&!D2&!D1&!D&!C&!B1&B&A1&A|E1&E&!D2&!D1&!D&!C&!B1&B&!A1&A|E1&E&D2&!D1&!D&!C&!B1&B&!A1&A|E1&E&D2&D1&!D&!C&!B1&B&!A1&A|E1&E&!D2&D1&!D&!C&!B1&B&!A1&A|E1&E&!D2&D1&D&!C&!B1&B&!A1&A|!E1&E&D2&D1&D&!C&!B1&B&!A1&A|E1&E&D2&D1&D&!C&!B1&B&!A1&A|E1&!E&D2&D1&D&!C&!B1&B&!A1&A|!E1&!E&D2&D1&D&!C&!B1&B&!A1&A|E1&E&D2&!D1&D&!C&!B1&B&!A1&A|E1&E&!D2&!D1&D&!C&!B1&B&!A1&A|E1&E&!D2&!D1&D&C&!B1&B&!A1&A|E1&E&D2&!D1&D&C&!B1&B&!A1&A|!E1&!E&D2&D1&D&C&!B1&B&!A1&A|E1&!E&D2&D1&D&C&!B1&B&!A1&A|E1&E&D2&D1&D&C&!B1&B&!A1&A|!E1&E&D2&D1&D&C&!B1&B&!A1&A|E1&E&!D2&D1&D&C&!B1&B&!A1&A|E1&E&!D2&D1&!D&C&!B1&B&!A1&A|E1&E&D2&D1&!D&C&!B1&B&!A1&A|E1&E&D2&!D1&!D&C&!B1&B&!A1&A|E1&E&!D2&!D1&!D&C&!B1&B&!A1&A|!E1&!E&!D2&!D1&!D&C&B1&B&!A1&A|E1&!E&!D2&!D1&!D&C&B1&B&!A1&A|E1&E&!D2&!D1&!D&C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&C&B1&B&!A1&A|!E1&E&D2&!D1&!D&C&B1&B&!A1&A|E1&E&D2&!D1&!D&C&B1&B&!A1&A|E1&!E&D2&!D1&!D&C&B1&B&!A1&A|!E1&!E&D2&!D1&!D&C&B1&B&!A1&A|!E1&!E&D2&D1&!D&C&B1&B&!A1&A|E1&!E&D2&D1&!D&C&B1&B&!A1&A|E1&E&D2&D1&!D&C&B1&B&!A1&A|!E1&E&D2&D1&!D&C&B1&B&!A1&A|!E1&E&!D2&D1&!D&C&B1&B&!A1&A|E1&E&!D2&D1&!D&C&B1&B&!A1&A|E1&!E&!D2&D1&!D&C&B1&B&!A1&A|!E1&!E&!D2&D1&!D&C&B1&B&!A1&A|!E1&!E&!D2&D1&D&C&B1&B&!A1&A|E1&!E&!D2&D1&D&C&B1&B&!A1&A|E1&E&!D2&D1&D&C&B1&B&!A1&A|!E1&E&!D2&D1&D&C&B1&B&!A1&A|!E1&E&D2&D1&D&C&B1&B&!A1&A|E1&E&D2&D1&D&C&B1&B&!A1&A|E1&!E&D2&D1&D&C&B1&B&!A1&A|!E1&!E&D2&D1&D&C&B1&B&!A1&A|!E1&!E&D2&!D1&D&C&B1&B&!A1&A|E1&!E&D2&!D1&D&C&B1&B&!A1&A|E1&E&D2&!D1&D&C&B1&B&!A1&A|!E1&E&D2&!D1&D&C&B1&B&!A1&A|!E1&E&!D2&!D1&D&C&B1&B&!A1&A|E1&E&!D2&!D1&D&C&B1&B&!A1&A|E1&!E&!D2&!D1&D&C&B1&B&!A1&A|!E1&!E&!D2&!D1&D&C&B1&B&!A1&A|E1&E&!D2&!D1&D&!C&B1&B&!A1&A|E1&E&D2&!D1&D&!C&B1&B&!A1&A|!E1&!E&D2&D1&D&!C&B1&B&!A1&A|E1&!E&D2&D1&D&!C&B1&B&!A1&A|E1&E&D2&D1&D&!C&B1&B&!A1&A|!E1&E&D2&D1&D&!C&B1&B&!A1&A|E1&E&!D2&D1&D&!C&B1&B&!A1&A|E1&E&!D2&D1&!D&!C&B1&B&!A1&A|E1&E&D2&D1&!D&!C&B1&B&!A1&A|E1&E&D2&!D1&!D&!C&B1&B&!A1&A|E1&E&!D2&!D1&!D&!C&B1&B&!A1&A|E1&E&!D2&!D1&!D&!C&B1&!B&!A1&A|E1&E&D2&!D1&!D&!C&B1&!B&!A1&A|E1&E&D2&D1&!D&!C&B1&!B&!A1&A|E1&E&!D2&D1&!D&!C&B1&!B&!A1&A|E1&E&!D2&D1&D&!C&B1&!B&!A1&A|!E1&E&D2&D1&D&!C&B1&!B&!A1&A|E1&E&D2&D1&D&!C&B1&!B&!A1&A|E1&!E&D2&D1&D&!C&B1&!B&!A1&A|!E1&!E&D2&D1&D&!C&B1&!B&!A1&A|E1&E&D2&!D1&D&!C&B1&!B&!A1&A|E1&E&!D2&!D1&D&!C&B1&!B&!A1&A|E1&E&!D2&!D1&D&C&B1&!B&!A1&A|E1&E&D2&!D1&D&C&B1&!B&!A1&A|!E1&!E&D2&D1&D&C&B1&!B&!A1&A|E1&!E&D2&D1&D&C&B1&!B&!A1&A|E1&E&D2&D1&D&C&B1&!B&!A1&A|!E1&E&D2&D1&D&C&B1&!B&!A1&A|E1&E&!D2&D1&D&C&B1&!B&!A1&A|E1&E&!D2&D1&!D&C&B1&!B&!A1&A|E1&E&D2&D1&!D&C&B1&!B&!A1&A|E1&E&D2&!D1&!D&C&B1&!B&!A1&A|E1&E&!D2&!D1&!D&C&B1&!B&!A1&A|E1&E&!D2&!D1&!D&C&!B1&!B&!A1&A|E1&E&D2&!D1&!D&C&!B1&!B&!A1&A|E1&E&D2&D1&!D&C&!B1&!B&!A1&A|E1&E&!D2&D1&!D&C&!B1&!B&!A1&A|E1&E&!D2&D1&D&C&!B1&!B&!A1&A|!E1&E&D2&D1&D&C&!B1&!B&!A1&A|E1&E&D2&D1&D&C&!B1&!B&!A1&A|E1&!E&D2&D1&D&C&!B1&!B&!A1&A|!E1&!E&D2&D1&D&C&!B1&!B&!A1&A|E1&E&D2&!D1&D&C&!B1&!B&!A1&A|E1&E&!D2&!D1&D&C&!B1&!B&!A1&A|E1&E&!D2&!D1&D&!C&!B1&!B&!A1&A|E1&E&D2&!D1&D&!C&!B1&!B&!A1&A|!E1&!E&D2&D1&D&!C&!B1&!B&!A1&A|E1&!E&D2&D1&D&!C&!B1&!B&!A1&A|E1&E&D2&D1&D&!C&!B1&!B&!A1&A|!E1&E&D2&D1&D&!C&!B1&!B&!A1&A|E1&E&!D2&D1&D&!C&!B1&!B&!A1&A|E1&E&!D2&D1&!D&!C&!B1&!B&!A1&A|E1&E&D2&D1&!D&!C&!B1&!B&!A1&A|E1&E&D2&!D1&!D&!C&!B1&!B&!A1&A|E1&E&!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAAOI22132.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAI3331 -l OOOAI3331 -i D C2 C1 C B2 B1 B A2 A1 A -o Y -f Y=!(D&C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|D&C2&C1&!C&!B2&!B1&B&A2&!A1&!A|D&!C2&C1&!C&!B2&!B1&B&A2&!A1&!A|D&!C2&C1&C&!B2&!B1&B&A2&!A1&!A|D&C2&C1&C&!B2&!B1&B&A2&!A1&!A|D&C2&!C1&C&!B2&!B1&B&A2&!A1&!A|D&!C2&!C1&C&!B2&!B1&B&A2&!A1&!A|D&!C2&!C1&C&B2&!B1&B&A2&!A1&!A|D&C2&!C1&C&B2&!B1&B&A2&!A1&!A|D&C2&C1&C&B2&!B1&B&A2&!A1&!A|D&!C2&C1&C&B2&!B1&B&A2&!A1&!A|D&!C2&C1&!C&B2&!B1&B&A2&!A1&!A|D&C2&C1&!C&B2&!B1&B&A2&!A1&!A|D&C2&!C1&!C&B2&!B1&B&A2&!A1&!A|D&C2&!C1&!C&B2&B1&B&A2&!A1&!A|D&C2&C1&!C&B2&B1&B&A2&!A1&!A|D&!C2&C1&!C&B2&B1&B&A2&!A1&!A|D&!C2&C1&C&B2&B1&B&A2&!A1&!A|D&C2&C1&C&B2&B1&B&A2&!A1&!A|D&C2&!C1&C&B2&B1&B&A2&!A1&!A|D&!C2&!C1&C&B2&B1&B&A2&!A1&!A|D&!C2&!C1&C&!B2&B1&B&A2&!A1&!A|D&C2&!C1&C&!B2&B1&B&A2&!A1&!A|D&C2&C1&C&!B2&B1&B&A2&!A1&!A|D&!C2&C1&C&!B2&B1&B&A2&!A1&!A|D&!C2&C1&!C&!B2&B1&B&A2&!A1&!A|D&C2&C1&!C&!B2&B1&B&A2&!A1&!A|D&C2&!C1&!C&!B2&B1&B&A2&!A1&!A|D&C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|D&C2&C1&!C&!B2&B1&!B&A2&!A1&!A|D&!C2&C1&!C&!B2&B1&!B&A2&!A1&!A|D&!C2&C1&C&!B2&B1&!B&A2&!A1&!A|D&C2&C1&C&!B2&B1&!B&A2&!A1&!A|D&C2&!C1&C&!B2&B1&!B&A2&!A1&!A|D&!C2&!C1&C&!B2&B1&!B&A2&!A1&!A|D&!C2&!C1&C&B2&B1&!B&A2&!A1&!A|D&C2&!C1&C&B2&B1&!B&A2&!A1&!A|D&C2&C1&C&B2&B1&!B&A2&!A1&!A|D&!C2&C1&C&B2&B1&!B&A2&!A1&!A|D&!C2&C1&!C&B2&B1&!B&A2&!A1&!A|D&C2&C1&!C&B2&B1&!B&A2&!A1&!A|D&C2&!C1&!C&B2&B1&!B&A2&!A1&!A|D&C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|D&C2&C1&!C&B2&!B1&!B&A2&!A1&!A|D&!C2&C1&!C&B2&!B1&!B&A2&!A1&!A|D&!C2&C1&C&B2&!B1&!B&A2&!A1&!A|D&C2&C1&C&B2&!B1&!B&A2&!A1&!A|D&C2&!C1&C&B2&!B1&!B&A2&!A1&!A|D&!C2&!C1&C&B2&!B1&!B&A2&!A1&!A|D&!C2&!C1&C&B2&!B1&!B&A2&A1&!A|D&C2&!C1&C&B2&!B1&!B&A2&A1&!A|D&C2&C1&C&B2&!B1&!B&A2&A1&!A|D&!C2&C1&C&B2&!B1&!B&A2&A1&!A|D&!C2&C1&!C&B2&!B1&!B&A2&A1&!A|D&C2&C1&!C&B2&!B1&!B&A2&A1&!A|D&C2&!C1&!C&B2&!B1&!B&A2&A1&!A|D&C2&!C1&!C&B2&B1&!B&A2&A1&!A|D&C2&C1&!C&B2&B1&!B&A2&A1&!A|D&!C2&C1&!C&B2&B1&!B&A2&A1&!A|D&!C2&C1&C&B2&B1&!B&A2&A1&!A|D&C2&C1&C&B2&B1&!B&A2&A1&!A|D&C2&!C1&C&B2&B1&!B&A2&A1&!A|D&!C2&!C1&C&B2&B1&!B&A2&A1&!A|D&!C2&!C1&C&!B2&B1&!B&A2&A1&!A|D&C2&!C1&C&!B2&B1&!B&A2&A1&!A|D&C2&C1&C&!B2&B1&!B&A2&A1&!A|D&!C2&C1&C&!B2&B1&!B&A2&A1&!A|D&!C2&C1&!C&!B2&B1&!B&A2&A1&!A|D&C2&C1&!C&!B2&B1&!B&A2&A1&!A|D&C2&!C1&!C&!B2&B1&!B&A2&A1&!A|D&C2&!C1&!C&!B2&B1&B&A2&A1&!A|D&C2&C1&!C&!B2&B1&B&A2&A1&!A|D&!C2&C1&!C&!B2&B1&B&A2&A1&!A|D&!C2&C1&C&!B2&B1&B&A2&A1&!A|D&C2&C1&C&!B2&B1&B&A2&A1&!A|D&C2&!C1&C&!B2&B1&B&A2&A1&!A|D&!C2&!C1&C&!B2&B1&B&A2&A1&!A|D&!C2&!C1&C&B2&B1&B&A2&A1&!A|D&C2&!C1&C&B2&B1&B&A2&A1&!A|D&C2&C1&C&B2&B1&B&A2&A1&!A|D&!C2&C1&C&B2&B1&B&A2&A1&!A|D&!C2&C1&!C&B2&B1&B&A2&A1&!A|D&C2&C1&!C&B2&B1&B&A2&A1&!A|D&C2&!C1&!C&B2&B1&B&A2&A1&!A|D&C2&!C1&!C&B2&!B1&B&A2&A1&!A|D&C2&C1&!C&B2&!B1&B&A2&A1&!A|D&!C2&C1&!C&B2&!B1&B&A2&A1&!A|D&!C2&C1&C&B2&!B1&B&A2&A1&!A|D&C2&C1&C&B2&!B1&B&A2&A1&!A|D&C2&!C1&C&B2&!B1&B&A2&A1&!A|D&!C2&!C1&C&B2&!B1&B&A2&A1&!A|D&!C2&!C1&C&!B2&!B1&B&A2&A1&!A|D&C2&!C1&C&!B2&!B1&B&A2&A1&!A|D&C2&C1&C&!B2&!B1&B&A2&A1&!A|D&!C2&C1&C&!B2&!B1&B&A2&A1&!A|D&!C2&C1&!C&!B2&!B1&B&A2&A1&!A|D&C2&C1&!C&!B2&!B1&B&A2&A1&!A|D&C2&!C1&!C&!B2&!B1&B&A2&A1&!A|D&C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|D&C2&C1&!C&!B2&!B1&B&!A2&A1&!A|D&!C2&C1&!C&!B2&!B1&B&!A2&A1&!A|D&!C2&C1&C&!B2&!B1&B&!A2&A1&!A|D&C2&C1&C&!B2&!B1&B&!A2&A1&!A|D&C2&!C1&C&!B2&!B1&B&!A2&A1&!A|D&!C2&!C1&C&!B2&!B1&B&!A2&A1&!A|D&!C2&!C1&C&B2&!B1&B&!A2&A1&!A|D&C2&!C1&C&B2&!B1&B&!A2&A1&!A|D&C2&C1&C&B2&!B1&B&!A2&A1&!A|D&!C2&C1&C&B2&!B1&B&!A2&A1&!A|D&!C2&C1&!C&B2&!B1&B&!A2&A1&!A|D&C2&C1&!C&B2&!B1&B&!A2&A1&!A|D&C2&!C1&!C&B2&!B1&B&!A2&A1&!A|D&C2&!C1&!C&B2&B1&B&!A2&A1&!A|D&C2&C1&!C&B2&B1&B&!A2&A1&!A|D&!C2&C1&!C&B2&B1&B&!A2&A1&!A|D&!C2&C1&C&B2&B1&B&!A2&A1&!A|D&C2&C1&C&B2&B1&B&!A2&A1&!A|D&C2&!C1&C&B2&B1&B&!A2&A1&!A|D&!C2&!C1&C&B2&B1&B&!A2&A1&!A|D&!C2&!C1&C&!B2&B1&B&!A2&A1&!A|D&C2&!C1&C&!B2&B1&B&!A2&A1&!A|D&C2&C1&C&!B2&B1&B&!A2&A1&!A|D&!C2&C1&C&!B2&B1&B&!A2&A1&!A|D&!C2&C1&!C&!B2&B1&B&!A2&A1&!A|D&C2&C1&!C&!B2&B1&B&!A2&A1&!A|D&C2&!C1&!C&!B2&B1&B&!A2&A1&!A|D&C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|D&C2&C1&!C&!B2&B1&!B&!A2&A1&!A|D&!C2&C1&!C&!B2&B1&!B&!A2&A1&!A|D&!C2&C1&C&!B2&B1&!B&!A2&A1&!A|D&C2&C1&C&!B2&B1&!B&!A2&A1&!A|D&C2&!C1&C&!B2&B1&!B&!A2&A1&!A|D&!C2&!C1&C&!B2&B1&!B&!A2&A1&!A|D&!C2&!C1&C&B2&B1&!B&!A2&A1&!A|D&C2&!C1&C&B2&B1&!B&!A2&A1&!A|D&C2&C1&C&B2&B1&!B&!A2&A1&!A|D&!C2&C1&C&B2&B1&!B&!A2&A1&!A|D&!C2&C1&!C&B2&B1&!B&!A2&A1&!A|D&C2&C1&!C&B2&B1&!B&!A2&A1&!A|D&C2&!C1&!C&B2&B1&!B&!A2&A1&!A|D&C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|D&C2&C1&!C&B2&!B1&!B&!A2&A1&!A|D&!C2&C1&!C&B2&!B1&!B&!A2&A1&!A|D&!C2&C1&C&B2&!B1&!B&!A2&A1&!A|D&C2&C1&C&B2&!B1&!B&!A2&A1&!A|D&C2&!C1&C&B2&!B1&!B&!A2&A1&!A|D&!C2&!C1&C&B2&!B1&!B&!A2&A1&!A|D&!C2&!C1&C&B2&!B1&!B&!A2&A1&A|D&C2&!C1&C&B2&!B1&!B&!A2&A1&A|D&C2&C1&C&B2&!B1&!B&!A2&A1&A|D&!C2&C1&C&B2&!B1&!B&!A2&A1&A|D&!C2&C1&!C&B2&!B1&!B&!A2&A1&A|D&C2&C1&!C&B2&!B1&!B&!A2&A1&A|D&C2&!C1&!C&B2&!B1&!B&!A2&A1&A|D&C2&!C1&!C&B2&B1&!B&!A2&A1&A|D&C2&C1&!C&B2&B1&!B&!A2&A1&A|D&!C2&C1&!C&B2&B1&!B&!A2&A1&A|D&!C2&C1&C&B2&B1&!B&!A2&A1&A|D&C2&C1&C&B2&B1&!B&!A2&A1&A|D&C2&!C1&C&B2&B1&!B&!A2&A1&A|D&!C2&!C1&C&B2&B1&!B&!A2&A1&A|D&!C2&!C1&C&!B2&B1&!B&!A2&A1&A|D&C2&!C1&C&!B2&B1&!B&!A2&A1&A|D&C2&C1&C&!B2&B1&!B&!A2&A1&A|D&!C2&C1&C&!B2&B1&!B&!A2&A1&A|D&!C2&C1&!C&!B2&B1&!B&!A2&A1&A|D&C2&C1&!C&!B2&B1&!B&!A2&A1&A|D&C2&!C1&!C&!B2&B1&!B&!A2&A1&A|D&C2&!C1&!C&!B2&B1&B&!A2&A1&A|D&C2&C1&!C&!B2&B1&B&!A2&A1&A|D&!C2&C1&!C&!B2&B1&B&!A2&A1&A|D&!C2&C1&C&!B2&B1&B&!A2&A1&A|D&C2&C1&C&!B2&B1&B&!A2&A1&A|D&C2&!C1&C&!B2&B1&B&!A2&A1&A|D&!C2&!C1&C&!B2&B1&B&!A2&A1&A|D&!C2&!C1&C&B2&B1&B&!A2&A1&A|D&C2&!C1&C&B2&B1&B&!A2&A1&A|D&C2&C1&C&B2&B1&B&!A2&A1&A|D&!C2&C1&C&B2&B1&B&!A2&A1&A|D&!C2&C1&!C&B2&B1&B&!A2&A1&A|D&C2&C1&!C&B2&B1&B&!A2&A1&A|D&C2&!C1&!C&B2&B1&B&!A2&A1&A|D&C2&!C1&!C&B2&!B1&B&!A2&A1&A|D&C2&C1&!C&B2&!B1&B&!A2&A1&A|D&!C2&C1&!C&B2&!B1&B&!A2&A1&A|D&!C2&C1&C&B2&!B1&B&!A2&A1&A|D&C2&C1&C&B2&!B1&B&!A2&A1&A|D&C2&!C1&C&B2&!B1&B&!A2&A1&A|D&!C2&!C1&C&B2&!B1&B&!A2&A1&A|D&!C2&!C1&C&!B2&!B1&B&!A2&A1&A|D&C2&!C1&C&!B2&!B1&B&!A2&A1&A|D&C2&C1&C&!B2&!B1&B&!A2&A1&A|D&!C2&C1&C&!B2&!B1&B&!A2&A1&A|D&!C2&C1&!C&!B2&!B1&B&!A2&A1&A|D&C2&C1&!C&!B2&!B1&B&!A2&A1&A|D&C2&!C1&!C&!B2&!B1&B&!A2&A1&A|D&C2&!C1&!C&!B2&!B1&B&A2&A1&A|D&C2&C1&!C&!B2&!B1&B&A2&A1&A|D&!C2&C1&!C&!B2&!B1&B&A2&A1&A|D&!C2&C1&C&!B2&!B1&B&A2&A1&A|D&C2&C1&C&!B2&!B1&B&A2&A1&A|D&C2&!C1&C&!B2&!B1&B&A2&A1&A|D&!C2&!C1&C&!B2&!B1&B&A2&A1&A|D&!C2&!C1&C&B2&!B1&B&A2&A1&A|D&C2&!C1&C&B2&!B1&B&A2&A1&A|D&C2&C1&C&B2&!B1&B&A2&A1&A|D&!C2&C1&C&B2&!B1&B&A2&A1&A|D&!C2&C1&!C&B2&!B1&B&A2&A1&A|D&C2&C1&!C&B2&!B1&B&A2&A1&A|D&C2&!C1&!C&B2&!B1&B&A2&A1&A|D&C2&!C1&!C&B2&B1&B&A2&A1&A|D&C2&C1&!C&B2&B1&B&A2&A1&A|D&!C2&C1&!C&B2&B1&B&A2&A1&A|D&!C2&C1&C&B2&B1&B&A2&A1&A|D&C2&C1&C&B2&B1&B&A2&A1&A|D&C2&!C1&C&B2&B1&B&A2&A1&A|D&!C2&!C1&C&B2&B1&B&A2&A1&A|D&!C2&!C1&C&!B2&B1&B&A2&A1&A|D&C2&!C1&C&!B2&B1&B&A2&A1&A|D&C2&C1&C&!B2&B1&B&A2&A1&A|D&!C2&C1&C&!B2&B1&B&A2&A1&A|D&!C2&C1&!C&!B2&B1&B&A2&A1&A|D&C2&C1&!C&!B2&B1&B&A2&A1&A|D&C2&!C1&!C&!B2&B1&B&A2&A1&A|D&C2&!C1&!C&!B2&B1&!B&A2&A1&A|D&C2&C1&!C&!B2&B1&!B&A2&A1&A|D&!C2&C1&!C&!B2&B1&!B&A2&A1&A|D&!C2&C1&C&!B2&B1&!B&A2&A1&A|D&C2&C1&C&!B2&B1&!B&A2&A1&A|D&C2&!C1&C&!B2&B1&!B&A2&A1&A|D&!C2&!C1&C&!B2&B1&!B&A2&A1&A|D&!C2&!C1&C&B2&B1&!B&A2&A1&A|D&C2&!C1&C&B2&B1&!B&A2&A1&A|D&C2&C1&C&B2&B1&!B&A2&A1&A|D&!C2&C1&C&B2&B1&!B&A2&A1&A|D&!C2&C1&!C&B2&B1&!B&A2&A1&A|D&C2&C1&!C&B2&B1&!B&A2&A1&A|D&C2&!C1&!C&B2&B1&!B&A2&A1&A|D&C2&!C1&!C&B2&!B1&!B&A2&A1&A|D&C2&C1&!C&B2&!B1&!B&A2&A1&A|D&!C2&C1&!C&B2&!B1&!B&A2&A1&A|D&!C2&C1&C&B2&!B1&!B&A2&A1&A|D&C2&C1&C&B2&!B1&!B&A2&A1&A|D&C2&!C1&C&B2&!B1&!B&A2&A1&A|D&!C2&!C1&C&B2&!B1&!B&A2&A1&A|D&!C2&!C1&C&B2&!B1&!B&A2&!A1&A|D&C2&!C1&C&B2&!B1&!B&A2&!A1&A|D&C2&C1&C&B2&!B1&!B&A2&!A1&A|D&!C2&C1&C&B2&!B1&!B&A2&!A1&A|D&!C2&C1&!C&B2&!B1&!B&A2&!A1&A|D&C2&C1&!C&B2&!B1&!B&A2&!A1&A|D&C2&!C1&!C&B2&!B1&!B&A2&!A1&A|D&C2&!C1&!C&B2&B1&!B&A2&!A1&A|D&C2&C1&!C&B2&B1&!B&A2&!A1&A|D&!C2&C1&!C&B2&B1&!B&A2&!A1&A|D&!C2&C1&C&B2&B1&!B&A2&!A1&A|D&C2&C1&C&B2&B1&!B&A2&!A1&A|D&C2&!C1&C&B2&B1&!B&A2&!A1&A|D&!C2&!C1&C&B2&B1&!B&A2&!A1&A|D&!C2&!C1&C&!B2&B1&!B&A2&!A1&A|D&C2&!C1&C&!B2&B1&!B&A2&!A1&A|D&C2&C1&C&!B2&B1&!B&A2&!A1&A|D&!C2&C1&C&!B2&B1&!B&A2&!A1&A|D&!C2&C1&!C&!B2&B1&!B&A2&!A1&A|D&C2&C1&!C&!B2&B1&!B&A2&!A1&A|D&C2&!C1&!C&!B2&B1&!B&A2&!A1&A|D&C2&!C1&!C&!B2&B1&B&A2&!A1&A|D&C2&C1&!C&!B2&B1&B&A2&!A1&A|D&!C2&C1&!C&!B2&B1&B&A2&!A1&A|D&!C2&C1&C&!B2&B1&B&A2&!A1&A|D&C2&C1&C&!B2&B1&B&A2&!A1&A|D&C2&!C1&C&!B2&B1&B&A2&!A1&A|D&!C2&!C1&C&!B2&B1&B&A2&!A1&A|D&!C2&!C1&C&B2&B1&B&A2&!A1&A|D&C2&!C1&C&B2&B1&B&A2&!A1&A|D&C2&C1&C&B2&B1&B&A2&!A1&A|D&!C2&C1&C&B2&B1&B&A2&!A1&A|D&!C2&C1&!C&B2&B1&B&A2&!A1&A|D&C2&C1&!C&B2&B1&B&A2&!A1&A|D&C2&!C1&!C&B2&B1&B&A2&!A1&A|D&C2&!C1&!C&B2&!B1&B&A2&!A1&A|D&C2&C1&!C&B2&!B1&B&A2&!A1&A|D&!C2&C1&!C&B2&!B1&B&A2&!A1&A|D&!C2&C1&C&B2&!B1&B&A2&!A1&A|D&C2&C1&C&B2&!B1&B&A2&!A1&A|D&C2&!C1&C&B2&!B1&B&A2&!A1&A|D&!C2&!C1&C&B2&!B1&B&A2&!A1&A|D&!C2&!C1&C&!B2&!B1&B&A2&!A1&A|D&C2&!C1&C&!B2&!B1&B&A2&!A1&A|D&C2&C1&C&!B2&!B1&B&A2&!A1&A|D&!C2&C1&C&!B2&!B1&B&A2&!A1&A|D&!C2&C1&!C&!B2&!B1&B&A2&!A1&A|D&C2&C1&!C&!B2&!B1&B&A2&!A1&A|D&C2&!C1&!C&!B2&!B1&B&A2&!A1&A|D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|D&C2&C1&!C&!B2&!B1&B&!A2&!A1&A|D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&A|D&!C2&C1&C&!B2&!B1&B&!A2&!A1&A|D&C2&C1&C&!B2&!B1&B&!A2&!A1&A|D&C2&!C1&C&!B2&!B1&B&!A2&!A1&A|D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&A|D&!C2&!C1&C&B2&!B1&B&!A2&!A1&A|D&C2&!C1&C&B2&!B1&B&!A2&!A1&A|D&C2&C1&C&B2&!B1&B&!A2&!A1&A|D&!C2&C1&C&B2&!B1&B&!A2&!A1&A|D&!C2&C1&!C&B2&!B1&B&!A2&!A1&A|D&C2&C1&!C&B2&!B1&B&!A2&!A1&A|D&C2&!C1&!C&B2&!B1&B&!A2&!A1&A|D&C2&!C1&!C&B2&B1&B&!A2&!A1&A|D&C2&C1&!C&B2&B1&B&!A2&!A1&A|D&!C2&C1&!C&B2&B1&B&!A2&!A1&A|D&!C2&C1&C&B2&B1&B&!A2&!A1&A|D&C2&C1&C&B2&B1&B&!A2&!A1&A|D&C2&!C1&C&B2&B1&B&!A2&!A1&A|D&!C2&!C1&C&B2&B1&B&!A2&!A1&A|D&!C2&!C1&C&!B2&B1&B&!A2&!A1&A|D&C2&!C1&C&!B2&B1&B&!A2&!A1&A|D&C2&C1&C&!B2&B1&B&!A2&!A1&A|D&!C2&C1&C&!B2&B1&B&!A2&!A1&A|D&!C2&C1&!C&!B2&B1&B&!A2&!A1&A|D&C2&C1&!C&!B2&B1&B&!A2&!A1&A|D&C2&!C1&!C&!B2&B1&B&!A2&!A1&A|D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|D&C2&C1&!C&!B2&B1&!B&!A2&!A1&A|D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&A|D&!C2&C1&C&!B2&B1&!B&!A2&!A1&A|D&C2&C1&C&!B2&B1&!B&!A2&!A1&A|D&C2&!C1&C&!B2&B1&!B&!A2&!A1&A|D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&A|D&!C2&!C1&C&B2&B1&!B&!A2&!A1&A|D&C2&!C1&C&B2&B1&!B&!A2&!A1&A|D&C2&C1&C&B2&B1&!B&!A2&!A1&A|D&!C2&C1&C&B2&B1&!B&!A2&!A1&A|D&!C2&C1&!C&B2&B1&!B&!A2&!A1&A|D&C2&C1&!C&B2&B1&!B&!A2&!A1&A|D&C2&!C1&!C&B2&B1&!B&!A2&!A1&A|D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|D&C2&C1&!C&B2&!B1&!B&!A2&!A1&A|D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&A|D&!C2&C1&C&B2&!B1&!B&!A2&!A1&A|D&C2&C1&C&B2&!B1&!B&!A2&!A1&A|D&C2&!C1&C&B2&!B1&!B&!A2&!A1&A|D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAI3331.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOI3122 -l AOOAOI3122 -i D1 D C1 C B A2 A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B&!A2&!A1&!A|!D1&!D&C1&!C&!B&!A2&!A1&!A|!D1&!D&C1&C&!B&!A2&!A1&!A|!D1&!D&!C1&C&!B&!A2&!A1&!A|!D1&!D&!C1&!C&B&!A2&!A1&!A|!D1&!D&!C1&!C&B&A2&!A1&!A|!D1&!D&!C1&C&!B&A2&!A1&!A|!D1&!D&C1&C&!B&A2&!A1&!A|!D1&!D&C1&!C&!B&A2&!A1&!A|!D1&!D&!C1&!C&!B&A2&!A1&!A|!D1&!D&!C1&!C&!B&A2&A1&!A|!D1&!D&C1&!C&!B&A2&A1&!A|!D1&!D&C1&C&!B&A2&A1&!A|!D1&!D&!C1&C&!B&A2&A1&!A|!D1&!D&!C1&!C&B&A2&A1&!A|!D1&!D&!C1&!C&B&!A2&A1&!A|!D1&!D&!C1&C&!B&!A2&A1&!A|!D1&!D&C1&C&!B&!A2&A1&!A|!D1&!D&C1&!C&!B&!A2&A1&!A|!D1&!D&!C1&!C&!B&!A2&A1&!A|!D1&!D&!C1&!C&!B&!A2&A1&A|!D1&!D&C1&!C&!B&!A2&A1&A|!D1&!D&C1&C&!B&!A2&A1&A|!D1&!D&!C1&C&!B&!A2&A1&A|!D1&!D&!C1&!C&B&!A2&A1&A|!D1&!D&!C1&!C&B&A2&A1&A|!D1&!D&!C1&!C&!B&A2&A1&A|!D1&!D&!C1&!C&!B&A2&!A1&A|!D1&!D&C1&!C&!B&A2&!A1&A|!D1&!D&C1&C&!B&A2&!A1&A|!D1&!D&!C1&C&!B&A2&!A1&A|!D1&!D&!C1&!C&B&A2&!A1&A|!D1&!D&!C1&!C&B&!A2&!A1&A|!D1&!D&!C1&C&!B&!A2&!A1&A|!D1&!D&C1&C&!B&!A2&!A1&A|!D1&!D&C1&!C&!B&!A2&!A1&A|!D1&!D&!C1&!C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOI3122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOAI2132 -l OAAOOAI2132 -i D1 D C2 C1 C B A1 A -o Y -f Y=!(!D1&D&C2&C1&C&!B&!A1&!A|D1&D&C2&C1&C&!B&!A1&!A|D1&!D&C2&C1&C&!B&!A1&!A|D1&!D&C2&C1&C&B&!A1&!A|D1&D&C2&C1&C&B&!A1&!A|!D1&D&C2&C1&C&B&!A1&!A|D1&!D&!C2&!C1&!C&B&A1&!A|D1&D&!C2&!C1&!C&B&A1&!A|!D1&D&!C2&!C1&!C&B&A1&!A|!D1&D&C2&!C1&!C&B&A1&!A|D1&D&C2&!C1&!C&B&A1&!A|D1&!D&C2&!C1&!C&B&A1&!A|D1&!D&C2&C1&!C&B&A1&!A|D1&D&C2&C1&!C&B&A1&!A|!D1&D&C2&C1&!C&B&A1&!A|!D1&D&!C2&C1&!C&B&A1&!A|D1&D&!C2&C1&!C&B&A1&!A|D1&!D&!C2&C1&!C&B&A1&!A|D1&!D&!C2&C1&C&B&A1&!A|D1&D&!C2&C1&C&B&A1&!A|!D1&D&!C2&C1&C&B&A1&!A|!D1&D&C2&C1&C&B&A1&!A|D1&D&C2&C1&C&B&A1&!A|D1&!D&C2&C1&C&B&A1&!A|D1&!D&C2&!C1&C&B&A1&!A|D1&D&C2&!C1&C&B&A1&!A|!D1&D&C2&!C1&C&B&A1&!A|!D1&D&!C2&!C1&C&B&A1&!A|D1&D&!C2&!C1&C&B&A1&!A|D1&!D&!C2&!C1&C&B&A1&!A|D1&!D&C2&C1&C&!B&A1&!A|D1&D&C2&C1&C&!B&A1&!A|!D1&D&C2&C1&C&!B&A1&!A|!D1&D&C2&C1&C&!B&A1&A|D1&D&C2&C1&C&!B&A1&A|D1&!D&C2&C1&C&!B&A1&A|D1&!D&!C2&!C1&C&B&A1&A|D1&D&!C2&!C1&C&B&A1&A|!D1&D&!C2&!C1&C&B&A1&A|!D1&D&C2&!C1&C&B&A1&A|D1&D&C2&!C1&C&B&A1&A|D1&!D&C2&!C1&C&B&A1&A|D1&!D&C2&C1&C&B&A1&A|D1&D&C2&C1&C&B&A1&A|!D1&D&C2&C1&C&B&A1&A|!D1&D&!C2&C1&C&B&A1&A|D1&D&!C2&C1&C&B&A1&A|D1&!D&!C2&C1&C&B&A1&A|D1&!D&!C2&C1&!C&B&A1&A|D1&D&!C2&C1&!C&B&A1&A|!D1&D&!C2&C1&!C&B&A1&A|!D1&D&C2&C1&!C&B&A1&A|D1&D&C2&C1&!C&B&A1&A|D1&!D&C2&C1&!C&B&A1&A|D1&!D&C2&!C1&!C&B&A1&A|D1&D&C2&!C1&!C&B&A1&A|!D1&D&C2&!C1&!C&B&A1&A|!D1&D&!C2&!C1&!C&B&A1&A|D1&D&!C2&!C1&!C&B&A1&A|D1&!D&!C2&!C1&!C&B&A1&A|D1&!D&!C2&!C1&!C&B&!A1&A|D1&D&!C2&!C1&!C&B&!A1&A|!D1&D&!C2&!C1&!C&B&!A1&A|!D1&D&C2&!C1&!C&B&!A1&A|D1&D&C2&!C1&!C&B&!A1&A|D1&!D&C2&!C1&!C&B&!A1&A|D1&!D&C2&C1&!C&B&!A1&A|D1&D&C2&C1&!C&B&!A1&A|!D1&D&C2&C1&!C&B&!A1&A|!D1&D&!C2&C1&!C&B&!A1&A|D1&D&!C2&C1&!C&B&!A1&A|D1&!D&!C2&C1&!C&B&!A1&A|D1&!D&!C2&C1&C&B&!A1&A|D1&D&!C2&C1&C&B&!A1&A|!D1&D&!C2&C1&C&B&!A1&A|!D1&D&C2&C1&C&B&!A1&A|D1&D&C2&C1&C&B&!A1&A|D1&!D&C2&C1&C&B&!A1&A|D1&!D&C2&!C1&C&B&!A1&A|D1&D&C2&!C1&C&B&!A1&A|!D1&D&C2&!C1&C&B&!A1&A|!D1&D&!C2&!C1&C&B&!A1&A|D1&D&!C2&!C1&C&B&!A1&A|D1&!D&!C2&!C1&C&B&!A1&A|D1&!D&C2&C1&C&!B&!A1&A|D1&D&C2&C1&C&!B&!A1&A|!D1&D&C2&C1&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOAI2132.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOOAI2222 -l AAAOOAI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=!(D1&!D&C1&C&!B1&!B&!A1&!A|D1&D&C1&C&!B1&!B&!A1&!A|!D1&D&C1&C&!B1&!B&!A1&!A|!D1&D&C1&C&B1&!B&!A1&!A|D1&D&C1&C&B1&!B&!A1&!A|D1&!D&C1&C&B1&!B&!A1&!A|D1&!D&!C1&!C&B1&B&!A1&!A|D1&D&!C1&!C&B1&B&!A1&!A|!D1&D&!C1&!C&B1&B&!A1&!A|!D1&D&C1&!C&B1&B&!A1&!A|D1&D&C1&!C&B1&B&!A1&!A|D1&!D&C1&!C&B1&B&!A1&!A|D1&!D&C1&C&B1&B&!A1&!A|D1&D&C1&C&B1&B&!A1&!A|!D1&D&C1&C&B1&B&!A1&!A|!D1&D&!C1&C&B1&B&!A1&!A|D1&D&!C1&C&B1&B&!A1&!A|D1&!D&!C1&C&B1&B&!A1&!A|!D1&D&C1&C&!B1&B&!A1&!A|D1&D&C1&C&!B1&B&!A1&!A|D1&!D&C1&C&!B1&B&!A1&!A|D1&!D&C1&C&!B1&B&A1&!A|D1&D&C1&C&!B1&B&A1&!A|!D1&D&C1&C&!B1&B&A1&!A|D1&!D&!C1&C&B1&B&A1&!A|D1&D&!C1&C&B1&B&A1&!A|!D1&D&!C1&C&B1&B&A1&!A|!D1&D&C1&C&B1&B&A1&!A|D1&D&C1&C&B1&B&A1&!A|D1&!D&C1&C&B1&B&A1&!A|D1&!D&C1&!C&B1&B&A1&!A|D1&D&C1&!C&B1&B&A1&!A|!D1&D&C1&!C&B1&B&A1&!A|!D1&D&!C1&!C&B1&B&A1&!A|D1&D&!C1&!C&B1&B&A1&!A|D1&!D&!C1&!C&B1&B&A1&!A|D1&!D&C1&C&B1&!B&A1&!A|D1&D&C1&C&B1&!B&A1&!A|!D1&D&C1&C&B1&!B&A1&!A|!D1&D&C1&C&!B1&!B&A1&!A|D1&D&C1&C&!B1&!B&A1&!A|D1&!D&C1&C&!B1&!B&A1&!A|D1&!D&!C1&!C&!B1&!B&A1&A|D1&D&!C1&!C&!B1&!B&A1&A|!D1&D&!C1&!C&!B1&!B&A1&A|!D1&D&C1&!C&!B1&!B&A1&A|D1&D&C1&!C&!B1&!B&A1&A|D1&!D&C1&!C&!B1&!B&A1&A|D1&!D&C1&C&!B1&!B&A1&A|D1&D&C1&C&!B1&!B&A1&A|!D1&D&C1&C&!B1&!B&A1&A|!D1&D&!C1&C&!B1&!B&A1&A|D1&D&!C1&C&!B1&!B&A1&A|D1&!D&!C1&C&!B1&!B&A1&A|D1&!D&!C1&C&B1&!B&A1&A|D1&D&!C1&C&B1&!B&A1&A|!D1&D&!C1&C&B1&!B&A1&A|!D1&D&C1&C&B1&!B&A1&A|D1&D&C1&C&B1&!B&A1&A|D1&!D&C1&C&B1&!B&A1&A|D1&!D&C1&!C&B1&!B&A1&A|D1&D&C1&!C&B1&!B&A1&A|!D1&D&C1&!C&B1&!B&A1&A|!D1&D&!C1&!C&B1&!B&A1&A|D1&D&!C1&!C&B1&!B&A1&A|D1&!D&!C1&!C&B1&!B&A1&A|D1&!D&!C1&!C&B1&B&A1&A|D1&D&!C1&!C&B1&B&A1&A|!D1&D&!C1&!C&B1&B&A1&A|!D1&D&C1&!C&B1&B&A1&A|D1&D&C1&!C&B1&B&A1&A|D1&!D&C1&!C&B1&B&A1&A|D1&!D&C1&C&B1&B&A1&A|D1&D&C1&C&B1&B&A1&A|!D1&D&C1&C&B1&B&A1&A|!D1&D&!C1&C&B1&B&A1&A|D1&D&!C1&C&B1&B&A1&A|D1&!D&!C1&C&B1&B&A1&A|D1&!D&!C1&C&!B1&B&A1&A|D1&D&!C1&C&!B1&B&A1&A|!D1&D&!C1&C&!B1&B&A1&A|!D1&D&C1&C&!B1&B&A1&A|D1&D&C1&C&!B1&B&A1&A|D1&!D&C1&C&!B1&B&A1&A|D1&!D&C1&!C&!B1&B&A1&A|D1&D&C1&!C&!B1&B&A1&A|!D1&D&C1&!C&!B1&B&A1&A|!D1&D&!C1&!C&!B1&B&A1&A|D1&D&!C1&!C&!B1&B&A1&A|D1&!D&!C1&!C&!B1&B&A1&A|D1&!D&C1&C&!B1&B&!A1&A|D1&D&C1&C&!B1&B&!A1&A|!D1&D&C1&C&!B1&B&!A1&A|D1&!D&!C1&C&B1&B&!A1&A|D1&D&!C1&C&B1&B&!A1&A|!D1&D&!C1&C&B1&B&!A1&A|!D1&D&C1&C&B1&B&!A1&A|D1&D&C1&C&B1&B&!A1&A|D1&!D&C1&C&B1&B&!A1&A|D1&!D&C1&!C&B1&B&!A1&A|D1&D&C1&!C&B1&B&!A1&A|!D1&D&C1&!C&B1&B&!A1&A|!D1&D&!C1&!C&B1&B&!A1&A|D1&D&!C1&!C&B1&B&!A1&A|D1&!D&!C1&!C&B1&B&!A1&A|D1&!D&C1&C&B1&!B&!A1&A|D1&D&C1&C&B1&!B&!A1&A|!D1&D&C1&C&B1&!B&!A1&A|!D1&D&C1&C&!B1&!B&!A1&A|D1&D&C1&C&!B1&!B&!A1&A|D1&!D&C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOOAI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOOAI22241 -l OOAAOOAI22241 -i E D3 D2 D1 D C1 C B1 B A1 A -o Y -f Y=!(E&D3&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|E&D3&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|E&!D3&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|E&!D3&D2&D1&!D&C1&C&!B1&!B&!A1&!A|E&D3&D2&D1&!D&C1&C&!B1&!B&!A1&!A|E&D3&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|E&!D3&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|E&!D3&!D2&D1&D&C1&C&!B1&!B&!A1&!A|E&D3&!D2&D1&D&C1&C&!B1&!B&!A1&!A|E&D3&D2&D1&D&C1&C&!B1&!B&!A1&!A|E&!D3&D2&D1&D&C1&C&!B1&!B&!A1&!A|E&!D3&D2&!D1&D&C1&C&!B1&!B&!A1&!A|E&D3&D2&!D1&D&C1&C&!B1&!B&!A1&!A|E&D3&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|E&!D3&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|E&!D3&!D2&!D1&D&C1&C&B1&!B&!A1&!A|E&D3&!D2&!D1&D&C1&C&B1&!B&!A1&!A|E&D3&D2&!D1&D&C1&C&B1&!B&!A1&!A|E&!D3&D2&!D1&D&C1&C&B1&!B&!A1&!A|E&!D3&D2&D1&D&C1&C&B1&!B&!A1&!A|E&D3&D2&D1&D&C1&C&B1&!B&!A1&!A|E&D3&!D2&D1&D&C1&C&B1&!B&!A1&!A|E&!D3&!D2&D1&D&C1&C&B1&!B&!A1&!A|E&!D3&!D2&D1&!D&C1&C&B1&!B&!A1&!A|E&D3&!D2&D1&!D&C1&C&B1&!B&!A1&!A|E&D3&D2&D1&!D&C1&C&B1&!B&!A1&!A|E&!D3&D2&D1&!D&C1&C&B1&!B&!A1&!A|E&!D3&D2&!D1&!D&C1&C&B1&!B&!A1&!A|E&D3&D2&!D1&!D&C1&C&B1&!B&!A1&!A|E&D3&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|E&D3&!D2&!D1&!D&C1&C&B1&B&!A1&!A|E&D3&D2&!D1&!D&C1&C&B1&B&!A1&!A|E&!D3&D2&!D1&!D&C1&C&B1&B&!A1&!A|E&!D3&D2&D1&!D&C1&C&B1&B&!A1&!A|E&D3&D2&D1&!D&C1&C&B1&B&!A1&!A|E&D3&!D2&D1&!D&C1&C&B1&B&!A1&!A|E&!D3&!D2&D1&!D&C1&C&B1&B&!A1&!A|E&!D3&!D2&D1&D&C1&C&B1&B&!A1&!A|E&D3&!D2&D1&D&C1&C&B1&B&!A1&!A|E&D3&D2&D1&D&C1&C&B1&B&!A1&!A|E&!D3&D2&D1&D&C1&C&B1&B&!A1&!A|E&!D3&D2&!D1&D&C1&C&B1&B&!A1&!A|E&D3&D2&!D1&D&C1&C&B1&B&!A1&!A|E&D3&!D2&!D1&D&C1&C&B1&B&!A1&!A|E&!D3&!D2&!D1&D&C1&C&B1&B&!A1&!A|E&!D3&!D2&!D1&D&C1&C&!B1&B&!A1&!A|E&D3&!D2&!D1&D&C1&C&!B1&B&!A1&!A|E&D3&D2&!D1&D&C1&C&!B1&B&!A1&!A|E&!D3&D2&!D1&D&C1&C&!B1&B&!A1&!A|E&!D3&D2&D1&D&C1&C&!B1&B&!A1&!A|E&D3&D2&D1&D&C1&C&!B1&B&!A1&!A|E&D3&!D2&D1&D&C1&C&!B1&B&!A1&!A|E&!D3&!D2&D1&D&C1&C&!B1&B&!A1&!A|E&!D3&!D2&D1&!D&C1&C&!B1&B&!A1&!A|E&D3&!D2&D1&!D&C1&C&!B1&B&!A1&!A|E&D3&D2&D1&!D&C1&C&!B1&B&!A1&!A|E&!D3&D2&D1&!D&C1&C&!B1&B&!A1&!A|E&!D3&D2&!D1&!D&C1&C&!B1&B&!A1&!A|E&D3&D2&!D1&!D&C1&C&!B1&B&!A1&!A|E&D3&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|E&D3&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|E&D3&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|E&!D3&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|E&!D3&D2&D1&!D&!C1&!C&!B1&B&A1&!A|E&D3&D2&D1&!D&!C1&!C&!B1&B&A1&!A|E&D3&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|E&!D3&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|E&!D3&!D2&D1&D&!C1&!C&!B1&B&A1&!A|E&D3&!D2&D1&D&!C1&!C&!B1&B&A1&!A|E&D3&D2&D1&D&!C1&!C&!B1&B&A1&!A|E&!D3&D2&D1&D&!C1&!C&!B1&B&A1&!A|E&!D3&D2&!D1&D&!C1&!C&!B1&B&A1&!A|E&D3&D2&!D1&D&!C1&!C&!B1&B&A1&!A|E&D3&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|E&!D3&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|E&!D3&!D2&!D1&D&C1&!C&!B1&B&A1&!A|E&D3&!D2&!D1&D&C1&!C&!B1&B&A1&!A|E&D3&D2&!D1&D&C1&!C&!B1&B&A1&!A|E&!D3&D2&!D1&D&C1&!C&!B1&B&A1&!A|E&!D3&D2&D1&D&C1&!C&!B1&B&A1&!A|E&D3&D2&D1&D&C1&!C&!B1&B&A1&!A|E&D3&!D2&D1&D&C1&!C&!B1&B&A1&!A|E&!D3&!D2&D1&D&C1&!C&!B1&B&A1&!A|E&!D3&!D2&D1&!D&C1&!C&!B1&B&A1&!A|E&D3&!D2&D1&!D&C1&!C&!B1&B&A1&!A|E&D3&D2&D1&!D&C1&!C&!B1&B&A1&!A|E&!D3&D2&D1&!D&C1&!C&!B1&B&A1&!A|E&!D3&D2&!D1&!D&C1&!C&!B1&B&A1&!A|E&D3&D2&!D1&!D&C1&!C&!B1&B&A1&!A|E&D3&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|E&D3&!D2&!D1&!D&C1&C&!B1&B&A1&!A|E&D3&D2&!D1&!D&C1&C&!B1&B&A1&!A|E&!D3&D2&!D1&!D&C1&C&!B1&B&A1&!A|E&!D3&D2&D1&!D&C1&C&!B1&B&A1&!A|E&D3&D2&D1&!D&C1&C&!B1&B&A1&!A|E&D3&!D2&D1&!D&C1&C&!B1&B&A1&!A|E&!D3&!D2&D1&!D&C1&C&!B1&B&A1&!A|E&!D3&!D2&D1&D&C1&C&!B1&B&A1&!A|E&D3&!D2&D1&D&C1&C&!B1&B&A1&!A|E&D3&D2&D1&D&C1&C&!B1&B&A1&!A|E&!D3&D2&D1&D&C1&C&!B1&B&A1&!A|E&!D3&D2&!D1&D&C1&C&!B1&B&A1&!A|E&D3&D2&!D1&D&C1&C&!B1&B&A1&!A|E&D3&!D2&!D1&D&C1&C&!B1&B&A1&!A|E&!D3&!D2&!D1&D&C1&C&!B1&B&A1&!A|E&!D3&!D2&!D1&D&!C1&C&!B1&B&A1&!A|E&D3&!D2&!D1&D&!C1&C&!B1&B&A1&!A|E&D3&D2&!D1&D&!C1&C&!B1&B&A1&!A|E&!D3&D2&!D1&D&!C1&C&!B1&B&A1&!A|E&!D3&D2&D1&D&!C1&C&!B1&B&A1&!A|E&D3&D2&D1&D&!C1&C&!B1&B&A1&!A|E&D3&!D2&D1&D&!C1&C&!B1&B&A1&!A|E&!D3&!D2&D1&D&!C1&C&!B1&B&A1&!A|E&!D3&!D2&D1&!D&!C1&C&!B1&B&A1&!A|E&D3&!D2&D1&!D&!C1&C&!B1&B&A1&!A|E&D3&D2&D1&!D&!C1&C&!B1&B&A1&!A|E&!D3&D2&D1&!D&!C1&C&!B1&B&A1&!A|E&!D3&D2&!D1&!D&!C1&C&!B1&B&A1&!A|E&D3&D2&!D1&!D&!C1&C&!B1&B&A1&!A|E&D3&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|E&D3&!D2&!D1&!D&!C1&C&B1&B&A1&!A|E&D3&D2&!D1&!D&!C1&C&B1&B&A1&!A|E&!D3&D2&!D1&!D&!C1&C&B1&B&A1&!A|E&!D3&D2&D1&!D&!C1&C&B1&B&A1&!A|E&D3&D2&D1&!D&!C1&C&B1&B&A1&!A|E&D3&!D2&D1&!D&!C1&C&B1&B&A1&!A|E&!D3&!D2&D1&!D&!C1&C&B1&B&A1&!A|E&!D3&!D2&D1&D&!C1&C&B1&B&A1&!A|E&D3&!D2&D1&D&!C1&C&B1&B&A1&!A|E&D3&D2&D1&D&!C1&C&B1&B&A1&!A|E&!D3&D2&D1&D&!C1&C&B1&B&A1&!A|E&!D3&D2&!D1&D&!C1&C&B1&B&A1&!A|E&D3&D2&!D1&D&!C1&C&B1&B&A1&!A|E&D3&!D2&!D1&D&!C1&C&B1&B&A1&!A|E&!D3&!D2&!D1&D&!C1&C&B1&B&A1&!A|E&!D3&!D2&!D1&D&C1&C&B1&B&A1&!A|E&D3&!D2&!D1&D&C1&C&B1&B&A1&!A|E&D3&D2&!D1&D&C1&C&B1&B&A1&!A|E&!D3&D2&!D1&D&C1&C&B1&B&A1&!A|E&!D3&D2&D1&D&C1&C&B1&B&A1&!A|E&D3&D2&D1&D&C1&C&B1&B&A1&!A|E&D3&!D2&D1&D&C1&C&B1&B&A1&!A|E&!D3&!D2&D1&D&C1&C&B1&B&A1&!A|E&!D3&!D2&D1&!D&C1&C&B1&B&A1&!A|E&D3&!D2&D1&!D&C1&C&B1&B&A1&!A|E&D3&D2&D1&!D&C1&C&B1&B&A1&!A|E&!D3&D2&D1&!D&C1&C&B1&B&A1&!A|E&!D3&D2&!D1&!D&C1&C&B1&B&A1&!A|E&D3&D2&!D1&!D&C1&C&B1&B&A1&!A|E&D3&!D2&!D1&!D&C1&C&B1&B&A1&!A|E&D3&!D2&!D1&!D&C1&!C&B1&B&A1&!A|E&D3&D2&!D1&!D&C1&!C&B1&B&A1&!A|E&!D3&D2&!D1&!D&C1&!C&B1&B&A1&!A|E&!D3&D2&D1&!D&C1&!C&B1&B&A1&!A|E&D3&D2&D1&!D&C1&!C&B1&B&A1&!A|E&D3&!D2&D1&!D&C1&!C&B1&B&A1&!A|E&!D3&!D2&D1&!D&C1&!C&B1&B&A1&!A|E&!D3&!D2&D1&D&C1&!C&B1&B&A1&!A|E&D3&!D2&D1&D&C1&!C&B1&B&A1&!A|E&D3&D2&D1&D&C1&!C&B1&B&A1&!A|E&!D3&D2&D1&D&C1&!C&B1&B&A1&!A|E&!D3&D2&!D1&D&C1&!C&B1&B&A1&!A|E&D3&D2&!D1&D&C1&!C&B1&B&A1&!A|E&D3&!D2&!D1&D&C1&!C&B1&B&A1&!A|E&!D3&!D2&!D1&D&C1&!C&B1&B&A1&!A|E&!D3&!D2&!D1&D&!C1&!C&B1&B&A1&!A|E&D3&!D2&!D1&D&!C1&!C&B1&B&A1&!A|E&D3&D2&!D1&D&!C1&!C&B1&B&A1&!A|E&!D3&D2&!D1&D&!C1&!C&B1&B&A1&!A|E&!D3&D2&D1&D&!C1&!C&B1&B&A1&!A|E&D3&D2&D1&D&!C1&!C&B1&B&A1&!A|E&D3&!D2&D1&D&!C1&!C&B1&B&A1&!A|E&!D3&!D2&D1&D&!C1&!C&B1&B&A1&!A|E&!D3&!D2&D1&!D&!C1&!C&B1&B&A1&!A|E&D3&!D2&D1&!D&!C1&!C&B1&B&A1&!A|E&D3&D2&D1&!D&!C1&!C&B1&B&A1&!A|E&!D3&D2&D1&!D&!C1&!C&B1&B&A1&!A|E&!D3&D2&!D1&!D&!C1&!C&B1&B&A1&!A|E&D3&D2&!D1&!D&!C1&!C&B1&B&A1&!A|E&D3&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|E&D3&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|E&D3&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|E&!D3&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|E&!D3&D2&D1&!D&!C1&!C&B1&!B&A1&!A|E&D3&D2&D1&!D&!C1&!C&B1&!B&A1&!A|E&D3&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|E&!D3&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|E&!D3&!D2&D1&D&!C1&!C&B1&!B&A1&!A|E&D3&!D2&D1&D&!C1&!C&B1&!B&A1&!A|E&D3&D2&D1&D&!C1&!C&B1&!B&A1&!A|E&!D3&D2&D1&D&!C1&!C&B1&!B&A1&!A|E&!D3&D2&!D1&D&!C1&!C&B1&!B&A1&!A|E&D3&D2&!D1&D&!C1&!C&B1&!B&A1&!A|E&D3&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|E&!D3&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|E&!D3&!D2&!D1&D&C1&!C&B1&!B&A1&!A|E&D3&!D2&!D1&D&C1&!C&B1&!B&A1&!A|E&D3&D2&!D1&D&C1&!C&B1&!B&A1&!A|E&!D3&D2&!D1&D&C1&!C&B1&!B&A1&!A|E&!D3&D2&D1&D&C1&!C&B1&!B&A1&!A|E&D3&D2&D1&D&C1&!C&B1&!B&A1&!A|E&D3&!D2&D1&D&C1&!C&B1&!B&A1&!A|E&!D3&!D2&D1&D&C1&!C&B1&!B&A1&!A|E&!D3&!D2&D1&!D&C1&!C&B1&!B&A1&!A|E&D3&!D2&D1&!D&C1&!C&B1&!B&A1&!A|E&D3&D2&D1&!D&C1&!C&B1&!B&A1&!A|E&!D3&D2&D1&!D&C1&!C&B1&!B&A1&!A|E&!D3&D2&!D1&!D&C1&!C&B1&!B&A1&!A|E&D3&D2&!D1&!D&C1&!C&B1&!B&A1&!A|E&D3&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|E&D3&!D2&!D1&!D&C1&C&B1&!B&A1&!A|E&D3&D2&!D1&!D&C1&C&B1&!B&A1&!A|E&!D3&D2&!D1&!D&C1&C&B1&!B&A1&!A|E&!D3&D2&D1&!D&C1&C&B1&!B&A1&!A|E&D3&D2&D1&!D&C1&C&B1&!B&A1&!A|E&D3&!D2&D1&!D&C1&C&B1&!B&A1&!A|E&!D3&!D2&D1&!D&C1&C&B1&!B&A1&!A|E&!D3&!D2&D1&D&C1&C&B1&!B&A1&!A|E&D3&!D2&D1&D&C1&C&B1&!B&A1&!A|E&D3&D2&D1&D&C1&C&B1&!B&A1&!A|E&!D3&D2&D1&D&C1&C&B1&!B&A1&!A|E&!D3&D2&!D1&D&C1&C&B1&!B&A1&!A|E&D3&D2&!D1&D&C1&C&B1&!B&A1&!A|E&D3&!D2&!D1&D&C1&C&B1&!B&A1&!A|E&!D3&!D2&!D1&D&C1&C&B1&!B&A1&!A|E&!D3&!D2&!D1&D&!C1&C&B1&!B&A1&!A|E&D3&!D2&!D1&D&!C1&C&B1&!B&A1&!A|E&D3&D2&!D1&D&!C1&C&B1&!B&A1&!A|E&!D3&D2&!D1&D&!C1&C&B1&!B&A1&!A|E&!D3&D2&D1&D&!C1&C&B1&!B&A1&!A|E&D3&D2&D1&D&!C1&C&B1&!B&A1&!A|E&D3&!D2&D1&D&!C1&C&B1&!B&A1&!A|E&!D3&!D2&D1&D&!C1&C&B1&!B&A1&!A|E&!D3&!D2&D1&!D&!C1&C&B1&!B&A1&!A|E&D3&!D2&D1&!D&!C1&C&B1&!B&A1&!A|E&D3&D2&D1&!D&!C1&C&B1&!B&A1&!A|E&!D3&D2&D1&!D&!C1&C&B1&!B&A1&!A|E&!D3&D2&!D1&!D&!C1&C&B1&!B&A1&!A|E&D3&D2&!D1&!D&!C1&C&B1&!B&A1&!A|E&D3&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|E&!D3&!D2&!D1&D&C1&C&!B1&!B&A1&!A|E&D3&!D2&!D1&D&C1&C&!B1&!B&A1&!A|E&D3&D2&!D1&D&C1&C&!B1&!B&A1&!A|E&!D3&D2&!D1&D&C1&C&!B1&!B&A1&!A|E&!D3&D2&D1&D&C1&C&!B1&!B&A1&!A|E&D3&D2&D1&D&C1&C&!B1&!B&A1&!A|E&D3&!D2&D1&D&C1&C&!B1&!B&A1&!A|E&!D3&!D2&D1&D&C1&C&!B1&!B&A1&!A|E&!D3&!D2&D1&!D&C1&C&!B1&!B&A1&!A|E&D3&!D2&D1&!D&C1&C&!B1&!B&A1&!A|E&D3&D2&D1&!D&C1&C&!B1&!B&A1&!A|E&!D3&D2&D1&!D&C1&C&!B1&!B&A1&!A|E&!D3&D2&!D1&!D&C1&C&!B1&!B&A1&!A|E&D3&D2&!D1&!D&C1&C&!B1&!B&A1&!A|E&D3&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|E&D3&!D2&!D1&!D&C1&C&!B1&!B&A1&A|E&D3&D2&!D1&!D&C1&C&!B1&!B&A1&A|E&!D3&D2&!D1&!D&C1&C&!B1&!B&A1&A|E&!D3&D2&D1&!D&C1&C&!B1&!B&A1&A|E&D3&D2&D1&!D&C1&C&!B1&!B&A1&A|E&D3&!D2&D1&!D&C1&C&!B1&!B&A1&A|E&!D3&!D2&D1&!D&C1&C&!B1&!B&A1&A|E&!D3&!D2&D1&D&C1&C&!B1&!B&A1&A|E&D3&!D2&D1&D&C1&C&!B1&!B&A1&A|E&D3&D2&D1&D&C1&C&!B1&!B&A1&A|E&!D3&D2&D1&D&C1&C&!B1&!B&A1&A|E&!D3&D2&!D1&D&C1&C&!B1&!B&A1&A|E&D3&D2&!D1&D&C1&C&!B1&!B&A1&A|E&D3&!D2&!D1&D&C1&C&!B1&!B&A1&A|E&!D3&!D2&!D1&D&C1&C&!B1&!B&A1&A|E&D3&!D2&!D1&!D&!C1&C&B1&!B&A1&A|E&D3&D2&!D1&!D&!C1&C&B1&!B&A1&A|E&!D3&D2&!D1&!D&!C1&C&B1&!B&A1&A|E&!D3&D2&D1&!D&!C1&C&B1&!B&A1&A|E&D3&D2&D1&!D&!C1&C&B1&!B&A1&A|E&D3&!D2&D1&!D&!C1&C&B1&!B&A1&A|E&!D3&!D2&D1&!D&!C1&C&B1&!B&A1&A|E&!D3&!D2&D1&D&!C1&C&B1&!B&A1&A|E&D3&!D2&D1&D&!C1&C&B1&!B&A1&A|E&D3&D2&D1&D&!C1&C&B1&!B&A1&A|E&!D3&D2&D1&D&!C1&C&B1&!B&A1&A|E&!D3&D2&!D1&D&!C1&C&B1&!B&A1&A|E&D3&D2&!D1&D&!C1&C&B1&!B&A1&A|E&D3&!D2&!D1&D&!C1&C&B1&!B&A1&A|E&!D3&!D2&!D1&D&!C1&C&B1&!B&A1&A|E&!D3&!D2&!D1&D&C1&C&B1&!B&A1&A|E&D3&!D2&!D1&D&C1&C&B1&!B&A1&A|E&D3&D2&!D1&D&C1&C&B1&!B&A1&A|E&!D3&D2&!D1&D&C1&C&B1&!B&A1&A|E&!D3&D2&D1&D&C1&C&B1&!B&A1&A|E&D3&D2&D1&D&C1&C&B1&!B&A1&A|E&D3&!D2&D1&D&C1&C&B1&!B&A1&A|E&!D3&!D2&D1&D&C1&C&B1&!B&A1&A|E&!D3&!D2&D1&!D&C1&C&B1&!B&A1&A|E&D3&!D2&D1&!D&C1&C&B1&!B&A1&A|E&D3&D2&D1&!D&C1&C&B1&!B&A1&A|E&!D3&D2&D1&!D&C1&C&B1&!B&A1&A|E&!D3&D2&!D1&!D&C1&C&B1&!B&A1&A|E&D3&D2&!D1&!D&C1&C&B1&!B&A1&A|E&D3&!D2&!D1&!D&C1&C&B1&!B&A1&A|E&D3&!D2&!D1&!D&C1&!C&B1&!B&A1&A|E&D3&D2&!D1&!D&C1&!C&B1&!B&A1&A|E&!D3&D2&!D1&!D&C1&!C&B1&!B&A1&A|E&!D3&D2&D1&!D&C1&!C&B1&!B&A1&A|E&D3&D2&D1&!D&C1&!C&B1&!B&A1&A|E&D3&!D2&D1&!D&C1&!C&B1&!B&A1&A|E&!D3&!D2&D1&!D&C1&!C&B1&!B&A1&A|E&!D3&!D2&D1&D&C1&!C&B1&!B&A1&A|E&D3&!D2&D1&D&C1&!C&B1&!B&A1&A|E&D3&D2&D1&D&C1&!C&B1&!B&A1&A|E&!D3&D2&D1&D&C1&!C&B1&!B&A1&A|E&!D3&D2&!D1&D&C1&!C&B1&!B&A1&A|E&D3&D2&!D1&D&C1&!C&B1&!B&A1&A|E&D3&!D2&!D1&D&C1&!C&B1&!B&A1&A|E&!D3&!D2&!D1&D&C1&!C&B1&!B&A1&A|E&!D3&!D2&!D1&D&!C1&!C&B1&!B&A1&A|E&D3&!D2&!D1&D&!C1&!C&B1&!B&A1&A|E&D3&D2&!D1&D&!C1&!C&B1&!B&A1&A|E&!D3&D2&!D1&D&!C1&!C&B1&!B&A1&A|E&!D3&D2&D1&D&!C1&!C&B1&!B&A1&A|E&D3&D2&D1&D&!C1&!C&B1&!B&A1&A|E&D3&!D2&D1&D&!C1&!C&B1&!B&A1&A|E&!D3&!D2&D1&D&!C1&!C&B1&!B&A1&A|E&!D3&!D2&D1&!D&!C1&!C&B1&!B&A1&A|E&D3&!D2&D1&!D&!C1&!C&B1&!B&A1&A|E&D3&D2&D1&!D&!C1&!C&B1&!B&A1&A|E&!D3&D2&D1&!D&!C1&!C&B1&!B&A1&A|E&!D3&D2&!D1&!D&!C1&!C&B1&!B&A1&A|E&D3&D2&!D1&!D&!C1&!C&B1&!B&A1&A|E&D3&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|E&D3&!D2&!D1&!D&!C1&!C&B1&B&A1&A|E&D3&D2&!D1&!D&!C1&!C&B1&B&A1&A|E&!D3&D2&!D1&!D&!C1&!C&B1&B&A1&A|E&!D3&D2&D1&!D&!C1&!C&B1&B&A1&A|E&D3&D2&D1&!D&!C1&!C&B1&B&A1&A|E&D3&!D2&D1&!D&!C1&!C&B1&B&A1&A|E&!D3&!D2&D1&!D&!C1&!C&B1&B&A1&A|E&!D3&!D2&D1&D&!C1&!C&B1&B&A1&A|E&D3&!D2&D1&D&!C1&!C&B1&B&A1&A|E&D3&D2&D1&D&!C1&!C&B1&B&A1&A|E&!D3&D2&D1&D&!C1&!C&B1&B&A1&A|E&!D3&D2&!D1&D&!C1&!C&B1&B&A1&A|E&D3&D2&!D1&D&!C1&!C&B1&B&A1&A|E&D3&!D2&!D1&D&!C1&!C&B1&B&A1&A|E&!D3&!D2&!D1&D&!C1&!C&B1&B&A1&A|E&!D3&!D2&!D1&D&C1&!C&B1&B&A1&A|E&D3&!D2&!D1&D&C1&!C&B1&B&A1&A|E&D3&D2&!D1&D&C1&!C&B1&B&A1&A|E&!D3&D2&!D1&D&C1&!C&B1&B&A1&A|E&!D3&D2&D1&D&C1&!C&B1&B&A1&A|E&D3&D2&D1&D&C1&!C&B1&B&A1&A|E&D3&!D2&D1&D&C1&!C&B1&B&A1&A|E&!D3&!D2&D1&D&C1&!C&B1&B&A1&A|E&!D3&!D2&D1&!D&C1&!C&B1&B&A1&A|E&D3&!D2&D1&!D&C1&!C&B1&B&A1&A|E&D3&D2&D1&!D&C1&!C&B1&B&A1&A|E&!D3&D2&D1&!D&C1&!C&B1&B&A1&A|E&!D3&D2&!D1&!D&C1&!C&B1&B&A1&A|E&D3&D2&!D1&!D&C1&!C&B1&B&A1&A|E&D3&!D2&!D1&!D&C1&!C&B1&B&A1&A|E&D3&!D2&!D1&!D&C1&C&B1&B&A1&A|E&D3&D2&!D1&!D&C1&C&B1&B&A1&A|E&!D3&D2&!D1&!D&C1&C&B1&B&A1&A|E&!D3&D2&D1&!D&C1&C&B1&B&A1&A|E&D3&D2&D1&!D&C1&C&B1&B&A1&A|E&D3&!D2&D1&!D&C1&C&B1&B&A1&A|E&!D3&!D2&D1&!D&C1&C&B1&B&A1&A|E&!D3&!D2&D1&D&C1&C&B1&B&A1&A|E&D3&!D2&D1&D&C1&C&B1&B&A1&A|E&D3&D2&D1&D&C1&C&B1&B&A1&A|E&!D3&D2&D1&D&C1&C&B1&B&A1&A|E&!D3&D2&!D1&D&C1&C&B1&B&A1&A|E&D3&D2&!D1&D&C1&C&B1&B&A1&A|E&D3&!D2&!D1&D&C1&C&B1&B&A1&A|E&!D3&!D2&!D1&D&C1&C&B1&B&A1&A|E&!D3&!D2&!D1&D&!C1&C&B1&B&A1&A|E&D3&!D2&!D1&D&!C1&C&B1&B&A1&A|E&D3&D2&!D1&D&!C1&C&B1&B&A1&A|E&!D3&D2&!D1&D&!C1&C&B1&B&A1&A|E&!D3&D2&D1&D&!C1&C&B1&B&A1&A|E&D3&D2&D1&D&!C1&C&B1&B&A1&A|E&D3&!D2&D1&D&!C1&C&B1&B&A1&A|E&!D3&!D2&D1&D&!C1&C&B1&B&A1&A|E&!D3&!D2&D1&!D&!C1&C&B1&B&A1&A|E&D3&!D2&D1&!D&!C1&C&B1&B&A1&A|E&D3&D2&D1&!D&!C1&C&B1&B&A1&A|E&!D3&D2&D1&!D&!C1&C&B1&B&A1&A|E&!D3&D2&!D1&!D&!C1&C&B1&B&A1&A|E&D3&D2&!D1&!D&!C1&C&B1&B&A1&A|E&D3&!D2&!D1&!D&!C1&C&B1&B&A1&A|E&D3&!D2&!D1&!D&!C1&C&!B1&B&A1&A|E&D3&D2&!D1&!D&!C1&C&!B1&B&A1&A|E&!D3&D2&!D1&!D&!C1&C&!B1&B&A1&A|E&!D3&D2&D1&!D&!C1&C&!B1&B&A1&A|E&D3&D2&D1&!D&!C1&C&!B1&B&A1&A|E&D3&!D2&D1&!D&!C1&C&!B1&B&A1&A|E&!D3&!D2&D1&!D&!C1&C&!B1&B&A1&A|E&!D3&!D2&D1&D&!C1&C&!B1&B&A1&A|E&D3&!D2&D1&D&!C1&C&!B1&B&A1&A|E&D3&D2&D1&D&!C1&C&!B1&B&A1&A|E&!D3&D2&D1&D&!C1&C&!B1&B&A1&A|E&!D3&D2&!D1&D&!C1&C&!B1&B&A1&A|E&D3&D2&!D1&D&!C1&C&!B1&B&A1&A|E&D3&!D2&!D1&D&!C1&C&!B1&B&A1&A|E&!D3&!D2&!D1&D&!C1&C&!B1&B&A1&A|E&!D3&!D2&!D1&D&C1&C&!B1&B&A1&A|E&D3&!D2&!D1&D&C1&C&!B1&B&A1&A|E&D3&D2&!D1&D&C1&C&!B1&B&A1&A|E&!D3&D2&!D1&D&C1&C&!B1&B&A1&A|E&!D3&D2&D1&D&C1&C&!B1&B&A1&A|E&D3&D2&D1&D&C1&C&!B1&B&A1&A|E&D3&!D2&D1&D&C1&C&!B1&B&A1&A|E&!D3&!D2&D1&D&C1&C&!B1&B&A1&A|E&!D3&!D2&D1&!D&C1&C&!B1&B&A1&A|E&D3&!D2&D1&!D&C1&C&!B1&B&A1&A|E&D3&D2&D1&!D&C1&C&!B1&B&A1&A|E&!D3&D2&D1&!D&C1&C&!B1&B&A1&A|E&!D3&D2&!D1&!D&C1&C&!B1&B&A1&A|E&D3&D2&!D1&!D&C1&C&!B1&B&A1&A|E&D3&!D2&!D1&!D&C1&C&!B1&B&A1&A|E&D3&!D2&!D1&!D&C1&!C&!B1&B&A1&A|E&D3&D2&!D1&!D&C1&!C&!B1&B&A1&A|E&!D3&D2&!D1&!D&C1&!C&!B1&B&A1&A|E&!D3&D2&D1&!D&C1&!C&!B1&B&A1&A|E&D3&D2&D1&!D&C1&!C&!B1&B&A1&A|E&D3&!D2&D1&!D&C1&!C&!B1&B&A1&A|E&!D3&!D2&D1&!D&C1&!C&!B1&B&A1&A|E&!D3&!D2&D1&D&C1&!C&!B1&B&A1&A|E&D3&!D2&D1&D&C1&!C&!B1&B&A1&A|E&D3&D2&D1&D&C1&!C&!B1&B&A1&A|E&!D3&D2&D1&D&C1&!C&!B1&B&A1&A|E&!D3&D2&!D1&D&C1&!C&!B1&B&A1&A|E&D3&D2&!D1&D&C1&!C&!B1&B&A1&A|E&D3&!D2&!D1&D&C1&!C&!B1&B&A1&A|E&!D3&!D2&!D1&D&C1&!C&!B1&B&A1&A|E&!D3&!D2&!D1&D&!C1&!C&!B1&B&A1&A|E&D3&!D2&!D1&D&!C1&!C&!B1&B&A1&A|E&D3&D2&!D1&D&!C1&!C&!B1&B&A1&A|E&!D3&D2&!D1&D&!C1&!C&!B1&B&A1&A|E&!D3&D2&D1&D&!C1&!C&!B1&B&A1&A|E&D3&D2&D1&D&!C1&!C&!B1&B&A1&A|E&D3&!D2&D1&D&!C1&!C&!B1&B&A1&A|E&!D3&!D2&D1&D&!C1&!C&!B1&B&A1&A|E&!D3&!D2&D1&!D&!C1&!C&!B1&B&A1&A|E&D3&!D2&D1&!D&!C1&!C&!B1&B&A1&A|E&D3&D2&D1&!D&!C1&!C&!B1&B&A1&A|E&!D3&D2&D1&!D&!C1&!C&!B1&B&A1&A|E&!D3&D2&!D1&!D&!C1&!C&!B1&B&A1&A|E&D3&D2&!D1&!D&!C1&!C&!B1&B&A1&A|E&D3&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|E&D3&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|E&D3&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|E&!D3&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|E&!D3&D2&D1&!D&!C1&!C&!B1&B&!A1&A|E&D3&D2&D1&!D&!C1&!C&!B1&B&!A1&A|E&D3&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|E&!D3&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|E&!D3&!D2&D1&D&!C1&!C&!B1&B&!A1&A|E&D3&!D2&D1&D&!C1&!C&!B1&B&!A1&A|E&D3&D2&D1&D&!C1&!C&!B1&B&!A1&A|E&!D3&D2&D1&D&!C1&!C&!B1&B&!A1&A|E&!D3&D2&!D1&D&!C1&!C&!B1&B&!A1&A|E&D3&D2&!D1&D&!C1&!C&!B1&B&!A1&A|E&D3&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|E&!D3&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|E&!D3&!D2&!D1&D&C1&!C&!B1&B&!A1&A|E&D3&!D2&!D1&D&C1&!C&!B1&B&!A1&A|E&D3&D2&!D1&D&C1&!C&!B1&B&!A1&A|E&!D3&D2&!D1&D&C1&!C&!B1&B&!A1&A|E&!D3&D2&D1&D&C1&!C&!B1&B&!A1&A|E&D3&D2&D1&D&C1&!C&!B1&B&!A1&A|E&D3&!D2&D1&D&C1&!C&!B1&B&!A1&A|E&!D3&!D2&D1&D&C1&!C&!B1&B&!A1&A|E&!D3&!D2&D1&!D&C1&!C&!B1&B&!A1&A|E&D3&!D2&D1&!D&C1&!C&!B1&B&!A1&A|E&D3&D2&D1&!D&C1&!C&!B1&B&!A1&A|E&!D3&D2&D1&!D&C1&!C&!B1&B&!A1&A|E&!D3&D2&!D1&!D&C1&!C&!B1&B&!A1&A|E&D3&D2&!D1&!D&C1&!C&!B1&B&!A1&A|E&D3&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|E&D3&!D2&!D1&!D&C1&C&!B1&B&!A1&A|E&D3&D2&!D1&!D&C1&C&!B1&B&!A1&A|E&!D3&D2&!D1&!D&C1&C&!B1&B&!A1&A|E&!D3&D2&D1&!D&C1&C&!B1&B&!A1&A|E&D3&D2&D1&!D&C1&C&!B1&B&!A1&A|E&D3&!D2&D1&!D&C1&C&!B1&B&!A1&A|E&!D3&!D2&D1&!D&C1&C&!B1&B&!A1&A|E&!D3&!D2&D1&D&C1&C&!B1&B&!A1&A|E&D3&!D2&D1&D&C1&C&!B1&B&!A1&A|E&D3&D2&D1&D&C1&C&!B1&B&!A1&A|E&!D3&D2&D1&D&C1&C&!B1&B&!A1&A|E&!D3&D2&!D1&D&C1&C&!B1&B&!A1&A|E&D3&D2&!D1&D&C1&C&!B1&B&!A1&A|E&D3&!D2&!D1&D&C1&C&!B1&B&!A1&A|E&!D3&!D2&!D1&D&C1&C&!B1&B&!A1&A|E&!D3&!D2&!D1&D&!C1&C&!B1&B&!A1&A|E&D3&!D2&!D1&D&!C1&C&!B1&B&!A1&A|E&D3&D2&!D1&D&!C1&C&!B1&B&!A1&A|E&!D3&D2&!D1&D&!C1&C&!B1&B&!A1&A|E&!D3&D2&D1&D&!C1&C&!B1&B&!A1&A|E&D3&D2&D1&D&!C1&C&!B1&B&!A1&A|E&D3&!D2&D1&D&!C1&C&!B1&B&!A1&A|E&!D3&!D2&D1&D&!C1&C&!B1&B&!A1&A|E&!D3&!D2&D1&!D&!C1&C&!B1&B&!A1&A|E&D3&!D2&D1&!D&!C1&C&!B1&B&!A1&A|E&D3&D2&D1&!D&!C1&C&!B1&B&!A1&A|E&!D3&D2&D1&!D&!C1&C&!B1&B&!A1&A|E&!D3&D2&!D1&!D&!C1&C&!B1&B&!A1&A|E&D3&D2&!D1&!D&!C1&C&!B1&B&!A1&A|E&D3&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|E&D3&!D2&!D1&!D&!C1&C&B1&B&!A1&A|E&D3&D2&!D1&!D&!C1&C&B1&B&!A1&A|E&!D3&D2&!D1&!D&!C1&C&B1&B&!A1&A|E&!D3&D2&D1&!D&!C1&C&B1&B&!A1&A|E&D3&D2&D1&!D&!C1&C&B1&B&!A1&A|E&D3&!D2&D1&!D&!C1&C&B1&B&!A1&A|E&!D3&!D2&D1&!D&!C1&C&B1&B&!A1&A|E&!D3&!D2&D1&D&!C1&C&B1&B&!A1&A|E&D3&!D2&D1&D&!C1&C&B1&B&!A1&A|E&D3&D2&D1&D&!C1&C&B1&B&!A1&A|E&!D3&D2&D1&D&!C1&C&B1&B&!A1&A|E&!D3&D2&!D1&D&!C1&C&B1&B&!A1&A|E&D3&D2&!D1&D&!C1&C&B1&B&!A1&A|E&D3&!D2&!D1&D&!C1&C&B1&B&!A1&A|E&!D3&!D2&!D1&D&!C1&C&B1&B&!A1&A|E&!D3&!D2&!D1&D&C1&C&B1&B&!A1&A|E&D3&!D2&!D1&D&C1&C&B1&B&!A1&A|E&D3&D2&!D1&D&C1&C&B1&B&!A1&A|E&!D3&D2&!D1&D&C1&C&B1&B&!A1&A|E&!D3&D2&D1&D&C1&C&B1&B&!A1&A|E&D3&D2&D1&D&C1&C&B1&B&!A1&A|E&D3&!D2&D1&D&C1&C&B1&B&!A1&A|E&!D3&!D2&D1&D&C1&C&B1&B&!A1&A|E&!D3&!D2&D1&!D&C1&C&B1&B&!A1&A|E&D3&!D2&D1&!D&C1&C&B1&B&!A1&A|E&D3&D2&D1&!D&C1&C&B1&B&!A1&A|E&!D3&D2&D1&!D&C1&C&B1&B&!A1&A|E&!D3&D2&!D1&!D&C1&C&B1&B&!A1&A|E&D3&D2&!D1&!D&C1&C&B1&B&!A1&A|E&D3&!D2&!D1&!D&C1&C&B1&B&!A1&A|E&D3&!D2&!D1&!D&C1&!C&B1&B&!A1&A|E&D3&D2&!D1&!D&C1&!C&B1&B&!A1&A|E&!D3&D2&!D1&!D&C1&!C&B1&B&!A1&A|E&!D3&D2&D1&!D&C1&!C&B1&B&!A1&A|E&D3&D2&D1&!D&C1&!C&B1&B&!A1&A|E&D3&!D2&D1&!D&C1&!C&B1&B&!A1&A|E&!D3&!D2&D1&!D&C1&!C&B1&B&!A1&A|E&!D3&!D2&D1&D&C1&!C&B1&B&!A1&A|E&D3&!D2&D1&D&C1&!C&B1&B&!A1&A|E&D3&D2&D1&D&C1&!C&B1&B&!A1&A|E&!D3&D2&D1&D&C1&!C&B1&B&!A1&A|E&!D3&D2&!D1&D&C1&!C&B1&B&!A1&A|E&D3&D2&!D1&D&C1&!C&B1&B&!A1&A|E&D3&!D2&!D1&D&C1&!C&B1&B&!A1&A|E&!D3&!D2&!D1&D&C1&!C&B1&B&!A1&A|E&!D3&!D2&!D1&D&!C1&!C&B1&B&!A1&A|E&D3&!D2&!D1&D&!C1&!C&B1&B&!A1&A|E&D3&D2&!D1&D&!C1&!C&B1&B&!A1&A|E&!D3&D2&!D1&D&!C1&!C&B1&B&!A1&A|E&!D3&D2&D1&D&!C1&!C&B1&B&!A1&A|E&D3&D2&D1&D&!C1&!C&B1&B&!A1&A|E&D3&!D2&D1&D&!C1&!C&B1&B&!A1&A|E&!D3&!D2&D1&D&!C1&!C&B1&B&!A1&A|E&!D3&!D2&D1&!D&!C1&!C&B1&B&!A1&A|E&D3&!D2&D1&!D&!C1&!C&B1&B&!A1&A|E&D3&D2&D1&!D&!C1&!C&B1&B&!A1&A|E&!D3&D2&D1&!D&!C1&!C&B1&B&!A1&A|E&!D3&D2&!D1&!D&!C1&!C&B1&B&!A1&A|E&D3&D2&!D1&!D&!C1&!C&B1&B&!A1&A|E&D3&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|E&D3&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|E&D3&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|E&!D3&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|E&!D3&D2&D1&!D&!C1&!C&B1&!B&!A1&A|E&D3&D2&D1&!D&!C1&!C&B1&!B&!A1&A|E&D3&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|E&!D3&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|E&!D3&!D2&D1&D&!C1&!C&B1&!B&!A1&A|E&D3&!D2&D1&D&!C1&!C&B1&!B&!A1&A|E&D3&D2&D1&D&!C1&!C&B1&!B&!A1&A|E&!D3&D2&D1&D&!C1&!C&B1&!B&!A1&A|E&!D3&D2&!D1&D&!C1&!C&B1&!B&!A1&A|E&D3&D2&!D1&D&!C1&!C&B1&!B&!A1&A|E&D3&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|E&!D3&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|E&!D3&!D2&!D1&D&C1&!C&B1&!B&!A1&A|E&D3&!D2&!D1&D&C1&!C&B1&!B&!A1&A|E&D3&D2&!D1&D&C1&!C&B1&!B&!A1&A|E&!D3&D2&!D1&D&C1&!C&B1&!B&!A1&A|E&!D3&D2&D1&D&C1&!C&B1&!B&!A1&A|E&D3&D2&D1&D&C1&!C&B1&!B&!A1&A|E&D3&!D2&D1&D&C1&!C&B1&!B&!A1&A|E&!D3&!D2&D1&D&C1&!C&B1&!B&!A1&A|E&!D3&!D2&D1&!D&C1&!C&B1&!B&!A1&A|E&D3&!D2&D1&!D&C1&!C&B1&!B&!A1&A|E&D3&D2&D1&!D&C1&!C&B1&!B&!A1&A|E&!D3&D2&D1&!D&C1&!C&B1&!B&!A1&A|E&!D3&D2&!D1&!D&C1&!C&B1&!B&!A1&A|E&D3&D2&!D1&!D&C1&!C&B1&!B&!A1&A|E&D3&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|E&D3&!D2&!D1&!D&C1&C&B1&!B&!A1&A|E&D3&D2&!D1&!D&C1&C&B1&!B&!A1&A|E&!D3&D2&!D1&!D&C1&C&B1&!B&!A1&A|E&!D3&D2&D1&!D&C1&C&B1&!B&!A1&A|E&D3&D2&D1&!D&C1&C&B1&!B&!A1&A|E&D3&!D2&D1&!D&C1&C&B1&!B&!A1&A|E&!D3&!D2&D1&!D&C1&C&B1&!B&!A1&A|E&!D3&!D2&D1&D&C1&C&B1&!B&!A1&A|E&D3&!D2&D1&D&C1&C&B1&!B&!A1&A|E&D3&D2&D1&D&C1&C&B1&!B&!A1&A|E&!D3&D2&D1&D&C1&C&B1&!B&!A1&A|E&!D3&D2&!D1&D&C1&C&B1&!B&!A1&A|E&D3&D2&!D1&D&C1&C&B1&!B&!A1&A|E&D3&!D2&!D1&D&C1&C&B1&!B&!A1&A|E&!D3&!D2&!D1&D&C1&C&B1&!B&!A1&A|E&!D3&!D2&!D1&D&!C1&C&B1&!B&!A1&A|E&D3&!D2&!D1&D&!C1&C&B1&!B&!A1&A|E&D3&D2&!D1&D&!C1&C&B1&!B&!A1&A|E&!D3&D2&!D1&D&!C1&C&B1&!B&!A1&A|E&!D3&D2&D1&D&!C1&C&B1&!B&!A1&A|E&D3&D2&D1&D&!C1&C&B1&!B&!A1&A|E&D3&!D2&D1&D&!C1&C&B1&!B&!A1&A|E&!D3&!D2&D1&D&!C1&C&B1&!B&!A1&A|E&!D3&!D2&D1&!D&!C1&C&B1&!B&!A1&A|E&D3&!D2&D1&!D&!C1&C&B1&!B&!A1&A|E&D3&D2&D1&!D&!C1&C&B1&!B&!A1&A|E&!D3&D2&D1&!D&!C1&C&B1&!B&!A1&A|E&!D3&D2&!D1&!D&!C1&C&B1&!B&!A1&A|E&D3&D2&!D1&!D&!C1&C&B1&!B&!A1&A|E&D3&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|E&!D3&!D2&!D1&D&C1&C&!B1&!B&!A1&A|E&D3&!D2&!D1&D&C1&C&!B1&!B&!A1&A|E&D3&D2&!D1&D&C1&C&!B1&!B&!A1&A|E&!D3&D2&!D1&D&C1&C&!B1&!B&!A1&A|E&!D3&D2&D1&D&C1&C&!B1&!B&!A1&A|E&D3&D2&D1&D&C1&C&!B1&!B&!A1&A|E&D3&!D2&D1&D&C1&C&!B1&!B&!A1&A|E&!D3&!D2&D1&D&C1&C&!B1&!B&!A1&A|E&!D3&!D2&D1&!D&C1&C&!B1&!B&!A1&A|E&D3&!D2&D1&!D&C1&C&!B1&!B&!A1&A|E&D3&D2&D1&!D&C1&C&!B1&!B&!A1&A|E&!D3&D2&D1&!D&C1&C&!B1&!B&!A1&A|E&!D3&D2&!D1&!D&C1&C&!B1&!B&!A1&A|E&D3&D2&!D1&!D&C1&C&!B1&!B&!A1&A|E&D3&!D2&!D1&!D&C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOOAI22241.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOOOAI22132 -l OOAOOOAI22132 -i E1 E D2 D1 D C B1 B A1 A -o Y -f Y=(!E1&!E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|E1&E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!E1&E&D2&!D1&!D&!C&!B1&!B&!A1&!A|E1&E&D2&!D1&!D&!C&!B1&!B&!A1&!A|E1&!E&D2&!D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&D2&D1&!D&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&!D&!C&!B1&!B&!A1&!A|E1&E&D2&D1&!D&!C&!B1&!B&!A1&!A|!E1&E&D2&D1&!D&!C&!B1&!B&!A1&!A|!E1&E&!D2&D1&!D&!C&!B1&!B&!A1&!A|E1&E&!D2&D1&!D&!C&!B1&!B&!A1&!A|E1&!E&!D2&D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&D&!C&!B1&!B&!A1&!A|E1&!E&!D2&D1&D&!C&!B1&!B&!A1&!A|E1&E&!D2&D1&D&!C&!B1&!B&!A1&!A|!E1&E&!D2&D1&D&!C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&!C&!B1&!B&!A1&!A|E1&E&D2&D1&D&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&!C&!B1&!B&!A1&!A|!E1&!E&D2&D1&D&!C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&D&!C&!B1&!B&!A1&!A|E1&!E&D2&!D1&D&!C&!B1&!B&!A1&!A|E1&E&D2&!D1&D&!C&!B1&!B&!A1&!A|!E1&E&D2&!D1&D&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&D&!C&!B1&!B&!A1&!A|E1&E&!D2&!D1&D&!C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&D&!C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&D&C&!B1&!B&!A1&!A|!E1&!E&D2&D1&D&C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&D&C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&C&!B1&!B&!A1&!A|!E1&!E&D2&D1&!D&C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&C&!B1&!B&!A1&!A|E1&E&!D2&!D1&!D&C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C&B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&C&B1&!B&!A1&!A|E1&E&!D2&!D1&!D&C&B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&C&B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&C&B1&!B&!A1&!A|!E1&!E&D2&D1&!D&C&B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&C&B1&!B&!A1&!A|!E1&!E&!D2&D1&D&C&B1&!B&!A1&!A|!E1&!E&D2&D1&D&C&B1&!B&!A1&!A|!E1&!E&D2&!D1&D&C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C&B1&!B&!A1&!A|E1&!E&!D2&!D1&D&!C&B1&!B&!A1&!A|E1&E&!D2&!D1&D&!C&B1&!B&!A1&!A|!E1&E&!D2&!D1&D&!C&B1&!B&!A1&!A|!E1&E&D2&!D1&D&!C&B1&!B&!A1&!A|E1&E&D2&!D1&D&!C&B1&!B&!A1&!A|E1&!E&D2&!D1&D&!C&B1&!B&!A1&!A|!E1&!E&D2&!D1&D&!C&B1&!B&!A1&!A|!E1&!E&D2&D1&D&!C&B1&!B&!A1&!A|E1&!E&D2&D1&D&!C&B1&!B&!A1&!A|E1&E&D2&D1&D&!C&B1&!B&!A1&!A|!E1&E&D2&D1&D&!C&B1&!B&!A1&!A|!E1&E&!D2&D1&D&!C&B1&!B&!A1&!A|E1&E&!D2&D1&D&!C&B1&!B&!A1&!A|E1&!E&!D2&D1&D&!C&B1&!B&!A1&!A|!E1&!E&!D2&D1&D&!C&B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C&B1&!B&!A1&!A|E1&!E&!D2&D1&!D&!C&B1&!B&!A1&!A|E1&E&!D2&D1&!D&!C&B1&!B&!A1&!A|!E1&E&!D2&D1&!D&!C&B1&!B&!A1&!A|!E1&E&D2&D1&!D&!C&B1&!B&!A1&!A|E1&E&D2&D1&!D&!C&B1&!B&!A1&!A|E1&!E&D2&D1&!D&!C&B1&!B&!A1&!A|!E1&!E&D2&D1&!D&!C&B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C&B1&!B&!A1&!A|E1&!E&D2&!D1&!D&!C&B1&!B&!A1&!A|E1&E&D2&!D1&!D&!C&B1&!B&!A1&!A|!E1&E&D2&!D1&!D&!C&B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C&B1&!B&!A1&!A|E1&E&!D2&!D1&!D&!C&B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&!C&B1&B&!A1&!A|E1&E&!D2&!D1&!D&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&!C&B1&B&!A1&!A|!E1&E&D2&!D1&!D&!C&B1&B&!A1&!A|E1&E&D2&!D1&!D&!C&B1&B&!A1&!A|E1&!E&D2&!D1&!D&!C&B1&B&!A1&!A|!E1&!E&D2&!D1&!D&!C&B1&B&!A1&!A|!E1&!E&D2&D1&!D&!C&B1&B&!A1&!A|E1&!E&D2&D1&!D&!C&B1&B&!A1&!A|E1&E&D2&D1&!D&!C&B1&B&!A1&!A|!E1&E&D2&D1&!D&!C&B1&B&!A1&!A|!E1&E&!D2&D1&!D&!C&B1&B&!A1&!A|E1&E&!D2&D1&!D&!C&B1&B&!A1&!A|E1&!E&!D2&D1&!D&!C&B1&B&!A1&!A|!E1&!E&!D2&D1&!D&!C&B1&B&!A1&!A|!E1&!E&!D2&D1&D&!C&B1&B&!A1&!A|E1&!E&!D2&D1&D&!C&B1&B&!A1&!A|E1&E&!D2&D1&D&!C&B1&B&!A1&!A|!E1&E&!D2&D1&D&!C&B1&B&!A1&!A|!E1&E&D2&D1&D&!C&B1&B&!A1&!A|E1&E&D2&D1&D&!C&B1&B&!A1&!A|E1&!E&D2&D1&D&!C&B1&B&!A1&!A|!E1&!E&D2&D1&D&!C&B1&B&!A1&!A|!E1&!E&D2&!D1&D&!C&B1&B&!A1&!A|E1&!E&D2&!D1&D&!C&B1&B&!A1&!A|E1&E&D2&!D1&D&!C&B1&B&!A1&!A|!E1&E&D2&!D1&D&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&D&!C&B1&B&!A1&!A|E1&E&!D2&!D1&D&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&D&!C&B1&B&!A1&!A|!E1&!E&!D2&!D1&D&!C&B1&B&!A1&!A|!E1&!E&!D2&!D1&D&C&B1&B&!A1&!A|!E1&!E&D2&!D1&D&C&B1&B&!A1&!A|!E1&!E&D2&D1&D&C&B1&B&!A1&!A|!E1&!E&!D2&D1&D&C&B1&B&!A1&!A|!E1&!E&!D2&D1&!D&C&B1&B&!A1&!A|!E1&!E&D2&D1&!D&C&B1&B&!A1&!A|!E1&!E&D2&!D1&!D&C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C&B1&B&!A1&!A|E1&E&!D2&!D1&!D&C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C&B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&C&B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&C&!B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C&!B1&B&!A1&!A|E1&E&!D2&!D1&!D&C&!B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C&!B1&B&!A1&!A|!E1&!E&D2&!D1&!D&C&!B1&B&!A1&!A|!E1&!E&D2&D1&!D&C&!B1&B&!A1&!A|!E1&!E&!D2&D1&!D&C&!B1&B&!A1&!A|!E1&!E&!D2&D1&D&C&!B1&B&!A1&!A|!E1&!E&D2&D1&D&C&!B1&B&!A1&!A|!E1&!E&D2&!D1&D&C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&D&C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&D&!C&!B1&B&!A1&!A|E1&!E&!D2&!D1&D&!C&!B1&B&!A1&!A|E1&E&!D2&!D1&D&!C&!B1&B&!A1&!A|!E1&E&!D2&!D1&D&!C&!B1&B&!A1&!A|!E1&E&D2&!D1&D&!C&!B1&B&!A1&!A|E1&E&D2&!D1&D&!C&!B1&B&!A1&!A|E1&!E&D2&!D1&D&!C&!B1&B&!A1&!A|!E1&!E&D2&!D1&D&!C&!B1&B&!A1&!A|!E1&!E&D2&D1&D&!C&!B1&B&!A1&!A|E1&!E&D2&D1&D&!C&!B1&B&!A1&!A|E1&E&D2&D1&D&!C&!B1&B&!A1&!A|!E1&E&D2&D1&D&!C&!B1&B&!A1&!A|!E1&E&!D2&D1&D&!C&!B1&B&!A1&!A|E1&E&!D2&D1&D&!C&!B1&B&!A1&!A|E1&!E&!D2&D1&D&!C&!B1&B&!A1&!A|!E1&!E&!D2&D1&D&!C&!B1&B&!A1&!A|!E1&!E&!D2&D1&!D&!C&!B1&B&!A1&!A|E1&!E&!D2&D1&!D&!C&!B1&B&!A1&!A|E1&E&!D2&D1&!D&!C&!B1&B&!A1&!A|!E1&E&!D2&D1&!D&!C&!B1&B&!A1&!A|!E1&E&D2&D1&!D&!C&!B1&B&!A1&!A|E1&E&D2&D1&!D&!C&!B1&B&!A1&!A|E1&!E&D2&D1&!D&!C&!B1&B&!A1&!A|!E1&!E&D2&D1&!D&!C&!B1&B&!A1&!A|!E1&!E&D2&!D1&!D&!C&!B1&B&!A1&!A|E1&!E&D2&!D1&!D&!C&!B1&B&!A1&!A|E1&E&D2&!D1&!D&!C&!B1&B&!A1&!A|!E1&E&D2&!D1&!D&!C&!B1&B&!A1&!A|!E1&E&!D2&!D1&!D&!C&!B1&B&!A1&!A|E1&E&!D2&!D1&!D&!C&!B1&B&!A1&!A|E1&!E&!D2&!D1&!D&!C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&!C&!B1&B&A1&!A|E1&E&!D2&!D1&!D&!C&!B1&B&A1&!A|!E1&E&!D2&!D1&!D&!C&!B1&B&A1&!A|!E1&!E&D2&!D1&!D&!C&!B1&B&A1&!A|!E1&!E&D2&D1&!D&!C&!B1&B&A1&!A|!E1&!E&!D2&D1&!D&!C&!B1&B&A1&!A|!E1&!E&!D2&D1&D&!C&!B1&B&A1&!A|!E1&!E&D2&D1&D&!C&!B1&B&A1&!A|!E1&!E&D2&!D1&D&!C&!B1&B&A1&!A|!E1&!E&!D2&!D1&D&!C&!B1&B&A1&!A|!E1&!E&!D2&!D1&D&C&!B1&B&A1&!A|!E1&!E&D2&!D1&D&C&!B1&B&A1&!A|!E1&!E&D2&D1&D&C&!B1&B&A1&!A|!E1&!E&!D2&D1&D&C&!B1&B&A1&!A|!E1&!E&!D2&D1&!D&C&!B1&B&A1&!A|!E1&!E&D2&D1&!D&C&!B1&B&A1&!A|!E1&!E&D2&!D1&!D&C&!B1&B&A1&!A|!E1&E&!D2&!D1&!D&C&!B1&B&A1&!A|E1&E&!D2&!D1&!D&C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&C&!B1&B&A1&!A|!E1&!E&!D2&!D1&!D&C&!B1&B&A1&!A|!E1&!E&!D2&!D1&!D&C&B1&B&A1&!A|E1&!E&!D2&!D1&!D&C&B1&B&A1&!A|E1&E&!D2&!D1&!D&C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&C&B1&B&A1&!A|!E1&!E&D2&!D1&!D&C&B1&B&A1&!A|!E1&!E&D2&D1&!D&C&B1&B&A1&!A|!E1&!E&!D2&D1&!D&C&B1&B&A1&!A|!E1&!E&!D2&D1&D&C&B1&B&A1&!A|!E1&!E&D2&D1&D&C&B1&B&A1&!A|!E1&!E&D2&!D1&D&C&B1&B&A1&!A|!E1&!E&!D2&!D1&D&C&B1&B&A1&!A|!E1&!E&!D2&!D1&D&!C&B1&B&A1&!A|!E1&!E&D2&!D1&D&!C&B1&B&A1&!A|!E1&!E&D2&D1&D&!C&B1&B&A1&!A|!E1&!E&!D2&D1&D&!C&B1&B&A1&!A|!E1&!E&!D2&D1&!D&!C&B1&B&A1&!A|!E1&!E&D2&D1&!D&!C&B1&B&A1&!A|!E1&!E&D2&!D1&!D&!C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&!C&B1&B&A1&!A|E1&E&!D2&!D1&!D&!C&B1&B&A1&!A|E1&!E&!D2&!D1&!D&!C&B1&B&A1&!A|!E1&!E&!D2&!D1&!D&!C&B1&B&A1&!A|!E1&!E&!D2&!D1&!D&!C&B1&!B&A1&!A|E1&!E&!D2&!D1&!D&!C&B1&!B&A1&!A|E1&E&!D2&!D1&!D&!C&B1&!B&A1&!A|!E1&E&!D2&!D1&!D&!C&B1&!B&A1&!A|!E1&!E&D2&!D1&!D&!C&B1&!B&A1&!A|!E1&!E&D2&D1&!D&!C&B1&!B&A1&!A|!E1&!E&!D2&D1&!D&!C&B1&!B&A1&!A|!E1&!E&!D2&D1&D&!C&B1&!B&A1&!A|!E1&!E&D2&D1&D&!C&B1&!B&A1&!A|!E1&!E&D2&!D1&D&!C&B1&!B&A1&!A|!E1&!E&!D2&!D1&D&!C&B1&!B&A1&!A|!E1&!E&!D2&!D1&D&C&B1&!B&A1&!A|!E1&!E&D2&!D1&D&C&B1&!B&A1&!A|!E1&!E&D2&D1&D&C&B1&!B&A1&!A|!E1&!E&!D2&D1&D&C&B1&!B&A1&!A|!E1&!E&!D2&D1&!D&C&B1&!B&A1&!A|!E1&!E&D2&D1&!D&C&B1&!B&A1&!A|!E1&!E&D2&!D1&!D&C&B1&!B&A1&!A|!E1&E&!D2&!D1&!D&C&B1&!B&A1&!A|E1&E&!D2&!D1&!D&C&B1&!B&A1&!A|E1&!E&!D2&!D1&!D&C&B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&C&B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&C&!B1&!B&A1&!A|E1&!E&!D2&!D1&!D&C&!B1&!B&A1&!A|E1&E&!D2&!D1&!D&C&!B1&!B&A1&!A|!E1&E&!D2&!D1&!D&C&!B1&!B&A1&!A|!E1&!E&D2&!D1&!D&C&!B1&!B&A1&!A|!E1&!E&D2&D1&!D&C&!B1&!B&A1&!A|!E1&!E&!D2&D1&!D&C&!B1&!B&A1&!A|!E1&!E&!D2&D1&D&C&!B1&!B&A1&!A|!E1&!E&D2&D1&D&C&!B1&!B&A1&!A|!E1&!E&D2&!D1&D&C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&D&C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&D&!C&!B1&!B&A1&!A|E1&!E&!D2&!D1&D&!C&!B1&!B&A1&!A|E1&E&!D2&!D1&D&!C&!B1&!B&A1&!A|!E1&E&!D2&!D1&D&!C&!B1&!B&A1&!A|!E1&E&D2&!D1&D&!C&!B1&!B&A1&!A|E1&E&D2&!D1&D&!C&!B1&!B&A1&!A|E1&!E&D2&!D1&D&!C&!B1&!B&A1&!A|!E1&!E&D2&!D1&D&!C&!B1&!B&A1&!A|!E1&!E&D2&D1&D&!C&!B1&!B&A1&!A|E1&!E&D2&D1&D&!C&!B1&!B&A1&!A|E1&E&D2&D1&D&!C&!B1&!B&A1&!A|!E1&E&D2&D1&D&!C&!B1&!B&A1&!A|!E1&E&!D2&D1&D&!C&!B1&!B&A1&!A|E1&E&!D2&D1&D&!C&!B1&!B&A1&!A|E1&!E&!D2&D1&D&!C&!B1&!B&A1&!A|!E1&!E&!D2&D1&D&!C&!B1&!B&A1&!A|!E1&!E&!D2&D1&!D&!C&!B1&!B&A1&!A|E1&!E&!D2&D1&!D&!C&!B1&!B&A1&!A|E1&E&!D2&D1&!D&!C&!B1&!B&A1&!A|!E1&E&!D2&D1&!D&!C&!B1&!B&A1&!A|!E1&E&D2&D1&!D&!C&!B1&!B&A1&!A|E1&E&D2&D1&!D&!C&!B1&!B&A1&!A|E1&!E&D2&D1&!D&!C&!B1&!B&A1&!A|!E1&!E&D2&D1&!D&!C&!B1&!B&A1&!A|!E1&!E&D2&!D1&!D&!C&!B1&!B&A1&!A|E1&!E&D2&!D1&!D&!C&!B1&!B&A1&!A|E1&E&D2&!D1&!D&!C&!B1&!B&A1&!A|!E1&E&D2&!D1&!D&!C&!B1&!B&A1&!A|!E1&E&!D2&!D1&!D&!C&!B1&!B&A1&!A|E1&E&!D2&!D1&!D&!C&!B1&!B&A1&!A|E1&!E&!D2&!D1&!D&!C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&!C&!B1&!B&A1&A|E1&E&!D2&!D1&!D&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&!C&!B1&!B&A1&A|!E1&E&D2&!D1&!D&!C&!B1&!B&A1&A|E1&E&D2&!D1&!D&!C&!B1&!B&A1&A|E1&!E&D2&!D1&!D&!C&!B1&!B&A1&A|!E1&!E&D2&!D1&!D&!C&!B1&!B&A1&A|!E1&!E&D2&D1&!D&!C&!B1&!B&A1&A|E1&!E&D2&D1&!D&!C&!B1&!B&A1&A|E1&E&D2&D1&!D&!C&!B1&!B&A1&A|!E1&E&D2&D1&!D&!C&!B1&!B&A1&A|!E1&E&!D2&D1&!D&!C&!B1&!B&A1&A|E1&E&!D2&D1&!D&!C&!B1&!B&A1&A|E1&!E&!D2&D1&!D&!C&!B1&!B&A1&A|!E1&!E&!D2&D1&!D&!C&!B1&!B&A1&A|!E1&!E&!D2&D1&D&!C&!B1&!B&A1&A|E1&!E&!D2&D1&D&!C&!B1&!B&A1&A|E1&E&!D2&D1&D&!C&!B1&!B&A1&A|!E1&E&!D2&D1&D&!C&!B1&!B&A1&A|!E1&E&D2&D1&D&!C&!B1&!B&A1&A|E1&E&D2&D1&D&!C&!B1&!B&A1&A|E1&!E&D2&D1&D&!C&!B1&!B&A1&A|!E1&!E&D2&D1&D&!C&!B1&!B&A1&A|!E1&!E&D2&!D1&D&!C&!B1&!B&A1&A|E1&!E&D2&!D1&D&!C&!B1&!B&A1&A|E1&E&D2&!D1&D&!C&!B1&!B&A1&A|!E1&E&D2&!D1&D&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&D&!C&!B1&!B&A1&A|E1&E&!D2&!D1&D&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&D&!C&!B1&!B&A1&A|!E1&!E&!D2&!D1&D&!C&!B1&!B&A1&A|!E1&!E&!D2&!D1&D&C&!B1&!B&A1&A|!E1&!E&D2&!D1&D&C&!B1&!B&A1&A|!E1&!E&D2&D1&D&C&!B1&!B&A1&A|!E1&!E&!D2&D1&D&C&!B1&!B&A1&A|!E1&!E&!D2&D1&!D&C&!B1&!B&A1&A|!E1&!E&D2&D1&!D&C&!B1&!B&A1&A|!E1&!E&D2&!D1&!D&C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&C&!B1&!B&A1&A|E1&E&!D2&!D1&!D&C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&C&!B1&!B&A1&A|!E1&!E&!D2&!D1&!D&C&!B1&!B&A1&A|!E1&!E&!D2&!D1&!D&C&B1&!B&A1&A|E1&!E&!D2&!D1&!D&C&B1&!B&A1&A|E1&E&!D2&!D1&!D&C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&C&B1&!B&A1&A|!E1&!E&D2&!D1&!D&C&B1&!B&A1&A|!E1&!E&D2&D1&!D&C&B1&!B&A1&A|!E1&!E&!D2&D1&!D&C&B1&!B&A1&A|!E1&!E&!D2&D1&D&C&B1&!B&A1&A|!E1&!E&D2&D1&D&C&B1&!B&A1&A|!E1&!E&D2&!D1&D&C&B1&!B&A1&A|!E1&!E&!D2&!D1&D&C&B1&!B&A1&A|!E1&!E&!D2&!D1&D&!C&B1&!B&A1&A|!E1&!E&D2&!D1&D&!C&B1&!B&A1&A|!E1&!E&D2&D1&D&!C&B1&!B&A1&A|!E1&!E&!D2&D1&D&!C&B1&!B&A1&A|!E1&!E&!D2&D1&!D&!C&B1&!B&A1&A|!E1&!E&D2&D1&!D&!C&B1&!B&A1&A|!E1&!E&D2&!D1&!D&!C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&!C&B1&!B&A1&A|E1&E&!D2&!D1&!D&!C&B1&!B&A1&A|E1&!E&!D2&!D1&!D&!C&B1&!B&A1&A|!E1&!E&!D2&!D1&!D&!C&B1&!B&A1&A|!E1&!E&!D2&!D1&!D&!C&B1&B&A1&A|E1&!E&!D2&!D1&!D&!C&B1&B&A1&A|E1&E&!D2&!D1&!D&!C&B1&B&A1&A|!E1&E&!D2&!D1&!D&!C&B1&B&A1&A|!E1&!E&D2&!D1&!D&!C&B1&B&A1&A|!E1&!E&D2&D1&!D&!C&B1&B&A1&A|!E1&!E&!D2&D1&!D&!C&B1&B&A1&A|!E1&!E&!D2&D1&D&!C&B1&B&A1&A|!E1&!E&D2&D1&D&!C&B1&B&A1&A|!E1&!E&D2&!D1&D&!C&B1&B&A1&A|!E1&!E&!D2&!D1&D&!C&B1&B&A1&A|!E1&!E&!D2&!D1&D&C&B1&B&A1&A|!E1&!E&D2&!D1&D&C&B1&B&A1&A|!E1&!E&D2&D1&D&C&B1&B&A1&A|!E1&!E&!D2&D1&D&C&B1&B&A1&A|!E1&!E&!D2&D1&!D&C&B1&B&A1&A|!E1&!E&D2&D1&!D&C&B1&B&A1&A|!E1&!E&D2&!D1&!D&C&B1&B&A1&A|!E1&E&!D2&!D1&!D&C&B1&B&A1&A|E1&E&!D2&!D1&!D&C&B1&B&A1&A|E1&!E&!D2&!D1&!D&C&B1&B&A1&A|!E1&!E&!D2&!D1&!D&C&B1&B&A1&A|!E1&!E&!D2&!D1&!D&C&!B1&B&A1&A|E1&!E&!D2&!D1&!D&C&!B1&B&A1&A|E1&E&!D2&!D1&!D&C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&C&!B1&B&A1&A|!E1&!E&D2&!D1&!D&C&!B1&B&A1&A|!E1&!E&D2&D1&!D&C&!B1&B&A1&A|!E1&!E&!D2&D1&!D&C&!B1&B&A1&A|!E1&!E&!D2&D1&D&C&!B1&B&A1&A|!E1&!E&D2&D1&D&C&!B1&B&A1&A|!E1&!E&D2&!D1&D&C&!B1&B&A1&A|!E1&!E&!D2&!D1&D&C&!B1&B&A1&A|!E1&!E&!D2&!D1&D&!C&!B1&B&A1&A|!E1&!E&D2&!D1&D&!C&!B1&B&A1&A|!E1&!E&D2&D1&D&!C&!B1&B&A1&A|!E1&!E&!D2&D1&D&!C&!B1&B&A1&A|!E1&!E&!D2&D1&!D&!C&!B1&B&A1&A|!E1&!E&D2&D1&!D&!C&!B1&B&A1&A|!E1&!E&D2&!D1&!D&!C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&!C&!B1&B&A1&A|E1&E&!D2&!D1&!D&!C&!B1&B&A1&A|E1&!E&!D2&!D1&!D&!C&!B1&B&A1&A|!E1&!E&!D2&!D1&!D&!C&!B1&B&A1&A|!E1&!E&!D2&!D1&!D&!C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&!C&!B1&B&!A1&A|E1&E&!D2&!D1&!D&!C&!B1&B&!A1&A|!E1&E&!D2&!D1&!D&!C&!B1&B&!A1&A|!E1&!E&D2&!D1&!D&!C&!B1&B&!A1&A|!E1&!E&D2&D1&!D&!C&!B1&B&!A1&A|!E1&!E&!D2&D1&!D&!C&!B1&B&!A1&A|!E1&!E&!D2&D1&D&!C&!B1&B&!A1&A|!E1&!E&D2&D1&D&!C&!B1&B&!A1&A|!E1&!E&D2&!D1&D&!C&!B1&B&!A1&A|!E1&!E&!D2&!D1&D&!C&!B1&B&!A1&A|!E1&!E&!D2&!D1&D&C&!B1&B&!A1&A|!E1&!E&D2&!D1&D&C&!B1&B&!A1&A|!E1&!E&D2&D1&D&C&!B1&B&!A1&A|!E1&!E&!D2&D1&D&C&!B1&B&!A1&A|!E1&!E&!D2&D1&!D&C&!B1&B&!A1&A|!E1&!E&D2&D1&!D&C&!B1&B&!A1&A|!E1&!E&D2&!D1&!D&C&!B1&B&!A1&A|!E1&E&!D2&!D1&!D&C&!B1&B&!A1&A|E1&E&!D2&!D1&!D&C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&C&!B1&B&!A1&A|!E1&!E&!D2&!D1&!D&C&!B1&B&!A1&A|!E1&!E&!D2&!D1&!D&C&B1&B&!A1&A|E1&!E&!D2&!D1&!D&C&B1&B&!A1&A|E1&E&!D2&!D1&!D&C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&C&B1&B&!A1&A|!E1&!E&D2&!D1&!D&C&B1&B&!A1&A|!E1&!E&D2&D1&!D&C&B1&B&!A1&A|!E1&!E&!D2&D1&!D&C&B1&B&!A1&A|!E1&!E&!D2&D1&D&C&B1&B&!A1&A|!E1&!E&D2&D1&D&C&B1&B&!A1&A|!E1&!E&D2&!D1&D&C&B1&B&!A1&A|!E1&!E&!D2&!D1&D&C&B1&B&!A1&A|!E1&!E&!D2&!D1&D&!C&B1&B&!A1&A|!E1&!E&D2&!D1&D&!C&B1&B&!A1&A|!E1&!E&D2&D1&D&!C&B1&B&!A1&A|!E1&!E&!D2&D1&D&!C&B1&B&!A1&A|!E1&!E&!D2&D1&!D&!C&B1&B&!A1&A|!E1&!E&D2&D1&!D&!C&B1&B&!A1&A|!E1&!E&D2&!D1&!D&!C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&!C&B1&B&!A1&A|E1&E&!D2&!D1&!D&!C&B1&B&!A1&A|E1&!E&!D2&!D1&!D&!C&B1&B&!A1&A|!E1&!E&!D2&!D1&!D&!C&B1&B&!A1&A|!E1&!E&!D2&!D1&!D&!C&B1&!B&!A1&A|E1&!E&!D2&!D1&!D&!C&B1&!B&!A1&A|E1&E&!D2&!D1&!D&!C&B1&!B&!A1&A|!E1&E&!D2&!D1&!D&!C&B1&!B&!A1&A|!E1&!E&D2&!D1&!D&!C&B1&!B&!A1&A|!E1&!E&D2&D1&!D&!C&B1&!B&!A1&A|!E1&!E&!D2&D1&!D&!C&B1&!B&!A1&A|!E1&!E&!D2&D1&D&!C&B1&!B&!A1&A|!E1&!E&D2&D1&D&!C&B1&!B&!A1&A|!E1&!E&D2&!D1&D&!C&B1&!B&!A1&A|!E1&!E&!D2&!D1&D&!C&B1&!B&!A1&A|!E1&!E&!D2&!D1&D&C&B1&!B&!A1&A|!E1&!E&D2&!D1&D&C&B1&!B&!A1&A|!E1&!E&D2&D1&D&C&B1&!B&!A1&A|!E1&!E&!D2&D1&D&C&B1&!B&!A1&A|!E1&!E&!D2&D1&!D&C&B1&!B&!A1&A|!E1&!E&D2&D1&!D&C&B1&!B&!A1&A|!E1&!E&D2&!D1&!D&C&B1&!B&!A1&A|!E1&E&!D2&!D1&!D&C&B1&!B&!A1&A|E1&E&!D2&!D1&!D&C&B1&!B&!A1&A|E1&!E&!D2&!D1&!D&C&B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&C&B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&C&!B1&!B&!A1&A|E1&!E&!D2&!D1&!D&C&!B1&!B&!A1&A|E1&E&!D2&!D1&!D&C&!B1&!B&!A1&A|!E1&E&!D2&!D1&!D&C&!B1&!B&!A1&A|!E1&!E&D2&!D1&!D&C&!B1&!B&!A1&A|!E1&!E&D2&D1&!D&C&!B1&!B&!A1&A|!E1&!E&!D2&D1&!D&C&!B1&!B&!A1&A|!E1&!E&!D2&D1&D&C&!B1&!B&!A1&A|!E1&!E&D2&D1&D&C&!B1&!B&!A1&A|!E1&!E&D2&!D1&D&C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&D&C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&D&!C&!B1&!B&!A1&A|E1&!E&!D2&!D1&D&!C&!B1&!B&!A1&A|E1&E&!D2&!D1&D&!C&!B1&!B&!A1&A|!E1&E&!D2&!D1&D&!C&!B1&!B&!A1&A|!E1&E&D2&!D1&D&!C&!B1&!B&!A1&A|E1&E&D2&!D1&D&!C&!B1&!B&!A1&A|E1&!E&D2&!D1&D&!C&!B1&!B&!A1&A|!E1&!E&D2&!D1&D&!C&!B1&!B&!A1&A|!E1&!E&D2&D1&D&!C&!B1&!B&!A1&A|E1&!E&D2&D1&D&!C&!B1&!B&!A1&A|E1&E&D2&D1&D&!C&!B1&!B&!A1&A|!E1&E&D2&D1&D&!C&!B1&!B&!A1&A|!E1&E&!D2&D1&D&!C&!B1&!B&!A1&A|E1&E&!D2&D1&D&!C&!B1&!B&!A1&A|E1&!E&!D2&D1&D&!C&!B1&!B&!A1&A|!E1&!E&!D2&D1&D&!C&!B1&!B&!A1&A|!E1&!E&!D2&D1&!D&!C&!B1&!B&!A1&A|E1&!E&!D2&D1&!D&!C&!B1&!B&!A1&A|E1&E&!D2&D1&!D&!C&!B1&!B&!A1&A|!E1&E&!D2&D1&!D&!C&!B1&!B&!A1&A|!E1&E&D2&D1&!D&!C&!B1&!B&!A1&A|E1&E&D2&D1&!D&!C&!B1&!B&!A1&A|E1&!E&D2&D1&!D&!C&!B1&!B&!A1&A|!E1&!E&D2&D1&!D&!C&!B1&!B&!A1&A|!E1&!E&D2&!D1&!D&!C&!B1&!B&!A1&A|E1&!E&D2&!D1&!D&!C&!B1&!B&!A1&A|E1&E&D2&!D1&!D&!C&!B1&!B&!A1&A|!E1&E&D2&!D1&!D&!C&!B1&!B&!A1&A|!E1&E&!D2&!D1&!D&!C&!B1&!B&!A1&A|E1&E&!D2&!D1&!D&!C&!B1&!B&!A1&A|E1&!E&!D2&!D1&!D&!C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOOOAI22132.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOAI21221 -l AOOAAOAI21221 -i E D1 D C1 C B A1 A -o Y -f Y=!(E&D1&D&!C1&!C&!B&!A1&!A|E&D1&D&C1&!C&!B&!A1&!A|E&D1&D&C1&C&!B&!A1&!A|E&D1&D&!C1&C&!B&!A1&!A|E&!D1&!D&!C1&C&B&!A1&!A|E&D1&!D&!C1&C&B&!A1&!A|E&D1&D&!C1&C&B&!A1&!A|E&!D1&D&!C1&C&B&!A1&!A|E&!D1&D&C1&C&B&!A1&!A|E&D1&D&C1&C&B&!A1&!A|E&D1&!D&C1&C&B&!A1&!A|E&!D1&!D&C1&C&B&!A1&!A|E&!D1&!D&C1&!C&B&!A1&!A|E&D1&!D&C1&!C&B&!A1&!A|E&D1&D&C1&!C&B&!A1&!A|E&!D1&D&C1&!C&B&!A1&!A|E&D1&D&!C1&!C&B&!A1&!A|E&D1&D&!C1&!C&B&A1&!A|E&!D1&D&C1&!C&B&A1&!A|E&D1&D&C1&!C&B&A1&!A|E&D1&!D&C1&!C&B&A1&!A|E&!D1&!D&C1&!C&B&A1&!A|E&!D1&!D&C1&C&B&A1&!A|E&D1&!D&C1&C&B&A1&!A|E&D1&D&C1&C&B&A1&!A|E&!D1&D&C1&C&B&A1&!A|E&!D1&D&!C1&C&B&A1&!A|E&D1&D&!C1&C&B&A1&!A|E&D1&!D&!C1&C&B&A1&!A|E&!D1&!D&!C1&C&B&A1&!A|E&D1&D&!C1&C&!B&A1&!A|E&D1&D&C1&C&!B&A1&!A|E&D1&D&C1&!C&!B&A1&!A|E&D1&D&!C1&!C&!B&A1&!A|E&D1&D&!C1&!C&!B&A1&A|E&!D1&D&C1&!C&!B&A1&A|E&D1&D&C1&!C&!B&A1&A|E&D1&!D&C1&!C&!B&A1&A|E&!D1&!D&C1&!C&!B&A1&A|E&!D1&!D&C1&C&!B&A1&A|E&D1&!D&C1&C&!B&A1&A|E&D1&D&C1&C&!B&A1&A|E&!D1&D&C1&C&!B&A1&A|E&!D1&D&!C1&C&!B&A1&A|E&D1&D&!C1&C&!B&A1&A|E&D1&!D&!C1&C&!B&A1&A|E&!D1&!D&!C1&C&!B&A1&A|E&!D1&!D&!C1&C&B&A1&A|E&D1&!D&!C1&C&B&A1&A|E&D1&D&!C1&C&B&A1&A|E&!D1&D&!C1&C&B&A1&A|E&!D1&D&C1&C&B&A1&A|E&D1&D&C1&C&B&A1&A|E&D1&!D&C1&C&B&A1&A|E&!D1&!D&C1&C&B&A1&A|E&!D1&!D&C1&!C&B&A1&A|E&D1&!D&C1&!C&B&A1&A|E&D1&D&C1&!C&B&A1&A|E&!D1&D&C1&!C&B&A1&A|E&D1&D&!C1&!C&B&A1&A|E&D1&D&!C1&!C&B&!A1&A|E&!D1&D&C1&!C&B&!A1&A|E&D1&D&C1&!C&B&!A1&A|E&D1&!D&C1&!C&B&!A1&A|E&!D1&!D&C1&!C&B&!A1&A|E&!D1&!D&C1&C&B&!A1&A|E&D1&!D&C1&C&B&!A1&A|E&D1&D&C1&C&B&!A1&A|E&!D1&D&C1&C&B&!A1&A|E&!D1&D&!C1&C&B&!A1&A|E&D1&D&!C1&C&B&!A1&A|E&D1&!D&!C1&C&B&!A1&A|E&!D1&!D&!C1&C&B&!A1&A|E&D1&D&!C1&C&!B&!A1&A|E&D1&D&C1&C&!B&!A1&A|E&D1&D&C1&!C&!B&!A1&A|E&D1&D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOAI21221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOOAI22221 -l OOAAOOAI22221 -i E D1 D C1 C B1 B A1 A -o Y -f Y=!(E&D1&!D&C1&C&!B1&!B&!A1&!A|E&D1&D&C1&C&!B1&!B&!A1&!A|E&!D1&D&C1&C&!B1&!B&!A1&!A|E&!D1&D&C1&C&B1&!B&!A1&!A|E&D1&D&C1&C&B1&!B&!A1&!A|E&D1&!D&C1&C&B1&!B&!A1&!A|E&D1&!D&C1&C&B1&B&!A1&!A|E&D1&D&C1&C&B1&B&!A1&!A|E&!D1&D&C1&C&B1&B&!A1&!A|E&!D1&D&C1&C&!B1&B&!A1&!A|E&D1&D&C1&C&!B1&B&!A1&!A|E&D1&!D&C1&C&!B1&B&!A1&!A|E&D1&!D&!C1&!C&!B1&B&A1&!A|E&D1&D&!C1&!C&!B1&B&A1&!A|E&!D1&D&!C1&!C&!B1&B&A1&!A|E&!D1&D&C1&!C&!B1&B&A1&!A|E&D1&D&C1&!C&!B1&B&A1&!A|E&D1&!D&C1&!C&!B1&B&A1&!A|E&D1&!D&C1&C&!B1&B&A1&!A|E&D1&D&C1&C&!B1&B&A1&!A|E&!D1&D&C1&C&!B1&B&A1&!A|E&!D1&D&!C1&C&!B1&B&A1&!A|E&D1&D&!C1&C&!B1&B&A1&!A|E&D1&!D&!C1&C&!B1&B&A1&!A|E&D1&!D&!C1&C&B1&B&A1&!A|E&D1&D&!C1&C&B1&B&A1&!A|E&!D1&D&!C1&C&B1&B&A1&!A|E&!D1&D&C1&C&B1&B&A1&!A|E&D1&D&C1&C&B1&B&A1&!A|E&D1&!D&C1&C&B1&B&A1&!A|E&D1&!D&C1&!C&B1&B&A1&!A|E&D1&D&C1&!C&B1&B&A1&!A|E&!D1&D&C1&!C&B1&B&A1&!A|E&!D1&D&!C1&!C&B1&B&A1&!A|E&D1&D&!C1&!C&B1&B&A1&!A|E&D1&!D&!C1&!C&B1&B&A1&!A|E&D1&!D&!C1&!C&B1&!B&A1&!A|E&D1&D&!C1&!C&B1&!B&A1&!A|E&!D1&D&!C1&!C&B1&!B&A1&!A|E&!D1&D&C1&!C&B1&!B&A1&!A|E&D1&D&C1&!C&B1&!B&A1&!A|E&D1&!D&C1&!C&B1&!B&A1&!A|E&D1&!D&C1&C&B1&!B&A1&!A|E&D1&D&C1&C&B1&!B&A1&!A|E&!D1&D&C1&C&B1&!B&A1&!A|E&!D1&D&!C1&C&B1&!B&A1&!A|E&D1&D&!C1&C&B1&!B&A1&!A|E&D1&!D&!C1&C&B1&!B&A1&!A|E&!D1&D&C1&C&!B1&!B&A1&!A|E&D1&D&C1&C&!B1&!B&A1&!A|E&D1&!D&C1&C&!B1&!B&A1&!A|E&D1&!D&C1&C&!B1&!B&A1&A|E&D1&D&C1&C&!B1&!B&A1&A|E&!D1&D&C1&C&!B1&!B&A1&A|E&D1&!D&!C1&C&B1&!B&A1&A|E&D1&D&!C1&C&B1&!B&A1&A|E&!D1&D&!C1&C&B1&!B&A1&A|E&!D1&D&C1&C&B1&!B&A1&A|E&D1&D&C1&C&B1&!B&A1&A|E&D1&!D&C1&C&B1&!B&A1&A|E&D1&!D&C1&!C&B1&!B&A1&A|E&D1&D&C1&!C&B1&!B&A1&A|E&!D1&D&C1&!C&B1&!B&A1&A|E&!D1&D&!C1&!C&B1&!B&A1&A|E&D1&D&!C1&!C&B1&!B&A1&A|E&D1&!D&!C1&!C&B1&!B&A1&A|E&D1&!D&!C1&!C&B1&B&A1&A|E&D1&D&!C1&!C&B1&B&A1&A|E&!D1&D&!C1&!C&B1&B&A1&A|E&!D1&D&C1&!C&B1&B&A1&A|E&D1&D&C1&!C&B1&B&A1&A|E&D1&!D&C1&!C&B1&B&A1&A|E&D1&!D&C1&C&B1&B&A1&A|E&D1&D&C1&C&B1&B&A1&A|E&!D1&D&C1&C&B1&B&A1&A|E&!D1&D&!C1&C&B1&B&A1&A|E&D1&D&!C1&C&B1&B&A1&A|E&D1&!D&!C1&C&B1&B&A1&A|E&D1&!D&!C1&C&!B1&B&A1&A|E&D1&D&!C1&C&!B1&B&A1&A|E&!D1&D&!C1&C&!B1&B&A1&A|E&!D1&D&C1&C&!B1&B&A1&A|E&D1&D&C1&C&!B1&B&A1&A|E&D1&!D&C1&C&!B1&B&A1&A|E&D1&!D&C1&!C&!B1&B&A1&A|E&D1&D&C1&!C&!B1&B&A1&A|E&!D1&D&C1&!C&!B1&B&A1&A|E&!D1&D&!C1&!C&!B1&B&A1&A|E&D1&D&!C1&!C&!B1&B&A1&A|E&D1&!D&!C1&!C&!B1&B&A1&A|E&D1&!D&!C1&!C&!B1&B&!A1&A|E&D1&D&!C1&!C&!B1&B&!A1&A|E&!D1&D&!C1&!C&!B1&B&!A1&A|E&!D1&D&C1&!C&!B1&B&!A1&A|E&D1&D&C1&!C&!B1&B&!A1&A|E&D1&!D&C1&!C&!B1&B&!A1&A|E&D1&!D&C1&C&!B1&B&!A1&A|E&D1&D&C1&C&!B1&B&!A1&A|E&!D1&D&C1&C&!B1&B&!A1&A|E&!D1&D&!C1&C&!B1&B&!A1&A|E&D1&D&!C1&C&!B1&B&!A1&A|E&D1&!D&!C1&C&!B1&B&!A1&A|E&D1&!D&!C1&C&B1&B&!A1&A|E&D1&D&!C1&C&B1&B&!A1&A|E&!D1&D&!C1&C&B1&B&!A1&A|E&!D1&D&C1&C&B1&B&!A1&A|E&D1&D&C1&C&B1&B&!A1&A|E&D1&!D&C1&C&B1&B&!A1&A|E&D1&!D&C1&!C&B1&B&!A1&A|E&D1&D&C1&!C&B1&B&!A1&A|E&!D1&D&C1&!C&B1&B&!A1&A|E&!D1&D&!C1&!C&B1&B&!A1&A|E&D1&D&!C1&!C&B1&B&!A1&A|E&D1&!D&!C1&!C&B1&B&!A1&A|E&D1&!D&!C1&!C&B1&!B&!A1&A|E&D1&D&!C1&!C&B1&!B&!A1&A|E&!D1&D&!C1&!C&B1&!B&!A1&A|E&!D1&D&C1&!C&B1&!B&!A1&A|E&D1&D&C1&!C&B1&!B&!A1&A|E&D1&!D&C1&!C&B1&!B&!A1&A|E&D1&!D&C1&C&B1&!B&!A1&A|E&D1&D&C1&C&B1&!B&!A1&A|E&!D1&D&C1&C&B1&!B&!A1&A|E&!D1&D&!C1&C&B1&!B&!A1&A|E&D1&D&!C1&C&B1&!B&!A1&A|E&D1&!D&!C1&C&B1&!B&!A1&A|E&!D1&D&C1&C&!B1&!B&!A1&A|E&D1&D&C1&C&!B1&!B&!A1&A|E&D1&!D&C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOOAI22221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOAAOI22212 -l OOAAOAAOI22212 -i E1 E D C1 C B1 B A1 A -o Y -f Y=(!E1&!E&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D&C1&!C&!B1&!B&!A1&!A|E1&!E&D&C1&!C&!B1&!B&!A1&!A|!E1&E&D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D&C1&C&!B1&!B&!A1&!A|E1&!E&!D&C1&C&!B1&!B&!A1&!A|!E1&E&!D&C1&C&!B1&!B&!A1&!A|!E1&!E&D&!C1&C&!B1&!B&!A1&!A|E1&!E&D&!C1&C&!B1&!B&!A1&!A|!E1&E&D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D&!C1&C&B1&!B&!A1&!A|E1&!E&!D&!C1&C&B1&!B&!A1&!A|!E1&E&!D&!C1&C&B1&!B&!A1&!A|!E1&E&D&!C1&C&B1&!B&!A1&!A|E1&!E&D&!C1&C&B1&!B&!A1&!A|!E1&!E&D&!C1&C&B1&!B&!A1&!A|!E1&E&!D&C1&C&B1&!B&!A1&!A|E1&!E&!D&C1&C&B1&!B&!A1&!A|!E1&!E&!D&C1&C&B1&!B&!A1&!A|!E1&!E&!D&C1&!C&B1&!B&!A1&!A|E1&!E&!D&C1&!C&B1&!B&!A1&!A|!E1&E&!D&C1&!C&B1&!B&!A1&!A|!E1&E&D&C1&!C&B1&!B&!A1&!A|E1&!E&D&C1&!C&B1&!B&!A1&!A|!E1&!E&D&C1&!C&B1&!B&!A1&!A|!E1&!E&D&!C1&!C&B1&!B&!A1&!A|E1&!E&D&!C1&!C&B1&!B&!A1&!A|!E1&E&D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D&!C1&!C&B1&B&!A1&!A|E1&!E&!D&!C1&!C&B1&B&!A1&!A|!E1&E&!D&!C1&!C&B1&B&!A1&!A|!E1&E&D&!C1&!C&B1&B&!A1&!A|E1&!E&D&!C1&!C&B1&B&!A1&!A|!E1&!E&D&!C1&!C&B1&B&!A1&!A|!E1&!E&D&C1&!C&B1&B&!A1&!A|E1&!E&D&C1&!C&B1&B&!A1&!A|!E1&E&D&C1&!C&B1&B&!A1&!A|!E1&E&!D&C1&!C&B1&B&!A1&!A|E1&!E&!D&C1&!C&B1&B&!A1&!A|!E1&!E&!D&C1&!C&B1&B&!A1&!A|!E1&!E&!D&C1&C&B1&B&!A1&!A|E1&!E&!D&C1&C&B1&B&!A1&!A|!E1&E&!D&C1&C&B1&B&!A1&!A|!E1&!E&D&!C1&C&B1&B&!A1&!A|E1&!E&D&!C1&C&B1&B&!A1&!A|!E1&E&D&!C1&C&B1&B&!A1&!A|!E1&E&!D&!C1&C&B1&B&!A1&!A|E1&!E&!D&!C1&C&B1&B&!A1&!A|!E1&!E&!D&!C1&C&B1&B&!A1&!A|!E1&!E&!D&!C1&C&!B1&B&!A1&!A|E1&!E&!D&!C1&C&!B1&B&!A1&!A|!E1&E&!D&!C1&C&!B1&B&!A1&!A|!E1&E&D&!C1&C&!B1&B&!A1&!A|E1&!E&D&!C1&C&!B1&B&!A1&!A|!E1&!E&D&!C1&C&!B1&B&!A1&!A|!E1&E&!D&C1&C&!B1&B&!A1&!A|E1&!E&!D&C1&C&!B1&B&!A1&!A|!E1&!E&!D&C1&C&!B1&B&!A1&!A|!E1&!E&!D&C1&!C&!B1&B&!A1&!A|E1&!E&!D&C1&!C&!B1&B&!A1&!A|!E1&E&!D&C1&!C&!B1&B&!A1&!A|!E1&E&D&C1&!C&!B1&B&!A1&!A|E1&!E&D&C1&!C&!B1&B&!A1&!A|!E1&!E&D&C1&!C&!B1&B&!A1&!A|!E1&!E&D&!C1&!C&!B1&B&!A1&!A|E1&!E&D&!C1&!C&!B1&B&!A1&!A|!E1&E&D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D&!C1&!C&!B1&B&A1&!A|E1&!E&!D&!C1&!C&!B1&B&A1&!A|!E1&E&!D&!C1&!C&!B1&B&A1&!A|!E1&E&!D&C1&!C&!B1&B&A1&!A|E1&!E&!D&C1&!C&!B1&B&A1&!A|!E1&!E&!D&C1&!C&!B1&B&A1&!A|!E1&!E&!D&C1&C&!B1&B&A1&!A|E1&!E&!D&C1&C&!B1&B&A1&!A|!E1&E&!D&C1&C&!B1&B&A1&!A|!E1&E&!D&!C1&C&!B1&B&A1&!A|E1&!E&!D&!C1&C&!B1&B&A1&!A|!E1&!E&!D&!C1&C&!B1&B&A1&!A|!E1&!E&!D&!C1&C&B1&B&A1&!A|E1&!E&!D&!C1&C&B1&B&A1&!A|!E1&E&!D&!C1&C&B1&B&A1&!A|!E1&E&!D&C1&C&B1&B&A1&!A|E1&!E&!D&C1&C&B1&B&A1&!A|!E1&!E&!D&C1&C&B1&B&A1&!A|!E1&!E&!D&C1&!C&B1&B&A1&!A|E1&!E&!D&C1&!C&B1&B&A1&!A|!E1&E&!D&C1&!C&B1&B&A1&!A|!E1&E&!D&!C1&!C&B1&B&A1&!A|E1&!E&!D&!C1&!C&B1&B&A1&!A|!E1&!E&!D&!C1&!C&B1&B&A1&!A|!E1&!E&!D&!C1&!C&B1&!B&A1&!A|E1&!E&!D&!C1&!C&B1&!B&A1&!A|!E1&E&!D&!C1&!C&B1&!B&A1&!A|!E1&E&!D&C1&!C&B1&!B&A1&!A|E1&!E&!D&C1&!C&B1&!B&A1&!A|!E1&!E&!D&C1&!C&B1&!B&A1&!A|!E1&!E&!D&C1&C&B1&!B&A1&!A|E1&!E&!D&C1&C&B1&!B&A1&!A|!E1&E&!D&C1&C&B1&!B&A1&!A|!E1&E&!D&!C1&C&B1&!B&A1&!A|E1&!E&!D&!C1&C&B1&!B&A1&!A|!E1&!E&!D&!C1&C&B1&!B&A1&!A|!E1&!E&!D&!C1&C&!B1&!B&A1&!A|E1&!E&!D&!C1&C&!B1&!B&A1&!A|!E1&E&!D&!C1&C&!B1&!B&A1&!A|!E1&E&D&!C1&C&!B1&!B&A1&!A|E1&!E&D&!C1&C&!B1&!B&A1&!A|!E1&!E&D&!C1&C&!B1&!B&A1&!A|!E1&E&!D&C1&C&!B1&!B&A1&!A|E1&!E&!D&C1&C&!B1&!B&A1&!A|!E1&!E&!D&C1&C&!B1&!B&A1&!A|!E1&!E&!D&C1&!C&!B1&!B&A1&!A|E1&!E&!D&C1&!C&!B1&!B&A1&!A|!E1&E&!D&C1&!C&!B1&!B&A1&!A|!E1&E&D&C1&!C&!B1&!B&A1&!A|E1&!E&D&C1&!C&!B1&!B&A1&!A|!E1&!E&D&C1&!C&!B1&!B&A1&!A|!E1&!E&D&!C1&!C&!B1&!B&A1&!A|E1&!E&D&!C1&!C&!B1&!B&A1&!A|!E1&E&D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D&!C1&!C&!B1&!B&A1&A|E1&!E&!D&!C1&!C&!B1&!B&A1&A|!E1&E&!D&!C1&!C&!B1&!B&A1&A|!E1&E&D&!C1&!C&!B1&!B&A1&A|E1&!E&D&!C1&!C&!B1&!B&A1&A|!E1&!E&D&!C1&!C&!B1&!B&A1&A|!E1&!E&D&C1&!C&!B1&!B&A1&A|E1&!E&D&C1&!C&!B1&!B&A1&A|!E1&E&D&C1&!C&!B1&!B&A1&A|!E1&E&!D&C1&!C&!B1&!B&A1&A|E1&!E&!D&C1&!C&!B1&!B&A1&A|!E1&!E&!D&C1&!C&!B1&!B&A1&A|!E1&!E&!D&C1&C&!B1&!B&A1&A|E1&!E&!D&C1&C&!B1&!B&A1&A|!E1&E&!D&C1&C&!B1&!B&A1&A|!E1&!E&D&!C1&C&!B1&!B&A1&A|E1&!E&D&!C1&C&!B1&!B&A1&A|!E1&E&D&!C1&C&!B1&!B&A1&A|!E1&E&!D&!C1&C&!B1&!B&A1&A|E1&!E&!D&!C1&C&!B1&!B&A1&A|!E1&!E&!D&!C1&C&!B1&!B&A1&A|!E1&!E&!D&!C1&C&B1&!B&A1&A|E1&!E&!D&!C1&C&B1&!B&A1&A|!E1&E&!D&!C1&C&B1&!B&A1&A|!E1&E&!D&C1&C&B1&!B&A1&A|E1&!E&!D&C1&C&B1&!B&A1&A|!E1&!E&!D&C1&C&B1&!B&A1&A|!E1&!E&!D&C1&!C&B1&!B&A1&A|E1&!E&!D&C1&!C&B1&!B&A1&A|!E1&E&!D&C1&!C&B1&!B&A1&A|!E1&E&!D&!C1&!C&B1&!B&A1&A|E1&!E&!D&!C1&!C&B1&!B&A1&A|!E1&!E&!D&!C1&!C&B1&!B&A1&A|!E1&!E&!D&!C1&!C&B1&B&A1&A|E1&!E&!D&!C1&!C&B1&B&A1&A|!E1&E&!D&!C1&!C&B1&B&A1&A|!E1&E&!D&C1&!C&B1&B&A1&A|E1&!E&!D&C1&!C&B1&B&A1&A|!E1&!E&!D&C1&!C&B1&B&A1&A|!E1&!E&!D&C1&C&B1&B&A1&A|E1&!E&!D&C1&C&B1&B&A1&A|!E1&E&!D&C1&C&B1&B&A1&A|!E1&E&!D&!C1&C&B1&B&A1&A|E1&!E&!D&!C1&C&B1&B&A1&A|!E1&!E&!D&!C1&C&B1&B&A1&A|!E1&!E&!D&!C1&C&!B1&B&A1&A|E1&!E&!D&!C1&C&!B1&B&A1&A|!E1&E&!D&!C1&C&!B1&B&A1&A|!E1&E&!D&C1&C&!B1&B&A1&A|E1&!E&!D&C1&C&!B1&B&A1&A|!E1&!E&!D&C1&C&!B1&B&A1&A|!E1&!E&!D&C1&!C&!B1&B&A1&A|E1&!E&!D&C1&!C&!B1&B&A1&A|!E1&E&!D&C1&!C&!B1&B&A1&A|!E1&E&!D&!C1&!C&!B1&B&A1&A|E1&!E&!D&!C1&!C&!B1&B&A1&A|!E1&!E&!D&!C1&!C&!B1&B&A1&A|!E1&!E&!D&!C1&!C&!B1&B&!A1&A|E1&!E&!D&!C1&!C&!B1&B&!A1&A|!E1&E&!D&!C1&!C&!B1&B&!A1&A|!E1&E&!D&C1&!C&!B1&B&!A1&A|E1&!E&!D&C1&!C&!B1&B&!A1&A|!E1&!E&!D&C1&!C&!B1&B&!A1&A|!E1&!E&!D&C1&C&!B1&B&!A1&A|E1&!E&!D&C1&C&!B1&B&!A1&A|!E1&E&!D&C1&C&!B1&B&!A1&A|!E1&E&!D&!C1&C&!B1&B&!A1&A|E1&!E&!D&!C1&C&!B1&B&!A1&A|!E1&!E&!D&!C1&C&!B1&B&!A1&A|!E1&!E&!D&!C1&C&B1&B&!A1&A|E1&!E&!D&!C1&C&B1&B&!A1&A|!E1&E&!D&!C1&C&B1&B&!A1&A|!E1&E&!D&C1&C&B1&B&!A1&A|E1&!E&!D&C1&C&B1&B&!A1&A|!E1&!E&!D&C1&C&B1&B&!A1&A|!E1&!E&!D&C1&!C&B1&B&!A1&A|E1&!E&!D&C1&!C&B1&B&!A1&A|!E1&E&!D&C1&!C&B1&B&!A1&A|!E1&E&!D&!C1&!C&B1&B&!A1&A|E1&!E&!D&!C1&!C&B1&B&!A1&A|!E1&!E&!D&!C1&!C&B1&B&!A1&A|!E1&!E&!D&!C1&!C&B1&!B&!A1&A|E1&!E&!D&!C1&!C&B1&!B&!A1&A|!E1&E&!D&!C1&!C&B1&!B&!A1&A|!E1&E&!D&C1&!C&B1&!B&!A1&A|E1&!E&!D&C1&!C&B1&!B&!A1&A|!E1&!E&!D&C1&!C&B1&!B&!A1&A|!E1&!E&!D&C1&C&B1&!B&!A1&A|E1&!E&!D&C1&C&B1&!B&!A1&A|!E1&E&!D&C1&C&B1&!B&!A1&A|!E1&E&!D&!C1&C&B1&!B&!A1&A|E1&!E&!D&!C1&C&B1&!B&!A1&A|!E1&!E&!D&!C1&C&B1&!B&!A1&A|!E1&!E&!D&!C1&C&!B1&!B&!A1&A|E1&!E&!D&!C1&C&!B1&!B&!A1&A|!E1&E&!D&!C1&C&!B1&!B&!A1&A|!E1&E&D&!C1&C&!B1&!B&!A1&A|E1&!E&D&!C1&C&!B1&!B&!A1&A|!E1&!E&D&!C1&C&!B1&!B&!A1&A|!E1&E&!D&C1&C&!B1&!B&!A1&A|E1&!E&!D&C1&C&!B1&!B&!A1&A|!E1&!E&!D&C1&C&!B1&!B&!A1&A|!E1&!E&!D&C1&!C&!B1&!B&!A1&A|E1&!E&!D&C1&!C&!B1&!B&!A1&A|!E1&E&!D&C1&!C&!B1&!B&!A1&A|!E1&E&D&C1&!C&!B1&!B&!A1&A|E1&!E&D&C1&!C&!B1&!B&!A1&A|!E1&!E&D&C1&!C&!B1&!B&!A1&A|!E1&!E&D&!C1&!C&!B1&!B&!A1&A|E1&!E&D&!C1&!C&!B1&!B&!A1&A|!E1&E&D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D&!C1&!C&!B1&!B&!A1&A|!E1&!E&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOAAOI22212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAAOI3322 -l AAAAOI3322 -i D1 D C1 C B2 B1 B A2 A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&!C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C1&C&B2&!B1&!B&!A2&!A1&!A|D1&!D&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&D&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&!D&C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&D&C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&D&!C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&!D&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C1&!C&B2&B1&!B&!A2&!A1&!A|D1&!D&!C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&D&!C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&D&C1&!C&B2&B1&!B&!A2&!A1&!A|D1&!D&C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&!D&C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&D&!C1&C&B2&B1&!B&!A2&!A1&!A|D1&!D&!C1&C&B2&B1&!B&!A2&!A1&!A|!D1&!D&!C1&C&B2&B1&!B&!A2&!A1&!A|!D1&!D&!C1&C&!B2&B1&!B&!A2&!A1&!A|D1&!D&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&D&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&!D&C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&D&C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&D&!C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&!D&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&!C1&!C&!B2&B1&B&!A2&!A1&!A|D1&!D&!C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&D&!C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&D&C1&!C&!B2&B1&B&!A2&!A1&!A|D1&!D&C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&!D&C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&D&!C1&C&!B2&B1&B&!A2&!A1&!A|D1&!D&!C1&C&!B2&B1&B&!A2&!A1&!A|!D1&!D&!C1&C&!B2&B1&B&!A2&!A1&!A|!D1&!D&!C1&!C&B2&!B1&B&!A2&!A1&!A|D1&!D&!C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&D&!C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&D&C1&!C&B2&!B1&B&!A2&!A1&!A|D1&!D&C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&!D&C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&D&!C1&C&B2&!B1&B&!A2&!A1&!A|D1&!D&!C1&C&B2&!B1&B&!A2&!A1&!A|!D1&!D&!C1&C&B2&!B1&B&!A2&!A1&!A|!D1&!D&!C1&C&!B2&!B1&B&!A2&!A1&!A|D1&!D&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&D&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&!D&C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&D&C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&D&!C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&!D&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&!C1&!C&!B2&!B1&B&A2&!A1&!A|D1&!D&!C1&!C&!B2&!B1&B&A2&!A1&!A|!D1&D&!C1&!C&!B2&!B1&B&A2&!A1&!A|!D1&D&C1&!C&!B2&!B1&B&A2&!A1&!A|D1&!D&C1&!C&!B2&!B1&B&A2&!A1&!A|!D1&!D&C1&!C&!B2&!B1&B&A2&!A1&!A|!D1&D&!C1&C&!B2&!B1&B&A2&!A1&!A|D1&!D&!C1&C&!B2&!B1&B&A2&!A1&!A|!D1&!D&!C1&C&!B2&!B1&B&A2&!A1&!A|!D1&!D&!C1&C&B2&!B1&B&A2&!A1&!A|D1&!D&!C1&C&B2&!B1&B&A2&!A1&!A|!D1&D&!C1&C&B2&!B1&B&A2&!A1&!A|!D1&!D&C1&!C&B2&!B1&B&A2&!A1&!A|D1&!D&C1&!C&B2&!B1&B&A2&!A1&!A|!D1&D&C1&!C&B2&!B1&B&A2&!A1&!A|!D1&D&!C1&!C&B2&!B1&B&A2&!A1&!A|D1&!D&!C1&!C&B2&!B1&B&A2&!A1&!A|!D1&!D&!C1&!C&B2&!B1&B&A2&!A1&!A|!D1&!D&!C1&C&!B2&B1&B&A2&!A1&!A|D1&!D&!C1&C&!B2&B1&B&A2&!A1&!A|!D1&D&!C1&C&!B2&B1&B&A2&!A1&!A|!D1&!D&C1&!C&!B2&B1&B&A2&!A1&!A|D1&!D&C1&!C&!B2&B1&B&A2&!A1&!A|!D1&D&C1&!C&!B2&B1&B&A2&!A1&!A|!D1&D&!C1&!C&!B2&B1&B&A2&!A1&!A|D1&!D&!C1&!C&!B2&B1&B&A2&!A1&!A|!D1&!D&!C1&!C&!B2&B1&B&A2&!A1&!A|!D1&!D&!C1&!C&!B2&B1&!B&A2&!A1&!A|D1&!D&!C1&!C&!B2&B1&!B&A2&!A1&!A|!D1&D&!C1&!C&!B2&B1&!B&A2&!A1&!A|!D1&D&C1&!C&!B2&B1&!B&A2&!A1&!A|D1&!D&C1&!C&!B2&B1&!B&A2&!A1&!A|!D1&!D&C1&!C&!B2&B1&!B&A2&!A1&!A|!D1&D&!C1&C&!B2&B1&!B&A2&!A1&!A|D1&!D&!C1&C&!B2&B1&!B&A2&!A1&!A|!D1&!D&!C1&C&!B2&B1&!B&A2&!A1&!A|!D1&!D&!C1&C&B2&B1&!B&A2&!A1&!A|D1&!D&!C1&C&B2&B1&!B&A2&!A1&!A|!D1&D&!C1&C&B2&B1&!B&A2&!A1&!A|!D1&!D&C1&!C&B2&B1&!B&A2&!A1&!A|D1&!D&C1&!C&B2&B1&!B&A2&!A1&!A|!D1&D&C1&!C&B2&B1&!B&A2&!A1&!A|!D1&D&!C1&!C&B2&B1&!B&A2&!A1&!A|D1&!D&!C1&!C&B2&B1&!B&A2&!A1&!A|!D1&!D&!C1&!C&B2&B1&!B&A2&!A1&!A|!D1&!D&!C1&!C&B2&!B1&!B&A2&!A1&!A|D1&!D&!C1&!C&B2&!B1&!B&A2&!A1&!A|!D1&D&!C1&!C&B2&!B1&!B&A2&!A1&!A|!D1&D&C1&!C&B2&!B1&!B&A2&!A1&!A|D1&!D&C1&!C&B2&!B1&!B&A2&!A1&!A|!D1&!D&C1&!C&B2&!B1&!B&A2&!A1&!A|!D1&D&!C1&C&B2&!B1&!B&A2&!A1&!A|D1&!D&!C1&C&B2&!B1&!B&A2&!A1&!A|!D1&!D&!C1&C&B2&!B1&!B&A2&!A1&!A|!D1&!D&!C1&C&!B2&!B1&!B&A2&!A1&!A|D1&!D&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&D&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&!D&C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&D&C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&D&!C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&!D&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&!C1&!C&!B2&!B1&!B&A2&A1&!A|D1&!D&!C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&D&!C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&D&C1&!C&!B2&!B1&!B&A2&A1&!A|D1&!D&C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&!D&C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&D&!C1&C&!B2&!B1&!B&A2&A1&!A|D1&!D&!C1&C&!B2&!B1&!B&A2&A1&!A|!D1&!D&!C1&C&!B2&!B1&!B&A2&A1&!A|!D1&!D&!C1&C&B2&!B1&!B&A2&A1&!A|D1&!D&!C1&C&B2&!B1&!B&A2&A1&!A|!D1&D&!C1&C&B2&!B1&!B&A2&A1&!A|!D1&!D&C1&!C&B2&!B1&!B&A2&A1&!A|D1&!D&C1&!C&B2&!B1&!B&A2&A1&!A|!D1&D&C1&!C&B2&!B1&!B&A2&A1&!A|!D1&D&!C1&!C&B2&!B1&!B&A2&A1&!A|D1&!D&!C1&!C&B2&!B1&!B&A2&A1&!A|!D1&!D&!C1&!C&B2&!B1&!B&A2&A1&!A|!D1&!D&!C1&!C&B2&B1&!B&A2&A1&!A|D1&!D&!C1&!C&B2&B1&!B&A2&A1&!A|!D1&D&!C1&!C&B2&B1&!B&A2&A1&!A|!D1&D&C1&!C&B2&B1&!B&A2&A1&!A|D1&!D&C1&!C&B2&B1&!B&A2&A1&!A|!D1&!D&C1&!C&B2&B1&!B&A2&A1&!A|!D1&D&!C1&C&B2&B1&!B&A2&A1&!A|D1&!D&!C1&C&B2&B1&!B&A2&A1&!A|!D1&!D&!C1&C&B2&B1&!B&A2&A1&!A|!D1&!D&!C1&C&!B2&B1&!B&A2&A1&!A|D1&!D&!C1&C&!B2&B1&!B&A2&A1&!A|!D1&D&!C1&C&!B2&B1&!B&A2&A1&!A|!D1&!D&C1&!C&!B2&B1&!B&A2&A1&!A|D1&!D&C1&!C&!B2&B1&!B&A2&A1&!A|!D1&D&C1&!C&!B2&B1&!B&A2&A1&!A|!D1&D&!C1&!C&!B2&B1&!B&A2&A1&!A|D1&!D&!C1&!C&!B2&B1&!B&A2&A1&!A|!D1&!D&!C1&!C&!B2&B1&!B&A2&A1&!A|!D1&!D&!C1&!C&!B2&B1&B&A2&A1&!A|D1&!D&!C1&!C&!B2&B1&B&A2&A1&!A|!D1&D&!C1&!C&!B2&B1&B&A2&A1&!A|!D1&D&C1&!C&!B2&B1&B&A2&A1&!A|D1&!D&C1&!C&!B2&B1&B&A2&A1&!A|!D1&!D&C1&!C&!B2&B1&B&A2&A1&!A|!D1&D&!C1&C&!B2&B1&B&A2&A1&!A|D1&!D&!C1&C&!B2&B1&B&A2&A1&!A|!D1&!D&!C1&C&!B2&B1&B&A2&A1&!A|!D1&!D&!C1&!C&B2&!B1&B&A2&A1&!A|D1&!D&!C1&!C&B2&!B1&B&A2&A1&!A|!D1&D&!C1&!C&B2&!B1&B&A2&A1&!A|!D1&D&C1&!C&B2&!B1&B&A2&A1&!A|D1&!D&C1&!C&B2&!B1&B&A2&A1&!A|!D1&!D&C1&!C&B2&!B1&B&A2&A1&!A|!D1&D&!C1&C&B2&!B1&B&A2&A1&!A|D1&!D&!C1&C&B2&!B1&B&A2&A1&!A|!D1&!D&!C1&C&B2&!B1&B&A2&A1&!A|!D1&!D&!C1&C&!B2&!B1&B&A2&A1&!A|D1&!D&!C1&C&!B2&!B1&B&A2&A1&!A|!D1&D&!C1&C&!B2&!B1&B&A2&A1&!A|!D1&!D&C1&!C&!B2&!B1&B&A2&A1&!A|D1&!D&C1&!C&!B2&!B1&B&A2&A1&!A|!D1&D&C1&!C&!B2&!B1&B&A2&A1&!A|!D1&D&!C1&!C&!B2&!B1&B&A2&A1&!A|D1&!D&!C1&!C&!B2&!B1&B&A2&A1&!A|!D1&!D&!C1&!C&!B2&!B1&B&A2&A1&!A|!D1&!D&!C1&!C&!B2&!B1&B&!A2&A1&!A|D1&!D&!C1&!C&!B2&!B1&B&!A2&A1&!A|!D1&D&!C1&!C&!B2&!B1&B&!A2&A1&!A|!D1&D&C1&!C&!B2&!B1&B&!A2&A1&!A|D1&!D&C1&!C&!B2&!B1&B&!A2&A1&!A|!D1&!D&C1&!C&!B2&!B1&B&!A2&A1&!A|!D1&D&!C1&C&!B2&!B1&B&!A2&A1&!A|D1&!D&!C1&C&!B2&!B1&B&!A2&A1&!A|!D1&!D&!C1&C&!B2&!B1&B&!A2&A1&!A|!D1&!D&!C1&C&B2&!B1&B&!A2&A1&!A|D1&!D&!C1&C&B2&!B1&B&!A2&A1&!A|!D1&D&!C1&C&B2&!B1&B&!A2&A1&!A|!D1&!D&C1&!C&B2&!B1&B&!A2&A1&!A|D1&!D&C1&!C&B2&!B1&B&!A2&A1&!A|!D1&D&C1&!C&B2&!B1&B&!A2&A1&!A|!D1&D&!C1&!C&B2&!B1&B&!A2&A1&!A|D1&!D&!C1&!C&B2&!B1&B&!A2&A1&!A|!D1&!D&!C1&!C&B2&!B1&B&!A2&A1&!A|!D1&!D&!C1&C&!B2&B1&B&!A2&A1&!A|D1&!D&!C1&C&!B2&B1&B&!A2&A1&!A|!D1&D&!C1&C&!B2&B1&B&!A2&A1&!A|!D1&!D&C1&!C&!B2&B1&B&!A2&A1&!A|D1&!D&C1&!C&!B2&B1&B&!A2&A1&!A|!D1&D&C1&!C&!B2&B1&B&!A2&A1&!A|!D1&D&!C1&!C&!B2&B1&B&!A2&A1&!A|D1&!D&!C1&!C&!B2&B1&B&!A2&A1&!A|!D1&!D&!C1&!C&!B2&B1&B&!A2&A1&!A|!D1&!D&!C1&!C&!B2&B1&!B&!A2&A1&!A|D1&!D&!C1&!C&!B2&B1&!B&!A2&A1&!A|!D1&D&!C1&!C&!B2&B1&!B&!A2&A1&!A|!D1&D&C1&!C&!B2&B1&!B&!A2&A1&!A|D1&!D&C1&!C&!B2&B1&!B&!A2&A1&!A|!D1&!D&C1&!C&!B2&B1&!B&!A2&A1&!A|!D1&D&!C1&C&!B2&B1&!B&!A2&A1&!A|D1&!D&!C1&C&!B2&B1&!B&!A2&A1&!A|!D1&!D&!C1&C&!B2&B1&!B&!A2&A1&!A|!D1&!D&!C1&C&B2&B1&!B&!A2&A1&!A|D1&!D&!C1&C&B2&B1&!B&!A2&A1&!A|!D1&D&!C1&C&B2&B1&!B&!A2&A1&!A|!D1&!D&C1&!C&B2&B1&!B&!A2&A1&!A|D1&!D&C1&!C&B2&B1&!B&!A2&A1&!A|!D1&D&C1&!C&B2&B1&!B&!A2&A1&!A|!D1&D&!C1&!C&B2&B1&!B&!A2&A1&!A|D1&!D&!C1&!C&B2&B1&!B&!A2&A1&!A|!D1&!D&!C1&!C&B2&B1&!B&!A2&A1&!A|!D1&!D&!C1&!C&B2&!B1&!B&!A2&A1&!A|D1&!D&!C1&!C&B2&!B1&!B&!A2&A1&!A|!D1&D&!C1&!C&B2&!B1&!B&!A2&A1&!A|!D1&D&C1&!C&B2&!B1&!B&!A2&A1&!A|D1&!D&C1&!C&B2&!B1&!B&!A2&A1&!A|!D1&!D&C1&!C&B2&!B1&!B&!A2&A1&!A|!D1&D&!C1&C&B2&!B1&!B&!A2&A1&!A|D1&!D&!C1&C&B2&!B1&!B&!A2&A1&!A|!D1&!D&!C1&C&B2&!B1&!B&!A2&A1&!A|!D1&!D&!C1&C&!B2&!B1&!B&!A2&A1&!A|D1&!D&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&D&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&!D&C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&D&C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&D&!C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&!D&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&!C1&!C&!B2&!B1&!B&!A2&A1&A|D1&!D&!C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&D&!C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&D&C1&!C&!B2&!B1&!B&!A2&A1&A|D1&!D&C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&!D&C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&D&!C1&C&!B2&!B1&!B&!A2&A1&A|D1&!D&!C1&C&!B2&!B1&!B&!A2&A1&A|!D1&!D&!C1&C&!B2&!B1&!B&!A2&A1&A|!D1&!D&!C1&C&B2&!B1&!B&!A2&A1&A|D1&!D&!C1&C&B2&!B1&!B&!A2&A1&A|!D1&D&!C1&C&B2&!B1&!B&!A2&A1&A|!D1&!D&C1&!C&B2&!B1&!B&!A2&A1&A|D1&!D&C1&!C&B2&!B1&!B&!A2&A1&A|!D1&D&C1&!C&B2&!B1&!B&!A2&A1&A|!D1&D&!C1&!C&B2&!B1&!B&!A2&A1&A|D1&!D&!C1&!C&B2&!B1&!B&!A2&A1&A|!D1&!D&!C1&!C&B2&!B1&!B&!A2&A1&A|!D1&!D&!C1&!C&B2&B1&!B&!A2&A1&A|D1&!D&!C1&!C&B2&B1&!B&!A2&A1&A|!D1&D&!C1&!C&B2&B1&!B&!A2&A1&A|!D1&D&C1&!C&B2&B1&!B&!A2&A1&A|D1&!D&C1&!C&B2&B1&!B&!A2&A1&A|!D1&!D&C1&!C&B2&B1&!B&!A2&A1&A|!D1&D&!C1&C&B2&B1&!B&!A2&A1&A|D1&!D&!C1&C&B2&B1&!B&!A2&A1&A|!D1&!D&!C1&C&B2&B1&!B&!A2&A1&A|!D1&!D&!C1&C&!B2&B1&!B&!A2&A1&A|D1&!D&!C1&C&!B2&B1&!B&!A2&A1&A|!D1&D&!C1&C&!B2&B1&!B&!A2&A1&A|!D1&!D&C1&!C&!B2&B1&!B&!A2&A1&A|D1&!D&C1&!C&!B2&B1&!B&!A2&A1&A|!D1&D&C1&!C&!B2&B1&!B&!A2&A1&A|!D1&D&!C1&!C&!B2&B1&!B&!A2&A1&A|D1&!D&!C1&!C&!B2&B1&!B&!A2&A1&A|!D1&!D&!C1&!C&!B2&B1&!B&!A2&A1&A|!D1&!D&!C1&!C&!B2&B1&B&!A2&A1&A|D1&!D&!C1&!C&!B2&B1&B&!A2&A1&A|!D1&D&!C1&!C&!B2&B1&B&!A2&A1&A|!D1&D&C1&!C&!B2&B1&B&!A2&A1&A|D1&!D&C1&!C&!B2&B1&B&!A2&A1&A|!D1&!D&C1&!C&!B2&B1&B&!A2&A1&A|!D1&D&!C1&C&!B2&B1&B&!A2&A1&A|D1&!D&!C1&C&!B2&B1&B&!A2&A1&A|!D1&!D&!C1&C&!B2&B1&B&!A2&A1&A|!D1&!D&!C1&!C&B2&!B1&B&!A2&A1&A|D1&!D&!C1&!C&B2&!B1&B&!A2&A1&A|!D1&D&!C1&!C&B2&!B1&B&!A2&A1&A|!D1&D&C1&!C&B2&!B1&B&!A2&A1&A|D1&!D&C1&!C&B2&!B1&B&!A2&A1&A|!D1&!D&C1&!C&B2&!B1&B&!A2&A1&A|!D1&D&!C1&C&B2&!B1&B&!A2&A1&A|D1&!D&!C1&C&B2&!B1&B&!A2&A1&A|!D1&!D&!C1&C&B2&!B1&B&!A2&A1&A|!D1&!D&!C1&C&!B2&!B1&B&!A2&A1&A|D1&!D&!C1&C&!B2&!B1&B&!A2&A1&A|!D1&D&!C1&C&!B2&!B1&B&!A2&A1&A|!D1&!D&C1&!C&!B2&!B1&B&!A2&A1&A|D1&!D&C1&!C&!B2&!B1&B&!A2&A1&A|!D1&D&C1&!C&!B2&!B1&B&!A2&A1&A|!D1&D&!C1&!C&!B2&!B1&B&!A2&A1&A|D1&!D&!C1&!C&!B2&!B1&B&!A2&A1&A|!D1&!D&!C1&!C&!B2&!B1&B&!A2&A1&A|!D1&!D&!C1&!C&!B2&!B1&!B&A2&!A1&A|D1&!D&!C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&D&!C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&D&C1&!C&!B2&!B1&!B&A2&!A1&A|D1&!D&C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&!D&C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&D&!C1&C&!B2&!B1&!B&A2&!A1&A|D1&!D&!C1&C&!B2&!B1&!B&A2&!A1&A|!D1&!D&!C1&C&!B2&!B1&!B&A2&!A1&A|!D1&!D&!C1&C&B2&!B1&!B&A2&!A1&A|D1&!D&!C1&C&B2&!B1&!B&A2&!A1&A|!D1&D&!C1&C&B2&!B1&!B&A2&!A1&A|!D1&!D&C1&!C&B2&!B1&!B&A2&!A1&A|D1&!D&C1&!C&B2&!B1&!B&A2&!A1&A|!D1&D&C1&!C&B2&!B1&!B&A2&!A1&A|!D1&D&!C1&!C&B2&!B1&!B&A2&!A1&A|D1&!D&!C1&!C&B2&!B1&!B&A2&!A1&A|!D1&!D&!C1&!C&B2&!B1&!B&A2&!A1&A|!D1&!D&!C1&!C&B2&B1&!B&A2&!A1&A|D1&!D&!C1&!C&B2&B1&!B&A2&!A1&A|!D1&D&!C1&!C&B2&B1&!B&A2&!A1&A|!D1&D&C1&!C&B2&B1&!B&A2&!A1&A|D1&!D&C1&!C&B2&B1&!B&A2&!A1&A|!D1&!D&C1&!C&B2&B1&!B&A2&!A1&A|!D1&D&!C1&C&B2&B1&!B&A2&!A1&A|D1&!D&!C1&C&B2&B1&!B&A2&!A1&A|!D1&!D&!C1&C&B2&B1&!B&A2&!A1&A|!D1&!D&!C1&C&!B2&B1&!B&A2&!A1&A|D1&!D&!C1&C&!B2&B1&!B&A2&!A1&A|!D1&D&!C1&C&!B2&B1&!B&A2&!A1&A|!D1&!D&C1&!C&!B2&B1&!B&A2&!A1&A|D1&!D&C1&!C&!B2&B1&!B&A2&!A1&A|!D1&D&C1&!C&!B2&B1&!B&A2&!A1&A|!D1&D&!C1&!C&!B2&B1&!B&A2&!A1&A|D1&!D&!C1&!C&!B2&B1&!B&A2&!A1&A|!D1&!D&!C1&!C&!B2&B1&!B&A2&!A1&A|!D1&!D&!C1&!C&!B2&B1&B&A2&!A1&A|D1&!D&!C1&!C&!B2&B1&B&A2&!A1&A|!D1&D&!C1&!C&!B2&B1&B&A2&!A1&A|!D1&D&C1&!C&!B2&B1&B&A2&!A1&A|D1&!D&C1&!C&!B2&B1&B&A2&!A1&A|!D1&!D&C1&!C&!B2&B1&B&A2&!A1&A|!D1&D&!C1&C&!B2&B1&B&A2&!A1&A|D1&!D&!C1&C&!B2&B1&B&A2&!A1&A|!D1&!D&!C1&C&!B2&B1&B&A2&!A1&A|!D1&!D&!C1&!C&B2&!B1&B&A2&!A1&A|D1&!D&!C1&!C&B2&!B1&B&A2&!A1&A|!D1&D&!C1&!C&B2&!B1&B&A2&!A1&A|!D1&D&C1&!C&B2&!B1&B&A2&!A1&A|D1&!D&C1&!C&B2&!B1&B&A2&!A1&A|!D1&!D&C1&!C&B2&!B1&B&A2&!A1&A|!D1&D&!C1&C&B2&!B1&B&A2&!A1&A|D1&!D&!C1&C&B2&!B1&B&A2&!A1&A|!D1&!D&!C1&C&B2&!B1&B&A2&!A1&A|!D1&!D&!C1&C&!B2&!B1&B&A2&!A1&A|D1&!D&!C1&C&!B2&!B1&B&A2&!A1&A|!D1&D&!C1&C&!B2&!B1&B&A2&!A1&A|!D1&!D&C1&!C&!B2&!B1&B&A2&!A1&A|D1&!D&C1&!C&!B2&!B1&B&A2&!A1&A|!D1&D&C1&!C&!B2&!B1&B&A2&!A1&A|!D1&D&!C1&!C&!B2&!B1&B&A2&!A1&A|D1&!D&!C1&!C&!B2&!B1&B&A2&!A1&A|!D1&!D&!C1&!C&!B2&!B1&B&A2&!A1&A|!D1&!D&!C1&!C&!B2&!B1&B&!A2&!A1&A|D1&!D&!C1&!C&!B2&!B1&B&!A2&!A1&A|!D1&D&!C1&!C&!B2&!B1&B&!A2&!A1&A|!D1&D&C1&!C&!B2&!B1&B&!A2&!A1&A|D1&!D&C1&!C&!B2&!B1&B&!A2&!A1&A|!D1&!D&C1&!C&!B2&!B1&B&!A2&!A1&A|!D1&D&!C1&C&!B2&!B1&B&!A2&!A1&A|D1&!D&!C1&C&!B2&!B1&B&!A2&!A1&A|!D1&!D&!C1&C&!B2&!B1&B&!A2&!A1&A|!D1&!D&!C1&C&B2&!B1&B&!A2&!A1&A|D1&!D&!C1&C&B2&!B1&B&!A2&!A1&A|!D1&D&!C1&C&B2&!B1&B&!A2&!A1&A|!D1&!D&C1&!C&B2&!B1&B&!A2&!A1&A|D1&!D&C1&!C&B2&!B1&B&!A2&!A1&A|!D1&D&C1&!C&B2&!B1&B&!A2&!A1&A|!D1&D&!C1&!C&B2&!B1&B&!A2&!A1&A|D1&!D&!C1&!C&B2&!B1&B&!A2&!A1&A|!D1&!D&!C1&!C&B2&!B1&B&!A2&!A1&A|!D1&!D&!C1&C&!B2&B1&B&!A2&!A1&A|D1&!D&!C1&C&!B2&B1&B&!A2&!A1&A|!D1&D&!C1&C&!B2&B1&B&!A2&!A1&A|!D1&!D&C1&!C&!B2&B1&B&!A2&!A1&A|D1&!D&C1&!C&!B2&B1&B&!A2&!A1&A|!D1&D&C1&!C&!B2&B1&B&!A2&!A1&A|!D1&D&!C1&!C&!B2&B1&B&!A2&!A1&A|D1&!D&!C1&!C&!B2&B1&B&!A2&!A1&A|!D1&!D&!C1&!C&!B2&B1&B&!A2&!A1&A|!D1&!D&!C1&!C&!B2&B1&!B&!A2&!A1&A|D1&!D&!C1&!C&!B2&B1&!B&!A2&!A1&A|!D1&D&!C1&!C&!B2&B1&!B&!A2&!A1&A|!D1&D&C1&!C&!B2&B1&!B&!A2&!A1&A|D1&!D&C1&!C&!B2&B1&!B&!A2&!A1&A|!D1&!D&C1&!C&!B2&B1&!B&!A2&!A1&A|!D1&D&!C1&C&!B2&B1&!B&!A2&!A1&A|D1&!D&!C1&C&!B2&B1&!B&!A2&!A1&A|!D1&!D&!C1&C&!B2&B1&!B&!A2&!A1&A|!D1&!D&!C1&C&B2&B1&!B&!A2&!A1&A|D1&!D&!C1&C&B2&B1&!B&!A2&!A1&A|!D1&D&!C1&C&B2&B1&!B&!A2&!A1&A|!D1&!D&C1&!C&B2&B1&!B&!A2&!A1&A|D1&!D&C1&!C&B2&B1&!B&!A2&!A1&A|!D1&D&C1&!C&B2&B1&!B&!A2&!A1&A|!D1&D&!C1&!C&B2&B1&!B&!A2&!A1&A|D1&!D&!C1&!C&B2&B1&!B&!A2&!A1&A|!D1&!D&!C1&!C&B2&B1&!B&!A2&!A1&A|!D1&!D&!C1&!C&B2&!B1&!B&!A2&!A1&A|D1&!D&!C1&!C&B2&!B1&!B&!A2&!A1&A|!D1&D&!C1&!C&B2&!B1&!B&!A2&!A1&A|!D1&D&C1&!C&B2&!B1&!B&!A2&!A1&A|D1&!D&C1&!C&B2&!B1&!B&!A2&!A1&A|!D1&!D&C1&!C&B2&!B1&!B&!A2&!A1&A|!D1&D&!C1&C&B2&!B1&!B&!A2&!A1&A|D1&!D&!C1&C&B2&!B1&!B&!A2&!A1&A|!D1&!D&!C1&C&B2&!B1&!B&!A2&!A1&A|!D1&!D&!C1&C&!B2&!B1&!B&!A2&!A1&A|D1&!D&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&D&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&C1&!C&!B2&!B1&!B&!A2&!A1&A|D1&!D&C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&D&C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&D&!C1&!C&!B2&!B1&!B&!A2&!A1&A|D1&!D&!C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAAOI3322.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOOAI22132 -l AAOAAOOAI22132 -i E1 E D2 D1 D C B1 B A1 A -o Y -f Y=!(!E1&E&D2&D1&D&!C&!B1&!B&!A1&!A|E1&E&D2&D1&D&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&C&!B1&!B&!A1&!A|E1&E&D2&D1&D&C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&C&B1&!B&!A1&!A|E1&E&D2&D1&D&C&B1&!B&!A1&!A|E1&!E&D2&D1&D&C&B1&!B&!A1&!A|E1&!E&D2&D1&D&!C&B1&!B&!A1&!A|E1&E&D2&D1&D&!C&B1&!B&!A1&!A|!E1&E&D2&D1&D&!C&B1&!B&!A1&!A|!E1&E&D2&D1&D&!C&B1&B&!A1&!A|E1&E&D2&D1&D&!C&B1&B&!A1&!A|E1&!E&D2&D1&D&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&D&C&B1&B&!A1&!A|E1&E&!D2&!D1&D&C&B1&B&!A1&!A|!E1&E&!D2&!D1&D&C&B1&B&!A1&!A|!E1&E&D2&!D1&D&C&B1&B&!A1&!A|E1&E&D2&!D1&D&C&B1&B&!A1&!A|E1&!E&D2&!D1&D&C&B1&B&!A1&!A|E1&!E&D2&D1&D&C&B1&B&!A1&!A|E1&E&D2&D1&D&C&B1&B&!A1&!A|!E1&E&D2&D1&D&C&B1&B&!A1&!A|!E1&E&!D2&D1&D&C&B1&B&!A1&!A|E1&E&!D2&D1&D&C&B1&B&!A1&!A|E1&!E&!D2&D1&D&C&B1&B&!A1&!A|E1&!E&!D2&D1&!D&C&B1&B&!A1&!A|E1&E&!D2&D1&!D&C&B1&B&!A1&!A|!E1&E&!D2&D1&!D&C&B1&B&!A1&!A|!E1&E&D2&D1&!D&C&B1&B&!A1&!A|E1&E&D2&D1&!D&C&B1&B&!A1&!A|E1&!E&D2&D1&!D&C&B1&B&!A1&!A|E1&!E&D2&!D1&!D&C&B1&B&!A1&!A|E1&E&D2&!D1&!D&C&B1&B&!A1&!A|!E1&E&D2&!D1&!D&C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C&B1&B&!A1&!A|E1&E&!D2&!D1&!D&C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C&B1&B&!A1&!A|!E1&E&D2&D1&D&C&!B1&B&!A1&!A|E1&E&D2&D1&D&C&!B1&B&!A1&!A|E1&!E&D2&D1&D&C&!B1&B&!A1&!A|E1&!E&D2&D1&D&!C&!B1&B&!A1&!A|E1&E&D2&D1&D&!C&!B1&B&!A1&!A|!E1&E&D2&D1&D&!C&!B1&B&!A1&!A|!E1&E&D2&D1&D&!C&!B1&B&A1&!A|E1&E&D2&D1&D&!C&!B1&B&A1&!A|E1&!E&D2&D1&D&!C&!B1&B&A1&!A|E1&!E&D2&D1&D&C&!B1&B&A1&!A|E1&E&D2&D1&D&C&!B1&B&A1&!A|!E1&E&D2&D1&D&C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&C&B1&B&A1&!A|E1&E&!D2&!D1&!D&C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&C&B1&B&A1&!A|!E1&E&D2&!D1&!D&C&B1&B&A1&!A|E1&E&D2&!D1&!D&C&B1&B&A1&!A|E1&!E&D2&!D1&!D&C&B1&B&A1&!A|E1&!E&D2&D1&!D&C&B1&B&A1&!A|E1&E&D2&D1&!D&C&B1&B&A1&!A|!E1&E&D2&D1&!D&C&B1&B&A1&!A|!E1&E&!D2&D1&!D&C&B1&B&A1&!A|E1&E&!D2&D1&!D&C&B1&B&A1&!A|E1&!E&!D2&D1&!D&C&B1&B&A1&!A|E1&!E&!D2&D1&D&C&B1&B&A1&!A|E1&E&!D2&D1&D&C&B1&B&A1&!A|!E1&E&!D2&D1&D&C&B1&B&A1&!A|!E1&E&D2&D1&D&C&B1&B&A1&!A|E1&E&D2&D1&D&C&B1&B&A1&!A|E1&!E&D2&D1&D&C&B1&B&A1&!A|E1&!E&D2&!D1&D&C&B1&B&A1&!A|E1&E&D2&!D1&D&C&B1&B&A1&!A|!E1&E&D2&!D1&D&C&B1&B&A1&!A|!E1&E&!D2&!D1&D&C&B1&B&A1&!A|E1&E&!D2&!D1&D&C&B1&B&A1&!A|E1&!E&!D2&!D1&D&C&B1&B&A1&!A|E1&!E&D2&D1&D&!C&B1&B&A1&!A|E1&E&D2&D1&D&!C&B1&B&A1&!A|!E1&E&D2&D1&D&!C&B1&B&A1&!A|!E1&E&D2&D1&D&!C&B1&!B&A1&!A|E1&E&D2&D1&D&!C&B1&!B&A1&!A|E1&!E&D2&D1&D&!C&B1&!B&A1&!A|E1&!E&D2&D1&D&C&B1&!B&A1&!A|E1&E&D2&D1&D&C&B1&!B&A1&!A|!E1&E&D2&D1&D&C&B1&!B&A1&!A|!E1&E&D2&D1&D&C&!B1&!B&A1&!A|E1&E&D2&D1&D&C&!B1&!B&A1&!A|E1&!E&D2&D1&D&C&!B1&!B&A1&!A|E1&!E&D2&D1&D&!C&!B1&!B&A1&!A|E1&E&D2&D1&D&!C&!B1&!B&A1&!A|!E1&E&D2&D1&D&!C&!B1&!B&A1&!A|!E1&E&D2&D1&D&!C&!B1&!B&A1&A|E1&E&D2&D1&D&!C&!B1&!B&A1&A|E1&!E&D2&D1&D&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&D&C&!B1&!B&A1&A|E1&E&!D2&!D1&D&C&!B1&!B&A1&A|!E1&E&!D2&!D1&D&C&!B1&!B&A1&A|!E1&E&D2&!D1&D&C&!B1&!B&A1&A|E1&E&D2&!D1&D&C&!B1&!B&A1&A|E1&!E&D2&!D1&D&C&!B1&!B&A1&A|E1&!E&D2&D1&D&C&!B1&!B&A1&A|E1&E&D2&D1&D&C&!B1&!B&A1&A|!E1&E&D2&D1&D&C&!B1&!B&A1&A|!E1&E&!D2&D1&D&C&!B1&!B&A1&A|E1&E&!D2&D1&D&C&!B1&!B&A1&A|E1&!E&!D2&D1&D&C&!B1&!B&A1&A|E1&!E&!D2&D1&!D&C&!B1&!B&A1&A|E1&E&!D2&D1&!D&C&!B1&!B&A1&A|!E1&E&!D2&D1&!D&C&!B1&!B&A1&A|!E1&E&D2&D1&!D&C&!B1&!B&A1&A|E1&E&D2&D1&!D&C&!B1&!B&A1&A|E1&!E&D2&D1&!D&C&!B1&!B&A1&A|E1&!E&D2&!D1&!D&C&!B1&!B&A1&A|E1&E&D2&!D1&!D&C&!B1&!B&A1&A|!E1&E&D2&!D1&!D&C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&C&!B1&!B&A1&A|E1&E&!D2&!D1&!D&C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&C&B1&!B&A1&A|E1&E&!D2&!D1&!D&C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&C&B1&!B&A1&A|!E1&E&D2&!D1&!D&C&B1&!B&A1&A|E1&E&D2&!D1&!D&C&B1&!B&A1&A|E1&!E&D2&!D1&!D&C&B1&!B&A1&A|E1&!E&D2&D1&!D&C&B1&!B&A1&A|E1&E&D2&D1&!D&C&B1&!B&A1&A|!E1&E&D2&D1&!D&C&B1&!B&A1&A|!E1&E&!D2&D1&!D&C&B1&!B&A1&A|E1&E&!D2&D1&!D&C&B1&!B&A1&A|E1&!E&!D2&D1&!D&C&B1&!B&A1&A|E1&!E&!D2&D1&D&C&B1&!B&A1&A|E1&E&!D2&D1&D&C&B1&!B&A1&A|!E1&E&!D2&D1&D&C&B1&!B&A1&A|!E1&E&D2&D1&D&C&B1&!B&A1&A|E1&E&D2&D1&D&C&B1&!B&A1&A|E1&!E&D2&D1&D&C&B1&!B&A1&A|E1&!E&D2&!D1&D&C&B1&!B&A1&A|E1&E&D2&!D1&D&C&B1&!B&A1&A|!E1&E&D2&!D1&D&C&B1&!B&A1&A|!E1&E&!D2&!D1&D&C&B1&!B&A1&A|E1&E&!D2&!D1&D&C&B1&!B&A1&A|E1&!E&!D2&!D1&D&C&B1&!B&A1&A|E1&!E&D2&D1&D&!C&B1&!B&A1&A|E1&E&D2&D1&D&!C&B1&!B&A1&A|!E1&E&D2&D1&D&!C&B1&!B&A1&A|!E1&E&D2&D1&D&!C&B1&B&A1&A|E1&E&D2&D1&D&!C&B1&B&A1&A|E1&!E&D2&D1&D&!C&B1&B&A1&A|E1&!E&!D2&!D1&D&C&B1&B&A1&A|E1&E&!D2&!D1&D&C&B1&B&A1&A|!E1&E&!D2&!D1&D&C&B1&B&A1&A|!E1&E&D2&!D1&D&C&B1&B&A1&A|E1&E&D2&!D1&D&C&B1&B&A1&A|E1&!E&D2&!D1&D&C&B1&B&A1&A|E1&!E&D2&D1&D&C&B1&B&A1&A|E1&E&D2&D1&D&C&B1&B&A1&A|!E1&E&D2&D1&D&C&B1&B&A1&A|!E1&E&!D2&D1&D&C&B1&B&A1&A|E1&E&!D2&D1&D&C&B1&B&A1&A|E1&!E&!D2&D1&D&C&B1&B&A1&A|E1&!E&!D2&D1&!D&C&B1&B&A1&A|E1&E&!D2&D1&!D&C&B1&B&A1&A|!E1&E&!D2&D1&!D&C&B1&B&A1&A|!E1&E&D2&D1&!D&C&B1&B&A1&A|E1&E&D2&D1&!D&C&B1&B&A1&A|E1&!E&D2&D1&!D&C&B1&B&A1&A|E1&!E&D2&!D1&!D&C&B1&B&A1&A|E1&E&D2&!D1&!D&C&B1&B&A1&A|!E1&E&D2&!D1&!D&C&B1&B&A1&A|!E1&E&!D2&!D1&!D&C&B1&B&A1&A|E1&E&!D2&!D1&!D&C&B1&B&A1&A|E1&!E&!D2&!D1&!D&C&B1&B&A1&A|E1&!E&!D2&!D1&!D&C&!B1&B&A1&A|E1&E&!D2&!D1&!D&C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&C&!B1&B&A1&A|!E1&E&D2&!D1&!D&C&!B1&B&A1&A|E1&E&D2&!D1&!D&C&!B1&B&A1&A|E1&!E&D2&!D1&!D&C&!B1&B&A1&A|E1&!E&D2&D1&!D&C&!B1&B&A1&A|E1&E&D2&D1&!D&C&!B1&B&A1&A|!E1&E&D2&D1&!D&C&!B1&B&A1&A|!E1&E&!D2&D1&!D&C&!B1&B&A1&A|E1&E&!D2&D1&!D&C&!B1&B&A1&A|E1&!E&!D2&D1&!D&C&!B1&B&A1&A|E1&!E&!D2&D1&D&C&!B1&B&A1&A|E1&E&!D2&D1&D&C&!B1&B&A1&A|!E1&E&!D2&D1&D&C&!B1&B&A1&A|!E1&E&D2&D1&D&C&!B1&B&A1&A|E1&E&D2&D1&D&C&!B1&B&A1&A|E1&!E&D2&D1&D&C&!B1&B&A1&A|E1&!E&D2&!D1&D&C&!B1&B&A1&A|E1&E&D2&!D1&D&C&!B1&B&A1&A|!E1&E&D2&!D1&D&C&!B1&B&A1&A|!E1&E&!D2&!D1&D&C&!B1&B&A1&A|E1&E&!D2&!D1&D&C&!B1&B&A1&A|E1&!E&!D2&!D1&D&C&!B1&B&A1&A|E1&!E&D2&D1&D&!C&!B1&B&A1&A|E1&E&D2&D1&D&!C&!B1&B&A1&A|!E1&E&D2&D1&D&!C&!B1&B&A1&A|!E1&E&D2&D1&D&!C&!B1&B&!A1&A|E1&E&D2&D1&D&!C&!B1&B&!A1&A|E1&!E&D2&D1&D&!C&!B1&B&!A1&A|E1&!E&D2&D1&D&C&!B1&B&!A1&A|E1&E&D2&D1&D&C&!B1&B&!A1&A|!E1&E&D2&D1&D&C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&C&B1&B&!A1&A|E1&E&!D2&!D1&!D&C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&C&B1&B&!A1&A|!E1&E&D2&!D1&!D&C&B1&B&!A1&A|E1&E&D2&!D1&!D&C&B1&B&!A1&A|E1&!E&D2&!D1&!D&C&B1&B&!A1&A|E1&!E&D2&D1&!D&C&B1&B&!A1&A|E1&E&D2&D1&!D&C&B1&B&!A1&A|!E1&E&D2&D1&!D&C&B1&B&!A1&A|!E1&E&!D2&D1&!D&C&B1&B&!A1&A|E1&E&!D2&D1&!D&C&B1&B&!A1&A|E1&!E&!D2&D1&!D&C&B1&B&!A1&A|E1&!E&!D2&D1&D&C&B1&B&!A1&A|E1&E&!D2&D1&D&C&B1&B&!A1&A|!E1&E&!D2&D1&D&C&B1&B&!A1&A|!E1&E&D2&D1&D&C&B1&B&!A1&A|E1&E&D2&D1&D&C&B1&B&!A1&A|E1&!E&D2&D1&D&C&B1&B&!A1&A|E1&!E&D2&!D1&D&C&B1&B&!A1&A|E1&E&D2&!D1&D&C&B1&B&!A1&A|!E1&E&D2&!D1&D&C&B1&B&!A1&A|!E1&E&!D2&!D1&D&C&B1&B&!A1&A|E1&E&!D2&!D1&D&C&B1&B&!A1&A|E1&!E&!D2&!D1&D&C&B1&B&!A1&A|E1&!E&D2&D1&D&!C&B1&B&!A1&A|E1&E&D2&D1&D&!C&B1&B&!A1&A|!E1&E&D2&D1&D&!C&B1&B&!A1&A|!E1&E&D2&D1&D&!C&B1&!B&!A1&A|E1&E&D2&D1&D&!C&B1&!B&!A1&A|E1&!E&D2&D1&D&!C&B1&!B&!A1&A|E1&!E&D2&D1&D&C&B1&!B&!A1&A|E1&E&D2&D1&D&C&B1&!B&!A1&A|!E1&E&D2&D1&D&C&B1&!B&!A1&A|!E1&E&D2&D1&D&C&!B1&!B&!A1&A|E1&E&D2&D1&D&C&!B1&!B&!A1&A|E1&!E&D2&D1&D&C&!B1&!B&!A1&A|E1&!E&D2&D1&D&!C&!B1&!B&!A1&A|E1&E&D2&D1&D&!C&!B1&!B&!A1&A|!E1&E&D2&D1&D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOOAI22132.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAI22121 -l AAOOAI22121 -i E D1 D C B1 B A1 A -o Y -f Y=!(E&!D1&D&C&!B1&!B&!A1&!A|E&D1&D&C&!B1&!B&!A1&!A|E&D1&!D&C&!B1&!B&!A1&!A|E&D1&!D&C&B1&!B&!A1&!A|E&D1&D&C&B1&!B&!A1&!A|E&!D1&D&C&B1&!B&!A1&!A|E&D1&!D&!C&B1&B&!A1&!A|E&D1&D&!C&B1&B&!A1&!A|E&!D1&D&!C&B1&B&!A1&!A|E&!D1&D&C&B1&B&!A1&!A|E&D1&D&C&B1&B&!A1&!A|E&D1&!D&C&B1&B&!A1&!A|E&D1&!D&C&!B1&B&!A1&!A|E&D1&D&C&!B1&B&!A1&!A|E&!D1&D&C&!B1&B&!A1&!A|E&!D1&D&C&!B1&B&A1&!A|E&D1&D&C&!B1&B&A1&!A|E&D1&!D&C&!B1&B&A1&!A|E&D1&!D&C&B1&B&A1&!A|E&D1&D&C&B1&B&A1&!A|E&!D1&D&C&B1&B&A1&!A|E&!D1&D&!C&B1&B&A1&!A|E&D1&D&!C&B1&B&A1&!A|E&D1&!D&!C&B1&B&A1&!A|E&!D1&D&C&B1&!B&A1&!A|E&D1&D&C&B1&!B&A1&!A|E&D1&!D&C&B1&!B&A1&!A|E&D1&!D&C&!B1&!B&A1&!A|E&D1&D&C&!B1&!B&A1&!A|E&!D1&D&C&!B1&!B&A1&!A|E&D1&!D&!C&!B1&!B&A1&A|E&D1&D&!C&!B1&!B&A1&A|E&!D1&D&!C&!B1&!B&A1&A|E&!D1&D&C&!B1&!B&A1&A|E&D1&D&C&!B1&!B&A1&A|E&D1&!D&C&!B1&!B&A1&A|E&D1&!D&C&B1&!B&A1&A|E&D1&D&C&B1&!B&A1&A|E&!D1&D&C&B1&!B&A1&A|E&!D1&D&!C&B1&!B&A1&A|E&D1&D&!C&B1&!B&A1&A|E&D1&!D&!C&B1&!B&A1&A|E&D1&!D&!C&B1&B&A1&A|E&D1&D&!C&B1&B&A1&A|E&!D1&D&!C&B1&B&A1&A|E&!D1&D&C&B1&B&A1&A|E&D1&D&C&B1&B&A1&A|E&D1&!D&C&B1&B&A1&A|E&D1&!D&C&!B1&B&A1&A|E&D1&D&C&!B1&B&A1&A|E&!D1&D&C&!B1&B&A1&A|E&!D1&D&!C&!B1&B&A1&A|E&D1&D&!C&!B1&B&A1&A|E&D1&!D&!C&!B1&B&A1&A|E&!D1&D&C&!B1&B&!A1&A|E&D1&D&C&!B1&B&!A1&A|E&D1&!D&C&!B1&B&!A1&A|E&D1&!D&C&B1&B&!A1&A|E&D1&D&C&B1&B&!A1&A|E&!D1&D&C&B1&B&!A1&A|E&!D1&D&!C&B1&B&!A1&A|E&D1&D&!C&B1&B&!A1&A|E&D1&!D&!C&B1&B&!A1&A|E&!D1&D&C&B1&!B&!A1&A|E&D1&D&C&B1&!B&!A1&A|E&D1&!D&C&B1&!B&!A1&A|E&D1&!D&C&!B1&!B&!A1&A|E&D1&D&C&!B1&!B&!A1&A|E&!D1&D&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAI22121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOI331 -l OOAOI331 -i C B2 B1 B A2 A1 A -o Y -f Y=(!C&!B2&!B1&!B&!A2&!A1&!A|!C&B2&!B1&!B&!A2&!A1&!A|!C&B2&B1&!B&!A2&!A1&!A|!C&!B2&B1&!B&!A2&!A1&!A|!C&!B2&B1&B&!A2&!A1&!A|!C&B2&B1&B&!A2&!A1&!A|!C&B2&!B1&B&!A2&!A1&!A|!C&!B2&!B1&B&!A2&!A1&!A|!C&!B2&!B1&!B&A2&!A1&!A|!C&!B2&!B1&!B&A2&A1&!A|!C&!B2&!B1&!B&!A2&A1&!A|!C&!B2&!B1&!B&!A2&A1&A|!C&!B2&!B1&!B&A2&A1&A|!C&!B2&!B1&!B&A2&!A1&A|!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOI331.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOAI3331 -l AAAOAI3331 -i D C2 C1 C B2 B1 B A2 A1 A -o Y -f Y=!(D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|D&C2&C1&C&B2&B1&B&!A2&!A1&!A|D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|D&C2&C1&C&!B2&!B1&B&A2&!A1&!A|D&C2&C1&C&B2&!B1&B&A2&!A1&!A|D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|D&C2&!C1&!C&B2&B1&B&A2&!A1&!A|D&C2&C1&!C&B2&B1&B&A2&!A1&!A|D&!C2&C1&!C&B2&B1&B&A2&!A1&!A|D&!C2&C1&C&B2&B1&B&A2&!A1&!A|D&C2&C1&C&B2&B1&B&A2&!A1&!A|D&C2&!C1&C&B2&B1&B&A2&!A1&!A|D&!C2&!C1&C&B2&B1&B&A2&!A1&!A|D&C2&C1&C&!B2&B1&B&A2&!A1&!A|D&C2&C1&C&!B2&B1&!B&A2&!A1&!A|D&C2&C1&C&B2&B1&!B&A2&!A1&!A|D&C2&C1&C&B2&!B1&!B&A2&!A1&!A|D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|D&C2&C1&C&B2&!B1&!B&A2&A1&!A|D&C2&C1&C&B2&B1&!B&A2&A1&!A|D&C2&C1&C&!B2&B1&!B&A2&A1&!A|D&C2&C1&C&!B2&B1&B&A2&A1&!A|D&!C2&!C1&C&B2&B1&B&A2&A1&!A|D&C2&!C1&C&B2&B1&B&A2&A1&!A|D&C2&C1&C&B2&B1&B&A2&A1&!A|D&!C2&C1&C&B2&B1&B&A2&A1&!A|D&!C2&C1&!C&B2&B1&B&A2&A1&!A|D&C2&C1&!C&B2&B1&B&A2&A1&!A|D&C2&!C1&!C&B2&B1&B&A2&A1&!A|D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|D&C2&C1&C&B2&!B1&B&A2&A1&!A|D&C2&C1&C&!B2&!B1&B&A2&A1&!A|D&C2&C1&C&!B2&!B1&B&!A2&A1&!A|D&C2&C1&C&B2&!B1&B&!A2&A1&!A|D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|D&C2&!C1&!C&B2&B1&B&!A2&A1&!A|D&C2&C1&!C&B2&B1&B&!A2&A1&!A|D&!C2&C1&!C&B2&B1&B&!A2&A1&!A|D&!C2&C1&C&B2&B1&B&!A2&A1&!A|D&C2&C1&C&B2&B1&B&!A2&A1&!A|D&C2&!C1&C&B2&B1&B&!A2&A1&!A|D&!C2&!C1&C&B2&B1&B&!A2&A1&!A|D&C2&C1&C&!B2&B1&B&!A2&A1&!A|D&C2&C1&C&!B2&B1&!B&!A2&A1&!A|D&C2&C1&C&B2&B1&!B&!A2&A1&!A|D&C2&C1&C&B2&!B1&!B&!A2&A1&!A|D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|D&C2&C1&C&B2&!B1&!B&!A2&A1&A|D&C2&C1&C&B2&B1&!B&!A2&A1&A|D&C2&C1&C&!B2&B1&!B&!A2&A1&A|D&C2&C1&C&!B2&B1&B&!A2&A1&A|D&!C2&!C1&C&B2&B1&B&!A2&A1&A|D&C2&!C1&C&B2&B1&B&!A2&A1&A|D&C2&C1&C&B2&B1&B&!A2&A1&A|D&!C2&C1&C&B2&B1&B&!A2&A1&A|D&!C2&C1&!C&B2&B1&B&!A2&A1&A|D&C2&C1&!C&B2&B1&B&!A2&A1&A|D&C2&!C1&!C&B2&B1&B&!A2&A1&A|D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|D&C2&C1&C&B2&!B1&B&!A2&A1&A|D&C2&C1&C&!B2&!B1&B&!A2&A1&A|D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|D&C2&!C1&!C&!B2&!B1&B&A2&A1&A|D&C2&C1&!C&!B2&!B1&B&A2&A1&A|D&!C2&C1&!C&!B2&!B1&B&A2&A1&A|D&!C2&C1&C&!B2&!B1&B&A2&A1&A|D&C2&C1&C&!B2&!B1&B&A2&A1&A|D&C2&!C1&C&!B2&!B1&B&A2&A1&A|D&!C2&!C1&C&!B2&!B1&B&A2&A1&A|D&!C2&!C1&C&B2&!B1&B&A2&A1&A|D&C2&!C1&C&B2&!B1&B&A2&A1&A|D&C2&C1&C&B2&!B1&B&A2&A1&A|D&!C2&C1&C&B2&!B1&B&A2&A1&A|D&!C2&C1&!C&B2&!B1&B&A2&A1&A|D&C2&C1&!C&B2&!B1&B&A2&A1&A|D&C2&!C1&!C&B2&!B1&B&A2&A1&A|D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|D&!C2&!C1&!C&B2&B1&B&A2&A1&A|D&C2&!C1&!C&B2&B1&B&A2&A1&A|D&C2&C1&!C&B2&B1&B&A2&A1&A|D&!C2&C1&!C&B2&B1&B&A2&A1&A|D&!C2&C1&C&B2&B1&B&A2&A1&A|D&C2&C1&C&B2&B1&B&A2&A1&A|D&C2&!C1&C&B2&B1&B&A2&A1&A|D&!C2&!C1&C&B2&B1&B&A2&A1&A|D&!C2&!C1&C&!B2&B1&B&A2&A1&A|D&C2&!C1&C&!B2&B1&B&A2&A1&A|D&C2&C1&C&!B2&B1&B&A2&A1&A|D&!C2&C1&C&!B2&B1&B&A2&A1&A|D&!C2&C1&!C&!B2&B1&B&A2&A1&A|D&C2&C1&!C&!B2&B1&B&A2&A1&A|D&C2&!C1&!C&!B2&B1&B&A2&A1&A|D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|D&C2&!C1&!C&!B2&B1&!B&A2&A1&A|D&C2&C1&!C&!B2&B1&!B&A2&A1&A|D&!C2&C1&!C&!B2&B1&!B&A2&A1&A|D&!C2&C1&C&!B2&B1&!B&A2&A1&A|D&C2&C1&C&!B2&B1&!B&A2&A1&A|D&C2&!C1&C&!B2&B1&!B&A2&A1&A|D&!C2&!C1&C&!B2&B1&!B&A2&A1&A|D&!C2&!C1&C&B2&B1&!B&A2&A1&A|D&C2&!C1&C&B2&B1&!B&A2&A1&A|D&C2&C1&C&B2&B1&!B&A2&A1&A|D&!C2&C1&C&B2&B1&!B&A2&A1&A|D&!C2&C1&!C&B2&B1&!B&A2&A1&A|D&C2&C1&!C&B2&B1&!B&A2&A1&A|D&C2&!C1&!C&B2&B1&!B&A2&A1&A|D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|D&C2&!C1&!C&B2&!B1&!B&A2&A1&A|D&C2&C1&!C&B2&!B1&!B&A2&A1&A|D&!C2&C1&!C&B2&!B1&!B&A2&A1&A|D&!C2&C1&C&B2&!B1&!B&A2&A1&A|D&C2&C1&C&B2&!B1&!B&A2&A1&A|D&C2&!C1&C&B2&!B1&!B&A2&A1&A|D&!C2&!C1&C&B2&!B1&!B&A2&A1&A|D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|D&C2&C1&C&!B2&!B1&!B&A2&A1&A|D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|D&C2&C1&C&B2&!B1&!B&A2&!A1&A|D&C2&C1&C&B2&B1&!B&A2&!A1&A|D&C2&C1&C&!B2&B1&!B&A2&!A1&A|D&C2&C1&C&!B2&B1&B&A2&!A1&A|D&!C2&!C1&C&B2&B1&B&A2&!A1&A|D&C2&!C1&C&B2&B1&B&A2&!A1&A|D&C2&C1&C&B2&B1&B&A2&!A1&A|D&!C2&C1&C&B2&B1&B&A2&!A1&A|D&!C2&C1&!C&B2&B1&B&A2&!A1&A|D&C2&C1&!C&B2&B1&B&A2&!A1&A|D&C2&!C1&!C&B2&B1&B&A2&!A1&A|D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|D&C2&C1&C&B2&!B1&B&A2&!A1&A|D&C2&C1&C&!B2&!B1&B&A2&!A1&A|D&C2&C1&C&!B2&!B1&B&!A2&!A1&A|D&C2&C1&C&B2&!B1&B&!A2&!A1&A|D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|D&C2&!C1&!C&B2&B1&B&!A2&!A1&A|D&C2&C1&!C&B2&B1&B&!A2&!A1&A|D&!C2&C1&!C&B2&B1&B&!A2&!A1&A|D&!C2&C1&C&B2&B1&B&!A2&!A1&A|D&C2&C1&C&B2&B1&B&!A2&!A1&A|D&C2&!C1&C&B2&B1&B&!A2&!A1&A|D&!C2&!C1&C&B2&B1&B&!A2&!A1&A|D&C2&C1&C&!B2&B1&B&!A2&!A1&A|D&C2&C1&C&!B2&B1&!B&!A2&!A1&A|D&C2&C1&C&B2&B1&!B&!A2&!A1&A|D&C2&C1&C&B2&!B1&!B&!A2&!A1&A|D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOAI3331.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOI21312 -l AOOAAOI21312 -i E1 E D C2 C1 C B A1 A -o Y -f Y=!(E1&E&!D&!C2&!C1&!C&!B&!A1&!A|E1&E&D&!C2&!C1&!C&!B&!A1&!A|E1&E&D&C2&!C1&!C&!B&!A1&!A|E1&E&!D&C2&!C1&!C&!B&!A1&!A|E1&E&!D&C2&C1&!C&!B&!A1&!A|E1&E&D&C2&C1&!C&!B&!A1&!A|E1&E&D&!C2&C1&!C&!B&!A1&!A|E1&E&!D&!C2&C1&!C&!B&!A1&!A|E1&E&!D&!C2&C1&C&!B&!A1&!A|E1&E&D&!C2&C1&C&!B&!A1&!A|E1&E&D&C2&C1&C&!B&!A1&!A|E1&E&!D&C2&C1&C&!B&!A1&!A|E1&E&!D&C2&!C1&C&!B&!A1&!A|E1&E&D&C2&!C1&C&!B&!A1&!A|E1&E&D&!C2&!C1&C&!B&!A1&!A|E1&E&!D&!C2&!C1&C&!B&!A1&!A|E1&E&!D&!C2&!C1&C&B&!A1&!A|!E1&E&D&!C2&!C1&C&B&!A1&!A|E1&E&D&!C2&!C1&C&B&!A1&!A|E1&!E&D&!C2&!C1&C&B&!A1&!A|!E1&!E&D&!C2&!C1&C&B&!A1&!A|!E1&!E&D&C2&!C1&C&B&!A1&!A|E1&!E&D&C2&!C1&C&B&!A1&!A|E1&E&D&C2&!C1&C&B&!A1&!A|!E1&E&D&C2&!C1&C&B&!A1&!A|E1&E&!D&C2&!C1&C&B&!A1&!A|E1&E&!D&C2&C1&C&B&!A1&!A|!E1&E&D&C2&C1&C&B&!A1&!A|E1&E&D&C2&C1&C&B&!A1&!A|E1&!E&D&C2&C1&C&B&!A1&!A|!E1&!E&D&C2&C1&C&B&!A1&!A|!E1&!E&D&!C2&C1&C&B&!A1&!A|E1&!E&D&!C2&C1&C&B&!A1&!A|E1&E&D&!C2&C1&C&B&!A1&!A|!E1&E&D&!C2&C1&C&B&!A1&!A|E1&E&!D&!C2&C1&C&B&!A1&!A|E1&E&!D&!C2&C1&!C&B&!A1&!A|!E1&E&D&!C2&C1&!C&B&!A1&!A|E1&E&D&!C2&C1&!C&B&!A1&!A|E1&!E&D&!C2&C1&!C&B&!A1&!A|!E1&!E&D&!C2&C1&!C&B&!A1&!A|!E1&!E&D&C2&C1&!C&B&!A1&!A|E1&!E&D&C2&C1&!C&B&!A1&!A|E1&E&D&C2&C1&!C&B&!A1&!A|!E1&E&D&C2&C1&!C&B&!A1&!A|E1&E&!D&C2&C1&!C&B&!A1&!A|E1&E&!D&C2&!C1&!C&B&!A1&!A|!E1&E&D&C2&!C1&!C&B&!A1&!A|E1&E&D&C2&!C1&!C&B&!A1&!A|E1&!E&D&C2&!C1&!C&B&!A1&!A|!E1&!E&D&C2&!C1&!C&B&!A1&!A|E1&E&D&!C2&!C1&!C&B&!A1&!A|E1&E&!D&!C2&!C1&!C&B&!A1&!A|E1&E&!D&!C2&!C1&!C&B&A1&!A|E1&E&D&!C2&!C1&!C&B&A1&!A|!E1&!E&D&C2&!C1&!C&B&A1&!A|E1&!E&D&C2&!C1&!C&B&A1&!A|E1&E&D&C2&!C1&!C&B&A1&!A|!E1&E&D&C2&!C1&!C&B&A1&!A|E1&E&!D&C2&!C1&!C&B&A1&!A|E1&E&!D&C2&C1&!C&B&A1&!A|!E1&E&D&C2&C1&!C&B&A1&!A|E1&E&D&C2&C1&!C&B&A1&!A|E1&!E&D&C2&C1&!C&B&A1&!A|!E1&!E&D&C2&C1&!C&B&A1&!A|!E1&!E&D&!C2&C1&!C&B&A1&!A|E1&!E&D&!C2&C1&!C&B&A1&!A|E1&E&D&!C2&C1&!C&B&A1&!A|!E1&E&D&!C2&C1&!C&B&A1&!A|E1&E&!D&!C2&C1&!C&B&A1&!A|E1&E&!D&!C2&C1&C&B&A1&!A|!E1&E&D&!C2&C1&C&B&A1&!A|E1&E&D&!C2&C1&C&B&A1&!A|E1&!E&D&!C2&C1&C&B&A1&!A|!E1&!E&D&!C2&C1&C&B&A1&!A|!E1&!E&D&C2&C1&C&B&A1&!A|E1&!E&D&C2&C1&C&B&A1&!A|E1&E&D&C2&C1&C&B&A1&!A|!E1&E&D&C2&C1&C&B&A1&!A|E1&E&!D&C2&C1&C&B&A1&!A|E1&E&!D&C2&!C1&C&B&A1&!A|!E1&E&D&C2&!C1&C&B&A1&!A|E1&E&D&C2&!C1&C&B&A1&!A|E1&!E&D&C2&!C1&C&B&A1&!A|!E1&!E&D&C2&!C1&C&B&A1&!A|!E1&!E&D&!C2&!C1&C&B&A1&!A|E1&!E&D&!C2&!C1&C&B&A1&!A|E1&E&D&!C2&!C1&C&B&A1&!A|!E1&E&D&!C2&!C1&C&B&A1&!A|E1&E&!D&!C2&!C1&C&B&A1&!A|E1&E&!D&!C2&!C1&C&!B&A1&!A|E1&E&D&!C2&!C1&C&!B&A1&!A|E1&E&D&C2&!C1&C&!B&A1&!A|E1&E&!D&C2&!C1&C&!B&A1&!A|E1&E&!D&C2&C1&C&!B&A1&!A|E1&E&D&C2&C1&C&!B&A1&!A|E1&E&D&!C2&C1&C&!B&A1&!A|E1&E&!D&!C2&C1&C&!B&A1&!A|E1&E&!D&!C2&C1&!C&!B&A1&!A|E1&E&D&!C2&C1&!C&!B&A1&!A|E1&E&D&C2&C1&!C&!B&A1&!A|E1&E&!D&C2&C1&!C&!B&A1&!A|E1&E&!D&C2&!C1&!C&!B&A1&!A|E1&E&D&C2&!C1&!C&!B&A1&!A|E1&E&D&!C2&!C1&!C&!B&A1&!A|E1&E&!D&!C2&!C1&!C&!B&A1&!A|E1&E&!D&!C2&!C1&!C&!B&A1&A|E1&E&D&!C2&!C1&!C&!B&A1&A|!E1&!E&D&C2&!C1&!C&!B&A1&A|E1&!E&D&C2&!C1&!C&!B&A1&A|E1&E&D&C2&!C1&!C&!B&A1&A|!E1&E&D&C2&!C1&!C&!B&A1&A|E1&E&!D&C2&!C1&!C&!B&A1&A|E1&E&!D&C2&C1&!C&!B&A1&A|!E1&E&D&C2&C1&!C&!B&A1&A|E1&E&D&C2&C1&!C&!B&A1&A|E1&!E&D&C2&C1&!C&!B&A1&A|!E1&!E&D&C2&C1&!C&!B&A1&A|!E1&!E&D&!C2&C1&!C&!B&A1&A|E1&!E&D&!C2&C1&!C&!B&A1&A|E1&E&D&!C2&C1&!C&!B&A1&A|!E1&E&D&!C2&C1&!C&!B&A1&A|E1&E&!D&!C2&C1&!C&!B&A1&A|E1&E&!D&!C2&C1&C&!B&A1&A|!E1&E&D&!C2&C1&C&!B&A1&A|E1&E&D&!C2&C1&C&!B&A1&A|E1&!E&D&!C2&C1&C&!B&A1&A|!E1&!E&D&!C2&C1&C&!B&A1&A|!E1&!E&D&C2&C1&C&!B&A1&A|E1&!E&D&C2&C1&C&!B&A1&A|E1&E&D&C2&C1&C&!B&A1&A|!E1&E&D&C2&C1&C&!B&A1&A|E1&E&!D&C2&C1&C&!B&A1&A|E1&E&!D&C2&!C1&C&!B&A1&A|!E1&E&D&C2&!C1&C&!B&A1&A|E1&E&D&C2&!C1&C&!B&A1&A|E1&!E&D&C2&!C1&C&!B&A1&A|!E1&!E&D&C2&!C1&C&!B&A1&A|!E1&!E&D&!C2&!C1&C&!B&A1&A|E1&!E&D&!C2&!C1&C&!B&A1&A|E1&E&D&!C2&!C1&C&!B&A1&A|!E1&E&D&!C2&!C1&C&!B&A1&A|E1&E&!D&!C2&!C1&C&!B&A1&A|E1&E&!D&!C2&!C1&C&B&A1&A|!E1&E&D&!C2&!C1&C&B&A1&A|E1&E&D&!C2&!C1&C&B&A1&A|E1&!E&D&!C2&!C1&C&B&A1&A|!E1&!E&D&!C2&!C1&C&B&A1&A|!E1&!E&D&C2&!C1&C&B&A1&A|E1&!E&D&C2&!C1&C&B&A1&A|E1&E&D&C2&!C1&C&B&A1&A|!E1&E&D&C2&!C1&C&B&A1&A|E1&E&!D&C2&!C1&C&B&A1&A|E1&E&!D&C2&C1&C&B&A1&A|!E1&E&D&C2&C1&C&B&A1&A|E1&E&D&C2&C1&C&B&A1&A|E1&!E&D&C2&C1&C&B&A1&A|!E1&!E&D&C2&C1&C&B&A1&A|!E1&!E&D&!C2&C1&C&B&A1&A|E1&!E&D&!C2&C1&C&B&A1&A|E1&E&D&!C2&C1&C&B&A1&A|!E1&E&D&!C2&C1&C&B&A1&A|E1&E&!D&!C2&C1&C&B&A1&A|E1&E&!D&!C2&C1&!C&B&A1&A|!E1&E&D&!C2&C1&!C&B&A1&A|E1&E&D&!C2&C1&!C&B&A1&A|E1&!E&D&!C2&C1&!C&B&A1&A|!E1&!E&D&!C2&C1&!C&B&A1&A|!E1&!E&D&C2&C1&!C&B&A1&A|E1&!E&D&C2&C1&!C&B&A1&A|E1&E&D&C2&C1&!C&B&A1&A|!E1&E&D&C2&C1&!C&B&A1&A|E1&E&!D&C2&C1&!C&B&A1&A|E1&E&!D&C2&!C1&!C&B&A1&A|!E1&E&D&C2&!C1&!C&B&A1&A|E1&E&D&C2&!C1&!C&B&A1&A|E1&!E&D&C2&!C1&!C&B&A1&A|!E1&!E&D&C2&!C1&!C&B&A1&A|E1&E&D&!C2&!C1&!C&B&A1&A|E1&E&!D&!C2&!C1&!C&B&A1&A|E1&E&!D&!C2&!C1&!C&B&!A1&A|E1&E&D&!C2&!C1&!C&B&!A1&A|!E1&!E&D&C2&!C1&!C&B&!A1&A|E1&!E&D&C2&!C1&!C&B&!A1&A|E1&E&D&C2&!C1&!C&B&!A1&A|!E1&E&D&C2&!C1&!C&B&!A1&A|E1&E&!D&C2&!C1&!C&B&!A1&A|E1&E&!D&C2&C1&!C&B&!A1&A|!E1&E&D&C2&C1&!C&B&!A1&A|E1&E&D&C2&C1&!C&B&!A1&A|E1&!E&D&C2&C1&!C&B&!A1&A|!E1&!E&D&C2&C1&!C&B&!A1&A|!E1&!E&D&!C2&C1&!C&B&!A1&A|E1&!E&D&!C2&C1&!C&B&!A1&A|E1&E&D&!C2&C1&!C&B&!A1&A|!E1&E&D&!C2&C1&!C&B&!A1&A|E1&E&!D&!C2&C1&!C&B&!A1&A|E1&E&!D&!C2&C1&C&B&!A1&A|!E1&E&D&!C2&C1&C&B&!A1&A|E1&E&D&!C2&C1&C&B&!A1&A|E1&!E&D&!C2&C1&C&B&!A1&A|!E1&!E&D&!C2&C1&C&B&!A1&A|!E1&!E&D&C2&C1&C&B&!A1&A|E1&!E&D&C2&C1&C&B&!A1&A|E1&E&D&C2&C1&C&B&!A1&A|!E1&E&D&C2&C1&C&B&!A1&A|E1&E&!D&C2&C1&C&B&!A1&A|E1&E&!D&C2&!C1&C&B&!A1&A|!E1&E&D&C2&!C1&C&B&!A1&A|E1&E&D&C2&!C1&C&B&!A1&A|E1&!E&D&C2&!C1&C&B&!A1&A|!E1&!E&D&C2&!C1&C&B&!A1&A|!E1&!E&D&!C2&!C1&C&B&!A1&A|E1&!E&D&!C2&!C1&C&B&!A1&A|E1&E&D&!C2&!C1&C&B&!A1&A|!E1&E&D&!C2&!C1&C&B&!A1&A|E1&E&!D&!C2&!C1&C&B&!A1&A|E1&E&!D&!C2&!C1&C&!B&!A1&A|E1&E&D&!C2&!C1&C&!B&!A1&A|E1&E&D&C2&!C1&C&!B&!A1&A|E1&E&!D&C2&!C1&C&!B&!A1&A|E1&E&!D&C2&C1&C&!B&!A1&A|E1&E&D&C2&C1&C&!B&!A1&A|E1&E&D&!C2&C1&C&!B&!A1&A|E1&E&!D&!C2&C1&C&!B&!A1&A|E1&E&!D&!C2&C1&!C&!B&!A1&A|E1&E&D&!C2&C1&!C&!B&!A1&A|E1&E&D&C2&C1&!C&!B&!A1&A|E1&E&!D&C2&C1&!C&!B&!A1&A|E1&E&!D&C2&!C1&!C&!B&!A1&A|E1&E&D&C2&!C1&!C&!B&!A1&A|E1&E&D&!C2&!C1&!C&!B&!A1&A|E1&E&!D&!C2&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOI21312.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOI2124 -l AOAAOI2124 -i D3 D2 D1 D C1 C B A1 A -o Y -f Y=!(D3&D2&D1&D&!C1&!C&!B&!A1&!A|D3&D2&D1&D&C1&!C&!B&!A1&!A|D3&D2&D1&D&C1&C&!B&!A1&!A|D3&D2&D1&D&!C1&C&!B&!A1&!A|D3&D2&D1&D&!C1&C&B&!A1&!A|!D3&!D2&!D1&D&C1&C&B&!A1&!A|D3&!D2&!D1&D&C1&C&B&!A1&!A|D3&D2&!D1&D&C1&C&B&!A1&!A|!D3&D2&!D1&D&C1&C&B&!A1&!A|!D3&D2&D1&D&C1&C&B&!A1&!A|D3&D2&D1&D&C1&C&B&!A1&!A|D3&!D2&D1&D&C1&C&B&!A1&!A|!D3&!D2&D1&D&C1&C&B&!A1&!A|!D3&!D2&D1&!D&C1&C&B&!A1&!A|D3&!D2&D1&!D&C1&C&B&!A1&!A|D3&D2&D1&!D&C1&C&B&!A1&!A|!D3&D2&D1&!D&C1&C&B&!A1&!A|!D3&D2&!D1&!D&C1&C&B&!A1&!A|D3&D2&!D1&!D&C1&C&B&!A1&!A|D3&!D2&!D1&!D&C1&C&B&!A1&!A|!D3&!D2&!D1&!D&C1&C&B&!A1&!A|D3&D2&D1&D&C1&!C&B&!A1&!A|D3&D2&D1&D&!C1&!C&B&!A1&!A|D3&D2&D1&D&!C1&!C&B&A1&!A|D3&D2&D1&D&C1&!C&B&A1&!A|!D3&!D2&!D1&!D&C1&C&B&A1&!A|D3&!D2&!D1&!D&C1&C&B&A1&!A|D3&D2&!D1&!D&C1&C&B&A1&!A|!D3&D2&!D1&!D&C1&C&B&A1&!A|!D3&D2&D1&!D&C1&C&B&A1&!A|D3&D2&D1&!D&C1&C&B&A1&!A|D3&!D2&D1&!D&C1&C&B&A1&!A|!D3&!D2&D1&!D&C1&C&B&A1&!A|!D3&!D2&D1&D&C1&C&B&A1&!A|D3&!D2&D1&D&C1&C&B&A1&!A|D3&D2&D1&D&C1&C&B&A1&!A|!D3&D2&D1&D&C1&C&B&A1&!A|!D3&D2&!D1&D&C1&C&B&A1&!A|D3&D2&!D1&D&C1&C&B&A1&!A|D3&!D2&!D1&D&C1&C&B&A1&!A|!D3&!D2&!D1&D&C1&C&B&A1&!A|D3&D2&D1&D&!C1&C&B&A1&!A|D3&D2&D1&D&!C1&C&!B&A1&!A|D3&D2&D1&D&C1&C&!B&A1&!A|D3&D2&D1&D&C1&!C&!B&A1&!A|D3&D2&D1&D&!C1&!C&!B&A1&!A|D3&D2&D1&D&!C1&!C&!B&A1&A|D3&D2&D1&D&C1&!C&!B&A1&A|!D3&!D2&!D1&!D&C1&C&!B&A1&A|D3&!D2&!D1&!D&C1&C&!B&A1&A|D3&D2&!D1&!D&C1&C&!B&A1&A|!D3&D2&!D1&!D&C1&C&!B&A1&A|!D3&D2&D1&!D&C1&C&!B&A1&A|D3&D2&D1&!D&C1&C&!B&A1&A|D3&!D2&D1&!D&C1&C&!B&A1&A|!D3&!D2&D1&!D&C1&C&!B&A1&A|!D3&!D2&D1&D&C1&C&!B&A1&A|D3&!D2&D1&D&C1&C&!B&A1&A|D3&D2&D1&D&C1&C&!B&A1&A|!D3&D2&D1&D&C1&C&!B&A1&A|!D3&D2&!D1&D&C1&C&!B&A1&A|D3&D2&!D1&D&C1&C&!B&A1&A|D3&!D2&!D1&D&C1&C&!B&A1&A|!D3&!D2&!D1&D&C1&C&!B&A1&A|D3&D2&D1&D&!C1&C&!B&A1&A|D3&D2&D1&D&!C1&C&B&A1&A|!D3&!D2&!D1&D&C1&C&B&A1&A|D3&!D2&!D1&D&C1&C&B&A1&A|D3&D2&!D1&D&C1&C&B&A1&A|!D3&D2&!D1&D&C1&C&B&A1&A|!D3&D2&D1&D&C1&C&B&A1&A|D3&D2&D1&D&C1&C&B&A1&A|D3&!D2&D1&D&C1&C&B&A1&A|!D3&!D2&D1&D&C1&C&B&A1&A|!D3&!D2&D1&!D&C1&C&B&A1&A|D3&!D2&D1&!D&C1&C&B&A1&A|D3&D2&D1&!D&C1&C&B&A1&A|!D3&D2&D1&!D&C1&C&B&A1&A|!D3&D2&!D1&!D&C1&C&B&A1&A|D3&D2&!D1&!D&C1&C&B&A1&A|D3&!D2&!D1&!D&C1&C&B&A1&A|!D3&!D2&!D1&!D&C1&C&B&A1&A|D3&D2&D1&D&C1&!C&B&A1&A|D3&D2&D1&D&!C1&!C&B&A1&A|D3&D2&D1&D&!C1&!C&B&!A1&A|D3&D2&D1&D&C1&!C&B&!A1&A|!D3&!D2&!D1&!D&C1&C&B&!A1&A|D3&!D2&!D1&!D&C1&C&B&!A1&A|D3&D2&!D1&!D&C1&C&B&!A1&A|!D3&D2&!D1&!D&C1&C&B&!A1&A|!D3&D2&D1&!D&C1&C&B&!A1&A|D3&D2&D1&!D&C1&C&B&!A1&A|D3&!D2&D1&!D&C1&C&B&!A1&A|!D3&!D2&D1&!D&C1&C&B&!A1&A|!D3&!D2&D1&D&C1&C&B&!A1&A|D3&!D2&D1&D&C1&C&B&!A1&A|D3&D2&D1&D&C1&C&B&!A1&A|!D3&D2&D1&D&C1&C&B&!A1&A|!D3&D2&!D1&D&C1&C&B&!A1&A|D3&D2&!D1&D&C1&C&B&!A1&A|D3&!D2&!D1&D&C1&C&B&!A1&A|!D3&!D2&!D1&D&C1&C&B&!A1&A|D3&D2&D1&D&!C1&C&B&!A1&A|D3&D2&D1&D&!C1&C&!B&!A1&A|D3&D2&D1&D&C1&C&!B&!A1&A|D3&D2&D1&D&C1&!C&!B&!A1&A|D3&D2&D1&D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOI2124.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAAOI21232 -l AOOAAAOI21232 -i E1 E D2 D1 D C1 C B A1 A -o Y -f Y=(!E1&!E&!D2&!D1&!D&!C1&!C&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&!B&!A1&!A|!E1&E&D2&!D1&!D&!C1&!C&!B&!A1&!A|E1&!E&D2&!D1&!D&!C1&!C&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&!B&!A1&!A|!E1&!E&D2&D1&!D&!C1&!C&!B&!A1&!A|E1&!E&D2&D1&!D&!C1&!C&!B&!A1&!A|!E1&E&D2&D1&!D&!C1&!C&!B&!A1&!A|!E1&E&!D2&D1&!D&!C1&!C&!B&!A1&!A|E1&!E&!D2&D1&!D&!C1&!C&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&!B&!A1&!A|!E1&!E&!D2&D1&D&!C1&!C&!B&!A1&!A|E1&!E&!D2&D1&D&!C1&!C&!B&!A1&!A|!E1&E&!D2&D1&D&!C1&!C&!B&!A1&!A|!E1&!E&D2&!D1&D&!C1&!C&!B&!A1&!A|E1&!E&D2&!D1&D&!C1&!C&!B&!A1&!A|!E1&E&D2&!D1&D&!C1&!C&!B&!A1&!A|!E1&E&!D2&!D1&D&!C1&!C&!B&!A1&!A|E1&!E&!D2&!D1&D&!C1&!C&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&!B&!A1&!A|!E1&!E&!D2&!D1&D&C1&!C&!B&!A1&!A|E1&!E&!D2&!D1&D&C1&!C&!B&!A1&!A|!E1&E&!D2&!D1&D&C1&!C&!B&!A1&!A|!E1&E&D2&!D1&D&C1&!C&!B&!A1&!A|E1&!E&D2&!D1&D&C1&!C&!B&!A1&!A|!E1&!E&D2&!D1&D&C1&!C&!B&!A1&!A|!E1&E&!D2&D1&D&C1&!C&!B&!A1&!A|E1&!E&!D2&D1&D&C1&!C&!B&!A1&!A|!E1&!E&!D2&D1&D&C1&!C&!B&!A1&!A|!E1&!E&!D2&D1&!D&C1&!C&!B&!A1&!A|E1&!E&!D2&D1&!D&C1&!C&!B&!A1&!A|!E1&E&!D2&D1&!D&C1&!C&!B&!A1&!A|!E1&E&D2&D1&!D&C1&!C&!B&!A1&!A|E1&!E&D2&D1&!D&C1&!C&!B&!A1&!A|!E1&!E&D2&D1&!D&C1&!C&!B&!A1&!A|!E1&!E&D2&!D1&!D&C1&!C&!B&!A1&!A|E1&!E&D2&!D1&!D&C1&!C&!B&!A1&!A|!E1&E&D2&!D1&!D&C1&!C&!B&!A1&!A|!E1&E&!D2&!D1&!D&C1&!C&!B&!A1&!A|E1&!E&!D2&!D1&!D&C1&!C&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&C&!B&!A1&!A|E1&!E&!D2&!D1&!D&C1&C&!B&!A1&!A|!E1&E&!D2&!D1&!D&C1&C&!B&!A1&!A|!E1&E&D2&!D1&!D&C1&C&!B&!A1&!A|E1&!E&D2&!D1&!D&C1&C&!B&!A1&!A|!E1&!E&D2&!D1&!D&C1&C&!B&!A1&!A|!E1&!E&D2&D1&!D&C1&C&!B&!A1&!A|E1&!E&D2&D1&!D&C1&C&!B&!A1&!A|!E1&E&D2&D1&!D&C1&C&!B&!A1&!A|!E1&E&!D2&D1&!D&C1&C&!B&!A1&!A|E1&!E&!D2&D1&!D&C1&C&!B&!A1&!A|!E1&!E&!D2&D1&!D&C1&C&!B&!A1&!A|!E1&!E&!D2&D1&D&C1&C&!B&!A1&!A|E1&!E&!D2&D1&D&C1&C&!B&!A1&!A|!E1&E&!D2&D1&D&C1&C&!B&!A1&!A|!E1&!E&D2&!D1&D&C1&C&!B&!A1&!A|E1&!E&D2&!D1&D&C1&C&!B&!A1&!A|!E1&E&D2&!D1&D&C1&C&!B&!A1&!A|!E1&E&!D2&!D1&D&C1&C&!B&!A1&!A|E1&!E&!D2&!D1&D&C1&C&!B&!A1&!A|!E1&!E&!D2&!D1&D&C1&C&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&C&!B&!A1&!A|E1&!E&!D2&!D1&D&!C1&C&!B&!A1&!A|!E1&E&!D2&!D1&D&!C1&C&!B&!A1&!A|!E1&E&D2&!D1&D&!C1&C&!B&!A1&!A|E1&!E&D2&!D1&D&!C1&C&!B&!A1&!A|!E1&!E&D2&!D1&D&!C1&C&!B&!A1&!A|!E1&E&!D2&D1&D&!C1&C&!B&!A1&!A|E1&!E&!D2&D1&D&!C1&C&!B&!A1&!A|!E1&!E&!D2&D1&D&!C1&C&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&C&!B&!A1&!A|E1&!E&!D2&D1&!D&!C1&C&!B&!A1&!A|!E1&E&!D2&D1&!D&!C1&C&!B&!A1&!A|!E1&E&D2&D1&!D&!C1&C&!B&!A1&!A|E1&!E&D2&D1&!D&!C1&C&!B&!A1&!A|!E1&!E&D2&D1&!D&!C1&C&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&C&!B&!A1&!A|E1&!E&D2&!D1&!D&!C1&C&!B&!A1&!A|!E1&E&D2&!D1&!D&!C1&C&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&C&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&C&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&B&!A1&!A|E1&!E&!D2&!D1&D&!C1&!C&B&!A1&!A|!E1&E&!D2&!D1&D&!C1&!C&B&!A1&!A|!E1&E&D2&!D1&D&!C1&!C&B&!A1&!A|E1&!E&D2&!D1&D&!C1&!C&B&!A1&!A|!E1&!E&D2&!D1&D&!C1&!C&B&!A1&!A|!E1&E&!D2&D1&D&!C1&!C&B&!A1&!A|E1&!E&!D2&D1&D&!C1&!C&B&!A1&!A|!E1&!E&!D2&D1&D&!C1&!C&B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&B&!A1&!A|E1&!E&!D2&D1&!D&!C1&!C&B&!A1&!A|!E1&E&!D2&D1&!D&!C1&!C&B&!A1&!A|!E1&E&D2&D1&!D&!C1&!C&B&!A1&!A|E1&!E&D2&D1&!D&!C1&!C&B&!A1&!A|!E1&!E&D2&D1&!D&!C1&!C&B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&B&!A1&!A|E1&!E&D2&!D1&!D&!C1&!C&B&!A1&!A|!E1&E&D2&!D1&!D&!C1&!C&B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&B&A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&B&A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&B&A1&!A|!E1&E&D2&!D1&!D&!C1&!C&B&A1&!A|E1&!E&D2&!D1&!D&!C1&!C&B&A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&B&A1&!A|!E1&!E&D2&D1&!D&!C1&!C&B&A1&!A|E1&!E&D2&D1&!D&!C1&!C&B&A1&!A|!E1&E&D2&D1&!D&!C1&!C&B&A1&!A|!E1&E&!D2&D1&!D&!C1&!C&B&A1&!A|E1&!E&!D2&D1&!D&!C1&!C&B&A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&B&A1&!A|!E1&!E&!D2&D1&D&!C1&!C&B&A1&!A|E1&!E&!D2&D1&D&!C1&!C&B&A1&!A|!E1&E&!D2&D1&D&!C1&!C&B&A1&!A|!E1&!E&D2&!D1&D&!C1&!C&B&A1&!A|E1&!E&D2&!D1&D&!C1&!C&B&A1&!A|!E1&E&D2&!D1&D&!C1&!C&B&A1&!A|!E1&E&!D2&!D1&D&!C1&!C&B&A1&!A|E1&!E&!D2&!D1&D&!C1&!C&B&A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&!B&A1&!A|E1&!E&!D2&!D1&!D&!C1&C&!B&A1&!A|!E1&E&!D2&!D1&!D&!C1&C&!B&A1&!A|!E1&E&D2&!D1&!D&!C1&C&!B&A1&!A|E1&!E&D2&!D1&!D&!C1&C&!B&A1&!A|!E1&!E&D2&!D1&!D&!C1&C&!B&A1&!A|!E1&!E&D2&D1&!D&!C1&C&!B&A1&!A|E1&!E&D2&D1&!D&!C1&C&!B&A1&!A|!E1&E&D2&D1&!D&!C1&C&!B&A1&!A|!E1&E&!D2&D1&!D&!C1&C&!B&A1&!A|E1&!E&!D2&D1&!D&!C1&C&!B&A1&!A|!E1&!E&!D2&D1&!D&!C1&C&!B&A1&!A|!E1&!E&!D2&D1&D&!C1&C&!B&A1&!A|E1&!E&!D2&D1&D&!C1&C&!B&A1&!A|!E1&E&!D2&D1&D&!C1&C&!B&A1&!A|!E1&!E&D2&!D1&D&!C1&C&!B&A1&!A|E1&!E&D2&!D1&D&!C1&C&!B&A1&!A|!E1&E&D2&!D1&D&!C1&C&!B&A1&!A|!E1&E&!D2&!D1&D&!C1&C&!B&A1&!A|E1&!E&!D2&!D1&D&!C1&C&!B&A1&!A|!E1&!E&!D2&!D1&D&!C1&C&!B&A1&!A|!E1&!E&!D2&!D1&D&C1&C&!B&A1&!A|E1&!E&!D2&!D1&D&C1&C&!B&A1&!A|!E1&E&!D2&!D1&D&C1&C&!B&A1&!A|!E1&E&D2&!D1&D&C1&C&!B&A1&!A|E1&!E&D2&!D1&D&C1&C&!B&A1&!A|!E1&!E&D2&!D1&D&C1&C&!B&A1&!A|!E1&E&!D2&D1&D&C1&C&!B&A1&!A|E1&!E&!D2&D1&D&C1&C&!B&A1&!A|!E1&!E&!D2&D1&D&C1&C&!B&A1&!A|!E1&!E&!D2&D1&!D&C1&C&!B&A1&!A|E1&!E&!D2&D1&!D&C1&C&!B&A1&!A|!E1&E&!D2&D1&!D&C1&C&!B&A1&!A|!E1&E&D2&D1&!D&C1&C&!B&A1&!A|E1&!E&D2&D1&!D&C1&C&!B&A1&!A|!E1&!E&D2&D1&!D&C1&C&!B&A1&!A|!E1&!E&D2&!D1&!D&C1&C&!B&A1&!A|E1&!E&D2&!D1&!D&C1&C&!B&A1&!A|!E1&E&D2&!D1&!D&C1&C&!B&A1&!A|!E1&E&!D2&!D1&!D&C1&C&!B&A1&!A|E1&!E&!D2&!D1&!D&C1&C&!B&A1&!A|!E1&!E&!D2&!D1&!D&C1&C&!B&A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&!B&A1&!A|E1&!E&!D2&!D1&!D&C1&!C&!B&A1&!A|!E1&E&!D2&!D1&!D&C1&!C&!B&A1&!A|!E1&E&D2&!D1&!D&C1&!C&!B&A1&!A|E1&!E&D2&!D1&!D&C1&!C&!B&A1&!A|!E1&!E&D2&!D1&!D&C1&!C&!B&A1&!A|!E1&!E&D2&D1&!D&C1&!C&!B&A1&!A|E1&!E&D2&D1&!D&C1&!C&!B&A1&!A|!E1&E&D2&D1&!D&C1&!C&!B&A1&!A|!E1&E&!D2&D1&!D&C1&!C&!B&A1&!A|E1&!E&!D2&D1&!D&C1&!C&!B&A1&!A|!E1&!E&!D2&D1&!D&C1&!C&!B&A1&!A|!E1&!E&!D2&D1&D&C1&!C&!B&A1&!A|E1&!E&!D2&D1&D&C1&!C&!B&A1&!A|!E1&E&!D2&D1&D&C1&!C&!B&A1&!A|!E1&!E&D2&!D1&D&C1&!C&!B&A1&!A|E1&!E&D2&!D1&D&C1&!C&!B&A1&!A|!E1&E&D2&!D1&D&C1&!C&!B&A1&!A|!E1&E&!D2&!D1&D&C1&!C&!B&A1&!A|E1&!E&!D2&!D1&D&C1&!C&!B&A1&!A|!E1&!E&!D2&!D1&D&C1&!C&!B&A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&!B&A1&!A|E1&!E&!D2&!D1&D&!C1&!C&!B&A1&!A|!E1&E&!D2&!D1&D&!C1&!C&!B&A1&!A|!E1&E&D2&!D1&D&!C1&!C&!B&A1&!A|E1&!E&D2&!D1&D&!C1&!C&!B&A1&!A|!E1&!E&D2&!D1&D&!C1&!C&!B&A1&!A|!E1&E&!D2&D1&D&!C1&!C&!B&A1&!A|E1&!E&!D2&D1&D&!C1&!C&!B&A1&!A|!E1&!E&!D2&D1&D&!C1&!C&!B&A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&!B&A1&!A|E1&!E&!D2&D1&!D&!C1&!C&!B&A1&!A|!E1&E&!D2&D1&!D&!C1&!C&!B&A1&!A|!E1&E&D2&D1&!D&!C1&!C&!B&A1&!A|E1&!E&D2&D1&!D&!C1&!C&!B&A1&!A|!E1&!E&D2&D1&!D&!C1&!C&!B&A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&!B&A1&!A|E1&!E&D2&!D1&!D&!C1&!C&!B&A1&!A|!E1&E&D2&!D1&!D&!C1&!C&!B&A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&!B&A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&!B&A1&A|E1&!E&!D2&!D1&!D&!C1&!C&!B&A1&A|!E1&E&!D2&!D1&!D&!C1&!C&!B&A1&A|!E1&E&D2&!D1&!D&!C1&!C&!B&A1&A|E1&!E&D2&!D1&!D&!C1&!C&!B&A1&A|!E1&!E&D2&!D1&!D&!C1&!C&!B&A1&A|!E1&!E&D2&D1&!D&!C1&!C&!B&A1&A|E1&!E&D2&D1&!D&!C1&!C&!B&A1&A|!E1&E&D2&D1&!D&!C1&!C&!B&A1&A|!E1&E&!D2&D1&!D&!C1&!C&!B&A1&A|E1&!E&!D2&D1&!D&!C1&!C&!B&A1&A|!E1&!E&!D2&D1&!D&!C1&!C&!B&A1&A|!E1&!E&!D2&D1&D&!C1&!C&!B&A1&A|E1&!E&!D2&D1&D&!C1&!C&!B&A1&A|!E1&E&!D2&D1&D&!C1&!C&!B&A1&A|!E1&!E&D2&!D1&D&!C1&!C&!B&A1&A|E1&!E&D2&!D1&D&!C1&!C&!B&A1&A|!E1&E&D2&!D1&D&!C1&!C&!B&A1&A|!E1&E&!D2&!D1&D&!C1&!C&!B&A1&A|E1&!E&!D2&!D1&D&!C1&!C&!B&A1&A|!E1&!E&!D2&!D1&D&!C1&!C&!B&A1&A|!E1&!E&!D2&!D1&D&!C1&!C&B&A1&A|E1&!E&!D2&!D1&D&!C1&!C&B&A1&A|!E1&E&!D2&!D1&D&!C1&!C&B&A1&A|!E1&E&D2&!D1&D&!C1&!C&B&A1&A|E1&!E&D2&!D1&D&!C1&!C&B&A1&A|!E1&!E&D2&!D1&D&!C1&!C&B&A1&A|!E1&E&!D2&D1&D&!C1&!C&B&A1&A|E1&!E&!D2&D1&D&!C1&!C&B&A1&A|!E1&!E&!D2&D1&D&!C1&!C&B&A1&A|!E1&!E&!D2&D1&!D&!C1&!C&B&A1&A|E1&!E&!D2&D1&!D&!C1&!C&B&A1&A|!E1&E&!D2&D1&!D&!C1&!C&B&A1&A|!E1&E&D2&D1&!D&!C1&!C&B&A1&A|E1&!E&D2&D1&!D&!C1&!C&B&A1&A|!E1&!E&D2&D1&!D&!C1&!C&B&A1&A|!E1&!E&D2&!D1&!D&!C1&!C&B&A1&A|E1&!E&D2&!D1&!D&!C1&!C&B&A1&A|!E1&E&D2&!D1&!D&!C1&!C&B&A1&A|!E1&E&!D2&!D1&!D&!C1&!C&B&A1&A|E1&!E&!D2&!D1&!D&!C1&!C&B&A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&B&A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&B&!A1&A|E1&!E&!D2&!D1&!D&!C1&!C&B&!A1&A|!E1&E&!D2&!D1&!D&!C1&!C&B&!A1&A|!E1&E&D2&!D1&!D&!C1&!C&B&!A1&A|E1&!E&D2&!D1&!D&!C1&!C&B&!A1&A|!E1&!E&D2&!D1&!D&!C1&!C&B&!A1&A|!E1&!E&D2&D1&!D&!C1&!C&B&!A1&A|E1&!E&D2&D1&!D&!C1&!C&B&!A1&A|!E1&E&D2&D1&!D&!C1&!C&B&!A1&A|!E1&E&!D2&D1&!D&!C1&!C&B&!A1&A|E1&!E&!D2&D1&!D&!C1&!C&B&!A1&A|!E1&!E&!D2&D1&!D&!C1&!C&B&!A1&A|!E1&!E&!D2&D1&D&!C1&!C&B&!A1&A|E1&!E&!D2&D1&D&!C1&!C&B&!A1&A|!E1&E&!D2&D1&D&!C1&!C&B&!A1&A|!E1&!E&D2&!D1&D&!C1&!C&B&!A1&A|E1&!E&D2&!D1&D&!C1&!C&B&!A1&A|!E1&E&D2&!D1&D&!C1&!C&B&!A1&A|!E1&E&!D2&!D1&D&!C1&!C&B&!A1&A|E1&!E&!D2&!D1&D&!C1&!C&B&!A1&A|!E1&!E&!D2&!D1&D&!C1&!C&B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&C&!B&!A1&A|E1&!E&!D2&!D1&!D&!C1&C&!B&!A1&A|!E1&E&!D2&!D1&!D&!C1&C&!B&!A1&A|!E1&E&D2&!D1&!D&!C1&C&!B&!A1&A|E1&!E&D2&!D1&!D&!C1&C&!B&!A1&A|!E1&!E&D2&!D1&!D&!C1&C&!B&!A1&A|!E1&!E&D2&D1&!D&!C1&C&!B&!A1&A|E1&!E&D2&D1&!D&!C1&C&!B&!A1&A|!E1&E&D2&D1&!D&!C1&C&!B&!A1&A|!E1&E&!D2&D1&!D&!C1&C&!B&!A1&A|E1&!E&!D2&D1&!D&!C1&C&!B&!A1&A|!E1&!E&!D2&D1&!D&!C1&C&!B&!A1&A|!E1&!E&!D2&D1&D&!C1&C&!B&!A1&A|E1&!E&!D2&D1&D&!C1&C&!B&!A1&A|!E1&E&!D2&D1&D&!C1&C&!B&!A1&A|!E1&!E&D2&!D1&D&!C1&C&!B&!A1&A|E1&!E&D2&!D1&D&!C1&C&!B&!A1&A|!E1&E&D2&!D1&D&!C1&C&!B&!A1&A|!E1&E&!D2&!D1&D&!C1&C&!B&!A1&A|E1&!E&!D2&!D1&D&!C1&C&!B&!A1&A|!E1&!E&!D2&!D1&D&!C1&C&!B&!A1&A|!E1&!E&!D2&!D1&D&C1&C&!B&!A1&A|E1&!E&!D2&!D1&D&C1&C&!B&!A1&A|!E1&E&!D2&!D1&D&C1&C&!B&!A1&A|!E1&E&D2&!D1&D&C1&C&!B&!A1&A|E1&!E&D2&!D1&D&C1&C&!B&!A1&A|!E1&!E&D2&!D1&D&C1&C&!B&!A1&A|!E1&E&!D2&D1&D&C1&C&!B&!A1&A|E1&!E&!D2&D1&D&C1&C&!B&!A1&A|!E1&!E&!D2&D1&D&C1&C&!B&!A1&A|!E1&!E&!D2&D1&!D&C1&C&!B&!A1&A|E1&!E&!D2&D1&!D&C1&C&!B&!A1&A|!E1&E&!D2&D1&!D&C1&C&!B&!A1&A|!E1&E&D2&D1&!D&C1&C&!B&!A1&A|E1&!E&D2&D1&!D&C1&C&!B&!A1&A|!E1&!E&D2&D1&!D&C1&C&!B&!A1&A|!E1&!E&D2&!D1&!D&C1&C&!B&!A1&A|E1&!E&D2&!D1&!D&C1&C&!B&!A1&A|!E1&E&D2&!D1&!D&C1&C&!B&!A1&A|!E1&E&!D2&!D1&!D&C1&C&!B&!A1&A|E1&!E&!D2&!D1&!D&C1&C&!B&!A1&A|!E1&!E&!D2&!D1&!D&C1&C&!B&!A1&A|!E1&!E&!D2&!D1&!D&C1&!C&!B&!A1&A|E1&!E&!D2&!D1&!D&C1&!C&!B&!A1&A|!E1&E&!D2&!D1&!D&C1&!C&!B&!A1&A|!E1&E&D2&!D1&!D&C1&!C&!B&!A1&A|E1&!E&D2&!D1&!D&C1&!C&!B&!A1&A|!E1&!E&D2&!D1&!D&C1&!C&!B&!A1&A|!E1&!E&D2&D1&!D&C1&!C&!B&!A1&A|E1&!E&D2&D1&!D&C1&!C&!B&!A1&A|!E1&E&D2&D1&!D&C1&!C&!B&!A1&A|!E1&E&!D2&D1&!D&C1&!C&!B&!A1&A|E1&!E&!D2&D1&!D&C1&!C&!B&!A1&A|!E1&!E&!D2&D1&!D&C1&!C&!B&!A1&A|!E1&!E&!D2&D1&D&C1&!C&!B&!A1&A|E1&!E&!D2&D1&D&C1&!C&!B&!A1&A|!E1&E&!D2&D1&D&C1&!C&!B&!A1&A|!E1&!E&D2&!D1&D&C1&!C&!B&!A1&A|E1&!E&D2&!D1&D&C1&!C&!B&!A1&A|!E1&E&D2&!D1&D&C1&!C&!B&!A1&A|!E1&E&!D2&!D1&D&C1&!C&!B&!A1&A|E1&!E&!D2&!D1&D&C1&!C&!B&!A1&A|!E1&!E&!D2&!D1&D&C1&!C&!B&!A1&A|!E1&!E&!D2&!D1&D&!C1&!C&!B&!A1&A|E1&!E&!D2&!D1&D&!C1&!C&!B&!A1&A|!E1&E&!D2&!D1&D&!C1&!C&!B&!A1&A|!E1&E&D2&!D1&D&!C1&!C&!B&!A1&A|E1&!E&D2&!D1&D&!C1&!C&!B&!A1&A|!E1&!E&D2&!D1&D&!C1&!C&!B&!A1&A|!E1&E&!D2&D1&D&!C1&!C&!B&!A1&A|E1&!E&!D2&D1&D&!C1&!C&!B&!A1&A|!E1&!E&!D2&D1&D&!C1&!C&!B&!A1&A|!E1&!E&!D2&D1&!D&!C1&!C&!B&!A1&A|E1&!E&!D2&D1&!D&!C1&!C&!B&!A1&A|!E1&E&!D2&D1&!D&!C1&!C&!B&!A1&A|!E1&E&D2&D1&!D&!C1&!C&!B&!A1&A|E1&!E&D2&D1&!D&!C1&!C&!B&!A1&A|!E1&!E&D2&D1&!D&!C1&!C&!B&!A1&A|!E1&!E&D2&!D1&!D&!C1&!C&!B&!A1&A|E1&!E&D2&!D1&!D&!C1&!C&!B&!A1&A|!E1&E&D2&!D1&!D&!C1&!C&!B&!A1&A|!E1&E&!D2&!D1&!D&!C1&!C&!B&!A1&A|E1&!E&!D2&!D1&!D&!C1&!C&!B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAAOI21232.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAI323 -l AAOOAI323 -i C2 C1 C B1 B A2 A1 A -o Y -f Y=!(C2&!C1&!C&B1&B&!A2&!A1&!A|C2&C1&!C&B1&B&!A2&!A1&!A|!C2&C1&!C&B1&B&!A2&!A1&!A|!C2&C1&C&B1&B&!A2&!A1&!A|C2&C1&C&B1&B&!A2&!A1&!A|C2&!C1&C&B1&B&!A2&!A1&!A|!C2&!C1&C&B1&B&!A2&!A1&!A|!C2&!C1&C&B1&B&A2&!A1&!A|C2&!C1&C&B1&B&A2&!A1&!A|C2&C1&C&B1&B&A2&!A1&!A|!C2&C1&C&B1&B&A2&!A1&!A|!C2&C1&!C&B1&B&A2&!A1&!A|C2&C1&!C&B1&B&A2&!A1&!A|C2&!C1&!C&B1&B&A2&!A1&!A|C2&!C1&!C&B1&B&A2&A1&!A|C2&C1&!C&B1&B&A2&A1&!A|!C2&C1&!C&B1&B&A2&A1&!A|!C2&C1&C&B1&B&A2&A1&!A|C2&C1&C&B1&B&A2&A1&!A|C2&!C1&C&B1&B&A2&A1&!A|!C2&!C1&C&B1&B&A2&A1&!A|!C2&!C1&C&B1&B&!A2&A1&!A|C2&!C1&C&B1&B&!A2&A1&!A|C2&C1&C&B1&B&!A2&A1&!A|!C2&C1&C&B1&B&!A2&A1&!A|!C2&C1&!C&B1&B&!A2&A1&!A|C2&C1&!C&B1&B&!A2&A1&!A|C2&!C1&!C&B1&B&!A2&A1&!A|C2&!C1&!C&B1&B&!A2&A1&A|C2&C1&!C&B1&B&!A2&A1&A|!C2&C1&!C&B1&B&!A2&A1&A|!C2&C1&C&B1&B&!A2&A1&A|C2&C1&C&B1&B&!A2&A1&A|C2&!C1&C&B1&B&!A2&A1&A|!C2&!C1&C&B1&B&!A2&A1&A|C2&!C1&!C&!B1&B&A2&A1&A|C2&C1&!C&!B1&B&A2&A1&A|!C2&C1&!C&!B1&B&A2&A1&A|!C2&C1&C&!B1&B&A2&A1&A|C2&C1&C&!B1&B&A2&A1&A|C2&!C1&C&!B1&B&A2&A1&A|!C2&!C1&C&!B1&B&A2&A1&A|!C2&!C1&C&B1&B&A2&A1&A|C2&!C1&C&B1&B&A2&A1&A|C2&C1&C&B1&B&A2&A1&A|!C2&C1&C&B1&B&A2&A1&A|!C2&C1&!C&B1&B&A2&A1&A|C2&C1&!C&B1&B&A2&A1&A|C2&!C1&!C&B1&B&A2&A1&A|C2&!C1&!C&B1&!B&A2&A1&A|C2&C1&!C&B1&!B&A2&A1&A|!C2&C1&!C&B1&!B&A2&A1&A|!C2&C1&C&B1&!B&A2&A1&A|C2&C1&C&B1&!B&A2&A1&A|C2&!C1&C&B1&!B&A2&A1&A|!C2&!C1&C&B1&!B&A2&A1&A|!C2&!C1&C&!B1&!B&A2&A1&A|C2&!C1&C&!B1&!B&A2&A1&A|C2&C1&C&!B1&!B&A2&A1&A|!C2&C1&C&!B1&!B&A2&A1&A|!C2&C1&!C&!B1&!B&A2&A1&A|C2&C1&!C&!B1&!B&A2&A1&A|C2&!C1&!C&!B1&!B&A2&A1&A|C2&!C1&!C&B1&B&A2&!A1&A|C2&C1&!C&B1&B&A2&!A1&A|!C2&C1&!C&B1&B&A2&!A1&A|!C2&C1&C&B1&B&A2&!A1&A|C2&C1&C&B1&B&A2&!A1&A|C2&!C1&C&B1&B&A2&!A1&A|!C2&!C1&C&B1&B&A2&!A1&A|!C2&!C1&C&B1&B&!A2&!A1&A|C2&!C1&C&B1&B&!A2&!A1&A|C2&C1&C&B1&B&!A2&!A1&A|!C2&C1&C&B1&B&!A2&!A1&A|!C2&C1&!C&B1&B&!A2&!A1&A|C2&C1&!C&B1&B&!A2&!A1&A|C2&!C1&!C&B1&B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAI323.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOI3212 -l OOAAOI3212 -i D1 D C B1 B A2 A1 A -o Y -f Y=!(D1&D&!C&!B1&!B&!A2&!A1&!A|D1&D&C&!B1&!B&!A2&!A1&!A|D1&D&C&B1&!B&!A2&!A1&!A|D1&D&!C&B1&!B&!A2&!A1&!A|D1&D&!C&B1&B&!A2&!A1&!A|D1&D&C&B1&B&!A2&!A1&!A|D1&D&C&!B1&B&!A2&!A1&!A|D1&D&!C&!B1&B&!A2&!A1&!A|D1&D&!C&!B1&B&A2&!A1&!A|!D1&D&C&!B1&B&A2&!A1&!A|D1&D&C&!B1&B&A2&!A1&!A|D1&!D&C&!B1&B&A2&!A1&!A|!D1&!D&C&!B1&B&A2&!A1&!A|!D1&!D&C&B1&B&A2&!A1&!A|D1&!D&C&B1&B&A2&!A1&!A|D1&D&C&B1&B&A2&!A1&!A|!D1&D&C&B1&B&A2&!A1&!A|D1&D&!C&B1&B&A2&!A1&!A|D1&D&!C&B1&!B&A2&!A1&!A|!D1&D&C&B1&!B&A2&!A1&!A|D1&D&C&B1&!B&A2&!A1&!A|D1&!D&C&B1&!B&A2&!A1&!A|!D1&!D&C&B1&!B&A2&!A1&!A|D1&D&C&!B1&!B&A2&!A1&!A|D1&D&!C&!B1&!B&A2&!A1&!A|D1&D&!C&!B1&!B&A2&A1&!A|D1&D&C&!B1&!B&A2&A1&!A|!D1&!D&C&B1&!B&A2&A1&!A|D1&!D&C&B1&!B&A2&A1&!A|D1&D&C&B1&!B&A2&A1&!A|!D1&D&C&B1&!B&A2&A1&!A|D1&D&!C&B1&!B&A2&A1&!A|D1&D&!C&B1&B&A2&A1&!A|!D1&D&C&B1&B&A2&A1&!A|D1&D&C&B1&B&A2&A1&!A|D1&!D&C&B1&B&A2&A1&!A|!D1&!D&C&B1&B&A2&A1&!A|!D1&!D&C&!B1&B&A2&A1&!A|D1&!D&C&!B1&B&A2&A1&!A|D1&D&C&!B1&B&A2&A1&!A|!D1&D&C&!B1&B&A2&A1&!A|D1&D&!C&!B1&B&A2&A1&!A|D1&D&!C&!B1&B&!A2&A1&!A|!D1&D&C&!B1&B&!A2&A1&!A|D1&D&C&!B1&B&!A2&A1&!A|D1&!D&C&!B1&B&!A2&A1&!A|!D1&!D&C&!B1&B&!A2&A1&!A|!D1&!D&C&B1&B&!A2&A1&!A|D1&!D&C&B1&B&!A2&A1&!A|D1&D&C&B1&B&!A2&A1&!A|!D1&D&C&B1&B&!A2&A1&!A|D1&D&!C&B1&B&!A2&A1&!A|D1&D&!C&B1&!B&!A2&A1&!A|!D1&D&C&B1&!B&!A2&A1&!A|D1&D&C&B1&!B&!A2&A1&!A|D1&!D&C&B1&!B&!A2&A1&!A|!D1&!D&C&B1&!B&!A2&A1&!A|D1&D&C&!B1&!B&!A2&A1&!A|D1&D&!C&!B1&!B&!A2&A1&!A|D1&D&!C&!B1&!B&!A2&A1&A|D1&D&C&!B1&!B&!A2&A1&A|!D1&!D&C&B1&!B&!A2&A1&A|D1&!D&C&B1&!B&!A2&A1&A|D1&D&C&B1&!B&!A2&A1&A|!D1&D&C&B1&!B&!A2&A1&A|D1&D&!C&B1&!B&!A2&A1&A|D1&D&!C&B1&B&!A2&A1&A|!D1&D&C&B1&B&!A2&A1&A|D1&D&C&B1&B&!A2&A1&A|D1&!D&C&B1&B&!A2&A1&A|!D1&!D&C&B1&B&!A2&A1&A|!D1&!D&C&!B1&B&!A2&A1&A|D1&!D&C&!B1&B&!A2&A1&A|D1&D&C&!B1&B&!A2&A1&A|!D1&D&C&!B1&B&!A2&A1&A|D1&D&!C&!B1&B&!A2&A1&A|D1&D&!C&!B1&B&A2&A1&A|!D1&D&C&!B1&B&A2&A1&A|D1&D&C&!B1&B&A2&A1&A|D1&!D&C&!B1&B&A2&A1&A|!D1&!D&C&!B1&B&A2&A1&A|!D1&!D&C&B1&B&A2&A1&A|D1&!D&C&B1&B&A2&A1&A|D1&D&C&B1&B&A2&A1&A|!D1&D&C&B1&B&A2&A1&A|D1&D&!C&B1&B&A2&A1&A|D1&D&!C&B1&!B&A2&A1&A|!D1&D&C&B1&!B&A2&A1&A|D1&D&C&B1&!B&A2&A1&A|D1&!D&C&B1&!B&A2&A1&A|!D1&!D&C&B1&!B&A2&A1&A|D1&D&C&!B1&!B&A2&A1&A|D1&D&!C&!B1&!B&A2&A1&A|D1&D&!C&!B1&!B&A2&!A1&A|D1&D&C&!B1&!B&A2&!A1&A|!D1&!D&C&B1&!B&A2&!A1&A|D1&!D&C&B1&!B&A2&!A1&A|D1&D&C&B1&!B&A2&!A1&A|!D1&D&C&B1&!B&A2&!A1&A|D1&D&!C&B1&!B&A2&!A1&A|D1&D&!C&B1&B&A2&!A1&A|!D1&D&C&B1&B&A2&!A1&A|D1&D&C&B1&B&A2&!A1&A|D1&!D&C&B1&B&A2&!A1&A|!D1&!D&C&B1&B&A2&!A1&A|!D1&!D&C&!B1&B&A2&!A1&A|D1&!D&C&!B1&B&A2&!A1&A|D1&D&C&!B1&B&A2&!A1&A|!D1&D&C&!B1&B&A2&!A1&A|D1&D&!C&!B1&B&A2&!A1&A|D1&D&!C&!B1&B&!A2&!A1&A|!D1&D&C&!B1&B&!A2&!A1&A|D1&D&C&!B1&B&!A2&!A1&A|D1&!D&C&!B1&B&!A2&!A1&A|!D1&!D&C&!B1&B&!A2&!A1&A|!D1&!D&C&B1&B&!A2&!A1&A|D1&!D&C&B1&B&!A2&!A1&A|D1&D&C&B1&B&!A2&!A1&A|!D1&D&C&B1&B&!A2&!A1&A|D1&D&!C&B1&B&!A2&!A1&A|D1&D&!C&B1&!B&!A2&!A1&A|!D1&D&C&B1&!B&!A2&!A1&A|D1&D&C&B1&!B&!A2&!A1&A|D1&!D&C&B1&!B&!A2&!A1&A|!D1&!D&C&B1&!B&!A2&!A1&A|D1&D&C&!B1&!B&!A2&!A1&A|D1&D&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOI3212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAOI2222 -l AAOAOI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B1&!B&!A1&!A|!D1&!D&C1&!C&!B1&!B&!A1&!A|!D1&!D&C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&B1&!B&!A1&!A|!D1&!D&C1&C&B1&!B&!A1&!A|!D1&!D&C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&B&!A1&!A|!D1&!D&C1&!C&B1&B&!A1&!A|!D1&!D&!C1&C&B1&B&!A1&!A|!D1&!D&!C1&C&!B1&B&!A1&!A|!D1&!D&C1&C&!B1&B&!A1&!A|!D1&!D&C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&A1&!A|!D1&!D&C1&!C&!B1&B&A1&!A|!D1&!D&C1&C&!B1&B&A1&!A|!D1&!D&!C1&C&!B1&B&A1&!A|!D1&!D&!C1&C&B1&B&A1&!A|!D1&!D&C1&!C&B1&B&A1&!A|!D1&!D&!C1&!C&B1&B&A1&!A|!D1&!D&!C1&!C&B1&!B&A1&!A|!D1&!D&C1&!C&B1&!B&A1&!A|!D1&!D&C1&C&B1&!B&A1&!A|!D1&!D&!C1&C&B1&!B&A1&!A|!D1&!D&!C1&C&!B1&!B&A1&!A|!D1&!D&C1&C&!B1&!B&A1&!A|!D1&!D&C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&A|!D1&!D&C1&!C&!B1&!B&A1&A|!D1&!D&!C1&C&!B1&!B&A1&A|!D1&!D&!C1&C&B1&!B&A1&A|!D1&!D&C1&!C&B1&!B&A1&A|!D1&!D&!C1&!C&B1&!B&A1&A|!D1&!D&!C1&!C&B1&B&A1&A|!D1&!D&C1&!C&B1&B&A1&A|!D1&!D&!C1&C&B1&B&A1&A|!D1&!D&!C1&C&!B1&B&A1&A|!D1&!D&C1&!C&!B1&B&A1&A|!D1&!D&!C1&!C&!B1&B&A1&A|!D1&!D&!C1&!C&!B1&B&!A1&A|!D1&!D&C1&!C&!B1&B&!A1&A|!D1&!D&C1&C&!B1&B&!A1&A|!D1&!D&!C1&C&!B1&B&!A1&A|!D1&!D&!C1&C&B1&B&!A1&A|!D1&!D&C1&!C&B1&B&!A1&A|!D1&!D&!C1&!C&B1&B&!A1&A|!D1&!D&!C1&!C&B1&!B&!A1&A|!D1&!D&C1&!C&B1&!B&!A1&A|!D1&!D&C1&C&B1&!B&!A1&A|!D1&!D&!C1&C&B1&!B&!A1&A|!D1&!D&!C1&C&!B1&!B&!A1&A|!D1&!D&C1&C&!B1&!B&!A1&A|!D1&!D&C1&!C&!B1&!B&!A1&A|!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAOI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOI212121 -l AOOAAOI212121 -i F E1 E D C1 C B A1 A -o Y -f Y=(!F&!E1&!E&!D&!C1&!C&!B&!A1&!A|!F&E1&!E&!D&!C1&!C&!B&!A1&!A|!F&!E1&E&!D&!C1&!C&!B&!A1&!A|!F&!E1&E&D&!C1&!C&!B&!A1&!A|!F&E1&!E&D&!C1&!C&!B&!A1&!A|!F&!E1&!E&D&!C1&!C&!B&!A1&!A|!F&!E1&!E&D&C1&!C&!B&!A1&!A|!F&E1&!E&D&C1&!C&!B&!A1&!A|!F&!E1&E&D&C1&!C&!B&!A1&!A|!F&!E1&E&!D&C1&!C&!B&!A1&!A|!F&E1&!E&!D&C1&!C&!B&!A1&!A|!F&!E1&!E&!D&C1&!C&!B&!A1&!A|!F&!E1&!E&!D&C1&C&!B&!A1&!A|!F&E1&!E&!D&C1&C&!B&!A1&!A|!F&!E1&E&!D&C1&C&!B&!A1&!A|!F&!E1&E&D&C1&C&!B&!A1&!A|!F&E1&!E&D&C1&C&!B&!A1&!A|!F&!E1&!E&D&C1&C&!B&!A1&!A|!F&!E1&!E&D&!C1&C&!B&!A1&!A|!F&E1&!E&D&!C1&C&!B&!A1&!A|!F&!E1&E&D&!C1&C&!B&!A1&!A|!F&!E1&E&!D&!C1&C&!B&!A1&!A|!F&E1&!E&!D&!C1&C&!B&!A1&!A|!F&!E1&!E&!D&!C1&C&!B&!A1&!A|!F&!E1&!E&!D&!C1&C&B&!A1&!A|!F&E1&!E&!D&!C1&C&B&!A1&!A|!F&!E1&E&!D&!C1&C&B&!A1&!A|!F&!E1&E&!D&C1&C&B&!A1&!A|!F&E1&!E&!D&C1&C&B&!A1&!A|!F&!E1&!E&!D&C1&C&B&!A1&!A|!F&!E1&!E&!D&C1&!C&B&!A1&!A|!F&E1&!E&!D&C1&!C&B&!A1&!A|!F&!E1&E&!D&C1&!C&B&!A1&!A|!F&!E1&!E&D&!C1&!C&B&!A1&!A|!F&E1&!E&D&!C1&!C&B&!A1&!A|!F&!E1&E&D&!C1&!C&B&!A1&!A|!F&!E1&E&!D&!C1&!C&B&!A1&!A|!F&E1&!E&!D&!C1&!C&B&!A1&!A|!F&!E1&!E&!D&!C1&!C&B&!A1&!A|!F&!E1&!E&!D&!C1&!C&B&A1&!A|!F&E1&!E&!D&!C1&!C&B&A1&!A|!F&!E1&E&!D&!C1&!C&B&A1&!A|!F&!E1&E&D&!C1&!C&B&A1&!A|!F&E1&!E&D&!C1&!C&B&A1&!A|!F&!E1&!E&D&!C1&!C&B&A1&!A|!F&!E1&E&!D&C1&!C&B&A1&!A|!F&E1&!E&!D&C1&!C&B&A1&!A|!F&!E1&!E&!D&C1&!C&B&A1&!A|!F&!E1&!E&!D&C1&C&B&A1&!A|!F&E1&!E&!D&C1&C&B&A1&!A|!F&!E1&E&!D&C1&C&B&A1&!A|!F&!E1&E&!D&!C1&C&B&A1&!A|!F&E1&!E&!D&!C1&C&B&A1&!A|!F&!E1&!E&!D&!C1&C&B&A1&!A|!F&!E1&!E&!D&!C1&C&!B&A1&!A|!F&E1&!E&!D&!C1&C&!B&A1&!A|!F&!E1&E&!D&!C1&C&!B&A1&!A|!F&!E1&E&D&!C1&C&!B&A1&!A|!F&E1&!E&D&!C1&C&!B&A1&!A|!F&!E1&!E&D&!C1&C&!B&A1&!A|!F&!E1&!E&D&C1&C&!B&A1&!A|!F&E1&!E&D&C1&C&!B&A1&!A|!F&!E1&E&D&C1&C&!B&A1&!A|!F&!E1&E&!D&C1&C&!B&A1&!A|!F&E1&!E&!D&C1&C&!B&A1&!A|!F&!E1&!E&!D&C1&C&!B&A1&!A|!F&!E1&!E&!D&C1&!C&!B&A1&!A|!F&E1&!E&!D&C1&!C&!B&A1&!A|!F&!E1&E&!D&C1&!C&!B&A1&!A|!F&!E1&E&D&C1&!C&!B&A1&!A|!F&E1&!E&D&C1&!C&!B&A1&!A|!F&!E1&!E&D&C1&!C&!B&A1&!A|!F&!E1&!E&D&!C1&!C&!B&A1&!A|!F&E1&!E&D&!C1&!C&!B&A1&!A|!F&!E1&E&D&!C1&!C&!B&A1&!A|!F&!E1&E&!D&!C1&!C&!B&A1&!A|!F&E1&!E&!D&!C1&!C&!B&A1&!A|!F&!E1&!E&!D&!C1&!C&!B&A1&!A|!F&!E1&!E&!D&!C1&!C&!B&A1&A|!F&E1&!E&!D&!C1&!C&!B&A1&A|!F&!E1&E&!D&!C1&!C&!B&A1&A|!F&!E1&E&D&!C1&!C&!B&A1&A|!F&E1&!E&D&!C1&!C&!B&A1&A|!F&!E1&!E&D&!C1&!C&!B&A1&A|!F&!E1&E&!D&C1&!C&!B&A1&A|!F&E1&!E&!D&C1&!C&!B&A1&A|!F&!E1&!E&!D&C1&!C&!B&A1&A|!F&!E1&!E&!D&C1&C&!B&A1&A|!F&E1&!E&!D&C1&C&!B&A1&A|!F&!E1&E&!D&C1&C&!B&A1&A|!F&!E1&E&!D&!C1&C&!B&A1&A|!F&E1&!E&!D&!C1&C&!B&A1&A|!F&!E1&!E&!D&!C1&C&!B&A1&A|!F&!E1&!E&!D&!C1&C&B&A1&A|!F&E1&!E&!D&!C1&C&B&A1&A|!F&!E1&E&!D&!C1&C&B&A1&A|!F&!E1&E&!D&C1&C&B&A1&A|!F&E1&!E&!D&C1&C&B&A1&A|!F&!E1&!E&!D&C1&C&B&A1&A|!F&!E1&!E&!D&C1&!C&B&A1&A|!F&E1&!E&!D&C1&!C&B&A1&A|!F&!E1&E&!D&C1&!C&B&A1&A|!F&!E1&!E&D&!C1&!C&B&A1&A|!F&E1&!E&D&!C1&!C&B&A1&A|!F&!E1&E&D&!C1&!C&B&A1&A|!F&!E1&E&!D&!C1&!C&B&A1&A|!F&E1&!E&!D&!C1&!C&B&A1&A|!F&!E1&!E&!D&!C1&!C&B&A1&A|!F&!E1&!E&!D&!C1&!C&B&!A1&A|!F&E1&!E&!D&!C1&!C&B&!A1&A|!F&!E1&E&!D&!C1&!C&B&!A1&A|!F&!E1&E&D&!C1&!C&B&!A1&A|!F&E1&!E&D&!C1&!C&B&!A1&A|!F&!E1&!E&D&!C1&!C&B&!A1&A|!F&!E1&E&!D&C1&!C&B&!A1&A|!F&E1&!E&!D&C1&!C&B&!A1&A|!F&!E1&!E&!D&C1&!C&B&!A1&A|!F&!E1&!E&!D&C1&C&B&!A1&A|!F&E1&!E&!D&C1&C&B&!A1&A|!F&!E1&E&!D&C1&C&B&!A1&A|!F&!E1&E&!D&!C1&C&B&!A1&A|!F&E1&!E&!D&!C1&C&B&!A1&A|!F&!E1&!E&!D&!C1&C&B&!A1&A|!F&!E1&!E&!D&!C1&C&!B&!A1&A|!F&E1&!E&!D&!C1&C&!B&!A1&A|!F&!E1&E&!D&!C1&C&!B&!A1&A|!F&!E1&E&D&!C1&C&!B&!A1&A|!F&E1&!E&D&!C1&C&!B&!A1&A|!F&!E1&!E&D&!C1&C&!B&!A1&A|!F&!E1&!E&D&C1&C&!B&!A1&A|!F&E1&!E&D&C1&C&!B&!A1&A|!F&!E1&E&D&C1&C&!B&!A1&A|!F&!E1&E&!D&C1&C&!B&!A1&A|!F&E1&!E&!D&C1&C&!B&!A1&A|!F&!E1&!E&!D&C1&C&!B&!A1&A|!F&!E1&!E&!D&C1&!C&!B&!A1&A|!F&E1&!E&!D&C1&!C&!B&!A1&A|!F&!E1&E&!D&C1&!C&!B&!A1&A|!F&!E1&E&D&C1&!C&!B&!A1&A|!F&E1&!E&D&C1&!C&!B&!A1&A|!F&!E1&!E&D&C1&!C&!B&!A1&A|!F&!E1&!E&D&!C1&!C&!B&!A1&A|!F&E1&!E&D&!C1&!C&!B&!A1&A|!F&!E1&E&D&!C1&!C&!B&!A1&A|!F&!E1&E&!D&!C1&!C&!B&!A1&A|!F&E1&!E&!D&!C1&!C&!B&!A1&A|!F&!E1&!E&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOI212121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAAOI2223 -l AAOOAAOI2223 -i D2 D1 D C1 C B1 B A1 A -o Y -f Y=!(D2&D1&D&!C1&!C&!B1&!B&!A1&!A|D2&D1&D&C1&!C&!B1&!B&!A1&!A|D2&D1&D&C1&C&!B1&!B&!A1&!A|D2&D1&D&!C1&C&!B1&!B&!A1&!A|D2&D1&D&!C1&C&B1&!B&!A1&!A|D2&D1&D&C1&C&B1&!B&!A1&!A|D2&D1&D&C1&!C&B1&!B&!A1&!A|D2&D1&D&!C1&!C&B1&!B&!A1&!A|D2&D1&D&!C1&!C&B1&B&!A1&!A|!D2&!D1&D&C1&!C&B1&B&!A1&!A|D2&!D1&D&C1&!C&B1&B&!A1&!A|D2&D1&D&C1&!C&B1&B&!A1&!A|!D2&D1&D&C1&!C&B1&B&!A1&!A|!D2&D1&!D&C1&!C&B1&B&!A1&!A|D2&D1&!D&C1&!C&B1&B&!A1&!A|D2&!D1&!D&C1&!C&B1&B&!A1&!A|!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!D2&!D1&!D&C1&C&B1&B&!A1&!A|D2&!D1&!D&C1&C&B1&B&!A1&!A|D2&D1&!D&C1&C&B1&B&!A1&!A|!D2&D1&!D&C1&C&B1&B&!A1&!A|!D2&D1&D&C1&C&B1&B&!A1&!A|D2&D1&D&C1&C&B1&B&!A1&!A|D2&!D1&D&C1&C&B1&B&!A1&!A|!D2&!D1&D&C1&C&B1&B&!A1&!A|!D2&!D1&D&!C1&C&B1&B&!A1&!A|D2&!D1&D&!C1&C&B1&B&!A1&!A|D2&D1&D&!C1&C&B1&B&!A1&!A|!D2&D1&D&!C1&C&B1&B&!A1&!A|!D2&D1&!D&!C1&C&B1&B&!A1&!A|D2&D1&!D&!C1&C&B1&B&!A1&!A|D2&!D1&!D&!C1&C&B1&B&!A1&!A|!D2&!D1&!D&!C1&C&B1&B&!A1&!A|D2&D1&D&!C1&C&!B1&B&!A1&!A|D2&D1&D&C1&C&!B1&B&!A1&!A|D2&D1&D&C1&!C&!B1&B&!A1&!A|D2&D1&D&!C1&!C&!B1&B&!A1&!A|D2&D1&D&!C1&!C&!B1&B&A1&!A|D2&D1&D&C1&!C&!B1&B&A1&!A|D2&D1&D&C1&C&!B1&B&A1&!A|D2&D1&D&!C1&C&!B1&B&A1&!A|!D2&!D1&!D&!C1&C&B1&B&A1&!A|D2&!D1&!D&!C1&C&B1&B&A1&!A|D2&D1&!D&!C1&C&B1&B&A1&!A|!D2&D1&!D&!C1&C&B1&B&A1&!A|!D2&D1&D&!C1&C&B1&B&A1&!A|D2&D1&D&!C1&C&B1&B&A1&!A|D2&!D1&D&!C1&C&B1&B&A1&!A|!D2&!D1&D&!C1&C&B1&B&A1&!A|!D2&!D1&D&C1&C&B1&B&A1&!A|D2&!D1&D&C1&C&B1&B&A1&!A|D2&D1&D&C1&C&B1&B&A1&!A|!D2&D1&D&C1&C&B1&B&A1&!A|!D2&D1&!D&C1&C&B1&B&A1&!A|D2&D1&!D&C1&C&B1&B&A1&!A|D2&!D1&!D&C1&C&B1&B&A1&!A|!D2&!D1&!D&C1&C&B1&B&A1&!A|!D2&!D1&!D&C1&!C&B1&B&A1&!A|D2&!D1&!D&C1&!C&B1&B&A1&!A|D2&D1&!D&C1&!C&B1&B&A1&!A|!D2&D1&!D&C1&!C&B1&B&A1&!A|!D2&D1&D&C1&!C&B1&B&A1&!A|D2&D1&D&C1&!C&B1&B&A1&!A|D2&!D1&D&C1&!C&B1&B&A1&!A|!D2&!D1&D&C1&!C&B1&B&A1&!A|D2&D1&D&!C1&!C&B1&B&A1&!A|D2&D1&D&!C1&!C&B1&!B&A1&!A|D2&D1&D&C1&!C&B1&!B&A1&!A|D2&D1&D&C1&C&B1&!B&A1&!A|D2&D1&D&!C1&C&B1&!B&A1&!A|D2&D1&D&!C1&C&!B1&!B&A1&!A|D2&D1&D&C1&C&!B1&!B&A1&!A|D2&D1&D&C1&!C&!B1&!B&A1&!A|D2&D1&D&!C1&!C&!B1&!B&A1&!A|D2&D1&D&!C1&!C&!B1&!B&A1&A|!D2&!D1&D&C1&!C&!B1&!B&A1&A|D2&!D1&D&C1&!C&!B1&!B&A1&A|D2&D1&D&C1&!C&!B1&!B&A1&A|!D2&D1&D&C1&!C&!B1&!B&A1&A|!D2&D1&!D&C1&!C&!B1&!B&A1&A|D2&D1&!D&C1&!C&!B1&!B&A1&A|D2&!D1&!D&C1&!C&!B1&!B&A1&A|!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!D2&!D1&!D&C1&C&!B1&!B&A1&A|D2&!D1&!D&C1&C&!B1&!B&A1&A|D2&D1&!D&C1&C&!B1&!B&A1&A|!D2&D1&!D&C1&C&!B1&!B&A1&A|!D2&D1&D&C1&C&!B1&!B&A1&A|D2&D1&D&C1&C&!B1&!B&A1&A|D2&!D1&D&C1&C&!B1&!B&A1&A|!D2&!D1&D&C1&C&!B1&!B&A1&A|!D2&!D1&D&!C1&C&!B1&!B&A1&A|D2&!D1&D&!C1&C&!B1&!B&A1&A|D2&D1&D&!C1&C&!B1&!B&A1&A|!D2&D1&D&!C1&C&!B1&!B&A1&A|!D2&D1&!D&!C1&C&!B1&!B&A1&A|D2&D1&!D&!C1&C&!B1&!B&A1&A|D2&!D1&!D&!C1&C&!B1&!B&A1&A|!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!D2&!D1&!D&!C1&C&B1&!B&A1&A|D2&!D1&!D&!C1&C&B1&!B&A1&A|D2&D1&!D&!C1&C&B1&!B&A1&A|!D2&D1&!D&!C1&C&B1&!B&A1&A|!D2&D1&D&!C1&C&B1&!B&A1&A|D2&D1&D&!C1&C&B1&!B&A1&A|D2&!D1&D&!C1&C&B1&!B&A1&A|!D2&!D1&D&!C1&C&B1&!B&A1&A|!D2&!D1&D&C1&C&B1&!B&A1&A|D2&!D1&D&C1&C&B1&!B&A1&A|D2&D1&D&C1&C&B1&!B&A1&A|!D2&D1&D&C1&C&B1&!B&A1&A|!D2&D1&!D&C1&C&B1&!B&A1&A|D2&D1&!D&C1&C&B1&!B&A1&A|D2&!D1&!D&C1&C&B1&!B&A1&A|!D2&!D1&!D&C1&C&B1&!B&A1&A|!D2&!D1&!D&C1&!C&B1&!B&A1&A|D2&!D1&!D&C1&!C&B1&!B&A1&A|D2&D1&!D&C1&!C&B1&!B&A1&A|!D2&D1&!D&C1&!C&B1&!B&A1&A|!D2&D1&D&C1&!C&B1&!B&A1&A|D2&D1&D&C1&!C&B1&!B&A1&A|D2&!D1&D&C1&!C&B1&!B&A1&A|!D2&!D1&D&C1&!C&B1&!B&A1&A|D2&D1&D&!C1&!C&B1&!B&A1&A|D2&D1&D&!C1&!C&B1&B&A1&A|!D2&!D1&D&C1&!C&B1&B&A1&A|D2&!D1&D&C1&!C&B1&B&A1&A|D2&D1&D&C1&!C&B1&B&A1&A|!D2&D1&D&C1&!C&B1&B&A1&A|!D2&D1&!D&C1&!C&B1&B&A1&A|D2&D1&!D&C1&!C&B1&B&A1&A|D2&!D1&!D&C1&!C&B1&B&A1&A|!D2&!D1&!D&C1&!C&B1&B&A1&A|!D2&!D1&!D&C1&C&B1&B&A1&A|D2&!D1&!D&C1&C&B1&B&A1&A|D2&D1&!D&C1&C&B1&B&A1&A|!D2&D1&!D&C1&C&B1&B&A1&A|!D2&D1&D&C1&C&B1&B&A1&A|D2&D1&D&C1&C&B1&B&A1&A|D2&!D1&D&C1&C&B1&B&A1&A|!D2&!D1&D&C1&C&B1&B&A1&A|!D2&!D1&D&!C1&C&B1&B&A1&A|D2&!D1&D&!C1&C&B1&B&A1&A|D2&D1&D&!C1&C&B1&B&A1&A|!D2&D1&D&!C1&C&B1&B&A1&A|!D2&D1&!D&!C1&C&B1&B&A1&A|D2&D1&!D&!C1&C&B1&B&A1&A|D2&!D1&!D&!C1&C&B1&B&A1&A|!D2&!D1&!D&!C1&C&B1&B&A1&A|!D2&!D1&!D&!C1&C&!B1&B&A1&A|D2&!D1&!D&!C1&C&!B1&B&A1&A|D2&D1&!D&!C1&C&!B1&B&A1&A|!D2&D1&!D&!C1&C&!B1&B&A1&A|!D2&D1&D&!C1&C&!B1&B&A1&A|D2&D1&D&!C1&C&!B1&B&A1&A|D2&!D1&D&!C1&C&!B1&B&A1&A|!D2&!D1&D&!C1&C&!B1&B&A1&A|!D2&!D1&D&C1&C&!B1&B&A1&A|D2&!D1&D&C1&C&!B1&B&A1&A|D2&D1&D&C1&C&!B1&B&A1&A|!D2&D1&D&C1&C&!B1&B&A1&A|!D2&D1&!D&C1&C&!B1&B&A1&A|D2&D1&!D&C1&C&!B1&B&A1&A|D2&!D1&!D&C1&C&!B1&B&A1&A|!D2&!D1&!D&C1&C&!B1&B&A1&A|!D2&!D1&!D&C1&!C&!B1&B&A1&A|D2&!D1&!D&C1&!C&!B1&B&A1&A|D2&D1&!D&C1&!C&!B1&B&A1&A|!D2&D1&!D&C1&!C&!B1&B&A1&A|!D2&D1&D&C1&!C&!B1&B&A1&A|D2&D1&D&C1&!C&!B1&B&A1&A|D2&!D1&D&C1&!C&!B1&B&A1&A|!D2&!D1&D&C1&!C&!B1&B&A1&A|D2&D1&D&!C1&!C&!B1&B&A1&A|D2&D1&D&!C1&!C&!B1&B&!A1&A|D2&D1&D&C1&!C&!B1&B&!A1&A|D2&D1&D&C1&C&!B1&B&!A1&A|D2&D1&D&!C1&C&!B1&B&!A1&A|!D2&!D1&!D&!C1&C&B1&B&!A1&A|D2&!D1&!D&!C1&C&B1&B&!A1&A|D2&D1&!D&!C1&C&B1&B&!A1&A|!D2&D1&!D&!C1&C&B1&B&!A1&A|!D2&D1&D&!C1&C&B1&B&!A1&A|D2&D1&D&!C1&C&B1&B&!A1&A|D2&!D1&D&!C1&C&B1&B&!A1&A|!D2&!D1&D&!C1&C&B1&B&!A1&A|!D2&!D1&D&C1&C&B1&B&!A1&A|D2&!D1&D&C1&C&B1&B&!A1&A|D2&D1&D&C1&C&B1&B&!A1&A|!D2&D1&D&C1&C&B1&B&!A1&A|!D2&D1&!D&C1&C&B1&B&!A1&A|D2&D1&!D&C1&C&B1&B&!A1&A|D2&!D1&!D&C1&C&B1&B&!A1&A|!D2&!D1&!D&C1&C&B1&B&!A1&A|!D2&!D1&!D&C1&!C&B1&B&!A1&A|D2&!D1&!D&C1&!C&B1&B&!A1&A|D2&D1&!D&C1&!C&B1&B&!A1&A|!D2&D1&!D&C1&!C&B1&B&!A1&A|!D2&D1&D&C1&!C&B1&B&!A1&A|D2&D1&D&C1&!C&B1&B&!A1&A|D2&!D1&D&C1&!C&B1&B&!A1&A|!D2&!D1&D&C1&!C&B1&B&!A1&A|D2&D1&D&!C1&!C&B1&B&!A1&A|D2&D1&D&!C1&!C&B1&!B&!A1&A|D2&D1&D&C1&!C&B1&!B&!A1&A|D2&D1&D&C1&C&B1&!B&!A1&A|D2&D1&D&!C1&C&B1&!B&!A1&A|D2&D1&D&!C1&C&!B1&!B&!A1&A|D2&D1&D&C1&C&!B1&!B&!A1&A|D2&D1&D&C1&!C&!B1&!B&!A1&A|D2&D1&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAAOI2223.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOAI2112 -l OAOAI2112 -i D1 D C B A1 A -o Y -f Y=!(D1&D&C&!B&!A1&!A|D1&D&C&B&!A1&!A|D1&D&!C&B&A1&!A|D1&D&C&B&A1&!A|D1&D&C&!B&A1&!A|D1&D&C&!B&A1&A|D1&D&C&B&A1&A|D1&D&!C&B&A1&A|D1&D&!C&B&!A1&A|D1&D&C&B&!A1&A|D1&D&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOAI2112.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAOOAOI221121 -l AAOAOOAOI221121 -i F E1 E D C B1 B A1 A -o Y -f Y=(!F&!E1&!E&!D&!C&!B1&!B&!A1&!A|!F&E1&!E&!D&!C&!B1&!B&!A1&!A|!F&E1&E&!D&!C&!B1&!B&!A1&!A|!F&!E1&E&!D&!C&!B1&!B&!A1&!A|!F&!E1&!E&D&!C&!B1&!B&!A1&!A|!F&!E1&!E&D&C&!B1&!B&!A1&!A|!F&!E1&E&!D&C&!B1&!B&!A1&!A|!F&E1&E&!D&C&!B1&!B&!A1&!A|!F&E1&!E&!D&C&!B1&!B&!A1&!A|!F&!E1&!E&!D&C&!B1&!B&!A1&!A|!F&!E1&!E&!D&C&B1&!B&!A1&!A|!F&E1&!E&!D&C&B1&!B&!A1&!A|!F&E1&E&!D&C&B1&!B&!A1&!A|!F&!E1&E&!D&C&B1&!B&!A1&!A|!F&!E1&!E&D&C&B1&!B&!A1&!A|!F&!E1&!E&D&!C&B1&!B&!A1&!A|!F&!E1&E&!D&!C&B1&!B&!A1&!A|!F&E1&E&!D&!C&B1&!B&!A1&!A|!F&E1&!E&!D&!C&B1&!B&!A1&!A|!F&!E1&!E&!D&!C&B1&!B&!A1&!A|!F&!E1&!E&!D&!C&B1&B&!A1&!A|!F&E1&!E&!D&!C&B1&B&!A1&!A|!F&E1&E&!D&!C&B1&B&!A1&!A|!F&!E1&E&!D&!C&B1&B&!A1&!A|!F&!E1&!E&D&!C&B1&B&!A1&!A|!F&!E1&!E&D&C&B1&B&!A1&!A|!F&!E1&!E&!D&C&B1&B&!A1&!A|!F&!E1&!E&!D&C&!B1&B&!A1&!A|!F&E1&!E&!D&C&!B1&B&!A1&!A|!F&E1&E&!D&C&!B1&B&!A1&!A|!F&!E1&E&!D&C&!B1&B&!A1&!A|!F&!E1&!E&D&C&!B1&B&!A1&!A|!F&!E1&!E&D&!C&!B1&B&!A1&!A|!F&!E1&E&!D&!C&!B1&B&!A1&!A|!F&E1&E&!D&!C&!B1&B&!A1&!A|!F&E1&!E&!D&!C&!B1&B&!A1&!A|!F&!E1&!E&!D&!C&!B1&B&!A1&!A|!F&!E1&!E&!D&!C&!B1&B&A1&!A|!F&E1&!E&!D&!C&!B1&B&A1&!A|!F&E1&E&!D&!C&!B1&B&A1&!A|!F&!E1&E&!D&!C&!B1&B&A1&!A|!F&!E1&!E&D&!C&!B1&B&A1&!A|!F&!E1&!E&D&C&!B1&B&A1&!A|!F&!E1&E&!D&C&!B1&B&A1&!A|!F&E1&E&!D&C&!B1&B&A1&!A|!F&E1&!E&!D&C&!B1&B&A1&!A|!F&!E1&!E&!D&C&!B1&B&A1&!A|!F&!E1&!E&!D&C&B1&B&A1&!A|!F&!E1&!E&D&C&B1&B&A1&!A|!F&!E1&!E&D&!C&B1&B&A1&!A|!F&!E1&E&!D&!C&B1&B&A1&!A|!F&E1&E&!D&!C&B1&B&A1&!A|!F&E1&!E&!D&!C&B1&B&A1&!A|!F&!E1&!E&!D&!C&B1&B&A1&!A|!F&!E1&!E&!D&!C&B1&!B&A1&!A|!F&E1&!E&!D&!C&B1&!B&A1&!A|!F&E1&E&!D&!C&B1&!B&A1&!A|!F&!E1&E&!D&!C&B1&!B&A1&!A|!F&!E1&!E&D&!C&B1&!B&A1&!A|!F&!E1&!E&D&C&B1&!B&A1&!A|!F&!E1&E&!D&C&B1&!B&A1&!A|!F&E1&E&!D&C&B1&!B&A1&!A|!F&E1&!E&!D&C&B1&!B&A1&!A|!F&!E1&!E&!D&C&B1&!B&A1&!A|!F&!E1&!E&!D&C&!B1&!B&A1&!A|!F&E1&!E&!D&C&!B1&!B&A1&!A|!F&E1&E&!D&C&!B1&!B&A1&!A|!F&!E1&E&!D&C&!B1&!B&A1&!A|!F&!E1&!E&D&C&!B1&!B&A1&!A|!F&!E1&!E&D&!C&!B1&!B&A1&!A|!F&!E1&E&!D&!C&!B1&!B&A1&!A|!F&E1&E&!D&!C&!B1&!B&A1&!A|!F&E1&!E&!D&!C&!B1&!B&A1&!A|!F&!E1&!E&!D&!C&!B1&!B&A1&!A|!F&!E1&!E&!D&!C&!B1&!B&A1&A|!F&E1&!E&!D&!C&!B1&!B&A1&A|!F&E1&E&!D&!C&!B1&!B&A1&A|!F&!E1&E&!D&!C&!B1&!B&A1&A|!F&!E1&!E&D&!C&!B1&!B&A1&A|!F&!E1&!E&D&C&!B1&!B&A1&A|!F&!E1&!E&!D&C&!B1&!B&A1&A|!F&!E1&!E&!D&C&B1&!B&A1&A|!F&!E1&!E&D&C&B1&!B&A1&A|!F&!E1&!E&D&!C&B1&!B&A1&A|!F&!E1&E&!D&!C&B1&!B&A1&A|!F&E1&E&!D&!C&B1&!B&A1&A|!F&E1&!E&!D&!C&B1&!B&A1&A|!F&!E1&!E&!D&!C&B1&!B&A1&A|!F&!E1&!E&!D&!C&B1&B&A1&A|!F&E1&!E&!D&!C&B1&B&A1&A|!F&E1&E&!D&!C&B1&B&A1&A|!F&!E1&E&!D&!C&B1&B&A1&A|!F&!E1&!E&D&!C&B1&B&A1&A|!F&!E1&!E&D&C&B1&B&A1&A|!F&!E1&!E&!D&C&B1&B&A1&A|!F&!E1&!E&!D&C&!B1&B&A1&A|!F&!E1&!E&D&C&!B1&B&A1&A|!F&!E1&!E&D&!C&!B1&B&A1&A|!F&!E1&E&!D&!C&!B1&B&A1&A|!F&E1&E&!D&!C&!B1&B&A1&A|!F&E1&!E&!D&!C&!B1&B&A1&A|!F&!E1&!E&!D&!C&!B1&B&A1&A|!F&!E1&!E&!D&!C&!B1&B&!A1&A|!F&E1&!E&!D&!C&!B1&B&!A1&A|!F&E1&E&!D&!C&!B1&B&!A1&A|!F&!E1&E&!D&!C&!B1&B&!A1&A|!F&!E1&!E&D&!C&!B1&B&!A1&A|!F&!E1&!E&D&C&!B1&B&!A1&A|!F&!E1&E&!D&C&!B1&B&!A1&A|!F&E1&E&!D&C&!B1&B&!A1&A|!F&E1&!E&!D&C&!B1&B&!A1&A|!F&!E1&!E&!D&C&!B1&B&!A1&A|!F&!E1&!E&!D&C&B1&B&!A1&A|!F&!E1&!E&D&C&B1&B&!A1&A|!F&!E1&!E&D&!C&B1&B&!A1&A|!F&!E1&E&!D&!C&B1&B&!A1&A|!F&E1&E&!D&!C&B1&B&!A1&A|!F&E1&!E&!D&!C&B1&B&!A1&A|!F&!E1&!E&!D&!C&B1&B&!A1&A|!F&!E1&!E&!D&!C&B1&!B&!A1&A|!F&E1&!E&!D&!C&B1&!B&!A1&A|!F&E1&E&!D&!C&B1&!B&!A1&A|!F&!E1&E&!D&!C&B1&!B&!A1&A|!F&!E1&!E&D&!C&B1&!B&!A1&A|!F&!E1&!E&D&C&B1&!B&!A1&A|!F&!E1&E&!D&C&B1&!B&!A1&A|!F&E1&E&!D&C&B1&!B&!A1&A|!F&E1&!E&!D&C&B1&!B&!A1&A|!F&!E1&!E&!D&C&B1&!B&!A1&A|!F&!E1&!E&!D&C&!B1&!B&!A1&A|!F&E1&!E&!D&C&!B1&!B&!A1&A|!F&E1&E&!D&C&!B1&!B&!A1&A|!F&!E1&E&!D&C&!B1&!B&!A1&A|!F&!E1&!E&D&C&!B1&!B&!A1&A|!F&!E1&!E&D&!C&!B1&!B&!A1&A|!F&!E1&E&!D&!C&!B1&!B&!A1&A|!F&E1&E&!D&!C&!B1&!B&!A1&A|!F&E1&!E&!D&!C&!B1&!B&!A1&A|!F&!E1&!E&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAOOAOI221121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOAI22122 -l AAOAAOAI22122 -i E1 E D1 D C B1 B A1 A -o Y -f Y=!(E1&E&D1&D&!C&!B1&!B&!A1&!A|E1&E&D1&D&C&!B1&!B&!A1&!A|E1&E&D1&D&C&B1&!B&!A1&!A|E1&E&D1&D&!C&B1&!B&!A1&!A|E1&E&D1&D&!C&B1&B&!A1&!A|E1&E&!D1&D&C&B1&B&!A1&!A|E1&E&D1&D&C&B1&B&!A1&!A|E1&E&D1&!D&C&B1&B&!A1&!A|E1&E&!D1&!D&C&B1&B&!A1&!A|E1&E&D1&D&C&!B1&B&!A1&!A|E1&E&D1&D&!C&!B1&B&!A1&!A|E1&E&D1&D&!C&!B1&B&A1&!A|E1&E&D1&D&C&!B1&B&A1&!A|E1&E&!D1&!D&C&B1&B&A1&!A|E1&E&D1&!D&C&B1&B&A1&!A|E1&E&D1&D&C&B1&B&A1&!A|E1&E&!D1&D&C&B1&B&A1&!A|E1&E&D1&D&!C&B1&B&A1&!A|E1&E&D1&D&!C&B1&!B&A1&!A|E1&E&D1&D&C&B1&!B&A1&!A|E1&E&D1&D&C&!B1&!B&A1&!A|E1&E&D1&D&!C&!B1&!B&A1&!A|E1&E&D1&D&!C&!B1&!B&A1&A|E1&E&!D1&D&C&!B1&!B&A1&A|E1&E&D1&D&C&!B1&!B&A1&A|E1&E&D1&!D&C&!B1&!B&A1&A|E1&E&!D1&!D&C&!B1&!B&A1&A|E1&E&!D1&!D&C&B1&!B&A1&A|E1&E&D1&!D&C&B1&!B&A1&A|E1&E&D1&D&C&B1&!B&A1&A|E1&E&!D1&D&C&B1&!B&A1&A|E1&E&D1&D&!C&B1&!B&A1&A|E1&E&D1&D&!C&B1&B&A1&A|E1&E&!D1&D&C&B1&B&A1&A|E1&E&D1&D&C&B1&B&A1&A|E1&E&D1&!D&C&B1&B&A1&A|E1&E&!D1&!D&C&B1&B&A1&A|E1&E&!D1&!D&C&!B1&B&A1&A|E1&E&D1&!D&C&!B1&B&A1&A|E1&E&D1&D&C&!B1&B&A1&A|E1&E&!D1&D&C&!B1&B&A1&A|E1&E&D1&D&!C&!B1&B&A1&A|E1&E&D1&D&!C&!B1&B&!A1&A|E1&E&D1&D&C&!B1&B&!A1&A|E1&E&!D1&!D&C&B1&B&!A1&A|E1&E&D1&!D&C&B1&B&!A1&A|E1&E&D1&D&C&B1&B&!A1&A|E1&E&!D1&D&C&B1&B&!A1&A|E1&E&D1&D&!C&B1&B&!A1&A|E1&E&D1&D&!C&B1&!B&!A1&A|E1&E&D1&D&C&B1&!B&!A1&A|E1&E&D1&D&C&!B1&!B&!A1&A|E1&E&D1&D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOAI22122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOI2212 -l OOAAOI2212 -i D1 D C B1 B A1 A -o Y -f Y=!(D1&D&!C&!B1&!B&!A1&!A|D1&D&C&!B1&!B&!A1&!A|D1&D&C&B1&!B&!A1&!A|D1&D&!C&B1&!B&!A1&!A|D1&D&!C&B1&B&!A1&!A|D1&D&C&B1&B&!A1&!A|D1&D&C&!B1&B&!A1&!A|D1&D&!C&!B1&B&!A1&!A|D1&D&!C&!B1&B&A1&!A|!D1&D&C&!B1&B&A1&!A|D1&D&C&!B1&B&A1&!A|D1&!D&C&!B1&B&A1&!A|!D1&!D&C&!B1&B&A1&!A|!D1&!D&C&B1&B&A1&!A|D1&!D&C&B1&B&A1&!A|D1&D&C&B1&B&A1&!A|!D1&D&C&B1&B&A1&!A|D1&D&!C&B1&B&A1&!A|D1&D&!C&B1&!B&A1&!A|!D1&D&C&B1&!B&A1&!A|D1&D&C&B1&!B&A1&!A|D1&!D&C&B1&!B&A1&!A|!D1&!D&C&B1&!B&A1&!A|D1&D&C&!B1&!B&A1&!A|D1&D&!C&!B1&!B&A1&!A|D1&D&!C&!B1&!B&A1&A|D1&D&C&!B1&!B&A1&A|!D1&!D&C&B1&!B&A1&A|D1&!D&C&B1&!B&A1&A|D1&D&C&B1&!B&A1&A|!D1&D&C&B1&!B&A1&A|D1&D&!C&B1&!B&A1&A|D1&D&!C&B1&B&A1&A|!D1&D&C&B1&B&A1&A|D1&D&C&B1&B&A1&A|D1&!D&C&B1&B&A1&A|!D1&!D&C&B1&B&A1&A|!D1&!D&C&!B1&B&A1&A|D1&!D&C&!B1&B&A1&A|D1&D&C&!B1&B&A1&A|!D1&D&C&!B1&B&A1&A|D1&D&!C&!B1&B&A1&A|D1&D&!C&!B1&B&!A1&A|!D1&D&C&!B1&B&!A1&A|D1&D&C&!B1&B&!A1&A|D1&!D&C&!B1&B&!A1&A|!D1&!D&C&!B1&B&!A1&A|!D1&!D&C&B1&B&!A1&A|D1&!D&C&B1&B&!A1&A|D1&D&C&B1&B&!A1&A|!D1&D&C&B1&B&!A1&A|D1&D&!C&B1&B&!A1&A|D1&D&!C&B1&!B&!A1&A|!D1&D&C&B1&!B&!A1&A|D1&D&C&B1&!B&!A1&A|D1&!D&C&B1&!B&!A1&A|!D1&!D&C&B1&!B&!A1&A|D1&D&C&!B1&!B&!A1&A|D1&D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOI2212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOAI21321 -l AOOAAOAI21321 -i E D1 D C2 C1 C B A1 A -o Y -f Y=!(E&D1&D&!C2&!C1&!C&!B&!A1&!A|E&D1&D&C2&!C1&!C&!B&!A1&!A|E&D1&D&C2&C1&!C&!B&!A1&!A|E&D1&D&!C2&C1&!C&!B&!A1&!A|E&D1&D&!C2&C1&C&!B&!A1&!A|E&D1&D&C2&C1&C&!B&!A1&!A|E&D1&D&C2&!C1&C&!B&!A1&!A|E&D1&D&!C2&!C1&C&!B&!A1&!A|E&!D1&!D&!C2&!C1&C&B&!A1&!A|E&D1&!D&!C2&!C1&C&B&!A1&!A|E&D1&D&!C2&!C1&C&B&!A1&!A|E&!D1&D&!C2&!C1&C&B&!A1&!A|E&!D1&D&C2&!C1&C&B&!A1&!A|E&D1&D&C2&!C1&C&B&!A1&!A|E&D1&!D&C2&!C1&C&B&!A1&!A|E&!D1&!D&C2&!C1&C&B&!A1&!A|E&!D1&!D&C2&C1&C&B&!A1&!A|E&D1&!D&C2&C1&C&B&!A1&!A|E&D1&D&C2&C1&C&B&!A1&!A|E&!D1&D&C2&C1&C&B&!A1&!A|E&!D1&D&!C2&C1&C&B&!A1&!A|E&D1&D&!C2&C1&C&B&!A1&!A|E&D1&!D&!C2&C1&C&B&!A1&!A|E&!D1&!D&!C2&C1&C&B&!A1&!A|E&!D1&!D&!C2&C1&!C&B&!A1&!A|E&D1&!D&!C2&C1&!C&B&!A1&!A|E&D1&D&!C2&C1&!C&B&!A1&!A|E&!D1&D&!C2&C1&!C&B&!A1&!A|E&!D1&D&C2&C1&!C&B&!A1&!A|E&D1&D&C2&C1&!C&B&!A1&!A|E&D1&!D&C2&C1&!C&B&!A1&!A|E&!D1&!D&C2&C1&!C&B&!A1&!A|E&!D1&!D&C2&!C1&!C&B&!A1&!A|E&D1&!D&C2&!C1&!C&B&!A1&!A|E&D1&D&C2&!C1&!C&B&!A1&!A|E&!D1&D&C2&!C1&!C&B&!A1&!A|E&D1&D&!C2&!C1&!C&B&!A1&!A|E&D1&D&!C2&!C1&!C&B&A1&!A|E&!D1&D&C2&!C1&!C&B&A1&!A|E&D1&D&C2&!C1&!C&B&A1&!A|E&D1&!D&C2&!C1&!C&B&A1&!A|E&!D1&!D&C2&!C1&!C&B&A1&!A|E&!D1&!D&C2&C1&!C&B&A1&!A|E&D1&!D&C2&C1&!C&B&A1&!A|E&D1&D&C2&C1&!C&B&A1&!A|E&!D1&D&C2&C1&!C&B&A1&!A|E&!D1&D&!C2&C1&!C&B&A1&!A|E&D1&D&!C2&C1&!C&B&A1&!A|E&D1&!D&!C2&C1&!C&B&A1&!A|E&!D1&!D&!C2&C1&!C&B&A1&!A|E&!D1&!D&!C2&C1&C&B&A1&!A|E&D1&!D&!C2&C1&C&B&A1&!A|E&D1&D&!C2&C1&C&B&A1&!A|E&!D1&D&!C2&C1&C&B&A1&!A|E&!D1&D&C2&C1&C&B&A1&!A|E&D1&D&C2&C1&C&B&A1&!A|E&D1&!D&C2&C1&C&B&A1&!A|E&!D1&!D&C2&C1&C&B&A1&!A|E&!D1&!D&C2&!C1&C&B&A1&!A|E&D1&!D&C2&!C1&C&B&A1&!A|E&D1&D&C2&!C1&C&B&A1&!A|E&!D1&D&C2&!C1&C&B&A1&!A|E&!D1&D&!C2&!C1&C&B&A1&!A|E&D1&D&!C2&!C1&C&B&A1&!A|E&D1&!D&!C2&!C1&C&B&A1&!A|E&!D1&!D&!C2&!C1&C&B&A1&!A|E&D1&D&!C2&!C1&C&!B&A1&!A|E&D1&D&C2&!C1&C&!B&A1&!A|E&D1&D&C2&C1&C&!B&A1&!A|E&D1&D&!C2&C1&C&!B&A1&!A|E&D1&D&!C2&C1&!C&!B&A1&!A|E&D1&D&C2&C1&!C&!B&A1&!A|E&D1&D&C2&!C1&!C&!B&A1&!A|E&D1&D&!C2&!C1&!C&!B&A1&!A|E&D1&D&!C2&!C1&!C&!B&A1&A|E&!D1&D&C2&!C1&!C&!B&A1&A|E&D1&D&C2&!C1&!C&!B&A1&A|E&D1&!D&C2&!C1&!C&!B&A1&A|E&!D1&!D&C2&!C1&!C&!B&A1&A|E&!D1&!D&C2&C1&!C&!B&A1&A|E&D1&!D&C2&C1&!C&!B&A1&A|E&D1&D&C2&C1&!C&!B&A1&A|E&!D1&D&C2&C1&!C&!B&A1&A|E&!D1&D&!C2&C1&!C&!B&A1&A|E&D1&D&!C2&C1&!C&!B&A1&A|E&D1&!D&!C2&C1&!C&!B&A1&A|E&!D1&!D&!C2&C1&!C&!B&A1&A|E&!D1&!D&!C2&C1&C&!B&A1&A|E&D1&!D&!C2&C1&C&!B&A1&A|E&D1&D&!C2&C1&C&!B&A1&A|E&!D1&D&!C2&C1&C&!B&A1&A|E&!D1&D&C2&C1&C&!B&A1&A|E&D1&D&C2&C1&C&!B&A1&A|E&D1&!D&C2&C1&C&!B&A1&A|E&!D1&!D&C2&C1&C&!B&A1&A|E&!D1&!D&C2&!C1&C&!B&A1&A|E&D1&!D&C2&!C1&C&!B&A1&A|E&D1&D&C2&!C1&C&!B&A1&A|E&!D1&D&C2&!C1&C&!B&A1&A|E&!D1&D&!C2&!C1&C&!B&A1&A|E&D1&D&!C2&!C1&C&!B&A1&A|E&D1&!D&!C2&!C1&C&!B&A1&A|E&!D1&!D&!C2&!C1&C&!B&A1&A|E&!D1&!D&!C2&!C1&C&B&A1&A|E&D1&!D&!C2&!C1&C&B&A1&A|E&D1&D&!C2&!C1&C&B&A1&A|E&!D1&D&!C2&!C1&C&B&A1&A|E&!D1&D&C2&!C1&C&B&A1&A|E&D1&D&C2&!C1&C&B&A1&A|E&D1&!D&C2&!C1&C&B&A1&A|E&!D1&!D&C2&!C1&C&B&A1&A|E&!D1&!D&C2&C1&C&B&A1&A|E&D1&!D&C2&C1&C&B&A1&A|E&D1&D&C2&C1&C&B&A1&A|E&!D1&D&C2&C1&C&B&A1&A|E&!D1&D&!C2&C1&C&B&A1&A|E&D1&D&!C2&C1&C&B&A1&A|E&D1&!D&!C2&C1&C&B&A1&A|E&!D1&!D&!C2&C1&C&B&A1&A|E&!D1&!D&!C2&C1&!C&B&A1&A|E&D1&!D&!C2&C1&!C&B&A1&A|E&D1&D&!C2&C1&!C&B&A1&A|E&!D1&D&!C2&C1&!C&B&A1&A|E&!D1&D&C2&C1&!C&B&A1&A|E&D1&D&C2&C1&!C&B&A1&A|E&D1&!D&C2&C1&!C&B&A1&A|E&!D1&!D&C2&C1&!C&B&A1&A|E&!D1&!D&C2&!C1&!C&B&A1&A|E&D1&!D&C2&!C1&!C&B&A1&A|E&D1&D&C2&!C1&!C&B&A1&A|E&!D1&D&C2&!C1&!C&B&A1&A|E&D1&D&!C2&!C1&!C&B&A1&A|E&D1&D&!C2&!C1&!C&B&!A1&A|E&!D1&D&C2&!C1&!C&B&!A1&A|E&D1&D&C2&!C1&!C&B&!A1&A|E&D1&!D&C2&!C1&!C&B&!A1&A|E&!D1&!D&C2&!C1&!C&B&!A1&A|E&!D1&!D&C2&C1&!C&B&!A1&A|E&D1&!D&C2&C1&!C&B&!A1&A|E&D1&D&C2&C1&!C&B&!A1&A|E&!D1&D&C2&C1&!C&B&!A1&A|E&!D1&D&!C2&C1&!C&B&!A1&A|E&D1&D&!C2&C1&!C&B&!A1&A|E&D1&!D&!C2&C1&!C&B&!A1&A|E&!D1&!D&!C2&C1&!C&B&!A1&A|E&!D1&!D&!C2&C1&C&B&!A1&A|E&D1&!D&!C2&C1&C&B&!A1&A|E&D1&D&!C2&C1&C&B&!A1&A|E&!D1&D&!C2&C1&C&B&!A1&A|E&!D1&D&C2&C1&C&B&!A1&A|E&D1&D&C2&C1&C&B&!A1&A|E&D1&!D&C2&C1&C&B&!A1&A|E&!D1&!D&C2&C1&C&B&!A1&A|E&!D1&!D&C2&!C1&C&B&!A1&A|E&D1&!D&C2&!C1&C&B&!A1&A|E&D1&D&C2&!C1&C&B&!A1&A|E&!D1&D&C2&!C1&C&B&!A1&A|E&!D1&D&!C2&!C1&C&B&!A1&A|E&D1&D&!C2&!C1&C&B&!A1&A|E&D1&!D&!C2&!C1&C&B&!A1&A|E&!D1&!D&!C2&!C1&C&B&!A1&A|E&D1&D&!C2&!C1&C&!B&!A1&A|E&D1&D&C2&!C1&C&!B&!A1&A|E&D1&D&C2&C1&C&!B&!A1&A|E&D1&D&!C2&C1&C&!B&!A1&A|E&D1&D&!C2&C1&!C&!B&!A1&A|E&D1&D&C2&C1&!C&!B&!A1&A|E&D1&D&C2&!C1&!C&!B&!A1&A|E&D1&D&!C2&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOAI21321.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOOAOI21321 -l AOOOAOI21321 -i E D1 D C2 C1 C B A1 A -o Y -f Y=(!E&!D1&!D&!C2&!C1&!C&!B&!A1&!A|!E&D1&!D&!C2&!C1&!C&!B&!A1&!A|!E&D1&D&!C2&!C1&!C&!B&!A1&!A|!E&!D1&D&!C2&!C1&!C&!B&!A1&!A|!E&!D1&D&C2&!C1&!C&!B&!A1&!A|!E&D1&D&C2&!C1&!C&!B&!A1&!A|!E&D1&!D&C2&!C1&!C&!B&!A1&!A|!E&!D1&!D&C2&!C1&!C&!B&!A1&!A|!E&!D1&!D&C2&C1&!C&!B&!A1&!A|!E&D1&!D&C2&C1&!C&!B&!A1&!A|!E&D1&D&C2&C1&!C&!B&!A1&!A|!E&!D1&D&C2&C1&!C&!B&!A1&!A|!E&!D1&D&!C2&C1&!C&!B&!A1&!A|!E&D1&D&!C2&C1&!C&!B&!A1&!A|!E&D1&!D&!C2&C1&!C&!B&!A1&!A|!E&!D1&!D&!C2&C1&!C&!B&!A1&!A|!E&!D1&!D&!C2&C1&C&!B&!A1&!A|!E&D1&!D&!C2&C1&C&!B&!A1&!A|!E&D1&D&!C2&C1&C&!B&!A1&!A|!E&!D1&D&!C2&C1&C&!B&!A1&!A|!E&!D1&D&C2&C1&C&!B&!A1&!A|!E&D1&D&C2&C1&C&!B&!A1&!A|!E&D1&!D&C2&C1&C&!B&!A1&!A|!E&!D1&!D&C2&C1&C&!B&!A1&!A|!E&!D1&!D&C2&!C1&C&!B&!A1&!A|!E&D1&!D&C2&!C1&C&!B&!A1&!A|!E&D1&D&C2&!C1&C&!B&!A1&!A|!E&!D1&D&C2&!C1&C&!B&!A1&!A|!E&!D1&D&!C2&!C1&C&!B&!A1&!A|!E&D1&D&!C2&!C1&C&!B&!A1&!A|!E&D1&!D&!C2&!C1&C&!B&!A1&!A|!E&!D1&!D&!C2&!C1&C&!B&!A1&!A|!E&!D1&!D&!C2&!C1&C&B&!A1&!A|!E&!D1&!D&C2&!C1&C&B&!A1&!A|!E&!D1&!D&C2&C1&C&B&!A1&!A|!E&!D1&!D&!C2&C1&C&B&!A1&!A|!E&!D1&!D&!C2&C1&!C&B&!A1&!A|!E&!D1&!D&C2&C1&!C&B&!A1&!A|!E&!D1&!D&C2&!C1&!C&B&!A1&!A|!E&!D1&D&!C2&!C1&!C&B&!A1&!A|!E&D1&D&!C2&!C1&!C&B&!A1&!A|!E&D1&!D&!C2&!C1&!C&B&!A1&!A|!E&!D1&!D&!C2&!C1&!C&B&!A1&!A|!E&!D1&!D&!C2&!C1&!C&B&A1&!A|!E&D1&!D&!C2&!C1&!C&B&A1&!A|!E&D1&D&!C2&!C1&!C&B&A1&!A|!E&!D1&D&!C2&!C1&!C&B&A1&!A|!E&!D1&!D&C2&!C1&!C&B&A1&!A|!E&!D1&!D&C2&C1&!C&B&A1&!A|!E&!D1&!D&!C2&C1&!C&B&A1&!A|!E&!D1&!D&!C2&C1&C&B&A1&!A|!E&!D1&!D&C2&C1&C&B&A1&!A|!E&!D1&!D&C2&!C1&C&B&A1&!A|!E&!D1&!D&!C2&!C1&C&B&A1&!A|!E&!D1&!D&!C2&!C1&C&!B&A1&!A|!E&D1&!D&!C2&!C1&C&!B&A1&!A|!E&D1&D&!C2&!C1&C&!B&A1&!A|!E&!D1&D&!C2&!C1&C&!B&A1&!A|!E&!D1&D&C2&!C1&C&!B&A1&!A|!E&D1&D&C2&!C1&C&!B&A1&!A|!E&D1&!D&C2&!C1&C&!B&A1&!A|!E&!D1&!D&C2&!C1&C&!B&A1&!A|!E&!D1&!D&C2&C1&C&!B&A1&!A|!E&D1&!D&C2&C1&C&!B&A1&!A|!E&D1&D&C2&C1&C&!B&A1&!A|!E&!D1&D&C2&C1&C&!B&A1&!A|!E&!D1&D&!C2&C1&C&!B&A1&!A|!E&D1&D&!C2&C1&C&!B&A1&!A|!E&D1&!D&!C2&C1&C&!B&A1&!A|!E&!D1&!D&!C2&C1&C&!B&A1&!A|!E&!D1&!D&!C2&C1&!C&!B&A1&!A|!E&D1&!D&!C2&C1&!C&!B&A1&!A|!E&D1&D&!C2&C1&!C&!B&A1&!A|!E&!D1&D&!C2&C1&!C&!B&A1&!A|!E&!D1&D&C2&C1&!C&!B&A1&!A|!E&D1&D&C2&C1&!C&!B&A1&!A|!E&D1&!D&C2&C1&!C&!B&A1&!A|!E&!D1&!D&C2&C1&!C&!B&A1&!A|!E&!D1&!D&C2&!C1&!C&!B&A1&!A|!E&D1&!D&C2&!C1&!C&!B&A1&!A|!E&D1&D&C2&!C1&!C&!B&A1&!A|!E&!D1&D&C2&!C1&!C&!B&A1&!A|!E&!D1&D&!C2&!C1&!C&!B&A1&!A|!E&D1&D&!C2&!C1&!C&!B&A1&!A|!E&D1&!D&!C2&!C1&!C&!B&A1&!A|!E&!D1&!D&!C2&!C1&!C&!B&A1&!A|!E&!D1&!D&!C2&!C1&!C&!B&A1&A|!E&D1&!D&!C2&!C1&!C&!B&A1&A|!E&D1&D&!C2&!C1&!C&!B&A1&A|!E&!D1&D&!C2&!C1&!C&!B&A1&A|!E&!D1&!D&C2&!C1&!C&!B&A1&A|!E&!D1&!D&C2&C1&!C&!B&A1&A|!E&!D1&!D&!C2&C1&!C&!B&A1&A|!E&!D1&!D&!C2&C1&C&!B&A1&A|!E&!D1&!D&C2&C1&C&!B&A1&A|!E&!D1&!D&C2&!C1&C&!B&A1&A|!E&!D1&!D&!C2&!C1&C&!B&A1&A|!E&!D1&!D&!C2&!C1&C&B&A1&A|!E&!D1&!D&C2&!C1&C&B&A1&A|!E&!D1&!D&C2&C1&C&B&A1&A|!E&!D1&!D&!C2&C1&C&B&A1&A|!E&!D1&!D&!C2&C1&!C&B&A1&A|!E&!D1&!D&C2&C1&!C&B&A1&A|!E&!D1&!D&C2&!C1&!C&B&A1&A|!E&!D1&D&!C2&!C1&!C&B&A1&A|!E&D1&D&!C2&!C1&!C&B&A1&A|!E&D1&!D&!C2&!C1&!C&B&A1&A|!E&!D1&!D&!C2&!C1&!C&B&A1&A|!E&!D1&!D&!C2&!C1&!C&B&!A1&A|!E&D1&!D&!C2&!C1&!C&B&!A1&A|!E&D1&D&!C2&!C1&!C&B&!A1&A|!E&!D1&D&!C2&!C1&!C&B&!A1&A|!E&!D1&!D&C2&!C1&!C&B&!A1&A|!E&!D1&!D&C2&C1&!C&B&!A1&A|!E&!D1&!D&!C2&C1&!C&B&!A1&A|!E&!D1&!D&!C2&C1&C&B&!A1&A|!E&!D1&!D&C2&C1&C&B&!A1&A|!E&!D1&!D&C2&!C1&C&B&!A1&A|!E&!D1&!D&!C2&!C1&C&B&!A1&A|!E&!D1&!D&!C2&!C1&C&!B&!A1&A|!E&D1&!D&!C2&!C1&C&!B&!A1&A|!E&D1&D&!C2&!C1&C&!B&!A1&A|!E&!D1&D&!C2&!C1&C&!B&!A1&A|!E&!D1&D&C2&!C1&C&!B&!A1&A|!E&D1&D&C2&!C1&C&!B&!A1&A|!E&D1&!D&C2&!C1&C&!B&!A1&A|!E&!D1&!D&C2&!C1&C&!B&!A1&A|!E&!D1&!D&C2&C1&C&!B&!A1&A|!E&D1&!D&C2&C1&C&!B&!A1&A|!E&D1&D&C2&C1&C&!B&!A1&A|!E&!D1&D&C2&C1&C&!B&!A1&A|!E&!D1&D&!C2&C1&C&!B&!A1&A|!E&D1&D&!C2&C1&C&!B&!A1&A|!E&D1&!D&!C2&C1&C&!B&!A1&A|!E&!D1&!D&!C2&C1&C&!B&!A1&A|!E&!D1&!D&!C2&C1&!C&!B&!A1&A|!E&D1&!D&!C2&C1&!C&!B&!A1&A|!E&D1&D&!C2&C1&!C&!B&!A1&A|!E&!D1&D&!C2&C1&!C&!B&!A1&A|!E&!D1&D&C2&C1&!C&!B&!A1&A|!E&D1&D&C2&C1&!C&!B&!A1&A|!E&D1&!D&C2&C1&!C&!B&!A1&A|!E&!D1&!D&C2&C1&!C&!B&!A1&A|!E&!D1&!D&C2&!C1&!C&!B&!A1&A|!E&D1&!D&C2&!C1&!C&!B&!A1&A|!E&D1&D&C2&!C1&!C&!B&!A1&A|!E&!D1&D&C2&!C1&!C&!B&!A1&A|!E&!D1&D&!C2&!C1&!C&!B&!A1&A|!E&D1&D&!C2&!C1&!C&!B&!A1&A|!E&D1&!D&!C2&!C1&!C&!B&!A1&A|!E&!D1&!D&!C2&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOOAOI21321.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAI2213 -l AAOOAI2213 -i D2 D1 D C B1 B A1 A -o Y -f Y=(!D2&!D1&!D&!C&!B1&!B&!A1&!A|D2&!D1&!D&!C&!B1&!B&!A1&!A|D2&D1&!D&!C&!B1&!B&!A1&!A|!D2&D1&!D&!C&!B1&!B&!A1&!A|!D2&D1&D&!C&!B1&!B&!A1&!A|D2&D1&D&!C&!B1&!B&!A1&!A|D2&!D1&D&!C&!B1&!B&!A1&!A|!D2&!D1&D&!C&!B1&!B&!A1&!A|!D2&!D1&!D&C&!B1&!B&!A1&!A|!D2&!D1&!D&C&B1&!B&!A1&!A|!D2&!D1&D&!C&B1&!B&!A1&!A|D2&!D1&D&!C&B1&!B&!A1&!A|D2&D1&D&!C&B1&!B&!A1&!A|!D2&D1&D&!C&B1&!B&!A1&!A|!D2&D1&!D&!C&B1&!B&!A1&!A|D2&D1&!D&!C&B1&!B&!A1&!A|D2&!D1&!D&!C&B1&!B&!A1&!A|!D2&!D1&!D&!C&B1&!B&!A1&!A|!D2&!D1&!D&!C&B1&B&!A1&!A|!D2&!D1&!D&C&B1&B&!A1&!A|!D2&!D1&!D&C&!B1&B&!A1&!A|!D2&!D1&D&!C&!B1&B&!A1&!A|D2&!D1&D&!C&!B1&B&!A1&!A|D2&D1&D&!C&!B1&B&!A1&!A|!D2&D1&D&!C&!B1&B&!A1&!A|!D2&D1&!D&!C&!B1&B&!A1&!A|D2&D1&!D&!C&!B1&B&!A1&!A|D2&!D1&!D&!C&!B1&B&!A1&!A|!D2&!D1&!D&!C&!B1&B&!A1&!A|!D2&!D1&!D&!C&!B1&B&A1&!A|D2&!D1&!D&!C&!B1&B&A1&!A|D2&D1&!D&!C&!B1&B&A1&!A|!D2&D1&!D&!C&!B1&B&A1&!A|!D2&D1&D&!C&!B1&B&A1&!A|D2&D1&D&!C&!B1&B&A1&!A|D2&!D1&D&!C&!B1&B&A1&!A|!D2&!D1&D&!C&!B1&B&A1&!A|!D2&!D1&!D&C&!B1&B&A1&!A|!D2&!D1&!D&C&B1&B&A1&!A|!D2&!D1&!D&!C&B1&B&A1&!A|!D2&!D1&!D&!C&B1&!B&A1&!A|D2&!D1&!D&!C&B1&!B&A1&!A|D2&D1&!D&!C&B1&!B&A1&!A|!D2&D1&!D&!C&B1&!B&A1&!A|!D2&D1&D&!C&B1&!B&A1&!A|D2&D1&D&!C&B1&!B&A1&!A|D2&!D1&D&!C&B1&!B&A1&!A|!D2&!D1&D&!C&B1&!B&A1&!A|!D2&!D1&!D&C&B1&!B&A1&!A|!D2&!D1&!D&C&!B1&!B&A1&!A|!D2&!D1&D&!C&!B1&!B&A1&!A|D2&!D1&D&!C&!B1&!B&A1&!A|D2&D1&D&!C&!B1&!B&A1&!A|!D2&D1&D&!C&!B1&!B&A1&!A|!D2&D1&!D&!C&!B1&!B&A1&!A|D2&D1&!D&!C&!B1&!B&A1&!A|D2&!D1&!D&!C&!B1&!B&A1&!A|!D2&!D1&!D&!C&!B1&!B&A1&!A|!D2&!D1&!D&!C&!B1&!B&A1&A|!D2&!D1&!D&C&!B1&!B&A1&A|!D2&!D1&!D&C&B1&!B&A1&A|!D2&!D1&!D&!C&B1&!B&A1&A|!D2&!D1&!D&!C&B1&B&A1&A|!D2&!D1&!D&C&B1&B&A1&A|!D2&!D1&!D&C&!B1&B&A1&A|!D2&!D1&!D&!C&!B1&B&A1&A|!D2&!D1&!D&!C&!B1&B&!A1&A|D2&!D1&!D&!C&!B1&B&!A1&A|D2&D1&!D&!C&!B1&B&!A1&A|!D2&D1&!D&!C&!B1&B&!A1&A|!D2&D1&D&!C&!B1&B&!A1&A|D2&D1&D&!C&!B1&B&!A1&A|D2&!D1&D&!C&!B1&B&!A1&A|!D2&!D1&D&!C&!B1&B&!A1&A|!D2&!D1&!D&C&!B1&B&!A1&A|!D2&!D1&!D&C&B1&B&!A1&A|!D2&!D1&!D&!C&B1&B&!A1&A|!D2&!D1&!D&!C&B1&!B&!A1&A|D2&!D1&!D&!C&B1&!B&!A1&A|D2&D1&!D&!C&B1&!B&!A1&A|!D2&D1&!D&!C&B1&!B&!A1&A|!D2&D1&D&!C&B1&!B&!A1&A|D2&D1&D&!C&B1&!B&!A1&A|D2&!D1&D&!C&B1&!B&!A1&A|!D2&!D1&D&!C&B1&!B&!A1&A|!D2&!D1&!D&C&B1&!B&!A1&A|!D2&!D1&!D&C&!B1&!B&!A1&A|!D2&!D1&D&!C&!B1&!B&!A1&A|D2&!D1&D&!C&!B1&!B&!A1&A|D2&D1&D&!C&!B1&!B&!A1&A|!D2&D1&D&!C&!B1&!B&!A1&A|!D2&D1&!D&!C&!B1&!B&!A1&A|D2&D1&!D&!C&!B1&!B&!A1&A|D2&!D1&!D&!C&!B1&!B&!A1&A|!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAI2213.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAAOOAI22232 -l AAOOAAOOAI22232 -i E1 E D2 D1 D C1 C B1 B A1 A -o Y -f Y=!(!E1&E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|E1&E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|E1&E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&C1&C&!B1&!B&!A1&!A|E1&E&D2&D1&D&C1&C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&C1&C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|E1&E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&!C1&C&B1&!B&!A1&!A|E1&E&D2&D1&D&!C1&C&B1&!B&!A1&!A|E1&!E&D2&D1&D&!C1&C&B1&!B&!A1&!A|E1&!E&D2&D1&D&C1&C&B1&!B&!A1&!A|E1&E&D2&D1&D&C1&C&B1&!B&!A1&!A|!E1&E&D2&D1&D&C1&C&B1&!B&!A1&!A|!E1&E&D2&D1&D&C1&!C&B1&!B&!A1&!A|E1&E&D2&D1&D&C1&!C&B1&!B&!A1&!A|E1&!E&D2&D1&D&C1&!C&B1&!B&!A1&!A|E1&!E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|E1&E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E1&E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E1&E&D2&D1&D&!C1&!C&B1&B&!A1&!A|E1&E&D2&D1&D&!C1&!C&B1&B&!A1&!A|E1&!E&D2&D1&D&!C1&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|E1&E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|!E1&E&D2&!D1&D&C1&!C&B1&B&!A1&!A|E1&E&D2&!D1&D&C1&!C&B1&B&!A1&!A|E1&!E&D2&!D1&D&C1&!C&B1&B&!A1&!A|E1&!E&D2&D1&D&C1&!C&B1&B&!A1&!A|E1&E&D2&D1&D&C1&!C&B1&B&!A1&!A|!E1&E&D2&D1&D&C1&!C&B1&B&!A1&!A|!E1&E&!D2&D1&D&C1&!C&B1&B&!A1&!A|E1&E&!D2&D1&D&C1&!C&B1&B&!A1&!A|E1&!E&!D2&D1&D&C1&!C&B1&B&!A1&!A|E1&!E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|E1&E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|!E1&E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|!E1&E&D2&D1&!D&C1&!C&B1&B&!A1&!A|E1&E&D2&D1&!D&C1&!C&B1&B&!A1&!A|E1&!E&D2&D1&!D&C1&!C&B1&B&!A1&!A|E1&!E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|E1&E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|!E1&E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|E1&E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|E1&E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|!E1&E&D2&!D1&!D&C1&C&B1&B&!A1&!A|E1&E&D2&!D1&!D&C1&C&B1&B&!A1&!A|E1&!E&D2&!D1&!D&C1&C&B1&B&!A1&!A|E1&!E&D2&D1&!D&C1&C&B1&B&!A1&!A|E1&E&D2&D1&!D&C1&C&B1&B&!A1&!A|!E1&E&D2&D1&!D&C1&C&B1&B&!A1&!A|!E1&E&!D2&D1&!D&C1&C&B1&B&!A1&!A|E1&E&!D2&D1&!D&C1&C&B1&B&!A1&!A|E1&!E&!D2&D1&!D&C1&C&B1&B&!A1&!A|E1&!E&!D2&D1&D&C1&C&B1&B&!A1&!A|E1&E&!D2&D1&D&C1&C&B1&B&!A1&!A|!E1&E&!D2&D1&D&C1&C&B1&B&!A1&!A|!E1&E&D2&D1&D&C1&C&B1&B&!A1&!A|E1&E&D2&D1&D&C1&C&B1&B&!A1&!A|E1&!E&D2&D1&D&C1&C&B1&B&!A1&!A|E1&!E&D2&!D1&D&C1&C&B1&B&!A1&!A|E1&E&D2&!D1&D&C1&C&B1&B&!A1&!A|!E1&E&D2&!D1&D&C1&C&B1&B&!A1&!A|!E1&E&!D2&!D1&D&C1&C&B1&B&!A1&!A|E1&E&!D2&!D1&D&C1&C&B1&B&!A1&!A|E1&!E&!D2&!D1&D&C1&C&B1&B&!A1&!A|E1&!E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|E1&E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|!E1&E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|!E1&E&D2&!D1&D&!C1&C&B1&B&!A1&!A|E1&E&D2&!D1&D&!C1&C&B1&B&!A1&!A|E1&!E&D2&!D1&D&!C1&C&B1&B&!A1&!A|E1&!E&D2&D1&D&!C1&C&B1&B&!A1&!A|E1&E&D2&D1&D&!C1&C&B1&B&!A1&!A|!E1&E&D2&D1&D&!C1&C&B1&B&!A1&!A|!E1&E&!D2&D1&D&!C1&C&B1&B&!A1&!A|E1&E&!D2&D1&D&!C1&C&B1&B&!A1&!A|E1&!E&!D2&D1&D&!C1&C&B1&B&!A1&!A|E1&!E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|E1&E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|!E1&E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|!E1&E&D2&D1&!D&!C1&C&B1&B&!A1&!A|E1&E&D2&D1&!D&!C1&C&B1&B&!A1&!A|E1&!E&D2&D1&!D&!C1&C&B1&B&!A1&!A|E1&!E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|E1&E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|!E1&E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|E1&E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!E1&E&D2&D1&D&!C1&C&!B1&B&!A1&!A|E1&E&D2&D1&D&!C1&C&!B1&B&!A1&!A|E1&!E&D2&D1&D&!C1&C&!B1&B&!A1&!A|E1&!E&D2&D1&D&C1&C&!B1&B&!A1&!A|E1&E&D2&D1&D&C1&C&!B1&B&!A1&!A|!E1&E&D2&D1&D&C1&C&!B1&B&!A1&!A|!E1&E&D2&D1&D&C1&!C&!B1&B&!A1&!A|E1&E&D2&D1&D&C1&!C&!B1&B&!A1&!A|E1&!E&D2&D1&D&C1&!C&!B1&B&!A1&!A|E1&!E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|E1&E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E1&E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E1&E&D2&D1&D&!C1&!C&!B1&B&A1&!A|E1&E&D2&D1&D&!C1&!C&!B1&B&A1&!A|E1&!E&D2&D1&D&!C1&!C&!B1&B&A1&!A|E1&!E&D2&D1&D&C1&!C&!B1&B&A1&!A|E1&E&D2&D1&D&C1&!C&!B1&B&A1&!A|!E1&E&D2&D1&D&C1&!C&!B1&B&A1&!A|!E1&E&D2&D1&D&C1&C&!B1&B&A1&!A|E1&E&D2&D1&D&C1&C&!B1&B&A1&!A|E1&!E&D2&D1&D&C1&C&!B1&B&A1&!A|E1&!E&D2&D1&D&!C1&C&!B1&B&A1&!A|E1&E&D2&D1&D&!C1&C&!B1&B&A1&!A|!E1&E&D2&D1&D&!C1&C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|E1&E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|!E1&E&D2&!D1&!D&!C1&C&B1&B&A1&!A|E1&E&D2&!D1&!D&!C1&C&B1&B&A1&!A|E1&!E&D2&!D1&!D&!C1&C&B1&B&A1&!A|E1&!E&D2&D1&!D&!C1&C&B1&B&A1&!A|E1&E&D2&D1&!D&!C1&C&B1&B&A1&!A|!E1&E&D2&D1&!D&!C1&C&B1&B&A1&!A|!E1&E&!D2&D1&!D&!C1&C&B1&B&A1&!A|E1&E&!D2&D1&!D&!C1&C&B1&B&A1&!A|E1&!E&!D2&D1&!D&!C1&C&B1&B&A1&!A|E1&!E&!D2&D1&D&!C1&C&B1&B&A1&!A|E1&E&!D2&D1&D&!C1&C&B1&B&A1&!A|!E1&E&!D2&D1&D&!C1&C&B1&B&A1&!A|!E1&E&D2&D1&D&!C1&C&B1&B&A1&!A|E1&E&D2&D1&D&!C1&C&B1&B&A1&!A|E1&!E&D2&D1&D&!C1&C&B1&B&A1&!A|E1&!E&D2&!D1&D&!C1&C&B1&B&A1&!A|E1&E&D2&!D1&D&!C1&C&B1&B&A1&!A|!E1&E&D2&!D1&D&!C1&C&B1&B&A1&!A|!E1&E&!D2&!D1&D&!C1&C&B1&B&A1&!A|E1&E&!D2&!D1&D&!C1&C&B1&B&A1&!A|E1&!E&!D2&!D1&D&!C1&C&B1&B&A1&!A|E1&!E&!D2&!D1&D&C1&C&B1&B&A1&!A|E1&E&!D2&!D1&D&C1&C&B1&B&A1&!A|!E1&E&!D2&!D1&D&C1&C&B1&B&A1&!A|!E1&E&D2&!D1&D&C1&C&B1&B&A1&!A|E1&E&D2&!D1&D&C1&C&B1&B&A1&!A|E1&!E&D2&!D1&D&C1&C&B1&B&A1&!A|E1&!E&D2&D1&D&C1&C&B1&B&A1&!A|E1&E&D2&D1&D&C1&C&B1&B&A1&!A|!E1&E&D2&D1&D&C1&C&B1&B&A1&!A|!E1&E&!D2&D1&D&C1&C&B1&B&A1&!A|E1&E&!D2&D1&D&C1&C&B1&B&A1&!A|E1&!E&!D2&D1&D&C1&C&B1&B&A1&!A|E1&!E&!D2&D1&!D&C1&C&B1&B&A1&!A|E1&E&!D2&D1&!D&C1&C&B1&B&A1&!A|!E1&E&!D2&D1&!D&C1&C&B1&B&A1&!A|!E1&E&D2&D1&!D&C1&C&B1&B&A1&!A|E1&E&D2&D1&!D&C1&C&B1&B&A1&!A|E1&!E&D2&D1&!D&C1&C&B1&B&A1&!A|E1&!E&D2&!D1&!D&C1&C&B1&B&A1&!A|E1&E&D2&!D1&!D&C1&C&B1&B&A1&!A|!E1&E&D2&!D1&!D&C1&C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&C1&C&B1&B&A1&!A|E1&E&!D2&!D1&!D&C1&C&B1&B&A1&!A|E1&!E&!D2&!D1&!D&C1&C&B1&B&A1&!A|E1&!E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|E1&E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|!E1&E&D2&!D1&!D&C1&!C&B1&B&A1&!A|E1&E&D2&!D1&!D&C1&!C&B1&B&A1&!A|E1&!E&D2&!D1&!D&C1&!C&B1&B&A1&!A|E1&!E&D2&D1&!D&C1&!C&B1&B&A1&!A|E1&E&D2&D1&!D&C1&!C&B1&B&A1&!A|!E1&E&D2&D1&!D&C1&!C&B1&B&A1&!A|!E1&E&!D2&D1&!D&C1&!C&B1&B&A1&!A|E1&E&!D2&D1&!D&C1&!C&B1&B&A1&!A|E1&!E&!D2&D1&!D&C1&!C&B1&B&A1&!A|E1&!E&!D2&D1&D&C1&!C&B1&B&A1&!A|E1&E&!D2&D1&D&C1&!C&B1&B&A1&!A|!E1&E&!D2&D1&D&C1&!C&B1&B&A1&!A|!E1&E&D2&D1&D&C1&!C&B1&B&A1&!A|E1&E&D2&D1&D&C1&!C&B1&B&A1&!A|E1&!E&D2&D1&D&C1&!C&B1&B&A1&!A|E1&!E&D2&!D1&D&C1&!C&B1&B&A1&!A|E1&E&D2&!D1&D&C1&!C&B1&B&A1&!A|!E1&E&D2&!D1&D&C1&!C&B1&B&A1&!A|!E1&E&!D2&!D1&D&C1&!C&B1&B&A1&!A|E1&E&!D2&!D1&D&C1&!C&B1&B&A1&!A|E1&!E&!D2&!D1&D&C1&!C&B1&B&A1&!A|E1&!E&D2&D1&D&!C1&!C&B1&B&A1&!A|E1&E&D2&D1&D&!C1&!C&B1&B&A1&!A|!E1&E&D2&D1&D&!C1&!C&B1&B&A1&!A|!E1&E&D2&D1&D&!C1&!C&B1&!B&A1&!A|E1&E&D2&D1&D&!C1&!C&B1&!B&A1&!A|E1&!E&D2&D1&D&!C1&!C&B1&!B&A1&!A|E1&!E&D2&D1&D&C1&!C&B1&!B&A1&!A|E1&E&D2&D1&D&C1&!C&B1&!B&A1&!A|!E1&E&D2&D1&D&C1&!C&B1&!B&A1&!A|!E1&E&D2&D1&D&C1&C&B1&!B&A1&!A|E1&E&D2&D1&D&C1&C&B1&!B&A1&!A|E1&!E&D2&D1&D&C1&C&B1&!B&A1&!A|E1&!E&D2&D1&D&!C1&C&B1&!B&A1&!A|E1&E&D2&D1&D&!C1&C&B1&!B&A1&!A|!E1&E&D2&D1&D&!C1&C&B1&!B&A1&!A|!E1&E&D2&D1&D&!C1&C&!B1&!B&A1&!A|E1&E&D2&D1&D&!C1&C&!B1&!B&A1&!A|E1&!E&D2&D1&D&!C1&C&!B1&!B&A1&!A|E1&!E&D2&D1&D&C1&C&!B1&!B&A1&!A|E1&E&D2&D1&D&C1&C&!B1&!B&A1&!A|!E1&E&D2&D1&D&C1&C&!B1&!B&A1&!A|!E1&E&D2&D1&D&C1&!C&!B1&!B&A1&!A|E1&E&D2&D1&D&C1&!C&!B1&!B&A1&!A|E1&!E&D2&D1&D&C1&!C&!B1&!B&A1&!A|E1&!E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|E1&E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E1&E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E1&E&D2&D1&D&!C1&!C&!B1&!B&A1&A|E1&E&D2&D1&D&!C1&!C&!B1&!B&A1&A|E1&!E&D2&D1&D&!C1&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|E1&E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|!E1&E&D2&!D1&D&C1&!C&!B1&!B&A1&A|E1&E&D2&!D1&D&C1&!C&!B1&!B&A1&A|E1&!E&D2&!D1&D&C1&!C&!B1&!B&A1&A|E1&!E&D2&D1&D&C1&!C&!B1&!B&A1&A|E1&E&D2&D1&D&C1&!C&!B1&!B&A1&A|!E1&E&D2&D1&D&C1&!C&!B1&!B&A1&A|!E1&E&!D2&D1&D&C1&!C&!B1&!B&A1&A|E1&E&!D2&D1&D&C1&!C&!B1&!B&A1&A|E1&!E&!D2&D1&D&C1&!C&!B1&!B&A1&A|E1&!E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|E1&E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|!E1&E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|!E1&E&D2&D1&!D&C1&!C&!B1&!B&A1&A|E1&E&D2&D1&!D&C1&!C&!B1&!B&A1&A|E1&!E&D2&D1&!D&C1&!C&!B1&!B&A1&A|E1&!E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|E1&E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|!E1&E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|E1&E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|E1&E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|!E1&E&D2&!D1&!D&C1&C&!B1&!B&A1&A|E1&E&D2&!D1&!D&C1&C&!B1&!B&A1&A|E1&!E&D2&!D1&!D&C1&C&!B1&!B&A1&A|E1&!E&D2&D1&!D&C1&C&!B1&!B&A1&A|E1&E&D2&D1&!D&C1&C&!B1&!B&A1&A|!E1&E&D2&D1&!D&C1&C&!B1&!B&A1&A|!E1&E&!D2&D1&!D&C1&C&!B1&!B&A1&A|E1&E&!D2&D1&!D&C1&C&!B1&!B&A1&A|E1&!E&!D2&D1&!D&C1&C&!B1&!B&A1&A|E1&!E&!D2&D1&D&C1&C&!B1&!B&A1&A|E1&E&!D2&D1&D&C1&C&!B1&!B&A1&A|!E1&E&!D2&D1&D&C1&C&!B1&!B&A1&A|!E1&E&D2&D1&D&C1&C&!B1&!B&A1&A|E1&E&D2&D1&D&C1&C&!B1&!B&A1&A|E1&!E&D2&D1&D&C1&C&!B1&!B&A1&A|E1&!E&D2&!D1&D&C1&C&!B1&!B&A1&A|E1&E&D2&!D1&D&C1&C&!B1&!B&A1&A|!E1&E&D2&!D1&D&C1&C&!B1&!B&A1&A|!E1&E&!D2&!D1&D&C1&C&!B1&!B&A1&A|E1&E&!D2&!D1&D&C1&C&!B1&!B&A1&A|E1&!E&!D2&!D1&D&C1&C&!B1&!B&A1&A|E1&!E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|E1&E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|!E1&E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|!E1&E&D2&!D1&D&!C1&C&!B1&!B&A1&A|E1&E&D2&!D1&D&!C1&C&!B1&!B&A1&A|E1&!E&D2&!D1&D&!C1&C&!B1&!B&A1&A|E1&!E&D2&D1&D&!C1&C&!B1&!B&A1&A|E1&E&D2&D1&D&!C1&C&!B1&!B&A1&A|!E1&E&D2&D1&D&!C1&C&!B1&!B&A1&A|!E1&E&!D2&D1&D&!C1&C&!B1&!B&A1&A|E1&E&!D2&D1&D&!C1&C&!B1&!B&A1&A|E1&!E&!D2&D1&D&!C1&C&!B1&!B&A1&A|E1&!E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|E1&E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|!E1&E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|!E1&E&D2&D1&!D&!C1&C&!B1&!B&A1&A|E1&E&D2&D1&!D&!C1&C&!B1&!B&A1&A|E1&!E&D2&D1&!D&!C1&C&!B1&!B&A1&A|E1&!E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|E1&E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|!E1&E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|E1&E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|E1&E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|!E1&E&D2&!D1&!D&!C1&C&B1&!B&A1&A|E1&E&D2&!D1&!D&!C1&C&B1&!B&A1&A|E1&!E&D2&!D1&!D&!C1&C&B1&!B&A1&A|E1&!E&D2&D1&!D&!C1&C&B1&!B&A1&A|E1&E&D2&D1&!D&!C1&C&B1&!B&A1&A|!E1&E&D2&D1&!D&!C1&C&B1&!B&A1&A|!E1&E&!D2&D1&!D&!C1&C&B1&!B&A1&A|E1&E&!D2&D1&!D&!C1&C&B1&!B&A1&A|E1&!E&!D2&D1&!D&!C1&C&B1&!B&A1&A|E1&!E&!D2&D1&D&!C1&C&B1&!B&A1&A|E1&E&!D2&D1&D&!C1&C&B1&!B&A1&A|!E1&E&!D2&D1&D&!C1&C&B1&!B&A1&A|!E1&E&D2&D1&D&!C1&C&B1&!B&A1&A|E1&E&D2&D1&D&!C1&C&B1&!B&A1&A|E1&!E&D2&D1&D&!C1&C&B1&!B&A1&A|E1&!E&D2&!D1&D&!C1&C&B1&!B&A1&A|E1&E&D2&!D1&D&!C1&C&B1&!B&A1&A|!E1&E&D2&!D1&D&!C1&C&B1&!B&A1&A|!E1&E&!D2&!D1&D&!C1&C&B1&!B&A1&A|E1&E&!D2&!D1&D&!C1&C&B1&!B&A1&A|E1&!E&!D2&!D1&D&!C1&C&B1&!B&A1&A|E1&!E&!D2&!D1&D&C1&C&B1&!B&A1&A|E1&E&!D2&!D1&D&C1&C&B1&!B&A1&A|!E1&E&!D2&!D1&D&C1&C&B1&!B&A1&A|!E1&E&D2&!D1&D&C1&C&B1&!B&A1&A|E1&E&D2&!D1&D&C1&C&B1&!B&A1&A|E1&!E&D2&!D1&D&C1&C&B1&!B&A1&A|E1&!E&D2&D1&D&C1&C&B1&!B&A1&A|E1&E&D2&D1&D&C1&C&B1&!B&A1&A|!E1&E&D2&D1&D&C1&C&B1&!B&A1&A|!E1&E&!D2&D1&D&C1&C&B1&!B&A1&A|E1&E&!D2&D1&D&C1&C&B1&!B&A1&A|E1&!E&!D2&D1&D&C1&C&B1&!B&A1&A|E1&!E&!D2&D1&!D&C1&C&B1&!B&A1&A|E1&E&!D2&D1&!D&C1&C&B1&!B&A1&A|!E1&E&!D2&D1&!D&C1&C&B1&!B&A1&A|!E1&E&D2&D1&!D&C1&C&B1&!B&A1&A|E1&E&D2&D1&!D&C1&C&B1&!B&A1&A|E1&!E&D2&D1&!D&C1&C&B1&!B&A1&A|E1&!E&D2&!D1&!D&C1&C&B1&!B&A1&A|E1&E&D2&!D1&!D&C1&C&B1&!B&A1&A|!E1&E&D2&!D1&!D&C1&C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&C1&C&B1&!B&A1&A|E1&E&!D2&!D1&!D&C1&C&B1&!B&A1&A|E1&!E&!D2&!D1&!D&C1&C&B1&!B&A1&A|E1&!E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|E1&E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|!E1&E&D2&!D1&!D&C1&!C&B1&!B&A1&A|E1&E&D2&!D1&!D&C1&!C&B1&!B&A1&A|E1&!E&D2&!D1&!D&C1&!C&B1&!B&A1&A|E1&!E&D2&D1&!D&C1&!C&B1&!B&A1&A|E1&E&D2&D1&!D&C1&!C&B1&!B&A1&A|!E1&E&D2&D1&!D&C1&!C&B1&!B&A1&A|!E1&E&!D2&D1&!D&C1&!C&B1&!B&A1&A|E1&E&!D2&D1&!D&C1&!C&B1&!B&A1&A|E1&!E&!D2&D1&!D&C1&!C&B1&!B&A1&A|E1&!E&!D2&D1&D&C1&!C&B1&!B&A1&A|E1&E&!D2&D1&D&C1&!C&B1&!B&A1&A|!E1&E&!D2&D1&D&C1&!C&B1&!B&A1&A|!E1&E&D2&D1&D&C1&!C&B1&!B&A1&A|E1&E&D2&D1&D&C1&!C&B1&!B&A1&A|E1&!E&D2&D1&D&C1&!C&B1&!B&A1&A|E1&!E&D2&!D1&D&C1&!C&B1&!B&A1&A|E1&E&D2&!D1&D&C1&!C&B1&!B&A1&A|!E1&E&D2&!D1&D&C1&!C&B1&!B&A1&A|!E1&E&!D2&!D1&D&C1&!C&B1&!B&A1&A|E1&E&!D2&!D1&D&C1&!C&B1&!B&A1&A|E1&!E&!D2&!D1&D&C1&!C&B1&!B&A1&A|E1&!E&D2&D1&D&!C1&!C&B1&!B&A1&A|E1&E&D2&D1&D&!C1&!C&B1&!B&A1&A|!E1&E&D2&D1&D&!C1&!C&B1&!B&A1&A|!E1&E&D2&D1&D&!C1&!C&B1&B&A1&A|E1&E&D2&D1&D&!C1&!C&B1&B&A1&A|E1&!E&D2&D1&D&!C1&!C&B1&B&A1&A|E1&!E&!D2&!D1&D&C1&!C&B1&B&A1&A|E1&E&!D2&!D1&D&C1&!C&B1&B&A1&A|!E1&E&!D2&!D1&D&C1&!C&B1&B&A1&A|!E1&E&D2&!D1&D&C1&!C&B1&B&A1&A|E1&E&D2&!D1&D&C1&!C&B1&B&A1&A|E1&!E&D2&!D1&D&C1&!C&B1&B&A1&A|E1&!E&D2&D1&D&C1&!C&B1&B&A1&A|E1&E&D2&D1&D&C1&!C&B1&B&A1&A|!E1&E&D2&D1&D&C1&!C&B1&B&A1&A|!E1&E&!D2&D1&D&C1&!C&B1&B&A1&A|E1&E&!D2&D1&D&C1&!C&B1&B&A1&A|E1&!E&!D2&D1&D&C1&!C&B1&B&A1&A|E1&!E&!D2&D1&!D&C1&!C&B1&B&A1&A|E1&E&!D2&D1&!D&C1&!C&B1&B&A1&A|!E1&E&!D2&D1&!D&C1&!C&B1&B&A1&A|!E1&E&D2&D1&!D&C1&!C&B1&B&A1&A|E1&E&D2&D1&!D&C1&!C&B1&B&A1&A|E1&!E&D2&D1&!D&C1&!C&B1&B&A1&A|E1&!E&D2&!D1&!D&C1&!C&B1&B&A1&A|E1&E&D2&!D1&!D&C1&!C&B1&B&A1&A|!E1&E&D2&!D1&!D&C1&!C&B1&B&A1&A|!E1&E&!D2&!D1&!D&C1&!C&B1&B&A1&A|E1&E&!D2&!D1&!D&C1&!C&B1&B&A1&A|E1&!E&!D2&!D1&!D&C1&!C&B1&B&A1&A|E1&!E&!D2&!D1&!D&C1&C&B1&B&A1&A|E1&E&!D2&!D1&!D&C1&C&B1&B&A1&A|!E1&E&!D2&!D1&!D&C1&C&B1&B&A1&A|!E1&E&D2&!D1&!D&C1&C&B1&B&A1&A|E1&E&D2&!D1&!D&C1&C&B1&B&A1&A|E1&!E&D2&!D1&!D&C1&C&B1&B&A1&A|E1&!E&D2&D1&!D&C1&C&B1&B&A1&A|E1&E&D2&D1&!D&C1&C&B1&B&A1&A|!E1&E&D2&D1&!D&C1&C&B1&B&A1&A|!E1&E&!D2&D1&!D&C1&C&B1&B&A1&A|E1&E&!D2&D1&!D&C1&C&B1&B&A1&A|E1&!E&!D2&D1&!D&C1&C&B1&B&A1&A|E1&!E&!D2&D1&D&C1&C&B1&B&A1&A|E1&E&!D2&D1&D&C1&C&B1&B&A1&A|!E1&E&!D2&D1&D&C1&C&B1&B&A1&A|!E1&E&D2&D1&D&C1&C&B1&B&A1&A|E1&E&D2&D1&D&C1&C&B1&B&A1&A|E1&!E&D2&D1&D&C1&C&B1&B&A1&A|E1&!E&D2&!D1&D&C1&C&B1&B&A1&A|E1&E&D2&!D1&D&C1&C&B1&B&A1&A|!E1&E&D2&!D1&D&C1&C&B1&B&A1&A|!E1&E&!D2&!D1&D&C1&C&B1&B&A1&A|E1&E&!D2&!D1&D&C1&C&B1&B&A1&A|E1&!E&!D2&!D1&D&C1&C&B1&B&A1&A|E1&!E&!D2&!D1&D&!C1&C&B1&B&A1&A|E1&E&!D2&!D1&D&!C1&C&B1&B&A1&A|!E1&E&!D2&!D1&D&!C1&C&B1&B&A1&A|!E1&E&D2&!D1&D&!C1&C&B1&B&A1&A|E1&E&D2&!D1&D&!C1&C&B1&B&A1&A|E1&!E&D2&!D1&D&!C1&C&B1&B&A1&A|E1&!E&D2&D1&D&!C1&C&B1&B&A1&A|E1&E&D2&D1&D&!C1&C&B1&B&A1&A|!E1&E&D2&D1&D&!C1&C&B1&B&A1&A|!E1&E&!D2&D1&D&!C1&C&B1&B&A1&A|E1&E&!D2&D1&D&!C1&C&B1&B&A1&A|E1&!E&!D2&D1&D&!C1&C&B1&B&A1&A|E1&!E&!D2&D1&!D&!C1&C&B1&B&A1&A|E1&E&!D2&D1&!D&!C1&C&B1&B&A1&A|!E1&E&!D2&D1&!D&!C1&C&B1&B&A1&A|!E1&E&D2&D1&!D&!C1&C&B1&B&A1&A|E1&E&D2&D1&!D&!C1&C&B1&B&A1&A|E1&!E&D2&D1&!D&!C1&C&B1&B&A1&A|E1&!E&D2&!D1&!D&!C1&C&B1&B&A1&A|E1&E&D2&!D1&!D&!C1&C&B1&B&A1&A|!E1&E&D2&!D1&!D&!C1&C&B1&B&A1&A|!E1&E&!D2&!D1&!D&!C1&C&B1&B&A1&A|E1&E&!D2&!D1&!D&!C1&C&B1&B&A1&A|E1&!E&!D2&!D1&!D&!C1&C&B1&B&A1&A|E1&!E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|E1&E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|!E1&E&D2&!D1&!D&!C1&C&!B1&B&A1&A|E1&E&D2&!D1&!D&!C1&C&!B1&B&A1&A|E1&!E&D2&!D1&!D&!C1&C&!B1&B&A1&A|E1&!E&D2&D1&!D&!C1&C&!B1&B&A1&A|E1&E&D2&D1&!D&!C1&C&!B1&B&A1&A|!E1&E&D2&D1&!D&!C1&C&!B1&B&A1&A|!E1&E&!D2&D1&!D&!C1&C&!B1&B&A1&A|E1&E&!D2&D1&!D&!C1&C&!B1&B&A1&A|E1&!E&!D2&D1&!D&!C1&C&!B1&B&A1&A|E1&!E&!D2&D1&D&!C1&C&!B1&B&A1&A|E1&E&!D2&D1&D&!C1&C&!B1&B&A1&A|!E1&E&!D2&D1&D&!C1&C&!B1&B&A1&A|!E1&E&D2&D1&D&!C1&C&!B1&B&A1&A|E1&E&D2&D1&D&!C1&C&!B1&B&A1&A|E1&!E&D2&D1&D&!C1&C&!B1&B&A1&A|E1&!E&D2&!D1&D&!C1&C&!B1&B&A1&A|E1&E&D2&!D1&D&!C1&C&!B1&B&A1&A|!E1&E&D2&!D1&D&!C1&C&!B1&B&A1&A|!E1&E&!D2&!D1&D&!C1&C&!B1&B&A1&A|E1&E&!D2&!D1&D&!C1&C&!B1&B&A1&A|E1&!E&!D2&!D1&D&!C1&C&!B1&B&A1&A|E1&!E&!D2&!D1&D&C1&C&!B1&B&A1&A|E1&E&!D2&!D1&D&C1&C&!B1&B&A1&A|!E1&E&!D2&!D1&D&C1&C&!B1&B&A1&A|!E1&E&D2&!D1&D&C1&C&!B1&B&A1&A|E1&E&D2&!D1&D&C1&C&!B1&B&A1&A|E1&!E&D2&!D1&D&C1&C&!B1&B&A1&A|E1&!E&D2&D1&D&C1&C&!B1&B&A1&A|E1&E&D2&D1&D&C1&C&!B1&B&A1&A|!E1&E&D2&D1&D&C1&C&!B1&B&A1&A|!E1&E&!D2&D1&D&C1&C&!B1&B&A1&A|E1&E&!D2&D1&D&C1&C&!B1&B&A1&A|E1&!E&!D2&D1&D&C1&C&!B1&B&A1&A|E1&!E&!D2&D1&!D&C1&C&!B1&B&A1&A|E1&E&!D2&D1&!D&C1&C&!B1&B&A1&A|!E1&E&!D2&D1&!D&C1&C&!B1&B&A1&A|!E1&E&D2&D1&!D&C1&C&!B1&B&A1&A|E1&E&D2&D1&!D&C1&C&!B1&B&A1&A|E1&!E&D2&D1&!D&C1&C&!B1&B&A1&A|E1&!E&D2&!D1&!D&C1&C&!B1&B&A1&A|E1&E&D2&!D1&!D&C1&C&!B1&B&A1&A|!E1&E&D2&!D1&!D&C1&C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&C1&C&!B1&B&A1&A|E1&E&!D2&!D1&!D&C1&C&!B1&B&A1&A|E1&!E&!D2&!D1&!D&C1&C&!B1&B&A1&A|E1&!E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|E1&E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|!E1&E&D2&!D1&!D&C1&!C&!B1&B&A1&A|E1&E&D2&!D1&!D&C1&!C&!B1&B&A1&A|E1&!E&D2&!D1&!D&C1&!C&!B1&B&A1&A|E1&!E&D2&D1&!D&C1&!C&!B1&B&A1&A|E1&E&D2&D1&!D&C1&!C&!B1&B&A1&A|!E1&E&D2&D1&!D&C1&!C&!B1&B&A1&A|!E1&E&!D2&D1&!D&C1&!C&!B1&B&A1&A|E1&E&!D2&D1&!D&C1&!C&!B1&B&A1&A|E1&!E&!D2&D1&!D&C1&!C&!B1&B&A1&A|E1&!E&!D2&D1&D&C1&!C&!B1&B&A1&A|E1&E&!D2&D1&D&C1&!C&!B1&B&A1&A|!E1&E&!D2&D1&D&C1&!C&!B1&B&A1&A|!E1&E&D2&D1&D&C1&!C&!B1&B&A1&A|E1&E&D2&D1&D&C1&!C&!B1&B&A1&A|E1&!E&D2&D1&D&C1&!C&!B1&B&A1&A|E1&!E&D2&!D1&D&C1&!C&!B1&B&A1&A|E1&E&D2&!D1&D&C1&!C&!B1&B&A1&A|!E1&E&D2&!D1&D&C1&!C&!B1&B&A1&A|!E1&E&!D2&!D1&D&C1&!C&!B1&B&A1&A|E1&E&!D2&!D1&D&C1&!C&!B1&B&A1&A|E1&!E&!D2&!D1&D&C1&!C&!B1&B&A1&A|E1&!E&D2&D1&D&!C1&!C&!B1&B&A1&A|E1&E&D2&D1&D&!C1&!C&!B1&B&A1&A|!E1&E&D2&D1&D&!C1&!C&!B1&B&A1&A|!E1&E&D2&D1&D&!C1&!C&!B1&B&!A1&A|E1&E&D2&D1&D&!C1&!C&!B1&B&!A1&A|E1&!E&D2&D1&D&!C1&!C&!B1&B&!A1&A|E1&!E&D2&D1&D&C1&!C&!B1&B&!A1&A|E1&E&D2&D1&D&C1&!C&!B1&B&!A1&A|!E1&E&D2&D1&D&C1&!C&!B1&B&!A1&A|!E1&E&D2&D1&D&C1&C&!B1&B&!A1&A|E1&E&D2&D1&D&C1&C&!B1&B&!A1&A|E1&!E&D2&D1&D&C1&C&!B1&B&!A1&A|E1&!E&D2&D1&D&!C1&C&!B1&B&!A1&A|E1&E&D2&D1&D&!C1&C&!B1&B&!A1&A|!E1&E&D2&D1&D&!C1&C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|E1&E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|!E1&E&D2&!D1&!D&!C1&C&B1&B&!A1&A|E1&E&D2&!D1&!D&!C1&C&B1&B&!A1&A|E1&!E&D2&!D1&!D&!C1&C&B1&B&!A1&A|E1&!E&D2&D1&!D&!C1&C&B1&B&!A1&A|E1&E&D2&D1&!D&!C1&C&B1&B&!A1&A|!E1&E&D2&D1&!D&!C1&C&B1&B&!A1&A|!E1&E&!D2&D1&!D&!C1&C&B1&B&!A1&A|E1&E&!D2&D1&!D&!C1&C&B1&B&!A1&A|E1&!E&!D2&D1&!D&!C1&C&B1&B&!A1&A|E1&!E&!D2&D1&D&!C1&C&B1&B&!A1&A|E1&E&!D2&D1&D&!C1&C&B1&B&!A1&A|!E1&E&!D2&D1&D&!C1&C&B1&B&!A1&A|!E1&E&D2&D1&D&!C1&C&B1&B&!A1&A|E1&E&D2&D1&D&!C1&C&B1&B&!A1&A|E1&!E&D2&D1&D&!C1&C&B1&B&!A1&A|E1&!E&D2&!D1&D&!C1&C&B1&B&!A1&A|E1&E&D2&!D1&D&!C1&C&B1&B&!A1&A|!E1&E&D2&!D1&D&!C1&C&B1&B&!A1&A|!E1&E&!D2&!D1&D&!C1&C&B1&B&!A1&A|E1&E&!D2&!D1&D&!C1&C&B1&B&!A1&A|E1&!E&!D2&!D1&D&!C1&C&B1&B&!A1&A|E1&!E&!D2&!D1&D&C1&C&B1&B&!A1&A|E1&E&!D2&!D1&D&C1&C&B1&B&!A1&A|!E1&E&!D2&!D1&D&C1&C&B1&B&!A1&A|!E1&E&D2&!D1&D&C1&C&B1&B&!A1&A|E1&E&D2&!D1&D&C1&C&B1&B&!A1&A|E1&!E&D2&!D1&D&C1&C&B1&B&!A1&A|E1&!E&D2&D1&D&C1&C&B1&B&!A1&A|E1&E&D2&D1&D&C1&C&B1&B&!A1&A|!E1&E&D2&D1&D&C1&C&B1&B&!A1&A|!E1&E&!D2&D1&D&C1&C&B1&B&!A1&A|E1&E&!D2&D1&D&C1&C&B1&B&!A1&A|E1&!E&!D2&D1&D&C1&C&B1&B&!A1&A|E1&!E&!D2&D1&!D&C1&C&B1&B&!A1&A|E1&E&!D2&D1&!D&C1&C&B1&B&!A1&A|!E1&E&!D2&D1&!D&C1&C&B1&B&!A1&A|!E1&E&D2&D1&!D&C1&C&B1&B&!A1&A|E1&E&D2&D1&!D&C1&C&B1&B&!A1&A|E1&!E&D2&D1&!D&C1&C&B1&B&!A1&A|E1&!E&D2&!D1&!D&C1&C&B1&B&!A1&A|E1&E&D2&!D1&!D&C1&C&B1&B&!A1&A|!E1&E&D2&!D1&!D&C1&C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&C1&C&B1&B&!A1&A|E1&E&!D2&!D1&!D&C1&C&B1&B&!A1&A|E1&!E&!D2&!D1&!D&C1&C&B1&B&!A1&A|E1&!E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|E1&E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|!E1&E&D2&!D1&!D&C1&!C&B1&B&!A1&A|E1&E&D2&!D1&!D&C1&!C&B1&B&!A1&A|E1&!E&D2&!D1&!D&C1&!C&B1&B&!A1&A|E1&!E&D2&D1&!D&C1&!C&B1&B&!A1&A|E1&E&D2&D1&!D&C1&!C&B1&B&!A1&A|!E1&E&D2&D1&!D&C1&!C&B1&B&!A1&A|!E1&E&!D2&D1&!D&C1&!C&B1&B&!A1&A|E1&E&!D2&D1&!D&C1&!C&B1&B&!A1&A|E1&!E&!D2&D1&!D&C1&!C&B1&B&!A1&A|E1&!E&!D2&D1&D&C1&!C&B1&B&!A1&A|E1&E&!D2&D1&D&C1&!C&B1&B&!A1&A|!E1&E&!D2&D1&D&C1&!C&B1&B&!A1&A|!E1&E&D2&D1&D&C1&!C&B1&B&!A1&A|E1&E&D2&D1&D&C1&!C&B1&B&!A1&A|E1&!E&D2&D1&D&C1&!C&B1&B&!A1&A|E1&!E&D2&!D1&D&C1&!C&B1&B&!A1&A|E1&E&D2&!D1&D&C1&!C&B1&B&!A1&A|!E1&E&D2&!D1&D&C1&!C&B1&B&!A1&A|!E1&E&!D2&!D1&D&C1&!C&B1&B&!A1&A|E1&E&!D2&!D1&D&C1&!C&B1&B&!A1&A|E1&!E&!D2&!D1&D&C1&!C&B1&B&!A1&A|E1&!E&D2&D1&D&!C1&!C&B1&B&!A1&A|E1&E&D2&D1&D&!C1&!C&B1&B&!A1&A|!E1&E&D2&D1&D&!C1&!C&B1&B&!A1&A|!E1&E&D2&D1&D&!C1&!C&B1&!B&!A1&A|E1&E&D2&D1&D&!C1&!C&B1&!B&!A1&A|E1&!E&D2&D1&D&!C1&!C&B1&!B&!A1&A|E1&!E&D2&D1&D&C1&!C&B1&!B&!A1&A|E1&E&D2&D1&D&C1&!C&B1&!B&!A1&A|!E1&E&D2&D1&D&C1&!C&B1&!B&!A1&A|!E1&E&D2&D1&D&C1&C&B1&!B&!A1&A|E1&E&D2&D1&D&C1&C&B1&!B&!A1&A|E1&!E&D2&D1&D&C1&C&B1&!B&!A1&A|E1&!E&D2&D1&D&!C1&C&B1&!B&!A1&A|E1&E&D2&D1&D&!C1&C&B1&!B&!A1&A|!E1&E&D2&D1&D&!C1&C&B1&!B&!A1&A|!E1&E&D2&D1&D&!C1&C&!B1&!B&!A1&A|E1&E&D2&D1&D&!C1&C&!B1&!B&!A1&A|E1&!E&D2&D1&D&!C1&C&!B1&!B&!A1&A|E1&!E&D2&D1&D&C1&C&!B1&!B&!A1&A|E1&E&D2&D1&D&C1&C&!B1&!B&!A1&A|!E1&E&D2&D1&D&C1&C&!B1&!B&!A1&A|!E1&E&D2&D1&D&C1&!C&!B1&!B&!A1&A|E1&E&D2&D1&D&C1&!C&!B1&!B&!A1&A|E1&!E&D2&D1&D&C1&!C&!B1&!B&!A1&A|E1&!E&D2&D1&D&!C1&!C&!B1&!B&!A1&A|E1&E&D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E1&E&D2&D1&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAAOOAI22232.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n MUX4 -l MUX4 -i IN0 IN1 IN2 IN3 S0 S1 S2 S3 -o Z -f 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist MUX4.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOI2221 -l OOAAOI2221 -i D C1 C B1 B A1 A -o Y -f Y=(!D&!C1&!C&!B1&!B&!A1&!A|!D&C1&!C&!B1&!B&!A1&!A|!D&!C1&C&!B1&!B&!A1&!A|!D&!C1&C&B1&!B&!A1&!A|!D&C1&!C&B1&!B&!A1&!A|!D&!C1&!C&B1&!B&!A1&!A|!D&!C1&!C&B1&B&!A1&!A|!D&C1&!C&B1&B&!A1&!A|!D&!C1&C&B1&B&!A1&!A|!D&!C1&C&!B1&B&!A1&!A|!D&C1&!C&!B1&B&!A1&!A|!D&!C1&!C&!B1&B&!A1&!A|!D&!C1&C&!B1&!B&A1&!A|!D&C1&!C&!B1&!B&A1&!A|!D&!C1&!C&!B1&!B&A1&!A|!D&!C1&!C&!B1&!B&A1&A|!D&C1&!C&!B1&!B&A1&A|!D&!C1&C&!B1&!B&A1&A|!D&!C1&C&!B1&!B&!A1&A|!D&C1&!C&!B1&!B&!A1&A|!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOI2221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOAOI221211 -l OOAAOAOI221211 -i F E D1 D C B1 B A1 A -o Y -f Y=(!F&!E&!D1&!D&!C&!B1&!B&!A1&!A|!F&E&!D1&!D&!C&!B1&!B&!A1&!A|!F&E&D1&!D&!C&!B1&!B&!A1&!A|!F&!E&D1&!D&!C&!B1&!B&!A1&!A|!F&!E&D1&D&!C&!B1&!B&!A1&!A|!F&E&!D1&D&!C&!B1&!B&!A1&!A|!F&!E&!D1&D&!C&!B1&!B&!A1&!A|!F&!E&!D1&D&C&!B1&!B&!A1&!A|!F&E&!D1&D&C&!B1&!B&!A1&!A|!F&!E&D1&D&C&!B1&!B&!A1&!A|!F&!E&D1&!D&C&!B1&!B&!A1&!A|!F&E&D1&!D&C&!B1&!B&!A1&!A|!F&E&!D1&!D&C&!B1&!B&!A1&!A|!F&!E&!D1&!D&C&!B1&!B&!A1&!A|!F&!E&!D1&!D&C&B1&!B&!A1&!A|!F&E&!D1&!D&C&B1&!B&!A1&!A|!F&E&D1&!D&C&B1&!B&!A1&!A|!F&!E&D1&!D&C&B1&!B&!A1&!A|!F&!E&D1&D&C&B1&!B&!A1&!A|!F&E&!D1&D&C&B1&!B&!A1&!A|!F&!E&!D1&D&C&B1&!B&!A1&!A|!F&!E&!D1&D&!C&B1&!B&!A1&!A|!F&E&!D1&D&!C&B1&!B&!A1&!A|!F&!E&D1&D&!C&B1&!B&!A1&!A|!F&!E&D1&!D&!C&B1&!B&!A1&!A|!F&E&D1&!D&!C&B1&!B&!A1&!A|!F&E&!D1&!D&!C&B1&!B&!A1&!A|!F&!E&!D1&!D&!C&B1&!B&!A1&!A|!F&!E&!D1&!D&!C&B1&B&!A1&!A|!F&E&!D1&!D&!C&B1&B&!A1&!A|!F&E&D1&!D&!C&B1&B&!A1&!A|!F&!E&D1&!D&!C&B1&B&!A1&!A|!F&!E&D1&D&!C&B1&B&!A1&!A|!F&E&!D1&D&!C&B1&B&!A1&!A|!F&!E&!D1&D&!C&B1&B&!A1&!A|!F&!E&!D1&D&C&B1&B&!A1&!A|!F&E&!D1&D&C&B1&B&!A1&!A|!F&!E&D1&D&C&B1&B&!A1&!A|!F&!E&D1&!D&C&B1&B&!A1&!A|!F&E&D1&!D&C&B1&B&!A1&!A|!F&E&!D1&!D&C&B1&B&!A1&!A|!F&!E&!D1&!D&C&B1&B&!A1&!A|!F&!E&!D1&!D&C&!B1&B&!A1&!A|!F&E&!D1&!D&C&!B1&B&!A1&!A|!F&E&D1&!D&C&!B1&B&!A1&!A|!F&!E&D1&!D&C&!B1&B&!A1&!A|!F&!E&D1&D&C&!B1&B&!A1&!A|!F&E&!D1&D&C&!B1&B&!A1&!A|!F&!E&!D1&D&C&!B1&B&!A1&!A|!F&!E&!D1&D&!C&!B1&B&!A1&!A|!F&E&!D1&D&!C&!B1&B&!A1&!A|!F&!E&D1&D&!C&!B1&B&!A1&!A|!F&!E&D1&!D&!C&!B1&B&!A1&!A|!F&E&D1&!D&!C&!B1&B&!A1&!A|!F&E&!D1&!D&!C&!B1&B&!A1&!A|!F&!E&!D1&!D&!C&!B1&B&!A1&!A|!F&!E&!D1&!D&!C&!B1&B&A1&!A|!F&E&!D1&!D&!C&!B1&B&A1&!A|!F&E&D1&!D&!C&!B1&B&A1&!A|!F&!E&D1&!D&!C&!B1&B&A1&!A|!F&!E&D1&D&!C&!B1&B&A1&!A|!F&E&!D1&D&!C&!B1&B&A1&!A|!F&!E&!D1&D&!C&!B1&B&A1&!A|!F&!E&!D1&D&C&!B1&B&A1&!A|!F&!E&D1&D&C&!B1&B&A1&!A|!F&!E&D1&!D&C&!B1&B&A1&!A|!F&!E&!D1&!D&C&!B1&B&A1&!A|!F&!E&!D1&!D&C&B1&B&A1&!A|!F&!E&D1&!D&C&B1&B&A1&!A|!F&!E&D1&D&C&B1&B&A1&!A|!F&!E&!D1&D&C&B1&B&A1&!A|!F&!E&!D1&D&!C&B1&B&A1&!A|!F&E&!D1&D&!C&B1&B&A1&!A|!F&!E&D1&D&!C&B1&B&A1&!A|!F&!E&D1&!D&!C&B1&B&A1&!A|!F&E&D1&!D&!C&B1&B&A1&!A|!F&E&!D1&!D&!C&B1&B&A1&!A|!F&!E&!D1&!D&!C&B1&B&A1&!A|!F&!E&!D1&!D&!C&B1&!B&A1&!A|!F&E&!D1&!D&!C&B1&!B&A1&!A|!F&E&D1&!D&!C&B1&!B&A1&!A|!F&!E&D1&!D&!C&B1&!B&A1&!A|!F&!E&D1&D&!C&B1&!B&A1&!A|!F&E&!D1&D&!C&B1&!B&A1&!A|!F&!E&!D1&D&!C&B1&!B&A1&!A|!F&!E&!D1&D&C&B1&!B&A1&!A|!F&!E&D1&D&C&B1&!B&A1&!A|!F&!E&D1&!D&C&B1&!B&A1&!A|!F&!E&!D1&!D&C&B1&!B&A1&!A|!F&!E&!D1&!D&C&!B1&!B&A1&!A|!F&E&!D1&!D&C&!B1&!B&A1&!A|!F&E&D1&!D&C&!B1&!B&A1&!A|!F&!E&D1&!D&C&!B1&!B&A1&!A|!F&!E&D1&D&C&!B1&!B&A1&!A|!F&E&!D1&D&C&!B1&!B&A1&!A|!F&!E&!D1&D&C&!B1&!B&A1&!A|!F&!E&!D1&D&!C&!B1&!B&A1&!A|!F&E&!D1&D&!C&!B1&!B&A1&!A|!F&!E&D1&D&!C&!B1&!B&A1&!A|!F&!E&D1&!D&!C&!B1&!B&A1&!A|!F&E&D1&!D&!C&!B1&!B&A1&!A|!F&E&!D1&!D&!C&!B1&!B&A1&!A|!F&!E&!D1&!D&!C&!B1&!B&A1&!A|!F&!E&!D1&!D&!C&!B1&!B&A1&A|!F&E&!D1&!D&!C&!B1&!B&A1&A|!F&E&D1&!D&!C&!B1&!B&A1&A|!F&!E&D1&!D&!C&!B1&!B&A1&A|!F&!E&D1&D&!C&!B1&!B&A1&A|!F&E&!D1&D&!C&!B1&!B&A1&A|!F&!E&!D1&D&!C&!B1&!B&A1&A|!F&!E&!D1&D&C&!B1&!B&A1&A|!F&E&!D1&D&C&!B1&!B&A1&A|!F&!E&D1&D&C&!B1&!B&A1&A|!F&!E&D1&!D&C&!B1&!B&A1&A|!F&E&D1&!D&C&!B1&!B&A1&A|!F&E&!D1&!D&C&!B1&!B&A1&A|!F&!E&!D1&!D&C&!B1&!B&A1&A|!F&!E&!D1&!D&C&B1&!B&A1&A|!F&!E&D1&!D&C&B1&!B&A1&A|!F&!E&D1&D&C&B1&!B&A1&A|!F&!E&!D1&D&C&B1&!B&A1&A|!F&!E&!D1&D&!C&B1&!B&A1&A|!F&E&!D1&D&!C&B1&!B&A1&A|!F&!E&D1&D&!C&B1&!B&A1&A|!F&!E&D1&!D&!C&B1&!B&A1&A|!F&E&D1&!D&!C&B1&!B&A1&A|!F&E&!D1&!D&!C&B1&!B&A1&A|!F&!E&!D1&!D&!C&B1&!B&A1&A|!F&!E&!D1&!D&!C&B1&B&A1&A|!F&E&!D1&!D&!C&B1&B&A1&A|!F&E&D1&!D&!C&B1&B&A1&A|!F&!E&D1&!D&!C&B1&B&A1&A|!F&!E&D1&D&!C&B1&B&A1&A|!F&E&!D1&D&!C&B1&B&A1&A|!F&!E&!D1&D&!C&B1&B&A1&A|!F&!E&!D1&D&C&B1&B&A1&A|!F&!E&D1&D&C&B1&B&A1&A|!F&!E&D1&!D&C&B1&B&A1&A|!F&!E&!D1&!D&C&B1&B&A1&A|!F&!E&!D1&!D&C&!B1&B&A1&A|!F&!E&D1&!D&C&!B1&B&A1&A|!F&!E&D1&D&C&!B1&B&A1&A|!F&!E&!D1&D&C&!B1&B&A1&A|!F&!E&!D1&D&!C&!B1&B&A1&A|!F&E&!D1&D&!C&!B1&B&A1&A|!F&!E&D1&D&!C&!B1&B&A1&A|!F&!E&D1&!D&!C&!B1&B&A1&A|!F&E&D1&!D&!C&!B1&B&A1&A|!F&E&!D1&!D&!C&!B1&B&A1&A|!F&!E&!D1&!D&!C&!B1&B&A1&A|!F&!E&!D1&!D&!C&!B1&B&!A1&A|!F&E&!D1&!D&!C&!B1&B&!A1&A|!F&E&D1&!D&!C&!B1&B&!A1&A|!F&!E&D1&!D&!C&!B1&B&!A1&A|!F&!E&D1&D&!C&!B1&B&!A1&A|!F&E&!D1&D&!C&!B1&B&!A1&A|!F&!E&!D1&D&!C&!B1&B&!A1&A|!F&!E&!D1&D&C&!B1&B&!A1&A|!F&!E&D1&D&C&!B1&B&!A1&A|!F&!E&D1&!D&C&!B1&B&!A1&A|!F&!E&!D1&!D&C&!B1&B&!A1&A|!F&!E&!D1&!D&C&B1&B&!A1&A|!F&!E&D1&!D&C&B1&B&!A1&A|!F&!E&D1&D&C&B1&B&!A1&A|!F&!E&!D1&D&C&B1&B&!A1&A|!F&!E&!D1&D&!C&B1&B&!A1&A|!F&E&!D1&D&!C&B1&B&!A1&A|!F&!E&D1&D&!C&B1&B&!A1&A|!F&!E&D1&!D&!C&B1&B&!A1&A|!F&E&D1&!D&!C&B1&B&!A1&A|!F&E&!D1&!D&!C&B1&B&!A1&A|!F&!E&!D1&!D&!C&B1&B&!A1&A|!F&!E&!D1&!D&!C&B1&!B&!A1&A|!F&E&!D1&!D&!C&B1&!B&!A1&A|!F&E&D1&!D&!C&B1&!B&!A1&A|!F&!E&D1&!D&!C&B1&!B&!A1&A|!F&!E&D1&D&!C&B1&!B&!A1&A|!F&E&!D1&D&!C&B1&!B&!A1&A|!F&!E&!D1&D&!C&B1&!B&!A1&A|!F&!E&!D1&D&C&B1&!B&!A1&A|!F&!E&D1&D&C&B1&!B&!A1&A|!F&!E&D1&!D&C&B1&!B&!A1&A|!F&!E&!D1&!D&C&B1&!B&!A1&A|!F&!E&!D1&!D&C&!B1&!B&!A1&A|!F&E&!D1&!D&C&!B1&!B&!A1&A|!F&E&D1&!D&C&!B1&!B&!A1&A|!F&!E&D1&!D&C&!B1&!B&!A1&A|!F&!E&D1&D&C&!B1&!B&!A1&A|!F&E&!D1&D&C&!B1&!B&!A1&A|!F&!E&!D1&D&C&!B1&!B&!A1&A|!F&!E&!D1&D&!C&!B1&!B&!A1&A|!F&E&!D1&D&!C&!B1&!B&!A1&A|!F&!E&D1&D&!C&!B1&!B&!A1&A|!F&!E&D1&!D&!C&!B1&!B&!A1&A|!F&E&D1&!D&!C&!B1&!B&!A1&A|!F&E&!D1&!D&!C&!B1&!B&!A1&A|!F&!E&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOAOI221211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOOAI2214 -l OOAOOAI2214 -i D3 D2 D1 D C B1 B A1 A -o Y -f Y=(!D3&!D2&!D1&!D&!C&!B1&!B&!A1&!A|D3&!D2&!D1&!D&!C&!B1&!B&!A1&!A|D3&D2&!D1&!D&!C&!B1&!B&!A1&!A|!D3&D2&!D1&!D&!C&!B1&!B&!A1&!A|!D3&D2&D1&!D&!C&!B1&!B&!A1&!A|D3&D2&D1&!D&!C&!B1&!B&!A1&!A|D3&!D2&D1&!D&!C&!B1&!B&!A1&!A|!D3&!D2&D1&!D&!C&!B1&!B&!A1&!A|!D3&!D2&D1&D&!C&!B1&!B&!A1&!A|D3&!D2&D1&D&!C&!B1&!B&!A1&!A|D3&D2&D1&D&!C&!B1&!B&!A1&!A|!D3&D2&D1&D&!C&!B1&!B&!A1&!A|!D3&D2&!D1&D&!C&!B1&!B&!A1&!A|D3&D2&!D1&D&!C&!B1&!B&!A1&!A|D3&!D2&!D1&D&!C&!B1&!B&!A1&!A|!D3&!D2&!D1&D&!C&!B1&!B&!A1&!A|!D3&!D2&!D1&!D&C&!B1&!B&!A1&!A|!D3&!D2&!D1&!D&C&B1&!B&!A1&!A|!D3&!D2&!D1&D&!C&B1&!B&!A1&!A|D3&!D2&!D1&D&!C&B1&!B&!A1&!A|D3&D2&!D1&D&!C&B1&!B&!A1&!A|!D3&D2&!D1&D&!C&B1&!B&!A1&!A|!D3&D2&D1&D&!C&B1&!B&!A1&!A|D3&D2&D1&D&!C&B1&!B&!A1&!A|D3&!D2&D1&D&!C&B1&!B&!A1&!A|!D3&!D2&D1&D&!C&B1&!B&!A1&!A|!D3&!D2&D1&!D&!C&B1&!B&!A1&!A|D3&!D2&D1&!D&!C&B1&!B&!A1&!A|D3&D2&D1&!D&!C&B1&!B&!A1&!A|!D3&D2&D1&!D&!C&B1&!B&!A1&!A|!D3&D2&!D1&!D&!C&B1&!B&!A1&!A|D3&D2&!D1&!D&!C&B1&!B&!A1&!A|D3&!D2&!D1&!D&!C&B1&!B&!A1&!A|!D3&!D2&!D1&!D&!C&B1&!B&!A1&!A|!D3&!D2&!D1&!D&!C&B1&B&!A1&!A|D3&!D2&!D1&!D&!C&B1&B&!A1&!A|D3&D2&!D1&!D&!C&B1&B&!A1&!A|!D3&D2&!D1&!D&!C&B1&B&!A1&!A|!D3&D2&D1&!D&!C&B1&B&!A1&!A|D3&D2&D1&!D&!C&B1&B&!A1&!A|D3&!D2&D1&!D&!C&B1&B&!A1&!A|!D3&!D2&D1&!D&!C&B1&B&!A1&!A|!D3&!D2&D1&D&!C&B1&B&!A1&!A|D3&!D2&D1&D&!C&B1&B&!A1&!A|D3&D2&D1&D&!C&B1&B&!A1&!A|!D3&D2&D1&D&!C&B1&B&!A1&!A|!D3&D2&!D1&D&!C&B1&B&!A1&!A|D3&D2&!D1&D&!C&B1&B&!A1&!A|D3&!D2&!D1&D&!C&B1&B&!A1&!A|!D3&!D2&!D1&D&!C&B1&B&!A1&!A|!D3&!D2&!D1&!D&C&B1&B&!A1&!A|!D3&!D2&!D1&!D&C&!B1&B&!A1&!A|!D3&!D2&!D1&D&!C&!B1&B&!A1&!A|D3&!D2&!D1&D&!C&!B1&B&!A1&!A|D3&D2&!D1&D&!C&!B1&B&!A1&!A|!D3&D2&!D1&D&!C&!B1&B&!A1&!A|!D3&D2&D1&D&!C&!B1&B&!A1&!A|D3&D2&D1&D&!C&!B1&B&!A1&!A|D3&!D2&D1&D&!C&!B1&B&!A1&!A|!D3&!D2&D1&D&!C&!B1&B&!A1&!A|!D3&!D2&D1&!D&!C&!B1&B&!A1&!A|D3&!D2&D1&!D&!C&!B1&B&!A1&!A|D3&D2&D1&!D&!C&!B1&B&!A1&!A|!D3&D2&D1&!D&!C&!B1&B&!A1&!A|!D3&D2&!D1&!D&!C&!B1&B&!A1&!A|D3&D2&!D1&!D&!C&!B1&B&!A1&!A|D3&!D2&!D1&!D&!C&!B1&B&!A1&!A|!D3&!D2&!D1&!D&!C&!B1&B&!A1&!A|!D3&!D2&!D1&!D&!C&!B1&B&A1&!A|!D3&!D2&!D1&!D&C&!B1&B&A1&!A|!D3&!D2&!D1&!D&C&B1&B&A1&!A|!D3&!D2&!D1&!D&!C&B1&B&A1&!A|!D3&!D2&!D1&!D&!C&B1&!B&A1&!A|!D3&!D2&!D1&!D&C&B1&!B&A1&!A|!D3&!D2&!D1&!D&C&!B1&!B&A1&!A|!D3&!D2&!D1&D&!C&!B1&!B&A1&!A|D3&!D2&!D1&D&!C&!B1&!B&A1&!A|D3&D2&!D1&D&!C&!B1&!B&A1&!A|!D3&D2&!D1&D&!C&!B1&!B&A1&!A|!D3&D2&D1&D&!C&!B1&!B&A1&!A|D3&D2&D1&D&!C&!B1&!B&A1&!A|D3&!D2&D1&D&!C&!B1&!B&A1&!A|!D3&!D2&D1&D&!C&!B1&!B&A1&!A|!D3&!D2&D1&!D&!C&!B1&!B&A1&!A|D3&!D2&D1&!D&!C&!B1&!B&A1&!A|D3&D2&D1&!D&!C&!B1&!B&A1&!A|!D3&D2&D1&!D&!C&!B1&!B&A1&!A|!D3&D2&!D1&!D&!C&!B1&!B&A1&!A|D3&D2&!D1&!D&!C&!B1&!B&A1&!A|D3&!D2&!D1&!D&!C&!B1&!B&A1&!A|!D3&!D2&!D1&!D&!C&!B1&!B&A1&!A|!D3&!D2&!D1&!D&!C&!B1&!B&A1&A|D3&!D2&!D1&!D&!C&!B1&!B&A1&A|D3&D2&!D1&!D&!C&!B1&!B&A1&A|!D3&D2&!D1&!D&!C&!B1&!B&A1&A|!D3&D2&D1&!D&!C&!B1&!B&A1&A|D3&D2&D1&!D&!C&!B1&!B&A1&A|D3&!D2&D1&!D&!C&!B1&!B&A1&A|!D3&!D2&D1&!D&!C&!B1&!B&A1&A|!D3&!D2&D1&D&!C&!B1&!B&A1&A|D3&!D2&D1&D&!C&!B1&!B&A1&A|D3&D2&D1&D&!C&!B1&!B&A1&A|!D3&D2&D1&D&!C&!B1&!B&A1&A|!D3&D2&!D1&D&!C&!B1&!B&A1&A|D3&D2&!D1&D&!C&!B1&!B&A1&A|D3&!D2&!D1&D&!C&!B1&!B&A1&A|!D3&!D2&!D1&D&!C&!B1&!B&A1&A|!D3&!D2&!D1&!D&C&!B1&!B&A1&A|!D3&!D2&!D1&!D&C&B1&!B&A1&A|!D3&!D2&!D1&!D&!C&B1&!B&A1&A|!D3&!D2&!D1&!D&!C&B1&B&A1&A|!D3&!D2&!D1&!D&C&B1&B&A1&A|!D3&!D2&!D1&!D&C&!B1&B&A1&A|!D3&!D2&!D1&!D&!C&!B1&B&A1&A|!D3&!D2&!D1&!D&!C&!B1&B&!A1&A|!D3&!D2&!D1&!D&C&!B1&B&!A1&A|!D3&!D2&!D1&!D&C&B1&B&!A1&A|!D3&!D2&!D1&!D&!C&B1&B&!A1&A|!D3&!D2&!D1&!D&!C&B1&!B&!A1&A|!D3&!D2&!D1&!D&C&B1&!B&!A1&A|!D3&!D2&!D1&!D&C&!B1&!B&!A1&A|!D3&!D2&!D1&D&!C&!B1&!B&!A1&A|D3&!D2&!D1&D&!C&!B1&!B&!A1&A|D3&D2&!D1&D&!C&!B1&!B&!A1&A|!D3&D2&!D1&D&!C&!B1&!B&!A1&A|!D3&D2&D1&D&!C&!B1&!B&!A1&A|D3&D2&D1&D&!C&!B1&!B&!A1&A|D3&!D2&D1&D&!C&!B1&!B&!A1&A|!D3&!D2&D1&D&!C&!B1&!B&!A1&A|!D3&!D2&D1&!D&!C&!B1&!B&!A1&A|D3&!D2&D1&!D&!C&!B1&!B&!A1&A|D3&D2&D1&!D&!C&!B1&!B&!A1&A|!D3&D2&D1&!D&!C&!B1&!B&!A1&A|!D3&D2&!D1&!D&!C&!B1&!B&!A1&A|D3&D2&!D1&!D&!C&!B1&!B&!A1&A|D3&!D2&!D1&!D&!C&!B1&!B&!A1&A|!D3&!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOOAI2214.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOI2241 -l OAAOI2241 -i D C3 C2 C1 C B1 B A1 A -o Y -f Y=(!D&!C3&!C2&!C1&!C&!B1&!B&!A1&!A|!D&C3&!C2&!C1&!C&!B1&!B&!A1&!A|!D&C3&C2&!C1&!C&!B1&!B&!A1&!A|!D&!C3&C2&!C1&!C&!B1&!B&!A1&!A|!D&!C3&C2&C1&!C&!B1&!B&!A1&!A|!D&C3&C2&C1&!C&!B1&!B&!A1&!A|!D&C3&!C2&C1&!C&!B1&!B&!A1&!A|!D&!C3&!C2&C1&!C&!B1&!B&!A1&!A|!D&!C3&!C2&C1&C&!B1&!B&!A1&!A|!D&C3&!C2&C1&C&!B1&!B&!A1&!A|!D&!C3&C2&C1&C&!B1&!B&!A1&!A|!D&!C3&C2&!C1&C&!B1&!B&!A1&!A|!D&C3&C2&!C1&C&!B1&!B&!A1&!A|!D&C3&!C2&!C1&C&!B1&!B&!A1&!A|!D&!C3&!C2&!C1&C&!B1&!B&!A1&!A|!D&!C3&!C2&!C1&C&B1&!B&!A1&!A|!D&C3&!C2&!C1&C&B1&!B&!A1&!A|!D&C3&C2&!C1&C&B1&!B&!A1&!A|!D&!C3&C2&!C1&C&B1&!B&!A1&!A|!D&!C3&C2&C1&C&B1&!B&!A1&!A|!D&C3&!C2&C1&C&B1&!B&!A1&!A|!D&!C3&!C2&C1&C&B1&!B&!A1&!A|!D&!C3&!C2&C1&!C&B1&!B&!A1&!A|!D&C3&!C2&C1&!C&B1&!B&!A1&!A|!D&C3&C2&C1&!C&B1&!B&!A1&!A|!D&!C3&C2&C1&!C&B1&!B&!A1&!A|!D&!C3&C2&!C1&!C&B1&!B&!A1&!A|!D&C3&C2&!C1&!C&B1&!B&!A1&!A|!D&C3&!C2&!C1&!C&B1&!B&!A1&!A|!D&!C3&!C2&!C1&!C&B1&!B&!A1&!A|!D&!C3&!C2&!C1&!C&B1&B&!A1&!A|!D&C3&!C2&!C1&!C&B1&B&!A1&!A|!D&C3&C2&!C1&!C&B1&B&!A1&!A|!D&!C3&C2&!C1&!C&B1&B&!A1&!A|!D&!C3&C2&C1&!C&B1&B&!A1&!A|!D&C3&C2&C1&!C&B1&B&!A1&!A|!D&C3&!C2&C1&!C&B1&B&!A1&!A|!D&!C3&!C2&C1&!C&B1&B&!A1&!A|!D&!C3&!C2&C1&C&B1&B&!A1&!A|!D&C3&!C2&C1&C&B1&B&!A1&!A|!D&!C3&C2&C1&C&B1&B&!A1&!A|!D&!C3&C2&!C1&C&B1&B&!A1&!A|!D&C3&C2&!C1&C&B1&B&!A1&!A|!D&C3&!C2&!C1&C&B1&B&!A1&!A|!D&!C3&!C2&!C1&C&B1&B&!A1&!A|!D&!C3&!C2&!C1&C&!B1&B&!A1&!A|!D&C3&!C2&!C1&C&!B1&B&!A1&!A|!D&C3&C2&!C1&C&!B1&B&!A1&!A|!D&!C3&C2&!C1&C&!B1&B&!A1&!A|!D&!C3&C2&C1&C&!B1&B&!A1&!A|!D&C3&!C2&C1&C&!B1&B&!A1&!A|!D&!C3&!C2&C1&C&!B1&B&!A1&!A|!D&!C3&!C2&C1&!C&!B1&B&!A1&!A|!D&C3&!C2&C1&!C&!B1&B&!A1&!A|!D&C3&C2&C1&!C&!B1&B&!A1&!A|!D&!C3&C2&C1&!C&!B1&B&!A1&!A|!D&!C3&C2&!C1&!C&!B1&B&!A1&!A|!D&C3&C2&!C1&!C&!B1&B&!A1&!A|!D&C3&!C2&!C1&!C&!B1&B&!A1&!A|!D&!C3&!C2&!C1&!C&!B1&B&!A1&!A|!D&!C3&!C2&!C1&!C&!B1&B&A1&!A|!D&C3&!C2&!C1&!C&!B1&B&A1&!A|!D&C3&C2&!C1&!C&!B1&B&A1&!A|!D&!C3&C2&!C1&!C&!B1&B&A1&!A|!D&!C3&C2&C1&!C&!B1&B&A1&!A|!D&C3&C2&C1&!C&!B1&B&A1&!A|!D&C3&!C2&C1&!C&!B1&B&A1&!A|!D&!C3&!C2&C1&!C&!B1&B&A1&!A|!D&!C3&!C2&C1&C&!B1&B&A1&!A|!D&C3&!C2&C1&C&!B1&B&A1&!A|!D&!C3&C2&C1&C&!B1&B&A1&!A|!D&!C3&C2&!C1&C&!B1&B&A1&!A|!D&C3&C2&!C1&C&!B1&B&A1&!A|!D&C3&!C2&!C1&C&!B1&B&A1&!A|!D&!C3&!C2&!C1&C&!B1&B&A1&!A|!D&!C3&!C2&!C1&!C&B1&!B&A1&!A|!D&C3&!C2&!C1&!C&B1&!B&A1&!A|!D&C3&C2&!C1&!C&B1&!B&A1&!A|!D&!C3&C2&!C1&!C&B1&!B&A1&!A|!D&!C3&C2&C1&!C&B1&!B&A1&!A|!D&C3&C2&C1&!C&B1&!B&A1&!A|!D&C3&!C2&C1&!C&B1&!B&A1&!A|!D&!C3&!C2&C1&!C&B1&!B&A1&!A|!D&!C3&!C2&C1&C&B1&!B&A1&!A|!D&C3&!C2&C1&C&B1&!B&A1&!A|!D&!C3&C2&C1&C&B1&!B&A1&!A|!D&!C3&C2&!C1&C&B1&!B&A1&!A|!D&C3&C2&!C1&C&B1&!B&A1&!A|!D&C3&!C2&!C1&C&B1&!B&A1&!A|!D&!C3&!C2&!C1&C&B1&!B&A1&!A|!D&!C3&!C2&!C1&C&!B1&!B&A1&!A|!D&C3&!C2&!C1&C&!B1&!B&A1&!A|!D&C3&C2&!C1&C&!B1&!B&A1&!A|!D&!C3&C2&!C1&C&!B1&!B&A1&!A|!D&!C3&C2&C1&C&!B1&!B&A1&!A|!D&C3&!C2&C1&C&!B1&!B&A1&!A|!D&!C3&!C2&C1&C&!B1&!B&A1&!A|!D&!C3&!C2&C1&!C&!B1&!B&A1&!A|!D&C3&!C2&C1&!C&!B1&!B&A1&!A|!D&C3&C2&C1&!C&!B1&!B&A1&!A|!D&!C3&C2&C1&!C&!B1&!B&A1&!A|!D&!C3&C2&!C1&!C&!B1&!B&A1&!A|!D&C3&C2&!C1&!C&!B1&!B&A1&!A|!D&C3&!C2&!C1&!C&!B1&!B&A1&!A|!D&!C3&!C2&!C1&!C&!B1&!B&A1&!A|!D&!C3&!C2&!C1&!C&!B1&!B&A1&A|!D&C3&!C2&!C1&!C&!B1&!B&A1&A|!D&C3&C2&!C1&!C&!B1&!B&A1&A|!D&!C3&C2&!C1&!C&!B1&!B&A1&A|!D&!C3&C2&C1&!C&!B1&!B&A1&A|!D&C3&C2&C1&!C&!B1&!B&A1&A|!D&C3&!C2&C1&!C&!B1&!B&A1&A|!D&!C3&!C2&C1&!C&!B1&!B&A1&A|!D&!C3&!C2&C1&C&!B1&!B&A1&A|!D&C3&!C2&C1&C&!B1&!B&A1&A|!D&!C3&C2&C1&C&!B1&!B&A1&A|!D&!C3&C2&!C1&C&!B1&!B&A1&A|!D&C3&C2&!C1&C&!B1&!B&A1&A|!D&C3&!C2&!C1&C&!B1&!B&A1&A|!D&!C3&!C2&!C1&C&!B1&!B&A1&A|!D&!C3&!C2&!C1&C&B1&!B&A1&A|!D&C3&!C2&!C1&C&B1&!B&A1&A|!D&C3&C2&!C1&C&B1&!B&A1&A|!D&!C3&C2&!C1&C&B1&!B&A1&A|!D&!C3&C2&C1&C&B1&!B&A1&A|!D&C3&!C2&C1&C&B1&!B&A1&A|!D&!C3&!C2&C1&C&B1&!B&A1&A|!D&!C3&!C2&C1&!C&B1&!B&A1&A|!D&C3&!C2&C1&!C&B1&!B&A1&A|!D&C3&C2&C1&!C&B1&!B&A1&A|!D&!C3&C2&C1&!C&B1&!B&A1&A|!D&!C3&C2&!C1&!C&B1&!B&A1&A|!D&C3&C2&!C1&!C&B1&!B&A1&A|!D&C3&!C2&!C1&!C&B1&!B&A1&A|!D&!C3&!C2&!C1&!C&B1&!B&A1&A|!D&!C3&!C2&!C1&C&!B1&B&A1&A|!D&C3&!C2&!C1&C&!B1&B&A1&A|!D&C3&C2&!C1&C&!B1&B&A1&A|!D&!C3&C2&!C1&C&!B1&B&A1&A|!D&!C3&C2&C1&C&!B1&B&A1&A|!D&C3&!C2&C1&C&!B1&B&A1&A|!D&!C3&!C2&C1&C&!B1&B&A1&A|!D&!C3&!C2&C1&!C&!B1&B&A1&A|!D&C3&!C2&C1&!C&!B1&B&A1&A|!D&C3&C2&C1&!C&!B1&B&A1&A|!D&!C3&C2&C1&!C&!B1&B&A1&A|!D&!C3&C2&!C1&!C&!B1&B&A1&A|!D&C3&C2&!C1&!C&!B1&B&A1&A|!D&C3&!C2&!C1&!C&!B1&B&A1&A|!D&!C3&!C2&!C1&!C&!B1&B&A1&A|!D&!C3&!C2&!C1&!C&!B1&B&!A1&A|!D&C3&!C2&!C1&!C&!B1&B&!A1&A|!D&C3&C2&!C1&!C&!B1&B&!A1&A|!D&!C3&C2&!C1&!C&!B1&B&!A1&A|!D&!C3&C2&C1&!C&!B1&B&!A1&A|!D&C3&C2&C1&!C&!B1&B&!A1&A|!D&C3&!C2&C1&!C&!B1&B&!A1&A|!D&!C3&!C2&C1&!C&!B1&B&!A1&A|!D&!C3&!C2&C1&C&!B1&B&!A1&A|!D&C3&!C2&C1&C&!B1&B&!A1&A|!D&!C3&C2&C1&C&!B1&B&!A1&A|!D&!C3&C2&!C1&C&!B1&B&!A1&A|!D&C3&C2&!C1&C&!B1&B&!A1&A|!D&C3&!C2&!C1&C&!B1&B&!A1&A|!D&!C3&!C2&!C1&C&!B1&B&!A1&A|!D&!C3&!C2&!C1&!C&B1&!B&!A1&A|!D&C3&!C2&!C1&!C&B1&!B&!A1&A|!D&C3&C2&!C1&!C&B1&!B&!A1&A|!D&!C3&C2&!C1&!C&B1&!B&!A1&A|!D&!C3&C2&C1&!C&B1&!B&!A1&A|!D&C3&C2&C1&!C&B1&!B&!A1&A|!D&C3&!C2&C1&!C&B1&!B&!A1&A|!D&!C3&!C2&C1&!C&B1&!B&!A1&A|!D&!C3&!C2&C1&C&B1&!B&!A1&A|!D&C3&!C2&C1&C&B1&!B&!A1&A|!D&!C3&C2&C1&C&B1&!B&!A1&A|!D&!C3&C2&!C1&C&B1&!B&!A1&A|!D&C3&C2&!C1&C&B1&!B&!A1&A|!D&C3&!C2&!C1&C&B1&!B&!A1&A|!D&!C3&!C2&!C1&C&B1&!B&!A1&A|!D&!C3&!C2&!C1&C&!B1&!B&!A1&A|!D&C3&!C2&!C1&C&!B1&!B&!A1&A|!D&C3&C2&!C1&C&!B1&!B&!A1&A|!D&!C3&C2&!C1&C&!B1&!B&!A1&A|!D&!C3&C2&C1&C&!B1&!B&!A1&A|!D&C3&!C2&C1&C&!B1&!B&!A1&A|!D&!C3&!C2&C1&C&!B1&!B&!A1&A|!D&!C3&!C2&C1&!C&!B1&!B&!A1&A|!D&C3&!C2&C1&!C&!B1&!B&!A1&A|!D&C3&C2&C1&!C&!B1&!B&!A1&A|!D&!C3&C2&C1&!C&!B1&!B&!A1&A|!D&!C3&C2&!C1&!C&!B1&!B&!A1&A|!D&C3&C2&!C1&!C&!B1&!B&!A1&A|!D&C3&!C2&!C1&!C&!B1&!B&!A1&A|!D&!C3&!C2&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOI2241.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAOI2211 -l AAOAOI2211 -i D C B1 B A1 A -o Y -f Y=(!D&!C&!B1&!B&!A1&!A|!D&C&!B1&!B&!A1&!A|!D&C&B1&!B&!A1&!A|!D&!C&B1&!B&!A1&!A|!D&!C&B1&B&!A1&!A|!D&C&!B1&B&!A1&!A|!D&!C&!B1&B&!A1&!A|!D&!C&!B1&B&A1&!A|!D&C&!B1&B&A1&!A|!D&!C&B1&B&A1&!A|!D&!C&B1&!B&A1&!A|!D&C&B1&!B&A1&!A|!D&C&!B1&!B&A1&!A|!D&!C&!B1&!B&A1&!A|!D&!C&!B1&!B&A1&A|!D&!C&B1&!B&A1&A|!D&!C&B1&B&A1&A|!D&!C&!B1&B&A1&A|!D&!C&!B1&B&!A1&A|!D&C&!B1&B&!A1&A|!D&!C&B1&B&!A1&A|!D&!C&B1&!B&!A1&A|!D&C&B1&!B&!A1&A|!D&C&!B1&!B&!A1&A|!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAOI2211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOI3212 -l AAOAAOI3212 -i D1 D C B1 B A2 A1 A -o Y -f Y=!(D1&D&!C&!B1&!B&!A2&!A1&!A|D1&D&C&!B1&!B&!A2&!A1&!A|D1&D&C&B1&!B&!A2&!A1&!A|D1&D&!C&B1&!B&!A2&!A1&!A|D1&D&!C&B1&B&!A2&!A1&!A|!D1&D&C&B1&B&!A2&!A1&!A|D1&D&C&B1&B&!A2&!A1&!A|D1&!D&C&B1&B&!A2&!A1&!A|!D1&!D&C&B1&B&!A2&!A1&!A|D1&D&C&!B1&B&!A2&!A1&!A|D1&D&!C&!B1&B&!A2&!A1&!A|D1&D&!C&!B1&B&A2&!A1&!A|D1&D&C&!B1&B&A2&!A1&!A|!D1&!D&C&B1&B&A2&!A1&!A|D1&!D&C&B1&B&A2&!A1&!A|D1&D&C&B1&B&A2&!A1&!A|!D1&D&C&B1&B&A2&!A1&!A|D1&D&!C&B1&B&A2&!A1&!A|D1&D&!C&B1&!B&A2&!A1&!A|D1&D&C&B1&!B&A2&!A1&!A|D1&D&C&!B1&!B&A2&!A1&!A|D1&D&!C&!B1&!B&A2&!A1&!A|D1&D&!C&!B1&!B&A2&A1&!A|D1&D&C&!B1&!B&A2&A1&!A|D1&D&C&B1&!B&A2&A1&!A|D1&D&!C&B1&!B&A2&A1&!A|D1&D&!C&B1&B&A2&A1&!A|!D1&D&C&B1&B&A2&A1&!A|D1&D&C&B1&B&A2&A1&!A|D1&!D&C&B1&B&A2&A1&!A|!D1&!D&C&B1&B&A2&A1&!A|D1&D&C&!B1&B&A2&A1&!A|D1&D&!C&!B1&B&A2&A1&!A|D1&D&!C&!B1&B&!A2&A1&!A|D1&D&C&!B1&B&!A2&A1&!A|!D1&!D&C&B1&B&!A2&A1&!A|D1&!D&C&B1&B&!A2&A1&!A|D1&D&C&B1&B&!A2&A1&!A|!D1&D&C&B1&B&!A2&A1&!A|D1&D&!C&B1&B&!A2&A1&!A|D1&D&!C&B1&!B&!A2&A1&!A|D1&D&C&B1&!B&!A2&A1&!A|D1&D&C&!B1&!B&!A2&A1&!A|D1&D&!C&!B1&!B&!A2&A1&!A|D1&D&!C&!B1&!B&!A2&A1&A|D1&D&C&!B1&!B&!A2&A1&A|D1&D&C&B1&!B&!A2&A1&A|D1&D&!C&B1&!B&!A2&A1&A|D1&D&!C&B1&B&!A2&A1&A|!D1&D&C&B1&B&!A2&A1&A|D1&D&C&B1&B&!A2&A1&A|D1&!D&C&B1&B&!A2&A1&A|!D1&!D&C&B1&B&!A2&A1&A|D1&D&C&!B1&B&!A2&A1&A|D1&D&!C&!B1&B&!A2&A1&A|D1&D&!C&!B1&B&A2&A1&A|!D1&D&C&!B1&B&A2&A1&A|D1&D&C&!B1&B&A2&A1&A|D1&!D&C&!B1&B&A2&A1&A|!D1&!D&C&!B1&B&A2&A1&A|!D1&!D&C&B1&B&A2&A1&A|D1&!D&C&B1&B&A2&A1&A|D1&D&C&B1&B&A2&A1&A|!D1&D&C&B1&B&A2&A1&A|D1&D&!C&B1&B&A2&A1&A|D1&D&!C&B1&!B&A2&A1&A|!D1&D&C&B1&!B&A2&A1&A|D1&D&C&B1&!B&A2&A1&A|D1&!D&C&B1&!B&A2&A1&A|!D1&!D&C&B1&!B&A2&A1&A|!D1&!D&C&!B1&!B&A2&A1&A|D1&!D&C&!B1&!B&A2&A1&A|D1&D&C&!B1&!B&A2&A1&A|!D1&D&C&!B1&!B&A2&A1&A|D1&D&!C&!B1&!B&A2&A1&A|D1&D&!C&!B1&!B&A2&!A1&A|D1&D&C&!B1&!B&A2&!A1&A|D1&D&C&B1&!B&A2&!A1&A|D1&D&!C&B1&!B&A2&!A1&A|D1&D&!C&B1&B&A2&!A1&A|!D1&D&C&B1&B&A2&!A1&A|D1&D&C&B1&B&A2&!A1&A|D1&!D&C&B1&B&A2&!A1&A|!D1&!D&C&B1&B&A2&!A1&A|D1&D&C&!B1&B&A2&!A1&A|D1&D&!C&!B1&B&A2&!A1&A|D1&D&!C&!B1&B&!A2&!A1&A|D1&D&C&!B1&B&!A2&!A1&A|!D1&!D&C&B1&B&!A2&!A1&A|D1&!D&C&B1&B&!A2&!A1&A|D1&D&C&B1&B&!A2&!A1&A|!D1&D&C&B1&B&!A2&!A1&A|D1&D&!C&B1&B&!A2&!A1&A|D1&D&!C&B1&!B&!A2&!A1&A|D1&D&C&B1&!B&!A2&!A1&A|D1&D&C&!B1&!B&!A2&!A1&A|D1&D&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOI3212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAOAI211211 -l OAOOAOAI211211 -i F E D1 D C B A1 A -o Y -f Y=!(F&E&!D1&!D&!C&!B&!A1&!A|F&E&D1&!D&!C&!B&!A1&!A|F&E&D1&D&!C&!B&!A1&!A|F&E&!D1&D&!C&!B&!A1&!A|F&!E&!D1&D&C&!B&!A1&!A|F&E&!D1&D&C&!B&!A1&!A|F&E&D1&D&C&!B&!A1&!A|F&!E&D1&D&C&!B&!A1&!A|F&!E&D1&!D&C&!B&!A1&!A|F&E&D1&!D&C&!B&!A1&!A|F&E&!D1&!D&C&!B&!A1&!A|F&E&!D1&!D&C&B&!A1&!A|F&E&D1&!D&C&B&!A1&!A|F&!E&D1&!D&C&B&!A1&!A|F&!E&D1&D&C&B&!A1&!A|F&E&D1&D&C&B&!A1&!A|F&E&!D1&D&C&B&!A1&!A|F&!E&!D1&D&C&B&!A1&!A|F&E&!D1&D&!C&B&!A1&!A|F&E&D1&D&!C&B&!A1&!A|F&E&D1&!D&!C&B&!A1&!A|F&E&!D1&!D&!C&B&!A1&!A|F&E&!D1&!D&!C&B&A1&!A|F&E&D1&!D&!C&B&A1&!A|F&!E&D1&!D&!C&B&A1&!A|F&!E&D1&D&!C&B&A1&!A|F&E&D1&D&!C&B&A1&!A|F&E&!D1&D&!C&B&A1&!A|F&!E&!D1&D&!C&B&A1&!A|F&!E&!D1&D&C&B&A1&!A|F&E&!D1&D&C&B&A1&!A|F&E&D1&D&C&B&A1&!A|F&!E&D1&D&C&B&A1&!A|F&!E&D1&!D&C&B&A1&!A|F&E&D1&!D&C&B&A1&!A|F&E&!D1&!D&C&B&A1&!A|F&E&!D1&!D&C&!B&A1&!A|F&E&D1&!D&C&!B&A1&!A|F&!E&D1&!D&C&!B&A1&!A|F&!E&D1&D&C&!B&A1&!A|F&E&D1&D&C&!B&A1&!A|F&E&!D1&D&C&!B&A1&!A|F&!E&!D1&D&C&!B&A1&!A|F&E&!D1&D&!C&!B&A1&!A|F&E&D1&D&!C&!B&A1&!A|F&E&D1&!D&!C&!B&A1&!A|F&E&!D1&!D&!C&!B&A1&!A|F&E&!D1&!D&!C&!B&A1&A|F&E&D1&!D&!C&!B&A1&A|F&E&D1&D&!C&!B&A1&A|F&E&!D1&D&!C&!B&A1&A|F&!E&!D1&D&C&!B&A1&A|F&E&!D1&D&C&!B&A1&A|F&E&D1&D&C&!B&A1&A|F&!E&D1&D&C&!B&A1&A|F&!E&D1&!D&C&!B&A1&A|F&E&D1&!D&C&!B&A1&A|F&E&!D1&!D&C&!B&A1&A|F&E&!D1&!D&C&B&A1&A|F&E&D1&!D&C&B&A1&A|F&!E&D1&!D&C&B&A1&A|F&!E&D1&D&C&B&A1&A|F&E&D1&D&C&B&A1&A|F&E&!D1&D&C&B&A1&A|F&!E&!D1&D&C&B&A1&A|F&!E&!D1&D&!C&B&A1&A|F&E&!D1&D&!C&B&A1&A|F&E&D1&D&!C&B&A1&A|F&!E&D1&D&!C&B&A1&A|F&!E&D1&!D&!C&B&A1&A|F&E&D1&!D&!C&B&A1&A|F&E&!D1&!D&!C&B&A1&A|F&E&!D1&!D&!C&B&!A1&A|F&E&D1&!D&!C&B&!A1&A|F&!E&D1&!D&!C&B&!A1&A|F&!E&D1&D&!C&B&!A1&A|F&E&D1&D&!C&B&!A1&A|F&E&!D1&D&!C&B&!A1&A|F&!E&!D1&D&!C&B&!A1&A|F&!E&!D1&D&C&B&!A1&A|F&E&!D1&D&C&B&!A1&A|F&E&D1&D&C&B&!A1&A|F&!E&D1&D&C&B&!A1&A|F&!E&D1&!D&C&B&!A1&A|F&E&D1&!D&C&B&!A1&A|F&E&!D1&!D&C&B&!A1&A|F&E&!D1&!D&C&!B&!A1&A|F&E&D1&!D&C&!B&!A1&A|F&!E&D1&!D&C&!B&!A1&A|F&!E&D1&D&C&!B&!A1&A|F&E&D1&D&C&!B&!A1&A|F&E&!D1&D&C&!B&!A1&A|F&!E&!D1&D&C&!B&!A1&A|F&E&!D1&D&!C&!B&!A1&A|F&E&D1&D&!C&!B&!A1&A|F&E&D1&!D&!C&!B&!A1&A|F&E&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAOAI211211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAI21131 -l OAOOAI21131 -i E D2 D1 D C B A1 A -o Y -f Y=!(E&!D2&!D1&D&C&!B&!A1&!A|E&D2&!D1&D&C&!B&!A1&!A|E&D2&D1&D&C&!B&!A1&!A|E&!D2&D1&D&C&!B&!A1&!A|E&!D2&D1&!D&C&!B&!A1&!A|E&D2&D1&!D&C&!B&!A1&!A|E&D2&!D1&!D&C&!B&!A1&!A|E&D2&!D1&!D&C&B&!A1&!A|E&D2&D1&!D&C&B&!A1&!A|E&!D2&D1&!D&C&B&!A1&!A|E&!D2&D1&D&C&B&!A1&!A|E&D2&D1&D&C&B&!A1&!A|E&D2&!D1&D&C&B&!A1&!A|E&!D2&!D1&D&C&B&!A1&!A|E&D2&!D1&!D&!C&B&A1&!A|E&D2&D1&!D&!C&B&A1&!A|E&!D2&D1&!D&!C&B&A1&!A|E&!D2&D1&D&!C&B&A1&!A|E&D2&D1&D&!C&B&A1&!A|E&D2&!D1&D&!C&B&A1&!A|E&!D2&!D1&D&!C&B&A1&!A|E&!D2&!D1&D&C&B&A1&!A|E&D2&!D1&D&C&B&A1&!A|E&D2&D1&D&C&B&A1&!A|E&!D2&D1&D&C&B&A1&!A|E&!D2&D1&!D&C&B&A1&!A|E&D2&D1&!D&C&B&A1&!A|E&D2&!D1&!D&C&B&A1&!A|E&D2&!D1&!D&C&!B&A1&!A|E&D2&D1&!D&C&!B&A1&!A|E&!D2&D1&!D&C&!B&A1&!A|E&!D2&D1&D&C&!B&A1&!A|E&D2&D1&D&C&!B&A1&!A|E&D2&!D1&D&C&!B&A1&!A|E&!D2&!D1&D&C&!B&A1&!A|E&!D2&!D1&D&C&!B&A1&A|E&D2&!D1&D&C&!B&A1&A|E&D2&D1&D&C&!B&A1&A|E&!D2&D1&D&C&!B&A1&A|E&!D2&D1&!D&C&!B&A1&A|E&D2&D1&!D&C&!B&A1&A|E&D2&!D1&!D&C&!B&A1&A|E&D2&!D1&!D&C&B&A1&A|E&D2&D1&!D&C&B&A1&A|E&!D2&D1&!D&C&B&A1&A|E&!D2&D1&D&C&B&A1&A|E&D2&D1&D&C&B&A1&A|E&D2&!D1&D&C&B&A1&A|E&!D2&!D1&D&C&B&A1&A|E&!D2&!D1&D&!C&B&A1&A|E&D2&!D1&D&!C&B&A1&A|E&D2&D1&D&!C&B&A1&A|E&!D2&D1&D&!C&B&A1&A|E&!D2&D1&!D&!C&B&A1&A|E&D2&D1&!D&!C&B&A1&A|E&D2&!D1&!D&!C&B&A1&A|E&D2&!D1&!D&!C&B&!A1&A|E&D2&D1&!D&!C&B&!A1&A|E&!D2&D1&!D&!C&B&!A1&A|E&!D2&D1&D&!C&B&!A1&A|E&D2&D1&D&!C&B&!A1&A|E&D2&!D1&D&!C&B&!A1&A|E&!D2&!D1&D&!C&B&!A1&A|E&!D2&!D1&D&C&B&!A1&A|E&D2&!D1&D&C&B&!A1&A|E&D2&D1&D&C&B&!A1&A|E&!D2&D1&D&C&B&!A1&A|E&!D2&D1&!D&C&B&!A1&A|E&D2&D1&!D&C&B&!A1&A|E&D2&!D1&!D&C&B&!A1&A|E&D2&!D1&!D&C&!B&!A1&A|E&D2&D1&!D&C&!B&!A1&A|E&!D2&D1&!D&C&!B&!A1&A|E&!D2&D1&D&C&!B&!A1&A|E&D2&D1&D&C&!B&!A1&A|E&D2&!D1&D&C&!B&!A1&A|E&!D2&!D1&D&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAI21131.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOOAI2322 -l AOOOAI2322 -i D1 D C1 C B2 B1 B A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B2&!B1&!B&!A1&!A|D1&!D&!C1&!C&!B2&!B1&!B&!A1&!A|D1&D&!C1&!C&!B2&!B1&!B&!A1&!A|!D1&D&!C1&!C&!B2&!B1&!B&!A1&!A|!D1&D&C1&!C&!B2&!B1&!B&!A1&!A|D1&D&C1&!C&!B2&!B1&!B&!A1&!A|D1&!D&C1&!C&!B2&!B1&!B&!A1&!A|!D1&!D&C1&!C&!B2&!B1&!B&!A1&!A|!D1&!D&C1&C&!B2&!B1&!B&!A1&!A|D1&!D&C1&C&!B2&!B1&!B&!A1&!A|D1&D&C1&C&!B2&!B1&!B&!A1&!A|!D1&D&C1&C&!B2&!B1&!B&!A1&!A|!D1&D&!C1&C&!B2&!B1&!B&!A1&!A|D1&D&!C1&C&!B2&!B1&!B&!A1&!A|D1&!D&!C1&C&!B2&!B1&!B&!A1&!A|!D1&!D&!C1&C&!B2&!B1&!B&!A1&!A|!D1&!D&!C1&C&B2&!B1&!B&!A1&!A|!D1&!D&C1&C&B2&!B1&!B&!A1&!A|!D1&!D&C1&!C&B2&!B1&!B&!A1&!A|!D1&D&!C1&!C&B2&!B1&!B&!A1&!A|D1&D&!C1&!C&B2&!B1&!B&!A1&!A|D1&!D&!C1&!C&B2&!B1&!B&!A1&!A|!D1&!D&!C1&!C&B2&!B1&!B&!A1&!A|!D1&!D&!C1&!C&B2&B1&!B&!A1&!A|D1&!D&!C1&!C&B2&B1&!B&!A1&!A|D1&D&!C1&!C&B2&B1&!B&!A1&!A|!D1&D&!C1&!C&B2&B1&!B&!A1&!A|!D1&!D&C1&!C&B2&B1&!B&!A1&!A|!D1&!D&C1&C&B2&B1&!B&!A1&!A|!D1&!D&!C1&C&B2&B1&!B&!A1&!A|!D1&!D&!C1&C&!B2&B1&!B&!A1&!A|!D1&!D&C1&C&!B2&B1&!B&!A1&!A|!D1&!D&C1&!C&!B2&B1&!B&!A1&!A|!D1&D&!C1&!C&!B2&B1&!B&!A1&!A|D1&D&!C1&!C&!B2&B1&!B&!A1&!A|D1&!D&!C1&!C&!B2&B1&!B&!A1&!A|!D1&!D&!C1&!C&!B2&B1&!B&!A1&!A|!D1&!D&!C1&!C&!B2&B1&B&!A1&!A|D1&!D&!C1&!C&!B2&B1&B&!A1&!A|D1&D&!C1&!C&!B2&B1&B&!A1&!A|!D1&D&!C1&!C&!B2&B1&B&!A1&!A|!D1&!D&C1&!C&!B2&B1&B&!A1&!A|!D1&!D&C1&C&!B2&B1&B&!A1&!A|!D1&!D&!C1&C&!B2&B1&B&!A1&!A|!D1&!D&!C1&C&B2&B1&B&!A1&!A|!D1&!D&C1&C&B2&B1&B&!A1&!A|!D1&!D&C1&!C&B2&B1&B&!A1&!A|!D1&D&!C1&!C&B2&B1&B&!A1&!A|D1&D&!C1&!C&B2&B1&B&!A1&!A|D1&!D&!C1&!C&B2&B1&B&!A1&!A|!D1&!D&!C1&!C&B2&B1&B&!A1&!A|!D1&!D&!C1&!C&B2&!B1&B&!A1&!A|D1&!D&!C1&!C&B2&!B1&B&!A1&!A|D1&D&!C1&!C&B2&!B1&B&!A1&!A|!D1&D&!C1&!C&B2&!B1&B&!A1&!A|!D1&!D&C1&!C&B2&!B1&B&!A1&!A|!D1&!D&C1&C&B2&!B1&B&!A1&!A|!D1&!D&!C1&C&B2&!B1&B&!A1&!A|!D1&!D&!C1&C&!B2&!B1&B&!A1&!A|!D1&!D&C1&C&!B2&!B1&B&!A1&!A|!D1&!D&C1&!C&!B2&!B1&B&!A1&!A|!D1&D&!C1&!C&!B2&!B1&B&!A1&!A|D1&D&!C1&!C&!B2&!B1&B&!A1&!A|D1&!D&!C1&!C&!B2&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B2&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B2&!B1&B&A1&!A|D1&!D&!C1&!C&!B2&!B1&B&A1&!A|D1&D&!C1&!C&!B2&!B1&B&A1&!A|!D1&D&!C1&!C&!B2&!B1&B&A1&!A|!D1&!D&C1&!C&!B2&!B1&B&A1&!A|!D1&!D&C1&C&!B2&!B1&B&A1&!A|!D1&!D&!C1&C&!B2&!B1&B&A1&!A|!D1&!D&!C1&C&B2&!B1&B&A1&!A|!D1&!D&C1&C&B2&!B1&B&A1&!A|!D1&!D&C1&!C&B2&!B1&B&A1&!A|!D1&D&!C1&!C&B2&!B1&B&A1&!A|D1&D&!C1&!C&B2&!B1&B&A1&!A|D1&!D&!C1&!C&B2&!B1&B&A1&!A|!D1&!D&!C1&!C&B2&!B1&B&A1&!A|!D1&!D&!C1&!C&B2&B1&B&A1&!A|D1&!D&!C1&!C&B2&B1&B&A1&!A|D1&D&!C1&!C&B2&B1&B&A1&!A|!D1&D&!C1&!C&B2&B1&B&A1&!A|!D1&!D&C1&!C&B2&B1&B&A1&!A|!D1&!D&C1&C&B2&B1&B&A1&!A|!D1&!D&!C1&C&B2&B1&B&A1&!A|!D1&!D&!C1&C&!B2&B1&B&A1&!A|!D1&!D&C1&C&!B2&B1&B&A1&!A|!D1&!D&C1&!C&!B2&B1&B&A1&!A|!D1&D&!C1&!C&!B2&B1&B&A1&!A|D1&D&!C1&!C&!B2&B1&B&A1&!A|D1&!D&!C1&!C&!B2&B1&B&A1&!A|!D1&!D&!C1&!C&!B2&B1&B&A1&!A|!D1&!D&!C1&!C&!B2&B1&!B&A1&!A|D1&!D&!C1&!C&!B2&B1&!B&A1&!A|D1&D&!C1&!C&!B2&B1&!B&A1&!A|!D1&D&!C1&!C&!B2&B1&!B&A1&!A|!D1&!D&C1&!C&!B2&B1&!B&A1&!A|!D1&!D&C1&C&!B2&B1&!B&A1&!A|!D1&!D&!C1&C&!B2&B1&!B&A1&!A|!D1&!D&!C1&C&B2&B1&!B&A1&!A|!D1&!D&C1&C&B2&B1&!B&A1&!A|!D1&!D&C1&!C&B2&B1&!B&A1&!A|!D1&D&!C1&!C&B2&B1&!B&A1&!A|D1&D&!C1&!C&B2&B1&!B&A1&!A|D1&!D&!C1&!C&B2&B1&!B&A1&!A|!D1&!D&!C1&!C&B2&B1&!B&A1&!A|!D1&!D&!C1&!C&B2&!B1&!B&A1&!A|D1&!D&!C1&!C&B2&!B1&!B&A1&!A|D1&D&!C1&!C&B2&!B1&!B&A1&!A|!D1&D&!C1&!C&B2&!B1&!B&A1&!A|!D1&!D&C1&!C&B2&!B1&!B&A1&!A|!D1&!D&C1&C&B2&!B1&!B&A1&!A|!D1&!D&!C1&C&B2&!B1&!B&A1&!A|!D1&!D&!C1&C&!B2&!B1&!B&A1&!A|D1&!D&!C1&C&!B2&!B1&!B&A1&!A|D1&D&!C1&C&!B2&!B1&!B&A1&!A|!D1&D&!C1&C&!B2&!B1&!B&A1&!A|!D1&D&C1&C&!B2&!B1&!B&A1&!A|D1&D&C1&C&!B2&!B1&!B&A1&!A|D1&!D&C1&C&!B2&!B1&!B&A1&!A|!D1&!D&C1&C&!B2&!B1&!B&A1&!A|!D1&!D&C1&!C&!B2&!B1&!B&A1&!A|D1&!D&C1&!C&!B2&!B1&!B&A1&!A|D1&D&C1&!C&!B2&!B1&!B&A1&!A|!D1&D&C1&!C&!B2&!B1&!B&A1&!A|!D1&D&!C1&!C&!B2&!B1&!B&A1&!A|D1&D&!C1&!C&!B2&!B1&!B&A1&!A|D1&!D&!C1&!C&!B2&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B2&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B2&!B1&!B&A1&A|D1&!D&!C1&!C&!B2&!B1&!B&A1&A|D1&D&!C1&!C&!B2&!B1&!B&A1&A|!D1&D&!C1&!C&!B2&!B1&!B&A1&A|!D1&!D&C1&!C&!B2&!B1&!B&A1&A|!D1&!D&C1&C&!B2&!B1&!B&A1&A|!D1&!D&!C1&C&!B2&!B1&!B&A1&A|!D1&!D&!C1&C&B2&!B1&!B&A1&A|!D1&!D&C1&C&B2&!B1&!B&A1&A|!D1&!D&C1&!C&B2&!B1&!B&A1&A|!D1&D&!C1&!C&B2&!B1&!B&A1&A|D1&D&!C1&!C&B2&!B1&!B&A1&A|D1&!D&!C1&!C&B2&!B1&!B&A1&A|!D1&!D&!C1&!C&B2&!B1&!B&A1&A|!D1&!D&!C1&!C&B2&B1&!B&A1&A|D1&!D&!C1&!C&B2&B1&!B&A1&A|D1&D&!C1&!C&B2&B1&!B&A1&A|!D1&D&!C1&!C&B2&B1&!B&A1&A|!D1&!D&C1&!C&B2&B1&!B&A1&A|!D1&!D&C1&C&B2&B1&!B&A1&A|!D1&!D&!C1&C&B2&B1&!B&A1&A|!D1&!D&!C1&C&!B2&B1&!B&A1&A|!D1&!D&C1&C&!B2&B1&!B&A1&A|!D1&!D&C1&!C&!B2&B1&!B&A1&A|!D1&D&!C1&!C&!B2&B1&!B&A1&A|D1&D&!C1&!C&!B2&B1&!B&A1&A|D1&!D&!C1&!C&!B2&B1&!B&A1&A|!D1&!D&!C1&!C&!B2&B1&!B&A1&A|!D1&!D&!C1&!C&!B2&B1&B&A1&A|D1&!D&!C1&!C&!B2&B1&B&A1&A|D1&D&!C1&!C&!B2&B1&B&A1&A|!D1&D&!C1&!C&!B2&B1&B&A1&A|!D1&!D&C1&!C&!B2&B1&B&A1&A|!D1&!D&C1&C&!B2&B1&B&A1&A|!D1&!D&!C1&C&!B2&B1&B&A1&A|!D1&!D&!C1&C&B2&B1&B&A1&A|!D1&!D&C1&C&B2&B1&B&A1&A|!D1&!D&C1&!C&B2&B1&B&A1&A|!D1&D&!C1&!C&B2&B1&B&A1&A|D1&D&!C1&!C&B2&B1&B&A1&A|D1&!D&!C1&!C&B2&B1&B&A1&A|!D1&!D&!C1&!C&B2&B1&B&A1&A|!D1&!D&!C1&!C&B2&!B1&B&A1&A|D1&!D&!C1&!C&B2&!B1&B&A1&A|D1&D&!C1&!C&B2&!B1&B&A1&A|!D1&D&!C1&!C&B2&!B1&B&A1&A|!D1&!D&C1&!C&B2&!B1&B&A1&A|!D1&!D&C1&C&B2&!B1&B&A1&A|!D1&!D&!C1&C&B2&!B1&B&A1&A|!D1&!D&!C1&C&!B2&!B1&B&A1&A|!D1&!D&C1&C&!B2&!B1&B&A1&A|!D1&!D&C1&!C&!B2&!B1&B&A1&A|!D1&D&!C1&!C&!B2&!B1&B&A1&A|D1&D&!C1&!C&!B2&!B1&B&A1&A|D1&!D&!C1&!C&!B2&!B1&B&A1&A|!D1&!D&!C1&!C&!B2&!B1&B&A1&A|!D1&!D&!C1&!C&!B2&!B1&B&!A1&A|D1&!D&!C1&!C&!B2&!B1&B&!A1&A|D1&D&!C1&!C&!B2&!B1&B&!A1&A|!D1&D&!C1&!C&!B2&!B1&B&!A1&A|!D1&!D&C1&!C&!B2&!B1&B&!A1&A|!D1&!D&C1&C&!B2&!B1&B&!A1&A|!D1&!D&!C1&C&!B2&!B1&B&!A1&A|!D1&!D&!C1&C&B2&!B1&B&!A1&A|!D1&!D&C1&C&B2&!B1&B&!A1&A|!D1&!D&C1&!C&B2&!B1&B&!A1&A|!D1&D&!C1&!C&B2&!B1&B&!A1&A|D1&D&!C1&!C&B2&!B1&B&!A1&A|D1&!D&!C1&!C&B2&!B1&B&!A1&A|!D1&!D&!C1&!C&B2&!B1&B&!A1&A|!D1&!D&!C1&!C&B2&B1&B&!A1&A|D1&!D&!C1&!C&B2&B1&B&!A1&A|D1&D&!C1&!C&B2&B1&B&!A1&A|!D1&D&!C1&!C&B2&B1&B&!A1&A|!D1&!D&C1&!C&B2&B1&B&!A1&A|!D1&!D&C1&C&B2&B1&B&!A1&A|!D1&!D&!C1&C&B2&B1&B&!A1&A|!D1&!D&!C1&C&!B2&B1&B&!A1&A|!D1&!D&C1&C&!B2&B1&B&!A1&A|!D1&!D&C1&!C&!B2&B1&B&!A1&A|!D1&D&!C1&!C&!B2&B1&B&!A1&A|D1&D&!C1&!C&!B2&B1&B&!A1&A|D1&!D&!C1&!C&!B2&B1&B&!A1&A|!D1&!D&!C1&!C&!B2&B1&B&!A1&A|!D1&!D&!C1&!C&!B2&B1&!B&!A1&A|D1&!D&!C1&!C&!B2&B1&!B&!A1&A|D1&D&!C1&!C&!B2&B1&!B&!A1&A|!D1&D&!C1&!C&!B2&B1&!B&!A1&A|!D1&!D&C1&!C&!B2&B1&!B&!A1&A|!D1&!D&C1&C&!B2&B1&!B&!A1&A|!D1&!D&!C1&C&!B2&B1&!B&!A1&A|!D1&!D&!C1&C&B2&B1&!B&!A1&A|!D1&!D&C1&C&B2&B1&!B&!A1&A|!D1&!D&C1&!C&B2&B1&!B&!A1&A|!D1&D&!C1&!C&B2&B1&!B&!A1&A|D1&D&!C1&!C&B2&B1&!B&!A1&A|D1&!D&!C1&!C&B2&B1&!B&!A1&A|!D1&!D&!C1&!C&B2&B1&!B&!A1&A|!D1&!D&!C1&!C&B2&!B1&!B&!A1&A|D1&!D&!C1&!C&B2&!B1&!B&!A1&A|D1&D&!C1&!C&B2&!B1&!B&!A1&A|!D1&D&!C1&!C&B2&!B1&!B&!A1&A|!D1&!D&C1&!C&B2&!B1&!B&!A1&A|!D1&!D&C1&C&B2&!B1&!B&!A1&A|!D1&!D&!C1&C&B2&!B1&!B&!A1&A|!D1&!D&!C1&C&!B2&!B1&!B&!A1&A|D1&!D&!C1&C&!B2&!B1&!B&!A1&A|D1&D&!C1&C&!B2&!B1&!B&!A1&A|!D1&D&!C1&C&!B2&!B1&!B&!A1&A|!D1&D&C1&C&!B2&!B1&!B&!A1&A|D1&D&C1&C&!B2&!B1&!B&!A1&A|D1&!D&C1&C&!B2&!B1&!B&!A1&A|!D1&!D&C1&C&!B2&!B1&!B&!A1&A|!D1&!D&C1&!C&!B2&!B1&!B&!A1&A|D1&!D&C1&!C&!B2&!B1&!B&!A1&A|D1&D&C1&!C&!B2&!B1&!B&!A1&A|!D1&D&C1&!C&!B2&!B1&!B&!A1&A|!D1&D&!C1&!C&!B2&!B1&!B&!A1&A|D1&D&!C1&!C&!B2&!B1&!B&!A1&A|D1&!D&!C1&!C&!B2&!B1&!B&!A1&A|!D1&!D&!C1&!C&!B2&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOOAI2322.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAAOOAI22222 -l AAOOAAOOAI22222 -i E1 E D1 D C1 C B1 B A1 A -o Y -f Y=!(E1&!E&D1&D&!C1&!C&!B1&!B&!A1&!A|E1&E&D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&E&D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&E&D1&D&C1&!C&!B1&!B&!A1&!A|E1&E&D1&D&C1&!C&!B1&!B&!A1&!A|E1&!E&D1&D&C1&!C&!B1&!B&!A1&!A|E1&!E&D1&D&C1&C&!B1&!B&!A1&!A|E1&E&D1&D&C1&C&!B1&!B&!A1&!A|!E1&E&D1&D&C1&C&!B1&!B&!A1&!A|!E1&E&D1&D&!C1&C&!B1&!B&!A1&!A|E1&E&D1&D&!C1&C&!B1&!B&!A1&!A|E1&!E&D1&D&!C1&C&!B1&!B&!A1&!A|E1&!E&D1&D&!C1&C&B1&!B&!A1&!A|E1&E&D1&D&!C1&C&B1&!B&!A1&!A|!E1&E&D1&D&!C1&C&B1&!B&!A1&!A|!E1&E&D1&D&C1&C&B1&!B&!A1&!A|E1&E&D1&D&C1&C&B1&!B&!A1&!A|E1&!E&D1&D&C1&C&B1&!B&!A1&!A|E1&!E&D1&D&C1&!C&B1&!B&!A1&!A|E1&E&D1&D&C1&!C&B1&!B&!A1&!A|!E1&E&D1&D&C1&!C&B1&!B&!A1&!A|!E1&E&D1&D&!C1&!C&B1&!B&!A1&!A|E1&E&D1&D&!C1&!C&B1&!B&!A1&!A|E1&!E&D1&D&!C1&!C&B1&!B&!A1&!A|E1&!E&D1&D&!C1&!C&B1&B&!A1&!A|E1&E&D1&D&!C1&!C&B1&B&!A1&!A|!E1&E&D1&D&!C1&!C&B1&B&!A1&!A|E1&!E&!D1&D&C1&!C&B1&B&!A1&!A|E1&E&!D1&D&C1&!C&B1&B&!A1&!A|!E1&E&!D1&D&C1&!C&B1&B&!A1&!A|!E1&E&D1&D&C1&!C&B1&B&!A1&!A|E1&E&D1&D&C1&!C&B1&B&!A1&!A|E1&!E&D1&D&C1&!C&B1&B&!A1&!A|E1&!E&D1&!D&C1&!C&B1&B&!A1&!A|E1&E&D1&!D&C1&!C&B1&B&!A1&!A|!E1&E&D1&!D&C1&!C&B1&B&!A1&!A|!E1&E&!D1&!D&C1&!C&B1&B&!A1&!A|E1&E&!D1&!D&C1&!C&B1&B&!A1&!A|E1&!E&!D1&!D&C1&!C&B1&B&!A1&!A|E1&!E&!D1&!D&C1&C&B1&B&!A1&!A|E1&E&!D1&!D&C1&C&B1&B&!A1&!A|!E1&E&!D1&!D&C1&C&B1&B&!A1&!A|!E1&E&D1&!D&C1&C&B1&B&!A1&!A|E1&E&D1&!D&C1&C&B1&B&!A1&!A|E1&!E&D1&!D&C1&C&B1&B&!A1&!A|E1&!E&D1&D&C1&C&B1&B&!A1&!A|E1&E&D1&D&C1&C&B1&B&!A1&!A|!E1&E&D1&D&C1&C&B1&B&!A1&!A|!E1&E&!D1&D&C1&C&B1&B&!A1&!A|E1&E&!D1&D&C1&C&B1&B&!A1&!A|E1&!E&!D1&D&C1&C&B1&B&!A1&!A|E1&!E&!D1&D&!C1&C&B1&B&!A1&!A|E1&E&!D1&D&!C1&C&B1&B&!A1&!A|!E1&E&!D1&D&!C1&C&B1&B&!A1&!A|!E1&E&D1&D&!C1&C&B1&B&!A1&!A|E1&E&D1&D&!C1&C&B1&B&!A1&!A|E1&!E&D1&D&!C1&C&B1&B&!A1&!A|E1&!E&D1&!D&!C1&C&B1&B&!A1&!A|E1&E&D1&!D&!C1&C&B1&B&!A1&!A|!E1&E&D1&!D&!C1&C&B1&B&!A1&!A|!E1&E&!D1&!D&!C1&C&B1&B&!A1&!A|E1&E&!D1&!D&!C1&C&B1&B&!A1&!A|E1&!E&!D1&!D&!C1&C&B1&B&!A1&!A|E1&!E&D1&D&!C1&C&!B1&B&!A1&!A|E1&E&D1&D&!C1&C&!B1&B&!A1&!A|!E1&E&D1&D&!C1&C&!B1&B&!A1&!A|!E1&E&D1&D&C1&C&!B1&B&!A1&!A|E1&E&D1&D&C1&C&!B1&B&!A1&!A|E1&!E&D1&D&C1&C&!B1&B&!A1&!A|E1&!E&D1&D&C1&!C&!B1&B&!A1&!A|E1&E&D1&D&C1&!C&!B1&B&!A1&!A|!E1&E&D1&D&C1&!C&!B1&B&!A1&!A|!E1&E&D1&D&!C1&!C&!B1&B&!A1&!A|E1&E&D1&D&!C1&!C&!B1&B&!A1&!A|E1&!E&D1&D&!C1&!C&!B1&B&!A1&!A|E1&!E&D1&D&!C1&!C&!B1&B&A1&!A|E1&E&D1&D&!C1&!C&!B1&B&A1&!A|!E1&E&D1&D&!C1&!C&!B1&B&A1&!A|!E1&E&D1&D&C1&!C&!B1&B&A1&!A|E1&E&D1&D&C1&!C&!B1&B&A1&!A|E1&!E&D1&D&C1&!C&!B1&B&A1&!A|E1&!E&D1&D&C1&C&!B1&B&A1&!A|E1&E&D1&D&C1&C&!B1&B&A1&!A|!E1&E&D1&D&C1&C&!B1&B&A1&!A|!E1&E&D1&D&!C1&C&!B1&B&A1&!A|E1&E&D1&D&!C1&C&!B1&B&A1&!A|E1&!E&D1&D&!C1&C&!B1&B&A1&!A|E1&!E&!D1&!D&!C1&C&B1&B&A1&!A|E1&E&!D1&!D&!C1&C&B1&B&A1&!A|!E1&E&!D1&!D&!C1&C&B1&B&A1&!A|!E1&E&D1&!D&!C1&C&B1&B&A1&!A|E1&E&D1&!D&!C1&C&B1&B&A1&!A|E1&!E&D1&!D&!C1&C&B1&B&A1&!A|E1&!E&D1&D&!C1&C&B1&B&A1&!A|E1&E&D1&D&!C1&C&B1&B&A1&!A|!E1&E&D1&D&!C1&C&B1&B&A1&!A|!E1&E&!D1&D&!C1&C&B1&B&A1&!A|E1&E&!D1&D&!C1&C&B1&B&A1&!A|E1&!E&!D1&D&!C1&C&B1&B&A1&!A|E1&!E&!D1&D&C1&C&B1&B&A1&!A|E1&E&!D1&D&C1&C&B1&B&A1&!A|!E1&E&!D1&D&C1&C&B1&B&A1&!A|!E1&E&D1&D&C1&C&B1&B&A1&!A|E1&E&D1&D&C1&C&B1&B&A1&!A|E1&!E&D1&D&C1&C&B1&B&A1&!A|E1&!E&D1&!D&C1&C&B1&B&A1&!A|E1&E&D1&!D&C1&C&B1&B&A1&!A|!E1&E&D1&!D&C1&C&B1&B&A1&!A|!E1&E&!D1&!D&C1&C&B1&B&A1&!A|E1&E&!D1&!D&C1&C&B1&B&A1&!A|E1&!E&!D1&!D&C1&C&B1&B&A1&!A|E1&!E&!D1&!D&C1&!C&B1&B&A1&!A|E1&E&!D1&!D&C1&!C&B1&B&A1&!A|!E1&E&!D1&!D&C1&!C&B1&B&A1&!A|!E1&E&D1&!D&C1&!C&B1&B&A1&!A|E1&E&D1&!D&C1&!C&B1&B&A1&!A|E1&!E&D1&!D&C1&!C&B1&B&A1&!A|E1&!E&D1&D&C1&!C&B1&B&A1&!A|E1&E&D1&D&C1&!C&B1&B&A1&!A|!E1&E&D1&D&C1&!C&B1&B&A1&!A|!E1&E&!D1&D&C1&!C&B1&B&A1&!A|E1&E&!D1&D&C1&!C&B1&B&A1&!A|E1&!E&!D1&D&C1&!C&B1&B&A1&!A|!E1&E&D1&D&!C1&!C&B1&B&A1&!A|E1&E&D1&D&!C1&!C&B1&B&A1&!A|E1&!E&D1&D&!C1&!C&B1&B&A1&!A|E1&!E&D1&D&!C1&!C&B1&!B&A1&!A|E1&E&D1&D&!C1&!C&B1&!B&A1&!A|!E1&E&D1&D&!C1&!C&B1&!B&A1&!A|!E1&E&D1&D&C1&!C&B1&!B&A1&!A|E1&E&D1&D&C1&!C&B1&!B&A1&!A|E1&!E&D1&D&C1&!C&B1&!B&A1&!A|E1&!E&D1&D&C1&C&B1&!B&A1&!A|E1&E&D1&D&C1&C&B1&!B&A1&!A|!E1&E&D1&D&C1&C&B1&!B&A1&!A|!E1&E&D1&D&!C1&C&B1&!B&A1&!A|E1&E&D1&D&!C1&C&B1&!B&A1&!A|E1&!E&D1&D&!C1&C&B1&!B&A1&!A|E1&!E&D1&D&!C1&C&!B1&!B&A1&!A|E1&E&D1&D&!C1&C&!B1&!B&A1&!A|!E1&E&D1&D&!C1&C&!B1&!B&A1&!A|!E1&E&D1&D&C1&C&!B1&!B&A1&!A|E1&E&D1&D&C1&C&!B1&!B&A1&!A|E1&!E&D1&D&C1&C&!B1&!B&A1&!A|E1&!E&D1&D&C1&!C&!B1&!B&A1&!A|E1&E&D1&D&C1&!C&!B1&!B&A1&!A|!E1&E&D1&D&C1&!C&!B1&!B&A1&!A|!E1&E&D1&D&!C1&!C&!B1&!B&A1&!A|E1&E&D1&D&!C1&!C&!B1&!B&A1&!A|E1&!E&D1&D&!C1&!C&!B1&!B&A1&!A|E1&!E&D1&D&!C1&!C&!B1&!B&A1&A|E1&E&D1&D&!C1&!C&!B1&!B&A1&A|!E1&E&D1&D&!C1&!C&!B1&!B&A1&A|E1&!E&!D1&D&C1&!C&!B1&!B&A1&A|E1&E&!D1&D&C1&!C&!B1&!B&A1&A|!E1&E&!D1&D&C1&!C&!B1&!B&A1&A|!E1&E&D1&D&C1&!C&!B1&!B&A1&A|E1&E&D1&D&C1&!C&!B1&!B&A1&A|E1&!E&D1&D&C1&!C&!B1&!B&A1&A|E1&!E&D1&!D&C1&!C&!B1&!B&A1&A|E1&E&D1&!D&C1&!C&!B1&!B&A1&A|!E1&E&D1&!D&C1&!C&!B1&!B&A1&A|!E1&E&!D1&!D&C1&!C&!B1&!B&A1&A|E1&E&!D1&!D&C1&!C&!B1&!B&A1&A|E1&!E&!D1&!D&C1&!C&!B1&!B&A1&A|E1&!E&!D1&!D&C1&C&!B1&!B&A1&A|E1&E&!D1&!D&C1&C&!B1&!B&A1&A|!E1&E&!D1&!D&C1&C&!B1&!B&A1&A|!E1&E&D1&!D&C1&C&!B1&!B&A1&A|E1&E&D1&!D&C1&C&!B1&!B&A1&A|E1&!E&D1&!D&C1&C&!B1&!B&A1&A|E1&!E&D1&D&C1&C&!B1&!B&A1&A|E1&E&D1&D&C1&C&!B1&!B&A1&A|!E1&E&D1&D&C1&C&!B1&!B&A1&A|!E1&E&!D1&D&C1&C&!B1&!B&A1&A|E1&E&!D1&D&C1&C&!B1&!B&A1&A|E1&!E&!D1&D&C1&C&!B1&!B&A1&A|E1&!E&!D1&D&!C1&C&!B1&!B&A1&A|E1&E&!D1&D&!C1&C&!B1&!B&A1&A|!E1&E&!D1&D&!C1&C&!B1&!B&A1&A|!E1&E&D1&D&!C1&C&!B1&!B&A1&A|E1&E&D1&D&!C1&C&!B1&!B&A1&A|E1&!E&D1&D&!C1&C&!B1&!B&A1&A|E1&!E&D1&!D&!C1&C&!B1&!B&A1&A|E1&E&D1&!D&!C1&C&!B1&!B&A1&A|!E1&E&D1&!D&!C1&C&!B1&!B&A1&A|!E1&E&!D1&!D&!C1&C&!B1&!B&A1&A|E1&E&!D1&!D&!C1&C&!B1&!B&A1&A|E1&!E&!D1&!D&!C1&C&!B1&!B&A1&A|E1&!E&!D1&!D&!C1&C&B1&!B&A1&A|E1&E&!D1&!D&!C1&C&B1&!B&A1&A|!E1&E&!D1&!D&!C1&C&B1&!B&A1&A|!E1&E&D1&!D&!C1&C&B1&!B&A1&A|E1&E&D1&!D&!C1&C&B1&!B&A1&A|E1&!E&D1&!D&!C1&C&B1&!B&A1&A|E1&!E&D1&D&!C1&C&B1&!B&A1&A|E1&E&D1&D&!C1&C&B1&!B&A1&A|!E1&E&D1&D&!C1&C&B1&!B&A1&A|!E1&E&!D1&D&!C1&C&B1&!B&A1&A|E1&E&!D1&D&!C1&C&B1&!B&A1&A|E1&!E&!D1&D&!C1&C&B1&!B&A1&A|E1&!E&!D1&D&C1&C&B1&!B&A1&A|E1&E&!D1&D&C1&C&B1&!B&A1&A|!E1&E&!D1&D&C1&C&B1&!B&A1&A|!E1&E&D1&D&C1&C&B1&!B&A1&A|E1&E&D1&D&C1&C&B1&!B&A1&A|E1&!E&D1&D&C1&C&B1&!B&A1&A|E1&!E&D1&!D&C1&C&B1&!B&A1&A|E1&E&D1&!D&C1&C&B1&!B&A1&A|!E1&E&D1&!D&C1&C&B1&!B&A1&A|!E1&E&!D1&!D&C1&C&B1&!B&A1&A|E1&E&!D1&!D&C1&C&B1&!B&A1&A|E1&!E&!D1&!D&C1&C&B1&!B&A1&A|E1&!E&!D1&!D&C1&!C&B1&!B&A1&A|E1&E&!D1&!D&C1&!C&B1&!B&A1&A|!E1&E&!D1&!D&C1&!C&B1&!B&A1&A|!E1&E&D1&!D&C1&!C&B1&!B&A1&A|E1&E&D1&!D&C1&!C&B1&!B&A1&A|E1&!E&D1&!D&C1&!C&B1&!B&A1&A|E1&!E&D1&D&C1&!C&B1&!B&A1&A|E1&E&D1&D&C1&!C&B1&!B&A1&A|!E1&E&D1&D&C1&!C&B1&!B&A1&A|!E1&E&!D1&D&C1&!C&B1&!B&A1&A|E1&E&!D1&D&C1&!C&B1&!B&A1&A|E1&!E&!D1&D&C1&!C&B1&!B&A1&A|!E1&E&D1&D&!C1&!C&B1&!B&A1&A|E1&E&D1&D&!C1&!C&B1&!B&A1&A|E1&!E&D1&D&!C1&!C&B1&!B&A1&A|E1&!E&D1&D&!C1&!C&B1&B&A1&A|E1&E&D1&D&!C1&!C&B1&B&A1&A|!E1&E&D1&D&!C1&!C&B1&B&A1&A|E1&!E&!D1&D&C1&!C&B1&B&A1&A|E1&E&!D1&D&C1&!C&B1&B&A1&A|!E1&E&!D1&D&C1&!C&B1&B&A1&A|!E1&E&D1&D&C1&!C&B1&B&A1&A|E1&E&D1&D&C1&!C&B1&B&A1&A|E1&!E&D1&D&C1&!C&B1&B&A1&A|E1&!E&D1&!D&C1&!C&B1&B&A1&A|E1&E&D1&!D&C1&!C&B1&B&A1&A|!E1&E&D1&!D&C1&!C&B1&B&A1&A|!E1&E&!D1&!D&C1&!C&B1&B&A1&A|E1&E&!D1&!D&C1&!C&B1&B&A1&A|E1&!E&!D1&!D&C1&!C&B1&B&A1&A|E1&!E&!D1&!D&C1&C&B1&B&A1&A|E1&E&!D1&!D&C1&C&B1&B&A1&A|!E1&E&!D1&!D&C1&C&B1&B&A1&A|!E1&E&D1&!D&C1&C&B1&B&A1&A|E1&E&D1&!D&C1&C&B1&B&A1&A|E1&!E&D1&!D&C1&C&B1&B&A1&A|E1&!E&D1&D&C1&C&B1&B&A1&A|E1&E&D1&D&C1&C&B1&B&A1&A|!E1&E&D1&D&C1&C&B1&B&A1&A|!E1&E&!D1&D&C1&C&B1&B&A1&A|E1&E&!D1&D&C1&C&B1&B&A1&A|E1&!E&!D1&D&C1&C&B1&B&A1&A|E1&!E&!D1&D&!C1&C&B1&B&A1&A|E1&E&!D1&D&!C1&C&B1&B&A1&A|!E1&E&!D1&D&!C1&C&B1&B&A1&A|!E1&E&D1&D&!C1&C&B1&B&A1&A|E1&E&D1&D&!C1&C&B1&B&A1&A|E1&!E&D1&D&!C1&C&B1&B&A1&A|E1&!E&D1&!D&!C1&C&B1&B&A1&A|E1&E&D1&!D&!C1&C&B1&B&A1&A|!E1&E&D1&!D&!C1&C&B1&B&A1&A|!E1&E&!D1&!D&!C1&C&B1&B&A1&A|E1&E&!D1&!D&!C1&C&B1&B&A1&A|E1&!E&!D1&!D&!C1&C&B1&B&A1&A|E1&!E&!D1&!D&!C1&C&!B1&B&A1&A|E1&E&!D1&!D&!C1&C&!B1&B&A1&A|!E1&E&!D1&!D&!C1&C&!B1&B&A1&A|!E1&E&D1&!D&!C1&C&!B1&B&A1&A|E1&E&D1&!D&!C1&C&!B1&B&A1&A|E1&!E&D1&!D&!C1&C&!B1&B&A1&A|E1&!E&D1&D&!C1&C&!B1&B&A1&A|E1&E&D1&D&!C1&C&!B1&B&A1&A|!E1&E&D1&D&!C1&C&!B1&B&A1&A|!E1&E&!D1&D&!C1&C&!B1&B&A1&A|E1&E&!D1&D&!C1&C&!B1&B&A1&A|E1&!E&!D1&D&!C1&C&!B1&B&A1&A|E1&!E&!D1&D&C1&C&!B1&B&A1&A|E1&E&!D1&D&C1&C&!B1&B&A1&A|!E1&E&!D1&D&C1&C&!B1&B&A1&A|!E1&E&D1&D&C1&C&!B1&B&A1&A|E1&E&D1&D&C1&C&!B1&B&A1&A|E1&!E&D1&D&C1&C&!B1&B&A1&A|E1&!E&D1&!D&C1&C&!B1&B&A1&A|E1&E&D1&!D&C1&C&!B1&B&A1&A|!E1&E&D1&!D&C1&C&!B1&B&A1&A|!E1&E&!D1&!D&C1&C&!B1&B&A1&A|E1&E&!D1&!D&C1&C&!B1&B&A1&A|E1&!E&!D1&!D&C1&C&!B1&B&A1&A|E1&!E&!D1&!D&C1&!C&!B1&B&A1&A|E1&E&!D1&!D&C1&!C&!B1&B&A1&A|!E1&E&!D1&!D&C1&!C&!B1&B&A1&A|!E1&E&D1&!D&C1&!C&!B1&B&A1&A|E1&E&D1&!D&C1&!C&!B1&B&A1&A|E1&!E&D1&!D&C1&!C&!B1&B&A1&A|E1&!E&D1&D&C1&!C&!B1&B&A1&A|E1&E&D1&D&C1&!C&!B1&B&A1&A|!E1&E&D1&D&C1&!C&!B1&B&A1&A|!E1&E&!D1&D&C1&!C&!B1&B&A1&A|E1&E&!D1&D&C1&!C&!B1&B&A1&A|E1&!E&!D1&D&C1&!C&!B1&B&A1&A|!E1&E&D1&D&!C1&!C&!B1&B&A1&A|E1&E&D1&D&!C1&!C&!B1&B&A1&A|E1&!E&D1&D&!C1&!C&!B1&B&A1&A|E1&!E&D1&D&!C1&!C&!B1&B&!A1&A|E1&E&D1&D&!C1&!C&!B1&B&!A1&A|!E1&E&D1&D&!C1&!C&!B1&B&!A1&A|!E1&E&D1&D&C1&!C&!B1&B&!A1&A|E1&E&D1&D&C1&!C&!B1&B&!A1&A|E1&!E&D1&D&C1&!C&!B1&B&!A1&A|E1&!E&D1&D&C1&C&!B1&B&!A1&A|E1&E&D1&D&C1&C&!B1&B&!A1&A|!E1&E&D1&D&C1&C&!B1&B&!A1&A|!E1&E&D1&D&!C1&C&!B1&B&!A1&A|E1&E&D1&D&!C1&C&!B1&B&!A1&A|E1&!E&D1&D&!C1&C&!B1&B&!A1&A|E1&!E&!D1&!D&!C1&C&B1&B&!A1&A|E1&E&!D1&!D&!C1&C&B1&B&!A1&A|!E1&E&!D1&!D&!C1&C&B1&B&!A1&A|!E1&E&D1&!D&!C1&C&B1&B&!A1&A|E1&E&D1&!D&!C1&C&B1&B&!A1&A|E1&!E&D1&!D&!C1&C&B1&B&!A1&A|E1&!E&D1&D&!C1&C&B1&B&!A1&A|E1&E&D1&D&!C1&C&B1&B&!A1&A|!E1&E&D1&D&!C1&C&B1&B&!A1&A|!E1&E&!D1&D&!C1&C&B1&B&!A1&A|E1&E&!D1&D&!C1&C&B1&B&!A1&A|E1&!E&!D1&D&!C1&C&B1&B&!A1&A|E1&!E&!D1&D&C1&C&B1&B&!A1&A|E1&E&!D1&D&C1&C&B1&B&!A1&A|!E1&E&!D1&D&C1&C&B1&B&!A1&A|!E1&E&D1&D&C1&C&B1&B&!A1&A|E1&E&D1&D&C1&C&B1&B&!A1&A|E1&!E&D1&D&C1&C&B1&B&!A1&A|E1&!E&D1&!D&C1&C&B1&B&!A1&A|E1&E&D1&!D&C1&C&B1&B&!A1&A|!E1&E&D1&!D&C1&C&B1&B&!A1&A|!E1&E&!D1&!D&C1&C&B1&B&!A1&A|E1&E&!D1&!D&C1&C&B1&B&!A1&A|E1&!E&!D1&!D&C1&C&B1&B&!A1&A|E1&!E&!D1&!D&C1&!C&B1&B&!A1&A|E1&E&!D1&!D&C1&!C&B1&B&!A1&A|!E1&E&!D1&!D&C1&!C&B1&B&!A1&A|!E1&E&D1&!D&C1&!C&B1&B&!A1&A|E1&E&D1&!D&C1&!C&B1&B&!A1&A|E1&!E&D1&!D&C1&!C&B1&B&!A1&A|E1&!E&D1&D&C1&!C&B1&B&!A1&A|E1&E&D1&D&C1&!C&B1&B&!A1&A|!E1&E&D1&D&C1&!C&B1&B&!A1&A|!E1&E&!D1&D&C1&!C&B1&B&!A1&A|E1&E&!D1&D&C1&!C&B1&B&!A1&A|E1&!E&!D1&D&C1&!C&B1&B&!A1&A|!E1&E&D1&D&!C1&!C&B1&B&!A1&A|E1&E&D1&D&!C1&!C&B1&B&!A1&A|E1&!E&D1&D&!C1&!C&B1&B&!A1&A|E1&!E&D1&D&!C1&!C&B1&!B&!A1&A|E1&E&D1&D&!C1&!C&B1&!B&!A1&A|!E1&E&D1&D&!C1&!C&B1&!B&!A1&A|!E1&E&D1&D&C1&!C&B1&!B&!A1&A|E1&E&D1&D&C1&!C&B1&!B&!A1&A|E1&!E&D1&D&C1&!C&B1&!B&!A1&A|E1&!E&D1&D&C1&C&B1&!B&!A1&A|E1&E&D1&D&C1&C&B1&!B&!A1&A|!E1&E&D1&D&C1&C&B1&!B&!A1&A|!E1&E&D1&D&!C1&C&B1&!B&!A1&A|E1&E&D1&D&!C1&C&B1&!B&!A1&A|E1&!E&D1&D&!C1&C&B1&!B&!A1&A|E1&!E&D1&D&!C1&C&!B1&!B&!A1&A|E1&E&D1&D&!C1&C&!B1&!B&!A1&A|!E1&E&D1&D&!C1&C&!B1&!B&!A1&A|!E1&E&D1&D&C1&C&!B1&!B&!A1&A|E1&E&D1&D&C1&C&!B1&!B&!A1&A|E1&!E&D1&D&C1&C&!B1&!B&!A1&A|E1&!E&D1&D&C1&!C&!B1&!B&!A1&A|E1&E&D1&D&C1&!C&!B1&!B&!A1&A|!E1&E&D1&D&C1&!C&!B1&!B&!A1&A|!E1&E&D1&D&!C1&!C&!B1&!B&!A1&A|E1&E&D1&D&!C1&!C&!B1&!B&!A1&A|E1&!E&D1&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAAOOAI22222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOAI221311 -l OOAAOAI221311 -i F E D2 D1 D C B1 B A1 A -o Y -f Y=!(F&E&!D2&!D1&D&C&!B1&!B&!A1&!A|F&E&D2&!D1&D&C&!B1&!B&!A1&!A|F&E&D2&D1&D&C&!B1&!B&!A1&!A|F&E&!D2&D1&D&C&!B1&!B&!A1&!A|F&E&!D2&D1&!D&C&!B1&!B&!A1&!A|F&E&D2&D1&!D&C&!B1&!B&!A1&!A|F&E&D2&!D1&!D&C&!B1&!B&!A1&!A|F&E&D2&!D1&!D&C&B1&!B&!A1&!A|F&E&D2&D1&!D&C&B1&!B&!A1&!A|F&E&!D2&D1&!D&C&B1&!B&!A1&!A|F&E&!D2&D1&D&C&B1&!B&!A1&!A|F&E&D2&D1&D&C&B1&!B&!A1&!A|F&E&D2&!D1&D&C&B1&!B&!A1&!A|F&E&!D2&!D1&D&C&B1&!B&!A1&!A|F&E&D2&!D1&!D&!C&B1&B&!A1&!A|F&E&D2&D1&!D&!C&B1&B&!A1&!A|F&E&!D2&D1&!D&!C&B1&B&!A1&!A|F&E&!D2&D1&D&!C&B1&B&!A1&!A|F&E&D2&D1&D&!C&B1&B&!A1&!A|F&E&D2&!D1&D&!C&B1&B&!A1&!A|F&E&!D2&!D1&D&!C&B1&B&!A1&!A|F&E&!D2&!D1&D&C&B1&B&!A1&!A|F&E&D2&!D1&D&C&B1&B&!A1&!A|F&E&D2&D1&D&C&B1&B&!A1&!A|F&E&!D2&D1&D&C&B1&B&!A1&!A|F&E&!D2&D1&!D&C&B1&B&!A1&!A|F&E&D2&D1&!D&C&B1&B&!A1&!A|F&E&D2&!D1&!D&C&B1&B&!A1&!A|F&E&D2&!D1&!D&C&!B1&B&!A1&!A|F&E&D2&D1&!D&C&!B1&B&!A1&!A|F&E&!D2&D1&!D&C&!B1&B&!A1&!A|F&E&!D2&D1&D&C&!B1&B&!A1&!A|F&E&D2&D1&D&C&!B1&B&!A1&!A|F&E&D2&!D1&D&C&!B1&B&!A1&!A|F&E&!D2&!D1&D&C&!B1&B&!A1&!A|F&E&!D2&!D1&D&C&!B1&B&A1&!A|F&E&D2&!D1&D&C&!B1&B&A1&!A|F&E&D2&D1&D&C&!B1&B&A1&!A|F&E&!D2&D1&D&C&!B1&B&A1&!A|F&E&!D2&D1&!D&C&!B1&B&A1&!A|F&E&D2&D1&!D&C&!B1&B&A1&!A|F&E&D2&!D1&!D&C&!B1&B&A1&!A|F&E&D2&!D1&!D&C&B1&B&A1&!A|F&E&D2&D1&!D&C&B1&B&A1&!A|F&E&!D2&D1&!D&C&B1&B&A1&!A|F&E&!D2&D1&D&C&B1&B&A1&!A|F&E&D2&D1&D&C&B1&B&A1&!A|F&E&D2&!D1&D&C&B1&B&A1&!A|F&E&!D2&!D1&D&C&B1&B&A1&!A|F&E&!D2&!D1&D&!C&B1&B&A1&!A|F&E&D2&!D1&D&!C&B1&B&A1&!A|F&E&D2&D1&D&!C&B1&B&A1&!A|F&E&!D2&D1&D&!C&B1&B&A1&!A|F&E&!D2&D1&!D&!C&B1&B&A1&!A|F&E&D2&D1&!D&!C&B1&B&A1&!A|F&E&D2&!D1&!D&!C&B1&B&A1&!A|F&E&!D2&!D1&D&C&B1&!B&A1&!A|F&E&D2&!D1&D&C&B1&!B&A1&!A|F&E&D2&D1&D&C&B1&!B&A1&!A|F&E&!D2&D1&D&C&B1&!B&A1&!A|F&E&!D2&D1&!D&C&B1&!B&A1&!A|F&E&D2&D1&!D&C&B1&!B&A1&!A|F&E&D2&!D1&!D&C&B1&!B&A1&!A|F&E&D2&!D1&!D&C&!B1&!B&A1&!A|F&E&D2&D1&!D&C&!B1&!B&A1&!A|F&E&!D2&D1&!D&C&!B1&!B&A1&!A|F&E&!D2&D1&D&C&!B1&!B&A1&!A|F&E&D2&D1&D&C&!B1&!B&A1&!A|F&E&D2&!D1&D&C&!B1&!B&A1&!A|F&E&!D2&!D1&D&C&!B1&!B&A1&!A|F&E&D2&!D1&!D&!C&!B1&!B&A1&A|F&E&D2&D1&!D&!C&!B1&!B&A1&A|F&E&!D2&D1&!D&!C&!B1&!B&A1&A|F&E&!D2&D1&D&!C&!B1&!B&A1&A|F&E&D2&D1&D&!C&!B1&!B&A1&A|F&E&D2&!D1&D&!C&!B1&!B&A1&A|F&E&!D2&!D1&D&!C&!B1&!B&A1&A|F&E&!D2&!D1&D&C&!B1&!B&A1&A|F&E&D2&!D1&D&C&!B1&!B&A1&A|F&E&D2&D1&D&C&!B1&!B&A1&A|F&E&!D2&D1&D&C&!B1&!B&A1&A|F&E&!D2&D1&!D&C&!B1&!B&A1&A|F&E&D2&D1&!D&C&!B1&!B&A1&A|F&E&D2&!D1&!D&C&!B1&!B&A1&A|F&E&D2&!D1&!D&C&B1&!B&A1&A|F&E&D2&D1&!D&C&B1&!B&A1&A|F&E&!D2&D1&!D&C&B1&!B&A1&A|F&E&!D2&D1&D&C&B1&!B&A1&A|F&E&D2&D1&D&C&B1&!B&A1&A|F&E&D2&!D1&D&C&B1&!B&A1&A|F&E&!D2&!D1&D&C&B1&!B&A1&A|F&E&!D2&!D1&D&!C&B1&!B&A1&A|F&E&D2&!D1&D&!C&B1&!B&A1&A|F&E&D2&D1&D&!C&B1&!B&A1&A|F&E&!D2&D1&D&!C&B1&!B&A1&A|F&E&!D2&D1&!D&!C&B1&!B&A1&A|F&E&D2&D1&!D&!C&B1&!B&A1&A|F&E&D2&!D1&!D&!C&B1&!B&A1&A|F&E&D2&!D1&!D&!C&B1&B&A1&A|F&E&D2&D1&!D&!C&B1&B&A1&A|F&E&!D2&D1&!D&!C&B1&B&A1&A|F&E&!D2&D1&D&!C&B1&B&A1&A|F&E&D2&D1&D&!C&B1&B&A1&A|F&E&D2&!D1&D&!C&B1&B&A1&A|F&E&!D2&!D1&D&!C&B1&B&A1&A|F&E&!D2&!D1&D&C&B1&B&A1&A|F&E&D2&!D1&D&C&B1&B&A1&A|F&E&D2&D1&D&C&B1&B&A1&A|F&E&!D2&D1&D&C&B1&B&A1&A|F&E&!D2&D1&!D&C&B1&B&A1&A|F&E&D2&D1&!D&C&B1&B&A1&A|F&E&D2&!D1&!D&C&B1&B&A1&A|F&E&D2&!D1&!D&C&!B1&B&A1&A|F&E&D2&D1&!D&C&!B1&B&A1&A|F&E&!D2&D1&!D&C&!B1&B&A1&A|F&E&!D2&D1&D&C&!B1&B&A1&A|F&E&D2&D1&D&C&!B1&B&A1&A|F&E&D2&!D1&D&C&!B1&B&A1&A|F&E&!D2&!D1&D&C&!B1&B&A1&A|F&E&!D2&!D1&D&!C&!B1&B&A1&A|F&E&D2&!D1&D&!C&!B1&B&A1&A|F&E&D2&D1&D&!C&!B1&B&A1&A|F&E&!D2&D1&D&!C&!B1&B&A1&A|F&E&!D2&D1&!D&!C&!B1&B&A1&A|F&E&D2&D1&!D&!C&!B1&B&A1&A|F&E&D2&!D1&!D&!C&!B1&B&A1&A|F&E&!D2&!D1&D&C&!B1&B&!A1&A|F&E&D2&!D1&D&C&!B1&B&!A1&A|F&E&D2&D1&D&C&!B1&B&!A1&A|F&E&!D2&D1&D&C&!B1&B&!A1&A|F&E&!D2&D1&!D&C&!B1&B&!A1&A|F&E&D2&D1&!D&C&!B1&B&!A1&A|F&E&D2&!D1&!D&C&!B1&B&!A1&A|F&E&D2&!D1&!D&C&B1&B&!A1&A|F&E&D2&D1&!D&C&B1&B&!A1&A|F&E&!D2&D1&!D&C&B1&B&!A1&A|F&E&!D2&D1&D&C&B1&B&!A1&A|F&E&D2&D1&D&C&B1&B&!A1&A|F&E&D2&!D1&D&C&B1&B&!A1&A|F&E&!D2&!D1&D&C&B1&B&!A1&A|F&E&!D2&!D1&D&!C&B1&B&!A1&A|F&E&D2&!D1&D&!C&B1&B&!A1&A|F&E&D2&D1&D&!C&B1&B&!A1&A|F&E&!D2&D1&D&!C&B1&B&!A1&A|F&E&!D2&D1&!D&!C&B1&B&!A1&A|F&E&D2&D1&!D&!C&B1&B&!A1&A|F&E&D2&!D1&!D&!C&B1&B&!A1&A|F&E&!D2&!D1&D&C&B1&!B&!A1&A|F&E&D2&!D1&D&C&B1&!B&!A1&A|F&E&D2&D1&D&C&B1&!B&!A1&A|F&E&!D2&D1&D&C&B1&!B&!A1&A|F&E&!D2&D1&!D&C&B1&!B&!A1&A|F&E&D2&D1&!D&C&B1&!B&!A1&A|F&E&D2&!D1&!D&C&B1&!B&!A1&A|F&E&D2&!D1&!D&C&!B1&!B&!A1&A|F&E&D2&D1&!D&C&!B1&!B&!A1&A|F&E&!D2&D1&!D&C&!B1&!B&!A1&A|F&E&!D2&D1&D&C&!B1&!B&!A1&A|F&E&D2&D1&D&C&!B1&!B&!A1&A|F&E&D2&!D1&D&C&!B1&!B&!A1&A|F&E&!D2&!D1&D&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOAI221311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAOAI33211 -l OOOAOAI33211 -i E D C1 C B2 B1 B A2 A1 A -o Y -f Y=!(E&D&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|E&D&C1&!C&!B2&!B1&!B&!A2&!A1&!A|E&D&C1&C&!B2&!B1&!B&!A2&!A1&!A|E&D&!C1&C&!B2&!B1&!B&!A2&!A1&!A|E&D&!C1&C&B2&!B1&!B&!A2&!A1&!A|E&D&C1&C&B2&!B1&!B&!A2&!A1&!A|E&D&C1&!C&B2&!B1&!B&!A2&!A1&!A|E&D&!C1&!C&B2&!B1&!B&!A2&!A1&!A|E&D&!C1&!C&B2&B1&!B&!A2&!A1&!A|E&D&C1&!C&B2&B1&!B&!A2&!A1&!A|E&D&C1&C&B2&B1&!B&!A2&!A1&!A|E&D&!C1&C&B2&B1&!B&!A2&!A1&!A|E&D&!C1&C&!B2&B1&!B&!A2&!A1&!A|E&D&C1&C&!B2&B1&!B&!A2&!A1&!A|E&D&C1&!C&!B2&B1&!B&!A2&!A1&!A|E&D&!C1&!C&!B2&B1&!B&!A2&!A1&!A|E&D&!C1&!C&!B2&B1&B&!A2&!A1&!A|E&D&C1&!C&!B2&B1&B&!A2&!A1&!A|E&D&C1&C&!B2&B1&B&!A2&!A1&!A|E&D&!C1&C&!B2&B1&B&!A2&!A1&!A|E&D&!C1&C&B2&B1&B&!A2&!A1&!A|E&D&C1&C&B2&B1&B&!A2&!A1&!A|E&D&C1&!C&B2&B1&B&!A2&!A1&!A|E&D&!C1&!C&B2&B1&B&!A2&!A1&!A|E&D&!C1&!C&B2&!B1&B&!A2&!A1&!A|E&D&C1&!C&B2&!B1&B&!A2&!A1&!A|E&D&C1&C&B2&!B1&B&!A2&!A1&!A|E&D&!C1&C&B2&!B1&B&!A2&!A1&!A|E&D&!C1&C&!B2&!B1&B&!A2&!A1&!A|E&D&C1&C&!B2&!B1&B&!A2&!A1&!A|E&D&C1&!C&!B2&!B1&B&!A2&!A1&!A|E&D&!C1&!C&!B2&!B1&B&!A2&!A1&!A|E&D&!C1&!C&!B2&!B1&B&A2&!A1&!A|E&D&C1&!C&!B2&!B1&B&A2&!A1&!A|E&!D&C1&!C&!B2&!B1&B&A2&!A1&!A|E&!D&C1&C&!B2&!B1&B&A2&!A1&!A|E&D&C1&C&!B2&!B1&B&A2&!A1&!A|E&D&!C1&C&!B2&!B1&B&A2&!A1&!A|E&!D&!C1&C&!B2&!B1&B&A2&!A1&!A|E&!D&!C1&C&B2&!B1&B&A2&!A1&!A|E&D&!C1&C&B2&!B1&B&A2&!A1&!A|E&D&C1&C&B2&!B1&B&A2&!A1&!A|E&!D&C1&C&B2&!B1&B&A2&!A1&!A|E&!D&C1&!C&B2&!B1&B&A2&!A1&!A|E&D&C1&!C&B2&!B1&B&A2&!A1&!A|E&D&!C1&!C&B2&!B1&B&A2&!A1&!A|E&D&!C1&!C&B2&B1&B&A2&!A1&!A|E&D&C1&!C&B2&B1&B&A2&!A1&!A|E&!D&C1&!C&B2&B1&B&A2&!A1&!A|E&!D&C1&C&B2&B1&B&A2&!A1&!A|E&D&C1&C&B2&B1&B&A2&!A1&!A|E&D&!C1&C&B2&B1&B&A2&!A1&!A|E&!D&!C1&C&B2&B1&B&A2&!A1&!A|E&!D&!C1&C&!B2&B1&B&A2&!A1&!A|E&D&!C1&C&!B2&B1&B&A2&!A1&!A|E&D&C1&C&!B2&B1&B&A2&!A1&!A|E&!D&C1&C&!B2&B1&B&A2&!A1&!A|E&!D&C1&!C&!B2&B1&B&A2&!A1&!A|E&D&C1&!C&!B2&B1&B&A2&!A1&!A|E&D&!C1&!C&!B2&B1&B&A2&!A1&!A|E&D&!C1&!C&!B2&B1&!B&A2&!A1&!A|E&D&C1&!C&!B2&B1&!B&A2&!A1&!A|E&!D&C1&!C&!B2&B1&!B&A2&!A1&!A|E&!D&C1&C&!B2&B1&!B&A2&!A1&!A|E&D&C1&C&!B2&B1&!B&A2&!A1&!A|E&D&!C1&C&!B2&B1&!B&A2&!A1&!A|E&!D&!C1&C&!B2&B1&!B&A2&!A1&!A|E&!D&!C1&C&B2&B1&!B&A2&!A1&!A|E&D&!C1&C&B2&B1&!B&A2&!A1&!A|E&D&C1&C&B2&B1&!B&A2&!A1&!A|E&!D&C1&C&B2&B1&!B&A2&!A1&!A|E&!D&C1&!C&B2&B1&!B&A2&!A1&!A|E&D&C1&!C&B2&B1&!B&A2&!A1&!A|E&D&!C1&!C&B2&B1&!B&A2&!A1&!A|E&D&!C1&!C&B2&!B1&!B&A2&!A1&!A|E&D&C1&!C&B2&!B1&!B&A2&!A1&!A|E&!D&C1&!C&B2&!B1&!B&A2&!A1&!A|E&!D&C1&C&B2&!B1&!B&A2&!A1&!A|E&D&C1&C&B2&!B1&!B&A2&!A1&!A|E&D&!C1&C&B2&!B1&!B&A2&!A1&!A|E&!D&!C1&C&B2&!B1&!B&A2&!A1&!A|E&D&!C1&C&!B2&!B1&!B&A2&!A1&!A|E&D&C1&C&!B2&!B1&!B&A2&!A1&!A|E&D&C1&!C&!B2&!B1&!B&A2&!A1&!A|E&D&!C1&!C&!B2&!B1&!B&A2&!A1&!A|E&D&!C1&!C&!B2&!B1&!B&A2&A1&!A|E&D&C1&!C&!B2&!B1&!B&A2&A1&!A|E&D&C1&C&!B2&!B1&!B&A2&A1&!A|E&D&!C1&C&!B2&!B1&!B&A2&A1&!A|E&!D&!C1&C&B2&!B1&!B&A2&A1&!A|E&D&!C1&C&B2&!B1&!B&A2&A1&!A|E&D&C1&C&B2&!B1&!B&A2&A1&!A|E&!D&C1&C&B2&!B1&!B&A2&A1&!A|E&!D&C1&!C&B2&!B1&!B&A2&A1&!A|E&D&C1&!C&B2&!B1&!B&A2&A1&!A|E&D&!C1&!C&B2&!B1&!B&A2&A1&!A|E&D&!C1&!C&B2&B1&!B&A2&A1&!A|E&D&C1&!C&B2&B1&!B&A2&A1&!A|E&!D&C1&!C&B2&B1&!B&A2&A1&!A|E&!D&C1&C&B2&B1&!B&A2&A1&!A|E&D&C1&C&B2&B1&!B&A2&A1&!A|E&D&!C1&C&B2&B1&!B&A2&A1&!A|E&!D&!C1&C&B2&B1&!B&A2&A1&!A|E&!D&!C1&C&!B2&B1&!B&A2&A1&!A|E&D&!C1&C&!B2&B1&!B&A2&A1&!A|E&D&C1&C&!B2&B1&!B&A2&A1&!A|E&!D&C1&C&!B2&B1&!B&A2&A1&!A|E&!D&C1&!C&!B2&B1&!B&A2&A1&!A|E&D&C1&!C&!B2&B1&!B&A2&A1&!A|E&D&!C1&!C&!B2&B1&!B&A2&A1&!A|E&D&!C1&!C&!B2&B1&B&A2&A1&!A|E&D&C1&!C&!B2&B1&B&A2&A1&!A|E&!D&C1&!C&!B2&B1&B&A2&A1&!A|E&!D&C1&C&!B2&B1&B&A2&A1&!A|E&D&C1&C&!B2&B1&B&A2&A1&!A|E&D&!C1&C&!B2&B1&B&A2&A1&!A|E&!D&!C1&C&!B2&B1&B&A2&A1&!A|E&!D&!C1&C&B2&B1&B&A2&A1&!A|E&D&!C1&C&B2&B1&B&A2&A1&!A|E&D&C1&C&B2&B1&B&A2&A1&!A|E&!D&C1&C&B2&B1&B&A2&A1&!A|E&!D&C1&!C&B2&B1&B&A2&A1&!A|E&D&C1&!C&B2&B1&B&A2&A1&!A|E&D&!C1&!C&B2&B1&B&A2&A1&!A|E&D&!C1&!C&B2&!B1&B&A2&A1&!A|E&D&C1&!C&B2&!B1&B&A2&A1&!A|E&!D&C1&!C&B2&!B1&B&A2&A1&!A|E&!D&C1&C&B2&!B1&B&A2&A1&!A|E&D&C1&C&B2&!B1&B&A2&A1&!A|E&D&!C1&C&B2&!B1&B&A2&A1&!A|E&!D&!C1&C&B2&!B1&B&A2&A1&!A|E&!D&!C1&C&!B2&!B1&B&A2&A1&!A|E&D&!C1&C&!B2&!B1&B&A2&A1&!A|E&D&C1&C&!B2&!B1&B&A2&A1&!A|E&!D&C1&C&!B2&!B1&B&A2&A1&!A|E&!D&C1&!C&!B2&!B1&B&A2&A1&!A|E&D&C1&!C&!B2&!B1&B&A2&A1&!A|E&D&!C1&!C&!B2&!B1&B&A2&A1&!A|E&D&!C1&!C&!B2&!B1&B&!A2&A1&!A|E&D&C1&!C&!B2&!B1&B&!A2&A1&!A|E&!D&C1&!C&!B2&!B1&B&!A2&A1&!A|E&!D&C1&C&!B2&!B1&B&!A2&A1&!A|E&D&C1&C&!B2&!B1&B&!A2&A1&!A|E&D&!C1&C&!B2&!B1&B&!A2&A1&!A|E&!D&!C1&C&!B2&!B1&B&!A2&A1&!A|E&!D&!C1&C&B2&!B1&B&!A2&A1&!A|E&D&!C1&C&B2&!B1&B&!A2&A1&!A|E&D&C1&C&B2&!B1&B&!A2&A1&!A|E&!D&C1&C&B2&!B1&B&!A2&A1&!A|E&!D&C1&!C&B2&!B1&B&!A2&A1&!A|E&D&C1&!C&B2&!B1&B&!A2&A1&!A|E&D&!C1&!C&B2&!B1&B&!A2&A1&!A|E&D&!C1&!C&B2&B1&B&!A2&A1&!A|E&D&C1&!C&B2&B1&B&!A2&A1&!A|E&!D&C1&!C&B2&B1&B&!A2&A1&!A|E&!D&C1&C&B2&B1&B&!A2&A1&!A|E&D&C1&C&B2&B1&B&!A2&A1&!A|E&D&!C1&C&B2&B1&B&!A2&A1&!A|E&!D&!C1&C&B2&B1&B&!A2&A1&!A|E&!D&!C1&C&!B2&B1&B&!A2&A1&!A|E&D&!C1&C&!B2&B1&B&!A2&A1&!A|E&D&C1&C&!B2&B1&B&!A2&A1&!A|E&!D&C1&C&!B2&B1&B&!A2&A1&!A|E&!D&C1&!C&!B2&B1&B&!A2&A1&!A|E&D&C1&!C&!B2&B1&B&!A2&A1&!A|E&D&!C1&!C&!B2&B1&B&!A2&A1&!A|E&D&!C1&!C&!B2&B1&!B&!A2&A1&!A|E&D&C1&!C&!B2&B1&!B&!A2&A1&!A|E&!D&C1&!C&!B2&B1&!B&!A2&A1&!A|E&!D&C1&C&!B2&B1&!B&!A2&A1&!A|E&D&C1&C&!B2&B1&!B&!A2&A1&!A|E&D&!C1&C&!B2&B1&!B&!A2&A1&!A|E&!D&!C1&C&!B2&B1&!B&!A2&A1&!A|E&!D&!C1&C&B2&B1&!B&!A2&A1&!A|E&D&!C1&C&B2&B1&!B&!A2&A1&!A|E&D&C1&C&B2&B1&!B&!A2&A1&!A|E&!D&C1&C&B2&B1&!B&!A2&A1&!A|E&!D&C1&!C&B2&B1&!B&!A2&A1&!A|E&D&C1&!C&B2&B1&!B&!A2&A1&!A|E&D&!C1&!C&B2&B1&!B&!A2&A1&!A|E&D&!C1&!C&B2&!B1&!B&!A2&A1&!A|E&D&C1&!C&B2&!B1&!B&!A2&A1&!A|E&!D&C1&!C&B2&!B1&!B&!A2&A1&!A|E&!D&C1&C&B2&!B1&!B&!A2&A1&!A|E&D&C1&C&B2&!B1&!B&!A2&A1&!A|E&D&!C1&C&B2&!B1&!B&!A2&A1&!A|E&!D&!C1&C&B2&!B1&!B&!A2&A1&!A|E&D&!C1&C&!B2&!B1&!B&!A2&A1&!A|E&D&C1&C&!B2&!B1&!B&!A2&A1&!A|E&D&C1&!C&!B2&!B1&!B&!A2&A1&!A|E&D&!C1&!C&!B2&!B1&!B&!A2&A1&!A|E&D&!C1&!C&!B2&!B1&!B&!A2&A1&A|E&D&C1&!C&!B2&!B1&!B&!A2&A1&A|E&D&C1&C&!B2&!B1&!B&!A2&A1&A|E&D&!C1&C&!B2&!B1&!B&!A2&A1&A|E&!D&!C1&C&B2&!B1&!B&!A2&A1&A|E&D&!C1&C&B2&!B1&!B&!A2&A1&A|E&D&C1&C&B2&!B1&!B&!A2&A1&A|E&!D&C1&C&B2&!B1&!B&!A2&A1&A|E&!D&C1&!C&B2&!B1&!B&!A2&A1&A|E&D&C1&!C&B2&!B1&!B&!A2&A1&A|E&D&!C1&!C&B2&!B1&!B&!A2&A1&A|E&D&!C1&!C&B2&B1&!B&!A2&A1&A|E&D&C1&!C&B2&B1&!B&!A2&A1&A|E&!D&C1&!C&B2&B1&!B&!A2&A1&A|E&!D&C1&C&B2&B1&!B&!A2&A1&A|E&D&C1&C&B2&B1&!B&!A2&A1&A|E&D&!C1&C&B2&B1&!B&!A2&A1&A|E&!D&!C1&C&B2&B1&!B&!A2&A1&A|E&!D&!C1&C&!B2&B1&!B&!A2&A1&A|E&D&!C1&C&!B2&B1&!B&!A2&A1&A|E&D&C1&C&!B2&B1&!B&!A2&A1&A|E&!D&C1&C&!B2&B1&!B&!A2&A1&A|E&!D&C1&!C&!B2&B1&!B&!A2&A1&A|E&D&C1&!C&!B2&B1&!B&!A2&A1&A|E&D&!C1&!C&!B2&B1&!B&!A2&A1&A|E&D&!C1&!C&!B2&B1&B&!A2&A1&A|E&D&C1&!C&!B2&B1&B&!A2&A1&A|E&!D&C1&!C&!B2&B1&B&!A2&A1&A|E&!D&C1&C&!B2&B1&B&!A2&A1&A|E&D&C1&C&!B2&B1&B&!A2&A1&A|E&D&!C1&C&!B2&B1&B&!A2&A1&A|E&!D&!C1&C&!B2&B1&B&!A2&A1&A|E&!D&!C1&C&B2&B1&B&!A2&A1&A|E&D&!C1&C&B2&B1&B&!A2&A1&A|E&D&C1&C&B2&B1&B&!A2&A1&A|E&!D&C1&C&B2&B1&B&!A2&A1&A|E&!D&C1&!C&B2&B1&B&!A2&A1&A|E&D&C1&!C&B2&B1&B&!A2&A1&A|E&D&!C1&!C&B2&B1&B&!A2&A1&A|E&D&!C1&!C&B2&!B1&B&!A2&A1&A|E&D&C1&!C&B2&!B1&B&!A2&A1&A|E&!D&C1&!C&B2&!B1&B&!A2&A1&A|E&!D&C1&C&B2&!B1&B&!A2&A1&A|E&D&C1&C&B2&!B1&B&!A2&A1&A|E&D&!C1&C&B2&!B1&B&!A2&A1&A|E&!D&!C1&C&B2&!B1&B&!A2&A1&A|E&!D&!C1&C&!B2&!B1&B&!A2&A1&A|E&D&!C1&C&!B2&!B1&B&!A2&A1&A|E&D&C1&C&!B2&!B1&B&!A2&A1&A|E&!D&C1&C&!B2&!B1&B&!A2&A1&A|E&!D&C1&!C&!B2&!B1&B&!A2&A1&A|E&D&C1&!C&!B2&!B1&B&!A2&A1&A|E&D&!C1&!C&!B2&!B1&B&!A2&A1&A|E&D&!C1&!C&!B2&!B1&B&A2&A1&A|E&D&C1&!C&!B2&!B1&B&A2&A1&A|E&!D&C1&!C&!B2&!B1&B&A2&A1&A|E&!D&C1&C&!B2&!B1&B&A2&A1&A|E&D&C1&C&!B2&!B1&B&A2&A1&A|E&D&!C1&C&!B2&!B1&B&A2&A1&A|E&!D&!C1&C&!B2&!B1&B&A2&A1&A|E&!D&!C1&C&B2&!B1&B&A2&A1&A|E&D&!C1&C&B2&!B1&B&A2&A1&A|E&D&C1&C&B2&!B1&B&A2&A1&A|E&!D&C1&C&B2&!B1&B&A2&A1&A|E&!D&C1&!C&B2&!B1&B&A2&A1&A|E&D&C1&!C&B2&!B1&B&A2&A1&A|E&D&!C1&!C&B2&!B1&B&A2&A1&A|E&D&!C1&!C&B2&B1&B&A2&A1&A|E&D&C1&!C&B2&B1&B&A2&A1&A|E&!D&C1&!C&B2&B1&B&A2&A1&A|E&!D&C1&C&B2&B1&B&A2&A1&A|E&D&C1&C&B2&B1&B&A2&A1&A|E&D&!C1&C&B2&B1&B&A2&A1&A|E&!D&!C1&C&B2&B1&B&A2&A1&A|E&!D&!C1&C&!B2&B1&B&A2&A1&A|E&D&!C1&C&!B2&B1&B&A2&A1&A|E&D&C1&C&!B2&B1&B&A2&A1&A|E&!D&C1&C&!B2&B1&B&A2&A1&A|E&!D&C1&!C&!B2&B1&B&A2&A1&A|E&D&C1&!C&!B2&B1&B&A2&A1&A|E&D&!C1&!C&!B2&B1&B&A2&A1&A|E&D&!C1&!C&!B2&B1&!B&A2&A1&A|E&D&C1&!C&!B2&B1&!B&A2&A1&A|E&!D&C1&!C&!B2&B1&!B&A2&A1&A|E&!D&C1&C&!B2&B1&!B&A2&A1&A|E&D&C1&C&!B2&B1&!B&A2&A1&A|E&D&!C1&C&!B2&B1&!B&A2&A1&A|E&!D&!C1&C&!B2&B1&!B&A2&A1&A|E&!D&!C1&C&B2&B1&!B&A2&A1&A|E&D&!C1&C&B2&B1&!B&A2&A1&A|E&D&C1&C&B2&B1&!B&A2&A1&A|E&!D&C1&C&B2&B1&!B&A2&A1&A|E&!D&C1&!C&B2&B1&!B&A2&A1&A|E&D&C1&!C&B2&B1&!B&A2&A1&A|E&D&!C1&!C&B2&B1&!B&A2&A1&A|E&D&!C1&!C&B2&!B1&!B&A2&A1&A|E&D&C1&!C&B2&!B1&!B&A2&A1&A|E&!D&C1&!C&B2&!B1&!B&A2&A1&A|E&!D&C1&C&B2&!B1&!B&A2&A1&A|E&D&C1&C&B2&!B1&!B&A2&A1&A|E&D&!C1&C&B2&!B1&!B&A2&A1&A|E&!D&!C1&C&B2&!B1&!B&A2&A1&A|E&D&!C1&C&!B2&!B1&!B&A2&A1&A|E&D&C1&C&!B2&!B1&!B&A2&A1&A|E&D&C1&!C&!B2&!B1&!B&A2&A1&A|E&D&!C1&!C&!B2&!B1&!B&A2&A1&A|E&D&!C1&!C&!B2&!B1&!B&A2&!A1&A|E&D&C1&!C&!B2&!B1&!B&A2&!A1&A|E&D&C1&C&!B2&!B1&!B&A2&!A1&A|E&D&!C1&C&!B2&!B1&!B&A2&!A1&A|E&!D&!C1&C&B2&!B1&!B&A2&!A1&A|E&D&!C1&C&B2&!B1&!B&A2&!A1&A|E&D&C1&C&B2&!B1&!B&A2&!A1&A|E&!D&C1&C&B2&!B1&!B&A2&!A1&A|E&!D&C1&!C&B2&!B1&!B&A2&!A1&A|E&D&C1&!C&B2&!B1&!B&A2&!A1&A|E&D&!C1&!C&B2&!B1&!B&A2&!A1&A|E&D&!C1&!C&B2&B1&!B&A2&!A1&A|E&D&C1&!C&B2&B1&!B&A2&!A1&A|E&!D&C1&!C&B2&B1&!B&A2&!A1&A|E&!D&C1&C&B2&B1&!B&A2&!A1&A|E&D&C1&C&B2&B1&!B&A2&!A1&A|E&D&!C1&C&B2&B1&!B&A2&!A1&A|E&!D&!C1&C&B2&B1&!B&A2&!A1&A|E&!D&!C1&C&!B2&B1&!B&A2&!A1&A|E&D&!C1&C&!B2&B1&!B&A2&!A1&A|E&D&C1&C&!B2&B1&!B&A2&!A1&A|E&!D&C1&C&!B2&B1&!B&A2&!A1&A|E&!D&C1&!C&!B2&B1&!B&A2&!A1&A|E&D&C1&!C&!B2&B1&!B&A2&!A1&A|E&D&!C1&!C&!B2&B1&!B&A2&!A1&A|E&D&!C1&!C&!B2&B1&B&A2&!A1&A|E&D&C1&!C&!B2&B1&B&A2&!A1&A|E&!D&C1&!C&!B2&B1&B&A2&!A1&A|E&!D&C1&C&!B2&B1&B&A2&!A1&A|E&D&C1&C&!B2&B1&B&A2&!A1&A|E&D&!C1&C&!B2&B1&B&A2&!A1&A|E&!D&!C1&C&!B2&B1&B&A2&!A1&A|E&!D&!C1&C&B2&B1&B&A2&!A1&A|E&D&!C1&C&B2&B1&B&A2&!A1&A|E&D&C1&C&B2&B1&B&A2&!A1&A|E&!D&C1&C&B2&B1&B&A2&!A1&A|E&!D&C1&!C&B2&B1&B&A2&!A1&A|E&D&C1&!C&B2&B1&B&A2&!A1&A|E&D&!C1&!C&B2&B1&B&A2&!A1&A|E&D&!C1&!C&B2&!B1&B&A2&!A1&A|E&D&C1&!C&B2&!B1&B&A2&!A1&A|E&!D&C1&!C&B2&!B1&B&A2&!A1&A|E&!D&C1&C&B2&!B1&B&A2&!A1&A|E&D&C1&C&B2&!B1&B&A2&!A1&A|E&D&!C1&C&B2&!B1&B&A2&!A1&A|E&!D&!C1&C&B2&!B1&B&A2&!A1&A|E&!D&!C1&C&!B2&!B1&B&A2&!A1&A|E&D&!C1&C&!B2&!B1&B&A2&!A1&A|E&D&C1&C&!B2&!B1&B&A2&!A1&A|E&!D&C1&C&!B2&!B1&B&A2&!A1&A|E&!D&C1&!C&!B2&!B1&B&A2&!A1&A|E&D&C1&!C&!B2&!B1&B&A2&!A1&A|E&D&!C1&!C&!B2&!B1&B&A2&!A1&A|E&D&!C1&!C&!B2&!B1&B&!A2&!A1&A|E&D&C1&!C&!B2&!B1&B&!A2&!A1&A|E&!D&C1&!C&!B2&!B1&B&!A2&!A1&A|E&!D&C1&C&!B2&!B1&B&!A2&!A1&A|E&D&C1&C&!B2&!B1&B&!A2&!A1&A|E&D&!C1&C&!B2&!B1&B&!A2&!A1&A|E&!D&!C1&C&!B2&!B1&B&!A2&!A1&A|E&!D&!C1&C&B2&!B1&B&!A2&!A1&A|E&D&!C1&C&B2&!B1&B&!A2&!A1&A|E&D&C1&C&B2&!B1&B&!A2&!A1&A|E&!D&C1&C&B2&!B1&B&!A2&!A1&A|E&!D&C1&!C&B2&!B1&B&!A2&!A1&A|E&D&C1&!C&B2&!B1&B&!A2&!A1&A|E&D&!C1&!C&B2&!B1&B&!A2&!A1&A|E&D&!C1&!C&B2&B1&B&!A2&!A1&A|E&D&C1&!C&B2&B1&B&!A2&!A1&A|E&!D&C1&!C&B2&B1&B&!A2&!A1&A|E&!D&C1&C&B2&B1&B&!A2&!A1&A|E&D&C1&C&B2&B1&B&!A2&!A1&A|E&D&!C1&C&B2&B1&B&!A2&!A1&A|E&!D&!C1&C&B2&B1&B&!A2&!A1&A|E&!D&!C1&C&!B2&B1&B&!A2&!A1&A|E&D&!C1&C&!B2&B1&B&!A2&!A1&A|E&D&C1&C&!B2&B1&B&!A2&!A1&A|E&!D&C1&C&!B2&B1&B&!A2&!A1&A|E&!D&C1&!C&!B2&B1&B&!A2&!A1&A|E&D&C1&!C&!B2&B1&B&!A2&!A1&A|E&D&!C1&!C&!B2&B1&B&!A2&!A1&A|E&D&!C1&!C&!B2&B1&!B&!A2&!A1&A|E&D&C1&!C&!B2&B1&!B&!A2&!A1&A|E&!D&C1&!C&!B2&B1&!B&!A2&!A1&A|E&!D&C1&C&!B2&B1&!B&!A2&!A1&A|E&D&C1&C&!B2&B1&!B&!A2&!A1&A|E&D&!C1&C&!B2&B1&!B&!A2&!A1&A|E&!D&!C1&C&!B2&B1&!B&!A2&!A1&A|E&!D&!C1&C&B2&B1&!B&!A2&!A1&A|E&D&!C1&C&B2&B1&!B&!A2&!A1&A|E&D&C1&C&B2&B1&!B&!A2&!A1&A|E&!D&C1&C&B2&B1&!B&!A2&!A1&A|E&!D&C1&!C&B2&B1&!B&!A2&!A1&A|E&D&C1&!C&B2&B1&!B&!A2&!A1&A|E&D&!C1&!C&B2&B1&!B&!A2&!A1&A|E&D&!C1&!C&B2&!B1&!B&!A2&!A1&A|E&D&C1&!C&B2&!B1&!B&!A2&!A1&A|E&!D&C1&!C&B2&!B1&!B&!A2&!A1&A|E&!D&C1&C&B2&!B1&!B&!A2&!A1&A|E&D&C1&C&B2&!B1&!B&!A2&!A1&A|E&D&!C1&C&B2&!B1&!B&!A2&!A1&A|E&!D&!C1&C&B2&!B1&!B&!A2&!A1&A|E&D&!C1&C&!B2&!B1&!B&!A2&!A1&A|E&D&C1&C&!B2&!B1&!B&!A2&!A1&A|E&D&C1&!C&!B2&!B1&!B&!A2&!A1&A|E&D&!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAOAI33211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOAOI22111 -l OAOAOI22111 -i E D C B1 B A1 A -o Y -f Y=(!E&!D&!C&!B1&!B&!A1&!A|!E&D&!C&!B1&!B&!A1&!A|!E&!D&C&!B1&!B&!A1&!A|!E&!D&C&B1&!B&!A1&!A|!E&D&!C&B1&!B&!A1&!A|!E&!D&!C&B1&!B&!A1&!A|!E&!D&!C&B1&B&!A1&!A|!E&D&!C&B1&B&!A1&!A|!E&!D&C&B1&B&!A1&!A|!E&!D&C&!B1&B&!A1&!A|!E&D&!C&!B1&B&!A1&!A|!E&!D&!C&!B1&B&!A1&!A|!E&!D&!C&!B1&B&A1&!A|!E&D&!C&!B1&B&A1&!A|!E&!D&C&!B1&B&A1&!A|!E&!D&C&B1&B&A1&!A|!E&!D&!C&B1&B&A1&!A|!E&!D&!C&B1&!B&A1&!A|!E&D&!C&B1&!B&A1&!A|!E&!D&C&B1&!B&A1&!A|!E&!D&C&!B1&!B&A1&!A|!E&D&!C&!B1&!B&A1&!A|!E&!D&!C&!B1&!B&A1&!A|!E&!D&!C&!B1&!B&A1&A|!E&D&!C&!B1&!B&A1&A|!E&!D&C&!B1&!B&A1&A|!E&!D&C&B1&!B&A1&A|!E&D&!C&B1&!B&A1&A|!E&!D&!C&B1&!B&A1&A|!E&!D&!C&B1&B&A1&A|!E&!D&C&B1&B&A1&A|!E&!D&C&!B1&B&A1&A|!E&D&!C&!B1&B&A1&A|!E&!D&!C&!B1&B&A1&A|!E&!D&!C&!B1&B&!A1&A|!E&D&!C&!B1&B&!A1&A|!E&!D&C&!B1&B&!A1&A|!E&!D&C&B1&B&!A1&A|!E&!D&!C&B1&B&!A1&A|!E&!D&!C&B1&!B&!A1&A|!E&D&!C&B1&!B&!A1&A|!E&!D&C&B1&!B&!A1&A|!E&!D&C&!B1&!B&!A1&A|!E&D&!C&!B1&!B&!A1&A|!E&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOAOI22111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAAOAI222311 -l AAOOAAOAI222311 -i F E D2 D1 D C1 C B1 B A1 A -o Y -f Y=!(F&E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|F&E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|F&E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|F&E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|F&E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|F&!E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|F&E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|F&!E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|F&E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|F&E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|F&E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|F&E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|F&E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|F&E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|F&E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|F&E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|F&E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|F&E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|F&E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|F&E&D2&D1&D&C1&C&!B1&!B&!A1&!A|F&!E&D2&D1&D&C1&C&!B1&!B&!A1&!A|F&E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|F&E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|F&E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|F&E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|F&!E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|F&E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|F&E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|F&E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|F&E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|F&E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|F&E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|F&E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|F&E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|F&E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|F&E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|F&E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|F&E&D2&D1&D&!C1&C&B1&!B&!A1&!A|F&!E&D2&D1&D&!C1&C&B1&!B&!A1&!A|F&E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|F&E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|F&E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|F&E&D2&!D1&D&C1&C&B1&!B&!A1&!A|F&!E&D2&D1&D&C1&C&B1&!B&!A1&!A|F&E&D2&D1&D&C1&C&B1&!B&!A1&!A|F&E&!D2&D1&D&C1&C&B1&!B&!A1&!A|F&E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|F&E&D2&D1&!D&C1&C&B1&!B&!A1&!A|F&E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|F&E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|F&E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|F&E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|F&E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|F&E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|F&E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|F&E&D2&D1&D&C1&!C&B1&!B&!A1&!A|F&!E&D2&D1&D&C1&!C&B1&!B&!A1&!A|F&E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|F&E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|F&E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|F&E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|F&!E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|F&E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|F&E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|F&E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|F&E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|F&E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|F&E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|F&E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|F&E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|F&E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|F&E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|F&E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|F&E&D2&D1&D&!C1&!C&B1&B&!A1&!A|F&!E&D2&D1&D&!C1&!C&B1&B&!A1&!A|F&E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|F&E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|F&!E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|F&E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|F&E&D2&!D1&D&C1&!C&B1&B&!A1&!A|F&!E&D2&!D1&D&C1&!C&B1&B&!A1&!A|F&!E&D2&D1&D&C1&!C&B1&B&!A1&!A|F&E&D2&D1&D&C1&!C&B1&B&!A1&!A|F&E&!D2&D1&D&C1&!C&B1&B&!A1&!A|F&!E&!D2&D1&D&C1&!C&B1&B&!A1&!A|F&!E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|F&E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|F&E&D2&D1&!D&C1&!C&B1&B&!A1&!A|F&!E&D2&D1&!D&C1&!C&B1&B&!A1&!A|F&!E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|F&E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|F&E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|F&!E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|F&!E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|F&E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|F&E&D2&!D1&!D&C1&C&B1&B&!A1&!A|F&!E&D2&!D1&!D&C1&C&B1&B&!A1&!A|F&!E&D2&D1&!D&C1&C&B1&B&!A1&!A|F&E&D2&D1&!D&C1&C&B1&B&!A1&!A|F&E&!D2&D1&!D&C1&C&B1&B&!A1&!A|F&!E&!D2&D1&!D&C1&C&B1&B&!A1&!A|F&!E&!D2&D1&D&C1&C&B1&B&!A1&!A|F&E&!D2&D1&D&C1&C&B1&B&!A1&!A|F&E&D2&D1&D&C1&C&B1&B&!A1&!A|F&!E&D2&D1&D&C1&C&B1&B&!A1&!A|F&!E&D2&!D1&D&C1&C&B1&B&!A1&!A|F&E&D2&!D1&D&C1&C&B1&B&!A1&!A|F&E&!D2&!D1&D&C1&C&B1&B&!A1&!A|F&!E&!D2&!D1&D&C1&C&B1&B&!A1&!A|F&!E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|F&E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|F&E&D2&!D1&D&!C1&C&B1&B&!A1&!A|F&!E&D2&!D1&D&!C1&C&B1&B&!A1&!A|F&!E&D2&D1&D&!C1&C&B1&B&!A1&!A|F&E&D2&D1&D&!C1&C&B1&B&!A1&!A|F&E&!D2&D1&D&!C1&C&B1&B&!A1&!A|F&!E&!D2&D1&D&!C1&C&B1&B&!A1&!A|F&!E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|F&E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|F&E&D2&D1&!D&!C1&C&B1&B&!A1&!A|F&!E&D2&D1&!D&!C1&C&B1&B&!A1&!A|F&!E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|F&E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|F&E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|F&!E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|F&E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|F&E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|F&E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|F&E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|F&E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|F&E&D2&D1&D&!C1&C&!B1&B&!A1&!A|F&!E&D2&D1&D&!C1&C&!B1&B&!A1&!A|F&E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|F&E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|F&E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|F&E&D2&!D1&D&C1&C&!B1&B&!A1&!A|F&!E&D2&D1&D&C1&C&!B1&B&!A1&!A|F&E&D2&D1&D&C1&C&!B1&B&!A1&!A|F&E&!D2&D1&D&C1&C&!B1&B&!A1&!A|F&E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|F&E&D2&D1&!D&C1&C&!B1&B&!A1&!A|F&E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|F&E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|F&E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|F&E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|F&E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|F&E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|F&E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|F&E&D2&D1&D&C1&!C&!B1&B&!A1&!A|F&!E&D2&D1&D&C1&!C&!B1&B&!A1&!A|F&E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|F&E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|F&E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|F&E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|F&!E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|F&E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|F&E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|F&E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|F&E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|F&E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|F&E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|F&E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|F&E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|F&E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|F&E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|F&E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|F&E&D2&D1&D&!C1&!C&!B1&B&A1&!A|F&!E&D2&D1&D&!C1&!C&!B1&B&A1&!A|F&E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|F&E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|F&E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|F&E&D2&!D1&D&C1&!C&!B1&B&A1&!A|F&!E&D2&D1&D&C1&!C&!B1&B&A1&!A|F&E&D2&D1&D&C1&!C&!B1&B&A1&!A|F&E&!D2&D1&D&C1&!C&!B1&B&A1&!A|F&E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|F&E&D2&D1&!D&C1&!C&!B1&B&A1&!A|F&E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|F&E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|F&E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|F&E&D2&!D1&!D&C1&C&!B1&B&A1&!A|F&E&D2&D1&!D&C1&C&!B1&B&A1&!A|F&E&!D2&D1&!D&C1&C&!B1&B&A1&!A|F&E&!D2&D1&D&C1&C&!B1&B&A1&!A|F&E&D2&D1&D&C1&C&!B1&B&A1&!A|F&!E&D2&D1&D&C1&C&!B1&B&A1&!A|F&E&D2&!D1&D&C1&C&!B1&B&A1&!A|F&E&!D2&!D1&D&C1&C&!B1&B&A1&!A|F&E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|F&E&D2&!D1&D&!C1&C&!B1&B&A1&!A|F&!E&D2&D1&D&!C1&C&!B1&B&A1&!A|F&E&D2&D1&D&!C1&C&!B1&B&A1&!A|F&E&!D2&D1&D&!C1&C&!B1&B&A1&!A|F&E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|F&E&D2&D1&!D&!C1&C&!B1&B&A1&!A|F&E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|F&E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|F&!E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|F&E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|F&E&D2&!D1&!D&!C1&C&B1&B&A1&!A|F&!E&D2&!D1&!D&!C1&C&B1&B&A1&!A|F&!E&D2&D1&!D&!C1&C&B1&B&A1&!A|F&E&D2&D1&!D&!C1&C&B1&B&A1&!A|F&E&!D2&D1&!D&!C1&C&B1&B&A1&!A|F&!E&!D2&D1&!D&!C1&C&B1&B&A1&!A|F&!E&!D2&D1&D&!C1&C&B1&B&A1&!A|F&E&!D2&D1&D&!C1&C&B1&B&A1&!A|F&E&D2&D1&D&!C1&C&B1&B&A1&!A|F&!E&D2&D1&D&!C1&C&B1&B&A1&!A|F&!E&D2&!D1&D&!C1&C&B1&B&A1&!A|F&E&D2&!D1&D&!C1&C&B1&B&A1&!A|F&E&!D2&!D1&D&!C1&C&B1&B&A1&!A|F&!E&!D2&!D1&D&!C1&C&B1&B&A1&!A|F&!E&!D2&!D1&D&C1&C&B1&B&A1&!A|F&E&!D2&!D1&D&C1&C&B1&B&A1&!A|F&E&D2&!D1&D&C1&C&B1&B&A1&!A|F&!E&D2&!D1&D&C1&C&B1&B&A1&!A|F&!E&D2&D1&D&C1&C&B1&B&A1&!A|F&E&D2&D1&D&C1&C&B1&B&A1&!A|F&E&!D2&D1&D&C1&C&B1&B&A1&!A|F&!E&!D2&D1&D&C1&C&B1&B&A1&!A|F&!E&!D2&D1&!D&C1&C&B1&B&A1&!A|F&E&!D2&D1&!D&C1&C&B1&B&A1&!A|F&E&D2&D1&!D&C1&C&B1&B&A1&!A|F&!E&D2&D1&!D&C1&C&B1&B&A1&!A|F&!E&D2&!D1&!D&C1&C&B1&B&A1&!A|F&E&D2&!D1&!D&C1&C&B1&B&A1&!A|F&E&!D2&!D1&!D&C1&C&B1&B&A1&!A|F&!E&!D2&!D1&!D&C1&C&B1&B&A1&!A|F&!E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|F&E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|F&E&D2&!D1&!D&C1&!C&B1&B&A1&!A|F&!E&D2&!D1&!D&C1&!C&B1&B&A1&!A|F&!E&D2&D1&!D&C1&!C&B1&B&A1&!A|F&E&D2&D1&!D&C1&!C&B1&B&A1&!A|F&E&!D2&D1&!D&C1&!C&B1&B&A1&!A|F&!E&!D2&D1&!D&C1&!C&B1&B&A1&!A|F&!E&!D2&D1&D&C1&!C&B1&B&A1&!A|F&E&!D2&D1&D&C1&!C&B1&B&A1&!A|F&E&D2&D1&D&C1&!C&B1&B&A1&!A|F&!E&D2&D1&D&C1&!C&B1&B&A1&!A|F&!E&D2&!D1&D&C1&!C&B1&B&A1&!A|F&E&D2&!D1&D&C1&!C&B1&B&A1&!A|F&E&!D2&!D1&D&C1&!C&B1&B&A1&!A|F&!E&!D2&!D1&D&C1&!C&B1&B&A1&!A|F&E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|F&E&D2&!D1&D&!C1&!C&B1&B&A1&!A|F&!E&D2&D1&D&!C1&!C&B1&B&A1&!A|F&E&D2&D1&D&!C1&!C&B1&B&A1&!A|F&E&!D2&D1&D&!C1&!C&B1&B&A1&!A|F&E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|F&E&D2&D1&!D&!C1&!C&B1&B&A1&!A|F&E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|F&E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|F&E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|F&E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|F&E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|F&E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|F&E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|F&E&D2&D1&D&!C1&!C&B1&!B&A1&!A|F&!E&D2&D1&D&!C1&!C&B1&!B&A1&!A|F&E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|F&E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|F&E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|F&E&D2&!D1&D&C1&!C&B1&!B&A1&!A|F&!E&D2&D1&D&C1&!C&B1&!B&A1&!A|F&E&D2&D1&D&C1&!C&B1&!B&A1&!A|F&E&!D2&D1&D&C1&!C&B1&!B&A1&!A|F&E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|F&E&D2&D1&!D&C1&!C&B1&!B&A1&!A|F&E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|F&E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|F&E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|F&E&D2&!D1&!D&C1&C&B1&!B&A1&!A|F&E&D2&D1&!D&C1&C&B1&!B&A1&!A|F&E&!D2&D1&!D&C1&C&B1&!B&A1&!A|F&E&!D2&D1&D&C1&C&B1&!B&A1&!A|F&E&D2&D1&D&C1&C&B1&!B&A1&!A|F&!E&D2&D1&D&C1&C&B1&!B&A1&!A|F&E&D2&!D1&D&C1&C&B1&!B&A1&!A|F&E&!D2&!D1&D&C1&C&B1&!B&A1&!A|F&E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|F&E&D2&!D1&D&!C1&C&B1&!B&A1&!A|F&!E&D2&D1&D&!C1&C&B1&!B&A1&!A|F&E&D2&D1&D&!C1&C&B1&!B&A1&!A|F&E&!D2&D1&D&!C1&C&B1&!B&A1&!A|F&E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|F&E&D2&D1&!D&!C1&C&B1&!B&A1&!A|F&E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|F&E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|F&E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|F&E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|F&E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|F&E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|F&E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|F&E&D2&D1&D&!C1&C&!B1&!B&A1&!A|F&!E&D2&D1&D&!C1&C&!B1&!B&A1&!A|F&E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|F&E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|F&E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|F&E&D2&!D1&D&C1&C&!B1&!B&A1&!A|F&!E&D2&D1&D&C1&C&!B1&!B&A1&!A|F&E&D2&D1&D&C1&C&!B1&!B&A1&!A|F&E&!D2&D1&D&C1&C&!B1&!B&A1&!A|F&E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|F&E&D2&D1&!D&C1&C&!B1&!B&A1&!A|F&E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|F&E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|F&E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|F&E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|F&E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|F&E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|F&E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|F&E&D2&D1&D&C1&!C&!B1&!B&A1&!A|F&!E&D2&D1&D&C1&!C&!B1&!B&A1&!A|F&E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|F&E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|F&E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|F&E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|F&!E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|F&E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|F&E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|F&E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|F&E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|F&E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|F&E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|F&E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|F&E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|F&E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|F&E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|F&E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|F&E&D2&D1&D&!C1&!C&!B1&!B&A1&A|F&!E&D2&D1&D&!C1&!C&!B1&!B&A1&A|F&E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|F&E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|F&!E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|F&E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|F&E&D2&!D1&D&C1&!C&!B1&!B&A1&A|F&!E&D2&!D1&D&C1&!C&!B1&!B&A1&A|F&!E&D2&D1&D&C1&!C&!B1&!B&A1&A|F&E&D2&D1&D&C1&!C&!B1&!B&A1&A|F&E&!D2&D1&D&C1&!C&!B1&!B&A1&A|F&!E&!D2&D1&D&C1&!C&!B1&!B&A1&A|F&!E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|F&E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|F&E&D2&D1&!D&C1&!C&!B1&!B&A1&A|F&!E&D2&D1&!D&C1&!C&!B1&!B&A1&A|F&!E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|F&E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|F&E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|F&!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|F&!E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|F&E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|F&E&D2&!D1&!D&C1&C&!B1&!B&A1&A|F&!E&D2&!D1&!D&C1&C&!B1&!B&A1&A|F&!E&D2&D1&!D&C1&C&!B1&!B&A1&A|F&E&D2&D1&!D&C1&C&!B1&!B&A1&A|F&E&!D2&D1&!D&C1&C&!B1&!B&A1&A|F&!E&!D2&D1&!D&C1&C&!B1&!B&A1&A|F&!E&!D2&D1&D&C1&C&!B1&!B&A1&A|F&E&!D2&D1&D&C1&C&!B1&!B&A1&A|F&E&D2&D1&D&C1&C&!B1&!B&A1&A|F&!E&D2&D1&D&C1&C&!B1&!B&A1&A|F&!E&D2&!D1&D&C1&C&!B1&!B&A1&A|F&E&D2&!D1&D&C1&C&!B1&!B&A1&A|F&E&!D2&!D1&D&C1&C&!B1&!B&A1&A|F&!E&!D2&!D1&D&C1&C&!B1&!B&A1&A|F&!E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|F&E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|F&E&D2&!D1&D&!C1&C&!B1&!B&A1&A|F&!E&D2&!D1&D&!C1&C&!B1&!B&A1&A|F&!E&D2&D1&D&!C1&C&!B1&!B&A1&A|F&E&D2&D1&D&!C1&C&!B1&!B&A1&A|F&E&!D2&D1&D&!C1&C&!B1&!B&A1&A|F&!E&!D2&D1&D&!C1&C&!B1&!B&A1&A|F&!E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|F&E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|F&E&D2&D1&!D&!C1&C&!B1&!B&A1&A|F&!E&D2&D1&!D&!C1&C&!B1&!B&A1&A|F&!E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|F&E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|F&E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|F&!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|F&!E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|F&E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|F&E&D2&!D1&!D&!C1&C&B1&!B&A1&A|F&!E&D2&!D1&!D&!C1&C&B1&!B&A1&A|F&!E&D2&D1&!D&!C1&C&B1&!B&A1&A|F&E&D2&D1&!D&!C1&C&B1&!B&A1&A|F&E&!D2&D1&!D&!C1&C&B1&!B&A1&A|F&!E&!D2&D1&!D&!C1&C&B1&!B&A1&A|F&!E&!D2&D1&D&!C1&C&B1&!B&A1&A|F&E&!D2&D1&D&!C1&C&B1&!B&A1&A|F&E&D2&D1&D&!C1&C&B1&!B&A1&A|F&!E&D2&D1&D&!C1&C&B1&!B&A1&A|F&!E&D2&!D1&D&!C1&C&B1&!B&A1&A|F&E&D2&!D1&D&!C1&C&B1&!B&A1&A|F&E&!D2&!D1&D&!C1&C&B1&!B&A1&A|F&!E&!D2&!D1&D&!C1&C&B1&!B&A1&A|F&!E&!D2&!D1&D&C1&C&B1&!B&A1&A|F&E&!D2&!D1&D&C1&C&B1&!B&A1&A|F&E&D2&!D1&D&C1&C&B1&!B&A1&A|F&!E&D2&!D1&D&C1&C&B1&!B&A1&A|F&!E&D2&D1&D&C1&C&B1&!B&A1&A|F&E&D2&D1&D&C1&C&B1&!B&A1&A|F&E&!D2&D1&D&C1&C&B1&!B&A1&A|F&!E&!D2&D1&D&C1&C&B1&!B&A1&A|F&!E&!D2&D1&!D&C1&C&B1&!B&A1&A|F&E&!D2&D1&!D&C1&C&B1&!B&A1&A|F&E&D2&D1&!D&C1&C&B1&!B&A1&A|F&!E&D2&D1&!D&C1&C&B1&!B&A1&A|F&!E&D2&!D1&!D&C1&C&B1&!B&A1&A|F&E&D2&!D1&!D&C1&C&B1&!B&A1&A|F&E&!D2&!D1&!D&C1&C&B1&!B&A1&A|F&!E&!D2&!D1&!D&C1&C&B1&!B&A1&A|F&!E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|F&E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|F&E&D2&!D1&!D&C1&!C&B1&!B&A1&A|F&!E&D2&!D1&!D&C1&!C&B1&!B&A1&A|F&!E&D2&D1&!D&C1&!C&B1&!B&A1&A|F&E&D2&D1&!D&C1&!C&B1&!B&A1&A|F&E&!D2&D1&!D&C1&!C&B1&!B&A1&A|F&!E&!D2&D1&!D&C1&!C&B1&!B&A1&A|F&!E&!D2&D1&D&C1&!C&B1&!B&A1&A|F&E&!D2&D1&D&C1&!C&B1&!B&A1&A|F&E&D2&D1&D&C1&!C&B1&!B&A1&A|F&!E&D2&D1&D&C1&!C&B1&!B&A1&A|F&!E&D2&!D1&D&C1&!C&B1&!B&A1&A|F&E&D2&!D1&D&C1&!C&B1&!B&A1&A|F&E&!D2&!D1&D&C1&!C&B1&!B&A1&A|F&!E&!D2&!D1&D&C1&!C&B1&!B&A1&A|F&E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|F&E&D2&!D1&D&!C1&!C&B1&!B&A1&A|F&!E&D2&D1&D&!C1&!C&B1&!B&A1&A|F&E&D2&D1&D&!C1&!C&B1&!B&A1&A|F&E&!D2&D1&D&!C1&!C&B1&!B&A1&A|F&E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|F&E&D2&D1&!D&!C1&!C&B1&!B&A1&A|F&E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|F&E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|F&E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|F&E&D2&!D1&!D&!C1&!C&B1&B&A1&A|F&E&D2&D1&!D&!C1&!C&B1&B&A1&A|F&E&!D2&D1&!D&!C1&!C&B1&B&A1&A|F&E&!D2&D1&D&!C1&!C&B1&B&A1&A|F&E&D2&D1&D&!C1&!C&B1&B&A1&A|F&!E&D2&D1&D&!C1&!C&B1&B&A1&A|F&E&D2&!D1&D&!C1&!C&B1&B&A1&A|F&E&!D2&!D1&D&!C1&!C&B1&B&A1&A|F&!E&!D2&!D1&D&C1&!C&B1&B&A1&A|F&E&!D2&!D1&D&C1&!C&B1&B&A1&A|F&E&D2&!D1&D&C1&!C&B1&B&A1&A|F&!E&D2&!D1&D&C1&!C&B1&B&A1&A|F&!E&D2&D1&D&C1&!C&B1&B&A1&A|F&E&D2&D1&D&C1&!C&B1&B&A1&A|F&E&!D2&D1&D&C1&!C&B1&B&A1&A|F&!E&!D2&D1&D&C1&!C&B1&B&A1&A|F&!E&!D2&D1&!D&C1&!C&B1&B&A1&A|F&E&!D2&D1&!D&C1&!C&B1&B&A1&A|F&E&D2&D1&!D&C1&!C&B1&B&A1&A|F&!E&D2&D1&!D&C1&!C&B1&B&A1&A|F&!E&D2&!D1&!D&C1&!C&B1&B&A1&A|F&E&D2&!D1&!D&C1&!C&B1&B&A1&A|F&E&!D2&!D1&!D&C1&!C&B1&B&A1&A|F&!E&!D2&!D1&!D&C1&!C&B1&B&A1&A|F&!E&!D2&!D1&!D&C1&C&B1&B&A1&A|F&E&!D2&!D1&!D&C1&C&B1&B&A1&A|F&E&D2&!D1&!D&C1&C&B1&B&A1&A|F&!E&D2&!D1&!D&C1&C&B1&B&A1&A|F&!E&D2&D1&!D&C1&C&B1&B&A1&A|F&E&D2&D1&!D&C1&C&B1&B&A1&A|F&E&!D2&D1&!D&C1&C&B1&B&A1&A|F&!E&!D2&D1&!D&C1&C&B1&B&A1&A|F&!E&!D2&D1&D&C1&C&B1&B&A1&A|F&E&!D2&D1&D&C1&C&B1&B&A1&A|F&E&D2&D1&D&C1&C&B1&B&A1&A|F&!E&D2&D1&D&C1&C&B1&B&A1&A|F&!E&D2&!D1&D&C1&C&B1&B&A1&A|F&E&D2&!D1&D&C1&C&B1&B&A1&A|F&E&!D2&!D1&D&C1&C&B1&B&A1&A|F&!E&!D2&!D1&D&C1&C&B1&B&A1&A|F&!E&!D2&!D1&D&!C1&C&B1&B&A1&A|F&E&!D2&!D1&D&!C1&C&B1&B&A1&A|F&E&D2&!D1&D&!C1&C&B1&B&A1&A|F&!E&D2&!D1&D&!C1&C&B1&B&A1&A|F&!E&D2&D1&D&!C1&C&B1&B&A1&A|F&E&D2&D1&D&!C1&C&B1&B&A1&A|F&E&!D2&D1&D&!C1&C&B1&B&A1&A|F&!E&!D2&D1&D&!C1&C&B1&B&A1&A|F&!E&!D2&D1&!D&!C1&C&B1&B&A1&A|F&E&!D2&D1&!D&!C1&C&B1&B&A1&A|F&E&D2&D1&!D&!C1&C&B1&B&A1&A|F&!E&D2&D1&!D&!C1&C&B1&B&A1&A|F&!E&D2&!D1&!D&!C1&C&B1&B&A1&A|F&E&D2&!D1&!D&!C1&C&B1&B&A1&A|F&E&!D2&!D1&!D&!C1&C&B1&B&A1&A|F&!E&!D2&!D1&!D&!C1&C&B1&B&A1&A|F&!E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|F&E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|F&E&D2&!D1&!D&!C1&C&!B1&B&A1&A|F&!E&D2&!D1&!D&!C1&C&!B1&B&A1&A|F&!E&D2&D1&!D&!C1&C&!B1&B&A1&A|F&E&D2&D1&!D&!C1&C&!B1&B&A1&A|F&E&!D2&D1&!D&!C1&C&!B1&B&A1&A|F&!E&!D2&D1&!D&!C1&C&!B1&B&A1&A|F&!E&!D2&D1&D&!C1&C&!B1&B&A1&A|F&E&!D2&D1&D&!C1&C&!B1&B&A1&A|F&E&D2&D1&D&!C1&C&!B1&B&A1&A|F&!E&D2&D1&D&!C1&C&!B1&B&A1&A|F&!E&D2&!D1&D&!C1&C&!B1&B&A1&A|F&E&D2&!D1&D&!C1&C&!B1&B&A1&A|F&E&!D2&!D1&D&!C1&C&!B1&B&A1&A|F&!E&!D2&!D1&D&!C1&C&!B1&B&A1&A|F&!E&!D2&!D1&D&C1&C&!B1&B&A1&A|F&E&!D2&!D1&D&C1&C&!B1&B&A1&A|F&E&D2&!D1&D&C1&C&!B1&B&A1&A|F&!E&D2&!D1&D&C1&C&!B1&B&A1&A|F&!E&D2&D1&D&C1&C&!B1&B&A1&A|F&E&D2&D1&D&C1&C&!B1&B&A1&A|F&E&!D2&D1&D&C1&C&!B1&B&A1&A|F&!E&!D2&D1&D&C1&C&!B1&B&A1&A|F&!E&!D2&D1&!D&C1&C&!B1&B&A1&A|F&E&!D2&D1&!D&C1&C&!B1&B&A1&A|F&E&D2&D1&!D&C1&C&!B1&B&A1&A|F&!E&D2&D1&!D&C1&C&!B1&B&A1&A|F&!E&D2&!D1&!D&C1&C&!B1&B&A1&A|F&E&D2&!D1&!D&C1&C&!B1&B&A1&A|F&E&!D2&!D1&!D&C1&C&!B1&B&A1&A|F&!E&!D2&!D1&!D&C1&C&!B1&B&A1&A|F&!E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|F&E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|F&E&D2&!D1&!D&C1&!C&!B1&B&A1&A|F&!E&D2&!D1&!D&C1&!C&!B1&B&A1&A|F&!E&D2&D1&!D&C1&!C&!B1&B&A1&A|F&E&D2&D1&!D&C1&!C&!B1&B&A1&A|F&E&!D2&D1&!D&C1&!C&!B1&B&A1&A|F&!E&!D2&D1&!D&C1&!C&!B1&B&A1&A|F&!E&!D2&D1&D&C1&!C&!B1&B&A1&A|F&E&!D2&D1&D&C1&!C&!B1&B&A1&A|F&E&D2&D1&D&C1&!C&!B1&B&A1&A|F&!E&D2&D1&D&C1&!C&!B1&B&A1&A|F&!E&D2&!D1&D&C1&!C&!B1&B&A1&A|F&E&D2&!D1&D&C1&!C&!B1&B&A1&A|F&E&!D2&!D1&D&C1&!C&!B1&B&A1&A|F&!E&!D2&!D1&D&C1&!C&!B1&B&A1&A|F&E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|F&E&D2&!D1&D&!C1&!C&!B1&B&A1&A|F&!E&D2&D1&D&!C1&!C&!B1&B&A1&A|F&E&D2&D1&D&!C1&!C&!B1&B&A1&A|F&E&!D2&D1&D&!C1&!C&!B1&B&A1&A|F&E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|F&E&D2&D1&!D&!C1&!C&!B1&B&A1&A|F&E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|F&E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|F&E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|F&E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|F&E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|F&E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|F&E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|F&E&D2&D1&D&!C1&!C&!B1&B&!A1&A|F&!E&D2&D1&D&!C1&!C&!B1&B&!A1&A|F&E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|F&E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|F&E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|F&E&D2&!D1&D&C1&!C&!B1&B&!A1&A|F&!E&D2&D1&D&C1&!C&!B1&B&!A1&A|F&E&D2&D1&D&C1&!C&!B1&B&!A1&A|F&E&!D2&D1&D&C1&!C&!B1&B&!A1&A|F&E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|F&E&D2&D1&!D&C1&!C&!B1&B&!A1&A|F&E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|F&E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|F&E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|F&E&D2&!D1&!D&C1&C&!B1&B&!A1&A|F&E&D2&D1&!D&C1&C&!B1&B&!A1&A|F&E&!D2&D1&!D&C1&C&!B1&B&!A1&A|F&E&!D2&D1&D&C1&C&!B1&B&!A1&A|F&E&D2&D1&D&C1&C&!B1&B&!A1&A|F&!E&D2&D1&D&C1&C&!B1&B&!A1&A|F&E&D2&!D1&D&C1&C&!B1&B&!A1&A|F&E&!D2&!D1&D&C1&C&!B1&B&!A1&A|F&E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|F&E&D2&!D1&D&!C1&C&!B1&B&!A1&A|F&!E&D2&D1&D&!C1&C&!B1&B&!A1&A|F&E&D2&D1&D&!C1&C&!B1&B&!A1&A|F&E&!D2&D1&D&!C1&C&!B1&B&!A1&A|F&E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|F&E&D2&D1&!D&!C1&C&!B1&B&!A1&A|F&E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|F&E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|F&!E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|F&E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|F&E&D2&!D1&!D&!C1&C&B1&B&!A1&A|F&!E&D2&!D1&!D&!C1&C&B1&B&!A1&A|F&!E&D2&D1&!D&!C1&C&B1&B&!A1&A|F&E&D2&D1&!D&!C1&C&B1&B&!A1&A|F&E&!D2&D1&!D&!C1&C&B1&B&!A1&A|F&!E&!D2&D1&!D&!C1&C&B1&B&!A1&A|F&!E&!D2&D1&D&!C1&C&B1&B&!A1&A|F&E&!D2&D1&D&!C1&C&B1&B&!A1&A|F&E&D2&D1&D&!C1&C&B1&B&!A1&A|F&!E&D2&D1&D&!C1&C&B1&B&!A1&A|F&!E&D2&!D1&D&!C1&C&B1&B&!A1&A|F&E&D2&!D1&D&!C1&C&B1&B&!A1&A|F&E&!D2&!D1&D&!C1&C&B1&B&!A1&A|F&!E&!D2&!D1&D&!C1&C&B1&B&!A1&A|F&!E&!D2&!D1&D&C1&C&B1&B&!A1&A|F&E&!D2&!D1&D&C1&C&B1&B&!A1&A|F&E&D2&!D1&D&C1&C&B1&B&!A1&A|F&!E&D2&!D1&D&C1&C&B1&B&!A1&A|F&!E&D2&D1&D&C1&C&B1&B&!A1&A|F&E&D2&D1&D&C1&C&B1&B&!A1&A|F&E&!D2&D1&D&C1&C&B1&B&!A1&A|F&!E&!D2&D1&D&C1&C&B1&B&!A1&A|F&!E&!D2&D1&!D&C1&C&B1&B&!A1&A|F&E&!D2&D1&!D&C1&C&B1&B&!A1&A|F&E&D2&D1&!D&C1&C&B1&B&!A1&A|F&!E&D2&D1&!D&C1&C&B1&B&!A1&A|F&!E&D2&!D1&!D&C1&C&B1&B&!A1&A|F&E&D2&!D1&!D&C1&C&B1&B&!A1&A|F&E&!D2&!D1&!D&C1&C&B1&B&!A1&A|F&!E&!D2&!D1&!D&C1&C&B1&B&!A1&A|F&!E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|F&E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|F&E&D2&!D1&!D&C1&!C&B1&B&!A1&A|F&!E&D2&!D1&!D&C1&!C&B1&B&!A1&A|F&!E&D2&D1&!D&C1&!C&B1&B&!A1&A|F&E&D2&D1&!D&C1&!C&B1&B&!A1&A|F&E&!D2&D1&!D&C1&!C&B1&B&!A1&A|F&!E&!D2&D1&!D&C1&!C&B1&B&!A1&A|F&!E&!D2&D1&D&C1&!C&B1&B&!A1&A|F&E&!D2&D1&D&C1&!C&B1&B&!A1&A|F&E&D2&D1&D&C1&!C&B1&B&!A1&A|F&!E&D2&D1&D&C1&!C&B1&B&!A1&A|F&!E&D2&!D1&D&C1&!C&B1&B&!A1&A|F&E&D2&!D1&D&C1&!C&B1&B&!A1&A|F&E&!D2&!D1&D&C1&!C&B1&B&!A1&A|F&!E&!D2&!D1&D&C1&!C&B1&B&!A1&A|F&E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|F&E&D2&!D1&D&!C1&!C&B1&B&!A1&A|F&!E&D2&D1&D&!C1&!C&B1&B&!A1&A|F&E&D2&D1&D&!C1&!C&B1&B&!A1&A|F&E&!D2&D1&D&!C1&!C&B1&B&!A1&A|F&E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|F&E&D2&D1&!D&!C1&!C&B1&B&!A1&A|F&E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|F&E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|F&E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|F&E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|F&E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|F&E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|F&E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|F&E&D2&D1&D&!C1&!C&B1&!B&!A1&A|F&!E&D2&D1&D&!C1&!C&B1&!B&!A1&A|F&E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|F&E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|F&E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|F&E&D2&!D1&D&C1&!C&B1&!B&!A1&A|F&!E&D2&D1&D&C1&!C&B1&!B&!A1&A|F&E&D2&D1&D&C1&!C&B1&!B&!A1&A|F&E&!D2&D1&D&C1&!C&B1&!B&!A1&A|F&E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|F&E&D2&D1&!D&C1&!C&B1&!B&!A1&A|F&E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|F&E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|F&E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|F&E&D2&!D1&!D&C1&C&B1&!B&!A1&A|F&E&D2&D1&!D&C1&C&B1&!B&!A1&A|F&E&!D2&D1&!D&C1&C&B1&!B&!A1&A|F&E&!D2&D1&D&C1&C&B1&!B&!A1&A|F&E&D2&D1&D&C1&C&B1&!B&!A1&A|F&!E&D2&D1&D&C1&C&B1&!B&!A1&A|F&E&D2&!D1&D&C1&C&B1&!B&!A1&A|F&E&!D2&!D1&D&C1&C&B1&!B&!A1&A|F&E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|F&E&D2&!D1&D&!C1&C&B1&!B&!A1&A|F&!E&D2&D1&D&!C1&C&B1&!B&!A1&A|F&E&D2&D1&D&!C1&C&B1&!B&!A1&A|F&E&!D2&D1&D&!C1&C&B1&!B&!A1&A|F&E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|F&E&D2&D1&!D&!C1&C&B1&!B&!A1&A|F&E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|F&E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|F&E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|F&E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|F&E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|F&E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|F&E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|F&E&D2&D1&D&!C1&C&!B1&!B&!A1&A|F&!E&D2&D1&D&!C1&C&!B1&!B&!A1&A|F&E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|F&E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|F&E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|F&E&D2&!D1&D&C1&C&!B1&!B&!A1&A|F&!E&D2&D1&D&C1&C&!B1&!B&!A1&A|F&E&D2&D1&D&C1&C&!B1&!B&!A1&A|F&E&!D2&D1&D&C1&C&!B1&!B&!A1&A|F&E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|F&E&D2&D1&!D&C1&C&!B1&!B&!A1&A|F&E&D2&!D1&!D&C1&C&!B1&!B&!A1&A|F&E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|F&E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|F&E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|F&E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|F&E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|F&E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|F&E&D2&D1&D&C1&!C&!B1&!B&!A1&A|F&!E&D2&D1&D&C1&!C&!B1&!B&!A1&A|F&E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|F&E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|F&E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|F&E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|F&!E&D2&D1&D&!C1&!C&!B1&!B&!A1&A|F&E&D2&D1&D&!C1&!C&!B1&!B&!A1&A|F&E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|F&E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|F&E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|F&E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|F&E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAAOAI222311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n MUX2 -l MUX2 -i IN0 IN1 S0 S1 -o Z -f 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist MUX2.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOOAOI221311 -l OOAOOAOI221311 -i F E D2 D1 D C B1 B A1 A -o Y -f Y=(!F&!E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!F&E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!F&E&D2&!D1&!D&!C&!B1&!B&!A1&!A|!F&!E&D2&!D1&!D&!C&!B1&!B&!A1&!A|!F&!E&D2&D1&!D&!C&!B1&!B&!A1&!A|!F&E&D2&D1&!D&!C&!B1&!B&!A1&!A|!F&E&!D2&D1&!D&!C&!B1&!B&!A1&!A|!F&!E&!D2&D1&!D&!C&!B1&!B&!A1&!A|!F&!E&!D2&D1&D&!C&!B1&!B&!A1&!A|!F&E&!D2&D1&D&!C&!B1&!B&!A1&!A|!F&E&D2&D1&D&!C&!B1&!B&!A1&!A|!F&!E&D2&D1&D&!C&!B1&!B&!A1&!A|!F&!E&D2&!D1&D&!C&!B1&!B&!A1&!A|!F&E&D2&!D1&D&!C&!B1&!B&!A1&!A|!F&E&!D2&!D1&D&!C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&D&!C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&D&C&!B1&!B&!A1&!A|!F&!E&D2&!D1&D&C&!B1&!B&!A1&!A|!F&!E&D2&D1&D&C&!B1&!B&!A1&!A|!F&!E&!D2&D1&D&C&!B1&!B&!A1&!A|!F&!E&!D2&D1&!D&C&!B1&!B&!A1&!A|!F&!E&D2&D1&!D&C&!B1&!B&!A1&!A|!F&!E&D2&!D1&!D&C&!B1&!B&!A1&!A|!F&E&!D2&!D1&!D&C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&C&B1&!B&!A1&!A|!F&E&!D2&!D1&!D&C&B1&!B&!A1&!A|!F&!E&D2&!D1&!D&C&B1&!B&!A1&!A|!F&!E&D2&D1&!D&C&B1&!B&!A1&!A|!F&!E&!D2&D1&!D&C&B1&!B&!A1&!A|!F&!E&!D2&D1&D&C&B1&!B&!A1&!A|!F&!E&D2&D1&D&C&B1&!B&!A1&!A|!F&!E&D2&!D1&D&C&B1&!B&!A1&!A|!F&!E&!D2&!D1&D&C&B1&!B&!A1&!A|!F&!E&!D2&!D1&D&!C&B1&!B&!A1&!A|!F&E&!D2&!D1&D&!C&B1&!B&!A1&!A|!F&E&D2&!D1&D&!C&B1&!B&!A1&!A|!F&!E&D2&!D1&D&!C&B1&!B&!A1&!A|!F&!E&D2&D1&D&!C&B1&!B&!A1&!A|!F&E&D2&D1&D&!C&B1&!B&!A1&!A|!F&E&!D2&D1&D&!C&B1&!B&!A1&!A|!F&!E&!D2&D1&D&!C&B1&!B&!A1&!A|!F&!E&!D2&D1&!D&!C&B1&!B&!A1&!A|!F&E&!D2&D1&!D&!C&B1&!B&!A1&!A|!F&E&D2&D1&!D&!C&B1&!B&!A1&!A|!F&!E&D2&D1&!D&!C&B1&!B&!A1&!A|!F&!E&D2&!D1&!D&!C&B1&!B&!A1&!A|!F&E&D2&!D1&!D&!C&B1&!B&!A1&!A|!F&E&!D2&!D1&!D&!C&B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C&B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C&B1&B&!A1&!A|!F&E&!D2&!D1&!D&!C&B1&B&!A1&!A|!F&E&D2&!D1&!D&!C&B1&B&!A1&!A|!F&!E&D2&!D1&!D&!C&B1&B&!A1&!A|!F&!E&D2&D1&!D&!C&B1&B&!A1&!A|!F&E&D2&D1&!D&!C&B1&B&!A1&!A|!F&E&!D2&D1&!D&!C&B1&B&!A1&!A|!F&!E&!D2&D1&!D&!C&B1&B&!A1&!A|!F&!E&!D2&D1&D&!C&B1&B&!A1&!A|!F&E&!D2&D1&D&!C&B1&B&!A1&!A|!F&E&D2&D1&D&!C&B1&B&!A1&!A|!F&!E&D2&D1&D&!C&B1&B&!A1&!A|!F&!E&D2&!D1&D&!C&B1&B&!A1&!A|!F&E&D2&!D1&D&!C&B1&B&!A1&!A|!F&E&!D2&!D1&D&!C&B1&B&!A1&!A|!F&!E&!D2&!D1&D&!C&B1&B&!A1&!A|!F&!E&!D2&!D1&D&C&B1&B&!A1&!A|!F&!E&D2&!D1&D&C&B1&B&!A1&!A|!F&!E&D2&D1&D&C&B1&B&!A1&!A|!F&!E&!D2&D1&D&C&B1&B&!A1&!A|!F&!E&!D2&D1&!D&C&B1&B&!A1&!A|!F&!E&D2&D1&!D&C&B1&B&!A1&!A|!F&!E&D2&!D1&!D&C&B1&B&!A1&!A|!F&E&!D2&!D1&!D&C&B1&B&!A1&!A|!F&!E&!D2&!D1&!D&C&B1&B&!A1&!A|!F&!E&!D2&!D1&!D&C&!B1&B&!A1&!A|!F&E&!D2&!D1&!D&C&!B1&B&!A1&!A|!F&!E&D2&!D1&!D&C&!B1&B&!A1&!A|!F&!E&D2&D1&!D&C&!B1&B&!A1&!A|!F&!E&!D2&D1&!D&C&!B1&B&!A1&!A|!F&!E&!D2&D1&D&C&!B1&B&!A1&!A|!F&!E&D2&D1&D&C&!B1&B&!A1&!A|!F&!E&D2&!D1&D&C&!B1&B&!A1&!A|!F&!E&!D2&!D1&D&C&!B1&B&!A1&!A|!F&!E&!D2&!D1&D&!C&!B1&B&!A1&!A|!F&E&!D2&!D1&D&!C&!B1&B&!A1&!A|!F&E&D2&!D1&D&!C&!B1&B&!A1&!A|!F&!E&D2&!D1&D&!C&!B1&B&!A1&!A|!F&!E&D2&D1&D&!C&!B1&B&!A1&!A|!F&E&D2&D1&D&!C&!B1&B&!A1&!A|!F&E&!D2&D1&D&!C&!B1&B&!A1&!A|!F&!E&!D2&D1&D&!C&!B1&B&!A1&!A|!F&!E&!D2&D1&!D&!C&!B1&B&!A1&!A|!F&E&!D2&D1&!D&!C&!B1&B&!A1&!A|!F&E&D2&D1&!D&!C&!B1&B&!A1&!A|!F&!E&D2&D1&!D&!C&!B1&B&!A1&!A|!F&!E&D2&!D1&!D&!C&!B1&B&!A1&!A|!F&E&D2&!D1&!D&!C&!B1&B&!A1&!A|!F&E&!D2&!D1&!D&!C&!B1&B&!A1&!A|!F&!E&!D2&!D1&!D&!C&!B1&B&!A1&!A|!F&!E&!D2&!D1&!D&!C&!B1&B&A1&!A|!F&E&!D2&!D1&!D&!C&!B1&B&A1&!A|!F&!E&D2&!D1&!D&!C&!B1&B&A1&!A|!F&!E&D2&D1&!D&!C&!B1&B&A1&!A|!F&!E&!D2&D1&!D&!C&!B1&B&A1&!A|!F&!E&!D2&D1&D&!C&!B1&B&A1&!A|!F&!E&D2&D1&D&!C&!B1&B&A1&!A|!F&!E&D2&!D1&D&!C&!B1&B&A1&!A|!F&!E&!D2&!D1&D&!C&!B1&B&A1&!A|!F&!E&!D2&!D1&D&C&!B1&B&A1&!A|!F&!E&D2&!D1&D&C&!B1&B&A1&!A|!F&!E&D2&D1&D&C&!B1&B&A1&!A|!F&!E&!D2&D1&D&C&!B1&B&A1&!A|!F&!E&!D2&D1&!D&C&!B1&B&A1&!A|!F&!E&D2&D1&!D&C&!B1&B&A1&!A|!F&!E&D2&!D1&!D&C&!B1&B&A1&!A|!F&E&!D2&!D1&!D&C&!B1&B&A1&!A|!F&!E&!D2&!D1&!D&C&!B1&B&A1&!A|!F&!E&!D2&!D1&!D&C&B1&B&A1&!A|!F&E&!D2&!D1&!D&C&B1&B&A1&!A|!F&!E&D2&!D1&!D&C&B1&B&A1&!A|!F&!E&D2&D1&!D&C&B1&B&A1&!A|!F&!E&!D2&D1&!D&C&B1&B&A1&!A|!F&!E&!D2&D1&D&C&B1&B&A1&!A|!F&!E&D2&D1&D&C&B1&B&A1&!A|!F&!E&D2&!D1&D&C&B1&B&A1&!A|!F&!E&!D2&!D1&D&C&B1&B&A1&!A|!F&!E&!D2&!D1&D&!C&B1&B&A1&!A|!F&!E&D2&!D1&D&!C&B1&B&A1&!A|!F&!E&D2&D1&D&!C&B1&B&A1&!A|!F&!E&!D2&D1&D&!C&B1&B&A1&!A|!F&!E&!D2&D1&!D&!C&B1&B&A1&!A|!F&!E&D2&D1&!D&!C&B1&B&A1&!A|!F&!E&D2&!D1&!D&!C&B1&B&A1&!A|!F&E&!D2&!D1&!D&!C&B1&B&A1&!A|!F&!E&!D2&!D1&!D&!C&B1&B&A1&!A|!F&!E&!D2&!D1&!D&!C&B1&!B&A1&!A|!F&E&!D2&!D1&!D&!C&B1&!B&A1&!A|!F&!E&D2&!D1&!D&!C&B1&!B&A1&!A|!F&!E&D2&D1&!D&!C&B1&!B&A1&!A|!F&!E&!D2&D1&!D&!C&B1&!B&A1&!A|!F&!E&!D2&D1&D&!C&B1&!B&A1&!A|!F&!E&D2&D1&D&!C&B1&!B&A1&!A|!F&!E&D2&!D1&D&!C&B1&!B&A1&!A|!F&!E&!D2&!D1&D&!C&B1&!B&A1&!A|!F&!E&!D2&!D1&D&C&B1&!B&A1&!A|!F&!E&D2&!D1&D&C&B1&!B&A1&!A|!F&!E&D2&D1&D&C&B1&!B&A1&!A|!F&!E&!D2&D1&D&C&B1&!B&A1&!A|!F&!E&!D2&D1&!D&C&B1&!B&A1&!A|!F&!E&D2&D1&!D&C&B1&!B&A1&!A|!F&!E&D2&!D1&!D&C&B1&!B&A1&!A|!F&E&!D2&!D1&!D&C&B1&!B&A1&!A|!F&!E&!D2&!D1&!D&C&B1&!B&A1&!A|!F&!E&!D2&!D1&!D&C&!B1&!B&A1&!A|!F&E&!D2&!D1&!D&C&!B1&!B&A1&!A|!F&!E&D2&!D1&!D&C&!B1&!B&A1&!A|!F&!E&D2&D1&!D&C&!B1&!B&A1&!A|!F&!E&!D2&D1&!D&C&!B1&!B&A1&!A|!F&!E&!D2&D1&D&C&!B1&!B&A1&!A|!F&!E&D2&D1&D&C&!B1&!B&A1&!A|!F&!E&D2&!D1&D&C&!B1&!B&A1&!A|!F&!E&!D2&!D1&D&C&!B1&!B&A1&!A|!F&!E&!D2&!D1&D&!C&!B1&!B&A1&!A|!F&E&!D2&!D1&D&!C&!B1&!B&A1&!A|!F&E&D2&!D1&D&!C&!B1&!B&A1&!A|!F&!E&D2&!D1&D&!C&!B1&!B&A1&!A|!F&!E&D2&D1&D&!C&!B1&!B&A1&!A|!F&E&D2&D1&D&!C&!B1&!B&A1&!A|!F&E&!D2&D1&D&!C&!B1&!B&A1&!A|!F&!E&!D2&D1&D&!C&!B1&!B&A1&!A|!F&!E&!D2&D1&!D&!C&!B1&!B&A1&!A|!F&E&!D2&D1&!D&!C&!B1&!B&A1&!A|!F&E&D2&D1&!D&!C&!B1&!B&A1&!A|!F&!E&D2&D1&!D&!C&!B1&!B&A1&!A|!F&!E&D2&!D1&!D&!C&!B1&!B&A1&!A|!F&E&D2&!D1&!D&!C&!B1&!B&A1&!A|!F&E&!D2&!D1&!D&!C&!B1&!B&A1&!A|!F&!E&!D2&!D1&!D&!C&!B1&!B&A1&!A|!F&!E&!D2&!D1&!D&!C&!B1&!B&A1&A|!F&E&!D2&!D1&!D&!C&!B1&!B&A1&A|!F&E&D2&!D1&!D&!C&!B1&!B&A1&A|!F&!E&D2&!D1&!D&!C&!B1&!B&A1&A|!F&!E&D2&D1&!D&!C&!B1&!B&A1&A|!F&E&D2&D1&!D&!C&!B1&!B&A1&A|!F&E&!D2&D1&!D&!C&!B1&!B&A1&A|!F&!E&!D2&D1&!D&!C&!B1&!B&A1&A|!F&!E&!D2&D1&D&!C&!B1&!B&A1&A|!F&E&!D2&D1&D&!C&!B1&!B&A1&A|!F&E&D2&D1&D&!C&!B1&!B&A1&A|!F&!E&D2&D1&D&!C&!B1&!B&A1&A|!F&!E&D2&!D1&D&!C&!B1&!B&A1&A|!F&E&D2&!D1&D&!C&!B1&!B&A1&A|!F&E&!D2&!D1&D&!C&!B1&!B&A1&A|!F&!E&!D2&!D1&D&!C&!B1&!B&A1&A|!F&!E&!D2&!D1&D&C&!B1&!B&A1&A|!F&!E&D2&!D1&D&C&!B1&!B&A1&A|!F&!E&D2&D1&D&C&!B1&!B&A1&A|!F&!E&!D2&D1&D&C&!B1&!B&A1&A|!F&!E&!D2&D1&!D&C&!B1&!B&A1&A|!F&!E&D2&D1&!D&C&!B1&!B&A1&A|!F&!E&D2&!D1&!D&C&!B1&!B&A1&A|!F&E&!D2&!D1&!D&C&!B1&!B&A1&A|!F&!E&!D2&!D1&!D&C&!B1&!B&A1&A|!F&!E&!D2&!D1&!D&C&B1&!B&A1&A|!F&E&!D2&!D1&!D&C&B1&!B&A1&A|!F&!E&D2&!D1&!D&C&B1&!B&A1&A|!F&!E&D2&D1&!D&C&B1&!B&A1&A|!F&!E&!D2&D1&!D&C&B1&!B&A1&A|!F&!E&!D2&D1&D&C&B1&!B&A1&A|!F&!E&D2&D1&D&C&B1&!B&A1&A|!F&!E&D2&!D1&D&C&B1&!B&A1&A|!F&!E&!D2&!D1&D&C&B1&!B&A1&A|!F&!E&!D2&!D1&D&!C&B1&!B&A1&A|!F&!E&D2&!D1&D&!C&B1&!B&A1&A|!F&!E&D2&D1&D&!C&B1&!B&A1&A|!F&!E&!D2&D1&D&!C&B1&!B&A1&A|!F&!E&!D2&D1&!D&!C&B1&!B&A1&A|!F&!E&D2&D1&!D&!C&B1&!B&A1&A|!F&!E&D2&!D1&!D&!C&B1&!B&A1&A|!F&E&!D2&!D1&!D&!C&B1&!B&A1&A|!F&!E&!D2&!D1&!D&!C&B1&!B&A1&A|!F&!E&!D2&!D1&!D&!C&B1&B&A1&A|!F&E&!D2&!D1&!D&!C&B1&B&A1&A|!F&!E&D2&!D1&!D&!C&B1&B&A1&A|!F&!E&D2&D1&!D&!C&B1&B&A1&A|!F&!E&!D2&D1&!D&!C&B1&B&A1&A|!F&!E&!D2&D1&D&!C&B1&B&A1&A|!F&!E&D2&D1&D&!C&B1&B&A1&A|!F&!E&D2&!D1&D&!C&B1&B&A1&A|!F&!E&!D2&!D1&D&!C&B1&B&A1&A|!F&!E&!D2&!D1&D&C&B1&B&A1&A|!F&!E&D2&!D1&D&C&B1&B&A1&A|!F&!E&D2&D1&D&C&B1&B&A1&A|!F&!E&!D2&D1&D&C&B1&B&A1&A|!F&!E&!D2&D1&!D&C&B1&B&A1&A|!F&!E&D2&D1&!D&C&B1&B&A1&A|!F&!E&D2&!D1&!D&C&B1&B&A1&A|!F&E&!D2&!D1&!D&C&B1&B&A1&A|!F&!E&!D2&!D1&!D&C&B1&B&A1&A|!F&!E&!D2&!D1&!D&C&!B1&B&A1&A|!F&E&!D2&!D1&!D&C&!B1&B&A1&A|!F&!E&D2&!D1&!D&C&!B1&B&A1&A|!F&!E&D2&D1&!D&C&!B1&B&A1&A|!F&!E&!D2&D1&!D&C&!B1&B&A1&A|!F&!E&!D2&D1&D&C&!B1&B&A1&A|!F&!E&D2&D1&D&C&!B1&B&A1&A|!F&!E&D2&!D1&D&C&!B1&B&A1&A|!F&!E&!D2&!D1&D&C&!B1&B&A1&A|!F&!E&!D2&!D1&D&!C&!B1&B&A1&A|!F&!E&D2&!D1&D&!C&!B1&B&A1&A|!F&!E&D2&D1&D&!C&!B1&B&A1&A|!F&!E&!D2&D1&D&!C&!B1&B&A1&A|!F&!E&!D2&D1&!D&!C&!B1&B&A1&A|!F&!E&D2&D1&!D&!C&!B1&B&A1&A|!F&!E&D2&!D1&!D&!C&!B1&B&A1&A|!F&E&!D2&!D1&!D&!C&!B1&B&A1&A|!F&!E&!D2&!D1&!D&!C&!B1&B&A1&A|!F&!E&!D2&!D1&!D&!C&!B1&B&!A1&A|!F&E&!D2&!D1&!D&!C&!B1&B&!A1&A|!F&!E&D2&!D1&!D&!C&!B1&B&!A1&A|!F&!E&D2&D1&!D&!C&!B1&B&!A1&A|!F&!E&!D2&D1&!D&!C&!B1&B&!A1&A|!F&!E&!D2&D1&D&!C&!B1&B&!A1&A|!F&!E&D2&D1&D&!C&!B1&B&!A1&A|!F&!E&D2&!D1&D&!C&!B1&B&!A1&A|!F&!E&!D2&!D1&D&!C&!B1&B&!A1&A|!F&!E&!D2&!D1&D&C&!B1&B&!A1&A|!F&!E&D2&!D1&D&C&!B1&B&!A1&A|!F&!E&D2&D1&D&C&!B1&B&!A1&A|!F&!E&!D2&D1&D&C&!B1&B&!A1&A|!F&!E&!D2&D1&!D&C&!B1&B&!A1&A|!F&!E&D2&D1&!D&C&!B1&B&!A1&A|!F&!E&D2&!D1&!D&C&!B1&B&!A1&A|!F&E&!D2&!D1&!D&C&!B1&B&!A1&A|!F&!E&!D2&!D1&!D&C&!B1&B&!A1&A|!F&!E&!D2&!D1&!D&C&B1&B&!A1&A|!F&E&!D2&!D1&!D&C&B1&B&!A1&A|!F&!E&D2&!D1&!D&C&B1&B&!A1&A|!F&!E&D2&D1&!D&C&B1&B&!A1&A|!F&!E&!D2&D1&!D&C&B1&B&!A1&A|!F&!E&!D2&D1&D&C&B1&B&!A1&A|!F&!E&D2&D1&D&C&B1&B&!A1&A|!F&!E&D2&!D1&D&C&B1&B&!A1&A|!F&!E&!D2&!D1&D&C&B1&B&!A1&A|!F&!E&!D2&!D1&D&!C&B1&B&!A1&A|!F&!E&D2&!D1&D&!C&B1&B&!A1&A|!F&!E&D2&D1&D&!C&B1&B&!A1&A|!F&!E&!D2&D1&D&!C&B1&B&!A1&A|!F&!E&!D2&D1&!D&!C&B1&B&!A1&A|!F&!E&D2&D1&!D&!C&B1&B&!A1&A|!F&!E&D2&!D1&!D&!C&B1&B&!A1&A|!F&E&!D2&!D1&!D&!C&B1&B&!A1&A|!F&!E&!D2&!D1&!D&!C&B1&B&!A1&A|!F&!E&!D2&!D1&!D&!C&B1&!B&!A1&A|!F&E&!D2&!D1&!D&!C&B1&!B&!A1&A|!F&!E&D2&!D1&!D&!C&B1&!B&!A1&A|!F&!E&D2&D1&!D&!C&B1&!B&!A1&A|!F&!E&!D2&D1&!D&!C&B1&!B&!A1&A|!F&!E&!D2&D1&D&!C&B1&!B&!A1&A|!F&!E&D2&D1&D&!C&B1&!B&!A1&A|!F&!E&D2&!D1&D&!C&B1&!B&!A1&A|!F&!E&!D2&!D1&D&!C&B1&!B&!A1&A|!F&!E&!D2&!D1&D&C&B1&!B&!A1&A|!F&!E&D2&!D1&D&C&B1&!B&!A1&A|!F&!E&D2&D1&D&C&B1&!B&!A1&A|!F&!E&!D2&D1&D&C&B1&!B&!A1&A|!F&!E&!D2&D1&!D&C&B1&!B&!A1&A|!F&!E&D2&D1&!D&C&B1&!B&!A1&A|!F&!E&D2&!D1&!D&C&B1&!B&!A1&A|!F&E&!D2&!D1&!D&C&B1&!B&!A1&A|!F&!E&!D2&!D1&!D&C&B1&!B&!A1&A|!F&!E&!D2&!D1&!D&C&!B1&!B&!A1&A|!F&E&!D2&!D1&!D&C&!B1&!B&!A1&A|!F&!E&D2&!D1&!D&C&!B1&!B&!A1&A|!F&!E&D2&D1&!D&C&!B1&!B&!A1&A|!F&!E&!D2&D1&!D&C&!B1&!B&!A1&A|!F&!E&!D2&D1&D&C&!B1&!B&!A1&A|!F&!E&D2&D1&D&C&!B1&!B&!A1&A|!F&!E&D2&!D1&D&C&!B1&!B&!A1&A|!F&!E&!D2&!D1&D&C&!B1&!B&!A1&A|!F&!E&!D2&!D1&D&!C&!B1&!B&!A1&A|!F&E&!D2&!D1&D&!C&!B1&!B&!A1&A|!F&E&D2&!D1&D&!C&!B1&!B&!A1&A|!F&!E&D2&!D1&D&!C&!B1&!B&!A1&A|!F&!E&D2&D1&D&!C&!B1&!B&!A1&A|!F&E&D2&D1&D&!C&!B1&!B&!A1&A|!F&E&!D2&D1&D&!C&!B1&!B&!A1&A|!F&!E&!D2&D1&D&!C&!B1&!B&!A1&A|!F&!E&!D2&D1&!D&!C&!B1&!B&!A1&A|!F&E&!D2&D1&!D&!C&!B1&!B&!A1&A|!F&E&D2&D1&!D&!C&!B1&!B&!A1&A|!F&!E&D2&D1&!D&!C&!B1&!B&!A1&A|!F&!E&D2&!D1&!D&!C&!B1&!B&!A1&A|!F&E&D2&!D1&!D&!C&!B1&!B&!A1&A|!F&E&!D2&!D1&!D&!C&!B1&!B&!A1&A|!F&!E&!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOOAOI221311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAI22221 -l AAOOAI22221 -i E D1 D C1 C B1 B A1 A -o Y -f Z=(E&!D1&D&C1&!C&B1&B&!A1&!A|E&D1&D&C1&!C&B1&B&!A1&!A|E&D1&!D&C1&!C&B1&B&!A1&!A|E&D1&!D&C1&C&B1&B&!A1&!A|E&D1&D&C1&C&B1&B&!A1&!A|E&!D1&D&C1&C&B1&B&!A1&!A|E&!D1&D&!C1&C&B1&B&!A1&!A|E&D1&D&!C1&C&B1&B&!A1&!A|E&D1&!D&!C1&C&B1&B&!A1&!A|E&D1&!D&!C1&C&B1&B&A1&!A|E&D1&D&!C1&C&B1&B&A1&!A|E&!D1&D&!C1&C&B1&B&A1&!A|E&!D1&D&C1&C&B1&B&A1&!A|E&D1&D&C1&C&B1&B&A1&!A|E&D1&!D&C1&C&B1&B&A1&!A|E&D1&!D&C1&!C&B1&B&A1&!A|E&D1&D&C1&!C&B1&B&A1&!A|E&!D1&D&C1&!C&B1&B&A1&!A|E&!D1&D&C1&!C&!B1&!B&A1&A|E&D1&D&C1&!C&!B1&!B&A1&A|E&D1&!D&C1&!C&!B1&!B&A1&A|E&D1&!D&C1&C&!B1&!B&A1&A|E&D1&D&C1&C&!B1&!B&A1&A|E&!D1&D&C1&C&!B1&!B&A1&A|E&!D1&D&!C1&C&!B1&!B&A1&A|E&D1&D&!C1&C&!B1&!B&A1&A|E&D1&!D&!C1&C&!B1&!B&A1&A|E&D1&!D&!C1&C&B1&!B&A1&A|E&D1&D&!C1&C&B1&!B&A1&A|E&!D1&D&!C1&C&B1&!B&A1&A|E&!D1&D&C1&C&B1&!B&A1&A|E&D1&D&C1&C&B1&!B&A1&A|E&D1&!D&C1&C&B1&!B&A1&A|E&D1&!D&C1&!C&B1&!B&A1&A|E&D1&D&C1&!C&B1&!B&A1&A|E&!D1&D&C1&!C&B1&!B&A1&A|E&!D1&D&C1&!C&B1&B&A1&A|E&D1&D&C1&!C&B1&B&A1&A|E&D1&!D&C1&!C&B1&B&A1&A|E&D1&!D&C1&C&B1&B&A1&A|E&D1&D&C1&C&B1&B&A1&A|E&!D1&D&C1&C&B1&B&A1&A|E&!D1&D&!C1&C&B1&B&A1&A|E&D1&D&!C1&C&B1&B&A1&A|E&D1&!D&!C1&C&B1&B&A1&A|E&D1&!D&!C1&C&!B1&B&A1&A|E&D1&D&!C1&C&!B1&B&A1&A|E&!D1&D&!C1&C&!B1&B&A1&A|E&!D1&D&C1&C&!B1&B&A1&A|E&D1&D&C1&C&!B1&B&A1&A|E&D1&!D&C1&C&!B1&B&A1&A|E&D1&!D&C1&!C&!B1&B&A1&A|E&D1&D&C1&!C&!B1&B&A1&A|E&!D1&D&C1&!C&!B1&B&A1&A|E&D1&!D&!C1&C&B1&B&!A1&A|E&D1&D&!C1&C&B1&B&!A1&A|E&!D1&D&!C1&C&B1&B&!A1&A|E&!D1&D&C1&C&B1&B&!A1&A|E&D1&D&C1&C&B1&B&!A1&A|E&D1&!D&C1&C&B1&B&!A1&A|E&D1&!D&C1&!C&B1&B&!A1&A|E&D1&D&C1&!C&B1&B&!A1&A|E&!D1&D&C1&!C&B1&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAI22221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOAOI21221 -l OAAOOAOI21221 -i E D1 D C1 C B A1 A -o Y -f Y=(!E&!D1&!D&!C1&!C&!B&!A1&!A|!E&D1&!D&!C1&!C&!B&!A1&!A|!E&D1&D&!C1&!C&!B&!A1&!A|!E&!D1&D&!C1&!C&!B&!A1&!A|!E&!D1&D&C1&!C&!B&!A1&!A|!E&D1&D&C1&!C&!B&!A1&!A|!E&D1&!D&C1&!C&!B&!A1&!A|!E&!D1&!D&C1&!C&!B&!A1&!A|!E&!D1&!D&C1&C&!B&!A1&!A|!E&!D1&D&!C1&C&!B&!A1&!A|!E&D1&D&!C1&C&!B&!A1&!A|!E&D1&!D&!C1&C&!B&!A1&!A|!E&!D1&!D&!C1&C&!B&!A1&!A|!E&!D1&!D&!C1&C&B&!A1&!A|!E&D1&!D&!C1&C&B&!A1&!A|!E&D1&D&!C1&C&B&!A1&!A|!E&!D1&D&!C1&C&B&!A1&!A|!E&!D1&!D&C1&C&B&!A1&!A|!E&!D1&!D&C1&!C&B&!A1&!A|!E&D1&!D&C1&!C&B&!A1&!A|!E&D1&D&C1&!C&B&!A1&!A|!E&!D1&D&C1&!C&B&!A1&!A|!E&!D1&D&!C1&!C&B&!A1&!A|!E&D1&D&!C1&!C&B&!A1&!A|!E&D1&!D&!C1&!C&B&!A1&!A|!E&!D1&!D&!C1&!C&B&!A1&!A|!E&!D1&!D&!C1&!C&B&A1&!A|!E&!D1&!D&C1&!C&B&A1&!A|!E&!D1&!D&C1&C&B&A1&!A|!E&!D1&!D&!C1&C&B&A1&!A|!E&!D1&!D&!C1&C&!B&A1&!A|!E&D1&!D&!C1&C&!B&A1&!A|!E&D1&D&!C1&C&!B&A1&!A|!E&!D1&D&!C1&C&!B&A1&!A|!E&!D1&!D&C1&C&!B&A1&!A|!E&!D1&!D&C1&!C&!B&A1&!A|!E&D1&!D&C1&!C&!B&A1&!A|!E&D1&D&C1&!C&!B&A1&!A|!E&!D1&D&C1&!C&!B&A1&!A|!E&!D1&D&!C1&!C&!B&A1&!A|!E&D1&D&!C1&!C&!B&A1&!A|!E&D1&!D&!C1&!C&!B&A1&!A|!E&!D1&!D&!C1&!C&!B&A1&!A|!E&!D1&!D&!C1&!C&!B&A1&A|!E&D1&!D&!C1&!C&!B&A1&A|!E&D1&D&!C1&!C&!B&A1&A|!E&!D1&D&!C1&!C&!B&A1&A|!E&!D1&D&C1&!C&!B&A1&A|!E&D1&D&C1&!C&!B&A1&A|!E&D1&!D&C1&!C&!B&A1&A|!E&!D1&!D&C1&!C&!B&A1&A|!E&!D1&!D&C1&C&!B&A1&A|!E&!D1&D&!C1&C&!B&A1&A|!E&D1&D&!C1&C&!B&A1&A|!E&D1&!D&!C1&C&!B&A1&A|!E&!D1&!D&!C1&C&!B&A1&A|!E&!D1&!D&!C1&C&B&A1&A|!E&!D1&!D&C1&C&B&A1&A|!E&!D1&!D&C1&!C&B&A1&A|!E&!D1&!D&!C1&!C&B&A1&A|!E&!D1&!D&!C1&!C&B&!A1&A|!E&!D1&!D&C1&!C&B&!A1&A|!E&!D1&!D&C1&C&B&!A1&A|!E&!D1&!D&!C1&C&B&!A1&A|!E&!D1&!D&!C1&C&!B&!A1&A|!E&D1&!D&!C1&C&!B&!A1&A|!E&D1&D&!C1&C&!B&!A1&A|!E&!D1&D&!C1&C&!B&!A1&A|!E&!D1&!D&C1&C&!B&!A1&A|!E&!D1&!D&C1&!C&!B&!A1&A|!E&D1&!D&C1&!C&!B&!A1&A|!E&D1&D&C1&!C&!B&!A1&A|!E&!D1&D&C1&!C&!B&!A1&A|!E&!D1&D&!C1&!C&!B&!A1&A|!E&D1&D&!C1&!C&!B&!A1&A|!E&D1&!D&!C1&!C&!B&!A1&A|!E&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOAOI21221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAI331 -l OOAI331 -i C B2 B1 B A2 A1 A -o Y -f Y=!(C&!B2&!B1&B&A2&!A1&!A|C&B2&!B1&B&A2&!A1&!A|C&B2&B1&B&A2&!A1&!A|C&!B2&B1&B&A2&!A1&!A|C&!B2&B1&!B&A2&!A1&!A|C&B2&B1&!B&A2&!A1&!A|C&B2&!B1&!B&A2&!A1&!A|C&B2&!B1&!B&A2&A1&!A|C&B2&B1&!B&A2&A1&!A|C&!B2&B1&!B&A2&A1&!A|C&!B2&B1&B&A2&A1&!A|C&B2&B1&B&A2&A1&!A|C&B2&!B1&B&A2&A1&!A|C&!B2&!B1&B&A2&A1&!A|C&!B2&!B1&B&!A2&A1&!A|C&B2&!B1&B&!A2&A1&!A|C&B2&B1&B&!A2&A1&!A|C&!B2&B1&B&!A2&A1&!A|C&!B2&B1&!B&!A2&A1&!A|C&B2&B1&!B&!A2&A1&!A|C&B2&!B1&!B&!A2&A1&!A|C&B2&!B1&!B&!A2&A1&A|C&B2&B1&!B&!A2&A1&A|C&!B2&B1&!B&!A2&A1&A|C&!B2&B1&B&!A2&A1&A|C&B2&B1&B&!A2&A1&A|C&B2&!B1&B&!A2&A1&A|C&!B2&!B1&B&!A2&A1&A|C&!B2&!B1&B&A2&A1&A|C&B2&!B1&B&A2&A1&A|C&B2&B1&B&A2&A1&A|C&!B2&B1&B&A2&A1&A|C&!B2&B1&!B&A2&A1&A|C&B2&B1&!B&A2&A1&A|C&B2&!B1&!B&A2&A1&A|C&B2&!B1&!B&A2&!A1&A|C&B2&B1&!B&A2&!A1&A|C&!B2&B1&!B&A2&!A1&A|C&!B2&B1&B&A2&!A1&A|C&B2&B1&B&A2&!A1&A|C&B2&!B1&B&A2&!A1&A|C&!B2&!B1&B&A2&!A1&A|C&!B2&!B1&B&!A2&!A1&A|C&B2&!B1&B&!A2&!A1&A|C&B2&B1&B&!A2&!A1&A|C&!B2&B1&B&!A2&!A1&A|C&!B2&B1&!B&!A2&!A1&A|C&B2&B1&!B&!A2&!A1&A|C&B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAI331.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOOAI21122 -l OAOOOAI21122 -i E1 E D1 D C B A1 A -o Y -f Y=!(E1&!E&!D1&D&C&!B&!A1&!A|E1&E&!D1&D&C&!B&!A1&!A|!E1&E&!D1&D&C&!B&!A1&!A|!E1&E&D1&D&C&!B&!A1&!A|E1&E&D1&D&C&!B&!A1&!A|E1&!E&D1&D&C&!B&!A1&!A|E1&!E&D1&!D&C&!B&!A1&!A|E1&E&D1&!D&C&!B&!A1&!A|!E1&E&D1&!D&C&!B&!A1&!A|!E1&E&D1&!D&C&B&!A1&!A|E1&E&D1&!D&C&B&!A1&!A|E1&!E&D1&!D&C&B&!A1&!A|E1&!E&D1&D&C&B&!A1&!A|E1&E&D1&D&C&B&!A1&!A|!E1&E&D1&D&C&B&!A1&!A|!E1&E&!D1&D&C&B&!A1&!A|E1&E&!D1&D&C&B&!A1&!A|E1&!E&!D1&D&C&B&!A1&!A|!E1&E&D1&!D&!C&B&A1&!A|E1&E&D1&!D&!C&B&A1&!A|E1&!E&D1&!D&!C&B&A1&!A|E1&!E&D1&D&!C&B&A1&!A|E1&E&D1&D&!C&B&A1&!A|!E1&E&D1&D&!C&B&A1&!A|!E1&E&!D1&D&!C&B&A1&!A|E1&E&!D1&D&!C&B&A1&!A|E1&!E&!D1&D&!C&B&A1&!A|E1&!E&!D1&D&C&B&A1&!A|E1&E&!D1&D&C&B&A1&!A|!E1&E&!D1&D&C&B&A1&!A|!E1&E&D1&D&C&B&A1&!A|E1&E&D1&D&C&B&A1&!A|E1&!E&D1&D&C&B&A1&!A|E1&!E&D1&!D&C&B&A1&!A|E1&E&D1&!D&C&B&A1&!A|!E1&E&D1&!D&C&B&A1&!A|!E1&E&D1&!D&C&!B&A1&!A|E1&E&D1&!D&C&!B&A1&!A|E1&!E&D1&!D&C&!B&A1&!A|E1&!E&D1&D&C&!B&A1&!A|E1&E&D1&D&C&!B&A1&!A|!E1&E&D1&D&C&!B&A1&!A|!E1&E&!D1&D&C&!B&A1&!A|E1&E&!D1&D&C&!B&A1&!A|E1&!E&!D1&D&C&!B&A1&!A|E1&!E&!D1&D&C&!B&A1&A|E1&E&!D1&D&C&!B&A1&A|!E1&E&!D1&D&C&!B&A1&A|!E1&E&D1&D&C&!B&A1&A|E1&E&D1&D&C&!B&A1&A|E1&!E&D1&D&C&!B&A1&A|E1&!E&D1&!D&C&!B&A1&A|E1&E&D1&!D&C&!B&A1&A|!E1&E&D1&!D&C&!B&A1&A|!E1&E&D1&!D&C&B&A1&A|E1&E&D1&!D&C&B&A1&A|E1&!E&D1&!D&C&B&A1&A|E1&!E&D1&D&C&B&A1&A|E1&E&D1&D&C&B&A1&A|!E1&E&D1&D&C&B&A1&A|!E1&E&!D1&D&C&B&A1&A|E1&E&!D1&D&C&B&A1&A|E1&!E&!D1&D&C&B&A1&A|E1&!E&!D1&D&!C&B&A1&A|E1&E&!D1&D&!C&B&A1&A|!E1&E&!D1&D&!C&B&A1&A|!E1&E&D1&D&!C&B&A1&A|E1&E&D1&D&!C&B&A1&A|E1&!E&D1&D&!C&B&A1&A|E1&!E&D1&!D&!C&B&A1&A|E1&E&D1&!D&!C&B&A1&A|!E1&E&D1&!D&!C&B&A1&A|!E1&E&D1&!D&!C&B&!A1&A|E1&E&D1&!D&!C&B&!A1&A|E1&!E&D1&!D&!C&B&!A1&A|E1&!E&D1&D&!C&B&!A1&A|E1&E&D1&D&!C&B&!A1&A|!E1&E&D1&D&!C&B&!A1&A|!E1&E&!D1&D&!C&B&!A1&A|E1&E&!D1&D&!C&B&!A1&A|E1&!E&!D1&D&!C&B&!A1&A|E1&!E&!D1&D&C&B&!A1&A|E1&E&!D1&D&C&B&!A1&A|!E1&E&!D1&D&C&B&!A1&A|!E1&E&D1&D&C&B&!A1&A|E1&E&D1&D&C&B&!A1&A|E1&!E&D1&D&C&B&!A1&A|E1&!E&D1&!D&C&B&!A1&A|E1&E&D1&!D&C&B&!A1&A|!E1&E&D1&!D&C&B&!A1&A|!E1&E&D1&!D&C&!B&!A1&A|E1&E&D1&!D&C&!B&!A1&A|E1&!E&D1&!D&C&!B&!A1&A|E1&!E&D1&D&C&!B&!A1&A|E1&E&D1&D&C&!B&!A1&A|!E1&E&D1&D&C&!B&!A1&A|!E1&E&!D1&D&C&!B&!A1&A|E1&E&!D1&D&C&!B&!A1&A|E1&!E&!D1&D&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOOAI21122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAI214 -l AOOAI214 -i C3 C2 C1 C B A1 A -o Y -f Y=(!C3&!C2&!C1&!C&!B&!A1&!A|C3&!C2&!C1&!C&!B&!A1&!A|C3&C2&!C1&!C&!B&!A1&!A|!C3&C2&!C1&!C&!B&!A1&!A|!C3&C2&C1&!C&!B&!A1&!A|C3&C2&C1&!C&!B&!A1&!A|C3&!C2&C1&!C&!B&!A1&!A|!C3&!C2&C1&!C&!B&!A1&!A|!C3&!C2&C1&C&!B&!A1&!A|C3&!C2&C1&C&!B&!A1&!A|C3&C2&C1&C&!B&!A1&!A|!C3&C2&C1&C&!B&!A1&!A|!C3&C2&!C1&C&!B&!A1&!A|C3&C2&!C1&C&!B&!A1&!A|C3&!C2&!C1&C&!B&!A1&!A|!C3&!C2&!C1&C&!B&!A1&!A|!C3&!C2&!C1&!C&B&!A1&!A|!C3&!C2&!C1&!C&B&A1&!A|!C3&!C2&!C1&C&!B&A1&!A|C3&!C2&!C1&C&!B&A1&!A|C3&C2&!C1&C&!B&A1&!A|!C3&C2&!C1&C&!B&A1&!A|!C3&C2&C1&C&!B&A1&!A|C3&C2&C1&C&!B&A1&!A|C3&!C2&C1&C&!B&A1&!A|!C3&!C2&C1&C&!B&A1&!A|!C3&!C2&C1&!C&!B&A1&!A|C3&!C2&C1&!C&!B&A1&!A|C3&C2&C1&!C&!B&A1&!A|!C3&C2&C1&!C&!B&A1&!A|!C3&C2&!C1&!C&!B&A1&!A|C3&C2&!C1&!C&!B&A1&!A|C3&!C2&!C1&!C&!B&A1&!A|!C3&!C2&!C1&!C&!B&A1&!A|!C3&!C2&!C1&!C&!B&A1&A|!C3&!C2&!C1&!C&B&A1&A|!C3&!C2&!C1&!C&B&!A1&A|!C3&!C2&!C1&C&!B&!A1&A|C3&!C2&!C1&C&!B&!A1&A|C3&C2&!C1&C&!B&!A1&A|!C3&C2&!C1&C&!B&!A1&A|!C3&C2&C1&C&!B&!A1&A|C3&C2&C1&C&!B&!A1&A|C3&!C2&C1&C&!B&!A1&A|!C3&!C2&C1&C&!B&!A1&A|!C3&!C2&C1&!C&!B&!A1&A|C3&!C2&C1&!C&!B&!A1&A|C3&C2&C1&!C&!B&!A1&A|!C3&C2&C1&!C&!B&!A1&A|!C3&C2&!C1&!C&!B&!A1&A|C3&C2&!C1&!C&!B&!A1&A|C3&!C2&!C1&!C&!B&!A1&A|!C3&!C2&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAI214.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOAOAI212311 -l OAAOOAOAI212311 -i F E D2 D1 D C1 C B A1 A -o Y -f Y=!(F&E&!D2&!D1&!D&!C1&!C&!B&!A1&!A|F&E&D2&!D1&!D&!C1&!C&!B&!A1&!A|F&E&D2&D1&!D&!C1&!C&!B&!A1&!A|F&E&!D2&D1&!D&!C1&!C&!B&!A1&!A|F&E&!D2&D1&D&!C1&!C&!B&!A1&!A|F&E&D2&D1&D&!C1&!C&!B&!A1&!A|F&E&D2&!D1&D&!C1&!C&!B&!A1&!A|F&E&!D2&!D1&D&!C1&!C&!B&!A1&!A|F&E&!D2&!D1&D&C1&!C&!B&!A1&!A|F&E&D2&!D1&D&C1&!C&!B&!A1&!A|F&E&D2&D1&D&C1&!C&!B&!A1&!A|F&E&!D2&D1&D&C1&!C&!B&!A1&!A|F&E&!D2&D1&!D&C1&!C&!B&!A1&!A|F&E&D2&D1&!D&C1&!C&!B&!A1&!A|F&E&D2&!D1&!D&C1&!C&!B&!A1&!A|F&E&!D2&!D1&!D&C1&!C&!B&!A1&!A|F&E&!D2&!D1&!D&C1&C&!B&!A1&!A|F&E&D2&!D1&!D&C1&C&!B&!A1&!A|F&!E&D2&!D1&!D&C1&C&!B&!A1&!A|F&!E&D2&D1&!D&C1&C&!B&!A1&!A|F&E&D2&D1&!D&C1&C&!B&!A1&!A|F&E&!D2&D1&!D&C1&C&!B&!A1&!A|F&!E&!D2&D1&!D&C1&C&!B&!A1&!A|F&!E&!D2&D1&D&C1&C&!B&!A1&!A|F&E&!D2&D1&D&C1&C&!B&!A1&!A|F&E&D2&D1&D&C1&C&!B&!A1&!A|F&!E&D2&D1&D&C1&C&!B&!A1&!A|F&!E&D2&!D1&D&C1&C&!B&!A1&!A|F&E&D2&!D1&D&C1&C&!B&!A1&!A|F&E&!D2&!D1&D&C1&C&!B&!A1&!A|F&!E&!D2&!D1&D&C1&C&!B&!A1&!A|F&E&!D2&!D1&D&!C1&C&!B&!A1&!A|F&E&D2&!D1&D&!C1&C&!B&!A1&!A|F&E&D2&D1&D&!C1&C&!B&!A1&!A|F&E&!D2&D1&D&!C1&C&!B&!A1&!A|F&E&!D2&D1&!D&!C1&C&!B&!A1&!A|F&E&D2&D1&!D&!C1&C&!B&!A1&!A|F&E&D2&!D1&!D&!C1&C&!B&!A1&!A|F&E&!D2&!D1&!D&!C1&C&!B&!A1&!A|F&E&!D2&!D1&!D&!C1&C&B&!A1&!A|F&E&D2&!D1&!D&!C1&C&B&!A1&!A|F&E&D2&D1&!D&!C1&C&B&!A1&!A|F&E&!D2&D1&!D&!C1&C&B&!A1&!A|F&E&!D2&D1&D&!C1&C&B&!A1&!A|F&E&D2&D1&D&!C1&C&B&!A1&!A|F&E&D2&!D1&D&!C1&C&B&!A1&!A|F&E&!D2&!D1&D&!C1&C&B&!A1&!A|F&!E&!D2&!D1&D&C1&C&B&!A1&!A|F&E&!D2&!D1&D&C1&C&B&!A1&!A|F&E&D2&!D1&D&C1&C&B&!A1&!A|F&!E&D2&!D1&D&C1&C&B&!A1&!A|F&!E&D2&D1&D&C1&C&B&!A1&!A|F&E&D2&D1&D&C1&C&B&!A1&!A|F&E&!D2&D1&D&C1&C&B&!A1&!A|F&!E&!D2&D1&D&C1&C&B&!A1&!A|F&!E&!D2&D1&!D&C1&C&B&!A1&!A|F&E&!D2&D1&!D&C1&C&B&!A1&!A|F&E&D2&D1&!D&C1&C&B&!A1&!A|F&!E&D2&D1&!D&C1&C&B&!A1&!A|F&!E&D2&!D1&!D&C1&C&B&!A1&!A|F&E&D2&!D1&!D&C1&C&B&!A1&!A|F&E&!D2&!D1&!D&C1&C&B&!A1&!A|F&E&!D2&!D1&!D&C1&!C&B&!A1&!A|F&E&D2&!D1&!D&C1&!C&B&!A1&!A|F&E&D2&D1&!D&C1&!C&B&!A1&!A|F&E&!D2&D1&!D&C1&!C&B&!A1&!A|F&E&!D2&D1&D&C1&!C&B&!A1&!A|F&E&D2&D1&D&C1&!C&B&!A1&!A|F&E&D2&!D1&D&C1&!C&B&!A1&!A|F&E&!D2&!D1&D&C1&!C&B&!A1&!A|F&E&!D2&!D1&D&!C1&!C&B&!A1&!A|F&E&D2&!D1&D&!C1&!C&B&!A1&!A|F&E&D2&D1&D&!C1&!C&B&!A1&!A|F&E&!D2&D1&D&!C1&!C&B&!A1&!A|F&E&!D2&D1&!D&!C1&!C&B&!A1&!A|F&E&D2&D1&!D&!C1&!C&B&!A1&!A|F&E&D2&!D1&!D&!C1&!C&B&!A1&!A|F&E&!D2&!D1&!D&!C1&!C&B&!A1&!A|F&E&!D2&!D1&!D&!C1&!C&B&A1&!A|F&E&D2&!D1&!D&!C1&!C&B&A1&!A|F&!E&D2&!D1&!D&!C1&!C&B&A1&!A|F&!E&D2&D1&!D&!C1&!C&B&A1&!A|F&E&D2&D1&!D&!C1&!C&B&A1&!A|F&E&!D2&D1&!D&!C1&!C&B&A1&!A|F&!E&!D2&D1&!D&!C1&!C&B&A1&!A|F&!E&!D2&D1&D&!C1&!C&B&A1&!A|F&E&!D2&D1&D&!C1&!C&B&A1&!A|F&E&D2&D1&D&!C1&!C&B&A1&!A|F&!E&D2&D1&D&!C1&!C&B&A1&!A|F&!E&D2&!D1&D&!C1&!C&B&A1&!A|F&E&D2&!D1&D&!C1&!C&B&A1&!A|F&E&!D2&!D1&D&!C1&!C&B&A1&!A|F&!E&!D2&!D1&D&!C1&!C&B&A1&!A|F&!E&!D2&!D1&D&C1&!C&B&A1&!A|F&E&!D2&!D1&D&C1&!C&B&A1&!A|F&E&D2&!D1&D&C1&!C&B&A1&!A|F&!E&D2&!D1&D&C1&!C&B&A1&!A|F&!E&D2&D1&D&C1&!C&B&A1&!A|F&E&D2&D1&D&C1&!C&B&A1&!A|F&E&!D2&D1&D&C1&!C&B&A1&!A|F&!E&!D2&D1&D&C1&!C&B&A1&!A|F&!E&!D2&D1&!D&C1&!C&B&A1&!A|F&E&!D2&D1&!D&C1&!C&B&A1&!A|F&E&D2&D1&!D&C1&!C&B&A1&!A|F&!E&D2&D1&!D&C1&!C&B&A1&!A|F&!E&D2&!D1&!D&C1&!C&B&A1&!A|F&E&D2&!D1&!D&C1&!C&B&A1&!A|F&E&!D2&!D1&!D&C1&!C&B&A1&!A|F&E&!D2&!D1&!D&C1&C&B&A1&!A|F&E&D2&!D1&!D&C1&C&B&A1&!A|F&!E&D2&!D1&!D&C1&C&B&A1&!A|F&!E&D2&D1&!D&C1&C&B&A1&!A|F&E&D2&D1&!D&C1&C&B&A1&!A|F&E&!D2&D1&!D&C1&C&B&A1&!A|F&!E&!D2&D1&!D&C1&C&B&A1&!A|F&!E&!D2&D1&D&C1&C&B&A1&!A|F&E&!D2&D1&D&C1&C&B&A1&!A|F&E&D2&D1&D&C1&C&B&A1&!A|F&!E&D2&D1&D&C1&C&B&A1&!A|F&!E&D2&!D1&D&C1&C&B&A1&!A|F&E&D2&!D1&D&C1&C&B&A1&!A|F&E&!D2&!D1&D&C1&C&B&A1&!A|F&!E&!D2&!D1&D&C1&C&B&A1&!A|F&!E&!D2&!D1&D&!C1&C&B&A1&!A|F&E&!D2&!D1&D&!C1&C&B&A1&!A|F&E&D2&!D1&D&!C1&C&B&A1&!A|F&!E&D2&!D1&D&!C1&C&B&A1&!A|F&!E&D2&D1&D&!C1&C&B&A1&!A|F&E&D2&D1&D&!C1&C&B&A1&!A|F&E&!D2&D1&D&!C1&C&B&A1&!A|F&!E&!D2&D1&D&!C1&C&B&A1&!A|F&!E&!D2&D1&!D&!C1&C&B&A1&!A|F&E&!D2&D1&!D&!C1&C&B&A1&!A|F&E&D2&D1&!D&!C1&C&B&A1&!A|F&!E&D2&D1&!D&!C1&C&B&A1&!A|F&!E&D2&!D1&!D&!C1&C&B&A1&!A|F&E&D2&!D1&!D&!C1&C&B&A1&!A|F&E&!D2&!D1&!D&!C1&C&B&A1&!A|F&E&!D2&!D1&!D&!C1&C&!B&A1&!A|F&E&D2&!D1&!D&!C1&C&!B&A1&!A|F&E&D2&D1&!D&!C1&C&!B&A1&!A|F&E&!D2&D1&!D&!C1&C&!B&A1&!A|F&E&!D2&D1&D&!C1&C&!B&A1&!A|F&E&D2&D1&D&!C1&C&!B&A1&!A|F&E&D2&!D1&D&!C1&C&!B&A1&!A|F&E&!D2&!D1&D&!C1&C&!B&A1&!A|F&!E&!D2&!D1&D&C1&C&!B&A1&!A|F&E&!D2&!D1&D&C1&C&!B&A1&!A|F&E&D2&!D1&D&C1&C&!B&A1&!A|F&!E&D2&!D1&D&C1&C&!B&A1&!A|F&!E&D2&D1&D&C1&C&!B&A1&!A|F&E&D2&D1&D&C1&C&!B&A1&!A|F&E&!D2&D1&D&C1&C&!B&A1&!A|F&!E&!D2&D1&D&C1&C&!B&A1&!A|F&!E&!D2&D1&!D&C1&C&!B&A1&!A|F&E&!D2&D1&!D&C1&C&!B&A1&!A|F&E&D2&D1&!D&C1&C&!B&A1&!A|F&!E&D2&D1&!D&C1&C&!B&A1&!A|F&!E&D2&!D1&!D&C1&C&!B&A1&!A|F&E&D2&!D1&!D&C1&C&!B&A1&!A|F&E&!D2&!D1&!D&C1&C&!B&A1&!A|F&E&!D2&!D1&!D&C1&!C&!B&A1&!A|F&E&D2&!D1&!D&C1&!C&!B&A1&!A|F&E&D2&D1&!D&C1&!C&!B&A1&!A|F&E&!D2&D1&!D&C1&!C&!B&A1&!A|F&E&!D2&D1&D&C1&!C&!B&A1&!A|F&E&D2&D1&D&C1&!C&!B&A1&!A|F&E&D2&!D1&D&C1&!C&!B&A1&!A|F&E&!D2&!D1&D&C1&!C&!B&A1&!A|F&E&!D2&!D1&D&!C1&!C&!B&A1&!A|F&E&D2&!D1&D&!C1&!C&!B&A1&!A|F&E&D2&D1&D&!C1&!C&!B&A1&!A|F&E&!D2&D1&D&!C1&!C&!B&A1&!A|F&E&!D2&D1&!D&!C1&!C&!B&A1&!A|F&E&D2&D1&!D&!C1&!C&!B&A1&!A|F&E&D2&!D1&!D&!C1&!C&!B&A1&!A|F&E&!D2&!D1&!D&!C1&!C&!B&A1&!A|F&E&!D2&!D1&!D&!C1&!C&!B&A1&A|F&E&D2&!D1&!D&!C1&!C&!B&A1&A|F&E&D2&D1&!D&!C1&!C&!B&A1&A|F&E&!D2&D1&!D&!C1&!C&!B&A1&A|F&E&!D2&D1&D&!C1&!C&!B&A1&A|F&E&D2&D1&D&!C1&!C&!B&A1&A|F&E&D2&!D1&D&!C1&!C&!B&A1&A|F&E&!D2&!D1&D&!C1&!C&!B&A1&A|F&E&!D2&!D1&D&C1&!C&!B&A1&A|F&E&D2&!D1&D&C1&!C&!B&A1&A|F&E&D2&D1&D&C1&!C&!B&A1&A|F&E&!D2&D1&D&C1&!C&!B&A1&A|F&E&!D2&D1&!D&C1&!C&!B&A1&A|F&E&D2&D1&!D&C1&!C&!B&A1&A|F&E&D2&!D1&!D&C1&!C&!B&A1&A|F&E&!D2&!D1&!D&C1&!C&!B&A1&A|F&E&!D2&!D1&!D&C1&C&!B&A1&A|F&E&D2&!D1&!D&C1&C&!B&A1&A|F&!E&D2&!D1&!D&C1&C&!B&A1&A|F&!E&D2&D1&!D&C1&C&!B&A1&A|F&E&D2&D1&!D&C1&C&!B&A1&A|F&E&!D2&D1&!D&C1&C&!B&A1&A|F&!E&!D2&D1&!D&C1&C&!B&A1&A|F&!E&!D2&D1&D&C1&C&!B&A1&A|F&E&!D2&D1&D&C1&C&!B&A1&A|F&E&D2&D1&D&C1&C&!B&A1&A|F&!E&D2&D1&D&C1&C&!B&A1&A|F&!E&D2&!D1&D&C1&C&!B&A1&A|F&E&D2&!D1&D&C1&C&!B&A1&A|F&E&!D2&!D1&D&C1&C&!B&A1&A|F&!E&!D2&!D1&D&C1&C&!B&A1&A|F&E&!D2&!D1&D&!C1&C&!B&A1&A|F&E&D2&!D1&D&!C1&C&!B&A1&A|F&E&D2&D1&D&!C1&C&!B&A1&A|F&E&!D2&D1&D&!C1&C&!B&A1&A|F&E&!D2&D1&!D&!C1&C&!B&A1&A|F&E&D2&D1&!D&!C1&C&!B&A1&A|F&E&D2&!D1&!D&!C1&C&!B&A1&A|F&E&!D2&!D1&!D&!C1&C&!B&A1&A|F&E&!D2&!D1&!D&!C1&C&B&A1&A|F&E&D2&!D1&!D&!C1&C&B&A1&A|F&!E&D2&!D1&!D&!C1&C&B&A1&A|F&!E&D2&D1&!D&!C1&C&B&A1&A|F&E&D2&D1&!D&!C1&C&B&A1&A|F&E&!D2&D1&!D&!C1&C&B&A1&A|F&!E&!D2&D1&!D&!C1&C&B&A1&A|F&!E&!D2&D1&D&!C1&C&B&A1&A|F&E&!D2&D1&D&!C1&C&B&A1&A|F&E&D2&D1&D&!C1&C&B&A1&A|F&!E&D2&D1&D&!C1&C&B&A1&A|F&!E&D2&!D1&D&!C1&C&B&A1&A|F&E&D2&!D1&D&!C1&C&B&A1&A|F&E&!D2&!D1&D&!C1&C&B&A1&A|F&!E&!D2&!D1&D&!C1&C&B&A1&A|F&!E&!D2&!D1&D&C1&C&B&A1&A|F&E&!D2&!D1&D&C1&C&B&A1&A|F&E&D2&!D1&D&C1&C&B&A1&A|F&!E&D2&!D1&D&C1&C&B&A1&A|F&!E&D2&D1&D&C1&C&B&A1&A|F&E&D2&D1&D&C1&C&B&A1&A|F&E&!D2&D1&D&C1&C&B&A1&A|F&!E&!D2&D1&D&C1&C&B&A1&A|F&!E&!D2&D1&!D&C1&C&B&A1&A|F&E&!D2&D1&!D&C1&C&B&A1&A|F&E&D2&D1&!D&C1&C&B&A1&A|F&!E&D2&D1&!D&C1&C&B&A1&A|F&!E&D2&!D1&!D&C1&C&B&A1&A|F&E&D2&!D1&!D&C1&C&B&A1&A|F&E&!D2&!D1&!D&C1&C&B&A1&A|F&E&!D2&!D1&!D&C1&!C&B&A1&A|F&E&D2&!D1&!D&C1&!C&B&A1&A|F&!E&D2&!D1&!D&C1&!C&B&A1&A|F&!E&D2&D1&!D&C1&!C&B&A1&A|F&E&D2&D1&!D&C1&!C&B&A1&A|F&E&!D2&D1&!D&C1&!C&B&A1&A|F&!E&!D2&D1&!D&C1&!C&B&A1&A|F&!E&!D2&D1&D&C1&!C&B&A1&A|F&E&!D2&D1&D&C1&!C&B&A1&A|F&E&D2&D1&D&C1&!C&B&A1&A|F&!E&D2&D1&D&C1&!C&B&A1&A|F&!E&D2&!D1&D&C1&!C&B&A1&A|F&E&D2&!D1&D&C1&!C&B&A1&A|F&E&!D2&!D1&D&C1&!C&B&A1&A|F&!E&!D2&!D1&D&C1&!C&B&A1&A|F&!E&!D2&!D1&D&!C1&!C&B&A1&A|F&E&!D2&!D1&D&!C1&!C&B&A1&A|F&E&D2&!D1&D&!C1&!C&B&A1&A|F&!E&D2&!D1&D&!C1&!C&B&A1&A|F&!E&D2&D1&D&!C1&!C&B&A1&A|F&E&D2&D1&D&!C1&!C&B&A1&A|F&E&!D2&D1&D&!C1&!C&B&A1&A|F&!E&!D2&D1&D&!C1&!C&B&A1&A|F&!E&!D2&D1&!D&!C1&!C&B&A1&A|F&E&!D2&D1&!D&!C1&!C&B&A1&A|F&E&D2&D1&!D&!C1&!C&B&A1&A|F&!E&D2&D1&!D&!C1&!C&B&A1&A|F&!E&D2&!D1&!D&!C1&!C&B&A1&A|F&E&D2&!D1&!D&!C1&!C&B&A1&A|F&E&!D2&!D1&!D&!C1&!C&B&A1&A|F&E&!D2&!D1&!D&!C1&!C&B&!A1&A|F&E&D2&!D1&!D&!C1&!C&B&!A1&A|F&!E&D2&!D1&!D&!C1&!C&B&!A1&A|F&!E&D2&D1&!D&!C1&!C&B&!A1&A|F&E&D2&D1&!D&!C1&!C&B&!A1&A|F&E&!D2&D1&!D&!C1&!C&B&!A1&A|F&!E&!D2&D1&!D&!C1&!C&B&!A1&A|F&!E&!D2&D1&D&!C1&!C&B&!A1&A|F&E&!D2&D1&D&!C1&!C&B&!A1&A|F&E&D2&D1&D&!C1&!C&B&!A1&A|F&!E&D2&D1&D&!C1&!C&B&!A1&A|F&!E&D2&!D1&D&!C1&!C&B&!A1&A|F&E&D2&!D1&D&!C1&!C&B&!A1&A|F&E&!D2&!D1&D&!C1&!C&B&!A1&A|F&!E&!D2&!D1&D&!C1&!C&B&!A1&A|F&!E&!D2&!D1&D&C1&!C&B&!A1&A|F&E&!D2&!D1&D&C1&!C&B&!A1&A|F&E&D2&!D1&D&C1&!C&B&!A1&A|F&!E&D2&!D1&D&C1&!C&B&!A1&A|F&!E&D2&D1&D&C1&!C&B&!A1&A|F&E&D2&D1&D&C1&!C&B&!A1&A|F&E&!D2&D1&D&C1&!C&B&!A1&A|F&!E&!D2&D1&D&C1&!C&B&!A1&A|F&!E&!D2&D1&!D&C1&!C&B&!A1&A|F&E&!D2&D1&!D&C1&!C&B&!A1&A|F&E&D2&D1&!D&C1&!C&B&!A1&A|F&!E&D2&D1&!D&C1&!C&B&!A1&A|F&!E&D2&!D1&!D&C1&!C&B&!A1&A|F&E&D2&!D1&!D&C1&!C&B&!A1&A|F&E&!D2&!D1&!D&C1&!C&B&!A1&A|F&E&!D2&!D1&!D&C1&C&B&!A1&A|F&E&D2&!D1&!D&C1&C&B&!A1&A|F&!E&D2&!D1&!D&C1&C&B&!A1&A|F&!E&D2&D1&!D&C1&C&B&!A1&A|F&E&D2&D1&!D&C1&C&B&!A1&A|F&E&!D2&D1&!D&C1&C&B&!A1&A|F&!E&!D2&D1&!D&C1&C&B&!A1&A|F&!E&!D2&D1&D&C1&C&B&!A1&A|F&E&!D2&D1&D&C1&C&B&!A1&A|F&E&D2&D1&D&C1&C&B&!A1&A|F&!E&D2&D1&D&C1&C&B&!A1&A|F&!E&D2&!D1&D&C1&C&B&!A1&A|F&E&D2&!D1&D&C1&C&B&!A1&A|F&E&!D2&!D1&D&C1&C&B&!A1&A|F&!E&!D2&!D1&D&C1&C&B&!A1&A|F&!E&!D2&!D1&D&!C1&C&B&!A1&A|F&E&!D2&!D1&D&!C1&C&B&!A1&A|F&E&D2&!D1&D&!C1&C&B&!A1&A|F&!E&D2&!D1&D&!C1&C&B&!A1&A|F&!E&D2&D1&D&!C1&C&B&!A1&A|F&E&D2&D1&D&!C1&C&B&!A1&A|F&E&!D2&D1&D&!C1&C&B&!A1&A|F&!E&!D2&D1&D&!C1&C&B&!A1&A|F&!E&!D2&D1&!D&!C1&C&B&!A1&A|F&E&!D2&D1&!D&!C1&C&B&!A1&A|F&E&D2&D1&!D&!C1&C&B&!A1&A|F&!E&D2&D1&!D&!C1&C&B&!A1&A|F&!E&D2&!D1&!D&!C1&C&B&!A1&A|F&E&D2&!D1&!D&!C1&C&B&!A1&A|F&E&!D2&!D1&!D&!C1&C&B&!A1&A|F&E&!D2&!D1&!D&!C1&C&!B&!A1&A|F&E&D2&!D1&!D&!C1&C&!B&!A1&A|F&E&D2&D1&!D&!C1&C&!B&!A1&A|F&E&!D2&D1&!D&!C1&C&!B&!A1&A|F&E&!D2&D1&D&!C1&C&!B&!A1&A|F&E&D2&D1&D&!C1&C&!B&!A1&A|F&E&D2&!D1&D&!C1&C&!B&!A1&A|F&E&!D2&!D1&D&!C1&C&!B&!A1&A|F&!E&!D2&!D1&D&C1&C&!B&!A1&A|F&E&!D2&!D1&D&C1&C&!B&!A1&A|F&E&D2&!D1&D&C1&C&!B&!A1&A|F&!E&D2&!D1&D&C1&C&!B&!A1&A|F&!E&D2&D1&D&C1&C&!B&!A1&A|F&E&D2&D1&D&C1&C&!B&!A1&A|F&E&!D2&D1&D&C1&C&!B&!A1&A|F&!E&!D2&D1&D&C1&C&!B&!A1&A|F&!E&!D2&D1&!D&C1&C&!B&!A1&A|F&E&!D2&D1&!D&C1&C&!B&!A1&A|F&E&D2&D1&!D&C1&C&!B&!A1&A|F&!E&D2&D1&!D&C1&C&!B&!A1&A|F&!E&D2&!D1&!D&C1&C&!B&!A1&A|F&E&D2&!D1&!D&C1&C&!B&!A1&A|F&E&!D2&!D1&!D&C1&C&!B&!A1&A|F&E&!D2&!D1&!D&C1&!C&!B&!A1&A|F&E&D2&!D1&!D&C1&!C&!B&!A1&A|F&E&D2&D1&!D&C1&!C&!B&!A1&A|F&E&!D2&D1&!D&C1&!C&!B&!A1&A|F&E&!D2&D1&D&C1&!C&!B&!A1&A|F&E&D2&D1&D&C1&!C&!B&!A1&A|F&E&D2&!D1&D&C1&!C&!B&!A1&A|F&E&!D2&!D1&D&C1&!C&!B&!A1&A|F&E&!D2&!D1&D&!C1&!C&!B&!A1&A|F&E&D2&!D1&D&!C1&!C&!B&!A1&A|F&E&D2&D1&D&!C1&!C&!B&!A1&A|F&E&!D2&D1&D&!C1&!C&!B&!A1&A|F&E&!D2&D1&!D&!C1&!C&!B&!A1&A|F&E&D2&D1&!D&!C1&!C&!B&!A1&A|F&E&D2&!D1&!D&!C1&!C&!B&!A1&A|F&E&!D2&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOAOAI212311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAI2121 -l AOOAI2121 -i D C1 C B A1 A -o Y -f Y=!(D&!C1&C&B&!A1&!A|D&C1&C&B&!A1&!A|D&C1&!C&B&!A1&!A|D&C1&!C&B&A1&!A|D&C1&C&B&A1&!A|D&!C1&C&B&A1&!A|D&C1&!C&!B&A1&A|D&C1&C&!B&A1&A|D&!C1&C&!B&A1&A|D&!C1&C&B&A1&A|D&C1&C&B&A1&A|D&C1&!C&B&A1&A|D&C1&!C&B&!A1&A|D&C1&C&B&!A1&A|D&!C1&C&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAI2121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAOI22111 -l AAOAOI22111 -i E D C B1 B A1 A -o Y -f Y=(!E&!D&!C&!B1&!B&!A1&!A|!E&D&!C&!B1&!B&!A1&!A|!E&!D&C&!B1&!B&!A1&!A|!E&!D&C&B1&!B&!A1&!A|!E&D&!C&B1&!B&!A1&!A|!E&!D&!C&B1&!B&!A1&!A|!E&!D&!C&B1&B&!A1&!A|!E&!D&C&B1&B&!A1&!A|!E&!D&C&!B1&B&!A1&!A|!E&D&!C&!B1&B&!A1&!A|!E&!D&!C&!B1&B&!A1&!A|!E&!D&!C&!B1&B&A1&!A|!E&D&!C&!B1&B&A1&!A|!E&!D&C&!B1&B&A1&!A|!E&!D&C&B1&B&A1&!A|!E&!D&!C&B1&B&A1&!A|!E&!D&!C&B1&!B&A1&!A|!E&D&!C&B1&!B&A1&!A|!E&!D&C&B1&!B&A1&!A|!E&!D&C&!B1&!B&A1&!A|!E&D&!C&!B1&!B&A1&!A|!E&!D&!C&!B1&!B&A1&!A|!E&!D&!C&!B1&!B&A1&A|!E&!D&C&!B1&!B&A1&A|!E&!D&C&B1&!B&A1&A|!E&!D&!C&B1&!B&A1&A|!E&!D&!C&B1&B&A1&A|!E&!D&C&B1&B&A1&A|!E&!D&C&!B1&B&A1&A|!E&!D&!C&!B1&B&A1&A|!E&!D&!C&!B1&B&!A1&A|!E&D&!C&!B1&B&!A1&A|!E&!D&C&!B1&B&!A1&A|!E&!D&C&B1&B&!A1&A|!E&!D&!C&B1&B&!A1&A|!E&!D&!C&B1&!B&!A1&A|!E&D&!C&B1&!B&!A1&A|!E&!D&C&B1&!B&!A1&A|!E&!D&C&!B1&!B&!A1&A|!E&D&!C&!B1&!B&!A1&A|!E&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAOI22111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAAOI2232 -l AAOOAAOI2232 -i D1 D C2 C1 C B1 B A1 A -o Y -f Y=(!D1&!D&!C2&!C1&!C&!B1&!B&!A1&!A|D1&!D&!C2&!C1&!C&!B1&!B&!A1&!A|!D1&D&!C2&!C1&!C&!B1&!B&!A1&!A|!D1&D&C2&!C1&!C&!B1&!B&!A1&!A|D1&!D&C2&!C1&!C&!B1&!B&!A1&!A|!D1&!D&C2&!C1&!C&!B1&!B&!A1&!A|!D1&!D&C2&C1&!C&!B1&!B&!A1&!A|D1&!D&C2&C1&!C&!B1&!B&!A1&!A|!D1&D&C2&C1&!C&!B1&!B&!A1&!A|!D1&D&!C2&C1&!C&!B1&!B&!A1&!A|D1&!D&!C2&C1&!C&!B1&!B&!A1&!A|!D1&!D&!C2&C1&!C&!B1&!B&!A1&!A|!D1&!D&!C2&C1&C&!B1&!B&!A1&!A|D1&!D&!C2&C1&C&!B1&!B&!A1&!A|!D1&D&!C2&C1&C&!B1&!B&!A1&!A|!D1&D&C2&C1&C&!B1&!B&!A1&!A|D1&!D&C2&C1&C&!B1&!B&!A1&!A|!D1&!D&C2&C1&C&!B1&!B&!A1&!A|!D1&!D&C2&!C1&C&!B1&!B&!A1&!A|D1&!D&C2&!C1&C&!B1&!B&!A1&!A|!D1&D&C2&!C1&C&!B1&!B&!A1&!A|!D1&D&!C2&!C1&C&!B1&!B&!A1&!A|D1&!D&!C2&!C1&C&!B1&!B&!A1&!A|!D1&!D&!C2&!C1&C&!B1&!B&!A1&!A|!D1&!D&!C2&!C1&C&B1&!B&!A1&!A|D1&!D&!C2&!C1&C&B1&!B&!A1&!A|!D1&D&!C2&!C1&C&B1&!B&!A1&!A|!D1&D&C2&!C1&C&B1&!B&!A1&!A|D1&!D&C2&!C1&C&B1&!B&!A1&!A|!D1&!D&C2&!C1&C&B1&!B&!A1&!A|!D1&!D&C2&C1&C&B1&!B&!A1&!A|D1&!D&C2&C1&C&B1&!B&!A1&!A|!D1&D&C2&C1&C&B1&!B&!A1&!A|!D1&D&!C2&C1&C&B1&!B&!A1&!A|D1&!D&!C2&C1&C&B1&!B&!A1&!A|!D1&!D&!C2&C1&C&B1&!B&!A1&!A|!D1&!D&!C2&C1&!C&B1&!B&!A1&!A|D1&!D&!C2&C1&!C&B1&!B&!A1&!A|!D1&D&!C2&C1&!C&B1&!B&!A1&!A|!D1&D&C2&C1&!C&B1&!B&!A1&!A|D1&!D&C2&C1&!C&B1&!B&!A1&!A|!D1&!D&C2&C1&!C&B1&!B&!A1&!A|!D1&!D&C2&!C1&!C&B1&!B&!A1&!A|D1&!D&C2&!C1&!C&B1&!B&!A1&!A|!D1&D&C2&!C1&!C&B1&!B&!A1&!A|!D1&D&!C2&!C1&!C&B1&!B&!A1&!A|D1&!D&!C2&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C2&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C2&!C1&!C&B1&B&!A1&!A|D1&!D&!C2&!C1&!C&B1&B&!A1&!A|!D1&D&!C2&!C1&!C&B1&B&!A1&!A|!D1&!D&!C2&!C1&C&!B1&B&!A1&!A|D1&!D&!C2&!C1&C&!B1&B&!A1&!A|!D1&D&!C2&!C1&C&!B1&B&!A1&!A|!D1&D&C2&!C1&C&!B1&B&!A1&!A|D1&!D&C2&!C1&C&!B1&B&!A1&!A|!D1&!D&C2&!C1&C&!B1&B&!A1&!A|!D1&!D&C2&C1&C&!B1&B&!A1&!A|D1&!D&C2&C1&C&!B1&B&!A1&!A|!D1&D&C2&C1&C&!B1&B&!A1&!A|!D1&D&!C2&C1&C&!B1&B&!A1&!A|D1&!D&!C2&C1&C&!B1&B&!A1&!A|!D1&!D&!C2&C1&C&!B1&B&!A1&!A|!D1&!D&!C2&C1&!C&!B1&B&!A1&!A|D1&!D&!C2&C1&!C&!B1&B&!A1&!A|!D1&D&!C2&C1&!C&!B1&B&!A1&!A|!D1&D&C2&C1&!C&!B1&B&!A1&!A|D1&!D&C2&C1&!C&!B1&B&!A1&!A|!D1&!D&C2&C1&!C&!B1&B&!A1&!A|!D1&!D&C2&!C1&!C&!B1&B&!A1&!A|D1&!D&C2&!C1&!C&!B1&B&!A1&!A|!D1&D&C2&!C1&!C&!B1&B&!A1&!A|!D1&D&!C2&!C1&!C&!B1&B&!A1&!A|D1&!D&!C2&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C2&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C2&!C1&!C&!B1&B&A1&!A|D1&!D&!C2&!C1&!C&!B1&B&A1&!A|!D1&D&!C2&!C1&!C&!B1&B&A1&!A|!D1&D&C2&!C1&!C&!B1&B&A1&!A|D1&!D&C2&!C1&!C&!B1&B&A1&!A|!D1&!D&C2&!C1&!C&!B1&B&A1&!A|!D1&!D&C2&C1&!C&!B1&B&A1&!A|D1&!D&C2&C1&!C&!B1&B&A1&!A|!D1&D&C2&C1&!C&!B1&B&A1&!A|!D1&D&!C2&C1&!C&!B1&B&A1&!A|D1&!D&!C2&C1&!C&!B1&B&A1&!A|!D1&!D&!C2&C1&!C&!B1&B&A1&!A|!D1&!D&!C2&C1&C&!B1&B&A1&!A|D1&!D&!C2&C1&C&!B1&B&A1&!A|!D1&D&!C2&C1&C&!B1&B&A1&!A|!D1&D&C2&C1&C&!B1&B&A1&!A|D1&!D&C2&C1&C&!B1&B&A1&!A|!D1&!D&C2&C1&C&!B1&B&A1&!A|!D1&!D&C2&!C1&C&!B1&B&A1&!A|D1&!D&C2&!C1&C&!B1&B&A1&!A|!D1&D&C2&!C1&C&!B1&B&A1&!A|!D1&D&!C2&!C1&C&!B1&B&A1&!A|D1&!D&!C2&!C1&C&!B1&B&A1&!A|!D1&!D&!C2&!C1&C&!B1&B&A1&!A|!D1&D&!C2&!C1&!C&B1&B&A1&!A|D1&!D&!C2&!C1&!C&B1&B&A1&!A|!D1&!D&!C2&!C1&!C&B1&B&A1&!A|!D1&!D&!C2&!C1&!C&B1&!B&A1&!A|D1&!D&!C2&!C1&!C&B1&!B&A1&!A|!D1&D&!C2&!C1&!C&B1&!B&A1&!A|!D1&D&C2&!C1&!C&B1&!B&A1&!A|D1&!D&C2&!C1&!C&B1&!B&A1&!A|!D1&!D&C2&!C1&!C&B1&!B&A1&!A|!D1&!D&C2&C1&!C&B1&!B&A1&!A|D1&!D&C2&C1&!C&B1&!B&A1&!A|!D1&D&C2&C1&!C&B1&!B&A1&!A|!D1&D&!C2&C1&!C&B1&!B&A1&!A|D1&!D&!C2&C1&!C&B1&!B&A1&!A|!D1&!D&!C2&C1&!C&B1&!B&A1&!A|!D1&!D&!C2&C1&C&B1&!B&A1&!A|D1&!D&!C2&C1&C&B1&!B&A1&!A|!D1&D&!C2&C1&C&B1&!B&A1&!A|!D1&D&C2&C1&C&B1&!B&A1&!A|D1&!D&C2&C1&C&B1&!B&A1&!A|!D1&!D&C2&C1&C&B1&!B&A1&!A|!D1&!D&C2&!C1&C&B1&!B&A1&!A|D1&!D&C2&!C1&C&B1&!B&A1&!A|!D1&D&C2&!C1&C&B1&!B&A1&!A|!D1&D&!C2&!C1&C&B1&!B&A1&!A|D1&!D&!C2&!C1&C&B1&!B&A1&!A|!D1&!D&!C2&!C1&C&B1&!B&A1&!A|!D1&!D&!C2&!C1&C&!B1&!B&A1&!A|D1&!D&!C2&!C1&C&!B1&!B&A1&!A|!D1&D&!C2&!C1&C&!B1&!B&A1&!A|!D1&D&C2&!C1&C&!B1&!B&A1&!A|D1&!D&C2&!C1&C&!B1&!B&A1&!A|!D1&!D&C2&!C1&C&!B1&!B&A1&!A|!D1&!D&C2&C1&C&!B1&!B&A1&!A|D1&!D&C2&C1&C&!B1&!B&A1&!A|!D1&D&C2&C1&C&!B1&!B&A1&!A|!D1&D&!C2&C1&C&!B1&!B&A1&!A|D1&!D&!C2&C1&C&!B1&!B&A1&!A|!D1&!D&!C2&C1&C&!B1&!B&A1&!A|!D1&!D&!C2&C1&!C&!B1&!B&A1&!A|D1&!D&!C2&C1&!C&!B1&!B&A1&!A|!D1&D&!C2&C1&!C&!B1&!B&A1&!A|!D1&D&C2&C1&!C&!B1&!B&A1&!A|D1&!D&C2&C1&!C&!B1&!B&A1&!A|!D1&!D&C2&C1&!C&!B1&!B&A1&!A|!D1&!D&C2&!C1&!C&!B1&!B&A1&!A|D1&!D&C2&!C1&!C&!B1&!B&A1&!A|!D1&D&C2&!C1&!C&!B1&!B&A1&!A|!D1&D&!C2&!C1&!C&!B1&!B&A1&!A|D1&!D&!C2&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C2&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C2&!C1&!C&!B1&!B&A1&A|D1&!D&!C2&!C1&!C&!B1&!B&A1&A|!D1&D&!C2&!C1&!C&!B1&!B&A1&A|!D1&D&!C2&!C1&!C&B1&!B&A1&A|D1&!D&!C2&!C1&!C&B1&!B&A1&A|!D1&!D&!C2&!C1&!C&B1&!B&A1&A|!D1&!D&!C2&!C1&!C&B1&B&A1&A|D1&!D&!C2&!C1&!C&B1&B&A1&A|!D1&D&!C2&!C1&!C&B1&B&A1&A|!D1&D&!C2&!C1&!C&!B1&B&A1&A|D1&!D&!C2&!C1&!C&!B1&B&A1&A|!D1&!D&!C2&!C1&!C&!B1&B&A1&A|!D1&!D&!C2&!C1&!C&!B1&B&!A1&A|D1&!D&!C2&!C1&!C&!B1&B&!A1&A|!D1&D&!C2&!C1&!C&!B1&B&!A1&A|!D1&D&C2&!C1&!C&!B1&B&!A1&A|D1&!D&C2&!C1&!C&!B1&B&!A1&A|!D1&!D&C2&!C1&!C&!B1&B&!A1&A|!D1&!D&C2&C1&!C&!B1&B&!A1&A|D1&!D&C2&C1&!C&!B1&B&!A1&A|!D1&D&C2&C1&!C&!B1&B&!A1&A|!D1&D&!C2&C1&!C&!B1&B&!A1&A|D1&!D&!C2&C1&!C&!B1&B&!A1&A|!D1&!D&!C2&C1&!C&!B1&B&!A1&A|!D1&!D&!C2&C1&C&!B1&B&!A1&A|D1&!D&!C2&C1&C&!B1&B&!A1&A|!D1&D&!C2&C1&C&!B1&B&!A1&A|!D1&D&C2&C1&C&!B1&B&!A1&A|D1&!D&C2&C1&C&!B1&B&!A1&A|!D1&!D&C2&C1&C&!B1&B&!A1&A|!D1&!D&C2&!C1&C&!B1&B&!A1&A|D1&!D&C2&!C1&C&!B1&B&!A1&A|!D1&D&C2&!C1&C&!B1&B&!A1&A|!D1&D&!C2&!C1&C&!B1&B&!A1&A|D1&!D&!C2&!C1&C&!B1&B&!A1&A|!D1&!D&!C2&!C1&C&!B1&B&!A1&A|!D1&D&!C2&!C1&!C&B1&B&!A1&A|D1&!D&!C2&!C1&!C&B1&B&!A1&A|!D1&!D&!C2&!C1&!C&B1&B&!A1&A|!D1&!D&!C2&!C1&!C&B1&!B&!A1&A|D1&!D&!C2&!C1&!C&B1&!B&!A1&A|!D1&D&!C2&!C1&!C&B1&!B&!A1&A|!D1&D&C2&!C1&!C&B1&!B&!A1&A|D1&!D&C2&!C1&!C&B1&!B&!A1&A|!D1&!D&C2&!C1&!C&B1&!B&!A1&A|!D1&!D&C2&C1&!C&B1&!B&!A1&A|D1&!D&C2&C1&!C&B1&!B&!A1&A|!D1&D&C2&C1&!C&B1&!B&!A1&A|!D1&D&!C2&C1&!C&B1&!B&!A1&A|D1&!D&!C2&C1&!C&B1&!B&!A1&A|!D1&!D&!C2&C1&!C&B1&!B&!A1&A|!D1&!D&!C2&C1&C&B1&!B&!A1&A|D1&!D&!C2&C1&C&B1&!B&!A1&A|!D1&D&!C2&C1&C&B1&!B&!A1&A|!D1&D&C2&C1&C&B1&!B&!A1&A|D1&!D&C2&C1&C&B1&!B&!A1&A|!D1&!D&C2&C1&C&B1&!B&!A1&A|!D1&!D&C2&!C1&C&B1&!B&!A1&A|D1&!D&C2&!C1&C&B1&!B&!A1&A|!D1&D&C2&!C1&C&B1&!B&!A1&A|!D1&D&!C2&!C1&C&B1&!B&!A1&A|D1&!D&!C2&!C1&C&B1&!B&!A1&A|!D1&!D&!C2&!C1&C&B1&!B&!A1&A|!D1&!D&!C2&!C1&C&!B1&!B&!A1&A|D1&!D&!C2&!C1&C&!B1&!B&!A1&A|!D1&D&!C2&!C1&C&!B1&!B&!A1&A|!D1&D&C2&!C1&C&!B1&!B&!A1&A|D1&!D&C2&!C1&C&!B1&!B&!A1&A|!D1&!D&C2&!C1&C&!B1&!B&!A1&A|!D1&!D&C2&C1&C&!B1&!B&!A1&A|D1&!D&C2&C1&C&!B1&!B&!A1&A|!D1&D&C2&C1&C&!B1&!B&!A1&A|!D1&D&!C2&C1&C&!B1&!B&!A1&A|D1&!D&!C2&C1&C&!B1&!B&!A1&A|!D1&!D&!C2&C1&C&!B1&!B&!A1&A|!D1&!D&!C2&C1&!C&!B1&!B&!A1&A|D1&!D&!C2&C1&!C&!B1&!B&!A1&A|!D1&D&!C2&C1&!C&!B1&!B&!A1&A|!D1&D&C2&C1&!C&!B1&!B&!A1&A|D1&!D&C2&C1&!C&!B1&!B&!A1&A|!D1&!D&C2&C1&!C&!B1&!B&!A1&A|!D1&!D&C2&!C1&!C&!B1&!B&!A1&A|D1&!D&C2&!C1&!C&!B1&!B&!A1&A|!D1&D&C2&!C1&!C&!B1&!B&!A1&A|!D1&D&!C2&!C1&!C&!B1&!B&!A1&A|D1&!D&!C2&!C1&!C&!B1&!B&!A1&A|!D1&!D&!C2&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAAOI2232.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOOAI2232 -l AAOOOAI2232 -i D1 D C2 C1 C B1 B A1 A -o Y -f Y=!(!D1&D&C2&!C1&!C&B1&B&!A1&!A|D1&D&C2&!C1&!C&B1&B&!A1&!A|D1&!D&C2&!C1&!C&B1&B&!A1&!A|D1&!D&C2&C1&!C&B1&B&!A1&!A|D1&D&C2&C1&!C&B1&B&!A1&!A|!D1&D&C2&C1&!C&B1&B&!A1&!A|!D1&D&!C2&C1&!C&B1&B&!A1&!A|D1&D&!C2&C1&!C&B1&B&!A1&!A|D1&!D&!C2&C1&!C&B1&B&!A1&!A|D1&!D&!C2&C1&C&B1&B&!A1&!A|D1&D&!C2&C1&C&B1&B&!A1&!A|!D1&D&!C2&C1&C&B1&B&!A1&!A|!D1&D&C2&C1&C&B1&B&!A1&!A|D1&D&C2&C1&C&B1&B&!A1&!A|D1&!D&C2&C1&C&B1&B&!A1&!A|D1&!D&C2&!C1&C&B1&B&!A1&!A|D1&D&C2&!C1&C&B1&B&!A1&!A|!D1&D&C2&!C1&C&B1&B&!A1&!A|!D1&D&!C2&!C1&C&B1&B&!A1&!A|D1&D&!C2&!C1&C&B1&B&!A1&!A|D1&!D&!C2&!C1&C&B1&B&!A1&!A|D1&!D&!C2&!C1&C&B1&B&A1&!A|D1&D&!C2&!C1&C&B1&B&A1&!A|!D1&D&!C2&!C1&C&B1&B&A1&!A|!D1&D&C2&!C1&C&B1&B&A1&!A|D1&D&C2&!C1&C&B1&B&A1&!A|D1&!D&C2&!C1&C&B1&B&A1&!A|D1&!D&C2&C1&C&B1&B&A1&!A|D1&D&C2&C1&C&B1&B&A1&!A|!D1&D&C2&C1&C&B1&B&A1&!A|!D1&D&!C2&C1&C&B1&B&A1&!A|D1&D&!C2&C1&C&B1&B&A1&!A|D1&!D&!C2&C1&C&B1&B&A1&!A|D1&!D&!C2&C1&!C&B1&B&A1&!A|D1&D&!C2&C1&!C&B1&B&A1&!A|!D1&D&!C2&C1&!C&B1&B&A1&!A|!D1&D&C2&C1&!C&B1&B&A1&!A|D1&D&C2&C1&!C&B1&B&A1&!A|D1&!D&C2&C1&!C&B1&B&A1&!A|D1&!D&C2&!C1&!C&B1&B&A1&!A|D1&D&C2&!C1&!C&B1&B&A1&!A|!D1&D&C2&!C1&!C&B1&B&A1&!A|!D1&D&C2&!C1&!C&!B1&!B&A1&A|D1&D&C2&!C1&!C&!B1&!B&A1&A|D1&!D&C2&!C1&!C&!B1&!B&A1&A|D1&!D&C2&C1&!C&!B1&!B&A1&A|D1&D&C2&C1&!C&!B1&!B&A1&A|!D1&D&C2&C1&!C&!B1&!B&A1&A|!D1&D&!C2&C1&!C&!B1&!B&A1&A|D1&D&!C2&C1&!C&!B1&!B&A1&A|D1&!D&!C2&C1&!C&!B1&!B&A1&A|D1&!D&!C2&C1&C&!B1&!B&A1&A|D1&D&!C2&C1&C&!B1&!B&A1&A|!D1&D&!C2&C1&C&!B1&!B&A1&A|!D1&D&C2&C1&C&!B1&!B&A1&A|D1&D&C2&C1&C&!B1&!B&A1&A|D1&!D&C2&C1&C&!B1&!B&A1&A|D1&!D&C2&!C1&C&!B1&!B&A1&A|D1&D&C2&!C1&C&!B1&!B&A1&A|!D1&D&C2&!C1&C&!B1&!B&A1&A|!D1&D&!C2&!C1&C&!B1&!B&A1&A|D1&D&!C2&!C1&C&!B1&!B&A1&A|D1&!D&!C2&!C1&C&!B1&!B&A1&A|D1&!D&!C2&!C1&C&B1&!B&A1&A|D1&D&!C2&!C1&C&B1&!B&A1&A|!D1&D&!C2&!C1&C&B1&!B&A1&A|!D1&D&C2&!C1&C&B1&!B&A1&A|D1&D&C2&!C1&C&B1&!B&A1&A|D1&!D&C2&!C1&C&B1&!B&A1&A|D1&!D&C2&C1&C&B1&!B&A1&A|D1&D&C2&C1&C&B1&!B&A1&A|!D1&D&C2&C1&C&B1&!B&A1&A|!D1&D&!C2&C1&C&B1&!B&A1&A|D1&D&!C2&C1&C&B1&!B&A1&A|D1&!D&!C2&C1&C&B1&!B&A1&A|D1&!D&!C2&C1&!C&B1&!B&A1&A|D1&D&!C2&C1&!C&B1&!B&A1&A|!D1&D&!C2&C1&!C&B1&!B&A1&A|!D1&D&C2&C1&!C&B1&!B&A1&A|D1&D&C2&C1&!C&B1&!B&A1&A|D1&!D&C2&C1&!C&B1&!B&A1&A|D1&!D&C2&!C1&!C&B1&!B&A1&A|D1&D&C2&!C1&!C&B1&!B&A1&A|!D1&D&C2&!C1&!C&B1&!B&A1&A|!D1&D&C2&!C1&!C&B1&B&A1&A|D1&D&C2&!C1&!C&B1&B&A1&A|D1&!D&C2&!C1&!C&B1&B&A1&A|D1&!D&C2&C1&!C&B1&B&A1&A|D1&D&C2&C1&!C&B1&B&A1&A|!D1&D&C2&C1&!C&B1&B&A1&A|!D1&D&!C2&C1&!C&B1&B&A1&A|D1&D&!C2&C1&!C&B1&B&A1&A|D1&!D&!C2&C1&!C&B1&B&A1&A|D1&!D&!C2&C1&C&B1&B&A1&A|D1&D&!C2&C1&C&B1&B&A1&A|!D1&D&!C2&C1&C&B1&B&A1&A|!D1&D&C2&C1&C&B1&B&A1&A|D1&D&C2&C1&C&B1&B&A1&A|D1&!D&C2&C1&C&B1&B&A1&A|D1&!D&C2&!C1&C&B1&B&A1&A|D1&D&C2&!C1&C&B1&B&A1&A|!D1&D&C2&!C1&C&B1&B&A1&A|!D1&D&!C2&!C1&C&B1&B&A1&A|D1&D&!C2&!C1&C&B1&B&A1&A|D1&!D&!C2&!C1&C&B1&B&A1&A|D1&!D&!C2&!C1&C&!B1&B&A1&A|D1&D&!C2&!C1&C&!B1&B&A1&A|!D1&D&!C2&!C1&C&!B1&B&A1&A|!D1&D&C2&!C1&C&!B1&B&A1&A|D1&D&C2&!C1&C&!B1&B&A1&A|D1&!D&C2&!C1&C&!B1&B&A1&A|D1&!D&C2&C1&C&!B1&B&A1&A|D1&D&C2&C1&C&!B1&B&A1&A|!D1&D&C2&C1&C&!B1&B&A1&A|!D1&D&!C2&C1&C&!B1&B&A1&A|D1&D&!C2&C1&C&!B1&B&A1&A|D1&!D&!C2&C1&C&!B1&B&A1&A|D1&!D&!C2&C1&!C&!B1&B&A1&A|D1&D&!C2&C1&!C&!B1&B&A1&A|!D1&D&!C2&C1&!C&!B1&B&A1&A|!D1&D&C2&C1&!C&!B1&B&A1&A|D1&D&C2&C1&!C&!B1&B&A1&A|D1&!D&C2&C1&!C&!B1&B&A1&A|D1&!D&C2&!C1&!C&!B1&B&A1&A|D1&D&C2&!C1&!C&!B1&B&A1&A|!D1&D&C2&!C1&!C&!B1&B&A1&A|D1&!D&!C2&!C1&C&B1&B&!A1&A|D1&D&!C2&!C1&C&B1&B&!A1&A|!D1&D&!C2&!C1&C&B1&B&!A1&A|!D1&D&C2&!C1&C&B1&B&!A1&A|D1&D&C2&!C1&C&B1&B&!A1&A|D1&!D&C2&!C1&C&B1&B&!A1&A|D1&!D&C2&C1&C&B1&B&!A1&A|D1&D&C2&C1&C&B1&B&!A1&A|!D1&D&C2&C1&C&B1&B&!A1&A|!D1&D&!C2&C1&C&B1&B&!A1&A|D1&D&!C2&C1&C&B1&B&!A1&A|D1&!D&!C2&C1&C&B1&B&!A1&A|D1&!D&!C2&C1&!C&B1&B&!A1&A|D1&D&!C2&C1&!C&B1&B&!A1&A|!D1&D&!C2&C1&!C&B1&B&!A1&A|!D1&D&C2&C1&!C&B1&B&!A1&A|D1&D&C2&C1&!C&B1&B&!A1&A|D1&!D&C2&C1&!C&B1&B&!A1&A|D1&!D&C2&!C1&!C&B1&B&!A1&A|D1&D&C2&!C1&!C&B1&B&!A1&A|!D1&D&C2&!C1&!C&B1&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOOAI2232.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAI221 -l AAOAI221 -i C B1 B A1 A -o Y -f Y=!(C&B1&B&!A1&!A|C&B1&B&A1&!A|C&!B1&!B&A1&A|C&B1&!B&A1&A|C&B1&B&A1&A|C&!B1&B&A1&A|C&B1&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAI221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAOAI32211 -l OOOAOAI32211 -i E D C1 C B1 B A2 A1 A -o Y -f Y=!(E&D&!C1&!C&!B1&!B&!A2&!A1&!A|E&D&C1&!C&!B1&!B&!A2&!A1&!A|E&D&C1&C&!B1&!B&!A2&!A1&!A|E&D&!C1&C&!B1&!B&!A2&!A1&!A|E&D&!C1&C&B1&!B&!A2&!A1&!A|E&D&C1&C&B1&!B&!A2&!A1&!A|E&D&C1&!C&B1&!B&!A2&!A1&!A|E&D&!C1&!C&B1&!B&!A2&!A1&!A|E&D&!C1&!C&B1&B&!A2&!A1&!A|E&D&C1&!C&B1&B&!A2&!A1&!A|E&D&C1&C&B1&B&!A2&!A1&!A|E&D&!C1&C&B1&B&!A2&!A1&!A|E&D&!C1&C&!B1&B&!A2&!A1&!A|E&D&C1&C&!B1&B&!A2&!A1&!A|E&D&C1&!C&!B1&B&!A2&!A1&!A|E&D&!C1&!C&!B1&B&!A2&!A1&!A|E&D&!C1&!C&!B1&B&A2&!A1&!A|E&D&C1&!C&!B1&B&A2&!A1&!A|E&!D&C1&!C&!B1&B&A2&!A1&!A|E&!D&C1&C&!B1&B&A2&!A1&!A|E&D&C1&C&!B1&B&A2&!A1&!A|E&D&!C1&C&!B1&B&A2&!A1&!A|E&!D&!C1&C&!B1&B&A2&!A1&!A|E&!D&!C1&C&B1&B&A2&!A1&!A|E&D&!C1&C&B1&B&A2&!A1&!A|E&D&C1&C&B1&B&A2&!A1&!A|E&!D&C1&C&B1&B&A2&!A1&!A|E&!D&C1&!C&B1&B&A2&!A1&!A|E&D&C1&!C&B1&B&A2&!A1&!A|E&D&!C1&!C&B1&B&A2&!A1&!A|E&D&!C1&!C&B1&!B&A2&!A1&!A|E&D&C1&!C&B1&!B&A2&!A1&!A|E&!D&C1&!C&B1&!B&A2&!A1&!A|E&!D&C1&C&B1&!B&A2&!A1&!A|E&D&C1&C&B1&!B&A2&!A1&!A|E&D&!C1&C&B1&!B&A2&!A1&!A|E&!D&!C1&C&B1&!B&A2&!A1&!A|E&D&!C1&C&!B1&!B&A2&!A1&!A|E&D&C1&C&!B1&!B&A2&!A1&!A|E&D&C1&!C&!B1&!B&A2&!A1&!A|E&D&!C1&!C&!B1&!B&A2&!A1&!A|E&D&!C1&!C&!B1&!B&A2&A1&!A|E&D&C1&!C&!B1&!B&A2&A1&!A|E&D&C1&C&!B1&!B&A2&A1&!A|E&D&!C1&C&!B1&!B&A2&A1&!A|E&!D&!C1&C&B1&!B&A2&A1&!A|E&D&!C1&C&B1&!B&A2&A1&!A|E&D&C1&C&B1&!B&A2&A1&!A|E&!D&C1&C&B1&!B&A2&A1&!A|E&!D&C1&!C&B1&!B&A2&A1&!A|E&D&C1&!C&B1&!B&A2&A1&!A|E&D&!C1&!C&B1&!B&A2&A1&!A|E&D&!C1&!C&B1&B&A2&A1&!A|E&D&C1&!C&B1&B&A2&A1&!A|E&!D&C1&!C&B1&B&A2&A1&!A|E&!D&C1&C&B1&B&A2&A1&!A|E&D&C1&C&B1&B&A2&A1&!A|E&D&!C1&C&B1&B&A2&A1&!A|E&!D&!C1&C&B1&B&A2&A1&!A|E&!D&!C1&C&!B1&B&A2&A1&!A|E&D&!C1&C&!B1&B&A2&A1&!A|E&D&C1&C&!B1&B&A2&A1&!A|E&!D&C1&C&!B1&B&A2&A1&!A|E&!D&C1&!C&!B1&B&A2&A1&!A|E&D&C1&!C&!B1&B&A2&A1&!A|E&D&!C1&!C&!B1&B&A2&A1&!A|E&D&!C1&!C&!B1&B&!A2&A1&!A|E&D&C1&!C&!B1&B&!A2&A1&!A|E&!D&C1&!C&!B1&B&!A2&A1&!A|E&!D&C1&C&!B1&B&!A2&A1&!A|E&D&C1&C&!B1&B&!A2&A1&!A|E&D&!C1&C&!B1&B&!A2&A1&!A|E&!D&!C1&C&!B1&B&!A2&A1&!A|E&!D&!C1&C&B1&B&!A2&A1&!A|E&D&!C1&C&B1&B&!A2&A1&!A|E&D&C1&C&B1&B&!A2&A1&!A|E&!D&C1&C&B1&B&!A2&A1&!A|E&!D&C1&!C&B1&B&!A2&A1&!A|E&D&C1&!C&B1&B&!A2&A1&!A|E&D&!C1&!C&B1&B&!A2&A1&!A|E&D&!C1&!C&B1&!B&!A2&A1&!A|E&D&C1&!C&B1&!B&!A2&A1&!A|E&!D&C1&!C&B1&!B&!A2&A1&!A|E&!D&C1&C&B1&!B&!A2&A1&!A|E&D&C1&C&B1&!B&!A2&A1&!A|E&D&!C1&C&B1&!B&!A2&A1&!A|E&!D&!C1&C&B1&!B&!A2&A1&!A|E&D&!C1&C&!B1&!B&!A2&A1&!A|E&D&C1&C&!B1&!B&!A2&A1&!A|E&D&C1&!C&!B1&!B&!A2&A1&!A|E&D&!C1&!C&!B1&!B&!A2&A1&!A|E&D&!C1&!C&!B1&!B&!A2&A1&A|E&D&C1&!C&!B1&!B&!A2&A1&A|E&D&C1&C&!B1&!B&!A2&A1&A|E&D&!C1&C&!B1&!B&!A2&A1&A|E&!D&!C1&C&B1&!B&!A2&A1&A|E&D&!C1&C&B1&!B&!A2&A1&A|E&D&C1&C&B1&!B&!A2&A1&A|E&!D&C1&C&B1&!B&!A2&A1&A|E&!D&C1&!C&B1&!B&!A2&A1&A|E&D&C1&!C&B1&!B&!A2&A1&A|E&D&!C1&!C&B1&!B&!A2&A1&A|E&D&!C1&!C&B1&B&!A2&A1&A|E&D&C1&!C&B1&B&!A2&A1&A|E&!D&C1&!C&B1&B&!A2&A1&A|E&!D&C1&C&B1&B&!A2&A1&A|E&D&C1&C&B1&B&!A2&A1&A|E&D&!C1&C&B1&B&!A2&A1&A|E&!D&!C1&C&B1&B&!A2&A1&A|E&!D&!C1&C&!B1&B&!A2&A1&A|E&D&!C1&C&!B1&B&!A2&A1&A|E&D&C1&C&!B1&B&!A2&A1&A|E&!D&C1&C&!B1&B&!A2&A1&A|E&!D&C1&!C&!B1&B&!A2&A1&A|E&D&C1&!C&!B1&B&!A2&A1&A|E&D&!C1&!C&!B1&B&!A2&A1&A|E&D&!C1&!C&!B1&B&A2&A1&A|E&D&C1&!C&!B1&B&A2&A1&A|E&!D&C1&!C&!B1&B&A2&A1&A|E&!D&C1&C&!B1&B&A2&A1&A|E&D&C1&C&!B1&B&A2&A1&A|E&D&!C1&C&!B1&B&A2&A1&A|E&!D&!C1&C&!B1&B&A2&A1&A|E&!D&!C1&C&B1&B&A2&A1&A|E&D&!C1&C&B1&B&A2&A1&A|E&D&C1&C&B1&B&A2&A1&A|E&!D&C1&C&B1&B&A2&A1&A|E&!D&C1&!C&B1&B&A2&A1&A|E&D&C1&!C&B1&B&A2&A1&A|E&D&!C1&!C&B1&B&A2&A1&A|E&D&!C1&!C&B1&!B&A2&A1&A|E&D&C1&!C&B1&!B&A2&A1&A|E&!D&C1&!C&B1&!B&A2&A1&A|E&!D&C1&C&B1&!B&A2&A1&A|E&D&C1&C&B1&!B&A2&A1&A|E&D&!C1&C&B1&!B&A2&A1&A|E&!D&!C1&C&B1&!B&A2&A1&A|E&D&!C1&C&!B1&!B&A2&A1&A|E&D&C1&C&!B1&!B&A2&A1&A|E&D&C1&!C&!B1&!B&A2&A1&A|E&D&!C1&!C&!B1&!B&A2&A1&A|E&D&!C1&!C&!B1&!B&A2&!A1&A|E&D&C1&!C&!B1&!B&A2&!A1&A|E&D&C1&C&!B1&!B&A2&!A1&A|E&D&!C1&C&!B1&!B&A2&!A1&A|E&!D&!C1&C&B1&!B&A2&!A1&A|E&D&!C1&C&B1&!B&A2&!A1&A|E&D&C1&C&B1&!B&A2&!A1&A|E&!D&C1&C&B1&!B&A2&!A1&A|E&!D&C1&!C&B1&!B&A2&!A1&A|E&D&C1&!C&B1&!B&A2&!A1&A|E&D&!C1&!C&B1&!B&A2&!A1&A|E&D&!C1&!C&B1&B&A2&!A1&A|E&D&C1&!C&B1&B&A2&!A1&A|E&!D&C1&!C&B1&B&A2&!A1&A|E&!D&C1&C&B1&B&A2&!A1&A|E&D&C1&C&B1&B&A2&!A1&A|E&D&!C1&C&B1&B&A2&!A1&A|E&!D&!C1&C&B1&B&A2&!A1&A|E&!D&!C1&C&!B1&B&A2&!A1&A|E&D&!C1&C&!B1&B&A2&!A1&A|E&D&C1&C&!B1&B&A2&!A1&A|E&!D&C1&C&!B1&B&A2&!A1&A|E&!D&C1&!C&!B1&B&A2&!A1&A|E&D&C1&!C&!B1&B&A2&!A1&A|E&D&!C1&!C&!B1&B&A2&!A1&A|E&D&!C1&!C&!B1&B&!A2&!A1&A|E&D&C1&!C&!B1&B&!A2&!A1&A|E&!D&C1&!C&!B1&B&!A2&!A1&A|E&!D&C1&C&!B1&B&!A2&!A1&A|E&D&C1&C&!B1&B&!A2&!A1&A|E&D&!C1&C&!B1&B&!A2&!A1&A|E&!D&!C1&C&!B1&B&!A2&!A1&A|E&!D&!C1&C&B1&B&!A2&!A1&A|E&D&!C1&C&B1&B&!A2&!A1&A|E&D&C1&C&B1&B&!A2&!A1&A|E&!D&C1&C&B1&B&!A2&!A1&A|E&!D&C1&!C&B1&B&!A2&!A1&A|E&D&C1&!C&B1&B&!A2&!A1&A|E&D&!C1&!C&B1&B&!A2&!A1&A|E&D&!C1&!C&B1&!B&!A2&!A1&A|E&D&C1&!C&B1&!B&!A2&!A1&A|E&!D&C1&!C&B1&!B&!A2&!A1&A|E&!D&C1&C&B1&!B&!A2&!A1&A|E&D&C1&C&B1&!B&!A2&!A1&A|E&D&!C1&C&B1&!B&!A2&!A1&A|E&!D&!C1&C&B1&!B&!A2&!A1&A|E&D&!C1&C&!B1&!B&!A2&!A1&A|E&D&C1&C&!B1&!B&!A2&!A1&A|E&D&C1&!C&!B1&!B&!A2&!A1&A|E&D&!C1&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAOAI32211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOOAI21113 -l AOAOOAI21113 -i E2 E1 E D C B A1 A -o Y -f Y=(!E2&!E1&!E&!D&!C&!B&!A1&!A|E2&!E1&!E&!D&!C&!B&!A1&!A|E2&E1&!E&!D&!C&!B&!A1&!A|!E2&E1&!E&!D&!C&!B&!A1&!A|!E2&E1&E&!D&!C&!B&!A1&!A|E2&E1&E&!D&!C&!B&!A1&!A|E2&!E1&E&!D&!C&!B&!A1&!A|!E2&!E1&E&!D&!C&!B&!A1&!A|!E2&!E1&!E&D&!C&!B&!A1&!A|!E2&!E1&!E&D&C&!B&!A1&!A|!E2&!E1&E&!D&C&!B&!A1&!A|E2&!E1&E&!D&C&!B&!A1&!A|E2&E1&E&!D&C&!B&!A1&!A|!E2&E1&E&!D&C&!B&!A1&!A|!E2&E1&!E&!D&C&!B&!A1&!A|E2&E1&!E&!D&C&!B&!A1&!A|E2&!E1&!E&!D&C&!B&!A1&!A|!E2&!E1&!E&!D&C&!B&!A1&!A|!E2&!E1&!E&!D&C&B&!A1&!A|!E2&!E1&!E&D&C&B&!A1&!A|!E2&!E1&!E&D&!C&B&!A1&!A|!E2&!E1&E&!D&!C&B&!A1&!A|E2&!E1&E&!D&!C&B&!A1&!A|E2&E1&E&!D&!C&B&!A1&!A|!E2&E1&E&!D&!C&B&!A1&!A|!E2&E1&!E&!D&!C&B&!A1&!A|E2&E1&!E&!D&!C&B&!A1&!A|E2&!E1&!E&!D&!C&B&!A1&!A|!E2&!E1&!E&!D&!C&B&!A1&!A|!E2&!E1&!E&!D&!C&B&A1&!A|E2&!E1&!E&!D&!C&B&A1&!A|E2&E1&!E&!D&!C&B&A1&!A|!E2&E1&!E&!D&!C&B&A1&!A|!E2&E1&E&!D&!C&B&A1&!A|E2&E1&E&!D&!C&B&A1&!A|E2&!E1&E&!D&!C&B&A1&!A|!E2&!E1&E&!D&!C&B&A1&!A|!E2&!E1&!E&D&!C&B&A1&!A|!E2&!E1&!E&D&C&B&A1&!A|!E2&!E1&!E&!D&C&B&A1&!A|!E2&!E1&!E&!D&C&!B&A1&!A|E2&!E1&!E&!D&C&!B&A1&!A|E2&E1&!E&!D&C&!B&A1&!A|!E2&E1&!E&!D&C&!B&A1&!A|!E2&E1&E&!D&C&!B&A1&!A|E2&E1&E&!D&C&!B&A1&!A|E2&!E1&E&!D&C&!B&A1&!A|!E2&!E1&E&!D&C&!B&A1&!A|!E2&!E1&!E&D&C&!B&A1&!A|!E2&!E1&!E&D&!C&!B&A1&!A|!E2&!E1&E&!D&!C&!B&A1&!A|E2&!E1&E&!D&!C&!B&A1&!A|E2&E1&E&!D&!C&!B&A1&!A|!E2&E1&E&!D&!C&!B&A1&!A|!E2&E1&!E&!D&!C&!B&A1&!A|E2&E1&!E&!D&!C&!B&A1&!A|E2&!E1&!E&!D&!C&!B&A1&!A|!E2&!E1&!E&!D&!C&!B&A1&!A|!E2&!E1&!E&!D&!C&!B&A1&A|E2&!E1&!E&!D&!C&!B&A1&A|E2&E1&!E&!D&!C&!B&A1&A|!E2&E1&!E&!D&!C&!B&A1&A|!E2&E1&E&!D&!C&!B&A1&A|E2&E1&E&!D&!C&!B&A1&A|E2&!E1&E&!D&!C&!B&A1&A|!E2&!E1&E&!D&!C&!B&A1&A|!E2&!E1&!E&D&!C&!B&A1&A|!E2&!E1&!E&D&C&!B&A1&A|!E2&!E1&!E&!D&C&!B&A1&A|!E2&!E1&!E&!D&C&B&A1&A|!E2&!E1&!E&D&C&B&A1&A|!E2&!E1&!E&D&!C&B&A1&A|!E2&!E1&E&!D&!C&B&A1&A|E2&!E1&E&!D&!C&B&A1&A|E2&E1&E&!D&!C&B&A1&A|!E2&E1&E&!D&!C&B&A1&A|!E2&E1&!E&!D&!C&B&A1&A|E2&E1&!E&!D&!C&B&A1&A|E2&!E1&!E&!D&!C&B&A1&A|!E2&!E1&!E&!D&!C&B&A1&A|!E2&!E1&!E&!D&!C&B&!A1&A|E2&!E1&!E&!D&!C&B&!A1&A|E2&E1&!E&!D&!C&B&!A1&A|!E2&E1&!E&!D&!C&B&!A1&A|!E2&E1&E&!D&!C&B&!A1&A|E2&E1&E&!D&!C&B&!A1&A|E2&!E1&E&!D&!C&B&!A1&A|!E2&!E1&E&!D&!C&B&!A1&A|!E2&!E1&!E&D&!C&B&!A1&A|!E2&!E1&!E&D&C&B&!A1&A|!E2&!E1&!E&!D&C&B&!A1&A|!E2&!E1&!E&!D&C&!B&!A1&A|E2&!E1&!E&!D&C&!B&!A1&A|E2&E1&!E&!D&C&!B&!A1&A|!E2&E1&!E&!D&C&!B&!A1&A|!E2&E1&E&!D&C&!B&!A1&A|E2&E1&E&!D&C&!B&!A1&A|E2&!E1&E&!D&C&!B&!A1&A|!E2&!E1&E&!D&C&!B&!A1&A|!E2&!E1&!E&D&C&!B&!A1&A|!E2&!E1&!E&D&!C&!B&!A1&A|!E2&!E1&E&!D&!C&!B&!A1&A|E2&!E1&E&!D&!C&!B&!A1&A|E2&E1&E&!D&!C&!B&!A1&A|!E2&E1&E&!D&!C&!B&!A1&A|!E2&E1&!E&!D&!C&!B&!A1&A|E2&E1&!E&!D&!C&!B&!A1&A|E2&!E1&!E&!D&!C&!B&!A1&A|!E2&!E1&!E&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOOAI21113.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAOOAI22113 -l AAOAOOAI22113 -i E2 E1 E D C B1 B A1 A -o Y -f Y=(!E2&!E1&!E&!D&!C&!B1&!B&!A1&!A|E2&!E1&!E&!D&!C&!B1&!B&!A1&!A|E2&E1&!E&!D&!C&!B1&!B&!A1&!A|!E2&E1&!E&!D&!C&!B1&!B&!A1&!A|!E2&E1&E&!D&!C&!B1&!B&!A1&!A|E2&E1&E&!D&!C&!B1&!B&!A1&!A|E2&!E1&E&!D&!C&!B1&!B&!A1&!A|!E2&!E1&E&!D&!C&!B1&!B&!A1&!A|!E2&!E1&!E&D&!C&!B1&!B&!A1&!A|!E2&!E1&!E&D&C&!B1&!B&!A1&!A|!E2&!E1&E&!D&C&!B1&!B&!A1&!A|E2&!E1&E&!D&C&!B1&!B&!A1&!A|E2&E1&E&!D&C&!B1&!B&!A1&!A|!E2&E1&E&!D&C&!B1&!B&!A1&!A|!E2&E1&!E&!D&C&!B1&!B&!A1&!A|E2&E1&!E&!D&C&!B1&!B&!A1&!A|E2&!E1&!E&!D&C&!B1&!B&!A1&!A|!E2&!E1&!E&!D&C&!B1&!B&!A1&!A|!E2&!E1&!E&!D&C&B1&!B&!A1&!A|E2&!E1&!E&!D&C&B1&!B&!A1&!A|E2&E1&!E&!D&C&B1&!B&!A1&!A|!E2&E1&!E&!D&C&B1&!B&!A1&!A|!E2&E1&E&!D&C&B1&!B&!A1&!A|E2&E1&E&!D&C&B1&!B&!A1&!A|E2&!E1&E&!D&C&B1&!B&!A1&!A|!E2&!E1&E&!D&C&B1&!B&!A1&!A|!E2&!E1&!E&D&C&B1&!B&!A1&!A|!E2&!E1&!E&D&!C&B1&!B&!A1&!A|!E2&!E1&E&!D&!C&B1&!B&!A1&!A|E2&!E1&E&!D&!C&B1&!B&!A1&!A|E2&E1&E&!D&!C&B1&!B&!A1&!A|!E2&E1&E&!D&!C&B1&!B&!A1&!A|!E2&E1&!E&!D&!C&B1&!B&!A1&!A|E2&E1&!E&!D&!C&B1&!B&!A1&!A|E2&!E1&!E&!D&!C&B1&!B&!A1&!A|!E2&!E1&!E&!D&!C&B1&!B&!A1&!A|!E2&!E1&!E&!D&!C&B1&B&!A1&!A|E2&!E1&!E&!D&!C&B1&B&!A1&!A|E2&E1&!E&!D&!C&B1&B&!A1&!A|!E2&E1&!E&!D&!C&B1&B&!A1&!A|!E2&E1&E&!D&!C&B1&B&!A1&!A|E2&E1&E&!D&!C&B1&B&!A1&!A|E2&!E1&E&!D&!C&B1&B&!A1&!A|!E2&!E1&E&!D&!C&B1&B&!A1&!A|!E2&!E1&!E&D&!C&B1&B&!A1&!A|!E2&!E1&!E&D&C&B1&B&!A1&!A|!E2&!E1&!E&!D&C&B1&B&!A1&!A|!E2&!E1&!E&!D&C&!B1&B&!A1&!A|E2&!E1&!E&!D&C&!B1&B&!A1&!A|E2&E1&!E&!D&C&!B1&B&!A1&!A|!E2&E1&!E&!D&C&!B1&B&!A1&!A|!E2&E1&E&!D&C&!B1&B&!A1&!A|E2&E1&E&!D&C&!B1&B&!A1&!A|E2&!E1&E&!D&C&!B1&B&!A1&!A|!E2&!E1&E&!D&C&!B1&B&!A1&!A|!E2&!E1&!E&D&C&!B1&B&!A1&!A|!E2&!E1&!E&D&!C&!B1&B&!A1&!A|!E2&!E1&E&!D&!C&!B1&B&!A1&!A|E2&!E1&E&!D&!C&!B1&B&!A1&!A|E2&E1&E&!D&!C&!B1&B&!A1&!A|!E2&E1&E&!D&!C&!B1&B&!A1&!A|!E2&E1&!E&!D&!C&!B1&B&!A1&!A|E2&E1&!E&!D&!C&!B1&B&!A1&!A|E2&!E1&!E&!D&!C&!B1&B&!A1&!A|!E2&!E1&!E&!D&!C&!B1&B&!A1&!A|!E2&!E1&!E&!D&!C&!B1&B&A1&!A|E2&!E1&!E&!D&!C&!B1&B&A1&!A|E2&E1&!E&!D&!C&!B1&B&A1&!A|!E2&E1&!E&!D&!C&!B1&B&A1&!A|!E2&E1&E&!D&!C&!B1&B&A1&!A|E2&E1&E&!D&!C&!B1&B&A1&!A|E2&!E1&E&!D&!C&!B1&B&A1&!A|!E2&!E1&E&!D&!C&!B1&B&A1&!A|!E2&!E1&!E&D&!C&!B1&B&A1&!A|!E2&!E1&!E&D&C&!B1&B&A1&!A|!E2&!E1&E&!D&C&!B1&B&A1&!A|E2&!E1&E&!D&C&!B1&B&A1&!A|E2&E1&E&!D&C&!B1&B&A1&!A|!E2&E1&E&!D&C&!B1&B&A1&!A|!E2&E1&!E&!D&C&!B1&B&A1&!A|E2&E1&!E&!D&C&!B1&B&A1&!A|E2&!E1&!E&!D&C&!B1&B&A1&!A|!E2&!E1&!E&!D&C&!B1&B&A1&!A|!E2&!E1&!E&!D&C&B1&B&A1&!A|!E2&!E1&!E&D&C&B1&B&A1&!A|!E2&!E1&!E&D&!C&B1&B&A1&!A|!E2&!E1&E&!D&!C&B1&B&A1&!A|E2&!E1&E&!D&!C&B1&B&A1&!A|E2&E1&E&!D&!C&B1&B&A1&!A|!E2&E1&E&!D&!C&B1&B&A1&!A|!E2&E1&!E&!D&!C&B1&B&A1&!A|E2&E1&!E&!D&!C&B1&B&A1&!A|E2&!E1&!E&!D&!C&B1&B&A1&!A|!E2&!E1&!E&!D&!C&B1&B&A1&!A|!E2&!E1&!E&!D&!C&B1&!B&A1&!A|E2&!E1&!E&!D&!C&B1&!B&A1&!A|E2&E1&!E&!D&!C&B1&!B&A1&!A|!E2&E1&!E&!D&!C&B1&!B&A1&!A|!E2&E1&E&!D&!C&B1&!B&A1&!A|E2&E1&E&!D&!C&B1&!B&A1&!A|E2&!E1&E&!D&!C&B1&!B&A1&!A|!E2&!E1&E&!D&!C&B1&!B&A1&!A|!E2&!E1&!E&D&!C&B1&!B&A1&!A|!E2&!E1&!E&D&C&B1&!B&A1&!A|!E2&!E1&E&!D&C&B1&!B&A1&!A|E2&!E1&E&!D&C&B1&!B&A1&!A|E2&E1&E&!D&C&B1&!B&A1&!A|!E2&E1&E&!D&C&B1&!B&A1&!A|!E2&E1&!E&!D&C&B1&!B&A1&!A|E2&E1&!E&!D&C&B1&!B&A1&!A|E2&!E1&!E&!D&C&B1&!B&A1&!A|!E2&!E1&!E&!D&C&B1&!B&A1&!A|!E2&!E1&!E&!D&C&!B1&!B&A1&!A|E2&!E1&!E&!D&C&!B1&!B&A1&!A|E2&E1&!E&!D&C&!B1&!B&A1&!A|!E2&E1&!E&!D&C&!B1&!B&A1&!A|!E2&E1&E&!D&C&!B1&!B&A1&!A|E2&E1&E&!D&C&!B1&!B&A1&!A|E2&!E1&E&!D&C&!B1&!B&A1&!A|!E2&!E1&E&!D&C&!B1&!B&A1&!A|!E2&!E1&!E&D&C&!B1&!B&A1&!A|!E2&!E1&!E&D&!C&!B1&!B&A1&!A|!E2&!E1&E&!D&!C&!B1&!B&A1&!A|E2&!E1&E&!D&!C&!B1&!B&A1&!A|E2&E1&E&!D&!C&!B1&!B&A1&!A|!E2&E1&E&!D&!C&!B1&!B&A1&!A|!E2&E1&!E&!D&!C&!B1&!B&A1&!A|E2&E1&!E&!D&!C&!B1&!B&A1&!A|E2&!E1&!E&!D&!C&!B1&!B&A1&!A|!E2&!E1&!E&!D&!C&!B1&!B&A1&!A|!E2&!E1&!E&!D&!C&!B1&!B&A1&A|E2&!E1&!E&!D&!C&!B1&!B&A1&A|E2&E1&!E&!D&!C&!B1&!B&A1&A|!E2&E1&!E&!D&!C&!B1&!B&A1&A|!E2&E1&E&!D&!C&!B1&!B&A1&A|E2&E1&E&!D&!C&!B1&!B&A1&A|E2&!E1&E&!D&!C&!B1&!B&A1&A|!E2&!E1&E&!D&!C&!B1&!B&A1&A|!E2&!E1&!E&D&!C&!B1&!B&A1&A|!E2&!E1&!E&D&C&!B1&!B&A1&A|!E2&!E1&!E&!D&C&!B1&!B&A1&A|!E2&!E1&!E&!D&C&B1&!B&A1&A|!E2&!E1&!E&D&C&B1&!B&A1&A|!E2&!E1&!E&D&!C&B1&!B&A1&A|!E2&!E1&E&!D&!C&B1&!B&A1&A|E2&!E1&E&!D&!C&B1&!B&A1&A|E2&E1&E&!D&!C&B1&!B&A1&A|!E2&E1&E&!D&!C&B1&!B&A1&A|!E2&E1&!E&!D&!C&B1&!B&A1&A|E2&E1&!E&!D&!C&B1&!B&A1&A|E2&!E1&!E&!D&!C&B1&!B&A1&A|!E2&!E1&!E&!D&!C&B1&!B&A1&A|!E2&!E1&!E&!D&!C&B1&B&A1&A|E2&!E1&!E&!D&!C&B1&B&A1&A|E2&E1&!E&!D&!C&B1&B&A1&A|!E2&E1&!E&!D&!C&B1&B&A1&A|!E2&E1&E&!D&!C&B1&B&A1&A|E2&E1&E&!D&!C&B1&B&A1&A|E2&!E1&E&!D&!C&B1&B&A1&A|!E2&!E1&E&!D&!C&B1&B&A1&A|!E2&!E1&!E&D&!C&B1&B&A1&A|!E2&!E1&!E&D&C&B1&B&A1&A|!E2&!E1&!E&!D&C&B1&B&A1&A|!E2&!E1&!E&!D&C&!B1&B&A1&A|!E2&!E1&!E&D&C&!B1&B&A1&A|!E2&!E1&!E&D&!C&!B1&B&A1&A|!E2&!E1&E&!D&!C&!B1&B&A1&A|E2&!E1&E&!D&!C&!B1&B&A1&A|E2&E1&E&!D&!C&!B1&B&A1&A|!E2&E1&E&!D&!C&!B1&B&A1&A|!E2&E1&!E&!D&!C&!B1&B&A1&A|E2&E1&!E&!D&!C&!B1&B&A1&A|E2&!E1&!E&!D&!C&!B1&B&A1&A|!E2&!E1&!E&!D&!C&!B1&B&A1&A|!E2&!E1&!E&!D&!C&!B1&B&!A1&A|E2&!E1&!E&!D&!C&!B1&B&!A1&A|E2&E1&!E&!D&!C&!B1&B&!A1&A|!E2&E1&!E&!D&!C&!B1&B&!A1&A|!E2&E1&E&!D&!C&!B1&B&!A1&A|E2&E1&E&!D&!C&!B1&B&!A1&A|E2&!E1&E&!D&!C&!B1&B&!A1&A|!E2&!E1&E&!D&!C&!B1&B&!A1&A|!E2&!E1&!E&D&!C&!B1&B&!A1&A|!E2&!E1&!E&D&C&!B1&B&!A1&A|!E2&!E1&E&!D&C&!B1&B&!A1&A|E2&!E1&E&!D&C&!B1&B&!A1&A|E2&E1&E&!D&C&!B1&B&!A1&A|!E2&E1&E&!D&C&!B1&B&!A1&A|!E2&E1&!E&!D&C&!B1&B&!A1&A|E2&E1&!E&!D&C&!B1&B&!A1&A|E2&!E1&!E&!D&C&!B1&B&!A1&A|!E2&!E1&!E&!D&C&!B1&B&!A1&A|!E2&!E1&!E&!D&C&B1&B&!A1&A|!E2&!E1&!E&D&C&B1&B&!A1&A|!E2&!E1&!E&D&!C&B1&B&!A1&A|!E2&!E1&E&!D&!C&B1&B&!A1&A|E2&!E1&E&!D&!C&B1&B&!A1&A|E2&E1&E&!D&!C&B1&B&!A1&A|!E2&E1&E&!D&!C&B1&B&!A1&A|!E2&E1&!E&!D&!C&B1&B&!A1&A|E2&E1&!E&!D&!C&B1&B&!A1&A|E2&!E1&!E&!D&!C&B1&B&!A1&A|!E2&!E1&!E&!D&!C&B1&B&!A1&A|!E2&!E1&!E&!D&!C&B1&!B&!A1&A|E2&!E1&!E&!D&!C&B1&!B&!A1&A|E2&E1&!E&!D&!C&B1&!B&!A1&A|!E2&E1&!E&!D&!C&B1&!B&!A1&A|!E2&E1&E&!D&!C&B1&!B&!A1&A|E2&E1&E&!D&!C&B1&!B&!A1&A|E2&!E1&E&!D&!C&B1&!B&!A1&A|!E2&!E1&E&!D&!C&B1&!B&!A1&A|!E2&!E1&!E&D&!C&B1&!B&!A1&A|!E2&!E1&!E&D&C&B1&!B&!A1&A|!E2&!E1&E&!D&C&B1&!B&!A1&A|E2&!E1&E&!D&C&B1&!B&!A1&A|E2&E1&E&!D&C&B1&!B&!A1&A|!E2&E1&E&!D&C&B1&!B&!A1&A|!E2&E1&!E&!D&C&B1&!B&!A1&A|E2&E1&!E&!D&C&B1&!B&!A1&A|E2&!E1&!E&!D&C&B1&!B&!A1&A|!E2&!E1&!E&!D&C&B1&!B&!A1&A|!E2&!E1&!E&!D&C&!B1&!B&!A1&A|E2&!E1&!E&!D&C&!B1&!B&!A1&A|E2&E1&!E&!D&C&!B1&!B&!A1&A|!E2&E1&!E&!D&C&!B1&!B&!A1&A|!E2&E1&E&!D&C&!B1&!B&!A1&A|E2&E1&E&!D&C&!B1&!B&!A1&A|E2&!E1&E&!D&C&!B1&!B&!A1&A|!E2&!E1&E&!D&C&!B1&!B&!A1&A|!E2&!E1&!E&D&C&!B1&!B&!A1&A|!E2&!E1&!E&D&!C&!B1&!B&!A1&A|!E2&!E1&E&!D&!C&!B1&!B&!A1&A|E2&!E1&E&!D&!C&!B1&!B&!A1&A|E2&E1&E&!D&!C&!B1&!B&!A1&A|!E2&E1&E&!D&!C&!B1&!B&!A1&A|!E2&E1&!E&!D&!C&!B1&!B&!A1&A|E2&E1&!E&!D&!C&!B1&!B&!A1&A|E2&!E1&!E&!D&!C&!B1&!B&!A1&A|!E2&!E1&!E&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAOOAI22113.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOOAOI22221 -l AAAOOAOI22221 -i E D1 D C1 C B1 B A1 A -o Y -f Y=(!E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&D1&D&C1&!C&!B1&!B&!A1&!A|!E&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&D1&D&!C1&C&!B1&!B&!A1&!A|!E&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&D1&!D&!C1&C&B1&!B&!A1&!A|!E&D1&D&!C1&C&B1&!B&!A1&!A|!E&!D1&D&!C1&C&B1&!B&!A1&!A|!E&!D1&!D&C1&C&B1&!B&!A1&!A|!E&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&D1&!D&C1&!C&B1&!B&!A1&!A|!E&D1&D&C1&!C&B1&!B&!A1&!A|!E&!D1&D&C1&!C&B1&!B&!A1&!A|!E&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&D1&D&!C1&!C&B1&!B&!A1&!A|!E&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&!D1&!D&C1&!C&B1&B&!A1&!A|!E&!D1&!D&C1&C&B1&B&!A1&!A|!E&!D1&!D&!C1&C&B1&B&!A1&!A|!E&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&D1&!D&!C1&C&!B1&B&!A1&!A|!E&D1&D&!C1&C&!B1&B&!A1&!A|!E&!D1&D&!C1&C&!B1&B&!A1&!A|!E&!D1&!D&C1&C&!B1&B&!A1&!A|!E&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&D1&!D&C1&!C&!B1&B&!A1&!A|!E&D1&D&C1&!C&!B1&B&!A1&!A|!E&!D1&D&C1&!C&!B1&B&!A1&!A|!E&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&D1&D&!C1&!C&!B1&B&!A1&!A|!E&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&D1&!D&!C1&!C&!B1&B&A1&!A|!E&D1&D&!C1&!C&!B1&B&A1&!A|!E&!D1&D&!C1&!C&!B1&B&A1&!A|!E&!D1&D&C1&!C&!B1&B&A1&!A|!E&D1&D&C1&!C&!B1&B&A1&!A|!E&D1&!D&C1&!C&!B1&B&A1&!A|!E&!D1&!D&C1&!C&!B1&B&A1&!A|!E&!D1&!D&C1&C&!B1&B&A1&!A|!E&!D1&D&!C1&C&!B1&B&A1&!A|!E&D1&D&!C1&C&!B1&B&A1&!A|!E&D1&!D&!C1&C&!B1&B&A1&!A|!E&!D1&!D&!C1&C&!B1&B&A1&!A|!E&!D1&!D&!C1&C&B1&B&A1&!A|!E&!D1&!D&C1&C&B1&B&A1&!A|!E&!D1&!D&C1&!C&B1&B&A1&!A|!E&!D1&!D&!C1&!C&B1&B&A1&!A|!E&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&D1&!D&!C1&!C&B1&!B&A1&!A|!E&D1&D&!C1&!C&B1&!B&A1&!A|!E&!D1&D&!C1&!C&B1&!B&A1&!A|!E&!D1&D&C1&!C&B1&!B&A1&!A|!E&D1&D&C1&!C&B1&!B&A1&!A|!E&D1&!D&C1&!C&B1&!B&A1&!A|!E&!D1&!D&C1&!C&B1&!B&A1&!A|!E&!D1&!D&C1&C&B1&!B&A1&!A|!E&!D1&D&!C1&C&B1&!B&A1&!A|!E&D1&D&!C1&C&B1&!B&A1&!A|!E&D1&!D&!C1&C&B1&!B&A1&!A|!E&!D1&!D&!C1&C&B1&!B&A1&!A|!E&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&D1&!D&!C1&C&!B1&!B&A1&!A|!E&D1&D&!C1&C&!B1&!B&A1&!A|!E&!D1&D&!C1&C&!B1&!B&A1&!A|!E&!D1&!D&C1&C&!B1&!B&A1&!A|!E&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&D1&!D&C1&!C&!B1&!B&A1&!A|!E&D1&D&C1&!C&!B1&!B&A1&!A|!E&!D1&D&C1&!C&!B1&!B&A1&!A|!E&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&D1&D&!C1&!C&!B1&!B&A1&!A|!E&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&!D1&!D&C1&!C&!B1&!B&A1&A|!E&!D1&!D&C1&C&!B1&!B&A1&A|!E&!D1&!D&!C1&C&!B1&!B&A1&A|!E&!D1&!D&!C1&C&B1&!B&A1&A|!E&!D1&!D&C1&C&B1&!B&A1&A|!E&!D1&!D&C1&!C&B1&!B&A1&A|!E&!D1&!D&!C1&!C&B1&!B&A1&A|!E&!D1&!D&!C1&!C&B1&B&A1&A|!E&!D1&!D&C1&!C&B1&B&A1&A|!E&!D1&!D&C1&C&B1&B&A1&A|!E&!D1&!D&!C1&C&B1&B&A1&A|!E&!D1&!D&!C1&C&!B1&B&A1&A|!E&!D1&!D&C1&C&!B1&B&A1&A|!E&!D1&!D&C1&!C&!B1&B&A1&A|!E&!D1&!D&!C1&!C&!B1&B&A1&A|!E&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&D1&!D&!C1&!C&!B1&B&!A1&A|!E&D1&D&!C1&!C&!B1&B&!A1&A|!E&!D1&D&!C1&!C&!B1&B&!A1&A|!E&!D1&D&C1&!C&!B1&B&!A1&A|!E&D1&D&C1&!C&!B1&B&!A1&A|!E&D1&!D&C1&!C&!B1&B&!A1&A|!E&!D1&!D&C1&!C&!B1&B&!A1&A|!E&!D1&!D&C1&C&!B1&B&!A1&A|!E&!D1&D&!C1&C&!B1&B&!A1&A|!E&D1&D&!C1&C&!B1&B&!A1&A|!E&D1&!D&!C1&C&!B1&B&!A1&A|!E&!D1&!D&!C1&C&!B1&B&!A1&A|!E&!D1&!D&!C1&C&B1&B&!A1&A|!E&!D1&!D&C1&C&B1&B&!A1&A|!E&!D1&!D&C1&!C&B1&B&!A1&A|!E&!D1&!D&!C1&!C&B1&B&!A1&A|!E&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&D1&!D&!C1&!C&B1&!B&!A1&A|!E&D1&D&!C1&!C&B1&!B&!A1&A|!E&!D1&D&!C1&!C&B1&!B&!A1&A|!E&!D1&D&C1&!C&B1&!B&!A1&A|!E&D1&D&C1&!C&B1&!B&!A1&A|!E&D1&!D&C1&!C&B1&!B&!A1&A|!E&!D1&!D&C1&!C&B1&!B&!A1&A|!E&!D1&!D&C1&C&B1&!B&!A1&A|!E&!D1&D&!C1&C&B1&!B&!A1&A|!E&D1&D&!C1&C&B1&!B&!A1&A|!E&D1&!D&!C1&C&B1&!B&!A1&A|!E&!D1&!D&!C1&C&B1&!B&!A1&A|!E&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&D1&!D&!C1&C&!B1&!B&!A1&A|!E&D1&D&!C1&C&!B1&!B&!A1&A|!E&!D1&D&!C1&C&!B1&!B&!A1&A|!E&!D1&!D&C1&C&!B1&!B&!A1&A|!E&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&D1&!D&C1&!C&!B1&!B&!A1&A|!E&D1&D&C1&!C&!B1&!B&!A1&A|!E&!D1&D&C1&!C&!B1&!B&!A1&A|!E&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&D1&D&!C1&!C&!B1&!B&!A1&A|!E&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOOAOI22221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOOAI22122 -l AAOOOAI22122 -i E1 E D1 D C B1 B A1 A -o Y -f Y=!(E1&!E&!D1&D&C&!B1&!B&!A1&!A|E1&E&!D1&D&C&!B1&!B&!A1&!A|!E1&E&!D1&D&C&!B1&!B&!A1&!A|!E1&E&D1&D&C&!B1&!B&!A1&!A|E1&E&D1&D&C&!B1&!B&!A1&!A|E1&!E&D1&D&C&!B1&!B&!A1&!A|E1&!E&D1&!D&C&!B1&!B&!A1&!A|E1&E&D1&!D&C&!B1&!B&!A1&!A|!E1&E&D1&!D&C&!B1&!B&!A1&!A|!E1&E&D1&!D&C&B1&!B&!A1&!A|E1&E&D1&!D&C&B1&!B&!A1&!A|E1&!E&D1&!D&C&B1&!B&!A1&!A|E1&!E&D1&D&C&B1&!B&!A1&!A|E1&E&D1&D&C&B1&!B&!A1&!A|!E1&E&D1&D&C&B1&!B&!A1&!A|!E1&E&!D1&D&C&B1&!B&!A1&!A|E1&E&!D1&D&C&B1&!B&!A1&!A|E1&!E&!D1&D&C&B1&!B&!A1&!A|!E1&E&D1&!D&!C&B1&B&!A1&!A|E1&E&D1&!D&!C&B1&B&!A1&!A|E1&!E&D1&!D&!C&B1&B&!A1&!A|E1&!E&D1&D&!C&B1&B&!A1&!A|E1&E&D1&D&!C&B1&B&!A1&!A|!E1&E&D1&D&!C&B1&B&!A1&!A|!E1&E&!D1&D&!C&B1&B&!A1&!A|E1&E&!D1&D&!C&B1&B&!A1&!A|E1&!E&!D1&D&!C&B1&B&!A1&!A|E1&!E&!D1&D&C&B1&B&!A1&!A|E1&E&!D1&D&C&B1&B&!A1&!A|!E1&E&!D1&D&C&B1&B&!A1&!A|!E1&E&D1&D&C&B1&B&!A1&!A|E1&E&D1&D&C&B1&B&!A1&!A|E1&!E&D1&D&C&B1&B&!A1&!A|E1&!E&D1&!D&C&B1&B&!A1&!A|E1&E&D1&!D&C&B1&B&!A1&!A|!E1&E&D1&!D&C&B1&B&!A1&!A|!E1&E&D1&!D&C&!B1&B&!A1&!A|E1&E&D1&!D&C&!B1&B&!A1&!A|E1&!E&D1&!D&C&!B1&B&!A1&!A|E1&!E&D1&D&C&!B1&B&!A1&!A|E1&E&D1&D&C&!B1&B&!A1&!A|!E1&E&D1&D&C&!B1&B&!A1&!A|!E1&E&!D1&D&C&!B1&B&!A1&!A|E1&E&!D1&D&C&!B1&B&!A1&!A|E1&!E&!D1&D&C&!B1&B&!A1&!A|E1&!E&!D1&D&C&!B1&B&A1&!A|E1&E&!D1&D&C&!B1&B&A1&!A|!E1&E&!D1&D&C&!B1&B&A1&!A|!E1&E&D1&D&C&!B1&B&A1&!A|E1&E&D1&D&C&!B1&B&A1&!A|E1&!E&D1&D&C&!B1&B&A1&!A|E1&!E&D1&!D&C&!B1&B&A1&!A|E1&E&D1&!D&C&!B1&B&A1&!A|!E1&E&D1&!D&C&!B1&B&A1&!A|!E1&E&D1&!D&C&B1&B&A1&!A|E1&E&D1&!D&C&B1&B&A1&!A|E1&!E&D1&!D&C&B1&B&A1&!A|E1&!E&D1&D&C&B1&B&A1&!A|E1&E&D1&D&C&B1&B&A1&!A|!E1&E&D1&D&C&B1&B&A1&!A|!E1&E&!D1&D&C&B1&B&A1&!A|E1&E&!D1&D&C&B1&B&A1&!A|E1&!E&!D1&D&C&B1&B&A1&!A|E1&!E&!D1&D&!C&B1&B&A1&!A|E1&E&!D1&D&!C&B1&B&A1&!A|!E1&E&!D1&D&!C&B1&B&A1&!A|!E1&E&D1&D&!C&B1&B&A1&!A|E1&E&D1&D&!C&B1&B&A1&!A|E1&!E&D1&D&!C&B1&B&A1&!A|E1&!E&D1&!D&!C&B1&B&A1&!A|E1&E&D1&!D&!C&B1&B&A1&!A|!E1&E&D1&!D&!C&B1&B&A1&!A|E1&!E&!D1&D&C&B1&!B&A1&!A|E1&E&!D1&D&C&B1&!B&A1&!A|!E1&E&!D1&D&C&B1&!B&A1&!A|!E1&E&D1&D&C&B1&!B&A1&!A|E1&E&D1&D&C&B1&!B&A1&!A|E1&!E&D1&D&C&B1&!B&A1&!A|E1&!E&D1&!D&C&B1&!B&A1&!A|E1&E&D1&!D&C&B1&!B&A1&!A|!E1&E&D1&!D&C&B1&!B&A1&!A|!E1&E&D1&!D&C&!B1&!B&A1&!A|E1&E&D1&!D&C&!B1&!B&A1&!A|E1&!E&D1&!D&C&!B1&!B&A1&!A|E1&!E&D1&D&C&!B1&!B&A1&!A|E1&E&D1&D&C&!B1&!B&A1&!A|!E1&E&D1&D&C&!B1&!B&A1&!A|!E1&E&!D1&D&C&!B1&!B&A1&!A|E1&E&!D1&D&C&!B1&!B&A1&!A|E1&!E&!D1&D&C&!B1&!B&A1&!A|!E1&E&D1&!D&!C&!B1&!B&A1&A|E1&E&D1&!D&!C&!B1&!B&A1&A|E1&!E&D1&!D&!C&!B1&!B&A1&A|E1&!E&D1&D&!C&!B1&!B&A1&A|E1&E&D1&D&!C&!B1&!B&A1&A|!E1&E&D1&D&!C&!B1&!B&A1&A|!E1&E&!D1&D&!C&!B1&!B&A1&A|E1&E&!D1&D&!C&!B1&!B&A1&A|E1&!E&!D1&D&!C&!B1&!B&A1&A|E1&!E&!D1&D&C&!B1&!B&A1&A|E1&E&!D1&D&C&!B1&!B&A1&A|!E1&E&!D1&D&C&!B1&!B&A1&A|!E1&E&D1&D&C&!B1&!B&A1&A|E1&E&D1&D&C&!B1&!B&A1&A|E1&!E&D1&D&C&!B1&!B&A1&A|E1&!E&D1&!D&C&!B1&!B&A1&A|E1&E&D1&!D&C&!B1&!B&A1&A|!E1&E&D1&!D&C&!B1&!B&A1&A|!E1&E&D1&!D&C&B1&!B&A1&A|E1&E&D1&!D&C&B1&!B&A1&A|E1&!E&D1&!D&C&B1&!B&A1&A|E1&!E&D1&D&C&B1&!B&A1&A|E1&E&D1&D&C&B1&!B&A1&A|!E1&E&D1&D&C&B1&!B&A1&A|!E1&E&!D1&D&C&B1&!B&A1&A|E1&E&!D1&D&C&B1&!B&A1&A|E1&!E&!D1&D&C&B1&!B&A1&A|E1&!E&!D1&D&!C&B1&!B&A1&A|E1&E&!D1&D&!C&B1&!B&A1&A|!E1&E&!D1&D&!C&B1&!B&A1&A|!E1&E&D1&D&!C&B1&!B&A1&A|E1&E&D1&D&!C&B1&!B&A1&A|E1&!E&D1&D&!C&B1&!B&A1&A|E1&!E&D1&!D&!C&B1&!B&A1&A|E1&E&D1&!D&!C&B1&!B&A1&A|!E1&E&D1&!D&!C&B1&!B&A1&A|!E1&E&D1&!D&!C&B1&B&A1&A|E1&E&D1&!D&!C&B1&B&A1&A|E1&!E&D1&!D&!C&B1&B&A1&A|E1&!E&D1&D&!C&B1&B&A1&A|E1&E&D1&D&!C&B1&B&A1&A|!E1&E&D1&D&!C&B1&B&A1&A|!E1&E&!D1&D&!C&B1&B&A1&A|E1&E&!D1&D&!C&B1&B&A1&A|E1&!E&!D1&D&!C&B1&B&A1&A|E1&!E&!D1&D&C&B1&B&A1&A|E1&E&!D1&D&C&B1&B&A1&A|!E1&E&!D1&D&C&B1&B&A1&A|!E1&E&D1&D&C&B1&B&A1&A|E1&E&D1&D&C&B1&B&A1&A|E1&!E&D1&D&C&B1&B&A1&A|E1&!E&D1&!D&C&B1&B&A1&A|E1&E&D1&!D&C&B1&B&A1&A|!E1&E&D1&!D&C&B1&B&A1&A|!E1&E&D1&!D&C&!B1&B&A1&A|E1&E&D1&!D&C&!B1&B&A1&A|E1&!E&D1&!D&C&!B1&B&A1&A|E1&!E&D1&D&C&!B1&B&A1&A|E1&E&D1&D&C&!B1&B&A1&A|!E1&E&D1&D&C&!B1&B&A1&A|!E1&E&!D1&D&C&!B1&B&A1&A|E1&E&!D1&D&C&!B1&B&A1&A|E1&!E&!D1&D&C&!B1&B&A1&A|E1&!E&!D1&D&!C&!B1&B&A1&A|E1&E&!D1&D&!C&!B1&B&A1&A|!E1&E&!D1&D&!C&!B1&B&A1&A|!E1&E&D1&D&!C&!B1&B&A1&A|E1&E&D1&D&!C&!B1&B&A1&A|E1&!E&D1&D&!C&!B1&B&A1&A|E1&!E&D1&!D&!C&!B1&B&A1&A|E1&E&D1&!D&!C&!B1&B&A1&A|!E1&E&D1&!D&!C&!B1&B&A1&A|E1&!E&!D1&D&C&!B1&B&!A1&A|E1&E&!D1&D&C&!B1&B&!A1&A|!E1&E&!D1&D&C&!B1&B&!A1&A|!E1&E&D1&D&C&!B1&B&!A1&A|E1&E&D1&D&C&!B1&B&!A1&A|E1&!E&D1&D&C&!B1&B&!A1&A|E1&!E&D1&!D&C&!B1&B&!A1&A|E1&E&D1&!D&C&!B1&B&!A1&A|!E1&E&D1&!D&C&!B1&B&!A1&A|!E1&E&D1&!D&C&B1&B&!A1&A|E1&E&D1&!D&C&B1&B&!A1&A|E1&!E&D1&!D&C&B1&B&!A1&A|E1&!E&D1&D&C&B1&B&!A1&A|E1&E&D1&D&C&B1&B&!A1&A|!E1&E&D1&D&C&B1&B&!A1&A|!E1&E&!D1&D&C&B1&B&!A1&A|E1&E&!D1&D&C&B1&B&!A1&A|E1&!E&!D1&D&C&B1&B&!A1&A|E1&!E&!D1&D&!C&B1&B&!A1&A|E1&E&!D1&D&!C&B1&B&!A1&A|!E1&E&!D1&D&!C&B1&B&!A1&A|!E1&E&D1&D&!C&B1&B&!A1&A|E1&E&D1&D&!C&B1&B&!A1&A|E1&!E&D1&D&!C&B1&B&!A1&A|E1&!E&D1&!D&!C&B1&B&!A1&A|E1&E&D1&!D&!C&B1&B&!A1&A|!E1&E&D1&!D&!C&B1&B&!A1&A|E1&!E&!D1&D&C&B1&!B&!A1&A|E1&E&!D1&D&C&B1&!B&!A1&A|!E1&E&!D1&D&C&B1&!B&!A1&A|!E1&E&D1&D&C&B1&!B&!A1&A|E1&E&D1&D&C&B1&!B&!A1&A|E1&!E&D1&D&C&B1&!B&!A1&A|E1&!E&D1&!D&C&B1&!B&!A1&A|E1&E&D1&!D&C&B1&!B&!A1&A|!E1&E&D1&!D&C&B1&!B&!A1&A|!E1&E&D1&!D&C&!B1&!B&!A1&A|E1&E&D1&!D&C&!B1&!B&!A1&A|E1&!E&D1&!D&C&!B1&!B&!A1&A|E1&!E&D1&D&C&!B1&!B&!A1&A|E1&E&D1&D&C&!B1&!B&!A1&A|!E1&E&D1&D&C&!B1&!B&!A1&A|!E1&E&!D1&D&C&!B1&!B&!A1&A|E1&E&!D1&D&C&!B1&!B&!A1&A|E1&!E&!D1&D&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOOAI22122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOI2211 -l OOAOI2211 -i D C B1 B A1 A -o Y -f Y=(!D&!C&!B1&!B&!A1&!A|!D&C&!B1&!B&!A1&!A|!D&C&B1&!B&!A1&!A|!D&!C&B1&!B&!A1&!A|!D&!C&B1&B&!A1&!A|!D&C&B1&B&!A1&!A|!D&C&!B1&B&!A1&!A|!D&!C&!B1&B&!A1&!A|!D&!C&!B1&B&A1&!A|!D&!C&B1&B&A1&!A|!D&!C&B1&!B&A1&!A|!D&C&!B1&!B&A1&!A|!D&!C&!B1&!B&A1&!A|!D&!C&!B1&!B&A1&A|!D&C&!B1&!B&A1&A|!D&!C&B1&!B&A1&A|!D&!C&B1&B&A1&A|!D&!C&!B1&B&A1&A|!D&!C&!B1&B&!A1&A|!D&!C&B1&B&!A1&A|!D&!C&B1&!B&!A1&A|!D&C&!B1&!B&!A1&A|!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOI2211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOOAOI212121 -l AOOAOOAOI212121 -i F E1 E D C1 C B A1 A -o Y -f Y=(!F&!E1&!E&!D&!C1&!C&!B&!A1&!A|!F&E1&!E&!D&!C1&!C&!B&!A1&!A|!F&E1&E&!D&!C1&!C&!B&!A1&!A|!F&!E1&E&!D&!C1&!C&!B&!A1&!A|!F&!E1&!E&D&!C1&!C&!B&!A1&!A|!F&!E1&!E&D&C1&!C&!B&!A1&!A|!F&!E1&E&!D&C1&!C&!B&!A1&!A|!F&E1&E&!D&C1&!C&!B&!A1&!A|!F&E1&!E&!D&C1&!C&!B&!A1&!A|!F&!E1&!E&!D&C1&!C&!B&!A1&!A|!F&!E1&!E&!D&C1&C&!B&!A1&!A|!F&E1&!E&!D&C1&C&!B&!A1&!A|!F&E1&E&!D&C1&C&!B&!A1&!A|!F&!E1&E&!D&C1&C&!B&!A1&!A|!F&!E1&!E&D&C1&C&!B&!A1&!A|!F&!E1&!E&D&!C1&C&!B&!A1&!A|!F&!E1&E&!D&!C1&C&!B&!A1&!A|!F&E1&E&!D&!C1&C&!B&!A1&!A|!F&E1&!E&!D&!C1&C&!B&!A1&!A|!F&!E1&!E&!D&!C1&C&!B&!A1&!A|!F&!E1&!E&!D&!C1&C&B&!A1&!A|!F&!E1&!E&D&!C1&C&B&!A1&!A|!F&!E1&!E&D&C1&C&B&!A1&!A|!F&!E1&!E&!D&C1&C&B&!A1&!A|!F&!E1&!E&!D&C1&!C&B&!A1&!A|!F&!E1&!E&D&C1&!C&B&!A1&!A|!F&!E1&!E&D&!C1&!C&B&!A1&!A|!F&!E1&E&!D&!C1&!C&B&!A1&!A|!F&E1&E&!D&!C1&!C&B&!A1&!A|!F&E1&!E&!D&!C1&!C&B&!A1&!A|!F&!E1&!E&!D&!C1&!C&B&!A1&!A|!F&!E1&!E&!D&!C1&!C&B&A1&!A|!F&E1&!E&!D&!C1&!C&B&A1&!A|!F&E1&E&!D&!C1&!C&B&A1&!A|!F&!E1&E&!D&!C1&!C&B&A1&!A|!F&!E1&!E&D&!C1&!C&B&A1&!A|!F&!E1&!E&D&C1&!C&B&A1&!A|!F&!E1&!E&!D&C1&!C&B&A1&!A|!F&!E1&!E&!D&C1&C&B&A1&!A|!F&!E1&!E&D&C1&C&B&A1&!A|!F&!E1&!E&D&!C1&C&B&A1&!A|!F&!E1&!E&!D&!C1&C&B&A1&!A|!F&!E1&!E&!D&!C1&C&!B&A1&!A|!F&E1&!E&!D&!C1&C&!B&A1&!A|!F&E1&E&!D&!C1&C&!B&A1&!A|!F&!E1&E&!D&!C1&C&!B&A1&!A|!F&!E1&!E&D&!C1&C&!B&A1&!A|!F&!E1&!E&D&C1&C&!B&A1&!A|!F&!E1&E&!D&C1&C&!B&A1&!A|!F&E1&E&!D&C1&C&!B&A1&!A|!F&E1&!E&!D&C1&C&!B&A1&!A|!F&!E1&!E&!D&C1&C&!B&A1&!A|!F&!E1&!E&!D&C1&!C&!B&A1&!A|!F&E1&!E&!D&C1&!C&!B&A1&!A|!F&E1&E&!D&C1&!C&!B&A1&!A|!F&!E1&E&!D&C1&!C&!B&A1&!A|!F&!E1&!E&D&C1&!C&!B&A1&!A|!F&!E1&!E&D&!C1&!C&!B&A1&!A|!F&!E1&E&!D&!C1&!C&!B&A1&!A|!F&E1&E&!D&!C1&!C&!B&A1&!A|!F&E1&!E&!D&!C1&!C&!B&A1&!A|!F&!E1&!E&!D&!C1&!C&!B&A1&!A|!F&!E1&!E&!D&!C1&!C&!B&A1&A|!F&E1&!E&!D&!C1&!C&!B&A1&A|!F&E1&E&!D&!C1&!C&!B&A1&A|!F&!E1&E&!D&!C1&!C&!B&A1&A|!F&!E1&!E&D&!C1&!C&!B&A1&A|!F&!E1&!E&D&C1&!C&!B&A1&A|!F&!E1&!E&!D&C1&!C&!B&A1&A|!F&!E1&!E&!D&C1&C&!B&A1&A|!F&!E1&!E&D&C1&C&!B&A1&A|!F&!E1&!E&D&!C1&C&!B&A1&A|!F&!E1&!E&!D&!C1&C&!B&A1&A|!F&!E1&!E&!D&!C1&C&B&A1&A|!F&!E1&!E&D&!C1&C&B&A1&A|!F&!E1&!E&D&C1&C&B&A1&A|!F&!E1&!E&!D&C1&C&B&A1&A|!F&!E1&!E&!D&C1&!C&B&A1&A|!F&!E1&!E&D&C1&!C&B&A1&A|!F&!E1&!E&D&!C1&!C&B&A1&A|!F&!E1&E&!D&!C1&!C&B&A1&A|!F&E1&E&!D&!C1&!C&B&A1&A|!F&E1&!E&!D&!C1&!C&B&A1&A|!F&!E1&!E&!D&!C1&!C&B&A1&A|!F&!E1&!E&!D&!C1&!C&B&!A1&A|!F&E1&!E&!D&!C1&!C&B&!A1&A|!F&E1&E&!D&!C1&!C&B&!A1&A|!F&!E1&E&!D&!C1&!C&B&!A1&A|!F&!E1&!E&D&!C1&!C&B&!A1&A|!F&!E1&!E&D&C1&!C&B&!A1&A|!F&!E1&!E&!D&C1&!C&B&!A1&A|!F&!E1&!E&!D&C1&C&B&!A1&A|!F&!E1&!E&D&C1&C&B&!A1&A|!F&!E1&!E&D&!C1&C&B&!A1&A|!F&!E1&!E&!D&!C1&C&B&!A1&A|!F&!E1&!E&!D&!C1&C&!B&!A1&A|!F&E1&!E&!D&!C1&C&!B&!A1&A|!F&E1&E&!D&!C1&C&!B&!A1&A|!F&!E1&E&!D&!C1&C&!B&!A1&A|!F&!E1&!E&D&!C1&C&!B&!A1&A|!F&!E1&!E&D&C1&C&!B&!A1&A|!F&!E1&E&!D&C1&C&!B&!A1&A|!F&E1&E&!D&C1&C&!B&!A1&A|!F&E1&!E&!D&C1&C&!B&!A1&A|!F&!E1&!E&!D&C1&C&!B&!A1&A|!F&!E1&!E&!D&C1&!C&!B&!A1&A|!F&E1&!E&!D&C1&!C&!B&!A1&A|!F&E1&E&!D&C1&!C&!B&!A1&A|!F&!E1&E&!D&C1&!C&!B&!A1&A|!F&!E1&!E&D&C1&!C&!B&!A1&A|!F&!E1&!E&D&!C1&!C&!B&!A1&A|!F&!E1&E&!D&!C1&!C&!B&!A1&A|!F&E1&E&!D&!C1&!C&!B&!A1&A|!F&E1&!E&!D&!C1&!C&!B&!A1&A|!F&!E1&!E&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOOAOI212121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOAAOI212112 -l AOOAOAAOI212112 -i F1 F E D C1 C B A1 A -o Y -f Y=(!F1&!F&!E&!D&!C1&!C&!B&!A1&!A|F1&!F&!E&!D&!C1&!C&!B&!A1&!A|!F1&F&!E&!D&!C1&!C&!B&!A1&!A|!F1&F&E&!D&!C1&!C&!B&!A1&!A|F1&!F&E&!D&!C1&!C&!B&!A1&!A|!F1&!F&E&!D&!C1&!C&!B&!A1&!A|!F1&F&!E&D&!C1&!C&!B&!A1&!A|F1&!F&!E&D&!C1&!C&!B&!A1&!A|!F1&!F&!E&D&!C1&!C&!B&!A1&!A|!F1&!F&!E&D&C1&!C&!B&!A1&!A|F1&!F&!E&D&C1&!C&!B&!A1&!A|!F1&F&!E&D&C1&!C&!B&!A1&!A|!F1&!F&E&!D&C1&!C&!B&!A1&!A|F1&!F&E&!D&C1&!C&!B&!A1&!A|!F1&F&E&!D&C1&!C&!B&!A1&!A|!F1&F&!E&!D&C1&!C&!B&!A1&!A|F1&!F&!E&!D&C1&!C&!B&!A1&!A|!F1&!F&!E&!D&C1&!C&!B&!A1&!A|!F1&!F&!E&!D&C1&C&!B&!A1&!A|F1&!F&!E&!D&C1&C&!B&!A1&!A|!F1&F&!E&!D&C1&C&!B&!A1&!A|!F1&F&E&!D&C1&C&!B&!A1&!A|F1&!F&E&!D&C1&C&!B&!A1&!A|!F1&!F&E&!D&C1&C&!B&!A1&!A|!F1&F&!E&D&C1&C&!B&!A1&!A|F1&!F&!E&D&C1&C&!B&!A1&!A|!F1&!F&!E&D&C1&C&!B&!A1&!A|!F1&!F&!E&D&!C1&C&!B&!A1&!A|F1&!F&!E&D&!C1&C&!B&!A1&!A|!F1&F&!E&D&!C1&C&!B&!A1&!A|!F1&!F&E&!D&!C1&C&!B&!A1&!A|F1&!F&E&!D&!C1&C&!B&!A1&!A|!F1&F&E&!D&!C1&C&!B&!A1&!A|!F1&F&!E&!D&!C1&C&!B&!A1&!A|F1&!F&!E&!D&!C1&C&!B&!A1&!A|!F1&!F&!E&!D&!C1&C&!B&!A1&!A|!F1&!F&!E&!D&!C1&C&B&!A1&!A|F1&!F&!E&!D&!C1&C&B&!A1&!A|!F1&F&!E&!D&!C1&C&B&!A1&!A|!F1&F&!E&D&!C1&C&B&!A1&!A|F1&!F&!E&D&!C1&C&B&!A1&!A|!F1&!F&!E&D&!C1&C&B&!A1&!A|!F1&!F&!E&D&C1&C&B&!A1&!A|F1&!F&!E&D&C1&C&B&!A1&!A|!F1&F&!E&D&C1&C&B&!A1&!A|!F1&F&!E&!D&C1&C&B&!A1&!A|F1&!F&!E&!D&C1&C&B&!A1&!A|!F1&!F&!E&!D&C1&C&B&!A1&!A|!F1&!F&!E&!D&C1&!C&B&!A1&!A|F1&!F&!E&!D&C1&!C&B&!A1&!A|!F1&F&!E&!D&C1&!C&B&!A1&!A|!F1&F&!E&D&C1&!C&B&!A1&!A|F1&!F&!E&D&C1&!C&B&!A1&!A|!F1&!F&!E&D&C1&!C&B&!A1&!A|!F1&!F&!E&D&!C1&!C&B&!A1&!A|F1&!F&!E&D&!C1&!C&B&!A1&!A|!F1&F&!E&D&!C1&!C&B&!A1&!A|!F1&!F&E&!D&!C1&!C&B&!A1&!A|F1&!F&E&!D&!C1&!C&B&!A1&!A|!F1&F&E&!D&!C1&!C&B&!A1&!A|!F1&F&!E&!D&!C1&!C&B&!A1&!A|F1&!F&!E&!D&!C1&!C&B&!A1&!A|!F1&!F&!E&!D&!C1&!C&B&!A1&!A|!F1&!F&!E&!D&!C1&!C&B&A1&!A|F1&!F&!E&!D&!C1&!C&B&A1&!A|!F1&F&!E&!D&!C1&!C&B&A1&!A|!F1&F&E&!D&!C1&!C&B&A1&!A|F1&!F&E&!D&!C1&!C&B&A1&!A|!F1&!F&E&!D&!C1&!C&B&A1&!A|!F1&F&!E&D&!C1&!C&B&A1&!A|F1&!F&!E&D&!C1&!C&B&A1&!A|!F1&!F&!E&D&!C1&!C&B&A1&!A|!F1&!F&!E&D&C1&!C&B&A1&!A|F1&!F&!E&D&C1&!C&B&A1&!A|!F1&F&!E&D&C1&!C&B&A1&!A|!F1&F&!E&!D&C1&!C&B&A1&!A|F1&!F&!E&!D&C1&!C&B&A1&!A|!F1&!F&!E&!D&C1&!C&B&A1&!A|!F1&!F&!E&!D&C1&C&B&A1&!A|F1&!F&!E&!D&C1&C&B&A1&!A|!F1&F&!E&!D&C1&C&B&A1&!A|!F1&F&!E&D&C1&C&B&A1&!A|F1&!F&!E&D&C1&C&B&A1&!A|!F1&!F&!E&D&C1&C&B&A1&!A|!F1&!F&!E&D&!C1&C&B&A1&!A|F1&!F&!E&D&!C1&C&B&A1&!A|!F1&F&!E&D&!C1&C&B&A1&!A|!F1&F&!E&!D&!C1&C&B&A1&!A|F1&!F&!E&!D&!C1&C&B&A1&!A|!F1&!F&!E&!D&!C1&C&B&A1&!A|!F1&!F&!E&!D&!C1&C&!B&A1&!A|F1&!F&!E&!D&!C1&C&!B&A1&!A|!F1&F&!E&!D&!C1&C&!B&A1&!A|!F1&F&E&!D&!C1&C&!B&A1&!A|F1&!F&E&!D&!C1&C&!B&A1&!A|!F1&!F&E&!D&!C1&C&!B&A1&!A|!F1&F&!E&D&!C1&C&!B&A1&!A|F1&!F&!E&D&!C1&C&!B&A1&!A|!F1&!F&!E&D&!C1&C&!B&A1&!A|!F1&!F&!E&D&C1&C&!B&A1&!A|F1&!F&!E&D&C1&C&!B&A1&!A|!F1&F&!E&D&C1&C&!B&A1&!A|!F1&!F&E&!D&C1&C&!B&A1&!A|F1&!F&E&!D&C1&C&!B&A1&!A|!F1&F&E&!D&C1&C&!B&A1&!A|!F1&F&!E&!D&C1&C&!B&A1&!A|F1&!F&!E&!D&C1&C&!B&A1&!A|!F1&!F&!E&!D&C1&C&!B&A1&!A|!F1&!F&!E&!D&C1&!C&!B&A1&!A|F1&!F&!E&!D&C1&!C&!B&A1&!A|!F1&F&!E&!D&C1&!C&!B&A1&!A|!F1&F&E&!D&C1&!C&!B&A1&!A|F1&!F&E&!D&C1&!C&!B&A1&!A|!F1&!F&E&!D&C1&!C&!B&A1&!A|!F1&F&!E&D&C1&!C&!B&A1&!A|F1&!F&!E&D&C1&!C&!B&A1&!A|!F1&!F&!E&D&C1&!C&!B&A1&!A|!F1&!F&!E&D&!C1&!C&!B&A1&!A|F1&!F&!E&D&!C1&!C&!B&A1&!A|!F1&F&!E&D&!C1&!C&!B&A1&!A|!F1&!F&E&!D&!C1&!C&!B&A1&!A|F1&!F&E&!D&!C1&!C&!B&A1&!A|!F1&F&E&!D&!C1&!C&!B&A1&!A|!F1&F&!E&!D&!C1&!C&!B&A1&!A|F1&!F&!E&!D&!C1&!C&!B&A1&!A|!F1&!F&!E&!D&!C1&!C&!B&A1&!A|!F1&!F&!E&!D&!C1&!C&!B&A1&A|F1&!F&!E&!D&!C1&!C&!B&A1&A|!F1&F&!E&!D&!C1&!C&!B&A1&A|!F1&F&E&!D&!C1&!C&!B&A1&A|F1&!F&E&!D&!C1&!C&!B&A1&A|!F1&!F&E&!D&!C1&!C&!B&A1&A|!F1&F&!E&D&!C1&!C&!B&A1&A|F1&!F&!E&D&!C1&!C&!B&A1&A|!F1&!F&!E&D&!C1&!C&!B&A1&A|!F1&!F&!E&D&C1&!C&!B&A1&A|F1&!F&!E&D&C1&!C&!B&A1&A|!F1&F&!E&D&C1&!C&!B&A1&A|!F1&F&!E&!D&C1&!C&!B&A1&A|F1&!F&!E&!D&C1&!C&!B&A1&A|!F1&!F&!E&!D&C1&!C&!B&A1&A|!F1&!F&!E&!D&C1&C&!B&A1&A|F1&!F&!E&!D&C1&C&!B&A1&A|!F1&F&!E&!D&C1&C&!B&A1&A|!F1&F&!E&D&C1&C&!B&A1&A|F1&!F&!E&D&C1&C&!B&A1&A|!F1&!F&!E&D&C1&C&!B&A1&A|!F1&!F&!E&D&!C1&C&!B&A1&A|F1&!F&!E&D&!C1&C&!B&A1&A|!F1&F&!E&D&!C1&C&!B&A1&A|!F1&F&!E&!D&!C1&C&!B&A1&A|F1&!F&!E&!D&!C1&C&!B&A1&A|!F1&!F&!E&!D&!C1&C&!B&A1&A|!F1&!F&!E&!D&!C1&C&B&A1&A|F1&!F&!E&!D&!C1&C&B&A1&A|!F1&F&!E&!D&!C1&C&B&A1&A|!F1&F&!E&D&!C1&C&B&A1&A|F1&!F&!E&D&!C1&C&B&A1&A|!F1&!F&!E&D&!C1&C&B&A1&A|!F1&!F&!E&D&C1&C&B&A1&A|F1&!F&!E&D&C1&C&B&A1&A|!F1&F&!E&D&C1&C&B&A1&A|!F1&F&!E&!D&C1&C&B&A1&A|F1&!F&!E&!D&C1&C&B&A1&A|!F1&!F&!E&!D&C1&C&B&A1&A|!F1&!F&!E&!D&C1&!C&B&A1&A|F1&!F&!E&!D&C1&!C&B&A1&A|!F1&F&!E&!D&C1&!C&B&A1&A|!F1&F&!E&D&C1&!C&B&A1&A|F1&!F&!E&D&C1&!C&B&A1&A|!F1&!F&!E&D&C1&!C&B&A1&A|!F1&!F&!E&D&!C1&!C&B&A1&A|F1&!F&!E&D&!C1&!C&B&A1&A|!F1&F&!E&D&!C1&!C&B&A1&A|!F1&!F&E&!D&!C1&!C&B&A1&A|F1&!F&E&!D&!C1&!C&B&A1&A|!F1&F&E&!D&!C1&!C&B&A1&A|!F1&F&!E&!D&!C1&!C&B&A1&A|F1&!F&!E&!D&!C1&!C&B&A1&A|!F1&!F&!E&!D&!C1&!C&B&A1&A|!F1&!F&!E&!D&!C1&!C&B&!A1&A|F1&!F&!E&!D&!C1&!C&B&!A1&A|!F1&F&!E&!D&!C1&!C&B&!A1&A|!F1&F&E&!D&!C1&!C&B&!A1&A|F1&!F&E&!D&!C1&!C&B&!A1&A|!F1&!F&E&!D&!C1&!C&B&!A1&A|!F1&F&!E&D&!C1&!C&B&!A1&A|F1&!F&!E&D&!C1&!C&B&!A1&A|!F1&!F&!E&D&!C1&!C&B&!A1&A|!F1&!F&!E&D&C1&!C&B&!A1&A|F1&!F&!E&D&C1&!C&B&!A1&A|!F1&F&!E&D&C1&!C&B&!A1&A|!F1&F&!E&!D&C1&!C&B&!A1&A|F1&!F&!E&!D&C1&!C&B&!A1&A|!F1&!F&!E&!D&C1&!C&B&!A1&A|!F1&!F&!E&!D&C1&C&B&!A1&A|F1&!F&!E&!D&C1&C&B&!A1&A|!F1&F&!E&!D&C1&C&B&!A1&A|!F1&F&!E&D&C1&C&B&!A1&A|F1&!F&!E&D&C1&C&B&!A1&A|!F1&!F&!E&D&C1&C&B&!A1&A|!F1&!F&!E&D&!C1&C&B&!A1&A|F1&!F&!E&D&!C1&C&B&!A1&A|!F1&F&!E&D&!C1&C&B&!A1&A|!F1&F&!E&!D&!C1&C&B&!A1&A|F1&!F&!E&!D&!C1&C&B&!A1&A|!F1&!F&!E&!D&!C1&C&B&!A1&A|!F1&!F&!E&!D&!C1&C&!B&!A1&A|F1&!F&!E&!D&!C1&C&!B&!A1&A|!F1&F&!E&!D&!C1&C&!B&!A1&A|!F1&F&E&!D&!C1&C&!B&!A1&A|F1&!F&E&!D&!C1&C&!B&!A1&A|!F1&!F&E&!D&!C1&C&!B&!A1&A|!F1&F&!E&D&!C1&C&!B&!A1&A|F1&!F&!E&D&!C1&C&!B&!A1&A|!F1&!F&!E&D&!C1&C&!B&!A1&A|!F1&!F&!E&D&C1&C&!B&!A1&A|F1&!F&!E&D&C1&C&!B&!A1&A|!F1&F&!E&D&C1&C&!B&!A1&A|!F1&!F&E&!D&C1&C&!B&!A1&A|F1&!F&E&!D&C1&C&!B&!A1&A|!F1&F&E&!D&C1&C&!B&!A1&A|!F1&F&!E&!D&C1&C&!B&!A1&A|F1&!F&!E&!D&C1&C&!B&!A1&A|!F1&!F&!E&!D&C1&C&!B&!A1&A|!F1&!F&!E&!D&C1&!C&!B&!A1&A|F1&!F&!E&!D&C1&!C&!B&!A1&A|!F1&F&!E&!D&C1&!C&!B&!A1&A|!F1&F&E&!D&C1&!C&!B&!A1&A|F1&!F&E&!D&C1&!C&!B&!A1&A|!F1&!F&E&!D&C1&!C&!B&!A1&A|!F1&F&!E&D&C1&!C&!B&!A1&A|F1&!F&!E&D&C1&!C&!B&!A1&A|!F1&!F&!E&D&C1&!C&!B&!A1&A|!F1&!F&!E&D&!C1&!C&!B&!A1&A|F1&!F&!E&D&!C1&!C&!B&!A1&A|!F1&F&!E&D&!C1&!C&!B&!A1&A|!F1&!F&E&!D&!C1&!C&!B&!A1&A|F1&!F&E&!D&!C1&!C&!B&!A1&A|!F1&F&E&!D&!C1&!C&!B&!A1&A|!F1&F&!E&!D&!C1&!C&!B&!A1&A|F1&!F&!E&!D&!C1&!C&!B&!A1&A|!F1&!F&!E&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOAAOI212112.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOI321 -l OOAOI321 -i C B1 B A2 A1 A -o Y -f Y=(!C&!B1&!B&!A2&!A1&!A|!C&B1&!B&!A2&!A1&!A|!C&B1&B&!A2&!A1&!A|!C&!B1&B&!A2&!A1&!A|!C&!B1&!B&A2&!A1&!A|!C&!B1&!B&A2&A1&!A|!C&!B1&!B&!A2&A1&!A|!C&!B1&!B&!A2&A1&A|!C&!B1&!B&A2&A1&A|!C&!B1&!B&A2&!A1&A|!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOI321.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOI2213 -l OOAAOI2213 -i D2 D1 D C B1 B A1 A -o Y -f Y=!(D2&D1&D&!C&!B1&!B&!A1&!A|D2&D1&D&C&!B1&!B&!A1&!A|D2&D1&D&C&B1&!B&!A1&!A|D2&D1&D&!C&B1&!B&!A1&!A|D2&D1&D&!C&B1&B&!A1&!A|D2&D1&D&C&B1&B&!A1&!A|D2&D1&D&C&!B1&B&!A1&!A|D2&D1&D&!C&!B1&B&!A1&!A|D2&D1&D&!C&!B1&B&A1&!A|!D2&!D1&D&C&!B1&B&A1&!A|D2&!D1&D&C&!B1&B&A1&!A|D2&D1&D&C&!B1&B&A1&!A|!D2&D1&D&C&!B1&B&A1&!A|!D2&D1&!D&C&!B1&B&A1&!A|D2&D1&!D&C&!B1&B&A1&!A|D2&!D1&!D&C&!B1&B&A1&!A|!D2&!D1&!D&C&!B1&B&A1&!A|!D2&!D1&!D&C&B1&B&A1&!A|D2&!D1&!D&C&B1&B&A1&!A|D2&D1&!D&C&B1&B&A1&!A|!D2&D1&!D&C&B1&B&A1&!A|!D2&D1&D&C&B1&B&A1&!A|D2&D1&D&C&B1&B&A1&!A|D2&!D1&D&C&B1&B&A1&!A|!D2&!D1&D&C&B1&B&A1&!A|D2&D1&D&!C&B1&B&A1&!A|D2&D1&D&!C&B1&!B&A1&!A|!D2&!D1&D&C&B1&!B&A1&!A|D2&!D1&D&C&B1&!B&A1&!A|D2&D1&D&C&B1&!B&A1&!A|!D2&D1&D&C&B1&!B&A1&!A|!D2&D1&!D&C&B1&!B&A1&!A|D2&D1&!D&C&B1&!B&A1&!A|D2&!D1&!D&C&B1&!B&A1&!A|!D2&!D1&!D&C&B1&!B&A1&!A|D2&D1&D&C&!B1&!B&A1&!A|D2&D1&D&!C&!B1&!B&A1&!A|D2&D1&D&!C&!B1&!B&A1&A|D2&D1&D&C&!B1&!B&A1&A|!D2&!D1&!D&C&B1&!B&A1&A|D2&!D1&!D&C&B1&!B&A1&A|D2&D1&!D&C&B1&!B&A1&A|!D2&D1&!D&C&B1&!B&A1&A|!D2&D1&D&C&B1&!B&A1&A|D2&D1&D&C&B1&!B&A1&A|D2&!D1&D&C&B1&!B&A1&A|!D2&!D1&D&C&B1&!B&A1&A|D2&D1&D&!C&B1&!B&A1&A|D2&D1&D&!C&B1&B&A1&A|!D2&!D1&D&C&B1&B&A1&A|D2&!D1&D&C&B1&B&A1&A|D2&D1&D&C&B1&B&A1&A|!D2&D1&D&C&B1&B&A1&A|!D2&D1&!D&C&B1&B&A1&A|D2&D1&!D&C&B1&B&A1&A|D2&!D1&!D&C&B1&B&A1&A|!D2&!D1&!D&C&B1&B&A1&A|!D2&!D1&!D&C&!B1&B&A1&A|D2&!D1&!D&C&!B1&B&A1&A|D2&D1&!D&C&!B1&B&A1&A|!D2&D1&!D&C&!B1&B&A1&A|!D2&D1&D&C&!B1&B&A1&A|D2&D1&D&C&!B1&B&A1&A|D2&!D1&D&C&!B1&B&A1&A|!D2&!D1&D&C&!B1&B&A1&A|D2&D1&D&!C&!B1&B&A1&A|D2&D1&D&!C&!B1&B&!A1&A|!D2&!D1&D&C&!B1&B&!A1&A|D2&!D1&D&C&!B1&B&!A1&A|D2&D1&D&C&!B1&B&!A1&A|!D2&D1&D&C&!B1&B&!A1&A|!D2&D1&!D&C&!B1&B&!A1&A|D2&D1&!D&C&!B1&B&!A1&A|D2&!D1&!D&C&!B1&B&!A1&A|!D2&!D1&!D&C&!B1&B&!A1&A|!D2&!D1&!D&C&B1&B&!A1&A|D2&!D1&!D&C&B1&B&!A1&A|D2&D1&!D&C&B1&B&!A1&A|!D2&D1&!D&C&B1&B&!A1&A|!D2&D1&D&C&B1&B&!A1&A|D2&D1&D&C&B1&B&!A1&A|D2&!D1&D&C&B1&B&!A1&A|!D2&!D1&D&C&B1&B&!A1&A|D2&D1&D&!C&B1&B&!A1&A|D2&D1&D&!C&B1&!B&!A1&A|!D2&!D1&D&C&B1&!B&!A1&A|D2&!D1&D&C&B1&!B&!A1&A|D2&D1&D&C&B1&!B&!A1&A|!D2&D1&D&C&B1&!B&!A1&A|!D2&D1&!D&C&B1&!B&!A1&A|D2&D1&!D&C&B1&!B&!A1&A|D2&!D1&!D&C&B1&!B&!A1&A|!D2&!D1&!D&C&B1&!B&!A1&A|D2&D1&D&C&!B1&!B&!A1&A|D2&D1&D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOI2213.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOAI22211 -l AAAOAI22211 -i E D C1 C B1 B A1 A -o Y -f Y=!(E&D&!C1&!C&!B1&!B&!A1&!A|E&D&C1&!C&!B1&!B&!A1&!A|E&!D&C1&C&!B1&!B&!A1&!A|E&D&C1&C&!B1&!B&!A1&!A|E&D&!C1&C&!B1&!B&!A1&!A|E&D&!C1&C&B1&!B&!A1&!A|E&D&C1&C&B1&!B&!A1&!A|E&!D&C1&C&B1&!B&!A1&!A|E&D&C1&!C&B1&!B&!A1&!A|E&D&!C1&!C&B1&!B&!A1&!A|E&!D&!C1&!C&B1&B&!A1&!A|E&D&!C1&!C&B1&B&!A1&!A|E&D&C1&!C&B1&B&!A1&!A|E&!D&C1&!C&B1&B&!A1&!A|E&!D&C1&C&B1&B&!A1&!A|E&D&C1&C&B1&B&!A1&!A|E&D&!C1&C&B1&B&!A1&!A|E&!D&!C1&C&B1&B&!A1&!A|E&D&!C1&C&!B1&B&!A1&!A|E&D&C1&C&!B1&B&!A1&!A|E&!D&C1&C&!B1&B&!A1&!A|E&D&C1&!C&!B1&B&!A1&!A|E&D&!C1&!C&!B1&B&!A1&!A|E&D&!C1&!C&!B1&B&A1&!A|E&D&C1&!C&!B1&B&A1&!A|E&!D&C1&C&!B1&B&A1&!A|E&D&C1&C&!B1&B&A1&!A|E&D&!C1&C&!B1&B&A1&!A|E&!D&!C1&C&B1&B&A1&!A|E&D&!C1&C&B1&B&A1&!A|E&D&C1&C&B1&B&A1&!A|E&!D&C1&C&B1&B&A1&!A|E&!D&C1&!C&B1&B&A1&!A|E&D&C1&!C&B1&B&A1&!A|E&D&!C1&!C&B1&B&A1&!A|E&!D&!C1&!C&B1&B&A1&!A|E&D&!C1&!C&B1&!B&A1&!A|E&D&C1&!C&B1&!B&A1&!A|E&!D&C1&C&B1&!B&A1&!A|E&D&C1&C&B1&!B&A1&!A|E&D&!C1&C&B1&!B&A1&!A|E&D&!C1&C&!B1&!B&A1&!A|E&D&C1&C&!B1&!B&A1&!A|E&!D&C1&C&!B1&!B&A1&!A|E&D&C1&!C&!B1&!B&A1&!A|E&D&!C1&!C&!B1&!B&A1&!A|E&!D&!C1&!C&!B1&!B&A1&A|E&D&!C1&!C&!B1&!B&A1&A|E&D&C1&!C&!B1&!B&A1&A|E&!D&C1&!C&!B1&!B&A1&A|E&!D&C1&C&!B1&!B&A1&A|E&D&C1&C&!B1&!B&A1&A|E&D&!C1&C&!B1&!B&A1&A|E&!D&!C1&C&!B1&!B&A1&A|E&!D&!C1&C&B1&!B&A1&A|E&D&!C1&C&B1&!B&A1&A|E&D&C1&C&B1&!B&A1&A|E&!D&C1&C&B1&!B&A1&A|E&!D&C1&!C&B1&!B&A1&A|E&D&C1&!C&B1&!B&A1&A|E&D&!C1&!C&B1&!B&A1&A|E&!D&!C1&!C&B1&!B&A1&A|E&!D&!C1&!C&B1&B&A1&A|E&D&!C1&!C&B1&B&A1&A|E&D&C1&!C&B1&B&A1&A|E&!D&C1&!C&B1&B&A1&A|E&!D&C1&C&B1&B&A1&A|E&D&C1&C&B1&B&A1&A|E&D&!C1&C&B1&B&A1&A|E&!D&!C1&C&B1&B&A1&A|E&!D&!C1&C&!B1&B&A1&A|E&D&!C1&C&!B1&B&A1&A|E&D&C1&C&!B1&B&A1&A|E&!D&C1&C&!B1&B&A1&A|E&!D&C1&!C&!B1&B&A1&A|E&D&C1&!C&!B1&B&A1&A|E&D&!C1&!C&!B1&B&A1&A|E&!D&!C1&!C&!B1&B&A1&A|E&D&!C1&!C&!B1&B&!A1&A|E&D&C1&!C&!B1&B&!A1&A|E&!D&C1&C&!B1&B&!A1&A|E&D&C1&C&!B1&B&!A1&A|E&D&!C1&C&!B1&B&!A1&A|E&!D&!C1&C&B1&B&!A1&A|E&D&!C1&C&B1&B&!A1&A|E&D&C1&C&B1&B&!A1&A|E&!D&C1&C&B1&B&!A1&A|E&!D&C1&!C&B1&B&!A1&A|E&D&C1&!C&B1&B&!A1&A|E&D&!C1&!C&B1&B&!A1&A|E&!D&!C1&!C&B1&B&!A1&A|E&D&!C1&!C&B1&!B&!A1&A|E&D&C1&!C&B1&!B&!A1&A|E&!D&C1&C&B1&!B&!A1&A|E&D&C1&C&B1&!B&!A1&A|E&D&!C1&C&B1&!B&!A1&A|E&D&!C1&C&!B1&!B&!A1&A|E&D&C1&C&!B1&!B&!A1&A|E&!D&C1&C&!B1&!B&!A1&A|E&D&C1&!C&!B1&!B&!A1&A|E&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOAI22211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOI22121 -l AAOAAOI22121 -i E D1 D C B1 B A1 A -o Y -f Y=(!E&!D1&!D&!C&!B1&!B&!A1&!A|!E&D1&!D&!C&!B1&!B&!A1&!A|!E&!D1&D&!C&!B1&!B&!A1&!A|!E&!D1&D&C&!B1&!B&!A1&!A|!E&D1&!D&C&!B1&!B&!A1&!A|!E&!D1&!D&C&!B1&!B&!A1&!A|!E&!D1&!D&C&B1&!B&!A1&!A|!E&D1&!D&C&B1&!B&!A1&!A|!E&!D1&D&C&B1&!B&!A1&!A|!E&!D1&D&!C&B1&!B&!A1&!A|!E&D1&!D&!C&B1&!B&!A1&!A|!E&!D1&!D&!C&B1&!B&!A1&!A|!E&!D1&!D&!C&B1&B&!A1&!A|!E&D1&!D&!C&B1&B&!A1&!A|!E&!D1&D&!C&B1&B&!A1&!A|!E&!D1&!D&C&!B1&B&!A1&!A|!E&D1&!D&C&!B1&B&!A1&!A|!E&!D1&D&C&!B1&B&!A1&!A|!E&!D1&D&!C&!B1&B&!A1&!A|!E&D1&!D&!C&!B1&B&!A1&!A|!E&!D1&!D&!C&!B1&B&!A1&!A|!E&!D1&!D&!C&!B1&B&A1&!A|!E&D1&!D&!C&!B1&B&A1&!A|!E&!D1&D&!C&!B1&B&A1&!A|!E&!D1&D&C&!B1&B&A1&!A|!E&D1&!D&C&!B1&B&A1&!A|!E&!D1&!D&C&!B1&B&A1&!A|!E&!D1&D&!C&B1&B&A1&!A|!E&D1&!D&!C&B1&B&A1&!A|!E&!D1&!D&!C&B1&B&A1&!A|!E&!D1&!D&!C&B1&!B&A1&!A|!E&D1&!D&!C&B1&!B&A1&!A|!E&!D1&D&!C&B1&!B&A1&!A|!E&!D1&D&C&B1&!B&A1&!A|!E&D1&!D&C&B1&!B&A1&!A|!E&!D1&!D&C&B1&!B&A1&!A|!E&!D1&!D&C&!B1&!B&A1&!A|!E&D1&!D&C&!B1&!B&A1&!A|!E&!D1&D&C&!B1&!B&A1&!A|!E&!D1&D&!C&!B1&!B&A1&!A|!E&D1&!D&!C&!B1&!B&A1&!A|!E&!D1&!D&!C&!B1&!B&A1&!A|!E&!D1&!D&!C&!B1&!B&A1&A|!E&D1&!D&!C&!B1&!B&A1&A|!E&!D1&D&!C&!B1&!B&A1&A|!E&!D1&D&!C&B1&!B&A1&A|!E&D1&!D&!C&B1&!B&A1&A|!E&!D1&!D&!C&B1&!B&A1&A|!E&!D1&!D&!C&B1&B&A1&A|!E&D1&!D&!C&B1&B&A1&A|!E&!D1&D&!C&B1&B&A1&A|!E&!D1&D&!C&!B1&B&A1&A|!E&D1&!D&!C&!B1&B&A1&A|!E&!D1&!D&!C&!B1&B&A1&A|!E&!D1&!D&!C&!B1&B&!A1&A|!E&D1&!D&!C&!B1&B&!A1&A|!E&!D1&D&!C&!B1&B&!A1&A|!E&!D1&D&C&!B1&B&!A1&A|!E&D1&!D&C&!B1&B&!A1&A|!E&!D1&!D&C&!B1&B&!A1&A|!E&!D1&D&!C&B1&B&!A1&A|!E&D1&!D&!C&B1&B&!A1&A|!E&!D1&!D&!C&B1&B&!A1&A|!E&!D1&!D&!C&B1&!B&!A1&A|!E&D1&!D&!C&B1&!B&!A1&A|!E&!D1&D&!C&B1&!B&!A1&A|!E&!D1&D&C&B1&!B&!A1&A|!E&D1&!D&C&B1&!B&!A1&A|!E&!D1&!D&C&B1&!B&!A1&A|!E&!D1&!D&C&!B1&!B&!A1&A|!E&D1&!D&C&!B1&!B&!A1&A|!E&!D1&D&C&!B1&!B&!A1&A|!E&!D1&D&!C&!B1&!B&!A1&A|!E&D1&!D&!C&!B1&!B&!A1&A|!E&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOI22121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAAOI22241 -l OOOAAOI22241 -i E D3 D2 D1 D C1 C B1 B A1 A -o Y -f Y=(!E&!D3&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D3&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&!D3&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D3&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D3&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!E&D3&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D3&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&D3&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&D3&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&!D3&D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E&D3&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&D3&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&D3&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D3&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&D3&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&D3&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&!D3&D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E&D3&D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E&D3&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&D&C1&C&!B1&!B&!A1&!A|!E&D3&!D2&D1&D&C1&C&!B1&!B&!A1&!A|!E&!D3&D2&D1&D&C1&C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E&D3&D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&D3&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&!D3&D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E&D3&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&D3&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&D3&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D3&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&D3&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&D3&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&!D3&D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E&D3&D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E&D3&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E&!D3&!D2&D1&D&!C1&C&B1&!B&!A1&!A|!E&D3&!D2&D1&D&!C1&C&B1&!B&!A1&!A|!E&!D3&D2&D1&D&!C1&C&B1&!B&!A1&!A|!E&!D3&D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E&D3&D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E&D3&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&C1&C&B1&!B&!A1&!A|!E&D3&!D2&!D1&D&C1&C&B1&!B&!A1&!A|!E&D3&D2&!D1&D&C1&C&B1&!B&!A1&!A|!E&!D3&D2&!D1&D&C1&C&B1&!B&!A1&!A|!E&!D3&D2&D1&D&C1&C&B1&!B&!A1&!A|!E&D3&!D2&D1&D&C1&C&B1&!B&!A1&!A|!E&!D3&!D2&D1&D&C1&C&B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&C1&C&B1&!B&!A1&!A|!E&D3&!D2&D1&!D&C1&C&B1&!B&!A1&!A|!E&D3&D2&D1&!D&C1&C&B1&!B&!A1&!A|!E&!D3&D2&D1&!D&C1&C&B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E&D3&D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&D3&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&!D3&D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E&D3&D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E&D3&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E&!D3&!D2&D1&D&C1&!C&B1&!B&!A1&!A|!E&D3&!D2&D1&D&C1&!C&B1&!B&!A1&!A|!E&!D3&D2&D1&D&C1&!C&B1&!B&!A1&!A|!E&!D3&D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E&D3&D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E&D3&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&D3&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&D3&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&!D3&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&!D3&D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E&D3&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E&!D3&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&D3&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&D3&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D3&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&D3&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&D3&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&!D3&D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E&D3&D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E&D3&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E&!D3&!D2&D1&D&!C1&!C&B1&B&!A1&!A|!E&D3&!D2&D1&D&!C1&!C&B1&B&!A1&!A|!E&!D3&D2&D1&D&!C1&!C&B1&B&!A1&!A|!E&!D3&D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E&D3&D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E&D3&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E&!D3&!D2&!D1&D&C1&!C&B1&B&!A1&!A|!E&D3&!D2&!D1&D&C1&!C&B1&B&!A1&!A|!E&D3&D2&!D1&D&C1&!C&B1&B&!A1&!A|!E&!D3&D2&!D1&D&C1&!C&B1&B&!A1&!A|!E&!D3&D2&D1&D&C1&!C&B1&B&!A1&!A|!E&D3&!D2&D1&D&C1&!C&B1&B&!A1&!A|!E&!D3&!D2&D1&D&C1&!C&B1&B&!A1&!A|!E&!D3&!D2&D1&!D&C1&!C&B1&B&!A1&!A|!E&D3&!D2&D1&!D&C1&!C&B1&B&!A1&!A|!E&D3&D2&D1&!D&C1&!C&B1&B&!A1&!A|!E&!D3&D2&D1&!D&C1&!C&B1&B&!A1&!A|!E&!D3&D2&!D1&!D&C1&!C&B1&B&!A1&!A|!E&D3&D2&!D1&!D&C1&!C&B1&B&!A1&!A|!E&D3&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!E&!D3&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!E&!D3&!D2&!D1&!D&C1&C&B1&B&!A1&!A|!E&D3&!D2&!D1&!D&C1&C&B1&B&!A1&!A|!E&D3&D2&!D1&!D&C1&C&B1&B&!A1&!A|!E&!D3&D2&!D1&!D&C1&C&B1&B&!A1&!A|!E&!D3&D2&D1&!D&C1&C&B1&B&!A1&!A|!E&D3&D2&D1&!D&C1&C&B1&B&!A1&!A|!E&D3&!D2&D1&!D&C1&C&B1&B&!A1&!A|!E&!D3&!D2&D1&!D&C1&C&B1&B&!A1&!A|!E&!D3&!D2&D1&D&C1&C&B1&B&!A1&!A|!E&D3&!D2&D1&D&C1&C&B1&B&!A1&!A|!E&!D3&D2&D1&D&C1&C&B1&B&!A1&!A|!E&!D3&D2&!D1&D&C1&C&B1&B&!A1&!A|!E&D3&D2&!D1&D&C1&C&B1&B&!A1&!A|!E&D3&!D2&!D1&D&C1&C&B1&B&!A1&!A|!E&!D3&!D2&!D1&D&C1&C&B1&B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&C&B1&B&!A1&!A|!E&D3&!D2&!D1&D&!C1&C&B1&B&!A1&!A|!E&D3&D2&!D1&D&!C1&C&B1&B&!A1&!A|!E&!D3&D2&!D1&D&!C1&C&B1&B&!A1&!A|!E&!D3&D2&D1&D&!C1&C&B1&B&!A1&!A|!E&D3&!D2&D1&D&!C1&C&B1&B&!A1&!A|!E&!D3&!D2&D1&D&!C1&C&B1&B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&C&B1&B&!A1&!A|!E&D3&!D2&D1&!D&!C1&C&B1&B&!A1&!A|!E&D3&D2&D1&!D&!C1&C&B1&B&!A1&!A|!E&!D3&D2&D1&!D&!C1&C&B1&B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&C&B1&B&!A1&!A|!E&D3&D2&!D1&!D&!C1&C&B1&B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&D3&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&!D3&D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E&D3&D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E&D3&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E&!D3&!D2&D1&D&!C1&C&!B1&B&!A1&!A|!E&D3&!D2&D1&D&!C1&C&!B1&B&!A1&!A|!E&!D3&D2&D1&D&!C1&C&!B1&B&!A1&!A|!E&!D3&D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E&D3&D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E&D3&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&D&C1&C&!B1&B&!A1&!A|!E&D3&!D2&!D1&D&C1&C&!B1&B&!A1&!A|!E&D3&D2&!D1&D&C1&C&!B1&B&!A1&!A|!E&!D3&D2&!D1&D&C1&C&!B1&B&!A1&!A|!E&!D3&D2&D1&D&C1&C&!B1&B&!A1&!A|!E&D3&!D2&D1&D&C1&C&!B1&B&!A1&!A|!E&!D3&!D2&D1&D&C1&C&!B1&B&!A1&!A|!E&!D3&!D2&D1&!D&C1&C&!B1&B&!A1&!A|!E&D3&!D2&D1&!D&C1&C&!B1&B&!A1&!A|!E&D3&D2&D1&!D&C1&C&!B1&B&!A1&!A|!E&!D3&D2&D1&!D&C1&C&!B1&B&!A1&!A|!E&!D3&D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E&D3&D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E&D3&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&D3&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&D3&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&!D3&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&!D3&D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E&D3&D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E&D3&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E&!D3&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E&!D3&!D2&D1&D&C1&!C&!B1&B&!A1&!A|!E&D3&!D2&D1&D&C1&!C&!B1&B&!A1&!A|!E&!D3&D2&D1&D&C1&!C&!B1&B&!A1&!A|!E&!D3&D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E&D3&D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E&D3&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&D3&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&D3&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&!D3&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&!D3&D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E&D3&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E&!D3&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&D3&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&D3&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D3&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&D3&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&D3&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&!D3&D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E&D3&D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E&D3&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E&!D3&!D2&D1&D&!C1&!C&!B1&B&A1&!A|!E&D3&!D2&D1&D&!C1&!C&!B1&B&A1&!A|!E&!D3&D2&D1&D&!C1&!C&!B1&B&A1&!A|!E&!D3&D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E&D3&D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E&D3&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&B1&B&A1&!A|!E&D3&!D2&!D1&D&!C1&!C&B1&B&A1&!A|!E&D3&D2&!D1&D&!C1&!C&B1&B&A1&!A|!E&!D3&D2&!D1&D&!C1&!C&B1&B&A1&!A|!E&!D3&D2&D1&D&!C1&!C&B1&B&A1&!A|!E&D3&!D2&D1&D&!C1&!C&B1&B&A1&!A|!E&!D3&!D2&D1&D&!C1&!C&B1&B&A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&B1&B&A1&!A|!E&D3&!D2&D1&!D&!C1&!C&B1&B&A1&!A|!E&D3&D2&D1&!D&!C1&!C&B1&B&A1&!A|!E&!D3&D2&D1&!D&!C1&!C&B1&B&A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E&D3&D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&D3&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&!D3&D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E&D3&D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E&D3&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E&!D3&!D2&D1&D&!C1&!C&B1&!B&A1&!A|!E&D3&!D2&D1&D&!C1&!C&B1&!B&A1&!A|!E&!D3&D2&D1&D&!C1&!C&B1&!B&A1&!A|!E&!D3&D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E&D3&D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E&D3&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E&!D3&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&D3&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&D3&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&!D3&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&!D3&D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E&D3&D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E&D3&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E&!D3&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E&!D3&!D2&D1&D&!C1&C&!B1&!B&A1&!A|!E&D3&!D2&D1&D&!C1&C&!B1&!B&A1&!A|!E&!D3&D2&D1&D&!C1&C&!B1&!B&A1&!A|!E&!D3&D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E&D3&D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E&D3&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&D&C1&C&!B1&!B&A1&!A|!E&D3&!D2&!D1&D&C1&C&!B1&!B&A1&!A|!E&D3&D2&!D1&D&C1&C&!B1&!B&A1&!A|!E&!D3&D2&!D1&D&C1&C&!B1&!B&A1&!A|!E&!D3&D2&D1&D&C1&C&!B1&!B&A1&!A|!E&D3&!D2&D1&D&C1&C&!B1&!B&A1&!A|!E&!D3&!D2&D1&D&C1&C&!B1&!B&A1&!A|!E&!D3&!D2&D1&!D&C1&C&!B1&!B&A1&!A|!E&D3&!D2&D1&!D&C1&C&!B1&!B&A1&!A|!E&D3&D2&D1&!D&C1&C&!B1&!B&A1&!A|!E&!D3&D2&D1&!D&C1&C&!B1&!B&A1&!A|!E&!D3&D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E&D3&D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E&D3&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&D3&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&D3&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&!D3&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&!D3&D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E&D3&D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E&D3&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E&!D3&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E&!D3&!D2&D1&D&C1&!C&!B1&!B&A1&!A|!E&D3&!D2&D1&D&C1&!C&!B1&!B&A1&!A|!E&!D3&D2&D1&D&C1&!C&!B1&!B&A1&!A|!E&!D3&D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E&D3&D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E&D3&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&D3&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&D3&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&!D3&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&!D3&D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E&D3&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E&!D3&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&D3&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&D3&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D3&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&D3&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&D3&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&D3&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&!D3&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&!D3&D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E&D3&D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E&D3&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E&!D3&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E&!D3&!D2&D1&D&!C1&!C&!B1&!B&A1&A|!E&D3&!D2&D1&D&!C1&!C&!B1&!B&A1&A|!E&!D3&D2&D1&D&!C1&!C&!B1&!B&A1&A|!E&!D3&D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E&D3&D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E&D3&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E&!D3&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E&!D3&!D2&!D1&D&C1&!C&!B1&!B&A1&A|!E&D3&!D2&!D1&D&C1&!C&!B1&!B&A1&A|!E&D3&D2&!D1&D&C1&!C&!B1&!B&A1&A|!E&!D3&D2&!D1&D&C1&!C&!B1&!B&A1&A|!E&!D3&D2&D1&D&C1&!C&!B1&!B&A1&A|!E&D3&!D2&D1&D&C1&!C&!B1&!B&A1&A|!E&!D3&!D2&D1&D&C1&!C&!B1&!B&A1&A|!E&!D3&!D2&D1&!D&C1&!C&!B1&!B&A1&A|!E&D3&!D2&D1&!D&C1&!C&!B1&!B&A1&A|!E&D3&D2&D1&!D&C1&!C&!B1&!B&A1&A|!E&!D3&D2&D1&!D&C1&!C&!B1&!B&A1&A|!E&!D3&D2&!D1&!D&C1&!C&!B1&!B&A1&A|!E&D3&D2&!D1&!D&C1&!C&!B1&!B&A1&A|!E&D3&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!E&!D3&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!E&!D3&!D2&!D1&!D&C1&C&!B1&!B&A1&A|!E&D3&!D2&!D1&!D&C1&C&!B1&!B&A1&A|!E&D3&D2&!D1&!D&C1&C&!B1&!B&A1&A|!E&!D3&D2&!D1&!D&C1&C&!B1&!B&A1&A|!E&!D3&D2&D1&!D&C1&C&!B1&!B&A1&A|!E&D3&D2&D1&!D&C1&C&!B1&!B&A1&A|!E&D3&!D2&D1&!D&C1&C&!B1&!B&A1&A|!E&!D3&!D2&D1&!D&C1&C&!B1&!B&A1&A|!E&!D3&!D2&D1&D&C1&C&!B1&!B&A1&A|!E&D3&!D2&D1&D&C1&C&!B1&!B&A1&A|!E&!D3&D2&D1&D&C1&C&!B1&!B&A1&A|!E&!D3&D2&!D1&D&C1&C&!B1&!B&A1&A|!E&D3&D2&!D1&D&C1&C&!B1&!B&A1&A|!E&D3&!D2&!D1&D&C1&C&!B1&!B&A1&A|!E&!D3&!D2&!D1&D&C1&C&!B1&!B&A1&A|!E&!D3&!D2&!D1&D&!C1&C&!B1&!B&A1&A|!E&D3&!D2&!D1&D&!C1&C&!B1&!B&A1&A|!E&D3&D2&!D1&D&!C1&C&!B1&!B&A1&A|!E&!D3&D2&!D1&D&!C1&C&!B1&!B&A1&A|!E&!D3&D2&D1&D&!C1&C&!B1&!B&A1&A|!E&D3&!D2&D1&D&!C1&C&!B1&!B&A1&A|!E&!D3&!D2&D1&D&!C1&C&!B1&!B&A1&A|!E&!D3&!D2&D1&!D&!C1&C&!B1&!B&A1&A|!E&D3&!D2&D1&!D&!C1&C&!B1&!B&A1&A|!E&D3&D2&D1&!D&!C1&C&!B1&!B&A1&A|!E&!D3&D2&D1&!D&!C1&C&!B1&!B&A1&A|!E&!D3&D2&!D1&!D&!C1&C&!B1&!B&A1&A|!E&D3&D2&!D1&!D&!C1&C&!B1&!B&A1&A|!E&D3&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!E&!D3&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!E&!D3&!D2&!D1&D&!C1&!C&B1&!B&A1&A|!E&D3&!D2&!D1&D&!C1&!C&B1&!B&A1&A|!E&D3&D2&!D1&D&!C1&!C&B1&!B&A1&A|!E&!D3&D2&!D1&D&!C1&!C&B1&!B&A1&A|!E&!D3&D2&D1&D&!C1&!C&B1&!B&A1&A|!E&D3&!D2&D1&D&!C1&!C&B1&!B&A1&A|!E&!D3&!D2&D1&D&!C1&!C&B1&!B&A1&A|!E&!D3&!D2&D1&!D&!C1&!C&B1&!B&A1&A|!E&D3&!D2&D1&!D&!C1&!C&B1&!B&A1&A|!E&D3&D2&D1&!D&!C1&!C&B1&!B&A1&A|!E&!D3&D2&D1&!D&!C1&!C&B1&!B&A1&A|!E&!D3&D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E&D3&D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E&D3&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E&!D3&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E&!D3&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!E&D3&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!E&D3&D2&!D1&!D&!C1&!C&B1&B&A1&A|!E&!D3&D2&!D1&!D&!C1&!C&B1&B&A1&A|!E&!D3&D2&D1&!D&!C1&!C&B1&B&A1&A|!E&D3&D2&D1&!D&!C1&!C&B1&B&A1&A|!E&D3&!D2&D1&!D&!C1&!C&B1&B&A1&A|!E&!D3&!D2&D1&!D&!C1&!C&B1&B&A1&A|!E&!D3&!D2&D1&D&!C1&!C&B1&B&A1&A|!E&D3&!D2&D1&D&!C1&!C&B1&B&A1&A|!E&!D3&D2&D1&D&!C1&!C&B1&B&A1&A|!E&!D3&D2&!D1&D&!C1&!C&B1&B&A1&A|!E&D3&D2&!D1&D&!C1&!C&B1&B&A1&A|!E&D3&!D2&!D1&D&!C1&!C&B1&B&A1&A|!E&!D3&!D2&!D1&D&!C1&!C&B1&B&A1&A|!E&!D3&!D2&!D1&D&!C1&!C&!B1&B&A1&A|!E&D3&!D2&!D1&D&!C1&!C&!B1&B&A1&A|!E&D3&D2&!D1&D&!C1&!C&!B1&B&A1&A|!E&!D3&D2&!D1&D&!C1&!C&!B1&B&A1&A|!E&!D3&D2&D1&D&!C1&!C&!B1&B&A1&A|!E&D3&!D2&D1&D&!C1&!C&!B1&B&A1&A|!E&!D3&!D2&D1&D&!C1&!C&!B1&B&A1&A|!E&!D3&!D2&D1&!D&!C1&!C&!B1&B&A1&A|!E&D3&!D2&D1&!D&!C1&!C&!B1&B&A1&A|!E&D3&D2&D1&!D&!C1&!C&!B1&B&A1&A|!E&!D3&D2&D1&!D&!C1&!C&!B1&B&A1&A|!E&!D3&D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E&D3&D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E&D3&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E&!D3&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E&!D3&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&D3&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&D3&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&!D3&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&!D3&D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E&D3&D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E&D3&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E&!D3&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E&!D3&!D2&D1&D&!C1&!C&!B1&B&!A1&A|!E&D3&!D2&D1&D&!C1&!C&!B1&B&!A1&A|!E&!D3&D2&D1&D&!C1&!C&!B1&B&!A1&A|!E&!D3&D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E&D3&D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E&D3&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E&!D3&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E&!D3&!D2&!D1&D&!C1&!C&B1&B&!A1&A|!E&D3&!D2&!D1&D&!C1&!C&B1&B&!A1&A|!E&D3&D2&!D1&D&!C1&!C&B1&B&!A1&A|!E&!D3&D2&!D1&D&!C1&!C&B1&B&!A1&A|!E&!D3&D2&D1&D&!C1&!C&B1&B&!A1&A|!E&D3&!D2&D1&D&!C1&!C&B1&B&!A1&A|!E&!D3&!D2&D1&D&!C1&!C&B1&B&!A1&A|!E&!D3&!D2&D1&!D&!C1&!C&B1&B&!A1&A|!E&D3&!D2&D1&!D&!C1&!C&B1&B&!A1&A|!E&D3&D2&D1&!D&!C1&!C&B1&B&!A1&A|!E&!D3&D2&D1&!D&!C1&!C&B1&B&!A1&A|!E&!D3&D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E&D3&D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E&D3&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E&!D3&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E&!D3&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&D3&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&D3&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&!D3&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&!D3&D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E&D3&D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E&D3&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E&!D3&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E&!D3&!D2&D1&D&!C1&!C&B1&!B&!A1&A|!E&D3&!D2&D1&D&!C1&!C&B1&!B&!A1&A|!E&!D3&D2&D1&D&!C1&!C&B1&!B&!A1&A|!E&!D3&D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E&D3&D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E&D3&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E&!D3&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E&!D3&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&D3&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&D3&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&!D3&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&!D3&D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E&D3&D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E&D3&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E&!D3&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E&!D3&!D2&D1&D&!C1&C&!B1&!B&!A1&A|!E&D3&!D2&D1&D&!C1&C&!B1&!B&!A1&A|!E&!D3&D2&D1&D&!C1&C&!B1&!B&!A1&A|!E&!D3&D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E&D3&D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E&D3&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E&!D3&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E&!D3&!D2&!D1&D&C1&C&!B1&!B&!A1&A|!E&D3&!D2&!D1&D&C1&C&!B1&!B&!A1&A|!E&D3&D2&!D1&D&C1&C&!B1&!B&!A1&A|!E&!D3&D2&!D1&D&C1&C&!B1&!B&!A1&A|!E&!D3&D2&D1&D&C1&C&!B1&!B&!A1&A|!E&D3&!D2&D1&D&C1&C&!B1&!B&!A1&A|!E&!D3&!D2&D1&D&C1&C&!B1&!B&!A1&A|!E&!D3&!D2&D1&!D&C1&C&!B1&!B&!A1&A|!E&D3&!D2&D1&!D&C1&C&!B1&!B&!A1&A|!E&D3&D2&D1&!D&C1&C&!B1&!B&!A1&A|!E&!D3&D2&D1&!D&C1&C&!B1&!B&!A1&A|!E&!D3&D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E&D3&D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E&D3&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E&!D3&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E&!D3&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&D3&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&D3&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&!D3&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&!D3&D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E&D3&D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E&D3&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E&!D3&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E&!D3&!D2&D1&D&C1&!C&!B1&!B&!A1&A|!E&D3&!D2&D1&D&C1&!C&!B1&!B&!A1&A|!E&!D3&D2&D1&D&C1&!C&!B1&!B&!A1&A|!E&!D3&D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E&D3&D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E&D3&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E&!D3&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E&!D3&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&D3&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&D3&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&!D3&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&!D3&D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E&D3&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E&!D3&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E&!D3&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&D3&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&D3&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&!D3&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&!D3&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E&D3&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E&D3&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E&!D3&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAAOI22241.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAOI32211 -l OOOAOI32211 -i E D C1 C B1 B A2 A1 A -o Y -f Y=(!E&!D&!C1&!C&!B1&!B&!A2&!A1&!A|!E&D&!C1&!C&!B1&!B&!A2&!A1&!A|!E&D&C1&!C&!B1&!B&!A2&!A1&!A|!E&!D&C1&!C&!B1&!B&!A2&!A1&!A|!E&!D&C1&C&!B1&!B&!A2&!A1&!A|!E&D&C1&C&!B1&!B&!A2&!A1&!A|!E&D&!C1&C&!B1&!B&!A2&!A1&!A|!E&!D&!C1&C&!B1&!B&!A2&!A1&!A|!E&!D&!C1&C&B1&!B&!A2&!A1&!A|!E&D&!C1&C&B1&!B&!A2&!A1&!A|!E&D&C1&C&B1&!B&!A2&!A1&!A|!E&!D&C1&C&B1&!B&!A2&!A1&!A|!E&!D&C1&!C&B1&!B&!A2&!A1&!A|!E&D&C1&!C&B1&!B&!A2&!A1&!A|!E&D&!C1&!C&B1&!B&!A2&!A1&!A|!E&!D&!C1&!C&B1&!B&!A2&!A1&!A|!E&!D&!C1&!C&B1&B&!A2&!A1&!A|!E&D&!C1&!C&B1&B&!A2&!A1&!A|!E&D&C1&!C&B1&B&!A2&!A1&!A|!E&!D&C1&!C&B1&B&!A2&!A1&!A|!E&!D&C1&C&B1&B&!A2&!A1&!A|!E&D&C1&C&B1&B&!A2&!A1&!A|!E&D&!C1&C&B1&B&!A2&!A1&!A|!E&!D&!C1&C&B1&B&!A2&!A1&!A|!E&!D&!C1&C&!B1&B&!A2&!A1&!A|!E&D&!C1&C&!B1&B&!A2&!A1&!A|!E&D&C1&C&!B1&B&!A2&!A1&!A|!E&!D&C1&C&!B1&B&!A2&!A1&!A|!E&!D&C1&!C&!B1&B&!A2&!A1&!A|!E&D&C1&!C&!B1&B&!A2&!A1&!A|!E&D&!C1&!C&!B1&B&!A2&!A1&!A|!E&!D&!C1&!C&!B1&B&!A2&!A1&!A|!E&!D&!C1&!C&!B1&B&A2&!A1&!A|!E&D&!C1&!C&!B1&B&A2&!A1&!A|!E&!D&C1&!C&!B1&B&A2&!A1&!A|!E&!D&C1&C&!B1&B&A2&!A1&!A|!E&!D&!C1&C&!B1&B&A2&!A1&!A|!E&!D&!C1&C&B1&B&A2&!A1&!A|!E&!D&C1&C&B1&B&A2&!A1&!A|!E&!D&C1&!C&B1&B&A2&!A1&!A|!E&D&!C1&!C&B1&B&A2&!A1&!A|!E&!D&!C1&!C&B1&B&A2&!A1&!A|!E&!D&!C1&!C&B1&!B&A2&!A1&!A|!E&D&!C1&!C&B1&!B&A2&!A1&!A|!E&!D&C1&!C&B1&!B&A2&!A1&!A|!E&!D&C1&C&B1&!B&A2&!A1&!A|!E&!D&!C1&C&B1&!B&A2&!A1&!A|!E&!D&!C1&C&!B1&!B&A2&!A1&!A|!E&D&!C1&C&!B1&!B&A2&!A1&!A|!E&D&C1&C&!B1&!B&A2&!A1&!A|!E&!D&C1&C&!B1&!B&A2&!A1&!A|!E&!D&C1&!C&!B1&!B&A2&!A1&!A|!E&D&C1&!C&!B1&!B&A2&!A1&!A|!E&D&!C1&!C&!B1&!B&A2&!A1&!A|!E&!D&!C1&!C&!B1&!B&A2&!A1&!A|!E&!D&!C1&!C&!B1&!B&A2&A1&!A|!E&D&!C1&!C&!B1&!B&A2&A1&!A|!E&D&C1&!C&!B1&!B&A2&A1&!A|!E&!D&C1&!C&!B1&!B&A2&A1&!A|!E&!D&C1&C&!B1&!B&A2&A1&!A|!E&D&C1&C&!B1&!B&A2&A1&!A|!E&D&!C1&C&!B1&!B&A2&A1&!A|!E&!D&!C1&C&!B1&!B&A2&A1&!A|!E&!D&!C1&C&B1&!B&A2&A1&!A|!E&!D&C1&C&B1&!B&A2&A1&!A|!E&!D&C1&!C&B1&!B&A2&A1&!A|!E&D&!C1&!C&B1&!B&A2&A1&!A|!E&!D&!C1&!C&B1&!B&A2&A1&!A|!E&!D&!C1&!C&B1&B&A2&A1&!A|!E&D&!C1&!C&B1&B&A2&A1&!A|!E&!D&C1&!C&B1&B&A2&A1&!A|!E&!D&C1&C&B1&B&A2&A1&!A|!E&!D&!C1&C&B1&B&A2&A1&!A|!E&!D&!C1&C&!B1&B&A2&A1&!A|!E&!D&C1&C&!B1&B&A2&A1&!A|!E&!D&C1&!C&!B1&B&A2&A1&!A|!E&D&!C1&!C&!B1&B&A2&A1&!A|!E&!D&!C1&!C&!B1&B&A2&A1&!A|!E&!D&!C1&!C&!B1&B&!A2&A1&!A|!E&D&!C1&!C&!B1&B&!A2&A1&!A|!E&!D&C1&!C&!B1&B&!A2&A1&!A|!E&!D&C1&C&!B1&B&!A2&A1&!A|!E&!D&!C1&C&!B1&B&!A2&A1&!A|!E&!D&!C1&C&B1&B&!A2&A1&!A|!E&!D&C1&C&B1&B&!A2&A1&!A|!E&!D&C1&!C&B1&B&!A2&A1&!A|!E&D&!C1&!C&B1&B&!A2&A1&!A|!E&!D&!C1&!C&B1&B&!A2&A1&!A|!E&!D&!C1&!C&B1&!B&!A2&A1&!A|!E&D&!C1&!C&B1&!B&!A2&A1&!A|!E&!D&C1&!C&B1&!B&!A2&A1&!A|!E&!D&C1&C&B1&!B&!A2&A1&!A|!E&!D&!C1&C&B1&!B&!A2&A1&!A|!E&!D&!C1&C&!B1&!B&!A2&A1&!A|!E&D&!C1&C&!B1&!B&!A2&A1&!A|!E&D&C1&C&!B1&!B&!A2&A1&!A|!E&!D&C1&C&!B1&!B&!A2&A1&!A|!E&!D&C1&!C&!B1&!B&!A2&A1&!A|!E&D&C1&!C&!B1&!B&!A2&A1&!A|!E&D&!C1&!C&!B1&!B&!A2&A1&!A|!E&!D&!C1&!C&!B1&!B&!A2&A1&!A|!E&!D&!C1&!C&!B1&!B&!A2&A1&A|!E&D&!C1&!C&!B1&!B&!A2&A1&A|!E&D&C1&!C&!B1&!B&!A2&A1&A|!E&!D&C1&!C&!B1&!B&!A2&A1&A|!E&!D&C1&C&!B1&!B&!A2&A1&A|!E&D&C1&C&!B1&!B&!A2&A1&A|!E&D&!C1&C&!B1&!B&!A2&A1&A|!E&!D&!C1&C&!B1&!B&!A2&A1&A|!E&!D&!C1&C&B1&!B&!A2&A1&A|!E&!D&C1&C&B1&!B&!A2&A1&A|!E&!D&C1&!C&B1&!B&!A2&A1&A|!E&D&!C1&!C&B1&!B&!A2&A1&A|!E&!D&!C1&!C&B1&!B&!A2&A1&A|!E&!D&!C1&!C&B1&B&!A2&A1&A|!E&D&!C1&!C&B1&B&!A2&A1&A|!E&!D&C1&!C&B1&B&!A2&A1&A|!E&!D&C1&C&B1&B&!A2&A1&A|!E&!D&!C1&C&B1&B&!A2&A1&A|!E&!D&!C1&C&!B1&B&!A2&A1&A|!E&!D&C1&C&!B1&B&!A2&A1&A|!E&!D&C1&!C&!B1&B&!A2&A1&A|!E&D&!C1&!C&!B1&B&!A2&A1&A|!E&!D&!C1&!C&!B1&B&!A2&A1&A|!E&!D&!C1&!C&!B1&B&A2&A1&A|!E&D&!C1&!C&!B1&B&A2&A1&A|!E&!D&C1&!C&!B1&B&A2&A1&A|!E&!D&C1&C&!B1&B&A2&A1&A|!E&!D&!C1&C&!B1&B&A2&A1&A|!E&!D&!C1&C&B1&B&A2&A1&A|!E&!D&C1&C&B1&B&A2&A1&A|!E&!D&C1&!C&B1&B&A2&A1&A|!E&D&!C1&!C&B1&B&A2&A1&A|!E&!D&!C1&!C&B1&B&A2&A1&A|!E&!D&!C1&!C&B1&!B&A2&A1&A|!E&D&!C1&!C&B1&!B&A2&A1&A|!E&!D&C1&!C&B1&!B&A2&A1&A|!E&!D&C1&C&B1&!B&A2&A1&A|!E&!D&!C1&C&B1&!B&A2&A1&A|!E&!D&!C1&C&!B1&!B&A2&A1&A|!E&D&!C1&C&!B1&!B&A2&A1&A|!E&D&C1&C&!B1&!B&A2&A1&A|!E&!D&C1&C&!B1&!B&A2&A1&A|!E&!D&C1&!C&!B1&!B&A2&A1&A|!E&D&C1&!C&!B1&!B&A2&A1&A|!E&D&!C1&!C&!B1&!B&A2&A1&A|!E&!D&!C1&!C&!B1&!B&A2&A1&A|!E&!D&!C1&!C&!B1&!B&A2&!A1&A|!E&D&!C1&!C&!B1&!B&A2&!A1&A|!E&D&C1&!C&!B1&!B&A2&!A1&A|!E&!D&C1&!C&!B1&!B&A2&!A1&A|!E&!D&C1&C&!B1&!B&A2&!A1&A|!E&D&C1&C&!B1&!B&A2&!A1&A|!E&D&!C1&C&!B1&!B&A2&!A1&A|!E&!D&!C1&C&!B1&!B&A2&!A1&A|!E&!D&!C1&C&B1&!B&A2&!A1&A|!E&!D&C1&C&B1&!B&A2&!A1&A|!E&!D&C1&!C&B1&!B&A2&!A1&A|!E&D&!C1&!C&B1&!B&A2&!A1&A|!E&!D&!C1&!C&B1&!B&A2&!A1&A|!E&!D&!C1&!C&B1&B&A2&!A1&A|!E&D&!C1&!C&B1&B&A2&!A1&A|!E&!D&C1&!C&B1&B&A2&!A1&A|!E&!D&C1&C&B1&B&A2&!A1&A|!E&!D&!C1&C&B1&B&A2&!A1&A|!E&!D&!C1&C&!B1&B&A2&!A1&A|!E&!D&C1&C&!B1&B&A2&!A1&A|!E&!D&C1&!C&!B1&B&A2&!A1&A|!E&D&!C1&!C&!B1&B&A2&!A1&A|!E&!D&!C1&!C&!B1&B&A2&!A1&A|!E&!D&!C1&!C&!B1&B&!A2&!A1&A|!E&D&!C1&!C&!B1&B&!A2&!A1&A|!E&!D&C1&!C&!B1&B&!A2&!A1&A|!E&!D&C1&C&!B1&B&!A2&!A1&A|!E&!D&!C1&C&!B1&B&!A2&!A1&A|!E&!D&!C1&C&B1&B&!A2&!A1&A|!E&!D&C1&C&B1&B&!A2&!A1&A|!E&!D&C1&!C&B1&B&!A2&!A1&A|!E&D&!C1&!C&B1&B&!A2&!A1&A|!E&!D&!C1&!C&B1&B&!A2&!A1&A|!E&!D&!C1&!C&B1&!B&!A2&!A1&A|!E&D&!C1&!C&B1&!B&!A2&!A1&A|!E&!D&C1&!C&B1&!B&!A2&!A1&A|!E&!D&C1&C&B1&!B&!A2&!A1&A|!E&!D&!C1&C&B1&!B&!A2&!A1&A|!E&!D&!C1&C&!B1&!B&!A2&!A1&A|!E&D&!C1&C&!B1&!B&!A2&!A1&A|!E&D&C1&C&!B1&!B&!A2&!A1&A|!E&!D&C1&C&!B1&!B&!A2&!A1&A|!E&!D&C1&!C&!B1&!B&!A2&!A1&A|!E&D&C1&!C&!B1&!B&!A2&!A1&A|!E&D&!C1&!C&!B1&!B&!A2&!A1&A|!E&!D&!C1&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAOI32211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOAI221211 -l OOAAOAI221211 -i F E D1 D C B1 B A1 A -o Y -f Y=!(F&E&!D1&!D&!C&!B1&!B&!A1&!A|F&E&D1&!D&!C&!B1&!B&!A1&!A|F&!E&D1&D&!C&!B1&!B&!A1&!A|F&E&D1&D&!C&!B1&!B&!A1&!A|F&E&!D1&D&!C&!B1&!B&!A1&!A|F&E&!D1&D&C&!B1&!B&!A1&!A|F&E&D1&D&C&!B1&!B&!A1&!A|F&!E&D1&D&C&!B1&!B&!A1&!A|F&E&D1&!D&C&!B1&!B&!A1&!A|F&E&!D1&!D&C&!B1&!B&!A1&!A|F&E&!D1&!D&C&B1&!B&!A1&!A|F&E&D1&!D&C&B1&!B&!A1&!A|F&!E&D1&D&C&B1&!B&!A1&!A|F&E&D1&D&C&B1&!B&!A1&!A|F&E&!D1&D&C&B1&!B&!A1&!A|F&E&!D1&D&!C&B1&!B&!A1&!A|F&E&D1&D&!C&B1&!B&!A1&!A|F&!E&D1&D&!C&B1&!B&!A1&!A|F&E&D1&!D&!C&B1&!B&!A1&!A|F&E&!D1&!D&!C&B1&!B&!A1&!A|F&E&!D1&!D&!C&B1&B&!A1&!A|F&E&D1&!D&!C&B1&B&!A1&!A|F&!E&D1&D&!C&B1&B&!A1&!A|F&E&D1&D&!C&B1&B&!A1&!A|F&E&!D1&D&!C&B1&B&!A1&!A|F&E&!D1&D&C&B1&B&!A1&!A|F&E&D1&D&C&B1&B&!A1&!A|F&!E&D1&D&C&B1&B&!A1&!A|F&E&D1&!D&C&B1&B&!A1&!A|F&E&!D1&!D&C&B1&B&!A1&!A|F&E&!D1&!D&C&!B1&B&!A1&!A|F&E&D1&!D&C&!B1&B&!A1&!A|F&!E&D1&D&C&!B1&B&!A1&!A|F&E&D1&D&C&!B1&B&!A1&!A|F&E&!D1&D&C&!B1&B&!A1&!A|F&E&!D1&D&!C&!B1&B&!A1&!A|F&E&D1&D&!C&!B1&B&!A1&!A|F&!E&D1&D&!C&!B1&B&!A1&!A|F&E&D1&!D&!C&!B1&B&!A1&!A|F&E&!D1&!D&!C&!B1&B&!A1&!A|F&E&!D1&!D&!C&!B1&B&A1&!A|F&E&D1&!D&!C&!B1&B&A1&!A|F&!E&D1&D&!C&!B1&B&A1&!A|F&E&D1&D&!C&!B1&B&A1&!A|F&E&!D1&D&!C&!B1&B&A1&!A|F&!E&!D1&D&C&!B1&B&A1&!A|F&E&!D1&D&C&!B1&B&A1&!A|F&E&D1&D&C&!B1&B&A1&!A|F&!E&D1&D&C&!B1&B&A1&!A|F&!E&D1&!D&C&!B1&B&A1&!A|F&E&D1&!D&C&!B1&B&A1&!A|F&E&!D1&!D&C&!B1&B&A1&!A|F&!E&!D1&!D&C&!B1&B&A1&!A|F&!E&!D1&!D&C&B1&B&A1&!A|F&E&!D1&!D&C&B1&B&A1&!A|F&E&D1&!D&C&B1&B&A1&!A|F&!E&D1&!D&C&B1&B&A1&!A|F&!E&D1&D&C&B1&B&A1&!A|F&E&D1&D&C&B1&B&A1&!A|F&E&!D1&D&C&B1&B&A1&!A|F&!E&!D1&D&C&B1&B&A1&!A|F&E&!D1&D&!C&B1&B&A1&!A|F&E&D1&D&!C&B1&B&A1&!A|F&!E&D1&D&!C&B1&B&A1&!A|F&E&D1&!D&!C&B1&B&A1&!A|F&E&!D1&!D&!C&B1&B&A1&!A|F&E&!D1&!D&!C&B1&!B&A1&!A|F&E&D1&!D&!C&B1&!B&A1&!A|F&!E&D1&D&!C&B1&!B&A1&!A|F&E&D1&D&!C&B1&!B&A1&!A|F&E&!D1&D&!C&B1&!B&A1&!A|F&!E&!D1&D&C&B1&!B&A1&!A|F&E&!D1&D&C&B1&!B&A1&!A|F&E&D1&D&C&B1&!B&A1&!A|F&!E&D1&D&C&B1&!B&A1&!A|F&!E&D1&!D&C&B1&!B&A1&!A|F&E&D1&!D&C&B1&!B&A1&!A|F&E&!D1&!D&C&B1&!B&A1&!A|F&!E&!D1&!D&C&B1&!B&A1&!A|F&E&!D1&!D&C&!B1&!B&A1&!A|F&E&D1&!D&C&!B1&!B&A1&!A|F&!E&D1&D&C&!B1&!B&A1&!A|F&E&D1&D&C&!B1&!B&A1&!A|F&E&!D1&D&C&!B1&!B&A1&!A|F&E&!D1&D&!C&!B1&!B&A1&!A|F&E&D1&D&!C&!B1&!B&A1&!A|F&!E&D1&D&!C&!B1&!B&A1&!A|F&E&D1&!D&!C&!B1&!B&A1&!A|F&E&!D1&!D&!C&!B1&!B&A1&!A|F&E&!D1&!D&!C&!B1&!B&A1&A|F&E&D1&!D&!C&!B1&!B&A1&A|F&!E&D1&D&!C&!B1&!B&A1&A|F&E&D1&D&!C&!B1&!B&A1&A|F&E&!D1&D&!C&!B1&!B&A1&A|F&E&!D1&D&C&!B1&!B&A1&A|F&E&D1&D&C&!B1&!B&A1&A|F&!E&D1&D&C&!B1&!B&A1&A|F&E&D1&!D&C&!B1&!B&A1&A|F&E&!D1&!D&C&!B1&!B&A1&A|F&!E&!D1&!D&C&B1&!B&A1&A|F&E&!D1&!D&C&B1&!B&A1&A|F&E&D1&!D&C&B1&!B&A1&A|F&!E&D1&!D&C&B1&!B&A1&A|F&!E&D1&D&C&B1&!B&A1&A|F&E&D1&D&C&B1&!B&A1&A|F&E&!D1&D&C&B1&!B&A1&A|F&!E&!D1&D&C&B1&!B&A1&A|F&E&!D1&D&!C&B1&!B&A1&A|F&E&D1&D&!C&B1&!B&A1&A|F&!E&D1&D&!C&B1&!B&A1&A|F&E&D1&!D&!C&B1&!B&A1&A|F&E&!D1&!D&!C&B1&!B&A1&A|F&E&!D1&!D&!C&B1&B&A1&A|F&E&D1&!D&!C&B1&B&A1&A|F&!E&D1&D&!C&B1&B&A1&A|F&E&D1&D&!C&B1&B&A1&A|F&E&!D1&D&!C&B1&B&A1&A|F&!E&!D1&D&C&B1&B&A1&A|F&E&!D1&D&C&B1&B&A1&A|F&E&D1&D&C&B1&B&A1&A|F&!E&D1&D&C&B1&B&A1&A|F&!E&D1&!D&C&B1&B&A1&A|F&E&D1&!D&C&B1&B&A1&A|F&E&!D1&!D&C&B1&B&A1&A|F&!E&!D1&!D&C&B1&B&A1&A|F&!E&!D1&!D&C&!B1&B&A1&A|F&E&!D1&!D&C&!B1&B&A1&A|F&E&D1&!D&C&!B1&B&A1&A|F&!E&D1&!D&C&!B1&B&A1&A|F&!E&D1&D&C&!B1&B&A1&A|F&E&D1&D&C&!B1&B&A1&A|F&E&!D1&D&C&!B1&B&A1&A|F&!E&!D1&D&C&!B1&B&A1&A|F&E&!D1&D&!C&!B1&B&A1&A|F&E&D1&D&!C&!B1&B&A1&A|F&!E&D1&D&!C&!B1&B&A1&A|F&E&D1&!D&!C&!B1&B&A1&A|F&E&!D1&!D&!C&!B1&B&A1&A|F&E&!D1&!D&!C&!B1&B&!A1&A|F&E&D1&!D&!C&!B1&B&!A1&A|F&!E&D1&D&!C&!B1&B&!A1&A|F&E&D1&D&!C&!B1&B&!A1&A|F&E&!D1&D&!C&!B1&B&!A1&A|F&!E&!D1&D&C&!B1&B&!A1&A|F&E&!D1&D&C&!B1&B&!A1&A|F&E&D1&D&C&!B1&B&!A1&A|F&!E&D1&D&C&!B1&B&!A1&A|F&!E&D1&!D&C&!B1&B&!A1&A|F&E&D1&!D&C&!B1&B&!A1&A|F&E&!D1&!D&C&!B1&B&!A1&A|F&!E&!D1&!D&C&!B1&B&!A1&A|F&!E&!D1&!D&C&B1&B&!A1&A|F&E&!D1&!D&C&B1&B&!A1&A|F&E&D1&!D&C&B1&B&!A1&A|F&!E&D1&!D&C&B1&B&!A1&A|F&!E&D1&D&C&B1&B&!A1&A|F&E&D1&D&C&B1&B&!A1&A|F&E&!D1&D&C&B1&B&!A1&A|F&!E&!D1&D&C&B1&B&!A1&A|F&E&!D1&D&!C&B1&B&!A1&A|F&E&D1&D&!C&B1&B&!A1&A|F&!E&D1&D&!C&B1&B&!A1&A|F&E&D1&!D&!C&B1&B&!A1&A|F&E&!D1&!D&!C&B1&B&!A1&A|F&E&!D1&!D&!C&B1&!B&!A1&A|F&E&D1&!D&!C&B1&!B&!A1&A|F&!E&D1&D&!C&B1&!B&!A1&A|F&E&D1&D&!C&B1&!B&!A1&A|F&E&!D1&D&!C&B1&!B&!A1&A|F&!E&!D1&D&C&B1&!B&!A1&A|F&E&!D1&D&C&B1&!B&!A1&A|F&E&D1&D&C&B1&!B&!A1&A|F&!E&D1&D&C&B1&!B&!A1&A|F&!E&D1&!D&C&B1&!B&!A1&A|F&E&D1&!D&C&B1&!B&!A1&A|F&E&!D1&!D&C&B1&!B&!A1&A|F&!E&!D1&!D&C&B1&!B&!A1&A|F&E&!D1&!D&C&!B1&!B&!A1&A|F&E&D1&!D&C&!B1&!B&!A1&A|F&!E&D1&D&C&!B1&!B&!A1&A|F&E&D1&D&C&!B1&!B&!A1&A|F&E&!D1&D&C&!B1&!B&!A1&A|F&E&!D1&D&!C&!B1&!B&!A1&A|F&E&D1&D&!C&!B1&!B&!A1&A|F&!E&D1&D&!C&!B1&!B&!A1&A|F&E&D1&!D&!C&!B1&!B&!A1&A|F&E&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOAI221211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAAAOI22232 -l OOOAAAOI22232 -i E1 E D2 D1 D C1 C B1 B A1 A -o Y -f Y=(!E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E1&E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|E1&!E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E1&E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E1&!E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E1&E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E1&E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|E1&!E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|!E1&E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|E1&!E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E1&E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E1&E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|E1&!E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|E1&!E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E1&!E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|E1&!E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|E1&!E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E1&!E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|E1&!E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|!E1&E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|!E1&!E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|E1&!E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E1&E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E1&E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|E1&!E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|E1&!E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|!E1&E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|!E1&E&D2&!D1&D&C1&C&B1&!B&!A1&!A|E1&!E&D2&!D1&D&C1&C&B1&!B&!A1&!A|!E1&!E&D2&!D1&D&C1&C&B1&!B&!A1&!A|!E1&E&!D2&D1&D&C1&C&B1&!B&!A1&!A|E1&!E&!D2&D1&D&C1&C&B1&!B&!A1&!A|!E1&!E&!D2&D1&D&C1&C&B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|E1&!E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|!E1&E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|!E1&E&D2&D1&!D&C1&C&B1&!B&!A1&!A|E1&!E&D2&D1&!D&C1&C&B1&!B&!A1&!A|!E1&!E&D2&D1&!D&C1&C&B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|E1&!E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E1&E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|E1&!E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E1&!E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|E1&!E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|E1&!E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|E1&!E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|!E1&E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|!E1&!E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|E1&!E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E1&E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E1&E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|E1&!E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E1&E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|E1&!E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E1&!E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|E1&!E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E1&!E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|E1&!E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|E1&!E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E1&!E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|E1&!E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|!E1&E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|!E1&!E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|E1&!E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E1&E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E1&!E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|!E1&E&D2&!D1&D&C1&!C&B1&B&!A1&!A|E1&!E&D2&!D1&D&C1&!C&B1&B&!A1&!A|!E1&!E&D2&!D1&D&C1&!C&B1&B&!A1&!A|!E1&E&!D2&D1&D&C1&!C&B1&B&!A1&!A|E1&!E&!D2&D1&D&C1&!C&B1&B&!A1&!A|!E1&!E&!D2&D1&D&C1&!C&B1&B&!A1&!A|!E1&!E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|E1&!E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|!E1&E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|!E1&E&D2&D1&!D&C1&!C&B1&B&!A1&!A|E1&!E&D2&D1&!D&C1&!C&B1&B&!A1&!A|!E1&!E&D2&D1&!D&C1&!C&B1&B&!A1&!A|!E1&!E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|E1&!E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|!E1&E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|!E1&E&D2&!D1&!D&C1&C&B1&B&!A1&!A|E1&!E&D2&!D1&!D&C1&C&B1&B&!A1&!A|!E1&!E&D2&!D1&!D&C1&C&B1&B&!A1&!A|!E1&!E&D2&D1&!D&C1&C&B1&B&!A1&!A|E1&!E&D2&D1&!D&C1&C&B1&B&!A1&!A|!E1&E&D2&D1&!D&C1&C&B1&B&!A1&!A|!E1&E&!D2&D1&!D&C1&C&B1&B&!A1&!A|E1&!E&!D2&D1&!D&C1&C&B1&B&!A1&!A|!E1&!E&!D2&D1&!D&C1&C&B1&B&!A1&!A|!E1&!E&!D2&D1&D&C1&C&B1&B&!A1&!A|E1&!E&!D2&D1&D&C1&C&B1&B&!A1&!A|!E1&E&!D2&D1&D&C1&C&B1&B&!A1&!A|!E1&!E&D2&!D1&D&C1&C&B1&B&!A1&!A|E1&!E&D2&!D1&D&C1&C&B1&B&!A1&!A|!E1&E&D2&!D1&D&C1&C&B1&B&!A1&!A|!E1&E&!D2&!D1&D&C1&C&B1&B&!A1&!A|E1&!E&!D2&!D1&D&C1&C&B1&B&!A1&!A|!E1&!E&!D2&!D1&D&C1&C&B1&B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|E1&!E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|!E1&E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|!E1&E&D2&!D1&D&!C1&C&B1&B&!A1&!A|E1&!E&D2&!D1&D&!C1&C&B1&B&!A1&!A|!E1&!E&D2&!D1&D&!C1&C&B1&B&!A1&!A|!E1&E&!D2&D1&D&!C1&C&B1&B&!A1&!A|E1&!E&!D2&D1&D&!C1&C&B1&B&!A1&!A|!E1&!E&!D2&D1&D&!C1&C&B1&B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|E1&!E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|!E1&E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|!E1&E&D2&D1&!D&!C1&C&B1&B&!A1&!A|E1&!E&D2&D1&!D&!C1&C&B1&B&!A1&!A|!E1&!E&D2&D1&!D&!C1&C&B1&B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|E1&!E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|!E1&E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|E1&!E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E1&!E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|E1&!E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|E1&!E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E1&!E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|E1&!E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|!E1&E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|!E1&!E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|E1&!E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E1&E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E1&E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|E1&!E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|E1&!E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|!E1&E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|!E1&E&D2&!D1&D&C1&C&!B1&B&!A1&!A|E1&!E&D2&!D1&D&C1&C&!B1&B&!A1&!A|!E1&!E&D2&!D1&D&C1&C&!B1&B&!A1&!A|!E1&E&!D2&D1&D&C1&C&!B1&B&!A1&!A|E1&!E&!D2&D1&D&C1&C&!B1&B&!A1&!A|!E1&!E&!D2&D1&D&C1&C&!B1&B&!A1&!A|!E1&!E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|E1&!E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|!E1&E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|!E1&E&D2&D1&!D&C1&C&!B1&B&!A1&!A|E1&!E&D2&D1&!D&C1&C&!B1&B&!A1&!A|!E1&!E&D2&D1&!D&C1&C&!B1&B&!A1&!A|!E1&!E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|E1&!E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E1&E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|E1&!E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E1&!E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E1&!E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|E1&!E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|E1&!E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|E1&!E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|!E1&E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|!E1&!E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|E1&!E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E1&E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E1&E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|E1&!E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E1&E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|E1&!E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E1&!E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E1&!E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E1&!E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|E1&!E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|!E1&E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|!E1&!E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|E1&!E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E1&E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E1&E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|E1&!E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|E1&!E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|!E1&E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|!E1&E&D2&!D1&D&!C1&!C&B1&B&A1&!A|E1&!E&D2&!D1&D&!C1&!C&B1&B&A1&!A|!E1&!E&D2&!D1&D&!C1&!C&B1&B&A1&!A|!E1&E&!D2&D1&D&!C1&!C&B1&B&A1&!A|E1&!E&!D2&D1&D&!C1&!C&B1&B&A1&!A|!E1&!E&!D2&D1&D&!C1&!C&B1&B&A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|E1&!E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|!E1&E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|!E1&E&D2&D1&!D&!C1&!C&B1&B&A1&!A|E1&!E&D2&D1&!D&!C1&!C&B1&B&A1&!A|!E1&!E&D2&D1&!D&!C1&!C&B1&B&A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|E1&!E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E1&E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E1&!E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E1&!E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|E1&!E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|!E1&E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|!E1&!E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|E1&!E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E1&E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E1&E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|E1&!E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|E1&!E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E1&!E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E1&!E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|E1&!E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|E1&!E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E1&!E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E1&!E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|E1&!E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|!E1&E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|!E1&!E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|E1&!E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E1&E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E1&E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|E1&!E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|E1&!E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|!E1&E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|!E1&E&D2&!D1&D&C1&C&!B1&!B&A1&!A|E1&!E&D2&!D1&D&C1&C&!B1&!B&A1&!A|!E1&!E&D2&!D1&D&C1&C&!B1&!B&A1&!A|!E1&E&!D2&D1&D&C1&C&!B1&!B&A1&!A|E1&!E&!D2&D1&D&C1&C&!B1&!B&A1&!A|!E1&!E&!D2&D1&D&C1&C&!B1&!B&A1&!A|!E1&!E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|E1&!E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|!E1&E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|!E1&E&D2&D1&!D&C1&C&!B1&!B&A1&!A|E1&!E&D2&D1&!D&C1&C&!B1&!B&A1&!A|!E1&!E&D2&D1&!D&C1&C&!B1&!B&A1&!A|!E1&!E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|E1&!E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E1&E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E1&E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|E1&!E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|E1&!E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E1&!E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E1&!E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|E1&!E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|E1&!E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|E1&!E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|!E1&E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|!E1&!E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|E1&!E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E1&E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E1&E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|E1&!E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E1&E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|E1&!E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E1&!E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E1&!E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|E1&!E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E1&!E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|E1&!E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|!E1&E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|!E1&!E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|E1&!E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E1&E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E1&!E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|!E1&E&D2&!D1&D&C1&!C&!B1&!B&A1&A|E1&!E&D2&!D1&D&C1&!C&!B1&!B&A1&A|!E1&!E&D2&!D1&D&C1&!C&!B1&!B&A1&A|!E1&E&!D2&D1&D&C1&!C&!B1&!B&A1&A|E1&!E&!D2&D1&D&C1&!C&!B1&!B&A1&A|!E1&!E&!D2&D1&D&C1&!C&!B1&!B&A1&A|!E1&!E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|E1&!E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|!E1&E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|!E1&E&D2&D1&!D&C1&!C&!B1&!B&A1&A|E1&!E&D2&D1&!D&C1&!C&!B1&!B&A1&A|!E1&!E&D2&D1&!D&C1&!C&!B1&!B&A1&A|!E1&!E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|E1&!E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|!E1&E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!E1&!E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|!E1&E&D2&!D1&!D&C1&C&!B1&!B&A1&A|E1&!E&D2&!D1&!D&C1&C&!B1&!B&A1&A|!E1&!E&D2&!D1&!D&C1&C&!B1&!B&A1&A|!E1&!E&D2&D1&!D&C1&C&!B1&!B&A1&A|E1&!E&D2&D1&!D&C1&C&!B1&!B&A1&A|!E1&E&D2&D1&!D&C1&C&!B1&!B&A1&A|!E1&E&!D2&D1&!D&C1&C&!B1&!B&A1&A|E1&!E&!D2&D1&!D&C1&C&!B1&!B&A1&A|!E1&!E&!D2&D1&!D&C1&C&!B1&!B&A1&A|!E1&!E&!D2&D1&D&C1&C&!B1&!B&A1&A|E1&!E&!D2&D1&D&C1&C&!B1&!B&A1&A|!E1&E&!D2&D1&D&C1&C&!B1&!B&A1&A|!E1&!E&D2&!D1&D&C1&C&!B1&!B&A1&A|E1&!E&D2&!D1&D&C1&C&!B1&!B&A1&A|!E1&E&D2&!D1&D&C1&C&!B1&!B&A1&A|!E1&E&!D2&!D1&D&C1&C&!B1&!B&A1&A|E1&!E&!D2&!D1&D&C1&C&!B1&!B&A1&A|!E1&!E&!D2&!D1&D&C1&C&!B1&!B&A1&A|!E1&!E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|E1&!E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|!E1&E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|!E1&E&D2&!D1&D&!C1&C&!B1&!B&A1&A|E1&!E&D2&!D1&D&!C1&C&!B1&!B&A1&A|!E1&!E&D2&!D1&D&!C1&C&!B1&!B&A1&A|!E1&E&!D2&D1&D&!C1&C&!B1&!B&A1&A|E1&!E&!D2&D1&D&!C1&C&!B1&!B&A1&A|!E1&!E&!D2&D1&D&!C1&C&!B1&!B&A1&A|!E1&!E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|E1&!E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|!E1&E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|!E1&E&D2&D1&!D&!C1&C&!B1&!B&A1&A|E1&!E&D2&D1&!D&!C1&C&!B1&!B&A1&A|!E1&!E&D2&D1&!D&!C1&C&!B1&!B&A1&A|!E1&!E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|E1&!E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|!E1&E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!E1&!E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|E1&!E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|!E1&E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|!E1&E&D2&!D1&D&!C1&!C&B1&!B&A1&A|E1&!E&D2&!D1&D&!C1&!C&B1&!B&A1&A|!E1&!E&D2&!D1&D&!C1&!C&B1&!B&A1&A|!E1&E&!D2&D1&D&!C1&!C&B1&!B&A1&A|E1&!E&!D2&D1&D&!C1&!C&B1&!B&A1&A|!E1&!E&!D2&D1&D&!C1&!C&B1&!B&A1&A|!E1&!E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|E1&!E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|!E1&E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|!E1&E&D2&D1&!D&!C1&!C&B1&!B&A1&A|E1&!E&D2&D1&!D&!C1&!C&B1&!B&A1&A|!E1&!E&D2&D1&!D&!C1&!C&B1&!B&A1&A|!E1&!E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|E1&!E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E1&E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|E1&!E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!E1&E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!E1&E&D2&!D1&!D&!C1&!C&B1&B&A1&A|E1&!E&D2&!D1&!D&!C1&!C&B1&B&A1&A|!E1&!E&D2&!D1&!D&!C1&!C&B1&B&A1&A|!E1&!E&D2&D1&!D&!C1&!C&B1&B&A1&A|E1&!E&D2&D1&!D&!C1&!C&B1&B&A1&A|!E1&E&D2&D1&!D&!C1&!C&B1&B&A1&A|!E1&E&!D2&D1&!D&!C1&!C&B1&B&A1&A|E1&!E&!D2&D1&!D&!C1&!C&B1&B&A1&A|!E1&!E&!D2&D1&!D&!C1&!C&B1&B&A1&A|!E1&!E&!D2&D1&D&!C1&!C&B1&B&A1&A|E1&!E&!D2&D1&D&!C1&!C&B1&B&A1&A|!E1&E&!D2&D1&D&!C1&!C&B1&B&A1&A|!E1&!E&D2&!D1&D&!C1&!C&B1&B&A1&A|E1&!E&D2&!D1&D&!C1&!C&B1&B&A1&A|!E1&E&D2&!D1&D&!C1&!C&B1&B&A1&A|!E1&E&!D2&!D1&D&!C1&!C&B1&B&A1&A|E1&!E&!D2&!D1&D&!C1&!C&B1&B&A1&A|!E1&!E&!D2&!D1&D&!C1&!C&B1&B&A1&A|!E1&!E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|E1&!E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|!E1&E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|!E1&E&D2&!D1&D&!C1&!C&!B1&B&A1&A|E1&!E&D2&!D1&D&!C1&!C&!B1&B&A1&A|!E1&!E&D2&!D1&D&!C1&!C&!B1&B&A1&A|!E1&E&!D2&D1&D&!C1&!C&!B1&B&A1&A|E1&!E&!D2&D1&D&!C1&!C&!B1&B&A1&A|!E1&!E&!D2&D1&D&!C1&!C&!B1&B&A1&A|!E1&!E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|E1&!E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|!E1&E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|!E1&E&D2&D1&!D&!C1&!C&!B1&B&A1&A|E1&!E&D2&D1&!D&!C1&!C&!B1&B&A1&A|!E1&!E&D2&D1&!D&!C1&!C&!B1&B&A1&A|!E1&!E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|E1&!E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E1&E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E1&!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E1&!E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E1&!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E1&!E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|E1&!E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|!E1&E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|!E1&!E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|E1&!E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E1&E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E1&E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|E1&!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E1&!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E1&!E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|E1&!E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|!E1&E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|!E1&E&D2&!D1&D&!C1&!C&B1&B&!A1&A|E1&!E&D2&!D1&D&!C1&!C&B1&B&!A1&A|!E1&!E&D2&!D1&D&!C1&!C&B1&B&!A1&A|!E1&E&!D2&D1&D&!C1&!C&B1&B&!A1&A|E1&!E&!D2&D1&D&!C1&!C&B1&B&!A1&A|!E1&!E&!D2&D1&D&!C1&!C&B1&B&!A1&A|!E1&!E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|E1&!E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|!E1&E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|!E1&E&D2&D1&!D&!C1&!C&B1&B&!A1&A|E1&!E&D2&D1&!D&!C1&!C&B1&B&!A1&A|!E1&!E&D2&D1&!D&!C1&!C&B1&B&!A1&A|!E1&!E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|E1&!E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E1&E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|E1&!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E1&!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E1&!E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E1&!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E1&!E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|E1&!E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|!E1&E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|!E1&!E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|E1&!E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E1&E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E1&E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|E1&!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E1&!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|E1&!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E1&!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E1&!E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|E1&!E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|E1&!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E1&!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E1&!E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|E1&!E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|!E1&E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|!E1&!E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|E1&!E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E1&E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E1&E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|E1&!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|E1&!E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|!E1&E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|!E1&E&D2&!D1&D&C1&C&!B1&!B&!A1&A|E1&!E&D2&!D1&D&C1&C&!B1&!B&!A1&A|!E1&!E&D2&!D1&D&C1&C&!B1&!B&!A1&A|!E1&E&!D2&D1&D&C1&C&!B1&!B&!A1&A|E1&!E&!D2&D1&D&C1&C&!B1&!B&!A1&A|!E1&!E&!D2&D1&D&C1&C&!B1&!B&!A1&A|!E1&!E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|E1&!E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|!E1&E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|!E1&E&D2&D1&!D&C1&C&!B1&!B&!A1&A|E1&!E&D2&D1&!D&C1&C&!B1&!B&!A1&A|!E1&!E&D2&D1&!D&C1&C&!B1&!B&!A1&A|!E1&!E&D2&!D1&!D&C1&C&!B1&!B&!A1&A|E1&!E&D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E1&E&D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E1&E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|E1&!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|E1&!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E1&!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E1&!E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|E1&!E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|E1&!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E1&!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E1&!E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|E1&!E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|!E1&E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|!E1&!E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|E1&!E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E1&E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E1&E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|E1&!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E1&E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|E1&!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E1&!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E1&!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAAAOI22232.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAAOI22241 -l AAOOAAOI22241 -i E D3 D2 D1 D C1 C B1 B A1 A -o Y -f Y=(!E&!D3&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D3&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&!D3&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D3&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D3&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!E&D3&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D3&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&D3&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&D3&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&!D3&D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E&D3&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&D3&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&D3&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D3&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&D3&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&D3&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&!D3&D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E&D3&D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E&D3&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&D&C1&C&!B1&!B&!A1&!A|!E&D3&!D2&D1&D&C1&C&!B1&!B&!A1&!A|!E&!D3&D2&D1&D&C1&C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E&D3&D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&D3&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&!D3&D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E&D3&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&D3&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&D3&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D3&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&D3&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&D3&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&!D3&D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E&D3&D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E&D3&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E&!D3&!D2&D1&D&!C1&C&B1&!B&!A1&!A|!E&D3&!D2&D1&D&!C1&C&B1&!B&!A1&!A|!E&!D3&D2&D1&D&!C1&C&B1&!B&!A1&!A|!E&!D3&D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E&D3&D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E&D3&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&C1&C&B1&!B&!A1&!A|!E&D3&!D2&!D1&D&C1&C&B1&!B&!A1&!A|!E&D3&D2&!D1&D&C1&C&B1&!B&!A1&!A|!E&!D3&D2&!D1&D&C1&C&B1&!B&!A1&!A|!E&!D3&D2&D1&D&C1&C&B1&!B&!A1&!A|!E&D3&!D2&D1&D&C1&C&B1&!B&!A1&!A|!E&!D3&!D2&D1&D&C1&C&B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&C1&C&B1&!B&!A1&!A|!E&D3&!D2&D1&!D&C1&C&B1&!B&!A1&!A|!E&D3&D2&D1&!D&C1&C&B1&!B&!A1&!A|!E&!D3&D2&D1&!D&C1&C&B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E&D3&D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&D3&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&!D3&D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E&D3&D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E&D3&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E&!D3&!D2&D1&D&C1&!C&B1&!B&!A1&!A|!E&D3&!D2&D1&D&C1&!C&B1&!B&!A1&!A|!E&!D3&D2&D1&D&C1&!C&B1&!B&!A1&!A|!E&!D3&D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E&D3&D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E&D3&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&D3&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&D3&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&!D3&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&!D3&D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E&D3&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E&!D3&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&D3&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&D3&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D3&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&D3&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&D3&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&!D3&D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E&D3&D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E&D3&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E&!D3&!D2&D1&D&!C1&!C&B1&B&!A1&!A|!E&D3&!D2&D1&D&!C1&!C&B1&B&!A1&!A|!E&!D3&D2&D1&D&!C1&!C&B1&B&!A1&!A|!E&!D3&D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E&D3&D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E&D3&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&D3&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&!D3&D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E&D3&D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E&D3&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E&!D3&!D2&D1&D&!C1&C&!B1&B&!A1&!A|!E&D3&!D2&D1&D&!C1&C&!B1&B&!A1&!A|!E&!D3&D2&D1&D&!C1&C&!B1&B&!A1&!A|!E&!D3&D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E&D3&D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E&D3&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&D&C1&C&!B1&B&!A1&!A|!E&D3&!D2&!D1&D&C1&C&!B1&B&!A1&!A|!E&D3&D2&!D1&D&C1&C&!B1&B&!A1&!A|!E&!D3&D2&!D1&D&C1&C&!B1&B&!A1&!A|!E&!D3&D2&D1&D&C1&C&!B1&B&!A1&!A|!E&D3&!D2&D1&D&C1&C&!B1&B&!A1&!A|!E&!D3&!D2&D1&D&C1&C&!B1&B&!A1&!A|!E&!D3&!D2&D1&!D&C1&C&!B1&B&!A1&!A|!E&D3&!D2&D1&!D&C1&C&!B1&B&!A1&!A|!E&D3&D2&D1&!D&C1&C&!B1&B&!A1&!A|!E&!D3&D2&D1&!D&C1&C&!B1&B&!A1&!A|!E&!D3&D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E&D3&D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E&D3&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&D3&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&D3&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&!D3&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&!D3&D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E&D3&D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E&D3&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E&!D3&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E&!D3&!D2&D1&D&C1&!C&!B1&B&!A1&!A|!E&D3&!D2&D1&D&C1&!C&!B1&B&!A1&!A|!E&!D3&D2&D1&D&C1&!C&!B1&B&!A1&!A|!E&!D3&D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E&D3&D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E&D3&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&D3&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&D3&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&!D3&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&!D3&D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E&D3&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E&!D3&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&D3&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&D3&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D3&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&D3&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&D3&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&!D3&D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E&D3&D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E&D3&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E&!D3&!D2&D1&D&!C1&!C&!B1&B&A1&!A|!E&D3&!D2&D1&D&!C1&!C&!B1&B&A1&!A|!E&!D3&D2&D1&D&!C1&!C&!B1&B&A1&!A|!E&!D3&D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E&D3&D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E&D3&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E&!D3&!D2&!D1&D&C1&!C&!B1&B&A1&!A|!E&D3&!D2&!D1&D&C1&!C&!B1&B&A1&!A|!E&D3&D2&!D1&D&C1&!C&!B1&B&A1&!A|!E&!D3&D2&!D1&D&C1&!C&!B1&B&A1&!A|!E&!D3&D2&D1&D&C1&!C&!B1&B&A1&!A|!E&D3&!D2&D1&D&C1&!C&!B1&B&A1&!A|!E&!D3&!D2&D1&D&C1&!C&!B1&B&A1&!A|!E&!D3&!D2&D1&!D&C1&!C&!B1&B&A1&!A|!E&D3&!D2&D1&!D&C1&!C&!B1&B&A1&!A|!E&D3&D2&D1&!D&C1&!C&!B1&B&A1&!A|!E&!D3&D2&D1&!D&C1&!C&!B1&B&A1&!A|!E&!D3&D2&!D1&!D&C1&!C&!B1&B&A1&!A|!E&D3&D2&!D1&!D&C1&!C&!B1&B&A1&!A|!E&D3&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!E&!D3&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!E&!D3&!D2&!D1&!D&C1&C&!B1&B&A1&!A|!E&D3&!D2&!D1&!D&C1&C&!B1&B&A1&!A|!E&D3&D2&!D1&!D&C1&C&!B1&B&A1&!A|!E&!D3&D2&!D1&!D&C1&C&!B1&B&A1&!A|!E&!D3&D2&D1&!D&C1&C&!B1&B&A1&!A|!E&D3&D2&D1&!D&C1&C&!B1&B&A1&!A|!E&D3&!D2&D1&!D&C1&C&!B1&B&A1&!A|!E&!D3&!D2&D1&!D&C1&C&!B1&B&A1&!A|!E&!D3&!D2&D1&D&C1&C&!B1&B&A1&!A|!E&D3&!D2&D1&D&C1&C&!B1&B&A1&!A|!E&!D3&D2&D1&D&C1&C&!B1&B&A1&!A|!E&!D3&D2&!D1&D&C1&C&!B1&B&A1&!A|!E&D3&D2&!D1&D&C1&C&!B1&B&A1&!A|!E&D3&!D2&!D1&D&C1&C&!B1&B&A1&!A|!E&!D3&!D2&!D1&D&C1&C&!B1&B&A1&!A|!E&!D3&!D2&!D1&D&!C1&C&!B1&B&A1&!A|!E&D3&!D2&!D1&D&!C1&C&!B1&B&A1&!A|!E&D3&D2&!D1&D&!C1&C&!B1&B&A1&!A|!E&!D3&D2&!D1&D&!C1&C&!B1&B&A1&!A|!E&!D3&D2&D1&D&!C1&C&!B1&B&A1&!A|!E&D3&!D2&D1&D&!C1&C&!B1&B&A1&!A|!E&!D3&!D2&D1&D&!C1&C&!B1&B&A1&!A|!E&!D3&!D2&D1&!D&!C1&C&!B1&B&A1&!A|!E&D3&!D2&D1&!D&!C1&C&!B1&B&A1&!A|!E&D3&D2&D1&!D&!C1&C&!B1&B&A1&!A|!E&!D3&D2&D1&!D&!C1&C&!B1&B&A1&!A|!E&!D3&D2&!D1&!D&!C1&C&!B1&B&A1&!A|!E&D3&D2&!D1&!D&!C1&C&!B1&B&A1&!A|!E&D3&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!E&!D3&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&B1&B&A1&!A|!E&D3&!D2&!D1&D&!C1&!C&B1&B&A1&!A|!E&D3&D2&!D1&D&!C1&!C&B1&B&A1&!A|!E&!D3&D2&!D1&D&!C1&!C&B1&B&A1&!A|!E&!D3&D2&D1&D&!C1&!C&B1&B&A1&!A|!E&D3&!D2&D1&D&!C1&!C&B1&B&A1&!A|!E&!D3&!D2&D1&D&!C1&!C&B1&B&A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&B1&B&A1&!A|!E&D3&!D2&D1&!D&!C1&!C&B1&B&A1&!A|!E&D3&D2&D1&!D&!C1&!C&B1&B&A1&!A|!E&!D3&D2&D1&!D&!C1&!C&B1&B&A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E&D3&D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&D3&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&!D3&D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E&D3&D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E&D3&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E&!D3&!D2&D1&D&!C1&!C&B1&!B&A1&!A|!E&D3&!D2&D1&D&!C1&!C&B1&!B&A1&!A|!E&!D3&D2&D1&D&!C1&!C&B1&!B&A1&!A|!E&!D3&D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E&D3&D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E&D3&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E&!D3&!D2&!D1&D&C1&!C&B1&!B&A1&!A|!E&D3&!D2&!D1&D&C1&!C&B1&!B&A1&!A|!E&D3&D2&!D1&D&C1&!C&B1&!B&A1&!A|!E&!D3&D2&!D1&D&C1&!C&B1&!B&A1&!A|!E&!D3&D2&D1&D&C1&!C&B1&!B&A1&!A|!E&D3&!D2&D1&D&C1&!C&B1&!B&A1&!A|!E&!D3&!D2&D1&D&C1&!C&B1&!B&A1&!A|!E&!D3&!D2&D1&!D&C1&!C&B1&!B&A1&!A|!E&D3&!D2&D1&!D&C1&!C&B1&!B&A1&!A|!E&D3&D2&D1&!D&C1&!C&B1&!B&A1&!A|!E&!D3&D2&D1&!D&C1&!C&B1&!B&A1&!A|!E&!D3&D2&!D1&!D&C1&!C&B1&!B&A1&!A|!E&D3&D2&!D1&!D&C1&!C&B1&!B&A1&!A|!E&D3&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!E&!D3&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!E&!D3&!D2&!D1&!D&C1&C&B1&!B&A1&!A|!E&D3&!D2&!D1&!D&C1&C&B1&!B&A1&!A|!E&D3&D2&!D1&!D&C1&C&B1&!B&A1&!A|!E&!D3&D2&!D1&!D&C1&C&B1&!B&A1&!A|!E&!D3&D2&D1&!D&C1&C&B1&!B&A1&!A|!E&D3&D2&D1&!D&C1&C&B1&!B&A1&!A|!E&D3&!D2&D1&!D&C1&C&B1&!B&A1&!A|!E&!D3&!D2&D1&!D&C1&C&B1&!B&A1&!A|!E&!D3&!D2&D1&D&C1&C&B1&!B&A1&!A|!E&D3&!D2&D1&D&C1&C&B1&!B&A1&!A|!E&!D3&D2&D1&D&C1&C&B1&!B&A1&!A|!E&!D3&D2&!D1&D&C1&C&B1&!B&A1&!A|!E&D3&D2&!D1&D&C1&C&B1&!B&A1&!A|!E&D3&!D2&!D1&D&C1&C&B1&!B&A1&!A|!E&!D3&!D2&!D1&D&C1&C&B1&!B&A1&!A|!E&!D3&!D2&!D1&D&!C1&C&B1&!B&A1&!A|!E&D3&!D2&!D1&D&!C1&C&B1&!B&A1&!A|!E&D3&D2&!D1&D&!C1&C&B1&!B&A1&!A|!E&!D3&D2&!D1&D&!C1&C&B1&!B&A1&!A|!E&!D3&D2&D1&D&!C1&C&B1&!B&A1&!A|!E&D3&!D2&D1&D&!C1&C&B1&!B&A1&!A|!E&!D3&!D2&D1&D&!C1&C&B1&!B&A1&!A|!E&!D3&!D2&D1&!D&!C1&C&B1&!B&A1&!A|!E&D3&!D2&D1&!D&!C1&C&B1&!B&A1&!A|!E&D3&D2&D1&!D&!C1&C&B1&!B&A1&!A|!E&!D3&D2&D1&!D&!C1&C&B1&!B&A1&!A|!E&!D3&D2&!D1&!D&!C1&C&B1&!B&A1&!A|!E&D3&D2&!D1&!D&!C1&C&B1&!B&A1&!A|!E&D3&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!E&!D3&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!E&!D3&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&D3&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&D3&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&!D3&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&!D3&D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E&D3&D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E&D3&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E&!D3&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E&!D3&!D2&D1&D&!C1&C&!B1&!B&A1&!A|!E&D3&!D2&D1&D&!C1&C&!B1&!B&A1&!A|!E&!D3&D2&D1&D&!C1&C&!B1&!B&A1&!A|!E&!D3&D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E&D3&D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E&D3&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&D&C1&C&!B1&!B&A1&!A|!E&D3&!D2&!D1&D&C1&C&!B1&!B&A1&!A|!E&D3&D2&!D1&D&C1&C&!B1&!B&A1&!A|!E&!D3&D2&!D1&D&C1&C&!B1&!B&A1&!A|!E&!D3&D2&D1&D&C1&C&!B1&!B&A1&!A|!E&D3&!D2&D1&D&C1&C&!B1&!B&A1&!A|!E&!D3&!D2&D1&D&C1&C&!B1&!B&A1&!A|!E&!D3&!D2&D1&!D&C1&C&!B1&!B&A1&!A|!E&D3&!D2&D1&!D&C1&C&!B1&!B&A1&!A|!E&D3&D2&D1&!D&C1&C&!B1&!B&A1&!A|!E&!D3&D2&D1&!D&C1&C&!B1&!B&A1&!A|!E&!D3&D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E&D3&D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E&D3&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&D3&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&D3&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&!D3&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&!D3&D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E&D3&D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E&D3&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E&!D3&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E&!D3&!D2&D1&D&C1&!C&!B1&!B&A1&!A|!E&D3&!D2&D1&D&C1&!C&!B1&!B&A1&!A|!E&!D3&D2&D1&D&C1&!C&!B1&!B&A1&!A|!E&!D3&D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E&D3&D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E&D3&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&D3&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&D3&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&!D3&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&!D3&D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E&D3&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E&!D3&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&D3&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&D3&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D3&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&D3&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&D3&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&D3&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&!D3&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&!D3&D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E&D3&D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E&D3&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E&!D3&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E&!D3&!D2&D1&D&!C1&!C&!B1&!B&A1&A|!E&D3&!D2&D1&D&!C1&!C&!B1&!B&A1&A|!E&!D3&D2&D1&D&!C1&!C&!B1&!B&A1&A|!E&!D3&D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E&D3&D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E&D3&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E&!D3&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E&!D3&!D2&!D1&D&!C1&!C&B1&!B&A1&A|!E&D3&!D2&!D1&D&!C1&!C&B1&!B&A1&A|!E&D3&D2&!D1&D&!C1&!C&B1&!B&A1&A|!E&!D3&D2&!D1&D&!C1&!C&B1&!B&A1&A|!E&!D3&D2&D1&D&!C1&!C&B1&!B&A1&A|!E&D3&!D2&D1&D&!C1&!C&B1&!B&A1&A|!E&!D3&!D2&D1&D&!C1&!C&B1&!B&A1&A|!E&!D3&!D2&D1&!D&!C1&!C&B1&!B&A1&A|!E&D3&!D2&D1&!D&!C1&!C&B1&!B&A1&A|!E&D3&D2&D1&!D&!C1&!C&B1&!B&A1&A|!E&!D3&D2&D1&!D&!C1&!C&B1&!B&A1&A|!E&!D3&D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E&D3&D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E&D3&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E&!D3&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E&!D3&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!E&D3&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!E&D3&D2&!D1&!D&!C1&!C&B1&B&A1&A|!E&!D3&D2&!D1&!D&!C1&!C&B1&B&A1&A|!E&!D3&D2&D1&!D&!C1&!C&B1&B&A1&A|!E&D3&D2&D1&!D&!C1&!C&B1&B&A1&A|!E&D3&!D2&D1&!D&!C1&!C&B1&B&A1&A|!E&!D3&!D2&D1&!D&!C1&!C&B1&B&A1&A|!E&!D3&!D2&D1&D&!C1&!C&B1&B&A1&A|!E&D3&!D2&D1&D&!C1&!C&B1&B&A1&A|!E&!D3&D2&D1&D&!C1&!C&B1&B&A1&A|!E&!D3&D2&!D1&D&!C1&!C&B1&B&A1&A|!E&D3&D2&!D1&D&!C1&!C&B1&B&A1&A|!E&D3&!D2&!D1&D&!C1&!C&B1&B&A1&A|!E&!D3&!D2&!D1&D&!C1&!C&B1&B&A1&A|!E&!D3&!D2&!D1&D&!C1&!C&!B1&B&A1&A|!E&D3&!D2&!D1&D&!C1&!C&!B1&B&A1&A|!E&D3&D2&!D1&D&!C1&!C&!B1&B&A1&A|!E&!D3&D2&!D1&D&!C1&!C&!B1&B&A1&A|!E&!D3&D2&D1&D&!C1&!C&!B1&B&A1&A|!E&D3&!D2&D1&D&!C1&!C&!B1&B&A1&A|!E&!D3&!D2&D1&D&!C1&!C&!B1&B&A1&A|!E&!D3&!D2&D1&!D&!C1&!C&!B1&B&A1&A|!E&D3&!D2&D1&!D&!C1&!C&!B1&B&A1&A|!E&D3&D2&D1&!D&!C1&!C&!B1&B&A1&A|!E&!D3&D2&D1&!D&!C1&!C&!B1&B&A1&A|!E&!D3&D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E&D3&D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E&D3&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E&!D3&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E&!D3&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&D3&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&D3&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&!D3&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&!D3&D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E&D3&D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E&D3&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E&!D3&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E&!D3&!D2&D1&D&!C1&!C&!B1&B&!A1&A|!E&D3&!D2&D1&D&!C1&!C&!B1&B&!A1&A|!E&!D3&D2&D1&D&!C1&!C&!B1&B&!A1&A|!E&!D3&D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E&D3&D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E&D3&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E&!D3&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E&!D3&!D2&!D1&D&C1&!C&!B1&B&!A1&A|!E&D3&!D2&!D1&D&C1&!C&!B1&B&!A1&A|!E&D3&D2&!D1&D&C1&!C&!B1&B&!A1&A|!E&!D3&D2&!D1&D&C1&!C&!B1&B&!A1&A|!E&!D3&D2&D1&D&C1&!C&!B1&B&!A1&A|!E&D3&!D2&D1&D&C1&!C&!B1&B&!A1&A|!E&!D3&!D2&D1&D&C1&!C&!B1&B&!A1&A|!E&!D3&!D2&D1&!D&C1&!C&!B1&B&!A1&A|!E&D3&!D2&D1&!D&C1&!C&!B1&B&!A1&A|!E&D3&D2&D1&!D&C1&!C&!B1&B&!A1&A|!E&!D3&D2&D1&!D&C1&!C&!B1&B&!A1&A|!E&!D3&D2&!D1&!D&C1&!C&!B1&B&!A1&A|!E&D3&D2&!D1&!D&C1&!C&!B1&B&!A1&A|!E&D3&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!E&!D3&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!E&!D3&!D2&!D1&!D&C1&C&!B1&B&!A1&A|!E&D3&!D2&!D1&!D&C1&C&!B1&B&!A1&A|!E&D3&D2&!D1&!D&C1&C&!B1&B&!A1&A|!E&!D3&D2&!D1&!D&C1&C&!B1&B&!A1&A|!E&!D3&D2&D1&!D&C1&C&!B1&B&!A1&A|!E&D3&D2&D1&!D&C1&C&!B1&B&!A1&A|!E&D3&!D2&D1&!D&C1&C&!B1&B&!A1&A|!E&!D3&!D2&D1&!D&C1&C&!B1&B&!A1&A|!E&!D3&!D2&D1&D&C1&C&!B1&B&!A1&A|!E&D3&!D2&D1&D&C1&C&!B1&B&!A1&A|!E&!D3&D2&D1&D&C1&C&!B1&B&!A1&A|!E&!D3&D2&!D1&D&C1&C&!B1&B&!A1&A|!E&D3&D2&!D1&D&C1&C&!B1&B&!A1&A|!E&D3&!D2&!D1&D&C1&C&!B1&B&!A1&A|!E&!D3&!D2&!D1&D&C1&C&!B1&B&!A1&A|!E&!D3&!D2&!D1&D&!C1&C&!B1&B&!A1&A|!E&D3&!D2&!D1&D&!C1&C&!B1&B&!A1&A|!E&D3&D2&!D1&D&!C1&C&!B1&B&!A1&A|!E&!D3&D2&!D1&D&!C1&C&!B1&B&!A1&A|!E&!D3&D2&D1&D&!C1&C&!B1&B&!A1&A|!E&D3&!D2&D1&D&!C1&C&!B1&B&!A1&A|!E&!D3&!D2&D1&D&!C1&C&!B1&B&!A1&A|!E&!D3&!D2&D1&!D&!C1&C&!B1&B&!A1&A|!E&D3&!D2&D1&!D&!C1&C&!B1&B&!A1&A|!E&D3&D2&D1&!D&!C1&C&!B1&B&!A1&A|!E&!D3&D2&D1&!D&!C1&C&!B1&B&!A1&A|!E&!D3&D2&!D1&!D&!C1&C&!B1&B&!A1&A|!E&D3&D2&!D1&!D&!C1&C&!B1&B&!A1&A|!E&D3&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!E&!D3&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!E&!D3&!D2&!D1&D&!C1&!C&B1&B&!A1&A|!E&D3&!D2&!D1&D&!C1&!C&B1&B&!A1&A|!E&D3&D2&!D1&D&!C1&!C&B1&B&!A1&A|!E&!D3&D2&!D1&D&!C1&!C&B1&B&!A1&A|!E&!D3&D2&D1&D&!C1&!C&B1&B&!A1&A|!E&D3&!D2&D1&D&!C1&!C&B1&B&!A1&A|!E&!D3&!D2&D1&D&!C1&!C&B1&B&!A1&A|!E&!D3&!D2&D1&!D&!C1&!C&B1&B&!A1&A|!E&D3&!D2&D1&!D&!C1&!C&B1&B&!A1&A|!E&D3&D2&D1&!D&!C1&!C&B1&B&!A1&A|!E&!D3&D2&D1&!D&!C1&!C&B1&B&!A1&A|!E&!D3&D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E&D3&D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E&D3&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E&!D3&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E&!D3&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&D3&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&D3&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&!D3&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&!D3&D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E&D3&D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E&D3&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E&!D3&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E&!D3&!D2&D1&D&!C1&!C&B1&!B&!A1&A|!E&D3&!D2&D1&D&!C1&!C&B1&!B&!A1&A|!E&!D3&D2&D1&D&!C1&!C&B1&!B&!A1&A|!E&!D3&D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E&D3&D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E&D3&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E&!D3&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E&!D3&!D2&!D1&D&C1&!C&B1&!B&!A1&A|!E&D3&!D2&!D1&D&C1&!C&B1&!B&!A1&A|!E&D3&D2&!D1&D&C1&!C&B1&!B&!A1&A|!E&!D3&D2&!D1&D&C1&!C&B1&!B&!A1&A|!E&!D3&D2&D1&D&C1&!C&B1&!B&!A1&A|!E&D3&!D2&D1&D&C1&!C&B1&!B&!A1&A|!E&!D3&!D2&D1&D&C1&!C&B1&!B&!A1&A|!E&!D3&!D2&D1&!D&C1&!C&B1&!B&!A1&A|!E&D3&!D2&D1&!D&C1&!C&B1&!B&!A1&A|!E&D3&D2&D1&!D&C1&!C&B1&!B&!A1&A|!E&!D3&D2&D1&!D&C1&!C&B1&!B&!A1&A|!E&!D3&D2&!D1&!D&C1&!C&B1&!B&!A1&A|!E&D3&D2&!D1&!D&C1&!C&B1&!B&!A1&A|!E&D3&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!E&!D3&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!E&!D3&!D2&!D1&!D&C1&C&B1&!B&!A1&A|!E&D3&!D2&!D1&!D&C1&C&B1&!B&!A1&A|!E&D3&D2&!D1&!D&C1&C&B1&!B&!A1&A|!E&!D3&D2&!D1&!D&C1&C&B1&!B&!A1&A|!E&!D3&D2&D1&!D&C1&C&B1&!B&!A1&A|!E&D3&D2&D1&!D&C1&C&B1&!B&!A1&A|!E&D3&!D2&D1&!D&C1&C&B1&!B&!A1&A|!E&!D3&!D2&D1&!D&C1&C&B1&!B&!A1&A|!E&!D3&!D2&D1&D&C1&C&B1&!B&!A1&A|!E&D3&!D2&D1&D&C1&C&B1&!B&!A1&A|!E&!D3&D2&D1&D&C1&C&B1&!B&!A1&A|!E&!D3&D2&!D1&D&C1&C&B1&!B&!A1&A|!E&D3&D2&!D1&D&C1&C&B1&!B&!A1&A|!E&D3&!D2&!D1&D&C1&C&B1&!B&!A1&A|!E&!D3&!D2&!D1&D&C1&C&B1&!B&!A1&A|!E&!D3&!D2&!D1&D&!C1&C&B1&!B&!A1&A|!E&D3&!D2&!D1&D&!C1&C&B1&!B&!A1&A|!E&D3&D2&!D1&D&!C1&C&B1&!B&!A1&A|!E&!D3&D2&!D1&D&!C1&C&B1&!B&!A1&A|!E&!D3&D2&D1&D&!C1&C&B1&!B&!A1&A|!E&D3&!D2&D1&D&!C1&C&B1&!B&!A1&A|!E&!D3&!D2&D1&D&!C1&C&B1&!B&!A1&A|!E&!D3&!D2&D1&!D&!C1&C&B1&!B&!A1&A|!E&D3&!D2&D1&!D&!C1&C&B1&!B&!A1&A|!E&D3&D2&D1&!D&!C1&C&B1&!B&!A1&A|!E&!D3&D2&D1&!D&!C1&C&B1&!B&!A1&A|!E&!D3&D2&!D1&!D&!C1&C&B1&!B&!A1&A|!E&D3&D2&!D1&!D&!C1&C&B1&!B&!A1&A|!E&D3&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!E&!D3&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!E&!D3&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&D3&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&D3&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&!D3&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&!D3&D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E&D3&D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E&D3&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E&!D3&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E&!D3&!D2&D1&D&!C1&C&!B1&!B&!A1&A|!E&D3&!D2&D1&D&!C1&C&!B1&!B&!A1&A|!E&!D3&D2&D1&D&!C1&C&!B1&!B&!A1&A|!E&!D3&D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E&D3&D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E&D3&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E&!D3&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E&!D3&!D2&!D1&D&C1&C&!B1&!B&!A1&A|!E&D3&!D2&!D1&D&C1&C&!B1&!B&!A1&A|!E&D3&D2&!D1&D&C1&C&!B1&!B&!A1&A|!E&!D3&D2&!D1&D&C1&C&!B1&!B&!A1&A|!E&!D3&D2&D1&D&C1&C&!B1&!B&!A1&A|!E&D3&!D2&D1&D&C1&C&!B1&!B&!A1&A|!E&!D3&!D2&D1&D&C1&C&!B1&!B&!A1&A|!E&!D3&!D2&D1&!D&C1&C&!B1&!B&!A1&A|!E&D3&!D2&D1&!D&C1&C&!B1&!B&!A1&A|!E&D3&D2&D1&!D&C1&C&!B1&!B&!A1&A|!E&!D3&D2&D1&!D&C1&C&!B1&!B&!A1&A|!E&!D3&D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E&D3&D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E&D3&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E&!D3&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E&!D3&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&D3&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&D3&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&!D3&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&!D3&D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E&D3&D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E&D3&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E&!D3&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E&!D3&!D2&D1&D&C1&!C&!B1&!B&!A1&A|!E&D3&!D2&D1&D&C1&!C&!B1&!B&!A1&A|!E&!D3&D2&D1&D&C1&!C&!B1&!B&!A1&A|!E&!D3&D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E&D3&D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E&D3&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E&!D3&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E&!D3&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&D3&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&D3&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&!D3&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&!D3&D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E&D3&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E&!D3&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E&!D3&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&D3&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&D3&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&!D3&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&!D3&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E&D3&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E&D3&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E&!D3&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAAOI22241.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOOAOI211131 -l AOAOOAOI211131 -i F E2 E1 E D C B A1 A -o Y -f Y=(!F&!E2&!E1&!E&!D&!C&!B&!A1&!A|!F&E2&!E1&!E&!D&!C&!B&!A1&!A|!F&E2&E1&!E&!D&!C&!B&!A1&!A|!F&!E2&E1&!E&!D&!C&!B&!A1&!A|!F&!E2&E1&E&!D&!C&!B&!A1&!A|!F&E2&E1&E&!D&!C&!B&!A1&!A|!F&E2&!E1&E&!D&!C&!B&!A1&!A|!F&!E2&!E1&E&!D&!C&!B&!A1&!A|!F&!E2&!E1&!E&D&!C&!B&!A1&!A|!F&!E2&!E1&!E&D&C&!B&!A1&!A|!F&!E2&!E1&E&!D&C&!B&!A1&!A|!F&E2&!E1&E&!D&C&!B&!A1&!A|!F&E2&E1&E&!D&C&!B&!A1&!A|!F&!E2&E1&E&!D&C&!B&!A1&!A|!F&!E2&E1&!E&!D&C&!B&!A1&!A|!F&E2&E1&!E&!D&C&!B&!A1&!A|!F&E2&!E1&!E&!D&C&!B&!A1&!A|!F&!E2&!E1&!E&!D&C&!B&!A1&!A|!F&!E2&!E1&!E&!D&C&B&!A1&!A|!F&!E2&!E1&!E&D&C&B&!A1&!A|!F&!E2&!E1&!E&D&!C&B&!A1&!A|!F&!E2&!E1&E&!D&!C&B&!A1&!A|!F&E2&!E1&E&!D&!C&B&!A1&!A|!F&E2&E1&E&!D&!C&B&!A1&!A|!F&!E2&E1&E&!D&!C&B&!A1&!A|!F&!E2&E1&!E&!D&!C&B&!A1&!A|!F&E2&E1&!E&!D&!C&B&!A1&!A|!F&E2&!E1&!E&!D&!C&B&!A1&!A|!F&!E2&!E1&!E&!D&!C&B&!A1&!A|!F&!E2&!E1&!E&!D&!C&B&A1&!A|!F&E2&!E1&!E&!D&!C&B&A1&!A|!F&E2&E1&!E&!D&!C&B&A1&!A|!F&!E2&E1&!E&!D&!C&B&A1&!A|!F&!E2&E1&E&!D&!C&B&A1&!A|!F&E2&E1&E&!D&!C&B&A1&!A|!F&E2&!E1&E&!D&!C&B&A1&!A|!F&!E2&!E1&E&!D&!C&B&A1&!A|!F&!E2&!E1&!E&D&!C&B&A1&!A|!F&!E2&!E1&!E&D&C&B&A1&!A|!F&!E2&!E1&!E&!D&C&B&A1&!A|!F&!E2&!E1&!E&!D&C&!B&A1&!A|!F&E2&!E1&!E&!D&C&!B&A1&!A|!F&E2&E1&!E&!D&C&!B&A1&!A|!F&!E2&E1&!E&!D&C&!B&A1&!A|!F&!E2&E1&E&!D&C&!B&A1&!A|!F&E2&E1&E&!D&C&!B&A1&!A|!F&E2&!E1&E&!D&C&!B&A1&!A|!F&!E2&!E1&E&!D&C&!B&A1&!A|!F&!E2&!E1&!E&D&C&!B&A1&!A|!F&!E2&!E1&!E&D&!C&!B&A1&!A|!F&!E2&!E1&E&!D&!C&!B&A1&!A|!F&E2&!E1&E&!D&!C&!B&A1&!A|!F&E2&E1&E&!D&!C&!B&A1&!A|!F&!E2&E1&E&!D&!C&!B&A1&!A|!F&!E2&E1&!E&!D&!C&!B&A1&!A|!F&E2&E1&!E&!D&!C&!B&A1&!A|!F&E2&!E1&!E&!D&!C&!B&A1&!A|!F&!E2&!E1&!E&!D&!C&!B&A1&!A|!F&!E2&!E1&!E&!D&!C&!B&A1&A|!F&E2&!E1&!E&!D&!C&!B&A1&A|!F&E2&E1&!E&!D&!C&!B&A1&A|!F&!E2&E1&!E&!D&!C&!B&A1&A|!F&!E2&E1&E&!D&!C&!B&A1&A|!F&E2&E1&E&!D&!C&!B&A1&A|!F&E2&!E1&E&!D&!C&!B&A1&A|!F&!E2&!E1&E&!D&!C&!B&A1&A|!F&!E2&!E1&!E&D&!C&!B&A1&A|!F&!E2&!E1&!E&D&C&!B&A1&A|!F&!E2&!E1&!E&!D&C&!B&A1&A|!F&!E2&!E1&!E&!D&C&B&A1&A|!F&!E2&!E1&!E&D&C&B&A1&A|!F&!E2&!E1&!E&D&!C&B&A1&A|!F&!E2&!E1&E&!D&!C&B&A1&A|!F&E2&!E1&E&!D&!C&B&A1&A|!F&E2&E1&E&!D&!C&B&A1&A|!F&!E2&E1&E&!D&!C&B&A1&A|!F&!E2&E1&!E&!D&!C&B&A1&A|!F&E2&E1&!E&!D&!C&B&A1&A|!F&E2&!E1&!E&!D&!C&B&A1&A|!F&!E2&!E1&!E&!D&!C&B&A1&A|!F&!E2&!E1&!E&!D&!C&B&!A1&A|!F&E2&!E1&!E&!D&!C&B&!A1&A|!F&E2&E1&!E&!D&!C&B&!A1&A|!F&!E2&E1&!E&!D&!C&B&!A1&A|!F&!E2&E1&E&!D&!C&B&!A1&A|!F&E2&E1&E&!D&!C&B&!A1&A|!F&E2&!E1&E&!D&!C&B&!A1&A|!F&!E2&!E1&E&!D&!C&B&!A1&A|!F&!E2&!E1&!E&D&!C&B&!A1&A|!F&!E2&!E1&!E&D&C&B&!A1&A|!F&!E2&!E1&!E&!D&C&B&!A1&A|!F&!E2&!E1&!E&!D&C&!B&!A1&A|!F&E2&!E1&!E&!D&C&!B&!A1&A|!F&E2&E1&!E&!D&C&!B&!A1&A|!F&!E2&E1&!E&!D&C&!B&!A1&A|!F&!E2&E1&E&!D&C&!B&!A1&A|!F&E2&E1&E&!D&C&!B&!A1&A|!F&E2&!E1&E&!D&C&!B&!A1&A|!F&!E2&!E1&E&!D&C&!B&!A1&A|!F&!E2&!E1&!E&D&C&!B&!A1&A|!F&!E2&!E1&!E&D&!C&!B&!A1&A|!F&!E2&!E1&E&!D&!C&!B&!A1&A|!F&E2&!E1&E&!D&!C&!B&!A1&A|!F&E2&E1&E&!D&!C&!B&!A1&A|!F&!E2&E1&E&!D&!C&!B&!A1&A|!F&!E2&E1&!E&!D&!C&!B&!A1&A|!F&E2&E1&!E&!D&!C&!B&!A1&A|!F&E2&!E1&!E&!D&!C&!B&!A1&A|!F&!E2&!E1&!E&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOOAOI211131.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAI2114 -l OAOOAI2114 -i D3 D2 D1 D C B A1 A -o Y -f Y=(!D3&!D2&!D1&!D&!C&!B&!A1&!A|D3&!D2&!D1&!D&!C&!B&!A1&!A|D3&D2&!D1&!D&!C&!B&!A1&!A|!D3&D2&!D1&!D&!C&!B&!A1&!A|!D3&D2&D1&!D&!C&!B&!A1&!A|D3&D2&D1&!D&!C&!B&!A1&!A|D3&!D2&D1&!D&!C&!B&!A1&!A|!D3&!D2&D1&!D&!C&!B&!A1&!A|!D3&!D2&D1&D&!C&!B&!A1&!A|D3&!D2&D1&D&!C&!B&!A1&!A|D3&D2&D1&D&!C&!B&!A1&!A|!D3&D2&D1&D&!C&!B&!A1&!A|!D3&D2&!D1&D&!C&!B&!A1&!A|D3&D2&!D1&D&!C&!B&!A1&!A|D3&!D2&!D1&D&!C&!B&!A1&!A|!D3&!D2&!D1&D&!C&!B&!A1&!A|!D3&!D2&!D1&!D&C&!B&!A1&!A|!D3&!D2&!D1&!D&C&B&!A1&!A|!D3&!D2&!D1&D&!C&B&!A1&!A|D3&!D2&!D1&D&!C&B&!A1&!A|D3&D2&!D1&D&!C&B&!A1&!A|!D3&D2&!D1&D&!C&B&!A1&!A|!D3&D2&D1&D&!C&B&!A1&!A|D3&D2&D1&D&!C&B&!A1&!A|D3&!D2&D1&D&!C&B&!A1&!A|!D3&!D2&D1&D&!C&B&!A1&!A|!D3&!D2&D1&!D&!C&B&!A1&!A|D3&!D2&D1&!D&!C&B&!A1&!A|D3&D2&D1&!D&!C&B&!A1&!A|!D3&D2&D1&!D&!C&B&!A1&!A|!D3&D2&!D1&!D&!C&B&!A1&!A|D3&D2&!D1&!D&!C&B&!A1&!A|D3&!D2&!D1&!D&!C&B&!A1&!A|!D3&!D2&!D1&!D&!C&B&!A1&!A|!D3&!D2&!D1&!D&!C&B&A1&!A|!D3&!D2&!D1&!D&C&B&A1&!A|!D3&!D2&!D1&!D&C&!B&A1&!A|!D3&!D2&!D1&D&!C&!B&A1&!A|D3&!D2&!D1&D&!C&!B&A1&!A|D3&D2&!D1&D&!C&!B&A1&!A|!D3&D2&!D1&D&!C&!B&A1&!A|!D3&D2&D1&D&!C&!B&A1&!A|D3&D2&D1&D&!C&!B&A1&!A|D3&!D2&D1&D&!C&!B&A1&!A|!D3&!D2&D1&D&!C&!B&A1&!A|!D3&!D2&D1&!D&!C&!B&A1&!A|D3&!D2&D1&!D&!C&!B&A1&!A|D3&D2&D1&!D&!C&!B&A1&!A|!D3&D2&D1&!D&!C&!B&A1&!A|!D3&D2&!D1&!D&!C&!B&A1&!A|D3&D2&!D1&!D&!C&!B&A1&!A|D3&!D2&!D1&!D&!C&!B&A1&!A|!D3&!D2&!D1&!D&!C&!B&A1&!A|!D3&!D2&!D1&!D&!C&!B&A1&A|D3&!D2&!D1&!D&!C&!B&A1&A|D3&D2&!D1&!D&!C&!B&A1&A|!D3&D2&!D1&!D&!C&!B&A1&A|!D3&D2&D1&!D&!C&!B&A1&A|D3&D2&D1&!D&!C&!B&A1&A|D3&!D2&D1&!D&!C&!B&A1&A|!D3&!D2&D1&!D&!C&!B&A1&A|!D3&!D2&D1&D&!C&!B&A1&A|D3&!D2&D1&D&!C&!B&A1&A|D3&D2&D1&D&!C&!B&A1&A|!D3&D2&D1&D&!C&!B&A1&A|!D3&D2&!D1&D&!C&!B&A1&A|D3&D2&!D1&D&!C&!B&A1&A|D3&!D2&!D1&D&!C&!B&A1&A|!D3&!D2&!D1&D&!C&!B&A1&A|!D3&!D2&!D1&!D&C&!B&A1&A|!D3&!D2&!D1&!D&C&B&A1&A|!D3&!D2&!D1&!D&!C&B&A1&A|!D3&!D2&!D1&!D&!C&B&!A1&A|!D3&!D2&!D1&!D&C&B&!A1&A|!D3&!D2&!D1&!D&C&!B&!A1&A|!D3&!D2&!D1&D&!C&!B&!A1&A|D3&!D2&!D1&D&!C&!B&!A1&A|D3&D2&!D1&D&!C&!B&!A1&A|!D3&D2&!D1&D&!C&!B&!A1&A|!D3&D2&D1&D&!C&!B&!A1&A|D3&D2&D1&D&!C&!B&!A1&A|D3&!D2&D1&D&!C&!B&!A1&A|!D3&!D2&D1&D&!C&!B&!A1&A|!D3&!D2&D1&!D&!C&!B&!A1&A|D3&!D2&D1&!D&!C&!B&!A1&A|D3&D2&D1&!D&!C&!B&!A1&A|!D3&D2&D1&!D&!C&!B&!A1&A|!D3&D2&!D1&!D&!C&!B&!A1&A|D3&D2&!D1&!D&!C&!B&!A1&A|D3&!D2&!D1&!D&!C&!B&!A1&A|!D3&!D2&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAI2114.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAI22 -l OAI22 -i B1 B A1 A -o Y -f Y=!(B1&B&A1&!A|B1&B&A1&A|B1&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAI22.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAOI211311 -l OAOOAOI211311 -i F E D2 D1 D C B A1 A -o Y -f Y=(!F&!E&!D2&!D1&!D&!C&!B&!A1&!A|!F&E&!D2&!D1&!D&!C&!B&!A1&!A|!F&E&D2&!D1&!D&!C&!B&!A1&!A|!F&!E&D2&!D1&!D&!C&!B&!A1&!A|!F&!E&D2&D1&!D&!C&!B&!A1&!A|!F&E&D2&D1&!D&!C&!B&!A1&!A|!F&E&!D2&D1&!D&!C&!B&!A1&!A|!F&!E&!D2&D1&!D&!C&!B&!A1&!A|!F&!E&!D2&D1&D&!C&!B&!A1&!A|!F&E&!D2&D1&D&!C&!B&!A1&!A|!F&E&D2&D1&D&!C&!B&!A1&!A|!F&!E&D2&D1&D&!C&!B&!A1&!A|!F&!E&D2&!D1&D&!C&!B&!A1&!A|!F&E&D2&!D1&D&!C&!B&!A1&!A|!F&E&!D2&!D1&D&!C&!B&!A1&!A|!F&!E&!D2&!D1&D&!C&!B&!A1&!A|!F&!E&!D2&!D1&D&C&!B&!A1&!A|!F&!E&D2&!D1&D&C&!B&!A1&!A|!F&!E&D2&D1&D&C&!B&!A1&!A|!F&!E&!D2&D1&D&C&!B&!A1&!A|!F&!E&!D2&D1&!D&C&!B&!A1&!A|!F&!E&D2&D1&!D&C&!B&!A1&!A|!F&!E&D2&!D1&!D&C&!B&!A1&!A|!F&E&!D2&!D1&!D&C&!B&!A1&!A|!F&!E&!D2&!D1&!D&C&!B&!A1&!A|!F&!E&!D2&!D1&!D&C&B&!A1&!A|!F&E&!D2&!D1&!D&C&B&!A1&!A|!F&!E&D2&!D1&!D&C&B&!A1&!A|!F&!E&D2&D1&!D&C&B&!A1&!A|!F&!E&!D2&D1&!D&C&B&!A1&!A|!F&!E&!D2&D1&D&C&B&!A1&!A|!F&!E&D2&D1&D&C&B&!A1&!A|!F&!E&D2&!D1&D&C&B&!A1&!A|!F&!E&!D2&!D1&D&C&B&!A1&!A|!F&!E&!D2&!D1&D&!C&B&!A1&!A|!F&E&!D2&!D1&D&!C&B&!A1&!A|!F&E&D2&!D1&D&!C&B&!A1&!A|!F&!E&D2&!D1&D&!C&B&!A1&!A|!F&!E&D2&D1&D&!C&B&!A1&!A|!F&E&D2&D1&D&!C&B&!A1&!A|!F&E&!D2&D1&D&!C&B&!A1&!A|!F&!E&!D2&D1&D&!C&B&!A1&!A|!F&!E&!D2&D1&!D&!C&B&!A1&!A|!F&E&!D2&D1&!D&!C&B&!A1&!A|!F&E&D2&D1&!D&!C&B&!A1&!A|!F&!E&D2&D1&!D&!C&B&!A1&!A|!F&!E&D2&!D1&!D&!C&B&!A1&!A|!F&E&D2&!D1&!D&!C&B&!A1&!A|!F&E&!D2&!D1&!D&!C&B&!A1&!A|!F&!E&!D2&!D1&!D&!C&B&!A1&!A|!F&!E&!D2&!D1&!D&!C&B&A1&!A|!F&E&!D2&!D1&!D&!C&B&A1&!A|!F&!E&D2&!D1&!D&!C&B&A1&!A|!F&!E&D2&D1&!D&!C&B&A1&!A|!F&!E&!D2&D1&!D&!C&B&A1&!A|!F&!E&!D2&D1&D&!C&B&A1&!A|!F&!E&D2&D1&D&!C&B&A1&!A|!F&!E&D2&!D1&D&!C&B&A1&!A|!F&!E&!D2&!D1&D&!C&B&A1&!A|!F&!E&!D2&!D1&D&C&B&A1&!A|!F&!E&D2&!D1&D&C&B&A1&!A|!F&!E&D2&D1&D&C&B&A1&!A|!F&!E&!D2&D1&D&C&B&A1&!A|!F&!E&!D2&D1&!D&C&B&A1&!A|!F&!E&D2&D1&!D&C&B&A1&!A|!F&!E&D2&!D1&!D&C&B&A1&!A|!F&E&!D2&!D1&!D&C&B&A1&!A|!F&!E&!D2&!D1&!D&C&B&A1&!A|!F&!E&!D2&!D1&!D&C&!B&A1&!A|!F&E&!D2&!D1&!D&C&!B&A1&!A|!F&!E&D2&!D1&!D&C&!B&A1&!A|!F&!E&D2&D1&!D&C&!B&A1&!A|!F&!E&!D2&D1&!D&C&!B&A1&!A|!F&!E&!D2&D1&D&C&!B&A1&!A|!F&!E&D2&D1&D&C&!B&A1&!A|!F&!E&D2&!D1&D&C&!B&A1&!A|!F&!E&!D2&!D1&D&C&!B&A1&!A|!F&!E&!D2&!D1&D&!C&!B&A1&!A|!F&E&!D2&!D1&D&!C&!B&A1&!A|!F&E&D2&!D1&D&!C&!B&A1&!A|!F&!E&D2&!D1&D&!C&!B&A1&!A|!F&!E&D2&D1&D&!C&!B&A1&!A|!F&E&D2&D1&D&!C&!B&A1&!A|!F&E&!D2&D1&D&!C&!B&A1&!A|!F&!E&!D2&D1&D&!C&!B&A1&!A|!F&!E&!D2&D1&!D&!C&!B&A1&!A|!F&E&!D2&D1&!D&!C&!B&A1&!A|!F&E&D2&D1&!D&!C&!B&A1&!A|!F&!E&D2&D1&!D&!C&!B&A1&!A|!F&!E&D2&!D1&!D&!C&!B&A1&!A|!F&E&D2&!D1&!D&!C&!B&A1&!A|!F&E&!D2&!D1&!D&!C&!B&A1&!A|!F&!E&!D2&!D1&!D&!C&!B&A1&!A|!F&!E&!D2&!D1&!D&!C&!B&A1&A|!F&E&!D2&!D1&!D&!C&!B&A1&A|!F&E&D2&!D1&!D&!C&!B&A1&A|!F&!E&D2&!D1&!D&!C&!B&A1&A|!F&!E&D2&D1&!D&!C&!B&A1&A|!F&E&D2&D1&!D&!C&!B&A1&A|!F&E&!D2&D1&!D&!C&!B&A1&A|!F&!E&!D2&D1&!D&!C&!B&A1&A|!F&!E&!D2&D1&D&!C&!B&A1&A|!F&E&!D2&D1&D&!C&!B&A1&A|!F&E&D2&D1&D&!C&!B&A1&A|!F&!E&D2&D1&D&!C&!B&A1&A|!F&!E&D2&!D1&D&!C&!B&A1&A|!F&E&D2&!D1&D&!C&!B&A1&A|!F&E&!D2&!D1&D&!C&!B&A1&A|!F&!E&!D2&!D1&D&!C&!B&A1&A|!F&!E&!D2&!D1&D&C&!B&A1&A|!F&!E&D2&!D1&D&C&!B&A1&A|!F&!E&D2&D1&D&C&!B&A1&A|!F&!E&!D2&D1&D&C&!B&A1&A|!F&!E&!D2&D1&!D&C&!B&A1&A|!F&!E&D2&D1&!D&C&!B&A1&A|!F&!E&D2&!D1&!D&C&!B&A1&A|!F&E&!D2&!D1&!D&C&!B&A1&A|!F&!E&!D2&!D1&!D&C&!B&A1&A|!F&!E&!D2&!D1&!D&C&B&A1&A|!F&E&!D2&!D1&!D&C&B&A1&A|!F&!E&D2&!D1&!D&C&B&A1&A|!F&!E&D2&D1&!D&C&B&A1&A|!F&!E&!D2&D1&!D&C&B&A1&A|!F&!E&!D2&D1&D&C&B&A1&A|!F&!E&D2&D1&D&C&B&A1&A|!F&!E&D2&!D1&D&C&B&A1&A|!F&!E&!D2&!D1&D&C&B&A1&A|!F&!E&!D2&!D1&D&!C&B&A1&A|!F&!E&D2&!D1&D&!C&B&A1&A|!F&!E&D2&D1&D&!C&B&A1&A|!F&!E&!D2&D1&D&!C&B&A1&A|!F&!E&!D2&D1&!D&!C&B&A1&A|!F&!E&D2&D1&!D&!C&B&A1&A|!F&!E&D2&!D1&!D&!C&B&A1&A|!F&E&!D2&!D1&!D&!C&B&A1&A|!F&!E&!D2&!D1&!D&!C&B&A1&A|!F&!E&!D2&!D1&!D&!C&B&!A1&A|!F&E&!D2&!D1&!D&!C&B&!A1&A|!F&!E&D2&!D1&!D&!C&B&!A1&A|!F&!E&D2&D1&!D&!C&B&!A1&A|!F&!E&!D2&D1&!D&!C&B&!A1&A|!F&!E&!D2&D1&D&!C&B&!A1&A|!F&!E&D2&D1&D&!C&B&!A1&A|!F&!E&D2&!D1&D&!C&B&!A1&A|!F&!E&!D2&!D1&D&!C&B&!A1&A|!F&!E&!D2&!D1&D&C&B&!A1&A|!F&!E&D2&!D1&D&C&B&!A1&A|!F&!E&D2&D1&D&C&B&!A1&A|!F&!E&!D2&D1&D&C&B&!A1&A|!F&!E&!D2&D1&!D&C&B&!A1&A|!F&!E&D2&D1&!D&C&B&!A1&A|!F&!E&D2&!D1&!D&C&B&!A1&A|!F&E&!D2&!D1&!D&C&B&!A1&A|!F&!E&!D2&!D1&!D&C&B&!A1&A|!F&!E&!D2&!D1&!D&C&!B&!A1&A|!F&E&!D2&!D1&!D&C&!B&!A1&A|!F&!E&D2&!D1&!D&C&!B&!A1&A|!F&!E&D2&D1&!D&C&!B&!A1&A|!F&!E&!D2&D1&!D&C&!B&!A1&A|!F&!E&!D2&D1&D&C&!B&!A1&A|!F&!E&D2&D1&D&C&!B&!A1&A|!F&!E&D2&!D1&D&C&!B&!A1&A|!F&!E&!D2&!D1&D&C&!B&!A1&A|!F&!E&!D2&!D1&D&!C&!B&!A1&A|!F&E&!D2&!D1&D&!C&!B&!A1&A|!F&E&D2&!D1&D&!C&!B&!A1&A|!F&!E&D2&!D1&D&!C&!B&!A1&A|!F&!E&D2&D1&D&!C&!B&!A1&A|!F&E&D2&D1&D&!C&!B&!A1&A|!F&E&!D2&D1&D&!C&!B&!A1&A|!F&!E&!D2&D1&D&!C&!B&!A1&A|!F&!E&!D2&D1&!D&!C&!B&!A1&A|!F&E&!D2&D1&!D&!C&!B&!A1&A|!F&E&D2&D1&!D&!C&!B&!A1&A|!F&!E&D2&D1&!D&!C&!B&!A1&A|!F&!E&D2&!D1&!D&!C&!B&!A1&A|!F&E&D2&!D1&!D&!C&!B&!A1&A|!F&E&!D2&!D1&!D&!C&!B&!A1&A|!F&!E&!D2&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAOI211311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOAI2122 -l OAAOOAI2122 -i D1 D C1 C B A1 A -o Y -f Y=!(D1&!D&C1&C&!B&!A1&!A|D1&D&C1&C&!B&!A1&!A|!D1&D&C1&C&!B&!A1&!A|!D1&D&C1&C&B&!A1&!A|D1&D&C1&C&B&!A1&!A|D1&!D&C1&C&B&!A1&!A|D1&!D&!C1&!C&B&A1&!A|D1&D&!C1&!C&B&A1&!A|!D1&D&!C1&!C&B&A1&!A|!D1&D&C1&!C&B&A1&!A|D1&D&C1&!C&B&A1&!A|D1&!D&C1&!C&B&A1&!A|D1&!D&C1&C&B&A1&!A|D1&D&C1&C&B&A1&!A|!D1&D&C1&C&B&A1&!A|!D1&D&!C1&C&B&A1&!A|D1&D&!C1&C&B&A1&!A|D1&!D&!C1&C&B&A1&!A|!D1&D&C1&C&!B&A1&!A|D1&D&C1&C&!B&A1&!A|D1&!D&C1&C&!B&A1&!A|D1&!D&C1&C&!B&A1&A|D1&D&C1&C&!B&A1&A|!D1&D&C1&C&!B&A1&A|D1&!D&!C1&C&B&A1&A|D1&D&!C1&C&B&A1&A|!D1&D&!C1&C&B&A1&A|!D1&D&C1&C&B&A1&A|D1&D&C1&C&B&A1&A|D1&!D&C1&C&B&A1&A|D1&!D&C1&!C&B&A1&A|D1&D&C1&!C&B&A1&A|!D1&D&C1&!C&B&A1&A|!D1&D&!C1&!C&B&A1&A|D1&D&!C1&!C&B&A1&A|D1&!D&!C1&!C&B&A1&A|D1&!D&!C1&!C&B&!A1&A|D1&D&!C1&!C&B&!A1&A|!D1&D&!C1&!C&B&!A1&A|!D1&D&C1&!C&B&!A1&A|D1&D&C1&!C&B&!A1&A|D1&!D&C1&!C&B&!A1&A|D1&!D&C1&C&B&!A1&A|D1&D&C1&C&B&!A1&A|!D1&D&C1&C&B&!A1&A|!D1&D&!C1&C&B&!A1&A|D1&D&!C1&C&B&!A1&A|D1&!D&!C1&C&B&!A1&A|!D1&D&C1&C&!B&!A1&A|D1&D&C1&C&!B&!A1&A|D1&!D&C1&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOAI2122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOOAI21114 -l AOAOOAI21114 -i E3 E2 E1 E D C B A1 A -o Y -f Y=(!E3&!E2&!E1&!E&!D&!C&!B&!A1&!A|E3&!E2&!E1&!E&!D&!C&!B&!A1&!A|E3&E2&!E1&!E&!D&!C&!B&!A1&!A|!E3&E2&!E1&!E&!D&!C&!B&!A1&!A|!E3&E2&E1&!E&!D&!C&!B&!A1&!A|E3&E2&E1&!E&!D&!C&!B&!A1&!A|E3&!E2&E1&!E&!D&!C&!B&!A1&!A|!E3&!E2&E1&!E&!D&!C&!B&!A1&!A|!E3&!E2&E1&E&!D&!C&!B&!A1&!A|E3&!E2&E1&E&!D&!C&!B&!A1&!A|E3&E2&E1&E&!D&!C&!B&!A1&!A|!E3&E2&E1&E&!D&!C&!B&!A1&!A|!E3&E2&!E1&E&!D&!C&!B&!A1&!A|E3&E2&!E1&E&!D&!C&!B&!A1&!A|E3&!E2&!E1&E&!D&!C&!B&!A1&!A|!E3&!E2&!E1&E&!D&!C&!B&!A1&!A|!E3&!E2&!E1&!E&D&!C&!B&!A1&!A|!E3&!E2&!E1&!E&D&C&!B&!A1&!A|!E3&!E2&!E1&E&!D&C&!B&!A1&!A|E3&!E2&!E1&E&!D&C&!B&!A1&!A|E3&E2&!E1&E&!D&C&!B&!A1&!A|!E3&E2&!E1&E&!D&C&!B&!A1&!A|!E3&E2&E1&E&!D&C&!B&!A1&!A|E3&E2&E1&E&!D&C&!B&!A1&!A|E3&!E2&E1&E&!D&C&!B&!A1&!A|!E3&!E2&E1&E&!D&C&!B&!A1&!A|!E3&!E2&E1&!E&!D&C&!B&!A1&!A|E3&!E2&E1&!E&!D&C&!B&!A1&!A|E3&E2&E1&!E&!D&C&!B&!A1&!A|!E3&E2&E1&!E&!D&C&!B&!A1&!A|!E3&E2&!E1&!E&!D&C&!B&!A1&!A|E3&E2&!E1&!E&!D&C&!B&!A1&!A|E3&!E2&!E1&!E&!D&C&!B&!A1&!A|!E3&!E2&!E1&!E&!D&C&!B&!A1&!A|!E3&!E2&!E1&!E&!D&C&B&!A1&!A|!E3&!E2&!E1&!E&D&C&B&!A1&!A|!E3&!E2&!E1&!E&D&!C&B&!A1&!A|!E3&!E2&!E1&E&!D&!C&B&!A1&!A|E3&!E2&!E1&E&!D&!C&B&!A1&!A|E3&E2&!E1&E&!D&!C&B&!A1&!A|!E3&E2&!E1&E&!D&!C&B&!A1&!A|!E3&E2&E1&E&!D&!C&B&!A1&!A|E3&E2&E1&E&!D&!C&B&!A1&!A|E3&!E2&E1&E&!D&!C&B&!A1&!A|!E3&!E2&E1&E&!D&!C&B&!A1&!A|!E3&!E2&E1&!E&!D&!C&B&!A1&!A|E3&!E2&E1&!E&!D&!C&B&!A1&!A|E3&E2&E1&!E&!D&!C&B&!A1&!A|!E3&E2&E1&!E&!D&!C&B&!A1&!A|!E3&E2&!E1&!E&!D&!C&B&!A1&!A|E3&E2&!E1&!E&!D&!C&B&!A1&!A|E3&!E2&!E1&!E&!D&!C&B&!A1&!A|!E3&!E2&!E1&!E&!D&!C&B&!A1&!A|!E3&!E2&!E1&!E&!D&!C&B&A1&!A|E3&!E2&!E1&!E&!D&!C&B&A1&!A|E3&E2&!E1&!E&!D&!C&B&A1&!A|!E3&E2&!E1&!E&!D&!C&B&A1&!A|!E3&E2&E1&!E&!D&!C&B&A1&!A|E3&E2&E1&!E&!D&!C&B&A1&!A|E3&!E2&E1&!E&!D&!C&B&A1&!A|!E3&!E2&E1&!E&!D&!C&B&A1&!A|!E3&!E2&E1&E&!D&!C&B&A1&!A|E3&!E2&E1&E&!D&!C&B&A1&!A|E3&E2&E1&E&!D&!C&B&A1&!A|!E3&E2&E1&E&!D&!C&B&A1&!A|!E3&E2&!E1&E&!D&!C&B&A1&!A|E3&E2&!E1&E&!D&!C&B&A1&!A|E3&!E2&!E1&E&!D&!C&B&A1&!A|!E3&!E2&!E1&E&!D&!C&B&A1&!A|!E3&!E2&!E1&!E&D&!C&B&A1&!A|!E3&!E2&!E1&!E&D&C&B&A1&!A|!E3&!E2&!E1&!E&!D&C&B&A1&!A|!E3&!E2&!E1&!E&!D&C&!B&A1&!A|E3&!E2&!E1&!E&!D&C&!B&A1&!A|E3&E2&!E1&!E&!D&C&!B&A1&!A|!E3&E2&!E1&!E&!D&C&!B&A1&!A|!E3&E2&E1&!E&!D&C&!B&A1&!A|E3&E2&E1&!E&!D&C&!B&A1&!A|E3&!E2&E1&!E&!D&C&!B&A1&!A|!E3&!E2&E1&!E&!D&C&!B&A1&!A|!E3&!E2&E1&E&!D&C&!B&A1&!A|E3&!E2&E1&E&!D&C&!B&A1&!A|E3&E2&E1&E&!D&C&!B&A1&!A|!E3&E2&E1&E&!D&C&!B&A1&!A|!E3&E2&!E1&E&!D&C&!B&A1&!A|E3&E2&!E1&E&!D&C&!B&A1&!A|E3&!E2&!E1&E&!D&C&!B&A1&!A|!E3&!E2&!E1&E&!D&C&!B&A1&!A|!E3&!E2&!E1&!E&D&C&!B&A1&!A|!E3&!E2&!E1&!E&D&!C&!B&A1&!A|!E3&!E2&!E1&E&!D&!C&!B&A1&!A|E3&!E2&!E1&E&!D&!C&!B&A1&!A|E3&E2&!E1&E&!D&!C&!B&A1&!A|!E3&E2&!E1&E&!D&!C&!B&A1&!A|!E3&E2&E1&E&!D&!C&!B&A1&!A|E3&E2&E1&E&!D&!C&!B&A1&!A|E3&!E2&E1&E&!D&!C&!B&A1&!A|!E3&!E2&E1&E&!D&!C&!B&A1&!A|!E3&!E2&E1&!E&!D&!C&!B&A1&!A|E3&!E2&E1&!E&!D&!C&!B&A1&!A|E3&E2&E1&!E&!D&!C&!B&A1&!A|!E3&E2&E1&!E&!D&!C&!B&A1&!A|!E3&E2&!E1&!E&!D&!C&!B&A1&!A|E3&E2&!E1&!E&!D&!C&!B&A1&!A|E3&!E2&!E1&!E&!D&!C&!B&A1&!A|!E3&!E2&!E1&!E&!D&!C&!B&A1&!A|!E3&!E2&!E1&!E&!D&!C&!B&A1&A|E3&!E2&!E1&!E&!D&!C&!B&A1&A|E3&E2&!E1&!E&!D&!C&!B&A1&A|!E3&E2&!E1&!E&!D&!C&!B&A1&A|!E3&E2&E1&!E&!D&!C&!B&A1&A|E3&E2&E1&!E&!D&!C&!B&A1&A|E3&!E2&E1&!E&!D&!C&!B&A1&A|!E3&!E2&E1&!E&!D&!C&!B&A1&A|!E3&!E2&E1&E&!D&!C&!B&A1&A|E3&!E2&E1&E&!D&!C&!B&A1&A|E3&E2&E1&E&!D&!C&!B&A1&A|!E3&E2&E1&E&!D&!C&!B&A1&A|!E3&E2&!E1&E&!D&!C&!B&A1&A|E3&E2&!E1&E&!D&!C&!B&A1&A|E3&!E2&!E1&E&!D&!C&!B&A1&A|!E3&!E2&!E1&E&!D&!C&!B&A1&A|!E3&!E2&!E1&!E&D&!C&!B&A1&A|!E3&!E2&!E1&!E&D&C&!B&A1&A|!E3&!E2&!E1&!E&!D&C&!B&A1&A|!E3&!E2&!E1&!E&!D&C&B&A1&A|!E3&!E2&!E1&!E&D&C&B&A1&A|!E3&!E2&!E1&!E&D&!C&B&A1&A|!E3&!E2&!E1&E&!D&!C&B&A1&A|E3&!E2&!E1&E&!D&!C&B&A1&A|E3&E2&!E1&E&!D&!C&B&A1&A|!E3&E2&!E1&E&!D&!C&B&A1&A|!E3&E2&E1&E&!D&!C&B&A1&A|E3&E2&E1&E&!D&!C&B&A1&A|E3&!E2&E1&E&!D&!C&B&A1&A|!E3&!E2&E1&E&!D&!C&B&A1&A|!E3&!E2&E1&!E&!D&!C&B&A1&A|E3&!E2&E1&!E&!D&!C&B&A1&A|E3&E2&E1&!E&!D&!C&B&A1&A|!E3&E2&E1&!E&!D&!C&B&A1&A|!E3&E2&!E1&!E&!D&!C&B&A1&A|E3&E2&!E1&!E&!D&!C&B&A1&A|E3&!E2&!E1&!E&!D&!C&B&A1&A|!E3&!E2&!E1&!E&!D&!C&B&A1&A|!E3&!E2&!E1&!E&!D&!C&B&!A1&A|E3&!E2&!E1&!E&!D&!C&B&!A1&A|E3&E2&!E1&!E&!D&!C&B&!A1&A|!E3&E2&!E1&!E&!D&!C&B&!A1&A|!E3&E2&E1&!E&!D&!C&B&!A1&A|E3&E2&E1&!E&!D&!C&B&!A1&A|E3&!E2&E1&!E&!D&!C&B&!A1&A|!E3&!E2&E1&!E&!D&!C&B&!A1&A|!E3&!E2&E1&E&!D&!C&B&!A1&A|E3&!E2&E1&E&!D&!C&B&!A1&A|E3&E2&E1&E&!D&!C&B&!A1&A|!E3&E2&E1&E&!D&!C&B&!A1&A|!E3&E2&!E1&E&!D&!C&B&!A1&A|E3&E2&!E1&E&!D&!C&B&!A1&A|E3&!E2&!E1&E&!D&!C&B&!A1&A|!E3&!E2&!E1&E&!D&!C&B&!A1&A|!E3&!E2&!E1&!E&D&!C&B&!A1&A|!E3&!E2&!E1&!E&D&C&B&!A1&A|!E3&!E2&!E1&!E&!D&C&B&!A1&A|!E3&!E2&!E1&!E&!D&C&!B&!A1&A|E3&!E2&!E1&!E&!D&C&!B&!A1&A|E3&E2&!E1&!E&!D&C&!B&!A1&A|!E3&E2&!E1&!E&!D&C&!B&!A1&A|!E3&E2&E1&!E&!D&C&!B&!A1&A|E3&E2&E1&!E&!D&C&!B&!A1&A|E3&!E2&E1&!E&!D&C&!B&!A1&A|!E3&!E2&E1&!E&!D&C&!B&!A1&A|!E3&!E2&E1&E&!D&C&!B&!A1&A|E3&!E2&E1&E&!D&C&!B&!A1&A|E3&E2&E1&E&!D&C&!B&!A1&A|!E3&E2&E1&E&!D&C&!B&!A1&A|!E3&E2&!E1&E&!D&C&!B&!A1&A|E3&E2&!E1&E&!D&C&!B&!A1&A|E3&!E2&!E1&E&!D&C&!B&!A1&A|!E3&!E2&!E1&E&!D&C&!B&!A1&A|!E3&!E2&!E1&!E&D&C&!B&!A1&A|!E3&!E2&!E1&!E&D&!C&!B&!A1&A|!E3&!E2&!E1&E&!D&!C&!B&!A1&A|E3&!E2&!E1&E&!D&!C&!B&!A1&A|E3&E2&!E1&E&!D&!C&!B&!A1&A|!E3&E2&!E1&E&!D&!C&!B&!A1&A|!E3&E2&E1&E&!D&!C&!B&!A1&A|E3&E2&E1&E&!D&!C&!B&!A1&A|E3&!E2&E1&E&!D&!C&!B&!A1&A|!E3&!E2&E1&E&!D&!C&!B&!A1&A|!E3&!E2&E1&!E&!D&!C&!B&!A1&A|E3&!E2&E1&!E&!D&!C&!B&!A1&A|E3&E2&E1&!E&!D&!C&!B&!A1&A|!E3&E2&E1&!E&!D&!C&!B&!A1&A|!E3&E2&!E1&!E&!D&!C&!B&!A1&A|E3&E2&!E1&!E&!D&!C&!B&!A1&A|E3&!E2&!E1&!E&!D&!C&!B&!A1&A|!E3&!E2&!E1&!E&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOOAI21114.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOAOI211111 -l AOAOAOI211111 -i F E D C B A1 A -o Y -f Y=(!F&!E&!D&!C&!B&!A1&!A|!F&E&!D&!C&!B&!A1&!A|!F&!E&D&!C&!B&!A1&!A|!F&!E&D&C&!B&!A1&!A|!F&E&!D&C&!B&!A1&!A|!F&!E&!D&C&!B&!A1&!A|!F&!E&!D&C&B&!A1&!A|!F&!E&D&C&B&!A1&!A|!F&!E&D&!C&B&!A1&!A|!F&E&!D&!C&B&!A1&!A|!F&!E&!D&!C&B&!A1&!A|!F&!E&!D&!C&B&A1&!A|!F&E&!D&!C&B&A1&!A|!F&!E&D&!C&B&A1&!A|!F&!E&D&C&B&A1&!A|!F&!E&!D&C&B&A1&!A|!F&!E&!D&C&!B&A1&!A|!F&E&!D&C&!B&A1&!A|!F&!E&D&C&!B&A1&!A|!F&!E&D&!C&!B&A1&!A|!F&E&!D&!C&!B&A1&!A|!F&!E&!D&!C&!B&A1&!A|!F&!E&!D&!C&!B&A1&A|!F&E&!D&!C&!B&A1&A|!F&!E&D&!C&!B&A1&A|!F&!E&D&C&!B&A1&A|!F&!E&!D&C&!B&A1&A|!F&!E&!D&C&B&A1&A|!F&!E&D&C&B&A1&A|!F&!E&D&!C&B&A1&A|!F&E&!D&!C&B&A1&A|!F&!E&!D&!C&B&A1&A|!F&!E&!D&!C&B&!A1&A|!F&E&!D&!C&B&!A1&A|!F&!E&D&!C&B&!A1&A|!F&!E&D&C&B&!A1&A|!F&!E&!D&C&B&!A1&A|!F&!E&!D&C&!B&!A1&A|!F&E&!D&C&!B&!A1&A|!F&!E&D&C&!B&!A1&A|!F&!E&D&!C&!B&!A1&A|!F&E&!D&!C&!B&!A1&A|!F&!E&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOAOI211111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOI3122 -l AOOAAOI3122 -i D1 D C1 C B A2 A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B&!A2&!A1&!A|D1&!D&!C1&!C&!B&!A2&!A1&!A|!D1&D&!C1&!C&!B&!A2&!A1&!A|!D1&D&C1&!C&!B&!A2&!A1&!A|D1&!D&C1&!C&!B&!A2&!A1&!A|!D1&!D&C1&!C&!B&!A2&!A1&!A|!D1&!D&C1&C&!B&!A2&!A1&!A|D1&!D&C1&C&!B&!A2&!A1&!A|!D1&D&C1&C&!B&!A2&!A1&!A|!D1&D&!C1&C&!B&!A2&!A1&!A|D1&!D&!C1&C&!B&!A2&!A1&!A|!D1&!D&!C1&C&!B&!A2&!A1&!A|!D1&D&!C1&!C&B&!A2&!A1&!A|D1&!D&!C1&!C&B&!A2&!A1&!A|!D1&!D&!C1&!C&B&!A2&!A1&!A|!D1&!D&!C1&!C&B&A2&!A1&!A|D1&!D&!C1&!C&B&A2&!A1&!A|!D1&D&!C1&!C&B&A2&!A1&!A|!D1&!D&!C1&C&!B&A2&!A1&!A|D1&!D&!C1&C&!B&A2&!A1&!A|!D1&D&!C1&C&!B&A2&!A1&!A|!D1&D&C1&C&!B&A2&!A1&!A|D1&!D&C1&C&!B&A2&!A1&!A|!D1&!D&C1&C&!B&A2&!A1&!A|!D1&!D&C1&!C&!B&A2&!A1&!A|D1&!D&C1&!C&!B&A2&!A1&!A|!D1&D&C1&!C&!B&A2&!A1&!A|!D1&D&!C1&!C&!B&A2&!A1&!A|D1&!D&!C1&!C&!B&A2&!A1&!A|!D1&!D&!C1&!C&!B&A2&!A1&!A|!D1&!D&!C1&!C&!B&A2&A1&!A|D1&!D&!C1&!C&!B&A2&A1&!A|!D1&D&!C1&!C&!B&A2&A1&!A|!D1&D&C1&!C&!B&A2&A1&!A|D1&!D&C1&!C&!B&A2&A1&!A|!D1&!D&C1&!C&!B&A2&A1&!A|!D1&!D&C1&C&!B&A2&A1&!A|D1&!D&C1&C&!B&A2&A1&!A|!D1&D&C1&C&!B&A2&A1&!A|!D1&D&!C1&C&!B&A2&A1&!A|D1&!D&!C1&C&!B&A2&A1&!A|!D1&!D&!C1&C&!B&A2&A1&!A|!D1&D&!C1&!C&B&A2&A1&!A|D1&!D&!C1&!C&B&A2&A1&!A|!D1&!D&!C1&!C&B&A2&A1&!A|!D1&!D&!C1&!C&B&!A2&A1&!A|D1&!D&!C1&!C&B&!A2&A1&!A|!D1&D&!C1&!C&B&!A2&A1&!A|!D1&!D&!C1&C&!B&!A2&A1&!A|D1&!D&!C1&C&!B&!A2&A1&!A|!D1&D&!C1&C&!B&!A2&A1&!A|!D1&D&C1&C&!B&!A2&A1&!A|D1&!D&C1&C&!B&!A2&A1&!A|!D1&!D&C1&C&!B&!A2&A1&!A|!D1&!D&C1&!C&!B&!A2&A1&!A|D1&!D&C1&!C&!B&!A2&A1&!A|!D1&D&C1&!C&!B&!A2&A1&!A|!D1&D&!C1&!C&!B&!A2&A1&!A|D1&!D&!C1&!C&!B&!A2&A1&!A|!D1&!D&!C1&!C&!B&!A2&A1&!A|!D1&!D&!C1&!C&!B&!A2&A1&A|D1&!D&!C1&!C&!B&!A2&A1&A|!D1&D&!C1&!C&!B&!A2&A1&A|!D1&D&C1&!C&!B&!A2&A1&A|D1&!D&C1&!C&!B&!A2&A1&A|!D1&!D&C1&!C&!B&!A2&A1&A|!D1&!D&C1&C&!B&!A2&A1&A|D1&!D&C1&C&!B&!A2&A1&A|!D1&D&C1&C&!B&!A2&A1&A|!D1&D&!C1&C&!B&!A2&A1&A|D1&!D&!C1&C&!B&!A2&A1&A|!D1&!D&!C1&C&!B&!A2&A1&A|!D1&D&!C1&!C&B&!A2&A1&A|D1&!D&!C1&!C&B&!A2&A1&A|!D1&!D&!C1&!C&B&!A2&A1&A|!D1&!D&!C1&!C&B&A2&A1&A|D1&!D&!C1&!C&B&A2&A1&A|!D1&D&!C1&!C&B&A2&A1&A|!D1&D&!C1&!C&!B&A2&A1&A|D1&!D&!C1&!C&!B&A2&A1&A|!D1&!D&!C1&!C&!B&A2&A1&A|!D1&!D&!C1&!C&!B&A2&!A1&A|D1&!D&!C1&!C&!B&A2&!A1&A|!D1&D&!C1&!C&!B&A2&!A1&A|!D1&D&C1&!C&!B&A2&!A1&A|D1&!D&C1&!C&!B&A2&!A1&A|!D1&!D&C1&!C&!B&A2&!A1&A|!D1&!D&C1&C&!B&A2&!A1&A|D1&!D&C1&C&!B&A2&!A1&A|!D1&D&C1&C&!B&A2&!A1&A|!D1&D&!C1&C&!B&A2&!A1&A|D1&!D&!C1&C&!B&A2&!A1&A|!D1&!D&!C1&C&!B&A2&!A1&A|!D1&D&!C1&!C&B&A2&!A1&A|D1&!D&!C1&!C&B&A2&!A1&A|!D1&!D&!C1&!C&B&A2&!A1&A|!D1&!D&!C1&!C&B&!A2&!A1&A|D1&!D&!C1&!C&B&!A2&!A1&A|!D1&D&!C1&!C&B&!A2&!A1&A|!D1&!D&!C1&C&!B&!A2&!A1&A|D1&!D&!C1&C&!B&!A2&!A1&A|!D1&D&!C1&C&!B&!A2&!A1&A|!D1&D&C1&C&!B&!A2&!A1&A|D1&!D&C1&C&!B&!A2&!A1&A|!D1&!D&C1&C&!B&!A2&!A1&A|!D1&!D&C1&!C&!B&!A2&!A1&A|D1&!D&C1&!C&!B&!A2&!A1&A|!D1&D&C1&!C&!B&!A2&!A1&A|!D1&D&!C1&!C&!B&!A2&!A1&A|D1&!D&!C1&!C&!B&!A2&!A1&A|!D1&!D&!C1&!C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOI3122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOAI22121 -l AAOAAOAI22121 -i E D1 D C B1 B A1 A -o Y -f Y=!(E&D1&D&!C&!B1&!B&!A1&!A|E&D1&D&C&!B1&!B&!A1&!A|E&D1&D&C&B1&!B&!A1&!A|E&D1&D&!C&B1&!B&!A1&!A|E&D1&D&!C&B1&B&!A1&!A|E&!D1&D&C&B1&B&!A1&!A|E&D1&D&C&B1&B&!A1&!A|E&D1&!D&C&B1&B&!A1&!A|E&!D1&!D&C&B1&B&!A1&!A|E&D1&D&C&!B1&B&!A1&!A|E&D1&D&!C&!B1&B&!A1&!A|E&D1&D&!C&!B1&B&A1&!A|E&D1&D&C&!B1&B&A1&!A|E&!D1&!D&C&B1&B&A1&!A|E&D1&!D&C&B1&B&A1&!A|E&D1&D&C&B1&B&A1&!A|E&!D1&D&C&B1&B&A1&!A|E&D1&D&!C&B1&B&A1&!A|E&D1&D&!C&B1&!B&A1&!A|E&D1&D&C&B1&!B&A1&!A|E&D1&D&C&!B1&!B&A1&!A|E&D1&D&!C&!B1&!B&A1&!A|E&D1&D&!C&!B1&!B&A1&A|E&!D1&D&C&!B1&!B&A1&A|E&D1&D&C&!B1&!B&A1&A|E&D1&!D&C&!B1&!B&A1&A|E&!D1&!D&C&!B1&!B&A1&A|E&!D1&!D&C&B1&!B&A1&A|E&D1&!D&C&B1&!B&A1&A|E&D1&D&C&B1&!B&A1&A|E&!D1&D&C&B1&!B&A1&A|E&D1&D&!C&B1&!B&A1&A|E&D1&D&!C&B1&B&A1&A|E&!D1&D&C&B1&B&A1&A|E&D1&D&C&B1&B&A1&A|E&D1&!D&C&B1&B&A1&A|E&!D1&!D&C&B1&B&A1&A|E&!D1&!D&C&!B1&B&A1&A|E&D1&!D&C&!B1&B&A1&A|E&D1&D&C&!B1&B&A1&A|E&!D1&D&C&!B1&B&A1&A|E&D1&D&!C&!B1&B&A1&A|E&D1&D&!C&!B1&B&!A1&A|E&D1&D&C&!B1&B&!A1&A|E&!D1&!D&C&B1&B&!A1&A|E&D1&!D&C&B1&B&!A1&A|E&D1&D&C&B1&B&!A1&A|E&!D1&D&C&B1&B&!A1&A|E&D1&D&!C&B1&B&!A1&A|E&D1&D&!C&B1&!B&!A1&A|E&D1&D&C&B1&!B&!A1&A|E&D1&D&C&!B1&!B&!A1&A|E&D1&D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOAI22121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAI332 -l OOOAI332 -i C1 C B2 B1 B A2 A1 A -o Y -f Y=(!C1&!C&!B2&!B1&!B&!A2&!A1&!A|C1&!C&!B2&!B1&!B&!A2&!A1&!A|C1&C&!B2&!B1&!B&!A2&!A1&!A|!C1&C&!B2&!B1&!B&!A2&!A1&!A|!C1&C&B2&!B1&!B&!A2&!A1&!A|C1&C&B2&!B1&!B&!A2&!A1&!A|C1&!C&B2&!B1&!B&!A2&!A1&!A|!C1&!C&B2&!B1&!B&!A2&!A1&!A|!C1&!C&B2&B1&!B&!A2&!A1&!A|C1&!C&B2&B1&!B&!A2&!A1&!A|C1&C&B2&B1&!B&!A2&!A1&!A|!C1&C&B2&B1&!B&!A2&!A1&!A|!C1&C&!B2&B1&!B&!A2&!A1&!A|C1&C&!B2&B1&!B&!A2&!A1&!A|C1&!C&!B2&B1&!B&!A2&!A1&!A|!C1&!C&!B2&B1&!B&!A2&!A1&!A|!C1&!C&!B2&B1&B&!A2&!A1&!A|C1&!C&!B2&B1&B&!A2&!A1&!A|C1&C&!B2&B1&B&!A2&!A1&!A|!C1&C&!B2&B1&B&!A2&!A1&!A|!C1&C&B2&B1&B&!A2&!A1&!A|C1&C&B2&B1&B&!A2&!A1&!A|C1&!C&B2&B1&B&!A2&!A1&!A|!C1&!C&B2&B1&B&!A2&!A1&!A|!C1&!C&B2&!B1&B&!A2&!A1&!A|C1&!C&B2&!B1&B&!A2&!A1&!A|C1&C&B2&!B1&B&!A2&!A1&!A|!C1&C&B2&!B1&B&!A2&!A1&!A|!C1&C&!B2&!B1&B&!A2&!A1&!A|C1&C&!B2&!B1&B&!A2&!A1&!A|C1&!C&!B2&!B1&B&!A2&!A1&!A|!C1&!C&!B2&!B1&B&!A2&!A1&!A|!C1&!C&!B2&!B1&B&A2&!A1&!A|!C1&!C&B2&!B1&B&A2&!A1&!A|!C1&!C&B2&B1&B&A2&!A1&!A|!C1&!C&!B2&B1&B&A2&!A1&!A|!C1&!C&!B2&B1&!B&A2&!A1&!A|!C1&!C&B2&B1&!B&A2&!A1&!A|!C1&!C&B2&!B1&!B&A2&!A1&!A|!C1&C&!B2&!B1&!B&A2&!A1&!A|C1&C&!B2&!B1&!B&A2&!A1&!A|C1&!C&!B2&!B1&!B&A2&!A1&!A|!C1&!C&!B2&!B1&!B&A2&!A1&!A|!C1&!C&!B2&!B1&!B&A2&A1&!A|C1&!C&!B2&!B1&!B&A2&A1&!A|C1&C&!B2&!B1&!B&A2&A1&!A|!C1&C&!B2&!B1&!B&A2&A1&!A|!C1&!C&B2&!B1&!B&A2&A1&!A|!C1&!C&B2&B1&!B&A2&A1&!A|!C1&!C&!B2&B1&!B&A2&A1&!A|!C1&!C&!B2&B1&B&A2&A1&!A|!C1&!C&B2&B1&B&A2&A1&!A|!C1&!C&B2&!B1&B&A2&A1&!A|!C1&!C&!B2&!B1&B&A2&A1&!A|!C1&!C&!B2&!B1&B&!A2&A1&!A|!C1&!C&B2&!B1&B&!A2&A1&!A|!C1&!C&B2&B1&B&!A2&A1&!A|!C1&!C&!B2&B1&B&!A2&A1&!A|!C1&!C&!B2&B1&!B&!A2&A1&!A|!C1&!C&B2&B1&!B&!A2&A1&!A|!C1&!C&B2&!B1&!B&!A2&A1&!A|!C1&C&!B2&!B1&!B&!A2&A1&!A|C1&C&!B2&!B1&!B&!A2&A1&!A|C1&!C&!B2&!B1&!B&!A2&A1&!A|!C1&!C&!B2&!B1&!B&!A2&A1&!A|!C1&!C&!B2&!B1&!B&!A2&A1&A|C1&!C&!B2&!B1&!B&!A2&A1&A|C1&C&!B2&!B1&!B&!A2&A1&A|!C1&C&!B2&!B1&!B&!A2&A1&A|!C1&!C&B2&!B1&!B&!A2&A1&A|!C1&!C&B2&B1&!B&!A2&A1&A|!C1&!C&!B2&B1&!B&!A2&A1&A|!C1&!C&!B2&B1&B&!A2&A1&A|!C1&!C&B2&B1&B&!A2&A1&A|!C1&!C&B2&!B1&B&!A2&A1&A|!C1&!C&!B2&!B1&B&!A2&A1&A|!C1&!C&!B2&!B1&B&A2&A1&A|!C1&!C&B2&!B1&B&A2&A1&A|!C1&!C&B2&B1&B&A2&A1&A|!C1&!C&!B2&B1&B&A2&A1&A|!C1&!C&!B2&B1&!B&A2&A1&A|!C1&!C&B2&B1&!B&A2&A1&A|!C1&!C&B2&!B1&!B&A2&A1&A|!C1&C&!B2&!B1&!B&A2&A1&A|C1&C&!B2&!B1&!B&A2&A1&A|C1&!C&!B2&!B1&!B&A2&A1&A|!C1&!C&!B2&!B1&!B&A2&A1&A|!C1&!C&!B2&!B1&!B&A2&!A1&A|C1&!C&!B2&!B1&!B&A2&!A1&A|C1&C&!B2&!B1&!B&A2&!A1&A|!C1&C&!B2&!B1&!B&A2&!A1&A|!C1&!C&B2&!B1&!B&A2&!A1&A|!C1&!C&B2&B1&!B&A2&!A1&A|!C1&!C&!B2&B1&!B&A2&!A1&A|!C1&!C&!B2&B1&B&A2&!A1&A|!C1&!C&B2&B1&B&A2&!A1&A|!C1&!C&B2&!B1&B&A2&!A1&A|!C1&!C&!B2&!B1&B&A2&!A1&A|!C1&!C&!B2&!B1&B&!A2&!A1&A|!C1&!C&B2&!B1&B&!A2&!A1&A|!C1&!C&B2&B1&B&!A2&!A1&A|!C1&!C&!B2&B1&B&!A2&!A1&A|!C1&!C&!B2&B1&!B&!A2&!A1&A|!C1&!C&B2&B1&!B&!A2&!A1&A|!C1&!C&B2&!B1&!B&!A2&!A1&A|!C1&C&!B2&!B1&!B&!A2&!A1&A|C1&C&!B2&!B1&!B&!A2&!A1&A|C1&!C&!B2&!B1&!B&!A2&!A1&A|!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAI332.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAI31 -l OAI31 -i B A2 A1 A -o Y -f Y=!(B&A2&!A1&!A|B&A2&A1&!A|B&!A2&A1&!A|B&!A2&A1&A|B&A2&A1&A|B&A2&!A1&A|B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAI31.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOI222 -l AAAOI222 -i C1 C B1 B A1 A -o Y -f Y=(!C1&!C&!B1&!B&!A1&!A|C1&!C&!B1&!B&!A1&!A|!C1&C&!B1&!B&!A1&!A|!C1&C&B1&!B&!A1&!A|C1&!C&B1&!B&!A1&!A|!C1&!C&B1&!B&!A1&!A|!C1&C&!B1&B&!A1&!A|C1&!C&!B1&B&!A1&!A|!C1&!C&!B1&B&!A1&!A|!C1&!C&!B1&B&A1&!A|C1&!C&!B1&B&A1&!A|!C1&C&!B1&B&A1&!A|!C1&!C&B1&!B&A1&!A|C1&!C&B1&!B&A1&!A|!C1&C&B1&!B&A1&!A|!C1&C&!B1&!B&A1&!A|C1&!C&!B1&!B&A1&!A|!C1&!C&!B1&!B&A1&!A|!C1&!C&!B1&B&!A1&A|C1&!C&!B1&B&!A1&A|!C1&C&!B1&B&!A1&A|!C1&!C&B1&!B&!A1&A|C1&!C&B1&!B&!A1&A|!C1&C&B1&!B&!A1&A|!C1&C&!B1&!B&!A1&A|C1&!C&!B1&!B&!A1&A|!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOI222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOI2211 -l AOAOI2211 -i D C B1 B A1 A -o Y -f Y=(!D&!C&!B1&!B&!A1&!A|!D&C&!B1&!B&!A1&!A|!D&!C&B1&!B&!A1&!A|!D&!C&B1&B&!A1&!A|!D&!C&!B1&B&!A1&!A|!D&!C&!B1&B&A1&!A|!D&!C&B1&B&A1&!A|!D&!C&B1&!B&A1&!A|!D&C&!B1&!B&A1&!A|!D&!C&!B1&!B&A1&!A|!D&!C&!B1&!B&A1&A|!D&!C&B1&!B&A1&A|!D&!C&B1&B&A1&A|!D&!C&!B1&B&A1&A|!D&!C&!B1&B&!A1&A|!D&!C&B1&B&!A1&A|!D&!C&B1&!B&!A1&A|!D&C&!B1&!B&!A1&A|!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOI2211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAOOAI22112 -l AAOAOOAI22112 -i E1 E D C B1 B A1 A -o Y -f Y=!(!E1&E&D&!C&!B1&!B&!A1&!A|E1&E&D&!C&!B1&!B&!A1&!A|E1&!E&D&!C&!B1&!B&!A1&!A|E1&!E&D&C&!B1&!B&!A1&!A|E1&E&D&C&!B1&!B&!A1&!A|!E1&E&D&C&!B1&!B&!A1&!A|!E1&E&D&C&B1&!B&!A1&!A|E1&E&D&C&B1&!B&!A1&!A|E1&!E&D&C&B1&!B&!A1&!A|E1&!E&D&!C&B1&!B&!A1&!A|E1&E&D&!C&B1&!B&!A1&!A|!E1&E&D&!C&B1&!B&!A1&!A|!E1&E&D&!C&B1&B&!A1&!A|E1&E&D&!C&B1&B&!A1&!A|E1&!E&D&!C&B1&B&!A1&!A|E1&!E&D&C&B1&B&!A1&!A|E1&E&D&C&B1&B&!A1&!A|!E1&E&D&C&B1&B&!A1&!A|!E1&E&!D&C&B1&B&!A1&!A|E1&E&!D&C&B1&B&!A1&!A|E1&!E&!D&C&B1&B&!A1&!A|!E1&E&D&C&!B1&B&!A1&!A|E1&E&D&C&!B1&B&!A1&!A|E1&!E&D&C&!B1&B&!A1&!A|E1&!E&D&!C&!B1&B&!A1&!A|E1&E&D&!C&!B1&B&!A1&!A|!E1&E&D&!C&!B1&B&!A1&!A|!E1&E&D&!C&!B1&B&A1&!A|E1&E&D&!C&!B1&B&A1&!A|E1&!E&D&!C&!B1&B&A1&!A|E1&!E&D&C&!B1&B&A1&!A|E1&E&D&C&!B1&B&A1&!A|!E1&E&D&C&!B1&B&A1&!A|E1&!E&!D&C&B1&B&A1&!A|E1&E&!D&C&B1&B&A1&!A|!E1&E&!D&C&B1&B&A1&!A|!E1&E&D&C&B1&B&A1&!A|E1&E&D&C&B1&B&A1&!A|E1&!E&D&C&B1&B&A1&!A|E1&!E&D&!C&B1&B&A1&!A|E1&E&D&!C&B1&B&A1&!A|!E1&E&D&!C&B1&B&A1&!A|!E1&E&D&!C&B1&!B&A1&!A|E1&E&D&!C&B1&!B&A1&!A|E1&!E&D&!C&B1&!B&A1&!A|E1&!E&D&C&B1&!B&A1&!A|E1&E&D&C&B1&!B&A1&!A|!E1&E&D&C&B1&!B&A1&!A|!E1&E&D&C&!B1&!B&A1&!A|E1&E&D&C&!B1&!B&A1&!A|E1&!E&D&C&!B1&!B&A1&!A|E1&!E&D&!C&!B1&!B&A1&!A|E1&E&D&!C&!B1&!B&A1&!A|!E1&E&D&!C&!B1&!B&A1&!A|!E1&E&D&!C&!B1&!B&A1&A|E1&E&D&!C&!B1&!B&A1&A|E1&!E&D&!C&!B1&!B&A1&A|E1&!E&D&C&!B1&!B&A1&A|E1&E&D&C&!B1&!B&A1&A|!E1&E&D&C&!B1&!B&A1&A|!E1&E&!D&C&!B1&!B&A1&A|E1&E&!D&C&!B1&!B&A1&A|E1&!E&!D&C&!B1&!B&A1&A|E1&!E&!D&C&B1&!B&A1&A|E1&E&!D&C&B1&!B&A1&A|!E1&E&!D&C&B1&!B&A1&A|!E1&E&D&C&B1&!B&A1&A|E1&E&D&C&B1&!B&A1&A|E1&!E&D&C&B1&!B&A1&A|E1&!E&D&!C&B1&!B&A1&A|E1&E&D&!C&B1&!B&A1&A|!E1&E&D&!C&B1&!B&A1&A|!E1&E&D&!C&B1&B&A1&A|E1&E&D&!C&B1&B&A1&A|E1&!E&D&!C&B1&B&A1&A|E1&!E&D&C&B1&B&A1&A|E1&E&D&C&B1&B&A1&A|!E1&E&D&C&B1&B&A1&A|!E1&E&!D&C&B1&B&A1&A|E1&E&!D&C&B1&B&A1&A|E1&!E&!D&C&B1&B&A1&A|E1&!E&!D&C&!B1&B&A1&A|E1&E&!D&C&!B1&B&A1&A|!E1&E&!D&C&!B1&B&A1&A|!E1&E&D&C&!B1&B&A1&A|E1&E&D&C&!B1&B&A1&A|E1&!E&D&C&!B1&B&A1&A|E1&!E&D&!C&!B1&B&A1&A|E1&E&D&!C&!B1&B&A1&A|!E1&E&D&!C&!B1&B&A1&A|!E1&E&D&!C&!B1&B&!A1&A|E1&E&D&!C&!B1&B&!A1&A|E1&!E&D&!C&!B1&B&!A1&A|E1&!E&D&C&!B1&B&!A1&A|E1&E&D&C&!B1&B&!A1&A|!E1&E&D&C&!B1&B&!A1&A|E1&!E&!D&C&B1&B&!A1&A|E1&E&!D&C&B1&B&!A1&A|!E1&E&!D&C&B1&B&!A1&A|!E1&E&D&C&B1&B&!A1&A|E1&E&D&C&B1&B&!A1&A|E1&!E&D&C&B1&B&!A1&A|E1&!E&D&!C&B1&B&!A1&A|E1&E&D&!C&B1&B&!A1&A|!E1&E&D&!C&B1&B&!A1&A|!E1&E&D&!C&B1&!B&!A1&A|E1&E&D&!C&B1&!B&!A1&A|E1&!E&D&!C&B1&!B&!A1&A|E1&!E&D&C&B1&!B&!A1&A|E1&E&D&C&B1&!B&!A1&A|!E1&E&D&C&B1&!B&!A1&A|!E1&E&D&C&!B1&!B&!A1&A|E1&E&D&C&!B1&!B&!A1&A|E1&!E&D&C&!B1&!B&!A1&A|E1&!E&D&!C&!B1&!B&!A1&A|E1&E&D&!C&!B1&!B&!A1&A|!E1&E&D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAOOAI22112.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOI31121 -l AOAAOI31121 -i E D1 D C B A2 A1 A -o Y -f Y=(!E&!D1&!D&!C&!B&!A2&!A1&!A|!E&D1&!D&!C&!B&!A2&!A1&!A|!E&!D1&D&!C&!B&!A2&!A1&!A|!E&!D1&D&C&!B&!A2&!A1&!A|!E&D1&!D&C&!B&!A2&!A1&!A|!E&!D1&!D&C&!B&!A2&!A1&!A|!E&!D1&D&!C&B&!A2&!A1&!A|!E&D1&!D&!C&B&!A2&!A1&!A|!E&!D1&!D&!C&B&!A2&!A1&!A|!E&!D1&!D&!C&B&A2&!A1&!A|!E&D1&!D&!C&B&A2&!A1&!A|!E&!D1&D&!C&B&A2&!A1&!A|!E&!D1&!D&C&!B&A2&!A1&!A|!E&D1&!D&C&!B&A2&!A1&!A|!E&!D1&D&C&!B&A2&!A1&!A|!E&!D1&D&!C&!B&A2&!A1&!A|!E&D1&!D&!C&!B&A2&!A1&!A|!E&!D1&!D&!C&!B&A2&!A1&!A|!E&!D1&!D&!C&!B&A2&A1&!A|!E&D1&!D&!C&!B&A2&A1&!A|!E&!D1&D&!C&!B&A2&A1&!A|!E&!D1&D&C&!B&A2&A1&!A|!E&D1&!D&C&!B&A2&A1&!A|!E&!D1&!D&C&!B&A2&A1&!A|!E&!D1&D&!C&B&A2&A1&!A|!E&D1&!D&!C&B&A2&A1&!A|!E&!D1&!D&!C&B&A2&A1&!A|!E&!D1&!D&!C&B&!A2&A1&!A|!E&D1&!D&!C&B&!A2&A1&!A|!E&!D1&D&!C&B&!A2&A1&!A|!E&!D1&!D&C&!B&!A2&A1&!A|!E&D1&!D&C&!B&!A2&A1&!A|!E&!D1&D&C&!B&!A2&A1&!A|!E&!D1&D&!C&!B&!A2&A1&!A|!E&D1&!D&!C&!B&!A2&A1&!A|!E&!D1&!D&!C&!B&!A2&A1&!A|!E&!D1&!D&!C&!B&!A2&A1&A|!E&D1&!D&!C&!B&!A2&A1&A|!E&!D1&D&!C&!B&!A2&A1&A|!E&!D1&D&C&!B&!A2&A1&A|!E&D1&!D&C&!B&!A2&A1&A|!E&!D1&!D&C&!B&!A2&A1&A|!E&!D1&D&!C&B&!A2&A1&A|!E&D1&!D&!C&B&!A2&A1&A|!E&!D1&!D&!C&B&!A2&A1&A|!E&!D1&!D&!C&B&A2&A1&A|!E&D1&!D&!C&B&A2&A1&A|!E&!D1&D&!C&B&A2&A1&A|!E&!D1&D&!C&!B&A2&A1&A|!E&D1&!D&!C&!B&A2&A1&A|!E&!D1&!D&!C&!B&A2&A1&A|!E&!D1&!D&!C&!B&A2&!A1&A|!E&D1&!D&!C&!B&A2&!A1&A|!E&!D1&D&!C&!B&A2&!A1&A|!E&!D1&D&C&!B&A2&!A1&A|!E&D1&!D&C&!B&A2&!A1&A|!E&!D1&!D&C&!B&A2&!A1&A|!E&!D1&D&!C&B&A2&!A1&A|!E&D1&!D&!C&B&A2&!A1&A|!E&!D1&!D&!C&B&A2&!A1&A|!E&!D1&!D&!C&B&!A2&!A1&A|!E&D1&!D&!C&B&!A2&!A1&A|!E&!D1&D&!C&B&!A2&!A1&A|!E&!D1&!D&C&!B&!A2&!A1&A|!E&D1&!D&C&!B&!A2&!A1&A|!E&!D1&D&C&!B&!A2&!A1&A|!E&!D1&D&!C&!B&!A2&!A1&A|!E&D1&!D&!C&!B&!A2&!A1&A|!E&!D1&!D&!C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOI31121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAI431 -l OOAI431 -i C B2 B1 B A3 A2 A1 A -o Y -f Y=!(C&!B2&!B1&B&A3&!A2&!A1&!A|C&B2&!B1&B&A3&!A2&!A1&!A|C&B2&B1&B&A3&!A2&!A1&!A|C&!B2&B1&B&A3&!A2&!A1&!A|C&!B2&B1&!B&A3&!A2&!A1&!A|C&B2&B1&!B&A3&!A2&!A1&!A|C&B2&!B1&!B&A3&!A2&!A1&!A|C&B2&!B1&!B&A3&A2&!A1&!A|C&B2&B1&!B&A3&A2&!A1&!A|C&!B2&B1&!B&A3&A2&!A1&!A|C&!B2&B1&B&A3&A2&!A1&!A|C&B2&B1&B&A3&A2&!A1&!A|C&B2&!B1&B&A3&A2&!A1&!A|C&!B2&!B1&B&A3&A2&!A1&!A|C&!B2&!B1&B&!A3&A2&!A1&!A|C&B2&!B1&B&!A3&A2&!A1&!A|C&B2&B1&B&!A3&A2&!A1&!A|C&!B2&B1&B&!A3&A2&!A1&!A|C&!B2&B1&!B&!A3&A2&!A1&!A|C&B2&B1&!B&!A3&A2&!A1&!A|C&B2&!B1&!B&!A3&A2&!A1&!A|C&B2&!B1&!B&!A3&A2&A1&!A|C&B2&B1&!B&!A3&A2&A1&!A|C&!B2&B1&!B&!A3&A2&A1&!A|C&!B2&B1&B&!A3&A2&A1&!A|C&B2&B1&B&!A3&A2&A1&!A|C&B2&!B1&B&!A3&A2&A1&!A|C&!B2&!B1&B&!A3&A2&A1&!A|C&!B2&!B1&B&A3&A2&A1&!A|C&B2&!B1&B&A3&A2&A1&!A|C&B2&B1&B&A3&A2&A1&!A|C&!B2&B1&B&A3&A2&A1&!A|C&!B2&B1&!B&A3&A2&A1&!A|C&B2&B1&!B&A3&A2&A1&!A|C&B2&!B1&!B&A3&A2&A1&!A|C&B2&!B1&!B&A3&!A2&A1&!A|C&B2&B1&!B&A3&!A2&A1&!A|C&!B2&B1&!B&A3&!A2&A1&!A|C&!B2&B1&B&A3&!A2&A1&!A|C&B2&B1&B&A3&!A2&A1&!A|C&B2&!B1&B&A3&!A2&A1&!A|C&!B2&!B1&B&A3&!A2&A1&!A|C&!B2&!B1&B&!A3&!A2&A1&!A|C&B2&!B1&B&!A3&!A2&A1&!A|C&B2&B1&B&!A3&!A2&A1&!A|C&!B2&B1&B&!A3&!A2&A1&!A|C&!B2&B1&!B&!A3&!A2&A1&!A|C&B2&B1&!B&!A3&!A2&A1&!A|C&B2&!B1&!B&!A3&!A2&A1&!A|C&B2&!B1&!B&!A3&!A2&A1&A|C&B2&B1&!B&!A3&!A2&A1&A|C&!B2&B1&!B&!A3&!A2&A1&A|C&!B2&B1&B&!A3&!A2&A1&A|C&B2&B1&B&!A3&!A2&A1&A|C&B2&!B1&B&!A3&!A2&A1&A|C&!B2&!B1&B&!A3&!A2&A1&A|C&!B2&!B1&B&A3&!A2&A1&A|C&B2&!B1&B&A3&!A2&A1&A|C&B2&B1&B&A3&!A2&A1&A|C&!B2&B1&B&A3&!A2&A1&A|C&!B2&B1&!B&A3&!A2&A1&A|C&B2&B1&!B&A3&!A2&A1&A|C&B2&!B1&!B&A3&!A2&A1&A|C&B2&!B1&!B&A3&A2&A1&A|C&B2&B1&!B&A3&A2&A1&A|C&!B2&B1&!B&A3&A2&A1&A|C&!B2&B1&B&A3&A2&A1&A|C&B2&B1&B&A3&A2&A1&A|C&B2&!B1&B&A3&A2&A1&A|C&!B2&!B1&B&A3&A2&A1&A|C&!B2&!B1&B&!A3&A2&A1&A|C&B2&!B1&B&!A3&A2&A1&A|C&B2&B1&B&!A3&A2&A1&A|C&!B2&B1&B&!A3&A2&A1&A|C&!B2&B1&!B&!A3&A2&A1&A|C&B2&B1&!B&!A3&A2&A1&A|C&B2&!B1&!B&!A3&A2&A1&A|C&B2&!B1&!B&!A3&A2&!A1&A|C&B2&B1&!B&!A3&A2&!A1&A|C&!B2&B1&!B&!A3&A2&!A1&A|C&!B2&B1&B&!A3&A2&!A1&A|C&B2&B1&B&!A3&A2&!A1&A|C&B2&!B1&B&!A3&A2&!A1&A|C&!B2&!B1&B&!A3&A2&!A1&A|C&!B2&!B1&B&A3&A2&!A1&A|C&B2&!B1&B&A3&A2&!A1&A|C&B2&B1&B&A3&A2&!A1&A|C&!B2&B1&B&A3&A2&!A1&A|C&!B2&B1&!B&A3&A2&!A1&A|C&B2&B1&!B&A3&A2&!A1&A|C&B2&!B1&!B&A3&A2&!A1&A|C&B2&!B1&!B&A3&!A2&!A1&A|C&B2&B1&!B&A3&!A2&!A1&A|C&!B2&B1&!B&A3&!A2&!A1&A|C&!B2&B1&B&A3&!A2&!A1&A|C&B2&B1&B&A3&!A2&!A1&A|C&B2&!B1&B&A3&!A2&!A1&A|C&!B2&!B1&B&A3&!A2&!A1&A|C&!B2&!B1&B&!A3&!A2&!A1&A|C&B2&!B1&B&!A3&!A2&!A1&A|C&B2&B1&B&!A3&!A2&!A1&A|C&!B2&B1&B&!A3&!A2&!A1&A|C&!B2&B1&!B&!A3&!A2&!A1&A|C&B2&B1&!B&!A3&!A2&!A1&A|C&B2&!B1&!B&!A3&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAI431.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOOAI2222 -l OOOOAI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=!(!D1&D&C1&!C&!B1&B&A1&!A|D1&D&C1&!C&!B1&B&A1&!A|D1&!D&C1&!C&!B1&B&A1&!A|D1&!D&C1&C&!B1&B&A1&!A|D1&D&C1&C&!B1&B&A1&!A|!D1&D&C1&C&!B1&B&A1&!A|!D1&D&!C1&C&!B1&B&A1&!A|D1&D&!C1&C&!B1&B&A1&!A|D1&!D&!C1&C&!B1&B&A1&!A|D1&!D&!C1&C&B1&B&A1&!A|D1&D&!C1&C&B1&B&A1&!A|!D1&D&!C1&C&B1&B&A1&!A|!D1&D&C1&C&B1&B&A1&!A|D1&D&C1&C&B1&B&A1&!A|D1&!D&C1&C&B1&B&A1&!A|D1&!D&C1&!C&B1&B&A1&!A|D1&D&C1&!C&B1&B&A1&!A|!D1&D&C1&!C&B1&B&A1&!A|!D1&D&C1&!C&B1&!B&A1&!A|D1&D&C1&!C&B1&!B&A1&!A|D1&!D&C1&!C&B1&!B&A1&!A|D1&!D&C1&C&B1&!B&A1&!A|D1&D&C1&C&B1&!B&A1&!A|!D1&D&C1&C&B1&!B&A1&!A|!D1&D&!C1&C&B1&!B&A1&!A|D1&D&!C1&C&B1&!B&A1&!A|D1&!D&!C1&C&B1&!B&A1&!A|D1&!D&!C1&C&B1&!B&A1&A|D1&D&!C1&C&B1&!B&A1&A|!D1&D&!C1&C&B1&!B&A1&A|!D1&D&C1&C&B1&!B&A1&A|D1&D&C1&C&B1&!B&A1&A|D1&!D&C1&C&B1&!B&A1&A|D1&!D&C1&!C&B1&!B&A1&A|D1&D&C1&!C&B1&!B&A1&A|!D1&D&C1&!C&B1&!B&A1&A|!D1&D&C1&!C&B1&B&A1&A|D1&D&C1&!C&B1&B&A1&A|D1&!D&C1&!C&B1&B&A1&A|D1&!D&C1&C&B1&B&A1&A|D1&D&C1&C&B1&B&A1&A|!D1&D&C1&C&B1&B&A1&A|!D1&D&!C1&C&B1&B&A1&A|D1&D&!C1&C&B1&B&A1&A|D1&!D&!C1&C&B1&B&A1&A|D1&!D&!C1&C&!B1&B&A1&A|D1&D&!C1&C&!B1&B&A1&A|!D1&D&!C1&C&!B1&B&A1&A|!D1&D&C1&C&!B1&B&A1&A|D1&D&C1&C&!B1&B&A1&A|D1&!D&C1&C&!B1&B&A1&A|D1&!D&C1&!C&!B1&B&A1&A|D1&D&C1&!C&!B1&B&A1&A|!D1&D&C1&!C&!B1&B&A1&A|!D1&D&C1&!C&!B1&B&!A1&A|D1&D&C1&!C&!B1&B&!A1&A|D1&!D&C1&!C&!B1&B&!A1&A|D1&!D&C1&C&!B1&B&!A1&A|D1&D&C1&C&!B1&B&!A1&A|!D1&D&C1&C&!B1&B&!A1&A|!D1&D&!C1&C&!B1&B&!A1&A|D1&D&!C1&C&!B1&B&!A1&A|D1&!D&!C1&C&!B1&B&!A1&A|D1&!D&!C1&C&B1&B&!A1&A|D1&D&!C1&C&B1&B&!A1&A|!D1&D&!C1&C&B1&B&!A1&A|!D1&D&C1&C&B1&B&!A1&A|D1&D&C1&C&B1&B&!A1&A|D1&!D&C1&C&B1&B&!A1&A|D1&!D&C1&!C&B1&B&!A1&A|D1&D&C1&!C&B1&B&!A1&A|!D1&D&C1&!C&B1&B&!A1&A|!D1&D&C1&!C&B1&!B&!A1&A|D1&D&C1&!C&B1&!B&!A1&A|D1&!D&C1&!C&B1&!B&!A1&A|D1&!D&C1&C&B1&!B&!A1&A|D1&D&C1&C&B1&!B&!A1&A|!D1&D&C1&C&B1&!B&!A1&A|!D1&D&!C1&C&B1&!B&!A1&A|D1&D&!C1&C&B1&!B&!A1&A|D1&!D&!C1&C&B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOOAI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOI332 -l OOAAOI332 -i C1 C B2 B1 B A2 A1 A -o Y -f Y=(!C1&!C&!B2&!B1&!B&!A2&!A1&!A|C1&!C&!B2&!B1&!B&!A2&!A1&!A|!C1&C&!B2&!B1&!B&!A2&!A1&!A|!C1&C&B2&!B1&!B&!A2&!A1&!A|C1&!C&B2&!B1&!B&!A2&!A1&!A|!C1&!C&B2&!B1&!B&!A2&!A1&!A|!C1&!C&B2&B1&!B&!A2&!A1&!A|C1&!C&B2&B1&!B&!A2&!A1&!A|!C1&C&B2&B1&!B&!A2&!A1&!A|!C1&C&!B2&B1&!B&!A2&!A1&!A|C1&!C&!B2&B1&!B&!A2&!A1&!A|!C1&!C&!B2&B1&!B&!A2&!A1&!A|!C1&!C&!B2&B1&B&!A2&!A1&!A|C1&!C&!B2&B1&B&!A2&!A1&!A|!C1&C&!B2&B1&B&!A2&!A1&!A|!C1&C&B2&B1&B&!A2&!A1&!A|C1&!C&B2&B1&B&!A2&!A1&!A|!C1&!C&B2&B1&B&!A2&!A1&!A|!C1&!C&B2&!B1&B&!A2&!A1&!A|C1&!C&B2&!B1&B&!A2&!A1&!A|!C1&C&B2&!B1&B&!A2&!A1&!A|!C1&C&!B2&!B1&B&!A2&!A1&!A|C1&!C&!B2&!B1&B&!A2&!A1&!A|!C1&!C&!B2&!B1&B&!A2&!A1&!A|!C1&C&!B2&!B1&!B&A2&!A1&!A|C1&!C&!B2&!B1&!B&A2&!A1&!A|!C1&!C&!B2&!B1&!B&A2&!A1&!A|!C1&!C&!B2&!B1&!B&A2&A1&!A|C1&!C&!B2&!B1&!B&A2&A1&!A|!C1&C&!B2&!B1&!B&A2&A1&!A|!C1&C&!B2&!B1&!B&!A2&A1&!A|C1&!C&!B2&!B1&!B&!A2&A1&!A|!C1&!C&!B2&!B1&!B&!A2&A1&!A|!C1&!C&!B2&!B1&!B&!A2&A1&A|C1&!C&!B2&!B1&!B&!A2&A1&A|!C1&C&!B2&!B1&!B&!A2&A1&A|!C1&C&!B2&!B1&!B&A2&A1&A|C1&!C&!B2&!B1&!B&A2&A1&A|!C1&!C&!B2&!B1&!B&A2&A1&A|!C1&!C&!B2&!B1&!B&A2&!A1&A|C1&!C&!B2&!B1&!B&A2&!A1&A|!C1&C&!B2&!B1&!B&A2&!A1&A|!C1&C&!B2&!B1&!B&!A2&!A1&A|C1&!C&!B2&!B1&!B&!A2&!A1&A|!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOI332.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOOAI2224 -l OOAAOOAI2224 -i D3 D2 D1 D C1 C B1 B A1 A -o Y -f Y=(!D3&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|D3&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|D3&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!D3&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!D3&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|D3&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|D3&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!D3&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!D3&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|D3&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|D3&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!D3&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!D3&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|D3&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|D3&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!D3&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!D3&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|D3&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|D3&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!D3&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!D3&D2&D1&D&C1&!C&!B1&!B&!A1&!A|D3&D2&D1&D&C1&!C&!B1&!B&!A1&!A|D3&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!D3&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!D3&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|D3&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|D3&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!D3&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!D3&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|D3&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|D3&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!D3&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!D3&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!D3&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|D3&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|D3&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!D3&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!D3&D2&D1&D&!C1&C&!B1&!B&!A1&!A|D3&D2&D1&D&!C1&C&!B1&!B&!A1&!A|D3&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!D3&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!D3&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|D3&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|D3&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!D3&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!D3&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|D3&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|D3&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!D3&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!D3&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|D3&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|D3&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!D3&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!D3&D2&D1&!D&!C1&C&B1&!B&!A1&!A|D3&D2&D1&!D&!C1&C&B1&!B&!A1&!A|D3&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!D3&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!D3&!D2&D1&D&!C1&C&B1&!B&!A1&!A|D3&!D2&D1&D&!C1&C&B1&!B&!A1&!A|D3&D2&D1&D&!C1&C&B1&!B&!A1&!A|!D3&D2&D1&D&!C1&C&B1&!B&!A1&!A|!D3&D2&!D1&D&!C1&C&B1&!B&!A1&!A|D3&D2&!D1&D&!C1&C&B1&!B&!A1&!A|D3&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!D3&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!D3&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!D3&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|D3&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|D3&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!D3&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!D3&D2&D1&!D&C1&!C&B1&!B&!A1&!A|D3&D2&D1&!D&C1&!C&B1&!B&!A1&!A|D3&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!D3&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!D3&!D2&D1&D&C1&!C&B1&!B&!A1&!A|D3&!D2&D1&D&C1&!C&B1&!B&!A1&!A|D3&D2&D1&D&C1&!C&B1&!B&!A1&!A|!D3&D2&D1&D&C1&!C&B1&!B&!A1&!A|!D3&D2&!D1&D&C1&!C&B1&!B&!A1&!A|D3&D2&!D1&D&C1&!C&B1&!B&!A1&!A|D3&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!D3&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!D3&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|D3&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|D3&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!D3&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!D3&D2&D1&D&!C1&!C&B1&!B&!A1&!A|D3&D2&D1&D&!C1&!C&B1&!B&!A1&!A|D3&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!D3&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!D3&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|D3&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|D3&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!D3&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!D3&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|D3&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|D3&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!D3&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!D3&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|D3&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|D3&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!D3&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!D3&D2&D1&!D&!C1&!C&B1&B&!A1&!A|D3&D2&D1&!D&!C1&!C&B1&B&!A1&!A|D3&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!D3&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!D3&!D2&D1&D&!C1&!C&B1&B&!A1&!A|D3&!D2&D1&D&!C1&!C&B1&B&!A1&!A|D3&D2&D1&D&!C1&!C&B1&B&!A1&!A|!D3&D2&D1&D&!C1&!C&B1&B&!A1&!A|!D3&D2&!D1&D&!C1&!C&B1&B&!A1&!A|D3&D2&!D1&D&!C1&!C&B1&B&!A1&!A|D3&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!D3&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!D3&!D2&!D1&D&C1&!C&B1&B&!A1&!A|D3&!D2&!D1&D&C1&!C&B1&B&!A1&!A|D3&D2&!D1&D&C1&!C&B1&B&!A1&!A|!D3&D2&!D1&D&C1&!C&B1&B&!A1&!A|!D3&D2&D1&D&C1&!C&B1&B&!A1&!A|D3&D2&D1&D&C1&!C&B1&B&!A1&!A|D3&!D2&D1&D&C1&!C&B1&B&!A1&!A|!D3&!D2&D1&D&C1&!C&B1&B&!A1&!A|!D3&!D2&D1&!D&C1&!C&B1&B&!A1&!A|D3&!D2&D1&!D&C1&!C&B1&B&!A1&!A|D3&D2&D1&!D&C1&!C&B1&B&!A1&!A|!D3&D2&D1&!D&C1&!C&B1&B&!A1&!A|!D3&D2&!D1&!D&C1&!C&B1&B&!A1&!A|D3&D2&!D1&!D&C1&!C&B1&B&!A1&!A|D3&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!D3&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!D3&!D2&!D1&!D&C1&C&B1&B&!A1&!A|!D3&!D2&!D1&D&!C1&C&B1&B&!A1&!A|D3&!D2&!D1&D&!C1&C&B1&B&!A1&!A|D3&D2&!D1&D&!C1&C&B1&B&!A1&!A|!D3&D2&!D1&D&!C1&C&B1&B&!A1&!A|!D3&D2&D1&D&!C1&C&B1&B&!A1&!A|D3&D2&D1&D&!C1&C&B1&B&!A1&!A|D3&!D2&D1&D&!C1&C&B1&B&!A1&!A|!D3&!D2&D1&D&!C1&C&B1&B&!A1&!A|!D3&!D2&D1&!D&!C1&C&B1&B&!A1&!A|D3&!D2&D1&!D&!C1&C&B1&B&!A1&!A|D3&D2&D1&!D&!C1&C&B1&B&!A1&!A|!D3&D2&D1&!D&!C1&C&B1&B&!A1&!A|!D3&D2&!D1&!D&!C1&C&B1&B&!A1&!A|D3&D2&!D1&!D&!C1&C&B1&B&!A1&!A|D3&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!D3&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!D3&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|D3&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|D3&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!D3&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!D3&D2&D1&!D&!C1&C&!B1&B&!A1&!A|D3&D2&D1&!D&!C1&C&!B1&B&!A1&!A|D3&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!D3&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!D3&!D2&D1&D&!C1&C&!B1&B&!A1&!A|D3&!D2&D1&D&!C1&C&!B1&B&!A1&!A|D3&D2&D1&D&!C1&C&!B1&B&!A1&!A|!D3&D2&D1&D&!C1&C&!B1&B&!A1&!A|!D3&D2&!D1&D&!C1&C&!B1&B&!A1&!A|D3&D2&!D1&D&!C1&C&!B1&B&!A1&!A|D3&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!D3&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!D3&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!D3&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|D3&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|D3&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!D3&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!D3&D2&D1&!D&C1&!C&!B1&B&!A1&!A|D3&D2&D1&!D&C1&!C&!B1&B&!A1&!A|D3&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!D3&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!D3&!D2&D1&D&C1&!C&!B1&B&!A1&!A|D3&!D2&D1&D&C1&!C&!B1&B&!A1&!A|D3&D2&D1&D&C1&!C&!B1&B&!A1&!A|!D3&D2&D1&D&C1&!C&!B1&B&!A1&!A|!D3&D2&!D1&D&C1&!C&!B1&B&!A1&!A|D3&D2&!D1&D&C1&!C&!B1&B&!A1&!A|D3&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!D3&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!D3&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|D3&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|D3&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!D3&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!D3&D2&D1&D&!C1&!C&!B1&B&!A1&!A|D3&D2&D1&D&!C1&!C&!B1&B&!A1&!A|D3&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!D3&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!D3&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|D3&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|D3&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!D3&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!D3&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|D3&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|D3&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!D3&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!D3&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!D3&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!D3&!D2&!D1&!D&C1&C&!B1&B&A1&!A|!D3&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!D3&!D2&!D1&!D&!C1&C&B1&B&A1&!A|!D3&!D2&!D1&!D&C1&C&B1&B&A1&!A|!D3&!D2&!D1&!D&C1&!C&B1&B&A1&!A|!D3&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!D3&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!D3&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!D3&!D2&!D1&!D&C1&C&B1&!B&A1&!A|!D3&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!D3&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|D3&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|D3&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!D3&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!D3&D2&D1&!D&!C1&C&!B1&!B&A1&!A|D3&D2&D1&!D&!C1&C&!B1&!B&A1&!A|D3&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!D3&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!D3&!D2&D1&D&!C1&C&!B1&!B&A1&!A|D3&!D2&D1&D&!C1&C&!B1&!B&A1&!A|D3&D2&D1&D&!C1&C&!B1&!B&A1&!A|!D3&D2&D1&D&!C1&C&!B1&!B&A1&!A|!D3&D2&!D1&D&!C1&C&!B1&!B&A1&!A|D3&D2&!D1&D&!C1&C&!B1&!B&A1&!A|D3&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!D3&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!D3&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!D3&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|D3&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|D3&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!D3&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!D3&D2&D1&!D&C1&!C&!B1&!B&A1&!A|D3&D2&D1&!D&C1&!C&!B1&!B&A1&!A|D3&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!D3&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!D3&!D2&D1&D&C1&!C&!B1&!B&A1&!A|D3&!D2&D1&D&C1&!C&!B1&!B&A1&!A|D3&D2&D1&D&C1&!C&!B1&!B&A1&!A|!D3&D2&D1&D&C1&!C&!B1&!B&A1&!A|!D3&D2&!D1&D&C1&!C&!B1&!B&A1&!A|D3&D2&!D1&D&C1&!C&!B1&!B&A1&!A|D3&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!D3&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!D3&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|D3&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|D3&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!D3&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!D3&D2&D1&D&!C1&!C&!B1&!B&A1&!A|D3&D2&D1&D&!C1&!C&!B1&!B&A1&!A|D3&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!D3&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!D3&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|D3&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|D3&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!D3&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!D3&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|D3&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|D3&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!D3&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!D3&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|D3&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|D3&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!D3&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!D3&D2&D1&!D&!C1&!C&!B1&!B&A1&A|D3&D2&D1&!D&!C1&!C&!B1&!B&A1&A|D3&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!D3&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!D3&!D2&D1&D&!C1&!C&!B1&!B&A1&A|D3&!D2&D1&D&!C1&!C&!B1&!B&A1&A|D3&D2&D1&D&!C1&!C&!B1&!B&A1&A|!D3&D2&D1&D&!C1&!C&!B1&!B&A1&A|!D3&D2&!D1&D&!C1&!C&!B1&!B&A1&A|D3&D2&!D1&D&!C1&!C&!B1&!B&A1&A|D3&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!D3&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!D3&!D2&!D1&D&C1&!C&!B1&!B&A1&A|D3&!D2&!D1&D&C1&!C&!B1&!B&A1&A|D3&D2&!D1&D&C1&!C&!B1&!B&A1&A|!D3&D2&!D1&D&C1&!C&!B1&!B&A1&A|!D3&D2&D1&D&C1&!C&!B1&!B&A1&A|D3&D2&D1&D&C1&!C&!B1&!B&A1&A|D3&!D2&D1&D&C1&!C&!B1&!B&A1&A|!D3&!D2&D1&D&C1&!C&!B1&!B&A1&A|!D3&!D2&D1&!D&C1&!C&!B1&!B&A1&A|D3&!D2&D1&!D&C1&!C&!B1&!B&A1&A|D3&D2&D1&!D&C1&!C&!B1&!B&A1&A|!D3&D2&D1&!D&C1&!C&!B1&!B&A1&A|!D3&D2&!D1&!D&C1&!C&!B1&!B&A1&A|D3&D2&!D1&!D&C1&!C&!B1&!B&A1&A|D3&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!D3&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!D3&!D2&!D1&!D&C1&C&!B1&!B&A1&A|!D3&!D2&!D1&D&!C1&C&!B1&!B&A1&A|D3&!D2&!D1&D&!C1&C&!B1&!B&A1&A|D3&D2&!D1&D&!C1&C&!B1&!B&A1&A|!D3&D2&!D1&D&!C1&C&!B1&!B&A1&A|!D3&D2&D1&D&!C1&C&!B1&!B&A1&A|D3&D2&D1&D&!C1&C&!B1&!B&A1&A|D3&!D2&D1&D&!C1&C&!B1&!B&A1&A|!D3&!D2&D1&D&!C1&C&!B1&!B&A1&A|!D3&!D2&D1&!D&!C1&C&!B1&!B&A1&A|D3&!D2&D1&!D&!C1&C&!B1&!B&A1&A|D3&D2&D1&!D&!C1&C&!B1&!B&A1&A|!D3&D2&D1&!D&!C1&C&!B1&!B&A1&A|!D3&D2&!D1&!D&!C1&C&!B1&!B&A1&A|D3&D2&!D1&!D&!C1&C&!B1&!B&A1&A|D3&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!D3&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!D3&!D2&!D1&!D&!C1&C&B1&!B&A1&A|!D3&!D2&!D1&!D&C1&C&B1&!B&A1&A|!D3&!D2&!D1&!D&C1&!C&B1&!B&A1&A|!D3&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!D3&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!D3&!D2&!D1&!D&C1&!C&B1&B&A1&A|!D3&!D2&!D1&!D&C1&C&B1&B&A1&A|!D3&!D2&!D1&!D&!C1&C&B1&B&A1&A|!D3&!D2&!D1&!D&!C1&C&!B1&B&A1&A|!D3&!D2&!D1&!D&C1&C&!B1&B&A1&A|!D3&!D2&!D1&!D&C1&!C&!B1&B&A1&A|!D3&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!D3&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!D3&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!D3&!D2&!D1&!D&C1&C&!B1&B&!A1&A|!D3&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!D3&!D2&!D1&!D&!C1&C&B1&B&!A1&A|!D3&!D2&!D1&!D&C1&C&B1&B&!A1&A|!D3&!D2&!D1&!D&C1&!C&B1&B&!A1&A|!D3&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!D3&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!D3&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!D3&!D2&!D1&!D&C1&C&B1&!B&!A1&A|!D3&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!D3&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|D3&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|D3&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!D3&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!D3&D2&D1&!D&!C1&C&!B1&!B&!A1&A|D3&D2&D1&!D&!C1&C&!B1&!B&!A1&A|D3&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!D3&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!D3&!D2&D1&D&!C1&C&!B1&!B&!A1&A|D3&!D2&D1&D&!C1&C&!B1&!B&!A1&A|D3&D2&D1&D&!C1&C&!B1&!B&!A1&A|!D3&D2&D1&D&!C1&C&!B1&!B&!A1&A|!D3&D2&!D1&D&!C1&C&!B1&!B&!A1&A|D3&D2&!D1&D&!C1&C&!B1&!B&!A1&A|D3&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!D3&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!D3&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!D3&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|D3&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|D3&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!D3&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!D3&D2&D1&!D&C1&!C&!B1&!B&!A1&A|D3&D2&D1&!D&C1&!C&!B1&!B&!A1&A|D3&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!D3&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!D3&!D2&D1&D&C1&!C&!B1&!B&!A1&A|D3&!D2&D1&D&C1&!C&!B1&!B&!A1&A|D3&D2&D1&D&C1&!C&!B1&!B&!A1&A|!D3&D2&D1&D&C1&!C&!B1&!B&!A1&A|!D3&D2&!D1&D&C1&!C&!B1&!B&!A1&A|D3&D2&!D1&D&C1&!C&!B1&!B&!A1&A|D3&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!D3&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!D3&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|D3&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|D3&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!D3&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!D3&D2&D1&D&!C1&!C&!B1&!B&!A1&A|D3&D2&D1&D&!C1&!C&!B1&!B&!A1&A|D3&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!D3&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!D3&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|D3&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|D3&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!D3&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!D3&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|D3&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|D3&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!D3&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOOAI2224.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOAI3122 -l OAAOOAI3122 -i D1 D C1 C B A2 A1 A -o Y -f Y=!(D1&!D&C1&C&!B&!A2&!A1&!A|D1&D&C1&C&!B&!A2&!A1&!A|!D1&D&C1&C&!B&!A2&!A1&!A|!D1&D&C1&C&B&!A2&!A1&!A|D1&D&C1&C&B&!A2&!A1&!A|D1&!D&C1&C&B&!A2&!A1&!A|D1&!D&!C1&!C&B&A2&!A1&!A|D1&D&!C1&!C&B&A2&!A1&!A|!D1&D&!C1&!C&B&A2&!A1&!A|!D1&D&C1&!C&B&A2&!A1&!A|D1&D&C1&!C&B&A2&!A1&!A|D1&!D&C1&!C&B&A2&!A1&!A|D1&!D&C1&C&B&A2&!A1&!A|D1&D&C1&C&B&A2&!A1&!A|!D1&D&C1&C&B&A2&!A1&!A|!D1&D&!C1&C&B&A2&!A1&!A|D1&D&!C1&C&B&A2&!A1&!A|D1&!D&!C1&C&B&A2&!A1&!A|!D1&D&C1&C&!B&A2&!A1&!A|D1&D&C1&C&!B&A2&!A1&!A|D1&!D&C1&C&!B&A2&!A1&!A|D1&!D&C1&C&!B&A2&A1&!A|D1&D&C1&C&!B&A2&A1&!A|!D1&D&C1&C&!B&A2&A1&!A|D1&!D&!C1&C&B&A2&A1&!A|D1&D&!C1&C&B&A2&A1&!A|!D1&D&!C1&C&B&A2&A1&!A|!D1&D&C1&C&B&A2&A1&!A|D1&D&C1&C&B&A2&A1&!A|D1&!D&C1&C&B&A2&A1&!A|D1&!D&C1&!C&B&A2&A1&!A|D1&D&C1&!C&B&A2&A1&!A|!D1&D&C1&!C&B&A2&A1&!A|!D1&D&!C1&!C&B&A2&A1&!A|D1&D&!C1&!C&B&A2&A1&!A|D1&!D&!C1&!C&B&A2&A1&!A|D1&!D&!C1&!C&B&!A2&A1&!A|D1&D&!C1&!C&B&!A2&A1&!A|!D1&D&!C1&!C&B&!A2&A1&!A|!D1&D&C1&!C&B&!A2&A1&!A|D1&D&C1&!C&B&!A2&A1&!A|D1&!D&C1&!C&B&!A2&A1&!A|D1&!D&C1&C&B&!A2&A1&!A|D1&D&C1&C&B&!A2&A1&!A|!D1&D&C1&C&B&!A2&A1&!A|!D1&D&!C1&C&B&!A2&A1&!A|D1&D&!C1&C&B&!A2&A1&!A|D1&!D&!C1&C&B&!A2&A1&!A|!D1&D&C1&C&!B&!A2&A1&!A|D1&D&C1&C&!B&!A2&A1&!A|D1&!D&C1&C&!B&!A2&A1&!A|D1&!D&C1&C&!B&!A2&A1&A|D1&D&C1&C&!B&!A2&A1&A|!D1&D&C1&C&!B&!A2&A1&A|D1&!D&!C1&C&B&!A2&A1&A|D1&D&!C1&C&B&!A2&A1&A|!D1&D&!C1&C&B&!A2&A1&A|!D1&D&C1&C&B&!A2&A1&A|D1&D&C1&C&B&!A2&A1&A|D1&!D&C1&C&B&!A2&A1&A|D1&!D&C1&!C&B&!A2&A1&A|D1&D&C1&!C&B&!A2&A1&A|!D1&D&C1&!C&B&!A2&A1&A|!D1&D&!C1&!C&B&!A2&A1&A|D1&D&!C1&!C&B&!A2&A1&A|D1&!D&!C1&!C&B&!A2&A1&A|D1&!D&!C1&!C&B&A2&A1&A|D1&D&!C1&!C&B&A2&A1&A|!D1&D&!C1&!C&B&A2&A1&A|!D1&D&C1&!C&B&A2&A1&A|D1&D&C1&!C&B&A2&A1&A|D1&!D&C1&!C&B&A2&A1&A|D1&!D&C1&C&B&A2&A1&A|D1&D&C1&C&B&A2&A1&A|!D1&D&C1&C&B&A2&A1&A|!D1&D&!C1&C&B&A2&A1&A|D1&D&!C1&C&B&A2&A1&A|D1&!D&!C1&C&B&A2&A1&A|!D1&D&C1&C&!B&A2&A1&A|D1&D&C1&C&!B&A2&A1&A|D1&!D&C1&C&!B&A2&A1&A|D1&!D&C1&C&!B&A2&!A1&A|D1&D&C1&C&!B&A2&!A1&A|!D1&D&C1&C&!B&A2&!A1&A|D1&!D&!C1&C&B&A2&!A1&A|D1&D&!C1&C&B&A2&!A1&A|!D1&D&!C1&C&B&A2&!A1&A|!D1&D&C1&C&B&A2&!A1&A|D1&D&C1&C&B&A2&!A1&A|D1&!D&C1&C&B&A2&!A1&A|D1&!D&C1&!C&B&A2&!A1&A|D1&D&C1&!C&B&A2&!A1&A|!D1&D&C1&!C&B&A2&!A1&A|!D1&D&!C1&!C&B&A2&!A1&A|D1&D&!C1&!C&B&A2&!A1&A|D1&!D&!C1&!C&B&A2&!A1&A|D1&!D&!C1&!C&B&!A2&!A1&A|D1&D&!C1&!C&B&!A2&!A1&A|!D1&D&!C1&!C&B&!A2&!A1&A|!D1&D&C1&!C&B&!A2&!A1&A|D1&D&C1&!C&B&!A2&!A1&A|D1&!D&C1&!C&B&!A2&!A1&A|D1&!D&C1&C&B&!A2&!A1&A|D1&D&C1&C&B&!A2&!A1&A|!D1&D&C1&C&B&!A2&!A1&A|!D1&D&!C1&C&B&!A2&!A1&A|D1&D&!C1&C&B&!A2&!A1&A|D1&!D&!C1&C&B&!A2&!A1&A|!D1&D&C1&C&!B&!A2&!A1&A|D1&D&C1&C&!B&!A2&!A1&A|D1&!D&C1&C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOAI3122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOAI21311 -l AOOAOAI21311 -i E D C2 C1 C B A1 A -o Y -f Y=!(E&D&!C2&!C1&!C&!B&!A1&!A|E&D&C2&!C1&!C&!B&!A1&!A|E&D&C2&C1&!C&!B&!A1&!A|E&D&!C2&C1&!C&!B&!A1&!A|E&D&!C2&C1&C&!B&!A1&!A|E&D&C2&C1&C&!B&!A1&!A|E&D&C2&!C1&C&!B&!A1&!A|E&D&!C2&!C1&C&!B&!A1&!A|E&!D&!C2&!C1&C&B&!A1&!A|E&D&!C2&!C1&C&B&!A1&!A|E&D&C2&!C1&C&B&!A1&!A|E&!D&C2&!C1&C&B&!A1&!A|E&!D&C2&C1&C&B&!A1&!A|E&D&C2&C1&C&B&!A1&!A|E&D&!C2&C1&C&B&!A1&!A|E&!D&!C2&C1&C&B&!A1&!A|E&!D&!C2&C1&!C&B&!A1&!A|E&D&!C2&C1&!C&B&!A1&!A|E&D&C2&C1&!C&B&!A1&!A|E&!D&C2&C1&!C&B&!A1&!A|E&!D&C2&!C1&!C&B&!A1&!A|E&D&C2&!C1&!C&B&!A1&!A|E&D&!C2&!C1&!C&B&!A1&!A|E&D&!C2&!C1&!C&B&A1&!A|E&D&C2&!C1&!C&B&A1&!A|E&!D&C2&!C1&!C&B&A1&!A|E&!D&C2&C1&!C&B&A1&!A|E&D&C2&C1&!C&B&A1&!A|E&D&!C2&C1&!C&B&A1&!A|E&!D&!C2&C1&!C&B&A1&!A|E&!D&!C2&C1&C&B&A1&!A|E&D&!C2&C1&C&B&A1&!A|E&D&C2&C1&C&B&A1&!A|E&!D&C2&C1&C&B&A1&!A|E&!D&C2&!C1&C&B&A1&!A|E&D&C2&!C1&C&B&A1&!A|E&D&!C2&!C1&C&B&A1&!A|E&!D&!C2&!C1&C&B&A1&!A|E&D&!C2&!C1&C&!B&A1&!A|E&D&C2&!C1&C&!B&A1&!A|E&D&C2&C1&C&!B&A1&!A|E&D&!C2&C1&C&!B&A1&!A|E&D&!C2&C1&!C&!B&A1&!A|E&D&C2&C1&!C&!B&A1&!A|E&D&C2&!C1&!C&!B&A1&!A|E&D&!C2&!C1&!C&!B&A1&!A|E&D&!C2&!C1&!C&!B&A1&A|E&D&C2&!C1&!C&!B&A1&A|E&!D&C2&!C1&!C&!B&A1&A|E&!D&C2&C1&!C&!B&A1&A|E&D&C2&C1&!C&!B&A1&A|E&D&!C2&C1&!C&!B&A1&A|E&!D&!C2&C1&!C&!B&A1&A|E&!D&!C2&C1&C&!B&A1&A|E&D&!C2&C1&C&!B&A1&A|E&D&C2&C1&C&!B&A1&A|E&!D&C2&C1&C&!B&A1&A|E&!D&C2&!C1&C&!B&A1&A|E&D&C2&!C1&C&!B&A1&A|E&D&!C2&!C1&C&!B&A1&A|E&!D&!C2&!C1&C&!B&A1&A|E&!D&!C2&!C1&C&B&A1&A|E&D&!C2&!C1&C&B&A1&A|E&D&C2&!C1&C&B&A1&A|E&!D&C2&!C1&C&B&A1&A|E&!D&C2&C1&C&B&A1&A|E&D&C2&C1&C&B&A1&A|E&D&!C2&C1&C&B&A1&A|E&!D&!C2&C1&C&B&A1&A|E&!D&!C2&C1&!C&B&A1&A|E&D&!C2&C1&!C&B&A1&A|E&D&C2&C1&!C&B&A1&A|E&!D&C2&C1&!C&B&A1&A|E&!D&C2&!C1&!C&B&A1&A|E&D&C2&!C1&!C&B&A1&A|E&D&!C2&!C1&!C&B&A1&A|E&D&!C2&!C1&!C&B&!A1&A|E&D&C2&!C1&!C&B&!A1&A|E&!D&C2&!C1&!C&B&!A1&A|E&!D&C2&C1&!C&B&!A1&A|E&D&C2&C1&!C&B&!A1&A|E&D&!C2&C1&!C&B&!A1&A|E&!D&!C2&C1&!C&B&!A1&A|E&!D&!C2&C1&C&B&!A1&A|E&D&!C2&C1&C&B&!A1&A|E&D&C2&C1&C&B&!A1&A|E&!D&C2&C1&C&B&!A1&A|E&!D&C2&!C1&C&B&!A1&A|E&D&C2&!C1&C&B&!A1&A|E&D&!C2&!C1&C&B&!A1&A|E&!D&!C2&!C1&C&B&!A1&A|E&D&!C2&!C1&C&!B&!A1&A|E&D&C2&!C1&C&!B&!A1&A|E&D&C2&C1&C&!B&!A1&A|E&D&!C2&C1&C&!B&!A1&A|E&D&!C2&C1&!C&!B&!A1&A|E&D&C2&C1&!C&!B&!A1&A|E&D&C2&!C1&!C&!B&!A1&A|E&D&!C2&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOAI21311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOI33 -l AAOI33 -i B2 B1 B A2 A1 A -o Y -f Y=!(B2&B1&B&!A2&!A1&!A|B2&B1&B&A2&!A1&!A|B2&B1&B&A2&A1&!A|B2&B1&B&!A2&A1&!A|B2&B1&B&!A2&A1&A|!B2&!B1&B&A2&A1&A|B2&!B1&B&A2&A1&A|B2&B1&B&A2&A1&A|!B2&B1&B&A2&A1&A|!B2&B1&!B&A2&A1&A|B2&B1&!B&A2&A1&A|B2&!B1&!B&A2&A1&A|!B2&!B1&!B&A2&A1&A|B2&B1&B&A2&!A1&A|B2&B1&B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOI33.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAI2112 -l OAOOAI2112 -i D1 D C B A1 A -o Y -f Y=(!D1&!D&!C&!B&!A1&!A|D1&!D&!C&!B&!A1&!A|D1&D&!C&!B&!A1&!A|!D1&D&!C&!B&!A1&!A|!D1&!D&C&!B&!A1&!A|!D1&!D&C&B&!A1&!A|!D1&D&!C&B&!A1&!A|D1&D&!C&B&!A1&!A|D1&!D&!C&B&!A1&!A|!D1&!D&!C&B&!A1&!A|!D1&!D&!C&B&A1&!A|!D1&!D&C&B&A1&!A|!D1&!D&C&!B&A1&!A|!D1&D&!C&!B&A1&!A|D1&D&!C&!B&A1&!A|D1&!D&!C&!B&A1&!A|!D1&!D&!C&!B&A1&!A|!D1&!D&!C&!B&A1&A|D1&!D&!C&!B&A1&A|D1&D&!C&!B&A1&A|!D1&D&!C&!B&A1&A|!D1&!D&C&!B&A1&A|!D1&!D&C&B&A1&A|!D1&!D&!C&B&A1&A|!D1&!D&!C&B&!A1&A|!D1&!D&C&B&!A1&A|!D1&!D&C&!B&!A1&A|!D1&D&!C&!B&!A1&A|D1&D&!C&!B&!A1&A|D1&!D&!C&!B&!A1&A|!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAI2112.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOAI2222 -l OAAOOAI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=!(D1&!D&C1&C&!B1&!B&!A1&!A|D1&D&C1&C&!B1&!B&!A1&!A|!D1&D&C1&C&!B1&!B&!A1&!A|!D1&D&C1&C&B1&!B&!A1&!A|D1&D&C1&C&B1&!B&!A1&!A|D1&!D&C1&C&B1&!B&!A1&!A|D1&!D&C1&C&B1&B&!A1&!A|D1&D&C1&C&B1&B&!A1&!A|!D1&D&C1&C&B1&B&!A1&!A|!D1&D&C1&C&!B1&B&!A1&!A|D1&D&C1&C&!B1&B&!A1&!A|D1&!D&C1&C&!B1&B&!A1&!A|D1&!D&C1&C&!B1&B&A1&!A|D1&D&C1&C&!B1&B&A1&!A|!D1&D&C1&C&!B1&B&A1&!A|D1&!D&!C1&C&B1&B&A1&!A|D1&D&!C1&C&B1&B&A1&!A|!D1&D&!C1&C&B1&B&A1&!A|!D1&D&C1&C&B1&B&A1&!A|D1&D&C1&C&B1&B&A1&!A|D1&!D&C1&C&B1&B&A1&!A|D1&!D&C1&!C&B1&B&A1&!A|D1&D&C1&!C&B1&B&A1&!A|!D1&D&C1&!C&B1&B&A1&!A|!D1&D&!C1&!C&B1&B&A1&!A|D1&D&!C1&!C&B1&B&A1&!A|D1&!D&!C1&!C&B1&B&A1&!A|D1&!D&C1&C&B1&!B&A1&!A|D1&D&C1&C&B1&!B&A1&!A|!D1&D&C1&C&B1&!B&A1&!A|!D1&D&C1&C&!B1&!B&A1&!A|D1&D&C1&C&!B1&!B&A1&!A|D1&!D&C1&C&!B1&!B&A1&!A|D1&!D&C1&C&!B1&!B&A1&A|D1&D&C1&C&!B1&!B&A1&A|!D1&D&C1&C&!B1&!B&A1&A|!D1&D&C1&C&B1&!B&A1&A|D1&D&C1&C&B1&!B&A1&A|D1&!D&C1&C&B1&!B&A1&A|D1&!D&!C1&!C&B1&B&A1&A|D1&D&!C1&!C&B1&B&A1&A|!D1&D&!C1&!C&B1&B&A1&A|!D1&D&C1&!C&B1&B&A1&A|D1&D&C1&!C&B1&B&A1&A|D1&!D&C1&!C&B1&B&A1&A|D1&!D&C1&C&B1&B&A1&A|D1&D&C1&C&B1&B&A1&A|!D1&D&C1&C&B1&B&A1&A|!D1&D&!C1&C&B1&B&A1&A|D1&D&!C1&C&B1&B&A1&A|D1&!D&!C1&C&B1&B&A1&A|!D1&D&C1&C&!B1&B&A1&A|D1&D&C1&C&!B1&B&A1&A|D1&!D&C1&C&!B1&B&A1&A|D1&!D&C1&C&!B1&B&!A1&A|D1&D&C1&C&!B1&B&!A1&A|!D1&D&C1&C&!B1&B&!A1&A|D1&!D&!C1&C&B1&B&!A1&A|D1&D&!C1&C&B1&B&!A1&A|!D1&D&!C1&C&B1&B&!A1&A|!D1&D&C1&C&B1&B&!A1&A|D1&D&C1&C&B1&B&!A1&A|D1&!D&C1&C&B1&B&!A1&A|D1&!D&C1&!C&B1&B&!A1&A|D1&D&C1&!C&B1&B&!A1&A|!D1&D&C1&!C&B1&B&!A1&A|!D1&D&!C1&!C&B1&B&!A1&A|D1&D&!C1&!C&B1&B&!A1&A|D1&!D&!C1&!C&B1&B&!A1&A|D1&!D&C1&C&B1&!B&!A1&A|D1&D&C1&C&B1&!B&!A1&A|!D1&D&C1&C&B1&!B&!A1&A|!D1&D&C1&C&!B1&!B&!A1&A|D1&D&C1&C&!B1&!B&!A1&A|D1&!D&C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOAI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOI22131 -l AAOAAOI22131 -i E D2 D1 D C B1 B A1 A -o Y -f Y=(!E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!E&D2&!D1&!D&!C&!B1&!B&!A1&!A|!E&D2&D1&!D&!C&!B1&!B&!A1&!A|!E&!D2&D1&!D&!C&!B1&!B&!A1&!A|!E&!D2&D1&D&!C&!B1&!B&!A1&!A|!E&D2&!D1&D&!C&!B1&!B&!A1&!A|!E&!D2&!D1&D&!C&!B1&!B&!A1&!A|!E&!D2&!D1&D&C&!B1&!B&!A1&!A|!E&D2&!D1&D&C&!B1&!B&!A1&!A|!E&!D2&D1&D&C&!B1&!B&!A1&!A|!E&!D2&D1&!D&C&!B1&!B&!A1&!A|!E&D2&D1&!D&C&!B1&!B&!A1&!A|!E&D2&!D1&!D&C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&C&B1&!B&!A1&!A|!E&D2&!D1&!D&C&B1&!B&!A1&!A|!E&D2&D1&!D&C&B1&!B&!A1&!A|!E&!D2&D1&!D&C&B1&!B&!A1&!A|!E&!D2&D1&D&C&B1&!B&!A1&!A|!E&D2&!D1&D&C&B1&!B&!A1&!A|!E&!D2&!D1&D&C&B1&!B&!A1&!A|!E&!D2&!D1&D&!C&B1&!B&!A1&!A|!E&D2&!D1&D&!C&B1&!B&!A1&!A|!E&!D2&D1&D&!C&B1&!B&!A1&!A|!E&!D2&D1&!D&!C&B1&!B&!A1&!A|!E&D2&D1&!D&!C&B1&!B&!A1&!A|!E&D2&!D1&!D&!C&B1&!B&!A1&!A|!E&!D2&!D1&!D&!C&B1&!B&!A1&!A|!E&!D2&!D1&!D&!C&B1&B&!A1&!A|!E&D2&!D1&!D&!C&B1&B&!A1&!A|!E&D2&D1&!D&!C&B1&B&!A1&!A|!E&!D2&D1&!D&!C&B1&B&!A1&!A|!E&!D2&D1&D&!C&B1&B&!A1&!A|!E&D2&!D1&D&!C&B1&B&!A1&!A|!E&!D2&!D1&D&!C&B1&B&!A1&!A|!E&!D2&!D1&!D&C&!B1&B&!A1&!A|!E&D2&!D1&!D&C&!B1&B&!A1&!A|!E&D2&D1&!D&C&!B1&B&!A1&!A|!E&!D2&D1&!D&C&!B1&B&!A1&!A|!E&!D2&D1&D&C&!B1&B&!A1&!A|!E&D2&!D1&D&C&!B1&B&!A1&!A|!E&!D2&!D1&D&C&!B1&B&!A1&!A|!E&!D2&!D1&D&!C&!B1&B&!A1&!A|!E&D2&!D1&D&!C&!B1&B&!A1&!A|!E&!D2&D1&D&!C&!B1&B&!A1&!A|!E&!D2&D1&!D&!C&!B1&B&!A1&!A|!E&D2&D1&!D&!C&!B1&B&!A1&!A|!E&D2&!D1&!D&!C&!B1&B&!A1&!A|!E&!D2&!D1&!D&!C&!B1&B&!A1&!A|!E&!D2&!D1&!D&!C&!B1&B&A1&!A|!E&D2&!D1&!D&!C&!B1&B&A1&!A|!E&D2&D1&!D&!C&!B1&B&A1&!A|!E&!D2&D1&!D&!C&!B1&B&A1&!A|!E&!D2&D1&D&!C&!B1&B&A1&!A|!E&D2&!D1&D&!C&!B1&B&A1&!A|!E&!D2&!D1&D&!C&!B1&B&A1&!A|!E&!D2&!D1&D&C&!B1&B&A1&!A|!E&D2&!D1&D&C&!B1&B&A1&!A|!E&!D2&D1&D&C&!B1&B&A1&!A|!E&!D2&D1&!D&C&!B1&B&A1&!A|!E&D2&D1&!D&C&!B1&B&A1&!A|!E&D2&!D1&!D&C&!B1&B&A1&!A|!E&!D2&!D1&!D&C&!B1&B&A1&!A|!E&!D2&!D1&D&!C&B1&B&A1&!A|!E&D2&!D1&D&!C&B1&B&A1&!A|!E&!D2&D1&D&!C&B1&B&A1&!A|!E&!D2&D1&!D&!C&B1&B&A1&!A|!E&D2&D1&!D&!C&B1&B&A1&!A|!E&D2&!D1&!D&!C&B1&B&A1&!A|!E&!D2&!D1&!D&!C&B1&B&A1&!A|!E&!D2&!D1&!D&!C&B1&!B&A1&!A|!E&D2&!D1&!D&!C&B1&!B&A1&!A|!E&D2&D1&!D&!C&B1&!B&A1&!A|!E&!D2&D1&!D&!C&B1&!B&A1&!A|!E&!D2&D1&D&!C&B1&!B&A1&!A|!E&D2&!D1&D&!C&B1&!B&A1&!A|!E&!D2&!D1&D&!C&B1&!B&A1&!A|!E&!D2&!D1&D&C&B1&!B&A1&!A|!E&D2&!D1&D&C&B1&!B&A1&!A|!E&!D2&D1&D&C&B1&!B&A1&!A|!E&!D2&D1&!D&C&B1&!B&A1&!A|!E&D2&D1&!D&C&B1&!B&A1&!A|!E&D2&!D1&!D&C&B1&!B&A1&!A|!E&!D2&!D1&!D&C&B1&!B&A1&!A|!E&!D2&!D1&!D&C&!B1&!B&A1&!A|!E&D2&!D1&!D&C&!B1&!B&A1&!A|!E&D2&D1&!D&C&!B1&!B&A1&!A|!E&!D2&D1&!D&C&!B1&!B&A1&!A|!E&!D2&D1&D&C&!B1&!B&A1&!A|!E&D2&!D1&D&C&!B1&!B&A1&!A|!E&!D2&!D1&D&C&!B1&!B&A1&!A|!E&!D2&!D1&D&!C&!B1&!B&A1&!A|!E&D2&!D1&D&!C&!B1&!B&A1&!A|!E&!D2&D1&D&!C&!B1&!B&A1&!A|!E&!D2&D1&!D&!C&!B1&!B&A1&!A|!E&D2&D1&!D&!C&!B1&!B&A1&!A|!E&D2&!D1&!D&!C&!B1&!B&A1&!A|!E&!D2&!D1&!D&!C&!B1&!B&A1&!A|!E&!D2&!D1&!D&!C&!B1&!B&A1&A|!E&D2&!D1&!D&!C&!B1&!B&A1&A|!E&D2&D1&!D&!C&!B1&!B&A1&A|!E&!D2&D1&!D&!C&!B1&!B&A1&A|!E&!D2&D1&D&!C&!B1&!B&A1&A|!E&D2&!D1&D&!C&!B1&!B&A1&A|!E&!D2&!D1&D&!C&!B1&!B&A1&A|!E&!D2&!D1&D&!C&B1&!B&A1&A|!E&D2&!D1&D&!C&B1&!B&A1&A|!E&!D2&D1&D&!C&B1&!B&A1&A|!E&!D2&D1&!D&!C&B1&!B&A1&A|!E&D2&D1&!D&!C&B1&!B&A1&A|!E&D2&!D1&!D&!C&B1&!B&A1&A|!E&!D2&!D1&!D&!C&B1&!B&A1&A|!E&!D2&!D1&!D&!C&B1&B&A1&A|!E&D2&!D1&!D&!C&B1&B&A1&A|!E&D2&D1&!D&!C&B1&B&A1&A|!E&!D2&D1&!D&!C&B1&B&A1&A|!E&!D2&D1&D&!C&B1&B&A1&A|!E&D2&!D1&D&!C&B1&B&A1&A|!E&!D2&!D1&D&!C&B1&B&A1&A|!E&!D2&!D1&D&!C&!B1&B&A1&A|!E&D2&!D1&D&!C&!B1&B&A1&A|!E&!D2&D1&D&!C&!B1&B&A1&A|!E&!D2&D1&!D&!C&!B1&B&A1&A|!E&D2&D1&!D&!C&!B1&B&A1&A|!E&D2&!D1&!D&!C&!B1&B&A1&A|!E&!D2&!D1&!D&!C&!B1&B&A1&A|!E&!D2&!D1&!D&!C&!B1&B&!A1&A|!E&D2&!D1&!D&!C&!B1&B&!A1&A|!E&D2&D1&!D&!C&!B1&B&!A1&A|!E&!D2&D1&!D&!C&!B1&B&!A1&A|!E&!D2&D1&D&!C&!B1&B&!A1&A|!E&D2&!D1&D&!C&!B1&B&!A1&A|!E&!D2&!D1&D&!C&!B1&B&!A1&A|!E&!D2&!D1&D&C&!B1&B&!A1&A|!E&D2&!D1&D&C&!B1&B&!A1&A|!E&!D2&D1&D&C&!B1&B&!A1&A|!E&!D2&D1&!D&C&!B1&B&!A1&A|!E&D2&D1&!D&C&!B1&B&!A1&A|!E&D2&!D1&!D&C&!B1&B&!A1&A|!E&!D2&!D1&!D&C&!B1&B&!A1&A|!E&!D2&!D1&D&!C&B1&B&!A1&A|!E&D2&!D1&D&!C&B1&B&!A1&A|!E&!D2&D1&D&!C&B1&B&!A1&A|!E&!D2&D1&!D&!C&B1&B&!A1&A|!E&D2&D1&!D&!C&B1&B&!A1&A|!E&D2&!D1&!D&!C&B1&B&!A1&A|!E&!D2&!D1&!D&!C&B1&B&!A1&A|!E&!D2&!D1&!D&!C&B1&!B&!A1&A|!E&D2&!D1&!D&!C&B1&!B&!A1&A|!E&D2&D1&!D&!C&B1&!B&!A1&A|!E&!D2&D1&!D&!C&B1&!B&!A1&A|!E&!D2&D1&D&!C&B1&!B&!A1&A|!E&D2&!D1&D&!C&B1&!B&!A1&A|!E&!D2&!D1&D&!C&B1&!B&!A1&A|!E&!D2&!D1&D&C&B1&!B&!A1&A|!E&D2&!D1&D&C&B1&!B&!A1&A|!E&!D2&D1&D&C&B1&!B&!A1&A|!E&!D2&D1&!D&C&B1&!B&!A1&A|!E&D2&D1&!D&C&B1&!B&!A1&A|!E&D2&!D1&!D&C&B1&!B&!A1&A|!E&!D2&!D1&!D&C&B1&!B&!A1&A|!E&!D2&!D1&!D&C&!B1&!B&!A1&A|!E&D2&!D1&!D&C&!B1&!B&!A1&A|!E&D2&D1&!D&C&!B1&!B&!A1&A|!E&!D2&D1&!D&C&!B1&!B&!A1&A|!E&!D2&D1&D&C&!B1&!B&!A1&A|!E&D2&!D1&D&C&!B1&!B&!A1&A|!E&!D2&!D1&D&C&!B1&!B&!A1&A|!E&!D2&!D1&D&!C&!B1&!B&!A1&A|!E&D2&!D1&D&!C&!B1&!B&!A1&A|!E&!D2&D1&D&!C&!B1&!B&!A1&A|!E&!D2&D1&!D&!C&!B1&!B&!A1&A|!E&D2&D1&!D&!C&!B1&!B&!A1&A|!E&D2&!D1&!D&!C&!B1&!B&!A1&A|!E&!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOI22131.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAI42 -l OOAI42 -i B1 B A3 A2 A1 A -o Y -f Y=(!B1&!B&!A3&!A2&!A1&!A|B1&!B&!A3&!A2&!A1&!A|B1&B&!A3&!A2&!A1&!A|!B1&B&!A3&!A2&!A1&!A|!B1&!B&A3&!A2&!A1&!A|!B1&!B&A3&A2&!A1&!A|!B1&!B&!A3&A2&!A1&!A|!B1&!B&!A3&A2&A1&!A|!B1&!B&A3&A2&A1&!A|!B1&!B&A3&!A2&A1&!A|!B1&!B&!A3&!A2&A1&!A|!B1&!B&!A3&!A2&A1&A|!B1&!B&A3&!A2&A1&A|!B1&!B&A3&A2&A1&A|!B1&!B&!A3&A2&A1&A|!B1&!B&!A3&A2&!A1&A|!B1&!B&A3&A2&!A1&A|!B1&!B&A3&!A2&!A1&A|!B1&!B&!A3&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAI42.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOI213 -l OAAOI213 -i C2 C1 C B A1 A -o Y -f Y=!(C2&C1&C&!B&!A1&!A|C2&C1&C&B&!A1&!A|!C2&!C1&!C&B&A1&!A|C2&!C1&!C&B&A1&!A|C2&C1&!C&B&A1&!A|!C2&C1&!C&B&A1&!A|!C2&C1&C&B&A1&!A|C2&C1&C&B&A1&!A|C2&!C1&C&B&A1&!A|!C2&!C1&C&B&A1&!A|C2&C1&C&!B&A1&!A|C2&C1&C&!B&A1&A|!C2&!C1&C&B&A1&A|C2&!C1&C&B&A1&A|C2&C1&C&B&A1&A|!C2&C1&C&B&A1&A|!C2&C1&!C&B&A1&A|C2&C1&!C&B&A1&A|C2&!C1&!C&B&A1&A|!C2&!C1&!C&B&A1&A|!C2&!C1&!C&B&!A1&A|C2&!C1&!C&B&!A1&A|C2&C1&!C&B&!A1&A|!C2&C1&!C&B&!A1&A|!C2&C1&C&B&!A1&A|C2&C1&C&B&!A1&A|C2&!C1&C&B&!A1&A|!C2&!C1&C&B&!A1&A|C2&C1&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOI213.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAI33 -l OAI33 -i B2 B1 B A2 A1 A -o Y -f Y=!(B2&B1&B&A2&!A1&!A|B2&B1&B&A2&A1&!A|B2&B1&B&!A2&A1&!A|B2&B1&B&!A2&A1&A|B2&B1&B&A2&A1&A|B2&B1&B&A2&!A1&A|B2&B1&B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAI33.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAI2331 -l AOOAI2331 -i D C2 C1 C B2 B1 B A1 A -o Y -f Y=!(D&!C2&!C1&C&B2&!B1&!B&!A1&!A|D&C2&!C1&C&B2&!B1&!B&!A1&!A|D&C2&C1&C&B2&!B1&!B&!A1&!A|D&!C2&C1&C&B2&!B1&!B&!A1&!A|D&!C2&C1&!C&B2&!B1&!B&!A1&!A|D&C2&C1&!C&B2&!B1&!B&!A1&!A|D&C2&!C1&!C&B2&!B1&!B&!A1&!A|D&C2&!C1&!C&B2&B1&!B&!A1&!A|D&C2&C1&!C&B2&B1&!B&!A1&!A|D&!C2&C1&!C&B2&B1&!B&!A1&!A|D&!C2&C1&C&B2&B1&!B&!A1&!A|D&C2&C1&C&B2&B1&!B&!A1&!A|D&C2&!C1&C&B2&B1&!B&!A1&!A|D&!C2&!C1&C&B2&B1&!B&!A1&!A|D&!C2&!C1&C&!B2&B1&!B&!A1&!A|D&C2&!C1&C&!B2&B1&!B&!A1&!A|D&C2&C1&C&!B2&B1&!B&!A1&!A|D&!C2&C1&C&!B2&B1&!B&!A1&!A|D&!C2&C1&!C&!B2&B1&!B&!A1&!A|D&C2&C1&!C&!B2&B1&!B&!A1&!A|D&C2&!C1&!C&!B2&B1&!B&!A1&!A|D&C2&!C1&!C&!B2&B1&B&!A1&!A|D&C2&C1&!C&!B2&B1&B&!A1&!A|D&!C2&C1&!C&!B2&B1&B&!A1&!A|D&!C2&C1&C&!B2&B1&B&!A1&!A|D&C2&C1&C&!B2&B1&B&!A1&!A|D&C2&!C1&C&!B2&B1&B&!A1&!A|D&!C2&!C1&C&!B2&B1&B&!A1&!A|D&!C2&!C1&C&B2&B1&B&!A1&!A|D&C2&!C1&C&B2&B1&B&!A1&!A|D&C2&C1&C&B2&B1&B&!A1&!A|D&!C2&C1&C&B2&B1&B&!A1&!A|D&!C2&C1&!C&B2&B1&B&!A1&!A|D&C2&C1&!C&B2&B1&B&!A1&!A|D&C2&!C1&!C&B2&B1&B&!A1&!A|D&C2&!C1&!C&B2&!B1&B&!A1&!A|D&C2&C1&!C&B2&!B1&B&!A1&!A|D&!C2&C1&!C&B2&!B1&B&!A1&!A|D&!C2&C1&C&B2&!B1&B&!A1&!A|D&C2&C1&C&B2&!B1&B&!A1&!A|D&C2&!C1&C&B2&!B1&B&!A1&!A|D&!C2&!C1&C&B2&!B1&B&!A1&!A|D&!C2&!C1&C&!B2&!B1&B&!A1&!A|D&C2&!C1&C&!B2&!B1&B&!A1&!A|D&C2&C1&C&!B2&!B1&B&!A1&!A|D&!C2&C1&C&!B2&!B1&B&!A1&!A|D&!C2&C1&!C&!B2&!B1&B&!A1&!A|D&C2&C1&!C&!B2&!B1&B&!A1&!A|D&C2&!C1&!C&!B2&!B1&B&!A1&!A|D&C2&!C1&!C&!B2&!B1&B&A1&!A|D&C2&C1&!C&!B2&!B1&B&A1&!A|D&!C2&C1&!C&!B2&!B1&B&A1&!A|D&!C2&C1&C&!B2&!B1&B&A1&!A|D&C2&C1&C&!B2&!B1&B&A1&!A|D&C2&!C1&C&!B2&!B1&B&A1&!A|D&!C2&!C1&C&!B2&!B1&B&A1&!A|D&!C2&!C1&C&B2&!B1&B&A1&!A|D&C2&!C1&C&B2&!B1&B&A1&!A|D&C2&C1&C&B2&!B1&B&A1&!A|D&!C2&C1&C&B2&!B1&B&A1&!A|D&!C2&C1&!C&B2&!B1&B&A1&!A|D&C2&C1&!C&B2&!B1&B&A1&!A|D&C2&!C1&!C&B2&!B1&B&A1&!A|D&C2&!C1&!C&B2&B1&B&A1&!A|D&C2&C1&!C&B2&B1&B&A1&!A|D&!C2&C1&!C&B2&B1&B&A1&!A|D&!C2&C1&C&B2&B1&B&A1&!A|D&C2&C1&C&B2&B1&B&A1&!A|D&C2&!C1&C&B2&B1&B&A1&!A|D&!C2&!C1&C&B2&B1&B&A1&!A|D&!C2&!C1&C&!B2&B1&B&A1&!A|D&C2&!C1&C&!B2&B1&B&A1&!A|D&C2&C1&C&!B2&B1&B&A1&!A|D&!C2&C1&C&!B2&B1&B&A1&!A|D&!C2&C1&!C&!B2&B1&B&A1&!A|D&C2&C1&!C&!B2&B1&B&A1&!A|D&C2&!C1&!C&!B2&B1&B&A1&!A|D&C2&!C1&!C&!B2&B1&!B&A1&!A|D&C2&C1&!C&!B2&B1&!B&A1&!A|D&!C2&C1&!C&!B2&B1&!B&A1&!A|D&!C2&C1&C&!B2&B1&!B&A1&!A|D&C2&C1&C&!B2&B1&!B&A1&!A|D&C2&!C1&C&!B2&B1&!B&A1&!A|D&!C2&!C1&C&!B2&B1&!B&A1&!A|D&!C2&!C1&C&B2&B1&!B&A1&!A|D&C2&!C1&C&B2&B1&!B&A1&!A|D&C2&C1&C&B2&B1&!B&A1&!A|D&!C2&C1&C&B2&B1&!B&A1&!A|D&!C2&C1&!C&B2&B1&!B&A1&!A|D&C2&C1&!C&B2&B1&!B&A1&!A|D&C2&!C1&!C&B2&B1&!B&A1&!A|D&C2&!C1&!C&B2&!B1&!B&A1&!A|D&C2&C1&!C&B2&!B1&!B&A1&!A|D&!C2&C1&!C&B2&!B1&!B&A1&!A|D&!C2&C1&C&B2&!B1&!B&A1&!A|D&C2&C1&C&B2&!B1&!B&A1&!A|D&C2&!C1&C&B2&!B1&!B&A1&!A|D&!C2&!C1&C&B2&!B1&!B&A1&!A|D&C2&!C1&!C&!B2&!B1&!B&A1&A|D&C2&C1&!C&!B2&!B1&!B&A1&A|D&!C2&C1&!C&!B2&!B1&!B&A1&A|D&!C2&C1&C&!B2&!B1&!B&A1&A|D&C2&C1&C&!B2&!B1&!B&A1&A|D&C2&!C1&C&!B2&!B1&!B&A1&A|D&!C2&!C1&C&!B2&!B1&!B&A1&A|D&!C2&!C1&C&B2&!B1&!B&A1&A|D&C2&!C1&C&B2&!B1&!B&A1&A|D&C2&C1&C&B2&!B1&!B&A1&A|D&!C2&C1&C&B2&!B1&!B&A1&A|D&!C2&C1&!C&B2&!B1&!B&A1&A|D&C2&C1&!C&B2&!B1&!B&A1&A|D&C2&!C1&!C&B2&!B1&!B&A1&A|D&C2&!C1&!C&B2&B1&!B&A1&A|D&C2&C1&!C&B2&B1&!B&A1&A|D&!C2&C1&!C&B2&B1&!B&A1&A|D&!C2&C1&C&B2&B1&!B&A1&A|D&C2&C1&C&B2&B1&!B&A1&A|D&C2&!C1&C&B2&B1&!B&A1&A|D&!C2&!C1&C&B2&B1&!B&A1&A|D&!C2&!C1&C&!B2&B1&!B&A1&A|D&C2&!C1&C&!B2&B1&!B&A1&A|D&C2&C1&C&!B2&B1&!B&A1&A|D&!C2&C1&C&!B2&B1&!B&A1&A|D&!C2&C1&!C&!B2&B1&!B&A1&A|D&C2&C1&!C&!B2&B1&!B&A1&A|D&C2&!C1&!C&!B2&B1&!B&A1&A|D&C2&!C1&!C&!B2&B1&B&A1&A|D&C2&C1&!C&!B2&B1&B&A1&A|D&!C2&C1&!C&!B2&B1&B&A1&A|D&!C2&C1&C&!B2&B1&B&A1&A|D&C2&C1&C&!B2&B1&B&A1&A|D&C2&!C1&C&!B2&B1&B&A1&A|D&!C2&!C1&C&!B2&B1&B&A1&A|D&!C2&!C1&C&B2&B1&B&A1&A|D&C2&!C1&C&B2&B1&B&A1&A|D&C2&C1&C&B2&B1&B&A1&A|D&!C2&C1&C&B2&B1&B&A1&A|D&!C2&C1&!C&B2&B1&B&A1&A|D&C2&C1&!C&B2&B1&B&A1&A|D&C2&!C1&!C&B2&B1&B&A1&A|D&C2&!C1&!C&B2&!B1&B&A1&A|D&C2&C1&!C&B2&!B1&B&A1&A|D&!C2&C1&!C&B2&!B1&B&A1&A|D&!C2&C1&C&B2&!B1&B&A1&A|D&C2&C1&C&B2&!B1&B&A1&A|D&C2&!C1&C&B2&!B1&B&A1&A|D&!C2&!C1&C&B2&!B1&B&A1&A|D&!C2&!C1&C&!B2&!B1&B&A1&A|D&C2&!C1&C&!B2&!B1&B&A1&A|D&C2&C1&C&!B2&!B1&B&A1&A|D&!C2&C1&C&!B2&!B1&B&A1&A|D&!C2&C1&!C&!B2&!B1&B&A1&A|D&C2&C1&!C&!B2&!B1&B&A1&A|D&C2&!C1&!C&!B2&!B1&B&A1&A|D&C2&!C1&!C&!B2&!B1&B&!A1&A|D&C2&C1&!C&!B2&!B1&B&!A1&A|D&!C2&C1&!C&!B2&!B1&B&!A1&A|D&!C2&C1&C&!B2&!B1&B&!A1&A|D&C2&C1&C&!B2&!B1&B&!A1&A|D&C2&!C1&C&!B2&!B1&B&!A1&A|D&!C2&!C1&C&!B2&!B1&B&!A1&A|D&!C2&!C1&C&B2&!B1&B&!A1&A|D&C2&!C1&C&B2&!B1&B&!A1&A|D&C2&C1&C&B2&!B1&B&!A1&A|D&!C2&C1&C&B2&!B1&B&!A1&A|D&!C2&C1&!C&B2&!B1&B&!A1&A|D&C2&C1&!C&B2&!B1&B&!A1&A|D&C2&!C1&!C&B2&!B1&B&!A1&A|D&C2&!C1&!C&B2&B1&B&!A1&A|D&C2&C1&!C&B2&B1&B&!A1&A|D&!C2&C1&!C&B2&B1&B&!A1&A|D&!C2&C1&C&B2&B1&B&!A1&A|D&C2&C1&C&B2&B1&B&!A1&A|D&C2&!C1&C&B2&B1&B&!A1&A|D&!C2&!C1&C&B2&B1&B&!A1&A|D&!C2&!C1&C&!B2&B1&B&!A1&A|D&C2&!C1&C&!B2&B1&B&!A1&A|D&C2&C1&C&!B2&B1&B&!A1&A|D&!C2&C1&C&!B2&B1&B&!A1&A|D&!C2&C1&!C&!B2&B1&B&!A1&A|D&C2&C1&!C&!B2&B1&B&!A1&A|D&C2&!C1&!C&!B2&B1&B&!A1&A|D&C2&!C1&!C&!B2&B1&!B&!A1&A|D&C2&C1&!C&!B2&B1&!B&!A1&A|D&!C2&C1&!C&!B2&B1&!B&!A1&A|D&!C2&C1&C&!B2&B1&!B&!A1&A|D&C2&C1&C&!B2&B1&!B&!A1&A|D&C2&!C1&C&!B2&B1&!B&!A1&A|D&!C2&!C1&C&!B2&B1&!B&!A1&A|D&!C2&!C1&C&B2&B1&!B&!A1&A|D&C2&!C1&C&B2&B1&!B&!A1&A|D&C2&C1&C&B2&B1&!B&!A1&A|D&!C2&C1&C&B2&B1&!B&!A1&A|D&!C2&C1&!C&B2&B1&!B&!A1&A|D&C2&C1&!C&B2&B1&!B&!A1&A|D&C2&!C1&!C&B2&B1&!B&!A1&A|D&C2&!C1&!C&B2&!B1&!B&!A1&A|D&C2&C1&!C&B2&!B1&!B&!A1&A|D&!C2&C1&!C&B2&!B1&!B&!A1&A|D&!C2&C1&C&B2&!B1&!B&!A1&A|D&C2&C1&C&B2&!B1&!B&!A1&A|D&C2&!C1&C&B2&!B1&!B&!A1&A|D&!C2&!C1&C&B2&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAI2331.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOAOAI212211 -l OAAOOAOAI212211 -i F E D1 D C1 C B A1 A -o Y -f Y=!(F&E&!D1&!D&!C1&!C&!B&!A1&!A|F&E&D1&!D&!C1&!C&!B&!A1&!A|F&E&D1&D&!C1&!C&!B&!A1&!A|F&E&!D1&D&!C1&!C&!B&!A1&!A|F&E&!D1&D&C1&!C&!B&!A1&!A|F&E&D1&D&C1&!C&!B&!A1&!A|F&E&D1&!D&C1&!C&!B&!A1&!A|F&E&!D1&!D&C1&!C&!B&!A1&!A|F&E&!D1&!D&C1&C&!B&!A1&!A|F&E&D1&!D&C1&C&!B&!A1&!A|F&!E&D1&!D&C1&C&!B&!A1&!A|F&!E&D1&D&C1&C&!B&!A1&!A|F&E&D1&D&C1&C&!B&!A1&!A|F&E&!D1&D&C1&C&!B&!A1&!A|F&!E&!D1&D&C1&C&!B&!A1&!A|F&E&!D1&D&!C1&C&!B&!A1&!A|F&E&D1&D&!C1&C&!B&!A1&!A|F&E&D1&!D&!C1&C&!B&!A1&!A|F&E&!D1&!D&!C1&C&!B&!A1&!A|F&E&!D1&!D&!C1&C&B&!A1&!A|F&E&D1&!D&!C1&C&B&!A1&!A|F&E&D1&D&!C1&C&B&!A1&!A|F&E&!D1&D&!C1&C&B&!A1&!A|F&!E&!D1&D&C1&C&B&!A1&!A|F&E&!D1&D&C1&C&B&!A1&!A|F&E&D1&D&C1&C&B&!A1&!A|F&!E&D1&D&C1&C&B&!A1&!A|F&!E&D1&!D&C1&C&B&!A1&!A|F&E&D1&!D&C1&C&B&!A1&!A|F&E&!D1&!D&C1&C&B&!A1&!A|F&E&!D1&!D&C1&!C&B&!A1&!A|F&E&D1&!D&C1&!C&B&!A1&!A|F&E&D1&D&C1&!C&B&!A1&!A|F&E&!D1&D&C1&!C&B&!A1&!A|F&E&!D1&D&!C1&!C&B&!A1&!A|F&E&D1&D&!C1&!C&B&!A1&!A|F&E&D1&!D&!C1&!C&B&!A1&!A|F&E&!D1&!D&!C1&!C&B&!A1&!A|F&E&!D1&!D&!C1&!C&B&A1&!A|F&E&D1&!D&!C1&!C&B&A1&!A|F&!E&D1&!D&!C1&!C&B&A1&!A|F&!E&D1&D&!C1&!C&B&A1&!A|F&E&D1&D&!C1&!C&B&A1&!A|F&E&!D1&D&!C1&!C&B&A1&!A|F&!E&!D1&D&!C1&!C&B&A1&!A|F&!E&!D1&D&C1&!C&B&A1&!A|F&E&!D1&D&C1&!C&B&A1&!A|F&E&D1&D&C1&!C&B&A1&!A|F&!E&D1&D&C1&!C&B&A1&!A|F&!E&D1&!D&C1&!C&B&A1&!A|F&E&D1&!D&C1&!C&B&A1&!A|F&E&!D1&!D&C1&!C&B&A1&!A|F&E&!D1&!D&C1&C&B&A1&!A|F&E&D1&!D&C1&C&B&A1&!A|F&!E&D1&!D&C1&C&B&A1&!A|F&!E&D1&D&C1&C&B&A1&!A|F&E&D1&D&C1&C&B&A1&!A|F&E&!D1&D&C1&C&B&A1&!A|F&!E&!D1&D&C1&C&B&A1&!A|F&!E&!D1&D&!C1&C&B&A1&!A|F&E&!D1&D&!C1&C&B&A1&!A|F&E&D1&D&!C1&C&B&A1&!A|F&!E&D1&D&!C1&C&B&A1&!A|F&!E&D1&!D&!C1&C&B&A1&!A|F&E&D1&!D&!C1&C&B&A1&!A|F&E&!D1&!D&!C1&C&B&A1&!A|F&E&!D1&!D&!C1&C&!B&A1&!A|F&E&D1&!D&!C1&C&!B&A1&!A|F&E&D1&D&!C1&C&!B&A1&!A|F&E&!D1&D&!C1&C&!B&A1&!A|F&!E&!D1&D&C1&C&!B&A1&!A|F&E&!D1&D&C1&C&!B&A1&!A|F&E&D1&D&C1&C&!B&A1&!A|F&!E&D1&D&C1&C&!B&A1&!A|F&!E&D1&!D&C1&C&!B&A1&!A|F&E&D1&!D&C1&C&!B&A1&!A|F&E&!D1&!D&C1&C&!B&A1&!A|F&E&!D1&!D&C1&!C&!B&A1&!A|F&E&D1&!D&C1&!C&!B&A1&!A|F&E&D1&D&C1&!C&!B&A1&!A|F&E&!D1&D&C1&!C&!B&A1&!A|F&E&!D1&D&!C1&!C&!B&A1&!A|F&E&D1&D&!C1&!C&!B&A1&!A|F&E&D1&!D&!C1&!C&!B&A1&!A|F&E&!D1&!D&!C1&!C&!B&A1&!A|F&E&!D1&!D&!C1&!C&!B&A1&A|F&E&D1&!D&!C1&!C&!B&A1&A|F&E&D1&D&!C1&!C&!B&A1&A|F&E&!D1&D&!C1&!C&!B&A1&A|F&E&!D1&D&C1&!C&!B&A1&A|F&E&D1&D&C1&!C&!B&A1&A|F&E&D1&!D&C1&!C&!B&A1&A|F&E&!D1&!D&C1&!C&!B&A1&A|F&E&!D1&!D&C1&C&!B&A1&A|F&E&D1&!D&C1&C&!B&A1&A|F&!E&D1&!D&C1&C&!B&A1&A|F&!E&D1&D&C1&C&!B&A1&A|F&E&D1&D&C1&C&!B&A1&A|F&E&!D1&D&C1&C&!B&A1&A|F&!E&!D1&D&C1&C&!B&A1&A|F&E&!D1&D&!C1&C&!B&A1&A|F&E&D1&D&!C1&C&!B&A1&A|F&E&D1&!D&!C1&C&!B&A1&A|F&E&!D1&!D&!C1&C&!B&A1&A|F&E&!D1&!D&!C1&C&B&A1&A|F&E&D1&!D&!C1&C&B&A1&A|F&!E&D1&!D&!C1&C&B&A1&A|F&!E&D1&D&!C1&C&B&A1&A|F&E&D1&D&!C1&C&B&A1&A|F&E&!D1&D&!C1&C&B&A1&A|F&!E&!D1&D&!C1&C&B&A1&A|F&!E&!D1&D&C1&C&B&A1&A|F&E&!D1&D&C1&C&B&A1&A|F&E&D1&D&C1&C&B&A1&A|F&!E&D1&D&C1&C&B&A1&A|F&!E&D1&!D&C1&C&B&A1&A|F&E&D1&!D&C1&C&B&A1&A|F&E&!D1&!D&C1&C&B&A1&A|F&E&!D1&!D&C1&!C&B&A1&A|F&E&D1&!D&C1&!C&B&A1&A|F&!E&D1&!D&C1&!C&B&A1&A|F&!E&D1&D&C1&!C&B&A1&A|F&E&D1&D&C1&!C&B&A1&A|F&E&!D1&D&C1&!C&B&A1&A|F&!E&!D1&D&C1&!C&B&A1&A|F&!E&!D1&D&!C1&!C&B&A1&A|F&E&!D1&D&!C1&!C&B&A1&A|F&E&D1&D&!C1&!C&B&A1&A|F&!E&D1&D&!C1&!C&B&A1&A|F&!E&D1&!D&!C1&!C&B&A1&A|F&E&D1&!D&!C1&!C&B&A1&A|F&E&!D1&!D&!C1&!C&B&A1&A|F&E&!D1&!D&!C1&!C&B&!A1&A|F&E&D1&!D&!C1&!C&B&!A1&A|F&!E&D1&!D&!C1&!C&B&!A1&A|F&!E&D1&D&!C1&!C&B&!A1&A|F&E&D1&D&!C1&!C&B&!A1&A|F&E&!D1&D&!C1&!C&B&!A1&A|F&!E&!D1&D&!C1&!C&B&!A1&A|F&!E&!D1&D&C1&!C&B&!A1&A|F&E&!D1&D&C1&!C&B&!A1&A|F&E&D1&D&C1&!C&B&!A1&A|F&!E&D1&D&C1&!C&B&!A1&A|F&!E&D1&!D&C1&!C&B&!A1&A|F&E&D1&!D&C1&!C&B&!A1&A|F&E&!D1&!D&C1&!C&B&!A1&A|F&E&!D1&!D&C1&C&B&!A1&A|F&E&D1&!D&C1&C&B&!A1&A|F&!E&D1&!D&C1&C&B&!A1&A|F&!E&D1&D&C1&C&B&!A1&A|F&E&D1&D&C1&C&B&!A1&A|F&E&!D1&D&C1&C&B&!A1&A|F&!E&!D1&D&C1&C&B&!A1&A|F&!E&!D1&D&!C1&C&B&!A1&A|F&E&!D1&D&!C1&C&B&!A1&A|F&E&D1&D&!C1&C&B&!A1&A|F&!E&D1&D&!C1&C&B&!A1&A|F&!E&D1&!D&!C1&C&B&!A1&A|F&E&D1&!D&!C1&C&B&!A1&A|F&E&!D1&!D&!C1&C&B&!A1&A|F&E&!D1&!D&!C1&C&!B&!A1&A|F&E&D1&!D&!C1&C&!B&!A1&A|F&E&D1&D&!C1&C&!B&!A1&A|F&E&!D1&D&!C1&C&!B&!A1&A|F&!E&!D1&D&C1&C&!B&!A1&A|F&E&!D1&D&C1&C&!B&!A1&A|F&E&D1&D&C1&C&!B&!A1&A|F&!E&D1&D&C1&C&!B&!A1&A|F&!E&D1&!D&C1&C&!B&!A1&A|F&E&D1&!D&C1&C&!B&!A1&A|F&E&!D1&!D&C1&C&!B&!A1&A|F&E&!D1&!D&C1&!C&!B&!A1&A|F&E&D1&!D&C1&!C&!B&!A1&A|F&E&D1&D&C1&!C&!B&!A1&A|F&E&!D1&D&C1&!C&!B&!A1&A|F&E&!D1&D&!C1&!C&!B&!A1&A|F&E&D1&D&!C1&!C&!B&!A1&A|F&E&D1&!D&!C1&!C&!B&!A1&A|F&E&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOAOAI212211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOAOAI222111 -l AAAOAOAI222111 -i F E D C1 C B1 B A1 A -o Y -f Y=!(F&E&!D&!C1&!C&!B1&!B&!A1&!A|F&E&D&!C1&!C&!B1&!B&!A1&!A|F&E&D&C1&!C&!B1&!B&!A1&!A|F&E&!D&C1&!C&!B1&!B&!A1&!A|F&E&!D&C1&C&!B1&!B&!A1&!A|F&E&D&C1&C&!B1&!B&!A1&!A|F&!E&D&C1&C&!B1&!B&!A1&!A|F&E&D&!C1&C&!B1&!B&!A1&!A|F&E&!D&!C1&C&!B1&!B&!A1&!A|F&E&!D&!C1&C&B1&!B&!A1&!A|F&E&D&!C1&C&B1&!B&!A1&!A|F&!E&D&C1&C&B1&!B&!A1&!A|F&E&D&C1&C&B1&!B&!A1&!A|F&E&!D&C1&C&B1&!B&!A1&!A|F&E&!D&C1&!C&B1&!B&!A1&!A|F&E&D&C1&!C&B1&!B&!A1&!A|F&E&D&!C1&!C&B1&!B&!A1&!A|F&E&!D&!C1&!C&B1&!B&!A1&!A|F&E&!D&!C1&!C&B1&B&!A1&!A|F&E&D&!C1&!C&B1&B&!A1&!A|F&!E&D&!C1&!C&B1&B&!A1&!A|F&!E&D&C1&!C&B1&B&!A1&!A|F&E&D&C1&!C&B1&B&!A1&!A|F&E&!D&C1&!C&B1&B&!A1&!A|F&E&!D&C1&C&B1&B&!A1&!A|F&E&D&C1&C&B1&B&!A1&!A|F&!E&D&C1&C&B1&B&!A1&!A|F&!E&D&!C1&C&B1&B&!A1&!A|F&E&D&!C1&C&B1&B&!A1&!A|F&E&!D&!C1&C&B1&B&!A1&!A|F&E&!D&!C1&C&!B1&B&!A1&!A|F&E&D&!C1&C&!B1&B&!A1&!A|F&!E&D&C1&C&!B1&B&!A1&!A|F&E&D&C1&C&!B1&B&!A1&!A|F&E&!D&C1&C&!B1&B&!A1&!A|F&E&!D&C1&!C&!B1&B&!A1&!A|F&E&D&C1&!C&!B1&B&!A1&!A|F&E&D&!C1&!C&!B1&B&!A1&!A|F&E&!D&!C1&!C&!B1&B&!A1&!A|F&E&!D&!C1&!C&!B1&B&A1&!A|F&E&D&!C1&!C&!B1&B&A1&!A|F&E&D&C1&!C&!B1&B&A1&!A|F&E&!D&C1&!C&!B1&B&A1&!A|F&E&!D&C1&C&!B1&B&A1&!A|F&E&D&C1&C&!B1&B&A1&!A|F&!E&D&C1&C&!B1&B&A1&!A|F&E&D&!C1&C&!B1&B&A1&!A|F&E&!D&!C1&C&!B1&B&A1&!A|F&E&!D&!C1&C&B1&B&A1&!A|F&E&D&!C1&C&B1&B&A1&!A|F&!E&D&!C1&C&B1&B&A1&!A|F&!E&D&C1&C&B1&B&A1&!A|F&E&D&C1&C&B1&B&A1&!A|F&E&!D&C1&C&B1&B&A1&!A|F&E&!D&C1&!C&B1&B&A1&!A|F&E&D&C1&!C&B1&B&A1&!A|F&!E&D&C1&!C&B1&B&A1&!A|F&!E&D&!C1&!C&B1&B&A1&!A|F&E&D&!C1&!C&B1&B&A1&!A|F&E&!D&!C1&!C&B1&B&A1&!A|F&E&!D&!C1&!C&B1&!B&A1&!A|F&E&D&!C1&!C&B1&!B&A1&!A|F&E&D&C1&!C&B1&!B&A1&!A|F&E&!D&C1&!C&B1&!B&A1&!A|F&E&!D&C1&C&B1&!B&A1&!A|F&E&D&C1&C&B1&!B&A1&!A|F&!E&D&C1&C&B1&!B&A1&!A|F&E&D&!C1&C&B1&!B&A1&!A|F&E&!D&!C1&C&B1&!B&A1&!A|F&E&!D&!C1&C&!B1&!B&A1&!A|F&E&D&!C1&C&!B1&!B&A1&!A|F&!E&D&C1&C&!B1&!B&A1&!A|F&E&D&C1&C&!B1&!B&A1&!A|F&E&!D&C1&C&!B1&!B&A1&!A|F&E&!D&C1&!C&!B1&!B&A1&!A|F&E&D&C1&!C&!B1&!B&A1&!A|F&E&D&!C1&!C&!B1&!B&A1&!A|F&E&!D&!C1&!C&!B1&!B&A1&!A|F&E&!D&!C1&!C&!B1&!B&A1&A|F&E&D&!C1&!C&!B1&!B&A1&A|F&!E&D&!C1&!C&!B1&!B&A1&A|F&!E&D&C1&!C&!B1&!B&A1&A|F&E&D&C1&!C&!B1&!B&A1&A|F&E&!D&C1&!C&!B1&!B&A1&A|F&E&!D&C1&C&!B1&!B&A1&A|F&E&D&C1&C&!B1&!B&A1&A|F&!E&D&C1&C&!B1&!B&A1&A|F&!E&D&!C1&C&!B1&!B&A1&A|F&E&D&!C1&C&!B1&!B&A1&A|F&E&!D&!C1&C&!B1&!B&A1&A|F&E&!D&!C1&C&B1&!B&A1&A|F&E&D&!C1&C&B1&!B&A1&A|F&!E&D&!C1&C&B1&!B&A1&A|F&!E&D&C1&C&B1&!B&A1&A|F&E&D&C1&C&B1&!B&A1&A|F&E&!D&C1&C&B1&!B&A1&A|F&E&!D&C1&!C&B1&!B&A1&A|F&E&D&C1&!C&B1&!B&A1&A|F&!E&D&C1&!C&B1&!B&A1&A|F&!E&D&!C1&!C&B1&!B&A1&A|F&E&D&!C1&!C&B1&!B&A1&A|F&E&!D&!C1&!C&B1&!B&A1&A|F&E&!D&!C1&!C&B1&B&A1&A|F&E&D&!C1&!C&B1&B&A1&A|F&!E&D&!C1&!C&B1&B&A1&A|F&!E&D&C1&!C&B1&B&A1&A|F&E&D&C1&!C&B1&B&A1&A|F&E&!D&C1&!C&B1&B&A1&A|F&E&!D&C1&C&B1&B&A1&A|F&E&D&C1&C&B1&B&A1&A|F&!E&D&C1&C&B1&B&A1&A|F&!E&D&!C1&C&B1&B&A1&A|F&E&D&!C1&C&B1&B&A1&A|F&E&!D&!C1&C&B1&B&A1&A|F&E&!D&!C1&C&!B1&B&A1&A|F&E&D&!C1&C&!B1&B&A1&A|F&!E&D&!C1&C&!B1&B&A1&A|F&!E&D&C1&C&!B1&B&A1&A|F&E&D&C1&C&!B1&B&A1&A|F&E&!D&C1&C&!B1&B&A1&A|F&E&!D&C1&!C&!B1&B&A1&A|F&E&D&C1&!C&!B1&B&A1&A|F&!E&D&C1&!C&!B1&B&A1&A|F&!E&D&!C1&!C&!B1&B&A1&A|F&E&D&!C1&!C&!B1&B&A1&A|F&E&!D&!C1&!C&!B1&B&A1&A|F&E&!D&!C1&!C&!B1&B&!A1&A|F&E&D&!C1&!C&!B1&B&!A1&A|F&E&D&C1&!C&!B1&B&!A1&A|F&E&!D&C1&!C&!B1&B&!A1&A|F&E&!D&C1&C&!B1&B&!A1&A|F&E&D&C1&C&!B1&B&!A1&A|F&!E&D&C1&C&!B1&B&!A1&A|F&E&D&!C1&C&!B1&B&!A1&A|F&E&!D&!C1&C&!B1&B&!A1&A|F&E&!D&!C1&C&B1&B&!A1&A|F&E&D&!C1&C&B1&B&!A1&A|F&!E&D&!C1&C&B1&B&!A1&A|F&!E&D&C1&C&B1&B&!A1&A|F&E&D&C1&C&B1&B&!A1&A|F&E&!D&C1&C&B1&B&!A1&A|F&E&!D&C1&!C&B1&B&!A1&A|F&E&D&C1&!C&B1&B&!A1&A|F&!E&D&C1&!C&B1&B&!A1&A|F&!E&D&!C1&!C&B1&B&!A1&A|F&E&D&!C1&!C&B1&B&!A1&A|F&E&!D&!C1&!C&B1&B&!A1&A|F&E&!D&!C1&!C&B1&!B&!A1&A|F&E&D&!C1&!C&B1&!B&!A1&A|F&E&D&C1&!C&B1&!B&!A1&A|F&E&!D&C1&!C&B1&!B&!A1&A|F&E&!D&C1&C&B1&!B&!A1&A|F&E&D&C1&C&B1&!B&!A1&A|F&!E&D&C1&C&B1&!B&!A1&A|F&E&D&!C1&C&B1&!B&!A1&A|F&E&!D&!C1&C&B1&!B&!A1&A|F&E&!D&!C1&C&!B1&!B&!A1&A|F&E&D&!C1&C&!B1&!B&!A1&A|F&!E&D&C1&C&!B1&!B&!A1&A|F&E&D&C1&C&!B1&!B&!A1&A|F&E&!D&C1&C&!B1&!B&!A1&A|F&E&!D&C1&!C&!B1&!B&!A1&A|F&E&D&C1&!C&!B1&!B&!A1&A|F&E&D&!C1&!C&!B1&!B&!A1&A|F&E&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOAOAI222111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOOAI21132 -l AOAAOOAI21132 -i E1 E D2 D1 D C B A1 A -o Y -f Y=!(!E1&E&D2&D1&D&!C&!B&!A1&!A|E1&E&D2&D1&D&!C&!B&!A1&!A|E1&!E&D2&D1&D&!C&!B&!A1&!A|E1&!E&D2&D1&D&C&!B&!A1&!A|E1&E&D2&D1&D&C&!B&!A1&!A|!E1&E&D2&D1&D&C&!B&!A1&!A|E1&!E&!D2&!D1&!D&C&B&!A1&!A|E1&E&!D2&!D1&!D&C&B&!A1&!A|!E1&E&!D2&!D1&!D&C&B&!A1&!A|!E1&E&D2&!D1&!D&C&B&!A1&!A|E1&E&D2&!D1&!D&C&B&!A1&!A|E1&!E&D2&!D1&!D&C&B&!A1&!A|E1&!E&D2&D1&!D&C&B&!A1&!A|E1&E&D2&D1&!D&C&B&!A1&!A|!E1&E&D2&D1&!D&C&B&!A1&!A|!E1&E&!D2&D1&!D&C&B&!A1&!A|E1&E&!D2&D1&!D&C&B&!A1&!A|E1&!E&!D2&D1&!D&C&B&!A1&!A|E1&!E&!D2&D1&D&C&B&!A1&!A|E1&E&!D2&D1&D&C&B&!A1&!A|!E1&E&!D2&D1&D&C&B&!A1&!A|!E1&E&D2&D1&D&C&B&!A1&!A|E1&E&D2&D1&D&C&B&!A1&!A|E1&!E&D2&D1&D&C&B&!A1&!A|E1&!E&D2&!D1&D&C&B&!A1&!A|E1&E&D2&!D1&D&C&B&!A1&!A|!E1&E&D2&!D1&D&C&B&!A1&!A|!E1&E&!D2&!D1&D&C&B&!A1&!A|E1&E&!D2&!D1&D&C&B&!A1&!A|E1&!E&!D2&!D1&D&C&B&!A1&!A|E1&!E&D2&D1&D&!C&B&!A1&!A|E1&E&D2&D1&D&!C&B&!A1&!A|!E1&E&D2&D1&D&!C&B&!A1&!A|!E1&E&D2&D1&D&!C&B&A1&!A|E1&E&D2&D1&D&!C&B&A1&!A|E1&!E&D2&D1&D&!C&B&A1&!A|E1&!E&!D2&!D1&D&C&B&A1&!A|E1&E&!D2&!D1&D&C&B&A1&!A|!E1&E&!D2&!D1&D&C&B&A1&!A|!E1&E&D2&!D1&D&C&B&A1&!A|E1&E&D2&!D1&D&C&B&A1&!A|E1&!E&D2&!D1&D&C&B&A1&!A|E1&!E&D2&D1&D&C&B&A1&!A|E1&E&D2&D1&D&C&B&A1&!A|!E1&E&D2&D1&D&C&B&A1&!A|!E1&E&!D2&D1&D&C&B&A1&!A|E1&E&!D2&D1&D&C&B&A1&!A|E1&!E&!D2&D1&D&C&B&A1&!A|E1&!E&!D2&D1&!D&C&B&A1&!A|E1&E&!D2&D1&!D&C&B&A1&!A|!E1&E&!D2&D1&!D&C&B&A1&!A|!E1&E&D2&D1&!D&C&B&A1&!A|E1&E&D2&D1&!D&C&B&A1&!A|E1&!E&D2&D1&!D&C&B&A1&!A|E1&!E&D2&!D1&!D&C&B&A1&!A|E1&E&D2&!D1&!D&C&B&A1&!A|!E1&E&D2&!D1&!D&C&B&A1&!A|!E1&E&!D2&!D1&!D&C&B&A1&!A|E1&E&!D2&!D1&!D&C&B&A1&!A|E1&!E&!D2&!D1&!D&C&B&A1&!A|!E1&E&D2&D1&D&C&!B&A1&!A|E1&E&D2&D1&D&C&!B&A1&!A|E1&!E&D2&D1&D&C&!B&A1&!A|E1&!E&D2&D1&D&!C&!B&A1&!A|E1&E&D2&D1&D&!C&!B&A1&!A|!E1&E&D2&D1&D&!C&!B&A1&!A|!E1&E&D2&D1&D&!C&!B&A1&A|E1&E&D2&D1&D&!C&!B&A1&A|E1&!E&D2&D1&D&!C&!B&A1&A|E1&!E&!D2&!D1&D&C&!B&A1&A|E1&E&!D2&!D1&D&C&!B&A1&A|!E1&E&!D2&!D1&D&C&!B&A1&A|!E1&E&D2&!D1&D&C&!B&A1&A|E1&E&D2&!D1&D&C&!B&A1&A|E1&!E&D2&!D1&D&C&!B&A1&A|E1&!E&D2&D1&D&C&!B&A1&A|E1&E&D2&D1&D&C&!B&A1&A|!E1&E&D2&D1&D&C&!B&A1&A|!E1&E&!D2&D1&D&C&!B&A1&A|E1&E&!D2&D1&D&C&!B&A1&A|E1&!E&!D2&D1&D&C&!B&A1&A|E1&!E&!D2&D1&!D&C&!B&A1&A|E1&E&!D2&D1&!D&C&!B&A1&A|!E1&E&!D2&D1&!D&C&!B&A1&A|!E1&E&D2&D1&!D&C&!B&A1&A|E1&E&D2&D1&!D&C&!B&A1&A|E1&!E&D2&D1&!D&C&!B&A1&A|E1&!E&D2&!D1&!D&C&!B&A1&A|E1&E&D2&!D1&!D&C&!B&A1&A|!E1&E&D2&!D1&!D&C&!B&A1&A|!E1&E&!D2&!D1&!D&C&!B&A1&A|E1&E&!D2&!D1&!D&C&!B&A1&A|E1&!E&!D2&!D1&!D&C&!B&A1&A|E1&!E&!D2&!D1&!D&C&B&A1&A|E1&E&!D2&!D1&!D&C&B&A1&A|!E1&E&!D2&!D1&!D&C&B&A1&A|!E1&E&D2&!D1&!D&C&B&A1&A|E1&E&D2&!D1&!D&C&B&A1&A|E1&!E&D2&!D1&!D&C&B&A1&A|E1&!E&D2&D1&!D&C&B&A1&A|E1&E&D2&D1&!D&C&B&A1&A|!E1&E&D2&D1&!D&C&B&A1&A|!E1&E&!D2&D1&!D&C&B&A1&A|E1&E&!D2&D1&!D&C&B&A1&A|E1&!E&!D2&D1&!D&C&B&A1&A|E1&!E&!D2&D1&D&C&B&A1&A|E1&E&!D2&D1&D&C&B&A1&A|!E1&E&!D2&D1&D&C&B&A1&A|!E1&E&D2&D1&D&C&B&A1&A|E1&E&D2&D1&D&C&B&A1&A|E1&!E&D2&D1&D&C&B&A1&A|E1&!E&D2&!D1&D&C&B&A1&A|E1&E&D2&!D1&D&C&B&A1&A|!E1&E&D2&!D1&D&C&B&A1&A|!E1&E&!D2&!D1&D&C&B&A1&A|E1&E&!D2&!D1&D&C&B&A1&A|E1&!E&!D2&!D1&D&C&B&A1&A|E1&!E&D2&D1&D&!C&B&A1&A|E1&E&D2&D1&D&!C&B&A1&A|!E1&E&D2&D1&D&!C&B&A1&A|!E1&E&D2&D1&D&!C&B&!A1&A|E1&E&D2&D1&D&!C&B&!A1&A|E1&!E&D2&D1&D&!C&B&!A1&A|E1&!E&!D2&!D1&D&C&B&!A1&A|E1&E&!D2&!D1&D&C&B&!A1&A|!E1&E&!D2&!D1&D&C&B&!A1&A|!E1&E&D2&!D1&D&C&B&!A1&A|E1&E&D2&!D1&D&C&B&!A1&A|E1&!E&D2&!D1&D&C&B&!A1&A|E1&!E&D2&D1&D&C&B&!A1&A|E1&E&D2&D1&D&C&B&!A1&A|!E1&E&D2&D1&D&C&B&!A1&A|!E1&E&!D2&D1&D&C&B&!A1&A|E1&E&!D2&D1&D&C&B&!A1&A|E1&!E&!D2&D1&D&C&B&!A1&A|E1&!E&!D2&D1&!D&C&B&!A1&A|E1&E&!D2&D1&!D&C&B&!A1&A|!E1&E&!D2&D1&!D&C&B&!A1&A|!E1&E&D2&D1&!D&C&B&!A1&A|E1&E&D2&D1&!D&C&B&!A1&A|E1&!E&D2&D1&!D&C&B&!A1&A|E1&!E&D2&!D1&!D&C&B&!A1&A|E1&E&D2&!D1&!D&C&B&!A1&A|!E1&E&D2&!D1&!D&C&B&!A1&A|!E1&E&!D2&!D1&!D&C&B&!A1&A|E1&E&!D2&!D1&!D&C&B&!A1&A|E1&!E&!D2&!D1&!D&C&B&!A1&A|!E1&E&D2&D1&D&C&!B&!A1&A|E1&E&D2&D1&D&C&!B&!A1&A|E1&!E&D2&D1&D&C&!B&!A1&A|E1&!E&D2&D1&D&!C&!B&!A1&A|E1&E&D2&D1&D&!C&!B&!A1&A|!E1&E&D2&D1&D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOOAI21132.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAI2213 -l OAOOAI2213 -i D2 D1 D C B1 B A1 A -o Y -f Y=(!D2&!D1&!D&!C&!B1&!B&!A1&!A|D2&!D1&!D&!C&!B1&!B&!A1&!A|D2&D1&!D&!C&!B1&!B&!A1&!A|!D2&D1&!D&!C&!B1&!B&!A1&!A|!D2&D1&D&!C&!B1&!B&!A1&!A|D2&D1&D&!C&!B1&!B&!A1&!A|D2&!D1&D&!C&!B1&!B&!A1&!A|!D2&!D1&D&!C&!B1&!B&!A1&!A|!D2&!D1&!D&C&!B1&!B&!A1&!A|!D2&!D1&!D&C&B1&!B&!A1&!A|!D2&!D1&D&!C&B1&!B&!A1&!A|D2&!D1&D&!C&B1&!B&!A1&!A|D2&D1&D&!C&B1&!B&!A1&!A|!D2&D1&D&!C&B1&!B&!A1&!A|!D2&D1&!D&!C&B1&!B&!A1&!A|D2&D1&!D&!C&B1&!B&!A1&!A|D2&!D1&!D&!C&B1&!B&!A1&!A|!D2&!D1&!D&!C&B1&!B&!A1&!A|!D2&!D1&!D&!C&B1&B&!A1&!A|D2&!D1&!D&!C&B1&B&!A1&!A|D2&D1&!D&!C&B1&B&!A1&!A|!D2&D1&!D&!C&B1&B&!A1&!A|!D2&D1&D&!C&B1&B&!A1&!A|D2&D1&D&!C&B1&B&!A1&!A|D2&!D1&D&!C&B1&B&!A1&!A|!D2&!D1&D&!C&B1&B&!A1&!A|!D2&!D1&!D&C&B1&B&!A1&!A|!D2&!D1&!D&C&!B1&B&!A1&!A|!D2&!D1&D&!C&!B1&B&!A1&!A|D2&!D1&D&!C&!B1&B&!A1&!A|D2&D1&D&!C&!B1&B&!A1&!A|!D2&D1&D&!C&!B1&B&!A1&!A|!D2&D1&!D&!C&!B1&B&!A1&!A|D2&D1&!D&!C&!B1&B&!A1&!A|D2&!D1&!D&!C&!B1&B&!A1&!A|!D2&!D1&!D&!C&!B1&B&!A1&!A|!D2&!D1&!D&!C&!B1&B&A1&!A|D2&!D1&!D&!C&!B1&B&A1&!A|D2&D1&!D&!C&!B1&B&A1&!A|!D2&D1&!D&!C&!B1&B&A1&!A|!D2&D1&D&!C&!B1&B&A1&!A|D2&D1&D&!C&!B1&B&A1&!A|D2&!D1&D&!C&!B1&B&A1&!A|!D2&!D1&D&!C&!B1&B&A1&!A|!D2&!D1&!D&C&!B1&B&A1&!A|!D2&!D1&!D&C&B1&B&A1&!A|!D2&!D1&!D&!C&B1&B&A1&!A|!D2&!D1&!D&!C&B1&!B&A1&!A|D2&!D1&!D&!C&B1&!B&A1&!A|D2&D1&!D&!C&B1&!B&A1&!A|!D2&D1&!D&!C&B1&!B&A1&!A|!D2&D1&D&!C&B1&!B&A1&!A|D2&D1&D&!C&B1&!B&A1&!A|D2&!D1&D&!C&B1&!B&A1&!A|!D2&!D1&D&!C&B1&!B&A1&!A|!D2&!D1&!D&C&B1&!B&A1&!A|!D2&!D1&!D&C&!B1&!B&A1&!A|!D2&!D1&D&!C&!B1&!B&A1&!A|D2&!D1&D&!C&!B1&!B&A1&!A|D2&D1&D&!C&!B1&!B&A1&!A|!D2&D1&D&!C&!B1&!B&A1&!A|!D2&D1&!D&!C&!B1&!B&A1&!A|D2&D1&!D&!C&!B1&!B&A1&!A|D2&!D1&!D&!C&!B1&!B&A1&!A|!D2&!D1&!D&!C&!B1&!B&A1&!A|!D2&!D1&!D&!C&!B1&!B&A1&A|D2&!D1&!D&!C&!B1&!B&A1&A|D2&D1&!D&!C&!B1&!B&A1&A|!D2&D1&!D&!C&!B1&!B&A1&A|!D2&D1&D&!C&!B1&!B&A1&A|D2&D1&D&!C&!B1&!B&A1&A|D2&!D1&D&!C&!B1&!B&A1&A|!D2&!D1&D&!C&!B1&!B&A1&A|!D2&!D1&!D&C&!B1&!B&A1&A|!D2&!D1&!D&C&B1&!B&A1&A|!D2&!D1&D&!C&B1&!B&A1&A|D2&!D1&D&!C&B1&!B&A1&A|D2&D1&D&!C&B1&!B&A1&A|!D2&D1&D&!C&B1&!B&A1&A|!D2&D1&!D&!C&B1&!B&A1&A|D2&D1&!D&!C&B1&!B&A1&A|D2&!D1&!D&!C&B1&!B&A1&A|!D2&!D1&!D&!C&B1&!B&A1&A|!D2&!D1&!D&!C&B1&B&A1&A|!D2&!D1&!D&C&B1&B&A1&A|!D2&!D1&!D&C&!B1&B&A1&A|!D2&!D1&D&!C&!B1&B&A1&A|D2&!D1&D&!C&!B1&B&A1&A|D2&D1&D&!C&!B1&B&A1&A|!D2&D1&D&!C&!B1&B&A1&A|!D2&D1&!D&!C&!B1&B&A1&A|D2&D1&!D&!C&!B1&B&A1&A|D2&!D1&!D&!C&!B1&B&A1&A|!D2&!D1&!D&!C&!B1&B&A1&A|!D2&!D1&!D&!C&!B1&B&!A1&A|D2&!D1&!D&!C&!B1&B&!A1&A|D2&D1&!D&!C&!B1&B&!A1&A|!D2&D1&!D&!C&!B1&B&!A1&A|!D2&D1&D&!C&!B1&B&!A1&A|D2&D1&D&!C&!B1&B&!A1&A|D2&!D1&D&!C&!B1&B&!A1&A|!D2&!D1&D&!C&!B1&B&!A1&A|!D2&!D1&!D&C&!B1&B&!A1&A|!D2&!D1&!D&C&B1&B&!A1&A|!D2&!D1&!D&!C&B1&B&!A1&A|!D2&!D1&!D&!C&B1&!B&!A1&A|D2&!D1&!D&!C&B1&!B&!A1&A|D2&D1&!D&!C&B1&!B&!A1&A|!D2&D1&!D&!C&B1&!B&!A1&A|!D2&D1&D&!C&B1&!B&!A1&A|D2&D1&D&!C&B1&!B&!A1&A|D2&!D1&D&!C&B1&!B&!A1&A|!D2&!D1&D&!C&B1&!B&!A1&A|!D2&!D1&!D&C&B1&!B&!A1&A|!D2&!D1&!D&C&!B1&!B&!A1&A|!D2&!D1&D&!C&!B1&!B&!A1&A|D2&!D1&D&!C&!B1&!B&!A1&A|D2&D1&D&!C&!B1&!B&!A1&A|!D2&D1&D&!C&!B1&!B&!A1&A|!D2&D1&!D&!C&!B1&!B&!A1&A|D2&D1&!D&!C&!B1&!B&!A1&A|D2&!D1&!D&!C&!B1&!B&!A1&A|!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAI2213.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOI2231 -l OAAOI2231 -i D C2 C1 C B1 B A1 A -o Y -f Y=(!D&!C2&!C1&!C&!B1&!B&!A1&!A|!D&C2&!C1&!C&!B1&!B&!A1&!A|!D&C2&C1&!C&!B1&!B&!A1&!A|!D&!C2&C1&!C&!B1&!B&!A1&!A|!D&!C2&C1&C&!B1&!B&!A1&!A|!D&C2&!C1&C&!B1&!B&!A1&!A|!D&!C2&!C1&C&!B1&!B&!A1&!A|!D&!C2&!C1&C&B1&!B&!A1&!A|!D&C2&!C1&C&B1&!B&!A1&!A|!D&!C2&C1&C&B1&!B&!A1&!A|!D&!C2&C1&!C&B1&!B&!A1&!A|!D&C2&C1&!C&B1&!B&!A1&!A|!D&C2&!C1&!C&B1&!B&!A1&!A|!D&!C2&!C1&!C&B1&!B&!A1&!A|!D&!C2&!C1&!C&B1&B&!A1&!A|!D&C2&!C1&!C&B1&B&!A1&!A|!D&C2&C1&!C&B1&B&!A1&!A|!D&!C2&C1&!C&B1&B&!A1&!A|!D&!C2&C1&C&B1&B&!A1&!A|!D&C2&!C1&C&B1&B&!A1&!A|!D&!C2&!C1&C&B1&B&!A1&!A|!D&!C2&!C1&C&!B1&B&!A1&!A|!D&C2&!C1&C&!B1&B&!A1&!A|!D&!C2&C1&C&!B1&B&!A1&!A|!D&!C2&C1&!C&!B1&B&!A1&!A|!D&C2&C1&!C&!B1&B&!A1&!A|!D&C2&!C1&!C&!B1&B&!A1&!A|!D&!C2&!C1&!C&!B1&B&!A1&!A|!D&!C2&!C1&!C&!B1&B&A1&!A|!D&C2&!C1&!C&!B1&B&A1&!A|!D&C2&C1&!C&!B1&B&A1&!A|!D&!C2&C1&!C&!B1&B&A1&!A|!D&!C2&C1&C&!B1&B&A1&!A|!D&C2&!C1&C&!B1&B&A1&!A|!D&!C2&!C1&C&!B1&B&A1&!A|!D&!C2&!C1&!C&B1&!B&A1&!A|!D&C2&!C1&!C&B1&!B&A1&!A|!D&C2&C1&!C&B1&!B&A1&!A|!D&!C2&C1&!C&B1&!B&A1&!A|!D&!C2&C1&C&B1&!B&A1&!A|!D&C2&!C1&C&B1&!B&A1&!A|!D&!C2&!C1&C&B1&!B&A1&!A|!D&!C2&!C1&C&!B1&!B&A1&!A|!D&C2&!C1&C&!B1&!B&A1&!A|!D&!C2&C1&C&!B1&!B&A1&!A|!D&!C2&C1&!C&!B1&!B&A1&!A|!D&C2&C1&!C&!B1&!B&A1&!A|!D&C2&!C1&!C&!B1&!B&A1&!A|!D&!C2&!C1&!C&!B1&!B&A1&!A|!D&!C2&!C1&!C&!B1&!B&A1&A|!D&C2&!C1&!C&!B1&!B&A1&A|!D&C2&C1&!C&!B1&!B&A1&A|!D&!C2&C1&!C&!B1&!B&A1&A|!D&!C2&C1&C&!B1&!B&A1&A|!D&C2&!C1&C&!B1&!B&A1&A|!D&!C2&!C1&C&!B1&!B&A1&A|!D&!C2&!C1&C&B1&!B&A1&A|!D&C2&!C1&C&B1&!B&A1&A|!D&!C2&C1&C&B1&!B&A1&A|!D&!C2&C1&!C&B1&!B&A1&A|!D&C2&C1&!C&B1&!B&A1&A|!D&C2&!C1&!C&B1&!B&A1&A|!D&!C2&!C1&!C&B1&!B&A1&A|!D&!C2&!C1&C&!B1&B&A1&A|!D&C2&!C1&C&!B1&B&A1&A|!D&!C2&C1&C&!B1&B&A1&A|!D&!C2&C1&!C&!B1&B&A1&A|!D&C2&C1&!C&!B1&B&A1&A|!D&C2&!C1&!C&!B1&B&A1&A|!D&!C2&!C1&!C&!B1&B&A1&A|!D&!C2&!C1&!C&!B1&B&!A1&A|!D&C2&!C1&!C&!B1&B&!A1&A|!D&C2&C1&!C&!B1&B&!A1&A|!D&!C2&C1&!C&!B1&B&!A1&A|!D&!C2&C1&C&!B1&B&!A1&A|!D&C2&!C1&C&!B1&B&!A1&A|!D&!C2&!C1&C&!B1&B&!A1&A|!D&!C2&!C1&!C&B1&!B&!A1&A|!D&C2&!C1&!C&B1&!B&!A1&A|!D&C2&C1&!C&B1&!B&!A1&A|!D&!C2&C1&!C&B1&!B&!A1&A|!D&!C2&C1&C&B1&!B&!A1&A|!D&C2&!C1&C&B1&!B&!A1&A|!D&!C2&!C1&C&B1&!B&!A1&A|!D&!C2&!C1&C&!B1&!B&!A1&A|!D&C2&!C1&C&!B1&!B&!A1&A|!D&!C2&C1&C&!B1&!B&!A1&A|!D&!C2&C1&!C&!B1&!B&!A1&A|!D&C2&C1&!C&!B1&!B&!A1&A|!D&C2&!C1&!C&!B1&!B&!A1&A|!D&!C2&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOI2231.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOI2213 -l AAOAAOI2213 -i D2 D1 D C B1 B A1 A -o Y -f Y=!(D2&D1&D&!C&!B1&!B&!A1&!A|D2&D1&D&C&!B1&!B&!A1&!A|D2&D1&D&C&B1&!B&!A1&!A|D2&D1&D&!C&B1&!B&!A1&!A|D2&D1&D&!C&B1&B&!A1&!A|!D2&!D1&D&C&B1&B&!A1&!A|D2&!D1&D&C&B1&B&!A1&!A|D2&D1&D&C&B1&B&!A1&!A|!D2&D1&D&C&B1&B&!A1&!A|!D2&D1&!D&C&B1&B&!A1&!A|D2&D1&!D&C&B1&B&!A1&!A|D2&!D1&!D&C&B1&B&!A1&!A|!D2&!D1&!D&C&B1&B&!A1&!A|D2&D1&D&C&!B1&B&!A1&!A|D2&D1&D&!C&!B1&B&!A1&!A|D2&D1&D&!C&!B1&B&A1&!A|D2&D1&D&C&!B1&B&A1&!A|!D2&!D1&!D&C&B1&B&A1&!A|D2&!D1&!D&C&B1&B&A1&!A|D2&D1&!D&C&B1&B&A1&!A|!D2&D1&!D&C&B1&B&A1&!A|!D2&D1&D&C&B1&B&A1&!A|D2&D1&D&C&B1&B&A1&!A|D2&!D1&D&C&B1&B&A1&!A|!D2&!D1&D&C&B1&B&A1&!A|D2&D1&D&!C&B1&B&A1&!A|D2&D1&D&!C&B1&!B&A1&!A|D2&D1&D&C&B1&!B&A1&!A|D2&D1&D&C&!B1&!B&A1&!A|D2&D1&D&!C&!B1&!B&A1&!A|D2&D1&D&!C&!B1&!B&A1&A|!D2&!D1&D&C&!B1&!B&A1&A|D2&!D1&D&C&!B1&!B&A1&A|D2&D1&D&C&!B1&!B&A1&A|!D2&D1&D&C&!B1&!B&A1&A|!D2&D1&!D&C&!B1&!B&A1&A|D2&D1&!D&C&!B1&!B&A1&A|D2&!D1&!D&C&!B1&!B&A1&A|!D2&!D1&!D&C&!B1&!B&A1&A|!D2&!D1&!D&C&B1&!B&A1&A|D2&!D1&!D&C&B1&!B&A1&A|D2&D1&!D&C&B1&!B&A1&A|!D2&D1&!D&C&B1&!B&A1&A|!D2&D1&D&C&B1&!B&A1&A|D2&D1&D&C&B1&!B&A1&A|D2&!D1&D&C&B1&!B&A1&A|!D2&!D1&D&C&B1&!B&A1&A|D2&D1&D&!C&B1&!B&A1&A|D2&D1&D&!C&B1&B&A1&A|!D2&!D1&D&C&B1&B&A1&A|D2&!D1&D&C&B1&B&A1&A|D2&D1&D&C&B1&B&A1&A|!D2&D1&D&C&B1&B&A1&A|!D2&D1&!D&C&B1&B&A1&A|D2&D1&!D&C&B1&B&A1&A|D2&!D1&!D&C&B1&B&A1&A|!D2&!D1&!D&C&B1&B&A1&A|!D2&!D1&!D&C&!B1&B&A1&A|D2&!D1&!D&C&!B1&B&A1&A|D2&D1&!D&C&!B1&B&A1&A|!D2&D1&!D&C&!B1&B&A1&A|!D2&D1&D&C&!B1&B&A1&A|D2&D1&D&C&!B1&B&A1&A|D2&!D1&D&C&!B1&B&A1&A|!D2&!D1&D&C&!B1&B&A1&A|D2&D1&D&!C&!B1&B&A1&A|D2&D1&D&!C&!B1&B&!A1&A|D2&D1&D&C&!B1&B&!A1&A|!D2&!D1&!D&C&B1&B&!A1&A|D2&!D1&!D&C&B1&B&!A1&A|D2&D1&!D&C&B1&B&!A1&A|!D2&D1&!D&C&B1&B&!A1&A|!D2&D1&D&C&B1&B&!A1&A|D2&D1&D&C&B1&B&!A1&A|D2&!D1&D&C&B1&B&!A1&A|!D2&!D1&D&C&B1&B&!A1&A|D2&D1&D&!C&B1&B&!A1&A|D2&D1&D&!C&B1&!B&!A1&A|D2&D1&D&C&B1&!B&!A1&A|D2&D1&D&C&!B1&!B&!A1&A|D2&D1&D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOI2213.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOOAOI21221 -l AOOOAOI21221 -i E D1 D C1 C B A1 A -o Y -f Y=(!E&!D1&!D&!C1&!C&!B&!A1&!A|!E&D1&!D&!C1&!C&!B&!A1&!A|!E&D1&D&!C1&!C&!B&!A1&!A|!E&!D1&D&!C1&!C&!B&!A1&!A|!E&!D1&D&C1&!C&!B&!A1&!A|!E&D1&D&C1&!C&!B&!A1&!A|!E&D1&!D&C1&!C&!B&!A1&!A|!E&!D1&!D&C1&!C&!B&!A1&!A|!E&!D1&!D&C1&C&!B&!A1&!A|!E&D1&!D&C1&C&!B&!A1&!A|!E&D1&D&C1&C&!B&!A1&!A|!E&!D1&D&C1&C&!B&!A1&!A|!E&!D1&D&!C1&C&!B&!A1&!A|!E&D1&D&!C1&C&!B&!A1&!A|!E&D1&!D&!C1&C&!B&!A1&!A|!E&!D1&!D&!C1&C&!B&!A1&!A|!E&!D1&!D&!C1&C&B&!A1&!A|!E&!D1&!D&C1&C&B&!A1&!A|!E&!D1&!D&C1&!C&B&!A1&!A|!E&!D1&D&!C1&!C&B&!A1&!A|!E&D1&D&!C1&!C&B&!A1&!A|!E&D1&!D&!C1&!C&B&!A1&!A|!E&!D1&!D&!C1&!C&B&!A1&!A|!E&!D1&!D&!C1&!C&B&A1&!A|!E&D1&!D&!C1&!C&B&A1&!A|!E&D1&D&!C1&!C&B&A1&!A|!E&!D1&D&!C1&!C&B&A1&!A|!E&!D1&!D&C1&!C&B&A1&!A|!E&!D1&!D&C1&C&B&A1&!A|!E&!D1&!D&!C1&C&B&A1&!A|!E&!D1&!D&!C1&C&!B&A1&!A|!E&D1&!D&!C1&C&!B&A1&!A|!E&D1&D&!C1&C&!B&A1&!A|!E&!D1&D&!C1&C&!B&A1&!A|!E&!D1&D&C1&C&!B&A1&!A|!E&D1&D&C1&C&!B&A1&!A|!E&D1&!D&C1&C&!B&A1&!A|!E&!D1&!D&C1&C&!B&A1&!A|!E&!D1&!D&C1&!C&!B&A1&!A|!E&D1&!D&C1&!C&!B&A1&!A|!E&D1&D&C1&!C&!B&A1&!A|!E&!D1&D&C1&!C&!B&A1&!A|!E&!D1&D&!C1&!C&!B&A1&!A|!E&D1&D&!C1&!C&!B&A1&!A|!E&D1&!D&!C1&!C&!B&A1&!A|!E&!D1&!D&!C1&!C&!B&A1&!A|!E&!D1&!D&!C1&!C&!B&A1&A|!E&D1&!D&!C1&!C&!B&A1&A|!E&D1&D&!C1&!C&!B&A1&A|!E&!D1&D&!C1&!C&!B&A1&A|!E&!D1&!D&C1&!C&!B&A1&A|!E&!D1&!D&C1&C&!B&A1&A|!E&!D1&!D&!C1&C&!B&A1&A|!E&!D1&!D&!C1&C&B&A1&A|!E&!D1&!D&C1&C&B&A1&A|!E&!D1&!D&C1&!C&B&A1&A|!E&!D1&D&!C1&!C&B&A1&A|!E&D1&D&!C1&!C&B&A1&A|!E&D1&!D&!C1&!C&B&A1&A|!E&!D1&!D&!C1&!C&B&A1&A|!E&!D1&!D&!C1&!C&B&!A1&A|!E&D1&!D&!C1&!C&B&!A1&A|!E&D1&D&!C1&!C&B&!A1&A|!E&!D1&D&!C1&!C&B&!A1&A|!E&!D1&!D&C1&!C&B&!A1&A|!E&!D1&!D&C1&C&B&!A1&A|!E&!D1&!D&!C1&C&B&!A1&A|!E&!D1&!D&!C1&C&!B&!A1&A|!E&D1&!D&!C1&C&!B&!A1&A|!E&D1&D&!C1&C&!B&!A1&A|!E&!D1&D&!C1&C&!B&!A1&A|!E&!D1&D&C1&C&!B&!A1&A|!E&D1&D&C1&C&!B&!A1&A|!E&D1&!D&C1&C&!B&!A1&A|!E&!D1&!D&C1&C&!B&!A1&A|!E&!D1&!D&C1&!C&!B&!A1&A|!E&D1&!D&C1&!C&!B&!A1&A|!E&D1&D&C1&!C&!B&!A1&A|!E&!D1&D&C1&!C&!B&!A1&A|!E&!D1&D&!C1&!C&!B&!A1&A|!E&D1&D&!C1&!C&!B&!A1&A|!E&D1&!D&!C1&!C&!B&!A1&A|!E&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOOAOI21221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOI22 -l AOI22 -i B1 B A1 A -o Y -f Y=(!B1&!B&!A1&!A|!B1&!B&A1&!A|!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOI22.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOOAOI221211 -l OOAOOAOI221211 -i F E D1 D C B1 B A1 A -o Y -f Y=(!F&!E&!D1&!D&!C&!B1&!B&!A1&!A|!F&E&!D1&!D&!C&!B1&!B&!A1&!A|!F&E&D1&!D&!C&!B1&!B&!A1&!A|!F&!E&D1&!D&!C&!B1&!B&!A1&!A|!F&!E&D1&D&!C&!B1&!B&!A1&!A|!F&E&D1&D&!C&!B1&!B&!A1&!A|!F&E&!D1&D&!C&!B1&!B&!A1&!A|!F&!E&!D1&D&!C&!B1&!B&!A1&!A|!F&!E&!D1&D&C&!B1&!B&!A1&!A|!F&!E&D1&D&C&!B1&!B&!A1&!A|!F&!E&D1&!D&C&!B1&!B&!A1&!A|!F&E&!D1&!D&C&!B1&!B&!A1&!A|!F&!E&!D1&!D&C&!B1&!B&!A1&!A|!F&!E&!D1&!D&C&B1&!B&!A1&!A|!F&E&!D1&!D&C&B1&!B&!A1&!A|!F&!E&D1&!D&C&B1&!B&!A1&!A|!F&!E&D1&D&C&B1&!B&!A1&!A|!F&!E&!D1&D&C&B1&!B&!A1&!A|!F&!E&!D1&D&!C&B1&!B&!A1&!A|!F&E&!D1&D&!C&B1&!B&!A1&!A|!F&E&D1&D&!C&B1&!B&!A1&!A|!F&!E&D1&D&!C&B1&!B&!A1&!A|!F&!E&D1&!D&!C&B1&!B&!A1&!A|!F&E&D1&!D&!C&B1&!B&!A1&!A|!F&E&!D1&!D&!C&B1&!B&!A1&!A|!F&!E&!D1&!D&!C&B1&!B&!A1&!A|!F&!E&!D1&!D&!C&B1&B&!A1&!A|!F&E&!D1&!D&!C&B1&B&!A1&!A|!F&E&D1&!D&!C&B1&B&!A1&!A|!F&!E&D1&!D&!C&B1&B&!A1&!A|!F&!E&D1&D&!C&B1&B&!A1&!A|!F&E&D1&D&!C&B1&B&!A1&!A|!F&E&!D1&D&!C&B1&B&!A1&!A|!F&!E&!D1&D&!C&B1&B&!A1&!A|!F&!E&!D1&D&C&B1&B&!A1&!A|!F&!E&D1&D&C&B1&B&!A1&!A|!F&!E&D1&!D&C&B1&B&!A1&!A|!F&E&!D1&!D&C&B1&B&!A1&!A|!F&!E&!D1&!D&C&B1&B&!A1&!A|!F&!E&!D1&!D&C&!B1&B&!A1&!A|!F&E&!D1&!D&C&!B1&B&!A1&!A|!F&!E&D1&!D&C&!B1&B&!A1&!A|!F&!E&D1&D&C&!B1&B&!A1&!A|!F&!E&!D1&D&C&!B1&B&!A1&!A|!F&!E&!D1&D&!C&!B1&B&!A1&!A|!F&E&!D1&D&!C&!B1&B&!A1&!A|!F&E&D1&D&!C&!B1&B&!A1&!A|!F&!E&D1&D&!C&!B1&B&!A1&!A|!F&!E&D1&!D&!C&!B1&B&!A1&!A|!F&E&D1&!D&!C&!B1&B&!A1&!A|!F&E&!D1&!D&!C&!B1&B&!A1&!A|!F&!E&!D1&!D&!C&!B1&B&!A1&!A|!F&!E&!D1&!D&!C&!B1&B&A1&!A|!F&E&!D1&!D&!C&!B1&B&A1&!A|!F&!E&D1&!D&!C&!B1&B&A1&!A|!F&!E&D1&D&!C&!B1&B&A1&!A|!F&!E&!D1&D&!C&!B1&B&A1&!A|!F&!E&!D1&D&C&!B1&B&A1&!A|!F&!E&D1&D&C&!B1&B&A1&!A|!F&!E&D1&!D&C&!B1&B&A1&!A|!F&E&!D1&!D&C&!B1&B&A1&!A|!F&!E&!D1&!D&C&!B1&B&A1&!A|!F&!E&!D1&!D&C&B1&B&A1&!A|!F&E&!D1&!D&C&B1&B&A1&!A|!F&!E&D1&!D&C&B1&B&A1&!A|!F&!E&D1&D&C&B1&B&A1&!A|!F&!E&!D1&D&C&B1&B&A1&!A|!F&!E&!D1&D&!C&B1&B&A1&!A|!F&!E&D1&D&!C&B1&B&A1&!A|!F&!E&D1&!D&!C&B1&B&A1&!A|!F&E&!D1&!D&!C&B1&B&A1&!A|!F&!E&!D1&!D&!C&B1&B&A1&!A|!F&!E&!D1&!D&!C&B1&!B&A1&!A|!F&E&!D1&!D&!C&B1&!B&A1&!A|!F&!E&D1&!D&!C&B1&!B&A1&!A|!F&!E&D1&D&!C&B1&!B&A1&!A|!F&!E&!D1&D&!C&B1&!B&A1&!A|!F&!E&!D1&D&C&B1&!B&A1&!A|!F&!E&D1&D&C&B1&!B&A1&!A|!F&!E&D1&!D&C&B1&!B&A1&!A|!F&E&!D1&!D&C&B1&!B&A1&!A|!F&!E&!D1&!D&C&B1&!B&A1&!A|!F&!E&!D1&!D&C&!B1&!B&A1&!A|!F&E&!D1&!D&C&!B1&!B&A1&!A|!F&!E&D1&!D&C&!B1&!B&A1&!A|!F&!E&D1&D&C&!B1&!B&A1&!A|!F&!E&!D1&D&C&!B1&!B&A1&!A|!F&!E&!D1&D&!C&!B1&!B&A1&!A|!F&E&!D1&D&!C&!B1&!B&A1&!A|!F&E&D1&D&!C&!B1&!B&A1&!A|!F&!E&D1&D&!C&!B1&!B&A1&!A|!F&!E&D1&!D&!C&!B1&!B&A1&!A|!F&E&D1&!D&!C&!B1&!B&A1&!A|!F&E&!D1&!D&!C&!B1&!B&A1&!A|!F&!E&!D1&!D&!C&!B1&!B&A1&!A|!F&!E&!D1&!D&!C&!B1&!B&A1&A|!F&E&!D1&!D&!C&!B1&!B&A1&A|!F&E&D1&!D&!C&!B1&!B&A1&A|!F&!E&D1&!D&!C&!B1&!B&A1&A|!F&!E&D1&D&!C&!B1&!B&A1&A|!F&E&D1&D&!C&!B1&!B&A1&A|!F&E&!D1&D&!C&!B1&!B&A1&A|!F&!E&!D1&D&!C&!B1&!B&A1&A|!F&!E&!D1&D&C&!B1&!B&A1&A|!F&!E&D1&D&C&!B1&!B&A1&A|!F&!E&D1&!D&C&!B1&!B&A1&A|!F&E&!D1&!D&C&!B1&!B&A1&A|!F&!E&!D1&!D&C&!B1&!B&A1&A|!F&!E&!D1&!D&C&B1&!B&A1&A|!F&E&!D1&!D&C&B1&!B&A1&A|!F&!E&D1&!D&C&B1&!B&A1&A|!F&!E&D1&D&C&B1&!B&A1&A|!F&!E&!D1&D&C&B1&!B&A1&A|!F&!E&!D1&D&!C&B1&!B&A1&A|!F&!E&D1&D&!C&B1&!B&A1&A|!F&!E&D1&!D&!C&B1&!B&A1&A|!F&E&!D1&!D&!C&B1&!B&A1&A|!F&!E&!D1&!D&!C&B1&!B&A1&A|!F&!E&!D1&!D&!C&B1&B&A1&A|!F&E&!D1&!D&!C&B1&B&A1&A|!F&!E&D1&!D&!C&B1&B&A1&A|!F&!E&D1&D&!C&B1&B&A1&A|!F&!E&!D1&D&!C&B1&B&A1&A|!F&!E&!D1&D&C&B1&B&A1&A|!F&!E&D1&D&C&B1&B&A1&A|!F&!E&D1&!D&C&B1&B&A1&A|!F&E&!D1&!D&C&B1&B&A1&A|!F&!E&!D1&!D&C&B1&B&A1&A|!F&!E&!D1&!D&C&!B1&B&A1&A|!F&E&!D1&!D&C&!B1&B&A1&A|!F&!E&D1&!D&C&!B1&B&A1&A|!F&!E&D1&D&C&!B1&B&A1&A|!F&!E&!D1&D&C&!B1&B&A1&A|!F&!E&!D1&D&!C&!B1&B&A1&A|!F&!E&D1&D&!C&!B1&B&A1&A|!F&!E&D1&!D&!C&!B1&B&A1&A|!F&E&!D1&!D&!C&!B1&B&A1&A|!F&!E&!D1&!D&!C&!B1&B&A1&A|!F&!E&!D1&!D&!C&!B1&B&!A1&A|!F&E&!D1&!D&!C&!B1&B&!A1&A|!F&!E&D1&!D&!C&!B1&B&!A1&A|!F&!E&D1&D&!C&!B1&B&!A1&A|!F&!E&!D1&D&!C&!B1&B&!A1&A|!F&!E&!D1&D&C&!B1&B&!A1&A|!F&!E&D1&D&C&!B1&B&!A1&A|!F&!E&D1&!D&C&!B1&B&!A1&A|!F&E&!D1&!D&C&!B1&B&!A1&A|!F&!E&!D1&!D&C&!B1&B&!A1&A|!F&!E&!D1&!D&C&B1&B&!A1&A|!F&E&!D1&!D&C&B1&B&!A1&A|!F&!E&D1&!D&C&B1&B&!A1&A|!F&!E&D1&D&C&B1&B&!A1&A|!F&!E&!D1&D&C&B1&B&!A1&A|!F&!E&!D1&D&!C&B1&B&!A1&A|!F&!E&D1&D&!C&B1&B&!A1&A|!F&!E&D1&!D&!C&B1&B&!A1&A|!F&E&!D1&!D&!C&B1&B&!A1&A|!F&!E&!D1&!D&!C&B1&B&!A1&A|!F&!E&!D1&!D&!C&B1&!B&!A1&A|!F&E&!D1&!D&!C&B1&!B&!A1&A|!F&!E&D1&!D&!C&B1&!B&!A1&A|!F&!E&D1&D&!C&B1&!B&!A1&A|!F&!E&!D1&D&!C&B1&!B&!A1&A|!F&!E&!D1&D&C&B1&!B&!A1&A|!F&!E&D1&D&C&B1&!B&!A1&A|!F&!E&D1&!D&C&B1&!B&!A1&A|!F&E&!D1&!D&C&B1&!B&!A1&A|!F&!E&!D1&!D&C&B1&!B&!A1&A|!F&!E&!D1&!D&C&!B1&!B&!A1&A|!F&E&!D1&!D&C&!B1&!B&!A1&A|!F&!E&D1&!D&C&!B1&!B&!A1&A|!F&!E&D1&D&C&!B1&!B&!A1&A|!F&!E&!D1&D&C&!B1&!B&!A1&A|!F&!E&!D1&D&!C&!B1&!B&!A1&A|!F&E&!D1&D&!C&!B1&!B&!A1&A|!F&E&D1&D&!C&!B1&!B&!A1&A|!F&!E&D1&D&!C&!B1&!B&!A1&A|!F&!E&D1&!D&!C&!B1&!B&!A1&A|!F&E&D1&!D&!C&!B1&!B&!A1&A|!F&E&!D1&!D&!C&!B1&!B&!A1&A|!F&!E&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOOAOI221211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOI2123 -l AOOAAOI2123 -i D2 D1 D C1 C B A1 A -o Y -f Y=(!D2&!D1&!D&!C1&!C&!B&!A1&!A|D2&!D1&!D&!C1&!C&!B&!A1&!A|D2&D1&!D&!C1&!C&!B&!A1&!A|!D2&D1&!D&!C1&!C&!B&!A1&!A|!D2&D1&D&!C1&!C&!B&!A1&!A|D2&!D1&D&!C1&!C&!B&!A1&!A|!D2&!D1&D&!C1&!C&!B&!A1&!A|!D2&!D1&D&C1&!C&!B&!A1&!A|D2&!D1&D&C1&!C&!B&!A1&!A|!D2&D1&D&C1&!C&!B&!A1&!A|!D2&D1&!D&C1&!C&!B&!A1&!A|D2&D1&!D&C1&!C&!B&!A1&!A|D2&!D1&!D&C1&!C&!B&!A1&!A|!D2&!D1&!D&C1&!C&!B&!A1&!A|!D2&!D1&!D&C1&C&!B&!A1&!A|D2&!D1&!D&C1&C&!B&!A1&!A|D2&D1&!D&C1&C&!B&!A1&!A|!D2&D1&!D&C1&C&!B&!A1&!A|!D2&D1&D&C1&C&!B&!A1&!A|D2&!D1&D&C1&C&!B&!A1&!A|!D2&!D1&D&C1&C&!B&!A1&!A|!D2&!D1&D&!C1&C&!B&!A1&!A|D2&!D1&D&!C1&C&!B&!A1&!A|!D2&D1&D&!C1&C&!B&!A1&!A|!D2&D1&!D&!C1&C&!B&!A1&!A|D2&D1&!D&!C1&C&!B&!A1&!A|D2&!D1&!D&!C1&C&!B&!A1&!A|!D2&!D1&!D&!C1&C&!B&!A1&!A|!D2&!D1&D&!C1&!C&B&!A1&!A|D2&!D1&D&!C1&!C&B&!A1&!A|!D2&D1&D&!C1&!C&B&!A1&!A|!D2&D1&!D&!C1&!C&B&!A1&!A|D2&D1&!D&!C1&!C&B&!A1&!A|D2&!D1&!D&!C1&!C&B&!A1&!A|!D2&!D1&!D&!C1&!C&B&!A1&!A|!D2&!D1&!D&!C1&!C&B&A1&!A|D2&!D1&!D&!C1&!C&B&A1&!A|D2&D1&!D&!C1&!C&B&A1&!A|!D2&D1&!D&!C1&!C&B&A1&!A|!D2&D1&D&!C1&!C&B&A1&!A|D2&!D1&D&!C1&!C&B&A1&!A|!D2&!D1&D&!C1&!C&B&A1&!A|!D2&!D1&!D&!C1&C&!B&A1&!A|D2&!D1&!D&!C1&C&!B&A1&!A|D2&D1&!D&!C1&C&!B&A1&!A|!D2&D1&!D&!C1&C&!B&A1&!A|!D2&D1&D&!C1&C&!B&A1&!A|D2&!D1&D&!C1&C&!B&A1&!A|!D2&!D1&D&!C1&C&!B&A1&!A|!D2&!D1&D&C1&C&!B&A1&!A|D2&!D1&D&C1&C&!B&A1&!A|!D2&D1&D&C1&C&!B&A1&!A|!D2&D1&!D&C1&C&!B&A1&!A|D2&D1&!D&C1&C&!B&A1&!A|D2&!D1&!D&C1&C&!B&A1&!A|!D2&!D1&!D&C1&C&!B&A1&!A|!D2&!D1&!D&C1&!C&!B&A1&!A|D2&!D1&!D&C1&!C&!B&A1&!A|D2&D1&!D&C1&!C&!B&A1&!A|!D2&D1&!D&C1&!C&!B&A1&!A|!D2&D1&D&C1&!C&!B&A1&!A|D2&!D1&D&C1&!C&!B&A1&!A|!D2&!D1&D&C1&!C&!B&A1&!A|!D2&!D1&D&!C1&!C&!B&A1&!A|D2&!D1&D&!C1&!C&!B&A1&!A|!D2&D1&D&!C1&!C&!B&A1&!A|!D2&D1&!D&!C1&!C&!B&A1&!A|D2&D1&!D&!C1&!C&!B&A1&!A|D2&!D1&!D&!C1&!C&!B&A1&!A|!D2&!D1&!D&!C1&!C&!B&A1&!A|!D2&!D1&!D&!C1&!C&!B&A1&A|D2&!D1&!D&!C1&!C&!B&A1&A|D2&D1&!D&!C1&!C&!B&A1&A|!D2&D1&!D&!C1&!C&!B&A1&A|!D2&D1&D&!C1&!C&!B&A1&A|D2&!D1&D&!C1&!C&!B&A1&A|!D2&!D1&D&!C1&!C&!B&A1&A|!D2&!D1&D&!C1&!C&B&A1&A|D2&!D1&D&!C1&!C&B&A1&A|!D2&D1&D&!C1&!C&B&A1&A|!D2&D1&!D&!C1&!C&B&A1&A|D2&D1&!D&!C1&!C&B&A1&A|D2&!D1&!D&!C1&!C&B&A1&A|!D2&!D1&!D&!C1&!C&B&A1&A|!D2&!D1&!D&!C1&!C&B&!A1&A|D2&!D1&!D&!C1&!C&B&!A1&A|D2&D1&!D&!C1&!C&B&!A1&A|!D2&D1&!D&!C1&!C&B&!A1&A|!D2&D1&D&!C1&!C&B&!A1&A|D2&!D1&D&!C1&!C&B&!A1&A|!D2&!D1&D&!C1&!C&B&!A1&A|!D2&!D1&!D&!C1&C&!B&!A1&A|D2&!D1&!D&!C1&C&!B&!A1&A|D2&D1&!D&!C1&C&!B&!A1&A|!D2&D1&!D&!C1&C&!B&!A1&A|!D2&D1&D&!C1&C&!B&!A1&A|D2&!D1&D&!C1&C&!B&!A1&A|!D2&!D1&D&!C1&C&!B&!A1&A|!D2&!D1&D&C1&C&!B&!A1&A|D2&!D1&D&C1&C&!B&!A1&A|!D2&D1&D&C1&C&!B&!A1&A|!D2&D1&!D&C1&C&!B&!A1&A|D2&D1&!D&C1&C&!B&!A1&A|D2&!D1&!D&C1&C&!B&!A1&A|!D2&!D1&!D&C1&C&!B&!A1&A|!D2&!D1&!D&C1&!C&!B&!A1&A|D2&!D1&!D&C1&!C&!B&!A1&A|D2&D1&!D&C1&!C&!B&!A1&A|!D2&D1&!D&C1&!C&!B&!A1&A|!D2&D1&D&C1&!C&!B&!A1&A|D2&!D1&D&C1&!C&!B&!A1&A|!D2&!D1&D&C1&!C&!B&!A1&A|!D2&!D1&D&!C1&!C&!B&!A1&A|D2&!D1&D&!C1&!C&!B&!A1&A|!D2&D1&D&!C1&!C&!B&!A1&A|!D2&D1&!D&!C1&!C&!B&!A1&A|D2&D1&!D&!C1&!C&!B&!A1&A|D2&!D1&!D&!C1&!C&!B&!A1&A|!D2&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOI2123.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOOAOAI222311 -l OOAAOOAOAI222311 -i F E D2 D1 D C1 C B1 B A1 A -o Y -f Y=!(F&E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|F&E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|F&E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|F&E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|F&E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|F&E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|F&E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|F&E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|F&E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|F&E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|F&E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|F&E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|F&E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|F&E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|F&!E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|F&!E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|F&E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|F&E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|F&!E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|F&!E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|F&E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|F&E&D2&D1&D&C1&C&!B1&!B&!A1&!A|F&!E&D2&D1&D&C1&C&!B1&!B&!A1&!A|F&!E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|F&E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|F&E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|F&!E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|F&E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|F&E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|F&E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|F&E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|F&E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|F&E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|F&E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|F&E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|F&E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|F&E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|F&E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|F&E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|F&E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|F&E&D2&D1&D&!C1&C&B1&!B&!A1&!A|F&E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|F&E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|F&!E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|F&E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|F&E&D2&!D1&D&C1&C&B1&!B&!A1&!A|F&!E&D2&!D1&D&C1&C&B1&!B&!A1&!A|F&!E&D2&D1&D&C1&C&B1&!B&!A1&!A|F&E&D2&D1&D&C1&C&B1&!B&!A1&!A|F&E&!D2&D1&D&C1&C&B1&!B&!A1&!A|F&!E&!D2&D1&D&C1&C&B1&!B&!A1&!A|F&!E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|F&E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|F&E&D2&D1&!D&C1&C&B1&!B&!A1&!A|F&!E&D2&D1&!D&C1&C&B1&!B&!A1&!A|F&!E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|F&E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|F&E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|F&E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|F&E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|F&E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|F&E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|F&E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|F&E&D2&D1&D&C1&!C&B1&!B&!A1&!A|F&E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|F&E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|F&E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|F&E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|F&E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|F&E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|F&E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|F&E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|F&E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|F&E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|F&E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|F&E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|F&E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|F&E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|F&E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|F&E&D2&D1&D&!C1&!C&B1&B&!A1&!A|F&E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|F&E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|F&E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|F&E&D2&!D1&D&C1&!C&B1&B&!A1&!A|F&E&D2&D1&D&C1&!C&B1&B&!A1&!A|F&E&!D2&D1&D&C1&!C&B1&B&!A1&!A|F&E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|F&E&D2&D1&!D&C1&!C&B1&B&!A1&!A|F&E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|F&E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|F&E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|F&E&D2&!D1&!D&C1&C&B1&B&!A1&!A|F&!E&D2&!D1&!D&C1&C&B1&B&!A1&!A|F&!E&D2&D1&!D&C1&C&B1&B&!A1&!A|F&E&D2&D1&!D&C1&C&B1&B&!A1&!A|F&E&!D2&D1&!D&C1&C&B1&B&!A1&!A|F&!E&!D2&D1&!D&C1&C&B1&B&!A1&!A|F&!E&!D2&D1&D&C1&C&B1&B&!A1&!A|F&E&!D2&D1&D&C1&C&B1&B&!A1&!A|F&E&D2&D1&D&C1&C&B1&B&!A1&!A|F&!E&D2&D1&D&C1&C&B1&B&!A1&!A|F&!E&D2&!D1&D&C1&C&B1&B&!A1&!A|F&E&D2&!D1&D&C1&C&B1&B&!A1&!A|F&E&!D2&!D1&D&C1&C&B1&B&!A1&!A|F&!E&!D2&!D1&D&C1&C&B1&B&!A1&!A|F&E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|F&E&D2&!D1&D&!C1&C&B1&B&!A1&!A|F&E&D2&D1&D&!C1&C&B1&B&!A1&!A|F&E&!D2&D1&D&!C1&C&B1&B&!A1&!A|F&E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|F&E&D2&D1&!D&!C1&C&B1&B&!A1&!A|F&E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|F&E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|F&E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|F&E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|F&E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|F&E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|F&E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|F&E&D2&D1&D&!C1&C&!B1&B&!A1&!A|F&E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|F&E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|F&!E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|F&E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|F&E&D2&!D1&D&C1&C&!B1&B&!A1&!A|F&!E&D2&!D1&D&C1&C&!B1&B&!A1&!A|F&!E&D2&D1&D&C1&C&!B1&B&!A1&!A|F&E&D2&D1&D&C1&C&!B1&B&!A1&!A|F&E&!D2&D1&D&C1&C&!B1&B&!A1&!A|F&!E&!D2&D1&D&C1&C&!B1&B&!A1&!A|F&!E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|F&E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|F&E&D2&D1&!D&C1&C&!B1&B&!A1&!A|F&!E&D2&D1&!D&C1&C&!B1&B&!A1&!A|F&!E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|F&E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|F&E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|F&E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|F&E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|F&E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|F&E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|F&E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|F&E&D2&D1&D&C1&!C&!B1&B&!A1&!A|F&E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|F&E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|F&E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|F&E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|F&E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|F&E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|F&E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|F&E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|F&E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|F&E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|F&E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|F&E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|F&!E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|F&!E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|F&E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|F&E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|F&!E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|F&!E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|F&E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|F&E&D2&D1&D&!C1&!C&!B1&B&A1&!A|F&!E&D2&D1&D&!C1&!C&!B1&B&A1&!A|F&!E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|F&E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|F&E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|F&!E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|F&!E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|F&E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|F&E&D2&!D1&D&C1&!C&!B1&B&A1&!A|F&!E&D2&!D1&D&C1&!C&!B1&B&A1&!A|F&!E&D2&D1&D&C1&!C&!B1&B&A1&!A|F&E&D2&D1&D&C1&!C&!B1&B&A1&!A|F&E&!D2&D1&D&C1&!C&!B1&B&A1&!A|F&!E&!D2&D1&D&C1&!C&!B1&B&A1&!A|F&!E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|F&E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|F&E&D2&D1&!D&C1&!C&!B1&B&A1&!A|F&!E&D2&D1&!D&C1&!C&!B1&B&A1&!A|F&!E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|F&E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|F&E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|F&E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|F&E&D2&!D1&!D&C1&C&!B1&B&A1&!A|F&!E&D2&!D1&!D&C1&C&!B1&B&A1&!A|F&!E&D2&D1&!D&C1&C&!B1&B&A1&!A|F&E&D2&D1&!D&C1&C&!B1&B&A1&!A|F&E&!D2&D1&!D&C1&C&!B1&B&A1&!A|F&!E&!D2&D1&!D&C1&C&!B1&B&A1&!A|F&!E&!D2&D1&D&C1&C&!B1&B&A1&!A|F&E&!D2&D1&D&C1&C&!B1&B&A1&!A|F&E&D2&D1&D&C1&C&!B1&B&A1&!A|F&!E&D2&D1&D&C1&C&!B1&B&A1&!A|F&!E&D2&!D1&D&C1&C&!B1&B&A1&!A|F&E&D2&!D1&D&C1&C&!B1&B&A1&!A|F&E&!D2&!D1&D&C1&C&!B1&B&A1&!A|F&!E&!D2&!D1&D&C1&C&!B1&B&A1&!A|F&!E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|F&E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|F&E&D2&!D1&D&!C1&C&!B1&B&A1&!A|F&!E&D2&!D1&D&!C1&C&!B1&B&A1&!A|F&!E&D2&D1&D&!C1&C&!B1&B&A1&!A|F&E&D2&D1&D&!C1&C&!B1&B&A1&!A|F&E&!D2&D1&D&!C1&C&!B1&B&A1&!A|F&!E&!D2&D1&D&!C1&C&!B1&B&A1&!A|F&!E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|F&E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|F&E&D2&D1&!D&!C1&C&!B1&B&A1&!A|F&!E&D2&D1&!D&!C1&C&!B1&B&A1&!A|F&!E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|F&E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|F&E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|F&E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|F&E&D2&!D1&!D&!C1&C&B1&B&A1&!A|F&!E&D2&!D1&!D&!C1&C&B1&B&A1&!A|F&!E&D2&D1&!D&!C1&C&B1&B&A1&!A|F&E&D2&D1&!D&!C1&C&B1&B&A1&!A|F&E&!D2&D1&!D&!C1&C&B1&B&A1&!A|F&!E&!D2&D1&!D&!C1&C&B1&B&A1&!A|F&!E&!D2&D1&D&!C1&C&B1&B&A1&!A|F&E&!D2&D1&D&!C1&C&B1&B&A1&!A|F&E&D2&D1&D&!C1&C&B1&B&A1&!A|F&!E&D2&D1&D&!C1&C&B1&B&A1&!A|F&!E&D2&!D1&D&!C1&C&B1&B&A1&!A|F&E&D2&!D1&D&!C1&C&B1&B&A1&!A|F&E&!D2&!D1&D&!C1&C&B1&B&A1&!A|F&!E&!D2&!D1&D&!C1&C&B1&B&A1&!A|F&!E&!D2&!D1&D&C1&C&B1&B&A1&!A|F&E&!D2&!D1&D&C1&C&B1&B&A1&!A|F&E&D2&!D1&D&C1&C&B1&B&A1&!A|F&!E&D2&!D1&D&C1&C&B1&B&A1&!A|F&!E&D2&D1&D&C1&C&B1&B&A1&!A|F&E&D2&D1&D&C1&C&B1&B&A1&!A|F&E&!D2&D1&D&C1&C&B1&B&A1&!A|F&!E&!D2&D1&D&C1&C&B1&B&A1&!A|F&!E&!D2&D1&!D&C1&C&B1&B&A1&!A|F&E&!D2&D1&!D&C1&C&B1&B&A1&!A|F&E&D2&D1&!D&C1&C&B1&B&A1&!A|F&!E&D2&D1&!D&C1&C&B1&B&A1&!A|F&!E&D2&!D1&!D&C1&C&B1&B&A1&!A|F&E&D2&!D1&!D&C1&C&B1&B&A1&!A|F&E&!D2&!D1&!D&C1&C&B1&B&A1&!A|F&E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|F&E&D2&!D1&!D&C1&!C&B1&B&A1&!A|F&!E&D2&!D1&!D&C1&!C&B1&B&A1&!A|F&!E&D2&D1&!D&C1&!C&B1&B&A1&!A|F&E&D2&D1&!D&C1&!C&B1&B&A1&!A|F&E&!D2&D1&!D&C1&!C&B1&B&A1&!A|F&!E&!D2&D1&!D&C1&!C&B1&B&A1&!A|F&!E&!D2&D1&D&C1&!C&B1&B&A1&!A|F&E&!D2&D1&D&C1&!C&B1&B&A1&!A|F&E&D2&D1&D&C1&!C&B1&B&A1&!A|F&!E&D2&D1&D&C1&!C&B1&B&A1&!A|F&!E&D2&!D1&D&C1&!C&B1&B&A1&!A|F&E&D2&!D1&D&C1&!C&B1&B&A1&!A|F&E&!D2&!D1&D&C1&!C&B1&B&A1&!A|F&!E&!D2&!D1&D&C1&!C&B1&B&A1&!A|F&!E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|F&E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|F&E&D2&!D1&D&!C1&!C&B1&B&A1&!A|F&!E&D2&!D1&D&!C1&!C&B1&B&A1&!A|F&!E&D2&D1&D&!C1&!C&B1&B&A1&!A|F&E&D2&D1&D&!C1&!C&B1&B&A1&!A|F&E&!D2&D1&D&!C1&!C&B1&B&A1&!A|F&!E&!D2&D1&D&!C1&!C&B1&B&A1&!A|F&!E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|F&E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|F&E&D2&D1&!D&!C1&!C&B1&B&A1&!A|F&!E&D2&D1&!D&!C1&!C&B1&B&A1&!A|F&!E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|F&E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|F&E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|F&E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|F&E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|F&!E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|F&!E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|F&E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|F&E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|F&!E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|F&!E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|F&E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|F&E&D2&D1&D&!C1&!C&B1&!B&A1&!A|F&!E&D2&D1&D&!C1&!C&B1&!B&A1&!A|F&!E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|F&E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|F&E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|F&!E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|F&!E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|F&E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|F&E&D2&!D1&D&C1&!C&B1&!B&A1&!A|F&!E&D2&!D1&D&C1&!C&B1&!B&A1&!A|F&!E&D2&D1&D&C1&!C&B1&!B&A1&!A|F&E&D2&D1&D&C1&!C&B1&!B&A1&!A|F&E&!D2&D1&D&C1&!C&B1&!B&A1&!A|F&!E&!D2&D1&D&C1&!C&B1&!B&A1&!A|F&!E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|F&E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|F&E&D2&D1&!D&C1&!C&B1&!B&A1&!A|F&!E&D2&D1&!D&C1&!C&B1&!B&A1&!A|F&!E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|F&E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|F&E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|F&E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|F&E&D2&!D1&!D&C1&C&B1&!B&A1&!A|F&!E&D2&!D1&!D&C1&C&B1&!B&A1&!A|F&!E&D2&D1&!D&C1&C&B1&!B&A1&!A|F&E&D2&D1&!D&C1&C&B1&!B&A1&!A|F&E&!D2&D1&!D&C1&C&B1&!B&A1&!A|F&!E&!D2&D1&!D&C1&C&B1&!B&A1&!A|F&!E&!D2&D1&D&C1&C&B1&!B&A1&!A|F&E&!D2&D1&D&C1&C&B1&!B&A1&!A|F&E&D2&D1&D&C1&C&B1&!B&A1&!A|F&!E&D2&D1&D&C1&C&B1&!B&A1&!A|F&!E&D2&!D1&D&C1&C&B1&!B&A1&!A|F&E&D2&!D1&D&C1&C&B1&!B&A1&!A|F&E&!D2&!D1&D&C1&C&B1&!B&A1&!A|F&!E&!D2&!D1&D&C1&C&B1&!B&A1&!A|F&!E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|F&E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|F&E&D2&!D1&D&!C1&C&B1&!B&A1&!A|F&!E&D2&!D1&D&!C1&C&B1&!B&A1&!A|F&!E&D2&D1&D&!C1&C&B1&!B&A1&!A|F&E&D2&D1&D&!C1&C&B1&!B&A1&!A|F&E&!D2&D1&D&!C1&C&B1&!B&A1&!A|F&!E&!D2&D1&D&!C1&C&B1&!B&A1&!A|F&!E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|F&E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|F&E&D2&D1&!D&!C1&C&B1&!B&A1&!A|F&!E&D2&D1&!D&!C1&C&B1&!B&A1&!A|F&!E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|F&E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|F&E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|F&E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|F&E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|F&E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|F&E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|F&E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|F&E&D2&D1&D&!C1&C&!B1&!B&A1&!A|F&E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|F&E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|F&!E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|F&E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|F&E&D2&!D1&D&C1&C&!B1&!B&A1&!A|F&!E&D2&!D1&D&C1&C&!B1&!B&A1&!A|F&!E&D2&D1&D&C1&C&!B1&!B&A1&!A|F&E&D2&D1&D&C1&C&!B1&!B&A1&!A|F&E&!D2&D1&D&C1&C&!B1&!B&A1&!A|F&!E&!D2&D1&D&C1&C&!B1&!B&A1&!A|F&!E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|F&E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|F&E&D2&D1&!D&C1&C&!B1&!B&A1&!A|F&!E&D2&D1&!D&C1&C&!B1&!B&A1&!A|F&!E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|F&E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|F&E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|F&E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|F&E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|F&E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|F&E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|F&E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|F&E&D2&D1&D&C1&!C&!B1&!B&A1&!A|F&E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|F&E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|F&E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|F&E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|F&E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|F&E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|F&E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|F&E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|F&E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|F&E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|F&E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|F&E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|F&E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|F&E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|F&E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|F&E&D2&D1&D&!C1&!C&!B1&!B&A1&A|F&E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|F&E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|F&E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|F&E&D2&!D1&D&C1&!C&!B1&!B&A1&A|F&E&D2&D1&D&C1&!C&!B1&!B&A1&A|F&E&!D2&D1&D&C1&!C&!B1&!B&A1&A|F&E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|F&E&D2&D1&!D&C1&!C&!B1&!B&A1&A|F&E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|F&E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|F&E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|F&E&D2&!D1&!D&C1&C&!B1&!B&A1&A|F&!E&D2&!D1&!D&C1&C&!B1&!B&A1&A|F&!E&D2&D1&!D&C1&C&!B1&!B&A1&A|F&E&D2&D1&!D&C1&C&!B1&!B&A1&A|F&E&!D2&D1&!D&C1&C&!B1&!B&A1&A|F&!E&!D2&D1&!D&C1&C&!B1&!B&A1&A|F&!E&!D2&D1&D&C1&C&!B1&!B&A1&A|F&E&!D2&D1&D&C1&C&!B1&!B&A1&A|F&E&D2&D1&D&C1&C&!B1&!B&A1&A|F&!E&D2&D1&D&C1&C&!B1&!B&A1&A|F&!E&D2&!D1&D&C1&C&!B1&!B&A1&A|F&E&D2&!D1&D&C1&C&!B1&!B&A1&A|F&E&!D2&!D1&D&C1&C&!B1&!B&A1&A|F&!E&!D2&!D1&D&C1&C&!B1&!B&A1&A|F&E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|F&E&D2&!D1&D&!C1&C&!B1&!B&A1&A|F&E&D2&D1&D&!C1&C&!B1&!B&A1&A|F&E&!D2&D1&D&!C1&C&!B1&!B&A1&A|F&E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|F&E&D2&D1&!D&!C1&C&!B1&!B&A1&A|F&E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|F&E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|F&E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|F&E&D2&!D1&!D&!C1&C&B1&!B&A1&A|F&!E&D2&!D1&!D&!C1&C&B1&!B&A1&A|F&!E&D2&D1&!D&!C1&C&B1&!B&A1&A|F&E&D2&D1&!D&!C1&C&B1&!B&A1&A|F&E&!D2&D1&!D&!C1&C&B1&!B&A1&A|F&!E&!D2&D1&!D&!C1&C&B1&!B&A1&A|F&!E&!D2&D1&D&!C1&C&B1&!B&A1&A|F&E&!D2&D1&D&!C1&C&B1&!B&A1&A|F&E&D2&D1&D&!C1&C&B1&!B&A1&A|F&!E&D2&D1&D&!C1&C&B1&!B&A1&A|F&!E&D2&!D1&D&!C1&C&B1&!B&A1&A|F&E&D2&!D1&D&!C1&C&B1&!B&A1&A|F&E&!D2&!D1&D&!C1&C&B1&!B&A1&A|F&!E&!D2&!D1&D&!C1&C&B1&!B&A1&A|F&!E&!D2&!D1&D&C1&C&B1&!B&A1&A|F&E&!D2&!D1&D&C1&C&B1&!B&A1&A|F&E&D2&!D1&D&C1&C&B1&!B&A1&A|F&!E&D2&!D1&D&C1&C&B1&!B&A1&A|F&!E&D2&D1&D&C1&C&B1&!B&A1&A|F&E&D2&D1&D&C1&C&B1&!B&A1&A|F&E&!D2&D1&D&C1&C&B1&!B&A1&A|F&!E&!D2&D1&D&C1&C&B1&!B&A1&A|F&!E&!D2&D1&!D&C1&C&B1&!B&A1&A|F&E&!D2&D1&!D&C1&C&B1&!B&A1&A|F&E&D2&D1&!D&C1&C&B1&!B&A1&A|F&!E&D2&D1&!D&C1&C&B1&!B&A1&A|F&!E&D2&!D1&!D&C1&C&B1&!B&A1&A|F&E&D2&!D1&!D&C1&C&B1&!B&A1&A|F&E&!D2&!D1&!D&C1&C&B1&!B&A1&A|F&E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|F&E&D2&!D1&!D&C1&!C&B1&!B&A1&A|F&!E&D2&!D1&!D&C1&!C&B1&!B&A1&A|F&!E&D2&D1&!D&C1&!C&B1&!B&A1&A|F&E&D2&D1&!D&C1&!C&B1&!B&A1&A|F&E&!D2&D1&!D&C1&!C&B1&!B&A1&A|F&!E&!D2&D1&!D&C1&!C&B1&!B&A1&A|F&!E&!D2&D1&D&C1&!C&B1&!B&A1&A|F&E&!D2&D1&D&C1&!C&B1&!B&A1&A|F&E&D2&D1&D&C1&!C&B1&!B&A1&A|F&!E&D2&D1&D&C1&!C&B1&!B&A1&A|F&!E&D2&!D1&D&C1&!C&B1&!B&A1&A|F&E&D2&!D1&D&C1&!C&B1&!B&A1&A|F&E&!D2&!D1&D&C1&!C&B1&!B&A1&A|F&!E&!D2&!D1&D&C1&!C&B1&!B&A1&A|F&!E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|F&E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|F&E&D2&!D1&D&!C1&!C&B1&!B&A1&A|F&!E&D2&!D1&D&!C1&!C&B1&!B&A1&A|F&!E&D2&D1&D&!C1&!C&B1&!B&A1&A|F&E&D2&D1&D&!C1&!C&B1&!B&A1&A|F&E&!D2&D1&D&!C1&!C&B1&!B&A1&A|F&!E&!D2&D1&D&!C1&!C&B1&!B&A1&A|F&!E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|F&E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|F&E&D2&D1&!D&!C1&!C&B1&!B&A1&A|F&!E&D2&D1&!D&!C1&!C&B1&!B&A1&A|F&!E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|F&E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|F&E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|F&E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|F&E&D2&!D1&!D&!C1&!C&B1&B&A1&A|F&!E&D2&!D1&!D&!C1&!C&B1&B&A1&A|F&!E&D2&D1&!D&!C1&!C&B1&B&A1&A|F&E&D2&D1&!D&!C1&!C&B1&B&A1&A|F&E&!D2&D1&!D&!C1&!C&B1&B&A1&A|F&!E&!D2&D1&!D&!C1&!C&B1&B&A1&A|F&!E&!D2&D1&D&!C1&!C&B1&B&A1&A|F&E&!D2&D1&D&!C1&!C&B1&B&A1&A|F&E&D2&D1&D&!C1&!C&B1&B&A1&A|F&!E&D2&D1&D&!C1&!C&B1&B&A1&A|F&!E&D2&!D1&D&!C1&!C&B1&B&A1&A|F&E&D2&!D1&D&!C1&!C&B1&B&A1&A|F&E&!D2&!D1&D&!C1&!C&B1&B&A1&A|F&!E&!D2&!D1&D&!C1&!C&B1&B&A1&A|F&!E&!D2&!D1&D&C1&!C&B1&B&A1&A|F&E&!D2&!D1&D&C1&!C&B1&B&A1&A|F&E&D2&!D1&D&C1&!C&B1&B&A1&A|F&!E&D2&!D1&D&C1&!C&B1&B&A1&A|F&!E&D2&D1&D&C1&!C&B1&B&A1&A|F&E&D2&D1&D&C1&!C&B1&B&A1&A|F&E&!D2&D1&D&C1&!C&B1&B&A1&A|F&!E&!D2&D1&D&C1&!C&B1&B&A1&A|F&!E&!D2&D1&!D&C1&!C&B1&B&A1&A|F&E&!D2&D1&!D&C1&!C&B1&B&A1&A|F&E&D2&D1&!D&C1&!C&B1&B&A1&A|F&!E&D2&D1&!D&C1&!C&B1&B&A1&A|F&!E&D2&!D1&!D&C1&!C&B1&B&A1&A|F&E&D2&!D1&!D&C1&!C&B1&B&A1&A|F&E&!D2&!D1&!D&C1&!C&B1&B&A1&A|F&E&!D2&!D1&!D&C1&C&B1&B&A1&A|F&E&D2&!D1&!D&C1&C&B1&B&A1&A|F&!E&D2&!D1&!D&C1&C&B1&B&A1&A|F&!E&D2&D1&!D&C1&C&B1&B&A1&A|F&E&D2&D1&!D&C1&C&B1&B&A1&A|F&E&!D2&D1&!D&C1&C&B1&B&A1&A|F&!E&!D2&D1&!D&C1&C&B1&B&A1&A|F&!E&!D2&D1&D&C1&C&B1&B&A1&A|F&E&!D2&D1&D&C1&C&B1&B&A1&A|F&E&D2&D1&D&C1&C&B1&B&A1&A|F&!E&D2&D1&D&C1&C&B1&B&A1&A|F&!E&D2&!D1&D&C1&C&B1&B&A1&A|F&E&D2&!D1&D&C1&C&B1&B&A1&A|F&E&!D2&!D1&D&C1&C&B1&B&A1&A|F&!E&!D2&!D1&D&C1&C&B1&B&A1&A|F&!E&!D2&!D1&D&!C1&C&B1&B&A1&A|F&E&!D2&!D1&D&!C1&C&B1&B&A1&A|F&E&D2&!D1&D&!C1&C&B1&B&A1&A|F&!E&D2&!D1&D&!C1&C&B1&B&A1&A|F&!E&D2&D1&D&!C1&C&B1&B&A1&A|F&E&D2&D1&D&!C1&C&B1&B&A1&A|F&E&!D2&D1&D&!C1&C&B1&B&A1&A|F&!E&!D2&D1&D&!C1&C&B1&B&A1&A|F&!E&!D2&D1&!D&!C1&C&B1&B&A1&A|F&E&!D2&D1&!D&!C1&C&B1&B&A1&A|F&E&D2&D1&!D&!C1&C&B1&B&A1&A|F&!E&D2&D1&!D&!C1&C&B1&B&A1&A|F&!E&D2&!D1&!D&!C1&C&B1&B&A1&A|F&E&D2&!D1&!D&!C1&C&B1&B&A1&A|F&E&!D2&!D1&!D&!C1&C&B1&B&A1&A|F&E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|F&E&D2&!D1&!D&!C1&C&!B1&B&A1&A|F&!E&D2&!D1&!D&!C1&C&!B1&B&A1&A|F&!E&D2&D1&!D&!C1&C&!B1&B&A1&A|F&E&D2&D1&!D&!C1&C&!B1&B&A1&A|F&E&!D2&D1&!D&!C1&C&!B1&B&A1&A|F&!E&!D2&D1&!D&!C1&C&!B1&B&A1&A|F&!E&!D2&D1&D&!C1&C&!B1&B&A1&A|F&E&!D2&D1&D&!C1&C&!B1&B&A1&A|F&E&D2&D1&D&!C1&C&!B1&B&A1&A|F&!E&D2&D1&D&!C1&C&!B1&B&A1&A|F&!E&D2&!D1&D&!C1&C&!B1&B&A1&A|F&E&D2&!D1&D&!C1&C&!B1&B&A1&A|F&E&!D2&!D1&D&!C1&C&!B1&B&A1&A|F&!E&!D2&!D1&D&!C1&C&!B1&B&A1&A|F&!E&!D2&!D1&D&C1&C&!B1&B&A1&A|F&E&!D2&!D1&D&C1&C&!B1&B&A1&A|F&E&D2&!D1&D&C1&C&!B1&B&A1&A|F&!E&D2&!D1&D&C1&C&!B1&B&A1&A|F&!E&D2&D1&D&C1&C&!B1&B&A1&A|F&E&D2&D1&D&C1&C&!B1&B&A1&A|F&E&!D2&D1&D&C1&C&!B1&B&A1&A|F&!E&!D2&D1&D&C1&C&!B1&B&A1&A|F&!E&!D2&D1&!D&C1&C&!B1&B&A1&A|F&E&!D2&D1&!D&C1&C&!B1&B&A1&A|F&E&D2&D1&!D&C1&C&!B1&B&A1&A|F&!E&D2&D1&!D&C1&C&!B1&B&A1&A|F&!E&D2&!D1&!D&C1&C&!B1&B&A1&A|F&E&D2&!D1&!D&C1&C&!B1&B&A1&A|F&E&!D2&!D1&!D&C1&C&!B1&B&A1&A|F&E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|F&E&D2&!D1&!D&C1&!C&!B1&B&A1&A|F&!E&D2&!D1&!D&C1&!C&!B1&B&A1&A|F&!E&D2&D1&!D&C1&!C&!B1&B&A1&A|F&E&D2&D1&!D&C1&!C&!B1&B&A1&A|F&E&!D2&D1&!D&C1&!C&!B1&B&A1&A|F&!E&!D2&D1&!D&C1&!C&!B1&B&A1&A|F&!E&!D2&D1&D&C1&!C&!B1&B&A1&A|F&E&!D2&D1&D&C1&!C&!B1&B&A1&A|F&E&D2&D1&D&C1&!C&!B1&B&A1&A|F&!E&D2&D1&D&C1&!C&!B1&B&A1&A|F&!E&D2&!D1&D&C1&!C&!B1&B&A1&A|F&E&D2&!D1&D&C1&!C&!B1&B&A1&A|F&E&!D2&!D1&D&C1&!C&!B1&B&A1&A|F&!E&!D2&!D1&D&C1&!C&!B1&B&A1&A|F&!E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|F&E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|F&E&D2&!D1&D&!C1&!C&!B1&B&A1&A|F&!E&D2&!D1&D&!C1&!C&!B1&B&A1&A|F&!E&D2&D1&D&!C1&!C&!B1&B&A1&A|F&E&D2&D1&D&!C1&!C&!B1&B&A1&A|F&E&!D2&D1&D&!C1&!C&!B1&B&A1&A|F&!E&!D2&D1&D&!C1&!C&!B1&B&A1&A|F&!E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|F&E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|F&E&D2&D1&!D&!C1&!C&!B1&B&A1&A|F&!E&D2&D1&!D&!C1&!C&!B1&B&A1&A|F&!E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|F&E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|F&E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|F&E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|F&E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|F&!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|F&!E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|F&E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|F&E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|F&!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|F&!E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|F&E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|F&E&D2&D1&D&!C1&!C&!B1&B&!A1&A|F&!E&D2&D1&D&!C1&!C&!B1&B&!A1&A|F&!E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|F&E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|F&E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|F&!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|F&!E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|F&E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|F&E&D2&!D1&D&C1&!C&!B1&B&!A1&A|F&!E&D2&!D1&D&C1&!C&!B1&B&!A1&A|F&!E&D2&D1&D&C1&!C&!B1&B&!A1&A|F&E&D2&D1&D&C1&!C&!B1&B&!A1&A|F&E&!D2&D1&D&C1&!C&!B1&B&!A1&A|F&!E&!D2&D1&D&C1&!C&!B1&B&!A1&A|F&!E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|F&E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|F&E&D2&D1&!D&C1&!C&!B1&B&!A1&A|F&!E&D2&D1&!D&C1&!C&!B1&B&!A1&A|F&!E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|F&E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|F&E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|F&E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|F&E&D2&!D1&!D&C1&C&!B1&B&!A1&A|F&!E&D2&!D1&!D&C1&C&!B1&B&!A1&A|F&!E&D2&D1&!D&C1&C&!B1&B&!A1&A|F&E&D2&D1&!D&C1&C&!B1&B&!A1&A|F&E&!D2&D1&!D&C1&C&!B1&B&!A1&A|F&!E&!D2&D1&!D&C1&C&!B1&B&!A1&A|F&!E&!D2&D1&D&C1&C&!B1&B&!A1&A|F&E&!D2&D1&D&C1&C&!B1&B&!A1&A|F&E&D2&D1&D&C1&C&!B1&B&!A1&A|F&!E&D2&D1&D&C1&C&!B1&B&!A1&A|F&!E&D2&!D1&D&C1&C&!B1&B&!A1&A|F&E&D2&!D1&D&C1&C&!B1&B&!A1&A|F&E&!D2&!D1&D&C1&C&!B1&B&!A1&A|F&!E&!D2&!D1&D&C1&C&!B1&B&!A1&A|F&!E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|F&E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|F&E&D2&!D1&D&!C1&C&!B1&B&!A1&A|F&!E&D2&!D1&D&!C1&C&!B1&B&!A1&A|F&!E&D2&D1&D&!C1&C&!B1&B&!A1&A|F&E&D2&D1&D&!C1&C&!B1&B&!A1&A|F&E&!D2&D1&D&!C1&C&!B1&B&!A1&A|F&!E&!D2&D1&D&!C1&C&!B1&B&!A1&A|F&!E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|F&E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|F&E&D2&D1&!D&!C1&C&!B1&B&!A1&A|F&!E&D2&D1&!D&!C1&C&!B1&B&!A1&A|F&!E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|F&E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|F&E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|F&E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|F&E&D2&!D1&!D&!C1&C&B1&B&!A1&A|F&!E&D2&!D1&!D&!C1&C&B1&B&!A1&A|F&!E&D2&D1&!D&!C1&C&B1&B&!A1&A|F&E&D2&D1&!D&!C1&C&B1&B&!A1&A|F&E&!D2&D1&!D&!C1&C&B1&B&!A1&A|F&!E&!D2&D1&!D&!C1&C&B1&B&!A1&A|F&!E&!D2&D1&D&!C1&C&B1&B&!A1&A|F&E&!D2&D1&D&!C1&C&B1&B&!A1&A|F&E&D2&D1&D&!C1&C&B1&B&!A1&A|F&!E&D2&D1&D&!C1&C&B1&B&!A1&A|F&!E&D2&!D1&D&!C1&C&B1&B&!A1&A|F&E&D2&!D1&D&!C1&C&B1&B&!A1&A|F&E&!D2&!D1&D&!C1&C&B1&B&!A1&A|F&!E&!D2&!D1&D&!C1&C&B1&B&!A1&A|F&!E&!D2&!D1&D&C1&C&B1&B&!A1&A|F&E&!D2&!D1&D&C1&C&B1&B&!A1&A|F&E&D2&!D1&D&C1&C&B1&B&!A1&A|F&!E&D2&!D1&D&C1&C&B1&B&!A1&A|F&!E&D2&D1&D&C1&C&B1&B&!A1&A|F&E&D2&D1&D&C1&C&B1&B&!A1&A|F&E&!D2&D1&D&C1&C&B1&B&!A1&A|F&!E&!D2&D1&D&C1&C&B1&B&!A1&A|F&!E&!D2&D1&!D&C1&C&B1&B&!A1&A|F&E&!D2&D1&!D&C1&C&B1&B&!A1&A|F&E&D2&D1&!D&C1&C&B1&B&!A1&A|F&!E&D2&D1&!D&C1&C&B1&B&!A1&A|F&!E&D2&!D1&!D&C1&C&B1&B&!A1&A|F&E&D2&!D1&!D&C1&C&B1&B&!A1&A|F&E&!D2&!D1&!D&C1&C&B1&B&!A1&A|F&E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|F&E&D2&!D1&!D&C1&!C&B1&B&!A1&A|F&!E&D2&!D1&!D&C1&!C&B1&B&!A1&A|F&!E&D2&D1&!D&C1&!C&B1&B&!A1&A|F&E&D2&D1&!D&C1&!C&B1&B&!A1&A|F&E&!D2&D1&!D&C1&!C&B1&B&!A1&A|F&!E&!D2&D1&!D&C1&!C&B1&B&!A1&A|F&!E&!D2&D1&D&C1&!C&B1&B&!A1&A|F&E&!D2&D1&D&C1&!C&B1&B&!A1&A|F&E&D2&D1&D&C1&!C&B1&B&!A1&A|F&!E&D2&D1&D&C1&!C&B1&B&!A1&A|F&!E&D2&!D1&D&C1&!C&B1&B&!A1&A|F&E&D2&!D1&D&C1&!C&B1&B&!A1&A|F&E&!D2&!D1&D&C1&!C&B1&B&!A1&A|F&!E&!D2&!D1&D&C1&!C&B1&B&!A1&A|F&!E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|F&E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|F&E&D2&!D1&D&!C1&!C&B1&B&!A1&A|F&!E&D2&!D1&D&!C1&!C&B1&B&!A1&A|F&!E&D2&D1&D&!C1&!C&B1&B&!A1&A|F&E&D2&D1&D&!C1&!C&B1&B&!A1&A|F&E&!D2&D1&D&!C1&!C&B1&B&!A1&A|F&!E&!D2&D1&D&!C1&!C&B1&B&!A1&A|F&!E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|F&E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|F&E&D2&D1&!D&!C1&!C&B1&B&!A1&A|F&!E&D2&D1&!D&!C1&!C&B1&B&!A1&A|F&!E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|F&E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|F&E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|F&E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|F&E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|F&!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|F&!E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|F&E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|F&E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|F&!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|F&!E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|F&E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|F&E&D2&D1&D&!C1&!C&B1&!B&!A1&A|F&!E&D2&D1&D&!C1&!C&B1&!B&!A1&A|F&!E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|F&E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|F&E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|F&!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|F&!E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|F&E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|F&E&D2&!D1&D&C1&!C&B1&!B&!A1&A|F&!E&D2&!D1&D&C1&!C&B1&!B&!A1&A|F&!E&D2&D1&D&C1&!C&B1&!B&!A1&A|F&E&D2&D1&D&C1&!C&B1&!B&!A1&A|F&E&!D2&D1&D&C1&!C&B1&!B&!A1&A|F&!E&!D2&D1&D&C1&!C&B1&!B&!A1&A|F&!E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|F&E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|F&E&D2&D1&!D&C1&!C&B1&!B&!A1&A|F&!E&D2&D1&!D&C1&!C&B1&!B&!A1&A|F&!E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|F&E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|F&E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|F&E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|F&E&D2&!D1&!D&C1&C&B1&!B&!A1&A|F&!E&D2&!D1&!D&C1&C&B1&!B&!A1&A|F&!E&D2&D1&!D&C1&C&B1&!B&!A1&A|F&E&D2&D1&!D&C1&C&B1&!B&!A1&A|F&E&!D2&D1&!D&C1&C&B1&!B&!A1&A|F&!E&!D2&D1&!D&C1&C&B1&!B&!A1&A|F&!E&!D2&D1&D&C1&C&B1&!B&!A1&A|F&E&!D2&D1&D&C1&C&B1&!B&!A1&A|F&E&D2&D1&D&C1&C&B1&!B&!A1&A|F&!E&D2&D1&D&C1&C&B1&!B&!A1&A|F&!E&D2&!D1&D&C1&C&B1&!B&!A1&A|F&E&D2&!D1&D&C1&C&B1&!B&!A1&A|F&E&!D2&!D1&D&C1&C&B1&!B&!A1&A|F&!E&!D2&!D1&D&C1&C&B1&!B&!A1&A|F&!E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|F&E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|F&E&D2&!D1&D&!C1&C&B1&!B&!A1&A|F&!E&D2&!D1&D&!C1&C&B1&!B&!A1&A|F&!E&D2&D1&D&!C1&C&B1&!B&!A1&A|F&E&D2&D1&D&!C1&C&B1&!B&!A1&A|F&E&!D2&D1&D&!C1&C&B1&!B&!A1&A|F&!E&!D2&D1&D&!C1&C&B1&!B&!A1&A|F&!E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|F&E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|F&E&D2&D1&!D&!C1&C&B1&!B&!A1&A|F&!E&D2&D1&!D&!C1&C&B1&!B&!A1&A|F&!E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|F&E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|F&E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|F&E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|F&E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|F&E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|F&E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|F&E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|F&E&D2&D1&D&!C1&C&!B1&!B&!A1&A|F&E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|F&E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|F&!E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|F&E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|F&E&D2&!D1&D&C1&C&!B1&!B&!A1&A|F&!E&D2&!D1&D&C1&C&!B1&!B&!A1&A|F&!E&D2&D1&D&C1&C&!B1&!B&!A1&A|F&E&D2&D1&D&C1&C&!B1&!B&!A1&A|F&E&!D2&D1&D&C1&C&!B1&!B&!A1&A|F&!E&!D2&D1&D&C1&C&!B1&!B&!A1&A|F&!E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|F&E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|F&E&D2&D1&!D&C1&C&!B1&!B&!A1&A|F&!E&D2&D1&!D&C1&C&!B1&!B&!A1&A|F&!E&D2&!D1&!D&C1&C&!B1&!B&!A1&A|F&E&D2&!D1&!D&C1&C&!B1&!B&!A1&A|F&E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|F&E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|F&E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|F&E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|F&E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|F&E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|F&E&D2&D1&D&C1&!C&!B1&!B&!A1&A|F&E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|F&E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|F&E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|F&E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|F&E&D2&D1&D&!C1&!C&!B1&!B&!A1&A|F&E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|F&E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|F&E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|F&E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|F&E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOOAOAI222311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOI3113 -l AOAAOI3113 -i D2 D1 D C B A2 A1 A -o Y -f Y=!(D2&D1&D&!C&!B&!A2&!A1&!A|D2&D1&D&C&!B&!A2&!A1&!A|!D2&!D1&!D&C&B&!A2&!A1&!A|D2&!D1&!D&C&B&!A2&!A1&!A|D2&D1&!D&C&B&!A2&!A1&!A|!D2&D1&!D&C&B&!A2&!A1&!A|!D2&D1&D&C&B&!A2&!A1&!A|D2&D1&D&C&B&!A2&!A1&!A|D2&!D1&D&C&B&!A2&!A1&!A|!D2&!D1&D&C&B&!A2&!A1&!A|D2&D1&D&!C&B&!A2&!A1&!A|D2&D1&D&!C&B&A2&!A1&!A|!D2&!D1&D&C&B&A2&!A1&!A|D2&!D1&D&C&B&A2&!A1&!A|D2&D1&D&C&B&A2&!A1&!A|!D2&D1&D&C&B&A2&!A1&!A|!D2&D1&!D&C&B&A2&!A1&!A|D2&D1&!D&C&B&A2&!A1&!A|D2&!D1&!D&C&B&A2&!A1&!A|!D2&!D1&!D&C&B&A2&!A1&!A|D2&D1&D&C&!B&A2&!A1&!A|D2&D1&D&!C&!B&A2&!A1&!A|D2&D1&D&!C&!B&A2&A1&!A|D2&D1&D&C&!B&A2&A1&!A|!D2&!D1&!D&C&B&A2&A1&!A|D2&!D1&!D&C&B&A2&A1&!A|D2&D1&!D&C&B&A2&A1&!A|!D2&D1&!D&C&B&A2&A1&!A|!D2&D1&D&C&B&A2&A1&!A|D2&D1&D&C&B&A2&A1&!A|D2&!D1&D&C&B&A2&A1&!A|!D2&!D1&D&C&B&A2&A1&!A|D2&D1&D&!C&B&A2&A1&!A|D2&D1&D&!C&B&!A2&A1&!A|!D2&!D1&D&C&B&!A2&A1&!A|D2&!D1&D&C&B&!A2&A1&!A|D2&D1&D&C&B&!A2&A1&!A|!D2&D1&D&C&B&!A2&A1&!A|!D2&D1&!D&C&B&!A2&A1&!A|D2&D1&!D&C&B&!A2&A1&!A|D2&!D1&!D&C&B&!A2&A1&!A|!D2&!D1&!D&C&B&!A2&A1&!A|D2&D1&D&C&!B&!A2&A1&!A|D2&D1&D&!C&!B&!A2&A1&!A|D2&D1&D&!C&!B&!A2&A1&A|D2&D1&D&C&!B&!A2&A1&A|!D2&!D1&!D&C&B&!A2&A1&A|D2&!D1&!D&C&B&!A2&A1&A|D2&D1&!D&C&B&!A2&A1&A|!D2&D1&!D&C&B&!A2&A1&A|!D2&D1&D&C&B&!A2&A1&A|D2&D1&D&C&B&!A2&A1&A|D2&!D1&D&C&B&!A2&A1&A|!D2&!D1&D&C&B&!A2&A1&A|D2&D1&D&!C&B&!A2&A1&A|D2&D1&D&!C&B&A2&A1&A|!D2&!D1&D&C&B&A2&A1&A|D2&!D1&D&C&B&A2&A1&A|D2&D1&D&C&B&A2&A1&A|!D2&D1&D&C&B&A2&A1&A|!D2&D1&!D&C&B&A2&A1&A|D2&D1&!D&C&B&A2&A1&A|D2&!D1&!D&C&B&A2&A1&A|!D2&!D1&!D&C&B&A2&A1&A|!D2&!D1&!D&C&!B&A2&A1&A|D2&!D1&!D&C&!B&A2&A1&A|D2&D1&!D&C&!B&A2&A1&A|!D2&D1&!D&C&!B&A2&A1&A|!D2&D1&D&C&!B&A2&A1&A|D2&D1&D&C&!B&A2&A1&A|D2&!D1&D&C&!B&A2&A1&A|!D2&!D1&D&C&!B&A2&A1&A|D2&D1&D&!C&!B&A2&A1&A|D2&D1&D&!C&!B&A2&!A1&A|D2&D1&D&C&!B&A2&!A1&A|!D2&!D1&!D&C&B&A2&!A1&A|D2&!D1&!D&C&B&A2&!A1&A|D2&D1&!D&C&B&A2&!A1&A|!D2&D1&!D&C&B&A2&!A1&A|!D2&D1&D&C&B&A2&!A1&A|D2&D1&D&C&B&A2&!A1&A|D2&!D1&D&C&B&A2&!A1&A|!D2&!D1&D&C&B&A2&!A1&A|D2&D1&D&!C&B&A2&!A1&A|D2&D1&D&!C&B&!A2&!A1&A|!D2&!D1&D&C&B&!A2&!A1&A|D2&!D1&D&C&B&!A2&!A1&A|D2&D1&D&C&B&!A2&!A1&A|!D2&D1&D&C&B&!A2&!A1&A|!D2&D1&!D&C&B&!A2&!A1&A|D2&D1&!D&C&B&!A2&!A1&A|D2&!D1&!D&C&B&!A2&!A1&A|!D2&!D1&!D&C&B&!A2&!A1&A|D2&D1&D&C&!B&!A2&!A1&A|D2&D1&D&!C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOI3113.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAI223 -l AOOAI223 -i C2 C1 C B1 B A1 A -o Y -f Y=(!C2&!C1&!C&!B1&!B&!A1&!A|C2&!C1&!C&!B1&!B&!A1&!A|C2&C1&!C&!B1&!B&!A1&!A|!C2&C1&!C&!B1&!B&!A1&!A|!C2&C1&C&!B1&!B&!A1&!A|C2&C1&C&!B1&!B&!A1&!A|C2&!C1&C&!B1&!B&!A1&!A|!C2&!C1&C&!B1&!B&!A1&!A|!C2&!C1&!C&B1&!B&!A1&!A|!C2&!C1&!C&B1&B&!A1&!A|!C2&!C1&!C&!B1&B&!A1&!A|!C2&!C1&!C&!B1&B&A1&!A|!C2&!C1&!C&B1&B&A1&!A|!C2&!C1&!C&B1&!B&A1&!A|!C2&!C1&C&!B1&!B&A1&!A|C2&!C1&C&!B1&!B&A1&!A|C2&C1&C&!B1&!B&A1&!A|!C2&C1&C&!B1&!B&A1&!A|!C2&C1&!C&!B1&!B&A1&!A|C2&C1&!C&!B1&!B&A1&!A|C2&!C1&!C&!B1&!B&A1&!A|!C2&!C1&!C&!B1&!B&A1&!A|!C2&!C1&!C&!B1&!B&A1&A|!C2&!C1&!C&B1&!B&A1&A|!C2&!C1&!C&B1&B&A1&A|!C2&!C1&!C&!B1&B&A1&A|!C2&!C1&!C&!B1&B&!A1&A|!C2&!C1&!C&B1&B&!A1&A|!C2&!C1&!C&B1&!B&!A1&A|!C2&!C1&C&!B1&!B&!A1&A|C2&!C1&C&!B1&!B&!A1&A|C2&C1&C&!B1&!B&!A1&A|!C2&C1&C&!B1&!B&!A1&A|!C2&C1&!C&!B1&!B&!A1&A|C2&C1&!C&!B1&!B&!A1&A|C2&!C1&!C&!B1&!B&!A1&A|!C2&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAI223.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOI2121 -l AOAOI2121 -i D C1 C B A1 A -o Y -f Y=(!D&!C1&!C&!B&!A1&!A|!D&C1&!C&!B&!A1&!A|!D&C1&C&!B&!A1&!A|!D&!C1&C&!B&!A1&!A|!D&!C1&C&B&!A1&!A|!D&C1&!C&B&!A1&!A|!D&!C1&!C&B&!A1&!A|!D&!C1&!C&B&A1&!A|!D&C1&!C&B&A1&!A|!D&!C1&C&B&A1&!A|!D&!C1&C&!B&A1&!A|!D&C1&C&!B&A1&!A|!D&C1&!C&!B&A1&!A|!D&!C1&!C&!B&A1&!A|!D&!C1&!C&!B&A1&A|!D&C1&!C&!B&A1&A|!D&!C1&C&!B&A1&A|!D&!C1&C&B&A1&A|!D&C1&!C&B&A1&A|!D&!C1&!C&B&A1&A|!D&!C1&!C&B&!A1&A|!D&C1&!C&B&!A1&A|!D&!C1&C&B&!A1&A|!D&!C1&C&!B&!A1&A|!D&C1&C&!B&!A1&A|!D&C1&!C&!B&!A1&A|!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOI2121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAI222 -l AAOAI222 -i C1 C B1 B A1 A -o Y -f Y=!(C1&C&B1&B&!A1&!A|C1&C&B1&B&A1&!A|C1&C&!B1&!B&A1&A|C1&C&B1&!B&A1&A|C1&C&B1&B&A1&A|C1&C&!B1&B&A1&A|C1&C&B1&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAI222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAI33 -l OOAI33 -i B2 B1 B A2 A1 A -o Y -f Y=(!B2&!B1&!B&!A2&!A1&!A|B2&!B1&!B&!A2&!A1&!A|B2&B1&!B&!A2&!A1&!A|!B2&B1&!B&!A2&!A1&!A|!B2&B1&B&!A2&!A1&!A|B2&B1&B&!A2&!A1&!A|B2&!B1&B&!A2&!A1&!A|!B2&!B1&B&!A2&!A1&!A|!B2&!B1&!B&A2&!A1&!A|!B2&!B1&!B&A2&A1&!A|!B2&!B1&!B&!A2&A1&!A|!B2&!B1&!B&!A2&A1&A|!B2&!B1&!B&A2&A1&A|!B2&!B1&!B&A2&!A1&A|!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAI33.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAI331 -l AOAI331 -i C B2 B1 B A2 A1 A -o Y -f Y=!(C&B2&!B1&!B&!A2&!A1&!A|C&B2&B1&!B&!A2&!A1&!A|C&!B2&B1&!B&!A2&!A1&!A|C&!B2&B1&B&!A2&!A1&!A|C&B2&B1&B&!A2&!A1&!A|C&B2&!B1&B&!A2&!A1&!A|C&!B2&!B1&B&!A2&!A1&!A|C&!B2&!B1&B&A2&!A1&!A|C&B2&!B1&B&A2&!A1&!A|C&B2&B1&B&A2&!A1&!A|C&!B2&B1&B&A2&!A1&!A|C&!B2&B1&!B&A2&!A1&!A|C&B2&B1&!B&A2&!A1&!A|C&B2&!B1&!B&A2&!A1&!A|C&B2&!B1&!B&A2&A1&!A|C&B2&B1&!B&A2&A1&!A|C&!B2&B1&!B&A2&A1&!A|C&!B2&B1&B&A2&A1&!A|C&B2&B1&B&A2&A1&!A|C&B2&!B1&B&A2&A1&!A|C&!B2&!B1&B&A2&A1&!A|C&!B2&!B1&B&!A2&A1&!A|C&B2&!B1&B&!A2&A1&!A|C&B2&B1&B&!A2&A1&!A|C&!B2&B1&B&!A2&A1&!A|C&!B2&B1&!B&!A2&A1&!A|C&B2&B1&!B&!A2&A1&!A|C&B2&!B1&!B&!A2&A1&!A|C&B2&!B1&!B&!A2&A1&A|C&B2&B1&!B&!A2&A1&A|C&!B2&B1&!B&!A2&A1&A|C&!B2&B1&B&!A2&A1&A|C&B2&B1&B&!A2&A1&A|C&B2&!B1&B&!A2&A1&A|C&!B2&!B1&B&!A2&A1&A|C&!B2&!B1&B&A2&A1&A|C&B2&!B1&B&A2&A1&A|C&B2&B1&B&A2&A1&A|C&!B2&B1&B&A2&A1&A|C&!B2&B1&!B&A2&A1&A|C&B2&B1&!B&A2&A1&A|C&B2&!B1&!B&A2&A1&A|C&!B2&!B1&!B&A2&A1&A|C&B2&!B1&!B&A2&!A1&A|C&B2&B1&!B&A2&!A1&A|C&!B2&B1&!B&A2&!A1&A|C&!B2&B1&B&A2&!A1&A|C&B2&B1&B&A2&!A1&A|C&B2&!B1&B&A2&!A1&A|C&!B2&!B1&B&A2&!A1&A|C&!B2&!B1&B&!A2&!A1&A|C&B2&!B1&B&!A2&!A1&A|C&B2&B1&B&!A2&!A1&A|C&!B2&B1&B&!A2&!A1&A|C&!B2&B1&!B&!A2&!A1&A|C&B2&B1&!B&!A2&!A1&A|C&B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAI331.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOOAOI211221 -l AOAAOOAOI211221 -i F E1 E D1 D C B A1 A -o Y -f Y=(!F&!E1&!E&!D1&!D&!C&!B&!A1&!A|!F&E1&!E&!D1&!D&!C&!B&!A1&!A|!F&E1&E&!D1&!D&!C&!B&!A1&!A|!F&!E1&E&!D1&!D&!C&!B&!A1&!A|!F&!E1&E&D1&!D&!C&!B&!A1&!A|!F&E1&E&D1&!D&!C&!B&!A1&!A|!F&E1&!E&D1&!D&!C&!B&!A1&!A|!F&!E1&!E&D1&!D&!C&!B&!A1&!A|!F&!E1&!E&D1&D&!C&!B&!A1&!A|!F&!E1&E&!D1&D&!C&!B&!A1&!A|!F&E1&E&!D1&D&!C&!B&!A1&!A|!F&E1&!E&!D1&D&!C&!B&!A1&!A|!F&!E1&!E&!D1&D&!C&!B&!A1&!A|!F&!E1&!E&!D1&D&C&!B&!A1&!A|!F&E1&!E&!D1&D&C&!B&!A1&!A|!F&E1&E&!D1&D&C&!B&!A1&!A|!F&!E1&E&!D1&D&C&!B&!A1&!A|!F&!E1&!E&D1&D&C&!B&!A1&!A|!F&!E1&!E&D1&!D&C&!B&!A1&!A|!F&E1&!E&D1&!D&C&!B&!A1&!A|!F&E1&E&D1&!D&C&!B&!A1&!A|!F&!E1&E&D1&!D&C&!B&!A1&!A|!F&!E1&E&!D1&!D&C&!B&!A1&!A|!F&E1&E&!D1&!D&C&!B&!A1&!A|!F&E1&!E&!D1&!D&C&!B&!A1&!A|!F&!E1&!E&!D1&!D&C&!B&!A1&!A|!F&!E1&!E&!D1&!D&C&B&!A1&!A|!F&!E1&!E&D1&!D&C&B&!A1&!A|!F&!E1&!E&D1&D&C&B&!A1&!A|!F&!E1&!E&!D1&D&C&B&!A1&!A|!F&!E1&!E&!D1&D&!C&B&!A1&!A|!F&E1&!E&!D1&D&!C&B&!A1&!A|!F&E1&E&!D1&D&!C&B&!A1&!A|!F&!E1&E&!D1&D&!C&B&!A1&!A|!F&!E1&!E&D1&D&!C&B&!A1&!A|!F&!E1&!E&D1&!D&!C&B&!A1&!A|!F&E1&!E&D1&!D&!C&B&!A1&!A|!F&E1&E&D1&!D&!C&B&!A1&!A|!F&!E1&E&D1&!D&!C&B&!A1&!A|!F&!E1&E&!D1&!D&!C&B&!A1&!A|!F&E1&E&!D1&!D&!C&B&!A1&!A|!F&E1&!E&!D1&!D&!C&B&!A1&!A|!F&!E1&!E&!D1&!D&!C&B&!A1&!A|!F&!E1&!E&!D1&!D&!C&B&A1&!A|!F&E1&!E&!D1&!D&!C&B&A1&!A|!F&E1&E&!D1&!D&!C&B&A1&!A|!F&!E1&E&!D1&!D&!C&B&A1&!A|!F&!E1&E&D1&!D&!C&B&A1&!A|!F&E1&E&D1&!D&!C&B&A1&!A|!F&E1&!E&D1&!D&!C&B&A1&!A|!F&!E1&!E&D1&!D&!C&B&A1&!A|!F&!E1&!E&D1&D&!C&B&A1&!A|!F&!E1&E&!D1&D&!C&B&A1&!A|!F&E1&E&!D1&D&!C&B&A1&!A|!F&E1&!E&!D1&D&!C&B&A1&!A|!F&!E1&!E&!D1&D&!C&B&A1&!A|!F&!E1&!E&!D1&D&C&B&A1&!A|!F&!E1&!E&D1&D&C&B&A1&!A|!F&!E1&!E&D1&!D&C&B&A1&!A|!F&!E1&!E&!D1&!D&C&B&A1&!A|!F&!E1&!E&!D1&!D&C&!B&A1&!A|!F&E1&!E&!D1&!D&C&!B&A1&!A|!F&E1&E&!D1&!D&C&!B&A1&!A|!F&!E1&E&!D1&!D&C&!B&A1&!A|!F&!E1&E&D1&!D&C&!B&A1&!A|!F&E1&E&D1&!D&C&!B&A1&!A|!F&E1&!E&D1&!D&C&!B&A1&!A|!F&!E1&!E&D1&!D&C&!B&A1&!A|!F&!E1&!E&D1&D&C&!B&A1&!A|!F&!E1&E&!D1&D&C&!B&A1&!A|!F&E1&E&!D1&D&C&!B&A1&!A|!F&E1&!E&!D1&D&C&!B&A1&!A|!F&!E1&!E&!D1&D&C&!B&A1&!A|!F&!E1&!E&!D1&D&!C&!B&A1&!A|!F&E1&!E&!D1&D&!C&!B&A1&!A|!F&E1&E&!D1&D&!C&!B&A1&!A|!F&!E1&E&!D1&D&!C&!B&A1&!A|!F&!E1&!E&D1&D&!C&!B&A1&!A|!F&!E1&!E&D1&!D&!C&!B&A1&!A|!F&E1&!E&D1&!D&!C&!B&A1&!A|!F&E1&E&D1&!D&!C&!B&A1&!A|!F&!E1&E&D1&!D&!C&!B&A1&!A|!F&!E1&E&!D1&!D&!C&!B&A1&!A|!F&E1&E&!D1&!D&!C&!B&A1&!A|!F&E1&!E&!D1&!D&!C&!B&A1&!A|!F&!E1&!E&!D1&!D&!C&!B&A1&!A|!F&!E1&!E&!D1&!D&!C&!B&A1&A|!F&E1&!E&!D1&!D&!C&!B&A1&A|!F&E1&E&!D1&!D&!C&!B&A1&A|!F&!E1&E&!D1&!D&!C&!B&A1&A|!F&!E1&E&D1&!D&!C&!B&A1&A|!F&E1&E&D1&!D&!C&!B&A1&A|!F&E1&!E&D1&!D&!C&!B&A1&A|!F&!E1&!E&D1&!D&!C&!B&A1&A|!F&!E1&!E&D1&D&!C&!B&A1&A|!F&!E1&E&!D1&D&!C&!B&A1&A|!F&E1&E&!D1&D&!C&!B&A1&A|!F&E1&!E&!D1&D&!C&!B&A1&A|!F&!E1&!E&!D1&D&!C&!B&A1&A|!F&!E1&!E&!D1&D&C&!B&A1&A|!F&!E1&!E&D1&D&C&!B&A1&A|!F&!E1&!E&D1&!D&C&!B&A1&A|!F&!E1&!E&!D1&!D&C&!B&A1&A|!F&!E1&!E&!D1&!D&C&B&A1&A|!F&!E1&!E&D1&!D&C&B&A1&A|!F&!E1&!E&D1&D&C&B&A1&A|!F&!E1&!E&!D1&D&C&B&A1&A|!F&!E1&!E&!D1&D&!C&B&A1&A|!F&E1&!E&!D1&D&!C&B&A1&A|!F&E1&E&!D1&D&!C&B&A1&A|!F&!E1&E&!D1&D&!C&B&A1&A|!F&!E1&!E&D1&D&!C&B&A1&A|!F&!E1&!E&D1&!D&!C&B&A1&A|!F&E1&!E&D1&!D&!C&B&A1&A|!F&E1&E&D1&!D&!C&B&A1&A|!F&!E1&E&D1&!D&!C&B&A1&A|!F&!E1&E&!D1&!D&!C&B&A1&A|!F&E1&E&!D1&!D&!C&B&A1&A|!F&E1&!E&!D1&!D&!C&B&A1&A|!F&!E1&!E&!D1&!D&!C&B&A1&A|!F&!E1&!E&!D1&!D&!C&B&!A1&A|!F&E1&!E&!D1&!D&!C&B&!A1&A|!F&E1&E&!D1&!D&!C&B&!A1&A|!F&!E1&E&!D1&!D&!C&B&!A1&A|!F&!E1&E&D1&!D&!C&B&!A1&A|!F&E1&E&D1&!D&!C&B&!A1&A|!F&E1&!E&D1&!D&!C&B&!A1&A|!F&!E1&!E&D1&!D&!C&B&!A1&A|!F&!E1&!E&D1&D&!C&B&!A1&A|!F&!E1&E&!D1&D&!C&B&!A1&A|!F&E1&E&!D1&D&!C&B&!A1&A|!F&E1&!E&!D1&D&!C&B&!A1&A|!F&!E1&!E&!D1&D&!C&B&!A1&A|!F&!E1&!E&!D1&D&C&B&!A1&A|!F&!E1&!E&D1&D&C&B&!A1&A|!F&!E1&!E&D1&!D&C&B&!A1&A|!F&!E1&!E&!D1&!D&C&B&!A1&A|!F&!E1&!E&!D1&!D&C&!B&!A1&A|!F&E1&!E&!D1&!D&C&!B&!A1&A|!F&E1&E&!D1&!D&C&!B&!A1&A|!F&!E1&E&!D1&!D&C&!B&!A1&A|!F&!E1&E&D1&!D&C&!B&!A1&A|!F&E1&E&D1&!D&C&!B&!A1&A|!F&E1&!E&D1&!D&C&!B&!A1&A|!F&!E1&!E&D1&!D&C&!B&!A1&A|!F&!E1&!E&D1&D&C&!B&!A1&A|!F&!E1&E&!D1&D&C&!B&!A1&A|!F&E1&E&!D1&D&C&!B&!A1&A|!F&E1&!E&!D1&D&C&!B&!A1&A|!F&!E1&!E&!D1&D&C&!B&!A1&A|!F&!E1&!E&!D1&D&!C&!B&!A1&A|!F&E1&!E&!D1&D&!C&!B&!A1&A|!F&E1&E&!D1&D&!C&!B&!A1&A|!F&!E1&E&!D1&D&!C&!B&!A1&A|!F&!E1&!E&D1&D&!C&!B&!A1&A|!F&!E1&!E&D1&!D&!C&!B&!A1&A|!F&E1&!E&D1&!D&!C&!B&!A1&A|!F&E1&E&D1&!D&!C&!B&!A1&A|!F&!E1&E&D1&!D&!C&!B&!A1&A|!F&!E1&E&!D1&!D&!C&!B&!A1&A|!F&E1&E&!D1&!D&!C&!B&!A1&A|!F&E1&!E&!D1&!D&!C&!B&!A1&A|!F&!E1&!E&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOOAOI211221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n INV -l INV -i A -o Y -f Y=!(A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist INV.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAAOI2222 -l OOOAAOI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B1&!B&!A1&!A|D1&!D&!C1&!C&!B1&!B&!A1&!A|!D1&D&!C1&!C&!B1&!B&!A1&!A|!D1&D&C1&!C&!B1&!B&!A1&!A|D1&!D&C1&!C&!B1&!B&!A1&!A|!D1&!D&C1&!C&!B1&!B&!A1&!A|!D1&!D&C1&C&!B1&!B&!A1&!A|D1&!D&C1&C&!B1&!B&!A1&!A|!D1&D&C1&C&!B1&!B&!A1&!A|!D1&D&!C1&C&!B1&!B&!A1&!A|D1&!D&!C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&B1&!B&!A1&!A|D1&!D&!C1&C&B1&!B&!A1&!A|!D1&D&!C1&C&B1&!B&!A1&!A|!D1&D&C1&C&B1&!B&!A1&!A|D1&!D&C1&C&B1&!B&!A1&!A|!D1&!D&C1&C&B1&!B&!A1&!A|!D1&!D&C1&!C&B1&!B&!A1&!A|D1&!D&C1&!C&B1&!B&!A1&!A|!D1&D&C1&!C&B1&!B&!A1&!A|!D1&D&!C1&!C&B1&!B&!A1&!A|D1&!D&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&B&!A1&!A|D1&!D&!C1&!C&B1&B&!A1&!A|!D1&D&!C1&!C&B1&B&!A1&!A|!D1&D&C1&!C&B1&B&!A1&!A|D1&!D&C1&!C&B1&B&!A1&!A|!D1&!D&C1&!C&B1&B&!A1&!A|!D1&!D&C1&C&B1&B&!A1&!A|D1&!D&C1&C&B1&B&!A1&!A|!D1&D&C1&C&B1&B&!A1&!A|!D1&D&!C1&C&B1&B&!A1&!A|D1&!D&!C1&C&B1&B&!A1&!A|!D1&!D&!C1&C&B1&B&!A1&!A|!D1&!D&!C1&C&!B1&B&!A1&!A|D1&!D&!C1&C&!B1&B&!A1&!A|!D1&D&!C1&C&!B1&B&!A1&!A|!D1&D&C1&C&!B1&B&!A1&!A|D1&!D&C1&C&!B1&B&!A1&!A|!D1&!D&C1&C&!B1&B&!A1&!A|!D1&!D&C1&!C&!B1&B&!A1&!A|D1&!D&C1&!C&!B1&B&!A1&!A|!D1&D&C1&!C&!B1&B&!A1&!A|!D1&D&!C1&!C&!B1&B&!A1&!A|D1&!D&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&A1&!A|D1&!D&!C1&!C&!B1&B&A1&!A|!D1&D&!C1&!C&!B1&B&A1&!A|!D1&D&!C1&!C&B1&B&A1&!A|D1&!D&!C1&!C&B1&B&A1&!A|!D1&!D&!C1&!C&B1&B&A1&!A|!D1&!D&!C1&!C&B1&!B&A1&!A|D1&!D&!C1&!C&B1&!B&A1&!A|!D1&D&!C1&!C&B1&!B&A1&!A|!D1&!D&!C1&C&!B1&!B&A1&!A|D1&!D&!C1&C&!B1&!B&A1&!A|!D1&D&!C1&C&!B1&!B&A1&!A|!D1&D&C1&C&!B1&!B&A1&!A|D1&!D&C1&C&!B1&!B&A1&!A|!D1&!D&C1&C&!B1&!B&A1&!A|!D1&!D&C1&!C&!B1&!B&A1&!A|D1&!D&C1&!C&!B1&!B&A1&!A|!D1&D&C1&!C&!B1&!B&A1&!A|!D1&D&!C1&!C&!B1&!B&A1&!A|D1&!D&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&A|D1&!D&!C1&!C&!B1&!B&A1&A|!D1&D&!C1&!C&!B1&!B&A1&A|!D1&D&C1&!C&!B1&!B&A1&A|D1&!D&C1&!C&!B1&!B&A1&A|!D1&!D&C1&!C&!B1&!B&A1&A|!D1&!D&C1&C&!B1&!B&A1&A|D1&!D&C1&C&!B1&!B&A1&A|!D1&D&C1&C&!B1&!B&A1&A|!D1&D&!C1&C&!B1&!B&A1&A|D1&!D&!C1&C&!B1&!B&A1&A|!D1&!D&!C1&C&!B1&!B&A1&A|!D1&D&!C1&!C&B1&!B&A1&A|D1&!D&!C1&!C&B1&!B&A1&A|!D1&!D&!C1&!C&B1&!B&A1&A|!D1&!D&!C1&!C&B1&B&A1&A|D1&!D&!C1&!C&B1&B&A1&A|!D1&D&!C1&!C&B1&B&A1&A|!D1&D&!C1&!C&!B1&B&A1&A|D1&!D&!C1&!C&!B1&B&A1&A|!D1&!D&!C1&!C&!B1&B&A1&A|!D1&!D&!C1&!C&!B1&B&!A1&A|D1&!D&!C1&!C&!B1&B&!A1&A|!D1&D&!C1&!C&!B1&B&!A1&A|!D1&D&!C1&!C&B1&B&!A1&A|D1&!D&!C1&!C&B1&B&!A1&A|!D1&!D&!C1&!C&B1&B&!A1&A|!D1&!D&!C1&!C&B1&!B&!A1&A|D1&!D&!C1&!C&B1&!B&!A1&A|!D1&D&!C1&!C&B1&!B&!A1&A|!D1&!D&!C1&C&!B1&!B&!A1&A|D1&!D&!C1&C&!B1&!B&!A1&A|!D1&D&!C1&C&!B1&!B&!A1&A|!D1&D&C1&C&!B1&!B&!A1&A|D1&!D&C1&C&!B1&!B&!A1&A|!D1&!D&C1&C&!B1&!B&!A1&A|!D1&!D&C1&!C&!B1&!B&!A1&A|D1&!D&C1&!C&!B1&!B&!A1&A|!D1&D&C1&!C&!B1&!B&!A1&A|!D1&D&!C1&!C&!B1&!B&!A1&A|D1&!D&!C1&!C&!B1&!B&!A1&A|!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAAOI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOI2221 -l AAAOI2221 -i D C1 C B1 B A1 A -o Y -f Y=(!D&!C1&!C&!B1&!B&!A1&!A|!D&C1&!C&!B1&!B&!A1&!A|!D&!C1&C&!B1&!B&!A1&!A|!D&!C1&C&B1&!B&!A1&!A|!D&C1&!C&B1&!B&!A1&!A|!D&!C1&!C&B1&!B&!A1&!A|!D&!C1&C&!B1&B&!A1&!A|!D&C1&!C&!B1&B&!A1&!A|!D&!C1&!C&!B1&B&!A1&!A|!D&!C1&!C&!B1&B&A1&!A|!D&C1&!C&!B1&B&A1&!A|!D&!C1&C&!B1&B&A1&!A|!D&!C1&!C&B1&!B&A1&!A|!D&C1&!C&B1&!B&A1&!A|!D&!C1&C&B1&!B&A1&!A|!D&!C1&C&!B1&!B&A1&!A|!D&C1&!C&!B1&!B&A1&!A|!D&!C1&!C&!B1&!B&A1&!A|!D&!C1&!C&!B1&B&!A1&A|!D&C1&!C&!B1&B&!A1&A|!D&!C1&C&!B1&B&!A1&A|!D&!C1&!C&B1&!B&!A1&A|!D&C1&!C&B1&!B&!A1&A|!D&!C1&C&B1&!B&!A1&A|!D&!C1&C&!B1&!B&!A1&A|!D&C1&!C&!B1&!B&!A1&A|!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOI2221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOAI2211 -l OAOAI2211 -i D C B1 B A1 A -o Y -f Y=!(D&C&!B1&!B&!A1&!A|D&C&B1&!B&!A1&!A|D&C&B1&B&!A1&!A|D&C&!B1&B&!A1&!A|D&C&!B1&B&A1&!A|D&C&B1&B&A1&!A|D&!C&B1&B&A1&!A|D&C&B1&!B&A1&!A|D&C&!B1&!B&A1&!A|D&C&!B1&!B&A1&A|D&C&B1&!B&A1&A|D&!C&B1&B&A1&A|D&C&B1&B&A1&A|D&C&!B1&B&A1&A|D&C&!B1&B&!A1&A|D&C&B1&B&!A1&A|D&!C&B1&B&!A1&A|D&C&B1&!B&!A1&A|D&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOAI2211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOOAI21213 -l AOOAOOAI21213 -i E2 E1 E D C1 C B A1 A -o Y -f Y=(!E2&!E1&!E&!D&!C1&!C&!B&!A1&!A|E2&!E1&!E&!D&!C1&!C&!B&!A1&!A|E2&E1&!E&!D&!C1&!C&!B&!A1&!A|!E2&E1&!E&!D&!C1&!C&!B&!A1&!A|!E2&E1&E&!D&!C1&!C&!B&!A1&!A|E2&E1&E&!D&!C1&!C&!B&!A1&!A|E2&!E1&E&!D&!C1&!C&!B&!A1&!A|!E2&!E1&E&!D&!C1&!C&!B&!A1&!A|!E2&!E1&!E&D&!C1&!C&!B&!A1&!A|!E2&!E1&!E&D&C1&!C&!B&!A1&!A|!E2&!E1&E&!D&C1&!C&!B&!A1&!A|E2&!E1&E&!D&C1&!C&!B&!A1&!A|E2&E1&E&!D&C1&!C&!B&!A1&!A|!E2&E1&E&!D&C1&!C&!B&!A1&!A|!E2&E1&!E&!D&C1&!C&!B&!A1&!A|E2&E1&!E&!D&C1&!C&!B&!A1&!A|E2&!E1&!E&!D&C1&!C&!B&!A1&!A|!E2&!E1&!E&!D&C1&!C&!B&!A1&!A|!E2&!E1&!E&!D&C1&C&!B&!A1&!A|E2&!E1&!E&!D&C1&C&!B&!A1&!A|E2&E1&!E&!D&C1&C&!B&!A1&!A|!E2&E1&!E&!D&C1&C&!B&!A1&!A|!E2&E1&E&!D&C1&C&!B&!A1&!A|E2&E1&E&!D&C1&C&!B&!A1&!A|E2&!E1&E&!D&C1&C&!B&!A1&!A|!E2&!E1&E&!D&C1&C&!B&!A1&!A|!E2&!E1&!E&D&C1&C&!B&!A1&!A|!E2&!E1&!E&D&!C1&C&!B&!A1&!A|!E2&!E1&E&!D&!C1&C&!B&!A1&!A|E2&!E1&E&!D&!C1&C&!B&!A1&!A|E2&E1&E&!D&!C1&C&!B&!A1&!A|!E2&E1&E&!D&!C1&C&!B&!A1&!A|!E2&E1&!E&!D&!C1&C&!B&!A1&!A|E2&E1&!E&!D&!C1&C&!B&!A1&!A|E2&!E1&!E&!D&!C1&C&!B&!A1&!A|!E2&!E1&!E&!D&!C1&C&!B&!A1&!A|!E2&!E1&!E&!D&!C1&C&B&!A1&!A|!E2&!E1&!E&D&!C1&C&B&!A1&!A|!E2&!E1&!E&D&C1&C&B&!A1&!A|!E2&!E1&!E&!D&C1&C&B&!A1&!A|!E2&!E1&!E&!D&C1&!C&B&!A1&!A|!E2&!E1&!E&D&C1&!C&B&!A1&!A|!E2&!E1&!E&D&!C1&!C&B&!A1&!A|!E2&!E1&E&!D&!C1&!C&B&!A1&!A|E2&!E1&E&!D&!C1&!C&B&!A1&!A|E2&E1&E&!D&!C1&!C&B&!A1&!A|!E2&E1&E&!D&!C1&!C&B&!A1&!A|!E2&E1&!E&!D&!C1&!C&B&!A1&!A|E2&E1&!E&!D&!C1&!C&B&!A1&!A|E2&!E1&!E&!D&!C1&!C&B&!A1&!A|!E2&!E1&!E&!D&!C1&!C&B&!A1&!A|!E2&!E1&!E&!D&!C1&!C&B&A1&!A|E2&!E1&!E&!D&!C1&!C&B&A1&!A|E2&E1&!E&!D&!C1&!C&B&A1&!A|!E2&E1&!E&!D&!C1&!C&B&A1&!A|!E2&E1&E&!D&!C1&!C&B&A1&!A|E2&E1&E&!D&!C1&!C&B&A1&!A|E2&!E1&E&!D&!C1&!C&B&A1&!A|!E2&!E1&E&!D&!C1&!C&B&A1&!A|!E2&!E1&!E&D&!C1&!C&B&A1&!A|!E2&!E1&!E&D&C1&!C&B&A1&!A|!E2&!E1&!E&!D&C1&!C&B&A1&!A|!E2&!E1&!E&!D&C1&C&B&A1&!A|!E2&!E1&!E&D&C1&C&B&A1&!A|!E2&!E1&!E&D&!C1&C&B&A1&!A|!E2&!E1&!E&!D&!C1&C&B&A1&!A|!E2&!E1&!E&!D&!C1&C&!B&A1&!A|E2&!E1&!E&!D&!C1&C&!B&A1&!A|E2&E1&!E&!D&!C1&C&!B&A1&!A|!E2&E1&!E&!D&!C1&C&!B&A1&!A|!E2&E1&E&!D&!C1&C&!B&A1&!A|E2&E1&E&!D&!C1&C&!B&A1&!A|E2&!E1&E&!D&!C1&C&!B&A1&!A|!E2&!E1&E&!D&!C1&C&!B&A1&!A|!E2&!E1&!E&D&!C1&C&!B&A1&!A|!E2&!E1&!E&D&C1&C&!B&A1&!A|!E2&!E1&E&!D&C1&C&!B&A1&!A|E2&!E1&E&!D&C1&C&!B&A1&!A|E2&E1&E&!D&C1&C&!B&A1&!A|!E2&E1&E&!D&C1&C&!B&A1&!A|!E2&E1&!E&!D&C1&C&!B&A1&!A|E2&E1&!E&!D&C1&C&!B&A1&!A|E2&!E1&!E&!D&C1&C&!B&A1&!A|!E2&!E1&!E&!D&C1&C&!B&A1&!A|!E2&!E1&!E&!D&C1&!C&!B&A1&!A|E2&!E1&!E&!D&C1&!C&!B&A1&!A|E2&E1&!E&!D&C1&!C&!B&A1&!A|!E2&E1&!E&!D&C1&!C&!B&A1&!A|!E2&E1&E&!D&C1&!C&!B&A1&!A|E2&E1&E&!D&C1&!C&!B&A1&!A|E2&!E1&E&!D&C1&!C&!B&A1&!A|!E2&!E1&E&!D&C1&!C&!B&A1&!A|!E2&!E1&!E&D&C1&!C&!B&A1&!A|!E2&!E1&!E&D&!C1&!C&!B&A1&!A|!E2&!E1&E&!D&!C1&!C&!B&A1&!A|E2&!E1&E&!D&!C1&!C&!B&A1&!A|E2&E1&E&!D&!C1&!C&!B&A1&!A|!E2&E1&E&!D&!C1&!C&!B&A1&!A|!E2&E1&!E&!D&!C1&!C&!B&A1&!A|E2&E1&!E&!D&!C1&!C&!B&A1&!A|E2&!E1&!E&!D&!C1&!C&!B&A1&!A|!E2&!E1&!E&!D&!C1&!C&!B&A1&!A|!E2&!E1&!E&!D&!C1&!C&!B&A1&A|E2&!E1&!E&!D&!C1&!C&!B&A1&A|E2&E1&!E&!D&!C1&!C&!B&A1&A|!E2&E1&!E&!D&!C1&!C&!B&A1&A|!E2&E1&E&!D&!C1&!C&!B&A1&A|E2&E1&E&!D&!C1&!C&!B&A1&A|E2&!E1&E&!D&!C1&!C&!B&A1&A|!E2&!E1&E&!D&!C1&!C&!B&A1&A|!E2&!E1&!E&D&!C1&!C&!B&A1&A|!E2&!E1&!E&D&C1&!C&!B&A1&A|!E2&!E1&!E&!D&C1&!C&!B&A1&A|!E2&!E1&!E&!D&C1&C&!B&A1&A|!E2&!E1&!E&D&C1&C&!B&A1&A|!E2&!E1&!E&D&!C1&C&!B&A1&A|!E2&!E1&!E&!D&!C1&C&!B&A1&A|!E2&!E1&!E&!D&!C1&C&B&A1&A|!E2&!E1&!E&D&!C1&C&B&A1&A|!E2&!E1&!E&D&C1&C&B&A1&A|!E2&!E1&!E&!D&C1&C&B&A1&A|!E2&!E1&!E&!D&C1&!C&B&A1&A|!E2&!E1&!E&D&C1&!C&B&A1&A|!E2&!E1&!E&D&!C1&!C&B&A1&A|!E2&!E1&E&!D&!C1&!C&B&A1&A|E2&!E1&E&!D&!C1&!C&B&A1&A|E2&E1&E&!D&!C1&!C&B&A1&A|!E2&E1&E&!D&!C1&!C&B&A1&A|!E2&E1&!E&!D&!C1&!C&B&A1&A|E2&E1&!E&!D&!C1&!C&B&A1&A|E2&!E1&!E&!D&!C1&!C&B&A1&A|!E2&!E1&!E&!D&!C1&!C&B&A1&A|!E2&!E1&!E&!D&!C1&!C&B&!A1&A|E2&!E1&!E&!D&!C1&!C&B&!A1&A|E2&E1&!E&!D&!C1&!C&B&!A1&A|!E2&E1&!E&!D&!C1&!C&B&!A1&A|!E2&E1&E&!D&!C1&!C&B&!A1&A|E2&E1&E&!D&!C1&!C&B&!A1&A|E2&!E1&E&!D&!C1&!C&B&!A1&A|!E2&!E1&E&!D&!C1&!C&B&!A1&A|!E2&!E1&!E&D&!C1&!C&B&!A1&A|!E2&!E1&!E&D&C1&!C&B&!A1&A|!E2&!E1&!E&!D&C1&!C&B&!A1&A|!E2&!E1&!E&!D&C1&C&B&!A1&A|!E2&!E1&!E&D&C1&C&B&!A1&A|!E2&!E1&!E&D&!C1&C&B&!A1&A|!E2&!E1&!E&!D&!C1&C&B&!A1&A|!E2&!E1&!E&!D&!C1&C&!B&!A1&A|E2&!E1&!E&!D&!C1&C&!B&!A1&A|E2&E1&!E&!D&!C1&C&!B&!A1&A|!E2&E1&!E&!D&!C1&C&!B&!A1&A|!E2&E1&E&!D&!C1&C&!B&!A1&A|E2&E1&E&!D&!C1&C&!B&!A1&A|E2&!E1&E&!D&!C1&C&!B&!A1&A|!E2&!E1&E&!D&!C1&C&!B&!A1&A|!E2&!E1&!E&D&!C1&C&!B&!A1&A|!E2&!E1&!E&D&C1&C&!B&!A1&A|!E2&!E1&E&!D&C1&C&!B&!A1&A|E2&!E1&E&!D&C1&C&!B&!A1&A|E2&E1&E&!D&C1&C&!B&!A1&A|!E2&E1&E&!D&C1&C&!B&!A1&A|!E2&E1&!E&!D&C1&C&!B&!A1&A|E2&E1&!E&!D&C1&C&!B&!A1&A|E2&!E1&!E&!D&C1&C&!B&!A1&A|!E2&!E1&!E&!D&C1&C&!B&!A1&A|!E2&!E1&!E&!D&C1&!C&!B&!A1&A|E2&!E1&!E&!D&C1&!C&!B&!A1&A|E2&E1&!E&!D&C1&!C&!B&!A1&A|!E2&E1&!E&!D&C1&!C&!B&!A1&A|!E2&E1&E&!D&C1&!C&!B&!A1&A|E2&E1&E&!D&C1&!C&!B&!A1&A|E2&!E1&E&!D&C1&!C&!B&!A1&A|!E2&!E1&E&!D&C1&!C&!B&!A1&A|!E2&!E1&!E&D&C1&!C&!B&!A1&A|!E2&!E1&!E&D&!C1&!C&!B&!A1&A|!E2&!E1&E&!D&!C1&!C&!B&!A1&A|E2&!E1&E&!D&!C1&!C&!B&!A1&A|E2&E1&E&!D&!C1&!C&!B&!A1&A|!E2&E1&E&!D&!C1&!C&!B&!A1&A|!E2&E1&!E&!D&!C1&!C&!B&!A1&A|E2&E1&!E&!D&!C1&!C&!B&!A1&A|E2&!E1&!E&!D&!C1&!C&!B&!A1&A|!E2&!E1&!E&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOOAI21213.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAI2131 -l AOOAI2131 -i D C2 C1 C B A1 A -o Y -f Y=!(D&!C2&!C1&C&B&!A1&!A|D&C2&!C1&C&B&!A1&!A|D&C2&C1&C&B&!A1&!A|D&!C2&C1&C&B&!A1&!A|D&!C2&C1&!C&B&!A1&!A|D&C2&C1&!C&B&!A1&!A|D&C2&!C1&!C&B&!A1&!A|D&C2&!C1&!C&B&A1&!A|D&C2&C1&!C&B&A1&!A|D&!C2&C1&!C&B&A1&!A|D&!C2&C1&C&B&A1&!A|D&C2&C1&C&B&A1&!A|D&C2&!C1&C&B&A1&!A|D&!C2&!C1&C&B&A1&!A|D&C2&!C1&!C&!B&A1&A|D&C2&C1&!C&!B&A1&A|D&!C2&C1&!C&!B&A1&A|D&!C2&C1&C&!B&A1&A|D&C2&C1&C&!B&A1&A|D&C2&!C1&C&!B&A1&A|D&!C2&!C1&C&!B&A1&A|D&!C2&!C1&C&B&A1&A|D&C2&!C1&C&B&A1&A|D&C2&C1&C&B&A1&A|D&!C2&C1&C&B&A1&A|D&!C2&C1&!C&B&A1&A|D&C2&C1&!C&B&A1&A|D&C2&!C1&!C&B&A1&A|D&C2&!C1&!C&B&!A1&A|D&C2&C1&!C&B&!A1&A|D&!C2&C1&!C&B&!A1&A|D&!C2&C1&C&B&!A1&A|D&C2&C1&C&B&!A1&A|D&C2&!C1&C&B&!A1&A|D&!C2&!C1&C&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAI2131.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAI322 -l OOOAI322 -i C1 C B1 B A2 A1 A -o Y -f Y=!(C1&!C&!B1&B&A2&!A1&!A|C1&C&!B1&B&A2&!A1&!A|!C1&C&!B1&B&A2&!A1&!A|!C1&C&B1&B&A2&!A1&!A|C1&C&B1&B&A2&!A1&!A|C1&!C&B1&B&A2&!A1&!A|C1&!C&B1&!B&A2&!A1&!A|C1&C&B1&!B&A2&!A1&!A|!C1&C&B1&!B&A2&!A1&!A|!C1&C&B1&!B&A2&A1&!A|C1&C&B1&!B&A2&A1&!A|C1&!C&B1&!B&A2&A1&!A|C1&!C&B1&B&A2&A1&!A|C1&C&B1&B&A2&A1&!A|!C1&C&B1&B&A2&A1&!A|!C1&C&!B1&B&A2&A1&!A|C1&C&!B1&B&A2&A1&!A|C1&!C&!B1&B&A2&A1&!A|C1&!C&!B1&B&!A2&A1&!A|C1&C&!B1&B&!A2&A1&!A|!C1&C&!B1&B&!A2&A1&!A|!C1&C&B1&B&!A2&A1&!A|C1&C&B1&B&!A2&A1&!A|C1&!C&B1&B&!A2&A1&!A|C1&!C&B1&!B&!A2&A1&!A|C1&C&B1&!B&!A2&A1&!A|!C1&C&B1&!B&!A2&A1&!A|!C1&C&B1&!B&!A2&A1&A|C1&C&B1&!B&!A2&A1&A|C1&!C&B1&!B&!A2&A1&A|C1&!C&B1&B&!A2&A1&A|C1&C&B1&B&!A2&A1&A|!C1&C&B1&B&!A2&A1&A|!C1&C&!B1&B&!A2&A1&A|C1&C&!B1&B&!A2&A1&A|C1&!C&!B1&B&!A2&A1&A|C1&!C&!B1&B&A2&A1&A|C1&C&!B1&B&A2&A1&A|!C1&C&!B1&B&A2&A1&A|!C1&C&B1&B&A2&A1&A|C1&C&B1&B&A2&A1&A|C1&!C&B1&B&A2&A1&A|C1&!C&B1&!B&A2&A1&A|C1&C&B1&!B&A2&A1&A|!C1&C&B1&!B&A2&A1&A|!C1&C&B1&!B&A2&!A1&A|C1&C&B1&!B&A2&!A1&A|C1&!C&B1&!B&A2&!A1&A|C1&!C&B1&B&A2&!A1&A|C1&C&B1&B&A2&!A1&A|!C1&C&B1&B&A2&!A1&A|!C1&C&!B1&B&A2&!A1&A|C1&C&!B1&B&A2&!A1&A|C1&!C&!B1&B&A2&!A1&A|C1&!C&!B1&B&!A2&!A1&A|C1&C&!B1&B&!A2&!A1&A|!C1&C&!B1&B&!A2&!A1&A|!C1&C&B1&B&!A2&!A1&A|C1&C&B1&B&!A2&!A1&A|C1&!C&B1&B&!A2&!A1&A|C1&!C&B1&!B&!A2&!A1&A|C1&C&B1&!B&!A2&!A1&A|!C1&C&B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAI322.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOI2131 -l AOOAOI2131 -i D C2 C1 C B A1 A -o Y -f Y=(!D&!C2&!C1&!C&!B&!A1&!A|!D&C2&!C1&!C&!B&!A1&!A|!D&C2&C1&!C&!B&!A1&!A|!D&!C2&C1&!C&!B&!A1&!A|!D&!C2&C1&C&!B&!A1&!A|!D&C2&C1&C&!B&!A1&!A|!D&C2&!C1&C&!B&!A1&!A|!D&!C2&!C1&C&!B&!A1&!A|!D&!C2&!C1&!C&B&!A1&!A|!D&!C2&!C1&!C&B&A1&!A|!D&!C2&!C1&C&!B&A1&!A|!D&C2&!C1&C&!B&A1&!A|!D&C2&C1&C&!B&A1&!A|!D&!C2&C1&C&!B&A1&!A|!D&!C2&C1&!C&!B&A1&!A|!D&C2&C1&!C&!B&A1&!A|!D&C2&!C1&!C&!B&A1&!A|!D&!C2&!C1&!C&!B&A1&!A|!D&!C2&!C1&!C&!B&A1&A|!D&!C2&!C1&!C&B&A1&A|!D&!C2&!C1&!C&B&!A1&A|!D&!C2&!C1&C&!B&!A1&A|!D&C2&!C1&C&!B&!A1&A|!D&C2&C1&C&!B&!A1&A|!D&!C2&C1&C&!B&!A1&A|!D&!C2&C1&!C&!B&!A1&A|!D&C2&C1&!C&!B&!A1&A|!D&C2&!C1&!C&!B&!A1&A|!D&!C2&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOI2131.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOI22211 -l AOOAOI22211 -i E D C1 C B1 B A1 A -o Y -f Y=(!E&!D&!C1&!C&!B1&!B&!A1&!A|!E&D&!C1&!C&!B1&!B&!A1&!A|!E&D&C1&!C&!B1&!B&!A1&!A|!E&!D&C1&!C&!B1&!B&!A1&!A|!E&!D&C1&C&!B1&!B&!A1&!A|!E&D&C1&C&!B1&!B&!A1&!A|!E&D&!C1&C&!B1&!B&!A1&!A|!E&!D&!C1&C&!B1&!B&!A1&!A|!E&!D&!C1&C&B1&!B&!A1&!A|!E&!D&C1&C&B1&!B&!A1&!A|!E&!D&C1&!C&B1&!B&!A1&!A|!E&D&!C1&!C&B1&!B&!A1&!A|!E&!D&!C1&!C&B1&!B&!A1&!A|!E&!D&!C1&!C&B1&B&!A1&!A|!E&D&!C1&!C&B1&B&!A1&!A|!E&!D&C1&!C&B1&B&!A1&!A|!E&!D&C1&C&B1&B&!A1&!A|!E&!D&!C1&C&B1&B&!A1&!A|!E&!D&!C1&C&!B1&B&!A1&!A|!E&!D&C1&C&!B1&B&!A1&!A|!E&!D&C1&!C&!B1&B&!A1&!A|!E&D&!C1&!C&!B1&B&!A1&!A|!E&!D&!C1&!C&!B1&B&!A1&!A|!E&!D&!C1&!C&!B1&B&A1&!A|!E&D&!C1&!C&!B1&B&A1&!A|!E&!D&C1&!C&!B1&B&A1&!A|!E&!D&C1&C&!B1&B&A1&!A|!E&!D&!C1&C&!B1&B&A1&!A|!E&!D&!C1&C&B1&B&A1&!A|!E&!D&C1&C&B1&B&A1&!A|!E&!D&C1&!C&B1&B&A1&!A|!E&D&!C1&!C&B1&B&A1&!A|!E&!D&!C1&!C&B1&B&A1&!A|!E&!D&!C1&!C&B1&!B&A1&!A|!E&D&!C1&!C&B1&!B&A1&!A|!E&!D&C1&!C&B1&!B&A1&!A|!E&!D&C1&C&B1&!B&A1&!A|!E&!D&!C1&C&B1&!B&A1&!A|!E&!D&!C1&C&!B1&!B&A1&!A|!E&D&!C1&C&!B1&!B&A1&!A|!E&D&C1&C&!B1&!B&A1&!A|!E&!D&C1&C&!B1&!B&A1&!A|!E&!D&C1&!C&!B1&!B&A1&!A|!E&D&C1&!C&!B1&!B&A1&!A|!E&D&!C1&!C&!B1&!B&A1&!A|!E&!D&!C1&!C&!B1&!B&A1&!A|!E&!D&!C1&!C&!B1&!B&A1&A|!E&D&!C1&!C&!B1&!B&A1&A|!E&!D&C1&!C&!B1&!B&A1&A|!E&!D&C1&C&!B1&!B&A1&A|!E&!D&!C1&C&!B1&!B&A1&A|!E&!D&!C1&C&B1&!B&A1&A|!E&!D&C1&C&B1&!B&A1&A|!E&!D&C1&!C&B1&!B&A1&A|!E&D&!C1&!C&B1&!B&A1&A|!E&!D&!C1&!C&B1&!B&A1&A|!E&!D&!C1&!C&B1&B&A1&A|!E&D&!C1&!C&B1&B&A1&A|!E&!D&C1&!C&B1&B&A1&A|!E&!D&C1&C&B1&B&A1&A|!E&!D&!C1&C&B1&B&A1&A|!E&!D&!C1&C&!B1&B&A1&A|!E&!D&C1&C&!B1&B&A1&A|!E&!D&C1&!C&!B1&B&A1&A|!E&D&!C1&!C&!B1&B&A1&A|!E&!D&!C1&!C&!B1&B&A1&A|!E&!D&!C1&!C&!B1&B&!A1&A|!E&D&!C1&!C&!B1&B&!A1&A|!E&!D&C1&!C&!B1&B&!A1&A|!E&!D&C1&C&!B1&B&!A1&A|!E&!D&!C1&C&!B1&B&!A1&A|!E&!D&!C1&C&B1&B&!A1&A|!E&!D&C1&C&B1&B&!A1&A|!E&!D&C1&!C&B1&B&!A1&A|!E&D&!C1&!C&B1&B&!A1&A|!E&!D&!C1&!C&B1&B&!A1&A|!E&!D&!C1&!C&B1&!B&!A1&A|!E&D&!C1&!C&B1&!B&!A1&A|!E&!D&C1&!C&B1&!B&!A1&A|!E&!D&C1&C&B1&!B&!A1&A|!E&!D&!C1&C&B1&!B&!A1&A|!E&!D&!C1&C&!B1&!B&!A1&A|!E&D&!C1&C&!B1&!B&!A1&A|!E&D&C1&C&!B1&!B&!A1&A|!E&!D&C1&C&!B1&!B&!A1&A|!E&!D&C1&!C&!B1&!B&!A1&A|!E&D&C1&!C&!B1&!B&!A1&A|!E&D&!C1&!C&!B1&!B&!A1&A|!E&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOI22211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOI321 -l AAOI321 -i C B1 B A2 A1 A -o Y -f Y=(!C&!B1&!B&!A2&!A1&!A|!C&B1&!B&!A2&!A1&!A|!C&!B1&B&!A2&!A1&!A|!C&!B1&B&A2&!A1&!A|!C&B1&!B&A2&!A1&!A|!C&!B1&!B&A2&!A1&!A|!C&!B1&!B&A2&A1&!A|!C&B1&!B&A2&A1&!A|!C&!B1&B&A2&A1&!A|!C&!B1&B&!A2&A1&!A|!C&B1&!B&!A2&A1&!A|!C&!B1&!B&!A2&A1&!A|!C&!B1&!B&!A2&A1&A|!C&B1&!B&!A2&A1&A|!C&!B1&B&!A2&A1&A|!C&!B1&!B&A2&!A1&A|!C&B1&!B&A2&!A1&A|!C&!B1&B&A2&!A1&A|!C&!B1&B&!A2&!A1&A|!C&B1&!B&!A2&!A1&A|!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOI321.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOAI21121 -l AOAAOAI21121 -i E D1 D C B A1 A -o Y -f Y=!(E&D1&D&!C&!B&!A1&!A|E&D1&D&C&!B&!A1&!A|E&!D1&!D&C&B&!A1&!A|E&D1&!D&C&B&!A1&!A|E&D1&D&C&B&!A1&!A|E&!D1&D&C&B&!A1&!A|E&D1&D&!C&B&!A1&!A|E&D1&D&!C&B&A1&!A|E&!D1&D&C&B&A1&!A|E&D1&D&C&B&A1&!A|E&D1&!D&C&B&A1&!A|E&!D1&!D&C&B&A1&!A|E&D1&D&C&!B&A1&!A|E&D1&D&!C&!B&A1&!A|E&D1&D&!C&!B&A1&A|E&!D1&D&C&!B&A1&A|E&D1&D&C&!B&A1&A|E&D1&!D&C&!B&A1&A|E&!D1&!D&C&!B&A1&A|E&!D1&!D&C&B&A1&A|E&D1&!D&C&B&A1&A|E&D1&D&C&B&A1&A|E&!D1&D&C&B&A1&A|E&D1&D&!C&B&A1&A|E&D1&D&!C&B&!A1&A|E&!D1&D&C&B&!A1&A|E&D1&D&C&B&!A1&A|E&D1&!D&C&B&!A1&A|E&!D1&!D&C&B&!A1&A|E&D1&D&C&!B&!A1&A|E&D1&D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOAI21121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAI43 -l OAI43 -i B2 B1 B A3 A2 A1 A -o Y -f Y=!(B2&B1&B&A3&!A2&!A1&!A|B2&B1&B&A3&A2&!A1&!A|B2&B1&B&!A3&A2&!A1&!A|B2&B1&B&!A3&A2&A1&!A|B2&B1&B&A3&A2&A1&!A|B2&B1&B&A3&!A2&A1&!A|B2&B1&B&!A3&!A2&A1&!A|B2&B1&B&!A3&!A2&A1&A|B2&B1&B&A3&!A2&A1&A|B2&B1&B&A3&A2&A1&A|B2&B1&B&!A3&A2&A1&A|B2&B1&B&!A3&A2&!A1&A|B2&B1&B&A3&A2&!A1&A|B2&B1&B&A3&!A2&!A1&A|B2&B1&B&!A3&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAI43.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAOI2223 -l OOOAOI2223 -i D2 D1 D C1 C B1 B A1 A -o Y -f Z=!(!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!D2&!D1&!D&C1&C&B1&B&!A1&!A|!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!D2&!D1&!D&C1&C&!B1&!B&A1&A|!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!D2&!D1&!D&!C1&!C&B1&B&A1&A|!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAOI2223.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOOAI21122 -l AOAAOOAI21122 -i E1 E D1 D C B A1 A -o Y -f Y=!(E1&!E&D1&D&!C&!B&!A1&!A|E1&E&D1&D&!C&!B&!A1&!A|!E1&E&D1&D&!C&!B&!A1&!A|!E1&E&D1&D&C&!B&!A1&!A|E1&E&D1&D&C&!B&!A1&!A|E1&!E&D1&D&C&!B&!A1&!A|E1&!E&!D1&!D&C&B&!A1&!A|E1&E&!D1&!D&C&B&!A1&!A|!E1&E&!D1&!D&C&B&!A1&!A|!E1&E&D1&!D&C&B&!A1&!A|E1&E&D1&!D&C&B&!A1&!A|E1&!E&D1&!D&C&B&!A1&!A|E1&!E&D1&D&C&B&!A1&!A|E1&E&D1&D&C&B&!A1&!A|!E1&E&D1&D&C&B&!A1&!A|!E1&E&!D1&D&C&B&!A1&!A|E1&E&!D1&D&C&B&!A1&!A|E1&!E&!D1&D&C&B&!A1&!A|!E1&E&D1&D&!C&B&!A1&!A|E1&E&D1&D&!C&B&!A1&!A|E1&!E&D1&D&!C&B&!A1&!A|E1&!E&D1&D&!C&B&A1&!A|E1&E&D1&D&!C&B&A1&!A|!E1&E&D1&D&!C&B&A1&!A|E1&!E&!D1&D&C&B&A1&!A|E1&E&!D1&D&C&B&A1&!A|!E1&E&!D1&D&C&B&A1&!A|!E1&E&D1&D&C&B&A1&!A|E1&E&D1&D&C&B&A1&!A|E1&!E&D1&D&C&B&A1&!A|E1&!E&D1&!D&C&B&A1&!A|E1&E&D1&!D&C&B&A1&!A|!E1&E&D1&!D&C&B&A1&!A|!E1&E&!D1&!D&C&B&A1&!A|E1&E&!D1&!D&C&B&A1&!A|E1&!E&!D1&!D&C&B&A1&!A|E1&!E&D1&D&C&!B&A1&!A|E1&E&D1&D&C&!B&A1&!A|!E1&E&D1&D&C&!B&A1&!A|!E1&E&D1&D&!C&!B&A1&!A|E1&E&D1&D&!C&!B&A1&!A|E1&!E&D1&D&!C&!B&A1&!A|E1&!E&D1&D&!C&!B&A1&A|E1&E&D1&D&!C&!B&A1&A|!E1&E&D1&D&!C&!B&A1&A|E1&!E&!D1&D&C&!B&A1&A|E1&E&!D1&D&C&!B&A1&A|!E1&E&!D1&D&C&!B&A1&A|!E1&E&D1&D&C&!B&A1&A|E1&E&D1&D&C&!B&A1&A|E1&!E&D1&D&C&!B&A1&A|E1&!E&D1&!D&C&!B&A1&A|E1&E&D1&!D&C&!B&A1&A|!E1&E&D1&!D&C&!B&A1&A|!E1&E&!D1&!D&C&!B&A1&A|E1&E&!D1&!D&C&!B&A1&A|E1&!E&!D1&!D&C&!B&A1&A|E1&!E&!D1&!D&C&B&A1&A|E1&E&!D1&!D&C&B&A1&A|!E1&E&!D1&!D&C&B&A1&A|!E1&E&D1&!D&C&B&A1&A|E1&E&D1&!D&C&B&A1&A|E1&!E&D1&!D&C&B&A1&A|E1&!E&D1&D&C&B&A1&A|E1&E&D1&D&C&B&A1&A|!E1&E&D1&D&C&B&A1&A|!E1&E&!D1&D&C&B&A1&A|E1&E&!D1&D&C&B&A1&A|E1&!E&!D1&D&C&B&A1&A|!E1&E&D1&D&!C&B&A1&A|E1&E&D1&D&!C&B&A1&A|E1&!E&D1&D&!C&B&A1&A|E1&!E&D1&D&!C&B&!A1&A|E1&E&D1&D&!C&B&!A1&A|!E1&E&D1&D&!C&B&!A1&A|E1&!E&!D1&D&C&B&!A1&A|E1&E&!D1&D&C&B&!A1&A|!E1&E&!D1&D&C&B&!A1&A|!E1&E&D1&D&C&B&!A1&A|E1&E&D1&D&C&B&!A1&A|E1&!E&D1&D&C&B&!A1&A|E1&!E&D1&!D&C&B&!A1&A|E1&E&D1&!D&C&B&!A1&A|!E1&E&D1&!D&C&B&!A1&A|!E1&E&!D1&!D&C&B&!A1&A|E1&E&!D1&!D&C&B&!A1&A|E1&!E&!D1&!D&C&B&!A1&A|E1&!E&D1&D&C&!B&!A1&A|E1&E&D1&D&C&!B&!A1&A|!E1&E&D1&D&C&!B&!A1&A|!E1&E&D1&D&!C&!B&!A1&A|E1&E&D1&D&!C&!B&!A1&A|E1&!E&D1&D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOOAI21122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAOAI22311 -l AAOOAOAI22311 -i E D C2 C1 C B1 B A1 A -o Y -f Y=!(E&D&!C2&!C1&!C&!B1&!B&!A1&!A|E&D&C2&!C1&!C&!B1&!B&!A1&!A|E&D&C2&C1&!C&!B1&!B&!A1&!A|E&D&!C2&C1&!C&!B1&!B&!A1&!A|E&D&!C2&C1&C&!B1&!B&!A1&!A|E&D&C2&C1&C&!B1&!B&!A1&!A|E&D&C2&!C1&C&!B1&!B&!A1&!A|E&D&!C2&!C1&C&!B1&!B&!A1&!A|E&D&!C2&!C1&C&B1&!B&!A1&!A|E&D&C2&!C1&C&B1&!B&!A1&!A|E&D&C2&C1&C&B1&!B&!A1&!A|E&D&!C2&C1&C&B1&!B&!A1&!A|E&D&!C2&C1&!C&B1&!B&!A1&!A|E&D&C2&C1&!C&B1&!B&!A1&!A|E&D&C2&!C1&!C&B1&!B&!A1&!A|E&D&!C2&!C1&!C&B1&!B&!A1&!A|E&D&!C2&!C1&!C&B1&B&!A1&!A|E&D&C2&!C1&!C&B1&B&!A1&!A|E&!D&C2&!C1&!C&B1&B&!A1&!A|E&!D&C2&C1&!C&B1&B&!A1&!A|E&D&C2&C1&!C&B1&B&!A1&!A|E&D&!C2&C1&!C&B1&B&!A1&!A|E&!D&!C2&C1&!C&B1&B&!A1&!A|E&!D&!C2&C1&C&B1&B&!A1&!A|E&D&!C2&C1&C&B1&B&!A1&!A|E&D&C2&C1&C&B1&B&!A1&!A|E&!D&C2&C1&C&B1&B&!A1&!A|E&!D&C2&!C1&C&B1&B&!A1&!A|E&D&C2&!C1&C&B1&B&!A1&!A|E&D&!C2&!C1&C&B1&B&!A1&!A|E&!D&!C2&!C1&C&B1&B&!A1&!A|E&D&!C2&!C1&C&!B1&B&!A1&!A|E&D&C2&!C1&C&!B1&B&!A1&!A|E&D&C2&C1&C&!B1&B&!A1&!A|E&D&!C2&C1&C&!B1&B&!A1&!A|E&D&!C2&C1&!C&!B1&B&!A1&!A|E&D&C2&C1&!C&!B1&B&!A1&!A|E&D&C2&!C1&!C&!B1&B&!A1&!A|E&D&!C2&!C1&!C&!B1&B&!A1&!A|E&D&!C2&!C1&!C&!B1&B&A1&!A|E&D&C2&!C1&!C&!B1&B&A1&!A|E&D&C2&C1&!C&!B1&B&A1&!A|E&D&!C2&C1&!C&!B1&B&A1&!A|E&D&!C2&C1&C&!B1&B&A1&!A|E&D&C2&C1&C&!B1&B&A1&!A|E&D&C2&!C1&C&!B1&B&A1&!A|E&D&!C2&!C1&C&!B1&B&A1&!A|E&!D&!C2&!C1&C&B1&B&A1&!A|E&D&!C2&!C1&C&B1&B&A1&!A|E&D&C2&!C1&C&B1&B&A1&!A|E&!D&C2&!C1&C&B1&B&A1&!A|E&!D&C2&C1&C&B1&B&A1&!A|E&D&C2&C1&C&B1&B&A1&!A|E&D&!C2&C1&C&B1&B&A1&!A|E&!D&!C2&C1&C&B1&B&A1&!A|E&!D&!C2&C1&!C&B1&B&A1&!A|E&D&!C2&C1&!C&B1&B&A1&!A|E&D&C2&C1&!C&B1&B&A1&!A|E&!D&C2&C1&!C&B1&B&A1&!A|E&!D&C2&!C1&!C&B1&B&A1&!A|E&D&C2&!C1&!C&B1&B&A1&!A|E&D&!C2&!C1&!C&B1&B&A1&!A|E&D&!C2&!C1&!C&B1&!B&A1&!A|E&D&C2&!C1&!C&B1&!B&A1&!A|E&D&C2&C1&!C&B1&!B&A1&!A|E&D&!C2&C1&!C&B1&!B&A1&!A|E&D&!C2&C1&C&B1&!B&A1&!A|E&D&C2&C1&C&B1&!B&A1&!A|E&D&C2&!C1&C&B1&!B&A1&!A|E&D&!C2&!C1&C&B1&!B&A1&!A|E&D&!C2&!C1&C&!B1&!B&A1&!A|E&D&C2&!C1&C&!B1&!B&A1&!A|E&D&C2&C1&C&!B1&!B&A1&!A|E&D&!C2&C1&C&!B1&!B&A1&!A|E&D&!C2&C1&!C&!B1&!B&A1&!A|E&D&C2&C1&!C&!B1&!B&A1&!A|E&D&C2&!C1&!C&!B1&!B&A1&!A|E&D&!C2&!C1&!C&!B1&!B&A1&!A|E&D&!C2&!C1&!C&!B1&!B&A1&A|E&D&C2&!C1&!C&!B1&!B&A1&A|E&!D&C2&!C1&!C&!B1&!B&A1&A|E&!D&C2&C1&!C&!B1&!B&A1&A|E&D&C2&C1&!C&!B1&!B&A1&A|E&D&!C2&C1&!C&!B1&!B&A1&A|E&!D&!C2&C1&!C&!B1&!B&A1&A|E&!D&!C2&C1&C&!B1&!B&A1&A|E&D&!C2&C1&C&!B1&!B&A1&A|E&D&C2&C1&C&!B1&!B&A1&A|E&!D&C2&C1&C&!B1&!B&A1&A|E&!D&C2&!C1&C&!B1&!B&A1&A|E&D&C2&!C1&C&!B1&!B&A1&A|E&D&!C2&!C1&C&!B1&!B&A1&A|E&!D&!C2&!C1&C&!B1&!B&A1&A|E&!D&!C2&!C1&C&B1&!B&A1&A|E&D&!C2&!C1&C&B1&!B&A1&A|E&D&C2&!C1&C&B1&!B&A1&A|E&!D&C2&!C1&C&B1&!B&A1&A|E&!D&C2&C1&C&B1&!B&A1&A|E&D&C2&C1&C&B1&!B&A1&A|E&D&!C2&C1&C&B1&!B&A1&A|E&!D&!C2&C1&C&B1&!B&A1&A|E&!D&!C2&C1&!C&B1&!B&A1&A|E&D&!C2&C1&!C&B1&!B&A1&A|E&D&C2&C1&!C&B1&!B&A1&A|E&!D&C2&C1&!C&B1&!B&A1&A|E&!D&C2&!C1&!C&B1&!B&A1&A|E&D&C2&!C1&!C&B1&!B&A1&A|E&D&!C2&!C1&!C&B1&!B&A1&A|E&D&!C2&!C1&!C&B1&B&A1&A|E&D&C2&!C1&!C&B1&B&A1&A|E&!D&C2&!C1&!C&B1&B&A1&A|E&!D&C2&C1&!C&B1&B&A1&A|E&D&C2&C1&!C&B1&B&A1&A|E&D&!C2&C1&!C&B1&B&A1&A|E&!D&!C2&C1&!C&B1&B&A1&A|E&!D&!C2&C1&C&B1&B&A1&A|E&D&!C2&C1&C&B1&B&A1&A|E&D&C2&C1&C&B1&B&A1&A|E&!D&C2&C1&C&B1&B&A1&A|E&!D&C2&!C1&C&B1&B&A1&A|E&D&C2&!C1&C&B1&B&A1&A|E&D&!C2&!C1&C&B1&B&A1&A|E&!D&!C2&!C1&C&B1&B&A1&A|E&!D&!C2&!C1&C&!B1&B&A1&A|E&D&!C2&!C1&C&!B1&B&A1&A|E&D&C2&!C1&C&!B1&B&A1&A|E&!D&C2&!C1&C&!B1&B&A1&A|E&!D&C2&C1&C&!B1&B&A1&A|E&D&C2&C1&C&!B1&B&A1&A|E&D&!C2&C1&C&!B1&B&A1&A|E&!D&!C2&C1&C&!B1&B&A1&A|E&!D&!C2&C1&!C&!B1&B&A1&A|E&D&!C2&C1&!C&!B1&B&A1&A|E&D&C2&C1&!C&!B1&B&A1&A|E&!D&C2&C1&!C&!B1&B&A1&A|E&!D&C2&!C1&!C&!B1&B&A1&A|E&D&C2&!C1&!C&!B1&B&A1&A|E&D&!C2&!C1&!C&!B1&B&A1&A|E&D&!C2&!C1&!C&!B1&B&!A1&A|E&D&C2&!C1&!C&!B1&B&!A1&A|E&D&C2&C1&!C&!B1&B&!A1&A|E&D&!C2&C1&!C&!B1&B&!A1&A|E&D&!C2&C1&C&!B1&B&!A1&A|E&D&C2&C1&C&!B1&B&!A1&A|E&D&C2&!C1&C&!B1&B&!A1&A|E&D&!C2&!C1&C&!B1&B&!A1&A|E&!D&!C2&!C1&C&B1&B&!A1&A|E&D&!C2&!C1&C&B1&B&!A1&A|E&D&C2&!C1&C&B1&B&!A1&A|E&!D&C2&!C1&C&B1&B&!A1&A|E&!D&C2&C1&C&B1&B&!A1&A|E&D&C2&C1&C&B1&B&!A1&A|E&D&!C2&C1&C&B1&B&!A1&A|E&!D&!C2&C1&C&B1&B&!A1&A|E&!D&!C2&C1&!C&B1&B&!A1&A|E&D&!C2&C1&!C&B1&B&!A1&A|E&D&C2&C1&!C&B1&B&!A1&A|E&!D&C2&C1&!C&B1&B&!A1&A|E&!D&C2&!C1&!C&B1&B&!A1&A|E&D&C2&!C1&!C&B1&B&!A1&A|E&D&!C2&!C1&!C&B1&B&!A1&A|E&D&!C2&!C1&!C&B1&!B&!A1&A|E&D&C2&!C1&!C&B1&!B&!A1&A|E&D&C2&C1&!C&B1&!B&!A1&A|E&D&!C2&C1&!C&B1&!B&!A1&A|E&D&!C2&C1&C&B1&!B&!A1&A|E&D&C2&C1&C&B1&!B&!A1&A|E&D&C2&!C1&C&B1&!B&!A1&A|E&D&!C2&!C1&C&B1&!B&!A1&A|E&D&!C2&!C1&C&!B1&!B&!A1&A|E&D&C2&!C1&C&!B1&!B&!A1&A|E&D&C2&C1&C&!B1&!B&!A1&A|E&D&!C2&C1&C&!B1&!B&!A1&A|E&D&!C2&C1&!C&!B1&!B&!A1&A|E&D&C2&C1&!C&!B1&!B&!A1&A|E&D&C2&!C1&!C&!B1&!B&!A1&A|E&D&!C2&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAOAI22311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOAI2212 -l OOAOAI2212 -i D1 D C B1 B A1 A -o Y -f Y=!(D1&D&C&!B1&!B&!A1&!A|D1&D&C&B1&!B&!A1&!A|D1&D&C&B1&B&!A1&!A|D1&D&C&!B1&B&!A1&!A|D1&D&!C&!B1&B&A1&!A|D1&D&C&!B1&B&A1&!A|D1&D&C&B1&B&A1&!A|D1&D&!C&B1&B&A1&!A|D1&D&!C&B1&!B&A1&!A|D1&D&C&B1&!B&A1&!A|D1&D&C&!B1&!B&A1&!A|D1&D&C&!B1&!B&A1&A|D1&D&C&B1&!B&A1&A|D1&D&!C&B1&!B&A1&A|D1&D&!C&B1&B&A1&A|D1&D&C&B1&B&A1&A|D1&D&C&!B1&B&A1&A|D1&D&!C&!B1&B&A1&A|D1&D&!C&!B1&B&!A1&A|D1&D&C&!B1&B&!A1&A|D1&D&C&B1&B&!A1&A|D1&D&!C&B1&B&!A1&A|D1&D&!C&B1&!B&!A1&A|D1&D&C&B1&!B&!A1&A|D1&D&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOAI2212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n MUX7 -l MUX7 -i IN0 IN1 IN2 IN3 IN4 IN5 IN6 S0 S1 S2 S3 S4 S5 S6 -o Z -f 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist MUX7.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOI2112 -l AOAOI2112 -i D1 D C B A1 A -o Y -f Y=(!D1&!D&!C&!B&!A1&!A|!D1&!D&C&!B&!A1&!A|!D1&!D&!C&B&!A1&!A|!D1&!D&!C&B&A1&!A|!D1&!D&C&!B&A1&!A|!D1&!D&!C&!B&A1&!A|!D1&!D&!C&!B&A1&A|!D1&!D&!C&B&A1&A|!D1&!D&!C&B&!A1&A|!D1&!D&C&!B&!A1&A|!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOI2112.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOAOI22111 -l OOAOAOI22111 -i E D C B1 B A1 A -o Y -f Y=(!E&!D&!C&!B1&!B&!A1&!A|!E&D&!C&!B1&!B&!A1&!A|!E&!D&C&!B1&!B&!A1&!A|!E&!D&C&B1&!B&!A1&!A|!E&D&!C&B1&!B&!A1&!A|!E&!D&!C&B1&!B&!A1&!A|!E&!D&!C&B1&B&!A1&!A|!E&D&!C&B1&B&!A1&!A|!E&!D&C&B1&B&!A1&!A|!E&!D&C&!B1&B&!A1&!A|!E&D&!C&!B1&B&!A1&!A|!E&!D&!C&!B1&B&!A1&!A|!E&!D&!C&!B1&B&A1&!A|!E&!D&C&!B1&B&A1&!A|!E&!D&C&B1&B&A1&!A|!E&!D&!C&B1&B&A1&!A|!E&!D&!C&B1&!B&A1&!A|!E&!D&C&B1&!B&A1&!A|!E&!D&C&!B1&!B&A1&!A|!E&D&!C&!B1&!B&A1&!A|!E&!D&!C&!B1&!B&A1&!A|!E&!D&!C&!B1&!B&A1&A|!E&D&!C&!B1&!B&A1&A|!E&!D&C&!B1&!B&A1&A|!E&!D&C&B1&!B&A1&A|!E&!D&!C&B1&!B&A1&A|!E&!D&!C&B1&B&A1&A|!E&!D&C&B1&B&A1&A|!E&!D&C&!B1&B&A1&A|!E&!D&!C&!B1&B&A1&A|!E&!D&!C&!B1&B&!A1&A|!E&!D&C&!B1&B&!A1&A|!E&!D&C&B1&B&!A1&A|!E&!D&!C&B1&B&!A1&A|!E&!D&!C&B1&!B&!A1&A|!E&!D&C&B1&!B&!A1&A|!E&!D&C&!B1&!B&!A1&A|!E&D&!C&!B1&!B&!A1&A|!E&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOAOI22111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOOAOI211121 -l AOAOOAOI211121 -i F E1 E D C B A1 A -o Y -f Y=(!F&!E1&!E&!D&!C&!B&!A1&!A|!F&E1&!E&!D&!C&!B&!A1&!A|!F&E1&E&!D&!C&!B&!A1&!A|!F&!E1&E&!D&!C&!B&!A1&!A|!F&!E1&!E&D&!C&!B&!A1&!A|!F&!E1&!E&D&C&!B&!A1&!A|!F&!E1&E&!D&C&!B&!A1&!A|!F&E1&E&!D&C&!B&!A1&!A|!F&E1&!E&!D&C&!B&!A1&!A|!F&!E1&!E&!D&C&!B&!A1&!A|!F&!E1&!E&!D&C&B&!A1&!A|!F&!E1&!E&D&C&B&!A1&!A|!F&!E1&!E&D&!C&B&!A1&!A|!F&!E1&E&!D&!C&B&!A1&!A|!F&E1&E&!D&!C&B&!A1&!A|!F&E1&!E&!D&!C&B&!A1&!A|!F&!E1&!E&!D&!C&B&!A1&!A|!F&!E1&!E&!D&!C&B&A1&!A|!F&E1&!E&!D&!C&B&A1&!A|!F&E1&E&!D&!C&B&A1&!A|!F&!E1&E&!D&!C&B&A1&!A|!F&!E1&!E&D&!C&B&A1&!A|!F&!E1&!E&D&C&B&A1&!A|!F&!E1&!E&!D&C&B&A1&!A|!F&!E1&!E&!D&C&!B&A1&!A|!F&E1&!E&!D&C&!B&A1&!A|!F&E1&E&!D&C&!B&A1&!A|!F&!E1&E&!D&C&!B&A1&!A|!F&!E1&!E&D&C&!B&A1&!A|!F&!E1&!E&D&!C&!B&A1&!A|!F&!E1&E&!D&!C&!B&A1&!A|!F&E1&E&!D&!C&!B&A1&!A|!F&E1&!E&!D&!C&!B&A1&!A|!F&!E1&!E&!D&!C&!B&A1&!A|!F&!E1&!E&!D&!C&!B&A1&A|!F&E1&!E&!D&!C&!B&A1&A|!F&E1&E&!D&!C&!B&A1&A|!F&!E1&E&!D&!C&!B&A1&A|!F&!E1&!E&D&!C&!B&A1&A|!F&!E1&!E&D&C&!B&A1&A|!F&!E1&!E&!D&C&!B&A1&A|!F&!E1&!E&!D&C&B&A1&A|!F&!E1&!E&D&C&B&A1&A|!F&!E1&!E&D&!C&B&A1&A|!F&!E1&E&!D&!C&B&A1&A|!F&E1&E&!D&!C&B&A1&A|!F&E1&!E&!D&!C&B&A1&A|!F&!E1&!E&!D&!C&B&A1&A|!F&!E1&!E&!D&!C&B&!A1&A|!F&E1&!E&!D&!C&B&!A1&A|!F&E1&E&!D&!C&B&!A1&A|!F&!E1&E&!D&!C&B&!A1&A|!F&!E1&!E&D&!C&B&!A1&A|!F&!E1&!E&D&C&B&!A1&A|!F&!E1&!E&!D&C&B&!A1&A|!F&!E1&!E&!D&C&!B&!A1&A|!F&E1&!E&!D&C&!B&!A1&A|!F&E1&E&!D&C&!B&!A1&A|!F&!E1&E&!D&C&!B&!A1&A|!F&!E1&!E&D&C&!B&!A1&A|!F&!E1&!E&D&!C&!B&!A1&A|!F&!E1&E&!D&!C&!B&!A1&A|!F&E1&E&!D&!C&!B&!A1&A|!F&E1&!E&!D&!C&!B&!A1&A|!F&!E1&!E&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOOAOI211121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOI21212 -l AOOAOI21212 -i E1 E D C1 C B A1 A -o Y -f Y=(!E1&!E&!D&!C1&!C&!B&!A1&!A|!E1&!E&D&!C1&!C&!B&!A1&!A|!E1&!E&D&C1&!C&!B&!A1&!A|!E1&!E&!D&C1&!C&!B&!A1&!A|!E1&!E&!D&C1&C&!B&!A1&!A|!E1&!E&D&C1&C&!B&!A1&!A|!E1&!E&D&!C1&C&!B&!A1&!A|!E1&!E&!D&!C1&C&!B&!A1&!A|!E1&!E&!D&!C1&C&B&!A1&!A|!E1&!E&!D&C1&C&B&!A1&!A|!E1&!E&!D&C1&!C&B&!A1&!A|!E1&!E&D&!C1&!C&B&!A1&!A|!E1&!E&!D&!C1&!C&B&!A1&!A|!E1&!E&!D&!C1&!C&B&A1&!A|!E1&!E&D&!C1&!C&B&A1&!A|!E1&!E&!D&C1&!C&B&A1&!A|!E1&!E&!D&C1&C&B&A1&!A|!E1&!E&!D&!C1&C&B&A1&!A|!E1&!E&!D&!C1&C&!B&A1&!A|!E1&!E&D&!C1&C&!B&A1&!A|!E1&!E&D&C1&C&!B&A1&!A|!E1&!E&!D&C1&C&!B&A1&!A|!E1&!E&!D&C1&!C&!B&A1&!A|!E1&!E&D&C1&!C&!B&A1&!A|!E1&!E&D&!C1&!C&!B&A1&!A|!E1&!E&!D&!C1&!C&!B&A1&!A|!E1&!E&!D&!C1&!C&!B&A1&A|!E1&!E&D&!C1&!C&!B&A1&A|!E1&!E&!D&C1&!C&!B&A1&A|!E1&!E&!D&C1&C&!B&A1&A|!E1&!E&!D&!C1&C&!B&A1&A|!E1&!E&!D&!C1&C&B&A1&A|!E1&!E&!D&C1&C&B&A1&A|!E1&!E&!D&C1&!C&B&A1&A|!E1&!E&D&!C1&!C&B&A1&A|!E1&!E&!D&!C1&!C&B&A1&A|!E1&!E&!D&!C1&!C&B&!A1&A|!E1&!E&D&!C1&!C&B&!A1&A|!E1&!E&!D&C1&!C&B&!A1&A|!E1&!E&!D&C1&C&B&!A1&A|!E1&!E&!D&!C1&C&B&!A1&A|!E1&!E&!D&!C1&C&!B&!A1&A|!E1&!E&D&!C1&C&!B&!A1&A|!E1&!E&D&C1&C&!B&!A1&A|!E1&!E&!D&C1&C&!B&!A1&A|!E1&!E&!D&C1&!C&!B&!A1&A|!E1&!E&D&C1&!C&!B&!A1&A|!E1&!E&D&!C1&!C&!B&!A1&A|!E1&!E&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOI21212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOOAOI21222 -l AOOOAOI21222 -i E1 E D1 D C1 C B A1 A -o Y -f Y=(!E1&!E&!D1&!D&!C1&!C&!B&!A1&!A|!E1&!E&D1&!D&!C1&!C&!B&!A1&!A|!E1&!E&D1&D&!C1&!C&!B&!A1&!A|!E1&!E&!D1&D&!C1&!C&!B&!A1&!A|!E1&!E&!D1&D&C1&!C&!B&!A1&!A|!E1&!E&D1&D&C1&!C&!B&!A1&!A|!E1&!E&D1&!D&C1&!C&!B&!A1&!A|!E1&!E&!D1&!D&C1&!C&!B&!A1&!A|!E1&!E&!D1&!D&C1&C&!B&!A1&!A|!E1&!E&D1&!D&C1&C&!B&!A1&!A|!E1&!E&D1&D&C1&C&!B&!A1&!A|!E1&!E&!D1&D&C1&C&!B&!A1&!A|!E1&!E&!D1&D&!C1&C&!B&!A1&!A|!E1&!E&D1&D&!C1&C&!B&!A1&!A|!E1&!E&D1&!D&!C1&C&!B&!A1&!A|!E1&!E&!D1&!D&!C1&C&!B&!A1&!A|!E1&!E&!D1&!D&!C1&C&B&!A1&!A|!E1&!E&!D1&!D&C1&C&B&!A1&!A|!E1&!E&!D1&!D&C1&!C&B&!A1&!A|!E1&!E&!D1&D&!C1&!C&B&!A1&!A|!E1&!E&D1&D&!C1&!C&B&!A1&!A|!E1&!E&D1&!D&!C1&!C&B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&B&A1&!A|!E1&!E&D1&!D&!C1&!C&B&A1&!A|!E1&!E&D1&D&!C1&!C&B&A1&!A|!E1&!E&!D1&D&!C1&!C&B&A1&!A|!E1&!E&!D1&!D&C1&!C&B&A1&!A|!E1&!E&!D1&!D&C1&C&B&A1&!A|!E1&!E&!D1&!D&!C1&C&B&A1&!A|!E1&!E&!D1&!D&!C1&C&!B&A1&!A|!E1&!E&D1&!D&!C1&C&!B&A1&!A|!E1&!E&D1&D&!C1&C&!B&A1&!A|!E1&!E&!D1&D&!C1&C&!B&A1&!A|!E1&!E&!D1&D&C1&C&!B&A1&!A|!E1&!E&D1&D&C1&C&!B&A1&!A|!E1&!E&D1&!D&C1&C&!B&A1&!A|!E1&!E&!D1&!D&C1&C&!B&A1&!A|!E1&!E&!D1&!D&C1&!C&!B&A1&!A|!E1&!E&D1&!D&C1&!C&!B&A1&!A|!E1&!E&D1&D&C1&!C&!B&A1&!A|!E1&!E&!D1&D&C1&!C&!B&A1&!A|!E1&!E&!D1&D&!C1&!C&!B&A1&!A|!E1&!E&D1&D&!C1&!C&!B&A1&!A|!E1&!E&D1&!D&!C1&!C&!B&A1&!A|!E1&!E&!D1&!D&!C1&!C&!B&A1&!A|!E1&!E&!D1&!D&!C1&!C&!B&A1&A|!E1&!E&D1&!D&!C1&!C&!B&A1&A|!E1&!E&D1&D&!C1&!C&!B&A1&A|!E1&!E&!D1&D&!C1&!C&!B&A1&A|!E1&!E&!D1&!D&C1&!C&!B&A1&A|!E1&!E&!D1&!D&C1&C&!B&A1&A|!E1&!E&!D1&!D&!C1&C&!B&A1&A|!E1&!E&!D1&!D&!C1&C&B&A1&A|!E1&!E&!D1&!D&C1&C&B&A1&A|!E1&!E&!D1&!D&C1&!C&B&A1&A|!E1&!E&!D1&D&!C1&!C&B&A1&A|!E1&!E&D1&D&!C1&!C&B&A1&A|!E1&!E&D1&!D&!C1&!C&B&A1&A|!E1&!E&!D1&!D&!C1&!C&B&A1&A|!E1&!E&!D1&!D&!C1&!C&B&!A1&A|!E1&!E&D1&!D&!C1&!C&B&!A1&A|!E1&!E&D1&D&!C1&!C&B&!A1&A|!E1&!E&!D1&D&!C1&!C&B&!A1&A|!E1&!E&!D1&!D&C1&!C&B&!A1&A|!E1&!E&!D1&!D&C1&C&B&!A1&A|!E1&!E&!D1&!D&!C1&C&B&!A1&A|!E1&!E&!D1&!D&!C1&C&!B&!A1&A|!E1&!E&D1&!D&!C1&C&!B&!A1&A|!E1&!E&D1&D&!C1&C&!B&!A1&A|!E1&!E&!D1&D&!C1&C&!B&!A1&A|!E1&!E&!D1&D&C1&C&!B&!A1&A|!E1&!E&D1&D&C1&C&!B&!A1&A|!E1&!E&D1&!D&C1&C&!B&!A1&A|!E1&!E&!D1&!D&C1&C&!B&!A1&A|!E1&!E&!D1&!D&C1&!C&!B&!A1&A|!E1&!E&D1&!D&C1&!C&!B&!A1&A|!E1&!E&D1&D&C1&!C&!B&!A1&A|!E1&!E&!D1&D&C1&!C&!B&!A1&A|!E1&!E&!D1&D&!C1&!C&!B&!A1&A|!E1&!E&D1&D&!C1&!C&!B&!A1&A|!E1&!E&D1&!D&!C1&!C&!B&!A1&A|!E1&!E&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOOAOI21222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOAOI221311 -l AAOAAOAOI221311 -i F E D2 D1 D C B1 B A1 A -o Y -f Y=(!F&!E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!F&E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!F&E&D2&!D1&!D&!C&!B1&!B&!A1&!A|!F&!E&D2&!D1&!D&!C&!B1&!B&!A1&!A|!F&!E&D2&D1&!D&!C&!B1&!B&!A1&!A|!F&E&D2&D1&!D&!C&!B1&!B&!A1&!A|!F&E&!D2&D1&!D&!C&!B1&!B&!A1&!A|!F&!E&!D2&D1&!D&!C&!B1&!B&!A1&!A|!F&!E&!D2&D1&D&!C&!B1&!B&!A1&!A|!F&E&!D2&D1&D&!C&!B1&!B&!A1&!A|!F&!E&D2&D1&D&!C&!B1&!B&!A1&!A|!F&!E&D2&!D1&D&!C&!B1&!B&!A1&!A|!F&E&D2&!D1&D&!C&!B1&!B&!A1&!A|!F&E&!D2&!D1&D&!C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&D&!C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&D&C&!B1&!B&!A1&!A|!F&E&!D2&!D1&D&C&!B1&!B&!A1&!A|!F&E&D2&!D1&D&C&!B1&!B&!A1&!A|!F&!E&D2&!D1&D&C&!B1&!B&!A1&!A|!F&!E&D2&D1&D&C&!B1&!B&!A1&!A|!F&E&!D2&D1&D&C&!B1&!B&!A1&!A|!F&!E&!D2&D1&D&C&!B1&!B&!A1&!A|!F&!E&!D2&D1&!D&C&!B1&!B&!A1&!A|!F&E&!D2&D1&!D&C&!B1&!B&!A1&!A|!F&E&D2&D1&!D&C&!B1&!B&!A1&!A|!F&!E&D2&D1&!D&C&!B1&!B&!A1&!A|!F&!E&D2&!D1&!D&C&!B1&!B&!A1&!A|!F&E&D2&!D1&!D&C&!B1&!B&!A1&!A|!F&E&!D2&!D1&!D&C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&C&B1&!B&!A1&!A|!F&E&!D2&!D1&!D&C&B1&!B&!A1&!A|!F&E&D2&!D1&!D&C&B1&!B&!A1&!A|!F&!E&D2&!D1&!D&C&B1&!B&!A1&!A|!F&!E&D2&D1&!D&C&B1&!B&!A1&!A|!F&E&D2&D1&!D&C&B1&!B&!A1&!A|!F&E&!D2&D1&!D&C&B1&!B&!A1&!A|!F&!E&!D2&D1&!D&C&B1&!B&!A1&!A|!F&!E&!D2&D1&D&C&B1&!B&!A1&!A|!F&E&!D2&D1&D&C&B1&!B&!A1&!A|!F&!E&D2&D1&D&C&B1&!B&!A1&!A|!F&!E&D2&!D1&D&C&B1&!B&!A1&!A|!F&E&D2&!D1&D&C&B1&!B&!A1&!A|!F&E&!D2&!D1&D&C&B1&!B&!A1&!A|!F&!E&!D2&!D1&D&C&B1&!B&!A1&!A|!F&!E&!D2&!D1&D&!C&B1&!B&!A1&!A|!F&E&!D2&!D1&D&!C&B1&!B&!A1&!A|!F&E&D2&!D1&D&!C&B1&!B&!A1&!A|!F&!E&D2&!D1&D&!C&B1&!B&!A1&!A|!F&!E&D2&D1&D&!C&B1&!B&!A1&!A|!F&E&!D2&D1&D&!C&B1&!B&!A1&!A|!F&!E&!D2&D1&D&!C&B1&!B&!A1&!A|!F&!E&!D2&D1&!D&!C&B1&!B&!A1&!A|!F&E&!D2&D1&!D&!C&B1&!B&!A1&!A|!F&E&D2&D1&!D&!C&B1&!B&!A1&!A|!F&!E&D2&D1&!D&!C&B1&!B&!A1&!A|!F&!E&D2&!D1&!D&!C&B1&!B&!A1&!A|!F&E&D2&!D1&!D&!C&B1&!B&!A1&!A|!F&E&!D2&!D1&!D&!C&B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C&B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C&B1&B&!A1&!A|!F&E&!D2&!D1&!D&!C&B1&B&!A1&!A|!F&E&D2&!D1&!D&!C&B1&B&!A1&!A|!F&!E&D2&!D1&!D&!C&B1&B&!A1&!A|!F&!E&D2&D1&!D&!C&B1&B&!A1&!A|!F&E&D2&D1&!D&!C&B1&B&!A1&!A|!F&E&!D2&D1&!D&!C&B1&B&!A1&!A|!F&!E&!D2&D1&!D&!C&B1&B&!A1&!A|!F&!E&!D2&D1&D&!C&B1&B&!A1&!A|!F&E&!D2&D1&D&!C&B1&B&!A1&!A|!F&!E&D2&D1&D&!C&B1&B&!A1&!A|!F&!E&D2&!D1&D&!C&B1&B&!A1&!A|!F&E&D2&!D1&D&!C&B1&B&!A1&!A|!F&E&!D2&!D1&D&!C&B1&B&!A1&!A|!F&!E&!D2&!D1&D&!C&B1&B&!A1&!A|!F&!E&!D2&!D1&D&C&B1&B&!A1&!A|!F&!E&D2&!D1&D&C&B1&B&!A1&!A|!F&!E&D2&D1&D&C&B1&B&!A1&!A|!F&!E&!D2&D1&D&C&B1&B&!A1&!A|!F&!E&!D2&D1&!D&C&B1&B&!A1&!A|!F&!E&D2&D1&!D&C&B1&B&!A1&!A|!F&!E&D2&!D1&!D&C&B1&B&!A1&!A|!F&!E&!D2&!D1&!D&C&B1&B&!A1&!A|!F&!E&!D2&!D1&!D&C&!B1&B&!A1&!A|!F&E&!D2&!D1&!D&C&!B1&B&!A1&!A|!F&E&D2&!D1&!D&C&!B1&B&!A1&!A|!F&!E&D2&!D1&!D&C&!B1&B&!A1&!A|!F&!E&D2&D1&!D&C&!B1&B&!A1&!A|!F&E&D2&D1&!D&C&!B1&B&!A1&!A|!F&E&!D2&D1&!D&C&!B1&B&!A1&!A|!F&!E&!D2&D1&!D&C&!B1&B&!A1&!A|!F&!E&!D2&D1&D&C&!B1&B&!A1&!A|!F&E&!D2&D1&D&C&!B1&B&!A1&!A|!F&!E&D2&D1&D&C&!B1&B&!A1&!A|!F&!E&D2&!D1&D&C&!B1&B&!A1&!A|!F&E&D2&!D1&D&C&!B1&B&!A1&!A|!F&E&!D2&!D1&D&C&!B1&B&!A1&!A|!F&!E&!D2&!D1&D&C&!B1&B&!A1&!A|!F&!E&!D2&!D1&D&!C&!B1&B&!A1&!A|!F&E&!D2&!D1&D&!C&!B1&B&!A1&!A|!F&E&D2&!D1&D&!C&!B1&B&!A1&!A|!F&!E&D2&!D1&D&!C&!B1&B&!A1&!A|!F&!E&D2&D1&D&!C&!B1&B&!A1&!A|!F&E&!D2&D1&D&!C&!B1&B&!A1&!A|!F&!E&!D2&D1&D&!C&!B1&B&!A1&!A|!F&!E&!D2&D1&!D&!C&!B1&B&!A1&!A|!F&E&!D2&D1&!D&!C&!B1&B&!A1&!A|!F&E&D2&D1&!D&!C&!B1&B&!A1&!A|!F&!E&D2&D1&!D&!C&!B1&B&!A1&!A|!F&!E&D2&!D1&!D&!C&!B1&B&!A1&!A|!F&E&D2&!D1&!D&!C&!B1&B&!A1&!A|!F&E&!D2&!D1&!D&!C&!B1&B&!A1&!A|!F&!E&!D2&!D1&!D&!C&!B1&B&!A1&!A|!F&!E&!D2&!D1&!D&!C&!B1&B&A1&!A|!F&E&!D2&!D1&!D&!C&!B1&B&A1&!A|!F&E&D2&!D1&!D&!C&!B1&B&A1&!A|!F&!E&D2&!D1&!D&!C&!B1&B&A1&!A|!F&!E&D2&D1&!D&!C&!B1&B&A1&!A|!F&E&D2&D1&!D&!C&!B1&B&A1&!A|!F&E&!D2&D1&!D&!C&!B1&B&A1&!A|!F&!E&!D2&D1&!D&!C&!B1&B&A1&!A|!F&!E&!D2&D1&D&!C&!B1&B&A1&!A|!F&E&!D2&D1&D&!C&!B1&B&A1&!A|!F&!E&D2&D1&D&!C&!B1&B&A1&!A|!F&!E&D2&!D1&D&!C&!B1&B&A1&!A|!F&E&D2&!D1&D&!C&!B1&B&A1&!A|!F&E&!D2&!D1&D&!C&!B1&B&A1&!A|!F&!E&!D2&!D1&D&!C&!B1&B&A1&!A|!F&!E&!D2&!D1&D&C&!B1&B&A1&!A|!F&E&!D2&!D1&D&C&!B1&B&A1&!A|!F&E&D2&!D1&D&C&!B1&B&A1&!A|!F&!E&D2&!D1&D&C&!B1&B&A1&!A|!F&!E&D2&D1&D&C&!B1&B&A1&!A|!F&E&!D2&D1&D&C&!B1&B&A1&!A|!F&!E&!D2&D1&D&C&!B1&B&A1&!A|!F&!E&!D2&D1&!D&C&!B1&B&A1&!A|!F&E&!D2&D1&!D&C&!B1&B&A1&!A|!F&E&D2&D1&!D&C&!B1&B&A1&!A|!F&!E&D2&D1&!D&C&!B1&B&A1&!A|!F&!E&D2&!D1&!D&C&!B1&B&A1&!A|!F&E&D2&!D1&!D&C&!B1&B&A1&!A|!F&E&!D2&!D1&!D&C&!B1&B&A1&!A|!F&!E&!D2&!D1&!D&C&!B1&B&A1&!A|!F&!E&!D2&!D1&!D&C&B1&B&A1&!A|!F&!E&D2&!D1&!D&C&B1&B&A1&!A|!F&!E&D2&D1&!D&C&B1&B&A1&!A|!F&!E&!D2&D1&!D&C&B1&B&A1&!A|!F&!E&!D2&D1&D&C&B1&B&A1&!A|!F&!E&D2&D1&D&C&B1&B&A1&!A|!F&!E&D2&!D1&D&C&B1&B&A1&!A|!F&!E&!D2&!D1&D&C&B1&B&A1&!A|!F&!E&!D2&!D1&D&!C&B1&B&A1&!A|!F&E&!D2&!D1&D&!C&B1&B&A1&!A|!F&E&D2&!D1&D&!C&B1&B&A1&!A|!F&!E&D2&!D1&D&!C&B1&B&A1&!A|!F&!E&D2&D1&D&!C&B1&B&A1&!A|!F&E&!D2&D1&D&!C&B1&B&A1&!A|!F&!E&!D2&D1&D&!C&B1&B&A1&!A|!F&!E&!D2&D1&!D&!C&B1&B&A1&!A|!F&E&!D2&D1&!D&!C&B1&B&A1&!A|!F&E&D2&D1&!D&!C&B1&B&A1&!A|!F&!E&D2&D1&!D&!C&B1&B&A1&!A|!F&!E&D2&!D1&!D&!C&B1&B&A1&!A|!F&E&D2&!D1&!D&!C&B1&B&A1&!A|!F&E&!D2&!D1&!D&!C&B1&B&A1&!A|!F&!E&!D2&!D1&!D&!C&B1&B&A1&!A|!F&!E&!D2&!D1&!D&!C&B1&!B&A1&!A|!F&E&!D2&!D1&!D&!C&B1&!B&A1&!A|!F&E&D2&!D1&!D&!C&B1&!B&A1&!A|!F&!E&D2&!D1&!D&!C&B1&!B&A1&!A|!F&!E&D2&D1&!D&!C&B1&!B&A1&!A|!F&E&D2&D1&!D&!C&B1&!B&A1&!A|!F&E&!D2&D1&!D&!C&B1&!B&A1&!A|!F&!E&!D2&D1&!D&!C&B1&!B&A1&!A|!F&!E&!D2&D1&D&!C&B1&!B&A1&!A|!F&E&!D2&D1&D&!C&B1&!B&A1&!A|!F&!E&D2&D1&D&!C&B1&!B&A1&!A|!F&!E&D2&!D1&D&!C&B1&!B&A1&!A|!F&E&D2&!D1&D&!C&B1&!B&A1&!A|!F&E&!D2&!D1&D&!C&B1&!B&A1&!A|!F&!E&!D2&!D1&D&!C&B1&!B&A1&!A|!F&!E&!D2&!D1&D&C&B1&!B&A1&!A|!F&E&!D2&!D1&D&C&B1&!B&A1&!A|!F&E&D2&!D1&D&C&B1&!B&A1&!A|!F&!E&D2&!D1&D&C&B1&!B&A1&!A|!F&!E&D2&D1&D&C&B1&!B&A1&!A|!F&E&!D2&D1&D&C&B1&!B&A1&!A|!F&!E&!D2&D1&D&C&B1&!B&A1&!A|!F&!E&!D2&D1&!D&C&B1&!B&A1&!A|!F&E&!D2&D1&!D&C&B1&!B&A1&!A|!F&E&D2&D1&!D&C&B1&!B&A1&!A|!F&!E&D2&D1&!D&C&B1&!B&A1&!A|!F&!E&D2&!D1&!D&C&B1&!B&A1&!A|!F&E&D2&!D1&!D&C&B1&!B&A1&!A|!F&E&!D2&!D1&!D&C&B1&!B&A1&!A|!F&!E&!D2&!D1&!D&C&B1&!B&A1&!A|!F&!E&!D2&!D1&!D&C&!B1&!B&A1&!A|!F&E&!D2&!D1&!D&C&!B1&!B&A1&!A|!F&E&D2&!D1&!D&C&!B1&!B&A1&!A|!F&!E&D2&!D1&!D&C&!B1&!B&A1&!A|!F&!E&D2&D1&!D&C&!B1&!B&A1&!A|!F&E&D2&D1&!D&C&!B1&!B&A1&!A|!F&E&!D2&D1&!D&C&!B1&!B&A1&!A|!F&!E&!D2&D1&!D&C&!B1&!B&A1&!A|!F&!E&!D2&D1&D&C&!B1&!B&A1&!A|!F&E&!D2&D1&D&C&!B1&!B&A1&!A|!F&!E&D2&D1&D&C&!B1&!B&A1&!A|!F&!E&D2&!D1&D&C&!B1&!B&A1&!A|!F&E&D2&!D1&D&C&!B1&!B&A1&!A|!F&E&!D2&!D1&D&C&!B1&!B&A1&!A|!F&!E&!D2&!D1&D&C&!B1&!B&A1&!A|!F&!E&!D2&!D1&D&!C&!B1&!B&A1&!A|!F&E&!D2&!D1&D&!C&!B1&!B&A1&!A|!F&E&D2&!D1&D&!C&!B1&!B&A1&!A|!F&!E&D2&!D1&D&!C&!B1&!B&A1&!A|!F&!E&D2&D1&D&!C&!B1&!B&A1&!A|!F&E&!D2&D1&D&!C&!B1&!B&A1&!A|!F&!E&!D2&D1&D&!C&!B1&!B&A1&!A|!F&!E&!D2&D1&!D&!C&!B1&!B&A1&!A|!F&E&!D2&D1&!D&!C&!B1&!B&A1&!A|!F&E&D2&D1&!D&!C&!B1&!B&A1&!A|!F&!E&D2&D1&!D&!C&!B1&!B&A1&!A|!F&!E&D2&!D1&!D&!C&!B1&!B&A1&!A|!F&E&D2&!D1&!D&!C&!B1&!B&A1&!A|!F&E&!D2&!D1&!D&!C&!B1&!B&A1&!A|!F&!E&!D2&!D1&!D&!C&!B1&!B&A1&!A|!F&!E&!D2&!D1&!D&!C&!B1&!B&A1&A|!F&E&!D2&!D1&!D&!C&!B1&!B&A1&A|!F&E&D2&!D1&!D&!C&!B1&!B&A1&A|!F&!E&D2&!D1&!D&!C&!B1&!B&A1&A|!F&!E&D2&D1&!D&!C&!B1&!B&A1&A|!F&E&D2&D1&!D&!C&!B1&!B&A1&A|!F&E&!D2&D1&!D&!C&!B1&!B&A1&A|!F&!E&!D2&D1&!D&!C&!B1&!B&A1&A|!F&!E&!D2&D1&D&!C&!B1&!B&A1&A|!F&E&!D2&D1&D&!C&!B1&!B&A1&A|!F&!E&D2&D1&D&!C&!B1&!B&A1&A|!F&!E&D2&!D1&D&!C&!B1&!B&A1&A|!F&E&D2&!D1&D&!C&!B1&!B&A1&A|!F&E&!D2&!D1&D&!C&!B1&!B&A1&A|!F&!E&!D2&!D1&D&!C&!B1&!B&A1&A|!F&!E&!D2&!D1&D&C&!B1&!B&A1&A|!F&!E&D2&!D1&D&C&!B1&!B&A1&A|!F&!E&D2&D1&D&C&!B1&!B&A1&A|!F&!E&!D2&D1&D&C&!B1&!B&A1&A|!F&!E&!D2&D1&!D&C&!B1&!B&A1&A|!F&!E&D2&D1&!D&C&!B1&!B&A1&A|!F&!E&D2&!D1&!D&C&!B1&!B&A1&A|!F&!E&!D2&!D1&!D&C&!B1&!B&A1&A|!F&!E&!D2&!D1&!D&C&B1&!B&A1&A|!F&!E&D2&!D1&!D&C&B1&!B&A1&A|!F&!E&D2&D1&!D&C&B1&!B&A1&A|!F&!E&!D2&D1&!D&C&B1&!B&A1&A|!F&!E&!D2&D1&D&C&B1&!B&A1&A|!F&!E&D2&D1&D&C&B1&!B&A1&A|!F&!E&D2&!D1&D&C&B1&!B&A1&A|!F&!E&!D2&!D1&D&C&B1&!B&A1&A|!F&!E&!D2&!D1&D&!C&B1&!B&A1&A|!F&E&!D2&!D1&D&!C&B1&!B&A1&A|!F&E&D2&!D1&D&!C&B1&!B&A1&A|!F&!E&D2&!D1&D&!C&B1&!B&A1&A|!F&!E&D2&D1&D&!C&B1&!B&A1&A|!F&E&!D2&D1&D&!C&B1&!B&A1&A|!F&!E&!D2&D1&D&!C&B1&!B&A1&A|!F&!E&!D2&D1&!D&!C&B1&!B&A1&A|!F&E&!D2&D1&!D&!C&B1&!B&A1&A|!F&E&D2&D1&!D&!C&B1&!B&A1&A|!F&!E&D2&D1&!D&!C&B1&!B&A1&A|!F&!E&D2&!D1&!D&!C&B1&!B&A1&A|!F&E&D2&!D1&!D&!C&B1&!B&A1&A|!F&E&!D2&!D1&!D&!C&B1&!B&A1&A|!F&!E&!D2&!D1&!D&!C&B1&!B&A1&A|!F&!E&!D2&!D1&!D&!C&B1&B&A1&A|!F&E&!D2&!D1&!D&!C&B1&B&A1&A|!F&E&D2&!D1&!D&!C&B1&B&A1&A|!F&!E&D2&!D1&!D&!C&B1&B&A1&A|!F&!E&D2&D1&!D&!C&B1&B&A1&A|!F&E&D2&D1&!D&!C&B1&B&A1&A|!F&E&!D2&D1&!D&!C&B1&B&A1&A|!F&!E&!D2&D1&!D&!C&B1&B&A1&A|!F&!E&!D2&D1&D&!C&B1&B&A1&A|!F&E&!D2&D1&D&!C&B1&B&A1&A|!F&!E&D2&D1&D&!C&B1&B&A1&A|!F&!E&D2&!D1&D&!C&B1&B&A1&A|!F&E&D2&!D1&D&!C&B1&B&A1&A|!F&E&!D2&!D1&D&!C&B1&B&A1&A|!F&!E&!D2&!D1&D&!C&B1&B&A1&A|!F&!E&!D2&!D1&D&C&B1&B&A1&A|!F&!E&D2&!D1&D&C&B1&B&A1&A|!F&!E&D2&D1&D&C&B1&B&A1&A|!F&!E&!D2&D1&D&C&B1&B&A1&A|!F&!E&!D2&D1&!D&C&B1&B&A1&A|!F&!E&D2&D1&!D&C&B1&B&A1&A|!F&!E&D2&!D1&!D&C&B1&B&A1&A|!F&!E&!D2&!D1&!D&C&B1&B&A1&A|!F&!E&!D2&!D1&!D&C&!B1&B&A1&A|!F&!E&D2&!D1&!D&C&!B1&B&A1&A|!F&!E&D2&D1&!D&C&!B1&B&A1&A|!F&!E&!D2&D1&!D&C&!B1&B&A1&A|!F&!E&!D2&D1&D&C&!B1&B&A1&A|!F&!E&D2&D1&D&C&!B1&B&A1&A|!F&!E&D2&!D1&D&C&!B1&B&A1&A|!F&!E&!D2&!D1&D&C&!B1&B&A1&A|!F&!E&!D2&!D1&D&!C&!B1&B&A1&A|!F&E&!D2&!D1&D&!C&!B1&B&A1&A|!F&E&D2&!D1&D&!C&!B1&B&A1&A|!F&!E&D2&!D1&D&!C&!B1&B&A1&A|!F&!E&D2&D1&D&!C&!B1&B&A1&A|!F&E&!D2&D1&D&!C&!B1&B&A1&A|!F&!E&!D2&D1&D&!C&!B1&B&A1&A|!F&!E&!D2&D1&!D&!C&!B1&B&A1&A|!F&E&!D2&D1&!D&!C&!B1&B&A1&A|!F&E&D2&D1&!D&!C&!B1&B&A1&A|!F&!E&D2&D1&!D&!C&!B1&B&A1&A|!F&!E&D2&!D1&!D&!C&!B1&B&A1&A|!F&E&D2&!D1&!D&!C&!B1&B&A1&A|!F&E&!D2&!D1&!D&!C&!B1&B&A1&A|!F&!E&!D2&!D1&!D&!C&!B1&B&A1&A|!F&!E&!D2&!D1&!D&!C&!B1&B&!A1&A|!F&E&!D2&!D1&!D&!C&!B1&B&!A1&A|!F&E&D2&!D1&!D&!C&!B1&B&!A1&A|!F&!E&D2&!D1&!D&!C&!B1&B&!A1&A|!F&!E&D2&D1&!D&!C&!B1&B&!A1&A|!F&E&D2&D1&!D&!C&!B1&B&!A1&A|!F&E&!D2&D1&!D&!C&!B1&B&!A1&A|!F&!E&!D2&D1&!D&!C&!B1&B&!A1&A|!F&!E&!D2&D1&D&!C&!B1&B&!A1&A|!F&E&!D2&D1&D&!C&!B1&B&!A1&A|!F&!E&D2&D1&D&!C&!B1&B&!A1&A|!F&!E&D2&!D1&D&!C&!B1&B&!A1&A|!F&E&D2&!D1&D&!C&!B1&B&!A1&A|!F&E&!D2&!D1&D&!C&!B1&B&!A1&A|!F&!E&!D2&!D1&D&!C&!B1&B&!A1&A|!F&!E&!D2&!D1&D&C&!B1&B&!A1&A|!F&E&!D2&!D1&D&C&!B1&B&!A1&A|!F&E&D2&!D1&D&C&!B1&B&!A1&A|!F&!E&D2&!D1&D&C&!B1&B&!A1&A|!F&!E&D2&D1&D&C&!B1&B&!A1&A|!F&E&!D2&D1&D&C&!B1&B&!A1&A|!F&!E&!D2&D1&D&C&!B1&B&!A1&A|!F&!E&!D2&D1&!D&C&!B1&B&!A1&A|!F&E&!D2&D1&!D&C&!B1&B&!A1&A|!F&E&D2&D1&!D&C&!B1&B&!A1&A|!F&!E&D2&D1&!D&C&!B1&B&!A1&A|!F&!E&D2&!D1&!D&C&!B1&B&!A1&A|!F&E&D2&!D1&!D&C&!B1&B&!A1&A|!F&E&!D2&!D1&!D&C&!B1&B&!A1&A|!F&!E&!D2&!D1&!D&C&!B1&B&!A1&A|!F&!E&!D2&!D1&!D&C&B1&B&!A1&A|!F&!E&D2&!D1&!D&C&B1&B&!A1&A|!F&!E&D2&D1&!D&C&B1&B&!A1&A|!F&!E&!D2&D1&!D&C&B1&B&!A1&A|!F&!E&!D2&D1&D&C&B1&B&!A1&A|!F&!E&D2&D1&D&C&B1&B&!A1&A|!F&!E&D2&!D1&D&C&B1&B&!A1&A|!F&!E&!D2&!D1&D&C&B1&B&!A1&A|!F&!E&!D2&!D1&D&!C&B1&B&!A1&A|!F&E&!D2&!D1&D&!C&B1&B&!A1&A|!F&E&D2&!D1&D&!C&B1&B&!A1&A|!F&!E&D2&!D1&D&!C&B1&B&!A1&A|!F&!E&D2&D1&D&!C&B1&B&!A1&A|!F&E&!D2&D1&D&!C&B1&B&!A1&A|!F&!E&!D2&D1&D&!C&B1&B&!A1&A|!F&!E&!D2&D1&!D&!C&B1&B&!A1&A|!F&E&!D2&D1&!D&!C&B1&B&!A1&A|!F&E&D2&D1&!D&!C&B1&B&!A1&A|!F&!E&D2&D1&!D&!C&B1&B&!A1&A|!F&!E&D2&!D1&!D&!C&B1&B&!A1&A|!F&E&D2&!D1&!D&!C&B1&B&!A1&A|!F&E&!D2&!D1&!D&!C&B1&B&!A1&A|!F&!E&!D2&!D1&!D&!C&B1&B&!A1&A|!F&!E&!D2&!D1&!D&!C&B1&!B&!A1&A|!F&E&!D2&!D1&!D&!C&B1&!B&!A1&A|!F&E&D2&!D1&!D&!C&B1&!B&!A1&A|!F&!E&D2&!D1&!D&!C&B1&!B&!A1&A|!F&!E&D2&D1&!D&!C&B1&!B&!A1&A|!F&E&D2&D1&!D&!C&B1&!B&!A1&A|!F&E&!D2&D1&!D&!C&B1&!B&!A1&A|!F&!E&!D2&D1&!D&!C&B1&!B&!A1&A|!F&!E&!D2&D1&D&!C&B1&!B&!A1&A|!F&E&!D2&D1&D&!C&B1&!B&!A1&A|!F&!E&D2&D1&D&!C&B1&!B&!A1&A|!F&!E&D2&!D1&D&!C&B1&!B&!A1&A|!F&E&D2&!D1&D&!C&B1&!B&!A1&A|!F&E&!D2&!D1&D&!C&B1&!B&!A1&A|!F&!E&!D2&!D1&D&!C&B1&!B&!A1&A|!F&!E&!D2&!D1&D&C&B1&!B&!A1&A|!F&E&!D2&!D1&D&C&B1&!B&!A1&A|!F&E&D2&!D1&D&C&B1&!B&!A1&A|!F&!E&D2&!D1&D&C&B1&!B&!A1&A|!F&!E&D2&D1&D&C&B1&!B&!A1&A|!F&E&!D2&D1&D&C&B1&!B&!A1&A|!F&!E&!D2&D1&D&C&B1&!B&!A1&A|!F&!E&!D2&D1&!D&C&B1&!B&!A1&A|!F&E&!D2&D1&!D&C&B1&!B&!A1&A|!F&E&D2&D1&!D&C&B1&!B&!A1&A|!F&!E&D2&D1&!D&C&B1&!B&!A1&A|!F&!E&D2&!D1&!D&C&B1&!B&!A1&A|!F&E&D2&!D1&!D&C&B1&!B&!A1&A|!F&E&!D2&!D1&!D&C&B1&!B&!A1&A|!F&!E&!D2&!D1&!D&C&B1&!B&!A1&A|!F&!E&!D2&!D1&!D&C&!B1&!B&!A1&A|!F&E&!D2&!D1&!D&C&!B1&!B&!A1&A|!F&E&D2&!D1&!D&C&!B1&!B&!A1&A|!F&!E&D2&!D1&!D&C&!B1&!B&!A1&A|!F&!E&D2&D1&!D&C&!B1&!B&!A1&A|!F&E&D2&D1&!D&C&!B1&!B&!A1&A|!F&E&!D2&D1&!D&C&!B1&!B&!A1&A|!F&!E&!D2&D1&!D&C&!B1&!B&!A1&A|!F&!E&!D2&D1&D&C&!B1&!B&!A1&A|!F&E&!D2&D1&D&C&!B1&!B&!A1&A|!F&!E&D2&D1&D&C&!B1&!B&!A1&A|!F&!E&D2&!D1&D&C&!B1&!B&!A1&A|!F&E&D2&!D1&D&C&!B1&!B&!A1&A|!F&E&!D2&!D1&D&C&!B1&!B&!A1&A|!F&!E&!D2&!D1&D&C&!B1&!B&!A1&A|!F&!E&!D2&!D1&D&!C&!B1&!B&!A1&A|!F&E&!D2&!D1&D&!C&!B1&!B&!A1&A|!F&E&D2&!D1&D&!C&!B1&!B&!A1&A|!F&!E&D2&!D1&D&!C&!B1&!B&!A1&A|!F&!E&D2&D1&D&!C&!B1&!B&!A1&A|!F&E&!D2&D1&D&!C&!B1&!B&!A1&A|!F&!E&!D2&D1&D&!C&!B1&!B&!A1&A|!F&!E&!D2&D1&!D&!C&!B1&!B&!A1&A|!F&E&!D2&D1&!D&!C&!B1&!B&!A1&A|!F&E&D2&D1&!D&!C&!B1&!B&!A1&A|!F&!E&D2&D1&!D&!C&!B1&!B&!A1&A|!F&!E&D2&!D1&!D&!C&!B1&!B&!A1&A|!F&E&D2&!D1&!D&!C&!B1&!B&!A1&A|!F&E&!D2&!D1&!D&!C&!B1&!B&!A1&A|!F&!E&!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOAOI221311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n MUX8 -l MUX8 -i IN0 IN1 IN2 IN3 IN4 IN5 IN6 IN7 S0 S1 S2 S3 S4 S5 S6 S7 -o Z -f 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist MUX8.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOOAI22122 -l OOAAOOAI22122 -i E1 E D1 D C B1 B A1 A -o Y -f Y=!(E1&!E&D1&D&!C&!B1&!B&!A1&!A|E1&E&D1&D&!C&!B1&!B&!A1&!A|!E1&E&D1&D&!C&!B1&!B&!A1&!A|!E1&E&D1&D&C&!B1&!B&!A1&!A|E1&E&D1&D&C&!B1&!B&!A1&!A|E1&!E&D1&D&C&!B1&!B&!A1&!A|E1&!E&D1&D&C&B1&!B&!A1&!A|E1&E&D1&D&C&B1&!B&!A1&!A|!E1&E&D1&D&C&B1&!B&!A1&!A|!E1&E&D1&D&!C&B1&!B&!A1&!A|E1&E&D1&D&!C&B1&!B&!A1&!A|E1&!E&D1&D&!C&B1&!B&!A1&!A|E1&!E&D1&D&!C&B1&B&!A1&!A|E1&E&D1&D&!C&B1&B&!A1&!A|!E1&E&D1&D&!C&B1&B&!A1&!A|!E1&E&D1&D&C&B1&B&!A1&!A|E1&E&D1&D&C&B1&B&!A1&!A|E1&!E&D1&D&C&B1&B&!A1&!A|E1&!E&D1&D&C&!B1&B&!A1&!A|E1&E&D1&D&C&!B1&B&!A1&!A|!E1&E&D1&D&C&!B1&B&!A1&!A|!E1&E&D1&D&!C&!B1&B&!A1&!A|E1&E&D1&D&!C&!B1&B&!A1&!A|E1&!E&D1&D&!C&!B1&B&!A1&!A|E1&!E&D1&D&!C&!B1&B&A1&!A|E1&E&D1&D&!C&!B1&B&A1&!A|!E1&E&D1&D&!C&!B1&B&A1&!A|E1&!E&!D1&D&C&!B1&B&A1&!A|E1&E&!D1&D&C&!B1&B&A1&!A|!E1&E&!D1&D&C&!B1&B&A1&!A|!E1&E&D1&D&C&!B1&B&A1&!A|E1&E&D1&D&C&!B1&B&A1&!A|E1&!E&D1&D&C&!B1&B&A1&!A|E1&!E&D1&!D&C&!B1&B&A1&!A|E1&E&D1&!D&C&!B1&B&A1&!A|!E1&E&D1&!D&C&!B1&B&A1&!A|!E1&E&!D1&!D&C&!B1&B&A1&!A|E1&E&!D1&!D&C&!B1&B&A1&!A|E1&!E&!D1&!D&C&!B1&B&A1&!A|E1&!E&!D1&!D&C&B1&B&A1&!A|E1&E&!D1&!D&C&B1&B&A1&!A|!E1&E&!D1&!D&C&B1&B&A1&!A|!E1&E&D1&!D&C&B1&B&A1&!A|E1&E&D1&!D&C&B1&B&A1&!A|E1&!E&D1&!D&C&B1&B&A1&!A|E1&!E&D1&D&C&B1&B&A1&!A|E1&E&D1&D&C&B1&B&A1&!A|!E1&E&D1&D&C&B1&B&A1&!A|!E1&E&!D1&D&C&B1&B&A1&!A|E1&E&!D1&D&C&B1&B&A1&!A|E1&!E&!D1&D&C&B1&B&A1&!A|!E1&E&D1&D&!C&B1&B&A1&!A|E1&E&D1&D&!C&B1&B&A1&!A|E1&!E&D1&D&!C&B1&B&A1&!A|E1&!E&D1&D&!C&B1&!B&A1&!A|E1&E&D1&D&!C&B1&!B&A1&!A|!E1&E&D1&D&!C&B1&!B&A1&!A|E1&!E&!D1&D&C&B1&!B&A1&!A|E1&E&!D1&D&C&B1&!B&A1&!A|!E1&E&!D1&D&C&B1&!B&A1&!A|!E1&E&D1&D&C&B1&!B&A1&!A|E1&E&D1&D&C&B1&!B&A1&!A|E1&!E&D1&D&C&B1&!B&A1&!A|E1&!E&D1&!D&C&B1&!B&A1&!A|E1&E&D1&!D&C&B1&!B&A1&!A|!E1&E&D1&!D&C&B1&!B&A1&!A|!E1&E&!D1&!D&C&B1&!B&A1&!A|E1&E&!D1&!D&C&B1&!B&A1&!A|E1&!E&!D1&!D&C&B1&!B&A1&!A|E1&!E&D1&D&C&!B1&!B&A1&!A|E1&E&D1&D&C&!B1&!B&A1&!A|!E1&E&D1&D&C&!B1&!B&A1&!A|!E1&E&D1&D&!C&!B1&!B&A1&!A|E1&E&D1&D&!C&!B1&!B&A1&!A|E1&!E&D1&D&!C&!B1&!B&A1&!A|E1&!E&D1&D&!C&!B1&!B&A1&A|E1&E&D1&D&!C&!B1&!B&A1&A|!E1&E&D1&D&!C&!B1&!B&A1&A|!E1&E&D1&D&C&!B1&!B&A1&A|E1&E&D1&D&C&!B1&!B&A1&A|E1&!E&D1&D&C&!B1&!B&A1&A|E1&!E&!D1&!D&C&B1&!B&A1&A|E1&E&!D1&!D&C&B1&!B&A1&A|!E1&E&!D1&!D&C&B1&!B&A1&A|!E1&E&D1&!D&C&B1&!B&A1&A|E1&E&D1&!D&C&B1&!B&A1&A|E1&!E&D1&!D&C&B1&!B&A1&A|E1&!E&D1&D&C&B1&!B&A1&A|E1&E&D1&D&C&B1&!B&A1&A|!E1&E&D1&D&C&B1&!B&A1&A|!E1&E&!D1&D&C&B1&!B&A1&A|E1&E&!D1&D&C&B1&!B&A1&A|E1&!E&!D1&D&C&B1&!B&A1&A|!E1&E&D1&D&!C&B1&!B&A1&A|E1&E&D1&D&!C&B1&!B&A1&A|E1&!E&D1&D&!C&B1&!B&A1&A|E1&!E&D1&D&!C&B1&B&A1&A|E1&E&D1&D&!C&B1&B&A1&A|!E1&E&D1&D&!C&B1&B&A1&A|E1&!E&!D1&D&C&B1&B&A1&A|E1&E&!D1&D&C&B1&B&A1&A|!E1&E&!D1&D&C&B1&B&A1&A|!E1&E&D1&D&C&B1&B&A1&A|E1&E&D1&D&C&B1&B&A1&A|E1&!E&D1&D&C&B1&B&A1&A|E1&!E&D1&!D&C&B1&B&A1&A|E1&E&D1&!D&C&B1&B&A1&A|!E1&E&D1&!D&C&B1&B&A1&A|!E1&E&!D1&!D&C&B1&B&A1&A|E1&E&!D1&!D&C&B1&B&A1&A|E1&!E&!D1&!D&C&B1&B&A1&A|E1&!E&!D1&!D&C&!B1&B&A1&A|E1&E&!D1&!D&C&!B1&B&A1&A|!E1&E&!D1&!D&C&!B1&B&A1&A|!E1&E&D1&!D&C&!B1&B&A1&A|E1&E&D1&!D&C&!B1&B&A1&A|E1&!E&D1&!D&C&!B1&B&A1&A|E1&!E&D1&D&C&!B1&B&A1&A|E1&E&D1&D&C&!B1&B&A1&A|!E1&E&D1&D&C&!B1&B&A1&A|!E1&E&!D1&D&C&!B1&B&A1&A|E1&E&!D1&D&C&!B1&B&A1&A|E1&!E&!D1&D&C&!B1&B&A1&A|!E1&E&D1&D&!C&!B1&B&A1&A|E1&E&D1&D&!C&!B1&B&A1&A|E1&!E&D1&D&!C&!B1&B&A1&A|E1&!E&D1&D&!C&!B1&B&!A1&A|E1&E&D1&D&!C&!B1&B&!A1&A|!E1&E&D1&D&!C&!B1&B&!A1&A|E1&!E&!D1&D&C&!B1&B&!A1&A|E1&E&!D1&D&C&!B1&B&!A1&A|!E1&E&!D1&D&C&!B1&B&!A1&A|!E1&E&D1&D&C&!B1&B&!A1&A|E1&E&D1&D&C&!B1&B&!A1&A|E1&!E&D1&D&C&!B1&B&!A1&A|E1&!E&D1&!D&C&!B1&B&!A1&A|E1&E&D1&!D&C&!B1&B&!A1&A|!E1&E&D1&!D&C&!B1&B&!A1&A|!E1&E&!D1&!D&C&!B1&B&!A1&A|E1&E&!D1&!D&C&!B1&B&!A1&A|E1&!E&!D1&!D&C&!B1&B&!A1&A|E1&!E&!D1&!D&C&B1&B&!A1&A|E1&E&!D1&!D&C&B1&B&!A1&A|!E1&E&!D1&!D&C&B1&B&!A1&A|!E1&E&D1&!D&C&B1&B&!A1&A|E1&E&D1&!D&C&B1&B&!A1&A|E1&!E&D1&!D&C&B1&B&!A1&A|E1&!E&D1&D&C&B1&B&!A1&A|E1&E&D1&D&C&B1&B&!A1&A|!E1&E&D1&D&C&B1&B&!A1&A|!E1&E&!D1&D&C&B1&B&!A1&A|E1&E&!D1&D&C&B1&B&!A1&A|E1&!E&!D1&D&C&B1&B&!A1&A|!E1&E&D1&D&!C&B1&B&!A1&A|E1&E&D1&D&!C&B1&B&!A1&A|E1&!E&D1&D&!C&B1&B&!A1&A|E1&!E&D1&D&!C&B1&!B&!A1&A|E1&E&D1&D&!C&B1&!B&!A1&A|!E1&E&D1&D&!C&B1&!B&!A1&A|E1&!E&!D1&D&C&B1&!B&!A1&A|E1&E&!D1&D&C&B1&!B&!A1&A|!E1&E&!D1&D&C&B1&!B&!A1&A|!E1&E&D1&D&C&B1&!B&!A1&A|E1&E&D1&D&C&B1&!B&!A1&A|E1&!E&D1&D&C&B1&!B&!A1&A|E1&!E&D1&!D&C&B1&!B&!A1&A|E1&E&D1&!D&C&B1&!B&!A1&A|!E1&E&D1&!D&C&B1&!B&!A1&A|!E1&E&!D1&!D&C&B1&!B&!A1&A|E1&E&!D1&!D&C&B1&!B&!A1&A|E1&!E&!D1&!D&C&B1&!B&!A1&A|E1&!E&D1&D&C&!B1&!B&!A1&A|E1&E&D1&D&C&!B1&!B&!A1&A|!E1&E&D1&D&C&!B1&!B&!A1&A|!E1&E&D1&D&!C&!B1&!B&!A1&A|E1&E&D1&D&!C&!B1&!B&!A1&A|E1&!E&D1&D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOOAI22122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOI2122 -l AOAOI2122 -i D1 D C1 C B A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B&!A1&!A|!D1&!D&C1&!C&!B&!A1&!A|!D1&!D&C1&C&!B&!A1&!A|!D1&!D&!C1&C&!B&!A1&!A|!D1&!D&!C1&C&B&!A1&!A|!D1&!D&C1&!C&B&!A1&!A|!D1&!D&!C1&!C&B&!A1&!A|!D1&!D&!C1&!C&B&A1&!A|!D1&!D&C1&!C&B&A1&!A|!D1&!D&!C1&C&B&A1&!A|!D1&!D&!C1&C&!B&A1&!A|!D1&!D&C1&C&!B&A1&!A|!D1&!D&C1&!C&!B&A1&!A|!D1&!D&!C1&!C&!B&A1&!A|!D1&!D&!C1&!C&!B&A1&A|!D1&!D&C1&!C&!B&A1&A|!D1&!D&!C1&C&!B&A1&A|!D1&!D&!C1&C&B&A1&A|!D1&!D&C1&!C&B&A1&A|!D1&!D&!C1&!C&B&A1&A|!D1&!D&!C1&!C&B&!A1&A|!D1&!D&C1&!C&B&!A1&A|!D1&!D&!C1&C&B&!A1&A|!D1&!D&!C1&C&!B&!A1&A|!D1&!D&C1&C&!B&!A1&A|!D1&!D&C1&!C&!B&!A1&A|!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOI2122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAI2222 -l OAOOAI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B1&!B&!A1&!A|D1&!D&!C1&!C&!B1&!B&!A1&!A|D1&D&!C1&!C&!B1&!B&!A1&!A|!D1&D&!C1&!C&!B1&!B&!A1&!A|!D1&!D&C1&!C&!B1&!B&!A1&!A|!D1&!D&C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&B1&!B&!A1&!A|!D1&!D&C1&C&B1&!B&!A1&!A|!D1&!D&C1&!C&B1&!B&!A1&!A|!D1&D&!C1&!C&B1&!B&!A1&!A|D1&D&!C1&!C&B1&!B&!A1&!A|D1&!D&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&B&!A1&!A|D1&!D&!C1&!C&B1&B&!A1&!A|D1&D&!C1&!C&B1&B&!A1&!A|!D1&D&!C1&!C&B1&B&!A1&!A|!D1&!D&C1&!C&B1&B&!A1&!A|!D1&!D&C1&C&B1&B&!A1&!A|!D1&!D&!C1&C&B1&B&!A1&!A|!D1&!D&!C1&C&!B1&B&!A1&!A|!D1&!D&C1&C&!B1&B&!A1&!A|!D1&!D&C1&!C&!B1&B&!A1&!A|!D1&D&!C1&!C&!B1&B&!A1&!A|D1&D&!C1&!C&!B1&B&!A1&!A|D1&!D&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&A1&!A|D1&!D&!C1&!C&!B1&B&A1&!A|D1&D&!C1&!C&!B1&B&A1&!A|!D1&D&!C1&!C&!B1&B&A1&!A|!D1&!D&C1&!C&!B1&B&A1&!A|!D1&!D&C1&C&!B1&B&A1&!A|!D1&!D&!C1&C&!B1&B&A1&!A|!D1&!D&!C1&C&B1&B&A1&!A|!D1&!D&C1&C&B1&B&A1&!A|!D1&!D&C1&!C&B1&B&A1&!A|!D1&!D&!C1&!C&B1&B&A1&!A|!D1&!D&!C1&!C&B1&!B&A1&!A|D1&!D&!C1&!C&B1&!B&A1&!A|D1&D&!C1&!C&B1&!B&A1&!A|!D1&D&!C1&!C&B1&!B&A1&!A|!D1&!D&C1&!C&B1&!B&A1&!A|!D1&!D&C1&C&B1&!B&A1&!A|!D1&!D&!C1&C&B1&!B&A1&!A|!D1&!D&!C1&C&!B1&!B&A1&!A|!D1&!D&C1&C&!B1&!B&A1&!A|!D1&!D&C1&!C&!B1&!B&A1&!A|!D1&D&!C1&!C&!B1&!B&A1&!A|D1&D&!C1&!C&!B1&!B&A1&!A|D1&!D&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&A|D1&!D&!C1&!C&!B1&!B&A1&A|D1&D&!C1&!C&!B1&!B&A1&A|!D1&D&!C1&!C&!B1&!B&A1&A|!D1&!D&C1&!C&!B1&!B&A1&A|!D1&!D&C1&C&!B1&!B&A1&A|!D1&!D&!C1&C&!B1&!B&A1&A|!D1&!D&!C1&C&B1&!B&A1&A|!D1&!D&C1&C&B1&!B&A1&A|!D1&!D&C1&!C&B1&!B&A1&A|!D1&D&!C1&!C&B1&!B&A1&A|D1&D&!C1&!C&B1&!B&A1&A|D1&!D&!C1&!C&B1&!B&A1&A|!D1&!D&!C1&!C&B1&!B&A1&A|!D1&!D&!C1&!C&B1&B&A1&A|!D1&!D&C1&!C&B1&B&A1&A|!D1&!D&C1&C&B1&B&A1&A|!D1&!D&!C1&C&B1&B&A1&A|!D1&!D&!C1&C&!B1&B&A1&A|!D1&!D&C1&C&!B1&B&A1&A|!D1&!D&C1&!C&!B1&B&A1&A|!D1&D&!C1&!C&!B1&B&A1&A|D1&D&!C1&!C&!B1&B&A1&A|D1&!D&!C1&!C&!B1&B&A1&A|!D1&!D&!C1&!C&!B1&B&A1&A|!D1&!D&!C1&!C&!B1&B&!A1&A|D1&!D&!C1&!C&!B1&B&!A1&A|D1&D&!C1&!C&!B1&B&!A1&A|!D1&D&!C1&!C&!B1&B&!A1&A|!D1&!D&C1&!C&!B1&B&!A1&A|!D1&!D&C1&C&!B1&B&!A1&A|!D1&!D&!C1&C&!B1&B&!A1&A|!D1&!D&!C1&C&B1&B&!A1&A|!D1&!D&C1&C&B1&B&!A1&A|!D1&!D&C1&!C&B1&B&!A1&A|!D1&!D&!C1&!C&B1&B&!A1&A|!D1&!D&!C1&!C&B1&!B&!A1&A|D1&!D&!C1&!C&B1&!B&!A1&A|D1&D&!C1&!C&B1&!B&!A1&A|!D1&D&!C1&!C&B1&!B&!A1&A|!D1&!D&C1&!C&B1&!B&!A1&A|!D1&!D&C1&C&B1&!B&!A1&A|!D1&!D&!C1&C&B1&!B&!A1&A|!D1&!D&!C1&C&!B1&!B&!A1&A|!D1&!D&C1&C&!B1&!B&!A1&A|!D1&!D&C1&!C&!B1&!B&!A1&A|!D1&D&!C1&!C&!B1&!B&!A1&A|D1&D&!C1&!C&!B1&!B&!A1&A|D1&!D&!C1&!C&!B1&!B&!A1&A|!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOI21321 -l AOOAAOI21321 -i E D1 D C2 C1 C B A1 A -o Y -f Z=!(!E&!D1&!D&!C2&!C1&!C&!B&!A1&!A|!E&D1&!D&!C2&!C1&!C&!B&!A1&!A|!E&!D1&D&!C2&!C1&!C&!B&!A1&!A|!E&!D1&D&C2&!C1&!C&!B&!A1&!A|!E&D1&!D&C2&!C1&!C&!B&!A1&!A|!E&!D1&!D&C2&!C1&!C&!B&!A1&!A|!E&!D1&!D&C2&C1&!C&!B&!A1&!A|!E&D1&!D&C2&C1&!C&!B&!A1&!A|!E&!D1&D&C2&C1&!C&!B&!A1&!A|!E&!D1&D&!C2&C1&!C&!B&!A1&!A|!E&D1&!D&!C2&C1&!C&!B&!A1&!A|!E&!D1&!D&!C2&C1&!C&!B&!A1&!A|!E&!D1&!D&!C2&C1&C&!B&!A1&!A|!E&D1&!D&!C2&C1&C&!B&!A1&!A|!E&!D1&D&!C2&C1&C&!B&!A1&!A|!E&!D1&D&C2&C1&C&!B&!A1&!A|!E&D1&!D&C2&C1&C&!B&!A1&!A|!E&!D1&!D&C2&C1&C&!B&!A1&!A|!E&!D1&!D&C2&!C1&C&!B&!A1&!A|!E&D1&!D&C2&!C1&C&!B&!A1&!A|!E&!D1&D&C2&!C1&C&!B&!A1&!A|!E&!D1&D&!C2&!C1&C&!B&!A1&!A|!E&D1&!D&!C2&!C1&C&!B&!A1&!A|!E&!D1&!D&!C2&!C1&C&!B&!A1&!A|!E&!D1&D&!C2&!C1&!C&B&!A1&!A|!E&D1&!D&!C2&!C1&!C&B&!A1&!A|!E&!D1&!D&!C2&!C1&!C&B&!A1&!A|!E&!D1&!D&!C2&!C1&!C&B&A1&!A|!E&D1&!D&!C2&!C1&!C&B&A1&!A|!E&!D1&D&!C2&!C1&!C&B&A1&!A|!E&!D1&!D&!C2&!C1&C&!B&A1&!A|!E&D1&!D&!C2&!C1&C&!B&A1&!A|!E&!D1&D&!C2&!C1&C&!B&A1&!A|!E&!D1&D&C2&!C1&C&!B&A1&!A|!E&D1&!D&C2&!C1&C&!B&A1&!A|!E&!D1&!D&C2&!C1&C&!B&A1&!A|!E&!D1&!D&C2&C1&C&!B&A1&!A|!E&D1&!D&C2&C1&C&!B&A1&!A|!E&!D1&D&C2&C1&C&!B&A1&!A|!E&!D1&D&!C2&C1&C&!B&A1&!A|!E&D1&!D&!C2&C1&C&!B&A1&!A|!E&!D1&!D&!C2&C1&C&!B&A1&!A|!E&!D1&!D&!C2&C1&!C&!B&A1&!A|!E&D1&!D&!C2&C1&!C&!B&A1&!A|!E&!D1&D&!C2&C1&!C&!B&A1&!A|!E&!D1&D&C2&C1&!C&!B&A1&!A|!E&D1&!D&C2&C1&!C&!B&A1&!A|!E&!D1&!D&C2&C1&!C&!B&A1&!A|!E&!D1&!D&C2&!C1&!C&!B&A1&!A|!E&D1&!D&C2&!C1&!C&!B&A1&!A|!E&!D1&D&C2&!C1&!C&!B&A1&!A|!E&!D1&D&!C2&!C1&!C&!B&A1&!A|!E&D1&!D&!C2&!C1&!C&!B&A1&!A|!E&!D1&!D&!C2&!C1&!C&!B&A1&!A|!E&!D1&!D&!C2&!C1&!C&!B&A1&A|!E&D1&!D&!C2&!C1&!C&!B&A1&A|!E&!D1&D&!C2&!C1&!C&!B&A1&A|!E&!D1&D&!C2&!C1&!C&B&A1&A|!E&D1&!D&!C2&!C1&!C&B&A1&A|!E&!D1&!D&!C2&!C1&!C&B&A1&A|!E&!D1&!D&!C2&!C1&!C&B&!A1&A|!E&D1&!D&!C2&!C1&!C&B&!A1&A|!E&!D1&D&!C2&!C1&!C&B&!A1&A|!E&!D1&!D&!C2&!C1&C&!B&!A1&A|!E&D1&!D&!C2&!C1&C&!B&!A1&A|!E&!D1&D&!C2&!C1&C&!B&!A1&A|!E&!D1&D&C2&!C1&C&!B&!A1&A|!E&D1&!D&C2&!C1&C&!B&!A1&A|!E&!D1&!D&C2&!C1&C&!B&!A1&A|!E&!D1&!D&C2&C1&C&!B&!A1&A|!E&D1&!D&C2&C1&C&!B&!A1&A|!E&!D1&D&C2&C1&C&!B&!A1&A|!E&!D1&D&!C2&C1&C&!B&!A1&A|!E&D1&!D&!C2&C1&C&!B&!A1&A|!E&!D1&!D&!C2&C1&C&!B&!A1&A|!E&!D1&!D&!C2&C1&!C&!B&!A1&A|!E&D1&!D&!C2&C1&!C&!B&!A1&A|!E&!D1&D&!C2&C1&!C&!B&!A1&A|!E&!D1&D&C2&C1&!C&!B&!A1&A|!E&D1&!D&C2&C1&!C&!B&!A1&A|!E&!D1&!D&C2&C1&!C&!B&!A1&A|!E&!D1&!D&C2&!C1&!C&!B&!A1&A|!E&D1&!D&C2&!C1&!C&!B&!A1&A|!E&!D1&D&C2&!C1&!C&!B&!A1&A|!E&!D1&D&!C2&!C1&!C&!B&!A1&A|!E&D1&!D&!C2&!C1&!C&!B&!A1&A|!E&!D1&!D&!C2&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOI21321.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOI223 -l OAAOI223 -i C2 C1 C B1 B A1 A -o Y -f Y=!(C2&C1&C&!B1&!B&!A1&!A|C2&C1&C&B1&!B&!A1&!A|C2&C1&C&B1&B&!A1&!A|C2&C1&C&!B1&B&!A1&!A|C2&C1&C&!B1&B&A1&!A|!C2&!C1&C&B1&B&A1&!A|C2&!C1&C&B1&B&A1&!A|C2&C1&C&B1&B&A1&!A|!C2&C1&C&B1&B&A1&!A|!C2&C1&!C&B1&B&A1&!A|C2&C1&!C&B1&B&A1&!A|C2&!C1&!C&B1&B&A1&!A|!C2&!C1&!C&B1&B&A1&!A|C2&C1&C&B1&!B&A1&!A|C2&C1&C&!B1&!B&A1&!A|C2&C1&C&!B1&!B&A1&A|C2&C1&C&B1&!B&A1&A|!C2&!C1&!C&B1&B&A1&A|C2&!C1&!C&B1&B&A1&A|C2&C1&!C&B1&B&A1&A|!C2&C1&!C&B1&B&A1&A|!C2&C1&C&B1&B&A1&A|C2&C1&C&B1&B&A1&A|C2&!C1&C&B1&B&A1&A|!C2&!C1&C&B1&B&A1&A|C2&C1&C&!B1&B&A1&A|C2&C1&C&!B1&B&!A1&A|!C2&!C1&C&B1&B&!A1&A|C2&!C1&C&B1&B&!A1&A|C2&C1&C&B1&B&!A1&A|!C2&C1&C&B1&B&!A1&A|!C2&C1&!C&B1&B&!A1&A|C2&C1&!C&B1&B&!A1&A|C2&!C1&!C&B1&B&!A1&A|!C2&!C1&!C&B1&B&!A1&A|C2&C1&C&B1&!B&!A1&A|C2&C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOI223.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOAOI211311 -l AOAAOAOI211311 -i F E D2 D1 D C B A1 A -o Y -f Y=(!F&!E&!D2&!D1&!D&!C&!B&!A1&!A|!F&E&!D2&!D1&!D&!C&!B&!A1&!A|!F&E&D2&!D1&!D&!C&!B&!A1&!A|!F&!E&D2&!D1&!D&!C&!B&!A1&!A|!F&!E&D2&D1&!D&!C&!B&!A1&!A|!F&E&D2&D1&!D&!C&!B&!A1&!A|!F&E&!D2&D1&!D&!C&!B&!A1&!A|!F&!E&!D2&D1&!D&!C&!B&!A1&!A|!F&!E&!D2&D1&D&!C&!B&!A1&!A|!F&E&!D2&D1&D&!C&!B&!A1&!A|!F&!E&D2&D1&D&!C&!B&!A1&!A|!F&!E&D2&!D1&D&!C&!B&!A1&!A|!F&E&D2&!D1&D&!C&!B&!A1&!A|!F&E&!D2&!D1&D&!C&!B&!A1&!A|!F&!E&!D2&!D1&D&!C&!B&!A1&!A|!F&!E&!D2&!D1&D&C&!B&!A1&!A|!F&E&!D2&!D1&D&C&!B&!A1&!A|!F&E&D2&!D1&D&C&!B&!A1&!A|!F&!E&D2&!D1&D&C&!B&!A1&!A|!F&!E&D2&D1&D&C&!B&!A1&!A|!F&E&!D2&D1&D&C&!B&!A1&!A|!F&!E&!D2&D1&D&C&!B&!A1&!A|!F&!E&!D2&D1&!D&C&!B&!A1&!A|!F&E&!D2&D1&!D&C&!B&!A1&!A|!F&E&D2&D1&!D&C&!B&!A1&!A|!F&!E&D2&D1&!D&C&!B&!A1&!A|!F&!E&D2&!D1&!D&C&!B&!A1&!A|!F&E&D2&!D1&!D&C&!B&!A1&!A|!F&E&!D2&!D1&!D&C&!B&!A1&!A|!F&!E&!D2&!D1&!D&C&!B&!A1&!A|!F&!E&!D2&!D1&!D&C&B&!A1&!A|!F&!E&D2&!D1&!D&C&B&!A1&!A|!F&!E&D2&D1&!D&C&B&!A1&!A|!F&!E&!D2&D1&!D&C&B&!A1&!A|!F&!E&!D2&D1&D&C&B&!A1&!A|!F&!E&D2&D1&D&C&B&!A1&!A|!F&!E&D2&!D1&D&C&B&!A1&!A|!F&!E&!D2&!D1&D&C&B&!A1&!A|!F&!E&!D2&!D1&D&!C&B&!A1&!A|!F&E&!D2&!D1&D&!C&B&!A1&!A|!F&E&D2&!D1&D&!C&B&!A1&!A|!F&!E&D2&!D1&D&!C&B&!A1&!A|!F&!E&D2&D1&D&!C&B&!A1&!A|!F&E&!D2&D1&D&!C&B&!A1&!A|!F&!E&!D2&D1&D&!C&B&!A1&!A|!F&!E&!D2&D1&!D&!C&B&!A1&!A|!F&E&!D2&D1&!D&!C&B&!A1&!A|!F&E&D2&D1&!D&!C&B&!A1&!A|!F&!E&D2&D1&!D&!C&B&!A1&!A|!F&!E&D2&!D1&!D&!C&B&!A1&!A|!F&E&D2&!D1&!D&!C&B&!A1&!A|!F&E&!D2&!D1&!D&!C&B&!A1&!A|!F&!E&!D2&!D1&!D&!C&B&!A1&!A|!F&!E&!D2&!D1&!D&!C&B&A1&!A|!F&E&!D2&!D1&!D&!C&B&A1&!A|!F&E&D2&!D1&!D&!C&B&A1&!A|!F&!E&D2&!D1&!D&!C&B&A1&!A|!F&!E&D2&D1&!D&!C&B&A1&!A|!F&E&D2&D1&!D&!C&B&A1&!A|!F&E&!D2&D1&!D&!C&B&A1&!A|!F&!E&!D2&D1&!D&!C&B&A1&!A|!F&!E&!D2&D1&D&!C&B&A1&!A|!F&E&!D2&D1&D&!C&B&A1&!A|!F&!E&D2&D1&D&!C&B&A1&!A|!F&!E&D2&!D1&D&!C&B&A1&!A|!F&E&D2&!D1&D&!C&B&A1&!A|!F&E&!D2&!D1&D&!C&B&A1&!A|!F&!E&!D2&!D1&D&!C&B&A1&!A|!F&!E&!D2&!D1&D&C&B&A1&!A|!F&!E&D2&!D1&D&C&B&A1&!A|!F&!E&D2&D1&D&C&B&A1&!A|!F&!E&!D2&D1&D&C&B&A1&!A|!F&!E&!D2&D1&!D&C&B&A1&!A|!F&!E&D2&D1&!D&C&B&A1&!A|!F&!E&D2&!D1&!D&C&B&A1&!A|!F&!E&!D2&!D1&!D&C&B&A1&!A|!F&!E&!D2&!D1&!D&C&!B&A1&!A|!F&E&!D2&!D1&!D&C&!B&A1&!A|!F&E&D2&!D1&!D&C&!B&A1&!A|!F&!E&D2&!D1&!D&C&!B&A1&!A|!F&!E&D2&D1&!D&C&!B&A1&!A|!F&E&D2&D1&!D&C&!B&A1&!A|!F&E&!D2&D1&!D&C&!B&A1&!A|!F&!E&!D2&D1&!D&C&!B&A1&!A|!F&!E&!D2&D1&D&C&!B&A1&!A|!F&E&!D2&D1&D&C&!B&A1&!A|!F&!E&D2&D1&D&C&!B&A1&!A|!F&!E&D2&!D1&D&C&!B&A1&!A|!F&E&D2&!D1&D&C&!B&A1&!A|!F&E&!D2&!D1&D&C&!B&A1&!A|!F&!E&!D2&!D1&D&C&!B&A1&!A|!F&!E&!D2&!D1&D&!C&!B&A1&!A|!F&E&!D2&!D1&D&!C&!B&A1&!A|!F&E&D2&!D1&D&!C&!B&A1&!A|!F&!E&D2&!D1&D&!C&!B&A1&!A|!F&!E&D2&D1&D&!C&!B&A1&!A|!F&E&!D2&D1&D&!C&!B&A1&!A|!F&!E&!D2&D1&D&!C&!B&A1&!A|!F&!E&!D2&D1&!D&!C&!B&A1&!A|!F&E&!D2&D1&!D&!C&!B&A1&!A|!F&E&D2&D1&!D&!C&!B&A1&!A|!F&!E&D2&D1&!D&!C&!B&A1&!A|!F&!E&D2&!D1&!D&!C&!B&A1&!A|!F&E&D2&!D1&!D&!C&!B&A1&!A|!F&E&!D2&!D1&!D&!C&!B&A1&!A|!F&!E&!D2&!D1&!D&!C&!B&A1&!A|!F&!E&!D2&!D1&!D&!C&!B&A1&A|!F&E&!D2&!D1&!D&!C&!B&A1&A|!F&E&D2&!D1&!D&!C&!B&A1&A|!F&!E&D2&!D1&!D&!C&!B&A1&A|!F&!E&D2&D1&!D&!C&!B&A1&A|!F&E&D2&D1&!D&!C&!B&A1&A|!F&E&!D2&D1&!D&!C&!B&A1&A|!F&!E&!D2&D1&!D&!C&!B&A1&A|!F&!E&!D2&D1&D&!C&!B&A1&A|!F&E&!D2&D1&D&!C&!B&A1&A|!F&!E&D2&D1&D&!C&!B&A1&A|!F&!E&D2&!D1&D&!C&!B&A1&A|!F&E&D2&!D1&D&!C&!B&A1&A|!F&E&!D2&!D1&D&!C&!B&A1&A|!F&!E&!D2&!D1&D&!C&!B&A1&A|!F&!E&!D2&!D1&D&C&!B&A1&A|!F&!E&D2&!D1&D&C&!B&A1&A|!F&!E&D2&D1&D&C&!B&A1&A|!F&!E&!D2&D1&D&C&!B&A1&A|!F&!E&!D2&D1&!D&C&!B&A1&A|!F&!E&D2&D1&!D&C&!B&A1&A|!F&!E&D2&!D1&!D&C&!B&A1&A|!F&!E&!D2&!D1&!D&C&!B&A1&A|!F&!E&!D2&!D1&!D&C&B&A1&A|!F&!E&D2&!D1&!D&C&B&A1&A|!F&!E&D2&D1&!D&C&B&A1&A|!F&!E&!D2&D1&!D&C&B&A1&A|!F&!E&!D2&D1&D&C&B&A1&A|!F&!E&D2&D1&D&C&B&A1&A|!F&!E&D2&!D1&D&C&B&A1&A|!F&!E&!D2&!D1&D&C&B&A1&A|!F&!E&!D2&!D1&D&!C&B&A1&A|!F&E&!D2&!D1&D&!C&B&A1&A|!F&E&D2&!D1&D&!C&B&A1&A|!F&!E&D2&!D1&D&!C&B&A1&A|!F&!E&D2&D1&D&!C&B&A1&A|!F&E&!D2&D1&D&!C&B&A1&A|!F&!E&!D2&D1&D&!C&B&A1&A|!F&!E&!D2&D1&!D&!C&B&A1&A|!F&E&!D2&D1&!D&!C&B&A1&A|!F&E&D2&D1&!D&!C&B&A1&A|!F&!E&D2&D1&!D&!C&B&A1&A|!F&!E&D2&!D1&!D&!C&B&A1&A|!F&E&D2&!D1&!D&!C&B&A1&A|!F&E&!D2&!D1&!D&!C&B&A1&A|!F&!E&!D2&!D1&!D&!C&B&A1&A|!F&!E&!D2&!D1&!D&!C&B&!A1&A|!F&E&!D2&!D1&!D&!C&B&!A1&A|!F&E&D2&!D1&!D&!C&B&!A1&A|!F&!E&D2&!D1&!D&!C&B&!A1&A|!F&!E&D2&D1&!D&!C&B&!A1&A|!F&E&D2&D1&!D&!C&B&!A1&A|!F&E&!D2&D1&!D&!C&B&!A1&A|!F&!E&!D2&D1&!D&!C&B&!A1&A|!F&!E&!D2&D1&D&!C&B&!A1&A|!F&E&!D2&D1&D&!C&B&!A1&A|!F&!E&D2&D1&D&!C&B&!A1&A|!F&!E&D2&!D1&D&!C&B&!A1&A|!F&E&D2&!D1&D&!C&B&!A1&A|!F&E&!D2&!D1&D&!C&B&!A1&A|!F&!E&!D2&!D1&D&!C&B&!A1&A|!F&!E&!D2&!D1&D&C&B&!A1&A|!F&!E&D2&!D1&D&C&B&!A1&A|!F&!E&D2&D1&D&C&B&!A1&A|!F&!E&!D2&D1&D&C&B&!A1&A|!F&!E&!D2&D1&!D&C&B&!A1&A|!F&!E&D2&D1&!D&C&B&!A1&A|!F&!E&D2&!D1&!D&C&B&!A1&A|!F&!E&!D2&!D1&!D&C&B&!A1&A|!F&!E&!D2&!D1&!D&C&!B&!A1&A|!F&E&!D2&!D1&!D&C&!B&!A1&A|!F&E&D2&!D1&!D&C&!B&!A1&A|!F&!E&D2&!D1&!D&C&!B&!A1&A|!F&!E&D2&D1&!D&C&!B&!A1&A|!F&E&D2&D1&!D&C&!B&!A1&A|!F&E&!D2&D1&!D&C&!B&!A1&A|!F&!E&!D2&D1&!D&C&!B&!A1&A|!F&!E&!D2&D1&D&C&!B&!A1&A|!F&E&!D2&D1&D&C&!B&!A1&A|!F&!E&D2&D1&D&C&!B&!A1&A|!F&!E&D2&!D1&D&C&!B&!A1&A|!F&E&D2&!D1&D&C&!B&!A1&A|!F&E&!D2&!D1&D&C&!B&!A1&A|!F&!E&!D2&!D1&D&C&!B&!A1&A|!F&!E&!D2&!D1&D&!C&!B&!A1&A|!F&E&!D2&!D1&D&!C&!B&!A1&A|!F&E&D2&!D1&D&!C&!B&!A1&A|!F&!E&D2&!D1&D&!C&!B&!A1&A|!F&!E&D2&D1&D&!C&!B&!A1&A|!F&E&!D2&D1&D&!C&!B&!A1&A|!F&!E&!D2&D1&D&!C&!B&!A1&A|!F&!E&!D2&D1&!D&!C&!B&!A1&A|!F&E&!D2&D1&!D&!C&!B&!A1&A|!F&E&D2&D1&!D&!C&!B&!A1&A|!F&!E&D2&D1&!D&!C&!B&!A1&A|!F&!E&D2&!D1&!D&!C&!B&!A1&A|!F&E&D2&!D1&!D&!C&!B&!A1&A|!F&E&!D2&!D1&!D&!C&!B&!A1&A|!F&!E&!D2&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOAOI211311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAAOI21122 -l OAOOAAOI21122 -i E1 E D1 D C B A1 A -o Y -f Y=(!E1&!E&!D1&!D&!C&!B&!A1&!A|E1&!E&!D1&!D&!C&!B&!A1&!A|!E1&E&!D1&!D&!C&!B&!A1&!A|!E1&E&D1&!D&!C&!B&!A1&!A|E1&!E&D1&!D&!C&!B&!A1&!A|!E1&!E&D1&!D&!C&!B&!A1&!A|!E1&!E&D1&D&!C&!B&!A1&!A|E1&!E&D1&D&!C&!B&!A1&!A|!E1&E&D1&D&!C&!B&!A1&!A|!E1&E&!D1&D&!C&!B&!A1&!A|E1&!E&!D1&D&!C&!B&!A1&!A|!E1&!E&!D1&D&!C&!B&!A1&!A|!E1&E&!D1&!D&C&!B&!A1&!A|E1&!E&!D1&!D&C&!B&!A1&!A|!E1&!E&!D1&!D&C&!B&!A1&!A|!E1&!E&!D1&!D&C&B&!A1&!A|E1&!E&!D1&!D&C&B&!A1&!A|!E1&E&!D1&!D&C&B&!A1&!A|!E1&!E&!D1&D&!C&B&!A1&!A|E1&!E&!D1&D&!C&B&!A1&!A|!E1&E&!D1&D&!C&B&!A1&!A|!E1&E&D1&D&!C&B&!A1&!A|E1&!E&D1&D&!C&B&!A1&!A|!E1&!E&D1&D&!C&B&!A1&!A|!E1&!E&D1&!D&!C&B&!A1&!A|E1&!E&D1&!D&!C&B&!A1&!A|!E1&E&D1&!D&!C&B&!A1&!A|!E1&E&!D1&!D&!C&B&!A1&!A|E1&!E&!D1&!D&!C&B&!A1&!A|!E1&!E&!D1&!D&!C&B&!A1&!A|!E1&!E&!D1&!D&!C&B&A1&!A|E1&!E&!D1&!D&!C&B&A1&!A|!E1&E&!D1&!D&!C&B&A1&!A|!E1&E&!D1&!D&C&B&A1&!A|E1&!E&!D1&!D&C&B&A1&!A|!E1&!E&!D1&!D&C&B&A1&!A|!E1&!E&!D1&!D&C&!B&A1&!A|E1&!E&!D1&!D&C&!B&A1&!A|!E1&E&!D1&!D&C&!B&A1&!A|!E1&!E&!D1&D&!C&!B&A1&!A|E1&!E&!D1&D&!C&!B&A1&!A|!E1&E&!D1&D&!C&!B&A1&!A|!E1&E&D1&D&!C&!B&A1&!A|E1&!E&D1&D&!C&!B&A1&!A|!E1&!E&D1&D&!C&!B&A1&!A|!E1&!E&D1&!D&!C&!B&A1&!A|E1&!E&D1&!D&!C&!B&A1&!A|!E1&E&D1&!D&!C&!B&A1&!A|!E1&E&!D1&!D&!C&!B&A1&!A|E1&!E&!D1&!D&!C&!B&A1&!A|!E1&!E&!D1&!D&!C&!B&A1&!A|!E1&!E&!D1&!D&!C&!B&A1&A|E1&!E&!D1&!D&!C&!B&A1&A|!E1&E&!D1&!D&!C&!B&A1&A|!E1&E&D1&!D&!C&!B&A1&A|E1&!E&D1&!D&!C&!B&A1&A|!E1&!E&D1&!D&!C&!B&A1&A|!E1&!E&D1&D&!C&!B&A1&A|E1&!E&D1&D&!C&!B&A1&A|!E1&E&D1&D&!C&!B&A1&A|!E1&E&!D1&D&!C&!B&A1&A|E1&!E&!D1&D&!C&!B&A1&A|!E1&!E&!D1&D&!C&!B&A1&A|!E1&E&!D1&!D&C&!B&A1&A|E1&!E&!D1&!D&C&!B&A1&A|!E1&!E&!D1&!D&C&!B&A1&A|!E1&!E&!D1&!D&C&B&A1&A|E1&!E&!D1&!D&C&B&A1&A|!E1&E&!D1&!D&C&B&A1&A|!E1&E&!D1&!D&!C&B&A1&A|E1&!E&!D1&!D&!C&B&A1&A|!E1&!E&!D1&!D&!C&B&A1&A|!E1&!E&!D1&!D&!C&B&!A1&A|E1&!E&!D1&!D&!C&B&!A1&A|!E1&E&!D1&!D&!C&B&!A1&A|!E1&E&!D1&!D&C&B&!A1&A|E1&!E&!D1&!D&C&B&!A1&A|!E1&!E&!D1&!D&C&B&!A1&A|!E1&!E&!D1&!D&C&!B&!A1&A|E1&!E&!D1&!D&C&!B&!A1&A|!E1&E&!D1&!D&C&!B&!A1&A|!E1&!E&!D1&D&!C&!B&!A1&A|E1&!E&!D1&D&!C&!B&!A1&A|!E1&E&!D1&D&!C&!B&!A1&A|!E1&E&D1&D&!C&!B&!A1&A|E1&!E&D1&D&!C&!B&!A1&A|!E1&!E&D1&D&!C&!B&!A1&A|!E1&!E&D1&!D&!C&!B&!A1&A|E1&!E&D1&!D&!C&!B&!A1&A|!E1&E&D1&!D&!C&!B&!A1&A|!E1&E&!D1&!D&!C&!B&!A1&A|E1&!E&!D1&!D&!C&!B&!A1&A|!E1&!E&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAAOI21122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOI232 -l OAAOI232 -i C1 C B2 B1 B A1 A -o Y -f Y=!(C1&C&!B2&!B1&!B&!A1&!A|C1&C&B2&!B1&!B&!A1&!A|C1&C&B2&B1&!B&!A1&!A|C1&C&!B2&B1&!B&!A1&!A|C1&C&!B2&B1&B&!A1&!A|C1&C&B2&B1&B&!A1&!A|C1&C&B2&!B1&B&!A1&!A|C1&C&!B2&!B1&B&!A1&!A|C1&C&!B2&!B1&B&A1&!A|C1&C&B2&!B1&B&A1&!A|!C1&!C&B2&B1&B&A1&!A|C1&!C&B2&B1&B&A1&!A|C1&C&B2&B1&B&A1&!A|!C1&C&B2&B1&B&A1&!A|C1&C&!B2&B1&B&A1&!A|C1&C&!B2&B1&!B&A1&!A|C1&C&B2&B1&!B&A1&!A|C1&C&B2&!B1&!B&A1&!A|C1&C&!B2&!B1&!B&A1&!A|C1&C&!B2&!B1&!B&A1&A|C1&C&B2&!B1&!B&A1&A|C1&C&B2&B1&!B&A1&A|C1&C&!B2&B1&!B&A1&A|C1&C&!B2&B1&B&A1&A|!C1&C&B2&B1&B&A1&A|C1&C&B2&B1&B&A1&A|C1&!C&B2&B1&B&A1&A|!C1&!C&B2&B1&B&A1&A|C1&C&B2&!B1&B&A1&A|C1&C&!B2&!B1&B&A1&A|C1&C&!B2&!B1&B&!A1&A|C1&C&B2&!B1&B&!A1&A|!C1&!C&B2&B1&B&!A1&A|C1&!C&B2&B1&B&!A1&A|C1&C&B2&B1&B&!A1&A|!C1&C&B2&B1&B&!A1&A|C1&C&!B2&B1&B&!A1&A|C1&C&!B2&B1&!B&!A1&A|C1&C&B2&B1&!B&!A1&A|C1&C&B2&!B1&!B&!A1&A|C1&C&!B2&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOI232.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAI2141 -l AOOAI2141 -i D C3 C2 C1 C B A1 A -o Y -f Y=!(D&!C3&!C2&!C1&C&B&!A1&!A|D&C3&!C2&!C1&C&B&!A1&!A|D&C3&C2&!C1&C&B&!A1&!A|D&!C3&C2&!C1&C&B&!A1&!A|D&!C3&C2&C1&C&B&!A1&!A|D&C3&C2&C1&C&B&!A1&!A|D&C3&!C2&C1&C&B&!A1&!A|D&!C3&!C2&C1&C&B&!A1&!A|D&!C3&!C2&C1&!C&B&!A1&!A|D&C3&!C2&C1&!C&B&!A1&!A|D&C3&C2&C1&!C&B&!A1&!A|D&!C3&C2&C1&!C&B&!A1&!A|D&!C3&C2&!C1&!C&B&!A1&!A|D&C3&C2&!C1&!C&B&!A1&!A|D&C3&!C2&!C1&!C&B&!A1&!A|D&C3&!C2&!C1&!C&B&A1&!A|D&C3&C2&!C1&!C&B&A1&!A|D&!C3&C2&!C1&!C&B&A1&!A|D&!C3&C2&C1&!C&B&A1&!A|D&C3&C2&C1&!C&B&A1&!A|D&C3&!C2&C1&!C&B&A1&!A|D&!C3&!C2&C1&!C&B&A1&!A|D&!C3&!C2&C1&C&B&A1&!A|D&C3&!C2&C1&C&B&A1&!A|D&C3&C2&C1&C&B&A1&!A|D&!C3&C2&C1&C&B&A1&!A|D&!C3&C2&!C1&C&B&A1&!A|D&C3&C2&!C1&C&B&A1&!A|D&C3&!C2&!C1&C&B&A1&!A|D&!C3&!C2&!C1&C&B&A1&!A|D&C3&!C2&!C1&!C&!B&A1&A|D&C3&C2&!C1&!C&!B&A1&A|D&!C3&C2&!C1&!C&!B&A1&A|D&!C3&C2&C1&!C&!B&A1&A|D&C3&C2&C1&!C&!B&A1&A|D&C3&!C2&C1&!C&!B&A1&A|D&!C3&!C2&C1&!C&!B&A1&A|D&!C3&!C2&C1&C&!B&A1&A|D&C3&!C2&C1&C&!B&A1&A|D&C3&C2&C1&C&!B&A1&A|D&!C3&C2&C1&C&!B&A1&A|D&!C3&C2&!C1&C&!B&A1&A|D&C3&C2&!C1&C&!B&A1&A|D&C3&!C2&!C1&C&!B&A1&A|D&!C3&!C2&!C1&C&!B&A1&A|D&!C3&!C2&!C1&C&B&A1&A|D&C3&!C2&!C1&C&B&A1&A|D&C3&C2&!C1&C&B&A1&A|D&!C3&C2&!C1&C&B&A1&A|D&!C3&C2&C1&C&B&A1&A|D&C3&C2&C1&C&B&A1&A|D&C3&!C2&C1&C&B&A1&A|D&!C3&!C2&C1&C&B&A1&A|D&!C3&!C2&C1&!C&B&A1&A|D&C3&!C2&C1&!C&B&A1&A|D&C3&C2&C1&!C&B&A1&A|D&!C3&C2&C1&!C&B&A1&A|D&!C3&C2&!C1&!C&B&A1&A|D&C3&C2&!C1&!C&B&A1&A|D&C3&!C2&!C1&!C&B&A1&A|D&C3&!C2&!C1&!C&B&!A1&A|D&C3&C2&!C1&!C&B&!A1&A|D&!C3&C2&!C1&!C&B&!A1&A|D&!C3&C2&C1&!C&B&!A1&A|D&C3&C2&C1&!C&B&!A1&A|D&C3&!C2&C1&!C&B&!A1&A|D&!C3&!C2&C1&!C&B&!A1&A|D&!C3&!C2&C1&C&B&!A1&A|D&C3&!C2&C1&C&B&!A1&A|D&C3&C2&C1&C&B&!A1&A|D&!C3&C2&C1&C&B&!A1&A|D&!C3&C2&!C1&C&B&!A1&A|D&C3&C2&!C1&C&B&!A1&A|D&C3&!C2&!C1&C&B&!A1&A|D&!C3&!C2&!C1&C&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAI2141.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n NAND2 -l NAND2 -i A1 A -o Y -f Y=!(A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist NAND2.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOAI3321 -l AAAOAI3321 -i D C1 C B2 B1 B A2 A1 A -o Y -f Y=!(D&C1&C&!B2&!B1&!B&!A2&!A1&!A|D&C1&C&B2&!B1&!B&!A2&!A1&!A|D&C1&C&B2&B1&!B&!A2&!A1&!A|D&C1&C&!B2&B1&!B&!A2&!A1&!A|D&C1&C&!B2&B1&B&!A2&!A1&!A|D&!C1&C&B2&B1&B&!A2&!A1&!A|D&C1&C&B2&B1&B&!A2&!A1&!A|D&C1&!C&B2&B1&B&!A2&!A1&!A|D&!C1&!C&B2&B1&B&!A2&!A1&!A|D&C1&C&B2&!B1&B&!A2&!A1&!A|D&C1&C&!B2&!B1&B&!A2&!A1&!A|D&C1&C&!B2&!B1&B&A2&!A1&!A|D&C1&C&B2&!B1&B&A2&!A1&!A|D&!C1&!C&B2&B1&B&A2&!A1&!A|D&C1&!C&B2&B1&B&A2&!A1&!A|D&C1&C&B2&B1&B&A2&!A1&!A|D&!C1&C&B2&B1&B&A2&!A1&!A|D&C1&C&!B2&B1&B&A2&!A1&!A|D&C1&C&!B2&B1&!B&A2&!A1&!A|D&C1&C&B2&B1&!B&A2&!A1&!A|D&C1&C&B2&!B1&!B&A2&!A1&!A|D&C1&C&!B2&!B1&!B&A2&!A1&!A|D&C1&C&!B2&!B1&!B&A2&A1&!A|D&C1&C&B2&!B1&!B&A2&A1&!A|D&C1&C&B2&B1&!B&A2&A1&!A|D&C1&C&!B2&B1&!B&A2&A1&!A|D&C1&C&!B2&B1&B&A2&A1&!A|D&!C1&C&B2&B1&B&A2&A1&!A|D&C1&C&B2&B1&B&A2&A1&!A|D&C1&!C&B2&B1&B&A2&A1&!A|D&!C1&!C&B2&B1&B&A2&A1&!A|D&C1&C&B2&!B1&B&A2&A1&!A|D&C1&C&!B2&!B1&B&A2&A1&!A|D&C1&C&!B2&!B1&B&!A2&A1&!A|D&C1&C&B2&!B1&B&!A2&A1&!A|D&!C1&!C&B2&B1&B&!A2&A1&!A|D&C1&!C&B2&B1&B&!A2&A1&!A|D&C1&C&B2&B1&B&!A2&A1&!A|D&!C1&C&B2&B1&B&!A2&A1&!A|D&C1&C&!B2&B1&B&!A2&A1&!A|D&C1&C&!B2&B1&!B&!A2&A1&!A|D&C1&C&B2&B1&!B&!A2&A1&!A|D&C1&C&B2&!B1&!B&!A2&A1&!A|D&C1&C&!B2&!B1&!B&!A2&A1&!A|D&C1&C&!B2&!B1&!B&!A2&A1&A|D&C1&C&B2&!B1&!B&!A2&A1&A|D&C1&C&B2&B1&!B&!A2&A1&A|D&C1&C&!B2&B1&!B&!A2&A1&A|D&C1&C&!B2&B1&B&!A2&A1&A|D&!C1&C&B2&B1&B&!A2&A1&A|D&C1&C&B2&B1&B&!A2&A1&A|D&C1&!C&B2&B1&B&!A2&A1&A|D&!C1&!C&B2&B1&B&!A2&A1&A|D&C1&C&B2&!B1&B&!A2&A1&A|D&C1&C&!B2&!B1&B&!A2&A1&A|D&!C1&!C&!B2&!B1&B&A2&A1&A|D&C1&!C&!B2&!B1&B&A2&A1&A|D&C1&C&!B2&!B1&B&A2&A1&A|D&!C1&C&!B2&!B1&B&A2&A1&A|D&!C1&C&B2&!B1&B&A2&A1&A|D&C1&C&B2&!B1&B&A2&A1&A|D&C1&!C&B2&!B1&B&A2&A1&A|D&!C1&!C&B2&!B1&B&A2&A1&A|D&!C1&!C&B2&B1&B&A2&A1&A|D&C1&!C&B2&B1&B&A2&A1&A|D&C1&C&B2&B1&B&A2&A1&A|D&!C1&C&B2&B1&B&A2&A1&A|D&!C1&C&!B2&B1&B&A2&A1&A|D&C1&C&!B2&B1&B&A2&A1&A|D&C1&!C&!B2&B1&B&A2&A1&A|D&!C1&!C&!B2&B1&B&A2&A1&A|D&!C1&!C&!B2&B1&!B&A2&A1&A|D&C1&!C&!B2&B1&!B&A2&A1&A|D&C1&C&!B2&B1&!B&A2&A1&A|D&!C1&C&!B2&B1&!B&A2&A1&A|D&!C1&C&B2&B1&!B&A2&A1&A|D&C1&C&B2&B1&!B&A2&A1&A|D&C1&!C&B2&B1&!B&A2&A1&A|D&!C1&!C&B2&B1&!B&A2&A1&A|D&!C1&!C&B2&!B1&!B&A2&A1&A|D&C1&!C&B2&!B1&!B&A2&A1&A|D&C1&C&B2&!B1&!B&A2&A1&A|D&!C1&C&B2&!B1&!B&A2&A1&A|D&!C1&C&!B2&!B1&!B&A2&A1&A|D&C1&C&!B2&!B1&!B&A2&A1&A|D&C1&!C&!B2&!B1&!B&A2&A1&A|D&!C1&!C&!B2&!B1&!B&A2&A1&A|D&C1&C&!B2&!B1&!B&A2&!A1&A|D&C1&C&B2&!B1&!B&A2&!A1&A|D&C1&C&B2&B1&!B&A2&!A1&A|D&C1&C&!B2&B1&!B&A2&!A1&A|D&C1&C&!B2&B1&B&A2&!A1&A|D&!C1&C&B2&B1&B&A2&!A1&A|D&C1&C&B2&B1&B&A2&!A1&A|D&C1&!C&B2&B1&B&A2&!A1&A|D&!C1&!C&B2&B1&B&A2&!A1&A|D&C1&C&B2&!B1&B&A2&!A1&A|D&C1&C&!B2&!B1&B&A2&!A1&A|D&C1&C&!B2&!B1&B&!A2&!A1&A|D&C1&C&B2&!B1&B&!A2&!A1&A|D&!C1&!C&B2&B1&B&!A2&!A1&A|D&C1&!C&B2&B1&B&!A2&!A1&A|D&C1&C&B2&B1&B&!A2&!A1&A|D&!C1&C&B2&B1&B&!A2&!A1&A|D&C1&C&!B2&B1&B&!A2&!A1&A|D&C1&C&!B2&B1&!B&!A2&!A1&A|D&C1&C&B2&B1&!B&!A2&!A1&A|D&C1&C&B2&!B1&!B&!A2&!A1&A|D&C1&C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOAI3321.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOAI21231 -l OAAOOAI21231 -i E D2 D1 D C1 C B A1 A -o Y -f Y=!(E&D2&!D1&!D&C1&C&!B&!A1&!A|E&D2&D1&!D&C1&C&!B&!A1&!A|E&!D2&D1&!D&C1&C&!B&!A1&!A|E&!D2&D1&D&C1&C&!B&!A1&!A|E&D2&D1&D&C1&C&!B&!A1&!A|E&D2&!D1&D&C1&C&!B&!A1&!A|E&!D2&!D1&D&C1&C&!B&!A1&!A|E&!D2&!D1&D&C1&C&B&!A1&!A|E&D2&!D1&D&C1&C&B&!A1&!A|E&D2&D1&D&C1&C&B&!A1&!A|E&!D2&D1&D&C1&C&B&!A1&!A|E&!D2&D1&!D&C1&C&B&!A1&!A|E&D2&D1&!D&C1&C&B&!A1&!A|E&D2&!D1&!D&C1&C&B&!A1&!A|E&D2&!D1&!D&!C1&!C&B&A1&!A|E&D2&D1&!D&!C1&!C&B&A1&!A|E&!D2&D1&!D&!C1&!C&B&A1&!A|E&!D2&D1&D&!C1&!C&B&A1&!A|E&D2&D1&D&!C1&!C&B&A1&!A|E&D2&!D1&D&!C1&!C&B&A1&!A|E&!D2&!D1&D&!C1&!C&B&A1&!A|E&!D2&!D1&D&C1&!C&B&A1&!A|E&D2&!D1&D&C1&!C&B&A1&!A|E&D2&D1&D&C1&!C&B&A1&!A|E&!D2&D1&D&C1&!C&B&A1&!A|E&!D2&D1&!D&C1&!C&B&A1&!A|E&D2&D1&!D&C1&!C&B&A1&!A|E&D2&!D1&!D&C1&!C&B&A1&!A|E&D2&!D1&!D&C1&C&B&A1&!A|E&D2&D1&!D&C1&C&B&A1&!A|E&!D2&D1&!D&C1&C&B&A1&!A|E&!D2&D1&D&C1&C&B&A1&!A|E&D2&D1&D&C1&C&B&A1&!A|E&D2&!D1&D&C1&C&B&A1&!A|E&!D2&!D1&D&C1&C&B&A1&!A|E&!D2&!D1&D&!C1&C&B&A1&!A|E&D2&!D1&D&!C1&C&B&A1&!A|E&D2&D1&D&!C1&C&B&A1&!A|E&!D2&D1&D&!C1&C&B&A1&!A|E&!D2&D1&!D&!C1&C&B&A1&!A|E&D2&D1&!D&!C1&C&B&A1&!A|E&D2&!D1&!D&!C1&C&B&A1&!A|E&!D2&!D1&D&C1&C&!B&A1&!A|E&D2&!D1&D&C1&C&!B&A1&!A|E&D2&D1&D&C1&C&!B&A1&!A|E&!D2&D1&D&C1&C&!B&A1&!A|E&!D2&D1&!D&C1&C&!B&A1&!A|E&D2&D1&!D&C1&C&!B&A1&!A|E&D2&!D1&!D&C1&C&!B&A1&!A|E&D2&!D1&!D&C1&C&!B&A1&A|E&D2&D1&!D&C1&C&!B&A1&A|E&!D2&D1&!D&C1&C&!B&A1&A|E&!D2&D1&D&C1&C&!B&A1&A|E&D2&D1&D&C1&C&!B&A1&A|E&D2&!D1&D&C1&C&!B&A1&A|E&!D2&!D1&D&C1&C&!B&A1&A|E&D2&!D1&!D&!C1&C&B&A1&A|E&D2&D1&!D&!C1&C&B&A1&A|E&!D2&D1&!D&!C1&C&B&A1&A|E&!D2&D1&D&!C1&C&B&A1&A|E&D2&D1&D&!C1&C&B&A1&A|E&D2&!D1&D&!C1&C&B&A1&A|E&!D2&!D1&D&!C1&C&B&A1&A|E&!D2&!D1&D&C1&C&B&A1&A|E&D2&!D1&D&C1&C&B&A1&A|E&D2&D1&D&C1&C&B&A1&A|E&!D2&D1&D&C1&C&B&A1&A|E&!D2&D1&!D&C1&C&B&A1&A|E&D2&D1&!D&C1&C&B&A1&A|E&D2&!D1&!D&C1&C&B&A1&A|E&D2&!D1&!D&C1&!C&B&A1&A|E&D2&D1&!D&C1&!C&B&A1&A|E&!D2&D1&!D&C1&!C&B&A1&A|E&!D2&D1&D&C1&!C&B&A1&A|E&D2&D1&D&C1&!C&B&A1&A|E&D2&!D1&D&C1&!C&B&A1&A|E&!D2&!D1&D&C1&!C&B&A1&A|E&!D2&!D1&D&!C1&!C&B&A1&A|E&D2&!D1&D&!C1&!C&B&A1&A|E&D2&D1&D&!C1&!C&B&A1&A|E&!D2&D1&D&!C1&!C&B&A1&A|E&!D2&D1&!D&!C1&!C&B&A1&A|E&D2&D1&!D&!C1&!C&B&A1&A|E&D2&!D1&!D&!C1&!C&B&A1&A|E&D2&!D1&!D&!C1&!C&B&!A1&A|E&D2&D1&!D&!C1&!C&B&!A1&A|E&!D2&D1&!D&!C1&!C&B&!A1&A|E&!D2&D1&D&!C1&!C&B&!A1&A|E&D2&D1&D&!C1&!C&B&!A1&A|E&D2&!D1&D&!C1&!C&B&!A1&A|E&!D2&!D1&D&!C1&!C&B&!A1&A|E&!D2&!D1&D&C1&!C&B&!A1&A|E&D2&!D1&D&C1&!C&B&!A1&A|E&D2&D1&D&C1&!C&B&!A1&A|E&!D2&D1&D&C1&!C&B&!A1&A|E&!D2&D1&!D&C1&!C&B&!A1&A|E&D2&D1&!D&C1&!C&B&!A1&A|E&D2&!D1&!D&C1&!C&B&!A1&A|E&D2&!D1&!D&C1&C&B&!A1&A|E&D2&D1&!D&C1&C&B&!A1&A|E&!D2&D1&!D&C1&C&B&!A1&A|E&!D2&D1&D&C1&C&B&!A1&A|E&D2&D1&D&C1&C&B&!A1&A|E&D2&!D1&D&C1&C&B&!A1&A|E&!D2&!D1&D&C1&C&B&!A1&A|E&!D2&!D1&D&!C1&C&B&!A1&A|E&D2&!D1&D&!C1&C&B&!A1&A|E&D2&D1&D&!C1&C&B&!A1&A|E&!D2&D1&D&!C1&C&B&!A1&A|E&!D2&D1&!D&!C1&C&B&!A1&A|E&D2&D1&!D&!C1&C&B&!A1&A|E&D2&!D1&!D&!C1&C&B&!A1&A|E&!D2&!D1&D&C1&C&!B&!A1&A|E&D2&!D1&D&C1&C&!B&!A1&A|E&D2&D1&D&C1&C&!B&!A1&A|E&!D2&D1&D&C1&C&!B&!A1&A|E&!D2&D1&!D&C1&C&!B&!A1&A|E&D2&D1&!D&C1&C&!B&!A1&A|E&D2&!D1&!D&C1&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOAI21231.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAOAOI222111 -l OOOAOAOI222111 -i F E D C1 C B1 B A1 A -o Y -f Y=(!F&!E&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D&C1&!C&!B1&!B&!A1&!A|!F&E&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D&C1&C&!B1&!B&!A1&!A|!F&E&!D&C1&C&!B1&!B&!A1&!A|!F&!E&D&C1&C&!B1&!B&!A1&!A|!F&!E&D&!C1&C&!B1&!B&!A1&!A|!F&E&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D&!C1&C&B1&!B&!A1&!A|!F&E&!D&!C1&C&B1&!B&!A1&!A|!F&!E&D&!C1&C&B1&!B&!A1&!A|!F&!E&D&C1&C&B1&!B&!A1&!A|!F&E&!D&C1&C&B1&!B&!A1&!A|!F&!E&!D&C1&C&B1&!B&!A1&!A|!F&!E&!D&C1&!C&B1&!B&!A1&!A|!F&E&!D&C1&!C&B1&!B&!A1&!A|!F&!E&D&C1&!C&B1&!B&!A1&!A|!F&!E&D&!C1&!C&B1&!B&!A1&!A|!F&E&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D&!C1&!C&B1&B&!A1&!A|!F&E&!D&!C1&!C&B1&B&!A1&!A|!F&!E&D&!C1&!C&B1&B&!A1&!A|!F&!E&D&C1&!C&B1&B&!A1&!A|!F&E&!D&C1&!C&B1&B&!A1&!A|!F&!E&!D&C1&!C&B1&B&!A1&!A|!F&!E&!D&C1&C&B1&B&!A1&!A|!F&E&!D&C1&C&B1&B&!A1&!A|!F&!E&D&C1&C&B1&B&!A1&!A|!F&!E&D&!C1&C&B1&B&!A1&!A|!F&E&!D&!C1&C&B1&B&!A1&!A|!F&!E&!D&!C1&C&B1&B&!A1&!A|!F&!E&!D&!C1&C&!B1&B&!A1&!A|!F&E&!D&!C1&C&!B1&B&!A1&!A|!F&!E&D&!C1&C&!B1&B&!A1&!A|!F&!E&D&C1&C&!B1&B&!A1&!A|!F&E&!D&C1&C&!B1&B&!A1&!A|!F&!E&!D&C1&C&!B1&B&!A1&!A|!F&!E&!D&C1&!C&!B1&B&!A1&!A|!F&E&!D&C1&!C&!B1&B&!A1&!A|!F&!E&D&C1&!C&!B1&B&!A1&!A|!F&!E&D&!C1&!C&!B1&B&!A1&!A|!F&E&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D&!C1&!C&!B1&B&A1&!A|!F&E&!D&!C1&!C&!B1&B&A1&!A|!F&!E&D&!C1&!C&!B1&B&A1&!A|!F&!E&D&C1&!C&!B1&B&A1&!A|!F&!E&!D&C1&!C&!B1&B&A1&!A|!F&!E&!D&C1&C&!B1&B&A1&!A|!F&!E&D&C1&C&!B1&B&A1&!A|!F&!E&D&!C1&C&!B1&B&A1&!A|!F&!E&!D&!C1&C&!B1&B&A1&!A|!F&!E&!D&!C1&C&B1&B&A1&!A|!F&!E&D&!C1&C&B1&B&A1&!A|!F&!E&D&C1&C&B1&B&A1&!A|!F&!E&!D&C1&C&B1&B&A1&!A|!F&!E&!D&C1&!C&B1&B&A1&!A|!F&!E&D&C1&!C&B1&B&A1&!A|!F&!E&D&!C1&!C&B1&B&A1&!A|!F&E&!D&!C1&!C&B1&B&A1&!A|!F&!E&!D&!C1&!C&B1&B&A1&!A|!F&!E&!D&!C1&!C&B1&!B&A1&!A|!F&E&!D&!C1&!C&B1&!B&A1&!A|!F&!E&D&!C1&!C&B1&!B&A1&!A|!F&!E&D&C1&!C&B1&!B&A1&!A|!F&!E&!D&C1&!C&B1&!B&A1&!A|!F&!E&!D&C1&C&B1&!B&A1&!A|!F&!E&D&C1&C&B1&!B&A1&!A|!F&!E&D&!C1&C&B1&!B&A1&!A|!F&!E&!D&!C1&C&B1&!B&A1&!A|!F&!E&!D&!C1&C&!B1&!B&A1&!A|!F&E&!D&!C1&C&!B1&!B&A1&!A|!F&!E&D&!C1&C&!B1&!B&A1&!A|!F&!E&D&C1&C&!B1&!B&A1&!A|!F&E&!D&C1&C&!B1&!B&A1&!A|!F&!E&!D&C1&C&!B1&!B&A1&!A|!F&!E&!D&C1&!C&!B1&!B&A1&!A|!F&E&!D&C1&!C&!B1&!B&A1&!A|!F&!E&D&C1&!C&!B1&!B&A1&!A|!F&!E&D&!C1&!C&!B1&!B&A1&!A|!F&E&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D&!C1&!C&!B1&!B&A1&A|!F&E&!D&!C1&!C&!B1&!B&A1&A|!F&!E&D&!C1&!C&!B1&!B&A1&A|!F&!E&D&C1&!C&!B1&!B&A1&A|!F&E&!D&C1&!C&!B1&!B&A1&A|!F&!E&!D&C1&!C&!B1&!B&A1&A|!F&!E&!D&C1&C&!B1&!B&A1&A|!F&E&!D&C1&C&!B1&!B&A1&A|!F&!E&D&C1&C&!B1&!B&A1&A|!F&!E&D&!C1&C&!B1&!B&A1&A|!F&E&!D&!C1&C&!B1&!B&A1&A|!F&!E&!D&!C1&C&!B1&!B&A1&A|!F&!E&!D&!C1&C&B1&!B&A1&A|!F&!E&D&!C1&C&B1&!B&A1&A|!F&!E&D&C1&C&B1&!B&A1&A|!F&!E&!D&C1&C&B1&!B&A1&A|!F&!E&!D&C1&!C&B1&!B&A1&A|!F&!E&D&C1&!C&B1&!B&A1&A|!F&!E&D&!C1&!C&B1&!B&A1&A|!F&E&!D&!C1&!C&B1&!B&A1&A|!F&!E&!D&!C1&!C&B1&!B&A1&A|!F&!E&!D&!C1&!C&B1&B&A1&A|!F&E&!D&!C1&!C&B1&B&A1&A|!F&!E&D&!C1&!C&B1&B&A1&A|!F&!E&D&C1&!C&B1&B&A1&A|!F&!E&!D&C1&!C&B1&B&A1&A|!F&!E&!D&C1&C&B1&B&A1&A|!F&!E&D&C1&C&B1&B&A1&A|!F&!E&D&!C1&C&B1&B&A1&A|!F&!E&!D&!C1&C&B1&B&A1&A|!F&!E&!D&!C1&C&!B1&B&A1&A|!F&!E&D&!C1&C&!B1&B&A1&A|!F&!E&D&C1&C&!B1&B&A1&A|!F&!E&!D&C1&C&!B1&B&A1&A|!F&!E&!D&C1&!C&!B1&B&A1&A|!F&!E&D&C1&!C&!B1&B&A1&A|!F&!E&D&!C1&!C&!B1&B&A1&A|!F&E&!D&!C1&!C&!B1&B&A1&A|!F&!E&!D&!C1&!C&!B1&B&A1&A|!F&!E&!D&!C1&!C&!B1&B&!A1&A|!F&E&!D&!C1&!C&!B1&B&!A1&A|!F&!E&D&!C1&!C&!B1&B&!A1&A|!F&!E&D&C1&!C&!B1&B&!A1&A|!F&!E&!D&C1&!C&!B1&B&!A1&A|!F&!E&!D&C1&C&!B1&B&!A1&A|!F&!E&D&C1&C&!B1&B&!A1&A|!F&!E&D&!C1&C&!B1&B&!A1&A|!F&!E&!D&!C1&C&!B1&B&!A1&A|!F&!E&!D&!C1&C&B1&B&!A1&A|!F&!E&D&!C1&C&B1&B&!A1&A|!F&!E&D&C1&C&B1&B&!A1&A|!F&!E&!D&C1&C&B1&B&!A1&A|!F&!E&!D&C1&!C&B1&B&!A1&A|!F&!E&D&C1&!C&B1&B&!A1&A|!F&!E&D&!C1&!C&B1&B&!A1&A|!F&E&!D&!C1&!C&B1&B&!A1&A|!F&!E&!D&!C1&!C&B1&B&!A1&A|!F&!E&!D&!C1&!C&B1&!B&!A1&A|!F&E&!D&!C1&!C&B1&!B&!A1&A|!F&!E&D&!C1&!C&B1&!B&!A1&A|!F&!E&D&C1&!C&B1&!B&!A1&A|!F&!E&!D&C1&!C&B1&!B&!A1&A|!F&!E&!D&C1&C&B1&!B&!A1&A|!F&!E&D&C1&C&B1&!B&!A1&A|!F&!E&D&!C1&C&B1&!B&!A1&A|!F&!E&!D&!C1&C&B1&!B&!A1&A|!F&!E&!D&!C1&C&!B1&!B&!A1&A|!F&E&!D&!C1&C&!B1&!B&!A1&A|!F&!E&D&!C1&C&!B1&!B&!A1&A|!F&!E&D&C1&C&!B1&!B&!A1&A|!F&E&!D&C1&C&!B1&!B&!A1&A|!F&!E&!D&C1&C&!B1&!B&!A1&A|!F&!E&!D&C1&!C&!B1&!B&!A1&A|!F&E&!D&C1&!C&!B1&!B&!A1&A|!F&!E&D&C1&!C&!B1&!B&!A1&A|!F&!E&D&!C1&!C&!B1&!B&!A1&A|!F&E&!D&!C1&!C&!B1&!B&!A1&A|!F&!E&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAOAOI222111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOAI2211 -l OOAOAI2211 -i D C B1 B A1 A -o Y -f Y=!(D&C&!B1&!B&!A1&!A|D&C&B1&!B&!A1&!A|D&C&B1&B&!A1&!A|D&C&!B1&B&!A1&!A|D&!C&!B1&B&A1&!A|D&C&!B1&B&A1&!A|D&C&B1&B&A1&!A|D&!C&B1&B&A1&!A|D&!C&B1&!B&A1&!A|D&C&B1&!B&A1&!A|D&C&!B1&!B&A1&!A|D&C&!B1&!B&A1&A|D&C&B1&!B&A1&A|D&!C&B1&!B&A1&A|D&!C&B1&B&A1&A|D&C&B1&B&A1&A|D&C&!B1&B&A1&A|D&!C&!B1&B&A1&A|D&!C&!B1&B&!A1&A|D&C&!B1&B&!A1&A|D&C&B1&B&!A1&A|D&!C&B1&B&!A1&A|D&!C&B1&!B&!A1&A|D&C&B1&!B&!A1&A|D&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOAI2211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAOI3212 -l AAOAOI3212 -i D1 D C B1 B A2 A1 A -o Y -f Y=(!D1&!D&!C&!B1&!B&!A2&!A1&!A|!D1&!D&C&!B1&!B&!A2&!A1&!A|!D1&!D&C&B1&!B&!A2&!A1&!A|!D1&!D&!C&B1&!B&!A2&!A1&!A|!D1&!D&!C&B1&B&!A2&!A1&!A|!D1&!D&C&!B1&B&!A2&!A1&!A|!D1&!D&!C&!B1&B&!A2&!A1&!A|!D1&!D&!C&!B1&B&A2&!A1&!A|!D1&!D&C&!B1&B&A2&!A1&!A|!D1&!D&!C&B1&B&A2&!A1&!A|!D1&!D&!C&B1&!B&A2&!A1&!A|!D1&!D&C&B1&!B&A2&!A1&!A|!D1&!D&C&!B1&!B&A2&!A1&!A|!D1&!D&!C&!B1&!B&A2&!A1&!A|!D1&!D&!C&!B1&!B&A2&A1&!A|!D1&!D&C&!B1&!B&A2&A1&!A|!D1&!D&C&B1&!B&A2&A1&!A|!D1&!D&!C&B1&!B&A2&A1&!A|!D1&!D&!C&B1&B&A2&A1&!A|!D1&!D&C&!B1&B&A2&A1&!A|!D1&!D&!C&!B1&B&A2&A1&!A|!D1&!D&!C&!B1&B&!A2&A1&!A|!D1&!D&C&!B1&B&!A2&A1&!A|!D1&!D&!C&B1&B&!A2&A1&!A|!D1&!D&!C&B1&!B&!A2&A1&!A|!D1&!D&C&B1&!B&!A2&A1&!A|!D1&!D&C&!B1&!B&!A2&A1&!A|!D1&!D&!C&!B1&!B&!A2&A1&!A|!D1&!D&!C&!B1&!B&!A2&A1&A|!D1&!D&C&!B1&!B&!A2&A1&A|!D1&!D&C&B1&!B&!A2&A1&A|!D1&!D&!C&B1&!B&!A2&A1&A|!D1&!D&!C&B1&B&!A2&A1&A|!D1&!D&C&!B1&B&!A2&A1&A|!D1&!D&!C&!B1&B&!A2&A1&A|!D1&!D&!C&!B1&B&A2&A1&A|!D1&!D&!C&B1&B&A2&A1&A|!D1&!D&!C&B1&!B&A2&A1&A|!D1&!D&!C&!B1&!B&A2&A1&A|!D1&!D&!C&!B1&!B&A2&!A1&A|!D1&!D&C&!B1&!B&A2&!A1&A|!D1&!D&C&B1&!B&A2&!A1&A|!D1&!D&!C&B1&!B&A2&!A1&A|!D1&!D&!C&B1&B&A2&!A1&A|!D1&!D&C&!B1&B&A2&!A1&A|!D1&!D&!C&!B1&B&A2&!A1&A|!D1&!D&!C&!B1&B&!A2&!A1&A|!D1&!D&C&!B1&B&!A2&!A1&A|!D1&!D&!C&B1&B&!A2&!A1&A|!D1&!D&!C&B1&!B&!A2&!A1&A|!D1&!D&C&B1&!B&!A2&!A1&A|!D1&!D&C&!B1&!B&!A2&!A1&A|!D1&!D&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAOI3212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOI3222 -l AAAOI3222 -i D1 D C1 C B1 B A2 A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B1&!B&!A2&!A1&!A|D1&!D&!C1&!C&!B1&!B&!A2&!A1&!A|!D1&D&!C1&!C&!B1&!B&!A2&!A1&!A|!D1&D&C1&!C&!B1&!B&!A2&!A1&!A|D1&!D&C1&!C&!B1&!B&!A2&!A1&!A|!D1&!D&C1&!C&!B1&!B&!A2&!A1&!A|!D1&D&!C1&C&!B1&!B&!A2&!A1&!A|D1&!D&!C1&C&!B1&!B&!A2&!A1&!A|!D1&!D&!C1&C&!B1&!B&!A2&!A1&!A|!D1&!D&!C1&C&B1&!B&!A2&!A1&!A|D1&!D&!C1&C&B1&!B&!A2&!A1&!A|!D1&D&!C1&C&B1&!B&!A2&!A1&!A|!D1&!D&C1&!C&B1&!B&!A2&!A1&!A|D1&!D&C1&!C&B1&!B&!A2&!A1&!A|!D1&D&C1&!C&B1&!B&!A2&!A1&!A|!D1&D&!C1&!C&B1&!B&!A2&!A1&!A|D1&!D&!C1&!C&B1&!B&!A2&!A1&!A|!D1&!D&!C1&!C&B1&!B&!A2&!A1&!A|!D1&!D&!C1&C&!B1&B&!A2&!A1&!A|D1&!D&!C1&C&!B1&B&!A2&!A1&!A|!D1&D&!C1&C&!B1&B&!A2&!A1&!A|!D1&!D&C1&!C&!B1&B&!A2&!A1&!A|D1&!D&C1&!C&!B1&B&!A2&!A1&!A|!D1&D&C1&!C&!B1&B&!A2&!A1&!A|!D1&D&!C1&!C&!B1&B&!A2&!A1&!A|D1&!D&!C1&!C&!B1&B&!A2&!A1&!A|!D1&!D&!C1&!C&!B1&B&!A2&!A1&!A|!D1&!D&!C1&!C&!B1&B&A2&!A1&!A|D1&!D&!C1&!C&!B1&B&A2&!A1&!A|!D1&D&!C1&!C&!B1&B&A2&!A1&!A|!D1&D&C1&!C&!B1&B&A2&!A1&!A|D1&!D&C1&!C&!B1&B&A2&!A1&!A|!D1&!D&C1&!C&!B1&B&A2&!A1&!A|!D1&D&!C1&C&!B1&B&A2&!A1&!A|D1&!D&!C1&C&!B1&B&A2&!A1&!A|!D1&!D&!C1&C&!B1&B&A2&!A1&!A|!D1&!D&!C1&!C&B1&!B&A2&!A1&!A|D1&!D&!C1&!C&B1&!B&A2&!A1&!A|!D1&D&!C1&!C&B1&!B&A2&!A1&!A|!D1&D&C1&!C&B1&!B&A2&!A1&!A|D1&!D&C1&!C&B1&!B&A2&!A1&!A|!D1&!D&C1&!C&B1&!B&A2&!A1&!A|!D1&D&!C1&C&B1&!B&A2&!A1&!A|D1&!D&!C1&C&B1&!B&A2&!A1&!A|!D1&!D&!C1&C&B1&!B&A2&!A1&!A|!D1&!D&!C1&C&!B1&!B&A2&!A1&!A|D1&!D&!C1&C&!B1&!B&A2&!A1&!A|!D1&D&!C1&C&!B1&!B&A2&!A1&!A|!D1&!D&C1&!C&!B1&!B&A2&!A1&!A|D1&!D&C1&!C&!B1&!B&A2&!A1&!A|!D1&D&C1&!C&!B1&!B&A2&!A1&!A|!D1&D&!C1&!C&!B1&!B&A2&!A1&!A|D1&!D&!C1&!C&!B1&!B&A2&!A1&!A|!D1&!D&!C1&!C&!B1&!B&A2&!A1&!A|!D1&!D&!C1&!C&!B1&!B&A2&A1&!A|D1&!D&!C1&!C&!B1&!B&A2&A1&!A|!D1&D&!C1&!C&!B1&!B&A2&A1&!A|!D1&D&C1&!C&!B1&!B&A2&A1&!A|D1&!D&C1&!C&!B1&!B&A2&A1&!A|!D1&!D&C1&!C&!B1&!B&A2&A1&!A|!D1&D&!C1&C&!B1&!B&A2&A1&!A|D1&!D&!C1&C&!B1&!B&A2&A1&!A|!D1&!D&!C1&C&!B1&!B&A2&A1&!A|!D1&!D&!C1&C&B1&!B&A2&A1&!A|D1&!D&!C1&C&B1&!B&A2&A1&!A|!D1&D&!C1&C&B1&!B&A2&A1&!A|!D1&!D&C1&!C&B1&!B&A2&A1&!A|D1&!D&C1&!C&B1&!B&A2&A1&!A|!D1&D&C1&!C&B1&!B&A2&A1&!A|!D1&D&!C1&!C&B1&!B&A2&A1&!A|D1&!D&!C1&!C&B1&!B&A2&A1&!A|!D1&!D&!C1&!C&B1&!B&A2&A1&!A|!D1&!D&!C1&C&!B1&B&A2&A1&!A|D1&!D&!C1&C&!B1&B&A2&A1&!A|!D1&D&!C1&C&!B1&B&A2&A1&!A|!D1&!D&C1&!C&!B1&B&A2&A1&!A|D1&!D&C1&!C&!B1&B&A2&A1&!A|!D1&D&C1&!C&!B1&B&A2&A1&!A|!D1&D&!C1&!C&!B1&B&A2&A1&!A|D1&!D&!C1&!C&!B1&B&A2&A1&!A|!D1&!D&!C1&!C&!B1&B&A2&A1&!A|!D1&!D&!C1&!C&!B1&B&!A2&A1&!A|D1&!D&!C1&!C&!B1&B&!A2&A1&!A|!D1&D&!C1&!C&!B1&B&!A2&A1&!A|!D1&D&C1&!C&!B1&B&!A2&A1&!A|D1&!D&C1&!C&!B1&B&!A2&A1&!A|!D1&!D&C1&!C&!B1&B&!A2&A1&!A|!D1&D&!C1&C&!B1&B&!A2&A1&!A|D1&!D&!C1&C&!B1&B&!A2&A1&!A|!D1&!D&!C1&C&!B1&B&!A2&A1&!A|!D1&!D&!C1&!C&B1&!B&!A2&A1&!A|D1&!D&!C1&!C&B1&!B&!A2&A1&!A|!D1&D&!C1&!C&B1&!B&!A2&A1&!A|!D1&D&C1&!C&B1&!B&!A2&A1&!A|D1&!D&C1&!C&B1&!B&!A2&A1&!A|!D1&!D&C1&!C&B1&!B&!A2&A1&!A|!D1&D&!C1&C&B1&!B&!A2&A1&!A|D1&!D&!C1&C&B1&!B&!A2&A1&!A|!D1&!D&!C1&C&B1&!B&!A2&A1&!A|!D1&!D&!C1&C&!B1&!B&!A2&A1&!A|D1&!D&!C1&C&!B1&!B&!A2&A1&!A|!D1&D&!C1&C&!B1&!B&!A2&A1&!A|!D1&!D&C1&!C&!B1&!B&!A2&A1&!A|D1&!D&C1&!C&!B1&!B&!A2&A1&!A|!D1&D&C1&!C&!B1&!B&!A2&A1&!A|!D1&D&!C1&!C&!B1&!B&!A2&A1&!A|D1&!D&!C1&!C&!B1&!B&!A2&A1&!A|!D1&!D&!C1&!C&!B1&!B&!A2&A1&!A|!D1&!D&!C1&!C&!B1&!B&!A2&A1&A|D1&!D&!C1&!C&!B1&!B&!A2&A1&A|!D1&D&!C1&!C&!B1&!B&!A2&A1&A|!D1&D&C1&!C&!B1&!B&!A2&A1&A|D1&!D&C1&!C&!B1&!B&!A2&A1&A|!D1&!D&C1&!C&!B1&!B&!A2&A1&A|!D1&D&!C1&C&!B1&!B&!A2&A1&A|D1&!D&!C1&C&!B1&!B&!A2&A1&A|!D1&!D&!C1&C&!B1&!B&!A2&A1&A|!D1&!D&!C1&C&B1&!B&!A2&A1&A|D1&!D&!C1&C&B1&!B&!A2&A1&A|!D1&D&!C1&C&B1&!B&!A2&A1&A|!D1&!D&C1&!C&B1&!B&!A2&A1&A|D1&!D&C1&!C&B1&!B&!A2&A1&A|!D1&D&C1&!C&B1&!B&!A2&A1&A|!D1&D&!C1&!C&B1&!B&!A2&A1&A|D1&!D&!C1&!C&B1&!B&!A2&A1&A|!D1&!D&!C1&!C&B1&!B&!A2&A1&A|!D1&!D&!C1&C&!B1&B&!A2&A1&A|D1&!D&!C1&C&!B1&B&!A2&A1&A|!D1&D&!C1&C&!B1&B&!A2&A1&A|!D1&!D&C1&!C&!B1&B&!A2&A1&A|D1&!D&C1&!C&!B1&B&!A2&A1&A|!D1&D&C1&!C&!B1&B&!A2&A1&A|!D1&D&!C1&!C&!B1&B&!A2&A1&A|D1&!D&!C1&!C&!B1&B&!A2&A1&A|!D1&!D&!C1&!C&!B1&B&!A2&A1&A|!D1&!D&!C1&!C&!B1&!B&A2&!A1&A|D1&!D&!C1&!C&!B1&!B&A2&!A1&A|!D1&D&!C1&!C&!B1&!B&A2&!A1&A|!D1&D&C1&!C&!B1&!B&A2&!A1&A|D1&!D&C1&!C&!B1&!B&A2&!A1&A|!D1&!D&C1&!C&!B1&!B&A2&!A1&A|!D1&D&!C1&C&!B1&!B&A2&!A1&A|D1&!D&!C1&C&!B1&!B&A2&!A1&A|!D1&!D&!C1&C&!B1&!B&A2&!A1&A|!D1&!D&!C1&C&B1&!B&A2&!A1&A|D1&!D&!C1&C&B1&!B&A2&!A1&A|!D1&D&!C1&C&B1&!B&A2&!A1&A|!D1&!D&C1&!C&B1&!B&A2&!A1&A|D1&!D&C1&!C&B1&!B&A2&!A1&A|!D1&D&C1&!C&B1&!B&A2&!A1&A|!D1&D&!C1&!C&B1&!B&A2&!A1&A|D1&!D&!C1&!C&B1&!B&A2&!A1&A|!D1&!D&!C1&!C&B1&!B&A2&!A1&A|!D1&!D&!C1&C&!B1&B&A2&!A1&A|D1&!D&!C1&C&!B1&B&A2&!A1&A|!D1&D&!C1&C&!B1&B&A2&!A1&A|!D1&!D&C1&!C&!B1&B&A2&!A1&A|D1&!D&C1&!C&!B1&B&A2&!A1&A|!D1&D&C1&!C&!B1&B&A2&!A1&A|!D1&D&!C1&!C&!B1&B&A2&!A1&A|D1&!D&!C1&!C&!B1&B&A2&!A1&A|!D1&!D&!C1&!C&!B1&B&A2&!A1&A|!D1&!D&!C1&!C&!B1&B&!A2&!A1&A|D1&!D&!C1&!C&!B1&B&!A2&!A1&A|!D1&D&!C1&!C&!B1&B&!A2&!A1&A|!D1&D&C1&!C&!B1&B&!A2&!A1&A|D1&!D&C1&!C&!B1&B&!A2&!A1&A|!D1&!D&C1&!C&!B1&B&!A2&!A1&A|!D1&D&!C1&C&!B1&B&!A2&!A1&A|D1&!D&!C1&C&!B1&B&!A2&!A1&A|!D1&!D&!C1&C&!B1&B&!A2&!A1&A|!D1&!D&!C1&!C&B1&!B&!A2&!A1&A|D1&!D&!C1&!C&B1&!B&!A2&!A1&A|!D1&D&!C1&!C&B1&!B&!A2&!A1&A|!D1&D&C1&!C&B1&!B&!A2&!A1&A|D1&!D&C1&!C&B1&!B&!A2&!A1&A|!D1&!D&C1&!C&B1&!B&!A2&!A1&A|!D1&D&!C1&C&B1&!B&!A2&!A1&A|D1&!D&!C1&C&B1&!B&!A2&!A1&A|!D1&!D&!C1&C&B1&!B&!A2&!A1&A|!D1&!D&!C1&C&!B1&!B&!A2&!A1&A|D1&!D&!C1&C&!B1&!B&!A2&!A1&A|!D1&D&!C1&C&!B1&!B&!A2&!A1&A|!D1&!D&C1&!C&!B1&!B&!A2&!A1&A|D1&!D&C1&!C&!B1&!B&!A2&!A1&A|!D1&D&C1&!C&!B1&!B&!A2&!A1&A|!D1&D&!C1&!C&!B1&!B&!A2&!A1&A|D1&!D&!C1&!C&!B1&!B&!A2&!A1&A|!D1&!D&!C1&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOI3222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOOAI22212 -l AAAOOAI22212 -i E1 E D C1 C B1 B A1 A -o Y -f Y=(!E1&!E&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D&!C1&!C&!B1&!B&!A1&!A|E1&E&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D&C1&!C&!B1&!B&!A1&!A|E1&E&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D&C1&C&!B1&!B&!A1&!A|!E1&!E&D&C1&C&!B1&!B&!A1&!A|!E1&!E&D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D&!C1&C&!B1&!B&!A1&!A|E1&E&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D&!C1&C&B1&!B&!A1&!A|E1&!E&!D&!C1&C&B1&!B&!A1&!A|E1&E&!D&!C1&C&B1&!B&!A1&!A|!E1&E&!D&!C1&C&B1&!B&!A1&!A|!E1&!E&D&!C1&C&B1&!B&!A1&!A|!E1&!E&D&C1&C&B1&!B&!A1&!A|!E1&!E&!D&C1&C&B1&!B&!A1&!A|!E1&!E&!D&C1&!C&B1&!B&!A1&!A|E1&!E&!D&C1&!C&B1&!B&!A1&!A|E1&E&!D&C1&!C&B1&!B&!A1&!A|!E1&E&!D&C1&!C&B1&!B&!A1&!A|!E1&!E&D&C1&!C&B1&!B&!A1&!A|!E1&!E&D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D&!C1&!C&B1&!B&!A1&!A|E1&E&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D&!C1&!C&B1&B&!A1&!A|!E1&!E&D&!C1&!C&B1&B&!A1&!A|!E1&!E&D&C1&!C&B1&B&!A1&!A|!E1&!E&!D&C1&!C&B1&B&!A1&!A|!E1&!E&!D&C1&C&B1&B&!A1&!A|!E1&!E&D&C1&C&B1&B&!A1&!A|!E1&!E&D&!C1&C&B1&B&!A1&!A|!E1&!E&!D&!C1&C&B1&B&!A1&!A|!E1&!E&!D&!C1&C&!B1&B&!A1&!A|E1&!E&!D&!C1&C&!B1&B&!A1&!A|E1&E&!D&!C1&C&!B1&B&!A1&!A|!E1&E&!D&!C1&C&!B1&B&!A1&!A|!E1&!E&D&!C1&C&!B1&B&!A1&!A|!E1&!E&D&C1&C&!B1&B&!A1&!A|!E1&!E&!D&C1&C&!B1&B&!A1&!A|!E1&!E&!D&C1&!C&!B1&B&!A1&!A|E1&!E&!D&C1&!C&!B1&B&!A1&!A|E1&E&!D&C1&!C&!B1&B&!A1&!A|!E1&E&!D&C1&!C&!B1&B&!A1&!A|!E1&!E&D&C1&!C&!B1&B&!A1&!A|!E1&!E&D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D&!C1&!C&!B1&B&!A1&!A|E1&E&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D&!C1&!C&!B1&B&A1&!A|E1&!E&!D&!C1&!C&!B1&B&A1&!A|E1&E&!D&!C1&!C&!B1&B&A1&!A|!E1&E&!D&!C1&!C&!B1&B&A1&!A|!E1&!E&D&!C1&!C&!B1&B&A1&!A|!E1&!E&D&C1&!C&!B1&B&A1&!A|!E1&E&!D&C1&!C&!B1&B&A1&!A|E1&E&!D&C1&!C&!B1&B&A1&!A|E1&!E&!D&C1&!C&!B1&B&A1&!A|!E1&!E&!D&C1&!C&!B1&B&A1&!A|!E1&!E&!D&C1&C&!B1&B&A1&!A|!E1&!E&D&C1&C&!B1&B&A1&!A|!E1&!E&D&!C1&C&!B1&B&A1&!A|!E1&E&!D&!C1&C&!B1&B&A1&!A|E1&E&!D&!C1&C&!B1&B&A1&!A|E1&!E&!D&!C1&C&!B1&B&A1&!A|!E1&!E&!D&!C1&C&!B1&B&A1&!A|!E1&!E&!D&!C1&C&B1&B&A1&!A|!E1&!E&D&!C1&C&B1&B&A1&!A|!E1&!E&D&C1&C&B1&B&A1&!A|!E1&!E&!D&C1&C&B1&B&A1&!A|!E1&!E&!D&C1&!C&B1&B&A1&!A|!E1&!E&D&C1&!C&B1&B&A1&!A|!E1&!E&D&!C1&!C&B1&B&A1&!A|!E1&!E&!D&!C1&!C&B1&B&A1&!A|!E1&!E&!D&!C1&!C&B1&!B&A1&!A|E1&!E&!D&!C1&!C&B1&!B&A1&!A|E1&E&!D&!C1&!C&B1&!B&A1&!A|!E1&E&!D&!C1&!C&B1&!B&A1&!A|!E1&!E&D&!C1&!C&B1&!B&A1&!A|!E1&!E&D&C1&!C&B1&!B&A1&!A|!E1&E&!D&C1&!C&B1&!B&A1&!A|E1&E&!D&C1&!C&B1&!B&A1&!A|E1&!E&!D&C1&!C&B1&!B&A1&!A|!E1&!E&!D&C1&!C&B1&!B&A1&!A|!E1&!E&!D&C1&C&B1&!B&A1&!A|!E1&!E&D&C1&C&B1&!B&A1&!A|!E1&!E&D&!C1&C&B1&!B&A1&!A|!E1&E&!D&!C1&C&B1&!B&A1&!A|E1&E&!D&!C1&C&B1&!B&A1&!A|E1&!E&!D&!C1&C&B1&!B&A1&!A|!E1&!E&!D&!C1&C&B1&!B&A1&!A|!E1&!E&!D&!C1&C&!B1&!B&A1&!A|E1&!E&!D&!C1&C&!B1&!B&A1&!A|E1&E&!D&!C1&C&!B1&!B&A1&!A|!E1&E&!D&!C1&C&!B1&!B&A1&!A|!E1&!E&D&!C1&C&!B1&!B&A1&!A|!E1&!E&D&C1&C&!B1&!B&A1&!A|!E1&!E&!D&C1&C&!B1&!B&A1&!A|!E1&!E&!D&C1&!C&!B1&!B&A1&!A|E1&!E&!D&C1&!C&!B1&!B&A1&!A|E1&E&!D&C1&!C&!B1&!B&A1&!A|!E1&E&!D&C1&!C&!B1&!B&A1&!A|!E1&!E&D&C1&!C&!B1&!B&A1&!A|!E1&!E&D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D&!C1&!C&!B1&!B&A1&!A|E1&E&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D&!C1&!C&!B1&!B&A1&A|!E1&!E&D&!C1&!C&!B1&!B&A1&A|!E1&!E&D&C1&!C&!B1&!B&A1&A|!E1&!E&!D&C1&!C&!B1&!B&A1&A|!E1&!E&!D&C1&C&!B1&!B&A1&A|!E1&!E&D&C1&C&!B1&!B&A1&A|!E1&!E&D&!C1&C&!B1&!B&A1&A|!E1&!E&!D&!C1&C&!B1&!B&A1&A|!E1&!E&!D&!C1&C&B1&!B&A1&A|!E1&!E&D&!C1&C&B1&!B&A1&A|!E1&!E&D&C1&C&B1&!B&A1&A|!E1&!E&!D&C1&C&B1&!B&A1&A|!E1&!E&!D&C1&!C&B1&!B&A1&A|!E1&!E&D&C1&!C&B1&!B&A1&A|!E1&!E&D&!C1&!C&B1&!B&A1&A|!E1&!E&!D&!C1&!C&B1&!B&A1&A|!E1&!E&!D&!C1&!C&B1&B&A1&A|!E1&!E&D&!C1&!C&B1&B&A1&A|!E1&!E&D&C1&!C&B1&B&A1&A|!E1&!E&!D&C1&!C&B1&B&A1&A|!E1&!E&!D&C1&C&B1&B&A1&A|!E1&!E&D&C1&C&B1&B&A1&A|!E1&!E&D&!C1&C&B1&B&A1&A|!E1&!E&!D&!C1&C&B1&B&A1&A|!E1&!E&!D&!C1&C&!B1&B&A1&A|!E1&!E&D&!C1&C&!B1&B&A1&A|!E1&!E&D&C1&C&!B1&B&A1&A|!E1&!E&!D&C1&C&!B1&B&A1&A|!E1&!E&!D&C1&!C&!B1&B&A1&A|!E1&!E&D&C1&!C&!B1&B&A1&A|!E1&!E&D&!C1&!C&!B1&B&A1&A|!E1&!E&!D&!C1&!C&!B1&B&A1&A|!E1&!E&!D&!C1&!C&!B1&B&!A1&A|E1&!E&!D&!C1&!C&!B1&B&!A1&A|E1&E&!D&!C1&!C&!B1&B&!A1&A|!E1&E&!D&!C1&!C&!B1&B&!A1&A|!E1&!E&D&!C1&!C&!B1&B&!A1&A|!E1&!E&D&C1&!C&!B1&B&!A1&A|!E1&E&!D&C1&!C&!B1&B&!A1&A|E1&E&!D&C1&!C&!B1&B&!A1&A|E1&!E&!D&C1&!C&!B1&B&!A1&A|!E1&!E&!D&C1&!C&!B1&B&!A1&A|!E1&!E&!D&C1&C&!B1&B&!A1&A|!E1&!E&D&C1&C&!B1&B&!A1&A|!E1&!E&D&!C1&C&!B1&B&!A1&A|!E1&E&!D&!C1&C&!B1&B&!A1&A|E1&E&!D&!C1&C&!B1&B&!A1&A|E1&!E&!D&!C1&C&!B1&B&!A1&A|!E1&!E&!D&!C1&C&!B1&B&!A1&A|!E1&!E&!D&!C1&C&B1&B&!A1&A|!E1&!E&D&!C1&C&B1&B&!A1&A|!E1&!E&D&C1&C&B1&B&!A1&A|!E1&!E&!D&C1&C&B1&B&!A1&A|!E1&!E&!D&C1&!C&B1&B&!A1&A|!E1&!E&D&C1&!C&B1&B&!A1&A|!E1&!E&D&!C1&!C&B1&B&!A1&A|!E1&!E&!D&!C1&!C&B1&B&!A1&A|!E1&!E&!D&!C1&!C&B1&!B&!A1&A|E1&!E&!D&!C1&!C&B1&!B&!A1&A|E1&E&!D&!C1&!C&B1&!B&!A1&A|!E1&E&!D&!C1&!C&B1&!B&!A1&A|!E1&!E&D&!C1&!C&B1&!B&!A1&A|!E1&!E&D&C1&!C&B1&!B&!A1&A|!E1&E&!D&C1&!C&B1&!B&!A1&A|E1&E&!D&C1&!C&B1&!B&!A1&A|E1&!E&!D&C1&!C&B1&!B&!A1&A|!E1&!E&!D&C1&!C&B1&!B&!A1&A|!E1&!E&!D&C1&C&B1&!B&!A1&A|!E1&!E&D&C1&C&B1&!B&!A1&A|!E1&!E&D&!C1&C&B1&!B&!A1&A|!E1&E&!D&!C1&C&B1&!B&!A1&A|E1&E&!D&!C1&C&B1&!B&!A1&A|E1&!E&!D&!C1&C&B1&!B&!A1&A|!E1&!E&!D&!C1&C&B1&!B&!A1&A|!E1&!E&!D&!C1&C&!B1&!B&!A1&A|E1&!E&!D&!C1&C&!B1&!B&!A1&A|E1&E&!D&!C1&C&!B1&!B&!A1&A|!E1&E&!D&!C1&C&!B1&!B&!A1&A|!E1&!E&D&!C1&C&!B1&!B&!A1&A|!E1&!E&D&C1&C&!B1&!B&!A1&A|!E1&!E&!D&C1&C&!B1&!B&!A1&A|!E1&!E&!D&C1&!C&!B1&!B&!A1&A|E1&!E&!D&C1&!C&!B1&!B&!A1&A|E1&E&!D&C1&!C&!B1&!B&!A1&A|!E1&E&!D&C1&!C&!B1&!B&!A1&A|!E1&!E&D&C1&!C&!B1&!B&!A1&A|!E1&!E&D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D&!C1&!C&!B1&!B&!A1&A|E1&E&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D&!C1&!C&!B1&!B&!A1&A|!E1&!E&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOOAI22212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAOI21121 -l OAOOAOI21121 -i E D1 D C B A1 A -o Y -f Y=(!E&!D1&!D&!C&!B&!A1&!A|!E&D1&!D&!C&!B&!A1&!A|!E&D1&D&!C&!B&!A1&!A|!E&!D1&D&!C&!B&!A1&!A|!E&!D1&!D&C&!B&!A1&!A|!E&!D1&!D&C&B&!A1&!A|!E&!D1&D&!C&B&!A1&!A|!E&D1&D&!C&B&!A1&!A|!E&D1&!D&!C&B&!A1&!A|!E&!D1&!D&!C&B&!A1&!A|!E&!D1&!D&!C&B&A1&!A|!E&!D1&!D&C&B&A1&!A|!E&!D1&!D&C&!B&A1&!A|!E&!D1&D&!C&!B&A1&!A|!E&D1&D&!C&!B&A1&!A|!E&D1&!D&!C&!B&A1&!A|!E&!D1&!D&!C&!B&A1&!A|!E&!D1&!D&!C&!B&A1&A|!E&D1&!D&!C&!B&A1&A|!E&D1&D&!C&!B&A1&A|!E&!D1&D&!C&!B&A1&A|!E&!D1&!D&C&!B&A1&A|!E&!D1&!D&C&B&A1&A|!E&!D1&!D&!C&B&A1&A|!E&!D1&!D&!C&B&!A1&A|!E&!D1&!D&C&B&!A1&A|!E&!D1&!D&C&!B&!A1&A|!E&!D1&D&!C&!B&!A1&A|!E&D1&D&!C&!B&!A1&A|!E&D1&!D&!C&!B&!A1&A|!E&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAOI21121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOI224 -l OAAOI224 -i C3 C2 C1 C B1 B A1 A -o Y -f Y=!(C3&C2&C1&C&!B1&!B&!A1&!A|C3&C2&C1&C&B1&!B&!A1&!A|C3&C2&C1&C&B1&B&!A1&!A|C3&C2&C1&C&!B1&B&!A1&!A|C3&C2&C1&C&!B1&B&A1&!A|!C3&!C2&!C1&C&B1&B&A1&!A|C3&!C2&!C1&C&B1&B&A1&!A|C3&C2&!C1&C&B1&B&A1&!A|!C3&C2&!C1&C&B1&B&A1&!A|!C3&C2&C1&C&B1&B&A1&!A|C3&C2&C1&C&B1&B&A1&!A|C3&!C2&C1&C&B1&B&A1&!A|!C3&!C2&C1&C&B1&B&A1&!A|!C3&!C2&C1&!C&B1&B&A1&!A|C3&!C2&C1&!C&B1&B&A1&!A|C3&C2&C1&!C&B1&B&A1&!A|!C3&C2&C1&!C&B1&B&A1&!A|!C3&C2&!C1&!C&B1&B&A1&!A|C3&C2&!C1&!C&B1&B&A1&!A|C3&!C2&!C1&!C&B1&B&A1&!A|!C3&!C2&!C1&!C&B1&B&A1&!A|C3&C2&C1&C&B1&!B&A1&!A|C3&C2&C1&C&!B1&!B&A1&!A|C3&C2&C1&C&!B1&!B&A1&A|C3&C2&C1&C&B1&!B&A1&A|!C3&!C2&!C1&!C&B1&B&A1&A|C3&!C2&!C1&!C&B1&B&A1&A|C3&C2&!C1&!C&B1&B&A1&A|!C3&C2&!C1&!C&B1&B&A1&A|!C3&C2&C1&!C&B1&B&A1&A|C3&C2&C1&!C&B1&B&A1&A|C3&!C2&C1&!C&B1&B&A1&A|!C3&!C2&C1&!C&B1&B&A1&A|!C3&!C2&C1&C&B1&B&A1&A|C3&!C2&C1&C&B1&B&A1&A|C3&C2&C1&C&B1&B&A1&A|!C3&C2&C1&C&B1&B&A1&A|!C3&C2&!C1&C&B1&B&A1&A|C3&C2&!C1&C&B1&B&A1&A|C3&!C2&!C1&C&B1&B&A1&A|!C3&!C2&!C1&C&B1&B&A1&A|C3&C2&C1&C&!B1&B&A1&A|C3&C2&C1&C&!B1&B&!A1&A|!C3&!C2&!C1&C&B1&B&!A1&A|C3&!C2&!C1&C&B1&B&!A1&A|C3&C2&!C1&C&B1&B&!A1&A|!C3&C2&!C1&C&B1&B&!A1&A|!C3&C2&C1&C&B1&B&!A1&A|C3&C2&C1&C&B1&B&!A1&A|C3&!C2&C1&C&B1&B&!A1&A|!C3&!C2&C1&C&B1&B&!A1&A|!C3&!C2&C1&!C&B1&B&!A1&A|C3&!C2&C1&!C&B1&B&!A1&A|C3&C2&C1&!C&B1&B&!A1&A|!C3&C2&C1&!C&B1&B&!A1&A|!C3&C2&!C1&!C&B1&B&!A1&A|C3&C2&!C1&!C&B1&B&!A1&A|C3&!C2&!C1&!C&B1&B&!A1&A|!C3&!C2&!C1&!C&B1&B&!A1&A|C3&C2&C1&C&B1&!B&!A1&A|C3&C2&C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOI224.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOOOAI22232 -l OOAAOOOAI22232 -i E1 E D2 D1 D C1 C B1 B A1 A -o Y -f Y=!(!E1&E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|E1&E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|E1&E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E1&E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E1&E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|E1&E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|E1&E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|!E1&E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&C1&C&!B1&!B&!A1&!A|E1&E&D2&D1&D&C1&C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&C1&C&!B1&!B&!A1&!A|E1&!E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|E1&E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E1&E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|E1&E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|E1&E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|!E1&E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|!E1&E&D2&!D1&D&C1&C&B1&!B&!A1&!A|E1&E&D2&!D1&D&C1&C&B1&!B&!A1&!A|E1&!E&D2&!D1&D&C1&C&B1&!B&!A1&!A|E1&!E&D2&D1&D&C1&C&B1&!B&!A1&!A|E1&E&D2&D1&D&C1&C&B1&!B&!A1&!A|!E1&E&D2&D1&D&C1&C&B1&!B&!A1&!A|!E1&E&!D2&D1&D&C1&C&B1&!B&!A1&!A|E1&E&!D2&D1&D&C1&C&B1&!B&!A1&!A|E1&!E&!D2&D1&D&C1&C&B1&!B&!A1&!A|E1&!E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|E1&E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|!E1&E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|!E1&E&D2&D1&!D&C1&C&B1&!B&!A1&!A|E1&E&D2&D1&!D&C1&C&B1&!B&!A1&!A|E1&!E&D2&D1&!D&C1&C&B1&!B&!A1&!A|E1&!E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|E1&E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E1&E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E1&E&D2&!D1&!D&C1&C&B1&B&!A1&!A|E1&E&D2&!D1&!D&C1&C&B1&B&!A1&!A|E1&!E&D2&!D1&!D&C1&C&B1&B&!A1&!A|E1&!E&D2&D1&!D&C1&C&B1&B&!A1&!A|E1&E&D2&D1&!D&C1&C&B1&B&!A1&!A|!E1&E&D2&D1&!D&C1&C&B1&B&!A1&!A|!E1&E&!D2&D1&!D&C1&C&B1&B&!A1&!A|E1&E&!D2&D1&!D&C1&C&B1&B&!A1&!A|E1&!E&!D2&D1&!D&C1&C&B1&B&!A1&!A|E1&!E&!D2&D1&D&C1&C&B1&B&!A1&!A|E1&E&!D2&D1&D&C1&C&B1&B&!A1&!A|!E1&E&!D2&D1&D&C1&C&B1&B&!A1&!A|!E1&E&D2&D1&D&C1&C&B1&B&!A1&!A|E1&E&D2&D1&D&C1&C&B1&B&!A1&!A|E1&!E&D2&D1&D&C1&C&B1&B&!A1&!A|E1&!E&D2&!D1&D&C1&C&B1&B&!A1&!A|E1&E&D2&!D1&D&C1&C&B1&B&!A1&!A|!E1&E&D2&!D1&D&C1&C&B1&B&!A1&!A|!E1&E&!D2&!D1&D&C1&C&B1&B&!A1&!A|E1&E&!D2&!D1&D&C1&C&B1&B&!A1&!A|E1&!E&!D2&!D1&D&C1&C&B1&B&!A1&!A|E1&!E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|E1&E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|!E1&E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|!E1&E&D2&!D1&D&C1&C&!B1&B&!A1&!A|E1&E&D2&!D1&D&C1&C&!B1&B&!A1&!A|E1&!E&D2&!D1&D&C1&C&!B1&B&!A1&!A|E1&!E&D2&D1&D&C1&C&!B1&B&!A1&!A|E1&E&D2&D1&D&C1&C&!B1&B&!A1&!A|!E1&E&D2&D1&D&C1&C&!B1&B&!A1&!A|!E1&E&!D2&D1&D&C1&C&!B1&B&!A1&!A|E1&E&!D2&D1&D&C1&C&!B1&B&!A1&!A|E1&!E&!D2&D1&D&C1&C&!B1&B&!A1&!A|E1&!E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|E1&E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|!E1&E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|!E1&E&D2&D1&!D&C1&C&!B1&B&!A1&!A|E1&E&D2&D1&!D&C1&C&!B1&B&!A1&!A|E1&!E&D2&D1&!D&C1&C&!B1&B&!A1&!A|E1&!E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|E1&E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E1&E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E1&E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|E1&E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|E1&E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|E1&E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|E1&E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|!E1&E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|!E1&E&D2&D1&D&!C1&!C&!B1&B&A1&!A|E1&E&D2&D1&D&!C1&!C&!B1&B&A1&!A|E1&!E&D2&D1&D&!C1&!C&!B1&B&A1&!A|E1&!E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|E1&E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E1&E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E1&E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|E1&E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|E1&!E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|E1&!E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|E1&E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|!E1&E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|!E1&E&D2&!D1&D&C1&!C&!B1&B&A1&!A|E1&E&D2&!D1&D&C1&!C&!B1&B&A1&!A|E1&!E&D2&!D1&D&C1&!C&!B1&B&A1&!A|E1&!E&D2&D1&D&C1&!C&!B1&B&A1&!A|E1&E&D2&D1&D&C1&!C&!B1&B&A1&!A|!E1&E&D2&D1&D&C1&!C&!B1&B&A1&!A|!E1&E&!D2&D1&D&C1&!C&!B1&B&A1&!A|E1&E&!D2&D1&D&C1&!C&!B1&B&A1&!A|E1&!E&!D2&D1&D&C1&!C&!B1&B&A1&!A|E1&!E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|E1&E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|!E1&E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|!E1&E&D2&D1&!D&C1&!C&!B1&B&A1&!A|E1&E&D2&D1&!D&C1&!C&!B1&B&A1&!A|E1&!E&D2&D1&!D&C1&!C&!B1&B&A1&!A|E1&!E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|E1&E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|!E1&E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|!E1&E&D2&!D1&!D&C1&C&!B1&B&A1&!A|E1&E&D2&!D1&!D&C1&C&!B1&B&A1&!A|E1&!E&D2&!D1&!D&C1&C&!B1&B&A1&!A|E1&!E&D2&D1&!D&C1&C&!B1&B&A1&!A|E1&E&D2&D1&!D&C1&C&!B1&B&A1&!A|!E1&E&D2&D1&!D&C1&C&!B1&B&A1&!A|!E1&E&!D2&D1&!D&C1&C&!B1&B&A1&!A|E1&E&!D2&D1&!D&C1&C&!B1&B&A1&!A|E1&!E&!D2&D1&!D&C1&C&!B1&B&A1&!A|E1&!E&!D2&D1&D&C1&C&!B1&B&A1&!A|E1&E&!D2&D1&D&C1&C&!B1&B&A1&!A|!E1&E&!D2&D1&D&C1&C&!B1&B&A1&!A|!E1&E&D2&D1&D&C1&C&!B1&B&A1&!A|E1&E&D2&D1&D&C1&C&!B1&B&A1&!A|E1&!E&D2&D1&D&C1&C&!B1&B&A1&!A|E1&!E&D2&!D1&D&C1&C&!B1&B&A1&!A|E1&E&D2&!D1&D&C1&C&!B1&B&A1&!A|!E1&E&D2&!D1&D&C1&C&!B1&B&A1&!A|!E1&E&!D2&!D1&D&C1&C&!B1&B&A1&!A|E1&E&!D2&!D1&D&C1&C&!B1&B&A1&!A|E1&!E&!D2&!D1&D&C1&C&!B1&B&A1&!A|E1&!E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|E1&E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|!E1&E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|!E1&E&D2&!D1&D&!C1&C&!B1&B&A1&!A|E1&E&D2&!D1&D&!C1&C&!B1&B&A1&!A|E1&!E&D2&!D1&D&!C1&C&!B1&B&A1&!A|E1&!E&D2&D1&D&!C1&C&!B1&B&A1&!A|E1&E&D2&D1&D&!C1&C&!B1&B&A1&!A|!E1&E&D2&D1&D&!C1&C&!B1&B&A1&!A|!E1&E&!D2&D1&D&!C1&C&!B1&B&A1&!A|E1&E&!D2&D1&D&!C1&C&!B1&B&A1&!A|E1&!E&!D2&D1&D&!C1&C&!B1&B&A1&!A|E1&!E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|E1&E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|!E1&E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|!E1&E&D2&D1&!D&!C1&C&!B1&B&A1&!A|E1&E&D2&D1&!D&!C1&C&!B1&B&A1&!A|E1&!E&D2&D1&!D&!C1&C&!B1&B&A1&!A|E1&!E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|E1&E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|!E1&E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|!E1&E&D2&!D1&!D&!C1&C&B1&B&A1&!A|E1&E&D2&!D1&!D&!C1&C&B1&B&A1&!A|E1&!E&D2&!D1&!D&!C1&C&B1&B&A1&!A|E1&!E&D2&D1&!D&!C1&C&B1&B&A1&!A|E1&E&D2&D1&!D&!C1&C&B1&B&A1&!A|!E1&E&D2&D1&!D&!C1&C&B1&B&A1&!A|!E1&E&!D2&D1&!D&!C1&C&B1&B&A1&!A|E1&E&!D2&D1&!D&!C1&C&B1&B&A1&!A|E1&!E&!D2&D1&!D&!C1&C&B1&B&A1&!A|E1&!E&!D2&D1&D&!C1&C&B1&B&A1&!A|E1&E&!D2&D1&D&!C1&C&B1&B&A1&!A|!E1&E&!D2&D1&D&!C1&C&B1&B&A1&!A|!E1&E&D2&D1&D&!C1&C&B1&B&A1&!A|E1&E&D2&D1&D&!C1&C&B1&B&A1&!A|E1&!E&D2&D1&D&!C1&C&B1&B&A1&!A|E1&!E&D2&!D1&D&!C1&C&B1&B&A1&!A|E1&E&D2&!D1&D&!C1&C&B1&B&A1&!A|!E1&E&D2&!D1&D&!C1&C&B1&B&A1&!A|!E1&E&!D2&!D1&D&!C1&C&B1&B&A1&!A|E1&E&!D2&!D1&D&!C1&C&B1&B&A1&!A|E1&!E&!D2&!D1&D&!C1&C&B1&B&A1&!A|E1&!E&!D2&!D1&D&C1&C&B1&B&A1&!A|E1&E&!D2&!D1&D&C1&C&B1&B&A1&!A|!E1&E&!D2&!D1&D&C1&C&B1&B&A1&!A|!E1&E&D2&!D1&D&C1&C&B1&B&A1&!A|E1&E&D2&!D1&D&C1&C&B1&B&A1&!A|E1&!E&D2&!D1&D&C1&C&B1&B&A1&!A|E1&!E&D2&D1&D&C1&C&B1&B&A1&!A|E1&E&D2&D1&D&C1&C&B1&B&A1&!A|!E1&E&D2&D1&D&C1&C&B1&B&A1&!A|!E1&E&!D2&D1&D&C1&C&B1&B&A1&!A|E1&E&!D2&D1&D&C1&C&B1&B&A1&!A|E1&!E&!D2&D1&D&C1&C&B1&B&A1&!A|E1&!E&!D2&D1&!D&C1&C&B1&B&A1&!A|E1&E&!D2&D1&!D&C1&C&B1&B&A1&!A|!E1&E&!D2&D1&!D&C1&C&B1&B&A1&!A|!E1&E&D2&D1&!D&C1&C&B1&B&A1&!A|E1&E&D2&D1&!D&C1&C&B1&B&A1&!A|E1&!E&D2&D1&!D&C1&C&B1&B&A1&!A|E1&!E&D2&!D1&!D&C1&C&B1&B&A1&!A|E1&E&D2&!D1&!D&C1&C&B1&B&A1&!A|!E1&E&D2&!D1&!D&C1&C&B1&B&A1&!A|!E1&E&D2&!D1&!D&C1&!C&B1&B&A1&!A|E1&E&D2&!D1&!D&C1&!C&B1&B&A1&!A|E1&!E&D2&!D1&!D&C1&!C&B1&B&A1&!A|E1&!E&D2&D1&!D&C1&!C&B1&B&A1&!A|E1&E&D2&D1&!D&C1&!C&B1&B&A1&!A|!E1&E&D2&D1&!D&C1&!C&B1&B&A1&!A|!E1&E&!D2&D1&!D&C1&!C&B1&B&A1&!A|E1&E&!D2&D1&!D&C1&!C&B1&B&A1&!A|E1&!E&!D2&D1&!D&C1&!C&B1&B&A1&!A|E1&!E&!D2&D1&D&C1&!C&B1&B&A1&!A|E1&E&!D2&D1&D&C1&!C&B1&B&A1&!A|!E1&E&!D2&D1&D&C1&!C&B1&B&A1&!A|!E1&E&D2&D1&D&C1&!C&B1&B&A1&!A|E1&E&D2&D1&D&C1&!C&B1&B&A1&!A|E1&!E&D2&D1&D&C1&!C&B1&B&A1&!A|E1&!E&D2&!D1&D&C1&!C&B1&B&A1&!A|E1&E&D2&!D1&D&C1&!C&B1&B&A1&!A|!E1&E&D2&!D1&D&C1&!C&B1&B&A1&!A|!E1&E&!D2&!D1&D&C1&!C&B1&B&A1&!A|E1&E&!D2&!D1&D&C1&!C&B1&B&A1&!A|E1&!E&!D2&!D1&D&C1&!C&B1&B&A1&!A|E1&!E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|E1&E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|!E1&E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|!E1&E&D2&!D1&D&!C1&!C&B1&B&A1&!A|E1&E&D2&!D1&D&!C1&!C&B1&B&A1&!A|E1&!E&D2&!D1&D&!C1&!C&B1&B&A1&!A|E1&!E&D2&D1&D&!C1&!C&B1&B&A1&!A|E1&E&D2&D1&D&!C1&!C&B1&B&A1&!A|!E1&E&D2&D1&D&!C1&!C&B1&B&A1&!A|!E1&E&!D2&D1&D&!C1&!C&B1&B&A1&!A|E1&E&!D2&D1&D&!C1&!C&B1&B&A1&!A|E1&!E&!D2&D1&D&!C1&!C&B1&B&A1&!A|E1&!E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|E1&E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|!E1&E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|!E1&E&D2&D1&!D&!C1&!C&B1&B&A1&!A|E1&E&D2&D1&!D&!C1&!C&B1&B&A1&!A|E1&!E&D2&D1&!D&!C1&!C&B1&B&A1&!A|E1&!E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|E1&E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E1&E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E1&E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|E1&E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|E1&E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|E1&E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|E1&E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|!E1&E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|!E1&E&D2&D1&D&!C1&!C&B1&!B&A1&!A|E1&E&D2&D1&D&!C1&!C&B1&!B&A1&!A|E1&!E&D2&D1&D&!C1&!C&B1&!B&A1&!A|E1&!E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|E1&E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E1&E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E1&E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|E1&E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|E1&!E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|E1&!E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|E1&E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|!E1&E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|!E1&E&D2&!D1&D&C1&!C&B1&!B&A1&!A|E1&E&D2&!D1&D&C1&!C&B1&!B&A1&!A|E1&!E&D2&!D1&D&C1&!C&B1&!B&A1&!A|E1&!E&D2&D1&D&C1&!C&B1&!B&A1&!A|E1&E&D2&D1&D&C1&!C&B1&!B&A1&!A|!E1&E&D2&D1&D&C1&!C&B1&!B&A1&!A|!E1&E&!D2&D1&D&C1&!C&B1&!B&A1&!A|E1&E&!D2&D1&D&C1&!C&B1&!B&A1&!A|E1&!E&!D2&D1&D&C1&!C&B1&!B&A1&!A|E1&!E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|E1&E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|!E1&E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|!E1&E&D2&D1&!D&C1&!C&B1&!B&A1&!A|E1&E&D2&D1&!D&C1&!C&B1&!B&A1&!A|E1&!E&D2&D1&!D&C1&!C&B1&!B&A1&!A|E1&!E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|E1&E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|!E1&E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|!E1&E&D2&!D1&!D&C1&C&B1&!B&A1&!A|E1&E&D2&!D1&!D&C1&C&B1&!B&A1&!A|E1&!E&D2&!D1&!D&C1&C&B1&!B&A1&!A|E1&!E&D2&D1&!D&C1&C&B1&!B&A1&!A|E1&E&D2&D1&!D&C1&C&B1&!B&A1&!A|!E1&E&D2&D1&!D&C1&C&B1&!B&A1&!A|!E1&E&!D2&D1&!D&C1&C&B1&!B&A1&!A|E1&E&!D2&D1&!D&C1&C&B1&!B&A1&!A|E1&!E&!D2&D1&!D&C1&C&B1&!B&A1&!A|E1&!E&!D2&D1&D&C1&C&B1&!B&A1&!A|E1&E&!D2&D1&D&C1&C&B1&!B&A1&!A|!E1&E&!D2&D1&D&C1&C&B1&!B&A1&!A|!E1&E&D2&D1&D&C1&C&B1&!B&A1&!A|E1&E&D2&D1&D&C1&C&B1&!B&A1&!A|E1&!E&D2&D1&D&C1&C&B1&!B&A1&!A|E1&!E&D2&!D1&D&C1&C&B1&!B&A1&!A|E1&E&D2&!D1&D&C1&C&B1&!B&A1&!A|!E1&E&D2&!D1&D&C1&C&B1&!B&A1&!A|!E1&E&!D2&!D1&D&C1&C&B1&!B&A1&!A|E1&E&!D2&!D1&D&C1&C&B1&!B&A1&!A|E1&!E&!D2&!D1&D&C1&C&B1&!B&A1&!A|E1&!E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|E1&E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|!E1&E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|!E1&E&D2&!D1&D&!C1&C&B1&!B&A1&!A|E1&E&D2&!D1&D&!C1&C&B1&!B&A1&!A|E1&!E&D2&!D1&D&!C1&C&B1&!B&A1&!A|E1&!E&D2&D1&D&!C1&C&B1&!B&A1&!A|E1&E&D2&D1&D&!C1&C&B1&!B&A1&!A|!E1&E&D2&D1&D&!C1&C&B1&!B&A1&!A|!E1&E&!D2&D1&D&!C1&C&B1&!B&A1&!A|E1&E&!D2&D1&D&!C1&C&B1&!B&A1&!A|E1&!E&!D2&D1&D&!C1&C&B1&!B&A1&!A|E1&!E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|E1&E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|!E1&E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|!E1&E&D2&D1&!D&!C1&C&B1&!B&A1&!A|E1&E&D2&D1&!D&!C1&C&B1&!B&A1&!A|E1&!E&D2&D1&!D&!C1&C&B1&!B&A1&!A|E1&!E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|E1&E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|!E1&E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|E1&!E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|E1&E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|!E1&E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|!E1&E&D2&!D1&D&C1&C&!B1&!B&A1&!A|E1&E&D2&!D1&D&C1&C&!B1&!B&A1&!A|E1&!E&D2&!D1&D&C1&C&!B1&!B&A1&!A|E1&!E&D2&D1&D&C1&C&!B1&!B&A1&!A|E1&E&D2&D1&D&C1&C&!B1&!B&A1&!A|!E1&E&D2&D1&D&C1&C&!B1&!B&A1&!A|!E1&E&!D2&D1&D&C1&C&!B1&!B&A1&!A|E1&E&!D2&D1&D&C1&C&!B1&!B&A1&!A|E1&!E&!D2&D1&D&C1&C&!B1&!B&A1&!A|E1&!E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|E1&E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|!E1&E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|!E1&E&D2&D1&!D&C1&C&!B1&!B&A1&!A|E1&E&D2&D1&!D&C1&C&!B1&!B&A1&!A|E1&!E&D2&D1&!D&C1&C&!B1&!B&A1&!A|E1&!E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|E1&E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E1&E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E1&E&D2&!D1&!D&C1&C&!B1&!B&A1&A|E1&E&D2&!D1&!D&C1&C&!B1&!B&A1&A|E1&!E&D2&!D1&!D&C1&C&!B1&!B&A1&A|E1&!E&D2&D1&!D&C1&C&!B1&!B&A1&A|E1&E&D2&D1&!D&C1&C&!B1&!B&A1&A|!E1&E&D2&D1&!D&C1&C&!B1&!B&A1&A|!E1&E&!D2&D1&!D&C1&C&!B1&!B&A1&A|E1&E&!D2&D1&!D&C1&C&!B1&!B&A1&A|E1&!E&!D2&D1&!D&C1&C&!B1&!B&A1&A|E1&!E&!D2&D1&D&C1&C&!B1&!B&A1&A|E1&E&!D2&D1&D&C1&C&!B1&!B&A1&A|!E1&E&!D2&D1&D&C1&C&!B1&!B&A1&A|!E1&E&D2&D1&D&C1&C&!B1&!B&A1&A|E1&E&D2&D1&D&C1&C&!B1&!B&A1&A|E1&!E&D2&D1&D&C1&C&!B1&!B&A1&A|E1&!E&D2&!D1&D&C1&C&!B1&!B&A1&A|E1&E&D2&!D1&D&C1&C&!B1&!B&A1&A|!E1&E&D2&!D1&D&C1&C&!B1&!B&A1&A|!E1&E&!D2&!D1&D&C1&C&!B1&!B&A1&A|E1&E&!D2&!D1&D&C1&C&!B1&!B&A1&A|E1&!E&!D2&!D1&D&C1&C&!B1&!B&A1&A|!E1&E&D2&!D1&!D&!C1&C&B1&!B&A1&A|E1&E&D2&!D1&!D&!C1&C&B1&!B&A1&A|E1&!E&D2&!D1&!D&!C1&C&B1&!B&A1&A|E1&!E&D2&D1&!D&!C1&C&B1&!B&A1&A|E1&E&D2&D1&!D&!C1&C&B1&!B&A1&A|!E1&E&D2&D1&!D&!C1&C&B1&!B&A1&A|!E1&E&!D2&D1&!D&!C1&C&B1&!B&A1&A|E1&E&!D2&D1&!D&!C1&C&B1&!B&A1&A|E1&!E&!D2&D1&!D&!C1&C&B1&!B&A1&A|E1&!E&!D2&D1&D&!C1&C&B1&!B&A1&A|E1&E&!D2&D1&D&!C1&C&B1&!B&A1&A|!E1&E&!D2&D1&D&!C1&C&B1&!B&A1&A|!E1&E&D2&D1&D&!C1&C&B1&!B&A1&A|E1&E&D2&D1&D&!C1&C&B1&!B&A1&A|E1&!E&D2&D1&D&!C1&C&B1&!B&A1&A|E1&!E&D2&!D1&D&!C1&C&B1&!B&A1&A|E1&E&D2&!D1&D&!C1&C&B1&!B&A1&A|!E1&E&D2&!D1&D&!C1&C&B1&!B&A1&A|!E1&E&!D2&!D1&D&!C1&C&B1&!B&A1&A|E1&E&!D2&!D1&D&!C1&C&B1&!B&A1&A|E1&!E&!D2&!D1&D&!C1&C&B1&!B&A1&A|E1&!E&!D2&!D1&D&C1&C&B1&!B&A1&A|E1&E&!D2&!D1&D&C1&C&B1&!B&A1&A|!E1&E&!D2&!D1&D&C1&C&B1&!B&A1&A|!E1&E&D2&!D1&D&C1&C&B1&!B&A1&A|E1&E&D2&!D1&D&C1&C&B1&!B&A1&A|E1&!E&D2&!D1&D&C1&C&B1&!B&A1&A|E1&!E&D2&D1&D&C1&C&B1&!B&A1&A|E1&E&D2&D1&D&C1&C&B1&!B&A1&A|!E1&E&D2&D1&D&C1&C&B1&!B&A1&A|!E1&E&!D2&D1&D&C1&C&B1&!B&A1&A|E1&E&!D2&D1&D&C1&C&B1&!B&A1&A|E1&!E&!D2&D1&D&C1&C&B1&!B&A1&A|E1&!E&!D2&D1&!D&C1&C&B1&!B&A1&A|E1&E&!D2&D1&!D&C1&C&B1&!B&A1&A|!E1&E&!D2&D1&!D&C1&C&B1&!B&A1&A|!E1&E&D2&D1&!D&C1&C&B1&!B&A1&A|E1&E&D2&D1&!D&C1&C&B1&!B&A1&A|E1&!E&D2&D1&!D&C1&C&B1&!B&A1&A|E1&!E&D2&!D1&!D&C1&C&B1&!B&A1&A|E1&E&D2&!D1&!D&C1&C&B1&!B&A1&A|!E1&E&D2&!D1&!D&C1&C&B1&!B&A1&A|!E1&E&D2&!D1&!D&C1&!C&B1&!B&A1&A|E1&E&D2&!D1&!D&C1&!C&B1&!B&A1&A|E1&!E&D2&!D1&!D&C1&!C&B1&!B&A1&A|E1&!E&D2&D1&!D&C1&!C&B1&!B&A1&A|E1&E&D2&D1&!D&C1&!C&B1&!B&A1&A|!E1&E&D2&D1&!D&C1&!C&B1&!B&A1&A|!E1&E&!D2&D1&!D&C1&!C&B1&!B&A1&A|E1&E&!D2&D1&!D&C1&!C&B1&!B&A1&A|E1&!E&!D2&D1&!D&C1&!C&B1&!B&A1&A|E1&!E&!D2&D1&D&C1&!C&B1&!B&A1&A|E1&E&!D2&D1&D&C1&!C&B1&!B&A1&A|!E1&E&!D2&D1&D&C1&!C&B1&!B&A1&A|!E1&E&D2&D1&D&C1&!C&B1&!B&A1&A|E1&E&D2&D1&D&C1&!C&B1&!B&A1&A|E1&!E&D2&D1&D&C1&!C&B1&!B&A1&A|E1&!E&D2&!D1&D&C1&!C&B1&!B&A1&A|E1&E&D2&!D1&D&C1&!C&B1&!B&A1&A|!E1&E&D2&!D1&D&C1&!C&B1&!B&A1&A|!E1&E&!D2&!D1&D&C1&!C&B1&!B&A1&A|E1&E&!D2&!D1&D&C1&!C&B1&!B&A1&A|E1&!E&!D2&!D1&D&C1&!C&B1&!B&A1&A|E1&!E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|E1&E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|!E1&E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|!E1&E&D2&!D1&D&!C1&!C&B1&!B&A1&A|E1&E&D2&!D1&D&!C1&!C&B1&!B&A1&A|E1&!E&D2&!D1&D&!C1&!C&B1&!B&A1&A|E1&!E&D2&D1&D&!C1&!C&B1&!B&A1&A|E1&E&D2&D1&D&!C1&!C&B1&!B&A1&A|!E1&E&D2&D1&D&!C1&!C&B1&!B&A1&A|!E1&E&!D2&D1&D&!C1&!C&B1&!B&A1&A|E1&E&!D2&D1&D&!C1&!C&B1&!B&A1&A|E1&!E&!D2&D1&D&!C1&!C&B1&!B&A1&A|E1&!E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|E1&E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|!E1&E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|!E1&E&D2&D1&!D&!C1&!C&B1&!B&A1&A|E1&E&D2&D1&!D&!C1&!C&B1&!B&A1&A|E1&!E&D2&D1&!D&!C1&!C&B1&!B&A1&A|E1&!E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|E1&E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E1&E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E1&E&D2&!D1&!D&!C1&!C&B1&B&A1&A|E1&E&D2&!D1&!D&!C1&!C&B1&B&A1&A|E1&!E&D2&!D1&!D&!C1&!C&B1&B&A1&A|E1&!E&D2&D1&!D&!C1&!C&B1&B&A1&A|E1&E&D2&D1&!D&!C1&!C&B1&B&A1&A|!E1&E&D2&D1&!D&!C1&!C&B1&B&A1&A|!E1&E&!D2&D1&!D&!C1&!C&B1&B&A1&A|E1&E&!D2&D1&!D&!C1&!C&B1&B&A1&A|E1&!E&!D2&D1&!D&!C1&!C&B1&B&A1&A|E1&!E&!D2&D1&D&!C1&!C&B1&B&A1&A|E1&E&!D2&D1&D&!C1&!C&B1&B&A1&A|!E1&E&!D2&D1&D&!C1&!C&B1&B&A1&A|!E1&E&D2&D1&D&!C1&!C&B1&B&A1&A|E1&E&D2&D1&D&!C1&!C&B1&B&A1&A|E1&!E&D2&D1&D&!C1&!C&B1&B&A1&A|E1&!E&D2&!D1&D&!C1&!C&B1&B&A1&A|E1&E&D2&!D1&D&!C1&!C&B1&B&A1&A|!E1&E&D2&!D1&D&!C1&!C&B1&B&A1&A|!E1&E&!D2&!D1&D&!C1&!C&B1&B&A1&A|E1&E&!D2&!D1&D&!C1&!C&B1&B&A1&A|E1&!E&!D2&!D1&D&!C1&!C&B1&B&A1&A|E1&!E&!D2&!D1&D&C1&!C&B1&B&A1&A|E1&E&!D2&!D1&D&C1&!C&B1&B&A1&A|!E1&E&!D2&!D1&D&C1&!C&B1&B&A1&A|!E1&E&D2&!D1&D&C1&!C&B1&B&A1&A|E1&E&D2&!D1&D&C1&!C&B1&B&A1&A|E1&!E&D2&!D1&D&C1&!C&B1&B&A1&A|E1&!E&D2&D1&D&C1&!C&B1&B&A1&A|E1&E&D2&D1&D&C1&!C&B1&B&A1&A|!E1&E&D2&D1&D&C1&!C&B1&B&A1&A|!E1&E&!D2&D1&D&C1&!C&B1&B&A1&A|E1&E&!D2&D1&D&C1&!C&B1&B&A1&A|E1&!E&!D2&D1&D&C1&!C&B1&B&A1&A|E1&!E&!D2&D1&!D&C1&!C&B1&B&A1&A|E1&E&!D2&D1&!D&C1&!C&B1&B&A1&A|!E1&E&!D2&D1&!D&C1&!C&B1&B&A1&A|!E1&E&D2&D1&!D&C1&!C&B1&B&A1&A|E1&E&D2&D1&!D&C1&!C&B1&B&A1&A|E1&!E&D2&D1&!D&C1&!C&B1&B&A1&A|E1&!E&D2&!D1&!D&C1&!C&B1&B&A1&A|E1&E&D2&!D1&!D&C1&!C&B1&B&A1&A|!E1&E&D2&!D1&!D&C1&!C&B1&B&A1&A|!E1&E&D2&!D1&!D&C1&C&B1&B&A1&A|E1&E&D2&!D1&!D&C1&C&B1&B&A1&A|E1&!E&D2&!D1&!D&C1&C&B1&B&A1&A|E1&!E&D2&D1&!D&C1&C&B1&B&A1&A|E1&E&D2&D1&!D&C1&C&B1&B&A1&A|!E1&E&D2&D1&!D&C1&C&B1&B&A1&A|!E1&E&!D2&D1&!D&C1&C&B1&B&A1&A|E1&E&!D2&D1&!D&C1&C&B1&B&A1&A|E1&!E&!D2&D1&!D&C1&C&B1&B&A1&A|E1&!E&!D2&D1&D&C1&C&B1&B&A1&A|E1&E&!D2&D1&D&C1&C&B1&B&A1&A|!E1&E&!D2&D1&D&C1&C&B1&B&A1&A|!E1&E&D2&D1&D&C1&C&B1&B&A1&A|E1&E&D2&D1&D&C1&C&B1&B&A1&A|E1&!E&D2&D1&D&C1&C&B1&B&A1&A|E1&!E&D2&!D1&D&C1&C&B1&B&A1&A|E1&E&D2&!D1&D&C1&C&B1&B&A1&A|!E1&E&D2&!D1&D&C1&C&B1&B&A1&A|!E1&E&!D2&!D1&D&C1&C&B1&B&A1&A|E1&E&!D2&!D1&D&C1&C&B1&B&A1&A|E1&!E&!D2&!D1&D&C1&C&B1&B&A1&A|E1&!E&!D2&!D1&D&!C1&C&B1&B&A1&A|E1&E&!D2&!D1&D&!C1&C&B1&B&A1&A|!E1&E&!D2&!D1&D&!C1&C&B1&B&A1&A|!E1&E&D2&!D1&D&!C1&C&B1&B&A1&A|E1&E&D2&!D1&D&!C1&C&B1&B&A1&A|E1&!E&D2&!D1&D&!C1&C&B1&B&A1&A|E1&!E&D2&D1&D&!C1&C&B1&B&A1&A|E1&E&D2&D1&D&!C1&C&B1&B&A1&A|!E1&E&D2&D1&D&!C1&C&B1&B&A1&A|!E1&E&!D2&D1&D&!C1&C&B1&B&A1&A|E1&E&!D2&D1&D&!C1&C&B1&B&A1&A|E1&!E&!D2&D1&D&!C1&C&B1&B&A1&A|E1&!E&!D2&D1&!D&!C1&C&B1&B&A1&A|E1&E&!D2&D1&!D&!C1&C&B1&B&A1&A|!E1&E&!D2&D1&!D&!C1&C&B1&B&A1&A|!E1&E&D2&D1&!D&!C1&C&B1&B&A1&A|E1&E&D2&D1&!D&!C1&C&B1&B&A1&A|E1&!E&D2&D1&!D&!C1&C&B1&B&A1&A|E1&!E&D2&!D1&!D&!C1&C&B1&B&A1&A|E1&E&D2&!D1&!D&!C1&C&B1&B&A1&A|!E1&E&D2&!D1&!D&!C1&C&B1&B&A1&A|!E1&E&D2&!D1&!D&!C1&C&!B1&B&A1&A|E1&E&D2&!D1&!D&!C1&C&!B1&B&A1&A|E1&!E&D2&!D1&!D&!C1&C&!B1&B&A1&A|E1&!E&D2&D1&!D&!C1&C&!B1&B&A1&A|E1&E&D2&D1&!D&!C1&C&!B1&B&A1&A|!E1&E&D2&D1&!D&!C1&C&!B1&B&A1&A|!E1&E&!D2&D1&!D&!C1&C&!B1&B&A1&A|E1&E&!D2&D1&!D&!C1&C&!B1&B&A1&A|E1&!E&!D2&D1&!D&!C1&C&!B1&B&A1&A|E1&!E&!D2&D1&D&!C1&C&!B1&B&A1&A|E1&E&!D2&D1&D&!C1&C&!B1&B&A1&A|!E1&E&!D2&D1&D&!C1&C&!B1&B&A1&A|!E1&E&D2&D1&D&!C1&C&!B1&B&A1&A|E1&E&D2&D1&D&!C1&C&!B1&B&A1&A|E1&!E&D2&D1&D&!C1&C&!B1&B&A1&A|E1&!E&D2&!D1&D&!C1&C&!B1&B&A1&A|E1&E&D2&!D1&D&!C1&C&!B1&B&A1&A|!E1&E&D2&!D1&D&!C1&C&!B1&B&A1&A|!E1&E&!D2&!D1&D&!C1&C&!B1&B&A1&A|E1&E&!D2&!D1&D&!C1&C&!B1&B&A1&A|E1&!E&!D2&!D1&D&!C1&C&!B1&B&A1&A|E1&!E&!D2&!D1&D&C1&C&!B1&B&A1&A|E1&E&!D2&!D1&D&C1&C&!B1&B&A1&A|!E1&E&!D2&!D1&D&C1&C&!B1&B&A1&A|!E1&E&D2&!D1&D&C1&C&!B1&B&A1&A|E1&E&D2&!D1&D&C1&C&!B1&B&A1&A|E1&!E&D2&!D1&D&C1&C&!B1&B&A1&A|E1&!E&D2&D1&D&C1&C&!B1&B&A1&A|E1&E&D2&D1&D&C1&C&!B1&B&A1&A|!E1&E&D2&D1&D&C1&C&!B1&B&A1&A|!E1&E&!D2&D1&D&C1&C&!B1&B&A1&A|E1&E&!D2&D1&D&C1&C&!B1&B&A1&A|E1&!E&!D2&D1&D&C1&C&!B1&B&A1&A|E1&!E&!D2&D1&!D&C1&C&!B1&B&A1&A|E1&E&!D2&D1&!D&C1&C&!B1&B&A1&A|!E1&E&!D2&D1&!D&C1&C&!B1&B&A1&A|!E1&E&D2&D1&!D&C1&C&!B1&B&A1&A|E1&E&D2&D1&!D&C1&C&!B1&B&A1&A|E1&!E&D2&D1&!D&C1&C&!B1&B&A1&A|E1&!E&D2&!D1&!D&C1&C&!B1&B&A1&A|E1&E&D2&!D1&!D&C1&C&!B1&B&A1&A|!E1&E&D2&!D1&!D&C1&C&!B1&B&A1&A|!E1&E&D2&!D1&!D&C1&!C&!B1&B&A1&A|E1&E&D2&!D1&!D&C1&!C&!B1&B&A1&A|E1&!E&D2&!D1&!D&C1&!C&!B1&B&A1&A|E1&!E&D2&D1&!D&C1&!C&!B1&B&A1&A|E1&E&D2&D1&!D&C1&!C&!B1&B&A1&A|!E1&E&D2&D1&!D&C1&!C&!B1&B&A1&A|!E1&E&!D2&D1&!D&C1&!C&!B1&B&A1&A|E1&E&!D2&D1&!D&C1&!C&!B1&B&A1&A|E1&!E&!D2&D1&!D&C1&!C&!B1&B&A1&A|E1&!E&!D2&D1&D&C1&!C&!B1&B&A1&A|E1&E&!D2&D1&D&C1&!C&!B1&B&A1&A|!E1&E&!D2&D1&D&C1&!C&!B1&B&A1&A|!E1&E&D2&D1&D&C1&!C&!B1&B&A1&A|E1&E&D2&D1&D&C1&!C&!B1&B&A1&A|E1&!E&D2&D1&D&C1&!C&!B1&B&A1&A|E1&!E&D2&!D1&D&C1&!C&!B1&B&A1&A|E1&E&D2&!D1&D&C1&!C&!B1&B&A1&A|!E1&E&D2&!D1&D&C1&!C&!B1&B&A1&A|!E1&E&!D2&!D1&D&C1&!C&!B1&B&A1&A|E1&E&!D2&!D1&D&C1&!C&!B1&B&A1&A|E1&!E&!D2&!D1&D&C1&!C&!B1&B&A1&A|E1&!E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|E1&E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|!E1&E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|!E1&E&D2&!D1&D&!C1&!C&!B1&B&A1&A|E1&E&D2&!D1&D&!C1&!C&!B1&B&A1&A|E1&!E&D2&!D1&D&!C1&!C&!B1&B&A1&A|E1&!E&D2&D1&D&!C1&!C&!B1&B&A1&A|E1&E&D2&D1&D&!C1&!C&!B1&B&A1&A|!E1&E&D2&D1&D&!C1&!C&!B1&B&A1&A|!E1&E&!D2&D1&D&!C1&!C&!B1&B&A1&A|E1&E&!D2&D1&D&!C1&!C&!B1&B&A1&A|E1&!E&!D2&D1&D&!C1&!C&!B1&B&A1&A|E1&!E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|E1&E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|!E1&E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|!E1&E&D2&D1&!D&!C1&!C&!B1&B&A1&A|E1&E&D2&D1&!D&!C1&!C&!B1&B&A1&A|E1&!E&D2&D1&!D&!C1&!C&!B1&B&A1&A|E1&!E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|E1&E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E1&E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E1&E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|E1&E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|E1&E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|E1&E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|E1&E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|!E1&E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|!E1&E&D2&D1&D&!C1&!C&!B1&B&!A1&A|E1&E&D2&D1&D&!C1&!C&!B1&B&!A1&A|E1&!E&D2&D1&D&!C1&!C&!B1&B&!A1&A|E1&!E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|E1&E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E1&E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E1&E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|E1&E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|E1&!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|E1&!E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|E1&E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|!E1&E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|!E1&E&D2&!D1&D&C1&!C&!B1&B&!A1&A|E1&E&D2&!D1&D&C1&!C&!B1&B&!A1&A|E1&!E&D2&!D1&D&C1&!C&!B1&B&!A1&A|E1&!E&D2&D1&D&C1&!C&!B1&B&!A1&A|E1&E&D2&D1&D&C1&!C&!B1&B&!A1&A|!E1&E&D2&D1&D&C1&!C&!B1&B&!A1&A|!E1&E&!D2&D1&D&C1&!C&!B1&B&!A1&A|E1&E&!D2&D1&D&C1&!C&!B1&B&!A1&A|E1&!E&!D2&D1&D&C1&!C&!B1&B&!A1&A|E1&!E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|E1&E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|!E1&E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|!E1&E&D2&D1&!D&C1&!C&!B1&B&!A1&A|E1&E&D2&D1&!D&C1&!C&!B1&B&!A1&A|E1&!E&D2&D1&!D&C1&!C&!B1&B&!A1&A|E1&!E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|E1&E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|!E1&E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|!E1&E&D2&!D1&!D&C1&C&!B1&B&!A1&A|E1&E&D2&!D1&!D&C1&C&!B1&B&!A1&A|E1&!E&D2&!D1&!D&C1&C&!B1&B&!A1&A|E1&!E&D2&D1&!D&C1&C&!B1&B&!A1&A|E1&E&D2&D1&!D&C1&C&!B1&B&!A1&A|!E1&E&D2&D1&!D&C1&C&!B1&B&!A1&A|!E1&E&!D2&D1&!D&C1&C&!B1&B&!A1&A|E1&E&!D2&D1&!D&C1&C&!B1&B&!A1&A|E1&!E&!D2&D1&!D&C1&C&!B1&B&!A1&A|E1&!E&!D2&D1&D&C1&C&!B1&B&!A1&A|E1&E&!D2&D1&D&C1&C&!B1&B&!A1&A|!E1&E&!D2&D1&D&C1&C&!B1&B&!A1&A|!E1&E&D2&D1&D&C1&C&!B1&B&!A1&A|E1&E&D2&D1&D&C1&C&!B1&B&!A1&A|E1&!E&D2&D1&D&C1&C&!B1&B&!A1&A|E1&!E&D2&!D1&D&C1&C&!B1&B&!A1&A|E1&E&D2&!D1&D&C1&C&!B1&B&!A1&A|!E1&E&D2&!D1&D&C1&C&!B1&B&!A1&A|!E1&E&!D2&!D1&D&C1&C&!B1&B&!A1&A|E1&E&!D2&!D1&D&C1&C&!B1&B&!A1&A|E1&!E&!D2&!D1&D&C1&C&!B1&B&!A1&A|E1&!E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|E1&E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|!E1&E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|!E1&E&D2&!D1&D&!C1&C&!B1&B&!A1&A|E1&E&D2&!D1&D&!C1&C&!B1&B&!A1&A|E1&!E&D2&!D1&D&!C1&C&!B1&B&!A1&A|E1&!E&D2&D1&D&!C1&C&!B1&B&!A1&A|E1&E&D2&D1&D&!C1&C&!B1&B&!A1&A|!E1&E&D2&D1&D&!C1&C&!B1&B&!A1&A|!E1&E&!D2&D1&D&!C1&C&!B1&B&!A1&A|E1&E&!D2&D1&D&!C1&C&!B1&B&!A1&A|E1&!E&!D2&D1&D&!C1&C&!B1&B&!A1&A|E1&!E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|E1&E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|!E1&E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|!E1&E&D2&D1&!D&!C1&C&!B1&B&!A1&A|E1&E&D2&D1&!D&!C1&C&!B1&B&!A1&A|E1&!E&D2&D1&!D&!C1&C&!B1&B&!A1&A|E1&!E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|E1&E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|!E1&E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|!E1&E&D2&!D1&!D&!C1&C&B1&B&!A1&A|E1&E&D2&!D1&!D&!C1&C&B1&B&!A1&A|E1&!E&D2&!D1&!D&!C1&C&B1&B&!A1&A|E1&!E&D2&D1&!D&!C1&C&B1&B&!A1&A|E1&E&D2&D1&!D&!C1&C&B1&B&!A1&A|!E1&E&D2&D1&!D&!C1&C&B1&B&!A1&A|!E1&E&!D2&D1&!D&!C1&C&B1&B&!A1&A|E1&E&!D2&D1&!D&!C1&C&B1&B&!A1&A|E1&!E&!D2&D1&!D&!C1&C&B1&B&!A1&A|E1&!E&!D2&D1&D&!C1&C&B1&B&!A1&A|E1&E&!D2&D1&D&!C1&C&B1&B&!A1&A|!E1&E&!D2&D1&D&!C1&C&B1&B&!A1&A|!E1&E&D2&D1&D&!C1&C&B1&B&!A1&A|E1&E&D2&D1&D&!C1&C&B1&B&!A1&A|E1&!E&D2&D1&D&!C1&C&B1&B&!A1&A|E1&!E&D2&!D1&D&!C1&C&B1&B&!A1&A|E1&E&D2&!D1&D&!C1&C&B1&B&!A1&A|!E1&E&D2&!D1&D&!C1&C&B1&B&!A1&A|!E1&E&!D2&!D1&D&!C1&C&B1&B&!A1&A|E1&E&!D2&!D1&D&!C1&C&B1&B&!A1&A|E1&!E&!D2&!D1&D&!C1&C&B1&B&!A1&A|E1&!E&!D2&!D1&D&C1&C&B1&B&!A1&A|E1&E&!D2&!D1&D&C1&C&B1&B&!A1&A|!E1&E&!D2&!D1&D&C1&C&B1&B&!A1&A|!E1&E&D2&!D1&D&C1&C&B1&B&!A1&A|E1&E&D2&!D1&D&C1&C&B1&B&!A1&A|E1&!E&D2&!D1&D&C1&C&B1&B&!A1&A|E1&!E&D2&D1&D&C1&C&B1&B&!A1&A|E1&E&D2&D1&D&C1&C&B1&B&!A1&A|!E1&E&D2&D1&D&C1&C&B1&B&!A1&A|!E1&E&!D2&D1&D&C1&C&B1&B&!A1&A|E1&E&!D2&D1&D&C1&C&B1&B&!A1&A|E1&!E&!D2&D1&D&C1&C&B1&B&!A1&A|E1&!E&!D2&D1&!D&C1&C&B1&B&!A1&A|E1&E&!D2&D1&!D&C1&C&B1&B&!A1&A|!E1&E&!D2&D1&!D&C1&C&B1&B&!A1&A|!E1&E&D2&D1&!D&C1&C&B1&B&!A1&A|E1&E&D2&D1&!D&C1&C&B1&B&!A1&A|E1&!E&D2&D1&!D&C1&C&B1&B&!A1&A|E1&!E&D2&!D1&!D&C1&C&B1&B&!A1&A|E1&E&D2&!D1&!D&C1&C&B1&B&!A1&A|!E1&E&D2&!D1&!D&C1&C&B1&B&!A1&A|!E1&E&D2&!D1&!D&C1&!C&B1&B&!A1&A|E1&E&D2&!D1&!D&C1&!C&B1&B&!A1&A|E1&!E&D2&!D1&!D&C1&!C&B1&B&!A1&A|E1&!E&D2&D1&!D&C1&!C&B1&B&!A1&A|E1&E&D2&D1&!D&C1&!C&B1&B&!A1&A|!E1&E&D2&D1&!D&C1&!C&B1&B&!A1&A|!E1&E&!D2&D1&!D&C1&!C&B1&B&!A1&A|E1&E&!D2&D1&!D&C1&!C&B1&B&!A1&A|E1&!E&!D2&D1&!D&C1&!C&B1&B&!A1&A|E1&!E&!D2&D1&D&C1&!C&B1&B&!A1&A|E1&E&!D2&D1&D&C1&!C&B1&B&!A1&A|!E1&E&!D2&D1&D&C1&!C&B1&B&!A1&A|!E1&E&D2&D1&D&C1&!C&B1&B&!A1&A|E1&E&D2&D1&D&C1&!C&B1&B&!A1&A|E1&!E&D2&D1&D&C1&!C&B1&B&!A1&A|E1&!E&D2&!D1&D&C1&!C&B1&B&!A1&A|E1&E&D2&!D1&D&C1&!C&B1&B&!A1&A|!E1&E&D2&!D1&D&C1&!C&B1&B&!A1&A|!E1&E&!D2&!D1&D&C1&!C&B1&B&!A1&A|E1&E&!D2&!D1&D&C1&!C&B1&B&!A1&A|E1&!E&!D2&!D1&D&C1&!C&B1&B&!A1&A|E1&!E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|E1&E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|!E1&E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|!E1&E&D2&!D1&D&!C1&!C&B1&B&!A1&A|E1&E&D2&!D1&D&!C1&!C&B1&B&!A1&A|E1&!E&D2&!D1&D&!C1&!C&B1&B&!A1&A|E1&!E&D2&D1&D&!C1&!C&B1&B&!A1&A|E1&E&D2&D1&D&!C1&!C&B1&B&!A1&A|!E1&E&D2&D1&D&!C1&!C&B1&B&!A1&A|!E1&E&!D2&D1&D&!C1&!C&B1&B&!A1&A|E1&E&!D2&D1&D&!C1&!C&B1&B&!A1&A|E1&!E&!D2&D1&D&!C1&!C&B1&B&!A1&A|E1&!E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|E1&E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|!E1&E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|!E1&E&D2&D1&!D&!C1&!C&B1&B&!A1&A|E1&E&D2&D1&!D&!C1&!C&B1&B&!A1&A|E1&!E&D2&D1&!D&!C1&!C&B1&B&!A1&A|E1&!E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|E1&E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E1&E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E1&E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|E1&E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|E1&E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|E1&E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|E1&E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|!E1&E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|!E1&E&D2&D1&D&!C1&!C&B1&!B&!A1&A|E1&E&D2&D1&D&!C1&!C&B1&!B&!A1&A|E1&!E&D2&D1&D&!C1&!C&B1&!B&!A1&A|E1&!E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|E1&E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E1&E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E1&E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|E1&E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|E1&!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|E1&!E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|E1&E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|!E1&E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|!E1&E&D2&!D1&D&C1&!C&B1&!B&!A1&A|E1&E&D2&!D1&D&C1&!C&B1&!B&!A1&A|E1&!E&D2&!D1&D&C1&!C&B1&!B&!A1&A|E1&!E&D2&D1&D&C1&!C&B1&!B&!A1&A|E1&E&D2&D1&D&C1&!C&B1&!B&!A1&A|!E1&E&D2&D1&D&C1&!C&B1&!B&!A1&A|!E1&E&!D2&D1&D&C1&!C&B1&!B&!A1&A|E1&E&!D2&D1&D&C1&!C&B1&!B&!A1&A|E1&!E&!D2&D1&D&C1&!C&B1&!B&!A1&A|E1&!E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|E1&E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|!E1&E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|!E1&E&D2&D1&!D&C1&!C&B1&!B&!A1&A|E1&E&D2&D1&!D&C1&!C&B1&!B&!A1&A|E1&!E&D2&D1&!D&C1&!C&B1&!B&!A1&A|E1&!E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|E1&E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|!E1&E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|!E1&E&D2&!D1&!D&C1&C&B1&!B&!A1&A|E1&E&D2&!D1&!D&C1&C&B1&!B&!A1&A|E1&!E&D2&!D1&!D&C1&C&B1&!B&!A1&A|E1&!E&D2&D1&!D&C1&C&B1&!B&!A1&A|E1&E&D2&D1&!D&C1&C&B1&!B&!A1&A|!E1&E&D2&D1&!D&C1&C&B1&!B&!A1&A|!E1&E&!D2&D1&!D&C1&C&B1&!B&!A1&A|E1&E&!D2&D1&!D&C1&C&B1&!B&!A1&A|E1&!E&!D2&D1&!D&C1&C&B1&!B&!A1&A|E1&!E&!D2&D1&D&C1&C&B1&!B&!A1&A|E1&E&!D2&D1&D&C1&C&B1&!B&!A1&A|!E1&E&!D2&D1&D&C1&C&B1&!B&!A1&A|!E1&E&D2&D1&D&C1&C&B1&!B&!A1&A|E1&E&D2&D1&D&C1&C&B1&!B&!A1&A|E1&!E&D2&D1&D&C1&C&B1&!B&!A1&A|E1&!E&D2&!D1&D&C1&C&B1&!B&!A1&A|E1&E&D2&!D1&D&C1&C&B1&!B&!A1&A|!E1&E&D2&!D1&D&C1&C&B1&!B&!A1&A|!E1&E&!D2&!D1&D&C1&C&B1&!B&!A1&A|E1&E&!D2&!D1&D&C1&C&B1&!B&!A1&A|E1&!E&!D2&!D1&D&C1&C&B1&!B&!A1&A|E1&!E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|E1&E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|!E1&E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|!E1&E&D2&!D1&D&!C1&C&B1&!B&!A1&A|E1&E&D2&!D1&D&!C1&C&B1&!B&!A1&A|E1&!E&D2&!D1&D&!C1&C&B1&!B&!A1&A|E1&!E&D2&D1&D&!C1&C&B1&!B&!A1&A|E1&E&D2&D1&D&!C1&C&B1&!B&!A1&A|!E1&E&D2&D1&D&!C1&C&B1&!B&!A1&A|!E1&E&!D2&D1&D&!C1&C&B1&!B&!A1&A|E1&E&!D2&D1&D&!C1&C&B1&!B&!A1&A|E1&!E&!D2&D1&D&!C1&C&B1&!B&!A1&A|E1&!E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|E1&E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|!E1&E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|!E1&E&D2&D1&!D&!C1&C&B1&!B&!A1&A|E1&E&D2&D1&!D&!C1&C&B1&!B&!A1&A|E1&!E&D2&D1&!D&!C1&C&B1&!B&!A1&A|E1&!E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|E1&E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|!E1&E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|E1&!E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|E1&E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|!E1&E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|!E1&E&D2&!D1&D&C1&C&!B1&!B&!A1&A|E1&E&D2&!D1&D&C1&C&!B1&!B&!A1&A|E1&!E&D2&!D1&D&C1&C&!B1&!B&!A1&A|E1&!E&D2&D1&D&C1&C&!B1&!B&!A1&A|E1&E&D2&D1&D&C1&C&!B1&!B&!A1&A|!E1&E&D2&D1&D&C1&C&!B1&!B&!A1&A|!E1&E&!D2&D1&D&C1&C&!B1&!B&!A1&A|E1&E&!D2&D1&D&C1&C&!B1&!B&!A1&A|E1&!E&!D2&D1&D&C1&C&!B1&!B&!A1&A|E1&!E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|E1&E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|!E1&E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|!E1&E&D2&D1&!D&C1&C&!B1&!B&!A1&A|E1&E&D2&D1&!D&C1&C&!B1&!B&!A1&A|E1&!E&D2&D1&!D&C1&C&!B1&!B&!A1&A|E1&!E&D2&!D1&!D&C1&C&!B1&!B&!A1&A|E1&E&D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E1&E&D2&!D1&!D&C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOOOAI22232.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n ASYNC1 -l ASYNC1 -i A B -o C CN -f C=!(!A&!B) CN=!(A&B) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist ASYNC1.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n MUX9 -l MUX9 -i IN0 IN1 IN2 IN3 IN4 IN5 IN6 IN7 IN8 S0 S1 S2 S3 S4 S5 S6 S7 S8 -o Z -f 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist MUX9.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOI2212 -l AAOAAOI2212 -i D1 D C B1 B A1 A -o Y -f Y=!(D1&D&!C&!B1&!B&!A1&!A|D1&D&C&!B1&!B&!A1&!A|D1&D&C&B1&!B&!A1&!A|D1&D&!C&B1&!B&!A1&!A|D1&D&!C&B1&B&!A1&!A|!D1&D&C&B1&B&!A1&!A|D1&D&C&B1&B&!A1&!A|D1&!D&C&B1&B&!A1&!A|!D1&!D&C&B1&B&!A1&!A|D1&D&C&!B1&B&!A1&!A|D1&D&!C&!B1&B&!A1&!A|D1&D&!C&!B1&B&A1&!A|D1&D&C&!B1&B&A1&!A|!D1&!D&C&B1&B&A1&!A|D1&!D&C&B1&B&A1&!A|D1&D&C&B1&B&A1&!A|!D1&D&C&B1&B&A1&!A|D1&D&!C&B1&B&A1&!A|D1&D&!C&B1&!B&A1&!A|D1&D&C&B1&!B&A1&!A|D1&D&C&!B1&!B&A1&!A|D1&D&!C&!B1&!B&A1&!A|D1&D&!C&!B1&!B&A1&A|!D1&D&C&!B1&!B&A1&A|D1&D&C&!B1&!B&A1&A|D1&!D&C&!B1&!B&A1&A|!D1&!D&C&!B1&!B&A1&A|!D1&!D&C&B1&!B&A1&A|D1&!D&C&B1&!B&A1&A|D1&D&C&B1&!B&A1&A|!D1&D&C&B1&!B&A1&A|D1&D&!C&B1&!B&A1&A|D1&D&!C&B1&B&A1&A|!D1&D&C&B1&B&A1&A|D1&D&C&B1&B&A1&A|D1&!D&C&B1&B&A1&A|!D1&!D&C&B1&B&A1&A|!D1&!D&C&!B1&B&A1&A|D1&!D&C&!B1&B&A1&A|D1&D&C&!B1&B&A1&A|!D1&D&C&!B1&B&A1&A|D1&D&!C&!B1&B&A1&A|D1&D&!C&!B1&B&!A1&A|D1&D&C&!B1&B&!A1&A|!D1&!D&C&B1&B&!A1&A|D1&!D&C&B1&B&!A1&A|D1&D&C&B1&B&!A1&A|!D1&D&C&B1&B&!A1&A|D1&D&!C&B1&B&!A1&A|D1&D&!C&B1&!B&!A1&A|D1&D&C&B1&!B&!A1&A|D1&D&C&!B1&!B&!A1&A|D1&D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOI2212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAI3221 -l AAOAI3221 -i D C1 C B1 B A2 A1 A -o Y -f Y=!(D&C1&!C&!B1&!B&!A2&!A1&!A|D&C1&C&!B1&!B&!A2&!A1&!A|D&!C1&C&!B1&!B&!A2&!A1&!A|D&!C1&C&B1&!B&!A2&!A1&!A|D&C1&C&B1&!B&!A2&!A1&!A|D&C1&!C&B1&!B&!A2&!A1&!A|D&!C1&!C&B1&B&!A2&!A1&!A|D&C1&!C&B1&B&!A2&!A1&!A|D&C1&C&B1&B&!A2&!A1&!A|D&!C1&C&B1&B&!A2&!A1&!A|D&!C1&C&!B1&B&!A2&!A1&!A|D&C1&C&!B1&B&!A2&!A1&!A|D&C1&!C&!B1&B&!A2&!A1&!A|D&C1&!C&!B1&B&A2&!A1&!A|D&C1&C&!B1&B&A2&!A1&!A|D&!C1&C&!B1&B&A2&!A1&!A|D&!C1&C&B1&B&A2&!A1&!A|D&C1&C&B1&B&A2&!A1&!A|D&C1&!C&B1&B&A2&!A1&!A|D&!C1&!C&B1&B&A2&!A1&!A|D&C1&!C&B1&!B&A2&!A1&!A|D&C1&C&B1&!B&A2&!A1&!A|D&!C1&C&B1&!B&A2&!A1&!A|D&!C1&C&!B1&!B&A2&!A1&!A|D&C1&C&!B1&!B&A2&!A1&!A|D&C1&!C&!B1&!B&A2&!A1&!A|D&C1&!C&!B1&!B&A2&A1&!A|D&C1&C&!B1&!B&A2&A1&!A|D&!C1&C&!B1&!B&A2&A1&!A|D&!C1&C&B1&!B&A2&A1&!A|D&C1&C&B1&!B&A2&A1&!A|D&C1&!C&B1&!B&A2&A1&!A|D&!C1&!C&B1&B&A2&A1&!A|D&C1&!C&B1&B&A2&A1&!A|D&C1&C&B1&B&A2&A1&!A|D&!C1&C&B1&B&A2&A1&!A|D&!C1&C&!B1&B&A2&A1&!A|D&C1&C&!B1&B&A2&A1&!A|D&C1&!C&!B1&B&A2&A1&!A|D&C1&!C&!B1&B&!A2&A1&!A|D&C1&C&!B1&B&!A2&A1&!A|D&!C1&C&!B1&B&!A2&A1&!A|D&!C1&C&B1&B&!A2&A1&!A|D&C1&C&B1&B&!A2&A1&!A|D&C1&!C&B1&B&!A2&A1&!A|D&!C1&!C&B1&B&!A2&A1&!A|D&C1&!C&B1&!B&!A2&A1&!A|D&C1&C&B1&!B&!A2&A1&!A|D&!C1&C&B1&!B&!A2&A1&!A|D&!C1&C&!B1&!B&!A2&A1&!A|D&C1&C&!B1&!B&!A2&A1&!A|D&C1&!C&!B1&!B&!A2&A1&!A|D&C1&!C&!B1&!B&!A2&A1&A|D&C1&C&!B1&!B&!A2&A1&A|D&!C1&C&!B1&!B&!A2&A1&A|D&!C1&C&B1&!B&!A2&A1&A|D&C1&C&B1&!B&!A2&A1&A|D&C1&!C&B1&!B&!A2&A1&A|D&!C1&!C&B1&B&!A2&A1&A|D&C1&!C&B1&B&!A2&A1&A|D&C1&C&B1&B&!A2&A1&A|D&!C1&C&B1&B&!A2&A1&A|D&!C1&C&!B1&B&!A2&A1&A|D&C1&C&!B1&B&!A2&A1&A|D&C1&!C&!B1&B&!A2&A1&A|D&!C1&!C&!B1&B&A2&A1&A|D&C1&!C&!B1&B&A2&A1&A|D&C1&C&!B1&B&A2&A1&A|D&!C1&C&!B1&B&A2&A1&A|D&!C1&C&B1&B&A2&A1&A|D&C1&C&B1&B&A2&A1&A|D&C1&!C&B1&B&A2&A1&A|D&!C1&!C&B1&B&A2&A1&A|D&!C1&!C&B1&!B&A2&A1&A|D&C1&!C&B1&!B&A2&A1&A|D&C1&C&B1&!B&A2&A1&A|D&!C1&C&B1&!B&A2&A1&A|D&!C1&C&!B1&!B&A2&A1&A|D&C1&C&!B1&!B&A2&A1&A|D&C1&!C&!B1&!B&A2&A1&A|D&!C1&!C&!B1&!B&A2&A1&A|D&C1&!C&!B1&!B&A2&!A1&A|D&C1&C&!B1&!B&A2&!A1&A|D&!C1&C&!B1&!B&A2&!A1&A|D&!C1&C&B1&!B&A2&!A1&A|D&C1&C&B1&!B&A2&!A1&A|D&C1&!C&B1&!B&A2&!A1&A|D&!C1&!C&B1&B&A2&!A1&A|D&C1&!C&B1&B&A2&!A1&A|D&C1&C&B1&B&A2&!A1&A|D&!C1&C&B1&B&A2&!A1&A|D&!C1&C&!B1&B&A2&!A1&A|D&C1&C&!B1&B&A2&!A1&A|D&C1&!C&!B1&B&A2&!A1&A|D&C1&!C&!B1&B&!A2&!A1&A|D&C1&C&!B1&B&!A2&!A1&A|D&!C1&C&!B1&B&!A2&!A1&A|D&!C1&C&B1&B&!A2&!A1&A|D&C1&C&B1&B&!A2&!A1&A|D&C1&!C&B1&B&!A2&!A1&A|D&!C1&!C&B1&B&!A2&!A1&A|D&C1&!C&B1&!B&!A2&!A1&A|D&C1&C&B1&!B&!A2&!A1&A|D&!C1&C&B1&!B&!A2&!A1&A|D&!C1&C&!B1&!B&!A2&!A1&A|D&C1&C&!B1&!B&!A2&!A1&A|D&C1&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAI3221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAI41 -l OAI41 -i B A3 A2 A1 A -o Y -f Y=!(B&A3&!A2&!A1&!A|B&A3&A2&!A1&!A|B&!A3&A2&!A1&!A|B&!A3&A2&A1&!A|B&A3&A2&A1&!A|B&A3&!A2&A1&!A|B&!A3&!A2&A1&!A|B&!A3&!A2&A1&A|B&A3&!A2&A1&A|B&A3&A2&A1&A|B&!A3&A2&A1&A|B&!A3&A2&!A1&A|B&A3&A2&!A1&A|B&A3&!A2&!A1&A|B&!A3&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAI41.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAI221 -l AOAI221 -i C B1 B A1 A -o Y -f Y=!(C&B1&!B&!A1&!A|C&B1&B&!A1&!A|C&!B1&B&!A1&!A|C&!B1&B&A1&!A|C&B1&B&A1&!A|C&B1&!B&A1&!A|C&!B1&!B&A1&A|C&B1&!B&A1&A|C&B1&B&A1&A|C&!B1&B&A1&A|C&!B1&B&!A1&A|C&B1&B&!A1&A|C&B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAI221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOAI22211 -l OOAAOAI22211 -i E D C1 C B1 B A1 A -o Y -f Y=!(E&D&!C1&!C&!B1&!B&!A1&!A|E&D&C1&!C&!B1&!B&!A1&!A|E&!D&C1&C&!B1&!B&!A1&!A|E&D&C1&C&!B1&!B&!A1&!A|E&D&!C1&C&!B1&!B&!A1&!A|E&D&!C1&C&B1&!B&!A1&!A|E&D&C1&C&B1&!B&!A1&!A|E&!D&C1&C&B1&!B&!A1&!A|E&D&C1&!C&B1&!B&!A1&!A|E&D&!C1&!C&B1&!B&!A1&!A|E&D&!C1&!C&B1&B&!A1&!A|E&D&C1&!C&B1&B&!A1&!A|E&!D&C1&C&B1&B&!A1&!A|E&D&C1&C&B1&B&!A1&!A|E&D&!C1&C&B1&B&!A1&!A|E&D&!C1&C&!B1&B&!A1&!A|E&D&C1&C&!B1&B&!A1&!A|E&!D&C1&C&!B1&B&!A1&!A|E&D&C1&!C&!B1&B&!A1&!A|E&D&!C1&!C&!B1&B&!A1&!A|E&!D&!C1&!C&!B1&B&A1&!A|E&D&!C1&!C&!B1&B&A1&!A|E&D&C1&!C&!B1&B&A1&!A|E&!D&C1&!C&!B1&B&A1&!A|E&!D&C1&C&!B1&B&A1&!A|E&D&C1&C&!B1&B&A1&!A|E&D&!C1&C&!B1&B&A1&!A|E&!D&!C1&C&!B1&B&A1&!A|E&!D&!C1&C&B1&B&A1&!A|E&D&!C1&C&B1&B&A1&!A|E&D&C1&C&B1&B&A1&!A|E&!D&C1&C&B1&B&A1&!A|E&!D&C1&!C&B1&B&A1&!A|E&D&C1&!C&B1&B&A1&!A|E&D&!C1&!C&B1&B&A1&!A|E&!D&!C1&!C&B1&B&A1&!A|E&!D&!C1&!C&B1&!B&A1&!A|E&D&!C1&!C&B1&!B&A1&!A|E&D&C1&!C&B1&!B&A1&!A|E&!D&C1&!C&B1&!B&A1&!A|E&!D&C1&C&B1&!B&A1&!A|E&D&C1&C&B1&!B&A1&!A|E&D&!C1&C&B1&!B&A1&!A|E&!D&!C1&C&B1&!B&A1&!A|E&D&!C1&C&!B1&!B&A1&!A|E&D&C1&C&!B1&!B&A1&!A|E&!D&C1&C&!B1&!B&A1&!A|E&D&C1&!C&!B1&!B&A1&!A|E&D&!C1&!C&!B1&!B&A1&!A|E&D&!C1&!C&!B1&!B&A1&A|E&D&C1&!C&!B1&!B&A1&A|E&!D&C1&C&!B1&!B&A1&A|E&D&C1&C&!B1&!B&A1&A|E&D&!C1&C&!B1&!B&A1&A|E&!D&!C1&C&B1&!B&A1&A|E&D&!C1&C&B1&!B&A1&A|E&D&C1&C&B1&!B&A1&A|E&!D&C1&C&B1&!B&A1&A|E&!D&C1&!C&B1&!B&A1&A|E&D&C1&!C&B1&!B&A1&A|E&D&!C1&!C&B1&!B&A1&A|E&!D&!C1&!C&B1&!B&A1&A|E&!D&!C1&!C&B1&B&A1&A|E&D&!C1&!C&B1&B&A1&A|E&D&C1&!C&B1&B&A1&A|E&!D&C1&!C&B1&B&A1&A|E&!D&C1&C&B1&B&A1&A|E&D&C1&C&B1&B&A1&A|E&D&!C1&C&B1&B&A1&A|E&!D&!C1&C&B1&B&A1&A|E&!D&!C1&C&!B1&B&A1&A|E&D&!C1&C&!B1&B&A1&A|E&D&C1&C&!B1&B&A1&A|E&!D&C1&C&!B1&B&A1&A|E&!D&C1&!C&!B1&B&A1&A|E&D&C1&!C&!B1&B&A1&A|E&D&!C1&!C&!B1&B&A1&A|E&!D&!C1&!C&!B1&B&A1&A|E&!D&!C1&!C&!B1&B&!A1&A|E&D&!C1&!C&!B1&B&!A1&A|E&D&C1&!C&!B1&B&!A1&A|E&!D&C1&!C&!B1&B&!A1&A|E&!D&C1&C&!B1&B&!A1&A|E&D&C1&C&!B1&B&!A1&A|E&D&!C1&C&!B1&B&!A1&A|E&!D&!C1&C&!B1&B&!A1&A|E&!D&!C1&C&B1&B&!A1&A|E&D&!C1&C&B1&B&!A1&A|E&D&C1&C&B1&B&!A1&A|E&!D&C1&C&B1&B&!A1&A|E&!D&C1&!C&B1&B&!A1&A|E&D&C1&!C&B1&B&!A1&A|E&D&!C1&!C&B1&B&!A1&A|E&!D&!C1&!C&B1&B&!A1&A|E&!D&!C1&!C&B1&!B&!A1&A|E&D&!C1&!C&B1&!B&!A1&A|E&D&C1&!C&B1&!B&!A1&A|E&!D&C1&!C&B1&!B&!A1&A|E&!D&C1&C&B1&!B&!A1&A|E&D&C1&C&B1&!B&!A1&A|E&D&!C1&C&B1&!B&!A1&A|E&!D&!C1&C&B1&!B&!A1&A|E&D&!C1&C&!B1&!B&!A1&A|E&D&C1&C&!B1&!B&!A1&A|E&!D&C1&C&!B1&!B&!A1&A|E&D&C1&!C&!B1&!B&!A1&A|E&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOAI22211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOI22141 -l AAOAAOI22141 -i E D3 D2 D1 D C B1 B A1 A -o Y -f Y=(!E&!D3&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!E&D3&D2&!D1&!D&!C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&!C&!B1&!B&!A1&!A|!E&!D3&D2&D1&!D&!C&!B1&!B&!A1&!A|!E&D3&D2&D1&!D&!C&!B1&!B&!A1&!A|!E&D3&!D2&D1&!D&!C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&!C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&D&!C&!B1&!B&!A1&!A|!E&D3&!D2&D1&D&!C&!B1&!B&!A1&!A|!E&!D3&D2&D1&D&!C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&D&!C&!B1&!B&!A1&!A|!E&D3&D2&!D1&D&!C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&D&!C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&!C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&D&C&!B1&!B&!A1&!A|!E&D3&D2&!D1&D&C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&D&C&!B1&!B&!A1&!A|!E&!D3&D2&D1&D&C&!B1&!B&!A1&!A|!E&D3&!D2&D1&D&C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&D&C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&C&!B1&!B&!A1&!A|!E&D3&!D2&D1&!D&C&!B1&!B&!A1&!A|!E&D3&D2&D1&!D&C&!B1&!B&!A1&!A|!E&!D3&D2&D1&!D&C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&C&!B1&!B&!A1&!A|!E&D3&D2&!D1&!D&C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&C&B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&C&B1&!B&!A1&!A|!E&D3&D2&!D1&!D&C&B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&C&B1&!B&!A1&!A|!E&!D3&D2&D1&!D&C&B1&!B&!A1&!A|!E&D3&D2&D1&!D&C&B1&!B&!A1&!A|!E&D3&!D2&D1&!D&C&B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&C&B1&!B&!A1&!A|!E&!D3&!D2&D1&D&C&B1&!B&!A1&!A|!E&D3&!D2&D1&D&C&B1&!B&!A1&!A|!E&!D3&D2&D1&D&C&B1&!B&!A1&!A|!E&!D3&D2&!D1&D&C&B1&!B&!A1&!A|!E&D3&D2&!D1&D&C&B1&!B&!A1&!A|!E&D3&!D2&!D1&D&C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&!C&B1&!B&!A1&!A|!E&D3&!D2&!D1&D&!C&B1&!B&!A1&!A|!E&D3&D2&!D1&D&!C&B1&!B&!A1&!A|!E&!D3&D2&!D1&D&!C&B1&!B&!A1&!A|!E&!D3&D2&D1&D&!C&B1&!B&!A1&!A|!E&D3&!D2&D1&D&!C&B1&!B&!A1&!A|!E&!D3&!D2&D1&D&!C&B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&!C&B1&!B&!A1&!A|!E&D3&!D2&D1&!D&!C&B1&!B&!A1&!A|!E&D3&D2&D1&!D&!C&B1&!B&!A1&!A|!E&!D3&D2&D1&!D&!C&B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&!C&B1&!B&!A1&!A|!E&D3&D2&!D1&!D&!C&B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&!C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&!C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&!C&B1&B&!A1&!A|!E&D3&!D2&!D1&!D&!C&B1&B&!A1&!A|!E&D3&D2&!D1&!D&!C&B1&B&!A1&!A|!E&!D3&D2&!D1&!D&!C&B1&B&!A1&!A|!E&!D3&D2&D1&!D&!C&B1&B&!A1&!A|!E&D3&D2&D1&!D&!C&B1&B&!A1&!A|!E&D3&!D2&D1&!D&!C&B1&B&!A1&!A|!E&!D3&!D2&D1&!D&!C&B1&B&!A1&!A|!E&!D3&!D2&D1&D&!C&B1&B&!A1&!A|!E&D3&!D2&D1&D&!C&B1&B&!A1&!A|!E&!D3&D2&D1&D&!C&B1&B&!A1&!A|!E&!D3&D2&!D1&D&!C&B1&B&!A1&!A|!E&D3&D2&!D1&D&!C&B1&B&!A1&!A|!E&D3&!D2&!D1&D&!C&B1&B&!A1&!A|!E&!D3&!D2&!D1&D&!C&B1&B&!A1&!A|!E&!D3&!D2&!D1&!D&C&!B1&B&!A1&!A|!E&D3&!D2&!D1&!D&C&!B1&B&!A1&!A|!E&D3&D2&!D1&!D&C&!B1&B&!A1&!A|!E&!D3&D2&!D1&!D&C&!B1&B&!A1&!A|!E&!D3&D2&D1&!D&C&!B1&B&!A1&!A|!E&D3&D2&D1&!D&C&!B1&B&!A1&!A|!E&D3&!D2&D1&!D&C&!B1&B&!A1&!A|!E&!D3&!D2&D1&!D&C&!B1&B&!A1&!A|!E&!D3&!D2&D1&D&C&!B1&B&!A1&!A|!E&D3&!D2&D1&D&C&!B1&B&!A1&!A|!E&!D3&D2&D1&D&C&!B1&B&!A1&!A|!E&!D3&D2&!D1&D&C&!B1&B&!A1&!A|!E&D3&D2&!D1&D&C&!B1&B&!A1&!A|!E&D3&!D2&!D1&D&C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&D&C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&D&!C&!B1&B&!A1&!A|!E&D3&!D2&!D1&D&!C&!B1&B&!A1&!A|!E&D3&D2&!D1&D&!C&!B1&B&!A1&!A|!E&!D3&D2&!D1&D&!C&!B1&B&!A1&!A|!E&!D3&D2&D1&D&!C&!B1&B&!A1&!A|!E&D3&!D2&D1&D&!C&!B1&B&!A1&!A|!E&!D3&!D2&D1&D&!C&!B1&B&!A1&!A|!E&!D3&!D2&D1&!D&!C&!B1&B&!A1&!A|!E&D3&!D2&D1&!D&!C&!B1&B&!A1&!A|!E&D3&D2&D1&!D&!C&!B1&B&!A1&!A|!E&!D3&D2&D1&!D&!C&!B1&B&!A1&!A|!E&!D3&D2&!D1&!D&!C&!B1&B&!A1&!A|!E&D3&D2&!D1&!D&!C&!B1&B&!A1&!A|!E&D3&!D2&!D1&!D&!C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&!D&!C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&!D&!C&!B1&B&A1&!A|!E&D3&!D2&!D1&!D&!C&!B1&B&A1&!A|!E&D3&D2&!D1&!D&!C&!B1&B&A1&!A|!E&!D3&D2&!D1&!D&!C&!B1&B&A1&!A|!E&!D3&D2&D1&!D&!C&!B1&B&A1&!A|!E&D3&D2&D1&!D&!C&!B1&B&A1&!A|!E&D3&!D2&D1&!D&!C&!B1&B&A1&!A|!E&!D3&!D2&D1&!D&!C&!B1&B&A1&!A|!E&!D3&!D2&D1&D&!C&!B1&B&A1&!A|!E&D3&!D2&D1&D&!C&!B1&B&A1&!A|!E&!D3&D2&D1&D&!C&!B1&B&A1&!A|!E&!D3&D2&!D1&D&!C&!B1&B&A1&!A|!E&D3&D2&!D1&D&!C&!B1&B&A1&!A|!E&D3&!D2&!D1&D&!C&!B1&B&A1&!A|!E&!D3&!D2&!D1&D&!C&!B1&B&A1&!A|!E&!D3&!D2&!D1&D&C&!B1&B&A1&!A|!E&D3&!D2&!D1&D&C&!B1&B&A1&!A|!E&D3&D2&!D1&D&C&!B1&B&A1&!A|!E&!D3&D2&!D1&D&C&!B1&B&A1&!A|!E&!D3&D2&D1&D&C&!B1&B&A1&!A|!E&D3&!D2&D1&D&C&!B1&B&A1&!A|!E&!D3&!D2&D1&D&C&!B1&B&A1&!A|!E&!D3&!D2&D1&!D&C&!B1&B&A1&!A|!E&D3&!D2&D1&!D&C&!B1&B&A1&!A|!E&D3&D2&D1&!D&C&!B1&B&A1&!A|!E&!D3&D2&D1&!D&C&!B1&B&A1&!A|!E&!D3&D2&!D1&!D&C&!B1&B&A1&!A|!E&D3&D2&!D1&!D&C&!B1&B&A1&!A|!E&D3&!D2&!D1&!D&C&!B1&B&A1&!A|!E&!D3&!D2&!D1&!D&C&!B1&B&A1&!A|!E&!D3&!D2&!D1&D&!C&B1&B&A1&!A|!E&D3&!D2&!D1&D&!C&B1&B&A1&!A|!E&D3&D2&!D1&D&!C&B1&B&A1&!A|!E&!D3&D2&!D1&D&!C&B1&B&A1&!A|!E&!D3&D2&D1&D&!C&B1&B&A1&!A|!E&D3&!D2&D1&D&!C&B1&B&A1&!A|!E&!D3&!D2&D1&D&!C&B1&B&A1&!A|!E&!D3&!D2&D1&!D&!C&B1&B&A1&!A|!E&D3&!D2&D1&!D&!C&B1&B&A1&!A|!E&D3&D2&D1&!D&!C&B1&B&A1&!A|!E&!D3&D2&D1&!D&!C&B1&B&A1&!A|!E&!D3&D2&!D1&!D&!C&B1&B&A1&!A|!E&D3&D2&!D1&!D&!C&B1&B&A1&!A|!E&D3&!D2&!D1&!D&!C&B1&B&A1&!A|!E&!D3&!D2&!D1&!D&!C&B1&B&A1&!A|!E&!D3&!D2&!D1&!D&!C&B1&!B&A1&!A|!E&D3&!D2&!D1&!D&!C&B1&!B&A1&!A|!E&D3&D2&!D1&!D&!C&B1&!B&A1&!A|!E&!D3&D2&!D1&!D&!C&B1&!B&A1&!A|!E&!D3&D2&D1&!D&!C&B1&!B&A1&!A|!E&D3&D2&D1&!D&!C&B1&!B&A1&!A|!E&D3&!D2&D1&!D&!C&B1&!B&A1&!A|!E&!D3&!D2&D1&!D&!C&B1&!B&A1&!A|!E&!D3&!D2&D1&D&!C&B1&!B&A1&!A|!E&D3&!D2&D1&D&!C&B1&!B&A1&!A|!E&!D3&D2&D1&D&!C&B1&!B&A1&!A|!E&!D3&D2&!D1&D&!C&B1&!B&A1&!A|!E&D3&D2&!D1&D&!C&B1&!B&A1&!A|!E&D3&!D2&!D1&D&!C&B1&!B&A1&!A|!E&!D3&!D2&!D1&D&!C&B1&!B&A1&!A|!E&!D3&!D2&!D1&D&C&B1&!B&A1&!A|!E&D3&!D2&!D1&D&C&B1&!B&A1&!A|!E&D3&D2&!D1&D&C&B1&!B&A1&!A|!E&!D3&D2&!D1&D&C&B1&!B&A1&!A|!E&!D3&D2&D1&D&C&B1&!B&A1&!A|!E&D3&!D2&D1&D&C&B1&!B&A1&!A|!E&!D3&!D2&D1&D&C&B1&!B&A1&!A|!E&!D3&!D2&D1&!D&C&B1&!B&A1&!A|!E&D3&!D2&D1&!D&C&B1&!B&A1&!A|!E&D3&D2&D1&!D&C&B1&!B&A1&!A|!E&!D3&D2&D1&!D&C&B1&!B&A1&!A|!E&!D3&D2&!D1&!D&C&B1&!B&A1&!A|!E&D3&D2&!D1&!D&C&B1&!B&A1&!A|!E&D3&!D2&!D1&!D&C&B1&!B&A1&!A|!E&!D3&!D2&!D1&!D&C&B1&!B&A1&!A|!E&!D3&!D2&!D1&!D&C&!B1&!B&A1&!A|!E&D3&!D2&!D1&!D&C&!B1&!B&A1&!A|!E&D3&D2&!D1&!D&C&!B1&!B&A1&!A|!E&!D3&D2&!D1&!D&C&!B1&!B&A1&!A|!E&!D3&D2&D1&!D&C&!B1&!B&A1&!A|!E&D3&D2&D1&!D&C&!B1&!B&A1&!A|!E&D3&!D2&D1&!D&C&!B1&!B&A1&!A|!E&!D3&!D2&D1&!D&C&!B1&!B&A1&!A|!E&!D3&!D2&D1&D&C&!B1&!B&A1&!A|!E&D3&!D2&D1&D&C&!B1&!B&A1&!A|!E&!D3&D2&D1&D&C&!B1&!B&A1&!A|!E&!D3&D2&!D1&D&C&!B1&!B&A1&!A|!E&D3&D2&!D1&D&C&!B1&!B&A1&!A|!E&D3&!D2&!D1&D&C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&D&C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&D&!C&!B1&!B&A1&!A|!E&D3&!D2&!D1&D&!C&!B1&!B&A1&!A|!E&D3&D2&!D1&D&!C&!B1&!B&A1&!A|!E&!D3&D2&!D1&D&!C&!B1&!B&A1&!A|!E&!D3&D2&D1&D&!C&!B1&!B&A1&!A|!E&D3&!D2&D1&D&!C&!B1&!B&A1&!A|!E&!D3&!D2&D1&D&!C&!B1&!B&A1&!A|!E&!D3&!D2&D1&!D&!C&!B1&!B&A1&!A|!E&D3&!D2&D1&!D&!C&!B1&!B&A1&!A|!E&D3&D2&D1&!D&!C&!B1&!B&A1&!A|!E&!D3&D2&D1&!D&!C&!B1&!B&A1&!A|!E&!D3&D2&!D1&!D&!C&!B1&!B&A1&!A|!E&D3&D2&!D1&!D&!C&!B1&!B&A1&!A|!E&D3&!D2&!D1&!D&!C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&!D&!C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&!D&!C&!B1&!B&A1&A|!E&D3&!D2&!D1&!D&!C&!B1&!B&A1&A|!E&D3&D2&!D1&!D&!C&!B1&!B&A1&A|!E&!D3&D2&!D1&!D&!C&!B1&!B&A1&A|!E&!D3&D2&D1&!D&!C&!B1&!B&A1&A|!E&D3&D2&D1&!D&!C&!B1&!B&A1&A|!E&D3&!D2&D1&!D&!C&!B1&!B&A1&A|!E&!D3&!D2&D1&!D&!C&!B1&!B&A1&A|!E&!D3&!D2&D1&D&!C&!B1&!B&A1&A|!E&D3&!D2&D1&D&!C&!B1&!B&A1&A|!E&!D3&D2&D1&D&!C&!B1&!B&A1&A|!E&!D3&D2&!D1&D&!C&!B1&!B&A1&A|!E&D3&D2&!D1&D&!C&!B1&!B&A1&A|!E&D3&!D2&!D1&D&!C&!B1&!B&A1&A|!E&!D3&!D2&!D1&D&!C&!B1&!B&A1&A|!E&!D3&!D2&!D1&D&!C&B1&!B&A1&A|!E&D3&!D2&!D1&D&!C&B1&!B&A1&A|!E&D3&D2&!D1&D&!C&B1&!B&A1&A|!E&!D3&D2&!D1&D&!C&B1&!B&A1&A|!E&!D3&D2&D1&D&!C&B1&!B&A1&A|!E&D3&!D2&D1&D&!C&B1&!B&A1&A|!E&!D3&!D2&D1&D&!C&B1&!B&A1&A|!E&!D3&!D2&D1&!D&!C&B1&!B&A1&A|!E&D3&!D2&D1&!D&!C&B1&!B&A1&A|!E&D3&D2&D1&!D&!C&B1&!B&A1&A|!E&!D3&D2&D1&!D&!C&B1&!B&A1&A|!E&!D3&D2&!D1&!D&!C&B1&!B&A1&A|!E&D3&D2&!D1&!D&!C&B1&!B&A1&A|!E&D3&!D2&!D1&!D&!C&B1&!B&A1&A|!E&!D3&!D2&!D1&!D&!C&B1&!B&A1&A|!E&!D3&!D2&!D1&!D&!C&B1&B&A1&A|!E&D3&!D2&!D1&!D&!C&B1&B&A1&A|!E&D3&D2&!D1&!D&!C&B1&B&A1&A|!E&!D3&D2&!D1&!D&!C&B1&B&A1&A|!E&!D3&D2&D1&!D&!C&B1&B&A1&A|!E&D3&D2&D1&!D&!C&B1&B&A1&A|!E&D3&!D2&D1&!D&!C&B1&B&A1&A|!E&!D3&!D2&D1&!D&!C&B1&B&A1&A|!E&!D3&!D2&D1&D&!C&B1&B&A1&A|!E&D3&!D2&D1&D&!C&B1&B&A1&A|!E&!D3&D2&D1&D&!C&B1&B&A1&A|!E&!D3&D2&!D1&D&!C&B1&B&A1&A|!E&D3&D2&!D1&D&!C&B1&B&A1&A|!E&D3&!D2&!D1&D&!C&B1&B&A1&A|!E&!D3&!D2&!D1&D&!C&B1&B&A1&A|!E&!D3&!D2&!D1&D&!C&!B1&B&A1&A|!E&D3&!D2&!D1&D&!C&!B1&B&A1&A|!E&D3&D2&!D1&D&!C&!B1&B&A1&A|!E&!D3&D2&!D1&D&!C&!B1&B&A1&A|!E&!D3&D2&D1&D&!C&!B1&B&A1&A|!E&D3&!D2&D1&D&!C&!B1&B&A1&A|!E&!D3&!D2&D1&D&!C&!B1&B&A1&A|!E&!D3&!D2&D1&!D&!C&!B1&B&A1&A|!E&D3&!D2&D1&!D&!C&!B1&B&A1&A|!E&D3&D2&D1&!D&!C&!B1&B&A1&A|!E&!D3&D2&D1&!D&!C&!B1&B&A1&A|!E&!D3&D2&!D1&!D&!C&!B1&B&A1&A|!E&D3&D2&!D1&!D&!C&!B1&B&A1&A|!E&D3&!D2&!D1&!D&!C&!B1&B&A1&A|!E&!D3&!D2&!D1&!D&!C&!B1&B&A1&A|!E&!D3&!D2&!D1&!D&!C&!B1&B&!A1&A|!E&D3&!D2&!D1&!D&!C&!B1&B&!A1&A|!E&D3&D2&!D1&!D&!C&!B1&B&!A1&A|!E&!D3&D2&!D1&!D&!C&!B1&B&!A1&A|!E&!D3&D2&D1&!D&!C&!B1&B&!A1&A|!E&D3&D2&D1&!D&!C&!B1&B&!A1&A|!E&D3&!D2&D1&!D&!C&!B1&B&!A1&A|!E&!D3&!D2&D1&!D&!C&!B1&B&!A1&A|!E&!D3&!D2&D1&D&!C&!B1&B&!A1&A|!E&D3&!D2&D1&D&!C&!B1&B&!A1&A|!E&!D3&D2&D1&D&!C&!B1&B&!A1&A|!E&!D3&D2&!D1&D&!C&!B1&B&!A1&A|!E&D3&D2&!D1&D&!C&!B1&B&!A1&A|!E&D3&!D2&!D1&D&!C&!B1&B&!A1&A|!E&!D3&!D2&!D1&D&!C&!B1&B&!A1&A|!E&!D3&!D2&!D1&D&C&!B1&B&!A1&A|!E&D3&!D2&!D1&D&C&!B1&B&!A1&A|!E&D3&D2&!D1&D&C&!B1&B&!A1&A|!E&!D3&D2&!D1&D&C&!B1&B&!A1&A|!E&!D3&D2&D1&D&C&!B1&B&!A1&A|!E&D3&!D2&D1&D&C&!B1&B&!A1&A|!E&!D3&!D2&D1&D&C&!B1&B&!A1&A|!E&!D3&!D2&D1&!D&C&!B1&B&!A1&A|!E&D3&!D2&D1&!D&C&!B1&B&!A1&A|!E&D3&D2&D1&!D&C&!B1&B&!A1&A|!E&!D3&D2&D1&!D&C&!B1&B&!A1&A|!E&!D3&D2&!D1&!D&C&!B1&B&!A1&A|!E&D3&D2&!D1&!D&C&!B1&B&!A1&A|!E&D3&!D2&!D1&!D&C&!B1&B&!A1&A|!E&!D3&!D2&!D1&!D&C&!B1&B&!A1&A|!E&!D3&!D2&!D1&D&!C&B1&B&!A1&A|!E&D3&!D2&!D1&D&!C&B1&B&!A1&A|!E&D3&D2&!D1&D&!C&B1&B&!A1&A|!E&!D3&D2&!D1&D&!C&B1&B&!A1&A|!E&!D3&D2&D1&D&!C&B1&B&!A1&A|!E&D3&!D2&D1&D&!C&B1&B&!A1&A|!E&!D3&!D2&D1&D&!C&B1&B&!A1&A|!E&!D3&!D2&D1&!D&!C&B1&B&!A1&A|!E&D3&!D2&D1&!D&!C&B1&B&!A1&A|!E&D3&D2&D1&!D&!C&B1&B&!A1&A|!E&!D3&D2&D1&!D&!C&B1&B&!A1&A|!E&!D3&D2&!D1&!D&!C&B1&B&!A1&A|!E&D3&D2&!D1&!D&!C&B1&B&!A1&A|!E&D3&!D2&!D1&!D&!C&B1&B&!A1&A|!E&!D3&!D2&!D1&!D&!C&B1&B&!A1&A|!E&!D3&!D2&!D1&!D&!C&B1&!B&!A1&A|!E&D3&!D2&!D1&!D&!C&B1&!B&!A1&A|!E&D3&D2&!D1&!D&!C&B1&!B&!A1&A|!E&!D3&D2&!D1&!D&!C&B1&!B&!A1&A|!E&!D3&D2&D1&!D&!C&B1&!B&!A1&A|!E&D3&D2&D1&!D&!C&B1&!B&!A1&A|!E&D3&!D2&D1&!D&!C&B1&!B&!A1&A|!E&!D3&!D2&D1&!D&!C&B1&!B&!A1&A|!E&!D3&!D2&D1&D&!C&B1&!B&!A1&A|!E&D3&!D2&D1&D&!C&B1&!B&!A1&A|!E&!D3&D2&D1&D&!C&B1&!B&!A1&A|!E&!D3&D2&!D1&D&!C&B1&!B&!A1&A|!E&D3&D2&!D1&D&!C&B1&!B&!A1&A|!E&D3&!D2&!D1&D&!C&B1&!B&!A1&A|!E&!D3&!D2&!D1&D&!C&B1&!B&!A1&A|!E&!D3&!D2&!D1&D&C&B1&!B&!A1&A|!E&D3&!D2&!D1&D&C&B1&!B&!A1&A|!E&D3&D2&!D1&D&C&B1&!B&!A1&A|!E&!D3&D2&!D1&D&C&B1&!B&!A1&A|!E&!D3&D2&D1&D&C&B1&!B&!A1&A|!E&D3&!D2&D1&D&C&B1&!B&!A1&A|!E&!D3&!D2&D1&D&C&B1&!B&!A1&A|!E&!D3&!D2&D1&!D&C&B1&!B&!A1&A|!E&D3&!D2&D1&!D&C&B1&!B&!A1&A|!E&D3&D2&D1&!D&C&B1&!B&!A1&A|!E&!D3&D2&D1&!D&C&B1&!B&!A1&A|!E&!D3&D2&!D1&!D&C&B1&!B&!A1&A|!E&D3&D2&!D1&!D&C&B1&!B&!A1&A|!E&D3&!D2&!D1&!D&C&B1&!B&!A1&A|!E&!D3&!D2&!D1&!D&C&B1&!B&!A1&A|!E&!D3&!D2&!D1&!D&C&!B1&!B&!A1&A|!E&D3&!D2&!D1&!D&C&!B1&!B&!A1&A|!E&D3&D2&!D1&!D&C&!B1&!B&!A1&A|!E&!D3&D2&!D1&!D&C&!B1&!B&!A1&A|!E&!D3&D2&D1&!D&C&!B1&!B&!A1&A|!E&D3&D2&D1&!D&C&!B1&!B&!A1&A|!E&D3&!D2&D1&!D&C&!B1&!B&!A1&A|!E&!D3&!D2&D1&!D&C&!B1&!B&!A1&A|!E&!D3&!D2&D1&D&C&!B1&!B&!A1&A|!E&D3&!D2&D1&D&C&!B1&!B&!A1&A|!E&!D3&D2&D1&D&C&!B1&!B&!A1&A|!E&!D3&D2&!D1&D&C&!B1&!B&!A1&A|!E&D3&D2&!D1&D&C&!B1&!B&!A1&A|!E&D3&!D2&!D1&D&C&!B1&!B&!A1&A|!E&!D3&!D2&!D1&D&C&!B1&!B&!A1&A|!E&!D3&!D2&!D1&D&!C&!B1&!B&!A1&A|!E&D3&!D2&!D1&D&!C&!B1&!B&!A1&A|!E&D3&D2&!D1&D&!C&!B1&!B&!A1&A|!E&!D3&D2&!D1&D&!C&!B1&!B&!A1&A|!E&!D3&D2&D1&D&!C&!B1&!B&!A1&A|!E&D3&!D2&D1&D&!C&!B1&!B&!A1&A|!E&!D3&!D2&D1&D&!C&!B1&!B&!A1&A|!E&!D3&!D2&D1&!D&!C&!B1&!B&!A1&A|!E&D3&!D2&D1&!D&!C&!B1&!B&!A1&A|!E&D3&D2&D1&!D&!C&!B1&!B&!A1&A|!E&!D3&D2&D1&!D&!C&!B1&!B&!A1&A|!E&!D3&D2&!D1&!D&!C&!B1&!B&!A1&A|!E&D3&D2&!D1&!D&!C&!B1&!B&!A1&A|!E&D3&!D2&!D1&!D&!C&!B1&!B&!A1&A|!E&!D3&!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOI22141.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAI222 -l AOOAI222 -i C1 C B1 B A1 A -o Y -f Y=(!C1&!C&!B1&!B&!A1&!A|C1&!C&!B1&!B&!A1&!A|C1&C&!B1&!B&!A1&!A|!C1&C&!B1&!B&!A1&!A|!C1&!C&B1&!B&!A1&!A|!C1&!C&B1&B&!A1&!A|!C1&!C&!B1&B&!A1&!A|!C1&!C&!B1&B&A1&!A|!C1&!C&B1&B&A1&!A|!C1&!C&B1&!B&A1&!A|!C1&C&!B1&!B&A1&!A|C1&C&!B1&!B&A1&!A|C1&!C&!B1&!B&A1&!A|!C1&!C&!B1&!B&A1&!A|!C1&!C&!B1&!B&A1&A|!C1&!C&B1&!B&A1&A|!C1&!C&B1&B&A1&A|!C1&!C&!B1&B&A1&A|!C1&!C&!B1&B&!A1&A|!C1&!C&B1&B&!A1&A|!C1&!C&B1&!B&!A1&A|!C1&C&!B1&!B&!A1&A|C1&C&!B1&!B&!A1&A|C1&!C&!B1&!B&!A1&A|!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAI222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOI3221 -l OOAOI3221 -i D C1 C B1 B A2 A1 A -o Y -f Y=(!D&!C1&!C&!B1&!B&!A2&!A1&!A|!D&C1&!C&!B1&!B&!A2&!A1&!A|!D&C1&C&!B1&!B&!A2&!A1&!A|!D&!C1&C&!B1&!B&!A2&!A1&!A|!D&!C1&C&B1&!B&!A2&!A1&!A|!D&C1&C&B1&!B&!A2&!A1&!A|!D&C1&!C&B1&!B&!A2&!A1&!A|!D&!C1&!C&B1&!B&!A2&!A1&!A|!D&!C1&!C&B1&B&!A2&!A1&!A|!D&C1&!C&B1&B&!A2&!A1&!A|!D&C1&C&B1&B&!A2&!A1&!A|!D&!C1&C&B1&B&!A2&!A1&!A|!D&!C1&C&!B1&B&!A2&!A1&!A|!D&C1&C&!B1&B&!A2&!A1&!A|!D&C1&!C&!B1&B&!A2&!A1&!A|!D&!C1&!C&!B1&B&!A2&!A1&!A|!D&!C1&!C&!B1&B&A2&!A1&!A|!D&C1&!C&!B1&B&A2&!A1&!A|!D&!C1&C&!B1&B&A2&!A1&!A|!D&!C1&C&B1&B&A2&!A1&!A|!D&C1&!C&B1&B&A2&!A1&!A|!D&!C1&!C&B1&B&A2&!A1&!A|!D&!C1&!C&B1&!B&A2&!A1&!A|!D&C1&!C&B1&!B&A2&!A1&!A|!D&!C1&C&B1&!B&A2&!A1&!A|!D&!C1&C&!B1&!B&A2&!A1&!A|!D&C1&C&!B1&!B&A2&!A1&!A|!D&C1&!C&!B1&!B&A2&!A1&!A|!D&!C1&!C&!B1&!B&A2&!A1&!A|!D&!C1&!C&!B1&!B&A2&A1&!A|!D&C1&!C&!B1&!B&A2&A1&!A|!D&C1&C&!B1&!B&A2&A1&!A|!D&!C1&C&!B1&!B&A2&A1&!A|!D&!C1&C&B1&!B&A2&A1&!A|!D&C1&!C&B1&!B&A2&A1&!A|!D&!C1&!C&B1&!B&A2&A1&!A|!D&!C1&!C&B1&B&A2&A1&!A|!D&C1&!C&B1&B&A2&A1&!A|!D&!C1&C&B1&B&A2&A1&!A|!D&!C1&C&!B1&B&A2&A1&!A|!D&C1&!C&!B1&B&A2&A1&!A|!D&!C1&!C&!B1&B&A2&A1&!A|!D&!C1&!C&!B1&B&!A2&A1&!A|!D&C1&!C&!B1&B&!A2&A1&!A|!D&!C1&C&!B1&B&!A2&A1&!A|!D&!C1&C&B1&B&!A2&A1&!A|!D&C1&!C&B1&B&!A2&A1&!A|!D&!C1&!C&B1&B&!A2&A1&!A|!D&!C1&!C&B1&!B&!A2&A1&!A|!D&C1&!C&B1&!B&!A2&A1&!A|!D&!C1&C&B1&!B&!A2&A1&!A|!D&!C1&C&!B1&!B&!A2&A1&!A|!D&C1&C&!B1&!B&!A2&A1&!A|!D&C1&!C&!B1&!B&!A2&A1&!A|!D&!C1&!C&!B1&!B&!A2&A1&!A|!D&!C1&!C&!B1&!B&!A2&A1&A|!D&C1&!C&!B1&!B&!A2&A1&A|!D&C1&C&!B1&!B&!A2&A1&A|!D&!C1&C&!B1&!B&!A2&A1&A|!D&!C1&C&B1&!B&!A2&A1&A|!D&C1&!C&B1&!B&!A2&A1&A|!D&!C1&!C&B1&!B&!A2&A1&A|!D&!C1&!C&B1&B&!A2&A1&A|!D&C1&!C&B1&B&!A2&A1&A|!D&!C1&C&B1&B&!A2&A1&A|!D&!C1&C&!B1&B&!A2&A1&A|!D&C1&!C&!B1&B&!A2&A1&A|!D&!C1&!C&!B1&B&!A2&A1&A|!D&!C1&!C&!B1&B&A2&A1&A|!D&C1&!C&!B1&B&A2&A1&A|!D&!C1&C&!B1&B&A2&A1&A|!D&!C1&C&B1&B&A2&A1&A|!D&C1&!C&B1&B&A2&A1&A|!D&!C1&!C&B1&B&A2&A1&A|!D&!C1&!C&B1&!B&A2&A1&A|!D&C1&!C&B1&!B&A2&A1&A|!D&!C1&C&B1&!B&A2&A1&A|!D&!C1&C&!B1&!B&A2&A1&A|!D&C1&C&!B1&!B&A2&A1&A|!D&C1&!C&!B1&!B&A2&A1&A|!D&!C1&!C&!B1&!B&A2&A1&A|!D&!C1&!C&!B1&!B&A2&!A1&A|!D&C1&!C&!B1&!B&A2&!A1&A|!D&C1&C&!B1&!B&A2&!A1&A|!D&!C1&C&!B1&!B&A2&!A1&A|!D&!C1&C&B1&!B&A2&!A1&A|!D&C1&!C&B1&!B&A2&!A1&A|!D&!C1&!C&B1&!B&A2&!A1&A|!D&!C1&!C&B1&B&A2&!A1&A|!D&C1&!C&B1&B&A2&!A1&A|!D&!C1&C&B1&B&A2&!A1&A|!D&!C1&C&!B1&B&A2&!A1&A|!D&C1&!C&!B1&B&A2&!A1&A|!D&!C1&!C&!B1&B&A2&!A1&A|!D&!C1&!C&!B1&B&!A2&!A1&A|!D&C1&!C&!B1&B&!A2&!A1&A|!D&!C1&C&!B1&B&!A2&!A1&A|!D&!C1&C&B1&B&!A2&!A1&A|!D&C1&!C&B1&B&!A2&!A1&A|!D&!C1&!C&B1&B&!A2&!A1&A|!D&!C1&!C&B1&!B&!A2&!A1&A|!D&C1&!C&B1&!B&!A2&!A1&A|!D&!C1&C&B1&!B&!A2&!A1&A|!D&!C1&C&!B1&!B&!A2&!A1&A|!D&C1&C&!B1&!B&!A2&!A1&A|!D&C1&!C&!B1&!B&!A2&!A1&A|!D&!C1&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOI3221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOI22131 -l OOAAOI22131 -i E D2 D1 D C B1 B A1 A -o Y -f Y=(!E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!E&D2&!D1&!D&!C&!B1&!B&!A1&!A|!E&D2&D1&!D&!C&!B1&!B&!A1&!A|!E&!D2&D1&!D&!C&!B1&!B&!A1&!A|!E&!D2&D1&D&!C&!B1&!B&!A1&!A|!E&D2&!D1&D&!C&!B1&!B&!A1&!A|!E&!D2&!D1&D&!C&!B1&!B&!A1&!A|!E&!D2&!D1&D&C&!B1&!B&!A1&!A|!E&D2&!D1&D&C&!B1&!B&!A1&!A|!E&!D2&D1&D&C&!B1&!B&!A1&!A|!E&!D2&D1&!D&C&!B1&!B&!A1&!A|!E&D2&D1&!D&C&!B1&!B&!A1&!A|!E&D2&!D1&!D&C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&C&B1&!B&!A1&!A|!E&D2&!D1&!D&C&B1&!B&!A1&!A|!E&D2&D1&!D&C&B1&!B&!A1&!A|!E&!D2&D1&!D&C&B1&!B&!A1&!A|!E&!D2&D1&D&C&B1&!B&!A1&!A|!E&D2&!D1&D&C&B1&!B&!A1&!A|!E&!D2&!D1&D&C&B1&!B&!A1&!A|!E&!D2&!D1&D&!C&B1&!B&!A1&!A|!E&D2&!D1&D&!C&B1&!B&!A1&!A|!E&!D2&D1&D&!C&B1&!B&!A1&!A|!E&!D2&D1&!D&!C&B1&!B&!A1&!A|!E&D2&D1&!D&!C&B1&!B&!A1&!A|!E&D2&!D1&!D&!C&B1&!B&!A1&!A|!E&!D2&!D1&!D&!C&B1&!B&!A1&!A|!E&!D2&!D1&!D&!C&B1&B&!A1&!A|!E&D2&!D1&!D&!C&B1&B&!A1&!A|!E&D2&D1&!D&!C&B1&B&!A1&!A|!E&!D2&D1&!D&!C&B1&B&!A1&!A|!E&!D2&D1&D&!C&B1&B&!A1&!A|!E&D2&!D1&D&!C&B1&B&!A1&!A|!E&!D2&!D1&D&!C&B1&B&!A1&!A|!E&!D2&!D1&D&C&B1&B&!A1&!A|!E&D2&!D1&D&C&B1&B&!A1&!A|!E&!D2&D1&D&C&B1&B&!A1&!A|!E&!D2&D1&!D&C&B1&B&!A1&!A|!E&D2&D1&!D&C&B1&B&!A1&!A|!E&D2&!D1&!D&C&B1&B&!A1&!A|!E&!D2&!D1&!D&C&B1&B&!A1&!A|!E&!D2&!D1&!D&C&!B1&B&!A1&!A|!E&D2&!D1&!D&C&!B1&B&!A1&!A|!E&D2&D1&!D&C&!B1&B&!A1&!A|!E&!D2&D1&!D&C&!B1&B&!A1&!A|!E&!D2&D1&D&C&!B1&B&!A1&!A|!E&D2&!D1&D&C&!B1&B&!A1&!A|!E&!D2&!D1&D&C&!B1&B&!A1&!A|!E&!D2&!D1&D&!C&!B1&B&!A1&!A|!E&D2&!D1&D&!C&!B1&B&!A1&!A|!E&!D2&D1&D&!C&!B1&B&!A1&!A|!E&!D2&D1&!D&!C&!B1&B&!A1&!A|!E&D2&D1&!D&!C&!B1&B&!A1&!A|!E&D2&!D1&!D&!C&!B1&B&!A1&!A|!E&!D2&!D1&!D&!C&!B1&B&!A1&!A|!E&!D2&!D1&!D&!C&!B1&B&A1&!A|!E&D2&!D1&!D&!C&!B1&B&A1&!A|!E&D2&D1&!D&!C&!B1&B&A1&!A|!E&!D2&D1&!D&!C&!B1&B&A1&!A|!E&!D2&D1&D&!C&!B1&B&A1&!A|!E&D2&!D1&D&!C&!B1&B&A1&!A|!E&!D2&!D1&D&!C&!B1&B&A1&!A|!E&!D2&!D1&D&!C&B1&B&A1&!A|!E&D2&!D1&D&!C&B1&B&A1&!A|!E&!D2&D1&D&!C&B1&B&A1&!A|!E&!D2&D1&!D&!C&B1&B&A1&!A|!E&D2&D1&!D&!C&B1&B&A1&!A|!E&D2&!D1&!D&!C&B1&B&A1&!A|!E&!D2&!D1&!D&!C&B1&B&A1&!A|!E&!D2&!D1&!D&!C&B1&!B&A1&!A|!E&D2&!D1&!D&!C&B1&!B&A1&!A|!E&D2&D1&!D&!C&B1&!B&A1&!A|!E&!D2&D1&!D&!C&B1&!B&A1&!A|!E&!D2&D1&D&!C&B1&!B&A1&!A|!E&D2&!D1&D&!C&B1&!B&A1&!A|!E&!D2&!D1&D&!C&B1&!B&A1&!A|!E&!D2&!D1&!D&C&!B1&!B&A1&!A|!E&D2&!D1&!D&C&!B1&!B&A1&!A|!E&D2&D1&!D&C&!B1&!B&A1&!A|!E&!D2&D1&!D&C&!B1&!B&A1&!A|!E&!D2&D1&D&C&!B1&!B&A1&!A|!E&D2&!D1&D&C&!B1&!B&A1&!A|!E&!D2&!D1&D&C&!B1&!B&A1&!A|!E&!D2&!D1&D&!C&!B1&!B&A1&!A|!E&D2&!D1&D&!C&!B1&!B&A1&!A|!E&!D2&D1&D&!C&!B1&!B&A1&!A|!E&!D2&D1&!D&!C&!B1&!B&A1&!A|!E&D2&D1&!D&!C&!B1&!B&A1&!A|!E&D2&!D1&!D&!C&!B1&!B&A1&!A|!E&!D2&!D1&!D&!C&!B1&!B&A1&!A|!E&!D2&!D1&!D&!C&!B1&!B&A1&A|!E&D2&!D1&!D&!C&!B1&!B&A1&A|!E&D2&D1&!D&!C&!B1&!B&A1&A|!E&!D2&D1&!D&!C&!B1&!B&A1&A|!E&!D2&D1&D&!C&!B1&!B&A1&A|!E&D2&!D1&D&!C&!B1&!B&A1&A|!E&!D2&!D1&D&!C&!B1&!B&A1&A|!E&!D2&!D1&D&C&!B1&!B&A1&A|!E&D2&!D1&D&C&!B1&!B&A1&A|!E&!D2&D1&D&C&!B1&!B&A1&A|!E&!D2&D1&!D&C&!B1&!B&A1&A|!E&D2&D1&!D&C&!B1&!B&A1&A|!E&D2&!D1&!D&C&!B1&!B&A1&A|!E&!D2&!D1&!D&C&!B1&!B&A1&A|!E&!D2&!D1&D&!C&B1&!B&A1&A|!E&D2&!D1&D&!C&B1&!B&A1&A|!E&!D2&D1&D&!C&B1&!B&A1&A|!E&!D2&D1&!D&!C&B1&!B&A1&A|!E&D2&D1&!D&!C&B1&!B&A1&A|!E&D2&!D1&!D&!C&B1&!B&A1&A|!E&!D2&!D1&!D&!C&B1&!B&A1&A|!E&!D2&!D1&!D&!C&B1&B&A1&A|!E&D2&!D1&!D&!C&B1&B&A1&A|!E&D2&D1&!D&!C&B1&B&A1&A|!E&!D2&D1&!D&!C&B1&B&A1&A|!E&!D2&D1&D&!C&B1&B&A1&A|!E&D2&!D1&D&!C&B1&B&A1&A|!E&!D2&!D1&D&!C&B1&B&A1&A|!E&!D2&!D1&D&!C&!B1&B&A1&A|!E&D2&!D1&D&!C&!B1&B&A1&A|!E&!D2&D1&D&!C&!B1&B&A1&A|!E&!D2&D1&!D&!C&!B1&B&A1&A|!E&D2&D1&!D&!C&!B1&B&A1&A|!E&D2&!D1&!D&!C&!B1&B&A1&A|!E&!D2&!D1&!D&!C&!B1&B&A1&A|!E&!D2&!D1&!D&!C&!B1&B&!A1&A|!E&D2&!D1&!D&!C&!B1&B&!A1&A|!E&D2&D1&!D&!C&!B1&B&!A1&A|!E&!D2&D1&!D&!C&!B1&B&!A1&A|!E&!D2&D1&D&!C&!B1&B&!A1&A|!E&D2&!D1&D&!C&!B1&B&!A1&A|!E&!D2&!D1&D&!C&!B1&B&!A1&A|!E&!D2&!D1&D&!C&B1&B&!A1&A|!E&D2&!D1&D&!C&B1&B&!A1&A|!E&!D2&D1&D&!C&B1&B&!A1&A|!E&!D2&D1&!D&!C&B1&B&!A1&A|!E&D2&D1&!D&!C&B1&B&!A1&A|!E&D2&!D1&!D&!C&B1&B&!A1&A|!E&!D2&!D1&!D&!C&B1&B&!A1&A|!E&!D2&!D1&!D&!C&B1&!B&!A1&A|!E&D2&!D1&!D&!C&B1&!B&!A1&A|!E&D2&D1&!D&!C&B1&!B&!A1&A|!E&!D2&D1&!D&!C&B1&!B&!A1&A|!E&!D2&D1&D&!C&B1&!B&!A1&A|!E&D2&!D1&D&!C&B1&!B&!A1&A|!E&!D2&!D1&D&!C&B1&!B&!A1&A|!E&!D2&!D1&!D&C&!B1&!B&!A1&A|!E&D2&!D1&!D&C&!B1&!B&!A1&A|!E&D2&D1&!D&C&!B1&!B&!A1&A|!E&!D2&D1&!D&C&!B1&!B&!A1&A|!E&!D2&D1&D&C&!B1&!B&!A1&A|!E&D2&!D1&D&C&!B1&!B&!A1&A|!E&!D2&!D1&D&C&!B1&!B&!A1&A|!E&!D2&!D1&D&!C&!B1&!B&!A1&A|!E&D2&!D1&D&!C&!B1&!B&!A1&A|!E&!D2&D1&D&!C&!B1&!B&!A1&A|!E&!D2&D1&!D&!C&!B1&!B&!A1&A|!E&D2&D1&!D&!C&!B1&!B&!A1&A|!E&D2&!D1&!D&!C&!B1&!B&!A1&A|!E&!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOI22131.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAAOI3332 -l AAAAOI3332 -i D1 D C2 C1 C B2 B1 B A2 A1 A -o Y -f Y=!(D1&D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|D1&D&C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|D1&!D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|D1&D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|D1&D&!C2&C1&C&B2&!B1&!B&!A2&!A1&!A|D1&D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&D&C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|D1&D&C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|D1&D&C2&C1&!C&B2&B1&!B&!A2&!A1&!A|D1&D&!C2&C1&!C&B2&B1&!B&!A2&!A1&!A|D1&D&!C2&C1&C&B2&B1&!B&!A2&!A1&!A|!D1&D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|D1&D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|D1&!D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|!D1&!D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|D1&D&C2&!C1&C&B2&B1&!B&!A2&!A1&!A|D1&D&!C2&!C1&C&B2&B1&!B&!A2&!A1&!A|D1&D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|D1&D&C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|D1&!D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|D1&D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|D1&D&!C2&C1&C&!B2&B1&!B&!A2&!A1&!A|D1&D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&D&C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|D1&D&C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|D1&D&C2&C1&!C&!B2&B1&B&!A2&!A1&!A|D1&D&!C2&C1&!C&!B2&B1&B&!A2&!A1&!A|D1&D&!C2&C1&C&!B2&B1&B&!A2&!A1&!A|!D1&D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|D1&D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|D1&!D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|!D1&!D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|D1&D&C2&!C1&C&!B2&B1&B&!A2&!A1&!A|D1&D&!C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!D1&!D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|D1&!D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|D1&D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|!D1&D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|!D1&D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|D1&D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|D1&!D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|!D1&!D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|!D1&!D&C2&C1&C&B2&B1&B&!A2&!A1&!A|D1&!D&C2&C1&C&B2&B1&B&!A2&!A1&!A|D1&D&C2&C1&C&B2&B1&B&!A2&!A1&!A|!D1&D&C2&C1&C&B2&B1&B&!A2&!A1&!A|!D1&D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|D1&D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|D1&!D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|!D1&!D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|!D1&!D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|D1&!D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|D1&D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|!D1&D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|!D1&D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|D1&D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|D1&!D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|!D1&!D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|!D1&!D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|D1&!D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|D1&D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!D1&D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!D1&D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|D1&D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|D1&!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!D1&!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|D1&D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|D1&D&C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|D1&D&C2&C1&!C&B2&!B1&B&!A2&!A1&!A|D1&D&!C2&C1&!C&B2&!B1&B&!A2&!A1&!A|D1&D&!C2&C1&C&B2&!B1&B&!A2&!A1&!A|!D1&D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|D1&D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|D1&!D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|!D1&!D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|D1&D&C2&!C1&C&B2&!B1&B&!A2&!A1&!A|D1&D&!C2&!C1&C&B2&!B1&B&!A2&!A1&!A|D1&D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|D1&D&C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|D1&!D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|D1&D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|D1&D&!C2&C1&C&!B2&!B1&B&!A2&!A1&!A|D1&D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&D&C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|D1&D&C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|D1&D&C2&C1&!C&!B2&!B1&B&A2&!A1&!A|D1&D&!C2&C1&!C&!B2&!B1&B&A2&!A1&!A|D1&D&!C2&C1&C&!B2&!B1&B&A2&!A1&!A|!D1&D&C2&C1&C&!B2&!B1&B&A2&!A1&!A|D1&D&C2&C1&C&!B2&!B1&B&A2&!A1&!A|D1&!D&C2&C1&C&!B2&!B1&B&A2&!A1&!A|!D1&!D&C2&C1&C&!B2&!B1&B&A2&!A1&!A|D1&D&C2&!C1&C&!B2&!B1&B&A2&!A1&!A|D1&D&!C2&!C1&C&!B2&!B1&B&A2&!A1&!A|D1&D&!C2&!C1&C&B2&!B1&B&A2&!A1&!A|D1&D&C2&!C1&C&B2&!B1&B&A2&!A1&!A|!D1&!D&C2&C1&C&B2&!B1&B&A2&!A1&!A|D1&!D&C2&C1&C&B2&!B1&B&A2&!A1&!A|D1&D&C2&C1&C&B2&!B1&B&A2&!A1&!A|!D1&D&C2&C1&C&B2&!B1&B&A2&!A1&!A|D1&D&!C2&C1&C&B2&!B1&B&A2&!A1&!A|D1&D&!C2&C1&!C&B2&!B1&B&A2&!A1&!A|D1&D&C2&C1&!C&B2&!B1&B&A2&!A1&!A|D1&D&C2&!C1&!C&B2&!B1&B&A2&!A1&!A|D1&D&!C2&!C1&!C&B2&!B1&B&A2&!A1&!A|!D1&!D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|D1&!D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|D1&D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|!D1&D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|!D1&D&C2&!C1&!C&B2&B1&B&A2&!A1&!A|D1&D&C2&!C1&!C&B2&B1&B&A2&!A1&!A|D1&!D&C2&!C1&!C&B2&B1&B&A2&!A1&!A|!D1&!D&C2&!C1&!C&B2&B1&B&A2&!A1&!A|!D1&!D&C2&C1&!C&B2&B1&B&A2&!A1&!A|D1&!D&C2&C1&!C&B2&B1&B&A2&!A1&!A|D1&D&C2&C1&!C&B2&B1&B&A2&!A1&!A|!D1&D&C2&C1&!C&B2&B1&B&A2&!A1&!A|!D1&D&!C2&C1&!C&B2&B1&B&A2&!A1&!A|D1&D&!C2&C1&!C&B2&B1&B&A2&!A1&!A|D1&!D&!C2&C1&!C&B2&B1&B&A2&!A1&!A|!D1&!D&!C2&C1&!C&B2&B1&B&A2&!A1&!A|!D1&!D&!C2&C1&C&B2&B1&B&A2&!A1&!A|D1&!D&!C2&C1&C&B2&B1&B&A2&!A1&!A|D1&D&!C2&C1&C&B2&B1&B&A2&!A1&!A|!D1&D&!C2&C1&C&B2&B1&B&A2&!A1&!A|!D1&D&C2&C1&C&B2&B1&B&A2&!A1&!A|D1&D&C2&C1&C&B2&B1&B&A2&!A1&!A|D1&!D&C2&C1&C&B2&B1&B&A2&!A1&!A|!D1&!D&C2&C1&C&B2&B1&B&A2&!A1&!A|!D1&!D&C2&!C1&C&B2&B1&B&A2&!A1&!A|D1&!D&C2&!C1&C&B2&B1&B&A2&!A1&!A|D1&D&C2&!C1&C&B2&B1&B&A2&!A1&!A|!D1&D&C2&!C1&C&B2&B1&B&A2&!A1&!A|!D1&D&!C2&!C1&C&B2&B1&B&A2&!A1&!A|D1&D&!C2&!C1&C&B2&B1&B&A2&!A1&!A|D1&!D&!C2&!C1&C&B2&B1&B&A2&!A1&!A|!D1&!D&!C2&!C1&C&B2&B1&B&A2&!A1&!A|D1&D&!C2&!C1&C&!B2&B1&B&A2&!A1&!A|D1&D&C2&!C1&C&!B2&B1&B&A2&!A1&!A|!D1&!D&C2&C1&C&!B2&B1&B&A2&!A1&!A|D1&!D&C2&C1&C&!B2&B1&B&A2&!A1&!A|D1&D&C2&C1&C&!B2&B1&B&A2&!A1&!A|!D1&D&C2&C1&C&!B2&B1&B&A2&!A1&!A|D1&D&!C2&C1&C&!B2&B1&B&A2&!A1&!A|D1&D&!C2&C1&!C&!B2&B1&B&A2&!A1&!A|D1&D&C2&C1&!C&!B2&B1&B&A2&!A1&!A|D1&D&C2&!C1&!C&!B2&B1&B&A2&!A1&!A|D1&D&!C2&!C1&!C&!B2&B1&B&A2&!A1&!A|D1&D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|D1&D&C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|D1&D&C2&C1&!C&!B2&B1&!B&A2&!A1&!A|D1&D&!C2&C1&!C&!B2&B1&!B&A2&!A1&!A|D1&D&!C2&C1&C&!B2&B1&!B&A2&!A1&!A|!D1&D&C2&C1&C&!B2&B1&!B&A2&!A1&!A|D1&D&C2&C1&C&!B2&B1&!B&A2&!A1&!A|D1&!D&C2&C1&C&!B2&B1&!B&A2&!A1&!A|!D1&!D&C2&C1&C&!B2&B1&!B&A2&!A1&!A|D1&D&C2&!C1&C&!B2&B1&!B&A2&!A1&!A|D1&D&!C2&!C1&C&!B2&B1&!B&A2&!A1&!A|D1&D&!C2&!C1&C&B2&B1&!B&A2&!A1&!A|D1&D&C2&!C1&C&B2&B1&!B&A2&!A1&!A|!D1&!D&C2&C1&C&B2&B1&!B&A2&!A1&!A|D1&!D&C2&C1&C&B2&B1&!B&A2&!A1&!A|D1&D&C2&C1&C&B2&B1&!B&A2&!A1&!A|!D1&D&C2&C1&C&B2&B1&!B&A2&!A1&!A|D1&D&!C2&C1&C&B2&B1&!B&A2&!A1&!A|D1&D&!C2&C1&!C&B2&B1&!B&A2&!A1&!A|D1&D&C2&C1&!C&B2&B1&!B&A2&!A1&!A|D1&D&C2&!C1&!C&B2&B1&!B&A2&!A1&!A|D1&D&!C2&!C1&!C&B2&B1&!B&A2&!A1&!A|D1&D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|D1&D&C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|D1&D&C2&C1&!C&B2&!B1&!B&A2&!A1&!A|D1&D&!C2&C1&!C&B2&!B1&!B&A2&!A1&!A|D1&D&!C2&C1&C&B2&!B1&!B&A2&!A1&!A|!D1&D&C2&C1&C&B2&!B1&!B&A2&!A1&!A|D1&D&C2&C1&C&B2&!B1&!B&A2&!A1&!A|D1&!D&C2&C1&C&B2&!B1&!B&A2&!A1&!A|!D1&!D&C2&C1&C&B2&!B1&!B&A2&!A1&!A|D1&D&C2&!C1&C&B2&!B1&!B&A2&!A1&!A|D1&D&!C2&!C1&C&B2&!B1&!B&A2&!A1&!A|D1&D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|D1&D&C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|D1&!D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|D1&D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|D1&D&!C2&C1&C&!B2&!B1&!B&A2&!A1&!A|D1&D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&D&C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|D1&D&C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|D1&D&C2&C1&!C&!B2&!B1&!B&A2&A1&!A|D1&D&!C2&C1&!C&!B2&!B1&!B&A2&A1&!A|D1&D&!C2&C1&C&!B2&!B1&!B&A2&A1&!A|!D1&D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|D1&D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|D1&!D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|!D1&!D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|D1&D&C2&!C1&C&!B2&!B1&!B&A2&A1&!A|D1&D&!C2&!C1&C&!B2&!B1&!B&A2&A1&!A|D1&D&!C2&!C1&C&B2&!B1&!B&A2&A1&!A|D1&D&C2&!C1&C&B2&!B1&!B&A2&A1&!A|!D1&!D&C2&C1&C&B2&!B1&!B&A2&A1&!A|D1&!D&C2&C1&C&B2&!B1&!B&A2&A1&!A|D1&D&C2&C1&C&B2&!B1&!B&A2&A1&!A|!D1&D&C2&C1&C&B2&!B1&!B&A2&A1&!A|D1&D&!C2&C1&C&B2&!B1&!B&A2&A1&!A|D1&D&!C2&C1&!C&B2&!B1&!B&A2&A1&!A|D1&D&C2&C1&!C&B2&!B1&!B&A2&A1&!A|D1&D&C2&!C1&!C&B2&!B1&!B&A2&A1&!A|D1&D&!C2&!C1&!C&B2&!B1&!B&A2&A1&!A|D1&D&!C2&!C1&!C&B2&B1&!B&A2&A1&!A|D1&D&C2&!C1&!C&B2&B1&!B&A2&A1&!A|D1&D&C2&C1&!C&B2&B1&!B&A2&A1&!A|D1&D&!C2&C1&!C&B2&B1&!B&A2&A1&!A|D1&D&!C2&C1&C&B2&B1&!B&A2&A1&!A|!D1&D&C2&C1&C&B2&B1&!B&A2&A1&!A|D1&D&C2&C1&C&B2&B1&!B&A2&A1&!A|D1&!D&C2&C1&C&B2&B1&!B&A2&A1&!A|!D1&!D&C2&C1&C&B2&B1&!B&A2&A1&!A|D1&D&C2&!C1&C&B2&B1&!B&A2&A1&!A|D1&D&!C2&!C1&C&B2&B1&!B&A2&A1&!A|D1&D&!C2&!C1&C&!B2&B1&!B&A2&A1&!A|D1&D&C2&!C1&C&!B2&B1&!B&A2&A1&!A|!D1&!D&C2&C1&C&!B2&B1&!B&A2&A1&!A|D1&!D&C2&C1&C&!B2&B1&!B&A2&A1&!A|D1&D&C2&C1&C&!B2&B1&!B&A2&A1&!A|!D1&D&C2&C1&C&!B2&B1&!B&A2&A1&!A|D1&D&!C2&C1&C&!B2&B1&!B&A2&A1&!A|D1&D&!C2&C1&!C&!B2&B1&!B&A2&A1&!A|D1&D&C2&C1&!C&!B2&B1&!B&A2&A1&!A|D1&D&C2&!C1&!C&!B2&B1&!B&A2&A1&!A|D1&D&!C2&!C1&!C&!B2&B1&!B&A2&A1&!A|D1&D&!C2&!C1&!C&!B2&B1&B&A2&A1&!A|D1&D&C2&!C1&!C&!B2&B1&B&A2&A1&!A|D1&D&C2&C1&!C&!B2&B1&B&A2&A1&!A|D1&D&!C2&C1&!C&!B2&B1&B&A2&A1&!A|D1&D&!C2&C1&C&!B2&B1&B&A2&A1&!A|!D1&D&C2&C1&C&!B2&B1&B&A2&A1&!A|D1&D&C2&C1&C&!B2&B1&B&A2&A1&!A|D1&!D&C2&C1&C&!B2&B1&B&A2&A1&!A|!D1&!D&C2&C1&C&!B2&B1&B&A2&A1&!A|D1&D&C2&!C1&C&!B2&B1&B&A2&A1&!A|D1&D&!C2&!C1&C&!B2&B1&B&A2&A1&!A|!D1&!D&!C2&!C1&C&B2&B1&B&A2&A1&!A|D1&!D&!C2&!C1&C&B2&B1&B&A2&A1&!A|D1&D&!C2&!C1&C&B2&B1&B&A2&A1&!A|!D1&D&!C2&!C1&C&B2&B1&B&A2&A1&!A|!D1&D&C2&!C1&C&B2&B1&B&A2&A1&!A|D1&D&C2&!C1&C&B2&B1&B&A2&A1&!A|D1&!D&C2&!C1&C&B2&B1&B&A2&A1&!A|!D1&!D&C2&!C1&C&B2&B1&B&A2&A1&!A|!D1&!D&C2&C1&C&B2&B1&B&A2&A1&!A|D1&!D&C2&C1&C&B2&B1&B&A2&A1&!A|D1&D&C2&C1&C&B2&B1&B&A2&A1&!A|!D1&D&C2&C1&C&B2&B1&B&A2&A1&!A|!D1&D&!C2&C1&C&B2&B1&B&A2&A1&!A|D1&D&!C2&C1&C&B2&B1&B&A2&A1&!A|D1&!D&!C2&C1&C&B2&B1&B&A2&A1&!A|!D1&!D&!C2&C1&C&B2&B1&B&A2&A1&!A|!D1&!D&!C2&C1&!C&B2&B1&B&A2&A1&!A|D1&!D&!C2&C1&!C&B2&B1&B&A2&A1&!A|D1&D&!C2&C1&!C&B2&B1&B&A2&A1&!A|!D1&D&!C2&C1&!C&B2&B1&B&A2&A1&!A|!D1&D&C2&C1&!C&B2&B1&B&A2&A1&!A|D1&D&C2&C1&!C&B2&B1&B&A2&A1&!A|D1&!D&C2&C1&!C&B2&B1&B&A2&A1&!A|!D1&!D&C2&C1&!C&B2&B1&B&A2&A1&!A|!D1&!D&C2&!C1&!C&B2&B1&B&A2&A1&!A|D1&!D&C2&!C1&!C&B2&B1&B&A2&A1&!A|D1&D&C2&!C1&!C&B2&B1&B&A2&A1&!A|!D1&D&C2&!C1&!C&B2&B1&B&A2&A1&!A|!D1&D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|D1&D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|D1&!D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|!D1&!D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|D1&D&!C2&!C1&!C&B2&!B1&B&A2&A1&!A|D1&D&C2&!C1&!C&B2&!B1&B&A2&A1&!A|D1&D&C2&C1&!C&B2&!B1&B&A2&A1&!A|D1&D&!C2&C1&!C&B2&!B1&B&A2&A1&!A|D1&D&!C2&C1&C&B2&!B1&B&A2&A1&!A|!D1&D&C2&C1&C&B2&!B1&B&A2&A1&!A|D1&D&C2&C1&C&B2&!B1&B&A2&A1&!A|D1&!D&C2&C1&C&B2&!B1&B&A2&A1&!A|!D1&!D&C2&C1&C&B2&!B1&B&A2&A1&!A|D1&D&C2&!C1&C&B2&!B1&B&A2&A1&!A|D1&D&!C2&!C1&C&B2&!B1&B&A2&A1&!A|D1&D&!C2&!C1&C&!B2&!B1&B&A2&A1&!A|D1&D&C2&!C1&C&!B2&!B1&B&A2&A1&!A|!D1&!D&C2&C1&C&!B2&!B1&B&A2&A1&!A|D1&!D&C2&C1&C&!B2&!B1&B&A2&A1&!A|D1&D&C2&C1&C&!B2&!B1&B&A2&A1&!A|!D1&D&C2&C1&C&!B2&!B1&B&A2&A1&!A|D1&D&!C2&C1&C&!B2&!B1&B&A2&A1&!A|D1&D&!C2&C1&!C&!B2&!B1&B&A2&A1&!A|D1&D&C2&C1&!C&!B2&!B1&B&A2&A1&!A|D1&D&C2&!C1&!C&!B2&!B1&B&A2&A1&!A|D1&D&!C2&!C1&!C&!B2&!B1&B&A2&A1&!A|D1&D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|D1&D&C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|D1&D&C2&C1&!C&!B2&!B1&B&!A2&A1&!A|D1&D&!C2&C1&!C&!B2&!B1&B&!A2&A1&!A|D1&D&!C2&C1&C&!B2&!B1&B&!A2&A1&!A|!D1&D&C2&C1&C&!B2&!B1&B&!A2&A1&!A|D1&D&C2&C1&C&!B2&!B1&B&!A2&A1&!A|D1&!D&C2&C1&C&!B2&!B1&B&!A2&A1&!A|!D1&!D&C2&C1&C&!B2&!B1&B&!A2&A1&!A|D1&D&C2&!C1&C&!B2&!B1&B&!A2&A1&!A|D1&D&!C2&!C1&C&!B2&!B1&B&!A2&A1&!A|D1&D&!C2&!C1&C&B2&!B1&B&!A2&A1&!A|D1&D&C2&!C1&C&B2&!B1&B&!A2&A1&!A|!D1&!D&C2&C1&C&B2&!B1&B&!A2&A1&!A|D1&!D&C2&C1&C&B2&!B1&B&!A2&A1&!A|D1&D&C2&C1&C&B2&!B1&B&!A2&A1&!A|!D1&D&C2&C1&C&B2&!B1&B&!A2&A1&!A|D1&D&!C2&C1&C&B2&!B1&B&!A2&A1&!A|D1&D&!C2&C1&!C&B2&!B1&B&!A2&A1&!A|D1&D&C2&C1&!C&B2&!B1&B&!A2&A1&!A|D1&D&C2&!C1&!C&B2&!B1&B&!A2&A1&!A|D1&D&!C2&!C1&!C&B2&!B1&B&!A2&A1&!A|!D1&!D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|D1&!D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|D1&D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|!D1&D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|!D1&D&C2&!C1&!C&B2&B1&B&!A2&A1&!A|D1&D&C2&!C1&!C&B2&B1&B&!A2&A1&!A|D1&!D&C2&!C1&!C&B2&B1&B&!A2&A1&!A|!D1&!D&C2&!C1&!C&B2&B1&B&!A2&A1&!A|!D1&!D&C2&C1&!C&B2&B1&B&!A2&A1&!A|D1&!D&C2&C1&!C&B2&B1&B&!A2&A1&!A|D1&D&C2&C1&!C&B2&B1&B&!A2&A1&!A|!D1&D&C2&C1&!C&B2&B1&B&!A2&A1&!A|!D1&D&!C2&C1&!C&B2&B1&B&!A2&A1&!A|D1&D&!C2&C1&!C&B2&B1&B&!A2&A1&!A|D1&!D&!C2&C1&!C&B2&B1&B&!A2&A1&!A|!D1&!D&!C2&C1&!C&B2&B1&B&!A2&A1&!A|!D1&!D&!C2&C1&C&B2&B1&B&!A2&A1&!A|D1&!D&!C2&C1&C&B2&B1&B&!A2&A1&!A|D1&D&!C2&C1&C&B2&B1&B&!A2&A1&!A|!D1&D&!C2&C1&C&B2&B1&B&!A2&A1&!A|!D1&D&C2&C1&C&B2&B1&B&!A2&A1&!A|D1&D&C2&C1&C&B2&B1&B&!A2&A1&!A|D1&!D&C2&C1&C&B2&B1&B&!A2&A1&!A|!D1&!D&C2&C1&C&B2&B1&B&!A2&A1&!A|!D1&!D&C2&!C1&C&B2&B1&B&!A2&A1&!A|D1&!D&C2&!C1&C&B2&B1&B&!A2&A1&!A|D1&D&C2&!C1&C&B2&B1&B&!A2&A1&!A|!D1&D&C2&!C1&C&B2&B1&B&!A2&A1&!A|!D1&D&!C2&!C1&C&B2&B1&B&!A2&A1&!A|D1&D&!C2&!C1&C&B2&B1&B&!A2&A1&!A|D1&!D&!C2&!C1&C&B2&B1&B&!A2&A1&!A|!D1&!D&!C2&!C1&C&B2&B1&B&!A2&A1&!A|D1&D&!C2&!C1&C&!B2&B1&B&!A2&A1&!A|D1&D&C2&!C1&C&!B2&B1&B&!A2&A1&!A|!D1&!D&C2&C1&C&!B2&B1&B&!A2&A1&!A|D1&!D&C2&C1&C&!B2&B1&B&!A2&A1&!A|D1&D&C2&C1&C&!B2&B1&B&!A2&A1&!A|!D1&D&C2&C1&C&!B2&B1&B&!A2&A1&!A|D1&D&!C2&C1&C&!B2&B1&B&!A2&A1&!A|D1&D&!C2&C1&!C&!B2&B1&B&!A2&A1&!A|D1&D&C2&C1&!C&!B2&B1&B&!A2&A1&!A|D1&D&C2&!C1&!C&!B2&B1&B&!A2&A1&!A|D1&D&!C2&!C1&!C&!B2&B1&B&!A2&A1&!A|D1&D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|D1&D&C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|D1&D&C2&C1&!C&!B2&B1&!B&!A2&A1&!A|D1&D&!C2&C1&!C&!B2&B1&!B&!A2&A1&!A|D1&D&!C2&C1&C&!B2&B1&!B&!A2&A1&!A|!D1&D&C2&C1&C&!B2&B1&!B&!A2&A1&!A|D1&D&C2&C1&C&!B2&B1&!B&!A2&A1&!A|D1&!D&C2&C1&C&!B2&B1&!B&!A2&A1&!A|!D1&!D&C2&C1&C&!B2&B1&!B&!A2&A1&!A|D1&D&C2&!C1&C&!B2&B1&!B&!A2&A1&!A|D1&D&!C2&!C1&C&!B2&B1&!B&!A2&A1&!A|D1&D&!C2&!C1&C&B2&B1&!B&!A2&A1&!A|D1&D&C2&!C1&C&B2&B1&!B&!A2&A1&!A|!D1&!D&C2&C1&C&B2&B1&!B&!A2&A1&!A|D1&!D&C2&C1&C&B2&B1&!B&!A2&A1&!A|D1&D&C2&C1&C&B2&B1&!B&!A2&A1&!A|!D1&D&C2&C1&C&B2&B1&!B&!A2&A1&!A|D1&D&!C2&C1&C&B2&B1&!B&!A2&A1&!A|D1&D&!C2&C1&!C&B2&B1&!B&!A2&A1&!A|D1&D&C2&C1&!C&B2&B1&!B&!A2&A1&!A|D1&D&C2&!C1&!C&B2&B1&!B&!A2&A1&!A|D1&D&!C2&!C1&!C&B2&B1&!B&!A2&A1&!A|D1&D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|D1&D&C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|D1&D&C2&C1&!C&B2&!B1&!B&!A2&A1&!A|D1&D&!C2&C1&!C&B2&!B1&!B&!A2&A1&!A|D1&D&!C2&C1&C&B2&!B1&!B&!A2&A1&!A|!D1&D&C2&C1&C&B2&!B1&!B&!A2&A1&!A|D1&D&C2&C1&C&B2&!B1&!B&!A2&A1&!A|D1&!D&C2&C1&C&B2&!B1&!B&!A2&A1&!A|!D1&!D&C2&C1&C&B2&!B1&!B&!A2&A1&!A|D1&D&C2&!C1&C&B2&!B1&!B&!A2&A1&!A|D1&D&!C2&!C1&C&B2&!B1&!B&!A2&A1&!A|D1&D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|D1&D&C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|D1&!D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|D1&D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|D1&D&!C2&C1&C&!B2&!B1&!B&!A2&A1&!A|D1&D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&D&C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|D1&D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|D1&D&C2&C1&!C&!B2&!B1&!B&!A2&A1&A|D1&D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&A|D1&D&!C2&C1&C&!B2&!B1&!B&!A2&A1&A|!D1&D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|D1&D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|D1&!D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|!D1&!D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|D1&D&C2&!C1&C&!B2&!B1&!B&!A2&A1&A|D1&D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&A|D1&D&!C2&!C1&C&B2&!B1&!B&!A2&A1&A|D1&D&C2&!C1&C&B2&!B1&!B&!A2&A1&A|!D1&!D&C2&C1&C&B2&!B1&!B&!A2&A1&A|D1&!D&C2&C1&C&B2&!B1&!B&!A2&A1&A|D1&D&C2&C1&C&B2&!B1&!B&!A2&A1&A|!D1&D&C2&C1&C&B2&!B1&!B&!A2&A1&A|D1&D&!C2&C1&C&B2&!B1&!B&!A2&A1&A|D1&D&!C2&C1&!C&B2&!B1&!B&!A2&A1&A|D1&D&C2&C1&!C&B2&!B1&!B&!A2&A1&A|D1&D&C2&!C1&!C&B2&!B1&!B&!A2&A1&A|D1&D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&A|D1&D&!C2&!C1&!C&B2&B1&!B&!A2&A1&A|D1&D&C2&!C1&!C&B2&B1&!B&!A2&A1&A|D1&D&C2&C1&!C&B2&B1&!B&!A2&A1&A|D1&D&!C2&C1&!C&B2&B1&!B&!A2&A1&A|D1&D&!C2&C1&C&B2&B1&!B&!A2&A1&A|!D1&D&C2&C1&C&B2&B1&!B&!A2&A1&A|D1&D&C2&C1&C&B2&B1&!B&!A2&A1&A|D1&!D&C2&C1&C&B2&B1&!B&!A2&A1&A|!D1&!D&C2&C1&C&B2&B1&!B&!A2&A1&A|D1&D&C2&!C1&C&B2&B1&!B&!A2&A1&A|D1&D&!C2&!C1&C&B2&B1&!B&!A2&A1&A|D1&D&!C2&!C1&C&!B2&B1&!B&!A2&A1&A|D1&D&C2&!C1&C&!B2&B1&!B&!A2&A1&A|!D1&!D&C2&C1&C&!B2&B1&!B&!A2&A1&A|D1&!D&C2&C1&C&!B2&B1&!B&!A2&A1&A|D1&D&C2&C1&C&!B2&B1&!B&!A2&A1&A|!D1&D&C2&C1&C&!B2&B1&!B&!A2&A1&A|D1&D&!C2&C1&C&!B2&B1&!B&!A2&A1&A|D1&D&!C2&C1&!C&!B2&B1&!B&!A2&A1&A|D1&D&C2&C1&!C&!B2&B1&!B&!A2&A1&A|D1&D&C2&!C1&!C&!B2&B1&!B&!A2&A1&A|D1&D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&A|D1&D&!C2&!C1&!C&!B2&B1&B&!A2&A1&A|D1&D&C2&!C1&!C&!B2&B1&B&!A2&A1&A|D1&D&C2&C1&!C&!B2&B1&B&!A2&A1&A|D1&D&!C2&C1&!C&!B2&B1&B&!A2&A1&A|D1&D&!C2&C1&C&!B2&B1&B&!A2&A1&A|!D1&D&C2&C1&C&!B2&B1&B&!A2&A1&A|D1&D&C2&C1&C&!B2&B1&B&!A2&A1&A|D1&!D&C2&C1&C&!B2&B1&B&!A2&A1&A|!D1&!D&C2&C1&C&!B2&B1&B&!A2&A1&A|D1&D&C2&!C1&C&!B2&B1&B&!A2&A1&A|D1&D&!C2&!C1&C&!B2&B1&B&!A2&A1&A|!D1&!D&!C2&!C1&C&B2&B1&B&!A2&A1&A|D1&!D&!C2&!C1&C&B2&B1&B&!A2&A1&A|D1&D&!C2&!C1&C&B2&B1&B&!A2&A1&A|!D1&D&!C2&!C1&C&B2&B1&B&!A2&A1&A|!D1&D&C2&!C1&C&B2&B1&B&!A2&A1&A|D1&D&C2&!C1&C&B2&B1&B&!A2&A1&A|D1&!D&C2&!C1&C&B2&B1&B&!A2&A1&A|!D1&!D&C2&!C1&C&B2&B1&B&!A2&A1&A|!D1&!D&C2&C1&C&B2&B1&B&!A2&A1&A|D1&!D&C2&C1&C&B2&B1&B&!A2&A1&A|D1&D&C2&C1&C&B2&B1&B&!A2&A1&A|!D1&D&C2&C1&C&B2&B1&B&!A2&A1&A|!D1&D&!C2&C1&C&B2&B1&B&!A2&A1&A|D1&D&!C2&C1&C&B2&B1&B&!A2&A1&A|D1&!D&!C2&C1&C&B2&B1&B&!A2&A1&A|!D1&!D&!C2&C1&C&B2&B1&B&!A2&A1&A|!D1&!D&!C2&C1&!C&B2&B1&B&!A2&A1&A|D1&!D&!C2&C1&!C&B2&B1&B&!A2&A1&A|D1&D&!C2&C1&!C&B2&B1&B&!A2&A1&A|!D1&D&!C2&C1&!C&B2&B1&B&!A2&A1&A|!D1&D&C2&C1&!C&B2&B1&B&!A2&A1&A|D1&D&C2&C1&!C&B2&B1&B&!A2&A1&A|D1&!D&C2&C1&!C&B2&B1&B&!A2&A1&A|!D1&!D&C2&C1&!C&B2&B1&B&!A2&A1&A|!D1&!D&C2&!C1&!C&B2&B1&B&!A2&A1&A|D1&!D&C2&!C1&!C&B2&B1&B&!A2&A1&A|D1&D&C2&!C1&!C&B2&B1&B&!A2&A1&A|!D1&D&C2&!C1&!C&B2&B1&B&!A2&A1&A|!D1&D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|D1&D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|D1&!D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|!D1&!D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|D1&D&!C2&!C1&!C&B2&!B1&B&!A2&A1&A|D1&D&C2&!C1&!C&B2&!B1&B&!A2&A1&A|D1&D&C2&C1&!C&B2&!B1&B&!A2&A1&A|D1&D&!C2&C1&!C&B2&!B1&B&!A2&A1&A|D1&D&!C2&C1&C&B2&!B1&B&!A2&A1&A|!D1&D&C2&C1&C&B2&!B1&B&!A2&A1&A|D1&D&C2&C1&C&B2&!B1&B&!A2&A1&A|D1&!D&C2&C1&C&B2&!B1&B&!A2&A1&A|!D1&!D&C2&C1&C&B2&!B1&B&!A2&A1&A|D1&D&C2&!C1&C&B2&!B1&B&!A2&A1&A|D1&D&!C2&!C1&C&B2&!B1&B&!A2&A1&A|D1&D&!C2&!C1&C&!B2&!B1&B&!A2&A1&A|D1&D&C2&!C1&C&!B2&!B1&B&!A2&A1&A|!D1&!D&C2&C1&C&!B2&!B1&B&!A2&A1&A|D1&!D&C2&C1&C&!B2&!B1&B&!A2&A1&A|D1&D&C2&C1&C&!B2&!B1&B&!A2&A1&A|!D1&D&C2&C1&C&!B2&!B1&B&!A2&A1&A|D1&D&!C2&C1&C&!B2&!B1&B&!A2&A1&A|D1&D&!C2&C1&!C&!B2&!B1&B&!A2&A1&A|D1&D&C2&C1&!C&!B2&!B1&B&!A2&A1&A|D1&D&C2&!C1&!C&!B2&!B1&B&!A2&A1&A|D1&D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&A|!D1&!D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|D1&!D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|D1&D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|!D1&D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|!D1&D&C2&!C1&!C&!B2&!B1&B&A2&A1&A|D1&D&C2&!C1&!C&!B2&!B1&B&A2&A1&A|D1&!D&C2&!C1&!C&!B2&!B1&B&A2&A1&A|!D1&!D&C2&!C1&!C&!B2&!B1&B&A2&A1&A|!D1&!D&C2&C1&!C&!B2&!B1&B&A2&A1&A|D1&!D&C2&C1&!C&!B2&!B1&B&A2&A1&A|D1&D&C2&C1&!C&!B2&!B1&B&A2&A1&A|!D1&D&C2&C1&!C&!B2&!B1&B&A2&A1&A|!D1&D&!C2&C1&!C&!B2&!B1&B&A2&A1&A|D1&D&!C2&C1&!C&!B2&!B1&B&A2&A1&A|D1&!D&!C2&C1&!C&!B2&!B1&B&A2&A1&A|!D1&!D&!C2&C1&!C&!B2&!B1&B&A2&A1&A|!D1&!D&!C2&C1&C&!B2&!B1&B&A2&A1&A|D1&!D&!C2&C1&C&!B2&!B1&B&A2&A1&A|D1&D&!C2&C1&C&!B2&!B1&B&A2&A1&A|!D1&D&!C2&C1&C&!B2&!B1&B&A2&A1&A|!D1&D&C2&C1&C&!B2&!B1&B&A2&A1&A|D1&D&C2&C1&C&!B2&!B1&B&A2&A1&A|D1&!D&C2&C1&C&!B2&!B1&B&A2&A1&A|!D1&!D&C2&C1&C&!B2&!B1&B&A2&A1&A|!D1&!D&C2&!C1&C&!B2&!B1&B&A2&A1&A|D1&!D&C2&!C1&C&!B2&!B1&B&A2&A1&A|D1&D&C2&!C1&C&!B2&!B1&B&A2&A1&A|!D1&D&C2&!C1&C&!B2&!B1&B&A2&A1&A|!D1&D&!C2&!C1&C&!B2&!B1&B&A2&A1&A|D1&D&!C2&!C1&C&!B2&!B1&B&A2&A1&A|D1&!D&!C2&!C1&C&!B2&!B1&B&A2&A1&A|!D1&!D&!C2&!C1&C&!B2&!B1&B&A2&A1&A|!D1&!D&!C2&!C1&C&B2&!B1&B&A2&A1&A|D1&!D&!C2&!C1&C&B2&!B1&B&A2&A1&A|D1&D&!C2&!C1&C&B2&!B1&B&A2&A1&A|!D1&D&!C2&!C1&C&B2&!B1&B&A2&A1&A|!D1&D&C2&!C1&C&B2&!B1&B&A2&A1&A|D1&D&C2&!C1&C&B2&!B1&B&A2&A1&A|D1&!D&C2&!C1&C&B2&!B1&B&A2&A1&A|!D1&!D&C2&!C1&C&B2&!B1&B&A2&A1&A|!D1&!D&C2&C1&C&B2&!B1&B&A2&A1&A|D1&!D&C2&C1&C&B2&!B1&B&A2&A1&A|D1&D&C2&C1&C&B2&!B1&B&A2&A1&A|!D1&D&C2&C1&C&B2&!B1&B&A2&A1&A|!D1&D&!C2&C1&C&B2&!B1&B&A2&A1&A|D1&D&!C2&C1&C&B2&!B1&B&A2&A1&A|D1&!D&!C2&C1&C&B2&!B1&B&A2&A1&A|!D1&!D&!C2&C1&C&B2&!B1&B&A2&A1&A|!D1&!D&!C2&C1&!C&B2&!B1&B&A2&A1&A|D1&!D&!C2&C1&!C&B2&!B1&B&A2&A1&A|D1&D&!C2&C1&!C&B2&!B1&B&A2&A1&A|!D1&D&!C2&C1&!C&B2&!B1&B&A2&A1&A|!D1&D&C2&C1&!C&B2&!B1&B&A2&A1&A|D1&D&C2&C1&!C&B2&!B1&B&A2&A1&A|D1&!D&C2&C1&!C&B2&!B1&B&A2&A1&A|!D1&!D&C2&C1&!C&B2&!B1&B&A2&A1&A|!D1&!D&C2&!C1&!C&B2&!B1&B&A2&A1&A|D1&!D&C2&!C1&!C&B2&!B1&B&A2&A1&A|D1&D&C2&!C1&!C&B2&!B1&B&A2&A1&A|!D1&D&C2&!C1&!C&B2&!B1&B&A2&A1&A|!D1&D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|D1&D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|D1&!D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|!D1&!D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|!D1&!D&!C2&!C1&!C&B2&B1&B&A2&A1&A|D1&!D&!C2&!C1&!C&B2&B1&B&A2&A1&A|D1&D&!C2&!C1&!C&B2&B1&B&A2&A1&A|!D1&D&!C2&!C1&!C&B2&B1&B&A2&A1&A|!D1&D&C2&!C1&!C&B2&B1&B&A2&A1&A|D1&D&C2&!C1&!C&B2&B1&B&A2&A1&A|D1&!D&C2&!C1&!C&B2&B1&B&A2&A1&A|!D1&!D&C2&!C1&!C&B2&B1&B&A2&A1&A|!D1&!D&C2&C1&!C&B2&B1&B&A2&A1&A|D1&!D&C2&C1&!C&B2&B1&B&A2&A1&A|D1&D&C2&C1&!C&B2&B1&B&A2&A1&A|!D1&D&C2&C1&!C&B2&B1&B&A2&A1&A|!D1&D&!C2&C1&!C&B2&B1&B&A2&A1&A|D1&D&!C2&C1&!C&B2&B1&B&A2&A1&A|D1&!D&!C2&C1&!C&B2&B1&B&A2&A1&A|!D1&!D&!C2&C1&!C&B2&B1&B&A2&A1&A|!D1&!D&!C2&C1&C&B2&B1&B&A2&A1&A|D1&!D&!C2&C1&C&B2&B1&B&A2&A1&A|D1&D&!C2&C1&C&B2&B1&B&A2&A1&A|!D1&D&!C2&C1&C&B2&B1&B&A2&A1&A|!D1&D&C2&C1&C&B2&B1&B&A2&A1&A|D1&D&C2&C1&C&B2&B1&B&A2&A1&A|D1&!D&C2&C1&C&B2&B1&B&A2&A1&A|!D1&!D&C2&C1&C&B2&B1&B&A2&A1&A|!D1&!D&C2&!C1&C&B2&B1&B&A2&A1&A|D1&!D&C2&!C1&C&B2&B1&B&A2&A1&A|D1&D&C2&!C1&C&B2&B1&B&A2&A1&A|!D1&D&C2&!C1&C&B2&B1&B&A2&A1&A|!D1&D&!C2&!C1&C&B2&B1&B&A2&A1&A|D1&D&!C2&!C1&C&B2&B1&B&A2&A1&A|D1&!D&!C2&!C1&C&B2&B1&B&A2&A1&A|!D1&!D&!C2&!C1&C&B2&B1&B&A2&A1&A|!D1&!D&!C2&!C1&C&!B2&B1&B&A2&A1&A|D1&!D&!C2&!C1&C&!B2&B1&B&A2&A1&A|D1&D&!C2&!C1&C&!B2&B1&B&A2&A1&A|!D1&D&!C2&!C1&C&!B2&B1&B&A2&A1&A|!D1&D&C2&!C1&C&!B2&B1&B&A2&A1&A|D1&D&C2&!C1&C&!B2&B1&B&A2&A1&A|D1&!D&C2&!C1&C&!B2&B1&B&A2&A1&A|!D1&!D&C2&!C1&C&!B2&B1&B&A2&A1&A|!D1&!D&C2&C1&C&!B2&B1&B&A2&A1&A|D1&!D&C2&C1&C&!B2&B1&B&A2&A1&A|D1&D&C2&C1&C&!B2&B1&B&A2&A1&A|!D1&D&C2&C1&C&!B2&B1&B&A2&A1&A|!D1&D&!C2&C1&C&!B2&B1&B&A2&A1&A|D1&D&!C2&C1&C&!B2&B1&B&A2&A1&A|D1&!D&!C2&C1&C&!B2&B1&B&A2&A1&A|!D1&!D&!C2&C1&C&!B2&B1&B&A2&A1&A|!D1&!D&!C2&C1&!C&!B2&B1&B&A2&A1&A|D1&!D&!C2&C1&!C&!B2&B1&B&A2&A1&A|D1&D&!C2&C1&!C&!B2&B1&B&A2&A1&A|!D1&D&!C2&C1&!C&!B2&B1&B&A2&A1&A|!D1&D&C2&C1&!C&!B2&B1&B&A2&A1&A|D1&D&C2&C1&!C&!B2&B1&B&A2&A1&A|D1&!D&C2&C1&!C&!B2&B1&B&A2&A1&A|!D1&!D&C2&C1&!C&!B2&B1&B&A2&A1&A|!D1&!D&C2&!C1&!C&!B2&B1&B&A2&A1&A|D1&!D&C2&!C1&!C&!B2&B1&B&A2&A1&A|D1&D&C2&!C1&!C&!B2&B1&B&A2&A1&A|!D1&D&C2&!C1&!C&!B2&B1&B&A2&A1&A|!D1&D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|D1&D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|D1&!D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|!D1&!D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|!D1&!D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|D1&!D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|D1&D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|!D1&D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|!D1&D&C2&!C1&!C&!B2&B1&!B&A2&A1&A|D1&D&C2&!C1&!C&!B2&B1&!B&A2&A1&A|D1&!D&C2&!C1&!C&!B2&B1&!B&A2&A1&A|!D1&!D&C2&!C1&!C&!B2&B1&!B&A2&A1&A|!D1&!D&C2&C1&!C&!B2&B1&!B&A2&A1&A|D1&!D&C2&C1&!C&!B2&B1&!B&A2&A1&A|D1&D&C2&C1&!C&!B2&B1&!B&A2&A1&A|!D1&D&C2&C1&!C&!B2&B1&!B&A2&A1&A|!D1&D&!C2&C1&!C&!B2&B1&!B&A2&A1&A|D1&D&!C2&C1&!C&!B2&B1&!B&A2&A1&A|D1&!D&!C2&C1&!C&!B2&B1&!B&A2&A1&A|!D1&!D&!C2&C1&!C&!B2&B1&!B&A2&A1&A|!D1&!D&!C2&C1&C&!B2&B1&!B&A2&A1&A|D1&!D&!C2&C1&C&!B2&B1&!B&A2&A1&A|D1&D&!C2&C1&C&!B2&B1&!B&A2&A1&A|!D1&D&!C2&C1&C&!B2&B1&!B&A2&A1&A|!D1&D&C2&C1&C&!B2&B1&!B&A2&A1&A|D1&D&C2&C1&C&!B2&B1&!B&A2&A1&A|D1&!D&C2&C1&C&!B2&B1&!B&A2&A1&A|!D1&!D&C2&C1&C&!B2&B1&!B&A2&A1&A|!D1&!D&C2&!C1&C&!B2&B1&!B&A2&A1&A|D1&!D&C2&!C1&C&!B2&B1&!B&A2&A1&A|D1&D&C2&!C1&C&!B2&B1&!B&A2&A1&A|!D1&D&C2&!C1&C&!B2&B1&!B&A2&A1&A|!D1&D&!C2&!C1&C&!B2&B1&!B&A2&A1&A|D1&D&!C2&!C1&C&!B2&B1&!B&A2&A1&A|D1&!D&!C2&!C1&C&!B2&B1&!B&A2&A1&A|!D1&!D&!C2&!C1&C&!B2&B1&!B&A2&A1&A|!D1&!D&!C2&!C1&C&B2&B1&!B&A2&A1&A|D1&!D&!C2&!C1&C&B2&B1&!B&A2&A1&A|D1&D&!C2&!C1&C&B2&B1&!B&A2&A1&A|!D1&D&!C2&!C1&C&B2&B1&!B&A2&A1&A|!D1&D&C2&!C1&C&B2&B1&!B&A2&A1&A|D1&D&C2&!C1&C&B2&B1&!B&A2&A1&A|D1&!D&C2&!C1&C&B2&B1&!B&A2&A1&A|!D1&!D&C2&!C1&C&B2&B1&!B&A2&A1&A|!D1&!D&C2&C1&C&B2&B1&!B&A2&A1&A|D1&!D&C2&C1&C&B2&B1&!B&A2&A1&A|D1&D&C2&C1&C&B2&B1&!B&A2&A1&A|!D1&D&C2&C1&C&B2&B1&!B&A2&A1&A|!D1&D&!C2&C1&C&B2&B1&!B&A2&A1&A|D1&D&!C2&C1&C&B2&B1&!B&A2&A1&A|D1&!D&!C2&C1&C&B2&B1&!B&A2&A1&A|!D1&!D&!C2&C1&C&B2&B1&!B&A2&A1&A|!D1&!D&!C2&C1&!C&B2&B1&!B&A2&A1&A|D1&!D&!C2&C1&!C&B2&B1&!B&A2&A1&A|D1&D&!C2&C1&!C&B2&B1&!B&A2&A1&A|!D1&D&!C2&C1&!C&B2&B1&!B&A2&A1&A|!D1&D&C2&C1&!C&B2&B1&!B&A2&A1&A|D1&D&C2&C1&!C&B2&B1&!B&A2&A1&A|D1&!D&C2&C1&!C&B2&B1&!B&A2&A1&A|!D1&!D&C2&C1&!C&B2&B1&!B&A2&A1&A|!D1&!D&C2&!C1&!C&B2&B1&!B&A2&A1&A|D1&!D&C2&!C1&!C&B2&B1&!B&A2&A1&A|D1&D&C2&!C1&!C&B2&B1&!B&A2&A1&A|!D1&D&C2&!C1&!C&B2&B1&!B&A2&A1&A|!D1&D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|D1&D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|D1&!D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|!D1&!D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|!D1&!D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|D1&!D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|D1&D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|!D1&D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|!D1&D&C2&!C1&!C&B2&!B1&!B&A2&A1&A|D1&D&C2&!C1&!C&B2&!B1&!B&A2&A1&A|D1&!D&C2&!C1&!C&B2&!B1&!B&A2&A1&A|!D1&!D&C2&!C1&!C&B2&!B1&!B&A2&A1&A|!D1&!D&C2&C1&!C&B2&!B1&!B&A2&A1&A|D1&!D&C2&C1&!C&B2&!B1&!B&A2&A1&A|D1&D&C2&C1&!C&B2&!B1&!B&A2&A1&A|!D1&D&C2&C1&!C&B2&!B1&!B&A2&A1&A|!D1&D&!C2&C1&!C&B2&!B1&!B&A2&A1&A|D1&D&!C2&C1&!C&B2&!B1&!B&A2&A1&A|D1&!D&!C2&C1&!C&B2&!B1&!B&A2&A1&A|!D1&!D&!C2&C1&!C&B2&!B1&!B&A2&A1&A|!D1&!D&!C2&C1&C&B2&!B1&!B&A2&A1&A|D1&!D&!C2&C1&C&B2&!B1&!B&A2&A1&A|D1&D&!C2&C1&C&B2&!B1&!B&A2&A1&A|!D1&D&!C2&C1&C&B2&!B1&!B&A2&A1&A|!D1&D&C2&C1&C&B2&!B1&!B&A2&A1&A|D1&D&C2&C1&C&B2&!B1&!B&A2&A1&A|D1&!D&C2&C1&C&B2&!B1&!B&A2&A1&A|!D1&!D&C2&C1&C&B2&!B1&!B&A2&A1&A|!D1&!D&C2&!C1&C&B2&!B1&!B&A2&A1&A|D1&!D&C2&!C1&C&B2&!B1&!B&A2&A1&A|D1&D&C2&!C1&C&B2&!B1&!B&A2&A1&A|!D1&D&C2&!C1&C&B2&!B1&!B&A2&A1&A|!D1&D&!C2&!C1&C&B2&!B1&!B&A2&A1&A|D1&D&!C2&!C1&C&B2&!B1&!B&A2&A1&A|D1&!D&!C2&!C1&C&B2&!B1&!B&A2&A1&A|!D1&!D&!C2&!C1&C&B2&!B1&!B&A2&A1&A|!D1&!D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|D1&!D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|D1&D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|!D1&D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|!D1&D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|D1&D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|D1&!D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|!D1&!D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|!D1&!D&C2&C1&C&!B2&!B1&!B&A2&A1&A|D1&!D&C2&C1&C&!B2&!B1&!B&A2&A1&A|D1&D&C2&C1&C&!B2&!B1&!B&A2&A1&A|!D1&D&C2&C1&C&!B2&!B1&!B&A2&A1&A|!D1&D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|D1&D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|D1&!D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|!D1&!D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|!D1&!D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|D1&!D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|D1&D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|!D1&D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|!D1&D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|D1&D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|D1&!D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|!D1&!D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|!D1&!D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|D1&!D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|D1&D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!D1&D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!D1&D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|D1&D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|D1&!D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!D1&!D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|D1&D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|D1&D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|D1&D&C2&C1&!C&!B2&!B1&!B&A2&!A1&A|D1&D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&A|D1&D&!C2&C1&C&!B2&!B1&!B&A2&!A1&A|!D1&D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|D1&D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|D1&!D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|!D1&!D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|D1&D&C2&!C1&C&!B2&!B1&!B&A2&!A1&A|D1&D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&A|D1&D&!C2&!C1&C&B2&!B1&!B&A2&!A1&A|D1&D&C2&!C1&C&B2&!B1&!B&A2&!A1&A|!D1&!D&C2&C1&C&B2&!B1&!B&A2&!A1&A|D1&!D&C2&C1&C&B2&!B1&!B&A2&!A1&A|D1&D&C2&C1&C&B2&!B1&!B&A2&!A1&A|!D1&D&C2&C1&C&B2&!B1&!B&A2&!A1&A|D1&D&!C2&C1&C&B2&!B1&!B&A2&!A1&A|D1&D&!C2&C1&!C&B2&!B1&!B&A2&!A1&A|D1&D&C2&C1&!C&B2&!B1&!B&A2&!A1&A|D1&D&C2&!C1&!C&B2&!B1&!B&A2&!A1&A|D1&D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&A|D1&D&!C2&!C1&!C&B2&B1&!B&A2&!A1&A|D1&D&C2&!C1&!C&B2&B1&!B&A2&!A1&A|D1&D&C2&C1&!C&B2&B1&!B&A2&!A1&A|D1&D&!C2&C1&!C&B2&B1&!B&A2&!A1&A|D1&D&!C2&C1&C&B2&B1&!B&A2&!A1&A|!D1&D&C2&C1&C&B2&B1&!B&A2&!A1&A|D1&D&C2&C1&C&B2&B1&!B&A2&!A1&A|D1&!D&C2&C1&C&B2&B1&!B&A2&!A1&A|!D1&!D&C2&C1&C&B2&B1&!B&A2&!A1&A|D1&D&C2&!C1&C&B2&B1&!B&A2&!A1&A|D1&D&!C2&!C1&C&B2&B1&!B&A2&!A1&A|D1&D&!C2&!C1&C&!B2&B1&!B&A2&!A1&A|D1&D&C2&!C1&C&!B2&B1&!B&A2&!A1&A|!D1&!D&C2&C1&C&!B2&B1&!B&A2&!A1&A|D1&!D&C2&C1&C&!B2&B1&!B&A2&!A1&A|D1&D&C2&C1&C&!B2&B1&!B&A2&!A1&A|!D1&D&C2&C1&C&!B2&B1&!B&A2&!A1&A|D1&D&!C2&C1&C&!B2&B1&!B&A2&!A1&A|D1&D&!C2&C1&!C&!B2&B1&!B&A2&!A1&A|D1&D&C2&C1&!C&!B2&B1&!B&A2&!A1&A|D1&D&C2&!C1&!C&!B2&B1&!B&A2&!A1&A|D1&D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&A|D1&D&!C2&!C1&!C&!B2&B1&B&A2&!A1&A|D1&D&C2&!C1&!C&!B2&B1&B&A2&!A1&A|D1&D&C2&C1&!C&!B2&B1&B&A2&!A1&A|D1&D&!C2&C1&!C&!B2&B1&B&A2&!A1&A|D1&D&!C2&C1&C&!B2&B1&B&A2&!A1&A|!D1&D&C2&C1&C&!B2&B1&B&A2&!A1&A|D1&D&C2&C1&C&!B2&B1&B&A2&!A1&A|D1&!D&C2&C1&C&!B2&B1&B&A2&!A1&A|!D1&!D&C2&C1&C&!B2&B1&B&A2&!A1&A|D1&D&C2&!C1&C&!B2&B1&B&A2&!A1&A|D1&D&!C2&!C1&C&!B2&B1&B&A2&!A1&A|!D1&!D&!C2&!C1&C&B2&B1&B&A2&!A1&A|D1&!D&!C2&!C1&C&B2&B1&B&A2&!A1&A|D1&D&!C2&!C1&C&B2&B1&B&A2&!A1&A|!D1&D&!C2&!C1&C&B2&B1&B&A2&!A1&A|!D1&D&C2&!C1&C&B2&B1&B&A2&!A1&A|D1&D&C2&!C1&C&B2&B1&B&A2&!A1&A|D1&!D&C2&!C1&C&B2&B1&B&A2&!A1&A|!D1&!D&C2&!C1&C&B2&B1&B&A2&!A1&A|!D1&!D&C2&C1&C&B2&B1&B&A2&!A1&A|D1&!D&C2&C1&C&B2&B1&B&A2&!A1&A|D1&D&C2&C1&C&B2&B1&B&A2&!A1&A|!D1&D&C2&C1&C&B2&B1&B&A2&!A1&A|!D1&D&!C2&C1&C&B2&B1&B&A2&!A1&A|D1&D&!C2&C1&C&B2&B1&B&A2&!A1&A|D1&!D&!C2&C1&C&B2&B1&B&A2&!A1&A|!D1&!D&!C2&C1&C&B2&B1&B&A2&!A1&A|!D1&!D&!C2&C1&!C&B2&B1&B&A2&!A1&A|D1&!D&!C2&C1&!C&B2&B1&B&A2&!A1&A|D1&D&!C2&C1&!C&B2&B1&B&A2&!A1&A|!D1&D&!C2&C1&!C&B2&B1&B&A2&!A1&A|!D1&D&C2&C1&!C&B2&B1&B&A2&!A1&A|D1&D&C2&C1&!C&B2&B1&B&A2&!A1&A|D1&!D&C2&C1&!C&B2&B1&B&A2&!A1&A|!D1&!D&C2&C1&!C&B2&B1&B&A2&!A1&A|!D1&!D&C2&!C1&!C&B2&B1&B&A2&!A1&A|D1&!D&C2&!C1&!C&B2&B1&B&A2&!A1&A|D1&D&C2&!C1&!C&B2&B1&B&A2&!A1&A|!D1&D&C2&!C1&!C&B2&B1&B&A2&!A1&A|!D1&D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|D1&D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|D1&!D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|!D1&!D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|D1&D&!C2&!C1&!C&B2&!B1&B&A2&!A1&A|D1&D&C2&!C1&!C&B2&!B1&B&A2&!A1&A|D1&D&C2&C1&!C&B2&!B1&B&A2&!A1&A|D1&D&!C2&C1&!C&B2&!B1&B&A2&!A1&A|D1&D&!C2&C1&C&B2&!B1&B&A2&!A1&A|!D1&D&C2&C1&C&B2&!B1&B&A2&!A1&A|D1&D&C2&C1&C&B2&!B1&B&A2&!A1&A|D1&!D&C2&C1&C&B2&!B1&B&A2&!A1&A|!D1&!D&C2&C1&C&B2&!B1&B&A2&!A1&A|D1&D&C2&!C1&C&B2&!B1&B&A2&!A1&A|D1&D&!C2&!C1&C&B2&!B1&B&A2&!A1&A|D1&D&!C2&!C1&C&!B2&!B1&B&A2&!A1&A|D1&D&C2&!C1&C&!B2&!B1&B&A2&!A1&A|!D1&!D&C2&C1&C&!B2&!B1&B&A2&!A1&A|D1&!D&C2&C1&C&!B2&!B1&B&A2&!A1&A|D1&D&C2&C1&C&!B2&!B1&B&A2&!A1&A|!D1&D&C2&C1&C&!B2&!B1&B&A2&!A1&A|D1&D&!C2&C1&C&!B2&!B1&B&A2&!A1&A|D1&D&!C2&C1&!C&!B2&!B1&B&A2&!A1&A|D1&D&C2&C1&!C&!B2&!B1&B&A2&!A1&A|D1&D&C2&!C1&!C&!B2&!B1&B&A2&!A1&A|D1&D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&A|D1&D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|D1&D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|D1&D&C2&C1&!C&!B2&!B1&B&!A2&!A1&A|D1&D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&A|D1&D&!C2&C1&C&!B2&!B1&B&!A2&!A1&A|!D1&D&C2&C1&C&!B2&!B1&B&!A2&!A1&A|D1&D&C2&C1&C&!B2&!B1&B&!A2&!A1&A|D1&!D&C2&C1&C&!B2&!B1&B&!A2&!A1&A|!D1&!D&C2&C1&C&!B2&!B1&B&!A2&!A1&A|D1&D&C2&!C1&C&!B2&!B1&B&!A2&!A1&A|D1&D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&A|D1&D&!C2&!C1&C&B2&!B1&B&!A2&!A1&A|D1&D&C2&!C1&C&B2&!B1&B&!A2&!A1&A|!D1&!D&C2&C1&C&B2&!B1&B&!A2&!A1&A|D1&!D&C2&C1&C&B2&!B1&B&!A2&!A1&A|D1&D&C2&C1&C&B2&!B1&B&!A2&!A1&A|!D1&D&C2&C1&C&B2&!B1&B&!A2&!A1&A|D1&D&!C2&C1&C&B2&!B1&B&!A2&!A1&A|D1&D&!C2&C1&!C&B2&!B1&B&!A2&!A1&A|D1&D&C2&C1&!C&B2&!B1&B&!A2&!A1&A|D1&D&C2&!C1&!C&B2&!B1&B&!A2&!A1&A|D1&D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&A|!D1&!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|D1&!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|D1&D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|!D1&D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|!D1&D&C2&!C1&!C&B2&B1&B&!A2&!A1&A|D1&D&C2&!C1&!C&B2&B1&B&!A2&!A1&A|D1&!D&C2&!C1&!C&B2&B1&B&!A2&!A1&A|!D1&!D&C2&!C1&!C&B2&B1&B&!A2&!A1&A|!D1&!D&C2&C1&!C&B2&B1&B&!A2&!A1&A|D1&!D&C2&C1&!C&B2&B1&B&!A2&!A1&A|D1&D&C2&C1&!C&B2&B1&B&!A2&!A1&A|!D1&D&C2&C1&!C&B2&B1&B&!A2&!A1&A|!D1&D&!C2&C1&!C&B2&B1&B&!A2&!A1&A|D1&D&!C2&C1&!C&B2&B1&B&!A2&!A1&A|D1&!D&!C2&C1&!C&B2&B1&B&!A2&!A1&A|!D1&!D&!C2&C1&!C&B2&B1&B&!A2&!A1&A|!D1&!D&!C2&C1&C&B2&B1&B&!A2&!A1&A|D1&!D&!C2&C1&C&B2&B1&B&!A2&!A1&A|D1&D&!C2&C1&C&B2&B1&B&!A2&!A1&A|!D1&D&!C2&C1&C&B2&B1&B&!A2&!A1&A|!D1&D&C2&C1&C&B2&B1&B&!A2&!A1&A|D1&D&C2&C1&C&B2&B1&B&!A2&!A1&A|D1&!D&C2&C1&C&B2&B1&B&!A2&!A1&A|!D1&!D&C2&C1&C&B2&B1&B&!A2&!A1&A|!D1&!D&C2&!C1&C&B2&B1&B&!A2&!A1&A|D1&!D&C2&!C1&C&B2&B1&B&!A2&!A1&A|D1&D&C2&!C1&C&B2&B1&B&!A2&!A1&A|!D1&D&C2&!C1&C&B2&B1&B&!A2&!A1&A|!D1&D&!C2&!C1&C&B2&B1&B&!A2&!A1&A|D1&D&!C2&!C1&C&B2&B1&B&!A2&!A1&A|D1&!D&!C2&!C1&C&B2&B1&B&!A2&!A1&A|!D1&!D&!C2&!C1&C&B2&B1&B&!A2&!A1&A|D1&D&!C2&!C1&C&!B2&B1&B&!A2&!A1&A|D1&D&C2&!C1&C&!B2&B1&B&!A2&!A1&A|!D1&!D&C2&C1&C&!B2&B1&B&!A2&!A1&A|D1&!D&C2&C1&C&!B2&B1&B&!A2&!A1&A|D1&D&C2&C1&C&!B2&B1&B&!A2&!A1&A|!D1&D&C2&C1&C&!B2&B1&B&!A2&!A1&A|D1&D&!C2&C1&C&!B2&B1&B&!A2&!A1&A|D1&D&!C2&C1&!C&!B2&B1&B&!A2&!A1&A|D1&D&C2&C1&!C&!B2&B1&B&!A2&!A1&A|D1&D&C2&!C1&!C&!B2&B1&B&!A2&!A1&A|D1&D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&A|D1&D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|D1&D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|D1&D&C2&C1&!C&!B2&B1&!B&!A2&!A1&A|D1&D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&A|D1&D&!C2&C1&C&!B2&B1&!B&!A2&!A1&A|!D1&D&C2&C1&C&!B2&B1&!B&!A2&!A1&A|D1&D&C2&C1&C&!B2&B1&!B&!A2&!A1&A|D1&!D&C2&C1&C&!B2&B1&!B&!A2&!A1&A|!D1&!D&C2&C1&C&!B2&B1&!B&!A2&!A1&A|D1&D&C2&!C1&C&!B2&B1&!B&!A2&!A1&A|D1&D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&A|D1&D&!C2&!C1&C&B2&B1&!B&!A2&!A1&A|D1&D&C2&!C1&C&B2&B1&!B&!A2&!A1&A|!D1&!D&C2&C1&C&B2&B1&!B&!A2&!A1&A|D1&!D&C2&C1&C&B2&B1&!B&!A2&!A1&A|D1&D&C2&C1&C&B2&B1&!B&!A2&!A1&A|!D1&D&C2&C1&C&B2&B1&!B&!A2&!A1&A|D1&D&!C2&C1&C&B2&B1&!B&!A2&!A1&A|D1&D&!C2&C1&!C&B2&B1&!B&!A2&!A1&A|D1&D&C2&C1&!C&B2&B1&!B&!A2&!A1&A|D1&D&C2&!C1&!C&B2&B1&!B&!A2&!A1&A|D1&D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&A|D1&D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|D1&D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|D1&D&C2&C1&!C&B2&!B1&!B&!A2&!A1&A|D1&D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&A|D1&D&!C2&C1&C&B2&!B1&!B&!A2&!A1&A|!D1&D&C2&C1&C&B2&!B1&!B&!A2&!A1&A|D1&D&C2&C1&C&B2&!B1&!B&!A2&!A1&A|D1&!D&C2&C1&C&B2&!B1&!B&!A2&!A1&A|!D1&!D&C2&C1&C&B2&!B1&!B&!A2&!A1&A|D1&D&C2&!C1&C&B2&!B1&!B&!A2&!A1&A|D1&D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&A|D1&D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|D1&D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A|D1&!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A|D1&D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A|D1&D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&A|D1&D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|D1&D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|D1&D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|D1&D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAAOI3332.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOI2121 -l OAAOI2121 -i D C1 C B A1 A -o Y -f Y=(!D&!C1&!C&!B&!A1&!A|!D&C1&!C&!B&!A1&!A|!D&!C1&C&!B&!A1&!A|!D&!C1&C&B&!A1&!A|!D&C1&!C&B&!A1&!A|!D&!C1&!C&B&!A1&!A|!D&!C1&C&!B&A1&!A|!D&C1&!C&!B&A1&!A|!D&!C1&!C&!B&A1&!A|!D&!C1&!C&!B&A1&A|!D&C1&!C&!B&A1&A|!D&!C1&C&!B&A1&A|!D&!C1&C&!B&!A1&A|!D&C1&!C&!B&!A1&A|!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOI2121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOAI2221 -l OAOAI2221 -i D C1 C B1 B A1 A -o Y -f Y=!(D&C1&!C&!B1&!B&!A1&!A|D&C1&C&!B1&!B&!A1&!A|D&!C1&C&!B1&!B&!A1&!A|D&!C1&C&B1&!B&!A1&!A|D&C1&C&B1&!B&!A1&!A|D&C1&!C&B1&!B&!A1&!A|D&C1&!C&B1&B&!A1&!A|D&C1&C&B1&B&!A1&!A|D&!C1&C&B1&B&!A1&!A|D&!C1&C&!B1&B&!A1&!A|D&C1&C&!B1&B&!A1&!A|D&C1&!C&!B1&B&!A1&!A|D&C1&!C&!B1&B&A1&!A|D&C1&C&!B1&B&A1&!A|D&!C1&C&!B1&B&A1&!A|D&!C1&C&B1&B&A1&!A|D&C1&C&B1&B&A1&!A|D&C1&!C&B1&B&A1&!A|D&!C1&!C&B1&B&A1&!A|D&C1&!C&B1&!B&A1&!A|D&C1&C&B1&!B&A1&!A|D&!C1&C&B1&!B&A1&!A|D&!C1&C&!B1&!B&A1&!A|D&C1&C&!B1&!B&A1&!A|D&C1&!C&!B1&!B&A1&!A|D&C1&!C&!B1&!B&A1&A|D&C1&C&!B1&!B&A1&A|D&!C1&C&!B1&!B&A1&A|D&!C1&C&B1&!B&A1&A|D&C1&C&B1&!B&A1&A|D&C1&!C&B1&!B&A1&A|D&!C1&!C&B1&B&A1&A|D&C1&!C&B1&B&A1&A|D&C1&C&B1&B&A1&A|D&!C1&C&B1&B&A1&A|D&!C1&C&!B1&B&A1&A|D&C1&C&!B1&B&A1&A|D&C1&!C&!B1&B&A1&A|D&C1&!C&!B1&B&!A1&A|D&C1&C&!B1&B&!A1&A|D&!C1&C&!B1&B&!A1&A|D&!C1&C&B1&B&!A1&A|D&C1&C&B1&B&!A1&A|D&C1&!C&B1&B&!A1&A|D&!C1&!C&B1&B&!A1&A|D&C1&!C&B1&!B&!A1&A|D&C1&C&B1&!B&!A1&A|D&!C1&C&B1&!B&!A1&A|D&!C1&C&!B1&!B&!A1&A|D&C1&C&!B1&!B&!A1&A|D&C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOAI2221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAI323 -l AOOAI323 -i C2 C1 C B1 B A2 A1 A -o Y -f Y=(!C2&!C1&!C&!B1&!B&!A2&!A1&!A|C2&!C1&!C&!B1&!B&!A2&!A1&!A|C2&C1&!C&!B1&!B&!A2&!A1&!A|!C2&C1&!C&!B1&!B&!A2&!A1&!A|!C2&C1&C&!B1&!B&!A2&!A1&!A|C2&C1&C&!B1&!B&!A2&!A1&!A|C2&!C1&C&!B1&!B&!A2&!A1&!A|!C2&!C1&C&!B1&!B&!A2&!A1&!A|!C2&!C1&!C&B1&!B&!A2&!A1&!A|!C2&!C1&!C&B1&B&!A2&!A1&!A|!C2&!C1&!C&!B1&B&!A2&!A1&!A|!C2&!C1&!C&!B1&B&A2&!A1&!A|!C2&!C1&!C&B1&B&A2&!A1&!A|!C2&!C1&!C&B1&!B&A2&!A1&!A|!C2&!C1&C&!B1&!B&A2&!A1&!A|C2&!C1&C&!B1&!B&A2&!A1&!A|C2&C1&C&!B1&!B&A2&!A1&!A|!C2&C1&C&!B1&!B&A2&!A1&!A|!C2&C1&!C&!B1&!B&A2&!A1&!A|C2&C1&!C&!B1&!B&A2&!A1&!A|C2&!C1&!C&!B1&!B&A2&!A1&!A|!C2&!C1&!C&!B1&!B&A2&!A1&!A|!C2&!C1&!C&!B1&!B&A2&A1&!A|C2&!C1&!C&!B1&!B&A2&A1&!A|C2&C1&!C&!B1&!B&A2&A1&!A|!C2&C1&!C&!B1&!B&A2&A1&!A|!C2&C1&C&!B1&!B&A2&A1&!A|C2&C1&C&!B1&!B&A2&A1&!A|C2&!C1&C&!B1&!B&A2&A1&!A|!C2&!C1&C&!B1&!B&A2&A1&!A|!C2&!C1&!C&B1&!B&A2&A1&!A|!C2&!C1&!C&B1&B&A2&A1&!A|!C2&!C1&!C&!B1&B&A2&A1&!A|!C2&!C1&!C&!B1&B&!A2&A1&!A|!C2&!C1&!C&B1&B&!A2&A1&!A|!C2&!C1&!C&B1&!B&!A2&A1&!A|!C2&!C1&C&!B1&!B&!A2&A1&!A|C2&!C1&C&!B1&!B&!A2&A1&!A|C2&C1&C&!B1&!B&!A2&A1&!A|!C2&C1&C&!B1&!B&!A2&A1&!A|!C2&C1&!C&!B1&!B&!A2&A1&!A|C2&C1&!C&!B1&!B&!A2&A1&!A|C2&!C1&!C&!B1&!B&!A2&A1&!A|!C2&!C1&!C&!B1&!B&!A2&A1&!A|!C2&!C1&!C&!B1&!B&!A2&A1&A|C2&!C1&!C&!B1&!B&!A2&A1&A|C2&C1&!C&!B1&!B&!A2&A1&A|!C2&C1&!C&!B1&!B&!A2&A1&A|!C2&C1&C&!B1&!B&!A2&A1&A|C2&C1&C&!B1&!B&!A2&A1&A|C2&!C1&C&!B1&!B&!A2&A1&A|!C2&!C1&C&!B1&!B&!A2&A1&A|!C2&!C1&!C&B1&!B&!A2&A1&A|!C2&!C1&!C&B1&B&!A2&A1&A|!C2&!C1&!C&!B1&B&!A2&A1&A|!C2&!C1&!C&!B1&B&A2&A1&A|!C2&!C1&!C&B1&B&A2&A1&A|!C2&!C1&!C&B1&!B&A2&A1&A|!C2&!C1&!C&!B1&!B&A2&A1&A|!C2&!C1&!C&!B1&!B&A2&!A1&A|C2&!C1&!C&!B1&!B&A2&!A1&A|C2&C1&!C&!B1&!B&A2&!A1&A|!C2&C1&!C&!B1&!B&A2&!A1&A|!C2&C1&C&!B1&!B&A2&!A1&A|C2&C1&C&!B1&!B&A2&!A1&A|C2&!C1&C&!B1&!B&A2&!A1&A|!C2&!C1&C&!B1&!B&A2&!A1&A|!C2&!C1&!C&B1&!B&A2&!A1&A|!C2&!C1&!C&B1&B&A2&!A1&A|!C2&!C1&!C&!B1&B&A2&!A1&A|!C2&!C1&!C&!B1&B&!A2&!A1&A|!C2&!C1&!C&B1&B&!A2&!A1&A|!C2&!C1&!C&B1&!B&!A2&!A1&A|!C2&!C1&C&!B1&!B&!A2&!A1&A|C2&!C1&C&!B1&!B&!A2&!A1&A|C2&C1&C&!B1&!B&!A2&!A1&A|!C2&C1&C&!B1&!B&!A2&!A1&A|!C2&C1&!C&!B1&!B&!A2&!A1&A|C2&C1&!C&!B1&!B&!A2&!A1&A|C2&!C1&!C&!B1&!B&!A2&!A1&A|!C2&!C1&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAI323.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOAI3322 -l AAAOAI3322 -i D1 D C1 C B2 B1 B A2 A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&!C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C1&C&B2&!B1&!B&!A2&!A1&!A|D1&!D&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&D&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&!D&C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&D&C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&D&!C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&!D&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C1&!C&B2&B1&!B&!A2&!A1&!A|D1&!D&!C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&D&!C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&D&C1&!C&B2&B1&!B&!A2&!A1&!A|D1&!D&C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&!D&C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&D&!C1&C&B2&B1&!B&!A2&!A1&!A|D1&!D&!C1&C&B2&B1&!B&!A2&!A1&!A|!D1&!D&!C1&C&B2&B1&!B&!A2&!A1&!A|!D1&!D&!C1&C&!B2&B1&!B&!A2&!A1&!A|D1&!D&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&D&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&!D&C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&D&C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&D&!C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&!D&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&!C1&!C&!B2&B1&B&!A2&!A1&!A|D1&!D&!C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&D&!C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&D&C1&!C&!B2&B1&B&!A2&!A1&!A|D1&!D&C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&!D&C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&D&!C1&C&!B2&B1&B&!A2&!A1&!A|D1&!D&!C1&C&!B2&B1&B&!A2&!A1&!A|!D1&!D&!C1&C&!B2&B1&B&!A2&!A1&!A|!D1&!D&!C1&!C&B2&!B1&B&!A2&!A1&!A|D1&!D&!C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&D&!C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&D&C1&!C&B2&!B1&B&!A2&!A1&!A|D1&!D&C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&!D&C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&D&!C1&C&B2&!B1&B&!A2&!A1&!A|D1&!D&!C1&C&B2&!B1&B&!A2&!A1&!A|!D1&!D&!C1&C&B2&!B1&B&!A2&!A1&!A|!D1&!D&!C1&C&!B2&!B1&B&!A2&!A1&!A|D1&!D&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&D&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&!D&C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&D&C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&D&!C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&!D&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&!C1&!C&!B2&!B1&B&A2&!A1&!A|D1&!D&!C1&!C&!B2&!B1&B&A2&!A1&!A|!D1&D&!C1&!C&!B2&!B1&B&A2&!A1&!A|!D1&D&C1&!C&!B2&!B1&B&A2&!A1&!A|D1&!D&C1&!C&!B2&!B1&B&A2&!A1&!A|!D1&!D&C1&!C&!B2&!B1&B&A2&!A1&!A|!D1&D&!C1&C&!B2&!B1&B&A2&!A1&!A|D1&!D&!C1&C&!B2&!B1&B&A2&!A1&!A|!D1&!D&!C1&C&!B2&!B1&B&A2&!A1&!A|!D1&!D&!C1&C&B2&!B1&B&A2&!A1&!A|D1&!D&!C1&C&B2&!B1&B&A2&!A1&!A|!D1&D&!C1&C&B2&!B1&B&A2&!A1&!A|!D1&!D&C1&!C&B2&!B1&B&A2&!A1&!A|D1&!D&C1&!C&B2&!B1&B&A2&!A1&!A|!D1&D&C1&!C&B2&!B1&B&A2&!A1&!A|!D1&D&!C1&!C&B2&!B1&B&A2&!A1&!A|D1&!D&!C1&!C&B2&!B1&B&A2&!A1&!A|!D1&!D&!C1&!C&B2&!B1&B&A2&!A1&!A|!D1&!D&!C1&C&!B2&B1&B&A2&!A1&!A|D1&!D&!C1&C&!B2&B1&B&A2&!A1&!A|!D1&D&!C1&C&!B2&B1&B&A2&!A1&!A|!D1&!D&C1&!C&!B2&B1&B&A2&!A1&!A|D1&!D&C1&!C&!B2&B1&B&A2&!A1&!A|!D1&D&C1&!C&!B2&B1&B&A2&!A1&!A|!D1&D&!C1&!C&!B2&B1&B&A2&!A1&!A|D1&!D&!C1&!C&!B2&B1&B&A2&!A1&!A|!D1&!D&!C1&!C&!B2&B1&B&A2&!A1&!A|!D1&!D&!C1&!C&!B2&B1&!B&A2&!A1&!A|D1&!D&!C1&!C&!B2&B1&!B&A2&!A1&!A|!D1&D&!C1&!C&!B2&B1&!B&A2&!A1&!A|!D1&D&C1&!C&!B2&B1&!B&A2&!A1&!A|D1&!D&C1&!C&!B2&B1&!B&A2&!A1&!A|!D1&!D&C1&!C&!B2&B1&!B&A2&!A1&!A|!D1&D&!C1&C&!B2&B1&!B&A2&!A1&!A|D1&!D&!C1&C&!B2&B1&!B&A2&!A1&!A|!D1&!D&!C1&C&!B2&B1&!B&A2&!A1&!A|!D1&!D&!C1&C&B2&B1&!B&A2&!A1&!A|D1&!D&!C1&C&B2&B1&!B&A2&!A1&!A|!D1&D&!C1&C&B2&B1&!B&A2&!A1&!A|!D1&!D&C1&!C&B2&B1&!B&A2&!A1&!A|D1&!D&C1&!C&B2&B1&!B&A2&!A1&!A|!D1&D&C1&!C&B2&B1&!B&A2&!A1&!A|!D1&D&!C1&!C&B2&B1&!B&A2&!A1&!A|D1&!D&!C1&!C&B2&B1&!B&A2&!A1&!A|!D1&!D&!C1&!C&B2&B1&!B&A2&!A1&!A|!D1&!D&!C1&!C&B2&!B1&!B&A2&!A1&!A|D1&!D&!C1&!C&B2&!B1&!B&A2&!A1&!A|!D1&D&!C1&!C&B2&!B1&!B&A2&!A1&!A|!D1&D&C1&!C&B2&!B1&!B&A2&!A1&!A|D1&!D&C1&!C&B2&!B1&!B&A2&!A1&!A|!D1&!D&C1&!C&B2&!B1&!B&A2&!A1&!A|!D1&D&!C1&C&B2&!B1&!B&A2&!A1&!A|D1&!D&!C1&C&B2&!B1&!B&A2&!A1&!A|!D1&!D&!C1&C&B2&!B1&!B&A2&!A1&!A|!D1&!D&!C1&C&!B2&!B1&!B&A2&!A1&!A|D1&!D&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&D&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&!D&C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&D&C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&D&!C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&!D&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&!C1&!C&!B2&!B1&!B&A2&A1&!A|D1&!D&!C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&D&!C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&D&C1&!C&!B2&!B1&!B&A2&A1&!A|D1&!D&C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&!D&C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&D&!C1&C&!B2&!B1&!B&A2&A1&!A|D1&!D&!C1&C&!B2&!B1&!B&A2&A1&!A|!D1&!D&!C1&C&!B2&!B1&!B&A2&A1&!A|!D1&!D&!C1&C&B2&!B1&!B&A2&A1&!A|D1&!D&!C1&C&B2&!B1&!B&A2&A1&!A|!D1&D&!C1&C&B2&!B1&!B&A2&A1&!A|!D1&!D&C1&!C&B2&!B1&!B&A2&A1&!A|D1&!D&C1&!C&B2&!B1&!B&A2&A1&!A|!D1&D&C1&!C&B2&!B1&!B&A2&A1&!A|!D1&D&!C1&!C&B2&!B1&!B&A2&A1&!A|D1&!D&!C1&!C&B2&!B1&!B&A2&A1&!A|!D1&!D&!C1&!C&B2&!B1&!B&A2&A1&!A|!D1&!D&!C1&!C&B2&B1&!B&A2&A1&!A|D1&!D&!C1&!C&B2&B1&!B&A2&A1&!A|!D1&D&!C1&!C&B2&B1&!B&A2&A1&!A|!D1&D&C1&!C&B2&B1&!B&A2&A1&!A|D1&!D&C1&!C&B2&B1&!B&A2&A1&!A|!D1&!D&C1&!C&B2&B1&!B&A2&A1&!A|!D1&D&!C1&C&B2&B1&!B&A2&A1&!A|D1&!D&!C1&C&B2&B1&!B&A2&A1&!A|!D1&!D&!C1&C&B2&B1&!B&A2&A1&!A|!D1&!D&!C1&C&!B2&B1&!B&A2&A1&!A|D1&!D&!C1&C&!B2&B1&!B&A2&A1&!A|!D1&D&!C1&C&!B2&B1&!B&A2&A1&!A|!D1&!D&C1&!C&!B2&B1&!B&A2&A1&!A|D1&!D&C1&!C&!B2&B1&!B&A2&A1&!A|!D1&D&C1&!C&!B2&B1&!B&A2&A1&!A|!D1&D&!C1&!C&!B2&B1&!B&A2&A1&!A|D1&!D&!C1&!C&!B2&B1&!B&A2&A1&!A|!D1&!D&!C1&!C&!B2&B1&!B&A2&A1&!A|!D1&!D&!C1&!C&!B2&B1&B&A2&A1&!A|D1&!D&!C1&!C&!B2&B1&B&A2&A1&!A|!D1&D&!C1&!C&!B2&B1&B&A2&A1&!A|!D1&D&C1&!C&!B2&B1&B&A2&A1&!A|D1&!D&C1&!C&!B2&B1&B&A2&A1&!A|!D1&!D&C1&!C&!B2&B1&B&A2&A1&!A|!D1&D&!C1&C&!B2&B1&B&A2&A1&!A|D1&!D&!C1&C&!B2&B1&B&A2&A1&!A|!D1&!D&!C1&C&!B2&B1&B&A2&A1&!A|!D1&!D&!C1&!C&B2&!B1&B&A2&A1&!A|D1&!D&!C1&!C&B2&!B1&B&A2&A1&!A|!D1&D&!C1&!C&B2&!B1&B&A2&A1&!A|!D1&D&C1&!C&B2&!B1&B&A2&A1&!A|D1&!D&C1&!C&B2&!B1&B&A2&A1&!A|!D1&!D&C1&!C&B2&!B1&B&A2&A1&!A|!D1&D&!C1&C&B2&!B1&B&A2&A1&!A|D1&!D&!C1&C&B2&!B1&B&A2&A1&!A|!D1&!D&!C1&C&B2&!B1&B&A2&A1&!A|!D1&!D&!C1&C&!B2&!B1&B&A2&A1&!A|D1&!D&!C1&C&!B2&!B1&B&A2&A1&!A|!D1&D&!C1&C&!B2&!B1&B&A2&A1&!A|!D1&!D&C1&!C&!B2&!B1&B&A2&A1&!A|D1&!D&C1&!C&!B2&!B1&B&A2&A1&!A|!D1&D&C1&!C&!B2&!B1&B&A2&A1&!A|!D1&D&!C1&!C&!B2&!B1&B&A2&A1&!A|D1&!D&!C1&!C&!B2&!B1&B&A2&A1&!A|!D1&!D&!C1&!C&!B2&!B1&B&A2&A1&!A|!D1&!D&!C1&!C&!B2&!B1&B&!A2&A1&!A|D1&!D&!C1&!C&!B2&!B1&B&!A2&A1&!A|!D1&D&!C1&!C&!B2&!B1&B&!A2&A1&!A|!D1&D&C1&!C&!B2&!B1&B&!A2&A1&!A|D1&!D&C1&!C&!B2&!B1&B&!A2&A1&!A|!D1&!D&C1&!C&!B2&!B1&B&!A2&A1&!A|!D1&D&!C1&C&!B2&!B1&B&!A2&A1&!A|D1&!D&!C1&C&!B2&!B1&B&!A2&A1&!A|!D1&!D&!C1&C&!B2&!B1&B&!A2&A1&!A|!D1&!D&!C1&C&B2&!B1&B&!A2&A1&!A|D1&!D&!C1&C&B2&!B1&B&!A2&A1&!A|!D1&D&!C1&C&B2&!B1&B&!A2&A1&!A|!D1&!D&C1&!C&B2&!B1&B&!A2&A1&!A|D1&!D&C1&!C&B2&!B1&B&!A2&A1&!A|!D1&D&C1&!C&B2&!B1&B&!A2&A1&!A|!D1&D&!C1&!C&B2&!B1&B&!A2&A1&!A|D1&!D&!C1&!C&B2&!B1&B&!A2&A1&!A|!D1&!D&!C1&!C&B2&!B1&B&!A2&A1&!A|!D1&!D&!C1&C&!B2&B1&B&!A2&A1&!A|D1&!D&!C1&C&!B2&B1&B&!A2&A1&!A|!D1&D&!C1&C&!B2&B1&B&!A2&A1&!A|!D1&!D&C1&!C&!B2&B1&B&!A2&A1&!A|D1&!D&C1&!C&!B2&B1&B&!A2&A1&!A|!D1&D&C1&!C&!B2&B1&B&!A2&A1&!A|!D1&D&!C1&!C&!B2&B1&B&!A2&A1&!A|D1&!D&!C1&!C&!B2&B1&B&!A2&A1&!A|!D1&!D&!C1&!C&!B2&B1&B&!A2&A1&!A|!D1&!D&!C1&!C&!B2&B1&!B&!A2&A1&!A|D1&!D&!C1&!C&!B2&B1&!B&!A2&A1&!A|!D1&D&!C1&!C&!B2&B1&!B&!A2&A1&!A|!D1&D&C1&!C&!B2&B1&!B&!A2&A1&!A|D1&!D&C1&!C&!B2&B1&!B&!A2&A1&!A|!D1&!D&C1&!C&!B2&B1&!B&!A2&A1&!A|!D1&D&!C1&C&!B2&B1&!B&!A2&A1&!A|D1&!D&!C1&C&!B2&B1&!B&!A2&A1&!A|!D1&!D&!C1&C&!B2&B1&!B&!A2&A1&!A|!D1&!D&!C1&C&B2&B1&!B&!A2&A1&!A|D1&!D&!C1&C&B2&B1&!B&!A2&A1&!A|!D1&D&!C1&C&B2&B1&!B&!A2&A1&!A|!D1&!D&C1&!C&B2&B1&!B&!A2&A1&!A|D1&!D&C1&!C&B2&B1&!B&!A2&A1&!A|!D1&D&C1&!C&B2&B1&!B&!A2&A1&!A|!D1&D&!C1&!C&B2&B1&!B&!A2&A1&!A|D1&!D&!C1&!C&B2&B1&!B&!A2&A1&!A|!D1&!D&!C1&!C&B2&B1&!B&!A2&A1&!A|!D1&!D&!C1&!C&B2&!B1&!B&!A2&A1&!A|D1&!D&!C1&!C&B2&!B1&!B&!A2&A1&!A|!D1&D&!C1&!C&B2&!B1&!B&!A2&A1&!A|!D1&D&C1&!C&B2&!B1&!B&!A2&A1&!A|D1&!D&C1&!C&B2&!B1&!B&!A2&A1&!A|!D1&!D&C1&!C&B2&!B1&!B&!A2&A1&!A|!D1&D&!C1&C&B2&!B1&!B&!A2&A1&!A|D1&!D&!C1&C&B2&!B1&!B&!A2&A1&!A|!D1&!D&!C1&C&B2&!B1&!B&!A2&A1&!A|!D1&!D&!C1&C&!B2&!B1&!B&!A2&A1&!A|D1&!D&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&D&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&!D&C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&D&C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&D&!C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&!D&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&!C1&!C&!B2&!B1&!B&!A2&A1&A|D1&!D&!C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&D&!C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&D&C1&!C&!B2&!B1&!B&!A2&A1&A|D1&!D&C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&!D&C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&D&!C1&C&!B2&!B1&!B&!A2&A1&A|D1&!D&!C1&C&!B2&!B1&!B&!A2&A1&A|!D1&!D&!C1&C&!B2&!B1&!B&!A2&A1&A|!D1&!D&!C1&C&B2&!B1&!B&!A2&A1&A|D1&!D&!C1&C&B2&!B1&!B&!A2&A1&A|!D1&D&!C1&C&B2&!B1&!B&!A2&A1&A|!D1&!D&C1&!C&B2&!B1&!B&!A2&A1&A|D1&!D&C1&!C&B2&!B1&!B&!A2&A1&A|!D1&D&C1&!C&B2&!B1&!B&!A2&A1&A|!D1&D&!C1&!C&B2&!B1&!B&!A2&A1&A|D1&!D&!C1&!C&B2&!B1&!B&!A2&A1&A|!D1&!D&!C1&!C&B2&!B1&!B&!A2&A1&A|!D1&!D&!C1&!C&B2&B1&!B&!A2&A1&A|D1&!D&!C1&!C&B2&B1&!B&!A2&A1&A|!D1&D&!C1&!C&B2&B1&!B&!A2&A1&A|!D1&D&C1&!C&B2&B1&!B&!A2&A1&A|D1&!D&C1&!C&B2&B1&!B&!A2&A1&A|!D1&!D&C1&!C&B2&B1&!B&!A2&A1&A|!D1&D&!C1&C&B2&B1&!B&!A2&A1&A|D1&!D&!C1&C&B2&B1&!B&!A2&A1&A|!D1&!D&!C1&C&B2&B1&!B&!A2&A1&A|!D1&!D&!C1&C&!B2&B1&!B&!A2&A1&A|D1&!D&!C1&C&!B2&B1&!B&!A2&A1&A|!D1&D&!C1&C&!B2&B1&!B&!A2&A1&A|!D1&!D&C1&!C&!B2&B1&!B&!A2&A1&A|D1&!D&C1&!C&!B2&B1&!B&!A2&A1&A|!D1&D&C1&!C&!B2&B1&!B&!A2&A1&A|!D1&D&!C1&!C&!B2&B1&!B&!A2&A1&A|D1&!D&!C1&!C&!B2&B1&!B&!A2&A1&A|!D1&!D&!C1&!C&!B2&B1&!B&!A2&A1&A|!D1&!D&!C1&!C&!B2&B1&B&!A2&A1&A|D1&!D&!C1&!C&!B2&B1&B&!A2&A1&A|!D1&D&!C1&!C&!B2&B1&B&!A2&A1&A|!D1&D&C1&!C&!B2&B1&B&!A2&A1&A|D1&!D&C1&!C&!B2&B1&B&!A2&A1&A|!D1&!D&C1&!C&!B2&B1&B&!A2&A1&A|!D1&D&!C1&C&!B2&B1&B&!A2&A1&A|D1&!D&!C1&C&!B2&B1&B&!A2&A1&A|!D1&!D&!C1&C&!B2&B1&B&!A2&A1&A|!D1&!D&!C1&!C&B2&!B1&B&!A2&A1&A|D1&!D&!C1&!C&B2&!B1&B&!A2&A1&A|!D1&D&!C1&!C&B2&!B1&B&!A2&A1&A|!D1&D&C1&!C&B2&!B1&B&!A2&A1&A|D1&!D&C1&!C&B2&!B1&B&!A2&A1&A|!D1&!D&C1&!C&B2&!B1&B&!A2&A1&A|!D1&D&!C1&C&B2&!B1&B&!A2&A1&A|D1&!D&!C1&C&B2&!B1&B&!A2&A1&A|!D1&!D&!C1&C&B2&!B1&B&!A2&A1&A|!D1&!D&!C1&C&!B2&!B1&B&!A2&A1&A|D1&!D&!C1&C&!B2&!B1&B&!A2&A1&A|!D1&D&!C1&C&!B2&!B1&B&!A2&A1&A|!D1&!D&C1&!C&!B2&!B1&B&!A2&A1&A|D1&!D&C1&!C&!B2&!B1&B&!A2&A1&A|!D1&D&C1&!C&!B2&!B1&B&!A2&A1&A|!D1&D&!C1&!C&!B2&!B1&B&!A2&A1&A|D1&!D&!C1&!C&!B2&!B1&B&!A2&A1&A|!D1&!D&!C1&!C&!B2&!B1&B&!A2&A1&A|!D1&!D&!C1&!C&!B2&!B1&!B&A2&!A1&A|D1&!D&!C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&D&!C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&D&C1&!C&!B2&!B1&!B&A2&!A1&A|D1&!D&C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&!D&C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&D&!C1&C&!B2&!B1&!B&A2&!A1&A|D1&!D&!C1&C&!B2&!B1&!B&A2&!A1&A|!D1&!D&!C1&C&!B2&!B1&!B&A2&!A1&A|!D1&!D&!C1&C&B2&!B1&!B&A2&!A1&A|D1&!D&!C1&C&B2&!B1&!B&A2&!A1&A|!D1&D&!C1&C&B2&!B1&!B&A2&!A1&A|!D1&!D&C1&!C&B2&!B1&!B&A2&!A1&A|D1&!D&C1&!C&B2&!B1&!B&A2&!A1&A|!D1&D&C1&!C&B2&!B1&!B&A2&!A1&A|!D1&D&!C1&!C&B2&!B1&!B&A2&!A1&A|D1&!D&!C1&!C&B2&!B1&!B&A2&!A1&A|!D1&!D&!C1&!C&B2&!B1&!B&A2&!A1&A|!D1&!D&!C1&!C&B2&B1&!B&A2&!A1&A|D1&!D&!C1&!C&B2&B1&!B&A2&!A1&A|!D1&D&!C1&!C&B2&B1&!B&A2&!A1&A|!D1&D&C1&!C&B2&B1&!B&A2&!A1&A|D1&!D&C1&!C&B2&B1&!B&A2&!A1&A|!D1&!D&C1&!C&B2&B1&!B&A2&!A1&A|!D1&D&!C1&C&B2&B1&!B&A2&!A1&A|D1&!D&!C1&C&B2&B1&!B&A2&!A1&A|!D1&!D&!C1&C&B2&B1&!B&A2&!A1&A|!D1&!D&!C1&C&!B2&B1&!B&A2&!A1&A|D1&!D&!C1&C&!B2&B1&!B&A2&!A1&A|!D1&D&!C1&C&!B2&B1&!B&A2&!A1&A|!D1&!D&C1&!C&!B2&B1&!B&A2&!A1&A|D1&!D&C1&!C&!B2&B1&!B&A2&!A1&A|!D1&D&C1&!C&!B2&B1&!B&A2&!A1&A|!D1&D&!C1&!C&!B2&B1&!B&A2&!A1&A|D1&!D&!C1&!C&!B2&B1&!B&A2&!A1&A|!D1&!D&!C1&!C&!B2&B1&!B&A2&!A1&A|!D1&!D&!C1&!C&!B2&B1&B&A2&!A1&A|D1&!D&!C1&!C&!B2&B1&B&A2&!A1&A|!D1&D&!C1&!C&!B2&B1&B&A2&!A1&A|!D1&D&C1&!C&!B2&B1&B&A2&!A1&A|D1&!D&C1&!C&!B2&B1&B&A2&!A1&A|!D1&!D&C1&!C&!B2&B1&B&A2&!A1&A|!D1&D&!C1&C&!B2&B1&B&A2&!A1&A|D1&!D&!C1&C&!B2&B1&B&A2&!A1&A|!D1&!D&!C1&C&!B2&B1&B&A2&!A1&A|!D1&!D&!C1&!C&B2&!B1&B&A2&!A1&A|D1&!D&!C1&!C&B2&!B1&B&A2&!A1&A|!D1&D&!C1&!C&B2&!B1&B&A2&!A1&A|!D1&D&C1&!C&B2&!B1&B&A2&!A1&A|D1&!D&C1&!C&B2&!B1&B&A2&!A1&A|!D1&!D&C1&!C&B2&!B1&B&A2&!A1&A|!D1&D&!C1&C&B2&!B1&B&A2&!A1&A|D1&!D&!C1&C&B2&!B1&B&A2&!A1&A|!D1&!D&!C1&C&B2&!B1&B&A2&!A1&A|!D1&!D&!C1&C&!B2&!B1&B&A2&!A1&A|D1&!D&!C1&C&!B2&!B1&B&A2&!A1&A|!D1&D&!C1&C&!B2&!B1&B&A2&!A1&A|!D1&!D&C1&!C&!B2&!B1&B&A2&!A1&A|D1&!D&C1&!C&!B2&!B1&B&A2&!A1&A|!D1&D&C1&!C&!B2&!B1&B&A2&!A1&A|!D1&D&!C1&!C&!B2&!B1&B&A2&!A1&A|D1&!D&!C1&!C&!B2&!B1&B&A2&!A1&A|!D1&!D&!C1&!C&!B2&!B1&B&A2&!A1&A|!D1&!D&!C1&!C&!B2&!B1&B&!A2&!A1&A|D1&!D&!C1&!C&!B2&!B1&B&!A2&!A1&A|!D1&D&!C1&!C&!B2&!B1&B&!A2&!A1&A|!D1&D&C1&!C&!B2&!B1&B&!A2&!A1&A|D1&!D&C1&!C&!B2&!B1&B&!A2&!A1&A|!D1&!D&C1&!C&!B2&!B1&B&!A2&!A1&A|!D1&D&!C1&C&!B2&!B1&B&!A2&!A1&A|D1&!D&!C1&C&!B2&!B1&B&!A2&!A1&A|!D1&!D&!C1&C&!B2&!B1&B&!A2&!A1&A|!D1&!D&!C1&C&B2&!B1&B&!A2&!A1&A|D1&!D&!C1&C&B2&!B1&B&!A2&!A1&A|!D1&D&!C1&C&B2&!B1&B&!A2&!A1&A|!D1&!D&C1&!C&B2&!B1&B&!A2&!A1&A|D1&!D&C1&!C&B2&!B1&B&!A2&!A1&A|!D1&D&C1&!C&B2&!B1&B&!A2&!A1&A|!D1&D&!C1&!C&B2&!B1&B&!A2&!A1&A|D1&!D&!C1&!C&B2&!B1&B&!A2&!A1&A|!D1&!D&!C1&!C&B2&!B1&B&!A2&!A1&A|!D1&!D&!C1&C&!B2&B1&B&!A2&!A1&A|D1&!D&!C1&C&!B2&B1&B&!A2&!A1&A|!D1&D&!C1&C&!B2&B1&B&!A2&!A1&A|!D1&!D&C1&!C&!B2&B1&B&!A2&!A1&A|D1&!D&C1&!C&!B2&B1&B&!A2&!A1&A|!D1&D&C1&!C&!B2&B1&B&!A2&!A1&A|!D1&D&!C1&!C&!B2&B1&B&!A2&!A1&A|D1&!D&!C1&!C&!B2&B1&B&!A2&!A1&A|!D1&!D&!C1&!C&!B2&B1&B&!A2&!A1&A|!D1&!D&!C1&!C&!B2&B1&!B&!A2&!A1&A|D1&!D&!C1&!C&!B2&B1&!B&!A2&!A1&A|!D1&D&!C1&!C&!B2&B1&!B&!A2&!A1&A|!D1&D&C1&!C&!B2&B1&!B&!A2&!A1&A|D1&!D&C1&!C&!B2&B1&!B&!A2&!A1&A|!D1&!D&C1&!C&!B2&B1&!B&!A2&!A1&A|!D1&D&!C1&C&!B2&B1&!B&!A2&!A1&A|D1&!D&!C1&C&!B2&B1&!B&!A2&!A1&A|!D1&!D&!C1&C&!B2&B1&!B&!A2&!A1&A|!D1&!D&!C1&C&B2&B1&!B&!A2&!A1&A|D1&!D&!C1&C&B2&B1&!B&!A2&!A1&A|!D1&D&!C1&C&B2&B1&!B&!A2&!A1&A|!D1&!D&C1&!C&B2&B1&!B&!A2&!A1&A|D1&!D&C1&!C&B2&B1&!B&!A2&!A1&A|!D1&D&C1&!C&B2&B1&!B&!A2&!A1&A|!D1&D&!C1&!C&B2&B1&!B&!A2&!A1&A|D1&!D&!C1&!C&B2&B1&!B&!A2&!A1&A|!D1&!D&!C1&!C&B2&B1&!B&!A2&!A1&A|!D1&!D&!C1&!C&B2&!B1&!B&!A2&!A1&A|D1&!D&!C1&!C&B2&!B1&!B&!A2&!A1&A|!D1&D&!C1&!C&B2&!B1&!B&!A2&!A1&A|!D1&D&C1&!C&B2&!B1&!B&!A2&!A1&A|D1&!D&C1&!C&B2&!B1&!B&!A2&!A1&A|!D1&!D&C1&!C&B2&!B1&!B&!A2&!A1&A|!D1&D&!C1&C&B2&!B1&!B&!A2&!A1&A|D1&!D&!C1&C&B2&!B1&!B&!A2&!A1&A|!D1&!D&!C1&C&B2&!B1&!B&!A2&!A1&A|!D1&!D&!C1&C&!B2&!B1&!B&!A2&!A1&A|D1&!D&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&D&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&C1&!C&!B2&!B1&!B&!A2&!A1&A|D1&!D&C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&D&C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&D&!C1&!C&!B2&!B1&!B&!A2&!A1&A|D1&!D&!C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOAI3322.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOOAI2133 -l AOOOAI2133 -i D2 D1 D C2 C1 C B A1 A -o Y -f Y=!(D2&!D1&!D&!C2&!C1&C&B&!A1&!A|D2&D1&!D&!C2&!C1&C&B&!A1&!A|!D2&D1&!D&!C2&!C1&C&B&!A1&!A|!D2&D1&D&!C2&!C1&C&B&!A1&!A|D2&D1&D&!C2&!C1&C&B&!A1&!A|D2&!D1&D&!C2&!C1&C&B&!A1&!A|!D2&!D1&D&!C2&!C1&C&B&!A1&!A|!D2&!D1&D&C2&!C1&C&B&!A1&!A|D2&!D1&D&C2&!C1&C&B&!A1&!A|D2&D1&D&C2&!C1&C&B&!A1&!A|!D2&D1&D&C2&!C1&C&B&!A1&!A|!D2&D1&!D&C2&!C1&C&B&!A1&!A|D2&D1&!D&C2&!C1&C&B&!A1&!A|D2&!D1&!D&C2&!C1&C&B&!A1&!A|D2&!D1&!D&C2&C1&C&B&!A1&!A|D2&D1&!D&C2&C1&C&B&!A1&!A|!D2&D1&!D&C2&C1&C&B&!A1&!A|!D2&D1&D&C2&C1&C&B&!A1&!A|D2&D1&D&C2&C1&C&B&!A1&!A|D2&!D1&D&C2&C1&C&B&!A1&!A|!D2&!D1&D&C2&C1&C&B&!A1&!A|!D2&!D1&D&!C2&C1&C&B&!A1&!A|D2&!D1&D&!C2&C1&C&B&!A1&!A|D2&D1&D&!C2&C1&C&B&!A1&!A|!D2&D1&D&!C2&C1&C&B&!A1&!A|!D2&D1&!D&!C2&C1&C&B&!A1&!A|D2&D1&!D&!C2&C1&C&B&!A1&!A|D2&!D1&!D&!C2&C1&C&B&!A1&!A|D2&!D1&!D&!C2&C1&!C&B&!A1&!A|D2&D1&!D&!C2&C1&!C&B&!A1&!A|!D2&D1&!D&!C2&C1&!C&B&!A1&!A|!D2&D1&D&!C2&C1&!C&B&!A1&!A|D2&D1&D&!C2&C1&!C&B&!A1&!A|D2&!D1&D&!C2&C1&!C&B&!A1&!A|!D2&!D1&D&!C2&C1&!C&B&!A1&!A|!D2&!D1&D&C2&C1&!C&B&!A1&!A|D2&!D1&D&C2&C1&!C&B&!A1&!A|D2&D1&D&C2&C1&!C&B&!A1&!A|!D2&D1&D&C2&C1&!C&B&!A1&!A|!D2&D1&!D&C2&C1&!C&B&!A1&!A|D2&D1&!D&C2&C1&!C&B&!A1&!A|D2&!D1&!D&C2&C1&!C&B&!A1&!A|D2&!D1&!D&C2&!C1&!C&B&!A1&!A|D2&D1&!D&C2&!C1&!C&B&!A1&!A|!D2&D1&!D&C2&!C1&!C&B&!A1&!A|!D2&D1&D&C2&!C1&!C&B&!A1&!A|D2&D1&D&C2&!C1&!C&B&!A1&!A|D2&!D1&D&C2&!C1&!C&B&!A1&!A|!D2&!D1&D&C2&!C1&!C&B&!A1&!A|!D2&!D1&D&C2&!C1&!C&B&A1&!A|D2&!D1&D&C2&!C1&!C&B&A1&!A|D2&D1&D&C2&!C1&!C&B&A1&!A|!D2&D1&D&C2&!C1&!C&B&A1&!A|!D2&D1&!D&C2&!C1&!C&B&A1&!A|D2&D1&!D&C2&!C1&!C&B&A1&!A|D2&!D1&!D&C2&!C1&!C&B&A1&!A|D2&!D1&!D&C2&C1&!C&B&A1&!A|D2&D1&!D&C2&C1&!C&B&A1&!A|!D2&D1&!D&C2&C1&!C&B&A1&!A|!D2&D1&D&C2&C1&!C&B&A1&!A|D2&D1&D&C2&C1&!C&B&A1&!A|D2&!D1&D&C2&C1&!C&B&A1&!A|!D2&!D1&D&C2&C1&!C&B&A1&!A|!D2&!D1&D&!C2&C1&!C&B&A1&!A|D2&!D1&D&!C2&C1&!C&B&A1&!A|D2&D1&D&!C2&C1&!C&B&A1&!A|!D2&D1&D&!C2&C1&!C&B&A1&!A|!D2&D1&!D&!C2&C1&!C&B&A1&!A|D2&D1&!D&!C2&C1&!C&B&A1&!A|D2&!D1&!D&!C2&C1&!C&B&A1&!A|D2&!D1&!D&!C2&C1&C&B&A1&!A|D2&D1&!D&!C2&C1&C&B&A1&!A|!D2&D1&!D&!C2&C1&C&B&A1&!A|!D2&D1&D&!C2&C1&C&B&A1&!A|D2&D1&D&!C2&C1&C&B&A1&!A|D2&!D1&D&!C2&C1&C&B&A1&!A|!D2&!D1&D&!C2&C1&C&B&A1&!A|!D2&!D1&D&C2&C1&C&B&A1&!A|D2&!D1&D&C2&C1&C&B&A1&!A|D2&D1&D&C2&C1&C&B&A1&!A|!D2&D1&D&C2&C1&C&B&A1&!A|!D2&D1&!D&C2&C1&C&B&A1&!A|D2&D1&!D&C2&C1&C&B&A1&!A|D2&!D1&!D&C2&C1&C&B&A1&!A|D2&!D1&!D&C2&!C1&C&B&A1&!A|D2&D1&!D&C2&!C1&C&B&A1&!A|!D2&D1&!D&C2&!C1&C&B&A1&!A|!D2&D1&D&C2&!C1&C&B&A1&!A|D2&D1&D&C2&!C1&C&B&A1&!A|D2&!D1&D&C2&!C1&C&B&A1&!A|!D2&!D1&D&C2&!C1&C&B&A1&!A|!D2&!D1&D&!C2&!C1&C&B&A1&!A|D2&!D1&D&!C2&!C1&C&B&A1&!A|D2&D1&D&!C2&!C1&C&B&A1&!A|!D2&D1&D&!C2&!C1&C&B&A1&!A|!D2&D1&!D&!C2&!C1&C&B&A1&!A|D2&D1&!D&!C2&!C1&C&B&A1&!A|D2&!D1&!D&!C2&!C1&C&B&A1&!A|!D2&!D1&D&C2&!C1&!C&!B&A1&A|D2&!D1&D&C2&!C1&!C&!B&A1&A|D2&D1&D&C2&!C1&!C&!B&A1&A|!D2&D1&D&C2&!C1&!C&!B&A1&A|!D2&D1&!D&C2&!C1&!C&!B&A1&A|D2&D1&!D&C2&!C1&!C&!B&A1&A|D2&!D1&!D&C2&!C1&!C&!B&A1&A|D2&!D1&!D&C2&C1&!C&!B&A1&A|D2&D1&!D&C2&C1&!C&!B&A1&A|!D2&D1&!D&C2&C1&!C&!B&A1&A|!D2&D1&D&C2&C1&!C&!B&A1&A|D2&D1&D&C2&C1&!C&!B&A1&A|D2&!D1&D&C2&C1&!C&!B&A1&A|!D2&!D1&D&C2&C1&!C&!B&A1&A|!D2&!D1&D&!C2&C1&!C&!B&A1&A|D2&!D1&D&!C2&C1&!C&!B&A1&A|D2&D1&D&!C2&C1&!C&!B&A1&A|!D2&D1&D&!C2&C1&!C&!B&A1&A|!D2&D1&!D&!C2&C1&!C&!B&A1&A|D2&D1&!D&!C2&C1&!C&!B&A1&A|D2&!D1&!D&!C2&C1&!C&!B&A1&A|D2&!D1&!D&!C2&C1&C&!B&A1&A|D2&D1&!D&!C2&C1&C&!B&A1&A|!D2&D1&!D&!C2&C1&C&!B&A1&A|!D2&D1&D&!C2&C1&C&!B&A1&A|D2&D1&D&!C2&C1&C&!B&A1&A|D2&!D1&D&!C2&C1&C&!B&A1&A|!D2&!D1&D&!C2&C1&C&!B&A1&A|!D2&!D1&D&C2&C1&C&!B&A1&A|D2&!D1&D&C2&C1&C&!B&A1&A|D2&D1&D&C2&C1&C&!B&A1&A|!D2&D1&D&C2&C1&C&!B&A1&A|!D2&D1&!D&C2&C1&C&!B&A1&A|D2&D1&!D&C2&C1&C&!B&A1&A|D2&!D1&!D&C2&C1&C&!B&A1&A|D2&!D1&!D&C2&!C1&C&!B&A1&A|D2&D1&!D&C2&!C1&C&!B&A1&A|!D2&D1&!D&C2&!C1&C&!B&A1&A|!D2&D1&D&C2&!C1&C&!B&A1&A|D2&D1&D&C2&!C1&C&!B&A1&A|D2&!D1&D&C2&!C1&C&!B&A1&A|!D2&!D1&D&C2&!C1&C&!B&A1&A|!D2&!D1&D&!C2&!C1&C&!B&A1&A|D2&!D1&D&!C2&!C1&C&!B&A1&A|D2&D1&D&!C2&!C1&C&!B&A1&A|!D2&D1&D&!C2&!C1&C&!B&A1&A|!D2&D1&!D&!C2&!C1&C&!B&A1&A|D2&D1&!D&!C2&!C1&C&!B&A1&A|D2&!D1&!D&!C2&!C1&C&!B&A1&A|D2&!D1&!D&!C2&!C1&C&B&A1&A|D2&D1&!D&!C2&!C1&C&B&A1&A|!D2&D1&!D&!C2&!C1&C&B&A1&A|!D2&D1&D&!C2&!C1&C&B&A1&A|D2&D1&D&!C2&!C1&C&B&A1&A|D2&!D1&D&!C2&!C1&C&B&A1&A|!D2&!D1&D&!C2&!C1&C&B&A1&A|!D2&!D1&D&C2&!C1&C&B&A1&A|D2&!D1&D&C2&!C1&C&B&A1&A|D2&D1&D&C2&!C1&C&B&A1&A|!D2&D1&D&C2&!C1&C&B&A1&A|!D2&D1&!D&C2&!C1&C&B&A1&A|D2&D1&!D&C2&!C1&C&B&A1&A|D2&!D1&!D&C2&!C1&C&B&A1&A|D2&!D1&!D&C2&C1&C&B&A1&A|D2&D1&!D&C2&C1&C&B&A1&A|!D2&D1&!D&C2&C1&C&B&A1&A|!D2&D1&D&C2&C1&C&B&A1&A|D2&D1&D&C2&C1&C&B&A1&A|D2&!D1&D&C2&C1&C&B&A1&A|!D2&!D1&D&C2&C1&C&B&A1&A|!D2&!D1&D&!C2&C1&C&B&A1&A|D2&!D1&D&!C2&C1&C&B&A1&A|D2&D1&D&!C2&C1&C&B&A1&A|!D2&D1&D&!C2&C1&C&B&A1&A|!D2&D1&!D&!C2&C1&C&B&A1&A|D2&D1&!D&!C2&C1&C&B&A1&A|D2&!D1&!D&!C2&C1&C&B&A1&A|D2&!D1&!D&!C2&C1&!C&B&A1&A|D2&D1&!D&!C2&C1&!C&B&A1&A|!D2&D1&!D&!C2&C1&!C&B&A1&A|!D2&D1&D&!C2&C1&!C&B&A1&A|D2&D1&D&!C2&C1&!C&B&A1&A|D2&!D1&D&!C2&C1&!C&B&A1&A|!D2&!D1&D&!C2&C1&!C&B&A1&A|!D2&!D1&D&C2&C1&!C&B&A1&A|D2&!D1&D&C2&C1&!C&B&A1&A|D2&D1&D&C2&C1&!C&B&A1&A|!D2&D1&D&C2&C1&!C&B&A1&A|!D2&D1&!D&C2&C1&!C&B&A1&A|D2&D1&!D&C2&C1&!C&B&A1&A|D2&!D1&!D&C2&C1&!C&B&A1&A|D2&!D1&!D&C2&!C1&!C&B&A1&A|D2&D1&!D&C2&!C1&!C&B&A1&A|!D2&D1&!D&C2&!C1&!C&B&A1&A|!D2&D1&D&C2&!C1&!C&B&A1&A|D2&D1&D&C2&!C1&!C&B&A1&A|D2&!D1&D&C2&!C1&!C&B&A1&A|!D2&!D1&D&C2&!C1&!C&B&A1&A|!D2&!D1&D&C2&!C1&!C&B&!A1&A|D2&!D1&D&C2&!C1&!C&B&!A1&A|D2&D1&D&C2&!C1&!C&B&!A1&A|!D2&D1&D&C2&!C1&!C&B&!A1&A|!D2&D1&!D&C2&!C1&!C&B&!A1&A|D2&D1&!D&C2&!C1&!C&B&!A1&A|D2&!D1&!D&C2&!C1&!C&B&!A1&A|D2&!D1&!D&C2&C1&!C&B&!A1&A|D2&D1&!D&C2&C1&!C&B&!A1&A|!D2&D1&!D&C2&C1&!C&B&!A1&A|!D2&D1&D&C2&C1&!C&B&!A1&A|D2&D1&D&C2&C1&!C&B&!A1&A|D2&!D1&D&C2&C1&!C&B&!A1&A|!D2&!D1&D&C2&C1&!C&B&!A1&A|!D2&!D1&D&!C2&C1&!C&B&!A1&A|D2&!D1&D&!C2&C1&!C&B&!A1&A|D2&D1&D&!C2&C1&!C&B&!A1&A|!D2&D1&D&!C2&C1&!C&B&!A1&A|!D2&D1&!D&!C2&C1&!C&B&!A1&A|D2&D1&!D&!C2&C1&!C&B&!A1&A|D2&!D1&!D&!C2&C1&!C&B&!A1&A|D2&!D1&!D&!C2&C1&C&B&!A1&A|D2&D1&!D&!C2&C1&C&B&!A1&A|!D2&D1&!D&!C2&C1&C&B&!A1&A|!D2&D1&D&!C2&C1&C&B&!A1&A|D2&D1&D&!C2&C1&C&B&!A1&A|D2&!D1&D&!C2&C1&C&B&!A1&A|!D2&!D1&D&!C2&C1&C&B&!A1&A|!D2&!D1&D&C2&C1&C&B&!A1&A|D2&!D1&D&C2&C1&C&B&!A1&A|D2&D1&D&C2&C1&C&B&!A1&A|!D2&D1&D&C2&C1&C&B&!A1&A|!D2&D1&!D&C2&C1&C&B&!A1&A|D2&D1&!D&C2&C1&C&B&!A1&A|D2&!D1&!D&C2&C1&C&B&!A1&A|D2&!D1&!D&C2&!C1&C&B&!A1&A|D2&D1&!D&C2&!C1&C&B&!A1&A|!D2&D1&!D&C2&!C1&C&B&!A1&A|!D2&D1&D&C2&!C1&C&B&!A1&A|D2&D1&D&C2&!C1&C&B&!A1&A|D2&!D1&D&C2&!C1&C&B&!A1&A|!D2&!D1&D&C2&!C1&C&B&!A1&A|!D2&!D1&D&!C2&!C1&C&B&!A1&A|D2&!D1&D&!C2&!C1&C&B&!A1&A|D2&D1&D&!C2&!C1&C&B&!A1&A|!D2&D1&D&!C2&!C1&C&B&!A1&A|!D2&D1&!D&!C2&!C1&C&B&!A1&A|D2&D1&!D&!C2&!C1&C&B&!A1&A|D2&!D1&!D&!C2&!C1&C&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOOAI2133.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOAOI221211 -l AAOAAOAOI221211 -i F E D1 D C B1 B A1 A -o Y -f Y=(!F&!E&!D1&!D&!C&!B1&!B&!A1&!A|!F&E&!D1&!D&!C&!B1&!B&!A1&!A|!F&E&D1&!D&!C&!B1&!B&!A1&!A|!F&!E&D1&!D&!C&!B1&!B&!A1&!A|!F&!E&D1&D&!C&!B1&!B&!A1&!A|!F&E&!D1&D&!C&!B1&!B&!A1&!A|!F&!E&!D1&D&!C&!B1&!B&!A1&!A|!F&!E&!D1&D&C&!B1&!B&!A1&!A|!F&E&!D1&D&C&!B1&!B&!A1&!A|!F&!E&D1&D&C&!B1&!B&!A1&!A|!F&!E&D1&!D&C&!B1&!B&!A1&!A|!F&E&D1&!D&C&!B1&!B&!A1&!A|!F&E&!D1&!D&C&!B1&!B&!A1&!A|!F&!E&!D1&!D&C&!B1&!B&!A1&!A|!F&!E&!D1&!D&C&B1&!B&!A1&!A|!F&E&!D1&!D&C&B1&!B&!A1&!A|!F&E&D1&!D&C&B1&!B&!A1&!A|!F&!E&D1&!D&C&B1&!B&!A1&!A|!F&!E&D1&D&C&B1&!B&!A1&!A|!F&E&!D1&D&C&B1&!B&!A1&!A|!F&!E&!D1&D&C&B1&!B&!A1&!A|!F&!E&!D1&D&!C&B1&!B&!A1&!A|!F&E&!D1&D&!C&B1&!B&!A1&!A|!F&!E&D1&D&!C&B1&!B&!A1&!A|!F&!E&D1&!D&!C&B1&!B&!A1&!A|!F&E&D1&!D&!C&B1&!B&!A1&!A|!F&E&!D1&!D&!C&B1&!B&!A1&!A|!F&!E&!D1&!D&!C&B1&!B&!A1&!A|!F&!E&!D1&!D&!C&B1&B&!A1&!A|!F&E&!D1&!D&!C&B1&B&!A1&!A|!F&E&D1&!D&!C&B1&B&!A1&!A|!F&!E&D1&!D&!C&B1&B&!A1&!A|!F&!E&D1&D&!C&B1&B&!A1&!A|!F&E&!D1&D&!C&B1&B&!A1&!A|!F&!E&!D1&D&!C&B1&B&!A1&!A|!F&!E&!D1&D&C&B1&B&!A1&!A|!F&!E&D1&D&C&B1&B&!A1&!A|!F&!E&D1&!D&C&B1&B&!A1&!A|!F&!E&!D1&!D&C&B1&B&!A1&!A|!F&!E&!D1&!D&C&!B1&B&!A1&!A|!F&E&!D1&!D&C&!B1&B&!A1&!A|!F&E&D1&!D&C&!B1&B&!A1&!A|!F&!E&D1&!D&C&!B1&B&!A1&!A|!F&!E&D1&D&C&!B1&B&!A1&!A|!F&E&!D1&D&C&!B1&B&!A1&!A|!F&!E&!D1&D&C&!B1&B&!A1&!A|!F&!E&!D1&D&!C&!B1&B&!A1&!A|!F&E&!D1&D&!C&!B1&B&!A1&!A|!F&!E&D1&D&!C&!B1&B&!A1&!A|!F&!E&D1&!D&!C&!B1&B&!A1&!A|!F&E&D1&!D&!C&!B1&B&!A1&!A|!F&E&!D1&!D&!C&!B1&B&!A1&!A|!F&!E&!D1&!D&!C&!B1&B&!A1&!A|!F&!E&!D1&!D&!C&!B1&B&A1&!A|!F&E&!D1&!D&!C&!B1&B&A1&!A|!F&E&D1&!D&!C&!B1&B&A1&!A|!F&!E&D1&!D&!C&!B1&B&A1&!A|!F&!E&D1&D&!C&!B1&B&A1&!A|!F&E&!D1&D&!C&!B1&B&A1&!A|!F&!E&!D1&D&!C&!B1&B&A1&!A|!F&!E&!D1&D&C&!B1&B&A1&!A|!F&E&!D1&D&C&!B1&B&A1&!A|!F&!E&D1&D&C&!B1&B&A1&!A|!F&!E&D1&!D&C&!B1&B&A1&!A|!F&E&D1&!D&C&!B1&B&A1&!A|!F&E&!D1&!D&C&!B1&B&A1&!A|!F&!E&!D1&!D&C&!B1&B&A1&!A|!F&!E&!D1&!D&C&B1&B&A1&!A|!F&!E&D1&!D&C&B1&B&A1&!A|!F&!E&D1&D&C&B1&B&A1&!A|!F&!E&!D1&D&C&B1&B&A1&!A|!F&!E&!D1&D&!C&B1&B&A1&!A|!F&E&!D1&D&!C&B1&B&A1&!A|!F&!E&D1&D&!C&B1&B&A1&!A|!F&!E&D1&!D&!C&B1&B&A1&!A|!F&E&D1&!D&!C&B1&B&A1&!A|!F&E&!D1&!D&!C&B1&B&A1&!A|!F&!E&!D1&!D&!C&B1&B&A1&!A|!F&!E&!D1&!D&!C&B1&!B&A1&!A|!F&E&!D1&!D&!C&B1&!B&A1&!A|!F&E&D1&!D&!C&B1&!B&A1&!A|!F&!E&D1&!D&!C&B1&!B&A1&!A|!F&!E&D1&D&!C&B1&!B&A1&!A|!F&E&!D1&D&!C&B1&!B&A1&!A|!F&!E&!D1&D&!C&B1&!B&A1&!A|!F&!E&!D1&D&C&B1&!B&A1&!A|!F&E&!D1&D&C&B1&!B&A1&!A|!F&!E&D1&D&C&B1&!B&A1&!A|!F&!E&D1&!D&C&B1&!B&A1&!A|!F&E&D1&!D&C&B1&!B&A1&!A|!F&E&!D1&!D&C&B1&!B&A1&!A|!F&!E&!D1&!D&C&B1&!B&A1&!A|!F&!E&!D1&!D&C&!B1&!B&A1&!A|!F&E&!D1&!D&C&!B1&!B&A1&!A|!F&E&D1&!D&C&!B1&!B&A1&!A|!F&!E&D1&!D&C&!B1&!B&A1&!A|!F&!E&D1&D&C&!B1&!B&A1&!A|!F&E&!D1&D&C&!B1&!B&A1&!A|!F&!E&!D1&D&C&!B1&!B&A1&!A|!F&!E&!D1&D&!C&!B1&!B&A1&!A|!F&E&!D1&D&!C&!B1&!B&A1&!A|!F&!E&D1&D&!C&!B1&!B&A1&!A|!F&!E&D1&!D&!C&!B1&!B&A1&!A|!F&E&D1&!D&!C&!B1&!B&A1&!A|!F&E&!D1&!D&!C&!B1&!B&A1&!A|!F&!E&!D1&!D&!C&!B1&!B&A1&!A|!F&!E&!D1&!D&!C&!B1&!B&A1&A|!F&E&!D1&!D&!C&!B1&!B&A1&A|!F&E&D1&!D&!C&!B1&!B&A1&A|!F&!E&D1&!D&!C&!B1&!B&A1&A|!F&!E&D1&D&!C&!B1&!B&A1&A|!F&E&!D1&D&!C&!B1&!B&A1&A|!F&!E&!D1&D&!C&!B1&!B&A1&A|!F&!E&!D1&D&C&!B1&!B&A1&A|!F&!E&D1&D&C&!B1&!B&A1&A|!F&!E&D1&!D&C&!B1&!B&A1&A|!F&!E&!D1&!D&C&!B1&!B&A1&A|!F&!E&!D1&!D&C&B1&!B&A1&A|!F&!E&D1&!D&C&B1&!B&A1&A|!F&!E&D1&D&C&B1&!B&A1&A|!F&!E&!D1&D&C&B1&!B&A1&A|!F&!E&!D1&D&!C&B1&!B&A1&A|!F&E&!D1&D&!C&B1&!B&A1&A|!F&!E&D1&D&!C&B1&!B&A1&A|!F&!E&D1&!D&!C&B1&!B&A1&A|!F&E&D1&!D&!C&B1&!B&A1&A|!F&E&!D1&!D&!C&B1&!B&A1&A|!F&!E&!D1&!D&!C&B1&!B&A1&A|!F&!E&!D1&!D&!C&B1&B&A1&A|!F&E&!D1&!D&!C&B1&B&A1&A|!F&E&D1&!D&!C&B1&B&A1&A|!F&!E&D1&!D&!C&B1&B&A1&A|!F&!E&D1&D&!C&B1&B&A1&A|!F&E&!D1&D&!C&B1&B&A1&A|!F&!E&!D1&D&!C&B1&B&A1&A|!F&!E&!D1&D&C&B1&B&A1&A|!F&!E&D1&D&C&B1&B&A1&A|!F&!E&D1&!D&C&B1&B&A1&A|!F&!E&!D1&!D&C&B1&B&A1&A|!F&!E&!D1&!D&C&!B1&B&A1&A|!F&!E&D1&!D&C&!B1&B&A1&A|!F&!E&D1&D&C&!B1&B&A1&A|!F&!E&!D1&D&C&!B1&B&A1&A|!F&!E&!D1&D&!C&!B1&B&A1&A|!F&E&!D1&D&!C&!B1&B&A1&A|!F&!E&D1&D&!C&!B1&B&A1&A|!F&!E&D1&!D&!C&!B1&B&A1&A|!F&E&D1&!D&!C&!B1&B&A1&A|!F&E&!D1&!D&!C&!B1&B&A1&A|!F&!E&!D1&!D&!C&!B1&B&A1&A|!F&!E&!D1&!D&!C&!B1&B&!A1&A|!F&E&!D1&!D&!C&!B1&B&!A1&A|!F&E&D1&!D&!C&!B1&B&!A1&A|!F&!E&D1&!D&!C&!B1&B&!A1&A|!F&!E&D1&D&!C&!B1&B&!A1&A|!F&E&!D1&D&!C&!B1&B&!A1&A|!F&!E&!D1&D&!C&!B1&B&!A1&A|!F&!E&!D1&D&C&!B1&B&!A1&A|!F&E&!D1&D&C&!B1&B&!A1&A|!F&!E&D1&D&C&!B1&B&!A1&A|!F&!E&D1&!D&C&!B1&B&!A1&A|!F&E&D1&!D&C&!B1&B&!A1&A|!F&E&!D1&!D&C&!B1&B&!A1&A|!F&!E&!D1&!D&C&!B1&B&!A1&A|!F&!E&!D1&!D&C&B1&B&!A1&A|!F&!E&D1&!D&C&B1&B&!A1&A|!F&!E&D1&D&C&B1&B&!A1&A|!F&!E&!D1&D&C&B1&B&!A1&A|!F&!E&!D1&D&!C&B1&B&!A1&A|!F&E&!D1&D&!C&B1&B&!A1&A|!F&!E&D1&D&!C&B1&B&!A1&A|!F&!E&D1&!D&!C&B1&B&!A1&A|!F&E&D1&!D&!C&B1&B&!A1&A|!F&E&!D1&!D&!C&B1&B&!A1&A|!F&!E&!D1&!D&!C&B1&B&!A1&A|!F&!E&!D1&!D&!C&B1&!B&!A1&A|!F&E&!D1&!D&!C&B1&!B&!A1&A|!F&E&D1&!D&!C&B1&!B&!A1&A|!F&!E&D1&!D&!C&B1&!B&!A1&A|!F&!E&D1&D&!C&B1&!B&!A1&A|!F&E&!D1&D&!C&B1&!B&!A1&A|!F&!E&!D1&D&!C&B1&!B&!A1&A|!F&!E&!D1&D&C&B1&!B&!A1&A|!F&E&!D1&D&C&B1&!B&!A1&A|!F&!E&D1&D&C&B1&!B&!A1&A|!F&!E&D1&!D&C&B1&!B&!A1&A|!F&E&D1&!D&C&B1&!B&!A1&A|!F&E&!D1&!D&C&B1&!B&!A1&A|!F&!E&!D1&!D&C&B1&!B&!A1&A|!F&!E&!D1&!D&C&!B1&!B&!A1&A|!F&E&!D1&!D&C&!B1&!B&!A1&A|!F&E&D1&!D&C&!B1&!B&!A1&A|!F&!E&D1&!D&C&!B1&!B&!A1&A|!F&!E&D1&D&C&!B1&!B&!A1&A|!F&E&!D1&D&C&!B1&!B&!A1&A|!F&!E&!D1&D&C&!B1&!B&!A1&A|!F&!E&!D1&D&!C&!B1&!B&!A1&A|!F&E&!D1&D&!C&!B1&!B&!A1&A|!F&!E&D1&D&!C&!B1&!B&!A1&A|!F&!E&D1&!D&!C&!B1&!B&!A1&A|!F&E&D1&!D&!C&!B1&!B&!A1&A|!F&E&!D1&!D&!C&!B1&!B&!A1&A|!F&!E&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOAOI221211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAI322 -l AOOAI322 -i C1 C B1 B A2 A1 A -o Y -f Y=(!C1&!C&!B1&!B&!A2&!A1&!A|C1&!C&!B1&!B&!A2&!A1&!A|C1&C&!B1&!B&!A2&!A1&!A|!C1&C&!B1&!B&!A2&!A1&!A|!C1&!C&B1&!B&!A2&!A1&!A|!C1&!C&B1&B&!A2&!A1&!A|!C1&!C&!B1&B&!A2&!A1&!A|!C1&!C&!B1&B&A2&!A1&!A|!C1&!C&B1&B&A2&!A1&!A|!C1&!C&B1&!B&A2&!A1&!A|!C1&C&!B1&!B&A2&!A1&!A|C1&C&!B1&!B&A2&!A1&!A|C1&!C&!B1&!B&A2&!A1&!A|!C1&!C&!B1&!B&A2&!A1&!A|!C1&!C&!B1&!B&A2&A1&!A|C1&!C&!B1&!B&A2&A1&!A|C1&C&!B1&!B&A2&A1&!A|!C1&C&!B1&!B&A2&A1&!A|!C1&!C&B1&!B&A2&A1&!A|!C1&!C&B1&B&A2&A1&!A|!C1&!C&!B1&B&A2&A1&!A|!C1&!C&!B1&B&!A2&A1&!A|!C1&!C&B1&B&!A2&A1&!A|!C1&!C&B1&!B&!A2&A1&!A|!C1&C&!B1&!B&!A2&A1&!A|C1&C&!B1&!B&!A2&A1&!A|C1&!C&!B1&!B&!A2&A1&!A|!C1&!C&!B1&!B&!A2&A1&!A|!C1&!C&!B1&!B&!A2&A1&A|C1&!C&!B1&!B&!A2&A1&A|C1&C&!B1&!B&!A2&A1&A|!C1&C&!B1&!B&!A2&A1&A|!C1&!C&B1&!B&!A2&A1&A|!C1&!C&B1&B&!A2&A1&A|!C1&!C&!B1&B&!A2&A1&A|!C1&!C&!B1&B&A2&A1&A|!C1&!C&B1&B&A2&A1&A|!C1&!C&B1&!B&A2&A1&A|!C1&!C&!B1&!B&A2&A1&A|!C1&!C&!B1&!B&A2&!A1&A|C1&!C&!B1&!B&A2&!A1&A|C1&C&!B1&!B&A2&!A1&A|!C1&C&!B1&!B&A2&!A1&A|!C1&!C&B1&!B&A2&!A1&A|!C1&!C&B1&B&A2&!A1&A|!C1&!C&!B1&B&A2&!A1&A|!C1&!C&!B1&B&!A2&!A1&A|!C1&!C&B1&B&!A2&!A1&A|!C1&!C&B1&!B&!A2&!A1&A|!C1&C&!B1&!B&!A2&!A1&A|C1&C&!B1&!B&!A2&!A1&A|C1&!C&!B1&!B&!A2&!A1&A|!C1&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAI322.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOAOI212111 -l AOOAOAOI212111 -i F E D C1 C B A1 A -o Y -f Y=(!F&!E&!D&!C1&!C&!B&!A1&!A|!F&E&!D&!C1&!C&!B&!A1&!A|!F&!E&D&!C1&!C&!B&!A1&!A|!F&!E&D&C1&!C&!B&!A1&!A|!F&E&!D&C1&!C&!B&!A1&!A|!F&!E&!D&C1&!C&!B&!A1&!A|!F&!E&!D&C1&C&!B&!A1&!A|!F&E&!D&C1&C&!B&!A1&!A|!F&!E&D&C1&C&!B&!A1&!A|!F&!E&D&!C1&C&!B&!A1&!A|!F&E&!D&!C1&C&!B&!A1&!A|!F&!E&!D&!C1&C&!B&!A1&!A|!F&!E&!D&!C1&C&B&!A1&!A|!F&!E&D&!C1&C&B&!A1&!A|!F&!E&D&C1&C&B&!A1&!A|!F&!E&!D&C1&C&B&!A1&!A|!F&!E&!D&C1&!C&B&!A1&!A|!F&!E&D&C1&!C&B&!A1&!A|!F&!E&D&!C1&!C&B&!A1&!A|!F&E&!D&!C1&!C&B&!A1&!A|!F&!E&!D&!C1&!C&B&!A1&!A|!F&!E&!D&!C1&!C&B&A1&!A|!F&E&!D&!C1&!C&B&A1&!A|!F&!E&D&!C1&!C&B&A1&!A|!F&!E&D&C1&!C&B&A1&!A|!F&!E&!D&C1&!C&B&A1&!A|!F&!E&!D&C1&C&B&A1&!A|!F&!E&D&C1&C&B&A1&!A|!F&!E&D&!C1&C&B&A1&!A|!F&!E&!D&!C1&C&B&A1&!A|!F&!E&!D&!C1&C&!B&A1&!A|!F&E&!D&!C1&C&!B&A1&!A|!F&!E&D&!C1&C&!B&A1&!A|!F&!E&D&C1&C&!B&A1&!A|!F&E&!D&C1&C&!B&A1&!A|!F&!E&!D&C1&C&!B&A1&!A|!F&!E&!D&C1&!C&!B&A1&!A|!F&E&!D&C1&!C&!B&A1&!A|!F&!E&D&C1&!C&!B&A1&!A|!F&!E&D&!C1&!C&!B&A1&!A|!F&E&!D&!C1&!C&!B&A1&!A|!F&!E&!D&!C1&!C&!B&A1&!A|!F&!E&!D&!C1&!C&!B&A1&A|!F&E&!D&!C1&!C&!B&A1&A|!F&!E&D&!C1&!C&!B&A1&A|!F&!E&D&C1&!C&!B&A1&A|!F&!E&!D&C1&!C&!B&A1&A|!F&!E&!D&C1&C&!B&A1&A|!F&!E&D&C1&C&!B&A1&A|!F&!E&D&!C1&C&!B&A1&A|!F&!E&!D&!C1&C&!B&A1&A|!F&!E&!D&!C1&C&B&A1&A|!F&!E&D&!C1&C&B&A1&A|!F&!E&D&C1&C&B&A1&A|!F&!E&!D&C1&C&B&A1&A|!F&!E&!D&C1&!C&B&A1&A|!F&!E&D&C1&!C&B&A1&A|!F&!E&D&!C1&!C&B&A1&A|!F&E&!D&!C1&!C&B&A1&A|!F&!E&!D&!C1&!C&B&A1&A|!F&!E&!D&!C1&!C&B&!A1&A|!F&E&!D&!C1&!C&B&!A1&A|!F&!E&D&!C1&!C&B&!A1&A|!F&!E&D&C1&!C&B&!A1&A|!F&!E&!D&C1&!C&B&!A1&A|!F&!E&!D&C1&C&B&!A1&A|!F&!E&D&C1&C&B&!A1&A|!F&!E&D&!C1&C&B&!A1&A|!F&!E&!D&!C1&C&B&!A1&A|!F&!E&!D&!C1&C&!B&!A1&A|!F&E&!D&!C1&C&!B&!A1&A|!F&!E&D&!C1&C&!B&!A1&A|!F&!E&D&C1&C&!B&!A1&A|!F&E&!D&C1&C&!B&!A1&A|!F&!E&!D&C1&C&!B&!A1&A|!F&!E&!D&C1&!C&!B&!A1&A|!F&E&!D&C1&!C&!B&!A1&A|!F&!E&D&C1&!C&!B&!A1&A|!F&!E&D&!C1&!C&!B&!A1&A|!F&E&!D&!C1&!C&!B&!A1&A|!F&!E&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOAOI212111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOAI2221 -l OOAOAI2221 -i D C1 C B1 B A1 A -o Y -f Y=!(D&C1&!C&!B1&!B&!A1&!A|D&C1&C&!B1&!B&!A1&!A|D&!C1&C&!B1&!B&!A1&!A|D&!C1&C&B1&!B&!A1&!A|D&C1&C&B1&!B&!A1&!A|D&C1&!C&B1&!B&!A1&!A|D&C1&!C&B1&B&!A1&!A|D&C1&C&B1&B&!A1&!A|D&!C1&C&B1&B&!A1&!A|D&!C1&C&!B1&B&!A1&!A|D&C1&C&!B1&B&!A1&!A|D&C1&!C&!B1&B&!A1&!A|D&!C1&!C&!B1&B&A1&!A|D&C1&!C&!B1&B&A1&!A|D&C1&C&!B1&B&A1&!A|D&!C1&C&!B1&B&A1&!A|D&!C1&C&B1&B&A1&!A|D&C1&C&B1&B&A1&!A|D&C1&!C&B1&B&A1&!A|D&!C1&!C&B1&B&A1&!A|D&!C1&!C&B1&!B&A1&!A|D&C1&!C&B1&!B&A1&!A|D&C1&C&B1&!B&A1&!A|D&!C1&C&B1&!B&A1&!A|D&!C1&C&!B1&!B&A1&!A|D&C1&C&!B1&!B&A1&!A|D&C1&!C&!B1&!B&A1&!A|D&C1&!C&!B1&!B&A1&A|D&C1&C&!B1&!B&A1&A|D&!C1&C&!B1&!B&A1&A|D&!C1&C&B1&!B&A1&A|D&C1&C&B1&!B&A1&A|D&C1&!C&B1&!B&A1&A|D&!C1&!C&B1&!B&A1&A|D&!C1&!C&B1&B&A1&A|D&C1&!C&B1&B&A1&A|D&C1&C&B1&B&A1&A|D&!C1&C&B1&B&A1&A|D&!C1&C&!B1&B&A1&A|D&C1&C&!B1&B&A1&A|D&C1&!C&!B1&B&A1&A|D&!C1&!C&!B1&B&A1&A|D&!C1&!C&!B1&B&!A1&A|D&C1&!C&!B1&B&!A1&A|D&C1&C&!B1&B&!A1&A|D&!C1&C&!B1&B&!A1&A|D&!C1&C&B1&B&!A1&A|D&C1&C&B1&B&!A1&A|D&C1&!C&B1&B&!A1&A|D&!C1&!C&B1&B&!A1&A|D&!C1&!C&B1&!B&!A1&A|D&C1&!C&B1&!B&!A1&A|D&C1&C&B1&!B&!A1&A|D&!C1&C&B1&!B&!A1&A|D&!C1&C&!B1&!B&!A1&A|D&C1&C&!B1&!B&!A1&A|D&C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOAI2221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAI3311 -l AAOAI3311 -i D C B2 B1 B A2 A1 A -o Y -f Y=!(D&C&!B2&!B1&!B&!A2&!A1&!A|D&C&B2&!B1&!B&!A2&!A1&!A|D&C&B2&B1&!B&!A2&!A1&!A|D&C&!B2&B1&!B&!A2&!A1&!A|D&C&!B2&B1&B&!A2&!A1&!A|D&C&B2&B1&B&!A2&!A1&!A|D&!C&B2&B1&B&!A2&!A1&!A|D&C&B2&!B1&B&!A2&!A1&!A|D&C&!B2&!B1&B&!A2&!A1&!A|D&C&!B2&!B1&B&A2&!A1&!A|D&C&B2&!B1&B&A2&!A1&!A|D&!C&B2&B1&B&A2&!A1&!A|D&C&B2&B1&B&A2&!A1&!A|D&C&!B2&B1&B&A2&!A1&!A|D&C&!B2&B1&!B&A2&!A1&!A|D&C&B2&B1&!B&A2&!A1&!A|D&C&B2&!B1&!B&A2&!A1&!A|D&C&!B2&!B1&!B&A2&!A1&!A|D&C&!B2&!B1&!B&A2&A1&!A|D&C&B2&!B1&!B&A2&A1&!A|D&C&B2&B1&!B&A2&A1&!A|D&C&!B2&B1&!B&A2&A1&!A|D&C&!B2&B1&B&A2&A1&!A|D&C&B2&B1&B&A2&A1&!A|D&!C&B2&B1&B&A2&A1&!A|D&C&B2&!B1&B&A2&A1&!A|D&C&!B2&!B1&B&A2&A1&!A|D&C&!B2&!B1&B&!A2&A1&!A|D&C&B2&!B1&B&!A2&A1&!A|D&!C&B2&B1&B&!A2&A1&!A|D&C&B2&B1&B&!A2&A1&!A|D&C&!B2&B1&B&!A2&A1&!A|D&C&!B2&B1&!B&!A2&A1&!A|D&C&B2&B1&!B&!A2&A1&!A|D&C&B2&!B1&!B&!A2&A1&!A|D&C&!B2&!B1&!B&!A2&A1&!A|D&C&!B2&!B1&!B&!A2&A1&A|D&C&B2&!B1&!B&!A2&A1&A|D&C&B2&B1&!B&!A2&A1&A|D&C&!B2&B1&!B&!A2&A1&A|D&C&!B2&B1&B&!A2&A1&A|D&C&B2&B1&B&!A2&A1&A|D&!C&B2&B1&B&!A2&A1&A|D&C&B2&!B1&B&!A2&A1&A|D&C&!B2&!B1&B&!A2&A1&A|D&!C&!B2&!B1&B&A2&A1&A|D&C&!B2&!B1&B&A2&A1&A|D&C&B2&!B1&B&A2&A1&A|D&!C&B2&!B1&B&A2&A1&A|D&!C&B2&B1&B&A2&A1&A|D&C&B2&B1&B&A2&A1&A|D&C&!B2&B1&B&A2&A1&A|D&!C&!B2&B1&B&A2&A1&A|D&!C&!B2&B1&!B&A2&A1&A|D&C&!B2&B1&!B&A2&A1&A|D&C&B2&B1&!B&A2&A1&A|D&!C&B2&B1&!B&A2&A1&A|D&!C&B2&!B1&!B&A2&A1&A|D&C&B2&!B1&!B&A2&A1&A|D&C&!B2&!B1&!B&A2&A1&A|D&!C&!B2&!B1&!B&A2&A1&A|D&C&!B2&!B1&!B&A2&!A1&A|D&C&B2&!B1&!B&A2&!A1&A|D&C&B2&B1&!B&A2&!A1&A|D&C&!B2&B1&!B&A2&!A1&A|D&C&!B2&B1&B&A2&!A1&A|D&C&B2&B1&B&A2&!A1&A|D&!C&B2&B1&B&A2&!A1&A|D&C&B2&!B1&B&A2&!A1&A|D&C&!B2&!B1&B&A2&!A1&A|D&C&!B2&!B1&B&!A2&!A1&A|D&C&B2&!B1&B&!A2&!A1&A|D&!C&B2&B1&B&!A2&!A1&A|D&C&B2&B1&B&!A2&!A1&A|D&C&!B2&B1&B&!A2&!A1&A|D&C&!B2&B1&!B&!A2&!A1&A|D&C&B2&B1&!B&!A2&!A1&A|D&C&B2&!B1&!B&!A2&!A1&A|D&C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAI3311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAI222 -l AAOOAI222 -i C1 C B1 B A1 A -o Y -f Y=!(C1&!C&B1&B&!A1&!A|C1&C&B1&B&!A1&!A|!C1&C&B1&B&!A1&!A|!C1&C&B1&B&A1&!A|C1&C&B1&B&A1&!A|C1&!C&B1&B&A1&!A|C1&!C&!B1&!B&A1&A|C1&C&!B1&!B&A1&A|!C1&C&!B1&!B&A1&A|!C1&C&B1&!B&A1&A|C1&C&B1&!B&A1&A|C1&!C&B1&!B&A1&A|C1&!C&B1&B&A1&A|C1&C&B1&B&A1&A|!C1&C&B1&B&A1&A|!C1&C&!B1&B&A1&A|C1&C&!B1&B&A1&A|C1&!C&!B1&B&A1&A|!C1&C&B1&B&!A1&A|C1&C&B1&B&!A1&A|C1&!C&B1&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAI222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOI2124 -l AOOAAOI2124 -i D3 D2 D1 D C1 C B A1 A -o Y -f Y=(!D3&!D2&!D1&!D&!C1&!C&!B&!A1&!A|D3&!D2&!D1&!D&!C1&!C&!B&!A1&!A|D3&D2&!D1&!D&!C1&!C&!B&!A1&!A|!D3&D2&!D1&!D&!C1&!C&!B&!A1&!A|!D3&D2&D1&!D&!C1&!C&!B&!A1&!A|D3&D2&D1&!D&!C1&!C&!B&!A1&!A|D3&!D2&D1&!D&!C1&!C&!B&!A1&!A|!D3&!D2&D1&!D&!C1&!C&!B&!A1&!A|!D3&!D2&D1&D&!C1&!C&!B&!A1&!A|D3&!D2&D1&D&!C1&!C&!B&!A1&!A|!D3&D2&D1&D&!C1&!C&!B&!A1&!A|!D3&D2&!D1&D&!C1&!C&!B&!A1&!A|D3&D2&!D1&D&!C1&!C&!B&!A1&!A|D3&!D2&!D1&D&!C1&!C&!B&!A1&!A|!D3&!D2&!D1&D&!C1&!C&!B&!A1&!A|!D3&!D2&!D1&D&C1&!C&!B&!A1&!A|D3&!D2&!D1&D&C1&!C&!B&!A1&!A|D3&D2&!D1&D&C1&!C&!B&!A1&!A|!D3&D2&!D1&D&C1&!C&!B&!A1&!A|!D3&D2&D1&D&C1&!C&!B&!A1&!A|D3&!D2&D1&D&C1&!C&!B&!A1&!A|!D3&!D2&D1&D&C1&!C&!B&!A1&!A|!D3&!D2&D1&!D&C1&!C&!B&!A1&!A|D3&!D2&D1&!D&C1&!C&!B&!A1&!A|D3&D2&D1&!D&C1&!C&!B&!A1&!A|!D3&D2&D1&!D&C1&!C&!B&!A1&!A|!D3&D2&!D1&!D&C1&!C&!B&!A1&!A|D3&D2&!D1&!D&C1&!C&!B&!A1&!A|D3&!D2&!D1&!D&C1&!C&!B&!A1&!A|!D3&!D2&!D1&!D&C1&!C&!B&!A1&!A|!D3&!D2&!D1&!D&C1&C&!B&!A1&!A|D3&!D2&!D1&!D&C1&C&!B&!A1&!A|D3&D2&!D1&!D&C1&C&!B&!A1&!A|!D3&D2&!D1&!D&C1&C&!B&!A1&!A|!D3&D2&D1&!D&C1&C&!B&!A1&!A|D3&D2&D1&!D&C1&C&!B&!A1&!A|D3&!D2&D1&!D&C1&C&!B&!A1&!A|!D3&!D2&D1&!D&C1&C&!B&!A1&!A|!D3&!D2&D1&D&C1&C&!B&!A1&!A|D3&!D2&D1&D&C1&C&!B&!A1&!A|!D3&D2&D1&D&C1&C&!B&!A1&!A|!D3&D2&!D1&D&C1&C&!B&!A1&!A|D3&D2&!D1&D&C1&C&!B&!A1&!A|D3&!D2&!D1&D&C1&C&!B&!A1&!A|!D3&!D2&!D1&D&C1&C&!B&!A1&!A|!D3&!D2&!D1&D&!C1&C&!B&!A1&!A|D3&!D2&!D1&D&!C1&C&!B&!A1&!A|D3&D2&!D1&D&!C1&C&!B&!A1&!A|!D3&D2&!D1&D&!C1&C&!B&!A1&!A|!D3&D2&D1&D&!C1&C&!B&!A1&!A|D3&!D2&D1&D&!C1&C&!B&!A1&!A|!D3&!D2&D1&D&!C1&C&!B&!A1&!A|!D3&!D2&D1&!D&!C1&C&!B&!A1&!A|D3&!D2&D1&!D&!C1&C&!B&!A1&!A|D3&D2&D1&!D&!C1&C&!B&!A1&!A|!D3&D2&D1&!D&!C1&C&!B&!A1&!A|!D3&D2&!D1&!D&!C1&C&!B&!A1&!A|D3&D2&!D1&!D&!C1&C&!B&!A1&!A|D3&!D2&!D1&!D&!C1&C&!B&!A1&!A|!D3&!D2&!D1&!D&!C1&C&!B&!A1&!A|!D3&!D2&!D1&D&!C1&!C&B&!A1&!A|D3&!D2&!D1&D&!C1&!C&B&!A1&!A|D3&D2&!D1&D&!C1&!C&B&!A1&!A|!D3&D2&!D1&D&!C1&!C&B&!A1&!A|!D3&D2&D1&D&!C1&!C&B&!A1&!A|D3&!D2&D1&D&!C1&!C&B&!A1&!A|!D3&!D2&D1&D&!C1&!C&B&!A1&!A|!D3&!D2&D1&!D&!C1&!C&B&!A1&!A|D3&!D2&D1&!D&!C1&!C&B&!A1&!A|D3&D2&D1&!D&!C1&!C&B&!A1&!A|!D3&D2&D1&!D&!C1&!C&B&!A1&!A|!D3&D2&!D1&!D&!C1&!C&B&!A1&!A|D3&D2&!D1&!D&!C1&!C&B&!A1&!A|D3&!D2&!D1&!D&!C1&!C&B&!A1&!A|!D3&!D2&!D1&!D&!C1&!C&B&!A1&!A|!D3&!D2&!D1&!D&!C1&!C&B&A1&!A|D3&!D2&!D1&!D&!C1&!C&B&A1&!A|D3&D2&!D1&!D&!C1&!C&B&A1&!A|!D3&D2&!D1&!D&!C1&!C&B&A1&!A|!D3&D2&D1&!D&!C1&!C&B&A1&!A|D3&D2&D1&!D&!C1&!C&B&A1&!A|D3&!D2&D1&!D&!C1&!C&B&A1&!A|!D3&!D2&D1&!D&!C1&!C&B&A1&!A|!D3&!D2&D1&D&!C1&!C&B&A1&!A|D3&!D2&D1&D&!C1&!C&B&A1&!A|!D3&D2&D1&D&!C1&!C&B&A1&!A|!D3&D2&!D1&D&!C1&!C&B&A1&!A|D3&D2&!D1&D&!C1&!C&B&A1&!A|D3&!D2&!D1&D&!C1&!C&B&A1&!A|!D3&!D2&!D1&D&!C1&!C&B&A1&!A|!D3&!D2&!D1&!D&!C1&C&!B&A1&!A|D3&!D2&!D1&!D&!C1&C&!B&A1&!A|D3&D2&!D1&!D&!C1&C&!B&A1&!A|!D3&D2&!D1&!D&!C1&C&!B&A1&!A|!D3&D2&D1&!D&!C1&C&!B&A1&!A|D3&D2&D1&!D&!C1&C&!B&A1&!A|D3&!D2&D1&!D&!C1&C&!B&A1&!A|!D3&!D2&D1&!D&!C1&C&!B&A1&!A|!D3&!D2&D1&D&!C1&C&!B&A1&!A|D3&!D2&D1&D&!C1&C&!B&A1&!A|!D3&D2&D1&D&!C1&C&!B&A1&!A|!D3&D2&!D1&D&!C1&C&!B&A1&!A|D3&D2&!D1&D&!C1&C&!B&A1&!A|D3&!D2&!D1&D&!C1&C&!B&A1&!A|!D3&!D2&!D1&D&!C1&C&!B&A1&!A|!D3&!D2&!D1&D&C1&C&!B&A1&!A|D3&!D2&!D1&D&C1&C&!B&A1&!A|D3&D2&!D1&D&C1&C&!B&A1&!A|!D3&D2&!D1&D&C1&C&!B&A1&!A|!D3&D2&D1&D&C1&C&!B&A1&!A|D3&!D2&D1&D&C1&C&!B&A1&!A|!D3&!D2&D1&D&C1&C&!B&A1&!A|!D3&!D2&D1&!D&C1&C&!B&A1&!A|D3&!D2&D1&!D&C1&C&!B&A1&!A|D3&D2&D1&!D&C1&C&!B&A1&!A|!D3&D2&D1&!D&C1&C&!B&A1&!A|!D3&D2&!D1&!D&C1&C&!B&A1&!A|D3&D2&!D1&!D&C1&C&!B&A1&!A|D3&!D2&!D1&!D&C1&C&!B&A1&!A|!D3&!D2&!D1&!D&C1&C&!B&A1&!A|!D3&!D2&!D1&!D&C1&!C&!B&A1&!A|D3&!D2&!D1&!D&C1&!C&!B&A1&!A|D3&D2&!D1&!D&C1&!C&!B&A1&!A|!D3&D2&!D1&!D&C1&!C&!B&A1&!A|!D3&D2&D1&!D&C1&!C&!B&A1&!A|D3&D2&D1&!D&C1&!C&!B&A1&!A|D3&!D2&D1&!D&C1&!C&!B&A1&!A|!D3&!D2&D1&!D&C1&!C&!B&A1&!A|!D3&!D2&D1&D&C1&!C&!B&A1&!A|D3&!D2&D1&D&C1&!C&!B&A1&!A|!D3&D2&D1&D&C1&!C&!B&A1&!A|!D3&D2&!D1&D&C1&!C&!B&A1&!A|D3&D2&!D1&D&C1&!C&!B&A1&!A|D3&!D2&!D1&D&C1&!C&!B&A1&!A|!D3&!D2&!D1&D&C1&!C&!B&A1&!A|!D3&!D2&!D1&D&!C1&!C&!B&A1&!A|D3&!D2&!D1&D&!C1&!C&!B&A1&!A|D3&D2&!D1&D&!C1&!C&!B&A1&!A|!D3&D2&!D1&D&!C1&!C&!B&A1&!A|!D3&D2&D1&D&!C1&!C&!B&A1&!A|D3&!D2&D1&D&!C1&!C&!B&A1&!A|!D3&!D2&D1&D&!C1&!C&!B&A1&!A|!D3&!D2&D1&!D&!C1&!C&!B&A1&!A|D3&!D2&D1&!D&!C1&!C&!B&A1&!A|D3&D2&D1&!D&!C1&!C&!B&A1&!A|!D3&D2&D1&!D&!C1&!C&!B&A1&!A|!D3&D2&!D1&!D&!C1&!C&!B&A1&!A|D3&D2&!D1&!D&!C1&!C&!B&A1&!A|D3&!D2&!D1&!D&!C1&!C&!B&A1&!A|!D3&!D2&!D1&!D&!C1&!C&!B&A1&!A|!D3&!D2&!D1&!D&!C1&!C&!B&A1&A|D3&!D2&!D1&!D&!C1&!C&!B&A1&A|D3&D2&!D1&!D&!C1&!C&!B&A1&A|!D3&D2&!D1&!D&!C1&!C&!B&A1&A|!D3&D2&D1&!D&!C1&!C&!B&A1&A|D3&D2&D1&!D&!C1&!C&!B&A1&A|D3&!D2&D1&!D&!C1&!C&!B&A1&A|!D3&!D2&D1&!D&!C1&!C&!B&A1&A|!D3&!D2&D1&D&!C1&!C&!B&A1&A|D3&!D2&D1&D&!C1&!C&!B&A1&A|!D3&D2&D1&D&!C1&!C&!B&A1&A|!D3&D2&!D1&D&!C1&!C&!B&A1&A|D3&D2&!D1&D&!C1&!C&!B&A1&A|D3&!D2&!D1&D&!C1&!C&!B&A1&A|!D3&!D2&!D1&D&!C1&!C&!B&A1&A|!D3&!D2&!D1&D&!C1&!C&B&A1&A|D3&!D2&!D1&D&!C1&!C&B&A1&A|D3&D2&!D1&D&!C1&!C&B&A1&A|!D3&D2&!D1&D&!C1&!C&B&A1&A|!D3&D2&D1&D&!C1&!C&B&A1&A|D3&!D2&D1&D&!C1&!C&B&A1&A|!D3&!D2&D1&D&!C1&!C&B&A1&A|!D3&!D2&D1&!D&!C1&!C&B&A1&A|D3&!D2&D1&!D&!C1&!C&B&A1&A|D3&D2&D1&!D&!C1&!C&B&A1&A|!D3&D2&D1&!D&!C1&!C&B&A1&A|!D3&D2&!D1&!D&!C1&!C&B&A1&A|D3&D2&!D1&!D&!C1&!C&B&A1&A|D3&!D2&!D1&!D&!C1&!C&B&A1&A|!D3&!D2&!D1&!D&!C1&!C&B&A1&A|!D3&!D2&!D1&!D&!C1&!C&B&!A1&A|D3&!D2&!D1&!D&!C1&!C&B&!A1&A|D3&D2&!D1&!D&!C1&!C&B&!A1&A|!D3&D2&!D1&!D&!C1&!C&B&!A1&A|!D3&D2&D1&!D&!C1&!C&B&!A1&A|D3&D2&D1&!D&!C1&!C&B&!A1&A|D3&!D2&D1&!D&!C1&!C&B&!A1&A|!D3&!D2&D1&!D&!C1&!C&B&!A1&A|!D3&!D2&D1&D&!C1&!C&B&!A1&A|D3&!D2&D1&D&!C1&!C&B&!A1&A|!D3&D2&D1&D&!C1&!C&B&!A1&A|!D3&D2&!D1&D&!C1&!C&B&!A1&A|D3&D2&!D1&D&!C1&!C&B&!A1&A|D3&!D2&!D1&D&!C1&!C&B&!A1&A|!D3&!D2&!D1&D&!C1&!C&B&!A1&A|!D3&!D2&!D1&!D&!C1&C&!B&!A1&A|D3&!D2&!D1&!D&!C1&C&!B&!A1&A|D3&D2&!D1&!D&!C1&C&!B&!A1&A|!D3&D2&!D1&!D&!C1&C&!B&!A1&A|!D3&D2&D1&!D&!C1&C&!B&!A1&A|D3&D2&D1&!D&!C1&C&!B&!A1&A|D3&!D2&D1&!D&!C1&C&!B&!A1&A|!D3&!D2&D1&!D&!C1&C&!B&!A1&A|!D3&!D2&D1&D&!C1&C&!B&!A1&A|D3&!D2&D1&D&!C1&C&!B&!A1&A|!D3&D2&D1&D&!C1&C&!B&!A1&A|!D3&D2&!D1&D&!C1&C&!B&!A1&A|D3&D2&!D1&D&!C1&C&!B&!A1&A|D3&!D2&!D1&D&!C1&C&!B&!A1&A|!D3&!D2&!D1&D&!C1&C&!B&!A1&A|!D3&!D2&!D1&D&C1&C&!B&!A1&A|D3&!D2&!D1&D&C1&C&!B&!A1&A|D3&D2&!D1&D&C1&C&!B&!A1&A|!D3&D2&!D1&D&C1&C&!B&!A1&A|!D3&D2&D1&D&C1&C&!B&!A1&A|D3&!D2&D1&D&C1&C&!B&!A1&A|!D3&!D2&D1&D&C1&C&!B&!A1&A|!D3&!D2&D1&!D&C1&C&!B&!A1&A|D3&!D2&D1&!D&C1&C&!B&!A1&A|D3&D2&D1&!D&C1&C&!B&!A1&A|!D3&D2&D1&!D&C1&C&!B&!A1&A|!D3&D2&!D1&!D&C1&C&!B&!A1&A|D3&D2&!D1&!D&C1&C&!B&!A1&A|D3&!D2&!D1&!D&C1&C&!B&!A1&A|!D3&!D2&!D1&!D&C1&C&!B&!A1&A|!D3&!D2&!D1&!D&C1&!C&!B&!A1&A|D3&!D2&!D1&!D&C1&!C&!B&!A1&A|D3&D2&!D1&!D&C1&!C&!B&!A1&A|!D3&D2&!D1&!D&C1&!C&!B&!A1&A|!D3&D2&D1&!D&C1&!C&!B&!A1&A|D3&D2&D1&!D&C1&!C&!B&!A1&A|D3&!D2&D1&!D&C1&!C&!B&!A1&A|!D3&!D2&D1&!D&C1&!C&!B&!A1&A|!D3&!D2&D1&D&C1&!C&!B&!A1&A|D3&!D2&D1&D&C1&!C&!B&!A1&A|!D3&D2&D1&D&C1&!C&!B&!A1&A|!D3&D2&!D1&D&C1&!C&!B&!A1&A|D3&D2&!D1&D&C1&!C&!B&!A1&A|D3&!D2&!D1&D&C1&!C&!B&!A1&A|!D3&!D2&!D1&D&C1&!C&!B&!A1&A|!D3&!D2&!D1&D&!C1&!C&!B&!A1&A|D3&!D2&!D1&D&!C1&!C&!B&!A1&A|D3&D2&!D1&D&!C1&!C&!B&!A1&A|!D3&D2&!D1&D&!C1&!C&!B&!A1&A|!D3&D2&D1&D&!C1&!C&!B&!A1&A|D3&!D2&D1&D&!C1&!C&!B&!A1&A|!D3&!D2&D1&D&!C1&!C&!B&!A1&A|!D3&!D2&D1&!D&!C1&!C&!B&!A1&A|D3&!D2&D1&!D&!C1&!C&!B&!A1&A|D3&D2&D1&!D&!C1&!C&!B&!A1&A|!D3&D2&D1&!D&!C1&!C&!B&!A1&A|!D3&D2&!D1&!D&!C1&!C&!B&!A1&A|D3&D2&!D1&!D&!C1&!C&!B&!A1&A|D3&!D2&!D1&!D&!C1&!C&!B&!A1&A|!D3&!D2&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOI2124.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOOAAOI22132 -l OOAOOAAOI22132 -i E1 E D2 D1 D C B1 B A1 A -o Y -f Y=(!E1&!E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!E1&E&D2&!D1&!D&!C&!B1&!B&!A1&!A|E1&!E&D2&!D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&D2&D1&!D&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&!D&!C&!B1&!B&!A1&!A|!E1&E&D2&D1&!D&!C&!B1&!B&!A1&!A|!E1&E&!D2&D1&!D&!C&!B1&!B&!A1&!A|E1&!E&!D2&D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&D&!C&!B1&!B&!A1&!A|E1&!E&!D2&D1&D&!C&!B1&!B&!A1&!A|!E1&E&!D2&D1&D&!C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&!C&!B1&!B&!A1&!A|!E1&!E&D2&D1&D&!C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&D&!C&!B1&!B&!A1&!A|E1&!E&D2&!D1&D&!C&!B1&!B&!A1&!A|!E1&E&D2&!D1&D&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&D&!C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&D&!C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C&B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&C&B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C&B1&!B&!A1&!A|E1&!E&!D2&!D1&D&!C&B1&!B&!A1&!A|!E1&E&!D2&!D1&D&!C&B1&!B&!A1&!A|!E1&E&D2&!D1&D&!C&B1&!B&!A1&!A|E1&!E&D2&!D1&D&!C&B1&!B&!A1&!A|!E1&!E&D2&!D1&D&!C&B1&!B&!A1&!A|!E1&!E&D2&D1&D&!C&B1&!B&!A1&!A|E1&!E&D2&D1&D&!C&B1&!B&!A1&!A|!E1&E&D2&D1&D&!C&B1&!B&!A1&!A|!E1&E&!D2&D1&D&!C&B1&!B&!A1&!A|E1&!E&!D2&D1&D&!C&B1&!B&!A1&!A|!E1&!E&!D2&D1&D&!C&B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C&B1&!B&!A1&!A|E1&!E&!D2&D1&!D&!C&B1&!B&!A1&!A|!E1&E&!D2&D1&!D&!C&B1&!B&!A1&!A|!E1&E&D2&D1&!D&!C&B1&!B&!A1&!A|E1&!E&D2&D1&!D&!C&B1&!B&!A1&!A|!E1&!E&D2&D1&!D&!C&B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C&B1&!B&!A1&!A|E1&!E&D2&!D1&!D&!C&B1&!B&!A1&!A|!E1&E&D2&!D1&!D&!C&B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C&B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&!C&B1&B&!A1&!A|!E1&E&D2&!D1&!D&!C&B1&B&!A1&!A|E1&!E&D2&!D1&!D&!C&B1&B&!A1&!A|!E1&!E&D2&!D1&!D&!C&B1&B&!A1&!A|!E1&!E&D2&D1&!D&!C&B1&B&!A1&!A|E1&!E&D2&D1&!D&!C&B1&B&!A1&!A|!E1&E&D2&D1&!D&!C&B1&B&!A1&!A|!E1&E&!D2&D1&!D&!C&B1&B&!A1&!A|E1&!E&!D2&D1&!D&!C&B1&B&!A1&!A|!E1&!E&!D2&D1&!D&!C&B1&B&!A1&!A|!E1&!E&!D2&D1&D&!C&B1&B&!A1&!A|E1&!E&!D2&D1&D&!C&B1&B&!A1&!A|!E1&E&!D2&D1&D&!C&B1&B&!A1&!A|!E1&E&D2&D1&D&!C&B1&B&!A1&!A|E1&!E&D2&D1&D&!C&B1&B&!A1&!A|!E1&!E&D2&D1&D&!C&B1&B&!A1&!A|!E1&!E&D2&!D1&D&!C&B1&B&!A1&!A|E1&!E&D2&!D1&D&!C&B1&B&!A1&!A|!E1&E&D2&!D1&D&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&D&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&D&!C&B1&B&!A1&!A|!E1&!E&!D2&!D1&D&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C&B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&C&B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&C&!B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C&!B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&D&!C&!B1&B&!A1&!A|E1&!E&!D2&!D1&D&!C&!B1&B&!A1&!A|!E1&E&!D2&!D1&D&!C&!B1&B&!A1&!A|!E1&E&D2&!D1&D&!C&!B1&B&!A1&!A|E1&!E&D2&!D1&D&!C&!B1&B&!A1&!A|!E1&!E&D2&!D1&D&!C&!B1&B&!A1&!A|!E1&!E&D2&D1&D&!C&!B1&B&!A1&!A|E1&!E&D2&D1&D&!C&!B1&B&!A1&!A|!E1&E&D2&D1&D&!C&!B1&B&!A1&!A|!E1&E&!D2&D1&D&!C&!B1&B&!A1&!A|E1&!E&!D2&D1&D&!C&!B1&B&!A1&!A|!E1&!E&!D2&D1&D&!C&!B1&B&!A1&!A|!E1&!E&!D2&D1&!D&!C&!B1&B&!A1&!A|E1&!E&!D2&D1&!D&!C&!B1&B&!A1&!A|!E1&E&!D2&D1&!D&!C&!B1&B&!A1&!A|!E1&E&D2&D1&!D&!C&!B1&B&!A1&!A|E1&!E&D2&D1&!D&!C&!B1&B&!A1&!A|!E1&!E&D2&D1&!D&!C&!B1&B&!A1&!A|!E1&!E&D2&!D1&!D&!C&!B1&B&!A1&!A|E1&!E&D2&!D1&!D&!C&!B1&B&!A1&!A|!E1&E&D2&!D1&!D&!C&!B1&B&!A1&!A|!E1&E&!D2&!D1&!D&!C&!B1&B&!A1&!A|E1&!E&!D2&!D1&!D&!C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&!C&!B1&B&A1&!A|!E1&E&!D2&!D1&!D&!C&!B1&B&A1&!A|!E1&E&!D2&!D1&!D&C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&C&!B1&B&A1&!A|!E1&!E&!D2&!D1&!D&C&!B1&B&A1&!A|!E1&!E&!D2&!D1&!D&C&B1&B&A1&!A|E1&!E&!D2&!D1&!D&C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&!C&B1&B&A1&!A|E1&!E&!D2&!D1&!D&!C&B1&B&A1&!A|!E1&!E&!D2&!D1&!D&!C&B1&B&A1&!A|!E1&!E&!D2&!D1&!D&!C&B1&!B&A1&!A|E1&!E&!D2&!D1&!D&!C&B1&!B&A1&!A|!E1&E&!D2&!D1&!D&!C&B1&!B&A1&!A|!E1&E&!D2&!D1&!D&C&B1&!B&A1&!A|E1&!E&!D2&!D1&!D&C&B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&C&B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&C&!B1&!B&A1&!A|E1&!E&!D2&!D1&!D&C&!B1&!B&A1&!A|!E1&E&!D2&!D1&!D&C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&D&!C&!B1&!B&A1&!A|E1&!E&!D2&!D1&D&!C&!B1&!B&A1&!A|!E1&E&!D2&!D1&D&!C&!B1&!B&A1&!A|!E1&E&D2&!D1&D&!C&!B1&!B&A1&!A|E1&!E&D2&!D1&D&!C&!B1&!B&A1&!A|!E1&!E&D2&!D1&D&!C&!B1&!B&A1&!A|!E1&!E&D2&D1&D&!C&!B1&!B&A1&!A|E1&!E&D2&D1&D&!C&!B1&!B&A1&!A|!E1&E&D2&D1&D&!C&!B1&!B&A1&!A|!E1&E&!D2&D1&D&!C&!B1&!B&A1&!A|E1&!E&!D2&D1&D&!C&!B1&!B&A1&!A|!E1&!E&!D2&D1&D&!C&!B1&!B&A1&!A|!E1&!E&!D2&D1&!D&!C&!B1&!B&A1&!A|E1&!E&!D2&D1&!D&!C&!B1&!B&A1&!A|!E1&E&!D2&D1&!D&!C&!B1&!B&A1&!A|!E1&E&D2&D1&!D&!C&!B1&!B&A1&!A|E1&!E&D2&D1&!D&!C&!B1&!B&A1&!A|!E1&!E&D2&D1&!D&!C&!B1&!B&A1&!A|!E1&!E&D2&!D1&!D&!C&!B1&!B&A1&!A|E1&!E&D2&!D1&!D&!C&!B1&!B&A1&!A|!E1&E&D2&!D1&!D&!C&!B1&!B&A1&!A|!E1&E&!D2&!D1&!D&!C&!B1&!B&A1&!A|E1&!E&!D2&!D1&!D&!C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&!C&!B1&!B&A1&A|!E1&E&D2&!D1&!D&!C&!B1&!B&A1&A|E1&!E&D2&!D1&!D&!C&!B1&!B&A1&A|!E1&!E&D2&!D1&!D&!C&!B1&!B&A1&A|!E1&!E&D2&D1&!D&!C&!B1&!B&A1&A|E1&!E&D2&D1&!D&!C&!B1&!B&A1&A|!E1&E&D2&D1&!D&!C&!B1&!B&A1&A|!E1&E&!D2&D1&!D&!C&!B1&!B&A1&A|E1&!E&!D2&D1&!D&!C&!B1&!B&A1&A|!E1&!E&!D2&D1&!D&!C&!B1&!B&A1&A|!E1&!E&!D2&D1&D&!C&!B1&!B&A1&A|E1&!E&!D2&D1&D&!C&!B1&!B&A1&A|!E1&E&!D2&D1&D&!C&!B1&!B&A1&A|!E1&E&D2&D1&D&!C&!B1&!B&A1&A|E1&!E&D2&D1&D&!C&!B1&!B&A1&A|!E1&!E&D2&D1&D&!C&!B1&!B&A1&A|!E1&!E&D2&!D1&D&!C&!B1&!B&A1&A|E1&!E&D2&!D1&D&!C&!B1&!B&A1&A|!E1&E&D2&!D1&D&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&D&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&D&!C&!B1&!B&A1&A|!E1&!E&!D2&!D1&D&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&C&!B1&!B&A1&A|!E1&!E&!D2&!D1&!D&C&!B1&!B&A1&A|!E1&!E&!D2&!D1&!D&C&B1&!B&A1&A|E1&!E&!D2&!D1&!D&C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&!C&B1&!B&A1&A|E1&!E&!D2&!D1&!D&!C&B1&!B&A1&A|!E1&!E&!D2&!D1&!D&!C&B1&!B&A1&A|!E1&!E&!D2&!D1&!D&!C&B1&B&A1&A|E1&!E&!D2&!D1&!D&!C&B1&B&A1&A|!E1&E&!D2&!D1&!D&!C&B1&B&A1&A|!E1&E&!D2&!D1&!D&C&B1&B&A1&A|E1&!E&!D2&!D1&!D&C&B1&B&A1&A|!E1&!E&!D2&!D1&!D&C&B1&B&A1&A|!E1&!E&!D2&!D1&!D&C&!B1&B&A1&A|E1&!E&!D2&!D1&!D&C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&!C&!B1&B&A1&A|E1&!E&!D2&!D1&!D&!C&!B1&B&A1&A|!E1&!E&!D2&!D1&!D&!C&!B1&B&A1&A|!E1&!E&!D2&!D1&!D&!C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&!C&!B1&B&!A1&A|!E1&E&!D2&!D1&!D&!C&!B1&B&!A1&A|!E1&E&!D2&!D1&!D&C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&C&!B1&B&!A1&A|!E1&!E&!D2&!D1&!D&C&!B1&B&!A1&A|!E1&!E&!D2&!D1&!D&C&B1&B&!A1&A|E1&!E&!D2&!D1&!D&C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&!C&B1&B&!A1&A|E1&!E&!D2&!D1&!D&!C&B1&B&!A1&A|!E1&!E&!D2&!D1&!D&!C&B1&B&!A1&A|!E1&!E&!D2&!D1&!D&!C&B1&!B&!A1&A|E1&!E&!D2&!D1&!D&!C&B1&!B&!A1&A|!E1&E&!D2&!D1&!D&!C&B1&!B&!A1&A|!E1&E&!D2&!D1&!D&C&B1&!B&!A1&A|E1&!E&!D2&!D1&!D&C&B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&C&B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&C&!B1&!B&!A1&A|E1&!E&!D2&!D1&!D&C&!B1&!B&!A1&A|!E1&E&!D2&!D1&!D&C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&D&!C&!B1&!B&!A1&A|E1&!E&!D2&!D1&D&!C&!B1&!B&!A1&A|!E1&E&!D2&!D1&D&!C&!B1&!B&!A1&A|!E1&E&D2&!D1&D&!C&!B1&!B&!A1&A|E1&!E&D2&!D1&D&!C&!B1&!B&!A1&A|!E1&!E&D2&!D1&D&!C&!B1&!B&!A1&A|!E1&!E&D2&D1&D&!C&!B1&!B&!A1&A|E1&!E&D2&D1&D&!C&!B1&!B&!A1&A|!E1&E&D2&D1&D&!C&!B1&!B&!A1&A|!E1&E&!D2&D1&D&!C&!B1&!B&!A1&A|E1&!E&!D2&D1&D&!C&!B1&!B&!A1&A|!E1&!E&!D2&D1&D&!C&!B1&!B&!A1&A|!E1&!E&!D2&D1&!D&!C&!B1&!B&!A1&A|E1&!E&!D2&D1&!D&!C&!B1&!B&!A1&A|!E1&E&!D2&D1&!D&!C&!B1&!B&!A1&A|!E1&E&D2&D1&!D&!C&!B1&!B&!A1&A|E1&!E&D2&D1&!D&!C&!B1&!B&!A1&A|!E1&!E&D2&D1&!D&!C&!B1&!B&!A1&A|!E1&!E&D2&!D1&!D&!C&!B1&!B&!A1&A|E1&!E&D2&!D1&!D&!C&!B1&!B&!A1&A|!E1&E&D2&!D1&!D&!C&!B1&!B&!A1&A|!E1&E&!D2&!D1&!D&!C&!B1&!B&!A1&A|E1&!E&!D2&!D1&!D&!C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOOAAOI22132.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOOAI21123 -l AOAAOOAI21123 -i E2 E1 E D1 D C B A1 A -o Y -f Y=!(E2&!E1&!E&D1&D&!C&!B&!A1&!A|E2&E1&!E&D1&D&!C&!B&!A1&!A|!E2&E1&!E&D1&D&!C&!B&!A1&!A|!E2&E1&E&D1&D&!C&!B&!A1&!A|E2&E1&E&D1&D&!C&!B&!A1&!A|E2&!E1&E&D1&D&!C&!B&!A1&!A|!E2&!E1&E&D1&D&!C&!B&!A1&!A|!E2&!E1&E&D1&D&C&!B&!A1&!A|E2&!E1&E&D1&D&C&!B&!A1&!A|E2&E1&E&D1&D&C&!B&!A1&!A|!E2&E1&E&D1&D&C&!B&!A1&!A|!E2&E1&!E&D1&D&C&!B&!A1&!A|E2&E1&!E&D1&D&C&!B&!A1&!A|E2&!E1&!E&D1&D&C&!B&!A1&!A|E2&!E1&!E&!D1&!D&C&B&!A1&!A|E2&E1&!E&!D1&!D&C&B&!A1&!A|!E2&E1&!E&!D1&!D&C&B&!A1&!A|!E2&E1&E&!D1&!D&C&B&!A1&!A|E2&E1&E&!D1&!D&C&B&!A1&!A|E2&!E1&E&!D1&!D&C&B&!A1&!A|!E2&!E1&E&!D1&!D&C&B&!A1&!A|!E2&!E1&E&D1&!D&C&B&!A1&!A|E2&!E1&E&D1&!D&C&B&!A1&!A|E2&E1&E&D1&!D&C&B&!A1&!A|!E2&E1&E&D1&!D&C&B&!A1&!A|!E2&E1&!E&D1&!D&C&B&!A1&!A|E2&E1&!E&D1&!D&C&B&!A1&!A|E2&!E1&!E&D1&!D&C&B&!A1&!A|E2&!E1&!E&D1&D&C&B&!A1&!A|E2&E1&!E&D1&D&C&B&!A1&!A|!E2&E1&!E&D1&D&C&B&!A1&!A|!E2&E1&E&D1&D&C&B&!A1&!A|E2&E1&E&D1&D&C&B&!A1&!A|E2&!E1&E&D1&D&C&B&!A1&!A|!E2&!E1&E&D1&D&C&B&!A1&!A|!E2&!E1&E&!D1&D&C&B&!A1&!A|E2&!E1&E&!D1&D&C&B&!A1&!A|E2&E1&E&!D1&D&C&B&!A1&!A|!E2&E1&E&!D1&D&C&B&!A1&!A|!E2&E1&!E&!D1&D&C&B&!A1&!A|E2&E1&!E&!D1&D&C&B&!A1&!A|E2&!E1&!E&!D1&D&C&B&!A1&!A|!E2&!E1&E&D1&D&!C&B&!A1&!A|E2&!E1&E&D1&D&!C&B&!A1&!A|E2&E1&E&D1&D&!C&B&!A1&!A|!E2&E1&E&D1&D&!C&B&!A1&!A|!E2&E1&!E&D1&D&!C&B&!A1&!A|E2&E1&!E&D1&D&!C&B&!A1&!A|E2&!E1&!E&D1&D&!C&B&!A1&!A|E2&!E1&!E&D1&D&!C&B&A1&!A|E2&E1&!E&D1&D&!C&B&A1&!A|!E2&E1&!E&D1&D&!C&B&A1&!A|!E2&E1&E&D1&D&!C&B&A1&!A|E2&E1&E&D1&D&!C&B&A1&!A|E2&!E1&E&D1&D&!C&B&A1&!A|!E2&!E1&E&D1&D&!C&B&A1&!A|E2&!E1&!E&!D1&D&C&B&A1&!A|E2&E1&!E&!D1&D&C&B&A1&!A|!E2&E1&!E&!D1&D&C&B&A1&!A|!E2&E1&E&!D1&D&C&B&A1&!A|E2&E1&E&!D1&D&C&B&A1&!A|E2&!E1&E&!D1&D&C&B&A1&!A|!E2&!E1&E&!D1&D&C&B&A1&!A|!E2&!E1&E&D1&D&C&B&A1&!A|E2&!E1&E&D1&D&C&B&A1&!A|E2&E1&E&D1&D&C&B&A1&!A|!E2&E1&E&D1&D&C&B&A1&!A|!E2&E1&!E&D1&D&C&B&A1&!A|E2&E1&!E&D1&D&C&B&A1&!A|E2&!E1&!E&D1&D&C&B&A1&!A|E2&!E1&!E&D1&!D&C&B&A1&!A|E2&E1&!E&D1&!D&C&B&A1&!A|!E2&E1&!E&D1&!D&C&B&A1&!A|!E2&E1&E&D1&!D&C&B&A1&!A|E2&E1&E&D1&!D&C&B&A1&!A|E2&!E1&E&D1&!D&C&B&A1&!A|!E2&!E1&E&D1&!D&C&B&A1&!A|!E2&!E1&E&!D1&!D&C&B&A1&!A|E2&!E1&E&!D1&!D&C&B&A1&!A|E2&E1&E&!D1&!D&C&B&A1&!A|!E2&E1&E&!D1&!D&C&B&A1&!A|!E2&E1&!E&!D1&!D&C&B&A1&!A|E2&E1&!E&!D1&!D&C&B&A1&!A|E2&!E1&!E&!D1&!D&C&B&A1&!A|E2&!E1&!E&D1&D&C&!B&A1&!A|E2&E1&!E&D1&D&C&!B&A1&!A|!E2&E1&!E&D1&D&C&!B&A1&!A|!E2&E1&E&D1&D&C&!B&A1&!A|E2&E1&E&D1&D&C&!B&A1&!A|E2&!E1&E&D1&D&C&!B&A1&!A|!E2&!E1&E&D1&D&C&!B&A1&!A|!E2&!E1&E&D1&D&!C&!B&A1&!A|E2&!E1&E&D1&D&!C&!B&A1&!A|E2&E1&E&D1&D&!C&!B&A1&!A|!E2&E1&E&D1&D&!C&!B&A1&!A|!E2&E1&!E&D1&D&!C&!B&A1&!A|E2&E1&!E&D1&D&!C&!B&A1&!A|E2&!E1&!E&D1&D&!C&!B&A1&!A|E2&!E1&!E&D1&D&!C&!B&A1&A|E2&E1&!E&D1&D&!C&!B&A1&A|!E2&E1&!E&D1&D&!C&!B&A1&A|!E2&E1&E&D1&D&!C&!B&A1&A|E2&E1&E&D1&D&!C&!B&A1&A|E2&!E1&E&D1&D&!C&!B&A1&A|!E2&!E1&E&D1&D&!C&!B&A1&A|E2&!E1&!E&!D1&D&C&!B&A1&A|E2&E1&!E&!D1&D&C&!B&A1&A|!E2&E1&!E&!D1&D&C&!B&A1&A|!E2&E1&E&!D1&D&C&!B&A1&A|E2&E1&E&!D1&D&C&!B&A1&A|E2&!E1&E&!D1&D&C&!B&A1&A|!E2&!E1&E&!D1&D&C&!B&A1&A|!E2&!E1&E&D1&D&C&!B&A1&A|E2&!E1&E&D1&D&C&!B&A1&A|E2&E1&E&D1&D&C&!B&A1&A|!E2&E1&E&D1&D&C&!B&A1&A|!E2&E1&!E&D1&D&C&!B&A1&A|E2&E1&!E&D1&D&C&!B&A1&A|E2&!E1&!E&D1&D&C&!B&A1&A|E2&!E1&!E&D1&!D&C&!B&A1&A|E2&E1&!E&D1&!D&C&!B&A1&A|!E2&E1&!E&D1&!D&C&!B&A1&A|!E2&E1&E&D1&!D&C&!B&A1&A|E2&E1&E&D1&!D&C&!B&A1&A|E2&!E1&E&D1&!D&C&!B&A1&A|!E2&!E1&E&D1&!D&C&!B&A1&A|!E2&!E1&E&!D1&!D&C&!B&A1&A|E2&!E1&E&!D1&!D&C&!B&A1&A|E2&E1&E&!D1&!D&C&!B&A1&A|!E2&E1&E&!D1&!D&C&!B&A1&A|!E2&E1&!E&!D1&!D&C&!B&A1&A|E2&E1&!E&!D1&!D&C&!B&A1&A|E2&!E1&!E&!D1&!D&C&!B&A1&A|E2&!E1&!E&!D1&!D&C&B&A1&A|E2&E1&!E&!D1&!D&C&B&A1&A|!E2&E1&!E&!D1&!D&C&B&A1&A|!E2&E1&E&!D1&!D&C&B&A1&A|E2&E1&E&!D1&!D&C&B&A1&A|E2&!E1&E&!D1&!D&C&B&A1&A|!E2&!E1&E&!D1&!D&C&B&A1&A|!E2&!E1&E&D1&!D&C&B&A1&A|E2&!E1&E&D1&!D&C&B&A1&A|E2&E1&E&D1&!D&C&B&A1&A|!E2&E1&E&D1&!D&C&B&A1&A|!E2&E1&!E&D1&!D&C&B&A1&A|E2&E1&!E&D1&!D&C&B&A1&A|E2&!E1&!E&D1&!D&C&B&A1&A|E2&!E1&!E&D1&D&C&B&A1&A|E2&E1&!E&D1&D&C&B&A1&A|!E2&E1&!E&D1&D&C&B&A1&A|!E2&E1&E&D1&D&C&B&A1&A|E2&E1&E&D1&D&C&B&A1&A|E2&!E1&E&D1&D&C&B&A1&A|!E2&!E1&E&D1&D&C&B&A1&A|!E2&!E1&E&!D1&D&C&B&A1&A|E2&!E1&E&!D1&D&C&B&A1&A|E2&E1&E&!D1&D&C&B&A1&A|!E2&E1&E&!D1&D&C&B&A1&A|!E2&E1&!E&!D1&D&C&B&A1&A|E2&E1&!E&!D1&D&C&B&A1&A|E2&!E1&!E&!D1&D&C&B&A1&A|!E2&!E1&E&D1&D&!C&B&A1&A|E2&!E1&E&D1&D&!C&B&A1&A|E2&E1&E&D1&D&!C&B&A1&A|!E2&E1&E&D1&D&!C&B&A1&A|!E2&E1&!E&D1&D&!C&B&A1&A|E2&E1&!E&D1&D&!C&B&A1&A|E2&!E1&!E&D1&D&!C&B&A1&A|E2&!E1&!E&D1&D&!C&B&!A1&A|E2&E1&!E&D1&D&!C&B&!A1&A|!E2&E1&!E&D1&D&!C&B&!A1&A|!E2&E1&E&D1&D&!C&B&!A1&A|E2&E1&E&D1&D&!C&B&!A1&A|E2&!E1&E&D1&D&!C&B&!A1&A|!E2&!E1&E&D1&D&!C&B&!A1&A|E2&!E1&!E&!D1&D&C&B&!A1&A|E2&E1&!E&!D1&D&C&B&!A1&A|!E2&E1&!E&!D1&D&C&B&!A1&A|!E2&E1&E&!D1&D&C&B&!A1&A|E2&E1&E&!D1&D&C&B&!A1&A|E2&!E1&E&!D1&D&C&B&!A1&A|!E2&!E1&E&!D1&D&C&B&!A1&A|!E2&!E1&E&D1&D&C&B&!A1&A|E2&!E1&E&D1&D&C&B&!A1&A|E2&E1&E&D1&D&C&B&!A1&A|!E2&E1&E&D1&D&C&B&!A1&A|!E2&E1&!E&D1&D&C&B&!A1&A|E2&E1&!E&D1&D&C&B&!A1&A|E2&!E1&!E&D1&D&C&B&!A1&A|E2&!E1&!E&D1&!D&C&B&!A1&A|E2&E1&!E&D1&!D&C&B&!A1&A|!E2&E1&!E&D1&!D&C&B&!A1&A|!E2&E1&E&D1&!D&C&B&!A1&A|E2&E1&E&D1&!D&C&B&!A1&A|E2&!E1&E&D1&!D&C&B&!A1&A|!E2&!E1&E&D1&!D&C&B&!A1&A|!E2&!E1&E&!D1&!D&C&B&!A1&A|E2&!E1&E&!D1&!D&C&B&!A1&A|E2&E1&E&!D1&!D&C&B&!A1&A|!E2&E1&E&!D1&!D&C&B&!A1&A|!E2&E1&!E&!D1&!D&C&B&!A1&A|E2&E1&!E&!D1&!D&C&B&!A1&A|E2&!E1&!E&!D1&!D&C&B&!A1&A|E2&!E1&!E&D1&D&C&!B&!A1&A|E2&E1&!E&D1&D&C&!B&!A1&A|!E2&E1&!E&D1&D&C&!B&!A1&A|!E2&E1&E&D1&D&C&!B&!A1&A|E2&E1&E&D1&D&C&!B&!A1&A|E2&!E1&E&D1&D&C&!B&!A1&A|!E2&!E1&E&D1&D&C&!B&!A1&A|!E2&!E1&E&D1&D&!C&!B&!A1&A|E2&!E1&E&D1&D&!C&!B&!A1&A|E2&E1&E&D1&D&!C&!B&!A1&A|!E2&E1&E&D1&D&!C&!B&!A1&A|!E2&E1&!E&D1&D&!C&!B&!A1&A|E2&E1&!E&D1&D&!C&!B&!A1&A|E2&!E1&!E&D1&D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOOAI21123.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAAOI22212 -l AAOOAAOI22212 -i E1 E D C1 C B1 B A1 A -o Y -f Y=!(E1&E&!D&!C1&!C&!B1&!B&!A1&!A|E1&E&D&!C1&!C&!B1&!B&!A1&!A|E1&E&D&C1&!C&!B1&!B&!A1&!A|E1&E&!D&C1&!C&!B1&!B&!A1&!A|E1&E&!D&C1&C&!B1&!B&!A1&!A|E1&E&D&C1&C&!B1&!B&!A1&!A|E1&E&D&!C1&C&!B1&!B&!A1&!A|E1&E&!D&!C1&C&!B1&!B&!A1&!A|E1&E&!D&!C1&C&B1&!B&!A1&!A|E1&E&D&!C1&C&B1&!B&!A1&!A|E1&E&D&C1&C&B1&!B&!A1&!A|E1&E&!D&C1&C&B1&!B&!A1&!A|E1&E&!D&C1&!C&B1&!B&!A1&!A|E1&E&D&C1&!C&B1&!B&!A1&!A|E1&E&D&!C1&!C&B1&!B&!A1&!A|E1&E&!D&!C1&!C&B1&!B&!A1&!A|E1&E&!D&!C1&!C&B1&B&!A1&!A|E1&E&D&!C1&!C&B1&B&!A1&!A|!E1&!E&D&C1&!C&B1&B&!A1&!A|E1&!E&D&C1&!C&B1&B&!A1&!A|E1&E&D&C1&!C&B1&B&!A1&!A|!E1&E&D&C1&!C&B1&B&!A1&!A|E1&E&!D&C1&!C&B1&B&!A1&!A|E1&E&!D&C1&C&B1&B&!A1&!A|!E1&E&D&C1&C&B1&B&!A1&!A|E1&E&D&C1&C&B1&B&!A1&!A|E1&!E&D&C1&C&B1&B&!A1&!A|!E1&!E&D&C1&C&B1&B&!A1&!A|!E1&!E&D&!C1&C&B1&B&!A1&!A|E1&!E&D&!C1&C&B1&B&!A1&!A|E1&E&D&!C1&C&B1&B&!A1&!A|!E1&E&D&!C1&C&B1&B&!A1&!A|E1&E&!D&!C1&C&B1&B&!A1&!A|E1&E&!D&!C1&C&!B1&B&!A1&!A|E1&E&D&!C1&C&!B1&B&!A1&!A|E1&E&D&C1&C&!B1&B&!A1&!A|E1&E&!D&C1&C&!B1&B&!A1&!A|E1&E&!D&C1&!C&!B1&B&!A1&!A|E1&E&D&C1&!C&!B1&B&!A1&!A|E1&E&D&!C1&!C&!B1&B&!A1&!A|E1&E&!D&!C1&!C&!B1&B&!A1&!A|E1&E&!D&!C1&!C&!B1&B&A1&!A|E1&E&D&!C1&!C&!B1&B&A1&!A|E1&E&D&C1&!C&!B1&B&A1&!A|E1&E&!D&C1&!C&!B1&B&A1&!A|E1&E&!D&C1&C&!B1&B&A1&!A|E1&E&D&C1&C&!B1&B&A1&!A|E1&E&D&!C1&C&!B1&B&A1&!A|E1&E&!D&!C1&C&!B1&B&A1&!A|E1&E&!D&!C1&C&B1&B&A1&!A|!E1&E&D&!C1&C&B1&B&A1&!A|E1&E&D&!C1&C&B1&B&A1&!A|E1&!E&D&!C1&C&B1&B&A1&!A|!E1&!E&D&!C1&C&B1&B&A1&!A|!E1&!E&D&C1&C&B1&B&A1&!A|E1&!E&D&C1&C&B1&B&A1&!A|E1&E&D&C1&C&B1&B&A1&!A|!E1&E&D&C1&C&B1&B&A1&!A|E1&E&!D&C1&C&B1&B&A1&!A|E1&E&!D&C1&!C&B1&B&A1&!A|!E1&E&D&C1&!C&B1&B&A1&!A|E1&E&D&C1&!C&B1&B&A1&!A|E1&!E&D&C1&!C&B1&B&A1&!A|!E1&!E&D&C1&!C&B1&B&A1&!A|E1&E&D&!C1&!C&B1&B&A1&!A|E1&E&!D&!C1&!C&B1&B&A1&!A|E1&E&!D&!C1&!C&B1&!B&A1&!A|E1&E&D&!C1&!C&B1&!B&A1&!A|E1&E&D&C1&!C&B1&!B&A1&!A|E1&E&!D&C1&!C&B1&!B&A1&!A|E1&E&!D&C1&C&B1&!B&A1&!A|E1&E&D&C1&C&B1&!B&A1&!A|E1&E&D&!C1&C&B1&!B&A1&!A|E1&E&!D&!C1&C&B1&!B&A1&!A|E1&E&!D&!C1&C&!B1&!B&A1&!A|E1&E&D&!C1&C&!B1&!B&A1&!A|E1&E&D&C1&C&!B1&!B&A1&!A|E1&E&!D&C1&C&!B1&!B&A1&!A|E1&E&!D&C1&!C&!B1&!B&A1&!A|E1&E&D&C1&!C&!B1&!B&A1&!A|E1&E&D&!C1&!C&!B1&!B&A1&!A|E1&E&!D&!C1&!C&!B1&!B&A1&!A|E1&E&!D&!C1&!C&!B1&!B&A1&A|E1&E&D&!C1&!C&!B1&!B&A1&A|!E1&!E&D&C1&!C&!B1&!B&A1&A|E1&!E&D&C1&!C&!B1&!B&A1&A|E1&E&D&C1&!C&!B1&!B&A1&A|!E1&E&D&C1&!C&!B1&!B&A1&A|E1&E&!D&C1&!C&!B1&!B&A1&A|E1&E&!D&C1&C&!B1&!B&A1&A|!E1&E&D&C1&C&!B1&!B&A1&A|E1&E&D&C1&C&!B1&!B&A1&A|E1&!E&D&C1&C&!B1&!B&A1&A|!E1&!E&D&C1&C&!B1&!B&A1&A|!E1&!E&D&!C1&C&!B1&!B&A1&A|E1&!E&D&!C1&C&!B1&!B&A1&A|E1&E&D&!C1&C&!B1&!B&A1&A|!E1&E&D&!C1&C&!B1&!B&A1&A|E1&E&!D&!C1&C&!B1&!B&A1&A|E1&E&!D&!C1&C&B1&!B&A1&A|!E1&E&D&!C1&C&B1&!B&A1&A|E1&E&D&!C1&C&B1&!B&A1&A|E1&!E&D&!C1&C&B1&!B&A1&A|!E1&!E&D&!C1&C&B1&!B&A1&A|!E1&!E&D&C1&C&B1&!B&A1&A|E1&!E&D&C1&C&B1&!B&A1&A|E1&E&D&C1&C&B1&!B&A1&A|!E1&E&D&C1&C&B1&!B&A1&A|E1&E&!D&C1&C&B1&!B&A1&A|E1&E&!D&C1&!C&B1&!B&A1&A|!E1&E&D&C1&!C&B1&!B&A1&A|E1&E&D&C1&!C&B1&!B&A1&A|E1&!E&D&C1&!C&B1&!B&A1&A|!E1&!E&D&C1&!C&B1&!B&A1&A|E1&E&D&!C1&!C&B1&!B&A1&A|E1&E&!D&!C1&!C&B1&!B&A1&A|E1&E&!D&!C1&!C&B1&B&A1&A|E1&E&D&!C1&!C&B1&B&A1&A|!E1&!E&D&C1&!C&B1&B&A1&A|E1&!E&D&C1&!C&B1&B&A1&A|E1&E&D&C1&!C&B1&B&A1&A|!E1&E&D&C1&!C&B1&B&A1&A|E1&E&!D&C1&!C&B1&B&A1&A|E1&E&!D&C1&C&B1&B&A1&A|!E1&E&D&C1&C&B1&B&A1&A|E1&E&D&C1&C&B1&B&A1&A|E1&!E&D&C1&C&B1&B&A1&A|!E1&!E&D&C1&C&B1&B&A1&A|!E1&!E&D&!C1&C&B1&B&A1&A|E1&!E&D&!C1&C&B1&B&A1&A|E1&E&D&!C1&C&B1&B&A1&A|!E1&E&D&!C1&C&B1&B&A1&A|E1&E&!D&!C1&C&B1&B&A1&A|E1&E&!D&!C1&C&!B1&B&A1&A|!E1&E&D&!C1&C&!B1&B&A1&A|E1&E&D&!C1&C&!B1&B&A1&A|E1&!E&D&!C1&C&!B1&B&A1&A|!E1&!E&D&!C1&C&!B1&B&A1&A|!E1&!E&D&C1&C&!B1&B&A1&A|E1&!E&D&C1&C&!B1&B&A1&A|E1&E&D&C1&C&!B1&B&A1&A|!E1&E&D&C1&C&!B1&B&A1&A|E1&E&!D&C1&C&!B1&B&A1&A|E1&E&!D&C1&!C&!B1&B&A1&A|!E1&E&D&C1&!C&!B1&B&A1&A|E1&E&D&C1&!C&!B1&B&A1&A|E1&!E&D&C1&!C&!B1&B&A1&A|!E1&!E&D&C1&!C&!B1&B&A1&A|E1&E&D&!C1&!C&!B1&B&A1&A|E1&E&!D&!C1&!C&!B1&B&A1&A|E1&E&!D&!C1&!C&!B1&B&!A1&A|E1&E&D&!C1&!C&!B1&B&!A1&A|E1&E&D&C1&!C&!B1&B&!A1&A|E1&E&!D&C1&!C&!B1&B&!A1&A|E1&E&!D&C1&C&!B1&B&!A1&A|E1&E&D&C1&C&!B1&B&!A1&A|E1&E&D&!C1&C&!B1&B&!A1&A|E1&E&!D&!C1&C&!B1&B&!A1&A|E1&E&!D&!C1&C&B1&B&!A1&A|!E1&E&D&!C1&C&B1&B&!A1&A|E1&E&D&!C1&C&B1&B&!A1&A|E1&!E&D&!C1&C&B1&B&!A1&A|!E1&!E&D&!C1&C&B1&B&!A1&A|!E1&!E&D&C1&C&B1&B&!A1&A|E1&!E&D&C1&C&B1&B&!A1&A|E1&E&D&C1&C&B1&B&!A1&A|!E1&E&D&C1&C&B1&B&!A1&A|E1&E&!D&C1&C&B1&B&!A1&A|E1&E&!D&C1&!C&B1&B&!A1&A|!E1&E&D&C1&!C&B1&B&!A1&A|E1&E&D&C1&!C&B1&B&!A1&A|E1&!E&D&C1&!C&B1&B&!A1&A|!E1&!E&D&C1&!C&B1&B&!A1&A|E1&E&D&!C1&!C&B1&B&!A1&A|E1&E&!D&!C1&!C&B1&B&!A1&A|E1&E&!D&!C1&!C&B1&!B&!A1&A|E1&E&D&!C1&!C&B1&!B&!A1&A|E1&E&D&C1&!C&B1&!B&!A1&A|E1&E&!D&C1&!C&B1&!B&!A1&A|E1&E&!D&C1&C&B1&!B&!A1&A|E1&E&D&C1&C&B1&!B&!A1&A|E1&E&D&!C1&C&B1&!B&!A1&A|E1&E&!D&!C1&C&B1&!B&!A1&A|E1&E&!D&!C1&C&!B1&!B&!A1&A|E1&E&D&!C1&C&!B1&!B&!A1&A|E1&E&D&C1&C&!B1&!B&!A1&A|E1&E&!D&C1&C&!B1&!B&!A1&A|E1&E&!D&C1&!C&!B1&!B&!A1&A|E1&E&D&C1&!C&!B1&!B&!A1&A|E1&E&D&!C1&!C&!B1&!B&!A1&A|E1&E&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAAOI22212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOI224 -l OOAAOI224 -i C3 C2 C1 C B1 B A1 A -o Y -f Y=(!C3&!C2&!C1&!C&!B1&!B&!A1&!A|C3&!C2&!C1&!C&!B1&!B&!A1&!A|C3&C2&!C1&!C&!B1&!B&!A1&!A|!C3&C2&!C1&!C&!B1&!B&!A1&!A|!C3&C2&C1&!C&!B1&!B&!A1&!A|C3&C2&C1&!C&!B1&!B&!A1&!A|C3&!C2&C1&!C&!B1&!B&!A1&!A|!C3&!C2&C1&!C&!B1&!B&!A1&!A|!C3&!C2&C1&C&!B1&!B&!A1&!A|C3&!C2&C1&C&!B1&!B&!A1&!A|!C3&C2&C1&C&!B1&!B&!A1&!A|!C3&C2&!C1&C&!B1&!B&!A1&!A|C3&C2&!C1&C&!B1&!B&!A1&!A|C3&!C2&!C1&C&!B1&!B&!A1&!A|!C3&!C2&!C1&C&!B1&!B&!A1&!A|!C3&!C2&!C1&C&B1&!B&!A1&!A|C3&!C2&!C1&C&B1&!B&!A1&!A|C3&C2&!C1&C&B1&!B&!A1&!A|!C3&C2&!C1&C&B1&!B&!A1&!A|!C3&C2&C1&C&B1&!B&!A1&!A|C3&!C2&C1&C&B1&!B&!A1&!A|!C3&!C2&C1&C&B1&!B&!A1&!A|!C3&!C2&C1&!C&B1&!B&!A1&!A|C3&!C2&C1&!C&B1&!B&!A1&!A|C3&C2&C1&!C&B1&!B&!A1&!A|!C3&C2&C1&!C&B1&!B&!A1&!A|!C3&C2&!C1&!C&B1&!B&!A1&!A|C3&C2&!C1&!C&B1&!B&!A1&!A|C3&!C2&!C1&!C&B1&!B&!A1&!A|!C3&!C2&!C1&!C&B1&!B&!A1&!A|!C3&!C2&!C1&!C&B1&B&!A1&!A|C3&!C2&!C1&!C&B1&B&!A1&!A|C3&C2&!C1&!C&B1&B&!A1&!A|!C3&C2&!C1&!C&B1&B&!A1&!A|!C3&C2&C1&!C&B1&B&!A1&!A|C3&C2&C1&!C&B1&B&!A1&!A|C3&!C2&C1&!C&B1&B&!A1&!A|!C3&!C2&C1&!C&B1&B&!A1&!A|!C3&!C2&C1&C&B1&B&!A1&!A|C3&!C2&C1&C&B1&B&!A1&!A|!C3&C2&C1&C&B1&B&!A1&!A|!C3&C2&!C1&C&B1&B&!A1&!A|C3&C2&!C1&C&B1&B&!A1&!A|C3&!C2&!C1&C&B1&B&!A1&!A|!C3&!C2&!C1&C&B1&B&!A1&!A|!C3&!C2&!C1&C&!B1&B&!A1&!A|C3&!C2&!C1&C&!B1&B&!A1&!A|C3&C2&!C1&C&!B1&B&!A1&!A|!C3&C2&!C1&C&!B1&B&!A1&!A|!C3&C2&C1&C&!B1&B&!A1&!A|C3&!C2&C1&C&!B1&B&!A1&!A|!C3&!C2&C1&C&!B1&B&!A1&!A|!C3&!C2&C1&!C&!B1&B&!A1&!A|C3&!C2&C1&!C&!B1&B&!A1&!A|C3&C2&C1&!C&!B1&B&!A1&!A|!C3&C2&C1&!C&!B1&B&!A1&!A|!C3&C2&!C1&!C&!B1&B&!A1&!A|C3&C2&!C1&!C&!B1&B&!A1&!A|C3&!C2&!C1&!C&!B1&B&!A1&!A|!C3&!C2&!C1&!C&!B1&B&!A1&!A|!C3&!C2&!C1&C&!B1&!B&A1&!A|C3&!C2&!C1&C&!B1&!B&A1&!A|C3&C2&!C1&C&!B1&!B&A1&!A|!C3&C2&!C1&C&!B1&!B&A1&!A|!C3&C2&C1&C&!B1&!B&A1&!A|C3&!C2&C1&C&!B1&!B&A1&!A|!C3&!C2&C1&C&!B1&!B&A1&!A|!C3&!C2&C1&!C&!B1&!B&A1&!A|C3&!C2&C1&!C&!B1&!B&A1&!A|C3&C2&C1&!C&!B1&!B&A1&!A|!C3&C2&C1&!C&!B1&!B&A1&!A|!C3&C2&!C1&!C&!B1&!B&A1&!A|C3&C2&!C1&!C&!B1&!B&A1&!A|C3&!C2&!C1&!C&!B1&!B&A1&!A|!C3&!C2&!C1&!C&!B1&!B&A1&!A|!C3&!C2&!C1&!C&!B1&!B&A1&A|C3&!C2&!C1&!C&!B1&!B&A1&A|C3&C2&!C1&!C&!B1&!B&A1&A|!C3&C2&!C1&!C&!B1&!B&A1&A|!C3&C2&C1&!C&!B1&!B&A1&A|C3&C2&C1&!C&!B1&!B&A1&A|C3&!C2&C1&!C&!B1&!B&A1&A|!C3&!C2&C1&!C&!B1&!B&A1&A|!C3&!C2&C1&C&!B1&!B&A1&A|C3&!C2&C1&C&!B1&!B&A1&A|!C3&C2&C1&C&!B1&!B&A1&A|!C3&C2&!C1&C&!B1&!B&A1&A|C3&C2&!C1&C&!B1&!B&A1&A|C3&!C2&!C1&C&!B1&!B&A1&A|!C3&!C2&!C1&C&!B1&!B&A1&A|!C3&!C2&!C1&C&!B1&!B&!A1&A|C3&!C2&!C1&C&!B1&!B&!A1&A|C3&C2&!C1&C&!B1&!B&!A1&A|!C3&C2&!C1&C&!B1&!B&!A1&A|!C3&C2&C1&C&!B1&!B&!A1&A|C3&!C2&C1&C&!B1&!B&!A1&A|!C3&!C2&C1&C&!B1&!B&!A1&A|!C3&!C2&C1&!C&!B1&!B&!A1&A|C3&!C2&C1&!C&!B1&!B&!A1&A|C3&C2&C1&!C&!B1&!B&!A1&A|!C3&C2&C1&!C&!B1&!B&!A1&A|!C3&C2&!C1&!C&!B1&!B&!A1&A|C3&C2&!C1&!C&!B1&!B&!A1&A|C3&!C2&!C1&!C&!B1&!B&!A1&A|!C3&!C2&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOI224.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOI311 -l OAOI311 -i C B A2 A1 A -o Y -f Y=(!C&!B&!A2&!A1&!A|!C&B&!A2&!A1&!A|!C&!B&A2&!A1&!A|!C&!B&A2&A1&!A|!C&!B&!A2&A1&!A|!C&!B&!A2&A1&A|!C&!B&A2&A1&A|!C&!B&A2&!A1&A|!C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOI311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOOAI2232 -l OOAAOOAI2232 -i D1 D C2 C1 C B1 B A1 A -o Y -f Y=!(!D1&D&C2&C1&C&!B1&!B&!A1&!A|D1&D&C2&C1&C&!B1&!B&!A1&!A|D1&!D&C2&C1&C&!B1&!B&!A1&!A|D1&!D&C2&C1&C&B1&!B&!A1&!A|D1&D&C2&C1&C&B1&!B&!A1&!A|!D1&D&C2&C1&C&B1&!B&!A1&!A|!D1&D&C2&C1&C&B1&B&!A1&!A|D1&D&C2&C1&C&B1&B&!A1&!A|D1&!D&C2&C1&C&B1&B&!A1&!A|D1&!D&C2&C1&C&!B1&B&!A1&!A|D1&D&C2&C1&C&!B1&B&!A1&!A|!D1&D&C2&C1&C&!B1&B&!A1&!A|D1&!D&!C2&!C1&!C&!B1&B&A1&!A|D1&D&!C2&!C1&!C&!B1&B&A1&!A|!D1&D&!C2&!C1&!C&!B1&B&A1&!A|!D1&D&C2&!C1&!C&!B1&B&A1&!A|D1&D&C2&!C1&!C&!B1&B&A1&!A|D1&!D&C2&!C1&!C&!B1&B&A1&!A|D1&!D&C2&C1&!C&!B1&B&A1&!A|D1&D&C2&C1&!C&!B1&B&A1&!A|!D1&D&C2&C1&!C&!B1&B&A1&!A|!D1&D&!C2&C1&!C&!B1&B&A1&!A|D1&D&!C2&C1&!C&!B1&B&A1&!A|D1&!D&!C2&C1&!C&!B1&B&A1&!A|D1&!D&!C2&C1&C&!B1&B&A1&!A|D1&D&!C2&C1&C&!B1&B&A1&!A|!D1&D&!C2&C1&C&!B1&B&A1&!A|!D1&D&C2&C1&C&!B1&B&A1&!A|D1&D&C2&C1&C&!B1&B&A1&!A|D1&!D&C2&C1&C&!B1&B&A1&!A|D1&!D&C2&!C1&C&!B1&B&A1&!A|D1&D&C2&!C1&C&!B1&B&A1&!A|!D1&D&C2&!C1&C&!B1&B&A1&!A|!D1&D&!C2&!C1&C&!B1&B&A1&!A|D1&D&!C2&!C1&C&!B1&B&A1&!A|D1&!D&!C2&!C1&C&!B1&B&A1&!A|D1&!D&!C2&!C1&C&B1&B&A1&!A|D1&D&!C2&!C1&C&B1&B&A1&!A|!D1&D&!C2&!C1&C&B1&B&A1&!A|!D1&D&C2&!C1&C&B1&B&A1&!A|D1&D&C2&!C1&C&B1&B&A1&!A|D1&!D&C2&!C1&C&B1&B&A1&!A|D1&!D&C2&C1&C&B1&B&A1&!A|D1&D&C2&C1&C&B1&B&A1&!A|!D1&D&C2&C1&C&B1&B&A1&!A|!D1&D&!C2&C1&C&B1&B&A1&!A|D1&D&!C2&C1&C&B1&B&A1&!A|D1&!D&!C2&C1&C&B1&B&A1&!A|D1&!D&!C2&C1&!C&B1&B&A1&!A|D1&D&!C2&C1&!C&B1&B&A1&!A|!D1&D&!C2&C1&!C&B1&B&A1&!A|!D1&D&C2&C1&!C&B1&B&A1&!A|D1&D&C2&C1&!C&B1&B&A1&!A|D1&!D&C2&C1&!C&B1&B&A1&!A|D1&!D&C2&!C1&!C&B1&B&A1&!A|D1&D&C2&!C1&!C&B1&B&A1&!A|!D1&D&C2&!C1&!C&B1&B&A1&!A|!D1&D&!C2&!C1&!C&B1&B&A1&!A|D1&D&!C2&!C1&!C&B1&B&A1&!A|D1&!D&!C2&!C1&!C&B1&B&A1&!A|D1&!D&!C2&!C1&!C&B1&!B&A1&!A|D1&D&!C2&!C1&!C&B1&!B&A1&!A|!D1&D&!C2&!C1&!C&B1&!B&A1&!A|!D1&D&C2&!C1&!C&B1&!B&A1&!A|D1&D&C2&!C1&!C&B1&!B&A1&!A|D1&!D&C2&!C1&!C&B1&!B&A1&!A|D1&!D&C2&C1&!C&B1&!B&A1&!A|D1&D&C2&C1&!C&B1&!B&A1&!A|!D1&D&C2&C1&!C&B1&!B&A1&!A|!D1&D&!C2&C1&!C&B1&!B&A1&!A|D1&D&!C2&C1&!C&B1&!B&A1&!A|D1&!D&!C2&C1&!C&B1&!B&A1&!A|D1&!D&!C2&C1&C&B1&!B&A1&!A|D1&D&!C2&C1&C&B1&!B&A1&!A|!D1&D&!C2&C1&C&B1&!B&A1&!A|!D1&D&C2&C1&C&B1&!B&A1&!A|D1&D&C2&C1&C&B1&!B&A1&!A|D1&!D&C2&C1&C&B1&!B&A1&!A|D1&!D&C2&!C1&C&B1&!B&A1&!A|D1&D&C2&!C1&C&B1&!B&A1&!A|!D1&D&C2&!C1&C&B1&!B&A1&!A|!D1&D&!C2&!C1&C&B1&!B&A1&!A|D1&D&!C2&!C1&C&B1&!B&A1&!A|D1&!D&!C2&!C1&C&B1&!B&A1&!A|D1&!D&C2&C1&C&!B1&!B&A1&!A|D1&D&C2&C1&C&!B1&!B&A1&!A|!D1&D&C2&C1&C&!B1&!B&A1&!A|!D1&D&C2&C1&C&!B1&!B&A1&A|D1&D&C2&C1&C&!B1&!B&A1&A|D1&!D&C2&C1&C&!B1&!B&A1&A|D1&!D&!C2&!C1&C&B1&!B&A1&A|D1&D&!C2&!C1&C&B1&!B&A1&A|!D1&D&!C2&!C1&C&B1&!B&A1&A|!D1&D&C2&!C1&C&B1&!B&A1&A|D1&D&C2&!C1&C&B1&!B&A1&A|D1&!D&C2&!C1&C&B1&!B&A1&A|D1&!D&C2&C1&C&B1&!B&A1&A|D1&D&C2&C1&C&B1&!B&A1&A|!D1&D&C2&C1&C&B1&!B&A1&A|!D1&D&!C2&C1&C&B1&!B&A1&A|D1&D&!C2&C1&C&B1&!B&A1&A|D1&!D&!C2&C1&C&B1&!B&A1&A|D1&!D&!C2&C1&!C&B1&!B&A1&A|D1&D&!C2&C1&!C&B1&!B&A1&A|!D1&D&!C2&C1&!C&B1&!B&A1&A|!D1&D&C2&C1&!C&B1&!B&A1&A|D1&D&C2&C1&!C&B1&!B&A1&A|D1&!D&C2&C1&!C&B1&!B&A1&A|D1&!D&C2&!C1&!C&B1&!B&A1&A|D1&D&C2&!C1&!C&B1&!B&A1&A|!D1&D&C2&!C1&!C&B1&!B&A1&A|!D1&D&!C2&!C1&!C&B1&!B&A1&A|D1&D&!C2&!C1&!C&B1&!B&A1&A|D1&!D&!C2&!C1&!C&B1&!B&A1&A|D1&!D&!C2&!C1&!C&B1&B&A1&A|D1&D&!C2&!C1&!C&B1&B&A1&A|!D1&D&!C2&!C1&!C&B1&B&A1&A|!D1&D&C2&!C1&!C&B1&B&A1&A|D1&D&C2&!C1&!C&B1&B&A1&A|D1&!D&C2&!C1&!C&B1&B&A1&A|D1&!D&C2&C1&!C&B1&B&A1&A|D1&D&C2&C1&!C&B1&B&A1&A|!D1&D&C2&C1&!C&B1&B&A1&A|!D1&D&!C2&C1&!C&B1&B&A1&A|D1&D&!C2&C1&!C&B1&B&A1&A|D1&!D&!C2&C1&!C&B1&B&A1&A|D1&!D&!C2&C1&C&B1&B&A1&A|D1&D&!C2&C1&C&B1&B&A1&A|!D1&D&!C2&C1&C&B1&B&A1&A|!D1&D&C2&C1&C&B1&B&A1&A|D1&D&C2&C1&C&B1&B&A1&A|D1&!D&C2&C1&C&B1&B&A1&A|D1&!D&C2&!C1&C&B1&B&A1&A|D1&D&C2&!C1&C&B1&B&A1&A|!D1&D&C2&!C1&C&B1&B&A1&A|!D1&D&!C2&!C1&C&B1&B&A1&A|D1&D&!C2&!C1&C&B1&B&A1&A|D1&!D&!C2&!C1&C&B1&B&A1&A|D1&!D&!C2&!C1&C&!B1&B&A1&A|D1&D&!C2&!C1&C&!B1&B&A1&A|!D1&D&!C2&!C1&C&!B1&B&A1&A|!D1&D&C2&!C1&C&!B1&B&A1&A|D1&D&C2&!C1&C&!B1&B&A1&A|D1&!D&C2&!C1&C&!B1&B&A1&A|D1&!D&C2&C1&C&!B1&B&A1&A|D1&D&C2&C1&C&!B1&B&A1&A|!D1&D&C2&C1&C&!B1&B&A1&A|!D1&D&!C2&C1&C&!B1&B&A1&A|D1&D&!C2&C1&C&!B1&B&A1&A|D1&!D&!C2&C1&C&!B1&B&A1&A|D1&!D&!C2&C1&!C&!B1&B&A1&A|D1&D&!C2&C1&!C&!B1&B&A1&A|!D1&D&!C2&C1&!C&!B1&B&A1&A|!D1&D&C2&C1&!C&!B1&B&A1&A|D1&D&C2&C1&!C&!B1&B&A1&A|D1&!D&C2&C1&!C&!B1&B&A1&A|D1&!D&C2&!C1&!C&!B1&B&A1&A|D1&D&C2&!C1&!C&!B1&B&A1&A|!D1&D&C2&!C1&!C&!B1&B&A1&A|!D1&D&!C2&!C1&!C&!B1&B&A1&A|D1&D&!C2&!C1&!C&!B1&B&A1&A|D1&!D&!C2&!C1&!C&!B1&B&A1&A|D1&!D&!C2&!C1&!C&!B1&B&!A1&A|D1&D&!C2&!C1&!C&!B1&B&!A1&A|!D1&D&!C2&!C1&!C&!B1&B&!A1&A|!D1&D&C2&!C1&!C&!B1&B&!A1&A|D1&D&C2&!C1&!C&!B1&B&!A1&A|D1&!D&C2&!C1&!C&!B1&B&!A1&A|D1&!D&C2&C1&!C&!B1&B&!A1&A|D1&D&C2&C1&!C&!B1&B&!A1&A|!D1&D&C2&C1&!C&!B1&B&!A1&A|!D1&D&!C2&C1&!C&!B1&B&!A1&A|D1&D&!C2&C1&!C&!B1&B&!A1&A|D1&!D&!C2&C1&!C&!B1&B&!A1&A|D1&!D&!C2&C1&C&!B1&B&!A1&A|D1&D&!C2&C1&C&!B1&B&!A1&A|!D1&D&!C2&C1&C&!B1&B&!A1&A|!D1&D&C2&C1&C&!B1&B&!A1&A|D1&D&C2&C1&C&!B1&B&!A1&A|D1&!D&C2&C1&C&!B1&B&!A1&A|D1&!D&C2&!C1&C&!B1&B&!A1&A|D1&D&C2&!C1&C&!B1&B&!A1&A|!D1&D&C2&!C1&C&!B1&B&!A1&A|!D1&D&!C2&!C1&C&!B1&B&!A1&A|D1&D&!C2&!C1&C&!B1&B&!A1&A|D1&!D&!C2&!C1&C&!B1&B&!A1&A|D1&!D&!C2&!C1&C&B1&B&!A1&A|D1&D&!C2&!C1&C&B1&B&!A1&A|!D1&D&!C2&!C1&C&B1&B&!A1&A|!D1&D&C2&!C1&C&B1&B&!A1&A|D1&D&C2&!C1&C&B1&B&!A1&A|D1&!D&C2&!C1&C&B1&B&!A1&A|D1&!D&C2&C1&C&B1&B&!A1&A|D1&D&C2&C1&C&B1&B&!A1&A|!D1&D&C2&C1&C&B1&B&!A1&A|!D1&D&!C2&C1&C&B1&B&!A1&A|D1&D&!C2&C1&C&B1&B&!A1&A|D1&!D&!C2&C1&C&B1&B&!A1&A|D1&!D&!C2&C1&!C&B1&B&!A1&A|D1&D&!C2&C1&!C&B1&B&!A1&A|!D1&D&!C2&C1&!C&B1&B&!A1&A|!D1&D&C2&C1&!C&B1&B&!A1&A|D1&D&C2&C1&!C&B1&B&!A1&A|D1&!D&C2&C1&!C&B1&B&!A1&A|D1&!D&C2&!C1&!C&B1&B&!A1&A|D1&D&C2&!C1&!C&B1&B&!A1&A|!D1&D&C2&!C1&!C&B1&B&!A1&A|!D1&D&!C2&!C1&!C&B1&B&!A1&A|D1&D&!C2&!C1&!C&B1&B&!A1&A|D1&!D&!C2&!C1&!C&B1&B&!A1&A|D1&!D&!C2&!C1&!C&B1&!B&!A1&A|D1&D&!C2&!C1&!C&B1&!B&!A1&A|!D1&D&!C2&!C1&!C&B1&!B&!A1&A|!D1&D&C2&!C1&!C&B1&!B&!A1&A|D1&D&C2&!C1&!C&B1&!B&!A1&A|D1&!D&C2&!C1&!C&B1&!B&!A1&A|D1&!D&C2&C1&!C&B1&!B&!A1&A|D1&D&C2&C1&!C&B1&!B&!A1&A|!D1&D&C2&C1&!C&B1&!B&!A1&A|!D1&D&!C2&C1&!C&B1&!B&!A1&A|D1&D&!C2&C1&!C&B1&!B&!A1&A|D1&!D&!C2&C1&!C&B1&!B&!A1&A|D1&!D&!C2&C1&C&B1&!B&!A1&A|D1&D&!C2&C1&C&B1&!B&!A1&A|!D1&D&!C2&C1&C&B1&!B&!A1&A|!D1&D&C2&C1&C&B1&!B&!A1&A|D1&D&C2&C1&C&B1&!B&!A1&A|D1&!D&C2&C1&C&B1&!B&!A1&A|D1&!D&C2&!C1&C&B1&!B&!A1&A|D1&D&C2&!C1&C&B1&!B&!A1&A|!D1&D&C2&!C1&C&B1&!B&!A1&A|!D1&D&!C2&!C1&C&B1&!B&!A1&A|D1&D&!C2&!C1&C&B1&!B&!A1&A|D1&!D&!C2&!C1&C&B1&!B&!A1&A|D1&!D&C2&C1&C&!B1&!B&!A1&A|D1&D&C2&C1&C&!B1&!B&!A1&A|!D1&D&C2&C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOOAI2232.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAI234 -l AOOAI234 -i C3 C2 C1 C B2 B1 B A1 A -o Y -f Y=(!C3&!C2&!C1&!C&!B2&!B1&!B&!A1&!A|C3&!C2&!C1&!C&!B2&!B1&!B&!A1&!A|C3&C2&!C1&!C&!B2&!B1&!B&!A1&!A|!C3&C2&!C1&!C&!B2&!B1&!B&!A1&!A|!C3&C2&C1&!C&!B2&!B1&!B&!A1&!A|C3&C2&C1&!C&!B2&!B1&!B&!A1&!A|C3&!C2&C1&!C&!B2&!B1&!B&!A1&!A|!C3&!C2&C1&!C&!B2&!B1&!B&!A1&!A|!C3&!C2&C1&C&!B2&!B1&!B&!A1&!A|C3&!C2&C1&C&!B2&!B1&!B&!A1&!A|C3&C2&C1&C&!B2&!B1&!B&!A1&!A|!C3&C2&C1&C&!B2&!B1&!B&!A1&!A|!C3&C2&!C1&C&!B2&!B1&!B&!A1&!A|C3&C2&!C1&C&!B2&!B1&!B&!A1&!A|C3&!C2&!C1&C&!B2&!B1&!B&!A1&!A|!C3&!C2&!C1&C&!B2&!B1&!B&!A1&!A|!C3&!C2&!C1&!C&B2&!B1&!B&!A1&!A|!C3&!C2&!C1&!C&B2&B1&!B&!A1&!A|!C3&!C2&!C1&!C&!B2&B1&!B&!A1&!A|!C3&!C2&!C1&!C&!B2&B1&B&!A1&!A|!C3&!C2&!C1&!C&B2&B1&B&!A1&!A|!C3&!C2&!C1&!C&B2&!B1&B&!A1&!A|!C3&!C2&!C1&!C&!B2&!B1&B&!A1&!A|!C3&!C2&!C1&!C&!B2&!B1&B&A1&!A|!C3&!C2&!C1&!C&B2&!B1&B&A1&!A|!C3&!C2&!C1&!C&B2&B1&B&A1&!A|!C3&!C2&!C1&!C&!B2&B1&B&A1&!A|!C3&!C2&!C1&!C&!B2&B1&!B&A1&!A|!C3&!C2&!C1&!C&B2&B1&!B&A1&!A|!C3&!C2&!C1&!C&B2&!B1&!B&A1&!A|!C3&!C2&!C1&C&!B2&!B1&!B&A1&!A|C3&!C2&!C1&C&!B2&!B1&!B&A1&!A|C3&C2&!C1&C&!B2&!B1&!B&A1&!A|!C3&C2&!C1&C&!B2&!B1&!B&A1&!A|!C3&C2&C1&C&!B2&!B1&!B&A1&!A|C3&C2&C1&C&!B2&!B1&!B&A1&!A|C3&!C2&C1&C&!B2&!B1&!B&A1&!A|!C3&!C2&C1&C&!B2&!B1&!B&A1&!A|!C3&!C2&C1&!C&!B2&!B1&!B&A1&!A|C3&!C2&C1&!C&!B2&!B1&!B&A1&!A|C3&C2&C1&!C&!B2&!B1&!B&A1&!A|!C3&C2&C1&!C&!B2&!B1&!B&A1&!A|!C3&C2&!C1&!C&!B2&!B1&!B&A1&!A|C3&C2&!C1&!C&!B2&!B1&!B&A1&!A|C3&!C2&!C1&!C&!B2&!B1&!B&A1&!A|!C3&!C2&!C1&!C&!B2&!B1&!B&A1&!A|!C3&!C2&!C1&!C&!B2&!B1&!B&A1&A|!C3&!C2&!C1&!C&B2&!B1&!B&A1&A|!C3&!C2&!C1&!C&B2&B1&!B&A1&A|!C3&!C2&!C1&!C&!B2&B1&!B&A1&A|!C3&!C2&!C1&!C&!B2&B1&B&A1&A|!C3&!C2&!C1&!C&B2&B1&B&A1&A|!C3&!C2&!C1&!C&B2&!B1&B&A1&A|!C3&!C2&!C1&!C&!B2&!B1&B&A1&A|!C3&!C2&!C1&!C&!B2&!B1&B&!A1&A|!C3&!C2&!C1&!C&B2&!B1&B&!A1&A|!C3&!C2&!C1&!C&B2&B1&B&!A1&A|!C3&!C2&!C1&!C&!B2&B1&B&!A1&A|!C3&!C2&!C1&!C&!B2&B1&!B&!A1&A|!C3&!C2&!C1&!C&B2&B1&!B&!A1&A|!C3&!C2&!C1&!C&B2&!B1&!B&!A1&A|!C3&!C2&!C1&C&!B2&!B1&!B&!A1&A|C3&!C2&!C1&C&!B2&!B1&!B&!A1&A|C3&C2&!C1&C&!B2&!B1&!B&!A1&A|!C3&C2&!C1&C&!B2&!B1&!B&!A1&A|!C3&C2&C1&C&!B2&!B1&!B&!A1&A|C3&C2&C1&C&!B2&!B1&!B&!A1&A|C3&!C2&C1&C&!B2&!B1&!B&!A1&A|!C3&!C2&C1&C&!B2&!B1&!B&!A1&A|!C3&!C2&C1&!C&!B2&!B1&!B&!A1&A|C3&!C2&C1&!C&!B2&!B1&!B&!A1&A|C3&C2&C1&!C&!B2&!B1&!B&!A1&A|!C3&C2&C1&!C&!B2&!B1&!B&!A1&A|!C3&C2&!C1&!C&!B2&!B1&!B&!A1&A|C3&C2&!C1&!C&!B2&!B1&!B&!A1&A|C3&!C2&!C1&!C&!B2&!B1&!B&!A1&A|!C3&!C2&!C1&!C&!B2&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAI234.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOI2222 -l AAOAAOI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=!(D1&D&!C1&!C&!B1&!B&!A1&!A|D1&D&C1&!C&!B1&!B&!A1&!A|D1&D&C1&C&!B1&!B&!A1&!A|D1&D&!C1&C&!B1&!B&!A1&!A|D1&D&!C1&C&B1&!B&!A1&!A|D1&D&C1&C&B1&!B&!A1&!A|D1&D&C1&!C&B1&!B&!A1&!A|D1&D&!C1&!C&B1&!B&!A1&!A|D1&D&!C1&!C&B1&B&!A1&!A|D1&D&C1&!C&B1&B&!A1&!A|!D1&!D&C1&C&B1&B&!A1&!A|D1&!D&C1&C&B1&B&!A1&!A|D1&D&C1&C&B1&B&!A1&!A|!D1&D&C1&C&B1&B&!A1&!A|D1&D&!C1&C&B1&B&!A1&!A|D1&D&!C1&C&!B1&B&!A1&!A|D1&D&C1&C&!B1&B&!A1&!A|D1&D&C1&!C&!B1&B&!A1&!A|D1&D&!C1&!C&!B1&B&!A1&!A|D1&D&!C1&!C&!B1&B&A1&!A|D1&D&C1&!C&!B1&B&A1&!A|D1&D&C1&C&!B1&B&A1&!A|D1&D&!C1&C&!B1&B&A1&!A|D1&D&!C1&C&B1&B&A1&!A|!D1&D&C1&C&B1&B&A1&!A|D1&D&C1&C&B1&B&A1&!A|D1&!D&C1&C&B1&B&A1&!A|!D1&!D&C1&C&B1&B&A1&!A|D1&D&C1&!C&B1&B&A1&!A|D1&D&!C1&!C&B1&B&A1&!A|D1&D&!C1&!C&B1&!B&A1&!A|D1&D&C1&!C&B1&!B&A1&!A|D1&D&C1&C&B1&!B&A1&!A|D1&D&!C1&C&B1&!B&A1&!A|D1&D&!C1&C&!B1&!B&A1&!A|D1&D&C1&C&!B1&!B&A1&!A|D1&D&C1&!C&!B1&!B&A1&!A|D1&D&!C1&!C&!B1&!B&A1&!A|D1&D&!C1&!C&!B1&!B&A1&A|D1&D&C1&!C&!B1&!B&A1&A|!D1&!D&C1&C&!B1&!B&A1&A|D1&!D&C1&C&!B1&!B&A1&A|D1&D&C1&C&!B1&!B&A1&A|!D1&D&C1&C&!B1&!B&A1&A|D1&D&!C1&C&!B1&!B&A1&A|D1&D&!C1&C&B1&!B&A1&A|!D1&D&C1&C&B1&!B&A1&A|D1&D&C1&C&B1&!B&A1&A|D1&!D&C1&C&B1&!B&A1&A|!D1&!D&C1&C&B1&!B&A1&A|D1&D&C1&!C&B1&!B&A1&A|D1&D&!C1&!C&B1&!B&A1&A|D1&D&!C1&!C&B1&B&A1&A|D1&D&C1&!C&B1&B&A1&A|!D1&!D&C1&C&B1&B&A1&A|D1&!D&C1&C&B1&B&A1&A|D1&D&C1&C&B1&B&A1&A|!D1&D&C1&C&B1&B&A1&A|D1&D&!C1&C&B1&B&A1&A|D1&D&!C1&C&!B1&B&A1&A|!D1&D&C1&C&!B1&B&A1&A|D1&D&C1&C&!B1&B&A1&A|D1&!D&C1&C&!B1&B&A1&A|!D1&!D&C1&C&!B1&B&A1&A|D1&D&C1&!C&!B1&B&A1&A|D1&D&!C1&!C&!B1&B&A1&A|D1&D&!C1&!C&!B1&B&!A1&A|D1&D&C1&!C&!B1&B&!A1&A|D1&D&C1&C&!B1&B&!A1&A|D1&D&!C1&C&!B1&B&!A1&A|D1&D&!C1&C&B1&B&!A1&A|!D1&D&C1&C&B1&B&!A1&A|D1&D&C1&C&B1&B&!A1&A|D1&!D&C1&C&B1&B&!A1&A|!D1&!D&C1&C&B1&B&!A1&A|D1&D&C1&!C&B1&B&!A1&A|D1&D&!C1&!C&B1&B&!A1&A|D1&D&!C1&!C&B1&!B&!A1&A|D1&D&C1&!C&B1&!B&!A1&A|D1&D&C1&C&B1&!B&!A1&A|D1&D&!C1&C&B1&!B&!A1&A|D1&D&!C1&C&!B1&!B&!A1&A|D1&D&C1&C&!B1&!B&!A1&A|D1&D&C1&!C&!B1&!B&!A1&A|D1&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n NAND4 -l NAND4 -i A3 A2 A1 A -o Y -f Y=!(A3&A2&A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist NAND4.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOI33 -l AOI33 -i B2 B1 B A2 A1 A -o Y -f Y=(!B2&!B1&!B&!A2&!A1&!A|!B2&!B1&!B&A2&!A1&!A|!B2&!B1&!B&A2&A1&!A|!B2&!B1&!B&!A2&A1&!A|!B2&!B1&!B&!A2&A1&A|!B2&!B1&!B&A2&!A1&A|!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOI33.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOI2231 -l OOAAOI2231 -i D C2 C1 C B1 B A1 A -o Y -f Y=(!D&!C2&!C1&!C&!B1&!B&!A1&!A|!D&C2&!C1&!C&!B1&!B&!A1&!A|!D&C2&C1&!C&!B1&!B&!A1&!A|!D&!C2&C1&!C&!B1&!B&!A1&!A|!D&!C2&C1&C&!B1&!B&!A1&!A|!D&C2&!C1&C&!B1&!B&!A1&!A|!D&!C2&!C1&C&!B1&!B&!A1&!A|!D&!C2&!C1&C&B1&!B&!A1&!A|!D&C2&!C1&C&B1&!B&!A1&!A|!D&!C2&C1&C&B1&!B&!A1&!A|!D&!C2&C1&!C&B1&!B&!A1&!A|!D&C2&C1&!C&B1&!B&!A1&!A|!D&C2&!C1&!C&B1&!B&!A1&!A|!D&!C2&!C1&!C&B1&!B&!A1&!A|!D&!C2&!C1&!C&B1&B&!A1&!A|!D&C2&!C1&!C&B1&B&!A1&!A|!D&C2&C1&!C&B1&B&!A1&!A|!D&!C2&C1&!C&B1&B&!A1&!A|!D&!C2&C1&C&B1&B&!A1&!A|!D&C2&!C1&C&B1&B&!A1&!A|!D&!C2&!C1&C&B1&B&!A1&!A|!D&!C2&!C1&C&!B1&B&!A1&!A|!D&C2&!C1&C&!B1&B&!A1&!A|!D&!C2&C1&C&!B1&B&!A1&!A|!D&!C2&C1&!C&!B1&B&!A1&!A|!D&C2&C1&!C&!B1&B&!A1&!A|!D&C2&!C1&!C&!B1&B&!A1&!A|!D&!C2&!C1&!C&!B1&B&!A1&!A|!D&!C2&!C1&C&!B1&!B&A1&!A|!D&C2&!C1&C&!B1&!B&A1&!A|!D&!C2&C1&C&!B1&!B&A1&!A|!D&!C2&C1&!C&!B1&!B&A1&!A|!D&C2&C1&!C&!B1&!B&A1&!A|!D&C2&!C1&!C&!B1&!B&A1&!A|!D&!C2&!C1&!C&!B1&!B&A1&!A|!D&!C2&!C1&!C&!B1&!B&A1&A|!D&C2&!C1&!C&!B1&!B&A1&A|!D&C2&C1&!C&!B1&!B&A1&A|!D&!C2&C1&!C&!B1&!B&A1&A|!D&!C2&C1&C&!B1&!B&A1&A|!D&C2&!C1&C&!B1&!B&A1&A|!D&!C2&!C1&C&!B1&!B&A1&A|!D&!C2&!C1&C&!B1&!B&!A1&A|!D&C2&!C1&C&!B1&!B&!A1&A|!D&!C2&C1&C&!B1&!B&!A1&A|!D&!C2&C1&!C&!B1&!B&!A1&A|!D&C2&C1&!C&!B1&!B&!A1&A|!D&C2&!C1&!C&!B1&!B&!A1&A|!D&!C2&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOI2231.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOAI22121 -l OOAOAI22121 -i E D1 D C B1 B A1 A -o Y -f Y=!(E&D1&!D&!C&!B1&!B&!A1&!A|E&D1&D&!C&!B1&!B&!A1&!A|E&!D1&D&!C&!B1&!B&!A1&!A|E&!D1&D&C&!B1&!B&!A1&!A|E&D1&D&C&!B1&!B&!A1&!A|E&D1&!D&C&!B1&!B&!A1&!A|E&D1&!D&C&B1&!B&!A1&!A|E&D1&D&C&B1&!B&!A1&!A|E&!D1&D&C&B1&!B&!A1&!A|E&!D1&D&!C&B1&!B&!A1&!A|E&D1&D&!C&B1&!B&!A1&!A|E&D1&!D&!C&B1&!B&!A1&!A|E&D1&!D&!C&B1&B&!A1&!A|E&D1&D&!C&B1&B&!A1&!A|E&!D1&D&!C&B1&B&!A1&!A|E&!D1&D&C&B1&B&!A1&!A|E&D1&D&C&B1&B&!A1&!A|E&D1&!D&C&B1&B&!A1&!A|E&D1&!D&C&!B1&B&!A1&!A|E&D1&D&C&!B1&B&!A1&!A|E&!D1&D&C&!B1&B&!A1&!A|E&!D1&D&!C&!B1&B&!A1&!A|E&D1&D&!C&!B1&B&!A1&!A|E&D1&!D&!C&!B1&B&!A1&!A|E&D1&!D&!C&!B1&B&A1&!A|E&D1&D&!C&!B1&B&A1&!A|E&!D1&D&!C&!B1&B&A1&!A|E&!D1&D&C&!B1&B&A1&!A|E&D1&D&C&!B1&B&A1&!A|E&D1&!D&C&!B1&B&A1&!A|E&!D1&!D&C&!B1&B&A1&!A|E&!D1&!D&C&B1&B&A1&!A|E&D1&!D&C&B1&B&A1&!A|E&D1&D&C&B1&B&A1&!A|E&!D1&D&C&B1&B&A1&!A|E&!D1&D&!C&B1&B&A1&!A|E&D1&D&!C&B1&B&A1&!A|E&D1&!D&!C&B1&B&A1&!A|E&D1&!D&!C&B1&!B&A1&!A|E&D1&D&!C&B1&!B&A1&!A|E&!D1&D&!C&B1&!B&A1&!A|E&!D1&D&C&B1&!B&A1&!A|E&D1&D&C&B1&!B&A1&!A|E&D1&!D&C&B1&!B&A1&!A|E&!D1&!D&C&B1&!B&A1&!A|E&D1&!D&C&!B1&!B&A1&!A|E&D1&D&C&!B1&!B&A1&!A|E&!D1&D&C&!B1&!B&A1&!A|E&!D1&D&!C&!B1&!B&A1&!A|E&D1&D&!C&!B1&!B&A1&!A|E&D1&!D&!C&!B1&!B&A1&!A|E&D1&!D&!C&!B1&!B&A1&A|E&D1&D&!C&!B1&!B&A1&A|E&!D1&D&!C&!B1&!B&A1&A|E&!D1&D&C&!B1&!B&A1&A|E&D1&D&C&!B1&!B&A1&A|E&D1&!D&C&!B1&!B&A1&A|E&!D1&!D&C&B1&!B&A1&A|E&D1&!D&C&B1&!B&A1&A|E&D1&D&C&B1&!B&A1&A|E&!D1&D&C&B1&!B&A1&A|E&!D1&D&!C&B1&!B&A1&A|E&D1&D&!C&B1&!B&A1&A|E&D1&!D&!C&B1&!B&A1&A|E&D1&!D&!C&B1&B&A1&A|E&D1&D&!C&B1&B&A1&A|E&!D1&D&!C&B1&B&A1&A|E&!D1&D&C&B1&B&A1&A|E&D1&D&C&B1&B&A1&A|E&D1&!D&C&B1&B&A1&A|E&!D1&!D&C&B1&B&A1&A|E&!D1&!D&C&!B1&B&A1&A|E&D1&!D&C&!B1&B&A1&A|E&D1&D&C&!B1&B&A1&A|E&!D1&D&C&!B1&B&A1&A|E&!D1&D&!C&!B1&B&A1&A|E&D1&D&!C&!B1&B&A1&A|E&D1&!D&!C&!B1&B&A1&A|E&D1&!D&!C&!B1&B&!A1&A|E&D1&D&!C&!B1&B&!A1&A|E&!D1&D&!C&!B1&B&!A1&A|E&!D1&D&C&!B1&B&!A1&A|E&D1&D&C&!B1&B&!A1&A|E&D1&!D&C&!B1&B&!A1&A|E&!D1&!D&C&!B1&B&!A1&A|E&!D1&!D&C&B1&B&!A1&A|E&D1&!D&C&B1&B&!A1&A|E&D1&D&C&B1&B&!A1&A|E&!D1&D&C&B1&B&!A1&A|E&!D1&D&!C&B1&B&!A1&A|E&D1&D&!C&B1&B&!A1&A|E&D1&!D&!C&B1&B&!A1&A|E&D1&!D&!C&B1&!B&!A1&A|E&D1&D&!C&B1&!B&!A1&A|E&!D1&D&!C&B1&!B&!A1&A|E&!D1&D&C&B1&!B&!A1&A|E&D1&D&C&B1&!B&!A1&A|E&D1&!D&C&B1&!B&!A1&A|E&!D1&!D&C&B1&!B&!A1&A|E&D1&!D&C&!B1&!B&!A1&A|E&D1&D&C&!B1&!B&!A1&A|E&!D1&D&C&!B1&!B&!A1&A|E&!D1&D&!C&!B1&!B&!A1&A|E&D1&D&!C&!B1&!B&!A1&A|E&D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOAI22121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAI322 -l OOAI322 -i C1 C B1 B A2 A1 A -o Y -f Y=!(C1&C&!B1&B&A2&!A1&!A|C1&C&B1&B&A2&!A1&!A|C1&C&B1&!B&A2&!A1&!A|C1&C&B1&!B&A2&A1&!A|C1&C&B1&B&A2&A1&!A|C1&C&!B1&B&A2&A1&!A|C1&C&!B1&B&!A2&A1&!A|C1&C&B1&B&!A2&A1&!A|C1&C&B1&!B&!A2&A1&!A|C1&C&B1&!B&!A2&A1&A|C1&C&B1&B&!A2&A1&A|C1&C&!B1&B&!A2&A1&A|C1&C&!B1&B&A2&A1&A|C1&C&B1&B&A2&A1&A|C1&C&B1&!B&A2&A1&A|C1&C&B1&!B&A2&!A1&A|C1&C&B1&B&A2&!A1&A|C1&C&!B1&B&A2&!A1&A|C1&C&!B1&B&!A2&!A1&A|C1&C&B1&B&!A2&!A1&A|C1&C&B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAI322.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOOAI3332 -l OOOOAI3332 -i D1 D C2 C1 C B2 B1 B A2 A1 A -o Y -f Y=(!D1&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|D1&!D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|D1&D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&D&C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|D1&D&C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|D1&!D&C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|D1&!D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|D1&D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&D&!C2&C1&C&B2&!B1&!B&!A2&!A1&!A|D1&D&!C2&C1&C&B2&!B1&!B&!A2&!A1&!A|D1&!D&!C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&!D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&D&C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&D&C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&!D&C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&!D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&!D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|D1&!D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|D1&D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&D&C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|D1&D&C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|D1&!D&C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&!D&C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&!D&C2&C1&!C&B2&B1&!B&!A2&!A1&!A|D1&!D&C2&C1&!C&B2&B1&!B&!A2&!A1&!A|D1&D&C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&D&C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&D&!C2&C1&!C&B2&B1&!B&!A2&!A1&!A|D1&D&!C2&C1&!C&B2&B1&!B&!A2&!A1&!A|D1&!D&!C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&!D&!C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&!D&!C2&C1&C&B2&B1&!B&!A2&!A1&!A|D1&!D&!C2&C1&C&B2&B1&!B&!A2&!A1&!A|D1&D&!C2&C1&C&B2&B1&!B&!A2&!A1&!A|!D1&D&!C2&C1&C&B2&B1&!B&!A2&!A1&!A|!D1&D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|D1&D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|D1&!D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|!D1&!D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|!D1&!D&C2&!C1&C&B2&B1&!B&!A2&!A1&!A|D1&!D&C2&!C1&C&B2&B1&!B&!A2&!A1&!A|D1&D&C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!D1&D&C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!D1&D&!C2&!C1&C&B2&B1&!B&!A2&!A1&!A|D1&D&!C2&!C1&C&B2&B1&!B&!A2&!A1&!A|D1&!D&!C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!D1&!D&!C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!D1&!D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|D1&!D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|D1&D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&D&C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|D1&D&C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|D1&!D&C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|D1&!D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|D1&D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&D&!C2&C1&C&!B2&B1&!B&!A2&!A1&!A|D1&D&!C2&C1&C&!B2&B1&!B&!A2&!A1&!A|D1&!D&!C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&!C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&!D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&D&C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&D&C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&!D&C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&!D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&!D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|D1&!D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|D1&D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&D&C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|D1&D&C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|D1&!D&C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&!D&C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&!D&C2&C1&!C&!B2&B1&B&!A2&!A1&!A|D1&!D&C2&C1&!C&!B2&B1&B&!A2&!A1&!A|D1&D&C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&D&C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&D&!C2&C1&!C&!B2&B1&B&!A2&!A1&!A|D1&D&!C2&C1&!C&!B2&B1&B&!A2&!A1&!A|D1&!D&!C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&!D&!C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&!D&!C2&C1&C&!B2&B1&B&!A2&!A1&!A|D1&!D&!C2&C1&C&!B2&B1&B&!A2&!A1&!A|D1&D&!C2&C1&C&!B2&B1&B&!A2&!A1&!A|!D1&D&!C2&C1&C&!B2&B1&B&!A2&!A1&!A|!D1&D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|D1&D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|D1&!D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|!D1&!D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|!D1&!D&C2&!C1&C&!B2&B1&B&!A2&!A1&!A|D1&!D&C2&!C1&C&!B2&B1&B&!A2&!A1&!A|D1&D&C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!D1&D&C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!D1&D&!C2&!C1&C&!B2&B1&B&!A2&!A1&!A|D1&D&!C2&!C1&C&!B2&B1&B&!A2&!A1&!A|D1&!D&!C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!D1&!D&!C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!D1&!D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|D1&!D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|D1&D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|!D1&D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|!D1&D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|D1&D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|D1&!D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|!D1&!D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|!D1&!D&C2&C1&C&B2&B1&B&!A2&!A1&!A|D1&!D&C2&C1&C&B2&B1&B&!A2&!A1&!A|D1&D&C2&C1&C&B2&B1&B&!A2&!A1&!A|!D1&D&C2&C1&C&B2&B1&B&!A2&!A1&!A|!D1&D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|D1&D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|D1&!D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|!D1&!D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|!D1&!D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|D1&!D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|D1&D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|!D1&D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|!D1&D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|D1&D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|D1&!D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|!D1&!D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|!D1&!D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|D1&!D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|D1&D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!D1&D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!D1&D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|D1&D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|D1&!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!D1&!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!D1&!D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|D1&!D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|D1&D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&D&C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|D1&D&C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|D1&!D&C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&!D&C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&!D&C2&C1&!C&B2&!B1&B&!A2&!A1&!A|D1&!D&C2&C1&!C&B2&!B1&B&!A2&!A1&!A|D1&D&C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&D&C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&D&!C2&C1&!C&B2&!B1&B&!A2&!A1&!A|D1&D&!C2&C1&!C&B2&!B1&B&!A2&!A1&!A|D1&!D&!C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&!D&!C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&!D&!C2&C1&C&B2&!B1&B&!A2&!A1&!A|D1&!D&!C2&C1&C&B2&!B1&B&!A2&!A1&!A|D1&D&!C2&C1&C&B2&!B1&B&!A2&!A1&!A|!D1&D&!C2&C1&C&B2&!B1&B&!A2&!A1&!A|!D1&D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|D1&D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|D1&!D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|!D1&!D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|!D1&!D&C2&!C1&C&B2&!B1&B&!A2&!A1&!A|D1&!D&C2&!C1&C&B2&!B1&B&!A2&!A1&!A|D1&D&C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!D1&D&C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!D1&D&!C2&!C1&C&B2&!B1&B&!A2&!A1&!A|D1&D&!C2&!C1&C&B2&!B1&B&!A2&!A1&!A|D1&!D&!C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!D1&!D&!C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!D1&!D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|D1&!D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|D1&D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&D&C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|D1&D&C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|D1&!D&C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|D1&!D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|D1&D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&D&!C2&C1&C&!B2&!B1&B&!A2&!A1&!A|D1&D&!C2&C1&C&!B2&!B1&B&!A2&!A1&!A|D1&!D&!C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&!C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&!D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&D&C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&D&C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&!D&C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&!D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&!D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|D1&!D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|D1&D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|!D1&D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|!D1&!D&C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|!D1&!D&C2&C1&!C&!B2&!B1&B&A2&!A1&!A|!D1&!D&!C2&C1&!C&!B2&!B1&B&A2&!A1&!A|!D1&!D&!C2&C1&C&!B2&!B1&B&A2&!A1&!A|!D1&!D&C2&C1&C&!B2&!B1&B&A2&!A1&!A|!D1&!D&C2&!C1&C&!B2&!B1&B&A2&!A1&!A|!D1&!D&!C2&!C1&C&!B2&!B1&B&A2&!A1&!A|!D1&!D&!C2&!C1&C&B2&!B1&B&A2&!A1&!A|!D1&!D&C2&!C1&C&B2&!B1&B&A2&!A1&!A|!D1&!D&C2&C1&C&B2&!B1&B&A2&!A1&!A|!D1&!D&!C2&C1&C&B2&!B1&B&A2&!A1&!A|!D1&!D&!C2&C1&!C&B2&!B1&B&A2&!A1&!A|!D1&!D&C2&C1&!C&B2&!B1&B&A2&!A1&!A|!D1&!D&C2&!C1&!C&B2&!B1&B&A2&!A1&!A|!D1&D&!C2&!C1&!C&B2&!B1&B&A2&!A1&!A|D1&D&!C2&!C1&!C&B2&!B1&B&A2&!A1&!A|D1&!D&!C2&!C1&!C&B2&!B1&B&A2&!A1&!A|!D1&!D&!C2&!C1&!C&B2&!B1&B&A2&!A1&!A|!D1&!D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|D1&!D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|D1&D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|!D1&D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|!D1&!D&C2&!C1&!C&B2&B1&B&A2&!A1&!A|!D1&!D&C2&C1&!C&B2&B1&B&A2&!A1&!A|!D1&!D&!C2&C1&!C&B2&B1&B&A2&!A1&!A|!D1&!D&!C2&C1&C&B2&B1&B&A2&!A1&!A|!D1&!D&C2&C1&C&B2&B1&B&A2&!A1&!A|!D1&!D&C2&!C1&C&B2&B1&B&A2&!A1&!A|!D1&!D&!C2&!C1&C&B2&B1&B&A2&!A1&!A|!D1&!D&!C2&!C1&C&!B2&B1&B&A2&!A1&!A|!D1&!D&C2&!C1&C&!B2&B1&B&A2&!A1&!A|!D1&!D&C2&C1&C&!B2&B1&B&A2&!A1&!A|!D1&!D&!C2&C1&C&!B2&B1&B&A2&!A1&!A|!D1&!D&!C2&C1&!C&!B2&B1&B&A2&!A1&!A|!D1&!D&C2&C1&!C&!B2&B1&B&A2&!A1&!A|!D1&!D&C2&!C1&!C&!B2&B1&B&A2&!A1&!A|!D1&D&!C2&!C1&!C&!B2&B1&B&A2&!A1&!A|D1&D&!C2&!C1&!C&!B2&B1&B&A2&!A1&!A|D1&!D&!C2&!C1&!C&!B2&B1&B&A2&!A1&!A|!D1&!D&!C2&!C1&!C&!B2&B1&B&A2&!A1&!A|!D1&!D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|D1&!D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|D1&D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|!D1&D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|!D1&!D&C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|!D1&!D&C2&C1&!C&!B2&B1&!B&A2&!A1&!A|!D1&!D&!C2&C1&!C&!B2&B1&!B&A2&!A1&!A|!D1&!D&!C2&C1&C&!B2&B1&!B&A2&!A1&!A|!D1&!D&C2&C1&C&!B2&B1&!B&A2&!A1&!A|!D1&!D&C2&!C1&C&!B2&B1&!B&A2&!A1&!A|!D1&!D&!C2&!C1&C&!B2&B1&!B&A2&!A1&!A|!D1&!D&!C2&!C1&C&B2&B1&!B&A2&!A1&!A|!D1&!D&C2&!C1&C&B2&B1&!B&A2&!A1&!A|!D1&!D&C2&C1&C&B2&B1&!B&A2&!A1&!A|!D1&!D&!C2&C1&C&B2&B1&!B&A2&!A1&!A|!D1&!D&!C2&C1&!C&B2&B1&!B&A2&!A1&!A|!D1&!D&C2&C1&!C&B2&B1&!B&A2&!A1&!A|!D1&!D&C2&!C1&!C&B2&B1&!B&A2&!A1&!A|!D1&D&!C2&!C1&!C&B2&B1&!B&A2&!A1&!A|D1&D&!C2&!C1&!C&B2&B1&!B&A2&!A1&!A|D1&!D&!C2&!C1&!C&B2&B1&!B&A2&!A1&!A|!D1&!D&!C2&!C1&!C&B2&B1&!B&A2&!A1&!A|!D1&!D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|D1&!D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|D1&D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|!D1&D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|!D1&!D&C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|!D1&!D&C2&C1&!C&B2&!B1&!B&A2&!A1&!A|!D1&!D&!C2&C1&!C&B2&!B1&!B&A2&!A1&!A|!D1&!D&!C2&C1&C&B2&!B1&!B&A2&!A1&!A|!D1&!D&C2&C1&C&B2&!B1&!B&A2&!A1&!A|!D1&!D&C2&!C1&C&B2&!B1&!B&A2&!A1&!A|!D1&!D&!C2&!C1&C&B2&!B1&!B&A2&!A1&!A|!D1&!D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|D1&!D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|D1&D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&D&C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|D1&D&C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|D1&!D&C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|D1&!D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|D1&D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&D&!C2&C1&C&!B2&!B1&!B&A2&!A1&!A|D1&D&!C2&C1&C&!B2&!B1&!B&A2&!A1&!A|D1&!D&!C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&!C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&!D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&D&C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&D&C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&!D&C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&!D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&!D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|D1&!D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|D1&D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&D&C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|D1&D&C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|D1&!D&C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&!D&C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&!D&C2&C1&!C&!B2&!B1&!B&A2&A1&!A|D1&!D&C2&C1&!C&!B2&!B1&!B&A2&A1&!A|D1&D&C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&D&C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&D&!C2&C1&!C&!B2&!B1&!B&A2&A1&!A|D1&D&!C2&C1&!C&!B2&!B1&!B&A2&A1&!A|D1&!D&!C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&!D&!C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&!D&!C2&C1&C&!B2&!B1&!B&A2&A1&!A|D1&!D&!C2&C1&C&!B2&!B1&!B&A2&A1&!A|D1&D&!C2&C1&C&!B2&!B1&!B&A2&A1&!A|!D1&D&!C2&C1&C&!B2&!B1&!B&A2&A1&!A|!D1&D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|D1&D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|D1&!D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|!D1&!D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|!D1&!D&C2&!C1&C&!B2&!B1&!B&A2&A1&!A|D1&!D&C2&!C1&C&!B2&!B1&!B&A2&A1&!A|D1&D&C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!D1&D&C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!D1&D&!C2&!C1&C&!B2&!B1&!B&A2&A1&!A|D1&D&!C2&!C1&C&!B2&!B1&!B&A2&A1&!A|D1&!D&!C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!D1&!D&!C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!D1&!D&!C2&!C1&C&B2&!B1&!B&A2&A1&!A|!D1&!D&C2&!C1&C&B2&!B1&!B&A2&A1&!A|!D1&!D&C2&C1&C&B2&!B1&!B&A2&A1&!A|!D1&!D&!C2&C1&C&B2&!B1&!B&A2&A1&!A|!D1&!D&!C2&C1&!C&B2&!B1&!B&A2&A1&!A|!D1&!D&C2&C1&!C&B2&!B1&!B&A2&A1&!A|!D1&!D&C2&!C1&!C&B2&!B1&!B&A2&A1&!A|!D1&D&!C2&!C1&!C&B2&!B1&!B&A2&A1&!A|D1&D&!C2&!C1&!C&B2&!B1&!B&A2&A1&!A|D1&!D&!C2&!C1&!C&B2&!B1&!B&A2&A1&!A|!D1&!D&!C2&!C1&!C&B2&!B1&!B&A2&A1&!A|!D1&!D&!C2&!C1&!C&B2&B1&!B&A2&A1&!A|D1&!D&!C2&!C1&!C&B2&B1&!B&A2&A1&!A|D1&D&!C2&!C1&!C&B2&B1&!B&A2&A1&!A|!D1&D&!C2&!C1&!C&B2&B1&!B&A2&A1&!A|!D1&!D&C2&!C1&!C&B2&B1&!B&A2&A1&!A|!D1&!D&C2&C1&!C&B2&B1&!B&A2&A1&!A|!D1&!D&!C2&C1&!C&B2&B1&!B&A2&A1&!A|!D1&!D&!C2&C1&C&B2&B1&!B&A2&A1&!A|!D1&!D&C2&C1&C&B2&B1&!B&A2&A1&!A|!D1&!D&C2&!C1&C&B2&B1&!B&A2&A1&!A|!D1&!D&!C2&!C1&C&B2&B1&!B&A2&A1&!A|!D1&!D&!C2&!C1&C&!B2&B1&!B&A2&A1&!A|!D1&!D&C2&!C1&C&!B2&B1&!B&A2&A1&!A|!D1&!D&C2&C1&C&!B2&B1&!B&A2&A1&!A|!D1&!D&!C2&C1&C&!B2&B1&!B&A2&A1&!A|!D1&!D&!C2&C1&!C&!B2&B1&!B&A2&A1&!A|!D1&!D&C2&C1&!C&!B2&B1&!B&A2&A1&!A|!D1&!D&C2&!C1&!C&!B2&B1&!B&A2&A1&!A|!D1&D&!C2&!C1&!C&!B2&B1&!B&A2&A1&!A|D1&D&!C2&!C1&!C&!B2&B1&!B&A2&A1&!A|D1&!D&!C2&!C1&!C&!B2&B1&!B&A2&A1&!A|!D1&!D&!C2&!C1&!C&!B2&B1&!B&A2&A1&!A|!D1&!D&!C2&!C1&!C&!B2&B1&B&A2&A1&!A|D1&!D&!C2&!C1&!C&!B2&B1&B&A2&A1&!A|D1&D&!C2&!C1&!C&!B2&B1&B&A2&A1&!A|!D1&D&!C2&!C1&!C&!B2&B1&B&A2&A1&!A|!D1&!D&C2&!C1&!C&!B2&B1&B&A2&A1&!A|!D1&!D&C2&C1&!C&!B2&B1&B&A2&A1&!A|!D1&!D&!C2&C1&!C&!B2&B1&B&A2&A1&!A|!D1&!D&!C2&C1&C&!B2&B1&B&A2&A1&!A|!D1&!D&C2&C1&C&!B2&B1&B&A2&A1&!A|!D1&!D&C2&!C1&C&!B2&B1&B&A2&A1&!A|!D1&!D&!C2&!C1&C&!B2&B1&B&A2&A1&!A|!D1&!D&!C2&!C1&C&B2&B1&B&A2&A1&!A|!D1&!D&C2&!C1&C&B2&B1&B&A2&A1&!A|!D1&!D&C2&C1&C&B2&B1&B&A2&A1&!A|!D1&!D&!C2&C1&C&B2&B1&B&A2&A1&!A|!D1&!D&!C2&C1&!C&B2&B1&B&A2&A1&!A|!D1&!D&C2&C1&!C&B2&B1&B&A2&A1&!A|!D1&!D&C2&!C1&!C&B2&B1&B&A2&A1&!A|!D1&D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|D1&D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|D1&!D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|!D1&!D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|!D1&!D&!C2&!C1&!C&B2&!B1&B&A2&A1&!A|D1&!D&!C2&!C1&!C&B2&!B1&B&A2&A1&!A|D1&D&!C2&!C1&!C&B2&!B1&B&A2&A1&!A|!D1&D&!C2&!C1&!C&B2&!B1&B&A2&A1&!A|!D1&!D&C2&!C1&!C&B2&!B1&B&A2&A1&!A|!D1&!D&C2&C1&!C&B2&!B1&B&A2&A1&!A|!D1&!D&!C2&C1&!C&B2&!B1&B&A2&A1&!A|!D1&!D&!C2&C1&C&B2&!B1&B&A2&A1&!A|!D1&!D&C2&C1&C&B2&!B1&B&A2&A1&!A|!D1&!D&C2&!C1&C&B2&!B1&B&A2&A1&!A|!D1&!D&!C2&!C1&C&B2&!B1&B&A2&A1&!A|!D1&!D&!C2&!C1&C&!B2&!B1&B&A2&A1&!A|!D1&!D&C2&!C1&C&!B2&!B1&B&A2&A1&!A|!D1&!D&C2&C1&C&!B2&!B1&B&A2&A1&!A|!D1&!D&!C2&C1&C&!B2&!B1&B&A2&A1&!A|!D1&!D&!C2&C1&!C&!B2&!B1&B&A2&A1&!A|!D1&!D&C2&C1&!C&!B2&!B1&B&A2&A1&!A|!D1&!D&C2&!C1&!C&!B2&!B1&B&A2&A1&!A|!D1&D&!C2&!C1&!C&!B2&!B1&B&A2&A1&!A|D1&D&!C2&!C1&!C&!B2&!B1&B&A2&A1&!A|D1&!D&!C2&!C1&!C&!B2&!B1&B&A2&A1&!A|!D1&!D&!C2&!C1&!C&!B2&!B1&B&A2&A1&!A|!D1&!D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|D1&!D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|D1&D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|!D1&D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|!D1&!D&C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|!D1&!D&C2&C1&!C&!B2&!B1&B&!A2&A1&!A|!D1&!D&!C2&C1&!C&!B2&!B1&B&!A2&A1&!A|!D1&!D&!C2&C1&C&!B2&!B1&B&!A2&A1&!A|!D1&!D&C2&C1&C&!B2&!B1&B&!A2&A1&!A|!D1&!D&C2&!C1&C&!B2&!B1&B&!A2&A1&!A|!D1&!D&!C2&!C1&C&!B2&!B1&B&!A2&A1&!A|!D1&!D&!C2&!C1&C&B2&!B1&B&!A2&A1&!A|!D1&!D&C2&!C1&C&B2&!B1&B&!A2&A1&!A|!D1&!D&C2&C1&C&B2&!B1&B&!A2&A1&!A|!D1&!D&!C2&C1&C&B2&!B1&B&!A2&A1&!A|!D1&!D&!C2&C1&!C&B2&!B1&B&!A2&A1&!A|!D1&!D&C2&C1&!C&B2&!B1&B&!A2&A1&!A|!D1&!D&C2&!C1&!C&B2&!B1&B&!A2&A1&!A|!D1&D&!C2&!C1&!C&B2&!B1&B&!A2&A1&!A|D1&D&!C2&!C1&!C&B2&!B1&B&!A2&A1&!A|D1&!D&!C2&!C1&!C&B2&!B1&B&!A2&A1&!A|!D1&!D&!C2&!C1&!C&B2&!B1&B&!A2&A1&!A|!D1&!D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|D1&!D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|D1&D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|!D1&D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|!D1&!D&C2&!C1&!C&B2&B1&B&!A2&A1&!A|!D1&!D&C2&C1&!C&B2&B1&B&!A2&A1&!A|!D1&!D&!C2&C1&!C&B2&B1&B&!A2&A1&!A|!D1&!D&!C2&C1&C&B2&B1&B&!A2&A1&!A|!D1&!D&C2&C1&C&B2&B1&B&!A2&A1&!A|!D1&!D&C2&!C1&C&B2&B1&B&!A2&A1&!A|!D1&!D&!C2&!C1&C&B2&B1&B&!A2&A1&!A|!D1&!D&!C2&!C1&C&!B2&B1&B&!A2&A1&!A|!D1&!D&C2&!C1&C&!B2&B1&B&!A2&A1&!A|!D1&!D&C2&C1&C&!B2&B1&B&!A2&A1&!A|!D1&!D&!C2&C1&C&!B2&B1&B&!A2&A1&!A|!D1&!D&!C2&C1&!C&!B2&B1&B&!A2&A1&!A|!D1&!D&C2&C1&!C&!B2&B1&B&!A2&A1&!A|!D1&!D&C2&!C1&!C&!B2&B1&B&!A2&A1&!A|!D1&D&!C2&!C1&!C&!B2&B1&B&!A2&A1&!A|D1&D&!C2&!C1&!C&!B2&B1&B&!A2&A1&!A|D1&!D&!C2&!C1&!C&!B2&B1&B&!A2&A1&!A|!D1&!D&!C2&!C1&!C&!B2&B1&B&!A2&A1&!A|!D1&!D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|D1&!D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|D1&D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|!D1&D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|!D1&!D&C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|!D1&!D&C2&C1&!C&!B2&B1&!B&!A2&A1&!A|!D1&!D&!C2&C1&!C&!B2&B1&!B&!A2&A1&!A|!D1&!D&!C2&C1&C&!B2&B1&!B&!A2&A1&!A|!D1&!D&C2&C1&C&!B2&B1&!B&!A2&A1&!A|!D1&!D&C2&!C1&C&!B2&B1&!B&!A2&A1&!A|!D1&!D&!C2&!C1&C&!B2&B1&!B&!A2&A1&!A|!D1&!D&!C2&!C1&C&B2&B1&!B&!A2&A1&!A|!D1&!D&C2&!C1&C&B2&B1&!B&!A2&A1&!A|!D1&!D&C2&C1&C&B2&B1&!B&!A2&A1&!A|!D1&!D&!C2&C1&C&B2&B1&!B&!A2&A1&!A|!D1&!D&!C2&C1&!C&B2&B1&!B&!A2&A1&!A|!D1&!D&C2&C1&!C&B2&B1&!B&!A2&A1&!A|!D1&!D&C2&!C1&!C&B2&B1&!B&!A2&A1&!A|!D1&D&!C2&!C1&!C&B2&B1&!B&!A2&A1&!A|D1&D&!C2&!C1&!C&B2&B1&!B&!A2&A1&!A|D1&!D&!C2&!C1&!C&B2&B1&!B&!A2&A1&!A|!D1&!D&!C2&!C1&!C&B2&B1&!B&!A2&A1&!A|!D1&!D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|D1&!D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|D1&D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|!D1&D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|!D1&!D&C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|!D1&!D&C2&C1&!C&B2&!B1&!B&!A2&A1&!A|!D1&!D&!C2&C1&!C&B2&!B1&!B&!A2&A1&!A|!D1&!D&!C2&C1&C&B2&!B1&!B&!A2&A1&!A|!D1&!D&C2&C1&C&B2&!B1&!B&!A2&A1&!A|!D1&!D&C2&!C1&C&B2&!B1&!B&!A2&A1&!A|!D1&!D&!C2&!C1&C&B2&!B1&!B&!A2&A1&!A|!D1&!D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|D1&!D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|D1&D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&D&C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|D1&D&C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|D1&!D&C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|D1&!D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|D1&D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&D&!C2&C1&C&!B2&!B1&!B&!A2&A1&!A|D1&D&!C2&C1&C&!B2&!B1&!B&!A2&A1&!A|D1&!D&!C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&!C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&!D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&D&C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&D&C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&!D&C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&!D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|D1&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|D1&D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|D1&D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|D1&!D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&!D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&!D&C2&C1&!C&!B2&!B1&!B&!A2&A1&A|D1&!D&C2&C1&!C&!B2&!B1&!B&!A2&A1&A|D1&D&C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&D&C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&A|D1&D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&A|D1&!D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&!D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&!D&!C2&C1&C&!B2&!B1&!B&!A2&A1&A|D1&!D&!C2&C1&C&!B2&!B1&!B&!A2&A1&A|D1&D&!C2&C1&C&!B2&!B1&!B&!A2&A1&A|!D1&D&!C2&C1&C&!B2&!B1&!B&!A2&A1&A|!D1&D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|D1&D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|D1&!D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|!D1&!D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|!D1&!D&C2&!C1&C&!B2&!B1&!B&!A2&A1&A|D1&!D&C2&!C1&C&!B2&!B1&!B&!A2&A1&A|D1&D&C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!D1&D&C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!D1&D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&A|D1&D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&A|D1&!D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!D1&!D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!D1&!D&!C2&!C1&C&B2&!B1&!B&!A2&A1&A|!D1&!D&C2&!C1&C&B2&!B1&!B&!A2&A1&A|!D1&!D&C2&C1&C&B2&!B1&!B&!A2&A1&A|!D1&!D&!C2&C1&C&B2&!B1&!B&!A2&A1&A|!D1&!D&!C2&C1&!C&B2&!B1&!B&!A2&A1&A|!D1&!D&C2&C1&!C&B2&!B1&!B&!A2&A1&A|!D1&!D&C2&!C1&!C&B2&!B1&!B&!A2&A1&A|!D1&D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&A|D1&D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&A|D1&!D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&A|!D1&!D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&A|!D1&!D&!C2&!C1&!C&B2&B1&!B&!A2&A1&A|D1&!D&!C2&!C1&!C&B2&B1&!B&!A2&A1&A|D1&D&!C2&!C1&!C&B2&B1&!B&!A2&A1&A|!D1&D&!C2&!C1&!C&B2&B1&!B&!A2&A1&A|!D1&!D&C2&!C1&!C&B2&B1&!B&!A2&A1&A|!D1&!D&C2&C1&!C&B2&B1&!B&!A2&A1&A|!D1&!D&!C2&C1&!C&B2&B1&!B&!A2&A1&A|!D1&!D&!C2&C1&C&B2&B1&!B&!A2&A1&A|!D1&!D&C2&C1&C&B2&B1&!B&!A2&A1&A|!D1&!D&C2&!C1&C&B2&B1&!B&!A2&A1&A|!D1&!D&!C2&!C1&C&B2&B1&!B&!A2&A1&A|!D1&!D&!C2&!C1&C&!B2&B1&!B&!A2&A1&A|!D1&!D&C2&!C1&C&!B2&B1&!B&!A2&A1&A|!D1&!D&C2&C1&C&!B2&B1&!B&!A2&A1&A|!D1&!D&!C2&C1&C&!B2&B1&!B&!A2&A1&A|!D1&!D&!C2&C1&!C&!B2&B1&!B&!A2&A1&A|!D1&!D&C2&C1&!C&!B2&B1&!B&!A2&A1&A|!D1&!D&C2&!C1&!C&!B2&B1&!B&!A2&A1&A|!D1&D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&A|D1&D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&A|D1&!D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&A|!D1&!D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&A|!D1&!D&!C2&!C1&!C&!B2&B1&B&!A2&A1&A|D1&!D&!C2&!C1&!C&!B2&B1&B&!A2&A1&A|D1&D&!C2&!C1&!C&!B2&B1&B&!A2&A1&A|!D1&D&!C2&!C1&!C&!B2&B1&B&!A2&A1&A|!D1&!D&C2&!C1&!C&!B2&B1&B&!A2&A1&A|!D1&!D&C2&C1&!C&!B2&B1&B&!A2&A1&A|!D1&!D&!C2&C1&!C&!B2&B1&B&!A2&A1&A|!D1&!D&!C2&C1&C&!B2&B1&B&!A2&A1&A|!D1&!D&C2&C1&C&!B2&B1&B&!A2&A1&A|!D1&!D&C2&!C1&C&!B2&B1&B&!A2&A1&A|!D1&!D&!C2&!C1&C&!B2&B1&B&!A2&A1&A|!D1&!D&!C2&!C1&C&B2&B1&B&!A2&A1&A|!D1&!D&C2&!C1&C&B2&B1&B&!A2&A1&A|!D1&!D&C2&C1&C&B2&B1&B&!A2&A1&A|!D1&!D&!C2&C1&C&B2&B1&B&!A2&A1&A|!D1&!D&!C2&C1&!C&B2&B1&B&!A2&A1&A|!D1&!D&C2&C1&!C&B2&B1&B&!A2&A1&A|!D1&!D&C2&!C1&!C&B2&B1&B&!A2&A1&A|!D1&D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|D1&D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|D1&!D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|!D1&!D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|!D1&!D&!C2&!C1&!C&B2&!B1&B&!A2&A1&A|D1&!D&!C2&!C1&!C&B2&!B1&B&!A2&A1&A|D1&D&!C2&!C1&!C&B2&!B1&B&!A2&A1&A|!D1&D&!C2&!C1&!C&B2&!B1&B&!A2&A1&A|!D1&!D&C2&!C1&!C&B2&!B1&B&!A2&A1&A|!D1&!D&C2&C1&!C&B2&!B1&B&!A2&A1&A|!D1&!D&!C2&C1&!C&B2&!B1&B&!A2&A1&A|!D1&!D&!C2&C1&C&B2&!B1&B&!A2&A1&A|!D1&!D&C2&C1&C&B2&!B1&B&!A2&A1&A|!D1&!D&C2&!C1&C&B2&!B1&B&!A2&A1&A|!D1&!D&!C2&!C1&C&B2&!B1&B&!A2&A1&A|!D1&!D&!C2&!C1&C&!B2&!B1&B&!A2&A1&A|!D1&!D&C2&!C1&C&!B2&!B1&B&!A2&A1&A|!D1&!D&C2&C1&C&!B2&!B1&B&!A2&A1&A|!D1&!D&!C2&C1&C&!B2&!B1&B&!A2&A1&A|!D1&!D&!C2&C1&!C&!B2&!B1&B&!A2&A1&A|!D1&!D&C2&C1&!C&!B2&!B1&B&!A2&A1&A|!D1&!D&C2&!C1&!C&!B2&!B1&B&!A2&A1&A|!D1&D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&A|D1&D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&A|D1&!D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&A|!D1&!D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&A|!D1&!D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|D1&!D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|D1&D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|!D1&D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|!D1&!D&C2&!C1&!C&!B2&!B1&B&A2&A1&A|!D1&!D&C2&C1&!C&!B2&!B1&B&A2&A1&A|!D1&!D&!C2&C1&!C&!B2&!B1&B&A2&A1&A|!D1&!D&!C2&C1&C&!B2&!B1&B&A2&A1&A|!D1&!D&C2&C1&C&!B2&!B1&B&A2&A1&A|!D1&!D&C2&!C1&C&!B2&!B1&B&A2&A1&A|!D1&!D&!C2&!C1&C&!B2&!B1&B&A2&A1&A|!D1&!D&!C2&!C1&C&B2&!B1&B&A2&A1&A|!D1&!D&C2&!C1&C&B2&!B1&B&A2&A1&A|!D1&!D&C2&C1&C&B2&!B1&B&A2&A1&A|!D1&!D&!C2&C1&C&B2&!B1&B&A2&A1&A|!D1&!D&!C2&C1&!C&B2&!B1&B&A2&A1&A|!D1&!D&C2&C1&!C&B2&!B1&B&A2&A1&A|!D1&!D&C2&!C1&!C&B2&!B1&B&A2&A1&A|!D1&D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|D1&D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|D1&!D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|!D1&!D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|!D1&!D&!C2&!C1&!C&B2&B1&B&A2&A1&A|D1&!D&!C2&!C1&!C&B2&B1&B&A2&A1&A|D1&D&!C2&!C1&!C&B2&B1&B&A2&A1&A|!D1&D&!C2&!C1&!C&B2&B1&B&A2&A1&A|!D1&!D&C2&!C1&!C&B2&B1&B&A2&A1&A|!D1&!D&C2&C1&!C&B2&B1&B&A2&A1&A|!D1&!D&!C2&C1&!C&B2&B1&B&A2&A1&A|!D1&!D&!C2&C1&C&B2&B1&B&A2&A1&A|!D1&!D&C2&C1&C&B2&B1&B&A2&A1&A|!D1&!D&C2&!C1&C&B2&B1&B&A2&A1&A|!D1&!D&!C2&!C1&C&B2&B1&B&A2&A1&A|!D1&!D&!C2&!C1&C&!B2&B1&B&A2&A1&A|!D1&!D&C2&!C1&C&!B2&B1&B&A2&A1&A|!D1&!D&C2&C1&C&!B2&B1&B&A2&A1&A|!D1&!D&!C2&C1&C&!B2&B1&B&A2&A1&A|!D1&!D&!C2&C1&!C&!B2&B1&B&A2&A1&A|!D1&!D&C2&C1&!C&!B2&B1&B&A2&A1&A|!D1&!D&C2&!C1&!C&!B2&B1&B&A2&A1&A|!D1&D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|D1&D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|D1&!D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|!D1&!D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|!D1&!D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|D1&!D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|D1&D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|!D1&D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|!D1&!D&C2&!C1&!C&!B2&B1&!B&A2&A1&A|!D1&!D&C2&C1&!C&!B2&B1&!B&A2&A1&A|!D1&!D&!C2&C1&!C&!B2&B1&!B&A2&A1&A|!D1&!D&!C2&C1&C&!B2&B1&!B&A2&A1&A|!D1&!D&C2&C1&C&!B2&B1&!B&A2&A1&A|!D1&!D&C2&!C1&C&!B2&B1&!B&A2&A1&A|!D1&!D&!C2&!C1&C&!B2&B1&!B&A2&A1&A|!D1&!D&!C2&!C1&C&B2&B1&!B&A2&A1&A|!D1&!D&C2&!C1&C&B2&B1&!B&A2&A1&A|!D1&!D&C2&C1&C&B2&B1&!B&A2&A1&A|!D1&!D&!C2&C1&C&B2&B1&!B&A2&A1&A|!D1&!D&!C2&C1&!C&B2&B1&!B&A2&A1&A|!D1&!D&C2&C1&!C&B2&B1&!B&A2&A1&A|!D1&!D&C2&!C1&!C&B2&B1&!B&A2&A1&A|!D1&D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|D1&D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|D1&!D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|!D1&!D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|!D1&!D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|D1&!D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|D1&D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|!D1&D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|!D1&!D&C2&!C1&!C&B2&!B1&!B&A2&A1&A|!D1&!D&C2&C1&!C&B2&!B1&!B&A2&A1&A|!D1&!D&!C2&C1&!C&B2&!B1&!B&A2&A1&A|!D1&!D&!C2&C1&C&B2&!B1&!B&A2&A1&A|!D1&!D&C2&C1&C&B2&!B1&!B&A2&A1&A|!D1&!D&C2&!C1&C&B2&!B1&!B&A2&A1&A|!D1&!D&!C2&!C1&C&B2&!B1&!B&A2&A1&A|!D1&!D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|D1&!D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|D1&D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|!D1&D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|!D1&D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|D1&D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|D1&!D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|!D1&!D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|!D1&!D&C2&C1&C&!B2&!B1&!B&A2&A1&A|D1&!D&C2&C1&C&!B2&!B1&!B&A2&A1&A|D1&D&C2&C1&C&!B2&!B1&!B&A2&A1&A|!D1&D&C2&C1&C&!B2&!B1&!B&A2&A1&A|!D1&D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|D1&D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|D1&!D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|!D1&!D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|!D1&!D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|D1&!D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|D1&D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|!D1&D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|!D1&D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|D1&D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|D1&!D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|!D1&!D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|!D1&!D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|D1&!D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|D1&D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!D1&D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!D1&D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|D1&D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|D1&!D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!D1&!D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!D1&!D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|D1&!D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|D1&D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|D1&D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|D1&!D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&!D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&!D&C2&C1&!C&!B2&!B1&!B&A2&!A1&A|D1&!D&C2&C1&!C&!B2&!B1&!B&A2&!A1&A|D1&D&C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&D&C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&A|D1&D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&A|D1&!D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&!D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&!D&!C2&C1&C&!B2&!B1&!B&A2&!A1&A|D1&!D&!C2&C1&C&!B2&!B1&!B&A2&!A1&A|D1&D&!C2&C1&C&!B2&!B1&!B&A2&!A1&A|!D1&D&!C2&C1&C&!B2&!B1&!B&A2&!A1&A|!D1&D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|D1&D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|D1&!D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|!D1&!D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|!D1&!D&C2&!C1&C&!B2&!B1&!B&A2&!A1&A|D1&!D&C2&!C1&C&!B2&!B1&!B&A2&!A1&A|D1&D&C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!D1&D&C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!D1&D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&A|D1&D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&A|D1&!D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!D1&!D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!D1&!D&!C2&!C1&C&B2&!B1&!B&A2&!A1&A|!D1&!D&C2&!C1&C&B2&!B1&!B&A2&!A1&A|!D1&!D&C2&C1&C&B2&!B1&!B&A2&!A1&A|!D1&!D&!C2&C1&C&B2&!B1&!B&A2&!A1&A|!D1&!D&!C2&C1&!C&B2&!B1&!B&A2&!A1&A|!D1&!D&C2&C1&!C&B2&!B1&!B&A2&!A1&A|!D1&!D&C2&!C1&!C&B2&!B1&!B&A2&!A1&A|!D1&D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&A|D1&D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&A|D1&!D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&A|!D1&!D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&A|!D1&!D&!C2&!C1&!C&B2&B1&!B&A2&!A1&A|D1&!D&!C2&!C1&!C&B2&B1&!B&A2&!A1&A|D1&D&!C2&!C1&!C&B2&B1&!B&A2&!A1&A|!D1&D&!C2&!C1&!C&B2&B1&!B&A2&!A1&A|!D1&!D&C2&!C1&!C&B2&B1&!B&A2&!A1&A|!D1&!D&C2&C1&!C&B2&B1&!B&A2&!A1&A|!D1&!D&!C2&C1&!C&B2&B1&!B&A2&!A1&A|!D1&!D&!C2&C1&C&B2&B1&!B&A2&!A1&A|!D1&!D&C2&C1&C&B2&B1&!B&A2&!A1&A|!D1&!D&C2&!C1&C&B2&B1&!B&A2&!A1&A|!D1&!D&!C2&!C1&C&B2&B1&!B&A2&!A1&A|!D1&!D&!C2&!C1&C&!B2&B1&!B&A2&!A1&A|!D1&!D&C2&!C1&C&!B2&B1&!B&A2&!A1&A|!D1&!D&C2&C1&C&!B2&B1&!B&A2&!A1&A|!D1&!D&!C2&C1&C&!B2&B1&!B&A2&!A1&A|!D1&!D&!C2&C1&!C&!B2&B1&!B&A2&!A1&A|!D1&!D&C2&C1&!C&!B2&B1&!B&A2&!A1&A|!D1&!D&C2&!C1&!C&!B2&B1&!B&A2&!A1&A|!D1&D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&A|D1&D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&A|D1&!D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&A|!D1&!D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&A|!D1&!D&!C2&!C1&!C&!B2&B1&B&A2&!A1&A|D1&!D&!C2&!C1&!C&!B2&B1&B&A2&!A1&A|D1&D&!C2&!C1&!C&!B2&B1&B&A2&!A1&A|!D1&D&!C2&!C1&!C&!B2&B1&B&A2&!A1&A|!D1&!D&C2&!C1&!C&!B2&B1&B&A2&!A1&A|!D1&!D&C2&C1&!C&!B2&B1&B&A2&!A1&A|!D1&!D&!C2&C1&!C&!B2&B1&B&A2&!A1&A|!D1&!D&!C2&C1&C&!B2&B1&B&A2&!A1&A|!D1&!D&C2&C1&C&!B2&B1&B&A2&!A1&A|!D1&!D&C2&!C1&C&!B2&B1&B&A2&!A1&A|!D1&!D&!C2&!C1&C&!B2&B1&B&A2&!A1&A|!D1&!D&!C2&!C1&C&B2&B1&B&A2&!A1&A|!D1&!D&C2&!C1&C&B2&B1&B&A2&!A1&A|!D1&!D&C2&C1&C&B2&B1&B&A2&!A1&A|!D1&!D&!C2&C1&C&B2&B1&B&A2&!A1&A|!D1&!D&!C2&C1&!C&B2&B1&B&A2&!A1&A|!D1&!D&C2&C1&!C&B2&B1&B&A2&!A1&A|!D1&!D&C2&!C1&!C&B2&B1&B&A2&!A1&A|!D1&D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|D1&D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|D1&!D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|!D1&!D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|!D1&!D&!C2&!C1&!C&B2&!B1&B&A2&!A1&A|D1&!D&!C2&!C1&!C&B2&!B1&B&A2&!A1&A|D1&D&!C2&!C1&!C&B2&!B1&B&A2&!A1&A|!D1&D&!C2&!C1&!C&B2&!B1&B&A2&!A1&A|!D1&!D&C2&!C1&!C&B2&!B1&B&A2&!A1&A|!D1&!D&C2&C1&!C&B2&!B1&B&A2&!A1&A|!D1&!D&!C2&C1&!C&B2&!B1&B&A2&!A1&A|!D1&!D&!C2&C1&C&B2&!B1&B&A2&!A1&A|!D1&!D&C2&C1&C&B2&!B1&B&A2&!A1&A|!D1&!D&C2&!C1&C&B2&!B1&B&A2&!A1&A|!D1&!D&!C2&!C1&C&B2&!B1&B&A2&!A1&A|!D1&!D&!C2&!C1&C&!B2&!B1&B&A2&!A1&A|!D1&!D&C2&!C1&C&!B2&!B1&B&A2&!A1&A|!D1&!D&C2&C1&C&!B2&!B1&B&A2&!A1&A|!D1&!D&!C2&C1&C&!B2&!B1&B&A2&!A1&A|!D1&!D&!C2&C1&!C&!B2&!B1&B&A2&!A1&A|!D1&!D&C2&C1&!C&!B2&!B1&B&A2&!A1&A|!D1&!D&C2&!C1&!C&!B2&!B1&B&A2&!A1&A|!D1&D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&A|D1&D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&A|D1&!D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&A|!D1&!D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&A|!D1&!D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|D1&!D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|D1&D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|!D1&D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|!D1&!D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|!D1&!D&C2&C1&!C&!B2&!B1&B&!A2&!A1&A|!D1&!D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&A|!D1&!D&!C2&C1&C&!B2&!B1&B&!A2&!A1&A|!D1&!D&C2&C1&C&!B2&!B1&B&!A2&!A1&A|!D1&!D&C2&!C1&C&!B2&!B1&B&!A2&!A1&A|!D1&!D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&A|!D1&!D&!C2&!C1&C&B2&!B1&B&!A2&!A1&A|!D1&!D&C2&!C1&C&B2&!B1&B&!A2&!A1&A|!D1&!D&C2&C1&C&B2&!B1&B&!A2&!A1&A|!D1&!D&!C2&C1&C&B2&!B1&B&!A2&!A1&A|!D1&!D&!C2&C1&!C&B2&!B1&B&!A2&!A1&A|!D1&!D&C2&C1&!C&B2&!B1&B&!A2&!A1&A|!D1&!D&C2&!C1&!C&B2&!B1&B&!A2&!A1&A|!D1&D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&A|D1&D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&A|D1&!D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&A|!D1&!D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&A|!D1&!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|D1&!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|D1&D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|!D1&D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|!D1&!D&C2&!C1&!C&B2&B1&B&!A2&!A1&A|!D1&!D&C2&C1&!C&B2&B1&B&!A2&!A1&A|!D1&!D&!C2&C1&!C&B2&B1&B&!A2&!A1&A|!D1&!D&!C2&C1&C&B2&B1&B&!A2&!A1&A|!D1&!D&C2&C1&C&B2&B1&B&!A2&!A1&A|!D1&!D&C2&!C1&C&B2&B1&B&!A2&!A1&A|!D1&!D&!C2&!C1&C&B2&B1&B&!A2&!A1&A|!D1&!D&!C2&!C1&C&!B2&B1&B&!A2&!A1&A|!D1&!D&C2&!C1&C&!B2&B1&B&!A2&!A1&A|!D1&!D&C2&C1&C&!B2&B1&B&!A2&!A1&A|!D1&!D&!C2&C1&C&!B2&B1&B&!A2&!A1&A|!D1&!D&!C2&C1&!C&!B2&B1&B&!A2&!A1&A|!D1&!D&C2&C1&!C&!B2&B1&B&!A2&!A1&A|!D1&!D&C2&!C1&!C&!B2&B1&B&!A2&!A1&A|!D1&D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&A|D1&D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&A|D1&!D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&A|!D1&!D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&A|!D1&!D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|D1&!D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|D1&D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|!D1&D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|!D1&!D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|!D1&!D&C2&C1&!C&!B2&B1&!B&!A2&!A1&A|!D1&!D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&A|!D1&!D&!C2&C1&C&!B2&B1&!B&!A2&!A1&A|!D1&!D&C2&C1&C&!B2&B1&!B&!A2&!A1&A|!D1&!D&C2&!C1&C&!B2&B1&!B&!A2&!A1&A|!D1&!D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&A|!D1&!D&!C2&!C1&C&B2&B1&!B&!A2&!A1&A|!D1&!D&C2&!C1&C&B2&B1&!B&!A2&!A1&A|!D1&!D&C2&C1&C&B2&B1&!B&!A2&!A1&A|!D1&!D&!C2&C1&C&B2&B1&!B&!A2&!A1&A|!D1&!D&!C2&C1&!C&B2&B1&!B&!A2&!A1&A|!D1&!D&C2&C1&!C&B2&B1&!B&!A2&!A1&A|!D1&!D&C2&!C1&!C&B2&B1&!B&!A2&!A1&A|!D1&D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&A|D1&D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&A|D1&!D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&A|!D1&!D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&A|!D1&!D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|D1&!D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|D1&D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|!D1&D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|!D1&!D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|!D1&!D&C2&C1&!C&B2&!B1&!B&!A2&!A1&A|!D1&!D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&A|!D1&!D&!C2&C1&C&B2&!B1&!B&!A2&!A1&A|!D1&!D&C2&C1&C&B2&!B1&!B&!A2&!A1&A|!D1&!D&C2&!C1&C&B2&!B1&!B&!A2&!A1&A|!D1&!D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&A|!D1&!D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|D1&!D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|D1&D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|D1&D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|D1&!D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A|D1&!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A|D1&D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&A|D1&D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&A|D1&!D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|D1&!D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|D1&D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|D1&D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|D1&!D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|D1&!D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|D1&D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|D1&D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|D1&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOOAI3332.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAAOI21132 -l AOAAAOI21132 -i E1 E D2 D1 D C B A1 A -o Y -f Y=(!E1&!E&!D2&!D1&!D&!C&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C&!B&!A1&!A|!E1&E&D2&!D1&!D&!C&!B&!A1&!A|E1&!E&D2&!D1&!D&!C&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C&!B&!A1&!A|!E1&!E&D2&D1&!D&!C&!B&!A1&!A|E1&!E&D2&D1&!D&!C&!B&!A1&!A|!E1&E&D2&D1&!D&!C&!B&!A1&!A|!E1&E&!D2&D1&!D&!C&!B&!A1&!A|E1&!E&!D2&D1&!D&!C&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C&!B&!A1&!A|!E1&!E&!D2&D1&D&!C&!B&!A1&!A|E1&!E&!D2&D1&D&!C&!B&!A1&!A|!E1&E&!D2&D1&D&!C&!B&!A1&!A|!E1&!E&D2&!D1&D&!C&!B&!A1&!A|E1&!E&D2&!D1&D&!C&!B&!A1&!A|!E1&E&D2&!D1&D&!C&!B&!A1&!A|!E1&E&!D2&!D1&D&!C&!B&!A1&!A|E1&!E&!D2&!D1&D&!C&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C&!B&!A1&!A|!E1&!E&!D2&!D1&D&C&!B&!A1&!A|E1&!E&!D2&!D1&D&C&!B&!A1&!A|!E1&E&!D2&!D1&D&C&!B&!A1&!A|!E1&E&D2&!D1&D&C&!B&!A1&!A|E1&!E&D2&!D1&D&C&!B&!A1&!A|!E1&!E&D2&!D1&D&C&!B&!A1&!A|!E1&E&!D2&D1&D&C&!B&!A1&!A|E1&!E&!D2&D1&D&C&!B&!A1&!A|!E1&!E&!D2&D1&D&C&!B&!A1&!A|!E1&!E&!D2&D1&!D&C&!B&!A1&!A|E1&!E&!D2&D1&!D&C&!B&!A1&!A|!E1&E&!D2&D1&!D&C&!B&!A1&!A|!E1&E&D2&D1&!D&C&!B&!A1&!A|E1&!E&D2&D1&!D&C&!B&!A1&!A|!E1&!E&D2&D1&!D&C&!B&!A1&!A|!E1&!E&D2&!D1&!D&C&!B&!A1&!A|E1&!E&D2&!D1&!D&C&!B&!A1&!A|!E1&E&D2&!D1&!D&C&!B&!A1&!A|!E1&E&!D2&!D1&!D&C&!B&!A1&!A|E1&!E&!D2&!D1&!D&C&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C&B&!A1&!A|E1&!E&!D2&!D1&D&!C&B&!A1&!A|!E1&E&!D2&!D1&D&!C&B&!A1&!A|!E1&E&D2&!D1&D&!C&B&!A1&!A|E1&!E&D2&!D1&D&!C&B&!A1&!A|!E1&!E&D2&!D1&D&!C&B&!A1&!A|!E1&E&!D2&D1&D&!C&B&!A1&!A|E1&!E&!D2&D1&D&!C&B&!A1&!A|!E1&!E&!D2&D1&D&!C&B&!A1&!A|!E1&!E&!D2&D1&!D&!C&B&!A1&!A|E1&!E&!D2&D1&!D&!C&B&!A1&!A|!E1&E&!D2&D1&!D&!C&B&!A1&!A|!E1&E&D2&D1&!D&!C&B&!A1&!A|E1&!E&D2&D1&!D&!C&B&!A1&!A|!E1&!E&D2&D1&!D&!C&B&!A1&!A|!E1&!E&D2&!D1&!D&!C&B&!A1&!A|E1&!E&D2&!D1&!D&!C&B&!A1&!A|!E1&E&D2&!D1&!D&!C&B&!A1&!A|!E1&E&!D2&!D1&!D&!C&B&!A1&!A|E1&!E&!D2&!D1&!D&!C&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C&B&A1&!A|E1&!E&!D2&!D1&!D&!C&B&A1&!A|!E1&E&!D2&!D1&!D&!C&B&A1&!A|!E1&E&D2&!D1&!D&!C&B&A1&!A|E1&!E&D2&!D1&!D&!C&B&A1&!A|!E1&!E&D2&!D1&!D&!C&B&A1&!A|!E1&!E&D2&D1&!D&!C&B&A1&!A|E1&!E&D2&D1&!D&!C&B&A1&!A|!E1&E&D2&D1&!D&!C&B&A1&!A|!E1&E&!D2&D1&!D&!C&B&A1&!A|E1&!E&!D2&D1&!D&!C&B&A1&!A|!E1&!E&!D2&D1&!D&!C&B&A1&!A|!E1&!E&!D2&D1&D&!C&B&A1&!A|E1&!E&!D2&D1&D&!C&B&A1&!A|!E1&E&!D2&D1&D&!C&B&A1&!A|!E1&!E&D2&!D1&D&!C&B&A1&!A|E1&!E&D2&!D1&D&!C&B&A1&!A|!E1&E&D2&!D1&D&!C&B&A1&!A|!E1&E&!D2&!D1&D&!C&B&A1&!A|E1&!E&!D2&!D1&D&!C&B&A1&!A|!E1&!E&!D2&!D1&D&!C&B&A1&!A|!E1&!E&!D2&!D1&!D&C&!B&A1&!A|E1&!E&!D2&!D1&!D&C&!B&A1&!A|!E1&E&!D2&!D1&!D&C&!B&A1&!A|!E1&E&D2&!D1&!D&C&!B&A1&!A|E1&!E&D2&!D1&!D&C&!B&A1&!A|!E1&!E&D2&!D1&!D&C&!B&A1&!A|!E1&!E&D2&D1&!D&C&!B&A1&!A|E1&!E&D2&D1&!D&C&!B&A1&!A|!E1&E&D2&D1&!D&C&!B&A1&!A|!E1&E&!D2&D1&!D&C&!B&A1&!A|E1&!E&!D2&D1&!D&C&!B&A1&!A|!E1&!E&!D2&D1&!D&C&!B&A1&!A|!E1&!E&!D2&D1&D&C&!B&A1&!A|E1&!E&!D2&D1&D&C&!B&A1&!A|!E1&E&!D2&D1&D&C&!B&A1&!A|!E1&!E&D2&!D1&D&C&!B&A1&!A|E1&!E&D2&!D1&D&C&!B&A1&!A|!E1&E&D2&!D1&D&C&!B&A1&!A|!E1&E&!D2&!D1&D&C&!B&A1&!A|E1&!E&!D2&!D1&D&C&!B&A1&!A|!E1&!E&!D2&!D1&D&C&!B&A1&!A|!E1&!E&!D2&!D1&D&!C&!B&A1&!A|E1&!E&!D2&!D1&D&!C&!B&A1&!A|!E1&E&!D2&!D1&D&!C&!B&A1&!A|!E1&E&D2&!D1&D&!C&!B&A1&!A|E1&!E&D2&!D1&D&!C&!B&A1&!A|!E1&!E&D2&!D1&D&!C&!B&A1&!A|!E1&E&!D2&D1&D&!C&!B&A1&!A|E1&!E&!D2&D1&D&!C&!B&A1&!A|!E1&!E&!D2&D1&D&!C&!B&A1&!A|!E1&!E&!D2&D1&!D&!C&!B&A1&!A|E1&!E&!D2&D1&!D&!C&!B&A1&!A|!E1&E&!D2&D1&!D&!C&!B&A1&!A|!E1&E&D2&D1&!D&!C&!B&A1&!A|E1&!E&D2&D1&!D&!C&!B&A1&!A|!E1&!E&D2&D1&!D&!C&!B&A1&!A|!E1&!E&D2&!D1&!D&!C&!B&A1&!A|E1&!E&D2&!D1&!D&!C&!B&A1&!A|!E1&E&D2&!D1&!D&!C&!B&A1&!A|!E1&E&!D2&!D1&!D&!C&!B&A1&!A|E1&!E&!D2&!D1&!D&!C&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C&!B&A1&A|E1&!E&!D2&!D1&!D&!C&!B&A1&A|!E1&E&!D2&!D1&!D&!C&!B&A1&A|!E1&E&D2&!D1&!D&!C&!B&A1&A|E1&!E&D2&!D1&!D&!C&!B&A1&A|!E1&!E&D2&!D1&!D&!C&!B&A1&A|!E1&!E&D2&D1&!D&!C&!B&A1&A|E1&!E&D2&D1&!D&!C&!B&A1&A|!E1&E&D2&D1&!D&!C&!B&A1&A|!E1&E&!D2&D1&!D&!C&!B&A1&A|E1&!E&!D2&D1&!D&!C&!B&A1&A|!E1&!E&!D2&D1&!D&!C&!B&A1&A|!E1&!E&!D2&D1&D&!C&!B&A1&A|E1&!E&!D2&D1&D&!C&!B&A1&A|!E1&E&!D2&D1&D&!C&!B&A1&A|!E1&!E&D2&!D1&D&!C&!B&A1&A|E1&!E&D2&!D1&D&!C&!B&A1&A|!E1&E&D2&!D1&D&!C&!B&A1&A|!E1&E&!D2&!D1&D&!C&!B&A1&A|E1&!E&!D2&!D1&D&!C&!B&A1&A|!E1&!E&!D2&!D1&D&!C&!B&A1&A|!E1&!E&!D2&!D1&D&!C&B&A1&A|E1&!E&!D2&!D1&D&!C&B&A1&A|!E1&E&!D2&!D1&D&!C&B&A1&A|!E1&E&D2&!D1&D&!C&B&A1&A|E1&!E&D2&!D1&D&!C&B&A1&A|!E1&!E&D2&!D1&D&!C&B&A1&A|!E1&E&!D2&D1&D&!C&B&A1&A|E1&!E&!D2&D1&D&!C&B&A1&A|!E1&!E&!D2&D1&D&!C&B&A1&A|!E1&!E&!D2&D1&!D&!C&B&A1&A|E1&!E&!D2&D1&!D&!C&B&A1&A|!E1&E&!D2&D1&!D&!C&B&A1&A|!E1&E&D2&D1&!D&!C&B&A1&A|E1&!E&D2&D1&!D&!C&B&A1&A|!E1&!E&D2&D1&!D&!C&B&A1&A|!E1&!E&D2&!D1&!D&!C&B&A1&A|E1&!E&D2&!D1&!D&!C&B&A1&A|!E1&E&D2&!D1&!D&!C&B&A1&A|!E1&E&!D2&!D1&!D&!C&B&A1&A|E1&!E&!D2&!D1&!D&!C&B&A1&A|!E1&!E&!D2&!D1&!D&!C&B&A1&A|!E1&!E&!D2&!D1&!D&!C&B&!A1&A|E1&!E&!D2&!D1&!D&!C&B&!A1&A|!E1&E&!D2&!D1&!D&!C&B&!A1&A|!E1&E&D2&!D1&!D&!C&B&!A1&A|E1&!E&D2&!D1&!D&!C&B&!A1&A|!E1&!E&D2&!D1&!D&!C&B&!A1&A|!E1&!E&D2&D1&!D&!C&B&!A1&A|E1&!E&D2&D1&!D&!C&B&!A1&A|!E1&E&D2&D1&!D&!C&B&!A1&A|!E1&E&!D2&D1&!D&!C&B&!A1&A|E1&!E&!D2&D1&!D&!C&B&!A1&A|!E1&!E&!D2&D1&!D&!C&B&!A1&A|!E1&!E&!D2&D1&D&!C&B&!A1&A|E1&!E&!D2&D1&D&!C&B&!A1&A|!E1&E&!D2&D1&D&!C&B&!A1&A|!E1&!E&D2&!D1&D&!C&B&!A1&A|E1&!E&D2&!D1&D&!C&B&!A1&A|!E1&E&D2&!D1&D&!C&B&!A1&A|!E1&E&!D2&!D1&D&!C&B&!A1&A|E1&!E&!D2&!D1&D&!C&B&!A1&A|!E1&!E&!D2&!D1&D&!C&B&!A1&A|!E1&!E&!D2&!D1&!D&C&!B&!A1&A|E1&!E&!D2&!D1&!D&C&!B&!A1&A|!E1&E&!D2&!D1&!D&C&!B&!A1&A|!E1&E&D2&!D1&!D&C&!B&!A1&A|E1&!E&D2&!D1&!D&C&!B&!A1&A|!E1&!E&D2&!D1&!D&C&!B&!A1&A|!E1&!E&D2&D1&!D&C&!B&!A1&A|E1&!E&D2&D1&!D&C&!B&!A1&A|!E1&E&D2&D1&!D&C&!B&!A1&A|!E1&E&!D2&D1&!D&C&!B&!A1&A|E1&!E&!D2&D1&!D&C&!B&!A1&A|!E1&!E&!D2&D1&!D&C&!B&!A1&A|!E1&!E&!D2&D1&D&C&!B&!A1&A|E1&!E&!D2&D1&D&C&!B&!A1&A|!E1&E&!D2&D1&D&C&!B&!A1&A|!E1&!E&D2&!D1&D&C&!B&!A1&A|E1&!E&D2&!D1&D&C&!B&!A1&A|!E1&E&D2&!D1&D&C&!B&!A1&A|!E1&E&!D2&!D1&D&C&!B&!A1&A|E1&!E&!D2&!D1&D&C&!B&!A1&A|!E1&!E&!D2&!D1&D&C&!B&!A1&A|!E1&!E&!D2&!D1&D&!C&!B&!A1&A|E1&!E&!D2&!D1&D&!C&!B&!A1&A|!E1&E&!D2&!D1&D&!C&!B&!A1&A|!E1&E&D2&!D1&D&!C&!B&!A1&A|E1&!E&D2&!D1&D&!C&!B&!A1&A|!E1&!E&D2&!D1&D&!C&!B&!A1&A|!E1&E&!D2&D1&D&!C&!B&!A1&A|E1&!E&!D2&D1&D&!C&!B&!A1&A|!E1&!E&!D2&D1&D&!C&!B&!A1&A|!E1&!E&!D2&D1&!D&!C&!B&!A1&A|E1&!E&!D2&D1&!D&!C&!B&!A1&A|!E1&E&!D2&D1&!D&!C&!B&!A1&A|!E1&E&D2&D1&!D&!C&!B&!A1&A|E1&!E&D2&D1&!D&!C&!B&!A1&A|!E1&!E&D2&D1&!D&!C&!B&!A1&A|!E1&!E&D2&!D1&!D&!C&!B&!A1&A|E1&!E&D2&!D1&!D&!C&!B&!A1&A|!E1&E&D2&!D1&!D&!C&!B&!A1&A|!E1&E&!D2&!D1&!D&!C&!B&!A1&A|E1&!E&!D2&!D1&!D&!C&!B&!A1&A|!E1&!E&!D2&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAAOI21132.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAI3112 -l OAOOAI3112 -i D1 D C B A2 A1 A -o Y -f Y=(!D1&!D&!C&!B&!A2&!A1&!A|D1&!D&!C&!B&!A2&!A1&!A|D1&D&!C&!B&!A2&!A1&!A|!D1&D&!C&!B&!A2&!A1&!A|!D1&!D&C&!B&!A2&!A1&!A|!D1&!D&C&B&!A2&!A1&!A|!D1&D&!C&B&!A2&!A1&!A|D1&D&!C&B&!A2&!A1&!A|D1&!D&!C&B&!A2&!A1&!A|!D1&!D&!C&B&!A2&!A1&!A|!D1&!D&!C&B&A2&!A1&!A|!D1&!D&C&B&A2&!A1&!A|!D1&!D&C&!B&A2&!A1&!A|!D1&D&!C&!B&A2&!A1&!A|D1&D&!C&!B&A2&!A1&!A|D1&!D&!C&!B&A2&!A1&!A|!D1&!D&!C&!B&A2&!A1&!A|!D1&!D&!C&!B&A2&A1&!A|D1&!D&!C&!B&A2&A1&!A|D1&D&!C&!B&A2&A1&!A|!D1&D&!C&!B&A2&A1&!A|!D1&!D&C&!B&A2&A1&!A|!D1&!D&C&B&A2&A1&!A|!D1&!D&!C&B&A2&A1&!A|!D1&!D&!C&B&!A2&A1&!A|!D1&!D&C&B&!A2&A1&!A|!D1&!D&C&!B&!A2&A1&!A|!D1&D&!C&!B&!A2&A1&!A|D1&D&!C&!B&!A2&A1&!A|D1&!D&!C&!B&!A2&A1&!A|!D1&!D&!C&!B&!A2&A1&!A|!D1&!D&!C&!B&!A2&A1&A|D1&!D&!C&!B&!A2&A1&A|D1&D&!C&!B&!A2&A1&A|!D1&D&!C&!B&!A2&A1&A|!D1&!D&C&!B&!A2&A1&A|!D1&!D&C&B&!A2&A1&A|!D1&!D&!C&B&!A2&A1&A|!D1&!D&!C&B&A2&A1&A|!D1&!D&C&B&A2&A1&A|!D1&!D&C&!B&A2&A1&A|!D1&D&!C&!B&A2&A1&A|D1&D&!C&!B&A2&A1&A|D1&!D&!C&!B&A2&A1&A|!D1&!D&!C&!B&A2&A1&A|!D1&!D&!C&!B&A2&!A1&A|D1&!D&!C&!B&A2&!A1&A|D1&D&!C&!B&A2&!A1&A|!D1&D&!C&!B&A2&!A1&A|!D1&!D&C&!B&A2&!A1&A|!D1&!D&C&B&A2&!A1&A|!D1&!D&!C&B&A2&!A1&A|!D1&!D&!C&B&!A2&!A1&A|!D1&!D&C&B&!A2&!A1&A|!D1&!D&C&!B&!A2&!A1&A|!D1&D&!C&!B&!A2&!A1&A|D1&D&!C&!B&!A2&!A1&A|D1&!D&!C&!B&!A2&!A1&A|!D1&!D&!C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAI3112.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOI2221 -l AOOAOI2221 -i D C1 C B1 B A1 A -o Y -f Y=(!D&!C1&!C&!B1&!B&!A1&!A|!D&C1&!C&!B1&!B&!A1&!A|!D&C1&C&!B1&!B&!A1&!A|!D&!C1&C&!B1&!B&!A1&!A|!D&!C1&!C&B1&!B&!A1&!A|!D&!C1&!C&B1&B&!A1&!A|!D&!C1&!C&!B1&B&!A1&!A|!D&!C1&!C&!B1&B&A1&!A|!D&!C1&!C&B1&B&A1&!A|!D&!C1&!C&B1&!B&A1&!A|!D&!C1&C&!B1&!B&A1&!A|!D&C1&C&!B1&!B&A1&!A|!D&C1&!C&!B1&!B&A1&!A|!D&!C1&!C&!B1&!B&A1&!A|!D&!C1&!C&!B1&!B&A1&A|!D&!C1&!C&B1&!B&A1&A|!D&!C1&!C&B1&B&A1&A|!D&!C1&!C&!B1&B&A1&A|!D&!C1&!C&!B1&B&!A1&A|!D&!C1&!C&B1&B&!A1&A|!D&!C1&!C&B1&!B&!A1&A|!D&!C1&C&!B1&!B&!A1&A|!D&C1&C&!B1&!B&!A1&A|!D&C1&!C&!B1&!B&!A1&A|!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOI2221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOAOI21111 -l OAOAOI21111 -i E D C B A1 A -o Y -f Y=(!E&!D&!C&!B&!A1&!A|!E&D&!C&!B&!A1&!A|!E&!D&C&!B&!A1&!A|!E&!D&C&B&!A1&!A|!E&D&!C&B&!A1&!A|!E&!D&!C&B&!A1&!A|!E&!D&!C&B&A1&!A|!E&!D&C&B&A1&!A|!E&!D&C&!B&A1&!A|!E&D&!C&!B&A1&!A|!E&!D&!C&!B&A1&!A|!E&!D&!C&!B&A1&A|!E&D&!C&!B&A1&A|!E&!D&C&!B&A1&A|!E&!D&C&B&A1&A|!E&!D&!C&B&A1&A|!E&!D&!C&B&!A1&A|!E&!D&C&B&!A1&A|!E&!D&C&!B&!A1&A|!E&D&!C&!B&!A1&A|!E&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOAOI21111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOOOAI22222 -l OOAAOOOAI22222 -i E1 E D1 D C1 C B1 B A1 A -o Y -f Y=!(!E1&E&D1&!D&C1&C&!B1&!B&!A1&!A|E1&E&D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&D1&D&C1&C&!B1&!B&!A1&!A|E1&E&D1&D&C1&C&!B1&!B&!A1&!A|!E1&E&D1&D&C1&C&!B1&!B&!A1&!A|!E1&E&!D1&D&C1&C&!B1&!B&!A1&!A|E1&E&!D1&D&C1&C&!B1&!B&!A1&!A|E1&!E&!D1&D&C1&C&!B1&!B&!A1&!A|E1&!E&!D1&D&C1&C&B1&!B&!A1&!A|E1&E&!D1&D&C1&C&B1&!B&!A1&!A|!E1&E&!D1&D&C1&C&B1&!B&!A1&!A|!E1&E&D1&D&C1&C&B1&!B&!A1&!A|E1&E&D1&D&C1&C&B1&!B&!A1&!A|E1&!E&D1&D&C1&C&B1&!B&!A1&!A|E1&!E&D1&!D&C1&C&B1&!B&!A1&!A|E1&E&D1&!D&C1&C&B1&!B&!A1&!A|!E1&E&D1&!D&C1&C&B1&!B&!A1&!A|!E1&E&D1&!D&C1&C&B1&B&!A1&!A|E1&E&D1&!D&C1&C&B1&B&!A1&!A|E1&!E&D1&!D&C1&C&B1&B&!A1&!A|E1&!E&D1&D&C1&C&B1&B&!A1&!A|E1&E&D1&D&C1&C&B1&B&!A1&!A|!E1&E&D1&D&C1&C&B1&B&!A1&!A|!E1&E&!D1&D&C1&C&B1&B&!A1&!A|E1&E&!D1&D&C1&C&B1&B&!A1&!A|E1&!E&!D1&D&C1&C&B1&B&!A1&!A|E1&!E&!D1&D&C1&C&!B1&B&!A1&!A|E1&E&!D1&D&C1&C&!B1&B&!A1&!A|!E1&E&!D1&D&C1&C&!B1&B&!A1&!A|!E1&E&D1&D&C1&C&!B1&B&!A1&!A|E1&E&D1&D&C1&C&!B1&B&!A1&!A|E1&!E&D1&D&C1&C&!B1&B&!A1&!A|E1&!E&D1&!D&C1&C&!B1&B&!A1&!A|E1&E&D1&!D&C1&C&!B1&B&!A1&!A|!E1&E&D1&!D&C1&C&!B1&B&!A1&!A|!E1&E&D1&!D&!C1&!C&!B1&B&A1&!A|E1&E&D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&D1&D&!C1&!C&!B1&B&A1&!A|E1&E&D1&D&!C1&!C&!B1&B&A1&!A|!E1&E&D1&D&!C1&!C&!B1&B&A1&!A|!E1&E&!D1&D&!C1&!C&!B1&B&A1&!A|E1&E&!D1&D&!C1&!C&!B1&B&A1&!A|E1&!E&!D1&D&!C1&!C&!B1&B&A1&!A|E1&!E&!D1&D&C1&!C&!B1&B&A1&!A|E1&E&!D1&D&C1&!C&!B1&B&A1&!A|!E1&E&!D1&D&C1&!C&!B1&B&A1&!A|!E1&E&D1&D&C1&!C&!B1&B&A1&!A|E1&E&D1&D&C1&!C&!B1&B&A1&!A|E1&!E&D1&D&C1&!C&!B1&B&A1&!A|E1&!E&D1&!D&C1&!C&!B1&B&A1&!A|E1&E&D1&!D&C1&!C&!B1&B&A1&!A|!E1&E&D1&!D&C1&!C&!B1&B&A1&!A|!E1&E&D1&!D&C1&C&!B1&B&A1&!A|E1&E&D1&!D&C1&C&!B1&B&A1&!A|E1&!E&D1&!D&C1&C&!B1&B&A1&!A|E1&!E&D1&D&C1&C&!B1&B&A1&!A|E1&E&D1&D&C1&C&!B1&B&A1&!A|!E1&E&D1&D&C1&C&!B1&B&A1&!A|!E1&E&!D1&D&C1&C&!B1&B&A1&!A|E1&E&!D1&D&C1&C&!B1&B&A1&!A|E1&!E&!D1&D&C1&C&!B1&B&A1&!A|E1&!E&!D1&D&!C1&C&!B1&B&A1&!A|E1&E&!D1&D&!C1&C&!B1&B&A1&!A|!E1&E&!D1&D&!C1&C&!B1&B&A1&!A|!E1&E&D1&D&!C1&C&!B1&B&A1&!A|E1&E&D1&D&!C1&C&!B1&B&A1&!A|E1&!E&D1&D&!C1&C&!B1&B&A1&!A|E1&!E&D1&!D&!C1&C&!B1&B&A1&!A|E1&E&D1&!D&!C1&C&!B1&B&A1&!A|!E1&E&D1&!D&!C1&C&!B1&B&A1&!A|!E1&E&D1&!D&!C1&C&B1&B&A1&!A|E1&E&D1&!D&!C1&C&B1&B&A1&!A|E1&!E&D1&!D&!C1&C&B1&B&A1&!A|E1&!E&D1&D&!C1&C&B1&B&A1&!A|E1&E&D1&D&!C1&C&B1&B&A1&!A|!E1&E&D1&D&!C1&C&B1&B&A1&!A|!E1&E&!D1&D&!C1&C&B1&B&A1&!A|E1&E&!D1&D&!C1&C&B1&B&A1&!A|E1&!E&!D1&D&!C1&C&B1&B&A1&!A|E1&!E&!D1&D&C1&C&B1&B&A1&!A|E1&E&!D1&D&C1&C&B1&B&A1&!A|!E1&E&!D1&D&C1&C&B1&B&A1&!A|!E1&E&D1&D&C1&C&B1&B&A1&!A|E1&E&D1&D&C1&C&B1&B&A1&!A|E1&!E&D1&D&C1&C&B1&B&A1&!A|E1&!E&D1&!D&C1&C&B1&B&A1&!A|E1&E&D1&!D&C1&C&B1&B&A1&!A|!E1&E&D1&!D&C1&C&B1&B&A1&!A|!E1&E&D1&!D&C1&!C&B1&B&A1&!A|E1&E&D1&!D&C1&!C&B1&B&A1&!A|E1&!E&D1&!D&C1&!C&B1&B&A1&!A|E1&!E&D1&D&C1&!C&B1&B&A1&!A|E1&E&D1&D&C1&!C&B1&B&A1&!A|!E1&E&D1&D&C1&!C&B1&B&A1&!A|!E1&E&!D1&D&C1&!C&B1&B&A1&!A|E1&E&!D1&D&C1&!C&B1&B&A1&!A|E1&!E&!D1&D&C1&!C&B1&B&A1&!A|E1&!E&!D1&D&!C1&!C&B1&B&A1&!A|E1&E&!D1&D&!C1&!C&B1&B&A1&!A|!E1&E&!D1&D&!C1&!C&B1&B&A1&!A|!E1&E&D1&D&!C1&!C&B1&B&A1&!A|E1&E&D1&D&!C1&!C&B1&B&A1&!A|E1&!E&D1&D&!C1&!C&B1&B&A1&!A|E1&!E&D1&!D&!C1&!C&B1&B&A1&!A|E1&E&D1&!D&!C1&!C&B1&B&A1&!A|!E1&E&D1&!D&!C1&!C&B1&B&A1&!A|!E1&E&D1&!D&!C1&!C&B1&!B&A1&!A|E1&E&D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&D1&D&!C1&!C&B1&!B&A1&!A|E1&E&D1&D&!C1&!C&B1&!B&A1&!A|!E1&E&D1&D&!C1&!C&B1&!B&A1&!A|!E1&E&!D1&D&!C1&!C&B1&!B&A1&!A|E1&E&!D1&D&!C1&!C&B1&!B&A1&!A|E1&!E&!D1&D&!C1&!C&B1&!B&A1&!A|E1&!E&!D1&D&C1&!C&B1&!B&A1&!A|E1&E&!D1&D&C1&!C&B1&!B&A1&!A|!E1&E&!D1&D&C1&!C&B1&!B&A1&!A|!E1&E&D1&D&C1&!C&B1&!B&A1&!A|E1&E&D1&D&C1&!C&B1&!B&A1&!A|E1&!E&D1&D&C1&!C&B1&!B&A1&!A|E1&!E&D1&!D&C1&!C&B1&!B&A1&!A|E1&E&D1&!D&C1&!C&B1&!B&A1&!A|!E1&E&D1&!D&C1&!C&B1&!B&A1&!A|!E1&E&D1&!D&C1&C&B1&!B&A1&!A|E1&E&D1&!D&C1&C&B1&!B&A1&!A|E1&!E&D1&!D&C1&C&B1&!B&A1&!A|E1&!E&D1&D&C1&C&B1&!B&A1&!A|E1&E&D1&D&C1&C&B1&!B&A1&!A|!E1&E&D1&D&C1&C&B1&!B&A1&!A|!E1&E&!D1&D&C1&C&B1&!B&A1&!A|E1&E&!D1&D&C1&C&B1&!B&A1&!A|E1&!E&!D1&D&C1&C&B1&!B&A1&!A|E1&!E&!D1&D&!C1&C&B1&!B&A1&!A|E1&E&!D1&D&!C1&C&B1&!B&A1&!A|!E1&E&!D1&D&!C1&C&B1&!B&A1&!A|!E1&E&D1&D&!C1&C&B1&!B&A1&!A|E1&E&D1&D&!C1&C&B1&!B&A1&!A|E1&!E&D1&D&!C1&C&B1&!B&A1&!A|E1&!E&D1&!D&!C1&C&B1&!B&A1&!A|E1&E&D1&!D&!C1&C&B1&!B&A1&!A|!E1&E&D1&!D&!C1&C&B1&!B&A1&!A|E1&!E&!D1&D&C1&C&!B1&!B&A1&!A|E1&E&!D1&D&C1&C&!B1&!B&A1&!A|!E1&E&!D1&D&C1&C&!B1&!B&A1&!A|!E1&E&D1&D&C1&C&!B1&!B&A1&!A|E1&E&D1&D&C1&C&!B1&!B&A1&!A|E1&!E&D1&D&C1&C&!B1&!B&A1&!A|E1&!E&D1&!D&C1&C&!B1&!B&A1&!A|E1&E&D1&!D&C1&C&!B1&!B&A1&!A|!E1&E&D1&!D&C1&C&!B1&!B&A1&!A|!E1&E&D1&!D&C1&C&!B1&!B&A1&A|E1&E&D1&!D&C1&C&!B1&!B&A1&A|E1&!E&D1&!D&C1&C&!B1&!B&A1&A|E1&!E&D1&D&C1&C&!B1&!B&A1&A|E1&E&D1&D&C1&C&!B1&!B&A1&A|!E1&E&D1&D&C1&C&!B1&!B&A1&A|!E1&E&!D1&D&C1&C&!B1&!B&A1&A|E1&E&!D1&D&C1&C&!B1&!B&A1&A|E1&!E&!D1&D&C1&C&!B1&!B&A1&A|!E1&E&D1&!D&!C1&C&B1&!B&A1&A|E1&E&D1&!D&!C1&C&B1&!B&A1&A|E1&!E&D1&!D&!C1&C&B1&!B&A1&A|E1&!E&D1&D&!C1&C&B1&!B&A1&A|E1&E&D1&D&!C1&C&B1&!B&A1&A|!E1&E&D1&D&!C1&C&B1&!B&A1&A|!E1&E&!D1&D&!C1&C&B1&!B&A1&A|E1&E&!D1&D&!C1&C&B1&!B&A1&A|E1&!E&!D1&D&!C1&C&B1&!B&A1&A|E1&!E&!D1&D&C1&C&B1&!B&A1&A|E1&E&!D1&D&C1&C&B1&!B&A1&A|!E1&E&!D1&D&C1&C&B1&!B&A1&A|!E1&E&D1&D&C1&C&B1&!B&A1&A|E1&E&D1&D&C1&C&B1&!B&A1&A|E1&!E&D1&D&C1&C&B1&!B&A1&A|E1&!E&D1&!D&C1&C&B1&!B&A1&A|E1&E&D1&!D&C1&C&B1&!B&A1&A|!E1&E&D1&!D&C1&C&B1&!B&A1&A|!E1&E&D1&!D&C1&!C&B1&!B&A1&A|E1&E&D1&!D&C1&!C&B1&!B&A1&A|E1&!E&D1&!D&C1&!C&B1&!B&A1&A|E1&!E&D1&D&C1&!C&B1&!B&A1&A|E1&E&D1&D&C1&!C&B1&!B&A1&A|!E1&E&D1&D&C1&!C&B1&!B&A1&A|!E1&E&!D1&D&C1&!C&B1&!B&A1&A|E1&E&!D1&D&C1&!C&B1&!B&A1&A|E1&!E&!D1&D&C1&!C&B1&!B&A1&A|E1&!E&!D1&D&!C1&!C&B1&!B&A1&A|E1&E&!D1&D&!C1&!C&B1&!B&A1&A|!E1&E&!D1&D&!C1&!C&B1&!B&A1&A|!E1&E&D1&D&!C1&!C&B1&!B&A1&A|E1&E&D1&D&!C1&!C&B1&!B&A1&A|E1&!E&D1&D&!C1&!C&B1&!B&A1&A|E1&!E&D1&!D&!C1&!C&B1&!B&A1&A|E1&E&D1&!D&!C1&!C&B1&!B&A1&A|!E1&E&D1&!D&!C1&!C&B1&!B&A1&A|!E1&E&D1&!D&!C1&!C&B1&B&A1&A|E1&E&D1&!D&!C1&!C&B1&B&A1&A|E1&!E&D1&!D&!C1&!C&B1&B&A1&A|E1&!E&D1&D&!C1&!C&B1&B&A1&A|E1&E&D1&D&!C1&!C&B1&B&A1&A|!E1&E&D1&D&!C1&!C&B1&B&A1&A|!E1&E&!D1&D&!C1&!C&B1&B&A1&A|E1&E&!D1&D&!C1&!C&B1&B&A1&A|E1&!E&!D1&D&!C1&!C&B1&B&A1&A|E1&!E&!D1&D&C1&!C&B1&B&A1&A|E1&E&!D1&D&C1&!C&B1&B&A1&A|!E1&E&!D1&D&C1&!C&B1&B&A1&A|!E1&E&D1&D&C1&!C&B1&B&A1&A|E1&E&D1&D&C1&!C&B1&B&A1&A|E1&!E&D1&D&C1&!C&B1&B&A1&A|E1&!E&D1&!D&C1&!C&B1&B&A1&A|E1&E&D1&!D&C1&!C&B1&B&A1&A|!E1&E&D1&!D&C1&!C&B1&B&A1&A|!E1&E&D1&!D&C1&C&B1&B&A1&A|E1&E&D1&!D&C1&C&B1&B&A1&A|E1&!E&D1&!D&C1&C&B1&B&A1&A|E1&!E&D1&D&C1&C&B1&B&A1&A|E1&E&D1&D&C1&C&B1&B&A1&A|!E1&E&D1&D&C1&C&B1&B&A1&A|!E1&E&!D1&D&C1&C&B1&B&A1&A|E1&E&!D1&D&C1&C&B1&B&A1&A|E1&!E&!D1&D&C1&C&B1&B&A1&A|E1&!E&!D1&D&!C1&C&B1&B&A1&A|E1&E&!D1&D&!C1&C&B1&B&A1&A|!E1&E&!D1&D&!C1&C&B1&B&A1&A|!E1&E&D1&D&!C1&C&B1&B&A1&A|E1&E&D1&D&!C1&C&B1&B&A1&A|E1&!E&D1&D&!C1&C&B1&B&A1&A|E1&!E&D1&!D&!C1&C&B1&B&A1&A|E1&E&D1&!D&!C1&C&B1&B&A1&A|!E1&E&D1&!D&!C1&C&B1&B&A1&A|!E1&E&D1&!D&!C1&C&!B1&B&A1&A|E1&E&D1&!D&!C1&C&!B1&B&A1&A|E1&!E&D1&!D&!C1&C&!B1&B&A1&A|E1&!E&D1&D&!C1&C&!B1&B&A1&A|E1&E&D1&D&!C1&C&!B1&B&A1&A|!E1&E&D1&D&!C1&C&!B1&B&A1&A|!E1&E&!D1&D&!C1&C&!B1&B&A1&A|E1&E&!D1&D&!C1&C&!B1&B&A1&A|E1&!E&!D1&D&!C1&C&!B1&B&A1&A|E1&!E&!D1&D&C1&C&!B1&B&A1&A|E1&E&!D1&D&C1&C&!B1&B&A1&A|!E1&E&!D1&D&C1&C&!B1&B&A1&A|!E1&E&D1&D&C1&C&!B1&B&A1&A|E1&E&D1&D&C1&C&!B1&B&A1&A|E1&!E&D1&D&C1&C&!B1&B&A1&A|E1&!E&D1&!D&C1&C&!B1&B&A1&A|E1&E&D1&!D&C1&C&!B1&B&A1&A|!E1&E&D1&!D&C1&C&!B1&B&A1&A|!E1&E&D1&!D&C1&!C&!B1&B&A1&A|E1&E&D1&!D&C1&!C&!B1&B&A1&A|E1&!E&D1&!D&C1&!C&!B1&B&A1&A|E1&!E&D1&D&C1&!C&!B1&B&A1&A|E1&E&D1&D&C1&!C&!B1&B&A1&A|!E1&E&D1&D&C1&!C&!B1&B&A1&A|!E1&E&!D1&D&C1&!C&!B1&B&A1&A|E1&E&!D1&D&C1&!C&!B1&B&A1&A|E1&!E&!D1&D&C1&!C&!B1&B&A1&A|E1&!E&!D1&D&!C1&!C&!B1&B&A1&A|E1&E&!D1&D&!C1&!C&!B1&B&A1&A|!E1&E&!D1&D&!C1&!C&!B1&B&A1&A|!E1&E&D1&D&!C1&!C&!B1&B&A1&A|E1&E&D1&D&!C1&!C&!B1&B&A1&A|E1&!E&D1&D&!C1&!C&!B1&B&A1&A|E1&!E&D1&!D&!C1&!C&!B1&B&A1&A|E1&E&D1&!D&!C1&!C&!B1&B&A1&A|!E1&E&D1&!D&!C1&!C&!B1&B&A1&A|!E1&E&D1&!D&!C1&!C&!B1&B&!A1&A|E1&E&D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&D1&D&!C1&!C&!B1&B&!A1&A|E1&E&D1&D&!C1&!C&!B1&B&!A1&A|!E1&E&D1&D&!C1&!C&!B1&B&!A1&A|!E1&E&!D1&D&!C1&!C&!B1&B&!A1&A|E1&E&!D1&D&!C1&!C&!B1&B&!A1&A|E1&!E&!D1&D&!C1&!C&!B1&B&!A1&A|E1&!E&!D1&D&C1&!C&!B1&B&!A1&A|E1&E&!D1&D&C1&!C&!B1&B&!A1&A|!E1&E&!D1&D&C1&!C&!B1&B&!A1&A|!E1&E&D1&D&C1&!C&!B1&B&!A1&A|E1&E&D1&D&C1&!C&!B1&B&!A1&A|E1&!E&D1&D&C1&!C&!B1&B&!A1&A|E1&!E&D1&!D&C1&!C&!B1&B&!A1&A|E1&E&D1&!D&C1&!C&!B1&B&!A1&A|!E1&E&D1&!D&C1&!C&!B1&B&!A1&A|!E1&E&D1&!D&C1&C&!B1&B&!A1&A|E1&E&D1&!D&C1&C&!B1&B&!A1&A|E1&!E&D1&!D&C1&C&!B1&B&!A1&A|E1&!E&D1&D&C1&C&!B1&B&!A1&A|E1&E&D1&D&C1&C&!B1&B&!A1&A|!E1&E&D1&D&C1&C&!B1&B&!A1&A|!E1&E&!D1&D&C1&C&!B1&B&!A1&A|E1&E&!D1&D&C1&C&!B1&B&!A1&A|E1&!E&!D1&D&C1&C&!B1&B&!A1&A|E1&!E&!D1&D&!C1&C&!B1&B&!A1&A|E1&E&!D1&D&!C1&C&!B1&B&!A1&A|!E1&E&!D1&D&!C1&C&!B1&B&!A1&A|!E1&E&D1&D&!C1&C&!B1&B&!A1&A|E1&E&D1&D&!C1&C&!B1&B&!A1&A|E1&!E&D1&D&!C1&C&!B1&B&!A1&A|E1&!E&D1&!D&!C1&C&!B1&B&!A1&A|E1&E&D1&!D&!C1&C&!B1&B&!A1&A|!E1&E&D1&!D&!C1&C&!B1&B&!A1&A|!E1&E&D1&!D&!C1&C&B1&B&!A1&A|E1&E&D1&!D&!C1&C&B1&B&!A1&A|E1&!E&D1&!D&!C1&C&B1&B&!A1&A|E1&!E&D1&D&!C1&C&B1&B&!A1&A|E1&E&D1&D&!C1&C&B1&B&!A1&A|!E1&E&D1&D&!C1&C&B1&B&!A1&A|!E1&E&!D1&D&!C1&C&B1&B&!A1&A|E1&E&!D1&D&!C1&C&B1&B&!A1&A|E1&!E&!D1&D&!C1&C&B1&B&!A1&A|E1&!E&!D1&D&C1&C&B1&B&!A1&A|E1&E&!D1&D&C1&C&B1&B&!A1&A|!E1&E&!D1&D&C1&C&B1&B&!A1&A|!E1&E&D1&D&C1&C&B1&B&!A1&A|E1&E&D1&D&C1&C&B1&B&!A1&A|E1&!E&D1&D&C1&C&B1&B&!A1&A|E1&!E&D1&!D&C1&C&B1&B&!A1&A|E1&E&D1&!D&C1&C&B1&B&!A1&A|!E1&E&D1&!D&C1&C&B1&B&!A1&A|!E1&E&D1&!D&C1&!C&B1&B&!A1&A|E1&E&D1&!D&C1&!C&B1&B&!A1&A|E1&!E&D1&!D&C1&!C&B1&B&!A1&A|E1&!E&D1&D&C1&!C&B1&B&!A1&A|E1&E&D1&D&C1&!C&B1&B&!A1&A|!E1&E&D1&D&C1&!C&B1&B&!A1&A|!E1&E&!D1&D&C1&!C&B1&B&!A1&A|E1&E&!D1&D&C1&!C&B1&B&!A1&A|E1&!E&!D1&D&C1&!C&B1&B&!A1&A|E1&!E&!D1&D&!C1&!C&B1&B&!A1&A|E1&E&!D1&D&!C1&!C&B1&B&!A1&A|!E1&E&!D1&D&!C1&!C&B1&B&!A1&A|!E1&E&D1&D&!C1&!C&B1&B&!A1&A|E1&E&D1&D&!C1&!C&B1&B&!A1&A|E1&!E&D1&D&!C1&!C&B1&B&!A1&A|E1&!E&D1&!D&!C1&!C&B1&B&!A1&A|E1&E&D1&!D&!C1&!C&B1&B&!A1&A|!E1&E&D1&!D&!C1&!C&B1&B&!A1&A|!E1&E&D1&!D&!C1&!C&B1&!B&!A1&A|E1&E&D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&D1&D&!C1&!C&B1&!B&!A1&A|E1&E&D1&D&!C1&!C&B1&!B&!A1&A|!E1&E&D1&D&!C1&!C&B1&!B&!A1&A|!E1&E&!D1&D&!C1&!C&B1&!B&!A1&A|E1&E&!D1&D&!C1&!C&B1&!B&!A1&A|E1&!E&!D1&D&!C1&!C&B1&!B&!A1&A|E1&!E&!D1&D&C1&!C&B1&!B&!A1&A|E1&E&!D1&D&C1&!C&B1&!B&!A1&A|!E1&E&!D1&D&C1&!C&B1&!B&!A1&A|!E1&E&D1&D&C1&!C&B1&!B&!A1&A|E1&E&D1&D&C1&!C&B1&!B&!A1&A|E1&!E&D1&D&C1&!C&B1&!B&!A1&A|E1&!E&D1&!D&C1&!C&B1&!B&!A1&A|E1&E&D1&!D&C1&!C&B1&!B&!A1&A|!E1&E&D1&!D&C1&!C&B1&!B&!A1&A|!E1&E&D1&!D&C1&C&B1&!B&!A1&A|E1&E&D1&!D&C1&C&B1&!B&!A1&A|E1&!E&D1&!D&C1&C&B1&!B&!A1&A|E1&!E&D1&D&C1&C&B1&!B&!A1&A|E1&E&D1&D&C1&C&B1&!B&!A1&A|!E1&E&D1&D&C1&C&B1&!B&!A1&A|!E1&E&!D1&D&C1&C&B1&!B&!A1&A|E1&E&!D1&D&C1&C&B1&!B&!A1&A|E1&!E&!D1&D&C1&C&B1&!B&!A1&A|E1&!E&!D1&D&!C1&C&B1&!B&!A1&A|E1&E&!D1&D&!C1&C&B1&!B&!A1&A|!E1&E&!D1&D&!C1&C&B1&!B&!A1&A|!E1&E&D1&D&!C1&C&B1&!B&!A1&A|E1&E&D1&D&!C1&C&B1&!B&!A1&A|E1&!E&D1&D&!C1&C&B1&!B&!A1&A|E1&!E&D1&!D&!C1&C&B1&!B&!A1&A|E1&E&D1&!D&!C1&C&B1&!B&!A1&A|!E1&E&D1&!D&!C1&C&B1&!B&!A1&A|E1&!E&!D1&D&C1&C&!B1&!B&!A1&A|E1&E&!D1&D&C1&C&!B1&!B&!A1&A|!E1&E&!D1&D&C1&C&!B1&!B&!A1&A|!E1&E&D1&D&C1&C&!B1&!B&!A1&A|E1&E&D1&D&C1&C&!B1&!B&!A1&A|E1&!E&D1&D&C1&C&!B1&!B&!A1&A|E1&!E&D1&!D&C1&C&!B1&!B&!A1&A|E1&E&D1&!D&C1&C&!B1&!B&!A1&A|!E1&E&D1&!D&C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOOOAI22222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOI333 -l AAAOI333 -i C2 C1 C B2 B1 B A2 A1 A -o Y -f Y=!(C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|C2&C1&C&B2&!B1&!B&!A2&!A1&!A|C2&C1&C&B2&B1&!B&!A2&!A1&!A|C2&C1&C&!B2&B1&!B&!A2&!A1&!A|C2&C1&C&!B2&B1&B&!A2&!A1&!A|!C2&!C1&C&B2&B1&B&!A2&!A1&!A|C2&!C1&C&B2&B1&B&!A2&!A1&!A|C2&C1&C&B2&B1&B&!A2&!A1&!A|!C2&C1&C&B2&B1&B&!A2&!A1&!A|!C2&C1&!C&B2&B1&B&!A2&!A1&!A|C2&C1&!C&B2&B1&B&!A2&!A1&!A|C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|C2&C1&C&B2&!B1&B&!A2&!A1&!A|C2&C1&C&!B2&!B1&B&!A2&!A1&!A|C2&C1&C&!B2&!B1&B&A2&!A1&!A|C2&C1&C&B2&!B1&B&A2&!A1&!A|!C2&!C1&!C&B2&B1&B&A2&!A1&!A|C2&!C1&!C&B2&B1&B&A2&!A1&!A|C2&C1&!C&B2&B1&B&A2&!A1&!A|!C2&C1&!C&B2&B1&B&A2&!A1&!A|!C2&C1&C&B2&B1&B&A2&!A1&!A|C2&C1&C&B2&B1&B&A2&!A1&!A|C2&!C1&C&B2&B1&B&A2&!A1&!A|!C2&!C1&C&B2&B1&B&A2&!A1&!A|C2&C1&C&!B2&B1&B&A2&!A1&!A|C2&C1&C&!B2&B1&!B&A2&!A1&!A|C2&C1&C&B2&B1&!B&A2&!A1&!A|C2&C1&C&B2&!B1&!B&A2&!A1&!A|C2&C1&C&!B2&!B1&!B&A2&!A1&!A|C2&C1&C&!B2&!B1&!B&A2&A1&!A|C2&C1&C&B2&!B1&!B&A2&A1&!A|C2&C1&C&B2&B1&!B&A2&A1&!A|C2&C1&C&!B2&B1&!B&A2&A1&!A|C2&C1&C&!B2&B1&B&A2&A1&!A|!C2&!C1&C&B2&B1&B&A2&A1&!A|C2&!C1&C&B2&B1&B&A2&A1&!A|C2&C1&C&B2&B1&B&A2&A1&!A|!C2&C1&C&B2&B1&B&A2&A1&!A|!C2&C1&!C&B2&B1&B&A2&A1&!A|C2&C1&!C&B2&B1&B&A2&A1&!A|C2&!C1&!C&B2&B1&B&A2&A1&!A|!C2&!C1&!C&B2&B1&B&A2&A1&!A|C2&C1&C&B2&!B1&B&A2&A1&!A|C2&C1&C&!B2&!B1&B&A2&A1&!A|C2&C1&C&!B2&!B1&B&!A2&A1&!A|C2&C1&C&B2&!B1&B&!A2&A1&!A|!C2&!C1&!C&B2&B1&B&!A2&A1&!A|C2&!C1&!C&B2&B1&B&!A2&A1&!A|C2&C1&!C&B2&B1&B&!A2&A1&!A|!C2&C1&!C&B2&B1&B&!A2&A1&!A|!C2&C1&C&B2&B1&B&!A2&A1&!A|C2&C1&C&B2&B1&B&!A2&A1&!A|C2&!C1&C&B2&B1&B&!A2&A1&!A|!C2&!C1&C&B2&B1&B&!A2&A1&!A|C2&C1&C&!B2&B1&B&!A2&A1&!A|C2&C1&C&!B2&B1&!B&!A2&A1&!A|C2&C1&C&B2&B1&!B&!A2&A1&!A|C2&C1&C&B2&!B1&!B&!A2&A1&!A|C2&C1&C&!B2&!B1&!B&!A2&A1&!A|C2&C1&C&!B2&!B1&!B&!A2&A1&A|C2&C1&C&B2&!B1&!B&!A2&A1&A|C2&C1&C&B2&B1&!B&!A2&A1&A|C2&C1&C&!B2&B1&!B&!A2&A1&A|C2&C1&C&!B2&B1&B&!A2&A1&A|!C2&!C1&C&B2&B1&B&!A2&A1&A|C2&!C1&C&B2&B1&B&!A2&A1&A|C2&C1&C&B2&B1&B&!A2&A1&A|!C2&C1&C&B2&B1&B&!A2&A1&A|!C2&C1&!C&B2&B1&B&!A2&A1&A|C2&C1&!C&B2&B1&B&!A2&A1&A|C2&!C1&!C&B2&B1&B&!A2&A1&A|!C2&!C1&!C&B2&B1&B&!A2&A1&A|C2&C1&C&B2&!B1&B&!A2&A1&A|C2&C1&C&!B2&!B1&B&!A2&A1&A|!C2&!C1&!C&!B2&!B1&B&A2&A1&A|C2&!C1&!C&!B2&!B1&B&A2&A1&A|C2&C1&!C&!B2&!B1&B&A2&A1&A|!C2&C1&!C&!B2&!B1&B&A2&A1&A|!C2&C1&C&!B2&!B1&B&A2&A1&A|C2&C1&C&!B2&!B1&B&A2&A1&A|C2&!C1&C&!B2&!B1&B&A2&A1&A|!C2&!C1&C&!B2&!B1&B&A2&A1&A|!C2&!C1&C&B2&!B1&B&A2&A1&A|C2&!C1&C&B2&!B1&B&A2&A1&A|C2&C1&C&B2&!B1&B&A2&A1&A|!C2&C1&C&B2&!B1&B&A2&A1&A|!C2&C1&!C&B2&!B1&B&A2&A1&A|C2&C1&!C&B2&!B1&B&A2&A1&A|C2&!C1&!C&B2&!B1&B&A2&A1&A|!C2&!C1&!C&B2&!B1&B&A2&A1&A|!C2&!C1&!C&B2&B1&B&A2&A1&A|C2&!C1&!C&B2&B1&B&A2&A1&A|C2&C1&!C&B2&B1&B&A2&A1&A|!C2&C1&!C&B2&B1&B&A2&A1&A|!C2&C1&C&B2&B1&B&A2&A1&A|C2&C1&C&B2&B1&B&A2&A1&A|C2&!C1&C&B2&B1&B&A2&A1&A|!C2&!C1&C&B2&B1&B&A2&A1&A|!C2&!C1&C&!B2&B1&B&A2&A1&A|C2&!C1&C&!B2&B1&B&A2&A1&A|C2&C1&C&!B2&B1&B&A2&A1&A|!C2&C1&C&!B2&B1&B&A2&A1&A|!C2&C1&!C&!B2&B1&B&A2&A1&A|C2&C1&!C&!B2&B1&B&A2&A1&A|C2&!C1&!C&!B2&B1&B&A2&A1&A|!C2&!C1&!C&!B2&B1&B&A2&A1&A|!C2&!C1&!C&!B2&B1&!B&A2&A1&A|C2&!C1&!C&!B2&B1&!B&A2&A1&A|C2&C1&!C&!B2&B1&!B&A2&A1&A|!C2&C1&!C&!B2&B1&!B&A2&A1&A|!C2&C1&C&!B2&B1&!B&A2&A1&A|C2&C1&C&!B2&B1&!B&A2&A1&A|C2&!C1&C&!B2&B1&!B&A2&A1&A|!C2&!C1&C&!B2&B1&!B&A2&A1&A|!C2&!C1&C&B2&B1&!B&A2&A1&A|C2&!C1&C&B2&B1&!B&A2&A1&A|C2&C1&C&B2&B1&!B&A2&A1&A|!C2&C1&C&B2&B1&!B&A2&A1&A|!C2&C1&!C&B2&B1&!B&A2&A1&A|C2&C1&!C&B2&B1&!B&A2&A1&A|C2&!C1&!C&B2&B1&!B&A2&A1&A|!C2&!C1&!C&B2&B1&!B&A2&A1&A|!C2&!C1&!C&B2&!B1&!B&A2&A1&A|C2&!C1&!C&B2&!B1&!B&A2&A1&A|C2&C1&!C&B2&!B1&!B&A2&A1&A|!C2&C1&!C&B2&!B1&!B&A2&A1&A|!C2&C1&C&B2&!B1&!B&A2&A1&A|C2&C1&C&B2&!B1&!B&A2&A1&A|C2&!C1&C&B2&!B1&!B&A2&A1&A|!C2&!C1&C&B2&!B1&!B&A2&A1&A|!C2&!C1&C&!B2&!B1&!B&A2&A1&A|C2&!C1&C&!B2&!B1&!B&A2&A1&A|C2&C1&C&!B2&!B1&!B&A2&A1&A|!C2&C1&C&!B2&!B1&!B&A2&A1&A|!C2&C1&!C&!B2&!B1&!B&A2&A1&A|C2&C1&!C&!B2&!B1&!B&A2&A1&A|C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|C2&C1&C&!B2&!B1&!B&A2&!A1&A|C2&C1&C&B2&!B1&!B&A2&!A1&A|C2&C1&C&B2&B1&!B&A2&!A1&A|C2&C1&C&!B2&B1&!B&A2&!A1&A|C2&C1&C&!B2&B1&B&A2&!A1&A|!C2&!C1&C&B2&B1&B&A2&!A1&A|C2&!C1&C&B2&B1&B&A2&!A1&A|C2&C1&C&B2&B1&B&A2&!A1&A|!C2&C1&C&B2&B1&B&A2&!A1&A|!C2&C1&!C&B2&B1&B&A2&!A1&A|C2&C1&!C&B2&B1&B&A2&!A1&A|C2&!C1&!C&B2&B1&B&A2&!A1&A|!C2&!C1&!C&B2&B1&B&A2&!A1&A|C2&C1&C&B2&!B1&B&A2&!A1&A|C2&C1&C&!B2&!B1&B&A2&!A1&A|C2&C1&C&!B2&!B1&B&!A2&!A1&A|C2&C1&C&B2&!B1&B&!A2&!A1&A|!C2&!C1&!C&B2&B1&B&!A2&!A1&A|C2&!C1&!C&B2&B1&B&!A2&!A1&A|C2&C1&!C&B2&B1&B&!A2&!A1&A|!C2&C1&!C&B2&B1&B&!A2&!A1&A|!C2&C1&C&B2&B1&B&!A2&!A1&A|C2&C1&C&B2&B1&B&!A2&!A1&A|C2&!C1&C&B2&B1&B&!A2&!A1&A|!C2&!C1&C&B2&B1&B&!A2&!A1&A|C2&C1&C&!B2&B1&B&!A2&!A1&A|C2&C1&C&!B2&B1&!B&!A2&!A1&A|C2&C1&C&B2&B1&!B&!A2&!A1&A|C2&C1&C&B2&!B1&!B&!A2&!A1&A|C2&C1&C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOI333.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOI221 -l AAOI221 -i C B1 B A1 A -o Y -f Y=(!C&!B1&!B&!A1&!A|!C&B1&!B&!A1&!A|!C&!B1&B&!A1&!A|!C&!B1&B&A1&!A|!C&B1&!B&A1&!A|!C&!B1&!B&A1&!A|!C&!B1&B&!A1&A|!C&B1&!B&!A1&A|!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOI221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAI2222 -l AAOOAI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=!(!D1&D&C1&!C&B1&B&!A1&!A|D1&D&C1&!C&B1&B&!A1&!A|D1&!D&C1&!C&B1&B&!A1&!A|D1&!D&C1&C&B1&B&!A1&!A|D1&D&C1&C&B1&B&!A1&!A|!D1&D&C1&C&B1&B&!A1&!A|!D1&D&!C1&C&B1&B&!A1&!A|D1&D&!C1&C&B1&B&!A1&!A|D1&!D&!C1&C&B1&B&!A1&!A|D1&!D&!C1&C&B1&B&A1&!A|D1&D&!C1&C&B1&B&A1&!A|!D1&D&!C1&C&B1&B&A1&!A|!D1&D&C1&C&B1&B&A1&!A|D1&D&C1&C&B1&B&A1&!A|D1&!D&C1&C&B1&B&A1&!A|D1&!D&C1&!C&B1&B&A1&!A|D1&D&C1&!C&B1&B&A1&!A|!D1&D&C1&!C&B1&B&A1&!A|!D1&D&C1&!C&!B1&!B&A1&A|D1&D&C1&!C&!B1&!B&A1&A|D1&!D&C1&!C&!B1&!B&A1&A|D1&!D&C1&C&!B1&!B&A1&A|D1&D&C1&C&!B1&!B&A1&A|!D1&D&C1&C&!B1&!B&A1&A|!D1&D&!C1&C&!B1&!B&A1&A|D1&D&!C1&C&!B1&!B&A1&A|D1&!D&!C1&C&!B1&!B&A1&A|D1&!D&!C1&C&B1&!B&A1&A|D1&D&!C1&C&B1&!B&A1&A|!D1&D&!C1&C&B1&!B&A1&A|!D1&D&C1&C&B1&!B&A1&A|D1&D&C1&C&B1&!B&A1&A|D1&!D&C1&C&B1&!B&A1&A|D1&!D&C1&!C&B1&!B&A1&A|D1&D&C1&!C&B1&!B&A1&A|!D1&D&C1&!C&B1&!B&A1&A|!D1&D&C1&!C&B1&B&A1&A|D1&D&C1&!C&B1&B&A1&A|D1&!D&C1&!C&B1&B&A1&A|D1&!D&C1&C&B1&B&A1&A|D1&D&C1&C&B1&B&A1&A|!D1&D&C1&C&B1&B&A1&A|!D1&D&!C1&C&B1&B&A1&A|D1&D&!C1&C&B1&B&A1&A|D1&!D&!C1&C&B1&B&A1&A|D1&!D&!C1&C&!B1&B&A1&A|D1&D&!C1&C&!B1&B&A1&A|!D1&D&!C1&C&!B1&B&A1&A|!D1&D&C1&C&!B1&B&A1&A|D1&D&C1&C&!B1&B&A1&A|D1&!D&C1&C&!B1&B&A1&A|D1&!D&C1&!C&!B1&B&A1&A|D1&D&C1&!C&!B1&B&A1&A|!D1&D&C1&!C&!B1&B&A1&A|D1&!D&!C1&C&B1&B&!A1&A|D1&D&!C1&C&B1&B&!A1&A|!D1&D&!C1&C&B1&B&!A1&A|!D1&D&C1&C&B1&B&!A1&A|D1&D&C1&C&B1&B&!A1&A|D1&!D&C1&C&B1&B&!A1&A|D1&!D&C1&!C&B1&B&!A1&A|D1&D&C1&!C&B1&B&!A1&A|!D1&D&C1&!C&B1&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOI2221 -l AOAOI2221 -i D C1 C B1 B A1 A -o Y -f Y=(!D&!C1&!C&!B1&!B&!A1&!A|!D&C1&!C&!B1&!B&!A1&!A|!D&C1&C&!B1&!B&!A1&!A|!D&!C1&C&!B1&!B&!A1&!A|!D&!C1&C&B1&!B&!A1&!A|!D&C1&!C&B1&!B&!A1&!A|!D&!C1&!C&B1&!B&!A1&!A|!D&!C1&!C&B1&B&!A1&!A|!D&C1&!C&B1&B&!A1&!A|!D&!C1&C&B1&B&!A1&!A|!D&!C1&C&!B1&B&!A1&!A|!D&C1&!C&!B1&B&!A1&!A|!D&!C1&!C&!B1&B&!A1&!A|!D&!C1&!C&!B1&B&A1&!A|!D&C1&!C&!B1&B&A1&!A|!D&!C1&C&!B1&B&A1&!A|!D&!C1&C&B1&B&A1&!A|!D&C1&!C&B1&B&A1&!A|!D&!C1&!C&B1&B&A1&!A|!D&!C1&!C&B1&!B&A1&!A|!D&C1&!C&B1&!B&A1&!A|!D&!C1&C&B1&!B&A1&!A|!D&!C1&C&!B1&!B&A1&!A|!D&C1&C&!B1&!B&A1&!A|!D&C1&!C&!B1&!B&A1&!A|!D&!C1&!C&!B1&!B&A1&!A|!D&!C1&!C&!B1&!B&A1&A|!D&C1&!C&!B1&!B&A1&A|!D&!C1&C&!B1&!B&A1&A|!D&!C1&C&B1&!B&A1&A|!D&C1&!C&B1&!B&A1&A|!D&!C1&!C&B1&!B&A1&A|!D&!C1&!C&B1&B&A1&A|!D&C1&!C&B1&B&A1&A|!D&!C1&C&B1&B&A1&A|!D&!C1&C&!B1&B&A1&A|!D&C1&!C&!B1&B&A1&A|!D&!C1&!C&!B1&B&A1&A|!D&!C1&!C&!B1&B&!A1&A|!D&C1&!C&!B1&B&!A1&A|!D&!C1&C&!B1&B&!A1&A|!D&!C1&C&B1&B&!A1&A|!D&C1&!C&B1&B&!A1&A|!D&!C1&!C&B1&B&!A1&A|!D&!C1&!C&B1&!B&!A1&A|!D&C1&!C&B1&!B&!A1&A|!D&!C1&C&B1&!B&!A1&A|!D&!C1&C&!B1&!B&!A1&A|!D&C1&C&!B1&!B&!A1&A|!D&C1&!C&!B1&!B&!A1&A|!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOI2221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOI23 -l AOI23 -i B2 B1 B A1 A -o Y -f Y=(!B2&!B1&!B&!A1&!A|!B2&!B1&!B&A1&!A|!B2&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOI23.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAOI2221 -l OOOAOI2221 -i D C1 C B1 B A1 A -o Y -f Y=(!D&!C1&!C&!B1&!B&!A1&!A|!D&C1&!C&!B1&!B&!A1&!A|!D&C1&C&!B1&!B&!A1&!A|!D&!C1&C&!B1&!B&!A1&!A|!D&!C1&C&B1&!B&!A1&!A|!D&C1&C&B1&!B&!A1&!A|!D&C1&!C&B1&!B&!A1&!A|!D&!C1&!C&B1&!B&!A1&!A|!D&!C1&!C&B1&B&!A1&!A|!D&C1&!C&B1&B&!A1&!A|!D&C1&C&B1&B&!A1&!A|!D&!C1&C&B1&B&!A1&!A|!D&!C1&C&!B1&B&!A1&!A|!D&C1&C&!B1&B&!A1&!A|!D&C1&!C&!B1&B&!A1&!A|!D&!C1&!C&!B1&B&!A1&!A|!D&!C1&!C&!B1&B&A1&!A|!D&!C1&!C&B1&B&A1&!A|!D&!C1&!C&B1&!B&A1&!A|!D&!C1&C&!B1&!B&A1&!A|!D&C1&C&!B1&!B&A1&!A|!D&C1&!C&!B1&!B&A1&!A|!D&!C1&!C&!B1&!B&A1&!A|!D&!C1&!C&!B1&!B&A1&A|!D&C1&!C&!B1&!B&A1&A|!D&C1&C&!B1&!B&A1&A|!D&!C1&C&!B1&!B&A1&A|!D&!C1&!C&B1&!B&A1&A|!D&!C1&!C&B1&B&A1&A|!D&!C1&!C&!B1&B&A1&A|!D&!C1&!C&!B1&B&!A1&A|!D&!C1&!C&B1&B&!A1&A|!D&!C1&!C&B1&!B&!A1&A|!D&!C1&C&!B1&!B&!A1&A|!D&C1&C&!B1&!B&!A1&A|!D&C1&!C&!B1&!B&!A1&A|!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAOI2221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAOI22121 -l AAOOAOI22121 -i E D1 D C B1 B A1 A -o Y -f Y=(!E&!D1&!D&!C&!B1&!B&!A1&!A|!E&D1&!D&!C&!B1&!B&!A1&!A|!E&D1&D&!C&!B1&!B&!A1&!A|!E&!D1&D&!C&!B1&!B&!A1&!A|!E&!D1&!D&C&!B1&!B&!A1&!A|!E&!D1&!D&C&B1&!B&!A1&!A|!E&!D1&D&!C&B1&!B&!A1&!A|!E&D1&D&!C&B1&!B&!A1&!A|!E&D1&!D&!C&B1&!B&!A1&!A|!E&!D1&!D&!C&B1&!B&!A1&!A|!E&!D1&!D&!C&B1&B&!A1&!A|!E&!D1&!D&C&B1&B&!A1&!A|!E&!D1&!D&C&!B1&B&!A1&!A|!E&!D1&D&!C&!B1&B&!A1&!A|!E&D1&D&!C&!B1&B&!A1&!A|!E&D1&!D&!C&!B1&B&!A1&!A|!E&!D1&!D&!C&!B1&B&!A1&!A|!E&!D1&!D&!C&!B1&B&A1&!A|!E&D1&!D&!C&!B1&B&A1&!A|!E&D1&D&!C&!B1&B&A1&!A|!E&!D1&D&!C&!B1&B&A1&!A|!E&!D1&!D&C&!B1&B&A1&!A|!E&!D1&!D&C&B1&B&A1&!A|!E&!D1&!D&!C&B1&B&A1&!A|!E&!D1&!D&!C&B1&!B&A1&!A|!E&D1&!D&!C&B1&!B&A1&!A|!E&D1&D&!C&B1&!B&A1&!A|!E&!D1&D&!C&B1&!B&A1&!A|!E&!D1&!D&C&B1&!B&A1&!A|!E&!D1&!D&C&!B1&!B&A1&!A|!E&!D1&D&!C&!B1&!B&A1&!A|!E&D1&D&!C&!B1&!B&A1&!A|!E&D1&!D&!C&!B1&!B&A1&!A|!E&!D1&!D&!C&!B1&!B&A1&!A|!E&!D1&!D&!C&!B1&!B&A1&A|!E&!D1&!D&C&!B1&!B&A1&A|!E&!D1&!D&C&B1&!B&A1&A|!E&!D1&!D&!C&B1&!B&A1&A|!E&!D1&!D&!C&B1&B&A1&A|!E&!D1&!D&C&B1&B&A1&A|!E&!D1&!D&C&!B1&B&A1&A|!E&!D1&!D&!C&!B1&B&A1&A|!E&!D1&!D&!C&!B1&B&!A1&A|!E&D1&!D&!C&!B1&B&!A1&A|!E&D1&D&!C&!B1&B&!A1&A|!E&!D1&D&!C&!B1&B&!A1&A|!E&!D1&!D&C&!B1&B&!A1&A|!E&!D1&!D&C&B1&B&!A1&A|!E&!D1&!D&!C&B1&B&!A1&A|!E&!D1&!D&!C&B1&!B&!A1&A|!E&D1&!D&!C&B1&!B&!A1&A|!E&D1&D&!C&B1&!B&!A1&A|!E&!D1&D&!C&B1&!B&!A1&A|!E&!D1&!D&C&B1&!B&!A1&A|!E&!D1&!D&C&!B1&!B&!A1&A|!E&!D1&D&!C&!B1&!B&!A1&A|!E&D1&D&!C&!B1&!B&!A1&A|!E&D1&!D&!C&!B1&!B&!A1&A|!E&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAOI22121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAI311 -l AOAI311 -i C B A2 A1 A -o Y -f Y=!(C&B&!A2&!A1&!A|C&B&A2&!A1&!A|C&B&A2&A1&!A|C&B&!A2&A1&!A|C&B&!A2&A1&A|C&B&A2&A1&A|C&!B&A2&A1&A|C&B&A2&!A1&A|C&B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAI311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOAI21311 -l OAAOAI21311 -i E D C2 C1 C B A1 A -o Y -f Y=!(E&D&!C2&!C1&!C&!B&!A1&!A|E&D&C2&!C1&!C&!B&!A1&!A|E&D&C2&C1&!C&!B&!A1&!A|E&D&!C2&C1&!C&!B&!A1&!A|E&D&!C2&C1&C&!B&!A1&!A|E&D&C2&C1&C&!B&!A1&!A|E&!D&C2&C1&C&!B&!A1&!A|E&D&C2&!C1&C&!B&!A1&!A|E&D&!C2&!C1&C&!B&!A1&!A|E&D&!C2&!C1&C&B&!A1&!A|E&D&C2&!C1&C&B&!A1&!A|E&!D&C2&C1&C&B&!A1&!A|E&D&C2&C1&C&B&!A1&!A|E&D&!C2&C1&C&B&!A1&!A|E&D&!C2&C1&!C&B&!A1&!A|E&D&C2&C1&!C&B&!A1&!A|E&D&C2&!C1&!C&B&!A1&!A|E&D&!C2&!C1&!C&B&!A1&!A|E&!D&!C2&!C1&!C&B&A1&!A|E&D&!C2&!C1&!C&B&A1&!A|E&D&C2&!C1&!C&B&A1&!A|E&!D&C2&!C1&!C&B&A1&!A|E&!D&C2&C1&!C&B&A1&!A|E&D&C2&C1&!C&B&A1&!A|E&D&!C2&C1&!C&B&A1&!A|E&!D&!C2&C1&!C&B&A1&!A|E&!D&!C2&C1&C&B&A1&!A|E&D&!C2&C1&C&B&A1&!A|E&D&C2&C1&C&B&A1&!A|E&!D&C2&C1&C&B&A1&!A|E&!D&C2&!C1&C&B&A1&!A|E&D&C2&!C1&C&B&A1&!A|E&D&!C2&!C1&C&B&A1&!A|E&!D&!C2&!C1&C&B&A1&!A|E&D&!C2&!C1&C&!B&A1&!A|E&D&C2&!C1&C&!B&A1&!A|E&!D&C2&C1&C&!B&A1&!A|E&D&C2&C1&C&!B&A1&!A|E&D&!C2&C1&C&!B&A1&!A|E&D&!C2&C1&!C&!B&A1&!A|E&D&C2&C1&!C&!B&A1&!A|E&D&C2&!C1&!C&!B&A1&!A|E&D&!C2&!C1&!C&!B&A1&!A|E&D&!C2&!C1&!C&!B&A1&A|E&D&C2&!C1&!C&!B&A1&A|E&D&C2&C1&!C&!B&A1&A|E&D&!C2&C1&!C&!B&A1&A|E&D&!C2&C1&C&!B&A1&A|E&D&C2&C1&C&!B&A1&A|E&!D&C2&C1&C&!B&A1&A|E&D&C2&!C1&C&!B&A1&A|E&D&!C2&!C1&C&!B&A1&A|E&!D&!C2&!C1&C&B&A1&A|E&D&!C2&!C1&C&B&A1&A|E&D&C2&!C1&C&B&A1&A|E&!D&C2&!C1&C&B&A1&A|E&!D&C2&C1&C&B&A1&A|E&D&C2&C1&C&B&A1&A|E&D&!C2&C1&C&B&A1&A|E&!D&!C2&C1&C&B&A1&A|E&!D&!C2&C1&!C&B&A1&A|E&D&!C2&C1&!C&B&A1&A|E&D&C2&C1&!C&B&A1&A|E&!D&C2&C1&!C&B&A1&A|E&!D&C2&!C1&!C&B&A1&A|E&D&C2&!C1&!C&B&A1&A|E&D&!C2&!C1&!C&B&A1&A|E&!D&!C2&!C1&!C&B&A1&A|E&!D&!C2&!C1&!C&B&!A1&A|E&D&!C2&!C1&!C&B&!A1&A|E&D&C2&!C1&!C&B&!A1&A|E&!D&C2&!C1&!C&B&!A1&A|E&!D&C2&C1&!C&B&!A1&A|E&D&C2&C1&!C&B&!A1&A|E&D&!C2&C1&!C&B&!A1&A|E&!D&!C2&C1&!C&B&!A1&A|E&!D&!C2&C1&C&B&!A1&A|E&D&!C2&C1&C&B&!A1&A|E&D&C2&C1&C&B&!A1&A|E&!D&C2&C1&C&B&!A1&A|E&!D&C2&!C1&C&B&!A1&A|E&D&C2&!C1&C&B&!A1&A|E&D&!C2&!C1&C&B&!A1&A|E&!D&!C2&!C1&C&B&!A1&A|E&D&!C2&!C1&C&!B&!A1&A|E&D&C2&!C1&C&!B&!A1&A|E&!D&C2&C1&C&!B&!A1&A|E&D&C2&C1&C&!B&!A1&A|E&D&!C2&C1&C&!B&!A1&A|E&D&!C2&C1&!C&!B&!A1&A|E&D&C2&C1&!C&!B&!A1&A|E&D&C2&!C1&!C&!B&!A1&A|E&D&!C2&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOAI21311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOAI3221 -l OOAAOAI3221 -i D C1 C B1 B A2 A1 A -o Y -f Y=!(D&C1&C&!B1&!B&!A2&!A1&!A|D&C1&C&B1&!B&!A2&!A1&!A|D&C1&C&B1&B&!A2&!A1&!A|D&C1&C&!B1&B&!A2&!A1&!A|D&!C1&!C&!B1&B&A2&!A1&!A|D&C1&!C&!B1&B&A2&!A1&!A|D&C1&C&!B1&B&A2&!A1&!A|D&!C1&C&!B1&B&A2&!A1&!A|D&!C1&C&B1&B&A2&!A1&!A|D&C1&C&B1&B&A2&!A1&!A|D&C1&!C&B1&B&A2&!A1&!A|D&!C1&!C&B1&B&A2&!A1&!A|D&!C1&!C&B1&!B&A2&!A1&!A|D&C1&!C&B1&!B&A2&!A1&!A|D&C1&C&B1&!B&A2&!A1&!A|D&!C1&C&B1&!B&A2&!A1&!A|D&C1&C&!B1&!B&A2&!A1&!A|D&C1&C&!B1&!B&A2&A1&!A|D&!C1&C&B1&!B&A2&A1&!A|D&C1&C&B1&!B&A2&A1&!A|D&C1&!C&B1&!B&A2&A1&!A|D&!C1&!C&B1&!B&A2&A1&!A|D&!C1&!C&B1&B&A2&A1&!A|D&C1&!C&B1&B&A2&A1&!A|D&C1&C&B1&B&A2&A1&!A|D&!C1&C&B1&B&A2&A1&!A|D&!C1&C&!B1&B&A2&A1&!A|D&C1&C&!B1&B&A2&A1&!A|D&C1&!C&!B1&B&A2&A1&!A|D&!C1&!C&!B1&B&A2&A1&!A|D&!C1&!C&!B1&B&!A2&A1&!A|D&C1&!C&!B1&B&!A2&A1&!A|D&C1&C&!B1&B&!A2&A1&!A|D&!C1&C&!B1&B&!A2&A1&!A|D&!C1&C&B1&B&!A2&A1&!A|D&C1&C&B1&B&!A2&A1&!A|D&C1&!C&B1&B&!A2&A1&!A|D&!C1&!C&B1&B&!A2&A1&!A|D&!C1&!C&B1&!B&!A2&A1&!A|D&C1&!C&B1&!B&!A2&A1&!A|D&C1&C&B1&!B&!A2&A1&!A|D&!C1&C&B1&!B&!A2&A1&!A|D&C1&C&!B1&!B&!A2&A1&!A|D&C1&C&!B1&!B&!A2&A1&A|D&!C1&C&B1&!B&!A2&A1&A|D&C1&C&B1&!B&!A2&A1&A|D&C1&!C&B1&!B&!A2&A1&A|D&!C1&!C&B1&!B&!A2&A1&A|D&!C1&!C&B1&B&!A2&A1&A|D&C1&!C&B1&B&!A2&A1&A|D&C1&C&B1&B&!A2&A1&A|D&!C1&C&B1&B&!A2&A1&A|D&!C1&C&!B1&B&!A2&A1&A|D&C1&C&!B1&B&!A2&A1&A|D&C1&!C&!B1&B&!A2&A1&A|D&!C1&!C&!B1&B&!A2&A1&A|D&!C1&!C&!B1&B&A2&A1&A|D&C1&!C&!B1&B&A2&A1&A|D&C1&C&!B1&B&A2&A1&A|D&!C1&C&!B1&B&A2&A1&A|D&!C1&C&B1&B&A2&A1&A|D&C1&C&B1&B&A2&A1&A|D&C1&!C&B1&B&A2&A1&A|D&!C1&!C&B1&B&A2&A1&A|D&!C1&!C&B1&!B&A2&A1&A|D&C1&!C&B1&!B&A2&A1&A|D&C1&C&B1&!B&A2&A1&A|D&!C1&C&B1&!B&A2&A1&A|D&C1&C&!B1&!B&A2&A1&A|D&C1&C&!B1&!B&A2&!A1&A|D&!C1&C&B1&!B&A2&!A1&A|D&C1&C&B1&!B&A2&!A1&A|D&C1&!C&B1&!B&A2&!A1&A|D&!C1&!C&B1&!B&A2&!A1&A|D&!C1&!C&B1&B&A2&!A1&A|D&C1&!C&B1&B&A2&!A1&A|D&C1&C&B1&B&A2&!A1&A|D&!C1&C&B1&B&A2&!A1&A|D&!C1&C&!B1&B&A2&!A1&A|D&C1&C&!B1&B&A2&!A1&A|D&C1&!C&!B1&B&A2&!A1&A|D&!C1&!C&!B1&B&A2&!A1&A|D&!C1&!C&!B1&B&!A2&!A1&A|D&C1&!C&!B1&B&!A2&!A1&A|D&C1&C&!B1&B&!A2&!A1&A|D&!C1&C&!B1&B&!A2&!A1&A|D&!C1&C&B1&B&!A2&!A1&A|D&C1&C&B1&B&!A2&!A1&A|D&C1&!C&B1&B&!A2&!A1&A|D&!C1&!C&B1&B&!A2&!A1&A|D&!C1&!C&B1&!B&!A2&!A1&A|D&C1&!C&B1&!B&!A2&!A1&A|D&C1&C&B1&!B&!A2&!A1&A|D&!C1&C&B1&!B&!A2&!A1&A|D&C1&C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOAI3221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOOAOI22131 -l OOAOOAOI22131 -i E D2 D1 D C B1 B A1 A -o Y -f Y=(!E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!E&D2&!D1&!D&!C&!B1&!B&!A1&!A|!E&D2&D1&!D&!C&!B1&!B&!A1&!A|!E&!D2&D1&!D&!C&!B1&!B&!A1&!A|!E&!D2&D1&D&!C&!B1&!B&!A1&!A|!E&D2&D1&D&!C&!B1&!B&!A1&!A|!E&D2&!D1&D&!C&!B1&!B&!A1&!A|!E&!D2&!D1&D&!C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&C&B1&!B&!A1&!A|!E&!D2&!D1&D&!C&B1&!B&!A1&!A|!E&D2&!D1&D&!C&B1&!B&!A1&!A|!E&D2&D1&D&!C&B1&!B&!A1&!A|!E&!D2&D1&D&!C&B1&!B&!A1&!A|!E&!D2&D1&!D&!C&B1&!B&!A1&!A|!E&D2&D1&!D&!C&B1&!B&!A1&!A|!E&D2&!D1&!D&!C&B1&!B&!A1&!A|!E&!D2&!D1&!D&!C&B1&!B&!A1&!A|!E&!D2&!D1&!D&!C&B1&B&!A1&!A|!E&D2&!D1&!D&!C&B1&B&!A1&!A|!E&D2&D1&!D&!C&B1&B&!A1&!A|!E&!D2&D1&!D&!C&B1&B&!A1&!A|!E&!D2&D1&D&!C&B1&B&!A1&!A|!E&D2&D1&D&!C&B1&B&!A1&!A|!E&D2&!D1&D&!C&B1&B&!A1&!A|!E&!D2&!D1&D&!C&B1&B&!A1&!A|!E&!D2&!D1&!D&C&B1&B&!A1&!A|!E&!D2&!D1&!D&C&!B1&B&!A1&!A|!E&!D2&!D1&D&!C&!B1&B&!A1&!A|!E&D2&!D1&D&!C&!B1&B&!A1&!A|!E&D2&D1&D&!C&!B1&B&!A1&!A|!E&!D2&D1&D&!C&!B1&B&!A1&!A|!E&!D2&D1&!D&!C&!B1&B&!A1&!A|!E&D2&D1&!D&!C&!B1&B&!A1&!A|!E&D2&!D1&!D&!C&!B1&B&!A1&!A|!E&!D2&!D1&!D&!C&!B1&B&!A1&!A|!E&!D2&!D1&!D&!C&!B1&B&A1&!A|!E&!D2&!D1&!D&C&!B1&B&A1&!A|!E&!D2&!D1&!D&C&B1&B&A1&!A|!E&!D2&!D1&!D&!C&B1&B&A1&!A|!E&!D2&!D1&!D&!C&B1&!B&A1&!A|!E&!D2&!D1&!D&C&B1&!B&A1&!A|!E&!D2&!D1&!D&C&!B1&!B&A1&!A|!E&!D2&!D1&D&!C&!B1&!B&A1&!A|!E&D2&!D1&D&!C&!B1&!B&A1&!A|!E&D2&D1&D&!C&!B1&!B&A1&!A|!E&!D2&D1&D&!C&!B1&!B&A1&!A|!E&!D2&D1&!D&!C&!B1&!B&A1&!A|!E&D2&D1&!D&!C&!B1&!B&A1&!A|!E&D2&!D1&!D&!C&!B1&!B&A1&!A|!E&!D2&!D1&!D&!C&!B1&!B&A1&!A|!E&!D2&!D1&!D&!C&!B1&!B&A1&A|!E&D2&!D1&!D&!C&!B1&!B&A1&A|!E&D2&D1&!D&!C&!B1&!B&A1&A|!E&!D2&D1&!D&!C&!B1&!B&A1&A|!E&!D2&D1&D&!C&!B1&!B&A1&A|!E&D2&D1&D&!C&!B1&!B&A1&A|!E&D2&!D1&D&!C&!B1&!B&A1&A|!E&!D2&!D1&D&!C&!B1&!B&A1&A|!E&!D2&!D1&!D&C&!B1&!B&A1&A|!E&!D2&!D1&!D&C&B1&!B&A1&A|!E&!D2&!D1&!D&!C&B1&!B&A1&A|!E&!D2&!D1&!D&!C&B1&B&A1&A|!E&!D2&!D1&!D&C&B1&B&A1&A|!E&!D2&!D1&!D&C&!B1&B&A1&A|!E&!D2&!D1&!D&!C&!B1&B&A1&A|!E&!D2&!D1&!D&!C&!B1&B&!A1&A|!E&!D2&!D1&!D&C&!B1&B&!A1&A|!E&!D2&!D1&!D&C&B1&B&!A1&A|!E&!D2&!D1&!D&!C&B1&B&!A1&A|!E&!D2&!D1&!D&!C&B1&!B&!A1&A|!E&!D2&!D1&!D&C&B1&!B&!A1&A|!E&!D2&!D1&!D&C&!B1&!B&!A1&A|!E&!D2&!D1&D&!C&!B1&!B&!A1&A|!E&D2&!D1&D&!C&!B1&!B&!A1&A|!E&D2&D1&D&!C&!B1&!B&!A1&A|!E&!D2&D1&D&!C&!B1&!B&!A1&A|!E&!D2&D1&!D&!C&!B1&!B&!A1&A|!E&D2&D1&!D&!C&!B1&!B&!A1&A|!E&D2&!D1&!D&!C&!B1&!B&!A1&A|!E&!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOOAOI22131.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAI422 -l OOAI422 -i C1 C B1 B A3 A2 A1 A -o Y -f Y=!(C1&C&!B1&B&A3&!A2&!A1&!A|C1&C&B1&B&A3&!A2&!A1&!A|C1&C&B1&!B&A3&!A2&!A1&!A|C1&C&B1&!B&A3&A2&!A1&!A|C1&C&B1&B&A3&A2&!A1&!A|C1&C&!B1&B&A3&A2&!A1&!A|C1&C&!B1&B&!A3&A2&!A1&!A|C1&C&B1&B&!A3&A2&!A1&!A|C1&C&B1&!B&!A3&A2&!A1&!A|C1&C&B1&!B&!A3&A2&A1&!A|C1&C&B1&B&!A3&A2&A1&!A|C1&C&!B1&B&!A3&A2&A1&!A|C1&C&!B1&B&A3&A2&A1&!A|C1&C&B1&B&A3&A2&A1&!A|C1&C&B1&!B&A3&A2&A1&!A|C1&C&B1&!B&A3&!A2&A1&!A|C1&C&B1&B&A3&!A2&A1&!A|C1&C&!B1&B&A3&!A2&A1&!A|C1&C&!B1&B&!A3&!A2&A1&!A|C1&C&B1&B&!A3&!A2&A1&!A|C1&C&B1&!B&!A3&!A2&A1&!A|C1&C&B1&!B&!A3&!A2&A1&A|C1&C&B1&B&!A3&!A2&A1&A|C1&C&!B1&B&!A3&!A2&A1&A|C1&C&!B1&B&A3&!A2&A1&A|C1&C&B1&B&A3&!A2&A1&A|C1&C&B1&!B&A3&!A2&A1&A|C1&C&B1&!B&A3&A2&A1&A|C1&C&B1&B&A3&A2&A1&A|C1&C&!B1&B&A3&A2&A1&A|C1&C&!B1&B&!A3&A2&A1&A|C1&C&B1&B&!A3&A2&A1&A|C1&C&B1&!B&!A3&A2&A1&A|C1&C&B1&!B&!A3&A2&!A1&A|C1&C&B1&B&!A3&A2&!A1&A|C1&C&!B1&B&!A3&A2&!A1&A|C1&C&!B1&B&A3&A2&!A1&A|C1&C&B1&B&A3&A2&!A1&A|C1&C&B1&!B&A3&A2&!A1&A|C1&C&B1&!B&A3&!A2&!A1&A|C1&C&B1&B&A3&!A2&!A1&A|C1&C&!B1&B&A3&!A2&!A1&A|C1&C&!B1&B&!A3&!A2&!A1&A|C1&C&B1&B&!A3&!A2&!A1&A|C1&C&B1&!B&!A3&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAI422.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOAI21211 -l AOOAOAI21211 -i E D C1 C B A1 A -o Y -f Y=!(E&D&!C1&!C&!B&!A1&!A|E&D&C1&!C&!B&!A1&!A|E&D&C1&C&!B&!A1&!A|E&D&!C1&C&!B&!A1&!A|E&!D&!C1&C&B&!A1&!A|E&D&!C1&C&B&!A1&!A|E&D&C1&C&B&!A1&!A|E&!D&C1&C&B&!A1&!A|E&!D&C1&!C&B&!A1&!A|E&D&C1&!C&B&!A1&!A|E&D&!C1&!C&B&!A1&!A|E&D&!C1&!C&B&A1&!A|E&D&C1&!C&B&A1&!A|E&!D&C1&!C&B&A1&!A|E&!D&C1&C&B&A1&!A|E&D&C1&C&B&A1&!A|E&D&!C1&C&B&A1&!A|E&!D&!C1&C&B&A1&!A|E&D&!C1&C&!B&A1&!A|E&D&C1&C&!B&A1&!A|E&D&C1&!C&!B&A1&!A|E&D&!C1&!C&!B&A1&!A|E&D&!C1&!C&!B&A1&A|E&D&C1&!C&!B&A1&A|E&!D&C1&!C&!B&A1&A|E&!D&C1&C&!B&A1&A|E&D&C1&C&!B&A1&A|E&D&!C1&C&!B&A1&A|E&!D&!C1&C&!B&A1&A|E&!D&!C1&C&B&A1&A|E&D&!C1&C&B&A1&A|E&D&C1&C&B&A1&A|E&!D&C1&C&B&A1&A|E&!D&C1&!C&B&A1&A|E&D&C1&!C&B&A1&A|E&D&!C1&!C&B&A1&A|E&D&!C1&!C&B&!A1&A|E&D&C1&!C&B&!A1&A|E&!D&C1&!C&B&!A1&A|E&!D&C1&C&B&!A1&A|E&D&C1&C&B&!A1&A|E&D&!C1&C&B&!A1&A|E&!D&!C1&C&B&!A1&A|E&D&!C1&C&!B&!A1&A|E&D&C1&C&!B&!A1&A|E&D&C1&!C&!B&!A1&A|E&D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOAI21211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAAOI21122 -l AOAAAOI21122 -i E1 E D1 D C B A1 A -o Y -f Y=(!E1&!E&!D1&!D&!C&!B&!A1&!A|E1&!E&!D1&!D&!C&!B&!A1&!A|!E1&E&!D1&!D&!C&!B&!A1&!A|!E1&E&D1&!D&!C&!B&!A1&!A|E1&!E&D1&!D&!C&!B&!A1&!A|!E1&!E&D1&!D&!C&!B&!A1&!A|!E1&E&!D1&D&!C&!B&!A1&!A|E1&!E&!D1&D&!C&!B&!A1&!A|!E1&!E&!D1&D&!C&!B&!A1&!A|!E1&!E&!D1&D&C&!B&!A1&!A|E1&!E&!D1&D&C&!B&!A1&!A|!E1&E&!D1&D&C&!B&!A1&!A|!E1&!E&D1&!D&C&!B&!A1&!A|E1&!E&D1&!D&C&!B&!A1&!A|!E1&E&D1&!D&C&!B&!A1&!A|!E1&E&!D1&!D&C&!B&!A1&!A|E1&!E&!D1&!D&C&!B&!A1&!A|!E1&!E&!D1&!D&C&!B&!A1&!A|!E1&!E&!D1&D&!C&B&!A1&!A|E1&!E&!D1&D&!C&B&!A1&!A|!E1&E&!D1&D&!C&B&!A1&!A|!E1&!E&D1&!D&!C&B&!A1&!A|E1&!E&D1&!D&!C&B&!A1&!A|!E1&E&D1&!D&!C&B&!A1&!A|!E1&E&!D1&!D&!C&B&!A1&!A|E1&!E&!D1&!D&!C&B&!A1&!A|!E1&!E&!D1&!D&!C&B&!A1&!A|!E1&!E&!D1&!D&!C&B&A1&!A|E1&!E&!D1&!D&!C&B&A1&!A|!E1&E&!D1&!D&!C&B&A1&!A|!E1&E&D1&!D&!C&B&A1&!A|E1&!E&D1&!D&!C&B&A1&!A|!E1&!E&D1&!D&!C&B&A1&!A|!E1&E&!D1&D&!C&B&A1&!A|E1&!E&!D1&D&!C&B&A1&!A|!E1&!E&!D1&D&!C&B&A1&!A|!E1&!E&!D1&!D&C&!B&A1&!A|E1&!E&!D1&!D&C&!B&A1&!A|!E1&E&!D1&!D&C&!B&A1&!A|!E1&E&D1&!D&C&!B&A1&!A|E1&!E&D1&!D&C&!B&A1&!A|!E1&!E&D1&!D&C&!B&A1&!A|!E1&E&!D1&D&C&!B&A1&!A|E1&!E&!D1&D&C&!B&A1&!A|!E1&!E&!D1&D&C&!B&A1&!A|!E1&!E&!D1&D&!C&!B&A1&!A|E1&!E&!D1&D&!C&!B&A1&!A|!E1&E&!D1&D&!C&!B&A1&!A|!E1&!E&D1&!D&!C&!B&A1&!A|E1&!E&D1&!D&!C&!B&A1&!A|!E1&E&D1&!D&!C&!B&A1&!A|!E1&E&!D1&!D&!C&!B&A1&!A|E1&!E&!D1&!D&!C&!B&A1&!A|!E1&!E&!D1&!D&!C&!B&A1&!A|!E1&!E&!D1&!D&!C&!B&A1&A|E1&!E&!D1&!D&!C&!B&A1&A|!E1&E&!D1&!D&!C&!B&A1&A|!E1&E&D1&!D&!C&!B&A1&A|E1&!E&D1&!D&!C&!B&A1&A|!E1&!E&D1&!D&!C&!B&A1&A|!E1&E&!D1&D&!C&!B&A1&A|E1&!E&!D1&D&!C&!B&A1&A|!E1&!E&!D1&D&!C&!B&A1&A|!E1&!E&!D1&D&!C&B&A1&A|E1&!E&!D1&D&!C&B&A1&A|!E1&E&!D1&D&!C&B&A1&A|!E1&!E&D1&!D&!C&B&A1&A|E1&!E&D1&!D&!C&B&A1&A|!E1&E&D1&!D&!C&B&A1&A|!E1&E&!D1&!D&!C&B&A1&A|E1&!E&!D1&!D&!C&B&A1&A|!E1&!E&!D1&!D&!C&B&A1&A|!E1&!E&!D1&!D&!C&B&!A1&A|E1&!E&!D1&!D&!C&B&!A1&A|!E1&E&!D1&!D&!C&B&!A1&A|!E1&E&D1&!D&!C&B&!A1&A|E1&!E&D1&!D&!C&B&!A1&A|!E1&!E&D1&!D&!C&B&!A1&A|!E1&E&!D1&D&!C&B&!A1&A|E1&!E&!D1&D&!C&B&!A1&A|!E1&!E&!D1&D&!C&B&!A1&A|!E1&!E&!D1&!D&C&!B&!A1&A|E1&!E&!D1&!D&C&!B&!A1&A|!E1&E&!D1&!D&C&!B&!A1&A|!E1&E&D1&!D&C&!B&!A1&A|E1&!E&D1&!D&C&!B&!A1&A|!E1&!E&D1&!D&C&!B&!A1&A|!E1&E&!D1&D&C&!B&!A1&A|E1&!E&!D1&D&C&!B&!A1&A|!E1&!E&!D1&D&C&!B&!A1&A|!E1&!E&!D1&D&!C&!B&!A1&A|E1&!E&!D1&D&!C&!B&!A1&A|!E1&E&!D1&D&!C&!B&!A1&A|!E1&!E&D1&!D&!C&!B&!A1&A|E1&!E&D1&!D&!C&!B&!A1&A|!E1&E&D1&!D&!C&!B&!A1&A|!E1&E&!D1&!D&!C&!B&!A1&A|E1&!E&!D1&!D&!C&!B&!A1&A|!E1&!E&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAAOI21122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOAI3212 -l OOAOAI3212 -i D1 D C B1 B A2 A1 A -o Y -f Y=!(D1&D&C&!B1&!B&!A2&!A1&!A|D1&D&C&B1&!B&!A2&!A1&!A|D1&D&C&B1&B&!A2&!A1&!A|D1&D&C&!B1&B&!A2&!A1&!A|D1&D&!C&!B1&B&A2&!A1&!A|D1&D&C&!B1&B&A2&!A1&!A|D1&D&C&B1&B&A2&!A1&!A|D1&D&!C&B1&B&A2&!A1&!A|D1&D&!C&B1&!B&A2&!A1&!A|D1&D&C&B1&!B&A2&!A1&!A|D1&D&C&!B1&!B&A2&!A1&!A|D1&D&C&!B1&!B&A2&A1&!A|D1&D&C&B1&!B&A2&A1&!A|D1&D&!C&B1&!B&A2&A1&!A|D1&D&!C&B1&B&A2&A1&!A|D1&D&C&B1&B&A2&A1&!A|D1&D&C&!B1&B&A2&A1&!A|D1&D&!C&!B1&B&A2&A1&!A|D1&D&!C&!B1&B&!A2&A1&!A|D1&D&C&!B1&B&!A2&A1&!A|D1&D&C&B1&B&!A2&A1&!A|D1&D&!C&B1&B&!A2&A1&!A|D1&D&!C&B1&!B&!A2&A1&!A|D1&D&C&B1&!B&!A2&A1&!A|D1&D&C&!B1&!B&!A2&A1&!A|D1&D&C&!B1&!B&!A2&A1&A|D1&D&C&B1&!B&!A2&A1&A|D1&D&!C&B1&!B&!A2&A1&A|D1&D&!C&B1&B&!A2&A1&A|D1&D&C&B1&B&!A2&A1&A|D1&D&C&!B1&B&!A2&A1&A|D1&D&!C&!B1&B&!A2&A1&A|D1&D&!C&!B1&B&A2&A1&A|D1&D&C&!B1&B&A2&A1&A|D1&D&C&B1&B&A2&A1&A|D1&D&!C&B1&B&A2&A1&A|D1&D&!C&B1&!B&A2&A1&A|D1&D&C&B1&!B&A2&A1&A|D1&D&C&!B1&!B&A2&A1&A|D1&D&C&!B1&!B&A2&!A1&A|D1&D&C&B1&!B&A2&!A1&A|D1&D&!C&B1&!B&A2&!A1&A|D1&D&!C&B1&B&A2&!A1&A|D1&D&C&B1&B&A2&!A1&A|D1&D&C&!B1&B&A2&!A1&A|D1&D&!C&!B1&B&A2&!A1&A|D1&D&!C&!B1&B&!A2&!A1&A|D1&D&C&!B1&B&!A2&!A1&A|D1&D&C&B1&B&!A2&!A1&A|D1&D&!C&B1&B&!A2&!A1&A|D1&D&!C&B1&!B&!A2&!A1&A|D1&D&C&B1&!B&!A2&!A1&A|D1&D&C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOAI3212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOAI32211 -l AAAOAI32211 -i E D C1 C B1 B A2 A1 A -o Y -f Y=!(E&D&!C1&!C&!B1&!B&!A2&!A1&!A|E&D&C1&!C&!B1&!B&!A2&!A1&!A|E&!D&C1&C&!B1&!B&!A2&!A1&!A|E&D&C1&C&!B1&!B&!A2&!A1&!A|E&D&!C1&C&!B1&!B&!A2&!A1&!A|E&D&!C1&C&B1&!B&!A2&!A1&!A|E&D&C1&C&B1&!B&!A2&!A1&!A|E&!D&C1&C&B1&!B&!A2&!A1&!A|E&D&C1&!C&B1&!B&!A2&!A1&!A|E&D&!C1&!C&B1&!B&!A2&!A1&!A|E&!D&!C1&!C&B1&B&!A2&!A1&!A|E&D&!C1&!C&B1&B&!A2&!A1&!A|E&D&C1&!C&B1&B&!A2&!A1&!A|E&!D&C1&!C&B1&B&!A2&!A1&!A|E&!D&C1&C&B1&B&!A2&!A1&!A|E&D&C1&C&B1&B&!A2&!A1&!A|E&D&!C1&C&B1&B&!A2&!A1&!A|E&!D&!C1&C&B1&B&!A2&!A1&!A|E&D&!C1&C&!B1&B&!A2&!A1&!A|E&D&C1&C&!B1&B&!A2&!A1&!A|E&!D&C1&C&!B1&B&!A2&!A1&!A|E&D&C1&!C&!B1&B&!A2&!A1&!A|E&D&!C1&!C&!B1&B&!A2&!A1&!A|E&D&!C1&!C&!B1&B&A2&!A1&!A|E&D&C1&!C&!B1&B&A2&!A1&!A|E&!D&C1&C&!B1&B&A2&!A1&!A|E&D&C1&C&!B1&B&A2&!A1&!A|E&D&!C1&C&!B1&B&A2&!A1&!A|E&!D&!C1&C&B1&B&A2&!A1&!A|E&D&!C1&C&B1&B&A2&!A1&!A|E&D&C1&C&B1&B&A2&!A1&!A|E&!D&C1&C&B1&B&A2&!A1&!A|E&!D&C1&!C&B1&B&A2&!A1&!A|E&D&C1&!C&B1&B&A2&!A1&!A|E&D&!C1&!C&B1&B&A2&!A1&!A|E&!D&!C1&!C&B1&B&A2&!A1&!A|E&D&!C1&!C&B1&!B&A2&!A1&!A|E&D&C1&!C&B1&!B&A2&!A1&!A|E&!D&C1&C&B1&!B&A2&!A1&!A|E&D&C1&C&B1&!B&A2&!A1&!A|E&D&!C1&C&B1&!B&A2&!A1&!A|E&D&!C1&C&!B1&!B&A2&!A1&!A|E&D&C1&C&!B1&!B&A2&!A1&!A|E&!D&C1&C&!B1&!B&A2&!A1&!A|E&D&C1&!C&!B1&!B&A2&!A1&!A|E&D&!C1&!C&!B1&!B&A2&!A1&!A|E&D&!C1&!C&!B1&!B&A2&A1&!A|E&D&C1&!C&!B1&!B&A2&A1&!A|E&!D&C1&C&!B1&!B&A2&A1&!A|E&D&C1&C&!B1&!B&A2&A1&!A|E&D&!C1&C&!B1&!B&A2&A1&!A|E&D&!C1&C&B1&!B&A2&A1&!A|E&D&C1&C&B1&!B&A2&A1&!A|E&!D&C1&C&B1&!B&A2&A1&!A|E&D&C1&!C&B1&!B&A2&A1&!A|E&D&!C1&!C&B1&!B&A2&A1&!A|E&!D&!C1&!C&B1&B&A2&A1&!A|E&D&!C1&!C&B1&B&A2&A1&!A|E&D&C1&!C&B1&B&A2&A1&!A|E&!D&C1&!C&B1&B&A2&A1&!A|E&!D&C1&C&B1&B&A2&A1&!A|E&D&C1&C&B1&B&A2&A1&!A|E&D&!C1&C&B1&B&A2&A1&!A|E&!D&!C1&C&B1&B&A2&A1&!A|E&D&!C1&C&!B1&B&A2&A1&!A|E&D&C1&C&!B1&B&A2&A1&!A|E&!D&C1&C&!B1&B&A2&A1&!A|E&D&C1&!C&!B1&B&A2&A1&!A|E&D&!C1&!C&!B1&B&A2&A1&!A|E&D&!C1&!C&!B1&B&!A2&A1&!A|E&D&C1&!C&!B1&B&!A2&A1&!A|E&!D&C1&C&!B1&B&!A2&A1&!A|E&D&C1&C&!B1&B&!A2&A1&!A|E&D&!C1&C&!B1&B&!A2&A1&!A|E&!D&!C1&C&B1&B&!A2&A1&!A|E&D&!C1&C&B1&B&!A2&A1&!A|E&D&C1&C&B1&B&!A2&A1&!A|E&!D&C1&C&B1&B&!A2&A1&!A|E&!D&C1&!C&B1&B&!A2&A1&!A|E&D&C1&!C&B1&B&!A2&A1&!A|E&D&!C1&!C&B1&B&!A2&A1&!A|E&!D&!C1&!C&B1&B&!A2&A1&!A|E&D&!C1&!C&B1&!B&!A2&A1&!A|E&D&C1&!C&B1&!B&!A2&A1&!A|E&!D&C1&C&B1&!B&!A2&A1&!A|E&D&C1&C&B1&!B&!A2&A1&!A|E&D&!C1&C&B1&!B&!A2&A1&!A|E&D&!C1&C&!B1&!B&!A2&A1&!A|E&D&C1&C&!B1&!B&!A2&A1&!A|E&!D&C1&C&!B1&!B&!A2&A1&!A|E&D&C1&!C&!B1&!B&!A2&A1&!A|E&D&!C1&!C&!B1&!B&!A2&A1&!A|E&D&!C1&!C&!B1&!B&!A2&A1&A|E&D&C1&!C&!B1&!B&!A2&A1&A|E&!D&C1&C&!B1&!B&!A2&A1&A|E&D&C1&C&!B1&!B&!A2&A1&A|E&D&!C1&C&!B1&!B&!A2&A1&A|E&D&!C1&C&B1&!B&!A2&A1&A|E&D&C1&C&B1&!B&!A2&A1&A|E&!D&C1&C&B1&!B&!A2&A1&A|E&D&C1&!C&B1&!B&!A2&A1&A|E&D&!C1&!C&B1&!B&!A2&A1&A|E&!D&!C1&!C&B1&B&!A2&A1&A|E&D&!C1&!C&B1&B&!A2&A1&A|E&D&C1&!C&B1&B&!A2&A1&A|E&!D&C1&!C&B1&B&!A2&A1&A|E&!D&C1&C&B1&B&!A2&A1&A|E&D&C1&C&B1&B&!A2&A1&A|E&D&!C1&C&B1&B&!A2&A1&A|E&!D&!C1&C&B1&B&!A2&A1&A|E&D&!C1&C&!B1&B&!A2&A1&A|E&D&C1&C&!B1&B&!A2&A1&A|E&!D&C1&C&!B1&B&!A2&A1&A|E&D&C1&!C&!B1&B&!A2&A1&A|E&D&!C1&!C&!B1&B&!A2&A1&A|E&!D&!C1&!C&!B1&B&A2&A1&A|E&D&!C1&!C&!B1&B&A2&A1&A|E&D&C1&!C&!B1&B&A2&A1&A|E&!D&C1&!C&!B1&B&A2&A1&A|E&!D&C1&C&!B1&B&A2&A1&A|E&D&C1&C&!B1&B&A2&A1&A|E&D&!C1&C&!B1&B&A2&A1&A|E&!D&!C1&C&!B1&B&A2&A1&A|E&!D&!C1&C&B1&B&A2&A1&A|E&D&!C1&C&B1&B&A2&A1&A|E&D&C1&C&B1&B&A2&A1&A|E&!D&C1&C&B1&B&A2&A1&A|E&!D&C1&!C&B1&B&A2&A1&A|E&D&C1&!C&B1&B&A2&A1&A|E&D&!C1&!C&B1&B&A2&A1&A|E&!D&!C1&!C&B1&B&A2&A1&A|E&!D&!C1&!C&B1&!B&A2&A1&A|E&D&!C1&!C&B1&!B&A2&A1&A|E&D&C1&!C&B1&!B&A2&A1&A|E&!D&C1&!C&B1&!B&A2&A1&A|E&!D&C1&C&B1&!B&A2&A1&A|E&D&C1&C&B1&!B&A2&A1&A|E&D&!C1&C&B1&!B&A2&A1&A|E&!D&!C1&C&B1&!B&A2&A1&A|E&!D&!C1&C&!B1&!B&A2&A1&A|E&D&!C1&C&!B1&!B&A2&A1&A|E&D&C1&C&!B1&!B&A2&A1&A|E&!D&C1&C&!B1&!B&A2&A1&A|E&!D&C1&!C&!B1&!B&A2&A1&A|E&D&C1&!C&!B1&!B&A2&A1&A|E&D&!C1&!C&!B1&!B&A2&A1&A|E&!D&!C1&!C&!B1&!B&A2&A1&A|E&D&!C1&!C&!B1&!B&A2&!A1&A|E&D&C1&!C&!B1&!B&A2&!A1&A|E&!D&C1&C&!B1&!B&A2&!A1&A|E&D&C1&C&!B1&!B&A2&!A1&A|E&D&!C1&C&!B1&!B&A2&!A1&A|E&D&!C1&C&B1&!B&A2&!A1&A|E&D&C1&C&B1&!B&A2&!A1&A|E&!D&C1&C&B1&!B&A2&!A1&A|E&D&C1&!C&B1&!B&A2&!A1&A|E&D&!C1&!C&B1&!B&A2&!A1&A|E&!D&!C1&!C&B1&B&A2&!A1&A|E&D&!C1&!C&B1&B&A2&!A1&A|E&D&C1&!C&B1&B&A2&!A1&A|E&!D&C1&!C&B1&B&A2&!A1&A|E&!D&C1&C&B1&B&A2&!A1&A|E&D&C1&C&B1&B&A2&!A1&A|E&D&!C1&C&B1&B&A2&!A1&A|E&!D&!C1&C&B1&B&A2&!A1&A|E&D&!C1&C&!B1&B&A2&!A1&A|E&D&C1&C&!B1&B&A2&!A1&A|E&!D&C1&C&!B1&B&A2&!A1&A|E&D&C1&!C&!B1&B&A2&!A1&A|E&D&!C1&!C&!B1&B&A2&!A1&A|E&D&!C1&!C&!B1&B&!A2&!A1&A|E&D&C1&!C&!B1&B&!A2&!A1&A|E&!D&C1&C&!B1&B&!A2&!A1&A|E&D&C1&C&!B1&B&!A2&!A1&A|E&D&!C1&C&!B1&B&!A2&!A1&A|E&!D&!C1&C&B1&B&!A2&!A1&A|E&D&!C1&C&B1&B&!A2&!A1&A|E&D&C1&C&B1&B&!A2&!A1&A|E&!D&C1&C&B1&B&!A2&!A1&A|E&!D&C1&!C&B1&B&!A2&!A1&A|E&D&C1&!C&B1&B&!A2&!A1&A|E&D&!C1&!C&B1&B&!A2&!A1&A|E&!D&!C1&!C&B1&B&!A2&!A1&A|E&D&!C1&!C&B1&!B&!A2&!A1&A|E&D&C1&!C&B1&!B&!A2&!A1&A|E&!D&C1&C&B1&!B&!A2&!A1&A|E&D&C1&C&B1&!B&!A2&!A1&A|E&D&!C1&C&B1&!B&!A2&!A1&A|E&D&!C1&C&!B1&!B&!A2&!A1&A|E&D&C1&C&!B1&!B&!A2&!A1&A|E&!D&C1&C&!B1&!B&!A2&!A1&A|E&D&C1&!C&!B1&!B&!A2&!A1&A|E&D&!C1&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOAI32211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOI21211 -l AOOAOI21211 -i E D C1 C B A1 A -o Y -f Y=(!E&!D&!C1&!C&!B&!A1&!A|!E&D&!C1&!C&!B&!A1&!A|!E&D&C1&!C&!B&!A1&!A|!E&!D&C1&!C&!B&!A1&!A|!E&!D&C1&C&!B&!A1&!A|!E&D&C1&C&!B&!A1&!A|!E&D&!C1&C&!B&!A1&!A|!E&!D&!C1&C&!B&!A1&!A|!E&!D&!C1&C&B&!A1&!A|!E&!D&C1&C&B&!A1&!A|!E&!D&C1&!C&B&!A1&!A|!E&D&!C1&!C&B&!A1&!A|!E&!D&!C1&!C&B&!A1&!A|!E&!D&!C1&!C&B&A1&!A|!E&D&!C1&!C&B&A1&!A|!E&!D&C1&!C&B&A1&!A|!E&!D&C1&C&B&A1&!A|!E&!D&!C1&C&B&A1&!A|!E&!D&!C1&C&!B&A1&!A|!E&D&!C1&C&!B&A1&!A|!E&D&C1&C&!B&A1&!A|!E&!D&C1&C&!B&A1&!A|!E&!D&C1&!C&!B&A1&!A|!E&D&C1&!C&!B&A1&!A|!E&D&!C1&!C&!B&A1&!A|!E&!D&!C1&!C&!B&A1&!A|!E&!D&!C1&!C&!B&A1&A|!E&D&!C1&!C&!B&A1&A|!E&!D&C1&!C&!B&A1&A|!E&!D&C1&C&!B&A1&A|!E&!D&!C1&C&!B&A1&A|!E&!D&!C1&C&B&A1&A|!E&!D&C1&C&B&A1&A|!E&!D&C1&!C&B&A1&A|!E&D&!C1&!C&B&A1&A|!E&!D&!C1&!C&B&A1&A|!E&!D&!C1&!C&B&!A1&A|!E&D&!C1&!C&B&!A1&A|!E&!D&C1&!C&B&!A1&A|!E&!D&C1&C&B&!A1&A|!E&!D&!C1&C&B&!A1&A|!E&!D&!C1&C&!B&!A1&A|!E&D&!C1&C&!B&!A1&A|!E&D&C1&C&!B&!A1&A|!E&!D&C1&C&!B&!A1&A|!E&!D&C1&!C&!B&!A1&A|!E&D&C1&!C&!B&!A1&A|!E&D&!C1&!C&!B&!A1&A|!E&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOI21211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOAI221311 -l AAOAAOAI221311 -i F E D2 D1 D C B1 B A1 A -o Y -f Y=!(F&E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|F&E&D2&!D1&!D&!C&!B1&!B&!A1&!A|F&E&D2&D1&!D&!C&!B1&!B&!A1&!A|F&E&!D2&D1&!D&!C&!B1&!B&!A1&!A|F&E&!D2&D1&D&!C&!B1&!B&!A1&!A|F&E&D2&D1&D&!C&!B1&!B&!A1&!A|F&!E&D2&D1&D&!C&!B1&!B&!A1&!A|F&E&D2&!D1&D&!C&!B1&!B&!A1&!A|F&E&!D2&!D1&D&!C&!B1&!B&!A1&!A|F&E&!D2&!D1&D&C&!B1&!B&!A1&!A|F&E&D2&!D1&D&C&!B1&!B&!A1&!A|F&!E&D2&D1&D&C&!B1&!B&!A1&!A|F&E&D2&D1&D&C&!B1&!B&!A1&!A|F&E&!D2&D1&D&C&!B1&!B&!A1&!A|F&E&!D2&D1&!D&C&!B1&!B&!A1&!A|F&E&D2&D1&!D&C&!B1&!B&!A1&!A|F&E&D2&!D1&!D&C&!B1&!B&!A1&!A|F&E&!D2&!D1&!D&C&!B1&!B&!A1&!A|F&E&!D2&!D1&!D&C&B1&!B&!A1&!A|F&E&D2&!D1&!D&C&B1&!B&!A1&!A|F&E&D2&D1&!D&C&B1&!B&!A1&!A|F&E&!D2&D1&!D&C&B1&!B&!A1&!A|F&E&!D2&D1&D&C&B1&!B&!A1&!A|F&E&D2&D1&D&C&B1&!B&!A1&!A|F&!E&D2&D1&D&C&B1&!B&!A1&!A|F&E&D2&!D1&D&C&B1&!B&!A1&!A|F&E&!D2&!D1&D&C&B1&!B&!A1&!A|F&E&!D2&!D1&D&!C&B1&!B&!A1&!A|F&E&D2&!D1&D&!C&B1&!B&!A1&!A|F&!E&D2&D1&D&!C&B1&!B&!A1&!A|F&E&D2&D1&D&!C&B1&!B&!A1&!A|F&E&!D2&D1&D&!C&B1&!B&!A1&!A|F&E&!D2&D1&!D&!C&B1&!B&!A1&!A|F&E&D2&D1&!D&!C&B1&!B&!A1&!A|F&E&D2&!D1&!D&!C&B1&!B&!A1&!A|F&E&!D2&!D1&!D&!C&B1&!B&!A1&!A|F&E&!D2&!D1&!D&!C&B1&B&!A1&!A|F&E&D2&!D1&!D&!C&B1&B&!A1&!A|F&E&D2&D1&!D&!C&B1&B&!A1&!A|F&E&!D2&D1&!D&!C&B1&B&!A1&!A|F&E&!D2&D1&D&!C&B1&B&!A1&!A|F&E&D2&D1&D&!C&B1&B&!A1&!A|F&!E&D2&D1&D&!C&B1&B&!A1&!A|F&E&D2&!D1&D&!C&B1&B&!A1&!A|F&E&!D2&!D1&D&!C&B1&B&!A1&!A|F&!E&!D2&!D1&D&C&B1&B&!A1&!A|F&E&!D2&!D1&D&C&B1&B&!A1&!A|F&E&D2&!D1&D&C&B1&B&!A1&!A|F&!E&D2&!D1&D&C&B1&B&!A1&!A|F&!E&D2&D1&D&C&B1&B&!A1&!A|F&E&D2&D1&D&C&B1&B&!A1&!A|F&E&!D2&D1&D&C&B1&B&!A1&!A|F&!E&!D2&D1&D&C&B1&B&!A1&!A|F&!E&!D2&D1&!D&C&B1&B&!A1&!A|F&E&!D2&D1&!D&C&B1&B&!A1&!A|F&E&D2&D1&!D&C&B1&B&!A1&!A|F&!E&D2&D1&!D&C&B1&B&!A1&!A|F&!E&D2&!D1&!D&C&B1&B&!A1&!A|F&E&D2&!D1&!D&C&B1&B&!A1&!A|F&E&!D2&!D1&!D&C&B1&B&!A1&!A|F&!E&!D2&!D1&!D&C&B1&B&!A1&!A|F&E&!D2&!D1&!D&C&!B1&B&!A1&!A|F&E&D2&!D1&!D&C&!B1&B&!A1&!A|F&E&D2&D1&!D&C&!B1&B&!A1&!A|F&E&!D2&D1&!D&C&!B1&B&!A1&!A|F&E&!D2&D1&D&C&!B1&B&!A1&!A|F&E&D2&D1&D&C&!B1&B&!A1&!A|F&!E&D2&D1&D&C&!B1&B&!A1&!A|F&E&D2&!D1&D&C&!B1&B&!A1&!A|F&E&!D2&!D1&D&C&!B1&B&!A1&!A|F&E&!D2&!D1&D&!C&!B1&B&!A1&!A|F&E&D2&!D1&D&!C&!B1&B&!A1&!A|F&!E&D2&D1&D&!C&!B1&B&!A1&!A|F&E&D2&D1&D&!C&!B1&B&!A1&!A|F&E&!D2&D1&D&!C&!B1&B&!A1&!A|F&E&!D2&D1&!D&!C&!B1&B&!A1&!A|F&E&D2&D1&!D&!C&!B1&B&!A1&!A|F&E&D2&!D1&!D&!C&!B1&B&!A1&!A|F&E&!D2&!D1&!D&!C&!B1&B&!A1&!A|F&E&!D2&!D1&!D&!C&!B1&B&A1&!A|F&E&D2&!D1&!D&!C&!B1&B&A1&!A|F&E&D2&D1&!D&!C&!B1&B&A1&!A|F&E&!D2&D1&!D&!C&!B1&B&A1&!A|F&E&!D2&D1&D&!C&!B1&B&A1&!A|F&E&D2&D1&D&!C&!B1&B&A1&!A|F&!E&D2&D1&D&!C&!B1&B&A1&!A|F&E&D2&!D1&D&!C&!B1&B&A1&!A|F&E&!D2&!D1&D&!C&!B1&B&A1&!A|F&E&!D2&!D1&D&C&!B1&B&A1&!A|F&E&D2&!D1&D&C&!B1&B&A1&!A|F&!E&D2&D1&D&C&!B1&B&A1&!A|F&E&D2&D1&D&C&!B1&B&A1&!A|F&E&!D2&D1&D&C&!B1&B&A1&!A|F&E&!D2&D1&!D&C&!B1&B&A1&!A|F&E&D2&D1&!D&C&!B1&B&A1&!A|F&E&D2&!D1&!D&C&!B1&B&A1&!A|F&E&!D2&!D1&!D&C&!B1&B&A1&!A|F&!E&!D2&!D1&!D&C&B1&B&A1&!A|F&E&!D2&!D1&!D&C&B1&B&A1&!A|F&E&D2&!D1&!D&C&B1&B&A1&!A|F&!E&D2&!D1&!D&C&B1&B&A1&!A|F&!E&D2&D1&!D&C&B1&B&A1&!A|F&E&D2&D1&!D&C&B1&B&A1&!A|F&E&!D2&D1&!D&C&B1&B&A1&!A|F&!E&!D2&D1&!D&C&B1&B&A1&!A|F&!E&!D2&D1&D&C&B1&B&A1&!A|F&E&!D2&D1&D&C&B1&B&A1&!A|F&E&D2&D1&D&C&B1&B&A1&!A|F&!E&D2&D1&D&C&B1&B&A1&!A|F&!E&D2&!D1&D&C&B1&B&A1&!A|F&E&D2&!D1&D&C&B1&B&A1&!A|F&E&!D2&!D1&D&C&B1&B&A1&!A|F&!E&!D2&!D1&D&C&B1&B&A1&!A|F&E&!D2&!D1&D&!C&B1&B&A1&!A|F&E&D2&!D1&D&!C&B1&B&A1&!A|F&!E&D2&D1&D&!C&B1&B&A1&!A|F&E&D2&D1&D&!C&B1&B&A1&!A|F&E&!D2&D1&D&!C&B1&B&A1&!A|F&E&!D2&D1&!D&!C&B1&B&A1&!A|F&E&D2&D1&!D&!C&B1&B&A1&!A|F&E&D2&!D1&!D&!C&B1&B&A1&!A|F&E&!D2&!D1&!D&!C&B1&B&A1&!A|F&E&!D2&!D1&!D&!C&B1&!B&A1&!A|F&E&D2&!D1&!D&!C&B1&!B&A1&!A|F&E&D2&D1&!D&!C&B1&!B&A1&!A|F&E&!D2&D1&!D&!C&B1&!B&A1&!A|F&E&!D2&D1&D&!C&B1&!B&A1&!A|F&E&D2&D1&D&!C&B1&!B&A1&!A|F&!E&D2&D1&D&!C&B1&!B&A1&!A|F&E&D2&!D1&D&!C&B1&!B&A1&!A|F&E&!D2&!D1&D&!C&B1&!B&A1&!A|F&E&!D2&!D1&D&C&B1&!B&A1&!A|F&E&D2&!D1&D&C&B1&!B&A1&!A|F&!E&D2&D1&D&C&B1&!B&A1&!A|F&E&D2&D1&D&C&B1&!B&A1&!A|F&E&!D2&D1&D&C&B1&!B&A1&!A|F&E&!D2&D1&!D&C&B1&!B&A1&!A|F&E&D2&D1&!D&C&B1&!B&A1&!A|F&E&D2&!D1&!D&C&B1&!B&A1&!A|F&E&!D2&!D1&!D&C&B1&!B&A1&!A|F&E&!D2&!D1&!D&C&!B1&!B&A1&!A|F&E&D2&!D1&!D&C&!B1&!B&A1&!A|F&E&D2&D1&!D&C&!B1&!B&A1&!A|F&E&!D2&D1&!D&C&!B1&!B&A1&!A|F&E&!D2&D1&D&C&!B1&!B&A1&!A|F&E&D2&D1&D&C&!B1&!B&A1&!A|F&!E&D2&D1&D&C&!B1&!B&A1&!A|F&E&D2&!D1&D&C&!B1&!B&A1&!A|F&E&!D2&!D1&D&C&!B1&!B&A1&!A|F&E&!D2&!D1&D&!C&!B1&!B&A1&!A|F&E&D2&!D1&D&!C&!B1&!B&A1&!A|F&!E&D2&D1&D&!C&!B1&!B&A1&!A|F&E&D2&D1&D&!C&!B1&!B&A1&!A|F&E&!D2&D1&D&!C&!B1&!B&A1&!A|F&E&!D2&D1&!D&!C&!B1&!B&A1&!A|F&E&D2&D1&!D&!C&!B1&!B&A1&!A|F&E&D2&!D1&!D&!C&!B1&!B&A1&!A|F&E&!D2&!D1&!D&!C&!B1&!B&A1&!A|F&E&!D2&!D1&!D&!C&!B1&!B&A1&A|F&E&D2&!D1&!D&!C&!B1&!B&A1&A|F&E&D2&D1&!D&!C&!B1&!B&A1&A|F&E&!D2&D1&!D&!C&!B1&!B&A1&A|F&E&!D2&D1&D&!C&!B1&!B&A1&A|F&E&D2&D1&D&!C&!B1&!B&A1&A|F&!E&D2&D1&D&!C&!B1&!B&A1&A|F&E&D2&!D1&D&!C&!B1&!B&A1&A|F&E&!D2&!D1&D&!C&!B1&!B&A1&A|F&!E&!D2&!D1&D&C&!B1&!B&A1&A|F&E&!D2&!D1&D&C&!B1&!B&A1&A|F&E&D2&!D1&D&C&!B1&!B&A1&A|F&!E&D2&!D1&D&C&!B1&!B&A1&A|F&!E&D2&D1&D&C&!B1&!B&A1&A|F&E&D2&D1&D&C&!B1&!B&A1&A|F&E&!D2&D1&D&C&!B1&!B&A1&A|F&!E&!D2&D1&D&C&!B1&!B&A1&A|F&!E&!D2&D1&!D&C&!B1&!B&A1&A|F&E&!D2&D1&!D&C&!B1&!B&A1&A|F&E&D2&D1&!D&C&!B1&!B&A1&A|F&!E&D2&D1&!D&C&!B1&!B&A1&A|F&!E&D2&!D1&!D&C&!B1&!B&A1&A|F&E&D2&!D1&!D&C&!B1&!B&A1&A|F&E&!D2&!D1&!D&C&!B1&!B&A1&A|F&!E&!D2&!D1&!D&C&!B1&!B&A1&A|F&!E&!D2&!D1&!D&C&B1&!B&A1&A|F&E&!D2&!D1&!D&C&B1&!B&A1&A|F&E&D2&!D1&!D&C&B1&!B&A1&A|F&!E&D2&!D1&!D&C&B1&!B&A1&A|F&!E&D2&D1&!D&C&B1&!B&A1&A|F&E&D2&D1&!D&C&B1&!B&A1&A|F&E&!D2&D1&!D&C&B1&!B&A1&A|F&!E&!D2&D1&!D&C&B1&!B&A1&A|F&!E&!D2&D1&D&C&B1&!B&A1&A|F&E&!D2&D1&D&C&B1&!B&A1&A|F&E&D2&D1&D&C&B1&!B&A1&A|F&!E&D2&D1&D&C&B1&!B&A1&A|F&!E&D2&!D1&D&C&B1&!B&A1&A|F&E&D2&!D1&D&C&B1&!B&A1&A|F&E&!D2&!D1&D&C&B1&!B&A1&A|F&!E&!D2&!D1&D&C&B1&!B&A1&A|F&E&!D2&!D1&D&!C&B1&!B&A1&A|F&E&D2&!D1&D&!C&B1&!B&A1&A|F&!E&D2&D1&D&!C&B1&!B&A1&A|F&E&D2&D1&D&!C&B1&!B&A1&A|F&E&!D2&D1&D&!C&B1&!B&A1&A|F&E&!D2&D1&!D&!C&B1&!B&A1&A|F&E&D2&D1&!D&!C&B1&!B&A1&A|F&E&D2&!D1&!D&!C&B1&!B&A1&A|F&E&!D2&!D1&!D&!C&B1&!B&A1&A|F&E&!D2&!D1&!D&!C&B1&B&A1&A|F&E&D2&!D1&!D&!C&B1&B&A1&A|F&E&D2&D1&!D&!C&B1&B&A1&A|F&E&!D2&D1&!D&!C&B1&B&A1&A|F&E&!D2&D1&D&!C&B1&B&A1&A|F&E&D2&D1&D&!C&B1&B&A1&A|F&!E&D2&D1&D&!C&B1&B&A1&A|F&E&D2&!D1&D&!C&B1&B&A1&A|F&E&!D2&!D1&D&!C&B1&B&A1&A|F&!E&!D2&!D1&D&C&B1&B&A1&A|F&E&!D2&!D1&D&C&B1&B&A1&A|F&E&D2&!D1&D&C&B1&B&A1&A|F&!E&D2&!D1&D&C&B1&B&A1&A|F&!E&D2&D1&D&C&B1&B&A1&A|F&E&D2&D1&D&C&B1&B&A1&A|F&E&!D2&D1&D&C&B1&B&A1&A|F&!E&!D2&D1&D&C&B1&B&A1&A|F&!E&!D2&D1&!D&C&B1&B&A1&A|F&E&!D2&D1&!D&C&B1&B&A1&A|F&E&D2&D1&!D&C&B1&B&A1&A|F&!E&D2&D1&!D&C&B1&B&A1&A|F&!E&D2&!D1&!D&C&B1&B&A1&A|F&E&D2&!D1&!D&C&B1&B&A1&A|F&E&!D2&!D1&!D&C&B1&B&A1&A|F&!E&!D2&!D1&!D&C&B1&B&A1&A|F&!E&!D2&!D1&!D&C&!B1&B&A1&A|F&E&!D2&!D1&!D&C&!B1&B&A1&A|F&E&D2&!D1&!D&C&!B1&B&A1&A|F&!E&D2&!D1&!D&C&!B1&B&A1&A|F&!E&D2&D1&!D&C&!B1&B&A1&A|F&E&D2&D1&!D&C&!B1&B&A1&A|F&E&!D2&D1&!D&C&!B1&B&A1&A|F&!E&!D2&D1&!D&C&!B1&B&A1&A|F&!E&!D2&D1&D&C&!B1&B&A1&A|F&E&!D2&D1&D&C&!B1&B&A1&A|F&E&D2&D1&D&C&!B1&B&A1&A|F&!E&D2&D1&D&C&!B1&B&A1&A|F&!E&D2&!D1&D&C&!B1&B&A1&A|F&E&D2&!D1&D&C&!B1&B&A1&A|F&E&!D2&!D1&D&C&!B1&B&A1&A|F&!E&!D2&!D1&D&C&!B1&B&A1&A|F&E&!D2&!D1&D&!C&!B1&B&A1&A|F&E&D2&!D1&D&!C&!B1&B&A1&A|F&!E&D2&D1&D&!C&!B1&B&A1&A|F&E&D2&D1&D&!C&!B1&B&A1&A|F&E&!D2&D1&D&!C&!B1&B&A1&A|F&E&!D2&D1&!D&!C&!B1&B&A1&A|F&E&D2&D1&!D&!C&!B1&B&A1&A|F&E&D2&!D1&!D&!C&!B1&B&A1&A|F&E&!D2&!D1&!D&!C&!B1&B&A1&A|F&E&!D2&!D1&!D&!C&!B1&B&!A1&A|F&E&D2&!D1&!D&!C&!B1&B&!A1&A|F&E&D2&D1&!D&!C&!B1&B&!A1&A|F&E&!D2&D1&!D&!C&!B1&B&!A1&A|F&E&!D2&D1&D&!C&!B1&B&!A1&A|F&E&D2&D1&D&!C&!B1&B&!A1&A|F&!E&D2&D1&D&!C&!B1&B&!A1&A|F&E&D2&!D1&D&!C&!B1&B&!A1&A|F&E&!D2&!D1&D&!C&!B1&B&!A1&A|F&E&!D2&!D1&D&C&!B1&B&!A1&A|F&E&D2&!D1&D&C&!B1&B&!A1&A|F&!E&D2&D1&D&C&!B1&B&!A1&A|F&E&D2&D1&D&C&!B1&B&!A1&A|F&E&!D2&D1&D&C&!B1&B&!A1&A|F&E&!D2&D1&!D&C&!B1&B&!A1&A|F&E&D2&D1&!D&C&!B1&B&!A1&A|F&E&D2&!D1&!D&C&!B1&B&!A1&A|F&E&!D2&!D1&!D&C&!B1&B&!A1&A|F&!E&!D2&!D1&!D&C&B1&B&!A1&A|F&E&!D2&!D1&!D&C&B1&B&!A1&A|F&E&D2&!D1&!D&C&B1&B&!A1&A|F&!E&D2&!D1&!D&C&B1&B&!A1&A|F&!E&D2&D1&!D&C&B1&B&!A1&A|F&E&D2&D1&!D&C&B1&B&!A1&A|F&E&!D2&D1&!D&C&B1&B&!A1&A|F&!E&!D2&D1&!D&C&B1&B&!A1&A|F&!E&!D2&D1&D&C&B1&B&!A1&A|F&E&!D2&D1&D&C&B1&B&!A1&A|F&E&D2&D1&D&C&B1&B&!A1&A|F&!E&D2&D1&D&C&B1&B&!A1&A|F&!E&D2&!D1&D&C&B1&B&!A1&A|F&E&D2&!D1&D&C&B1&B&!A1&A|F&E&!D2&!D1&D&C&B1&B&!A1&A|F&!E&!D2&!D1&D&C&B1&B&!A1&A|F&E&!D2&!D1&D&!C&B1&B&!A1&A|F&E&D2&!D1&D&!C&B1&B&!A1&A|F&!E&D2&D1&D&!C&B1&B&!A1&A|F&E&D2&D1&D&!C&B1&B&!A1&A|F&E&!D2&D1&D&!C&B1&B&!A1&A|F&E&!D2&D1&!D&!C&B1&B&!A1&A|F&E&D2&D1&!D&!C&B1&B&!A1&A|F&E&D2&!D1&!D&!C&B1&B&!A1&A|F&E&!D2&!D1&!D&!C&B1&B&!A1&A|F&E&!D2&!D1&!D&!C&B1&!B&!A1&A|F&E&D2&!D1&!D&!C&B1&!B&!A1&A|F&E&D2&D1&!D&!C&B1&!B&!A1&A|F&E&!D2&D1&!D&!C&B1&!B&!A1&A|F&E&!D2&D1&D&!C&B1&!B&!A1&A|F&E&D2&D1&D&!C&B1&!B&!A1&A|F&!E&D2&D1&D&!C&B1&!B&!A1&A|F&E&D2&!D1&D&!C&B1&!B&!A1&A|F&E&!D2&!D1&D&!C&B1&!B&!A1&A|F&E&!D2&!D1&D&C&B1&!B&!A1&A|F&E&D2&!D1&D&C&B1&!B&!A1&A|F&!E&D2&D1&D&C&B1&!B&!A1&A|F&E&D2&D1&D&C&B1&!B&!A1&A|F&E&!D2&D1&D&C&B1&!B&!A1&A|F&E&!D2&D1&!D&C&B1&!B&!A1&A|F&E&D2&D1&!D&C&B1&!B&!A1&A|F&E&D2&!D1&!D&C&B1&!B&!A1&A|F&E&!D2&!D1&!D&C&B1&!B&!A1&A|F&E&!D2&!D1&!D&C&!B1&!B&!A1&A|F&E&D2&!D1&!D&C&!B1&!B&!A1&A|F&E&D2&D1&!D&C&!B1&!B&!A1&A|F&E&!D2&D1&!D&C&!B1&!B&!A1&A|F&E&!D2&D1&D&C&!B1&!B&!A1&A|F&E&D2&D1&D&C&!B1&!B&!A1&A|F&!E&D2&D1&D&C&!B1&!B&!A1&A|F&E&D2&!D1&D&C&!B1&!B&!A1&A|F&E&!D2&!D1&D&C&!B1&!B&!A1&A|F&E&!D2&!D1&D&!C&!B1&!B&!A1&A|F&E&D2&!D1&D&!C&!B1&!B&!A1&A|F&!E&D2&D1&D&!C&!B1&!B&!A1&A|F&E&D2&D1&D&!C&!B1&!B&!A1&A|F&E&!D2&D1&D&!C&!B1&!B&!A1&A|F&E&!D2&D1&!D&!C&!B1&!B&!A1&A|F&E&D2&D1&!D&!C&!B1&!B&!A1&A|F&E&D2&!D1&!D&!C&!B1&!B&!A1&A|F&E&!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOAI221311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAAAOI22222 -l OOOAAAOI22222 -i E1 E D1 D C1 C B1 B A1 A -o Y -f Y=(!E1&!E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&D1&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D1&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&!D1&D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D1&D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D1&D&C1&!C&!B1&!B&!A1&!A|!E1&!E&D1&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&E&D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D1&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&!D1&!D&C1&C&!B1&!B&!A1&!A|!E1&E&!D1&!D&C1&C&!B1&!B&!A1&!A|!E1&E&D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&D1&!D&C1&C&!B1&!B&!A1&!A|!E1&!E&D1&!D&C1&C&!B1&!B&!A1&!A|!E1&E&!D1&D&C1&C&!B1&!B&!A1&!A|E1&!E&!D1&D&C1&C&!B1&!B&!A1&!A|!E1&!E&!D1&D&C1&C&!B1&!B&!A1&!A|!E1&!E&!D1&D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D1&D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D1&D&!C1&C&!B1&!B&!A1&!A|!E1&!E&D1&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&E&D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D1&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&!C1&C&B1&!B&!A1&!A|E1&!E&!D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&!D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&D1&!D&!C1&C&B1&!B&!A1&!A|E1&!E&D1&!D&!C1&C&B1&!B&!A1&!A|!E1&!E&D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&!D1&D&!C1&C&B1&!B&!A1&!A|E1&!E&!D1&D&!C1&C&B1&!B&!A1&!A|!E1&!E&!D1&D&!C1&C&B1&!B&!A1&!A|!E1&!E&!D1&D&C1&C&B1&!B&!A1&!A|E1&!E&!D1&D&C1&C&B1&!B&!A1&!A|!E1&E&!D1&D&C1&C&B1&!B&!A1&!A|!E1&!E&D1&!D&C1&C&B1&!B&!A1&!A|E1&!E&D1&!D&C1&C&B1&!B&!A1&!A|!E1&E&D1&!D&C1&C&B1&!B&!A1&!A|!E1&E&!D1&!D&C1&C&B1&!B&!A1&!A|E1&!E&!D1&!D&C1&C&B1&!B&!A1&!A|!E1&!E&!D1&!D&C1&C&B1&!B&!A1&!A|!E1&!E&!D1&!D&C1&!C&B1&!B&!A1&!A|E1&!E&!D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&!D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&D1&!D&C1&!C&B1&!B&!A1&!A|E1&!E&D1&!D&C1&!C&B1&!B&!A1&!A|!E1&!E&D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&!D1&D&C1&!C&B1&!B&!A1&!A|E1&!E&!D1&D&C1&!C&B1&!B&!A1&!A|!E1&!E&!D1&D&C1&!C&B1&!B&!A1&!A|!E1&!E&!D1&D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D1&D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D1&D&!C1&!C&B1&!B&!A1&!A|!E1&!E&D1&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&E&D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D1&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&B1&B&!A1&!A|E1&!E&!D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&!D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&D1&!D&!C1&!C&B1&B&!A1&!A|E1&!E&D1&!D&!C1&!C&B1&B&!A1&!A|!E1&!E&D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&!D1&D&!C1&!C&B1&B&!A1&!A|E1&!E&!D1&D&!C1&!C&B1&B&!A1&!A|!E1&!E&!D1&D&!C1&!C&B1&B&!A1&!A|!E1&!E&!D1&D&C1&!C&B1&B&!A1&!A|E1&!E&!D1&D&C1&!C&B1&B&!A1&!A|!E1&E&!D1&D&C1&!C&B1&B&!A1&!A|!E1&!E&D1&!D&C1&!C&B1&B&!A1&!A|E1&!E&D1&!D&C1&!C&B1&B&!A1&!A|!E1&E&D1&!D&C1&!C&B1&B&!A1&!A|!E1&E&!D1&!D&C1&!C&B1&B&!A1&!A|E1&!E&!D1&!D&C1&!C&B1&B&!A1&!A|!E1&!E&!D1&!D&C1&!C&B1&B&!A1&!A|!E1&!E&!D1&!D&C1&C&B1&B&!A1&!A|E1&!E&!D1&!D&C1&C&B1&B&!A1&!A|!E1&E&!D1&!D&C1&C&B1&B&!A1&!A|!E1&E&D1&!D&C1&C&B1&B&!A1&!A|E1&!E&D1&!D&C1&C&B1&B&!A1&!A|!E1&!E&D1&!D&C1&C&B1&B&!A1&!A|!E1&E&!D1&D&C1&C&B1&B&!A1&!A|E1&!E&!D1&D&C1&C&B1&B&!A1&!A|!E1&!E&!D1&D&C1&C&B1&B&!A1&!A|!E1&!E&!D1&D&!C1&C&B1&B&!A1&!A|E1&!E&!D1&D&!C1&C&B1&B&!A1&!A|!E1&E&!D1&D&!C1&C&B1&B&!A1&!A|!E1&!E&D1&!D&!C1&C&B1&B&!A1&!A|E1&!E&D1&!D&!C1&C&B1&B&!A1&!A|!E1&E&D1&!D&!C1&C&B1&B&!A1&!A|!E1&E&!D1&!D&!C1&C&B1&B&!A1&!A|E1&!E&!D1&!D&!C1&C&B1&B&!A1&!A|!E1&!E&!D1&!D&!C1&C&B1&B&!A1&!A|!E1&!E&!D1&!D&!C1&C&!B1&B&!A1&!A|E1&!E&!D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&!D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&D1&!D&!C1&C&!B1&B&!A1&!A|E1&!E&D1&!D&!C1&C&!B1&B&!A1&!A|!E1&!E&D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&!D1&D&!C1&C&!B1&B&!A1&!A|E1&!E&!D1&D&!C1&C&!B1&B&!A1&!A|!E1&!E&!D1&D&!C1&C&!B1&B&!A1&!A|!E1&!E&!D1&D&C1&C&!B1&B&!A1&!A|E1&!E&!D1&D&C1&C&!B1&B&!A1&!A|!E1&E&!D1&D&C1&C&!B1&B&!A1&!A|!E1&!E&D1&!D&C1&C&!B1&B&!A1&!A|E1&!E&D1&!D&C1&C&!B1&B&!A1&!A|!E1&E&D1&!D&C1&C&!B1&B&!A1&!A|!E1&E&!D1&!D&C1&C&!B1&B&!A1&!A|E1&!E&!D1&!D&C1&C&!B1&B&!A1&!A|!E1&!E&!D1&!D&C1&C&!B1&B&!A1&!A|!E1&!E&!D1&!D&C1&!C&!B1&B&!A1&!A|E1&!E&!D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&!D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&D1&!D&C1&!C&!B1&B&!A1&!A|E1&!E&D1&!D&C1&!C&!B1&B&!A1&!A|!E1&!E&D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&!D1&D&C1&!C&!B1&B&!A1&!A|E1&!E&!D1&D&C1&!C&!B1&B&!A1&!A|!E1&!E&!D1&D&C1&!C&!B1&B&!A1&!A|!E1&!E&!D1&D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D1&D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D1&D&!C1&!C&!B1&B&!A1&!A|!E1&!E&D1&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&E&D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D1&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&!D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&!D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&D1&!D&!C1&!C&!B1&B&A1&!A|!E1&!E&D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&!D1&D&!C1&!C&!B1&B&A1&!A|E1&!E&!D1&D&!C1&!C&!B1&B&A1&!A|!E1&!E&!D1&D&!C1&!C&!B1&B&A1&!A|!E1&!E&!D1&D&!C1&!C&B1&B&A1&!A|E1&!E&!D1&D&!C1&!C&B1&B&A1&!A|!E1&E&!D1&D&!C1&!C&B1&B&A1&!A|!E1&!E&D1&!D&!C1&!C&B1&B&A1&!A|E1&!E&D1&!D&!C1&!C&B1&B&A1&!A|!E1&E&D1&!D&!C1&!C&B1&B&A1&!A|!E1&E&!D1&!D&!C1&!C&B1&B&A1&!A|E1&!E&!D1&!D&!C1&!C&B1&B&A1&!A|!E1&!E&!D1&!D&!C1&!C&B1&B&A1&!A|!E1&!E&!D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&!D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&!D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&D1&!D&!C1&!C&B1&!B&A1&!A|!E1&!E&D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&!D1&D&!C1&!C&B1&!B&A1&!A|E1&!E&!D1&D&!C1&!C&B1&!B&A1&!A|!E1&!E&!D1&D&!C1&!C&B1&!B&A1&!A|!E1&!E&!D1&!D&!C1&C&!B1&!B&A1&!A|E1&!E&!D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&!D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&D1&!D&!C1&C&!B1&!B&A1&!A|E1&!E&D1&!D&!C1&C&!B1&!B&A1&!A|!E1&!E&D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&!D1&D&!C1&C&!B1&!B&A1&!A|E1&!E&!D1&D&!C1&C&!B1&!B&A1&!A|!E1&!E&!D1&D&!C1&C&!B1&!B&A1&!A|!E1&!E&!D1&D&C1&C&!B1&!B&A1&!A|E1&!E&!D1&D&C1&C&!B1&!B&A1&!A|!E1&E&!D1&D&C1&C&!B1&!B&A1&!A|!E1&!E&D1&!D&C1&C&!B1&!B&A1&!A|E1&!E&D1&!D&C1&C&!B1&!B&A1&!A|!E1&E&D1&!D&C1&C&!B1&!B&A1&!A|!E1&E&!D1&!D&C1&C&!B1&!B&A1&!A|E1&!E&!D1&!D&C1&C&!B1&!B&A1&!A|!E1&!E&!D1&!D&C1&C&!B1&!B&A1&!A|!E1&!E&!D1&!D&C1&!C&!B1&!B&A1&!A|E1&!E&!D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&!D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&D1&!D&C1&!C&!B1&!B&A1&!A|E1&!E&D1&!D&C1&!C&!B1&!B&A1&!A|!E1&!E&D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&!D1&D&C1&!C&!B1&!B&A1&!A|E1&!E&!D1&D&C1&!C&!B1&!B&A1&!A|!E1&!E&!D1&D&C1&!C&!B1&!B&A1&!A|!E1&!E&!D1&D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D1&D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D1&D&!C1&!C&!B1&!B&A1&!A|!E1&!E&D1&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&E&D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D1&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D1&!D&!C1&!C&!B1&!B&A1&A|E1&!E&!D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&!D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&D1&!D&!C1&!C&!B1&!B&A1&A|E1&!E&D1&!D&!C1&!C&!B1&!B&A1&A|!E1&!E&D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&!D1&D&!C1&!C&!B1&!B&A1&A|E1&!E&!D1&D&!C1&!C&!B1&!B&A1&A|!E1&!E&!D1&D&!C1&!C&!B1&!B&A1&A|!E1&!E&!D1&D&C1&!C&!B1&!B&A1&A|E1&!E&!D1&D&C1&!C&!B1&!B&A1&A|!E1&E&!D1&D&C1&!C&!B1&!B&A1&A|!E1&!E&D1&!D&C1&!C&!B1&!B&A1&A|E1&!E&D1&!D&C1&!C&!B1&!B&A1&A|!E1&E&D1&!D&C1&!C&!B1&!B&A1&A|!E1&E&!D1&!D&C1&!C&!B1&!B&A1&A|E1&!E&!D1&!D&C1&!C&!B1&!B&A1&A|!E1&!E&!D1&!D&C1&!C&!B1&!B&A1&A|!E1&!E&!D1&!D&C1&C&!B1&!B&A1&A|E1&!E&!D1&!D&C1&C&!B1&!B&A1&A|!E1&E&!D1&!D&C1&C&!B1&!B&A1&A|!E1&E&D1&!D&C1&C&!B1&!B&A1&A|E1&!E&D1&!D&C1&C&!B1&!B&A1&A|!E1&!E&D1&!D&C1&C&!B1&!B&A1&A|!E1&E&!D1&D&C1&C&!B1&!B&A1&A|E1&!E&!D1&D&C1&C&!B1&!B&A1&A|!E1&!E&!D1&D&C1&C&!B1&!B&A1&A|!E1&!E&!D1&D&!C1&C&!B1&!B&A1&A|E1&!E&!D1&D&!C1&C&!B1&!B&A1&A|!E1&E&!D1&D&!C1&C&!B1&!B&A1&A|!E1&!E&D1&!D&!C1&C&!B1&!B&A1&A|E1&!E&D1&!D&!C1&C&!B1&!B&A1&A|!E1&E&D1&!D&!C1&C&!B1&!B&A1&A|!E1&E&!D1&!D&!C1&C&!B1&!B&A1&A|E1&!E&!D1&!D&!C1&C&!B1&!B&A1&A|!E1&!E&!D1&!D&!C1&C&!B1&!B&A1&A|!E1&!E&!D1&D&!C1&!C&B1&!B&A1&A|E1&!E&!D1&D&!C1&!C&B1&!B&A1&A|!E1&E&!D1&D&!C1&!C&B1&!B&A1&A|!E1&!E&D1&!D&!C1&!C&B1&!B&A1&A|E1&!E&D1&!D&!C1&!C&B1&!B&A1&A|!E1&E&D1&!D&!C1&!C&B1&!B&A1&A|!E1&E&!D1&!D&!C1&!C&B1&!B&A1&A|E1&!E&!D1&!D&!C1&!C&B1&!B&A1&A|!E1&!E&!D1&!D&!C1&!C&B1&!B&A1&A|!E1&!E&!D1&!D&!C1&!C&B1&B&A1&A|E1&!E&!D1&!D&!C1&!C&B1&B&A1&A|!E1&E&!D1&!D&!C1&!C&B1&B&A1&A|!E1&E&D1&!D&!C1&!C&B1&B&A1&A|E1&!E&D1&!D&!C1&!C&B1&B&A1&A|!E1&!E&D1&!D&!C1&!C&B1&B&A1&A|!E1&E&!D1&D&!C1&!C&B1&B&A1&A|E1&!E&!D1&D&!C1&!C&B1&B&A1&A|!E1&!E&!D1&D&!C1&!C&B1&B&A1&A|!E1&!E&!D1&D&!C1&!C&!B1&B&A1&A|E1&!E&!D1&D&!C1&!C&!B1&B&A1&A|!E1&E&!D1&D&!C1&!C&!B1&B&A1&A|!E1&!E&D1&!D&!C1&!C&!B1&B&A1&A|E1&!E&D1&!D&!C1&!C&!B1&B&A1&A|!E1&E&D1&!D&!C1&!C&!B1&B&A1&A|!E1&E&!D1&!D&!C1&!C&!B1&B&A1&A|E1&!E&!D1&!D&!C1&!C&!B1&B&A1&A|!E1&!E&!D1&!D&!C1&!C&!B1&B&A1&A|!E1&!E&!D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&!D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&!D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&D1&!D&!C1&!C&!B1&B&!A1&A|!E1&!E&D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&!D1&D&!C1&!C&!B1&B&!A1&A|E1&!E&!D1&D&!C1&!C&!B1&B&!A1&A|!E1&!E&!D1&D&!C1&!C&!B1&B&!A1&A|!E1&!E&!D1&D&!C1&!C&B1&B&!A1&A|E1&!E&!D1&D&!C1&!C&B1&B&!A1&A|!E1&E&!D1&D&!C1&!C&B1&B&!A1&A|!E1&!E&D1&!D&!C1&!C&B1&B&!A1&A|E1&!E&D1&!D&!C1&!C&B1&B&!A1&A|!E1&E&D1&!D&!C1&!C&B1&B&!A1&A|!E1&E&!D1&!D&!C1&!C&B1&B&!A1&A|E1&!E&!D1&!D&!C1&!C&B1&B&!A1&A|!E1&!E&!D1&!D&!C1&!C&B1&B&!A1&A|!E1&!E&!D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&!D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&!D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&D1&!D&!C1&!C&B1&!B&!A1&A|!E1&!E&D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&!D1&D&!C1&!C&B1&!B&!A1&A|E1&!E&!D1&D&!C1&!C&B1&!B&!A1&A|!E1&!E&!D1&D&!C1&!C&B1&!B&!A1&A|!E1&!E&!D1&!D&!C1&C&!B1&!B&!A1&A|E1&!E&!D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&!D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&D1&!D&!C1&C&!B1&!B&!A1&A|E1&!E&D1&!D&!C1&C&!B1&!B&!A1&A|!E1&!E&D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&!D1&D&!C1&C&!B1&!B&!A1&A|E1&!E&!D1&D&!C1&C&!B1&!B&!A1&A|!E1&!E&!D1&D&!C1&C&!B1&!B&!A1&A|!E1&!E&!D1&D&C1&C&!B1&!B&!A1&A|E1&!E&!D1&D&C1&C&!B1&!B&!A1&A|!E1&E&!D1&D&C1&C&!B1&!B&!A1&A|!E1&!E&D1&!D&C1&C&!B1&!B&!A1&A|E1&!E&D1&!D&C1&C&!B1&!B&!A1&A|!E1&E&D1&!D&C1&C&!B1&!B&!A1&A|!E1&E&!D1&!D&C1&C&!B1&!B&!A1&A|E1&!E&!D1&!D&C1&C&!B1&!B&!A1&A|!E1&!E&!D1&!D&C1&C&!B1&!B&!A1&A|!E1&!E&!D1&!D&C1&!C&!B1&!B&!A1&A|E1&!E&!D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&!D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&D1&!D&C1&!C&!B1&!B&!A1&A|E1&!E&D1&!D&C1&!C&!B1&!B&!A1&A|!E1&!E&D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&!D1&D&C1&!C&!B1&!B&!A1&A|E1&!E&!D1&D&C1&!C&!B1&!B&!A1&A|!E1&!E&!D1&D&C1&!C&!B1&!B&!A1&A|!E1&!E&!D1&D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D1&D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D1&D&!C1&!C&!B1&!B&!A1&A|!E1&!E&D1&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&E&D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D1&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&!E&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAAAOI22222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAOOAI22212 -l OOOAOOAI22212 -i E1 E D C1 C B1 B A1 A -o Y -f Y=(!E1&!E&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D&!C1&!C&!B1&!B&!A1&!A|E1&E&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D&C1&!C&!B1&!B&!A1&!A|E1&E&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D&C1&C&!B1&!B&!A1&!A|E1&!E&!D&C1&C&!B1&!B&!A1&!A|E1&E&!D&C1&C&!B1&!B&!A1&!A|!E1&E&!D&C1&C&!B1&!B&!A1&!A|!E1&!E&D&C1&C&!B1&!B&!A1&!A|!E1&!E&D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D&!C1&C&!B1&!B&!A1&!A|E1&E&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D&!C1&C&B1&!B&!A1&!A|E1&!E&!D&!C1&C&B1&!B&!A1&!A|E1&E&!D&!C1&C&B1&!B&!A1&!A|!E1&E&!D&!C1&C&B1&!B&!A1&!A|!E1&!E&D&!C1&C&B1&!B&!A1&!A|!E1&!E&D&C1&C&B1&!B&!A1&!A|!E1&E&!D&C1&C&B1&!B&!A1&!A|E1&E&!D&C1&C&B1&!B&!A1&!A|E1&!E&!D&C1&C&B1&!B&!A1&!A|!E1&!E&!D&C1&C&B1&!B&!A1&!A|!E1&!E&!D&C1&!C&B1&!B&!A1&!A|E1&!E&!D&C1&!C&B1&!B&!A1&!A|E1&E&!D&C1&!C&B1&!B&!A1&!A|!E1&E&!D&C1&!C&B1&!B&!A1&!A|!E1&!E&D&C1&!C&B1&!B&!A1&!A|!E1&!E&D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D&!C1&!C&B1&!B&!A1&!A|E1&E&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D&!C1&!C&B1&B&!A1&!A|E1&!E&!D&!C1&!C&B1&B&!A1&!A|E1&E&!D&!C1&!C&B1&B&!A1&!A|!E1&E&!D&!C1&!C&B1&B&!A1&!A|!E1&!E&D&!C1&!C&B1&B&!A1&!A|!E1&!E&D&C1&!C&B1&B&!A1&!A|!E1&E&!D&C1&!C&B1&B&!A1&!A|E1&E&!D&C1&!C&B1&B&!A1&!A|E1&!E&!D&C1&!C&B1&B&!A1&!A|!E1&!E&!D&C1&!C&B1&B&!A1&!A|!E1&!E&!D&C1&C&B1&B&!A1&!A|E1&!E&!D&C1&C&B1&B&!A1&!A|E1&E&!D&C1&C&B1&B&!A1&!A|!E1&E&!D&C1&C&B1&B&!A1&!A|!E1&!E&D&C1&C&B1&B&!A1&!A|!E1&!E&D&!C1&C&B1&B&!A1&!A|!E1&E&!D&!C1&C&B1&B&!A1&!A|E1&E&!D&!C1&C&B1&B&!A1&!A|E1&!E&!D&!C1&C&B1&B&!A1&!A|!E1&!E&!D&!C1&C&B1&B&!A1&!A|!E1&!E&!D&!C1&C&!B1&B&!A1&!A|E1&!E&!D&!C1&C&!B1&B&!A1&!A|E1&E&!D&!C1&C&!B1&B&!A1&!A|!E1&E&!D&!C1&C&!B1&B&!A1&!A|!E1&!E&D&!C1&C&!B1&B&!A1&!A|!E1&!E&D&C1&C&!B1&B&!A1&!A|!E1&E&!D&C1&C&!B1&B&!A1&!A|E1&E&!D&C1&C&!B1&B&!A1&!A|E1&!E&!D&C1&C&!B1&B&!A1&!A|!E1&!E&!D&C1&C&!B1&B&!A1&!A|!E1&!E&!D&C1&!C&!B1&B&!A1&!A|E1&!E&!D&C1&!C&!B1&B&!A1&!A|E1&E&!D&C1&!C&!B1&B&!A1&!A|!E1&E&!D&C1&!C&!B1&B&!A1&!A|!E1&!E&D&C1&!C&!B1&B&!A1&!A|!E1&!E&D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D&!C1&!C&!B1&B&!A1&!A|E1&E&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D&!C1&!C&!B1&B&A1&!A|E1&!E&!D&!C1&!C&!B1&B&A1&!A|E1&E&!D&!C1&!C&!B1&B&A1&!A|!E1&E&!D&!C1&!C&!B1&B&A1&!A|!E1&!E&D&!C1&!C&!B1&B&A1&!A|!E1&!E&D&C1&!C&!B1&B&A1&!A|!E1&!E&!D&C1&!C&!B1&B&A1&!A|!E1&!E&!D&C1&C&!B1&B&A1&!A|!E1&!E&D&C1&C&!B1&B&A1&!A|!E1&!E&D&!C1&C&!B1&B&A1&!A|!E1&!E&!D&!C1&C&!B1&B&A1&!A|!E1&!E&!D&!C1&C&B1&B&A1&!A|!E1&!E&D&!C1&C&B1&B&A1&!A|!E1&!E&D&C1&C&B1&B&A1&!A|!E1&!E&!D&C1&C&B1&B&A1&!A|!E1&!E&!D&C1&!C&B1&B&A1&!A|!E1&!E&D&C1&!C&B1&B&A1&!A|!E1&!E&D&!C1&!C&B1&B&A1&!A|!E1&E&!D&!C1&!C&B1&B&A1&!A|E1&E&!D&!C1&!C&B1&B&A1&!A|E1&!E&!D&!C1&!C&B1&B&A1&!A|!E1&!E&!D&!C1&!C&B1&B&A1&!A|!E1&!E&!D&!C1&!C&B1&!B&A1&!A|E1&!E&!D&!C1&!C&B1&!B&A1&!A|E1&E&!D&!C1&!C&B1&!B&A1&!A|!E1&E&!D&!C1&!C&B1&!B&A1&!A|!E1&!E&D&!C1&!C&B1&!B&A1&!A|!E1&!E&D&C1&!C&B1&!B&A1&!A|!E1&!E&!D&C1&!C&B1&!B&A1&!A|!E1&!E&!D&C1&C&B1&!B&A1&!A|!E1&!E&D&C1&C&B1&!B&A1&!A|!E1&!E&D&!C1&C&B1&!B&A1&!A|!E1&!E&!D&!C1&C&B1&!B&A1&!A|!E1&!E&!D&!C1&C&!B1&!B&A1&!A|E1&!E&!D&!C1&C&!B1&!B&A1&!A|E1&E&!D&!C1&C&!B1&!B&A1&!A|!E1&E&!D&!C1&C&!B1&!B&A1&!A|!E1&!E&D&!C1&C&!B1&!B&A1&!A|!E1&!E&D&C1&C&!B1&!B&A1&!A|!E1&E&!D&C1&C&!B1&!B&A1&!A|E1&E&!D&C1&C&!B1&!B&A1&!A|E1&!E&!D&C1&C&!B1&!B&A1&!A|!E1&!E&!D&C1&C&!B1&!B&A1&!A|!E1&!E&!D&C1&!C&!B1&!B&A1&!A|E1&!E&!D&C1&!C&!B1&!B&A1&!A|E1&E&!D&C1&!C&!B1&!B&A1&!A|!E1&E&!D&C1&!C&!B1&!B&A1&!A|!E1&!E&D&C1&!C&!B1&!B&A1&!A|!E1&!E&D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D&!C1&!C&!B1&!B&A1&!A|E1&E&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D&!C1&!C&!B1&!B&A1&A|E1&!E&!D&!C1&!C&!B1&!B&A1&A|E1&E&!D&!C1&!C&!B1&!B&A1&A|!E1&E&!D&!C1&!C&!B1&!B&A1&A|!E1&!E&D&!C1&!C&!B1&!B&A1&A|!E1&!E&D&C1&!C&!B1&!B&A1&A|!E1&E&!D&C1&!C&!B1&!B&A1&A|E1&E&!D&C1&!C&!B1&!B&A1&A|E1&!E&!D&C1&!C&!B1&!B&A1&A|!E1&!E&!D&C1&!C&!B1&!B&A1&A|!E1&!E&!D&C1&C&!B1&!B&A1&A|E1&!E&!D&C1&C&!B1&!B&A1&A|E1&E&!D&C1&C&!B1&!B&A1&A|!E1&E&!D&C1&C&!B1&!B&A1&A|!E1&!E&D&C1&C&!B1&!B&A1&A|!E1&!E&D&!C1&C&!B1&!B&A1&A|!E1&E&!D&!C1&C&!B1&!B&A1&A|E1&E&!D&!C1&C&!B1&!B&A1&A|E1&!E&!D&!C1&C&!B1&!B&A1&A|!E1&!E&!D&!C1&C&!B1&!B&A1&A|!E1&!E&!D&!C1&C&B1&!B&A1&A|!E1&!E&D&!C1&C&B1&!B&A1&A|!E1&!E&D&C1&C&B1&!B&A1&A|!E1&!E&!D&C1&C&B1&!B&A1&A|!E1&!E&!D&C1&!C&B1&!B&A1&A|!E1&!E&D&C1&!C&B1&!B&A1&A|!E1&!E&D&!C1&!C&B1&!B&A1&A|!E1&E&!D&!C1&!C&B1&!B&A1&A|E1&E&!D&!C1&!C&B1&!B&A1&A|E1&!E&!D&!C1&!C&B1&!B&A1&A|!E1&!E&!D&!C1&!C&B1&!B&A1&A|!E1&!E&!D&!C1&!C&B1&B&A1&A|E1&!E&!D&!C1&!C&B1&B&A1&A|E1&E&!D&!C1&!C&B1&B&A1&A|!E1&E&!D&!C1&!C&B1&B&A1&A|!E1&!E&D&!C1&!C&B1&B&A1&A|!E1&!E&D&C1&!C&B1&B&A1&A|!E1&!E&!D&C1&!C&B1&B&A1&A|!E1&!E&!D&C1&C&B1&B&A1&A|!E1&!E&D&C1&C&B1&B&A1&A|!E1&!E&D&!C1&C&B1&B&A1&A|!E1&!E&!D&!C1&C&B1&B&A1&A|!E1&!E&!D&!C1&C&!B1&B&A1&A|!E1&!E&D&!C1&C&!B1&B&A1&A|!E1&!E&D&C1&C&!B1&B&A1&A|!E1&!E&!D&C1&C&!B1&B&A1&A|!E1&!E&!D&C1&!C&!B1&B&A1&A|!E1&!E&D&C1&!C&!B1&B&A1&A|!E1&!E&D&!C1&!C&!B1&B&A1&A|!E1&E&!D&!C1&!C&!B1&B&A1&A|E1&E&!D&!C1&!C&!B1&B&A1&A|E1&!E&!D&!C1&!C&!B1&B&A1&A|!E1&!E&!D&!C1&!C&!B1&B&A1&A|!E1&!E&!D&!C1&!C&!B1&B&!A1&A|E1&!E&!D&!C1&!C&!B1&B&!A1&A|E1&E&!D&!C1&!C&!B1&B&!A1&A|!E1&E&!D&!C1&!C&!B1&B&!A1&A|!E1&!E&D&!C1&!C&!B1&B&!A1&A|!E1&!E&D&C1&!C&!B1&B&!A1&A|!E1&!E&!D&C1&!C&!B1&B&!A1&A|!E1&!E&!D&C1&C&!B1&B&!A1&A|!E1&!E&D&C1&C&!B1&B&!A1&A|!E1&!E&D&!C1&C&!B1&B&!A1&A|!E1&!E&!D&!C1&C&!B1&B&!A1&A|!E1&!E&!D&!C1&C&B1&B&!A1&A|!E1&!E&D&!C1&C&B1&B&!A1&A|!E1&!E&D&C1&C&B1&B&!A1&A|!E1&!E&!D&C1&C&B1&B&!A1&A|!E1&!E&!D&C1&!C&B1&B&!A1&A|!E1&!E&D&C1&!C&B1&B&!A1&A|!E1&!E&D&!C1&!C&B1&B&!A1&A|!E1&E&!D&!C1&!C&B1&B&!A1&A|E1&E&!D&!C1&!C&B1&B&!A1&A|E1&!E&!D&!C1&!C&B1&B&!A1&A|!E1&!E&!D&!C1&!C&B1&B&!A1&A|!E1&!E&!D&!C1&!C&B1&!B&!A1&A|E1&!E&!D&!C1&!C&B1&!B&!A1&A|E1&E&!D&!C1&!C&B1&!B&!A1&A|!E1&E&!D&!C1&!C&B1&!B&!A1&A|!E1&!E&D&!C1&!C&B1&!B&!A1&A|!E1&!E&D&C1&!C&B1&!B&!A1&A|!E1&!E&!D&C1&!C&B1&!B&!A1&A|!E1&!E&!D&C1&C&B1&!B&!A1&A|!E1&!E&D&C1&C&B1&!B&!A1&A|!E1&!E&D&!C1&C&B1&!B&!A1&A|!E1&!E&!D&!C1&C&B1&!B&!A1&A|!E1&!E&!D&!C1&C&!B1&!B&!A1&A|E1&!E&!D&!C1&C&!B1&!B&!A1&A|E1&E&!D&!C1&C&!B1&!B&!A1&A|!E1&E&!D&!C1&C&!B1&!B&!A1&A|!E1&!E&D&!C1&C&!B1&!B&!A1&A|!E1&!E&D&C1&C&!B1&!B&!A1&A|!E1&E&!D&C1&C&!B1&!B&!A1&A|E1&E&!D&C1&C&!B1&!B&!A1&A|E1&!E&!D&C1&C&!B1&!B&!A1&A|!E1&!E&!D&C1&C&!B1&!B&!A1&A|!E1&!E&!D&C1&!C&!B1&!B&!A1&A|E1&!E&!D&C1&!C&!B1&!B&!A1&A|E1&E&!D&C1&!C&!B1&!B&!A1&A|!E1&E&!D&C1&!C&!B1&!B&!A1&A|!E1&!E&D&C1&!C&!B1&!B&!A1&A|!E1&!E&D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D&!C1&!C&!B1&!B&!A1&A|E1&E&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D&!C1&!C&!B1&!B&!A1&A|!E1&!E&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAOOAI22212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOI214 -l OAAOI214 -i C3 C2 C1 C B A1 A -o Y -f Y=!(C3&C2&C1&C&!B&!A1&!A|C3&C2&C1&C&B&!A1&!A|!C3&!C2&!C1&!C&B&A1&!A|C3&!C2&!C1&!C&B&A1&!A|C3&C2&!C1&!C&B&A1&!A|!C3&C2&!C1&!C&B&A1&!A|!C3&C2&C1&!C&B&A1&!A|C3&C2&C1&!C&B&A1&!A|C3&!C2&C1&!C&B&A1&!A|!C3&!C2&C1&!C&B&A1&!A|!C3&!C2&C1&C&B&A1&!A|C3&!C2&C1&C&B&A1&!A|C3&C2&C1&C&B&A1&!A|!C3&C2&C1&C&B&A1&!A|!C3&C2&!C1&C&B&A1&!A|C3&C2&!C1&C&B&A1&!A|C3&!C2&!C1&C&B&A1&!A|!C3&!C2&!C1&C&B&A1&!A|C3&C2&C1&C&!B&A1&!A|C3&C2&C1&C&!B&A1&A|!C3&!C2&!C1&C&B&A1&A|C3&!C2&!C1&C&B&A1&A|C3&C2&!C1&C&B&A1&A|!C3&C2&!C1&C&B&A1&A|!C3&C2&C1&C&B&A1&A|C3&C2&C1&C&B&A1&A|C3&!C2&C1&C&B&A1&A|!C3&!C2&C1&C&B&A1&A|!C3&!C2&C1&!C&B&A1&A|C3&!C2&C1&!C&B&A1&A|C3&C2&C1&!C&B&A1&A|!C3&C2&C1&!C&B&A1&A|!C3&C2&!C1&!C&B&A1&A|C3&C2&!C1&!C&B&A1&A|C3&!C2&!C1&!C&B&A1&A|!C3&!C2&!C1&!C&B&A1&A|!C3&!C2&!C1&!C&B&!A1&A|C3&!C2&!C1&!C&B&!A1&A|C3&C2&!C1&!C&B&!A1&A|!C3&C2&!C1&!C&B&!A1&A|!C3&C2&C1&!C&B&!A1&A|C3&C2&C1&!C&B&!A1&A|C3&!C2&C1&!C&B&!A1&A|!C3&!C2&C1&!C&B&!A1&A|!C3&!C2&C1&C&B&!A1&A|C3&!C2&C1&C&B&!A1&A|C3&C2&C1&C&B&!A1&A|!C3&C2&C1&C&B&!A1&A|!C3&C2&!C1&C&B&!A1&A|C3&C2&!C1&C&B&!A1&A|C3&!C2&!C1&C&B&!A1&A|!C3&!C2&!C1&C&B&!A1&A|C3&C2&C1&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOI214.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAAOI3322 -l OOOAAOI3322 -i D1 D C1 C B2 B1 B A2 A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&!C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C1&C&B2&!B1&!B&!A2&!A1&!A|D1&!D&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&D&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&D&C1&C&B2&!B1&!B&!A2&!A1&!A|D1&!D&C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&!D&C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&D&C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&D&!C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&!D&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C1&!C&B2&B1&!B&!A2&!A1&!A|D1&!D&!C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&D&!C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&D&C1&!C&B2&B1&!B&!A2&!A1&!A|D1&!D&C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&!D&C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&!D&C1&C&B2&B1&!B&!A2&!A1&!A|D1&!D&C1&C&B2&B1&!B&!A2&!A1&!A|!D1&D&C1&C&B2&B1&!B&!A2&!A1&!A|!D1&D&!C1&C&B2&B1&!B&!A2&!A1&!A|D1&!D&!C1&C&B2&B1&!B&!A2&!A1&!A|!D1&!D&!C1&C&B2&B1&!B&!A2&!A1&!A|!D1&!D&!C1&C&!B2&B1&!B&!A2&!A1&!A|D1&!D&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&D&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&D&C1&C&!B2&B1&!B&!A2&!A1&!A|D1&!D&C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&!D&C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&D&C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&D&!C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&!D&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&!C1&!C&!B2&B1&B&!A2&!A1&!A|D1&!D&!C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&D&!C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&D&C1&!C&!B2&B1&B&!A2&!A1&!A|D1&!D&C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&!D&C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&!D&C1&C&!B2&B1&B&!A2&!A1&!A|D1&!D&C1&C&!B2&B1&B&!A2&!A1&!A|!D1&D&C1&C&!B2&B1&B&!A2&!A1&!A|!D1&D&!C1&C&!B2&B1&B&!A2&!A1&!A|D1&!D&!C1&C&!B2&B1&B&!A2&!A1&!A|!D1&!D&!C1&C&!B2&B1&B&!A2&!A1&!A|!D1&!D&!C1&C&B2&B1&B&!A2&!A1&!A|D1&!D&!C1&C&B2&B1&B&!A2&!A1&!A|!D1&D&!C1&C&B2&B1&B&!A2&!A1&!A|!D1&D&C1&C&B2&B1&B&!A2&!A1&!A|D1&!D&C1&C&B2&B1&B&!A2&!A1&!A|!D1&!D&C1&C&B2&B1&B&!A2&!A1&!A|!D1&!D&C1&!C&B2&B1&B&!A2&!A1&!A|D1&!D&C1&!C&B2&B1&B&!A2&!A1&!A|!D1&D&C1&!C&B2&B1&B&!A2&!A1&!A|!D1&D&!C1&!C&B2&B1&B&!A2&!A1&!A|D1&!D&!C1&!C&B2&B1&B&!A2&!A1&!A|!D1&!D&!C1&!C&B2&B1&B&!A2&!A1&!A|!D1&!D&!C1&!C&B2&!B1&B&!A2&!A1&!A|D1&!D&!C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&D&!C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&D&C1&!C&B2&!B1&B&!A2&!A1&!A|D1&!D&C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&!D&C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&!D&C1&C&B2&!B1&B&!A2&!A1&!A|D1&!D&C1&C&B2&!B1&B&!A2&!A1&!A|!D1&D&C1&C&B2&!B1&B&!A2&!A1&!A|!D1&D&!C1&C&B2&!B1&B&!A2&!A1&!A|D1&!D&!C1&C&B2&!B1&B&!A2&!A1&!A|!D1&!D&!C1&C&B2&!B1&B&!A2&!A1&!A|!D1&!D&!C1&C&!B2&!B1&B&!A2&!A1&!A|D1&!D&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&D&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&D&C1&C&!B2&!B1&B&!A2&!A1&!A|D1&!D&C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&!D&C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&D&C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&D&!C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&!D&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&!C1&!C&!B2&!B1&B&A2&!A1&!A|D1&!D&!C1&!C&!B2&!B1&B&A2&!A1&!A|!D1&D&!C1&!C&!B2&!B1&B&A2&!A1&!A|!D1&D&!C1&!C&B2&!B1&B&A2&!A1&!A|D1&!D&!C1&!C&B2&!B1&B&A2&!A1&!A|!D1&!D&!C1&!C&B2&!B1&B&A2&!A1&!A|!D1&!D&!C1&!C&B2&B1&B&A2&!A1&!A|D1&!D&!C1&!C&B2&B1&B&A2&!A1&!A|!D1&D&!C1&!C&B2&B1&B&A2&!A1&!A|!D1&D&!C1&!C&!B2&B1&B&A2&!A1&!A|D1&!D&!C1&!C&!B2&B1&B&A2&!A1&!A|!D1&!D&!C1&!C&!B2&B1&B&A2&!A1&!A|!D1&!D&!C1&!C&!B2&B1&!B&A2&!A1&!A|D1&!D&!C1&!C&!B2&B1&!B&A2&!A1&!A|!D1&D&!C1&!C&!B2&B1&!B&A2&!A1&!A|!D1&D&!C1&!C&B2&B1&!B&A2&!A1&!A|D1&!D&!C1&!C&B2&B1&!B&A2&!A1&!A|!D1&!D&!C1&!C&B2&B1&!B&A2&!A1&!A|!D1&!D&!C1&!C&B2&!B1&!B&A2&!A1&!A|D1&!D&!C1&!C&B2&!B1&!B&A2&!A1&!A|!D1&D&!C1&!C&B2&!B1&!B&A2&!A1&!A|!D1&!D&!C1&C&!B2&!B1&!B&A2&!A1&!A|D1&!D&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&D&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&D&C1&C&!B2&!B1&!B&A2&!A1&!A|D1&!D&C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&!D&C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&D&C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&D&!C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&!D&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&!C1&!C&!B2&!B1&!B&A2&A1&!A|D1&!D&!C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&D&!C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&D&C1&!C&!B2&!B1&!B&A2&A1&!A|D1&!D&C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&!D&C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&!D&C1&C&!B2&!B1&!B&A2&A1&!A|D1&!D&C1&C&!B2&!B1&!B&A2&A1&!A|!D1&D&C1&C&!B2&!B1&!B&A2&A1&!A|!D1&D&!C1&C&!B2&!B1&!B&A2&A1&!A|D1&!D&!C1&C&!B2&!B1&!B&A2&A1&!A|!D1&!D&!C1&C&!B2&!B1&!B&A2&A1&!A|!D1&D&!C1&!C&B2&!B1&!B&A2&A1&!A|D1&!D&!C1&!C&B2&!B1&!B&A2&A1&!A|!D1&!D&!C1&!C&B2&!B1&!B&A2&A1&!A|!D1&!D&!C1&!C&B2&B1&!B&A2&A1&!A|D1&!D&!C1&!C&B2&B1&!B&A2&A1&!A|!D1&D&!C1&!C&B2&B1&!B&A2&A1&!A|!D1&D&!C1&!C&!B2&B1&!B&A2&A1&!A|D1&!D&!C1&!C&!B2&B1&!B&A2&A1&!A|!D1&!D&!C1&!C&!B2&B1&!B&A2&A1&!A|!D1&!D&!C1&!C&!B2&B1&B&A2&A1&!A|D1&!D&!C1&!C&!B2&B1&B&A2&A1&!A|!D1&D&!C1&!C&!B2&B1&B&A2&A1&!A|!D1&D&!C1&!C&B2&B1&B&A2&A1&!A|D1&!D&!C1&!C&B2&B1&B&A2&A1&!A|!D1&!D&!C1&!C&B2&B1&B&A2&A1&!A|!D1&!D&!C1&!C&B2&!B1&B&A2&A1&!A|D1&!D&!C1&!C&B2&!B1&B&A2&A1&!A|!D1&D&!C1&!C&B2&!B1&B&A2&A1&!A|!D1&D&!C1&!C&!B2&!B1&B&A2&A1&!A|D1&!D&!C1&!C&!B2&!B1&B&A2&A1&!A|!D1&!D&!C1&!C&!B2&!B1&B&A2&A1&!A|!D1&!D&!C1&!C&!B2&!B1&B&!A2&A1&!A|D1&!D&!C1&!C&!B2&!B1&B&!A2&A1&!A|!D1&D&!C1&!C&!B2&!B1&B&!A2&A1&!A|!D1&D&!C1&!C&B2&!B1&B&!A2&A1&!A|D1&!D&!C1&!C&B2&!B1&B&!A2&A1&!A|!D1&!D&!C1&!C&B2&!B1&B&!A2&A1&!A|!D1&!D&!C1&!C&B2&B1&B&!A2&A1&!A|D1&!D&!C1&!C&B2&B1&B&!A2&A1&!A|!D1&D&!C1&!C&B2&B1&B&!A2&A1&!A|!D1&D&!C1&!C&!B2&B1&B&!A2&A1&!A|D1&!D&!C1&!C&!B2&B1&B&!A2&A1&!A|!D1&!D&!C1&!C&!B2&B1&B&!A2&A1&!A|!D1&!D&!C1&!C&!B2&B1&!B&!A2&A1&!A|D1&!D&!C1&!C&!B2&B1&!B&!A2&A1&!A|!D1&D&!C1&!C&!B2&B1&!B&!A2&A1&!A|!D1&D&!C1&!C&B2&B1&!B&!A2&A1&!A|D1&!D&!C1&!C&B2&B1&!B&!A2&A1&!A|!D1&!D&!C1&!C&B2&B1&!B&!A2&A1&!A|!D1&!D&!C1&!C&B2&!B1&!B&!A2&A1&!A|D1&!D&!C1&!C&B2&!B1&!B&!A2&A1&!A|!D1&D&!C1&!C&B2&!B1&!B&!A2&A1&!A|!D1&!D&!C1&C&!B2&!B1&!B&!A2&A1&!A|D1&!D&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&D&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&D&C1&C&!B2&!B1&!B&!A2&A1&!A|D1&!D&C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&!D&C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&D&C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&D&!C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&!D&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&!C1&!C&!B2&!B1&!B&!A2&A1&A|D1&!D&!C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&D&!C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&D&C1&!C&!B2&!B1&!B&!A2&A1&A|D1&!D&C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&!D&C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&!D&C1&C&!B2&!B1&!B&!A2&A1&A|D1&!D&C1&C&!B2&!B1&!B&!A2&A1&A|!D1&D&C1&C&!B2&!B1&!B&!A2&A1&A|!D1&D&!C1&C&!B2&!B1&!B&!A2&A1&A|D1&!D&!C1&C&!B2&!B1&!B&!A2&A1&A|!D1&!D&!C1&C&!B2&!B1&!B&!A2&A1&A|!D1&D&!C1&!C&B2&!B1&!B&!A2&A1&A|D1&!D&!C1&!C&B2&!B1&!B&!A2&A1&A|!D1&!D&!C1&!C&B2&!B1&!B&!A2&A1&A|!D1&!D&!C1&!C&B2&B1&!B&!A2&A1&A|D1&!D&!C1&!C&B2&B1&!B&!A2&A1&A|!D1&D&!C1&!C&B2&B1&!B&!A2&A1&A|!D1&D&!C1&!C&!B2&B1&!B&!A2&A1&A|D1&!D&!C1&!C&!B2&B1&!B&!A2&A1&A|!D1&!D&!C1&!C&!B2&B1&!B&!A2&A1&A|!D1&!D&!C1&!C&!B2&B1&B&!A2&A1&A|D1&!D&!C1&!C&!B2&B1&B&!A2&A1&A|!D1&D&!C1&!C&!B2&B1&B&!A2&A1&A|!D1&D&!C1&!C&B2&B1&B&!A2&A1&A|D1&!D&!C1&!C&B2&B1&B&!A2&A1&A|!D1&!D&!C1&!C&B2&B1&B&!A2&A1&A|!D1&!D&!C1&!C&B2&!B1&B&!A2&A1&A|D1&!D&!C1&!C&B2&!B1&B&!A2&A1&A|!D1&D&!C1&!C&B2&!B1&B&!A2&A1&A|!D1&D&!C1&!C&!B2&!B1&B&!A2&A1&A|D1&!D&!C1&!C&!B2&!B1&B&!A2&A1&A|!D1&!D&!C1&!C&!B2&!B1&B&!A2&A1&A|!D1&!D&!C1&!C&!B2&!B1&B&A2&A1&A|D1&!D&!C1&!C&!B2&!B1&B&A2&A1&A|!D1&D&!C1&!C&!B2&!B1&B&A2&A1&A|!D1&D&!C1&!C&B2&!B1&B&A2&A1&A|D1&!D&!C1&!C&B2&!B1&B&A2&A1&A|!D1&!D&!C1&!C&B2&!B1&B&A2&A1&A|!D1&!D&!C1&!C&B2&B1&B&A2&A1&A|D1&!D&!C1&!C&B2&B1&B&A2&A1&A|!D1&D&!C1&!C&B2&B1&B&A2&A1&A|!D1&D&!C1&!C&!B2&B1&B&A2&A1&A|D1&!D&!C1&!C&!B2&B1&B&A2&A1&A|!D1&!D&!C1&!C&!B2&B1&B&A2&A1&A|!D1&!D&!C1&!C&!B2&B1&!B&A2&A1&A|D1&!D&!C1&!C&!B2&B1&!B&A2&A1&A|!D1&D&!C1&!C&!B2&B1&!B&A2&A1&A|!D1&D&!C1&!C&B2&B1&!B&A2&A1&A|D1&!D&!C1&!C&B2&B1&!B&A2&A1&A|!D1&!D&!C1&!C&B2&B1&!B&A2&A1&A|!D1&!D&!C1&!C&B2&!B1&!B&A2&A1&A|D1&!D&!C1&!C&B2&!B1&!B&A2&A1&A|!D1&D&!C1&!C&B2&!B1&!B&A2&A1&A|!D1&!D&!C1&C&!B2&!B1&!B&A2&A1&A|D1&!D&!C1&C&!B2&!B1&!B&A2&A1&A|!D1&D&!C1&C&!B2&!B1&!B&A2&A1&A|!D1&D&C1&C&!B2&!B1&!B&A2&A1&A|D1&!D&C1&C&!B2&!B1&!B&A2&A1&A|!D1&!D&C1&C&!B2&!B1&!B&A2&A1&A|!D1&!D&C1&!C&!B2&!B1&!B&A2&A1&A|D1&!D&C1&!C&!B2&!B1&!B&A2&A1&A|!D1&D&C1&!C&!B2&!B1&!B&A2&A1&A|!D1&D&!C1&!C&!B2&!B1&!B&A2&A1&A|D1&!D&!C1&!C&!B2&!B1&!B&A2&A1&A|!D1&!D&!C1&!C&!B2&!B1&!B&A2&A1&A|!D1&!D&!C1&!C&!B2&!B1&!B&A2&!A1&A|D1&!D&!C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&D&!C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&D&C1&!C&!B2&!B1&!B&A2&!A1&A|D1&!D&C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&!D&C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&!D&C1&C&!B2&!B1&!B&A2&!A1&A|D1&!D&C1&C&!B2&!B1&!B&A2&!A1&A|!D1&D&C1&C&!B2&!B1&!B&A2&!A1&A|!D1&D&!C1&C&!B2&!B1&!B&A2&!A1&A|D1&!D&!C1&C&!B2&!B1&!B&A2&!A1&A|!D1&!D&!C1&C&!B2&!B1&!B&A2&!A1&A|!D1&D&!C1&!C&B2&!B1&!B&A2&!A1&A|D1&!D&!C1&!C&B2&!B1&!B&A2&!A1&A|!D1&!D&!C1&!C&B2&!B1&!B&A2&!A1&A|!D1&!D&!C1&!C&B2&B1&!B&A2&!A1&A|D1&!D&!C1&!C&B2&B1&!B&A2&!A1&A|!D1&D&!C1&!C&B2&B1&!B&A2&!A1&A|!D1&D&!C1&!C&!B2&B1&!B&A2&!A1&A|D1&!D&!C1&!C&!B2&B1&!B&A2&!A1&A|!D1&!D&!C1&!C&!B2&B1&!B&A2&!A1&A|!D1&!D&!C1&!C&!B2&B1&B&A2&!A1&A|D1&!D&!C1&!C&!B2&B1&B&A2&!A1&A|!D1&D&!C1&!C&!B2&B1&B&A2&!A1&A|!D1&D&!C1&!C&B2&B1&B&A2&!A1&A|D1&!D&!C1&!C&B2&B1&B&A2&!A1&A|!D1&!D&!C1&!C&B2&B1&B&A2&!A1&A|!D1&!D&!C1&!C&B2&!B1&B&A2&!A1&A|D1&!D&!C1&!C&B2&!B1&B&A2&!A1&A|!D1&D&!C1&!C&B2&!B1&B&A2&!A1&A|!D1&D&!C1&!C&!B2&!B1&B&A2&!A1&A|D1&!D&!C1&!C&!B2&!B1&B&A2&!A1&A|!D1&!D&!C1&!C&!B2&!B1&B&A2&!A1&A|!D1&!D&!C1&!C&!B2&!B1&B&!A2&!A1&A|D1&!D&!C1&!C&!B2&!B1&B&!A2&!A1&A|!D1&D&!C1&!C&!B2&!B1&B&!A2&!A1&A|!D1&D&!C1&!C&B2&!B1&B&!A2&!A1&A|D1&!D&!C1&!C&B2&!B1&B&!A2&!A1&A|!D1&!D&!C1&!C&B2&!B1&B&!A2&!A1&A|!D1&!D&!C1&!C&B2&B1&B&!A2&!A1&A|D1&!D&!C1&!C&B2&B1&B&!A2&!A1&A|!D1&D&!C1&!C&B2&B1&B&!A2&!A1&A|!D1&D&!C1&!C&!B2&B1&B&!A2&!A1&A|D1&!D&!C1&!C&!B2&B1&B&!A2&!A1&A|!D1&!D&!C1&!C&!B2&B1&B&!A2&!A1&A|!D1&!D&!C1&!C&!B2&B1&!B&!A2&!A1&A|D1&!D&!C1&!C&!B2&B1&!B&!A2&!A1&A|!D1&D&!C1&!C&!B2&B1&!B&!A2&!A1&A|!D1&D&!C1&!C&B2&B1&!B&!A2&!A1&A|D1&!D&!C1&!C&B2&B1&!B&!A2&!A1&A|!D1&!D&!C1&!C&B2&B1&!B&!A2&!A1&A|!D1&!D&!C1&!C&B2&!B1&!B&!A2&!A1&A|D1&!D&!C1&!C&B2&!B1&!B&!A2&!A1&A|!D1&D&!C1&!C&B2&!B1&!B&!A2&!A1&A|!D1&!D&!C1&C&!B2&!B1&!B&!A2&!A1&A|D1&!D&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&D&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&D&C1&C&!B2&!B1&!B&!A2&!A1&A|D1&!D&C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&C1&!C&!B2&!B1&!B&!A2&!A1&A|D1&!D&C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&D&C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&D&!C1&!C&!B2&!B1&!B&!A2&!A1&A|D1&!D&!C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAAOI3322.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOAI2232 -l OAAOOAI2232 -i D1 D C1 C B1 B A1 A -o Y -f Y=!(D1&!D&C1&C&!B1&!B&!A1&!A|D1&D&C1&C&!B1&!B&!A1&!A|!D1&D&C1&C&!B1&!B&!A1&!A|!D1&D&C1&C&B1&!B&!A1&!A|D1&D&C1&C&B1&!B&!A1&!A|D1&!D&C1&C&B1&!B&!A1&!A|D1&!D&C1&C&B1&B&!A1&!A|D1&D&C1&C&B1&B&!A1&!A|!D1&D&C1&C&B1&B&!A1&!A|!D1&D&C1&C&!B1&B&!A1&!A|D1&D&C1&C&!B1&B&!A1&!A|D1&!D&C1&C&!B1&B&!A1&!A|D1&!D&C1&C&!B1&B&A1&!A|D1&D&C1&C&!B1&B&A1&!A|!D1&D&C1&C&!B1&B&A1&!A|D1&!D&!C1&C&B1&B&A1&!A|D1&D&!C1&C&B1&B&A1&!A|!D1&D&!C1&C&B1&B&A1&!A|!D1&D&C1&C&B1&B&A1&!A|D1&D&C1&C&B1&B&A1&!A|D1&!D&C1&C&B1&B&A1&!A|D1&!D&C1&!C&B1&B&A1&!A|D1&D&C1&!C&B1&B&A1&!A|!D1&D&C1&!C&B1&B&A1&!A|!D1&D&!C1&!C&B1&B&A1&!A|D1&D&!C1&!C&B1&B&A1&!A|D1&!D&!C1&!C&B1&B&A1&!A|D1&!D&C1&C&B1&!B&A1&!A|D1&D&C1&C&B1&!B&A1&!A|!D1&D&C1&C&B1&!B&A1&!A|!D1&D&C1&C&!B1&!B&A1&!A|D1&D&C1&C&!B1&!B&A1&!A|D1&!D&C1&C&!B1&!B&A1&!A|D1&!D&C1&C&!B1&!B&A1&A|D1&D&C1&C&!B1&!B&A1&A|!D1&D&C1&C&!B1&!B&A1&A|!D1&D&C1&C&B1&!B&A1&A|D1&D&C1&C&B1&!B&A1&A|D1&!D&C1&C&B1&!B&A1&A|D1&!D&!C1&!C&B1&B&A1&A|D1&D&!C1&!C&B1&B&A1&A|!D1&D&!C1&!C&B1&B&A1&A|!D1&D&C1&!C&B1&B&A1&A|D1&D&C1&!C&B1&B&A1&A|D1&!D&C1&!C&B1&B&A1&A|D1&!D&C1&C&B1&B&A1&A|D1&D&C1&C&B1&B&A1&A|!D1&D&C1&C&B1&B&A1&A|!D1&D&!C1&C&B1&B&A1&A|D1&D&!C1&C&B1&B&A1&A|D1&!D&!C1&C&B1&B&A1&A|!D1&D&C1&C&!B1&B&A1&A|D1&D&C1&C&!B1&B&A1&A|D1&!D&C1&C&!B1&B&A1&A|D1&!D&C1&C&!B1&B&!A1&A|D1&D&C1&C&!B1&B&!A1&A|!D1&D&C1&C&!B1&B&!A1&A|D1&!D&!C1&C&B1&B&!A1&A|D1&D&!C1&C&B1&B&!A1&A|!D1&D&!C1&C&B1&B&!A1&A|!D1&D&C1&C&B1&B&!A1&A|D1&D&C1&C&B1&B&!A1&A|D1&!D&C1&C&B1&B&!A1&A|D1&!D&C1&!C&B1&B&!A1&A|D1&D&C1&!C&B1&B&!A1&A|!D1&D&C1&!C&B1&B&!A1&A|!D1&D&!C1&!C&B1&B&!A1&A|D1&D&!C1&!C&B1&B&!A1&A|D1&!D&!C1&!C&B1&B&!A1&A|D1&!D&C1&C&B1&!B&!A1&A|D1&D&C1&C&B1&!B&!A1&A|!D1&D&C1&C&B1&!B&!A1&A|!D1&D&C1&C&!B1&!B&!A1&A|D1&D&C1&C&!B1&!B&!A1&A|D1&!D&C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOAI2232.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAI221 -l OOAI221 -i C B1 B A1 A -o Y -f Y=!(C&!B1&B&A1&!A|C&B1&B&A1&!A|C&B1&!B&A1&!A|C&B1&!B&A1&A|C&B1&B&A1&A|C&!B1&B&A1&A|C&!B1&B&!A1&A|C&B1&B&!A1&A|C&B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAI221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAAOI22221 -l OOOAAOI22221 -i E D1 D C1 C B1 B A1 A -o Y -f Y=(!E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&D1&!D&C1&C&!B1&!B&!A1&!A|!E&!D1&D&C1&C&!B1&!B&!A1&!A|!E&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&D1&!D&!C1&C&B1&!B&!A1&!A|!E&!D1&D&!C1&C&B1&!B&!A1&!A|!E&!D1&D&C1&C&B1&!B&!A1&!A|!E&D1&!D&C1&C&B1&!B&!A1&!A|!E&!D1&!D&C1&C&B1&!B&!A1&!A|!E&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&D1&!D&C1&!C&B1&!B&!A1&!A|!E&!D1&D&C1&!C&B1&!B&!A1&!A|!E&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&D1&!D&!C1&!C&B1&B&!A1&!A|!E&!D1&D&!C1&!C&B1&B&!A1&!A|!E&!D1&D&C1&!C&B1&B&!A1&!A|!E&D1&!D&C1&!C&B1&B&!A1&!A|!E&!D1&!D&C1&!C&B1&B&!A1&!A|!E&!D1&!D&C1&C&B1&B&!A1&!A|!E&D1&!D&C1&C&B1&B&!A1&!A|!E&!D1&D&C1&C&B1&B&!A1&!A|!E&!D1&D&!C1&C&B1&B&!A1&!A|!E&D1&!D&!C1&C&B1&B&!A1&!A|!E&!D1&!D&!C1&C&B1&B&!A1&!A|!E&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&D1&!D&!C1&C&!B1&B&!A1&!A|!E&!D1&D&!C1&C&!B1&B&!A1&!A|!E&!D1&D&C1&C&!B1&B&!A1&!A|!E&D1&!D&C1&C&!B1&B&!A1&!A|!E&!D1&!D&C1&C&!B1&B&!A1&!A|!E&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&D1&!D&C1&!C&!B1&B&!A1&!A|!E&!D1&D&C1&!C&!B1&B&!A1&!A|!E&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&D1&!D&!C1&!C&!B1&B&A1&!A|!E&!D1&D&!C1&!C&!B1&B&A1&!A|!E&!D1&D&!C1&!C&B1&B&A1&!A|!E&D1&!D&!C1&!C&B1&B&A1&!A|!E&!D1&!D&!C1&!C&B1&B&A1&!A|!E&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&D1&!D&!C1&!C&B1&!B&A1&!A|!E&!D1&D&!C1&!C&B1&!B&A1&!A|!E&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&D1&!D&!C1&C&!B1&!B&A1&!A|!E&!D1&D&!C1&C&!B1&!B&A1&!A|!E&!D1&D&C1&C&!B1&!B&A1&!A|!E&D1&!D&C1&C&!B1&!B&A1&!A|!E&!D1&!D&C1&C&!B1&!B&A1&!A|!E&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&D1&!D&C1&!C&!B1&!B&A1&!A|!E&!D1&D&C1&!C&!B1&!B&A1&!A|!E&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&D1&!D&!C1&!C&!B1&!B&A1&A|!E&!D1&D&!C1&!C&!B1&!B&A1&A|!E&!D1&D&C1&!C&!B1&!B&A1&A|!E&D1&!D&C1&!C&!B1&!B&A1&A|!E&!D1&!D&C1&!C&!B1&!B&A1&A|!E&!D1&!D&C1&C&!B1&!B&A1&A|!E&D1&!D&C1&C&!B1&!B&A1&A|!E&!D1&D&C1&C&!B1&!B&A1&A|!E&!D1&D&!C1&C&!B1&!B&A1&A|!E&D1&!D&!C1&C&!B1&!B&A1&A|!E&!D1&!D&!C1&C&!B1&!B&A1&A|!E&!D1&D&!C1&!C&B1&!B&A1&A|!E&D1&!D&!C1&!C&B1&!B&A1&A|!E&!D1&!D&!C1&!C&B1&!B&A1&A|!E&!D1&!D&!C1&!C&B1&B&A1&A|!E&D1&!D&!C1&!C&B1&B&A1&A|!E&!D1&D&!C1&!C&B1&B&A1&A|!E&!D1&D&!C1&!C&!B1&B&A1&A|!E&D1&!D&!C1&!C&!B1&B&A1&A|!E&!D1&!D&!C1&!C&!B1&B&A1&A|!E&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&D1&!D&!C1&!C&!B1&B&!A1&A|!E&!D1&D&!C1&!C&!B1&B&!A1&A|!E&!D1&D&!C1&!C&B1&B&!A1&A|!E&D1&!D&!C1&!C&B1&B&!A1&A|!E&!D1&!D&!C1&!C&B1&B&!A1&A|!E&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&D1&!D&!C1&!C&B1&!B&!A1&A|!E&!D1&D&!C1&!C&B1&!B&!A1&A|!E&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&D1&!D&!C1&C&!B1&!B&!A1&A|!E&!D1&D&!C1&C&!B1&!B&!A1&A|!E&!D1&D&C1&C&!B1&!B&!A1&A|!E&D1&!D&C1&C&!B1&!B&!A1&A|!E&!D1&!D&C1&C&!B1&!B&!A1&A|!E&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&D1&!D&C1&!C&!B1&!B&!A1&A|!E&!D1&D&C1&!C&!B1&!B&!A1&A|!E&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAAOI22221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOAI2231 -l OAAOAI2231 -i D C2 C1 C B1 B A1 A -o Y -f Y=!(D&C2&C1&C&!B1&!B&!A1&!A|D&C2&C1&C&B1&!B&!A1&!A|D&C2&C1&C&B1&B&!A1&!A|D&C2&C1&C&!B1&B&!A1&!A|D&C2&C1&C&!B1&B&A1&!A|D&!C2&!C1&C&B1&B&A1&!A|D&C2&!C1&C&B1&B&A1&!A|D&C2&C1&C&B1&B&A1&!A|D&!C2&C1&C&B1&B&A1&!A|D&!C2&C1&!C&B1&B&A1&!A|D&C2&C1&!C&B1&B&A1&!A|D&C2&!C1&!C&B1&B&A1&!A|D&!C2&!C1&!C&B1&B&A1&!A|D&C2&C1&C&B1&!B&A1&!A|D&C2&C1&C&!B1&!B&A1&!A|D&C2&C1&C&!B1&!B&A1&A|D&C2&C1&C&B1&!B&A1&A|D&!C2&!C1&!C&B1&B&A1&A|D&C2&!C1&!C&B1&B&A1&A|D&C2&C1&!C&B1&B&A1&A|D&!C2&C1&!C&B1&B&A1&A|D&!C2&C1&C&B1&B&A1&A|D&C2&C1&C&B1&B&A1&A|D&C2&!C1&C&B1&B&A1&A|D&!C2&!C1&C&B1&B&A1&A|D&C2&C1&C&!B1&B&A1&A|D&C2&C1&C&!B1&B&!A1&A|D&!C2&!C1&C&B1&B&!A1&A|D&C2&!C1&C&B1&B&!A1&A|D&C2&C1&C&B1&B&!A1&A|D&!C2&C1&C&B1&B&!A1&A|D&!C2&C1&!C&B1&B&!A1&A|D&C2&C1&!C&B1&B&!A1&A|D&C2&!C1&!C&B1&B&!A1&A|D&!C2&!C1&!C&B1&B&!A1&A|D&C2&C1&C&B1&!B&!A1&A|D&C2&C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOAI2231.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAI22 -l OOAI22 -i B1 B A1 A -o Y -f Y=(!B1&!B&!A1&!A|B1&!B&!A1&!A|B1&B&!A1&!A|!B1&B&!A1&!A|!B1&!B&A1&!A|!B1&!B&A1&A|!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAI22.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOI22122 -l AAOAAOI22122 -i E1 E D1 D C B1 B A1 A -o Y -f Y=!(E1&E&!D1&!D&!C&!B1&!B&!A1&!A|E1&E&D1&!D&!C&!B1&!B&!A1&!A|E1&E&D1&D&!C&!B1&!B&!A1&!A|E1&E&!D1&D&!C&!B1&!B&!A1&!A|E1&E&!D1&D&C&!B1&!B&!A1&!A|!E1&E&D1&D&C&!B1&!B&!A1&!A|E1&E&D1&D&C&!B1&!B&!A1&!A|E1&!E&D1&D&C&!B1&!B&!A1&!A|!E1&!E&D1&D&C&!B1&!B&!A1&!A|E1&E&D1&!D&C&!B1&!B&!A1&!A|E1&E&!D1&!D&C&!B1&!B&!A1&!A|E1&E&!D1&!D&C&B1&!B&!A1&!A|E1&E&D1&!D&C&B1&!B&!A1&!A|!E1&!E&D1&D&C&B1&!B&!A1&!A|E1&!E&D1&D&C&B1&!B&!A1&!A|E1&E&D1&D&C&B1&!B&!A1&!A|!E1&E&D1&D&C&B1&!B&!A1&!A|E1&E&!D1&D&C&B1&!B&!A1&!A|E1&E&!D1&D&!C&B1&!B&!A1&!A|E1&E&D1&D&!C&B1&!B&!A1&!A|E1&E&D1&!D&!C&B1&!B&!A1&!A|E1&E&!D1&!D&!C&B1&!B&!A1&!A|E1&E&!D1&!D&!C&B1&B&!A1&!A|E1&E&D1&!D&!C&B1&B&!A1&!A|!E1&!E&D1&D&!C&B1&B&!A1&!A|E1&!E&D1&D&!C&B1&B&!A1&!A|E1&E&D1&D&!C&B1&B&!A1&!A|!E1&E&D1&D&!C&B1&B&!A1&!A|E1&E&!D1&D&!C&B1&B&!A1&!A|E1&E&!D1&D&C&B1&B&!A1&!A|!E1&E&D1&D&C&B1&B&!A1&!A|E1&E&D1&D&C&B1&B&!A1&!A|E1&!E&D1&D&C&B1&B&!A1&!A|!E1&!E&D1&D&C&B1&B&!A1&!A|E1&E&D1&!D&C&B1&B&!A1&!A|E1&E&!D1&!D&C&B1&B&!A1&!A|E1&E&!D1&!D&C&!B1&B&!A1&!A|E1&E&D1&!D&C&!B1&B&!A1&!A|!E1&!E&D1&D&C&!B1&B&!A1&!A|E1&!E&D1&D&C&!B1&B&!A1&!A|E1&E&D1&D&C&!B1&B&!A1&!A|!E1&E&D1&D&C&!B1&B&!A1&!A|E1&E&!D1&D&C&!B1&B&!A1&!A|E1&E&!D1&D&!C&!B1&B&!A1&!A|E1&E&D1&D&!C&!B1&B&!A1&!A|E1&E&D1&!D&!C&!B1&B&!A1&!A|E1&E&!D1&!D&!C&!B1&B&!A1&!A|E1&E&!D1&!D&!C&!B1&B&A1&!A|E1&E&D1&!D&!C&!B1&B&A1&!A|E1&E&D1&D&!C&!B1&B&A1&!A|E1&E&!D1&D&!C&!B1&B&A1&!A|E1&E&!D1&D&C&!B1&B&A1&!A|!E1&E&D1&D&C&!B1&B&A1&!A|E1&E&D1&D&C&!B1&B&A1&!A|E1&!E&D1&D&C&!B1&B&A1&!A|!E1&!E&D1&D&C&!B1&B&A1&!A|E1&E&D1&!D&C&!B1&B&A1&!A|E1&E&!D1&!D&C&!B1&B&A1&!A|E1&E&!D1&!D&C&B1&B&A1&!A|E1&E&D1&!D&C&B1&B&A1&!A|!E1&!E&D1&D&C&B1&B&A1&!A|E1&!E&D1&D&C&B1&B&A1&!A|E1&E&D1&D&C&B1&B&A1&!A|!E1&E&D1&D&C&B1&B&A1&!A|E1&E&!D1&D&C&B1&B&A1&!A|E1&E&!D1&D&!C&B1&B&A1&!A|!E1&E&D1&D&!C&B1&B&A1&!A|E1&E&D1&D&!C&B1&B&A1&!A|E1&!E&D1&D&!C&B1&B&A1&!A|!E1&!E&D1&D&!C&B1&B&A1&!A|E1&E&D1&!D&!C&B1&B&A1&!A|E1&E&!D1&!D&!C&B1&B&A1&!A|E1&E&!D1&!D&!C&B1&!B&A1&!A|E1&E&D1&!D&!C&B1&!B&A1&!A|E1&E&D1&D&!C&B1&!B&A1&!A|E1&E&!D1&D&!C&B1&!B&A1&!A|E1&E&!D1&D&C&B1&!B&A1&!A|!E1&E&D1&D&C&B1&!B&A1&!A|E1&E&D1&D&C&B1&!B&A1&!A|E1&!E&D1&D&C&B1&!B&A1&!A|!E1&!E&D1&D&C&B1&!B&A1&!A|E1&E&D1&!D&C&B1&!B&A1&!A|E1&E&!D1&!D&C&B1&!B&A1&!A|E1&E&!D1&!D&C&!B1&!B&A1&!A|E1&E&D1&!D&C&!B1&!B&A1&!A|!E1&!E&D1&D&C&!B1&!B&A1&!A|E1&!E&D1&D&C&!B1&!B&A1&!A|E1&E&D1&D&C&!B1&!B&A1&!A|!E1&E&D1&D&C&!B1&!B&A1&!A|E1&E&!D1&D&C&!B1&!B&A1&!A|E1&E&!D1&D&!C&!B1&!B&A1&!A|E1&E&D1&D&!C&!B1&!B&A1&!A|E1&E&D1&!D&!C&!B1&!B&A1&!A|E1&E&!D1&!D&!C&!B1&!B&A1&!A|E1&E&!D1&!D&!C&!B1&!B&A1&A|E1&E&D1&!D&!C&!B1&!B&A1&A|!E1&!E&D1&D&!C&!B1&!B&A1&A|E1&!E&D1&D&!C&!B1&!B&A1&A|E1&E&D1&D&!C&!B1&!B&A1&A|!E1&E&D1&D&!C&!B1&!B&A1&A|E1&E&!D1&D&!C&!B1&!B&A1&A|E1&E&!D1&D&C&!B1&!B&A1&A|!E1&E&D1&D&C&!B1&!B&A1&A|E1&E&D1&D&C&!B1&!B&A1&A|E1&!E&D1&D&C&!B1&!B&A1&A|!E1&!E&D1&D&C&!B1&!B&A1&A|E1&E&D1&!D&C&!B1&!B&A1&A|E1&E&!D1&!D&C&!B1&!B&A1&A|E1&E&!D1&!D&C&B1&!B&A1&A|E1&E&D1&!D&C&B1&!B&A1&A|!E1&!E&D1&D&C&B1&!B&A1&A|E1&!E&D1&D&C&B1&!B&A1&A|E1&E&D1&D&C&B1&!B&A1&A|!E1&E&D1&D&C&B1&!B&A1&A|E1&E&!D1&D&C&B1&!B&A1&A|E1&E&!D1&D&!C&B1&!B&A1&A|!E1&E&D1&D&!C&B1&!B&A1&A|E1&E&D1&D&!C&B1&!B&A1&A|E1&!E&D1&D&!C&B1&!B&A1&A|!E1&!E&D1&D&!C&B1&!B&A1&A|E1&E&D1&!D&!C&B1&!B&A1&A|E1&E&!D1&!D&!C&B1&!B&A1&A|E1&E&!D1&!D&!C&B1&B&A1&A|E1&E&D1&!D&!C&B1&B&A1&A|!E1&!E&D1&D&!C&B1&B&A1&A|E1&!E&D1&D&!C&B1&B&A1&A|E1&E&D1&D&!C&B1&B&A1&A|!E1&E&D1&D&!C&B1&B&A1&A|E1&E&!D1&D&!C&B1&B&A1&A|E1&E&!D1&D&C&B1&B&A1&A|!E1&E&D1&D&C&B1&B&A1&A|E1&E&D1&D&C&B1&B&A1&A|E1&!E&D1&D&C&B1&B&A1&A|!E1&!E&D1&D&C&B1&B&A1&A|E1&E&D1&!D&C&B1&B&A1&A|E1&E&!D1&!D&C&B1&B&A1&A|E1&E&!D1&!D&C&!B1&B&A1&A|E1&E&D1&!D&C&!B1&B&A1&A|!E1&!E&D1&D&C&!B1&B&A1&A|E1&!E&D1&D&C&!B1&B&A1&A|E1&E&D1&D&C&!B1&B&A1&A|!E1&E&D1&D&C&!B1&B&A1&A|E1&E&!D1&D&C&!B1&B&A1&A|E1&E&!D1&D&!C&!B1&B&A1&A|!E1&E&D1&D&!C&!B1&B&A1&A|E1&E&D1&D&!C&!B1&B&A1&A|E1&!E&D1&D&!C&!B1&B&A1&A|!E1&!E&D1&D&!C&!B1&B&A1&A|E1&E&D1&!D&!C&!B1&B&A1&A|E1&E&!D1&!D&!C&!B1&B&A1&A|E1&E&!D1&!D&!C&!B1&B&!A1&A|E1&E&D1&!D&!C&!B1&B&!A1&A|E1&E&D1&D&!C&!B1&B&!A1&A|E1&E&!D1&D&!C&!B1&B&!A1&A|E1&E&!D1&D&C&!B1&B&!A1&A|!E1&E&D1&D&C&!B1&B&!A1&A|E1&E&D1&D&C&!B1&B&!A1&A|E1&!E&D1&D&C&!B1&B&!A1&A|!E1&!E&D1&D&C&!B1&B&!A1&A|E1&E&D1&!D&C&!B1&B&!A1&A|E1&E&!D1&!D&C&!B1&B&!A1&A|E1&E&!D1&!D&C&B1&B&!A1&A|E1&E&D1&!D&C&B1&B&!A1&A|!E1&!E&D1&D&C&B1&B&!A1&A|E1&!E&D1&D&C&B1&B&!A1&A|E1&E&D1&D&C&B1&B&!A1&A|!E1&E&D1&D&C&B1&B&!A1&A|E1&E&!D1&D&C&B1&B&!A1&A|E1&E&!D1&D&!C&B1&B&!A1&A|!E1&E&D1&D&!C&B1&B&!A1&A|E1&E&D1&D&!C&B1&B&!A1&A|E1&!E&D1&D&!C&B1&B&!A1&A|!E1&!E&D1&D&!C&B1&B&!A1&A|E1&E&D1&!D&!C&B1&B&!A1&A|E1&E&!D1&!D&!C&B1&B&!A1&A|E1&E&!D1&!D&!C&B1&!B&!A1&A|E1&E&D1&!D&!C&B1&!B&!A1&A|E1&E&D1&D&!C&B1&!B&!A1&A|E1&E&!D1&D&!C&B1&!B&!A1&A|E1&E&!D1&D&C&B1&!B&!A1&A|!E1&E&D1&D&C&B1&!B&!A1&A|E1&E&D1&D&C&B1&!B&!A1&A|E1&!E&D1&D&C&B1&!B&!A1&A|!E1&!E&D1&D&C&B1&!B&!A1&A|E1&E&D1&!D&C&B1&!B&!A1&A|E1&E&!D1&!D&C&B1&!B&!A1&A|E1&E&!D1&!D&C&!B1&!B&!A1&A|E1&E&D1&!D&C&!B1&!B&!A1&A|!E1&!E&D1&D&C&!B1&!B&!A1&A|E1&!E&D1&D&C&!B1&!B&!A1&A|E1&E&D1&D&C&!B1&!B&!A1&A|!E1&E&D1&D&C&!B1&!B&!A1&A|E1&E&!D1&D&C&!B1&!B&!A1&A|E1&E&!D1&D&!C&!B1&!B&!A1&A|E1&E&D1&D&!C&!B1&!B&!A1&A|E1&E&D1&!D&!C&!B1&!B&!A1&A|E1&E&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOI22122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOAI21221 -l OAAOOAI21221 -i E D1 D C1 C B A1 A -o Y -f Y=!(E&D1&!D&C1&C&!B&!A1&!A|E&D1&D&C1&C&!B&!A1&!A|E&!D1&D&C1&C&!B&!A1&!A|E&!D1&D&C1&C&B&!A1&!A|E&D1&D&C1&C&B&!A1&!A|E&D1&!D&C1&C&B&!A1&!A|E&D1&!D&!C1&!C&B&A1&!A|E&D1&D&!C1&!C&B&A1&!A|E&!D1&D&!C1&!C&B&A1&!A|E&!D1&D&C1&!C&B&A1&!A|E&D1&D&C1&!C&B&A1&!A|E&D1&!D&C1&!C&B&A1&!A|E&D1&!D&C1&C&B&A1&!A|E&D1&D&C1&C&B&A1&!A|E&!D1&D&C1&C&B&A1&!A|E&!D1&D&!C1&C&B&A1&!A|E&D1&D&!C1&C&B&A1&!A|E&D1&!D&!C1&C&B&A1&!A|E&!D1&D&C1&C&!B&A1&!A|E&D1&D&C1&C&!B&A1&!A|E&D1&!D&C1&C&!B&A1&!A|E&D1&!D&C1&C&!B&A1&A|E&D1&D&C1&C&!B&A1&A|E&!D1&D&C1&C&!B&A1&A|E&D1&!D&!C1&C&B&A1&A|E&D1&D&!C1&C&B&A1&A|E&!D1&D&!C1&C&B&A1&A|E&!D1&D&C1&C&B&A1&A|E&D1&D&C1&C&B&A1&A|E&D1&!D&C1&C&B&A1&A|E&D1&!D&C1&!C&B&A1&A|E&D1&D&C1&!C&B&A1&A|E&!D1&D&C1&!C&B&A1&A|E&!D1&D&!C1&!C&B&A1&A|E&D1&D&!C1&!C&B&A1&A|E&D1&!D&!C1&!C&B&A1&A|E&D1&!D&!C1&!C&B&!A1&A|E&D1&D&!C1&!C&B&!A1&A|E&!D1&D&!C1&!C&B&!A1&A|E&!D1&D&C1&!C&B&!A1&A|E&D1&D&C1&!C&B&!A1&A|E&D1&!D&C1&!C&B&!A1&A|E&D1&!D&C1&C&B&!A1&A|E&D1&D&C1&C&B&!A1&A|E&!D1&D&C1&C&B&!A1&A|E&!D1&D&!C1&C&B&!A1&A|E&D1&D&!C1&C&B&!A1&A|E&D1&!D&!C1&C&B&!A1&A|E&!D1&D&C1&C&!B&!A1&A|E&D1&D&C1&C&!B&!A1&A|E&D1&!D&C1&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOAI21221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOI221 -l OAOI221 -i C B1 B A1 A -o Y -f Y=(!C&!B1&!B&!A1&!A|!C&B1&!B&!A1&!A|!C&B1&B&!A1&!A|!C&!B1&B&!A1&!A|!C&!B1&B&A1&!A|!C&B1&!B&A1&!A|!C&!B1&!B&A1&!A|!C&!B1&!B&A1&A|!C&B1&!B&A1&A|!C&!B1&B&A1&A|!C&!B1&B&!A1&A|!C&B1&!B&!A1&A|!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOI221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOAOI33211 -l AAAOAOI33211 -i E D C1 C B2 B1 B A2 A1 A -o Y -f Y=(!E&!D&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&D&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&D&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&D&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&!C1&C&B2&!B1&!B&!A2&!A1&!A|!E&D&!C1&C&B2&!B1&!B&!A2&!A1&!A|!E&!D&C1&C&B2&!B1&!B&!A2&!A1&!A|!E&!D&C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&D&C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&D&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&!D&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&!D&!C1&!C&B2&B1&!B&!A2&!A1&!A|!E&D&!C1&!C&B2&B1&!B&!A2&!A1&!A|!E&D&C1&!C&B2&B1&!B&!A2&!A1&!A|!E&!D&C1&!C&B2&B1&!B&!A2&!A1&!A|!E&!D&C1&C&B2&B1&!B&!A2&!A1&!A|!E&D&!C1&C&B2&B1&!B&!A2&!A1&!A|!E&!D&!C1&C&B2&B1&!B&!A2&!A1&!A|!E&!D&!C1&C&!B2&B1&!B&!A2&!A1&!A|!E&D&!C1&C&!B2&B1&!B&!A2&!A1&!A|!E&!D&C1&C&!B2&B1&!B&!A2&!A1&!A|!E&!D&C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&D&C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&D&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&!D&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&!D&!C1&!C&!B2&B1&B&!A2&!A1&!A|!E&D&!C1&!C&!B2&B1&B&!A2&!A1&!A|!E&D&C1&!C&!B2&B1&B&!A2&!A1&!A|!E&!D&C1&!C&!B2&B1&B&!A2&!A1&!A|!E&!D&C1&C&!B2&B1&B&!A2&!A1&!A|!E&D&!C1&C&!B2&B1&B&!A2&!A1&!A|!E&!D&!C1&C&!B2&B1&B&!A2&!A1&!A|!E&!D&!C1&C&B2&B1&B&!A2&!A1&!A|!E&!D&C1&C&B2&B1&B&!A2&!A1&!A|!E&!D&C1&!C&B2&B1&B&!A2&!A1&!A|!E&!D&!C1&!C&B2&B1&B&!A2&!A1&!A|!E&!D&!C1&!C&B2&!B1&B&!A2&!A1&!A|!E&D&!C1&!C&B2&!B1&B&!A2&!A1&!A|!E&D&C1&!C&B2&!B1&B&!A2&!A1&!A|!E&!D&C1&!C&B2&!B1&B&!A2&!A1&!A|!E&!D&C1&C&B2&!B1&B&!A2&!A1&!A|!E&D&!C1&C&B2&!B1&B&!A2&!A1&!A|!E&!D&!C1&C&B2&!B1&B&!A2&!A1&!A|!E&!D&!C1&C&!B2&!B1&B&!A2&!A1&!A|!E&D&!C1&C&!B2&!B1&B&!A2&!A1&!A|!E&!D&C1&C&!B2&!B1&B&!A2&!A1&!A|!E&!D&C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&D&C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&D&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&!D&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&!D&!C1&!C&!B2&!B1&B&A2&!A1&!A|!E&D&!C1&!C&!B2&!B1&B&A2&!A1&!A|!E&D&C1&!C&!B2&!B1&B&A2&!A1&!A|!E&!D&C1&!C&!B2&!B1&B&A2&!A1&!A|!E&!D&C1&C&!B2&!B1&B&A2&!A1&!A|!E&D&!C1&C&!B2&!B1&B&A2&!A1&!A|!E&!D&!C1&C&!B2&!B1&B&A2&!A1&!A|!E&!D&!C1&C&B2&!B1&B&A2&!A1&!A|!E&D&!C1&C&B2&!B1&B&A2&!A1&!A|!E&!D&C1&C&B2&!B1&B&A2&!A1&!A|!E&!D&C1&!C&B2&!B1&B&A2&!A1&!A|!E&D&C1&!C&B2&!B1&B&A2&!A1&!A|!E&D&!C1&!C&B2&!B1&B&A2&!A1&!A|!E&!D&!C1&!C&B2&!B1&B&A2&!A1&!A|!E&!D&!C1&!C&B2&B1&B&A2&!A1&!A|!E&!D&C1&!C&B2&B1&B&A2&!A1&!A|!E&!D&C1&C&B2&B1&B&A2&!A1&!A|!E&!D&!C1&C&B2&B1&B&A2&!A1&!A|!E&!D&!C1&C&!B2&B1&B&A2&!A1&!A|!E&D&!C1&C&!B2&B1&B&A2&!A1&!A|!E&!D&C1&C&!B2&B1&B&A2&!A1&!A|!E&!D&C1&!C&!B2&B1&B&A2&!A1&!A|!E&D&C1&!C&!B2&B1&B&A2&!A1&!A|!E&D&!C1&!C&!B2&B1&B&A2&!A1&!A|!E&!D&!C1&!C&!B2&B1&B&A2&!A1&!A|!E&!D&!C1&!C&!B2&B1&!B&A2&!A1&!A|!E&D&!C1&!C&!B2&B1&!B&A2&!A1&!A|!E&D&C1&!C&!B2&B1&!B&A2&!A1&!A|!E&!D&C1&!C&!B2&B1&!B&A2&!A1&!A|!E&!D&C1&C&!B2&B1&!B&A2&!A1&!A|!E&D&!C1&C&!B2&B1&!B&A2&!A1&!A|!E&!D&!C1&C&!B2&B1&!B&A2&!A1&!A|!E&!D&!C1&C&B2&B1&!B&A2&!A1&!A|!E&D&!C1&C&B2&B1&!B&A2&!A1&!A|!E&!D&C1&C&B2&B1&!B&A2&!A1&!A|!E&!D&C1&!C&B2&B1&!B&A2&!A1&!A|!E&D&C1&!C&B2&B1&!B&A2&!A1&!A|!E&D&!C1&!C&B2&B1&!B&A2&!A1&!A|!E&!D&!C1&!C&B2&B1&!B&A2&!A1&!A|!E&!D&!C1&!C&B2&!B1&!B&A2&!A1&!A|!E&D&!C1&!C&B2&!B1&!B&A2&!A1&!A|!E&D&C1&!C&B2&!B1&!B&A2&!A1&!A|!E&!D&C1&!C&B2&!B1&!B&A2&!A1&!A|!E&!D&C1&C&B2&!B1&!B&A2&!A1&!A|!E&D&!C1&C&B2&!B1&!B&A2&!A1&!A|!E&!D&!C1&C&B2&!B1&!B&A2&!A1&!A|!E&!D&!C1&C&!B2&!B1&!B&A2&!A1&!A|!E&D&!C1&C&!B2&!B1&!B&A2&!A1&!A|!E&!D&C1&C&!B2&!B1&!B&A2&!A1&!A|!E&!D&C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&D&C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&D&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&!D&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&!D&!C1&!C&!B2&!B1&!B&A2&A1&!A|!E&D&!C1&!C&!B2&!B1&!B&A2&A1&!A|!E&D&C1&!C&!B2&!B1&!B&A2&A1&!A|!E&!D&C1&!C&!B2&!B1&!B&A2&A1&!A|!E&!D&C1&C&!B2&!B1&!B&A2&A1&!A|!E&D&!C1&C&!B2&!B1&!B&A2&A1&!A|!E&!D&!C1&C&!B2&!B1&!B&A2&A1&!A|!E&!D&!C1&C&B2&!B1&!B&A2&A1&!A|!E&D&!C1&C&B2&!B1&!B&A2&A1&!A|!E&!D&C1&C&B2&!B1&!B&A2&A1&!A|!E&!D&C1&!C&B2&!B1&!B&A2&A1&!A|!E&D&C1&!C&B2&!B1&!B&A2&A1&!A|!E&D&!C1&!C&B2&!B1&!B&A2&A1&!A|!E&!D&!C1&!C&B2&!B1&!B&A2&A1&!A|!E&!D&!C1&!C&B2&B1&!B&A2&A1&!A|!E&D&!C1&!C&B2&B1&!B&A2&A1&!A|!E&D&C1&!C&B2&B1&!B&A2&A1&!A|!E&!D&C1&!C&B2&B1&!B&A2&A1&!A|!E&!D&C1&C&B2&B1&!B&A2&A1&!A|!E&D&!C1&C&B2&B1&!B&A2&A1&!A|!E&!D&!C1&C&B2&B1&!B&A2&A1&!A|!E&!D&!C1&C&!B2&B1&!B&A2&A1&!A|!E&D&!C1&C&!B2&B1&!B&A2&A1&!A|!E&!D&C1&C&!B2&B1&!B&A2&A1&!A|!E&!D&C1&!C&!B2&B1&!B&A2&A1&!A|!E&D&C1&!C&!B2&B1&!B&A2&A1&!A|!E&D&!C1&!C&!B2&B1&!B&A2&A1&!A|!E&!D&!C1&!C&!B2&B1&!B&A2&A1&!A|!E&!D&!C1&!C&!B2&B1&B&A2&A1&!A|!E&D&!C1&!C&!B2&B1&B&A2&A1&!A|!E&D&C1&!C&!B2&B1&B&A2&A1&!A|!E&!D&C1&!C&!B2&B1&B&A2&A1&!A|!E&!D&C1&C&!B2&B1&B&A2&A1&!A|!E&D&!C1&C&!B2&B1&B&A2&A1&!A|!E&!D&!C1&C&!B2&B1&B&A2&A1&!A|!E&!D&!C1&C&B2&B1&B&A2&A1&!A|!E&!D&C1&C&B2&B1&B&A2&A1&!A|!E&!D&C1&!C&B2&B1&B&A2&A1&!A|!E&!D&!C1&!C&B2&B1&B&A2&A1&!A|!E&!D&!C1&!C&B2&!B1&B&A2&A1&!A|!E&D&!C1&!C&B2&!B1&B&A2&A1&!A|!E&D&C1&!C&B2&!B1&B&A2&A1&!A|!E&!D&C1&!C&B2&!B1&B&A2&A1&!A|!E&!D&C1&C&B2&!B1&B&A2&A1&!A|!E&D&!C1&C&B2&!B1&B&A2&A1&!A|!E&!D&!C1&C&B2&!B1&B&A2&A1&!A|!E&!D&!C1&C&!B2&!B1&B&A2&A1&!A|!E&D&!C1&C&!B2&!B1&B&A2&A1&!A|!E&!D&C1&C&!B2&!B1&B&A2&A1&!A|!E&!D&C1&!C&!B2&!B1&B&A2&A1&!A|!E&D&C1&!C&!B2&!B1&B&A2&A1&!A|!E&D&!C1&!C&!B2&!B1&B&A2&A1&!A|!E&!D&!C1&!C&!B2&!B1&B&A2&A1&!A|!E&!D&!C1&!C&!B2&!B1&B&!A2&A1&!A|!E&D&!C1&!C&!B2&!B1&B&!A2&A1&!A|!E&D&C1&!C&!B2&!B1&B&!A2&A1&!A|!E&!D&C1&!C&!B2&!B1&B&!A2&A1&!A|!E&!D&C1&C&!B2&!B1&B&!A2&A1&!A|!E&D&!C1&C&!B2&!B1&B&!A2&A1&!A|!E&!D&!C1&C&!B2&!B1&B&!A2&A1&!A|!E&!D&!C1&C&B2&!B1&B&!A2&A1&!A|!E&D&!C1&C&B2&!B1&B&!A2&A1&!A|!E&!D&C1&C&B2&!B1&B&!A2&A1&!A|!E&!D&C1&!C&B2&!B1&B&!A2&A1&!A|!E&D&C1&!C&B2&!B1&B&!A2&A1&!A|!E&D&!C1&!C&B2&!B1&B&!A2&A1&!A|!E&!D&!C1&!C&B2&!B1&B&!A2&A1&!A|!E&!D&!C1&!C&B2&B1&B&!A2&A1&!A|!E&!D&C1&!C&B2&B1&B&!A2&A1&!A|!E&!D&C1&C&B2&B1&B&!A2&A1&!A|!E&!D&!C1&C&B2&B1&B&!A2&A1&!A|!E&!D&!C1&C&!B2&B1&B&!A2&A1&!A|!E&D&!C1&C&!B2&B1&B&!A2&A1&!A|!E&!D&C1&C&!B2&B1&B&!A2&A1&!A|!E&!D&C1&!C&!B2&B1&B&!A2&A1&!A|!E&D&C1&!C&!B2&B1&B&!A2&A1&!A|!E&D&!C1&!C&!B2&B1&B&!A2&A1&!A|!E&!D&!C1&!C&!B2&B1&B&!A2&A1&!A|!E&!D&!C1&!C&!B2&B1&!B&!A2&A1&!A|!E&D&!C1&!C&!B2&B1&!B&!A2&A1&!A|!E&D&C1&!C&!B2&B1&!B&!A2&A1&!A|!E&!D&C1&!C&!B2&B1&!B&!A2&A1&!A|!E&!D&C1&C&!B2&B1&!B&!A2&A1&!A|!E&D&!C1&C&!B2&B1&!B&!A2&A1&!A|!E&!D&!C1&C&!B2&B1&!B&!A2&A1&!A|!E&!D&!C1&C&B2&B1&!B&!A2&A1&!A|!E&D&!C1&C&B2&B1&!B&!A2&A1&!A|!E&!D&C1&C&B2&B1&!B&!A2&A1&!A|!E&!D&C1&!C&B2&B1&!B&!A2&A1&!A|!E&D&C1&!C&B2&B1&!B&!A2&A1&!A|!E&D&!C1&!C&B2&B1&!B&!A2&A1&!A|!E&!D&!C1&!C&B2&B1&!B&!A2&A1&!A|!E&!D&!C1&!C&B2&!B1&!B&!A2&A1&!A|!E&D&!C1&!C&B2&!B1&!B&!A2&A1&!A|!E&D&C1&!C&B2&!B1&!B&!A2&A1&!A|!E&!D&C1&!C&B2&!B1&!B&!A2&A1&!A|!E&!D&C1&C&B2&!B1&!B&!A2&A1&!A|!E&D&!C1&C&B2&!B1&!B&!A2&A1&!A|!E&!D&!C1&C&B2&!B1&!B&!A2&A1&!A|!E&!D&!C1&C&!B2&!B1&!B&!A2&A1&!A|!E&D&!C1&C&!B2&!B1&!B&!A2&A1&!A|!E&!D&C1&C&!B2&!B1&!B&!A2&A1&!A|!E&!D&C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&D&C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&D&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&!D&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&!D&!C1&!C&!B2&!B1&!B&!A2&A1&A|!E&D&!C1&!C&!B2&!B1&!B&!A2&A1&A|!E&D&C1&!C&!B2&!B1&!B&!A2&A1&A|!E&!D&C1&!C&!B2&!B1&!B&!A2&A1&A|!E&!D&C1&C&!B2&!B1&!B&!A2&A1&A|!E&D&!C1&C&!B2&!B1&!B&!A2&A1&A|!E&!D&!C1&C&!B2&!B1&!B&!A2&A1&A|!E&!D&!C1&C&B2&!B1&!B&!A2&A1&A|!E&D&!C1&C&B2&!B1&!B&!A2&A1&A|!E&!D&C1&C&B2&!B1&!B&!A2&A1&A|!E&!D&C1&!C&B2&!B1&!B&!A2&A1&A|!E&D&C1&!C&B2&!B1&!B&!A2&A1&A|!E&D&!C1&!C&B2&!B1&!B&!A2&A1&A|!E&!D&!C1&!C&B2&!B1&!B&!A2&A1&A|!E&!D&!C1&!C&B2&B1&!B&!A2&A1&A|!E&D&!C1&!C&B2&B1&!B&!A2&A1&A|!E&D&C1&!C&B2&B1&!B&!A2&A1&A|!E&!D&C1&!C&B2&B1&!B&!A2&A1&A|!E&!D&C1&C&B2&B1&!B&!A2&A1&A|!E&D&!C1&C&B2&B1&!B&!A2&A1&A|!E&!D&!C1&C&B2&B1&!B&!A2&A1&A|!E&!D&!C1&C&!B2&B1&!B&!A2&A1&A|!E&D&!C1&C&!B2&B1&!B&!A2&A1&A|!E&!D&C1&C&!B2&B1&!B&!A2&A1&A|!E&!D&C1&!C&!B2&B1&!B&!A2&A1&A|!E&D&C1&!C&!B2&B1&!B&!A2&A1&A|!E&D&!C1&!C&!B2&B1&!B&!A2&A1&A|!E&!D&!C1&!C&!B2&B1&!B&!A2&A1&A|!E&!D&!C1&!C&!B2&B1&B&!A2&A1&A|!E&D&!C1&!C&!B2&B1&B&!A2&A1&A|!E&D&C1&!C&!B2&B1&B&!A2&A1&A|!E&!D&C1&!C&!B2&B1&B&!A2&A1&A|!E&!D&C1&C&!B2&B1&B&!A2&A1&A|!E&D&!C1&C&!B2&B1&B&!A2&A1&A|!E&!D&!C1&C&!B2&B1&B&!A2&A1&A|!E&!D&!C1&C&B2&B1&B&!A2&A1&A|!E&!D&C1&C&B2&B1&B&!A2&A1&A|!E&!D&C1&!C&B2&B1&B&!A2&A1&A|!E&!D&!C1&!C&B2&B1&B&!A2&A1&A|!E&!D&!C1&!C&B2&!B1&B&!A2&A1&A|!E&D&!C1&!C&B2&!B1&B&!A2&A1&A|!E&D&C1&!C&B2&!B1&B&!A2&A1&A|!E&!D&C1&!C&B2&!B1&B&!A2&A1&A|!E&!D&C1&C&B2&!B1&B&!A2&A1&A|!E&D&!C1&C&B2&!B1&B&!A2&A1&A|!E&!D&!C1&C&B2&!B1&B&!A2&A1&A|!E&!D&!C1&C&!B2&!B1&B&!A2&A1&A|!E&D&!C1&C&!B2&!B1&B&!A2&A1&A|!E&!D&C1&C&!B2&!B1&B&!A2&A1&A|!E&!D&C1&!C&!B2&!B1&B&!A2&A1&A|!E&D&C1&!C&!B2&!B1&B&!A2&A1&A|!E&D&!C1&!C&!B2&!B1&B&!A2&A1&A|!E&!D&!C1&!C&!B2&!B1&B&!A2&A1&A|!E&!D&!C1&!C&!B2&!B1&B&A2&A1&A|!E&!D&C1&!C&!B2&!B1&B&A2&A1&A|!E&!D&C1&C&!B2&!B1&B&A2&A1&A|!E&!D&!C1&C&!B2&!B1&B&A2&A1&A|!E&!D&!C1&C&B2&!B1&B&A2&A1&A|!E&!D&C1&C&B2&!B1&B&A2&A1&A|!E&!D&C1&!C&B2&!B1&B&A2&A1&A|!E&!D&!C1&!C&B2&!B1&B&A2&A1&A|!E&!D&!C1&!C&B2&B1&B&A2&A1&A|!E&!D&C1&!C&B2&B1&B&A2&A1&A|!E&!D&C1&C&B2&B1&B&A2&A1&A|!E&!D&!C1&C&B2&B1&B&A2&A1&A|!E&!D&!C1&C&!B2&B1&B&A2&A1&A|!E&!D&C1&C&!B2&B1&B&A2&A1&A|!E&!D&C1&!C&!B2&B1&B&A2&A1&A|!E&!D&!C1&!C&!B2&B1&B&A2&A1&A|!E&!D&!C1&!C&!B2&B1&!B&A2&A1&A|!E&!D&C1&!C&!B2&B1&!B&A2&A1&A|!E&!D&C1&C&!B2&B1&!B&A2&A1&A|!E&!D&!C1&C&!B2&B1&!B&A2&A1&A|!E&!D&!C1&C&B2&B1&!B&A2&A1&A|!E&!D&C1&C&B2&B1&!B&A2&A1&A|!E&!D&C1&!C&B2&B1&!B&A2&A1&A|!E&!D&!C1&!C&B2&B1&!B&A2&A1&A|!E&!D&!C1&!C&B2&!B1&!B&A2&A1&A|!E&!D&C1&!C&B2&!B1&!B&A2&A1&A|!E&!D&C1&C&B2&!B1&!B&A2&A1&A|!E&!D&!C1&C&B2&!B1&!B&A2&A1&A|!E&!D&!C1&C&!B2&!B1&!B&A2&A1&A|!E&!D&C1&C&!B2&!B1&!B&A2&A1&A|!E&!D&C1&!C&!B2&!B1&!B&A2&A1&A|!E&!D&!C1&!C&!B2&!B1&!B&A2&A1&A|!E&!D&!C1&!C&!B2&!B1&!B&A2&!A1&A|!E&D&!C1&!C&!B2&!B1&!B&A2&!A1&A|!E&D&C1&!C&!B2&!B1&!B&A2&!A1&A|!E&!D&C1&!C&!B2&!B1&!B&A2&!A1&A|!E&!D&C1&C&!B2&!B1&!B&A2&!A1&A|!E&D&!C1&C&!B2&!B1&!B&A2&!A1&A|!E&!D&!C1&C&!B2&!B1&!B&A2&!A1&A|!E&!D&!C1&C&B2&!B1&!B&A2&!A1&A|!E&D&!C1&C&B2&!B1&!B&A2&!A1&A|!E&!D&C1&C&B2&!B1&!B&A2&!A1&A|!E&!D&C1&!C&B2&!B1&!B&A2&!A1&A|!E&D&C1&!C&B2&!B1&!B&A2&!A1&A|!E&D&!C1&!C&B2&!B1&!B&A2&!A1&A|!E&!D&!C1&!C&B2&!B1&!B&A2&!A1&A|!E&!D&!C1&!C&B2&B1&!B&A2&!A1&A|!E&D&!C1&!C&B2&B1&!B&A2&!A1&A|!E&D&C1&!C&B2&B1&!B&A2&!A1&A|!E&!D&C1&!C&B2&B1&!B&A2&!A1&A|!E&!D&C1&C&B2&B1&!B&A2&!A1&A|!E&D&!C1&C&B2&B1&!B&A2&!A1&A|!E&!D&!C1&C&B2&B1&!B&A2&!A1&A|!E&!D&!C1&C&!B2&B1&!B&A2&!A1&A|!E&D&!C1&C&!B2&B1&!B&A2&!A1&A|!E&!D&C1&C&!B2&B1&!B&A2&!A1&A|!E&!D&C1&!C&!B2&B1&!B&A2&!A1&A|!E&D&C1&!C&!B2&B1&!B&A2&!A1&A|!E&D&!C1&!C&!B2&B1&!B&A2&!A1&A|!E&!D&!C1&!C&!B2&B1&!B&A2&!A1&A|!E&!D&!C1&!C&!B2&B1&B&A2&!A1&A|!E&D&!C1&!C&!B2&B1&B&A2&!A1&A|!E&D&C1&!C&!B2&B1&B&A2&!A1&A|!E&!D&C1&!C&!B2&B1&B&A2&!A1&A|!E&!D&C1&C&!B2&B1&B&A2&!A1&A|!E&D&!C1&C&!B2&B1&B&A2&!A1&A|!E&!D&!C1&C&!B2&B1&B&A2&!A1&A|!E&!D&!C1&C&B2&B1&B&A2&!A1&A|!E&!D&C1&C&B2&B1&B&A2&!A1&A|!E&!D&C1&!C&B2&B1&B&A2&!A1&A|!E&!D&!C1&!C&B2&B1&B&A2&!A1&A|!E&!D&!C1&!C&B2&!B1&B&A2&!A1&A|!E&D&!C1&!C&B2&!B1&B&A2&!A1&A|!E&D&C1&!C&B2&!B1&B&A2&!A1&A|!E&!D&C1&!C&B2&!B1&B&A2&!A1&A|!E&!D&C1&C&B2&!B1&B&A2&!A1&A|!E&D&!C1&C&B2&!B1&B&A2&!A1&A|!E&!D&!C1&C&B2&!B1&B&A2&!A1&A|!E&!D&!C1&C&!B2&!B1&B&A2&!A1&A|!E&D&!C1&C&!B2&!B1&B&A2&!A1&A|!E&!D&C1&C&!B2&!B1&B&A2&!A1&A|!E&!D&C1&!C&!B2&!B1&B&A2&!A1&A|!E&D&C1&!C&!B2&!B1&B&A2&!A1&A|!E&D&!C1&!C&!B2&!B1&B&A2&!A1&A|!E&!D&!C1&!C&!B2&!B1&B&A2&!A1&A|!E&!D&!C1&!C&!B2&!B1&B&!A2&!A1&A|!E&D&!C1&!C&!B2&!B1&B&!A2&!A1&A|!E&D&C1&!C&!B2&!B1&B&!A2&!A1&A|!E&!D&C1&!C&!B2&!B1&B&!A2&!A1&A|!E&!D&C1&C&!B2&!B1&B&!A2&!A1&A|!E&D&!C1&C&!B2&!B1&B&!A2&!A1&A|!E&!D&!C1&C&!B2&!B1&B&!A2&!A1&A|!E&!D&!C1&C&B2&!B1&B&!A2&!A1&A|!E&D&!C1&C&B2&!B1&B&!A2&!A1&A|!E&!D&C1&C&B2&!B1&B&!A2&!A1&A|!E&!D&C1&!C&B2&!B1&B&!A2&!A1&A|!E&D&C1&!C&B2&!B1&B&!A2&!A1&A|!E&D&!C1&!C&B2&!B1&B&!A2&!A1&A|!E&!D&!C1&!C&B2&!B1&B&!A2&!A1&A|!E&!D&!C1&!C&B2&B1&B&!A2&!A1&A|!E&!D&C1&!C&B2&B1&B&!A2&!A1&A|!E&!D&C1&C&B2&B1&B&!A2&!A1&A|!E&!D&!C1&C&B2&B1&B&!A2&!A1&A|!E&!D&!C1&C&!B2&B1&B&!A2&!A1&A|!E&D&!C1&C&!B2&B1&B&!A2&!A1&A|!E&!D&C1&C&!B2&B1&B&!A2&!A1&A|!E&!D&C1&!C&!B2&B1&B&!A2&!A1&A|!E&D&C1&!C&!B2&B1&B&!A2&!A1&A|!E&D&!C1&!C&!B2&B1&B&!A2&!A1&A|!E&!D&!C1&!C&!B2&B1&B&!A2&!A1&A|!E&!D&!C1&!C&!B2&B1&!B&!A2&!A1&A|!E&D&!C1&!C&!B2&B1&!B&!A2&!A1&A|!E&D&C1&!C&!B2&B1&!B&!A2&!A1&A|!E&!D&C1&!C&!B2&B1&!B&!A2&!A1&A|!E&!D&C1&C&!B2&B1&!B&!A2&!A1&A|!E&D&!C1&C&!B2&B1&!B&!A2&!A1&A|!E&!D&!C1&C&!B2&B1&!B&!A2&!A1&A|!E&!D&!C1&C&B2&B1&!B&!A2&!A1&A|!E&D&!C1&C&B2&B1&!B&!A2&!A1&A|!E&!D&C1&C&B2&B1&!B&!A2&!A1&A|!E&!D&C1&!C&B2&B1&!B&!A2&!A1&A|!E&D&C1&!C&B2&B1&!B&!A2&!A1&A|!E&D&!C1&!C&B2&B1&!B&!A2&!A1&A|!E&!D&!C1&!C&B2&B1&!B&!A2&!A1&A|!E&!D&!C1&!C&B2&!B1&!B&!A2&!A1&A|!E&D&!C1&!C&B2&!B1&!B&!A2&!A1&A|!E&D&C1&!C&B2&!B1&!B&!A2&!A1&A|!E&!D&C1&!C&B2&!B1&!B&!A2&!A1&A|!E&!D&C1&C&B2&!B1&!B&!A2&!A1&A|!E&D&!C1&C&B2&!B1&!B&!A2&!A1&A|!E&!D&!C1&C&B2&!B1&!B&!A2&!A1&A|!E&!D&!C1&C&!B2&!B1&!B&!A2&!A1&A|!E&D&!C1&C&!B2&!B1&!B&!A2&!A1&A|!E&!D&C1&C&!B2&!B1&!B&!A2&!A1&A|!E&!D&C1&!C&!B2&!B1&!B&!A2&!A1&A|!E&D&C1&!C&!B2&!B1&!B&!A2&!A1&A|!E&D&!C1&!C&!B2&!B1&!B&!A2&!A1&A|!E&!D&!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOAOI33211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOOAI2222 -l AOOOAI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=!(D1&!D&!C1&C&B1&!B&!A1&!A|D1&D&!C1&C&B1&!B&!A1&!A|!D1&D&!C1&C&B1&!B&!A1&!A|!D1&D&C1&C&B1&!B&!A1&!A|D1&D&C1&C&B1&!B&!A1&!A|D1&!D&C1&C&B1&!B&!A1&!A|D1&!D&C1&!C&B1&!B&!A1&!A|D1&D&C1&!C&B1&!B&!A1&!A|!D1&D&C1&!C&B1&!B&!A1&!A|!D1&D&C1&!C&B1&B&!A1&!A|D1&D&C1&!C&B1&B&!A1&!A|D1&!D&C1&!C&B1&B&!A1&!A|D1&!D&C1&C&B1&B&!A1&!A|D1&D&C1&C&B1&B&!A1&!A|!D1&D&C1&C&B1&B&!A1&!A|!D1&D&!C1&C&B1&B&!A1&!A|D1&D&!C1&C&B1&B&!A1&!A|D1&!D&!C1&C&B1&B&!A1&!A|D1&!D&!C1&C&!B1&B&!A1&!A|D1&D&!C1&C&!B1&B&!A1&!A|!D1&D&!C1&C&!B1&B&!A1&!A|!D1&D&C1&C&!B1&B&!A1&!A|D1&D&C1&C&!B1&B&!A1&!A|D1&!D&C1&C&!B1&B&!A1&!A|D1&!D&C1&!C&!B1&B&!A1&!A|D1&D&C1&!C&!B1&B&!A1&!A|!D1&D&C1&!C&!B1&B&!A1&!A|!D1&D&C1&!C&!B1&B&A1&!A|D1&D&C1&!C&!B1&B&A1&!A|D1&!D&C1&!C&!B1&B&A1&!A|D1&!D&C1&C&!B1&B&A1&!A|D1&D&C1&C&!B1&B&A1&!A|!D1&D&C1&C&!B1&B&A1&!A|!D1&D&!C1&C&!B1&B&A1&!A|D1&D&!C1&C&!B1&B&A1&!A|D1&!D&!C1&C&!B1&B&A1&!A|D1&!D&!C1&C&B1&B&A1&!A|D1&D&!C1&C&B1&B&A1&!A|!D1&D&!C1&C&B1&B&A1&!A|!D1&D&C1&C&B1&B&A1&!A|D1&D&C1&C&B1&B&A1&!A|D1&!D&C1&C&B1&B&A1&!A|D1&!D&C1&!C&B1&B&A1&!A|D1&D&C1&!C&B1&B&A1&!A|!D1&D&C1&!C&B1&B&A1&!A|!D1&D&C1&!C&B1&!B&A1&!A|D1&D&C1&!C&B1&!B&A1&!A|D1&!D&C1&!C&B1&!B&A1&!A|D1&!D&C1&C&B1&!B&A1&!A|D1&D&C1&C&B1&!B&A1&!A|!D1&D&C1&C&B1&!B&A1&!A|!D1&D&!C1&C&B1&!B&A1&!A|D1&D&!C1&C&B1&!B&A1&!A|D1&!D&!C1&C&B1&!B&A1&!A|!D1&D&C1&!C&!B1&!B&A1&A|D1&D&C1&!C&!B1&!B&A1&A|D1&!D&C1&!C&!B1&!B&A1&A|D1&!D&C1&C&!B1&!B&A1&A|D1&D&C1&C&!B1&!B&A1&A|!D1&D&C1&C&!B1&!B&A1&A|!D1&D&!C1&C&!B1&!B&A1&A|D1&D&!C1&C&!B1&!B&A1&A|D1&!D&!C1&C&!B1&!B&A1&A|D1&!D&!C1&C&B1&!B&A1&A|D1&D&!C1&C&B1&!B&A1&A|!D1&D&!C1&C&B1&!B&A1&A|!D1&D&C1&C&B1&!B&A1&A|D1&D&C1&C&B1&!B&A1&A|D1&!D&C1&C&B1&!B&A1&A|D1&!D&C1&!C&B1&!B&A1&A|D1&D&C1&!C&B1&!B&A1&A|!D1&D&C1&!C&B1&!B&A1&A|!D1&D&C1&!C&B1&B&A1&A|D1&D&C1&!C&B1&B&A1&A|D1&!D&C1&!C&B1&B&A1&A|D1&!D&C1&C&B1&B&A1&A|D1&D&C1&C&B1&B&A1&A|!D1&D&C1&C&B1&B&A1&A|!D1&D&!C1&C&B1&B&A1&A|D1&D&!C1&C&B1&B&A1&A|D1&!D&!C1&C&B1&B&A1&A|D1&!D&!C1&C&!B1&B&A1&A|D1&D&!C1&C&!B1&B&A1&A|!D1&D&!C1&C&!B1&B&A1&A|!D1&D&C1&C&!B1&B&A1&A|D1&D&C1&C&!B1&B&A1&A|D1&!D&C1&C&!B1&B&A1&A|D1&!D&C1&!C&!B1&B&A1&A|D1&D&C1&!C&!B1&B&A1&A|!D1&D&C1&!C&!B1&B&A1&A|!D1&D&C1&!C&!B1&B&!A1&A|D1&D&C1&!C&!B1&B&!A1&A|D1&!D&C1&!C&!B1&B&!A1&A|D1&!D&C1&C&!B1&B&!A1&A|D1&D&C1&C&!B1&B&!A1&A|!D1&D&C1&C&!B1&B&!A1&A|!D1&D&!C1&C&!B1&B&!A1&A|D1&D&!C1&C&!B1&B&!A1&A|D1&!D&!C1&C&!B1&B&!A1&A|D1&!D&!C1&C&B1&B&!A1&A|D1&D&!C1&C&B1&B&!A1&A|!D1&D&!C1&C&B1&B&!A1&A|!D1&D&C1&C&B1&B&!A1&A|D1&D&C1&C&B1&B&!A1&A|D1&!D&C1&C&B1&B&!A1&A|D1&!D&C1&!C&B1&B&!A1&A|D1&D&C1&!C&B1&B&!A1&A|!D1&D&C1&!C&B1&B&!A1&A|!D1&D&C1&!C&B1&!B&!A1&A|D1&D&C1&!C&B1&!B&!A1&A|D1&!D&C1&!C&B1&!B&!A1&A|D1&!D&C1&C&B1&!B&!A1&A|D1&D&C1&C&B1&!B&!A1&A|!D1&D&C1&C&B1&!B&!A1&A|!D1&D&!C1&C&B1&!B&!A1&A|D1&D&!C1&C&B1&!B&!A1&A|D1&!D&!C1&C&B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOOAI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOI2212 -l AOAAOI2212 -i D1 D C B1 B A1 A -o Y -f Y=(!D1&!D&!C&!B1&!B&!A1&!A|D1&!D&!C&!B1&!B&!A1&!A|!D1&D&!C&!B1&!B&!A1&!A|!D1&D&C&!B1&!B&!A1&!A|D1&!D&C&!B1&!B&!A1&!A|!D1&!D&C&!B1&!B&!A1&!A|!D1&D&!C&B1&!B&!A1&!A|D1&!D&!C&B1&!B&!A1&!A|!D1&!D&!C&B1&!B&!A1&!A|!D1&!D&!C&B1&B&!A1&!A|D1&!D&!C&B1&B&!A1&!A|!D1&D&!C&B1&B&!A1&!A|!D1&D&!C&!B1&B&!A1&!A|D1&!D&!C&!B1&B&!A1&!A|!D1&!D&!C&!B1&B&!A1&!A|!D1&!D&!C&!B1&B&A1&!A|D1&!D&!C&!B1&B&A1&!A|!D1&D&!C&!B1&B&A1&!A|!D1&D&!C&B1&B&A1&!A|D1&!D&!C&B1&B&A1&!A|!D1&!D&!C&B1&B&A1&!A|!D1&!D&!C&B1&!B&A1&!A|D1&!D&!C&B1&!B&A1&!A|!D1&D&!C&B1&!B&A1&!A|!D1&!D&C&!B1&!B&A1&!A|D1&!D&C&!B1&!B&A1&!A|!D1&D&C&!B1&!B&A1&!A|!D1&D&!C&!B1&!B&A1&!A|D1&!D&!C&!B1&!B&A1&!A|!D1&!D&!C&!B1&!B&A1&!A|!D1&!D&!C&!B1&!B&A1&A|D1&!D&!C&!B1&!B&A1&A|!D1&D&!C&!B1&!B&A1&A|!D1&D&!C&B1&!B&A1&A|D1&!D&!C&B1&!B&A1&A|!D1&!D&!C&B1&!B&A1&A|!D1&!D&!C&B1&B&A1&A|D1&!D&!C&B1&B&A1&A|!D1&D&!C&B1&B&A1&A|!D1&D&!C&!B1&B&A1&A|D1&!D&!C&!B1&B&A1&A|!D1&!D&!C&!B1&B&A1&A|!D1&!D&!C&!B1&B&!A1&A|D1&!D&!C&!B1&B&!A1&A|!D1&D&!C&!B1&B&!A1&A|!D1&D&!C&B1&B&!A1&A|D1&!D&!C&B1&B&!A1&A|!D1&!D&!C&B1&B&!A1&A|!D1&!D&!C&B1&!B&!A1&A|D1&!D&!C&B1&!B&!A1&A|!D1&D&!C&B1&!B&!A1&A|!D1&!D&C&!B1&!B&!A1&A|D1&!D&C&!B1&!B&!A1&A|!D1&D&C&!B1&!B&!A1&A|!D1&D&!C&!B1&!B&!A1&A|D1&!D&!C&!B1&!B&!A1&A|!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOI2212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOOAOI222311 -l OOAAOOAOI222311 -i F E D2 D1 D C1 C B1 B A1 A -o Y -f Y=(!F&!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!F&E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!F&E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!F&E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!F&E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!F&!E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!F&!E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|!F&E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|!F&E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!F&E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!F&E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!F&E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!F&E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!F&E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!F&!E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!F&!E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|!F&!E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|!F&!E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|!F&!E&D2&D1&D&C1&C&!B1&!B&!A1&!A|!F&!E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!F&E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!F&E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!F&!E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!F&!E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|!F&E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|!F&E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!F&E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!F&E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!F&E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!F&E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!F&E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!F&E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!F&!E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!F&!E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|!F&E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|!F&E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!F&!E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!F&!E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|!F&E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|!F&E&D2&D1&D&!C1&C&B1&!B&!A1&!A|!F&!E&D2&D1&D&!C1&C&B1&!B&!A1&!A|!F&!E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|!F&E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|!F&E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!F&!E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!F&!E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|!F&!E&D2&!D1&D&C1&C&B1&!B&!A1&!A|!F&!E&D2&D1&D&C1&C&B1&!B&!A1&!A|!F&!E&!D2&D1&D&C1&C&B1&!B&!A1&!A|!F&!E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|!F&!E&D2&D1&!D&C1&C&B1&!B&!A1&!A|!F&!E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|!F&E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!F&E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!F&E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!F&!E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!F&!E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|!F&E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|!F&E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!F&!E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!F&!E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|!F&E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|!F&E&D2&D1&D&C1&!C&B1&!B&!A1&!A|!F&!E&D2&D1&D&C1&!C&B1&!B&!A1&!A|!F&!E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|!F&E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|!F&E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!F&!E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!F&!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!F&E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!F&E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!F&!E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!F&!E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|!F&E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|!F&E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!F&E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!F&E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!F&E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!F&E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!F&E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!F&E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!F&!E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!F&!E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|!F&E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|!F&E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!F&!E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!F&!E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|!F&E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|!F&E&D2&D1&D&!C1&!C&B1&B&!A1&!A|!F&!E&D2&D1&D&!C1&!C&B1&B&!A1&!A|!F&!E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|!F&E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|!F&E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!F&!E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!F&!E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|!F&E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|!F&E&D2&!D1&D&C1&!C&B1&B&!A1&!A|!F&!E&D2&!D1&D&C1&!C&B1&B&!A1&!A|!F&!E&D2&D1&D&C1&!C&B1&B&!A1&!A|!F&E&D2&D1&D&C1&!C&B1&B&!A1&!A|!F&E&!D2&D1&D&C1&!C&B1&B&!A1&!A|!F&!E&!D2&D1&D&C1&!C&B1&B&!A1&!A|!F&!E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|!F&E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|!F&E&D2&D1&!D&C1&!C&B1&B&!A1&!A|!F&!E&D2&D1&!D&C1&!C&B1&B&!A1&!A|!F&!E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|!F&E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|!F&E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!F&!E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!F&!E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|!F&E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|!F&!E&D2&!D1&!D&C1&C&B1&B&!A1&!A|!F&!E&D2&D1&!D&C1&C&B1&B&!A1&!A|!F&!E&!D2&D1&!D&C1&C&B1&B&!A1&!A|!F&!E&!D2&D1&D&C1&C&B1&B&!A1&!A|!F&!E&D2&D1&D&C1&C&B1&B&!A1&!A|!F&!E&D2&!D1&D&C1&C&B1&B&!A1&!A|!F&!E&!D2&!D1&D&C1&C&B1&B&!A1&!A|!F&!E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|!F&E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|!F&E&D2&!D1&D&!C1&C&B1&B&!A1&!A|!F&!E&D2&!D1&D&!C1&C&B1&B&!A1&!A|!F&!E&D2&D1&D&!C1&C&B1&B&!A1&!A|!F&E&D2&D1&D&!C1&C&B1&B&!A1&!A|!F&E&!D2&D1&D&!C1&C&B1&B&!A1&!A|!F&!E&!D2&D1&D&!C1&C&B1&B&!A1&!A|!F&!E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|!F&E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|!F&E&D2&D1&!D&!C1&C&B1&B&!A1&!A|!F&!E&D2&D1&!D&!C1&C&B1&B&!A1&!A|!F&!E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|!F&E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|!F&E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!F&E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!F&E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!F&!E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!F&!E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|!F&E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|!F&E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!F&!E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!F&!E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|!F&E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|!F&E&D2&D1&D&!C1&C&!B1&B&!A1&!A|!F&!E&D2&D1&D&!C1&C&!B1&B&!A1&!A|!F&!E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|!F&E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|!F&E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!F&!E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!F&!E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|!F&!E&D2&!D1&D&C1&C&!B1&B&!A1&!A|!F&!E&D2&D1&D&C1&C&!B1&B&!A1&!A|!F&!E&!D2&D1&D&C1&C&!B1&B&!A1&!A|!F&!E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|!F&!E&D2&D1&!D&C1&C&!B1&B&!A1&!A|!F&!E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|!F&E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!F&!E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!F&!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!F&E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!F&E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!F&!E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!F&!E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|!F&E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|!F&E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!F&!E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!F&!E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|!F&E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|!F&E&D2&D1&D&C1&!C&!B1&B&!A1&!A|!F&!E&D2&D1&D&C1&!C&!B1&B&!A1&!A|!F&!E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|!F&E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|!F&E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!F&!E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!F&!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!F&E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!F&E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!F&!E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!F&!E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|!F&E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|!F&E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!F&E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!F&E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!F&E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!F&E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!F&E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!F&!E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!F&!E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|!F&!E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|!F&!E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|!F&!E&D2&D1&D&!C1&!C&!B1&B&A1&!A|!F&!E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|!F&!E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|!F&!E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|!F&!E&D2&!D1&D&C1&!C&!B1&B&A1&!A|!F&!E&D2&D1&D&C1&!C&!B1&B&A1&!A|!F&!E&!D2&D1&D&C1&!C&!B1&B&A1&!A|!F&!E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|!F&!E&D2&D1&!D&C1&!C&!B1&B&A1&!A|!F&!E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|!F&E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!F&!E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!F&!E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|!F&E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|!F&!E&D2&!D1&!D&C1&C&!B1&B&A1&!A|!F&!E&D2&D1&!D&C1&C&!B1&B&A1&!A|!F&!E&!D2&D1&!D&C1&C&!B1&B&A1&!A|!F&!E&!D2&D1&D&C1&C&!B1&B&A1&!A|!F&!E&D2&D1&D&C1&C&!B1&B&A1&!A|!F&!E&D2&!D1&D&C1&C&!B1&B&A1&!A|!F&!E&!D2&!D1&D&C1&C&!B1&B&A1&!A|!F&!E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|!F&!E&D2&!D1&D&!C1&C&!B1&B&A1&!A|!F&!E&D2&D1&D&!C1&C&!B1&B&A1&!A|!F&!E&!D2&D1&D&!C1&C&!B1&B&A1&!A|!F&!E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|!F&!E&D2&D1&!D&!C1&C&!B1&B&A1&!A|!F&!E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|!F&E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!F&!E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!F&!E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|!F&E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|!F&!E&D2&!D1&!D&!C1&C&B1&B&A1&!A|!F&!E&D2&D1&!D&!C1&C&B1&B&A1&!A|!F&!E&!D2&D1&!D&!C1&C&B1&B&A1&!A|!F&!E&!D2&D1&D&!C1&C&B1&B&A1&!A|!F&!E&D2&D1&D&!C1&C&B1&B&A1&!A|!F&!E&D2&!D1&D&!C1&C&B1&B&A1&!A|!F&!E&!D2&!D1&D&!C1&C&B1&B&A1&!A|!F&!E&!D2&!D1&D&C1&C&B1&B&A1&!A|!F&!E&D2&!D1&D&C1&C&B1&B&A1&!A|!F&!E&D2&D1&D&C1&C&B1&B&A1&!A|!F&!E&!D2&D1&D&C1&C&B1&B&A1&!A|!F&!E&!D2&D1&!D&C1&C&B1&B&A1&!A|!F&!E&D2&D1&!D&C1&C&B1&B&A1&!A|!F&!E&D2&!D1&!D&C1&C&B1&B&A1&!A|!F&E&!D2&!D1&!D&C1&C&B1&B&A1&!A|!F&!E&!D2&!D1&!D&C1&C&B1&B&A1&!A|!F&!E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|!F&E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|!F&!E&D2&!D1&!D&C1&!C&B1&B&A1&!A|!F&!E&D2&D1&!D&C1&!C&B1&B&A1&!A|!F&!E&!D2&D1&!D&C1&!C&B1&B&A1&!A|!F&!E&!D2&D1&D&C1&!C&B1&B&A1&!A|!F&!E&D2&D1&D&C1&!C&B1&B&A1&!A|!F&!E&D2&!D1&D&C1&!C&B1&B&A1&!A|!F&!E&!D2&!D1&D&C1&!C&B1&B&A1&!A|!F&!E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|!F&!E&D2&!D1&D&!C1&!C&B1&B&A1&!A|!F&!E&D2&D1&D&!C1&!C&B1&B&A1&!A|!F&!E&!D2&D1&D&!C1&!C&B1&B&A1&!A|!F&!E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|!F&!E&D2&D1&!D&!C1&!C&B1&B&A1&!A|!F&!E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|!F&E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!F&E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!F&!E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!F&!E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|!F&!E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|!F&!E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|!F&!E&D2&D1&D&!C1&!C&B1&!B&A1&!A|!F&!E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|!F&!E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|!F&!E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|!F&!E&D2&!D1&D&C1&!C&B1&!B&A1&!A|!F&!E&D2&D1&D&C1&!C&B1&!B&A1&!A|!F&!E&!D2&D1&D&C1&!C&B1&!B&A1&!A|!F&!E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|!F&!E&D2&D1&!D&C1&!C&B1&!B&A1&!A|!F&!E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|!F&E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!F&!E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!F&!E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|!F&E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|!F&!E&D2&!D1&!D&C1&C&B1&!B&A1&!A|!F&!E&D2&D1&!D&C1&C&B1&!B&A1&!A|!F&!E&!D2&D1&!D&C1&C&B1&!B&A1&!A|!F&!E&!D2&D1&D&C1&C&B1&!B&A1&!A|!F&!E&D2&D1&D&C1&C&B1&!B&A1&!A|!F&!E&D2&!D1&D&C1&C&B1&!B&A1&!A|!F&!E&!D2&!D1&D&C1&C&B1&!B&A1&!A|!F&!E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|!F&!E&D2&!D1&D&!C1&C&B1&!B&A1&!A|!F&!E&D2&D1&D&!C1&C&B1&!B&A1&!A|!F&!E&!D2&D1&D&!C1&C&B1&!B&A1&!A|!F&!E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|!F&!E&D2&D1&!D&!C1&C&B1&!B&A1&!A|!F&!E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|!F&E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!F&!E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!F&!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!F&E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!F&E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!F&!E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!F&!E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|!F&E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|!F&E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!F&!E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!F&!E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|!F&E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|!F&E&D2&D1&D&!C1&C&!B1&!B&A1&!A|!F&!E&D2&D1&D&!C1&C&!B1&!B&A1&!A|!F&!E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|!F&E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|!F&E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!F&!E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!F&!E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|!F&!E&D2&!D1&D&C1&C&!B1&!B&A1&!A|!F&!E&D2&D1&D&C1&C&!B1&!B&A1&!A|!F&!E&!D2&D1&D&C1&C&!B1&!B&A1&!A|!F&!E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|!F&!E&D2&D1&!D&C1&C&!B1&!B&A1&!A|!F&!E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|!F&E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!F&!E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!F&!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!F&E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!F&E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!F&!E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!F&!E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|!F&E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|!F&E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!F&!E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!F&!E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|!F&E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|!F&E&D2&D1&D&C1&!C&!B1&!B&A1&!A|!F&!E&D2&D1&D&C1&!C&!B1&!B&A1&!A|!F&!E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|!F&E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|!F&E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!F&!E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!F&!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!F&E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!F&E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!F&!E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!F&!E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|!F&E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|!F&E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!F&E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!F&E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!F&E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!F&E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!F&E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!F&E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!F&!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!F&!E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|!F&E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|!F&E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!F&!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!F&!E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|!F&E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|!F&E&D2&D1&D&!C1&!C&!B1&!B&A1&A|!F&!E&D2&D1&D&!C1&!C&!B1&!B&A1&A|!F&!E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|!F&E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|!F&E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!F&!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!F&!E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|!F&E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|!F&E&D2&!D1&D&C1&!C&!B1&!B&A1&A|!F&!E&D2&!D1&D&C1&!C&!B1&!B&A1&A|!F&!E&D2&D1&D&C1&!C&!B1&!B&A1&A|!F&E&D2&D1&D&C1&!C&!B1&!B&A1&A|!F&E&!D2&D1&D&C1&!C&!B1&!B&A1&A|!F&!E&!D2&D1&D&C1&!C&!B1&!B&A1&A|!F&!E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|!F&E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|!F&E&D2&D1&!D&C1&!C&!B1&!B&A1&A|!F&!E&D2&D1&!D&C1&!C&!B1&!B&A1&A|!F&!E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|!F&E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|!F&E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!F&!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!F&!E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|!F&E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|!F&!E&D2&!D1&!D&C1&C&!B1&!B&A1&A|!F&!E&D2&D1&!D&C1&C&!B1&!B&A1&A|!F&!E&!D2&D1&!D&C1&C&!B1&!B&A1&A|!F&!E&!D2&D1&D&C1&C&!B1&!B&A1&A|!F&!E&D2&D1&D&C1&C&!B1&!B&A1&A|!F&!E&D2&!D1&D&C1&C&!B1&!B&A1&A|!F&!E&!D2&!D1&D&C1&C&!B1&!B&A1&A|!F&!E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|!F&E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|!F&E&D2&!D1&D&!C1&C&!B1&!B&A1&A|!F&!E&D2&!D1&D&!C1&C&!B1&!B&A1&A|!F&!E&D2&D1&D&!C1&C&!B1&!B&A1&A|!F&E&D2&D1&D&!C1&C&!B1&!B&A1&A|!F&E&!D2&D1&D&!C1&C&!B1&!B&A1&A|!F&!E&!D2&D1&D&!C1&C&!B1&!B&A1&A|!F&!E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|!F&E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|!F&E&D2&D1&!D&!C1&C&!B1&!B&A1&A|!F&!E&D2&D1&!D&!C1&C&!B1&!B&A1&A|!F&!E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|!F&E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|!F&E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!F&!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!F&!E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|!F&E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|!F&!E&D2&!D1&!D&!C1&C&B1&!B&A1&A|!F&!E&D2&D1&!D&!C1&C&B1&!B&A1&A|!F&!E&!D2&D1&!D&!C1&C&B1&!B&A1&A|!F&!E&!D2&D1&D&!C1&C&B1&!B&A1&A|!F&!E&D2&D1&D&!C1&C&B1&!B&A1&A|!F&!E&D2&!D1&D&!C1&C&B1&!B&A1&A|!F&!E&!D2&!D1&D&!C1&C&B1&!B&A1&A|!F&!E&!D2&!D1&D&C1&C&B1&!B&A1&A|!F&!E&D2&!D1&D&C1&C&B1&!B&A1&A|!F&!E&D2&D1&D&C1&C&B1&!B&A1&A|!F&!E&!D2&D1&D&C1&C&B1&!B&A1&A|!F&!E&!D2&D1&!D&C1&C&B1&!B&A1&A|!F&!E&D2&D1&!D&C1&C&B1&!B&A1&A|!F&!E&D2&!D1&!D&C1&C&B1&!B&A1&A|!F&E&!D2&!D1&!D&C1&C&B1&!B&A1&A|!F&!E&!D2&!D1&!D&C1&C&B1&!B&A1&A|!F&!E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|!F&E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|!F&!E&D2&!D1&!D&C1&!C&B1&!B&A1&A|!F&!E&D2&D1&!D&C1&!C&B1&!B&A1&A|!F&!E&!D2&D1&!D&C1&!C&B1&!B&A1&A|!F&!E&!D2&D1&D&C1&!C&B1&!B&A1&A|!F&!E&D2&D1&D&C1&!C&B1&!B&A1&A|!F&!E&D2&!D1&D&C1&!C&B1&!B&A1&A|!F&!E&!D2&!D1&D&C1&!C&B1&!B&A1&A|!F&!E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|!F&!E&D2&!D1&D&!C1&!C&B1&!B&A1&A|!F&!E&D2&D1&D&!C1&!C&B1&!B&A1&A|!F&!E&!D2&D1&D&!C1&!C&B1&!B&A1&A|!F&!E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|!F&!E&D2&D1&!D&!C1&!C&B1&!B&A1&A|!F&!E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|!F&E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!F&!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!F&!E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!F&E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!F&!E&D2&!D1&!D&!C1&!C&B1&B&A1&A|!F&!E&D2&D1&!D&!C1&!C&B1&B&A1&A|!F&!E&!D2&D1&!D&!C1&!C&B1&B&A1&A|!F&!E&!D2&D1&D&!C1&!C&B1&B&A1&A|!F&!E&D2&D1&D&!C1&!C&B1&B&A1&A|!F&!E&D2&!D1&D&!C1&!C&B1&B&A1&A|!F&!E&!D2&!D1&D&!C1&!C&B1&B&A1&A|!F&!E&!D2&!D1&D&C1&!C&B1&B&A1&A|!F&!E&D2&!D1&D&C1&!C&B1&B&A1&A|!F&!E&D2&D1&D&C1&!C&B1&B&A1&A|!F&!E&!D2&D1&D&C1&!C&B1&B&A1&A|!F&!E&!D2&D1&!D&C1&!C&B1&B&A1&A|!F&!E&D2&D1&!D&C1&!C&B1&B&A1&A|!F&!E&D2&!D1&!D&C1&!C&B1&B&A1&A|!F&E&!D2&!D1&!D&C1&!C&B1&B&A1&A|!F&!E&!D2&!D1&!D&C1&!C&B1&B&A1&A|!F&!E&!D2&!D1&!D&C1&C&B1&B&A1&A|!F&E&!D2&!D1&!D&C1&C&B1&B&A1&A|!F&!E&D2&!D1&!D&C1&C&B1&B&A1&A|!F&!E&D2&D1&!D&C1&C&B1&B&A1&A|!F&!E&!D2&D1&!D&C1&C&B1&B&A1&A|!F&!E&!D2&D1&D&C1&C&B1&B&A1&A|!F&!E&D2&D1&D&C1&C&B1&B&A1&A|!F&!E&D2&!D1&D&C1&C&B1&B&A1&A|!F&!E&!D2&!D1&D&C1&C&B1&B&A1&A|!F&!E&!D2&!D1&D&!C1&C&B1&B&A1&A|!F&!E&D2&!D1&D&!C1&C&B1&B&A1&A|!F&!E&D2&D1&D&!C1&C&B1&B&A1&A|!F&!E&!D2&D1&D&!C1&C&B1&B&A1&A|!F&!E&!D2&D1&!D&!C1&C&B1&B&A1&A|!F&!E&D2&D1&!D&!C1&C&B1&B&A1&A|!F&!E&D2&!D1&!D&!C1&C&B1&B&A1&A|!F&E&!D2&!D1&!D&!C1&C&B1&B&A1&A|!F&!E&!D2&!D1&!D&!C1&C&B1&B&A1&A|!F&!E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|!F&E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|!F&!E&D2&!D1&!D&!C1&C&!B1&B&A1&A|!F&!E&D2&D1&!D&!C1&C&!B1&B&A1&A|!F&!E&!D2&D1&!D&!C1&C&!B1&B&A1&A|!F&!E&!D2&D1&D&!C1&C&!B1&B&A1&A|!F&!E&D2&D1&D&!C1&C&!B1&B&A1&A|!F&!E&D2&!D1&D&!C1&C&!B1&B&A1&A|!F&!E&!D2&!D1&D&!C1&C&!B1&B&A1&A|!F&!E&!D2&!D1&D&C1&C&!B1&B&A1&A|!F&!E&D2&!D1&D&C1&C&!B1&B&A1&A|!F&!E&D2&D1&D&C1&C&!B1&B&A1&A|!F&!E&!D2&D1&D&C1&C&!B1&B&A1&A|!F&!E&!D2&D1&!D&C1&C&!B1&B&A1&A|!F&!E&D2&D1&!D&C1&C&!B1&B&A1&A|!F&!E&D2&!D1&!D&C1&C&!B1&B&A1&A|!F&E&!D2&!D1&!D&C1&C&!B1&B&A1&A|!F&!E&!D2&!D1&!D&C1&C&!B1&B&A1&A|!F&!E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|!F&E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|!F&!E&D2&!D1&!D&C1&!C&!B1&B&A1&A|!F&!E&D2&D1&!D&C1&!C&!B1&B&A1&A|!F&!E&!D2&D1&!D&C1&!C&!B1&B&A1&A|!F&!E&!D2&D1&D&C1&!C&!B1&B&A1&A|!F&!E&D2&D1&D&C1&!C&!B1&B&A1&A|!F&!E&D2&!D1&D&C1&!C&!B1&B&A1&A|!F&!E&!D2&!D1&D&C1&!C&!B1&B&A1&A|!F&!E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|!F&!E&D2&!D1&D&!C1&!C&!B1&B&A1&A|!F&!E&D2&D1&D&!C1&!C&!B1&B&A1&A|!F&!E&!D2&D1&D&!C1&!C&!B1&B&A1&A|!F&!E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|!F&!E&D2&D1&!D&!C1&!C&!B1&B&A1&A|!F&!E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|!F&E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!F&!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!F&!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!F&E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!F&!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!F&!E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|!F&!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|!F&!E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|!F&!E&D2&D1&D&!C1&!C&!B1&B&!A1&A|!F&!E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|!F&!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|!F&!E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|!F&!E&D2&!D1&D&C1&!C&!B1&B&!A1&A|!F&!E&D2&D1&D&C1&!C&!B1&B&!A1&A|!F&!E&!D2&D1&D&C1&!C&!B1&B&!A1&A|!F&!E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|!F&!E&D2&D1&!D&C1&!C&!B1&B&!A1&A|!F&!E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|!F&E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!F&!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!F&!E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|!F&E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|!F&!E&D2&!D1&!D&C1&C&!B1&B&!A1&A|!F&!E&D2&D1&!D&C1&C&!B1&B&!A1&A|!F&!E&!D2&D1&!D&C1&C&!B1&B&!A1&A|!F&!E&!D2&D1&D&C1&C&!B1&B&!A1&A|!F&!E&D2&D1&D&C1&C&!B1&B&!A1&A|!F&!E&D2&!D1&D&C1&C&!B1&B&!A1&A|!F&!E&!D2&!D1&D&C1&C&!B1&B&!A1&A|!F&!E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|!F&!E&D2&!D1&D&!C1&C&!B1&B&!A1&A|!F&!E&D2&D1&D&!C1&C&!B1&B&!A1&A|!F&!E&!D2&D1&D&!C1&C&!B1&B&!A1&A|!F&!E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|!F&!E&D2&D1&!D&!C1&C&!B1&B&!A1&A|!F&!E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|!F&E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!F&!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!F&!E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|!F&E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|!F&!E&D2&!D1&!D&!C1&C&B1&B&!A1&A|!F&!E&D2&D1&!D&!C1&C&B1&B&!A1&A|!F&!E&!D2&D1&!D&!C1&C&B1&B&!A1&A|!F&!E&!D2&D1&D&!C1&C&B1&B&!A1&A|!F&!E&D2&D1&D&!C1&C&B1&B&!A1&A|!F&!E&D2&!D1&D&!C1&C&B1&B&!A1&A|!F&!E&!D2&!D1&D&!C1&C&B1&B&!A1&A|!F&!E&!D2&!D1&D&C1&C&B1&B&!A1&A|!F&!E&D2&!D1&D&C1&C&B1&B&!A1&A|!F&!E&D2&D1&D&C1&C&B1&B&!A1&A|!F&!E&!D2&D1&D&C1&C&B1&B&!A1&A|!F&!E&!D2&D1&!D&C1&C&B1&B&!A1&A|!F&!E&D2&D1&!D&C1&C&B1&B&!A1&A|!F&!E&D2&!D1&!D&C1&C&B1&B&!A1&A|!F&E&!D2&!D1&!D&C1&C&B1&B&!A1&A|!F&!E&!D2&!D1&!D&C1&C&B1&B&!A1&A|!F&!E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|!F&E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|!F&!E&D2&!D1&!D&C1&!C&B1&B&!A1&A|!F&!E&D2&D1&!D&C1&!C&B1&B&!A1&A|!F&!E&!D2&D1&!D&C1&!C&B1&B&!A1&A|!F&!E&!D2&D1&D&C1&!C&B1&B&!A1&A|!F&!E&D2&D1&D&C1&!C&B1&B&!A1&A|!F&!E&D2&!D1&D&C1&!C&B1&B&!A1&A|!F&!E&!D2&!D1&D&C1&!C&B1&B&!A1&A|!F&!E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|!F&!E&D2&!D1&D&!C1&!C&B1&B&!A1&A|!F&!E&D2&D1&D&!C1&!C&B1&B&!A1&A|!F&!E&!D2&D1&D&!C1&!C&B1&B&!A1&A|!F&!E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|!F&!E&D2&D1&!D&!C1&!C&B1&B&!A1&A|!F&!E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|!F&E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!F&!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!F&!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!F&E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!F&!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!F&!E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|!F&!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|!F&!E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|!F&!E&D2&D1&D&!C1&!C&B1&!B&!A1&A|!F&!E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|!F&!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|!F&!E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|!F&!E&D2&!D1&D&C1&!C&B1&!B&!A1&A|!F&!E&D2&D1&D&C1&!C&B1&!B&!A1&A|!F&!E&!D2&D1&D&C1&!C&B1&!B&!A1&A|!F&!E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|!F&!E&D2&D1&!D&C1&!C&B1&!B&!A1&A|!F&!E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|!F&E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!F&!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!F&!E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|!F&E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|!F&!E&D2&!D1&!D&C1&C&B1&!B&!A1&A|!F&!E&D2&D1&!D&C1&C&B1&!B&!A1&A|!F&!E&!D2&D1&!D&C1&C&B1&!B&!A1&A|!F&!E&!D2&D1&D&C1&C&B1&!B&!A1&A|!F&!E&D2&D1&D&C1&C&B1&!B&!A1&A|!F&!E&D2&!D1&D&C1&C&B1&!B&!A1&A|!F&!E&!D2&!D1&D&C1&C&B1&!B&!A1&A|!F&!E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|!F&!E&D2&!D1&D&!C1&C&B1&!B&!A1&A|!F&!E&D2&D1&D&!C1&C&B1&!B&!A1&A|!F&!E&!D2&D1&D&!C1&C&B1&!B&!A1&A|!F&!E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|!F&!E&D2&D1&!D&!C1&C&B1&!B&!A1&A|!F&!E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|!F&E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!F&!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!F&!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!F&E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!F&E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!F&!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!F&!E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|!F&E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|!F&E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!F&!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!F&!E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|!F&E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|!F&E&D2&D1&D&!C1&C&!B1&!B&!A1&A|!F&!E&D2&D1&D&!C1&C&!B1&!B&!A1&A|!F&!E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|!F&E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|!F&E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!F&!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!F&!E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|!F&!E&D2&!D1&D&C1&C&!B1&!B&!A1&A|!F&!E&D2&D1&D&C1&C&!B1&!B&!A1&A|!F&!E&!D2&D1&D&C1&C&!B1&!B&!A1&A|!F&!E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|!F&!E&D2&D1&!D&C1&C&!B1&!B&!A1&A|!F&!E&D2&!D1&!D&C1&C&!B1&!B&!A1&A|!F&E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!F&!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!F&!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!F&E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!F&E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!F&!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!F&!E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|!F&E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|!F&E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!F&!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!F&!E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|!F&E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|!F&E&D2&D1&D&C1&!C&!B1&!B&!A1&A|!F&!E&D2&D1&D&C1&!C&!B1&!B&!A1&A|!F&!E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|!F&E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|!F&E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!F&!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!F&!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!F&E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!F&E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!F&!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!F&!E&D2&D1&D&!C1&!C&!B1&!B&!A1&A|!F&E&D2&D1&D&!C1&!C&!B1&!B&!A1&A|!F&E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!F&!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!F&!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!F&E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!F&E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!F&!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!F&!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!F&E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!F&E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!F&!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOOAOI222311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAAOI2232 -l OOAAAOI2232 -i D1 D C2 C1 C B1 B A1 A -o Y -f Y=(!D1&!D&!C2&!C1&!C&!B1&!B&!A1&!A|D1&!D&!C2&!C1&!C&!B1&!B&!A1&!A|!D1&D&!C2&!C1&!C&!B1&!B&!A1&!A|!D1&D&C2&!C1&!C&!B1&!B&!A1&!A|D1&!D&C2&!C1&!C&!B1&!B&!A1&!A|!D1&!D&C2&!C1&!C&!B1&!B&!A1&!A|!D1&!D&C2&C1&!C&!B1&!B&!A1&!A|D1&!D&C2&C1&!C&!B1&!B&!A1&!A|!D1&D&C2&C1&!C&!B1&!B&!A1&!A|!D1&D&!C2&C1&!C&!B1&!B&!A1&!A|D1&!D&!C2&C1&!C&!B1&!B&!A1&!A|!D1&!D&!C2&C1&!C&!B1&!B&!A1&!A|!D1&!D&!C2&C1&C&!B1&!B&!A1&!A|D1&!D&!C2&C1&C&!B1&!B&!A1&!A|!D1&D&!C2&C1&C&!B1&!B&!A1&!A|!D1&!D&C2&!C1&C&!B1&!B&!A1&!A|D1&!D&C2&!C1&C&!B1&!B&!A1&!A|!D1&D&C2&!C1&C&!B1&!B&!A1&!A|!D1&D&!C2&!C1&C&!B1&!B&!A1&!A|D1&!D&!C2&!C1&C&!B1&!B&!A1&!A|!D1&!D&!C2&!C1&C&!B1&!B&!A1&!A|!D1&!D&!C2&!C1&C&B1&!B&!A1&!A|D1&!D&!C2&!C1&C&B1&!B&!A1&!A|!D1&D&!C2&!C1&C&B1&!B&!A1&!A|!D1&D&C2&!C1&C&B1&!B&!A1&!A|D1&!D&C2&!C1&C&B1&!B&!A1&!A|!D1&!D&C2&!C1&C&B1&!B&!A1&!A|!D1&D&!C2&C1&C&B1&!B&!A1&!A|D1&!D&!C2&C1&C&B1&!B&!A1&!A|!D1&!D&!C2&C1&C&B1&!B&!A1&!A|!D1&!D&!C2&C1&!C&B1&!B&!A1&!A|D1&!D&!C2&C1&!C&B1&!B&!A1&!A|!D1&D&!C2&C1&!C&B1&!B&!A1&!A|!D1&D&C2&C1&!C&B1&!B&!A1&!A|D1&!D&C2&C1&!C&B1&!B&!A1&!A|!D1&!D&C2&C1&!C&B1&!B&!A1&!A|!D1&!D&C2&!C1&!C&B1&!B&!A1&!A|D1&!D&C2&!C1&!C&B1&!B&!A1&!A|!D1&D&C2&!C1&!C&B1&!B&!A1&!A|!D1&D&!C2&!C1&!C&B1&!B&!A1&!A|D1&!D&!C2&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C2&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C2&!C1&!C&B1&B&!A1&!A|D1&!D&!C2&!C1&!C&B1&B&!A1&!A|!D1&D&!C2&!C1&!C&B1&B&!A1&!A|!D1&D&C2&!C1&!C&B1&B&!A1&!A|D1&!D&C2&!C1&!C&B1&B&!A1&!A|!D1&!D&C2&!C1&!C&B1&B&!A1&!A|!D1&!D&C2&C1&!C&B1&B&!A1&!A|D1&!D&C2&C1&!C&B1&B&!A1&!A|!D1&D&C2&C1&!C&B1&B&!A1&!A|!D1&D&!C2&C1&!C&B1&B&!A1&!A|D1&!D&!C2&C1&!C&B1&B&!A1&!A|!D1&!D&!C2&C1&!C&B1&B&!A1&!A|!D1&!D&!C2&C1&C&B1&B&!A1&!A|D1&!D&!C2&C1&C&B1&B&!A1&!A|!D1&D&!C2&C1&C&B1&B&!A1&!A|!D1&!D&C2&!C1&C&B1&B&!A1&!A|D1&!D&C2&!C1&C&B1&B&!A1&!A|!D1&D&C2&!C1&C&B1&B&!A1&!A|!D1&D&!C2&!C1&C&B1&B&!A1&!A|D1&!D&!C2&!C1&C&B1&B&!A1&!A|!D1&!D&!C2&!C1&C&B1&B&!A1&!A|!D1&!D&!C2&!C1&C&!B1&B&!A1&!A|D1&!D&!C2&!C1&C&!B1&B&!A1&!A|!D1&D&!C2&!C1&C&!B1&B&!A1&!A|!D1&D&C2&!C1&C&!B1&B&!A1&!A|D1&!D&C2&!C1&C&!B1&B&!A1&!A|!D1&!D&C2&!C1&C&!B1&B&!A1&!A|!D1&D&!C2&C1&C&!B1&B&!A1&!A|D1&!D&!C2&C1&C&!B1&B&!A1&!A|!D1&!D&!C2&C1&C&!B1&B&!A1&!A|!D1&!D&!C2&C1&!C&!B1&B&!A1&!A|D1&!D&!C2&C1&!C&!B1&B&!A1&!A|!D1&D&!C2&C1&!C&!B1&B&!A1&!A|!D1&D&C2&C1&!C&!B1&B&!A1&!A|D1&!D&C2&C1&!C&!B1&B&!A1&!A|!D1&!D&C2&C1&!C&!B1&B&!A1&!A|!D1&!D&C2&!C1&!C&!B1&B&!A1&!A|D1&!D&C2&!C1&!C&!B1&B&!A1&!A|!D1&D&C2&!C1&!C&!B1&B&!A1&!A|!D1&D&!C2&!C1&!C&!B1&B&!A1&!A|D1&!D&!C2&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C2&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C2&!C1&C&!B1&!B&A1&!A|D1&!D&!C2&!C1&C&!B1&!B&A1&!A|!D1&D&!C2&!C1&C&!B1&!B&A1&!A|!D1&D&C2&!C1&C&!B1&!B&A1&!A|D1&!D&C2&!C1&C&!B1&!B&A1&!A|!D1&!D&C2&!C1&C&!B1&!B&A1&!A|!D1&D&!C2&C1&C&!B1&!B&A1&!A|D1&!D&!C2&C1&C&!B1&!B&A1&!A|!D1&!D&!C2&C1&C&!B1&!B&A1&!A|!D1&!D&!C2&C1&!C&!B1&!B&A1&!A|D1&!D&!C2&C1&!C&!B1&!B&A1&!A|!D1&D&!C2&C1&!C&!B1&!B&A1&!A|!D1&D&C2&C1&!C&!B1&!B&A1&!A|D1&!D&C2&C1&!C&!B1&!B&A1&!A|!D1&!D&C2&C1&!C&!B1&!B&A1&!A|!D1&!D&C2&!C1&!C&!B1&!B&A1&!A|D1&!D&C2&!C1&!C&!B1&!B&A1&!A|!D1&D&C2&!C1&!C&!B1&!B&A1&!A|!D1&D&!C2&!C1&!C&!B1&!B&A1&!A|D1&!D&!C2&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C2&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C2&!C1&!C&!B1&!B&A1&A|D1&!D&!C2&!C1&!C&!B1&!B&A1&A|!D1&D&!C2&!C1&!C&!B1&!B&A1&A|!D1&D&C2&!C1&!C&!B1&!B&A1&A|D1&!D&C2&!C1&!C&!B1&!B&A1&A|!D1&!D&C2&!C1&!C&!B1&!B&A1&A|!D1&!D&C2&C1&!C&!B1&!B&A1&A|D1&!D&C2&C1&!C&!B1&!B&A1&A|!D1&D&C2&C1&!C&!B1&!B&A1&A|!D1&D&!C2&C1&!C&!B1&!B&A1&A|D1&!D&!C2&C1&!C&!B1&!B&A1&A|!D1&!D&!C2&C1&!C&!B1&!B&A1&A|!D1&!D&!C2&C1&C&!B1&!B&A1&A|D1&!D&!C2&C1&C&!B1&!B&A1&A|!D1&D&!C2&C1&C&!B1&!B&A1&A|!D1&!D&C2&!C1&C&!B1&!B&A1&A|D1&!D&C2&!C1&C&!B1&!B&A1&A|!D1&D&C2&!C1&C&!B1&!B&A1&A|!D1&D&!C2&!C1&C&!B1&!B&A1&A|D1&!D&!C2&!C1&C&!B1&!B&A1&A|!D1&!D&!C2&!C1&C&!B1&!B&A1&A|!D1&!D&!C2&!C1&C&!B1&!B&!A1&A|D1&!D&!C2&!C1&C&!B1&!B&!A1&A|!D1&D&!C2&!C1&C&!B1&!B&!A1&A|!D1&D&C2&!C1&C&!B1&!B&!A1&A|D1&!D&C2&!C1&C&!B1&!B&!A1&A|!D1&!D&C2&!C1&C&!B1&!B&!A1&A|!D1&D&!C2&C1&C&!B1&!B&!A1&A|D1&!D&!C2&C1&C&!B1&!B&!A1&A|!D1&!D&!C2&C1&C&!B1&!B&!A1&A|!D1&!D&!C2&C1&!C&!B1&!B&!A1&A|D1&!D&!C2&C1&!C&!B1&!B&!A1&A|!D1&D&!C2&C1&!C&!B1&!B&!A1&A|!D1&D&C2&C1&!C&!B1&!B&!A1&A|D1&!D&C2&C1&!C&!B1&!B&!A1&A|!D1&!D&C2&C1&!C&!B1&!B&!A1&A|!D1&!D&C2&!C1&!C&!B1&!B&!A1&A|D1&!D&C2&!C1&!C&!B1&!B&!A1&A|!D1&D&C2&!C1&!C&!B1&!B&!A1&A|!D1&D&!C2&!C1&!C&!B1&!B&!A1&A|D1&!D&!C2&!C1&!C&!B1&!B&!A1&A|!D1&!D&!C2&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAAOI2232.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAOI22212 -l AAOOAOI22212 -i E1 E D C1 C B1 B A1 A -o Y -f Y=(!E1&!E&!D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D&C1&C&!B1&!B&!A1&!A|!E1&!E&D&C1&C&!B1&!B&!A1&!A|!E1&!E&D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D&!C1&C&B1&!B&!A1&!A|!E1&!E&D&!C1&C&B1&!B&!A1&!A|!E1&!E&D&C1&C&B1&!B&!A1&!A|!E1&!E&!D&C1&C&B1&!B&!A1&!A|!E1&!E&!D&C1&!C&B1&!B&!A1&!A|!E1&!E&D&C1&!C&B1&!B&!A1&!A|!E1&!E&D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D&!C1&!C&B1&B&!A1&!A|!E1&!E&D&!C1&!C&B1&B&!A1&!A|!E1&!E&!D&C1&!C&B1&B&!A1&!A|!E1&!E&!D&C1&C&B1&B&!A1&!A|!E1&!E&!D&!C1&C&B1&B&!A1&!A|!E1&!E&!D&!C1&C&!B1&B&!A1&!A|!E1&!E&D&!C1&C&!B1&B&!A1&!A|!E1&!E&D&C1&C&!B1&B&!A1&!A|!E1&!E&!D&C1&C&!B1&B&!A1&!A|!E1&!E&!D&C1&!C&!B1&B&!A1&!A|!E1&!E&D&C1&!C&!B1&B&!A1&!A|!E1&!E&D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D&!C1&!C&!B1&B&A1&!A|!E1&!E&D&!C1&!C&!B1&B&A1&!A|!E1&!E&D&C1&!C&!B1&B&A1&!A|!E1&!E&!D&C1&!C&!B1&B&A1&!A|!E1&!E&!D&C1&C&!B1&B&A1&!A|!E1&!E&D&C1&C&!B1&B&A1&!A|!E1&!E&D&!C1&C&!B1&B&A1&!A|!E1&!E&!D&!C1&C&!B1&B&A1&!A|!E1&!E&!D&!C1&C&B1&B&A1&!A|!E1&!E&!D&C1&C&B1&B&A1&!A|!E1&!E&!D&C1&!C&B1&B&A1&!A|!E1&!E&D&!C1&!C&B1&B&A1&!A|!E1&!E&!D&!C1&!C&B1&B&A1&!A|!E1&!E&!D&!C1&!C&B1&!B&A1&!A|!E1&!E&D&!C1&!C&B1&!B&A1&!A|!E1&!E&D&C1&!C&B1&!B&A1&!A|!E1&!E&!D&C1&!C&B1&!B&A1&!A|!E1&!E&!D&C1&C&B1&!B&A1&!A|!E1&!E&D&C1&C&B1&!B&A1&!A|!E1&!E&D&!C1&C&B1&!B&A1&!A|!E1&!E&!D&!C1&C&B1&!B&A1&!A|!E1&!E&!D&!C1&C&!B1&!B&A1&!A|!E1&!E&D&!C1&C&!B1&!B&A1&!A|!E1&!E&D&C1&C&!B1&!B&A1&!A|!E1&!E&!D&C1&C&!B1&!B&A1&!A|!E1&!E&!D&C1&!C&!B1&!B&A1&!A|!E1&!E&D&C1&!C&!B1&!B&A1&!A|!E1&!E&D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D&!C1&!C&!B1&!B&A1&A|!E1&!E&D&!C1&!C&!B1&!B&A1&A|!E1&!E&!D&C1&!C&!B1&!B&A1&A|!E1&!E&!D&C1&C&!B1&!B&A1&A|!E1&!E&!D&!C1&C&!B1&!B&A1&A|!E1&!E&!D&!C1&C&B1&!B&A1&A|!E1&!E&!D&C1&C&B1&!B&A1&A|!E1&!E&!D&C1&!C&B1&!B&A1&A|!E1&!E&D&!C1&!C&B1&!B&A1&A|!E1&!E&!D&!C1&!C&B1&!B&A1&A|!E1&!E&!D&!C1&!C&B1&B&A1&A|!E1&!E&D&!C1&!C&B1&B&A1&A|!E1&!E&!D&C1&!C&B1&B&A1&A|!E1&!E&!D&C1&C&B1&B&A1&A|!E1&!E&!D&!C1&C&B1&B&A1&A|!E1&!E&!D&!C1&C&!B1&B&A1&A|!E1&!E&!D&C1&C&!B1&B&A1&A|!E1&!E&!D&C1&!C&!B1&B&A1&A|!E1&!E&D&!C1&!C&!B1&B&A1&A|!E1&!E&!D&!C1&!C&!B1&B&A1&A|!E1&!E&!D&!C1&!C&!B1&B&!A1&A|!E1&!E&D&!C1&!C&!B1&B&!A1&A|!E1&!E&D&C1&!C&!B1&B&!A1&A|!E1&!E&!D&C1&!C&!B1&B&!A1&A|!E1&!E&!D&C1&C&!B1&B&!A1&A|!E1&!E&D&C1&C&!B1&B&!A1&A|!E1&!E&D&!C1&C&!B1&B&!A1&A|!E1&!E&!D&!C1&C&!B1&B&!A1&A|!E1&!E&!D&!C1&C&B1&B&!A1&A|!E1&!E&!D&C1&C&B1&B&!A1&A|!E1&!E&!D&C1&!C&B1&B&!A1&A|!E1&!E&D&!C1&!C&B1&B&!A1&A|!E1&!E&!D&!C1&!C&B1&B&!A1&A|!E1&!E&!D&!C1&!C&B1&!B&!A1&A|!E1&!E&D&!C1&!C&B1&!B&!A1&A|!E1&!E&D&C1&!C&B1&!B&!A1&A|!E1&!E&!D&C1&!C&B1&!B&!A1&A|!E1&!E&!D&C1&C&B1&!B&!A1&A|!E1&!E&D&C1&C&B1&!B&!A1&A|!E1&!E&D&!C1&C&B1&!B&!A1&A|!E1&!E&!D&!C1&C&B1&!B&!A1&A|!E1&!E&!D&!C1&C&!B1&!B&!A1&A|!E1&!E&D&!C1&C&!B1&!B&!A1&A|!E1&!E&D&C1&C&!B1&!B&!A1&A|!E1&!E&!D&C1&C&!B1&!B&!A1&A|!E1&!E&!D&C1&!C&!B1&!B&!A1&A|!E1&!E&D&C1&!C&!B1&!B&!A1&A|!E1&!E&D&!C1&!C&!B1&!B&!A1&A|!E1&!E&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAOI22212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOAAOAI211121 -l OAOAAOAI211121 -i F E1 E D C B A1 A -o Y -f Y=!(F&!E1&E&D&!C&!B&!A1&!A|F&E1&E&D&!C&!B&!A1&!A|F&E1&!E&D&!C&!B&!A1&!A|F&E1&!E&D&C&!B&!A1&!A|F&E1&E&D&C&!B&!A1&!A|F&!E1&E&D&C&!B&!A1&!A|F&E1&!E&!D&C&B&!A1&!A|F&E1&E&!D&C&B&!A1&!A|F&!E1&E&!D&C&B&!A1&!A|F&!E1&E&D&C&B&!A1&!A|F&E1&E&D&C&B&!A1&!A|F&E1&!E&D&C&B&!A1&!A|F&E1&!E&D&!C&B&!A1&!A|F&E1&E&D&!C&B&!A1&!A|F&!E1&E&D&!C&B&!A1&!A|F&!E1&E&D&!C&B&A1&!A|F&E1&E&D&!C&B&A1&!A|F&E1&!E&D&!C&B&A1&!A|F&E1&!E&D&C&B&A1&!A|F&E1&E&D&C&B&A1&!A|F&!E1&E&D&C&B&A1&!A|F&!E1&E&!D&C&B&A1&!A|F&E1&E&!D&C&B&A1&!A|F&E1&!E&!D&C&B&A1&!A|F&!E1&E&D&C&!B&A1&!A|F&E1&E&D&C&!B&A1&!A|F&E1&!E&D&C&!B&A1&!A|F&E1&!E&D&!C&!B&A1&!A|F&E1&E&D&!C&!B&A1&!A|F&!E1&E&D&!C&!B&A1&!A|F&!E1&E&D&!C&!B&A1&A|F&E1&E&D&!C&!B&A1&A|F&E1&!E&D&!C&!B&A1&A|F&E1&!E&D&C&!B&A1&A|F&E1&E&D&C&!B&A1&A|F&!E1&E&D&C&!B&A1&A|F&!E1&E&!D&C&!B&A1&A|F&E1&E&!D&C&!B&A1&A|F&E1&!E&!D&C&!B&A1&A|F&E1&!E&!D&C&B&A1&A|F&E1&E&!D&C&B&A1&A|F&!E1&E&!D&C&B&A1&A|F&!E1&E&D&C&B&A1&A|F&E1&E&D&C&B&A1&A|F&E1&!E&D&C&B&A1&A|F&E1&!E&D&!C&B&A1&A|F&E1&E&D&!C&B&A1&A|F&!E1&E&D&!C&B&A1&A|F&!E1&E&D&!C&B&!A1&A|F&E1&E&D&!C&B&!A1&A|F&E1&!E&D&!C&B&!A1&A|F&E1&!E&D&C&B&!A1&A|F&E1&E&D&C&B&!A1&A|F&!E1&E&D&C&B&!A1&A|F&!E1&E&!D&C&B&!A1&A|F&E1&E&!D&C&B&!A1&A|F&E1&!E&!D&C&B&!A1&A|F&!E1&E&D&C&!B&!A1&A|F&E1&E&D&C&!B&!A1&A|F&E1&!E&D&C&!B&!A1&A|F&E1&!E&D&!C&!B&!A1&A|F&E1&E&D&!C&!B&!A1&A|F&!E1&E&D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOAAOAI211121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOAI221121 -l AAOAAOAI221121 -i F E1 E D C B1 B A1 A -o Y -f Y=!(F&E1&E&!D&!C&!B1&!B&!A1&!A|F&E1&E&D&!C&!B1&!B&!A1&!A|F&!E1&!E&D&C&!B1&!B&!A1&!A|F&E1&!E&D&C&!B1&!B&!A1&!A|F&E1&E&D&C&!B1&!B&!A1&!A|F&!E1&E&D&C&!B1&!B&!A1&!A|F&E1&E&!D&C&!B1&!B&!A1&!A|F&E1&E&!D&C&B1&!B&!A1&!A|F&!E1&E&D&C&B1&!B&!A1&!A|F&E1&E&D&C&B1&!B&!A1&!A|F&E1&!E&D&C&B1&!B&!A1&!A|F&!E1&!E&D&C&B1&!B&!A1&!A|F&E1&E&D&!C&B1&!B&!A1&!A|F&E1&E&!D&!C&B1&!B&!A1&!A|F&E1&E&!D&!C&B1&B&!A1&!A|F&!E1&E&D&!C&B1&B&!A1&!A|F&E1&E&D&!C&B1&B&!A1&!A|F&E1&!E&D&!C&B1&B&!A1&!A|F&!E1&!E&D&!C&B1&B&!A1&!A|F&!E1&!E&D&C&B1&B&!A1&!A|F&E1&!E&D&C&B1&B&!A1&!A|F&E1&E&D&C&B1&B&!A1&!A|F&!E1&E&D&C&B1&B&!A1&!A|F&E1&E&!D&C&B1&B&!A1&!A|F&E1&E&!D&C&!B1&B&!A1&!A|F&!E1&E&D&C&!B1&B&!A1&!A|F&E1&E&D&C&!B1&B&!A1&!A|F&E1&!E&D&C&!B1&B&!A1&!A|F&!E1&!E&D&C&!B1&B&!A1&!A|F&E1&E&D&!C&!B1&B&!A1&!A|F&E1&E&!D&!C&!B1&B&!A1&!A|F&E1&E&!D&!C&!B1&B&A1&!A|F&E1&E&D&!C&!B1&B&A1&!A|F&!E1&!E&D&C&!B1&B&A1&!A|F&E1&!E&D&C&!B1&B&A1&!A|F&E1&E&D&C&!B1&B&A1&!A|F&!E1&E&D&C&!B1&B&A1&!A|F&E1&E&!D&C&!B1&B&A1&!A|F&E1&E&!D&C&B1&B&A1&!A|F&!E1&E&D&C&B1&B&A1&!A|F&E1&E&D&C&B1&B&A1&!A|F&E1&!E&D&C&B1&B&A1&!A|F&!E1&!E&D&C&B1&B&A1&!A|F&!E1&!E&D&!C&B1&B&A1&!A|F&E1&!E&D&!C&B1&B&A1&!A|F&E1&E&D&!C&B1&B&A1&!A|F&!E1&E&D&!C&B1&B&A1&!A|F&E1&E&!D&!C&B1&B&A1&!A|F&E1&E&!D&!C&B1&!B&A1&!A|F&E1&E&D&!C&B1&!B&A1&!A|F&!E1&!E&D&C&B1&!B&A1&!A|F&E1&!E&D&C&B1&!B&A1&!A|F&E1&E&D&C&B1&!B&A1&!A|F&!E1&E&D&C&B1&!B&A1&!A|F&E1&E&!D&C&B1&!B&A1&!A|F&E1&E&!D&C&!B1&!B&A1&!A|F&!E1&E&D&C&!B1&!B&A1&!A|F&E1&E&D&C&!B1&!B&A1&!A|F&E1&!E&D&C&!B1&!B&A1&!A|F&!E1&!E&D&C&!B1&!B&A1&!A|F&E1&E&D&!C&!B1&!B&A1&!A|F&E1&E&!D&!C&!B1&!B&A1&!A|F&E1&E&!D&!C&!B1&!B&A1&A|F&!E1&E&D&!C&!B1&!B&A1&A|F&E1&E&D&!C&!B1&!B&A1&A|F&E1&!E&D&!C&!B1&!B&A1&A|F&!E1&!E&D&!C&!B1&!B&A1&A|F&!E1&!E&D&C&!B1&!B&A1&A|F&E1&!E&D&C&!B1&!B&A1&A|F&E1&E&D&C&!B1&!B&A1&A|F&!E1&E&D&C&!B1&!B&A1&A|F&E1&E&!D&C&!B1&!B&A1&A|F&E1&E&!D&C&B1&!B&A1&A|F&!E1&E&D&C&B1&!B&A1&A|F&E1&E&D&C&B1&!B&A1&A|F&E1&!E&D&C&B1&!B&A1&A|F&!E1&!E&D&C&B1&!B&A1&A|F&!E1&!E&D&!C&B1&!B&A1&A|F&E1&!E&D&!C&B1&!B&A1&A|F&E1&E&D&!C&B1&!B&A1&A|F&!E1&E&D&!C&B1&!B&A1&A|F&E1&E&!D&!C&B1&!B&A1&A|F&E1&E&!D&!C&B1&B&A1&A|F&!E1&E&D&!C&B1&B&A1&A|F&E1&E&D&!C&B1&B&A1&A|F&E1&!E&D&!C&B1&B&A1&A|F&!E1&!E&D&!C&B1&B&A1&A|F&!E1&!E&D&C&B1&B&A1&A|F&E1&!E&D&C&B1&B&A1&A|F&E1&E&D&C&B1&B&A1&A|F&!E1&E&D&C&B1&B&A1&A|F&E1&E&!D&C&B1&B&A1&A|F&E1&E&!D&C&!B1&B&A1&A|F&!E1&E&D&C&!B1&B&A1&A|F&E1&E&D&C&!B1&B&A1&A|F&E1&!E&D&C&!B1&B&A1&A|F&!E1&!E&D&C&!B1&B&A1&A|F&!E1&!E&D&!C&!B1&B&A1&A|F&E1&!E&D&!C&!B1&B&A1&A|F&E1&E&D&!C&!B1&B&A1&A|F&!E1&E&D&!C&!B1&B&A1&A|F&E1&E&!D&!C&!B1&B&A1&A|F&E1&E&!D&!C&!B1&B&!A1&A|F&E1&E&D&!C&!B1&B&!A1&A|F&!E1&!E&D&C&!B1&B&!A1&A|F&E1&!E&D&C&!B1&B&!A1&A|F&E1&E&D&C&!B1&B&!A1&A|F&!E1&E&D&C&!B1&B&!A1&A|F&E1&E&!D&C&!B1&B&!A1&A|F&E1&E&!D&C&B1&B&!A1&A|F&!E1&E&D&C&B1&B&!A1&A|F&E1&E&D&C&B1&B&!A1&A|F&E1&!E&D&C&B1&B&!A1&A|F&!E1&!E&D&C&B1&B&!A1&A|F&!E1&!E&D&!C&B1&B&!A1&A|F&E1&!E&D&!C&B1&B&!A1&A|F&E1&E&D&!C&B1&B&!A1&A|F&!E1&E&D&!C&B1&B&!A1&A|F&E1&E&!D&!C&B1&B&!A1&A|F&E1&E&!D&!C&B1&!B&!A1&A|F&E1&E&D&!C&B1&!B&!A1&A|F&!E1&!E&D&C&B1&!B&!A1&A|F&E1&!E&D&C&B1&!B&!A1&A|F&E1&E&D&C&B1&!B&!A1&A|F&!E1&E&D&C&B1&!B&!A1&A|F&E1&E&!D&C&B1&!B&!A1&A|F&E1&E&!D&C&!B1&!B&!A1&A|F&!E1&E&D&C&!B1&!B&!A1&A|F&E1&E&D&C&!B1&!B&!A1&A|F&E1&!E&D&C&!B1&!B&!A1&A|F&!E1&!E&D&C&!B1&!B&!A1&A|F&E1&E&D&!C&!B1&!B&!A1&A|F&E1&E&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOAI221121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOOAI22141 -l OOAOOAI22141 -i E D3 D2 D1 D C B1 B A1 A -o Y -f Y=!(E&!D3&!D2&!D1&D&C&!B1&!B&!A1&!A|E&D3&!D2&!D1&D&C&!B1&!B&!A1&!A|E&D3&D2&!D1&D&C&!B1&!B&!A1&!A|E&!D3&D2&!D1&D&C&!B1&!B&!A1&!A|E&!D3&D2&D1&D&C&!B1&!B&!A1&!A|E&D3&D2&D1&D&C&!B1&!B&!A1&!A|E&D3&!D2&D1&D&C&!B1&!B&!A1&!A|E&!D3&!D2&D1&D&C&!B1&!B&!A1&!A|E&!D3&!D2&D1&!D&C&!B1&!B&!A1&!A|E&D3&!D2&D1&!D&C&!B1&!B&!A1&!A|E&D3&D2&D1&!D&C&!B1&!B&!A1&!A|E&!D3&D2&D1&!D&C&!B1&!B&!A1&!A|E&!D3&D2&!D1&!D&C&!B1&!B&!A1&!A|E&D3&D2&!D1&!D&C&!B1&!B&!A1&!A|E&D3&!D2&!D1&!D&C&!B1&!B&!A1&!A|E&D3&!D2&!D1&!D&C&B1&!B&!A1&!A|E&D3&D2&!D1&!D&C&B1&!B&!A1&!A|E&!D3&D2&!D1&!D&C&B1&!B&!A1&!A|E&!D3&D2&D1&!D&C&B1&!B&!A1&!A|E&D3&D2&D1&!D&C&B1&!B&!A1&!A|E&D3&!D2&D1&!D&C&B1&!B&!A1&!A|E&!D3&!D2&D1&!D&C&B1&!B&!A1&!A|E&!D3&!D2&D1&D&C&B1&!B&!A1&!A|E&D3&!D2&D1&D&C&B1&!B&!A1&!A|E&D3&D2&D1&D&C&B1&!B&!A1&!A|E&!D3&D2&D1&D&C&B1&!B&!A1&!A|E&!D3&D2&!D1&D&C&B1&!B&!A1&!A|E&D3&D2&!D1&D&C&B1&!B&!A1&!A|E&D3&!D2&!D1&D&C&B1&!B&!A1&!A|E&!D3&!D2&!D1&D&C&B1&!B&!A1&!A|E&!D3&!D2&!D1&D&C&B1&B&!A1&!A|E&D3&!D2&!D1&D&C&B1&B&!A1&!A|E&D3&D2&!D1&D&C&B1&B&!A1&!A|E&!D3&D2&!D1&D&C&B1&B&!A1&!A|E&!D3&D2&D1&D&C&B1&B&!A1&!A|E&D3&D2&D1&D&C&B1&B&!A1&!A|E&D3&!D2&D1&D&C&B1&B&!A1&!A|E&!D3&!D2&D1&D&C&B1&B&!A1&!A|E&!D3&!D2&D1&!D&C&B1&B&!A1&!A|E&D3&!D2&D1&!D&C&B1&B&!A1&!A|E&D3&D2&D1&!D&C&B1&B&!A1&!A|E&!D3&D2&D1&!D&C&B1&B&!A1&!A|E&!D3&D2&!D1&!D&C&B1&B&!A1&!A|E&D3&D2&!D1&!D&C&B1&B&!A1&!A|E&D3&!D2&!D1&!D&C&B1&B&!A1&!A|E&D3&!D2&!D1&!D&C&!B1&B&!A1&!A|E&D3&D2&!D1&!D&C&!B1&B&!A1&!A|E&!D3&D2&!D1&!D&C&!B1&B&!A1&!A|E&!D3&D2&D1&!D&C&!B1&B&!A1&!A|E&D3&D2&D1&!D&C&!B1&B&!A1&!A|E&D3&!D2&D1&!D&C&!B1&B&!A1&!A|E&!D3&!D2&D1&!D&C&!B1&B&!A1&!A|E&!D3&!D2&D1&D&C&!B1&B&!A1&!A|E&D3&!D2&D1&D&C&!B1&B&!A1&!A|E&D3&D2&D1&D&C&!B1&B&!A1&!A|E&!D3&D2&D1&D&C&!B1&B&!A1&!A|E&!D3&D2&!D1&D&C&!B1&B&!A1&!A|E&D3&D2&!D1&D&C&!B1&B&!A1&!A|E&D3&!D2&!D1&D&C&!B1&B&!A1&!A|E&!D3&!D2&!D1&D&C&!B1&B&!A1&!A|E&D3&!D2&!D1&!D&!C&!B1&B&A1&!A|E&D3&D2&!D1&!D&!C&!B1&B&A1&!A|E&!D3&D2&!D1&!D&!C&!B1&B&A1&!A|E&!D3&D2&D1&!D&!C&!B1&B&A1&!A|E&D3&D2&D1&!D&!C&!B1&B&A1&!A|E&D3&!D2&D1&!D&!C&!B1&B&A1&!A|E&!D3&!D2&D1&!D&!C&!B1&B&A1&!A|E&!D3&!D2&D1&D&!C&!B1&B&A1&!A|E&D3&!D2&D1&D&!C&!B1&B&A1&!A|E&D3&D2&D1&D&!C&!B1&B&A1&!A|E&!D3&D2&D1&D&!C&!B1&B&A1&!A|E&!D3&D2&!D1&D&!C&!B1&B&A1&!A|E&D3&D2&!D1&D&!C&!B1&B&A1&!A|E&D3&!D2&!D1&D&!C&!B1&B&A1&!A|E&!D3&!D2&!D1&D&!C&!B1&B&A1&!A|E&!D3&!D2&!D1&D&C&!B1&B&A1&!A|E&D3&!D2&!D1&D&C&!B1&B&A1&!A|E&D3&D2&!D1&D&C&!B1&B&A1&!A|E&!D3&D2&!D1&D&C&!B1&B&A1&!A|E&!D3&D2&D1&D&C&!B1&B&A1&!A|E&D3&D2&D1&D&C&!B1&B&A1&!A|E&D3&!D2&D1&D&C&!B1&B&A1&!A|E&!D3&!D2&D1&D&C&!B1&B&A1&!A|E&!D3&!D2&D1&!D&C&!B1&B&A1&!A|E&D3&!D2&D1&!D&C&!B1&B&A1&!A|E&D3&D2&D1&!D&C&!B1&B&A1&!A|E&!D3&D2&D1&!D&C&!B1&B&A1&!A|E&!D3&D2&!D1&!D&C&!B1&B&A1&!A|E&D3&D2&!D1&!D&C&!B1&B&A1&!A|E&D3&!D2&!D1&!D&C&!B1&B&A1&!A|E&D3&!D2&!D1&!D&C&B1&B&A1&!A|E&D3&D2&!D1&!D&C&B1&B&A1&!A|E&!D3&D2&!D1&!D&C&B1&B&A1&!A|E&!D3&D2&D1&!D&C&B1&B&A1&!A|E&D3&D2&D1&!D&C&B1&B&A1&!A|E&D3&!D2&D1&!D&C&B1&B&A1&!A|E&!D3&!D2&D1&!D&C&B1&B&A1&!A|E&!D3&!D2&D1&D&C&B1&B&A1&!A|E&D3&!D2&D1&D&C&B1&B&A1&!A|E&D3&D2&D1&D&C&B1&B&A1&!A|E&!D3&D2&D1&D&C&B1&B&A1&!A|E&!D3&D2&!D1&D&C&B1&B&A1&!A|E&D3&D2&!D1&D&C&B1&B&A1&!A|E&D3&!D2&!D1&D&C&B1&B&A1&!A|E&!D3&!D2&!D1&D&C&B1&B&A1&!A|E&!D3&!D2&!D1&D&!C&B1&B&A1&!A|E&D3&!D2&!D1&D&!C&B1&B&A1&!A|E&D3&D2&!D1&D&!C&B1&B&A1&!A|E&!D3&D2&!D1&D&!C&B1&B&A1&!A|E&!D3&D2&D1&D&!C&B1&B&A1&!A|E&D3&D2&D1&D&!C&B1&B&A1&!A|E&D3&!D2&D1&D&!C&B1&B&A1&!A|E&!D3&!D2&D1&D&!C&B1&B&A1&!A|E&!D3&!D2&D1&!D&!C&B1&B&A1&!A|E&D3&!D2&D1&!D&!C&B1&B&A1&!A|E&D3&D2&D1&!D&!C&B1&B&A1&!A|E&!D3&D2&D1&!D&!C&B1&B&A1&!A|E&!D3&D2&!D1&!D&!C&B1&B&A1&!A|E&D3&D2&!D1&!D&!C&B1&B&A1&!A|E&D3&!D2&!D1&!D&!C&B1&B&A1&!A|E&D3&!D2&!D1&!D&!C&B1&!B&A1&!A|E&D3&D2&!D1&!D&!C&B1&!B&A1&!A|E&!D3&D2&!D1&!D&!C&B1&!B&A1&!A|E&!D3&D2&D1&!D&!C&B1&!B&A1&!A|E&D3&D2&D1&!D&!C&B1&!B&A1&!A|E&D3&!D2&D1&!D&!C&B1&!B&A1&!A|E&!D3&!D2&D1&!D&!C&B1&!B&A1&!A|E&!D3&!D2&D1&D&!C&B1&!B&A1&!A|E&D3&!D2&D1&D&!C&B1&!B&A1&!A|E&D3&D2&D1&D&!C&B1&!B&A1&!A|E&!D3&D2&D1&D&!C&B1&!B&A1&!A|E&!D3&D2&!D1&D&!C&B1&!B&A1&!A|E&D3&D2&!D1&D&!C&B1&!B&A1&!A|E&D3&!D2&!D1&D&!C&B1&!B&A1&!A|E&!D3&!D2&!D1&D&!C&B1&!B&A1&!A|E&!D3&!D2&!D1&D&C&B1&!B&A1&!A|E&D3&!D2&!D1&D&C&B1&!B&A1&!A|E&D3&D2&!D1&D&C&B1&!B&A1&!A|E&!D3&D2&!D1&D&C&B1&!B&A1&!A|E&!D3&D2&D1&D&C&B1&!B&A1&!A|E&D3&D2&D1&D&C&B1&!B&A1&!A|E&D3&!D2&D1&D&C&B1&!B&A1&!A|E&!D3&!D2&D1&D&C&B1&!B&A1&!A|E&!D3&!D2&D1&!D&C&B1&!B&A1&!A|E&D3&!D2&D1&!D&C&B1&!B&A1&!A|E&D3&D2&D1&!D&C&B1&!B&A1&!A|E&!D3&D2&D1&!D&C&B1&!B&A1&!A|E&!D3&D2&!D1&!D&C&B1&!B&A1&!A|E&D3&D2&!D1&!D&C&B1&!B&A1&!A|E&D3&!D2&!D1&!D&C&B1&!B&A1&!A|E&D3&!D2&!D1&!D&C&!B1&!B&A1&!A|E&D3&D2&!D1&!D&C&!B1&!B&A1&!A|E&!D3&D2&!D1&!D&C&!B1&!B&A1&!A|E&!D3&D2&D1&!D&C&!B1&!B&A1&!A|E&D3&D2&D1&!D&C&!B1&!B&A1&!A|E&D3&!D2&D1&!D&C&!B1&!B&A1&!A|E&!D3&!D2&D1&!D&C&!B1&!B&A1&!A|E&!D3&!D2&D1&D&C&!B1&!B&A1&!A|E&D3&!D2&D1&D&C&!B1&!B&A1&!A|E&D3&D2&D1&D&C&!B1&!B&A1&!A|E&!D3&D2&D1&D&C&!B1&!B&A1&!A|E&!D3&D2&!D1&D&C&!B1&!B&A1&!A|E&D3&D2&!D1&D&C&!B1&!B&A1&!A|E&D3&!D2&!D1&D&C&!B1&!B&A1&!A|E&!D3&!D2&!D1&D&C&!B1&!B&A1&!A|E&!D3&!D2&!D1&D&C&!B1&!B&A1&A|E&D3&!D2&!D1&D&C&!B1&!B&A1&A|E&D3&D2&!D1&D&C&!B1&!B&A1&A|E&!D3&D2&!D1&D&C&!B1&!B&A1&A|E&!D3&D2&D1&D&C&!B1&!B&A1&A|E&D3&D2&D1&D&C&!B1&!B&A1&A|E&D3&!D2&D1&D&C&!B1&!B&A1&A|E&!D3&!D2&D1&D&C&!B1&!B&A1&A|E&!D3&!D2&D1&!D&C&!B1&!B&A1&A|E&D3&!D2&D1&!D&C&!B1&!B&A1&A|E&D3&D2&D1&!D&C&!B1&!B&A1&A|E&!D3&D2&D1&!D&C&!B1&!B&A1&A|E&!D3&D2&!D1&!D&C&!B1&!B&A1&A|E&D3&D2&!D1&!D&C&!B1&!B&A1&A|E&D3&!D2&!D1&!D&C&!B1&!B&A1&A|E&D3&!D2&!D1&!D&C&B1&!B&A1&A|E&D3&D2&!D1&!D&C&B1&!B&A1&A|E&!D3&D2&!D1&!D&C&B1&!B&A1&A|E&!D3&D2&D1&!D&C&B1&!B&A1&A|E&D3&D2&D1&!D&C&B1&!B&A1&A|E&D3&!D2&D1&!D&C&B1&!B&A1&A|E&!D3&!D2&D1&!D&C&B1&!B&A1&A|E&!D3&!D2&D1&D&C&B1&!B&A1&A|E&D3&!D2&D1&D&C&B1&!B&A1&A|E&D3&D2&D1&D&C&B1&!B&A1&A|E&!D3&D2&D1&D&C&B1&!B&A1&A|E&!D3&D2&!D1&D&C&B1&!B&A1&A|E&D3&D2&!D1&D&C&B1&!B&A1&A|E&D3&!D2&!D1&D&C&B1&!B&A1&A|E&!D3&!D2&!D1&D&C&B1&!B&A1&A|E&!D3&!D2&!D1&D&!C&B1&!B&A1&A|E&D3&!D2&!D1&D&!C&B1&!B&A1&A|E&D3&D2&!D1&D&!C&B1&!B&A1&A|E&!D3&D2&!D1&D&!C&B1&!B&A1&A|E&!D3&D2&D1&D&!C&B1&!B&A1&A|E&D3&D2&D1&D&!C&B1&!B&A1&A|E&D3&!D2&D1&D&!C&B1&!B&A1&A|E&!D3&!D2&D1&D&!C&B1&!B&A1&A|E&!D3&!D2&D1&!D&!C&B1&!B&A1&A|E&D3&!D2&D1&!D&!C&B1&!B&A1&A|E&D3&D2&D1&!D&!C&B1&!B&A1&A|E&!D3&D2&D1&!D&!C&B1&!B&A1&A|E&!D3&D2&!D1&!D&!C&B1&!B&A1&A|E&D3&D2&!D1&!D&!C&B1&!B&A1&A|E&D3&!D2&!D1&!D&!C&B1&!B&A1&A|E&D3&!D2&!D1&!D&!C&B1&B&A1&A|E&D3&D2&!D1&!D&!C&B1&B&A1&A|E&!D3&D2&!D1&!D&!C&B1&B&A1&A|E&!D3&D2&D1&!D&!C&B1&B&A1&A|E&D3&D2&D1&!D&!C&B1&B&A1&A|E&D3&!D2&D1&!D&!C&B1&B&A1&A|E&!D3&!D2&D1&!D&!C&B1&B&A1&A|E&!D3&!D2&D1&D&!C&B1&B&A1&A|E&D3&!D2&D1&D&!C&B1&B&A1&A|E&D3&D2&D1&D&!C&B1&B&A1&A|E&!D3&D2&D1&D&!C&B1&B&A1&A|E&!D3&D2&!D1&D&!C&B1&B&A1&A|E&D3&D2&!D1&D&!C&B1&B&A1&A|E&D3&!D2&!D1&D&!C&B1&B&A1&A|E&!D3&!D2&!D1&D&!C&B1&B&A1&A|E&!D3&!D2&!D1&D&C&B1&B&A1&A|E&D3&!D2&!D1&D&C&B1&B&A1&A|E&D3&D2&!D1&D&C&B1&B&A1&A|E&!D3&D2&!D1&D&C&B1&B&A1&A|E&!D3&D2&D1&D&C&B1&B&A1&A|E&D3&D2&D1&D&C&B1&B&A1&A|E&D3&!D2&D1&D&C&B1&B&A1&A|E&!D3&!D2&D1&D&C&B1&B&A1&A|E&!D3&!D2&D1&!D&C&B1&B&A1&A|E&D3&!D2&D1&!D&C&B1&B&A1&A|E&D3&D2&D1&!D&C&B1&B&A1&A|E&!D3&D2&D1&!D&C&B1&B&A1&A|E&!D3&D2&!D1&!D&C&B1&B&A1&A|E&D3&D2&!D1&!D&C&B1&B&A1&A|E&D3&!D2&!D1&!D&C&B1&B&A1&A|E&D3&!D2&!D1&!D&C&!B1&B&A1&A|E&D3&D2&!D1&!D&C&!B1&B&A1&A|E&!D3&D2&!D1&!D&C&!B1&B&A1&A|E&!D3&D2&D1&!D&C&!B1&B&A1&A|E&D3&D2&D1&!D&C&!B1&B&A1&A|E&D3&!D2&D1&!D&C&!B1&B&A1&A|E&!D3&!D2&D1&!D&C&!B1&B&A1&A|E&!D3&!D2&D1&D&C&!B1&B&A1&A|E&D3&!D2&D1&D&C&!B1&B&A1&A|E&D3&D2&D1&D&C&!B1&B&A1&A|E&!D3&D2&D1&D&C&!B1&B&A1&A|E&!D3&D2&!D1&D&C&!B1&B&A1&A|E&D3&D2&!D1&D&C&!B1&B&A1&A|E&D3&!D2&!D1&D&C&!B1&B&A1&A|E&!D3&!D2&!D1&D&C&!B1&B&A1&A|E&!D3&!D2&!D1&D&!C&!B1&B&A1&A|E&D3&!D2&!D1&D&!C&!B1&B&A1&A|E&D3&D2&!D1&D&!C&!B1&B&A1&A|E&!D3&D2&!D1&D&!C&!B1&B&A1&A|E&!D3&D2&D1&D&!C&!B1&B&A1&A|E&D3&D2&D1&D&!C&!B1&B&A1&A|E&D3&!D2&D1&D&!C&!B1&B&A1&A|E&!D3&!D2&D1&D&!C&!B1&B&A1&A|E&!D3&!D2&D1&!D&!C&!B1&B&A1&A|E&D3&!D2&D1&!D&!C&!B1&B&A1&A|E&D3&D2&D1&!D&!C&!B1&B&A1&A|E&!D3&D2&D1&!D&!C&!B1&B&A1&A|E&!D3&D2&!D1&!D&!C&!B1&B&A1&A|E&D3&D2&!D1&!D&!C&!B1&B&A1&A|E&D3&!D2&!D1&!D&!C&!B1&B&A1&A|E&D3&!D2&!D1&!D&!C&!B1&B&!A1&A|E&D3&D2&!D1&!D&!C&!B1&B&!A1&A|E&!D3&D2&!D1&!D&!C&!B1&B&!A1&A|E&!D3&D2&D1&!D&!C&!B1&B&!A1&A|E&D3&D2&D1&!D&!C&!B1&B&!A1&A|E&D3&!D2&D1&!D&!C&!B1&B&!A1&A|E&!D3&!D2&D1&!D&!C&!B1&B&!A1&A|E&!D3&!D2&D1&D&!C&!B1&B&!A1&A|E&D3&!D2&D1&D&!C&!B1&B&!A1&A|E&D3&D2&D1&D&!C&!B1&B&!A1&A|E&!D3&D2&D1&D&!C&!B1&B&!A1&A|E&!D3&D2&!D1&D&!C&!B1&B&!A1&A|E&D3&D2&!D1&D&!C&!B1&B&!A1&A|E&D3&!D2&!D1&D&!C&!B1&B&!A1&A|E&!D3&!D2&!D1&D&!C&!B1&B&!A1&A|E&!D3&!D2&!D1&D&C&!B1&B&!A1&A|E&D3&!D2&!D1&D&C&!B1&B&!A1&A|E&D3&D2&!D1&D&C&!B1&B&!A1&A|E&!D3&D2&!D1&D&C&!B1&B&!A1&A|E&!D3&D2&D1&D&C&!B1&B&!A1&A|E&D3&D2&D1&D&C&!B1&B&!A1&A|E&D3&!D2&D1&D&C&!B1&B&!A1&A|E&!D3&!D2&D1&D&C&!B1&B&!A1&A|E&!D3&!D2&D1&!D&C&!B1&B&!A1&A|E&D3&!D2&D1&!D&C&!B1&B&!A1&A|E&D3&D2&D1&!D&C&!B1&B&!A1&A|E&!D3&D2&D1&!D&C&!B1&B&!A1&A|E&!D3&D2&!D1&!D&C&!B1&B&!A1&A|E&D3&D2&!D1&!D&C&!B1&B&!A1&A|E&D3&!D2&!D1&!D&C&!B1&B&!A1&A|E&D3&!D2&!D1&!D&C&B1&B&!A1&A|E&D3&D2&!D1&!D&C&B1&B&!A1&A|E&!D3&D2&!D1&!D&C&B1&B&!A1&A|E&!D3&D2&D1&!D&C&B1&B&!A1&A|E&D3&D2&D1&!D&C&B1&B&!A1&A|E&D3&!D2&D1&!D&C&B1&B&!A1&A|E&!D3&!D2&D1&!D&C&B1&B&!A1&A|E&!D3&!D2&D1&D&C&B1&B&!A1&A|E&D3&!D2&D1&D&C&B1&B&!A1&A|E&D3&D2&D1&D&C&B1&B&!A1&A|E&!D3&D2&D1&D&C&B1&B&!A1&A|E&!D3&D2&!D1&D&C&B1&B&!A1&A|E&D3&D2&!D1&D&C&B1&B&!A1&A|E&D3&!D2&!D1&D&C&B1&B&!A1&A|E&!D3&!D2&!D1&D&C&B1&B&!A1&A|E&!D3&!D2&!D1&D&!C&B1&B&!A1&A|E&D3&!D2&!D1&D&!C&B1&B&!A1&A|E&D3&D2&!D1&D&!C&B1&B&!A1&A|E&!D3&D2&!D1&D&!C&B1&B&!A1&A|E&!D3&D2&D1&D&!C&B1&B&!A1&A|E&D3&D2&D1&D&!C&B1&B&!A1&A|E&D3&!D2&D1&D&!C&B1&B&!A1&A|E&!D3&!D2&D1&D&!C&B1&B&!A1&A|E&!D3&!D2&D1&!D&!C&B1&B&!A1&A|E&D3&!D2&D1&!D&!C&B1&B&!A1&A|E&D3&D2&D1&!D&!C&B1&B&!A1&A|E&!D3&D2&D1&!D&!C&B1&B&!A1&A|E&!D3&D2&!D1&!D&!C&B1&B&!A1&A|E&D3&D2&!D1&!D&!C&B1&B&!A1&A|E&D3&!D2&!D1&!D&!C&B1&B&!A1&A|E&D3&!D2&!D1&!D&!C&B1&!B&!A1&A|E&D3&D2&!D1&!D&!C&B1&!B&!A1&A|E&!D3&D2&!D1&!D&!C&B1&!B&!A1&A|E&!D3&D2&D1&!D&!C&B1&!B&!A1&A|E&D3&D2&D1&!D&!C&B1&!B&!A1&A|E&D3&!D2&D1&!D&!C&B1&!B&!A1&A|E&!D3&!D2&D1&!D&!C&B1&!B&!A1&A|E&!D3&!D2&D1&D&!C&B1&!B&!A1&A|E&D3&!D2&D1&D&!C&B1&!B&!A1&A|E&D3&D2&D1&D&!C&B1&!B&!A1&A|E&!D3&D2&D1&D&!C&B1&!B&!A1&A|E&!D3&D2&!D1&D&!C&B1&!B&!A1&A|E&D3&D2&!D1&D&!C&B1&!B&!A1&A|E&D3&!D2&!D1&D&!C&B1&!B&!A1&A|E&!D3&!D2&!D1&D&!C&B1&!B&!A1&A|E&!D3&!D2&!D1&D&C&B1&!B&!A1&A|E&D3&!D2&!D1&D&C&B1&!B&!A1&A|E&D3&D2&!D1&D&C&B1&!B&!A1&A|E&!D3&D2&!D1&D&C&B1&!B&!A1&A|E&!D3&D2&D1&D&C&B1&!B&!A1&A|E&D3&D2&D1&D&C&B1&!B&!A1&A|E&D3&!D2&D1&D&C&B1&!B&!A1&A|E&!D3&!D2&D1&D&C&B1&!B&!A1&A|E&!D3&!D2&D1&!D&C&B1&!B&!A1&A|E&D3&!D2&D1&!D&C&B1&!B&!A1&A|E&D3&D2&D1&!D&C&B1&!B&!A1&A|E&!D3&D2&D1&!D&C&B1&!B&!A1&A|E&!D3&D2&!D1&!D&C&B1&!B&!A1&A|E&D3&D2&!D1&!D&C&B1&!B&!A1&A|E&D3&!D2&!D1&!D&C&B1&!B&!A1&A|E&D3&!D2&!D1&!D&C&!B1&!B&!A1&A|E&D3&D2&!D1&!D&C&!B1&!B&!A1&A|E&!D3&D2&!D1&!D&C&!B1&!B&!A1&A|E&!D3&D2&D1&!D&C&!B1&!B&!A1&A|E&D3&D2&D1&!D&C&!B1&!B&!A1&A|E&D3&!D2&D1&!D&C&!B1&!B&!A1&A|E&!D3&!D2&D1&!D&C&!B1&!B&!A1&A|E&!D3&!D2&D1&D&C&!B1&!B&!A1&A|E&D3&!D2&D1&D&C&!B1&!B&!A1&A|E&D3&D2&D1&D&C&!B1&!B&!A1&A|E&!D3&D2&D1&D&C&!B1&!B&!A1&A|E&!D3&D2&!D1&D&C&!B1&!B&!A1&A|E&D3&D2&!D1&D&C&!B1&!B&!A1&A|E&D3&!D2&!D1&D&C&!B1&!B&!A1&A|E&!D3&!D2&!D1&D&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOOAI22141.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAI322 -l AAOOAI322 -i C1 C B1 B A2 A1 A -o Y -f Y=!(C1&!C&B1&B&!A2&!A1&!A|C1&C&B1&B&!A2&!A1&!A|!C1&C&B1&B&!A2&!A1&!A|!C1&C&B1&B&A2&!A1&!A|C1&C&B1&B&A2&!A1&!A|C1&!C&B1&B&A2&!A1&!A|C1&!C&B1&B&A2&A1&!A|C1&C&B1&B&A2&A1&!A|!C1&C&B1&B&A2&A1&!A|!C1&C&B1&B&!A2&A1&!A|C1&C&B1&B&!A2&A1&!A|C1&!C&B1&B&!A2&A1&!A|C1&!C&B1&B&!A2&A1&A|C1&C&B1&B&!A2&A1&A|!C1&C&B1&B&!A2&A1&A|C1&!C&!B1&B&A2&A1&A|C1&C&!B1&B&A2&A1&A|!C1&C&!B1&B&A2&A1&A|!C1&C&B1&B&A2&A1&A|C1&C&B1&B&A2&A1&A|C1&!C&B1&B&A2&A1&A|C1&!C&B1&!B&A2&A1&A|C1&C&B1&!B&A2&A1&A|!C1&C&B1&!B&A2&A1&A|!C1&C&!B1&!B&A2&A1&A|C1&C&!B1&!B&A2&A1&A|C1&!C&!B1&!B&A2&A1&A|C1&!C&B1&B&A2&!A1&A|C1&C&B1&B&A2&!A1&A|!C1&C&B1&B&A2&!A1&A|!C1&C&B1&B&!A2&!A1&A|C1&C&B1&B&!A2&!A1&A|C1&!C&B1&B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAI322.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOOAAOI21222 -l AOOOAAOI21222 -i E1 E D1 D C1 C B A1 A -o Y -f Y=(!E1&!E&!D1&!D&!C1&!C&!B&!A1&!A|E1&!E&!D1&!D&!C1&!C&!B&!A1&!A|!E1&E&!D1&!D&!C1&!C&!B&!A1&!A|!E1&E&D1&!D&!C1&!C&!B&!A1&!A|E1&!E&D1&!D&!C1&!C&!B&!A1&!A|!E1&!E&D1&!D&!C1&!C&!B&!A1&!A|!E1&!E&D1&D&!C1&!C&!B&!A1&!A|E1&!E&D1&D&!C1&!C&!B&!A1&!A|!E1&E&D1&D&!C1&!C&!B&!A1&!A|!E1&E&!D1&D&!C1&!C&!B&!A1&!A|E1&!E&!D1&D&!C1&!C&!B&!A1&!A|!E1&!E&!D1&D&!C1&!C&!B&!A1&!A|!E1&!E&!D1&D&C1&!C&!B&!A1&!A|E1&!E&!D1&D&C1&!C&!B&!A1&!A|!E1&E&!D1&D&C1&!C&!B&!A1&!A|!E1&E&D1&D&C1&!C&!B&!A1&!A|E1&!E&D1&D&C1&!C&!B&!A1&!A|!E1&!E&D1&D&C1&!C&!B&!A1&!A|!E1&!E&D1&!D&C1&!C&!B&!A1&!A|E1&!E&D1&!D&C1&!C&!B&!A1&!A|!E1&E&D1&!D&C1&!C&!B&!A1&!A|!E1&E&!D1&!D&C1&!C&!B&!A1&!A|E1&!E&!D1&!D&C1&!C&!B&!A1&!A|!E1&!E&!D1&!D&C1&!C&!B&!A1&!A|!E1&!E&!D1&!D&C1&C&!B&!A1&!A|E1&!E&!D1&!D&C1&C&!B&!A1&!A|!E1&E&!D1&!D&C1&C&!B&!A1&!A|!E1&E&D1&!D&C1&C&!B&!A1&!A|E1&!E&D1&!D&C1&C&!B&!A1&!A|!E1&!E&D1&!D&C1&C&!B&!A1&!A|!E1&!E&D1&D&C1&C&!B&!A1&!A|E1&!E&D1&D&C1&C&!B&!A1&!A|!E1&E&D1&D&C1&C&!B&!A1&!A|!E1&E&!D1&D&C1&C&!B&!A1&!A|E1&!E&!D1&D&C1&C&!B&!A1&!A|!E1&!E&!D1&D&C1&C&!B&!A1&!A|!E1&!E&!D1&D&!C1&C&!B&!A1&!A|E1&!E&!D1&D&!C1&C&!B&!A1&!A|!E1&E&!D1&D&!C1&C&!B&!A1&!A|!E1&E&D1&D&!C1&C&!B&!A1&!A|E1&!E&D1&D&!C1&C&!B&!A1&!A|!E1&!E&D1&D&!C1&C&!B&!A1&!A|!E1&!E&D1&!D&!C1&C&!B&!A1&!A|E1&!E&D1&!D&!C1&C&!B&!A1&!A|!E1&E&D1&!D&!C1&C&!B&!A1&!A|!E1&E&!D1&!D&!C1&C&!B&!A1&!A|E1&!E&!D1&!D&!C1&C&!B&!A1&!A|!E1&!E&!D1&!D&!C1&C&!B&!A1&!A|!E1&!E&!D1&!D&!C1&C&B&!A1&!A|E1&!E&!D1&!D&!C1&C&B&!A1&!A|!E1&E&!D1&!D&!C1&C&B&!A1&!A|!E1&E&!D1&!D&C1&C&B&!A1&!A|E1&!E&!D1&!D&C1&C&B&!A1&!A|!E1&!E&!D1&!D&C1&C&B&!A1&!A|!E1&!E&!D1&!D&C1&!C&B&!A1&!A|E1&!E&!D1&!D&C1&!C&B&!A1&!A|!E1&E&!D1&!D&C1&!C&B&!A1&!A|!E1&!E&!D1&D&!C1&!C&B&!A1&!A|E1&!E&!D1&D&!C1&!C&B&!A1&!A|!E1&E&!D1&D&!C1&!C&B&!A1&!A|!E1&E&D1&D&!C1&!C&B&!A1&!A|E1&!E&D1&D&!C1&!C&B&!A1&!A|!E1&!E&D1&D&!C1&!C&B&!A1&!A|!E1&!E&D1&!D&!C1&!C&B&!A1&!A|E1&!E&D1&!D&!C1&!C&B&!A1&!A|!E1&E&D1&!D&!C1&!C&B&!A1&!A|!E1&E&!D1&!D&!C1&!C&B&!A1&!A|E1&!E&!D1&!D&!C1&!C&B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&B&A1&!A|E1&!E&!D1&!D&!C1&!C&B&A1&!A|!E1&E&!D1&!D&!C1&!C&B&A1&!A|!E1&E&D1&!D&!C1&!C&B&A1&!A|E1&!E&D1&!D&!C1&!C&B&A1&!A|!E1&!E&D1&!D&!C1&!C&B&A1&!A|!E1&!E&D1&D&!C1&!C&B&A1&!A|E1&!E&D1&D&!C1&!C&B&A1&!A|!E1&E&D1&D&!C1&!C&B&A1&!A|!E1&E&!D1&D&!C1&!C&B&A1&!A|E1&!E&!D1&D&!C1&!C&B&A1&!A|!E1&!E&!D1&D&!C1&!C&B&A1&!A|!E1&E&!D1&!D&C1&!C&B&A1&!A|E1&!E&!D1&!D&C1&!C&B&A1&!A|!E1&!E&!D1&!D&C1&!C&B&A1&!A|!E1&!E&!D1&!D&C1&C&B&A1&!A|E1&!E&!D1&!D&C1&C&B&A1&!A|!E1&E&!D1&!D&C1&C&B&A1&!A|!E1&E&!D1&!D&!C1&C&B&A1&!A|E1&!E&!D1&!D&!C1&C&B&A1&!A|!E1&!E&!D1&!D&!C1&C&B&A1&!A|!E1&!E&!D1&!D&!C1&C&!B&A1&!A|E1&!E&!D1&!D&!C1&C&!B&A1&!A|!E1&E&!D1&!D&!C1&C&!B&A1&!A|!E1&E&D1&!D&!C1&C&!B&A1&!A|E1&!E&D1&!D&!C1&C&!B&A1&!A|!E1&!E&D1&!D&!C1&C&!B&A1&!A|!E1&!E&D1&D&!C1&C&!B&A1&!A|E1&!E&D1&D&!C1&C&!B&A1&!A|!E1&E&D1&D&!C1&C&!B&A1&!A|!E1&E&!D1&D&!C1&C&!B&A1&!A|E1&!E&!D1&D&!C1&C&!B&A1&!A|!E1&!E&!D1&D&!C1&C&!B&A1&!A|!E1&!E&!D1&D&C1&C&!B&A1&!A|E1&!E&!D1&D&C1&C&!B&A1&!A|!E1&E&!D1&D&C1&C&!B&A1&!A|!E1&E&D1&D&C1&C&!B&A1&!A|E1&!E&D1&D&C1&C&!B&A1&!A|!E1&!E&D1&D&C1&C&!B&A1&!A|!E1&!E&D1&!D&C1&C&!B&A1&!A|E1&!E&D1&!D&C1&C&!B&A1&!A|!E1&E&D1&!D&C1&C&!B&A1&!A|!E1&E&!D1&!D&C1&C&!B&A1&!A|E1&!E&!D1&!D&C1&C&!B&A1&!A|!E1&!E&!D1&!D&C1&C&!B&A1&!A|!E1&!E&!D1&!D&C1&!C&!B&A1&!A|E1&!E&!D1&!D&C1&!C&!B&A1&!A|!E1&E&!D1&!D&C1&!C&!B&A1&!A|!E1&E&D1&!D&C1&!C&!B&A1&!A|E1&!E&D1&!D&C1&!C&!B&A1&!A|!E1&!E&D1&!D&C1&!C&!B&A1&!A|!E1&!E&D1&D&C1&!C&!B&A1&!A|E1&!E&D1&D&C1&!C&!B&A1&!A|!E1&E&D1&D&C1&!C&!B&A1&!A|!E1&E&!D1&D&C1&!C&!B&A1&!A|E1&!E&!D1&D&C1&!C&!B&A1&!A|!E1&!E&!D1&D&C1&!C&!B&A1&!A|!E1&!E&!D1&D&!C1&!C&!B&A1&!A|E1&!E&!D1&D&!C1&!C&!B&A1&!A|!E1&E&!D1&D&!C1&!C&!B&A1&!A|!E1&E&D1&D&!C1&!C&!B&A1&!A|E1&!E&D1&D&!C1&!C&!B&A1&!A|!E1&!E&D1&D&!C1&!C&!B&A1&!A|!E1&!E&D1&!D&!C1&!C&!B&A1&!A|E1&!E&D1&!D&!C1&!C&!B&A1&!A|!E1&E&D1&!D&!C1&!C&!B&A1&!A|!E1&E&!D1&!D&!C1&!C&!B&A1&!A|E1&!E&!D1&!D&!C1&!C&!B&A1&!A|!E1&!E&!D1&!D&!C1&!C&!B&A1&!A|!E1&!E&!D1&!D&!C1&!C&!B&A1&A|E1&!E&!D1&!D&!C1&!C&!B&A1&A|!E1&E&!D1&!D&!C1&!C&!B&A1&A|!E1&E&D1&!D&!C1&!C&!B&A1&A|E1&!E&D1&!D&!C1&!C&!B&A1&A|!E1&!E&D1&!D&!C1&!C&!B&A1&A|!E1&!E&D1&D&!C1&!C&!B&A1&A|E1&!E&D1&D&!C1&!C&!B&A1&A|!E1&E&D1&D&!C1&!C&!B&A1&A|!E1&E&!D1&D&!C1&!C&!B&A1&A|E1&!E&!D1&D&!C1&!C&!B&A1&A|!E1&!E&!D1&D&!C1&!C&!B&A1&A|!E1&E&!D1&!D&C1&!C&!B&A1&A|E1&!E&!D1&!D&C1&!C&!B&A1&A|!E1&!E&!D1&!D&C1&!C&!B&A1&A|!E1&!E&!D1&!D&C1&C&!B&A1&A|E1&!E&!D1&!D&C1&C&!B&A1&A|!E1&E&!D1&!D&C1&C&!B&A1&A|!E1&E&!D1&!D&!C1&C&!B&A1&A|E1&!E&!D1&!D&!C1&C&!B&A1&A|!E1&!E&!D1&!D&!C1&C&!B&A1&A|!E1&!E&!D1&!D&!C1&C&B&A1&A|E1&!E&!D1&!D&!C1&C&B&A1&A|!E1&E&!D1&!D&!C1&C&B&A1&A|!E1&E&!D1&!D&C1&C&B&A1&A|E1&!E&!D1&!D&C1&C&B&A1&A|!E1&!E&!D1&!D&C1&C&B&A1&A|!E1&!E&!D1&!D&C1&!C&B&A1&A|E1&!E&!D1&!D&C1&!C&B&A1&A|!E1&E&!D1&!D&C1&!C&B&A1&A|!E1&!E&!D1&D&!C1&!C&B&A1&A|E1&!E&!D1&D&!C1&!C&B&A1&A|!E1&E&!D1&D&!C1&!C&B&A1&A|!E1&E&D1&D&!C1&!C&B&A1&A|E1&!E&D1&D&!C1&!C&B&A1&A|!E1&!E&D1&D&!C1&!C&B&A1&A|!E1&!E&D1&!D&!C1&!C&B&A1&A|E1&!E&D1&!D&!C1&!C&B&A1&A|!E1&E&D1&!D&!C1&!C&B&A1&A|!E1&E&!D1&!D&!C1&!C&B&A1&A|E1&!E&!D1&!D&!C1&!C&B&A1&A|!E1&!E&!D1&!D&!C1&!C&B&A1&A|!E1&!E&!D1&!D&!C1&!C&B&!A1&A|E1&!E&!D1&!D&!C1&!C&B&!A1&A|!E1&E&!D1&!D&!C1&!C&B&!A1&A|!E1&E&D1&!D&!C1&!C&B&!A1&A|E1&!E&D1&!D&!C1&!C&B&!A1&A|!E1&!E&D1&!D&!C1&!C&B&!A1&A|!E1&!E&D1&D&!C1&!C&B&!A1&A|E1&!E&D1&D&!C1&!C&B&!A1&A|!E1&E&D1&D&!C1&!C&B&!A1&A|!E1&E&!D1&D&!C1&!C&B&!A1&A|E1&!E&!D1&D&!C1&!C&B&!A1&A|!E1&!E&!D1&D&!C1&!C&B&!A1&A|!E1&E&!D1&!D&C1&!C&B&!A1&A|E1&!E&!D1&!D&C1&!C&B&!A1&A|!E1&!E&!D1&!D&C1&!C&B&!A1&A|!E1&!E&!D1&!D&C1&C&B&!A1&A|E1&!E&!D1&!D&C1&C&B&!A1&A|!E1&E&!D1&!D&C1&C&B&!A1&A|!E1&E&!D1&!D&!C1&C&B&!A1&A|E1&!E&!D1&!D&!C1&C&B&!A1&A|!E1&!E&!D1&!D&!C1&C&B&!A1&A|!E1&!E&!D1&!D&!C1&C&!B&!A1&A|E1&!E&!D1&!D&!C1&C&!B&!A1&A|!E1&E&!D1&!D&!C1&C&!B&!A1&A|!E1&E&D1&!D&!C1&C&!B&!A1&A|E1&!E&D1&!D&!C1&C&!B&!A1&A|!E1&!E&D1&!D&!C1&C&!B&!A1&A|!E1&!E&D1&D&!C1&C&!B&!A1&A|E1&!E&D1&D&!C1&C&!B&!A1&A|!E1&E&D1&D&!C1&C&!B&!A1&A|!E1&E&!D1&D&!C1&C&!B&!A1&A|E1&!E&!D1&D&!C1&C&!B&!A1&A|!E1&!E&!D1&D&!C1&C&!B&!A1&A|!E1&!E&!D1&D&C1&C&!B&!A1&A|E1&!E&!D1&D&C1&C&!B&!A1&A|!E1&E&!D1&D&C1&C&!B&!A1&A|!E1&E&D1&D&C1&C&!B&!A1&A|E1&!E&D1&D&C1&C&!B&!A1&A|!E1&!E&D1&D&C1&C&!B&!A1&A|!E1&!E&D1&!D&C1&C&!B&!A1&A|E1&!E&D1&!D&C1&C&!B&!A1&A|!E1&E&D1&!D&C1&C&!B&!A1&A|!E1&E&!D1&!D&C1&C&!B&!A1&A|E1&!E&!D1&!D&C1&C&!B&!A1&A|!E1&!E&!D1&!D&C1&C&!B&!A1&A|!E1&!E&!D1&!D&C1&!C&!B&!A1&A|E1&!E&!D1&!D&C1&!C&!B&!A1&A|!E1&E&!D1&!D&C1&!C&!B&!A1&A|!E1&E&D1&!D&C1&!C&!B&!A1&A|E1&!E&D1&!D&C1&!C&!B&!A1&A|!E1&!E&D1&!D&C1&!C&!B&!A1&A|!E1&!E&D1&D&C1&!C&!B&!A1&A|E1&!E&D1&D&C1&!C&!B&!A1&A|!E1&E&D1&D&C1&!C&!B&!A1&A|!E1&E&!D1&D&C1&!C&!B&!A1&A|E1&!E&!D1&D&C1&!C&!B&!A1&A|!E1&!E&!D1&D&C1&!C&!B&!A1&A|!E1&!E&!D1&D&!C1&!C&!B&!A1&A|E1&!E&!D1&D&!C1&!C&!B&!A1&A|!E1&E&!D1&D&!C1&!C&!B&!A1&A|!E1&E&D1&D&!C1&!C&!B&!A1&A|E1&!E&D1&D&!C1&!C&!B&!A1&A|!E1&!E&D1&D&!C1&!C&!B&!A1&A|!E1&!E&D1&!D&!C1&!C&!B&!A1&A|E1&!E&D1&!D&!C1&!C&!B&!A1&A|!E1&E&D1&!D&!C1&!C&!B&!A1&A|!E1&E&!D1&!D&!C1&!C&!B&!A1&A|E1&!E&!D1&!D&!C1&!C&!B&!A1&A|!E1&!E&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOOAAOI21222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAOI3221 -l OOOAOI3221 -i D C1 C B1 B A2 A1 A -o Y -f Y=(!D&!C1&!C&!B1&!B&!A2&!A1&!A|!D&C1&!C&!B1&!B&!A2&!A1&!A|!D&C1&C&!B1&!B&!A2&!A1&!A|!D&!C1&C&!B1&!B&!A2&!A1&!A|!D&!C1&C&B1&!B&!A2&!A1&!A|!D&C1&C&B1&!B&!A2&!A1&!A|!D&C1&!C&B1&!B&!A2&!A1&!A|!D&!C1&!C&B1&!B&!A2&!A1&!A|!D&!C1&!C&B1&B&!A2&!A1&!A|!D&C1&!C&B1&B&!A2&!A1&!A|!D&C1&C&B1&B&!A2&!A1&!A|!D&!C1&C&B1&B&!A2&!A1&!A|!D&!C1&C&!B1&B&!A2&!A1&!A|!D&C1&C&!B1&B&!A2&!A1&!A|!D&C1&!C&!B1&B&!A2&!A1&!A|!D&!C1&!C&!B1&B&!A2&!A1&!A|!D&!C1&!C&!B1&B&A2&!A1&!A|!D&!C1&!C&B1&B&A2&!A1&!A|!D&!C1&!C&B1&!B&A2&!A1&!A|!D&!C1&C&!B1&!B&A2&!A1&!A|!D&C1&C&!B1&!B&A2&!A1&!A|!D&C1&!C&!B1&!B&A2&!A1&!A|!D&!C1&!C&!B1&!B&A2&!A1&!A|!D&!C1&!C&!B1&!B&A2&A1&!A|!D&C1&!C&!B1&!B&A2&A1&!A|!D&C1&C&!B1&!B&A2&A1&!A|!D&!C1&C&!B1&!B&A2&A1&!A|!D&!C1&!C&B1&!B&A2&A1&!A|!D&!C1&!C&B1&B&A2&A1&!A|!D&!C1&!C&!B1&B&A2&A1&!A|!D&!C1&!C&!B1&B&!A2&A1&!A|!D&!C1&!C&B1&B&!A2&A1&!A|!D&!C1&!C&B1&!B&!A2&A1&!A|!D&!C1&C&!B1&!B&!A2&A1&!A|!D&C1&C&!B1&!B&!A2&A1&!A|!D&C1&!C&!B1&!B&!A2&A1&!A|!D&!C1&!C&!B1&!B&!A2&A1&!A|!D&!C1&!C&!B1&!B&!A2&A1&A|!D&C1&!C&!B1&!B&!A2&A1&A|!D&C1&C&!B1&!B&!A2&A1&A|!D&!C1&C&!B1&!B&!A2&A1&A|!D&!C1&!C&B1&!B&!A2&A1&A|!D&!C1&!C&B1&B&!A2&A1&A|!D&!C1&!C&!B1&B&!A2&A1&A|!D&!C1&!C&!B1&B&A2&A1&A|!D&!C1&!C&B1&B&A2&A1&A|!D&!C1&!C&B1&!B&A2&A1&A|!D&!C1&C&!B1&!B&A2&A1&A|!D&C1&C&!B1&!B&A2&A1&A|!D&C1&!C&!B1&!B&A2&A1&A|!D&!C1&!C&!B1&!B&A2&A1&A|!D&!C1&!C&!B1&!B&A2&!A1&A|!D&C1&!C&!B1&!B&A2&!A1&A|!D&C1&C&!B1&!B&A2&!A1&A|!D&!C1&C&!B1&!B&A2&!A1&A|!D&!C1&!C&B1&!B&A2&!A1&A|!D&!C1&!C&B1&B&A2&!A1&A|!D&!C1&!C&!B1&B&A2&!A1&A|!D&!C1&!C&!B1&B&!A2&!A1&A|!D&!C1&!C&B1&B&!A2&!A1&A|!D&!C1&!C&B1&!B&!A2&!A1&A|!D&!C1&C&!B1&!B&!A2&!A1&A|!D&C1&C&!B1&!B&!A2&!A1&A|!D&C1&!C&!B1&!B&!A2&!A1&A|!D&!C1&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAOI3221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOI41 -l AOI41 -i B A3 A2 A1 A -o Y -f Y=(!B&!A3&!A2&!A1&!A|!B&A3&!A2&!A1&!A|!B&A3&A2&!A1&!A|!B&!A3&A2&!A1&!A|!B&!A3&A2&A1&!A|!B&A3&A2&A1&!A|!B&A3&!A2&A1&!A|!B&!A3&!A2&A1&!A|!B&!A3&!A2&A1&A|!B&A3&!A2&A1&A|!B&!A3&A2&A1&A|!B&!A3&A2&!A1&A|!B&A3&A2&!A1&A|!B&A3&!A2&!A1&A|!B&!A3&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOI41.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOAI3221 -l AAAOAI3221 -i D C1 C B1 B A2 A1 A -o Y -f Y=!(D&C1&C&!B1&!B&!A2&!A1&!A|D&C1&C&B1&!B&!A2&!A1&!A|D&!C1&!C&B1&B&!A2&!A1&!A|D&C1&!C&B1&B&!A2&!A1&!A|D&C1&C&B1&B&!A2&!A1&!A|D&!C1&C&B1&B&!A2&!A1&!A|D&C1&C&!B1&B&!A2&!A1&!A|D&C1&C&!B1&B&A2&!A1&!A|D&!C1&C&B1&B&A2&!A1&!A|D&C1&C&B1&B&A2&!A1&!A|D&C1&!C&B1&B&A2&!A1&!A|D&!C1&!C&B1&B&A2&!A1&!A|D&C1&C&B1&!B&A2&!A1&!A|D&C1&C&!B1&!B&A2&!A1&!A|D&C1&C&!B1&!B&A2&A1&!A|D&C1&C&B1&!B&A2&A1&!A|D&!C1&!C&B1&B&A2&A1&!A|D&C1&!C&B1&B&A2&A1&!A|D&C1&C&B1&B&A2&A1&!A|D&!C1&C&B1&B&A2&A1&!A|D&C1&C&!B1&B&A2&A1&!A|D&C1&C&!B1&B&!A2&A1&!A|D&!C1&C&B1&B&!A2&A1&!A|D&C1&C&B1&B&!A2&A1&!A|D&C1&!C&B1&B&!A2&A1&!A|D&!C1&!C&B1&B&!A2&A1&!A|D&C1&C&B1&!B&!A2&A1&!A|D&C1&C&!B1&!B&!A2&A1&!A|D&C1&C&!B1&!B&!A2&A1&A|D&C1&C&B1&!B&!A2&A1&A|D&!C1&!C&B1&B&!A2&A1&A|D&C1&!C&B1&B&!A2&A1&A|D&C1&C&B1&B&!A2&A1&A|D&!C1&C&B1&B&!A2&A1&A|D&C1&C&!B1&B&!A2&A1&A|D&!C1&!C&!B1&B&A2&A1&A|D&C1&!C&!B1&B&A2&A1&A|D&C1&C&!B1&B&A2&A1&A|D&!C1&C&!B1&B&A2&A1&A|D&!C1&C&B1&B&A2&A1&A|D&C1&C&B1&B&A2&A1&A|D&C1&!C&B1&B&A2&A1&A|D&!C1&!C&B1&B&A2&A1&A|D&!C1&!C&B1&!B&A2&A1&A|D&C1&!C&B1&!B&A2&A1&A|D&C1&C&B1&!B&A2&A1&A|D&!C1&C&B1&!B&A2&A1&A|D&!C1&C&!B1&!B&A2&A1&A|D&C1&C&!B1&!B&A2&A1&A|D&C1&!C&!B1&!B&A2&A1&A|D&!C1&!C&!B1&!B&A2&A1&A|D&C1&C&!B1&!B&A2&!A1&A|D&C1&C&B1&!B&A2&!A1&A|D&!C1&!C&B1&B&A2&!A1&A|D&C1&!C&B1&B&A2&!A1&A|D&C1&C&B1&B&A2&!A1&A|D&!C1&C&B1&B&A2&!A1&A|D&C1&C&!B1&B&A2&!A1&A|D&C1&C&!B1&B&!A2&!A1&A|D&!C1&C&B1&B&!A2&!A1&A|D&C1&C&B1&B&!A2&!A1&A|D&C1&!C&B1&B&!A2&!A1&A|D&!C1&!C&B1&B&!A2&!A1&A|D&C1&C&B1&!B&!A2&!A1&A|D&C1&C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOAI3221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOAI22122 -l OOAAOAI22122 -i E1 E D1 D C B1 B A1 A -o Y -f Y=!(E1&E&D1&D&!C&!B1&!B&!A1&!A|E1&E&D1&D&C&!B1&!B&!A1&!A|E1&E&D1&D&C&B1&!B&!A1&!A|E1&E&D1&D&!C&B1&!B&!A1&!A|E1&E&D1&D&!C&B1&B&!A1&!A|E1&E&D1&D&C&B1&B&!A1&!A|E1&E&D1&D&C&!B1&B&!A1&!A|E1&E&D1&D&!C&!B1&B&!A1&!A|E1&E&D1&D&!C&!B1&B&A1&!A|E1&E&!D1&D&C&!B1&B&A1&!A|E1&E&D1&D&C&!B1&B&A1&!A|E1&E&D1&!D&C&!B1&B&A1&!A|E1&E&!D1&!D&C&!B1&B&A1&!A|E1&E&!D1&!D&C&B1&B&A1&!A|E1&E&D1&!D&C&B1&B&A1&!A|E1&E&D1&D&C&B1&B&A1&!A|E1&E&!D1&D&C&B1&B&A1&!A|E1&E&D1&D&!C&B1&B&A1&!A|E1&E&D1&D&!C&B1&!B&A1&!A|E1&E&!D1&D&C&B1&!B&A1&!A|E1&E&D1&D&C&B1&!B&A1&!A|E1&E&D1&!D&C&B1&!B&A1&!A|E1&E&!D1&!D&C&B1&!B&A1&!A|E1&E&D1&D&C&!B1&!B&A1&!A|E1&E&D1&D&!C&!B1&!B&A1&!A|E1&E&D1&D&!C&!B1&!B&A1&A|E1&E&D1&D&C&!B1&!B&A1&A|E1&E&!D1&!D&C&B1&!B&A1&A|E1&E&D1&!D&C&B1&!B&A1&A|E1&E&D1&D&C&B1&!B&A1&A|E1&E&!D1&D&C&B1&!B&A1&A|E1&E&D1&D&!C&B1&!B&A1&A|E1&E&D1&D&!C&B1&B&A1&A|E1&E&!D1&D&C&B1&B&A1&A|E1&E&D1&D&C&B1&B&A1&A|E1&E&D1&!D&C&B1&B&A1&A|E1&E&!D1&!D&C&B1&B&A1&A|E1&E&!D1&!D&C&!B1&B&A1&A|E1&E&D1&!D&C&!B1&B&A1&A|E1&E&D1&D&C&!B1&B&A1&A|E1&E&!D1&D&C&!B1&B&A1&A|E1&E&D1&D&!C&!B1&B&A1&A|E1&E&D1&D&!C&!B1&B&!A1&A|E1&E&!D1&D&C&!B1&B&!A1&A|E1&E&D1&D&C&!B1&B&!A1&A|E1&E&D1&!D&C&!B1&B&!A1&A|E1&E&!D1&!D&C&!B1&B&!A1&A|E1&E&!D1&!D&C&B1&B&!A1&A|E1&E&D1&!D&C&B1&B&!A1&A|E1&E&D1&D&C&B1&B&!A1&A|E1&E&!D1&D&C&B1&B&!A1&A|E1&E&D1&D&!C&B1&B&!A1&A|E1&E&D1&D&!C&B1&!B&!A1&A|E1&E&!D1&D&C&B1&!B&!A1&A|E1&E&D1&D&C&B1&!B&!A1&A|E1&E&D1&!D&C&B1&!B&!A1&A|E1&E&!D1&!D&C&B1&!B&!A1&A|E1&E&D1&D&C&!B1&!B&!A1&A|E1&E&D1&D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOAI22122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOI21241 -l AOOAAOI21241 -i E D3 D2 D1 D C1 C B A1 A -o Y -f Y=(!E&!D3&!D2&!D1&!D&!C1&!C&!B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&!B&!A1&!A|!E&D3&D2&!D1&!D&!C1&!C&!B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&!B&!A1&!A|!E&!D3&D2&D1&!D&!C1&!C&!B&!A1&!A|!E&D3&D2&D1&!D&!C1&!C&!B&!A1&!A|!E&D3&!D2&D1&!D&!C1&!C&!B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&!B&!A1&!A|!E&!D3&!D2&D1&D&!C1&!C&!B&!A1&!A|!E&D3&!D2&D1&D&!C1&!C&!B&!A1&!A|!E&!D3&D2&D1&D&!C1&!C&!B&!A1&!A|!E&!D3&D2&!D1&D&!C1&!C&!B&!A1&!A|!E&D3&D2&!D1&D&!C1&!C&!B&!A1&!A|!E&D3&!D2&!D1&D&!C1&!C&!B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&!B&!A1&!A|!E&!D3&!D2&!D1&D&C1&!C&!B&!A1&!A|!E&D3&!D2&!D1&D&C1&!C&!B&!A1&!A|!E&D3&D2&!D1&D&C1&!C&!B&!A1&!A|!E&!D3&D2&!D1&D&C1&!C&!B&!A1&!A|!E&!D3&D2&D1&D&C1&!C&!B&!A1&!A|!E&D3&!D2&D1&D&C1&!C&!B&!A1&!A|!E&!D3&!D2&D1&D&C1&!C&!B&!A1&!A|!E&!D3&!D2&D1&!D&C1&!C&!B&!A1&!A|!E&D3&!D2&D1&!D&C1&!C&!B&!A1&!A|!E&D3&D2&D1&!D&C1&!C&!B&!A1&!A|!E&!D3&D2&D1&!D&C1&!C&!B&!A1&!A|!E&!D3&D2&!D1&!D&C1&!C&!B&!A1&!A|!E&D3&D2&!D1&!D&C1&!C&!B&!A1&!A|!E&D3&!D2&!D1&!D&C1&!C&!B&!A1&!A|!E&!D3&!D2&!D1&!D&C1&!C&!B&!A1&!A|!E&!D3&!D2&!D1&!D&C1&C&!B&!A1&!A|!E&D3&!D2&!D1&!D&C1&C&!B&!A1&!A|!E&D3&D2&!D1&!D&C1&C&!B&!A1&!A|!E&!D3&D2&!D1&!D&C1&C&!B&!A1&!A|!E&!D3&D2&D1&!D&C1&C&!B&!A1&!A|!E&D3&D2&D1&!D&C1&C&!B&!A1&!A|!E&D3&!D2&D1&!D&C1&C&!B&!A1&!A|!E&!D3&!D2&D1&!D&C1&C&!B&!A1&!A|!E&!D3&!D2&D1&D&C1&C&!B&!A1&!A|!E&D3&!D2&D1&D&C1&C&!B&!A1&!A|!E&!D3&D2&D1&D&C1&C&!B&!A1&!A|!E&!D3&D2&!D1&D&C1&C&!B&!A1&!A|!E&D3&D2&!D1&D&C1&C&!B&!A1&!A|!E&D3&!D2&!D1&D&C1&C&!B&!A1&!A|!E&!D3&!D2&!D1&D&C1&C&!B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&C&!B&!A1&!A|!E&D3&!D2&!D1&D&!C1&C&!B&!A1&!A|!E&D3&D2&!D1&D&!C1&C&!B&!A1&!A|!E&!D3&D2&!D1&D&!C1&C&!B&!A1&!A|!E&!D3&D2&D1&D&!C1&C&!B&!A1&!A|!E&D3&!D2&D1&D&!C1&C&!B&!A1&!A|!E&!D3&!D2&D1&D&!C1&C&!B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&C&!B&!A1&!A|!E&D3&!D2&D1&!D&!C1&C&!B&!A1&!A|!E&D3&D2&D1&!D&!C1&C&!B&!A1&!A|!E&!D3&D2&D1&!D&!C1&C&!B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&C&!B&!A1&!A|!E&D3&D2&!D1&!D&!C1&C&!B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&C&!B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&C&!B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&B&!A1&!A|!E&D3&!D2&!D1&D&!C1&!C&B&!A1&!A|!E&D3&D2&!D1&D&!C1&!C&B&!A1&!A|!E&!D3&D2&!D1&D&!C1&!C&B&!A1&!A|!E&!D3&D2&D1&D&!C1&!C&B&!A1&!A|!E&D3&!D2&D1&D&!C1&!C&B&!A1&!A|!E&!D3&!D2&D1&D&!C1&!C&B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&B&!A1&!A|!E&D3&!D2&D1&!D&!C1&!C&B&!A1&!A|!E&D3&D2&D1&!D&!C1&!C&B&!A1&!A|!E&!D3&D2&D1&!D&!C1&!C&B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&B&!A1&!A|!E&D3&D2&!D1&!D&!C1&!C&B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&B&A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&B&A1&!A|!E&D3&D2&!D1&!D&!C1&!C&B&A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&B&A1&!A|!E&!D3&D2&D1&!D&!C1&!C&B&A1&!A|!E&D3&D2&D1&!D&!C1&!C&B&A1&!A|!E&D3&!D2&D1&!D&!C1&!C&B&A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&B&A1&!A|!E&!D3&!D2&D1&D&!C1&!C&B&A1&!A|!E&D3&!D2&D1&D&!C1&!C&B&A1&!A|!E&!D3&D2&D1&D&!C1&!C&B&A1&!A|!E&!D3&D2&!D1&D&!C1&!C&B&A1&!A|!E&D3&D2&!D1&D&!C1&!C&B&A1&!A|!E&D3&!D2&!D1&D&!C1&!C&B&A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&B&A1&!A|!E&!D3&!D2&!D1&!D&!C1&C&!B&A1&!A|!E&D3&!D2&!D1&!D&!C1&C&!B&A1&!A|!E&D3&D2&!D1&!D&!C1&C&!B&A1&!A|!E&!D3&D2&!D1&!D&!C1&C&!B&A1&!A|!E&!D3&D2&D1&!D&!C1&C&!B&A1&!A|!E&D3&D2&D1&!D&!C1&C&!B&A1&!A|!E&D3&!D2&D1&!D&!C1&C&!B&A1&!A|!E&!D3&!D2&D1&!D&!C1&C&!B&A1&!A|!E&!D3&!D2&D1&D&!C1&C&!B&A1&!A|!E&D3&!D2&D1&D&!C1&C&!B&A1&!A|!E&!D3&D2&D1&D&!C1&C&!B&A1&!A|!E&!D3&D2&!D1&D&!C1&C&!B&A1&!A|!E&D3&D2&!D1&D&!C1&C&!B&A1&!A|!E&D3&!D2&!D1&D&!C1&C&!B&A1&!A|!E&!D3&!D2&!D1&D&!C1&C&!B&A1&!A|!E&!D3&!D2&!D1&D&C1&C&!B&A1&!A|!E&D3&!D2&!D1&D&C1&C&!B&A1&!A|!E&D3&D2&!D1&D&C1&C&!B&A1&!A|!E&!D3&D2&!D1&D&C1&C&!B&A1&!A|!E&!D3&D2&D1&D&C1&C&!B&A1&!A|!E&D3&!D2&D1&D&C1&C&!B&A1&!A|!E&!D3&!D2&D1&D&C1&C&!B&A1&!A|!E&!D3&!D2&D1&!D&C1&C&!B&A1&!A|!E&D3&!D2&D1&!D&C1&C&!B&A1&!A|!E&D3&D2&D1&!D&C1&C&!B&A1&!A|!E&!D3&D2&D1&!D&C1&C&!B&A1&!A|!E&!D3&D2&!D1&!D&C1&C&!B&A1&!A|!E&D3&D2&!D1&!D&C1&C&!B&A1&!A|!E&D3&!D2&!D1&!D&C1&C&!B&A1&!A|!E&!D3&!D2&!D1&!D&C1&C&!B&A1&!A|!E&!D3&!D2&!D1&!D&C1&!C&!B&A1&!A|!E&D3&!D2&!D1&!D&C1&!C&!B&A1&!A|!E&D3&D2&!D1&!D&C1&!C&!B&A1&!A|!E&!D3&D2&!D1&!D&C1&!C&!B&A1&!A|!E&!D3&D2&D1&!D&C1&!C&!B&A1&!A|!E&D3&D2&D1&!D&C1&!C&!B&A1&!A|!E&D3&!D2&D1&!D&C1&!C&!B&A1&!A|!E&!D3&!D2&D1&!D&C1&!C&!B&A1&!A|!E&!D3&!D2&D1&D&C1&!C&!B&A1&!A|!E&D3&!D2&D1&D&C1&!C&!B&A1&!A|!E&!D3&D2&D1&D&C1&!C&!B&A1&!A|!E&!D3&D2&!D1&D&C1&!C&!B&A1&!A|!E&D3&D2&!D1&D&C1&!C&!B&A1&!A|!E&D3&!D2&!D1&D&C1&!C&!B&A1&!A|!E&!D3&!D2&!D1&D&C1&!C&!B&A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&!B&A1&!A|!E&D3&!D2&!D1&D&!C1&!C&!B&A1&!A|!E&D3&D2&!D1&D&!C1&!C&!B&A1&!A|!E&!D3&D2&!D1&D&!C1&!C&!B&A1&!A|!E&!D3&D2&D1&D&!C1&!C&!B&A1&!A|!E&D3&!D2&D1&D&!C1&!C&!B&A1&!A|!E&!D3&!D2&D1&D&!C1&!C&!B&A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&!B&A1&!A|!E&D3&!D2&D1&!D&!C1&!C&!B&A1&!A|!E&D3&D2&D1&!D&!C1&!C&!B&A1&!A|!E&!D3&D2&D1&!D&!C1&!C&!B&A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&!B&A1&!A|!E&D3&D2&!D1&!D&!C1&!C&!B&A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&!B&A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&!B&A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&!B&A1&A|!E&D3&!D2&!D1&!D&!C1&!C&!B&A1&A|!E&D3&D2&!D1&!D&!C1&!C&!B&A1&A|!E&!D3&D2&!D1&!D&!C1&!C&!B&A1&A|!E&!D3&D2&D1&!D&!C1&!C&!B&A1&A|!E&D3&D2&D1&!D&!C1&!C&!B&A1&A|!E&D3&!D2&D1&!D&!C1&!C&!B&A1&A|!E&!D3&!D2&D1&!D&!C1&!C&!B&A1&A|!E&!D3&!D2&D1&D&!C1&!C&!B&A1&A|!E&D3&!D2&D1&D&!C1&!C&!B&A1&A|!E&!D3&D2&D1&D&!C1&!C&!B&A1&A|!E&!D3&D2&!D1&D&!C1&!C&!B&A1&A|!E&D3&D2&!D1&D&!C1&!C&!B&A1&A|!E&D3&!D2&!D1&D&!C1&!C&!B&A1&A|!E&!D3&!D2&!D1&D&!C1&!C&!B&A1&A|!E&!D3&!D2&!D1&D&!C1&!C&B&A1&A|!E&D3&!D2&!D1&D&!C1&!C&B&A1&A|!E&D3&D2&!D1&D&!C1&!C&B&A1&A|!E&!D3&D2&!D1&D&!C1&!C&B&A1&A|!E&!D3&D2&D1&D&!C1&!C&B&A1&A|!E&D3&!D2&D1&D&!C1&!C&B&A1&A|!E&!D3&!D2&D1&D&!C1&!C&B&A1&A|!E&!D3&!D2&D1&!D&!C1&!C&B&A1&A|!E&D3&!D2&D1&!D&!C1&!C&B&A1&A|!E&D3&D2&D1&!D&!C1&!C&B&A1&A|!E&!D3&D2&D1&!D&!C1&!C&B&A1&A|!E&!D3&D2&!D1&!D&!C1&!C&B&A1&A|!E&D3&D2&!D1&!D&!C1&!C&B&A1&A|!E&D3&!D2&!D1&!D&!C1&!C&B&A1&A|!E&!D3&!D2&!D1&!D&!C1&!C&B&A1&A|!E&!D3&!D2&!D1&!D&!C1&!C&B&!A1&A|!E&D3&!D2&!D1&!D&!C1&!C&B&!A1&A|!E&D3&D2&!D1&!D&!C1&!C&B&!A1&A|!E&!D3&D2&!D1&!D&!C1&!C&B&!A1&A|!E&!D3&D2&D1&!D&!C1&!C&B&!A1&A|!E&D3&D2&D1&!D&!C1&!C&B&!A1&A|!E&D3&!D2&D1&!D&!C1&!C&B&!A1&A|!E&!D3&!D2&D1&!D&!C1&!C&B&!A1&A|!E&!D3&!D2&D1&D&!C1&!C&B&!A1&A|!E&D3&!D2&D1&D&!C1&!C&B&!A1&A|!E&!D3&D2&D1&D&!C1&!C&B&!A1&A|!E&!D3&D2&!D1&D&!C1&!C&B&!A1&A|!E&D3&D2&!D1&D&!C1&!C&B&!A1&A|!E&D3&!D2&!D1&D&!C1&!C&B&!A1&A|!E&!D3&!D2&!D1&D&!C1&!C&B&!A1&A|!E&!D3&!D2&!D1&!D&!C1&C&!B&!A1&A|!E&D3&!D2&!D1&!D&!C1&C&!B&!A1&A|!E&D3&D2&!D1&!D&!C1&C&!B&!A1&A|!E&!D3&D2&!D1&!D&!C1&C&!B&!A1&A|!E&!D3&D2&D1&!D&!C1&C&!B&!A1&A|!E&D3&D2&D1&!D&!C1&C&!B&!A1&A|!E&D3&!D2&D1&!D&!C1&C&!B&!A1&A|!E&!D3&!D2&D1&!D&!C1&C&!B&!A1&A|!E&!D3&!D2&D1&D&!C1&C&!B&!A1&A|!E&D3&!D2&D1&D&!C1&C&!B&!A1&A|!E&!D3&D2&D1&D&!C1&C&!B&!A1&A|!E&!D3&D2&!D1&D&!C1&C&!B&!A1&A|!E&D3&D2&!D1&D&!C1&C&!B&!A1&A|!E&D3&!D2&!D1&D&!C1&C&!B&!A1&A|!E&!D3&!D2&!D1&D&!C1&C&!B&!A1&A|!E&!D3&!D2&!D1&D&C1&C&!B&!A1&A|!E&D3&!D2&!D1&D&C1&C&!B&!A1&A|!E&D3&D2&!D1&D&C1&C&!B&!A1&A|!E&!D3&D2&!D1&D&C1&C&!B&!A1&A|!E&!D3&D2&D1&D&C1&C&!B&!A1&A|!E&D3&!D2&D1&D&C1&C&!B&!A1&A|!E&!D3&!D2&D1&D&C1&C&!B&!A1&A|!E&!D3&!D2&D1&!D&C1&C&!B&!A1&A|!E&D3&!D2&D1&!D&C1&C&!B&!A1&A|!E&D3&D2&D1&!D&C1&C&!B&!A1&A|!E&!D3&D2&D1&!D&C1&C&!B&!A1&A|!E&!D3&D2&!D1&!D&C1&C&!B&!A1&A|!E&D3&D2&!D1&!D&C1&C&!B&!A1&A|!E&D3&!D2&!D1&!D&C1&C&!B&!A1&A|!E&!D3&!D2&!D1&!D&C1&C&!B&!A1&A|!E&!D3&!D2&!D1&!D&C1&!C&!B&!A1&A|!E&D3&!D2&!D1&!D&C1&!C&!B&!A1&A|!E&D3&D2&!D1&!D&C1&!C&!B&!A1&A|!E&!D3&D2&!D1&!D&C1&!C&!B&!A1&A|!E&!D3&D2&D1&!D&C1&!C&!B&!A1&A|!E&D3&D2&D1&!D&C1&!C&!B&!A1&A|!E&D3&!D2&D1&!D&C1&!C&!B&!A1&A|!E&!D3&!D2&D1&!D&C1&!C&!B&!A1&A|!E&!D3&!D2&D1&D&C1&!C&!B&!A1&A|!E&D3&!D2&D1&D&C1&!C&!B&!A1&A|!E&!D3&D2&D1&D&C1&!C&!B&!A1&A|!E&!D3&D2&!D1&D&C1&!C&!B&!A1&A|!E&D3&D2&!D1&D&C1&!C&!B&!A1&A|!E&D3&!D2&!D1&D&C1&!C&!B&!A1&A|!E&!D3&!D2&!D1&D&C1&!C&!B&!A1&A|!E&!D3&!D2&!D1&D&!C1&!C&!B&!A1&A|!E&D3&!D2&!D1&D&!C1&!C&!B&!A1&A|!E&D3&D2&!D1&D&!C1&!C&!B&!A1&A|!E&!D3&D2&!D1&D&!C1&!C&!B&!A1&A|!E&!D3&D2&D1&D&!C1&!C&!B&!A1&A|!E&D3&!D2&D1&D&!C1&!C&!B&!A1&A|!E&!D3&!D2&D1&D&!C1&!C&!B&!A1&A|!E&!D3&!D2&D1&!D&!C1&!C&!B&!A1&A|!E&D3&!D2&D1&!D&!C1&!C&!B&!A1&A|!E&D3&D2&D1&!D&!C1&!C&!B&!A1&A|!E&!D3&D2&D1&!D&!C1&!C&!B&!A1&A|!E&!D3&D2&!D1&!D&!C1&!C&!B&!A1&A|!E&D3&D2&!D1&!D&!C1&!C&!B&!A1&A|!E&D3&!D2&!D1&!D&!C1&!C&!B&!A1&A|!E&!D3&!D2&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOI21241.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOOAI21222 -l OAAOOOAI21222 -i E1 E D1 D C1 C B A1 A -o Y -f Y=!(!E1&E&D1&!D&C1&C&!B&!A1&!A|E1&E&D1&!D&C1&C&!B&!A1&!A|E1&!E&D1&!D&C1&C&!B&!A1&!A|E1&!E&D1&D&C1&C&!B&!A1&!A|E1&E&D1&D&C1&C&!B&!A1&!A|!E1&E&D1&D&C1&C&!B&!A1&!A|!E1&E&!D1&D&C1&C&!B&!A1&!A|E1&E&!D1&D&C1&C&!B&!A1&!A|E1&!E&!D1&D&C1&C&!B&!A1&!A|E1&!E&!D1&D&C1&C&B&!A1&!A|E1&E&!D1&D&C1&C&B&!A1&!A|!E1&E&!D1&D&C1&C&B&!A1&!A|!E1&E&D1&D&C1&C&B&!A1&!A|E1&E&D1&D&C1&C&B&!A1&!A|E1&!E&D1&D&C1&C&B&!A1&!A|E1&!E&D1&!D&C1&C&B&!A1&!A|E1&E&D1&!D&C1&C&B&!A1&!A|!E1&E&D1&!D&C1&C&B&!A1&!A|!E1&E&D1&!D&!C1&!C&B&A1&!A|E1&E&D1&!D&!C1&!C&B&A1&!A|E1&!E&D1&!D&!C1&!C&B&A1&!A|E1&!E&D1&D&!C1&!C&B&A1&!A|E1&E&D1&D&!C1&!C&B&A1&!A|!E1&E&D1&D&!C1&!C&B&A1&!A|!E1&E&!D1&D&!C1&!C&B&A1&!A|E1&E&!D1&D&!C1&!C&B&A1&!A|E1&!E&!D1&D&!C1&!C&B&A1&!A|E1&!E&!D1&D&C1&!C&B&A1&!A|E1&E&!D1&D&C1&!C&B&A1&!A|!E1&E&!D1&D&C1&!C&B&A1&!A|!E1&E&D1&D&C1&!C&B&A1&!A|E1&E&D1&D&C1&!C&B&A1&!A|E1&!E&D1&D&C1&!C&B&A1&!A|E1&!E&D1&!D&C1&!C&B&A1&!A|E1&E&D1&!D&C1&!C&B&A1&!A|!E1&E&D1&!D&C1&!C&B&A1&!A|!E1&E&D1&!D&C1&C&B&A1&!A|E1&E&D1&!D&C1&C&B&A1&!A|E1&!E&D1&!D&C1&C&B&A1&!A|E1&!E&D1&D&C1&C&B&A1&!A|E1&E&D1&D&C1&C&B&A1&!A|!E1&E&D1&D&C1&C&B&A1&!A|!E1&E&!D1&D&C1&C&B&A1&!A|E1&E&!D1&D&C1&C&B&A1&!A|E1&!E&!D1&D&C1&C&B&A1&!A|E1&!E&!D1&D&!C1&C&B&A1&!A|E1&E&!D1&D&!C1&C&B&A1&!A|!E1&E&!D1&D&!C1&C&B&A1&!A|!E1&E&D1&D&!C1&C&B&A1&!A|E1&E&D1&D&!C1&C&B&A1&!A|E1&!E&D1&D&!C1&C&B&A1&!A|E1&!E&D1&!D&!C1&C&B&A1&!A|E1&E&D1&!D&!C1&C&B&A1&!A|!E1&E&D1&!D&!C1&C&B&A1&!A|E1&!E&!D1&D&C1&C&!B&A1&!A|E1&E&!D1&D&C1&C&!B&A1&!A|!E1&E&!D1&D&C1&C&!B&A1&!A|!E1&E&D1&D&C1&C&!B&A1&!A|E1&E&D1&D&C1&C&!B&A1&!A|E1&!E&D1&D&C1&C&!B&A1&!A|E1&!E&D1&!D&C1&C&!B&A1&!A|E1&E&D1&!D&C1&C&!B&A1&!A|!E1&E&D1&!D&C1&C&!B&A1&!A|!E1&E&D1&!D&C1&C&!B&A1&A|E1&E&D1&!D&C1&C&!B&A1&A|E1&!E&D1&!D&C1&C&!B&A1&A|E1&!E&D1&D&C1&C&!B&A1&A|E1&E&D1&D&C1&C&!B&A1&A|!E1&E&D1&D&C1&C&!B&A1&A|!E1&E&!D1&D&C1&C&!B&A1&A|E1&E&!D1&D&C1&C&!B&A1&A|E1&!E&!D1&D&C1&C&!B&A1&A|!E1&E&D1&!D&!C1&C&B&A1&A|E1&E&D1&!D&!C1&C&B&A1&A|E1&!E&D1&!D&!C1&C&B&A1&A|E1&!E&D1&D&!C1&C&B&A1&A|E1&E&D1&D&!C1&C&B&A1&A|!E1&E&D1&D&!C1&C&B&A1&A|!E1&E&!D1&D&!C1&C&B&A1&A|E1&E&!D1&D&!C1&C&B&A1&A|E1&!E&!D1&D&!C1&C&B&A1&A|E1&!E&!D1&D&C1&C&B&A1&A|E1&E&!D1&D&C1&C&B&A1&A|!E1&E&!D1&D&C1&C&B&A1&A|!E1&E&D1&D&C1&C&B&A1&A|E1&E&D1&D&C1&C&B&A1&A|E1&!E&D1&D&C1&C&B&A1&A|E1&!E&D1&!D&C1&C&B&A1&A|E1&E&D1&!D&C1&C&B&A1&A|!E1&E&D1&!D&C1&C&B&A1&A|!E1&E&D1&!D&C1&!C&B&A1&A|E1&E&D1&!D&C1&!C&B&A1&A|E1&!E&D1&!D&C1&!C&B&A1&A|E1&!E&D1&D&C1&!C&B&A1&A|E1&E&D1&D&C1&!C&B&A1&A|!E1&E&D1&D&C1&!C&B&A1&A|!E1&E&!D1&D&C1&!C&B&A1&A|E1&E&!D1&D&C1&!C&B&A1&A|E1&!E&!D1&D&C1&!C&B&A1&A|E1&!E&!D1&D&!C1&!C&B&A1&A|E1&E&!D1&D&!C1&!C&B&A1&A|!E1&E&!D1&D&!C1&!C&B&A1&A|!E1&E&D1&D&!C1&!C&B&A1&A|E1&E&D1&D&!C1&!C&B&A1&A|E1&!E&D1&D&!C1&!C&B&A1&A|E1&!E&D1&!D&!C1&!C&B&A1&A|E1&E&D1&!D&!C1&!C&B&A1&A|!E1&E&D1&!D&!C1&!C&B&A1&A|!E1&E&D1&!D&!C1&!C&B&!A1&A|E1&E&D1&!D&!C1&!C&B&!A1&A|E1&!E&D1&!D&!C1&!C&B&!A1&A|E1&!E&D1&D&!C1&!C&B&!A1&A|E1&E&D1&D&!C1&!C&B&!A1&A|!E1&E&D1&D&!C1&!C&B&!A1&A|!E1&E&!D1&D&!C1&!C&B&!A1&A|E1&E&!D1&D&!C1&!C&B&!A1&A|E1&!E&!D1&D&!C1&!C&B&!A1&A|E1&!E&!D1&D&C1&!C&B&!A1&A|E1&E&!D1&D&C1&!C&B&!A1&A|!E1&E&!D1&D&C1&!C&B&!A1&A|!E1&E&D1&D&C1&!C&B&!A1&A|E1&E&D1&D&C1&!C&B&!A1&A|E1&!E&D1&D&C1&!C&B&!A1&A|E1&!E&D1&!D&C1&!C&B&!A1&A|E1&E&D1&!D&C1&!C&B&!A1&A|!E1&E&D1&!D&C1&!C&B&!A1&A|!E1&E&D1&!D&C1&C&B&!A1&A|E1&E&D1&!D&C1&C&B&!A1&A|E1&!E&D1&!D&C1&C&B&!A1&A|E1&!E&D1&D&C1&C&B&!A1&A|E1&E&D1&D&C1&C&B&!A1&A|!E1&E&D1&D&C1&C&B&!A1&A|!E1&E&!D1&D&C1&C&B&!A1&A|E1&E&!D1&D&C1&C&B&!A1&A|E1&!E&!D1&D&C1&C&B&!A1&A|E1&!E&!D1&D&!C1&C&B&!A1&A|E1&E&!D1&D&!C1&C&B&!A1&A|!E1&E&!D1&D&!C1&C&B&!A1&A|!E1&E&D1&D&!C1&C&B&!A1&A|E1&E&D1&D&!C1&C&B&!A1&A|E1&!E&D1&D&!C1&C&B&!A1&A|E1&!E&D1&!D&!C1&C&B&!A1&A|E1&E&D1&!D&!C1&C&B&!A1&A|!E1&E&D1&!D&!C1&C&B&!A1&A|E1&!E&!D1&D&C1&C&!B&!A1&A|E1&E&!D1&D&C1&C&!B&!A1&A|!E1&E&!D1&D&C1&C&!B&!A1&A|!E1&E&D1&D&C1&C&!B&!A1&A|E1&E&D1&D&C1&C&!B&!A1&A|E1&!E&D1&D&C1&C&!B&!A1&A|E1&!E&D1&!D&C1&C&!B&!A1&A|E1&E&D1&!D&C1&C&!B&!A1&A|!E1&E&D1&!D&C1&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOOAI21222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAAOAOI222311 -l AAOOAAOAOI222311 -i F E D2 D1 D C1 C B1 B A1 A -o Y -f Y=(!F&!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!F&E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!F&E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!F&E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!F&!E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!F&!E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|!F&E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!F&E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!F&E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!F&E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!F&E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!F&E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!F&E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!F&!E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!F&!E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|!F&E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|!F&E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|!F&!E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|!F&!E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|!F&E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|!F&!E&D2&D1&D&C1&C&!B1&!B&!A1&!A|!F&!E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|!F&E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|!F&E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!F&E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!F&E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!F&!E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!F&!E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|!F&E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!F&E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!F&E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!F&E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!F&E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!F&E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!F&E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!F&!E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!F&!E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|!F&E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|!F&E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!F&!E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!F&!E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|!F&E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|!F&!E&D2&D1&D&!C1&C&B1&!B&!A1&!A|!F&!E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|!F&E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|!F&E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!F&!E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!F&!E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|!F&E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|!F&E&D2&!D1&D&C1&C&B1&!B&!A1&!A|!F&!E&D2&!D1&D&C1&C&B1&!B&!A1&!A|!F&!E&D2&D1&D&C1&C&B1&!B&!A1&!A|!F&E&!D2&D1&D&C1&C&B1&!B&!A1&!A|!F&!E&!D2&D1&D&C1&C&B1&!B&!A1&!A|!F&!E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|!F&E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|!F&E&D2&D1&!D&C1&C&B1&!B&!A1&!A|!F&!E&D2&D1&!D&C1&C&B1&!B&!A1&!A|!F&!E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|!F&E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|!F&E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!F&E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!F&E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!F&!E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!F&!E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|!F&E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|!F&E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!F&!E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!F&!E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|!F&E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|!F&!E&D2&D1&D&C1&!C&B1&!B&!A1&!A|!F&!E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|!F&E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|!F&E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!F&!E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!F&!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!F&E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!F&E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!F&!E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!F&!E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|!F&E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!F&E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!F&E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!F&E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!F&E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!F&E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!F&E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!F&!E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!F&!E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|!F&E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|!F&E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!F&!E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!F&!E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|!F&E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|!F&!E&D2&D1&D&!C1&!C&B1&B&!A1&!A|!F&!E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|!F&E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|!F&E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!F&!E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!F&!E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|!F&!E&D2&!D1&D&C1&!C&B1&B&!A1&!A|!F&!E&D2&D1&D&C1&!C&B1&B&!A1&!A|!F&!E&!D2&D1&D&C1&!C&B1&B&!A1&!A|!F&!E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|!F&!E&D2&D1&!D&C1&!C&B1&B&!A1&!A|!F&!E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|!F&!E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!F&!E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|!F&!E&D2&!D1&!D&C1&C&B1&B&!A1&!A|!F&!E&D2&D1&!D&C1&C&B1&B&!A1&!A|!F&!E&!D2&D1&!D&C1&C&B1&B&!A1&!A|!F&!E&!D2&D1&D&C1&C&B1&B&!A1&!A|!F&!E&D2&D1&D&C1&C&B1&B&!A1&!A|!F&!E&D2&!D1&D&C1&C&B1&B&!A1&!A|!F&!E&!D2&!D1&D&C1&C&B1&B&!A1&!A|!F&!E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|!F&!E&D2&!D1&D&!C1&C&B1&B&!A1&!A|!F&!E&D2&D1&D&!C1&C&B1&B&!A1&!A|!F&!E&!D2&D1&D&!C1&C&B1&B&!A1&!A|!F&!E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|!F&!E&D2&D1&!D&!C1&C&B1&B&!A1&!A|!F&!E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!F&E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!F&E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!F&!E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!F&!E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|!F&E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|!F&E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!F&!E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!F&!E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|!F&E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|!F&!E&D2&D1&D&!C1&C&!B1&B&!A1&!A|!F&!E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|!F&E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|!F&E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!F&!E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!F&!E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|!F&E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|!F&E&D2&!D1&D&C1&C&!B1&B&!A1&!A|!F&!E&D2&!D1&D&C1&C&!B1&B&!A1&!A|!F&!E&D2&D1&D&C1&C&!B1&B&!A1&!A|!F&E&!D2&D1&D&C1&C&!B1&B&!A1&!A|!F&!E&!D2&D1&D&C1&C&!B1&B&!A1&!A|!F&!E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|!F&E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|!F&E&D2&D1&!D&C1&C&!B1&B&!A1&!A|!F&!E&D2&D1&!D&C1&C&!B1&B&!A1&!A|!F&!E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|!F&E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|!F&E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!F&!E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!F&!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!F&E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!F&E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!F&!E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!F&!E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|!F&E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|!F&E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!F&!E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!F&!E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|!F&E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|!F&!E&D2&D1&D&C1&!C&!B1&B&!A1&!A|!F&!E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|!F&E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|!F&E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!F&!E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!F&!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!F&E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!F&E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!F&!E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!F&!E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|!F&E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!F&E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!F&E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!F&E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!F&E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!F&E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!F&E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!F&!E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!F&!E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|!F&E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|!F&E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|!F&!E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|!F&!E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|!F&E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|!F&!E&D2&D1&D&!C1&!C&!B1&B&A1&!A|!F&!E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|!F&E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|!F&E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|!F&!E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|!F&!E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|!F&E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|!F&E&D2&!D1&D&C1&!C&!B1&B&A1&!A|!F&!E&D2&!D1&D&C1&!C&!B1&B&A1&!A|!F&!E&D2&D1&D&C1&!C&!B1&B&A1&!A|!F&E&!D2&D1&D&C1&!C&!B1&B&A1&!A|!F&!E&!D2&D1&D&C1&!C&!B1&B&A1&!A|!F&!E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|!F&E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|!F&E&D2&D1&!D&C1&!C&!B1&B&A1&!A|!F&!E&D2&D1&!D&C1&!C&!B1&B&A1&!A|!F&!E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|!F&E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|!F&E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!F&!E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!F&!E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|!F&E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|!F&E&D2&!D1&!D&C1&C&!B1&B&A1&!A|!F&!E&D2&!D1&!D&C1&C&!B1&B&A1&!A|!F&!E&D2&D1&!D&C1&C&!B1&B&A1&!A|!F&E&D2&D1&!D&C1&C&!B1&B&A1&!A|!F&E&!D2&D1&!D&C1&C&!B1&B&A1&!A|!F&!E&!D2&D1&!D&C1&C&!B1&B&A1&!A|!F&!E&!D2&D1&D&C1&C&!B1&B&A1&!A|!F&E&!D2&D1&D&C1&C&!B1&B&A1&!A|!F&!E&D2&D1&D&C1&C&!B1&B&A1&!A|!F&!E&D2&!D1&D&C1&C&!B1&B&A1&!A|!F&E&D2&!D1&D&C1&C&!B1&B&A1&!A|!F&E&!D2&!D1&D&C1&C&!B1&B&A1&!A|!F&!E&!D2&!D1&D&C1&C&!B1&B&A1&!A|!F&!E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|!F&E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|!F&E&D2&!D1&D&!C1&C&!B1&B&A1&!A|!F&!E&D2&!D1&D&!C1&C&!B1&B&A1&!A|!F&!E&D2&D1&D&!C1&C&!B1&B&A1&!A|!F&E&!D2&D1&D&!C1&C&!B1&B&A1&!A|!F&!E&!D2&D1&D&!C1&C&!B1&B&A1&!A|!F&!E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|!F&E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|!F&E&D2&D1&!D&!C1&C&!B1&B&A1&!A|!F&!E&D2&D1&!D&!C1&C&!B1&B&A1&!A|!F&!E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|!F&E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|!F&E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!F&!E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!F&!E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|!F&!E&D2&!D1&!D&!C1&C&B1&B&A1&!A|!F&!E&D2&D1&!D&!C1&C&B1&B&A1&!A|!F&!E&!D2&D1&!D&!C1&C&B1&B&A1&!A|!F&!E&!D2&D1&D&!C1&C&B1&B&A1&!A|!F&!E&D2&D1&D&!C1&C&B1&B&A1&!A|!F&!E&D2&!D1&D&!C1&C&B1&B&A1&!A|!F&!E&!D2&!D1&D&!C1&C&B1&B&A1&!A|!F&!E&!D2&!D1&D&C1&C&B1&B&A1&!A|!F&!E&D2&!D1&D&C1&C&B1&B&A1&!A|!F&!E&D2&D1&D&C1&C&B1&B&A1&!A|!F&!E&!D2&D1&D&C1&C&B1&B&A1&!A|!F&!E&!D2&D1&!D&C1&C&B1&B&A1&!A|!F&!E&D2&D1&!D&C1&C&B1&B&A1&!A|!F&!E&D2&!D1&!D&C1&C&B1&B&A1&!A|!F&!E&!D2&!D1&!D&C1&C&B1&B&A1&!A|!F&!E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|!F&!E&D2&!D1&!D&C1&!C&B1&B&A1&!A|!F&!E&D2&D1&!D&C1&!C&B1&B&A1&!A|!F&!E&!D2&D1&!D&C1&!C&B1&B&A1&!A|!F&!E&!D2&D1&D&C1&!C&B1&B&A1&!A|!F&!E&D2&D1&D&C1&!C&B1&B&A1&!A|!F&!E&D2&!D1&D&C1&!C&B1&B&A1&!A|!F&!E&!D2&!D1&D&C1&!C&B1&B&A1&!A|!F&!E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|!F&E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|!F&E&D2&!D1&D&!C1&!C&B1&B&A1&!A|!F&!E&D2&!D1&D&!C1&!C&B1&B&A1&!A|!F&!E&D2&D1&D&!C1&!C&B1&B&A1&!A|!F&E&!D2&D1&D&!C1&!C&B1&B&A1&!A|!F&!E&!D2&D1&D&!C1&!C&B1&B&A1&!A|!F&!E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|!F&E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|!F&E&D2&D1&!D&!C1&!C&B1&B&A1&!A|!F&!E&D2&D1&!D&!C1&!C&B1&B&A1&!A|!F&!E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|!F&E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|!F&E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!F&E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!F&E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!F&!E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!F&!E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|!F&E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|!F&E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|!F&!E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|!F&!E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|!F&E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|!F&!E&D2&D1&D&!C1&!C&B1&!B&A1&!A|!F&!E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|!F&E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|!F&E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|!F&!E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|!F&!E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|!F&E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|!F&E&D2&!D1&D&C1&!C&B1&!B&A1&!A|!F&!E&D2&!D1&D&C1&!C&B1&!B&A1&!A|!F&!E&D2&D1&D&C1&!C&B1&!B&A1&!A|!F&E&!D2&D1&D&C1&!C&B1&!B&A1&!A|!F&!E&!D2&D1&D&C1&!C&B1&!B&A1&!A|!F&!E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|!F&E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|!F&E&D2&D1&!D&C1&!C&B1&!B&A1&!A|!F&!E&D2&D1&!D&C1&!C&B1&!B&A1&!A|!F&!E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|!F&E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|!F&E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!F&!E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!F&!E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|!F&E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|!F&E&D2&!D1&!D&C1&C&B1&!B&A1&!A|!F&!E&D2&!D1&!D&C1&C&B1&!B&A1&!A|!F&!E&D2&D1&!D&C1&C&B1&!B&A1&!A|!F&E&D2&D1&!D&C1&C&B1&!B&A1&!A|!F&E&!D2&D1&!D&C1&C&B1&!B&A1&!A|!F&!E&!D2&D1&!D&C1&C&B1&!B&A1&!A|!F&!E&!D2&D1&D&C1&C&B1&!B&A1&!A|!F&E&!D2&D1&D&C1&C&B1&!B&A1&!A|!F&!E&D2&D1&D&C1&C&B1&!B&A1&!A|!F&!E&D2&!D1&D&C1&C&B1&!B&A1&!A|!F&E&D2&!D1&D&C1&C&B1&!B&A1&!A|!F&E&!D2&!D1&D&C1&C&B1&!B&A1&!A|!F&!E&!D2&!D1&D&C1&C&B1&!B&A1&!A|!F&!E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|!F&E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|!F&E&D2&!D1&D&!C1&C&B1&!B&A1&!A|!F&!E&D2&!D1&D&!C1&C&B1&!B&A1&!A|!F&!E&D2&D1&D&!C1&C&B1&!B&A1&!A|!F&E&!D2&D1&D&!C1&C&B1&!B&A1&!A|!F&!E&!D2&D1&D&!C1&C&B1&!B&A1&!A|!F&!E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|!F&E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|!F&E&D2&D1&!D&!C1&C&B1&!B&A1&!A|!F&!E&D2&D1&!D&!C1&C&B1&!B&A1&!A|!F&!E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|!F&E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|!F&E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!F&!E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!F&!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!F&E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!F&E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!F&!E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!F&!E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|!F&E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|!F&E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!F&!E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!F&!E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|!F&E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|!F&!E&D2&D1&D&!C1&C&!B1&!B&A1&!A|!F&!E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|!F&E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|!F&E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!F&!E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!F&!E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|!F&E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|!F&E&D2&!D1&D&C1&C&!B1&!B&A1&!A|!F&!E&D2&!D1&D&C1&C&!B1&!B&A1&!A|!F&!E&D2&D1&D&C1&C&!B1&!B&A1&!A|!F&E&!D2&D1&D&C1&C&!B1&!B&A1&!A|!F&!E&!D2&D1&D&C1&C&!B1&!B&A1&!A|!F&!E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|!F&E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|!F&E&D2&D1&!D&C1&C&!B1&!B&A1&!A|!F&!E&D2&D1&!D&C1&C&!B1&!B&A1&!A|!F&!E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|!F&E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|!F&E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!F&!E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!F&!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!F&E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!F&E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!F&!E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!F&!E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|!F&E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|!F&E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!F&!E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!F&!E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|!F&E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|!F&!E&D2&D1&D&C1&!C&!B1&!B&A1&!A|!F&!E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|!F&E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|!F&E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!F&!E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!F&!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!F&E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!F&E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!F&!E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!F&!E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|!F&E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!F&E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!F&E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!F&E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!F&E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!F&E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!F&E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!F&!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!F&!E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|!F&E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|!F&E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!F&!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!F&!E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|!F&E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|!F&!E&D2&D1&D&!C1&!C&!B1&!B&A1&A|!F&!E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|!F&E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|!F&E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!F&!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!F&!E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|!F&!E&D2&!D1&D&C1&!C&!B1&!B&A1&A|!F&!E&D2&D1&D&C1&!C&!B1&!B&A1&A|!F&!E&!D2&D1&D&C1&!C&!B1&!B&A1&A|!F&!E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|!F&!E&D2&D1&!D&C1&!C&!B1&!B&A1&A|!F&!E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|!F&!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!F&!E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|!F&!E&D2&!D1&!D&C1&C&!B1&!B&A1&A|!F&!E&D2&D1&!D&C1&C&!B1&!B&A1&A|!F&!E&!D2&D1&!D&C1&C&!B1&!B&A1&A|!F&!E&!D2&D1&D&C1&C&!B1&!B&A1&A|!F&!E&D2&D1&D&C1&C&!B1&!B&A1&A|!F&!E&D2&!D1&D&C1&C&!B1&!B&A1&A|!F&!E&!D2&!D1&D&C1&C&!B1&!B&A1&A|!F&!E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|!F&!E&D2&!D1&D&!C1&C&!B1&!B&A1&A|!F&!E&D2&D1&D&!C1&C&!B1&!B&A1&A|!F&!E&!D2&D1&D&!C1&C&!B1&!B&A1&A|!F&!E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|!F&!E&D2&D1&!D&!C1&C&!B1&!B&A1&A|!F&!E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|!F&!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!F&!E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|!F&!E&D2&!D1&!D&!C1&C&B1&!B&A1&A|!F&!E&D2&D1&!D&!C1&C&B1&!B&A1&A|!F&!E&!D2&D1&!D&!C1&C&B1&!B&A1&A|!F&!E&!D2&D1&D&!C1&C&B1&!B&A1&A|!F&!E&D2&D1&D&!C1&C&B1&!B&A1&A|!F&!E&D2&!D1&D&!C1&C&B1&!B&A1&A|!F&!E&!D2&!D1&D&!C1&C&B1&!B&A1&A|!F&!E&!D2&!D1&D&C1&C&B1&!B&A1&A|!F&!E&D2&!D1&D&C1&C&B1&!B&A1&A|!F&!E&D2&D1&D&C1&C&B1&!B&A1&A|!F&!E&!D2&D1&D&C1&C&B1&!B&A1&A|!F&!E&!D2&D1&!D&C1&C&B1&!B&A1&A|!F&!E&D2&D1&!D&C1&C&B1&!B&A1&A|!F&!E&D2&!D1&!D&C1&C&B1&!B&A1&A|!F&!E&!D2&!D1&!D&C1&C&B1&!B&A1&A|!F&!E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|!F&!E&D2&!D1&!D&C1&!C&B1&!B&A1&A|!F&!E&D2&D1&!D&C1&!C&B1&!B&A1&A|!F&!E&!D2&D1&!D&C1&!C&B1&!B&A1&A|!F&!E&!D2&D1&D&C1&!C&B1&!B&A1&A|!F&!E&D2&D1&D&C1&!C&B1&!B&A1&A|!F&!E&D2&!D1&D&C1&!C&B1&!B&A1&A|!F&!E&!D2&!D1&D&C1&!C&B1&!B&A1&A|!F&!E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|!F&E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|!F&E&D2&!D1&D&!C1&!C&B1&!B&A1&A|!F&!E&D2&!D1&D&!C1&!C&B1&!B&A1&A|!F&!E&D2&D1&D&!C1&!C&B1&!B&A1&A|!F&E&!D2&D1&D&!C1&!C&B1&!B&A1&A|!F&!E&!D2&D1&D&!C1&!C&B1&!B&A1&A|!F&!E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|!F&E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|!F&E&D2&D1&!D&!C1&!C&B1&!B&A1&A|!F&!E&D2&D1&!D&!C1&!C&B1&!B&A1&A|!F&!E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|!F&E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|!F&E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!F&!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!F&!E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!F&E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!F&E&D2&!D1&!D&!C1&!C&B1&B&A1&A|!F&!E&D2&!D1&!D&!C1&!C&B1&B&A1&A|!F&!E&D2&D1&!D&!C1&!C&B1&B&A1&A|!F&E&D2&D1&!D&!C1&!C&B1&B&A1&A|!F&E&!D2&D1&!D&!C1&!C&B1&B&A1&A|!F&!E&!D2&D1&!D&!C1&!C&B1&B&A1&A|!F&!E&!D2&D1&D&!C1&!C&B1&B&A1&A|!F&E&!D2&D1&D&!C1&!C&B1&B&A1&A|!F&!E&D2&D1&D&!C1&!C&B1&B&A1&A|!F&!E&D2&!D1&D&!C1&!C&B1&B&A1&A|!F&E&D2&!D1&D&!C1&!C&B1&B&A1&A|!F&E&!D2&!D1&D&!C1&!C&B1&B&A1&A|!F&!E&!D2&!D1&D&!C1&!C&B1&B&A1&A|!F&!E&!D2&!D1&D&C1&!C&B1&B&A1&A|!F&!E&D2&!D1&D&C1&!C&B1&B&A1&A|!F&!E&D2&D1&D&C1&!C&B1&B&A1&A|!F&!E&!D2&D1&D&C1&!C&B1&B&A1&A|!F&!E&!D2&D1&!D&C1&!C&B1&B&A1&A|!F&!E&D2&D1&!D&C1&!C&B1&B&A1&A|!F&!E&D2&!D1&!D&C1&!C&B1&B&A1&A|!F&!E&!D2&!D1&!D&C1&!C&B1&B&A1&A|!F&!E&!D2&!D1&!D&C1&C&B1&B&A1&A|!F&!E&D2&!D1&!D&C1&C&B1&B&A1&A|!F&!E&D2&D1&!D&C1&C&B1&B&A1&A|!F&!E&!D2&D1&!D&C1&C&B1&B&A1&A|!F&!E&!D2&D1&D&C1&C&B1&B&A1&A|!F&!E&D2&D1&D&C1&C&B1&B&A1&A|!F&!E&D2&!D1&D&C1&C&B1&B&A1&A|!F&!E&!D2&!D1&D&C1&C&B1&B&A1&A|!F&!E&!D2&!D1&D&!C1&C&B1&B&A1&A|!F&!E&D2&!D1&D&!C1&C&B1&B&A1&A|!F&!E&D2&D1&D&!C1&C&B1&B&A1&A|!F&!E&!D2&D1&D&!C1&C&B1&B&A1&A|!F&!E&!D2&D1&!D&!C1&C&B1&B&A1&A|!F&!E&D2&D1&!D&!C1&C&B1&B&A1&A|!F&!E&D2&!D1&!D&!C1&C&B1&B&A1&A|!F&!E&!D2&!D1&!D&!C1&C&B1&B&A1&A|!F&!E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|!F&!E&D2&!D1&!D&!C1&C&!B1&B&A1&A|!F&!E&D2&D1&!D&!C1&C&!B1&B&A1&A|!F&!E&!D2&D1&!D&!C1&C&!B1&B&A1&A|!F&!E&!D2&D1&D&!C1&C&!B1&B&A1&A|!F&!E&D2&D1&D&!C1&C&!B1&B&A1&A|!F&!E&D2&!D1&D&!C1&C&!B1&B&A1&A|!F&!E&!D2&!D1&D&!C1&C&!B1&B&A1&A|!F&!E&!D2&!D1&D&C1&C&!B1&B&A1&A|!F&!E&D2&!D1&D&C1&C&!B1&B&A1&A|!F&!E&D2&D1&D&C1&C&!B1&B&A1&A|!F&!E&!D2&D1&D&C1&C&!B1&B&A1&A|!F&!E&!D2&D1&!D&C1&C&!B1&B&A1&A|!F&!E&D2&D1&!D&C1&C&!B1&B&A1&A|!F&!E&D2&!D1&!D&C1&C&!B1&B&A1&A|!F&!E&!D2&!D1&!D&C1&C&!B1&B&A1&A|!F&!E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|!F&!E&D2&!D1&!D&C1&!C&!B1&B&A1&A|!F&!E&D2&D1&!D&C1&!C&!B1&B&A1&A|!F&!E&!D2&D1&!D&C1&!C&!B1&B&A1&A|!F&!E&!D2&D1&D&C1&!C&!B1&B&A1&A|!F&!E&D2&D1&D&C1&!C&!B1&B&A1&A|!F&!E&D2&!D1&D&C1&!C&!B1&B&A1&A|!F&!E&!D2&!D1&D&C1&!C&!B1&B&A1&A|!F&!E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|!F&E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|!F&E&D2&!D1&D&!C1&!C&!B1&B&A1&A|!F&!E&D2&!D1&D&!C1&!C&!B1&B&A1&A|!F&!E&D2&D1&D&!C1&!C&!B1&B&A1&A|!F&E&!D2&D1&D&!C1&!C&!B1&B&A1&A|!F&!E&!D2&D1&D&!C1&!C&!B1&B&A1&A|!F&!E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|!F&E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|!F&E&D2&D1&!D&!C1&!C&!B1&B&A1&A|!F&!E&D2&D1&!D&!C1&!C&!B1&B&A1&A|!F&!E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|!F&E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|!F&E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!F&!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!F&!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!F&E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!F&E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!F&!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!F&!E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|!F&E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|!F&E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|!F&!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|!F&!E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|!F&E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|!F&!E&D2&D1&D&!C1&!C&!B1&B&!A1&A|!F&!E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|!F&E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|!F&E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|!F&!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|!F&!E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|!F&E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|!F&E&D2&!D1&D&C1&!C&!B1&B&!A1&A|!F&!E&D2&!D1&D&C1&!C&!B1&B&!A1&A|!F&!E&D2&D1&D&C1&!C&!B1&B&!A1&A|!F&E&!D2&D1&D&C1&!C&!B1&B&!A1&A|!F&!E&!D2&D1&D&C1&!C&!B1&B&!A1&A|!F&!E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|!F&E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|!F&E&D2&D1&!D&C1&!C&!B1&B&!A1&A|!F&!E&D2&D1&!D&C1&!C&!B1&B&!A1&A|!F&!E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|!F&E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|!F&E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!F&!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!F&!E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|!F&E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|!F&E&D2&!D1&!D&C1&C&!B1&B&!A1&A|!F&!E&D2&!D1&!D&C1&C&!B1&B&!A1&A|!F&!E&D2&D1&!D&C1&C&!B1&B&!A1&A|!F&E&D2&D1&!D&C1&C&!B1&B&!A1&A|!F&E&!D2&D1&!D&C1&C&!B1&B&!A1&A|!F&!E&!D2&D1&!D&C1&C&!B1&B&!A1&A|!F&!E&!D2&D1&D&C1&C&!B1&B&!A1&A|!F&E&!D2&D1&D&C1&C&!B1&B&!A1&A|!F&!E&D2&D1&D&C1&C&!B1&B&!A1&A|!F&!E&D2&!D1&D&C1&C&!B1&B&!A1&A|!F&E&D2&!D1&D&C1&C&!B1&B&!A1&A|!F&E&!D2&!D1&D&C1&C&!B1&B&!A1&A|!F&!E&!D2&!D1&D&C1&C&!B1&B&!A1&A|!F&!E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|!F&E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|!F&E&D2&!D1&D&!C1&C&!B1&B&!A1&A|!F&!E&D2&!D1&D&!C1&C&!B1&B&!A1&A|!F&!E&D2&D1&D&!C1&C&!B1&B&!A1&A|!F&E&!D2&D1&D&!C1&C&!B1&B&!A1&A|!F&!E&!D2&D1&D&!C1&C&!B1&B&!A1&A|!F&!E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|!F&E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|!F&E&D2&D1&!D&!C1&C&!B1&B&!A1&A|!F&!E&D2&D1&!D&!C1&C&!B1&B&!A1&A|!F&!E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|!F&E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|!F&E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!F&!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!F&!E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|!F&!E&D2&!D1&!D&!C1&C&B1&B&!A1&A|!F&!E&D2&D1&!D&!C1&C&B1&B&!A1&A|!F&!E&!D2&D1&!D&!C1&C&B1&B&!A1&A|!F&!E&!D2&D1&D&!C1&C&B1&B&!A1&A|!F&!E&D2&D1&D&!C1&C&B1&B&!A1&A|!F&!E&D2&!D1&D&!C1&C&B1&B&!A1&A|!F&!E&!D2&!D1&D&!C1&C&B1&B&!A1&A|!F&!E&!D2&!D1&D&C1&C&B1&B&!A1&A|!F&!E&D2&!D1&D&C1&C&B1&B&!A1&A|!F&!E&D2&D1&D&C1&C&B1&B&!A1&A|!F&!E&!D2&D1&D&C1&C&B1&B&!A1&A|!F&!E&!D2&D1&!D&C1&C&B1&B&!A1&A|!F&!E&D2&D1&!D&C1&C&B1&B&!A1&A|!F&!E&D2&!D1&!D&C1&C&B1&B&!A1&A|!F&!E&!D2&!D1&!D&C1&C&B1&B&!A1&A|!F&!E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|!F&!E&D2&!D1&!D&C1&!C&B1&B&!A1&A|!F&!E&D2&D1&!D&C1&!C&B1&B&!A1&A|!F&!E&!D2&D1&!D&C1&!C&B1&B&!A1&A|!F&!E&!D2&D1&D&C1&!C&B1&B&!A1&A|!F&!E&D2&D1&D&C1&!C&B1&B&!A1&A|!F&!E&D2&!D1&D&C1&!C&B1&B&!A1&A|!F&!E&!D2&!D1&D&C1&!C&B1&B&!A1&A|!F&!E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|!F&E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|!F&E&D2&!D1&D&!C1&!C&B1&B&!A1&A|!F&!E&D2&!D1&D&!C1&!C&B1&B&!A1&A|!F&!E&D2&D1&D&!C1&!C&B1&B&!A1&A|!F&E&!D2&D1&D&!C1&!C&B1&B&!A1&A|!F&!E&!D2&D1&D&!C1&!C&B1&B&!A1&A|!F&!E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|!F&E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|!F&E&D2&D1&!D&!C1&!C&B1&B&!A1&A|!F&!E&D2&D1&!D&!C1&!C&B1&B&!A1&A|!F&!E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|!F&E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|!F&E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!F&!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!F&!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!F&E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!F&E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!F&!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!F&!E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|!F&E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|!F&E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|!F&!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|!F&!E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|!F&E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|!F&!E&D2&D1&D&!C1&!C&B1&!B&!A1&A|!F&!E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|!F&E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|!F&E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|!F&!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|!F&!E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|!F&E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|!F&E&D2&!D1&D&C1&!C&B1&!B&!A1&A|!F&!E&D2&!D1&D&C1&!C&B1&!B&!A1&A|!F&!E&D2&D1&D&C1&!C&B1&!B&!A1&A|!F&E&!D2&D1&D&C1&!C&B1&!B&!A1&A|!F&!E&!D2&D1&D&C1&!C&B1&!B&!A1&A|!F&!E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|!F&E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|!F&E&D2&D1&!D&C1&!C&B1&!B&!A1&A|!F&!E&D2&D1&!D&C1&!C&B1&!B&!A1&A|!F&!E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|!F&E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|!F&E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!F&!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!F&!E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|!F&E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|!F&E&D2&!D1&!D&C1&C&B1&!B&!A1&A|!F&!E&D2&!D1&!D&C1&C&B1&!B&!A1&A|!F&!E&D2&D1&!D&C1&C&B1&!B&!A1&A|!F&E&D2&D1&!D&C1&C&B1&!B&!A1&A|!F&E&!D2&D1&!D&C1&C&B1&!B&!A1&A|!F&!E&!D2&D1&!D&C1&C&B1&!B&!A1&A|!F&!E&!D2&D1&D&C1&C&B1&!B&!A1&A|!F&E&!D2&D1&D&C1&C&B1&!B&!A1&A|!F&!E&D2&D1&D&C1&C&B1&!B&!A1&A|!F&!E&D2&!D1&D&C1&C&B1&!B&!A1&A|!F&E&D2&!D1&D&C1&C&B1&!B&!A1&A|!F&E&!D2&!D1&D&C1&C&B1&!B&!A1&A|!F&!E&!D2&!D1&D&C1&C&B1&!B&!A1&A|!F&!E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|!F&E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|!F&E&D2&!D1&D&!C1&C&B1&!B&!A1&A|!F&!E&D2&!D1&D&!C1&C&B1&!B&!A1&A|!F&!E&D2&D1&D&!C1&C&B1&!B&!A1&A|!F&E&!D2&D1&D&!C1&C&B1&!B&!A1&A|!F&!E&!D2&D1&D&!C1&C&B1&!B&!A1&A|!F&!E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|!F&E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|!F&E&D2&D1&!D&!C1&C&B1&!B&!A1&A|!F&!E&D2&D1&!D&!C1&C&B1&!B&!A1&A|!F&!E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|!F&E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|!F&E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!F&!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!F&!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!F&E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!F&E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!F&!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!F&!E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|!F&E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|!F&E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!F&!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!F&!E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|!F&E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|!F&!E&D2&D1&D&!C1&C&!B1&!B&!A1&A|!F&!E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|!F&E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|!F&E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!F&!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!F&!E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|!F&E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|!F&E&D2&!D1&D&C1&C&!B1&!B&!A1&A|!F&!E&D2&!D1&D&C1&C&!B1&!B&!A1&A|!F&!E&D2&D1&D&C1&C&!B1&!B&!A1&A|!F&E&!D2&D1&D&C1&C&!B1&!B&!A1&A|!F&!E&!D2&D1&D&C1&C&!B1&!B&!A1&A|!F&!E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|!F&E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|!F&E&D2&D1&!D&C1&C&!B1&!B&!A1&A|!F&!E&D2&D1&!D&C1&C&!B1&!B&!A1&A|!F&!E&D2&!D1&!D&C1&C&!B1&!B&!A1&A|!F&E&D2&!D1&!D&C1&C&!B1&!B&!A1&A|!F&E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!F&!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!F&!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!F&E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!F&E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!F&!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!F&!E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|!F&E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|!F&E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!F&!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!F&!E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|!F&E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|!F&!E&D2&D1&D&C1&!C&!B1&!B&!A1&A|!F&!E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|!F&E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|!F&E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!F&!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!F&!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!F&E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!F&E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!F&!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!F&!E&D2&D1&D&!C1&!C&!B1&!B&!A1&A|!F&E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!F&!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!F&!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!F&E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!F&E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!F&!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!F&!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!F&E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!F&E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!F&!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAAOAOI222311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOAOI21121 -l OAOAOI21121 -i E D1 D C B A1 A -o Y -f Y=(!E&!D1&!D&!C&!B&!A1&!A|!E&D1&!D&!C&!B&!A1&!A|!E&D1&D&!C&!B&!A1&!A|!E&!D1&D&!C&!B&!A1&!A|!E&!D1&D&C&!B&!A1&!A|!E&D1&!D&C&!B&!A1&!A|!E&!D1&!D&C&!B&!A1&!A|!E&!D1&!D&C&B&!A1&!A|!E&D1&!D&C&B&!A1&!A|!E&!D1&D&C&B&!A1&!A|!E&!D1&D&!C&B&!A1&!A|!E&D1&D&!C&B&!A1&!A|!E&D1&!D&!C&B&!A1&!A|!E&!D1&!D&!C&B&!A1&!A|!E&!D1&!D&!C&B&A1&!A|!E&D1&!D&!C&B&A1&!A|!E&!D1&D&!C&B&A1&!A|!E&!D1&D&C&B&A1&!A|!E&D1&!D&C&B&A1&!A|!E&!D1&!D&C&B&A1&!A|!E&!D1&!D&C&!B&A1&!A|!E&D1&!D&C&!B&A1&!A|!E&!D1&D&C&!B&A1&!A|!E&!D1&D&!C&!B&A1&!A|!E&D1&D&!C&!B&A1&!A|!E&D1&!D&!C&!B&A1&!A|!E&!D1&!D&!C&!B&A1&!A|!E&!D1&!D&!C&!B&A1&A|!E&D1&!D&!C&!B&A1&A|!E&D1&D&!C&!B&A1&A|!E&!D1&D&!C&!B&A1&A|!E&!D1&D&C&!B&A1&A|!E&D1&!D&C&!B&A1&A|!E&!D1&!D&C&!B&A1&A|!E&!D1&!D&C&B&A1&A|!E&D1&!D&C&B&A1&A|!E&!D1&D&C&B&A1&A|!E&!D1&D&!C&B&A1&A|!E&D1&!D&!C&B&A1&A|!E&!D1&!D&!C&B&A1&A|!E&!D1&!D&!C&B&!A1&A|!E&D1&!D&!C&B&!A1&A|!E&!D1&D&!C&B&!A1&A|!E&!D1&D&C&B&!A1&A|!E&D1&!D&C&B&!A1&A|!E&!D1&!D&C&B&!A1&A|!E&!D1&!D&C&!B&!A1&A|!E&D1&!D&C&!B&!A1&A|!E&!D1&D&C&!B&!A1&A|!E&!D1&D&!C&!B&!A1&A|!E&D1&D&!C&!B&!A1&A|!E&D1&!D&!C&!B&!A1&A|!E&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOAOI21121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAOI2222 -l OOOAOI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B1&!B&!A1&!A|!D1&!D&C1&!C&!B1&!B&!A1&!A|!D1&!D&C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&B1&!B&!A1&!A|!D1&!D&C1&C&B1&!B&!A1&!A|!D1&!D&C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&B&!A1&!A|!D1&!D&C1&!C&B1&B&!A1&!A|!D1&!D&C1&C&B1&B&!A1&!A|!D1&!D&!C1&C&B1&B&!A1&!A|!D1&!D&!C1&C&!B1&B&!A1&!A|!D1&!D&C1&C&!B1&B&!A1&!A|!D1&!D&C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&A1&!A|!D1&!D&!C1&!C&B1&B&A1&!A|!D1&!D&!C1&!C&B1&!B&A1&!A|!D1&!D&!C1&C&!B1&!B&A1&!A|!D1&!D&C1&C&!B1&!B&A1&!A|!D1&!D&C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&A|!D1&!D&C1&!C&!B1&!B&A1&A|!D1&!D&C1&C&!B1&!B&A1&A|!D1&!D&!C1&C&!B1&!B&A1&A|!D1&!D&!C1&!C&B1&!B&A1&A|!D1&!D&!C1&!C&B1&B&A1&A|!D1&!D&!C1&!C&!B1&B&A1&A|!D1&!D&!C1&!C&!B1&B&!A1&A|!D1&!D&!C1&!C&B1&B&!A1&A|!D1&!D&!C1&!C&B1&!B&!A1&A|!D1&!D&!C1&C&!B1&!B&!A1&A|!D1&!D&C1&C&!B1&!B&!A1&A|!D1&!D&C1&!C&!B1&!B&!A1&A|!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAOI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAI3211 -l AAOAI3211 -i D C B1 B A2 A1 A -o Y -f Y=!(D&C&!B1&!B&!A2&!A1&!A|D&C&B1&!B&!A2&!A1&!A|D&!C&B1&B&!A2&!A1&!A|D&C&B1&B&!A2&!A1&!A|D&C&!B1&B&!A2&!A1&!A|D&C&!B1&B&A2&!A1&!A|D&C&B1&B&A2&!A1&!A|D&!C&B1&B&A2&!A1&!A|D&C&B1&!B&A2&!A1&!A|D&C&!B1&!B&A2&!A1&!A|D&C&!B1&!B&A2&A1&!A|D&C&B1&!B&A2&A1&!A|D&!C&B1&B&A2&A1&!A|D&C&B1&B&A2&A1&!A|D&C&!B1&B&A2&A1&!A|D&C&!B1&B&!A2&A1&!A|D&C&B1&B&!A2&A1&!A|D&!C&B1&B&!A2&A1&!A|D&C&B1&!B&!A2&A1&!A|D&C&!B1&!B&!A2&A1&!A|D&C&!B1&!B&!A2&A1&A|D&C&B1&!B&!A2&A1&A|D&!C&B1&B&!A2&A1&A|D&C&B1&B&!A2&A1&A|D&C&!B1&B&!A2&A1&A|D&!C&!B1&B&A2&A1&A|D&C&!B1&B&A2&A1&A|D&C&B1&B&A2&A1&A|D&!C&B1&B&A2&A1&A|D&!C&B1&!B&A2&A1&A|D&C&B1&!B&A2&A1&A|D&C&!B1&!B&A2&A1&A|D&!C&!B1&!B&A2&A1&A|D&C&!B1&!B&A2&!A1&A|D&C&B1&!B&A2&!A1&A|D&!C&B1&B&A2&!A1&A|D&C&B1&B&A2&!A1&A|D&C&!B1&B&A2&!A1&A|D&C&!B1&B&!A2&!A1&A|D&C&B1&B&!A2&!A1&A|D&!C&B1&B&!A2&!A1&A|D&C&B1&!B&!A2&!A1&A|D&C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAI3211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAOI21131 -l OAOOAOI21131 -i E D2 D1 D C B A1 A -o Y -f Y=(!E&!D2&!D1&!D&!C&!B&!A1&!A|!E&D2&!D1&!D&!C&!B&!A1&!A|!E&D2&D1&!D&!C&!B&!A1&!A|!E&!D2&D1&!D&!C&!B&!A1&!A|!E&!D2&D1&D&!C&!B&!A1&!A|!E&D2&D1&D&!C&!B&!A1&!A|!E&D2&!D1&D&!C&!B&!A1&!A|!E&!D2&!D1&D&!C&!B&!A1&!A|!E&!D2&!D1&!D&C&!B&!A1&!A|!E&!D2&!D1&!D&C&B&!A1&!A|!E&!D2&!D1&D&!C&B&!A1&!A|!E&D2&!D1&D&!C&B&!A1&!A|!E&D2&D1&D&!C&B&!A1&!A|!E&!D2&D1&D&!C&B&!A1&!A|!E&!D2&D1&!D&!C&B&!A1&!A|!E&D2&D1&!D&!C&B&!A1&!A|!E&D2&!D1&!D&!C&B&!A1&!A|!E&!D2&!D1&!D&!C&B&!A1&!A|!E&!D2&!D1&!D&!C&B&A1&!A|!E&!D2&!D1&!D&C&B&A1&!A|!E&!D2&!D1&!D&C&!B&A1&!A|!E&!D2&!D1&D&!C&!B&A1&!A|!E&D2&!D1&D&!C&!B&A1&!A|!E&D2&D1&D&!C&!B&A1&!A|!E&!D2&D1&D&!C&!B&A1&!A|!E&!D2&D1&!D&!C&!B&A1&!A|!E&D2&D1&!D&!C&!B&A1&!A|!E&D2&!D1&!D&!C&!B&A1&!A|!E&!D2&!D1&!D&!C&!B&A1&!A|!E&!D2&!D1&!D&!C&!B&A1&A|!E&D2&!D1&!D&!C&!B&A1&A|!E&D2&D1&!D&!C&!B&A1&A|!E&!D2&D1&!D&!C&!B&A1&A|!E&!D2&D1&D&!C&!B&A1&A|!E&D2&D1&D&!C&!B&A1&A|!E&D2&!D1&D&!C&!B&A1&A|!E&!D2&!D1&D&!C&!B&A1&A|!E&!D2&!D1&!D&C&!B&A1&A|!E&!D2&!D1&!D&C&B&A1&A|!E&!D2&!D1&!D&!C&B&A1&A|!E&!D2&!D1&!D&!C&B&!A1&A|!E&!D2&!D1&!D&C&B&!A1&A|!E&!D2&!D1&!D&C&!B&!A1&A|!E&!D2&!D1&D&!C&!B&!A1&A|!E&D2&!D1&D&!C&!B&!A1&A|!E&D2&D1&D&!C&!B&!A1&A|!E&!D2&D1&D&!C&!B&!A1&A|!E&!D2&D1&!D&!C&!B&!A1&A|!E&D2&D1&!D&!C&!B&!A1&A|!E&D2&!D1&!D&!C&!B&!A1&A|!E&!D2&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAOI21131.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOOAI22121 -l OOAOOAI22121 -i E D1 D C B1 B A1 A -o Y -f Y=!(E&!D1&D&C&!B1&!B&!A1&!A|E&D1&D&C&!B1&!B&!A1&!A|E&D1&!D&C&!B1&!B&!A1&!A|E&D1&!D&C&B1&!B&!A1&!A|E&D1&D&C&B1&!B&!A1&!A|E&!D1&D&C&B1&!B&!A1&!A|E&!D1&D&C&B1&B&!A1&!A|E&D1&D&C&B1&B&!A1&!A|E&D1&!D&C&B1&B&!A1&!A|E&D1&!D&C&!B1&B&!A1&!A|E&D1&D&C&!B1&B&!A1&!A|E&!D1&D&C&!B1&B&!A1&!A|E&D1&!D&!C&!B1&B&A1&!A|E&D1&D&!C&!B1&B&A1&!A|E&!D1&D&!C&!B1&B&A1&!A|E&!D1&D&C&!B1&B&A1&!A|E&D1&D&C&!B1&B&A1&!A|E&D1&!D&C&!B1&B&A1&!A|E&D1&!D&C&B1&B&A1&!A|E&D1&D&C&B1&B&A1&!A|E&!D1&D&C&B1&B&A1&!A|E&!D1&D&!C&B1&B&A1&!A|E&D1&D&!C&B1&B&A1&!A|E&D1&!D&!C&B1&B&A1&!A|E&D1&!D&!C&B1&!B&A1&!A|E&D1&D&!C&B1&!B&A1&!A|E&!D1&D&!C&B1&!B&A1&!A|E&!D1&D&C&B1&!B&A1&!A|E&D1&D&C&B1&!B&A1&!A|E&D1&!D&C&B1&!B&A1&!A|E&D1&!D&C&!B1&!B&A1&!A|E&D1&D&C&!B1&!B&A1&!A|E&!D1&D&C&!B1&!B&A1&!A|E&!D1&D&C&!B1&!B&A1&A|E&D1&D&C&!B1&!B&A1&A|E&D1&!D&C&!B1&!B&A1&A|E&D1&!D&C&B1&!B&A1&A|E&D1&D&C&B1&!B&A1&A|E&!D1&D&C&B1&!B&A1&A|E&!D1&D&!C&B1&!B&A1&A|E&D1&D&!C&B1&!B&A1&A|E&D1&!D&!C&B1&!B&A1&A|E&D1&!D&!C&B1&B&A1&A|E&D1&D&!C&B1&B&A1&A|E&!D1&D&!C&B1&B&A1&A|E&!D1&D&C&B1&B&A1&A|E&D1&D&C&B1&B&A1&A|E&D1&!D&C&B1&B&A1&A|E&D1&!D&C&!B1&B&A1&A|E&D1&D&C&!B1&B&A1&A|E&!D1&D&C&!B1&B&A1&A|E&!D1&D&!C&!B1&B&A1&A|E&D1&D&!C&!B1&B&A1&A|E&D1&!D&!C&!B1&B&A1&A|E&D1&!D&!C&!B1&B&!A1&A|E&D1&D&!C&!B1&B&!A1&A|E&!D1&D&!C&!B1&B&!A1&A|E&!D1&D&C&!B1&B&!A1&A|E&D1&D&C&!B1&B&!A1&A|E&D1&!D&C&!B1&B&!A1&A|E&D1&!D&C&B1&B&!A1&A|E&D1&D&C&B1&B&!A1&A|E&!D1&D&C&B1&B&!A1&A|E&!D1&D&!C&B1&B&!A1&A|E&D1&D&!C&B1&B&!A1&A|E&D1&!D&!C&B1&B&!A1&A|E&D1&!D&!C&B1&!B&!A1&A|E&D1&D&!C&B1&!B&!A1&A|E&!D1&D&!C&B1&!B&!A1&A|E&!D1&D&C&B1&!B&!A1&A|E&D1&D&C&B1&!B&!A1&A|E&D1&!D&C&B1&!B&!A1&A|E&D1&!D&C&!B1&!B&!A1&A|E&D1&D&C&!B1&!B&!A1&A|E&!D1&D&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOOAI22121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOAI33111 -l OOAOAI33111 -i E D C B2 B1 B A2 A1 A -o Y -f Y=!(E&D&!C&!B2&!B1&!B&!A2&!A1&!A|E&D&C&!B2&!B1&!B&!A2&!A1&!A|E&D&C&B2&!B1&!B&!A2&!A1&!A|E&D&!C&B2&!B1&!B&!A2&!A1&!A|E&D&!C&B2&B1&!B&!A2&!A1&!A|E&D&C&B2&B1&!B&!A2&!A1&!A|E&D&C&!B2&B1&!B&!A2&!A1&!A|E&D&!C&!B2&B1&!B&!A2&!A1&!A|E&D&!C&!B2&B1&B&!A2&!A1&!A|E&D&C&!B2&B1&B&!A2&!A1&!A|E&D&C&B2&B1&B&!A2&!A1&!A|E&D&!C&B2&B1&B&!A2&!A1&!A|E&D&!C&B2&!B1&B&!A2&!A1&!A|E&D&C&B2&!B1&B&!A2&!A1&!A|E&D&C&!B2&!B1&B&!A2&!A1&!A|E&D&!C&!B2&!B1&B&!A2&!A1&!A|E&D&!C&!B2&!B1&B&A2&!A1&!A|E&D&C&!B2&!B1&B&A2&!A1&!A|E&!D&C&!B2&!B1&B&A2&!A1&!A|E&!D&C&B2&!B1&B&A2&!A1&!A|E&D&C&B2&!B1&B&A2&!A1&!A|E&D&!C&B2&!B1&B&A2&!A1&!A|E&D&!C&B2&B1&B&A2&!A1&!A|E&D&C&B2&B1&B&A2&!A1&!A|E&!D&C&B2&B1&B&A2&!A1&!A|E&!D&C&!B2&B1&B&A2&!A1&!A|E&D&C&!B2&B1&B&A2&!A1&!A|E&D&!C&!B2&B1&B&A2&!A1&!A|E&D&!C&!B2&B1&!B&A2&!A1&!A|E&D&C&!B2&B1&!B&A2&!A1&!A|E&!D&C&!B2&B1&!B&A2&!A1&!A|E&!D&C&B2&B1&!B&A2&!A1&!A|E&D&C&B2&B1&!B&A2&!A1&!A|E&D&!C&B2&B1&!B&A2&!A1&!A|E&D&!C&B2&!B1&!B&A2&!A1&!A|E&D&C&B2&!B1&!B&A2&!A1&!A|E&!D&C&B2&!B1&!B&A2&!A1&!A|E&D&C&!B2&!B1&!B&A2&!A1&!A|E&D&!C&!B2&!B1&!B&A2&!A1&!A|E&D&!C&!B2&!B1&!B&A2&A1&!A|E&D&C&!B2&!B1&!B&A2&A1&!A|E&!D&C&B2&!B1&!B&A2&A1&!A|E&D&C&B2&!B1&!B&A2&A1&!A|E&D&!C&B2&!B1&!B&A2&A1&!A|E&D&!C&B2&B1&!B&A2&A1&!A|E&D&C&B2&B1&!B&A2&A1&!A|E&!D&C&B2&B1&!B&A2&A1&!A|E&!D&C&!B2&B1&!B&A2&A1&!A|E&D&C&!B2&B1&!B&A2&A1&!A|E&D&!C&!B2&B1&!B&A2&A1&!A|E&D&!C&!B2&B1&B&A2&A1&!A|E&D&C&!B2&B1&B&A2&A1&!A|E&!D&C&!B2&B1&B&A2&A1&!A|E&!D&C&B2&B1&B&A2&A1&!A|E&D&C&B2&B1&B&A2&A1&!A|E&D&!C&B2&B1&B&A2&A1&!A|E&D&!C&B2&!B1&B&A2&A1&!A|E&D&C&B2&!B1&B&A2&A1&!A|E&!D&C&B2&!B1&B&A2&A1&!A|E&!D&C&!B2&!B1&B&A2&A1&!A|E&D&C&!B2&!B1&B&A2&A1&!A|E&D&!C&!B2&!B1&B&A2&A1&!A|E&D&!C&!B2&!B1&B&!A2&A1&!A|E&D&C&!B2&!B1&B&!A2&A1&!A|E&!D&C&!B2&!B1&B&!A2&A1&!A|E&!D&C&B2&!B1&B&!A2&A1&!A|E&D&C&B2&!B1&B&!A2&A1&!A|E&D&!C&B2&!B1&B&!A2&A1&!A|E&D&!C&B2&B1&B&!A2&A1&!A|E&D&C&B2&B1&B&!A2&A1&!A|E&!D&C&B2&B1&B&!A2&A1&!A|E&!D&C&!B2&B1&B&!A2&A1&!A|E&D&C&!B2&B1&B&!A2&A1&!A|E&D&!C&!B2&B1&B&!A2&A1&!A|E&D&!C&!B2&B1&!B&!A2&A1&!A|E&D&C&!B2&B1&!B&!A2&A1&!A|E&!D&C&!B2&B1&!B&!A2&A1&!A|E&!D&C&B2&B1&!B&!A2&A1&!A|E&D&C&B2&B1&!B&!A2&A1&!A|E&D&!C&B2&B1&!B&!A2&A1&!A|E&D&!C&B2&!B1&!B&!A2&A1&!A|E&D&C&B2&!B1&!B&!A2&A1&!A|E&!D&C&B2&!B1&!B&!A2&A1&!A|E&D&C&!B2&!B1&!B&!A2&A1&!A|E&D&!C&!B2&!B1&!B&!A2&A1&!A|E&D&!C&!B2&!B1&!B&!A2&A1&A|E&D&C&!B2&!B1&!B&!A2&A1&A|E&!D&C&B2&!B1&!B&!A2&A1&A|E&D&C&B2&!B1&!B&!A2&A1&A|E&D&!C&B2&!B1&!B&!A2&A1&A|E&D&!C&B2&B1&!B&!A2&A1&A|E&D&C&B2&B1&!B&!A2&A1&A|E&!D&C&B2&B1&!B&!A2&A1&A|E&!D&C&!B2&B1&!B&!A2&A1&A|E&D&C&!B2&B1&!B&!A2&A1&A|E&D&!C&!B2&B1&!B&!A2&A1&A|E&D&!C&!B2&B1&B&!A2&A1&A|E&D&C&!B2&B1&B&!A2&A1&A|E&!D&C&!B2&B1&B&!A2&A1&A|E&!D&C&B2&B1&B&!A2&A1&A|E&D&C&B2&B1&B&!A2&A1&A|E&D&!C&B2&B1&B&!A2&A1&A|E&D&!C&B2&!B1&B&!A2&A1&A|E&D&C&B2&!B1&B&!A2&A1&A|E&!D&C&B2&!B1&B&!A2&A1&A|E&!D&C&!B2&!B1&B&!A2&A1&A|E&D&C&!B2&!B1&B&!A2&A1&A|E&D&!C&!B2&!B1&B&!A2&A1&A|E&D&!C&!B2&!B1&B&A2&A1&A|E&D&C&!B2&!B1&B&A2&A1&A|E&!D&C&!B2&!B1&B&A2&A1&A|E&!D&C&B2&!B1&B&A2&A1&A|E&D&C&B2&!B1&B&A2&A1&A|E&D&!C&B2&!B1&B&A2&A1&A|E&D&!C&B2&B1&B&A2&A1&A|E&D&C&B2&B1&B&A2&A1&A|E&!D&C&B2&B1&B&A2&A1&A|E&!D&C&!B2&B1&B&A2&A1&A|E&D&C&!B2&B1&B&A2&A1&A|E&D&!C&!B2&B1&B&A2&A1&A|E&D&!C&!B2&B1&!B&A2&A1&A|E&D&C&!B2&B1&!B&A2&A1&A|E&!D&C&!B2&B1&!B&A2&A1&A|E&!D&C&B2&B1&!B&A2&A1&A|E&D&C&B2&B1&!B&A2&A1&A|E&D&!C&B2&B1&!B&A2&A1&A|E&D&!C&B2&!B1&!B&A2&A1&A|E&D&C&B2&!B1&!B&A2&A1&A|E&!D&C&B2&!B1&!B&A2&A1&A|E&D&C&!B2&!B1&!B&A2&A1&A|E&D&!C&!B2&!B1&!B&A2&A1&A|E&D&!C&!B2&!B1&!B&A2&!A1&A|E&D&C&!B2&!B1&!B&A2&!A1&A|E&!D&C&B2&!B1&!B&A2&!A1&A|E&D&C&B2&!B1&!B&A2&!A1&A|E&D&!C&B2&!B1&!B&A2&!A1&A|E&D&!C&B2&B1&!B&A2&!A1&A|E&D&C&B2&B1&!B&A2&!A1&A|E&!D&C&B2&B1&!B&A2&!A1&A|E&!D&C&!B2&B1&!B&A2&!A1&A|E&D&C&!B2&B1&!B&A2&!A1&A|E&D&!C&!B2&B1&!B&A2&!A1&A|E&D&!C&!B2&B1&B&A2&!A1&A|E&D&C&!B2&B1&B&A2&!A1&A|E&!D&C&!B2&B1&B&A2&!A1&A|E&!D&C&B2&B1&B&A2&!A1&A|E&D&C&B2&B1&B&A2&!A1&A|E&D&!C&B2&B1&B&A2&!A1&A|E&D&!C&B2&!B1&B&A2&!A1&A|E&D&C&B2&!B1&B&A2&!A1&A|E&!D&C&B2&!B1&B&A2&!A1&A|E&!D&C&!B2&!B1&B&A2&!A1&A|E&D&C&!B2&!B1&B&A2&!A1&A|E&D&!C&!B2&!B1&B&A2&!A1&A|E&D&!C&!B2&!B1&B&!A2&!A1&A|E&D&C&!B2&!B1&B&!A2&!A1&A|E&!D&C&!B2&!B1&B&!A2&!A1&A|E&!D&C&B2&!B1&B&!A2&!A1&A|E&D&C&B2&!B1&B&!A2&!A1&A|E&D&!C&B2&!B1&B&!A2&!A1&A|E&D&!C&B2&B1&B&!A2&!A1&A|E&D&C&B2&B1&B&!A2&!A1&A|E&!D&C&B2&B1&B&!A2&!A1&A|E&!D&C&!B2&B1&B&!A2&!A1&A|E&D&C&!B2&B1&B&!A2&!A1&A|E&D&!C&!B2&B1&B&!A2&!A1&A|E&D&!C&!B2&B1&!B&!A2&!A1&A|E&D&C&!B2&B1&!B&!A2&!A1&A|E&!D&C&!B2&B1&!B&!A2&!A1&A|E&!D&C&B2&B1&!B&!A2&!A1&A|E&D&C&B2&B1&!B&!A2&!A1&A|E&D&!C&B2&B1&!B&!A2&!A1&A|E&D&!C&B2&!B1&!B&!A2&!A1&A|E&D&C&B2&!B1&!B&!A2&!A1&A|E&!D&C&B2&!B1&!B&!A2&!A1&A|E&D&C&!B2&!B1&!B&!A2&!A1&A|E&D&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOAI33111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAI2123 -l OAOOAI2123 -i D2 D1 D C1 C B A1 A -o Y -f Y=(!D2&!D1&!D&!C1&!C&!B&!A1&!A|D2&!D1&!D&!C1&!C&!B&!A1&!A|D2&D1&!D&!C1&!C&!B&!A1&!A|!D2&D1&!D&!C1&!C&!B&!A1&!A|!D2&D1&D&!C1&!C&!B&!A1&!A|D2&D1&D&!C1&!C&!B&!A1&!A|D2&!D1&D&!C1&!C&!B&!A1&!A|!D2&!D1&D&!C1&!C&!B&!A1&!A|!D2&!D1&!D&C1&!C&!B&!A1&!A|!D2&!D1&!D&C1&C&!B&!A1&!A|!D2&!D1&!D&!C1&C&!B&!A1&!A|!D2&!D1&!D&!C1&C&B&!A1&!A|!D2&!D1&!D&C1&C&B&!A1&!A|!D2&!D1&!D&C1&!C&B&!A1&!A|!D2&!D1&D&!C1&!C&B&!A1&!A|D2&!D1&D&!C1&!C&B&!A1&!A|D2&D1&D&!C1&!C&B&!A1&!A|!D2&D1&D&!C1&!C&B&!A1&!A|!D2&D1&!D&!C1&!C&B&!A1&!A|D2&D1&!D&!C1&!C&B&!A1&!A|D2&!D1&!D&!C1&!C&B&!A1&!A|!D2&!D1&!D&!C1&!C&B&!A1&!A|!D2&!D1&!D&!C1&!C&B&A1&!A|!D2&!D1&!D&C1&!C&B&A1&!A|!D2&!D1&!D&C1&C&B&A1&!A|!D2&!D1&!D&!C1&C&B&A1&!A|!D2&!D1&!D&!C1&C&!B&A1&!A|!D2&!D1&!D&C1&C&!B&A1&!A|!D2&!D1&!D&C1&!C&!B&A1&!A|!D2&!D1&D&!C1&!C&!B&A1&!A|D2&!D1&D&!C1&!C&!B&A1&!A|D2&D1&D&!C1&!C&!B&A1&!A|!D2&D1&D&!C1&!C&!B&A1&!A|!D2&D1&!D&!C1&!C&!B&A1&!A|D2&D1&!D&!C1&!C&!B&A1&!A|D2&!D1&!D&!C1&!C&!B&A1&!A|!D2&!D1&!D&!C1&!C&!B&A1&!A|!D2&!D1&!D&!C1&!C&!B&A1&A|D2&!D1&!D&!C1&!C&!B&A1&A|D2&D1&!D&!C1&!C&!B&A1&A|!D2&D1&!D&!C1&!C&!B&A1&A|!D2&D1&D&!C1&!C&!B&A1&A|D2&D1&D&!C1&!C&!B&A1&A|D2&!D1&D&!C1&!C&!B&A1&A|!D2&!D1&D&!C1&!C&!B&A1&A|!D2&!D1&!D&C1&!C&!B&A1&A|!D2&!D1&!D&C1&C&!B&A1&A|!D2&!D1&!D&!C1&C&!B&A1&A|!D2&!D1&!D&!C1&C&B&A1&A|!D2&!D1&!D&C1&C&B&A1&A|!D2&!D1&!D&C1&!C&B&A1&A|!D2&!D1&!D&!C1&!C&B&A1&A|!D2&!D1&!D&!C1&!C&B&!A1&A|!D2&!D1&!D&C1&!C&B&!A1&A|!D2&!D1&!D&C1&C&B&!A1&A|!D2&!D1&!D&!C1&C&B&!A1&A|!D2&!D1&!D&!C1&C&!B&!A1&A|!D2&!D1&!D&C1&C&!B&!A1&A|!D2&!D1&!D&C1&!C&!B&!A1&A|!D2&!D1&D&!C1&!C&!B&!A1&A|D2&!D1&D&!C1&!C&!B&!A1&A|D2&D1&D&!C1&!C&!B&!A1&A|!D2&D1&D&!C1&!C&!B&!A1&A|!D2&D1&!D&!C1&!C&!B&!A1&A|D2&D1&!D&!C1&!C&!B&!A1&A|D2&!D1&!D&!C1&!C&!B&!A1&A|!D2&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAI2123.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOI421 -l AAOI421 -i C B1 B A3 A2 A1 A -o Y -f Y=(!C&!B1&!B&!A3&!A2&!A1&!A|!C&B1&!B&!A3&!A2&!A1&!A|!C&!B1&B&!A3&!A2&!A1&!A|!C&!B1&B&A3&!A2&!A1&!A|!C&B1&!B&A3&!A2&!A1&!A|!C&!B1&!B&A3&!A2&!A1&!A|!C&!B1&!B&A3&A2&!A1&!A|!C&B1&!B&A3&A2&!A1&!A|!C&!B1&B&A3&A2&!A1&!A|!C&!B1&B&!A3&A2&!A1&!A|!C&B1&!B&!A3&A2&!A1&!A|!C&!B1&!B&!A3&A2&!A1&!A|!C&!B1&!B&!A3&A2&A1&!A|!C&B1&!B&!A3&A2&A1&!A|!C&!B1&B&!A3&A2&A1&!A|!C&!B1&B&A3&A2&A1&!A|!C&B1&!B&A3&A2&A1&!A|!C&!B1&!B&A3&A2&A1&!A|!C&!B1&!B&A3&!A2&A1&!A|!C&B1&!B&A3&!A2&A1&!A|!C&!B1&B&A3&!A2&A1&!A|!C&!B1&B&!A3&!A2&A1&!A|!C&B1&!B&!A3&!A2&A1&!A|!C&!B1&!B&!A3&!A2&A1&!A|!C&!B1&!B&!A3&!A2&A1&A|!C&B1&!B&!A3&!A2&A1&A|!C&!B1&B&!A3&!A2&A1&A|!C&!B1&B&A3&!A2&A1&A|!C&B1&!B&A3&!A2&A1&A|!C&!B1&!B&A3&!A2&A1&A|!C&!B1&B&!A3&A2&A1&A|!C&B1&!B&!A3&A2&A1&A|!C&!B1&!B&!A3&A2&A1&A|!C&!B1&!B&!A3&A2&!A1&A|!C&B1&!B&!A3&A2&!A1&A|!C&!B1&B&!A3&A2&!A1&A|!C&!B1&B&A3&A2&!A1&A|!C&B1&!B&A3&A2&!A1&A|!C&!B1&!B&A3&A2&!A1&A|!C&!B1&!B&A3&!A2&!A1&A|!C&B1&!B&A3&!A2&!A1&A|!C&!B1&B&A3&!A2&!A1&A|!C&!B1&B&!A3&!A2&!A1&A|!C&B1&!B&!A3&!A2&!A1&A|!C&!B1&!B&!A3&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOI421.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOAAOI21212 -l OAAOAAOI21212 -i E1 E D C1 C B A1 A -o Y -f Y=!(E1&E&!D&!C1&!C&!B&!A1&!A|E1&E&D&!C1&!C&!B&!A1&!A|E1&E&D&C1&!C&!B&!A1&!A|E1&E&!D&C1&!C&!B&!A1&!A|E1&E&!D&C1&C&!B&!A1&!A|!E1&E&D&C1&C&!B&!A1&!A|E1&E&D&C1&C&!B&!A1&!A|E1&!E&D&C1&C&!B&!A1&!A|!E1&!E&D&C1&C&!B&!A1&!A|E1&E&D&!C1&C&!B&!A1&!A|E1&E&!D&!C1&C&!B&!A1&!A|E1&E&!D&!C1&C&B&!A1&!A|E1&E&D&!C1&C&B&!A1&!A|!E1&!E&D&C1&C&B&!A1&!A|E1&!E&D&C1&C&B&!A1&!A|E1&E&D&C1&C&B&!A1&!A|!E1&E&D&C1&C&B&!A1&!A|E1&E&!D&C1&C&B&!A1&!A|E1&E&!D&C1&!C&B&!A1&!A|E1&E&D&C1&!C&B&!A1&!A|E1&E&D&!C1&!C&B&!A1&!A|E1&E&!D&!C1&!C&B&!A1&!A|E1&E&!D&!C1&!C&B&A1&!A|!E1&E&D&!C1&!C&B&A1&!A|E1&E&D&!C1&!C&B&A1&!A|E1&!E&D&!C1&!C&B&A1&!A|!E1&!E&D&!C1&!C&B&A1&!A|!E1&!E&D&C1&!C&B&A1&!A|E1&!E&D&C1&!C&B&A1&!A|E1&E&D&C1&!C&B&A1&!A|!E1&E&D&C1&!C&B&A1&!A|E1&E&!D&C1&!C&B&A1&!A|E1&E&!D&C1&C&B&A1&!A|!E1&E&D&C1&C&B&A1&!A|E1&E&D&C1&C&B&A1&!A|E1&!E&D&C1&C&B&A1&!A|!E1&!E&D&C1&C&B&A1&!A|!E1&!E&D&!C1&C&B&A1&!A|E1&!E&D&!C1&C&B&A1&!A|E1&E&D&!C1&C&B&A1&!A|!E1&E&D&!C1&C&B&A1&!A|E1&E&!D&!C1&C&B&A1&!A|E1&E&!D&!C1&C&!B&A1&!A|E1&E&D&!C1&C&!B&A1&!A|!E1&!E&D&C1&C&!B&A1&!A|E1&!E&D&C1&C&!B&A1&!A|E1&E&D&C1&C&!B&A1&!A|!E1&E&D&C1&C&!B&A1&!A|E1&E&!D&C1&C&!B&A1&!A|E1&E&!D&C1&!C&!B&A1&!A|E1&E&D&C1&!C&!B&A1&!A|E1&E&D&!C1&!C&!B&A1&!A|E1&E&!D&!C1&!C&!B&A1&!A|E1&E&!D&!C1&!C&!B&A1&A|E1&E&D&!C1&!C&!B&A1&A|E1&E&D&C1&!C&!B&A1&A|E1&E&!D&C1&!C&!B&A1&A|E1&E&!D&C1&C&!B&A1&A|!E1&E&D&C1&C&!B&A1&A|E1&E&D&C1&C&!B&A1&A|E1&!E&D&C1&C&!B&A1&A|!E1&!E&D&C1&C&!B&A1&A|E1&E&D&!C1&C&!B&A1&A|E1&E&!D&!C1&C&!B&A1&A|E1&E&!D&!C1&C&B&A1&A|!E1&E&D&!C1&C&B&A1&A|E1&E&D&!C1&C&B&A1&A|E1&!E&D&!C1&C&B&A1&A|!E1&!E&D&!C1&C&B&A1&A|!E1&!E&D&C1&C&B&A1&A|E1&!E&D&C1&C&B&A1&A|E1&E&D&C1&C&B&A1&A|!E1&E&D&C1&C&B&A1&A|E1&E&!D&C1&C&B&A1&A|E1&E&!D&C1&!C&B&A1&A|!E1&E&D&C1&!C&B&A1&A|E1&E&D&C1&!C&B&A1&A|E1&!E&D&C1&!C&B&A1&A|!E1&!E&D&C1&!C&B&A1&A|!E1&!E&D&!C1&!C&B&A1&A|E1&!E&D&!C1&!C&B&A1&A|E1&E&D&!C1&!C&B&A1&A|!E1&E&D&!C1&!C&B&A1&A|E1&E&!D&!C1&!C&B&A1&A|E1&E&!D&!C1&!C&B&!A1&A|!E1&E&D&!C1&!C&B&!A1&A|E1&E&D&!C1&!C&B&!A1&A|E1&!E&D&!C1&!C&B&!A1&A|!E1&!E&D&!C1&!C&B&!A1&A|!E1&!E&D&C1&!C&B&!A1&A|E1&!E&D&C1&!C&B&!A1&A|E1&E&D&C1&!C&B&!A1&A|!E1&E&D&C1&!C&B&!A1&A|E1&E&!D&C1&!C&B&!A1&A|E1&E&!D&C1&C&B&!A1&A|!E1&E&D&C1&C&B&!A1&A|E1&E&D&C1&C&B&!A1&A|E1&!E&D&C1&C&B&!A1&A|!E1&!E&D&C1&C&B&!A1&A|!E1&!E&D&!C1&C&B&!A1&A|E1&!E&D&!C1&C&B&!A1&A|E1&E&D&!C1&C&B&!A1&A|!E1&E&D&!C1&C&B&!A1&A|E1&E&!D&!C1&C&B&!A1&A|E1&E&!D&!C1&C&!B&!A1&A|E1&E&D&!C1&C&!B&!A1&A|!E1&!E&D&C1&C&!B&!A1&A|E1&!E&D&C1&C&!B&!A1&A|E1&E&D&C1&C&!B&!A1&A|!E1&E&D&C1&C&!B&!A1&A|E1&E&!D&C1&C&!B&!A1&A|E1&E&!D&C1&!C&!B&!A1&A|E1&E&D&C1&!C&!B&!A1&A|E1&E&D&!C1&!C&!B&!A1&A|E1&E&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOAAOI21212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOAI2231 -l OOAAOAI2231 -i D C2 C1 C B1 B A1 A -o Y -f Y=!(D&C2&C1&C&!B1&!B&!A1&!A|D&C2&C1&C&B1&!B&!A1&!A|D&C2&C1&C&B1&B&!A1&!A|D&C2&C1&C&!B1&B&!A1&!A|D&!C2&!C1&!C&!B1&B&A1&!A|D&C2&!C1&!C&!B1&B&A1&!A|D&C2&C1&!C&!B1&B&A1&!A|D&!C2&C1&!C&!B1&B&A1&!A|D&!C2&C1&C&!B1&B&A1&!A|D&C2&C1&C&!B1&B&A1&!A|D&C2&!C1&C&!B1&B&A1&!A|D&!C2&!C1&C&!B1&B&A1&!A|D&!C2&!C1&C&B1&B&A1&!A|D&C2&!C1&C&B1&B&A1&!A|D&C2&C1&C&B1&B&A1&!A|D&!C2&C1&C&B1&B&A1&!A|D&!C2&C1&!C&B1&B&A1&!A|D&C2&C1&!C&B1&B&A1&!A|D&C2&!C1&!C&B1&B&A1&!A|D&!C2&!C1&!C&B1&B&A1&!A|D&!C2&!C1&!C&B1&!B&A1&!A|D&C2&!C1&!C&B1&!B&A1&!A|D&C2&C1&!C&B1&!B&A1&!A|D&!C2&C1&!C&B1&!B&A1&!A|D&!C2&C1&C&B1&!B&A1&!A|D&C2&C1&C&B1&!B&A1&!A|D&C2&!C1&C&B1&!B&A1&!A|D&!C2&!C1&C&B1&!B&A1&!A|D&C2&C1&C&!B1&!B&A1&!A|D&C2&C1&C&!B1&!B&A1&A|D&!C2&!C1&C&B1&!B&A1&A|D&C2&!C1&C&B1&!B&A1&A|D&C2&C1&C&B1&!B&A1&A|D&!C2&C1&C&B1&!B&A1&A|D&!C2&C1&!C&B1&!B&A1&A|D&C2&C1&!C&B1&!B&A1&A|D&C2&!C1&!C&B1&!B&A1&A|D&!C2&!C1&!C&B1&!B&A1&A|D&!C2&!C1&!C&B1&B&A1&A|D&C2&!C1&!C&B1&B&A1&A|D&C2&C1&!C&B1&B&A1&A|D&!C2&C1&!C&B1&B&A1&A|D&!C2&C1&C&B1&B&A1&A|D&C2&C1&C&B1&B&A1&A|D&C2&!C1&C&B1&B&A1&A|D&!C2&!C1&C&B1&B&A1&A|D&!C2&!C1&C&!B1&B&A1&A|D&C2&!C1&C&!B1&B&A1&A|D&C2&C1&C&!B1&B&A1&A|D&!C2&C1&C&!B1&B&A1&A|D&!C2&C1&!C&!B1&B&A1&A|D&C2&C1&!C&!B1&B&A1&A|D&C2&!C1&!C&!B1&B&A1&A|D&!C2&!C1&!C&!B1&B&A1&A|D&!C2&!C1&!C&!B1&B&!A1&A|D&C2&!C1&!C&!B1&B&!A1&A|D&C2&C1&!C&!B1&B&!A1&A|D&!C2&C1&!C&!B1&B&!A1&A|D&!C2&C1&C&!B1&B&!A1&A|D&C2&C1&C&!B1&B&!A1&A|D&C2&!C1&C&!B1&B&!A1&A|D&!C2&!C1&C&!B1&B&!A1&A|D&!C2&!C1&C&B1&B&!A1&A|D&C2&!C1&C&B1&B&!A1&A|D&C2&C1&C&B1&B&!A1&A|D&!C2&C1&C&B1&B&!A1&A|D&!C2&C1&!C&B1&B&!A1&A|D&C2&C1&!C&B1&B&!A1&A|D&C2&!C1&!C&B1&B&!A1&A|D&!C2&!C1&!C&B1&B&!A1&A|D&!C2&!C1&!C&B1&!B&!A1&A|D&C2&!C1&!C&B1&!B&!A1&A|D&C2&C1&!C&B1&!B&!A1&A|D&!C2&C1&!C&B1&!B&!A1&A|D&!C2&C1&C&B1&!B&!A1&A|D&C2&C1&C&B1&!B&!A1&A|D&C2&!C1&C&B1&!B&!A1&A|D&!C2&!C1&C&B1&!B&!A1&A|D&C2&C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOAI2231.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOI21212 -l AOOAAOI21212 -i E1 E D C1 C B A1 A -o Y -f Y=!(E1&E&!D&!C1&!C&!B&!A1&!A|E1&E&D&!C1&!C&!B&!A1&!A|E1&E&D&C1&!C&!B&!A1&!A|E1&E&!D&C1&!C&!B&!A1&!A|E1&E&!D&C1&C&!B&!A1&!A|E1&E&D&C1&C&!B&!A1&!A|E1&E&D&!C1&C&!B&!A1&!A|E1&E&!D&!C1&C&!B&!A1&!A|E1&E&!D&!C1&C&B&!A1&!A|!E1&E&D&!C1&C&B&!A1&!A|E1&E&D&!C1&C&B&!A1&!A|E1&!E&D&!C1&C&B&!A1&!A|!E1&!E&D&!C1&C&B&!A1&!A|!E1&!E&D&C1&C&B&!A1&!A|E1&!E&D&C1&C&B&!A1&!A|E1&E&D&C1&C&B&!A1&!A|!E1&E&D&C1&C&B&!A1&!A|E1&E&!D&C1&C&B&!A1&!A|E1&E&!D&C1&!C&B&!A1&!A|!E1&E&D&C1&!C&B&!A1&!A|E1&E&D&C1&!C&B&!A1&!A|E1&!E&D&C1&!C&B&!A1&!A|!E1&!E&D&C1&!C&B&!A1&!A|E1&E&D&!C1&!C&B&!A1&!A|E1&E&!D&!C1&!C&B&!A1&!A|E1&E&!D&!C1&!C&B&A1&!A|E1&E&D&!C1&!C&B&A1&!A|!E1&!E&D&C1&!C&B&A1&!A|E1&!E&D&C1&!C&B&A1&!A|E1&E&D&C1&!C&B&A1&!A|!E1&E&D&C1&!C&B&A1&!A|E1&E&!D&C1&!C&B&A1&!A|E1&E&!D&C1&C&B&A1&!A|!E1&E&D&C1&C&B&A1&!A|E1&E&D&C1&C&B&A1&!A|E1&!E&D&C1&C&B&A1&!A|!E1&!E&D&C1&C&B&A1&!A|!E1&!E&D&!C1&C&B&A1&!A|E1&!E&D&!C1&C&B&A1&!A|E1&E&D&!C1&C&B&A1&!A|!E1&E&D&!C1&C&B&A1&!A|E1&E&!D&!C1&C&B&A1&!A|E1&E&!D&!C1&C&!B&A1&!A|E1&E&D&!C1&C&!B&A1&!A|E1&E&D&C1&C&!B&A1&!A|E1&E&!D&C1&C&!B&A1&!A|E1&E&!D&C1&!C&!B&A1&!A|E1&E&D&C1&!C&!B&A1&!A|E1&E&D&!C1&!C&!B&A1&!A|E1&E&!D&!C1&!C&!B&A1&!A|E1&E&!D&!C1&!C&!B&A1&A|E1&E&D&!C1&!C&!B&A1&A|!E1&!E&D&C1&!C&!B&A1&A|E1&!E&D&C1&!C&!B&A1&A|E1&E&D&C1&!C&!B&A1&A|!E1&E&D&C1&!C&!B&A1&A|E1&E&!D&C1&!C&!B&A1&A|E1&E&!D&C1&C&!B&A1&A|!E1&E&D&C1&C&!B&A1&A|E1&E&D&C1&C&!B&A1&A|E1&!E&D&C1&C&!B&A1&A|!E1&!E&D&C1&C&!B&A1&A|!E1&!E&D&!C1&C&!B&A1&A|E1&!E&D&!C1&C&!B&A1&A|E1&E&D&!C1&C&!B&A1&A|!E1&E&D&!C1&C&!B&A1&A|E1&E&!D&!C1&C&!B&A1&A|E1&E&!D&!C1&C&B&A1&A|!E1&E&D&!C1&C&B&A1&A|E1&E&D&!C1&C&B&A1&A|E1&!E&D&!C1&C&B&A1&A|!E1&!E&D&!C1&C&B&A1&A|!E1&!E&D&C1&C&B&A1&A|E1&!E&D&C1&C&B&A1&A|E1&E&D&C1&C&B&A1&A|!E1&E&D&C1&C&B&A1&A|E1&E&!D&C1&C&B&A1&A|E1&E&!D&C1&!C&B&A1&A|!E1&E&D&C1&!C&B&A1&A|E1&E&D&C1&!C&B&A1&A|E1&!E&D&C1&!C&B&A1&A|!E1&!E&D&C1&!C&B&A1&A|E1&E&D&!C1&!C&B&A1&A|E1&E&!D&!C1&!C&B&A1&A|E1&E&!D&!C1&!C&B&!A1&A|E1&E&D&!C1&!C&B&!A1&A|!E1&!E&D&C1&!C&B&!A1&A|E1&!E&D&C1&!C&B&!A1&A|E1&E&D&C1&!C&B&!A1&A|!E1&E&D&C1&!C&B&!A1&A|E1&E&!D&C1&!C&B&!A1&A|E1&E&!D&C1&C&B&!A1&A|!E1&E&D&C1&C&B&!A1&A|E1&E&D&C1&C&B&!A1&A|E1&!E&D&C1&C&B&!A1&A|!E1&!E&D&C1&C&B&!A1&A|!E1&!E&D&!C1&C&B&!A1&A|E1&!E&D&!C1&C&B&!A1&A|E1&E&D&!C1&C&B&!A1&A|!E1&E&D&!C1&C&B&!A1&A|E1&E&!D&!C1&C&B&!A1&A|E1&E&!D&!C1&C&!B&!A1&A|E1&E&D&!C1&C&!B&!A1&A|E1&E&D&C1&C&!B&!A1&A|E1&E&!D&C1&C&!B&!A1&A|E1&E&!D&C1&!C&!B&!A1&A|E1&E&D&C1&!C&!B&!A1&A|E1&E&D&!C1&!C&!B&!A1&A|E1&E&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOI21212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAOAI211311 -l OAOOAOAI211311 -i F E D2 D1 D C B A1 A -o Y -f Y=!(F&E&!D2&!D1&!D&!C&!B&!A1&!A|F&E&D2&!D1&!D&!C&!B&!A1&!A|F&E&D2&D1&!D&!C&!B&!A1&!A|F&E&!D2&D1&!D&!C&!B&!A1&!A|F&E&!D2&D1&D&!C&!B&!A1&!A|F&E&D2&D1&D&!C&!B&!A1&!A|F&E&D2&!D1&D&!C&!B&!A1&!A|F&E&!D2&!D1&D&!C&!B&!A1&!A|F&!E&!D2&!D1&D&C&!B&!A1&!A|F&E&!D2&!D1&D&C&!B&!A1&!A|F&E&D2&!D1&D&C&!B&!A1&!A|F&!E&D2&!D1&D&C&!B&!A1&!A|F&!E&D2&D1&D&C&!B&!A1&!A|F&E&D2&D1&D&C&!B&!A1&!A|F&E&!D2&D1&D&C&!B&!A1&!A|F&!E&!D2&D1&D&C&!B&!A1&!A|F&!E&!D2&D1&!D&C&!B&!A1&!A|F&E&!D2&D1&!D&C&!B&!A1&!A|F&E&D2&D1&!D&C&!B&!A1&!A|F&!E&D2&D1&!D&C&!B&!A1&!A|F&!E&D2&!D1&!D&C&!B&!A1&!A|F&E&D2&!D1&!D&C&!B&!A1&!A|F&E&!D2&!D1&!D&C&!B&!A1&!A|F&E&!D2&!D1&!D&C&B&!A1&!A|F&E&D2&!D1&!D&C&B&!A1&!A|F&!E&D2&!D1&!D&C&B&!A1&!A|F&!E&D2&D1&!D&C&B&!A1&!A|F&E&D2&D1&!D&C&B&!A1&!A|F&E&!D2&D1&!D&C&B&!A1&!A|F&!E&!D2&D1&!D&C&B&!A1&!A|F&!E&!D2&D1&D&C&B&!A1&!A|F&E&!D2&D1&D&C&B&!A1&!A|F&E&D2&D1&D&C&B&!A1&!A|F&!E&D2&D1&D&C&B&!A1&!A|F&!E&D2&!D1&D&C&B&!A1&!A|F&E&D2&!D1&D&C&B&!A1&!A|F&E&!D2&!D1&D&C&B&!A1&!A|F&!E&!D2&!D1&D&C&B&!A1&!A|F&E&!D2&!D1&D&!C&B&!A1&!A|F&E&D2&!D1&D&!C&B&!A1&!A|F&E&D2&D1&D&!C&B&!A1&!A|F&E&!D2&D1&D&!C&B&!A1&!A|F&E&!D2&D1&!D&!C&B&!A1&!A|F&E&D2&D1&!D&!C&B&!A1&!A|F&E&D2&!D1&!D&!C&B&!A1&!A|F&E&!D2&!D1&!D&!C&B&!A1&!A|F&E&!D2&!D1&!D&!C&B&A1&!A|F&E&D2&!D1&!D&!C&B&A1&!A|F&!E&D2&!D1&!D&!C&B&A1&!A|F&!E&D2&D1&!D&!C&B&A1&!A|F&E&D2&D1&!D&!C&B&A1&!A|F&E&!D2&D1&!D&!C&B&A1&!A|F&!E&!D2&D1&!D&!C&B&A1&!A|F&!E&!D2&D1&D&!C&B&A1&!A|F&E&!D2&D1&D&!C&B&A1&!A|F&E&D2&D1&D&!C&B&A1&!A|F&!E&D2&D1&D&!C&B&A1&!A|F&!E&D2&!D1&D&!C&B&A1&!A|F&E&D2&!D1&D&!C&B&A1&!A|F&E&!D2&!D1&D&!C&B&A1&!A|F&!E&!D2&!D1&D&!C&B&A1&!A|F&!E&!D2&!D1&D&C&B&A1&!A|F&E&!D2&!D1&D&C&B&A1&!A|F&E&D2&!D1&D&C&B&A1&!A|F&!E&D2&!D1&D&C&B&A1&!A|F&!E&D2&D1&D&C&B&A1&!A|F&E&D2&D1&D&C&B&A1&!A|F&E&!D2&D1&D&C&B&A1&!A|F&!E&!D2&D1&D&C&B&A1&!A|F&!E&!D2&D1&!D&C&B&A1&!A|F&E&!D2&D1&!D&C&B&A1&!A|F&E&D2&D1&!D&C&B&A1&!A|F&!E&D2&D1&!D&C&B&A1&!A|F&!E&D2&!D1&!D&C&B&A1&!A|F&E&D2&!D1&!D&C&B&A1&!A|F&E&!D2&!D1&!D&C&B&A1&!A|F&E&!D2&!D1&!D&C&!B&A1&!A|F&E&D2&!D1&!D&C&!B&A1&!A|F&!E&D2&!D1&!D&C&!B&A1&!A|F&!E&D2&D1&!D&C&!B&A1&!A|F&E&D2&D1&!D&C&!B&A1&!A|F&E&!D2&D1&!D&C&!B&A1&!A|F&!E&!D2&D1&!D&C&!B&A1&!A|F&!E&!D2&D1&D&C&!B&A1&!A|F&E&!D2&D1&D&C&!B&A1&!A|F&E&D2&D1&D&C&!B&A1&!A|F&!E&D2&D1&D&C&!B&A1&!A|F&!E&D2&!D1&D&C&!B&A1&!A|F&E&D2&!D1&D&C&!B&A1&!A|F&E&!D2&!D1&D&C&!B&A1&!A|F&!E&!D2&!D1&D&C&!B&A1&!A|F&E&!D2&!D1&D&!C&!B&A1&!A|F&E&D2&!D1&D&!C&!B&A1&!A|F&E&D2&D1&D&!C&!B&A1&!A|F&E&!D2&D1&D&!C&!B&A1&!A|F&E&!D2&D1&!D&!C&!B&A1&!A|F&E&D2&D1&!D&!C&!B&A1&!A|F&E&D2&!D1&!D&!C&!B&A1&!A|F&E&!D2&!D1&!D&!C&!B&A1&!A|F&E&!D2&!D1&!D&!C&!B&A1&A|F&E&D2&!D1&!D&!C&!B&A1&A|F&E&D2&D1&!D&!C&!B&A1&A|F&E&!D2&D1&!D&!C&!B&A1&A|F&E&!D2&D1&D&!C&!B&A1&A|F&E&D2&D1&D&!C&!B&A1&A|F&E&D2&!D1&D&!C&!B&A1&A|F&E&!D2&!D1&D&!C&!B&A1&A|F&!E&!D2&!D1&D&C&!B&A1&A|F&E&!D2&!D1&D&C&!B&A1&A|F&E&D2&!D1&D&C&!B&A1&A|F&!E&D2&!D1&D&C&!B&A1&A|F&!E&D2&D1&D&C&!B&A1&A|F&E&D2&D1&D&C&!B&A1&A|F&E&!D2&D1&D&C&!B&A1&A|F&!E&!D2&D1&D&C&!B&A1&A|F&!E&!D2&D1&!D&C&!B&A1&A|F&E&!D2&D1&!D&C&!B&A1&A|F&E&D2&D1&!D&C&!B&A1&A|F&!E&D2&D1&!D&C&!B&A1&A|F&!E&D2&!D1&!D&C&!B&A1&A|F&E&D2&!D1&!D&C&!B&A1&A|F&E&!D2&!D1&!D&C&!B&A1&A|F&E&!D2&!D1&!D&C&B&A1&A|F&E&D2&!D1&!D&C&B&A1&A|F&!E&D2&!D1&!D&C&B&A1&A|F&!E&D2&D1&!D&C&B&A1&A|F&E&D2&D1&!D&C&B&A1&A|F&E&!D2&D1&!D&C&B&A1&A|F&!E&!D2&D1&!D&C&B&A1&A|F&!E&!D2&D1&D&C&B&A1&A|F&E&!D2&D1&D&C&B&A1&A|F&E&D2&D1&D&C&B&A1&A|F&!E&D2&D1&D&C&B&A1&A|F&!E&D2&!D1&D&C&B&A1&A|F&E&D2&!D1&D&C&B&A1&A|F&E&!D2&!D1&D&C&B&A1&A|F&!E&!D2&!D1&D&C&B&A1&A|F&!E&!D2&!D1&D&!C&B&A1&A|F&E&!D2&!D1&D&!C&B&A1&A|F&E&D2&!D1&D&!C&B&A1&A|F&!E&D2&!D1&D&!C&B&A1&A|F&!E&D2&D1&D&!C&B&A1&A|F&E&D2&D1&D&!C&B&A1&A|F&E&!D2&D1&D&!C&B&A1&A|F&!E&!D2&D1&D&!C&B&A1&A|F&!E&!D2&D1&!D&!C&B&A1&A|F&E&!D2&D1&!D&!C&B&A1&A|F&E&D2&D1&!D&!C&B&A1&A|F&!E&D2&D1&!D&!C&B&A1&A|F&!E&D2&!D1&!D&!C&B&A1&A|F&E&D2&!D1&!D&!C&B&A1&A|F&E&!D2&!D1&!D&!C&B&A1&A|F&E&!D2&!D1&!D&!C&B&!A1&A|F&E&D2&!D1&!D&!C&B&!A1&A|F&!E&D2&!D1&!D&!C&B&!A1&A|F&!E&D2&D1&!D&!C&B&!A1&A|F&E&D2&D1&!D&!C&B&!A1&A|F&E&!D2&D1&!D&!C&B&!A1&A|F&!E&!D2&D1&!D&!C&B&!A1&A|F&!E&!D2&D1&D&!C&B&!A1&A|F&E&!D2&D1&D&!C&B&!A1&A|F&E&D2&D1&D&!C&B&!A1&A|F&!E&D2&D1&D&!C&B&!A1&A|F&!E&D2&!D1&D&!C&B&!A1&A|F&E&D2&!D1&D&!C&B&!A1&A|F&E&!D2&!D1&D&!C&B&!A1&A|F&!E&!D2&!D1&D&!C&B&!A1&A|F&!E&!D2&!D1&D&C&B&!A1&A|F&E&!D2&!D1&D&C&B&!A1&A|F&E&D2&!D1&D&C&B&!A1&A|F&!E&D2&!D1&D&C&B&!A1&A|F&!E&D2&D1&D&C&B&!A1&A|F&E&D2&D1&D&C&B&!A1&A|F&E&!D2&D1&D&C&B&!A1&A|F&!E&!D2&D1&D&C&B&!A1&A|F&!E&!D2&D1&!D&C&B&!A1&A|F&E&!D2&D1&!D&C&B&!A1&A|F&E&D2&D1&!D&C&B&!A1&A|F&!E&D2&D1&!D&C&B&!A1&A|F&!E&D2&!D1&!D&C&B&!A1&A|F&E&D2&!D1&!D&C&B&!A1&A|F&E&!D2&!D1&!D&C&B&!A1&A|F&E&!D2&!D1&!D&C&!B&!A1&A|F&E&D2&!D1&!D&C&!B&!A1&A|F&!E&D2&!D1&!D&C&!B&!A1&A|F&!E&D2&D1&!D&C&!B&!A1&A|F&E&D2&D1&!D&C&!B&!A1&A|F&E&!D2&D1&!D&C&!B&!A1&A|F&!E&!D2&D1&!D&C&!B&!A1&A|F&!E&!D2&D1&D&C&!B&!A1&A|F&E&!D2&D1&D&C&!B&!A1&A|F&E&D2&D1&D&C&!B&!A1&A|F&!E&D2&D1&D&C&!B&!A1&A|F&!E&D2&!D1&D&C&!B&!A1&A|F&E&D2&!D1&D&C&!B&!A1&A|F&E&!D2&!D1&D&C&!B&!A1&A|F&!E&!D2&!D1&D&C&!B&!A1&A|F&E&!D2&!D1&D&!C&!B&!A1&A|F&E&D2&!D1&D&!C&!B&!A1&A|F&E&D2&D1&D&!C&!B&!A1&A|F&E&!D2&D1&D&!C&!B&!A1&A|F&E&!D2&D1&!D&!C&!B&!A1&A|F&E&D2&D1&!D&!C&!B&!A1&A|F&E&D2&!D1&!D&!C&!B&!A1&A|F&E&!D2&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAOAI211311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOI3221 -l AOOAOI3221 -i D C1 C B1 B A2 A1 A -o Y -f Y=(!D&!C1&!C&!B1&!B&!A2&!A1&!A|!D&C1&!C&!B1&!B&!A2&!A1&!A|!D&C1&C&!B1&!B&!A2&!A1&!A|!D&!C1&C&!B1&!B&!A2&!A1&!A|!D&!C1&!C&B1&!B&!A2&!A1&!A|!D&!C1&!C&B1&B&!A2&!A1&!A|!D&!C1&!C&!B1&B&!A2&!A1&!A|!D&!C1&!C&!B1&B&A2&!A1&!A|!D&!C1&!C&B1&B&A2&!A1&!A|!D&!C1&!C&B1&!B&A2&!A1&!A|!D&!C1&C&!B1&!B&A2&!A1&!A|!D&C1&C&!B1&!B&A2&!A1&!A|!D&C1&!C&!B1&!B&A2&!A1&!A|!D&!C1&!C&!B1&!B&A2&!A1&!A|!D&!C1&!C&!B1&!B&A2&A1&!A|!D&C1&!C&!B1&!B&A2&A1&!A|!D&C1&C&!B1&!B&A2&A1&!A|!D&!C1&C&!B1&!B&A2&A1&!A|!D&!C1&!C&B1&!B&A2&A1&!A|!D&!C1&!C&B1&B&A2&A1&!A|!D&!C1&!C&!B1&B&A2&A1&!A|!D&!C1&!C&!B1&B&!A2&A1&!A|!D&!C1&!C&B1&B&!A2&A1&!A|!D&!C1&!C&B1&!B&!A2&A1&!A|!D&!C1&C&!B1&!B&!A2&A1&!A|!D&C1&C&!B1&!B&!A2&A1&!A|!D&C1&!C&!B1&!B&!A2&A1&!A|!D&!C1&!C&!B1&!B&!A2&A1&!A|!D&!C1&!C&!B1&!B&!A2&A1&A|!D&C1&!C&!B1&!B&!A2&A1&A|!D&C1&C&!B1&!B&!A2&A1&A|!D&!C1&C&!B1&!B&!A2&A1&A|!D&!C1&!C&B1&!B&!A2&A1&A|!D&!C1&!C&B1&B&!A2&A1&A|!D&!C1&!C&!B1&B&!A2&A1&A|!D&!C1&!C&!B1&B&A2&A1&A|!D&!C1&!C&B1&B&A2&A1&A|!D&!C1&!C&B1&!B&A2&A1&A|!D&!C1&!C&!B1&!B&A2&A1&A|!D&!C1&!C&!B1&!B&A2&!A1&A|!D&C1&!C&!B1&!B&A2&!A1&A|!D&C1&C&!B1&!B&A2&!A1&A|!D&!C1&C&!B1&!B&A2&!A1&A|!D&!C1&!C&B1&!B&A2&!A1&A|!D&!C1&!C&B1&B&A2&!A1&A|!D&!C1&!C&!B1&B&A2&!A1&A|!D&!C1&!C&!B1&B&!A2&!A1&A|!D&!C1&!C&B1&B&!A2&!A1&A|!D&!C1&!C&B1&!B&!A2&!A1&A|!D&!C1&C&!B1&!B&!A2&!A1&A|!D&C1&C&!B1&!B&!A2&!A1&A|!D&C1&!C&!B1&!B&!A2&!A1&A|!D&!C1&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOI3221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOI2112 -l AOAAOI2112 -i D1 D C B A1 A -o Y -f Y=!(D1&D&!C&!B&!A1&!A|D1&D&C&!B&!A1&!A|!D1&!D&C&B&!A1&!A|D1&!D&C&B&!A1&!A|D1&D&C&B&!A1&!A|!D1&D&C&B&!A1&!A|D1&D&!C&B&!A1&!A|D1&D&!C&B&A1&!A|!D1&D&C&B&A1&!A|D1&D&C&B&A1&!A|D1&!D&C&B&A1&!A|!D1&!D&C&B&A1&!A|D1&D&C&!B&A1&!A|D1&D&!C&!B&A1&!A|D1&D&!C&!B&A1&A|!D1&D&C&!B&A1&A|D1&D&C&!B&A1&A|D1&!D&C&!B&A1&A|!D1&!D&C&!B&A1&A|!D1&!D&C&B&A1&A|D1&!D&C&B&A1&A|D1&D&C&B&A1&A|!D1&D&C&B&A1&A|D1&D&!C&B&A1&A|D1&D&!C&B&!A1&A|!D1&D&C&B&!A1&A|D1&D&C&B&!A1&A|D1&!D&C&B&!A1&A|!D1&!D&C&B&!A1&A|D1&D&C&!B&!A1&A|D1&D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOI2112.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOOOAI22122 -l OOAOOOAI22122 -i E1 E D1 D C B1 B A1 A -o Y -f Y=!(E1&!E&!D1&D&C&!B1&!B&!A1&!A|E1&E&!D1&D&C&!B1&!B&!A1&!A|!E1&E&!D1&D&C&!B1&!B&!A1&!A|!E1&E&D1&D&C&!B1&!B&!A1&!A|E1&E&D1&D&C&!B1&!B&!A1&!A|E1&!E&D1&D&C&!B1&!B&!A1&!A|E1&!E&D1&!D&C&!B1&!B&!A1&!A|E1&E&D1&!D&C&!B1&!B&!A1&!A|!E1&E&D1&!D&C&!B1&!B&!A1&!A|!E1&E&D1&!D&C&B1&!B&!A1&!A|E1&E&D1&!D&C&B1&!B&!A1&!A|E1&!E&D1&!D&C&B1&!B&!A1&!A|E1&!E&D1&D&C&B1&!B&!A1&!A|E1&E&D1&D&C&B1&!B&!A1&!A|!E1&E&D1&D&C&B1&!B&!A1&!A|!E1&E&!D1&D&C&B1&!B&!A1&!A|E1&E&!D1&D&C&B1&!B&!A1&!A|E1&!E&!D1&D&C&B1&!B&!A1&!A|E1&!E&!D1&D&C&B1&B&!A1&!A|E1&E&!D1&D&C&B1&B&!A1&!A|!E1&E&!D1&D&C&B1&B&!A1&!A|!E1&E&D1&D&C&B1&B&!A1&!A|E1&E&D1&D&C&B1&B&!A1&!A|E1&!E&D1&D&C&B1&B&!A1&!A|E1&!E&D1&!D&C&B1&B&!A1&!A|E1&E&D1&!D&C&B1&B&!A1&!A|!E1&E&D1&!D&C&B1&B&!A1&!A|!E1&E&D1&!D&C&!B1&B&!A1&!A|E1&E&D1&!D&C&!B1&B&!A1&!A|E1&!E&D1&!D&C&!B1&B&!A1&!A|E1&!E&D1&D&C&!B1&B&!A1&!A|E1&E&D1&D&C&!B1&B&!A1&!A|!E1&E&D1&D&C&!B1&B&!A1&!A|!E1&E&!D1&D&C&!B1&B&!A1&!A|E1&E&!D1&D&C&!B1&B&!A1&!A|E1&!E&!D1&D&C&!B1&B&!A1&!A|!E1&E&D1&!D&!C&!B1&B&A1&!A|E1&E&D1&!D&!C&!B1&B&A1&!A|E1&!E&D1&!D&!C&!B1&B&A1&!A|E1&!E&D1&D&!C&!B1&B&A1&!A|E1&E&D1&D&!C&!B1&B&A1&!A|!E1&E&D1&D&!C&!B1&B&A1&!A|!E1&E&!D1&D&!C&!B1&B&A1&!A|E1&E&!D1&D&!C&!B1&B&A1&!A|E1&!E&!D1&D&!C&!B1&B&A1&!A|E1&!E&!D1&D&C&!B1&B&A1&!A|E1&E&!D1&D&C&!B1&B&A1&!A|!E1&E&!D1&D&C&!B1&B&A1&!A|!E1&E&D1&D&C&!B1&B&A1&!A|E1&E&D1&D&C&!B1&B&A1&!A|E1&!E&D1&D&C&!B1&B&A1&!A|E1&!E&D1&!D&C&!B1&B&A1&!A|E1&E&D1&!D&C&!B1&B&A1&!A|!E1&E&D1&!D&C&!B1&B&A1&!A|!E1&E&D1&!D&C&B1&B&A1&!A|E1&E&D1&!D&C&B1&B&A1&!A|E1&!E&D1&!D&C&B1&B&A1&!A|E1&!E&D1&D&C&B1&B&A1&!A|E1&E&D1&D&C&B1&B&A1&!A|!E1&E&D1&D&C&B1&B&A1&!A|!E1&E&!D1&D&C&B1&B&A1&!A|E1&E&!D1&D&C&B1&B&A1&!A|E1&!E&!D1&D&C&B1&B&A1&!A|E1&!E&!D1&D&!C&B1&B&A1&!A|E1&E&!D1&D&!C&B1&B&A1&!A|!E1&E&!D1&D&!C&B1&B&A1&!A|!E1&E&D1&D&!C&B1&B&A1&!A|E1&E&D1&D&!C&B1&B&A1&!A|E1&!E&D1&D&!C&B1&B&A1&!A|E1&!E&D1&!D&!C&B1&B&A1&!A|E1&E&D1&!D&!C&B1&B&A1&!A|!E1&E&D1&!D&!C&B1&B&A1&!A|!E1&E&D1&!D&!C&B1&!B&A1&!A|E1&E&D1&!D&!C&B1&!B&A1&!A|E1&!E&D1&!D&!C&B1&!B&A1&!A|E1&!E&D1&D&!C&B1&!B&A1&!A|E1&E&D1&D&!C&B1&!B&A1&!A|!E1&E&D1&D&!C&B1&!B&A1&!A|!E1&E&!D1&D&!C&B1&!B&A1&!A|E1&E&!D1&D&!C&B1&!B&A1&!A|E1&!E&!D1&D&!C&B1&!B&A1&!A|E1&!E&!D1&D&C&B1&!B&A1&!A|E1&E&!D1&D&C&B1&!B&A1&!A|!E1&E&!D1&D&C&B1&!B&A1&!A|!E1&E&D1&D&C&B1&!B&A1&!A|E1&E&D1&D&C&B1&!B&A1&!A|E1&!E&D1&D&C&B1&!B&A1&!A|E1&!E&D1&!D&C&B1&!B&A1&!A|E1&E&D1&!D&C&B1&!B&A1&!A|!E1&E&D1&!D&C&B1&!B&A1&!A|!E1&E&D1&!D&C&!B1&!B&A1&!A|E1&E&D1&!D&C&!B1&!B&A1&!A|E1&!E&D1&!D&C&!B1&!B&A1&!A|E1&!E&D1&D&C&!B1&!B&A1&!A|E1&E&D1&D&C&!B1&!B&A1&!A|!E1&E&D1&D&C&!B1&!B&A1&!A|!E1&E&!D1&D&C&!B1&!B&A1&!A|E1&E&!D1&D&C&!B1&!B&A1&!A|E1&!E&!D1&D&C&!B1&!B&A1&!A|E1&!E&!D1&D&C&!B1&!B&A1&A|E1&E&!D1&D&C&!B1&!B&A1&A|!E1&E&!D1&D&C&!B1&!B&A1&A|!E1&E&D1&D&C&!B1&!B&A1&A|E1&E&D1&D&C&!B1&!B&A1&A|E1&!E&D1&D&C&!B1&!B&A1&A|E1&!E&D1&!D&C&!B1&!B&A1&A|E1&E&D1&!D&C&!B1&!B&A1&A|!E1&E&D1&!D&C&!B1&!B&A1&A|!E1&E&D1&!D&C&B1&!B&A1&A|E1&E&D1&!D&C&B1&!B&A1&A|E1&!E&D1&!D&C&B1&!B&A1&A|E1&!E&D1&D&C&B1&!B&A1&A|E1&E&D1&D&C&B1&!B&A1&A|!E1&E&D1&D&C&B1&!B&A1&A|!E1&E&!D1&D&C&B1&!B&A1&A|E1&E&!D1&D&C&B1&!B&A1&A|E1&!E&!D1&D&C&B1&!B&A1&A|E1&!E&!D1&D&!C&B1&!B&A1&A|E1&E&!D1&D&!C&B1&!B&A1&A|!E1&E&!D1&D&!C&B1&!B&A1&A|!E1&E&D1&D&!C&B1&!B&A1&A|E1&E&D1&D&!C&B1&!B&A1&A|E1&!E&D1&D&!C&B1&!B&A1&A|E1&!E&D1&!D&!C&B1&!B&A1&A|E1&E&D1&!D&!C&B1&!B&A1&A|!E1&E&D1&!D&!C&B1&!B&A1&A|!E1&E&D1&!D&!C&B1&B&A1&A|E1&E&D1&!D&!C&B1&B&A1&A|E1&!E&D1&!D&!C&B1&B&A1&A|E1&!E&D1&D&!C&B1&B&A1&A|E1&E&D1&D&!C&B1&B&A1&A|!E1&E&D1&D&!C&B1&B&A1&A|!E1&E&!D1&D&!C&B1&B&A1&A|E1&E&!D1&D&!C&B1&B&A1&A|E1&!E&!D1&D&!C&B1&B&A1&A|E1&!E&!D1&D&C&B1&B&A1&A|E1&E&!D1&D&C&B1&B&A1&A|!E1&E&!D1&D&C&B1&B&A1&A|!E1&E&D1&D&C&B1&B&A1&A|E1&E&D1&D&C&B1&B&A1&A|E1&!E&D1&D&C&B1&B&A1&A|E1&!E&D1&!D&C&B1&B&A1&A|E1&E&D1&!D&C&B1&B&A1&A|!E1&E&D1&!D&C&B1&B&A1&A|!E1&E&D1&!D&C&!B1&B&A1&A|E1&E&D1&!D&C&!B1&B&A1&A|E1&!E&D1&!D&C&!B1&B&A1&A|E1&!E&D1&D&C&!B1&B&A1&A|E1&E&D1&D&C&!B1&B&A1&A|!E1&E&D1&D&C&!B1&B&A1&A|!E1&E&!D1&D&C&!B1&B&A1&A|E1&E&!D1&D&C&!B1&B&A1&A|E1&!E&!D1&D&C&!B1&B&A1&A|E1&!E&!D1&D&!C&!B1&B&A1&A|E1&E&!D1&D&!C&!B1&B&A1&A|!E1&E&!D1&D&!C&!B1&B&A1&A|!E1&E&D1&D&!C&!B1&B&A1&A|E1&E&D1&D&!C&!B1&B&A1&A|E1&!E&D1&D&!C&!B1&B&A1&A|E1&!E&D1&!D&!C&!B1&B&A1&A|E1&E&D1&!D&!C&!B1&B&A1&A|!E1&E&D1&!D&!C&!B1&B&A1&A|!E1&E&D1&!D&!C&!B1&B&!A1&A|E1&E&D1&!D&!C&!B1&B&!A1&A|E1&!E&D1&!D&!C&!B1&B&!A1&A|E1&!E&D1&D&!C&!B1&B&!A1&A|E1&E&D1&D&!C&!B1&B&!A1&A|!E1&E&D1&D&!C&!B1&B&!A1&A|!E1&E&!D1&D&!C&!B1&B&!A1&A|E1&E&!D1&D&!C&!B1&B&!A1&A|E1&!E&!D1&D&!C&!B1&B&!A1&A|E1&!E&!D1&D&C&!B1&B&!A1&A|E1&E&!D1&D&C&!B1&B&!A1&A|!E1&E&!D1&D&C&!B1&B&!A1&A|!E1&E&D1&D&C&!B1&B&!A1&A|E1&E&D1&D&C&!B1&B&!A1&A|E1&!E&D1&D&C&!B1&B&!A1&A|E1&!E&D1&!D&C&!B1&B&!A1&A|E1&E&D1&!D&C&!B1&B&!A1&A|!E1&E&D1&!D&C&!B1&B&!A1&A|!E1&E&D1&!D&C&B1&B&!A1&A|E1&E&D1&!D&C&B1&B&!A1&A|E1&!E&D1&!D&C&B1&B&!A1&A|E1&!E&D1&D&C&B1&B&!A1&A|E1&E&D1&D&C&B1&B&!A1&A|!E1&E&D1&D&C&B1&B&!A1&A|!E1&E&!D1&D&C&B1&B&!A1&A|E1&E&!D1&D&C&B1&B&!A1&A|E1&!E&!D1&D&C&B1&B&!A1&A|E1&!E&!D1&D&!C&B1&B&!A1&A|E1&E&!D1&D&!C&B1&B&!A1&A|!E1&E&!D1&D&!C&B1&B&!A1&A|!E1&E&D1&D&!C&B1&B&!A1&A|E1&E&D1&D&!C&B1&B&!A1&A|E1&!E&D1&D&!C&B1&B&!A1&A|E1&!E&D1&!D&!C&B1&B&!A1&A|E1&E&D1&!D&!C&B1&B&!A1&A|!E1&E&D1&!D&!C&B1&B&!A1&A|!E1&E&D1&!D&!C&B1&!B&!A1&A|E1&E&D1&!D&!C&B1&!B&!A1&A|E1&!E&D1&!D&!C&B1&!B&!A1&A|E1&!E&D1&D&!C&B1&!B&!A1&A|E1&E&D1&D&!C&B1&!B&!A1&A|!E1&E&D1&D&!C&B1&!B&!A1&A|!E1&E&!D1&D&!C&B1&!B&!A1&A|E1&E&!D1&D&!C&B1&!B&!A1&A|E1&!E&!D1&D&!C&B1&!B&!A1&A|E1&!E&!D1&D&C&B1&!B&!A1&A|E1&E&!D1&D&C&B1&!B&!A1&A|!E1&E&!D1&D&C&B1&!B&!A1&A|!E1&E&D1&D&C&B1&!B&!A1&A|E1&E&D1&D&C&B1&!B&!A1&A|E1&!E&D1&D&C&B1&!B&!A1&A|E1&!E&D1&!D&C&B1&!B&!A1&A|E1&E&D1&!D&C&B1&!B&!A1&A|!E1&E&D1&!D&C&B1&!B&!A1&A|!E1&E&D1&!D&C&!B1&!B&!A1&A|E1&E&D1&!D&C&!B1&!B&!A1&A|E1&!E&D1&!D&C&!B1&!B&!A1&A|E1&!E&D1&D&C&!B1&!B&!A1&A|E1&E&D1&D&C&!B1&!B&!A1&A|!E1&E&D1&D&C&!B1&!B&!A1&A|!E1&E&!D1&D&C&!B1&!B&!A1&A|E1&E&!D1&D&C&!B1&!B&!A1&A|E1&!E&!D1&D&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOOOAI22122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOAI2111 -l OAOAI2111 -i D C B A1 A -o Y -f Y=!(D&C&!B&!A1&!A|D&C&B&!A1&!A|D&!C&B&A1&!A|D&C&B&A1&!A|D&C&!B&A1&!A|D&C&!B&A1&A|D&C&B&A1&A|D&!C&B&A1&A|D&!C&B&!A1&A|D&C&B&!A1&A|D&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOAI2111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOOAI3332 -l AAAOOAI3332 -i D1 D C2 C1 C B2 B1 B A2 A1 A -o Y -f Y=!(!D1&D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|D1&D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|D1&D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|D1&!D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|D1&!D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|D1&D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|D1&D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|D1&!D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|D1&!D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|D1&D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|!D1&D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|!D1&D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|D1&D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|D1&!D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|D1&!D&C2&C1&C&B2&B1&B&!A2&!A1&!A|D1&D&C2&C1&C&B2&B1&B&!A2&!A1&!A|!D1&D&C2&C1&C&B2&B1&B&!A2&!A1&!A|!D1&D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|D1&D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|D1&!D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|D1&!D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|D1&D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|!D1&D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|!D1&D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|D1&D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|D1&!D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|D1&!D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|D1&D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!D1&D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!D1&D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|D1&D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|D1&!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!D1&D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|D1&D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|D1&!D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|D1&!D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|D1&D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&D&C2&C1&C&!B2&!B1&B&A2&!A1&!A|D1&D&C2&C1&C&!B2&!B1&B&A2&!A1&!A|D1&!D&C2&C1&C&!B2&!B1&B&A2&!A1&!A|D1&!D&C2&C1&C&B2&!B1&B&A2&!A1&!A|D1&D&C2&C1&C&B2&!B1&B&A2&!A1&!A|!D1&D&C2&C1&C&B2&!B1&B&A2&!A1&!A|D1&!D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|D1&D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|!D1&D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|!D1&D&C2&!C1&!C&B2&B1&B&A2&!A1&!A|D1&D&C2&!C1&!C&B2&B1&B&A2&!A1&!A|D1&!D&C2&!C1&!C&B2&B1&B&A2&!A1&!A|D1&!D&C2&C1&!C&B2&B1&B&A2&!A1&!A|D1&D&C2&C1&!C&B2&B1&B&A2&!A1&!A|!D1&D&C2&C1&!C&B2&B1&B&A2&!A1&!A|!D1&D&!C2&C1&!C&B2&B1&B&A2&!A1&!A|D1&D&!C2&C1&!C&B2&B1&B&A2&!A1&!A|D1&!D&!C2&C1&!C&B2&B1&B&A2&!A1&!A|D1&!D&!C2&C1&C&B2&B1&B&A2&!A1&!A|D1&D&!C2&C1&C&B2&B1&B&A2&!A1&!A|!D1&D&!C2&C1&C&B2&B1&B&A2&!A1&!A|!D1&D&C2&C1&C&B2&B1&B&A2&!A1&!A|D1&D&C2&C1&C&B2&B1&B&A2&!A1&!A|D1&!D&C2&C1&C&B2&B1&B&A2&!A1&!A|D1&!D&C2&!C1&C&B2&B1&B&A2&!A1&!A|D1&D&C2&!C1&C&B2&B1&B&A2&!A1&!A|!D1&D&C2&!C1&C&B2&B1&B&A2&!A1&!A|!D1&D&!C2&!C1&C&B2&B1&B&A2&!A1&!A|D1&D&!C2&!C1&C&B2&B1&B&A2&!A1&!A|D1&!D&!C2&!C1&C&B2&B1&B&A2&!A1&!A|D1&!D&C2&C1&C&!B2&B1&B&A2&!A1&!A|D1&D&C2&C1&C&!B2&B1&B&A2&!A1&!A|!D1&D&C2&C1&C&!B2&B1&B&A2&!A1&!A|!D1&D&C2&C1&C&!B2&B1&!B&A2&!A1&!A|D1&D&C2&C1&C&!B2&B1&!B&A2&!A1&!A|D1&!D&C2&C1&C&!B2&B1&!B&A2&!A1&!A|D1&!D&C2&C1&C&B2&B1&!B&A2&!A1&!A|D1&D&C2&C1&C&B2&B1&!B&A2&!A1&!A|!D1&D&C2&C1&C&B2&B1&!B&A2&!A1&!A|!D1&D&C2&C1&C&B2&!B1&!B&A2&!A1&!A|D1&D&C2&C1&C&B2&!B1&!B&A2&!A1&!A|D1&!D&C2&C1&C&B2&!B1&!B&A2&!A1&!A|D1&!D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|D1&D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|D1&D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|D1&!D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|D1&!D&C2&C1&C&B2&!B1&!B&A2&A1&!A|D1&D&C2&C1&C&B2&!B1&!B&A2&A1&!A|!D1&D&C2&C1&C&B2&!B1&!B&A2&A1&!A|!D1&D&C2&C1&C&B2&B1&!B&A2&A1&!A|D1&D&C2&C1&C&B2&B1&!B&A2&A1&!A|D1&!D&C2&C1&C&B2&B1&!B&A2&A1&!A|D1&!D&C2&C1&C&!B2&B1&!B&A2&A1&!A|D1&D&C2&C1&C&!B2&B1&!B&A2&A1&!A|!D1&D&C2&C1&C&!B2&B1&!B&A2&A1&!A|!D1&D&C2&C1&C&!B2&B1&B&A2&A1&!A|D1&D&C2&C1&C&!B2&B1&B&A2&A1&!A|D1&!D&C2&C1&C&!B2&B1&B&A2&A1&!A|D1&!D&!C2&!C1&C&B2&B1&B&A2&A1&!A|D1&D&!C2&!C1&C&B2&B1&B&A2&A1&!A|!D1&D&!C2&!C1&C&B2&B1&B&A2&A1&!A|!D1&D&C2&!C1&C&B2&B1&B&A2&A1&!A|D1&D&C2&!C1&C&B2&B1&B&A2&A1&!A|D1&!D&C2&!C1&C&B2&B1&B&A2&A1&!A|D1&!D&C2&C1&C&B2&B1&B&A2&A1&!A|D1&D&C2&C1&C&B2&B1&B&A2&A1&!A|!D1&D&C2&C1&C&B2&B1&B&A2&A1&!A|!D1&D&!C2&C1&C&B2&B1&B&A2&A1&!A|D1&D&!C2&C1&C&B2&B1&B&A2&A1&!A|D1&!D&!C2&C1&C&B2&B1&B&A2&A1&!A|D1&!D&!C2&C1&!C&B2&B1&B&A2&A1&!A|D1&D&!C2&C1&!C&B2&B1&B&A2&A1&!A|!D1&D&!C2&C1&!C&B2&B1&B&A2&A1&!A|!D1&D&C2&C1&!C&B2&B1&B&A2&A1&!A|D1&D&C2&C1&!C&B2&B1&B&A2&A1&!A|D1&!D&C2&C1&!C&B2&B1&B&A2&A1&!A|D1&!D&C2&!C1&!C&B2&B1&B&A2&A1&!A|D1&D&C2&!C1&!C&B2&B1&B&A2&A1&!A|!D1&D&C2&!C1&!C&B2&B1&B&A2&A1&!A|!D1&D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|D1&D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|D1&!D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|!D1&D&C2&C1&C&B2&!B1&B&A2&A1&!A|D1&D&C2&C1&C&B2&!B1&B&A2&A1&!A|D1&!D&C2&C1&C&B2&!B1&B&A2&A1&!A|D1&!D&C2&C1&C&!B2&!B1&B&A2&A1&!A|D1&D&C2&C1&C&!B2&!B1&B&A2&A1&!A|!D1&D&C2&C1&C&!B2&!B1&B&A2&A1&!A|!D1&D&C2&C1&C&!B2&!B1&B&!A2&A1&!A|D1&D&C2&C1&C&!B2&!B1&B&!A2&A1&!A|D1&!D&C2&C1&C&!B2&!B1&B&!A2&A1&!A|D1&!D&C2&C1&C&B2&!B1&B&!A2&A1&!A|D1&D&C2&C1&C&B2&!B1&B&!A2&A1&!A|!D1&D&C2&C1&C&B2&!B1&B&!A2&A1&!A|D1&!D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|D1&D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|!D1&D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|!D1&D&C2&!C1&!C&B2&B1&B&!A2&A1&!A|D1&D&C2&!C1&!C&B2&B1&B&!A2&A1&!A|D1&!D&C2&!C1&!C&B2&B1&B&!A2&A1&!A|D1&!D&C2&C1&!C&B2&B1&B&!A2&A1&!A|D1&D&C2&C1&!C&B2&B1&B&!A2&A1&!A|!D1&D&C2&C1&!C&B2&B1&B&!A2&A1&!A|!D1&D&!C2&C1&!C&B2&B1&B&!A2&A1&!A|D1&D&!C2&C1&!C&B2&B1&B&!A2&A1&!A|D1&!D&!C2&C1&!C&B2&B1&B&!A2&A1&!A|D1&!D&!C2&C1&C&B2&B1&B&!A2&A1&!A|D1&D&!C2&C1&C&B2&B1&B&!A2&A1&!A|!D1&D&!C2&C1&C&B2&B1&B&!A2&A1&!A|!D1&D&C2&C1&C&B2&B1&B&!A2&A1&!A|D1&D&C2&C1&C&B2&B1&B&!A2&A1&!A|D1&!D&C2&C1&C&B2&B1&B&!A2&A1&!A|D1&!D&C2&!C1&C&B2&B1&B&!A2&A1&!A|D1&D&C2&!C1&C&B2&B1&B&!A2&A1&!A|!D1&D&C2&!C1&C&B2&B1&B&!A2&A1&!A|!D1&D&!C2&!C1&C&B2&B1&B&!A2&A1&!A|D1&D&!C2&!C1&C&B2&B1&B&!A2&A1&!A|D1&!D&!C2&!C1&C&B2&B1&B&!A2&A1&!A|D1&!D&C2&C1&C&!B2&B1&B&!A2&A1&!A|D1&D&C2&C1&C&!B2&B1&B&!A2&A1&!A|!D1&D&C2&C1&C&!B2&B1&B&!A2&A1&!A|!D1&D&C2&C1&C&!B2&B1&!B&!A2&A1&!A|D1&D&C2&C1&C&!B2&B1&!B&!A2&A1&!A|D1&!D&C2&C1&C&!B2&B1&!B&!A2&A1&!A|D1&!D&C2&C1&C&B2&B1&!B&!A2&A1&!A|D1&D&C2&C1&C&B2&B1&!B&!A2&A1&!A|!D1&D&C2&C1&C&B2&B1&!B&!A2&A1&!A|!D1&D&C2&C1&C&B2&!B1&!B&!A2&A1&!A|D1&D&C2&C1&C&B2&!B1&!B&!A2&A1&!A|D1&!D&C2&C1&C&B2&!B1&!B&!A2&A1&!A|D1&!D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|D1&D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|D1&D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|D1&!D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|D1&!D&C2&C1&C&B2&!B1&!B&!A2&A1&A|D1&D&C2&C1&C&B2&!B1&!B&!A2&A1&A|!D1&D&C2&C1&C&B2&!B1&!B&!A2&A1&A|!D1&D&C2&C1&C&B2&B1&!B&!A2&A1&A|D1&D&C2&C1&C&B2&B1&!B&!A2&A1&A|D1&!D&C2&C1&C&B2&B1&!B&!A2&A1&A|D1&!D&C2&C1&C&!B2&B1&!B&!A2&A1&A|D1&D&C2&C1&C&!B2&B1&!B&!A2&A1&A|!D1&D&C2&C1&C&!B2&B1&!B&!A2&A1&A|!D1&D&C2&C1&C&!B2&B1&B&!A2&A1&A|D1&D&C2&C1&C&!B2&B1&B&!A2&A1&A|D1&!D&C2&C1&C&!B2&B1&B&!A2&A1&A|D1&!D&!C2&!C1&C&B2&B1&B&!A2&A1&A|D1&D&!C2&!C1&C&B2&B1&B&!A2&A1&A|!D1&D&!C2&!C1&C&B2&B1&B&!A2&A1&A|!D1&D&C2&!C1&C&B2&B1&B&!A2&A1&A|D1&D&C2&!C1&C&B2&B1&B&!A2&A1&A|D1&!D&C2&!C1&C&B2&B1&B&!A2&A1&A|D1&!D&C2&C1&C&B2&B1&B&!A2&A1&A|D1&D&C2&C1&C&B2&B1&B&!A2&A1&A|!D1&D&C2&C1&C&B2&B1&B&!A2&A1&A|!D1&D&!C2&C1&C&B2&B1&B&!A2&A1&A|D1&D&!C2&C1&C&B2&B1&B&!A2&A1&A|D1&!D&!C2&C1&C&B2&B1&B&!A2&A1&A|D1&!D&!C2&C1&!C&B2&B1&B&!A2&A1&A|D1&D&!C2&C1&!C&B2&B1&B&!A2&A1&A|!D1&D&!C2&C1&!C&B2&B1&B&!A2&A1&A|!D1&D&C2&C1&!C&B2&B1&B&!A2&A1&A|D1&D&C2&C1&!C&B2&B1&B&!A2&A1&A|D1&!D&C2&C1&!C&B2&B1&B&!A2&A1&A|D1&!D&C2&!C1&!C&B2&B1&B&!A2&A1&A|D1&D&C2&!C1&!C&B2&B1&B&!A2&A1&A|!D1&D&C2&!C1&!C&B2&B1&B&!A2&A1&A|!D1&D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|D1&D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|D1&!D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|!D1&D&C2&C1&C&B2&!B1&B&!A2&A1&A|D1&D&C2&C1&C&B2&!B1&B&!A2&A1&A|D1&!D&C2&C1&C&B2&!B1&B&!A2&A1&A|D1&!D&C2&C1&C&!B2&!B1&B&!A2&A1&A|D1&D&C2&C1&C&!B2&!B1&B&!A2&A1&A|!D1&D&C2&C1&C&!B2&!B1&B&!A2&A1&A|D1&!D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|D1&D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|!D1&D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|!D1&D&C2&!C1&!C&!B2&!B1&B&A2&A1&A|D1&D&C2&!C1&!C&!B2&!B1&B&A2&A1&A|D1&!D&C2&!C1&!C&!B2&!B1&B&A2&A1&A|D1&!D&C2&C1&!C&!B2&!B1&B&A2&A1&A|D1&D&C2&C1&!C&!B2&!B1&B&A2&A1&A|!D1&D&C2&C1&!C&!B2&!B1&B&A2&A1&A|!D1&D&!C2&C1&!C&!B2&!B1&B&A2&A1&A|D1&D&!C2&C1&!C&!B2&!B1&B&A2&A1&A|D1&!D&!C2&C1&!C&!B2&!B1&B&A2&A1&A|D1&!D&!C2&C1&C&!B2&!B1&B&A2&A1&A|D1&D&!C2&C1&C&!B2&!B1&B&A2&A1&A|!D1&D&!C2&C1&C&!B2&!B1&B&A2&A1&A|!D1&D&C2&C1&C&!B2&!B1&B&A2&A1&A|D1&D&C2&C1&C&!B2&!B1&B&A2&A1&A|D1&!D&C2&C1&C&!B2&!B1&B&A2&A1&A|D1&!D&C2&!C1&C&!B2&!B1&B&A2&A1&A|D1&D&C2&!C1&C&!B2&!B1&B&A2&A1&A|!D1&D&C2&!C1&C&!B2&!B1&B&A2&A1&A|!D1&D&!C2&!C1&C&!B2&!B1&B&A2&A1&A|D1&D&!C2&!C1&C&!B2&!B1&B&A2&A1&A|D1&!D&!C2&!C1&C&!B2&!B1&B&A2&A1&A|D1&!D&!C2&!C1&C&B2&!B1&B&A2&A1&A|D1&D&!C2&!C1&C&B2&!B1&B&A2&A1&A|!D1&D&!C2&!C1&C&B2&!B1&B&A2&A1&A|!D1&D&C2&!C1&C&B2&!B1&B&A2&A1&A|D1&D&C2&!C1&C&B2&!B1&B&A2&A1&A|D1&!D&C2&!C1&C&B2&!B1&B&A2&A1&A|D1&!D&C2&C1&C&B2&!B1&B&A2&A1&A|D1&D&C2&C1&C&B2&!B1&B&A2&A1&A|!D1&D&C2&C1&C&B2&!B1&B&A2&A1&A|!D1&D&!C2&C1&C&B2&!B1&B&A2&A1&A|D1&D&!C2&C1&C&B2&!B1&B&A2&A1&A|D1&!D&!C2&C1&C&B2&!B1&B&A2&A1&A|D1&!D&!C2&C1&!C&B2&!B1&B&A2&A1&A|D1&D&!C2&C1&!C&B2&!B1&B&A2&A1&A|!D1&D&!C2&C1&!C&B2&!B1&B&A2&A1&A|!D1&D&C2&C1&!C&B2&!B1&B&A2&A1&A|D1&D&C2&C1&!C&B2&!B1&B&A2&A1&A|D1&!D&C2&C1&!C&B2&!B1&B&A2&A1&A|D1&!D&C2&!C1&!C&B2&!B1&B&A2&A1&A|D1&D&C2&!C1&!C&B2&!B1&B&A2&A1&A|!D1&D&C2&!C1&!C&B2&!B1&B&A2&A1&A|!D1&D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|D1&D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|D1&!D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|D1&!D&!C2&!C1&!C&B2&B1&B&A2&A1&A|D1&D&!C2&!C1&!C&B2&B1&B&A2&A1&A|!D1&D&!C2&!C1&!C&B2&B1&B&A2&A1&A|!D1&D&C2&!C1&!C&B2&B1&B&A2&A1&A|D1&D&C2&!C1&!C&B2&B1&B&A2&A1&A|D1&!D&C2&!C1&!C&B2&B1&B&A2&A1&A|D1&!D&C2&C1&!C&B2&B1&B&A2&A1&A|D1&D&C2&C1&!C&B2&B1&B&A2&A1&A|!D1&D&C2&C1&!C&B2&B1&B&A2&A1&A|!D1&D&!C2&C1&!C&B2&B1&B&A2&A1&A|D1&D&!C2&C1&!C&B2&B1&B&A2&A1&A|D1&!D&!C2&C1&!C&B2&B1&B&A2&A1&A|D1&!D&!C2&C1&C&B2&B1&B&A2&A1&A|D1&D&!C2&C1&C&B2&B1&B&A2&A1&A|!D1&D&!C2&C1&C&B2&B1&B&A2&A1&A|!D1&D&C2&C1&C&B2&B1&B&A2&A1&A|D1&D&C2&C1&C&B2&B1&B&A2&A1&A|D1&!D&C2&C1&C&B2&B1&B&A2&A1&A|D1&!D&C2&!C1&C&B2&B1&B&A2&A1&A|D1&D&C2&!C1&C&B2&B1&B&A2&A1&A|!D1&D&C2&!C1&C&B2&B1&B&A2&A1&A|!D1&D&!C2&!C1&C&B2&B1&B&A2&A1&A|D1&D&!C2&!C1&C&B2&B1&B&A2&A1&A|D1&!D&!C2&!C1&C&B2&B1&B&A2&A1&A|D1&!D&!C2&!C1&C&!B2&B1&B&A2&A1&A|D1&D&!C2&!C1&C&!B2&B1&B&A2&A1&A|!D1&D&!C2&!C1&C&!B2&B1&B&A2&A1&A|!D1&D&C2&!C1&C&!B2&B1&B&A2&A1&A|D1&D&C2&!C1&C&!B2&B1&B&A2&A1&A|D1&!D&C2&!C1&C&!B2&B1&B&A2&A1&A|D1&!D&C2&C1&C&!B2&B1&B&A2&A1&A|D1&D&C2&C1&C&!B2&B1&B&A2&A1&A|!D1&D&C2&C1&C&!B2&B1&B&A2&A1&A|!D1&D&!C2&C1&C&!B2&B1&B&A2&A1&A|D1&D&!C2&C1&C&!B2&B1&B&A2&A1&A|D1&!D&!C2&C1&C&!B2&B1&B&A2&A1&A|D1&!D&!C2&C1&!C&!B2&B1&B&A2&A1&A|D1&D&!C2&C1&!C&!B2&B1&B&A2&A1&A|!D1&D&!C2&C1&!C&!B2&B1&B&A2&A1&A|!D1&D&C2&C1&!C&!B2&B1&B&A2&A1&A|D1&D&C2&C1&!C&!B2&B1&B&A2&A1&A|D1&!D&C2&C1&!C&!B2&B1&B&A2&A1&A|D1&!D&C2&!C1&!C&!B2&B1&B&A2&A1&A|D1&D&C2&!C1&!C&!B2&B1&B&A2&A1&A|!D1&D&C2&!C1&!C&!B2&B1&B&A2&A1&A|!D1&D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|D1&D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|D1&!D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|D1&!D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|D1&D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|!D1&D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|!D1&D&C2&!C1&!C&!B2&B1&!B&A2&A1&A|D1&D&C2&!C1&!C&!B2&B1&!B&A2&A1&A|D1&!D&C2&!C1&!C&!B2&B1&!B&A2&A1&A|D1&!D&C2&C1&!C&!B2&B1&!B&A2&A1&A|D1&D&C2&C1&!C&!B2&B1&!B&A2&A1&A|!D1&D&C2&C1&!C&!B2&B1&!B&A2&A1&A|!D1&D&!C2&C1&!C&!B2&B1&!B&A2&A1&A|D1&D&!C2&C1&!C&!B2&B1&!B&A2&A1&A|D1&!D&!C2&C1&!C&!B2&B1&!B&A2&A1&A|D1&!D&!C2&C1&C&!B2&B1&!B&A2&A1&A|D1&D&!C2&C1&C&!B2&B1&!B&A2&A1&A|!D1&D&!C2&C1&C&!B2&B1&!B&A2&A1&A|!D1&D&C2&C1&C&!B2&B1&!B&A2&A1&A|D1&D&C2&C1&C&!B2&B1&!B&A2&A1&A|D1&!D&C2&C1&C&!B2&B1&!B&A2&A1&A|D1&!D&C2&!C1&C&!B2&B1&!B&A2&A1&A|D1&D&C2&!C1&C&!B2&B1&!B&A2&A1&A|!D1&D&C2&!C1&C&!B2&B1&!B&A2&A1&A|!D1&D&!C2&!C1&C&!B2&B1&!B&A2&A1&A|D1&D&!C2&!C1&C&!B2&B1&!B&A2&A1&A|D1&!D&!C2&!C1&C&!B2&B1&!B&A2&A1&A|D1&!D&!C2&!C1&C&B2&B1&!B&A2&A1&A|D1&D&!C2&!C1&C&B2&B1&!B&A2&A1&A|!D1&D&!C2&!C1&C&B2&B1&!B&A2&A1&A|!D1&D&C2&!C1&C&B2&B1&!B&A2&A1&A|D1&D&C2&!C1&C&B2&B1&!B&A2&A1&A|D1&!D&C2&!C1&C&B2&B1&!B&A2&A1&A|D1&!D&C2&C1&C&B2&B1&!B&A2&A1&A|D1&D&C2&C1&C&B2&B1&!B&A2&A1&A|!D1&D&C2&C1&C&B2&B1&!B&A2&A1&A|!D1&D&!C2&C1&C&B2&B1&!B&A2&A1&A|D1&D&!C2&C1&C&B2&B1&!B&A2&A1&A|D1&!D&!C2&C1&C&B2&B1&!B&A2&A1&A|D1&!D&!C2&C1&!C&B2&B1&!B&A2&A1&A|D1&D&!C2&C1&!C&B2&B1&!B&A2&A1&A|!D1&D&!C2&C1&!C&B2&B1&!B&A2&A1&A|!D1&D&C2&C1&!C&B2&B1&!B&A2&A1&A|D1&D&C2&C1&!C&B2&B1&!B&A2&A1&A|D1&!D&C2&C1&!C&B2&B1&!B&A2&A1&A|D1&!D&C2&!C1&!C&B2&B1&!B&A2&A1&A|D1&D&C2&!C1&!C&B2&B1&!B&A2&A1&A|!D1&D&C2&!C1&!C&B2&B1&!B&A2&A1&A|!D1&D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|D1&D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|D1&!D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|D1&!D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|D1&D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|!D1&D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|!D1&D&C2&!C1&!C&B2&!B1&!B&A2&A1&A|D1&D&C2&!C1&!C&B2&!B1&!B&A2&A1&A|D1&!D&C2&!C1&!C&B2&!B1&!B&A2&A1&A|D1&!D&C2&C1&!C&B2&!B1&!B&A2&A1&A|D1&D&C2&C1&!C&B2&!B1&!B&A2&A1&A|!D1&D&C2&C1&!C&B2&!B1&!B&A2&A1&A|!D1&D&!C2&C1&!C&B2&!B1&!B&A2&A1&A|D1&D&!C2&C1&!C&B2&!B1&!B&A2&A1&A|D1&!D&!C2&C1&!C&B2&!B1&!B&A2&A1&A|D1&!D&!C2&C1&C&B2&!B1&!B&A2&A1&A|D1&D&!C2&C1&C&B2&!B1&!B&A2&A1&A|!D1&D&!C2&C1&C&B2&!B1&!B&A2&A1&A|!D1&D&C2&C1&C&B2&!B1&!B&A2&A1&A|D1&D&C2&C1&C&B2&!B1&!B&A2&A1&A|D1&!D&C2&C1&C&B2&!B1&!B&A2&A1&A|D1&!D&C2&!C1&C&B2&!B1&!B&A2&A1&A|D1&D&C2&!C1&C&B2&!B1&!B&A2&A1&A|!D1&D&C2&!C1&C&B2&!B1&!B&A2&A1&A|!D1&D&!C2&!C1&C&B2&!B1&!B&A2&A1&A|D1&D&!C2&!C1&C&B2&!B1&!B&A2&A1&A|D1&!D&!C2&!C1&C&B2&!B1&!B&A2&A1&A|D1&!D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|D1&D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|!D1&D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|!D1&D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|D1&D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|D1&!D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|D1&!D&C2&C1&C&!B2&!B1&!B&A2&A1&A|D1&D&C2&C1&C&!B2&!B1&!B&A2&A1&A|!D1&D&C2&C1&C&!B2&!B1&!B&A2&A1&A|!D1&D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|D1&D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|D1&!D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|D1&!D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|D1&D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|!D1&D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|!D1&D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|D1&D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|D1&!D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|D1&!D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|D1&D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!D1&D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!D1&D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|D1&D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|D1&!D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!D1&D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|D1&D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|D1&!D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|D1&!D&C2&C1&C&B2&!B1&!B&A2&!A1&A|D1&D&C2&C1&C&B2&!B1&!B&A2&!A1&A|!D1&D&C2&C1&C&B2&!B1&!B&A2&!A1&A|!D1&D&C2&C1&C&B2&B1&!B&A2&!A1&A|D1&D&C2&C1&C&B2&B1&!B&A2&!A1&A|D1&!D&C2&C1&C&B2&B1&!B&A2&!A1&A|D1&!D&C2&C1&C&!B2&B1&!B&A2&!A1&A|D1&D&C2&C1&C&!B2&B1&!B&A2&!A1&A|!D1&D&C2&C1&C&!B2&B1&!B&A2&!A1&A|!D1&D&C2&C1&C&!B2&B1&B&A2&!A1&A|D1&D&C2&C1&C&!B2&B1&B&A2&!A1&A|D1&!D&C2&C1&C&!B2&B1&B&A2&!A1&A|D1&!D&!C2&!C1&C&B2&B1&B&A2&!A1&A|D1&D&!C2&!C1&C&B2&B1&B&A2&!A1&A|!D1&D&!C2&!C1&C&B2&B1&B&A2&!A1&A|!D1&D&C2&!C1&C&B2&B1&B&A2&!A1&A|D1&D&C2&!C1&C&B2&B1&B&A2&!A1&A|D1&!D&C2&!C1&C&B2&B1&B&A2&!A1&A|D1&!D&C2&C1&C&B2&B1&B&A2&!A1&A|D1&D&C2&C1&C&B2&B1&B&A2&!A1&A|!D1&D&C2&C1&C&B2&B1&B&A2&!A1&A|!D1&D&!C2&C1&C&B2&B1&B&A2&!A1&A|D1&D&!C2&C1&C&B2&B1&B&A2&!A1&A|D1&!D&!C2&C1&C&B2&B1&B&A2&!A1&A|D1&!D&!C2&C1&!C&B2&B1&B&A2&!A1&A|D1&D&!C2&C1&!C&B2&B1&B&A2&!A1&A|!D1&D&!C2&C1&!C&B2&B1&B&A2&!A1&A|!D1&D&C2&C1&!C&B2&B1&B&A2&!A1&A|D1&D&C2&C1&!C&B2&B1&B&A2&!A1&A|D1&!D&C2&C1&!C&B2&B1&B&A2&!A1&A|D1&!D&C2&!C1&!C&B2&B1&B&A2&!A1&A|D1&D&C2&!C1&!C&B2&B1&B&A2&!A1&A|!D1&D&C2&!C1&!C&B2&B1&B&A2&!A1&A|!D1&D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|D1&D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|D1&!D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|!D1&D&C2&C1&C&B2&!B1&B&A2&!A1&A|D1&D&C2&C1&C&B2&!B1&B&A2&!A1&A|D1&!D&C2&C1&C&B2&!B1&B&A2&!A1&A|D1&!D&C2&C1&C&!B2&!B1&B&A2&!A1&A|D1&D&C2&C1&C&!B2&!B1&B&A2&!A1&A|!D1&D&C2&C1&C&!B2&!B1&B&A2&!A1&A|!D1&D&C2&C1&C&!B2&!B1&B&!A2&!A1&A|D1&D&C2&C1&C&!B2&!B1&B&!A2&!A1&A|D1&!D&C2&C1&C&!B2&!B1&B&!A2&!A1&A|D1&!D&C2&C1&C&B2&!B1&B&!A2&!A1&A|D1&D&C2&C1&C&B2&!B1&B&!A2&!A1&A|!D1&D&C2&C1&C&B2&!B1&B&!A2&!A1&A|D1&!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|D1&D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|!D1&D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|!D1&D&C2&!C1&!C&B2&B1&B&!A2&!A1&A|D1&D&C2&!C1&!C&B2&B1&B&!A2&!A1&A|D1&!D&C2&!C1&!C&B2&B1&B&!A2&!A1&A|D1&!D&C2&C1&!C&B2&B1&B&!A2&!A1&A|D1&D&C2&C1&!C&B2&B1&B&!A2&!A1&A|!D1&D&C2&C1&!C&B2&B1&B&!A2&!A1&A|!D1&D&!C2&C1&!C&B2&B1&B&!A2&!A1&A|D1&D&!C2&C1&!C&B2&B1&B&!A2&!A1&A|D1&!D&!C2&C1&!C&B2&B1&B&!A2&!A1&A|D1&!D&!C2&C1&C&B2&B1&B&!A2&!A1&A|D1&D&!C2&C1&C&B2&B1&B&!A2&!A1&A|!D1&D&!C2&C1&C&B2&B1&B&!A2&!A1&A|!D1&D&C2&C1&C&B2&B1&B&!A2&!A1&A|D1&D&C2&C1&C&B2&B1&B&!A2&!A1&A|D1&!D&C2&C1&C&B2&B1&B&!A2&!A1&A|D1&!D&C2&!C1&C&B2&B1&B&!A2&!A1&A|D1&D&C2&!C1&C&B2&B1&B&!A2&!A1&A|!D1&D&C2&!C1&C&B2&B1&B&!A2&!A1&A|!D1&D&!C2&!C1&C&B2&B1&B&!A2&!A1&A|D1&D&!C2&!C1&C&B2&B1&B&!A2&!A1&A|D1&!D&!C2&!C1&C&B2&B1&B&!A2&!A1&A|D1&!D&C2&C1&C&!B2&B1&B&!A2&!A1&A|D1&D&C2&C1&C&!B2&B1&B&!A2&!A1&A|!D1&D&C2&C1&C&!B2&B1&B&!A2&!A1&A|!D1&D&C2&C1&C&!B2&B1&!B&!A2&!A1&A|D1&D&C2&C1&C&!B2&B1&!B&!A2&!A1&A|D1&!D&C2&C1&C&!B2&B1&!B&!A2&!A1&A|D1&!D&C2&C1&C&B2&B1&!B&!A2&!A1&A|D1&D&C2&C1&C&B2&B1&!B&!A2&!A1&A|!D1&D&C2&C1&C&B2&B1&!B&!A2&!A1&A|!D1&D&C2&C1&C&B2&!B1&!B&!A2&!A1&A|D1&D&C2&C1&C&B2&!B1&!B&!A2&!A1&A|D1&!D&C2&C1&C&B2&!B1&!B&!A2&!A1&A|D1&!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A|D1&D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOOAI3332.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOI2122 -l AOOAOI2122 -i D1 D C1 C B A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B&!A1&!A|!D1&!D&C1&!C&!B&!A1&!A|!D1&!D&C1&C&!B&!A1&!A|!D1&!D&!C1&C&!B&!A1&!A|!D1&!D&!C1&!C&B&!A1&!A|!D1&!D&!C1&!C&B&A1&!A|!D1&!D&!C1&C&!B&A1&!A|!D1&!D&C1&C&!B&A1&!A|!D1&!D&C1&!C&!B&A1&!A|!D1&!D&!C1&!C&!B&A1&!A|!D1&!D&!C1&!C&!B&A1&A|!D1&!D&!C1&!C&B&A1&A|!D1&!D&!C1&!C&B&!A1&A|!D1&!D&!C1&C&!B&!A1&A|!D1&!D&C1&C&!B&!A1&A|!D1&!D&C1&!C&!B&!A1&A|!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOI2122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n MUX6 -l MUX6 -i IN0 IN1 IN2 IN3 IN4 IN5 S0 S1 S2 S3 S4 S5 -o Z -f 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist MUX6.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOOAI21132 -l OAOOOAI21132 -i E1 E D2 D1 D C B A1 A -o Y -f Y=!(E1&!E&!D2&!D1&D&C&!B&!A1&!A|E1&E&!D2&!D1&D&C&!B&!A1&!A|!E1&E&!D2&!D1&D&C&!B&!A1&!A|!E1&E&D2&!D1&D&C&!B&!A1&!A|E1&E&D2&!D1&D&C&!B&!A1&!A|E1&!E&D2&!D1&D&C&!B&!A1&!A|E1&!E&D2&D1&D&C&!B&!A1&!A|E1&E&D2&D1&D&C&!B&!A1&!A|!E1&E&D2&D1&D&C&!B&!A1&!A|!E1&E&!D2&D1&D&C&!B&!A1&!A|E1&E&!D2&D1&D&C&!B&!A1&!A|E1&!E&!D2&D1&D&C&!B&!A1&!A|E1&!E&!D2&D1&!D&C&!B&!A1&!A|E1&E&!D2&D1&!D&C&!B&!A1&!A|!E1&E&!D2&D1&!D&C&!B&!A1&!A|!E1&E&D2&D1&!D&C&!B&!A1&!A|E1&E&D2&D1&!D&C&!B&!A1&!A|E1&!E&D2&D1&!D&C&!B&!A1&!A|E1&!E&D2&!D1&!D&C&!B&!A1&!A|E1&E&D2&!D1&!D&C&!B&!A1&!A|!E1&E&D2&!D1&!D&C&!B&!A1&!A|!E1&E&D2&!D1&!D&C&B&!A1&!A|E1&E&D2&!D1&!D&C&B&!A1&!A|E1&!E&D2&!D1&!D&C&B&!A1&!A|E1&!E&D2&D1&!D&C&B&!A1&!A|E1&E&D2&D1&!D&C&B&!A1&!A|!E1&E&D2&D1&!D&C&B&!A1&!A|!E1&E&!D2&D1&!D&C&B&!A1&!A|E1&E&!D2&D1&!D&C&B&!A1&!A|E1&!E&!D2&D1&!D&C&B&!A1&!A|E1&!E&!D2&D1&D&C&B&!A1&!A|E1&E&!D2&D1&D&C&B&!A1&!A|!E1&E&!D2&D1&D&C&B&!A1&!A|!E1&E&D2&D1&D&C&B&!A1&!A|E1&E&D2&D1&D&C&B&!A1&!A|E1&!E&D2&D1&D&C&B&!A1&!A|E1&!E&D2&!D1&D&C&B&!A1&!A|E1&E&D2&!D1&D&C&B&!A1&!A|!E1&E&D2&!D1&D&C&B&!A1&!A|!E1&E&!D2&!D1&D&C&B&!A1&!A|E1&E&!D2&!D1&D&C&B&!A1&!A|E1&!E&!D2&!D1&D&C&B&!A1&!A|!E1&E&D2&!D1&!D&!C&B&A1&!A|E1&E&D2&!D1&!D&!C&B&A1&!A|E1&!E&D2&!D1&!D&!C&B&A1&!A|E1&!E&D2&D1&!D&!C&B&A1&!A|E1&E&D2&D1&!D&!C&B&A1&!A|!E1&E&D2&D1&!D&!C&B&A1&!A|!E1&E&!D2&D1&!D&!C&B&A1&!A|E1&E&!D2&D1&!D&!C&B&A1&!A|E1&!E&!D2&D1&!D&!C&B&A1&!A|E1&!E&!D2&D1&D&!C&B&A1&!A|E1&E&!D2&D1&D&!C&B&A1&!A|!E1&E&!D2&D1&D&!C&B&A1&!A|!E1&E&D2&D1&D&!C&B&A1&!A|E1&E&D2&D1&D&!C&B&A1&!A|E1&!E&D2&D1&D&!C&B&A1&!A|E1&!E&D2&!D1&D&!C&B&A1&!A|E1&E&D2&!D1&D&!C&B&A1&!A|!E1&E&D2&!D1&D&!C&B&A1&!A|!E1&E&!D2&!D1&D&!C&B&A1&!A|E1&E&!D2&!D1&D&!C&B&A1&!A|E1&!E&!D2&!D1&D&!C&B&A1&!A|E1&!E&!D2&!D1&D&C&B&A1&!A|E1&E&!D2&!D1&D&C&B&A1&!A|!E1&E&!D2&!D1&D&C&B&A1&!A|!E1&E&D2&!D1&D&C&B&A1&!A|E1&E&D2&!D1&D&C&B&A1&!A|E1&!E&D2&!D1&D&C&B&A1&!A|E1&!E&D2&D1&D&C&B&A1&!A|E1&E&D2&D1&D&C&B&A1&!A|!E1&E&D2&D1&D&C&B&A1&!A|!E1&E&!D2&D1&D&C&B&A1&!A|E1&E&!D2&D1&D&C&B&A1&!A|E1&!E&!D2&D1&D&C&B&A1&!A|E1&!E&!D2&D1&!D&C&B&A1&!A|E1&E&!D2&D1&!D&C&B&A1&!A|!E1&E&!D2&D1&!D&C&B&A1&!A|!E1&E&D2&D1&!D&C&B&A1&!A|E1&E&D2&D1&!D&C&B&A1&!A|E1&!E&D2&D1&!D&C&B&A1&!A|E1&!E&D2&!D1&!D&C&B&A1&!A|E1&E&D2&!D1&!D&C&B&A1&!A|!E1&E&D2&!D1&!D&C&B&A1&!A|!E1&E&D2&!D1&!D&C&!B&A1&!A|E1&E&D2&!D1&!D&C&!B&A1&!A|E1&!E&D2&!D1&!D&C&!B&A1&!A|E1&!E&D2&D1&!D&C&!B&A1&!A|E1&E&D2&D1&!D&C&!B&A1&!A|!E1&E&D2&D1&!D&C&!B&A1&!A|!E1&E&!D2&D1&!D&C&!B&A1&!A|E1&E&!D2&D1&!D&C&!B&A1&!A|E1&!E&!D2&D1&!D&C&!B&A1&!A|E1&!E&!D2&D1&D&C&!B&A1&!A|E1&E&!D2&D1&D&C&!B&A1&!A|!E1&E&!D2&D1&D&C&!B&A1&!A|!E1&E&D2&D1&D&C&!B&A1&!A|E1&E&D2&D1&D&C&!B&A1&!A|E1&!E&D2&D1&D&C&!B&A1&!A|E1&!E&D2&!D1&D&C&!B&A1&!A|E1&E&D2&!D1&D&C&!B&A1&!A|!E1&E&D2&!D1&D&C&!B&A1&!A|!E1&E&!D2&!D1&D&C&!B&A1&!A|E1&E&!D2&!D1&D&C&!B&A1&!A|E1&!E&!D2&!D1&D&C&!B&A1&!A|E1&!E&!D2&!D1&D&C&!B&A1&A|E1&E&!D2&!D1&D&C&!B&A1&A|!E1&E&!D2&!D1&D&C&!B&A1&A|!E1&E&D2&!D1&D&C&!B&A1&A|E1&E&D2&!D1&D&C&!B&A1&A|E1&!E&D2&!D1&D&C&!B&A1&A|E1&!E&D2&D1&D&C&!B&A1&A|E1&E&D2&D1&D&C&!B&A1&A|!E1&E&D2&D1&D&C&!B&A1&A|!E1&E&!D2&D1&D&C&!B&A1&A|E1&E&!D2&D1&D&C&!B&A1&A|E1&!E&!D2&D1&D&C&!B&A1&A|E1&!E&!D2&D1&!D&C&!B&A1&A|E1&E&!D2&D1&!D&C&!B&A1&A|!E1&E&!D2&D1&!D&C&!B&A1&A|!E1&E&D2&D1&!D&C&!B&A1&A|E1&E&D2&D1&!D&C&!B&A1&A|E1&!E&D2&D1&!D&C&!B&A1&A|E1&!E&D2&!D1&!D&C&!B&A1&A|E1&E&D2&!D1&!D&C&!B&A1&A|!E1&E&D2&!D1&!D&C&!B&A1&A|!E1&E&D2&!D1&!D&C&B&A1&A|E1&E&D2&!D1&!D&C&B&A1&A|E1&!E&D2&!D1&!D&C&B&A1&A|E1&!E&D2&D1&!D&C&B&A1&A|E1&E&D2&D1&!D&C&B&A1&A|!E1&E&D2&D1&!D&C&B&A1&A|!E1&E&!D2&D1&!D&C&B&A1&A|E1&E&!D2&D1&!D&C&B&A1&A|E1&!E&!D2&D1&!D&C&B&A1&A|E1&!E&!D2&D1&D&C&B&A1&A|E1&E&!D2&D1&D&C&B&A1&A|!E1&E&!D2&D1&D&C&B&A1&A|!E1&E&D2&D1&D&C&B&A1&A|E1&E&D2&D1&D&C&B&A1&A|E1&!E&D2&D1&D&C&B&A1&A|E1&!E&D2&!D1&D&C&B&A1&A|E1&E&D2&!D1&D&C&B&A1&A|!E1&E&D2&!D1&D&C&B&A1&A|!E1&E&!D2&!D1&D&C&B&A1&A|E1&E&!D2&!D1&D&C&B&A1&A|E1&!E&!D2&!D1&D&C&B&A1&A|E1&!E&!D2&!D1&D&!C&B&A1&A|E1&E&!D2&!D1&D&!C&B&A1&A|!E1&E&!D2&!D1&D&!C&B&A1&A|!E1&E&D2&!D1&D&!C&B&A1&A|E1&E&D2&!D1&D&!C&B&A1&A|E1&!E&D2&!D1&D&!C&B&A1&A|E1&!E&D2&D1&D&!C&B&A1&A|E1&E&D2&D1&D&!C&B&A1&A|!E1&E&D2&D1&D&!C&B&A1&A|!E1&E&!D2&D1&D&!C&B&A1&A|E1&E&!D2&D1&D&!C&B&A1&A|E1&!E&!D2&D1&D&!C&B&A1&A|E1&!E&!D2&D1&!D&!C&B&A1&A|E1&E&!D2&D1&!D&!C&B&A1&A|!E1&E&!D2&D1&!D&!C&B&A1&A|!E1&E&D2&D1&!D&!C&B&A1&A|E1&E&D2&D1&!D&!C&B&A1&A|E1&!E&D2&D1&!D&!C&B&A1&A|E1&!E&D2&!D1&!D&!C&B&A1&A|E1&E&D2&!D1&!D&!C&B&A1&A|!E1&E&D2&!D1&!D&!C&B&A1&A|!E1&E&D2&!D1&!D&!C&B&!A1&A|E1&E&D2&!D1&!D&!C&B&!A1&A|E1&!E&D2&!D1&!D&!C&B&!A1&A|E1&!E&D2&D1&!D&!C&B&!A1&A|E1&E&D2&D1&!D&!C&B&!A1&A|!E1&E&D2&D1&!D&!C&B&!A1&A|!E1&E&!D2&D1&!D&!C&B&!A1&A|E1&E&!D2&D1&!D&!C&B&!A1&A|E1&!E&!D2&D1&!D&!C&B&!A1&A|E1&!E&!D2&D1&D&!C&B&!A1&A|E1&E&!D2&D1&D&!C&B&!A1&A|!E1&E&!D2&D1&D&!C&B&!A1&A|!E1&E&D2&D1&D&!C&B&!A1&A|E1&E&D2&D1&D&!C&B&!A1&A|E1&!E&D2&D1&D&!C&B&!A1&A|E1&!E&D2&!D1&D&!C&B&!A1&A|E1&E&D2&!D1&D&!C&B&!A1&A|!E1&E&D2&!D1&D&!C&B&!A1&A|!E1&E&!D2&!D1&D&!C&B&!A1&A|E1&E&!D2&!D1&D&!C&B&!A1&A|E1&!E&!D2&!D1&D&!C&B&!A1&A|E1&!E&!D2&!D1&D&C&B&!A1&A|E1&E&!D2&!D1&D&C&B&!A1&A|!E1&E&!D2&!D1&D&C&B&!A1&A|!E1&E&D2&!D1&D&C&B&!A1&A|E1&E&D2&!D1&D&C&B&!A1&A|E1&!E&D2&!D1&D&C&B&!A1&A|E1&!E&D2&D1&D&C&B&!A1&A|E1&E&D2&D1&D&C&B&!A1&A|!E1&E&D2&D1&D&C&B&!A1&A|!E1&E&!D2&D1&D&C&B&!A1&A|E1&E&!D2&D1&D&C&B&!A1&A|E1&!E&!D2&D1&D&C&B&!A1&A|E1&!E&!D2&D1&!D&C&B&!A1&A|E1&E&!D2&D1&!D&C&B&!A1&A|!E1&E&!D2&D1&!D&C&B&!A1&A|!E1&E&D2&D1&!D&C&B&!A1&A|E1&E&D2&D1&!D&C&B&!A1&A|E1&!E&D2&D1&!D&C&B&!A1&A|E1&!E&D2&!D1&!D&C&B&!A1&A|E1&E&D2&!D1&!D&C&B&!A1&A|!E1&E&D2&!D1&!D&C&B&!A1&A|!E1&E&D2&!D1&!D&C&!B&!A1&A|E1&E&D2&!D1&!D&C&!B&!A1&A|E1&!E&D2&!D1&!D&C&!B&!A1&A|E1&!E&D2&D1&!D&C&!B&!A1&A|E1&E&D2&D1&!D&C&!B&!A1&A|!E1&E&D2&D1&!D&C&!B&!A1&A|!E1&E&!D2&D1&!D&C&!B&!A1&A|E1&E&!D2&D1&!D&C&!B&!A1&A|E1&!E&!D2&D1&!D&C&!B&!A1&A|E1&!E&!D2&D1&D&C&!B&!A1&A|E1&E&!D2&D1&D&C&!B&!A1&A|!E1&E&!D2&D1&D&C&!B&!A1&A|!E1&E&D2&D1&D&C&!B&!A1&A|E1&E&D2&D1&D&C&!B&!A1&A|E1&!E&D2&D1&D&C&!B&!A1&A|E1&!E&D2&!D1&D&C&!B&!A1&A|E1&E&D2&!D1&D&C&!B&!A1&A|!E1&E&D2&!D1&D&C&!B&!A1&A|!E1&E&!D2&!D1&D&C&!B&!A1&A|E1&E&!D2&!D1&D&C&!B&!A1&A|E1&!E&!D2&!D1&D&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOOAI21132.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOI21 -l AOI21 -i B A1 A -o Y -f Y=(!B&!A1&!A|!B&A1&!A|!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOI21.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOI3312 -l OOAAOI3312 -i D1 D C B2 B1 B A2 A1 A -o Y -f Y=(!D1&!D&!C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&C&B2&!B1&!B&!A2&!A1&!A|D1&!D&C&B2&!B1&!B&!A2&!A1&!A|!D1&D&C&B2&!B1&!B&!A2&!A1&!A|!D1&D&!C&B2&!B1&!B&!A2&!A1&!A|D1&!D&!C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C&B2&B1&!B&!A2&!A1&!A|D1&!D&!C&B2&B1&!B&!A2&!A1&!A|!D1&D&!C&B2&B1&!B&!A2&!A1&!A|!D1&D&C&B2&B1&!B&!A2&!A1&!A|D1&!D&C&B2&B1&!B&!A2&!A1&!A|!D1&!D&C&B2&B1&!B&!A2&!A1&!A|!D1&!D&C&!B2&B1&!B&!A2&!A1&!A|D1&!D&C&!B2&B1&!B&!A2&!A1&!A|!D1&D&C&!B2&B1&!B&!A2&!A1&!A|!D1&D&!C&!B2&B1&!B&!A2&!A1&!A|D1&!D&!C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&!C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&!C&!B2&B1&B&!A2&!A1&!A|D1&!D&!C&!B2&B1&B&!A2&!A1&!A|!D1&D&!C&!B2&B1&B&!A2&!A1&!A|!D1&D&C&!B2&B1&B&!A2&!A1&!A|D1&!D&C&!B2&B1&B&!A2&!A1&!A|!D1&!D&C&!B2&B1&B&!A2&!A1&!A|!D1&!D&C&B2&B1&B&!A2&!A1&!A|D1&!D&C&B2&B1&B&!A2&!A1&!A|!D1&D&C&B2&B1&B&!A2&!A1&!A|!D1&D&!C&B2&B1&B&!A2&!A1&!A|D1&!D&!C&B2&B1&B&!A2&!A1&!A|!D1&!D&!C&B2&B1&B&!A2&!A1&!A|!D1&!D&!C&B2&!B1&B&!A2&!A1&!A|D1&!D&!C&B2&!B1&B&!A2&!A1&!A|!D1&D&!C&B2&!B1&B&!A2&!A1&!A|!D1&D&C&B2&!B1&B&!A2&!A1&!A|D1&!D&C&B2&!B1&B&!A2&!A1&!A|!D1&!D&C&B2&!B1&B&!A2&!A1&!A|!D1&!D&C&!B2&!B1&B&!A2&!A1&!A|D1&!D&C&!B2&!B1&B&!A2&!A1&!A|!D1&D&C&!B2&!B1&B&!A2&!A1&!A|!D1&D&!C&!B2&!B1&B&!A2&!A1&!A|D1&!D&!C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&!C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&!C&!B2&!B1&B&A2&!A1&!A|D1&!D&!C&!B2&!B1&B&A2&!A1&!A|!D1&D&!C&!B2&!B1&B&A2&!A1&!A|!D1&D&!C&B2&!B1&B&A2&!A1&!A|D1&!D&!C&B2&!B1&B&A2&!A1&!A|!D1&!D&!C&B2&!B1&B&A2&!A1&!A|!D1&!D&!C&B2&B1&B&A2&!A1&!A|D1&!D&!C&B2&B1&B&A2&!A1&!A|!D1&D&!C&B2&B1&B&A2&!A1&!A|!D1&D&!C&!B2&B1&B&A2&!A1&!A|D1&!D&!C&!B2&B1&B&A2&!A1&!A|!D1&!D&!C&!B2&B1&B&A2&!A1&!A|!D1&!D&!C&!B2&B1&!B&A2&!A1&!A|D1&!D&!C&!B2&B1&!B&A2&!A1&!A|!D1&D&!C&!B2&B1&!B&A2&!A1&!A|!D1&D&!C&B2&B1&!B&A2&!A1&!A|D1&!D&!C&B2&B1&!B&A2&!A1&!A|!D1&!D&!C&B2&B1&!B&A2&!A1&!A|!D1&!D&!C&B2&!B1&!B&A2&!A1&!A|D1&!D&!C&B2&!B1&!B&A2&!A1&!A|!D1&D&!C&B2&!B1&!B&A2&!A1&!A|!D1&!D&C&!B2&!B1&!B&A2&!A1&!A|D1&!D&C&!B2&!B1&!B&A2&!A1&!A|!D1&D&C&!B2&!B1&!B&A2&!A1&!A|!D1&D&!C&!B2&!B1&!B&A2&!A1&!A|D1&!D&!C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&!C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&!C&!B2&!B1&!B&A2&A1&!A|D1&!D&!C&!B2&!B1&!B&A2&A1&!A|!D1&D&!C&!B2&!B1&!B&A2&A1&!A|!D1&D&C&!B2&!B1&!B&A2&A1&!A|D1&!D&C&!B2&!B1&!B&A2&A1&!A|!D1&!D&C&!B2&!B1&!B&A2&A1&!A|!D1&D&!C&B2&!B1&!B&A2&A1&!A|D1&!D&!C&B2&!B1&!B&A2&A1&!A|!D1&!D&!C&B2&!B1&!B&A2&A1&!A|!D1&!D&!C&B2&B1&!B&A2&A1&!A|D1&!D&!C&B2&B1&!B&A2&A1&!A|!D1&D&!C&B2&B1&!B&A2&A1&!A|!D1&D&!C&!B2&B1&!B&A2&A1&!A|D1&!D&!C&!B2&B1&!B&A2&A1&!A|!D1&!D&!C&!B2&B1&!B&A2&A1&!A|!D1&!D&!C&!B2&B1&B&A2&A1&!A|D1&!D&!C&!B2&B1&B&A2&A1&!A|!D1&D&!C&!B2&B1&B&A2&A1&!A|!D1&D&!C&B2&B1&B&A2&A1&!A|D1&!D&!C&B2&B1&B&A2&A1&!A|!D1&!D&!C&B2&B1&B&A2&A1&!A|!D1&!D&!C&B2&!B1&B&A2&A1&!A|D1&!D&!C&B2&!B1&B&A2&A1&!A|!D1&D&!C&B2&!B1&B&A2&A1&!A|!D1&D&!C&!B2&!B1&B&A2&A1&!A|D1&!D&!C&!B2&!B1&B&A2&A1&!A|!D1&!D&!C&!B2&!B1&B&A2&A1&!A|!D1&!D&!C&!B2&!B1&B&!A2&A1&!A|D1&!D&!C&!B2&!B1&B&!A2&A1&!A|!D1&D&!C&!B2&!B1&B&!A2&A1&!A|!D1&D&!C&B2&!B1&B&!A2&A1&!A|D1&!D&!C&B2&!B1&B&!A2&A1&!A|!D1&!D&!C&B2&!B1&B&!A2&A1&!A|!D1&!D&!C&B2&B1&B&!A2&A1&!A|D1&!D&!C&B2&B1&B&!A2&A1&!A|!D1&D&!C&B2&B1&B&!A2&A1&!A|!D1&D&!C&!B2&B1&B&!A2&A1&!A|D1&!D&!C&!B2&B1&B&!A2&A1&!A|!D1&!D&!C&!B2&B1&B&!A2&A1&!A|!D1&!D&!C&!B2&B1&!B&!A2&A1&!A|D1&!D&!C&!B2&B1&!B&!A2&A1&!A|!D1&D&!C&!B2&B1&!B&!A2&A1&!A|!D1&D&!C&B2&B1&!B&!A2&A1&!A|D1&!D&!C&B2&B1&!B&!A2&A1&!A|!D1&!D&!C&B2&B1&!B&!A2&A1&!A|!D1&!D&!C&B2&!B1&!B&!A2&A1&!A|D1&!D&!C&B2&!B1&!B&!A2&A1&!A|!D1&D&!C&B2&!B1&!B&!A2&A1&!A|!D1&!D&C&!B2&!B1&!B&!A2&A1&!A|D1&!D&C&!B2&!B1&!B&!A2&A1&!A|!D1&D&C&!B2&!B1&!B&!A2&A1&!A|!D1&D&!C&!B2&!B1&!B&!A2&A1&!A|D1&!D&!C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&!C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&!C&!B2&!B1&!B&!A2&A1&A|D1&!D&!C&!B2&!B1&!B&!A2&A1&A|!D1&D&!C&!B2&!B1&!B&!A2&A1&A|!D1&D&C&!B2&!B1&!B&!A2&A1&A|D1&!D&C&!B2&!B1&!B&!A2&A1&A|!D1&!D&C&!B2&!B1&!B&!A2&A1&A|!D1&D&!C&B2&!B1&!B&!A2&A1&A|D1&!D&!C&B2&!B1&!B&!A2&A1&A|!D1&!D&!C&B2&!B1&!B&!A2&A1&A|!D1&!D&!C&B2&B1&!B&!A2&A1&A|D1&!D&!C&B2&B1&!B&!A2&A1&A|!D1&D&!C&B2&B1&!B&!A2&A1&A|!D1&D&!C&!B2&B1&!B&!A2&A1&A|D1&!D&!C&!B2&B1&!B&!A2&A1&A|!D1&!D&!C&!B2&B1&!B&!A2&A1&A|!D1&!D&!C&!B2&B1&B&!A2&A1&A|D1&!D&!C&!B2&B1&B&!A2&A1&A|!D1&D&!C&!B2&B1&B&!A2&A1&A|!D1&D&!C&B2&B1&B&!A2&A1&A|D1&!D&!C&B2&B1&B&!A2&A1&A|!D1&!D&!C&B2&B1&B&!A2&A1&A|!D1&!D&!C&B2&!B1&B&!A2&A1&A|D1&!D&!C&B2&!B1&B&!A2&A1&A|!D1&D&!C&B2&!B1&B&!A2&A1&A|!D1&D&!C&!B2&!B1&B&!A2&A1&A|D1&!D&!C&!B2&!B1&B&!A2&A1&A|!D1&!D&!C&!B2&!B1&B&!A2&A1&A|!D1&!D&!C&!B2&!B1&B&A2&A1&A|D1&!D&!C&!B2&!B1&B&A2&A1&A|!D1&D&!C&!B2&!B1&B&A2&A1&A|!D1&D&!C&B2&!B1&B&A2&A1&A|D1&!D&!C&B2&!B1&B&A2&A1&A|!D1&!D&!C&B2&!B1&B&A2&A1&A|!D1&!D&!C&B2&B1&B&A2&A1&A|D1&!D&!C&B2&B1&B&A2&A1&A|!D1&D&!C&B2&B1&B&A2&A1&A|!D1&D&!C&!B2&B1&B&A2&A1&A|D1&!D&!C&!B2&B1&B&A2&A1&A|!D1&!D&!C&!B2&B1&B&A2&A1&A|!D1&!D&!C&!B2&B1&!B&A2&A1&A|D1&!D&!C&!B2&B1&!B&A2&A1&A|!D1&D&!C&!B2&B1&!B&A2&A1&A|!D1&D&!C&B2&B1&!B&A2&A1&A|D1&!D&!C&B2&B1&!B&A2&A1&A|!D1&!D&!C&B2&B1&!B&A2&A1&A|!D1&!D&!C&B2&!B1&!B&A2&A1&A|D1&!D&!C&B2&!B1&!B&A2&A1&A|!D1&D&!C&B2&!B1&!B&A2&A1&A|!D1&!D&C&!B2&!B1&!B&A2&A1&A|D1&!D&C&!B2&!B1&!B&A2&A1&A|!D1&D&C&!B2&!B1&!B&A2&A1&A|!D1&D&!C&!B2&!B1&!B&A2&A1&A|D1&!D&!C&!B2&!B1&!B&A2&A1&A|!D1&!D&!C&!B2&!B1&!B&A2&A1&A|!D1&!D&!C&!B2&!B1&!B&A2&!A1&A|D1&!D&!C&!B2&!B1&!B&A2&!A1&A|!D1&D&!C&!B2&!B1&!B&A2&!A1&A|!D1&D&C&!B2&!B1&!B&A2&!A1&A|D1&!D&C&!B2&!B1&!B&A2&!A1&A|!D1&!D&C&!B2&!B1&!B&A2&!A1&A|!D1&D&!C&B2&!B1&!B&A2&!A1&A|D1&!D&!C&B2&!B1&!B&A2&!A1&A|!D1&!D&!C&B2&!B1&!B&A2&!A1&A|!D1&!D&!C&B2&B1&!B&A2&!A1&A|D1&!D&!C&B2&B1&!B&A2&!A1&A|!D1&D&!C&B2&B1&!B&A2&!A1&A|!D1&D&!C&!B2&B1&!B&A2&!A1&A|D1&!D&!C&!B2&B1&!B&A2&!A1&A|!D1&!D&!C&!B2&B1&!B&A2&!A1&A|!D1&!D&!C&!B2&B1&B&A2&!A1&A|D1&!D&!C&!B2&B1&B&A2&!A1&A|!D1&D&!C&!B2&B1&B&A2&!A1&A|!D1&D&!C&B2&B1&B&A2&!A1&A|D1&!D&!C&B2&B1&B&A2&!A1&A|!D1&!D&!C&B2&B1&B&A2&!A1&A|!D1&!D&!C&B2&!B1&B&A2&!A1&A|D1&!D&!C&B2&!B1&B&A2&!A1&A|!D1&D&!C&B2&!B1&B&A2&!A1&A|!D1&D&!C&!B2&!B1&B&A2&!A1&A|D1&!D&!C&!B2&!B1&B&A2&!A1&A|!D1&!D&!C&!B2&!B1&B&A2&!A1&A|!D1&!D&!C&!B2&!B1&B&!A2&!A1&A|D1&!D&!C&!B2&!B1&B&!A2&!A1&A|!D1&D&!C&!B2&!B1&B&!A2&!A1&A|!D1&D&!C&B2&!B1&B&!A2&!A1&A|D1&!D&!C&B2&!B1&B&!A2&!A1&A|!D1&!D&!C&B2&!B1&B&!A2&!A1&A|!D1&!D&!C&B2&B1&B&!A2&!A1&A|D1&!D&!C&B2&B1&B&!A2&!A1&A|!D1&D&!C&B2&B1&B&!A2&!A1&A|!D1&D&!C&!B2&B1&B&!A2&!A1&A|D1&!D&!C&!B2&B1&B&!A2&!A1&A|!D1&!D&!C&!B2&B1&B&!A2&!A1&A|!D1&!D&!C&!B2&B1&!B&!A2&!A1&A|D1&!D&!C&!B2&B1&!B&!A2&!A1&A|!D1&D&!C&!B2&B1&!B&!A2&!A1&A|!D1&D&!C&B2&B1&!B&!A2&!A1&A|D1&!D&!C&B2&B1&!B&!A2&!A1&A|!D1&!D&!C&B2&B1&!B&!A2&!A1&A|!D1&!D&!C&B2&!B1&!B&!A2&!A1&A|D1&!D&!C&B2&!B1&!B&!A2&!A1&A|!D1&D&!C&B2&!B1&!B&!A2&!A1&A|!D1&!D&C&!B2&!B1&!B&!A2&!A1&A|D1&!D&C&!B2&!B1&!B&!A2&!A1&A|!D1&D&C&!B2&!B1&!B&!A2&!A1&A|!D1&D&!C&!B2&!B1&!B&!A2&!A1&A|D1&!D&!C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOI3312.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOAI221211 -l AAOAAOAI221211 -i F E D1 D C B1 B A1 A -o Y -f Y=!(F&E&!D1&!D&!C&!B1&!B&!A1&!A|F&E&D1&!D&!C&!B1&!B&!A1&!A|F&!E&D1&D&!C&!B1&!B&!A1&!A|F&E&D1&D&!C&!B1&!B&!A1&!A|F&E&!D1&D&!C&!B1&!B&!A1&!A|F&E&!D1&D&C&!B1&!B&!A1&!A|F&E&D1&D&C&!B1&!B&!A1&!A|F&!E&D1&D&C&!B1&!B&!A1&!A|F&E&D1&!D&C&!B1&!B&!A1&!A|F&E&!D1&!D&C&!B1&!B&!A1&!A|F&E&!D1&!D&C&B1&!B&!A1&!A|F&E&D1&!D&C&B1&!B&!A1&!A|F&!E&D1&D&C&B1&!B&!A1&!A|F&E&D1&D&C&B1&!B&!A1&!A|F&E&!D1&D&C&B1&!B&!A1&!A|F&E&!D1&D&!C&B1&!B&!A1&!A|F&E&D1&D&!C&B1&!B&!A1&!A|F&!E&D1&D&!C&B1&!B&!A1&!A|F&E&D1&!D&!C&B1&!B&!A1&!A|F&E&!D1&!D&!C&B1&!B&!A1&!A|F&E&!D1&!D&!C&B1&B&!A1&!A|F&E&D1&!D&!C&B1&B&!A1&!A|F&!E&D1&D&!C&B1&B&!A1&!A|F&E&D1&D&!C&B1&B&!A1&!A|F&E&!D1&D&!C&B1&B&!A1&!A|F&!E&!D1&D&C&B1&B&!A1&!A|F&E&!D1&D&C&B1&B&!A1&!A|F&E&D1&D&C&B1&B&!A1&!A|F&!E&D1&D&C&B1&B&!A1&!A|F&!E&D1&!D&C&B1&B&!A1&!A|F&E&D1&!D&C&B1&B&!A1&!A|F&E&!D1&!D&C&B1&B&!A1&!A|F&!E&!D1&!D&C&B1&B&!A1&!A|F&E&!D1&!D&C&!B1&B&!A1&!A|F&E&D1&!D&C&!B1&B&!A1&!A|F&!E&D1&D&C&!B1&B&!A1&!A|F&E&D1&D&C&!B1&B&!A1&!A|F&E&!D1&D&C&!B1&B&!A1&!A|F&E&!D1&D&!C&!B1&B&!A1&!A|F&E&D1&D&!C&!B1&B&!A1&!A|F&!E&D1&D&!C&!B1&B&!A1&!A|F&E&D1&!D&!C&!B1&B&!A1&!A|F&E&!D1&!D&!C&!B1&B&!A1&!A|F&E&!D1&!D&!C&!B1&B&A1&!A|F&E&D1&!D&!C&!B1&B&A1&!A|F&!E&D1&D&!C&!B1&B&A1&!A|F&E&D1&D&!C&!B1&B&A1&!A|F&E&!D1&D&!C&!B1&B&A1&!A|F&E&!D1&D&C&!B1&B&A1&!A|F&E&D1&D&C&!B1&B&A1&!A|F&!E&D1&D&C&!B1&B&A1&!A|F&E&D1&!D&C&!B1&B&A1&!A|F&E&!D1&!D&C&!B1&B&A1&!A|F&!E&!D1&!D&C&B1&B&A1&!A|F&E&!D1&!D&C&B1&B&A1&!A|F&E&D1&!D&C&B1&B&A1&!A|F&!E&D1&!D&C&B1&B&A1&!A|F&!E&D1&D&C&B1&B&A1&!A|F&E&D1&D&C&B1&B&A1&!A|F&E&!D1&D&C&B1&B&A1&!A|F&!E&!D1&D&C&B1&B&A1&!A|F&E&!D1&D&!C&B1&B&A1&!A|F&E&D1&D&!C&B1&B&A1&!A|F&!E&D1&D&!C&B1&B&A1&!A|F&E&D1&!D&!C&B1&B&A1&!A|F&E&!D1&!D&!C&B1&B&A1&!A|F&E&!D1&!D&!C&B1&!B&A1&!A|F&E&D1&!D&!C&B1&!B&A1&!A|F&!E&D1&D&!C&B1&!B&A1&!A|F&E&D1&D&!C&B1&!B&A1&!A|F&E&!D1&D&!C&B1&!B&A1&!A|F&E&!D1&D&C&B1&!B&A1&!A|F&E&D1&D&C&B1&!B&A1&!A|F&!E&D1&D&C&B1&!B&A1&!A|F&E&D1&!D&C&B1&!B&A1&!A|F&E&!D1&!D&C&B1&!B&A1&!A|F&E&!D1&!D&C&!B1&!B&A1&!A|F&E&D1&!D&C&!B1&!B&A1&!A|F&!E&D1&D&C&!B1&!B&A1&!A|F&E&D1&D&C&!B1&!B&A1&!A|F&E&!D1&D&C&!B1&!B&A1&!A|F&E&!D1&D&!C&!B1&!B&A1&!A|F&E&D1&D&!C&!B1&!B&A1&!A|F&!E&D1&D&!C&!B1&!B&A1&!A|F&E&D1&!D&!C&!B1&!B&A1&!A|F&E&!D1&!D&!C&!B1&!B&A1&!A|F&E&!D1&!D&!C&!B1&!B&A1&A|F&E&D1&!D&!C&!B1&!B&A1&A|F&!E&D1&D&!C&!B1&!B&A1&A|F&E&D1&D&!C&!B1&!B&A1&A|F&E&!D1&D&!C&!B1&!B&A1&A|F&!E&!D1&D&C&!B1&!B&A1&A|F&E&!D1&D&C&!B1&!B&A1&A|F&E&D1&D&C&!B1&!B&A1&A|F&!E&D1&D&C&!B1&!B&A1&A|F&!E&D1&!D&C&!B1&!B&A1&A|F&E&D1&!D&C&!B1&!B&A1&A|F&E&!D1&!D&C&!B1&!B&A1&A|F&!E&!D1&!D&C&!B1&!B&A1&A|F&!E&!D1&!D&C&B1&!B&A1&A|F&E&!D1&!D&C&B1&!B&A1&A|F&E&D1&!D&C&B1&!B&A1&A|F&!E&D1&!D&C&B1&!B&A1&A|F&!E&D1&D&C&B1&!B&A1&A|F&E&D1&D&C&B1&!B&A1&A|F&E&!D1&D&C&B1&!B&A1&A|F&!E&!D1&D&C&B1&!B&A1&A|F&E&!D1&D&!C&B1&!B&A1&A|F&E&D1&D&!C&B1&!B&A1&A|F&!E&D1&D&!C&B1&!B&A1&A|F&E&D1&!D&!C&B1&!B&A1&A|F&E&!D1&!D&!C&B1&!B&A1&A|F&E&!D1&!D&!C&B1&B&A1&A|F&E&D1&!D&!C&B1&B&A1&A|F&!E&D1&D&!C&B1&B&A1&A|F&E&D1&D&!C&B1&B&A1&A|F&E&!D1&D&!C&B1&B&A1&A|F&!E&!D1&D&C&B1&B&A1&A|F&E&!D1&D&C&B1&B&A1&A|F&E&D1&D&C&B1&B&A1&A|F&!E&D1&D&C&B1&B&A1&A|F&!E&D1&!D&C&B1&B&A1&A|F&E&D1&!D&C&B1&B&A1&A|F&E&!D1&!D&C&B1&B&A1&A|F&!E&!D1&!D&C&B1&B&A1&A|F&!E&!D1&!D&C&!B1&B&A1&A|F&E&!D1&!D&C&!B1&B&A1&A|F&E&D1&!D&C&!B1&B&A1&A|F&!E&D1&!D&C&!B1&B&A1&A|F&!E&D1&D&C&!B1&B&A1&A|F&E&D1&D&C&!B1&B&A1&A|F&E&!D1&D&C&!B1&B&A1&A|F&!E&!D1&D&C&!B1&B&A1&A|F&E&!D1&D&!C&!B1&B&A1&A|F&E&D1&D&!C&!B1&B&A1&A|F&!E&D1&D&!C&!B1&B&A1&A|F&E&D1&!D&!C&!B1&B&A1&A|F&E&!D1&!D&!C&!B1&B&A1&A|F&E&!D1&!D&!C&!B1&B&!A1&A|F&E&D1&!D&!C&!B1&B&!A1&A|F&!E&D1&D&!C&!B1&B&!A1&A|F&E&D1&D&!C&!B1&B&!A1&A|F&E&!D1&D&!C&!B1&B&!A1&A|F&E&!D1&D&C&!B1&B&!A1&A|F&E&D1&D&C&!B1&B&!A1&A|F&!E&D1&D&C&!B1&B&!A1&A|F&E&D1&!D&C&!B1&B&!A1&A|F&E&!D1&!D&C&!B1&B&!A1&A|F&!E&!D1&!D&C&B1&B&!A1&A|F&E&!D1&!D&C&B1&B&!A1&A|F&E&D1&!D&C&B1&B&!A1&A|F&!E&D1&!D&C&B1&B&!A1&A|F&!E&D1&D&C&B1&B&!A1&A|F&E&D1&D&C&B1&B&!A1&A|F&E&!D1&D&C&B1&B&!A1&A|F&!E&!D1&D&C&B1&B&!A1&A|F&E&!D1&D&!C&B1&B&!A1&A|F&E&D1&D&!C&B1&B&!A1&A|F&!E&D1&D&!C&B1&B&!A1&A|F&E&D1&!D&!C&B1&B&!A1&A|F&E&!D1&!D&!C&B1&B&!A1&A|F&E&!D1&!D&!C&B1&!B&!A1&A|F&E&D1&!D&!C&B1&!B&!A1&A|F&!E&D1&D&!C&B1&!B&!A1&A|F&E&D1&D&!C&B1&!B&!A1&A|F&E&!D1&D&!C&B1&!B&!A1&A|F&E&!D1&D&C&B1&!B&!A1&A|F&E&D1&D&C&B1&!B&!A1&A|F&!E&D1&D&C&B1&!B&!A1&A|F&E&D1&!D&C&B1&!B&!A1&A|F&E&!D1&!D&C&B1&!B&!A1&A|F&E&!D1&!D&C&!B1&!B&!A1&A|F&E&D1&!D&C&!B1&!B&!A1&A|F&!E&D1&D&C&!B1&!B&!A1&A|F&E&D1&D&C&!B1&!B&!A1&A|F&E&!D1&D&C&!B1&!B&!A1&A|F&E&!D1&D&!C&!B1&!B&!A1&A|F&E&D1&D&!C&!B1&!B&!A1&A|F&!E&D1&D&!C&!B1&!B&!A1&A|F&E&D1&!D&!C&!B1&!B&!A1&A|F&E&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOAI221211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOOAI21222 -l AOOAAOOAI21222 -i E1 E D1 D C1 C B A1 A -o Y -f Y=!(E1&!E&D1&D&!C1&!C&!B&!A1&!A|E1&E&D1&D&!C1&!C&!B&!A1&!A|!E1&E&D1&D&!C1&!C&!B&!A1&!A|!E1&E&D1&D&C1&!C&!B&!A1&!A|E1&E&D1&D&C1&!C&!B&!A1&!A|E1&!E&D1&D&C1&!C&!B&!A1&!A|E1&!E&D1&D&C1&C&!B&!A1&!A|E1&E&D1&D&C1&C&!B&!A1&!A|!E1&E&D1&D&C1&C&!B&!A1&!A|!E1&E&D1&D&!C1&C&!B&!A1&!A|E1&E&D1&D&!C1&C&!B&!A1&!A|E1&!E&D1&D&!C1&C&!B&!A1&!A|E1&!E&!D1&!D&!C1&C&B&!A1&!A|E1&E&!D1&!D&!C1&C&B&!A1&!A|!E1&E&!D1&!D&!C1&C&B&!A1&!A|!E1&E&D1&!D&!C1&C&B&!A1&!A|E1&E&D1&!D&!C1&C&B&!A1&!A|E1&!E&D1&!D&!C1&C&B&!A1&!A|E1&!E&D1&D&!C1&C&B&!A1&!A|E1&E&D1&D&!C1&C&B&!A1&!A|!E1&E&D1&D&!C1&C&B&!A1&!A|!E1&E&!D1&D&!C1&C&B&!A1&!A|E1&E&!D1&D&!C1&C&B&!A1&!A|E1&!E&!D1&D&!C1&C&B&!A1&!A|E1&!E&!D1&D&C1&C&B&!A1&!A|E1&E&!D1&D&C1&C&B&!A1&!A|!E1&E&!D1&D&C1&C&B&!A1&!A|!E1&E&D1&D&C1&C&B&!A1&!A|E1&E&D1&D&C1&C&B&!A1&!A|E1&!E&D1&D&C1&C&B&!A1&!A|E1&!E&D1&!D&C1&C&B&!A1&!A|E1&E&D1&!D&C1&C&B&!A1&!A|!E1&E&D1&!D&C1&C&B&!A1&!A|!E1&E&!D1&!D&C1&C&B&!A1&!A|E1&E&!D1&!D&C1&C&B&!A1&!A|E1&!E&!D1&!D&C1&C&B&!A1&!A|E1&!E&!D1&!D&C1&!C&B&!A1&!A|E1&E&!D1&!D&C1&!C&B&!A1&!A|!E1&E&!D1&!D&C1&!C&B&!A1&!A|!E1&E&D1&!D&C1&!C&B&!A1&!A|E1&E&D1&!D&C1&!C&B&!A1&!A|E1&!E&D1&!D&C1&!C&B&!A1&!A|E1&!E&D1&D&C1&!C&B&!A1&!A|E1&E&D1&D&C1&!C&B&!A1&!A|!E1&E&D1&D&C1&!C&B&!A1&!A|!E1&E&!D1&D&C1&!C&B&!A1&!A|E1&E&!D1&D&C1&!C&B&!A1&!A|E1&!E&!D1&D&C1&!C&B&!A1&!A|!E1&E&D1&D&!C1&!C&B&!A1&!A|E1&E&D1&D&!C1&!C&B&!A1&!A|E1&!E&D1&D&!C1&!C&B&!A1&!A|E1&!E&D1&D&!C1&!C&B&A1&!A|E1&E&D1&D&!C1&!C&B&A1&!A|!E1&E&D1&D&!C1&!C&B&A1&!A|E1&!E&!D1&D&C1&!C&B&A1&!A|E1&E&!D1&D&C1&!C&B&A1&!A|!E1&E&!D1&D&C1&!C&B&A1&!A|!E1&E&D1&D&C1&!C&B&A1&!A|E1&E&D1&D&C1&!C&B&A1&!A|E1&!E&D1&D&C1&!C&B&A1&!A|E1&!E&D1&!D&C1&!C&B&A1&!A|E1&E&D1&!D&C1&!C&B&A1&!A|!E1&E&D1&!D&C1&!C&B&A1&!A|!E1&E&!D1&!D&C1&!C&B&A1&!A|E1&E&!D1&!D&C1&!C&B&A1&!A|E1&!E&!D1&!D&C1&!C&B&A1&!A|E1&!E&!D1&!D&C1&C&B&A1&!A|E1&E&!D1&!D&C1&C&B&A1&!A|!E1&E&!D1&!D&C1&C&B&A1&!A|!E1&E&D1&!D&C1&C&B&A1&!A|E1&E&D1&!D&C1&C&B&A1&!A|E1&!E&D1&!D&C1&C&B&A1&!A|E1&!E&D1&D&C1&C&B&A1&!A|E1&E&D1&D&C1&C&B&A1&!A|!E1&E&D1&D&C1&C&B&A1&!A|!E1&E&!D1&D&C1&C&B&A1&!A|E1&E&!D1&D&C1&C&B&A1&!A|E1&!E&!D1&D&C1&C&B&A1&!A|E1&!E&!D1&D&!C1&C&B&A1&!A|E1&E&!D1&D&!C1&C&B&A1&!A|!E1&E&!D1&D&!C1&C&B&A1&!A|!E1&E&D1&D&!C1&C&B&A1&!A|E1&E&D1&D&!C1&C&B&A1&!A|E1&!E&D1&D&!C1&C&B&A1&!A|E1&!E&D1&!D&!C1&C&B&A1&!A|E1&E&D1&!D&!C1&C&B&A1&!A|!E1&E&D1&!D&!C1&C&B&A1&!A|!E1&E&!D1&!D&!C1&C&B&A1&!A|E1&E&!D1&!D&!C1&C&B&A1&!A|E1&!E&!D1&!D&!C1&C&B&A1&!A|E1&!E&D1&D&!C1&C&!B&A1&!A|E1&E&D1&D&!C1&C&!B&A1&!A|!E1&E&D1&D&!C1&C&!B&A1&!A|!E1&E&D1&D&C1&C&!B&A1&!A|E1&E&D1&D&C1&C&!B&A1&!A|E1&!E&D1&D&C1&C&!B&A1&!A|E1&!E&D1&D&C1&!C&!B&A1&!A|E1&E&D1&D&C1&!C&!B&A1&!A|!E1&E&D1&D&C1&!C&!B&A1&!A|!E1&E&D1&D&!C1&!C&!B&A1&!A|E1&E&D1&D&!C1&!C&!B&A1&!A|E1&!E&D1&D&!C1&!C&!B&A1&!A|E1&!E&D1&D&!C1&!C&!B&A1&A|E1&E&D1&D&!C1&!C&!B&A1&A|!E1&E&D1&D&!C1&!C&!B&A1&A|E1&!E&!D1&D&C1&!C&!B&A1&A|E1&E&!D1&D&C1&!C&!B&A1&A|!E1&E&!D1&D&C1&!C&!B&A1&A|!E1&E&D1&D&C1&!C&!B&A1&A|E1&E&D1&D&C1&!C&!B&A1&A|E1&!E&D1&D&C1&!C&!B&A1&A|E1&!E&D1&!D&C1&!C&!B&A1&A|E1&E&D1&!D&C1&!C&!B&A1&A|!E1&E&D1&!D&C1&!C&!B&A1&A|!E1&E&!D1&!D&C1&!C&!B&A1&A|E1&E&!D1&!D&C1&!C&!B&A1&A|E1&!E&!D1&!D&C1&!C&!B&A1&A|E1&!E&!D1&!D&C1&C&!B&A1&A|E1&E&!D1&!D&C1&C&!B&A1&A|!E1&E&!D1&!D&C1&C&!B&A1&A|!E1&E&D1&!D&C1&C&!B&A1&A|E1&E&D1&!D&C1&C&!B&A1&A|E1&!E&D1&!D&C1&C&!B&A1&A|E1&!E&D1&D&C1&C&!B&A1&A|E1&E&D1&D&C1&C&!B&A1&A|!E1&E&D1&D&C1&C&!B&A1&A|!E1&E&!D1&D&C1&C&!B&A1&A|E1&E&!D1&D&C1&C&!B&A1&A|E1&!E&!D1&D&C1&C&!B&A1&A|E1&!E&!D1&D&!C1&C&!B&A1&A|E1&E&!D1&D&!C1&C&!B&A1&A|!E1&E&!D1&D&!C1&C&!B&A1&A|!E1&E&D1&D&!C1&C&!B&A1&A|E1&E&D1&D&!C1&C&!B&A1&A|E1&!E&D1&D&!C1&C&!B&A1&A|E1&!E&D1&!D&!C1&C&!B&A1&A|E1&E&D1&!D&!C1&C&!B&A1&A|!E1&E&D1&!D&!C1&C&!B&A1&A|!E1&E&!D1&!D&!C1&C&!B&A1&A|E1&E&!D1&!D&!C1&C&!B&A1&A|E1&!E&!D1&!D&!C1&C&!B&A1&A|E1&!E&!D1&!D&!C1&C&B&A1&A|E1&E&!D1&!D&!C1&C&B&A1&A|!E1&E&!D1&!D&!C1&C&B&A1&A|!E1&E&D1&!D&!C1&C&B&A1&A|E1&E&D1&!D&!C1&C&B&A1&A|E1&!E&D1&!D&!C1&C&B&A1&A|E1&!E&D1&D&!C1&C&B&A1&A|E1&E&D1&D&!C1&C&B&A1&A|!E1&E&D1&D&!C1&C&B&A1&A|!E1&E&!D1&D&!C1&C&B&A1&A|E1&E&!D1&D&!C1&C&B&A1&A|E1&!E&!D1&D&!C1&C&B&A1&A|E1&!E&!D1&D&C1&C&B&A1&A|E1&E&!D1&D&C1&C&B&A1&A|!E1&E&!D1&D&C1&C&B&A1&A|!E1&E&D1&D&C1&C&B&A1&A|E1&E&D1&D&C1&C&B&A1&A|E1&!E&D1&D&C1&C&B&A1&A|E1&!E&D1&!D&C1&C&B&A1&A|E1&E&D1&!D&C1&C&B&A1&A|!E1&E&D1&!D&C1&C&B&A1&A|!E1&E&!D1&!D&C1&C&B&A1&A|E1&E&!D1&!D&C1&C&B&A1&A|E1&!E&!D1&!D&C1&C&B&A1&A|E1&!E&!D1&!D&C1&!C&B&A1&A|E1&E&!D1&!D&C1&!C&B&A1&A|!E1&E&!D1&!D&C1&!C&B&A1&A|!E1&E&D1&!D&C1&!C&B&A1&A|E1&E&D1&!D&C1&!C&B&A1&A|E1&!E&D1&!D&C1&!C&B&A1&A|E1&!E&D1&D&C1&!C&B&A1&A|E1&E&D1&D&C1&!C&B&A1&A|!E1&E&D1&D&C1&!C&B&A1&A|!E1&E&!D1&D&C1&!C&B&A1&A|E1&E&!D1&D&C1&!C&B&A1&A|E1&!E&!D1&D&C1&!C&B&A1&A|!E1&E&D1&D&!C1&!C&B&A1&A|E1&E&D1&D&!C1&!C&B&A1&A|E1&!E&D1&D&!C1&!C&B&A1&A|E1&!E&D1&D&!C1&!C&B&!A1&A|E1&E&D1&D&!C1&!C&B&!A1&A|!E1&E&D1&D&!C1&!C&B&!A1&A|E1&!E&!D1&D&C1&!C&B&!A1&A|E1&E&!D1&D&C1&!C&B&!A1&A|!E1&E&!D1&D&C1&!C&B&!A1&A|!E1&E&D1&D&C1&!C&B&!A1&A|E1&E&D1&D&C1&!C&B&!A1&A|E1&!E&D1&D&C1&!C&B&!A1&A|E1&!E&D1&!D&C1&!C&B&!A1&A|E1&E&D1&!D&C1&!C&B&!A1&A|!E1&E&D1&!D&C1&!C&B&!A1&A|!E1&E&!D1&!D&C1&!C&B&!A1&A|E1&E&!D1&!D&C1&!C&B&!A1&A|E1&!E&!D1&!D&C1&!C&B&!A1&A|E1&!E&!D1&!D&C1&C&B&!A1&A|E1&E&!D1&!D&C1&C&B&!A1&A|!E1&E&!D1&!D&C1&C&B&!A1&A|!E1&E&D1&!D&C1&C&B&!A1&A|E1&E&D1&!D&C1&C&B&!A1&A|E1&!E&D1&!D&C1&C&B&!A1&A|E1&!E&D1&D&C1&C&B&!A1&A|E1&E&D1&D&C1&C&B&!A1&A|!E1&E&D1&D&C1&C&B&!A1&A|!E1&E&!D1&D&C1&C&B&!A1&A|E1&E&!D1&D&C1&C&B&!A1&A|E1&!E&!D1&D&C1&C&B&!A1&A|E1&!E&!D1&D&!C1&C&B&!A1&A|E1&E&!D1&D&!C1&C&B&!A1&A|!E1&E&!D1&D&!C1&C&B&!A1&A|!E1&E&D1&D&!C1&C&B&!A1&A|E1&E&D1&D&!C1&C&B&!A1&A|E1&!E&D1&D&!C1&C&B&!A1&A|E1&!E&D1&!D&!C1&C&B&!A1&A|E1&E&D1&!D&!C1&C&B&!A1&A|!E1&E&D1&!D&!C1&C&B&!A1&A|!E1&E&!D1&!D&!C1&C&B&!A1&A|E1&E&!D1&!D&!C1&C&B&!A1&A|E1&!E&!D1&!D&!C1&C&B&!A1&A|E1&!E&D1&D&!C1&C&!B&!A1&A|E1&E&D1&D&!C1&C&!B&!A1&A|!E1&E&D1&D&!C1&C&!B&!A1&A|!E1&E&D1&D&C1&C&!B&!A1&A|E1&E&D1&D&C1&C&!B&!A1&A|E1&!E&D1&D&C1&C&!B&!A1&A|E1&!E&D1&D&C1&!C&!B&!A1&A|E1&E&D1&D&C1&!C&!B&!A1&A|!E1&E&D1&D&C1&!C&!B&!A1&A|!E1&E&D1&D&!C1&!C&!B&!A1&A|E1&E&D1&D&!C1&!C&!B&!A1&A|E1&!E&D1&D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOOAI21222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n MUX5 -l MUX5 -i IN0 IN1 IN2 IN3 IN4 S0 S1 S2 S3 S4 -o Z -f 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist MUX5.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOOAI211212 -l AOAAOOAI211212 -i F1 F E D1 D C B A1 A -o Y -f Y=(!F1&!F&!E&!D1&!D&!C&!B&!A1&!A|F1&!F&!E&!D1&!D&!C&!B&!A1&!A|F1&F&!E&!D1&!D&!C&!B&!A1&!A|!F1&F&!E&!D1&!D&!C&!B&!A1&!A|!F1&!F&E&!D1&!D&!C&!B&!A1&!A|!F1&!F&E&D1&!D&!C&!B&!A1&!A|!F1&F&!E&D1&!D&!C&!B&!A1&!A|F1&F&!E&D1&!D&!C&!B&!A1&!A|F1&!F&!E&D1&!D&!C&!B&!A1&!A|!F1&!F&!E&D1&!D&!C&!B&!A1&!A|!F1&!F&!E&D1&D&!C&!B&!A1&!A|!F1&!F&E&D1&D&!C&!B&!A1&!A|!F1&!F&E&!D1&D&!C&!B&!A1&!A|!F1&F&!E&!D1&D&!C&!B&!A1&!A|F1&F&!E&!D1&D&!C&!B&!A1&!A|F1&!F&!E&!D1&D&!C&!B&!A1&!A|!F1&!F&!E&!D1&D&!C&!B&!A1&!A|!F1&!F&!E&!D1&D&C&!B&!A1&!A|F1&!F&!E&!D1&D&C&!B&!A1&!A|F1&F&!E&!D1&D&C&!B&!A1&!A|!F1&F&!E&!D1&D&C&!B&!A1&!A|!F1&!F&E&!D1&D&C&!B&!A1&!A|!F1&!F&E&D1&D&C&!B&!A1&!A|!F1&!F&!E&D1&D&C&!B&!A1&!A|!F1&!F&!E&D1&!D&C&!B&!A1&!A|F1&!F&!E&D1&!D&C&!B&!A1&!A|F1&F&!E&D1&!D&C&!B&!A1&!A|!F1&F&!E&D1&!D&C&!B&!A1&!A|!F1&!F&E&D1&!D&C&!B&!A1&!A|!F1&!F&E&!D1&!D&C&!B&!A1&!A|!F1&F&!E&!D1&!D&C&!B&!A1&!A|F1&F&!E&!D1&!D&C&!B&!A1&!A|F1&!F&!E&!D1&!D&C&!B&!A1&!A|!F1&!F&!E&!D1&!D&C&!B&!A1&!A|!F1&!F&!E&!D1&!D&C&B&!A1&!A|!F1&!F&E&!D1&!D&C&B&!A1&!A|!F1&!F&E&D1&!D&C&B&!A1&!A|!F1&!F&!E&D1&!D&C&B&!A1&!A|!F1&!F&!E&D1&D&C&B&!A1&!A|!F1&!F&E&D1&D&C&B&!A1&!A|!F1&!F&E&!D1&D&C&B&!A1&!A|!F1&!F&!E&!D1&D&C&B&!A1&!A|!F1&!F&!E&!D1&D&!C&B&!A1&!A|F1&!F&!E&!D1&D&!C&B&!A1&!A|F1&F&!E&!D1&D&!C&B&!A1&!A|!F1&F&!E&!D1&D&!C&B&!A1&!A|!F1&!F&E&!D1&D&!C&B&!A1&!A|!F1&!F&E&D1&D&!C&B&!A1&!A|!F1&!F&!E&D1&D&!C&B&!A1&!A|!F1&!F&!E&D1&!D&!C&B&!A1&!A|F1&!F&!E&D1&!D&!C&B&!A1&!A|F1&F&!E&D1&!D&!C&B&!A1&!A|!F1&F&!E&D1&!D&!C&B&!A1&!A|!F1&!F&E&D1&!D&!C&B&!A1&!A|!F1&!F&E&!D1&!D&!C&B&!A1&!A|!F1&F&!E&!D1&!D&!C&B&!A1&!A|F1&F&!E&!D1&!D&!C&B&!A1&!A|F1&!F&!E&!D1&!D&!C&B&!A1&!A|!F1&!F&!E&!D1&!D&!C&B&!A1&!A|!F1&!F&!E&!D1&!D&!C&B&A1&!A|F1&!F&!E&!D1&!D&!C&B&A1&!A|F1&F&!E&!D1&!D&!C&B&A1&!A|!F1&F&!E&!D1&!D&!C&B&A1&!A|!F1&!F&E&!D1&!D&!C&B&A1&!A|!F1&!F&E&D1&!D&!C&B&A1&!A|!F1&F&!E&D1&!D&!C&B&A1&!A|F1&F&!E&D1&!D&!C&B&A1&!A|F1&!F&!E&D1&!D&!C&B&A1&!A|!F1&!F&!E&D1&!D&!C&B&A1&!A|!F1&!F&!E&D1&D&!C&B&A1&!A|!F1&!F&E&D1&D&!C&B&A1&!A|!F1&!F&E&!D1&D&!C&B&A1&!A|!F1&F&!E&!D1&D&!C&B&A1&!A|F1&F&!E&!D1&D&!C&B&A1&!A|F1&!F&!E&!D1&D&!C&B&A1&!A|!F1&!F&!E&!D1&D&!C&B&A1&!A|!F1&!F&!E&!D1&D&C&B&A1&!A|!F1&!F&E&!D1&D&C&B&A1&!A|!F1&!F&E&D1&D&C&B&A1&!A|!F1&!F&!E&D1&D&C&B&A1&!A|!F1&!F&!E&D1&!D&C&B&A1&!A|!F1&!F&E&D1&!D&C&B&A1&!A|!F1&!F&E&!D1&!D&C&B&A1&!A|!F1&!F&!E&!D1&!D&C&B&A1&!A|!F1&!F&!E&!D1&!D&C&!B&A1&!A|F1&!F&!E&!D1&!D&C&!B&A1&!A|F1&F&!E&!D1&!D&C&!B&A1&!A|!F1&F&!E&!D1&!D&C&!B&A1&!A|!F1&!F&E&!D1&!D&C&!B&A1&!A|!F1&!F&E&D1&!D&C&!B&A1&!A|!F1&F&!E&D1&!D&C&!B&A1&!A|F1&F&!E&D1&!D&C&!B&A1&!A|F1&!F&!E&D1&!D&C&!B&A1&!A|!F1&!F&!E&D1&!D&C&!B&A1&!A|!F1&!F&!E&D1&D&C&!B&A1&!A|!F1&!F&E&D1&D&C&!B&A1&!A|!F1&!F&E&!D1&D&C&!B&A1&!A|!F1&F&!E&!D1&D&C&!B&A1&!A|F1&F&!E&!D1&D&C&!B&A1&!A|F1&!F&!E&!D1&D&C&!B&A1&!A|!F1&!F&!E&!D1&D&C&!B&A1&!A|!F1&!F&!E&!D1&D&!C&!B&A1&!A|F1&!F&!E&!D1&D&!C&!B&A1&!A|F1&F&!E&!D1&D&!C&!B&A1&!A|!F1&F&!E&!D1&D&!C&!B&A1&!A|!F1&!F&E&!D1&D&!C&!B&A1&!A|!F1&!F&E&D1&D&!C&!B&A1&!A|!F1&!F&!E&D1&D&!C&!B&A1&!A|!F1&!F&!E&D1&!D&!C&!B&A1&!A|F1&!F&!E&D1&!D&!C&!B&A1&!A|F1&F&!E&D1&!D&!C&!B&A1&!A|!F1&F&!E&D1&!D&!C&!B&A1&!A|!F1&!F&E&D1&!D&!C&!B&A1&!A|!F1&!F&E&!D1&!D&!C&!B&A1&!A|!F1&F&!E&!D1&!D&!C&!B&A1&!A|F1&F&!E&!D1&!D&!C&!B&A1&!A|F1&!F&!E&!D1&!D&!C&!B&A1&!A|!F1&!F&!E&!D1&!D&!C&!B&A1&!A|!F1&!F&!E&!D1&!D&!C&!B&A1&A|F1&!F&!E&!D1&!D&!C&!B&A1&A|F1&F&!E&!D1&!D&!C&!B&A1&A|!F1&F&!E&!D1&!D&!C&!B&A1&A|!F1&!F&E&!D1&!D&!C&!B&A1&A|!F1&!F&E&D1&!D&!C&!B&A1&A|!F1&F&!E&D1&!D&!C&!B&A1&A|F1&F&!E&D1&!D&!C&!B&A1&A|F1&!F&!E&D1&!D&!C&!B&A1&A|!F1&!F&!E&D1&!D&!C&!B&A1&A|!F1&!F&!E&D1&D&!C&!B&A1&A|!F1&!F&E&D1&D&!C&!B&A1&A|!F1&!F&E&!D1&D&!C&!B&A1&A|!F1&F&!E&!D1&D&!C&!B&A1&A|F1&F&!E&!D1&D&!C&!B&A1&A|F1&!F&!E&!D1&D&!C&!B&A1&A|!F1&!F&!E&!D1&D&!C&!B&A1&A|!F1&!F&!E&!D1&D&C&!B&A1&A|!F1&!F&E&!D1&D&C&!B&A1&A|!F1&!F&E&D1&D&C&!B&A1&A|!F1&!F&!E&D1&D&C&!B&A1&A|!F1&!F&!E&D1&!D&C&!B&A1&A|!F1&!F&E&D1&!D&C&!B&A1&A|!F1&!F&E&!D1&!D&C&!B&A1&A|!F1&!F&!E&!D1&!D&C&!B&A1&A|!F1&!F&!E&!D1&!D&C&B&A1&A|!F1&!F&E&!D1&!D&C&B&A1&A|!F1&!F&E&D1&!D&C&B&A1&A|!F1&!F&!E&D1&!D&C&B&A1&A|!F1&!F&!E&D1&D&C&B&A1&A|!F1&!F&E&D1&D&C&B&A1&A|!F1&!F&E&!D1&D&C&B&A1&A|!F1&!F&!E&!D1&D&C&B&A1&A|!F1&!F&!E&!D1&D&!C&B&A1&A|F1&!F&!E&!D1&D&!C&B&A1&A|F1&F&!E&!D1&D&!C&B&A1&A|!F1&F&!E&!D1&D&!C&B&A1&A|!F1&!F&E&!D1&D&!C&B&A1&A|!F1&!F&E&D1&D&!C&B&A1&A|!F1&!F&!E&D1&D&!C&B&A1&A|!F1&!F&!E&D1&!D&!C&B&A1&A|F1&!F&!E&D1&!D&!C&B&A1&A|F1&F&!E&D1&!D&!C&B&A1&A|!F1&F&!E&D1&!D&!C&B&A1&A|!F1&!F&E&D1&!D&!C&B&A1&A|!F1&!F&E&!D1&!D&!C&B&A1&A|!F1&F&!E&!D1&!D&!C&B&A1&A|F1&F&!E&!D1&!D&!C&B&A1&A|F1&!F&!E&!D1&!D&!C&B&A1&A|!F1&!F&!E&!D1&!D&!C&B&A1&A|!F1&!F&!E&!D1&!D&!C&B&!A1&A|F1&!F&!E&!D1&!D&!C&B&!A1&A|F1&F&!E&!D1&!D&!C&B&!A1&A|!F1&F&!E&!D1&!D&!C&B&!A1&A|!F1&!F&E&!D1&!D&!C&B&!A1&A|!F1&!F&E&D1&!D&!C&B&!A1&A|!F1&F&!E&D1&!D&!C&B&!A1&A|F1&F&!E&D1&!D&!C&B&!A1&A|F1&!F&!E&D1&!D&!C&B&!A1&A|!F1&!F&!E&D1&!D&!C&B&!A1&A|!F1&!F&!E&D1&D&!C&B&!A1&A|!F1&!F&E&D1&D&!C&B&!A1&A|!F1&!F&E&!D1&D&!C&B&!A1&A|!F1&F&!E&!D1&D&!C&B&!A1&A|F1&F&!E&!D1&D&!C&B&!A1&A|F1&!F&!E&!D1&D&!C&B&!A1&A|!F1&!F&!E&!D1&D&!C&B&!A1&A|!F1&!F&!E&!D1&D&C&B&!A1&A|!F1&!F&E&!D1&D&C&B&!A1&A|!F1&!F&E&D1&D&C&B&!A1&A|!F1&!F&!E&D1&D&C&B&!A1&A|!F1&!F&!E&D1&!D&C&B&!A1&A|!F1&!F&E&D1&!D&C&B&!A1&A|!F1&!F&E&!D1&!D&C&B&!A1&A|!F1&!F&!E&!D1&!D&C&B&!A1&A|!F1&!F&!E&!D1&!D&C&!B&!A1&A|F1&!F&!E&!D1&!D&C&!B&!A1&A|F1&F&!E&!D1&!D&C&!B&!A1&A|!F1&F&!E&!D1&!D&C&!B&!A1&A|!F1&!F&E&!D1&!D&C&!B&!A1&A|!F1&!F&E&D1&!D&C&!B&!A1&A|!F1&F&!E&D1&!D&C&!B&!A1&A|F1&F&!E&D1&!D&C&!B&!A1&A|F1&!F&!E&D1&!D&C&!B&!A1&A|!F1&!F&!E&D1&!D&C&!B&!A1&A|!F1&!F&!E&D1&D&C&!B&!A1&A|!F1&!F&E&D1&D&C&!B&!A1&A|!F1&!F&E&!D1&D&C&!B&!A1&A|!F1&F&!E&!D1&D&C&!B&!A1&A|F1&F&!E&!D1&D&C&!B&!A1&A|F1&!F&!E&!D1&D&C&!B&!A1&A|!F1&!F&!E&!D1&D&C&!B&!A1&A|!F1&!F&!E&!D1&D&!C&!B&!A1&A|F1&!F&!E&!D1&D&!C&!B&!A1&A|F1&F&!E&!D1&D&!C&!B&!A1&A|!F1&F&!E&!D1&D&!C&!B&!A1&A|!F1&!F&E&!D1&D&!C&!B&!A1&A|!F1&!F&E&D1&D&!C&!B&!A1&A|!F1&!F&!E&D1&D&!C&!B&!A1&A|!F1&!F&!E&D1&!D&!C&!B&!A1&A|F1&!F&!E&D1&!D&!C&!B&!A1&A|F1&F&!E&D1&!D&!C&!B&!A1&A|!F1&F&!E&D1&!D&!C&!B&!A1&A|!F1&!F&E&D1&!D&!C&!B&!A1&A|!F1&!F&E&!D1&!D&!C&!B&!A1&A|!F1&F&!E&!D1&!D&!C&!B&!A1&A|F1&F&!E&!D1&!D&!C&!B&!A1&A|F1&!F&!E&!D1&!D&!C&!B&!A1&A|!F1&!F&!E&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOOAI211212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAOAI221211 -l AAOOAOAI221211 -i F E D1 D C B1 B A1 A -o Y -f Y=!(F&E&!D1&!D&!C&!B1&!B&!A1&!A|F&E&D1&!D&!C&!B1&!B&!A1&!A|F&E&D1&D&!C&!B1&!B&!A1&!A|F&E&!D1&D&!C&!B1&!B&!A1&!A|F&!E&!D1&D&C&!B1&!B&!A1&!A|F&E&!D1&D&C&!B1&!B&!A1&!A|F&E&D1&D&C&!B1&!B&!A1&!A|F&!E&D1&D&C&!B1&!B&!A1&!A|F&!E&D1&!D&C&!B1&!B&!A1&!A|F&E&D1&!D&C&!B1&!B&!A1&!A|F&E&!D1&!D&C&!B1&!B&!A1&!A|F&E&!D1&!D&C&B1&!B&!A1&!A|F&E&D1&!D&C&B1&!B&!A1&!A|F&!E&D1&!D&C&B1&!B&!A1&!A|F&!E&D1&D&C&B1&!B&!A1&!A|F&E&D1&D&C&B1&!B&!A1&!A|F&E&!D1&D&C&B1&!B&!A1&!A|F&!E&!D1&D&C&B1&!B&!A1&!A|F&E&!D1&D&!C&B1&!B&!A1&!A|F&E&D1&D&!C&B1&!B&!A1&!A|F&E&D1&!D&!C&B1&!B&!A1&!A|F&E&!D1&!D&!C&B1&!B&!A1&!A|F&E&!D1&!D&!C&B1&B&!A1&!A|F&E&D1&!D&!C&B1&B&!A1&!A|F&!E&D1&!D&!C&B1&B&!A1&!A|F&!E&D1&D&!C&B1&B&!A1&!A|F&E&D1&D&!C&B1&B&!A1&!A|F&E&!D1&D&!C&B1&B&!A1&!A|F&!E&!D1&D&!C&B1&B&!A1&!A|F&!E&!D1&D&C&B1&B&!A1&!A|F&E&!D1&D&C&B1&B&!A1&!A|F&E&D1&D&C&B1&B&!A1&!A|F&!E&D1&D&C&B1&B&!A1&!A|F&!E&D1&!D&C&B1&B&!A1&!A|F&E&D1&!D&C&B1&B&!A1&!A|F&E&!D1&!D&C&B1&B&!A1&!A|F&E&!D1&!D&C&!B1&B&!A1&!A|F&E&D1&!D&C&!B1&B&!A1&!A|F&!E&D1&!D&C&!B1&B&!A1&!A|F&!E&D1&D&C&!B1&B&!A1&!A|F&E&D1&D&C&!B1&B&!A1&!A|F&E&!D1&D&C&!B1&B&!A1&!A|F&!E&!D1&D&C&!B1&B&!A1&!A|F&E&!D1&D&!C&!B1&B&!A1&!A|F&E&D1&D&!C&!B1&B&!A1&!A|F&E&D1&!D&!C&!B1&B&!A1&!A|F&E&!D1&!D&!C&!B1&B&!A1&!A|F&E&!D1&!D&!C&!B1&B&A1&!A|F&E&D1&!D&!C&!B1&B&A1&!A|F&E&D1&D&!C&!B1&B&A1&!A|F&E&!D1&D&!C&!B1&B&A1&!A|F&!E&!D1&D&C&!B1&B&A1&!A|F&E&!D1&D&C&!B1&B&A1&!A|F&E&D1&D&C&!B1&B&A1&!A|F&!E&D1&D&C&!B1&B&A1&!A|F&!E&D1&!D&C&!B1&B&A1&!A|F&E&D1&!D&C&!B1&B&A1&!A|F&E&!D1&!D&C&!B1&B&A1&!A|F&E&!D1&!D&C&B1&B&A1&!A|F&E&D1&!D&C&B1&B&A1&!A|F&!E&D1&!D&C&B1&B&A1&!A|F&!E&D1&D&C&B1&B&A1&!A|F&E&D1&D&C&B1&B&A1&!A|F&E&!D1&D&C&B1&B&A1&!A|F&!E&!D1&D&C&B1&B&A1&!A|F&!E&!D1&D&!C&B1&B&A1&!A|F&E&!D1&D&!C&B1&B&A1&!A|F&E&D1&D&!C&B1&B&A1&!A|F&!E&D1&D&!C&B1&B&A1&!A|F&!E&D1&!D&!C&B1&B&A1&!A|F&E&D1&!D&!C&B1&B&A1&!A|F&E&!D1&!D&!C&B1&B&A1&!A|F&E&!D1&!D&!C&B1&!B&A1&!A|F&E&D1&!D&!C&B1&!B&A1&!A|F&E&D1&D&!C&B1&!B&A1&!A|F&E&!D1&D&!C&B1&!B&A1&!A|F&!E&!D1&D&C&B1&!B&A1&!A|F&E&!D1&D&C&B1&!B&A1&!A|F&E&D1&D&C&B1&!B&A1&!A|F&!E&D1&D&C&B1&!B&A1&!A|F&!E&D1&!D&C&B1&!B&A1&!A|F&E&D1&!D&C&B1&!B&A1&!A|F&E&!D1&!D&C&B1&!B&A1&!A|F&E&!D1&!D&C&!B1&!B&A1&!A|F&E&D1&!D&C&!B1&!B&A1&!A|F&!E&D1&!D&C&!B1&!B&A1&!A|F&!E&D1&D&C&!B1&!B&A1&!A|F&E&D1&D&C&!B1&!B&A1&!A|F&E&!D1&D&C&!B1&!B&A1&!A|F&!E&!D1&D&C&!B1&!B&A1&!A|F&E&!D1&D&!C&!B1&!B&A1&!A|F&E&D1&D&!C&!B1&!B&A1&!A|F&E&D1&!D&!C&!B1&!B&A1&!A|F&E&!D1&!D&!C&!B1&!B&A1&!A|F&E&!D1&!D&!C&!B1&!B&A1&A|F&E&D1&!D&!C&!B1&!B&A1&A|F&!E&D1&!D&!C&!B1&!B&A1&A|F&!E&D1&D&!C&!B1&!B&A1&A|F&E&D1&D&!C&!B1&!B&A1&A|F&E&!D1&D&!C&!B1&!B&A1&A|F&!E&!D1&D&!C&!B1&!B&A1&A|F&!E&!D1&D&C&!B1&!B&A1&A|F&E&!D1&D&C&!B1&!B&A1&A|F&E&D1&D&C&!B1&!B&A1&A|F&!E&D1&D&C&!B1&!B&A1&A|F&!E&D1&!D&C&!B1&!B&A1&A|F&E&D1&!D&C&!B1&!B&A1&A|F&E&!D1&!D&C&!B1&!B&A1&A|F&E&!D1&!D&C&B1&!B&A1&A|F&E&D1&!D&C&B1&!B&A1&A|F&!E&D1&!D&C&B1&!B&A1&A|F&!E&D1&D&C&B1&!B&A1&A|F&E&D1&D&C&B1&!B&A1&A|F&E&!D1&D&C&B1&!B&A1&A|F&!E&!D1&D&C&B1&!B&A1&A|F&!E&!D1&D&!C&B1&!B&A1&A|F&E&!D1&D&!C&B1&!B&A1&A|F&E&D1&D&!C&B1&!B&A1&A|F&!E&D1&D&!C&B1&!B&A1&A|F&!E&D1&!D&!C&B1&!B&A1&A|F&E&D1&!D&!C&B1&!B&A1&A|F&E&!D1&!D&!C&B1&!B&A1&A|F&E&!D1&!D&!C&B1&B&A1&A|F&E&D1&!D&!C&B1&B&A1&A|F&!E&D1&!D&!C&B1&B&A1&A|F&!E&D1&D&!C&B1&B&A1&A|F&E&D1&D&!C&B1&B&A1&A|F&E&!D1&D&!C&B1&B&A1&A|F&!E&!D1&D&!C&B1&B&A1&A|F&!E&!D1&D&C&B1&B&A1&A|F&E&!D1&D&C&B1&B&A1&A|F&E&D1&D&C&B1&B&A1&A|F&!E&D1&D&C&B1&B&A1&A|F&!E&D1&!D&C&B1&B&A1&A|F&E&D1&!D&C&B1&B&A1&A|F&E&!D1&!D&C&B1&B&A1&A|F&E&!D1&!D&C&!B1&B&A1&A|F&E&D1&!D&C&!B1&B&A1&A|F&!E&D1&!D&C&!B1&B&A1&A|F&!E&D1&D&C&!B1&B&A1&A|F&E&D1&D&C&!B1&B&A1&A|F&E&!D1&D&C&!B1&B&A1&A|F&!E&!D1&D&C&!B1&B&A1&A|F&!E&!D1&D&!C&!B1&B&A1&A|F&E&!D1&D&!C&!B1&B&A1&A|F&E&D1&D&!C&!B1&B&A1&A|F&!E&D1&D&!C&!B1&B&A1&A|F&!E&D1&!D&!C&!B1&B&A1&A|F&E&D1&!D&!C&!B1&B&A1&A|F&E&!D1&!D&!C&!B1&B&A1&A|F&E&!D1&!D&!C&!B1&B&!A1&A|F&E&D1&!D&!C&!B1&B&!A1&A|F&E&D1&D&!C&!B1&B&!A1&A|F&E&!D1&D&!C&!B1&B&!A1&A|F&!E&!D1&D&C&!B1&B&!A1&A|F&E&!D1&D&C&!B1&B&!A1&A|F&E&D1&D&C&!B1&B&!A1&A|F&!E&D1&D&C&!B1&B&!A1&A|F&!E&D1&!D&C&!B1&B&!A1&A|F&E&D1&!D&C&!B1&B&!A1&A|F&E&!D1&!D&C&!B1&B&!A1&A|F&E&!D1&!D&C&B1&B&!A1&A|F&E&D1&!D&C&B1&B&!A1&A|F&!E&D1&!D&C&B1&B&!A1&A|F&!E&D1&D&C&B1&B&!A1&A|F&E&D1&D&C&B1&B&!A1&A|F&E&!D1&D&C&B1&B&!A1&A|F&!E&!D1&D&C&B1&B&!A1&A|F&!E&!D1&D&!C&B1&B&!A1&A|F&E&!D1&D&!C&B1&B&!A1&A|F&E&D1&D&!C&B1&B&!A1&A|F&!E&D1&D&!C&B1&B&!A1&A|F&!E&D1&!D&!C&B1&B&!A1&A|F&E&D1&!D&!C&B1&B&!A1&A|F&E&!D1&!D&!C&B1&B&!A1&A|F&E&!D1&!D&!C&B1&!B&!A1&A|F&E&D1&!D&!C&B1&!B&!A1&A|F&E&D1&D&!C&B1&!B&!A1&A|F&E&!D1&D&!C&B1&!B&!A1&A|F&!E&!D1&D&C&B1&!B&!A1&A|F&E&!D1&D&C&B1&!B&!A1&A|F&E&D1&D&C&B1&!B&!A1&A|F&!E&D1&D&C&B1&!B&!A1&A|F&!E&D1&!D&C&B1&!B&!A1&A|F&E&D1&!D&C&B1&!B&!A1&A|F&E&!D1&!D&C&B1&!B&!A1&A|F&E&!D1&!D&C&!B1&!B&!A1&A|F&E&D1&!D&C&!B1&!B&!A1&A|F&!E&D1&!D&C&!B1&!B&!A1&A|F&!E&D1&D&C&!B1&!B&!A1&A|F&E&D1&D&C&!B1&!B&!A1&A|F&E&!D1&D&C&!B1&!B&!A1&A|F&!E&!D1&D&C&!B1&!B&!A1&A|F&E&!D1&D&!C&!B1&!B&!A1&A|F&E&D1&D&!C&!B1&!B&!A1&A|F&E&D1&!D&!C&!B1&!B&!A1&A|F&E&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAOAI221211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOOAI21232 -l OAAOOOAI21232 -i E1 E D2 D1 D C1 C B A1 A -o Y -f Y=!(!E1&E&D2&!D1&!D&C1&C&!B&!A1&!A|E1&E&D2&!D1&!D&C1&C&!B&!A1&!A|E1&!E&D2&!D1&!D&C1&C&!B&!A1&!A|E1&!E&D2&D1&!D&C1&C&!B&!A1&!A|E1&E&D2&D1&!D&C1&C&!B&!A1&!A|!E1&E&D2&D1&!D&C1&C&!B&!A1&!A|!E1&E&!D2&D1&!D&C1&C&!B&!A1&!A|E1&E&!D2&D1&!D&C1&C&!B&!A1&!A|E1&!E&!D2&D1&!D&C1&C&!B&!A1&!A|E1&!E&!D2&D1&D&C1&C&!B&!A1&!A|E1&E&!D2&D1&D&C1&C&!B&!A1&!A|!E1&E&!D2&D1&D&C1&C&!B&!A1&!A|!E1&E&D2&D1&D&C1&C&!B&!A1&!A|E1&E&D2&D1&D&C1&C&!B&!A1&!A|E1&!E&D2&D1&D&C1&C&!B&!A1&!A|E1&!E&D2&!D1&D&C1&C&!B&!A1&!A|E1&E&D2&!D1&D&C1&C&!B&!A1&!A|!E1&E&D2&!D1&D&C1&C&!B&!A1&!A|!E1&E&!D2&!D1&D&C1&C&!B&!A1&!A|E1&E&!D2&!D1&D&C1&C&!B&!A1&!A|E1&!E&!D2&!D1&D&C1&C&!B&!A1&!A|E1&!E&!D2&!D1&D&C1&C&B&!A1&!A|E1&E&!D2&!D1&D&C1&C&B&!A1&!A|!E1&E&!D2&!D1&D&C1&C&B&!A1&!A|!E1&E&D2&!D1&D&C1&C&B&!A1&!A|E1&E&D2&!D1&D&C1&C&B&!A1&!A|E1&!E&D2&!D1&D&C1&C&B&!A1&!A|E1&!E&D2&D1&D&C1&C&B&!A1&!A|E1&E&D2&D1&D&C1&C&B&!A1&!A|!E1&E&D2&D1&D&C1&C&B&!A1&!A|!E1&E&!D2&D1&D&C1&C&B&!A1&!A|E1&E&!D2&D1&D&C1&C&B&!A1&!A|E1&!E&!D2&D1&D&C1&C&B&!A1&!A|E1&!E&!D2&D1&!D&C1&C&B&!A1&!A|E1&E&!D2&D1&!D&C1&C&B&!A1&!A|!E1&E&!D2&D1&!D&C1&C&B&!A1&!A|!E1&E&D2&D1&!D&C1&C&B&!A1&!A|E1&E&D2&D1&!D&C1&C&B&!A1&!A|E1&!E&D2&D1&!D&C1&C&B&!A1&!A|E1&!E&D2&!D1&!D&C1&C&B&!A1&!A|E1&E&D2&!D1&!D&C1&C&B&!A1&!A|!E1&E&D2&!D1&!D&C1&C&B&!A1&!A|!E1&E&D2&!D1&!D&!C1&!C&B&A1&!A|E1&E&D2&!D1&!D&!C1&!C&B&A1&!A|E1&!E&D2&!D1&!D&!C1&!C&B&A1&!A|E1&!E&D2&D1&!D&!C1&!C&B&A1&!A|E1&E&D2&D1&!D&!C1&!C&B&A1&!A|!E1&E&D2&D1&!D&!C1&!C&B&A1&!A|!E1&E&!D2&D1&!D&!C1&!C&B&A1&!A|E1&E&!D2&D1&!D&!C1&!C&B&A1&!A|E1&!E&!D2&D1&!D&!C1&!C&B&A1&!A|E1&!E&!D2&D1&D&!C1&!C&B&A1&!A|E1&E&!D2&D1&D&!C1&!C&B&A1&!A|!E1&E&!D2&D1&D&!C1&!C&B&A1&!A|!E1&E&D2&D1&D&!C1&!C&B&A1&!A|E1&E&D2&D1&D&!C1&!C&B&A1&!A|E1&!E&D2&D1&D&!C1&!C&B&A1&!A|E1&!E&D2&!D1&D&!C1&!C&B&A1&!A|E1&E&D2&!D1&D&!C1&!C&B&A1&!A|!E1&E&D2&!D1&D&!C1&!C&B&A1&!A|!E1&E&!D2&!D1&D&!C1&!C&B&A1&!A|E1&E&!D2&!D1&D&!C1&!C&B&A1&!A|E1&!E&!D2&!D1&D&!C1&!C&B&A1&!A|E1&!E&!D2&!D1&D&C1&!C&B&A1&!A|E1&E&!D2&!D1&D&C1&!C&B&A1&!A|!E1&E&!D2&!D1&D&C1&!C&B&A1&!A|!E1&E&D2&!D1&D&C1&!C&B&A1&!A|E1&E&D2&!D1&D&C1&!C&B&A1&!A|E1&!E&D2&!D1&D&C1&!C&B&A1&!A|E1&!E&D2&D1&D&C1&!C&B&A1&!A|E1&E&D2&D1&D&C1&!C&B&A1&!A|!E1&E&D2&D1&D&C1&!C&B&A1&!A|!E1&E&!D2&D1&D&C1&!C&B&A1&!A|E1&E&!D2&D1&D&C1&!C&B&A1&!A|E1&!E&!D2&D1&D&C1&!C&B&A1&!A|E1&!E&!D2&D1&!D&C1&!C&B&A1&!A|E1&E&!D2&D1&!D&C1&!C&B&A1&!A|!E1&E&!D2&D1&!D&C1&!C&B&A1&!A|!E1&E&D2&D1&!D&C1&!C&B&A1&!A|E1&E&D2&D1&!D&C1&!C&B&A1&!A|E1&!E&D2&D1&!D&C1&!C&B&A1&!A|E1&!E&D2&!D1&!D&C1&!C&B&A1&!A|E1&E&D2&!D1&!D&C1&!C&B&A1&!A|!E1&E&D2&!D1&!D&C1&!C&B&A1&!A|!E1&E&D2&!D1&!D&C1&C&B&A1&!A|E1&E&D2&!D1&!D&C1&C&B&A1&!A|E1&!E&D2&!D1&!D&C1&C&B&A1&!A|E1&!E&D2&D1&!D&C1&C&B&A1&!A|E1&E&D2&D1&!D&C1&C&B&A1&!A|!E1&E&D2&D1&!D&C1&C&B&A1&!A|!E1&E&!D2&D1&!D&C1&C&B&A1&!A|E1&E&!D2&D1&!D&C1&C&B&A1&!A|E1&!E&!D2&D1&!D&C1&C&B&A1&!A|E1&!E&!D2&D1&D&C1&C&B&A1&!A|E1&E&!D2&D1&D&C1&C&B&A1&!A|!E1&E&!D2&D1&D&C1&C&B&A1&!A|!E1&E&D2&D1&D&C1&C&B&A1&!A|E1&E&D2&D1&D&C1&C&B&A1&!A|E1&!E&D2&D1&D&C1&C&B&A1&!A|E1&!E&D2&!D1&D&C1&C&B&A1&!A|E1&E&D2&!D1&D&C1&C&B&A1&!A|!E1&E&D2&!D1&D&C1&C&B&A1&!A|!E1&E&!D2&!D1&D&C1&C&B&A1&!A|E1&E&!D2&!D1&D&C1&C&B&A1&!A|E1&!E&!D2&!D1&D&C1&C&B&A1&!A|E1&!E&!D2&!D1&D&!C1&C&B&A1&!A|E1&E&!D2&!D1&D&!C1&C&B&A1&!A|!E1&E&!D2&!D1&D&!C1&C&B&A1&!A|!E1&E&D2&!D1&D&!C1&C&B&A1&!A|E1&E&D2&!D1&D&!C1&C&B&A1&!A|E1&!E&D2&!D1&D&!C1&C&B&A1&!A|E1&!E&D2&D1&D&!C1&C&B&A1&!A|E1&E&D2&D1&D&!C1&C&B&A1&!A|!E1&E&D2&D1&D&!C1&C&B&A1&!A|!E1&E&!D2&D1&D&!C1&C&B&A1&!A|E1&E&!D2&D1&D&!C1&C&B&A1&!A|E1&!E&!D2&D1&D&!C1&C&B&A1&!A|E1&!E&!D2&D1&!D&!C1&C&B&A1&!A|E1&E&!D2&D1&!D&!C1&C&B&A1&!A|!E1&E&!D2&D1&!D&!C1&C&B&A1&!A|!E1&E&D2&D1&!D&!C1&C&B&A1&!A|E1&E&D2&D1&!D&!C1&C&B&A1&!A|E1&!E&D2&D1&!D&!C1&C&B&A1&!A|E1&!E&D2&!D1&!D&!C1&C&B&A1&!A|E1&E&D2&!D1&!D&!C1&C&B&A1&!A|!E1&E&D2&!D1&!D&!C1&C&B&A1&!A|E1&!E&!D2&!D1&D&C1&C&!B&A1&!A|E1&E&!D2&!D1&D&C1&C&!B&A1&!A|!E1&E&!D2&!D1&D&C1&C&!B&A1&!A|!E1&E&D2&!D1&D&C1&C&!B&A1&!A|E1&E&D2&!D1&D&C1&C&!B&A1&!A|E1&!E&D2&!D1&D&C1&C&!B&A1&!A|E1&!E&D2&D1&D&C1&C&!B&A1&!A|E1&E&D2&D1&D&C1&C&!B&A1&!A|!E1&E&D2&D1&D&C1&C&!B&A1&!A|!E1&E&!D2&D1&D&C1&C&!B&A1&!A|E1&E&!D2&D1&D&C1&C&!B&A1&!A|E1&!E&!D2&D1&D&C1&C&!B&A1&!A|E1&!E&!D2&D1&!D&C1&C&!B&A1&!A|E1&E&!D2&D1&!D&C1&C&!B&A1&!A|!E1&E&!D2&D1&!D&C1&C&!B&A1&!A|!E1&E&D2&D1&!D&C1&C&!B&A1&!A|E1&E&D2&D1&!D&C1&C&!B&A1&!A|E1&!E&D2&D1&!D&C1&C&!B&A1&!A|E1&!E&D2&!D1&!D&C1&C&!B&A1&!A|E1&E&D2&!D1&!D&C1&C&!B&A1&!A|!E1&E&D2&!D1&!D&C1&C&!B&A1&!A|!E1&E&D2&!D1&!D&C1&C&!B&A1&A|E1&E&D2&!D1&!D&C1&C&!B&A1&A|E1&!E&D2&!D1&!D&C1&C&!B&A1&A|E1&!E&D2&D1&!D&C1&C&!B&A1&A|E1&E&D2&D1&!D&C1&C&!B&A1&A|!E1&E&D2&D1&!D&C1&C&!B&A1&A|!E1&E&!D2&D1&!D&C1&C&!B&A1&A|E1&E&!D2&D1&!D&C1&C&!B&A1&A|E1&!E&!D2&D1&!D&C1&C&!B&A1&A|E1&!E&!D2&D1&D&C1&C&!B&A1&A|E1&E&!D2&D1&D&C1&C&!B&A1&A|!E1&E&!D2&D1&D&C1&C&!B&A1&A|!E1&E&D2&D1&D&C1&C&!B&A1&A|E1&E&D2&D1&D&C1&C&!B&A1&A|E1&!E&D2&D1&D&C1&C&!B&A1&A|E1&!E&D2&!D1&D&C1&C&!B&A1&A|E1&E&D2&!D1&D&C1&C&!B&A1&A|!E1&E&D2&!D1&D&C1&C&!B&A1&A|!E1&E&!D2&!D1&D&C1&C&!B&A1&A|E1&E&!D2&!D1&D&C1&C&!B&A1&A|E1&!E&!D2&!D1&D&C1&C&!B&A1&A|!E1&E&D2&!D1&!D&!C1&C&B&A1&A|E1&E&D2&!D1&!D&!C1&C&B&A1&A|E1&!E&D2&!D1&!D&!C1&C&B&A1&A|E1&!E&D2&D1&!D&!C1&C&B&A1&A|E1&E&D2&D1&!D&!C1&C&B&A1&A|!E1&E&D2&D1&!D&!C1&C&B&A1&A|!E1&E&!D2&D1&!D&!C1&C&B&A1&A|E1&E&!D2&D1&!D&!C1&C&B&A1&A|E1&!E&!D2&D1&!D&!C1&C&B&A1&A|E1&!E&!D2&D1&D&!C1&C&B&A1&A|E1&E&!D2&D1&D&!C1&C&B&A1&A|!E1&E&!D2&D1&D&!C1&C&B&A1&A|!E1&E&D2&D1&D&!C1&C&B&A1&A|E1&E&D2&D1&D&!C1&C&B&A1&A|E1&!E&D2&D1&D&!C1&C&B&A1&A|E1&!E&D2&!D1&D&!C1&C&B&A1&A|E1&E&D2&!D1&D&!C1&C&B&A1&A|!E1&E&D2&!D1&D&!C1&C&B&A1&A|!E1&E&!D2&!D1&D&!C1&C&B&A1&A|E1&E&!D2&!D1&D&!C1&C&B&A1&A|E1&!E&!D2&!D1&D&!C1&C&B&A1&A|E1&!E&!D2&!D1&D&C1&C&B&A1&A|E1&E&!D2&!D1&D&C1&C&B&A1&A|!E1&E&!D2&!D1&D&C1&C&B&A1&A|!E1&E&D2&!D1&D&C1&C&B&A1&A|E1&E&D2&!D1&D&C1&C&B&A1&A|E1&!E&D2&!D1&D&C1&C&B&A1&A|E1&!E&D2&D1&D&C1&C&B&A1&A|E1&E&D2&D1&D&C1&C&B&A1&A|!E1&E&D2&D1&D&C1&C&B&A1&A|!E1&E&!D2&D1&D&C1&C&B&A1&A|E1&E&!D2&D1&D&C1&C&B&A1&A|E1&!E&!D2&D1&D&C1&C&B&A1&A|E1&!E&!D2&D1&!D&C1&C&B&A1&A|E1&E&!D2&D1&!D&C1&C&B&A1&A|!E1&E&!D2&D1&!D&C1&C&B&A1&A|!E1&E&D2&D1&!D&C1&C&B&A1&A|E1&E&D2&D1&!D&C1&C&B&A1&A|E1&!E&D2&D1&!D&C1&C&B&A1&A|E1&!E&D2&!D1&!D&C1&C&B&A1&A|E1&E&D2&!D1&!D&C1&C&B&A1&A|!E1&E&D2&!D1&!D&C1&C&B&A1&A|!E1&E&D2&!D1&!D&C1&!C&B&A1&A|E1&E&D2&!D1&!D&C1&!C&B&A1&A|E1&!E&D2&!D1&!D&C1&!C&B&A1&A|E1&!E&D2&D1&!D&C1&!C&B&A1&A|E1&E&D2&D1&!D&C1&!C&B&A1&A|!E1&E&D2&D1&!D&C1&!C&B&A1&A|!E1&E&!D2&D1&!D&C1&!C&B&A1&A|E1&E&!D2&D1&!D&C1&!C&B&A1&A|E1&!E&!D2&D1&!D&C1&!C&B&A1&A|E1&!E&!D2&D1&D&C1&!C&B&A1&A|E1&E&!D2&D1&D&C1&!C&B&A1&A|!E1&E&!D2&D1&D&C1&!C&B&A1&A|!E1&E&D2&D1&D&C1&!C&B&A1&A|E1&E&D2&D1&D&C1&!C&B&A1&A|E1&!E&D2&D1&D&C1&!C&B&A1&A|E1&!E&D2&!D1&D&C1&!C&B&A1&A|E1&E&D2&!D1&D&C1&!C&B&A1&A|!E1&E&D2&!D1&D&C1&!C&B&A1&A|!E1&E&!D2&!D1&D&C1&!C&B&A1&A|E1&E&!D2&!D1&D&C1&!C&B&A1&A|E1&!E&!D2&!D1&D&C1&!C&B&A1&A|E1&!E&!D2&!D1&D&!C1&!C&B&A1&A|E1&E&!D2&!D1&D&!C1&!C&B&A1&A|!E1&E&!D2&!D1&D&!C1&!C&B&A1&A|!E1&E&D2&!D1&D&!C1&!C&B&A1&A|E1&E&D2&!D1&D&!C1&!C&B&A1&A|E1&!E&D2&!D1&D&!C1&!C&B&A1&A|E1&!E&D2&D1&D&!C1&!C&B&A1&A|E1&E&D2&D1&D&!C1&!C&B&A1&A|!E1&E&D2&D1&D&!C1&!C&B&A1&A|!E1&E&!D2&D1&D&!C1&!C&B&A1&A|E1&E&!D2&D1&D&!C1&!C&B&A1&A|E1&!E&!D2&D1&D&!C1&!C&B&A1&A|E1&!E&!D2&D1&!D&!C1&!C&B&A1&A|E1&E&!D2&D1&!D&!C1&!C&B&A1&A|!E1&E&!D2&D1&!D&!C1&!C&B&A1&A|!E1&E&D2&D1&!D&!C1&!C&B&A1&A|E1&E&D2&D1&!D&!C1&!C&B&A1&A|E1&!E&D2&D1&!D&!C1&!C&B&A1&A|E1&!E&D2&!D1&!D&!C1&!C&B&A1&A|E1&E&D2&!D1&!D&!C1&!C&B&A1&A|!E1&E&D2&!D1&!D&!C1&!C&B&A1&A|!E1&E&D2&!D1&!D&!C1&!C&B&!A1&A|E1&E&D2&!D1&!D&!C1&!C&B&!A1&A|E1&!E&D2&!D1&!D&!C1&!C&B&!A1&A|E1&!E&D2&D1&!D&!C1&!C&B&!A1&A|E1&E&D2&D1&!D&!C1&!C&B&!A1&A|!E1&E&D2&D1&!D&!C1&!C&B&!A1&A|!E1&E&!D2&D1&!D&!C1&!C&B&!A1&A|E1&E&!D2&D1&!D&!C1&!C&B&!A1&A|E1&!E&!D2&D1&!D&!C1&!C&B&!A1&A|E1&!E&!D2&D1&D&!C1&!C&B&!A1&A|E1&E&!D2&D1&D&!C1&!C&B&!A1&A|!E1&E&!D2&D1&D&!C1&!C&B&!A1&A|!E1&E&D2&D1&D&!C1&!C&B&!A1&A|E1&E&D2&D1&D&!C1&!C&B&!A1&A|E1&!E&D2&D1&D&!C1&!C&B&!A1&A|E1&!E&D2&!D1&D&!C1&!C&B&!A1&A|E1&E&D2&!D1&D&!C1&!C&B&!A1&A|!E1&E&D2&!D1&D&!C1&!C&B&!A1&A|!E1&E&!D2&!D1&D&!C1&!C&B&!A1&A|E1&E&!D2&!D1&D&!C1&!C&B&!A1&A|E1&!E&!D2&!D1&D&!C1&!C&B&!A1&A|E1&!E&!D2&!D1&D&C1&!C&B&!A1&A|E1&E&!D2&!D1&D&C1&!C&B&!A1&A|!E1&E&!D2&!D1&D&C1&!C&B&!A1&A|!E1&E&D2&!D1&D&C1&!C&B&!A1&A|E1&E&D2&!D1&D&C1&!C&B&!A1&A|E1&!E&D2&!D1&D&C1&!C&B&!A1&A|E1&!E&D2&D1&D&C1&!C&B&!A1&A|E1&E&D2&D1&D&C1&!C&B&!A1&A|!E1&E&D2&D1&D&C1&!C&B&!A1&A|!E1&E&!D2&D1&D&C1&!C&B&!A1&A|E1&E&!D2&D1&D&C1&!C&B&!A1&A|E1&!E&!D2&D1&D&C1&!C&B&!A1&A|E1&!E&!D2&D1&!D&C1&!C&B&!A1&A|E1&E&!D2&D1&!D&C1&!C&B&!A1&A|!E1&E&!D2&D1&!D&C1&!C&B&!A1&A|!E1&E&D2&D1&!D&C1&!C&B&!A1&A|E1&E&D2&D1&!D&C1&!C&B&!A1&A|E1&!E&D2&D1&!D&C1&!C&B&!A1&A|E1&!E&D2&!D1&!D&C1&!C&B&!A1&A|E1&E&D2&!D1&!D&C1&!C&B&!A1&A|!E1&E&D2&!D1&!D&C1&!C&B&!A1&A|!E1&E&D2&!D1&!D&C1&C&B&!A1&A|E1&E&D2&!D1&!D&C1&C&B&!A1&A|E1&!E&D2&!D1&!D&C1&C&B&!A1&A|E1&!E&D2&D1&!D&C1&C&B&!A1&A|E1&E&D2&D1&!D&C1&C&B&!A1&A|!E1&E&D2&D1&!D&C1&C&B&!A1&A|!E1&E&!D2&D1&!D&C1&C&B&!A1&A|E1&E&!D2&D1&!D&C1&C&B&!A1&A|E1&!E&!D2&D1&!D&C1&C&B&!A1&A|E1&!E&!D2&D1&D&C1&C&B&!A1&A|E1&E&!D2&D1&D&C1&C&B&!A1&A|!E1&E&!D2&D1&D&C1&C&B&!A1&A|!E1&E&D2&D1&D&C1&C&B&!A1&A|E1&E&D2&D1&D&C1&C&B&!A1&A|E1&!E&D2&D1&D&C1&C&B&!A1&A|E1&!E&D2&!D1&D&C1&C&B&!A1&A|E1&E&D2&!D1&D&C1&C&B&!A1&A|!E1&E&D2&!D1&D&C1&C&B&!A1&A|!E1&E&!D2&!D1&D&C1&C&B&!A1&A|E1&E&!D2&!D1&D&C1&C&B&!A1&A|E1&!E&!D2&!D1&D&C1&C&B&!A1&A|E1&!E&!D2&!D1&D&!C1&C&B&!A1&A|E1&E&!D2&!D1&D&!C1&C&B&!A1&A|!E1&E&!D2&!D1&D&!C1&C&B&!A1&A|!E1&E&D2&!D1&D&!C1&C&B&!A1&A|E1&E&D2&!D1&D&!C1&C&B&!A1&A|E1&!E&D2&!D1&D&!C1&C&B&!A1&A|E1&!E&D2&D1&D&!C1&C&B&!A1&A|E1&E&D2&D1&D&!C1&C&B&!A1&A|!E1&E&D2&D1&D&!C1&C&B&!A1&A|!E1&E&!D2&D1&D&!C1&C&B&!A1&A|E1&E&!D2&D1&D&!C1&C&B&!A1&A|E1&!E&!D2&D1&D&!C1&C&B&!A1&A|E1&!E&!D2&D1&!D&!C1&C&B&!A1&A|E1&E&!D2&D1&!D&!C1&C&B&!A1&A|!E1&E&!D2&D1&!D&!C1&C&B&!A1&A|!E1&E&D2&D1&!D&!C1&C&B&!A1&A|E1&E&D2&D1&!D&!C1&C&B&!A1&A|E1&!E&D2&D1&!D&!C1&C&B&!A1&A|E1&!E&D2&!D1&!D&!C1&C&B&!A1&A|E1&E&D2&!D1&!D&!C1&C&B&!A1&A|!E1&E&D2&!D1&!D&!C1&C&B&!A1&A|E1&!E&!D2&!D1&D&C1&C&!B&!A1&A|E1&E&!D2&!D1&D&C1&C&!B&!A1&A|!E1&E&!D2&!D1&D&C1&C&!B&!A1&A|!E1&E&D2&!D1&D&C1&C&!B&!A1&A|E1&E&D2&!D1&D&C1&C&!B&!A1&A|E1&!E&D2&!D1&D&C1&C&!B&!A1&A|E1&!E&D2&D1&D&C1&C&!B&!A1&A|E1&E&D2&D1&D&C1&C&!B&!A1&A|!E1&E&D2&D1&D&C1&C&!B&!A1&A|!E1&E&!D2&D1&D&C1&C&!B&!A1&A|E1&E&!D2&D1&D&C1&C&!B&!A1&A|E1&!E&!D2&D1&D&C1&C&!B&!A1&A|E1&!E&!D2&D1&!D&C1&C&!B&!A1&A|E1&E&!D2&D1&!D&C1&C&!B&!A1&A|!E1&E&!D2&D1&!D&C1&C&!B&!A1&A|!E1&E&D2&D1&!D&C1&C&!B&!A1&A|E1&E&D2&D1&!D&C1&C&!B&!A1&A|E1&!E&D2&D1&!D&C1&C&!B&!A1&A|E1&!E&D2&!D1&!D&C1&C&!B&!A1&A|E1&E&D2&!D1&!D&C1&C&!B&!A1&A|!E1&E&D2&!D1&!D&C1&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOOAI21232.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOAAOI22212 -l AAAOAAOI22212 -i E1 E D C1 C B1 B A1 A -o Y -f Y=!(E1&E&!D&!C1&!C&!B1&!B&!A1&!A|E1&E&D&!C1&!C&!B1&!B&!A1&!A|E1&E&D&C1&!C&!B1&!B&!A1&!A|E1&E&!D&C1&!C&!B1&!B&!A1&!A|E1&E&!D&C1&C&!B1&!B&!A1&!A|!E1&E&D&C1&C&!B1&!B&!A1&!A|E1&E&D&C1&C&!B1&!B&!A1&!A|E1&!E&D&C1&C&!B1&!B&!A1&!A|!E1&!E&D&C1&C&!B1&!B&!A1&!A|E1&E&D&!C1&C&!B1&!B&!A1&!A|E1&E&!D&!C1&C&!B1&!B&!A1&!A|E1&E&!D&!C1&C&B1&!B&!A1&!A|E1&E&D&!C1&C&B1&!B&!A1&!A|!E1&!E&D&C1&C&B1&!B&!A1&!A|E1&!E&D&C1&C&B1&!B&!A1&!A|E1&E&D&C1&C&B1&!B&!A1&!A|!E1&E&D&C1&C&B1&!B&!A1&!A|E1&E&!D&C1&C&B1&!B&!A1&!A|E1&E&!D&C1&!C&B1&!B&!A1&!A|E1&E&D&C1&!C&B1&!B&!A1&!A|E1&E&D&!C1&!C&B1&!B&!A1&!A|E1&E&!D&!C1&!C&B1&!B&!A1&!A|E1&E&!D&!C1&!C&B1&B&!A1&!A|!E1&E&D&!C1&!C&B1&B&!A1&!A|E1&E&D&!C1&!C&B1&B&!A1&!A|E1&!E&D&!C1&!C&B1&B&!A1&!A|!E1&!E&D&!C1&!C&B1&B&!A1&!A|!E1&!E&D&C1&!C&B1&B&!A1&!A|E1&!E&D&C1&!C&B1&B&!A1&!A|E1&E&D&C1&!C&B1&B&!A1&!A|!E1&E&D&C1&!C&B1&B&!A1&!A|E1&E&!D&C1&!C&B1&B&!A1&!A|E1&E&!D&C1&C&B1&B&!A1&!A|!E1&E&D&C1&C&B1&B&!A1&!A|E1&E&D&C1&C&B1&B&!A1&!A|E1&!E&D&C1&C&B1&B&!A1&!A|!E1&!E&D&C1&C&B1&B&!A1&!A|!E1&!E&D&!C1&C&B1&B&!A1&!A|E1&!E&D&!C1&C&B1&B&!A1&!A|E1&E&D&!C1&C&B1&B&!A1&!A|!E1&E&D&!C1&C&B1&B&!A1&!A|E1&E&!D&!C1&C&B1&B&!A1&!A|E1&E&!D&!C1&C&!B1&B&!A1&!A|E1&E&D&!C1&C&!B1&B&!A1&!A|!E1&!E&D&C1&C&!B1&B&!A1&!A|E1&!E&D&C1&C&!B1&B&!A1&!A|E1&E&D&C1&C&!B1&B&!A1&!A|!E1&E&D&C1&C&!B1&B&!A1&!A|E1&E&!D&C1&C&!B1&B&!A1&!A|E1&E&!D&C1&!C&!B1&B&!A1&!A|E1&E&D&C1&!C&!B1&B&!A1&!A|E1&E&D&!C1&!C&!B1&B&!A1&!A|E1&E&!D&!C1&!C&!B1&B&!A1&!A|E1&E&!D&!C1&!C&!B1&B&A1&!A|E1&E&D&!C1&!C&!B1&B&A1&!A|E1&E&D&C1&!C&!B1&B&A1&!A|E1&E&!D&C1&!C&!B1&B&A1&!A|E1&E&!D&C1&C&!B1&B&A1&!A|!E1&E&D&C1&C&!B1&B&A1&!A|E1&E&D&C1&C&!B1&B&A1&!A|E1&!E&D&C1&C&!B1&B&A1&!A|!E1&!E&D&C1&C&!B1&B&A1&!A|E1&E&D&!C1&C&!B1&B&A1&!A|E1&E&!D&!C1&C&!B1&B&A1&!A|E1&E&!D&!C1&C&B1&B&A1&!A|!E1&E&D&!C1&C&B1&B&A1&!A|E1&E&D&!C1&C&B1&B&A1&!A|E1&!E&D&!C1&C&B1&B&A1&!A|!E1&!E&D&!C1&C&B1&B&A1&!A|!E1&!E&D&C1&C&B1&B&A1&!A|E1&!E&D&C1&C&B1&B&A1&!A|E1&E&D&C1&C&B1&B&A1&!A|!E1&E&D&C1&C&B1&B&A1&!A|E1&E&!D&C1&C&B1&B&A1&!A|E1&E&!D&C1&!C&B1&B&A1&!A|!E1&E&D&C1&!C&B1&B&A1&!A|E1&E&D&C1&!C&B1&B&A1&!A|E1&!E&D&C1&!C&B1&B&A1&!A|!E1&!E&D&C1&!C&B1&B&A1&!A|!E1&!E&D&!C1&!C&B1&B&A1&!A|E1&!E&D&!C1&!C&B1&B&A1&!A|E1&E&D&!C1&!C&B1&B&A1&!A|!E1&E&D&!C1&!C&B1&B&A1&!A|E1&E&!D&!C1&!C&B1&B&A1&!A|E1&E&!D&!C1&!C&B1&!B&A1&!A|E1&E&D&!C1&!C&B1&!B&A1&!A|E1&E&D&C1&!C&B1&!B&A1&!A|E1&E&!D&C1&!C&B1&!B&A1&!A|E1&E&!D&C1&C&B1&!B&A1&!A|!E1&E&D&C1&C&B1&!B&A1&!A|E1&E&D&C1&C&B1&!B&A1&!A|E1&!E&D&C1&C&B1&!B&A1&!A|!E1&!E&D&C1&C&B1&!B&A1&!A|E1&E&D&!C1&C&B1&!B&A1&!A|E1&E&!D&!C1&C&B1&!B&A1&!A|E1&E&!D&!C1&C&!B1&!B&A1&!A|E1&E&D&!C1&C&!B1&!B&A1&!A|!E1&!E&D&C1&C&!B1&!B&A1&!A|E1&!E&D&C1&C&!B1&!B&A1&!A|E1&E&D&C1&C&!B1&!B&A1&!A|!E1&E&D&C1&C&!B1&!B&A1&!A|E1&E&!D&C1&C&!B1&!B&A1&!A|E1&E&!D&C1&!C&!B1&!B&A1&!A|E1&E&D&C1&!C&!B1&!B&A1&!A|E1&E&D&!C1&!C&!B1&!B&A1&!A|E1&E&!D&!C1&!C&!B1&!B&A1&!A|E1&E&!D&!C1&!C&!B1&!B&A1&A|!E1&E&D&!C1&!C&!B1&!B&A1&A|E1&E&D&!C1&!C&!B1&!B&A1&A|E1&!E&D&!C1&!C&!B1&!B&A1&A|!E1&!E&D&!C1&!C&!B1&!B&A1&A|!E1&!E&D&C1&!C&!B1&!B&A1&A|E1&!E&D&C1&!C&!B1&!B&A1&A|E1&E&D&C1&!C&!B1&!B&A1&A|!E1&E&D&C1&!C&!B1&!B&A1&A|E1&E&!D&C1&!C&!B1&!B&A1&A|E1&E&!D&C1&C&!B1&!B&A1&A|!E1&E&D&C1&C&!B1&!B&A1&A|E1&E&D&C1&C&!B1&!B&A1&A|E1&!E&D&C1&C&!B1&!B&A1&A|!E1&!E&D&C1&C&!B1&!B&A1&A|!E1&!E&D&!C1&C&!B1&!B&A1&A|E1&!E&D&!C1&C&!B1&!B&A1&A|E1&E&D&!C1&C&!B1&!B&A1&A|!E1&E&D&!C1&C&!B1&!B&A1&A|E1&E&!D&!C1&C&!B1&!B&A1&A|E1&E&!D&!C1&C&B1&!B&A1&A|!E1&E&D&!C1&C&B1&!B&A1&A|E1&E&D&!C1&C&B1&!B&A1&A|E1&!E&D&!C1&C&B1&!B&A1&A|!E1&!E&D&!C1&C&B1&!B&A1&A|!E1&!E&D&C1&C&B1&!B&A1&A|E1&!E&D&C1&C&B1&!B&A1&A|E1&E&D&C1&C&B1&!B&A1&A|!E1&E&D&C1&C&B1&!B&A1&A|E1&E&!D&C1&C&B1&!B&A1&A|E1&E&!D&C1&!C&B1&!B&A1&A|!E1&E&D&C1&!C&B1&!B&A1&A|E1&E&D&C1&!C&B1&!B&A1&A|E1&!E&D&C1&!C&B1&!B&A1&A|!E1&!E&D&C1&!C&B1&!B&A1&A|!E1&!E&D&!C1&!C&B1&!B&A1&A|E1&!E&D&!C1&!C&B1&!B&A1&A|E1&E&D&!C1&!C&B1&!B&A1&A|!E1&E&D&!C1&!C&B1&!B&A1&A|E1&E&!D&!C1&!C&B1&!B&A1&A|E1&E&!D&!C1&!C&B1&B&A1&A|!E1&E&D&!C1&!C&B1&B&A1&A|E1&E&D&!C1&!C&B1&B&A1&A|E1&!E&D&!C1&!C&B1&B&A1&A|!E1&!E&D&!C1&!C&B1&B&A1&A|!E1&!E&D&C1&!C&B1&B&A1&A|E1&!E&D&C1&!C&B1&B&A1&A|E1&E&D&C1&!C&B1&B&A1&A|!E1&E&D&C1&!C&B1&B&A1&A|E1&E&!D&C1&!C&B1&B&A1&A|E1&E&!D&C1&C&B1&B&A1&A|!E1&E&D&C1&C&B1&B&A1&A|E1&E&D&C1&C&B1&B&A1&A|E1&!E&D&C1&C&B1&B&A1&A|!E1&!E&D&C1&C&B1&B&A1&A|!E1&!E&D&!C1&C&B1&B&A1&A|E1&!E&D&!C1&C&B1&B&A1&A|E1&E&D&!C1&C&B1&B&A1&A|!E1&E&D&!C1&C&B1&B&A1&A|E1&E&!D&!C1&C&B1&B&A1&A|E1&E&!D&!C1&C&!B1&B&A1&A|!E1&E&D&!C1&C&!B1&B&A1&A|E1&E&D&!C1&C&!B1&B&A1&A|E1&!E&D&!C1&C&!B1&B&A1&A|!E1&!E&D&!C1&C&!B1&B&A1&A|!E1&!E&D&C1&C&!B1&B&A1&A|E1&!E&D&C1&C&!B1&B&A1&A|E1&E&D&C1&C&!B1&B&A1&A|!E1&E&D&C1&C&!B1&B&A1&A|E1&E&!D&C1&C&!B1&B&A1&A|E1&E&!D&C1&!C&!B1&B&A1&A|!E1&E&D&C1&!C&!B1&B&A1&A|E1&E&D&C1&!C&!B1&B&A1&A|E1&!E&D&C1&!C&!B1&B&A1&A|!E1&!E&D&C1&!C&!B1&B&A1&A|!E1&!E&D&!C1&!C&!B1&B&A1&A|E1&!E&D&!C1&!C&!B1&B&A1&A|E1&E&D&!C1&!C&!B1&B&A1&A|!E1&E&D&!C1&!C&!B1&B&A1&A|E1&E&!D&!C1&!C&!B1&B&A1&A|E1&E&!D&!C1&!C&!B1&B&!A1&A|E1&E&D&!C1&!C&!B1&B&!A1&A|E1&E&D&C1&!C&!B1&B&!A1&A|E1&E&!D&C1&!C&!B1&B&!A1&A|E1&E&!D&C1&C&!B1&B&!A1&A|!E1&E&D&C1&C&!B1&B&!A1&A|E1&E&D&C1&C&!B1&B&!A1&A|E1&!E&D&C1&C&!B1&B&!A1&A|!E1&!E&D&C1&C&!B1&B&!A1&A|E1&E&D&!C1&C&!B1&B&!A1&A|E1&E&!D&!C1&C&!B1&B&!A1&A|E1&E&!D&!C1&C&B1&B&!A1&A|!E1&E&D&!C1&C&B1&B&!A1&A|E1&E&D&!C1&C&B1&B&!A1&A|E1&!E&D&!C1&C&B1&B&!A1&A|!E1&!E&D&!C1&C&B1&B&!A1&A|!E1&!E&D&C1&C&B1&B&!A1&A|E1&!E&D&C1&C&B1&B&!A1&A|E1&E&D&C1&C&B1&B&!A1&A|!E1&E&D&C1&C&B1&B&!A1&A|E1&E&!D&C1&C&B1&B&!A1&A|E1&E&!D&C1&!C&B1&B&!A1&A|!E1&E&D&C1&!C&B1&B&!A1&A|E1&E&D&C1&!C&B1&B&!A1&A|E1&!E&D&C1&!C&B1&B&!A1&A|!E1&!E&D&C1&!C&B1&B&!A1&A|!E1&!E&D&!C1&!C&B1&B&!A1&A|E1&!E&D&!C1&!C&B1&B&!A1&A|E1&E&D&!C1&!C&B1&B&!A1&A|!E1&E&D&!C1&!C&B1&B&!A1&A|E1&E&!D&!C1&!C&B1&B&!A1&A|E1&E&!D&!C1&!C&B1&!B&!A1&A|E1&E&D&!C1&!C&B1&!B&!A1&A|E1&E&D&C1&!C&B1&!B&!A1&A|E1&E&!D&C1&!C&B1&!B&!A1&A|E1&E&!D&C1&C&B1&!B&!A1&A|!E1&E&D&C1&C&B1&!B&!A1&A|E1&E&D&C1&C&B1&!B&!A1&A|E1&!E&D&C1&C&B1&!B&!A1&A|!E1&!E&D&C1&C&B1&!B&!A1&A|E1&E&D&!C1&C&B1&!B&!A1&A|E1&E&!D&!C1&C&B1&!B&!A1&A|E1&E&!D&!C1&C&!B1&!B&!A1&A|E1&E&D&!C1&C&!B1&!B&!A1&A|!E1&!E&D&C1&C&!B1&!B&!A1&A|E1&!E&D&C1&C&!B1&!B&!A1&A|E1&E&D&C1&C&!B1&!B&!A1&A|!E1&E&D&C1&C&!B1&!B&!A1&A|E1&E&!D&C1&C&!B1&!B&!A1&A|E1&E&!D&C1&!C&!B1&!B&!A1&A|E1&E&D&C1&!C&!B1&!B&!A1&A|E1&E&D&!C1&!C&!B1&!B&!A1&A|E1&E&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOAAOI22212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOOAAOI22222 -l OOAAOOAAOI22222 -i E1 E D1 D C1 C B1 B A1 A -o Y -f Y=(!E1&!E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&D1&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D1&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&E&D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D1&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&!D1&D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D1&D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D1&D&C1&!C&!B1&!B&!A1&!A|!E1&E&D1&D&C1&!C&!B1&!B&!A1&!A|E1&!E&D1&D&C1&!C&!B1&!B&!A1&!A|!E1&!E&D1&D&C1&!C&!B1&!B&!A1&!A|!E1&!E&D1&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&E&D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D1&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&!D1&!D&C1&C&!B1&!B&!A1&!A|!E1&E&!D1&!D&C1&C&!B1&!B&!A1&!A|!E1&!E&!D1&D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D1&D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D1&D&!C1&C&!B1&!B&!A1&!A|!E1&E&D1&D&!C1&C&!B1&!B&!A1&!A|E1&!E&D1&D&!C1&C&!B1&!B&!A1&!A|!E1&!E&D1&D&!C1&C&!B1&!B&!A1&!A|!E1&!E&D1&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&E&D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D1&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&!C1&C&B1&!B&!A1&!A|E1&!E&!D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&!D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&D1&!D&!C1&C&B1&!B&!A1&!A|E1&!E&D1&!D&!C1&C&B1&!B&!A1&!A|!E1&!E&D1&!D&!C1&C&B1&!B&!A1&!A|!E1&!E&D1&D&!C1&C&B1&!B&!A1&!A|E1&!E&D1&D&!C1&C&B1&!B&!A1&!A|!E1&E&D1&D&!C1&C&B1&!B&!A1&!A|!E1&E&!D1&D&!C1&C&B1&!B&!A1&!A|E1&!E&!D1&D&!C1&C&B1&!B&!A1&!A|!E1&!E&!D1&D&!C1&C&B1&!B&!A1&!A|!E1&E&!D1&!D&C1&C&B1&!B&!A1&!A|E1&!E&!D1&!D&C1&C&B1&!B&!A1&!A|!E1&!E&!D1&!D&C1&C&B1&!B&!A1&!A|!E1&!E&!D1&!D&C1&!C&B1&!B&!A1&!A|E1&!E&!D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&!D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&D1&!D&C1&!C&B1&!B&!A1&!A|E1&!E&D1&!D&C1&!C&B1&!B&!A1&!A|!E1&!E&D1&!D&C1&!C&B1&!B&!A1&!A|!E1&!E&D1&D&C1&!C&B1&!B&!A1&!A|E1&!E&D1&D&C1&!C&B1&!B&!A1&!A|!E1&E&D1&D&C1&!C&B1&!B&!A1&!A|!E1&E&!D1&D&C1&!C&B1&!B&!A1&!A|E1&!E&!D1&D&C1&!C&B1&!B&!A1&!A|!E1&!E&!D1&D&C1&!C&B1&!B&!A1&!A|!E1&!E&!D1&D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D1&D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D1&D&!C1&!C&B1&!B&!A1&!A|!E1&E&D1&D&!C1&!C&B1&!B&!A1&!A|E1&!E&D1&D&!C1&!C&B1&!B&!A1&!A|!E1&!E&D1&D&!C1&!C&B1&!B&!A1&!A|!E1&!E&D1&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&E&D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D1&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&B1&B&!A1&!A|E1&!E&!D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&!D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&D1&!D&!C1&!C&B1&B&!A1&!A|E1&!E&D1&!D&!C1&!C&B1&B&!A1&!A|!E1&!E&D1&!D&!C1&!C&B1&B&!A1&!A|!E1&!E&D1&D&!C1&!C&B1&B&!A1&!A|E1&!E&D1&D&!C1&!C&B1&B&!A1&!A|!E1&E&D1&D&!C1&!C&B1&B&!A1&!A|!E1&E&!D1&D&!C1&!C&B1&B&!A1&!A|E1&!E&!D1&D&!C1&!C&B1&B&!A1&!A|!E1&!E&!D1&D&!C1&!C&B1&B&!A1&!A|!E1&!E&!D1&D&C1&!C&B1&B&!A1&!A|E1&!E&!D1&D&C1&!C&B1&B&!A1&!A|!E1&E&!D1&D&C1&!C&B1&B&!A1&!A|!E1&E&D1&D&C1&!C&B1&B&!A1&!A|E1&!E&D1&D&C1&!C&B1&B&!A1&!A|!E1&!E&D1&D&C1&!C&B1&B&!A1&!A|!E1&!E&D1&!D&C1&!C&B1&B&!A1&!A|E1&!E&D1&!D&C1&!C&B1&B&!A1&!A|!E1&E&D1&!D&C1&!C&B1&B&!A1&!A|!E1&E&!D1&!D&C1&!C&B1&B&!A1&!A|E1&!E&!D1&!D&C1&!C&B1&B&!A1&!A|!E1&!E&!D1&!D&C1&!C&B1&B&!A1&!A|!E1&!E&!D1&!D&C1&C&B1&B&!A1&!A|E1&!E&!D1&!D&C1&C&B1&B&!A1&!A|!E1&E&!D1&!D&C1&C&B1&B&!A1&!A|!E1&!E&!D1&D&!C1&C&B1&B&!A1&!A|E1&!E&!D1&D&!C1&C&B1&B&!A1&!A|!E1&E&!D1&D&!C1&C&B1&B&!A1&!A|!E1&E&D1&D&!C1&C&B1&B&!A1&!A|E1&!E&D1&D&!C1&C&B1&B&!A1&!A|!E1&!E&D1&D&!C1&C&B1&B&!A1&!A|!E1&!E&D1&!D&!C1&C&B1&B&!A1&!A|E1&!E&D1&!D&!C1&C&B1&B&!A1&!A|!E1&E&D1&!D&!C1&C&B1&B&!A1&!A|!E1&E&!D1&!D&!C1&C&B1&B&!A1&!A|E1&!E&!D1&!D&!C1&C&B1&B&!A1&!A|!E1&!E&!D1&!D&!C1&C&B1&B&!A1&!A|!E1&!E&!D1&!D&!C1&C&!B1&B&!A1&!A|E1&!E&!D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&!D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&D1&!D&!C1&C&!B1&B&!A1&!A|E1&!E&D1&!D&!C1&C&!B1&B&!A1&!A|!E1&!E&D1&!D&!C1&C&!B1&B&!A1&!A|!E1&!E&D1&D&!C1&C&!B1&B&!A1&!A|E1&!E&D1&D&!C1&C&!B1&B&!A1&!A|!E1&E&D1&D&!C1&C&!B1&B&!A1&!A|!E1&E&!D1&D&!C1&C&!B1&B&!A1&!A|E1&!E&!D1&D&!C1&C&!B1&B&!A1&!A|!E1&!E&!D1&D&!C1&C&!B1&B&!A1&!A|!E1&E&!D1&!D&C1&C&!B1&B&!A1&!A|E1&!E&!D1&!D&C1&C&!B1&B&!A1&!A|!E1&!E&!D1&!D&C1&C&!B1&B&!A1&!A|!E1&!E&!D1&!D&C1&!C&!B1&B&!A1&!A|E1&!E&!D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&!D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&D1&!D&C1&!C&!B1&B&!A1&!A|E1&!E&D1&!D&C1&!C&!B1&B&!A1&!A|!E1&!E&D1&!D&C1&!C&!B1&B&!A1&!A|!E1&!E&D1&D&C1&!C&!B1&B&!A1&!A|E1&!E&D1&D&C1&!C&!B1&B&!A1&!A|!E1&E&D1&D&C1&!C&!B1&B&!A1&!A|!E1&E&!D1&D&C1&!C&!B1&B&!A1&!A|E1&!E&!D1&D&C1&!C&!B1&B&!A1&!A|!E1&!E&!D1&D&C1&!C&!B1&B&!A1&!A|!E1&!E&!D1&D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D1&D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D1&D&!C1&!C&!B1&B&!A1&!A|!E1&E&D1&D&!C1&!C&!B1&B&!A1&!A|E1&!E&D1&D&!C1&!C&!B1&B&!A1&!A|!E1&!E&D1&D&!C1&!C&!B1&B&!A1&!A|!E1&!E&D1&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&E&D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D1&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&!D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&!D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&!D1&!D&C1&!C&!B1&B&A1&!A|E1&!E&!D1&!D&C1&!C&!B1&B&A1&!A|!E1&!E&!D1&!D&C1&!C&!B1&B&A1&!A|!E1&!E&!D1&!D&C1&C&!B1&B&A1&!A|E1&!E&!D1&!D&C1&C&!B1&B&A1&!A|!E1&E&!D1&!D&C1&C&!B1&B&A1&!A|!E1&E&!D1&!D&!C1&C&!B1&B&A1&!A|E1&!E&!D1&!D&!C1&C&!B1&B&A1&!A|!E1&!E&!D1&!D&!C1&C&!B1&B&A1&!A|!E1&!E&!D1&!D&!C1&C&B1&B&A1&!A|E1&!E&!D1&!D&!C1&C&B1&B&A1&!A|!E1&E&!D1&!D&!C1&C&B1&B&A1&!A|!E1&E&!D1&!D&C1&C&B1&B&A1&!A|E1&!E&!D1&!D&C1&C&B1&B&A1&!A|!E1&!E&!D1&!D&C1&C&B1&B&A1&!A|!E1&!E&!D1&!D&C1&!C&B1&B&A1&!A|E1&!E&!D1&!D&C1&!C&B1&B&A1&!A|!E1&E&!D1&!D&C1&!C&B1&B&A1&!A|!E1&E&!D1&!D&!C1&!C&B1&B&A1&!A|E1&!E&!D1&!D&!C1&!C&B1&B&A1&!A|!E1&!E&!D1&!D&!C1&!C&B1&B&A1&!A|!E1&!E&!D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&!D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&!D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&!D1&!D&C1&!C&B1&!B&A1&!A|E1&!E&!D1&!D&C1&!C&B1&!B&A1&!A|!E1&!E&!D1&!D&C1&!C&B1&!B&A1&!A|!E1&!E&!D1&!D&C1&C&B1&!B&A1&!A|E1&!E&!D1&!D&C1&C&B1&!B&A1&!A|!E1&E&!D1&!D&C1&C&B1&!B&A1&!A|!E1&E&!D1&!D&!C1&C&B1&!B&A1&!A|E1&!E&!D1&!D&!C1&C&B1&!B&A1&!A|!E1&!E&!D1&!D&!C1&C&B1&!B&A1&!A|!E1&!E&!D1&!D&!C1&C&!B1&!B&A1&!A|E1&!E&!D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&!D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&D1&!D&!C1&C&!B1&!B&A1&!A|E1&!E&D1&!D&!C1&C&!B1&!B&A1&!A|!E1&!E&D1&!D&!C1&C&!B1&!B&A1&!A|!E1&!E&D1&D&!C1&C&!B1&!B&A1&!A|E1&!E&D1&D&!C1&C&!B1&!B&A1&!A|!E1&E&D1&D&!C1&C&!B1&!B&A1&!A|!E1&E&!D1&D&!C1&C&!B1&!B&A1&!A|E1&!E&!D1&D&!C1&C&!B1&!B&A1&!A|!E1&!E&!D1&D&!C1&C&!B1&!B&A1&!A|!E1&E&!D1&!D&C1&C&!B1&!B&A1&!A|E1&!E&!D1&!D&C1&C&!B1&!B&A1&!A|!E1&!E&!D1&!D&C1&C&!B1&!B&A1&!A|!E1&!E&!D1&!D&C1&!C&!B1&!B&A1&!A|E1&!E&!D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&!D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&D1&!D&C1&!C&!B1&!B&A1&!A|E1&!E&D1&!D&C1&!C&!B1&!B&A1&!A|!E1&!E&D1&!D&C1&!C&!B1&!B&A1&!A|!E1&!E&D1&D&C1&!C&!B1&!B&A1&!A|E1&!E&D1&D&C1&!C&!B1&!B&A1&!A|!E1&E&D1&D&C1&!C&!B1&!B&A1&!A|!E1&E&!D1&D&C1&!C&!B1&!B&A1&!A|E1&!E&!D1&D&C1&!C&!B1&!B&A1&!A|!E1&!E&!D1&D&C1&!C&!B1&!B&A1&!A|!E1&!E&!D1&D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D1&D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D1&D&!C1&!C&!B1&!B&A1&!A|!E1&E&D1&D&!C1&!C&!B1&!B&A1&!A|E1&!E&D1&D&!C1&!C&!B1&!B&A1&!A|!E1&!E&D1&D&!C1&!C&!B1&!B&A1&!A|!E1&!E&D1&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&E&D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D1&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D1&!D&!C1&!C&!B1&!B&A1&A|E1&!E&!D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&!D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&D1&!D&!C1&!C&!B1&!B&A1&A|E1&!E&D1&!D&!C1&!C&!B1&!B&A1&A|!E1&!E&D1&!D&!C1&!C&!B1&!B&A1&A|!E1&!E&D1&D&!C1&!C&!B1&!B&A1&A|E1&!E&D1&D&!C1&!C&!B1&!B&A1&A|!E1&E&D1&D&!C1&!C&!B1&!B&A1&A|!E1&E&!D1&D&!C1&!C&!B1&!B&A1&A|E1&!E&!D1&D&!C1&!C&!B1&!B&A1&A|!E1&!E&!D1&D&!C1&!C&!B1&!B&A1&A|!E1&!E&!D1&D&C1&!C&!B1&!B&A1&A|E1&!E&!D1&D&C1&!C&!B1&!B&A1&A|!E1&E&!D1&D&C1&!C&!B1&!B&A1&A|!E1&E&D1&D&C1&!C&!B1&!B&A1&A|E1&!E&D1&D&C1&!C&!B1&!B&A1&A|!E1&!E&D1&D&C1&!C&!B1&!B&A1&A|!E1&!E&D1&!D&C1&!C&!B1&!B&A1&A|E1&!E&D1&!D&C1&!C&!B1&!B&A1&A|!E1&E&D1&!D&C1&!C&!B1&!B&A1&A|!E1&E&!D1&!D&C1&!C&!B1&!B&A1&A|E1&!E&!D1&!D&C1&!C&!B1&!B&A1&A|!E1&!E&!D1&!D&C1&!C&!B1&!B&A1&A|!E1&!E&!D1&!D&C1&C&!B1&!B&A1&A|E1&!E&!D1&!D&C1&C&!B1&!B&A1&A|!E1&E&!D1&!D&C1&C&!B1&!B&A1&A|!E1&!E&!D1&D&!C1&C&!B1&!B&A1&A|E1&!E&!D1&D&!C1&C&!B1&!B&A1&A|!E1&E&!D1&D&!C1&C&!B1&!B&A1&A|!E1&E&D1&D&!C1&C&!B1&!B&A1&A|E1&!E&D1&D&!C1&C&!B1&!B&A1&A|!E1&!E&D1&D&!C1&C&!B1&!B&A1&A|!E1&!E&D1&!D&!C1&C&!B1&!B&A1&A|E1&!E&D1&!D&!C1&C&!B1&!B&A1&A|!E1&E&D1&!D&!C1&C&!B1&!B&A1&A|!E1&E&!D1&!D&!C1&C&!B1&!B&A1&A|E1&!E&!D1&!D&!C1&C&!B1&!B&A1&A|!E1&!E&!D1&!D&!C1&C&!B1&!B&A1&A|!E1&!E&!D1&!D&!C1&C&B1&!B&A1&A|E1&!E&!D1&!D&!C1&C&B1&!B&A1&A|!E1&E&!D1&!D&!C1&C&B1&!B&A1&A|!E1&E&!D1&!D&C1&C&B1&!B&A1&A|E1&!E&!D1&!D&C1&C&B1&!B&A1&A|!E1&!E&!D1&!D&C1&C&B1&!B&A1&A|!E1&!E&!D1&!D&C1&!C&B1&!B&A1&A|E1&!E&!D1&!D&C1&!C&B1&!B&A1&A|!E1&E&!D1&!D&C1&!C&B1&!B&A1&A|!E1&E&!D1&!D&!C1&!C&B1&!B&A1&A|E1&!E&!D1&!D&!C1&!C&B1&!B&A1&A|!E1&!E&!D1&!D&!C1&!C&B1&!B&A1&A|!E1&!E&!D1&!D&!C1&!C&B1&B&A1&A|E1&!E&!D1&!D&!C1&!C&B1&B&A1&A|!E1&E&!D1&!D&!C1&!C&B1&B&A1&A|!E1&E&!D1&!D&C1&!C&B1&B&A1&A|E1&!E&!D1&!D&C1&!C&B1&B&A1&A|!E1&!E&!D1&!D&C1&!C&B1&B&A1&A|!E1&!E&!D1&!D&C1&C&B1&B&A1&A|E1&!E&!D1&!D&C1&C&B1&B&A1&A|!E1&E&!D1&!D&C1&C&B1&B&A1&A|!E1&E&!D1&!D&!C1&C&B1&B&A1&A|E1&!E&!D1&!D&!C1&C&B1&B&A1&A|!E1&!E&!D1&!D&!C1&C&B1&B&A1&A|!E1&!E&!D1&!D&!C1&C&!B1&B&A1&A|E1&!E&!D1&!D&!C1&C&!B1&B&A1&A|!E1&E&!D1&!D&!C1&C&!B1&B&A1&A|!E1&E&!D1&!D&C1&C&!B1&B&A1&A|E1&!E&!D1&!D&C1&C&!B1&B&A1&A|!E1&!E&!D1&!D&C1&C&!B1&B&A1&A|!E1&!E&!D1&!D&C1&!C&!B1&B&A1&A|E1&!E&!D1&!D&C1&!C&!B1&B&A1&A|!E1&E&!D1&!D&C1&!C&!B1&B&A1&A|!E1&E&!D1&!D&!C1&!C&!B1&B&A1&A|E1&!E&!D1&!D&!C1&!C&!B1&B&A1&A|!E1&!E&!D1&!D&!C1&!C&!B1&B&A1&A|!E1&!E&!D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&!D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&!D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&!D1&!D&C1&!C&!B1&B&!A1&A|E1&!E&!D1&!D&C1&!C&!B1&B&!A1&A|!E1&!E&!D1&!D&C1&!C&!B1&B&!A1&A|!E1&!E&!D1&!D&C1&C&!B1&B&!A1&A|E1&!E&!D1&!D&C1&C&!B1&B&!A1&A|!E1&E&!D1&!D&C1&C&!B1&B&!A1&A|!E1&E&!D1&!D&!C1&C&!B1&B&!A1&A|E1&!E&!D1&!D&!C1&C&!B1&B&!A1&A|!E1&!E&!D1&!D&!C1&C&!B1&B&!A1&A|!E1&!E&!D1&!D&!C1&C&B1&B&!A1&A|E1&!E&!D1&!D&!C1&C&B1&B&!A1&A|!E1&E&!D1&!D&!C1&C&B1&B&!A1&A|!E1&E&!D1&!D&C1&C&B1&B&!A1&A|E1&!E&!D1&!D&C1&C&B1&B&!A1&A|!E1&!E&!D1&!D&C1&C&B1&B&!A1&A|!E1&!E&!D1&!D&C1&!C&B1&B&!A1&A|E1&!E&!D1&!D&C1&!C&B1&B&!A1&A|!E1&E&!D1&!D&C1&!C&B1&B&!A1&A|!E1&E&!D1&!D&!C1&!C&B1&B&!A1&A|E1&!E&!D1&!D&!C1&!C&B1&B&!A1&A|!E1&!E&!D1&!D&!C1&!C&B1&B&!A1&A|!E1&!E&!D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&!D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&!D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&!D1&!D&C1&!C&B1&!B&!A1&A|E1&!E&!D1&!D&C1&!C&B1&!B&!A1&A|!E1&!E&!D1&!D&C1&!C&B1&!B&!A1&A|!E1&!E&!D1&!D&C1&C&B1&!B&!A1&A|E1&!E&!D1&!D&C1&C&B1&!B&!A1&A|!E1&E&!D1&!D&C1&C&B1&!B&!A1&A|!E1&E&!D1&!D&!C1&C&B1&!B&!A1&A|E1&!E&!D1&!D&!C1&C&B1&!B&!A1&A|!E1&!E&!D1&!D&!C1&C&B1&!B&!A1&A|!E1&!E&!D1&!D&!C1&C&!B1&!B&!A1&A|E1&!E&!D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&!D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&D1&!D&!C1&C&!B1&!B&!A1&A|E1&!E&D1&!D&!C1&C&!B1&!B&!A1&A|!E1&!E&D1&!D&!C1&C&!B1&!B&!A1&A|!E1&!E&D1&D&!C1&C&!B1&!B&!A1&A|E1&!E&D1&D&!C1&C&!B1&!B&!A1&A|!E1&E&D1&D&!C1&C&!B1&!B&!A1&A|!E1&E&!D1&D&!C1&C&!B1&!B&!A1&A|E1&!E&!D1&D&!C1&C&!B1&!B&!A1&A|!E1&!E&!D1&D&!C1&C&!B1&!B&!A1&A|!E1&E&!D1&!D&C1&C&!B1&!B&!A1&A|E1&!E&!D1&!D&C1&C&!B1&!B&!A1&A|!E1&!E&!D1&!D&C1&C&!B1&!B&!A1&A|!E1&!E&!D1&!D&C1&!C&!B1&!B&!A1&A|E1&!E&!D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&!D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&D1&!D&C1&!C&!B1&!B&!A1&A|E1&!E&D1&!D&C1&!C&!B1&!B&!A1&A|!E1&!E&D1&!D&C1&!C&!B1&!B&!A1&A|!E1&!E&D1&D&C1&!C&!B1&!B&!A1&A|E1&!E&D1&D&C1&!C&!B1&!B&!A1&A|!E1&E&D1&D&C1&!C&!B1&!B&!A1&A|!E1&E&!D1&D&C1&!C&!B1&!B&!A1&A|E1&!E&!D1&D&C1&!C&!B1&!B&!A1&A|!E1&!E&!D1&D&C1&!C&!B1&!B&!A1&A|!E1&!E&!D1&D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D1&D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D1&D&!C1&!C&!B1&!B&!A1&A|!E1&E&D1&D&!C1&!C&!B1&!B&!A1&A|E1&!E&D1&D&!C1&!C&!B1&!B&!A1&A|!E1&!E&D1&D&!C1&!C&!B1&!B&!A1&A|!E1&!E&D1&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&E&D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D1&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&!E&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOOAAOI22222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAI22131 -l AAOOAI22131 -i E D2 D1 D C B1 B A1 A -o Y -f Y=!(E&!D2&!D1&D&C&!B1&!B&!A1&!A|E&D2&!D1&D&C&!B1&!B&!A1&!A|E&D2&D1&D&C&!B1&!B&!A1&!A|E&!D2&D1&D&C&!B1&!B&!A1&!A|E&!D2&D1&!D&C&!B1&!B&!A1&!A|E&D2&D1&!D&C&!B1&!B&!A1&!A|E&D2&!D1&!D&C&!B1&!B&!A1&!A|E&D2&!D1&!D&C&B1&!B&!A1&!A|E&D2&D1&!D&C&B1&!B&!A1&!A|E&!D2&D1&!D&C&B1&!B&!A1&!A|E&!D2&D1&D&C&B1&!B&!A1&!A|E&D2&D1&D&C&B1&!B&!A1&!A|E&D2&!D1&D&C&B1&!B&!A1&!A|E&!D2&!D1&D&C&B1&!B&!A1&!A|E&D2&!D1&!D&!C&B1&B&!A1&!A|E&D2&D1&!D&!C&B1&B&!A1&!A|E&!D2&D1&!D&!C&B1&B&!A1&!A|E&!D2&D1&D&!C&B1&B&!A1&!A|E&D2&D1&D&!C&B1&B&!A1&!A|E&D2&!D1&D&!C&B1&B&!A1&!A|E&!D2&!D1&D&!C&B1&B&!A1&!A|E&!D2&!D1&D&C&B1&B&!A1&!A|E&D2&!D1&D&C&B1&B&!A1&!A|E&D2&D1&D&C&B1&B&!A1&!A|E&!D2&D1&D&C&B1&B&!A1&!A|E&!D2&D1&!D&C&B1&B&!A1&!A|E&D2&D1&!D&C&B1&B&!A1&!A|E&D2&!D1&!D&C&B1&B&!A1&!A|E&D2&!D1&!D&C&!B1&B&!A1&!A|E&D2&D1&!D&C&!B1&B&!A1&!A|E&!D2&D1&!D&C&!B1&B&!A1&!A|E&!D2&D1&D&C&!B1&B&!A1&!A|E&D2&D1&D&C&!B1&B&!A1&!A|E&D2&!D1&D&C&!B1&B&!A1&!A|E&!D2&!D1&D&C&!B1&B&!A1&!A|E&!D2&!D1&D&C&!B1&B&A1&!A|E&D2&!D1&D&C&!B1&B&A1&!A|E&D2&D1&D&C&!B1&B&A1&!A|E&!D2&D1&D&C&!B1&B&A1&!A|E&!D2&D1&!D&C&!B1&B&A1&!A|E&D2&D1&!D&C&!B1&B&A1&!A|E&D2&!D1&!D&C&!B1&B&A1&!A|E&D2&!D1&!D&C&B1&B&A1&!A|E&D2&D1&!D&C&B1&B&A1&!A|E&!D2&D1&!D&C&B1&B&A1&!A|E&!D2&D1&D&C&B1&B&A1&!A|E&D2&D1&D&C&B1&B&A1&!A|E&D2&!D1&D&C&B1&B&A1&!A|E&!D2&!D1&D&C&B1&B&A1&!A|E&!D2&!D1&D&!C&B1&B&A1&!A|E&D2&!D1&D&!C&B1&B&A1&!A|E&D2&D1&D&!C&B1&B&A1&!A|E&!D2&D1&D&!C&B1&B&A1&!A|E&!D2&D1&!D&!C&B1&B&A1&!A|E&D2&D1&!D&!C&B1&B&A1&!A|E&D2&!D1&!D&!C&B1&B&A1&!A|E&!D2&!D1&D&C&B1&!B&A1&!A|E&D2&!D1&D&C&B1&!B&A1&!A|E&D2&D1&D&C&B1&!B&A1&!A|E&!D2&D1&D&C&B1&!B&A1&!A|E&!D2&D1&!D&C&B1&!B&A1&!A|E&D2&D1&!D&C&B1&!B&A1&!A|E&D2&!D1&!D&C&B1&!B&A1&!A|E&D2&!D1&!D&C&!B1&!B&A1&!A|E&D2&D1&!D&C&!B1&!B&A1&!A|E&!D2&D1&!D&C&!B1&!B&A1&!A|E&!D2&D1&D&C&!B1&!B&A1&!A|E&D2&D1&D&C&!B1&!B&A1&!A|E&D2&!D1&D&C&!B1&!B&A1&!A|E&!D2&!D1&D&C&!B1&!B&A1&!A|E&D2&!D1&!D&!C&!B1&!B&A1&A|E&D2&D1&!D&!C&!B1&!B&A1&A|E&!D2&D1&!D&!C&!B1&!B&A1&A|E&!D2&D1&D&!C&!B1&!B&A1&A|E&D2&D1&D&!C&!B1&!B&A1&A|E&D2&!D1&D&!C&!B1&!B&A1&A|E&!D2&!D1&D&!C&!B1&!B&A1&A|E&!D2&!D1&D&C&!B1&!B&A1&A|E&D2&!D1&D&C&!B1&!B&A1&A|E&D2&D1&D&C&!B1&!B&A1&A|E&!D2&D1&D&C&!B1&!B&A1&A|E&!D2&D1&!D&C&!B1&!B&A1&A|E&D2&D1&!D&C&!B1&!B&A1&A|E&D2&!D1&!D&C&!B1&!B&A1&A|E&D2&!D1&!D&C&B1&!B&A1&A|E&D2&D1&!D&C&B1&!B&A1&A|E&!D2&D1&!D&C&B1&!B&A1&A|E&!D2&D1&D&C&B1&!B&A1&A|E&D2&D1&D&C&B1&!B&A1&A|E&D2&!D1&D&C&B1&!B&A1&A|E&!D2&!D1&D&C&B1&!B&A1&A|E&!D2&!D1&D&!C&B1&!B&A1&A|E&D2&!D1&D&!C&B1&!B&A1&A|E&D2&D1&D&!C&B1&!B&A1&A|E&!D2&D1&D&!C&B1&!B&A1&A|E&!D2&D1&!D&!C&B1&!B&A1&A|E&D2&D1&!D&!C&B1&!B&A1&A|E&D2&!D1&!D&!C&B1&!B&A1&A|E&D2&!D1&!D&!C&B1&B&A1&A|E&D2&D1&!D&!C&B1&B&A1&A|E&!D2&D1&!D&!C&B1&B&A1&A|E&!D2&D1&D&!C&B1&B&A1&A|E&D2&D1&D&!C&B1&B&A1&A|E&D2&!D1&D&!C&B1&B&A1&A|E&!D2&!D1&D&!C&B1&B&A1&A|E&!D2&!D1&D&C&B1&B&A1&A|E&D2&!D1&D&C&B1&B&A1&A|E&D2&D1&D&C&B1&B&A1&A|E&!D2&D1&D&C&B1&B&A1&A|E&!D2&D1&!D&C&B1&B&A1&A|E&D2&D1&!D&C&B1&B&A1&A|E&D2&!D1&!D&C&B1&B&A1&A|E&D2&!D1&!D&C&!B1&B&A1&A|E&D2&D1&!D&C&!B1&B&A1&A|E&!D2&D1&!D&C&!B1&B&A1&A|E&!D2&D1&D&C&!B1&B&A1&A|E&D2&D1&D&C&!B1&B&A1&A|E&D2&!D1&D&C&!B1&B&A1&A|E&!D2&!D1&D&C&!B1&B&A1&A|E&!D2&!D1&D&!C&!B1&B&A1&A|E&D2&!D1&D&!C&!B1&B&A1&A|E&D2&D1&D&!C&!B1&B&A1&A|E&!D2&D1&D&!C&!B1&B&A1&A|E&!D2&D1&!D&!C&!B1&B&A1&A|E&D2&D1&!D&!C&!B1&B&A1&A|E&D2&!D1&!D&!C&!B1&B&A1&A|E&!D2&!D1&D&C&!B1&B&!A1&A|E&D2&!D1&D&C&!B1&B&!A1&A|E&D2&D1&D&C&!B1&B&!A1&A|E&!D2&D1&D&C&!B1&B&!A1&A|E&!D2&D1&!D&C&!B1&B&!A1&A|E&D2&D1&!D&C&!B1&B&!A1&A|E&D2&!D1&!D&C&!B1&B&!A1&A|E&D2&!D1&!D&C&B1&B&!A1&A|E&D2&D1&!D&C&B1&B&!A1&A|E&!D2&D1&!D&C&B1&B&!A1&A|E&!D2&D1&D&C&B1&B&!A1&A|E&D2&D1&D&C&B1&B&!A1&A|E&D2&!D1&D&C&B1&B&!A1&A|E&!D2&!D1&D&C&B1&B&!A1&A|E&!D2&!D1&D&!C&B1&B&!A1&A|E&D2&!D1&D&!C&B1&B&!A1&A|E&D2&D1&D&!C&B1&B&!A1&A|E&!D2&D1&D&!C&B1&B&!A1&A|E&!D2&D1&!D&!C&B1&B&!A1&A|E&D2&D1&!D&!C&B1&B&!A1&A|E&D2&!D1&!D&!C&B1&B&!A1&A|E&!D2&!D1&D&C&B1&!B&!A1&A|E&D2&!D1&D&C&B1&!B&!A1&A|E&D2&D1&D&C&B1&!B&!A1&A|E&!D2&D1&D&C&B1&!B&!A1&A|E&!D2&D1&!D&C&B1&!B&!A1&A|E&D2&D1&!D&C&B1&!B&!A1&A|E&D2&!D1&!D&C&B1&!B&!A1&A|E&D2&!D1&!D&C&!B1&!B&!A1&A|E&D2&D1&!D&C&!B1&!B&!A1&A|E&!D2&D1&!D&C&!B1&!B&!A1&A|E&!D2&D1&D&C&!B1&!B&!A1&A|E&D2&D1&D&C&!B1&!B&!A1&A|E&D2&!D1&D&C&!B1&!B&!A1&A|E&!D2&!D1&D&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAI22131.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOAOI21231 -l OAAOOAOI21231 -i E D2 D1 D C1 C B A1 A -o Y -f Y=(!E&!D2&!D1&!D&!C1&!C&!B&!A1&!A|!E&D2&!D1&!D&!C1&!C&!B&!A1&!A|!E&D2&D1&!D&!C1&!C&!B&!A1&!A|!E&!D2&D1&!D&!C1&!C&!B&!A1&!A|!E&!D2&D1&D&!C1&!C&!B&!A1&!A|!E&D2&D1&D&!C1&!C&!B&!A1&!A|!E&D2&!D1&D&!C1&!C&!B&!A1&!A|!E&!D2&!D1&D&!C1&!C&!B&!A1&!A|!E&!D2&!D1&D&C1&!C&!B&!A1&!A|!E&D2&!D1&D&C1&!C&!B&!A1&!A|!E&D2&D1&D&C1&!C&!B&!A1&!A|!E&!D2&D1&D&C1&!C&!B&!A1&!A|!E&!D2&D1&!D&C1&!C&!B&!A1&!A|!E&D2&D1&!D&C1&!C&!B&!A1&!A|!E&D2&!D1&!D&C1&!C&!B&!A1&!A|!E&!D2&!D1&!D&C1&!C&!B&!A1&!A|!E&!D2&!D1&!D&C1&C&!B&!A1&!A|!E&!D2&!D1&D&!C1&C&!B&!A1&!A|!E&D2&!D1&D&!C1&C&!B&!A1&!A|!E&D2&D1&D&!C1&C&!B&!A1&!A|!E&!D2&D1&D&!C1&C&!B&!A1&!A|!E&!D2&D1&!D&!C1&C&!B&!A1&!A|!E&D2&D1&!D&!C1&C&!B&!A1&!A|!E&D2&!D1&!D&!C1&C&!B&!A1&!A|!E&!D2&!D1&!D&!C1&C&!B&!A1&!A|!E&!D2&!D1&!D&!C1&C&B&!A1&!A|!E&D2&!D1&!D&!C1&C&B&!A1&!A|!E&D2&D1&!D&!C1&C&B&!A1&!A|!E&!D2&D1&!D&!C1&C&B&!A1&!A|!E&!D2&D1&D&!C1&C&B&!A1&!A|!E&D2&D1&D&!C1&C&B&!A1&!A|!E&D2&!D1&D&!C1&C&B&!A1&!A|!E&!D2&!D1&D&!C1&C&B&!A1&!A|!E&!D2&!D1&!D&C1&C&B&!A1&!A|!E&!D2&!D1&!D&C1&!C&B&!A1&!A|!E&D2&!D1&!D&C1&!C&B&!A1&!A|!E&D2&D1&!D&C1&!C&B&!A1&!A|!E&!D2&D1&!D&C1&!C&B&!A1&!A|!E&!D2&D1&D&C1&!C&B&!A1&!A|!E&D2&D1&D&C1&!C&B&!A1&!A|!E&D2&!D1&D&C1&!C&B&!A1&!A|!E&!D2&!D1&D&C1&!C&B&!A1&!A|!E&!D2&!D1&D&!C1&!C&B&!A1&!A|!E&D2&!D1&D&!C1&!C&B&!A1&!A|!E&D2&D1&D&!C1&!C&B&!A1&!A|!E&!D2&D1&D&!C1&!C&B&!A1&!A|!E&!D2&D1&!D&!C1&!C&B&!A1&!A|!E&D2&D1&!D&!C1&!C&B&!A1&!A|!E&D2&!D1&!D&!C1&!C&B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&B&A1&!A|!E&!D2&!D1&!D&C1&!C&B&A1&!A|!E&!D2&!D1&!D&C1&C&B&A1&!A|!E&!D2&!D1&!D&!C1&C&B&A1&!A|!E&!D2&!D1&!D&!C1&C&!B&A1&!A|!E&D2&!D1&!D&!C1&C&!B&A1&!A|!E&D2&D1&!D&!C1&C&!B&A1&!A|!E&!D2&D1&!D&!C1&C&!B&A1&!A|!E&!D2&D1&D&!C1&C&!B&A1&!A|!E&D2&D1&D&!C1&C&!B&A1&!A|!E&D2&!D1&D&!C1&C&!B&A1&!A|!E&!D2&!D1&D&!C1&C&!B&A1&!A|!E&!D2&!D1&!D&C1&C&!B&A1&!A|!E&!D2&!D1&!D&C1&!C&!B&A1&!A|!E&D2&!D1&!D&C1&!C&!B&A1&!A|!E&D2&D1&!D&C1&!C&!B&A1&!A|!E&!D2&D1&!D&C1&!C&!B&A1&!A|!E&!D2&D1&D&C1&!C&!B&A1&!A|!E&D2&D1&D&C1&!C&!B&A1&!A|!E&D2&!D1&D&C1&!C&!B&A1&!A|!E&!D2&!D1&D&C1&!C&!B&A1&!A|!E&!D2&!D1&D&!C1&!C&!B&A1&!A|!E&D2&!D1&D&!C1&!C&!B&A1&!A|!E&D2&D1&D&!C1&!C&!B&A1&!A|!E&!D2&D1&D&!C1&!C&!B&A1&!A|!E&!D2&D1&!D&!C1&!C&!B&A1&!A|!E&D2&D1&!D&!C1&!C&!B&A1&!A|!E&D2&!D1&!D&!C1&!C&!B&A1&!A|!E&!D2&!D1&!D&!C1&!C&!B&A1&!A|!E&!D2&!D1&!D&!C1&!C&!B&A1&A|!E&D2&!D1&!D&!C1&!C&!B&A1&A|!E&D2&D1&!D&!C1&!C&!B&A1&A|!E&!D2&D1&!D&!C1&!C&!B&A1&A|!E&!D2&D1&D&!C1&!C&!B&A1&A|!E&D2&D1&D&!C1&!C&!B&A1&A|!E&D2&!D1&D&!C1&!C&!B&A1&A|!E&!D2&!D1&D&!C1&!C&!B&A1&A|!E&!D2&!D1&D&C1&!C&!B&A1&A|!E&D2&!D1&D&C1&!C&!B&A1&A|!E&D2&D1&D&C1&!C&!B&A1&A|!E&!D2&D1&D&C1&!C&!B&A1&A|!E&!D2&D1&!D&C1&!C&!B&A1&A|!E&D2&D1&!D&C1&!C&!B&A1&A|!E&D2&!D1&!D&C1&!C&!B&A1&A|!E&!D2&!D1&!D&C1&!C&!B&A1&A|!E&!D2&!D1&!D&C1&C&!B&A1&A|!E&!D2&!D1&D&!C1&C&!B&A1&A|!E&D2&!D1&D&!C1&C&!B&A1&A|!E&D2&D1&D&!C1&C&!B&A1&A|!E&!D2&D1&D&!C1&C&!B&A1&A|!E&!D2&D1&!D&!C1&C&!B&A1&A|!E&D2&D1&!D&!C1&C&!B&A1&A|!E&D2&!D1&!D&!C1&C&!B&A1&A|!E&!D2&!D1&!D&!C1&C&!B&A1&A|!E&!D2&!D1&!D&!C1&C&B&A1&A|!E&!D2&!D1&!D&C1&C&B&A1&A|!E&!D2&!D1&!D&C1&!C&B&A1&A|!E&!D2&!D1&!D&!C1&!C&B&A1&A|!E&!D2&!D1&!D&!C1&!C&B&!A1&A|!E&!D2&!D1&!D&C1&!C&B&!A1&A|!E&!D2&!D1&!D&C1&C&B&!A1&A|!E&!D2&!D1&!D&!C1&C&B&!A1&A|!E&!D2&!D1&!D&!C1&C&!B&!A1&A|!E&D2&!D1&!D&!C1&C&!B&!A1&A|!E&D2&D1&!D&!C1&C&!B&!A1&A|!E&!D2&D1&!D&!C1&C&!B&!A1&A|!E&!D2&D1&D&!C1&C&!B&!A1&A|!E&D2&D1&D&!C1&C&!B&!A1&A|!E&D2&!D1&D&!C1&C&!B&!A1&A|!E&!D2&!D1&D&!C1&C&!B&!A1&A|!E&!D2&!D1&!D&C1&C&!B&!A1&A|!E&!D2&!D1&!D&C1&!C&!B&!A1&A|!E&D2&!D1&!D&C1&!C&!B&!A1&A|!E&D2&D1&!D&C1&!C&!B&!A1&A|!E&!D2&D1&!D&C1&!C&!B&!A1&A|!E&!D2&D1&D&C1&!C&!B&!A1&A|!E&D2&D1&D&C1&!C&!B&!A1&A|!E&D2&!D1&D&C1&!C&!B&!A1&A|!E&!D2&!D1&D&C1&!C&!B&!A1&A|!E&!D2&!D1&D&!C1&!C&!B&!A1&A|!E&D2&!D1&D&!C1&!C&!B&!A1&A|!E&D2&D1&D&!C1&!C&!B&!A1&A|!E&!D2&D1&D&!C1&!C&!B&!A1&A|!E&!D2&D1&!D&!C1&!C&!B&!A1&A|!E&D2&D1&!D&!C1&!C&!B&!A1&A|!E&D2&!D1&!D&!C1&!C&!B&!A1&A|!E&!D2&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOAOI21231.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAI223 -l AAOOAI223 -i C2 C1 C B1 B A1 A -o Y -f Y=!(C2&!C1&!C&B1&B&!A1&!A|C2&C1&!C&B1&B&!A1&!A|!C2&C1&!C&B1&B&!A1&!A|!C2&C1&C&B1&B&!A1&!A|C2&C1&C&B1&B&!A1&!A|C2&!C1&C&B1&B&!A1&!A|!C2&!C1&C&B1&B&!A1&!A|!C2&!C1&C&B1&B&A1&!A|C2&!C1&C&B1&B&A1&!A|C2&C1&C&B1&B&A1&!A|!C2&C1&C&B1&B&A1&!A|!C2&C1&!C&B1&B&A1&!A|C2&C1&!C&B1&B&A1&!A|C2&!C1&!C&B1&B&A1&!A|C2&!C1&!C&!B1&!B&A1&A|C2&C1&!C&!B1&!B&A1&A|!C2&C1&!C&!B1&!B&A1&A|!C2&C1&C&!B1&!B&A1&A|C2&C1&C&!B1&!B&A1&A|C2&!C1&C&!B1&!B&A1&A|!C2&!C1&C&!B1&!B&A1&A|!C2&!C1&C&B1&!B&A1&A|C2&!C1&C&B1&!B&A1&A|C2&C1&C&B1&!B&A1&A|!C2&C1&C&B1&!B&A1&A|!C2&C1&!C&B1&!B&A1&A|C2&C1&!C&B1&!B&A1&A|C2&!C1&!C&B1&!B&A1&A|C2&!C1&!C&B1&B&A1&A|C2&C1&!C&B1&B&A1&A|!C2&C1&!C&B1&B&A1&A|!C2&C1&C&B1&B&A1&A|C2&C1&C&B1&B&A1&A|C2&!C1&C&B1&B&A1&A|!C2&!C1&C&B1&B&A1&A|!C2&!C1&C&!B1&B&A1&A|C2&!C1&C&!B1&B&A1&A|C2&C1&C&!B1&B&A1&A|!C2&C1&C&!B1&B&A1&A|!C2&C1&!C&!B1&B&A1&A|C2&C1&!C&!B1&B&A1&A|C2&!C1&!C&!B1&B&A1&A|!C2&!C1&C&B1&B&!A1&A|C2&!C1&C&B1&B&!A1&A|C2&C1&C&B1&B&!A1&A|!C2&C1&C&B1&B&!A1&A|!C2&C1&!C&B1&B&!A1&A|C2&C1&!C&B1&B&!A1&A|C2&!C1&!C&B1&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAI223.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOAOI21211 -l OAAOAOI21211 -i E D C1 C B A1 A -o Y -f Y=(!E&!D&!C1&!C&!B&!A1&!A|!E&D&!C1&!C&!B&!A1&!A|!E&D&C1&!C&!B&!A1&!A|!E&!D&C1&!C&!B&!A1&!A|!E&!D&C1&C&!B&!A1&!A|!E&D&!C1&C&!B&!A1&!A|!E&!D&!C1&C&!B&!A1&!A|!E&!D&!C1&C&B&!A1&!A|!E&D&!C1&C&B&!A1&!A|!E&!D&C1&C&B&!A1&!A|!E&!D&C1&!C&B&!A1&!A|!E&D&C1&!C&B&!A1&!A|!E&D&!C1&!C&B&!A1&!A|!E&!D&!C1&!C&B&!A1&!A|!E&!D&!C1&!C&B&A1&!A|!E&!D&C1&!C&B&A1&!A|!E&!D&C1&C&B&A1&!A|!E&!D&!C1&C&B&A1&!A|!E&!D&!C1&C&!B&A1&!A|!E&D&!C1&C&!B&A1&!A|!E&!D&C1&C&!B&A1&!A|!E&!D&C1&!C&!B&A1&!A|!E&D&C1&!C&!B&A1&!A|!E&D&!C1&!C&!B&A1&!A|!E&!D&!C1&!C&!B&A1&!A|!E&!D&!C1&!C&!B&A1&A|!E&D&!C1&!C&!B&A1&A|!E&D&C1&!C&!B&A1&A|!E&!D&C1&!C&!B&A1&A|!E&!D&C1&C&!B&A1&A|!E&D&!C1&C&!B&A1&A|!E&!D&!C1&C&!B&A1&A|!E&!D&!C1&C&B&A1&A|!E&!D&C1&C&B&A1&A|!E&!D&C1&!C&B&A1&A|!E&!D&!C1&!C&B&A1&A|!E&!D&!C1&!C&B&!A1&A|!E&!D&C1&!C&B&!A1&A|!E&!D&C1&C&B&!A1&A|!E&!D&!C1&C&B&!A1&A|!E&!D&!C1&C&!B&!A1&A|!E&D&!C1&C&!B&!A1&A|!E&!D&C1&C&!B&!A1&A|!E&!D&C1&!C&!B&!A1&A|!E&D&C1&!C&!B&!A1&A|!E&D&!C1&!C&!B&!A1&A|!E&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOAOI21211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOI232 -l OAOI232 -i C1 C B2 B1 B A1 A -o Y -f Y=(!C1&!C&!B2&!B1&!B&!A1&!A|!C1&!C&B2&!B1&!B&!A1&!A|!C1&!C&B2&B1&!B&!A1&!A|!C1&!C&!B2&B1&!B&!A1&!A|!C1&!C&!B2&B1&B&!A1&!A|!C1&!C&B2&B1&B&!A1&!A|!C1&!C&B2&!B1&B&!A1&!A|!C1&!C&!B2&!B1&B&!A1&!A|!C1&!C&!B2&!B1&B&A1&!A|!C1&!C&B2&!B1&B&A1&!A|!C1&!C&!B2&B1&B&A1&!A|!C1&!C&!B2&B1&!B&A1&!A|!C1&!C&B2&B1&!B&A1&!A|!C1&!C&B2&!B1&!B&A1&!A|!C1&!C&!B2&!B1&!B&A1&!A|!C1&!C&!B2&!B1&!B&A1&A|!C1&!C&B2&!B1&!B&A1&A|!C1&!C&B2&B1&!B&A1&A|!C1&!C&!B2&B1&!B&A1&A|!C1&!C&!B2&B1&B&A1&A|!C1&!C&B2&!B1&B&A1&A|!C1&!C&!B2&!B1&B&A1&A|!C1&!C&!B2&!B1&B&!A1&A|!C1&!C&B2&!B1&B&!A1&A|!C1&!C&!B2&B1&B&!A1&A|!C1&!C&!B2&B1&!B&!A1&A|!C1&!C&B2&B1&!B&!A1&A|!C1&!C&B2&!B1&!B&!A1&A|!C1&!C&!B2&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOI232.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOI222 -l OOAOI222 -i C1 C B1 B A1 A -o Y -f Y=(!C1&!C&!B1&!B&!A1&!A|!C1&!C&B1&!B&!A1&!A|!C1&!C&B1&B&!A1&!A|!C1&!C&!B1&B&!A1&!A|!C1&!C&!B1&!B&A1&!A|!C1&!C&!B1&!B&A1&A|!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOI222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOOAOAI222211 -l AAAOOAOAI222211 -i F E D1 D C1 C B1 B A1 A -o Y -f Y=!(F&E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|F&E&D1&!D&!C1&!C&!B1&!B&!A1&!A|F&E&D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&!D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&!D1&D&C1&!C&!B1&!B&!A1&!A|F&E&D1&D&C1&!C&!B1&!B&!A1&!A|F&E&D1&!D&C1&!C&!B1&!B&!A1&!A|F&E&!D1&!D&C1&!C&!B1&!B&!A1&!A|F&E&!D1&!D&C1&C&!B1&!B&!A1&!A|F&E&D1&!D&C1&C&!B1&!B&!A1&!A|F&!E&D1&!D&C1&C&!B1&!B&!A1&!A|F&!E&D1&D&C1&C&!B1&!B&!A1&!A|F&E&D1&D&C1&C&!B1&!B&!A1&!A|F&E&!D1&D&C1&C&!B1&!B&!A1&!A|F&!E&!D1&D&C1&C&!B1&!B&!A1&!A|F&E&!D1&D&!C1&C&!B1&!B&!A1&!A|F&E&D1&D&!C1&C&!B1&!B&!A1&!A|F&E&D1&!D&!C1&C&!B1&!B&!A1&!A|F&E&!D1&!D&!C1&C&!B1&!B&!A1&!A|F&E&!D1&!D&!C1&C&B1&!B&!A1&!A|F&E&D1&!D&!C1&C&B1&!B&!A1&!A|F&E&D1&D&!C1&C&B1&!B&!A1&!A|F&E&!D1&D&!C1&C&B1&!B&!A1&!A|F&!E&!D1&D&C1&C&B1&!B&!A1&!A|F&E&!D1&D&C1&C&B1&!B&!A1&!A|F&E&D1&D&C1&C&B1&!B&!A1&!A|F&!E&D1&D&C1&C&B1&!B&!A1&!A|F&!E&D1&!D&C1&C&B1&!B&!A1&!A|F&E&D1&!D&C1&C&B1&!B&!A1&!A|F&E&!D1&!D&C1&C&B1&!B&!A1&!A|F&E&!D1&!D&C1&!C&B1&!B&!A1&!A|F&E&D1&!D&C1&!C&B1&!B&!A1&!A|F&E&D1&D&C1&!C&B1&!B&!A1&!A|F&E&!D1&D&C1&!C&B1&!B&!A1&!A|F&E&!D1&D&!C1&!C&B1&!B&!A1&!A|F&E&D1&D&!C1&!C&B1&!B&!A1&!A|F&E&D1&!D&!C1&!C&B1&!B&!A1&!A|F&E&!D1&!D&!C1&!C&B1&!B&!A1&!A|F&E&!D1&!D&!C1&!C&B1&B&!A1&!A|F&E&D1&!D&!C1&!C&B1&B&!A1&!A|F&!E&D1&!D&!C1&!C&B1&B&!A1&!A|F&!E&D1&D&!C1&!C&B1&B&!A1&!A|F&E&D1&D&!C1&!C&B1&B&!A1&!A|F&E&!D1&D&!C1&!C&B1&B&!A1&!A|F&!E&!D1&D&!C1&!C&B1&B&!A1&!A|F&!E&!D1&D&C1&!C&B1&B&!A1&!A|F&E&!D1&D&C1&!C&B1&B&!A1&!A|F&E&D1&D&C1&!C&B1&B&!A1&!A|F&!E&D1&D&C1&!C&B1&B&!A1&!A|F&!E&D1&!D&C1&!C&B1&B&!A1&!A|F&E&D1&!D&C1&!C&B1&B&!A1&!A|F&E&!D1&!D&C1&!C&B1&B&!A1&!A|F&E&!D1&!D&C1&C&B1&B&!A1&!A|F&E&D1&!D&C1&C&B1&B&!A1&!A|F&!E&D1&!D&C1&C&B1&B&!A1&!A|F&!E&D1&D&C1&C&B1&B&!A1&!A|F&E&D1&D&C1&C&B1&B&!A1&!A|F&E&!D1&D&C1&C&B1&B&!A1&!A|F&!E&!D1&D&C1&C&B1&B&!A1&!A|F&!E&!D1&D&!C1&C&B1&B&!A1&!A|F&E&!D1&D&!C1&C&B1&B&!A1&!A|F&E&D1&D&!C1&C&B1&B&!A1&!A|F&!E&D1&D&!C1&C&B1&B&!A1&!A|F&!E&D1&!D&!C1&C&B1&B&!A1&!A|F&E&D1&!D&!C1&C&B1&B&!A1&!A|F&E&!D1&!D&!C1&C&B1&B&!A1&!A|F&E&!D1&!D&!C1&C&!B1&B&!A1&!A|F&E&D1&!D&!C1&C&!B1&B&!A1&!A|F&E&D1&D&!C1&C&!B1&B&!A1&!A|F&E&!D1&D&!C1&C&!B1&B&!A1&!A|F&!E&!D1&D&C1&C&!B1&B&!A1&!A|F&E&!D1&D&C1&C&!B1&B&!A1&!A|F&E&D1&D&C1&C&!B1&B&!A1&!A|F&!E&D1&D&C1&C&!B1&B&!A1&!A|F&!E&D1&!D&C1&C&!B1&B&!A1&!A|F&E&D1&!D&C1&C&!B1&B&!A1&!A|F&E&!D1&!D&C1&C&!B1&B&!A1&!A|F&E&!D1&!D&C1&!C&!B1&B&!A1&!A|F&E&D1&!D&C1&!C&!B1&B&!A1&!A|F&E&D1&D&C1&!C&!B1&B&!A1&!A|F&E&!D1&D&C1&!C&!B1&B&!A1&!A|F&E&!D1&D&!C1&!C&!B1&B&!A1&!A|F&E&D1&D&!C1&!C&!B1&B&!A1&!A|F&E&D1&!D&!C1&!C&!B1&B&!A1&!A|F&E&!D1&!D&!C1&!C&!B1&B&!A1&!A|F&E&!D1&!D&!C1&!C&!B1&B&A1&!A|F&E&D1&!D&!C1&!C&!B1&B&A1&!A|F&E&D1&D&!C1&!C&!B1&B&A1&!A|F&E&!D1&D&!C1&!C&!B1&B&A1&!A|F&E&!D1&D&C1&!C&!B1&B&A1&!A|F&E&D1&D&C1&!C&!B1&B&A1&!A|F&E&D1&!D&C1&!C&!B1&B&A1&!A|F&E&!D1&!D&C1&!C&!B1&B&A1&!A|F&E&!D1&!D&C1&C&!B1&B&A1&!A|F&E&D1&!D&C1&C&!B1&B&A1&!A|F&!E&D1&!D&C1&C&!B1&B&A1&!A|F&!E&D1&D&C1&C&!B1&B&A1&!A|F&E&D1&D&C1&C&!B1&B&A1&!A|F&E&!D1&D&C1&C&!B1&B&A1&!A|F&!E&!D1&D&C1&C&!B1&B&A1&!A|F&E&!D1&D&!C1&C&!B1&B&A1&!A|F&E&D1&D&!C1&C&!B1&B&A1&!A|F&E&D1&!D&!C1&C&!B1&B&A1&!A|F&E&!D1&!D&!C1&C&!B1&B&A1&!A|F&E&!D1&!D&!C1&C&B1&B&A1&!A|F&E&D1&!D&!C1&C&B1&B&A1&!A|F&!E&D1&!D&!C1&C&B1&B&A1&!A|F&!E&D1&D&!C1&C&B1&B&A1&!A|F&E&D1&D&!C1&C&B1&B&A1&!A|F&E&!D1&D&!C1&C&B1&B&A1&!A|F&!E&!D1&D&!C1&C&B1&B&A1&!A|F&!E&!D1&D&C1&C&B1&B&A1&!A|F&E&!D1&D&C1&C&B1&B&A1&!A|F&E&D1&D&C1&C&B1&B&A1&!A|F&!E&D1&D&C1&C&B1&B&A1&!A|F&!E&D1&!D&C1&C&B1&B&A1&!A|F&E&D1&!D&C1&C&B1&B&A1&!A|F&E&!D1&!D&C1&C&B1&B&A1&!A|F&E&!D1&!D&C1&!C&B1&B&A1&!A|F&E&D1&!D&C1&!C&B1&B&A1&!A|F&!E&D1&!D&C1&!C&B1&B&A1&!A|F&!E&D1&D&C1&!C&B1&B&A1&!A|F&E&D1&D&C1&!C&B1&B&A1&!A|F&E&!D1&D&C1&!C&B1&B&A1&!A|F&!E&!D1&D&C1&!C&B1&B&A1&!A|F&!E&!D1&D&!C1&!C&B1&B&A1&!A|F&E&!D1&D&!C1&!C&B1&B&A1&!A|F&E&D1&D&!C1&!C&B1&B&A1&!A|F&!E&D1&D&!C1&!C&B1&B&A1&!A|F&!E&D1&!D&!C1&!C&B1&B&A1&!A|F&E&D1&!D&!C1&!C&B1&B&A1&!A|F&E&!D1&!D&!C1&!C&B1&B&A1&!A|F&E&!D1&!D&!C1&!C&B1&!B&A1&!A|F&E&D1&!D&!C1&!C&B1&!B&A1&!A|F&E&D1&D&!C1&!C&B1&!B&A1&!A|F&E&!D1&D&!C1&!C&B1&!B&A1&!A|F&E&!D1&D&C1&!C&B1&!B&A1&!A|F&E&D1&D&C1&!C&B1&!B&A1&!A|F&E&D1&!D&C1&!C&B1&!B&A1&!A|F&E&!D1&!D&C1&!C&B1&!B&A1&!A|F&E&!D1&!D&C1&C&B1&!B&A1&!A|F&E&D1&!D&C1&C&B1&!B&A1&!A|F&!E&D1&!D&C1&C&B1&!B&A1&!A|F&!E&D1&D&C1&C&B1&!B&A1&!A|F&E&D1&D&C1&C&B1&!B&A1&!A|F&E&!D1&D&C1&C&B1&!B&A1&!A|F&!E&!D1&D&C1&C&B1&!B&A1&!A|F&E&!D1&D&!C1&C&B1&!B&A1&!A|F&E&D1&D&!C1&C&B1&!B&A1&!A|F&E&D1&!D&!C1&C&B1&!B&A1&!A|F&E&!D1&!D&!C1&C&B1&!B&A1&!A|F&E&!D1&!D&!C1&C&!B1&!B&A1&!A|F&E&D1&!D&!C1&C&!B1&!B&A1&!A|F&E&D1&D&!C1&C&!B1&!B&A1&!A|F&E&!D1&D&!C1&C&!B1&!B&A1&!A|F&!E&!D1&D&C1&C&!B1&!B&A1&!A|F&E&!D1&D&C1&C&!B1&!B&A1&!A|F&E&D1&D&C1&C&!B1&!B&A1&!A|F&!E&D1&D&C1&C&!B1&!B&A1&!A|F&!E&D1&!D&C1&C&!B1&!B&A1&!A|F&E&D1&!D&C1&C&!B1&!B&A1&!A|F&E&!D1&!D&C1&C&!B1&!B&A1&!A|F&E&!D1&!D&C1&!C&!B1&!B&A1&!A|F&E&D1&!D&C1&!C&!B1&!B&A1&!A|F&E&D1&D&C1&!C&!B1&!B&A1&!A|F&E&!D1&D&C1&!C&!B1&!B&A1&!A|F&E&!D1&D&!C1&!C&!B1&!B&A1&!A|F&E&D1&D&!C1&!C&!B1&!B&A1&!A|F&E&D1&!D&!C1&!C&!B1&!B&A1&!A|F&E&!D1&!D&!C1&!C&!B1&!B&A1&!A|F&E&!D1&!D&!C1&!C&!B1&!B&A1&A|F&E&D1&!D&!C1&!C&!B1&!B&A1&A|F&!E&D1&!D&!C1&!C&!B1&!B&A1&A|F&!E&D1&D&!C1&!C&!B1&!B&A1&A|F&E&D1&D&!C1&!C&!B1&!B&A1&A|F&E&!D1&D&!C1&!C&!B1&!B&A1&A|F&!E&!D1&D&!C1&!C&!B1&!B&A1&A|F&!E&!D1&D&C1&!C&!B1&!B&A1&A|F&E&!D1&D&C1&!C&!B1&!B&A1&A|F&E&D1&D&C1&!C&!B1&!B&A1&A|F&!E&D1&D&C1&!C&!B1&!B&A1&A|F&!E&D1&!D&C1&!C&!B1&!B&A1&A|F&E&D1&!D&C1&!C&!B1&!B&A1&A|F&E&!D1&!D&C1&!C&!B1&!B&A1&A|F&E&!D1&!D&C1&C&!B1&!B&A1&A|F&E&D1&!D&C1&C&!B1&!B&A1&A|F&!E&D1&!D&C1&C&!B1&!B&A1&A|F&!E&D1&D&C1&C&!B1&!B&A1&A|F&E&D1&D&C1&C&!B1&!B&A1&A|F&E&!D1&D&C1&C&!B1&!B&A1&A|F&!E&!D1&D&C1&C&!B1&!B&A1&A|F&!E&!D1&D&!C1&C&!B1&!B&A1&A|F&E&!D1&D&!C1&C&!B1&!B&A1&A|F&E&D1&D&!C1&C&!B1&!B&A1&A|F&!E&D1&D&!C1&C&!B1&!B&A1&A|F&!E&D1&!D&!C1&C&!B1&!B&A1&A|F&E&D1&!D&!C1&C&!B1&!B&A1&A|F&E&!D1&!D&!C1&C&!B1&!B&A1&A|F&E&!D1&!D&!C1&C&B1&!B&A1&A|F&E&D1&!D&!C1&C&B1&!B&A1&A|F&!E&D1&!D&!C1&C&B1&!B&A1&A|F&!E&D1&D&!C1&C&B1&!B&A1&A|F&E&D1&D&!C1&C&B1&!B&A1&A|F&E&!D1&D&!C1&C&B1&!B&A1&A|F&!E&!D1&D&!C1&C&B1&!B&A1&A|F&!E&!D1&D&C1&C&B1&!B&A1&A|F&E&!D1&D&C1&C&B1&!B&A1&A|F&E&D1&D&C1&C&B1&!B&A1&A|F&!E&D1&D&C1&C&B1&!B&A1&A|F&!E&D1&!D&C1&C&B1&!B&A1&A|F&E&D1&!D&C1&C&B1&!B&A1&A|F&E&!D1&!D&C1&C&B1&!B&A1&A|F&E&!D1&!D&C1&!C&B1&!B&A1&A|F&E&D1&!D&C1&!C&B1&!B&A1&A|F&!E&D1&!D&C1&!C&B1&!B&A1&A|F&!E&D1&D&C1&!C&B1&!B&A1&A|F&E&D1&D&C1&!C&B1&!B&A1&A|F&E&!D1&D&C1&!C&B1&!B&A1&A|F&!E&!D1&D&C1&!C&B1&!B&A1&A|F&!E&!D1&D&!C1&!C&B1&!B&A1&A|F&E&!D1&D&!C1&!C&B1&!B&A1&A|F&E&D1&D&!C1&!C&B1&!B&A1&A|F&!E&D1&D&!C1&!C&B1&!B&A1&A|F&!E&D1&!D&!C1&!C&B1&!B&A1&A|F&E&D1&!D&!C1&!C&B1&!B&A1&A|F&E&!D1&!D&!C1&!C&B1&!B&A1&A|F&E&!D1&!D&!C1&!C&B1&B&A1&A|F&E&D1&!D&!C1&!C&B1&B&A1&A|F&!E&D1&!D&!C1&!C&B1&B&A1&A|F&!E&D1&D&!C1&!C&B1&B&A1&A|F&E&D1&D&!C1&!C&B1&B&A1&A|F&E&!D1&D&!C1&!C&B1&B&A1&A|F&!E&!D1&D&!C1&!C&B1&B&A1&A|F&!E&!D1&D&C1&!C&B1&B&A1&A|F&E&!D1&D&C1&!C&B1&B&A1&A|F&E&D1&D&C1&!C&B1&B&A1&A|F&!E&D1&D&C1&!C&B1&B&A1&A|F&!E&D1&!D&C1&!C&B1&B&A1&A|F&E&D1&!D&C1&!C&B1&B&A1&A|F&E&!D1&!D&C1&!C&B1&B&A1&A|F&E&!D1&!D&C1&C&B1&B&A1&A|F&E&D1&!D&C1&C&B1&B&A1&A|F&!E&D1&!D&C1&C&B1&B&A1&A|F&!E&D1&D&C1&C&B1&B&A1&A|F&E&D1&D&C1&C&B1&B&A1&A|F&E&!D1&D&C1&C&B1&B&A1&A|F&!E&!D1&D&C1&C&B1&B&A1&A|F&!E&!D1&D&!C1&C&B1&B&A1&A|F&E&!D1&D&!C1&C&B1&B&A1&A|F&E&D1&D&!C1&C&B1&B&A1&A|F&!E&D1&D&!C1&C&B1&B&A1&A|F&!E&D1&!D&!C1&C&B1&B&A1&A|F&E&D1&!D&!C1&C&B1&B&A1&A|F&E&!D1&!D&!C1&C&B1&B&A1&A|F&E&!D1&!D&!C1&C&!B1&B&A1&A|F&E&D1&!D&!C1&C&!B1&B&A1&A|F&!E&D1&!D&!C1&C&!B1&B&A1&A|F&!E&D1&D&!C1&C&!B1&B&A1&A|F&E&D1&D&!C1&C&!B1&B&A1&A|F&E&!D1&D&!C1&C&!B1&B&A1&A|F&!E&!D1&D&!C1&C&!B1&B&A1&A|F&!E&!D1&D&C1&C&!B1&B&A1&A|F&E&!D1&D&C1&C&!B1&B&A1&A|F&E&D1&D&C1&C&!B1&B&A1&A|F&!E&D1&D&C1&C&!B1&B&A1&A|F&!E&D1&!D&C1&C&!B1&B&A1&A|F&E&D1&!D&C1&C&!B1&B&A1&A|F&E&!D1&!D&C1&C&!B1&B&A1&A|F&E&!D1&!D&C1&!C&!B1&B&A1&A|F&E&D1&!D&C1&!C&!B1&B&A1&A|F&!E&D1&!D&C1&!C&!B1&B&A1&A|F&!E&D1&D&C1&!C&!B1&B&A1&A|F&E&D1&D&C1&!C&!B1&B&A1&A|F&E&!D1&D&C1&!C&!B1&B&A1&A|F&!E&!D1&D&C1&!C&!B1&B&A1&A|F&!E&!D1&D&!C1&!C&!B1&B&A1&A|F&E&!D1&D&!C1&!C&!B1&B&A1&A|F&E&D1&D&!C1&!C&!B1&B&A1&A|F&!E&D1&D&!C1&!C&!B1&B&A1&A|F&!E&D1&!D&!C1&!C&!B1&B&A1&A|F&E&D1&!D&!C1&!C&!B1&B&A1&A|F&E&!D1&!D&!C1&!C&!B1&B&A1&A|F&E&!D1&!D&!C1&!C&!B1&B&!A1&A|F&E&D1&!D&!C1&!C&!B1&B&!A1&A|F&E&D1&D&!C1&!C&!B1&B&!A1&A|F&E&!D1&D&!C1&!C&!B1&B&!A1&A|F&E&!D1&D&C1&!C&!B1&B&!A1&A|F&E&D1&D&C1&!C&!B1&B&!A1&A|F&E&D1&!D&C1&!C&!B1&B&!A1&A|F&E&!D1&!D&C1&!C&!B1&B&!A1&A|F&E&!D1&!D&C1&C&!B1&B&!A1&A|F&E&D1&!D&C1&C&!B1&B&!A1&A|F&!E&D1&!D&C1&C&!B1&B&!A1&A|F&!E&D1&D&C1&C&!B1&B&!A1&A|F&E&D1&D&C1&C&!B1&B&!A1&A|F&E&!D1&D&C1&C&!B1&B&!A1&A|F&!E&!D1&D&C1&C&!B1&B&!A1&A|F&E&!D1&D&!C1&C&!B1&B&!A1&A|F&E&D1&D&!C1&C&!B1&B&!A1&A|F&E&D1&!D&!C1&C&!B1&B&!A1&A|F&E&!D1&!D&!C1&C&!B1&B&!A1&A|F&E&!D1&!D&!C1&C&B1&B&!A1&A|F&E&D1&!D&!C1&C&B1&B&!A1&A|F&!E&D1&!D&!C1&C&B1&B&!A1&A|F&!E&D1&D&!C1&C&B1&B&!A1&A|F&E&D1&D&!C1&C&B1&B&!A1&A|F&E&!D1&D&!C1&C&B1&B&!A1&A|F&!E&!D1&D&!C1&C&B1&B&!A1&A|F&!E&!D1&D&C1&C&B1&B&!A1&A|F&E&!D1&D&C1&C&B1&B&!A1&A|F&E&D1&D&C1&C&B1&B&!A1&A|F&!E&D1&D&C1&C&B1&B&!A1&A|F&!E&D1&!D&C1&C&B1&B&!A1&A|F&E&D1&!D&C1&C&B1&B&!A1&A|F&E&!D1&!D&C1&C&B1&B&!A1&A|F&E&!D1&!D&C1&!C&B1&B&!A1&A|F&E&D1&!D&C1&!C&B1&B&!A1&A|F&!E&D1&!D&C1&!C&B1&B&!A1&A|F&!E&D1&D&C1&!C&B1&B&!A1&A|F&E&D1&D&C1&!C&B1&B&!A1&A|F&E&!D1&D&C1&!C&B1&B&!A1&A|F&!E&!D1&D&C1&!C&B1&B&!A1&A|F&!E&!D1&D&!C1&!C&B1&B&!A1&A|F&E&!D1&D&!C1&!C&B1&B&!A1&A|F&E&D1&D&!C1&!C&B1&B&!A1&A|F&!E&D1&D&!C1&!C&B1&B&!A1&A|F&!E&D1&!D&!C1&!C&B1&B&!A1&A|F&E&D1&!D&!C1&!C&B1&B&!A1&A|F&E&!D1&!D&!C1&!C&B1&B&!A1&A|F&E&!D1&!D&!C1&!C&B1&!B&!A1&A|F&E&D1&!D&!C1&!C&B1&!B&!A1&A|F&E&D1&D&!C1&!C&B1&!B&!A1&A|F&E&!D1&D&!C1&!C&B1&!B&!A1&A|F&E&!D1&D&C1&!C&B1&!B&!A1&A|F&E&D1&D&C1&!C&B1&!B&!A1&A|F&E&D1&!D&C1&!C&B1&!B&!A1&A|F&E&!D1&!D&C1&!C&B1&!B&!A1&A|F&E&!D1&!D&C1&C&B1&!B&!A1&A|F&E&D1&!D&C1&C&B1&!B&!A1&A|F&!E&D1&!D&C1&C&B1&!B&!A1&A|F&!E&D1&D&C1&C&B1&!B&!A1&A|F&E&D1&D&C1&C&B1&!B&!A1&A|F&E&!D1&D&C1&C&B1&!B&!A1&A|F&!E&!D1&D&C1&C&B1&!B&!A1&A|F&E&!D1&D&!C1&C&B1&!B&!A1&A|F&E&D1&D&!C1&C&B1&!B&!A1&A|F&E&D1&!D&!C1&C&B1&!B&!A1&A|F&E&!D1&!D&!C1&C&B1&!B&!A1&A|F&E&!D1&!D&!C1&C&!B1&!B&!A1&A|F&E&D1&!D&!C1&C&!B1&!B&!A1&A|F&E&D1&D&!C1&C&!B1&!B&!A1&A|F&E&!D1&D&!C1&C&!B1&!B&!A1&A|F&!E&!D1&D&C1&C&!B1&!B&!A1&A|F&E&!D1&D&C1&C&!B1&!B&!A1&A|F&E&D1&D&C1&C&!B1&!B&!A1&A|F&!E&D1&D&C1&C&!B1&!B&!A1&A|F&!E&D1&!D&C1&C&!B1&!B&!A1&A|F&E&D1&!D&C1&C&!B1&!B&!A1&A|F&E&!D1&!D&C1&C&!B1&!B&!A1&A|F&E&!D1&!D&C1&!C&!B1&!B&!A1&A|F&E&D1&!D&C1&!C&!B1&!B&!A1&A|F&E&D1&D&C1&!C&!B1&!B&!A1&A|F&E&!D1&D&C1&!C&!B1&!B&!A1&A|F&E&!D1&D&!C1&!C&!B1&!B&!A1&A|F&E&D1&D&!C1&!C&!B1&!B&!A1&A|F&E&D1&!D&!C1&!C&!B1&!B&!A1&A|F&E&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOOAOAI222211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAOI33211 -l OOOAOI33211 -i E D C1 C B2 B1 B A2 A1 A -o Y -f Y=(!E&!D&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&D&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&D&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&D&C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&D&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&!C1&C&B2&!B1&!B&!A2&!A1&!A|!E&D&!C1&C&B2&!B1&!B&!A2&!A1&!A|!E&D&C1&C&B2&!B1&!B&!A2&!A1&!A|!E&!D&C1&C&B2&!B1&!B&!A2&!A1&!A|!E&!D&C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&D&C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&D&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&!D&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&!D&!C1&!C&B2&B1&!B&!A2&!A1&!A|!E&D&!C1&!C&B2&B1&!B&!A2&!A1&!A|!E&D&C1&!C&B2&B1&!B&!A2&!A1&!A|!E&!D&C1&!C&B2&B1&!B&!A2&!A1&!A|!E&!D&C1&C&B2&B1&!B&!A2&!A1&!A|!E&D&C1&C&B2&B1&!B&!A2&!A1&!A|!E&D&!C1&C&B2&B1&!B&!A2&!A1&!A|!E&!D&!C1&C&B2&B1&!B&!A2&!A1&!A|!E&!D&!C1&C&!B2&B1&!B&!A2&!A1&!A|!E&D&!C1&C&!B2&B1&!B&!A2&!A1&!A|!E&D&C1&C&!B2&B1&!B&!A2&!A1&!A|!E&!D&C1&C&!B2&B1&!B&!A2&!A1&!A|!E&!D&C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&D&C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&D&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&!D&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&!D&!C1&!C&!B2&B1&B&!A2&!A1&!A|!E&D&!C1&!C&!B2&B1&B&!A2&!A1&!A|!E&D&C1&!C&!B2&B1&B&!A2&!A1&!A|!E&!D&C1&!C&!B2&B1&B&!A2&!A1&!A|!E&!D&C1&C&!B2&B1&B&!A2&!A1&!A|!E&D&C1&C&!B2&B1&B&!A2&!A1&!A|!E&D&!C1&C&!B2&B1&B&!A2&!A1&!A|!E&!D&!C1&C&!B2&B1&B&!A2&!A1&!A|!E&!D&!C1&C&B2&B1&B&!A2&!A1&!A|!E&D&!C1&C&B2&B1&B&!A2&!A1&!A|!E&D&C1&C&B2&B1&B&!A2&!A1&!A|!E&!D&C1&C&B2&B1&B&!A2&!A1&!A|!E&!D&C1&!C&B2&B1&B&!A2&!A1&!A|!E&D&C1&!C&B2&B1&B&!A2&!A1&!A|!E&D&!C1&!C&B2&B1&B&!A2&!A1&!A|!E&!D&!C1&!C&B2&B1&B&!A2&!A1&!A|!E&!D&!C1&!C&B2&!B1&B&!A2&!A1&!A|!E&D&!C1&!C&B2&!B1&B&!A2&!A1&!A|!E&D&C1&!C&B2&!B1&B&!A2&!A1&!A|!E&!D&C1&!C&B2&!B1&B&!A2&!A1&!A|!E&!D&C1&C&B2&!B1&B&!A2&!A1&!A|!E&D&C1&C&B2&!B1&B&!A2&!A1&!A|!E&D&!C1&C&B2&!B1&B&!A2&!A1&!A|!E&!D&!C1&C&B2&!B1&B&!A2&!A1&!A|!E&!D&!C1&C&!B2&!B1&B&!A2&!A1&!A|!E&D&!C1&C&!B2&!B1&B&!A2&!A1&!A|!E&D&C1&C&!B2&!B1&B&!A2&!A1&!A|!E&!D&C1&C&!B2&!B1&B&!A2&!A1&!A|!E&!D&C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&D&C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&D&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&!D&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&!D&!C1&!C&!B2&!B1&B&A2&!A1&!A|!E&D&!C1&!C&!B2&!B1&B&A2&!A1&!A|!E&!D&C1&!C&!B2&!B1&B&A2&!A1&!A|!E&!D&C1&C&!B2&!B1&B&A2&!A1&!A|!E&!D&!C1&C&!B2&!B1&B&A2&!A1&!A|!E&!D&!C1&C&B2&!B1&B&A2&!A1&!A|!E&!D&C1&C&B2&!B1&B&A2&!A1&!A|!E&!D&C1&!C&B2&!B1&B&A2&!A1&!A|!E&D&!C1&!C&B2&!B1&B&A2&!A1&!A|!E&!D&!C1&!C&B2&!B1&B&A2&!A1&!A|!E&!D&!C1&!C&B2&B1&B&A2&!A1&!A|!E&D&!C1&!C&B2&B1&B&A2&!A1&!A|!E&!D&C1&!C&B2&B1&B&A2&!A1&!A|!E&!D&C1&C&B2&B1&B&A2&!A1&!A|!E&!D&!C1&C&B2&B1&B&A2&!A1&!A|!E&!D&!C1&C&!B2&B1&B&A2&!A1&!A|!E&!D&C1&C&!B2&B1&B&A2&!A1&!A|!E&!D&C1&!C&!B2&B1&B&A2&!A1&!A|!E&D&!C1&!C&!B2&B1&B&A2&!A1&!A|!E&!D&!C1&!C&!B2&B1&B&A2&!A1&!A|!E&!D&!C1&!C&!B2&B1&!B&A2&!A1&!A|!E&D&!C1&!C&!B2&B1&!B&A2&!A1&!A|!E&!D&C1&!C&!B2&B1&!B&A2&!A1&!A|!E&!D&C1&C&!B2&B1&!B&A2&!A1&!A|!E&!D&!C1&C&!B2&B1&!B&A2&!A1&!A|!E&!D&!C1&C&B2&B1&!B&A2&!A1&!A|!E&!D&C1&C&B2&B1&!B&A2&!A1&!A|!E&!D&C1&!C&B2&B1&!B&A2&!A1&!A|!E&D&!C1&!C&B2&B1&!B&A2&!A1&!A|!E&!D&!C1&!C&B2&B1&!B&A2&!A1&!A|!E&!D&!C1&!C&B2&!B1&!B&A2&!A1&!A|!E&D&!C1&!C&B2&!B1&!B&A2&!A1&!A|!E&!D&C1&!C&B2&!B1&!B&A2&!A1&!A|!E&!D&C1&C&B2&!B1&!B&A2&!A1&!A|!E&!D&!C1&C&B2&!B1&!B&A2&!A1&!A|!E&!D&!C1&C&!B2&!B1&!B&A2&!A1&!A|!E&D&!C1&C&!B2&!B1&!B&A2&!A1&!A|!E&D&C1&C&!B2&!B1&!B&A2&!A1&!A|!E&!D&C1&C&!B2&!B1&!B&A2&!A1&!A|!E&!D&C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&D&C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&D&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&!D&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&!D&!C1&!C&!B2&!B1&!B&A2&A1&!A|!E&D&!C1&!C&!B2&!B1&!B&A2&A1&!A|!E&D&C1&!C&!B2&!B1&!B&A2&A1&!A|!E&!D&C1&!C&!B2&!B1&!B&A2&A1&!A|!E&!D&C1&C&!B2&!B1&!B&A2&A1&!A|!E&D&C1&C&!B2&!B1&!B&A2&A1&!A|!E&D&!C1&C&!B2&!B1&!B&A2&A1&!A|!E&!D&!C1&C&!B2&!B1&!B&A2&A1&!A|!E&!D&!C1&C&B2&!B1&!B&A2&A1&!A|!E&!D&C1&C&B2&!B1&!B&A2&A1&!A|!E&!D&C1&!C&B2&!B1&!B&A2&A1&!A|!E&D&!C1&!C&B2&!B1&!B&A2&A1&!A|!E&!D&!C1&!C&B2&!B1&!B&A2&A1&!A|!E&!D&!C1&!C&B2&B1&!B&A2&A1&!A|!E&D&!C1&!C&B2&B1&!B&A2&A1&!A|!E&!D&C1&!C&B2&B1&!B&A2&A1&!A|!E&!D&C1&C&B2&B1&!B&A2&A1&!A|!E&!D&!C1&C&B2&B1&!B&A2&A1&!A|!E&!D&!C1&C&!B2&B1&!B&A2&A1&!A|!E&!D&C1&C&!B2&B1&!B&A2&A1&!A|!E&!D&C1&!C&!B2&B1&!B&A2&A1&!A|!E&D&!C1&!C&!B2&B1&!B&A2&A1&!A|!E&!D&!C1&!C&!B2&B1&!B&A2&A1&!A|!E&!D&!C1&!C&!B2&B1&B&A2&A1&!A|!E&D&!C1&!C&!B2&B1&B&A2&A1&!A|!E&!D&C1&!C&!B2&B1&B&A2&A1&!A|!E&!D&C1&C&!B2&B1&B&A2&A1&!A|!E&!D&!C1&C&!B2&B1&B&A2&A1&!A|!E&!D&!C1&C&B2&B1&B&A2&A1&!A|!E&!D&C1&C&B2&B1&B&A2&A1&!A|!E&!D&C1&!C&B2&B1&B&A2&A1&!A|!E&D&!C1&!C&B2&B1&B&A2&A1&!A|!E&!D&!C1&!C&B2&B1&B&A2&A1&!A|!E&!D&!C1&!C&B2&!B1&B&A2&A1&!A|!E&D&!C1&!C&B2&!B1&B&A2&A1&!A|!E&!D&C1&!C&B2&!B1&B&A2&A1&!A|!E&!D&C1&C&B2&!B1&B&A2&A1&!A|!E&!D&!C1&C&B2&!B1&B&A2&A1&!A|!E&!D&!C1&C&!B2&!B1&B&A2&A1&!A|!E&!D&C1&C&!B2&!B1&B&A2&A1&!A|!E&!D&C1&!C&!B2&!B1&B&A2&A1&!A|!E&D&!C1&!C&!B2&!B1&B&A2&A1&!A|!E&!D&!C1&!C&!B2&!B1&B&A2&A1&!A|!E&!D&!C1&!C&!B2&!B1&B&!A2&A1&!A|!E&D&!C1&!C&!B2&!B1&B&!A2&A1&!A|!E&!D&C1&!C&!B2&!B1&B&!A2&A1&!A|!E&!D&C1&C&!B2&!B1&B&!A2&A1&!A|!E&!D&!C1&C&!B2&!B1&B&!A2&A1&!A|!E&!D&!C1&C&B2&!B1&B&!A2&A1&!A|!E&!D&C1&C&B2&!B1&B&!A2&A1&!A|!E&!D&C1&!C&B2&!B1&B&!A2&A1&!A|!E&D&!C1&!C&B2&!B1&B&!A2&A1&!A|!E&!D&!C1&!C&B2&!B1&B&!A2&A1&!A|!E&!D&!C1&!C&B2&B1&B&!A2&A1&!A|!E&D&!C1&!C&B2&B1&B&!A2&A1&!A|!E&!D&C1&!C&B2&B1&B&!A2&A1&!A|!E&!D&C1&C&B2&B1&B&!A2&A1&!A|!E&!D&!C1&C&B2&B1&B&!A2&A1&!A|!E&!D&!C1&C&!B2&B1&B&!A2&A1&!A|!E&!D&C1&C&!B2&B1&B&!A2&A1&!A|!E&!D&C1&!C&!B2&B1&B&!A2&A1&!A|!E&D&!C1&!C&!B2&B1&B&!A2&A1&!A|!E&!D&!C1&!C&!B2&B1&B&!A2&A1&!A|!E&!D&!C1&!C&!B2&B1&!B&!A2&A1&!A|!E&D&!C1&!C&!B2&B1&!B&!A2&A1&!A|!E&!D&C1&!C&!B2&B1&!B&!A2&A1&!A|!E&!D&C1&C&!B2&B1&!B&!A2&A1&!A|!E&!D&!C1&C&!B2&B1&!B&!A2&A1&!A|!E&!D&!C1&C&B2&B1&!B&!A2&A1&!A|!E&!D&C1&C&B2&B1&!B&!A2&A1&!A|!E&!D&C1&!C&B2&B1&!B&!A2&A1&!A|!E&D&!C1&!C&B2&B1&!B&!A2&A1&!A|!E&!D&!C1&!C&B2&B1&!B&!A2&A1&!A|!E&!D&!C1&!C&B2&!B1&!B&!A2&A1&!A|!E&D&!C1&!C&B2&!B1&!B&!A2&A1&!A|!E&!D&C1&!C&B2&!B1&!B&!A2&A1&!A|!E&!D&C1&C&B2&!B1&!B&!A2&A1&!A|!E&!D&!C1&C&B2&!B1&!B&!A2&A1&!A|!E&!D&!C1&C&!B2&!B1&!B&!A2&A1&!A|!E&D&!C1&C&!B2&!B1&!B&!A2&A1&!A|!E&D&C1&C&!B2&!B1&!B&!A2&A1&!A|!E&!D&C1&C&!B2&!B1&!B&!A2&A1&!A|!E&!D&C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&D&C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&D&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&!D&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&!D&!C1&!C&!B2&!B1&!B&!A2&A1&A|!E&D&!C1&!C&!B2&!B1&!B&!A2&A1&A|!E&D&C1&!C&!B2&!B1&!B&!A2&A1&A|!E&!D&C1&!C&!B2&!B1&!B&!A2&A1&A|!E&!D&C1&C&!B2&!B1&!B&!A2&A1&A|!E&D&C1&C&!B2&!B1&!B&!A2&A1&A|!E&D&!C1&C&!B2&!B1&!B&!A2&A1&A|!E&!D&!C1&C&!B2&!B1&!B&!A2&A1&A|!E&!D&!C1&C&B2&!B1&!B&!A2&A1&A|!E&!D&C1&C&B2&!B1&!B&!A2&A1&A|!E&!D&C1&!C&B2&!B1&!B&!A2&A1&A|!E&D&!C1&!C&B2&!B1&!B&!A2&A1&A|!E&!D&!C1&!C&B2&!B1&!B&!A2&A1&A|!E&!D&!C1&!C&B2&B1&!B&!A2&A1&A|!E&D&!C1&!C&B2&B1&!B&!A2&A1&A|!E&!D&C1&!C&B2&B1&!B&!A2&A1&A|!E&!D&C1&C&B2&B1&!B&!A2&A1&A|!E&!D&!C1&C&B2&B1&!B&!A2&A1&A|!E&!D&!C1&C&!B2&B1&!B&!A2&A1&A|!E&!D&C1&C&!B2&B1&!B&!A2&A1&A|!E&!D&C1&!C&!B2&B1&!B&!A2&A1&A|!E&D&!C1&!C&!B2&B1&!B&!A2&A1&A|!E&!D&!C1&!C&!B2&B1&!B&!A2&A1&A|!E&!D&!C1&!C&!B2&B1&B&!A2&A1&A|!E&D&!C1&!C&!B2&B1&B&!A2&A1&A|!E&!D&C1&!C&!B2&B1&B&!A2&A1&A|!E&!D&C1&C&!B2&B1&B&!A2&A1&A|!E&!D&!C1&C&!B2&B1&B&!A2&A1&A|!E&!D&!C1&C&B2&B1&B&!A2&A1&A|!E&!D&C1&C&B2&B1&B&!A2&A1&A|!E&!D&C1&!C&B2&B1&B&!A2&A1&A|!E&D&!C1&!C&B2&B1&B&!A2&A1&A|!E&!D&!C1&!C&B2&B1&B&!A2&A1&A|!E&!D&!C1&!C&B2&!B1&B&!A2&A1&A|!E&D&!C1&!C&B2&!B1&B&!A2&A1&A|!E&!D&C1&!C&B2&!B1&B&!A2&A1&A|!E&!D&C1&C&B2&!B1&B&!A2&A1&A|!E&!D&!C1&C&B2&!B1&B&!A2&A1&A|!E&!D&!C1&C&!B2&!B1&B&!A2&A1&A|!E&!D&C1&C&!B2&!B1&B&!A2&A1&A|!E&!D&C1&!C&!B2&!B1&B&!A2&A1&A|!E&D&!C1&!C&!B2&!B1&B&!A2&A1&A|!E&!D&!C1&!C&!B2&!B1&B&!A2&A1&A|!E&!D&!C1&!C&!B2&!B1&B&A2&A1&A|!E&D&!C1&!C&!B2&!B1&B&A2&A1&A|!E&!D&C1&!C&!B2&!B1&B&A2&A1&A|!E&!D&C1&C&!B2&!B1&B&A2&A1&A|!E&!D&!C1&C&!B2&!B1&B&A2&A1&A|!E&!D&!C1&C&B2&!B1&B&A2&A1&A|!E&!D&C1&C&B2&!B1&B&A2&A1&A|!E&!D&C1&!C&B2&!B1&B&A2&A1&A|!E&D&!C1&!C&B2&!B1&B&A2&A1&A|!E&!D&!C1&!C&B2&!B1&B&A2&A1&A|!E&!D&!C1&!C&B2&B1&B&A2&A1&A|!E&D&!C1&!C&B2&B1&B&A2&A1&A|!E&!D&C1&!C&B2&B1&B&A2&A1&A|!E&!D&C1&C&B2&B1&B&A2&A1&A|!E&!D&!C1&C&B2&B1&B&A2&A1&A|!E&!D&!C1&C&!B2&B1&B&A2&A1&A|!E&!D&C1&C&!B2&B1&B&A2&A1&A|!E&!D&C1&!C&!B2&B1&B&A2&A1&A|!E&D&!C1&!C&!B2&B1&B&A2&A1&A|!E&!D&!C1&!C&!B2&B1&B&A2&A1&A|!E&!D&!C1&!C&!B2&B1&!B&A2&A1&A|!E&D&!C1&!C&!B2&B1&!B&A2&A1&A|!E&!D&C1&!C&!B2&B1&!B&A2&A1&A|!E&!D&C1&C&!B2&B1&!B&A2&A1&A|!E&!D&!C1&C&!B2&B1&!B&A2&A1&A|!E&!D&!C1&C&B2&B1&!B&A2&A1&A|!E&!D&C1&C&B2&B1&!B&A2&A1&A|!E&!D&C1&!C&B2&B1&!B&A2&A1&A|!E&D&!C1&!C&B2&B1&!B&A2&A1&A|!E&!D&!C1&!C&B2&B1&!B&A2&A1&A|!E&!D&!C1&!C&B2&!B1&!B&A2&A1&A|!E&D&!C1&!C&B2&!B1&!B&A2&A1&A|!E&!D&C1&!C&B2&!B1&!B&A2&A1&A|!E&!D&C1&C&B2&!B1&!B&A2&A1&A|!E&!D&!C1&C&B2&!B1&!B&A2&A1&A|!E&!D&!C1&C&!B2&!B1&!B&A2&A1&A|!E&D&!C1&C&!B2&!B1&!B&A2&A1&A|!E&D&C1&C&!B2&!B1&!B&A2&A1&A|!E&!D&C1&C&!B2&!B1&!B&A2&A1&A|!E&!D&C1&!C&!B2&!B1&!B&A2&A1&A|!E&D&C1&!C&!B2&!B1&!B&A2&A1&A|!E&D&!C1&!C&!B2&!B1&!B&A2&A1&A|!E&!D&!C1&!C&!B2&!B1&!B&A2&A1&A|!E&!D&!C1&!C&!B2&!B1&!B&A2&!A1&A|!E&D&!C1&!C&!B2&!B1&!B&A2&!A1&A|!E&D&C1&!C&!B2&!B1&!B&A2&!A1&A|!E&!D&C1&!C&!B2&!B1&!B&A2&!A1&A|!E&!D&C1&C&!B2&!B1&!B&A2&!A1&A|!E&D&C1&C&!B2&!B1&!B&A2&!A1&A|!E&D&!C1&C&!B2&!B1&!B&A2&!A1&A|!E&!D&!C1&C&!B2&!B1&!B&A2&!A1&A|!E&!D&!C1&C&B2&!B1&!B&A2&!A1&A|!E&!D&C1&C&B2&!B1&!B&A2&!A1&A|!E&!D&C1&!C&B2&!B1&!B&A2&!A1&A|!E&D&!C1&!C&B2&!B1&!B&A2&!A1&A|!E&!D&!C1&!C&B2&!B1&!B&A2&!A1&A|!E&!D&!C1&!C&B2&B1&!B&A2&!A1&A|!E&D&!C1&!C&B2&B1&!B&A2&!A1&A|!E&!D&C1&!C&B2&B1&!B&A2&!A1&A|!E&!D&C1&C&B2&B1&!B&A2&!A1&A|!E&!D&!C1&C&B2&B1&!B&A2&!A1&A|!E&!D&!C1&C&!B2&B1&!B&A2&!A1&A|!E&!D&C1&C&!B2&B1&!B&A2&!A1&A|!E&!D&C1&!C&!B2&B1&!B&A2&!A1&A|!E&D&!C1&!C&!B2&B1&!B&A2&!A1&A|!E&!D&!C1&!C&!B2&B1&!B&A2&!A1&A|!E&!D&!C1&!C&!B2&B1&B&A2&!A1&A|!E&D&!C1&!C&!B2&B1&B&A2&!A1&A|!E&!D&C1&!C&!B2&B1&B&A2&!A1&A|!E&!D&C1&C&!B2&B1&B&A2&!A1&A|!E&!D&!C1&C&!B2&B1&B&A2&!A1&A|!E&!D&!C1&C&B2&B1&B&A2&!A1&A|!E&!D&C1&C&B2&B1&B&A2&!A1&A|!E&!D&C1&!C&B2&B1&B&A2&!A1&A|!E&D&!C1&!C&B2&B1&B&A2&!A1&A|!E&!D&!C1&!C&B2&B1&B&A2&!A1&A|!E&!D&!C1&!C&B2&!B1&B&A2&!A1&A|!E&D&!C1&!C&B2&!B1&B&A2&!A1&A|!E&!D&C1&!C&B2&!B1&B&A2&!A1&A|!E&!D&C1&C&B2&!B1&B&A2&!A1&A|!E&!D&!C1&C&B2&!B1&B&A2&!A1&A|!E&!D&!C1&C&!B2&!B1&B&A2&!A1&A|!E&!D&C1&C&!B2&!B1&B&A2&!A1&A|!E&!D&C1&!C&!B2&!B1&B&A2&!A1&A|!E&D&!C1&!C&!B2&!B1&B&A2&!A1&A|!E&!D&!C1&!C&!B2&!B1&B&A2&!A1&A|!E&!D&!C1&!C&!B2&!B1&B&!A2&!A1&A|!E&D&!C1&!C&!B2&!B1&B&!A2&!A1&A|!E&!D&C1&!C&!B2&!B1&B&!A2&!A1&A|!E&!D&C1&C&!B2&!B1&B&!A2&!A1&A|!E&!D&!C1&C&!B2&!B1&B&!A2&!A1&A|!E&!D&!C1&C&B2&!B1&B&!A2&!A1&A|!E&!D&C1&C&B2&!B1&B&!A2&!A1&A|!E&!D&C1&!C&B2&!B1&B&!A2&!A1&A|!E&D&!C1&!C&B2&!B1&B&!A2&!A1&A|!E&!D&!C1&!C&B2&!B1&B&!A2&!A1&A|!E&!D&!C1&!C&B2&B1&B&!A2&!A1&A|!E&D&!C1&!C&B2&B1&B&!A2&!A1&A|!E&!D&C1&!C&B2&B1&B&!A2&!A1&A|!E&!D&C1&C&B2&B1&B&!A2&!A1&A|!E&!D&!C1&C&B2&B1&B&!A2&!A1&A|!E&!D&!C1&C&!B2&B1&B&!A2&!A1&A|!E&!D&C1&C&!B2&B1&B&!A2&!A1&A|!E&!D&C1&!C&!B2&B1&B&!A2&!A1&A|!E&D&!C1&!C&!B2&B1&B&!A2&!A1&A|!E&!D&!C1&!C&!B2&B1&B&!A2&!A1&A|!E&!D&!C1&!C&!B2&B1&!B&!A2&!A1&A|!E&D&!C1&!C&!B2&B1&!B&!A2&!A1&A|!E&!D&C1&!C&!B2&B1&!B&!A2&!A1&A|!E&!D&C1&C&!B2&B1&!B&!A2&!A1&A|!E&!D&!C1&C&!B2&B1&!B&!A2&!A1&A|!E&!D&!C1&C&B2&B1&!B&!A2&!A1&A|!E&!D&C1&C&B2&B1&!B&!A2&!A1&A|!E&!D&C1&!C&B2&B1&!B&!A2&!A1&A|!E&D&!C1&!C&B2&B1&!B&!A2&!A1&A|!E&!D&!C1&!C&B2&B1&!B&!A2&!A1&A|!E&!D&!C1&!C&B2&!B1&!B&!A2&!A1&A|!E&D&!C1&!C&B2&!B1&!B&!A2&!A1&A|!E&!D&C1&!C&B2&!B1&!B&!A2&!A1&A|!E&!D&C1&C&B2&!B1&!B&!A2&!A1&A|!E&!D&!C1&C&B2&!B1&!B&!A2&!A1&A|!E&!D&!C1&C&!B2&!B1&!B&!A2&!A1&A|!E&D&!C1&C&!B2&!B1&!B&!A2&!A1&A|!E&D&C1&C&!B2&!B1&!B&!A2&!A1&A|!E&!D&C1&C&!B2&!B1&!B&!A2&!A1&A|!E&!D&C1&!C&!B2&!B1&!B&!A2&!A1&A|!E&D&C1&!C&!B2&!B1&!B&!A2&!A1&A|!E&D&!C1&!C&!B2&!B1&!B&!A2&!A1&A|!E&!D&!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAOI33211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOAI22212 -l AAAOAI22212 -i E1 E D C1 C B1 B A1 A -o Y -f Y=!(E1&E&D&!C1&!C&!B1&!B&!A1&!A|E1&E&D&C1&!C&!B1&!B&!A1&!A|E1&E&!D&C1&C&!B1&!B&!A1&!A|E1&E&D&C1&C&!B1&!B&!A1&!A|E1&E&D&!C1&C&!B1&!B&!A1&!A|E1&E&D&!C1&C&B1&!B&!A1&!A|E1&E&D&C1&C&B1&!B&!A1&!A|E1&E&!D&C1&C&B1&!B&!A1&!A|E1&E&D&C1&!C&B1&!B&!A1&!A|E1&E&D&!C1&!C&B1&!B&!A1&!A|E1&E&!D&!C1&!C&B1&B&!A1&!A|E1&E&D&!C1&!C&B1&B&!A1&!A|E1&E&D&C1&!C&B1&B&!A1&!A|E1&E&!D&C1&!C&B1&B&!A1&!A|E1&E&!D&C1&C&B1&B&!A1&!A|E1&E&D&C1&C&B1&B&!A1&!A|E1&E&D&!C1&C&B1&B&!A1&!A|E1&E&!D&!C1&C&B1&B&!A1&!A|E1&E&D&!C1&C&!B1&B&!A1&!A|E1&E&D&C1&C&!B1&B&!A1&!A|E1&E&!D&C1&C&!B1&B&!A1&!A|E1&E&D&C1&!C&!B1&B&!A1&!A|E1&E&D&!C1&!C&!B1&B&!A1&!A|E1&E&D&!C1&!C&!B1&B&A1&!A|E1&E&D&C1&!C&!B1&B&A1&!A|E1&E&!D&C1&C&!B1&B&A1&!A|E1&E&D&C1&C&!B1&B&A1&!A|E1&E&D&!C1&C&!B1&B&A1&!A|E1&E&!D&!C1&C&B1&B&A1&!A|E1&E&D&!C1&C&B1&B&A1&!A|E1&E&D&C1&C&B1&B&A1&!A|E1&E&!D&C1&C&B1&B&A1&!A|E1&E&!D&C1&!C&B1&B&A1&!A|E1&E&D&C1&!C&B1&B&A1&!A|E1&E&D&!C1&!C&B1&B&A1&!A|E1&E&!D&!C1&!C&B1&B&A1&!A|E1&E&D&!C1&!C&B1&!B&A1&!A|E1&E&D&C1&!C&B1&!B&A1&!A|E1&E&!D&C1&C&B1&!B&A1&!A|E1&E&D&C1&C&B1&!B&A1&!A|E1&E&D&!C1&C&B1&!B&A1&!A|E1&E&D&!C1&C&!B1&!B&A1&!A|E1&E&D&C1&C&!B1&!B&A1&!A|E1&E&!D&C1&C&!B1&!B&A1&!A|E1&E&D&C1&!C&!B1&!B&A1&!A|E1&E&D&!C1&!C&!B1&!B&A1&!A|E1&E&!D&!C1&!C&!B1&!B&A1&A|E1&E&D&!C1&!C&!B1&!B&A1&A|E1&E&D&C1&!C&!B1&!B&A1&A|E1&E&!D&C1&!C&!B1&!B&A1&A|E1&E&!D&C1&C&!B1&!B&A1&A|E1&E&D&C1&C&!B1&!B&A1&A|E1&E&D&!C1&C&!B1&!B&A1&A|E1&E&!D&!C1&C&!B1&!B&A1&A|E1&E&!D&!C1&C&B1&!B&A1&A|E1&E&D&!C1&C&B1&!B&A1&A|E1&E&D&C1&C&B1&!B&A1&A|E1&E&!D&C1&C&B1&!B&A1&A|E1&E&!D&C1&!C&B1&!B&A1&A|E1&E&D&C1&!C&B1&!B&A1&A|E1&E&D&!C1&!C&B1&!B&A1&A|E1&E&!D&!C1&!C&B1&!B&A1&A|E1&E&!D&!C1&!C&B1&B&A1&A|E1&E&D&!C1&!C&B1&B&A1&A|E1&E&D&C1&!C&B1&B&A1&A|E1&E&!D&C1&!C&B1&B&A1&A|E1&E&!D&C1&C&B1&B&A1&A|E1&E&D&C1&C&B1&B&A1&A|E1&E&D&!C1&C&B1&B&A1&A|E1&E&!D&!C1&C&B1&B&A1&A|E1&E&!D&!C1&C&!B1&B&A1&A|E1&E&D&!C1&C&!B1&B&A1&A|E1&E&D&C1&C&!B1&B&A1&A|E1&E&!D&C1&C&!B1&B&A1&A|E1&E&!D&C1&!C&!B1&B&A1&A|E1&E&D&C1&!C&!B1&B&A1&A|E1&E&D&!C1&!C&!B1&B&A1&A|E1&E&!D&!C1&!C&!B1&B&A1&A|E1&E&D&!C1&!C&!B1&B&!A1&A|E1&E&D&C1&!C&!B1&B&!A1&A|E1&E&!D&C1&C&!B1&B&!A1&A|E1&E&D&C1&C&!B1&B&!A1&A|E1&E&D&!C1&C&!B1&B&!A1&A|E1&E&!D&!C1&C&B1&B&!A1&A|E1&E&D&!C1&C&B1&B&!A1&A|E1&E&D&C1&C&B1&B&!A1&A|E1&E&!D&C1&C&B1&B&!A1&A|E1&E&!D&C1&!C&B1&B&!A1&A|E1&E&D&C1&!C&B1&B&!A1&A|E1&E&D&!C1&!C&B1&B&!A1&A|E1&E&!D&!C1&!C&B1&B&!A1&A|E1&E&D&!C1&!C&B1&!B&!A1&A|E1&E&D&C1&!C&B1&!B&!A1&A|E1&E&!D&C1&C&B1&!B&!A1&A|E1&E&D&C1&C&B1&!B&!A1&A|E1&E&D&!C1&C&B1&!B&!A1&A|E1&E&D&!C1&C&!B1&!B&!A1&A|E1&E&D&C1&C&!B1&!B&!A1&A|E1&E&!D&C1&C&!B1&!B&!A1&A|E1&E&D&C1&!C&!B1&!B&!A1&A|E1&E&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOAI22212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOAI22211 -l AOOAOAI22211 -i E D C1 C B1 B A1 A -o Y -f Y=!(E&D&!C1&!C&!B1&!B&!A1&!A|E&D&C1&!C&!B1&!B&!A1&!A|E&D&C1&C&!B1&!B&!A1&!A|E&D&!C1&C&!B1&!B&!A1&!A|E&!D&!C1&C&B1&!B&!A1&!A|E&D&!C1&C&B1&!B&!A1&!A|E&D&C1&C&B1&!B&!A1&!A|E&!D&C1&C&B1&!B&!A1&!A|E&!D&C1&!C&B1&!B&!A1&!A|E&D&C1&!C&B1&!B&!A1&!A|E&D&!C1&!C&B1&!B&!A1&!A|E&D&!C1&!C&B1&B&!A1&!A|E&D&C1&!C&B1&B&!A1&!A|E&!D&C1&!C&B1&B&!A1&!A|E&!D&C1&C&B1&B&!A1&!A|E&D&C1&C&B1&B&!A1&!A|E&D&!C1&C&B1&B&!A1&!A|E&!D&!C1&C&B1&B&!A1&!A|E&!D&!C1&C&!B1&B&!A1&!A|E&D&!C1&C&!B1&B&!A1&!A|E&D&C1&C&!B1&B&!A1&!A|E&!D&C1&C&!B1&B&!A1&!A|E&!D&C1&!C&!B1&B&!A1&!A|E&D&C1&!C&!B1&B&!A1&!A|E&D&!C1&!C&!B1&B&!A1&!A|E&D&!C1&!C&!B1&B&A1&!A|E&D&C1&!C&!B1&B&A1&!A|E&!D&C1&!C&!B1&B&A1&!A|E&!D&C1&C&!B1&B&A1&!A|E&D&C1&C&!B1&B&A1&!A|E&D&!C1&C&!B1&B&A1&!A|E&!D&!C1&C&!B1&B&A1&!A|E&!D&!C1&C&B1&B&A1&!A|E&D&!C1&C&B1&B&A1&!A|E&D&C1&C&B1&B&A1&!A|E&!D&C1&C&B1&B&A1&!A|E&!D&C1&!C&B1&B&A1&!A|E&D&C1&!C&B1&B&A1&!A|E&D&!C1&!C&B1&B&A1&!A|E&D&!C1&!C&B1&!B&A1&!A|E&D&C1&!C&B1&!B&A1&!A|E&!D&C1&!C&B1&!B&A1&!A|E&!D&C1&C&B1&!B&A1&!A|E&D&C1&C&B1&!B&A1&!A|E&D&!C1&C&B1&!B&A1&!A|E&!D&!C1&C&B1&!B&A1&!A|E&D&!C1&C&!B1&!B&A1&!A|E&D&C1&C&!B1&!B&A1&!A|E&D&C1&!C&!B1&!B&A1&!A|E&D&!C1&!C&!B1&!B&A1&!A|E&D&!C1&!C&!B1&!B&A1&A|E&D&C1&!C&!B1&!B&A1&A|E&!D&C1&!C&!B1&!B&A1&A|E&!D&C1&C&!B1&!B&A1&A|E&D&C1&C&!B1&!B&A1&A|E&D&!C1&C&!B1&!B&A1&A|E&!D&!C1&C&!B1&!B&A1&A|E&!D&!C1&C&B1&!B&A1&A|E&D&!C1&C&B1&!B&A1&A|E&D&C1&C&B1&!B&A1&A|E&!D&C1&C&B1&!B&A1&A|E&!D&C1&!C&B1&!B&A1&A|E&D&C1&!C&B1&!B&A1&A|E&D&!C1&!C&B1&!B&A1&A|E&D&!C1&!C&B1&B&A1&A|E&D&C1&!C&B1&B&A1&A|E&!D&C1&!C&B1&B&A1&A|E&!D&C1&C&B1&B&A1&A|E&D&C1&C&B1&B&A1&A|E&D&!C1&C&B1&B&A1&A|E&!D&!C1&C&B1&B&A1&A|E&!D&!C1&C&!B1&B&A1&A|E&D&!C1&C&!B1&B&A1&A|E&D&C1&C&!B1&B&A1&A|E&!D&C1&C&!B1&B&A1&A|E&!D&C1&!C&!B1&B&A1&A|E&D&C1&!C&!B1&B&A1&A|E&D&!C1&!C&!B1&B&A1&A|E&D&!C1&!C&!B1&B&!A1&A|E&D&C1&!C&!B1&B&!A1&A|E&!D&C1&!C&!B1&B&!A1&A|E&!D&C1&C&!B1&B&!A1&A|E&D&C1&C&!B1&B&!A1&A|E&D&!C1&C&!B1&B&!A1&A|E&!D&!C1&C&!B1&B&!A1&A|E&!D&!C1&C&B1&B&!A1&A|E&D&!C1&C&B1&B&!A1&A|E&D&C1&C&B1&B&!A1&A|E&!D&C1&C&B1&B&!A1&A|E&!D&C1&!C&B1&B&!A1&A|E&D&C1&!C&B1&B&!A1&A|E&D&!C1&!C&B1&B&!A1&A|E&D&!C1&!C&B1&!B&!A1&A|E&D&C1&!C&B1&!B&!A1&A|E&!D&C1&!C&B1&!B&!A1&A|E&!D&C1&C&B1&!B&!A1&A|E&D&C1&C&B1&!B&!A1&A|E&D&!C1&C&B1&!B&!A1&A|E&!D&!C1&C&B1&!B&!A1&A|E&D&!C1&C&!B1&!B&!A1&A|E&D&C1&C&!B1&!B&!A1&A|E&D&C1&!C&!B1&!B&!A1&A|E&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOAI22211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOOAAOI22232 -l OOAAOOAAOI22232 -i E1 E D2 D1 D C1 C B1 B A1 A -o Y -f Y=(!E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E1&E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|E1&!E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E1&!E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E1&E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|E1&!E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E1&!E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|E1&!E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E1&!E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|E1&!E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|E1&!E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E1&!E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|E1&!E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|!E1&E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|!E1&E&D2&D1&D&!C1&C&B1&!B&!A1&!A|E1&!E&D2&D1&D&!C1&C&B1&!B&!A1&!A|!E1&!E&D2&D1&D&!C1&C&B1&!B&!A1&!A|!E1&!E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|E1&!E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E1&E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E1&E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|E1&!E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|E1&!E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E1&!E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|E1&!E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|E1&!E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|E1&!E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|!E1&E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|!E1&E&D2&D1&D&C1&!C&B1&!B&!A1&!A|E1&!E&D2&D1&D&C1&!C&B1&!B&!A1&!A|!E1&!E&D2&D1&D&C1&!C&B1&!B&!A1&!A|!E1&!E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|E1&!E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E1&E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E1&E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|E1&!E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E1&E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|E1&!E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E1&!E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E1&!E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|E1&!E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E1&E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|E1&!E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E1&!E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|E1&!E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|E1&!E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E1&!E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|E1&!E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|!E1&E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|!E1&E&D2&D1&D&!C1&!C&B1&B&!A1&!A|E1&!E&D2&D1&D&!C1&!C&B1&B&!A1&!A|!E1&!E&D2&D1&D&!C1&!C&B1&B&!A1&!A|!E1&!E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|E1&!E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E1&E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E1&!E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|!E1&E&D2&!D1&D&C1&!C&B1&B&!A1&!A|E1&!E&D2&!D1&D&C1&!C&B1&B&!A1&!A|!E1&!E&D2&!D1&D&C1&!C&B1&B&!A1&!A|!E1&!E&D2&D1&D&C1&!C&B1&B&!A1&!A|E1&!E&D2&D1&D&C1&!C&B1&B&!A1&!A|!E1&E&D2&D1&D&C1&!C&B1&B&!A1&!A|!E1&E&!D2&D1&D&C1&!C&B1&B&!A1&!A|E1&!E&!D2&D1&D&C1&!C&B1&B&!A1&!A|!E1&!E&!D2&D1&D&C1&!C&B1&B&!A1&!A|!E1&!E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|E1&!E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|!E1&E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|!E1&E&D2&D1&!D&C1&!C&B1&B&!A1&!A|E1&!E&D2&D1&!D&C1&!C&B1&B&!A1&!A|!E1&!E&D2&D1&!D&C1&!C&B1&B&!A1&!A|!E1&!E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|E1&!E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|!E1&E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|E1&!E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|!E1&E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|!E1&E&D2&!D1&D&!C1&C&B1&B&!A1&!A|E1&!E&D2&!D1&D&!C1&C&B1&B&!A1&!A|!E1&!E&D2&!D1&D&!C1&C&B1&B&!A1&!A|!E1&!E&D2&D1&D&!C1&C&B1&B&!A1&!A|E1&!E&D2&D1&D&!C1&C&B1&B&!A1&!A|!E1&E&D2&D1&D&!C1&C&B1&B&!A1&!A|!E1&E&!D2&D1&D&!C1&C&B1&B&!A1&!A|E1&!E&!D2&D1&D&!C1&C&B1&B&!A1&!A|!E1&!E&!D2&D1&D&!C1&C&B1&B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|E1&!E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|!E1&E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|!E1&E&D2&D1&!D&!C1&C&B1&B&!A1&!A|E1&!E&D2&D1&!D&!C1&C&B1&B&!A1&!A|!E1&!E&D2&D1&!D&!C1&C&B1&B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|E1&!E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|!E1&E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|E1&!E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E1&!E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|E1&!E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|E1&!E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E1&!E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|E1&!E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|!E1&E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|!E1&E&D2&D1&D&!C1&C&!B1&B&!A1&!A|E1&!E&D2&D1&D&!C1&C&!B1&B&!A1&!A|!E1&!E&D2&D1&D&!C1&C&!B1&B&!A1&!A|!E1&!E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|E1&!E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E1&E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E1&E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|E1&!E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|E1&!E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E1&!E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E1&!E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|E1&!E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|E1&!E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|E1&!E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|!E1&E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|!E1&E&D2&D1&D&C1&!C&!B1&B&!A1&!A|E1&!E&D2&D1&D&C1&!C&!B1&B&!A1&!A|!E1&!E&D2&D1&D&C1&!C&!B1&B&!A1&!A|!E1&!E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|E1&!E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E1&E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E1&E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|E1&!E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E1&E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|E1&!E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E1&!E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E1&!E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|E1&!E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E1&E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!E1&!E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|!E1&E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|!E1&E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|E1&!E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&C1&C&B1&B&A1&!A|E1&!E&!D2&!D1&!D&C1&C&B1&B&A1&!A|!E1&!E&!D2&!D1&!D&C1&C&B1&B&A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|E1&!E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|E1&!E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|E1&!E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|!E1&E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|!E1&E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|E1&!E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|E1&!E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E1&!E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E1&!E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|E1&!E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|E1&!E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E1&!E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E1&!E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|E1&!E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|!E1&E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|!E1&E&D2&D1&D&!C1&C&!B1&!B&A1&!A|E1&!E&D2&D1&D&!C1&C&!B1&!B&A1&!A|!E1&!E&D2&D1&D&!C1&C&!B1&!B&A1&!A|!E1&!E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|E1&!E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E1&E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E1&E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|E1&!E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E1&E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|E1&!E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|E1&!E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E1&!E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E1&!E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|E1&!E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|E1&!E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|E1&!E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|!E1&E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|!E1&E&D2&D1&D&C1&!C&!B1&!B&A1&!A|E1&!E&D2&D1&D&C1&!C&!B1&!B&A1&!A|!E1&!E&D2&D1&D&C1&!C&!B1&!B&A1&!A|!E1&!E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|E1&!E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E1&E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E1&E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|E1&!E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E1&E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|E1&!E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E1&!E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E1&!E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|E1&!E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E1&E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E1&!E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|E1&!E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E1&!E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|E1&!E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|!E1&E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|!E1&E&D2&D1&D&!C1&!C&!B1&!B&A1&A|E1&!E&D2&D1&D&!C1&!C&!B1&!B&A1&A|!E1&!E&D2&D1&D&!C1&!C&!B1&!B&A1&A|!E1&!E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|E1&!E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E1&E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E1&!E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|!E1&E&D2&!D1&D&C1&!C&!B1&!B&A1&A|E1&!E&D2&!D1&D&C1&!C&!B1&!B&A1&A|!E1&!E&D2&!D1&D&C1&!C&!B1&!B&A1&A|!E1&!E&D2&D1&D&C1&!C&!B1&!B&A1&A|E1&!E&D2&D1&D&C1&!C&!B1&!B&A1&A|!E1&E&D2&D1&D&C1&!C&!B1&!B&A1&A|!E1&E&!D2&D1&D&C1&!C&!B1&!B&A1&A|E1&!E&!D2&D1&D&C1&!C&!B1&!B&A1&A|!E1&!E&!D2&D1&D&C1&!C&!B1&!B&A1&A|!E1&!E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|E1&!E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|!E1&E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|!E1&E&D2&D1&!D&C1&!C&!B1&!B&A1&A|E1&!E&D2&D1&!D&C1&!C&!B1&!B&A1&A|!E1&!E&D2&D1&!D&C1&!C&!B1&!B&A1&A|!E1&!E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|E1&!E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|!E1&E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!E1&!E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|!E1&!E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|E1&!E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|!E1&E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|!E1&E&D2&!D1&D&!C1&C&!B1&!B&A1&A|E1&!E&D2&!D1&D&!C1&C&!B1&!B&A1&A|!E1&!E&D2&!D1&D&!C1&C&!B1&!B&A1&A|!E1&!E&D2&D1&D&!C1&C&!B1&!B&A1&A|E1&!E&D2&D1&D&!C1&C&!B1&!B&A1&A|!E1&E&D2&D1&D&!C1&C&!B1&!B&A1&A|!E1&E&!D2&D1&D&!C1&C&!B1&!B&A1&A|E1&!E&!D2&D1&D&!C1&C&!B1&!B&A1&A|!E1&!E&!D2&D1&D&!C1&C&!B1&!B&A1&A|!E1&!E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|E1&!E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|!E1&E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|!E1&E&D2&D1&!D&!C1&C&!B1&!B&A1&A|E1&!E&D2&D1&!D&!C1&C&!B1&!B&A1&A|!E1&!E&D2&D1&!D&!C1&C&!B1&!B&A1&A|!E1&!E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|E1&!E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|!E1&E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!E1&!E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|E1&!E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&C1&C&B1&!B&A1&A|E1&!E&!D2&!D1&!D&C1&C&B1&!B&A1&A|!E1&!E&!D2&!D1&!D&C1&C&B1&!B&A1&A|!E1&!E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|E1&!E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|E1&!E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!E1&E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!E1&E&!D2&!D1&!D&C1&!C&B1&B&A1&A|E1&!E&!D2&!D1&!D&C1&!C&B1&B&A1&A|!E1&!E&!D2&!D1&!D&C1&!C&B1&B&A1&A|!E1&!E&!D2&!D1&!D&C1&C&B1&B&A1&A|E1&!E&!D2&!D1&!D&C1&C&B1&B&A1&A|!E1&E&!D2&!D1&!D&C1&C&B1&B&A1&A|!E1&E&!D2&!D1&!D&!C1&C&B1&B&A1&A|E1&!E&!D2&!D1&!D&!C1&C&B1&B&A1&A|!E1&!E&!D2&!D1&!D&!C1&C&B1&B&A1&A|!E1&!E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|E1&!E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&C1&C&!B1&B&A1&A|E1&!E&!D2&!D1&!D&C1&C&!B1&B&A1&A|!E1&!E&!D2&!D1&!D&C1&C&!B1&B&A1&A|!E1&!E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|E1&!E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!E1&!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!E1&!E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|!E1&E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|!E1&E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|E1&!E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&C1&C&B1&B&!A1&A|E1&!E&!D2&!D1&!D&C1&C&B1&B&!A1&A|!E1&!E&!D2&!D1&!D&C1&C&B1&B&!A1&A|!E1&!E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|E1&!E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|E1&!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|E1&!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|E1&!E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|!E1&E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|!E1&E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|E1&!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|E1&!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E1&!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E1&!E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|E1&!E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|E1&!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E1&!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E1&!E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|E1&!E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|!E1&E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|!E1&E&D2&D1&D&!C1&C&!B1&!B&!A1&A|E1&!E&D2&D1&D&!C1&C&!B1&!B&!A1&A|!E1&!E&D2&D1&D&!C1&C&!B1&!B&!A1&A|!E1&!E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|E1&!E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E1&E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E1&E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|E1&!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E1&E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|E1&!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|E1&!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E1&!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E1&!E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|E1&!E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|E1&!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E1&!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E1&!E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|E1&!E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|!E1&E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|!E1&E&D2&D1&D&C1&!C&!B1&!B&!A1&A|E1&!E&D2&D1&D&C1&!C&!B1&!B&!A1&A|!E1&!E&D2&D1&D&C1&!C&!B1&!B&!A1&A|!E1&!E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|E1&!E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E1&E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E1&E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|E1&!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E1&E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|E1&!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E1&!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E1&!E&D2&D1&D&!C1&!C&!B1&!B&!A1&A|E1&!E&D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E1&E&D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E1&!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOOAAOI22232.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOI331 -l AAOI331 -i C B2 B1 B A2 A1 A -o Y -f Y=(!C&!B2&!B1&!B&!A2&!A1&!A|!C&B2&!B1&!B&!A2&!A1&!A|!C&B2&B1&!B&!A2&!A1&!A|!C&!B2&B1&!B&!A2&!A1&!A|!C&!B2&B1&B&!A2&!A1&!A|!C&B2&!B1&B&!A2&!A1&!A|!C&!B2&!B1&B&!A2&!A1&!A|!C&!B2&!B1&B&A2&!A1&!A|!C&B2&!B1&B&A2&!A1&!A|!C&!B2&B1&B&A2&!A1&!A|!C&!B2&B1&!B&A2&!A1&!A|!C&B2&B1&!B&A2&!A1&!A|!C&B2&!B1&!B&A2&!A1&!A|!C&!B2&!B1&!B&A2&!A1&!A|!C&!B2&!B1&!B&A2&A1&!A|!C&B2&!B1&!B&A2&A1&!A|!C&B2&B1&!B&A2&A1&!A|!C&!B2&B1&!B&A2&A1&!A|!C&!B2&B1&B&A2&A1&!A|!C&B2&!B1&B&A2&A1&!A|!C&!B2&!B1&B&A2&A1&!A|!C&!B2&!B1&B&!A2&A1&!A|!C&B2&!B1&B&!A2&A1&!A|!C&!B2&B1&B&!A2&A1&!A|!C&!B2&B1&!B&!A2&A1&!A|!C&B2&B1&!B&!A2&A1&!A|!C&B2&!B1&!B&!A2&A1&!A|!C&!B2&!B1&!B&!A2&A1&!A|!C&!B2&!B1&!B&!A2&A1&A|!C&B2&!B1&!B&!A2&A1&A|!C&B2&B1&!B&!A2&A1&A|!C&!B2&B1&!B&!A2&A1&A|!C&!B2&B1&B&!A2&A1&A|!C&B2&!B1&B&!A2&A1&A|!C&!B2&!B1&B&!A2&A1&A|!C&!B2&!B1&!B&A2&!A1&A|!C&B2&!B1&!B&A2&!A1&A|!C&B2&B1&!B&A2&!A1&A|!C&!B2&B1&!B&A2&!A1&A|!C&!B2&B1&B&A2&!A1&A|!C&B2&!B1&B&A2&!A1&A|!C&!B2&!B1&B&A2&!A1&A|!C&!B2&!B1&B&!A2&!A1&A|!C&B2&!B1&B&!A2&!A1&A|!C&!B2&B1&B&!A2&!A1&A|!C&!B2&B1&!B&!A2&!A1&A|!C&B2&B1&!B&!A2&!A1&A|!C&B2&!B1&!B&!A2&!A1&A|!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOI331.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOAI33311 -l AAAOAI33311 -i E D C2 C1 C B2 B1 B A2 A1 A -o Y -f Y=!(E&D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|E&D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|E&D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|E&D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|E&D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|E&D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|E&!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|E&D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|E&D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|E&D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|E&D&C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|E&!D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|E&D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|E&D&!C2&C1&C&B2&!B1&!B&!A2&!A1&!A|E&D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|E&D&C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|E&D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|E&D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|E&D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|E&D&C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|E&D&C2&C1&!C&B2&B1&!B&!A2&!A1&!A|E&D&!C2&C1&!C&B2&B1&!B&!A2&!A1&!A|E&D&!C2&C1&C&B2&B1&!B&!A2&!A1&!A|E&D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|E&!D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|E&D&C2&!C1&C&B2&B1&!B&!A2&!A1&!A|E&D&!C2&!C1&C&B2&B1&!B&!A2&!A1&!A|E&D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|E&D&C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|E&!D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|E&D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|E&D&!C2&C1&C&!B2&B1&!B&!A2&!A1&!A|E&D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|E&D&C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|E&D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|E&D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|E&D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|E&D&C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|E&D&C2&C1&!C&!B2&B1&B&!A2&!A1&!A|E&D&!C2&C1&!C&!B2&B1&B&!A2&!A1&!A|E&D&!C2&C1&C&!B2&B1&B&!A2&!A1&!A|E&D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|E&!D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|E&D&C2&!C1&C&!B2&B1&B&!A2&!A1&!A|E&D&!C2&!C1&C&!B2&B1&B&!A2&!A1&!A|E&!D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|E&D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|E&D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|E&!D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|E&!D&C2&C1&C&B2&B1&B&!A2&!A1&!A|E&D&C2&C1&C&B2&B1&B&!A2&!A1&!A|E&D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|E&!D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|E&!D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|E&D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|E&D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|E&!D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|E&!D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|E&D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|E&D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|E&!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|E&D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|E&D&C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|E&D&C2&C1&!C&B2&!B1&B&!A2&!A1&!A|E&D&!C2&C1&!C&B2&!B1&B&!A2&!A1&!A|E&D&!C2&C1&C&B2&!B1&B&!A2&!A1&!A|E&D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|E&!D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|E&D&C2&!C1&C&B2&!B1&B&!A2&!A1&!A|E&D&!C2&!C1&C&B2&!B1&B&!A2&!A1&!A|E&D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|E&D&C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|E&!D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|E&D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|E&D&!C2&C1&C&!B2&!B1&B&!A2&!A1&!A|E&D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|E&D&C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|E&D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|E&D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|E&D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|E&D&C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|E&D&C2&C1&!C&!B2&!B1&B&A2&!A1&!A|E&D&!C2&C1&!C&!B2&!B1&B&A2&!A1&!A|E&D&!C2&C1&C&!B2&!B1&B&A2&!A1&!A|E&D&C2&C1&C&!B2&!B1&B&A2&!A1&!A|E&!D&C2&C1&C&!B2&!B1&B&A2&!A1&!A|E&D&C2&!C1&C&!B2&!B1&B&A2&!A1&!A|E&D&!C2&!C1&C&!B2&!B1&B&A2&!A1&!A|E&D&!C2&!C1&C&B2&!B1&B&A2&!A1&!A|E&D&C2&!C1&C&B2&!B1&B&A2&!A1&!A|E&!D&C2&C1&C&B2&!B1&B&A2&!A1&!A|E&D&C2&C1&C&B2&!B1&B&A2&!A1&!A|E&D&!C2&C1&C&B2&!B1&B&A2&!A1&!A|E&D&!C2&C1&!C&B2&!B1&B&A2&!A1&!A|E&D&C2&C1&!C&B2&!B1&B&A2&!A1&!A|E&D&C2&!C1&!C&B2&!B1&B&A2&!A1&!A|E&D&!C2&!C1&!C&B2&!B1&B&A2&!A1&!A|E&!D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|E&D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|E&D&C2&!C1&!C&B2&B1&B&A2&!A1&!A|E&!D&C2&!C1&!C&B2&B1&B&A2&!A1&!A|E&!D&C2&C1&!C&B2&B1&B&A2&!A1&!A|E&D&C2&C1&!C&B2&B1&B&A2&!A1&!A|E&D&!C2&C1&!C&B2&B1&B&A2&!A1&!A|E&!D&!C2&C1&!C&B2&B1&B&A2&!A1&!A|E&!D&!C2&C1&C&B2&B1&B&A2&!A1&!A|E&D&!C2&C1&C&B2&B1&B&A2&!A1&!A|E&D&C2&C1&C&B2&B1&B&A2&!A1&!A|E&!D&C2&C1&C&B2&B1&B&A2&!A1&!A|E&!D&C2&!C1&C&B2&B1&B&A2&!A1&!A|E&D&C2&!C1&C&B2&B1&B&A2&!A1&!A|E&D&!C2&!C1&C&B2&B1&B&A2&!A1&!A|E&!D&!C2&!C1&C&B2&B1&B&A2&!A1&!A|E&D&!C2&!C1&C&!B2&B1&B&A2&!A1&!A|E&D&C2&!C1&C&!B2&B1&B&A2&!A1&!A|E&!D&C2&C1&C&!B2&B1&B&A2&!A1&!A|E&D&C2&C1&C&!B2&B1&B&A2&!A1&!A|E&D&!C2&C1&C&!B2&B1&B&A2&!A1&!A|E&D&!C2&C1&!C&!B2&B1&B&A2&!A1&!A|E&D&C2&C1&!C&!B2&B1&B&A2&!A1&!A|E&D&C2&!C1&!C&!B2&B1&B&A2&!A1&!A|E&D&!C2&!C1&!C&!B2&B1&B&A2&!A1&!A|E&D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|E&D&C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|E&D&C2&C1&!C&!B2&B1&!B&A2&!A1&!A|E&D&!C2&C1&!C&!B2&B1&!B&A2&!A1&!A|E&D&!C2&C1&C&!B2&B1&!B&A2&!A1&!A|E&D&C2&C1&C&!B2&B1&!B&A2&!A1&!A|E&!D&C2&C1&C&!B2&B1&!B&A2&!A1&!A|E&D&C2&!C1&C&!B2&B1&!B&A2&!A1&!A|E&D&!C2&!C1&C&!B2&B1&!B&A2&!A1&!A|E&D&!C2&!C1&C&B2&B1&!B&A2&!A1&!A|E&D&C2&!C1&C&B2&B1&!B&A2&!A1&!A|E&!D&C2&C1&C&B2&B1&!B&A2&!A1&!A|E&D&C2&C1&C&B2&B1&!B&A2&!A1&!A|E&D&!C2&C1&C&B2&B1&!B&A2&!A1&!A|E&D&!C2&C1&!C&B2&B1&!B&A2&!A1&!A|E&D&C2&C1&!C&B2&B1&!B&A2&!A1&!A|E&D&C2&!C1&!C&B2&B1&!B&A2&!A1&!A|E&D&!C2&!C1&!C&B2&B1&!B&A2&!A1&!A|E&D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|E&D&C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|E&D&C2&C1&!C&B2&!B1&!B&A2&!A1&!A|E&D&!C2&C1&!C&B2&!B1&!B&A2&!A1&!A|E&D&!C2&C1&C&B2&!B1&!B&A2&!A1&!A|E&D&C2&C1&C&B2&!B1&!B&A2&!A1&!A|E&!D&C2&C1&C&B2&!B1&!B&A2&!A1&!A|E&D&C2&!C1&C&B2&!B1&!B&A2&!A1&!A|E&D&!C2&!C1&C&B2&!B1&!B&A2&!A1&!A|E&D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|E&D&C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|E&!D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|E&D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|E&D&!C2&C1&C&!B2&!B1&!B&A2&!A1&!A|E&D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|E&D&C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|E&D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|E&D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|E&D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|E&D&C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|E&D&C2&C1&!C&!B2&!B1&!B&A2&A1&!A|E&D&!C2&C1&!C&!B2&!B1&!B&A2&A1&!A|E&D&!C2&C1&C&!B2&!B1&!B&A2&A1&!A|E&D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|E&!D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|E&D&C2&!C1&C&!B2&!B1&!B&A2&A1&!A|E&D&!C2&!C1&C&!B2&!B1&!B&A2&A1&!A|E&D&!C2&!C1&C&B2&!B1&!B&A2&A1&!A|E&D&C2&!C1&C&B2&!B1&!B&A2&A1&!A|E&!D&C2&C1&C&B2&!B1&!B&A2&A1&!A|E&D&C2&C1&C&B2&!B1&!B&A2&A1&!A|E&D&!C2&C1&C&B2&!B1&!B&A2&A1&!A|E&D&!C2&C1&!C&B2&!B1&!B&A2&A1&!A|E&D&C2&C1&!C&B2&!B1&!B&A2&A1&!A|E&D&C2&!C1&!C&B2&!B1&!B&A2&A1&!A|E&D&!C2&!C1&!C&B2&!B1&!B&A2&A1&!A|E&D&!C2&!C1&!C&B2&B1&!B&A2&A1&!A|E&D&C2&!C1&!C&B2&B1&!B&A2&A1&!A|E&D&C2&C1&!C&B2&B1&!B&A2&A1&!A|E&D&!C2&C1&!C&B2&B1&!B&A2&A1&!A|E&D&!C2&C1&C&B2&B1&!B&A2&A1&!A|E&D&C2&C1&C&B2&B1&!B&A2&A1&!A|E&!D&C2&C1&C&B2&B1&!B&A2&A1&!A|E&D&C2&!C1&C&B2&B1&!B&A2&A1&!A|E&D&!C2&!C1&C&B2&B1&!B&A2&A1&!A|E&D&!C2&!C1&C&!B2&B1&!B&A2&A1&!A|E&D&C2&!C1&C&!B2&B1&!B&A2&A1&!A|E&!D&C2&C1&C&!B2&B1&!B&A2&A1&!A|E&D&C2&C1&C&!B2&B1&!B&A2&A1&!A|E&D&!C2&C1&C&!B2&B1&!B&A2&A1&!A|E&D&!C2&C1&!C&!B2&B1&!B&A2&A1&!A|E&D&C2&C1&!C&!B2&B1&!B&A2&A1&!A|E&D&C2&!C1&!C&!B2&B1&!B&A2&A1&!A|E&D&!C2&!C1&!C&!B2&B1&!B&A2&A1&!A|E&D&!C2&!C1&!C&!B2&B1&B&A2&A1&!A|E&D&C2&!C1&!C&!B2&B1&B&A2&A1&!A|E&D&C2&C1&!C&!B2&B1&B&A2&A1&!A|E&D&!C2&C1&!C&!B2&B1&B&A2&A1&!A|E&D&!C2&C1&C&!B2&B1&B&A2&A1&!A|E&D&C2&C1&C&!B2&B1&B&A2&A1&!A|E&!D&C2&C1&C&!B2&B1&B&A2&A1&!A|E&D&C2&!C1&C&!B2&B1&B&A2&A1&!A|E&D&!C2&!C1&C&!B2&B1&B&A2&A1&!A|E&!D&!C2&!C1&C&B2&B1&B&A2&A1&!A|E&D&!C2&!C1&C&B2&B1&B&A2&A1&!A|E&D&C2&!C1&C&B2&B1&B&A2&A1&!A|E&!D&C2&!C1&C&B2&B1&B&A2&A1&!A|E&!D&C2&C1&C&B2&B1&B&A2&A1&!A|E&D&C2&C1&C&B2&B1&B&A2&A1&!A|E&D&!C2&C1&C&B2&B1&B&A2&A1&!A|E&!D&!C2&C1&C&B2&B1&B&A2&A1&!A|E&!D&!C2&C1&!C&B2&B1&B&A2&A1&!A|E&D&!C2&C1&!C&B2&B1&B&A2&A1&!A|E&D&C2&C1&!C&B2&B1&B&A2&A1&!A|E&!D&C2&C1&!C&B2&B1&B&A2&A1&!A|E&!D&C2&!C1&!C&B2&B1&B&A2&A1&!A|E&D&C2&!C1&!C&B2&B1&B&A2&A1&!A|E&D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|E&!D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|E&D&!C2&!C1&!C&B2&!B1&B&A2&A1&!A|E&D&C2&!C1&!C&B2&!B1&B&A2&A1&!A|E&D&C2&C1&!C&B2&!B1&B&A2&A1&!A|E&D&!C2&C1&!C&B2&!B1&B&A2&A1&!A|E&D&!C2&C1&C&B2&!B1&B&A2&A1&!A|E&D&C2&C1&C&B2&!B1&B&A2&A1&!A|E&!D&C2&C1&C&B2&!B1&B&A2&A1&!A|E&D&C2&!C1&C&B2&!B1&B&A2&A1&!A|E&D&!C2&!C1&C&B2&!B1&B&A2&A1&!A|E&D&!C2&!C1&C&!B2&!B1&B&A2&A1&!A|E&D&C2&!C1&C&!B2&!B1&B&A2&A1&!A|E&!D&C2&C1&C&!B2&!B1&B&A2&A1&!A|E&D&C2&C1&C&!B2&!B1&B&A2&A1&!A|E&D&!C2&C1&C&!B2&!B1&B&A2&A1&!A|E&D&!C2&C1&!C&!B2&!B1&B&A2&A1&!A|E&D&C2&C1&!C&!B2&!B1&B&A2&A1&!A|E&D&C2&!C1&!C&!B2&!B1&B&A2&A1&!A|E&D&!C2&!C1&!C&!B2&!B1&B&A2&A1&!A|E&D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|E&D&C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|E&D&C2&C1&!C&!B2&!B1&B&!A2&A1&!A|E&D&!C2&C1&!C&!B2&!B1&B&!A2&A1&!A|E&D&!C2&C1&C&!B2&!B1&B&!A2&A1&!A|E&D&C2&C1&C&!B2&!B1&B&!A2&A1&!A|E&!D&C2&C1&C&!B2&!B1&B&!A2&A1&!A|E&D&C2&!C1&C&!B2&!B1&B&!A2&A1&!A|E&D&!C2&!C1&C&!B2&!B1&B&!A2&A1&!A|E&D&!C2&!C1&C&B2&!B1&B&!A2&A1&!A|E&D&C2&!C1&C&B2&!B1&B&!A2&A1&!A|E&!D&C2&C1&C&B2&!B1&B&!A2&A1&!A|E&D&C2&C1&C&B2&!B1&B&!A2&A1&!A|E&D&!C2&C1&C&B2&!B1&B&!A2&A1&!A|E&D&!C2&C1&!C&B2&!B1&B&!A2&A1&!A|E&D&C2&C1&!C&B2&!B1&B&!A2&A1&!A|E&D&C2&!C1&!C&B2&!B1&B&!A2&A1&!A|E&D&!C2&!C1&!C&B2&!B1&B&!A2&A1&!A|E&!D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|E&D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|E&D&C2&!C1&!C&B2&B1&B&!A2&A1&!A|E&!D&C2&!C1&!C&B2&B1&B&!A2&A1&!A|E&!D&C2&C1&!C&B2&B1&B&!A2&A1&!A|E&D&C2&C1&!C&B2&B1&B&!A2&A1&!A|E&D&!C2&C1&!C&B2&B1&B&!A2&A1&!A|E&!D&!C2&C1&!C&B2&B1&B&!A2&A1&!A|E&!D&!C2&C1&C&B2&B1&B&!A2&A1&!A|E&D&!C2&C1&C&B2&B1&B&!A2&A1&!A|E&D&C2&C1&C&B2&B1&B&!A2&A1&!A|E&!D&C2&C1&C&B2&B1&B&!A2&A1&!A|E&!D&C2&!C1&C&B2&B1&B&!A2&A1&!A|E&D&C2&!C1&C&B2&B1&B&!A2&A1&!A|E&D&!C2&!C1&C&B2&B1&B&!A2&A1&!A|E&!D&!C2&!C1&C&B2&B1&B&!A2&A1&!A|E&D&!C2&!C1&C&!B2&B1&B&!A2&A1&!A|E&D&C2&!C1&C&!B2&B1&B&!A2&A1&!A|E&!D&C2&C1&C&!B2&B1&B&!A2&A1&!A|E&D&C2&C1&C&!B2&B1&B&!A2&A1&!A|E&D&!C2&C1&C&!B2&B1&B&!A2&A1&!A|E&D&!C2&C1&!C&!B2&B1&B&!A2&A1&!A|E&D&C2&C1&!C&!B2&B1&B&!A2&A1&!A|E&D&C2&!C1&!C&!B2&B1&B&!A2&A1&!A|E&D&!C2&!C1&!C&!B2&B1&B&!A2&A1&!A|E&D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|E&D&C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|E&D&C2&C1&!C&!B2&B1&!B&!A2&A1&!A|E&D&!C2&C1&!C&!B2&B1&!B&!A2&A1&!A|E&D&!C2&C1&C&!B2&B1&!B&!A2&A1&!A|E&D&C2&C1&C&!B2&B1&!B&!A2&A1&!A|E&!D&C2&C1&C&!B2&B1&!B&!A2&A1&!A|E&D&C2&!C1&C&!B2&B1&!B&!A2&A1&!A|E&D&!C2&!C1&C&!B2&B1&!B&!A2&A1&!A|E&D&!C2&!C1&C&B2&B1&!B&!A2&A1&!A|E&D&C2&!C1&C&B2&B1&!B&!A2&A1&!A|E&!D&C2&C1&C&B2&B1&!B&!A2&A1&!A|E&D&C2&C1&C&B2&B1&!B&!A2&A1&!A|E&D&!C2&C1&C&B2&B1&!B&!A2&A1&!A|E&D&!C2&C1&!C&B2&B1&!B&!A2&A1&!A|E&D&C2&C1&!C&B2&B1&!B&!A2&A1&!A|E&D&C2&!C1&!C&B2&B1&!B&!A2&A1&!A|E&D&!C2&!C1&!C&B2&B1&!B&!A2&A1&!A|E&D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|E&D&C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|E&D&C2&C1&!C&B2&!B1&!B&!A2&A1&!A|E&D&!C2&C1&!C&B2&!B1&!B&!A2&A1&!A|E&D&!C2&C1&C&B2&!B1&!B&!A2&A1&!A|E&D&C2&C1&C&B2&!B1&!B&!A2&A1&!A|E&!D&C2&C1&C&B2&!B1&!B&!A2&A1&!A|E&D&C2&!C1&C&B2&!B1&!B&!A2&A1&!A|E&D&!C2&!C1&C&B2&!B1&!B&!A2&A1&!A|E&D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|E&D&C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|E&!D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|E&D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|E&D&!C2&C1&C&!B2&!B1&!B&!A2&A1&!A|E&D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|E&D&C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|E&D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|E&D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|E&D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|E&D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|E&D&C2&C1&!C&!B2&!B1&!B&!A2&A1&A|E&D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&A|E&D&!C2&C1&C&!B2&!B1&!B&!A2&A1&A|E&D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|E&!D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|E&D&C2&!C1&C&!B2&!B1&!B&!A2&A1&A|E&D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&A|E&D&!C2&!C1&C&B2&!B1&!B&!A2&A1&A|E&D&C2&!C1&C&B2&!B1&!B&!A2&A1&A|E&!D&C2&C1&C&B2&!B1&!B&!A2&A1&A|E&D&C2&C1&C&B2&!B1&!B&!A2&A1&A|E&D&!C2&C1&C&B2&!B1&!B&!A2&A1&A|E&D&!C2&C1&!C&B2&!B1&!B&!A2&A1&A|E&D&C2&C1&!C&B2&!B1&!B&!A2&A1&A|E&D&C2&!C1&!C&B2&!B1&!B&!A2&A1&A|E&D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&A|E&D&!C2&!C1&!C&B2&B1&!B&!A2&A1&A|E&D&C2&!C1&!C&B2&B1&!B&!A2&A1&A|E&D&C2&C1&!C&B2&B1&!B&!A2&A1&A|E&D&!C2&C1&!C&B2&B1&!B&!A2&A1&A|E&D&!C2&C1&C&B2&B1&!B&!A2&A1&A|E&D&C2&C1&C&B2&B1&!B&!A2&A1&A|E&!D&C2&C1&C&B2&B1&!B&!A2&A1&A|E&D&C2&!C1&C&B2&B1&!B&!A2&A1&A|E&D&!C2&!C1&C&B2&B1&!B&!A2&A1&A|E&D&!C2&!C1&C&!B2&B1&!B&!A2&A1&A|E&D&C2&!C1&C&!B2&B1&!B&!A2&A1&A|E&!D&C2&C1&C&!B2&B1&!B&!A2&A1&A|E&D&C2&C1&C&!B2&B1&!B&!A2&A1&A|E&D&!C2&C1&C&!B2&B1&!B&!A2&A1&A|E&D&!C2&C1&!C&!B2&B1&!B&!A2&A1&A|E&D&C2&C1&!C&!B2&B1&!B&!A2&A1&A|E&D&C2&!C1&!C&!B2&B1&!B&!A2&A1&A|E&D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&A|E&D&!C2&!C1&!C&!B2&B1&B&!A2&A1&A|E&D&C2&!C1&!C&!B2&B1&B&!A2&A1&A|E&D&C2&C1&!C&!B2&B1&B&!A2&A1&A|E&D&!C2&C1&!C&!B2&B1&B&!A2&A1&A|E&D&!C2&C1&C&!B2&B1&B&!A2&A1&A|E&D&C2&C1&C&!B2&B1&B&!A2&A1&A|E&!D&C2&C1&C&!B2&B1&B&!A2&A1&A|E&D&C2&!C1&C&!B2&B1&B&!A2&A1&A|E&D&!C2&!C1&C&!B2&B1&B&!A2&A1&A|E&!D&!C2&!C1&C&B2&B1&B&!A2&A1&A|E&D&!C2&!C1&C&B2&B1&B&!A2&A1&A|E&D&C2&!C1&C&B2&B1&B&!A2&A1&A|E&!D&C2&!C1&C&B2&B1&B&!A2&A1&A|E&!D&C2&C1&C&B2&B1&B&!A2&A1&A|E&D&C2&C1&C&B2&B1&B&!A2&A1&A|E&D&!C2&C1&C&B2&B1&B&!A2&A1&A|E&!D&!C2&C1&C&B2&B1&B&!A2&A1&A|E&!D&!C2&C1&!C&B2&B1&B&!A2&A1&A|E&D&!C2&C1&!C&B2&B1&B&!A2&A1&A|E&D&C2&C1&!C&B2&B1&B&!A2&A1&A|E&!D&C2&C1&!C&B2&B1&B&!A2&A1&A|E&!D&C2&!C1&!C&B2&B1&B&!A2&A1&A|E&D&C2&!C1&!C&B2&B1&B&!A2&A1&A|E&D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|E&!D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|E&D&!C2&!C1&!C&B2&!B1&B&!A2&A1&A|E&D&C2&!C1&!C&B2&!B1&B&!A2&A1&A|E&D&C2&C1&!C&B2&!B1&B&!A2&A1&A|E&D&!C2&C1&!C&B2&!B1&B&!A2&A1&A|E&D&!C2&C1&C&B2&!B1&B&!A2&A1&A|E&D&C2&C1&C&B2&!B1&B&!A2&A1&A|E&!D&C2&C1&C&B2&!B1&B&!A2&A1&A|E&D&C2&!C1&C&B2&!B1&B&!A2&A1&A|E&D&!C2&!C1&C&B2&!B1&B&!A2&A1&A|E&D&!C2&!C1&C&!B2&!B1&B&!A2&A1&A|E&D&C2&!C1&C&!B2&!B1&B&!A2&A1&A|E&!D&C2&C1&C&!B2&!B1&B&!A2&A1&A|E&D&C2&C1&C&!B2&!B1&B&!A2&A1&A|E&D&!C2&C1&C&!B2&!B1&B&!A2&A1&A|E&D&!C2&C1&!C&!B2&!B1&B&!A2&A1&A|E&D&C2&C1&!C&!B2&!B1&B&!A2&A1&A|E&D&C2&!C1&!C&!B2&!B1&B&!A2&A1&A|E&D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&A|E&!D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|E&D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|E&D&C2&!C1&!C&!B2&!B1&B&A2&A1&A|E&!D&C2&!C1&!C&!B2&!B1&B&A2&A1&A|E&!D&C2&C1&!C&!B2&!B1&B&A2&A1&A|E&D&C2&C1&!C&!B2&!B1&B&A2&A1&A|E&D&!C2&C1&!C&!B2&!B1&B&A2&A1&A|E&!D&!C2&C1&!C&!B2&!B1&B&A2&A1&A|E&!D&!C2&C1&C&!B2&!B1&B&A2&A1&A|E&D&!C2&C1&C&!B2&!B1&B&A2&A1&A|E&D&C2&C1&C&!B2&!B1&B&A2&A1&A|E&!D&C2&C1&C&!B2&!B1&B&A2&A1&A|E&!D&C2&!C1&C&!B2&!B1&B&A2&A1&A|E&D&C2&!C1&C&!B2&!B1&B&A2&A1&A|E&D&!C2&!C1&C&!B2&!B1&B&A2&A1&A|E&!D&!C2&!C1&C&!B2&!B1&B&A2&A1&A|E&!D&!C2&!C1&C&B2&!B1&B&A2&A1&A|E&D&!C2&!C1&C&B2&!B1&B&A2&A1&A|E&D&C2&!C1&C&B2&!B1&B&A2&A1&A|E&!D&C2&!C1&C&B2&!B1&B&A2&A1&A|E&!D&C2&C1&C&B2&!B1&B&A2&A1&A|E&D&C2&C1&C&B2&!B1&B&A2&A1&A|E&D&!C2&C1&C&B2&!B1&B&A2&A1&A|E&!D&!C2&C1&C&B2&!B1&B&A2&A1&A|E&!D&!C2&C1&!C&B2&!B1&B&A2&A1&A|E&D&!C2&C1&!C&B2&!B1&B&A2&A1&A|E&D&C2&C1&!C&B2&!B1&B&A2&A1&A|E&!D&C2&C1&!C&B2&!B1&B&A2&A1&A|E&!D&C2&!C1&!C&B2&!B1&B&A2&A1&A|E&D&C2&!C1&!C&B2&!B1&B&A2&A1&A|E&D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|E&!D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|E&!D&!C2&!C1&!C&B2&B1&B&A2&A1&A|E&D&!C2&!C1&!C&B2&B1&B&A2&A1&A|E&D&C2&!C1&!C&B2&B1&B&A2&A1&A|E&!D&C2&!C1&!C&B2&B1&B&A2&A1&A|E&!D&C2&C1&!C&B2&B1&B&A2&A1&A|E&D&C2&C1&!C&B2&B1&B&A2&A1&A|E&D&!C2&C1&!C&B2&B1&B&A2&A1&A|E&!D&!C2&C1&!C&B2&B1&B&A2&A1&A|E&!D&!C2&C1&C&B2&B1&B&A2&A1&A|E&D&!C2&C1&C&B2&B1&B&A2&A1&A|E&D&C2&C1&C&B2&B1&B&A2&A1&A|E&!D&C2&C1&C&B2&B1&B&A2&A1&A|E&!D&C2&!C1&C&B2&B1&B&A2&A1&A|E&D&C2&!C1&C&B2&B1&B&A2&A1&A|E&D&!C2&!C1&C&B2&B1&B&A2&A1&A|E&!D&!C2&!C1&C&B2&B1&B&A2&A1&A|E&!D&!C2&!C1&C&!B2&B1&B&A2&A1&A|E&D&!C2&!C1&C&!B2&B1&B&A2&A1&A|E&D&C2&!C1&C&!B2&B1&B&A2&A1&A|E&!D&C2&!C1&C&!B2&B1&B&A2&A1&A|E&!D&C2&C1&C&!B2&B1&B&A2&A1&A|E&D&C2&C1&C&!B2&B1&B&A2&A1&A|E&D&!C2&C1&C&!B2&B1&B&A2&A1&A|E&!D&!C2&C1&C&!B2&B1&B&A2&A1&A|E&!D&!C2&C1&!C&!B2&B1&B&A2&A1&A|E&D&!C2&C1&!C&!B2&B1&B&A2&A1&A|E&D&C2&C1&!C&!B2&B1&B&A2&A1&A|E&!D&C2&C1&!C&!B2&B1&B&A2&A1&A|E&!D&C2&!C1&!C&!B2&B1&B&A2&A1&A|E&D&C2&!C1&!C&!B2&B1&B&A2&A1&A|E&D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|E&!D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|E&!D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|E&D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|E&D&C2&!C1&!C&!B2&B1&!B&A2&A1&A|E&!D&C2&!C1&!C&!B2&B1&!B&A2&A1&A|E&!D&C2&C1&!C&!B2&B1&!B&A2&A1&A|E&D&C2&C1&!C&!B2&B1&!B&A2&A1&A|E&D&!C2&C1&!C&!B2&B1&!B&A2&A1&A|E&!D&!C2&C1&!C&!B2&B1&!B&A2&A1&A|E&!D&!C2&C1&C&!B2&B1&!B&A2&A1&A|E&D&!C2&C1&C&!B2&B1&!B&A2&A1&A|E&D&C2&C1&C&!B2&B1&!B&A2&A1&A|E&!D&C2&C1&C&!B2&B1&!B&A2&A1&A|E&!D&C2&!C1&C&!B2&B1&!B&A2&A1&A|E&D&C2&!C1&C&!B2&B1&!B&A2&A1&A|E&D&!C2&!C1&C&!B2&B1&!B&A2&A1&A|E&!D&!C2&!C1&C&!B2&B1&!B&A2&A1&A|E&!D&!C2&!C1&C&B2&B1&!B&A2&A1&A|E&D&!C2&!C1&C&B2&B1&!B&A2&A1&A|E&D&C2&!C1&C&B2&B1&!B&A2&A1&A|E&!D&C2&!C1&C&B2&B1&!B&A2&A1&A|E&!D&C2&C1&C&B2&B1&!B&A2&A1&A|E&D&C2&C1&C&B2&B1&!B&A2&A1&A|E&D&!C2&C1&C&B2&B1&!B&A2&A1&A|E&!D&!C2&C1&C&B2&B1&!B&A2&A1&A|E&!D&!C2&C1&!C&B2&B1&!B&A2&A1&A|E&D&!C2&C1&!C&B2&B1&!B&A2&A1&A|E&D&C2&C1&!C&B2&B1&!B&A2&A1&A|E&!D&C2&C1&!C&B2&B1&!B&A2&A1&A|E&!D&C2&!C1&!C&B2&B1&!B&A2&A1&A|E&D&C2&!C1&!C&B2&B1&!B&A2&A1&A|E&D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|E&!D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|E&!D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|E&D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|E&D&C2&!C1&!C&B2&!B1&!B&A2&A1&A|E&!D&C2&!C1&!C&B2&!B1&!B&A2&A1&A|E&!D&C2&C1&!C&B2&!B1&!B&A2&A1&A|E&D&C2&C1&!C&B2&!B1&!B&A2&A1&A|E&D&!C2&C1&!C&B2&!B1&!B&A2&A1&A|E&!D&!C2&C1&!C&B2&!B1&!B&A2&A1&A|E&!D&!C2&C1&C&B2&!B1&!B&A2&A1&A|E&D&!C2&C1&C&B2&!B1&!B&A2&A1&A|E&D&C2&C1&C&B2&!B1&!B&A2&A1&A|E&!D&C2&C1&C&B2&!B1&!B&A2&A1&A|E&!D&C2&!C1&C&B2&!B1&!B&A2&A1&A|E&D&C2&!C1&C&B2&!B1&!B&A2&A1&A|E&D&!C2&!C1&C&B2&!B1&!B&A2&A1&A|E&!D&!C2&!C1&C&B2&!B1&!B&A2&A1&A|E&!D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|E&D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|E&D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|E&!D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|E&!D&C2&C1&C&!B2&!B1&!B&A2&A1&A|E&D&C2&C1&C&!B2&!B1&!B&A2&A1&A|E&D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|E&!D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|E&!D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|E&D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|E&D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|E&!D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|E&!D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|E&D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|E&D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|E&!D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|E&D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|E&D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|E&D&C2&C1&!C&!B2&!B1&!B&A2&!A1&A|E&D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&A|E&D&!C2&C1&C&!B2&!B1&!B&A2&!A1&A|E&D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|E&!D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|E&D&C2&!C1&C&!B2&!B1&!B&A2&!A1&A|E&D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&A|E&D&!C2&!C1&C&B2&!B1&!B&A2&!A1&A|E&D&C2&!C1&C&B2&!B1&!B&A2&!A1&A|E&!D&C2&C1&C&B2&!B1&!B&A2&!A1&A|E&D&C2&C1&C&B2&!B1&!B&A2&!A1&A|E&D&!C2&C1&C&B2&!B1&!B&A2&!A1&A|E&D&!C2&C1&!C&B2&!B1&!B&A2&!A1&A|E&D&C2&C1&!C&B2&!B1&!B&A2&!A1&A|E&D&C2&!C1&!C&B2&!B1&!B&A2&!A1&A|E&D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&A|E&D&!C2&!C1&!C&B2&B1&!B&A2&!A1&A|E&D&C2&!C1&!C&B2&B1&!B&A2&!A1&A|E&D&C2&C1&!C&B2&B1&!B&A2&!A1&A|E&D&!C2&C1&!C&B2&B1&!B&A2&!A1&A|E&D&!C2&C1&C&B2&B1&!B&A2&!A1&A|E&D&C2&C1&C&B2&B1&!B&A2&!A1&A|E&!D&C2&C1&C&B2&B1&!B&A2&!A1&A|E&D&C2&!C1&C&B2&B1&!B&A2&!A1&A|E&D&!C2&!C1&C&B2&B1&!B&A2&!A1&A|E&D&!C2&!C1&C&!B2&B1&!B&A2&!A1&A|E&D&C2&!C1&C&!B2&B1&!B&A2&!A1&A|E&!D&C2&C1&C&!B2&B1&!B&A2&!A1&A|E&D&C2&C1&C&!B2&B1&!B&A2&!A1&A|E&D&!C2&C1&C&!B2&B1&!B&A2&!A1&A|E&D&!C2&C1&!C&!B2&B1&!B&A2&!A1&A|E&D&C2&C1&!C&!B2&B1&!B&A2&!A1&A|E&D&C2&!C1&!C&!B2&B1&!B&A2&!A1&A|E&D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&A|E&D&!C2&!C1&!C&!B2&B1&B&A2&!A1&A|E&D&C2&!C1&!C&!B2&B1&B&A2&!A1&A|E&D&C2&C1&!C&!B2&B1&B&A2&!A1&A|E&D&!C2&C1&!C&!B2&B1&B&A2&!A1&A|E&D&!C2&C1&C&!B2&B1&B&A2&!A1&A|E&D&C2&C1&C&!B2&B1&B&A2&!A1&A|E&!D&C2&C1&C&!B2&B1&B&A2&!A1&A|E&D&C2&!C1&C&!B2&B1&B&A2&!A1&A|E&D&!C2&!C1&C&!B2&B1&B&A2&!A1&A|E&!D&!C2&!C1&C&B2&B1&B&A2&!A1&A|E&D&!C2&!C1&C&B2&B1&B&A2&!A1&A|E&D&C2&!C1&C&B2&B1&B&A2&!A1&A|E&!D&C2&!C1&C&B2&B1&B&A2&!A1&A|E&!D&C2&C1&C&B2&B1&B&A2&!A1&A|E&D&C2&C1&C&B2&B1&B&A2&!A1&A|E&D&!C2&C1&C&B2&B1&B&A2&!A1&A|E&!D&!C2&C1&C&B2&B1&B&A2&!A1&A|E&!D&!C2&C1&!C&B2&B1&B&A2&!A1&A|E&D&!C2&C1&!C&B2&B1&B&A2&!A1&A|E&D&C2&C1&!C&B2&B1&B&A2&!A1&A|E&!D&C2&C1&!C&B2&B1&B&A2&!A1&A|E&!D&C2&!C1&!C&B2&B1&B&A2&!A1&A|E&D&C2&!C1&!C&B2&B1&B&A2&!A1&A|E&D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|E&!D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|E&D&!C2&!C1&!C&B2&!B1&B&A2&!A1&A|E&D&C2&!C1&!C&B2&!B1&B&A2&!A1&A|E&D&C2&C1&!C&B2&!B1&B&A2&!A1&A|E&D&!C2&C1&!C&B2&!B1&B&A2&!A1&A|E&D&!C2&C1&C&B2&!B1&B&A2&!A1&A|E&D&C2&C1&C&B2&!B1&B&A2&!A1&A|E&!D&C2&C1&C&B2&!B1&B&A2&!A1&A|E&D&C2&!C1&C&B2&!B1&B&A2&!A1&A|E&D&!C2&!C1&C&B2&!B1&B&A2&!A1&A|E&D&!C2&!C1&C&!B2&!B1&B&A2&!A1&A|E&D&C2&!C1&C&!B2&!B1&B&A2&!A1&A|E&!D&C2&C1&C&!B2&!B1&B&A2&!A1&A|E&D&C2&C1&C&!B2&!B1&B&A2&!A1&A|E&D&!C2&C1&C&!B2&!B1&B&A2&!A1&A|E&D&!C2&C1&!C&!B2&!B1&B&A2&!A1&A|E&D&C2&C1&!C&!B2&!B1&B&A2&!A1&A|E&D&C2&!C1&!C&!B2&!B1&B&A2&!A1&A|E&D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&A|E&D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|E&D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|E&D&C2&C1&!C&!B2&!B1&B&!A2&!A1&A|E&D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&A|E&D&!C2&C1&C&!B2&!B1&B&!A2&!A1&A|E&D&C2&C1&C&!B2&!B1&B&!A2&!A1&A|E&!D&C2&C1&C&!B2&!B1&B&!A2&!A1&A|E&D&C2&!C1&C&!B2&!B1&B&!A2&!A1&A|E&D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&A|E&D&!C2&!C1&C&B2&!B1&B&!A2&!A1&A|E&D&C2&!C1&C&B2&!B1&B&!A2&!A1&A|E&!D&C2&C1&C&B2&!B1&B&!A2&!A1&A|E&D&C2&C1&C&B2&!B1&B&!A2&!A1&A|E&D&!C2&C1&C&B2&!B1&B&!A2&!A1&A|E&D&!C2&C1&!C&B2&!B1&B&!A2&!A1&A|E&D&C2&C1&!C&B2&!B1&B&!A2&!A1&A|E&D&C2&!C1&!C&B2&!B1&B&!A2&!A1&A|E&D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&A|E&!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|E&D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|E&D&C2&!C1&!C&B2&B1&B&!A2&!A1&A|E&!D&C2&!C1&!C&B2&B1&B&!A2&!A1&A|E&!D&C2&C1&!C&B2&B1&B&!A2&!A1&A|E&D&C2&C1&!C&B2&B1&B&!A2&!A1&A|E&D&!C2&C1&!C&B2&B1&B&!A2&!A1&A|E&!D&!C2&C1&!C&B2&B1&B&!A2&!A1&A|E&!D&!C2&C1&C&B2&B1&B&!A2&!A1&A|E&D&!C2&C1&C&B2&B1&B&!A2&!A1&A|E&D&C2&C1&C&B2&B1&B&!A2&!A1&A|E&!D&C2&C1&C&B2&B1&B&!A2&!A1&A|E&!D&C2&!C1&C&B2&B1&B&!A2&!A1&A|E&D&C2&!C1&C&B2&B1&B&!A2&!A1&A|E&D&!C2&!C1&C&B2&B1&B&!A2&!A1&A|E&!D&!C2&!C1&C&B2&B1&B&!A2&!A1&A|E&D&!C2&!C1&C&!B2&B1&B&!A2&!A1&A|E&D&C2&!C1&C&!B2&B1&B&!A2&!A1&A|E&!D&C2&C1&C&!B2&B1&B&!A2&!A1&A|E&D&C2&C1&C&!B2&B1&B&!A2&!A1&A|E&D&!C2&C1&C&!B2&B1&B&!A2&!A1&A|E&D&!C2&C1&!C&!B2&B1&B&!A2&!A1&A|E&D&C2&C1&!C&!B2&B1&B&!A2&!A1&A|E&D&C2&!C1&!C&!B2&B1&B&!A2&!A1&A|E&D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&A|E&D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|E&D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|E&D&C2&C1&!C&!B2&B1&!B&!A2&!A1&A|E&D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&A|E&D&!C2&C1&C&!B2&B1&!B&!A2&!A1&A|E&D&C2&C1&C&!B2&B1&!B&!A2&!A1&A|E&!D&C2&C1&C&!B2&B1&!B&!A2&!A1&A|E&D&C2&!C1&C&!B2&B1&!B&!A2&!A1&A|E&D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&A|E&D&!C2&!C1&C&B2&B1&!B&!A2&!A1&A|E&D&C2&!C1&C&B2&B1&!B&!A2&!A1&A|E&!D&C2&C1&C&B2&B1&!B&!A2&!A1&A|E&D&C2&C1&C&B2&B1&!B&!A2&!A1&A|E&D&!C2&C1&C&B2&B1&!B&!A2&!A1&A|E&D&!C2&C1&!C&B2&B1&!B&!A2&!A1&A|E&D&C2&C1&!C&B2&B1&!B&!A2&!A1&A|E&D&C2&!C1&!C&B2&B1&!B&!A2&!A1&A|E&D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&A|E&D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|E&D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|E&D&C2&C1&!C&B2&!B1&!B&!A2&!A1&A|E&D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&A|E&D&!C2&C1&C&B2&!B1&!B&!A2&!A1&A|E&D&C2&C1&C&B2&!B1&!B&!A2&!A1&A|E&!D&C2&C1&C&B2&!B1&!B&!A2&!A1&A|E&D&C2&!C1&C&B2&!B1&!B&!A2&!A1&A|E&D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&A|E&D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|E&D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|E&!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A|E&D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A|E&D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&A|E&D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|E&D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|E&D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|E&D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOAI33311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAAOI2223 -l OOOAAOI2223 -i D2 D1 D C1 C B1 B A1 A -o Y -f Y=!(D2&D1&D&!C1&!C&!B1&!B&!A1&!A|D2&D1&D&C1&!C&!B1&!B&!A1&!A|D2&D1&D&C1&C&!B1&!B&!A1&!A|D2&D1&D&!C1&C&!B1&!B&!A1&!A|D2&D1&D&!C1&C&B1&!B&!A1&!A|D2&D1&D&C1&C&B1&!B&!A1&!A|D2&D1&D&C1&!C&B1&!B&!A1&!A|D2&D1&D&!C1&!C&B1&!B&!A1&!A|D2&D1&D&!C1&!C&B1&B&!A1&!A|D2&D1&D&C1&!C&B1&B&!A1&!A|D2&D1&D&C1&C&B1&B&!A1&!A|D2&D1&D&!C1&C&B1&B&!A1&!A|D2&D1&D&!C1&C&!B1&B&!A1&!A|D2&D1&D&C1&C&!B1&B&!A1&!A|D2&D1&D&C1&!C&!B1&B&!A1&!A|D2&D1&D&!C1&!C&!B1&B&!A1&!A|D2&D1&D&!C1&!C&!B1&B&A1&!A|!D2&!D1&D&C1&!C&!B1&B&A1&!A|D2&!D1&D&C1&!C&!B1&B&A1&!A|D2&D1&D&C1&!C&!B1&B&A1&!A|!D2&D1&D&C1&!C&!B1&B&A1&!A|!D2&D1&!D&C1&!C&!B1&B&A1&!A|D2&D1&!D&C1&!C&!B1&B&A1&!A|D2&!D1&!D&C1&!C&!B1&B&A1&!A|!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!D2&!D1&!D&C1&C&!B1&B&A1&!A|D2&!D1&!D&C1&C&!B1&B&A1&!A|D2&D1&!D&C1&C&!B1&B&A1&!A|!D2&D1&!D&C1&C&!B1&B&A1&!A|!D2&D1&D&C1&C&!B1&B&A1&!A|D2&D1&D&C1&C&!B1&B&A1&!A|D2&!D1&D&C1&C&!B1&B&A1&!A|!D2&!D1&D&C1&C&!B1&B&A1&!A|!D2&!D1&D&!C1&C&!B1&B&A1&!A|D2&!D1&D&!C1&C&!B1&B&A1&!A|D2&D1&D&!C1&C&!B1&B&A1&!A|!D2&D1&D&!C1&C&!B1&B&A1&!A|!D2&D1&!D&!C1&C&!B1&B&A1&!A|D2&D1&!D&!C1&C&!B1&B&A1&!A|D2&!D1&!D&!C1&C&!B1&B&A1&!A|!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!D2&!D1&!D&!C1&C&B1&B&A1&!A|D2&!D1&!D&!C1&C&B1&B&A1&!A|D2&D1&!D&!C1&C&B1&B&A1&!A|!D2&D1&!D&!C1&C&B1&B&A1&!A|!D2&D1&D&!C1&C&B1&B&A1&!A|D2&D1&D&!C1&C&B1&B&A1&!A|D2&!D1&D&!C1&C&B1&B&A1&!A|!D2&!D1&D&!C1&C&B1&B&A1&!A|!D2&!D1&D&C1&C&B1&B&A1&!A|D2&!D1&D&C1&C&B1&B&A1&!A|D2&D1&D&C1&C&B1&B&A1&!A|!D2&D1&D&C1&C&B1&B&A1&!A|!D2&D1&!D&C1&C&B1&B&A1&!A|D2&D1&!D&C1&C&B1&B&A1&!A|D2&!D1&!D&C1&C&B1&B&A1&!A|!D2&!D1&!D&C1&C&B1&B&A1&!A|!D2&!D1&!D&C1&!C&B1&B&A1&!A|D2&!D1&!D&C1&!C&B1&B&A1&!A|D2&D1&!D&C1&!C&B1&B&A1&!A|!D2&D1&!D&C1&!C&B1&B&A1&!A|!D2&D1&D&C1&!C&B1&B&A1&!A|D2&D1&D&C1&!C&B1&B&A1&!A|D2&!D1&D&C1&!C&B1&B&A1&!A|!D2&!D1&D&C1&!C&B1&B&A1&!A|D2&D1&D&!C1&!C&B1&B&A1&!A|D2&D1&D&!C1&!C&B1&!B&A1&!A|!D2&!D1&D&C1&!C&B1&!B&A1&!A|D2&!D1&D&C1&!C&B1&!B&A1&!A|D2&D1&D&C1&!C&B1&!B&A1&!A|!D2&D1&D&C1&!C&B1&!B&A1&!A|!D2&D1&!D&C1&!C&B1&!B&A1&!A|D2&D1&!D&C1&!C&B1&!B&A1&!A|D2&!D1&!D&C1&!C&B1&!B&A1&!A|!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!D2&!D1&!D&C1&C&B1&!B&A1&!A|D2&!D1&!D&C1&C&B1&!B&A1&!A|D2&D1&!D&C1&C&B1&!B&A1&!A|!D2&D1&!D&C1&C&B1&!B&A1&!A|!D2&D1&D&C1&C&B1&!B&A1&!A|D2&D1&D&C1&C&B1&!B&A1&!A|D2&!D1&D&C1&C&B1&!B&A1&!A|!D2&!D1&D&C1&C&B1&!B&A1&!A|!D2&!D1&D&!C1&C&B1&!B&A1&!A|D2&!D1&D&!C1&C&B1&!B&A1&!A|D2&D1&D&!C1&C&B1&!B&A1&!A|!D2&D1&D&!C1&C&B1&!B&A1&!A|!D2&D1&!D&!C1&C&B1&!B&A1&!A|D2&D1&!D&!C1&C&B1&!B&A1&!A|D2&!D1&!D&!C1&C&B1&!B&A1&!A|!D2&!D1&!D&!C1&C&B1&!B&A1&!A|D2&D1&D&!C1&C&!B1&!B&A1&!A|D2&D1&D&C1&C&!B1&!B&A1&!A|D2&D1&D&C1&!C&!B1&!B&A1&!A|D2&D1&D&!C1&!C&!B1&!B&A1&!A|D2&D1&D&!C1&!C&!B1&!B&A1&A|D2&D1&D&C1&!C&!B1&!B&A1&A|D2&D1&D&C1&C&!B1&!B&A1&A|D2&D1&D&!C1&C&!B1&!B&A1&A|!D2&!D1&!D&!C1&C&B1&!B&A1&A|D2&!D1&!D&!C1&C&B1&!B&A1&A|D2&D1&!D&!C1&C&B1&!B&A1&A|!D2&D1&!D&!C1&C&B1&!B&A1&A|!D2&D1&D&!C1&C&B1&!B&A1&A|D2&D1&D&!C1&C&B1&!B&A1&A|D2&!D1&D&!C1&C&B1&!B&A1&A|!D2&!D1&D&!C1&C&B1&!B&A1&A|!D2&!D1&D&C1&C&B1&!B&A1&A|D2&!D1&D&C1&C&B1&!B&A1&A|D2&D1&D&C1&C&B1&!B&A1&A|!D2&D1&D&C1&C&B1&!B&A1&A|!D2&D1&!D&C1&C&B1&!B&A1&A|D2&D1&!D&C1&C&B1&!B&A1&A|D2&!D1&!D&C1&C&B1&!B&A1&A|!D2&!D1&!D&C1&C&B1&!B&A1&A|!D2&!D1&!D&C1&!C&B1&!B&A1&A|D2&!D1&!D&C1&!C&B1&!B&A1&A|D2&D1&!D&C1&!C&B1&!B&A1&A|!D2&D1&!D&C1&!C&B1&!B&A1&A|!D2&D1&D&C1&!C&B1&!B&A1&A|D2&D1&D&C1&!C&B1&!B&A1&A|D2&!D1&D&C1&!C&B1&!B&A1&A|!D2&!D1&D&C1&!C&B1&!B&A1&A|D2&D1&D&!C1&!C&B1&!B&A1&A|D2&D1&D&!C1&!C&B1&B&A1&A|!D2&!D1&D&C1&!C&B1&B&A1&A|D2&!D1&D&C1&!C&B1&B&A1&A|D2&D1&D&C1&!C&B1&B&A1&A|!D2&D1&D&C1&!C&B1&B&A1&A|!D2&D1&!D&C1&!C&B1&B&A1&A|D2&D1&!D&C1&!C&B1&B&A1&A|D2&!D1&!D&C1&!C&B1&B&A1&A|!D2&!D1&!D&C1&!C&B1&B&A1&A|!D2&!D1&!D&C1&C&B1&B&A1&A|D2&!D1&!D&C1&C&B1&B&A1&A|D2&D1&!D&C1&C&B1&B&A1&A|!D2&D1&!D&C1&C&B1&B&A1&A|!D2&D1&D&C1&C&B1&B&A1&A|D2&D1&D&C1&C&B1&B&A1&A|D2&!D1&D&C1&C&B1&B&A1&A|!D2&!D1&D&C1&C&B1&B&A1&A|!D2&!D1&D&!C1&C&B1&B&A1&A|D2&!D1&D&!C1&C&B1&B&A1&A|D2&D1&D&!C1&C&B1&B&A1&A|!D2&D1&D&!C1&C&B1&B&A1&A|!D2&D1&!D&!C1&C&B1&B&A1&A|D2&D1&!D&!C1&C&B1&B&A1&A|D2&!D1&!D&!C1&C&B1&B&A1&A|!D2&!D1&!D&!C1&C&B1&B&A1&A|!D2&!D1&!D&!C1&C&!B1&B&A1&A|D2&!D1&!D&!C1&C&!B1&B&A1&A|D2&D1&!D&!C1&C&!B1&B&A1&A|!D2&D1&!D&!C1&C&!B1&B&A1&A|!D2&D1&D&!C1&C&!B1&B&A1&A|D2&D1&D&!C1&C&!B1&B&A1&A|D2&!D1&D&!C1&C&!B1&B&A1&A|!D2&!D1&D&!C1&C&!B1&B&A1&A|!D2&!D1&D&C1&C&!B1&B&A1&A|D2&!D1&D&C1&C&!B1&B&A1&A|D2&D1&D&C1&C&!B1&B&A1&A|!D2&D1&D&C1&C&!B1&B&A1&A|!D2&D1&!D&C1&C&!B1&B&A1&A|D2&D1&!D&C1&C&!B1&B&A1&A|D2&!D1&!D&C1&C&!B1&B&A1&A|!D2&!D1&!D&C1&C&!B1&B&A1&A|!D2&!D1&!D&C1&!C&!B1&B&A1&A|D2&!D1&!D&C1&!C&!B1&B&A1&A|D2&D1&!D&C1&!C&!B1&B&A1&A|!D2&D1&!D&C1&!C&!B1&B&A1&A|!D2&D1&D&C1&!C&!B1&B&A1&A|D2&D1&D&C1&!C&!B1&B&A1&A|D2&!D1&D&C1&!C&!B1&B&A1&A|!D2&!D1&D&C1&!C&!B1&B&A1&A|D2&D1&D&!C1&!C&!B1&B&A1&A|D2&D1&D&!C1&!C&!B1&B&!A1&A|!D2&!D1&D&C1&!C&!B1&B&!A1&A|D2&!D1&D&C1&!C&!B1&B&!A1&A|D2&D1&D&C1&!C&!B1&B&!A1&A|!D2&D1&D&C1&!C&!B1&B&!A1&A|!D2&D1&!D&C1&!C&!B1&B&!A1&A|D2&D1&!D&C1&!C&!B1&B&!A1&A|D2&!D1&!D&C1&!C&!B1&B&!A1&A|!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!D2&!D1&!D&C1&C&!B1&B&!A1&A|D2&!D1&!D&C1&C&!B1&B&!A1&A|D2&D1&!D&C1&C&!B1&B&!A1&A|!D2&D1&!D&C1&C&!B1&B&!A1&A|!D2&D1&D&C1&C&!B1&B&!A1&A|D2&D1&D&C1&C&!B1&B&!A1&A|D2&!D1&D&C1&C&!B1&B&!A1&A|!D2&!D1&D&C1&C&!B1&B&!A1&A|!D2&!D1&D&!C1&C&!B1&B&!A1&A|D2&!D1&D&!C1&C&!B1&B&!A1&A|D2&D1&D&!C1&C&!B1&B&!A1&A|!D2&D1&D&!C1&C&!B1&B&!A1&A|!D2&D1&!D&!C1&C&!B1&B&!A1&A|D2&D1&!D&!C1&C&!B1&B&!A1&A|D2&!D1&!D&!C1&C&!B1&B&!A1&A|!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!D2&!D1&!D&!C1&C&B1&B&!A1&A|D2&!D1&!D&!C1&C&B1&B&!A1&A|D2&D1&!D&!C1&C&B1&B&!A1&A|!D2&D1&!D&!C1&C&B1&B&!A1&A|!D2&D1&D&!C1&C&B1&B&!A1&A|D2&D1&D&!C1&C&B1&B&!A1&A|D2&!D1&D&!C1&C&B1&B&!A1&A|!D2&!D1&D&!C1&C&B1&B&!A1&A|!D2&!D1&D&C1&C&B1&B&!A1&A|D2&!D1&D&C1&C&B1&B&!A1&A|D2&D1&D&C1&C&B1&B&!A1&A|!D2&D1&D&C1&C&B1&B&!A1&A|!D2&D1&!D&C1&C&B1&B&!A1&A|D2&D1&!D&C1&C&B1&B&!A1&A|D2&!D1&!D&C1&C&B1&B&!A1&A|!D2&!D1&!D&C1&C&B1&B&!A1&A|!D2&!D1&!D&C1&!C&B1&B&!A1&A|D2&!D1&!D&C1&!C&B1&B&!A1&A|D2&D1&!D&C1&!C&B1&B&!A1&A|!D2&D1&!D&C1&!C&B1&B&!A1&A|!D2&D1&D&C1&!C&B1&B&!A1&A|D2&D1&D&C1&!C&B1&B&!A1&A|D2&!D1&D&C1&!C&B1&B&!A1&A|!D2&!D1&D&C1&!C&B1&B&!A1&A|D2&D1&D&!C1&!C&B1&B&!A1&A|D2&D1&D&!C1&!C&B1&!B&!A1&A|!D2&!D1&D&C1&!C&B1&!B&!A1&A|D2&!D1&D&C1&!C&B1&!B&!A1&A|D2&D1&D&C1&!C&B1&!B&!A1&A|!D2&D1&D&C1&!C&B1&!B&!A1&A|!D2&D1&!D&C1&!C&B1&!B&!A1&A|D2&D1&!D&C1&!C&B1&!B&!A1&A|D2&!D1&!D&C1&!C&B1&!B&!A1&A|!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!D2&!D1&!D&C1&C&B1&!B&!A1&A|D2&!D1&!D&C1&C&B1&!B&!A1&A|D2&D1&!D&C1&C&B1&!B&!A1&A|!D2&D1&!D&C1&C&B1&!B&!A1&A|!D2&D1&D&C1&C&B1&!B&!A1&A|D2&D1&D&C1&C&B1&!B&!A1&A|D2&!D1&D&C1&C&B1&!B&!A1&A|!D2&!D1&D&C1&C&B1&!B&!A1&A|!D2&!D1&D&!C1&C&B1&!B&!A1&A|D2&!D1&D&!C1&C&B1&!B&!A1&A|D2&D1&D&!C1&C&B1&!B&!A1&A|!D2&D1&D&!C1&C&B1&!B&!A1&A|!D2&D1&!D&!C1&C&B1&!B&!A1&A|D2&D1&!D&!C1&C&B1&!B&!A1&A|D2&!D1&!D&!C1&C&B1&!B&!A1&A|!D2&!D1&!D&!C1&C&B1&!B&!A1&A|D2&D1&D&!C1&C&!B1&!B&!A1&A|D2&D1&D&C1&C&!B1&!B&!A1&A|D2&D1&D&C1&!C&!B1&!B&!A1&A|D2&D1&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAAOI2223.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAOAI22221 -l AAOOAOAI22221 -i E D1 D C1 C B1 B A1 A -o Y -f Y=!(E&D1&!D&!C1&!C&!B1&!B&!A1&!A|E&D1&D&!C1&!C&!B1&!B&!A1&!A|E&!D1&D&!C1&!C&!B1&!B&!A1&!A|E&!D1&D&C1&!C&!B1&!B&!A1&!A|E&D1&D&C1&!C&!B1&!B&!A1&!A|E&D1&!D&C1&!C&!B1&!B&!A1&!A|E&D1&!D&C1&C&!B1&!B&!A1&!A|E&D1&D&C1&C&!B1&!B&!A1&!A|E&!D1&D&C1&C&!B1&!B&!A1&!A|E&!D1&D&!C1&C&!B1&!B&!A1&!A|E&D1&D&!C1&C&!B1&!B&!A1&!A|E&D1&!D&!C1&C&!B1&!B&!A1&!A|E&D1&!D&!C1&C&B1&!B&!A1&!A|E&D1&D&!C1&C&B1&!B&!A1&!A|E&!D1&D&!C1&C&B1&!B&!A1&!A|E&!D1&D&C1&C&B1&!B&!A1&!A|E&D1&D&C1&C&B1&!B&!A1&!A|E&D1&!D&C1&C&B1&!B&!A1&!A|E&D1&!D&C1&!C&B1&!B&!A1&!A|E&D1&D&C1&!C&B1&!B&!A1&!A|E&!D1&D&C1&!C&B1&!B&!A1&!A|E&!D1&D&!C1&!C&B1&!B&!A1&!A|E&D1&D&!C1&!C&B1&!B&!A1&!A|E&D1&!D&!C1&!C&B1&!B&!A1&!A|E&D1&!D&!C1&!C&B1&B&!A1&!A|E&D1&D&!C1&!C&B1&B&!A1&!A|E&!D1&D&!C1&!C&B1&B&!A1&!A|E&!D1&D&C1&!C&B1&B&!A1&!A|E&D1&D&C1&!C&B1&B&!A1&!A|E&D1&!D&C1&!C&B1&B&!A1&!A|E&!D1&!D&C1&!C&B1&B&!A1&!A|E&!D1&!D&C1&C&B1&B&!A1&!A|E&D1&!D&C1&C&B1&B&!A1&!A|E&D1&D&C1&C&B1&B&!A1&!A|E&!D1&D&C1&C&B1&B&!A1&!A|E&!D1&D&!C1&C&B1&B&!A1&!A|E&D1&D&!C1&C&B1&B&!A1&!A|E&D1&!D&!C1&C&B1&B&!A1&!A|E&!D1&!D&!C1&C&B1&B&!A1&!A|E&D1&!D&!C1&C&!B1&B&!A1&!A|E&D1&D&!C1&C&!B1&B&!A1&!A|E&!D1&D&!C1&C&!B1&B&!A1&!A|E&!D1&D&C1&C&!B1&B&!A1&!A|E&D1&D&C1&C&!B1&B&!A1&!A|E&D1&!D&C1&C&!B1&B&!A1&!A|E&D1&!D&C1&!C&!B1&B&!A1&!A|E&D1&D&C1&!C&!B1&B&!A1&!A|E&!D1&D&C1&!C&!B1&B&!A1&!A|E&!D1&D&!C1&!C&!B1&B&!A1&!A|E&D1&D&!C1&!C&!B1&B&!A1&!A|E&D1&!D&!C1&!C&!B1&B&!A1&!A|E&D1&!D&!C1&!C&!B1&B&A1&!A|E&D1&D&!C1&!C&!B1&B&A1&!A|E&!D1&D&!C1&!C&!B1&B&A1&!A|E&!D1&D&C1&!C&!B1&B&A1&!A|E&D1&D&C1&!C&!B1&B&A1&!A|E&D1&!D&C1&!C&!B1&B&A1&!A|E&D1&!D&C1&C&!B1&B&A1&!A|E&D1&D&C1&C&!B1&B&A1&!A|E&!D1&D&C1&C&!B1&B&A1&!A|E&!D1&D&!C1&C&!B1&B&A1&!A|E&D1&D&!C1&C&!B1&B&A1&!A|E&D1&!D&!C1&C&!B1&B&A1&!A|E&!D1&!D&!C1&C&B1&B&A1&!A|E&D1&!D&!C1&C&B1&B&A1&!A|E&D1&D&!C1&C&B1&B&A1&!A|E&!D1&D&!C1&C&B1&B&A1&!A|E&!D1&D&C1&C&B1&B&A1&!A|E&D1&D&C1&C&B1&B&A1&!A|E&D1&!D&C1&C&B1&B&A1&!A|E&!D1&!D&C1&C&B1&B&A1&!A|E&!D1&!D&C1&!C&B1&B&A1&!A|E&D1&!D&C1&!C&B1&B&A1&!A|E&D1&D&C1&!C&B1&B&A1&!A|E&!D1&D&C1&!C&B1&B&A1&!A|E&!D1&D&!C1&!C&B1&B&A1&!A|E&D1&D&!C1&!C&B1&B&A1&!A|E&D1&!D&!C1&!C&B1&B&A1&!A|E&D1&!D&!C1&!C&B1&!B&A1&!A|E&D1&D&!C1&!C&B1&!B&A1&!A|E&!D1&D&!C1&!C&B1&!B&A1&!A|E&!D1&D&C1&!C&B1&!B&A1&!A|E&D1&D&C1&!C&B1&!B&A1&!A|E&D1&!D&C1&!C&B1&!B&A1&!A|E&D1&!D&C1&C&B1&!B&A1&!A|E&D1&D&C1&C&B1&!B&A1&!A|E&!D1&D&C1&C&B1&!B&A1&!A|E&!D1&D&!C1&C&B1&!B&A1&!A|E&D1&D&!C1&C&B1&!B&A1&!A|E&D1&!D&!C1&C&B1&!B&A1&!A|E&D1&!D&!C1&C&!B1&!B&A1&!A|E&D1&D&!C1&C&!B1&!B&A1&!A|E&!D1&D&!C1&C&!B1&!B&A1&!A|E&!D1&D&C1&C&!B1&!B&A1&!A|E&D1&D&C1&C&!B1&!B&A1&!A|E&D1&!D&C1&C&!B1&!B&A1&!A|E&D1&!D&C1&!C&!B1&!B&A1&!A|E&D1&D&C1&!C&!B1&!B&A1&!A|E&!D1&D&C1&!C&!B1&!B&A1&!A|E&!D1&D&!C1&!C&!B1&!B&A1&!A|E&D1&D&!C1&!C&!B1&!B&A1&!A|E&D1&!D&!C1&!C&!B1&!B&A1&!A|E&D1&!D&!C1&!C&!B1&!B&A1&A|E&D1&D&!C1&!C&!B1&!B&A1&A|E&!D1&D&!C1&!C&!B1&!B&A1&A|E&!D1&D&C1&!C&!B1&!B&A1&A|E&D1&D&C1&!C&!B1&!B&A1&A|E&D1&!D&C1&!C&!B1&!B&A1&A|E&!D1&!D&C1&!C&!B1&!B&A1&A|E&!D1&!D&C1&C&!B1&!B&A1&A|E&D1&!D&C1&C&!B1&!B&A1&A|E&D1&D&C1&C&!B1&!B&A1&A|E&!D1&D&C1&C&!B1&!B&A1&A|E&!D1&D&!C1&C&!B1&!B&A1&A|E&D1&D&!C1&C&!B1&!B&A1&A|E&D1&!D&!C1&C&!B1&!B&A1&A|E&!D1&!D&!C1&C&!B1&!B&A1&A|E&!D1&!D&!C1&C&B1&!B&A1&A|E&D1&!D&!C1&C&B1&!B&A1&A|E&D1&D&!C1&C&B1&!B&A1&A|E&!D1&D&!C1&C&B1&!B&A1&A|E&!D1&D&C1&C&B1&!B&A1&A|E&D1&D&C1&C&B1&!B&A1&A|E&D1&!D&C1&C&B1&!B&A1&A|E&!D1&!D&C1&C&B1&!B&A1&A|E&!D1&!D&C1&!C&B1&!B&A1&A|E&D1&!D&C1&!C&B1&!B&A1&A|E&D1&D&C1&!C&B1&!B&A1&A|E&!D1&D&C1&!C&B1&!B&A1&A|E&!D1&D&!C1&!C&B1&!B&A1&A|E&D1&D&!C1&!C&B1&!B&A1&A|E&D1&!D&!C1&!C&B1&!B&A1&A|E&D1&!D&!C1&!C&B1&B&A1&A|E&D1&D&!C1&!C&B1&B&A1&A|E&!D1&D&!C1&!C&B1&B&A1&A|E&!D1&D&C1&!C&B1&B&A1&A|E&D1&D&C1&!C&B1&B&A1&A|E&D1&!D&C1&!C&B1&B&A1&A|E&!D1&!D&C1&!C&B1&B&A1&A|E&!D1&!D&C1&C&B1&B&A1&A|E&D1&!D&C1&C&B1&B&A1&A|E&D1&D&C1&C&B1&B&A1&A|E&!D1&D&C1&C&B1&B&A1&A|E&!D1&D&!C1&C&B1&B&A1&A|E&D1&D&!C1&C&B1&B&A1&A|E&D1&!D&!C1&C&B1&B&A1&A|E&!D1&!D&!C1&C&B1&B&A1&A|E&!D1&!D&!C1&C&!B1&B&A1&A|E&D1&!D&!C1&C&!B1&B&A1&A|E&D1&D&!C1&C&!B1&B&A1&A|E&!D1&D&!C1&C&!B1&B&A1&A|E&!D1&D&C1&C&!B1&B&A1&A|E&D1&D&C1&C&!B1&B&A1&A|E&D1&!D&C1&C&!B1&B&A1&A|E&!D1&!D&C1&C&!B1&B&A1&A|E&!D1&!D&C1&!C&!B1&B&A1&A|E&D1&!D&C1&!C&!B1&B&A1&A|E&D1&D&C1&!C&!B1&B&A1&A|E&!D1&D&C1&!C&!B1&B&A1&A|E&!D1&D&!C1&!C&!B1&B&A1&A|E&D1&D&!C1&!C&!B1&B&A1&A|E&D1&!D&!C1&!C&!B1&B&A1&A|E&D1&!D&!C1&!C&!B1&B&!A1&A|E&D1&D&!C1&!C&!B1&B&!A1&A|E&!D1&D&!C1&!C&!B1&B&!A1&A|E&!D1&D&C1&!C&!B1&B&!A1&A|E&D1&D&C1&!C&!B1&B&!A1&A|E&D1&!D&C1&!C&!B1&B&!A1&A|E&D1&!D&C1&C&!B1&B&!A1&A|E&D1&D&C1&C&!B1&B&!A1&A|E&!D1&D&C1&C&!B1&B&!A1&A|E&!D1&D&!C1&C&!B1&B&!A1&A|E&D1&D&!C1&C&!B1&B&!A1&A|E&D1&!D&!C1&C&!B1&B&!A1&A|E&!D1&!D&!C1&C&B1&B&!A1&A|E&D1&!D&!C1&C&B1&B&!A1&A|E&D1&D&!C1&C&B1&B&!A1&A|E&!D1&D&!C1&C&B1&B&!A1&A|E&!D1&D&C1&C&B1&B&!A1&A|E&D1&D&C1&C&B1&B&!A1&A|E&D1&!D&C1&C&B1&B&!A1&A|E&!D1&!D&C1&C&B1&B&!A1&A|E&!D1&!D&C1&!C&B1&B&!A1&A|E&D1&!D&C1&!C&B1&B&!A1&A|E&D1&D&C1&!C&B1&B&!A1&A|E&!D1&D&C1&!C&B1&B&!A1&A|E&!D1&D&!C1&!C&B1&B&!A1&A|E&D1&D&!C1&!C&B1&B&!A1&A|E&D1&!D&!C1&!C&B1&B&!A1&A|E&D1&!D&!C1&!C&B1&!B&!A1&A|E&D1&D&!C1&!C&B1&!B&!A1&A|E&!D1&D&!C1&!C&B1&!B&!A1&A|E&!D1&D&C1&!C&B1&!B&!A1&A|E&D1&D&C1&!C&B1&!B&!A1&A|E&D1&!D&C1&!C&B1&!B&!A1&A|E&D1&!D&C1&C&B1&!B&!A1&A|E&D1&D&C1&C&B1&!B&!A1&A|E&!D1&D&C1&C&B1&!B&!A1&A|E&!D1&D&!C1&C&B1&!B&!A1&A|E&D1&D&!C1&C&B1&!B&!A1&A|E&D1&!D&!C1&C&B1&!B&!A1&A|E&D1&!D&!C1&C&!B1&!B&!A1&A|E&D1&D&!C1&C&!B1&!B&!A1&A|E&!D1&D&!C1&C&!B1&!B&!A1&A|E&!D1&D&C1&C&!B1&!B&!A1&A|E&D1&D&C1&C&!B1&!B&!A1&A|E&D1&!D&C1&C&!B1&!B&!A1&A|E&D1&!D&C1&!C&!B1&!B&!A1&A|E&D1&D&C1&!C&!B1&!B&!A1&A|E&!D1&D&C1&!C&!B1&!B&!A1&A|E&!D1&D&!C1&!C&!B1&!B&!A1&A|E&D1&D&!C1&!C&!B1&!B&!A1&A|E&D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAOAI22221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOOAI2222 -l OOAAOOAI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B1&!B&!A1&!A|D1&!D&!C1&!C&!B1&!B&!A1&!A|D1&D&!C1&!C&!B1&!B&!A1&!A|!D1&D&!C1&!C&!B1&!B&!A1&!A|!D1&D&C1&!C&!B1&!B&!A1&!A|D1&D&C1&!C&!B1&!B&!A1&!A|D1&!D&C1&!C&!B1&!B&!A1&!A|!D1&!D&C1&!C&!B1&!B&!A1&!A|!D1&!D&C1&C&!B1&!B&!A1&!A|!D1&D&!C1&C&!B1&!B&!A1&!A|D1&D&!C1&C&!B1&!B&!A1&!A|D1&!D&!C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&B1&!B&!A1&!A|D1&!D&!C1&C&B1&!B&!A1&!A|D1&D&!C1&C&B1&!B&!A1&!A|!D1&D&!C1&C&B1&!B&!A1&!A|!D1&!D&C1&C&B1&!B&!A1&!A|!D1&!D&C1&!C&B1&!B&!A1&!A|D1&!D&C1&!C&B1&!B&!A1&!A|D1&D&C1&!C&B1&!B&!A1&!A|!D1&D&C1&!C&B1&!B&!A1&!A|!D1&D&!C1&!C&B1&!B&!A1&!A|D1&D&!C1&!C&B1&!B&!A1&!A|D1&!D&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&B&!A1&!A|D1&!D&!C1&!C&B1&B&!A1&!A|D1&D&!C1&!C&B1&B&!A1&!A|!D1&D&!C1&!C&B1&B&!A1&!A|!D1&D&C1&!C&B1&B&!A1&!A|D1&D&C1&!C&B1&B&!A1&!A|D1&!D&C1&!C&B1&B&!A1&!A|!D1&!D&C1&!C&B1&B&!A1&!A|!D1&!D&C1&C&B1&B&!A1&!A|!D1&D&!C1&C&B1&B&!A1&!A|D1&D&!C1&C&B1&B&!A1&!A|D1&!D&!C1&C&B1&B&!A1&!A|!D1&!D&!C1&C&B1&B&!A1&!A|!D1&!D&!C1&C&!B1&B&!A1&!A|D1&!D&!C1&C&!B1&B&!A1&!A|D1&D&!C1&C&!B1&B&!A1&!A|!D1&D&!C1&C&!B1&B&!A1&!A|!D1&!D&C1&C&!B1&B&!A1&!A|!D1&!D&C1&!C&!B1&B&!A1&!A|D1&!D&C1&!C&!B1&B&!A1&!A|D1&D&C1&!C&!B1&B&!A1&!A|!D1&D&C1&!C&!B1&B&!A1&!A|!D1&D&!C1&!C&!B1&B&!A1&!A|D1&D&!C1&!C&!B1&B&!A1&!A|D1&!D&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&A1&!A|!D1&!D&C1&!C&!B1&B&A1&!A|!D1&!D&C1&C&!B1&B&A1&!A|!D1&!D&!C1&C&!B1&B&A1&!A|!D1&!D&!C1&C&B1&B&A1&!A|!D1&!D&C1&C&B1&B&A1&!A|!D1&!D&C1&!C&B1&B&A1&!A|!D1&!D&!C1&!C&B1&B&A1&!A|!D1&!D&!C1&!C&B1&!B&A1&!A|!D1&!D&C1&!C&B1&!B&A1&!A|!D1&!D&C1&C&B1&!B&A1&!A|!D1&!D&!C1&C&B1&!B&A1&!A|!D1&!D&!C1&C&!B1&!B&A1&!A|D1&!D&!C1&C&!B1&!B&A1&!A|D1&D&!C1&C&!B1&!B&A1&!A|!D1&D&!C1&C&!B1&!B&A1&!A|!D1&!D&C1&C&!B1&!B&A1&!A|!D1&!D&C1&!C&!B1&!B&A1&!A|D1&!D&C1&!C&!B1&!B&A1&!A|D1&D&C1&!C&!B1&!B&A1&!A|!D1&D&C1&!C&!B1&!B&A1&!A|!D1&D&!C1&!C&!B1&!B&A1&!A|D1&D&!C1&!C&!B1&!B&A1&!A|D1&!D&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&A|D1&!D&!C1&!C&!B1&!B&A1&A|D1&D&!C1&!C&!B1&!B&A1&A|!D1&D&!C1&!C&!B1&!B&A1&A|!D1&D&C1&!C&!B1&!B&A1&A|D1&D&C1&!C&!B1&!B&A1&A|D1&!D&C1&!C&!B1&!B&A1&A|!D1&!D&C1&!C&!B1&!B&A1&A|!D1&!D&C1&C&!B1&!B&A1&A|!D1&D&!C1&C&!B1&!B&A1&A|D1&D&!C1&C&!B1&!B&A1&A|D1&!D&!C1&C&!B1&!B&A1&A|!D1&!D&!C1&C&!B1&!B&A1&A|!D1&!D&!C1&C&B1&!B&A1&A|!D1&!D&C1&C&B1&!B&A1&A|!D1&!D&C1&!C&B1&!B&A1&A|!D1&!D&!C1&!C&B1&!B&A1&A|!D1&!D&!C1&!C&B1&B&A1&A|!D1&!D&C1&!C&B1&B&A1&A|!D1&!D&C1&C&B1&B&A1&A|!D1&!D&!C1&C&B1&B&A1&A|!D1&!D&!C1&C&!B1&B&A1&A|!D1&!D&C1&C&!B1&B&A1&A|!D1&!D&C1&!C&!B1&B&A1&A|!D1&!D&!C1&!C&!B1&B&A1&A|!D1&!D&!C1&!C&!B1&B&!A1&A|!D1&!D&C1&!C&!B1&B&!A1&A|!D1&!D&C1&C&!B1&B&!A1&A|!D1&!D&!C1&C&!B1&B&!A1&A|!D1&!D&!C1&C&B1&B&!A1&A|!D1&!D&C1&C&B1&B&!A1&A|!D1&!D&C1&!C&B1&B&!A1&A|!D1&!D&!C1&!C&B1&B&!A1&A|!D1&!D&!C1&!C&B1&!B&!A1&A|!D1&!D&C1&!C&B1&!B&!A1&A|!D1&!D&C1&C&B1&!B&!A1&A|!D1&!D&!C1&C&B1&!B&!A1&A|!D1&!D&!C1&C&!B1&!B&!A1&A|D1&!D&!C1&C&!B1&!B&!A1&A|D1&D&!C1&C&!B1&!B&!A1&A|!D1&D&!C1&C&!B1&!B&!A1&A|!D1&!D&C1&C&!B1&!B&!A1&A|!D1&!D&C1&!C&!B1&!B&!A1&A|D1&!D&C1&!C&!B1&!B&!A1&A|D1&D&C1&!C&!B1&!B&!A1&A|!D1&D&C1&!C&!B1&!B&!A1&A|!D1&D&!C1&!C&!B1&!B&!A1&A|D1&D&!C1&!C&!B1&!B&!A1&A|D1&!D&!C1&!C&!B1&!B&!A1&A|!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOOAI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOAOI22211 -l AAAOAOI22211 -i E D C1 C B1 B A1 A -o Y -f Y=(!E&!D&!C1&!C&!B1&!B&!A1&!A|!E&D&!C1&!C&!B1&!B&!A1&!A|!E&D&C1&!C&!B1&!B&!A1&!A|!E&!D&C1&!C&!B1&!B&!A1&!A|!E&!D&C1&C&!B1&!B&!A1&!A|!E&D&!C1&C&!B1&!B&!A1&!A|!E&!D&!C1&C&!B1&!B&!A1&!A|!E&!D&!C1&C&B1&!B&!A1&!A|!E&D&!C1&C&B1&!B&!A1&!A|!E&!D&C1&C&B1&!B&!A1&!A|!E&!D&C1&!C&B1&!B&!A1&!A|!E&D&C1&!C&B1&!B&!A1&!A|!E&D&!C1&!C&B1&!B&!A1&!A|!E&!D&!C1&!C&B1&!B&!A1&!A|!E&!D&!C1&!C&B1&B&!A1&!A|!E&!D&C1&!C&B1&B&!A1&!A|!E&!D&C1&C&B1&B&!A1&!A|!E&!D&!C1&C&B1&B&!A1&!A|!E&!D&!C1&C&!B1&B&!A1&!A|!E&D&!C1&C&!B1&B&!A1&!A|!E&!D&C1&C&!B1&B&!A1&!A|!E&!D&C1&!C&!B1&B&!A1&!A|!E&D&C1&!C&!B1&B&!A1&!A|!E&D&!C1&!C&!B1&B&!A1&!A|!E&!D&!C1&!C&!B1&B&!A1&!A|!E&!D&!C1&!C&!B1&B&A1&!A|!E&D&!C1&!C&!B1&B&A1&!A|!E&D&C1&!C&!B1&B&A1&!A|!E&!D&C1&!C&!B1&B&A1&!A|!E&!D&C1&C&!B1&B&A1&!A|!E&D&!C1&C&!B1&B&A1&!A|!E&!D&!C1&C&!B1&B&A1&!A|!E&!D&!C1&C&B1&B&A1&!A|!E&!D&C1&C&B1&B&A1&!A|!E&!D&C1&!C&B1&B&A1&!A|!E&!D&!C1&!C&B1&B&A1&!A|!E&!D&!C1&!C&B1&!B&A1&!A|!E&D&!C1&!C&B1&!B&A1&!A|!E&D&C1&!C&B1&!B&A1&!A|!E&!D&C1&!C&B1&!B&A1&!A|!E&!D&C1&C&B1&!B&A1&!A|!E&D&!C1&C&B1&!B&A1&!A|!E&!D&!C1&C&B1&!B&A1&!A|!E&!D&!C1&C&!B1&!B&A1&!A|!E&D&!C1&C&!B1&!B&A1&!A|!E&!D&C1&C&!B1&!B&A1&!A|!E&!D&C1&!C&!B1&!B&A1&!A|!E&D&C1&!C&!B1&!B&A1&!A|!E&D&!C1&!C&!B1&!B&A1&!A|!E&!D&!C1&!C&!B1&!B&A1&!A|!E&!D&!C1&!C&!B1&!B&A1&A|!E&!D&C1&!C&!B1&!B&A1&A|!E&!D&C1&C&!B1&!B&A1&A|!E&!D&!C1&C&!B1&!B&A1&A|!E&!D&!C1&C&B1&!B&A1&A|!E&!D&C1&C&B1&!B&A1&A|!E&!D&C1&!C&B1&!B&A1&A|!E&!D&!C1&!C&B1&!B&A1&A|!E&!D&!C1&!C&B1&B&A1&A|!E&!D&C1&!C&B1&B&A1&A|!E&!D&C1&C&B1&B&A1&A|!E&!D&!C1&C&B1&B&A1&A|!E&!D&!C1&C&!B1&B&A1&A|!E&!D&C1&C&!B1&B&A1&A|!E&!D&C1&!C&!B1&B&A1&A|!E&!D&!C1&!C&!B1&B&A1&A|!E&!D&!C1&!C&!B1&B&!A1&A|!E&D&!C1&!C&!B1&B&!A1&A|!E&D&C1&!C&!B1&B&!A1&A|!E&!D&C1&!C&!B1&B&!A1&A|!E&!D&C1&C&!B1&B&!A1&A|!E&D&!C1&C&!B1&B&!A1&A|!E&!D&!C1&C&!B1&B&!A1&A|!E&!D&!C1&C&B1&B&!A1&A|!E&!D&C1&C&B1&B&!A1&A|!E&!D&C1&!C&B1&B&!A1&A|!E&!D&!C1&!C&B1&B&!A1&A|!E&!D&!C1&!C&B1&!B&!A1&A|!E&D&!C1&!C&B1&!B&!A1&A|!E&D&C1&!C&B1&!B&!A1&A|!E&!D&C1&!C&B1&!B&!A1&A|!E&!D&C1&C&B1&!B&!A1&A|!E&D&!C1&C&B1&!B&!A1&A|!E&!D&!C1&C&B1&!B&!A1&A|!E&!D&!C1&C&!B1&!B&!A1&A|!E&D&!C1&C&!B1&!B&!A1&A|!E&!D&C1&C&!B1&!B&!A1&A|!E&!D&C1&!C&!B1&!B&!A1&A|!E&D&C1&!C&!B1&!B&!A1&A|!E&D&!C1&!C&!B1&!B&!A1&A|!E&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOAOI22211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOAOI22221 -l AAAOAOI22221 -i E D1 D C1 C B1 B A1 A -o Y -f Y=(!E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&D1&D&C1&!C&!B1&!B&!A1&!A|!E&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&D1&!D&C1&C&!B1&!B&!A1&!A|!E&!D1&D&C1&C&!B1&!B&!A1&!A|!E&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&D1&D&!C1&C&!B1&!B&!A1&!A|!E&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&D1&!D&!C1&C&B1&!B&!A1&!A|!E&D1&D&!C1&C&B1&!B&!A1&!A|!E&!D1&D&!C1&C&B1&!B&!A1&!A|!E&!D1&D&C1&C&B1&!B&!A1&!A|!E&D1&!D&C1&C&B1&!B&!A1&!A|!E&!D1&!D&C1&C&B1&!B&!A1&!A|!E&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&D1&!D&C1&!C&B1&!B&!A1&!A|!E&D1&D&C1&!C&B1&!B&!A1&!A|!E&!D1&D&C1&!C&B1&!B&!A1&!A|!E&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&D1&D&!C1&!C&B1&!B&!A1&!A|!E&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&D1&!D&!C1&!C&B1&B&!A1&!A|!E&!D1&D&!C1&!C&B1&B&!A1&!A|!E&!D1&D&C1&!C&B1&B&!A1&!A|!E&D1&!D&C1&!C&B1&B&!A1&!A|!E&!D1&!D&C1&!C&B1&B&!A1&!A|!E&!D1&!D&C1&C&B1&B&!A1&!A|!E&D1&!D&C1&C&B1&B&!A1&!A|!E&!D1&D&C1&C&B1&B&!A1&!A|!E&!D1&D&!C1&C&B1&B&!A1&!A|!E&D1&!D&!C1&C&B1&B&!A1&!A|!E&!D1&!D&!C1&C&B1&B&!A1&!A|!E&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&D1&!D&!C1&C&!B1&B&!A1&!A|!E&D1&D&!C1&C&!B1&B&!A1&!A|!E&!D1&D&!C1&C&!B1&B&!A1&!A|!E&!D1&D&C1&C&!B1&B&!A1&!A|!E&D1&!D&C1&C&!B1&B&!A1&!A|!E&!D1&!D&C1&C&!B1&B&!A1&!A|!E&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&D1&!D&C1&!C&!B1&B&!A1&!A|!E&D1&D&C1&!C&!B1&B&!A1&!A|!E&!D1&D&C1&!C&!B1&B&!A1&!A|!E&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&D1&D&!C1&!C&!B1&B&!A1&!A|!E&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&D1&!D&!C1&!C&!B1&B&A1&!A|!E&D1&D&!C1&!C&!B1&B&A1&!A|!E&!D1&D&!C1&!C&!B1&B&A1&!A|!E&!D1&D&C1&!C&!B1&B&A1&!A|!E&D1&D&C1&!C&!B1&B&A1&!A|!E&D1&!D&C1&!C&!B1&B&A1&!A|!E&!D1&!D&C1&!C&!B1&B&A1&!A|!E&!D1&!D&C1&C&!B1&B&A1&!A|!E&D1&!D&C1&C&!B1&B&A1&!A|!E&!D1&D&C1&C&!B1&B&A1&!A|!E&!D1&D&!C1&C&!B1&B&A1&!A|!E&D1&D&!C1&C&!B1&B&A1&!A|!E&D1&!D&!C1&C&!B1&B&A1&!A|!E&!D1&!D&!C1&C&!B1&B&A1&!A|!E&!D1&!D&!C1&C&B1&B&A1&!A|!E&D1&!D&!C1&C&B1&B&A1&!A|!E&!D1&D&!C1&C&B1&B&A1&!A|!E&!D1&D&C1&C&B1&B&A1&!A|!E&D1&!D&C1&C&B1&B&A1&!A|!E&!D1&!D&C1&C&B1&B&A1&!A|!E&!D1&!D&C1&!C&B1&B&A1&!A|!E&D1&!D&C1&!C&B1&B&A1&!A|!E&!D1&D&C1&!C&B1&B&A1&!A|!E&!D1&D&!C1&!C&B1&B&A1&!A|!E&D1&!D&!C1&!C&B1&B&A1&!A|!E&!D1&!D&!C1&!C&B1&B&A1&!A|!E&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&D1&!D&!C1&!C&B1&!B&A1&!A|!E&D1&D&!C1&!C&B1&!B&A1&!A|!E&!D1&D&!C1&!C&B1&!B&A1&!A|!E&!D1&D&C1&!C&B1&!B&A1&!A|!E&D1&D&C1&!C&B1&!B&A1&!A|!E&D1&!D&C1&!C&B1&!B&A1&!A|!E&!D1&!D&C1&!C&B1&!B&A1&!A|!E&!D1&!D&C1&C&B1&!B&A1&!A|!E&D1&!D&C1&C&B1&!B&A1&!A|!E&!D1&D&C1&C&B1&!B&A1&!A|!E&!D1&D&!C1&C&B1&!B&A1&!A|!E&D1&D&!C1&C&B1&!B&A1&!A|!E&D1&!D&!C1&C&B1&!B&A1&!A|!E&!D1&!D&!C1&C&B1&!B&A1&!A|!E&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&D1&!D&!C1&C&!B1&!B&A1&!A|!E&D1&D&!C1&C&!B1&!B&A1&!A|!E&!D1&D&!C1&C&!B1&!B&A1&!A|!E&!D1&D&C1&C&!B1&!B&A1&!A|!E&D1&!D&C1&C&!B1&!B&A1&!A|!E&!D1&!D&C1&C&!B1&!B&A1&!A|!E&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&D1&!D&C1&!C&!B1&!B&A1&!A|!E&D1&D&C1&!C&!B1&!B&A1&!A|!E&!D1&D&C1&!C&!B1&!B&A1&!A|!E&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&D1&D&!C1&!C&!B1&!B&A1&!A|!E&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&D1&!D&!C1&!C&!B1&!B&A1&A|!E&!D1&D&!C1&!C&!B1&!B&A1&A|!E&!D1&D&C1&!C&!B1&!B&A1&A|!E&D1&!D&C1&!C&!B1&!B&A1&A|!E&!D1&!D&C1&!C&!B1&!B&A1&A|!E&!D1&!D&C1&C&!B1&!B&A1&A|!E&D1&!D&C1&C&!B1&!B&A1&A|!E&!D1&D&C1&C&!B1&!B&A1&A|!E&!D1&D&!C1&C&!B1&!B&A1&A|!E&D1&!D&!C1&C&!B1&!B&A1&A|!E&!D1&!D&!C1&C&!B1&!B&A1&A|!E&!D1&!D&!C1&C&B1&!B&A1&A|!E&D1&!D&!C1&C&B1&!B&A1&A|!E&!D1&D&!C1&C&B1&!B&A1&A|!E&!D1&D&C1&C&B1&!B&A1&A|!E&D1&!D&C1&C&B1&!B&A1&A|!E&!D1&!D&C1&C&B1&!B&A1&A|!E&!D1&!D&C1&!C&B1&!B&A1&A|!E&D1&!D&C1&!C&B1&!B&A1&A|!E&!D1&D&C1&!C&B1&!B&A1&A|!E&!D1&D&!C1&!C&B1&!B&A1&A|!E&D1&!D&!C1&!C&B1&!B&A1&A|!E&!D1&!D&!C1&!C&B1&!B&A1&A|!E&!D1&!D&!C1&!C&B1&B&A1&A|!E&D1&!D&!C1&!C&B1&B&A1&A|!E&!D1&D&!C1&!C&B1&B&A1&A|!E&!D1&D&C1&!C&B1&B&A1&A|!E&D1&!D&C1&!C&B1&B&A1&A|!E&!D1&!D&C1&!C&B1&B&A1&A|!E&!D1&!D&C1&C&B1&B&A1&A|!E&D1&!D&C1&C&B1&B&A1&A|!E&!D1&D&C1&C&B1&B&A1&A|!E&!D1&D&!C1&C&B1&B&A1&A|!E&D1&!D&!C1&C&B1&B&A1&A|!E&!D1&!D&!C1&C&B1&B&A1&A|!E&!D1&!D&!C1&C&!B1&B&A1&A|!E&D1&!D&!C1&C&!B1&B&A1&A|!E&!D1&D&!C1&C&!B1&B&A1&A|!E&!D1&D&C1&C&!B1&B&A1&A|!E&D1&!D&C1&C&!B1&B&A1&A|!E&!D1&!D&C1&C&!B1&B&A1&A|!E&!D1&!D&C1&!C&!B1&B&A1&A|!E&D1&!D&C1&!C&!B1&B&A1&A|!E&!D1&D&C1&!C&!B1&B&A1&A|!E&!D1&D&!C1&!C&!B1&B&A1&A|!E&D1&!D&!C1&!C&!B1&B&A1&A|!E&!D1&!D&!C1&!C&!B1&B&A1&A|!E&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&D1&!D&!C1&!C&!B1&B&!A1&A|!E&D1&D&!C1&!C&!B1&B&!A1&A|!E&!D1&D&!C1&!C&!B1&B&!A1&A|!E&!D1&D&C1&!C&!B1&B&!A1&A|!E&D1&D&C1&!C&!B1&B&!A1&A|!E&D1&!D&C1&!C&!B1&B&!A1&A|!E&!D1&!D&C1&!C&!B1&B&!A1&A|!E&!D1&!D&C1&C&!B1&B&!A1&A|!E&D1&!D&C1&C&!B1&B&!A1&A|!E&!D1&D&C1&C&!B1&B&!A1&A|!E&!D1&D&!C1&C&!B1&B&!A1&A|!E&D1&D&!C1&C&!B1&B&!A1&A|!E&D1&!D&!C1&C&!B1&B&!A1&A|!E&!D1&!D&!C1&C&!B1&B&!A1&A|!E&!D1&!D&!C1&C&B1&B&!A1&A|!E&D1&!D&!C1&C&B1&B&!A1&A|!E&!D1&D&!C1&C&B1&B&!A1&A|!E&!D1&D&C1&C&B1&B&!A1&A|!E&D1&!D&C1&C&B1&B&!A1&A|!E&!D1&!D&C1&C&B1&B&!A1&A|!E&!D1&!D&C1&!C&B1&B&!A1&A|!E&D1&!D&C1&!C&B1&B&!A1&A|!E&!D1&D&C1&!C&B1&B&!A1&A|!E&!D1&D&!C1&!C&B1&B&!A1&A|!E&D1&!D&!C1&!C&B1&B&!A1&A|!E&!D1&!D&!C1&!C&B1&B&!A1&A|!E&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&D1&!D&!C1&!C&B1&!B&!A1&A|!E&D1&D&!C1&!C&B1&!B&!A1&A|!E&!D1&D&!C1&!C&B1&!B&!A1&A|!E&!D1&D&C1&!C&B1&!B&!A1&A|!E&D1&D&C1&!C&B1&!B&!A1&A|!E&D1&!D&C1&!C&B1&!B&!A1&A|!E&!D1&!D&C1&!C&B1&!B&!A1&A|!E&!D1&!D&C1&C&B1&!B&!A1&A|!E&D1&!D&C1&C&B1&!B&!A1&A|!E&!D1&D&C1&C&B1&!B&!A1&A|!E&!D1&D&!C1&C&B1&!B&!A1&A|!E&D1&D&!C1&C&B1&!B&!A1&A|!E&D1&!D&!C1&C&B1&!B&!A1&A|!E&!D1&!D&!C1&C&B1&!B&!A1&A|!E&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&D1&!D&!C1&C&!B1&!B&!A1&A|!E&D1&D&!C1&C&!B1&!B&!A1&A|!E&!D1&D&!C1&C&!B1&!B&!A1&A|!E&!D1&D&C1&C&!B1&!B&!A1&A|!E&D1&!D&C1&C&!B1&!B&!A1&A|!E&!D1&!D&C1&C&!B1&!B&!A1&A|!E&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&D1&!D&C1&!C&!B1&!B&!A1&A|!E&D1&D&C1&!C&!B1&!B&!A1&A|!E&!D1&D&C1&!C&!B1&!B&!A1&A|!E&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&D1&D&!C1&!C&!B1&!B&!A1&A|!E&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOAOI22221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOI222 -l AAOI222 -i C1 C B1 B A1 A -o Y -f Y=(!C1&!C&!B1&!B&!A1&!A|!C1&!C&B1&!B&!A1&!A|!C1&!C&!B1&B&!A1&!A|!C1&!C&!B1&B&A1&!A|!C1&!C&B1&!B&A1&!A|!C1&!C&!B1&!B&A1&!A|!C1&!C&!B1&B&!A1&A|!C1&!C&B1&!B&!A1&A|!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOI222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAI22141 -l AAOOAI22141 -i E D3 D2 D1 D C B1 B A1 A -o Y -f Y=!(E&!D3&!D2&!D1&D&C&!B1&!B&!A1&!A|E&D3&!D2&!D1&D&C&!B1&!B&!A1&!A|E&D3&D2&!D1&D&C&!B1&!B&!A1&!A|E&!D3&D2&!D1&D&C&!B1&!B&!A1&!A|E&!D3&D2&D1&D&C&!B1&!B&!A1&!A|E&D3&D2&D1&D&C&!B1&!B&!A1&!A|E&D3&!D2&D1&D&C&!B1&!B&!A1&!A|E&!D3&!D2&D1&D&C&!B1&!B&!A1&!A|E&!D3&!D2&D1&!D&C&!B1&!B&!A1&!A|E&D3&!D2&D1&!D&C&!B1&!B&!A1&!A|E&D3&D2&D1&!D&C&!B1&!B&!A1&!A|E&!D3&D2&D1&!D&C&!B1&!B&!A1&!A|E&!D3&D2&!D1&!D&C&!B1&!B&!A1&!A|E&D3&D2&!D1&!D&C&!B1&!B&!A1&!A|E&D3&!D2&!D1&!D&C&!B1&!B&!A1&!A|E&D3&!D2&!D1&!D&C&B1&!B&!A1&!A|E&D3&D2&!D1&!D&C&B1&!B&!A1&!A|E&!D3&D2&!D1&!D&C&B1&!B&!A1&!A|E&!D3&D2&D1&!D&C&B1&!B&!A1&!A|E&D3&D2&D1&!D&C&B1&!B&!A1&!A|E&D3&!D2&D1&!D&C&B1&!B&!A1&!A|E&!D3&!D2&D1&!D&C&B1&!B&!A1&!A|E&!D3&!D2&D1&D&C&B1&!B&!A1&!A|E&D3&!D2&D1&D&C&B1&!B&!A1&!A|E&D3&D2&D1&D&C&B1&!B&!A1&!A|E&!D3&D2&D1&D&C&B1&!B&!A1&!A|E&!D3&D2&!D1&D&C&B1&!B&!A1&!A|E&D3&D2&!D1&D&C&B1&!B&!A1&!A|E&D3&!D2&!D1&D&C&B1&!B&!A1&!A|E&!D3&!D2&!D1&D&C&B1&!B&!A1&!A|E&D3&!D2&!D1&!D&!C&B1&B&!A1&!A|E&D3&D2&!D1&!D&!C&B1&B&!A1&!A|E&!D3&D2&!D1&!D&!C&B1&B&!A1&!A|E&!D3&D2&D1&!D&!C&B1&B&!A1&!A|E&D3&D2&D1&!D&!C&B1&B&!A1&!A|E&D3&!D2&D1&!D&!C&B1&B&!A1&!A|E&!D3&!D2&D1&!D&!C&B1&B&!A1&!A|E&!D3&!D2&D1&D&!C&B1&B&!A1&!A|E&D3&!D2&D1&D&!C&B1&B&!A1&!A|E&D3&D2&D1&D&!C&B1&B&!A1&!A|E&!D3&D2&D1&D&!C&B1&B&!A1&!A|E&!D3&D2&!D1&D&!C&B1&B&!A1&!A|E&D3&D2&!D1&D&!C&B1&B&!A1&!A|E&D3&!D2&!D1&D&!C&B1&B&!A1&!A|E&!D3&!D2&!D1&D&!C&B1&B&!A1&!A|E&!D3&!D2&!D1&D&C&B1&B&!A1&!A|E&D3&!D2&!D1&D&C&B1&B&!A1&!A|E&D3&D2&!D1&D&C&B1&B&!A1&!A|E&!D3&D2&!D1&D&C&B1&B&!A1&!A|E&!D3&D2&D1&D&C&B1&B&!A1&!A|E&D3&D2&D1&D&C&B1&B&!A1&!A|E&D3&!D2&D1&D&C&B1&B&!A1&!A|E&!D3&!D2&D1&D&C&B1&B&!A1&!A|E&!D3&!D2&D1&!D&C&B1&B&!A1&!A|E&D3&!D2&D1&!D&C&B1&B&!A1&!A|E&D3&D2&D1&!D&C&B1&B&!A1&!A|E&!D3&D2&D1&!D&C&B1&B&!A1&!A|E&!D3&D2&!D1&!D&C&B1&B&!A1&!A|E&D3&D2&!D1&!D&C&B1&B&!A1&!A|E&D3&!D2&!D1&!D&C&B1&B&!A1&!A|E&D3&!D2&!D1&!D&C&!B1&B&!A1&!A|E&D3&D2&!D1&!D&C&!B1&B&!A1&!A|E&!D3&D2&!D1&!D&C&!B1&B&!A1&!A|E&!D3&D2&D1&!D&C&!B1&B&!A1&!A|E&D3&D2&D1&!D&C&!B1&B&!A1&!A|E&D3&!D2&D1&!D&C&!B1&B&!A1&!A|E&!D3&!D2&D1&!D&C&!B1&B&!A1&!A|E&!D3&!D2&D1&D&C&!B1&B&!A1&!A|E&D3&!D2&D1&D&C&!B1&B&!A1&!A|E&D3&D2&D1&D&C&!B1&B&!A1&!A|E&!D3&D2&D1&D&C&!B1&B&!A1&!A|E&!D3&D2&!D1&D&C&!B1&B&!A1&!A|E&D3&D2&!D1&D&C&!B1&B&!A1&!A|E&D3&!D2&!D1&D&C&!B1&B&!A1&!A|E&!D3&!D2&!D1&D&C&!B1&B&!A1&!A|E&!D3&!D2&!D1&D&C&!B1&B&A1&!A|E&D3&!D2&!D1&D&C&!B1&B&A1&!A|E&D3&D2&!D1&D&C&!B1&B&A1&!A|E&!D3&D2&!D1&D&C&!B1&B&A1&!A|E&!D3&D2&D1&D&C&!B1&B&A1&!A|E&D3&D2&D1&D&C&!B1&B&A1&!A|E&D3&!D2&D1&D&C&!B1&B&A1&!A|E&!D3&!D2&D1&D&C&!B1&B&A1&!A|E&!D3&!D2&D1&!D&C&!B1&B&A1&!A|E&D3&!D2&D1&!D&C&!B1&B&A1&!A|E&D3&D2&D1&!D&C&!B1&B&A1&!A|E&!D3&D2&D1&!D&C&!B1&B&A1&!A|E&!D3&D2&!D1&!D&C&!B1&B&A1&!A|E&D3&D2&!D1&!D&C&!B1&B&A1&!A|E&D3&!D2&!D1&!D&C&!B1&B&A1&!A|E&D3&!D2&!D1&!D&C&B1&B&A1&!A|E&D3&D2&!D1&!D&C&B1&B&A1&!A|E&!D3&D2&!D1&!D&C&B1&B&A1&!A|E&!D3&D2&D1&!D&C&B1&B&A1&!A|E&D3&D2&D1&!D&C&B1&B&A1&!A|E&D3&!D2&D1&!D&C&B1&B&A1&!A|E&!D3&!D2&D1&!D&C&B1&B&A1&!A|E&!D3&!D2&D1&D&C&B1&B&A1&!A|E&D3&!D2&D1&D&C&B1&B&A1&!A|E&D3&D2&D1&D&C&B1&B&A1&!A|E&!D3&D2&D1&D&C&B1&B&A1&!A|E&!D3&D2&!D1&D&C&B1&B&A1&!A|E&D3&D2&!D1&D&C&B1&B&A1&!A|E&D3&!D2&!D1&D&C&B1&B&A1&!A|E&!D3&!D2&!D1&D&C&B1&B&A1&!A|E&!D3&!D2&!D1&D&!C&B1&B&A1&!A|E&D3&!D2&!D1&D&!C&B1&B&A1&!A|E&D3&D2&!D1&D&!C&B1&B&A1&!A|E&!D3&D2&!D1&D&!C&B1&B&A1&!A|E&!D3&D2&D1&D&!C&B1&B&A1&!A|E&D3&D2&D1&D&!C&B1&B&A1&!A|E&D3&!D2&D1&D&!C&B1&B&A1&!A|E&!D3&!D2&D1&D&!C&B1&B&A1&!A|E&!D3&!D2&D1&!D&!C&B1&B&A1&!A|E&D3&!D2&D1&!D&!C&B1&B&A1&!A|E&D3&D2&D1&!D&!C&B1&B&A1&!A|E&!D3&D2&D1&!D&!C&B1&B&A1&!A|E&!D3&D2&!D1&!D&!C&B1&B&A1&!A|E&D3&D2&!D1&!D&!C&B1&B&A1&!A|E&D3&!D2&!D1&!D&!C&B1&B&A1&!A|E&!D3&!D2&!D1&D&C&B1&!B&A1&!A|E&D3&!D2&!D1&D&C&B1&!B&A1&!A|E&D3&D2&!D1&D&C&B1&!B&A1&!A|E&!D3&D2&!D1&D&C&B1&!B&A1&!A|E&!D3&D2&D1&D&C&B1&!B&A1&!A|E&D3&D2&D1&D&C&B1&!B&A1&!A|E&D3&!D2&D1&D&C&B1&!B&A1&!A|E&!D3&!D2&D1&D&C&B1&!B&A1&!A|E&!D3&!D2&D1&!D&C&B1&!B&A1&!A|E&D3&!D2&D1&!D&C&B1&!B&A1&!A|E&D3&D2&D1&!D&C&B1&!B&A1&!A|E&!D3&D2&D1&!D&C&B1&!B&A1&!A|E&!D3&D2&!D1&!D&C&B1&!B&A1&!A|E&D3&D2&!D1&!D&C&B1&!B&A1&!A|E&D3&!D2&!D1&!D&C&B1&!B&A1&!A|E&D3&!D2&!D1&!D&C&!B1&!B&A1&!A|E&D3&D2&!D1&!D&C&!B1&!B&A1&!A|E&!D3&D2&!D1&!D&C&!B1&!B&A1&!A|E&!D3&D2&D1&!D&C&!B1&!B&A1&!A|E&D3&D2&D1&!D&C&!B1&!B&A1&!A|E&D3&!D2&D1&!D&C&!B1&!B&A1&!A|E&!D3&!D2&D1&!D&C&!B1&!B&A1&!A|E&!D3&!D2&D1&D&C&!B1&!B&A1&!A|E&D3&!D2&D1&D&C&!B1&!B&A1&!A|E&D3&D2&D1&D&C&!B1&!B&A1&!A|E&!D3&D2&D1&D&C&!B1&!B&A1&!A|E&!D3&D2&!D1&D&C&!B1&!B&A1&!A|E&D3&D2&!D1&D&C&!B1&!B&A1&!A|E&D3&!D2&!D1&D&C&!B1&!B&A1&!A|E&!D3&!D2&!D1&D&C&!B1&!B&A1&!A|E&D3&!D2&!D1&!D&!C&!B1&!B&A1&A|E&D3&D2&!D1&!D&!C&!B1&!B&A1&A|E&!D3&D2&!D1&!D&!C&!B1&!B&A1&A|E&!D3&D2&D1&!D&!C&!B1&!B&A1&A|E&D3&D2&D1&!D&!C&!B1&!B&A1&A|E&D3&!D2&D1&!D&!C&!B1&!B&A1&A|E&!D3&!D2&D1&!D&!C&!B1&!B&A1&A|E&!D3&!D2&D1&D&!C&!B1&!B&A1&A|E&D3&!D2&D1&D&!C&!B1&!B&A1&A|E&D3&D2&D1&D&!C&!B1&!B&A1&A|E&!D3&D2&D1&D&!C&!B1&!B&A1&A|E&!D3&D2&!D1&D&!C&!B1&!B&A1&A|E&D3&D2&!D1&D&!C&!B1&!B&A1&A|E&D3&!D2&!D1&D&!C&!B1&!B&A1&A|E&!D3&!D2&!D1&D&!C&!B1&!B&A1&A|E&!D3&!D2&!D1&D&C&!B1&!B&A1&A|E&D3&!D2&!D1&D&C&!B1&!B&A1&A|E&D3&D2&!D1&D&C&!B1&!B&A1&A|E&!D3&D2&!D1&D&C&!B1&!B&A1&A|E&!D3&D2&D1&D&C&!B1&!B&A1&A|E&D3&D2&D1&D&C&!B1&!B&A1&A|E&D3&!D2&D1&D&C&!B1&!B&A1&A|E&!D3&!D2&D1&D&C&!B1&!B&A1&A|E&!D3&!D2&D1&!D&C&!B1&!B&A1&A|E&D3&!D2&D1&!D&C&!B1&!B&A1&A|E&D3&D2&D1&!D&C&!B1&!B&A1&A|E&!D3&D2&D1&!D&C&!B1&!B&A1&A|E&!D3&D2&!D1&!D&C&!B1&!B&A1&A|E&D3&D2&!D1&!D&C&!B1&!B&A1&A|E&D3&!D2&!D1&!D&C&!B1&!B&A1&A|E&D3&!D2&!D1&!D&C&B1&!B&A1&A|E&D3&D2&!D1&!D&C&B1&!B&A1&A|E&!D3&D2&!D1&!D&C&B1&!B&A1&A|E&!D3&D2&D1&!D&C&B1&!B&A1&A|E&D3&D2&D1&!D&C&B1&!B&A1&A|E&D3&!D2&D1&!D&C&B1&!B&A1&A|E&!D3&!D2&D1&!D&C&B1&!B&A1&A|E&!D3&!D2&D1&D&C&B1&!B&A1&A|E&D3&!D2&D1&D&C&B1&!B&A1&A|E&D3&D2&D1&D&C&B1&!B&A1&A|E&!D3&D2&D1&D&C&B1&!B&A1&A|E&!D3&D2&!D1&D&C&B1&!B&A1&A|E&D3&D2&!D1&D&C&B1&!B&A1&A|E&D3&!D2&!D1&D&C&B1&!B&A1&A|E&!D3&!D2&!D1&D&C&B1&!B&A1&A|E&!D3&!D2&!D1&D&!C&B1&!B&A1&A|E&D3&!D2&!D1&D&!C&B1&!B&A1&A|E&D3&D2&!D1&D&!C&B1&!B&A1&A|E&!D3&D2&!D1&D&!C&B1&!B&A1&A|E&!D3&D2&D1&D&!C&B1&!B&A1&A|E&D3&D2&D1&D&!C&B1&!B&A1&A|E&D3&!D2&D1&D&!C&B1&!B&A1&A|E&!D3&!D2&D1&D&!C&B1&!B&A1&A|E&!D3&!D2&D1&!D&!C&B1&!B&A1&A|E&D3&!D2&D1&!D&!C&B1&!B&A1&A|E&D3&D2&D1&!D&!C&B1&!B&A1&A|E&!D3&D2&D1&!D&!C&B1&!B&A1&A|E&!D3&D2&!D1&!D&!C&B1&!B&A1&A|E&D3&D2&!D1&!D&!C&B1&!B&A1&A|E&D3&!D2&!D1&!D&!C&B1&!B&A1&A|E&D3&!D2&!D1&!D&!C&B1&B&A1&A|E&D3&D2&!D1&!D&!C&B1&B&A1&A|E&!D3&D2&!D1&!D&!C&B1&B&A1&A|E&!D3&D2&D1&!D&!C&B1&B&A1&A|E&D3&D2&D1&!D&!C&B1&B&A1&A|E&D3&!D2&D1&!D&!C&B1&B&A1&A|E&!D3&!D2&D1&!D&!C&B1&B&A1&A|E&!D3&!D2&D1&D&!C&B1&B&A1&A|E&D3&!D2&D1&D&!C&B1&B&A1&A|E&D3&D2&D1&D&!C&B1&B&A1&A|E&!D3&D2&D1&D&!C&B1&B&A1&A|E&!D3&D2&!D1&D&!C&B1&B&A1&A|E&D3&D2&!D1&D&!C&B1&B&A1&A|E&D3&!D2&!D1&D&!C&B1&B&A1&A|E&!D3&!D2&!D1&D&!C&B1&B&A1&A|E&!D3&!D2&!D1&D&C&B1&B&A1&A|E&D3&!D2&!D1&D&C&B1&B&A1&A|E&D3&D2&!D1&D&C&B1&B&A1&A|E&!D3&D2&!D1&D&C&B1&B&A1&A|E&!D3&D2&D1&D&C&B1&B&A1&A|E&D3&D2&D1&D&C&B1&B&A1&A|E&D3&!D2&D1&D&C&B1&B&A1&A|E&!D3&!D2&D1&D&C&B1&B&A1&A|E&!D3&!D2&D1&!D&C&B1&B&A1&A|E&D3&!D2&D1&!D&C&B1&B&A1&A|E&D3&D2&D1&!D&C&B1&B&A1&A|E&!D3&D2&D1&!D&C&B1&B&A1&A|E&!D3&D2&!D1&!D&C&B1&B&A1&A|E&D3&D2&!D1&!D&C&B1&B&A1&A|E&D3&!D2&!D1&!D&C&B1&B&A1&A|E&D3&!D2&!D1&!D&C&!B1&B&A1&A|E&D3&D2&!D1&!D&C&!B1&B&A1&A|E&!D3&D2&!D1&!D&C&!B1&B&A1&A|E&!D3&D2&D1&!D&C&!B1&B&A1&A|E&D3&D2&D1&!D&C&!B1&B&A1&A|E&D3&!D2&D1&!D&C&!B1&B&A1&A|E&!D3&!D2&D1&!D&C&!B1&B&A1&A|E&!D3&!D2&D1&D&C&!B1&B&A1&A|E&D3&!D2&D1&D&C&!B1&B&A1&A|E&D3&D2&D1&D&C&!B1&B&A1&A|E&!D3&D2&D1&D&C&!B1&B&A1&A|E&!D3&D2&!D1&D&C&!B1&B&A1&A|E&D3&D2&!D1&D&C&!B1&B&A1&A|E&D3&!D2&!D1&D&C&!B1&B&A1&A|E&!D3&!D2&!D1&D&C&!B1&B&A1&A|E&!D3&!D2&!D1&D&!C&!B1&B&A1&A|E&D3&!D2&!D1&D&!C&!B1&B&A1&A|E&D3&D2&!D1&D&!C&!B1&B&A1&A|E&!D3&D2&!D1&D&!C&!B1&B&A1&A|E&!D3&D2&D1&D&!C&!B1&B&A1&A|E&D3&D2&D1&D&!C&!B1&B&A1&A|E&D3&!D2&D1&D&!C&!B1&B&A1&A|E&!D3&!D2&D1&D&!C&!B1&B&A1&A|E&!D3&!D2&D1&!D&!C&!B1&B&A1&A|E&D3&!D2&D1&!D&!C&!B1&B&A1&A|E&D3&D2&D1&!D&!C&!B1&B&A1&A|E&!D3&D2&D1&!D&!C&!B1&B&A1&A|E&!D3&D2&!D1&!D&!C&!B1&B&A1&A|E&D3&D2&!D1&!D&!C&!B1&B&A1&A|E&D3&!D2&!D1&!D&!C&!B1&B&A1&A|E&!D3&!D2&!D1&D&C&!B1&B&!A1&A|E&D3&!D2&!D1&D&C&!B1&B&!A1&A|E&D3&D2&!D1&D&C&!B1&B&!A1&A|E&!D3&D2&!D1&D&C&!B1&B&!A1&A|E&!D3&D2&D1&D&C&!B1&B&!A1&A|E&D3&D2&D1&D&C&!B1&B&!A1&A|E&D3&!D2&D1&D&C&!B1&B&!A1&A|E&!D3&!D2&D1&D&C&!B1&B&!A1&A|E&!D3&!D2&D1&!D&C&!B1&B&!A1&A|E&D3&!D2&D1&!D&C&!B1&B&!A1&A|E&D3&D2&D1&!D&C&!B1&B&!A1&A|E&!D3&D2&D1&!D&C&!B1&B&!A1&A|E&!D3&D2&!D1&!D&C&!B1&B&!A1&A|E&D3&D2&!D1&!D&C&!B1&B&!A1&A|E&D3&!D2&!D1&!D&C&!B1&B&!A1&A|E&D3&!D2&!D1&!D&C&B1&B&!A1&A|E&D3&D2&!D1&!D&C&B1&B&!A1&A|E&!D3&D2&!D1&!D&C&B1&B&!A1&A|E&!D3&D2&D1&!D&C&B1&B&!A1&A|E&D3&D2&D1&!D&C&B1&B&!A1&A|E&D3&!D2&D1&!D&C&B1&B&!A1&A|E&!D3&!D2&D1&!D&C&B1&B&!A1&A|E&!D3&!D2&D1&D&C&B1&B&!A1&A|E&D3&!D2&D1&D&C&B1&B&!A1&A|E&D3&D2&D1&D&C&B1&B&!A1&A|E&!D3&D2&D1&D&C&B1&B&!A1&A|E&!D3&D2&!D1&D&C&B1&B&!A1&A|E&D3&D2&!D1&D&C&B1&B&!A1&A|E&D3&!D2&!D1&D&C&B1&B&!A1&A|E&!D3&!D2&!D1&D&C&B1&B&!A1&A|E&!D3&!D2&!D1&D&!C&B1&B&!A1&A|E&D3&!D2&!D1&D&!C&B1&B&!A1&A|E&D3&D2&!D1&D&!C&B1&B&!A1&A|E&!D3&D2&!D1&D&!C&B1&B&!A1&A|E&!D3&D2&D1&D&!C&B1&B&!A1&A|E&D3&D2&D1&D&!C&B1&B&!A1&A|E&D3&!D2&D1&D&!C&B1&B&!A1&A|E&!D3&!D2&D1&D&!C&B1&B&!A1&A|E&!D3&!D2&D1&!D&!C&B1&B&!A1&A|E&D3&!D2&D1&!D&!C&B1&B&!A1&A|E&D3&D2&D1&!D&!C&B1&B&!A1&A|E&!D3&D2&D1&!D&!C&B1&B&!A1&A|E&!D3&D2&!D1&!D&!C&B1&B&!A1&A|E&D3&D2&!D1&!D&!C&B1&B&!A1&A|E&D3&!D2&!D1&!D&!C&B1&B&!A1&A|E&!D3&!D2&!D1&D&C&B1&!B&!A1&A|E&D3&!D2&!D1&D&C&B1&!B&!A1&A|E&D3&D2&!D1&D&C&B1&!B&!A1&A|E&!D3&D2&!D1&D&C&B1&!B&!A1&A|E&!D3&D2&D1&D&C&B1&!B&!A1&A|E&D3&D2&D1&D&C&B1&!B&!A1&A|E&D3&!D2&D1&D&C&B1&!B&!A1&A|E&!D3&!D2&D1&D&C&B1&!B&!A1&A|E&!D3&!D2&D1&!D&C&B1&!B&!A1&A|E&D3&!D2&D1&!D&C&B1&!B&!A1&A|E&D3&D2&D1&!D&C&B1&!B&!A1&A|E&!D3&D2&D1&!D&C&B1&!B&!A1&A|E&!D3&D2&!D1&!D&C&B1&!B&!A1&A|E&D3&D2&!D1&!D&C&B1&!B&!A1&A|E&D3&!D2&!D1&!D&C&B1&!B&!A1&A|E&D3&!D2&!D1&!D&C&!B1&!B&!A1&A|E&D3&D2&!D1&!D&C&!B1&!B&!A1&A|E&!D3&D2&!D1&!D&C&!B1&!B&!A1&A|E&!D3&D2&D1&!D&C&!B1&!B&!A1&A|E&D3&D2&D1&!D&C&!B1&!B&!A1&A|E&D3&!D2&D1&!D&C&!B1&!B&!A1&A|E&!D3&!D2&D1&!D&C&!B1&!B&!A1&A|E&!D3&!D2&D1&D&C&!B1&!B&!A1&A|E&D3&!D2&D1&D&C&!B1&!B&!A1&A|E&D3&D2&D1&D&C&!B1&!B&!A1&A|E&!D3&D2&D1&D&C&!B1&!B&!A1&A|E&!D3&D2&!D1&D&C&!B1&!B&!A1&A|E&D3&D2&!D1&D&C&!B1&!B&!A1&A|E&D3&!D2&!D1&D&C&!B1&!B&!A1&A|E&!D3&!D2&!D1&D&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAI22141.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOAAOI22112 -l OAOAAOI22112 -i E1 E D C B1 B A1 A -o Y -f Y=!(E1&E&!D&!C&!B1&!B&!A1&!A|E1&E&D&!C&!B1&!B&!A1&!A|!E1&!E&D&C&!B1&!B&!A1&!A|E1&!E&D&C&!B1&!B&!A1&!A|E1&E&D&C&!B1&!B&!A1&!A|!E1&E&D&C&!B1&!B&!A1&!A|E1&E&!D&C&!B1&!B&!A1&!A|E1&E&!D&C&B1&!B&!A1&!A|!E1&E&D&C&B1&!B&!A1&!A|E1&E&D&C&B1&!B&!A1&!A|E1&!E&D&C&B1&!B&!A1&!A|!E1&!E&D&C&B1&!B&!A1&!A|E1&E&D&!C&B1&!B&!A1&!A|E1&E&!D&!C&B1&!B&!A1&!A|E1&E&!D&!C&B1&B&!A1&!A|E1&E&D&!C&B1&B&!A1&!A|!E1&!E&D&C&B1&B&!A1&!A|E1&!E&D&C&B1&B&!A1&!A|E1&E&D&C&B1&B&!A1&!A|!E1&E&D&C&B1&B&!A1&!A|E1&E&!D&C&B1&B&!A1&!A|E1&E&!D&C&!B1&B&!A1&!A|!E1&E&D&C&!B1&B&!A1&!A|E1&E&D&C&!B1&B&!A1&!A|E1&!E&D&C&!B1&B&!A1&!A|!E1&!E&D&C&!B1&B&!A1&!A|E1&E&D&!C&!B1&B&!A1&!A|E1&E&!D&!C&!B1&B&!A1&!A|E1&E&!D&!C&!B1&B&A1&!A|E1&E&D&!C&!B1&B&A1&!A|!E1&!E&D&C&!B1&B&A1&!A|E1&!E&D&C&!B1&B&A1&!A|E1&E&D&C&!B1&B&A1&!A|!E1&E&D&C&!B1&B&A1&!A|E1&E&!D&C&!B1&B&A1&!A|E1&E&!D&C&B1&B&A1&!A|!E1&E&D&C&B1&B&A1&!A|E1&E&D&C&B1&B&A1&!A|E1&!E&D&C&B1&B&A1&!A|!E1&!E&D&C&B1&B&A1&!A|!E1&!E&D&!C&B1&B&A1&!A|E1&!E&D&!C&B1&B&A1&!A|E1&E&D&!C&B1&B&A1&!A|!E1&E&D&!C&B1&B&A1&!A|E1&E&!D&!C&B1&B&A1&!A|E1&E&!D&!C&B1&!B&A1&!A|E1&E&D&!C&B1&!B&A1&!A|!E1&!E&D&C&B1&!B&A1&!A|E1&!E&D&C&B1&!B&A1&!A|E1&E&D&C&B1&!B&A1&!A|!E1&E&D&C&B1&!B&A1&!A|E1&E&!D&C&B1&!B&A1&!A|E1&E&!D&C&!B1&!B&A1&!A|!E1&E&D&C&!B1&!B&A1&!A|E1&E&D&C&!B1&!B&A1&!A|E1&!E&D&C&!B1&!B&A1&!A|!E1&!E&D&C&!B1&!B&A1&!A|E1&E&D&!C&!B1&!B&A1&!A|E1&E&!D&!C&!B1&!B&A1&!A|E1&E&!D&!C&!B1&!B&A1&A|E1&E&D&!C&!B1&!B&A1&A|!E1&!E&D&C&!B1&!B&A1&A|E1&!E&D&C&!B1&!B&A1&A|E1&E&D&C&!B1&!B&A1&A|!E1&E&D&C&!B1&!B&A1&A|E1&E&!D&C&!B1&!B&A1&A|E1&E&!D&C&B1&!B&A1&A|!E1&E&D&C&B1&!B&A1&A|E1&E&D&C&B1&!B&A1&A|E1&!E&D&C&B1&!B&A1&A|!E1&!E&D&C&B1&!B&A1&A|E1&E&D&!C&B1&!B&A1&A|E1&E&!D&!C&B1&!B&A1&A|E1&E&!D&!C&B1&B&A1&A|!E1&E&D&!C&B1&B&A1&A|E1&E&D&!C&B1&B&A1&A|E1&!E&D&!C&B1&B&A1&A|!E1&!E&D&!C&B1&B&A1&A|!E1&!E&D&C&B1&B&A1&A|E1&!E&D&C&B1&B&A1&A|E1&E&D&C&B1&B&A1&A|!E1&E&D&C&B1&B&A1&A|E1&E&!D&C&B1&B&A1&A|E1&E&!D&C&!B1&B&A1&A|!E1&E&D&C&!B1&B&A1&A|E1&E&D&C&!B1&B&A1&A|E1&!E&D&C&!B1&B&A1&A|!E1&!E&D&C&!B1&B&A1&A|E1&E&D&!C&!B1&B&A1&A|E1&E&!D&!C&!B1&B&A1&A|E1&E&!D&!C&!B1&B&!A1&A|E1&E&D&!C&!B1&B&!A1&A|!E1&!E&D&C&!B1&B&!A1&A|E1&!E&D&C&!B1&B&!A1&A|E1&E&D&C&!B1&B&!A1&A|!E1&E&D&C&!B1&B&!A1&A|E1&E&!D&C&!B1&B&!A1&A|E1&E&!D&C&B1&B&!A1&A|!E1&E&D&C&B1&B&!A1&A|E1&E&D&C&B1&B&!A1&A|E1&!E&D&C&B1&B&!A1&A|!E1&!E&D&C&B1&B&!A1&A|!E1&!E&D&!C&B1&B&!A1&A|E1&!E&D&!C&B1&B&!A1&A|E1&E&D&!C&B1&B&!A1&A|!E1&E&D&!C&B1&B&!A1&A|E1&E&!D&!C&B1&B&!A1&A|E1&E&!D&!C&B1&!B&!A1&A|E1&E&D&!C&B1&!B&!A1&A|!E1&!E&D&C&B1&!B&!A1&A|E1&!E&D&C&B1&!B&!A1&A|E1&E&D&C&B1&!B&!A1&A|!E1&E&D&C&B1&!B&!A1&A|E1&E&!D&C&B1&!B&!A1&A|E1&E&!D&C&!B1&!B&!A1&A|!E1&E&D&C&!B1&!B&!A1&A|E1&E&D&C&!B1&!B&!A1&A|E1&!E&D&C&!B1&!B&!A1&A|!E1&!E&D&C&!B1&!B&!A1&A|E1&E&D&!C&!B1&!B&!A1&A|E1&E&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOAAOI22112.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAOI33111 -l AAOAOI33111 -i E D C B2 B1 B A2 A1 A -o Y -f Y=(!E&!D&!C&!B2&!B1&!B&!A2&!A1&!A|!E&D&!C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&C&B2&!B1&!B&!A2&!A1&!A|!E&D&!C&B2&!B1&!B&!A2&!A1&!A|!E&!D&!C&B2&!B1&!B&!A2&!A1&!A|!E&!D&!C&B2&B1&!B&!A2&!A1&!A|!E&D&!C&B2&B1&!B&!A2&!A1&!A|!E&!D&C&B2&B1&!B&!A2&!A1&!A|!E&!D&C&!B2&B1&!B&!A2&!A1&!A|!E&D&!C&!B2&B1&!B&!A2&!A1&!A|!E&!D&!C&!B2&B1&!B&!A2&!A1&!A|!E&!D&!C&!B2&B1&B&!A2&!A1&!A|!E&D&!C&!B2&B1&B&!A2&!A1&!A|!E&!D&C&!B2&B1&B&!A2&!A1&!A|!E&!D&C&B2&B1&B&!A2&!A1&!A|!E&!D&!C&B2&B1&B&!A2&!A1&!A|!E&!D&!C&B2&!B1&B&!A2&!A1&!A|!E&D&!C&B2&!B1&B&!A2&!A1&!A|!E&!D&C&B2&!B1&B&!A2&!A1&!A|!E&!D&C&!B2&!B1&B&!A2&!A1&!A|!E&D&!C&!B2&!B1&B&!A2&!A1&!A|!E&!D&!C&!B2&!B1&B&!A2&!A1&!A|!E&!D&!C&!B2&!B1&B&A2&!A1&!A|!E&D&!C&!B2&!B1&B&A2&!A1&!A|!E&!D&C&!B2&!B1&B&A2&!A1&!A|!E&!D&C&B2&!B1&B&A2&!A1&!A|!E&D&!C&B2&!B1&B&A2&!A1&!A|!E&!D&!C&B2&!B1&B&A2&!A1&!A|!E&!D&!C&B2&B1&B&A2&!A1&!A|!E&!D&C&B2&B1&B&A2&!A1&!A|!E&!D&C&!B2&B1&B&A2&!A1&!A|!E&D&!C&!B2&B1&B&A2&!A1&!A|!E&!D&!C&!B2&B1&B&A2&!A1&!A|!E&!D&!C&!B2&B1&!B&A2&!A1&!A|!E&D&!C&!B2&B1&!B&A2&!A1&!A|!E&!D&C&!B2&B1&!B&A2&!A1&!A|!E&!D&C&B2&B1&!B&A2&!A1&!A|!E&D&!C&B2&B1&!B&A2&!A1&!A|!E&!D&!C&B2&B1&!B&A2&!A1&!A|!E&!D&!C&B2&!B1&!B&A2&!A1&!A|!E&D&!C&B2&!B1&!B&A2&!A1&!A|!E&!D&C&B2&!B1&!B&A2&!A1&!A|!E&!D&C&!B2&!B1&!B&A2&!A1&!A|!E&D&!C&!B2&!B1&!B&A2&!A1&!A|!E&!D&!C&!B2&!B1&!B&A2&!A1&!A|!E&!D&!C&!B2&!B1&!B&A2&A1&!A|!E&D&!C&!B2&!B1&!B&A2&A1&!A|!E&!D&C&!B2&!B1&!B&A2&A1&!A|!E&!D&C&B2&!B1&!B&A2&A1&!A|!E&D&!C&B2&!B1&!B&A2&A1&!A|!E&!D&!C&B2&!B1&!B&A2&A1&!A|!E&!D&!C&B2&B1&!B&A2&A1&!A|!E&D&!C&B2&B1&!B&A2&A1&!A|!E&!D&C&B2&B1&!B&A2&A1&!A|!E&!D&C&!B2&B1&!B&A2&A1&!A|!E&D&!C&!B2&B1&!B&A2&A1&!A|!E&!D&!C&!B2&B1&!B&A2&A1&!A|!E&!D&!C&!B2&B1&B&A2&A1&!A|!E&D&!C&!B2&B1&B&A2&A1&!A|!E&!D&C&!B2&B1&B&A2&A1&!A|!E&!D&C&B2&B1&B&A2&A1&!A|!E&!D&!C&B2&B1&B&A2&A1&!A|!E&!D&!C&B2&!B1&B&A2&A1&!A|!E&D&!C&B2&!B1&B&A2&A1&!A|!E&!D&C&B2&!B1&B&A2&A1&!A|!E&!D&C&!B2&!B1&B&A2&A1&!A|!E&D&!C&!B2&!B1&B&A2&A1&!A|!E&!D&!C&!B2&!B1&B&A2&A1&!A|!E&!D&!C&!B2&!B1&B&!A2&A1&!A|!E&D&!C&!B2&!B1&B&!A2&A1&!A|!E&!D&C&!B2&!B1&B&!A2&A1&!A|!E&!D&C&B2&!B1&B&!A2&A1&!A|!E&D&!C&B2&!B1&B&!A2&A1&!A|!E&!D&!C&B2&!B1&B&!A2&A1&!A|!E&!D&!C&B2&B1&B&!A2&A1&!A|!E&!D&C&B2&B1&B&!A2&A1&!A|!E&!D&C&!B2&B1&B&!A2&A1&!A|!E&D&!C&!B2&B1&B&!A2&A1&!A|!E&!D&!C&!B2&B1&B&!A2&A1&!A|!E&!D&!C&!B2&B1&!B&!A2&A1&!A|!E&D&!C&!B2&B1&!B&!A2&A1&!A|!E&!D&C&!B2&B1&!B&!A2&A1&!A|!E&!D&C&B2&B1&!B&!A2&A1&!A|!E&D&!C&B2&B1&!B&!A2&A1&!A|!E&!D&!C&B2&B1&!B&!A2&A1&!A|!E&!D&!C&B2&!B1&!B&!A2&A1&!A|!E&D&!C&B2&!B1&!B&!A2&A1&!A|!E&!D&C&B2&!B1&!B&!A2&A1&!A|!E&!D&C&!B2&!B1&!B&!A2&A1&!A|!E&D&!C&!B2&!B1&!B&!A2&A1&!A|!E&!D&!C&!B2&!B1&!B&!A2&A1&!A|!E&!D&!C&!B2&!B1&!B&!A2&A1&A|!E&D&!C&!B2&!B1&!B&!A2&A1&A|!E&!D&C&!B2&!B1&!B&!A2&A1&A|!E&!D&C&B2&!B1&!B&!A2&A1&A|!E&D&!C&B2&!B1&!B&!A2&A1&A|!E&!D&!C&B2&!B1&!B&!A2&A1&A|!E&!D&!C&B2&B1&!B&!A2&A1&A|!E&D&!C&B2&B1&!B&!A2&A1&A|!E&!D&C&B2&B1&!B&!A2&A1&A|!E&!D&C&!B2&B1&!B&!A2&A1&A|!E&D&!C&!B2&B1&!B&!A2&A1&A|!E&!D&!C&!B2&B1&!B&!A2&A1&A|!E&!D&!C&!B2&B1&B&!A2&A1&A|!E&D&!C&!B2&B1&B&!A2&A1&A|!E&!D&C&!B2&B1&B&!A2&A1&A|!E&!D&C&B2&B1&B&!A2&A1&A|!E&!D&!C&B2&B1&B&!A2&A1&A|!E&!D&!C&B2&!B1&B&!A2&A1&A|!E&D&!C&B2&!B1&B&!A2&A1&A|!E&!D&C&B2&!B1&B&!A2&A1&A|!E&!D&C&!B2&!B1&B&!A2&A1&A|!E&D&!C&!B2&!B1&B&!A2&A1&A|!E&!D&!C&!B2&!B1&B&!A2&A1&A|!E&!D&!C&!B2&!B1&B&A2&A1&A|!E&!D&C&!B2&!B1&B&A2&A1&A|!E&!D&C&B2&!B1&B&A2&A1&A|!E&!D&!C&B2&!B1&B&A2&A1&A|!E&!D&!C&B2&B1&B&A2&A1&A|!E&!D&C&B2&B1&B&A2&A1&A|!E&!D&C&!B2&B1&B&A2&A1&A|!E&!D&!C&!B2&B1&B&A2&A1&A|!E&!D&!C&!B2&B1&!B&A2&A1&A|!E&!D&C&!B2&B1&!B&A2&A1&A|!E&!D&C&B2&B1&!B&A2&A1&A|!E&!D&!C&B2&B1&!B&A2&A1&A|!E&!D&!C&B2&!B1&!B&A2&A1&A|!E&!D&C&B2&!B1&!B&A2&A1&A|!E&!D&C&!B2&!B1&!B&A2&A1&A|!E&!D&!C&!B2&!B1&!B&A2&A1&A|!E&!D&!C&!B2&!B1&!B&A2&!A1&A|!E&D&!C&!B2&!B1&!B&A2&!A1&A|!E&!D&C&!B2&!B1&!B&A2&!A1&A|!E&!D&C&B2&!B1&!B&A2&!A1&A|!E&D&!C&B2&!B1&!B&A2&!A1&A|!E&!D&!C&B2&!B1&!B&A2&!A1&A|!E&!D&!C&B2&B1&!B&A2&!A1&A|!E&D&!C&B2&B1&!B&A2&!A1&A|!E&!D&C&B2&B1&!B&A2&!A1&A|!E&!D&C&!B2&B1&!B&A2&!A1&A|!E&D&!C&!B2&B1&!B&A2&!A1&A|!E&!D&!C&!B2&B1&!B&A2&!A1&A|!E&!D&!C&!B2&B1&B&A2&!A1&A|!E&D&!C&!B2&B1&B&A2&!A1&A|!E&!D&C&!B2&B1&B&A2&!A1&A|!E&!D&C&B2&B1&B&A2&!A1&A|!E&!D&!C&B2&B1&B&A2&!A1&A|!E&!D&!C&B2&!B1&B&A2&!A1&A|!E&D&!C&B2&!B1&B&A2&!A1&A|!E&!D&C&B2&!B1&B&A2&!A1&A|!E&!D&C&!B2&!B1&B&A2&!A1&A|!E&D&!C&!B2&!B1&B&A2&!A1&A|!E&!D&!C&!B2&!B1&B&A2&!A1&A|!E&!D&!C&!B2&!B1&B&!A2&!A1&A|!E&D&!C&!B2&!B1&B&!A2&!A1&A|!E&!D&C&!B2&!B1&B&!A2&!A1&A|!E&!D&C&B2&!B1&B&!A2&!A1&A|!E&D&!C&B2&!B1&B&!A2&!A1&A|!E&!D&!C&B2&!B1&B&!A2&!A1&A|!E&!D&!C&B2&B1&B&!A2&!A1&A|!E&!D&C&B2&B1&B&!A2&!A1&A|!E&!D&C&!B2&B1&B&!A2&!A1&A|!E&D&!C&!B2&B1&B&!A2&!A1&A|!E&!D&!C&!B2&B1&B&!A2&!A1&A|!E&!D&!C&!B2&B1&!B&!A2&!A1&A|!E&D&!C&!B2&B1&!B&!A2&!A1&A|!E&!D&C&!B2&B1&!B&!A2&!A1&A|!E&!D&C&B2&B1&!B&!A2&!A1&A|!E&D&!C&B2&B1&!B&!A2&!A1&A|!E&!D&!C&B2&B1&!B&!A2&!A1&A|!E&!D&!C&B2&!B1&!B&!A2&!A1&A|!E&D&!C&B2&!B1&!B&!A2&!A1&A|!E&!D&C&B2&!B1&!B&!A2&!A1&A|!E&!D&C&!B2&!B1&!B&!A2&!A1&A|!E&D&!C&!B2&!B1&!B&!A2&!A1&A|!E&!D&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAOI33111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAAOI2222 -l OAAAOI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B1&!B&!A1&!A|D1&!D&!C1&!C&!B1&!B&!A1&!A|!D1&D&!C1&!C&!B1&!B&!A1&!A|!D1&D&C1&!C&!B1&!B&!A1&!A|D1&!D&C1&!C&!B1&!B&!A1&!A|!D1&!D&C1&!C&!B1&!B&!A1&!A|!D1&D&!C1&C&!B1&!B&!A1&!A|D1&!D&!C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&B1&!B&!A1&!A|D1&!D&!C1&C&B1&!B&!A1&!A|!D1&D&!C1&C&B1&!B&!A1&!A|!D1&!D&C1&!C&B1&!B&!A1&!A|D1&!D&C1&!C&B1&!B&!A1&!A|!D1&D&C1&!C&B1&!B&!A1&!A|!D1&D&!C1&!C&B1&!B&!A1&!A|D1&!D&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&B&!A1&!A|D1&!D&!C1&!C&B1&B&!A1&!A|!D1&D&!C1&!C&B1&B&!A1&!A|!D1&D&C1&!C&B1&B&!A1&!A|D1&!D&C1&!C&B1&B&!A1&!A|!D1&!D&C1&!C&B1&B&!A1&!A|!D1&D&!C1&C&B1&B&!A1&!A|D1&!D&!C1&C&B1&B&!A1&!A|!D1&!D&!C1&C&B1&B&!A1&!A|!D1&!D&!C1&C&!B1&B&!A1&!A|D1&!D&!C1&C&!B1&B&!A1&!A|!D1&D&!C1&C&!B1&B&!A1&!A|!D1&!D&C1&!C&!B1&B&!A1&!A|D1&!D&C1&!C&!B1&B&!A1&!A|!D1&D&C1&!C&!B1&B&!A1&!A|!D1&D&!C1&!C&!B1&B&!A1&!A|D1&!D&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&A1&!A|D1&!D&!C1&!C&!B1&B&A1&!A|!D1&D&!C1&!C&!B1&B&A1&!A|!D1&D&C1&!C&!B1&B&A1&!A|D1&!D&C1&!C&!B1&B&A1&!A|!D1&!D&C1&!C&!B1&B&A1&!A|!D1&D&!C1&C&!B1&B&A1&!A|D1&!D&!C1&C&!B1&B&A1&!A|!D1&!D&!C1&C&!B1&B&A1&!A|!D1&!D&!C1&!C&B1&!B&A1&!A|D1&!D&!C1&!C&B1&!B&A1&!A|!D1&D&!C1&!C&B1&!B&A1&!A|!D1&D&C1&!C&B1&!B&A1&!A|D1&!D&C1&!C&B1&!B&A1&!A|!D1&!D&C1&!C&B1&!B&A1&!A|!D1&D&!C1&C&B1&!B&A1&!A|D1&!D&!C1&C&B1&!B&A1&!A|!D1&!D&!C1&C&B1&!B&A1&!A|!D1&!D&!C1&C&!B1&!B&A1&!A|D1&!D&!C1&C&!B1&!B&A1&!A|!D1&D&!C1&C&!B1&!B&A1&!A|!D1&!D&C1&!C&!B1&!B&A1&!A|D1&!D&C1&!C&!B1&!B&A1&!A|!D1&D&C1&!C&!B1&!B&A1&!A|!D1&D&!C1&!C&!B1&!B&A1&!A|D1&!D&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&A|D1&!D&!C1&!C&!B1&!B&A1&A|!D1&D&!C1&!C&!B1&!B&A1&A|!D1&D&C1&!C&!B1&!B&A1&A|D1&!D&C1&!C&!B1&!B&A1&A|!D1&!D&C1&!C&!B1&!B&A1&A|!D1&D&!C1&C&!B1&!B&A1&A|D1&!D&!C1&C&!B1&!B&A1&A|!D1&!D&!C1&C&!B1&!B&A1&A|!D1&!D&!C1&C&B1&!B&A1&A|D1&!D&!C1&C&B1&!B&A1&A|!D1&D&!C1&C&B1&!B&A1&A|!D1&!D&C1&!C&B1&!B&A1&A|D1&!D&C1&!C&B1&!B&A1&A|!D1&D&C1&!C&B1&!B&A1&A|!D1&D&!C1&!C&B1&!B&A1&A|D1&!D&!C1&!C&B1&!B&A1&A|!D1&!D&!C1&!C&B1&!B&A1&A|!D1&!D&!C1&C&!B1&B&A1&A|D1&!D&!C1&C&!B1&B&A1&A|!D1&D&!C1&C&!B1&B&A1&A|!D1&!D&C1&!C&!B1&B&A1&A|D1&!D&C1&!C&!B1&B&A1&A|!D1&D&C1&!C&!B1&B&A1&A|!D1&D&!C1&!C&!B1&B&A1&A|D1&!D&!C1&!C&!B1&B&A1&A|!D1&!D&!C1&!C&!B1&B&A1&A|!D1&!D&!C1&!C&!B1&B&!A1&A|D1&!D&!C1&!C&!B1&B&!A1&A|!D1&D&!C1&!C&!B1&B&!A1&A|!D1&D&C1&!C&!B1&B&!A1&A|D1&!D&C1&!C&!B1&B&!A1&A|!D1&!D&C1&!C&!B1&B&!A1&A|!D1&D&!C1&C&!B1&B&!A1&A|D1&!D&!C1&C&!B1&B&!A1&A|!D1&!D&!C1&C&!B1&B&!A1&A|!D1&!D&!C1&!C&B1&!B&!A1&A|D1&!D&!C1&!C&B1&!B&!A1&A|!D1&D&!C1&!C&B1&!B&!A1&A|!D1&D&C1&!C&B1&!B&!A1&A|D1&!D&C1&!C&B1&!B&!A1&A|!D1&!D&C1&!C&B1&!B&!A1&A|!D1&D&!C1&C&B1&!B&!A1&A|D1&!D&!C1&C&B1&!B&!A1&A|!D1&!D&!C1&C&B1&!B&!A1&A|!D1&!D&!C1&C&!B1&!B&!A1&A|D1&!D&!C1&C&!B1&!B&!A1&A|!D1&D&!C1&C&!B1&!B&!A1&A|!D1&!D&C1&!C&!B1&!B&!A1&A|D1&!D&C1&!C&!B1&!B&!A1&A|!D1&D&C1&!C&!B1&!B&!A1&A|!D1&D&!C1&!C&!B1&!B&!A1&A|D1&!D&!C1&!C&!B1&!B&!A1&A|!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAAOI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAAOI2232 -l OAAAOI2232 -i D1 D C2 C1 C B1 B A1 A -o Y -f Y=!(D1&D&!C2&!C1&!C&!B1&!B&!A1&!A|D1&D&C2&!C1&!C&!B1&!B&!A1&!A|D1&D&C2&C1&!C&!B1&!B&!A1&!A|D1&D&!C2&C1&!C&!B1&!B&!A1&!A|D1&D&!C2&C1&C&!B1&!B&!A1&!A|!D1&D&C2&C1&C&!B1&!B&!A1&!A|D1&D&C2&C1&C&!B1&!B&!A1&!A|D1&!D&C2&C1&C&!B1&!B&!A1&!A|!D1&!D&C2&C1&C&!B1&!B&!A1&!A|D1&D&C2&!C1&C&!B1&!B&!A1&!A|D1&D&!C2&!C1&C&!B1&!B&!A1&!A|D1&D&!C2&!C1&C&B1&!B&!A1&!A|D1&D&C2&!C1&C&B1&!B&!A1&!A|!D1&!D&C2&C1&C&B1&!B&!A1&!A|D1&!D&C2&C1&C&B1&!B&!A1&!A|D1&D&C2&C1&C&B1&!B&!A1&!A|!D1&D&C2&C1&C&B1&!B&!A1&!A|D1&D&!C2&C1&C&B1&!B&!A1&!A|D1&D&!C2&C1&!C&B1&!B&!A1&!A|D1&D&C2&C1&!C&B1&!B&!A1&!A|D1&D&C2&!C1&!C&B1&!B&!A1&!A|D1&D&!C2&!C1&!C&B1&!B&!A1&!A|D1&D&!C2&!C1&!C&B1&B&!A1&!A|D1&D&C2&!C1&!C&B1&B&!A1&!A|D1&D&C2&C1&!C&B1&B&!A1&!A|D1&D&!C2&C1&!C&B1&B&!A1&!A|D1&D&!C2&C1&C&B1&B&!A1&!A|!D1&D&C2&C1&C&B1&B&!A1&!A|D1&D&C2&C1&C&B1&B&!A1&!A|D1&!D&C2&C1&C&B1&B&!A1&!A|!D1&!D&C2&C1&C&B1&B&!A1&!A|D1&D&C2&!C1&C&B1&B&!A1&!A|D1&D&!C2&!C1&C&B1&B&!A1&!A|D1&D&!C2&!C1&C&!B1&B&!A1&!A|D1&D&C2&!C1&C&!B1&B&!A1&!A|!D1&!D&C2&C1&C&!B1&B&!A1&!A|D1&!D&C2&C1&C&!B1&B&!A1&!A|D1&D&C2&C1&C&!B1&B&!A1&!A|!D1&D&C2&C1&C&!B1&B&!A1&!A|D1&D&!C2&C1&C&!B1&B&!A1&!A|D1&D&!C2&C1&!C&!B1&B&!A1&!A|D1&D&C2&C1&!C&!B1&B&!A1&!A|D1&D&C2&!C1&!C&!B1&B&!A1&!A|D1&D&!C2&!C1&!C&!B1&B&!A1&!A|D1&D&!C2&!C1&!C&!B1&B&A1&!A|D1&D&C2&!C1&!C&!B1&B&A1&!A|D1&D&C2&C1&!C&!B1&B&A1&!A|D1&D&!C2&C1&!C&!B1&B&A1&!A|D1&D&!C2&C1&C&!B1&B&A1&!A|!D1&D&C2&C1&C&!B1&B&A1&!A|D1&D&C2&C1&C&!B1&B&A1&!A|D1&!D&C2&C1&C&!B1&B&A1&!A|!D1&!D&C2&C1&C&!B1&B&A1&!A|D1&D&C2&!C1&C&!B1&B&A1&!A|D1&D&!C2&!C1&C&!B1&B&A1&!A|!D1&!D&!C2&!C1&C&B1&B&A1&!A|D1&!D&!C2&!C1&C&B1&B&A1&!A|D1&D&!C2&!C1&C&B1&B&A1&!A|!D1&D&!C2&!C1&C&B1&B&A1&!A|!D1&D&C2&!C1&C&B1&B&A1&!A|D1&D&C2&!C1&C&B1&B&A1&!A|D1&!D&C2&!C1&C&B1&B&A1&!A|!D1&!D&C2&!C1&C&B1&B&A1&!A|!D1&!D&C2&C1&C&B1&B&A1&!A|D1&!D&C2&C1&C&B1&B&A1&!A|D1&D&C2&C1&C&B1&B&A1&!A|!D1&D&C2&C1&C&B1&B&A1&!A|!D1&D&!C2&C1&C&B1&B&A1&!A|D1&D&!C2&C1&C&B1&B&A1&!A|D1&!D&!C2&C1&C&B1&B&A1&!A|!D1&!D&!C2&C1&C&B1&B&A1&!A|!D1&!D&!C2&C1&!C&B1&B&A1&!A|D1&!D&!C2&C1&!C&B1&B&A1&!A|D1&D&!C2&C1&!C&B1&B&A1&!A|!D1&D&!C2&C1&!C&B1&B&A1&!A|!D1&D&C2&C1&!C&B1&B&A1&!A|D1&D&C2&C1&!C&B1&B&A1&!A|D1&!D&C2&C1&!C&B1&B&A1&!A|!D1&!D&C2&C1&!C&B1&B&A1&!A|!D1&!D&C2&!C1&!C&B1&B&A1&!A|D1&!D&C2&!C1&!C&B1&B&A1&!A|D1&D&C2&!C1&!C&B1&B&A1&!A|!D1&D&C2&!C1&!C&B1&B&A1&!A|!D1&D&!C2&!C1&!C&B1&B&A1&!A|D1&D&!C2&!C1&!C&B1&B&A1&!A|D1&!D&!C2&!C1&!C&B1&B&A1&!A|!D1&!D&!C2&!C1&!C&B1&B&A1&!A|D1&D&!C2&!C1&!C&B1&!B&A1&!A|D1&D&C2&!C1&!C&B1&!B&A1&!A|D1&D&C2&C1&!C&B1&!B&A1&!A|D1&D&!C2&C1&!C&B1&!B&A1&!A|D1&D&!C2&C1&C&B1&!B&A1&!A|!D1&D&C2&C1&C&B1&!B&A1&!A|D1&D&C2&C1&C&B1&!B&A1&!A|D1&!D&C2&C1&C&B1&!B&A1&!A|!D1&!D&C2&C1&C&B1&!B&A1&!A|D1&D&C2&!C1&C&B1&!B&A1&!A|D1&D&!C2&!C1&C&B1&!B&A1&!A|D1&D&!C2&!C1&C&!B1&!B&A1&!A|D1&D&C2&!C1&C&!B1&!B&A1&!A|!D1&!D&C2&C1&C&!B1&!B&A1&!A|D1&!D&C2&C1&C&!B1&!B&A1&!A|D1&D&C2&C1&C&!B1&!B&A1&!A|!D1&D&C2&C1&C&!B1&!B&A1&!A|D1&D&!C2&C1&C&!B1&!B&A1&!A|D1&D&!C2&C1&!C&!B1&!B&A1&!A|D1&D&C2&C1&!C&!B1&!B&A1&!A|D1&D&C2&!C1&!C&!B1&!B&A1&!A|D1&D&!C2&!C1&!C&!B1&!B&A1&!A|D1&D&!C2&!C1&!C&!B1&!B&A1&A|D1&D&C2&!C1&!C&!B1&!B&A1&A|D1&D&C2&C1&!C&!B1&!B&A1&A|D1&D&!C2&C1&!C&!B1&!B&A1&A|D1&D&!C2&C1&C&!B1&!B&A1&A|!D1&D&C2&C1&C&!B1&!B&A1&A|D1&D&C2&C1&C&!B1&!B&A1&A|D1&!D&C2&C1&C&!B1&!B&A1&A|!D1&!D&C2&C1&C&!B1&!B&A1&A|D1&D&C2&!C1&C&!B1&!B&A1&A|D1&D&!C2&!C1&C&!B1&!B&A1&A|D1&D&!C2&!C1&C&B1&!B&A1&A|D1&D&C2&!C1&C&B1&!B&A1&A|!D1&!D&C2&C1&C&B1&!B&A1&A|D1&!D&C2&C1&C&B1&!B&A1&A|D1&D&C2&C1&C&B1&!B&A1&A|!D1&D&C2&C1&C&B1&!B&A1&A|D1&D&!C2&C1&C&B1&!B&A1&A|D1&D&!C2&C1&!C&B1&!B&A1&A|D1&D&C2&C1&!C&B1&!B&A1&A|D1&D&C2&!C1&!C&B1&!B&A1&A|D1&D&!C2&!C1&!C&B1&!B&A1&A|!D1&!D&!C2&!C1&!C&B1&B&A1&A|D1&!D&!C2&!C1&!C&B1&B&A1&A|D1&D&!C2&!C1&!C&B1&B&A1&A|!D1&D&!C2&!C1&!C&B1&B&A1&A|!D1&D&C2&!C1&!C&B1&B&A1&A|D1&D&C2&!C1&!C&B1&B&A1&A|D1&!D&C2&!C1&!C&B1&B&A1&A|!D1&!D&C2&!C1&!C&B1&B&A1&A|!D1&!D&C2&C1&!C&B1&B&A1&A|D1&!D&C2&C1&!C&B1&B&A1&A|D1&D&C2&C1&!C&B1&B&A1&A|!D1&D&C2&C1&!C&B1&B&A1&A|!D1&D&!C2&C1&!C&B1&B&A1&A|D1&D&!C2&C1&!C&B1&B&A1&A|D1&!D&!C2&C1&!C&B1&B&A1&A|!D1&!D&!C2&C1&!C&B1&B&A1&A|!D1&!D&!C2&C1&C&B1&B&A1&A|D1&!D&!C2&C1&C&B1&B&A1&A|D1&D&!C2&C1&C&B1&B&A1&A|!D1&D&!C2&C1&C&B1&B&A1&A|!D1&D&C2&C1&C&B1&B&A1&A|D1&D&C2&C1&C&B1&B&A1&A|D1&!D&C2&C1&C&B1&B&A1&A|!D1&!D&C2&C1&C&B1&B&A1&A|!D1&!D&C2&!C1&C&B1&B&A1&A|D1&!D&C2&!C1&C&B1&B&A1&A|D1&D&C2&!C1&C&B1&B&A1&A|!D1&D&C2&!C1&C&B1&B&A1&A|!D1&D&!C2&!C1&C&B1&B&A1&A|D1&D&!C2&!C1&C&B1&B&A1&A|D1&!D&!C2&!C1&C&B1&B&A1&A|!D1&!D&!C2&!C1&C&B1&B&A1&A|D1&D&!C2&!C1&C&!B1&B&A1&A|D1&D&C2&!C1&C&!B1&B&A1&A|!D1&!D&C2&C1&C&!B1&B&A1&A|D1&!D&C2&C1&C&!B1&B&A1&A|D1&D&C2&C1&C&!B1&B&A1&A|!D1&D&C2&C1&C&!B1&B&A1&A|D1&D&!C2&C1&C&!B1&B&A1&A|D1&D&!C2&C1&!C&!B1&B&A1&A|D1&D&C2&C1&!C&!B1&B&A1&A|D1&D&C2&!C1&!C&!B1&B&A1&A|D1&D&!C2&!C1&!C&!B1&B&A1&A|D1&D&!C2&!C1&!C&!B1&B&!A1&A|D1&D&C2&!C1&!C&!B1&B&!A1&A|D1&D&C2&C1&!C&!B1&B&!A1&A|D1&D&!C2&C1&!C&!B1&B&!A1&A|D1&D&!C2&C1&C&!B1&B&!A1&A|!D1&D&C2&C1&C&!B1&B&!A1&A|D1&D&C2&C1&C&!B1&B&!A1&A|D1&!D&C2&C1&C&!B1&B&!A1&A|!D1&!D&C2&C1&C&!B1&B&!A1&A|D1&D&C2&!C1&C&!B1&B&!A1&A|D1&D&!C2&!C1&C&!B1&B&!A1&A|!D1&!D&!C2&!C1&C&B1&B&!A1&A|D1&!D&!C2&!C1&C&B1&B&!A1&A|D1&D&!C2&!C1&C&B1&B&!A1&A|!D1&D&!C2&!C1&C&B1&B&!A1&A|!D1&D&C2&!C1&C&B1&B&!A1&A|D1&D&C2&!C1&C&B1&B&!A1&A|D1&!D&C2&!C1&C&B1&B&!A1&A|!D1&!D&C2&!C1&C&B1&B&!A1&A|!D1&!D&C2&C1&C&B1&B&!A1&A|D1&!D&C2&C1&C&B1&B&!A1&A|D1&D&C2&C1&C&B1&B&!A1&A|!D1&D&C2&C1&C&B1&B&!A1&A|!D1&D&!C2&C1&C&B1&B&!A1&A|D1&D&!C2&C1&C&B1&B&!A1&A|D1&!D&!C2&C1&C&B1&B&!A1&A|!D1&!D&!C2&C1&C&B1&B&!A1&A|!D1&!D&!C2&C1&!C&B1&B&!A1&A|D1&!D&!C2&C1&!C&B1&B&!A1&A|D1&D&!C2&C1&!C&B1&B&!A1&A|!D1&D&!C2&C1&!C&B1&B&!A1&A|!D1&D&C2&C1&!C&B1&B&!A1&A|D1&D&C2&C1&!C&B1&B&!A1&A|D1&!D&C2&C1&!C&B1&B&!A1&A|!D1&!D&C2&C1&!C&B1&B&!A1&A|!D1&!D&C2&!C1&!C&B1&B&!A1&A|D1&!D&C2&!C1&!C&B1&B&!A1&A|D1&D&C2&!C1&!C&B1&B&!A1&A|!D1&D&C2&!C1&!C&B1&B&!A1&A|!D1&D&!C2&!C1&!C&B1&B&!A1&A|D1&D&!C2&!C1&!C&B1&B&!A1&A|D1&!D&!C2&!C1&!C&B1&B&!A1&A|!D1&!D&!C2&!C1&!C&B1&B&!A1&A|D1&D&!C2&!C1&!C&B1&!B&!A1&A|D1&D&C2&!C1&!C&B1&!B&!A1&A|D1&D&C2&C1&!C&B1&!B&!A1&A|D1&D&!C2&C1&!C&B1&!B&!A1&A|D1&D&!C2&C1&C&B1&!B&!A1&A|!D1&D&C2&C1&C&B1&!B&!A1&A|D1&D&C2&C1&C&B1&!B&!A1&A|D1&!D&C2&C1&C&B1&!B&!A1&A|!D1&!D&C2&C1&C&B1&!B&!A1&A|D1&D&C2&!C1&C&B1&!B&!A1&A|D1&D&!C2&!C1&C&B1&!B&!A1&A|D1&D&!C2&!C1&C&!B1&!B&!A1&A|D1&D&C2&!C1&C&!B1&!B&!A1&A|!D1&!D&C2&C1&C&!B1&!B&!A1&A|D1&!D&C2&C1&C&!B1&!B&!A1&A|D1&D&C2&C1&C&!B1&!B&!A1&A|!D1&D&C2&C1&C&!B1&!B&!A1&A|D1&D&!C2&C1&C&!B1&!B&!A1&A|D1&D&!C2&C1&!C&!B1&!B&!A1&A|D1&D&C2&C1&!C&!B1&!B&!A1&A|D1&D&C2&!C1&!C&!B1&!B&!A1&A|D1&D&!C2&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAAOI2232.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOAOI221111 -l OOAOAOI221111 -i F E D C B1 B A1 A -o Y -f Y=(!F&!E&!D&!C&!B1&!B&!A1&!A|!F&E&!D&!C&!B1&!B&!A1&!A|!F&!E&D&!C&!B1&!B&!A1&!A|!F&!E&D&C&!B1&!B&!A1&!A|!F&E&!D&C&!B1&!B&!A1&!A|!F&!E&!D&C&!B1&!B&!A1&!A|!F&!E&!D&C&B1&!B&!A1&!A|!F&E&!D&C&B1&!B&!A1&!A|!F&!E&D&C&B1&!B&!A1&!A|!F&!E&D&!C&B1&!B&!A1&!A|!F&E&!D&!C&B1&!B&!A1&!A|!F&!E&!D&!C&B1&!B&!A1&!A|!F&!E&!D&!C&B1&B&!A1&!A|!F&E&!D&!C&B1&B&!A1&!A|!F&!E&D&!C&B1&B&!A1&!A|!F&!E&D&C&B1&B&!A1&!A|!F&E&!D&C&B1&B&!A1&!A|!F&!E&!D&C&B1&B&!A1&!A|!F&!E&!D&C&!B1&B&!A1&!A|!F&E&!D&C&!B1&B&!A1&!A|!F&!E&D&C&!B1&B&!A1&!A|!F&!E&D&!C&!B1&B&!A1&!A|!F&E&!D&!C&!B1&B&!A1&!A|!F&!E&!D&!C&!B1&B&!A1&!A|!F&!E&!D&!C&!B1&B&A1&!A|!F&E&!D&!C&!B1&B&A1&!A|!F&!E&D&!C&!B1&B&A1&!A|!F&!E&D&C&!B1&B&A1&!A|!F&!E&!D&C&!B1&B&A1&!A|!F&!E&!D&C&B1&B&A1&!A|!F&!E&D&C&B1&B&A1&!A|!F&!E&D&!C&B1&B&A1&!A|!F&E&!D&!C&B1&B&A1&!A|!F&!E&!D&!C&B1&B&A1&!A|!F&!E&!D&!C&B1&!B&A1&!A|!F&E&!D&!C&B1&!B&A1&!A|!F&!E&D&!C&B1&!B&A1&!A|!F&!E&D&C&B1&!B&A1&!A|!F&!E&!D&C&B1&!B&A1&!A|!F&!E&!D&C&!B1&!B&A1&!A|!F&E&!D&C&!B1&!B&A1&!A|!F&!E&D&C&!B1&!B&A1&!A|!F&!E&D&!C&!B1&!B&A1&!A|!F&E&!D&!C&!B1&!B&A1&!A|!F&!E&!D&!C&!B1&!B&A1&!A|!F&!E&!D&!C&!B1&!B&A1&A|!F&E&!D&!C&!B1&!B&A1&A|!F&!E&D&!C&!B1&!B&A1&A|!F&!E&D&C&!B1&!B&A1&A|!F&E&!D&C&!B1&!B&A1&A|!F&!E&!D&C&!B1&!B&A1&A|!F&!E&!D&C&B1&!B&A1&A|!F&!E&D&C&B1&!B&A1&A|!F&!E&D&!C&B1&!B&A1&A|!F&E&!D&!C&B1&!B&A1&A|!F&!E&!D&!C&B1&!B&A1&A|!F&!E&!D&!C&B1&B&A1&A|!F&E&!D&!C&B1&B&A1&A|!F&!E&D&!C&B1&B&A1&A|!F&!E&D&C&B1&B&A1&A|!F&!E&!D&C&B1&B&A1&A|!F&!E&!D&C&!B1&B&A1&A|!F&!E&D&C&!B1&B&A1&A|!F&!E&D&!C&!B1&B&A1&A|!F&E&!D&!C&!B1&B&A1&A|!F&!E&!D&!C&!B1&B&A1&A|!F&!E&!D&!C&!B1&B&!A1&A|!F&E&!D&!C&!B1&B&!A1&A|!F&!E&D&!C&!B1&B&!A1&A|!F&!E&D&C&!B1&B&!A1&A|!F&!E&!D&C&!B1&B&!A1&A|!F&!E&!D&C&B1&B&!A1&A|!F&!E&D&C&B1&B&!A1&A|!F&!E&D&!C&B1&B&!A1&A|!F&E&!D&!C&B1&B&!A1&A|!F&!E&!D&!C&B1&B&!A1&A|!F&!E&!D&!C&B1&!B&!A1&A|!F&E&!D&!C&B1&!B&!A1&A|!F&!E&D&!C&B1&!B&!A1&A|!F&!E&D&C&B1&!B&!A1&A|!F&!E&!D&C&B1&!B&!A1&A|!F&!E&!D&C&!B1&!B&!A1&A|!F&E&!D&C&!B1&!B&!A1&A|!F&!E&D&C&!B1&!B&!A1&A|!F&!E&D&!C&!B1&!B&!A1&A|!F&E&!D&!C&!B1&!B&!A1&A|!F&!E&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOAOI221111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAAOI3222 -l OOOAAOI3222 -i D1 D C1 C B1 B A2 A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B1&!B&!A2&!A1&!A|D1&!D&!C1&!C&!B1&!B&!A2&!A1&!A|!D1&D&!C1&!C&!B1&!B&!A2&!A1&!A|!D1&D&C1&!C&!B1&!B&!A2&!A1&!A|D1&!D&C1&!C&!B1&!B&!A2&!A1&!A|!D1&!D&C1&!C&!B1&!B&!A2&!A1&!A|!D1&!D&C1&C&!B1&!B&!A2&!A1&!A|D1&!D&C1&C&!B1&!B&!A2&!A1&!A|!D1&D&C1&C&!B1&!B&!A2&!A1&!A|!D1&D&!C1&C&!B1&!B&!A2&!A1&!A|D1&!D&!C1&C&!B1&!B&!A2&!A1&!A|!D1&!D&!C1&C&!B1&!B&!A2&!A1&!A|!D1&!D&!C1&C&B1&!B&!A2&!A1&!A|D1&!D&!C1&C&B1&!B&!A2&!A1&!A|!D1&D&!C1&C&B1&!B&!A2&!A1&!A|!D1&D&C1&C&B1&!B&!A2&!A1&!A|D1&!D&C1&C&B1&!B&!A2&!A1&!A|!D1&!D&C1&C&B1&!B&!A2&!A1&!A|!D1&!D&C1&!C&B1&!B&!A2&!A1&!A|D1&!D&C1&!C&B1&!B&!A2&!A1&!A|!D1&D&C1&!C&B1&!B&!A2&!A1&!A|!D1&D&!C1&!C&B1&!B&!A2&!A1&!A|D1&!D&!C1&!C&B1&!B&!A2&!A1&!A|!D1&!D&!C1&!C&B1&!B&!A2&!A1&!A|!D1&!D&!C1&!C&B1&B&!A2&!A1&!A|D1&!D&!C1&!C&B1&B&!A2&!A1&!A|!D1&D&!C1&!C&B1&B&!A2&!A1&!A|!D1&D&C1&!C&B1&B&!A2&!A1&!A|D1&!D&C1&!C&B1&B&!A2&!A1&!A|!D1&!D&C1&!C&B1&B&!A2&!A1&!A|!D1&!D&C1&C&B1&B&!A2&!A1&!A|D1&!D&C1&C&B1&B&!A2&!A1&!A|!D1&D&C1&C&B1&B&!A2&!A1&!A|!D1&D&!C1&C&B1&B&!A2&!A1&!A|D1&!D&!C1&C&B1&B&!A2&!A1&!A|!D1&!D&!C1&C&B1&B&!A2&!A1&!A|!D1&!D&!C1&C&!B1&B&!A2&!A1&!A|D1&!D&!C1&C&!B1&B&!A2&!A1&!A|!D1&D&!C1&C&!B1&B&!A2&!A1&!A|!D1&D&C1&C&!B1&B&!A2&!A1&!A|D1&!D&C1&C&!B1&B&!A2&!A1&!A|!D1&!D&C1&C&!B1&B&!A2&!A1&!A|!D1&!D&C1&!C&!B1&B&!A2&!A1&!A|D1&!D&C1&!C&!B1&B&!A2&!A1&!A|!D1&D&C1&!C&!B1&B&!A2&!A1&!A|!D1&D&!C1&!C&!B1&B&!A2&!A1&!A|D1&!D&!C1&!C&!B1&B&!A2&!A1&!A|!D1&!D&!C1&!C&!B1&B&!A2&!A1&!A|!D1&!D&!C1&!C&!B1&B&A2&!A1&!A|D1&!D&!C1&!C&!B1&B&A2&!A1&!A|!D1&D&!C1&!C&!B1&B&A2&!A1&!A|!D1&D&!C1&!C&B1&B&A2&!A1&!A|D1&!D&!C1&!C&B1&B&A2&!A1&!A|!D1&!D&!C1&!C&B1&B&A2&!A1&!A|!D1&!D&!C1&!C&B1&!B&A2&!A1&!A|D1&!D&!C1&!C&B1&!B&A2&!A1&!A|!D1&D&!C1&!C&B1&!B&A2&!A1&!A|!D1&!D&!C1&C&!B1&!B&A2&!A1&!A|D1&!D&!C1&C&!B1&!B&A2&!A1&!A|!D1&D&!C1&C&!B1&!B&A2&!A1&!A|!D1&D&C1&C&!B1&!B&A2&!A1&!A|D1&!D&C1&C&!B1&!B&A2&!A1&!A|!D1&!D&C1&C&!B1&!B&A2&!A1&!A|!D1&!D&C1&!C&!B1&!B&A2&!A1&!A|D1&!D&C1&!C&!B1&!B&A2&!A1&!A|!D1&D&C1&!C&!B1&!B&A2&!A1&!A|!D1&D&!C1&!C&!B1&!B&A2&!A1&!A|D1&!D&!C1&!C&!B1&!B&A2&!A1&!A|!D1&!D&!C1&!C&!B1&!B&A2&!A1&!A|!D1&!D&!C1&!C&!B1&!B&A2&A1&!A|D1&!D&!C1&!C&!B1&!B&A2&A1&!A|!D1&D&!C1&!C&!B1&!B&A2&A1&!A|!D1&D&C1&!C&!B1&!B&A2&A1&!A|D1&!D&C1&!C&!B1&!B&A2&A1&!A|!D1&!D&C1&!C&!B1&!B&A2&A1&!A|!D1&!D&C1&C&!B1&!B&A2&A1&!A|D1&!D&C1&C&!B1&!B&A2&A1&!A|!D1&D&C1&C&!B1&!B&A2&A1&!A|!D1&D&!C1&C&!B1&!B&A2&A1&!A|D1&!D&!C1&C&!B1&!B&A2&A1&!A|!D1&!D&!C1&C&!B1&!B&A2&A1&!A|!D1&D&!C1&!C&B1&!B&A2&A1&!A|D1&!D&!C1&!C&B1&!B&A2&A1&!A|!D1&!D&!C1&!C&B1&!B&A2&A1&!A|!D1&!D&!C1&!C&B1&B&A2&A1&!A|D1&!D&!C1&!C&B1&B&A2&A1&!A|!D1&D&!C1&!C&B1&B&A2&A1&!A|!D1&D&!C1&!C&!B1&B&A2&A1&!A|D1&!D&!C1&!C&!B1&B&A2&A1&!A|!D1&!D&!C1&!C&!B1&B&A2&A1&!A|!D1&!D&!C1&!C&!B1&B&!A2&A1&!A|D1&!D&!C1&!C&!B1&B&!A2&A1&!A|!D1&D&!C1&!C&!B1&B&!A2&A1&!A|!D1&D&!C1&!C&B1&B&!A2&A1&!A|D1&!D&!C1&!C&B1&B&!A2&A1&!A|!D1&!D&!C1&!C&B1&B&!A2&A1&!A|!D1&!D&!C1&!C&B1&!B&!A2&A1&!A|D1&!D&!C1&!C&B1&!B&!A2&A1&!A|!D1&D&!C1&!C&B1&!B&!A2&A1&!A|!D1&!D&!C1&C&!B1&!B&!A2&A1&!A|D1&!D&!C1&C&!B1&!B&!A2&A1&!A|!D1&D&!C1&C&!B1&!B&!A2&A1&!A|!D1&D&C1&C&!B1&!B&!A2&A1&!A|D1&!D&C1&C&!B1&!B&!A2&A1&!A|!D1&!D&C1&C&!B1&!B&!A2&A1&!A|!D1&!D&C1&!C&!B1&!B&!A2&A1&!A|D1&!D&C1&!C&!B1&!B&!A2&A1&!A|!D1&D&C1&!C&!B1&!B&!A2&A1&!A|!D1&D&!C1&!C&!B1&!B&!A2&A1&!A|D1&!D&!C1&!C&!B1&!B&!A2&A1&!A|!D1&!D&!C1&!C&!B1&!B&!A2&A1&!A|!D1&!D&!C1&!C&!B1&!B&!A2&A1&A|D1&!D&!C1&!C&!B1&!B&!A2&A1&A|!D1&D&!C1&!C&!B1&!B&!A2&A1&A|!D1&D&C1&!C&!B1&!B&!A2&A1&A|D1&!D&C1&!C&!B1&!B&!A2&A1&A|!D1&!D&C1&!C&!B1&!B&!A2&A1&A|!D1&!D&C1&C&!B1&!B&!A2&A1&A|D1&!D&C1&C&!B1&!B&!A2&A1&A|!D1&D&C1&C&!B1&!B&!A2&A1&A|!D1&D&!C1&C&!B1&!B&!A2&A1&A|D1&!D&!C1&C&!B1&!B&!A2&A1&A|!D1&!D&!C1&C&!B1&!B&!A2&A1&A|!D1&D&!C1&!C&B1&!B&!A2&A1&A|D1&!D&!C1&!C&B1&!B&!A2&A1&A|!D1&!D&!C1&!C&B1&!B&!A2&A1&A|!D1&!D&!C1&!C&B1&B&!A2&A1&A|D1&!D&!C1&!C&B1&B&!A2&A1&A|!D1&D&!C1&!C&B1&B&!A2&A1&A|!D1&D&!C1&!C&!B1&B&!A2&A1&A|D1&!D&!C1&!C&!B1&B&!A2&A1&A|!D1&!D&!C1&!C&!B1&B&!A2&A1&A|!D1&!D&!C1&!C&!B1&B&A2&A1&A|D1&!D&!C1&!C&!B1&B&A2&A1&A|!D1&D&!C1&!C&!B1&B&A2&A1&A|!D1&D&!C1&!C&B1&B&A2&A1&A|D1&!D&!C1&!C&B1&B&A2&A1&A|!D1&!D&!C1&!C&B1&B&A2&A1&A|!D1&!D&!C1&!C&B1&!B&A2&A1&A|D1&!D&!C1&!C&B1&!B&A2&A1&A|!D1&D&!C1&!C&B1&!B&A2&A1&A|!D1&!D&!C1&C&!B1&!B&A2&A1&A|D1&!D&!C1&C&!B1&!B&A2&A1&A|!D1&D&!C1&C&!B1&!B&A2&A1&A|!D1&D&C1&C&!B1&!B&A2&A1&A|D1&!D&C1&C&!B1&!B&A2&A1&A|!D1&!D&C1&C&!B1&!B&A2&A1&A|!D1&!D&C1&!C&!B1&!B&A2&A1&A|D1&!D&C1&!C&!B1&!B&A2&A1&A|!D1&D&C1&!C&!B1&!B&A2&A1&A|!D1&D&!C1&!C&!B1&!B&A2&A1&A|D1&!D&!C1&!C&!B1&!B&A2&A1&A|!D1&!D&!C1&!C&!B1&!B&A2&A1&A|!D1&!D&!C1&!C&!B1&!B&A2&!A1&A|D1&!D&!C1&!C&!B1&!B&A2&!A1&A|!D1&D&!C1&!C&!B1&!B&A2&!A1&A|!D1&D&C1&!C&!B1&!B&A2&!A1&A|D1&!D&C1&!C&!B1&!B&A2&!A1&A|!D1&!D&C1&!C&!B1&!B&A2&!A1&A|!D1&!D&C1&C&!B1&!B&A2&!A1&A|D1&!D&C1&C&!B1&!B&A2&!A1&A|!D1&D&C1&C&!B1&!B&A2&!A1&A|!D1&D&!C1&C&!B1&!B&A2&!A1&A|D1&!D&!C1&C&!B1&!B&A2&!A1&A|!D1&!D&!C1&C&!B1&!B&A2&!A1&A|!D1&D&!C1&!C&B1&!B&A2&!A1&A|D1&!D&!C1&!C&B1&!B&A2&!A1&A|!D1&!D&!C1&!C&B1&!B&A2&!A1&A|!D1&!D&!C1&!C&B1&B&A2&!A1&A|D1&!D&!C1&!C&B1&B&A2&!A1&A|!D1&D&!C1&!C&B1&B&A2&!A1&A|!D1&D&!C1&!C&!B1&B&A2&!A1&A|D1&!D&!C1&!C&!B1&B&A2&!A1&A|!D1&!D&!C1&!C&!B1&B&A2&!A1&A|!D1&!D&!C1&!C&!B1&B&!A2&!A1&A|D1&!D&!C1&!C&!B1&B&!A2&!A1&A|!D1&D&!C1&!C&!B1&B&!A2&!A1&A|!D1&D&!C1&!C&B1&B&!A2&!A1&A|D1&!D&!C1&!C&B1&B&!A2&!A1&A|!D1&!D&!C1&!C&B1&B&!A2&!A1&A|!D1&!D&!C1&!C&B1&!B&!A2&!A1&A|D1&!D&!C1&!C&B1&!B&!A2&!A1&A|!D1&D&!C1&!C&B1&!B&!A2&!A1&A|!D1&!D&!C1&C&!B1&!B&!A2&!A1&A|D1&!D&!C1&C&!B1&!B&!A2&!A1&A|!D1&D&!C1&C&!B1&!B&!A2&!A1&A|!D1&D&C1&C&!B1&!B&!A2&!A1&A|D1&!D&C1&C&!B1&!B&!A2&!A1&A|!D1&!D&C1&C&!B1&!B&!A2&!A1&A|!D1&!D&C1&!C&!B1&!B&!A2&!A1&A|D1&!D&C1&!C&!B1&!B&!A2&!A1&A|!D1&D&C1&!C&!B1&!B&!A2&!A1&A|!D1&D&!C1&!C&!B1&!B&!A2&!A1&A|D1&!D&!C1&!C&!B1&!B&!A2&!A1&A|!D1&!D&!C1&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAAOI3222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOI3331 -l AAAOI3331 -i D C2 C1 C B2 B1 B A2 A1 A -o Y -f Y=(!D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|!D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D&C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D&!C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|!D&C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|!D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|!D&C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|!D&C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!D&!C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!D&!C2&C1&C&B2&B1&!B&!A2&!A1&!A|!D&C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!D&!C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D&C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D&!C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|!D&C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|!D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|!D&C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|!D&C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!D&!C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!D&!C2&C1&C&!B2&B1&B&!A2&!A1&!A|!D&C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!D&!C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|!D&C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|!D&C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!D&!C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!D&!C2&C1&C&B2&!B1&B&!A2&!A1&!A|!D&C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!D&!C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D&C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D&!C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|!D&C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|!D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|!D&C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|!D&C2&C1&!C&!B2&!B1&B&A2&!A1&!A|!D&!C2&C1&!C&!B2&!B1&B&A2&!A1&!A|!D&!C2&C1&C&!B2&!B1&B&A2&!A1&!A|!D&C2&!C1&C&!B2&!B1&B&A2&!A1&!A|!D&!C2&!C1&C&!B2&!B1&B&A2&!A1&!A|!D&!C2&!C1&C&B2&!B1&B&A2&!A1&!A|!D&C2&!C1&C&B2&!B1&B&A2&!A1&!A|!D&!C2&C1&C&B2&!B1&B&A2&!A1&!A|!D&!C2&C1&!C&B2&!B1&B&A2&!A1&!A|!D&C2&C1&!C&B2&!B1&B&A2&!A1&!A|!D&C2&!C1&!C&B2&!B1&B&A2&!A1&!A|!D&!C2&!C1&!C&B2&!B1&B&A2&!A1&!A|!D&!C2&!C1&C&!B2&B1&B&A2&!A1&!A|!D&C2&!C1&C&!B2&B1&B&A2&!A1&!A|!D&!C2&C1&C&!B2&B1&B&A2&!A1&!A|!D&!C2&C1&!C&!B2&B1&B&A2&!A1&!A|!D&C2&C1&!C&!B2&B1&B&A2&!A1&!A|!D&C2&!C1&!C&!B2&B1&B&A2&!A1&!A|!D&!C2&!C1&!C&!B2&B1&B&A2&!A1&!A|!D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|!D&C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|!D&C2&C1&!C&!B2&B1&!B&A2&!A1&!A|!D&!C2&C1&!C&!B2&B1&!B&A2&!A1&!A|!D&!C2&C1&C&!B2&B1&!B&A2&!A1&!A|!D&C2&!C1&C&!B2&B1&!B&A2&!A1&!A|!D&!C2&!C1&C&!B2&B1&!B&A2&!A1&!A|!D&!C2&!C1&C&B2&B1&!B&A2&!A1&!A|!D&C2&!C1&C&B2&B1&!B&A2&!A1&!A|!D&!C2&C1&C&B2&B1&!B&A2&!A1&!A|!D&!C2&C1&!C&B2&B1&!B&A2&!A1&!A|!D&C2&C1&!C&B2&B1&!B&A2&!A1&!A|!D&C2&!C1&!C&B2&B1&!B&A2&!A1&!A|!D&!C2&!C1&!C&B2&B1&!B&A2&!A1&!A|!D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|!D&C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|!D&C2&C1&!C&B2&!B1&!B&A2&!A1&!A|!D&!C2&C1&!C&B2&!B1&!B&A2&!A1&!A|!D&!C2&C1&C&B2&!B1&!B&A2&!A1&!A|!D&C2&!C1&C&B2&!B1&!B&A2&!A1&!A|!D&!C2&!C1&C&B2&!B1&!B&A2&!A1&!A|!D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D&C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D&!C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|!D&C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|!D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|!D&C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|!D&C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!D&!C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!D&!C2&C1&C&!B2&!B1&!B&A2&A1&!A|!D&C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!D&!C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!D&!C2&!C1&C&B2&!B1&!B&A2&A1&!A|!D&C2&!C1&C&B2&!B1&!B&A2&A1&!A|!D&!C2&C1&C&B2&!B1&!B&A2&A1&!A|!D&!C2&C1&!C&B2&!B1&!B&A2&A1&!A|!D&C2&C1&!C&B2&!B1&!B&A2&A1&!A|!D&C2&!C1&!C&B2&!B1&!B&A2&A1&!A|!D&!C2&!C1&!C&B2&!B1&!B&A2&A1&!A|!D&!C2&!C1&!C&B2&B1&!B&A2&A1&!A|!D&C2&!C1&!C&B2&B1&!B&A2&A1&!A|!D&C2&C1&!C&B2&B1&!B&A2&A1&!A|!D&!C2&C1&!C&B2&B1&!B&A2&A1&!A|!D&!C2&C1&C&B2&B1&!B&A2&A1&!A|!D&C2&!C1&C&B2&B1&!B&A2&A1&!A|!D&!C2&!C1&C&B2&B1&!B&A2&A1&!A|!D&!C2&!C1&C&!B2&B1&!B&A2&A1&!A|!D&C2&!C1&C&!B2&B1&!B&A2&A1&!A|!D&!C2&C1&C&!B2&B1&!B&A2&A1&!A|!D&!C2&C1&!C&!B2&B1&!B&A2&A1&!A|!D&C2&C1&!C&!B2&B1&!B&A2&A1&!A|!D&C2&!C1&!C&!B2&B1&!B&A2&A1&!A|!D&!C2&!C1&!C&!B2&B1&!B&A2&A1&!A|!D&!C2&!C1&!C&!B2&B1&B&A2&A1&!A|!D&C2&!C1&!C&!B2&B1&B&A2&A1&!A|!D&C2&C1&!C&!B2&B1&B&A2&A1&!A|!D&!C2&C1&!C&!B2&B1&B&A2&A1&!A|!D&!C2&C1&C&!B2&B1&B&A2&A1&!A|!D&C2&!C1&C&!B2&B1&B&A2&A1&!A|!D&!C2&!C1&C&!B2&B1&B&A2&A1&!A|!D&!C2&!C1&!C&B2&!B1&B&A2&A1&!A|!D&C2&!C1&!C&B2&!B1&B&A2&A1&!A|!D&C2&C1&!C&B2&!B1&B&A2&A1&!A|!D&!C2&C1&!C&B2&!B1&B&A2&A1&!A|!D&!C2&C1&C&B2&!B1&B&A2&A1&!A|!D&C2&!C1&C&B2&!B1&B&A2&A1&!A|!D&!C2&!C1&C&B2&!B1&B&A2&A1&!A|!D&!C2&!C1&C&!B2&!B1&B&A2&A1&!A|!D&C2&!C1&C&!B2&!B1&B&A2&A1&!A|!D&!C2&C1&C&!B2&!B1&B&A2&A1&!A|!D&!C2&C1&!C&!B2&!B1&B&A2&A1&!A|!D&C2&C1&!C&!B2&!B1&B&A2&A1&!A|!D&C2&!C1&!C&!B2&!B1&B&A2&A1&!A|!D&!C2&!C1&!C&!B2&!B1&B&A2&A1&!A|!D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|!D&C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|!D&C2&C1&!C&!B2&!B1&B&!A2&A1&!A|!D&!C2&C1&!C&!B2&!B1&B&!A2&A1&!A|!D&!C2&C1&C&!B2&!B1&B&!A2&A1&!A|!D&C2&!C1&C&!B2&!B1&B&!A2&A1&!A|!D&!C2&!C1&C&!B2&!B1&B&!A2&A1&!A|!D&!C2&!C1&C&B2&!B1&B&!A2&A1&!A|!D&C2&!C1&C&B2&!B1&B&!A2&A1&!A|!D&!C2&C1&C&B2&!B1&B&!A2&A1&!A|!D&!C2&C1&!C&B2&!B1&B&!A2&A1&!A|!D&C2&C1&!C&B2&!B1&B&!A2&A1&!A|!D&C2&!C1&!C&B2&!B1&B&!A2&A1&!A|!D&!C2&!C1&!C&B2&!B1&B&!A2&A1&!A|!D&!C2&!C1&C&!B2&B1&B&!A2&A1&!A|!D&C2&!C1&C&!B2&B1&B&!A2&A1&!A|!D&!C2&C1&C&!B2&B1&B&!A2&A1&!A|!D&!C2&C1&!C&!B2&B1&B&!A2&A1&!A|!D&C2&C1&!C&!B2&B1&B&!A2&A1&!A|!D&C2&!C1&!C&!B2&B1&B&!A2&A1&!A|!D&!C2&!C1&!C&!B2&B1&B&!A2&A1&!A|!D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|!D&C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|!D&C2&C1&!C&!B2&B1&!B&!A2&A1&!A|!D&!C2&C1&!C&!B2&B1&!B&!A2&A1&!A|!D&!C2&C1&C&!B2&B1&!B&!A2&A1&!A|!D&C2&!C1&C&!B2&B1&!B&!A2&A1&!A|!D&!C2&!C1&C&!B2&B1&!B&!A2&A1&!A|!D&!C2&!C1&C&B2&B1&!B&!A2&A1&!A|!D&C2&!C1&C&B2&B1&!B&!A2&A1&!A|!D&!C2&C1&C&B2&B1&!B&!A2&A1&!A|!D&!C2&C1&!C&B2&B1&!B&!A2&A1&!A|!D&C2&C1&!C&B2&B1&!B&!A2&A1&!A|!D&C2&!C1&!C&B2&B1&!B&!A2&A1&!A|!D&!C2&!C1&!C&B2&B1&!B&!A2&A1&!A|!D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|!D&C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|!D&C2&C1&!C&B2&!B1&!B&!A2&A1&!A|!D&!C2&C1&!C&B2&!B1&!B&!A2&A1&!A|!D&!C2&C1&C&B2&!B1&!B&!A2&A1&!A|!D&C2&!C1&C&B2&!B1&!B&!A2&A1&!A|!D&!C2&!C1&C&B2&!B1&!B&!A2&A1&!A|!D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D&C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D&!C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|!D&C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|!D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|!D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|!D&C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!D&!C2&C1&C&!B2&!B1&!B&!A2&A1&A|!D&C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!D&!C2&!C1&C&B2&!B1&!B&!A2&A1&A|!D&C2&!C1&C&B2&!B1&!B&!A2&A1&A|!D&!C2&C1&C&B2&!B1&!B&!A2&A1&A|!D&!C2&C1&!C&B2&!B1&!B&!A2&A1&A|!D&C2&C1&!C&B2&!B1&!B&!A2&A1&A|!D&C2&!C1&!C&B2&!B1&!B&!A2&A1&A|!D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&A|!D&!C2&!C1&!C&B2&B1&!B&!A2&A1&A|!D&C2&!C1&!C&B2&B1&!B&!A2&A1&A|!D&C2&C1&!C&B2&B1&!B&!A2&A1&A|!D&!C2&C1&!C&B2&B1&!B&!A2&A1&A|!D&!C2&C1&C&B2&B1&!B&!A2&A1&A|!D&C2&!C1&C&B2&B1&!B&!A2&A1&A|!D&!C2&!C1&C&B2&B1&!B&!A2&A1&A|!D&!C2&!C1&C&!B2&B1&!B&!A2&A1&A|!D&C2&!C1&C&!B2&B1&!B&!A2&A1&A|!D&!C2&C1&C&!B2&B1&!B&!A2&A1&A|!D&!C2&C1&!C&!B2&B1&!B&!A2&A1&A|!D&C2&C1&!C&!B2&B1&!B&!A2&A1&A|!D&C2&!C1&!C&!B2&B1&!B&!A2&A1&A|!D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&A|!D&!C2&!C1&!C&!B2&B1&B&!A2&A1&A|!D&C2&!C1&!C&!B2&B1&B&!A2&A1&A|!D&C2&C1&!C&!B2&B1&B&!A2&A1&A|!D&!C2&C1&!C&!B2&B1&B&!A2&A1&A|!D&!C2&C1&C&!B2&B1&B&!A2&A1&A|!D&C2&!C1&C&!B2&B1&B&!A2&A1&A|!D&!C2&!C1&C&!B2&B1&B&!A2&A1&A|!D&!C2&!C1&!C&B2&!B1&B&!A2&A1&A|!D&C2&!C1&!C&B2&!B1&B&!A2&A1&A|!D&C2&C1&!C&B2&!B1&B&!A2&A1&A|!D&!C2&C1&!C&B2&!B1&B&!A2&A1&A|!D&!C2&C1&C&B2&!B1&B&!A2&A1&A|!D&C2&!C1&C&B2&!B1&B&!A2&A1&A|!D&!C2&!C1&C&B2&!B1&B&!A2&A1&A|!D&!C2&!C1&C&!B2&!B1&B&!A2&A1&A|!D&C2&!C1&C&!B2&!B1&B&!A2&A1&A|!D&!C2&C1&C&!B2&!B1&B&!A2&A1&A|!D&!C2&C1&!C&!B2&!B1&B&!A2&A1&A|!D&C2&C1&!C&!B2&!B1&B&!A2&A1&A|!D&C2&!C1&!C&!B2&!B1&B&!A2&A1&A|!D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&A|!D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|!D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|!D&C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!D&!C2&C1&C&!B2&!B1&!B&A2&!A1&A|!D&C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!D&!C2&!C1&C&B2&!B1&!B&A2&!A1&A|!D&C2&!C1&C&B2&!B1&!B&A2&!A1&A|!D&!C2&C1&C&B2&!B1&!B&A2&!A1&A|!D&!C2&C1&!C&B2&!B1&!B&A2&!A1&A|!D&C2&C1&!C&B2&!B1&!B&A2&!A1&A|!D&C2&!C1&!C&B2&!B1&!B&A2&!A1&A|!D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&A|!D&!C2&!C1&!C&B2&B1&!B&A2&!A1&A|!D&C2&!C1&!C&B2&B1&!B&A2&!A1&A|!D&C2&C1&!C&B2&B1&!B&A2&!A1&A|!D&!C2&C1&!C&B2&B1&!B&A2&!A1&A|!D&!C2&C1&C&B2&B1&!B&A2&!A1&A|!D&C2&!C1&C&B2&B1&!B&A2&!A1&A|!D&!C2&!C1&C&B2&B1&!B&A2&!A1&A|!D&!C2&!C1&C&!B2&B1&!B&A2&!A1&A|!D&C2&!C1&C&!B2&B1&!B&A2&!A1&A|!D&!C2&C1&C&!B2&B1&!B&A2&!A1&A|!D&!C2&C1&!C&!B2&B1&!B&A2&!A1&A|!D&C2&C1&!C&!B2&B1&!B&A2&!A1&A|!D&C2&!C1&!C&!B2&B1&!B&A2&!A1&A|!D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&A|!D&!C2&!C1&!C&!B2&B1&B&A2&!A1&A|!D&C2&!C1&!C&!B2&B1&B&A2&!A1&A|!D&C2&C1&!C&!B2&B1&B&A2&!A1&A|!D&!C2&C1&!C&!B2&B1&B&A2&!A1&A|!D&!C2&C1&C&!B2&B1&B&A2&!A1&A|!D&C2&!C1&C&!B2&B1&B&A2&!A1&A|!D&!C2&!C1&C&!B2&B1&B&A2&!A1&A|!D&!C2&!C1&!C&B2&!B1&B&A2&!A1&A|!D&C2&!C1&!C&B2&!B1&B&A2&!A1&A|!D&C2&C1&!C&B2&!B1&B&A2&!A1&A|!D&!C2&C1&!C&B2&!B1&B&A2&!A1&A|!D&!C2&C1&C&B2&!B1&B&A2&!A1&A|!D&C2&!C1&C&B2&!B1&B&A2&!A1&A|!D&!C2&!C1&C&B2&!B1&B&A2&!A1&A|!D&!C2&!C1&C&!B2&!B1&B&A2&!A1&A|!D&C2&!C1&C&!B2&!B1&B&A2&!A1&A|!D&!C2&C1&C&!B2&!B1&B&A2&!A1&A|!D&!C2&C1&!C&!B2&!B1&B&A2&!A1&A|!D&C2&C1&!C&!B2&!B1&B&A2&!A1&A|!D&C2&!C1&!C&!B2&!B1&B&A2&!A1&A|!D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&A|!D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|!D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|!D&C2&C1&!C&!B2&!B1&B&!A2&!A1&A|!D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&A|!D&!C2&C1&C&!B2&!B1&B&!A2&!A1&A|!D&C2&!C1&C&!B2&!B1&B&!A2&!A1&A|!D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&A|!D&!C2&!C1&C&B2&!B1&B&!A2&!A1&A|!D&C2&!C1&C&B2&!B1&B&!A2&!A1&A|!D&!C2&C1&C&B2&!B1&B&!A2&!A1&A|!D&!C2&C1&!C&B2&!B1&B&!A2&!A1&A|!D&C2&C1&!C&B2&!B1&B&!A2&!A1&A|!D&C2&!C1&!C&B2&!B1&B&!A2&!A1&A|!D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&A|!D&!C2&!C1&C&!B2&B1&B&!A2&!A1&A|!D&C2&!C1&C&!B2&B1&B&!A2&!A1&A|!D&!C2&C1&C&!B2&B1&B&!A2&!A1&A|!D&!C2&C1&!C&!B2&B1&B&!A2&!A1&A|!D&C2&C1&!C&!B2&B1&B&!A2&!A1&A|!D&C2&!C1&!C&!B2&B1&B&!A2&!A1&A|!D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&A|!D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|!D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|!D&C2&C1&!C&!B2&B1&!B&!A2&!A1&A|!D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&A|!D&!C2&C1&C&!B2&B1&!B&!A2&!A1&A|!D&C2&!C1&C&!B2&B1&!B&!A2&!A1&A|!D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&A|!D&!C2&!C1&C&B2&B1&!B&!A2&!A1&A|!D&C2&!C1&C&B2&B1&!B&!A2&!A1&A|!D&!C2&C1&C&B2&B1&!B&!A2&!A1&A|!D&!C2&C1&!C&B2&B1&!B&!A2&!A1&A|!D&C2&C1&!C&B2&B1&!B&!A2&!A1&A|!D&C2&!C1&!C&B2&B1&!B&!A2&!A1&A|!D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&A|!D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|!D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|!D&C2&C1&!C&B2&!B1&!B&!A2&!A1&A|!D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&A|!D&!C2&C1&C&B2&!B1&!B&!A2&!A1&A|!D&C2&!C1&C&B2&!B1&!B&!A2&!A1&A|!D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&A|!D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|!D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|!D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|!D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOI3331.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOAI22111 -l AOAOAI22111 -i E D C B1 B A1 A -o Y -f Y=!(E&D&!C&!B1&!B&!A1&!A|E&D&C&!B1&!B&!A1&!A|E&!D&C&B1&!B&!A1&!A|E&D&C&B1&!B&!A1&!A|E&D&!C&B1&!B&!A1&!A|E&D&!C&B1&B&!A1&!A|E&D&C&B1&B&!A1&!A|E&!D&C&B1&B&!A1&!A|E&!D&C&!B1&B&!A1&!A|E&D&C&!B1&B&!A1&!A|E&D&!C&!B1&B&!A1&!A|E&D&!C&!B1&B&A1&!A|E&D&C&!B1&B&A1&!A|E&!D&C&!B1&B&A1&!A|E&!D&C&B1&B&A1&!A|E&D&C&B1&B&A1&!A|E&D&!C&B1&B&A1&!A|E&D&!C&B1&!B&A1&!A|E&D&C&B1&!B&A1&!A|E&!D&C&B1&!B&A1&!A|E&D&C&!B1&!B&A1&!A|E&D&!C&!B1&!B&A1&!A|E&D&!C&!B1&!B&A1&A|E&D&C&!B1&!B&A1&A|E&!D&C&!B1&!B&A1&A|E&!D&C&B1&!B&A1&A|E&D&C&B1&!B&A1&A|E&D&!C&B1&!B&A1&A|E&D&!C&B1&B&A1&A|E&D&C&B1&B&A1&A|E&!D&C&B1&B&A1&A|E&!D&C&!B1&B&A1&A|E&D&C&!B1&B&A1&A|E&D&!C&!B1&B&A1&A|E&D&!C&!B1&B&!A1&A|E&D&C&!B1&B&!A1&A|E&!D&C&!B1&B&!A1&A|E&!D&C&B1&B&!A1&A|E&D&C&B1&B&!A1&A|E&D&!C&B1&B&!A1&A|E&D&!C&B1&!B&!A1&A|E&D&C&B1&!B&!A1&A|E&!D&C&B1&!B&!A1&A|E&D&C&!B1&!B&!A1&A|E&D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOAI22111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOOAI2213 -l OOAOOAI2213 -i D2 D1 D C B1 B A1 A -o Y -f Y=(!D2&!D1&!D&!C&!B1&!B&!A1&!A|D2&!D1&!D&!C&!B1&!B&!A1&!A|D2&D1&!D&!C&!B1&!B&!A1&!A|!D2&D1&!D&!C&!B1&!B&!A1&!A|!D2&D1&D&!C&!B1&!B&!A1&!A|D2&D1&D&!C&!B1&!B&!A1&!A|D2&!D1&D&!C&!B1&!B&!A1&!A|!D2&!D1&D&!C&!B1&!B&!A1&!A|!D2&!D1&!D&C&!B1&!B&!A1&!A|!D2&!D1&!D&C&B1&!B&!A1&!A|!D2&!D1&D&!C&B1&!B&!A1&!A|D2&!D1&D&!C&B1&!B&!A1&!A|D2&D1&D&!C&B1&!B&!A1&!A|!D2&D1&D&!C&B1&!B&!A1&!A|!D2&D1&!D&!C&B1&!B&!A1&!A|D2&D1&!D&!C&B1&!B&!A1&!A|D2&!D1&!D&!C&B1&!B&!A1&!A|!D2&!D1&!D&!C&B1&!B&!A1&!A|!D2&!D1&!D&!C&B1&B&!A1&!A|D2&!D1&!D&!C&B1&B&!A1&!A|D2&D1&!D&!C&B1&B&!A1&!A|!D2&D1&!D&!C&B1&B&!A1&!A|!D2&D1&D&!C&B1&B&!A1&!A|D2&D1&D&!C&B1&B&!A1&!A|D2&!D1&D&!C&B1&B&!A1&!A|!D2&!D1&D&!C&B1&B&!A1&!A|!D2&!D1&!D&C&B1&B&!A1&!A|!D2&!D1&!D&C&!B1&B&!A1&!A|!D2&!D1&D&!C&!B1&B&!A1&!A|D2&!D1&D&!C&!B1&B&!A1&!A|D2&D1&D&!C&!B1&B&!A1&!A|!D2&D1&D&!C&!B1&B&!A1&!A|!D2&D1&!D&!C&!B1&B&!A1&!A|D2&D1&!D&!C&!B1&B&!A1&!A|D2&!D1&!D&!C&!B1&B&!A1&!A|!D2&!D1&!D&!C&!B1&B&!A1&!A|!D2&!D1&!D&!C&!B1&B&A1&!A|!D2&!D1&!D&C&!B1&B&A1&!A|!D2&!D1&!D&C&B1&B&A1&!A|!D2&!D1&!D&!C&B1&B&A1&!A|!D2&!D1&!D&!C&B1&!B&A1&!A|!D2&!D1&!D&C&B1&!B&A1&!A|!D2&!D1&!D&C&!B1&!B&A1&!A|!D2&!D1&D&!C&!B1&!B&A1&!A|D2&!D1&D&!C&!B1&!B&A1&!A|D2&D1&D&!C&!B1&!B&A1&!A|!D2&D1&D&!C&!B1&!B&A1&!A|!D2&D1&!D&!C&!B1&!B&A1&!A|D2&D1&!D&!C&!B1&!B&A1&!A|D2&!D1&!D&!C&!B1&!B&A1&!A|!D2&!D1&!D&!C&!B1&!B&A1&!A|!D2&!D1&!D&!C&!B1&!B&A1&A|D2&!D1&!D&!C&!B1&!B&A1&A|D2&D1&!D&!C&!B1&!B&A1&A|!D2&D1&!D&!C&!B1&!B&A1&A|!D2&D1&D&!C&!B1&!B&A1&A|D2&D1&D&!C&!B1&!B&A1&A|D2&!D1&D&!C&!B1&!B&A1&A|!D2&!D1&D&!C&!B1&!B&A1&A|!D2&!D1&!D&C&!B1&!B&A1&A|!D2&!D1&!D&C&B1&!B&A1&A|!D2&!D1&!D&!C&B1&!B&A1&A|!D2&!D1&!D&!C&B1&B&A1&A|!D2&!D1&!D&C&B1&B&A1&A|!D2&!D1&!D&C&!B1&B&A1&A|!D2&!D1&!D&!C&!B1&B&A1&A|!D2&!D1&!D&!C&!B1&B&!A1&A|!D2&!D1&!D&C&!B1&B&!A1&A|!D2&!D1&!D&C&B1&B&!A1&A|!D2&!D1&!D&!C&B1&B&!A1&A|!D2&!D1&!D&!C&B1&!B&!A1&A|!D2&!D1&!D&C&B1&!B&!A1&A|!D2&!D1&!D&C&!B1&!B&!A1&A|!D2&!D1&D&!C&!B1&!B&!A1&A|D2&!D1&D&!C&!B1&!B&!A1&A|D2&D1&D&!C&!B1&!B&!A1&A|!D2&D1&D&!C&!B1&!B&!A1&A|!D2&D1&!D&!C&!B1&!B&!A1&A|D2&D1&!D&!C&!B1&!B&!A1&A|D2&!D1&!D&!C&!B1&!B&!A1&A|!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOOAI2213.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOI3212 -l AOAAOI3212 -i D1 D C B1 B A2 A1 A -o Y -f Y=(!D1&!D&!C&!B1&!B&!A2&!A1&!A|D1&!D&!C&!B1&!B&!A2&!A1&!A|!D1&D&!C&!B1&!B&!A2&!A1&!A|!D1&D&C&!B1&!B&!A2&!A1&!A|D1&!D&C&!B1&!B&!A2&!A1&!A|!D1&!D&C&!B1&!B&!A2&!A1&!A|!D1&D&!C&B1&!B&!A2&!A1&!A|D1&!D&!C&B1&!B&!A2&!A1&!A|!D1&!D&!C&B1&!B&!A2&!A1&!A|!D1&!D&!C&B1&B&!A2&!A1&!A|D1&!D&!C&B1&B&!A2&!A1&!A|!D1&D&!C&B1&B&!A2&!A1&!A|!D1&D&!C&!B1&B&!A2&!A1&!A|D1&!D&!C&!B1&B&!A2&!A1&!A|!D1&!D&!C&!B1&B&!A2&!A1&!A|!D1&!D&!C&!B1&B&A2&!A1&!A|D1&!D&!C&!B1&B&A2&!A1&!A|!D1&D&!C&!B1&B&A2&!A1&!A|!D1&D&!C&B1&B&A2&!A1&!A|D1&!D&!C&B1&B&A2&!A1&!A|!D1&!D&!C&B1&B&A2&!A1&!A|!D1&!D&!C&B1&!B&A2&!A1&!A|D1&!D&!C&B1&!B&A2&!A1&!A|!D1&D&!C&B1&!B&A2&!A1&!A|!D1&!D&C&!B1&!B&A2&!A1&!A|D1&!D&C&!B1&!B&A2&!A1&!A|!D1&D&C&!B1&!B&A2&!A1&!A|!D1&D&!C&!B1&!B&A2&!A1&!A|D1&!D&!C&!B1&!B&A2&!A1&!A|!D1&!D&!C&!B1&!B&A2&!A1&!A|!D1&!D&!C&!B1&!B&A2&A1&!A|D1&!D&!C&!B1&!B&A2&A1&!A|!D1&D&!C&!B1&!B&A2&A1&!A|!D1&D&C&!B1&!B&A2&A1&!A|D1&!D&C&!B1&!B&A2&A1&!A|!D1&!D&C&!B1&!B&A2&A1&!A|!D1&D&!C&B1&!B&A2&A1&!A|D1&!D&!C&B1&!B&A2&A1&!A|!D1&!D&!C&B1&!B&A2&A1&!A|!D1&!D&!C&B1&B&A2&A1&!A|D1&!D&!C&B1&B&A2&A1&!A|!D1&D&!C&B1&B&A2&A1&!A|!D1&D&!C&!B1&B&A2&A1&!A|D1&!D&!C&!B1&B&A2&A1&!A|!D1&!D&!C&!B1&B&A2&A1&!A|!D1&!D&!C&!B1&B&!A2&A1&!A|D1&!D&!C&!B1&B&!A2&A1&!A|!D1&D&!C&!B1&B&!A2&A1&!A|!D1&D&!C&B1&B&!A2&A1&!A|D1&!D&!C&B1&B&!A2&A1&!A|!D1&!D&!C&B1&B&!A2&A1&!A|!D1&!D&!C&B1&!B&!A2&A1&!A|D1&!D&!C&B1&!B&!A2&A1&!A|!D1&D&!C&B1&!B&!A2&A1&!A|!D1&!D&C&!B1&!B&!A2&A1&!A|D1&!D&C&!B1&!B&!A2&A1&!A|!D1&D&C&!B1&!B&!A2&A1&!A|!D1&D&!C&!B1&!B&!A2&A1&!A|D1&!D&!C&!B1&!B&!A2&A1&!A|!D1&!D&!C&!B1&!B&!A2&A1&!A|!D1&!D&!C&!B1&!B&!A2&A1&A|D1&!D&!C&!B1&!B&!A2&A1&A|!D1&D&!C&!B1&!B&!A2&A1&A|!D1&D&C&!B1&!B&!A2&A1&A|D1&!D&C&!B1&!B&!A2&A1&A|!D1&!D&C&!B1&!B&!A2&A1&A|!D1&D&!C&B1&!B&!A2&A1&A|D1&!D&!C&B1&!B&!A2&A1&A|!D1&!D&!C&B1&!B&!A2&A1&A|!D1&!D&!C&B1&B&!A2&A1&A|D1&!D&!C&B1&B&!A2&A1&A|!D1&D&!C&B1&B&!A2&A1&A|!D1&D&!C&!B1&B&!A2&A1&A|D1&!D&!C&!B1&B&!A2&A1&A|!D1&!D&!C&!B1&B&!A2&A1&A|!D1&!D&!C&!B1&B&A2&A1&A|D1&!D&!C&!B1&B&A2&A1&A|!D1&D&!C&!B1&B&A2&A1&A|!D1&D&!C&B1&B&A2&A1&A|D1&!D&!C&B1&B&A2&A1&A|!D1&!D&!C&B1&B&A2&A1&A|!D1&!D&!C&B1&!B&A2&A1&A|D1&!D&!C&B1&!B&A2&A1&A|!D1&D&!C&B1&!B&A2&A1&A|!D1&D&!C&!B1&!B&A2&A1&A|D1&!D&!C&!B1&!B&A2&A1&A|!D1&!D&!C&!B1&!B&A2&A1&A|!D1&!D&!C&!B1&!B&A2&!A1&A|D1&!D&!C&!B1&!B&A2&!A1&A|!D1&D&!C&!B1&!B&A2&!A1&A|!D1&D&C&!B1&!B&A2&!A1&A|D1&!D&C&!B1&!B&A2&!A1&A|!D1&!D&C&!B1&!B&A2&!A1&A|!D1&D&!C&B1&!B&A2&!A1&A|D1&!D&!C&B1&!B&A2&!A1&A|!D1&!D&!C&B1&!B&A2&!A1&A|!D1&!D&!C&B1&B&A2&!A1&A|D1&!D&!C&B1&B&A2&!A1&A|!D1&D&!C&B1&B&A2&!A1&A|!D1&D&!C&!B1&B&A2&!A1&A|D1&!D&!C&!B1&B&A2&!A1&A|!D1&!D&!C&!B1&B&A2&!A1&A|!D1&!D&!C&!B1&B&!A2&!A1&A|D1&!D&!C&!B1&B&!A2&!A1&A|!D1&D&!C&!B1&B&!A2&!A1&A|!D1&D&!C&B1&B&!A2&!A1&A|D1&!D&!C&B1&B&!A2&!A1&A|!D1&!D&!C&B1&B&!A2&!A1&A|!D1&!D&!C&B1&!B&!A2&!A1&A|D1&!D&!C&B1&!B&!A2&!A1&A|!D1&D&!C&B1&!B&!A2&!A1&A|!D1&!D&C&!B1&!B&!A2&!A1&A|D1&!D&C&!B1&!B&!A2&!A1&A|!D1&D&C&!B1&!B&!A2&!A1&A|!D1&D&!C&!B1&!B&!A2&!A1&A|D1&!D&!C&!B1&!B&!A2&!A1&A|!D1&!D&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOI3212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOAI22111 -l OOAOAI22111 -i E D C B1 B A1 A -o Y -f Y=!(E&D&!C&!B1&!B&!A1&!A|E&D&C&!B1&!B&!A1&!A|E&D&C&B1&!B&!A1&!A|E&D&!C&B1&!B&!A1&!A|E&D&!C&B1&B&!A1&!A|E&D&C&B1&B&!A1&!A|E&D&C&!B1&B&!A1&!A|E&D&!C&!B1&B&!A1&!A|E&D&!C&!B1&B&A1&!A|E&D&C&!B1&B&A1&!A|E&!D&C&!B1&B&A1&!A|E&!D&C&B1&B&A1&!A|E&D&C&B1&B&A1&!A|E&D&!C&B1&B&A1&!A|E&D&!C&B1&!B&A1&!A|E&D&C&B1&!B&A1&!A|E&!D&C&B1&!B&A1&!A|E&D&C&!B1&!B&A1&!A|E&D&!C&!B1&!B&A1&!A|E&D&!C&!B1&!B&A1&A|E&D&C&!B1&!B&A1&A|E&!D&C&B1&!B&A1&A|E&D&C&B1&!B&A1&A|E&D&!C&B1&!B&A1&A|E&D&!C&B1&B&A1&A|E&D&C&B1&B&A1&A|E&!D&C&B1&B&A1&A|E&!D&C&!B1&B&A1&A|E&D&C&!B1&B&A1&A|E&D&!C&!B1&B&A1&A|E&D&!C&!B1&B&!A1&A|E&D&C&!B1&B&!A1&A|E&!D&C&!B1&B&!A1&A|E&!D&C&B1&B&!A1&A|E&D&C&B1&B&!A1&A|E&D&!C&B1&B&!A1&A|E&D&!C&B1&!B&!A1&A|E&D&C&B1&!B&!A1&A|E&!D&C&B1&!B&!A1&A|E&D&C&!B1&!B&!A1&A|E&D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOAI22111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAI2241 -l AAOOAI2241 -i D C3 C2 C1 C B1 B A1 A -o Y -f Y=!(D&C3&!C2&!C1&!C&B1&B&!A1&!A|D&C3&C2&!C1&!C&B1&B&!A1&!A|D&!C3&C2&!C1&!C&B1&B&!A1&!A|D&!C3&C2&C1&!C&B1&B&!A1&!A|D&C3&C2&C1&!C&B1&B&!A1&!A|D&C3&!C2&C1&!C&B1&B&!A1&!A|D&!C3&!C2&C1&!C&B1&B&!A1&!A|D&!C3&!C2&C1&C&B1&B&!A1&!A|D&C3&!C2&C1&C&B1&B&!A1&!A|D&C3&C2&C1&C&B1&B&!A1&!A|D&!C3&C2&C1&C&B1&B&!A1&!A|D&!C3&C2&!C1&C&B1&B&!A1&!A|D&C3&C2&!C1&C&B1&B&!A1&!A|D&C3&!C2&!C1&C&B1&B&!A1&!A|D&!C3&!C2&!C1&C&B1&B&!A1&!A|D&!C3&!C2&!C1&C&B1&B&A1&!A|D&C3&!C2&!C1&C&B1&B&A1&!A|D&C3&C2&!C1&C&B1&B&A1&!A|D&!C3&C2&!C1&C&B1&B&A1&!A|D&!C3&C2&C1&C&B1&B&A1&!A|D&C3&C2&C1&C&B1&B&A1&!A|D&C3&!C2&C1&C&B1&B&A1&!A|D&!C3&!C2&C1&C&B1&B&A1&!A|D&!C3&!C2&C1&!C&B1&B&A1&!A|D&C3&!C2&C1&!C&B1&B&A1&!A|D&C3&C2&C1&!C&B1&B&A1&!A|D&!C3&C2&C1&!C&B1&B&A1&!A|D&!C3&C2&!C1&!C&B1&B&A1&!A|D&C3&C2&!C1&!C&B1&B&A1&!A|D&C3&!C2&!C1&!C&B1&B&A1&!A|D&C3&!C2&!C1&!C&!B1&!B&A1&A|D&C3&C2&!C1&!C&!B1&!B&A1&A|D&!C3&C2&!C1&!C&!B1&!B&A1&A|D&!C3&C2&C1&!C&!B1&!B&A1&A|D&C3&C2&C1&!C&!B1&!B&A1&A|D&C3&!C2&C1&!C&!B1&!B&A1&A|D&!C3&!C2&C1&!C&!B1&!B&A1&A|D&!C3&!C2&C1&C&!B1&!B&A1&A|D&C3&!C2&C1&C&!B1&!B&A1&A|D&C3&C2&C1&C&!B1&!B&A1&A|D&!C3&C2&C1&C&!B1&!B&A1&A|D&!C3&C2&!C1&C&!B1&!B&A1&A|D&C3&C2&!C1&C&!B1&!B&A1&A|D&C3&!C2&!C1&C&!B1&!B&A1&A|D&!C3&!C2&!C1&C&!B1&!B&A1&A|D&!C3&!C2&!C1&C&B1&!B&A1&A|D&C3&!C2&!C1&C&B1&!B&A1&A|D&C3&C2&!C1&C&B1&!B&A1&A|D&!C3&C2&!C1&C&B1&!B&A1&A|D&!C3&C2&C1&C&B1&!B&A1&A|D&C3&C2&C1&C&B1&!B&A1&A|D&C3&!C2&C1&C&B1&!B&A1&A|D&!C3&!C2&C1&C&B1&!B&A1&A|D&!C3&!C2&C1&!C&B1&!B&A1&A|D&C3&!C2&C1&!C&B1&!B&A1&A|D&C3&C2&C1&!C&B1&!B&A1&A|D&!C3&C2&C1&!C&B1&!B&A1&A|D&!C3&C2&!C1&!C&B1&!B&A1&A|D&C3&C2&!C1&!C&B1&!B&A1&A|D&C3&!C2&!C1&!C&B1&!B&A1&A|D&C3&!C2&!C1&!C&B1&B&A1&A|D&C3&C2&!C1&!C&B1&B&A1&A|D&!C3&C2&!C1&!C&B1&B&A1&A|D&!C3&C2&C1&!C&B1&B&A1&A|D&C3&C2&C1&!C&B1&B&A1&A|D&C3&!C2&C1&!C&B1&B&A1&A|D&!C3&!C2&C1&!C&B1&B&A1&A|D&!C3&!C2&C1&C&B1&B&A1&A|D&C3&!C2&C1&C&B1&B&A1&A|D&C3&C2&C1&C&B1&B&A1&A|D&!C3&C2&C1&C&B1&B&A1&A|D&!C3&C2&!C1&C&B1&B&A1&A|D&C3&C2&!C1&C&B1&B&A1&A|D&C3&!C2&!C1&C&B1&B&A1&A|D&!C3&!C2&!C1&C&B1&B&A1&A|D&!C3&!C2&!C1&C&!B1&B&A1&A|D&C3&!C2&!C1&C&!B1&B&A1&A|D&C3&C2&!C1&C&!B1&B&A1&A|D&!C3&C2&!C1&C&!B1&B&A1&A|D&!C3&C2&C1&C&!B1&B&A1&A|D&C3&C2&C1&C&!B1&B&A1&A|D&C3&!C2&C1&C&!B1&B&A1&A|D&!C3&!C2&C1&C&!B1&B&A1&A|D&!C3&!C2&C1&!C&!B1&B&A1&A|D&C3&!C2&C1&!C&!B1&B&A1&A|D&C3&C2&C1&!C&!B1&B&A1&A|D&!C3&C2&C1&!C&!B1&B&A1&A|D&!C3&C2&!C1&!C&!B1&B&A1&A|D&C3&C2&!C1&!C&!B1&B&A1&A|D&C3&!C2&!C1&!C&!B1&B&A1&A|D&!C3&!C2&!C1&C&B1&B&!A1&A|D&C3&!C2&!C1&C&B1&B&!A1&A|D&C3&C2&!C1&C&B1&B&!A1&A|D&!C3&C2&!C1&C&B1&B&!A1&A|D&!C3&C2&C1&C&B1&B&!A1&A|D&C3&C2&C1&C&B1&B&!A1&A|D&C3&!C2&C1&C&B1&B&!A1&A|D&!C3&!C2&C1&C&B1&B&!A1&A|D&!C3&!C2&C1&!C&B1&B&!A1&A|D&C3&!C2&C1&!C&B1&B&!A1&A|D&C3&C2&C1&!C&B1&B&!A1&A|D&!C3&C2&C1&!C&B1&B&!A1&A|D&!C3&C2&!C1&!C&B1&B&!A1&A|D&C3&C2&!C1&!C&B1&B&!A1&A|D&C3&!C2&!C1&!C&B1&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAI2241.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAOI22211 -l AAOOAOI22211 -i E D C1 C B1 B A1 A -o Y -f Y=(!E&!D&!C1&!C&!B1&!B&!A1&!A|!E&D&!C1&!C&!B1&!B&!A1&!A|!E&D&C1&!C&!B1&!B&!A1&!A|!E&!D&C1&!C&!B1&!B&!A1&!A|!E&!D&C1&C&!B1&!B&!A1&!A|!E&D&C1&C&!B1&!B&!A1&!A|!E&D&!C1&C&!B1&!B&!A1&!A|!E&!D&!C1&C&!B1&!B&!A1&!A|!E&!D&!C1&C&B1&!B&!A1&!A|!E&D&!C1&C&B1&!B&!A1&!A|!E&D&C1&C&B1&!B&!A1&!A|!E&!D&C1&C&B1&!B&!A1&!A|!E&!D&C1&!C&B1&!B&!A1&!A|!E&D&C1&!C&B1&!B&!A1&!A|!E&D&!C1&!C&B1&!B&!A1&!A|!E&!D&!C1&!C&B1&!B&!A1&!A|!E&!D&!C1&!C&B1&B&!A1&!A|!E&D&!C1&!C&B1&B&!A1&!A|!E&!D&C1&!C&B1&B&!A1&!A|!E&!D&C1&C&B1&B&!A1&!A|!E&!D&!C1&C&B1&B&!A1&!A|!E&!D&!C1&C&!B1&B&!A1&!A|!E&D&!C1&C&!B1&B&!A1&!A|!E&D&C1&C&!B1&B&!A1&!A|!E&!D&C1&C&!B1&B&!A1&!A|!E&!D&C1&!C&!B1&B&!A1&!A|!E&D&C1&!C&!B1&B&!A1&!A|!E&D&!C1&!C&!B1&B&!A1&!A|!E&!D&!C1&!C&!B1&B&!A1&!A|!E&!D&!C1&!C&!B1&B&A1&!A|!E&D&!C1&!C&!B1&B&A1&!A|!E&D&C1&!C&!B1&B&A1&!A|!E&!D&C1&!C&!B1&B&A1&!A|!E&!D&C1&C&!B1&B&A1&!A|!E&D&C1&C&!B1&B&A1&!A|!E&D&!C1&C&!B1&B&A1&!A|!E&!D&!C1&C&!B1&B&A1&!A|!E&!D&!C1&C&B1&B&A1&!A|!E&!D&C1&C&B1&B&A1&!A|!E&!D&C1&!C&B1&B&A1&!A|!E&D&!C1&!C&B1&B&A1&!A|!E&!D&!C1&!C&B1&B&A1&!A|!E&!D&!C1&!C&B1&!B&A1&!A|!E&D&!C1&!C&B1&!B&A1&!A|!E&D&C1&!C&B1&!B&A1&!A|!E&!D&C1&!C&B1&!B&A1&!A|!E&!D&C1&C&B1&!B&A1&!A|!E&D&C1&C&B1&!B&A1&!A|!E&D&!C1&C&B1&!B&A1&!A|!E&!D&!C1&C&B1&!B&A1&!A|!E&!D&!C1&C&!B1&!B&A1&!A|!E&D&!C1&C&!B1&!B&A1&!A|!E&D&C1&C&!B1&!B&A1&!A|!E&!D&C1&C&!B1&!B&A1&!A|!E&!D&C1&!C&!B1&!B&A1&!A|!E&D&C1&!C&!B1&!B&A1&!A|!E&D&!C1&!C&!B1&!B&A1&!A|!E&!D&!C1&!C&!B1&!B&A1&!A|!E&!D&!C1&!C&!B1&!B&A1&A|!E&D&!C1&!C&!B1&!B&A1&A|!E&!D&C1&!C&!B1&!B&A1&A|!E&!D&C1&C&!B1&!B&A1&A|!E&!D&!C1&C&!B1&!B&A1&A|!E&!D&!C1&C&B1&!B&A1&A|!E&!D&C1&C&B1&!B&A1&A|!E&!D&C1&!C&B1&!B&A1&A|!E&D&!C1&!C&B1&!B&A1&A|!E&!D&!C1&!C&B1&!B&A1&A|!E&!D&!C1&!C&B1&B&A1&A|!E&D&!C1&!C&B1&B&A1&A|!E&!D&C1&!C&B1&B&A1&A|!E&!D&C1&C&B1&B&A1&A|!E&!D&!C1&C&B1&B&A1&A|!E&!D&!C1&C&!B1&B&A1&A|!E&!D&C1&C&!B1&B&A1&A|!E&!D&C1&!C&!B1&B&A1&A|!E&D&!C1&!C&!B1&B&A1&A|!E&!D&!C1&!C&!B1&B&A1&A|!E&!D&!C1&!C&!B1&B&!A1&A|!E&D&!C1&!C&!B1&B&!A1&A|!E&D&C1&!C&!B1&B&!A1&A|!E&!D&C1&!C&!B1&B&!A1&A|!E&!D&C1&C&!B1&B&!A1&A|!E&D&C1&C&!B1&B&!A1&A|!E&D&!C1&C&!B1&B&!A1&A|!E&!D&!C1&C&!B1&B&!A1&A|!E&!D&!C1&C&B1&B&!A1&A|!E&!D&C1&C&B1&B&!A1&A|!E&!D&C1&!C&B1&B&!A1&A|!E&D&!C1&!C&B1&B&!A1&A|!E&!D&!C1&!C&B1&B&!A1&A|!E&!D&!C1&!C&B1&!B&!A1&A|!E&D&!C1&!C&B1&!B&!A1&A|!E&D&C1&!C&B1&!B&!A1&A|!E&!D&C1&!C&B1&!B&!A1&A|!E&!D&C1&C&B1&!B&!A1&A|!E&D&C1&C&B1&!B&!A1&A|!E&D&!C1&C&B1&!B&!A1&A|!E&!D&!C1&C&B1&!B&!A1&A|!E&!D&!C1&C&!B1&!B&!A1&A|!E&D&!C1&C&!B1&!B&!A1&A|!E&D&C1&C&!B1&!B&!A1&A|!E&!D&C1&C&!B1&!B&!A1&A|!E&!D&C1&!C&!B1&!B&!A1&A|!E&D&C1&!C&!B1&!B&!A1&A|!E&D&!C1&!C&!B1&!B&!A1&A|!E&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAOI22211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOI2121 -l AOOAOI2121 -i D C1 C B A1 A -o Y -f Y=(!D&!C1&!C&!B&!A1&!A|!D&C1&!C&!B&!A1&!A|!D&C1&C&!B&!A1&!A|!D&!C1&C&!B&!A1&!A|!D&!C1&!C&B&!A1&!A|!D&!C1&!C&B&A1&!A|!D&!C1&C&!B&A1&!A|!D&C1&C&!B&A1&!A|!D&C1&!C&!B&A1&!A|!D&!C1&!C&!B&A1&!A|!D&!C1&!C&!B&A1&A|!D&!C1&!C&B&A1&A|!D&!C1&!C&B&!A1&A|!D&!C1&C&!B&!A1&A|!D&C1&C&!B&!A1&A|!D&C1&!C&!B&!A1&A|!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOI2121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOOAI3322 -l OOOOAI3322 -i D1 D C1 C B2 B1 B A2 A1 A -o Y -f Y=!(!D1&D&C1&!C&!B2&!B1&B&A2&!A1&!A|D1&D&C1&!C&!B2&!B1&B&A2&!A1&!A|D1&!D&C1&!C&!B2&!B1&B&A2&!A1&!A|D1&!D&C1&C&!B2&!B1&B&A2&!A1&!A|D1&D&C1&C&!B2&!B1&B&A2&!A1&!A|!D1&D&C1&C&!B2&!B1&B&A2&!A1&!A|!D1&D&!C1&C&!B2&!B1&B&A2&!A1&!A|D1&D&!C1&C&!B2&!B1&B&A2&!A1&!A|D1&!D&!C1&C&!B2&!B1&B&A2&!A1&!A|D1&!D&!C1&C&B2&!B1&B&A2&!A1&!A|D1&D&!C1&C&B2&!B1&B&A2&!A1&!A|!D1&D&!C1&C&B2&!B1&B&A2&!A1&!A|!D1&D&C1&C&B2&!B1&B&A2&!A1&!A|D1&D&C1&C&B2&!B1&B&A2&!A1&!A|D1&!D&C1&C&B2&!B1&B&A2&!A1&!A|D1&!D&C1&!C&B2&!B1&B&A2&!A1&!A|D1&D&C1&!C&B2&!B1&B&A2&!A1&!A|!D1&D&C1&!C&B2&!B1&B&A2&!A1&!A|!D1&D&C1&!C&B2&B1&B&A2&!A1&!A|D1&D&C1&!C&B2&B1&B&A2&!A1&!A|D1&!D&C1&!C&B2&B1&B&A2&!A1&!A|D1&!D&C1&C&B2&B1&B&A2&!A1&!A|D1&D&C1&C&B2&B1&B&A2&!A1&!A|!D1&D&C1&C&B2&B1&B&A2&!A1&!A|!D1&D&!C1&C&B2&B1&B&A2&!A1&!A|D1&D&!C1&C&B2&B1&B&A2&!A1&!A|D1&!D&!C1&C&B2&B1&B&A2&!A1&!A|D1&!D&!C1&C&!B2&B1&B&A2&!A1&!A|D1&D&!C1&C&!B2&B1&B&A2&!A1&!A|!D1&D&!C1&C&!B2&B1&B&A2&!A1&!A|!D1&D&C1&C&!B2&B1&B&A2&!A1&!A|D1&D&C1&C&!B2&B1&B&A2&!A1&!A|D1&!D&C1&C&!B2&B1&B&A2&!A1&!A|D1&!D&C1&!C&!B2&B1&B&A2&!A1&!A|D1&D&C1&!C&!B2&B1&B&A2&!A1&!A|!D1&D&C1&!C&!B2&B1&B&A2&!A1&!A|!D1&D&C1&!C&!B2&B1&!B&A2&!A1&!A|D1&D&C1&!C&!B2&B1&!B&A2&!A1&!A|D1&!D&C1&!C&!B2&B1&!B&A2&!A1&!A|D1&!D&C1&C&!B2&B1&!B&A2&!A1&!A|D1&D&C1&C&!B2&B1&!B&A2&!A1&!A|!D1&D&C1&C&!B2&B1&!B&A2&!A1&!A|!D1&D&!C1&C&!B2&B1&!B&A2&!A1&!A|D1&D&!C1&C&!B2&B1&!B&A2&!A1&!A|D1&!D&!C1&C&!B2&B1&!B&A2&!A1&!A|D1&!D&!C1&C&B2&B1&!B&A2&!A1&!A|D1&D&!C1&C&B2&B1&!B&A2&!A1&!A|!D1&D&!C1&C&B2&B1&!B&A2&!A1&!A|!D1&D&C1&C&B2&B1&!B&A2&!A1&!A|D1&D&C1&C&B2&B1&!B&A2&!A1&!A|D1&!D&C1&C&B2&B1&!B&A2&!A1&!A|D1&!D&C1&!C&B2&B1&!B&A2&!A1&!A|D1&D&C1&!C&B2&B1&!B&A2&!A1&!A|!D1&D&C1&!C&B2&B1&!B&A2&!A1&!A|!D1&D&C1&!C&B2&!B1&!B&A2&!A1&!A|D1&D&C1&!C&B2&!B1&!B&A2&!A1&!A|D1&!D&C1&!C&B2&!B1&!B&A2&!A1&!A|D1&!D&C1&C&B2&!B1&!B&A2&!A1&!A|D1&D&C1&C&B2&!B1&!B&A2&!A1&!A|!D1&D&C1&C&B2&!B1&!B&A2&!A1&!A|!D1&D&!C1&C&B2&!B1&!B&A2&!A1&!A|D1&D&!C1&C&B2&!B1&!B&A2&!A1&!A|D1&!D&!C1&C&B2&!B1&!B&A2&!A1&!A|D1&!D&!C1&C&B2&!B1&!B&A2&A1&!A|D1&D&!C1&C&B2&!B1&!B&A2&A1&!A|!D1&D&!C1&C&B2&!B1&!B&A2&A1&!A|!D1&D&C1&C&B2&!B1&!B&A2&A1&!A|D1&D&C1&C&B2&!B1&!B&A2&A1&!A|D1&!D&C1&C&B2&!B1&!B&A2&A1&!A|D1&!D&C1&!C&B2&!B1&!B&A2&A1&!A|D1&D&C1&!C&B2&!B1&!B&A2&A1&!A|!D1&D&C1&!C&B2&!B1&!B&A2&A1&!A|!D1&D&C1&!C&B2&B1&!B&A2&A1&!A|D1&D&C1&!C&B2&B1&!B&A2&A1&!A|D1&!D&C1&!C&B2&B1&!B&A2&A1&!A|D1&!D&C1&C&B2&B1&!B&A2&A1&!A|D1&D&C1&C&B2&B1&!B&A2&A1&!A|!D1&D&C1&C&B2&B1&!B&A2&A1&!A|!D1&D&!C1&C&B2&B1&!B&A2&A1&!A|D1&D&!C1&C&B2&B1&!B&A2&A1&!A|D1&!D&!C1&C&B2&B1&!B&A2&A1&!A|D1&!D&!C1&C&!B2&B1&!B&A2&A1&!A|D1&D&!C1&C&!B2&B1&!B&A2&A1&!A|!D1&D&!C1&C&!B2&B1&!B&A2&A1&!A|!D1&D&C1&C&!B2&B1&!B&A2&A1&!A|D1&D&C1&C&!B2&B1&!B&A2&A1&!A|D1&!D&C1&C&!B2&B1&!B&A2&A1&!A|D1&!D&C1&!C&!B2&B1&!B&A2&A1&!A|D1&D&C1&!C&!B2&B1&!B&A2&A1&!A|!D1&D&C1&!C&!B2&B1&!B&A2&A1&!A|!D1&D&C1&!C&!B2&B1&B&A2&A1&!A|D1&D&C1&!C&!B2&B1&B&A2&A1&!A|D1&!D&C1&!C&!B2&B1&B&A2&A1&!A|D1&!D&C1&C&!B2&B1&B&A2&A1&!A|D1&D&C1&C&!B2&B1&B&A2&A1&!A|!D1&D&C1&C&!B2&B1&B&A2&A1&!A|!D1&D&!C1&C&!B2&B1&B&A2&A1&!A|D1&D&!C1&C&!B2&B1&B&A2&A1&!A|D1&!D&!C1&C&!B2&B1&B&A2&A1&!A|D1&!D&!C1&C&B2&B1&B&A2&A1&!A|D1&D&!C1&C&B2&B1&B&A2&A1&!A|!D1&D&!C1&C&B2&B1&B&A2&A1&!A|!D1&D&C1&C&B2&B1&B&A2&A1&!A|D1&D&C1&C&B2&B1&B&A2&A1&!A|D1&!D&C1&C&B2&B1&B&A2&A1&!A|D1&!D&C1&!C&B2&B1&B&A2&A1&!A|D1&D&C1&!C&B2&B1&B&A2&A1&!A|!D1&D&C1&!C&B2&B1&B&A2&A1&!A|!D1&D&C1&!C&B2&!B1&B&A2&A1&!A|D1&D&C1&!C&B2&!B1&B&A2&A1&!A|D1&!D&C1&!C&B2&!B1&B&A2&A1&!A|D1&!D&C1&C&B2&!B1&B&A2&A1&!A|D1&D&C1&C&B2&!B1&B&A2&A1&!A|!D1&D&C1&C&B2&!B1&B&A2&A1&!A|!D1&D&!C1&C&B2&!B1&B&A2&A1&!A|D1&D&!C1&C&B2&!B1&B&A2&A1&!A|D1&!D&!C1&C&B2&!B1&B&A2&A1&!A|D1&!D&!C1&C&!B2&!B1&B&A2&A1&!A|D1&D&!C1&C&!B2&!B1&B&A2&A1&!A|!D1&D&!C1&C&!B2&!B1&B&A2&A1&!A|!D1&D&C1&C&!B2&!B1&B&A2&A1&!A|D1&D&C1&C&!B2&!B1&B&A2&A1&!A|D1&!D&C1&C&!B2&!B1&B&A2&A1&!A|D1&!D&C1&!C&!B2&!B1&B&A2&A1&!A|D1&D&C1&!C&!B2&!B1&B&A2&A1&!A|!D1&D&C1&!C&!B2&!B1&B&A2&A1&!A|!D1&D&C1&!C&!B2&!B1&B&!A2&A1&!A|D1&D&C1&!C&!B2&!B1&B&!A2&A1&!A|D1&!D&C1&!C&!B2&!B1&B&!A2&A1&!A|D1&!D&C1&C&!B2&!B1&B&!A2&A1&!A|D1&D&C1&C&!B2&!B1&B&!A2&A1&!A|!D1&D&C1&C&!B2&!B1&B&!A2&A1&!A|!D1&D&!C1&C&!B2&!B1&B&!A2&A1&!A|D1&D&!C1&C&!B2&!B1&B&!A2&A1&!A|D1&!D&!C1&C&!B2&!B1&B&!A2&A1&!A|D1&!D&!C1&C&B2&!B1&B&!A2&A1&!A|D1&D&!C1&C&B2&!B1&B&!A2&A1&!A|!D1&D&!C1&C&B2&!B1&B&!A2&A1&!A|!D1&D&C1&C&B2&!B1&B&!A2&A1&!A|D1&D&C1&C&B2&!B1&B&!A2&A1&!A|D1&!D&C1&C&B2&!B1&B&!A2&A1&!A|D1&!D&C1&!C&B2&!B1&B&!A2&A1&!A|D1&D&C1&!C&B2&!B1&B&!A2&A1&!A|!D1&D&C1&!C&B2&!B1&B&!A2&A1&!A|!D1&D&C1&!C&B2&B1&B&!A2&A1&!A|D1&D&C1&!C&B2&B1&B&!A2&A1&!A|D1&!D&C1&!C&B2&B1&B&!A2&A1&!A|D1&!D&C1&C&B2&B1&B&!A2&A1&!A|D1&D&C1&C&B2&B1&B&!A2&A1&!A|!D1&D&C1&C&B2&B1&B&!A2&A1&!A|!D1&D&!C1&C&B2&B1&B&!A2&A1&!A|D1&D&!C1&C&B2&B1&B&!A2&A1&!A|D1&!D&!C1&C&B2&B1&B&!A2&A1&!A|D1&!D&!C1&C&!B2&B1&B&!A2&A1&!A|D1&D&!C1&C&!B2&B1&B&!A2&A1&!A|!D1&D&!C1&C&!B2&B1&B&!A2&A1&!A|!D1&D&C1&C&!B2&B1&B&!A2&A1&!A|D1&D&C1&C&!B2&B1&B&!A2&A1&!A|D1&!D&C1&C&!B2&B1&B&!A2&A1&!A|D1&!D&C1&!C&!B2&B1&B&!A2&A1&!A|D1&D&C1&!C&!B2&B1&B&!A2&A1&!A|!D1&D&C1&!C&!B2&B1&B&!A2&A1&!A|!D1&D&C1&!C&!B2&B1&!B&!A2&A1&!A|D1&D&C1&!C&!B2&B1&!B&!A2&A1&!A|D1&!D&C1&!C&!B2&B1&!B&!A2&A1&!A|D1&!D&C1&C&!B2&B1&!B&!A2&A1&!A|D1&D&C1&C&!B2&B1&!B&!A2&A1&!A|!D1&D&C1&C&!B2&B1&!B&!A2&A1&!A|!D1&D&!C1&C&!B2&B1&!B&!A2&A1&!A|D1&D&!C1&C&!B2&B1&!B&!A2&A1&!A|D1&!D&!C1&C&!B2&B1&!B&!A2&A1&!A|D1&!D&!C1&C&B2&B1&!B&!A2&A1&!A|D1&D&!C1&C&B2&B1&!B&!A2&A1&!A|!D1&D&!C1&C&B2&B1&!B&!A2&A1&!A|!D1&D&C1&C&B2&B1&!B&!A2&A1&!A|D1&D&C1&C&B2&B1&!B&!A2&A1&!A|D1&!D&C1&C&B2&B1&!B&!A2&A1&!A|D1&!D&C1&!C&B2&B1&!B&!A2&A1&!A|D1&D&C1&!C&B2&B1&!B&!A2&A1&!A|!D1&D&C1&!C&B2&B1&!B&!A2&A1&!A|!D1&D&C1&!C&B2&!B1&!B&!A2&A1&!A|D1&D&C1&!C&B2&!B1&!B&!A2&A1&!A|D1&!D&C1&!C&B2&!B1&!B&!A2&A1&!A|D1&!D&C1&C&B2&!B1&!B&!A2&A1&!A|D1&D&C1&C&B2&!B1&!B&!A2&A1&!A|!D1&D&C1&C&B2&!B1&!B&!A2&A1&!A|!D1&D&!C1&C&B2&!B1&!B&!A2&A1&!A|D1&D&!C1&C&B2&!B1&!B&!A2&A1&!A|D1&!D&!C1&C&B2&!B1&!B&!A2&A1&!A|D1&!D&!C1&C&B2&!B1&!B&!A2&A1&A|D1&D&!C1&C&B2&!B1&!B&!A2&A1&A|!D1&D&!C1&C&B2&!B1&!B&!A2&A1&A|!D1&D&C1&C&B2&!B1&!B&!A2&A1&A|D1&D&C1&C&B2&!B1&!B&!A2&A1&A|D1&!D&C1&C&B2&!B1&!B&!A2&A1&A|D1&!D&C1&!C&B2&!B1&!B&!A2&A1&A|D1&D&C1&!C&B2&!B1&!B&!A2&A1&A|!D1&D&C1&!C&B2&!B1&!B&!A2&A1&A|!D1&D&C1&!C&B2&B1&!B&!A2&A1&A|D1&D&C1&!C&B2&B1&!B&!A2&A1&A|D1&!D&C1&!C&B2&B1&!B&!A2&A1&A|D1&!D&C1&C&B2&B1&!B&!A2&A1&A|D1&D&C1&C&B2&B1&!B&!A2&A1&A|!D1&D&C1&C&B2&B1&!B&!A2&A1&A|!D1&D&!C1&C&B2&B1&!B&!A2&A1&A|D1&D&!C1&C&B2&B1&!B&!A2&A1&A|D1&!D&!C1&C&B2&B1&!B&!A2&A1&A|D1&!D&!C1&C&!B2&B1&!B&!A2&A1&A|D1&D&!C1&C&!B2&B1&!B&!A2&A1&A|!D1&D&!C1&C&!B2&B1&!B&!A2&A1&A|!D1&D&C1&C&!B2&B1&!B&!A2&A1&A|D1&D&C1&C&!B2&B1&!B&!A2&A1&A|D1&!D&C1&C&!B2&B1&!B&!A2&A1&A|D1&!D&C1&!C&!B2&B1&!B&!A2&A1&A|D1&D&C1&!C&!B2&B1&!B&!A2&A1&A|!D1&D&C1&!C&!B2&B1&!B&!A2&A1&A|!D1&D&C1&!C&!B2&B1&B&!A2&A1&A|D1&D&C1&!C&!B2&B1&B&!A2&A1&A|D1&!D&C1&!C&!B2&B1&B&!A2&A1&A|D1&!D&C1&C&!B2&B1&B&!A2&A1&A|D1&D&C1&C&!B2&B1&B&!A2&A1&A|!D1&D&C1&C&!B2&B1&B&!A2&A1&A|!D1&D&!C1&C&!B2&B1&B&!A2&A1&A|D1&D&!C1&C&!B2&B1&B&!A2&A1&A|D1&!D&!C1&C&!B2&B1&B&!A2&A1&A|D1&!D&!C1&C&B2&B1&B&!A2&A1&A|D1&D&!C1&C&B2&B1&B&!A2&A1&A|!D1&D&!C1&C&B2&B1&B&!A2&A1&A|!D1&D&C1&C&B2&B1&B&!A2&A1&A|D1&D&C1&C&B2&B1&B&!A2&A1&A|D1&!D&C1&C&B2&B1&B&!A2&A1&A|D1&!D&C1&!C&B2&B1&B&!A2&A1&A|D1&D&C1&!C&B2&B1&B&!A2&A1&A|!D1&D&C1&!C&B2&B1&B&!A2&A1&A|!D1&D&C1&!C&B2&!B1&B&!A2&A1&A|D1&D&C1&!C&B2&!B1&B&!A2&A1&A|D1&!D&C1&!C&B2&!B1&B&!A2&A1&A|D1&!D&C1&C&B2&!B1&B&!A2&A1&A|D1&D&C1&C&B2&!B1&B&!A2&A1&A|!D1&D&C1&C&B2&!B1&B&!A2&A1&A|!D1&D&!C1&C&B2&!B1&B&!A2&A1&A|D1&D&!C1&C&B2&!B1&B&!A2&A1&A|D1&!D&!C1&C&B2&!B1&B&!A2&A1&A|D1&!D&!C1&C&!B2&!B1&B&!A2&A1&A|D1&D&!C1&C&!B2&!B1&B&!A2&A1&A|!D1&D&!C1&C&!B2&!B1&B&!A2&A1&A|!D1&D&C1&C&!B2&!B1&B&!A2&A1&A|D1&D&C1&C&!B2&!B1&B&!A2&A1&A|D1&!D&C1&C&!B2&!B1&B&!A2&A1&A|D1&!D&C1&!C&!B2&!B1&B&!A2&A1&A|D1&D&C1&!C&!B2&!B1&B&!A2&A1&A|!D1&D&C1&!C&!B2&!B1&B&!A2&A1&A|!D1&D&C1&!C&!B2&!B1&B&A2&A1&A|D1&D&C1&!C&!B2&!B1&B&A2&A1&A|D1&!D&C1&!C&!B2&!B1&B&A2&A1&A|D1&!D&C1&C&!B2&!B1&B&A2&A1&A|D1&D&C1&C&!B2&!B1&B&A2&A1&A|!D1&D&C1&C&!B2&!B1&B&A2&A1&A|!D1&D&!C1&C&!B2&!B1&B&A2&A1&A|D1&D&!C1&C&!B2&!B1&B&A2&A1&A|D1&!D&!C1&C&!B2&!B1&B&A2&A1&A|D1&!D&!C1&C&B2&!B1&B&A2&A1&A|D1&D&!C1&C&B2&!B1&B&A2&A1&A|!D1&D&!C1&C&B2&!B1&B&A2&A1&A|!D1&D&C1&C&B2&!B1&B&A2&A1&A|D1&D&C1&C&B2&!B1&B&A2&A1&A|D1&!D&C1&C&B2&!B1&B&A2&A1&A|D1&!D&C1&!C&B2&!B1&B&A2&A1&A|D1&D&C1&!C&B2&!B1&B&A2&A1&A|!D1&D&C1&!C&B2&!B1&B&A2&A1&A|!D1&D&C1&!C&B2&B1&B&A2&A1&A|D1&D&C1&!C&B2&B1&B&A2&A1&A|D1&!D&C1&!C&B2&B1&B&A2&A1&A|D1&!D&C1&C&B2&B1&B&A2&A1&A|D1&D&C1&C&B2&B1&B&A2&A1&A|!D1&D&C1&C&B2&B1&B&A2&A1&A|!D1&D&!C1&C&B2&B1&B&A2&A1&A|D1&D&!C1&C&B2&B1&B&A2&A1&A|D1&!D&!C1&C&B2&B1&B&A2&A1&A|D1&!D&!C1&C&!B2&B1&B&A2&A1&A|D1&D&!C1&C&!B2&B1&B&A2&A1&A|!D1&D&!C1&C&!B2&B1&B&A2&A1&A|!D1&D&C1&C&!B2&B1&B&A2&A1&A|D1&D&C1&C&!B2&B1&B&A2&A1&A|D1&!D&C1&C&!B2&B1&B&A2&A1&A|D1&!D&C1&!C&!B2&B1&B&A2&A1&A|D1&D&C1&!C&!B2&B1&B&A2&A1&A|!D1&D&C1&!C&!B2&B1&B&A2&A1&A|!D1&D&C1&!C&!B2&B1&!B&A2&A1&A|D1&D&C1&!C&!B2&B1&!B&A2&A1&A|D1&!D&C1&!C&!B2&B1&!B&A2&A1&A|D1&!D&C1&C&!B2&B1&!B&A2&A1&A|D1&D&C1&C&!B2&B1&!B&A2&A1&A|!D1&D&C1&C&!B2&B1&!B&A2&A1&A|!D1&D&!C1&C&!B2&B1&!B&A2&A1&A|D1&D&!C1&C&!B2&B1&!B&A2&A1&A|D1&!D&!C1&C&!B2&B1&!B&A2&A1&A|D1&!D&!C1&C&B2&B1&!B&A2&A1&A|D1&D&!C1&C&B2&B1&!B&A2&A1&A|!D1&D&!C1&C&B2&B1&!B&A2&A1&A|!D1&D&C1&C&B2&B1&!B&A2&A1&A|D1&D&C1&C&B2&B1&!B&A2&A1&A|D1&!D&C1&C&B2&B1&!B&A2&A1&A|D1&!D&C1&!C&B2&B1&!B&A2&A1&A|D1&D&C1&!C&B2&B1&!B&A2&A1&A|!D1&D&C1&!C&B2&B1&!B&A2&A1&A|!D1&D&C1&!C&B2&!B1&!B&A2&A1&A|D1&D&C1&!C&B2&!B1&!B&A2&A1&A|D1&!D&C1&!C&B2&!B1&!B&A2&A1&A|D1&!D&C1&C&B2&!B1&!B&A2&A1&A|D1&D&C1&C&B2&!B1&!B&A2&A1&A|!D1&D&C1&C&B2&!B1&!B&A2&A1&A|!D1&D&!C1&C&B2&!B1&!B&A2&A1&A|D1&D&!C1&C&B2&!B1&!B&A2&A1&A|D1&!D&!C1&C&B2&!B1&!B&A2&A1&A|D1&!D&!C1&C&B2&!B1&!B&A2&!A1&A|D1&D&!C1&C&B2&!B1&!B&A2&!A1&A|!D1&D&!C1&C&B2&!B1&!B&A2&!A1&A|!D1&D&C1&C&B2&!B1&!B&A2&!A1&A|D1&D&C1&C&B2&!B1&!B&A2&!A1&A|D1&!D&C1&C&B2&!B1&!B&A2&!A1&A|D1&!D&C1&!C&B2&!B1&!B&A2&!A1&A|D1&D&C1&!C&B2&!B1&!B&A2&!A1&A|!D1&D&C1&!C&B2&!B1&!B&A2&!A1&A|!D1&D&C1&!C&B2&B1&!B&A2&!A1&A|D1&D&C1&!C&B2&B1&!B&A2&!A1&A|D1&!D&C1&!C&B2&B1&!B&A2&!A1&A|D1&!D&C1&C&B2&B1&!B&A2&!A1&A|D1&D&C1&C&B2&B1&!B&A2&!A1&A|!D1&D&C1&C&B2&B1&!B&A2&!A1&A|!D1&D&!C1&C&B2&B1&!B&A2&!A1&A|D1&D&!C1&C&B2&B1&!B&A2&!A1&A|D1&!D&!C1&C&B2&B1&!B&A2&!A1&A|D1&!D&!C1&C&!B2&B1&!B&A2&!A1&A|D1&D&!C1&C&!B2&B1&!B&A2&!A1&A|!D1&D&!C1&C&!B2&B1&!B&A2&!A1&A|!D1&D&C1&C&!B2&B1&!B&A2&!A1&A|D1&D&C1&C&!B2&B1&!B&A2&!A1&A|D1&!D&C1&C&!B2&B1&!B&A2&!A1&A|D1&!D&C1&!C&!B2&B1&!B&A2&!A1&A|D1&D&C1&!C&!B2&B1&!B&A2&!A1&A|!D1&D&C1&!C&!B2&B1&!B&A2&!A1&A|!D1&D&C1&!C&!B2&B1&B&A2&!A1&A|D1&D&C1&!C&!B2&B1&B&A2&!A1&A|D1&!D&C1&!C&!B2&B1&B&A2&!A1&A|D1&!D&C1&C&!B2&B1&B&A2&!A1&A|D1&D&C1&C&!B2&B1&B&A2&!A1&A|!D1&D&C1&C&!B2&B1&B&A2&!A1&A|!D1&D&!C1&C&!B2&B1&B&A2&!A1&A|D1&D&!C1&C&!B2&B1&B&A2&!A1&A|D1&!D&!C1&C&!B2&B1&B&A2&!A1&A|D1&!D&!C1&C&B2&B1&B&A2&!A1&A|D1&D&!C1&C&B2&B1&B&A2&!A1&A|!D1&D&!C1&C&B2&B1&B&A2&!A1&A|!D1&D&C1&C&B2&B1&B&A2&!A1&A|D1&D&C1&C&B2&B1&B&A2&!A1&A|D1&!D&C1&C&B2&B1&B&A2&!A1&A|D1&!D&C1&!C&B2&B1&B&A2&!A1&A|D1&D&C1&!C&B2&B1&B&A2&!A1&A|!D1&D&C1&!C&B2&B1&B&A2&!A1&A|!D1&D&C1&!C&B2&!B1&B&A2&!A1&A|D1&D&C1&!C&B2&!B1&B&A2&!A1&A|D1&!D&C1&!C&B2&!B1&B&A2&!A1&A|D1&!D&C1&C&B2&!B1&B&A2&!A1&A|D1&D&C1&C&B2&!B1&B&A2&!A1&A|!D1&D&C1&C&B2&!B1&B&A2&!A1&A|!D1&D&!C1&C&B2&!B1&B&A2&!A1&A|D1&D&!C1&C&B2&!B1&B&A2&!A1&A|D1&!D&!C1&C&B2&!B1&B&A2&!A1&A|D1&!D&!C1&C&!B2&!B1&B&A2&!A1&A|D1&D&!C1&C&!B2&!B1&B&A2&!A1&A|!D1&D&!C1&C&!B2&!B1&B&A2&!A1&A|!D1&D&C1&C&!B2&!B1&B&A2&!A1&A|D1&D&C1&C&!B2&!B1&B&A2&!A1&A|D1&!D&C1&C&!B2&!B1&B&A2&!A1&A|D1&!D&C1&!C&!B2&!B1&B&A2&!A1&A|D1&D&C1&!C&!B2&!B1&B&A2&!A1&A|!D1&D&C1&!C&!B2&!B1&B&A2&!A1&A|!D1&D&C1&!C&!B2&!B1&B&!A2&!A1&A|D1&D&C1&!C&!B2&!B1&B&!A2&!A1&A|D1&!D&C1&!C&!B2&!B1&B&!A2&!A1&A|D1&!D&C1&C&!B2&!B1&B&!A2&!A1&A|D1&D&C1&C&!B2&!B1&B&!A2&!A1&A|!D1&D&C1&C&!B2&!B1&B&!A2&!A1&A|!D1&D&!C1&C&!B2&!B1&B&!A2&!A1&A|D1&D&!C1&C&!B2&!B1&B&!A2&!A1&A|D1&!D&!C1&C&!B2&!B1&B&!A2&!A1&A|D1&!D&!C1&C&B2&!B1&B&!A2&!A1&A|D1&D&!C1&C&B2&!B1&B&!A2&!A1&A|!D1&D&!C1&C&B2&!B1&B&!A2&!A1&A|!D1&D&C1&C&B2&!B1&B&!A2&!A1&A|D1&D&C1&C&B2&!B1&B&!A2&!A1&A|D1&!D&C1&C&B2&!B1&B&!A2&!A1&A|D1&!D&C1&!C&B2&!B1&B&!A2&!A1&A|D1&D&C1&!C&B2&!B1&B&!A2&!A1&A|!D1&D&C1&!C&B2&!B1&B&!A2&!A1&A|!D1&D&C1&!C&B2&B1&B&!A2&!A1&A|D1&D&C1&!C&B2&B1&B&!A2&!A1&A|D1&!D&C1&!C&B2&B1&B&!A2&!A1&A|D1&!D&C1&C&B2&B1&B&!A2&!A1&A|D1&D&C1&C&B2&B1&B&!A2&!A1&A|!D1&D&C1&C&B2&B1&B&!A2&!A1&A|!D1&D&!C1&C&B2&B1&B&!A2&!A1&A|D1&D&!C1&C&B2&B1&B&!A2&!A1&A|D1&!D&!C1&C&B2&B1&B&!A2&!A1&A|D1&!D&!C1&C&!B2&B1&B&!A2&!A1&A|D1&D&!C1&C&!B2&B1&B&!A2&!A1&A|!D1&D&!C1&C&!B2&B1&B&!A2&!A1&A|!D1&D&C1&C&!B2&B1&B&!A2&!A1&A|D1&D&C1&C&!B2&B1&B&!A2&!A1&A|D1&!D&C1&C&!B2&B1&B&!A2&!A1&A|D1&!D&C1&!C&!B2&B1&B&!A2&!A1&A|D1&D&C1&!C&!B2&B1&B&!A2&!A1&A|!D1&D&C1&!C&!B2&B1&B&!A2&!A1&A|!D1&D&C1&!C&!B2&B1&!B&!A2&!A1&A|D1&D&C1&!C&!B2&B1&!B&!A2&!A1&A|D1&!D&C1&!C&!B2&B1&!B&!A2&!A1&A|D1&!D&C1&C&!B2&B1&!B&!A2&!A1&A|D1&D&C1&C&!B2&B1&!B&!A2&!A1&A|!D1&D&C1&C&!B2&B1&!B&!A2&!A1&A|!D1&D&!C1&C&!B2&B1&!B&!A2&!A1&A|D1&D&!C1&C&!B2&B1&!B&!A2&!A1&A|D1&!D&!C1&C&!B2&B1&!B&!A2&!A1&A|D1&!D&!C1&C&B2&B1&!B&!A2&!A1&A|D1&D&!C1&C&B2&B1&!B&!A2&!A1&A|!D1&D&!C1&C&B2&B1&!B&!A2&!A1&A|!D1&D&C1&C&B2&B1&!B&!A2&!A1&A|D1&D&C1&C&B2&B1&!B&!A2&!A1&A|D1&!D&C1&C&B2&B1&!B&!A2&!A1&A|D1&!D&C1&!C&B2&B1&!B&!A2&!A1&A|D1&D&C1&!C&B2&B1&!B&!A2&!A1&A|!D1&D&C1&!C&B2&B1&!B&!A2&!A1&A|!D1&D&C1&!C&B2&!B1&!B&!A2&!A1&A|D1&D&C1&!C&B2&!B1&!B&!A2&!A1&A|D1&!D&C1&!C&B2&!B1&!B&!A2&!A1&A|D1&!D&C1&C&B2&!B1&!B&!A2&!A1&A|D1&D&C1&C&B2&!B1&!B&!A2&!A1&A|!D1&D&C1&C&B2&!B1&!B&!A2&!A1&A|!D1&D&!C1&C&B2&!B1&!B&!A2&!A1&A|D1&D&!C1&C&B2&!B1&!B&!A2&!A1&A|D1&!D&!C1&C&B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOOAI3322.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOI231 -l OAOI231 -i C B2 B1 B A1 A -o Y -f Y=(!C&!B2&!B1&!B&!A1&!A|!C&B2&!B1&!B&!A1&!A|!C&B2&B1&!B&!A1&!A|!C&!B2&B1&!B&!A1&!A|!C&!B2&B1&B&!A1&!A|!C&B2&B1&B&!A1&!A|!C&B2&!B1&B&!A1&!A|!C&!B2&!B1&B&!A1&!A|!C&!B2&!B1&B&A1&!A|!C&B2&!B1&B&A1&!A|!C&!B2&B1&B&A1&!A|!C&!B2&B1&!B&A1&!A|!C&B2&B1&!B&A1&!A|!C&B2&!B1&!B&A1&!A|!C&!B2&!B1&!B&A1&!A|!C&!B2&!B1&!B&A1&A|!C&B2&!B1&!B&A1&A|!C&B2&B1&!B&A1&A|!C&!B2&B1&!B&A1&A|!C&!B2&B1&B&A1&A|!C&B2&!B1&B&A1&A|!C&!B2&!B1&B&A1&A|!C&!B2&!B1&B&!A1&A|!C&B2&!B1&B&!A1&A|!C&!B2&B1&B&!A1&A|!C&!B2&B1&!B&!A1&A|!C&B2&B1&!B&!A1&A|!C&B2&!B1&!B&!A1&A|!C&!B2&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOI231.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOAOI211211 -l AOAAOAOI211211 -i F E D1 D C B A1 A -o Y -f Y=(!F&!E&!D1&!D&!C&!B&!A1&!A|!F&E&!D1&!D&!C&!B&!A1&!A|!F&E&D1&!D&!C&!B&!A1&!A|!F&!E&D1&!D&!C&!B&!A1&!A|!F&!E&D1&D&!C&!B&!A1&!A|!F&E&!D1&D&!C&!B&!A1&!A|!F&!E&!D1&D&!C&!B&!A1&!A|!F&!E&!D1&D&C&!B&!A1&!A|!F&E&!D1&D&C&!B&!A1&!A|!F&!E&D1&D&C&!B&!A1&!A|!F&!E&D1&!D&C&!B&!A1&!A|!F&E&D1&!D&C&!B&!A1&!A|!F&E&!D1&!D&C&!B&!A1&!A|!F&!E&!D1&!D&C&!B&!A1&!A|!F&!E&!D1&!D&C&B&!A1&!A|!F&!E&D1&!D&C&B&!A1&!A|!F&!E&D1&D&C&B&!A1&!A|!F&!E&!D1&D&C&B&!A1&!A|!F&!E&!D1&D&!C&B&!A1&!A|!F&E&!D1&D&!C&B&!A1&!A|!F&!E&D1&D&!C&B&!A1&!A|!F&!E&D1&!D&!C&B&!A1&!A|!F&E&D1&!D&!C&B&!A1&!A|!F&E&!D1&!D&!C&B&!A1&!A|!F&!E&!D1&!D&!C&B&!A1&!A|!F&!E&!D1&!D&!C&B&A1&!A|!F&E&!D1&!D&!C&B&A1&!A|!F&E&D1&!D&!C&B&A1&!A|!F&!E&D1&!D&!C&B&A1&!A|!F&!E&D1&D&!C&B&A1&!A|!F&E&!D1&D&!C&B&A1&!A|!F&!E&!D1&D&!C&B&A1&!A|!F&!E&!D1&D&C&B&A1&!A|!F&!E&D1&D&C&B&A1&!A|!F&!E&D1&!D&C&B&A1&!A|!F&!E&!D1&!D&C&B&A1&!A|!F&!E&!D1&!D&C&!B&A1&!A|!F&E&!D1&!D&C&!B&A1&!A|!F&E&D1&!D&C&!B&A1&!A|!F&!E&D1&!D&C&!B&A1&!A|!F&!E&D1&D&C&!B&A1&!A|!F&E&!D1&D&C&!B&A1&!A|!F&!E&!D1&D&C&!B&A1&!A|!F&!E&!D1&D&!C&!B&A1&!A|!F&E&!D1&D&!C&!B&A1&!A|!F&!E&D1&D&!C&!B&A1&!A|!F&!E&D1&!D&!C&!B&A1&!A|!F&E&D1&!D&!C&!B&A1&!A|!F&E&!D1&!D&!C&!B&A1&!A|!F&!E&!D1&!D&!C&!B&A1&!A|!F&!E&!D1&!D&!C&!B&A1&A|!F&E&!D1&!D&!C&!B&A1&A|!F&E&D1&!D&!C&!B&A1&A|!F&!E&D1&!D&!C&!B&A1&A|!F&!E&D1&D&!C&!B&A1&A|!F&E&!D1&D&!C&!B&A1&A|!F&!E&!D1&D&!C&!B&A1&A|!F&!E&!D1&D&C&!B&A1&A|!F&!E&D1&D&C&!B&A1&A|!F&!E&D1&!D&C&!B&A1&A|!F&!E&!D1&!D&C&!B&A1&A|!F&!E&!D1&!D&C&B&A1&A|!F&!E&D1&!D&C&B&A1&A|!F&!E&D1&D&C&B&A1&A|!F&!E&!D1&D&C&B&A1&A|!F&!E&!D1&D&!C&B&A1&A|!F&E&!D1&D&!C&B&A1&A|!F&!E&D1&D&!C&B&A1&A|!F&!E&D1&!D&!C&B&A1&A|!F&E&D1&!D&!C&B&A1&A|!F&E&!D1&!D&!C&B&A1&A|!F&!E&!D1&!D&!C&B&A1&A|!F&!E&!D1&!D&!C&B&!A1&A|!F&E&!D1&!D&!C&B&!A1&A|!F&E&D1&!D&!C&B&!A1&A|!F&!E&D1&!D&!C&B&!A1&A|!F&!E&D1&D&!C&B&!A1&A|!F&E&!D1&D&!C&B&!A1&A|!F&!E&!D1&D&!C&B&!A1&A|!F&!E&!D1&D&C&B&!A1&A|!F&!E&D1&D&C&B&!A1&A|!F&!E&D1&!D&C&B&!A1&A|!F&!E&!D1&!D&C&B&!A1&A|!F&!E&!D1&!D&C&!B&!A1&A|!F&E&!D1&!D&C&!B&!A1&A|!F&E&D1&!D&C&!B&!A1&A|!F&!E&D1&!D&C&!B&!A1&A|!F&!E&D1&D&C&!B&!A1&A|!F&E&!D1&D&C&!B&!A1&A|!F&!E&!D1&D&C&!B&!A1&A|!F&!E&!D1&D&!C&!B&!A1&A|!F&E&!D1&D&!C&!B&!A1&A|!F&!E&D1&D&!C&!B&!A1&A|!F&!E&D1&!D&!C&!B&!A1&A|!F&E&D1&!D&!C&!B&!A1&A|!F&E&!D1&!D&!C&!B&!A1&A|!F&!E&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOAOI211211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOI321 -l OAOI321 -i C B1 B A2 A1 A -o Y -f Y=(!C&!B1&!B&!A2&!A1&!A|!C&B1&!B&!A2&!A1&!A|!C&B1&B&!A2&!A1&!A|!C&!B1&B&!A2&!A1&!A|!C&!B1&B&A2&!A1&!A|!C&B1&!B&A2&!A1&!A|!C&!B1&!B&A2&!A1&!A|!C&!B1&!B&A2&A1&!A|!C&B1&!B&A2&A1&!A|!C&!B1&B&A2&A1&!A|!C&!B1&B&!A2&A1&!A|!C&B1&!B&!A2&A1&!A|!C&!B1&!B&!A2&A1&!A|!C&!B1&!B&!A2&A1&A|!C&B1&!B&!A2&A1&A|!C&!B1&B&!A2&A1&A|!C&!B1&B&A2&A1&A|!C&B1&!B&A2&A1&A|!C&!B1&!B&A2&A1&A|!C&!B1&!B&A2&!A1&A|!C&B1&!B&A2&!A1&A|!C&!B1&B&A2&!A1&A|!C&!B1&B&!A2&!A1&A|!C&B1&!B&!A2&!A1&A|!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOI321.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOAOAI221111 -l OOAOAOAI221111 -i F E D C B1 B A1 A -o Y -f Y=!(F&E&!D&!C&!B1&!B&!A1&!A|F&E&D&!C&!B1&!B&!A1&!A|F&!E&D&C&!B1&!B&!A1&!A|F&E&D&C&!B1&!B&!A1&!A|F&E&!D&C&!B1&!B&!A1&!A|F&E&!D&C&B1&!B&!A1&!A|F&E&D&C&B1&!B&!A1&!A|F&!E&D&C&B1&!B&!A1&!A|F&E&D&!C&B1&!B&!A1&!A|F&E&!D&!C&B1&!B&!A1&!A|F&E&!D&!C&B1&B&!A1&!A|F&E&D&!C&B1&B&!A1&!A|F&!E&D&C&B1&B&!A1&!A|F&E&D&C&B1&B&!A1&!A|F&E&!D&C&B1&B&!A1&!A|F&E&!D&C&!B1&B&!A1&!A|F&E&D&C&!B1&B&!A1&!A|F&!E&D&C&!B1&B&!A1&!A|F&E&D&!C&!B1&B&!A1&!A|F&E&!D&!C&!B1&B&!A1&!A|F&E&!D&!C&!B1&B&A1&!A|F&E&D&!C&!B1&B&A1&!A|F&!E&D&!C&!B1&B&A1&!A|F&!E&D&C&!B1&B&A1&!A|F&E&D&C&!B1&B&A1&!A|F&E&!D&C&!B1&B&A1&!A|F&E&!D&C&B1&B&A1&!A|F&E&D&C&B1&B&A1&!A|F&!E&D&C&B1&B&A1&!A|F&!E&D&!C&B1&B&A1&!A|F&E&D&!C&B1&B&A1&!A|F&E&!D&!C&B1&B&A1&!A|F&E&!D&!C&B1&!B&A1&!A|F&E&D&!C&B1&!B&A1&!A|F&!E&D&!C&B1&!B&A1&!A|F&!E&D&C&B1&!B&A1&!A|F&E&D&C&B1&!B&A1&!A|F&E&!D&C&B1&!B&A1&!A|F&E&!D&C&!B1&!B&A1&!A|F&E&D&C&!B1&!B&A1&!A|F&!E&D&C&!B1&!B&A1&!A|F&E&D&!C&!B1&!B&A1&!A|F&E&!D&!C&!B1&!B&A1&!A|F&E&!D&!C&!B1&!B&A1&A|F&E&D&!C&!B1&!B&A1&A|F&!E&D&C&!B1&!B&A1&A|F&E&D&C&!B1&!B&A1&A|F&E&!D&C&!B1&!B&A1&A|F&E&!D&C&B1&!B&A1&A|F&E&D&C&B1&!B&A1&A|F&!E&D&C&B1&!B&A1&A|F&!E&D&!C&B1&!B&A1&A|F&E&D&!C&B1&!B&A1&A|F&E&!D&!C&B1&!B&A1&A|F&E&!D&!C&B1&B&A1&A|F&E&D&!C&B1&B&A1&A|F&!E&D&!C&B1&B&A1&A|F&!E&D&C&B1&B&A1&A|F&E&D&C&B1&B&A1&A|F&E&!D&C&B1&B&A1&A|F&E&!D&C&!B1&B&A1&A|F&E&D&C&!B1&B&A1&A|F&!E&D&C&!B1&B&A1&A|F&!E&D&!C&!B1&B&A1&A|F&E&D&!C&!B1&B&A1&A|F&E&!D&!C&!B1&B&A1&A|F&E&!D&!C&!B1&B&!A1&A|F&E&D&!C&!B1&B&!A1&A|F&!E&D&!C&!B1&B&!A1&A|F&!E&D&C&!B1&B&!A1&A|F&E&D&C&!B1&B&!A1&A|F&E&!D&C&!B1&B&!A1&A|F&E&!D&C&B1&B&!A1&A|F&E&D&C&B1&B&!A1&A|F&!E&D&C&B1&B&!A1&A|F&!E&D&!C&B1&B&!A1&A|F&E&D&!C&B1&B&!A1&A|F&E&!D&!C&B1&B&!A1&A|F&E&!D&!C&B1&!B&!A1&A|F&E&D&!C&B1&!B&!A1&A|F&!E&D&!C&B1&!B&!A1&A|F&!E&D&C&B1&!B&!A1&A|F&E&D&C&B1&!B&!A1&A|F&E&!D&C&B1&!B&!A1&A|F&E&!D&C&!B1&!B&!A1&A|F&E&D&C&!B1&!B&!A1&A|F&!E&D&C&!B1&!B&!A1&A|F&E&D&!C&!B1&!B&!A1&A|F&E&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOAOAI221111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAI42 -l OAI42 -i B1 B A3 A2 A1 A -o Y -f Y=!(B1&B&A3&!A2&!A1&!A|B1&B&A3&A2&!A1&!A|B1&B&!A3&A2&!A1&!A|B1&B&!A3&A2&A1&!A|B1&B&A3&A2&A1&!A|B1&B&A3&!A2&A1&!A|B1&B&!A3&!A2&A1&!A|B1&B&!A3&!A2&A1&A|B1&B&A3&!A2&A1&A|B1&B&A3&A2&A1&A|B1&B&!A3&A2&A1&A|B1&B&!A3&A2&!A1&A|B1&B&A3&A2&!A1&A|B1&B&A3&!A2&!A1&A|B1&B&!A3&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAI42.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOAI2221 -l OOAAOAI2221 -i D C1 C B1 B A1 A -o Y -f Y=!(D&C1&C&!B1&!B&!A1&!A|D&C1&C&B1&!B&!A1&!A|D&C1&C&B1&B&!A1&!A|D&C1&C&!B1&B&!A1&!A|D&!C1&!C&!B1&B&A1&!A|D&C1&!C&!B1&B&A1&!A|D&C1&C&!B1&B&A1&!A|D&!C1&C&!B1&B&A1&!A|D&!C1&C&B1&B&A1&!A|D&C1&C&B1&B&A1&!A|D&C1&!C&B1&B&A1&!A|D&!C1&!C&B1&B&A1&!A|D&!C1&!C&B1&!B&A1&!A|D&C1&!C&B1&!B&A1&!A|D&C1&C&B1&!B&A1&!A|D&!C1&C&B1&!B&A1&!A|D&C1&C&!B1&!B&A1&!A|D&C1&C&!B1&!B&A1&A|D&!C1&C&B1&!B&A1&A|D&C1&C&B1&!B&A1&A|D&C1&!C&B1&!B&A1&A|D&!C1&!C&B1&!B&A1&A|D&!C1&!C&B1&B&A1&A|D&C1&!C&B1&B&A1&A|D&C1&C&B1&B&A1&A|D&!C1&C&B1&B&A1&A|D&!C1&C&!B1&B&A1&A|D&C1&C&!B1&B&A1&A|D&C1&!C&!B1&B&A1&A|D&!C1&!C&!B1&B&A1&A|D&!C1&!C&!B1&B&!A1&A|D&C1&!C&!B1&B&!A1&A|D&C1&C&!B1&B&!A1&A|D&!C1&C&!B1&B&!A1&A|D&!C1&C&B1&B&!A1&A|D&C1&C&B1&B&!A1&A|D&C1&!C&B1&B&!A1&A|D&!C1&!C&B1&B&!A1&A|D&!C1&!C&B1&!B&!A1&A|D&C1&!C&B1&!B&!A1&A|D&C1&C&B1&!B&!A1&A|D&!C1&C&B1&!B&!A1&A|D&C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOAI2221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOI332 -l AAOI332 -i C1 C B2 B1 B A2 A1 A -o Y -f Y=(!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!C1&!C&B2&!B1&!B&!A2&!A1&!A|!C1&!C&B2&B1&!B&!A2&!A1&!A|!C1&!C&!B2&B1&!B&!A2&!A1&!A|!C1&!C&!B2&B1&B&!A2&!A1&!A|!C1&!C&B2&!B1&B&!A2&!A1&!A|!C1&!C&!B2&!B1&B&!A2&!A1&!A|!C1&!C&!B2&!B1&B&A2&!A1&!A|!C1&!C&B2&!B1&B&A2&!A1&!A|!C1&!C&!B2&B1&B&A2&!A1&!A|!C1&!C&!B2&B1&!B&A2&!A1&!A|!C1&!C&B2&B1&!B&A2&!A1&!A|!C1&!C&B2&!B1&!B&A2&!A1&!A|!C1&!C&!B2&!B1&!B&A2&!A1&!A|!C1&!C&!B2&!B1&!B&A2&A1&!A|!C1&!C&B2&!B1&!B&A2&A1&!A|!C1&!C&B2&B1&!B&A2&A1&!A|!C1&!C&!B2&B1&!B&A2&A1&!A|!C1&!C&!B2&B1&B&A2&A1&!A|!C1&!C&B2&!B1&B&A2&A1&!A|!C1&!C&!B2&!B1&B&A2&A1&!A|!C1&!C&!B2&!B1&B&!A2&A1&!A|!C1&!C&B2&!B1&B&!A2&A1&!A|!C1&!C&!B2&B1&B&!A2&A1&!A|!C1&!C&!B2&B1&!B&!A2&A1&!A|!C1&!C&B2&B1&!B&!A2&A1&!A|!C1&!C&B2&!B1&!B&!A2&A1&!A|!C1&!C&!B2&!B1&!B&!A2&A1&!A|!C1&!C&!B2&!B1&!B&!A2&A1&A|!C1&!C&B2&!B1&!B&!A2&A1&A|!C1&!C&B2&B1&!B&!A2&A1&A|!C1&!C&!B2&B1&!B&!A2&A1&A|!C1&!C&!B2&B1&B&!A2&A1&A|!C1&!C&B2&!B1&B&!A2&A1&A|!C1&!C&!B2&!B1&B&!A2&A1&A|!C1&!C&!B2&!B1&!B&A2&!A1&A|!C1&!C&B2&!B1&!B&A2&!A1&A|!C1&!C&B2&B1&!B&A2&!A1&A|!C1&!C&!B2&B1&!B&A2&!A1&A|!C1&!C&!B2&B1&B&A2&!A1&A|!C1&!C&B2&!B1&B&A2&!A1&A|!C1&!C&!B2&!B1&B&A2&!A1&A|!C1&!C&!B2&!B1&B&!A2&!A1&A|!C1&!C&B2&!B1&B&!A2&!A1&A|!C1&!C&!B2&B1&B&!A2&!A1&A|!C1&!C&!B2&B1&!B&!A2&!A1&A|!C1&!C&B2&B1&!B&!A2&!A1&A|!C1&!C&B2&!B1&!B&!A2&!A1&A|!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOI332.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAAOAI222211 -l OOOAAOAI222211 -i F E D1 D C1 C B1 B A1 A -o Y -f Y=!(F&E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|F&E&D1&!D&!C1&!C&!B1&!B&!A1&!A|F&!E&D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&!D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&!D1&D&C1&!C&!B1&!B&!A1&!A|F&E&D1&D&C1&!C&!B1&!B&!A1&!A|F&!E&D1&D&C1&!C&!B1&!B&!A1&!A|F&E&D1&!D&C1&!C&!B1&!B&!A1&!A|F&E&!D1&!D&C1&!C&!B1&!B&!A1&!A|F&E&!D1&!D&C1&C&!B1&!B&!A1&!A|F&E&D1&!D&C1&C&!B1&!B&!A1&!A|F&!E&D1&D&C1&C&!B1&!B&!A1&!A|F&E&D1&D&C1&C&!B1&!B&!A1&!A|F&E&!D1&D&C1&C&!B1&!B&!A1&!A|F&E&!D1&D&!C1&C&!B1&!B&!A1&!A|F&E&D1&D&!C1&C&!B1&!B&!A1&!A|F&!E&D1&D&!C1&C&!B1&!B&!A1&!A|F&E&D1&!D&!C1&C&!B1&!B&!A1&!A|F&E&!D1&!D&!C1&C&!B1&!B&!A1&!A|F&E&!D1&!D&!C1&C&B1&!B&!A1&!A|F&E&D1&!D&!C1&C&B1&!B&!A1&!A|F&!E&D1&D&!C1&C&B1&!B&!A1&!A|F&E&D1&D&!C1&C&B1&!B&!A1&!A|F&E&!D1&D&!C1&C&B1&!B&!A1&!A|F&E&!D1&D&C1&C&B1&!B&!A1&!A|F&E&D1&D&C1&C&B1&!B&!A1&!A|F&!E&D1&D&C1&C&B1&!B&!A1&!A|F&E&D1&!D&C1&C&B1&!B&!A1&!A|F&E&!D1&!D&C1&C&B1&!B&!A1&!A|F&E&!D1&!D&C1&!C&B1&!B&!A1&!A|F&E&D1&!D&C1&!C&B1&!B&!A1&!A|F&!E&D1&D&C1&!C&B1&!B&!A1&!A|F&E&D1&D&C1&!C&B1&!B&!A1&!A|F&E&!D1&D&C1&!C&B1&!B&!A1&!A|F&E&!D1&D&!C1&!C&B1&!B&!A1&!A|F&E&D1&D&!C1&!C&B1&!B&!A1&!A|F&!E&D1&D&!C1&!C&B1&!B&!A1&!A|F&E&D1&!D&!C1&!C&B1&!B&!A1&!A|F&E&!D1&!D&!C1&!C&B1&!B&!A1&!A|F&E&!D1&!D&!C1&!C&B1&B&!A1&!A|F&E&D1&!D&!C1&!C&B1&B&!A1&!A|F&!E&D1&D&!C1&!C&B1&B&!A1&!A|F&E&D1&D&!C1&!C&B1&B&!A1&!A|F&E&!D1&D&!C1&!C&B1&B&!A1&!A|F&E&!D1&D&C1&!C&B1&B&!A1&!A|F&E&D1&D&C1&!C&B1&B&!A1&!A|F&!E&D1&D&C1&!C&B1&B&!A1&!A|F&E&D1&!D&C1&!C&B1&B&!A1&!A|F&E&!D1&!D&C1&!C&B1&B&!A1&!A|F&E&!D1&!D&C1&C&B1&B&!A1&!A|F&E&D1&!D&C1&C&B1&B&!A1&!A|F&!E&D1&D&C1&C&B1&B&!A1&!A|F&E&D1&D&C1&C&B1&B&!A1&!A|F&E&!D1&D&C1&C&B1&B&!A1&!A|F&E&!D1&D&!C1&C&B1&B&!A1&!A|F&E&D1&D&!C1&C&B1&B&!A1&!A|F&!E&D1&D&!C1&C&B1&B&!A1&!A|F&E&D1&!D&!C1&C&B1&B&!A1&!A|F&E&!D1&!D&!C1&C&B1&B&!A1&!A|F&E&!D1&!D&!C1&C&!B1&B&!A1&!A|F&E&D1&!D&!C1&C&!B1&B&!A1&!A|F&!E&D1&D&!C1&C&!B1&B&!A1&!A|F&E&D1&D&!C1&C&!B1&B&!A1&!A|F&E&!D1&D&!C1&C&!B1&B&!A1&!A|F&E&!D1&D&C1&C&!B1&B&!A1&!A|F&E&D1&D&C1&C&!B1&B&!A1&!A|F&!E&D1&D&C1&C&!B1&B&!A1&!A|F&E&D1&!D&C1&C&!B1&B&!A1&!A|F&E&!D1&!D&C1&C&!B1&B&!A1&!A|F&E&!D1&!D&C1&!C&!B1&B&!A1&!A|F&E&D1&!D&C1&!C&!B1&B&!A1&!A|F&!E&D1&D&C1&!C&!B1&B&!A1&!A|F&E&D1&D&C1&!C&!B1&B&!A1&!A|F&E&!D1&D&C1&!C&!B1&B&!A1&!A|F&E&!D1&D&!C1&!C&!B1&B&!A1&!A|F&E&D1&D&!C1&!C&!B1&B&!A1&!A|F&!E&D1&D&!C1&!C&!B1&B&!A1&!A|F&E&D1&!D&!C1&!C&!B1&B&!A1&!A|F&E&!D1&!D&!C1&!C&!B1&B&!A1&!A|F&E&!D1&!D&!C1&!C&!B1&B&A1&!A|F&E&D1&!D&!C1&!C&!B1&B&A1&!A|F&!E&D1&D&!C1&!C&!B1&B&A1&!A|F&E&D1&D&!C1&!C&!B1&B&A1&!A|F&E&!D1&D&!C1&!C&!B1&B&A1&!A|F&!E&!D1&D&C1&!C&!B1&B&A1&!A|F&E&!D1&D&C1&!C&!B1&B&A1&!A|F&E&D1&D&C1&!C&!B1&B&A1&!A|F&!E&D1&D&C1&!C&!B1&B&A1&!A|F&!E&D1&!D&C1&!C&!B1&B&A1&!A|F&E&D1&!D&C1&!C&!B1&B&A1&!A|F&E&!D1&!D&C1&!C&!B1&B&A1&!A|F&!E&!D1&!D&C1&!C&!B1&B&A1&!A|F&!E&!D1&!D&C1&C&!B1&B&A1&!A|F&E&!D1&!D&C1&C&!B1&B&A1&!A|F&E&D1&!D&C1&C&!B1&B&A1&!A|F&!E&D1&!D&C1&C&!B1&B&A1&!A|F&!E&D1&D&C1&C&!B1&B&A1&!A|F&E&D1&D&C1&C&!B1&B&A1&!A|F&E&!D1&D&C1&C&!B1&B&A1&!A|F&!E&!D1&D&C1&C&!B1&B&A1&!A|F&!E&!D1&D&!C1&C&!B1&B&A1&!A|F&E&!D1&D&!C1&C&!B1&B&A1&!A|F&E&D1&D&!C1&C&!B1&B&A1&!A|F&!E&D1&D&!C1&C&!B1&B&A1&!A|F&!E&D1&!D&!C1&C&!B1&B&A1&!A|F&E&D1&!D&!C1&C&!B1&B&A1&!A|F&E&!D1&!D&!C1&C&!B1&B&A1&!A|F&!E&!D1&!D&!C1&C&!B1&B&A1&!A|F&!E&!D1&!D&!C1&C&B1&B&A1&!A|F&E&!D1&!D&!C1&C&B1&B&A1&!A|F&E&D1&!D&!C1&C&B1&B&A1&!A|F&!E&D1&!D&!C1&C&B1&B&A1&!A|F&!E&D1&D&!C1&C&B1&B&A1&!A|F&E&D1&D&!C1&C&B1&B&A1&!A|F&E&!D1&D&!C1&C&B1&B&A1&!A|F&!E&!D1&D&!C1&C&B1&B&A1&!A|F&!E&!D1&D&C1&C&B1&B&A1&!A|F&E&!D1&D&C1&C&B1&B&A1&!A|F&E&D1&D&C1&C&B1&B&A1&!A|F&!E&D1&D&C1&C&B1&B&A1&!A|F&!E&D1&!D&C1&C&B1&B&A1&!A|F&E&D1&!D&C1&C&B1&B&A1&!A|F&E&!D1&!D&C1&C&B1&B&A1&!A|F&!E&!D1&!D&C1&C&B1&B&A1&!A|F&!E&!D1&!D&C1&!C&B1&B&A1&!A|F&E&!D1&!D&C1&!C&B1&B&A1&!A|F&E&D1&!D&C1&!C&B1&B&A1&!A|F&!E&D1&!D&C1&!C&B1&B&A1&!A|F&!E&D1&D&C1&!C&B1&B&A1&!A|F&E&D1&D&C1&!C&B1&B&A1&!A|F&E&!D1&D&C1&!C&B1&B&A1&!A|F&!E&!D1&D&C1&!C&B1&B&A1&!A|F&E&!D1&D&!C1&!C&B1&B&A1&!A|F&E&D1&D&!C1&!C&B1&B&A1&!A|F&!E&D1&D&!C1&!C&B1&B&A1&!A|F&E&D1&!D&!C1&!C&B1&B&A1&!A|F&E&!D1&!D&!C1&!C&B1&B&A1&!A|F&E&!D1&!D&!C1&!C&B1&!B&A1&!A|F&E&D1&!D&!C1&!C&B1&!B&A1&!A|F&!E&D1&D&!C1&!C&B1&!B&A1&!A|F&E&D1&D&!C1&!C&B1&!B&A1&!A|F&E&!D1&D&!C1&!C&B1&!B&A1&!A|F&!E&!D1&D&C1&!C&B1&!B&A1&!A|F&E&!D1&D&C1&!C&B1&!B&A1&!A|F&E&D1&D&C1&!C&B1&!B&A1&!A|F&!E&D1&D&C1&!C&B1&!B&A1&!A|F&!E&D1&!D&C1&!C&B1&!B&A1&!A|F&E&D1&!D&C1&!C&B1&!B&A1&!A|F&E&!D1&!D&C1&!C&B1&!B&A1&!A|F&!E&!D1&!D&C1&!C&B1&!B&A1&!A|F&!E&!D1&!D&C1&C&B1&!B&A1&!A|F&E&!D1&!D&C1&C&B1&!B&A1&!A|F&E&D1&!D&C1&C&B1&!B&A1&!A|F&!E&D1&!D&C1&C&B1&!B&A1&!A|F&!E&D1&D&C1&C&B1&!B&A1&!A|F&E&D1&D&C1&C&B1&!B&A1&!A|F&E&!D1&D&C1&C&B1&!B&A1&!A|F&!E&!D1&D&C1&C&B1&!B&A1&!A|F&!E&!D1&D&!C1&C&B1&!B&A1&!A|F&E&!D1&D&!C1&C&B1&!B&A1&!A|F&E&D1&D&!C1&C&B1&!B&A1&!A|F&!E&D1&D&!C1&C&B1&!B&A1&!A|F&!E&D1&!D&!C1&C&B1&!B&A1&!A|F&E&D1&!D&!C1&C&B1&!B&A1&!A|F&E&!D1&!D&!C1&C&B1&!B&A1&!A|F&!E&!D1&!D&!C1&C&B1&!B&A1&!A|F&E&!D1&!D&!C1&C&!B1&!B&A1&!A|F&E&D1&!D&!C1&C&!B1&!B&A1&!A|F&!E&D1&D&!C1&C&!B1&!B&A1&!A|F&E&D1&D&!C1&C&!B1&!B&A1&!A|F&E&!D1&D&!C1&C&!B1&!B&A1&!A|F&E&!D1&D&C1&C&!B1&!B&A1&!A|F&E&D1&D&C1&C&!B1&!B&A1&!A|F&!E&D1&D&C1&C&!B1&!B&A1&!A|F&E&D1&!D&C1&C&!B1&!B&A1&!A|F&E&!D1&!D&C1&C&!B1&!B&A1&!A|F&E&!D1&!D&C1&!C&!B1&!B&A1&!A|F&E&D1&!D&C1&!C&!B1&!B&A1&!A|F&!E&D1&D&C1&!C&!B1&!B&A1&!A|F&E&D1&D&C1&!C&!B1&!B&A1&!A|F&E&!D1&D&C1&!C&!B1&!B&A1&!A|F&E&!D1&D&!C1&!C&!B1&!B&A1&!A|F&E&D1&D&!C1&!C&!B1&!B&A1&!A|F&!E&D1&D&!C1&!C&!B1&!B&A1&!A|F&E&D1&!D&!C1&!C&!B1&!B&A1&!A|F&E&!D1&!D&!C1&!C&!B1&!B&A1&!A|F&E&!D1&!D&!C1&!C&!B1&!B&A1&A|F&E&D1&!D&!C1&!C&!B1&!B&A1&A|F&!E&D1&D&!C1&!C&!B1&!B&A1&A|F&E&D1&D&!C1&!C&!B1&!B&A1&A|F&E&!D1&D&!C1&!C&!B1&!B&A1&A|F&E&!D1&D&C1&!C&!B1&!B&A1&A|F&E&D1&D&C1&!C&!B1&!B&A1&A|F&!E&D1&D&C1&!C&!B1&!B&A1&A|F&E&D1&!D&C1&!C&!B1&!B&A1&A|F&E&!D1&!D&C1&!C&!B1&!B&A1&A|F&E&!D1&!D&C1&C&!B1&!B&A1&A|F&E&D1&!D&C1&C&!B1&!B&A1&A|F&!E&D1&D&C1&C&!B1&!B&A1&A|F&E&D1&D&C1&C&!B1&!B&A1&A|F&E&!D1&D&C1&C&!B1&!B&A1&A|F&E&!D1&D&!C1&C&!B1&!B&A1&A|F&E&D1&D&!C1&C&!B1&!B&A1&A|F&!E&D1&D&!C1&C&!B1&!B&A1&A|F&E&D1&!D&!C1&C&!B1&!B&A1&A|F&E&!D1&!D&!C1&C&!B1&!B&A1&A|F&!E&!D1&!D&!C1&C&B1&!B&A1&A|F&E&!D1&!D&!C1&C&B1&!B&A1&A|F&E&D1&!D&!C1&C&B1&!B&A1&A|F&!E&D1&!D&!C1&C&B1&!B&A1&A|F&!E&D1&D&!C1&C&B1&!B&A1&A|F&E&D1&D&!C1&C&B1&!B&A1&A|F&E&!D1&D&!C1&C&B1&!B&A1&A|F&!E&!D1&D&!C1&C&B1&!B&A1&A|F&!E&!D1&D&C1&C&B1&!B&A1&A|F&E&!D1&D&C1&C&B1&!B&A1&A|F&E&D1&D&C1&C&B1&!B&A1&A|F&!E&D1&D&C1&C&B1&!B&A1&A|F&!E&D1&!D&C1&C&B1&!B&A1&A|F&E&D1&!D&C1&C&B1&!B&A1&A|F&E&!D1&!D&C1&C&B1&!B&A1&A|F&!E&!D1&!D&C1&C&B1&!B&A1&A|F&!E&!D1&!D&C1&!C&B1&!B&A1&A|F&E&!D1&!D&C1&!C&B1&!B&A1&A|F&E&D1&!D&C1&!C&B1&!B&A1&A|F&!E&D1&!D&C1&!C&B1&!B&A1&A|F&!E&D1&D&C1&!C&B1&!B&A1&A|F&E&D1&D&C1&!C&B1&!B&A1&A|F&E&!D1&D&C1&!C&B1&!B&A1&A|F&!E&!D1&D&C1&!C&B1&!B&A1&A|F&E&!D1&D&!C1&!C&B1&!B&A1&A|F&E&D1&D&!C1&!C&B1&!B&A1&A|F&!E&D1&D&!C1&!C&B1&!B&A1&A|F&E&D1&!D&!C1&!C&B1&!B&A1&A|F&E&!D1&!D&!C1&!C&B1&!B&A1&A|F&E&!D1&!D&!C1&!C&B1&B&A1&A|F&E&D1&!D&!C1&!C&B1&B&A1&A|F&!E&D1&D&!C1&!C&B1&B&A1&A|F&E&D1&D&!C1&!C&B1&B&A1&A|F&E&!D1&D&!C1&!C&B1&B&A1&A|F&!E&!D1&D&C1&!C&B1&B&A1&A|F&E&!D1&D&C1&!C&B1&B&A1&A|F&E&D1&D&C1&!C&B1&B&A1&A|F&!E&D1&D&C1&!C&B1&B&A1&A|F&!E&D1&!D&C1&!C&B1&B&A1&A|F&E&D1&!D&C1&!C&B1&B&A1&A|F&E&!D1&!D&C1&!C&B1&B&A1&A|F&!E&!D1&!D&C1&!C&B1&B&A1&A|F&!E&!D1&!D&C1&C&B1&B&A1&A|F&E&!D1&!D&C1&C&B1&B&A1&A|F&E&D1&!D&C1&C&B1&B&A1&A|F&!E&D1&!D&C1&C&B1&B&A1&A|F&!E&D1&D&C1&C&B1&B&A1&A|F&E&D1&D&C1&C&B1&B&A1&A|F&E&!D1&D&C1&C&B1&B&A1&A|F&!E&!D1&D&C1&C&B1&B&A1&A|F&!E&!D1&D&!C1&C&B1&B&A1&A|F&E&!D1&D&!C1&C&B1&B&A1&A|F&E&D1&D&!C1&C&B1&B&A1&A|F&!E&D1&D&!C1&C&B1&B&A1&A|F&!E&D1&!D&!C1&C&B1&B&A1&A|F&E&D1&!D&!C1&C&B1&B&A1&A|F&E&!D1&!D&!C1&C&B1&B&A1&A|F&!E&!D1&!D&!C1&C&B1&B&A1&A|F&!E&!D1&!D&!C1&C&!B1&B&A1&A|F&E&!D1&!D&!C1&C&!B1&B&A1&A|F&E&D1&!D&!C1&C&!B1&B&A1&A|F&!E&D1&!D&!C1&C&!B1&B&A1&A|F&!E&D1&D&!C1&C&!B1&B&A1&A|F&E&D1&D&!C1&C&!B1&B&A1&A|F&E&!D1&D&!C1&C&!B1&B&A1&A|F&!E&!D1&D&!C1&C&!B1&B&A1&A|F&!E&!D1&D&C1&C&!B1&B&A1&A|F&E&!D1&D&C1&C&!B1&B&A1&A|F&E&D1&D&C1&C&!B1&B&A1&A|F&!E&D1&D&C1&C&!B1&B&A1&A|F&!E&D1&!D&C1&C&!B1&B&A1&A|F&E&D1&!D&C1&C&!B1&B&A1&A|F&E&!D1&!D&C1&C&!B1&B&A1&A|F&!E&!D1&!D&C1&C&!B1&B&A1&A|F&!E&!D1&!D&C1&!C&!B1&B&A1&A|F&E&!D1&!D&C1&!C&!B1&B&A1&A|F&E&D1&!D&C1&!C&!B1&B&A1&A|F&!E&D1&!D&C1&!C&!B1&B&A1&A|F&!E&D1&D&C1&!C&!B1&B&A1&A|F&E&D1&D&C1&!C&!B1&B&A1&A|F&E&!D1&D&C1&!C&!B1&B&A1&A|F&!E&!D1&D&C1&!C&!B1&B&A1&A|F&E&!D1&D&!C1&!C&!B1&B&A1&A|F&E&D1&D&!C1&!C&!B1&B&A1&A|F&!E&D1&D&!C1&!C&!B1&B&A1&A|F&E&D1&!D&!C1&!C&!B1&B&A1&A|F&E&!D1&!D&!C1&!C&!B1&B&A1&A|F&E&!D1&!D&!C1&!C&!B1&B&!A1&A|F&E&D1&!D&!C1&!C&!B1&B&!A1&A|F&!E&D1&D&!C1&!C&!B1&B&!A1&A|F&E&D1&D&!C1&!C&!B1&B&!A1&A|F&E&!D1&D&!C1&!C&!B1&B&!A1&A|F&!E&!D1&D&C1&!C&!B1&B&!A1&A|F&E&!D1&D&C1&!C&!B1&B&!A1&A|F&E&D1&D&C1&!C&!B1&B&!A1&A|F&!E&D1&D&C1&!C&!B1&B&!A1&A|F&!E&D1&!D&C1&!C&!B1&B&!A1&A|F&E&D1&!D&C1&!C&!B1&B&!A1&A|F&E&!D1&!D&C1&!C&!B1&B&!A1&A|F&!E&!D1&!D&C1&!C&!B1&B&!A1&A|F&!E&!D1&!D&C1&C&!B1&B&!A1&A|F&E&!D1&!D&C1&C&!B1&B&!A1&A|F&E&D1&!D&C1&C&!B1&B&!A1&A|F&!E&D1&!D&C1&C&!B1&B&!A1&A|F&!E&D1&D&C1&C&!B1&B&!A1&A|F&E&D1&D&C1&C&!B1&B&!A1&A|F&E&!D1&D&C1&C&!B1&B&!A1&A|F&!E&!D1&D&C1&C&!B1&B&!A1&A|F&!E&!D1&D&!C1&C&!B1&B&!A1&A|F&E&!D1&D&!C1&C&!B1&B&!A1&A|F&E&D1&D&!C1&C&!B1&B&!A1&A|F&!E&D1&D&!C1&C&!B1&B&!A1&A|F&!E&D1&!D&!C1&C&!B1&B&!A1&A|F&E&D1&!D&!C1&C&!B1&B&!A1&A|F&E&!D1&!D&!C1&C&!B1&B&!A1&A|F&!E&!D1&!D&!C1&C&!B1&B&!A1&A|F&!E&!D1&!D&!C1&C&B1&B&!A1&A|F&E&!D1&!D&!C1&C&B1&B&!A1&A|F&E&D1&!D&!C1&C&B1&B&!A1&A|F&!E&D1&!D&!C1&C&B1&B&!A1&A|F&!E&D1&D&!C1&C&B1&B&!A1&A|F&E&D1&D&!C1&C&B1&B&!A1&A|F&E&!D1&D&!C1&C&B1&B&!A1&A|F&!E&!D1&D&!C1&C&B1&B&!A1&A|F&!E&!D1&D&C1&C&B1&B&!A1&A|F&E&!D1&D&C1&C&B1&B&!A1&A|F&E&D1&D&C1&C&B1&B&!A1&A|F&!E&D1&D&C1&C&B1&B&!A1&A|F&!E&D1&!D&C1&C&B1&B&!A1&A|F&E&D1&!D&C1&C&B1&B&!A1&A|F&E&!D1&!D&C1&C&B1&B&!A1&A|F&!E&!D1&!D&C1&C&B1&B&!A1&A|F&!E&!D1&!D&C1&!C&B1&B&!A1&A|F&E&!D1&!D&C1&!C&B1&B&!A1&A|F&E&D1&!D&C1&!C&B1&B&!A1&A|F&!E&D1&!D&C1&!C&B1&B&!A1&A|F&!E&D1&D&C1&!C&B1&B&!A1&A|F&E&D1&D&C1&!C&B1&B&!A1&A|F&E&!D1&D&C1&!C&B1&B&!A1&A|F&!E&!D1&D&C1&!C&B1&B&!A1&A|F&E&!D1&D&!C1&!C&B1&B&!A1&A|F&E&D1&D&!C1&!C&B1&B&!A1&A|F&!E&D1&D&!C1&!C&B1&B&!A1&A|F&E&D1&!D&!C1&!C&B1&B&!A1&A|F&E&!D1&!D&!C1&!C&B1&B&!A1&A|F&E&!D1&!D&!C1&!C&B1&!B&!A1&A|F&E&D1&!D&!C1&!C&B1&!B&!A1&A|F&!E&D1&D&!C1&!C&B1&!B&!A1&A|F&E&D1&D&!C1&!C&B1&!B&!A1&A|F&E&!D1&D&!C1&!C&B1&!B&!A1&A|F&!E&!D1&D&C1&!C&B1&!B&!A1&A|F&E&!D1&D&C1&!C&B1&!B&!A1&A|F&E&D1&D&C1&!C&B1&!B&!A1&A|F&!E&D1&D&C1&!C&B1&!B&!A1&A|F&!E&D1&!D&C1&!C&B1&!B&!A1&A|F&E&D1&!D&C1&!C&B1&!B&!A1&A|F&E&!D1&!D&C1&!C&B1&!B&!A1&A|F&!E&!D1&!D&C1&!C&B1&!B&!A1&A|F&!E&!D1&!D&C1&C&B1&!B&!A1&A|F&E&!D1&!D&C1&C&B1&!B&!A1&A|F&E&D1&!D&C1&C&B1&!B&!A1&A|F&!E&D1&!D&C1&C&B1&!B&!A1&A|F&!E&D1&D&C1&C&B1&!B&!A1&A|F&E&D1&D&C1&C&B1&!B&!A1&A|F&E&!D1&D&C1&C&B1&!B&!A1&A|F&!E&!D1&D&C1&C&B1&!B&!A1&A|F&!E&!D1&D&!C1&C&B1&!B&!A1&A|F&E&!D1&D&!C1&C&B1&!B&!A1&A|F&E&D1&D&!C1&C&B1&!B&!A1&A|F&!E&D1&D&!C1&C&B1&!B&!A1&A|F&!E&D1&!D&!C1&C&B1&!B&!A1&A|F&E&D1&!D&!C1&C&B1&!B&!A1&A|F&E&!D1&!D&!C1&C&B1&!B&!A1&A|F&!E&!D1&!D&!C1&C&B1&!B&!A1&A|F&E&!D1&!D&!C1&C&!B1&!B&!A1&A|F&E&D1&!D&!C1&C&!B1&!B&!A1&A|F&!E&D1&D&!C1&C&!B1&!B&!A1&A|F&E&D1&D&!C1&C&!B1&!B&!A1&A|F&E&!D1&D&!C1&C&!B1&!B&!A1&A|F&E&!D1&D&C1&C&!B1&!B&!A1&A|F&E&D1&D&C1&C&!B1&!B&!A1&A|F&!E&D1&D&C1&C&!B1&!B&!A1&A|F&E&D1&!D&C1&C&!B1&!B&!A1&A|F&E&!D1&!D&C1&C&!B1&!B&!A1&A|F&E&!D1&!D&C1&!C&!B1&!B&!A1&A|F&E&D1&!D&C1&!C&!B1&!B&!A1&A|F&!E&D1&D&C1&!C&!B1&!B&!A1&A|F&E&D1&D&C1&!C&!B1&!B&!A1&A|F&E&!D1&D&C1&!C&!B1&!B&!A1&A|F&E&!D1&D&!C1&!C&!B1&!B&!A1&A|F&E&D1&D&!C1&!C&!B1&!B&!A1&A|F&!E&D1&D&!C1&!C&!B1&!B&!A1&A|F&E&D1&!D&!C1&!C&!B1&!B&!A1&A|F&E&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAAOAI222211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAOAAOI221112 -l AAOAOAAOI221112 -i F1 F E D C B1 B A1 A -o Y -f Y=!(F1&F&!E&!D&!C&!B1&!B&!A1&!A|F1&F&E&!D&!C&!B1&!B&!A1&!A|!F1&!F&E&D&!C&!B1&!B&!A1&!A|F1&!F&E&D&!C&!B1&!B&!A1&!A|F1&F&E&D&!C&!B1&!B&!A1&!A|!F1&F&E&D&!C&!B1&!B&!A1&!A|F1&F&!E&D&!C&!B1&!B&!A1&!A|F1&F&!E&D&C&!B1&!B&!A1&!A|!F1&F&E&D&C&!B1&!B&!A1&!A|F1&F&E&D&C&!B1&!B&!A1&!A|F1&!F&E&D&C&!B1&!B&!A1&!A|!F1&!F&E&D&C&!B1&!B&!A1&!A|F1&F&E&!D&C&!B1&!B&!A1&!A|F1&F&!E&!D&C&!B1&!B&!A1&!A|F1&F&!E&!D&C&B1&!B&!A1&!A|F1&F&E&!D&C&B1&!B&!A1&!A|!F1&!F&E&D&C&B1&!B&!A1&!A|F1&!F&E&D&C&B1&!B&!A1&!A|F1&F&E&D&C&B1&!B&!A1&!A|!F1&F&E&D&C&B1&!B&!A1&!A|F1&F&!E&D&C&B1&!B&!A1&!A|F1&F&!E&D&!C&B1&!B&!A1&!A|!F1&F&E&D&!C&B1&!B&!A1&!A|F1&F&E&D&!C&B1&!B&!A1&!A|F1&!F&E&D&!C&B1&!B&!A1&!A|!F1&!F&E&D&!C&B1&!B&!A1&!A|F1&F&E&!D&!C&B1&!B&!A1&!A|F1&F&!E&!D&!C&B1&!B&!A1&!A|F1&F&!E&!D&!C&B1&B&!A1&!A|F1&F&E&!D&!C&B1&B&!A1&!A|!F1&!F&E&D&!C&B1&B&!A1&!A|F1&!F&E&D&!C&B1&B&!A1&!A|F1&F&E&D&!C&B1&B&!A1&!A|!F1&F&E&D&!C&B1&B&!A1&!A|F1&F&!E&D&!C&B1&B&!A1&!A|F1&F&!E&D&C&B1&B&!A1&!A|!F1&F&E&D&C&B1&B&!A1&!A|F1&F&E&D&C&B1&B&!A1&!A|F1&!F&E&D&C&B1&B&!A1&!A|!F1&!F&E&D&C&B1&B&!A1&!A|!F1&!F&E&!D&C&B1&B&!A1&!A|F1&!F&E&!D&C&B1&B&!A1&!A|F1&F&E&!D&C&B1&B&!A1&!A|!F1&F&E&!D&C&B1&B&!A1&!A|F1&F&!E&!D&C&B1&B&!A1&!A|F1&F&!E&!D&C&!B1&B&!A1&!A|F1&F&E&!D&C&!B1&B&!A1&!A|!F1&!F&E&D&C&!B1&B&!A1&!A|F1&!F&E&D&C&!B1&B&!A1&!A|F1&F&E&D&C&!B1&B&!A1&!A|!F1&F&E&D&C&!B1&B&!A1&!A|F1&F&!E&D&C&!B1&B&!A1&!A|F1&F&!E&D&!C&!B1&B&!A1&!A|!F1&F&E&D&!C&!B1&B&!A1&!A|F1&F&E&D&!C&!B1&B&!A1&!A|F1&!F&E&D&!C&!B1&B&!A1&!A|!F1&!F&E&D&!C&!B1&B&!A1&!A|F1&F&E&!D&!C&!B1&B&!A1&!A|F1&F&!E&!D&!C&!B1&B&!A1&!A|F1&F&!E&!D&!C&!B1&B&A1&!A|F1&F&E&!D&!C&!B1&B&A1&!A|!F1&!F&E&D&!C&!B1&B&A1&!A|F1&!F&E&D&!C&!B1&B&A1&!A|F1&F&E&D&!C&!B1&B&A1&!A|!F1&F&E&D&!C&!B1&B&A1&!A|F1&F&!E&D&!C&!B1&B&A1&!A|F1&F&!E&D&C&!B1&B&A1&!A|!F1&F&E&D&C&!B1&B&A1&!A|F1&F&E&D&C&!B1&B&A1&!A|F1&!F&E&D&C&!B1&B&A1&!A|!F1&!F&E&D&C&!B1&B&A1&!A|F1&F&E&!D&C&!B1&B&A1&!A|F1&F&!E&!D&C&!B1&B&A1&!A|F1&F&!E&!D&C&B1&B&A1&!A|!F1&F&E&!D&C&B1&B&A1&!A|F1&F&E&!D&C&B1&B&A1&!A|F1&!F&E&!D&C&B1&B&A1&!A|!F1&!F&E&!D&C&B1&B&A1&!A|!F1&!F&E&D&C&B1&B&A1&!A|F1&!F&E&D&C&B1&B&A1&!A|F1&F&E&D&C&B1&B&A1&!A|!F1&F&E&D&C&B1&B&A1&!A|F1&F&!E&D&C&B1&B&A1&!A|F1&F&!E&D&!C&B1&B&A1&!A|!F1&F&E&D&!C&B1&B&A1&!A|F1&F&E&D&!C&B1&B&A1&!A|F1&!F&E&D&!C&B1&B&A1&!A|!F1&!F&E&D&!C&B1&B&A1&!A|F1&F&E&!D&!C&B1&B&A1&!A|F1&F&!E&!D&!C&B1&B&A1&!A|F1&F&!E&!D&!C&B1&!B&A1&!A|F1&F&E&!D&!C&B1&!B&A1&!A|!F1&!F&E&D&!C&B1&!B&A1&!A|F1&!F&E&D&!C&B1&!B&A1&!A|F1&F&E&D&!C&B1&!B&A1&!A|!F1&F&E&D&!C&B1&!B&A1&!A|F1&F&!E&D&!C&B1&!B&A1&!A|F1&F&!E&D&C&B1&!B&A1&!A|!F1&F&E&D&C&B1&!B&A1&!A|F1&F&E&D&C&B1&!B&A1&!A|F1&!F&E&D&C&B1&!B&A1&!A|!F1&!F&E&D&C&B1&!B&A1&!A|F1&F&E&!D&C&B1&!B&A1&!A|F1&F&!E&!D&C&B1&!B&A1&!A|F1&F&!E&!D&C&!B1&!B&A1&!A|F1&F&E&!D&C&!B1&!B&A1&!A|!F1&!F&E&D&C&!B1&!B&A1&!A|F1&!F&E&D&C&!B1&!B&A1&!A|F1&F&E&D&C&!B1&!B&A1&!A|!F1&F&E&D&C&!B1&!B&A1&!A|F1&F&!E&D&C&!B1&!B&A1&!A|F1&F&!E&D&!C&!B1&!B&A1&!A|!F1&F&E&D&!C&!B1&!B&A1&!A|F1&F&E&D&!C&!B1&!B&A1&!A|F1&!F&E&D&!C&!B1&!B&A1&!A|!F1&!F&E&D&!C&!B1&!B&A1&!A|F1&F&E&!D&!C&!B1&!B&A1&!A|F1&F&!E&!D&!C&!B1&!B&A1&!A|F1&F&!E&!D&!C&!B1&!B&A1&A|F1&F&E&!D&!C&!B1&!B&A1&A|!F1&!F&E&D&!C&!B1&!B&A1&A|F1&!F&E&D&!C&!B1&!B&A1&A|F1&F&E&D&!C&!B1&!B&A1&A|!F1&F&E&D&!C&!B1&!B&A1&A|F1&F&!E&D&!C&!B1&!B&A1&A|F1&F&!E&D&C&!B1&!B&A1&A|!F1&F&E&D&C&!B1&!B&A1&A|F1&F&E&D&C&!B1&!B&A1&A|F1&!F&E&D&C&!B1&!B&A1&A|!F1&!F&E&D&C&!B1&!B&A1&A|!F1&!F&E&!D&C&!B1&!B&A1&A|F1&!F&E&!D&C&!B1&!B&A1&A|F1&F&E&!D&C&!B1&!B&A1&A|!F1&F&E&!D&C&!B1&!B&A1&A|F1&F&!E&!D&C&!B1&!B&A1&A|F1&F&!E&!D&C&B1&!B&A1&A|!F1&F&E&!D&C&B1&!B&A1&A|F1&F&E&!D&C&B1&!B&A1&A|F1&!F&E&!D&C&B1&!B&A1&A|!F1&!F&E&!D&C&B1&!B&A1&A|!F1&!F&E&D&C&B1&!B&A1&A|F1&!F&E&D&C&B1&!B&A1&A|F1&F&E&D&C&B1&!B&A1&A|!F1&F&E&D&C&B1&!B&A1&A|F1&F&!E&D&C&B1&!B&A1&A|F1&F&!E&D&!C&B1&!B&A1&A|!F1&F&E&D&!C&B1&!B&A1&A|F1&F&E&D&!C&B1&!B&A1&A|F1&!F&E&D&!C&B1&!B&A1&A|!F1&!F&E&D&!C&B1&!B&A1&A|F1&F&E&!D&!C&B1&!B&A1&A|F1&F&!E&!D&!C&B1&!B&A1&A|F1&F&!E&!D&!C&B1&B&A1&A|F1&F&E&!D&!C&B1&B&A1&A|!F1&!F&E&D&!C&B1&B&A1&A|F1&!F&E&D&!C&B1&B&A1&A|F1&F&E&D&!C&B1&B&A1&A|!F1&F&E&D&!C&B1&B&A1&A|F1&F&!E&D&!C&B1&B&A1&A|F1&F&!E&D&C&B1&B&A1&A|!F1&F&E&D&C&B1&B&A1&A|F1&F&E&D&C&B1&B&A1&A|F1&!F&E&D&C&B1&B&A1&A|!F1&!F&E&D&C&B1&B&A1&A|!F1&!F&E&!D&C&B1&B&A1&A|F1&!F&E&!D&C&B1&B&A1&A|F1&F&E&!D&C&B1&B&A1&A|!F1&F&E&!D&C&B1&B&A1&A|F1&F&!E&!D&C&B1&B&A1&A|F1&F&!E&!D&C&!B1&B&A1&A|!F1&F&E&!D&C&!B1&B&A1&A|F1&F&E&!D&C&!B1&B&A1&A|F1&!F&E&!D&C&!B1&B&A1&A|!F1&!F&E&!D&C&!B1&B&A1&A|!F1&!F&E&D&C&!B1&B&A1&A|F1&!F&E&D&C&!B1&B&A1&A|F1&F&E&D&C&!B1&B&A1&A|!F1&F&E&D&C&!B1&B&A1&A|F1&F&!E&D&C&!B1&B&A1&A|F1&F&!E&D&!C&!B1&B&A1&A|!F1&F&E&D&!C&!B1&B&A1&A|F1&F&E&D&!C&!B1&B&A1&A|F1&!F&E&D&!C&!B1&B&A1&A|!F1&!F&E&D&!C&!B1&B&A1&A|F1&F&E&!D&!C&!B1&B&A1&A|F1&F&!E&!D&!C&!B1&B&A1&A|F1&F&!E&!D&!C&!B1&B&!A1&A|F1&F&E&!D&!C&!B1&B&!A1&A|!F1&!F&E&D&!C&!B1&B&!A1&A|F1&!F&E&D&!C&!B1&B&!A1&A|F1&F&E&D&!C&!B1&B&!A1&A|!F1&F&E&D&!C&!B1&B&!A1&A|F1&F&!E&D&!C&!B1&B&!A1&A|F1&F&!E&D&C&!B1&B&!A1&A|!F1&F&E&D&C&!B1&B&!A1&A|F1&F&E&D&C&!B1&B&!A1&A|F1&!F&E&D&C&!B1&B&!A1&A|!F1&!F&E&D&C&!B1&B&!A1&A|F1&F&E&!D&C&!B1&B&!A1&A|F1&F&!E&!D&C&!B1&B&!A1&A|F1&F&!E&!D&C&B1&B&!A1&A|!F1&F&E&!D&C&B1&B&!A1&A|F1&F&E&!D&C&B1&B&!A1&A|F1&!F&E&!D&C&B1&B&!A1&A|!F1&!F&E&!D&C&B1&B&!A1&A|!F1&!F&E&D&C&B1&B&!A1&A|F1&!F&E&D&C&B1&B&!A1&A|F1&F&E&D&C&B1&B&!A1&A|!F1&F&E&D&C&B1&B&!A1&A|F1&F&!E&D&C&B1&B&!A1&A|F1&F&!E&D&!C&B1&B&!A1&A|!F1&F&E&D&!C&B1&B&!A1&A|F1&F&E&D&!C&B1&B&!A1&A|F1&!F&E&D&!C&B1&B&!A1&A|!F1&!F&E&D&!C&B1&B&!A1&A|F1&F&E&!D&!C&B1&B&!A1&A|F1&F&!E&!D&!C&B1&B&!A1&A|F1&F&!E&!D&!C&B1&!B&!A1&A|F1&F&E&!D&!C&B1&!B&!A1&A|!F1&!F&E&D&!C&B1&!B&!A1&A|F1&!F&E&D&!C&B1&!B&!A1&A|F1&F&E&D&!C&B1&!B&!A1&A|!F1&F&E&D&!C&B1&!B&!A1&A|F1&F&!E&D&!C&B1&!B&!A1&A|F1&F&!E&D&C&B1&!B&!A1&A|!F1&F&E&D&C&B1&!B&!A1&A|F1&F&E&D&C&B1&!B&!A1&A|F1&!F&E&D&C&B1&!B&!A1&A|!F1&!F&E&D&C&B1&!B&!A1&A|F1&F&E&!D&C&B1&!B&!A1&A|F1&F&!E&!D&C&B1&!B&!A1&A|F1&F&!E&!D&C&!B1&!B&!A1&A|F1&F&E&!D&C&!B1&!B&!A1&A|!F1&!F&E&D&C&!B1&!B&!A1&A|F1&!F&E&D&C&!B1&!B&!A1&A|F1&F&E&D&C&!B1&!B&!A1&A|!F1&F&E&D&C&!B1&!B&!A1&A|F1&F&!E&D&C&!B1&!B&!A1&A|F1&F&!E&D&!C&!B1&!B&!A1&A|!F1&F&E&D&!C&!B1&!B&!A1&A|F1&F&E&D&!C&!B1&!B&!A1&A|F1&!F&E&D&!C&!B1&!B&!A1&A|!F1&!F&E&D&!C&!B1&!B&!A1&A|F1&F&E&!D&!C&!B1&!B&!A1&A|F1&F&!E&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAOAAOI221112.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOAI2123 -l OAAOOAI2123 -i D2 D1 D C1 C B A1 A -o Y -f Y=!(D2&!D1&!D&C1&C&!B&!A1&!A|D2&D1&!D&C1&C&!B&!A1&!A|!D2&D1&!D&C1&C&!B&!A1&!A|!D2&D1&D&C1&C&!B&!A1&!A|D2&D1&D&C1&C&!B&!A1&!A|D2&!D1&D&C1&C&!B&!A1&!A|!D2&!D1&D&C1&C&!B&!A1&!A|!D2&!D1&D&C1&C&B&!A1&!A|D2&!D1&D&C1&C&B&!A1&!A|D2&D1&D&C1&C&B&!A1&!A|!D2&D1&D&C1&C&B&!A1&!A|!D2&D1&!D&C1&C&B&!A1&!A|D2&D1&!D&C1&C&B&!A1&!A|D2&!D1&!D&C1&C&B&!A1&!A|D2&!D1&!D&!C1&!C&B&A1&!A|D2&D1&!D&!C1&!C&B&A1&!A|!D2&D1&!D&!C1&!C&B&A1&!A|!D2&D1&D&!C1&!C&B&A1&!A|D2&D1&D&!C1&!C&B&A1&!A|D2&!D1&D&!C1&!C&B&A1&!A|!D2&!D1&D&!C1&!C&B&A1&!A|!D2&!D1&D&C1&!C&B&A1&!A|D2&!D1&D&C1&!C&B&A1&!A|D2&D1&D&C1&!C&B&A1&!A|!D2&D1&D&C1&!C&B&A1&!A|!D2&D1&!D&C1&!C&B&A1&!A|D2&D1&!D&C1&!C&B&A1&!A|D2&!D1&!D&C1&!C&B&A1&!A|D2&!D1&!D&C1&C&B&A1&!A|D2&D1&!D&C1&C&B&A1&!A|!D2&D1&!D&C1&C&B&A1&!A|!D2&D1&D&C1&C&B&A1&!A|D2&D1&D&C1&C&B&A1&!A|D2&!D1&D&C1&C&B&A1&!A|!D2&!D1&D&C1&C&B&A1&!A|!D2&!D1&D&!C1&C&B&A1&!A|D2&!D1&D&!C1&C&B&A1&!A|D2&D1&D&!C1&C&B&A1&!A|!D2&D1&D&!C1&C&B&A1&!A|!D2&D1&!D&!C1&C&B&A1&!A|D2&D1&!D&!C1&C&B&A1&!A|D2&!D1&!D&!C1&C&B&A1&!A|!D2&!D1&D&C1&C&!B&A1&!A|D2&!D1&D&C1&C&!B&A1&!A|D2&D1&D&C1&C&!B&A1&!A|!D2&D1&D&C1&C&!B&A1&!A|!D2&D1&!D&C1&C&!B&A1&!A|D2&D1&!D&C1&C&!B&A1&!A|D2&!D1&!D&C1&C&!B&A1&!A|D2&!D1&!D&C1&C&!B&A1&A|D2&D1&!D&C1&C&!B&A1&A|!D2&D1&!D&C1&C&!B&A1&A|!D2&D1&D&C1&C&!B&A1&A|D2&D1&D&C1&C&!B&A1&A|D2&!D1&D&C1&C&!B&A1&A|!D2&!D1&D&C1&C&!B&A1&A|D2&!D1&!D&!C1&C&B&A1&A|D2&D1&!D&!C1&C&B&A1&A|!D2&D1&!D&!C1&C&B&A1&A|!D2&D1&D&!C1&C&B&A1&A|D2&D1&D&!C1&C&B&A1&A|D2&!D1&D&!C1&C&B&A1&A|!D2&!D1&D&!C1&C&B&A1&A|!D2&!D1&D&C1&C&B&A1&A|D2&!D1&D&C1&C&B&A1&A|D2&D1&D&C1&C&B&A1&A|!D2&D1&D&C1&C&B&A1&A|!D2&D1&!D&C1&C&B&A1&A|D2&D1&!D&C1&C&B&A1&A|D2&!D1&!D&C1&C&B&A1&A|D2&!D1&!D&C1&!C&B&A1&A|D2&D1&!D&C1&!C&B&A1&A|!D2&D1&!D&C1&!C&B&A1&A|!D2&D1&D&C1&!C&B&A1&A|D2&D1&D&C1&!C&B&A1&A|D2&!D1&D&C1&!C&B&A1&A|!D2&!D1&D&C1&!C&B&A1&A|!D2&!D1&D&!C1&!C&B&A1&A|D2&!D1&D&!C1&!C&B&A1&A|D2&D1&D&!C1&!C&B&A1&A|!D2&D1&D&!C1&!C&B&A1&A|!D2&D1&!D&!C1&!C&B&A1&A|D2&D1&!D&!C1&!C&B&A1&A|D2&!D1&!D&!C1&!C&B&A1&A|D2&!D1&!D&!C1&!C&B&!A1&A|D2&D1&!D&!C1&!C&B&!A1&A|!D2&D1&!D&!C1&!C&B&!A1&A|!D2&D1&D&!C1&!C&B&!A1&A|D2&D1&D&!C1&!C&B&!A1&A|D2&!D1&D&!C1&!C&B&!A1&A|!D2&!D1&D&!C1&!C&B&!A1&A|!D2&!D1&D&C1&!C&B&!A1&A|D2&!D1&D&C1&!C&B&!A1&A|D2&D1&D&C1&!C&B&!A1&A|!D2&D1&D&C1&!C&B&!A1&A|!D2&D1&!D&C1&!C&B&!A1&A|D2&D1&!D&C1&!C&B&!A1&A|D2&!D1&!D&C1&!C&B&!A1&A|D2&!D1&!D&C1&C&B&!A1&A|D2&D1&!D&C1&C&B&!A1&A|!D2&D1&!D&C1&C&B&!A1&A|!D2&D1&D&C1&C&B&!A1&A|D2&D1&D&C1&C&B&!A1&A|D2&!D1&D&C1&C&B&!A1&A|!D2&!D1&D&C1&C&B&!A1&A|!D2&!D1&D&!C1&C&B&!A1&A|D2&!D1&D&!C1&C&B&!A1&A|D2&D1&D&!C1&C&B&!A1&A|!D2&D1&D&!C1&C&B&!A1&A|!D2&D1&!D&!C1&C&B&!A1&A|D2&D1&!D&!C1&C&B&!A1&A|D2&!D1&!D&!C1&C&B&!A1&A|!D2&!D1&D&C1&C&!B&!A1&A|D2&!D1&D&C1&C&!B&!A1&A|D2&D1&D&C1&C&!B&!A1&A|!D2&D1&D&C1&C&!B&!A1&A|!D2&D1&!D&C1&C&!B&!A1&A|D2&D1&!D&C1&C&!B&!A1&A|D2&!D1&!D&C1&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOAI2123.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAI321 -l AOAI321 -i C B1 B A2 A1 A -o Y -f Y=!(C&B1&!B&!A2&!A1&!A|C&B1&B&!A2&!A1&!A|C&!B1&B&!A2&!A1&!A|C&!B1&B&A2&!A1&!A|C&B1&B&A2&!A1&!A|C&B1&!B&A2&!A1&!A|C&B1&!B&A2&A1&!A|C&B1&B&A2&A1&!A|C&!B1&B&A2&A1&!A|C&!B1&B&!A2&A1&!A|C&B1&B&!A2&A1&!A|C&B1&!B&!A2&A1&!A|C&B1&!B&!A2&A1&A|C&B1&B&!A2&A1&A|C&!B1&B&!A2&A1&A|C&!B1&B&A2&A1&A|C&B1&B&A2&A1&A|C&B1&!B&A2&A1&A|C&!B1&!B&A2&A1&A|C&B1&!B&A2&!A1&A|C&B1&B&A2&!A1&A|C&!B1&B&A2&!A1&A|C&!B1&B&!A2&!A1&A|C&B1&B&!A2&!A1&A|C&B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAI321.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AND4 -l AND4 -i A B C D -o Z -f Z=(A&B&C&D) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AND4.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOAOI221311 -l OOAAOAOI221311 -i F E D2 D1 D C B1 B A1 A -o Y -f Y=(!F&!E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!F&E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!F&E&D2&!D1&!D&!C&!B1&!B&!A1&!A|!F&!E&D2&!D1&!D&!C&!B1&!B&!A1&!A|!F&!E&D2&D1&!D&!C&!B1&!B&!A1&!A|!F&E&D2&D1&!D&!C&!B1&!B&!A1&!A|!F&E&!D2&D1&!D&!C&!B1&!B&!A1&!A|!F&!E&!D2&D1&!D&!C&!B1&!B&!A1&!A|!F&!E&!D2&D1&D&!C&!B1&!B&!A1&!A|!F&E&!D2&D1&D&!C&!B1&!B&!A1&!A|!F&!E&D2&D1&D&!C&!B1&!B&!A1&!A|!F&!E&D2&!D1&D&!C&!B1&!B&!A1&!A|!F&E&D2&!D1&D&!C&!B1&!B&!A1&!A|!F&E&!D2&!D1&D&!C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&D&!C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&D&C&!B1&!B&!A1&!A|!F&E&!D2&!D1&D&C&!B1&!B&!A1&!A|!F&E&D2&!D1&D&C&!B1&!B&!A1&!A|!F&!E&D2&!D1&D&C&!B1&!B&!A1&!A|!F&!E&D2&D1&D&C&!B1&!B&!A1&!A|!F&E&!D2&D1&D&C&!B1&!B&!A1&!A|!F&!E&!D2&D1&D&C&!B1&!B&!A1&!A|!F&!E&!D2&D1&!D&C&!B1&!B&!A1&!A|!F&E&!D2&D1&!D&C&!B1&!B&!A1&!A|!F&E&D2&D1&!D&C&!B1&!B&!A1&!A|!F&!E&D2&D1&!D&C&!B1&!B&!A1&!A|!F&!E&D2&!D1&!D&C&!B1&!B&!A1&!A|!F&E&D2&!D1&!D&C&!B1&!B&!A1&!A|!F&E&!D2&!D1&!D&C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&C&B1&!B&!A1&!A|!F&E&!D2&!D1&!D&C&B1&!B&!A1&!A|!F&E&D2&!D1&!D&C&B1&!B&!A1&!A|!F&!E&D2&!D1&!D&C&B1&!B&!A1&!A|!F&!E&D2&D1&!D&C&B1&!B&!A1&!A|!F&E&D2&D1&!D&C&B1&!B&!A1&!A|!F&E&!D2&D1&!D&C&B1&!B&!A1&!A|!F&!E&!D2&D1&!D&C&B1&!B&!A1&!A|!F&!E&!D2&D1&D&C&B1&!B&!A1&!A|!F&E&!D2&D1&D&C&B1&!B&!A1&!A|!F&!E&D2&D1&D&C&B1&!B&!A1&!A|!F&!E&D2&!D1&D&C&B1&!B&!A1&!A|!F&E&D2&!D1&D&C&B1&!B&!A1&!A|!F&E&!D2&!D1&D&C&B1&!B&!A1&!A|!F&!E&!D2&!D1&D&C&B1&!B&!A1&!A|!F&!E&!D2&!D1&D&!C&B1&!B&!A1&!A|!F&E&!D2&!D1&D&!C&B1&!B&!A1&!A|!F&E&D2&!D1&D&!C&B1&!B&!A1&!A|!F&!E&D2&!D1&D&!C&B1&!B&!A1&!A|!F&!E&D2&D1&D&!C&B1&!B&!A1&!A|!F&E&!D2&D1&D&!C&B1&!B&!A1&!A|!F&!E&!D2&D1&D&!C&B1&!B&!A1&!A|!F&!E&!D2&D1&!D&!C&B1&!B&!A1&!A|!F&E&!D2&D1&!D&!C&B1&!B&!A1&!A|!F&E&D2&D1&!D&!C&B1&!B&!A1&!A|!F&!E&D2&D1&!D&!C&B1&!B&!A1&!A|!F&!E&D2&!D1&!D&!C&B1&!B&!A1&!A|!F&E&D2&!D1&!D&!C&B1&!B&!A1&!A|!F&E&!D2&!D1&!D&!C&B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C&B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C&B1&B&!A1&!A|!F&E&!D2&!D1&!D&!C&B1&B&!A1&!A|!F&E&D2&!D1&!D&!C&B1&B&!A1&!A|!F&!E&D2&!D1&!D&!C&B1&B&!A1&!A|!F&!E&D2&D1&!D&!C&B1&B&!A1&!A|!F&E&D2&D1&!D&!C&B1&B&!A1&!A|!F&E&!D2&D1&!D&!C&B1&B&!A1&!A|!F&!E&!D2&D1&!D&!C&B1&B&!A1&!A|!F&!E&!D2&D1&D&!C&B1&B&!A1&!A|!F&E&!D2&D1&D&!C&B1&B&!A1&!A|!F&!E&D2&D1&D&!C&B1&B&!A1&!A|!F&!E&D2&!D1&D&!C&B1&B&!A1&!A|!F&E&D2&!D1&D&!C&B1&B&!A1&!A|!F&E&!D2&!D1&D&!C&B1&B&!A1&!A|!F&!E&!D2&!D1&D&!C&B1&B&!A1&!A|!F&!E&!D2&!D1&D&C&B1&B&!A1&!A|!F&E&!D2&!D1&D&C&B1&B&!A1&!A|!F&E&D2&!D1&D&C&B1&B&!A1&!A|!F&!E&D2&!D1&D&C&B1&B&!A1&!A|!F&!E&D2&D1&D&C&B1&B&!A1&!A|!F&E&!D2&D1&D&C&B1&B&!A1&!A|!F&!E&!D2&D1&D&C&B1&B&!A1&!A|!F&!E&!D2&D1&!D&C&B1&B&!A1&!A|!F&E&!D2&D1&!D&C&B1&B&!A1&!A|!F&E&D2&D1&!D&C&B1&B&!A1&!A|!F&!E&D2&D1&!D&C&B1&B&!A1&!A|!F&!E&D2&!D1&!D&C&B1&B&!A1&!A|!F&E&D2&!D1&!D&C&B1&B&!A1&!A|!F&E&!D2&!D1&!D&C&B1&B&!A1&!A|!F&!E&!D2&!D1&!D&C&B1&B&!A1&!A|!F&!E&!D2&!D1&!D&C&!B1&B&!A1&!A|!F&E&!D2&!D1&!D&C&!B1&B&!A1&!A|!F&E&D2&!D1&!D&C&!B1&B&!A1&!A|!F&!E&D2&!D1&!D&C&!B1&B&!A1&!A|!F&!E&D2&D1&!D&C&!B1&B&!A1&!A|!F&E&D2&D1&!D&C&!B1&B&!A1&!A|!F&E&!D2&D1&!D&C&!B1&B&!A1&!A|!F&!E&!D2&D1&!D&C&!B1&B&!A1&!A|!F&!E&!D2&D1&D&C&!B1&B&!A1&!A|!F&E&!D2&D1&D&C&!B1&B&!A1&!A|!F&!E&D2&D1&D&C&!B1&B&!A1&!A|!F&!E&D2&!D1&D&C&!B1&B&!A1&!A|!F&E&D2&!D1&D&C&!B1&B&!A1&!A|!F&E&!D2&!D1&D&C&!B1&B&!A1&!A|!F&!E&!D2&!D1&D&C&!B1&B&!A1&!A|!F&!E&!D2&!D1&D&!C&!B1&B&!A1&!A|!F&E&!D2&!D1&D&!C&!B1&B&!A1&!A|!F&E&D2&!D1&D&!C&!B1&B&!A1&!A|!F&!E&D2&!D1&D&!C&!B1&B&!A1&!A|!F&!E&D2&D1&D&!C&!B1&B&!A1&!A|!F&E&!D2&D1&D&!C&!B1&B&!A1&!A|!F&!E&!D2&D1&D&!C&!B1&B&!A1&!A|!F&!E&!D2&D1&!D&!C&!B1&B&!A1&!A|!F&E&!D2&D1&!D&!C&!B1&B&!A1&!A|!F&E&D2&D1&!D&!C&!B1&B&!A1&!A|!F&!E&D2&D1&!D&!C&!B1&B&!A1&!A|!F&!E&D2&!D1&!D&!C&!B1&B&!A1&!A|!F&E&D2&!D1&!D&!C&!B1&B&!A1&!A|!F&E&!D2&!D1&!D&!C&!B1&B&!A1&!A|!F&!E&!D2&!D1&!D&!C&!B1&B&!A1&!A|!F&!E&!D2&!D1&!D&!C&!B1&B&A1&!A|!F&E&!D2&!D1&!D&!C&!B1&B&A1&!A|!F&E&D2&!D1&!D&!C&!B1&B&A1&!A|!F&!E&D2&!D1&!D&!C&!B1&B&A1&!A|!F&!E&D2&D1&!D&!C&!B1&B&A1&!A|!F&E&D2&D1&!D&!C&!B1&B&A1&!A|!F&E&!D2&D1&!D&!C&!B1&B&A1&!A|!F&!E&!D2&D1&!D&!C&!B1&B&A1&!A|!F&!E&!D2&D1&D&!C&!B1&B&A1&!A|!F&E&!D2&D1&D&!C&!B1&B&A1&!A|!F&!E&D2&D1&D&!C&!B1&B&A1&!A|!F&!E&D2&!D1&D&!C&!B1&B&A1&!A|!F&E&D2&!D1&D&!C&!B1&B&A1&!A|!F&E&!D2&!D1&D&!C&!B1&B&A1&!A|!F&!E&!D2&!D1&D&!C&!B1&B&A1&!A|!F&!E&!D2&!D1&D&C&!B1&B&A1&!A|!F&!E&D2&!D1&D&C&!B1&B&A1&!A|!F&!E&D2&D1&D&C&!B1&B&A1&!A|!F&!E&!D2&D1&D&C&!B1&B&A1&!A|!F&!E&!D2&D1&!D&C&!B1&B&A1&!A|!F&!E&D2&D1&!D&C&!B1&B&A1&!A|!F&!E&D2&!D1&!D&C&!B1&B&A1&!A|!F&!E&!D2&!D1&!D&C&!B1&B&A1&!A|!F&!E&!D2&!D1&!D&C&B1&B&A1&!A|!F&!E&D2&!D1&!D&C&B1&B&A1&!A|!F&!E&D2&D1&!D&C&B1&B&A1&!A|!F&!E&!D2&D1&!D&C&B1&B&A1&!A|!F&!E&!D2&D1&D&C&B1&B&A1&!A|!F&!E&D2&D1&D&C&B1&B&A1&!A|!F&!E&D2&!D1&D&C&B1&B&A1&!A|!F&!E&!D2&!D1&D&C&B1&B&A1&!A|!F&!E&!D2&!D1&D&!C&B1&B&A1&!A|!F&E&!D2&!D1&D&!C&B1&B&A1&!A|!F&E&D2&!D1&D&!C&B1&B&A1&!A|!F&!E&D2&!D1&D&!C&B1&B&A1&!A|!F&!E&D2&D1&D&!C&B1&B&A1&!A|!F&E&!D2&D1&D&!C&B1&B&A1&!A|!F&!E&!D2&D1&D&!C&B1&B&A1&!A|!F&!E&!D2&D1&!D&!C&B1&B&A1&!A|!F&E&!D2&D1&!D&!C&B1&B&A1&!A|!F&E&D2&D1&!D&!C&B1&B&A1&!A|!F&!E&D2&D1&!D&!C&B1&B&A1&!A|!F&!E&D2&!D1&!D&!C&B1&B&A1&!A|!F&E&D2&!D1&!D&!C&B1&B&A1&!A|!F&E&!D2&!D1&!D&!C&B1&B&A1&!A|!F&!E&!D2&!D1&!D&!C&B1&B&A1&!A|!F&!E&!D2&!D1&!D&!C&B1&!B&A1&!A|!F&E&!D2&!D1&!D&!C&B1&!B&A1&!A|!F&E&D2&!D1&!D&!C&B1&!B&A1&!A|!F&!E&D2&!D1&!D&!C&B1&!B&A1&!A|!F&!E&D2&D1&!D&!C&B1&!B&A1&!A|!F&E&D2&D1&!D&!C&B1&!B&A1&!A|!F&E&!D2&D1&!D&!C&B1&!B&A1&!A|!F&!E&!D2&D1&!D&!C&B1&!B&A1&!A|!F&!E&!D2&D1&D&!C&B1&!B&A1&!A|!F&E&!D2&D1&D&!C&B1&!B&A1&!A|!F&!E&D2&D1&D&!C&B1&!B&A1&!A|!F&!E&D2&!D1&D&!C&B1&!B&A1&!A|!F&E&D2&!D1&D&!C&B1&!B&A1&!A|!F&E&!D2&!D1&D&!C&B1&!B&A1&!A|!F&!E&!D2&!D1&D&!C&B1&!B&A1&!A|!F&!E&!D2&!D1&D&C&B1&!B&A1&!A|!F&!E&D2&!D1&D&C&B1&!B&A1&!A|!F&!E&D2&D1&D&C&B1&!B&A1&!A|!F&!E&!D2&D1&D&C&B1&!B&A1&!A|!F&!E&!D2&D1&!D&C&B1&!B&A1&!A|!F&!E&D2&D1&!D&C&B1&!B&A1&!A|!F&!E&D2&!D1&!D&C&B1&!B&A1&!A|!F&!E&!D2&!D1&!D&C&B1&!B&A1&!A|!F&!E&!D2&!D1&!D&C&!B1&!B&A1&!A|!F&E&!D2&!D1&!D&C&!B1&!B&A1&!A|!F&E&D2&!D1&!D&C&!B1&!B&A1&!A|!F&!E&D2&!D1&!D&C&!B1&!B&A1&!A|!F&!E&D2&D1&!D&C&!B1&!B&A1&!A|!F&E&D2&D1&!D&C&!B1&!B&A1&!A|!F&E&!D2&D1&!D&C&!B1&!B&A1&!A|!F&!E&!D2&D1&!D&C&!B1&!B&A1&!A|!F&!E&!D2&D1&D&C&!B1&!B&A1&!A|!F&E&!D2&D1&D&C&!B1&!B&A1&!A|!F&!E&D2&D1&D&C&!B1&!B&A1&!A|!F&!E&D2&!D1&D&C&!B1&!B&A1&!A|!F&E&D2&!D1&D&C&!B1&!B&A1&!A|!F&E&!D2&!D1&D&C&!B1&!B&A1&!A|!F&!E&!D2&!D1&D&C&!B1&!B&A1&!A|!F&!E&!D2&!D1&D&!C&!B1&!B&A1&!A|!F&E&!D2&!D1&D&!C&!B1&!B&A1&!A|!F&E&D2&!D1&D&!C&!B1&!B&A1&!A|!F&!E&D2&!D1&D&!C&!B1&!B&A1&!A|!F&!E&D2&D1&D&!C&!B1&!B&A1&!A|!F&E&!D2&D1&D&!C&!B1&!B&A1&!A|!F&!E&!D2&D1&D&!C&!B1&!B&A1&!A|!F&!E&!D2&D1&!D&!C&!B1&!B&A1&!A|!F&E&!D2&D1&!D&!C&!B1&!B&A1&!A|!F&E&D2&D1&!D&!C&!B1&!B&A1&!A|!F&!E&D2&D1&!D&!C&!B1&!B&A1&!A|!F&!E&D2&!D1&!D&!C&!B1&!B&A1&!A|!F&E&D2&!D1&!D&!C&!B1&!B&A1&!A|!F&E&!D2&!D1&!D&!C&!B1&!B&A1&!A|!F&!E&!D2&!D1&!D&!C&!B1&!B&A1&!A|!F&!E&!D2&!D1&!D&!C&!B1&!B&A1&A|!F&E&!D2&!D1&!D&!C&!B1&!B&A1&A|!F&E&D2&!D1&!D&!C&!B1&!B&A1&A|!F&!E&D2&!D1&!D&!C&!B1&!B&A1&A|!F&!E&D2&D1&!D&!C&!B1&!B&A1&A|!F&E&D2&D1&!D&!C&!B1&!B&A1&A|!F&E&!D2&D1&!D&!C&!B1&!B&A1&A|!F&!E&!D2&D1&!D&!C&!B1&!B&A1&A|!F&!E&!D2&D1&D&!C&!B1&!B&A1&A|!F&E&!D2&D1&D&!C&!B1&!B&A1&A|!F&!E&D2&D1&D&!C&!B1&!B&A1&A|!F&!E&D2&!D1&D&!C&!B1&!B&A1&A|!F&E&D2&!D1&D&!C&!B1&!B&A1&A|!F&E&!D2&!D1&D&!C&!B1&!B&A1&A|!F&!E&!D2&!D1&D&!C&!B1&!B&A1&A|!F&!E&!D2&!D1&D&C&!B1&!B&A1&A|!F&E&!D2&!D1&D&C&!B1&!B&A1&A|!F&E&D2&!D1&D&C&!B1&!B&A1&A|!F&!E&D2&!D1&D&C&!B1&!B&A1&A|!F&!E&D2&D1&D&C&!B1&!B&A1&A|!F&E&!D2&D1&D&C&!B1&!B&A1&A|!F&!E&!D2&D1&D&C&!B1&!B&A1&A|!F&!E&!D2&D1&!D&C&!B1&!B&A1&A|!F&E&!D2&D1&!D&C&!B1&!B&A1&A|!F&E&D2&D1&!D&C&!B1&!B&A1&A|!F&!E&D2&D1&!D&C&!B1&!B&A1&A|!F&!E&D2&!D1&!D&C&!B1&!B&A1&A|!F&E&D2&!D1&!D&C&!B1&!B&A1&A|!F&E&!D2&!D1&!D&C&!B1&!B&A1&A|!F&!E&!D2&!D1&!D&C&!B1&!B&A1&A|!F&!E&!D2&!D1&!D&C&B1&!B&A1&A|!F&!E&D2&!D1&!D&C&B1&!B&A1&A|!F&!E&D2&D1&!D&C&B1&!B&A1&A|!F&!E&!D2&D1&!D&C&B1&!B&A1&A|!F&!E&!D2&D1&D&C&B1&!B&A1&A|!F&!E&D2&D1&D&C&B1&!B&A1&A|!F&!E&D2&!D1&D&C&B1&!B&A1&A|!F&!E&!D2&!D1&D&C&B1&!B&A1&A|!F&!E&!D2&!D1&D&!C&B1&!B&A1&A|!F&E&!D2&!D1&D&!C&B1&!B&A1&A|!F&E&D2&!D1&D&!C&B1&!B&A1&A|!F&!E&D2&!D1&D&!C&B1&!B&A1&A|!F&!E&D2&D1&D&!C&B1&!B&A1&A|!F&E&!D2&D1&D&!C&B1&!B&A1&A|!F&!E&!D2&D1&D&!C&B1&!B&A1&A|!F&!E&!D2&D1&!D&!C&B1&!B&A1&A|!F&E&!D2&D1&!D&!C&B1&!B&A1&A|!F&E&D2&D1&!D&!C&B1&!B&A1&A|!F&!E&D2&D1&!D&!C&B1&!B&A1&A|!F&!E&D2&!D1&!D&!C&B1&!B&A1&A|!F&E&D2&!D1&!D&!C&B1&!B&A1&A|!F&E&!D2&!D1&!D&!C&B1&!B&A1&A|!F&!E&!D2&!D1&!D&!C&B1&!B&A1&A|!F&!E&!D2&!D1&!D&!C&B1&B&A1&A|!F&E&!D2&!D1&!D&!C&B1&B&A1&A|!F&E&D2&!D1&!D&!C&B1&B&A1&A|!F&!E&D2&!D1&!D&!C&B1&B&A1&A|!F&!E&D2&D1&!D&!C&B1&B&A1&A|!F&E&D2&D1&!D&!C&B1&B&A1&A|!F&E&!D2&D1&!D&!C&B1&B&A1&A|!F&!E&!D2&D1&!D&!C&B1&B&A1&A|!F&!E&!D2&D1&D&!C&B1&B&A1&A|!F&E&!D2&D1&D&!C&B1&B&A1&A|!F&!E&D2&D1&D&!C&B1&B&A1&A|!F&!E&D2&!D1&D&!C&B1&B&A1&A|!F&E&D2&!D1&D&!C&B1&B&A1&A|!F&E&!D2&!D1&D&!C&B1&B&A1&A|!F&!E&!D2&!D1&D&!C&B1&B&A1&A|!F&!E&!D2&!D1&D&C&B1&B&A1&A|!F&!E&D2&!D1&D&C&B1&B&A1&A|!F&!E&D2&D1&D&C&B1&B&A1&A|!F&!E&!D2&D1&D&C&B1&B&A1&A|!F&!E&!D2&D1&!D&C&B1&B&A1&A|!F&!E&D2&D1&!D&C&B1&B&A1&A|!F&!E&D2&!D1&!D&C&B1&B&A1&A|!F&!E&!D2&!D1&!D&C&B1&B&A1&A|!F&!E&!D2&!D1&!D&C&!B1&B&A1&A|!F&!E&D2&!D1&!D&C&!B1&B&A1&A|!F&!E&D2&D1&!D&C&!B1&B&A1&A|!F&!E&!D2&D1&!D&C&!B1&B&A1&A|!F&!E&!D2&D1&D&C&!B1&B&A1&A|!F&!E&D2&D1&D&C&!B1&B&A1&A|!F&!E&D2&!D1&D&C&!B1&B&A1&A|!F&!E&!D2&!D1&D&C&!B1&B&A1&A|!F&!E&!D2&!D1&D&!C&!B1&B&A1&A|!F&E&!D2&!D1&D&!C&!B1&B&A1&A|!F&E&D2&!D1&D&!C&!B1&B&A1&A|!F&!E&D2&!D1&D&!C&!B1&B&A1&A|!F&!E&D2&D1&D&!C&!B1&B&A1&A|!F&E&!D2&D1&D&!C&!B1&B&A1&A|!F&!E&!D2&D1&D&!C&!B1&B&A1&A|!F&!E&!D2&D1&!D&!C&!B1&B&A1&A|!F&E&!D2&D1&!D&!C&!B1&B&A1&A|!F&E&D2&D1&!D&!C&!B1&B&A1&A|!F&!E&D2&D1&!D&!C&!B1&B&A1&A|!F&!E&D2&!D1&!D&!C&!B1&B&A1&A|!F&E&D2&!D1&!D&!C&!B1&B&A1&A|!F&E&!D2&!D1&!D&!C&!B1&B&A1&A|!F&!E&!D2&!D1&!D&!C&!B1&B&A1&A|!F&!E&!D2&!D1&!D&!C&!B1&B&!A1&A|!F&E&!D2&!D1&!D&!C&!B1&B&!A1&A|!F&E&D2&!D1&!D&!C&!B1&B&!A1&A|!F&!E&D2&!D1&!D&!C&!B1&B&!A1&A|!F&!E&D2&D1&!D&!C&!B1&B&!A1&A|!F&E&D2&D1&!D&!C&!B1&B&!A1&A|!F&E&!D2&D1&!D&!C&!B1&B&!A1&A|!F&!E&!D2&D1&!D&!C&!B1&B&!A1&A|!F&!E&!D2&D1&D&!C&!B1&B&!A1&A|!F&E&!D2&D1&D&!C&!B1&B&!A1&A|!F&!E&D2&D1&D&!C&!B1&B&!A1&A|!F&!E&D2&!D1&D&!C&!B1&B&!A1&A|!F&E&D2&!D1&D&!C&!B1&B&!A1&A|!F&E&!D2&!D1&D&!C&!B1&B&!A1&A|!F&!E&!D2&!D1&D&!C&!B1&B&!A1&A|!F&!E&!D2&!D1&D&C&!B1&B&!A1&A|!F&!E&D2&!D1&D&C&!B1&B&!A1&A|!F&!E&D2&D1&D&C&!B1&B&!A1&A|!F&!E&!D2&D1&D&C&!B1&B&!A1&A|!F&!E&!D2&D1&!D&C&!B1&B&!A1&A|!F&!E&D2&D1&!D&C&!B1&B&!A1&A|!F&!E&D2&!D1&!D&C&!B1&B&!A1&A|!F&!E&!D2&!D1&!D&C&!B1&B&!A1&A|!F&!E&!D2&!D1&!D&C&B1&B&!A1&A|!F&!E&D2&!D1&!D&C&B1&B&!A1&A|!F&!E&D2&D1&!D&C&B1&B&!A1&A|!F&!E&!D2&D1&!D&C&B1&B&!A1&A|!F&!E&!D2&D1&D&C&B1&B&!A1&A|!F&!E&D2&D1&D&C&B1&B&!A1&A|!F&!E&D2&!D1&D&C&B1&B&!A1&A|!F&!E&!D2&!D1&D&C&B1&B&!A1&A|!F&!E&!D2&!D1&D&!C&B1&B&!A1&A|!F&E&!D2&!D1&D&!C&B1&B&!A1&A|!F&E&D2&!D1&D&!C&B1&B&!A1&A|!F&!E&D2&!D1&D&!C&B1&B&!A1&A|!F&!E&D2&D1&D&!C&B1&B&!A1&A|!F&E&!D2&D1&D&!C&B1&B&!A1&A|!F&!E&!D2&D1&D&!C&B1&B&!A1&A|!F&!E&!D2&D1&!D&!C&B1&B&!A1&A|!F&E&!D2&D1&!D&!C&B1&B&!A1&A|!F&E&D2&D1&!D&!C&B1&B&!A1&A|!F&!E&D2&D1&!D&!C&B1&B&!A1&A|!F&!E&D2&!D1&!D&!C&B1&B&!A1&A|!F&E&D2&!D1&!D&!C&B1&B&!A1&A|!F&E&!D2&!D1&!D&!C&B1&B&!A1&A|!F&!E&!D2&!D1&!D&!C&B1&B&!A1&A|!F&!E&!D2&!D1&!D&!C&B1&!B&!A1&A|!F&E&!D2&!D1&!D&!C&B1&!B&!A1&A|!F&E&D2&!D1&!D&!C&B1&!B&!A1&A|!F&!E&D2&!D1&!D&!C&B1&!B&!A1&A|!F&!E&D2&D1&!D&!C&B1&!B&!A1&A|!F&E&D2&D1&!D&!C&B1&!B&!A1&A|!F&E&!D2&D1&!D&!C&B1&!B&!A1&A|!F&!E&!D2&D1&!D&!C&B1&!B&!A1&A|!F&!E&!D2&D1&D&!C&B1&!B&!A1&A|!F&E&!D2&D1&D&!C&B1&!B&!A1&A|!F&!E&D2&D1&D&!C&B1&!B&!A1&A|!F&!E&D2&!D1&D&!C&B1&!B&!A1&A|!F&E&D2&!D1&D&!C&B1&!B&!A1&A|!F&E&!D2&!D1&D&!C&B1&!B&!A1&A|!F&!E&!D2&!D1&D&!C&B1&!B&!A1&A|!F&!E&!D2&!D1&D&C&B1&!B&!A1&A|!F&!E&D2&!D1&D&C&B1&!B&!A1&A|!F&!E&D2&D1&D&C&B1&!B&!A1&A|!F&!E&!D2&D1&D&C&B1&!B&!A1&A|!F&!E&!D2&D1&!D&C&B1&!B&!A1&A|!F&!E&D2&D1&!D&C&B1&!B&!A1&A|!F&!E&D2&!D1&!D&C&B1&!B&!A1&A|!F&!E&!D2&!D1&!D&C&B1&!B&!A1&A|!F&!E&!D2&!D1&!D&C&!B1&!B&!A1&A|!F&E&!D2&!D1&!D&C&!B1&!B&!A1&A|!F&E&D2&!D1&!D&C&!B1&!B&!A1&A|!F&!E&D2&!D1&!D&C&!B1&!B&!A1&A|!F&!E&D2&D1&!D&C&!B1&!B&!A1&A|!F&E&D2&D1&!D&C&!B1&!B&!A1&A|!F&E&!D2&D1&!D&C&!B1&!B&!A1&A|!F&!E&!D2&D1&!D&C&!B1&!B&!A1&A|!F&!E&!D2&D1&D&C&!B1&!B&!A1&A|!F&E&!D2&D1&D&C&!B1&!B&!A1&A|!F&!E&D2&D1&D&C&!B1&!B&!A1&A|!F&!E&D2&!D1&D&C&!B1&!B&!A1&A|!F&E&D2&!D1&D&C&!B1&!B&!A1&A|!F&E&!D2&!D1&D&C&!B1&!B&!A1&A|!F&!E&!D2&!D1&D&C&!B1&!B&!A1&A|!F&!E&!D2&!D1&D&!C&!B1&!B&!A1&A|!F&E&!D2&!D1&D&!C&!B1&!B&!A1&A|!F&E&D2&!D1&D&!C&!B1&!B&!A1&A|!F&!E&D2&!D1&D&!C&!B1&!B&!A1&A|!F&!E&D2&D1&D&!C&!B1&!B&!A1&A|!F&E&!D2&D1&D&!C&!B1&!B&!A1&A|!F&!E&!D2&D1&D&!C&!B1&!B&!A1&A|!F&!E&!D2&D1&!D&!C&!B1&!B&!A1&A|!F&E&!D2&D1&!D&!C&!B1&!B&!A1&A|!F&E&D2&D1&!D&!C&!B1&!B&!A1&A|!F&!E&D2&D1&!D&!C&!B1&!B&!A1&A|!F&!E&D2&!D1&!D&!C&!B1&!B&!A1&A|!F&E&D2&!D1&!D&!C&!B1&!B&!A1&A|!F&E&!D2&!D1&!D&!C&!B1&!B&!A1&A|!F&!E&!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOAOI221311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOAI21121 -l AOAOAI21121 -i E D1 D C B A1 A -o Y -f Y=!(E&D1&!D&!C&!B&!A1&!A|E&D1&D&!C&!B&!A1&!A|E&!D1&D&!C&!B&!A1&!A|E&!D1&D&C&!B&!A1&!A|E&D1&D&C&!B&!A1&!A|E&D1&!D&C&!B&!A1&!A|E&!D1&!D&C&B&!A1&!A|E&D1&!D&C&B&!A1&!A|E&D1&D&C&B&!A1&!A|E&!D1&D&C&B&!A1&!A|E&!D1&D&!C&B&!A1&!A|E&D1&D&!C&B&!A1&!A|E&D1&!D&!C&B&!A1&!A|E&D1&!D&!C&B&A1&!A|E&D1&D&!C&B&A1&!A|E&!D1&D&!C&B&A1&!A|E&!D1&D&C&B&A1&!A|E&D1&D&C&B&A1&!A|E&D1&!D&C&B&A1&!A|E&!D1&!D&C&B&A1&!A|E&D1&!D&C&!B&A1&!A|E&D1&D&C&!B&A1&!A|E&!D1&D&C&!B&A1&!A|E&!D1&D&!C&!B&A1&!A|E&D1&D&!C&!B&A1&!A|E&D1&!D&!C&!B&A1&!A|E&D1&!D&!C&!B&A1&A|E&D1&D&!C&!B&A1&A|E&!D1&D&!C&!B&A1&A|E&!D1&D&C&!B&A1&A|E&D1&D&C&!B&A1&A|E&D1&!D&C&!B&A1&A|E&!D1&!D&C&!B&A1&A|E&!D1&!D&C&B&A1&A|E&D1&!D&C&B&A1&A|E&D1&D&C&B&A1&A|E&!D1&D&C&B&A1&A|E&!D1&D&!C&B&A1&A|E&D1&D&!C&B&A1&A|E&D1&!D&!C&B&A1&A|E&D1&!D&!C&B&!A1&A|E&D1&D&!C&B&!A1&A|E&!D1&D&!C&B&!A1&A|E&!D1&D&C&B&!A1&A|E&D1&D&C&B&!A1&A|E&D1&!D&C&B&!A1&A|E&!D1&!D&C&B&!A1&A|E&D1&!D&C&!B&!A1&A|E&D1&D&C&!B&!A1&A|E&!D1&D&C&!B&!A1&A|E&!D1&D&!C&!B&!A1&A|E&D1&D&!C&!B&!A1&A|E&D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOAI21121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOAI212311 -l AOOAAOAI212311 -i F E D2 D1 D C1 C B A1 A -o Y -f Y=!(F&E&!D2&!D1&!D&!C1&!C&!B&!A1&!A|F&E&D2&!D1&!D&!C1&!C&!B&!A1&!A|F&E&D2&D1&!D&!C1&!C&!B&!A1&!A|F&E&!D2&D1&!D&!C1&!C&!B&!A1&!A|F&E&!D2&D1&D&!C1&!C&!B&!A1&!A|F&E&D2&D1&D&!C1&!C&!B&!A1&!A|F&!E&D2&D1&D&!C1&!C&!B&!A1&!A|F&E&D2&!D1&D&!C1&!C&!B&!A1&!A|F&E&!D2&!D1&D&!C1&!C&!B&!A1&!A|F&E&!D2&!D1&D&C1&!C&!B&!A1&!A|F&E&D2&!D1&D&C1&!C&!B&!A1&!A|F&!E&D2&D1&D&C1&!C&!B&!A1&!A|F&E&D2&D1&D&C1&!C&!B&!A1&!A|F&E&!D2&D1&D&C1&!C&!B&!A1&!A|F&E&!D2&D1&!D&C1&!C&!B&!A1&!A|F&E&D2&D1&!D&C1&!C&!B&!A1&!A|F&E&D2&!D1&!D&C1&!C&!B&!A1&!A|F&E&!D2&!D1&!D&C1&!C&!B&!A1&!A|F&E&!D2&!D1&!D&C1&C&!B&!A1&!A|F&E&D2&!D1&!D&C1&C&!B&!A1&!A|F&E&D2&D1&!D&C1&C&!B&!A1&!A|F&E&!D2&D1&!D&C1&C&!B&!A1&!A|F&E&!D2&D1&D&C1&C&!B&!A1&!A|F&E&D2&D1&D&C1&C&!B&!A1&!A|F&!E&D2&D1&D&C1&C&!B&!A1&!A|F&E&D2&!D1&D&C1&C&!B&!A1&!A|F&E&!D2&!D1&D&C1&C&!B&!A1&!A|F&E&!D2&!D1&D&!C1&C&!B&!A1&!A|F&E&D2&!D1&D&!C1&C&!B&!A1&!A|F&!E&D2&D1&D&!C1&C&!B&!A1&!A|F&E&D2&D1&D&!C1&C&!B&!A1&!A|F&E&!D2&D1&D&!C1&C&!B&!A1&!A|F&E&!D2&D1&!D&!C1&C&!B&!A1&!A|F&E&D2&D1&!D&!C1&C&!B&!A1&!A|F&E&D2&!D1&!D&!C1&C&!B&!A1&!A|F&E&!D2&!D1&!D&!C1&C&!B&!A1&!A|F&!E&!D2&!D1&!D&!C1&C&B&!A1&!A|F&E&!D2&!D1&!D&!C1&C&B&!A1&!A|F&E&D2&!D1&!D&!C1&C&B&!A1&!A|F&!E&D2&!D1&!D&!C1&C&B&!A1&!A|F&!E&D2&D1&!D&!C1&C&B&!A1&!A|F&E&D2&D1&!D&!C1&C&B&!A1&!A|F&E&!D2&D1&!D&!C1&C&B&!A1&!A|F&!E&!D2&D1&!D&!C1&C&B&!A1&!A|F&!E&!D2&D1&D&!C1&C&B&!A1&!A|F&E&!D2&D1&D&!C1&C&B&!A1&!A|F&E&D2&D1&D&!C1&C&B&!A1&!A|F&!E&D2&D1&D&!C1&C&B&!A1&!A|F&!E&D2&!D1&D&!C1&C&B&!A1&!A|F&E&D2&!D1&D&!C1&C&B&!A1&!A|F&E&!D2&!D1&D&!C1&C&B&!A1&!A|F&!E&!D2&!D1&D&!C1&C&B&!A1&!A|F&!E&!D2&!D1&D&C1&C&B&!A1&!A|F&E&!D2&!D1&D&C1&C&B&!A1&!A|F&E&D2&!D1&D&C1&C&B&!A1&!A|F&!E&D2&!D1&D&C1&C&B&!A1&!A|F&!E&D2&D1&D&C1&C&B&!A1&!A|F&E&D2&D1&D&C1&C&B&!A1&!A|F&E&!D2&D1&D&C1&C&B&!A1&!A|F&!E&!D2&D1&D&C1&C&B&!A1&!A|F&!E&!D2&D1&!D&C1&C&B&!A1&!A|F&E&!D2&D1&!D&C1&C&B&!A1&!A|F&E&D2&D1&!D&C1&C&B&!A1&!A|F&!E&D2&D1&!D&C1&C&B&!A1&!A|F&!E&D2&!D1&!D&C1&C&B&!A1&!A|F&E&D2&!D1&!D&C1&C&B&!A1&!A|F&E&!D2&!D1&!D&C1&C&B&!A1&!A|F&!E&!D2&!D1&!D&C1&C&B&!A1&!A|F&!E&!D2&!D1&!D&C1&!C&B&!A1&!A|F&E&!D2&!D1&!D&C1&!C&B&!A1&!A|F&E&D2&!D1&!D&C1&!C&B&!A1&!A|F&!E&D2&!D1&!D&C1&!C&B&!A1&!A|F&!E&D2&D1&!D&C1&!C&B&!A1&!A|F&E&D2&D1&!D&C1&!C&B&!A1&!A|F&E&!D2&D1&!D&C1&!C&B&!A1&!A|F&!E&!D2&D1&!D&C1&!C&B&!A1&!A|F&!E&!D2&D1&D&C1&!C&B&!A1&!A|F&E&!D2&D1&D&C1&!C&B&!A1&!A|F&E&D2&D1&D&C1&!C&B&!A1&!A|F&!E&D2&D1&D&C1&!C&B&!A1&!A|F&!E&D2&!D1&D&C1&!C&B&!A1&!A|F&E&D2&!D1&D&C1&!C&B&!A1&!A|F&E&!D2&!D1&D&C1&!C&B&!A1&!A|F&!E&!D2&!D1&D&C1&!C&B&!A1&!A|F&E&!D2&!D1&D&!C1&!C&B&!A1&!A|F&E&D2&!D1&D&!C1&!C&B&!A1&!A|F&!E&D2&D1&D&!C1&!C&B&!A1&!A|F&E&D2&D1&D&!C1&!C&B&!A1&!A|F&E&!D2&D1&D&!C1&!C&B&!A1&!A|F&E&!D2&D1&!D&!C1&!C&B&!A1&!A|F&E&D2&D1&!D&!C1&!C&B&!A1&!A|F&E&D2&!D1&!D&!C1&!C&B&!A1&!A|F&E&!D2&!D1&!D&!C1&!C&B&!A1&!A|F&E&!D2&!D1&!D&!C1&!C&B&A1&!A|F&E&D2&!D1&!D&!C1&!C&B&A1&!A|F&E&D2&D1&!D&!C1&!C&B&A1&!A|F&E&!D2&D1&!D&!C1&!C&B&A1&!A|F&E&!D2&D1&D&!C1&!C&B&A1&!A|F&E&D2&D1&D&!C1&!C&B&A1&!A|F&!E&D2&D1&D&!C1&!C&B&A1&!A|F&E&D2&!D1&D&!C1&!C&B&A1&!A|F&E&!D2&!D1&D&!C1&!C&B&A1&!A|F&!E&!D2&!D1&D&C1&!C&B&A1&!A|F&E&!D2&!D1&D&C1&!C&B&A1&!A|F&E&D2&!D1&D&C1&!C&B&A1&!A|F&!E&D2&!D1&D&C1&!C&B&A1&!A|F&!E&D2&D1&D&C1&!C&B&A1&!A|F&E&D2&D1&D&C1&!C&B&A1&!A|F&E&!D2&D1&D&C1&!C&B&A1&!A|F&!E&!D2&D1&D&C1&!C&B&A1&!A|F&!E&!D2&D1&!D&C1&!C&B&A1&!A|F&E&!D2&D1&!D&C1&!C&B&A1&!A|F&E&D2&D1&!D&C1&!C&B&A1&!A|F&!E&D2&D1&!D&C1&!C&B&A1&!A|F&!E&D2&!D1&!D&C1&!C&B&A1&!A|F&E&D2&!D1&!D&C1&!C&B&A1&!A|F&E&!D2&!D1&!D&C1&!C&B&A1&!A|F&!E&!D2&!D1&!D&C1&!C&B&A1&!A|F&!E&!D2&!D1&!D&C1&C&B&A1&!A|F&E&!D2&!D1&!D&C1&C&B&A1&!A|F&E&D2&!D1&!D&C1&C&B&A1&!A|F&!E&D2&!D1&!D&C1&C&B&A1&!A|F&!E&D2&D1&!D&C1&C&B&A1&!A|F&E&D2&D1&!D&C1&C&B&A1&!A|F&E&!D2&D1&!D&C1&C&B&A1&!A|F&!E&!D2&D1&!D&C1&C&B&A1&!A|F&!E&!D2&D1&D&C1&C&B&A1&!A|F&E&!D2&D1&D&C1&C&B&A1&!A|F&E&D2&D1&D&C1&C&B&A1&!A|F&!E&D2&D1&D&C1&C&B&A1&!A|F&!E&D2&!D1&D&C1&C&B&A1&!A|F&E&D2&!D1&D&C1&C&B&A1&!A|F&E&!D2&!D1&D&C1&C&B&A1&!A|F&!E&!D2&!D1&D&C1&C&B&A1&!A|F&!E&!D2&!D1&D&!C1&C&B&A1&!A|F&E&!D2&!D1&D&!C1&C&B&A1&!A|F&E&D2&!D1&D&!C1&C&B&A1&!A|F&!E&D2&!D1&D&!C1&C&B&A1&!A|F&!E&D2&D1&D&!C1&C&B&A1&!A|F&E&D2&D1&D&!C1&C&B&A1&!A|F&E&!D2&D1&D&!C1&C&B&A1&!A|F&!E&!D2&D1&D&!C1&C&B&A1&!A|F&!E&!D2&D1&!D&!C1&C&B&A1&!A|F&E&!D2&D1&!D&!C1&C&B&A1&!A|F&E&D2&D1&!D&!C1&C&B&A1&!A|F&!E&D2&D1&!D&!C1&C&B&A1&!A|F&!E&D2&!D1&!D&!C1&C&B&A1&!A|F&E&D2&!D1&!D&!C1&C&B&A1&!A|F&E&!D2&!D1&!D&!C1&C&B&A1&!A|F&!E&!D2&!D1&!D&!C1&C&B&A1&!A|F&E&!D2&!D1&!D&!C1&C&!B&A1&!A|F&E&D2&!D1&!D&!C1&C&!B&A1&!A|F&E&D2&D1&!D&!C1&C&!B&A1&!A|F&E&!D2&D1&!D&!C1&C&!B&A1&!A|F&E&!D2&D1&D&!C1&C&!B&A1&!A|F&E&D2&D1&D&!C1&C&!B&A1&!A|F&!E&D2&D1&D&!C1&C&!B&A1&!A|F&E&D2&!D1&D&!C1&C&!B&A1&!A|F&E&!D2&!D1&D&!C1&C&!B&A1&!A|F&E&!D2&!D1&D&C1&C&!B&A1&!A|F&E&D2&!D1&D&C1&C&!B&A1&!A|F&!E&D2&D1&D&C1&C&!B&A1&!A|F&E&D2&D1&D&C1&C&!B&A1&!A|F&E&!D2&D1&D&C1&C&!B&A1&!A|F&E&!D2&D1&!D&C1&C&!B&A1&!A|F&E&D2&D1&!D&C1&C&!B&A1&!A|F&E&D2&!D1&!D&C1&C&!B&A1&!A|F&E&!D2&!D1&!D&C1&C&!B&A1&!A|F&E&!D2&!D1&!D&C1&!C&!B&A1&!A|F&E&D2&!D1&!D&C1&!C&!B&A1&!A|F&E&D2&D1&!D&C1&!C&!B&A1&!A|F&E&!D2&D1&!D&C1&!C&!B&A1&!A|F&E&!D2&D1&D&C1&!C&!B&A1&!A|F&E&D2&D1&D&C1&!C&!B&A1&!A|F&!E&D2&D1&D&C1&!C&!B&A1&!A|F&E&D2&!D1&D&C1&!C&!B&A1&!A|F&E&!D2&!D1&D&C1&!C&!B&A1&!A|F&E&!D2&!D1&D&!C1&!C&!B&A1&!A|F&E&D2&!D1&D&!C1&!C&!B&A1&!A|F&!E&D2&D1&D&!C1&!C&!B&A1&!A|F&E&D2&D1&D&!C1&!C&!B&A1&!A|F&E&!D2&D1&D&!C1&!C&!B&A1&!A|F&E&!D2&D1&!D&!C1&!C&!B&A1&!A|F&E&D2&D1&!D&!C1&!C&!B&A1&!A|F&E&D2&!D1&!D&!C1&!C&!B&A1&!A|F&E&!D2&!D1&!D&!C1&!C&!B&A1&!A|F&E&!D2&!D1&!D&!C1&!C&!B&A1&A|F&E&D2&!D1&!D&!C1&!C&!B&A1&A|F&E&D2&D1&!D&!C1&!C&!B&A1&A|F&E&!D2&D1&!D&!C1&!C&!B&A1&A|F&E&!D2&D1&D&!C1&!C&!B&A1&A|F&E&D2&D1&D&!C1&!C&!B&A1&A|F&!E&D2&D1&D&!C1&!C&!B&A1&A|F&E&D2&!D1&D&!C1&!C&!B&A1&A|F&E&!D2&!D1&D&!C1&!C&!B&A1&A|F&!E&!D2&!D1&D&C1&!C&!B&A1&A|F&E&!D2&!D1&D&C1&!C&!B&A1&A|F&E&D2&!D1&D&C1&!C&!B&A1&A|F&!E&D2&!D1&D&C1&!C&!B&A1&A|F&!E&D2&D1&D&C1&!C&!B&A1&A|F&E&D2&D1&D&C1&!C&!B&A1&A|F&E&!D2&D1&D&C1&!C&!B&A1&A|F&!E&!D2&D1&D&C1&!C&!B&A1&A|F&!E&!D2&D1&!D&C1&!C&!B&A1&A|F&E&!D2&D1&!D&C1&!C&!B&A1&A|F&E&D2&D1&!D&C1&!C&!B&A1&A|F&!E&D2&D1&!D&C1&!C&!B&A1&A|F&!E&D2&!D1&!D&C1&!C&!B&A1&A|F&E&D2&!D1&!D&C1&!C&!B&A1&A|F&E&!D2&!D1&!D&C1&!C&!B&A1&A|F&!E&!D2&!D1&!D&C1&!C&!B&A1&A|F&!E&!D2&!D1&!D&C1&C&!B&A1&A|F&E&!D2&!D1&!D&C1&C&!B&A1&A|F&E&D2&!D1&!D&C1&C&!B&A1&A|F&!E&D2&!D1&!D&C1&C&!B&A1&A|F&!E&D2&D1&!D&C1&C&!B&A1&A|F&E&D2&D1&!D&C1&C&!B&A1&A|F&E&!D2&D1&!D&C1&C&!B&A1&A|F&!E&!D2&D1&!D&C1&C&!B&A1&A|F&!E&!D2&D1&D&C1&C&!B&A1&A|F&E&!D2&D1&D&C1&C&!B&A1&A|F&E&D2&D1&D&C1&C&!B&A1&A|F&!E&D2&D1&D&C1&C&!B&A1&A|F&!E&D2&!D1&D&C1&C&!B&A1&A|F&E&D2&!D1&D&C1&C&!B&A1&A|F&E&!D2&!D1&D&C1&C&!B&A1&A|F&!E&!D2&!D1&D&C1&C&!B&A1&A|F&!E&!D2&!D1&D&!C1&C&!B&A1&A|F&E&!D2&!D1&D&!C1&C&!B&A1&A|F&E&D2&!D1&D&!C1&C&!B&A1&A|F&!E&D2&!D1&D&!C1&C&!B&A1&A|F&!E&D2&D1&D&!C1&C&!B&A1&A|F&E&D2&D1&D&!C1&C&!B&A1&A|F&E&!D2&D1&D&!C1&C&!B&A1&A|F&!E&!D2&D1&D&!C1&C&!B&A1&A|F&!E&!D2&D1&!D&!C1&C&!B&A1&A|F&E&!D2&D1&!D&!C1&C&!B&A1&A|F&E&D2&D1&!D&!C1&C&!B&A1&A|F&!E&D2&D1&!D&!C1&C&!B&A1&A|F&!E&D2&!D1&!D&!C1&C&!B&A1&A|F&E&D2&!D1&!D&!C1&C&!B&A1&A|F&E&!D2&!D1&!D&!C1&C&!B&A1&A|F&!E&!D2&!D1&!D&!C1&C&!B&A1&A|F&!E&!D2&!D1&!D&!C1&C&B&A1&A|F&E&!D2&!D1&!D&!C1&C&B&A1&A|F&E&D2&!D1&!D&!C1&C&B&A1&A|F&!E&D2&!D1&!D&!C1&C&B&A1&A|F&!E&D2&D1&!D&!C1&C&B&A1&A|F&E&D2&D1&!D&!C1&C&B&A1&A|F&E&!D2&D1&!D&!C1&C&B&A1&A|F&!E&!D2&D1&!D&!C1&C&B&A1&A|F&!E&!D2&D1&D&!C1&C&B&A1&A|F&E&!D2&D1&D&!C1&C&B&A1&A|F&E&D2&D1&D&!C1&C&B&A1&A|F&!E&D2&D1&D&!C1&C&B&A1&A|F&!E&D2&!D1&D&!C1&C&B&A1&A|F&E&D2&!D1&D&!C1&C&B&A1&A|F&E&!D2&!D1&D&!C1&C&B&A1&A|F&!E&!D2&!D1&D&!C1&C&B&A1&A|F&!E&!D2&!D1&D&C1&C&B&A1&A|F&E&!D2&!D1&D&C1&C&B&A1&A|F&E&D2&!D1&D&C1&C&B&A1&A|F&!E&D2&!D1&D&C1&C&B&A1&A|F&!E&D2&D1&D&C1&C&B&A1&A|F&E&D2&D1&D&C1&C&B&A1&A|F&E&!D2&D1&D&C1&C&B&A1&A|F&!E&!D2&D1&D&C1&C&B&A1&A|F&!E&!D2&D1&!D&C1&C&B&A1&A|F&E&!D2&D1&!D&C1&C&B&A1&A|F&E&D2&D1&!D&C1&C&B&A1&A|F&!E&D2&D1&!D&C1&C&B&A1&A|F&!E&D2&!D1&!D&C1&C&B&A1&A|F&E&D2&!D1&!D&C1&C&B&A1&A|F&E&!D2&!D1&!D&C1&C&B&A1&A|F&!E&!D2&!D1&!D&C1&C&B&A1&A|F&!E&!D2&!D1&!D&C1&!C&B&A1&A|F&E&!D2&!D1&!D&C1&!C&B&A1&A|F&E&D2&!D1&!D&C1&!C&B&A1&A|F&!E&D2&!D1&!D&C1&!C&B&A1&A|F&!E&D2&D1&!D&C1&!C&B&A1&A|F&E&D2&D1&!D&C1&!C&B&A1&A|F&E&!D2&D1&!D&C1&!C&B&A1&A|F&!E&!D2&D1&!D&C1&!C&B&A1&A|F&!E&!D2&D1&D&C1&!C&B&A1&A|F&E&!D2&D1&D&C1&!C&B&A1&A|F&E&D2&D1&D&C1&!C&B&A1&A|F&!E&D2&D1&D&C1&!C&B&A1&A|F&!E&D2&!D1&D&C1&!C&B&A1&A|F&E&D2&!D1&D&C1&!C&B&A1&A|F&E&!D2&!D1&D&C1&!C&B&A1&A|F&!E&!D2&!D1&D&C1&!C&B&A1&A|F&E&!D2&!D1&D&!C1&!C&B&A1&A|F&E&D2&!D1&D&!C1&!C&B&A1&A|F&!E&D2&D1&D&!C1&!C&B&A1&A|F&E&D2&D1&D&!C1&!C&B&A1&A|F&E&!D2&D1&D&!C1&!C&B&A1&A|F&E&!D2&D1&!D&!C1&!C&B&A1&A|F&E&D2&D1&!D&!C1&!C&B&A1&A|F&E&D2&!D1&!D&!C1&!C&B&A1&A|F&E&!D2&!D1&!D&!C1&!C&B&A1&A|F&E&!D2&!D1&!D&!C1&!C&B&!A1&A|F&E&D2&!D1&!D&!C1&!C&B&!A1&A|F&E&D2&D1&!D&!C1&!C&B&!A1&A|F&E&!D2&D1&!D&!C1&!C&B&!A1&A|F&E&!D2&D1&D&!C1&!C&B&!A1&A|F&E&D2&D1&D&!C1&!C&B&!A1&A|F&!E&D2&D1&D&!C1&!C&B&!A1&A|F&E&D2&!D1&D&!C1&!C&B&!A1&A|F&E&!D2&!D1&D&!C1&!C&B&!A1&A|F&!E&!D2&!D1&D&C1&!C&B&!A1&A|F&E&!D2&!D1&D&C1&!C&B&!A1&A|F&E&D2&!D1&D&C1&!C&B&!A1&A|F&!E&D2&!D1&D&C1&!C&B&!A1&A|F&!E&D2&D1&D&C1&!C&B&!A1&A|F&E&D2&D1&D&C1&!C&B&!A1&A|F&E&!D2&D1&D&C1&!C&B&!A1&A|F&!E&!D2&D1&D&C1&!C&B&!A1&A|F&!E&!D2&D1&!D&C1&!C&B&!A1&A|F&E&!D2&D1&!D&C1&!C&B&!A1&A|F&E&D2&D1&!D&C1&!C&B&!A1&A|F&!E&D2&D1&!D&C1&!C&B&!A1&A|F&!E&D2&!D1&!D&C1&!C&B&!A1&A|F&E&D2&!D1&!D&C1&!C&B&!A1&A|F&E&!D2&!D1&!D&C1&!C&B&!A1&A|F&!E&!D2&!D1&!D&C1&!C&B&!A1&A|F&!E&!D2&!D1&!D&C1&C&B&!A1&A|F&E&!D2&!D1&!D&C1&C&B&!A1&A|F&E&D2&!D1&!D&C1&C&B&!A1&A|F&!E&D2&!D1&!D&C1&C&B&!A1&A|F&!E&D2&D1&!D&C1&C&B&!A1&A|F&E&D2&D1&!D&C1&C&B&!A1&A|F&E&!D2&D1&!D&C1&C&B&!A1&A|F&!E&!D2&D1&!D&C1&C&B&!A1&A|F&!E&!D2&D1&D&C1&C&B&!A1&A|F&E&!D2&D1&D&C1&C&B&!A1&A|F&E&D2&D1&D&C1&C&B&!A1&A|F&!E&D2&D1&D&C1&C&B&!A1&A|F&!E&D2&!D1&D&C1&C&B&!A1&A|F&E&D2&!D1&D&C1&C&B&!A1&A|F&E&!D2&!D1&D&C1&C&B&!A1&A|F&!E&!D2&!D1&D&C1&C&B&!A1&A|F&!E&!D2&!D1&D&!C1&C&B&!A1&A|F&E&!D2&!D1&D&!C1&C&B&!A1&A|F&E&D2&!D1&D&!C1&C&B&!A1&A|F&!E&D2&!D1&D&!C1&C&B&!A1&A|F&!E&D2&D1&D&!C1&C&B&!A1&A|F&E&D2&D1&D&!C1&C&B&!A1&A|F&E&!D2&D1&D&!C1&C&B&!A1&A|F&!E&!D2&D1&D&!C1&C&B&!A1&A|F&!E&!D2&D1&!D&!C1&C&B&!A1&A|F&E&!D2&D1&!D&!C1&C&B&!A1&A|F&E&D2&D1&!D&!C1&C&B&!A1&A|F&!E&D2&D1&!D&!C1&C&B&!A1&A|F&!E&D2&!D1&!D&!C1&C&B&!A1&A|F&E&D2&!D1&!D&!C1&C&B&!A1&A|F&E&!D2&!D1&!D&!C1&C&B&!A1&A|F&!E&!D2&!D1&!D&!C1&C&B&!A1&A|F&E&!D2&!D1&!D&!C1&C&!B&!A1&A|F&E&D2&!D1&!D&!C1&C&!B&!A1&A|F&E&D2&D1&!D&!C1&C&!B&!A1&A|F&E&!D2&D1&!D&!C1&C&!B&!A1&A|F&E&!D2&D1&D&!C1&C&!B&!A1&A|F&E&D2&D1&D&!C1&C&!B&!A1&A|F&!E&D2&D1&D&!C1&C&!B&!A1&A|F&E&D2&!D1&D&!C1&C&!B&!A1&A|F&E&!D2&!D1&D&!C1&C&!B&!A1&A|F&E&!D2&!D1&D&C1&C&!B&!A1&A|F&E&D2&!D1&D&C1&C&!B&!A1&A|F&!E&D2&D1&D&C1&C&!B&!A1&A|F&E&D2&D1&D&C1&C&!B&!A1&A|F&E&!D2&D1&D&C1&C&!B&!A1&A|F&E&!D2&D1&!D&C1&C&!B&!A1&A|F&E&D2&D1&!D&C1&C&!B&!A1&A|F&E&D2&!D1&!D&C1&C&!B&!A1&A|F&E&!D2&!D1&!D&C1&C&!B&!A1&A|F&E&!D2&!D1&!D&C1&!C&!B&!A1&A|F&E&D2&!D1&!D&C1&!C&!B&!A1&A|F&E&D2&D1&!D&C1&!C&!B&!A1&A|F&E&!D2&D1&!D&C1&!C&!B&!A1&A|F&E&!D2&D1&D&C1&!C&!B&!A1&A|F&E&D2&D1&D&C1&!C&!B&!A1&A|F&!E&D2&D1&D&C1&!C&!B&!A1&A|F&E&D2&!D1&D&C1&!C&!B&!A1&A|F&E&!D2&!D1&D&C1&!C&!B&!A1&A|F&E&!D2&!D1&D&!C1&!C&!B&!A1&A|F&E&D2&!D1&D&!C1&!C&!B&!A1&A|F&!E&D2&D1&D&!C1&!C&!B&!A1&A|F&E&D2&D1&D&!C1&!C&!B&!A1&A|F&E&!D2&D1&D&!C1&!C&!B&!A1&A|F&E&!D2&D1&!D&!C1&!C&!B&!A1&A|F&E&D2&D1&!D&!C1&!C&!B&!A1&A|F&E&D2&!D1&!D&!C1&!C&!B&!A1&A|F&E&!D2&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOAI212311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAAOAI211221 -l AOAAAOAI211221 -i F E1 E D1 D C B A1 A -o Y -f Y=!(F&E1&E&!D1&!D&!C&!B&!A1&!A|F&E1&E&D1&!D&!C&!B&!A1&!A|F&!E1&!E&D1&D&!C&!B&!A1&!A|F&E1&!E&D1&D&!C&!B&!A1&!A|F&E1&E&D1&D&!C&!B&!A1&!A|F&!E1&E&D1&D&!C&!B&!A1&!A|F&E1&E&!D1&D&!C&!B&!A1&!A|F&E1&E&!D1&D&C&!B&!A1&!A|F&!E1&E&D1&D&C&!B&!A1&!A|F&E1&E&D1&D&C&!B&!A1&!A|F&E1&!E&D1&D&C&!B&!A1&!A|F&!E1&!E&D1&D&C&!B&!A1&!A|F&E1&E&D1&!D&C&!B&!A1&!A|F&E1&E&!D1&!D&C&!B&!A1&!A|F&!E1&!E&!D1&!D&C&B&!A1&!A|F&E1&!E&!D1&!D&C&B&!A1&!A|F&E1&E&!D1&!D&C&B&!A1&!A|F&!E1&E&!D1&!D&C&B&!A1&!A|F&!E1&E&D1&!D&C&B&!A1&!A|F&E1&E&D1&!D&C&B&!A1&!A|F&E1&!E&D1&!D&C&B&!A1&!A|F&!E1&!E&D1&!D&C&B&!A1&!A|F&!E1&!E&D1&D&C&B&!A1&!A|F&E1&!E&D1&D&C&B&!A1&!A|F&E1&E&D1&D&C&B&!A1&!A|F&!E1&E&D1&D&C&B&!A1&!A|F&!E1&E&!D1&D&C&B&!A1&!A|F&E1&E&!D1&D&C&B&!A1&!A|F&E1&!E&!D1&D&C&B&!A1&!A|F&!E1&!E&!D1&D&C&B&!A1&!A|F&E1&E&!D1&D&!C&B&!A1&!A|F&!E1&E&D1&D&!C&B&!A1&!A|F&E1&E&D1&D&!C&B&!A1&!A|F&E1&!E&D1&D&!C&B&!A1&!A|F&!E1&!E&D1&D&!C&B&!A1&!A|F&E1&E&D1&!D&!C&B&!A1&!A|F&E1&E&!D1&!D&!C&B&!A1&!A|F&E1&E&!D1&!D&!C&B&A1&!A|F&E1&E&D1&!D&!C&B&A1&!A|F&!E1&!E&D1&D&!C&B&A1&!A|F&E1&!E&D1&D&!C&B&A1&!A|F&E1&E&D1&D&!C&B&A1&!A|F&!E1&E&D1&D&!C&B&A1&!A|F&E1&E&!D1&D&!C&B&A1&!A|F&!E1&!E&!D1&D&C&B&A1&!A|F&E1&!E&!D1&D&C&B&A1&!A|F&E1&E&!D1&D&C&B&A1&!A|F&!E1&E&!D1&D&C&B&A1&!A|F&!E1&E&D1&D&C&B&A1&!A|F&E1&E&D1&D&C&B&A1&!A|F&E1&!E&D1&D&C&B&A1&!A|F&!E1&!E&D1&D&C&B&A1&!A|F&!E1&!E&D1&!D&C&B&A1&!A|F&E1&!E&D1&!D&C&B&A1&!A|F&E1&E&D1&!D&C&B&A1&!A|F&!E1&E&D1&!D&C&B&A1&!A|F&!E1&E&!D1&!D&C&B&A1&!A|F&E1&E&!D1&!D&C&B&A1&!A|F&E1&!E&!D1&!D&C&B&A1&!A|F&!E1&!E&!D1&!D&C&B&A1&!A|F&E1&E&!D1&!D&C&!B&A1&!A|F&E1&E&D1&!D&C&!B&A1&!A|F&!E1&!E&D1&D&C&!B&A1&!A|F&E1&!E&D1&D&C&!B&A1&!A|F&E1&E&D1&D&C&!B&A1&!A|F&!E1&E&D1&D&C&!B&A1&!A|F&E1&E&!D1&D&C&!B&A1&!A|F&E1&E&!D1&D&!C&!B&A1&!A|F&!E1&E&D1&D&!C&!B&A1&!A|F&E1&E&D1&D&!C&!B&A1&!A|F&E1&!E&D1&D&!C&!B&A1&!A|F&!E1&!E&D1&D&!C&!B&A1&!A|F&E1&E&D1&!D&!C&!B&A1&!A|F&E1&E&!D1&!D&!C&!B&A1&!A|F&E1&E&!D1&!D&!C&!B&A1&A|F&E1&E&D1&!D&!C&!B&A1&A|F&!E1&!E&D1&D&!C&!B&A1&A|F&E1&!E&D1&D&!C&!B&A1&A|F&E1&E&D1&D&!C&!B&A1&A|F&!E1&E&D1&D&!C&!B&A1&A|F&E1&E&!D1&D&!C&!B&A1&A|F&!E1&!E&!D1&D&C&!B&A1&A|F&E1&!E&!D1&D&C&!B&A1&A|F&E1&E&!D1&D&C&!B&A1&A|F&!E1&E&!D1&D&C&!B&A1&A|F&!E1&E&D1&D&C&!B&A1&A|F&E1&E&D1&D&C&!B&A1&A|F&E1&!E&D1&D&C&!B&A1&A|F&!E1&!E&D1&D&C&!B&A1&A|F&!E1&!E&D1&!D&C&!B&A1&A|F&E1&!E&D1&!D&C&!B&A1&A|F&E1&E&D1&!D&C&!B&A1&A|F&!E1&E&D1&!D&C&!B&A1&A|F&!E1&E&!D1&!D&C&!B&A1&A|F&E1&E&!D1&!D&C&!B&A1&A|F&E1&!E&!D1&!D&C&!B&A1&A|F&!E1&!E&!D1&!D&C&!B&A1&A|F&!E1&!E&!D1&!D&C&B&A1&A|F&E1&!E&!D1&!D&C&B&A1&A|F&E1&E&!D1&!D&C&B&A1&A|F&!E1&E&!D1&!D&C&B&A1&A|F&!E1&E&D1&!D&C&B&A1&A|F&E1&E&D1&!D&C&B&A1&A|F&E1&!E&D1&!D&C&B&A1&A|F&!E1&!E&D1&!D&C&B&A1&A|F&!E1&!E&D1&D&C&B&A1&A|F&E1&!E&D1&D&C&B&A1&A|F&E1&E&D1&D&C&B&A1&A|F&!E1&E&D1&D&C&B&A1&A|F&!E1&E&!D1&D&C&B&A1&A|F&E1&E&!D1&D&C&B&A1&A|F&E1&!E&!D1&D&C&B&A1&A|F&!E1&!E&!D1&D&C&B&A1&A|F&E1&E&!D1&D&!C&B&A1&A|F&!E1&E&D1&D&!C&B&A1&A|F&E1&E&D1&D&!C&B&A1&A|F&E1&!E&D1&D&!C&B&A1&A|F&!E1&!E&D1&D&!C&B&A1&A|F&E1&E&D1&!D&!C&B&A1&A|F&E1&E&!D1&!D&!C&B&A1&A|F&E1&E&!D1&!D&!C&B&!A1&A|F&E1&E&D1&!D&!C&B&!A1&A|F&!E1&!E&D1&D&!C&B&!A1&A|F&E1&!E&D1&D&!C&B&!A1&A|F&E1&E&D1&D&!C&B&!A1&A|F&!E1&E&D1&D&!C&B&!A1&A|F&E1&E&!D1&D&!C&B&!A1&A|F&!E1&!E&!D1&D&C&B&!A1&A|F&E1&!E&!D1&D&C&B&!A1&A|F&E1&E&!D1&D&C&B&!A1&A|F&!E1&E&!D1&D&C&B&!A1&A|F&!E1&E&D1&D&C&B&!A1&A|F&E1&E&D1&D&C&B&!A1&A|F&E1&!E&D1&D&C&B&!A1&A|F&!E1&!E&D1&D&C&B&!A1&A|F&!E1&!E&D1&!D&C&B&!A1&A|F&E1&!E&D1&!D&C&B&!A1&A|F&E1&E&D1&!D&C&B&!A1&A|F&!E1&E&D1&!D&C&B&!A1&A|F&!E1&E&!D1&!D&C&B&!A1&A|F&E1&E&!D1&!D&C&B&!A1&A|F&E1&!E&!D1&!D&C&B&!A1&A|F&!E1&!E&!D1&!D&C&B&!A1&A|F&E1&E&!D1&!D&C&!B&!A1&A|F&E1&E&D1&!D&C&!B&!A1&A|F&!E1&!E&D1&D&C&!B&!A1&A|F&E1&!E&D1&D&C&!B&!A1&A|F&E1&E&D1&D&C&!B&!A1&A|F&!E1&E&D1&D&C&!B&!A1&A|F&E1&E&!D1&D&C&!B&!A1&A|F&E1&E&!D1&D&!C&!B&!A1&A|F&!E1&E&D1&D&!C&!B&!A1&A|F&E1&E&D1&D&!C&!B&!A1&A|F&E1&!E&D1&D&!C&!B&!A1&A|F&!E1&!E&D1&D&!C&!B&!A1&A|F&E1&E&D1&!D&!C&!B&!A1&A|F&E1&E&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAAOAI211221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOAI22121 -l OOAAOAI22121 -i E D1 D C B1 B A1 A -o Y -f Y=!(E&D1&D&!C&!B1&!B&!A1&!A|E&D1&D&C&!B1&!B&!A1&!A|E&D1&D&C&B1&!B&!A1&!A|E&D1&D&!C&B1&!B&!A1&!A|E&D1&D&!C&B1&B&!A1&!A|E&D1&D&C&B1&B&!A1&!A|E&D1&D&C&!B1&B&!A1&!A|E&D1&D&!C&!B1&B&!A1&!A|E&D1&D&!C&!B1&B&A1&!A|E&!D1&D&C&!B1&B&A1&!A|E&D1&D&C&!B1&B&A1&!A|E&D1&!D&C&!B1&B&A1&!A|E&!D1&!D&C&!B1&B&A1&!A|E&!D1&!D&C&B1&B&A1&!A|E&D1&!D&C&B1&B&A1&!A|E&D1&D&C&B1&B&A1&!A|E&!D1&D&C&B1&B&A1&!A|E&D1&D&!C&B1&B&A1&!A|E&D1&D&!C&B1&!B&A1&!A|E&!D1&D&C&B1&!B&A1&!A|E&D1&D&C&B1&!B&A1&!A|E&D1&!D&C&B1&!B&A1&!A|E&!D1&!D&C&B1&!B&A1&!A|E&D1&D&C&!B1&!B&A1&!A|E&D1&D&!C&!B1&!B&A1&!A|E&D1&D&!C&!B1&!B&A1&A|E&D1&D&C&!B1&!B&A1&A|E&!D1&!D&C&B1&!B&A1&A|E&D1&!D&C&B1&!B&A1&A|E&D1&D&C&B1&!B&A1&A|E&!D1&D&C&B1&!B&A1&A|E&D1&D&!C&B1&!B&A1&A|E&D1&D&!C&B1&B&A1&A|E&!D1&D&C&B1&B&A1&A|E&D1&D&C&B1&B&A1&A|E&D1&!D&C&B1&B&A1&A|E&!D1&!D&C&B1&B&A1&A|E&!D1&!D&C&!B1&B&A1&A|E&D1&!D&C&!B1&B&A1&A|E&D1&D&C&!B1&B&A1&A|E&!D1&D&C&!B1&B&A1&A|E&D1&D&!C&!B1&B&A1&A|E&D1&D&!C&!B1&B&!A1&A|E&!D1&D&C&!B1&B&!A1&A|E&D1&D&C&!B1&B&!A1&A|E&D1&!D&C&!B1&B&!A1&A|E&!D1&!D&C&!B1&B&!A1&A|E&!D1&!D&C&B1&B&!A1&A|E&D1&!D&C&B1&B&!A1&A|E&D1&D&C&B1&B&!A1&A|E&!D1&D&C&B1&B&!A1&A|E&D1&D&!C&B1&B&!A1&A|E&D1&D&!C&B1&!B&!A1&A|E&!D1&D&C&B1&!B&!A1&A|E&D1&D&C&B1&!B&!A1&A|E&D1&!D&C&B1&!B&!A1&A|E&!D1&!D&C&B1&!B&!A1&A|E&D1&D&C&!B1&!B&!A1&A|E&D1&D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOAI22121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAI313 -l AOOAI313 -i C2 C1 C B A2 A1 A -o Y -f Y=!(!C2&!C1&C&B&!A2&!A1&!A|C2&!C1&C&B&!A2&!A1&!A|C2&C1&C&B&!A2&!A1&!A|!C2&C1&C&B&!A2&!A1&!A|!C2&C1&!C&B&!A2&!A1&!A|C2&C1&!C&B&!A2&!A1&!A|C2&!C1&!C&B&!A2&!A1&!A|C2&!C1&!C&B&A2&!A1&!A|C2&C1&!C&B&A2&!A1&!A|!C2&C1&!C&B&A2&!A1&!A|!C2&C1&C&B&A2&!A1&!A|C2&C1&C&B&A2&!A1&!A|C2&!C1&C&B&A2&!A1&!A|!C2&!C1&C&B&A2&!A1&!A|!C2&!C1&C&B&A2&A1&!A|C2&!C1&C&B&A2&A1&!A|C2&C1&C&B&A2&A1&!A|!C2&C1&C&B&A2&A1&!A|!C2&C1&!C&B&A2&A1&!A|C2&C1&!C&B&A2&A1&!A|C2&!C1&!C&B&A2&A1&!A|C2&!C1&!C&B&!A2&A1&!A|C2&C1&!C&B&!A2&A1&!A|!C2&C1&!C&B&!A2&A1&!A|!C2&C1&C&B&!A2&A1&!A|C2&C1&C&B&!A2&A1&!A|C2&!C1&C&B&!A2&A1&!A|!C2&!C1&C&B&!A2&A1&!A|!C2&!C1&C&B&!A2&A1&A|C2&!C1&C&B&!A2&A1&A|C2&C1&C&B&!A2&A1&A|!C2&C1&C&B&!A2&A1&A|!C2&C1&!C&B&!A2&A1&A|C2&C1&!C&B&!A2&A1&A|C2&!C1&!C&B&!A2&A1&A|C2&!C1&!C&B&A2&A1&A|C2&C1&!C&B&A2&A1&A|!C2&C1&!C&B&A2&A1&A|!C2&C1&C&B&A2&A1&A|C2&C1&C&B&A2&A1&A|C2&!C1&C&B&A2&A1&A|!C2&!C1&C&B&A2&A1&A|!C2&!C1&C&!B&A2&A1&A|C2&!C1&C&!B&A2&A1&A|C2&C1&C&!B&A2&A1&A|!C2&C1&C&!B&A2&A1&A|!C2&C1&!C&!B&A2&A1&A|C2&C1&!C&!B&A2&A1&A|C2&!C1&!C&!B&A2&A1&A|!C2&!C1&C&B&A2&!A1&A|C2&!C1&C&B&A2&!A1&A|C2&C1&C&B&A2&!A1&A|!C2&C1&C&B&A2&!A1&A|!C2&C1&!C&B&A2&!A1&A|C2&C1&!C&B&A2&!A1&A|C2&!C1&!C&B&A2&!A1&A|C2&!C1&!C&B&!A2&!A1&A|C2&C1&!C&B&!A2&!A1&A|!C2&C1&!C&B&!A2&!A1&A|!C2&C1&C&B&!A2&!A1&A|C2&C1&C&B&!A2&!A1&A|C2&!C1&C&B&!A2&!A1&A|!C2&!C1&C&B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAI313.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOAOI21241 -l OAAOOAOI21241 -i E D3 D2 D1 D C1 C B A1 A -o Y -f Z=!(!E&!D3&!D2&!D1&!D&!C1&!C&!B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&!B&!A1&!A|!E&D3&D2&!D1&!D&!C1&!C&!B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&!B&!A1&!A|!E&!D3&D2&D1&!D&!C1&!C&!B&!A1&!A|!E&D3&D2&D1&!D&!C1&!C&!B&!A1&!A|!E&D3&!D2&D1&!D&!C1&!C&!B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&!B&!A1&!A|!E&!D3&!D2&D1&D&!C1&!C&!B&!A1&!A|!E&D3&!D2&D1&D&!C1&!C&!B&!A1&!A|!E&D3&D2&D1&D&!C1&!C&!B&!A1&!A|!E&!D3&D2&D1&D&!C1&!C&!B&!A1&!A|!E&!D3&D2&!D1&D&!C1&!C&!B&!A1&!A|!E&D3&D2&!D1&D&!C1&!C&!B&!A1&!A|!E&D3&!D2&!D1&D&!C1&!C&!B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&!B&!A1&!A|!E&!D3&!D2&!D1&D&C1&!C&!B&!A1&!A|!E&D3&!D2&!D1&D&C1&!C&!B&!A1&!A|!E&D3&D2&!D1&D&C1&!C&!B&!A1&!A|!E&!D3&D2&!D1&D&C1&!C&!B&!A1&!A|!E&!D3&D2&D1&D&C1&!C&!B&!A1&!A|!E&D3&D2&D1&D&C1&!C&!B&!A1&!A|!E&D3&!D2&D1&D&C1&!C&!B&!A1&!A|!E&!D3&!D2&D1&D&C1&!C&!B&!A1&!A|!E&!D3&!D2&D1&!D&C1&!C&!B&!A1&!A|!E&D3&!D2&D1&!D&C1&!C&!B&!A1&!A|!E&D3&D2&D1&!D&C1&!C&!B&!A1&!A|!E&!D3&D2&D1&!D&C1&!C&!B&!A1&!A|!E&!D3&D2&!D1&!D&C1&!C&!B&!A1&!A|!E&D3&D2&!D1&!D&C1&!C&!B&!A1&!A|!E&D3&!D2&!D1&!D&C1&!C&!B&!A1&!A|!E&!D3&!D2&!D1&!D&C1&!C&!B&!A1&!A|!E&!D3&!D2&!D1&!D&C1&C&!B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&C&!B&!A1&!A|!E&D3&!D2&!D1&D&!C1&C&!B&!A1&!A|!E&D3&D2&!D1&D&!C1&C&!B&!A1&!A|!E&!D3&D2&!D1&D&!C1&C&!B&!A1&!A|!E&!D3&D2&D1&D&!C1&C&!B&!A1&!A|!E&D3&D2&D1&D&!C1&C&!B&!A1&!A|!E&D3&!D2&D1&D&!C1&C&!B&!A1&!A|!E&!D3&!D2&D1&D&!C1&C&!B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&C&!B&!A1&!A|!E&D3&!D2&D1&!D&!C1&C&!B&!A1&!A|!E&D3&D2&D1&!D&!C1&C&!B&!A1&!A|!E&!D3&D2&D1&!D&!C1&C&!B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&C&!B&!A1&!A|!E&D3&D2&!D1&!D&!C1&C&!B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&C&!B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&C&!B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&C&B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&C&B&!A1&!A|!E&D3&D2&!D1&!D&!C1&C&B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&C&B&!A1&!A|!E&!D3&D2&D1&!D&!C1&C&B&!A1&!A|!E&D3&D2&D1&!D&!C1&C&B&!A1&!A|!E&D3&!D2&D1&!D&!C1&C&B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&C&B&!A1&!A|!E&!D3&!D2&D1&D&!C1&C&B&!A1&!A|!E&D3&!D2&D1&D&!C1&C&B&!A1&!A|!E&D3&D2&D1&D&!C1&C&B&!A1&!A|!E&!D3&D2&D1&D&!C1&C&B&!A1&!A|!E&!D3&D2&!D1&D&!C1&C&B&!A1&!A|!E&D3&D2&!D1&D&!C1&C&B&!A1&!A|!E&D3&!D2&!D1&D&!C1&C&B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&C&B&!A1&!A|!E&!D3&!D2&!D1&!D&C1&C&B&!A1&!A|!E&!D3&!D2&!D1&!D&C1&!C&B&!A1&!A|!E&D3&!D2&!D1&!D&C1&!C&B&!A1&!A|!E&D3&D2&!D1&!D&C1&!C&B&!A1&!A|!E&!D3&D2&!D1&!D&C1&!C&B&!A1&!A|!E&!D3&D2&D1&!D&C1&!C&B&!A1&!A|!E&D3&D2&D1&!D&C1&!C&B&!A1&!A|!E&D3&!D2&D1&!D&C1&!C&B&!A1&!A|!E&!D3&!D2&D1&!D&C1&!C&B&!A1&!A|!E&!D3&!D2&D1&D&C1&!C&B&!A1&!A|!E&D3&!D2&D1&D&C1&!C&B&!A1&!A|!E&D3&D2&D1&D&C1&!C&B&!A1&!A|!E&!D3&D2&D1&D&C1&!C&B&!A1&!A|!E&!D3&D2&!D1&D&C1&!C&B&!A1&!A|!E&D3&D2&!D1&D&C1&!C&B&!A1&!A|!E&D3&!D2&!D1&D&C1&!C&B&!A1&!A|!E&!D3&!D2&!D1&D&C1&!C&B&!A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&B&!A1&!A|!E&D3&!D2&!D1&D&!C1&!C&B&!A1&!A|!E&D3&D2&!D1&D&!C1&!C&B&!A1&!A|!E&!D3&D2&!D1&D&!C1&!C&B&!A1&!A|!E&!D3&D2&D1&D&!C1&!C&B&!A1&!A|!E&D3&D2&D1&D&!C1&!C&B&!A1&!A|!E&D3&!D2&D1&D&!C1&!C&B&!A1&!A|!E&!D3&!D2&D1&D&!C1&!C&B&!A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&B&!A1&!A|!E&D3&!D2&D1&!D&!C1&!C&B&!A1&!A|!E&D3&D2&D1&!D&!C1&!C&B&!A1&!A|!E&!D3&D2&D1&!D&!C1&!C&B&!A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&B&!A1&!A|!E&D3&D2&!D1&!D&!C1&!C&B&!A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&B&!A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&B&A1&!A|!E&!D3&!D2&!D1&!D&C1&!C&B&A1&!A|!E&!D3&!D2&!D1&!D&C1&C&B&A1&!A|!E&!D3&!D2&!D1&!D&!C1&C&B&A1&!A|!E&!D3&!D2&!D1&!D&!C1&C&!B&A1&!A|!E&D3&!D2&!D1&!D&!C1&C&!B&A1&!A|!E&D3&D2&!D1&!D&!C1&C&!B&A1&!A|!E&!D3&D2&!D1&!D&!C1&C&!B&A1&!A|!E&!D3&D2&D1&!D&!C1&C&!B&A1&!A|!E&D3&D2&D1&!D&!C1&C&!B&A1&!A|!E&D3&!D2&D1&!D&!C1&C&!B&A1&!A|!E&!D3&!D2&D1&!D&!C1&C&!B&A1&!A|!E&!D3&!D2&D1&D&!C1&C&!B&A1&!A|!E&D3&!D2&D1&D&!C1&C&!B&A1&!A|!E&D3&D2&D1&D&!C1&C&!B&A1&!A|!E&!D3&D2&D1&D&!C1&C&!B&A1&!A|!E&!D3&D2&!D1&D&!C1&C&!B&A1&!A|!E&D3&D2&!D1&D&!C1&C&!B&A1&!A|!E&D3&!D2&!D1&D&!C1&C&!B&A1&!A|!E&!D3&!D2&!D1&D&!C1&C&!B&A1&!A|!E&!D3&!D2&!D1&!D&C1&C&!B&A1&!A|!E&!D3&!D2&!D1&!D&C1&!C&!B&A1&!A|!E&D3&!D2&!D1&!D&C1&!C&!B&A1&!A|!E&D3&D2&!D1&!D&C1&!C&!B&A1&!A|!E&!D3&D2&!D1&!D&C1&!C&!B&A1&!A|!E&!D3&D2&D1&!D&C1&!C&!B&A1&!A|!E&D3&D2&D1&!D&C1&!C&!B&A1&!A|!E&D3&!D2&D1&!D&C1&!C&!B&A1&!A|!E&!D3&!D2&D1&!D&C1&!C&!B&A1&!A|!E&!D3&!D2&D1&D&C1&!C&!B&A1&!A|!E&D3&!D2&D1&D&C1&!C&!B&A1&!A|!E&D3&D2&D1&D&C1&!C&!B&A1&!A|!E&!D3&D2&D1&D&C1&!C&!B&A1&!A|!E&!D3&D2&!D1&D&C1&!C&!B&A1&!A|!E&D3&D2&!D1&D&C1&!C&!B&A1&!A|!E&D3&!D2&!D1&D&C1&!C&!B&A1&!A|!E&!D3&!D2&!D1&D&C1&!C&!B&A1&!A|!E&!D3&!D2&!D1&D&!C1&!C&!B&A1&!A|!E&D3&!D2&!D1&D&!C1&!C&!B&A1&!A|!E&D3&D2&!D1&D&!C1&!C&!B&A1&!A|!E&!D3&D2&!D1&D&!C1&!C&!B&A1&!A|!E&!D3&D2&D1&D&!C1&!C&!B&A1&!A|!E&D3&D2&D1&D&!C1&!C&!B&A1&!A|!E&D3&!D2&D1&D&!C1&!C&!B&A1&!A|!E&!D3&!D2&D1&D&!C1&!C&!B&A1&!A|!E&!D3&!D2&D1&!D&!C1&!C&!B&A1&!A|!E&D3&!D2&D1&!D&!C1&!C&!B&A1&!A|!E&D3&D2&D1&!D&!C1&!C&!B&A1&!A|!E&!D3&D2&D1&!D&!C1&!C&!B&A1&!A|!E&!D3&D2&!D1&!D&!C1&!C&!B&A1&!A|!E&D3&D2&!D1&!D&!C1&!C&!B&A1&!A|!E&D3&!D2&!D1&!D&!C1&!C&!B&A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&!B&A1&!A|!E&!D3&!D2&!D1&!D&!C1&!C&!B&A1&A|!E&D3&!D2&!D1&!D&!C1&!C&!B&A1&A|!E&D3&D2&!D1&!D&!C1&!C&!B&A1&A|!E&!D3&D2&!D1&!D&!C1&!C&!B&A1&A|!E&!D3&D2&D1&!D&!C1&!C&!B&A1&A|!E&D3&D2&D1&!D&!C1&!C&!B&A1&A|!E&D3&!D2&D1&!D&!C1&!C&!B&A1&A|!E&!D3&!D2&D1&!D&!C1&!C&!B&A1&A|!E&!D3&!D2&D1&D&!C1&!C&!B&A1&A|!E&D3&!D2&D1&D&!C1&!C&!B&A1&A|!E&D3&D2&D1&D&!C1&!C&!B&A1&A|!E&!D3&D2&D1&D&!C1&!C&!B&A1&A|!E&!D3&D2&!D1&D&!C1&!C&!B&A1&A|!E&D3&D2&!D1&D&!C1&!C&!B&A1&A|!E&D3&!D2&!D1&D&!C1&!C&!B&A1&A|!E&!D3&!D2&!D1&D&!C1&!C&!B&A1&A|!E&!D3&!D2&!D1&D&C1&!C&!B&A1&A|!E&D3&!D2&!D1&D&C1&!C&!B&A1&A|!E&D3&D2&!D1&D&C1&!C&!B&A1&A|!E&!D3&D2&!D1&D&C1&!C&!B&A1&A|!E&!D3&D2&D1&D&C1&!C&!B&A1&A|!E&D3&D2&D1&D&C1&!C&!B&A1&A|!E&D3&!D2&D1&D&C1&!C&!B&A1&A|!E&!D3&!D2&D1&D&C1&!C&!B&A1&A|!E&!D3&!D2&D1&!D&C1&!C&!B&A1&A|!E&D3&!D2&D1&!D&C1&!C&!B&A1&A|!E&D3&D2&D1&!D&C1&!C&!B&A1&A|!E&!D3&D2&D1&!D&C1&!C&!B&A1&A|!E&!D3&D2&!D1&!D&C1&!C&!B&A1&A|!E&D3&D2&!D1&!D&C1&!C&!B&A1&A|!E&D3&!D2&!D1&!D&C1&!C&!B&A1&A|!E&!D3&!D2&!D1&!D&C1&!C&!B&A1&A|!E&!D3&!D2&!D1&!D&C1&C&!B&A1&A|!E&!D3&!D2&!D1&D&!C1&C&!B&A1&A|!E&D3&!D2&!D1&D&!C1&C&!B&A1&A|!E&D3&D2&!D1&D&!C1&C&!B&A1&A|!E&!D3&D2&!D1&D&!C1&C&!B&A1&A|!E&!D3&D2&D1&D&!C1&C&!B&A1&A|!E&D3&D2&D1&D&!C1&C&!B&A1&A|!E&D3&!D2&D1&D&!C1&C&!B&A1&A|!E&!D3&!D2&D1&D&!C1&C&!B&A1&A|!E&!D3&!D2&D1&!D&!C1&C&!B&A1&A|!E&D3&!D2&D1&!D&!C1&C&!B&A1&A|!E&D3&D2&D1&!D&!C1&C&!B&A1&A|!E&!D3&D2&D1&!D&!C1&C&!B&A1&A|!E&!D3&D2&!D1&!D&!C1&C&!B&A1&A|!E&D3&D2&!D1&!D&!C1&C&!B&A1&A|!E&D3&!D2&!D1&!D&!C1&C&!B&A1&A|!E&!D3&!D2&!D1&!D&!C1&C&!B&A1&A|!E&!D3&!D2&!D1&!D&!C1&C&B&A1&A|!E&!D3&!D2&!D1&!D&C1&C&B&A1&A|!E&!D3&!D2&!D1&!D&C1&!C&B&A1&A|!E&!D3&!D2&!D1&!D&!C1&!C&B&A1&A|!E&!D3&!D2&!D1&!D&!C1&!C&B&!A1&A|!E&!D3&!D2&!D1&!D&C1&!C&B&!A1&A|!E&!D3&!D2&!D1&!D&C1&C&B&!A1&A|!E&!D3&!D2&!D1&!D&!C1&C&B&!A1&A|!E&!D3&!D2&!D1&!D&!C1&C&!B&!A1&A|!E&D3&!D2&!D1&!D&!C1&C&!B&!A1&A|!E&D3&D2&!D1&!D&!C1&C&!B&!A1&A|!E&!D3&D2&!D1&!D&!C1&C&!B&!A1&A|!E&!D3&D2&D1&!D&!C1&C&!B&!A1&A|!E&D3&D2&D1&!D&!C1&C&!B&!A1&A|!E&D3&!D2&D1&!D&!C1&C&!B&!A1&A|!E&!D3&!D2&D1&!D&!C1&C&!B&!A1&A|!E&!D3&!D2&D1&D&!C1&C&!B&!A1&A|!E&D3&!D2&D1&D&!C1&C&!B&!A1&A|!E&D3&D2&D1&D&!C1&C&!B&!A1&A|!E&!D3&D2&D1&D&!C1&C&!B&!A1&A|!E&!D3&D2&!D1&D&!C1&C&!B&!A1&A|!E&D3&D2&!D1&D&!C1&C&!B&!A1&A|!E&D3&!D2&!D1&D&!C1&C&!B&!A1&A|!E&!D3&!D2&!D1&D&!C1&C&!B&!A1&A|!E&!D3&!D2&!D1&!D&C1&C&!B&!A1&A|!E&!D3&!D2&!D1&!D&C1&!C&!B&!A1&A|!E&D3&!D2&!D1&!D&C1&!C&!B&!A1&A|!E&D3&D2&!D1&!D&C1&!C&!B&!A1&A|!E&!D3&D2&!D1&!D&C1&!C&!B&!A1&A|!E&!D3&D2&D1&!D&C1&!C&!B&!A1&A|!E&D3&D2&D1&!D&C1&!C&!B&!A1&A|!E&D3&!D2&D1&!D&C1&!C&!B&!A1&A|!E&!D3&!D2&D1&!D&C1&!C&!B&!A1&A|!E&!D3&!D2&D1&D&C1&!C&!B&!A1&A|!E&D3&!D2&D1&D&C1&!C&!B&!A1&A|!E&D3&D2&D1&D&C1&!C&!B&!A1&A|!E&!D3&D2&D1&D&C1&!C&!B&!A1&A|!E&!D3&D2&!D1&D&C1&!C&!B&!A1&A|!E&D3&D2&!D1&D&C1&!C&!B&!A1&A|!E&D3&!D2&!D1&D&C1&!C&!B&!A1&A|!E&!D3&!D2&!D1&D&C1&!C&!B&!A1&A|!E&!D3&!D2&!D1&D&!C1&!C&!B&!A1&A|!E&D3&!D2&!D1&D&!C1&!C&!B&!A1&A|!E&D3&D2&!D1&D&!C1&!C&!B&!A1&A|!E&!D3&D2&!D1&D&!C1&!C&!B&!A1&A|!E&!D3&D2&D1&D&!C1&!C&!B&!A1&A|!E&D3&D2&D1&D&!C1&!C&!B&!A1&A|!E&D3&!D2&D1&D&!C1&!C&!B&!A1&A|!E&!D3&!D2&D1&D&!C1&!C&!B&!A1&A|!E&!D3&!D2&D1&!D&!C1&!C&!B&!A1&A|!E&D3&!D2&D1&!D&!C1&!C&!B&!A1&A|!E&D3&D2&D1&!D&!C1&!C&!B&!A1&A|!E&!D3&D2&D1&!D&!C1&!C&!B&!A1&A|!E&!D3&D2&!D1&!D&!C1&!C&!B&!A1&A|!E&D3&D2&!D1&!D&!C1&!C&!B&!A1&A|!E&D3&!D2&!D1&!D&!C1&!C&!B&!A1&A|!E&!D3&!D2&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOAOI21241.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOI212 -l OAOI212 -i C1 C B A1 A -o Y -f Y=(!C1&!C&!B&!A1&!A|!C1&!C&B&!A1&!A|!C1&!C&!B&A1&!A|!C1&!C&!B&A1&A|!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOI212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOOAOI22231 -l AAAOOAOI22231 -i E D2 D1 D C1 C B1 B A1 A -o Y -f Y=(!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|!E&D2&D1&D&!C1&C&B1&!B&!A1&!A|!E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|!E&D2&D1&D&C1&!C&B1&!B&!A1&!A|!E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|!E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|!E&D2&D1&D&!C1&C&!B1&B&!A1&!A|!E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|!E&D2&D1&D&C1&!C&!B1&B&!A1&!A|!E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|!E&D2&D1&D&!C1&!C&!B1&B&A1&!A|!E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|!E&D2&!D1&D&C1&!C&!B1&B&A1&!A|!E&D2&D1&D&C1&!C&!B1&B&A1&!A|!E&!D2&D1&D&C1&!C&!B1&B&A1&!A|!E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|!E&D2&D1&!D&C1&!C&!B1&B&A1&!A|!E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|!E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|!E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|!E&D2&!D1&D&!C1&C&!B1&B&A1&!A|!E&D2&D1&D&!C1&C&!B1&B&A1&!A|!E&!D2&D1&D&!C1&C&!B1&B&A1&!A|!E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|!E&D2&D1&!D&!C1&C&!B1&B&A1&!A|!E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|!E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|!E&!D2&!D1&!D&C1&C&B1&B&A1&!A|!E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|!E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|!E&D2&D1&D&!C1&!C&B1&!B&A1&!A|!E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|!E&D2&!D1&D&C1&!C&B1&!B&A1&!A|!E&D2&D1&D&C1&!C&B1&!B&A1&!A|!E&!D2&D1&D&C1&!C&B1&!B&A1&!A|!E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|!E&D2&D1&!D&C1&!C&B1&!B&A1&!A|!E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|!E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|!E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|!E&D2&!D1&D&!C1&C&B1&!B&A1&!A|!E&D2&D1&D&!C1&C&B1&!B&A1&!A|!E&!D2&D1&D&!C1&C&B1&!B&A1&!A|!E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|!E&D2&D1&!D&!C1&C&B1&!B&A1&!A|!E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|!E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|!E&D2&D1&D&!C1&C&!B1&!B&A1&!A|!E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|!E&D2&D1&D&C1&!C&!B1&!B&A1&!A|!E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|!E&!D2&!D1&!D&C1&C&B1&!B&A1&A|!E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!E&!D2&!D1&!D&C1&!C&B1&B&A1&A|!E&!D2&!D1&!D&C1&C&B1&B&A1&A|!E&!D2&!D1&!D&!C1&C&B1&B&A1&A|!E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|!E&!D2&!D1&!D&C1&C&!B1&B&A1&A|!E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|!E&D2&D1&D&!C1&!C&!B1&B&!A1&A|!E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|!E&D2&!D1&D&C1&!C&!B1&B&!A1&A|!E&D2&D1&D&C1&!C&!B1&B&!A1&A|!E&!D2&D1&D&C1&!C&!B1&B&!A1&A|!E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|!E&D2&D1&!D&C1&!C&!B1&B&!A1&A|!E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|!E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|!E&D2&!D1&D&!C1&C&!B1&B&!A1&A|!E&D2&D1&D&!C1&C&!B1&B&!A1&A|!E&!D2&D1&D&!C1&C&!B1&B&!A1&A|!E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|!E&D2&D1&!D&!C1&C&!B1&B&!A1&A|!E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|!E&!D2&!D1&!D&C1&C&B1&B&!A1&A|!E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|!E&D2&D1&D&!C1&!C&B1&!B&!A1&A|!E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|!E&D2&!D1&D&C1&!C&B1&!B&!A1&A|!E&D2&D1&D&C1&!C&B1&!B&!A1&A|!E&!D2&D1&D&C1&!C&B1&!B&!A1&A|!E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|!E&D2&D1&!D&C1&!C&B1&!B&!A1&A|!E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|!E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|!E&D2&!D1&D&!C1&C&B1&!B&!A1&A|!E&D2&D1&D&!C1&C&B1&!B&!A1&A|!E&!D2&D1&D&!C1&C&B1&!B&!A1&A|!E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|!E&D2&D1&!D&!C1&C&B1&!B&!A1&A|!E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|!E&D2&D1&D&!C1&C&!B1&!B&!A1&A|!E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|!E&D2&D1&D&C1&!C&!B1&!B&!A1&A|!E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOOAOI22231.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAOAI22211 -l OOOAOAI22211 -i E D C1 C B1 B A1 A -o Y -f Y=!(E&D&!C1&!C&!B1&!B&!A1&!A|E&D&C1&!C&!B1&!B&!A1&!A|E&D&C1&C&!B1&!B&!A1&!A|E&D&!C1&C&!B1&!B&!A1&!A|E&D&!C1&C&B1&!B&!A1&!A|E&D&C1&C&B1&!B&!A1&!A|E&D&C1&!C&B1&!B&!A1&!A|E&D&!C1&!C&B1&!B&!A1&!A|E&D&!C1&!C&B1&B&!A1&!A|E&D&C1&!C&B1&B&!A1&!A|E&D&C1&C&B1&B&!A1&!A|E&D&!C1&C&B1&B&!A1&!A|E&D&!C1&C&!B1&B&!A1&!A|E&D&C1&C&!B1&B&!A1&!A|E&D&C1&!C&!B1&B&!A1&!A|E&D&!C1&!C&!B1&B&!A1&!A|E&D&!C1&!C&!B1&B&A1&!A|E&D&C1&!C&!B1&B&A1&!A|E&!D&C1&!C&!B1&B&A1&!A|E&!D&C1&C&!B1&B&A1&!A|E&D&C1&C&!B1&B&A1&!A|E&D&!C1&C&!B1&B&A1&!A|E&!D&!C1&C&!B1&B&A1&!A|E&!D&!C1&C&B1&B&A1&!A|E&D&!C1&C&B1&B&A1&!A|E&D&C1&C&B1&B&A1&!A|E&!D&C1&C&B1&B&A1&!A|E&!D&C1&!C&B1&B&A1&!A|E&D&C1&!C&B1&B&A1&!A|E&D&!C1&!C&B1&B&A1&!A|E&D&!C1&!C&B1&!B&A1&!A|E&D&C1&!C&B1&!B&A1&!A|E&!D&C1&!C&B1&!B&A1&!A|E&!D&C1&C&B1&!B&A1&!A|E&D&C1&C&B1&!B&A1&!A|E&D&!C1&C&B1&!B&A1&!A|E&!D&!C1&C&B1&!B&A1&!A|E&D&!C1&C&!B1&!B&A1&!A|E&D&C1&C&!B1&!B&A1&!A|E&D&C1&!C&!B1&!B&A1&!A|E&D&!C1&!C&!B1&!B&A1&!A|E&D&!C1&!C&!B1&!B&A1&A|E&D&C1&!C&!B1&!B&A1&A|E&D&C1&C&!B1&!B&A1&A|E&D&!C1&C&!B1&!B&A1&A|E&!D&!C1&C&B1&!B&A1&A|E&D&!C1&C&B1&!B&A1&A|E&D&C1&C&B1&!B&A1&A|E&!D&C1&C&B1&!B&A1&A|E&!D&C1&!C&B1&!B&A1&A|E&D&C1&!C&B1&!B&A1&A|E&D&!C1&!C&B1&!B&A1&A|E&D&!C1&!C&B1&B&A1&A|E&D&C1&!C&B1&B&A1&A|E&!D&C1&!C&B1&B&A1&A|E&!D&C1&C&B1&B&A1&A|E&D&C1&C&B1&B&A1&A|E&D&!C1&C&B1&B&A1&A|E&!D&!C1&C&B1&B&A1&A|E&!D&!C1&C&!B1&B&A1&A|E&D&!C1&C&!B1&B&A1&A|E&D&C1&C&!B1&B&A1&A|E&!D&C1&C&!B1&B&A1&A|E&!D&C1&!C&!B1&B&A1&A|E&D&C1&!C&!B1&B&A1&A|E&D&!C1&!C&!B1&B&A1&A|E&D&!C1&!C&!B1&B&!A1&A|E&D&C1&!C&!B1&B&!A1&A|E&!D&C1&!C&!B1&B&!A1&A|E&!D&C1&C&!B1&B&!A1&A|E&D&C1&C&!B1&B&!A1&A|E&D&!C1&C&!B1&B&!A1&A|E&!D&!C1&C&!B1&B&!A1&A|E&!D&!C1&C&B1&B&!A1&A|E&D&!C1&C&B1&B&!A1&A|E&D&C1&C&B1&B&!A1&A|E&!D&C1&C&B1&B&!A1&A|E&!D&C1&!C&B1&B&!A1&A|E&D&C1&!C&B1&B&!A1&A|E&D&!C1&!C&B1&B&!A1&A|E&D&!C1&!C&B1&!B&!A1&A|E&D&C1&!C&B1&!B&!A1&A|E&!D&C1&!C&B1&!B&!A1&A|E&!D&C1&C&B1&!B&!A1&A|E&D&C1&C&B1&!B&!A1&A|E&D&!C1&C&B1&!B&!A1&A|E&!D&!C1&C&B1&!B&!A1&A|E&D&!C1&C&!B1&!B&!A1&A|E&D&C1&C&!B1&!B&!A1&A|E&D&C1&!C&!B1&!B&!A1&A|E&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAOAI22211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOOAAOI211122 -l AOAOOAAOI211122 -i F1 F E1 E D C B A1 A -o Y -f Y=(!F1&!F&!E1&!E&!D&!C&!B&!A1&!A|F1&!F&!E1&!E&!D&!C&!B&!A1&!A|!F1&F&!E1&!E&!D&!C&!B&!A1&!A|!F1&F&E1&!E&!D&!C&!B&!A1&!A|F1&!F&E1&!E&!D&!C&!B&!A1&!A|!F1&!F&E1&!E&!D&!C&!B&!A1&!A|!F1&!F&E1&E&!D&!C&!B&!A1&!A|F1&!F&E1&E&!D&!C&!B&!A1&!A|!F1&F&E1&E&!D&!C&!B&!A1&!A|!F1&F&!E1&E&!D&!C&!B&!A1&!A|F1&!F&!E1&E&!D&!C&!B&!A1&!A|!F1&!F&!E1&E&!D&!C&!B&!A1&!A|!F1&F&!E1&!E&D&!C&!B&!A1&!A|F1&!F&!E1&!E&D&!C&!B&!A1&!A|!F1&!F&!E1&!E&D&!C&!B&!A1&!A|!F1&!F&!E1&!E&D&C&!B&!A1&!A|F1&!F&!E1&!E&D&C&!B&!A1&!A|!F1&F&!E1&!E&D&C&!B&!A1&!A|!F1&!F&!E1&E&!D&C&!B&!A1&!A|F1&!F&!E1&E&!D&C&!B&!A1&!A|!F1&F&!E1&E&!D&C&!B&!A1&!A|!F1&F&E1&E&!D&C&!B&!A1&!A|F1&!F&E1&E&!D&C&!B&!A1&!A|!F1&!F&E1&E&!D&C&!B&!A1&!A|!F1&!F&E1&!E&!D&C&!B&!A1&!A|F1&!F&E1&!E&!D&C&!B&!A1&!A|!F1&F&E1&!E&!D&C&!B&!A1&!A|!F1&F&!E1&!E&!D&C&!B&!A1&!A|F1&!F&!E1&!E&!D&C&!B&!A1&!A|!F1&!F&!E1&!E&!D&C&!B&!A1&!A|!F1&!F&!E1&!E&!D&C&B&!A1&!A|F1&!F&!E1&!E&!D&C&B&!A1&!A|!F1&F&!E1&!E&!D&C&B&!A1&!A|!F1&F&!E1&!E&D&C&B&!A1&!A|F1&!F&!E1&!E&D&C&B&!A1&!A|!F1&!F&!E1&!E&D&C&B&!A1&!A|!F1&!F&!E1&!E&D&!C&B&!A1&!A|F1&!F&!E1&!E&D&!C&B&!A1&!A|!F1&F&!E1&!E&D&!C&B&!A1&!A|!F1&!F&!E1&E&!D&!C&B&!A1&!A|F1&!F&!E1&E&!D&!C&B&!A1&!A|!F1&F&!E1&E&!D&!C&B&!A1&!A|!F1&F&E1&E&!D&!C&B&!A1&!A|F1&!F&E1&E&!D&!C&B&!A1&!A|!F1&!F&E1&E&!D&!C&B&!A1&!A|!F1&!F&E1&!E&!D&!C&B&!A1&!A|F1&!F&E1&!E&!D&!C&B&!A1&!A|!F1&F&E1&!E&!D&!C&B&!A1&!A|!F1&F&!E1&!E&!D&!C&B&!A1&!A|F1&!F&!E1&!E&!D&!C&B&!A1&!A|!F1&!F&!E1&!E&!D&!C&B&!A1&!A|!F1&!F&!E1&!E&!D&!C&B&A1&!A|F1&!F&!E1&!E&!D&!C&B&A1&!A|!F1&F&!E1&!E&!D&!C&B&A1&!A|!F1&F&E1&!E&!D&!C&B&A1&!A|F1&!F&E1&!E&!D&!C&B&A1&!A|!F1&!F&E1&!E&!D&!C&B&A1&!A|!F1&!F&E1&E&!D&!C&B&A1&!A|F1&!F&E1&E&!D&!C&B&A1&!A|!F1&F&E1&E&!D&!C&B&A1&!A|!F1&F&!E1&E&!D&!C&B&A1&!A|F1&!F&!E1&E&!D&!C&B&A1&!A|!F1&!F&!E1&E&!D&!C&B&A1&!A|!F1&F&!E1&!E&D&!C&B&A1&!A|F1&!F&!E1&!E&D&!C&B&A1&!A|!F1&!F&!E1&!E&D&!C&B&A1&!A|!F1&!F&!E1&!E&D&C&B&A1&!A|F1&!F&!E1&!E&D&C&B&A1&!A|!F1&F&!E1&!E&D&C&B&A1&!A|!F1&F&!E1&!E&!D&C&B&A1&!A|F1&!F&!E1&!E&!D&C&B&A1&!A|!F1&!F&!E1&!E&!D&C&B&A1&!A|!F1&!F&!E1&!E&!D&C&!B&A1&!A|F1&!F&!E1&!E&!D&C&!B&A1&!A|!F1&F&!E1&!E&!D&C&!B&A1&!A|!F1&F&E1&!E&!D&C&!B&A1&!A|F1&!F&E1&!E&!D&C&!B&A1&!A|!F1&!F&E1&!E&!D&C&!B&A1&!A|!F1&!F&E1&E&!D&C&!B&A1&!A|F1&!F&E1&E&!D&C&!B&A1&!A|!F1&F&E1&E&!D&C&!B&A1&!A|!F1&F&!E1&E&!D&C&!B&A1&!A|F1&!F&!E1&E&!D&C&!B&A1&!A|!F1&!F&!E1&E&!D&C&!B&A1&!A|!F1&F&!E1&!E&D&C&!B&A1&!A|F1&!F&!E1&!E&D&C&!B&A1&!A|!F1&!F&!E1&!E&D&C&!B&A1&!A|!F1&!F&!E1&!E&D&!C&!B&A1&!A|F1&!F&!E1&!E&D&!C&!B&A1&!A|!F1&F&!E1&!E&D&!C&!B&A1&!A|!F1&!F&!E1&E&!D&!C&!B&A1&!A|F1&!F&!E1&E&!D&!C&!B&A1&!A|!F1&F&!E1&E&!D&!C&!B&A1&!A|!F1&F&E1&E&!D&!C&!B&A1&!A|F1&!F&E1&E&!D&!C&!B&A1&!A|!F1&!F&E1&E&!D&!C&!B&A1&!A|!F1&!F&E1&!E&!D&!C&!B&A1&!A|F1&!F&E1&!E&!D&!C&!B&A1&!A|!F1&F&E1&!E&!D&!C&!B&A1&!A|!F1&F&!E1&!E&!D&!C&!B&A1&!A|F1&!F&!E1&!E&!D&!C&!B&A1&!A|!F1&!F&!E1&!E&!D&!C&!B&A1&!A|!F1&!F&!E1&!E&!D&!C&!B&A1&A|F1&!F&!E1&!E&!D&!C&!B&A1&A|!F1&F&!E1&!E&!D&!C&!B&A1&A|!F1&F&E1&!E&!D&!C&!B&A1&A|F1&!F&E1&!E&!D&!C&!B&A1&A|!F1&!F&E1&!E&!D&!C&!B&A1&A|!F1&!F&E1&E&!D&!C&!B&A1&A|F1&!F&E1&E&!D&!C&!B&A1&A|!F1&F&E1&E&!D&!C&!B&A1&A|!F1&F&!E1&E&!D&!C&!B&A1&A|F1&!F&!E1&E&!D&!C&!B&A1&A|!F1&!F&!E1&E&!D&!C&!B&A1&A|!F1&F&!E1&!E&D&!C&!B&A1&A|F1&!F&!E1&!E&D&!C&!B&A1&A|!F1&!F&!E1&!E&D&!C&!B&A1&A|!F1&!F&!E1&!E&D&C&!B&A1&A|F1&!F&!E1&!E&D&C&!B&A1&A|!F1&F&!E1&!E&D&C&!B&A1&A|!F1&F&!E1&!E&!D&C&!B&A1&A|F1&!F&!E1&!E&!D&C&!B&A1&A|!F1&!F&!E1&!E&!D&C&!B&A1&A|!F1&!F&!E1&!E&!D&C&B&A1&A|F1&!F&!E1&!E&!D&C&B&A1&A|!F1&F&!E1&!E&!D&C&B&A1&A|!F1&F&!E1&!E&D&C&B&A1&A|F1&!F&!E1&!E&D&C&B&A1&A|!F1&!F&!E1&!E&D&C&B&A1&A|!F1&!F&!E1&!E&D&!C&B&A1&A|F1&!F&!E1&!E&D&!C&B&A1&A|!F1&F&!E1&!E&D&!C&B&A1&A|!F1&!F&!E1&E&!D&!C&B&A1&A|F1&!F&!E1&E&!D&!C&B&A1&A|!F1&F&!E1&E&!D&!C&B&A1&A|!F1&F&E1&E&!D&!C&B&A1&A|F1&!F&E1&E&!D&!C&B&A1&A|!F1&!F&E1&E&!D&!C&B&A1&A|!F1&!F&E1&!E&!D&!C&B&A1&A|F1&!F&E1&!E&!D&!C&B&A1&A|!F1&F&E1&!E&!D&!C&B&A1&A|!F1&F&!E1&!E&!D&!C&B&A1&A|F1&!F&!E1&!E&!D&!C&B&A1&A|!F1&!F&!E1&!E&!D&!C&B&A1&A|!F1&!F&!E1&!E&!D&!C&B&!A1&A|F1&!F&!E1&!E&!D&!C&B&!A1&A|!F1&F&!E1&!E&!D&!C&B&!A1&A|!F1&F&E1&!E&!D&!C&B&!A1&A|F1&!F&E1&!E&!D&!C&B&!A1&A|!F1&!F&E1&!E&!D&!C&B&!A1&A|!F1&!F&E1&E&!D&!C&B&!A1&A|F1&!F&E1&E&!D&!C&B&!A1&A|!F1&F&E1&E&!D&!C&B&!A1&A|!F1&F&!E1&E&!D&!C&B&!A1&A|F1&!F&!E1&E&!D&!C&B&!A1&A|!F1&!F&!E1&E&!D&!C&B&!A1&A|!F1&F&!E1&!E&D&!C&B&!A1&A|F1&!F&!E1&!E&D&!C&B&!A1&A|!F1&!F&!E1&!E&D&!C&B&!A1&A|!F1&!F&!E1&!E&D&C&B&!A1&A|F1&!F&!E1&!E&D&C&B&!A1&A|!F1&F&!E1&!E&D&C&B&!A1&A|!F1&F&!E1&!E&!D&C&B&!A1&A|F1&!F&!E1&!E&!D&C&B&!A1&A|!F1&!F&!E1&!E&!D&C&B&!A1&A|!F1&!F&!E1&!E&!D&C&!B&!A1&A|F1&!F&!E1&!E&!D&C&!B&!A1&A|!F1&F&!E1&!E&!D&C&!B&!A1&A|!F1&F&E1&!E&!D&C&!B&!A1&A|F1&!F&E1&!E&!D&C&!B&!A1&A|!F1&!F&E1&!E&!D&C&!B&!A1&A|!F1&!F&E1&E&!D&C&!B&!A1&A|F1&!F&E1&E&!D&C&!B&!A1&A|!F1&F&E1&E&!D&C&!B&!A1&A|!F1&F&!E1&E&!D&C&!B&!A1&A|F1&!F&!E1&E&!D&C&!B&!A1&A|!F1&!F&!E1&E&!D&C&!B&!A1&A|!F1&F&!E1&!E&D&C&!B&!A1&A|F1&!F&!E1&!E&D&C&!B&!A1&A|!F1&!F&!E1&!E&D&C&!B&!A1&A|!F1&!F&!E1&!E&D&!C&!B&!A1&A|F1&!F&!E1&!E&D&!C&!B&!A1&A|!F1&F&!E1&!E&D&!C&!B&!A1&A|!F1&!F&!E1&E&!D&!C&!B&!A1&A|F1&!F&!E1&E&!D&!C&!B&!A1&A|!F1&F&!E1&E&!D&!C&!B&!A1&A|!F1&F&E1&E&!D&!C&!B&!A1&A|F1&!F&E1&E&!D&!C&!B&!A1&A|!F1&!F&E1&E&!D&!C&!B&!A1&A|!F1&!F&E1&!E&!D&!C&!B&!A1&A|F1&!F&E1&!E&!D&!C&!B&!A1&A|!F1&F&E1&!E&!D&!C&!B&!A1&A|!F1&F&!E1&!E&!D&!C&!B&!A1&A|F1&!F&!E1&!E&!D&!C&!B&!A1&A|!F1&!F&!E1&!E&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOOAAOI211122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAI2212 -l AAOOAI2212 -i D1 D C B1 B A1 A -o Y -f Y=(!D1&!D&!C&!B1&!B&!A1&!A|D1&!D&!C&!B1&!B&!A1&!A|D1&D&!C&!B1&!B&!A1&!A|!D1&D&!C&!B1&!B&!A1&!A|!D1&!D&C&!B1&!B&!A1&!A|!D1&!D&C&B1&!B&!A1&!A|!D1&D&!C&B1&!B&!A1&!A|D1&D&!C&B1&!B&!A1&!A|D1&!D&!C&B1&!B&!A1&!A|!D1&!D&!C&B1&!B&!A1&!A|!D1&!D&!C&B1&B&!A1&!A|!D1&!D&C&B1&B&!A1&!A|!D1&!D&C&!B1&B&!A1&!A|!D1&D&!C&!B1&B&!A1&!A|D1&D&!C&!B1&B&!A1&!A|D1&!D&!C&!B1&B&!A1&!A|!D1&!D&!C&!B1&B&!A1&!A|!D1&!D&!C&!B1&B&A1&!A|D1&!D&!C&!B1&B&A1&!A|D1&D&!C&!B1&B&A1&!A|!D1&D&!C&!B1&B&A1&!A|!D1&!D&C&!B1&B&A1&!A|!D1&!D&C&B1&B&A1&!A|!D1&!D&!C&B1&B&A1&!A|!D1&!D&!C&B1&!B&A1&!A|D1&!D&!C&B1&!B&A1&!A|D1&D&!C&B1&!B&A1&!A|!D1&D&!C&B1&!B&A1&!A|!D1&!D&C&B1&!B&A1&!A|!D1&!D&C&!B1&!B&A1&!A|!D1&D&!C&!B1&!B&A1&!A|D1&D&!C&!B1&!B&A1&!A|D1&!D&!C&!B1&!B&A1&!A|!D1&!D&!C&!B1&!B&A1&!A|!D1&!D&!C&!B1&!B&A1&A|!D1&!D&C&!B1&!B&A1&A|!D1&!D&C&B1&!B&A1&A|!D1&!D&!C&B1&!B&A1&A|!D1&!D&!C&B1&B&A1&A|!D1&!D&C&B1&B&A1&A|!D1&!D&C&!B1&B&A1&A|!D1&!D&!C&!B1&B&A1&A|!D1&!D&!C&!B1&B&!A1&A|D1&!D&!C&!B1&B&!A1&A|D1&D&!C&!B1&B&!A1&A|!D1&D&!C&!B1&B&!A1&A|!D1&!D&C&!B1&B&!A1&A|!D1&!D&C&B1&B&!A1&A|!D1&!D&!C&B1&B&!A1&A|!D1&!D&!C&B1&!B&!A1&A|D1&!D&!C&B1&!B&!A1&A|D1&D&!C&B1&!B&!A1&A|!D1&D&!C&B1&!B&!A1&A|!D1&!D&C&B1&!B&!A1&A|!D1&!D&C&!B1&!B&!A1&A|!D1&D&!C&!B1&!B&!A1&A|D1&D&!C&!B1&!B&!A1&A|D1&!D&!C&!B1&!B&!A1&A|!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAI2212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAOI2221 -l AAOAOI2221 -i D C1 C B1 B A1 A -o Y -f Y=(!D&!C1&!C&!B1&!B&!A1&!A|!D&C1&!C&!B1&!B&!A1&!A|!D&C1&C&!B1&!B&!A1&!A|!D&!C1&C&!B1&!B&!A1&!A|!D&!C1&C&B1&!B&!A1&!A|!D&C1&C&B1&!B&!A1&!A|!D&C1&!C&B1&!B&!A1&!A|!D&!C1&!C&B1&!B&!A1&!A|!D&!C1&!C&B1&B&!A1&!A|!D&C1&!C&B1&B&!A1&!A|!D&!C1&C&B1&B&!A1&!A|!D&!C1&C&!B1&B&!A1&!A|!D&C1&C&!B1&B&!A1&!A|!D&C1&!C&!B1&B&!A1&!A|!D&!C1&!C&!B1&B&!A1&!A|!D&!C1&!C&!B1&B&A1&!A|!D&C1&!C&!B1&B&A1&!A|!D&C1&C&!B1&B&A1&!A|!D&!C1&C&!B1&B&A1&!A|!D&!C1&C&B1&B&A1&!A|!D&C1&!C&B1&B&A1&!A|!D&!C1&!C&B1&B&A1&!A|!D&!C1&!C&B1&!B&A1&!A|!D&C1&!C&B1&!B&A1&!A|!D&C1&C&B1&!B&A1&!A|!D&!C1&C&B1&!B&A1&!A|!D&!C1&C&!B1&!B&A1&!A|!D&C1&C&!B1&!B&A1&!A|!D&C1&!C&!B1&!B&A1&!A|!D&!C1&!C&!B1&!B&A1&!A|!D&!C1&!C&!B1&!B&A1&A|!D&C1&!C&!B1&!B&A1&A|!D&!C1&C&!B1&!B&A1&A|!D&!C1&C&B1&!B&A1&A|!D&C1&!C&B1&!B&A1&A|!D&!C1&!C&B1&!B&A1&A|!D&!C1&!C&B1&B&A1&A|!D&C1&!C&B1&B&A1&A|!D&!C1&C&B1&B&A1&A|!D&!C1&C&!B1&B&A1&A|!D&C1&!C&!B1&B&A1&A|!D&!C1&!C&!B1&B&A1&A|!D&!C1&!C&!B1&B&!A1&A|!D&C1&!C&!B1&B&!A1&A|!D&C1&C&!B1&B&!A1&A|!D&!C1&C&!B1&B&!A1&A|!D&!C1&C&B1&B&!A1&A|!D&C1&!C&B1&B&!A1&A|!D&!C1&!C&B1&B&!A1&A|!D&!C1&!C&B1&!B&!A1&A|!D&C1&!C&B1&!B&!A1&A|!D&C1&C&B1&!B&!A1&A|!D&!C1&C&B1&!B&!A1&A|!D&!C1&C&!B1&!B&!A1&A|!D&C1&C&!B1&!B&!A1&A|!D&C1&!C&!B1&!B&!A1&A|!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAOI2221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOAOI212211 -l AOOAAOAOI212211 -i F E D1 D C1 C B A1 A -o Y -f Y=(!F&!E&!D1&!D&!C1&!C&!B&!A1&!A|!F&E&!D1&!D&!C1&!C&!B&!A1&!A|!F&E&D1&!D&!C1&!C&!B&!A1&!A|!F&!E&D1&!D&!C1&!C&!B&!A1&!A|!F&!E&D1&D&!C1&!C&!B&!A1&!A|!F&E&!D1&D&!C1&!C&!B&!A1&!A|!F&!E&!D1&D&!C1&!C&!B&!A1&!A|!F&!E&!D1&D&C1&!C&!B&!A1&!A|!F&E&!D1&D&C1&!C&!B&!A1&!A|!F&!E&D1&D&C1&!C&!B&!A1&!A|!F&!E&D1&!D&C1&!C&!B&!A1&!A|!F&E&D1&!D&C1&!C&!B&!A1&!A|!F&E&!D1&!D&C1&!C&!B&!A1&!A|!F&!E&!D1&!D&C1&!C&!B&!A1&!A|!F&!E&!D1&!D&C1&C&!B&!A1&!A|!F&E&!D1&!D&C1&C&!B&!A1&!A|!F&E&D1&!D&C1&C&!B&!A1&!A|!F&!E&D1&!D&C1&C&!B&!A1&!A|!F&!E&D1&D&C1&C&!B&!A1&!A|!F&E&!D1&D&C1&C&!B&!A1&!A|!F&!E&!D1&D&C1&C&!B&!A1&!A|!F&!E&!D1&D&!C1&C&!B&!A1&!A|!F&E&!D1&D&!C1&C&!B&!A1&!A|!F&!E&D1&D&!C1&C&!B&!A1&!A|!F&!E&D1&!D&!C1&C&!B&!A1&!A|!F&E&D1&!D&!C1&C&!B&!A1&!A|!F&E&!D1&!D&!C1&C&!B&!A1&!A|!F&!E&!D1&!D&!C1&C&!B&!A1&!A|!F&!E&!D1&!D&!C1&C&B&!A1&!A|!F&!E&D1&!D&!C1&C&B&!A1&!A|!F&!E&D1&D&!C1&C&B&!A1&!A|!F&!E&!D1&D&!C1&C&B&!A1&!A|!F&!E&!D1&D&C1&C&B&!A1&!A|!F&!E&D1&D&C1&C&B&!A1&!A|!F&!E&D1&!D&C1&C&B&!A1&!A|!F&!E&!D1&!D&C1&C&B&!A1&!A|!F&!E&!D1&!D&C1&!C&B&!A1&!A|!F&!E&D1&!D&C1&!C&B&!A1&!A|!F&!E&D1&D&C1&!C&B&!A1&!A|!F&!E&!D1&D&C1&!C&B&!A1&!A|!F&!E&!D1&D&!C1&!C&B&!A1&!A|!F&E&!D1&D&!C1&!C&B&!A1&!A|!F&!E&D1&D&!C1&!C&B&!A1&!A|!F&!E&D1&!D&!C1&!C&B&!A1&!A|!F&E&D1&!D&!C1&!C&B&!A1&!A|!F&E&!D1&!D&!C1&!C&B&!A1&!A|!F&!E&!D1&!D&!C1&!C&B&!A1&!A|!F&!E&!D1&!D&!C1&!C&B&A1&!A|!F&E&!D1&!D&!C1&!C&B&A1&!A|!F&E&D1&!D&!C1&!C&B&A1&!A|!F&!E&D1&!D&!C1&!C&B&A1&!A|!F&!E&D1&D&!C1&!C&B&A1&!A|!F&E&!D1&D&!C1&!C&B&A1&!A|!F&!E&!D1&D&!C1&!C&B&A1&!A|!F&!E&!D1&D&C1&!C&B&A1&!A|!F&!E&D1&D&C1&!C&B&A1&!A|!F&!E&D1&!D&C1&!C&B&A1&!A|!F&!E&!D1&!D&C1&!C&B&A1&!A|!F&!E&!D1&!D&C1&C&B&A1&!A|!F&!E&D1&!D&C1&C&B&A1&!A|!F&!E&D1&D&C1&C&B&A1&!A|!F&!E&!D1&D&C1&C&B&A1&!A|!F&!E&!D1&D&!C1&C&B&A1&!A|!F&!E&D1&D&!C1&C&B&A1&!A|!F&!E&D1&!D&!C1&C&B&A1&!A|!F&!E&!D1&!D&!C1&C&B&A1&!A|!F&!E&!D1&!D&!C1&C&!B&A1&!A|!F&E&!D1&!D&!C1&C&!B&A1&!A|!F&E&D1&!D&!C1&C&!B&A1&!A|!F&!E&D1&!D&!C1&C&!B&A1&!A|!F&!E&D1&D&!C1&C&!B&A1&!A|!F&E&!D1&D&!C1&C&!B&A1&!A|!F&!E&!D1&D&!C1&C&!B&A1&!A|!F&!E&!D1&D&C1&C&!B&A1&!A|!F&E&!D1&D&C1&C&!B&A1&!A|!F&!E&D1&D&C1&C&!B&A1&!A|!F&!E&D1&!D&C1&C&!B&A1&!A|!F&E&D1&!D&C1&C&!B&A1&!A|!F&E&!D1&!D&C1&C&!B&A1&!A|!F&!E&!D1&!D&C1&C&!B&A1&!A|!F&!E&!D1&!D&C1&!C&!B&A1&!A|!F&E&!D1&!D&C1&!C&!B&A1&!A|!F&E&D1&!D&C1&!C&!B&A1&!A|!F&!E&D1&!D&C1&!C&!B&A1&!A|!F&!E&D1&D&C1&!C&!B&A1&!A|!F&E&!D1&D&C1&!C&!B&A1&!A|!F&!E&!D1&D&C1&!C&!B&A1&!A|!F&!E&!D1&D&!C1&!C&!B&A1&!A|!F&E&!D1&D&!C1&!C&!B&A1&!A|!F&!E&D1&D&!C1&!C&!B&A1&!A|!F&!E&D1&!D&!C1&!C&!B&A1&!A|!F&E&D1&!D&!C1&!C&!B&A1&!A|!F&E&!D1&!D&!C1&!C&!B&A1&!A|!F&!E&!D1&!D&!C1&!C&!B&A1&!A|!F&!E&!D1&!D&!C1&!C&!B&A1&A|!F&E&!D1&!D&!C1&!C&!B&A1&A|!F&E&D1&!D&!C1&!C&!B&A1&A|!F&!E&D1&!D&!C1&!C&!B&A1&A|!F&!E&D1&D&!C1&!C&!B&A1&A|!F&E&!D1&D&!C1&!C&!B&A1&A|!F&!E&!D1&D&!C1&!C&!B&A1&A|!F&!E&!D1&D&C1&!C&!B&A1&A|!F&!E&D1&D&C1&!C&!B&A1&A|!F&!E&D1&!D&C1&!C&!B&A1&A|!F&!E&!D1&!D&C1&!C&!B&A1&A|!F&!E&!D1&!D&C1&C&!B&A1&A|!F&!E&D1&!D&C1&C&!B&A1&A|!F&!E&D1&D&C1&C&!B&A1&A|!F&!E&!D1&D&C1&C&!B&A1&A|!F&!E&!D1&D&!C1&C&!B&A1&A|!F&!E&D1&D&!C1&C&!B&A1&A|!F&!E&D1&!D&!C1&C&!B&A1&A|!F&!E&!D1&!D&!C1&C&!B&A1&A|!F&!E&!D1&!D&!C1&C&B&A1&A|!F&!E&D1&!D&!C1&C&B&A1&A|!F&!E&D1&D&!C1&C&B&A1&A|!F&!E&!D1&D&!C1&C&B&A1&A|!F&!E&!D1&D&C1&C&B&A1&A|!F&!E&D1&D&C1&C&B&A1&A|!F&!E&D1&!D&C1&C&B&A1&A|!F&!E&!D1&!D&C1&C&B&A1&A|!F&!E&!D1&!D&C1&!C&B&A1&A|!F&!E&D1&!D&C1&!C&B&A1&A|!F&!E&D1&D&C1&!C&B&A1&A|!F&!E&!D1&D&C1&!C&B&A1&A|!F&!E&!D1&D&!C1&!C&B&A1&A|!F&E&!D1&D&!C1&!C&B&A1&A|!F&!E&D1&D&!C1&!C&B&A1&A|!F&!E&D1&!D&!C1&!C&B&A1&A|!F&E&D1&!D&!C1&!C&B&A1&A|!F&E&!D1&!D&!C1&!C&B&A1&A|!F&!E&!D1&!D&!C1&!C&B&A1&A|!F&!E&!D1&!D&!C1&!C&B&!A1&A|!F&E&!D1&!D&!C1&!C&B&!A1&A|!F&E&D1&!D&!C1&!C&B&!A1&A|!F&!E&D1&!D&!C1&!C&B&!A1&A|!F&!E&D1&D&!C1&!C&B&!A1&A|!F&E&!D1&D&!C1&!C&B&!A1&A|!F&!E&!D1&D&!C1&!C&B&!A1&A|!F&!E&!D1&D&C1&!C&B&!A1&A|!F&!E&D1&D&C1&!C&B&!A1&A|!F&!E&D1&!D&C1&!C&B&!A1&A|!F&!E&!D1&!D&C1&!C&B&!A1&A|!F&!E&!D1&!D&C1&C&B&!A1&A|!F&!E&D1&!D&C1&C&B&!A1&A|!F&!E&D1&D&C1&C&B&!A1&A|!F&!E&!D1&D&C1&C&B&!A1&A|!F&!E&!D1&D&!C1&C&B&!A1&A|!F&!E&D1&D&!C1&C&B&!A1&A|!F&!E&D1&!D&!C1&C&B&!A1&A|!F&!E&!D1&!D&!C1&C&B&!A1&A|!F&!E&!D1&!D&!C1&C&!B&!A1&A|!F&E&!D1&!D&!C1&C&!B&!A1&A|!F&E&D1&!D&!C1&C&!B&!A1&A|!F&!E&D1&!D&!C1&C&!B&!A1&A|!F&!E&D1&D&!C1&C&!B&!A1&A|!F&E&!D1&D&!C1&C&!B&!A1&A|!F&!E&!D1&D&!C1&C&!B&!A1&A|!F&!E&!D1&D&C1&C&!B&!A1&A|!F&E&!D1&D&C1&C&!B&!A1&A|!F&!E&D1&D&C1&C&!B&!A1&A|!F&!E&D1&!D&C1&C&!B&!A1&A|!F&E&D1&!D&C1&C&!B&!A1&A|!F&E&!D1&!D&C1&C&!B&!A1&A|!F&!E&!D1&!D&C1&C&!B&!A1&A|!F&!E&!D1&!D&C1&!C&!B&!A1&A|!F&E&!D1&!D&C1&!C&!B&!A1&A|!F&E&D1&!D&C1&!C&!B&!A1&A|!F&!E&D1&!D&C1&!C&!B&!A1&A|!F&!E&D1&D&C1&!C&!B&!A1&A|!F&E&!D1&D&C1&!C&!B&!A1&A|!F&!E&!D1&D&C1&!C&!B&!A1&A|!F&!E&!D1&D&!C1&!C&!B&!A1&A|!F&E&!D1&D&!C1&!C&!B&!A1&A|!F&!E&D1&D&!C1&!C&!B&!A1&A|!F&!E&D1&!D&!C1&!C&!B&!A1&A|!F&E&D1&!D&!C1&!C&!B&!A1&A|!F&E&!D1&!D&!C1&!C&!B&!A1&A|!F&!E&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOAOI212211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOI42 -l AAOI42 -i B1 B A3 A2 A1 A -o Y -f Y=!(B1&B&!A3&!A2&!A1&!A|B1&B&A3&!A2&!A1&!A|B1&B&A3&A2&!A1&!A|B1&B&!A3&A2&!A1&!A|B1&B&!A3&A2&A1&!A|B1&B&A3&A2&A1&!A|B1&B&A3&!A2&A1&!A|B1&B&!A3&!A2&A1&!A|B1&B&!A3&!A2&A1&A|B1&B&A3&!A2&A1&A|!B1&!B&A3&A2&A1&A|B1&!B&A3&A2&A1&A|B1&B&A3&A2&A1&A|!B1&B&A3&A2&A1&A|B1&B&!A3&A2&A1&A|B1&B&!A3&A2&!A1&A|B1&B&A3&A2&!A1&A|B1&B&A3&!A2&!A1&A|B1&B&!A3&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOI42.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOAAOI21112 -l OAOAAOI21112 -i E1 E D C B A1 A -o Y -f Y=(!E1&!E&!D&!C&!B&!A1&!A|E1&!E&!D&!C&!B&!A1&!A|!E1&E&!D&!C&!B&!A1&!A|!E1&E&D&!C&!B&!A1&!A|E1&!E&D&!C&!B&!A1&!A|!E1&!E&D&!C&!B&!A1&!A|!E1&E&!D&C&!B&!A1&!A|E1&!E&!D&C&!B&!A1&!A|!E1&!E&!D&C&!B&!A1&!A|!E1&!E&!D&C&B&!A1&!A|E1&!E&!D&C&B&!A1&!A|!E1&E&!D&C&B&!A1&!A|!E1&!E&D&!C&B&!A1&!A|E1&!E&D&!C&B&!A1&!A|!E1&E&D&!C&B&!A1&!A|!E1&E&!D&!C&B&!A1&!A|E1&!E&!D&!C&B&!A1&!A|!E1&!E&!D&!C&B&!A1&!A|!E1&!E&!D&!C&B&A1&!A|E1&!E&!D&!C&B&A1&!A|!E1&E&!D&!C&B&A1&!A|!E1&E&!D&C&B&A1&!A|E1&!E&!D&C&B&A1&!A|!E1&!E&!D&C&B&A1&!A|!E1&!E&!D&C&!B&A1&!A|E1&!E&!D&C&!B&A1&!A|!E1&E&!D&C&!B&A1&!A|!E1&!E&D&!C&!B&A1&!A|E1&!E&D&!C&!B&A1&!A|!E1&E&D&!C&!B&A1&!A|!E1&E&!D&!C&!B&A1&!A|E1&!E&!D&!C&!B&A1&!A|!E1&!E&!D&!C&!B&A1&!A|!E1&!E&!D&!C&!B&A1&A|E1&!E&!D&!C&!B&A1&A|!E1&E&!D&!C&!B&A1&A|!E1&E&D&!C&!B&A1&A|E1&!E&D&!C&!B&A1&A|!E1&!E&D&!C&!B&A1&A|!E1&E&!D&C&!B&A1&A|E1&!E&!D&C&!B&A1&A|!E1&!E&!D&C&!B&A1&A|!E1&!E&!D&C&B&A1&A|E1&!E&!D&C&B&A1&A|!E1&E&!D&C&B&A1&A|!E1&E&!D&!C&B&A1&A|E1&!E&!D&!C&B&A1&A|!E1&!E&!D&!C&B&A1&A|!E1&!E&!D&!C&B&!A1&A|E1&!E&!D&!C&B&!A1&A|!E1&E&!D&!C&B&!A1&A|!E1&E&!D&C&B&!A1&A|E1&!E&!D&C&B&!A1&A|!E1&!E&!D&C&B&!A1&A|!E1&!E&!D&C&!B&!A1&A|E1&!E&!D&C&!B&!A1&A|!E1&E&!D&C&!B&!A1&A|!E1&!E&D&!C&!B&!A1&A|E1&!E&D&!C&!B&!A1&A|!E1&E&D&!C&!B&!A1&A|!E1&E&!D&!C&!B&!A1&A|E1&!E&!D&!C&!B&!A1&A|!E1&!E&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOAAOI21112.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOI211 -l OAOI211 -i C B A1 A -o Y -f Y=(!C&!B&!A1&!A|!C&B&!A1&!A|!C&!B&A1&!A|!C&!B&A1&A|!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOI211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOAI33211 -l AAAOAI33211 -i E D C1 C B2 B1 B A2 A1 A -o Y -f Y=!(E&D&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|E&D&C1&!C&!B2&!B1&!B&!A2&!A1&!A|E&!D&C1&C&!B2&!B1&!B&!A2&!A1&!A|E&D&C1&C&!B2&!B1&!B&!A2&!A1&!A|E&D&!C1&C&!B2&!B1&!B&!A2&!A1&!A|E&D&!C1&C&B2&!B1&!B&!A2&!A1&!A|E&D&C1&C&B2&!B1&!B&!A2&!A1&!A|E&!D&C1&C&B2&!B1&!B&!A2&!A1&!A|E&D&C1&!C&B2&!B1&!B&!A2&!A1&!A|E&D&!C1&!C&B2&!B1&!B&!A2&!A1&!A|E&D&!C1&!C&B2&B1&!B&!A2&!A1&!A|E&D&C1&!C&B2&B1&!B&!A2&!A1&!A|E&!D&C1&C&B2&B1&!B&!A2&!A1&!A|E&D&C1&C&B2&B1&!B&!A2&!A1&!A|E&D&!C1&C&B2&B1&!B&!A2&!A1&!A|E&D&!C1&C&!B2&B1&!B&!A2&!A1&!A|E&D&C1&C&!B2&B1&!B&!A2&!A1&!A|E&!D&C1&C&!B2&B1&!B&!A2&!A1&!A|E&D&C1&!C&!B2&B1&!B&!A2&!A1&!A|E&D&!C1&!C&!B2&B1&!B&!A2&!A1&!A|E&D&!C1&!C&!B2&B1&B&!A2&!A1&!A|E&D&C1&!C&!B2&B1&B&!A2&!A1&!A|E&!D&C1&C&!B2&B1&B&!A2&!A1&!A|E&D&C1&C&!B2&B1&B&!A2&!A1&!A|E&D&!C1&C&!B2&B1&B&!A2&!A1&!A|E&!D&!C1&C&B2&B1&B&!A2&!A1&!A|E&D&!C1&C&B2&B1&B&!A2&!A1&!A|E&D&C1&C&B2&B1&B&!A2&!A1&!A|E&!D&C1&C&B2&B1&B&!A2&!A1&!A|E&!D&C1&!C&B2&B1&B&!A2&!A1&!A|E&D&C1&!C&B2&B1&B&!A2&!A1&!A|E&D&!C1&!C&B2&B1&B&!A2&!A1&!A|E&!D&!C1&!C&B2&B1&B&!A2&!A1&!A|E&D&!C1&!C&B2&!B1&B&!A2&!A1&!A|E&D&C1&!C&B2&!B1&B&!A2&!A1&!A|E&!D&C1&C&B2&!B1&B&!A2&!A1&!A|E&D&C1&C&B2&!B1&B&!A2&!A1&!A|E&D&!C1&C&B2&!B1&B&!A2&!A1&!A|E&D&!C1&C&!B2&!B1&B&!A2&!A1&!A|E&D&C1&C&!B2&!B1&B&!A2&!A1&!A|E&!D&C1&C&!B2&!B1&B&!A2&!A1&!A|E&D&C1&!C&!B2&!B1&B&!A2&!A1&!A|E&D&!C1&!C&!B2&!B1&B&!A2&!A1&!A|E&D&!C1&!C&!B2&!B1&B&A2&!A1&!A|E&D&C1&!C&!B2&!B1&B&A2&!A1&!A|E&!D&C1&C&!B2&!B1&B&A2&!A1&!A|E&D&C1&C&!B2&!B1&B&A2&!A1&!A|E&D&!C1&C&!B2&!B1&B&A2&!A1&!A|E&D&!C1&C&B2&!B1&B&A2&!A1&!A|E&D&C1&C&B2&!B1&B&A2&!A1&!A|E&!D&C1&C&B2&!B1&B&A2&!A1&!A|E&D&C1&!C&B2&!B1&B&A2&!A1&!A|E&D&!C1&!C&B2&!B1&B&A2&!A1&!A|E&!D&!C1&!C&B2&B1&B&A2&!A1&!A|E&D&!C1&!C&B2&B1&B&A2&!A1&!A|E&D&C1&!C&B2&B1&B&A2&!A1&!A|E&!D&C1&!C&B2&B1&B&A2&!A1&!A|E&!D&C1&C&B2&B1&B&A2&!A1&!A|E&D&C1&C&B2&B1&B&A2&!A1&!A|E&D&!C1&C&B2&B1&B&A2&!A1&!A|E&!D&!C1&C&B2&B1&B&A2&!A1&!A|E&D&!C1&C&!B2&B1&B&A2&!A1&!A|E&D&C1&C&!B2&B1&B&A2&!A1&!A|E&!D&C1&C&!B2&B1&B&A2&!A1&!A|E&D&C1&!C&!B2&B1&B&A2&!A1&!A|E&D&!C1&!C&!B2&B1&B&A2&!A1&!A|E&D&!C1&!C&!B2&B1&!B&A2&!A1&!A|E&D&C1&!C&!B2&B1&!B&A2&!A1&!A|E&!D&C1&C&!B2&B1&!B&A2&!A1&!A|E&D&C1&C&!B2&B1&!B&A2&!A1&!A|E&D&!C1&C&!B2&B1&!B&A2&!A1&!A|E&D&!C1&C&B2&B1&!B&A2&!A1&!A|E&D&C1&C&B2&B1&!B&A2&!A1&!A|E&!D&C1&C&B2&B1&!B&A2&!A1&!A|E&D&C1&!C&B2&B1&!B&A2&!A1&!A|E&D&!C1&!C&B2&B1&!B&A2&!A1&!A|E&D&!C1&!C&B2&!B1&!B&A2&!A1&!A|E&D&C1&!C&B2&!B1&!B&A2&!A1&!A|E&!D&C1&C&B2&!B1&!B&A2&!A1&!A|E&D&C1&C&B2&!B1&!B&A2&!A1&!A|E&D&!C1&C&B2&!B1&!B&A2&!A1&!A|E&D&!C1&C&!B2&!B1&!B&A2&!A1&!A|E&D&C1&C&!B2&!B1&!B&A2&!A1&!A|E&!D&C1&C&!B2&!B1&!B&A2&!A1&!A|E&D&C1&!C&!B2&!B1&!B&A2&!A1&!A|E&D&!C1&!C&!B2&!B1&!B&A2&!A1&!A|E&D&!C1&!C&!B2&!B1&!B&A2&A1&!A|E&D&C1&!C&!B2&!B1&!B&A2&A1&!A|E&!D&C1&C&!B2&!B1&!B&A2&A1&!A|E&D&C1&C&!B2&!B1&!B&A2&A1&!A|E&D&!C1&C&!B2&!B1&!B&A2&A1&!A|E&D&!C1&C&B2&!B1&!B&A2&A1&!A|E&D&C1&C&B2&!B1&!B&A2&A1&!A|E&!D&C1&C&B2&!B1&!B&A2&A1&!A|E&D&C1&!C&B2&!B1&!B&A2&A1&!A|E&D&!C1&!C&B2&!B1&!B&A2&A1&!A|E&D&!C1&!C&B2&B1&!B&A2&A1&!A|E&D&C1&!C&B2&B1&!B&A2&A1&!A|E&!D&C1&C&B2&B1&!B&A2&A1&!A|E&D&C1&C&B2&B1&!B&A2&A1&!A|E&D&!C1&C&B2&B1&!B&A2&A1&!A|E&D&!C1&C&!B2&B1&!B&A2&A1&!A|E&D&C1&C&!B2&B1&!B&A2&A1&!A|E&!D&C1&C&!B2&B1&!B&A2&A1&!A|E&D&C1&!C&!B2&B1&!B&A2&A1&!A|E&D&!C1&!C&!B2&B1&!B&A2&A1&!A|E&D&!C1&!C&!B2&B1&B&A2&A1&!A|E&D&C1&!C&!B2&B1&B&A2&A1&!A|E&!D&C1&C&!B2&B1&B&A2&A1&!A|E&D&C1&C&!B2&B1&B&A2&A1&!A|E&D&!C1&C&!B2&B1&B&A2&A1&!A|E&!D&!C1&C&B2&B1&B&A2&A1&!A|E&D&!C1&C&B2&B1&B&A2&A1&!A|E&D&C1&C&B2&B1&B&A2&A1&!A|E&!D&C1&C&B2&B1&B&A2&A1&!A|E&!D&C1&!C&B2&B1&B&A2&A1&!A|E&D&C1&!C&B2&B1&B&A2&A1&!A|E&D&!C1&!C&B2&B1&B&A2&A1&!A|E&!D&!C1&!C&B2&B1&B&A2&A1&!A|E&D&!C1&!C&B2&!B1&B&A2&A1&!A|E&D&C1&!C&B2&!B1&B&A2&A1&!A|E&!D&C1&C&B2&!B1&B&A2&A1&!A|E&D&C1&C&B2&!B1&B&A2&A1&!A|E&D&!C1&C&B2&!B1&B&A2&A1&!A|E&D&!C1&C&!B2&!B1&B&A2&A1&!A|E&D&C1&C&!B2&!B1&B&A2&A1&!A|E&!D&C1&C&!B2&!B1&B&A2&A1&!A|E&D&C1&!C&!B2&!B1&B&A2&A1&!A|E&D&!C1&!C&!B2&!B1&B&A2&A1&!A|E&D&!C1&!C&!B2&!B1&B&!A2&A1&!A|E&D&C1&!C&!B2&!B1&B&!A2&A1&!A|E&!D&C1&C&!B2&!B1&B&!A2&A1&!A|E&D&C1&C&!B2&!B1&B&!A2&A1&!A|E&D&!C1&C&!B2&!B1&B&!A2&A1&!A|E&D&!C1&C&B2&!B1&B&!A2&A1&!A|E&D&C1&C&B2&!B1&B&!A2&A1&!A|E&!D&C1&C&B2&!B1&B&!A2&A1&!A|E&D&C1&!C&B2&!B1&B&!A2&A1&!A|E&D&!C1&!C&B2&!B1&B&!A2&A1&!A|E&!D&!C1&!C&B2&B1&B&!A2&A1&!A|E&D&!C1&!C&B2&B1&B&!A2&A1&!A|E&D&C1&!C&B2&B1&B&!A2&A1&!A|E&!D&C1&!C&B2&B1&B&!A2&A1&!A|E&!D&C1&C&B2&B1&B&!A2&A1&!A|E&D&C1&C&B2&B1&B&!A2&A1&!A|E&D&!C1&C&B2&B1&B&!A2&A1&!A|E&!D&!C1&C&B2&B1&B&!A2&A1&!A|E&D&!C1&C&!B2&B1&B&!A2&A1&!A|E&D&C1&C&!B2&B1&B&!A2&A1&!A|E&!D&C1&C&!B2&B1&B&!A2&A1&!A|E&D&C1&!C&!B2&B1&B&!A2&A1&!A|E&D&!C1&!C&!B2&B1&B&!A2&A1&!A|E&D&!C1&!C&!B2&B1&!B&!A2&A1&!A|E&D&C1&!C&!B2&B1&!B&!A2&A1&!A|E&!D&C1&C&!B2&B1&!B&!A2&A1&!A|E&D&C1&C&!B2&B1&!B&!A2&A1&!A|E&D&!C1&C&!B2&B1&!B&!A2&A1&!A|E&D&!C1&C&B2&B1&!B&!A2&A1&!A|E&D&C1&C&B2&B1&!B&!A2&A1&!A|E&!D&C1&C&B2&B1&!B&!A2&A1&!A|E&D&C1&!C&B2&B1&!B&!A2&A1&!A|E&D&!C1&!C&B2&B1&!B&!A2&A1&!A|E&D&!C1&!C&B2&!B1&!B&!A2&A1&!A|E&D&C1&!C&B2&!B1&!B&!A2&A1&!A|E&!D&C1&C&B2&!B1&!B&!A2&A1&!A|E&D&C1&C&B2&!B1&!B&!A2&A1&!A|E&D&!C1&C&B2&!B1&!B&!A2&A1&!A|E&D&!C1&C&!B2&!B1&!B&!A2&A1&!A|E&D&C1&C&!B2&!B1&!B&!A2&A1&!A|E&!D&C1&C&!B2&!B1&!B&!A2&A1&!A|E&D&C1&!C&!B2&!B1&!B&!A2&A1&!A|E&D&!C1&!C&!B2&!B1&!B&!A2&A1&!A|E&D&!C1&!C&!B2&!B1&!B&!A2&A1&A|E&D&C1&!C&!B2&!B1&!B&!A2&A1&A|E&!D&C1&C&!B2&!B1&!B&!A2&A1&A|E&D&C1&C&!B2&!B1&!B&!A2&A1&A|E&D&!C1&C&!B2&!B1&!B&!A2&A1&A|E&D&!C1&C&B2&!B1&!B&!A2&A1&A|E&D&C1&C&B2&!B1&!B&!A2&A1&A|E&!D&C1&C&B2&!B1&!B&!A2&A1&A|E&D&C1&!C&B2&!B1&!B&!A2&A1&A|E&D&!C1&!C&B2&!B1&!B&!A2&A1&A|E&D&!C1&!C&B2&B1&!B&!A2&A1&A|E&D&C1&!C&B2&B1&!B&!A2&A1&A|E&!D&C1&C&B2&B1&!B&!A2&A1&A|E&D&C1&C&B2&B1&!B&!A2&A1&A|E&D&!C1&C&B2&B1&!B&!A2&A1&A|E&D&!C1&C&!B2&B1&!B&!A2&A1&A|E&D&C1&C&!B2&B1&!B&!A2&A1&A|E&!D&C1&C&!B2&B1&!B&!A2&A1&A|E&D&C1&!C&!B2&B1&!B&!A2&A1&A|E&D&!C1&!C&!B2&B1&!B&!A2&A1&A|E&D&!C1&!C&!B2&B1&B&!A2&A1&A|E&D&C1&!C&!B2&B1&B&!A2&A1&A|E&!D&C1&C&!B2&B1&B&!A2&A1&A|E&D&C1&C&!B2&B1&B&!A2&A1&A|E&D&!C1&C&!B2&B1&B&!A2&A1&A|E&!D&!C1&C&B2&B1&B&!A2&A1&A|E&D&!C1&C&B2&B1&B&!A2&A1&A|E&D&C1&C&B2&B1&B&!A2&A1&A|E&!D&C1&C&B2&B1&B&!A2&A1&A|E&!D&C1&!C&B2&B1&B&!A2&A1&A|E&D&C1&!C&B2&B1&B&!A2&A1&A|E&D&!C1&!C&B2&B1&B&!A2&A1&A|E&!D&!C1&!C&B2&B1&B&!A2&A1&A|E&D&!C1&!C&B2&!B1&B&!A2&A1&A|E&D&C1&!C&B2&!B1&B&!A2&A1&A|E&!D&C1&C&B2&!B1&B&!A2&A1&A|E&D&C1&C&B2&!B1&B&!A2&A1&A|E&D&!C1&C&B2&!B1&B&!A2&A1&A|E&D&!C1&C&!B2&!B1&B&!A2&A1&A|E&D&C1&C&!B2&!B1&B&!A2&A1&A|E&!D&C1&C&!B2&!B1&B&!A2&A1&A|E&D&C1&!C&!B2&!B1&B&!A2&A1&A|E&D&!C1&!C&!B2&!B1&B&!A2&A1&A|E&!D&!C1&!C&!B2&!B1&B&A2&A1&A|E&D&!C1&!C&!B2&!B1&B&A2&A1&A|E&D&C1&!C&!B2&!B1&B&A2&A1&A|E&!D&C1&!C&!B2&!B1&B&A2&A1&A|E&!D&C1&C&!B2&!B1&B&A2&A1&A|E&D&C1&C&!B2&!B1&B&A2&A1&A|E&D&!C1&C&!B2&!B1&B&A2&A1&A|E&!D&!C1&C&!B2&!B1&B&A2&A1&A|E&!D&!C1&C&B2&!B1&B&A2&A1&A|E&D&!C1&C&B2&!B1&B&A2&A1&A|E&D&C1&C&B2&!B1&B&A2&A1&A|E&!D&C1&C&B2&!B1&B&A2&A1&A|E&!D&C1&!C&B2&!B1&B&A2&A1&A|E&D&C1&!C&B2&!B1&B&A2&A1&A|E&D&!C1&!C&B2&!B1&B&A2&A1&A|E&!D&!C1&!C&B2&!B1&B&A2&A1&A|E&!D&!C1&!C&B2&B1&B&A2&A1&A|E&D&!C1&!C&B2&B1&B&A2&A1&A|E&D&C1&!C&B2&B1&B&A2&A1&A|E&!D&C1&!C&B2&B1&B&A2&A1&A|E&!D&C1&C&B2&B1&B&A2&A1&A|E&D&C1&C&B2&B1&B&A2&A1&A|E&D&!C1&C&B2&B1&B&A2&A1&A|E&!D&!C1&C&B2&B1&B&A2&A1&A|E&!D&!C1&C&!B2&B1&B&A2&A1&A|E&D&!C1&C&!B2&B1&B&A2&A1&A|E&D&C1&C&!B2&B1&B&A2&A1&A|E&!D&C1&C&!B2&B1&B&A2&A1&A|E&!D&C1&!C&!B2&B1&B&A2&A1&A|E&D&C1&!C&!B2&B1&B&A2&A1&A|E&D&!C1&!C&!B2&B1&B&A2&A1&A|E&!D&!C1&!C&!B2&B1&B&A2&A1&A|E&!D&!C1&!C&!B2&B1&!B&A2&A1&A|E&D&!C1&!C&!B2&B1&!B&A2&A1&A|E&D&C1&!C&!B2&B1&!B&A2&A1&A|E&!D&C1&!C&!B2&B1&!B&A2&A1&A|E&!D&C1&C&!B2&B1&!B&A2&A1&A|E&D&C1&C&!B2&B1&!B&A2&A1&A|E&D&!C1&C&!B2&B1&!B&A2&A1&A|E&!D&!C1&C&!B2&B1&!B&A2&A1&A|E&!D&!C1&C&B2&B1&!B&A2&A1&A|E&D&!C1&C&B2&B1&!B&A2&A1&A|E&D&C1&C&B2&B1&!B&A2&A1&A|E&!D&C1&C&B2&B1&!B&A2&A1&A|E&!D&C1&!C&B2&B1&!B&A2&A1&A|E&D&C1&!C&B2&B1&!B&A2&A1&A|E&D&!C1&!C&B2&B1&!B&A2&A1&A|E&!D&!C1&!C&B2&B1&!B&A2&A1&A|E&!D&!C1&!C&B2&!B1&!B&A2&A1&A|E&D&!C1&!C&B2&!B1&!B&A2&A1&A|E&D&C1&!C&B2&!B1&!B&A2&A1&A|E&!D&C1&!C&B2&!B1&!B&A2&A1&A|E&!D&C1&C&B2&!B1&!B&A2&A1&A|E&D&C1&C&B2&!B1&!B&A2&A1&A|E&D&!C1&C&B2&!B1&!B&A2&A1&A|E&!D&!C1&C&B2&!B1&!B&A2&A1&A|E&!D&!C1&C&!B2&!B1&!B&A2&A1&A|E&D&!C1&C&!B2&!B1&!B&A2&A1&A|E&D&C1&C&!B2&!B1&!B&A2&A1&A|E&!D&C1&C&!B2&!B1&!B&A2&A1&A|E&!D&C1&!C&!B2&!B1&!B&A2&A1&A|E&D&C1&!C&!B2&!B1&!B&A2&A1&A|E&D&!C1&!C&!B2&!B1&!B&A2&A1&A|E&!D&!C1&!C&!B2&!B1&!B&A2&A1&A|E&D&!C1&!C&!B2&!B1&!B&A2&!A1&A|E&D&C1&!C&!B2&!B1&!B&A2&!A1&A|E&!D&C1&C&!B2&!B1&!B&A2&!A1&A|E&D&C1&C&!B2&!B1&!B&A2&!A1&A|E&D&!C1&C&!B2&!B1&!B&A2&!A1&A|E&D&!C1&C&B2&!B1&!B&A2&!A1&A|E&D&C1&C&B2&!B1&!B&A2&!A1&A|E&!D&C1&C&B2&!B1&!B&A2&!A1&A|E&D&C1&!C&B2&!B1&!B&A2&!A1&A|E&D&!C1&!C&B2&!B1&!B&A2&!A1&A|E&D&!C1&!C&B2&B1&!B&A2&!A1&A|E&D&C1&!C&B2&B1&!B&A2&!A1&A|E&!D&C1&C&B2&B1&!B&A2&!A1&A|E&D&C1&C&B2&B1&!B&A2&!A1&A|E&D&!C1&C&B2&B1&!B&A2&!A1&A|E&D&!C1&C&!B2&B1&!B&A2&!A1&A|E&D&C1&C&!B2&B1&!B&A2&!A1&A|E&!D&C1&C&!B2&B1&!B&A2&!A1&A|E&D&C1&!C&!B2&B1&!B&A2&!A1&A|E&D&!C1&!C&!B2&B1&!B&A2&!A1&A|E&D&!C1&!C&!B2&B1&B&A2&!A1&A|E&D&C1&!C&!B2&B1&B&A2&!A1&A|E&!D&C1&C&!B2&B1&B&A2&!A1&A|E&D&C1&C&!B2&B1&B&A2&!A1&A|E&D&!C1&C&!B2&B1&B&A2&!A1&A|E&!D&!C1&C&B2&B1&B&A2&!A1&A|E&D&!C1&C&B2&B1&B&A2&!A1&A|E&D&C1&C&B2&B1&B&A2&!A1&A|E&!D&C1&C&B2&B1&B&A2&!A1&A|E&!D&C1&!C&B2&B1&B&A2&!A1&A|E&D&C1&!C&B2&B1&B&A2&!A1&A|E&D&!C1&!C&B2&B1&B&A2&!A1&A|E&!D&!C1&!C&B2&B1&B&A2&!A1&A|E&D&!C1&!C&B2&!B1&B&A2&!A1&A|E&D&C1&!C&B2&!B1&B&A2&!A1&A|E&!D&C1&C&B2&!B1&B&A2&!A1&A|E&D&C1&C&B2&!B1&B&A2&!A1&A|E&D&!C1&C&B2&!B1&B&A2&!A1&A|E&D&!C1&C&!B2&!B1&B&A2&!A1&A|E&D&C1&C&!B2&!B1&B&A2&!A1&A|E&!D&C1&C&!B2&!B1&B&A2&!A1&A|E&D&C1&!C&!B2&!B1&B&A2&!A1&A|E&D&!C1&!C&!B2&!B1&B&A2&!A1&A|E&D&!C1&!C&!B2&!B1&B&!A2&!A1&A|E&D&C1&!C&!B2&!B1&B&!A2&!A1&A|E&!D&C1&C&!B2&!B1&B&!A2&!A1&A|E&D&C1&C&!B2&!B1&B&!A2&!A1&A|E&D&!C1&C&!B2&!B1&B&!A2&!A1&A|E&D&!C1&C&B2&!B1&B&!A2&!A1&A|E&D&C1&C&B2&!B1&B&!A2&!A1&A|E&!D&C1&C&B2&!B1&B&!A2&!A1&A|E&D&C1&!C&B2&!B1&B&!A2&!A1&A|E&D&!C1&!C&B2&!B1&B&!A2&!A1&A|E&!D&!C1&!C&B2&B1&B&!A2&!A1&A|E&D&!C1&!C&B2&B1&B&!A2&!A1&A|E&D&C1&!C&B2&B1&B&!A2&!A1&A|E&!D&C1&!C&B2&B1&B&!A2&!A1&A|E&!D&C1&C&B2&B1&B&!A2&!A1&A|E&D&C1&C&B2&B1&B&!A2&!A1&A|E&D&!C1&C&B2&B1&B&!A2&!A1&A|E&!D&!C1&C&B2&B1&B&!A2&!A1&A|E&D&!C1&C&!B2&B1&B&!A2&!A1&A|E&D&C1&C&!B2&B1&B&!A2&!A1&A|E&!D&C1&C&!B2&B1&B&!A2&!A1&A|E&D&C1&!C&!B2&B1&B&!A2&!A1&A|E&D&!C1&!C&!B2&B1&B&!A2&!A1&A|E&D&!C1&!C&!B2&B1&!B&!A2&!A1&A|E&D&C1&!C&!B2&B1&!B&!A2&!A1&A|E&!D&C1&C&!B2&B1&!B&!A2&!A1&A|E&D&C1&C&!B2&B1&!B&!A2&!A1&A|E&D&!C1&C&!B2&B1&!B&!A2&!A1&A|E&D&!C1&C&B2&B1&!B&!A2&!A1&A|E&D&C1&C&B2&B1&!B&!A2&!A1&A|E&!D&C1&C&B2&B1&!B&!A2&!A1&A|E&D&C1&!C&B2&B1&!B&!A2&!A1&A|E&D&!C1&!C&B2&B1&!B&!A2&!A1&A|E&D&!C1&!C&B2&!B1&!B&!A2&!A1&A|E&D&C1&!C&B2&!B1&!B&!A2&!A1&A|E&!D&C1&C&B2&!B1&!B&!A2&!A1&A|E&D&C1&C&B2&!B1&!B&!A2&!A1&A|E&D&!C1&C&B2&!B1&!B&!A2&!A1&A|E&D&!C1&C&!B2&!B1&!B&!A2&!A1&A|E&D&C1&C&!B2&!B1&!B&!A2&!A1&A|E&!D&C1&C&!B2&!B1&!B&!A2&!A1&A|E&D&C1&!C&!B2&!B1&!B&!A2&!A1&A|E&D&!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOAI33211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAAOI2222 -l AAAAOI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B1&!B&!A1&!A|D1&!D&!C1&!C&!B1&!B&!A1&!A|!D1&D&!C1&!C&!B1&!B&!A1&!A|!D1&D&C1&!C&!B1&!B&!A1&!A|D1&!D&C1&!C&!B1&!B&!A1&!A|!D1&!D&C1&!C&!B1&!B&!A1&!A|!D1&D&!C1&C&!B1&!B&!A1&!A|D1&!D&!C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&B1&!B&!A1&!A|D1&!D&!C1&C&B1&!B&!A1&!A|!D1&D&!C1&C&B1&!B&!A1&!A|!D1&!D&C1&!C&B1&!B&!A1&!A|D1&!D&C1&!C&B1&!B&!A1&!A|!D1&D&C1&!C&B1&!B&!A1&!A|!D1&D&!C1&!C&B1&!B&!A1&!A|D1&!D&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&C&!B1&B&!A1&!A|D1&!D&!C1&C&!B1&B&!A1&!A|!D1&D&!C1&C&!B1&B&!A1&!A|!D1&!D&C1&!C&!B1&B&!A1&!A|D1&!D&C1&!C&!B1&B&!A1&!A|!D1&D&C1&!C&!B1&B&!A1&!A|!D1&D&!C1&!C&!B1&B&!A1&!A|D1&!D&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&A1&!A|D1&!D&!C1&!C&!B1&B&A1&!A|!D1&D&!C1&!C&!B1&B&A1&!A|!D1&D&C1&!C&!B1&B&A1&!A|D1&!D&C1&!C&!B1&B&A1&!A|!D1&!D&C1&!C&!B1&B&A1&!A|!D1&D&!C1&C&!B1&B&A1&!A|D1&!D&!C1&C&!B1&B&A1&!A|!D1&!D&!C1&C&!B1&B&A1&!A|!D1&!D&!C1&!C&B1&!B&A1&!A|D1&!D&!C1&!C&B1&!B&A1&!A|!D1&D&!C1&!C&B1&!B&A1&!A|!D1&D&C1&!C&B1&!B&A1&!A|D1&!D&C1&!C&B1&!B&A1&!A|!D1&!D&C1&!C&B1&!B&A1&!A|!D1&D&!C1&C&B1&!B&A1&!A|D1&!D&!C1&C&B1&!B&A1&!A|!D1&!D&!C1&C&B1&!B&A1&!A|!D1&!D&!C1&C&!B1&!B&A1&!A|D1&!D&!C1&C&!B1&!B&A1&!A|!D1&D&!C1&C&!B1&!B&A1&!A|!D1&!D&C1&!C&!B1&!B&A1&!A|D1&!D&C1&!C&!B1&!B&A1&!A|!D1&D&C1&!C&!B1&!B&A1&!A|!D1&D&!C1&!C&!B1&!B&A1&!A|D1&!D&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&B&!A1&A|D1&!D&!C1&!C&!B1&B&!A1&A|!D1&D&!C1&!C&!B1&B&!A1&A|!D1&D&C1&!C&!B1&B&!A1&A|D1&!D&C1&!C&!B1&B&!A1&A|!D1&!D&C1&!C&!B1&B&!A1&A|!D1&D&!C1&C&!B1&B&!A1&A|D1&!D&!C1&C&!B1&B&!A1&A|!D1&!D&!C1&C&!B1&B&!A1&A|!D1&!D&!C1&!C&B1&!B&!A1&A|D1&!D&!C1&!C&B1&!B&!A1&A|!D1&D&!C1&!C&B1&!B&!A1&A|!D1&D&C1&!C&B1&!B&!A1&A|D1&!D&C1&!C&B1&!B&!A1&A|!D1&!D&C1&!C&B1&!B&!A1&A|!D1&D&!C1&C&B1&!B&!A1&A|D1&!D&!C1&C&B1&!B&!A1&A|!D1&!D&!C1&C&B1&!B&!A1&A|!D1&!D&!C1&C&!B1&!B&!A1&A|D1&!D&!C1&C&!B1&!B&!A1&A|!D1&D&!C1&C&!B1&!B&!A1&A|!D1&!D&C1&!C&!B1&!B&!A1&A|D1&!D&C1&!C&!B1&!B&!A1&A|!D1&D&C1&!C&!B1&!B&!A1&A|!D1&D&!C1&!C&!B1&!B&!A1&A|D1&!D&!C1&!C&!B1&!B&!A1&A|!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAAOI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOI21311 -l AOOAOI21311 -i E D C2 C1 C B A1 A -o Y -f Y=(!E&!D&!C2&!C1&!C&!B&!A1&!A|!E&D&!C2&!C1&!C&!B&!A1&!A|!E&D&C2&!C1&!C&!B&!A1&!A|!E&!D&C2&!C1&!C&!B&!A1&!A|!E&!D&C2&C1&!C&!B&!A1&!A|!E&D&C2&C1&!C&!B&!A1&!A|!E&D&!C2&C1&!C&!B&!A1&!A|!E&!D&!C2&C1&!C&!B&!A1&!A|!E&!D&!C2&C1&C&!B&!A1&!A|!E&D&!C2&C1&C&!B&!A1&!A|!E&D&C2&C1&C&!B&!A1&!A|!E&!D&C2&C1&C&!B&!A1&!A|!E&!D&C2&!C1&C&!B&!A1&!A|!E&D&C2&!C1&C&!B&!A1&!A|!E&D&!C2&!C1&C&!B&!A1&!A|!E&!D&!C2&!C1&C&!B&!A1&!A|!E&!D&!C2&!C1&C&B&!A1&!A|!E&!D&C2&!C1&C&B&!A1&!A|!E&!D&C2&C1&C&B&!A1&!A|!E&!D&!C2&C1&C&B&!A1&!A|!E&!D&!C2&C1&!C&B&!A1&!A|!E&!D&C2&C1&!C&B&!A1&!A|!E&!D&C2&!C1&!C&B&!A1&!A|!E&D&!C2&!C1&!C&B&!A1&!A|!E&!D&!C2&!C1&!C&B&!A1&!A|!E&!D&!C2&!C1&!C&B&A1&!A|!E&D&!C2&!C1&!C&B&A1&!A|!E&!D&C2&!C1&!C&B&A1&!A|!E&!D&C2&C1&!C&B&A1&!A|!E&!D&!C2&C1&!C&B&A1&!A|!E&!D&!C2&C1&C&B&A1&!A|!E&!D&C2&C1&C&B&A1&!A|!E&!D&C2&!C1&C&B&A1&!A|!E&!D&!C2&!C1&C&B&A1&!A|!E&!D&!C2&!C1&C&!B&A1&!A|!E&D&!C2&!C1&C&!B&A1&!A|!E&D&C2&!C1&C&!B&A1&!A|!E&!D&C2&!C1&C&!B&A1&!A|!E&!D&C2&C1&C&!B&A1&!A|!E&D&C2&C1&C&!B&A1&!A|!E&D&!C2&C1&C&!B&A1&!A|!E&!D&!C2&C1&C&!B&A1&!A|!E&!D&!C2&C1&!C&!B&A1&!A|!E&D&!C2&C1&!C&!B&A1&!A|!E&D&C2&C1&!C&!B&A1&!A|!E&!D&C2&C1&!C&!B&A1&!A|!E&!D&C2&!C1&!C&!B&A1&!A|!E&D&C2&!C1&!C&!B&A1&!A|!E&D&!C2&!C1&!C&!B&A1&!A|!E&!D&!C2&!C1&!C&!B&A1&!A|!E&!D&!C2&!C1&!C&!B&A1&A|!E&D&!C2&!C1&!C&!B&A1&A|!E&!D&C2&!C1&!C&!B&A1&A|!E&!D&C2&C1&!C&!B&A1&A|!E&!D&!C2&C1&!C&!B&A1&A|!E&!D&!C2&C1&C&!B&A1&A|!E&!D&C2&C1&C&!B&A1&A|!E&!D&C2&!C1&C&!B&A1&A|!E&!D&!C2&!C1&C&!B&A1&A|!E&!D&!C2&!C1&C&B&A1&A|!E&!D&C2&!C1&C&B&A1&A|!E&!D&C2&C1&C&B&A1&A|!E&!D&!C2&C1&C&B&A1&A|!E&!D&!C2&C1&!C&B&A1&A|!E&!D&C2&C1&!C&B&A1&A|!E&!D&C2&!C1&!C&B&A1&A|!E&D&!C2&!C1&!C&B&A1&A|!E&!D&!C2&!C1&!C&B&A1&A|!E&!D&!C2&!C1&!C&B&!A1&A|!E&D&!C2&!C1&!C&B&!A1&A|!E&!D&C2&!C1&!C&B&!A1&A|!E&!D&C2&C1&!C&B&!A1&A|!E&!D&!C2&C1&!C&B&!A1&A|!E&!D&!C2&C1&C&B&!A1&A|!E&!D&C2&C1&C&B&!A1&A|!E&!D&C2&!C1&C&B&!A1&A|!E&!D&!C2&!C1&C&B&!A1&A|!E&!D&!C2&!C1&C&!B&!A1&A|!E&D&!C2&!C1&C&!B&!A1&A|!E&D&C2&!C1&C&!B&!A1&A|!E&!D&C2&!C1&C&!B&!A1&A|!E&!D&C2&C1&C&!B&!A1&A|!E&D&C2&C1&C&!B&!A1&A|!E&D&!C2&C1&C&!B&!A1&A|!E&!D&!C2&C1&C&!B&!A1&A|!E&!D&!C2&C1&!C&!B&!A1&A|!E&D&!C2&C1&!C&!B&!A1&A|!E&D&C2&C1&!C&!B&!A1&A|!E&!D&C2&C1&!C&!B&!A1&A|!E&!D&C2&!C1&!C&!B&!A1&A|!E&D&C2&!C1&!C&!B&!A1&A|!E&D&!C2&!C1&!C&!B&!A1&A|!E&!D&!C2&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOI21311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOI3211 -l OOAOI3211 -i D C B1 B A2 A1 A -o Y -f Y=(!D&!C&!B1&!B&!A2&!A1&!A|!D&C&!B1&!B&!A2&!A1&!A|!D&C&B1&!B&!A2&!A1&!A|!D&!C&B1&!B&!A2&!A1&!A|!D&!C&B1&B&!A2&!A1&!A|!D&C&B1&B&!A2&!A1&!A|!D&C&!B1&B&!A2&!A1&!A|!D&!C&!B1&B&!A2&!A1&!A|!D&!C&!B1&B&A2&!A1&!A|!D&!C&B1&B&A2&!A1&!A|!D&!C&B1&!B&A2&!A1&!A|!D&C&!B1&!B&A2&!A1&!A|!D&!C&!B1&!B&A2&!A1&!A|!D&!C&!B1&!B&A2&A1&!A|!D&C&!B1&!B&A2&A1&!A|!D&!C&B1&!B&A2&A1&!A|!D&!C&B1&B&A2&A1&!A|!D&!C&!B1&B&A2&A1&!A|!D&!C&!B1&B&!A2&A1&!A|!D&!C&B1&B&!A2&A1&!A|!D&!C&B1&!B&!A2&A1&!A|!D&C&!B1&!B&!A2&A1&!A|!D&!C&!B1&!B&!A2&A1&!A|!D&!C&!B1&!B&!A2&A1&A|!D&C&!B1&!B&!A2&A1&A|!D&!C&B1&!B&!A2&A1&A|!D&!C&B1&B&!A2&A1&A|!D&!C&!B1&B&!A2&A1&A|!D&!C&!B1&B&A2&A1&A|!D&!C&B1&B&A2&A1&A|!D&!C&B1&!B&A2&A1&A|!D&C&!B1&!B&A2&A1&A|!D&!C&!B1&!B&A2&A1&A|!D&!C&!B1&!B&A2&!A1&A|!D&C&!B1&!B&A2&!A1&A|!D&!C&B1&!B&A2&!A1&A|!D&!C&B1&B&A2&!A1&A|!D&!C&!B1&B&A2&!A1&A|!D&!C&!B1&B&!A2&!A1&A|!D&!C&B1&B&!A2&!A1&A|!D&!C&B1&!B&!A2&!A1&A|!D&C&!B1&!B&!A2&!A1&A|!D&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOI3211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOAI2122 -l OAAOAI2122 -i D1 D C1 C B A1 A -o Y -f Y=!(D1&D&C1&C&!B&!A1&!A|D1&D&C1&C&B&!A1&!A|D1&D&!C1&!C&B&A1&!A|D1&D&C1&!C&B&A1&!A|D1&D&C1&C&B&A1&!A|D1&D&!C1&C&B&A1&!A|D1&D&C1&C&!B&A1&!A|D1&D&C1&C&!B&A1&A|D1&D&!C1&C&B&A1&A|D1&D&C1&C&B&A1&A|D1&D&C1&!C&B&A1&A|D1&D&!C1&!C&B&A1&A|D1&D&!C1&!C&B&!A1&A|D1&D&C1&!C&B&!A1&A|D1&D&C1&C&B&!A1&A|D1&D&!C1&C&B&!A1&A|D1&D&C1&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOAI2122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOOAI22131 -l OOAOOAI22131 -i E D2 D1 D C B1 B A1 A -o Y -f Y=!(E&!D2&!D1&D&C&!B1&!B&!A1&!A|E&D2&!D1&D&C&!B1&!B&!A1&!A|E&D2&D1&D&C&!B1&!B&!A1&!A|E&!D2&D1&D&C&!B1&!B&!A1&!A|E&!D2&D1&!D&C&!B1&!B&!A1&!A|E&D2&D1&!D&C&!B1&!B&!A1&!A|E&D2&!D1&!D&C&!B1&!B&!A1&!A|E&D2&!D1&!D&C&B1&!B&!A1&!A|E&D2&D1&!D&C&B1&!B&!A1&!A|E&!D2&D1&!D&C&B1&!B&!A1&!A|E&!D2&D1&D&C&B1&!B&!A1&!A|E&D2&D1&D&C&B1&!B&!A1&!A|E&D2&!D1&D&C&B1&!B&!A1&!A|E&!D2&!D1&D&C&B1&!B&!A1&!A|E&!D2&!D1&D&C&B1&B&!A1&!A|E&D2&!D1&D&C&B1&B&!A1&!A|E&D2&D1&D&C&B1&B&!A1&!A|E&!D2&D1&D&C&B1&B&!A1&!A|E&!D2&D1&!D&C&B1&B&!A1&!A|E&D2&D1&!D&C&B1&B&!A1&!A|E&D2&!D1&!D&C&B1&B&!A1&!A|E&D2&!D1&!D&C&!B1&B&!A1&!A|E&D2&D1&!D&C&!B1&B&!A1&!A|E&!D2&D1&!D&C&!B1&B&!A1&!A|E&!D2&D1&D&C&!B1&B&!A1&!A|E&D2&D1&D&C&!B1&B&!A1&!A|E&D2&!D1&D&C&!B1&B&!A1&!A|E&!D2&!D1&D&C&!B1&B&!A1&!A|E&D2&!D1&!D&!C&!B1&B&A1&!A|E&D2&D1&!D&!C&!B1&B&A1&!A|E&!D2&D1&!D&!C&!B1&B&A1&!A|E&!D2&D1&D&!C&!B1&B&A1&!A|E&D2&D1&D&!C&!B1&B&A1&!A|E&D2&!D1&D&!C&!B1&B&A1&!A|E&!D2&!D1&D&!C&!B1&B&A1&!A|E&!D2&!D1&D&C&!B1&B&A1&!A|E&D2&!D1&D&C&!B1&B&A1&!A|E&D2&D1&D&C&!B1&B&A1&!A|E&!D2&D1&D&C&!B1&B&A1&!A|E&!D2&D1&!D&C&!B1&B&A1&!A|E&D2&D1&!D&C&!B1&B&A1&!A|E&D2&!D1&!D&C&!B1&B&A1&!A|E&D2&!D1&!D&C&B1&B&A1&!A|E&D2&D1&!D&C&B1&B&A1&!A|E&!D2&D1&!D&C&B1&B&A1&!A|E&!D2&D1&D&C&B1&B&A1&!A|E&D2&D1&D&C&B1&B&A1&!A|E&D2&!D1&D&C&B1&B&A1&!A|E&!D2&!D1&D&C&B1&B&A1&!A|E&!D2&!D1&D&!C&B1&B&A1&!A|E&D2&!D1&D&!C&B1&B&A1&!A|E&D2&D1&D&!C&B1&B&A1&!A|E&!D2&D1&D&!C&B1&B&A1&!A|E&!D2&D1&!D&!C&B1&B&A1&!A|E&D2&D1&!D&!C&B1&B&A1&!A|E&D2&!D1&!D&!C&B1&B&A1&!A|E&D2&!D1&!D&!C&B1&!B&A1&!A|E&D2&D1&!D&!C&B1&!B&A1&!A|E&!D2&D1&!D&!C&B1&!B&A1&!A|E&!D2&D1&D&!C&B1&!B&A1&!A|E&D2&D1&D&!C&B1&!B&A1&!A|E&D2&!D1&D&!C&B1&!B&A1&!A|E&!D2&!D1&D&!C&B1&!B&A1&!A|E&!D2&!D1&D&C&B1&!B&A1&!A|E&D2&!D1&D&C&B1&!B&A1&!A|E&D2&D1&D&C&B1&!B&A1&!A|E&!D2&D1&D&C&B1&!B&A1&!A|E&!D2&D1&!D&C&B1&!B&A1&!A|E&D2&D1&!D&C&B1&!B&A1&!A|E&D2&!D1&!D&C&B1&!B&A1&!A|E&D2&!D1&!D&C&!B1&!B&A1&!A|E&D2&D1&!D&C&!B1&!B&A1&!A|E&!D2&D1&!D&C&!B1&!B&A1&!A|E&!D2&D1&D&C&!B1&!B&A1&!A|E&D2&D1&D&C&!B1&!B&A1&!A|E&D2&!D1&D&C&!B1&!B&A1&!A|E&!D2&!D1&D&C&!B1&!B&A1&!A|E&!D2&!D1&D&C&!B1&!B&A1&A|E&D2&!D1&D&C&!B1&!B&A1&A|E&D2&D1&D&C&!B1&!B&A1&A|E&!D2&D1&D&C&!B1&!B&A1&A|E&!D2&D1&!D&C&!B1&!B&A1&A|E&D2&D1&!D&C&!B1&!B&A1&A|E&D2&!D1&!D&C&!B1&!B&A1&A|E&D2&!D1&!D&C&B1&!B&A1&A|E&D2&D1&!D&C&B1&!B&A1&A|E&!D2&D1&!D&C&B1&!B&A1&A|E&!D2&D1&D&C&B1&!B&A1&A|E&D2&D1&D&C&B1&!B&A1&A|E&D2&!D1&D&C&B1&!B&A1&A|E&!D2&!D1&D&C&B1&!B&A1&A|E&!D2&!D1&D&!C&B1&!B&A1&A|E&D2&!D1&D&!C&B1&!B&A1&A|E&D2&D1&D&!C&B1&!B&A1&A|E&!D2&D1&D&!C&B1&!B&A1&A|E&!D2&D1&!D&!C&B1&!B&A1&A|E&D2&D1&!D&!C&B1&!B&A1&A|E&D2&!D1&!D&!C&B1&!B&A1&A|E&D2&!D1&!D&!C&B1&B&A1&A|E&D2&D1&!D&!C&B1&B&A1&A|E&!D2&D1&!D&!C&B1&B&A1&A|E&!D2&D1&D&!C&B1&B&A1&A|E&D2&D1&D&!C&B1&B&A1&A|E&D2&!D1&D&!C&B1&B&A1&A|E&!D2&!D1&D&!C&B1&B&A1&A|E&!D2&!D1&D&C&B1&B&A1&A|E&D2&!D1&D&C&B1&B&A1&A|E&D2&D1&D&C&B1&B&A1&A|E&!D2&D1&D&C&B1&B&A1&A|E&!D2&D1&!D&C&B1&B&A1&A|E&D2&D1&!D&C&B1&B&A1&A|E&D2&!D1&!D&C&B1&B&A1&A|E&D2&!D1&!D&C&!B1&B&A1&A|E&D2&D1&!D&C&!B1&B&A1&A|E&!D2&D1&!D&C&!B1&B&A1&A|E&!D2&D1&D&C&!B1&B&A1&A|E&D2&D1&D&C&!B1&B&A1&A|E&D2&!D1&D&C&!B1&B&A1&A|E&!D2&!D1&D&C&!B1&B&A1&A|E&!D2&!D1&D&!C&!B1&B&A1&A|E&D2&!D1&D&!C&!B1&B&A1&A|E&D2&D1&D&!C&!B1&B&A1&A|E&!D2&D1&D&!C&!B1&B&A1&A|E&!D2&D1&!D&!C&!B1&B&A1&A|E&D2&D1&!D&!C&!B1&B&A1&A|E&D2&!D1&!D&!C&!B1&B&A1&A|E&D2&!D1&!D&!C&!B1&B&!A1&A|E&D2&D1&!D&!C&!B1&B&!A1&A|E&!D2&D1&!D&!C&!B1&B&!A1&A|E&!D2&D1&D&!C&!B1&B&!A1&A|E&D2&D1&D&!C&!B1&B&!A1&A|E&D2&!D1&D&!C&!B1&B&!A1&A|E&!D2&!D1&D&!C&!B1&B&!A1&A|E&!D2&!D1&D&C&!B1&B&!A1&A|E&D2&!D1&D&C&!B1&B&!A1&A|E&D2&D1&D&C&!B1&B&!A1&A|E&!D2&D1&D&C&!B1&B&!A1&A|E&!D2&D1&!D&C&!B1&B&!A1&A|E&D2&D1&!D&C&!B1&B&!A1&A|E&D2&!D1&!D&C&!B1&B&!A1&A|E&D2&!D1&!D&C&B1&B&!A1&A|E&D2&D1&!D&C&B1&B&!A1&A|E&!D2&D1&!D&C&B1&B&!A1&A|E&!D2&D1&D&C&B1&B&!A1&A|E&D2&D1&D&C&B1&B&!A1&A|E&D2&!D1&D&C&B1&B&!A1&A|E&!D2&!D1&D&C&B1&B&!A1&A|E&!D2&!D1&D&!C&B1&B&!A1&A|E&D2&!D1&D&!C&B1&B&!A1&A|E&D2&D1&D&!C&B1&B&!A1&A|E&!D2&D1&D&!C&B1&B&!A1&A|E&!D2&D1&!D&!C&B1&B&!A1&A|E&D2&D1&!D&!C&B1&B&!A1&A|E&D2&!D1&!D&!C&B1&B&!A1&A|E&D2&!D1&!D&!C&B1&!B&!A1&A|E&D2&D1&!D&!C&B1&!B&!A1&A|E&!D2&D1&!D&!C&B1&!B&!A1&A|E&!D2&D1&D&!C&B1&!B&!A1&A|E&D2&D1&D&!C&B1&!B&!A1&A|E&D2&!D1&D&!C&B1&!B&!A1&A|E&!D2&!D1&D&!C&B1&!B&!A1&A|E&!D2&!D1&D&C&B1&!B&!A1&A|E&D2&!D1&D&C&B1&!B&!A1&A|E&D2&D1&D&C&B1&!B&!A1&A|E&!D2&D1&D&C&B1&!B&!A1&A|E&!D2&D1&!D&C&B1&!B&!A1&A|E&D2&D1&!D&C&B1&!B&!A1&A|E&D2&!D1&!D&C&B1&!B&!A1&A|E&D2&!D1&!D&C&!B1&!B&!A1&A|E&D2&D1&!D&C&!B1&!B&!A1&A|E&!D2&D1&!D&C&!B1&!B&!A1&A|E&!D2&D1&D&C&!B1&!B&!A1&A|E&D2&D1&D&C&!B1&!B&!A1&A|E&D2&!D1&D&C&!B1&!B&!A1&A|E&!D2&!D1&D&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOOAI22131.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOOOAI22222 -l AAAOOOAI22222 -i E1 E D1 D C1 C B1 B A1 A -o Y -f Y=!(!E1&E&D1&!D&C1&C&!B1&!B&!A1&!A|E1&E&D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&D1&D&C1&C&!B1&!B&!A1&!A|E1&E&D1&D&C1&C&!B1&!B&!A1&!A|!E1&E&D1&D&C1&C&!B1&!B&!A1&!A|!E1&E&!D1&D&C1&C&!B1&!B&!A1&!A|E1&E&!D1&D&C1&C&!B1&!B&!A1&!A|E1&!E&!D1&D&C1&C&!B1&!B&!A1&!A|E1&!E&!D1&D&C1&C&B1&!B&!A1&!A|E1&E&!D1&D&C1&C&B1&!B&!A1&!A|!E1&E&!D1&D&C1&C&B1&!B&!A1&!A|!E1&E&D1&D&C1&C&B1&!B&!A1&!A|E1&E&D1&D&C1&C&B1&!B&!A1&!A|E1&!E&D1&D&C1&C&B1&!B&!A1&!A|E1&!E&D1&!D&C1&C&B1&!B&!A1&!A|E1&E&D1&!D&C1&C&B1&!B&!A1&!A|!E1&E&D1&!D&C1&C&B1&!B&!A1&!A|!E1&E&D1&!D&!C1&!C&B1&B&!A1&!A|E1&E&D1&!D&!C1&!C&B1&B&!A1&!A|E1&!E&D1&!D&!C1&!C&B1&B&!A1&!A|E1&!E&D1&D&!C1&!C&B1&B&!A1&!A|E1&E&D1&D&!C1&!C&B1&B&!A1&!A|!E1&E&D1&D&!C1&!C&B1&B&!A1&!A|!E1&E&!D1&D&!C1&!C&B1&B&!A1&!A|E1&E&!D1&D&!C1&!C&B1&B&!A1&!A|E1&!E&!D1&D&!C1&!C&B1&B&!A1&!A|E1&!E&!D1&D&C1&!C&B1&B&!A1&!A|E1&E&!D1&D&C1&!C&B1&B&!A1&!A|!E1&E&!D1&D&C1&!C&B1&B&!A1&!A|!E1&E&D1&D&C1&!C&B1&B&!A1&!A|E1&E&D1&D&C1&!C&B1&B&!A1&!A|E1&!E&D1&D&C1&!C&B1&B&!A1&!A|E1&!E&D1&!D&C1&!C&B1&B&!A1&!A|E1&E&D1&!D&C1&!C&B1&B&!A1&!A|!E1&E&D1&!D&C1&!C&B1&B&!A1&!A|!E1&E&D1&!D&C1&C&B1&B&!A1&!A|E1&E&D1&!D&C1&C&B1&B&!A1&!A|E1&!E&D1&!D&C1&C&B1&B&!A1&!A|E1&!E&D1&D&C1&C&B1&B&!A1&!A|E1&E&D1&D&C1&C&B1&B&!A1&!A|!E1&E&D1&D&C1&C&B1&B&!A1&!A|!E1&E&!D1&D&C1&C&B1&B&!A1&!A|E1&E&!D1&D&C1&C&B1&B&!A1&!A|E1&!E&!D1&D&C1&C&B1&B&!A1&!A|E1&!E&!D1&D&!C1&C&B1&B&!A1&!A|E1&E&!D1&D&!C1&C&B1&B&!A1&!A|!E1&E&!D1&D&!C1&C&B1&B&!A1&!A|!E1&E&D1&D&!C1&C&B1&B&!A1&!A|E1&E&D1&D&!C1&C&B1&B&!A1&!A|E1&!E&D1&D&!C1&C&B1&B&!A1&!A|E1&!E&D1&!D&!C1&C&B1&B&!A1&!A|E1&E&D1&!D&!C1&C&B1&B&!A1&!A|!E1&E&D1&!D&!C1&C&B1&B&!A1&!A|E1&!E&!D1&D&C1&C&!B1&B&!A1&!A|E1&E&!D1&D&C1&C&!B1&B&!A1&!A|!E1&E&!D1&D&C1&C&!B1&B&!A1&!A|!E1&E&D1&D&C1&C&!B1&B&!A1&!A|E1&E&D1&D&C1&C&!B1&B&!A1&!A|E1&!E&D1&D&C1&C&!B1&B&!A1&!A|E1&!E&D1&!D&C1&C&!B1&B&!A1&!A|E1&E&D1&!D&C1&C&!B1&B&!A1&!A|!E1&E&D1&!D&C1&C&!B1&B&!A1&!A|!E1&E&D1&!D&C1&C&!B1&B&A1&!A|E1&E&D1&!D&C1&C&!B1&B&A1&!A|E1&!E&D1&!D&C1&C&!B1&B&A1&!A|E1&!E&D1&D&C1&C&!B1&B&A1&!A|E1&E&D1&D&C1&C&!B1&B&A1&!A|!E1&E&D1&D&C1&C&!B1&B&A1&!A|!E1&E&!D1&D&C1&C&!B1&B&A1&!A|E1&E&!D1&D&C1&C&!B1&B&A1&!A|E1&!E&!D1&D&C1&C&!B1&B&A1&!A|!E1&E&D1&!D&!C1&C&B1&B&A1&!A|E1&E&D1&!D&!C1&C&B1&B&A1&!A|E1&!E&D1&!D&!C1&C&B1&B&A1&!A|E1&!E&D1&D&!C1&C&B1&B&A1&!A|E1&E&D1&D&!C1&C&B1&B&A1&!A|!E1&E&D1&D&!C1&C&B1&B&A1&!A|!E1&E&!D1&D&!C1&C&B1&B&A1&!A|E1&E&!D1&D&!C1&C&B1&B&A1&!A|E1&!E&!D1&D&!C1&C&B1&B&A1&!A|E1&!E&!D1&D&C1&C&B1&B&A1&!A|E1&E&!D1&D&C1&C&B1&B&A1&!A|!E1&E&!D1&D&C1&C&B1&B&A1&!A|!E1&E&D1&D&C1&C&B1&B&A1&!A|E1&E&D1&D&C1&C&B1&B&A1&!A|E1&!E&D1&D&C1&C&B1&B&A1&!A|E1&!E&D1&!D&C1&C&B1&B&A1&!A|E1&E&D1&!D&C1&C&B1&B&A1&!A|!E1&E&D1&!D&C1&C&B1&B&A1&!A|!E1&E&D1&!D&C1&!C&B1&B&A1&!A|E1&E&D1&!D&C1&!C&B1&B&A1&!A|E1&!E&D1&!D&C1&!C&B1&B&A1&!A|E1&!E&D1&D&C1&!C&B1&B&A1&!A|E1&E&D1&D&C1&!C&B1&B&A1&!A|!E1&E&D1&D&C1&!C&B1&B&A1&!A|!E1&E&!D1&D&C1&!C&B1&B&A1&!A|E1&E&!D1&D&C1&!C&B1&B&A1&!A|E1&!E&!D1&D&C1&!C&B1&B&A1&!A|E1&!E&!D1&D&!C1&!C&B1&B&A1&!A|E1&E&!D1&D&!C1&!C&B1&B&A1&!A|!E1&E&!D1&D&!C1&!C&B1&B&A1&!A|!E1&E&D1&D&!C1&!C&B1&B&A1&!A|E1&E&D1&D&!C1&!C&B1&B&A1&!A|E1&!E&D1&D&!C1&!C&B1&B&A1&!A|E1&!E&D1&!D&!C1&!C&B1&B&A1&!A|E1&E&D1&!D&!C1&!C&B1&B&A1&!A|!E1&E&D1&!D&!C1&!C&B1&B&A1&!A|!E1&E&D1&!D&C1&C&B1&!B&A1&!A|E1&E&D1&!D&C1&C&B1&!B&A1&!A|E1&!E&D1&!D&C1&C&B1&!B&A1&!A|E1&!E&D1&D&C1&C&B1&!B&A1&!A|E1&E&D1&D&C1&C&B1&!B&A1&!A|!E1&E&D1&D&C1&C&B1&!B&A1&!A|!E1&E&!D1&D&C1&C&B1&!B&A1&!A|E1&E&!D1&D&C1&C&B1&!B&A1&!A|E1&!E&!D1&D&C1&C&B1&!B&A1&!A|E1&!E&!D1&D&C1&C&!B1&!B&A1&!A|E1&E&!D1&D&C1&C&!B1&!B&A1&!A|!E1&E&!D1&D&C1&C&!B1&!B&A1&!A|!E1&E&D1&D&C1&C&!B1&!B&A1&!A|E1&E&D1&D&C1&C&!B1&!B&A1&!A|E1&!E&D1&D&C1&C&!B1&!B&A1&!A|E1&!E&D1&!D&C1&C&!B1&!B&A1&!A|E1&E&D1&!D&C1&C&!B1&!B&A1&!A|!E1&E&D1&!D&C1&C&!B1&!B&A1&!A|!E1&E&D1&!D&!C1&!C&!B1&!B&A1&A|E1&E&D1&!D&!C1&!C&!B1&!B&A1&A|E1&!E&D1&!D&!C1&!C&!B1&!B&A1&A|E1&!E&D1&D&!C1&!C&!B1&!B&A1&A|E1&E&D1&D&!C1&!C&!B1&!B&A1&A|!E1&E&D1&D&!C1&!C&!B1&!B&A1&A|!E1&E&!D1&D&!C1&!C&!B1&!B&A1&A|E1&E&!D1&D&!C1&!C&!B1&!B&A1&A|E1&!E&!D1&D&!C1&!C&!B1&!B&A1&A|E1&!E&!D1&D&C1&!C&!B1&!B&A1&A|E1&E&!D1&D&C1&!C&!B1&!B&A1&A|!E1&E&!D1&D&C1&!C&!B1&!B&A1&A|!E1&E&D1&D&C1&!C&!B1&!B&A1&A|E1&E&D1&D&C1&!C&!B1&!B&A1&A|E1&!E&D1&D&C1&!C&!B1&!B&A1&A|E1&!E&D1&!D&C1&!C&!B1&!B&A1&A|E1&E&D1&!D&C1&!C&!B1&!B&A1&A|!E1&E&D1&!D&C1&!C&!B1&!B&A1&A|!E1&E&D1&!D&C1&C&!B1&!B&A1&A|E1&E&D1&!D&C1&C&!B1&!B&A1&A|E1&!E&D1&!D&C1&C&!B1&!B&A1&A|E1&!E&D1&D&C1&C&!B1&!B&A1&A|E1&E&D1&D&C1&C&!B1&!B&A1&A|!E1&E&D1&D&C1&C&!B1&!B&A1&A|!E1&E&!D1&D&C1&C&!B1&!B&A1&A|E1&E&!D1&D&C1&C&!B1&!B&A1&A|E1&!E&!D1&D&C1&C&!B1&!B&A1&A|E1&!E&!D1&D&!C1&C&!B1&!B&A1&A|E1&E&!D1&D&!C1&C&!B1&!B&A1&A|!E1&E&!D1&D&!C1&C&!B1&!B&A1&A|!E1&E&D1&D&!C1&C&!B1&!B&A1&A|E1&E&D1&D&!C1&C&!B1&!B&A1&A|E1&!E&D1&D&!C1&C&!B1&!B&A1&A|E1&!E&D1&!D&!C1&C&!B1&!B&A1&A|E1&E&D1&!D&!C1&C&!B1&!B&A1&A|!E1&E&D1&!D&!C1&C&!B1&!B&A1&A|!E1&E&D1&!D&!C1&C&B1&!B&A1&A|E1&E&D1&!D&!C1&C&B1&!B&A1&A|E1&!E&D1&!D&!C1&C&B1&!B&A1&A|E1&!E&D1&D&!C1&C&B1&!B&A1&A|E1&E&D1&D&!C1&C&B1&!B&A1&A|!E1&E&D1&D&!C1&C&B1&!B&A1&A|!E1&E&!D1&D&!C1&C&B1&!B&A1&A|E1&E&!D1&D&!C1&C&B1&!B&A1&A|E1&!E&!D1&D&!C1&C&B1&!B&A1&A|E1&!E&!D1&D&C1&C&B1&!B&A1&A|E1&E&!D1&D&C1&C&B1&!B&A1&A|!E1&E&!D1&D&C1&C&B1&!B&A1&A|!E1&E&D1&D&C1&C&B1&!B&A1&A|E1&E&D1&D&C1&C&B1&!B&A1&A|E1&!E&D1&D&C1&C&B1&!B&A1&A|E1&!E&D1&!D&C1&C&B1&!B&A1&A|E1&E&D1&!D&C1&C&B1&!B&A1&A|!E1&E&D1&!D&C1&C&B1&!B&A1&A|!E1&E&D1&!D&C1&!C&B1&!B&A1&A|E1&E&D1&!D&C1&!C&B1&!B&A1&A|E1&!E&D1&!D&C1&!C&B1&!B&A1&A|E1&!E&D1&D&C1&!C&B1&!B&A1&A|E1&E&D1&D&C1&!C&B1&!B&A1&A|!E1&E&D1&D&C1&!C&B1&!B&A1&A|!E1&E&!D1&D&C1&!C&B1&!B&A1&A|E1&E&!D1&D&C1&!C&B1&!B&A1&A|E1&!E&!D1&D&C1&!C&B1&!B&A1&A|E1&!E&!D1&D&!C1&!C&B1&!B&A1&A|E1&E&!D1&D&!C1&!C&B1&!B&A1&A|!E1&E&!D1&D&!C1&!C&B1&!B&A1&A|!E1&E&D1&D&!C1&!C&B1&!B&A1&A|E1&E&D1&D&!C1&!C&B1&!B&A1&A|E1&!E&D1&D&!C1&!C&B1&!B&A1&A|E1&!E&D1&!D&!C1&!C&B1&!B&A1&A|E1&E&D1&!D&!C1&!C&B1&!B&A1&A|!E1&E&D1&!D&!C1&!C&B1&!B&A1&A|!E1&E&D1&!D&!C1&!C&B1&B&A1&A|E1&E&D1&!D&!C1&!C&B1&B&A1&A|E1&!E&D1&!D&!C1&!C&B1&B&A1&A|E1&!E&D1&D&!C1&!C&B1&B&A1&A|E1&E&D1&D&!C1&!C&B1&B&A1&A|!E1&E&D1&D&!C1&!C&B1&B&A1&A|!E1&E&!D1&D&!C1&!C&B1&B&A1&A|E1&E&!D1&D&!C1&!C&B1&B&A1&A|E1&!E&!D1&D&!C1&!C&B1&B&A1&A|E1&!E&!D1&D&C1&!C&B1&B&A1&A|E1&E&!D1&D&C1&!C&B1&B&A1&A|!E1&E&!D1&D&C1&!C&B1&B&A1&A|!E1&E&D1&D&C1&!C&B1&B&A1&A|E1&E&D1&D&C1&!C&B1&B&A1&A|E1&!E&D1&D&C1&!C&B1&B&A1&A|E1&!E&D1&!D&C1&!C&B1&B&A1&A|E1&E&D1&!D&C1&!C&B1&B&A1&A|!E1&E&D1&!D&C1&!C&B1&B&A1&A|!E1&E&D1&!D&C1&C&B1&B&A1&A|E1&E&D1&!D&C1&C&B1&B&A1&A|E1&!E&D1&!D&C1&C&B1&B&A1&A|E1&!E&D1&D&C1&C&B1&B&A1&A|E1&E&D1&D&C1&C&B1&B&A1&A|!E1&E&D1&D&C1&C&B1&B&A1&A|!E1&E&!D1&D&C1&C&B1&B&A1&A|E1&E&!D1&D&C1&C&B1&B&A1&A|E1&!E&!D1&D&C1&C&B1&B&A1&A|E1&!E&!D1&D&!C1&C&B1&B&A1&A|E1&E&!D1&D&!C1&C&B1&B&A1&A|!E1&E&!D1&D&!C1&C&B1&B&A1&A|!E1&E&D1&D&!C1&C&B1&B&A1&A|E1&E&D1&D&!C1&C&B1&B&A1&A|E1&!E&D1&D&!C1&C&B1&B&A1&A|E1&!E&D1&!D&!C1&C&B1&B&A1&A|E1&E&D1&!D&!C1&C&B1&B&A1&A|!E1&E&D1&!D&!C1&C&B1&B&A1&A|!E1&E&D1&!D&!C1&C&!B1&B&A1&A|E1&E&D1&!D&!C1&C&!B1&B&A1&A|E1&!E&D1&!D&!C1&C&!B1&B&A1&A|E1&!E&D1&D&!C1&C&!B1&B&A1&A|E1&E&D1&D&!C1&C&!B1&B&A1&A|!E1&E&D1&D&!C1&C&!B1&B&A1&A|!E1&E&!D1&D&!C1&C&!B1&B&A1&A|E1&E&!D1&D&!C1&C&!B1&B&A1&A|E1&!E&!D1&D&!C1&C&!B1&B&A1&A|E1&!E&!D1&D&C1&C&!B1&B&A1&A|E1&E&!D1&D&C1&C&!B1&B&A1&A|!E1&E&!D1&D&C1&C&!B1&B&A1&A|!E1&E&D1&D&C1&C&!B1&B&A1&A|E1&E&D1&D&C1&C&!B1&B&A1&A|E1&!E&D1&D&C1&C&!B1&B&A1&A|E1&!E&D1&!D&C1&C&!B1&B&A1&A|E1&E&D1&!D&C1&C&!B1&B&A1&A|!E1&E&D1&!D&C1&C&!B1&B&A1&A|!E1&E&D1&!D&C1&!C&!B1&B&A1&A|E1&E&D1&!D&C1&!C&!B1&B&A1&A|E1&!E&D1&!D&C1&!C&!B1&B&A1&A|E1&!E&D1&D&C1&!C&!B1&B&A1&A|E1&E&D1&D&C1&!C&!B1&B&A1&A|!E1&E&D1&D&C1&!C&!B1&B&A1&A|!E1&E&!D1&D&C1&!C&!B1&B&A1&A|E1&E&!D1&D&C1&!C&!B1&B&A1&A|E1&!E&!D1&D&C1&!C&!B1&B&A1&A|E1&!E&!D1&D&!C1&!C&!B1&B&A1&A|E1&E&!D1&D&!C1&!C&!B1&B&A1&A|!E1&E&!D1&D&!C1&!C&!B1&B&A1&A|!E1&E&D1&D&!C1&!C&!B1&B&A1&A|E1&E&D1&D&!C1&!C&!B1&B&A1&A|E1&!E&D1&D&!C1&!C&!B1&B&A1&A|E1&!E&D1&!D&!C1&!C&!B1&B&A1&A|E1&E&D1&!D&!C1&!C&!B1&B&A1&A|!E1&E&D1&!D&!C1&!C&!B1&B&A1&A|!E1&E&D1&!D&C1&C&!B1&B&!A1&A|E1&E&D1&!D&C1&C&!B1&B&!A1&A|E1&!E&D1&!D&C1&C&!B1&B&!A1&A|E1&!E&D1&D&C1&C&!B1&B&!A1&A|E1&E&D1&D&C1&C&!B1&B&!A1&A|!E1&E&D1&D&C1&C&!B1&B&!A1&A|!E1&E&!D1&D&C1&C&!B1&B&!A1&A|E1&E&!D1&D&C1&C&!B1&B&!A1&A|E1&!E&!D1&D&C1&C&!B1&B&!A1&A|!E1&E&D1&!D&!C1&C&B1&B&!A1&A|E1&E&D1&!D&!C1&C&B1&B&!A1&A|E1&!E&D1&!D&!C1&C&B1&B&!A1&A|E1&!E&D1&D&!C1&C&B1&B&!A1&A|E1&E&D1&D&!C1&C&B1&B&!A1&A|!E1&E&D1&D&!C1&C&B1&B&!A1&A|!E1&E&!D1&D&!C1&C&B1&B&!A1&A|E1&E&!D1&D&!C1&C&B1&B&!A1&A|E1&!E&!D1&D&!C1&C&B1&B&!A1&A|E1&!E&!D1&D&C1&C&B1&B&!A1&A|E1&E&!D1&D&C1&C&B1&B&!A1&A|!E1&E&!D1&D&C1&C&B1&B&!A1&A|!E1&E&D1&D&C1&C&B1&B&!A1&A|E1&E&D1&D&C1&C&B1&B&!A1&A|E1&!E&D1&D&C1&C&B1&B&!A1&A|E1&!E&D1&!D&C1&C&B1&B&!A1&A|E1&E&D1&!D&C1&C&B1&B&!A1&A|!E1&E&D1&!D&C1&C&B1&B&!A1&A|!E1&E&D1&!D&C1&!C&B1&B&!A1&A|E1&E&D1&!D&C1&!C&B1&B&!A1&A|E1&!E&D1&!D&C1&!C&B1&B&!A1&A|E1&!E&D1&D&C1&!C&B1&B&!A1&A|E1&E&D1&D&C1&!C&B1&B&!A1&A|!E1&E&D1&D&C1&!C&B1&B&!A1&A|!E1&E&!D1&D&C1&!C&B1&B&!A1&A|E1&E&!D1&D&C1&!C&B1&B&!A1&A|E1&!E&!D1&D&C1&!C&B1&B&!A1&A|E1&!E&!D1&D&!C1&!C&B1&B&!A1&A|E1&E&!D1&D&!C1&!C&B1&B&!A1&A|!E1&E&!D1&D&!C1&!C&B1&B&!A1&A|!E1&E&D1&D&!C1&!C&B1&B&!A1&A|E1&E&D1&D&!C1&!C&B1&B&!A1&A|E1&!E&D1&D&!C1&!C&B1&B&!A1&A|E1&!E&D1&!D&!C1&!C&B1&B&!A1&A|E1&E&D1&!D&!C1&!C&B1&B&!A1&A|!E1&E&D1&!D&!C1&!C&B1&B&!A1&A|!E1&E&D1&!D&C1&C&B1&!B&!A1&A|E1&E&D1&!D&C1&C&B1&!B&!A1&A|E1&!E&D1&!D&C1&C&B1&!B&!A1&A|E1&!E&D1&D&C1&C&B1&!B&!A1&A|E1&E&D1&D&C1&C&B1&!B&!A1&A|!E1&E&D1&D&C1&C&B1&!B&!A1&A|!E1&E&!D1&D&C1&C&B1&!B&!A1&A|E1&E&!D1&D&C1&C&B1&!B&!A1&A|E1&!E&!D1&D&C1&C&B1&!B&!A1&A|E1&!E&!D1&D&C1&C&!B1&!B&!A1&A|E1&E&!D1&D&C1&C&!B1&!B&!A1&A|!E1&E&!D1&D&C1&C&!B1&!B&!A1&A|!E1&E&D1&D&C1&C&!B1&!B&!A1&A|E1&E&D1&D&C1&C&!B1&!B&!A1&A|E1&!E&D1&D&C1&C&!B1&!B&!A1&A|E1&!E&D1&!D&C1&C&!B1&!B&!A1&A|E1&E&D1&!D&C1&C&!B1&!B&!A1&A|!E1&E&D1&!D&C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOOOAI22222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAI3321 -l OOOAI3321 -i D C1 C B2 B1 B A2 A1 A -o Y -f Y=!(D&C1&!C&!B2&!B1&B&A2&!A1&!A|D&C1&C&!B2&!B1&B&A2&!A1&!A|D&!C1&C&!B2&!B1&B&A2&!A1&!A|D&!C1&C&B2&!B1&B&A2&!A1&!A|D&C1&C&B2&!B1&B&A2&!A1&!A|D&C1&!C&B2&!B1&B&A2&!A1&!A|D&C1&!C&B2&B1&B&A2&!A1&!A|D&C1&C&B2&B1&B&A2&!A1&!A|D&!C1&C&B2&B1&B&A2&!A1&!A|D&!C1&C&!B2&B1&B&A2&!A1&!A|D&C1&C&!B2&B1&B&A2&!A1&!A|D&C1&!C&!B2&B1&B&A2&!A1&!A|D&C1&!C&!B2&B1&!B&A2&!A1&!A|D&C1&C&!B2&B1&!B&A2&!A1&!A|D&!C1&C&!B2&B1&!B&A2&!A1&!A|D&!C1&C&B2&B1&!B&A2&!A1&!A|D&C1&C&B2&B1&!B&A2&!A1&!A|D&C1&!C&B2&B1&!B&A2&!A1&!A|D&C1&!C&B2&!B1&!B&A2&!A1&!A|D&C1&C&B2&!B1&!B&A2&!A1&!A|D&!C1&C&B2&!B1&!B&A2&!A1&!A|D&!C1&C&B2&!B1&!B&A2&A1&!A|D&C1&C&B2&!B1&!B&A2&A1&!A|D&C1&!C&B2&!B1&!B&A2&A1&!A|D&C1&!C&B2&B1&!B&A2&A1&!A|D&C1&C&B2&B1&!B&A2&A1&!A|D&!C1&C&B2&B1&!B&A2&A1&!A|D&!C1&C&!B2&B1&!B&A2&A1&!A|D&C1&C&!B2&B1&!B&A2&A1&!A|D&C1&!C&!B2&B1&!B&A2&A1&!A|D&C1&!C&!B2&B1&B&A2&A1&!A|D&C1&C&!B2&B1&B&A2&A1&!A|D&!C1&C&!B2&B1&B&A2&A1&!A|D&!C1&C&B2&B1&B&A2&A1&!A|D&C1&C&B2&B1&B&A2&A1&!A|D&C1&!C&B2&B1&B&A2&A1&!A|D&C1&!C&B2&!B1&B&A2&A1&!A|D&C1&C&B2&!B1&B&A2&A1&!A|D&!C1&C&B2&!B1&B&A2&A1&!A|D&!C1&C&!B2&!B1&B&A2&A1&!A|D&C1&C&!B2&!B1&B&A2&A1&!A|D&C1&!C&!B2&!B1&B&A2&A1&!A|D&C1&!C&!B2&!B1&B&!A2&A1&!A|D&C1&C&!B2&!B1&B&!A2&A1&!A|D&!C1&C&!B2&!B1&B&!A2&A1&!A|D&!C1&C&B2&!B1&B&!A2&A1&!A|D&C1&C&B2&!B1&B&!A2&A1&!A|D&C1&!C&B2&!B1&B&!A2&A1&!A|D&C1&!C&B2&B1&B&!A2&A1&!A|D&C1&C&B2&B1&B&!A2&A1&!A|D&!C1&C&B2&B1&B&!A2&A1&!A|D&!C1&C&!B2&B1&B&!A2&A1&!A|D&C1&C&!B2&B1&B&!A2&A1&!A|D&C1&!C&!B2&B1&B&!A2&A1&!A|D&C1&!C&!B2&B1&!B&!A2&A1&!A|D&C1&C&!B2&B1&!B&!A2&A1&!A|D&!C1&C&!B2&B1&!B&!A2&A1&!A|D&!C1&C&B2&B1&!B&!A2&A1&!A|D&C1&C&B2&B1&!B&!A2&A1&!A|D&C1&!C&B2&B1&!B&!A2&A1&!A|D&C1&!C&B2&!B1&!B&!A2&A1&!A|D&C1&C&B2&!B1&!B&!A2&A1&!A|D&!C1&C&B2&!B1&!B&!A2&A1&!A|D&!C1&C&B2&!B1&!B&!A2&A1&A|D&C1&C&B2&!B1&!B&!A2&A1&A|D&C1&!C&B2&!B1&!B&!A2&A1&A|D&C1&!C&B2&B1&!B&!A2&A1&A|D&C1&C&B2&B1&!B&!A2&A1&A|D&!C1&C&B2&B1&!B&!A2&A1&A|D&!C1&C&!B2&B1&!B&!A2&A1&A|D&C1&C&!B2&B1&!B&!A2&A1&A|D&C1&!C&!B2&B1&!B&!A2&A1&A|D&C1&!C&!B2&B1&B&!A2&A1&A|D&C1&C&!B2&B1&B&!A2&A1&A|D&!C1&C&!B2&B1&B&!A2&A1&A|D&!C1&C&B2&B1&B&!A2&A1&A|D&C1&C&B2&B1&B&!A2&A1&A|D&C1&!C&B2&B1&B&!A2&A1&A|D&C1&!C&B2&!B1&B&!A2&A1&A|D&C1&C&B2&!B1&B&!A2&A1&A|D&!C1&C&B2&!B1&B&!A2&A1&A|D&!C1&C&!B2&!B1&B&!A2&A1&A|D&C1&C&!B2&!B1&B&!A2&A1&A|D&C1&!C&!B2&!B1&B&!A2&A1&A|D&C1&!C&!B2&!B1&B&A2&A1&A|D&C1&C&!B2&!B1&B&A2&A1&A|D&!C1&C&!B2&!B1&B&A2&A1&A|D&!C1&C&B2&!B1&B&A2&A1&A|D&C1&C&B2&!B1&B&A2&A1&A|D&C1&!C&B2&!B1&B&A2&A1&A|D&C1&!C&B2&B1&B&A2&A1&A|D&C1&C&B2&B1&B&A2&A1&A|D&!C1&C&B2&B1&B&A2&A1&A|D&!C1&C&!B2&B1&B&A2&A1&A|D&C1&C&!B2&B1&B&A2&A1&A|D&C1&!C&!B2&B1&B&A2&A1&A|D&C1&!C&!B2&B1&!B&A2&A1&A|D&C1&C&!B2&B1&!B&A2&A1&A|D&!C1&C&!B2&B1&!B&A2&A1&A|D&!C1&C&B2&B1&!B&A2&A1&A|D&C1&C&B2&B1&!B&A2&A1&A|D&C1&!C&B2&B1&!B&A2&A1&A|D&C1&!C&B2&!B1&!B&A2&A1&A|D&C1&C&B2&!B1&!B&A2&A1&A|D&!C1&C&B2&!B1&!B&A2&A1&A|D&!C1&C&B2&!B1&!B&A2&!A1&A|D&C1&C&B2&!B1&!B&A2&!A1&A|D&C1&!C&B2&!B1&!B&A2&!A1&A|D&C1&!C&B2&B1&!B&A2&!A1&A|D&C1&C&B2&B1&!B&A2&!A1&A|D&!C1&C&B2&B1&!B&A2&!A1&A|D&!C1&C&!B2&B1&!B&A2&!A1&A|D&C1&C&!B2&B1&!B&A2&!A1&A|D&C1&!C&!B2&B1&!B&A2&!A1&A|D&C1&!C&!B2&B1&B&A2&!A1&A|D&C1&C&!B2&B1&B&A2&!A1&A|D&!C1&C&!B2&B1&B&A2&!A1&A|D&!C1&C&B2&B1&B&A2&!A1&A|D&C1&C&B2&B1&B&A2&!A1&A|D&C1&!C&B2&B1&B&A2&!A1&A|D&C1&!C&B2&!B1&B&A2&!A1&A|D&C1&C&B2&!B1&B&A2&!A1&A|D&!C1&C&B2&!B1&B&A2&!A1&A|D&!C1&C&!B2&!B1&B&A2&!A1&A|D&C1&C&!B2&!B1&B&A2&!A1&A|D&C1&!C&!B2&!B1&B&A2&!A1&A|D&C1&!C&!B2&!B1&B&!A2&!A1&A|D&C1&C&!B2&!B1&B&!A2&!A1&A|D&!C1&C&!B2&!B1&B&!A2&!A1&A|D&!C1&C&B2&!B1&B&!A2&!A1&A|D&C1&C&B2&!B1&B&!A2&!A1&A|D&C1&!C&B2&!B1&B&!A2&!A1&A|D&C1&!C&B2&B1&B&!A2&!A1&A|D&C1&C&B2&B1&B&!A2&!A1&A|D&!C1&C&B2&B1&B&!A2&!A1&A|D&!C1&C&!B2&B1&B&!A2&!A1&A|D&C1&C&!B2&B1&B&!A2&!A1&A|D&C1&!C&!B2&B1&B&!A2&!A1&A|D&C1&!C&!B2&B1&!B&!A2&!A1&A|D&C1&C&!B2&B1&!B&!A2&!A1&A|D&!C1&C&!B2&B1&!B&!A2&!A1&A|D&!C1&C&B2&B1&!B&!A2&!A1&A|D&C1&C&B2&B1&!B&!A2&!A1&A|D&C1&!C&B2&B1&!B&!A2&!A1&A|D&C1&!C&B2&!B1&!B&!A2&!A1&A|D&C1&C&B2&!B1&!B&!A2&!A1&A|D&!C1&C&B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAI3321.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOOAI22112 -l OOAOOAI22112 -i E1 E D C B1 B A1 A -o Y -f Y=!(!E1&E&D&!C&!B1&!B&!A1&!A|E1&E&D&!C&!B1&!B&!A1&!A|E1&!E&D&!C&!B1&!B&!A1&!A|E1&!E&D&C&!B1&!B&!A1&!A|E1&E&D&C&!B1&!B&!A1&!A|!E1&E&D&C&!B1&!B&!A1&!A|!E1&E&D&C&B1&!B&!A1&!A|E1&E&D&C&B1&!B&!A1&!A|E1&!E&D&C&B1&!B&!A1&!A|E1&!E&D&!C&B1&!B&!A1&!A|E1&E&D&!C&B1&!B&!A1&!A|!E1&E&D&!C&B1&!B&!A1&!A|!E1&E&D&!C&B1&B&!A1&!A|E1&E&D&!C&B1&B&!A1&!A|E1&!E&D&!C&B1&B&!A1&!A|E1&!E&D&C&B1&B&!A1&!A|E1&E&D&C&B1&B&!A1&!A|!E1&E&D&C&B1&B&!A1&!A|!E1&E&D&C&!B1&B&!A1&!A|E1&E&D&C&!B1&B&!A1&!A|E1&!E&D&C&!B1&B&!A1&!A|E1&!E&D&!C&!B1&B&!A1&!A|E1&E&D&!C&!B1&B&!A1&!A|!E1&E&D&!C&!B1&B&!A1&!A|!E1&E&D&!C&!B1&B&A1&!A|E1&E&D&!C&!B1&B&A1&!A|E1&!E&D&!C&!B1&B&A1&!A|E1&!E&D&C&!B1&B&A1&!A|E1&E&D&C&!B1&B&A1&!A|!E1&E&D&C&!B1&B&A1&!A|!E1&E&!D&C&!B1&B&A1&!A|E1&E&!D&C&!B1&B&A1&!A|E1&!E&!D&C&!B1&B&A1&!A|E1&!E&!D&C&B1&B&A1&!A|E1&E&!D&C&B1&B&A1&!A|!E1&E&!D&C&B1&B&A1&!A|!E1&E&D&C&B1&B&A1&!A|E1&E&D&C&B1&B&A1&!A|E1&!E&D&C&B1&B&A1&!A|E1&!E&D&!C&B1&B&A1&!A|E1&E&D&!C&B1&B&A1&!A|!E1&E&D&!C&B1&B&A1&!A|!E1&E&D&!C&B1&!B&A1&!A|E1&E&D&!C&B1&!B&A1&!A|E1&!E&D&!C&B1&!B&A1&!A|E1&!E&D&C&B1&!B&A1&!A|E1&E&D&C&B1&!B&A1&!A|!E1&E&D&C&B1&!B&A1&!A|!E1&E&!D&C&B1&!B&A1&!A|E1&E&!D&C&B1&!B&A1&!A|E1&!E&!D&C&B1&!B&A1&!A|!E1&E&D&C&!B1&!B&A1&!A|E1&E&D&C&!B1&!B&A1&!A|E1&!E&D&C&!B1&!B&A1&!A|E1&!E&D&!C&!B1&!B&A1&!A|E1&E&D&!C&!B1&!B&A1&!A|!E1&E&D&!C&!B1&!B&A1&!A|!E1&E&D&!C&!B1&!B&A1&A|E1&E&D&!C&!B1&!B&A1&A|E1&!E&D&!C&!B1&!B&A1&A|E1&!E&D&C&!B1&!B&A1&A|E1&E&D&C&!B1&!B&A1&A|!E1&E&D&C&!B1&!B&A1&A|E1&!E&!D&C&B1&!B&A1&A|E1&E&!D&C&B1&!B&A1&A|!E1&E&!D&C&B1&!B&A1&A|!E1&E&D&C&B1&!B&A1&A|E1&E&D&C&B1&!B&A1&A|E1&!E&D&C&B1&!B&A1&A|E1&!E&D&!C&B1&!B&A1&A|E1&E&D&!C&B1&!B&A1&A|!E1&E&D&!C&B1&!B&A1&A|!E1&E&D&!C&B1&B&A1&A|E1&E&D&!C&B1&B&A1&A|E1&!E&D&!C&B1&B&A1&A|E1&!E&D&C&B1&B&A1&A|E1&E&D&C&B1&B&A1&A|!E1&E&D&C&B1&B&A1&A|!E1&E&!D&C&B1&B&A1&A|E1&E&!D&C&B1&B&A1&A|E1&!E&!D&C&B1&B&A1&A|E1&!E&!D&C&!B1&B&A1&A|E1&E&!D&C&!B1&B&A1&A|!E1&E&!D&C&!B1&B&A1&A|!E1&E&D&C&!B1&B&A1&A|E1&E&D&C&!B1&B&A1&A|E1&!E&D&C&!B1&B&A1&A|E1&!E&D&!C&!B1&B&A1&A|E1&E&D&!C&!B1&B&A1&A|!E1&E&D&!C&!B1&B&A1&A|!E1&E&D&!C&!B1&B&!A1&A|E1&E&D&!C&!B1&B&!A1&A|E1&!E&D&!C&!B1&B&!A1&A|E1&!E&D&C&!B1&B&!A1&A|E1&E&D&C&!B1&B&!A1&A|!E1&E&D&C&!B1&B&!A1&A|!E1&E&!D&C&!B1&B&!A1&A|E1&E&!D&C&!B1&B&!A1&A|E1&!E&!D&C&!B1&B&!A1&A|E1&!E&!D&C&B1&B&!A1&A|E1&E&!D&C&B1&B&!A1&A|!E1&E&!D&C&B1&B&!A1&A|!E1&E&D&C&B1&B&!A1&A|E1&E&D&C&B1&B&!A1&A|E1&!E&D&C&B1&B&!A1&A|E1&!E&D&!C&B1&B&!A1&A|E1&E&D&!C&B1&B&!A1&A|!E1&E&D&!C&B1&B&!A1&A|!E1&E&D&!C&B1&!B&!A1&A|E1&E&D&!C&B1&!B&!A1&A|E1&!E&D&!C&B1&!B&!A1&A|E1&!E&D&C&B1&!B&!A1&A|E1&E&D&C&B1&!B&!A1&A|!E1&E&D&C&B1&!B&!A1&A|!E1&E&!D&C&B1&!B&!A1&A|E1&E&!D&C&B1&!B&!A1&A|E1&!E&!D&C&B1&!B&!A1&A|!E1&E&D&C&!B1&!B&!A1&A|E1&E&D&C&!B1&!B&!A1&A|E1&!E&D&C&!B1&!B&!A1&A|E1&!E&D&!C&!B1&!B&!A1&A|E1&E&D&!C&!B1&!B&!A1&A|!E1&E&D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOOAI22112.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAI32 -l OOAI32 -i B1 B A2 A1 A -o Y -f Y=(!B1&!B&!A2&!A1&!A|B1&!B&!A2&!A1&!A|B1&B&!A2&!A1&!A|!B1&B&!A2&!A1&!A|!B1&!B&A2&!A1&!A|!B1&!B&A2&A1&!A|!B1&!B&!A2&A1&!A|!B1&!B&!A2&A1&A|!B1&!B&A2&A1&A|!B1&!B&A2&!A1&A|!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAI32.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOOAI2142 -l AOOOAI2142 -i D1 D C3 C2 C1 C B A1 A -o Y -f Y=!(D1&!D&!C3&!C2&!C1&C&B&!A1&!A|D1&D&!C3&!C2&!C1&C&B&!A1&!A|!D1&D&!C3&!C2&!C1&C&B&!A1&!A|!D1&D&C3&!C2&!C1&C&B&!A1&!A|D1&D&C3&!C2&!C1&C&B&!A1&!A|D1&!D&C3&!C2&!C1&C&B&!A1&!A|D1&!D&C3&C2&!C1&C&B&!A1&!A|D1&D&C3&C2&!C1&C&B&!A1&!A|!D1&D&C3&C2&!C1&C&B&!A1&!A|!D1&D&!C3&C2&!C1&C&B&!A1&!A|D1&D&!C3&C2&!C1&C&B&!A1&!A|D1&!D&!C3&C2&!C1&C&B&!A1&!A|D1&!D&!C3&C2&C1&C&B&!A1&!A|D1&D&!C3&C2&C1&C&B&!A1&!A|!D1&D&!C3&C2&C1&C&B&!A1&!A|!D1&D&C3&C2&C1&C&B&!A1&!A|D1&D&C3&C2&C1&C&B&!A1&!A|D1&!D&C3&C2&C1&C&B&!A1&!A|D1&!D&C3&!C2&C1&C&B&!A1&!A|D1&D&C3&!C2&C1&C&B&!A1&!A|!D1&D&C3&!C2&C1&C&B&!A1&!A|!D1&D&!C3&!C2&C1&C&B&!A1&!A|D1&D&!C3&!C2&C1&C&B&!A1&!A|D1&!D&!C3&!C2&C1&C&B&!A1&!A|D1&!D&!C3&!C2&C1&!C&B&!A1&!A|D1&D&!C3&!C2&C1&!C&B&!A1&!A|!D1&D&!C3&!C2&C1&!C&B&!A1&!A|!D1&D&C3&!C2&C1&!C&B&!A1&!A|D1&D&C3&!C2&C1&!C&B&!A1&!A|D1&!D&C3&!C2&C1&!C&B&!A1&!A|D1&!D&C3&C2&C1&!C&B&!A1&!A|D1&D&C3&C2&C1&!C&B&!A1&!A|!D1&D&C3&C2&C1&!C&B&!A1&!A|!D1&D&!C3&C2&C1&!C&B&!A1&!A|D1&D&!C3&C2&C1&!C&B&!A1&!A|D1&!D&!C3&C2&C1&!C&B&!A1&!A|D1&!D&!C3&C2&!C1&!C&B&!A1&!A|D1&D&!C3&C2&!C1&!C&B&!A1&!A|!D1&D&!C3&C2&!C1&!C&B&!A1&!A|!D1&D&C3&C2&!C1&!C&B&!A1&!A|D1&D&C3&C2&!C1&!C&B&!A1&!A|D1&!D&C3&C2&!C1&!C&B&!A1&!A|D1&!D&C3&!C2&!C1&!C&B&!A1&!A|D1&D&C3&!C2&!C1&!C&B&!A1&!A|!D1&D&C3&!C2&!C1&!C&B&!A1&!A|!D1&D&C3&!C2&!C1&!C&B&A1&!A|D1&D&C3&!C2&!C1&!C&B&A1&!A|D1&!D&C3&!C2&!C1&!C&B&A1&!A|D1&!D&C3&C2&!C1&!C&B&A1&!A|D1&D&C3&C2&!C1&!C&B&A1&!A|!D1&D&C3&C2&!C1&!C&B&A1&!A|!D1&D&!C3&C2&!C1&!C&B&A1&!A|D1&D&!C3&C2&!C1&!C&B&A1&!A|D1&!D&!C3&C2&!C1&!C&B&A1&!A|D1&!D&!C3&C2&C1&!C&B&A1&!A|D1&D&!C3&C2&C1&!C&B&A1&!A|!D1&D&!C3&C2&C1&!C&B&A1&!A|!D1&D&C3&C2&C1&!C&B&A1&!A|D1&D&C3&C2&C1&!C&B&A1&!A|D1&!D&C3&C2&C1&!C&B&A1&!A|D1&!D&C3&!C2&C1&!C&B&A1&!A|D1&D&C3&!C2&C1&!C&B&A1&!A|!D1&D&C3&!C2&C1&!C&B&A1&!A|!D1&D&!C3&!C2&C1&!C&B&A1&!A|D1&D&!C3&!C2&C1&!C&B&A1&!A|D1&!D&!C3&!C2&C1&!C&B&A1&!A|D1&!D&!C3&!C2&C1&C&B&A1&!A|D1&D&!C3&!C2&C1&C&B&A1&!A|!D1&D&!C3&!C2&C1&C&B&A1&!A|!D1&D&C3&!C2&C1&C&B&A1&!A|D1&D&C3&!C2&C1&C&B&A1&!A|D1&!D&C3&!C2&C1&C&B&A1&!A|D1&!D&C3&C2&C1&C&B&A1&!A|D1&D&C3&C2&C1&C&B&A1&!A|!D1&D&C3&C2&C1&C&B&A1&!A|!D1&D&!C3&C2&C1&C&B&A1&!A|D1&D&!C3&C2&C1&C&B&A1&!A|D1&!D&!C3&C2&C1&C&B&A1&!A|D1&!D&!C3&C2&!C1&C&B&A1&!A|D1&D&!C3&C2&!C1&C&B&A1&!A|!D1&D&!C3&C2&!C1&C&B&A1&!A|!D1&D&C3&C2&!C1&C&B&A1&!A|D1&D&C3&C2&!C1&C&B&A1&!A|D1&!D&C3&C2&!C1&C&B&A1&!A|D1&!D&C3&!C2&!C1&C&B&A1&!A|D1&D&C3&!C2&!C1&C&B&A1&!A|!D1&D&C3&!C2&!C1&C&B&A1&!A|!D1&D&!C3&!C2&!C1&C&B&A1&!A|D1&D&!C3&!C2&!C1&C&B&A1&!A|D1&!D&!C3&!C2&!C1&C&B&A1&!A|!D1&D&C3&!C2&!C1&!C&!B&A1&A|D1&D&C3&!C2&!C1&!C&!B&A1&A|D1&!D&C3&!C2&!C1&!C&!B&A1&A|D1&!D&C3&C2&!C1&!C&!B&A1&A|D1&D&C3&C2&!C1&!C&!B&A1&A|!D1&D&C3&C2&!C1&!C&!B&A1&A|!D1&D&!C3&C2&!C1&!C&!B&A1&A|D1&D&!C3&C2&!C1&!C&!B&A1&A|D1&!D&!C3&C2&!C1&!C&!B&A1&A|D1&!D&!C3&C2&C1&!C&!B&A1&A|D1&D&!C3&C2&C1&!C&!B&A1&A|!D1&D&!C3&C2&C1&!C&!B&A1&A|!D1&D&C3&C2&C1&!C&!B&A1&A|D1&D&C3&C2&C1&!C&!B&A1&A|D1&!D&C3&C2&C1&!C&!B&A1&A|D1&!D&C3&!C2&C1&!C&!B&A1&A|D1&D&C3&!C2&C1&!C&!B&A1&A|!D1&D&C3&!C2&C1&!C&!B&A1&A|!D1&D&!C3&!C2&C1&!C&!B&A1&A|D1&D&!C3&!C2&C1&!C&!B&A1&A|D1&!D&!C3&!C2&C1&!C&!B&A1&A|D1&!D&!C3&!C2&C1&C&!B&A1&A|D1&D&!C3&!C2&C1&C&!B&A1&A|!D1&D&!C3&!C2&C1&C&!B&A1&A|!D1&D&C3&!C2&C1&C&!B&A1&A|D1&D&C3&!C2&C1&C&!B&A1&A|D1&!D&C3&!C2&C1&C&!B&A1&A|D1&!D&C3&C2&C1&C&!B&A1&A|D1&D&C3&C2&C1&C&!B&A1&A|!D1&D&C3&C2&C1&C&!B&A1&A|!D1&D&!C3&C2&C1&C&!B&A1&A|D1&D&!C3&C2&C1&C&!B&A1&A|D1&!D&!C3&C2&C1&C&!B&A1&A|D1&!D&!C3&C2&!C1&C&!B&A1&A|D1&D&!C3&C2&!C1&C&!B&A1&A|!D1&D&!C3&C2&!C1&C&!B&A1&A|!D1&D&C3&C2&!C1&C&!B&A1&A|D1&D&C3&C2&!C1&C&!B&A1&A|D1&!D&C3&C2&!C1&C&!B&A1&A|D1&!D&C3&!C2&!C1&C&!B&A1&A|D1&D&C3&!C2&!C1&C&!B&A1&A|!D1&D&C3&!C2&!C1&C&!B&A1&A|!D1&D&!C3&!C2&!C1&C&!B&A1&A|D1&D&!C3&!C2&!C1&C&!B&A1&A|D1&!D&!C3&!C2&!C1&C&!B&A1&A|D1&!D&!C3&!C2&!C1&C&B&A1&A|D1&D&!C3&!C2&!C1&C&B&A1&A|!D1&D&!C3&!C2&!C1&C&B&A1&A|!D1&D&C3&!C2&!C1&C&B&A1&A|D1&D&C3&!C2&!C1&C&B&A1&A|D1&!D&C3&!C2&!C1&C&B&A1&A|D1&!D&C3&C2&!C1&C&B&A1&A|D1&D&C3&C2&!C1&C&B&A1&A|!D1&D&C3&C2&!C1&C&B&A1&A|!D1&D&!C3&C2&!C1&C&B&A1&A|D1&D&!C3&C2&!C1&C&B&A1&A|D1&!D&!C3&C2&!C1&C&B&A1&A|D1&!D&!C3&C2&C1&C&B&A1&A|D1&D&!C3&C2&C1&C&B&A1&A|!D1&D&!C3&C2&C1&C&B&A1&A|!D1&D&C3&C2&C1&C&B&A1&A|D1&D&C3&C2&C1&C&B&A1&A|D1&!D&C3&C2&C1&C&B&A1&A|D1&!D&C3&!C2&C1&C&B&A1&A|D1&D&C3&!C2&C1&C&B&A1&A|!D1&D&C3&!C2&C1&C&B&A1&A|!D1&D&!C3&!C2&C1&C&B&A1&A|D1&D&!C3&!C2&C1&C&B&A1&A|D1&!D&!C3&!C2&C1&C&B&A1&A|D1&!D&!C3&!C2&C1&!C&B&A1&A|D1&D&!C3&!C2&C1&!C&B&A1&A|!D1&D&!C3&!C2&C1&!C&B&A1&A|!D1&D&C3&!C2&C1&!C&B&A1&A|D1&D&C3&!C2&C1&!C&B&A1&A|D1&!D&C3&!C2&C1&!C&B&A1&A|D1&!D&C3&C2&C1&!C&B&A1&A|D1&D&C3&C2&C1&!C&B&A1&A|!D1&D&C3&C2&C1&!C&B&A1&A|!D1&D&!C3&C2&C1&!C&B&A1&A|D1&D&!C3&C2&C1&!C&B&A1&A|D1&!D&!C3&C2&C1&!C&B&A1&A|D1&!D&!C3&C2&!C1&!C&B&A1&A|D1&D&!C3&C2&!C1&!C&B&A1&A|!D1&D&!C3&C2&!C1&!C&B&A1&A|!D1&D&C3&C2&!C1&!C&B&A1&A|D1&D&C3&C2&!C1&!C&B&A1&A|D1&!D&C3&C2&!C1&!C&B&A1&A|D1&!D&C3&!C2&!C1&!C&B&A1&A|D1&D&C3&!C2&!C1&!C&B&A1&A|!D1&D&C3&!C2&!C1&!C&B&A1&A|!D1&D&C3&!C2&!C1&!C&B&!A1&A|D1&D&C3&!C2&!C1&!C&B&!A1&A|D1&!D&C3&!C2&!C1&!C&B&!A1&A|D1&!D&C3&C2&!C1&!C&B&!A1&A|D1&D&C3&C2&!C1&!C&B&!A1&A|!D1&D&C3&C2&!C1&!C&B&!A1&A|!D1&D&!C3&C2&!C1&!C&B&!A1&A|D1&D&!C3&C2&!C1&!C&B&!A1&A|D1&!D&!C3&C2&!C1&!C&B&!A1&A|D1&!D&!C3&C2&C1&!C&B&!A1&A|D1&D&!C3&C2&C1&!C&B&!A1&A|!D1&D&!C3&C2&C1&!C&B&!A1&A|!D1&D&C3&C2&C1&!C&B&!A1&A|D1&D&C3&C2&C1&!C&B&!A1&A|D1&!D&C3&C2&C1&!C&B&!A1&A|D1&!D&C3&!C2&C1&!C&B&!A1&A|D1&D&C3&!C2&C1&!C&B&!A1&A|!D1&D&C3&!C2&C1&!C&B&!A1&A|!D1&D&!C3&!C2&C1&!C&B&!A1&A|D1&D&!C3&!C2&C1&!C&B&!A1&A|D1&!D&!C3&!C2&C1&!C&B&!A1&A|D1&!D&!C3&!C2&C1&C&B&!A1&A|D1&D&!C3&!C2&C1&C&B&!A1&A|!D1&D&!C3&!C2&C1&C&B&!A1&A|!D1&D&C3&!C2&C1&C&B&!A1&A|D1&D&C3&!C2&C1&C&B&!A1&A|D1&!D&C3&!C2&C1&C&B&!A1&A|D1&!D&C3&C2&C1&C&B&!A1&A|D1&D&C3&C2&C1&C&B&!A1&A|!D1&D&C3&C2&C1&C&B&!A1&A|!D1&D&!C3&C2&C1&C&B&!A1&A|D1&D&!C3&C2&C1&C&B&!A1&A|D1&!D&!C3&C2&C1&C&B&!A1&A|D1&!D&!C3&C2&!C1&C&B&!A1&A|D1&D&!C3&C2&!C1&C&B&!A1&A|!D1&D&!C3&C2&!C1&C&B&!A1&A|!D1&D&C3&C2&!C1&C&B&!A1&A|D1&D&C3&C2&!C1&C&B&!A1&A|D1&!D&C3&C2&!C1&C&B&!A1&A|D1&!D&C3&!C2&!C1&C&B&!A1&A|D1&D&C3&!C2&!C1&C&B&!A1&A|!D1&D&C3&!C2&!C1&C&B&!A1&A|!D1&D&!C3&!C2&!C1&C&B&!A1&A|D1&D&!C3&!C2&!C1&C&B&!A1&A|D1&!D&!C3&!C2&!C1&C&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOOAI2142.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n MUX10 -l MUX10 -i IN0 IN1 IN2 IN3 IN4 IN5 IN6 IN7 IN8 IN9 S0 S1 S2 S3 S4 S5 S6 S7 S8 S9 -o Z -f 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist MUX10.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAOI211211 -l OAOOAOI211211 -i F E D1 D C B A1 A -o Y -f Y=(!F&!E&!D1&!D&!C&!B&!A1&!A|!F&E&!D1&!D&!C&!B&!A1&!A|!F&E&D1&!D&!C&!B&!A1&!A|!F&!E&D1&!D&!C&!B&!A1&!A|!F&!E&D1&D&!C&!B&!A1&!A|!F&E&D1&D&!C&!B&!A1&!A|!F&E&!D1&D&!C&!B&!A1&!A|!F&!E&!D1&D&!C&!B&!A1&!A|!F&!E&!D1&D&C&!B&!A1&!A|!F&!E&D1&D&C&!B&!A1&!A|!F&!E&D1&!D&C&!B&!A1&!A|!F&E&!D1&!D&C&!B&!A1&!A|!F&!E&!D1&!D&C&!B&!A1&!A|!F&!E&!D1&!D&C&B&!A1&!A|!F&E&!D1&!D&C&B&!A1&!A|!F&!E&D1&!D&C&B&!A1&!A|!F&!E&D1&D&C&B&!A1&!A|!F&!E&!D1&D&C&B&!A1&!A|!F&!E&!D1&D&!C&B&!A1&!A|!F&E&!D1&D&!C&B&!A1&!A|!F&E&D1&D&!C&B&!A1&!A|!F&!E&D1&D&!C&B&!A1&!A|!F&!E&D1&!D&!C&B&!A1&!A|!F&E&D1&!D&!C&B&!A1&!A|!F&E&!D1&!D&!C&B&!A1&!A|!F&!E&!D1&!D&!C&B&!A1&!A|!F&!E&!D1&!D&!C&B&A1&!A|!F&E&!D1&!D&!C&B&A1&!A|!F&!E&D1&!D&!C&B&A1&!A|!F&!E&D1&D&!C&B&A1&!A|!F&!E&!D1&D&!C&B&A1&!A|!F&!E&!D1&D&C&B&A1&!A|!F&!E&D1&D&C&B&A1&!A|!F&!E&D1&!D&C&B&A1&!A|!F&E&!D1&!D&C&B&A1&!A|!F&!E&!D1&!D&C&B&A1&!A|!F&!E&!D1&!D&C&!B&A1&!A|!F&E&!D1&!D&C&!B&A1&!A|!F&!E&D1&!D&C&!B&A1&!A|!F&!E&D1&D&C&!B&A1&!A|!F&!E&!D1&D&C&!B&A1&!A|!F&!E&!D1&D&!C&!B&A1&!A|!F&E&!D1&D&!C&!B&A1&!A|!F&E&D1&D&!C&!B&A1&!A|!F&!E&D1&D&!C&!B&A1&!A|!F&!E&D1&!D&!C&!B&A1&!A|!F&E&D1&!D&!C&!B&A1&!A|!F&E&!D1&!D&!C&!B&A1&!A|!F&!E&!D1&!D&!C&!B&A1&!A|!F&!E&!D1&!D&!C&!B&A1&A|!F&E&!D1&!D&!C&!B&A1&A|!F&E&D1&!D&!C&!B&A1&A|!F&!E&D1&!D&!C&!B&A1&A|!F&!E&D1&D&!C&!B&A1&A|!F&E&D1&D&!C&!B&A1&A|!F&E&!D1&D&!C&!B&A1&A|!F&!E&!D1&D&!C&!B&A1&A|!F&!E&!D1&D&C&!B&A1&A|!F&!E&D1&D&C&!B&A1&A|!F&!E&D1&!D&C&!B&A1&A|!F&E&!D1&!D&C&!B&A1&A|!F&!E&!D1&!D&C&!B&A1&A|!F&!E&!D1&!D&C&B&A1&A|!F&E&!D1&!D&C&B&A1&A|!F&!E&D1&!D&C&B&A1&A|!F&!E&D1&D&C&B&A1&A|!F&!E&!D1&D&C&B&A1&A|!F&!E&!D1&D&!C&B&A1&A|!F&!E&D1&D&!C&B&A1&A|!F&!E&D1&!D&!C&B&A1&A|!F&E&!D1&!D&!C&B&A1&A|!F&!E&!D1&!D&!C&B&A1&A|!F&!E&!D1&!D&!C&B&!A1&A|!F&E&!D1&!D&!C&B&!A1&A|!F&!E&D1&!D&!C&B&!A1&A|!F&!E&D1&D&!C&B&!A1&A|!F&!E&!D1&D&!C&B&!A1&A|!F&!E&!D1&D&C&B&!A1&A|!F&!E&D1&D&C&B&!A1&A|!F&!E&D1&!D&C&B&!A1&A|!F&E&!D1&!D&C&B&!A1&A|!F&!E&!D1&!D&C&B&!A1&A|!F&!E&!D1&!D&C&!B&!A1&A|!F&E&!D1&!D&C&!B&!A1&A|!F&!E&D1&!D&C&!B&!A1&A|!F&!E&D1&D&C&!B&!A1&A|!F&!E&!D1&D&C&!B&!A1&A|!F&!E&!D1&D&!C&!B&!A1&A|!F&E&!D1&D&!C&!B&!A1&A|!F&E&D1&D&!C&!B&!A1&A|!F&!E&D1&D&!C&!B&!A1&A|!F&!E&D1&!D&!C&!B&!A1&A|!F&E&D1&!D&!C&!B&!A1&A|!F&E&!D1&!D&!C&!B&!A1&A|!F&!E&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAOI211211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAI312 -l AOOAI312 -i C1 C B A2 A1 A -o Y -f Y=!(!C1&C&B&!A2&!A1&!A|C1&C&B&!A2&!A1&!A|C1&!C&B&!A2&!A1&!A|C1&!C&B&A2&!A1&!A|C1&C&B&A2&!A1&!A|!C1&C&B&A2&!A1&!A|!C1&C&B&A2&A1&!A|C1&C&B&A2&A1&!A|C1&!C&B&A2&A1&!A|C1&!C&B&!A2&A1&!A|C1&C&B&!A2&A1&!A|!C1&C&B&!A2&A1&!A|!C1&C&B&!A2&A1&A|C1&C&B&!A2&A1&A|C1&!C&B&!A2&A1&A|C1&!C&B&A2&A1&A|C1&C&B&A2&A1&A|!C1&C&B&A2&A1&A|!C1&C&!B&A2&A1&A|C1&C&!B&A2&A1&A|C1&!C&!B&A2&A1&A|!C1&C&B&A2&!A1&A|C1&C&B&A2&!A1&A|C1&!C&B&A2&!A1&A|C1&!C&B&!A2&!A1&A|C1&C&B&!A2&!A1&A|!C1&C&B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAI312.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAI2211 -l AAOAI2211 -i D C B1 B A1 A -o Y -f Y=!(D&C&!B1&!B&!A1&!A|D&C&B1&!B&!A1&!A|D&!C&B1&B&!A1&!A|D&C&B1&B&!A1&!A|D&C&!B1&B&!A1&!A|D&C&!B1&B&A1&!A|D&C&B1&B&A1&!A|D&!C&B1&B&A1&!A|D&C&B1&!B&A1&!A|D&C&!B1&!B&A1&!A|D&!C&!B1&!B&A1&A|D&C&!B1&!B&A1&A|D&C&B1&!B&A1&A|D&!C&B1&!B&A1&A|D&!C&B1&B&A1&A|D&C&B1&B&A1&A|D&C&!B1&B&A1&A|D&!C&!B1&B&A1&A|D&C&!B1&B&!A1&A|D&C&B1&B&!A1&A|D&!C&B1&B&!A1&A|D&C&B1&!B&!A1&A|D&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAI2211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOAI22311 -l OOAAOAI22311 -i E D C2 C1 C B1 B A1 A -o Y -f Y=!(E&D&!C2&!C1&!C&!B1&!B&!A1&!A|E&D&C2&!C1&!C&!B1&!B&!A1&!A|E&D&C2&C1&!C&!B1&!B&!A1&!A|E&D&!C2&C1&!C&!B1&!B&!A1&!A|E&D&!C2&C1&C&!B1&!B&!A1&!A|E&D&C2&C1&C&!B1&!B&!A1&!A|E&!D&C2&C1&C&!B1&!B&!A1&!A|E&D&C2&!C1&C&!B1&!B&!A1&!A|E&D&!C2&!C1&C&!B1&!B&!A1&!A|E&D&!C2&!C1&C&B1&!B&!A1&!A|E&D&C2&!C1&C&B1&!B&!A1&!A|E&!D&C2&C1&C&B1&!B&!A1&!A|E&D&C2&C1&C&B1&!B&!A1&!A|E&D&!C2&C1&C&B1&!B&!A1&!A|E&D&!C2&C1&!C&B1&!B&!A1&!A|E&D&C2&C1&!C&B1&!B&!A1&!A|E&D&C2&!C1&!C&B1&!B&!A1&!A|E&D&!C2&!C1&!C&B1&!B&!A1&!A|E&D&!C2&!C1&!C&B1&B&!A1&!A|E&D&C2&!C1&!C&B1&B&!A1&!A|E&D&C2&C1&!C&B1&B&!A1&!A|E&D&!C2&C1&!C&B1&B&!A1&!A|E&D&!C2&C1&C&B1&B&!A1&!A|E&D&C2&C1&C&B1&B&!A1&!A|E&!D&C2&C1&C&B1&B&!A1&!A|E&D&C2&!C1&C&B1&B&!A1&!A|E&D&!C2&!C1&C&B1&B&!A1&!A|E&D&!C2&!C1&C&!B1&B&!A1&!A|E&D&C2&!C1&C&!B1&B&!A1&!A|E&!D&C2&C1&C&!B1&B&!A1&!A|E&D&C2&C1&C&!B1&B&!A1&!A|E&D&!C2&C1&C&!B1&B&!A1&!A|E&D&!C2&C1&!C&!B1&B&!A1&!A|E&D&C2&C1&!C&!B1&B&!A1&!A|E&D&C2&!C1&!C&!B1&B&!A1&!A|E&D&!C2&!C1&!C&!B1&B&!A1&!A|E&!D&!C2&!C1&!C&!B1&B&A1&!A|E&D&!C2&!C1&!C&!B1&B&A1&!A|E&D&C2&!C1&!C&!B1&B&A1&!A|E&!D&C2&!C1&!C&!B1&B&A1&!A|E&!D&C2&C1&!C&!B1&B&A1&!A|E&D&C2&C1&!C&!B1&B&A1&!A|E&D&!C2&C1&!C&!B1&B&A1&!A|E&!D&!C2&C1&!C&!B1&B&A1&!A|E&!D&!C2&C1&C&!B1&B&A1&!A|E&D&!C2&C1&C&!B1&B&A1&!A|E&D&C2&C1&C&!B1&B&A1&!A|E&!D&C2&C1&C&!B1&B&A1&!A|E&!D&C2&!C1&C&!B1&B&A1&!A|E&D&C2&!C1&C&!B1&B&A1&!A|E&D&!C2&!C1&C&!B1&B&A1&!A|E&!D&!C2&!C1&C&!B1&B&A1&!A|E&!D&!C2&!C1&C&B1&B&A1&!A|E&D&!C2&!C1&C&B1&B&A1&!A|E&D&C2&!C1&C&B1&B&A1&!A|E&!D&C2&!C1&C&B1&B&A1&!A|E&!D&C2&C1&C&B1&B&A1&!A|E&D&C2&C1&C&B1&B&A1&!A|E&D&!C2&C1&C&B1&B&A1&!A|E&!D&!C2&C1&C&B1&B&A1&!A|E&!D&!C2&C1&!C&B1&B&A1&!A|E&D&!C2&C1&!C&B1&B&A1&!A|E&D&C2&C1&!C&B1&B&A1&!A|E&!D&C2&C1&!C&B1&B&A1&!A|E&!D&C2&!C1&!C&B1&B&A1&!A|E&D&C2&!C1&!C&B1&B&A1&!A|E&D&!C2&!C1&!C&B1&B&A1&!A|E&!D&!C2&!C1&!C&B1&B&A1&!A|E&!D&!C2&!C1&!C&B1&!B&A1&!A|E&D&!C2&!C1&!C&B1&!B&A1&!A|E&D&C2&!C1&!C&B1&!B&A1&!A|E&!D&C2&!C1&!C&B1&!B&A1&!A|E&!D&C2&C1&!C&B1&!B&A1&!A|E&D&C2&C1&!C&B1&!B&A1&!A|E&D&!C2&C1&!C&B1&!B&A1&!A|E&!D&!C2&C1&!C&B1&!B&A1&!A|E&!D&!C2&C1&C&B1&!B&A1&!A|E&D&!C2&C1&C&B1&!B&A1&!A|E&D&C2&C1&C&B1&!B&A1&!A|E&!D&C2&C1&C&B1&!B&A1&!A|E&!D&C2&!C1&C&B1&!B&A1&!A|E&D&C2&!C1&C&B1&!B&A1&!A|E&D&!C2&!C1&C&B1&!B&A1&!A|E&!D&!C2&!C1&C&B1&!B&A1&!A|E&D&!C2&!C1&C&!B1&!B&A1&!A|E&D&C2&!C1&C&!B1&!B&A1&!A|E&!D&C2&C1&C&!B1&!B&A1&!A|E&D&C2&C1&C&!B1&!B&A1&!A|E&D&!C2&C1&C&!B1&!B&A1&!A|E&D&!C2&C1&!C&!B1&!B&A1&!A|E&D&C2&C1&!C&!B1&!B&A1&!A|E&D&C2&!C1&!C&!B1&!B&A1&!A|E&D&!C2&!C1&!C&!B1&!B&A1&!A|E&D&!C2&!C1&!C&!B1&!B&A1&A|E&D&C2&!C1&!C&!B1&!B&A1&A|E&D&C2&C1&!C&!B1&!B&A1&A|E&D&!C2&C1&!C&!B1&!B&A1&A|E&D&!C2&C1&C&!B1&!B&A1&A|E&D&C2&C1&C&!B1&!B&A1&A|E&!D&C2&C1&C&!B1&!B&A1&A|E&D&C2&!C1&C&!B1&!B&A1&A|E&D&!C2&!C1&C&!B1&!B&A1&A|E&!D&!C2&!C1&C&B1&!B&A1&A|E&D&!C2&!C1&C&B1&!B&A1&A|E&D&C2&!C1&C&B1&!B&A1&A|E&!D&C2&!C1&C&B1&!B&A1&A|E&!D&C2&C1&C&B1&!B&A1&A|E&D&C2&C1&C&B1&!B&A1&A|E&D&!C2&C1&C&B1&!B&A1&A|E&!D&!C2&C1&C&B1&!B&A1&A|E&!D&!C2&C1&!C&B1&!B&A1&A|E&D&!C2&C1&!C&B1&!B&A1&A|E&D&C2&C1&!C&B1&!B&A1&A|E&!D&C2&C1&!C&B1&!B&A1&A|E&!D&C2&!C1&!C&B1&!B&A1&A|E&D&C2&!C1&!C&B1&!B&A1&A|E&D&!C2&!C1&!C&B1&!B&A1&A|E&!D&!C2&!C1&!C&B1&!B&A1&A|E&!D&!C2&!C1&!C&B1&B&A1&A|E&D&!C2&!C1&!C&B1&B&A1&A|E&D&C2&!C1&!C&B1&B&A1&A|E&!D&C2&!C1&!C&B1&B&A1&A|E&!D&C2&C1&!C&B1&B&A1&A|E&D&C2&C1&!C&B1&B&A1&A|E&D&!C2&C1&!C&B1&B&A1&A|E&!D&!C2&C1&!C&B1&B&A1&A|E&!D&!C2&C1&C&B1&B&A1&A|E&D&!C2&C1&C&B1&B&A1&A|E&D&C2&C1&C&B1&B&A1&A|E&!D&C2&C1&C&B1&B&A1&A|E&!D&C2&!C1&C&B1&B&A1&A|E&D&C2&!C1&C&B1&B&A1&A|E&D&!C2&!C1&C&B1&B&A1&A|E&!D&!C2&!C1&C&B1&B&A1&A|E&!D&!C2&!C1&C&!B1&B&A1&A|E&D&!C2&!C1&C&!B1&B&A1&A|E&D&C2&!C1&C&!B1&B&A1&A|E&!D&C2&!C1&C&!B1&B&A1&A|E&!D&C2&C1&C&!B1&B&A1&A|E&D&C2&C1&C&!B1&B&A1&A|E&D&!C2&C1&C&!B1&B&A1&A|E&!D&!C2&C1&C&!B1&B&A1&A|E&!D&!C2&C1&!C&!B1&B&A1&A|E&D&!C2&C1&!C&!B1&B&A1&A|E&D&C2&C1&!C&!B1&B&A1&A|E&!D&C2&C1&!C&!B1&B&A1&A|E&!D&C2&!C1&!C&!B1&B&A1&A|E&D&C2&!C1&!C&!B1&B&A1&A|E&D&!C2&!C1&!C&!B1&B&A1&A|E&!D&!C2&!C1&!C&!B1&B&A1&A|E&!D&!C2&!C1&!C&!B1&B&!A1&A|E&D&!C2&!C1&!C&!B1&B&!A1&A|E&D&C2&!C1&!C&!B1&B&!A1&A|E&!D&C2&!C1&!C&!B1&B&!A1&A|E&!D&C2&C1&!C&!B1&B&!A1&A|E&D&C2&C1&!C&!B1&B&!A1&A|E&D&!C2&C1&!C&!B1&B&!A1&A|E&!D&!C2&C1&!C&!B1&B&!A1&A|E&!D&!C2&C1&C&!B1&B&!A1&A|E&D&!C2&C1&C&!B1&B&!A1&A|E&D&C2&C1&C&!B1&B&!A1&A|E&!D&C2&C1&C&!B1&B&!A1&A|E&!D&C2&!C1&C&!B1&B&!A1&A|E&D&C2&!C1&C&!B1&B&!A1&A|E&D&!C2&!C1&C&!B1&B&!A1&A|E&!D&!C2&!C1&C&!B1&B&!A1&A|E&!D&!C2&!C1&C&B1&B&!A1&A|E&D&!C2&!C1&C&B1&B&!A1&A|E&D&C2&!C1&C&B1&B&!A1&A|E&!D&C2&!C1&C&B1&B&!A1&A|E&!D&C2&C1&C&B1&B&!A1&A|E&D&C2&C1&C&B1&B&!A1&A|E&D&!C2&C1&C&B1&B&!A1&A|E&!D&!C2&C1&C&B1&B&!A1&A|E&!D&!C2&C1&!C&B1&B&!A1&A|E&D&!C2&C1&!C&B1&B&!A1&A|E&D&C2&C1&!C&B1&B&!A1&A|E&!D&C2&C1&!C&B1&B&!A1&A|E&!D&C2&!C1&!C&B1&B&!A1&A|E&D&C2&!C1&!C&B1&B&!A1&A|E&D&!C2&!C1&!C&B1&B&!A1&A|E&!D&!C2&!C1&!C&B1&B&!A1&A|E&!D&!C2&!C1&!C&B1&!B&!A1&A|E&D&!C2&!C1&!C&B1&!B&!A1&A|E&D&C2&!C1&!C&B1&!B&!A1&A|E&!D&C2&!C1&!C&B1&!B&!A1&A|E&!D&C2&C1&!C&B1&!B&!A1&A|E&D&C2&C1&!C&B1&!B&!A1&A|E&D&!C2&C1&!C&B1&!B&!A1&A|E&!D&!C2&C1&!C&B1&!B&!A1&A|E&!D&!C2&C1&C&B1&!B&!A1&A|E&D&!C2&C1&C&B1&!B&!A1&A|E&D&C2&C1&C&B1&!B&!A1&A|E&!D&C2&C1&C&B1&!B&!A1&A|E&!D&C2&!C1&C&B1&!B&!A1&A|E&D&C2&!C1&C&B1&!B&!A1&A|E&D&!C2&!C1&C&B1&!B&!A1&A|E&!D&!C2&!C1&C&B1&!B&!A1&A|E&D&!C2&!C1&C&!B1&!B&!A1&A|E&D&C2&!C1&C&!B1&!B&!A1&A|E&!D&C2&C1&C&!B1&!B&!A1&A|E&D&C2&C1&C&!B1&!B&!A1&A|E&D&!C2&C1&C&!B1&!B&!A1&A|E&D&!C2&C1&!C&!B1&!B&!A1&A|E&D&C2&C1&!C&!B1&!B&!A1&A|E&D&C2&!C1&!C&!B1&!B&!A1&A|E&D&!C2&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOAI22311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAAOAI22221 -l OOOAAOAI22221 -i E D1 D C1 C B1 B A1 A -o Y -f Y=!(E&D1&D&!C1&!C&!B1&!B&!A1&!A|E&D1&D&C1&!C&!B1&!B&!A1&!A|E&D1&D&C1&C&!B1&!B&!A1&!A|E&D1&D&!C1&C&!B1&!B&!A1&!A|E&D1&D&!C1&C&B1&!B&!A1&!A|E&D1&D&C1&C&B1&!B&!A1&!A|E&D1&D&C1&!C&B1&!B&!A1&!A|E&D1&D&!C1&!C&B1&!B&!A1&!A|E&D1&D&!C1&!C&B1&B&!A1&!A|E&D1&D&C1&!C&B1&B&!A1&!A|E&D1&D&C1&C&B1&B&!A1&!A|E&D1&D&!C1&C&B1&B&!A1&!A|E&D1&D&!C1&C&!B1&B&!A1&!A|E&D1&D&C1&C&!B1&B&!A1&!A|E&D1&D&C1&!C&!B1&B&!A1&!A|E&D1&D&!C1&!C&!B1&B&!A1&!A|E&D1&D&!C1&!C&!B1&B&A1&!A|E&!D1&D&C1&!C&!B1&B&A1&!A|E&D1&D&C1&!C&!B1&B&A1&!A|E&D1&!D&C1&!C&!B1&B&A1&!A|E&!D1&!D&C1&!C&!B1&B&A1&!A|E&!D1&!D&C1&C&!B1&B&A1&!A|E&D1&!D&C1&C&!B1&B&A1&!A|E&D1&D&C1&C&!B1&B&A1&!A|E&!D1&D&C1&C&!B1&B&A1&!A|E&!D1&D&!C1&C&!B1&B&A1&!A|E&D1&D&!C1&C&!B1&B&A1&!A|E&D1&!D&!C1&C&!B1&B&A1&!A|E&!D1&!D&!C1&C&!B1&B&A1&!A|E&!D1&!D&!C1&C&B1&B&A1&!A|E&D1&!D&!C1&C&B1&B&A1&!A|E&D1&D&!C1&C&B1&B&A1&!A|E&!D1&D&!C1&C&B1&B&A1&!A|E&!D1&D&C1&C&B1&B&A1&!A|E&D1&D&C1&C&B1&B&A1&!A|E&D1&!D&C1&C&B1&B&A1&!A|E&!D1&!D&C1&C&B1&B&A1&!A|E&!D1&!D&C1&!C&B1&B&A1&!A|E&D1&!D&C1&!C&B1&B&A1&!A|E&D1&D&C1&!C&B1&B&A1&!A|E&!D1&D&C1&!C&B1&B&A1&!A|E&D1&D&!C1&!C&B1&B&A1&!A|E&D1&D&!C1&!C&B1&!B&A1&!A|E&!D1&D&C1&!C&B1&!B&A1&!A|E&D1&D&C1&!C&B1&!B&A1&!A|E&D1&!D&C1&!C&B1&!B&A1&!A|E&!D1&!D&C1&!C&B1&!B&A1&!A|E&!D1&!D&C1&C&B1&!B&A1&!A|E&D1&!D&C1&C&B1&!B&A1&!A|E&D1&D&C1&C&B1&!B&A1&!A|E&!D1&D&C1&C&B1&!B&A1&!A|E&!D1&D&!C1&C&B1&!B&A1&!A|E&D1&D&!C1&C&B1&!B&A1&!A|E&D1&!D&!C1&C&B1&!B&A1&!A|E&!D1&!D&!C1&C&B1&!B&A1&!A|E&D1&D&!C1&C&!B1&!B&A1&!A|E&D1&D&C1&C&!B1&!B&A1&!A|E&D1&D&C1&!C&!B1&!B&A1&!A|E&D1&D&!C1&!C&!B1&!B&A1&!A|E&D1&D&!C1&!C&!B1&!B&A1&A|E&D1&D&C1&!C&!B1&!B&A1&A|E&D1&D&C1&C&!B1&!B&A1&A|E&D1&D&!C1&C&!B1&!B&A1&A|E&!D1&!D&!C1&C&B1&!B&A1&A|E&D1&!D&!C1&C&B1&!B&A1&A|E&D1&D&!C1&C&B1&!B&A1&A|E&!D1&D&!C1&C&B1&!B&A1&A|E&!D1&D&C1&C&B1&!B&A1&A|E&D1&D&C1&C&B1&!B&A1&A|E&D1&!D&C1&C&B1&!B&A1&A|E&!D1&!D&C1&C&B1&!B&A1&A|E&!D1&!D&C1&!C&B1&!B&A1&A|E&D1&!D&C1&!C&B1&!B&A1&A|E&D1&D&C1&!C&B1&!B&A1&A|E&!D1&D&C1&!C&B1&!B&A1&A|E&D1&D&!C1&!C&B1&!B&A1&A|E&D1&D&!C1&!C&B1&B&A1&A|E&!D1&D&C1&!C&B1&B&A1&A|E&D1&D&C1&!C&B1&B&A1&A|E&D1&!D&C1&!C&B1&B&A1&A|E&!D1&!D&C1&!C&B1&B&A1&A|E&!D1&!D&C1&C&B1&B&A1&A|E&D1&!D&C1&C&B1&B&A1&A|E&D1&D&C1&C&B1&B&A1&A|E&!D1&D&C1&C&B1&B&A1&A|E&!D1&D&!C1&C&B1&B&A1&A|E&D1&D&!C1&C&B1&B&A1&A|E&D1&!D&!C1&C&B1&B&A1&A|E&!D1&!D&!C1&C&B1&B&A1&A|E&!D1&!D&!C1&C&!B1&B&A1&A|E&D1&!D&!C1&C&!B1&B&A1&A|E&D1&D&!C1&C&!B1&B&A1&A|E&!D1&D&!C1&C&!B1&B&A1&A|E&!D1&D&C1&C&!B1&B&A1&A|E&D1&D&C1&C&!B1&B&A1&A|E&D1&!D&C1&C&!B1&B&A1&A|E&!D1&!D&C1&C&!B1&B&A1&A|E&!D1&!D&C1&!C&!B1&B&A1&A|E&D1&!D&C1&!C&!B1&B&A1&A|E&D1&D&C1&!C&!B1&B&A1&A|E&!D1&D&C1&!C&!B1&B&A1&A|E&D1&D&!C1&!C&!B1&B&A1&A|E&D1&D&!C1&!C&!B1&B&!A1&A|E&!D1&D&C1&!C&!B1&B&!A1&A|E&D1&D&C1&!C&!B1&B&!A1&A|E&D1&!D&C1&!C&!B1&B&!A1&A|E&!D1&!D&C1&!C&!B1&B&!A1&A|E&!D1&!D&C1&C&!B1&B&!A1&A|E&D1&!D&C1&C&!B1&B&!A1&A|E&D1&D&C1&C&!B1&B&!A1&A|E&!D1&D&C1&C&!B1&B&!A1&A|E&!D1&D&!C1&C&!B1&B&!A1&A|E&D1&D&!C1&C&!B1&B&!A1&A|E&D1&!D&!C1&C&!B1&B&!A1&A|E&!D1&!D&!C1&C&!B1&B&!A1&A|E&!D1&!D&!C1&C&B1&B&!A1&A|E&D1&!D&!C1&C&B1&B&!A1&A|E&D1&D&!C1&C&B1&B&!A1&A|E&!D1&D&!C1&C&B1&B&!A1&A|E&!D1&D&C1&C&B1&B&!A1&A|E&D1&D&C1&C&B1&B&!A1&A|E&D1&!D&C1&C&B1&B&!A1&A|E&!D1&!D&C1&C&B1&B&!A1&A|E&!D1&!D&C1&!C&B1&B&!A1&A|E&D1&!D&C1&!C&B1&B&!A1&A|E&D1&D&C1&!C&B1&B&!A1&A|E&!D1&D&C1&!C&B1&B&!A1&A|E&D1&D&!C1&!C&B1&B&!A1&A|E&D1&D&!C1&!C&B1&!B&!A1&A|E&!D1&D&C1&!C&B1&!B&!A1&A|E&D1&D&C1&!C&B1&!B&!A1&A|E&D1&!D&C1&!C&B1&!B&!A1&A|E&!D1&!D&C1&!C&B1&!B&!A1&A|E&!D1&!D&C1&C&B1&!B&!A1&A|E&D1&!D&C1&C&B1&!B&!A1&A|E&D1&D&C1&C&B1&!B&!A1&A|E&!D1&D&C1&C&B1&!B&!A1&A|E&!D1&D&!C1&C&B1&!B&!A1&A|E&D1&D&!C1&C&B1&!B&!A1&A|E&D1&!D&!C1&C&B1&!B&!A1&A|E&!D1&!D&!C1&C&B1&!B&!A1&A|E&D1&D&!C1&C&!B1&!B&!A1&A|E&D1&D&C1&C&!B1&!B&!A1&A|E&D1&D&C1&!C&!B1&!B&!A1&A|E&D1&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAAOAI22221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOOAI22231 -l OOAAOOAI22231 -i E D2 D1 D C1 C B1 B A1 A -o Y -f Y=!(E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|E&D2&D1&D&C1&C&!B1&!B&!A1&!A|E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|E&D2&!D1&D&C1&C&B1&!B&!A1&!A|E&D2&D1&D&C1&C&B1&!B&!A1&!A|E&!D2&D1&D&C1&C&B1&!B&!A1&!A|E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|E&D2&D1&!D&C1&C&B1&!B&!A1&!A|E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|E&D2&!D1&!D&C1&C&B1&B&!A1&!A|E&D2&D1&!D&C1&C&B1&B&!A1&!A|E&!D2&D1&!D&C1&C&B1&B&!A1&!A|E&!D2&D1&D&C1&C&B1&B&!A1&!A|E&D2&D1&D&C1&C&B1&B&!A1&!A|E&D2&!D1&D&C1&C&B1&B&!A1&!A|E&!D2&!D1&D&C1&C&B1&B&!A1&!A|E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|E&D2&!D1&D&C1&C&!B1&B&!A1&!A|E&D2&D1&D&C1&C&!B1&B&!A1&!A|E&!D2&D1&D&C1&C&!B1&B&!A1&!A|E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|E&D2&D1&!D&C1&C&!B1&B&!A1&!A|E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|E&D2&D1&D&!C1&!C&!B1&B&A1&!A|E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|E&D2&!D1&D&C1&!C&!B1&B&A1&!A|E&D2&D1&D&C1&!C&!B1&B&A1&!A|E&!D2&D1&D&C1&!C&!B1&B&A1&!A|E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|E&D2&D1&!D&C1&!C&!B1&B&A1&!A|E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|E&D2&!D1&!D&C1&C&!B1&B&A1&!A|E&D2&D1&!D&C1&C&!B1&B&A1&!A|E&!D2&D1&!D&C1&C&!B1&B&A1&!A|E&!D2&D1&D&C1&C&!B1&B&A1&!A|E&D2&D1&D&C1&C&!B1&B&A1&!A|E&D2&!D1&D&C1&C&!B1&B&A1&!A|E&!D2&!D1&D&C1&C&!B1&B&A1&!A|E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|E&D2&!D1&D&!C1&C&!B1&B&A1&!A|E&D2&D1&D&!C1&C&!B1&B&A1&!A|E&!D2&D1&D&!C1&C&!B1&B&A1&!A|E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|E&D2&D1&!D&!C1&C&!B1&B&A1&!A|E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|E&D2&!D1&!D&!C1&C&B1&B&A1&!A|E&D2&D1&!D&!C1&C&B1&B&A1&!A|E&!D2&D1&!D&!C1&C&B1&B&A1&!A|E&!D2&D1&D&!C1&C&B1&B&A1&!A|E&D2&D1&D&!C1&C&B1&B&A1&!A|E&D2&!D1&D&!C1&C&B1&B&A1&!A|E&!D2&!D1&D&!C1&C&B1&B&A1&!A|E&!D2&!D1&D&C1&C&B1&B&A1&!A|E&D2&!D1&D&C1&C&B1&B&A1&!A|E&D2&D1&D&C1&C&B1&B&A1&!A|E&!D2&D1&D&C1&C&B1&B&A1&!A|E&!D2&D1&!D&C1&C&B1&B&A1&!A|E&D2&D1&!D&C1&C&B1&B&A1&!A|E&D2&!D1&!D&C1&C&B1&B&A1&!A|E&D2&!D1&!D&C1&!C&B1&B&A1&!A|E&D2&D1&!D&C1&!C&B1&B&A1&!A|E&!D2&D1&!D&C1&!C&B1&B&A1&!A|E&!D2&D1&D&C1&!C&B1&B&A1&!A|E&D2&D1&D&C1&!C&B1&B&A1&!A|E&D2&!D1&D&C1&!C&B1&B&A1&!A|E&!D2&!D1&D&C1&!C&B1&B&A1&!A|E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|E&D2&!D1&D&!C1&!C&B1&B&A1&!A|E&D2&D1&D&!C1&!C&B1&B&A1&!A|E&!D2&D1&D&!C1&!C&B1&B&A1&!A|E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|E&D2&D1&!D&!C1&!C&B1&B&A1&!A|E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|E&D2&D1&D&!C1&!C&B1&!B&A1&!A|E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|E&D2&!D1&D&C1&!C&B1&!B&A1&!A|E&D2&D1&D&C1&!C&B1&!B&A1&!A|E&!D2&D1&D&C1&!C&B1&!B&A1&!A|E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|E&D2&D1&!D&C1&!C&B1&!B&A1&!A|E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|E&D2&!D1&!D&C1&C&B1&!B&A1&!A|E&D2&D1&!D&C1&C&B1&!B&A1&!A|E&!D2&D1&!D&C1&C&B1&!B&A1&!A|E&!D2&D1&D&C1&C&B1&!B&A1&!A|E&D2&D1&D&C1&C&B1&!B&A1&!A|E&D2&!D1&D&C1&C&B1&!B&A1&!A|E&!D2&!D1&D&C1&C&B1&!B&A1&!A|E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|E&D2&!D1&D&!C1&C&B1&!B&A1&!A|E&D2&D1&D&!C1&C&B1&!B&A1&!A|E&!D2&D1&D&!C1&C&B1&!B&A1&!A|E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|E&D2&D1&!D&!C1&C&B1&!B&A1&!A|E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|E&D2&!D1&D&C1&C&!B1&!B&A1&!A|E&D2&D1&D&C1&C&!B1&!B&A1&!A|E&!D2&D1&D&C1&C&!B1&!B&A1&!A|E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|E&D2&D1&!D&C1&C&!B1&!B&A1&!A|E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|E&D2&!D1&!D&C1&C&!B1&!B&A1&A|E&D2&D1&!D&C1&C&!B1&!B&A1&A|E&!D2&D1&!D&C1&C&!B1&!B&A1&A|E&!D2&D1&D&C1&C&!B1&!B&A1&A|E&D2&D1&D&C1&C&!B1&!B&A1&A|E&D2&!D1&D&C1&C&!B1&!B&A1&A|E&!D2&!D1&D&C1&C&!B1&!B&A1&A|E&D2&!D1&!D&!C1&C&B1&!B&A1&A|E&D2&D1&!D&!C1&C&B1&!B&A1&A|E&!D2&D1&!D&!C1&C&B1&!B&A1&A|E&!D2&D1&D&!C1&C&B1&!B&A1&A|E&D2&D1&D&!C1&C&B1&!B&A1&A|E&D2&!D1&D&!C1&C&B1&!B&A1&A|E&!D2&!D1&D&!C1&C&B1&!B&A1&A|E&!D2&!D1&D&C1&C&B1&!B&A1&A|E&D2&!D1&D&C1&C&B1&!B&A1&A|E&D2&D1&D&C1&C&B1&!B&A1&A|E&!D2&D1&D&C1&C&B1&!B&A1&A|E&!D2&D1&!D&C1&C&B1&!B&A1&A|E&D2&D1&!D&C1&C&B1&!B&A1&A|E&D2&!D1&!D&C1&C&B1&!B&A1&A|E&D2&!D1&!D&C1&!C&B1&!B&A1&A|E&D2&D1&!D&C1&!C&B1&!B&A1&A|E&!D2&D1&!D&C1&!C&B1&!B&A1&A|E&!D2&D1&D&C1&!C&B1&!B&A1&A|E&D2&D1&D&C1&!C&B1&!B&A1&A|E&D2&!D1&D&C1&!C&B1&!B&A1&A|E&!D2&!D1&D&C1&!C&B1&!B&A1&A|E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|E&D2&!D1&D&!C1&!C&B1&!B&A1&A|E&D2&D1&D&!C1&!C&B1&!B&A1&A|E&!D2&D1&D&!C1&!C&B1&!B&A1&A|E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|E&D2&D1&!D&!C1&!C&B1&!B&A1&A|E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|E&D2&!D1&!D&!C1&!C&B1&B&A1&A|E&D2&D1&!D&!C1&!C&B1&B&A1&A|E&!D2&D1&!D&!C1&!C&B1&B&A1&A|E&!D2&D1&D&!C1&!C&B1&B&A1&A|E&D2&D1&D&!C1&!C&B1&B&A1&A|E&D2&!D1&D&!C1&!C&B1&B&A1&A|E&!D2&!D1&D&!C1&!C&B1&B&A1&A|E&!D2&!D1&D&C1&!C&B1&B&A1&A|E&D2&!D1&D&C1&!C&B1&B&A1&A|E&D2&D1&D&C1&!C&B1&B&A1&A|E&!D2&D1&D&C1&!C&B1&B&A1&A|E&!D2&D1&!D&C1&!C&B1&B&A1&A|E&D2&D1&!D&C1&!C&B1&B&A1&A|E&D2&!D1&!D&C1&!C&B1&B&A1&A|E&D2&!D1&!D&C1&C&B1&B&A1&A|E&D2&D1&!D&C1&C&B1&B&A1&A|E&!D2&D1&!D&C1&C&B1&B&A1&A|E&!D2&D1&D&C1&C&B1&B&A1&A|E&D2&D1&D&C1&C&B1&B&A1&A|E&D2&!D1&D&C1&C&B1&B&A1&A|E&!D2&!D1&D&C1&C&B1&B&A1&A|E&!D2&!D1&D&!C1&C&B1&B&A1&A|E&D2&!D1&D&!C1&C&B1&B&A1&A|E&D2&D1&D&!C1&C&B1&B&A1&A|E&!D2&D1&D&!C1&C&B1&B&A1&A|E&!D2&D1&!D&!C1&C&B1&B&A1&A|E&D2&D1&!D&!C1&C&B1&B&A1&A|E&D2&!D1&!D&!C1&C&B1&B&A1&A|E&D2&!D1&!D&!C1&C&!B1&B&A1&A|E&D2&D1&!D&!C1&C&!B1&B&A1&A|E&!D2&D1&!D&!C1&C&!B1&B&A1&A|E&!D2&D1&D&!C1&C&!B1&B&A1&A|E&D2&D1&D&!C1&C&!B1&B&A1&A|E&D2&!D1&D&!C1&C&!B1&B&A1&A|E&!D2&!D1&D&!C1&C&!B1&B&A1&A|E&!D2&!D1&D&C1&C&!B1&B&A1&A|E&D2&!D1&D&C1&C&!B1&B&A1&A|E&D2&D1&D&C1&C&!B1&B&A1&A|E&!D2&D1&D&C1&C&!B1&B&A1&A|E&!D2&D1&!D&C1&C&!B1&B&A1&A|E&D2&D1&!D&C1&C&!B1&B&A1&A|E&D2&!D1&!D&C1&C&!B1&B&A1&A|E&D2&!D1&!D&C1&!C&!B1&B&A1&A|E&D2&D1&!D&C1&!C&!B1&B&A1&A|E&!D2&D1&!D&C1&!C&!B1&B&A1&A|E&!D2&D1&D&C1&!C&!B1&B&A1&A|E&D2&D1&D&C1&!C&!B1&B&A1&A|E&D2&!D1&D&C1&!C&!B1&B&A1&A|E&!D2&!D1&D&C1&!C&!B1&B&A1&A|E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|E&D2&!D1&D&!C1&!C&!B1&B&A1&A|E&D2&D1&D&!C1&!C&!B1&B&A1&A|E&!D2&D1&D&!C1&!C&!B1&B&A1&A|E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|E&D2&D1&!D&!C1&!C&!B1&B&A1&A|E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|E&D2&D1&D&!C1&!C&!B1&B&!A1&A|E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|E&D2&!D1&D&C1&!C&!B1&B&!A1&A|E&D2&D1&D&C1&!C&!B1&B&!A1&A|E&!D2&D1&D&C1&!C&!B1&B&!A1&A|E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|E&D2&D1&!D&C1&!C&!B1&B&!A1&A|E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|E&D2&!D1&!D&C1&C&!B1&B&!A1&A|E&D2&D1&!D&C1&C&!B1&B&!A1&A|E&!D2&D1&!D&C1&C&!B1&B&!A1&A|E&!D2&D1&D&C1&C&!B1&B&!A1&A|E&D2&D1&D&C1&C&!B1&B&!A1&A|E&D2&!D1&D&C1&C&!B1&B&!A1&A|E&!D2&!D1&D&C1&C&!B1&B&!A1&A|E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|E&D2&!D1&D&!C1&C&!B1&B&!A1&A|E&D2&D1&D&!C1&C&!B1&B&!A1&A|E&!D2&D1&D&!C1&C&!B1&B&!A1&A|E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|E&D2&D1&!D&!C1&C&!B1&B&!A1&A|E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|E&D2&!D1&!D&!C1&C&B1&B&!A1&A|E&D2&D1&!D&!C1&C&B1&B&!A1&A|E&!D2&D1&!D&!C1&C&B1&B&!A1&A|E&!D2&D1&D&!C1&C&B1&B&!A1&A|E&D2&D1&D&!C1&C&B1&B&!A1&A|E&D2&!D1&D&!C1&C&B1&B&!A1&A|E&!D2&!D1&D&!C1&C&B1&B&!A1&A|E&!D2&!D1&D&C1&C&B1&B&!A1&A|E&D2&!D1&D&C1&C&B1&B&!A1&A|E&D2&D1&D&C1&C&B1&B&!A1&A|E&!D2&D1&D&C1&C&B1&B&!A1&A|E&!D2&D1&!D&C1&C&B1&B&!A1&A|E&D2&D1&!D&C1&C&B1&B&!A1&A|E&D2&!D1&!D&C1&C&B1&B&!A1&A|E&D2&!D1&!D&C1&!C&B1&B&!A1&A|E&D2&D1&!D&C1&!C&B1&B&!A1&A|E&!D2&D1&!D&C1&!C&B1&B&!A1&A|E&!D2&D1&D&C1&!C&B1&B&!A1&A|E&D2&D1&D&C1&!C&B1&B&!A1&A|E&D2&!D1&D&C1&!C&B1&B&!A1&A|E&!D2&!D1&D&C1&!C&B1&B&!A1&A|E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|E&D2&!D1&D&!C1&!C&B1&B&!A1&A|E&D2&D1&D&!C1&!C&B1&B&!A1&A|E&!D2&D1&D&!C1&!C&B1&B&!A1&A|E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|E&D2&D1&!D&!C1&!C&B1&B&!A1&A|E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|E&D2&D1&D&!C1&!C&B1&!B&!A1&A|E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|E&D2&!D1&D&C1&!C&B1&!B&!A1&A|E&D2&D1&D&C1&!C&B1&!B&!A1&A|E&!D2&D1&D&C1&!C&B1&!B&!A1&A|E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|E&D2&D1&!D&C1&!C&B1&!B&!A1&A|E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|E&D2&!D1&!D&C1&C&B1&!B&!A1&A|E&D2&D1&!D&C1&C&B1&!B&!A1&A|E&!D2&D1&!D&C1&C&B1&!B&!A1&A|E&!D2&D1&D&C1&C&B1&!B&!A1&A|E&D2&D1&D&C1&C&B1&!B&!A1&A|E&D2&!D1&D&C1&C&B1&!B&!A1&A|E&!D2&!D1&D&C1&C&B1&!B&!A1&A|E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|E&D2&!D1&D&!C1&C&B1&!B&!A1&A|E&D2&D1&D&!C1&C&B1&!B&!A1&A|E&!D2&D1&D&!C1&C&B1&!B&!A1&A|E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|E&D2&D1&!D&!C1&C&B1&!B&!A1&A|E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|E&D2&!D1&D&C1&C&!B1&!B&!A1&A|E&D2&D1&D&C1&C&!B1&!B&!A1&A|E&!D2&D1&D&C1&C&!B1&!B&!A1&A|E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|E&D2&D1&!D&C1&C&!B1&!B&!A1&A|E&D2&!D1&!D&C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOOAI22231.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOAOI21311 -l OAAOAOI21311 -i E D C2 C1 C B A1 A -o Y -f Y=(!E&!D&!C2&!C1&!C&!B&!A1&!A|!E&D&!C2&!C1&!C&!B&!A1&!A|!E&D&C2&!C1&!C&!B&!A1&!A|!E&!D&C2&!C1&!C&!B&!A1&!A|!E&!D&C2&C1&!C&!B&!A1&!A|!E&D&C2&C1&!C&!B&!A1&!A|!E&D&!C2&C1&!C&!B&!A1&!A|!E&!D&!C2&C1&!C&!B&!A1&!A|!E&!D&!C2&C1&C&!B&!A1&!A|!E&D&!C2&C1&C&!B&!A1&!A|!E&!D&C2&C1&C&!B&!A1&!A|!E&!D&C2&!C1&C&!B&!A1&!A|!E&D&C2&!C1&C&!B&!A1&!A|!E&D&!C2&!C1&C&!B&!A1&!A|!E&!D&!C2&!C1&C&!B&!A1&!A|!E&!D&!C2&!C1&C&B&!A1&!A|!E&D&!C2&!C1&C&B&!A1&!A|!E&D&C2&!C1&C&B&!A1&!A|!E&!D&C2&!C1&C&B&!A1&!A|!E&!D&C2&C1&C&B&!A1&!A|!E&D&!C2&C1&C&B&!A1&!A|!E&!D&!C2&C1&C&B&!A1&!A|!E&!D&!C2&C1&!C&B&!A1&!A|!E&D&!C2&C1&!C&B&!A1&!A|!E&D&C2&C1&!C&B&!A1&!A|!E&!D&C2&C1&!C&B&!A1&!A|!E&!D&C2&!C1&!C&B&!A1&!A|!E&D&C2&!C1&!C&B&!A1&!A|!E&D&!C2&!C1&!C&B&!A1&!A|!E&!D&!C2&!C1&!C&B&!A1&!A|!E&!D&!C2&!C1&!C&B&A1&!A|!E&!D&C2&!C1&!C&B&A1&!A|!E&!D&C2&C1&!C&B&A1&!A|!E&!D&!C2&C1&!C&B&A1&!A|!E&!D&!C2&C1&C&B&A1&!A|!E&!D&C2&C1&C&B&A1&!A|!E&!D&C2&!C1&C&B&A1&!A|!E&!D&!C2&!C1&C&B&A1&!A|!E&!D&!C2&!C1&C&!B&A1&!A|!E&D&!C2&!C1&C&!B&A1&!A|!E&D&C2&!C1&C&!B&A1&!A|!E&!D&C2&!C1&C&!B&A1&!A|!E&!D&C2&C1&C&!B&A1&!A|!E&D&!C2&C1&C&!B&A1&!A|!E&!D&!C2&C1&C&!B&A1&!A|!E&!D&!C2&C1&!C&!B&A1&!A|!E&D&!C2&C1&!C&!B&A1&!A|!E&D&C2&C1&!C&!B&A1&!A|!E&!D&C2&C1&!C&!B&A1&!A|!E&!D&C2&!C1&!C&!B&A1&!A|!E&D&C2&!C1&!C&!B&A1&!A|!E&D&!C2&!C1&!C&!B&A1&!A|!E&!D&!C2&!C1&!C&!B&A1&!A|!E&!D&!C2&!C1&!C&!B&A1&A|!E&D&!C2&!C1&!C&!B&A1&A|!E&D&C2&!C1&!C&!B&A1&A|!E&!D&C2&!C1&!C&!B&A1&A|!E&!D&C2&C1&!C&!B&A1&A|!E&D&C2&C1&!C&!B&A1&A|!E&D&!C2&C1&!C&!B&A1&A|!E&!D&!C2&C1&!C&!B&A1&A|!E&!D&!C2&C1&C&!B&A1&A|!E&D&!C2&C1&C&!B&A1&A|!E&!D&C2&C1&C&!B&A1&A|!E&!D&C2&!C1&C&!B&A1&A|!E&D&C2&!C1&C&!B&A1&A|!E&D&!C2&!C1&C&!B&A1&A|!E&!D&!C2&!C1&C&!B&A1&A|!E&!D&!C2&!C1&C&B&A1&A|!E&!D&C2&!C1&C&B&A1&A|!E&!D&C2&C1&C&B&A1&A|!E&!D&!C2&C1&C&B&A1&A|!E&!D&!C2&C1&!C&B&A1&A|!E&!D&C2&C1&!C&B&A1&A|!E&!D&C2&!C1&!C&B&A1&A|!E&!D&!C2&!C1&!C&B&A1&A|!E&!D&!C2&!C1&!C&B&!A1&A|!E&!D&C2&!C1&!C&B&!A1&A|!E&!D&C2&C1&!C&B&!A1&A|!E&!D&!C2&C1&!C&B&!A1&A|!E&!D&!C2&C1&C&B&!A1&A|!E&!D&C2&C1&C&B&!A1&A|!E&!D&C2&!C1&C&B&!A1&A|!E&!D&!C2&!C1&C&B&!A1&A|!E&!D&!C2&!C1&C&!B&!A1&A|!E&D&!C2&!C1&C&!B&!A1&A|!E&D&C2&!C1&C&!B&!A1&A|!E&!D&C2&!C1&C&!B&!A1&A|!E&!D&C2&C1&C&!B&!A1&A|!E&D&!C2&C1&C&!B&!A1&A|!E&!D&!C2&C1&C&!B&!A1&A|!E&!D&!C2&C1&!C&!B&!A1&A|!E&D&!C2&C1&!C&!B&!A1&A|!E&D&C2&C1&!C&!B&!A1&A|!E&!D&C2&C1&!C&!B&!A1&A|!E&!D&C2&!C1&!C&!B&!A1&A|!E&D&C2&!C1&!C&!B&!A1&A|!E&D&!C2&!C1&!C&!B&!A1&A|!E&!D&!C2&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOAOI21311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOOAI22221 -l AAAOOAI22221 -i E D1 D C1 C B1 B A1 A -o Y -f Y=!(E&D1&!D&C1&C&!B1&!B&!A1&!A|E&D1&D&C1&C&!B1&!B&!A1&!A|E&!D1&D&C1&C&!B1&!B&!A1&!A|E&!D1&D&C1&C&B1&!B&!A1&!A|E&D1&D&C1&C&B1&!B&!A1&!A|E&D1&!D&C1&C&B1&!B&!A1&!A|E&D1&!D&!C1&!C&B1&B&!A1&!A|E&D1&D&!C1&!C&B1&B&!A1&!A|E&!D1&D&!C1&!C&B1&B&!A1&!A|E&!D1&D&C1&!C&B1&B&!A1&!A|E&D1&D&C1&!C&B1&B&!A1&!A|E&D1&!D&C1&!C&B1&B&!A1&!A|E&D1&!D&C1&C&B1&B&!A1&!A|E&D1&D&C1&C&B1&B&!A1&!A|E&!D1&D&C1&C&B1&B&!A1&!A|E&!D1&D&!C1&C&B1&B&!A1&!A|E&D1&D&!C1&C&B1&B&!A1&!A|E&D1&!D&!C1&C&B1&B&!A1&!A|E&!D1&D&C1&C&!B1&B&!A1&!A|E&D1&D&C1&C&!B1&B&!A1&!A|E&D1&!D&C1&C&!B1&B&!A1&!A|E&D1&!D&C1&C&!B1&B&A1&!A|E&D1&D&C1&C&!B1&B&A1&!A|E&!D1&D&C1&C&!B1&B&A1&!A|E&D1&!D&!C1&C&B1&B&A1&!A|E&D1&D&!C1&C&B1&B&A1&!A|E&!D1&D&!C1&C&B1&B&A1&!A|E&!D1&D&C1&C&B1&B&A1&!A|E&D1&D&C1&C&B1&B&A1&!A|E&D1&!D&C1&C&B1&B&A1&!A|E&D1&!D&C1&!C&B1&B&A1&!A|E&D1&D&C1&!C&B1&B&A1&!A|E&!D1&D&C1&!C&B1&B&A1&!A|E&!D1&D&!C1&!C&B1&B&A1&!A|E&D1&D&!C1&!C&B1&B&A1&!A|E&D1&!D&!C1&!C&B1&B&A1&!A|E&D1&!D&C1&C&B1&!B&A1&!A|E&D1&D&C1&C&B1&!B&A1&!A|E&!D1&D&C1&C&B1&!B&A1&!A|E&!D1&D&C1&C&!B1&!B&A1&!A|E&D1&D&C1&C&!B1&!B&A1&!A|E&D1&!D&C1&C&!B1&!B&A1&!A|E&D1&!D&!C1&!C&!B1&!B&A1&A|E&D1&D&!C1&!C&!B1&!B&A1&A|E&!D1&D&!C1&!C&!B1&!B&A1&A|E&!D1&D&C1&!C&!B1&!B&A1&A|E&D1&D&C1&!C&!B1&!B&A1&A|E&D1&!D&C1&!C&!B1&!B&A1&A|E&D1&!D&C1&C&!B1&!B&A1&A|E&D1&D&C1&C&!B1&!B&A1&A|E&!D1&D&C1&C&!B1&!B&A1&A|E&!D1&D&!C1&C&!B1&!B&A1&A|E&D1&D&!C1&C&!B1&!B&A1&A|E&D1&!D&!C1&C&!B1&!B&A1&A|E&D1&!D&!C1&C&B1&!B&A1&A|E&D1&D&!C1&C&B1&!B&A1&A|E&!D1&D&!C1&C&B1&!B&A1&A|E&!D1&D&C1&C&B1&!B&A1&A|E&D1&D&C1&C&B1&!B&A1&A|E&D1&!D&C1&C&B1&!B&A1&A|E&D1&!D&C1&!C&B1&!B&A1&A|E&D1&D&C1&!C&B1&!B&A1&A|E&!D1&D&C1&!C&B1&!B&A1&A|E&!D1&D&!C1&!C&B1&!B&A1&A|E&D1&D&!C1&!C&B1&!B&A1&A|E&D1&!D&!C1&!C&B1&!B&A1&A|E&D1&!D&!C1&!C&B1&B&A1&A|E&D1&D&!C1&!C&B1&B&A1&A|E&!D1&D&!C1&!C&B1&B&A1&A|E&!D1&D&C1&!C&B1&B&A1&A|E&D1&D&C1&!C&B1&B&A1&A|E&D1&!D&C1&!C&B1&B&A1&A|E&D1&!D&C1&C&B1&B&A1&A|E&D1&D&C1&C&B1&B&A1&A|E&!D1&D&C1&C&B1&B&A1&A|E&!D1&D&!C1&C&B1&B&A1&A|E&D1&D&!C1&C&B1&B&A1&A|E&D1&!D&!C1&C&B1&B&A1&A|E&D1&!D&!C1&C&!B1&B&A1&A|E&D1&D&!C1&C&!B1&B&A1&A|E&!D1&D&!C1&C&!B1&B&A1&A|E&!D1&D&C1&C&!B1&B&A1&A|E&D1&D&C1&C&!B1&B&A1&A|E&D1&!D&C1&C&!B1&B&A1&A|E&D1&!D&C1&!C&!B1&B&A1&A|E&D1&D&C1&!C&!B1&B&A1&A|E&!D1&D&C1&!C&!B1&B&A1&A|E&!D1&D&!C1&!C&!B1&B&A1&A|E&D1&D&!C1&!C&!B1&B&A1&A|E&D1&!D&!C1&!C&!B1&B&A1&A|E&D1&!D&C1&C&!B1&B&!A1&A|E&D1&D&C1&C&!B1&B&!A1&A|E&!D1&D&C1&C&!B1&B&!A1&A|E&D1&!D&!C1&C&B1&B&!A1&A|E&D1&D&!C1&C&B1&B&!A1&A|E&!D1&D&!C1&C&B1&B&!A1&A|E&!D1&D&C1&C&B1&B&!A1&A|E&D1&D&C1&C&B1&B&!A1&A|E&D1&!D&C1&C&B1&B&!A1&A|E&D1&!D&C1&!C&B1&B&!A1&A|E&D1&D&C1&!C&B1&B&!A1&A|E&!D1&D&C1&!C&B1&B&!A1&A|E&!D1&D&!C1&!C&B1&B&!A1&A|E&D1&D&!C1&!C&B1&B&!A1&A|E&D1&!D&!C1&!C&B1&B&!A1&A|E&D1&!D&C1&C&B1&!B&!A1&A|E&D1&D&C1&C&B1&!B&!A1&A|E&!D1&D&C1&C&B1&!B&!A1&A|E&!D1&D&C1&C&!B1&!B&!A1&A|E&D1&D&C1&C&!B1&!B&!A1&A|E&D1&!D&C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOOAI22221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOI3111 -l AOAOI3111 -i D C B A2 A1 A -o Y -f Y=(!D&!C&!B&!A2&!A1&!A|!D&C&!B&!A2&!A1&!A|!D&!C&B&!A2&!A1&!A|!D&!C&B&A2&!A1&!A|!D&C&!B&A2&!A1&!A|!D&!C&!B&A2&!A1&!A|!D&!C&!B&A2&A1&!A|!D&C&!B&A2&A1&!A|!D&!C&B&A2&A1&!A|!D&!C&B&!A2&A1&!A|!D&C&!B&!A2&A1&!A|!D&!C&!B&!A2&A1&!A|!D&!C&!B&!A2&A1&A|!D&C&!B&!A2&A1&A|!D&!C&B&!A2&A1&A|!D&!C&B&A2&A1&A|!D&!C&!B&A2&A1&A|!D&!C&!B&A2&!A1&A|!D&C&!B&A2&!A1&A|!D&!C&B&A2&!A1&A|!D&!C&B&!A2&!A1&A|!D&C&!B&!A2&!A1&A|!D&!C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOI3111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAI222 -l AOAI222 -i C1 C B1 B A1 A -o Y -f Y=!(C1&C&B1&!B&!A1&!A|C1&C&B1&B&!A1&!A|C1&C&!B1&B&!A1&!A|C1&C&!B1&B&A1&!A|C1&C&B1&B&A1&!A|C1&C&B1&!B&A1&!A|C1&C&!B1&!B&A1&A|C1&C&B1&!B&A1&A|C1&C&B1&B&A1&A|C1&C&!B1&B&A1&A|C1&C&!B1&B&!A1&A|C1&C&B1&B&!A1&A|C1&C&B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAI222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOAI21211 -l OAAOAI21211 -i E D C1 C B A1 A -o Y -f Y=!(E&D&C1&C&!B&!A1&!A|E&D&C1&C&B&!A1&!A|E&D&!C1&!C&B&A1&!A|E&D&C1&!C&B&A1&!A|E&D&C1&C&B&A1&!A|E&D&!C1&C&B&A1&!A|E&D&C1&C&!B&A1&!A|E&D&C1&C&!B&A1&A|E&D&!C1&C&B&A1&A|E&D&C1&C&B&A1&A|E&D&C1&!C&B&A1&A|E&D&!C1&!C&B&A1&A|E&D&!C1&!C&B&!A1&A|E&D&C1&!C&B&!A1&A|E&D&C1&C&B&!A1&A|E&D&!C1&C&B&!A1&A|E&D&C1&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOAI21211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAAOI2224 -l AAOOAAOI2224 -i D3 D2 D1 D C1 C B1 B A1 A -o Y -f Y=!(D3&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|D3&D2&D1&D&C1&!C&!B1&!B&!A1&!A|D3&D2&D1&D&C1&C&!B1&!B&!A1&!A|D3&D2&D1&D&!C1&C&!B1&!B&!A1&!A|D3&D2&D1&D&!C1&C&B1&!B&!A1&!A|D3&D2&D1&D&C1&C&B1&!B&!A1&!A|D3&D2&D1&D&C1&!C&B1&!B&!A1&!A|D3&D2&D1&D&!C1&!C&B1&!B&!A1&!A|D3&D2&D1&D&!C1&!C&B1&B&!A1&!A|!D3&!D2&!D1&D&C1&!C&B1&B&!A1&!A|D3&!D2&!D1&D&C1&!C&B1&B&!A1&!A|D3&D2&!D1&D&C1&!C&B1&B&!A1&!A|!D3&D2&!D1&D&C1&!C&B1&B&!A1&!A|!D3&D2&D1&D&C1&!C&B1&B&!A1&!A|D3&D2&D1&D&C1&!C&B1&B&!A1&!A|D3&!D2&D1&D&C1&!C&B1&B&!A1&!A|!D3&!D2&D1&D&C1&!C&B1&B&!A1&!A|!D3&!D2&D1&!D&C1&!C&B1&B&!A1&!A|D3&!D2&D1&!D&C1&!C&B1&B&!A1&!A|D3&D2&D1&!D&C1&!C&B1&B&!A1&!A|!D3&D2&D1&!D&C1&!C&B1&B&!A1&!A|!D3&D2&!D1&!D&C1&!C&B1&B&!A1&!A|D3&D2&!D1&!D&C1&!C&B1&B&!A1&!A|D3&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!D3&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!D3&!D2&!D1&!D&C1&C&B1&B&!A1&!A|D3&!D2&!D1&!D&C1&C&B1&B&!A1&!A|D3&D2&!D1&!D&C1&C&B1&B&!A1&!A|!D3&D2&!D1&!D&C1&C&B1&B&!A1&!A|!D3&D2&D1&!D&C1&C&B1&B&!A1&!A|D3&D2&D1&!D&C1&C&B1&B&!A1&!A|D3&!D2&D1&!D&C1&C&B1&B&!A1&!A|!D3&!D2&D1&!D&C1&C&B1&B&!A1&!A|!D3&!D2&D1&D&C1&C&B1&B&!A1&!A|D3&!D2&D1&D&C1&C&B1&B&!A1&!A|D3&D2&D1&D&C1&C&B1&B&!A1&!A|!D3&D2&D1&D&C1&C&B1&B&!A1&!A|!D3&D2&!D1&D&C1&C&B1&B&!A1&!A|D3&D2&!D1&D&C1&C&B1&B&!A1&!A|D3&!D2&!D1&D&C1&C&B1&B&!A1&!A|!D3&!D2&!D1&D&C1&C&B1&B&!A1&!A|!D3&!D2&!D1&D&!C1&C&B1&B&!A1&!A|D3&!D2&!D1&D&!C1&C&B1&B&!A1&!A|D3&D2&!D1&D&!C1&C&B1&B&!A1&!A|!D3&D2&!D1&D&!C1&C&B1&B&!A1&!A|!D3&D2&D1&D&!C1&C&B1&B&!A1&!A|D3&D2&D1&D&!C1&C&B1&B&!A1&!A|D3&!D2&D1&D&!C1&C&B1&B&!A1&!A|!D3&!D2&D1&D&!C1&C&B1&B&!A1&!A|!D3&!D2&D1&!D&!C1&C&B1&B&!A1&!A|D3&!D2&D1&!D&!C1&C&B1&B&!A1&!A|D3&D2&D1&!D&!C1&C&B1&B&!A1&!A|!D3&D2&D1&!D&!C1&C&B1&B&!A1&!A|!D3&D2&!D1&!D&!C1&C&B1&B&!A1&!A|D3&D2&!D1&!D&!C1&C&B1&B&!A1&!A|D3&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!D3&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|D3&D2&D1&D&!C1&C&!B1&B&!A1&!A|D3&D2&D1&D&C1&C&!B1&B&!A1&!A|D3&D2&D1&D&C1&!C&!B1&B&!A1&!A|D3&D2&D1&D&!C1&!C&!B1&B&!A1&!A|D3&D2&D1&D&!C1&!C&!B1&B&A1&!A|D3&D2&D1&D&C1&!C&!B1&B&A1&!A|D3&D2&D1&D&C1&C&!B1&B&A1&!A|D3&D2&D1&D&!C1&C&!B1&B&A1&!A|!D3&!D2&!D1&!D&!C1&C&B1&B&A1&!A|D3&!D2&!D1&!D&!C1&C&B1&B&A1&!A|D3&D2&!D1&!D&!C1&C&B1&B&A1&!A|!D3&D2&!D1&!D&!C1&C&B1&B&A1&!A|!D3&D2&D1&!D&!C1&C&B1&B&A1&!A|D3&D2&D1&!D&!C1&C&B1&B&A1&!A|D3&!D2&D1&!D&!C1&C&B1&B&A1&!A|!D3&!D2&D1&!D&!C1&C&B1&B&A1&!A|!D3&!D2&D1&D&!C1&C&B1&B&A1&!A|D3&!D2&D1&D&!C1&C&B1&B&A1&!A|D3&D2&D1&D&!C1&C&B1&B&A1&!A|!D3&D2&D1&D&!C1&C&B1&B&A1&!A|!D3&D2&!D1&D&!C1&C&B1&B&A1&!A|D3&D2&!D1&D&!C1&C&B1&B&A1&!A|D3&!D2&!D1&D&!C1&C&B1&B&A1&!A|!D3&!D2&!D1&D&!C1&C&B1&B&A1&!A|!D3&!D2&!D1&D&C1&C&B1&B&A1&!A|D3&!D2&!D1&D&C1&C&B1&B&A1&!A|D3&D2&!D1&D&C1&C&B1&B&A1&!A|!D3&D2&!D1&D&C1&C&B1&B&A1&!A|!D3&D2&D1&D&C1&C&B1&B&A1&!A|D3&D2&D1&D&C1&C&B1&B&A1&!A|D3&!D2&D1&D&C1&C&B1&B&A1&!A|!D3&!D2&D1&D&C1&C&B1&B&A1&!A|!D3&!D2&D1&!D&C1&C&B1&B&A1&!A|D3&!D2&D1&!D&C1&C&B1&B&A1&!A|D3&D2&D1&!D&C1&C&B1&B&A1&!A|!D3&D2&D1&!D&C1&C&B1&B&A1&!A|!D3&D2&!D1&!D&C1&C&B1&B&A1&!A|D3&D2&!D1&!D&C1&C&B1&B&A1&!A|D3&!D2&!D1&!D&C1&C&B1&B&A1&!A|!D3&!D2&!D1&!D&C1&C&B1&B&A1&!A|!D3&!D2&!D1&!D&C1&!C&B1&B&A1&!A|D3&!D2&!D1&!D&C1&!C&B1&B&A1&!A|D3&D2&!D1&!D&C1&!C&B1&B&A1&!A|!D3&D2&!D1&!D&C1&!C&B1&B&A1&!A|!D3&D2&D1&!D&C1&!C&B1&B&A1&!A|D3&D2&D1&!D&C1&!C&B1&B&A1&!A|D3&!D2&D1&!D&C1&!C&B1&B&A1&!A|!D3&!D2&D1&!D&C1&!C&B1&B&A1&!A|!D3&!D2&D1&D&C1&!C&B1&B&A1&!A|D3&!D2&D1&D&C1&!C&B1&B&A1&!A|D3&D2&D1&D&C1&!C&B1&B&A1&!A|!D3&D2&D1&D&C1&!C&B1&B&A1&!A|!D3&D2&!D1&D&C1&!C&B1&B&A1&!A|D3&D2&!D1&D&C1&!C&B1&B&A1&!A|D3&!D2&!D1&D&C1&!C&B1&B&A1&!A|!D3&!D2&!D1&D&C1&!C&B1&B&A1&!A|D3&D2&D1&D&!C1&!C&B1&B&A1&!A|D3&D2&D1&D&!C1&!C&B1&!B&A1&!A|D3&D2&D1&D&C1&!C&B1&!B&A1&!A|D3&D2&D1&D&C1&C&B1&!B&A1&!A|D3&D2&D1&D&!C1&C&B1&!B&A1&!A|D3&D2&D1&D&!C1&C&!B1&!B&A1&!A|D3&D2&D1&D&C1&C&!B1&!B&A1&!A|D3&D2&D1&D&C1&!C&!B1&!B&A1&!A|D3&D2&D1&D&!C1&!C&!B1&!B&A1&!A|D3&D2&D1&D&!C1&!C&!B1&!B&A1&A|!D3&!D2&!D1&D&C1&!C&!B1&!B&A1&A|D3&!D2&!D1&D&C1&!C&!B1&!B&A1&A|D3&D2&!D1&D&C1&!C&!B1&!B&A1&A|!D3&D2&!D1&D&C1&!C&!B1&!B&A1&A|!D3&D2&D1&D&C1&!C&!B1&!B&A1&A|D3&D2&D1&D&C1&!C&!B1&!B&A1&A|D3&!D2&D1&D&C1&!C&!B1&!B&A1&A|!D3&!D2&D1&D&C1&!C&!B1&!B&A1&A|!D3&!D2&D1&!D&C1&!C&!B1&!B&A1&A|D3&!D2&D1&!D&C1&!C&!B1&!B&A1&A|D3&D2&D1&!D&C1&!C&!B1&!B&A1&A|!D3&D2&D1&!D&C1&!C&!B1&!B&A1&A|!D3&D2&!D1&!D&C1&!C&!B1&!B&A1&A|D3&D2&!D1&!D&C1&!C&!B1&!B&A1&A|D3&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!D3&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!D3&!D2&!D1&!D&C1&C&!B1&!B&A1&A|D3&!D2&!D1&!D&C1&C&!B1&!B&A1&A|D3&D2&!D1&!D&C1&C&!B1&!B&A1&A|!D3&D2&!D1&!D&C1&C&!B1&!B&A1&A|!D3&D2&D1&!D&C1&C&!B1&!B&A1&A|D3&D2&D1&!D&C1&C&!B1&!B&A1&A|D3&!D2&D1&!D&C1&C&!B1&!B&A1&A|!D3&!D2&D1&!D&C1&C&!B1&!B&A1&A|!D3&!D2&D1&D&C1&C&!B1&!B&A1&A|D3&!D2&D1&D&C1&C&!B1&!B&A1&A|D3&D2&D1&D&C1&C&!B1&!B&A1&A|!D3&D2&D1&D&C1&C&!B1&!B&A1&A|!D3&D2&!D1&D&C1&C&!B1&!B&A1&A|D3&D2&!D1&D&C1&C&!B1&!B&A1&A|D3&!D2&!D1&D&C1&C&!B1&!B&A1&A|!D3&!D2&!D1&D&C1&C&!B1&!B&A1&A|!D3&!D2&!D1&D&!C1&C&!B1&!B&A1&A|D3&!D2&!D1&D&!C1&C&!B1&!B&A1&A|D3&D2&!D1&D&!C1&C&!B1&!B&A1&A|!D3&D2&!D1&D&!C1&C&!B1&!B&A1&A|!D3&D2&D1&D&!C1&C&!B1&!B&A1&A|D3&D2&D1&D&!C1&C&!B1&!B&A1&A|D3&!D2&D1&D&!C1&C&!B1&!B&A1&A|!D3&!D2&D1&D&!C1&C&!B1&!B&A1&A|!D3&!D2&D1&!D&!C1&C&!B1&!B&A1&A|D3&!D2&D1&!D&!C1&C&!B1&!B&A1&A|D3&D2&D1&!D&!C1&C&!B1&!B&A1&A|!D3&D2&D1&!D&!C1&C&!B1&!B&A1&A|!D3&D2&!D1&!D&!C1&C&!B1&!B&A1&A|D3&D2&!D1&!D&!C1&C&!B1&!B&A1&A|D3&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!D3&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!D3&!D2&!D1&!D&!C1&C&B1&!B&A1&A|D3&!D2&!D1&!D&!C1&C&B1&!B&A1&A|D3&D2&!D1&!D&!C1&C&B1&!B&A1&A|!D3&D2&!D1&!D&!C1&C&B1&!B&A1&A|!D3&D2&D1&!D&!C1&C&B1&!B&A1&A|D3&D2&D1&!D&!C1&C&B1&!B&A1&A|D3&!D2&D1&!D&!C1&C&B1&!B&A1&A|!D3&!D2&D1&!D&!C1&C&B1&!B&A1&A|!D3&!D2&D1&D&!C1&C&B1&!B&A1&A|D3&!D2&D1&D&!C1&C&B1&!B&A1&A|D3&D2&D1&D&!C1&C&B1&!B&A1&A|!D3&D2&D1&D&!C1&C&B1&!B&A1&A|!D3&D2&!D1&D&!C1&C&B1&!B&A1&A|D3&D2&!D1&D&!C1&C&B1&!B&A1&A|D3&!D2&!D1&D&!C1&C&B1&!B&A1&A|!D3&!D2&!D1&D&!C1&C&B1&!B&A1&A|!D3&!D2&!D1&D&C1&C&B1&!B&A1&A|D3&!D2&!D1&D&C1&C&B1&!B&A1&A|D3&D2&!D1&D&C1&C&B1&!B&A1&A|!D3&D2&!D1&D&C1&C&B1&!B&A1&A|!D3&D2&D1&D&C1&C&B1&!B&A1&A|D3&D2&D1&D&C1&C&B1&!B&A1&A|D3&!D2&D1&D&C1&C&B1&!B&A1&A|!D3&!D2&D1&D&C1&C&B1&!B&A1&A|!D3&!D2&D1&!D&C1&C&B1&!B&A1&A|D3&!D2&D1&!D&C1&C&B1&!B&A1&A|D3&D2&D1&!D&C1&C&B1&!B&A1&A|!D3&D2&D1&!D&C1&C&B1&!B&A1&A|!D3&D2&!D1&!D&C1&C&B1&!B&A1&A|D3&D2&!D1&!D&C1&C&B1&!B&A1&A|D3&!D2&!D1&!D&C1&C&B1&!B&A1&A|!D3&!D2&!D1&!D&C1&C&B1&!B&A1&A|!D3&!D2&!D1&!D&C1&!C&B1&!B&A1&A|D3&!D2&!D1&!D&C1&!C&B1&!B&A1&A|D3&D2&!D1&!D&C1&!C&B1&!B&A1&A|!D3&D2&!D1&!D&C1&!C&B1&!B&A1&A|!D3&D2&D1&!D&C1&!C&B1&!B&A1&A|D3&D2&D1&!D&C1&!C&B1&!B&A1&A|D3&!D2&D1&!D&C1&!C&B1&!B&A1&A|!D3&!D2&D1&!D&C1&!C&B1&!B&A1&A|!D3&!D2&D1&D&C1&!C&B1&!B&A1&A|D3&!D2&D1&D&C1&!C&B1&!B&A1&A|D3&D2&D1&D&C1&!C&B1&!B&A1&A|!D3&D2&D1&D&C1&!C&B1&!B&A1&A|!D3&D2&!D1&D&C1&!C&B1&!B&A1&A|D3&D2&!D1&D&C1&!C&B1&!B&A1&A|D3&!D2&!D1&D&C1&!C&B1&!B&A1&A|!D3&!D2&!D1&D&C1&!C&B1&!B&A1&A|D3&D2&D1&D&!C1&!C&B1&!B&A1&A|D3&D2&D1&D&!C1&!C&B1&B&A1&A|!D3&!D2&!D1&D&C1&!C&B1&B&A1&A|D3&!D2&!D1&D&C1&!C&B1&B&A1&A|D3&D2&!D1&D&C1&!C&B1&B&A1&A|!D3&D2&!D1&D&C1&!C&B1&B&A1&A|!D3&D2&D1&D&C1&!C&B1&B&A1&A|D3&D2&D1&D&C1&!C&B1&B&A1&A|D3&!D2&D1&D&C1&!C&B1&B&A1&A|!D3&!D2&D1&D&C1&!C&B1&B&A1&A|!D3&!D2&D1&!D&C1&!C&B1&B&A1&A|D3&!D2&D1&!D&C1&!C&B1&B&A1&A|D3&D2&D1&!D&C1&!C&B1&B&A1&A|!D3&D2&D1&!D&C1&!C&B1&B&A1&A|!D3&D2&!D1&!D&C1&!C&B1&B&A1&A|D3&D2&!D1&!D&C1&!C&B1&B&A1&A|D3&!D2&!D1&!D&C1&!C&B1&B&A1&A|!D3&!D2&!D1&!D&C1&!C&B1&B&A1&A|!D3&!D2&!D1&!D&C1&C&B1&B&A1&A|D3&!D2&!D1&!D&C1&C&B1&B&A1&A|D3&D2&!D1&!D&C1&C&B1&B&A1&A|!D3&D2&!D1&!D&C1&C&B1&B&A1&A|!D3&D2&D1&!D&C1&C&B1&B&A1&A|D3&D2&D1&!D&C1&C&B1&B&A1&A|D3&!D2&D1&!D&C1&C&B1&B&A1&A|!D3&!D2&D1&!D&C1&C&B1&B&A1&A|!D3&!D2&D1&D&C1&C&B1&B&A1&A|D3&!D2&D1&D&C1&C&B1&B&A1&A|D3&D2&D1&D&C1&C&B1&B&A1&A|!D3&D2&D1&D&C1&C&B1&B&A1&A|!D3&D2&!D1&D&C1&C&B1&B&A1&A|D3&D2&!D1&D&C1&C&B1&B&A1&A|D3&!D2&!D1&D&C1&C&B1&B&A1&A|!D3&!D2&!D1&D&C1&C&B1&B&A1&A|!D3&!D2&!D1&D&!C1&C&B1&B&A1&A|D3&!D2&!D1&D&!C1&C&B1&B&A1&A|D3&D2&!D1&D&!C1&C&B1&B&A1&A|!D3&D2&!D1&D&!C1&C&B1&B&A1&A|!D3&D2&D1&D&!C1&C&B1&B&A1&A|D3&D2&D1&D&!C1&C&B1&B&A1&A|D3&!D2&D1&D&!C1&C&B1&B&A1&A|!D3&!D2&D1&D&!C1&C&B1&B&A1&A|!D3&!D2&D1&!D&!C1&C&B1&B&A1&A|D3&!D2&D1&!D&!C1&C&B1&B&A1&A|D3&D2&D1&!D&!C1&C&B1&B&A1&A|!D3&D2&D1&!D&!C1&C&B1&B&A1&A|!D3&D2&!D1&!D&!C1&C&B1&B&A1&A|D3&D2&!D1&!D&!C1&C&B1&B&A1&A|D3&!D2&!D1&!D&!C1&C&B1&B&A1&A|!D3&!D2&!D1&!D&!C1&C&B1&B&A1&A|!D3&!D2&!D1&!D&!C1&C&!B1&B&A1&A|D3&!D2&!D1&!D&!C1&C&!B1&B&A1&A|D3&D2&!D1&!D&!C1&C&!B1&B&A1&A|!D3&D2&!D1&!D&!C1&C&!B1&B&A1&A|!D3&D2&D1&!D&!C1&C&!B1&B&A1&A|D3&D2&D1&!D&!C1&C&!B1&B&A1&A|D3&!D2&D1&!D&!C1&C&!B1&B&A1&A|!D3&!D2&D1&!D&!C1&C&!B1&B&A1&A|!D3&!D2&D1&D&!C1&C&!B1&B&A1&A|D3&!D2&D1&D&!C1&C&!B1&B&A1&A|D3&D2&D1&D&!C1&C&!B1&B&A1&A|!D3&D2&D1&D&!C1&C&!B1&B&A1&A|!D3&D2&!D1&D&!C1&C&!B1&B&A1&A|D3&D2&!D1&D&!C1&C&!B1&B&A1&A|D3&!D2&!D1&D&!C1&C&!B1&B&A1&A|!D3&!D2&!D1&D&!C1&C&!B1&B&A1&A|!D3&!D2&!D1&D&C1&C&!B1&B&A1&A|D3&!D2&!D1&D&C1&C&!B1&B&A1&A|D3&D2&!D1&D&C1&C&!B1&B&A1&A|!D3&D2&!D1&D&C1&C&!B1&B&A1&A|!D3&D2&D1&D&C1&C&!B1&B&A1&A|D3&D2&D1&D&C1&C&!B1&B&A1&A|D3&!D2&D1&D&C1&C&!B1&B&A1&A|!D3&!D2&D1&D&C1&C&!B1&B&A1&A|!D3&!D2&D1&!D&C1&C&!B1&B&A1&A|D3&!D2&D1&!D&C1&C&!B1&B&A1&A|D3&D2&D1&!D&C1&C&!B1&B&A1&A|!D3&D2&D1&!D&C1&C&!B1&B&A1&A|!D3&D2&!D1&!D&C1&C&!B1&B&A1&A|D3&D2&!D1&!D&C1&C&!B1&B&A1&A|D3&!D2&!D1&!D&C1&C&!B1&B&A1&A|!D3&!D2&!D1&!D&C1&C&!B1&B&A1&A|!D3&!D2&!D1&!D&C1&!C&!B1&B&A1&A|D3&!D2&!D1&!D&C1&!C&!B1&B&A1&A|D3&D2&!D1&!D&C1&!C&!B1&B&A1&A|!D3&D2&!D1&!D&C1&!C&!B1&B&A1&A|!D3&D2&D1&!D&C1&!C&!B1&B&A1&A|D3&D2&D1&!D&C1&!C&!B1&B&A1&A|D3&!D2&D1&!D&C1&!C&!B1&B&A1&A|!D3&!D2&D1&!D&C1&!C&!B1&B&A1&A|!D3&!D2&D1&D&C1&!C&!B1&B&A1&A|D3&!D2&D1&D&C1&!C&!B1&B&A1&A|D3&D2&D1&D&C1&!C&!B1&B&A1&A|!D3&D2&D1&D&C1&!C&!B1&B&A1&A|!D3&D2&!D1&D&C1&!C&!B1&B&A1&A|D3&D2&!D1&D&C1&!C&!B1&B&A1&A|D3&!D2&!D1&D&C1&!C&!B1&B&A1&A|!D3&!D2&!D1&D&C1&!C&!B1&B&A1&A|D3&D2&D1&D&!C1&!C&!B1&B&A1&A|D3&D2&D1&D&!C1&!C&!B1&B&!A1&A|D3&D2&D1&D&C1&!C&!B1&B&!A1&A|D3&D2&D1&D&C1&C&!B1&B&!A1&A|D3&D2&D1&D&!C1&C&!B1&B&!A1&A|!D3&!D2&!D1&!D&!C1&C&B1&B&!A1&A|D3&!D2&!D1&!D&!C1&C&B1&B&!A1&A|D3&D2&!D1&!D&!C1&C&B1&B&!A1&A|!D3&D2&!D1&!D&!C1&C&B1&B&!A1&A|!D3&D2&D1&!D&!C1&C&B1&B&!A1&A|D3&D2&D1&!D&!C1&C&B1&B&!A1&A|D3&!D2&D1&!D&!C1&C&B1&B&!A1&A|!D3&!D2&D1&!D&!C1&C&B1&B&!A1&A|!D3&!D2&D1&D&!C1&C&B1&B&!A1&A|D3&!D2&D1&D&!C1&C&B1&B&!A1&A|D3&D2&D1&D&!C1&C&B1&B&!A1&A|!D3&D2&D1&D&!C1&C&B1&B&!A1&A|!D3&D2&!D1&D&!C1&C&B1&B&!A1&A|D3&D2&!D1&D&!C1&C&B1&B&!A1&A|D3&!D2&!D1&D&!C1&C&B1&B&!A1&A|!D3&!D2&!D1&D&!C1&C&B1&B&!A1&A|!D3&!D2&!D1&D&C1&C&B1&B&!A1&A|D3&!D2&!D1&D&C1&C&B1&B&!A1&A|D3&D2&!D1&D&C1&C&B1&B&!A1&A|!D3&D2&!D1&D&C1&C&B1&B&!A1&A|!D3&D2&D1&D&C1&C&B1&B&!A1&A|D3&D2&D1&D&C1&C&B1&B&!A1&A|D3&!D2&D1&D&C1&C&B1&B&!A1&A|!D3&!D2&D1&D&C1&C&B1&B&!A1&A|!D3&!D2&D1&!D&C1&C&B1&B&!A1&A|D3&!D2&D1&!D&C1&C&B1&B&!A1&A|D3&D2&D1&!D&C1&C&B1&B&!A1&A|!D3&D2&D1&!D&C1&C&B1&B&!A1&A|!D3&D2&!D1&!D&C1&C&B1&B&!A1&A|D3&D2&!D1&!D&C1&C&B1&B&!A1&A|D3&!D2&!D1&!D&C1&C&B1&B&!A1&A|!D3&!D2&!D1&!D&C1&C&B1&B&!A1&A|!D3&!D2&!D1&!D&C1&!C&B1&B&!A1&A|D3&!D2&!D1&!D&C1&!C&B1&B&!A1&A|D3&D2&!D1&!D&C1&!C&B1&B&!A1&A|!D3&D2&!D1&!D&C1&!C&B1&B&!A1&A|!D3&D2&D1&!D&C1&!C&B1&B&!A1&A|D3&D2&D1&!D&C1&!C&B1&B&!A1&A|D3&!D2&D1&!D&C1&!C&B1&B&!A1&A|!D3&!D2&D1&!D&C1&!C&B1&B&!A1&A|!D3&!D2&D1&D&C1&!C&B1&B&!A1&A|D3&!D2&D1&D&C1&!C&B1&B&!A1&A|D3&D2&D1&D&C1&!C&B1&B&!A1&A|!D3&D2&D1&D&C1&!C&B1&B&!A1&A|!D3&D2&!D1&D&C1&!C&B1&B&!A1&A|D3&D2&!D1&D&C1&!C&B1&B&!A1&A|D3&!D2&!D1&D&C1&!C&B1&B&!A1&A|!D3&!D2&!D1&D&C1&!C&B1&B&!A1&A|D3&D2&D1&D&!C1&!C&B1&B&!A1&A|D3&D2&D1&D&!C1&!C&B1&!B&!A1&A|D3&D2&D1&D&C1&!C&B1&!B&!A1&A|D3&D2&D1&D&C1&C&B1&!B&!A1&A|D3&D2&D1&D&!C1&C&B1&!B&!A1&A|D3&D2&D1&D&!C1&C&!B1&!B&!A1&A|D3&D2&D1&D&C1&C&!B1&!B&!A1&A|D3&D2&D1&D&C1&!C&!B1&!B&!A1&A|D3&D2&D1&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAAOI2224.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOOAI3322 -l AAAOOAI3322 -i D1 D C1 C B2 B1 B A2 A1 A -o Y -f Y=!(D1&!D&C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&D&C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&C1&C&B2&!B1&!B&!A2&!A1&!A|D1&D&C1&C&B2&!B1&!B&!A2&!A1&!A|D1&!D&C1&C&B2&!B1&!B&!A2&!A1&!A|D1&!D&C1&C&B2&B1&!B&!A2&!A1&!A|D1&D&C1&C&B2&B1&!B&!A2&!A1&!A|!D1&D&C1&C&B2&B1&!B&!A2&!A1&!A|!D1&D&C1&C&!B2&B1&!B&!A2&!A1&!A|D1&D&C1&C&!B2&B1&!B&!A2&!A1&!A|D1&!D&C1&C&!B2&B1&!B&!A2&!A1&!A|D1&!D&C1&C&!B2&B1&B&!A2&!A1&!A|D1&D&C1&C&!B2&B1&B&!A2&!A1&!A|!D1&D&C1&C&!B2&B1&B&!A2&!A1&!A|D1&!D&!C1&C&B2&B1&B&!A2&!A1&!A|D1&D&!C1&C&B2&B1&B&!A2&!A1&!A|!D1&D&!C1&C&B2&B1&B&!A2&!A1&!A|!D1&D&C1&C&B2&B1&B&!A2&!A1&!A|D1&D&C1&C&B2&B1&B&!A2&!A1&!A|D1&!D&C1&C&B2&B1&B&!A2&!A1&!A|D1&!D&C1&!C&B2&B1&B&!A2&!A1&!A|D1&D&C1&!C&B2&B1&B&!A2&!A1&!A|!D1&D&C1&!C&B2&B1&B&!A2&!A1&!A|!D1&D&!C1&!C&B2&B1&B&!A2&!A1&!A|D1&D&!C1&!C&B2&B1&B&!A2&!A1&!A|D1&!D&!C1&!C&B2&B1&B&!A2&!A1&!A|D1&!D&C1&C&B2&!B1&B&!A2&!A1&!A|D1&D&C1&C&B2&!B1&B&!A2&!A1&!A|!D1&D&C1&C&B2&!B1&B&!A2&!A1&!A|!D1&D&C1&C&!B2&!B1&B&!A2&!A1&!A|D1&D&C1&C&!B2&!B1&B&!A2&!A1&!A|D1&!D&C1&C&!B2&!B1&B&!A2&!A1&!A|D1&!D&C1&C&!B2&!B1&B&A2&!A1&!A|D1&D&C1&C&!B2&!B1&B&A2&!A1&!A|!D1&D&C1&C&!B2&!B1&B&A2&!A1&!A|!D1&D&C1&C&B2&!B1&B&A2&!A1&!A|D1&D&C1&C&B2&!B1&B&A2&!A1&!A|D1&!D&C1&C&B2&!B1&B&A2&!A1&!A|D1&!D&!C1&!C&B2&B1&B&A2&!A1&!A|D1&D&!C1&!C&B2&B1&B&A2&!A1&!A|!D1&D&!C1&!C&B2&B1&B&A2&!A1&!A|!D1&D&C1&!C&B2&B1&B&A2&!A1&!A|D1&D&C1&!C&B2&B1&B&A2&!A1&!A|D1&!D&C1&!C&B2&B1&B&A2&!A1&!A|D1&!D&C1&C&B2&B1&B&A2&!A1&!A|D1&D&C1&C&B2&B1&B&A2&!A1&!A|!D1&D&C1&C&B2&B1&B&A2&!A1&!A|!D1&D&!C1&C&B2&B1&B&A2&!A1&!A|D1&D&!C1&C&B2&B1&B&A2&!A1&!A|D1&!D&!C1&C&B2&B1&B&A2&!A1&!A|!D1&D&C1&C&!B2&B1&B&A2&!A1&!A|D1&D&C1&C&!B2&B1&B&A2&!A1&!A|D1&!D&C1&C&!B2&B1&B&A2&!A1&!A|D1&!D&C1&C&!B2&B1&!B&A2&!A1&!A|D1&D&C1&C&!B2&B1&!B&A2&!A1&!A|!D1&D&C1&C&!B2&B1&!B&A2&!A1&!A|!D1&D&C1&C&B2&B1&!B&A2&!A1&!A|D1&D&C1&C&B2&B1&!B&A2&!A1&!A|D1&!D&C1&C&B2&B1&!B&A2&!A1&!A|D1&!D&C1&C&B2&!B1&!B&A2&!A1&!A|D1&D&C1&C&B2&!B1&!B&A2&!A1&!A|!D1&D&C1&C&B2&!B1&!B&A2&!A1&!A|!D1&D&C1&C&!B2&!B1&!B&A2&!A1&!A|D1&D&C1&C&!B2&!B1&!B&A2&!A1&!A|D1&!D&C1&C&!B2&!B1&!B&A2&!A1&!A|D1&!D&C1&C&!B2&!B1&!B&A2&A1&!A|D1&D&C1&C&!B2&!B1&!B&A2&A1&!A|!D1&D&C1&C&!B2&!B1&!B&A2&A1&!A|!D1&D&C1&C&B2&!B1&!B&A2&A1&!A|D1&D&C1&C&B2&!B1&!B&A2&A1&!A|D1&!D&C1&C&B2&!B1&!B&A2&A1&!A|D1&!D&C1&C&B2&B1&!B&A2&A1&!A|D1&D&C1&C&B2&B1&!B&A2&A1&!A|!D1&D&C1&C&B2&B1&!B&A2&A1&!A|!D1&D&C1&C&!B2&B1&!B&A2&A1&!A|D1&D&C1&C&!B2&B1&!B&A2&A1&!A|D1&!D&C1&C&!B2&B1&!B&A2&A1&!A|D1&!D&C1&C&!B2&B1&B&A2&A1&!A|D1&D&C1&C&!B2&B1&B&A2&A1&!A|!D1&D&C1&C&!B2&B1&B&A2&A1&!A|D1&!D&!C1&C&B2&B1&B&A2&A1&!A|D1&D&!C1&C&B2&B1&B&A2&A1&!A|!D1&D&!C1&C&B2&B1&B&A2&A1&!A|!D1&D&C1&C&B2&B1&B&A2&A1&!A|D1&D&C1&C&B2&B1&B&A2&A1&!A|D1&!D&C1&C&B2&B1&B&A2&A1&!A|D1&!D&C1&!C&B2&B1&B&A2&A1&!A|D1&D&C1&!C&B2&B1&B&A2&A1&!A|!D1&D&C1&!C&B2&B1&B&A2&A1&!A|!D1&D&!C1&!C&B2&B1&B&A2&A1&!A|D1&D&!C1&!C&B2&B1&B&A2&A1&!A|D1&!D&!C1&!C&B2&B1&B&A2&A1&!A|D1&!D&C1&C&B2&!B1&B&A2&A1&!A|D1&D&C1&C&B2&!B1&B&A2&A1&!A|!D1&D&C1&C&B2&!B1&B&A2&A1&!A|!D1&D&C1&C&!B2&!B1&B&A2&A1&!A|D1&D&C1&C&!B2&!B1&B&A2&A1&!A|D1&!D&C1&C&!B2&!B1&B&A2&A1&!A|D1&!D&C1&C&!B2&!B1&B&!A2&A1&!A|D1&D&C1&C&!B2&!B1&B&!A2&A1&!A|!D1&D&C1&C&!B2&!B1&B&!A2&A1&!A|!D1&D&C1&C&B2&!B1&B&!A2&A1&!A|D1&D&C1&C&B2&!B1&B&!A2&A1&!A|D1&!D&C1&C&B2&!B1&B&!A2&A1&!A|D1&!D&!C1&!C&B2&B1&B&!A2&A1&!A|D1&D&!C1&!C&B2&B1&B&!A2&A1&!A|!D1&D&!C1&!C&B2&B1&B&!A2&A1&!A|!D1&D&C1&!C&B2&B1&B&!A2&A1&!A|D1&D&C1&!C&B2&B1&B&!A2&A1&!A|D1&!D&C1&!C&B2&B1&B&!A2&A1&!A|D1&!D&C1&C&B2&B1&B&!A2&A1&!A|D1&D&C1&C&B2&B1&B&!A2&A1&!A|!D1&D&C1&C&B2&B1&B&!A2&A1&!A|!D1&D&!C1&C&B2&B1&B&!A2&A1&!A|D1&D&!C1&C&B2&B1&B&!A2&A1&!A|D1&!D&!C1&C&B2&B1&B&!A2&A1&!A|!D1&D&C1&C&!B2&B1&B&!A2&A1&!A|D1&D&C1&C&!B2&B1&B&!A2&A1&!A|D1&!D&C1&C&!B2&B1&B&!A2&A1&!A|D1&!D&C1&C&!B2&B1&!B&!A2&A1&!A|D1&D&C1&C&!B2&B1&!B&!A2&A1&!A|!D1&D&C1&C&!B2&B1&!B&!A2&A1&!A|!D1&D&C1&C&B2&B1&!B&!A2&A1&!A|D1&D&C1&C&B2&B1&!B&!A2&A1&!A|D1&!D&C1&C&B2&B1&!B&!A2&A1&!A|D1&!D&C1&C&B2&!B1&!B&!A2&A1&!A|D1&D&C1&C&B2&!B1&!B&!A2&A1&!A|!D1&D&C1&C&B2&!B1&!B&!A2&A1&!A|!D1&D&C1&C&!B2&!B1&!B&!A2&A1&!A|D1&D&C1&C&!B2&!B1&!B&!A2&A1&!A|D1&!D&C1&C&!B2&!B1&!B&!A2&A1&!A|D1&!D&C1&C&!B2&!B1&!B&!A2&A1&A|D1&D&C1&C&!B2&!B1&!B&!A2&A1&A|!D1&D&C1&C&!B2&!B1&!B&!A2&A1&A|!D1&D&C1&C&B2&!B1&!B&!A2&A1&A|D1&D&C1&C&B2&!B1&!B&!A2&A1&A|D1&!D&C1&C&B2&!B1&!B&!A2&A1&A|D1&!D&C1&C&B2&B1&!B&!A2&A1&A|D1&D&C1&C&B2&B1&!B&!A2&A1&A|!D1&D&C1&C&B2&B1&!B&!A2&A1&A|!D1&D&C1&C&!B2&B1&!B&!A2&A1&A|D1&D&C1&C&!B2&B1&!B&!A2&A1&A|D1&!D&C1&C&!B2&B1&!B&!A2&A1&A|D1&!D&C1&C&!B2&B1&B&!A2&A1&A|D1&D&C1&C&!B2&B1&B&!A2&A1&A|!D1&D&C1&C&!B2&B1&B&!A2&A1&A|D1&!D&!C1&C&B2&B1&B&!A2&A1&A|D1&D&!C1&C&B2&B1&B&!A2&A1&A|!D1&D&!C1&C&B2&B1&B&!A2&A1&A|!D1&D&C1&C&B2&B1&B&!A2&A1&A|D1&D&C1&C&B2&B1&B&!A2&A1&A|D1&!D&C1&C&B2&B1&B&!A2&A1&A|D1&!D&C1&!C&B2&B1&B&!A2&A1&A|D1&D&C1&!C&B2&B1&B&!A2&A1&A|!D1&D&C1&!C&B2&B1&B&!A2&A1&A|!D1&D&!C1&!C&B2&B1&B&!A2&A1&A|D1&D&!C1&!C&B2&B1&B&!A2&A1&A|D1&!D&!C1&!C&B2&B1&B&!A2&A1&A|D1&!D&C1&C&B2&!B1&B&!A2&A1&A|D1&D&C1&C&B2&!B1&B&!A2&A1&A|!D1&D&C1&C&B2&!B1&B&!A2&A1&A|!D1&D&C1&C&!B2&!B1&B&!A2&A1&A|D1&D&C1&C&!B2&!B1&B&!A2&A1&A|D1&!D&C1&C&!B2&!B1&B&!A2&A1&A|D1&!D&!C1&!C&!B2&!B1&B&A2&A1&A|D1&D&!C1&!C&!B2&!B1&B&A2&A1&A|!D1&D&!C1&!C&!B2&!B1&B&A2&A1&A|!D1&D&C1&!C&!B2&!B1&B&A2&A1&A|D1&D&C1&!C&!B2&!B1&B&A2&A1&A|D1&!D&C1&!C&!B2&!B1&B&A2&A1&A|D1&!D&C1&C&!B2&!B1&B&A2&A1&A|D1&D&C1&C&!B2&!B1&B&A2&A1&A|!D1&D&C1&C&!B2&!B1&B&A2&A1&A|!D1&D&!C1&C&!B2&!B1&B&A2&A1&A|D1&D&!C1&C&!B2&!B1&B&A2&A1&A|D1&!D&!C1&C&!B2&!B1&B&A2&A1&A|D1&!D&!C1&C&B2&!B1&B&A2&A1&A|D1&D&!C1&C&B2&!B1&B&A2&A1&A|!D1&D&!C1&C&B2&!B1&B&A2&A1&A|!D1&D&C1&C&B2&!B1&B&A2&A1&A|D1&D&C1&C&B2&!B1&B&A2&A1&A|D1&!D&C1&C&B2&!B1&B&A2&A1&A|D1&!D&C1&!C&B2&!B1&B&A2&A1&A|D1&D&C1&!C&B2&!B1&B&A2&A1&A|!D1&D&C1&!C&B2&!B1&B&A2&A1&A|!D1&D&!C1&!C&B2&!B1&B&A2&A1&A|D1&D&!C1&!C&B2&!B1&B&A2&A1&A|D1&!D&!C1&!C&B2&!B1&B&A2&A1&A|D1&!D&!C1&!C&B2&B1&B&A2&A1&A|D1&D&!C1&!C&B2&B1&B&A2&A1&A|!D1&D&!C1&!C&B2&B1&B&A2&A1&A|!D1&D&C1&!C&B2&B1&B&A2&A1&A|D1&D&C1&!C&B2&B1&B&A2&A1&A|D1&!D&C1&!C&B2&B1&B&A2&A1&A|D1&!D&C1&C&B2&B1&B&A2&A1&A|D1&D&C1&C&B2&B1&B&A2&A1&A|!D1&D&C1&C&B2&B1&B&A2&A1&A|!D1&D&!C1&C&B2&B1&B&A2&A1&A|D1&D&!C1&C&B2&B1&B&A2&A1&A|D1&!D&!C1&C&B2&B1&B&A2&A1&A|D1&!D&!C1&C&!B2&B1&B&A2&A1&A|D1&D&!C1&C&!B2&B1&B&A2&A1&A|!D1&D&!C1&C&!B2&B1&B&A2&A1&A|!D1&D&C1&C&!B2&B1&B&A2&A1&A|D1&D&C1&C&!B2&B1&B&A2&A1&A|D1&!D&C1&C&!B2&B1&B&A2&A1&A|D1&!D&C1&!C&!B2&B1&B&A2&A1&A|D1&D&C1&!C&!B2&B1&B&A2&A1&A|!D1&D&C1&!C&!B2&B1&B&A2&A1&A|!D1&D&!C1&!C&!B2&B1&B&A2&A1&A|D1&D&!C1&!C&!B2&B1&B&A2&A1&A|D1&!D&!C1&!C&!B2&B1&B&A2&A1&A|D1&!D&!C1&!C&!B2&B1&!B&A2&A1&A|D1&D&!C1&!C&!B2&B1&!B&A2&A1&A|!D1&D&!C1&!C&!B2&B1&!B&A2&A1&A|!D1&D&C1&!C&!B2&B1&!B&A2&A1&A|D1&D&C1&!C&!B2&B1&!B&A2&A1&A|D1&!D&C1&!C&!B2&B1&!B&A2&A1&A|D1&!D&C1&C&!B2&B1&!B&A2&A1&A|D1&D&C1&C&!B2&B1&!B&A2&A1&A|!D1&D&C1&C&!B2&B1&!B&A2&A1&A|!D1&D&!C1&C&!B2&B1&!B&A2&A1&A|D1&D&!C1&C&!B2&B1&!B&A2&A1&A|D1&!D&!C1&C&!B2&B1&!B&A2&A1&A|D1&!D&!C1&C&B2&B1&!B&A2&A1&A|D1&D&!C1&C&B2&B1&!B&A2&A1&A|!D1&D&!C1&C&B2&B1&!B&A2&A1&A|!D1&D&C1&C&B2&B1&!B&A2&A1&A|D1&D&C1&C&B2&B1&!B&A2&A1&A|D1&!D&C1&C&B2&B1&!B&A2&A1&A|D1&!D&C1&!C&B2&B1&!B&A2&A1&A|D1&D&C1&!C&B2&B1&!B&A2&A1&A|!D1&D&C1&!C&B2&B1&!B&A2&A1&A|!D1&D&!C1&!C&B2&B1&!B&A2&A1&A|D1&D&!C1&!C&B2&B1&!B&A2&A1&A|D1&!D&!C1&!C&B2&B1&!B&A2&A1&A|D1&!D&!C1&!C&B2&!B1&!B&A2&A1&A|D1&D&!C1&!C&B2&!B1&!B&A2&A1&A|!D1&D&!C1&!C&B2&!B1&!B&A2&A1&A|!D1&D&C1&!C&B2&!B1&!B&A2&A1&A|D1&D&C1&!C&B2&!B1&!B&A2&A1&A|D1&!D&C1&!C&B2&!B1&!B&A2&A1&A|D1&!D&C1&C&B2&!B1&!B&A2&A1&A|D1&D&C1&C&B2&!B1&!B&A2&A1&A|!D1&D&C1&C&B2&!B1&!B&A2&A1&A|!D1&D&!C1&C&B2&!B1&!B&A2&A1&A|D1&D&!C1&C&B2&!B1&!B&A2&A1&A|D1&!D&!C1&C&B2&!B1&!B&A2&A1&A|D1&!D&!C1&C&!B2&!B1&!B&A2&A1&A|D1&D&!C1&C&!B2&!B1&!B&A2&A1&A|!D1&D&!C1&C&!B2&!B1&!B&A2&A1&A|!D1&D&C1&C&!B2&!B1&!B&A2&A1&A|D1&D&C1&C&!B2&!B1&!B&A2&A1&A|D1&!D&C1&C&!B2&!B1&!B&A2&A1&A|D1&!D&C1&!C&!B2&!B1&!B&A2&A1&A|D1&D&C1&!C&!B2&!B1&!B&A2&A1&A|!D1&D&C1&!C&!B2&!B1&!B&A2&A1&A|!D1&D&!C1&!C&!B2&!B1&!B&A2&A1&A|D1&D&!C1&!C&!B2&!B1&!B&A2&A1&A|D1&!D&!C1&!C&!B2&!B1&!B&A2&A1&A|D1&!D&C1&C&!B2&!B1&!B&A2&!A1&A|D1&D&C1&C&!B2&!B1&!B&A2&!A1&A|!D1&D&C1&C&!B2&!B1&!B&A2&!A1&A|!D1&D&C1&C&B2&!B1&!B&A2&!A1&A|D1&D&C1&C&B2&!B1&!B&A2&!A1&A|D1&!D&C1&C&B2&!B1&!B&A2&!A1&A|D1&!D&C1&C&B2&B1&!B&A2&!A1&A|D1&D&C1&C&B2&B1&!B&A2&!A1&A|!D1&D&C1&C&B2&B1&!B&A2&!A1&A|!D1&D&C1&C&!B2&B1&!B&A2&!A1&A|D1&D&C1&C&!B2&B1&!B&A2&!A1&A|D1&!D&C1&C&!B2&B1&!B&A2&!A1&A|D1&!D&C1&C&!B2&B1&B&A2&!A1&A|D1&D&C1&C&!B2&B1&B&A2&!A1&A|!D1&D&C1&C&!B2&B1&B&A2&!A1&A|D1&!D&!C1&C&B2&B1&B&A2&!A1&A|D1&D&!C1&C&B2&B1&B&A2&!A1&A|!D1&D&!C1&C&B2&B1&B&A2&!A1&A|!D1&D&C1&C&B2&B1&B&A2&!A1&A|D1&D&C1&C&B2&B1&B&A2&!A1&A|D1&!D&C1&C&B2&B1&B&A2&!A1&A|D1&!D&C1&!C&B2&B1&B&A2&!A1&A|D1&D&C1&!C&B2&B1&B&A2&!A1&A|!D1&D&C1&!C&B2&B1&B&A2&!A1&A|!D1&D&!C1&!C&B2&B1&B&A2&!A1&A|D1&D&!C1&!C&B2&B1&B&A2&!A1&A|D1&!D&!C1&!C&B2&B1&B&A2&!A1&A|D1&!D&C1&C&B2&!B1&B&A2&!A1&A|D1&D&C1&C&B2&!B1&B&A2&!A1&A|!D1&D&C1&C&B2&!B1&B&A2&!A1&A|!D1&D&C1&C&!B2&!B1&B&A2&!A1&A|D1&D&C1&C&!B2&!B1&B&A2&!A1&A|D1&!D&C1&C&!B2&!B1&B&A2&!A1&A|D1&!D&C1&C&!B2&!B1&B&!A2&!A1&A|D1&D&C1&C&!B2&!B1&B&!A2&!A1&A|!D1&D&C1&C&!B2&!B1&B&!A2&!A1&A|!D1&D&C1&C&B2&!B1&B&!A2&!A1&A|D1&D&C1&C&B2&!B1&B&!A2&!A1&A|D1&!D&C1&C&B2&!B1&B&!A2&!A1&A|D1&!D&!C1&!C&B2&B1&B&!A2&!A1&A|D1&D&!C1&!C&B2&B1&B&!A2&!A1&A|!D1&D&!C1&!C&B2&B1&B&!A2&!A1&A|!D1&D&C1&!C&B2&B1&B&!A2&!A1&A|D1&D&C1&!C&B2&B1&B&!A2&!A1&A|D1&!D&C1&!C&B2&B1&B&!A2&!A1&A|D1&!D&C1&C&B2&B1&B&!A2&!A1&A|D1&D&C1&C&B2&B1&B&!A2&!A1&A|!D1&D&C1&C&B2&B1&B&!A2&!A1&A|!D1&D&!C1&C&B2&B1&B&!A2&!A1&A|D1&D&!C1&C&B2&B1&B&!A2&!A1&A|D1&!D&!C1&C&B2&B1&B&!A2&!A1&A|!D1&D&C1&C&!B2&B1&B&!A2&!A1&A|D1&D&C1&C&!B2&B1&B&!A2&!A1&A|D1&!D&C1&C&!B2&B1&B&!A2&!A1&A|D1&!D&C1&C&!B2&B1&!B&!A2&!A1&A|D1&D&C1&C&!B2&B1&!B&!A2&!A1&A|!D1&D&C1&C&!B2&B1&!B&!A2&!A1&A|!D1&D&C1&C&B2&B1&!B&!A2&!A1&A|D1&D&C1&C&B2&B1&!B&!A2&!A1&A|D1&!D&C1&C&B2&B1&!B&!A2&!A1&A|D1&!D&C1&C&B2&!B1&!B&!A2&!A1&A|D1&D&C1&C&B2&!B1&!B&!A2&!A1&A|!D1&D&C1&C&B2&!B1&!B&!A2&!A1&A|!D1&D&C1&C&!B2&!B1&!B&!A2&!A1&A|D1&D&C1&C&!B2&!B1&!B&!A2&!A1&A|D1&!D&C1&C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOOAI3322.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAAOAI22231 -l AAOOAAOAI22231 -i E D2 D1 D C1 C B1 B A1 A -o Y -f Y=!(E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|E&D2&D1&D&C1&C&!B1&!B&!A1&!A|E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|E&D2&D1&D&!C1&C&B1&!B&!A1&!A|E&D2&D1&D&C1&C&B1&!B&!A1&!A|E&D2&D1&D&C1&!C&B1&!B&!A1&!A|E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|E&D2&D1&D&!C1&!C&B1&B&!A1&!A|E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|E&D2&!D1&D&C1&!C&B1&B&!A1&!A|E&D2&D1&D&C1&!C&B1&B&!A1&!A|E&!D2&D1&D&C1&!C&B1&B&!A1&!A|E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|E&D2&D1&!D&C1&!C&B1&B&!A1&!A|E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|E&D2&!D1&!D&C1&C&B1&B&!A1&!A|E&D2&D1&!D&C1&C&B1&B&!A1&!A|E&!D2&D1&!D&C1&C&B1&B&!A1&!A|E&!D2&D1&D&C1&C&B1&B&!A1&!A|E&D2&D1&D&C1&C&B1&B&!A1&!A|E&D2&!D1&D&C1&C&B1&B&!A1&!A|E&!D2&!D1&D&C1&C&B1&B&!A1&!A|E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|E&D2&!D1&D&!C1&C&B1&B&!A1&!A|E&D2&D1&D&!C1&C&B1&B&!A1&!A|E&!D2&D1&D&!C1&C&B1&B&!A1&!A|E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|E&D2&D1&!D&!C1&C&B1&B&!A1&!A|E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|E&D2&D1&D&!C1&C&!B1&B&!A1&!A|E&D2&D1&D&C1&C&!B1&B&!A1&!A|E&D2&D1&D&C1&!C&!B1&B&!A1&!A|E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|E&D2&D1&D&!C1&!C&!B1&B&A1&!A|E&D2&D1&D&C1&!C&!B1&B&A1&!A|E&D2&D1&D&C1&C&!B1&B&A1&!A|E&D2&D1&D&!C1&C&!B1&B&A1&!A|E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|E&D2&!D1&!D&!C1&C&B1&B&A1&!A|E&D2&D1&!D&!C1&C&B1&B&A1&!A|E&!D2&D1&!D&!C1&C&B1&B&A1&!A|E&!D2&D1&D&!C1&C&B1&B&A1&!A|E&D2&D1&D&!C1&C&B1&B&A1&!A|E&D2&!D1&D&!C1&C&B1&B&A1&!A|E&!D2&!D1&D&!C1&C&B1&B&A1&!A|E&!D2&!D1&D&C1&C&B1&B&A1&!A|E&D2&!D1&D&C1&C&B1&B&A1&!A|E&D2&D1&D&C1&C&B1&B&A1&!A|E&!D2&D1&D&C1&C&B1&B&A1&!A|E&!D2&D1&!D&C1&C&B1&B&A1&!A|E&D2&D1&!D&C1&C&B1&B&A1&!A|E&D2&!D1&!D&C1&C&B1&B&A1&!A|E&!D2&!D1&!D&C1&C&B1&B&A1&!A|E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|E&D2&!D1&!D&C1&!C&B1&B&A1&!A|E&D2&D1&!D&C1&!C&B1&B&A1&!A|E&!D2&D1&!D&C1&!C&B1&B&A1&!A|E&!D2&D1&D&C1&!C&B1&B&A1&!A|E&D2&D1&D&C1&!C&B1&B&A1&!A|E&D2&!D1&D&C1&!C&B1&B&A1&!A|E&!D2&!D1&D&C1&!C&B1&B&A1&!A|E&D2&D1&D&!C1&!C&B1&B&A1&!A|E&D2&D1&D&!C1&!C&B1&!B&A1&!A|E&D2&D1&D&C1&!C&B1&!B&A1&!A|E&D2&D1&D&C1&C&B1&!B&A1&!A|E&D2&D1&D&!C1&C&B1&!B&A1&!A|E&D2&D1&D&!C1&C&!B1&!B&A1&!A|E&D2&D1&D&C1&C&!B1&!B&A1&!A|E&D2&D1&D&C1&!C&!B1&!B&A1&!A|E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|E&D2&D1&D&!C1&!C&!B1&!B&A1&A|E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|E&D2&!D1&D&C1&!C&!B1&!B&A1&A|E&D2&D1&D&C1&!C&!B1&!B&A1&A|E&!D2&D1&D&C1&!C&!B1&!B&A1&A|E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|E&D2&D1&!D&C1&!C&!B1&!B&A1&A|E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|E&D2&!D1&!D&C1&C&!B1&!B&A1&A|E&D2&D1&!D&C1&C&!B1&!B&A1&A|E&!D2&D1&!D&C1&C&!B1&!B&A1&A|E&!D2&D1&D&C1&C&!B1&!B&A1&A|E&D2&D1&D&C1&C&!B1&!B&A1&A|E&D2&!D1&D&C1&C&!B1&!B&A1&A|E&!D2&!D1&D&C1&C&!B1&!B&A1&A|E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|E&D2&!D1&D&!C1&C&!B1&!B&A1&A|E&D2&D1&D&!C1&C&!B1&!B&A1&A|E&!D2&D1&D&!C1&C&!B1&!B&A1&A|E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|E&D2&D1&!D&!C1&C&!B1&!B&A1&A|E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|E&D2&!D1&!D&!C1&C&B1&!B&A1&A|E&D2&D1&!D&!C1&C&B1&!B&A1&A|E&!D2&D1&!D&!C1&C&B1&!B&A1&A|E&!D2&D1&D&!C1&C&B1&!B&A1&A|E&D2&D1&D&!C1&C&B1&!B&A1&A|E&D2&!D1&D&!C1&C&B1&!B&A1&A|E&!D2&!D1&D&!C1&C&B1&!B&A1&A|E&!D2&!D1&D&C1&C&B1&!B&A1&A|E&D2&!D1&D&C1&C&B1&!B&A1&A|E&D2&D1&D&C1&C&B1&!B&A1&A|E&!D2&D1&D&C1&C&B1&!B&A1&A|E&!D2&D1&!D&C1&C&B1&!B&A1&A|E&D2&D1&!D&C1&C&B1&!B&A1&A|E&D2&!D1&!D&C1&C&B1&!B&A1&A|E&!D2&!D1&!D&C1&C&B1&!B&A1&A|E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|E&D2&!D1&!D&C1&!C&B1&!B&A1&A|E&D2&D1&!D&C1&!C&B1&!B&A1&A|E&!D2&D1&!D&C1&!C&B1&!B&A1&A|E&!D2&D1&D&C1&!C&B1&!B&A1&A|E&D2&D1&D&C1&!C&B1&!B&A1&A|E&D2&!D1&D&C1&!C&B1&!B&A1&A|E&!D2&!D1&D&C1&!C&B1&!B&A1&A|E&D2&D1&D&!C1&!C&B1&!B&A1&A|E&D2&D1&D&!C1&!C&B1&B&A1&A|E&!D2&!D1&D&C1&!C&B1&B&A1&A|E&D2&!D1&D&C1&!C&B1&B&A1&A|E&D2&D1&D&C1&!C&B1&B&A1&A|E&!D2&D1&D&C1&!C&B1&B&A1&A|E&!D2&D1&!D&C1&!C&B1&B&A1&A|E&D2&D1&!D&C1&!C&B1&B&A1&A|E&D2&!D1&!D&C1&!C&B1&B&A1&A|E&!D2&!D1&!D&C1&!C&B1&B&A1&A|E&!D2&!D1&!D&C1&C&B1&B&A1&A|E&D2&!D1&!D&C1&C&B1&B&A1&A|E&D2&D1&!D&C1&C&B1&B&A1&A|E&!D2&D1&!D&C1&C&B1&B&A1&A|E&!D2&D1&D&C1&C&B1&B&A1&A|E&D2&D1&D&C1&C&B1&B&A1&A|E&D2&!D1&D&C1&C&B1&B&A1&A|E&!D2&!D1&D&C1&C&B1&B&A1&A|E&!D2&!D1&D&!C1&C&B1&B&A1&A|E&D2&!D1&D&!C1&C&B1&B&A1&A|E&D2&D1&D&!C1&C&B1&B&A1&A|E&!D2&D1&D&!C1&C&B1&B&A1&A|E&!D2&D1&!D&!C1&C&B1&B&A1&A|E&D2&D1&!D&!C1&C&B1&B&A1&A|E&D2&!D1&!D&!C1&C&B1&B&A1&A|E&!D2&!D1&!D&!C1&C&B1&B&A1&A|E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|E&D2&!D1&!D&!C1&C&!B1&B&A1&A|E&D2&D1&!D&!C1&C&!B1&B&A1&A|E&!D2&D1&!D&!C1&C&!B1&B&A1&A|E&!D2&D1&D&!C1&C&!B1&B&A1&A|E&D2&D1&D&!C1&C&!B1&B&A1&A|E&D2&!D1&D&!C1&C&!B1&B&A1&A|E&!D2&!D1&D&!C1&C&!B1&B&A1&A|E&!D2&!D1&D&C1&C&!B1&B&A1&A|E&D2&!D1&D&C1&C&!B1&B&A1&A|E&D2&D1&D&C1&C&!B1&B&A1&A|E&!D2&D1&D&C1&C&!B1&B&A1&A|E&!D2&D1&!D&C1&C&!B1&B&A1&A|E&D2&D1&!D&C1&C&!B1&B&A1&A|E&D2&!D1&!D&C1&C&!B1&B&A1&A|E&!D2&!D1&!D&C1&C&!B1&B&A1&A|E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|E&D2&!D1&!D&C1&!C&!B1&B&A1&A|E&D2&D1&!D&C1&!C&!B1&B&A1&A|E&!D2&D1&!D&C1&!C&!B1&B&A1&A|E&!D2&D1&D&C1&!C&!B1&B&A1&A|E&D2&D1&D&C1&!C&!B1&B&A1&A|E&D2&!D1&D&C1&!C&!B1&B&A1&A|E&!D2&!D1&D&C1&!C&!B1&B&A1&A|E&D2&D1&D&!C1&!C&!B1&B&A1&A|E&D2&D1&D&!C1&!C&!B1&B&!A1&A|E&D2&D1&D&C1&!C&!B1&B&!A1&A|E&D2&D1&D&C1&C&!B1&B&!A1&A|E&D2&D1&D&!C1&C&!B1&B&!A1&A|E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|E&D2&!D1&!D&!C1&C&B1&B&!A1&A|E&D2&D1&!D&!C1&C&B1&B&!A1&A|E&!D2&D1&!D&!C1&C&B1&B&!A1&A|E&!D2&D1&D&!C1&C&B1&B&!A1&A|E&D2&D1&D&!C1&C&B1&B&!A1&A|E&D2&!D1&D&!C1&C&B1&B&!A1&A|E&!D2&!D1&D&!C1&C&B1&B&!A1&A|E&!D2&!D1&D&C1&C&B1&B&!A1&A|E&D2&!D1&D&C1&C&B1&B&!A1&A|E&D2&D1&D&C1&C&B1&B&!A1&A|E&!D2&D1&D&C1&C&B1&B&!A1&A|E&!D2&D1&!D&C1&C&B1&B&!A1&A|E&D2&D1&!D&C1&C&B1&B&!A1&A|E&D2&!D1&!D&C1&C&B1&B&!A1&A|E&!D2&!D1&!D&C1&C&B1&B&!A1&A|E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|E&D2&!D1&!D&C1&!C&B1&B&!A1&A|E&D2&D1&!D&C1&!C&B1&B&!A1&A|E&!D2&D1&!D&C1&!C&B1&B&!A1&A|E&!D2&D1&D&C1&!C&B1&B&!A1&A|E&D2&D1&D&C1&!C&B1&B&!A1&A|E&D2&!D1&D&C1&!C&B1&B&!A1&A|E&!D2&!D1&D&C1&!C&B1&B&!A1&A|E&D2&D1&D&!C1&!C&B1&B&!A1&A|E&D2&D1&D&!C1&!C&B1&!B&!A1&A|E&D2&D1&D&C1&!C&B1&!B&!A1&A|E&D2&D1&D&C1&C&B1&!B&!A1&A|E&D2&D1&D&!C1&C&B1&!B&!A1&A|E&D2&D1&D&!C1&C&!B1&!B&!A1&A|E&D2&D1&D&C1&C&!B1&!B&!A1&A|E&D2&D1&D&C1&!C&!B1&!B&!A1&A|E&D2&D1&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAAOAI22231.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOI43 -l AOI43 -i B2 B1 B A3 A2 A1 A -o Y -f Y=(!B2&!B1&!B&!A3&!A2&!A1&!A|!B2&!B1&!B&A3&!A2&!A1&!A|!B2&!B1&!B&A3&A2&!A1&!A|!B2&!B1&!B&!A3&A2&!A1&!A|!B2&!B1&!B&!A3&A2&A1&!A|!B2&!B1&!B&A3&A2&A1&!A|!B2&!B1&!B&A3&!A2&A1&!A|!B2&!B1&!B&!A3&!A2&A1&!A|!B2&!B1&!B&!A3&!A2&A1&A|!B2&!B1&!B&A3&!A2&A1&A|!B2&!B1&!B&!A3&A2&A1&A|!B2&!B1&!B&!A3&A2&!A1&A|!B2&!B1&!B&A3&A2&!A1&A|!B2&!B1&!B&A3&!A2&!A1&A|!B2&!B1&!B&!A3&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOI43.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOOAI3222 -l OOOOAI3222 -i D1 D C1 C B1 B A2 A1 A -o Y -f Y=!(!D1&D&C1&!C&!B1&B&A2&!A1&!A|D1&D&C1&!C&!B1&B&A2&!A1&!A|D1&!D&C1&!C&!B1&B&A2&!A1&!A|D1&!D&C1&C&!B1&B&A2&!A1&!A|D1&D&C1&C&!B1&B&A2&!A1&!A|!D1&D&C1&C&!B1&B&A2&!A1&!A|!D1&D&!C1&C&!B1&B&A2&!A1&!A|D1&D&!C1&C&!B1&B&A2&!A1&!A|D1&!D&!C1&C&!B1&B&A2&!A1&!A|D1&!D&!C1&C&B1&B&A2&!A1&!A|D1&D&!C1&C&B1&B&A2&!A1&!A|!D1&D&!C1&C&B1&B&A2&!A1&!A|!D1&D&C1&C&B1&B&A2&!A1&!A|D1&D&C1&C&B1&B&A2&!A1&!A|D1&!D&C1&C&B1&B&A2&!A1&!A|D1&!D&C1&!C&B1&B&A2&!A1&!A|D1&D&C1&!C&B1&B&A2&!A1&!A|!D1&D&C1&!C&B1&B&A2&!A1&!A|!D1&D&C1&!C&B1&!B&A2&!A1&!A|D1&D&C1&!C&B1&!B&A2&!A1&!A|D1&!D&C1&!C&B1&!B&A2&!A1&!A|D1&!D&C1&C&B1&!B&A2&!A1&!A|D1&D&C1&C&B1&!B&A2&!A1&!A|!D1&D&C1&C&B1&!B&A2&!A1&!A|!D1&D&!C1&C&B1&!B&A2&!A1&!A|D1&D&!C1&C&B1&!B&A2&!A1&!A|D1&!D&!C1&C&B1&!B&A2&!A1&!A|D1&!D&!C1&C&B1&!B&A2&A1&!A|D1&D&!C1&C&B1&!B&A2&A1&!A|!D1&D&!C1&C&B1&!B&A2&A1&!A|!D1&D&C1&C&B1&!B&A2&A1&!A|D1&D&C1&C&B1&!B&A2&A1&!A|D1&!D&C1&C&B1&!B&A2&A1&!A|D1&!D&C1&!C&B1&!B&A2&A1&!A|D1&D&C1&!C&B1&!B&A2&A1&!A|!D1&D&C1&!C&B1&!B&A2&A1&!A|!D1&D&C1&!C&B1&B&A2&A1&!A|D1&D&C1&!C&B1&B&A2&A1&!A|D1&!D&C1&!C&B1&B&A2&A1&!A|D1&!D&C1&C&B1&B&A2&A1&!A|D1&D&C1&C&B1&B&A2&A1&!A|!D1&D&C1&C&B1&B&A2&A1&!A|!D1&D&!C1&C&B1&B&A2&A1&!A|D1&D&!C1&C&B1&B&A2&A1&!A|D1&!D&!C1&C&B1&B&A2&A1&!A|D1&!D&!C1&C&!B1&B&A2&A1&!A|D1&D&!C1&C&!B1&B&A2&A1&!A|!D1&D&!C1&C&!B1&B&A2&A1&!A|!D1&D&C1&C&!B1&B&A2&A1&!A|D1&D&C1&C&!B1&B&A2&A1&!A|D1&!D&C1&C&!B1&B&A2&A1&!A|D1&!D&C1&!C&!B1&B&A2&A1&!A|D1&D&C1&!C&!B1&B&A2&A1&!A|!D1&D&C1&!C&!B1&B&A2&A1&!A|!D1&D&C1&!C&!B1&B&!A2&A1&!A|D1&D&C1&!C&!B1&B&!A2&A1&!A|D1&!D&C1&!C&!B1&B&!A2&A1&!A|D1&!D&C1&C&!B1&B&!A2&A1&!A|D1&D&C1&C&!B1&B&!A2&A1&!A|!D1&D&C1&C&!B1&B&!A2&A1&!A|!D1&D&!C1&C&!B1&B&!A2&A1&!A|D1&D&!C1&C&!B1&B&!A2&A1&!A|D1&!D&!C1&C&!B1&B&!A2&A1&!A|D1&!D&!C1&C&B1&B&!A2&A1&!A|D1&D&!C1&C&B1&B&!A2&A1&!A|!D1&D&!C1&C&B1&B&!A2&A1&!A|!D1&D&C1&C&B1&B&!A2&A1&!A|D1&D&C1&C&B1&B&!A2&A1&!A|D1&!D&C1&C&B1&B&!A2&A1&!A|D1&!D&C1&!C&B1&B&!A2&A1&!A|D1&D&C1&!C&B1&B&!A2&A1&!A|!D1&D&C1&!C&B1&B&!A2&A1&!A|!D1&D&C1&!C&B1&!B&!A2&A1&!A|D1&D&C1&!C&B1&!B&!A2&A1&!A|D1&!D&C1&!C&B1&!B&!A2&A1&!A|D1&!D&C1&C&B1&!B&!A2&A1&!A|D1&D&C1&C&B1&!B&!A2&A1&!A|!D1&D&C1&C&B1&!B&!A2&A1&!A|!D1&D&!C1&C&B1&!B&!A2&A1&!A|D1&D&!C1&C&B1&!B&!A2&A1&!A|D1&!D&!C1&C&B1&!B&!A2&A1&!A|D1&!D&!C1&C&B1&!B&!A2&A1&A|D1&D&!C1&C&B1&!B&!A2&A1&A|!D1&D&!C1&C&B1&!B&!A2&A1&A|!D1&D&C1&C&B1&!B&!A2&A1&A|D1&D&C1&C&B1&!B&!A2&A1&A|D1&!D&C1&C&B1&!B&!A2&A1&A|D1&!D&C1&!C&B1&!B&!A2&A1&A|D1&D&C1&!C&B1&!B&!A2&A1&A|!D1&D&C1&!C&B1&!B&!A2&A1&A|!D1&D&C1&!C&B1&B&!A2&A1&A|D1&D&C1&!C&B1&B&!A2&A1&A|D1&!D&C1&!C&B1&B&!A2&A1&A|D1&!D&C1&C&B1&B&!A2&A1&A|D1&D&C1&C&B1&B&!A2&A1&A|!D1&D&C1&C&B1&B&!A2&A1&A|!D1&D&!C1&C&B1&B&!A2&A1&A|D1&D&!C1&C&B1&B&!A2&A1&A|D1&!D&!C1&C&B1&B&!A2&A1&A|D1&!D&!C1&C&!B1&B&!A2&A1&A|D1&D&!C1&C&!B1&B&!A2&A1&A|!D1&D&!C1&C&!B1&B&!A2&A1&A|!D1&D&C1&C&!B1&B&!A2&A1&A|D1&D&C1&C&!B1&B&!A2&A1&A|D1&!D&C1&C&!B1&B&!A2&A1&A|D1&!D&C1&!C&!B1&B&!A2&A1&A|D1&D&C1&!C&!B1&B&!A2&A1&A|!D1&D&C1&!C&!B1&B&!A2&A1&A|!D1&D&C1&!C&!B1&B&A2&A1&A|D1&D&C1&!C&!B1&B&A2&A1&A|D1&!D&C1&!C&!B1&B&A2&A1&A|D1&!D&C1&C&!B1&B&A2&A1&A|D1&D&C1&C&!B1&B&A2&A1&A|!D1&D&C1&C&!B1&B&A2&A1&A|!D1&D&!C1&C&!B1&B&A2&A1&A|D1&D&!C1&C&!B1&B&A2&A1&A|D1&!D&!C1&C&!B1&B&A2&A1&A|D1&!D&!C1&C&B1&B&A2&A1&A|D1&D&!C1&C&B1&B&A2&A1&A|!D1&D&!C1&C&B1&B&A2&A1&A|!D1&D&C1&C&B1&B&A2&A1&A|D1&D&C1&C&B1&B&A2&A1&A|D1&!D&C1&C&B1&B&A2&A1&A|D1&!D&C1&!C&B1&B&A2&A1&A|D1&D&C1&!C&B1&B&A2&A1&A|!D1&D&C1&!C&B1&B&A2&A1&A|!D1&D&C1&!C&B1&!B&A2&A1&A|D1&D&C1&!C&B1&!B&A2&A1&A|D1&!D&C1&!C&B1&!B&A2&A1&A|D1&!D&C1&C&B1&!B&A2&A1&A|D1&D&C1&C&B1&!B&A2&A1&A|!D1&D&C1&C&B1&!B&A2&A1&A|!D1&D&!C1&C&B1&!B&A2&A1&A|D1&D&!C1&C&B1&!B&A2&A1&A|D1&!D&!C1&C&B1&!B&A2&A1&A|D1&!D&!C1&C&B1&!B&A2&!A1&A|D1&D&!C1&C&B1&!B&A2&!A1&A|!D1&D&!C1&C&B1&!B&A2&!A1&A|!D1&D&C1&C&B1&!B&A2&!A1&A|D1&D&C1&C&B1&!B&A2&!A1&A|D1&!D&C1&C&B1&!B&A2&!A1&A|D1&!D&C1&!C&B1&!B&A2&!A1&A|D1&D&C1&!C&B1&!B&A2&!A1&A|!D1&D&C1&!C&B1&!B&A2&!A1&A|!D1&D&C1&!C&B1&B&A2&!A1&A|D1&D&C1&!C&B1&B&A2&!A1&A|D1&!D&C1&!C&B1&B&A2&!A1&A|D1&!D&C1&C&B1&B&A2&!A1&A|D1&D&C1&C&B1&B&A2&!A1&A|!D1&D&C1&C&B1&B&A2&!A1&A|!D1&D&!C1&C&B1&B&A2&!A1&A|D1&D&!C1&C&B1&B&A2&!A1&A|D1&!D&!C1&C&B1&B&A2&!A1&A|D1&!D&!C1&C&!B1&B&A2&!A1&A|D1&D&!C1&C&!B1&B&A2&!A1&A|!D1&D&!C1&C&!B1&B&A2&!A1&A|!D1&D&C1&C&!B1&B&A2&!A1&A|D1&D&C1&C&!B1&B&A2&!A1&A|D1&!D&C1&C&!B1&B&A2&!A1&A|D1&!D&C1&!C&!B1&B&A2&!A1&A|D1&D&C1&!C&!B1&B&A2&!A1&A|!D1&D&C1&!C&!B1&B&A2&!A1&A|!D1&D&C1&!C&!B1&B&!A2&!A1&A|D1&D&C1&!C&!B1&B&!A2&!A1&A|D1&!D&C1&!C&!B1&B&!A2&!A1&A|D1&!D&C1&C&!B1&B&!A2&!A1&A|D1&D&C1&C&!B1&B&!A2&!A1&A|!D1&D&C1&C&!B1&B&!A2&!A1&A|!D1&D&!C1&C&!B1&B&!A2&!A1&A|D1&D&!C1&C&!B1&B&!A2&!A1&A|D1&!D&!C1&C&!B1&B&!A2&!A1&A|D1&!D&!C1&C&B1&B&!A2&!A1&A|D1&D&!C1&C&B1&B&!A2&!A1&A|!D1&D&!C1&C&B1&B&!A2&!A1&A|!D1&D&C1&C&B1&B&!A2&!A1&A|D1&D&C1&C&B1&B&!A2&!A1&A|D1&!D&C1&C&B1&B&!A2&!A1&A|D1&!D&C1&!C&B1&B&!A2&!A1&A|D1&D&C1&!C&B1&B&!A2&!A1&A|!D1&D&C1&!C&B1&B&!A2&!A1&A|!D1&D&C1&!C&B1&!B&!A2&!A1&A|D1&D&C1&!C&B1&!B&!A2&!A1&A|D1&!D&C1&!C&B1&!B&!A2&!A1&A|D1&!D&C1&C&B1&!B&!A2&!A1&A|D1&D&C1&C&B1&!B&!A2&!A1&A|!D1&D&C1&C&B1&!B&!A2&!A1&A|!D1&D&!C1&C&B1&!B&!A2&!A1&A|D1&D&!C1&C&B1&!B&!A2&!A1&A|D1&!D&!C1&C&B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOOAI3222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOOAAOI22122 -l OOAOOAAOI22122 -i E1 E D1 D C B1 B A1 A -o Y -f Y=(!E1&!E&!D1&!D&!C&!B1&!B&!A1&!A|E1&!E&!D1&!D&!C&!B1&!B&!A1&!A|!E1&E&!D1&!D&!C&!B1&!B&!A1&!A|!E1&E&D1&!D&!C&!B1&!B&!A1&!A|E1&!E&D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&D1&D&!C&!B1&!B&!A1&!A|E1&!E&D1&D&!C&!B1&!B&!A1&!A|!E1&E&D1&D&!C&!B1&!B&!A1&!A|!E1&E&!D1&D&!C&!B1&!B&!A1&!A|E1&!E&!D1&D&!C&!B1&!B&!A1&!A|!E1&!E&!D1&D&!C&!B1&!B&!A1&!A|!E1&E&!D1&!D&C&!B1&!B&!A1&!A|E1&!E&!D1&!D&C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&C&B1&!B&!A1&!A|E1&!E&!D1&!D&C&B1&!B&!A1&!A|!E1&E&!D1&!D&C&B1&!B&!A1&!A|!E1&!E&!D1&D&!C&B1&!B&!A1&!A|E1&!E&!D1&D&!C&B1&!B&!A1&!A|!E1&E&!D1&D&!C&B1&!B&!A1&!A|!E1&E&D1&D&!C&B1&!B&!A1&!A|E1&!E&D1&D&!C&B1&!B&!A1&!A|!E1&!E&D1&D&!C&B1&!B&!A1&!A|!E1&!E&D1&!D&!C&B1&!B&!A1&!A|E1&!E&D1&!D&!C&B1&!B&!A1&!A|!E1&E&D1&!D&!C&B1&!B&!A1&!A|!E1&E&!D1&!D&!C&B1&!B&!A1&!A|E1&!E&!D1&!D&!C&B1&!B&!A1&!A|!E1&!E&!D1&!D&!C&B1&!B&!A1&!A|!E1&!E&!D1&!D&!C&B1&B&!A1&!A|E1&!E&!D1&!D&!C&B1&B&!A1&!A|!E1&E&!D1&!D&!C&B1&B&!A1&!A|!E1&E&D1&!D&!C&B1&B&!A1&!A|E1&!E&D1&!D&!C&B1&B&!A1&!A|!E1&!E&D1&!D&!C&B1&B&!A1&!A|!E1&!E&D1&D&!C&B1&B&!A1&!A|E1&!E&D1&D&!C&B1&B&!A1&!A|!E1&E&D1&D&!C&B1&B&!A1&!A|!E1&E&!D1&D&!C&B1&B&!A1&!A|E1&!E&!D1&D&!C&B1&B&!A1&!A|!E1&!E&!D1&D&!C&B1&B&!A1&!A|!E1&E&!D1&!D&C&B1&B&!A1&!A|E1&!E&!D1&!D&C&B1&B&!A1&!A|!E1&!E&!D1&!D&C&B1&B&!A1&!A|!E1&!E&!D1&!D&C&!B1&B&!A1&!A|E1&!E&!D1&!D&C&!B1&B&!A1&!A|!E1&E&!D1&!D&C&!B1&B&!A1&!A|!E1&!E&!D1&D&!C&!B1&B&!A1&!A|E1&!E&!D1&D&!C&!B1&B&!A1&!A|!E1&E&!D1&D&!C&!B1&B&!A1&!A|!E1&E&D1&D&!C&!B1&B&!A1&!A|E1&!E&D1&D&!C&!B1&B&!A1&!A|!E1&!E&D1&D&!C&!B1&B&!A1&!A|!E1&!E&D1&!D&!C&!B1&B&!A1&!A|E1&!E&D1&!D&!C&!B1&B&!A1&!A|!E1&E&D1&!D&!C&!B1&B&!A1&!A|!E1&E&!D1&!D&!C&!B1&B&!A1&!A|E1&!E&!D1&!D&!C&!B1&B&!A1&!A|!E1&!E&!D1&!D&!C&!B1&B&!A1&!A|!E1&!E&!D1&!D&!C&!B1&B&A1&!A|E1&!E&!D1&!D&!C&!B1&B&A1&!A|!E1&E&!D1&!D&!C&!B1&B&A1&!A|!E1&E&!D1&!D&C&!B1&B&A1&!A|E1&!E&!D1&!D&C&!B1&B&A1&!A|!E1&!E&!D1&!D&C&!B1&B&A1&!A|!E1&!E&!D1&!D&C&B1&B&A1&!A|E1&!E&!D1&!D&C&B1&B&A1&!A|!E1&E&!D1&!D&C&B1&B&A1&!A|!E1&E&!D1&!D&!C&B1&B&A1&!A|E1&!E&!D1&!D&!C&B1&B&A1&!A|!E1&!E&!D1&!D&!C&B1&B&A1&!A|!E1&!E&!D1&!D&!C&B1&!B&A1&!A|E1&!E&!D1&!D&!C&B1&!B&A1&!A|!E1&E&!D1&!D&!C&B1&!B&A1&!A|!E1&E&!D1&!D&C&B1&!B&A1&!A|E1&!E&!D1&!D&C&B1&!B&A1&!A|!E1&!E&!D1&!D&C&B1&!B&A1&!A|!E1&!E&!D1&!D&C&!B1&!B&A1&!A|E1&!E&!D1&!D&C&!B1&!B&A1&!A|!E1&E&!D1&!D&C&!B1&!B&A1&!A|!E1&!E&!D1&D&!C&!B1&!B&A1&!A|E1&!E&!D1&D&!C&!B1&!B&A1&!A|!E1&E&!D1&D&!C&!B1&!B&A1&!A|!E1&E&D1&D&!C&!B1&!B&A1&!A|E1&!E&D1&D&!C&!B1&!B&A1&!A|!E1&!E&D1&D&!C&!B1&!B&A1&!A|!E1&!E&D1&!D&!C&!B1&!B&A1&!A|E1&!E&D1&!D&!C&!B1&!B&A1&!A|!E1&E&D1&!D&!C&!B1&!B&A1&!A|!E1&E&!D1&!D&!C&!B1&!B&A1&!A|E1&!E&!D1&!D&!C&!B1&!B&A1&!A|!E1&!E&!D1&!D&!C&!B1&!B&A1&!A|!E1&!E&!D1&!D&!C&!B1&!B&A1&A|E1&!E&!D1&!D&!C&!B1&!B&A1&A|!E1&E&!D1&!D&!C&!B1&!B&A1&A|!E1&E&D1&!D&!C&!B1&!B&A1&A|E1&!E&D1&!D&!C&!B1&!B&A1&A|!E1&!E&D1&!D&!C&!B1&!B&A1&A|!E1&!E&D1&D&!C&!B1&!B&A1&A|E1&!E&D1&D&!C&!B1&!B&A1&A|!E1&E&D1&D&!C&!B1&!B&A1&A|!E1&E&!D1&D&!C&!B1&!B&A1&A|E1&!E&!D1&D&!C&!B1&!B&A1&A|!E1&!E&!D1&D&!C&!B1&!B&A1&A|!E1&E&!D1&!D&C&!B1&!B&A1&A|E1&!E&!D1&!D&C&!B1&!B&A1&A|!E1&!E&!D1&!D&C&!B1&!B&A1&A|!E1&!E&!D1&!D&C&B1&!B&A1&A|E1&!E&!D1&!D&C&B1&!B&A1&A|!E1&E&!D1&!D&C&B1&!B&A1&A|!E1&E&!D1&!D&!C&B1&!B&A1&A|E1&!E&!D1&!D&!C&B1&!B&A1&A|!E1&!E&!D1&!D&!C&B1&!B&A1&A|!E1&!E&!D1&!D&!C&B1&B&A1&A|E1&!E&!D1&!D&!C&B1&B&A1&A|!E1&E&!D1&!D&!C&B1&B&A1&A|!E1&E&!D1&!D&C&B1&B&A1&A|E1&!E&!D1&!D&C&B1&B&A1&A|!E1&!E&!D1&!D&C&B1&B&A1&A|!E1&!E&!D1&!D&C&!B1&B&A1&A|E1&!E&!D1&!D&C&!B1&B&A1&A|!E1&E&!D1&!D&C&!B1&B&A1&A|!E1&E&!D1&!D&!C&!B1&B&A1&A|E1&!E&!D1&!D&!C&!B1&B&A1&A|!E1&!E&!D1&!D&!C&!B1&B&A1&A|!E1&!E&!D1&!D&!C&!B1&B&!A1&A|E1&!E&!D1&!D&!C&!B1&B&!A1&A|!E1&E&!D1&!D&!C&!B1&B&!A1&A|!E1&E&!D1&!D&C&!B1&B&!A1&A|E1&!E&!D1&!D&C&!B1&B&!A1&A|!E1&!E&!D1&!D&C&!B1&B&!A1&A|!E1&!E&!D1&!D&C&B1&B&!A1&A|E1&!E&!D1&!D&C&B1&B&!A1&A|!E1&E&!D1&!D&C&B1&B&!A1&A|!E1&E&!D1&!D&!C&B1&B&!A1&A|E1&!E&!D1&!D&!C&B1&B&!A1&A|!E1&!E&!D1&!D&!C&B1&B&!A1&A|!E1&!E&!D1&!D&!C&B1&!B&!A1&A|E1&!E&!D1&!D&!C&B1&!B&!A1&A|!E1&E&!D1&!D&!C&B1&!B&!A1&A|!E1&E&!D1&!D&C&B1&!B&!A1&A|E1&!E&!D1&!D&C&B1&!B&!A1&A|!E1&!E&!D1&!D&C&B1&!B&!A1&A|!E1&!E&!D1&!D&C&!B1&!B&!A1&A|E1&!E&!D1&!D&C&!B1&!B&!A1&A|!E1&E&!D1&!D&C&!B1&!B&!A1&A|!E1&!E&!D1&D&!C&!B1&!B&!A1&A|E1&!E&!D1&D&!C&!B1&!B&!A1&A|!E1&E&!D1&D&!C&!B1&!B&!A1&A|!E1&E&D1&D&!C&!B1&!B&!A1&A|E1&!E&D1&D&!C&!B1&!B&!A1&A|!E1&!E&D1&D&!C&!B1&!B&!A1&A|!E1&!E&D1&!D&!C&!B1&!B&!A1&A|E1&!E&D1&!D&!C&!B1&!B&!A1&A|!E1&E&D1&!D&!C&!B1&!B&!A1&A|!E1&E&!D1&!D&!C&!B1&!B&!A1&A|E1&!E&!D1&!D&!C&!B1&!B&!A1&A|!E1&!E&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOOAAOI22122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAOI22131 -l AAOOAOI22131 -i E D2 D1 D C B1 B A1 A -o Y -f Y=(!E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!E&D2&!D1&!D&!C&!B1&!B&!A1&!A|!E&D2&D1&!D&!C&!B1&!B&!A1&!A|!E&!D2&D1&!D&!C&!B1&!B&!A1&!A|!E&!D2&D1&D&!C&!B1&!B&!A1&!A|!E&D2&D1&D&!C&!B1&!B&!A1&!A|!E&D2&!D1&D&!C&!B1&!B&!A1&!A|!E&!D2&!D1&D&!C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&C&B1&!B&!A1&!A|!E&!D2&!D1&D&!C&B1&!B&!A1&!A|!E&D2&!D1&D&!C&B1&!B&!A1&!A|!E&D2&D1&D&!C&B1&!B&!A1&!A|!E&!D2&D1&D&!C&B1&!B&!A1&!A|!E&!D2&D1&!D&!C&B1&!B&!A1&!A|!E&D2&D1&!D&!C&B1&!B&!A1&!A|!E&D2&!D1&!D&!C&B1&!B&!A1&!A|!E&!D2&!D1&!D&!C&B1&!B&!A1&!A|!E&!D2&!D1&!D&!C&B1&B&!A1&!A|!E&!D2&!D1&!D&C&B1&B&!A1&!A|!E&!D2&!D1&!D&C&!B1&B&!A1&!A|!E&!D2&!D1&D&!C&!B1&B&!A1&!A|!E&D2&!D1&D&!C&!B1&B&!A1&!A|!E&D2&D1&D&!C&!B1&B&!A1&!A|!E&!D2&D1&D&!C&!B1&B&!A1&!A|!E&!D2&D1&!D&!C&!B1&B&!A1&!A|!E&D2&D1&!D&!C&!B1&B&!A1&!A|!E&D2&!D1&!D&!C&!B1&B&!A1&!A|!E&!D2&!D1&!D&!C&!B1&B&!A1&!A|!E&!D2&!D1&!D&!C&!B1&B&A1&!A|!E&D2&!D1&!D&!C&!B1&B&A1&!A|!E&D2&D1&!D&!C&!B1&B&A1&!A|!E&!D2&D1&!D&!C&!B1&B&A1&!A|!E&!D2&D1&D&!C&!B1&B&A1&!A|!E&D2&D1&D&!C&!B1&B&A1&!A|!E&D2&!D1&D&!C&!B1&B&A1&!A|!E&!D2&!D1&D&!C&!B1&B&A1&!A|!E&!D2&!D1&!D&C&!B1&B&A1&!A|!E&!D2&!D1&!D&C&B1&B&A1&!A|!E&!D2&!D1&!D&!C&B1&B&A1&!A|!E&!D2&!D1&!D&!C&B1&!B&A1&!A|!E&D2&!D1&!D&!C&B1&!B&A1&!A|!E&D2&D1&!D&!C&B1&!B&A1&!A|!E&!D2&D1&!D&!C&B1&!B&A1&!A|!E&!D2&D1&D&!C&B1&!B&A1&!A|!E&D2&D1&D&!C&B1&!B&A1&!A|!E&D2&!D1&D&!C&B1&!B&A1&!A|!E&!D2&!D1&D&!C&B1&!B&A1&!A|!E&!D2&!D1&!D&C&B1&!B&A1&!A|!E&!D2&!D1&!D&C&!B1&!B&A1&!A|!E&!D2&!D1&D&!C&!B1&!B&A1&!A|!E&D2&!D1&D&!C&!B1&!B&A1&!A|!E&D2&D1&D&!C&!B1&!B&A1&!A|!E&!D2&D1&D&!C&!B1&!B&A1&!A|!E&!D2&D1&!D&!C&!B1&!B&A1&!A|!E&D2&D1&!D&!C&!B1&!B&A1&!A|!E&D2&!D1&!D&!C&!B1&!B&A1&!A|!E&!D2&!D1&!D&!C&!B1&!B&A1&!A|!E&!D2&!D1&!D&!C&!B1&!B&A1&A|!E&!D2&!D1&!D&C&!B1&!B&A1&A|!E&!D2&!D1&!D&C&B1&!B&A1&A|!E&!D2&!D1&!D&!C&B1&!B&A1&A|!E&!D2&!D1&!D&!C&B1&B&A1&A|!E&!D2&!D1&!D&C&B1&B&A1&A|!E&!D2&!D1&!D&C&!B1&B&A1&A|!E&!D2&!D1&!D&!C&!B1&B&A1&A|!E&!D2&!D1&!D&!C&!B1&B&!A1&A|!E&D2&!D1&!D&!C&!B1&B&!A1&A|!E&D2&D1&!D&!C&!B1&B&!A1&A|!E&!D2&D1&!D&!C&!B1&B&!A1&A|!E&!D2&D1&D&!C&!B1&B&!A1&A|!E&D2&D1&D&!C&!B1&B&!A1&A|!E&D2&!D1&D&!C&!B1&B&!A1&A|!E&!D2&!D1&D&!C&!B1&B&!A1&A|!E&!D2&!D1&!D&C&!B1&B&!A1&A|!E&!D2&!D1&!D&C&B1&B&!A1&A|!E&!D2&!D1&!D&!C&B1&B&!A1&A|!E&!D2&!D1&!D&!C&B1&!B&!A1&A|!E&D2&!D1&!D&!C&B1&!B&!A1&A|!E&D2&D1&!D&!C&B1&!B&!A1&A|!E&!D2&D1&!D&!C&B1&!B&!A1&A|!E&!D2&D1&D&!C&B1&!B&!A1&A|!E&D2&D1&D&!C&B1&!B&!A1&A|!E&D2&!D1&D&!C&B1&!B&!A1&A|!E&!D2&!D1&D&!C&B1&!B&!A1&A|!E&!D2&!D1&!D&C&B1&!B&!A1&A|!E&!D2&!D1&!D&C&!B1&!B&!A1&A|!E&!D2&!D1&D&!C&!B1&!B&!A1&A|!E&D2&!D1&D&!C&!B1&!B&!A1&A|!E&D2&D1&D&!C&!B1&!B&!A1&A|!E&!D2&D1&D&!C&!B1&!B&!A1&A|!E&!D2&D1&!D&!C&!B1&!B&!A1&A|!E&D2&D1&!D&!C&!B1&!B&!A1&A|!E&D2&!D1&!D&!C&!B1&!B&!A1&A|!E&!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAOI22131.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAOAOI222111 -l AAOOAOAOI222111 -i F E D C1 C B1 B A1 A -o Y -f Y=(!F&!E&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D&C1&!C&!B1&!B&!A1&!A|!F&E&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D&C1&C&!B1&!B&!A1&!A|!F&E&!D&C1&C&!B1&!B&!A1&!A|!F&!E&D&C1&C&!B1&!B&!A1&!A|!F&!E&D&!C1&C&!B1&!B&!A1&!A|!F&E&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D&!C1&C&B1&!B&!A1&!A|!F&E&!D&!C1&C&B1&!B&!A1&!A|!F&!E&D&!C1&C&B1&!B&!A1&!A|!F&!E&D&C1&C&B1&!B&!A1&!A|!F&E&!D&C1&C&B1&!B&!A1&!A|!F&!E&!D&C1&C&B1&!B&!A1&!A|!F&!E&!D&C1&!C&B1&!B&!A1&!A|!F&E&!D&C1&!C&B1&!B&!A1&!A|!F&!E&D&C1&!C&B1&!B&!A1&!A|!F&!E&D&!C1&!C&B1&!B&!A1&!A|!F&E&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D&!C1&!C&B1&B&!A1&!A|!F&E&!D&!C1&!C&B1&B&!A1&!A|!F&!E&D&!C1&!C&B1&B&!A1&!A|!F&!E&D&C1&!C&B1&B&!A1&!A|!F&!E&!D&C1&!C&B1&B&!A1&!A|!F&!E&!D&C1&C&B1&B&!A1&!A|!F&!E&D&C1&C&B1&B&!A1&!A|!F&!E&D&!C1&C&B1&B&!A1&!A|!F&!E&!D&!C1&C&B1&B&!A1&!A|!F&!E&!D&!C1&C&!B1&B&!A1&!A|!F&E&!D&!C1&C&!B1&B&!A1&!A|!F&!E&D&!C1&C&!B1&B&!A1&!A|!F&!E&D&C1&C&!B1&B&!A1&!A|!F&E&!D&C1&C&!B1&B&!A1&!A|!F&!E&!D&C1&C&!B1&B&!A1&!A|!F&!E&!D&C1&!C&!B1&B&!A1&!A|!F&E&!D&C1&!C&!B1&B&!A1&!A|!F&!E&D&C1&!C&!B1&B&!A1&!A|!F&!E&D&!C1&!C&!B1&B&!A1&!A|!F&E&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D&!C1&!C&!B1&B&A1&!A|!F&E&!D&!C1&!C&!B1&B&A1&!A|!F&!E&D&!C1&!C&!B1&B&A1&!A|!F&!E&D&C1&!C&!B1&B&A1&!A|!F&E&!D&C1&!C&!B1&B&A1&!A|!F&!E&!D&C1&!C&!B1&B&A1&!A|!F&!E&!D&C1&C&!B1&B&A1&!A|!F&E&!D&C1&C&!B1&B&A1&!A|!F&!E&D&C1&C&!B1&B&A1&!A|!F&!E&D&!C1&C&!B1&B&A1&!A|!F&E&!D&!C1&C&!B1&B&A1&!A|!F&!E&!D&!C1&C&!B1&B&A1&!A|!F&!E&!D&!C1&C&B1&B&A1&!A|!F&!E&D&!C1&C&B1&B&A1&!A|!F&!E&D&C1&C&B1&B&A1&!A|!F&!E&!D&C1&C&B1&B&A1&!A|!F&!E&!D&C1&!C&B1&B&A1&!A|!F&!E&D&C1&!C&B1&B&A1&!A|!F&!E&D&!C1&!C&B1&B&A1&!A|!F&E&!D&!C1&!C&B1&B&A1&!A|!F&!E&!D&!C1&!C&B1&B&A1&!A|!F&!E&!D&!C1&!C&B1&!B&A1&!A|!F&E&!D&!C1&!C&B1&!B&A1&!A|!F&!E&D&!C1&!C&B1&!B&A1&!A|!F&!E&D&C1&!C&B1&!B&A1&!A|!F&E&!D&C1&!C&B1&!B&A1&!A|!F&!E&!D&C1&!C&B1&!B&A1&!A|!F&!E&!D&C1&C&B1&!B&A1&!A|!F&E&!D&C1&C&B1&!B&A1&!A|!F&!E&D&C1&C&B1&!B&A1&!A|!F&!E&D&!C1&C&B1&!B&A1&!A|!F&E&!D&!C1&C&B1&!B&A1&!A|!F&!E&!D&!C1&C&B1&!B&A1&!A|!F&!E&!D&!C1&C&!B1&!B&A1&!A|!F&E&!D&!C1&C&!B1&!B&A1&!A|!F&!E&D&!C1&C&!B1&!B&A1&!A|!F&!E&D&C1&C&!B1&!B&A1&!A|!F&E&!D&C1&C&!B1&!B&A1&!A|!F&!E&!D&C1&C&!B1&!B&A1&!A|!F&!E&!D&C1&!C&!B1&!B&A1&!A|!F&E&!D&C1&!C&!B1&!B&A1&!A|!F&!E&D&C1&!C&!B1&!B&A1&!A|!F&!E&D&!C1&!C&!B1&!B&A1&!A|!F&E&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D&!C1&!C&!B1&!B&A1&A|!F&E&!D&!C1&!C&!B1&!B&A1&A|!F&!E&D&!C1&!C&!B1&!B&A1&A|!F&!E&D&C1&!C&!B1&!B&A1&A|!F&!E&!D&C1&!C&!B1&!B&A1&A|!F&!E&!D&C1&C&!B1&!B&A1&A|!F&!E&D&C1&C&!B1&!B&A1&A|!F&!E&D&!C1&C&!B1&!B&A1&A|!F&!E&!D&!C1&C&!B1&!B&A1&A|!F&!E&!D&!C1&C&B1&!B&A1&A|!F&!E&D&!C1&C&B1&!B&A1&A|!F&!E&D&C1&C&B1&!B&A1&A|!F&!E&!D&C1&C&B1&!B&A1&A|!F&!E&!D&C1&!C&B1&!B&A1&A|!F&!E&D&C1&!C&B1&!B&A1&A|!F&!E&D&!C1&!C&B1&!B&A1&A|!F&E&!D&!C1&!C&B1&!B&A1&A|!F&!E&!D&!C1&!C&B1&!B&A1&A|!F&!E&!D&!C1&!C&B1&B&A1&A|!F&E&!D&!C1&!C&B1&B&A1&A|!F&!E&D&!C1&!C&B1&B&A1&A|!F&!E&D&C1&!C&B1&B&A1&A|!F&!E&!D&C1&!C&B1&B&A1&A|!F&!E&!D&C1&C&B1&B&A1&A|!F&!E&D&C1&C&B1&B&A1&A|!F&!E&D&!C1&C&B1&B&A1&A|!F&!E&!D&!C1&C&B1&B&A1&A|!F&!E&!D&!C1&C&!B1&B&A1&A|!F&!E&D&!C1&C&!B1&B&A1&A|!F&!E&D&C1&C&!B1&B&A1&A|!F&!E&!D&C1&C&!B1&B&A1&A|!F&!E&!D&C1&!C&!B1&B&A1&A|!F&!E&D&C1&!C&!B1&B&A1&A|!F&!E&D&!C1&!C&!B1&B&A1&A|!F&E&!D&!C1&!C&!B1&B&A1&A|!F&!E&!D&!C1&!C&!B1&B&A1&A|!F&!E&!D&!C1&!C&!B1&B&!A1&A|!F&E&!D&!C1&!C&!B1&B&!A1&A|!F&!E&D&!C1&!C&!B1&B&!A1&A|!F&!E&D&C1&!C&!B1&B&!A1&A|!F&E&!D&C1&!C&!B1&B&!A1&A|!F&!E&!D&C1&!C&!B1&B&!A1&A|!F&!E&!D&C1&C&!B1&B&!A1&A|!F&E&!D&C1&C&!B1&B&!A1&A|!F&!E&D&C1&C&!B1&B&!A1&A|!F&!E&D&!C1&C&!B1&B&!A1&A|!F&E&!D&!C1&C&!B1&B&!A1&A|!F&!E&!D&!C1&C&!B1&B&!A1&A|!F&!E&!D&!C1&C&B1&B&!A1&A|!F&!E&D&!C1&C&B1&B&!A1&A|!F&!E&D&C1&C&B1&B&!A1&A|!F&!E&!D&C1&C&B1&B&!A1&A|!F&!E&!D&C1&!C&B1&B&!A1&A|!F&!E&D&C1&!C&B1&B&!A1&A|!F&!E&D&!C1&!C&B1&B&!A1&A|!F&E&!D&!C1&!C&B1&B&!A1&A|!F&!E&!D&!C1&!C&B1&B&!A1&A|!F&!E&!D&!C1&!C&B1&!B&!A1&A|!F&E&!D&!C1&!C&B1&!B&!A1&A|!F&!E&D&!C1&!C&B1&!B&!A1&A|!F&!E&D&C1&!C&B1&!B&!A1&A|!F&E&!D&C1&!C&B1&!B&!A1&A|!F&!E&!D&C1&!C&B1&!B&!A1&A|!F&!E&!D&C1&C&B1&!B&!A1&A|!F&E&!D&C1&C&B1&!B&!A1&A|!F&!E&D&C1&C&B1&!B&!A1&A|!F&!E&D&!C1&C&B1&!B&!A1&A|!F&E&!D&!C1&C&B1&!B&!A1&A|!F&!E&!D&!C1&C&B1&!B&!A1&A|!F&!E&!D&!C1&C&!B1&!B&!A1&A|!F&E&!D&!C1&C&!B1&!B&!A1&A|!F&!E&D&!C1&C&!B1&!B&!A1&A|!F&!E&D&C1&C&!B1&!B&!A1&A|!F&E&!D&C1&C&!B1&!B&!A1&A|!F&!E&!D&C1&C&!B1&!B&!A1&A|!F&!E&!D&C1&!C&!B1&!B&!A1&A|!F&E&!D&C1&!C&!B1&!B&!A1&A|!F&!E&D&C1&!C&!B1&!B&!A1&A|!F&!E&D&!C1&!C&!B1&!B&!A1&A|!F&E&!D&!C1&!C&!B1&!B&!A1&A|!F&!E&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAOAOI222111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOI2241 -l OOAAOI2241 -i D C3 C2 C1 C B1 B A1 A -o Y -f Y=(!D&!C3&!C2&!C1&!C&!B1&!B&!A1&!A|!D&C3&!C2&!C1&!C&!B1&!B&!A1&!A|!D&C3&C2&!C1&!C&!B1&!B&!A1&!A|!D&!C3&C2&!C1&!C&!B1&!B&!A1&!A|!D&!C3&C2&C1&!C&!B1&!B&!A1&!A|!D&C3&C2&C1&!C&!B1&!B&!A1&!A|!D&C3&!C2&C1&!C&!B1&!B&!A1&!A|!D&!C3&!C2&C1&!C&!B1&!B&!A1&!A|!D&!C3&!C2&C1&C&!B1&!B&!A1&!A|!D&C3&!C2&C1&C&!B1&!B&!A1&!A|!D&!C3&C2&C1&C&!B1&!B&!A1&!A|!D&!C3&C2&!C1&C&!B1&!B&!A1&!A|!D&C3&C2&!C1&C&!B1&!B&!A1&!A|!D&C3&!C2&!C1&C&!B1&!B&!A1&!A|!D&!C3&!C2&!C1&C&!B1&!B&!A1&!A|!D&!C3&!C2&!C1&C&B1&!B&!A1&!A|!D&C3&!C2&!C1&C&B1&!B&!A1&!A|!D&C3&C2&!C1&C&B1&!B&!A1&!A|!D&!C3&C2&!C1&C&B1&!B&!A1&!A|!D&!C3&C2&C1&C&B1&!B&!A1&!A|!D&C3&!C2&C1&C&B1&!B&!A1&!A|!D&!C3&!C2&C1&C&B1&!B&!A1&!A|!D&!C3&!C2&C1&!C&B1&!B&!A1&!A|!D&C3&!C2&C1&!C&B1&!B&!A1&!A|!D&C3&C2&C1&!C&B1&!B&!A1&!A|!D&!C3&C2&C1&!C&B1&!B&!A1&!A|!D&!C3&C2&!C1&!C&B1&!B&!A1&!A|!D&C3&C2&!C1&!C&B1&!B&!A1&!A|!D&C3&!C2&!C1&!C&B1&!B&!A1&!A|!D&!C3&!C2&!C1&!C&B1&!B&!A1&!A|!D&!C3&!C2&!C1&!C&B1&B&!A1&!A|!D&C3&!C2&!C1&!C&B1&B&!A1&!A|!D&C3&C2&!C1&!C&B1&B&!A1&!A|!D&!C3&C2&!C1&!C&B1&B&!A1&!A|!D&!C3&C2&C1&!C&B1&B&!A1&!A|!D&C3&C2&C1&!C&B1&B&!A1&!A|!D&C3&!C2&C1&!C&B1&B&!A1&!A|!D&!C3&!C2&C1&!C&B1&B&!A1&!A|!D&!C3&!C2&C1&C&B1&B&!A1&!A|!D&C3&!C2&C1&C&B1&B&!A1&!A|!D&!C3&C2&C1&C&B1&B&!A1&!A|!D&!C3&C2&!C1&C&B1&B&!A1&!A|!D&C3&C2&!C1&C&B1&B&!A1&!A|!D&C3&!C2&!C1&C&B1&B&!A1&!A|!D&!C3&!C2&!C1&C&B1&B&!A1&!A|!D&!C3&!C2&!C1&C&!B1&B&!A1&!A|!D&C3&!C2&!C1&C&!B1&B&!A1&!A|!D&C3&C2&!C1&C&!B1&B&!A1&!A|!D&!C3&C2&!C1&C&!B1&B&!A1&!A|!D&!C3&C2&C1&C&!B1&B&!A1&!A|!D&C3&!C2&C1&C&!B1&B&!A1&!A|!D&!C3&!C2&C1&C&!B1&B&!A1&!A|!D&!C3&!C2&C1&!C&!B1&B&!A1&!A|!D&C3&!C2&C1&!C&!B1&B&!A1&!A|!D&C3&C2&C1&!C&!B1&B&!A1&!A|!D&!C3&C2&C1&!C&!B1&B&!A1&!A|!D&!C3&C2&!C1&!C&!B1&B&!A1&!A|!D&C3&C2&!C1&!C&!B1&B&!A1&!A|!D&C3&!C2&!C1&!C&!B1&B&!A1&!A|!D&!C3&!C2&!C1&!C&!B1&B&!A1&!A|!D&!C3&!C2&!C1&C&!B1&!B&A1&!A|!D&C3&!C2&!C1&C&!B1&!B&A1&!A|!D&C3&C2&!C1&C&!B1&!B&A1&!A|!D&!C3&C2&!C1&C&!B1&!B&A1&!A|!D&!C3&C2&C1&C&!B1&!B&A1&!A|!D&C3&!C2&C1&C&!B1&!B&A1&!A|!D&!C3&!C2&C1&C&!B1&!B&A1&!A|!D&!C3&!C2&C1&!C&!B1&!B&A1&!A|!D&C3&!C2&C1&!C&!B1&!B&A1&!A|!D&C3&C2&C1&!C&!B1&!B&A1&!A|!D&!C3&C2&C1&!C&!B1&!B&A1&!A|!D&!C3&C2&!C1&!C&!B1&!B&A1&!A|!D&C3&C2&!C1&!C&!B1&!B&A1&!A|!D&C3&!C2&!C1&!C&!B1&!B&A1&!A|!D&!C3&!C2&!C1&!C&!B1&!B&A1&!A|!D&!C3&!C2&!C1&!C&!B1&!B&A1&A|!D&C3&!C2&!C1&!C&!B1&!B&A1&A|!D&C3&C2&!C1&!C&!B1&!B&A1&A|!D&!C3&C2&!C1&!C&!B1&!B&A1&A|!D&!C3&C2&C1&!C&!B1&!B&A1&A|!D&C3&C2&C1&!C&!B1&!B&A1&A|!D&C3&!C2&C1&!C&!B1&!B&A1&A|!D&!C3&!C2&C1&!C&!B1&!B&A1&A|!D&!C3&!C2&C1&C&!B1&!B&A1&A|!D&C3&!C2&C1&C&!B1&!B&A1&A|!D&!C3&C2&C1&C&!B1&!B&A1&A|!D&!C3&C2&!C1&C&!B1&!B&A1&A|!D&C3&C2&!C1&C&!B1&!B&A1&A|!D&C3&!C2&!C1&C&!B1&!B&A1&A|!D&!C3&!C2&!C1&C&!B1&!B&A1&A|!D&!C3&!C2&!C1&C&!B1&!B&!A1&A|!D&C3&!C2&!C1&C&!B1&!B&!A1&A|!D&C3&C2&!C1&C&!B1&!B&!A1&A|!D&!C3&C2&!C1&C&!B1&!B&!A1&A|!D&!C3&C2&C1&C&!B1&!B&!A1&A|!D&C3&!C2&C1&C&!B1&!B&!A1&A|!D&!C3&!C2&C1&C&!B1&!B&!A1&A|!D&!C3&!C2&C1&!C&!B1&!B&!A1&A|!D&C3&!C2&C1&!C&!B1&!B&!A1&A|!D&C3&C2&C1&!C&!B1&!B&!A1&A|!D&!C3&C2&C1&!C&!B1&!B&!A1&A|!D&!C3&C2&!C1&!C&!B1&!B&!A1&A|!D&C3&C2&!C1&!C&!B1&!B&!A1&A|!D&C3&!C2&!C1&!C&!B1&!B&!A1&A|!D&!C3&!C2&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOI2241.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOI3221 -l AAAOI3221 -i D C1 C B1 B A2 A1 A -o Y -f Y=(!D&!C1&!C&!B1&!B&!A2&!A1&!A|!D&C1&!C&!B1&!B&!A2&!A1&!A|!D&!C1&C&!B1&!B&!A2&!A1&!A|!D&!C1&C&B1&!B&!A2&!A1&!A|!D&C1&!C&B1&!B&!A2&!A1&!A|!D&!C1&!C&B1&!B&!A2&!A1&!A|!D&!C1&C&!B1&B&!A2&!A1&!A|!D&C1&!C&!B1&B&!A2&!A1&!A|!D&!C1&!C&!B1&B&!A2&!A1&!A|!D&!C1&!C&!B1&B&A2&!A1&!A|!D&C1&!C&!B1&B&A2&!A1&!A|!D&!C1&C&!B1&B&A2&!A1&!A|!D&!C1&!C&B1&!B&A2&!A1&!A|!D&C1&!C&B1&!B&A2&!A1&!A|!D&!C1&C&B1&!B&A2&!A1&!A|!D&!C1&C&!B1&!B&A2&!A1&!A|!D&C1&!C&!B1&!B&A2&!A1&!A|!D&!C1&!C&!B1&!B&A2&!A1&!A|!D&!C1&!C&!B1&!B&A2&A1&!A|!D&C1&!C&!B1&!B&A2&A1&!A|!D&!C1&C&!B1&!B&A2&A1&!A|!D&!C1&C&B1&!B&A2&A1&!A|!D&C1&!C&B1&!B&A2&A1&!A|!D&!C1&!C&B1&!B&A2&A1&!A|!D&!C1&C&!B1&B&A2&A1&!A|!D&C1&!C&!B1&B&A2&A1&!A|!D&!C1&!C&!B1&B&A2&A1&!A|!D&!C1&!C&!B1&B&!A2&A1&!A|!D&C1&!C&!B1&B&!A2&A1&!A|!D&!C1&C&!B1&B&!A2&A1&!A|!D&!C1&!C&B1&!B&!A2&A1&!A|!D&C1&!C&B1&!B&!A2&A1&!A|!D&!C1&C&B1&!B&!A2&A1&!A|!D&!C1&C&!B1&!B&!A2&A1&!A|!D&C1&!C&!B1&!B&!A2&A1&!A|!D&!C1&!C&!B1&!B&!A2&A1&!A|!D&!C1&!C&!B1&!B&!A2&A1&A|!D&C1&!C&!B1&!B&!A2&A1&A|!D&!C1&C&!B1&!B&!A2&A1&A|!D&!C1&C&B1&!B&!A2&A1&A|!D&C1&!C&B1&!B&!A2&A1&A|!D&!C1&!C&B1&!B&!A2&A1&A|!D&!C1&C&!B1&B&!A2&A1&A|!D&C1&!C&!B1&B&!A2&A1&A|!D&!C1&!C&!B1&B&!A2&A1&A|!D&!C1&!C&!B1&!B&A2&!A1&A|!D&C1&!C&!B1&!B&A2&!A1&A|!D&!C1&C&!B1&!B&A2&!A1&A|!D&!C1&C&B1&!B&A2&!A1&A|!D&C1&!C&B1&!B&A2&!A1&A|!D&!C1&!C&B1&!B&A2&!A1&A|!D&!C1&C&!B1&B&A2&!A1&A|!D&C1&!C&!B1&B&A2&!A1&A|!D&!C1&!C&!B1&B&A2&!A1&A|!D&!C1&!C&!B1&B&!A2&!A1&A|!D&C1&!C&!B1&B&!A2&!A1&A|!D&!C1&C&!B1&B&!A2&!A1&A|!D&!C1&!C&B1&!B&!A2&!A1&A|!D&C1&!C&B1&!B&!A2&!A1&A|!D&!C1&C&B1&!B&!A2&!A1&A|!D&!C1&C&!B1&!B&!A2&!A1&A|!D&C1&!C&!B1&!B&!A2&!A1&A|!D&!C1&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOI3221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAOOAI22122 -l AAOAOOAI22122 -i E1 E D1 D C B1 B A1 A -o Y -f Y=(!E1&!E&!D1&!D&!C&!B1&!B&!A1&!A|E1&!E&!D1&!D&!C&!B1&!B&!A1&!A|E1&E&!D1&!D&!C&!B1&!B&!A1&!A|!E1&E&!D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&D1&D&!C&!B1&!B&!A1&!A|!E1&!E&!D1&D&!C&!B1&!B&!A1&!A|!E1&!E&!D1&D&C&!B1&!B&!A1&!A|!E1&!E&D1&D&C&!B1&!B&!A1&!A|!E1&!E&D1&!D&C&!B1&!B&!A1&!A|!E1&E&!D1&!D&C&!B1&!B&!A1&!A|E1&E&!D1&!D&C&!B1&!B&!A1&!A|E1&!E&!D1&!D&C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&C&B1&!B&!A1&!A|E1&!E&!D1&!D&C&B1&!B&!A1&!A|E1&E&!D1&!D&C&B1&!B&!A1&!A|!E1&E&!D1&!D&C&B1&!B&!A1&!A|!E1&!E&D1&!D&C&B1&!B&!A1&!A|!E1&!E&D1&D&C&B1&!B&!A1&!A|!E1&!E&!D1&D&C&B1&!B&!A1&!A|!E1&!E&!D1&D&!C&B1&!B&!A1&!A|!E1&!E&D1&D&!C&B1&!B&!A1&!A|!E1&!E&D1&!D&!C&B1&!B&!A1&!A|!E1&E&!D1&!D&!C&B1&!B&!A1&!A|E1&E&!D1&!D&!C&B1&!B&!A1&!A|E1&!E&!D1&!D&!C&B1&!B&!A1&!A|!E1&!E&!D1&!D&!C&B1&!B&!A1&!A|!E1&!E&!D1&!D&!C&B1&B&!A1&!A|E1&!E&!D1&!D&!C&B1&B&!A1&!A|E1&E&!D1&!D&!C&B1&B&!A1&!A|!E1&E&!D1&!D&!C&B1&B&!A1&!A|!E1&!E&D1&!D&!C&B1&B&!A1&!A|!E1&!E&D1&D&!C&B1&B&!A1&!A|!E1&!E&!D1&D&!C&B1&B&!A1&!A|!E1&!E&!D1&D&C&B1&B&!A1&!A|!E1&!E&D1&D&C&B1&B&!A1&!A|!E1&!E&D1&!D&C&B1&B&!A1&!A|!E1&!E&!D1&!D&C&B1&B&!A1&!A|!E1&!E&!D1&!D&C&!B1&B&!A1&!A|E1&!E&!D1&!D&C&!B1&B&!A1&!A|E1&E&!D1&!D&C&!B1&B&!A1&!A|!E1&E&!D1&!D&C&!B1&B&!A1&!A|!E1&!E&D1&!D&C&!B1&B&!A1&!A|!E1&!E&D1&D&C&!B1&B&!A1&!A|!E1&!E&!D1&D&C&!B1&B&!A1&!A|!E1&!E&!D1&D&!C&!B1&B&!A1&!A|!E1&!E&D1&D&!C&!B1&B&!A1&!A|!E1&!E&D1&!D&!C&!B1&B&!A1&!A|!E1&E&!D1&!D&!C&!B1&B&!A1&!A|E1&E&!D1&!D&!C&!B1&B&!A1&!A|E1&!E&!D1&!D&!C&!B1&B&!A1&!A|!E1&!E&!D1&!D&!C&!B1&B&!A1&!A|!E1&!E&!D1&!D&!C&!B1&B&A1&!A|E1&!E&!D1&!D&!C&!B1&B&A1&!A|E1&E&!D1&!D&!C&!B1&B&A1&!A|!E1&E&!D1&!D&!C&!B1&B&A1&!A|!E1&!E&D1&!D&!C&!B1&B&A1&!A|!E1&!E&D1&D&!C&!B1&B&A1&!A|!E1&!E&!D1&D&!C&!B1&B&A1&!A|!E1&!E&!D1&D&C&!B1&B&A1&!A|!E1&!E&D1&D&C&!B1&B&A1&!A|!E1&!E&D1&!D&C&!B1&B&A1&!A|!E1&E&!D1&!D&C&!B1&B&A1&!A|E1&E&!D1&!D&C&!B1&B&A1&!A|E1&!E&!D1&!D&C&!B1&B&A1&!A|!E1&!E&!D1&!D&C&!B1&B&A1&!A|!E1&!E&!D1&!D&C&B1&B&A1&!A|!E1&!E&D1&!D&C&B1&B&A1&!A|!E1&!E&D1&D&C&B1&B&A1&!A|!E1&!E&!D1&D&C&B1&B&A1&!A|!E1&!E&!D1&D&!C&B1&B&A1&!A|!E1&!E&D1&D&!C&B1&B&A1&!A|!E1&!E&D1&!D&!C&B1&B&A1&!A|!E1&E&!D1&!D&!C&B1&B&A1&!A|E1&E&!D1&!D&!C&B1&B&A1&!A|E1&!E&!D1&!D&!C&B1&B&A1&!A|!E1&!E&!D1&!D&!C&B1&B&A1&!A|!E1&!E&!D1&!D&!C&B1&!B&A1&!A|E1&!E&!D1&!D&!C&B1&!B&A1&!A|E1&E&!D1&!D&!C&B1&!B&A1&!A|!E1&E&!D1&!D&!C&B1&!B&A1&!A|!E1&!E&D1&!D&!C&B1&!B&A1&!A|!E1&!E&D1&D&!C&B1&!B&A1&!A|!E1&!E&!D1&D&!C&B1&!B&A1&!A|!E1&!E&!D1&D&C&B1&!B&A1&!A|!E1&!E&D1&D&C&B1&!B&A1&!A|!E1&!E&D1&!D&C&B1&!B&A1&!A|!E1&E&!D1&!D&C&B1&!B&A1&!A|E1&E&!D1&!D&C&B1&!B&A1&!A|E1&!E&!D1&!D&C&B1&!B&A1&!A|!E1&!E&!D1&!D&C&B1&!B&A1&!A|!E1&!E&!D1&!D&C&!B1&!B&A1&!A|E1&!E&!D1&!D&C&!B1&!B&A1&!A|E1&E&!D1&!D&C&!B1&!B&A1&!A|!E1&E&!D1&!D&C&!B1&!B&A1&!A|!E1&!E&D1&!D&C&!B1&!B&A1&!A|!E1&!E&D1&D&C&!B1&!B&A1&!A|!E1&!E&!D1&D&C&!B1&!B&A1&!A|!E1&!E&!D1&D&!C&!B1&!B&A1&!A|!E1&!E&D1&D&!C&!B1&!B&A1&!A|!E1&!E&D1&!D&!C&!B1&!B&A1&!A|!E1&E&!D1&!D&!C&!B1&!B&A1&!A|E1&E&!D1&!D&!C&!B1&!B&A1&!A|E1&!E&!D1&!D&!C&!B1&!B&A1&!A|!E1&!E&!D1&!D&!C&!B1&!B&A1&!A|!E1&!E&!D1&!D&!C&!B1&!B&A1&A|E1&!E&!D1&!D&!C&!B1&!B&A1&A|E1&E&!D1&!D&!C&!B1&!B&A1&A|!E1&E&!D1&!D&!C&!B1&!B&A1&A|!E1&!E&D1&!D&!C&!B1&!B&A1&A|!E1&!E&D1&D&!C&!B1&!B&A1&A|!E1&!E&!D1&D&!C&!B1&!B&A1&A|!E1&!E&!D1&D&C&!B1&!B&A1&A|!E1&!E&D1&D&C&!B1&!B&A1&A|!E1&!E&D1&!D&C&!B1&!B&A1&A|!E1&!E&!D1&!D&C&!B1&!B&A1&A|!E1&!E&!D1&!D&C&B1&!B&A1&A|!E1&!E&D1&!D&C&B1&!B&A1&A|!E1&!E&D1&D&C&B1&!B&A1&A|!E1&!E&!D1&D&C&B1&!B&A1&A|!E1&!E&!D1&D&!C&B1&!B&A1&A|!E1&!E&D1&D&!C&B1&!B&A1&A|!E1&!E&D1&!D&!C&B1&!B&A1&A|!E1&E&!D1&!D&!C&B1&!B&A1&A|E1&E&!D1&!D&!C&B1&!B&A1&A|E1&!E&!D1&!D&!C&B1&!B&A1&A|!E1&!E&!D1&!D&!C&B1&!B&A1&A|!E1&!E&!D1&!D&!C&B1&B&A1&A|E1&!E&!D1&!D&!C&B1&B&A1&A|E1&E&!D1&!D&!C&B1&B&A1&A|!E1&E&!D1&!D&!C&B1&B&A1&A|!E1&!E&D1&!D&!C&B1&B&A1&A|!E1&!E&D1&D&!C&B1&B&A1&A|!E1&!E&!D1&D&!C&B1&B&A1&A|!E1&!E&!D1&D&C&B1&B&A1&A|!E1&!E&D1&D&C&B1&B&A1&A|!E1&!E&D1&!D&C&B1&B&A1&A|!E1&!E&!D1&!D&C&B1&B&A1&A|!E1&!E&!D1&!D&C&!B1&B&A1&A|!E1&!E&D1&!D&C&!B1&B&A1&A|!E1&!E&D1&D&C&!B1&B&A1&A|!E1&!E&!D1&D&C&!B1&B&A1&A|!E1&!E&!D1&D&!C&!B1&B&A1&A|!E1&!E&D1&D&!C&!B1&B&A1&A|!E1&!E&D1&!D&!C&!B1&B&A1&A|!E1&E&!D1&!D&!C&!B1&B&A1&A|E1&E&!D1&!D&!C&!B1&B&A1&A|E1&!E&!D1&!D&!C&!B1&B&A1&A|!E1&!E&!D1&!D&!C&!B1&B&A1&A|!E1&!E&!D1&!D&!C&!B1&B&!A1&A|E1&!E&!D1&!D&!C&!B1&B&!A1&A|E1&E&!D1&!D&!C&!B1&B&!A1&A|!E1&E&!D1&!D&!C&!B1&B&!A1&A|!E1&!E&D1&!D&!C&!B1&B&!A1&A|!E1&!E&D1&D&!C&!B1&B&!A1&A|!E1&!E&!D1&D&!C&!B1&B&!A1&A|!E1&!E&!D1&D&C&!B1&B&!A1&A|!E1&!E&D1&D&C&!B1&B&!A1&A|!E1&!E&D1&!D&C&!B1&B&!A1&A|!E1&E&!D1&!D&C&!B1&B&!A1&A|E1&E&!D1&!D&C&!B1&B&!A1&A|E1&!E&!D1&!D&C&!B1&B&!A1&A|!E1&!E&!D1&!D&C&!B1&B&!A1&A|!E1&!E&!D1&!D&C&B1&B&!A1&A|!E1&!E&D1&!D&C&B1&B&!A1&A|!E1&!E&D1&D&C&B1&B&!A1&A|!E1&!E&!D1&D&C&B1&B&!A1&A|!E1&!E&!D1&D&!C&B1&B&!A1&A|!E1&!E&D1&D&!C&B1&B&!A1&A|!E1&!E&D1&!D&!C&B1&B&!A1&A|!E1&E&!D1&!D&!C&B1&B&!A1&A|E1&E&!D1&!D&!C&B1&B&!A1&A|E1&!E&!D1&!D&!C&B1&B&!A1&A|!E1&!E&!D1&!D&!C&B1&B&!A1&A|!E1&!E&!D1&!D&!C&B1&!B&!A1&A|E1&!E&!D1&!D&!C&B1&!B&!A1&A|E1&E&!D1&!D&!C&B1&!B&!A1&A|!E1&E&!D1&!D&!C&B1&!B&!A1&A|!E1&!E&D1&!D&!C&B1&!B&!A1&A|!E1&!E&D1&D&!C&B1&!B&!A1&A|!E1&!E&!D1&D&!C&B1&!B&!A1&A|!E1&!E&!D1&D&C&B1&!B&!A1&A|!E1&!E&D1&D&C&B1&!B&!A1&A|!E1&!E&D1&!D&C&B1&!B&!A1&A|!E1&E&!D1&!D&C&B1&!B&!A1&A|E1&E&!D1&!D&C&B1&!B&!A1&A|E1&!E&!D1&!D&C&B1&!B&!A1&A|!E1&!E&!D1&!D&C&B1&!B&!A1&A|!E1&!E&!D1&!D&C&!B1&!B&!A1&A|E1&!E&!D1&!D&C&!B1&!B&!A1&A|E1&E&!D1&!D&C&!B1&!B&!A1&A|!E1&E&!D1&!D&C&!B1&!B&!A1&A|!E1&!E&D1&!D&C&!B1&!B&!A1&A|!E1&!E&D1&D&C&!B1&!B&!A1&A|!E1&!E&!D1&D&C&!B1&!B&!A1&A|!E1&!E&!D1&D&!C&!B1&!B&!A1&A|!E1&!E&D1&D&!C&!B1&!B&!A1&A|!E1&!E&D1&!D&!C&!B1&!B&!A1&A|!E1&E&!D1&!D&!C&!B1&!B&!A1&A|E1&E&!D1&!D&!C&!B1&!B&!A1&A|E1&!E&!D1&!D&!C&!B1&!B&!A1&A|!E1&!E&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAOOAI22122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOAI21221 -l AOOAOAI21221 -i E D1 D C1 C B A1 A -o Y -f Y=!(E&D1&!D&!C1&!C&!B&!A1&!A|E&D1&D&!C1&!C&!B&!A1&!A|E&!D1&D&!C1&!C&!B&!A1&!A|E&!D1&D&C1&!C&!B&!A1&!A|E&D1&D&C1&!C&!B&!A1&!A|E&D1&!D&C1&!C&!B&!A1&!A|E&D1&!D&C1&C&!B&!A1&!A|E&D1&D&C1&C&!B&!A1&!A|E&!D1&D&C1&C&!B&!A1&!A|E&!D1&D&!C1&C&!B&!A1&!A|E&D1&D&!C1&C&!B&!A1&!A|E&D1&!D&!C1&C&!B&!A1&!A|E&!D1&!D&!C1&C&B&!A1&!A|E&D1&!D&!C1&C&B&!A1&!A|E&D1&D&!C1&C&B&!A1&!A|E&!D1&D&!C1&C&B&!A1&!A|E&!D1&D&C1&C&B&!A1&!A|E&D1&D&C1&C&B&!A1&!A|E&D1&!D&C1&C&B&!A1&!A|E&!D1&!D&C1&C&B&!A1&!A|E&!D1&!D&C1&!C&B&!A1&!A|E&D1&!D&C1&!C&B&!A1&!A|E&D1&D&C1&!C&B&!A1&!A|E&!D1&D&C1&!C&B&!A1&!A|E&!D1&D&!C1&!C&B&!A1&!A|E&D1&D&!C1&!C&B&!A1&!A|E&D1&!D&!C1&!C&B&!A1&!A|E&D1&!D&!C1&!C&B&A1&!A|E&D1&D&!C1&!C&B&A1&!A|E&!D1&D&!C1&!C&B&A1&!A|E&!D1&D&C1&!C&B&A1&!A|E&D1&D&C1&!C&B&A1&!A|E&D1&!D&C1&!C&B&A1&!A|E&!D1&!D&C1&!C&B&A1&!A|E&!D1&!D&C1&C&B&A1&!A|E&D1&!D&C1&C&B&A1&!A|E&D1&D&C1&C&B&A1&!A|E&!D1&D&C1&C&B&A1&!A|E&!D1&D&!C1&C&B&A1&!A|E&D1&D&!C1&C&B&A1&!A|E&D1&!D&!C1&C&B&A1&!A|E&!D1&!D&!C1&C&B&A1&!A|E&D1&!D&!C1&C&!B&A1&!A|E&D1&D&!C1&C&!B&A1&!A|E&!D1&D&!C1&C&!B&A1&!A|E&!D1&D&C1&C&!B&A1&!A|E&D1&D&C1&C&!B&A1&!A|E&D1&!D&C1&C&!B&A1&!A|E&D1&!D&C1&!C&!B&A1&!A|E&D1&D&C1&!C&!B&A1&!A|E&!D1&D&C1&!C&!B&A1&!A|E&!D1&D&!C1&!C&!B&A1&!A|E&D1&D&!C1&!C&!B&A1&!A|E&D1&!D&!C1&!C&!B&A1&!A|E&D1&!D&!C1&!C&!B&A1&A|E&D1&D&!C1&!C&!B&A1&A|E&!D1&D&!C1&!C&!B&A1&A|E&!D1&D&C1&!C&!B&A1&A|E&D1&D&C1&!C&!B&A1&A|E&D1&!D&C1&!C&!B&A1&A|E&!D1&!D&C1&!C&!B&A1&A|E&!D1&!D&C1&C&!B&A1&A|E&D1&!D&C1&C&!B&A1&A|E&D1&D&C1&C&!B&A1&A|E&!D1&D&C1&C&!B&A1&A|E&!D1&D&!C1&C&!B&A1&A|E&D1&D&!C1&C&!B&A1&A|E&D1&!D&!C1&C&!B&A1&A|E&!D1&!D&!C1&C&!B&A1&A|E&!D1&!D&!C1&C&B&A1&A|E&D1&!D&!C1&C&B&A1&A|E&D1&D&!C1&C&B&A1&A|E&!D1&D&!C1&C&B&A1&A|E&!D1&D&C1&C&B&A1&A|E&D1&D&C1&C&B&A1&A|E&D1&!D&C1&C&B&A1&A|E&!D1&!D&C1&C&B&A1&A|E&!D1&!D&C1&!C&B&A1&A|E&D1&!D&C1&!C&B&A1&A|E&D1&D&C1&!C&B&A1&A|E&!D1&D&C1&!C&B&A1&A|E&!D1&D&!C1&!C&B&A1&A|E&D1&D&!C1&!C&B&A1&A|E&D1&!D&!C1&!C&B&A1&A|E&D1&!D&!C1&!C&B&!A1&A|E&D1&D&!C1&!C&B&!A1&A|E&!D1&D&!C1&!C&B&!A1&A|E&!D1&D&C1&!C&B&!A1&A|E&D1&D&C1&!C&B&!A1&A|E&D1&!D&C1&!C&B&!A1&A|E&!D1&!D&C1&!C&B&!A1&A|E&!D1&!D&C1&C&B&!A1&A|E&D1&!D&C1&C&B&!A1&A|E&D1&D&C1&C&B&!A1&A|E&!D1&D&C1&C&B&!A1&A|E&!D1&D&!C1&C&B&!A1&A|E&D1&D&!C1&C&B&!A1&A|E&D1&!D&!C1&C&B&!A1&A|E&!D1&!D&!C1&C&B&!A1&A|E&D1&!D&!C1&C&!B&!A1&A|E&D1&D&!C1&C&!B&!A1&A|E&!D1&D&!C1&C&!B&!A1&A|E&!D1&D&C1&C&!B&!A1&A|E&D1&D&C1&C&!B&!A1&A|E&D1&!D&C1&C&!B&!A1&A|E&D1&!D&C1&!C&!B&!A1&A|E&D1&D&C1&!C&!B&!A1&A|E&!D1&D&C1&!C&!B&!A1&A|E&!D1&D&!C1&!C&!B&!A1&A|E&D1&D&!C1&!C&!B&!A1&A|E&D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOAI21221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOOAI21112 -l AOAOOAI21112 -i E1 E D C B A1 A -o Y -f Y=!(!E1&E&D&!C&!B&!A1&!A|E1&E&D&!C&!B&!A1&!A|E1&!E&D&!C&!B&!A1&!A|E1&!E&D&C&!B&!A1&!A|E1&E&D&C&!B&!A1&!A|!E1&E&D&C&!B&!A1&!A|E1&!E&!D&C&B&!A1&!A|E1&E&!D&C&B&!A1&!A|!E1&E&!D&C&B&!A1&!A|!E1&E&D&C&B&!A1&!A|E1&E&D&C&B&!A1&!A|E1&!E&D&C&B&!A1&!A|E1&!E&D&!C&B&!A1&!A|E1&E&D&!C&B&!A1&!A|!E1&E&D&!C&B&!A1&!A|!E1&E&D&!C&B&A1&!A|E1&E&D&!C&B&A1&!A|E1&!E&D&!C&B&A1&!A|E1&!E&D&C&B&A1&!A|E1&E&D&C&B&A1&!A|!E1&E&D&C&B&A1&!A|!E1&E&!D&C&B&A1&!A|E1&E&!D&C&B&A1&!A|E1&!E&!D&C&B&A1&!A|!E1&E&D&C&!B&A1&!A|E1&E&D&C&!B&A1&!A|E1&!E&D&C&!B&A1&!A|E1&!E&D&!C&!B&A1&!A|E1&E&D&!C&!B&A1&!A|!E1&E&D&!C&!B&A1&!A|!E1&E&D&!C&!B&A1&A|E1&E&D&!C&!B&A1&A|E1&!E&D&!C&!B&A1&A|E1&!E&D&C&!B&A1&A|E1&E&D&C&!B&A1&A|!E1&E&D&C&!B&A1&A|!E1&E&!D&C&!B&A1&A|E1&E&!D&C&!B&A1&A|E1&!E&!D&C&!B&A1&A|E1&!E&!D&C&B&A1&A|E1&E&!D&C&B&A1&A|!E1&E&!D&C&B&A1&A|!E1&E&D&C&B&A1&A|E1&E&D&C&B&A1&A|E1&!E&D&C&B&A1&A|E1&!E&D&!C&B&A1&A|E1&E&D&!C&B&A1&A|!E1&E&D&!C&B&A1&A|!E1&E&D&!C&B&!A1&A|E1&E&D&!C&B&!A1&A|E1&!E&D&!C&B&!A1&A|E1&!E&D&C&B&!A1&A|E1&E&D&C&B&!A1&A|!E1&E&D&C&B&!A1&A|!E1&E&!D&C&B&!A1&A|E1&E&!D&C&B&!A1&A|E1&!E&!D&C&B&!A1&A|!E1&E&D&C&!B&!A1&A|E1&E&D&C&!B&!A1&A|E1&!E&D&C&!B&!A1&A|E1&!E&D&!C&!B&!A1&A|E1&E&D&!C&!B&!A1&A|!E1&E&D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOOAI21112.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOOAI2222 -l OOAOOAI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B1&!B&!A1&!A|D1&!D&!C1&!C&!B1&!B&!A1&!A|D1&D&!C1&!C&!B1&!B&!A1&!A|!D1&D&!C1&!C&!B1&!B&!A1&!A|!D1&!D&C1&!C&!B1&!B&!A1&!A|!D1&!D&C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&B1&!B&!A1&!A|!D1&!D&C1&C&B1&!B&!A1&!A|!D1&!D&C1&!C&B1&!B&!A1&!A|!D1&D&!C1&!C&B1&!B&!A1&!A|D1&D&!C1&!C&B1&!B&!A1&!A|D1&!D&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&B&!A1&!A|D1&!D&!C1&!C&B1&B&!A1&!A|D1&D&!C1&!C&B1&B&!A1&!A|!D1&D&!C1&!C&B1&B&!A1&!A|!D1&!D&C1&!C&B1&B&!A1&!A|!D1&!D&C1&C&B1&B&!A1&!A|!D1&!D&!C1&C&B1&B&!A1&!A|!D1&!D&!C1&C&!B1&B&!A1&!A|!D1&!D&C1&C&!B1&B&!A1&!A|!D1&!D&C1&!C&!B1&B&!A1&!A|!D1&D&!C1&!C&!B1&B&!A1&!A|D1&D&!C1&!C&!B1&B&!A1&!A|D1&!D&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&A1&!A|!D1&!D&C1&!C&!B1&B&A1&!A|!D1&!D&C1&C&!B1&B&A1&!A|!D1&!D&!C1&C&!B1&B&A1&!A|!D1&!D&!C1&C&B1&B&A1&!A|!D1&!D&C1&C&B1&B&A1&!A|!D1&!D&C1&!C&B1&B&A1&!A|!D1&!D&!C1&!C&B1&B&A1&!A|!D1&!D&!C1&!C&B1&!B&A1&!A|!D1&!D&C1&!C&B1&!B&A1&!A|!D1&!D&C1&C&B1&!B&A1&!A|!D1&!D&!C1&C&B1&!B&A1&!A|!D1&!D&!C1&C&!B1&!B&A1&!A|!D1&!D&C1&C&!B1&!B&A1&!A|!D1&!D&C1&!C&!B1&!B&A1&!A|!D1&D&!C1&!C&!B1&!B&A1&!A|D1&D&!C1&!C&!B1&!B&A1&!A|D1&!D&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&A|D1&!D&!C1&!C&!B1&!B&A1&A|D1&D&!C1&!C&!B1&!B&A1&A|!D1&D&!C1&!C&!B1&!B&A1&A|!D1&!D&C1&!C&!B1&!B&A1&A|!D1&!D&C1&C&!B1&!B&A1&A|!D1&!D&!C1&C&!B1&!B&A1&A|!D1&!D&!C1&C&B1&!B&A1&A|!D1&!D&C1&C&B1&!B&A1&A|!D1&!D&C1&!C&B1&!B&A1&A|!D1&!D&!C1&!C&B1&!B&A1&A|!D1&!D&!C1&!C&B1&B&A1&A|!D1&!D&C1&!C&B1&B&A1&A|!D1&!D&C1&C&B1&B&A1&A|!D1&!D&!C1&C&B1&B&A1&A|!D1&!D&!C1&C&!B1&B&A1&A|!D1&!D&C1&C&!B1&B&A1&A|!D1&!D&C1&!C&!B1&B&A1&A|!D1&!D&!C1&!C&!B1&B&A1&A|!D1&!D&!C1&!C&!B1&B&!A1&A|!D1&!D&C1&!C&!B1&B&!A1&A|!D1&!D&C1&C&!B1&B&!A1&A|!D1&!D&!C1&C&!B1&B&!A1&A|!D1&!D&!C1&C&B1&B&!A1&A|!D1&!D&C1&C&B1&B&!A1&A|!D1&!D&C1&!C&B1&B&!A1&A|!D1&!D&!C1&!C&B1&B&!A1&A|!D1&!D&!C1&!C&B1&!B&!A1&A|!D1&!D&C1&!C&B1&!B&!A1&A|!D1&!D&C1&C&B1&!B&!A1&A|!D1&!D&!C1&C&B1&!B&!A1&A|!D1&!D&!C1&C&!B1&!B&!A1&A|!D1&!D&C1&C&!B1&!B&!A1&A|!D1&!D&C1&!C&!B1&!B&!A1&A|!D1&D&!C1&!C&!B1&!B&!A1&A|D1&D&!C1&!C&!B1&!B&!A1&A|D1&!D&!C1&!C&!B1&!B&!A1&A|!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOOAI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOAI21111 -l AOAOAI21111 -i E D C B A1 A -o Y -f Y=!(E&D&!C&!B&!A1&!A|E&D&C&!B&!A1&!A|E&!D&C&B&!A1&!A|E&D&C&B&!A1&!A|E&D&!C&B&!A1&!A|E&D&!C&B&A1&!A|E&D&C&B&A1&!A|E&!D&C&B&A1&!A|E&D&C&!B&A1&!A|E&D&!C&!B&A1&!A|E&D&!C&!B&A1&A|E&D&C&!B&A1&A|E&!D&C&!B&A1&A|E&!D&C&B&A1&A|E&D&C&B&A1&A|E&D&!C&B&A1&A|E&D&!C&B&!A1&A|E&D&C&B&!A1&A|E&!D&C&B&!A1&A|E&D&C&!B&!A1&A|E&D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOAI21111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOAI3131 -l OAAOAI3131 -i D C2 C1 C B A2 A1 A -o Y -f Y=!(D&C2&C1&C&!B&!A2&!A1&!A|D&C2&C1&C&B&!A2&!A1&!A|D&!C2&!C1&!C&B&A2&!A1&!A|D&C2&!C1&!C&B&A2&!A1&!A|D&C2&C1&!C&B&A2&!A1&!A|D&!C2&C1&!C&B&A2&!A1&!A|D&!C2&C1&C&B&A2&!A1&!A|D&C2&C1&C&B&A2&!A1&!A|D&C2&!C1&C&B&A2&!A1&!A|D&!C2&!C1&C&B&A2&!A1&!A|D&C2&C1&C&!B&A2&!A1&!A|D&C2&C1&C&!B&A2&A1&!A|D&!C2&!C1&C&B&A2&A1&!A|D&C2&!C1&C&B&A2&A1&!A|D&C2&C1&C&B&A2&A1&!A|D&!C2&C1&C&B&A2&A1&!A|D&!C2&C1&!C&B&A2&A1&!A|D&C2&C1&!C&B&A2&A1&!A|D&C2&!C1&!C&B&A2&A1&!A|D&!C2&!C1&!C&B&A2&A1&!A|D&!C2&!C1&!C&B&!A2&A1&!A|D&C2&!C1&!C&B&!A2&A1&!A|D&C2&C1&!C&B&!A2&A1&!A|D&!C2&C1&!C&B&!A2&A1&!A|D&!C2&C1&C&B&!A2&A1&!A|D&C2&C1&C&B&!A2&A1&!A|D&C2&!C1&C&B&!A2&A1&!A|D&!C2&!C1&C&B&!A2&A1&!A|D&C2&C1&C&!B&!A2&A1&!A|D&C2&C1&C&!B&!A2&A1&A|D&!C2&!C1&C&B&!A2&A1&A|D&C2&!C1&C&B&!A2&A1&A|D&C2&C1&C&B&!A2&A1&A|D&!C2&C1&C&B&!A2&A1&A|D&!C2&C1&!C&B&!A2&A1&A|D&C2&C1&!C&B&!A2&A1&A|D&C2&!C1&!C&B&!A2&A1&A|D&!C2&!C1&!C&B&!A2&A1&A|D&!C2&!C1&!C&B&A2&A1&A|D&C2&!C1&!C&B&A2&A1&A|D&C2&C1&!C&B&A2&A1&A|D&!C2&C1&!C&B&A2&A1&A|D&!C2&C1&C&B&A2&A1&A|D&C2&C1&C&B&A2&A1&A|D&C2&!C1&C&B&A2&A1&A|D&!C2&!C1&C&B&A2&A1&A|D&C2&C1&C&!B&A2&A1&A|D&C2&C1&C&!B&A2&!A1&A|D&!C2&!C1&C&B&A2&!A1&A|D&C2&!C1&C&B&A2&!A1&A|D&C2&C1&C&B&A2&!A1&A|D&!C2&C1&C&B&A2&!A1&A|D&!C2&C1&!C&B&A2&!A1&A|D&C2&C1&!C&B&A2&!A1&A|D&C2&!C1&!C&B&A2&!A1&A|D&!C2&!C1&!C&B&A2&!A1&A|D&!C2&!C1&!C&B&!A2&!A1&A|D&C2&!C1&!C&B&!A2&!A1&A|D&C2&C1&!C&B&!A2&!A1&A|D&!C2&C1&!C&B&!A2&!A1&A|D&!C2&C1&C&B&!A2&!A1&A|D&C2&C1&C&B&!A2&!A1&A|D&C2&!C1&C&B&!A2&!A1&A|D&!C2&!C1&C&B&!A2&!A1&A|D&C2&C1&C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOAI3131.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOAI2121 -l OAAOAI2121 -i D C1 C B A1 A -o Y -f Y=!(D&C1&C&!B&!A1&!A|D&C1&C&B&!A1&!A|D&!C1&!C&B&A1&!A|D&C1&!C&B&A1&!A|D&C1&C&B&A1&!A|D&!C1&C&B&A1&!A|D&C1&C&!B&A1&!A|D&C1&C&!B&A1&A|D&!C1&C&B&A1&A|D&C1&C&B&A1&A|D&C1&!C&B&A1&A|D&!C1&!C&B&A1&A|D&!C1&!C&B&!A1&A|D&C1&!C&B&!A1&A|D&C1&C&B&!A1&A|D&!C1&C&B&!A1&A|D&C1&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOAI2121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOAI32111 -l OOAOAI32111 -i E D C B1 B A2 A1 A -o Y -f Y=!(E&D&!C&!B1&!B&!A2&!A1&!A|E&D&C&!B1&!B&!A2&!A1&!A|E&D&C&B1&!B&!A2&!A1&!A|E&D&!C&B1&!B&!A2&!A1&!A|E&D&!C&B1&B&!A2&!A1&!A|E&D&C&B1&B&!A2&!A1&!A|E&D&C&!B1&B&!A2&!A1&!A|E&D&!C&!B1&B&!A2&!A1&!A|E&D&!C&!B1&B&A2&!A1&!A|E&D&C&!B1&B&A2&!A1&!A|E&!D&C&!B1&B&A2&!A1&!A|E&!D&C&B1&B&A2&!A1&!A|E&D&C&B1&B&A2&!A1&!A|E&D&!C&B1&B&A2&!A1&!A|E&D&!C&B1&!B&A2&!A1&!A|E&D&C&B1&!B&A2&!A1&!A|E&!D&C&B1&!B&A2&!A1&!A|E&D&C&!B1&!B&A2&!A1&!A|E&D&!C&!B1&!B&A2&!A1&!A|E&D&!C&!B1&!B&A2&A1&!A|E&D&C&!B1&!B&A2&A1&!A|E&!D&C&B1&!B&A2&A1&!A|E&D&C&B1&!B&A2&A1&!A|E&D&!C&B1&!B&A2&A1&!A|E&D&!C&B1&B&A2&A1&!A|E&D&C&B1&B&A2&A1&!A|E&!D&C&B1&B&A2&A1&!A|E&!D&C&!B1&B&A2&A1&!A|E&D&C&!B1&B&A2&A1&!A|E&D&!C&!B1&B&A2&A1&!A|E&D&!C&!B1&B&!A2&A1&!A|E&D&C&!B1&B&!A2&A1&!A|E&!D&C&!B1&B&!A2&A1&!A|E&!D&C&B1&B&!A2&A1&!A|E&D&C&B1&B&!A2&A1&!A|E&D&!C&B1&B&!A2&A1&!A|E&D&!C&B1&!B&!A2&A1&!A|E&D&C&B1&!B&!A2&A1&!A|E&!D&C&B1&!B&!A2&A1&!A|E&D&C&!B1&!B&!A2&A1&!A|E&D&!C&!B1&!B&!A2&A1&!A|E&D&!C&!B1&!B&!A2&A1&A|E&D&C&!B1&!B&!A2&A1&A|E&!D&C&B1&!B&!A2&A1&A|E&D&C&B1&!B&!A2&A1&A|E&D&!C&B1&!B&!A2&A1&A|E&D&!C&B1&B&!A2&A1&A|E&D&C&B1&B&!A2&A1&A|E&!D&C&B1&B&!A2&A1&A|E&!D&C&!B1&B&!A2&A1&A|E&D&C&!B1&B&!A2&A1&A|E&D&!C&!B1&B&!A2&A1&A|E&D&!C&!B1&B&A2&A1&A|E&D&C&!B1&B&A2&A1&A|E&!D&C&!B1&B&A2&A1&A|E&!D&C&B1&B&A2&A1&A|E&D&C&B1&B&A2&A1&A|E&D&!C&B1&B&A2&A1&A|E&D&!C&B1&!B&A2&A1&A|E&D&C&B1&!B&A2&A1&A|E&!D&C&B1&!B&A2&A1&A|E&D&C&!B1&!B&A2&A1&A|E&D&!C&!B1&!B&A2&A1&A|E&D&!C&!B1&!B&A2&!A1&A|E&D&C&!B1&!B&A2&!A1&A|E&!D&C&B1&!B&A2&!A1&A|E&D&C&B1&!B&A2&!A1&A|E&D&!C&B1&!B&A2&!A1&A|E&D&!C&B1&B&A2&!A1&A|E&D&C&B1&B&A2&!A1&A|E&!D&C&B1&B&A2&!A1&A|E&!D&C&!B1&B&A2&!A1&A|E&D&C&!B1&B&A2&!A1&A|E&D&!C&!B1&B&A2&!A1&A|E&D&!C&!B1&B&!A2&!A1&A|E&D&C&!B1&B&!A2&!A1&A|E&!D&C&!B1&B&!A2&!A1&A|E&!D&C&B1&B&!A2&!A1&A|E&D&C&B1&B&!A2&!A1&A|E&D&!C&B1&B&!A2&!A1&A|E&D&!C&B1&!B&!A2&!A1&A|E&D&C&B1&!B&!A2&!A1&A|E&!D&C&B1&!B&!A2&!A1&A|E&D&C&!B1&!B&!A2&!A1&A|E&D&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOAI32111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOAI211311 -l AOAAOAI211311 -i F E D2 D1 D C B A1 A -o Y -f Y=!(F&E&!D2&!D1&!D&!C&!B&!A1&!A|F&E&D2&!D1&!D&!C&!B&!A1&!A|F&E&D2&D1&!D&!C&!B&!A1&!A|F&E&!D2&D1&!D&!C&!B&!A1&!A|F&E&!D2&D1&D&!C&!B&!A1&!A|F&E&D2&D1&D&!C&!B&!A1&!A|F&!E&D2&D1&D&!C&!B&!A1&!A|F&E&D2&!D1&D&!C&!B&!A1&!A|F&E&!D2&!D1&D&!C&!B&!A1&!A|F&E&!D2&!D1&D&C&!B&!A1&!A|F&E&D2&!D1&D&C&!B&!A1&!A|F&!E&D2&D1&D&C&!B&!A1&!A|F&E&D2&D1&D&C&!B&!A1&!A|F&E&!D2&D1&D&C&!B&!A1&!A|F&E&!D2&D1&!D&C&!B&!A1&!A|F&E&D2&D1&!D&C&!B&!A1&!A|F&E&D2&!D1&!D&C&!B&!A1&!A|F&E&!D2&!D1&!D&C&!B&!A1&!A|F&!E&!D2&!D1&!D&C&B&!A1&!A|F&E&!D2&!D1&!D&C&B&!A1&!A|F&E&D2&!D1&!D&C&B&!A1&!A|F&!E&D2&!D1&!D&C&B&!A1&!A|F&!E&D2&D1&!D&C&B&!A1&!A|F&E&D2&D1&!D&C&B&!A1&!A|F&E&!D2&D1&!D&C&B&!A1&!A|F&!E&!D2&D1&!D&C&B&!A1&!A|F&!E&!D2&D1&D&C&B&!A1&!A|F&E&!D2&D1&D&C&B&!A1&!A|F&E&D2&D1&D&C&B&!A1&!A|F&!E&D2&D1&D&C&B&!A1&!A|F&!E&D2&!D1&D&C&B&!A1&!A|F&E&D2&!D1&D&C&B&!A1&!A|F&E&!D2&!D1&D&C&B&!A1&!A|F&!E&!D2&!D1&D&C&B&!A1&!A|F&E&!D2&!D1&D&!C&B&!A1&!A|F&E&D2&!D1&D&!C&B&!A1&!A|F&!E&D2&D1&D&!C&B&!A1&!A|F&E&D2&D1&D&!C&B&!A1&!A|F&E&!D2&D1&D&!C&B&!A1&!A|F&E&!D2&D1&!D&!C&B&!A1&!A|F&E&D2&D1&!D&!C&B&!A1&!A|F&E&D2&!D1&!D&!C&B&!A1&!A|F&E&!D2&!D1&!D&!C&B&!A1&!A|F&E&!D2&!D1&!D&!C&B&A1&!A|F&E&D2&!D1&!D&!C&B&A1&!A|F&E&D2&D1&!D&!C&B&A1&!A|F&E&!D2&D1&!D&!C&B&A1&!A|F&E&!D2&D1&D&!C&B&A1&!A|F&E&D2&D1&D&!C&B&A1&!A|F&!E&D2&D1&D&!C&B&A1&!A|F&E&D2&!D1&D&!C&B&A1&!A|F&E&!D2&!D1&D&!C&B&A1&!A|F&!E&!D2&!D1&D&C&B&A1&!A|F&E&!D2&!D1&D&C&B&A1&!A|F&E&D2&!D1&D&C&B&A1&!A|F&!E&D2&!D1&D&C&B&A1&!A|F&!E&D2&D1&D&C&B&A1&!A|F&E&D2&D1&D&C&B&A1&!A|F&E&!D2&D1&D&C&B&A1&!A|F&!E&!D2&D1&D&C&B&A1&!A|F&!E&!D2&D1&!D&C&B&A1&!A|F&E&!D2&D1&!D&C&B&A1&!A|F&E&D2&D1&!D&C&B&A1&!A|F&!E&D2&D1&!D&C&B&A1&!A|F&!E&D2&!D1&!D&C&B&A1&!A|F&E&D2&!D1&!D&C&B&A1&!A|F&E&!D2&!D1&!D&C&B&A1&!A|F&!E&!D2&!D1&!D&C&B&A1&!A|F&E&!D2&!D1&!D&C&!B&A1&!A|F&E&D2&!D1&!D&C&!B&A1&!A|F&E&D2&D1&!D&C&!B&A1&!A|F&E&!D2&D1&!D&C&!B&A1&!A|F&E&!D2&D1&D&C&!B&A1&!A|F&E&D2&D1&D&C&!B&A1&!A|F&!E&D2&D1&D&C&!B&A1&!A|F&E&D2&!D1&D&C&!B&A1&!A|F&E&!D2&!D1&D&C&!B&A1&!A|F&E&!D2&!D1&D&!C&!B&A1&!A|F&E&D2&!D1&D&!C&!B&A1&!A|F&!E&D2&D1&D&!C&!B&A1&!A|F&E&D2&D1&D&!C&!B&A1&!A|F&E&!D2&D1&D&!C&!B&A1&!A|F&E&!D2&D1&!D&!C&!B&A1&!A|F&E&D2&D1&!D&!C&!B&A1&!A|F&E&D2&!D1&!D&!C&!B&A1&!A|F&E&!D2&!D1&!D&!C&!B&A1&!A|F&E&!D2&!D1&!D&!C&!B&A1&A|F&E&D2&!D1&!D&!C&!B&A1&A|F&E&D2&D1&!D&!C&!B&A1&A|F&E&!D2&D1&!D&!C&!B&A1&A|F&E&!D2&D1&D&!C&!B&A1&A|F&E&D2&D1&D&!C&!B&A1&A|F&!E&D2&D1&D&!C&!B&A1&A|F&E&D2&!D1&D&!C&!B&A1&A|F&E&!D2&!D1&D&!C&!B&A1&A|F&!E&!D2&!D1&D&C&!B&A1&A|F&E&!D2&!D1&D&C&!B&A1&A|F&E&D2&!D1&D&C&!B&A1&A|F&!E&D2&!D1&D&C&!B&A1&A|F&!E&D2&D1&D&C&!B&A1&A|F&E&D2&D1&D&C&!B&A1&A|F&E&!D2&D1&D&C&!B&A1&A|F&!E&!D2&D1&D&C&!B&A1&A|F&!E&!D2&D1&!D&C&!B&A1&A|F&E&!D2&D1&!D&C&!B&A1&A|F&E&D2&D1&!D&C&!B&A1&A|F&!E&D2&D1&!D&C&!B&A1&A|F&!E&D2&!D1&!D&C&!B&A1&A|F&E&D2&!D1&!D&C&!B&A1&A|F&E&!D2&!D1&!D&C&!B&A1&A|F&!E&!D2&!D1&!D&C&!B&A1&A|F&!E&!D2&!D1&!D&C&B&A1&A|F&E&!D2&!D1&!D&C&B&A1&A|F&E&D2&!D1&!D&C&B&A1&A|F&!E&D2&!D1&!D&C&B&A1&A|F&!E&D2&D1&!D&C&B&A1&A|F&E&D2&D1&!D&C&B&A1&A|F&E&!D2&D1&!D&C&B&A1&A|F&!E&!D2&D1&!D&C&B&A1&A|F&!E&!D2&D1&D&C&B&A1&A|F&E&!D2&D1&D&C&B&A1&A|F&E&D2&D1&D&C&B&A1&A|F&!E&D2&D1&D&C&B&A1&A|F&!E&D2&!D1&D&C&B&A1&A|F&E&D2&!D1&D&C&B&A1&A|F&E&!D2&!D1&D&C&B&A1&A|F&!E&!D2&!D1&D&C&B&A1&A|F&E&!D2&!D1&D&!C&B&A1&A|F&E&D2&!D1&D&!C&B&A1&A|F&!E&D2&D1&D&!C&B&A1&A|F&E&D2&D1&D&!C&B&A1&A|F&E&!D2&D1&D&!C&B&A1&A|F&E&!D2&D1&!D&!C&B&A1&A|F&E&D2&D1&!D&!C&B&A1&A|F&E&D2&!D1&!D&!C&B&A1&A|F&E&!D2&!D1&!D&!C&B&A1&A|F&E&!D2&!D1&!D&!C&B&!A1&A|F&E&D2&!D1&!D&!C&B&!A1&A|F&E&D2&D1&!D&!C&B&!A1&A|F&E&!D2&D1&!D&!C&B&!A1&A|F&E&!D2&D1&D&!C&B&!A1&A|F&E&D2&D1&D&!C&B&!A1&A|F&!E&D2&D1&D&!C&B&!A1&A|F&E&D2&!D1&D&!C&B&!A1&A|F&E&!D2&!D1&D&!C&B&!A1&A|F&!E&!D2&!D1&D&C&B&!A1&A|F&E&!D2&!D1&D&C&B&!A1&A|F&E&D2&!D1&D&C&B&!A1&A|F&!E&D2&!D1&D&C&B&!A1&A|F&!E&D2&D1&D&C&B&!A1&A|F&E&D2&D1&D&C&B&!A1&A|F&E&!D2&D1&D&C&B&!A1&A|F&!E&!D2&D1&D&C&B&!A1&A|F&!E&!D2&D1&!D&C&B&!A1&A|F&E&!D2&D1&!D&C&B&!A1&A|F&E&D2&D1&!D&C&B&!A1&A|F&!E&D2&D1&!D&C&B&!A1&A|F&!E&D2&!D1&!D&C&B&!A1&A|F&E&D2&!D1&!D&C&B&!A1&A|F&E&!D2&!D1&!D&C&B&!A1&A|F&!E&!D2&!D1&!D&C&B&!A1&A|F&E&!D2&!D1&!D&C&!B&!A1&A|F&E&D2&!D1&!D&C&!B&!A1&A|F&E&D2&D1&!D&C&!B&!A1&A|F&E&!D2&D1&!D&C&!B&!A1&A|F&E&!D2&D1&D&C&!B&!A1&A|F&E&D2&D1&D&C&!B&!A1&A|F&!E&D2&D1&D&C&!B&!A1&A|F&E&D2&!D1&D&C&!B&!A1&A|F&E&!D2&!D1&D&C&!B&!A1&A|F&E&!D2&!D1&D&!C&!B&!A1&A|F&E&D2&!D1&D&!C&!B&!A1&A|F&!E&D2&D1&D&!C&!B&!A1&A|F&E&D2&D1&D&!C&!B&!A1&A|F&E&!D2&D1&D&!C&!B&!A1&A|F&E&!D2&D1&!D&!C&!B&!A1&A|F&E&D2&D1&!D&!C&!B&!A1&A|F&E&D2&!D1&!D&!C&!B&!A1&A|F&E&!D2&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOAI211311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAAOAI222311 -l OOOAAOAI222311 -i F E D2 D1 D C1 C B1 B A1 A -o Y -f Y=!(F&E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|F&E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|F&E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|F&E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|F&E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|F&!E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|F&E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|F&!E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|F&E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|F&E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|F&E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|F&E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|F&E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|F&E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|F&E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|F&E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|F&E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|F&E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|F&E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|F&E&D2&D1&D&C1&C&!B1&!B&!A1&!A|F&!E&D2&D1&D&C1&C&!B1&!B&!A1&!A|F&E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|F&E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|F&E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|F&E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|F&!E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|F&E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|F&E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|F&E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|F&E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|F&E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|F&E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|F&E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|F&E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|F&E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|F&E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|F&E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|F&E&D2&D1&D&!C1&C&B1&!B&!A1&!A|F&!E&D2&D1&D&!C1&C&B1&!B&!A1&!A|F&E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|F&E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|F&E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|F&E&D2&!D1&D&C1&C&B1&!B&!A1&!A|F&!E&D2&D1&D&C1&C&B1&!B&!A1&!A|F&E&D2&D1&D&C1&C&B1&!B&!A1&!A|F&E&!D2&D1&D&C1&C&B1&!B&!A1&!A|F&E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|F&E&D2&D1&!D&C1&C&B1&!B&!A1&!A|F&E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|F&E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|F&E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|F&E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|F&E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|F&E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|F&E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|F&E&D2&D1&D&C1&!C&B1&!B&!A1&!A|F&!E&D2&D1&D&C1&!C&B1&!B&!A1&!A|F&E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|F&E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|F&E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|F&E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|F&!E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|F&E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|F&E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|F&E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|F&E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|F&E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|F&E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|F&E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|F&E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|F&E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|F&E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|F&E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|F&E&D2&D1&D&!C1&!C&B1&B&!A1&!A|F&!E&D2&D1&D&!C1&!C&B1&B&!A1&!A|F&E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|F&E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|F&E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|F&E&D2&!D1&D&C1&!C&B1&B&!A1&!A|F&!E&D2&D1&D&C1&!C&B1&B&!A1&!A|F&E&D2&D1&D&C1&!C&B1&B&!A1&!A|F&E&!D2&D1&D&C1&!C&B1&B&!A1&!A|F&E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|F&E&D2&D1&!D&C1&!C&B1&B&!A1&!A|F&E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|F&E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|F&E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|F&E&D2&!D1&!D&C1&C&B1&B&!A1&!A|F&E&D2&D1&!D&C1&C&B1&B&!A1&!A|F&E&!D2&D1&!D&C1&C&B1&B&!A1&!A|F&E&!D2&D1&D&C1&C&B1&B&!A1&!A|F&E&D2&D1&D&C1&C&B1&B&!A1&!A|F&!E&D2&D1&D&C1&C&B1&B&!A1&!A|F&E&D2&!D1&D&C1&C&B1&B&!A1&!A|F&E&!D2&!D1&D&C1&C&B1&B&!A1&!A|F&E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|F&E&D2&!D1&D&!C1&C&B1&B&!A1&!A|F&!E&D2&D1&D&!C1&C&B1&B&!A1&!A|F&E&D2&D1&D&!C1&C&B1&B&!A1&!A|F&E&!D2&D1&D&!C1&C&B1&B&!A1&!A|F&E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|F&E&D2&D1&!D&!C1&C&B1&B&!A1&!A|F&E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|F&E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|F&E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|F&E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|F&E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|F&E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|F&E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|F&E&D2&D1&D&!C1&C&!B1&B&!A1&!A|F&!E&D2&D1&D&!C1&C&!B1&B&!A1&!A|F&E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|F&E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|F&E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|F&E&D2&!D1&D&C1&C&!B1&B&!A1&!A|F&!E&D2&D1&D&C1&C&!B1&B&!A1&!A|F&E&D2&D1&D&C1&C&!B1&B&!A1&!A|F&E&!D2&D1&D&C1&C&!B1&B&!A1&!A|F&E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|F&E&D2&D1&!D&C1&C&!B1&B&!A1&!A|F&E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|F&E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|F&E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|F&E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|F&E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|F&E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|F&E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|F&E&D2&D1&D&C1&!C&!B1&B&!A1&!A|F&!E&D2&D1&D&C1&!C&!B1&B&!A1&!A|F&E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|F&E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|F&E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|F&E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|F&!E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|F&E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|F&E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|F&E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|F&E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|F&E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|F&E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|F&E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|F&E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|F&E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|F&E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|F&E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|F&E&D2&D1&D&!C1&!C&!B1&B&A1&!A|F&!E&D2&D1&D&!C1&!C&!B1&B&A1&!A|F&E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|F&E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|F&!E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|F&E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|F&E&D2&!D1&D&C1&!C&!B1&B&A1&!A|F&!E&D2&!D1&D&C1&!C&!B1&B&A1&!A|F&!E&D2&D1&D&C1&!C&!B1&B&A1&!A|F&E&D2&D1&D&C1&!C&!B1&B&A1&!A|F&E&!D2&D1&D&C1&!C&!B1&B&A1&!A|F&!E&!D2&D1&D&C1&!C&!B1&B&A1&!A|F&!E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|F&E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|F&E&D2&D1&!D&C1&!C&!B1&B&A1&!A|F&!E&D2&D1&!D&C1&!C&!B1&B&A1&!A|F&!E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|F&E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|F&E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|F&!E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|F&!E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|F&E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|F&E&D2&!D1&!D&C1&C&!B1&B&A1&!A|F&!E&D2&!D1&!D&C1&C&!B1&B&A1&!A|F&!E&D2&D1&!D&C1&C&!B1&B&A1&!A|F&E&D2&D1&!D&C1&C&!B1&B&A1&!A|F&E&!D2&D1&!D&C1&C&!B1&B&A1&!A|F&!E&!D2&D1&!D&C1&C&!B1&B&A1&!A|F&!E&!D2&D1&D&C1&C&!B1&B&A1&!A|F&E&!D2&D1&D&C1&C&!B1&B&A1&!A|F&E&D2&D1&D&C1&C&!B1&B&A1&!A|F&!E&D2&D1&D&C1&C&!B1&B&A1&!A|F&!E&D2&!D1&D&C1&C&!B1&B&A1&!A|F&E&D2&!D1&D&C1&C&!B1&B&A1&!A|F&E&!D2&!D1&D&C1&C&!B1&B&A1&!A|F&!E&!D2&!D1&D&C1&C&!B1&B&A1&!A|F&!E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|F&E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|F&E&D2&!D1&D&!C1&C&!B1&B&A1&!A|F&!E&D2&!D1&D&!C1&C&!B1&B&A1&!A|F&!E&D2&D1&D&!C1&C&!B1&B&A1&!A|F&E&D2&D1&D&!C1&C&!B1&B&A1&!A|F&E&!D2&D1&D&!C1&C&!B1&B&A1&!A|F&!E&!D2&D1&D&!C1&C&!B1&B&A1&!A|F&!E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|F&E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|F&E&D2&D1&!D&!C1&C&!B1&B&A1&!A|F&!E&D2&D1&!D&!C1&C&!B1&B&A1&!A|F&!E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|F&E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|F&E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|F&!E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|F&!E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|F&E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|F&E&D2&!D1&!D&!C1&C&B1&B&A1&!A|F&!E&D2&!D1&!D&!C1&C&B1&B&A1&!A|F&!E&D2&D1&!D&!C1&C&B1&B&A1&!A|F&E&D2&D1&!D&!C1&C&B1&B&A1&!A|F&E&!D2&D1&!D&!C1&C&B1&B&A1&!A|F&!E&!D2&D1&!D&!C1&C&B1&B&A1&!A|F&!E&!D2&D1&D&!C1&C&B1&B&A1&!A|F&E&!D2&D1&D&!C1&C&B1&B&A1&!A|F&E&D2&D1&D&!C1&C&B1&B&A1&!A|F&!E&D2&D1&D&!C1&C&B1&B&A1&!A|F&!E&D2&!D1&D&!C1&C&B1&B&A1&!A|F&E&D2&!D1&D&!C1&C&B1&B&A1&!A|F&E&!D2&!D1&D&!C1&C&B1&B&A1&!A|F&!E&!D2&!D1&D&!C1&C&B1&B&A1&!A|F&!E&!D2&!D1&D&C1&C&B1&B&A1&!A|F&E&!D2&!D1&D&C1&C&B1&B&A1&!A|F&E&D2&!D1&D&C1&C&B1&B&A1&!A|F&!E&D2&!D1&D&C1&C&B1&B&A1&!A|F&!E&D2&D1&D&C1&C&B1&B&A1&!A|F&E&D2&D1&D&C1&C&B1&B&A1&!A|F&E&!D2&D1&D&C1&C&B1&B&A1&!A|F&!E&!D2&D1&D&C1&C&B1&B&A1&!A|F&!E&!D2&D1&!D&C1&C&B1&B&A1&!A|F&E&!D2&D1&!D&C1&C&B1&B&A1&!A|F&E&D2&D1&!D&C1&C&B1&B&A1&!A|F&!E&D2&D1&!D&C1&C&B1&B&A1&!A|F&!E&D2&!D1&!D&C1&C&B1&B&A1&!A|F&E&D2&!D1&!D&C1&C&B1&B&A1&!A|F&E&!D2&!D1&!D&C1&C&B1&B&A1&!A|F&!E&!D2&!D1&!D&C1&C&B1&B&A1&!A|F&!E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|F&E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|F&E&D2&!D1&!D&C1&!C&B1&B&A1&!A|F&!E&D2&!D1&!D&C1&!C&B1&B&A1&!A|F&!E&D2&D1&!D&C1&!C&B1&B&A1&!A|F&E&D2&D1&!D&C1&!C&B1&B&A1&!A|F&E&!D2&D1&!D&C1&!C&B1&B&A1&!A|F&!E&!D2&D1&!D&C1&!C&B1&B&A1&!A|F&!E&!D2&D1&D&C1&!C&B1&B&A1&!A|F&E&!D2&D1&D&C1&!C&B1&B&A1&!A|F&E&D2&D1&D&C1&!C&B1&B&A1&!A|F&!E&D2&D1&D&C1&!C&B1&B&A1&!A|F&!E&D2&!D1&D&C1&!C&B1&B&A1&!A|F&E&D2&!D1&D&C1&!C&B1&B&A1&!A|F&E&!D2&!D1&D&C1&!C&B1&B&A1&!A|F&!E&!D2&!D1&D&C1&!C&B1&B&A1&!A|F&E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|F&E&D2&!D1&D&!C1&!C&B1&B&A1&!A|F&!E&D2&D1&D&!C1&!C&B1&B&A1&!A|F&E&D2&D1&D&!C1&!C&B1&B&A1&!A|F&E&!D2&D1&D&!C1&!C&B1&B&A1&!A|F&E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|F&E&D2&D1&!D&!C1&!C&B1&B&A1&!A|F&E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|F&E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|F&E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|F&E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|F&E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|F&E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|F&E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|F&E&D2&D1&D&!C1&!C&B1&!B&A1&!A|F&!E&D2&D1&D&!C1&!C&B1&!B&A1&!A|F&E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|F&E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|F&!E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|F&E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|F&E&D2&!D1&D&C1&!C&B1&!B&A1&!A|F&!E&D2&!D1&D&C1&!C&B1&!B&A1&!A|F&!E&D2&D1&D&C1&!C&B1&!B&A1&!A|F&E&D2&D1&D&C1&!C&B1&!B&A1&!A|F&E&!D2&D1&D&C1&!C&B1&!B&A1&!A|F&!E&!D2&D1&D&C1&!C&B1&!B&A1&!A|F&!E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|F&E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|F&E&D2&D1&!D&C1&!C&B1&!B&A1&!A|F&!E&D2&D1&!D&C1&!C&B1&!B&A1&!A|F&!E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|F&E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|F&E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|F&!E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|F&!E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|F&E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|F&E&D2&!D1&!D&C1&C&B1&!B&A1&!A|F&!E&D2&!D1&!D&C1&C&B1&!B&A1&!A|F&!E&D2&D1&!D&C1&C&B1&!B&A1&!A|F&E&D2&D1&!D&C1&C&B1&!B&A1&!A|F&E&!D2&D1&!D&C1&C&B1&!B&A1&!A|F&!E&!D2&D1&!D&C1&C&B1&!B&A1&!A|F&!E&!D2&D1&D&C1&C&B1&!B&A1&!A|F&E&!D2&D1&D&C1&C&B1&!B&A1&!A|F&E&D2&D1&D&C1&C&B1&!B&A1&!A|F&!E&D2&D1&D&C1&C&B1&!B&A1&!A|F&!E&D2&!D1&D&C1&C&B1&!B&A1&!A|F&E&D2&!D1&D&C1&C&B1&!B&A1&!A|F&E&!D2&!D1&D&C1&C&B1&!B&A1&!A|F&!E&!D2&!D1&D&C1&C&B1&!B&A1&!A|F&!E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|F&E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|F&E&D2&!D1&D&!C1&C&B1&!B&A1&!A|F&!E&D2&!D1&D&!C1&C&B1&!B&A1&!A|F&!E&D2&D1&D&!C1&C&B1&!B&A1&!A|F&E&D2&D1&D&!C1&C&B1&!B&A1&!A|F&E&!D2&D1&D&!C1&C&B1&!B&A1&!A|F&!E&!D2&D1&D&!C1&C&B1&!B&A1&!A|F&!E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|F&E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|F&E&D2&D1&!D&!C1&C&B1&!B&A1&!A|F&!E&D2&D1&!D&!C1&C&B1&!B&A1&!A|F&!E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|F&E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|F&E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|F&!E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|F&E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|F&E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|F&E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|F&E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|F&E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|F&E&D2&D1&D&!C1&C&!B1&!B&A1&!A|F&!E&D2&D1&D&!C1&C&!B1&!B&A1&!A|F&E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|F&E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|F&E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|F&E&D2&!D1&D&C1&C&!B1&!B&A1&!A|F&!E&D2&D1&D&C1&C&!B1&!B&A1&!A|F&E&D2&D1&D&C1&C&!B1&!B&A1&!A|F&E&!D2&D1&D&C1&C&!B1&!B&A1&!A|F&E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|F&E&D2&D1&!D&C1&C&!B1&!B&A1&!A|F&E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|F&E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|F&E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|F&E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|F&E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|F&E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|F&E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|F&E&D2&D1&D&C1&!C&!B1&!B&A1&!A|F&!E&D2&D1&D&C1&!C&!B1&!B&A1&!A|F&E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|F&E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|F&E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|F&E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|F&!E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|F&E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|F&E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|F&E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|F&E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|F&E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|F&E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|F&E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|F&E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|F&E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|F&E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|F&E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|F&E&D2&D1&D&!C1&!C&!B1&!B&A1&A|F&!E&D2&D1&D&!C1&!C&!B1&!B&A1&A|F&E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|F&E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|F&E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|F&E&D2&!D1&D&C1&!C&!B1&!B&A1&A|F&!E&D2&D1&D&C1&!C&!B1&!B&A1&A|F&E&D2&D1&D&C1&!C&!B1&!B&A1&A|F&E&!D2&D1&D&C1&!C&!B1&!B&A1&A|F&E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|F&E&D2&D1&!D&C1&!C&!B1&!B&A1&A|F&E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|F&E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|F&E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|F&E&D2&!D1&!D&C1&C&!B1&!B&A1&A|F&E&D2&D1&!D&C1&C&!B1&!B&A1&A|F&E&!D2&D1&!D&C1&C&!B1&!B&A1&A|F&E&!D2&D1&D&C1&C&!B1&!B&A1&A|F&E&D2&D1&D&C1&C&!B1&!B&A1&A|F&!E&D2&D1&D&C1&C&!B1&!B&A1&A|F&E&D2&!D1&D&C1&C&!B1&!B&A1&A|F&E&!D2&!D1&D&C1&C&!B1&!B&A1&A|F&E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|F&E&D2&!D1&D&!C1&C&!B1&!B&A1&A|F&!E&D2&D1&D&!C1&C&!B1&!B&A1&A|F&E&D2&D1&D&!C1&C&!B1&!B&A1&A|F&E&!D2&D1&D&!C1&C&!B1&!B&A1&A|F&E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|F&E&D2&D1&!D&!C1&C&!B1&!B&A1&A|F&E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|F&E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|F&!E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|F&E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|F&E&D2&!D1&!D&!C1&C&B1&!B&A1&A|F&!E&D2&!D1&!D&!C1&C&B1&!B&A1&A|F&!E&D2&D1&!D&!C1&C&B1&!B&A1&A|F&E&D2&D1&!D&!C1&C&B1&!B&A1&A|F&E&!D2&D1&!D&!C1&C&B1&!B&A1&A|F&!E&!D2&D1&!D&!C1&C&B1&!B&A1&A|F&!E&!D2&D1&D&!C1&C&B1&!B&A1&A|F&E&!D2&D1&D&!C1&C&B1&!B&A1&A|F&E&D2&D1&D&!C1&C&B1&!B&A1&A|F&!E&D2&D1&D&!C1&C&B1&!B&A1&A|F&!E&D2&!D1&D&!C1&C&B1&!B&A1&A|F&E&D2&!D1&D&!C1&C&B1&!B&A1&A|F&E&!D2&!D1&D&!C1&C&B1&!B&A1&A|F&!E&!D2&!D1&D&!C1&C&B1&!B&A1&A|F&!E&!D2&!D1&D&C1&C&B1&!B&A1&A|F&E&!D2&!D1&D&C1&C&B1&!B&A1&A|F&E&D2&!D1&D&C1&C&B1&!B&A1&A|F&!E&D2&!D1&D&C1&C&B1&!B&A1&A|F&!E&D2&D1&D&C1&C&B1&!B&A1&A|F&E&D2&D1&D&C1&C&B1&!B&A1&A|F&E&!D2&D1&D&C1&C&B1&!B&A1&A|F&!E&!D2&D1&D&C1&C&B1&!B&A1&A|F&!E&!D2&D1&!D&C1&C&B1&!B&A1&A|F&E&!D2&D1&!D&C1&C&B1&!B&A1&A|F&E&D2&D1&!D&C1&C&B1&!B&A1&A|F&!E&D2&D1&!D&C1&C&B1&!B&A1&A|F&!E&D2&!D1&!D&C1&C&B1&!B&A1&A|F&E&D2&!D1&!D&C1&C&B1&!B&A1&A|F&E&!D2&!D1&!D&C1&C&B1&!B&A1&A|F&!E&!D2&!D1&!D&C1&C&B1&!B&A1&A|F&!E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|F&E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|F&E&D2&!D1&!D&C1&!C&B1&!B&A1&A|F&!E&D2&!D1&!D&C1&!C&B1&!B&A1&A|F&!E&D2&D1&!D&C1&!C&B1&!B&A1&A|F&E&D2&D1&!D&C1&!C&B1&!B&A1&A|F&E&!D2&D1&!D&C1&!C&B1&!B&A1&A|F&!E&!D2&D1&!D&C1&!C&B1&!B&A1&A|F&!E&!D2&D1&D&C1&!C&B1&!B&A1&A|F&E&!D2&D1&D&C1&!C&B1&!B&A1&A|F&E&D2&D1&D&C1&!C&B1&!B&A1&A|F&!E&D2&D1&D&C1&!C&B1&!B&A1&A|F&!E&D2&!D1&D&C1&!C&B1&!B&A1&A|F&E&D2&!D1&D&C1&!C&B1&!B&A1&A|F&E&!D2&!D1&D&C1&!C&B1&!B&A1&A|F&!E&!D2&!D1&D&C1&!C&B1&!B&A1&A|F&E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|F&E&D2&!D1&D&!C1&!C&B1&!B&A1&A|F&!E&D2&D1&D&!C1&!C&B1&!B&A1&A|F&E&D2&D1&D&!C1&!C&B1&!B&A1&A|F&E&!D2&D1&D&!C1&!C&B1&!B&A1&A|F&E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|F&E&D2&D1&!D&!C1&!C&B1&!B&A1&A|F&E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|F&E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|F&E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|F&E&D2&!D1&!D&!C1&!C&B1&B&A1&A|F&E&D2&D1&!D&!C1&!C&B1&B&A1&A|F&E&!D2&D1&!D&!C1&!C&B1&B&A1&A|F&E&!D2&D1&D&!C1&!C&B1&B&A1&A|F&E&D2&D1&D&!C1&!C&B1&B&A1&A|F&!E&D2&D1&D&!C1&!C&B1&B&A1&A|F&E&D2&!D1&D&!C1&!C&B1&B&A1&A|F&E&!D2&!D1&D&!C1&!C&B1&B&A1&A|F&!E&!D2&!D1&D&C1&!C&B1&B&A1&A|F&E&!D2&!D1&D&C1&!C&B1&B&A1&A|F&E&D2&!D1&D&C1&!C&B1&B&A1&A|F&!E&D2&!D1&D&C1&!C&B1&B&A1&A|F&!E&D2&D1&D&C1&!C&B1&B&A1&A|F&E&D2&D1&D&C1&!C&B1&B&A1&A|F&E&!D2&D1&D&C1&!C&B1&B&A1&A|F&!E&!D2&D1&D&C1&!C&B1&B&A1&A|F&!E&!D2&D1&!D&C1&!C&B1&B&A1&A|F&E&!D2&D1&!D&C1&!C&B1&B&A1&A|F&E&D2&D1&!D&C1&!C&B1&B&A1&A|F&!E&D2&D1&!D&C1&!C&B1&B&A1&A|F&!E&D2&!D1&!D&C1&!C&B1&B&A1&A|F&E&D2&!D1&!D&C1&!C&B1&B&A1&A|F&E&!D2&!D1&!D&C1&!C&B1&B&A1&A|F&!E&!D2&!D1&!D&C1&!C&B1&B&A1&A|F&!E&!D2&!D1&!D&C1&C&B1&B&A1&A|F&E&!D2&!D1&!D&C1&C&B1&B&A1&A|F&E&D2&!D1&!D&C1&C&B1&B&A1&A|F&!E&D2&!D1&!D&C1&C&B1&B&A1&A|F&!E&D2&D1&!D&C1&C&B1&B&A1&A|F&E&D2&D1&!D&C1&C&B1&B&A1&A|F&E&!D2&D1&!D&C1&C&B1&B&A1&A|F&!E&!D2&D1&!D&C1&C&B1&B&A1&A|F&!E&!D2&D1&D&C1&C&B1&B&A1&A|F&E&!D2&D1&D&C1&C&B1&B&A1&A|F&E&D2&D1&D&C1&C&B1&B&A1&A|F&!E&D2&D1&D&C1&C&B1&B&A1&A|F&!E&D2&!D1&D&C1&C&B1&B&A1&A|F&E&D2&!D1&D&C1&C&B1&B&A1&A|F&E&!D2&!D1&D&C1&C&B1&B&A1&A|F&!E&!D2&!D1&D&C1&C&B1&B&A1&A|F&!E&!D2&!D1&D&!C1&C&B1&B&A1&A|F&E&!D2&!D1&D&!C1&C&B1&B&A1&A|F&E&D2&!D1&D&!C1&C&B1&B&A1&A|F&!E&D2&!D1&D&!C1&C&B1&B&A1&A|F&!E&D2&D1&D&!C1&C&B1&B&A1&A|F&E&D2&D1&D&!C1&C&B1&B&A1&A|F&E&!D2&D1&D&!C1&C&B1&B&A1&A|F&!E&!D2&D1&D&!C1&C&B1&B&A1&A|F&!E&!D2&D1&!D&!C1&C&B1&B&A1&A|F&E&!D2&D1&!D&!C1&C&B1&B&A1&A|F&E&D2&D1&!D&!C1&C&B1&B&A1&A|F&!E&D2&D1&!D&!C1&C&B1&B&A1&A|F&!E&D2&!D1&!D&!C1&C&B1&B&A1&A|F&E&D2&!D1&!D&!C1&C&B1&B&A1&A|F&E&!D2&!D1&!D&!C1&C&B1&B&A1&A|F&!E&!D2&!D1&!D&!C1&C&B1&B&A1&A|F&!E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|F&E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|F&E&D2&!D1&!D&!C1&C&!B1&B&A1&A|F&!E&D2&!D1&!D&!C1&C&!B1&B&A1&A|F&!E&D2&D1&!D&!C1&C&!B1&B&A1&A|F&E&D2&D1&!D&!C1&C&!B1&B&A1&A|F&E&!D2&D1&!D&!C1&C&!B1&B&A1&A|F&!E&!D2&D1&!D&!C1&C&!B1&B&A1&A|F&!E&!D2&D1&D&!C1&C&!B1&B&A1&A|F&E&!D2&D1&D&!C1&C&!B1&B&A1&A|F&E&D2&D1&D&!C1&C&!B1&B&A1&A|F&!E&D2&D1&D&!C1&C&!B1&B&A1&A|F&!E&D2&!D1&D&!C1&C&!B1&B&A1&A|F&E&D2&!D1&D&!C1&C&!B1&B&A1&A|F&E&!D2&!D1&D&!C1&C&!B1&B&A1&A|F&!E&!D2&!D1&D&!C1&C&!B1&B&A1&A|F&!E&!D2&!D1&D&C1&C&!B1&B&A1&A|F&E&!D2&!D1&D&C1&C&!B1&B&A1&A|F&E&D2&!D1&D&C1&C&!B1&B&A1&A|F&!E&D2&!D1&D&C1&C&!B1&B&A1&A|F&!E&D2&D1&D&C1&C&!B1&B&A1&A|F&E&D2&D1&D&C1&C&!B1&B&A1&A|F&E&!D2&D1&D&C1&C&!B1&B&A1&A|F&!E&!D2&D1&D&C1&C&!B1&B&A1&A|F&!E&!D2&D1&!D&C1&C&!B1&B&A1&A|F&E&!D2&D1&!D&C1&C&!B1&B&A1&A|F&E&D2&D1&!D&C1&C&!B1&B&A1&A|F&!E&D2&D1&!D&C1&C&!B1&B&A1&A|F&!E&D2&!D1&!D&C1&C&!B1&B&A1&A|F&E&D2&!D1&!D&C1&C&!B1&B&A1&A|F&E&!D2&!D1&!D&C1&C&!B1&B&A1&A|F&!E&!D2&!D1&!D&C1&C&!B1&B&A1&A|F&!E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|F&E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|F&E&D2&!D1&!D&C1&!C&!B1&B&A1&A|F&!E&D2&!D1&!D&C1&!C&!B1&B&A1&A|F&!E&D2&D1&!D&C1&!C&!B1&B&A1&A|F&E&D2&D1&!D&C1&!C&!B1&B&A1&A|F&E&!D2&D1&!D&C1&!C&!B1&B&A1&A|F&!E&!D2&D1&!D&C1&!C&!B1&B&A1&A|F&!E&!D2&D1&D&C1&!C&!B1&B&A1&A|F&E&!D2&D1&D&C1&!C&!B1&B&A1&A|F&E&D2&D1&D&C1&!C&!B1&B&A1&A|F&!E&D2&D1&D&C1&!C&!B1&B&A1&A|F&!E&D2&!D1&D&C1&!C&!B1&B&A1&A|F&E&D2&!D1&D&C1&!C&!B1&B&A1&A|F&E&!D2&!D1&D&C1&!C&!B1&B&A1&A|F&!E&!D2&!D1&D&C1&!C&!B1&B&A1&A|F&E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|F&E&D2&!D1&D&!C1&!C&!B1&B&A1&A|F&!E&D2&D1&D&!C1&!C&!B1&B&A1&A|F&E&D2&D1&D&!C1&!C&!B1&B&A1&A|F&E&!D2&D1&D&!C1&!C&!B1&B&A1&A|F&E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|F&E&D2&D1&!D&!C1&!C&!B1&B&A1&A|F&E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|F&E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|F&E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|F&E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|F&E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|F&E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|F&E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|F&E&D2&D1&D&!C1&!C&!B1&B&!A1&A|F&!E&D2&D1&D&!C1&!C&!B1&B&!A1&A|F&E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|F&E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|F&!E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|F&E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|F&E&D2&!D1&D&C1&!C&!B1&B&!A1&A|F&!E&D2&!D1&D&C1&!C&!B1&B&!A1&A|F&!E&D2&D1&D&C1&!C&!B1&B&!A1&A|F&E&D2&D1&D&C1&!C&!B1&B&!A1&A|F&E&!D2&D1&D&C1&!C&!B1&B&!A1&A|F&!E&!D2&D1&D&C1&!C&!B1&B&!A1&A|F&!E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|F&E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|F&E&D2&D1&!D&C1&!C&!B1&B&!A1&A|F&!E&D2&D1&!D&C1&!C&!B1&B&!A1&A|F&!E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|F&E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|F&E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|F&!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|F&!E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|F&E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|F&E&D2&!D1&!D&C1&C&!B1&B&!A1&A|F&!E&D2&!D1&!D&C1&C&!B1&B&!A1&A|F&!E&D2&D1&!D&C1&C&!B1&B&!A1&A|F&E&D2&D1&!D&C1&C&!B1&B&!A1&A|F&E&!D2&D1&!D&C1&C&!B1&B&!A1&A|F&!E&!D2&D1&!D&C1&C&!B1&B&!A1&A|F&!E&!D2&D1&D&C1&C&!B1&B&!A1&A|F&E&!D2&D1&D&C1&C&!B1&B&!A1&A|F&E&D2&D1&D&C1&C&!B1&B&!A1&A|F&!E&D2&D1&D&C1&C&!B1&B&!A1&A|F&!E&D2&!D1&D&C1&C&!B1&B&!A1&A|F&E&D2&!D1&D&C1&C&!B1&B&!A1&A|F&E&!D2&!D1&D&C1&C&!B1&B&!A1&A|F&!E&!D2&!D1&D&C1&C&!B1&B&!A1&A|F&!E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|F&E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|F&E&D2&!D1&D&!C1&C&!B1&B&!A1&A|F&!E&D2&!D1&D&!C1&C&!B1&B&!A1&A|F&!E&D2&D1&D&!C1&C&!B1&B&!A1&A|F&E&D2&D1&D&!C1&C&!B1&B&!A1&A|F&E&!D2&D1&D&!C1&C&!B1&B&!A1&A|F&!E&!D2&D1&D&!C1&C&!B1&B&!A1&A|F&!E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|F&E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|F&E&D2&D1&!D&!C1&C&!B1&B&!A1&A|F&!E&D2&D1&!D&!C1&C&!B1&B&!A1&A|F&!E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|F&E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|F&E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|F&!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|F&!E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|F&E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|F&E&D2&!D1&!D&!C1&C&B1&B&!A1&A|F&!E&D2&!D1&!D&!C1&C&B1&B&!A1&A|F&!E&D2&D1&!D&!C1&C&B1&B&!A1&A|F&E&D2&D1&!D&!C1&C&B1&B&!A1&A|F&E&!D2&D1&!D&!C1&C&B1&B&!A1&A|F&!E&!D2&D1&!D&!C1&C&B1&B&!A1&A|F&!E&!D2&D1&D&!C1&C&B1&B&!A1&A|F&E&!D2&D1&D&!C1&C&B1&B&!A1&A|F&E&D2&D1&D&!C1&C&B1&B&!A1&A|F&!E&D2&D1&D&!C1&C&B1&B&!A1&A|F&!E&D2&!D1&D&!C1&C&B1&B&!A1&A|F&E&D2&!D1&D&!C1&C&B1&B&!A1&A|F&E&!D2&!D1&D&!C1&C&B1&B&!A1&A|F&!E&!D2&!D1&D&!C1&C&B1&B&!A1&A|F&!E&!D2&!D1&D&C1&C&B1&B&!A1&A|F&E&!D2&!D1&D&C1&C&B1&B&!A1&A|F&E&D2&!D1&D&C1&C&B1&B&!A1&A|F&!E&D2&!D1&D&C1&C&B1&B&!A1&A|F&!E&D2&D1&D&C1&C&B1&B&!A1&A|F&E&D2&D1&D&C1&C&B1&B&!A1&A|F&E&!D2&D1&D&C1&C&B1&B&!A1&A|F&!E&!D2&D1&D&C1&C&B1&B&!A1&A|F&!E&!D2&D1&!D&C1&C&B1&B&!A1&A|F&E&!D2&D1&!D&C1&C&B1&B&!A1&A|F&E&D2&D1&!D&C1&C&B1&B&!A1&A|F&!E&D2&D1&!D&C1&C&B1&B&!A1&A|F&!E&D2&!D1&!D&C1&C&B1&B&!A1&A|F&E&D2&!D1&!D&C1&C&B1&B&!A1&A|F&E&!D2&!D1&!D&C1&C&B1&B&!A1&A|F&!E&!D2&!D1&!D&C1&C&B1&B&!A1&A|F&!E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|F&E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|F&E&D2&!D1&!D&C1&!C&B1&B&!A1&A|F&!E&D2&!D1&!D&C1&!C&B1&B&!A1&A|F&!E&D2&D1&!D&C1&!C&B1&B&!A1&A|F&E&D2&D1&!D&C1&!C&B1&B&!A1&A|F&E&!D2&D1&!D&C1&!C&B1&B&!A1&A|F&!E&!D2&D1&!D&C1&!C&B1&B&!A1&A|F&!E&!D2&D1&D&C1&!C&B1&B&!A1&A|F&E&!D2&D1&D&C1&!C&B1&B&!A1&A|F&E&D2&D1&D&C1&!C&B1&B&!A1&A|F&!E&D2&D1&D&C1&!C&B1&B&!A1&A|F&!E&D2&!D1&D&C1&!C&B1&B&!A1&A|F&E&D2&!D1&D&C1&!C&B1&B&!A1&A|F&E&!D2&!D1&D&C1&!C&B1&B&!A1&A|F&!E&!D2&!D1&D&C1&!C&B1&B&!A1&A|F&E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|F&E&D2&!D1&D&!C1&!C&B1&B&!A1&A|F&!E&D2&D1&D&!C1&!C&B1&B&!A1&A|F&E&D2&D1&D&!C1&!C&B1&B&!A1&A|F&E&!D2&D1&D&!C1&!C&B1&B&!A1&A|F&E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|F&E&D2&D1&!D&!C1&!C&B1&B&!A1&A|F&E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|F&E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|F&E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|F&E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|F&E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|F&E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|F&E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|F&E&D2&D1&D&!C1&!C&B1&!B&!A1&A|F&!E&D2&D1&D&!C1&!C&B1&!B&!A1&A|F&E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|F&E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|F&!E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|F&E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|F&E&D2&!D1&D&C1&!C&B1&!B&!A1&A|F&!E&D2&!D1&D&C1&!C&B1&!B&!A1&A|F&!E&D2&D1&D&C1&!C&B1&!B&!A1&A|F&E&D2&D1&D&C1&!C&B1&!B&!A1&A|F&E&!D2&D1&D&C1&!C&B1&!B&!A1&A|F&!E&!D2&D1&D&C1&!C&B1&!B&!A1&A|F&!E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|F&E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|F&E&D2&D1&!D&C1&!C&B1&!B&!A1&A|F&!E&D2&D1&!D&C1&!C&B1&!B&!A1&A|F&!E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|F&E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|F&E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|F&!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|F&!E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|F&E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|F&E&D2&!D1&!D&C1&C&B1&!B&!A1&A|F&!E&D2&!D1&!D&C1&C&B1&!B&!A1&A|F&!E&D2&D1&!D&C1&C&B1&!B&!A1&A|F&E&D2&D1&!D&C1&C&B1&!B&!A1&A|F&E&!D2&D1&!D&C1&C&B1&!B&!A1&A|F&!E&!D2&D1&!D&C1&C&B1&!B&!A1&A|F&!E&!D2&D1&D&C1&C&B1&!B&!A1&A|F&E&!D2&D1&D&C1&C&B1&!B&!A1&A|F&E&D2&D1&D&C1&C&B1&!B&!A1&A|F&!E&D2&D1&D&C1&C&B1&!B&!A1&A|F&!E&D2&!D1&D&C1&C&B1&!B&!A1&A|F&E&D2&!D1&D&C1&C&B1&!B&!A1&A|F&E&!D2&!D1&D&C1&C&B1&!B&!A1&A|F&!E&!D2&!D1&D&C1&C&B1&!B&!A1&A|F&!E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|F&E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|F&E&D2&!D1&D&!C1&C&B1&!B&!A1&A|F&!E&D2&!D1&D&!C1&C&B1&!B&!A1&A|F&!E&D2&D1&D&!C1&C&B1&!B&!A1&A|F&E&D2&D1&D&!C1&C&B1&!B&!A1&A|F&E&!D2&D1&D&!C1&C&B1&!B&!A1&A|F&!E&!D2&D1&D&!C1&C&B1&!B&!A1&A|F&!E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|F&E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|F&E&D2&D1&!D&!C1&C&B1&!B&!A1&A|F&!E&D2&D1&!D&!C1&C&B1&!B&!A1&A|F&!E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|F&E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|F&E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|F&!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|F&E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|F&E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|F&E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|F&E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|F&E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|F&E&D2&D1&D&!C1&C&!B1&!B&!A1&A|F&!E&D2&D1&D&!C1&C&!B1&!B&!A1&A|F&E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|F&E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|F&E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|F&E&D2&!D1&D&C1&C&!B1&!B&!A1&A|F&!E&D2&D1&D&C1&C&!B1&!B&!A1&A|F&E&D2&D1&D&C1&C&!B1&!B&!A1&A|F&E&!D2&D1&D&C1&C&!B1&!B&!A1&A|F&E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|F&E&D2&D1&!D&C1&C&!B1&!B&!A1&A|F&E&D2&!D1&!D&C1&C&!B1&!B&!A1&A|F&E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|F&E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|F&E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|F&E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|F&E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|F&E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|F&E&D2&D1&D&C1&!C&!B1&!B&!A1&A|F&!E&D2&D1&D&C1&!C&!B1&!B&!A1&A|F&E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|F&E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|F&E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|F&E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|F&!E&D2&D1&D&!C1&!C&!B1&!B&!A1&A|F&E&D2&D1&D&!C1&!C&!B1&!B&!A1&A|F&E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|F&E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|F&E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|F&E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|F&E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAAOAI222311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOAAOI21232 -l OAAOOAAOI21232 -i E1 E D2 D1 D C1 C B A1 A -o Y -f Y=(!E1&!E&!D2&!D1&!D&!C1&!C&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&!B&!A1&!A|!E1&E&D2&!D1&!D&!C1&!C&!B&!A1&!A|E1&!E&D2&!D1&!D&!C1&!C&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&!B&!A1&!A|!E1&!E&D2&D1&!D&!C1&!C&!B&!A1&!A|E1&!E&D2&D1&!D&!C1&!C&!B&!A1&!A|!E1&E&D2&D1&!D&!C1&!C&!B&!A1&!A|!E1&E&!D2&D1&!D&!C1&!C&!B&!A1&!A|E1&!E&!D2&D1&!D&!C1&!C&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&!B&!A1&!A|!E1&!E&!D2&D1&D&!C1&!C&!B&!A1&!A|E1&!E&!D2&D1&D&!C1&!C&!B&!A1&!A|!E1&E&!D2&D1&D&!C1&!C&!B&!A1&!A|!E1&E&D2&D1&D&!C1&!C&!B&!A1&!A|E1&!E&D2&D1&D&!C1&!C&!B&!A1&!A|!E1&!E&D2&D1&D&!C1&!C&!B&!A1&!A|!E1&!E&D2&!D1&D&!C1&!C&!B&!A1&!A|E1&!E&D2&!D1&D&!C1&!C&!B&!A1&!A|!E1&E&D2&!D1&D&!C1&!C&!B&!A1&!A|!E1&E&!D2&!D1&D&!C1&!C&!B&!A1&!A|E1&!E&!D2&!D1&D&!C1&!C&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&!B&!A1&!A|!E1&!E&!D2&!D1&D&C1&!C&!B&!A1&!A|E1&!E&!D2&!D1&D&C1&!C&!B&!A1&!A|!E1&E&!D2&!D1&D&C1&!C&!B&!A1&!A|!E1&E&D2&!D1&D&C1&!C&!B&!A1&!A|E1&!E&D2&!D1&D&C1&!C&!B&!A1&!A|!E1&!E&D2&!D1&D&C1&!C&!B&!A1&!A|!E1&!E&D2&D1&D&C1&!C&!B&!A1&!A|E1&!E&D2&D1&D&C1&!C&!B&!A1&!A|!E1&E&D2&D1&D&C1&!C&!B&!A1&!A|!E1&E&!D2&D1&D&C1&!C&!B&!A1&!A|E1&!E&!D2&D1&D&C1&!C&!B&!A1&!A|!E1&!E&!D2&D1&D&C1&!C&!B&!A1&!A|!E1&!E&!D2&D1&!D&C1&!C&!B&!A1&!A|E1&!E&!D2&D1&!D&C1&!C&!B&!A1&!A|!E1&E&!D2&D1&!D&C1&!C&!B&!A1&!A|!E1&E&D2&D1&!D&C1&!C&!B&!A1&!A|E1&!E&D2&D1&!D&C1&!C&!B&!A1&!A|!E1&!E&D2&D1&!D&C1&!C&!B&!A1&!A|!E1&!E&D2&!D1&!D&C1&!C&!B&!A1&!A|E1&!E&D2&!D1&!D&C1&!C&!B&!A1&!A|!E1&E&D2&!D1&!D&C1&!C&!B&!A1&!A|!E1&E&!D2&!D1&!D&C1&!C&!B&!A1&!A|E1&!E&!D2&!D1&!D&C1&!C&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&C&!B&!A1&!A|E1&!E&!D2&!D1&!D&C1&C&!B&!A1&!A|!E1&E&!D2&!D1&!D&C1&C&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&C&!B&!A1&!A|E1&!E&!D2&!D1&D&!C1&C&!B&!A1&!A|!E1&E&!D2&!D1&D&!C1&C&!B&!A1&!A|!E1&E&D2&!D1&D&!C1&C&!B&!A1&!A|E1&!E&D2&!D1&D&!C1&C&!B&!A1&!A|!E1&!E&D2&!D1&D&!C1&C&!B&!A1&!A|!E1&!E&D2&D1&D&!C1&C&!B&!A1&!A|E1&!E&D2&D1&D&!C1&C&!B&!A1&!A|!E1&E&D2&D1&D&!C1&C&!B&!A1&!A|!E1&E&!D2&D1&D&!C1&C&!B&!A1&!A|E1&!E&!D2&D1&D&!C1&C&!B&!A1&!A|!E1&!E&!D2&D1&D&!C1&C&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&C&!B&!A1&!A|E1&!E&!D2&D1&!D&!C1&C&!B&!A1&!A|!E1&E&!D2&D1&!D&!C1&C&!B&!A1&!A|!E1&E&D2&D1&!D&!C1&C&!B&!A1&!A|E1&!E&D2&D1&!D&!C1&C&!B&!A1&!A|!E1&!E&D2&D1&!D&!C1&C&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&C&!B&!A1&!A|E1&!E&D2&!D1&!D&!C1&C&!B&!A1&!A|!E1&E&D2&!D1&!D&!C1&C&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&C&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&C&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&C&B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&C&B&!A1&!A|!E1&E&D2&!D1&!D&!C1&C&B&!A1&!A|E1&!E&D2&!D1&!D&!C1&C&B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&C&B&!A1&!A|!E1&!E&D2&D1&!D&!C1&C&B&!A1&!A|E1&!E&D2&D1&!D&!C1&C&B&!A1&!A|!E1&E&D2&D1&!D&!C1&C&B&!A1&!A|!E1&E&!D2&D1&!D&!C1&C&B&!A1&!A|E1&!E&!D2&D1&!D&!C1&C&B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&C&B&!A1&!A|!E1&!E&!D2&D1&D&!C1&C&B&!A1&!A|E1&!E&!D2&D1&D&!C1&C&B&!A1&!A|!E1&E&!D2&D1&D&!C1&C&B&!A1&!A|!E1&E&D2&D1&D&!C1&C&B&!A1&!A|E1&!E&D2&D1&D&!C1&C&B&!A1&!A|!E1&!E&D2&D1&D&!C1&C&B&!A1&!A|!E1&!E&D2&!D1&D&!C1&C&B&!A1&!A|E1&!E&D2&!D1&D&!C1&C&B&!A1&!A|!E1&E&D2&!D1&D&!C1&C&B&!A1&!A|!E1&E&!D2&!D1&D&!C1&C&B&!A1&!A|E1&!E&!D2&!D1&D&!C1&C&B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&C&B&!A1&!A|!E1&E&!D2&!D1&!D&C1&C&B&!A1&!A|E1&!E&!D2&!D1&!D&C1&C&B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&C&B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&B&!A1&!A|E1&!E&!D2&!D1&!D&C1&!C&B&!A1&!A|!E1&E&!D2&!D1&!D&C1&!C&B&!A1&!A|!E1&E&D2&!D1&!D&C1&!C&B&!A1&!A|E1&!E&D2&!D1&!D&C1&!C&B&!A1&!A|!E1&!E&D2&!D1&!D&C1&!C&B&!A1&!A|!E1&!E&D2&D1&!D&C1&!C&B&!A1&!A|E1&!E&D2&D1&!D&C1&!C&B&!A1&!A|!E1&E&D2&D1&!D&C1&!C&B&!A1&!A|!E1&E&!D2&D1&!D&C1&!C&B&!A1&!A|E1&!E&!D2&D1&!D&C1&!C&B&!A1&!A|!E1&!E&!D2&D1&!D&C1&!C&B&!A1&!A|!E1&!E&!D2&D1&D&C1&!C&B&!A1&!A|E1&!E&!D2&D1&D&C1&!C&B&!A1&!A|!E1&E&!D2&D1&D&C1&!C&B&!A1&!A|!E1&E&D2&D1&D&C1&!C&B&!A1&!A|E1&!E&D2&D1&D&C1&!C&B&!A1&!A|!E1&!E&D2&D1&D&C1&!C&B&!A1&!A|!E1&!E&D2&!D1&D&C1&!C&B&!A1&!A|E1&!E&D2&!D1&D&C1&!C&B&!A1&!A|!E1&E&D2&!D1&D&C1&!C&B&!A1&!A|!E1&E&!D2&!D1&D&C1&!C&B&!A1&!A|E1&!E&!D2&!D1&D&C1&!C&B&!A1&!A|!E1&!E&!D2&!D1&D&C1&!C&B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&B&!A1&!A|E1&!E&!D2&!D1&D&!C1&!C&B&!A1&!A|!E1&E&!D2&!D1&D&!C1&!C&B&!A1&!A|!E1&E&D2&!D1&D&!C1&!C&B&!A1&!A|E1&!E&D2&!D1&D&!C1&!C&B&!A1&!A|!E1&!E&D2&!D1&D&!C1&!C&B&!A1&!A|!E1&!E&D2&D1&D&!C1&!C&B&!A1&!A|E1&!E&D2&D1&D&!C1&!C&B&!A1&!A|!E1&E&D2&D1&D&!C1&!C&B&!A1&!A|!E1&E&!D2&D1&D&!C1&!C&B&!A1&!A|E1&!E&!D2&D1&D&!C1&!C&B&!A1&!A|!E1&!E&!D2&D1&D&!C1&!C&B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&B&!A1&!A|E1&!E&!D2&D1&!D&!C1&!C&B&!A1&!A|!E1&E&!D2&D1&!D&!C1&!C&B&!A1&!A|!E1&E&D2&D1&!D&!C1&!C&B&!A1&!A|E1&!E&D2&D1&!D&!C1&!C&B&!A1&!A|!E1&!E&D2&D1&!D&!C1&!C&B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&B&!A1&!A|E1&!E&D2&!D1&!D&!C1&!C&B&!A1&!A|!E1&E&D2&!D1&!D&!C1&!C&B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&B&A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&B&A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&B&A1&!A|!E1&E&!D2&!D1&!D&C1&!C&B&A1&!A|E1&!E&!D2&!D1&!D&C1&!C&B&A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&B&A1&!A|!E1&!E&!D2&!D1&!D&C1&C&B&A1&!A|E1&!E&!D2&!D1&!D&C1&C&B&A1&!A|!E1&E&!D2&!D1&!D&C1&C&B&A1&!A|!E1&E&!D2&!D1&!D&!C1&C&B&A1&!A|E1&!E&!D2&!D1&!D&!C1&C&B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&!B&A1&!A|E1&!E&!D2&!D1&!D&!C1&C&!B&A1&!A|!E1&E&!D2&!D1&!D&!C1&C&!B&A1&!A|!E1&E&D2&!D1&!D&!C1&C&!B&A1&!A|E1&!E&D2&!D1&!D&!C1&C&!B&A1&!A|!E1&!E&D2&!D1&!D&!C1&C&!B&A1&!A|!E1&!E&D2&D1&!D&!C1&C&!B&A1&!A|E1&!E&D2&D1&!D&!C1&C&!B&A1&!A|!E1&E&D2&D1&!D&!C1&C&!B&A1&!A|!E1&E&!D2&D1&!D&!C1&C&!B&A1&!A|E1&!E&!D2&D1&!D&!C1&C&!B&A1&!A|!E1&!E&!D2&D1&!D&!C1&C&!B&A1&!A|!E1&!E&!D2&D1&D&!C1&C&!B&A1&!A|E1&!E&!D2&D1&D&!C1&C&!B&A1&!A|!E1&E&!D2&D1&D&!C1&C&!B&A1&!A|!E1&E&D2&D1&D&!C1&C&!B&A1&!A|E1&!E&D2&D1&D&!C1&C&!B&A1&!A|!E1&!E&D2&D1&D&!C1&C&!B&A1&!A|!E1&!E&D2&!D1&D&!C1&C&!B&A1&!A|E1&!E&D2&!D1&D&!C1&C&!B&A1&!A|!E1&E&D2&!D1&D&!C1&C&!B&A1&!A|!E1&E&!D2&!D1&D&!C1&C&!B&A1&!A|E1&!E&!D2&!D1&D&!C1&C&!B&A1&!A|!E1&!E&!D2&!D1&D&!C1&C&!B&A1&!A|!E1&E&!D2&!D1&!D&C1&C&!B&A1&!A|E1&!E&!D2&!D1&!D&C1&C&!B&A1&!A|!E1&!E&!D2&!D1&!D&C1&C&!B&A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&!B&A1&!A|E1&!E&!D2&!D1&!D&C1&!C&!B&A1&!A|!E1&E&!D2&!D1&!D&C1&!C&!B&A1&!A|!E1&E&D2&!D1&!D&C1&!C&!B&A1&!A|E1&!E&D2&!D1&!D&C1&!C&!B&A1&!A|!E1&!E&D2&!D1&!D&C1&!C&!B&A1&!A|!E1&!E&D2&D1&!D&C1&!C&!B&A1&!A|E1&!E&D2&D1&!D&C1&!C&!B&A1&!A|!E1&E&D2&D1&!D&C1&!C&!B&A1&!A|!E1&E&!D2&D1&!D&C1&!C&!B&A1&!A|E1&!E&!D2&D1&!D&C1&!C&!B&A1&!A|!E1&!E&!D2&D1&!D&C1&!C&!B&A1&!A|!E1&!E&!D2&D1&D&C1&!C&!B&A1&!A|E1&!E&!D2&D1&D&C1&!C&!B&A1&!A|!E1&E&!D2&D1&D&C1&!C&!B&A1&!A|!E1&E&D2&D1&D&C1&!C&!B&A1&!A|E1&!E&D2&D1&D&C1&!C&!B&A1&!A|!E1&!E&D2&D1&D&C1&!C&!B&A1&!A|!E1&!E&D2&!D1&D&C1&!C&!B&A1&!A|E1&!E&D2&!D1&D&C1&!C&!B&A1&!A|!E1&E&D2&!D1&D&C1&!C&!B&A1&!A|!E1&E&!D2&!D1&D&C1&!C&!B&A1&!A|E1&!E&!D2&!D1&D&C1&!C&!B&A1&!A|!E1&!E&!D2&!D1&D&C1&!C&!B&A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&!B&A1&!A|E1&!E&!D2&!D1&D&!C1&!C&!B&A1&!A|!E1&E&!D2&!D1&D&!C1&!C&!B&A1&!A|!E1&E&D2&!D1&D&!C1&!C&!B&A1&!A|E1&!E&D2&!D1&D&!C1&!C&!B&A1&!A|!E1&!E&D2&!D1&D&!C1&!C&!B&A1&!A|!E1&!E&D2&D1&D&!C1&!C&!B&A1&!A|E1&!E&D2&D1&D&!C1&!C&!B&A1&!A|!E1&E&D2&D1&D&!C1&!C&!B&A1&!A|!E1&E&!D2&D1&D&!C1&!C&!B&A1&!A|E1&!E&!D2&D1&D&!C1&!C&!B&A1&!A|!E1&!E&!D2&D1&D&!C1&!C&!B&A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&!B&A1&!A|E1&!E&!D2&D1&!D&!C1&!C&!B&A1&!A|!E1&E&!D2&D1&!D&!C1&!C&!B&A1&!A|!E1&E&D2&D1&!D&!C1&!C&!B&A1&!A|E1&!E&D2&D1&!D&!C1&!C&!B&A1&!A|!E1&!E&D2&D1&!D&!C1&!C&!B&A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&!B&A1&!A|E1&!E&D2&!D1&!D&!C1&!C&!B&A1&!A|!E1&E&D2&!D1&!D&!C1&!C&!B&A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&!B&A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&!B&A1&A|E1&!E&!D2&!D1&!D&!C1&!C&!B&A1&A|!E1&E&!D2&!D1&!D&!C1&!C&!B&A1&A|!E1&E&D2&!D1&!D&!C1&!C&!B&A1&A|E1&!E&D2&!D1&!D&!C1&!C&!B&A1&A|!E1&!E&D2&!D1&!D&!C1&!C&!B&A1&A|!E1&!E&D2&D1&!D&!C1&!C&!B&A1&A|E1&!E&D2&D1&!D&!C1&!C&!B&A1&A|!E1&E&D2&D1&!D&!C1&!C&!B&A1&A|!E1&E&!D2&D1&!D&!C1&!C&!B&A1&A|E1&!E&!D2&D1&!D&!C1&!C&!B&A1&A|!E1&!E&!D2&D1&!D&!C1&!C&!B&A1&A|!E1&!E&!D2&D1&D&!C1&!C&!B&A1&A|E1&!E&!D2&D1&D&!C1&!C&!B&A1&A|!E1&E&!D2&D1&D&!C1&!C&!B&A1&A|!E1&E&D2&D1&D&!C1&!C&!B&A1&A|E1&!E&D2&D1&D&!C1&!C&!B&A1&A|!E1&!E&D2&D1&D&!C1&!C&!B&A1&A|!E1&!E&D2&!D1&D&!C1&!C&!B&A1&A|E1&!E&D2&!D1&D&!C1&!C&!B&A1&A|!E1&E&D2&!D1&D&!C1&!C&!B&A1&A|!E1&E&!D2&!D1&D&!C1&!C&!B&A1&A|E1&!E&!D2&!D1&D&!C1&!C&!B&A1&A|!E1&!E&!D2&!D1&D&!C1&!C&!B&A1&A|!E1&!E&!D2&!D1&D&C1&!C&!B&A1&A|E1&!E&!D2&!D1&D&C1&!C&!B&A1&A|!E1&E&!D2&!D1&D&C1&!C&!B&A1&A|!E1&E&D2&!D1&D&C1&!C&!B&A1&A|E1&!E&D2&!D1&D&C1&!C&!B&A1&A|!E1&!E&D2&!D1&D&C1&!C&!B&A1&A|!E1&!E&D2&D1&D&C1&!C&!B&A1&A|E1&!E&D2&D1&D&C1&!C&!B&A1&A|!E1&E&D2&D1&D&C1&!C&!B&A1&A|!E1&E&!D2&D1&D&C1&!C&!B&A1&A|E1&!E&!D2&D1&D&C1&!C&!B&A1&A|!E1&!E&!D2&D1&D&C1&!C&!B&A1&A|!E1&!E&!D2&D1&!D&C1&!C&!B&A1&A|E1&!E&!D2&D1&!D&C1&!C&!B&A1&A|!E1&E&!D2&D1&!D&C1&!C&!B&A1&A|!E1&E&D2&D1&!D&C1&!C&!B&A1&A|E1&!E&D2&D1&!D&C1&!C&!B&A1&A|!E1&!E&D2&D1&!D&C1&!C&!B&A1&A|!E1&!E&D2&!D1&!D&C1&!C&!B&A1&A|E1&!E&D2&!D1&!D&C1&!C&!B&A1&A|!E1&E&D2&!D1&!D&C1&!C&!B&A1&A|!E1&E&!D2&!D1&!D&C1&!C&!B&A1&A|E1&!E&!D2&!D1&!D&C1&!C&!B&A1&A|!E1&!E&!D2&!D1&!D&C1&!C&!B&A1&A|!E1&!E&!D2&!D1&!D&C1&C&!B&A1&A|E1&!E&!D2&!D1&!D&C1&C&!B&A1&A|!E1&E&!D2&!D1&!D&C1&C&!B&A1&A|!E1&!E&!D2&!D1&D&!C1&C&!B&A1&A|E1&!E&!D2&!D1&D&!C1&C&!B&A1&A|!E1&E&!D2&!D1&D&!C1&C&!B&A1&A|!E1&E&D2&!D1&D&!C1&C&!B&A1&A|E1&!E&D2&!D1&D&!C1&C&!B&A1&A|!E1&!E&D2&!D1&D&!C1&C&!B&A1&A|!E1&!E&D2&D1&D&!C1&C&!B&A1&A|E1&!E&D2&D1&D&!C1&C&!B&A1&A|!E1&E&D2&D1&D&!C1&C&!B&A1&A|!E1&E&!D2&D1&D&!C1&C&!B&A1&A|E1&!E&!D2&D1&D&!C1&C&!B&A1&A|!E1&!E&!D2&D1&D&!C1&C&!B&A1&A|!E1&!E&!D2&D1&!D&!C1&C&!B&A1&A|E1&!E&!D2&D1&!D&!C1&C&!B&A1&A|!E1&E&!D2&D1&!D&!C1&C&!B&A1&A|!E1&E&D2&D1&!D&!C1&C&!B&A1&A|E1&!E&D2&D1&!D&!C1&C&!B&A1&A|!E1&!E&D2&D1&!D&!C1&C&!B&A1&A|!E1&!E&D2&!D1&!D&!C1&C&!B&A1&A|E1&!E&D2&!D1&!D&!C1&C&!B&A1&A|!E1&E&D2&!D1&!D&!C1&C&!B&A1&A|!E1&E&!D2&!D1&!D&!C1&C&!B&A1&A|E1&!E&!D2&!D1&!D&!C1&C&!B&A1&A|!E1&!E&!D2&!D1&!D&!C1&C&!B&A1&A|!E1&!E&!D2&!D1&!D&!C1&C&B&A1&A|E1&!E&!D2&!D1&!D&!C1&C&B&A1&A|!E1&E&!D2&!D1&!D&!C1&C&B&A1&A|!E1&E&!D2&!D1&!D&C1&C&B&A1&A|E1&!E&!D2&!D1&!D&C1&C&B&A1&A|!E1&!E&!D2&!D1&!D&C1&C&B&A1&A|!E1&!E&!D2&!D1&!D&C1&!C&B&A1&A|E1&!E&!D2&!D1&!D&C1&!C&B&A1&A|!E1&E&!D2&!D1&!D&C1&!C&B&A1&A|!E1&E&!D2&!D1&!D&!C1&!C&B&A1&A|E1&!E&!D2&!D1&!D&!C1&!C&B&A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&B&A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&B&!A1&A|E1&!E&!D2&!D1&!D&!C1&!C&B&!A1&A|!E1&E&!D2&!D1&!D&!C1&!C&B&!A1&A|!E1&E&!D2&!D1&!D&C1&!C&B&!A1&A|E1&!E&!D2&!D1&!D&C1&!C&B&!A1&A|!E1&!E&!D2&!D1&!D&C1&!C&B&!A1&A|!E1&!E&!D2&!D1&!D&C1&C&B&!A1&A|E1&!E&!D2&!D1&!D&C1&C&B&!A1&A|!E1&E&!D2&!D1&!D&C1&C&B&!A1&A|!E1&E&!D2&!D1&!D&!C1&C&B&!A1&A|E1&!E&!D2&!D1&!D&!C1&C&B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&C&B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&C&!B&!A1&A|E1&!E&!D2&!D1&!D&!C1&C&!B&!A1&A|!E1&E&!D2&!D1&!D&!C1&C&!B&!A1&A|!E1&E&D2&!D1&!D&!C1&C&!B&!A1&A|E1&!E&D2&!D1&!D&!C1&C&!B&!A1&A|!E1&!E&D2&!D1&!D&!C1&C&!B&!A1&A|!E1&!E&D2&D1&!D&!C1&C&!B&!A1&A|E1&!E&D2&D1&!D&!C1&C&!B&!A1&A|!E1&E&D2&D1&!D&!C1&C&!B&!A1&A|!E1&E&!D2&D1&!D&!C1&C&!B&!A1&A|E1&!E&!D2&D1&!D&!C1&C&!B&!A1&A|!E1&!E&!D2&D1&!D&!C1&C&!B&!A1&A|!E1&!E&!D2&D1&D&!C1&C&!B&!A1&A|E1&!E&!D2&D1&D&!C1&C&!B&!A1&A|!E1&E&!D2&D1&D&!C1&C&!B&!A1&A|!E1&E&D2&D1&D&!C1&C&!B&!A1&A|E1&!E&D2&D1&D&!C1&C&!B&!A1&A|!E1&!E&D2&D1&D&!C1&C&!B&!A1&A|!E1&!E&D2&!D1&D&!C1&C&!B&!A1&A|E1&!E&D2&!D1&D&!C1&C&!B&!A1&A|!E1&E&D2&!D1&D&!C1&C&!B&!A1&A|!E1&E&!D2&!D1&D&!C1&C&!B&!A1&A|E1&!E&!D2&!D1&D&!C1&C&!B&!A1&A|!E1&!E&!D2&!D1&D&!C1&C&!B&!A1&A|!E1&E&!D2&!D1&!D&C1&C&!B&!A1&A|E1&!E&!D2&!D1&!D&C1&C&!B&!A1&A|!E1&!E&!D2&!D1&!D&C1&C&!B&!A1&A|!E1&!E&!D2&!D1&!D&C1&!C&!B&!A1&A|E1&!E&!D2&!D1&!D&C1&!C&!B&!A1&A|!E1&E&!D2&!D1&!D&C1&!C&!B&!A1&A|!E1&E&D2&!D1&!D&C1&!C&!B&!A1&A|E1&!E&D2&!D1&!D&C1&!C&!B&!A1&A|!E1&!E&D2&!D1&!D&C1&!C&!B&!A1&A|!E1&!E&D2&D1&!D&C1&!C&!B&!A1&A|E1&!E&D2&D1&!D&C1&!C&!B&!A1&A|!E1&E&D2&D1&!D&C1&!C&!B&!A1&A|!E1&E&!D2&D1&!D&C1&!C&!B&!A1&A|E1&!E&!D2&D1&!D&C1&!C&!B&!A1&A|!E1&!E&!D2&D1&!D&C1&!C&!B&!A1&A|!E1&!E&!D2&D1&D&C1&!C&!B&!A1&A|E1&!E&!D2&D1&D&C1&!C&!B&!A1&A|!E1&E&!D2&D1&D&C1&!C&!B&!A1&A|!E1&E&D2&D1&D&C1&!C&!B&!A1&A|E1&!E&D2&D1&D&C1&!C&!B&!A1&A|!E1&!E&D2&D1&D&C1&!C&!B&!A1&A|!E1&!E&D2&!D1&D&C1&!C&!B&!A1&A|E1&!E&D2&!D1&D&C1&!C&!B&!A1&A|!E1&E&D2&!D1&D&C1&!C&!B&!A1&A|!E1&E&!D2&!D1&D&C1&!C&!B&!A1&A|E1&!E&!D2&!D1&D&C1&!C&!B&!A1&A|!E1&!E&!D2&!D1&D&C1&!C&!B&!A1&A|!E1&!E&!D2&!D1&D&!C1&!C&!B&!A1&A|E1&!E&!D2&!D1&D&!C1&!C&!B&!A1&A|!E1&E&!D2&!D1&D&!C1&!C&!B&!A1&A|!E1&E&D2&!D1&D&!C1&!C&!B&!A1&A|E1&!E&D2&!D1&D&!C1&!C&!B&!A1&A|!E1&!E&D2&!D1&D&!C1&!C&!B&!A1&A|!E1&!E&D2&D1&D&!C1&!C&!B&!A1&A|E1&!E&D2&D1&D&!C1&!C&!B&!A1&A|!E1&E&D2&D1&D&!C1&!C&!B&!A1&A|!E1&E&!D2&D1&D&!C1&!C&!B&!A1&A|E1&!E&!D2&D1&D&!C1&!C&!B&!A1&A|!E1&!E&!D2&D1&D&!C1&!C&!B&!A1&A|!E1&!E&!D2&D1&!D&!C1&!C&!B&!A1&A|E1&!E&!D2&D1&!D&!C1&!C&!B&!A1&A|!E1&E&!D2&D1&!D&!C1&!C&!B&!A1&A|!E1&E&D2&D1&!D&!C1&!C&!B&!A1&A|E1&!E&D2&D1&!D&!C1&!C&!B&!A1&A|!E1&!E&D2&D1&!D&!C1&!C&!B&!A1&A|!E1&!E&D2&!D1&!D&!C1&!C&!B&!A1&A|E1&!E&D2&!D1&!D&!C1&!C&!B&!A1&A|!E1&E&D2&!D1&!D&!C1&!C&!B&!A1&A|!E1&E&!D2&!D1&!D&!C1&!C&!B&!A1&A|E1&!E&!D2&!D1&!D&!C1&!C&!B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOAAOI21232.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOAAOI21113 -l OAOAAOI21113 -i E2 E1 E D C B A1 A -o Y -f Y=!(E2&E1&E&!D&!C&!B&!A1&!A|E2&E1&E&D&!C&!B&!A1&!A|!E2&!E1&!E&D&C&!B&!A1&!A|E2&!E1&!E&D&C&!B&!A1&!A|E2&E1&!E&D&C&!B&!A1&!A|!E2&E1&!E&D&C&!B&!A1&!A|!E2&E1&E&D&C&!B&!A1&!A|E2&E1&E&D&C&!B&!A1&!A|E2&!E1&E&D&C&!B&!A1&!A|!E2&!E1&E&D&C&!B&!A1&!A|E2&E1&E&!D&C&!B&!A1&!A|E2&E1&E&!D&C&B&!A1&!A|!E2&!E1&E&D&C&B&!A1&!A|E2&!E1&E&D&C&B&!A1&!A|E2&E1&E&D&C&B&!A1&!A|!E2&E1&E&D&C&B&!A1&!A|!E2&E1&!E&D&C&B&!A1&!A|E2&E1&!E&D&C&B&!A1&!A|E2&!E1&!E&D&C&B&!A1&!A|!E2&!E1&!E&D&C&B&!A1&!A|E2&E1&E&D&!C&B&!A1&!A|E2&E1&E&!D&!C&B&!A1&!A|E2&E1&E&!D&!C&B&A1&!A|!E2&!E1&E&D&!C&B&A1&!A|E2&!E1&E&D&!C&B&A1&!A|E2&E1&E&D&!C&B&A1&!A|!E2&E1&E&D&!C&B&A1&!A|!E2&E1&!E&D&!C&B&A1&!A|E2&E1&!E&D&!C&B&A1&!A|E2&!E1&!E&D&!C&B&A1&!A|!E2&!E1&!E&D&!C&B&A1&!A|!E2&!E1&!E&D&C&B&A1&!A|E2&!E1&!E&D&C&B&A1&!A|E2&E1&!E&D&C&B&A1&!A|!E2&E1&!E&D&C&B&A1&!A|!E2&E1&E&D&C&B&A1&!A|E2&E1&E&D&C&B&A1&!A|E2&!E1&E&D&C&B&A1&!A|!E2&!E1&E&D&C&B&A1&!A|E2&E1&E&!D&C&B&A1&!A|E2&E1&E&!D&C&!B&A1&!A|!E2&!E1&E&D&C&!B&A1&!A|E2&!E1&E&D&C&!B&A1&!A|E2&E1&E&D&C&!B&A1&!A|!E2&E1&E&D&C&!B&A1&!A|!E2&E1&!E&D&C&!B&A1&!A|E2&E1&!E&D&C&!B&A1&!A|E2&!E1&!E&D&C&!B&A1&!A|!E2&!E1&!E&D&C&!B&A1&!A|E2&E1&E&D&!C&!B&A1&!A|E2&E1&E&!D&!C&!B&A1&!A|E2&E1&E&!D&!C&!B&A1&A|E2&E1&E&D&!C&!B&A1&A|!E2&!E1&!E&D&C&!B&A1&A|E2&!E1&!E&D&C&!B&A1&A|E2&E1&!E&D&C&!B&A1&A|!E2&E1&!E&D&C&!B&A1&A|!E2&E1&E&D&C&!B&A1&A|E2&E1&E&D&C&!B&A1&A|E2&!E1&E&D&C&!B&A1&A|!E2&!E1&E&D&C&!B&A1&A|E2&E1&E&!D&C&!B&A1&A|E2&E1&E&!D&C&B&A1&A|!E2&!E1&E&D&C&B&A1&A|E2&!E1&E&D&C&B&A1&A|E2&E1&E&D&C&B&A1&A|!E2&E1&E&D&C&B&A1&A|!E2&E1&!E&D&C&B&A1&A|E2&E1&!E&D&C&B&A1&A|E2&!E1&!E&D&C&B&A1&A|!E2&!E1&!E&D&C&B&A1&A|!E2&!E1&!E&D&!C&B&A1&A|E2&!E1&!E&D&!C&B&A1&A|E2&E1&!E&D&!C&B&A1&A|!E2&E1&!E&D&!C&B&A1&A|!E2&E1&E&D&!C&B&A1&A|E2&E1&E&D&!C&B&A1&A|E2&!E1&E&D&!C&B&A1&A|!E2&!E1&E&D&!C&B&A1&A|E2&E1&E&!D&!C&B&A1&A|E2&E1&E&!D&!C&B&!A1&A|!E2&!E1&E&D&!C&B&!A1&A|E2&!E1&E&D&!C&B&!A1&A|E2&E1&E&D&!C&B&!A1&A|!E2&E1&E&D&!C&B&!A1&A|!E2&E1&!E&D&!C&B&!A1&A|E2&E1&!E&D&!C&B&!A1&A|E2&!E1&!E&D&!C&B&!A1&A|!E2&!E1&!E&D&!C&B&!A1&A|!E2&!E1&!E&D&C&B&!A1&A|E2&!E1&!E&D&C&B&!A1&A|E2&E1&!E&D&C&B&!A1&A|!E2&E1&!E&D&C&B&!A1&A|!E2&E1&E&D&C&B&!A1&A|E2&E1&E&D&C&B&!A1&A|E2&!E1&E&D&C&B&!A1&A|!E2&!E1&E&D&C&B&!A1&A|E2&E1&E&!D&C&B&!A1&A|E2&E1&E&!D&C&!B&!A1&A|!E2&!E1&E&D&C&!B&!A1&A|E2&!E1&E&D&C&!B&!A1&A|E2&E1&E&D&C&!B&!A1&A|!E2&E1&E&D&C&!B&!A1&A|!E2&E1&!E&D&C&!B&!A1&A|E2&E1&!E&D&C&!B&!A1&A|E2&!E1&!E&D&C&!B&!A1&A|!E2&!E1&!E&D&C&!B&!A1&A|E2&E1&E&D&!C&!B&!A1&A|E2&E1&E&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOAAOI21113.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOI22 -l AAOI22 -i B1 B A1 A -o Y -f Y=!(B1&B&!A1&!A|B1&B&A1&!A|!B1&!B&A1&A|B1&!B&A1&A|B1&B&A1&A|!B1&B&A1&A|B1&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOI22.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOI2114 -l AOAAOI2114 -i D3 D2 D1 D C B A1 A -o Y -f Y=!(D3&D2&D1&D&!C&!B&!A1&!A|D3&D2&D1&D&C&!B&!A1&!A|!D3&!D2&!D1&!D&C&B&!A1&!A|D3&!D2&!D1&!D&C&B&!A1&!A|D3&D2&!D1&!D&C&B&!A1&!A|!D3&D2&!D1&!D&C&B&!A1&!A|!D3&D2&D1&!D&C&B&!A1&!A|D3&D2&D1&!D&C&B&!A1&!A|D3&!D2&D1&!D&C&B&!A1&!A|!D3&!D2&D1&!D&C&B&!A1&!A|!D3&!D2&D1&D&C&B&!A1&!A|D3&!D2&D1&D&C&B&!A1&!A|D3&D2&D1&D&C&B&!A1&!A|!D3&D2&D1&D&C&B&!A1&!A|!D3&D2&!D1&D&C&B&!A1&!A|D3&D2&!D1&D&C&B&!A1&!A|D3&!D2&!D1&D&C&B&!A1&!A|!D3&!D2&!D1&D&C&B&!A1&!A|D3&D2&D1&D&!C&B&!A1&!A|D3&D2&D1&D&!C&B&A1&!A|!D3&!D2&!D1&D&C&B&A1&!A|D3&!D2&!D1&D&C&B&A1&!A|D3&D2&!D1&D&C&B&A1&!A|!D3&D2&!D1&D&C&B&A1&!A|!D3&D2&D1&D&C&B&A1&!A|D3&D2&D1&D&C&B&A1&!A|D3&!D2&D1&D&C&B&A1&!A|!D3&!D2&D1&D&C&B&A1&!A|!D3&!D2&D1&!D&C&B&A1&!A|D3&!D2&D1&!D&C&B&A1&!A|D3&D2&D1&!D&C&B&A1&!A|!D3&D2&D1&!D&C&B&A1&!A|!D3&D2&!D1&!D&C&B&A1&!A|D3&D2&!D1&!D&C&B&A1&!A|D3&!D2&!D1&!D&C&B&A1&!A|!D3&!D2&!D1&!D&C&B&A1&!A|D3&D2&D1&D&C&!B&A1&!A|D3&D2&D1&D&!C&!B&A1&!A|D3&D2&D1&D&!C&!B&A1&A|!D3&!D2&!D1&D&C&!B&A1&A|D3&!D2&!D1&D&C&!B&A1&A|D3&D2&!D1&D&C&!B&A1&A|!D3&D2&!D1&D&C&!B&A1&A|!D3&D2&D1&D&C&!B&A1&A|D3&D2&D1&D&C&!B&A1&A|D3&!D2&D1&D&C&!B&A1&A|!D3&!D2&D1&D&C&!B&A1&A|!D3&!D2&D1&!D&C&!B&A1&A|D3&!D2&D1&!D&C&!B&A1&A|D3&D2&D1&!D&C&!B&A1&A|!D3&D2&D1&!D&C&!B&A1&A|!D3&D2&!D1&!D&C&!B&A1&A|D3&D2&!D1&!D&C&!B&A1&A|D3&!D2&!D1&!D&C&!B&A1&A|!D3&!D2&!D1&!D&C&!B&A1&A|!D3&!D2&!D1&!D&C&B&A1&A|D3&!D2&!D1&!D&C&B&A1&A|D3&D2&!D1&!D&C&B&A1&A|!D3&D2&!D1&!D&C&B&A1&A|!D3&D2&D1&!D&C&B&A1&A|D3&D2&D1&!D&C&B&A1&A|D3&!D2&D1&!D&C&B&A1&A|!D3&!D2&D1&!D&C&B&A1&A|!D3&!D2&D1&D&C&B&A1&A|D3&!D2&D1&D&C&B&A1&A|D3&D2&D1&D&C&B&A1&A|!D3&D2&D1&D&C&B&A1&A|!D3&D2&!D1&D&C&B&A1&A|D3&D2&!D1&D&C&B&A1&A|D3&!D2&!D1&D&C&B&A1&A|!D3&!D2&!D1&D&C&B&A1&A|D3&D2&D1&D&!C&B&A1&A|D3&D2&D1&D&!C&B&!A1&A|!D3&!D2&!D1&D&C&B&!A1&A|D3&!D2&!D1&D&C&B&!A1&A|D3&D2&!D1&D&C&B&!A1&A|!D3&D2&!D1&D&C&B&!A1&A|!D3&D2&D1&D&C&B&!A1&A|D3&D2&D1&D&C&B&!A1&A|D3&!D2&D1&D&C&B&!A1&A|!D3&!D2&D1&D&C&B&!A1&A|!D3&!D2&D1&!D&C&B&!A1&A|D3&!D2&D1&!D&C&B&!A1&A|D3&D2&D1&!D&C&B&!A1&A|!D3&D2&D1&!D&C&B&!A1&A|!D3&D2&!D1&!D&C&B&!A1&A|D3&D2&!D1&!D&C&B&!A1&A|D3&!D2&!D1&!D&C&B&!A1&A|!D3&!D2&!D1&!D&C&B&!A1&A|D3&D2&D1&D&C&!B&!A1&A|D3&D2&D1&D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOI2114.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAAOI22132 -l AAOOAAOI22132 -i E1 E D2 D1 D C B1 B A1 A -o Y -f Y=(!E1&!E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!E1&E&D2&!D1&!D&!C&!B1&!B&!A1&!A|E1&!E&D2&!D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&D2&D1&!D&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&!D&!C&!B1&!B&!A1&!A|!E1&E&D2&D1&!D&!C&!B1&!B&!A1&!A|!E1&E&!D2&D1&!D&!C&!B1&!B&!A1&!A|E1&!E&!D2&D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&D&!C&!B1&!B&!A1&!A|E1&!E&!D2&D1&D&!C&!B1&!B&!A1&!A|!E1&E&!D2&D1&D&!C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&!C&!B1&!B&!A1&!A|!E1&!E&D2&D1&D&!C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&D&!C&!B1&!B&!A1&!A|E1&!E&D2&!D1&D&!C&!B1&!B&!A1&!A|!E1&E&D2&!D1&D&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&D&!C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&D&!C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C&B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&C&B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C&B1&!B&!A1&!A|E1&!E&!D2&!D1&D&!C&B1&!B&!A1&!A|!E1&E&!D2&!D1&D&!C&B1&!B&!A1&!A|!E1&E&D2&!D1&D&!C&B1&!B&!A1&!A|E1&!E&D2&!D1&D&!C&B1&!B&!A1&!A|!E1&!E&D2&!D1&D&!C&B1&!B&!A1&!A|!E1&!E&D2&D1&D&!C&B1&!B&!A1&!A|E1&!E&D2&D1&D&!C&B1&!B&!A1&!A|!E1&E&D2&D1&D&!C&B1&!B&!A1&!A|!E1&E&!D2&D1&D&!C&B1&!B&!A1&!A|E1&!E&!D2&D1&D&!C&B1&!B&!A1&!A|!E1&!E&!D2&D1&D&!C&B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C&B1&!B&!A1&!A|E1&!E&!D2&D1&!D&!C&B1&!B&!A1&!A|!E1&E&!D2&D1&!D&!C&B1&!B&!A1&!A|!E1&E&D2&D1&!D&!C&B1&!B&!A1&!A|E1&!E&D2&D1&!D&!C&B1&!B&!A1&!A|!E1&!E&D2&D1&!D&!C&B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C&B1&!B&!A1&!A|E1&!E&D2&!D1&!D&!C&B1&!B&!A1&!A|!E1&E&D2&!D1&!D&!C&B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C&B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C&B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&C&B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&C&!B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C&!B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&D&!C&!B1&B&!A1&!A|E1&!E&!D2&!D1&D&!C&!B1&B&!A1&!A|!E1&E&!D2&!D1&D&!C&!B1&B&!A1&!A|!E1&E&D2&!D1&D&!C&!B1&B&!A1&!A|E1&!E&D2&!D1&D&!C&!B1&B&!A1&!A|!E1&!E&D2&!D1&D&!C&!B1&B&!A1&!A|!E1&!E&D2&D1&D&!C&!B1&B&!A1&!A|E1&!E&D2&D1&D&!C&!B1&B&!A1&!A|!E1&E&D2&D1&D&!C&!B1&B&!A1&!A|!E1&E&!D2&D1&D&!C&!B1&B&!A1&!A|E1&!E&!D2&D1&D&!C&!B1&B&!A1&!A|!E1&!E&!D2&D1&D&!C&!B1&B&!A1&!A|!E1&!E&!D2&D1&!D&!C&!B1&B&!A1&!A|E1&!E&!D2&D1&!D&!C&!B1&B&!A1&!A|!E1&E&!D2&D1&!D&!C&!B1&B&!A1&!A|!E1&E&D2&D1&!D&!C&!B1&B&!A1&!A|E1&!E&D2&D1&!D&!C&!B1&B&!A1&!A|!E1&!E&D2&D1&!D&!C&!B1&B&!A1&!A|!E1&!E&D2&!D1&!D&!C&!B1&B&!A1&!A|E1&!E&D2&!D1&!D&!C&!B1&B&!A1&!A|!E1&E&D2&!D1&!D&!C&!B1&B&!A1&!A|!E1&E&!D2&!D1&!D&!C&!B1&B&!A1&!A|E1&!E&!D2&!D1&!D&!C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&!C&!B1&B&A1&!A|!E1&E&!D2&!D1&!D&!C&!B1&B&A1&!A|!E1&E&D2&!D1&!D&!C&!B1&B&A1&!A|E1&!E&D2&!D1&!D&!C&!B1&B&A1&!A|!E1&!E&D2&!D1&!D&!C&!B1&B&A1&!A|!E1&!E&D2&D1&!D&!C&!B1&B&A1&!A|E1&!E&D2&D1&!D&!C&!B1&B&A1&!A|!E1&E&D2&D1&!D&!C&!B1&B&A1&!A|!E1&E&!D2&D1&!D&!C&!B1&B&A1&!A|E1&!E&!D2&D1&!D&!C&!B1&B&A1&!A|!E1&!E&!D2&D1&!D&!C&!B1&B&A1&!A|!E1&!E&!D2&D1&D&!C&!B1&B&A1&!A|E1&!E&!D2&D1&D&!C&!B1&B&A1&!A|!E1&E&!D2&D1&D&!C&!B1&B&A1&!A|!E1&E&D2&D1&D&!C&!B1&B&A1&!A|E1&!E&D2&D1&D&!C&!B1&B&A1&!A|!E1&!E&D2&D1&D&!C&!B1&B&A1&!A|!E1&!E&D2&!D1&D&!C&!B1&B&A1&!A|E1&!E&D2&!D1&D&!C&!B1&B&A1&!A|!E1&E&D2&!D1&D&!C&!B1&B&A1&!A|!E1&E&!D2&!D1&D&!C&!B1&B&A1&!A|E1&!E&!D2&!D1&D&!C&!B1&B&A1&!A|!E1&!E&!D2&!D1&D&!C&!B1&B&A1&!A|!E1&E&!D2&!D1&!D&C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&C&!B1&B&A1&!A|!E1&!E&!D2&!D1&!D&C&!B1&B&A1&!A|!E1&!E&!D2&!D1&!D&C&B1&B&A1&!A|E1&!E&!D2&!D1&!D&C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&!C&B1&B&A1&!A|E1&!E&!D2&!D1&!D&!C&B1&B&A1&!A|!E1&!E&!D2&!D1&!D&!C&B1&B&A1&!A|!E1&!E&!D2&!D1&!D&!C&B1&!B&A1&!A|E1&!E&!D2&!D1&!D&!C&B1&!B&A1&!A|!E1&E&!D2&!D1&!D&!C&B1&!B&A1&!A|!E1&E&D2&!D1&!D&!C&B1&!B&A1&!A|E1&!E&D2&!D1&!D&!C&B1&!B&A1&!A|!E1&!E&D2&!D1&!D&!C&B1&!B&A1&!A|!E1&!E&D2&D1&!D&!C&B1&!B&A1&!A|E1&!E&D2&D1&!D&!C&B1&!B&A1&!A|!E1&E&D2&D1&!D&!C&B1&!B&A1&!A|!E1&E&!D2&D1&!D&!C&B1&!B&A1&!A|E1&!E&!D2&D1&!D&!C&B1&!B&A1&!A|!E1&!E&!D2&D1&!D&!C&B1&!B&A1&!A|!E1&!E&!D2&D1&D&!C&B1&!B&A1&!A|E1&!E&!D2&D1&D&!C&B1&!B&A1&!A|!E1&E&!D2&D1&D&!C&B1&!B&A1&!A|!E1&E&D2&D1&D&!C&B1&!B&A1&!A|E1&!E&D2&D1&D&!C&B1&!B&A1&!A|!E1&!E&D2&D1&D&!C&B1&!B&A1&!A|!E1&!E&D2&!D1&D&!C&B1&!B&A1&!A|E1&!E&D2&!D1&D&!C&B1&!B&A1&!A|!E1&E&D2&!D1&D&!C&B1&!B&A1&!A|!E1&E&!D2&!D1&D&!C&B1&!B&A1&!A|E1&!E&!D2&!D1&D&!C&B1&!B&A1&!A|!E1&!E&!D2&!D1&D&!C&B1&!B&A1&!A|!E1&E&!D2&!D1&!D&C&B1&!B&A1&!A|E1&!E&!D2&!D1&!D&C&B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&C&B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&C&!B1&!B&A1&!A|E1&!E&!D2&!D1&!D&C&!B1&!B&A1&!A|!E1&E&!D2&!D1&!D&C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&D&!C&!B1&!B&A1&!A|E1&!E&!D2&!D1&D&!C&!B1&!B&A1&!A|!E1&E&!D2&!D1&D&!C&!B1&!B&A1&!A|!E1&E&D2&!D1&D&!C&!B1&!B&A1&!A|E1&!E&D2&!D1&D&!C&!B1&!B&A1&!A|!E1&!E&D2&!D1&D&!C&!B1&!B&A1&!A|!E1&!E&D2&D1&D&!C&!B1&!B&A1&!A|E1&!E&D2&D1&D&!C&!B1&!B&A1&!A|!E1&E&D2&D1&D&!C&!B1&!B&A1&!A|!E1&E&!D2&D1&D&!C&!B1&!B&A1&!A|E1&!E&!D2&D1&D&!C&!B1&!B&A1&!A|!E1&!E&!D2&D1&D&!C&!B1&!B&A1&!A|!E1&!E&!D2&D1&!D&!C&!B1&!B&A1&!A|E1&!E&!D2&D1&!D&!C&!B1&!B&A1&!A|!E1&E&!D2&D1&!D&!C&!B1&!B&A1&!A|!E1&E&D2&D1&!D&!C&!B1&!B&A1&!A|E1&!E&D2&D1&!D&!C&!B1&!B&A1&!A|!E1&!E&D2&D1&!D&!C&!B1&!B&A1&!A|!E1&!E&D2&!D1&!D&!C&!B1&!B&A1&!A|E1&!E&D2&!D1&!D&!C&!B1&!B&A1&!A|!E1&E&D2&!D1&!D&!C&!B1&!B&A1&!A|!E1&E&!D2&!D1&!D&!C&!B1&!B&A1&!A|E1&!E&!D2&!D1&!D&!C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&C&!B1&!B&A1&A|!E1&!E&!D2&!D1&!D&C&!B1&!B&A1&A|!E1&!E&!D2&!D1&!D&C&B1&!B&A1&A|E1&!E&!D2&!D1&!D&C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&!C&B1&!B&A1&A|E1&!E&!D2&!D1&!D&!C&B1&!B&A1&A|!E1&!E&!D2&!D1&!D&!C&B1&!B&A1&A|!E1&!E&!D2&!D1&!D&!C&B1&B&A1&A|E1&!E&!D2&!D1&!D&!C&B1&B&A1&A|!E1&E&!D2&!D1&!D&!C&B1&B&A1&A|!E1&E&!D2&!D1&!D&C&B1&B&A1&A|E1&!E&!D2&!D1&!D&C&B1&B&A1&A|!E1&!E&!D2&!D1&!D&C&B1&B&A1&A|!E1&!E&!D2&!D1&!D&C&!B1&B&A1&A|E1&!E&!D2&!D1&!D&C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&!C&!B1&B&A1&A|E1&!E&!D2&!D1&!D&!C&!B1&B&A1&A|!E1&!E&!D2&!D1&!D&!C&!B1&B&A1&A|!E1&!E&!D2&!D1&!D&!C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&!C&!B1&B&!A1&A|!E1&E&!D2&!D1&!D&!C&!B1&B&!A1&A|!E1&E&D2&!D1&!D&!C&!B1&B&!A1&A|E1&!E&D2&!D1&!D&!C&!B1&B&!A1&A|!E1&!E&D2&!D1&!D&!C&!B1&B&!A1&A|!E1&!E&D2&D1&!D&!C&!B1&B&!A1&A|E1&!E&D2&D1&!D&!C&!B1&B&!A1&A|!E1&E&D2&D1&!D&!C&!B1&B&!A1&A|!E1&E&!D2&D1&!D&!C&!B1&B&!A1&A|E1&!E&!D2&D1&!D&!C&!B1&B&!A1&A|!E1&!E&!D2&D1&!D&!C&!B1&B&!A1&A|!E1&!E&!D2&D1&D&!C&!B1&B&!A1&A|E1&!E&!D2&D1&D&!C&!B1&B&!A1&A|!E1&E&!D2&D1&D&!C&!B1&B&!A1&A|!E1&E&D2&D1&D&!C&!B1&B&!A1&A|E1&!E&D2&D1&D&!C&!B1&B&!A1&A|!E1&!E&D2&D1&D&!C&!B1&B&!A1&A|!E1&!E&D2&!D1&D&!C&!B1&B&!A1&A|E1&!E&D2&!D1&D&!C&!B1&B&!A1&A|!E1&E&D2&!D1&D&!C&!B1&B&!A1&A|!E1&E&!D2&!D1&D&!C&!B1&B&!A1&A|E1&!E&!D2&!D1&D&!C&!B1&B&!A1&A|!E1&!E&!D2&!D1&D&!C&!B1&B&!A1&A|!E1&E&!D2&!D1&!D&C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&C&!B1&B&!A1&A|!E1&!E&!D2&!D1&!D&C&!B1&B&!A1&A|!E1&!E&!D2&!D1&!D&C&B1&B&!A1&A|E1&!E&!D2&!D1&!D&C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&!C&B1&B&!A1&A|E1&!E&!D2&!D1&!D&!C&B1&B&!A1&A|!E1&!E&!D2&!D1&!D&!C&B1&B&!A1&A|!E1&!E&!D2&!D1&!D&!C&B1&!B&!A1&A|E1&!E&!D2&!D1&!D&!C&B1&!B&!A1&A|!E1&E&!D2&!D1&!D&!C&B1&!B&!A1&A|!E1&E&D2&!D1&!D&!C&B1&!B&!A1&A|E1&!E&D2&!D1&!D&!C&B1&!B&!A1&A|!E1&!E&D2&!D1&!D&!C&B1&!B&!A1&A|!E1&!E&D2&D1&!D&!C&B1&!B&!A1&A|E1&!E&D2&D1&!D&!C&B1&!B&!A1&A|!E1&E&D2&D1&!D&!C&B1&!B&!A1&A|!E1&E&!D2&D1&!D&!C&B1&!B&!A1&A|E1&!E&!D2&D1&!D&!C&B1&!B&!A1&A|!E1&!E&!D2&D1&!D&!C&B1&!B&!A1&A|!E1&!E&!D2&D1&D&!C&B1&!B&!A1&A|E1&!E&!D2&D1&D&!C&B1&!B&!A1&A|!E1&E&!D2&D1&D&!C&B1&!B&!A1&A|!E1&E&D2&D1&D&!C&B1&!B&!A1&A|E1&!E&D2&D1&D&!C&B1&!B&!A1&A|!E1&!E&D2&D1&D&!C&B1&!B&!A1&A|!E1&!E&D2&!D1&D&!C&B1&!B&!A1&A|E1&!E&D2&!D1&D&!C&B1&!B&!A1&A|!E1&E&D2&!D1&D&!C&B1&!B&!A1&A|!E1&E&!D2&!D1&D&!C&B1&!B&!A1&A|E1&!E&!D2&!D1&D&!C&B1&!B&!A1&A|!E1&!E&!D2&!D1&D&!C&B1&!B&!A1&A|!E1&E&!D2&!D1&!D&C&B1&!B&!A1&A|E1&!E&!D2&!D1&!D&C&B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&C&B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&C&!B1&!B&!A1&A|E1&!E&!D2&!D1&!D&C&!B1&!B&!A1&A|!E1&E&!D2&!D1&!D&C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&D&!C&!B1&!B&!A1&A|E1&!E&!D2&!D1&D&!C&!B1&!B&!A1&A|!E1&E&!D2&!D1&D&!C&!B1&!B&!A1&A|!E1&E&D2&!D1&D&!C&!B1&!B&!A1&A|E1&!E&D2&!D1&D&!C&!B1&!B&!A1&A|!E1&!E&D2&!D1&D&!C&!B1&!B&!A1&A|!E1&!E&D2&D1&D&!C&!B1&!B&!A1&A|E1&!E&D2&D1&D&!C&!B1&!B&!A1&A|!E1&E&D2&D1&D&!C&!B1&!B&!A1&A|!E1&E&!D2&D1&D&!C&!B1&!B&!A1&A|E1&!E&!D2&D1&D&!C&!B1&!B&!A1&A|!E1&!E&!D2&D1&D&!C&!B1&!B&!A1&A|!E1&!E&!D2&D1&!D&!C&!B1&!B&!A1&A|E1&!E&!D2&D1&!D&!C&!B1&!B&!A1&A|!E1&E&!D2&D1&!D&!C&!B1&!B&!A1&A|!E1&E&D2&D1&!D&!C&!B1&!B&!A1&A|E1&!E&D2&D1&!D&!C&!B1&!B&!A1&A|!E1&!E&D2&D1&!D&!C&!B1&!B&!A1&A|!E1&!E&D2&!D1&!D&!C&!B1&!B&!A1&A|E1&!E&D2&!D1&!D&!C&!B1&!B&!A1&A|!E1&E&D2&!D1&!D&!C&!B1&!B&!A1&A|!E1&E&!D2&!D1&!D&!C&!B1&!B&!A1&A|E1&!E&!D2&!D1&!D&!C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAAOI22132.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAI2221 -l AAOAI2221 -i D C1 C B1 B A1 A -o Y -f Y=!(D&C1&!C&!B1&!B&!A1&!A|D&C1&C&!B1&!B&!A1&!A|D&!C1&C&!B1&!B&!A1&!A|D&!C1&C&B1&!B&!A1&!A|D&C1&C&B1&!B&!A1&!A|D&C1&!C&B1&!B&!A1&!A|D&!C1&!C&B1&B&!A1&!A|D&C1&!C&B1&B&!A1&!A|D&C1&C&B1&B&!A1&!A|D&!C1&C&B1&B&!A1&!A|D&!C1&C&!B1&B&!A1&!A|D&C1&C&!B1&B&!A1&!A|D&C1&!C&!B1&B&!A1&!A|D&C1&!C&!B1&B&A1&!A|D&C1&C&!B1&B&A1&!A|D&!C1&C&!B1&B&A1&!A|D&!C1&C&B1&B&A1&!A|D&C1&C&B1&B&A1&!A|D&C1&!C&B1&B&A1&!A|D&!C1&!C&B1&B&A1&!A|D&C1&!C&B1&!B&A1&!A|D&C1&C&B1&!B&A1&!A|D&!C1&C&B1&!B&A1&!A|D&!C1&C&!B1&!B&A1&!A|D&C1&C&!B1&!B&A1&!A|D&C1&!C&!B1&!B&A1&!A|D&!C1&!C&!B1&!B&A1&A|D&C1&!C&!B1&!B&A1&A|D&C1&C&!B1&!B&A1&A|D&!C1&C&!B1&!B&A1&A|D&!C1&C&B1&!B&A1&A|D&C1&C&B1&!B&A1&A|D&C1&!C&B1&!B&A1&A|D&!C1&!C&B1&!B&A1&A|D&!C1&!C&B1&B&A1&A|D&C1&!C&B1&B&A1&A|D&C1&C&B1&B&A1&A|D&!C1&C&B1&B&A1&A|D&!C1&C&!B1&B&A1&A|D&C1&C&!B1&B&A1&A|D&C1&!C&!B1&B&A1&A|D&!C1&!C&!B1&B&A1&A|D&C1&!C&!B1&B&!A1&A|D&C1&C&!B1&B&!A1&A|D&!C1&C&!B1&B&!A1&A|D&!C1&C&B1&B&!A1&A|D&C1&C&B1&B&!A1&A|D&C1&!C&B1&B&!A1&A|D&!C1&!C&B1&B&!A1&A|D&C1&!C&B1&!B&!A1&A|D&C1&C&B1&!B&!A1&A|D&!C1&C&B1&!B&!A1&A|D&!C1&C&!B1&!B&!A1&A|D&C1&C&!B1&!B&!A1&A|D&C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAI2221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOAI3311 -l OOAOAI3311 -i D C B2 B1 B A2 A1 A -o Y -f Y=!(D&C&!B2&!B1&!B&!A2&!A1&!A|D&C&B2&!B1&!B&!A2&!A1&!A|D&C&B2&B1&!B&!A2&!A1&!A|D&C&!B2&B1&!B&!A2&!A1&!A|D&C&!B2&B1&B&!A2&!A1&!A|D&C&B2&B1&B&!A2&!A1&!A|D&C&B2&!B1&B&!A2&!A1&!A|D&C&!B2&!B1&B&!A2&!A1&!A|D&!C&!B2&!B1&B&A2&!A1&!A|D&C&!B2&!B1&B&A2&!A1&!A|D&C&B2&!B1&B&A2&!A1&!A|D&!C&B2&!B1&B&A2&!A1&!A|D&!C&B2&B1&B&A2&!A1&!A|D&C&B2&B1&B&A2&!A1&!A|D&C&!B2&B1&B&A2&!A1&!A|D&!C&!B2&B1&B&A2&!A1&!A|D&!C&!B2&B1&!B&A2&!A1&!A|D&C&!B2&B1&!B&A2&!A1&!A|D&C&B2&B1&!B&A2&!A1&!A|D&!C&B2&B1&!B&A2&!A1&!A|D&!C&B2&!B1&!B&A2&!A1&!A|D&C&B2&!B1&!B&A2&!A1&!A|D&C&!B2&!B1&!B&A2&!A1&!A|D&C&!B2&!B1&!B&A2&A1&!A|D&C&B2&!B1&!B&A2&A1&!A|D&!C&B2&!B1&!B&A2&A1&!A|D&!C&B2&B1&!B&A2&A1&!A|D&C&B2&B1&!B&A2&A1&!A|D&C&!B2&B1&!B&A2&A1&!A|D&!C&!B2&B1&!B&A2&A1&!A|D&!C&!B2&B1&B&A2&A1&!A|D&C&!B2&B1&B&A2&A1&!A|D&C&B2&B1&B&A2&A1&!A|D&!C&B2&B1&B&A2&A1&!A|D&!C&B2&!B1&B&A2&A1&!A|D&C&B2&!B1&B&A2&A1&!A|D&C&!B2&!B1&B&A2&A1&!A|D&!C&!B2&!B1&B&A2&A1&!A|D&!C&!B2&!B1&B&!A2&A1&!A|D&C&!B2&!B1&B&!A2&A1&!A|D&C&B2&!B1&B&!A2&A1&!A|D&!C&B2&!B1&B&!A2&A1&!A|D&!C&B2&B1&B&!A2&A1&!A|D&C&B2&B1&B&!A2&A1&!A|D&C&!B2&B1&B&!A2&A1&!A|D&!C&!B2&B1&B&!A2&A1&!A|D&!C&!B2&B1&!B&!A2&A1&!A|D&C&!B2&B1&!B&!A2&A1&!A|D&C&B2&B1&!B&!A2&A1&!A|D&!C&B2&B1&!B&!A2&A1&!A|D&!C&B2&!B1&!B&!A2&A1&!A|D&C&B2&!B1&!B&!A2&A1&!A|D&C&!B2&!B1&!B&!A2&A1&!A|D&C&!B2&!B1&!B&!A2&A1&A|D&C&B2&!B1&!B&!A2&A1&A|D&!C&B2&!B1&!B&!A2&A1&A|D&!C&B2&B1&!B&!A2&A1&A|D&C&B2&B1&!B&!A2&A1&A|D&C&!B2&B1&!B&!A2&A1&A|D&!C&!B2&B1&!B&!A2&A1&A|D&!C&!B2&B1&B&!A2&A1&A|D&C&!B2&B1&B&!A2&A1&A|D&C&B2&B1&B&!A2&A1&A|D&!C&B2&B1&B&!A2&A1&A|D&!C&B2&!B1&B&!A2&A1&A|D&C&B2&!B1&B&!A2&A1&A|D&C&!B2&!B1&B&!A2&A1&A|D&!C&!B2&!B1&B&!A2&A1&A|D&!C&!B2&!B1&B&A2&A1&A|D&C&!B2&!B1&B&A2&A1&A|D&C&B2&!B1&B&A2&A1&A|D&!C&B2&!B1&B&A2&A1&A|D&!C&B2&B1&B&A2&A1&A|D&C&B2&B1&B&A2&A1&A|D&C&!B2&B1&B&A2&A1&A|D&!C&!B2&B1&B&A2&A1&A|D&!C&!B2&B1&!B&A2&A1&A|D&C&!B2&B1&!B&A2&A1&A|D&C&B2&B1&!B&A2&A1&A|D&!C&B2&B1&!B&A2&A1&A|D&!C&B2&!B1&!B&A2&A1&A|D&C&B2&!B1&!B&A2&A1&A|D&C&!B2&!B1&!B&A2&A1&A|D&C&!B2&!B1&!B&A2&!A1&A|D&C&B2&!B1&!B&A2&!A1&A|D&!C&B2&!B1&!B&A2&!A1&A|D&!C&B2&B1&!B&A2&!A1&A|D&C&B2&B1&!B&A2&!A1&A|D&C&!B2&B1&!B&A2&!A1&A|D&!C&!B2&B1&!B&A2&!A1&A|D&!C&!B2&B1&B&A2&!A1&A|D&C&!B2&B1&B&A2&!A1&A|D&C&B2&B1&B&A2&!A1&A|D&!C&B2&B1&B&A2&!A1&A|D&!C&B2&!B1&B&A2&!A1&A|D&C&B2&!B1&B&A2&!A1&A|D&C&!B2&!B1&B&A2&!A1&A|D&!C&!B2&!B1&B&A2&!A1&A|D&!C&!B2&!B1&B&!A2&!A1&A|D&C&!B2&!B1&B&!A2&!A1&A|D&C&B2&!B1&B&!A2&!A1&A|D&!C&B2&!B1&B&!A2&!A1&A|D&!C&B2&B1&B&!A2&!A1&A|D&C&B2&B1&B&!A2&!A1&A|D&C&!B2&B1&B&!A2&!A1&A|D&!C&!B2&B1&B&!A2&!A1&A|D&!C&!B2&B1&!B&!A2&!A1&A|D&C&!B2&B1&!B&!A2&!A1&A|D&C&B2&B1&!B&!A2&!A1&A|D&!C&B2&B1&!B&!A2&!A1&A|D&!C&B2&!B1&!B&!A2&!A1&A|D&C&B2&!B1&!B&!A2&!A1&A|D&C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOAI3311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOI3112 -l AOAOI3112 -i D1 D C B A2 A1 A -o Y -f Y=(!D1&!D&!C&!B&!A2&!A1&!A|!D1&!D&C&!B&!A2&!A1&!A|!D1&!D&!C&B&!A2&!A1&!A|!D1&!D&!C&B&A2&!A1&!A|!D1&!D&C&!B&A2&!A1&!A|!D1&!D&!C&!B&A2&!A1&!A|!D1&!D&!C&!B&A2&A1&!A|!D1&!D&C&!B&A2&A1&!A|!D1&!D&!C&B&A2&A1&!A|!D1&!D&!C&B&!A2&A1&!A|!D1&!D&C&!B&!A2&A1&!A|!D1&!D&!C&!B&!A2&A1&!A|!D1&!D&!C&!B&!A2&A1&A|!D1&!D&C&!B&!A2&A1&A|!D1&!D&!C&B&!A2&A1&A|!D1&!D&!C&B&A2&A1&A|!D1&!D&!C&!B&A2&A1&A|!D1&!D&!C&!B&A2&!A1&A|!D1&!D&C&!B&A2&!A1&A|!D1&!D&!C&B&A2&!A1&A|!D1&!D&!C&B&!A2&!A1&A|!D1&!D&C&!B&!A2&!A1&A|!D1&!D&!C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOI3112.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAAOI21222 -l AOOAAAOI21222 -i E1 E D1 D C1 C B A1 A -o Y -f Y=(!E1&!E&!D1&!D&!C1&!C&!B&!A1&!A|E1&!E&!D1&!D&!C1&!C&!B&!A1&!A|!E1&E&!D1&!D&!C1&!C&!B&!A1&!A|!E1&E&D1&!D&!C1&!C&!B&!A1&!A|E1&!E&D1&!D&!C1&!C&!B&!A1&!A|!E1&!E&D1&!D&!C1&!C&!B&!A1&!A|!E1&E&!D1&D&!C1&!C&!B&!A1&!A|E1&!E&!D1&D&!C1&!C&!B&!A1&!A|!E1&!E&!D1&D&!C1&!C&!B&!A1&!A|!E1&!E&!D1&D&C1&!C&!B&!A1&!A|E1&!E&!D1&D&C1&!C&!B&!A1&!A|!E1&E&!D1&D&C1&!C&!B&!A1&!A|!E1&!E&D1&!D&C1&!C&!B&!A1&!A|E1&!E&D1&!D&C1&!C&!B&!A1&!A|!E1&E&D1&!D&C1&!C&!B&!A1&!A|!E1&E&!D1&!D&C1&!C&!B&!A1&!A|E1&!E&!D1&!D&C1&!C&!B&!A1&!A|!E1&!E&!D1&!D&C1&!C&!B&!A1&!A|!E1&!E&!D1&!D&C1&C&!B&!A1&!A|E1&!E&!D1&!D&C1&C&!B&!A1&!A|!E1&E&!D1&!D&C1&C&!B&!A1&!A|!E1&E&D1&!D&C1&C&!B&!A1&!A|E1&!E&D1&!D&C1&C&!B&!A1&!A|!E1&!E&D1&!D&C1&C&!B&!A1&!A|!E1&E&!D1&D&C1&C&!B&!A1&!A|E1&!E&!D1&D&C1&C&!B&!A1&!A|!E1&!E&!D1&D&C1&C&!B&!A1&!A|!E1&!E&!D1&D&!C1&C&!B&!A1&!A|E1&!E&!D1&D&!C1&C&!B&!A1&!A|!E1&E&!D1&D&!C1&C&!B&!A1&!A|!E1&!E&D1&!D&!C1&C&!B&!A1&!A|E1&!E&D1&!D&!C1&C&!B&!A1&!A|!E1&E&D1&!D&!C1&C&!B&!A1&!A|!E1&E&!D1&!D&!C1&C&!B&!A1&!A|E1&!E&!D1&!D&!C1&C&!B&!A1&!A|!E1&!E&!D1&!D&!C1&C&!B&!A1&!A|!E1&!E&!D1&D&!C1&!C&B&!A1&!A|E1&!E&!D1&D&!C1&!C&B&!A1&!A|!E1&E&!D1&D&!C1&!C&B&!A1&!A|!E1&!E&D1&!D&!C1&!C&B&!A1&!A|E1&!E&D1&!D&!C1&!C&B&!A1&!A|!E1&E&D1&!D&!C1&!C&B&!A1&!A|!E1&E&!D1&!D&!C1&!C&B&!A1&!A|E1&!E&!D1&!D&!C1&!C&B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&B&A1&!A|E1&!E&!D1&!D&!C1&!C&B&A1&!A|!E1&E&!D1&!D&!C1&!C&B&A1&!A|!E1&E&D1&!D&!C1&!C&B&A1&!A|E1&!E&D1&!D&!C1&!C&B&A1&!A|!E1&!E&D1&!D&!C1&!C&B&A1&!A|!E1&E&!D1&D&!C1&!C&B&A1&!A|E1&!E&!D1&D&!C1&!C&B&A1&!A|!E1&!E&!D1&D&!C1&!C&B&A1&!A|!E1&!E&!D1&!D&!C1&C&!B&A1&!A|E1&!E&!D1&!D&!C1&C&!B&A1&!A|!E1&E&!D1&!D&!C1&C&!B&A1&!A|!E1&E&D1&!D&!C1&C&!B&A1&!A|E1&!E&D1&!D&!C1&C&!B&A1&!A|!E1&!E&D1&!D&!C1&C&!B&A1&!A|!E1&E&!D1&D&!C1&C&!B&A1&!A|E1&!E&!D1&D&!C1&C&!B&A1&!A|!E1&!E&!D1&D&!C1&C&!B&A1&!A|!E1&!E&!D1&D&C1&C&!B&A1&!A|E1&!E&!D1&D&C1&C&!B&A1&!A|!E1&E&!D1&D&C1&C&!B&A1&!A|!E1&!E&D1&!D&C1&C&!B&A1&!A|E1&!E&D1&!D&C1&C&!B&A1&!A|!E1&E&D1&!D&C1&C&!B&A1&!A|!E1&E&!D1&!D&C1&C&!B&A1&!A|E1&!E&!D1&!D&C1&C&!B&A1&!A|!E1&!E&!D1&!D&C1&C&!B&A1&!A|!E1&!E&!D1&!D&C1&!C&!B&A1&!A|E1&!E&!D1&!D&C1&!C&!B&A1&!A|!E1&E&!D1&!D&C1&!C&!B&A1&!A|!E1&E&D1&!D&C1&!C&!B&A1&!A|E1&!E&D1&!D&C1&!C&!B&A1&!A|!E1&!E&D1&!D&C1&!C&!B&A1&!A|!E1&E&!D1&D&C1&!C&!B&A1&!A|E1&!E&!D1&D&C1&!C&!B&A1&!A|!E1&!E&!D1&D&C1&!C&!B&A1&!A|!E1&!E&!D1&D&!C1&!C&!B&A1&!A|E1&!E&!D1&D&!C1&!C&!B&A1&!A|!E1&E&!D1&D&!C1&!C&!B&A1&!A|!E1&!E&D1&!D&!C1&!C&!B&A1&!A|E1&!E&D1&!D&!C1&!C&!B&A1&!A|!E1&E&D1&!D&!C1&!C&!B&A1&!A|!E1&E&!D1&!D&!C1&!C&!B&A1&!A|E1&!E&!D1&!D&!C1&!C&!B&A1&!A|!E1&!E&!D1&!D&!C1&!C&!B&A1&!A|!E1&!E&!D1&!D&!C1&!C&!B&A1&A|E1&!E&!D1&!D&!C1&!C&!B&A1&A|!E1&E&!D1&!D&!C1&!C&!B&A1&A|!E1&E&D1&!D&!C1&!C&!B&A1&A|E1&!E&D1&!D&!C1&!C&!B&A1&A|!E1&!E&D1&!D&!C1&!C&!B&A1&A|!E1&E&!D1&D&!C1&!C&!B&A1&A|E1&!E&!D1&D&!C1&!C&!B&A1&A|!E1&!E&!D1&D&!C1&!C&!B&A1&A|!E1&!E&!D1&D&!C1&!C&B&A1&A|E1&!E&!D1&D&!C1&!C&B&A1&A|!E1&E&!D1&D&!C1&!C&B&A1&A|!E1&!E&D1&!D&!C1&!C&B&A1&A|E1&!E&D1&!D&!C1&!C&B&A1&A|!E1&E&D1&!D&!C1&!C&B&A1&A|!E1&E&!D1&!D&!C1&!C&B&A1&A|E1&!E&!D1&!D&!C1&!C&B&A1&A|!E1&!E&!D1&!D&!C1&!C&B&A1&A|!E1&!E&!D1&!D&!C1&!C&B&!A1&A|E1&!E&!D1&!D&!C1&!C&B&!A1&A|!E1&E&!D1&!D&!C1&!C&B&!A1&A|!E1&E&D1&!D&!C1&!C&B&!A1&A|E1&!E&D1&!D&!C1&!C&B&!A1&A|!E1&!E&D1&!D&!C1&!C&B&!A1&A|!E1&E&!D1&D&!C1&!C&B&!A1&A|E1&!E&!D1&D&!C1&!C&B&!A1&A|!E1&!E&!D1&D&!C1&!C&B&!A1&A|!E1&!E&!D1&!D&!C1&C&!B&!A1&A|E1&!E&!D1&!D&!C1&C&!B&!A1&A|!E1&E&!D1&!D&!C1&C&!B&!A1&A|!E1&E&D1&!D&!C1&C&!B&!A1&A|E1&!E&D1&!D&!C1&C&!B&!A1&A|!E1&!E&D1&!D&!C1&C&!B&!A1&A|!E1&E&!D1&D&!C1&C&!B&!A1&A|E1&!E&!D1&D&!C1&C&!B&!A1&A|!E1&!E&!D1&D&!C1&C&!B&!A1&A|!E1&!E&!D1&D&C1&C&!B&!A1&A|E1&!E&!D1&D&C1&C&!B&!A1&A|!E1&E&!D1&D&C1&C&!B&!A1&A|!E1&!E&D1&!D&C1&C&!B&!A1&A|E1&!E&D1&!D&C1&C&!B&!A1&A|!E1&E&D1&!D&C1&C&!B&!A1&A|!E1&E&!D1&!D&C1&C&!B&!A1&A|E1&!E&!D1&!D&C1&C&!B&!A1&A|!E1&!E&!D1&!D&C1&C&!B&!A1&A|!E1&!E&!D1&!D&C1&!C&!B&!A1&A|E1&!E&!D1&!D&C1&!C&!B&!A1&A|!E1&E&!D1&!D&C1&!C&!B&!A1&A|!E1&E&D1&!D&C1&!C&!B&!A1&A|E1&!E&D1&!D&C1&!C&!B&!A1&A|!E1&!E&D1&!D&C1&!C&!B&!A1&A|!E1&E&!D1&D&C1&!C&!B&!A1&A|E1&!E&!D1&D&C1&!C&!B&!A1&A|!E1&!E&!D1&D&C1&!C&!B&!A1&A|!E1&!E&!D1&D&!C1&!C&!B&!A1&A|E1&!E&!D1&D&!C1&!C&!B&!A1&A|!E1&E&!D1&D&!C1&!C&!B&!A1&A|!E1&!E&D1&!D&!C1&!C&!B&!A1&A|E1&!E&D1&!D&!C1&!C&!B&!A1&A|!E1&E&D1&!D&!C1&!C&!B&!A1&A|!E1&E&!D1&!D&!C1&!C&!B&!A1&A|E1&!E&!D1&!D&!C1&!C&!B&!A1&A|!E1&!E&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAAOI21222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAI3212 -l AAOOAI3212 -i D1 D C B1 B A2 A1 A -o Y -f Y=(!D1&!D&!C&!B1&!B&!A2&!A1&!A|D1&!D&!C&!B1&!B&!A2&!A1&!A|D1&D&!C&!B1&!B&!A2&!A1&!A|!D1&D&!C&!B1&!B&!A2&!A1&!A|!D1&!D&C&!B1&!B&!A2&!A1&!A|!D1&!D&C&B1&!B&!A2&!A1&!A|!D1&D&!C&B1&!B&!A2&!A1&!A|D1&D&!C&B1&!B&!A2&!A1&!A|D1&!D&!C&B1&!B&!A2&!A1&!A|!D1&!D&!C&B1&!B&!A2&!A1&!A|!D1&!D&!C&B1&B&!A2&!A1&!A|!D1&!D&C&B1&B&!A2&!A1&!A|!D1&!D&C&!B1&B&!A2&!A1&!A|!D1&D&!C&!B1&B&!A2&!A1&!A|D1&D&!C&!B1&B&!A2&!A1&!A|D1&!D&!C&!B1&B&!A2&!A1&!A|!D1&!D&!C&!B1&B&!A2&!A1&!A|!D1&!D&!C&!B1&B&A2&!A1&!A|D1&!D&!C&!B1&B&A2&!A1&!A|D1&D&!C&!B1&B&A2&!A1&!A|!D1&D&!C&!B1&B&A2&!A1&!A|!D1&!D&C&!B1&B&A2&!A1&!A|!D1&!D&C&B1&B&A2&!A1&!A|!D1&!D&!C&B1&B&A2&!A1&!A|!D1&!D&!C&B1&!B&A2&!A1&!A|D1&!D&!C&B1&!B&A2&!A1&!A|D1&D&!C&B1&!B&A2&!A1&!A|!D1&D&!C&B1&!B&A2&!A1&!A|!D1&!D&C&B1&!B&A2&!A1&!A|!D1&!D&C&!B1&!B&A2&!A1&!A|!D1&D&!C&!B1&!B&A2&!A1&!A|D1&D&!C&!B1&!B&A2&!A1&!A|D1&!D&!C&!B1&!B&A2&!A1&!A|!D1&!D&!C&!B1&!B&A2&!A1&!A|!D1&!D&!C&!B1&!B&A2&A1&!A|D1&!D&!C&!B1&!B&A2&A1&!A|D1&D&!C&!B1&!B&A2&A1&!A|!D1&D&!C&!B1&!B&A2&A1&!A|!D1&!D&C&!B1&!B&A2&A1&!A|!D1&!D&C&B1&!B&A2&A1&!A|!D1&D&!C&B1&!B&A2&A1&!A|D1&D&!C&B1&!B&A2&A1&!A|D1&!D&!C&B1&!B&A2&A1&!A|!D1&!D&!C&B1&!B&A2&A1&!A|!D1&!D&!C&B1&B&A2&A1&!A|!D1&!D&C&B1&B&A2&A1&!A|!D1&!D&C&!B1&B&A2&A1&!A|!D1&D&!C&!B1&B&A2&A1&!A|D1&D&!C&!B1&B&A2&A1&!A|D1&!D&!C&!B1&B&A2&A1&!A|!D1&!D&!C&!B1&B&A2&A1&!A|!D1&!D&!C&!B1&B&!A2&A1&!A|D1&!D&!C&!B1&B&!A2&A1&!A|D1&D&!C&!B1&B&!A2&A1&!A|!D1&D&!C&!B1&B&!A2&A1&!A|!D1&!D&C&!B1&B&!A2&A1&!A|!D1&!D&C&B1&B&!A2&A1&!A|!D1&!D&!C&B1&B&!A2&A1&!A|!D1&!D&!C&B1&!B&!A2&A1&!A|D1&!D&!C&B1&!B&!A2&A1&!A|D1&D&!C&B1&!B&!A2&A1&!A|!D1&D&!C&B1&!B&!A2&A1&!A|!D1&!D&C&B1&!B&!A2&A1&!A|!D1&!D&C&!B1&!B&!A2&A1&!A|!D1&D&!C&!B1&!B&!A2&A1&!A|D1&D&!C&!B1&!B&!A2&A1&!A|D1&!D&!C&!B1&!B&!A2&A1&!A|!D1&!D&!C&!B1&!B&!A2&A1&!A|!D1&!D&!C&!B1&!B&!A2&A1&A|D1&!D&!C&!B1&!B&!A2&A1&A|D1&D&!C&!B1&!B&!A2&A1&A|!D1&D&!C&!B1&!B&!A2&A1&A|!D1&!D&C&!B1&!B&!A2&A1&A|!D1&!D&C&B1&!B&!A2&A1&A|!D1&D&!C&B1&!B&!A2&A1&A|D1&D&!C&B1&!B&!A2&A1&A|D1&!D&!C&B1&!B&!A2&A1&A|!D1&!D&!C&B1&!B&!A2&A1&A|!D1&!D&!C&B1&B&!A2&A1&A|!D1&!D&C&B1&B&!A2&A1&A|!D1&!D&C&!B1&B&!A2&A1&A|!D1&D&!C&!B1&B&!A2&A1&A|D1&D&!C&!B1&B&!A2&A1&A|D1&!D&!C&!B1&B&!A2&A1&A|!D1&!D&!C&!B1&B&!A2&A1&A|!D1&!D&!C&!B1&B&A2&A1&A|!D1&!D&C&!B1&B&A2&A1&A|!D1&!D&C&B1&B&A2&A1&A|!D1&!D&!C&B1&B&A2&A1&A|!D1&!D&!C&B1&!B&A2&A1&A|!D1&!D&C&B1&!B&A2&A1&A|!D1&!D&C&!B1&!B&A2&A1&A|!D1&!D&!C&!B1&!B&A2&A1&A|!D1&!D&!C&!B1&!B&A2&!A1&A|D1&!D&!C&!B1&!B&A2&!A1&A|D1&D&!C&!B1&!B&A2&!A1&A|!D1&D&!C&!B1&!B&A2&!A1&A|!D1&!D&C&!B1&!B&A2&!A1&A|!D1&!D&C&B1&!B&A2&!A1&A|!D1&D&!C&B1&!B&A2&!A1&A|D1&D&!C&B1&!B&A2&!A1&A|D1&!D&!C&B1&!B&A2&!A1&A|!D1&!D&!C&B1&!B&A2&!A1&A|!D1&!D&!C&B1&B&A2&!A1&A|!D1&!D&C&B1&B&A2&!A1&A|!D1&!D&C&!B1&B&A2&!A1&A|!D1&D&!C&!B1&B&A2&!A1&A|D1&D&!C&!B1&B&A2&!A1&A|D1&!D&!C&!B1&B&A2&!A1&A|!D1&!D&!C&!B1&B&A2&!A1&A|!D1&!D&!C&!B1&B&!A2&!A1&A|D1&!D&!C&!B1&B&!A2&!A1&A|D1&D&!C&!B1&B&!A2&!A1&A|!D1&D&!C&!B1&B&!A2&!A1&A|!D1&!D&C&!B1&B&!A2&!A1&A|!D1&!D&C&B1&B&!A2&!A1&A|!D1&!D&!C&B1&B&!A2&!A1&A|!D1&!D&!C&B1&!B&!A2&!A1&A|D1&!D&!C&B1&!B&!A2&!A1&A|D1&D&!C&B1&!B&!A2&!A1&A|!D1&D&!C&B1&!B&!A2&!A1&A|!D1&!D&C&B1&!B&!A2&!A1&A|!D1&!D&C&!B1&!B&!A2&!A1&A|!D1&D&!C&!B1&!B&!A2&!A1&A|D1&D&!C&!B1&!B&!A2&!A1&A|D1&!D&!C&!B1&!B&!A2&!A1&A|!D1&!D&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAI3212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAAOAOI222311 -l OOOAAOAOI222311 -i F E D2 D1 D C1 C B1 B A1 A -o Y -f Y=(!F&!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!F&E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!F&E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!F&E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!F&!E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!F&!E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|!F&E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!F&E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!F&E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!F&E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!F&E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!F&E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!F&E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!F&!E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!F&!E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|!F&E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|!F&E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|!F&!E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|!F&!E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|!F&E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|!F&!E&D2&D1&D&C1&C&!B1&!B&!A1&!A|!F&!E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|!F&E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|!F&E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!F&E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!F&E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!F&!E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!F&!E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|!F&E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!F&E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!F&E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!F&E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!F&E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!F&E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!F&E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!F&!E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!F&!E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|!F&E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|!F&E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!F&!E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!F&!E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|!F&E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|!F&!E&D2&D1&D&!C1&C&B1&!B&!A1&!A|!F&!E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|!F&E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|!F&E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!F&!E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!F&!E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|!F&E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|!F&E&D2&!D1&D&C1&C&B1&!B&!A1&!A|!F&!E&D2&!D1&D&C1&C&B1&!B&!A1&!A|!F&!E&D2&D1&D&C1&C&B1&!B&!A1&!A|!F&E&!D2&D1&D&C1&C&B1&!B&!A1&!A|!F&!E&!D2&D1&D&C1&C&B1&!B&!A1&!A|!F&!E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|!F&E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|!F&E&D2&D1&!D&C1&C&B1&!B&!A1&!A|!F&!E&D2&D1&!D&C1&C&B1&!B&!A1&!A|!F&!E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|!F&E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|!F&E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!F&E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!F&E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!F&!E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!F&!E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|!F&E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|!F&E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!F&!E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!F&!E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|!F&E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|!F&!E&D2&D1&D&C1&!C&B1&!B&!A1&!A|!F&!E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|!F&E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|!F&E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!F&!E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!F&!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!F&E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!F&E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!F&!E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!F&!E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|!F&E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!F&E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!F&E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!F&E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!F&E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!F&E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!F&E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!F&!E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!F&!E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|!F&E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|!F&E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!F&!E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!F&!E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|!F&E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|!F&!E&D2&D1&D&!C1&!C&B1&B&!A1&!A|!F&!E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|!F&E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|!F&E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!F&!E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!F&!E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|!F&E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|!F&E&D2&!D1&D&C1&!C&B1&B&!A1&!A|!F&!E&D2&!D1&D&C1&!C&B1&B&!A1&!A|!F&!E&D2&D1&D&C1&!C&B1&B&!A1&!A|!F&E&!D2&D1&D&C1&!C&B1&B&!A1&!A|!F&!E&!D2&D1&D&C1&!C&B1&B&!A1&!A|!F&!E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|!F&E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|!F&E&D2&D1&!D&C1&!C&B1&B&!A1&!A|!F&!E&D2&D1&!D&C1&!C&B1&B&!A1&!A|!F&!E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|!F&E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|!F&E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!F&!E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!F&!E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|!F&E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|!F&E&D2&!D1&!D&C1&C&B1&B&!A1&!A|!F&!E&D2&!D1&!D&C1&C&B1&B&!A1&!A|!F&!E&D2&D1&!D&C1&C&B1&B&!A1&!A|!F&E&D2&D1&!D&C1&C&B1&B&!A1&!A|!F&E&!D2&D1&!D&C1&C&B1&B&!A1&!A|!F&!E&!D2&D1&!D&C1&C&B1&B&!A1&!A|!F&!E&!D2&D1&D&C1&C&B1&B&!A1&!A|!F&E&!D2&D1&D&C1&C&B1&B&!A1&!A|!F&!E&D2&D1&D&C1&C&B1&B&!A1&!A|!F&!E&D2&!D1&D&C1&C&B1&B&!A1&!A|!F&E&D2&!D1&D&C1&C&B1&B&!A1&!A|!F&E&!D2&!D1&D&C1&C&B1&B&!A1&!A|!F&!E&!D2&!D1&D&C1&C&B1&B&!A1&!A|!F&!E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|!F&E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|!F&E&D2&!D1&D&!C1&C&B1&B&!A1&!A|!F&!E&D2&!D1&D&!C1&C&B1&B&!A1&!A|!F&!E&D2&D1&D&!C1&C&B1&B&!A1&!A|!F&E&!D2&D1&D&!C1&C&B1&B&!A1&!A|!F&!E&!D2&D1&D&!C1&C&B1&B&!A1&!A|!F&!E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|!F&E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|!F&E&D2&D1&!D&!C1&C&B1&B&!A1&!A|!F&!E&D2&D1&!D&!C1&C&B1&B&!A1&!A|!F&!E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|!F&E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|!F&E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!F&E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!F&E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!F&!E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!F&!E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|!F&E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|!F&E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!F&!E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!F&!E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|!F&E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|!F&!E&D2&D1&D&!C1&C&!B1&B&!A1&!A|!F&!E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|!F&E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|!F&E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!F&!E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!F&!E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|!F&E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|!F&E&D2&!D1&D&C1&C&!B1&B&!A1&!A|!F&!E&D2&!D1&D&C1&C&!B1&B&!A1&!A|!F&!E&D2&D1&D&C1&C&!B1&B&!A1&!A|!F&E&!D2&D1&D&C1&C&!B1&B&!A1&!A|!F&!E&!D2&D1&D&C1&C&!B1&B&!A1&!A|!F&!E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|!F&E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|!F&E&D2&D1&!D&C1&C&!B1&B&!A1&!A|!F&!E&D2&D1&!D&C1&C&!B1&B&!A1&!A|!F&!E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|!F&E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|!F&E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!F&!E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!F&!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!F&E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!F&E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!F&!E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!F&!E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|!F&E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|!F&E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!F&!E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!F&!E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|!F&E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|!F&!E&D2&D1&D&C1&!C&!B1&B&!A1&!A|!F&!E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|!F&E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|!F&E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!F&!E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!F&!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!F&E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!F&E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!F&!E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!F&!E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|!F&E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!F&E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!F&E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!F&E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!F&E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!F&E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!F&E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!F&!E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!F&!E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|!F&E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|!F&E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|!F&!E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|!F&!E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|!F&E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|!F&!E&D2&D1&D&!C1&!C&!B1&B&A1&!A|!F&!E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|!F&E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|!F&E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|!F&!E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|!F&!E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|!F&!E&D2&!D1&D&C1&!C&!B1&B&A1&!A|!F&!E&D2&D1&D&C1&!C&!B1&B&A1&!A|!F&!E&!D2&D1&D&C1&!C&!B1&B&A1&!A|!F&!E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|!F&!E&D2&D1&!D&C1&!C&!B1&B&A1&!A|!F&!E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|!F&!E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!F&!E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|!F&!E&D2&!D1&!D&C1&C&!B1&B&A1&!A|!F&!E&D2&D1&!D&C1&C&!B1&B&A1&!A|!F&!E&!D2&D1&!D&C1&C&!B1&B&A1&!A|!F&!E&!D2&D1&D&C1&C&!B1&B&A1&!A|!F&!E&D2&D1&D&C1&C&!B1&B&A1&!A|!F&!E&D2&!D1&D&C1&C&!B1&B&A1&!A|!F&!E&!D2&!D1&D&C1&C&!B1&B&A1&!A|!F&!E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|!F&!E&D2&!D1&D&!C1&C&!B1&B&A1&!A|!F&!E&D2&D1&D&!C1&C&!B1&B&A1&!A|!F&!E&!D2&D1&D&!C1&C&!B1&B&A1&!A|!F&!E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|!F&!E&D2&D1&!D&!C1&C&!B1&B&A1&!A|!F&!E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|!F&!E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!F&!E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|!F&!E&D2&!D1&!D&!C1&C&B1&B&A1&!A|!F&!E&D2&D1&!D&!C1&C&B1&B&A1&!A|!F&!E&!D2&D1&!D&!C1&C&B1&B&A1&!A|!F&!E&!D2&D1&D&!C1&C&B1&B&A1&!A|!F&!E&D2&D1&D&!C1&C&B1&B&A1&!A|!F&!E&D2&!D1&D&!C1&C&B1&B&A1&!A|!F&!E&!D2&!D1&D&!C1&C&B1&B&A1&!A|!F&!E&!D2&!D1&D&C1&C&B1&B&A1&!A|!F&!E&D2&!D1&D&C1&C&B1&B&A1&!A|!F&!E&D2&D1&D&C1&C&B1&B&A1&!A|!F&!E&!D2&D1&D&C1&C&B1&B&A1&!A|!F&!E&!D2&D1&!D&C1&C&B1&B&A1&!A|!F&!E&D2&D1&!D&C1&C&B1&B&A1&!A|!F&!E&D2&!D1&!D&C1&C&B1&B&A1&!A|!F&!E&!D2&!D1&!D&C1&C&B1&B&A1&!A|!F&!E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|!F&!E&D2&!D1&!D&C1&!C&B1&B&A1&!A|!F&!E&D2&D1&!D&C1&!C&B1&B&A1&!A|!F&!E&!D2&D1&!D&C1&!C&B1&B&A1&!A|!F&!E&!D2&D1&D&C1&!C&B1&B&A1&!A|!F&!E&D2&D1&D&C1&!C&B1&B&A1&!A|!F&!E&D2&!D1&D&C1&!C&B1&B&A1&!A|!F&!E&!D2&!D1&D&C1&!C&B1&B&A1&!A|!F&!E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|!F&E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|!F&E&D2&!D1&D&!C1&!C&B1&B&A1&!A|!F&!E&D2&!D1&D&!C1&!C&B1&B&A1&!A|!F&!E&D2&D1&D&!C1&!C&B1&B&A1&!A|!F&E&!D2&D1&D&!C1&!C&B1&B&A1&!A|!F&!E&!D2&D1&D&!C1&!C&B1&B&A1&!A|!F&!E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|!F&E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|!F&E&D2&D1&!D&!C1&!C&B1&B&A1&!A|!F&!E&D2&D1&!D&!C1&!C&B1&B&A1&!A|!F&!E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|!F&E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|!F&E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!F&E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!F&E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!F&!E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!F&!E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|!F&E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|!F&E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|!F&!E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|!F&!E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|!F&E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|!F&!E&D2&D1&D&!C1&!C&B1&!B&A1&!A|!F&!E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|!F&E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|!F&E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|!F&!E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|!F&!E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|!F&!E&D2&!D1&D&C1&!C&B1&!B&A1&!A|!F&!E&D2&D1&D&C1&!C&B1&!B&A1&!A|!F&!E&!D2&D1&D&C1&!C&B1&!B&A1&!A|!F&!E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|!F&!E&D2&D1&!D&C1&!C&B1&!B&A1&!A|!F&!E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|!F&!E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!F&!E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|!F&!E&D2&!D1&!D&C1&C&B1&!B&A1&!A|!F&!E&D2&D1&!D&C1&C&B1&!B&A1&!A|!F&!E&!D2&D1&!D&C1&C&B1&!B&A1&!A|!F&!E&!D2&D1&D&C1&C&B1&!B&A1&!A|!F&!E&D2&D1&D&C1&C&B1&!B&A1&!A|!F&!E&D2&!D1&D&C1&C&B1&!B&A1&!A|!F&!E&!D2&!D1&D&C1&C&B1&!B&A1&!A|!F&!E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|!F&!E&D2&!D1&D&!C1&C&B1&!B&A1&!A|!F&!E&D2&D1&D&!C1&C&B1&!B&A1&!A|!F&!E&!D2&D1&D&!C1&C&B1&!B&A1&!A|!F&!E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|!F&!E&D2&D1&!D&!C1&C&B1&!B&A1&!A|!F&!E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|!F&!E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!F&!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!F&E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!F&E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!F&!E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!F&!E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|!F&E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|!F&E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!F&!E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!F&!E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|!F&E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|!F&!E&D2&D1&D&!C1&C&!B1&!B&A1&!A|!F&!E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|!F&E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|!F&E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!F&!E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!F&!E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|!F&E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|!F&E&D2&!D1&D&C1&C&!B1&!B&A1&!A|!F&!E&D2&!D1&D&C1&C&!B1&!B&A1&!A|!F&!E&D2&D1&D&C1&C&!B1&!B&A1&!A|!F&E&!D2&D1&D&C1&C&!B1&!B&A1&!A|!F&!E&!D2&D1&D&C1&C&!B1&!B&A1&!A|!F&!E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|!F&E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|!F&E&D2&D1&!D&C1&C&!B1&!B&A1&!A|!F&!E&D2&D1&!D&C1&C&!B1&!B&A1&!A|!F&!E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|!F&E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|!F&E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!F&!E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!F&!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!F&E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!F&E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!F&!E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!F&!E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|!F&E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|!F&E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!F&!E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!F&!E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|!F&E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|!F&!E&D2&D1&D&C1&!C&!B1&!B&A1&!A|!F&!E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|!F&E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|!F&E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!F&!E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!F&!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!F&E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!F&E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!F&!E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!F&!E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|!F&E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!F&E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!F&E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!F&E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!F&E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!F&E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!F&E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!F&!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!F&!E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|!F&E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|!F&E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!F&!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!F&!E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|!F&E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|!F&!E&D2&D1&D&!C1&!C&!B1&!B&A1&A|!F&!E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|!F&E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|!F&E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!F&!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!F&!E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|!F&E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|!F&E&D2&!D1&D&C1&!C&!B1&!B&A1&A|!F&!E&D2&!D1&D&C1&!C&!B1&!B&A1&A|!F&!E&D2&D1&D&C1&!C&!B1&!B&A1&A|!F&E&!D2&D1&D&C1&!C&!B1&!B&A1&A|!F&!E&!D2&D1&D&C1&!C&!B1&!B&A1&A|!F&!E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|!F&E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|!F&E&D2&D1&!D&C1&!C&!B1&!B&A1&A|!F&!E&D2&D1&!D&C1&!C&!B1&!B&A1&A|!F&!E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|!F&E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|!F&E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!F&!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!F&!E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|!F&E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|!F&E&D2&!D1&!D&C1&C&!B1&!B&A1&A|!F&!E&D2&!D1&!D&C1&C&!B1&!B&A1&A|!F&!E&D2&D1&!D&C1&C&!B1&!B&A1&A|!F&E&D2&D1&!D&C1&C&!B1&!B&A1&A|!F&E&!D2&D1&!D&C1&C&!B1&!B&A1&A|!F&!E&!D2&D1&!D&C1&C&!B1&!B&A1&A|!F&!E&!D2&D1&D&C1&C&!B1&!B&A1&A|!F&E&!D2&D1&D&C1&C&!B1&!B&A1&A|!F&!E&D2&D1&D&C1&C&!B1&!B&A1&A|!F&!E&D2&!D1&D&C1&C&!B1&!B&A1&A|!F&E&D2&!D1&D&C1&C&!B1&!B&A1&A|!F&E&!D2&!D1&D&C1&C&!B1&!B&A1&A|!F&!E&!D2&!D1&D&C1&C&!B1&!B&A1&A|!F&!E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|!F&E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|!F&E&D2&!D1&D&!C1&C&!B1&!B&A1&A|!F&!E&D2&!D1&D&!C1&C&!B1&!B&A1&A|!F&!E&D2&D1&D&!C1&C&!B1&!B&A1&A|!F&E&!D2&D1&D&!C1&C&!B1&!B&A1&A|!F&!E&!D2&D1&D&!C1&C&!B1&!B&A1&A|!F&!E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|!F&E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|!F&E&D2&D1&!D&!C1&C&!B1&!B&A1&A|!F&!E&D2&D1&!D&!C1&C&!B1&!B&A1&A|!F&!E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|!F&E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|!F&E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!F&!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!F&!E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|!F&!E&D2&!D1&!D&!C1&C&B1&!B&A1&A|!F&!E&D2&D1&!D&!C1&C&B1&!B&A1&A|!F&!E&!D2&D1&!D&!C1&C&B1&!B&A1&A|!F&!E&!D2&D1&D&!C1&C&B1&!B&A1&A|!F&!E&D2&D1&D&!C1&C&B1&!B&A1&A|!F&!E&D2&!D1&D&!C1&C&B1&!B&A1&A|!F&!E&!D2&!D1&D&!C1&C&B1&!B&A1&A|!F&!E&!D2&!D1&D&C1&C&B1&!B&A1&A|!F&!E&D2&!D1&D&C1&C&B1&!B&A1&A|!F&!E&D2&D1&D&C1&C&B1&!B&A1&A|!F&!E&!D2&D1&D&C1&C&B1&!B&A1&A|!F&!E&!D2&D1&!D&C1&C&B1&!B&A1&A|!F&!E&D2&D1&!D&C1&C&B1&!B&A1&A|!F&!E&D2&!D1&!D&C1&C&B1&!B&A1&A|!F&!E&!D2&!D1&!D&C1&C&B1&!B&A1&A|!F&!E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|!F&!E&D2&!D1&!D&C1&!C&B1&!B&A1&A|!F&!E&D2&D1&!D&C1&!C&B1&!B&A1&A|!F&!E&!D2&D1&!D&C1&!C&B1&!B&A1&A|!F&!E&!D2&D1&D&C1&!C&B1&!B&A1&A|!F&!E&D2&D1&D&C1&!C&B1&!B&A1&A|!F&!E&D2&!D1&D&C1&!C&B1&!B&A1&A|!F&!E&!D2&!D1&D&C1&!C&B1&!B&A1&A|!F&!E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|!F&E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|!F&E&D2&!D1&D&!C1&!C&B1&!B&A1&A|!F&!E&D2&!D1&D&!C1&!C&B1&!B&A1&A|!F&!E&D2&D1&D&!C1&!C&B1&!B&A1&A|!F&E&!D2&D1&D&!C1&!C&B1&!B&A1&A|!F&!E&!D2&D1&D&!C1&!C&B1&!B&A1&A|!F&!E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|!F&E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|!F&E&D2&D1&!D&!C1&!C&B1&!B&A1&A|!F&!E&D2&D1&!D&!C1&!C&B1&!B&A1&A|!F&!E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|!F&E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|!F&E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!F&!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!F&!E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!F&E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!F&E&D2&!D1&!D&!C1&!C&B1&B&A1&A|!F&!E&D2&!D1&!D&!C1&!C&B1&B&A1&A|!F&!E&D2&D1&!D&!C1&!C&B1&B&A1&A|!F&E&D2&D1&!D&!C1&!C&B1&B&A1&A|!F&E&!D2&D1&!D&!C1&!C&B1&B&A1&A|!F&!E&!D2&D1&!D&!C1&!C&B1&B&A1&A|!F&!E&!D2&D1&D&!C1&!C&B1&B&A1&A|!F&E&!D2&D1&D&!C1&!C&B1&B&A1&A|!F&!E&D2&D1&D&!C1&!C&B1&B&A1&A|!F&!E&D2&!D1&D&!C1&!C&B1&B&A1&A|!F&E&D2&!D1&D&!C1&!C&B1&B&A1&A|!F&E&!D2&!D1&D&!C1&!C&B1&B&A1&A|!F&!E&!D2&!D1&D&!C1&!C&B1&B&A1&A|!F&!E&!D2&!D1&D&C1&!C&B1&B&A1&A|!F&!E&D2&!D1&D&C1&!C&B1&B&A1&A|!F&!E&D2&D1&D&C1&!C&B1&B&A1&A|!F&!E&!D2&D1&D&C1&!C&B1&B&A1&A|!F&!E&!D2&D1&!D&C1&!C&B1&B&A1&A|!F&!E&D2&D1&!D&C1&!C&B1&B&A1&A|!F&!E&D2&!D1&!D&C1&!C&B1&B&A1&A|!F&!E&!D2&!D1&!D&C1&!C&B1&B&A1&A|!F&!E&!D2&!D1&!D&C1&C&B1&B&A1&A|!F&!E&D2&!D1&!D&C1&C&B1&B&A1&A|!F&!E&D2&D1&!D&C1&C&B1&B&A1&A|!F&!E&!D2&D1&!D&C1&C&B1&B&A1&A|!F&!E&!D2&D1&D&C1&C&B1&B&A1&A|!F&!E&D2&D1&D&C1&C&B1&B&A1&A|!F&!E&D2&!D1&D&C1&C&B1&B&A1&A|!F&!E&!D2&!D1&D&C1&C&B1&B&A1&A|!F&!E&!D2&!D1&D&!C1&C&B1&B&A1&A|!F&!E&D2&!D1&D&!C1&C&B1&B&A1&A|!F&!E&D2&D1&D&!C1&C&B1&B&A1&A|!F&!E&!D2&D1&D&!C1&C&B1&B&A1&A|!F&!E&!D2&D1&!D&!C1&C&B1&B&A1&A|!F&!E&D2&D1&!D&!C1&C&B1&B&A1&A|!F&!E&D2&!D1&!D&!C1&C&B1&B&A1&A|!F&!E&!D2&!D1&!D&!C1&C&B1&B&A1&A|!F&!E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|!F&!E&D2&!D1&!D&!C1&C&!B1&B&A1&A|!F&!E&D2&D1&!D&!C1&C&!B1&B&A1&A|!F&!E&!D2&D1&!D&!C1&C&!B1&B&A1&A|!F&!E&!D2&D1&D&!C1&C&!B1&B&A1&A|!F&!E&D2&D1&D&!C1&C&!B1&B&A1&A|!F&!E&D2&!D1&D&!C1&C&!B1&B&A1&A|!F&!E&!D2&!D1&D&!C1&C&!B1&B&A1&A|!F&!E&!D2&!D1&D&C1&C&!B1&B&A1&A|!F&!E&D2&!D1&D&C1&C&!B1&B&A1&A|!F&!E&D2&D1&D&C1&C&!B1&B&A1&A|!F&!E&!D2&D1&D&C1&C&!B1&B&A1&A|!F&!E&!D2&D1&!D&C1&C&!B1&B&A1&A|!F&!E&D2&D1&!D&C1&C&!B1&B&A1&A|!F&!E&D2&!D1&!D&C1&C&!B1&B&A1&A|!F&!E&!D2&!D1&!D&C1&C&!B1&B&A1&A|!F&!E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|!F&!E&D2&!D1&!D&C1&!C&!B1&B&A1&A|!F&!E&D2&D1&!D&C1&!C&!B1&B&A1&A|!F&!E&!D2&D1&!D&C1&!C&!B1&B&A1&A|!F&!E&!D2&D1&D&C1&!C&!B1&B&A1&A|!F&!E&D2&D1&D&C1&!C&!B1&B&A1&A|!F&!E&D2&!D1&D&C1&!C&!B1&B&A1&A|!F&!E&!D2&!D1&D&C1&!C&!B1&B&A1&A|!F&!E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|!F&E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|!F&E&D2&!D1&D&!C1&!C&!B1&B&A1&A|!F&!E&D2&!D1&D&!C1&!C&!B1&B&A1&A|!F&!E&D2&D1&D&!C1&!C&!B1&B&A1&A|!F&E&!D2&D1&D&!C1&!C&!B1&B&A1&A|!F&!E&!D2&D1&D&!C1&!C&!B1&B&A1&A|!F&!E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|!F&E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|!F&E&D2&D1&!D&!C1&!C&!B1&B&A1&A|!F&!E&D2&D1&!D&!C1&!C&!B1&B&A1&A|!F&!E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|!F&E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|!F&E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!F&!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!F&!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!F&E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!F&E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!F&!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!F&!E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|!F&E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|!F&E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|!F&!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|!F&!E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|!F&E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|!F&!E&D2&D1&D&!C1&!C&!B1&B&!A1&A|!F&!E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|!F&E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|!F&E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|!F&!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|!F&!E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|!F&!E&D2&!D1&D&C1&!C&!B1&B&!A1&A|!F&!E&D2&D1&D&C1&!C&!B1&B&!A1&A|!F&!E&!D2&D1&D&C1&!C&!B1&B&!A1&A|!F&!E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|!F&!E&D2&D1&!D&C1&!C&!B1&B&!A1&A|!F&!E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|!F&!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!F&!E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|!F&!E&D2&!D1&!D&C1&C&!B1&B&!A1&A|!F&!E&D2&D1&!D&C1&C&!B1&B&!A1&A|!F&!E&!D2&D1&!D&C1&C&!B1&B&!A1&A|!F&!E&!D2&D1&D&C1&C&!B1&B&!A1&A|!F&!E&D2&D1&D&C1&C&!B1&B&!A1&A|!F&!E&D2&!D1&D&C1&C&!B1&B&!A1&A|!F&!E&!D2&!D1&D&C1&C&!B1&B&!A1&A|!F&!E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|!F&!E&D2&!D1&D&!C1&C&!B1&B&!A1&A|!F&!E&D2&D1&D&!C1&C&!B1&B&!A1&A|!F&!E&!D2&D1&D&!C1&C&!B1&B&!A1&A|!F&!E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|!F&!E&D2&D1&!D&!C1&C&!B1&B&!A1&A|!F&!E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|!F&!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!F&!E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|!F&!E&D2&!D1&!D&!C1&C&B1&B&!A1&A|!F&!E&D2&D1&!D&!C1&C&B1&B&!A1&A|!F&!E&!D2&D1&!D&!C1&C&B1&B&!A1&A|!F&!E&!D2&D1&D&!C1&C&B1&B&!A1&A|!F&!E&D2&D1&D&!C1&C&B1&B&!A1&A|!F&!E&D2&!D1&D&!C1&C&B1&B&!A1&A|!F&!E&!D2&!D1&D&!C1&C&B1&B&!A1&A|!F&!E&!D2&!D1&D&C1&C&B1&B&!A1&A|!F&!E&D2&!D1&D&C1&C&B1&B&!A1&A|!F&!E&D2&D1&D&C1&C&B1&B&!A1&A|!F&!E&!D2&D1&D&C1&C&B1&B&!A1&A|!F&!E&!D2&D1&!D&C1&C&B1&B&!A1&A|!F&!E&D2&D1&!D&C1&C&B1&B&!A1&A|!F&!E&D2&!D1&!D&C1&C&B1&B&!A1&A|!F&!E&!D2&!D1&!D&C1&C&B1&B&!A1&A|!F&!E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|!F&!E&D2&!D1&!D&C1&!C&B1&B&!A1&A|!F&!E&D2&D1&!D&C1&!C&B1&B&!A1&A|!F&!E&!D2&D1&!D&C1&!C&B1&B&!A1&A|!F&!E&!D2&D1&D&C1&!C&B1&B&!A1&A|!F&!E&D2&D1&D&C1&!C&B1&B&!A1&A|!F&!E&D2&!D1&D&C1&!C&B1&B&!A1&A|!F&!E&!D2&!D1&D&C1&!C&B1&B&!A1&A|!F&!E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|!F&E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|!F&E&D2&!D1&D&!C1&!C&B1&B&!A1&A|!F&!E&D2&!D1&D&!C1&!C&B1&B&!A1&A|!F&!E&D2&D1&D&!C1&!C&B1&B&!A1&A|!F&E&!D2&D1&D&!C1&!C&B1&B&!A1&A|!F&!E&!D2&D1&D&!C1&!C&B1&B&!A1&A|!F&!E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|!F&E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|!F&E&D2&D1&!D&!C1&!C&B1&B&!A1&A|!F&!E&D2&D1&!D&!C1&!C&B1&B&!A1&A|!F&!E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|!F&E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|!F&E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!F&!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!F&!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!F&E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!F&E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!F&!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!F&!E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|!F&E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|!F&E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|!F&!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|!F&!E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|!F&E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|!F&!E&D2&D1&D&!C1&!C&B1&!B&!A1&A|!F&!E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|!F&E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|!F&E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|!F&!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|!F&!E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|!F&!E&D2&!D1&D&C1&!C&B1&!B&!A1&A|!F&!E&D2&D1&D&C1&!C&B1&!B&!A1&A|!F&!E&!D2&D1&D&C1&!C&B1&!B&!A1&A|!F&!E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|!F&!E&D2&D1&!D&C1&!C&B1&!B&!A1&A|!F&!E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|!F&!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!F&!E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|!F&!E&D2&!D1&!D&C1&C&B1&!B&!A1&A|!F&!E&D2&D1&!D&C1&C&B1&!B&!A1&A|!F&!E&!D2&D1&!D&C1&C&B1&!B&!A1&A|!F&!E&!D2&D1&D&C1&C&B1&!B&!A1&A|!F&!E&D2&D1&D&C1&C&B1&!B&!A1&A|!F&!E&D2&!D1&D&C1&C&B1&!B&!A1&A|!F&!E&!D2&!D1&D&C1&C&B1&!B&!A1&A|!F&!E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|!F&!E&D2&!D1&D&!C1&C&B1&!B&!A1&A|!F&!E&D2&D1&D&!C1&C&B1&!B&!A1&A|!F&!E&!D2&D1&D&!C1&C&B1&!B&!A1&A|!F&!E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|!F&!E&D2&D1&!D&!C1&C&B1&!B&!A1&A|!F&!E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|!F&!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!F&!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!F&E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!F&E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!F&!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!F&!E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|!F&E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|!F&E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!F&!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!F&!E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|!F&E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|!F&!E&D2&D1&D&!C1&C&!B1&!B&!A1&A|!F&!E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|!F&E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|!F&E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!F&!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!F&!E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|!F&E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|!F&E&D2&!D1&D&C1&C&!B1&!B&!A1&A|!F&!E&D2&!D1&D&C1&C&!B1&!B&!A1&A|!F&!E&D2&D1&D&C1&C&!B1&!B&!A1&A|!F&E&!D2&D1&D&C1&C&!B1&!B&!A1&A|!F&!E&!D2&D1&D&C1&C&!B1&!B&!A1&A|!F&!E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|!F&E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|!F&E&D2&D1&!D&C1&C&!B1&!B&!A1&A|!F&!E&D2&D1&!D&C1&C&!B1&!B&!A1&A|!F&!E&D2&!D1&!D&C1&C&!B1&!B&!A1&A|!F&E&D2&!D1&!D&C1&C&!B1&!B&!A1&A|!F&E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!F&!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!F&!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!F&E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!F&E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!F&!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!F&!E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|!F&E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|!F&E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!F&!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!F&!E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|!F&E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|!F&!E&D2&D1&D&C1&!C&!B1&!B&!A1&A|!F&!E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|!F&E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|!F&E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!F&!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!F&!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!F&E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!F&E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!F&!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!F&!E&D2&D1&D&!C1&!C&!B1&!B&!A1&A|!F&E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!F&!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!F&!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!F&E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!F&E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!F&!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!F&!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!F&E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!F&E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!F&!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAAOAOI222311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAOI2212 -l AAOAOI2212 -i D1 D C B1 B A1 A -o Y -f Y=(!D1&!D&!C&!B1&!B&!A1&!A|!D1&!D&C&!B1&!B&!A1&!A|!D1&!D&C&B1&!B&!A1&!A|!D1&!D&!C&B1&!B&!A1&!A|!D1&!D&!C&B1&B&!A1&!A|!D1&!D&C&!B1&B&!A1&!A|!D1&!D&!C&!B1&B&!A1&!A|!D1&!D&!C&!B1&B&A1&!A|!D1&!D&C&!B1&B&A1&!A|!D1&!D&!C&B1&B&A1&!A|!D1&!D&!C&B1&!B&A1&!A|!D1&!D&C&B1&!B&A1&!A|!D1&!D&C&!B1&!B&A1&!A|!D1&!D&!C&!B1&!B&A1&!A|!D1&!D&!C&!B1&!B&A1&A|!D1&!D&!C&B1&!B&A1&A|!D1&!D&!C&B1&B&A1&A|!D1&!D&!C&!B1&B&A1&A|!D1&!D&!C&!B1&B&!A1&A|!D1&!D&C&!B1&B&!A1&A|!D1&!D&!C&B1&B&!A1&A|!D1&!D&!C&B1&!B&!A1&A|!D1&!D&C&B1&!B&!A1&A|!D1&!D&C&!B1&!B&!A1&A|!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAOI2212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAOAI22221 -l OOOAOAI22221 -i E D1 D C1 C B1 B A1 A -o Y -f Y=!(E&D1&!D&!C1&!C&!B1&!B&!A1&!A|E&D1&D&!C1&!C&!B1&!B&!A1&!A|E&!D1&D&!C1&!C&!B1&!B&!A1&!A|E&!D1&D&C1&!C&!B1&!B&!A1&!A|E&D1&D&C1&!C&!B1&!B&!A1&!A|E&D1&!D&C1&!C&!B1&!B&!A1&!A|E&D1&!D&C1&C&!B1&!B&!A1&!A|E&D1&D&C1&C&!B1&!B&!A1&!A|E&!D1&D&C1&C&!B1&!B&!A1&!A|E&!D1&D&!C1&C&!B1&!B&!A1&!A|E&D1&D&!C1&C&!B1&!B&!A1&!A|E&D1&!D&!C1&C&!B1&!B&!A1&!A|E&D1&!D&!C1&C&B1&!B&!A1&!A|E&D1&D&!C1&C&B1&!B&!A1&!A|E&!D1&D&!C1&C&B1&!B&!A1&!A|E&!D1&D&C1&C&B1&!B&!A1&!A|E&D1&D&C1&C&B1&!B&!A1&!A|E&D1&!D&C1&C&B1&!B&!A1&!A|E&D1&!D&C1&!C&B1&!B&!A1&!A|E&D1&D&C1&!C&B1&!B&!A1&!A|E&!D1&D&C1&!C&B1&!B&!A1&!A|E&!D1&D&!C1&!C&B1&!B&!A1&!A|E&D1&D&!C1&!C&B1&!B&!A1&!A|E&D1&!D&!C1&!C&B1&!B&!A1&!A|E&D1&!D&!C1&!C&B1&B&!A1&!A|E&D1&D&!C1&!C&B1&B&!A1&!A|E&!D1&D&!C1&!C&B1&B&!A1&!A|E&!D1&D&C1&!C&B1&B&!A1&!A|E&D1&D&C1&!C&B1&B&!A1&!A|E&D1&!D&C1&!C&B1&B&!A1&!A|E&D1&!D&C1&C&B1&B&!A1&!A|E&D1&D&C1&C&B1&B&!A1&!A|E&!D1&D&C1&C&B1&B&!A1&!A|E&!D1&D&!C1&C&B1&B&!A1&!A|E&D1&D&!C1&C&B1&B&!A1&!A|E&D1&!D&!C1&C&B1&B&!A1&!A|E&D1&!D&!C1&C&!B1&B&!A1&!A|E&D1&D&!C1&C&!B1&B&!A1&!A|E&!D1&D&!C1&C&!B1&B&!A1&!A|E&!D1&D&C1&C&!B1&B&!A1&!A|E&D1&D&C1&C&!B1&B&!A1&!A|E&D1&!D&C1&C&!B1&B&!A1&!A|E&D1&!D&C1&!C&!B1&B&!A1&!A|E&D1&D&C1&!C&!B1&B&!A1&!A|E&!D1&D&C1&!C&!B1&B&!A1&!A|E&!D1&D&!C1&!C&!B1&B&!A1&!A|E&D1&D&!C1&!C&!B1&B&!A1&!A|E&D1&!D&!C1&!C&!B1&B&!A1&!A|E&D1&!D&!C1&!C&!B1&B&A1&!A|E&D1&D&!C1&!C&!B1&B&A1&!A|E&!D1&D&!C1&!C&!B1&B&A1&!A|E&!D1&D&C1&!C&!B1&B&A1&!A|E&D1&D&C1&!C&!B1&B&A1&!A|E&D1&!D&C1&!C&!B1&B&A1&!A|E&!D1&!D&C1&!C&!B1&B&A1&!A|E&!D1&!D&C1&C&!B1&B&A1&!A|E&D1&!D&C1&C&!B1&B&A1&!A|E&D1&D&C1&C&!B1&B&A1&!A|E&!D1&D&C1&C&!B1&B&A1&!A|E&!D1&D&!C1&C&!B1&B&A1&!A|E&D1&D&!C1&C&!B1&B&A1&!A|E&D1&!D&!C1&C&!B1&B&A1&!A|E&!D1&!D&!C1&C&!B1&B&A1&!A|E&!D1&!D&!C1&C&B1&B&A1&!A|E&D1&!D&!C1&C&B1&B&A1&!A|E&D1&D&!C1&C&B1&B&A1&!A|E&!D1&D&!C1&C&B1&B&A1&!A|E&!D1&D&C1&C&B1&B&A1&!A|E&D1&D&C1&C&B1&B&A1&!A|E&D1&!D&C1&C&B1&B&A1&!A|E&!D1&!D&C1&C&B1&B&A1&!A|E&!D1&!D&C1&!C&B1&B&A1&!A|E&D1&!D&C1&!C&B1&B&A1&!A|E&D1&D&C1&!C&B1&B&A1&!A|E&!D1&D&C1&!C&B1&B&A1&!A|E&!D1&D&!C1&!C&B1&B&A1&!A|E&D1&D&!C1&!C&B1&B&A1&!A|E&D1&!D&!C1&!C&B1&B&A1&!A|E&D1&!D&!C1&!C&B1&!B&A1&!A|E&D1&D&!C1&!C&B1&!B&A1&!A|E&!D1&D&!C1&!C&B1&!B&A1&!A|E&!D1&D&C1&!C&B1&!B&A1&!A|E&D1&D&C1&!C&B1&!B&A1&!A|E&D1&!D&C1&!C&B1&!B&A1&!A|E&!D1&!D&C1&!C&B1&!B&A1&!A|E&!D1&!D&C1&C&B1&!B&A1&!A|E&D1&!D&C1&C&B1&!B&A1&!A|E&D1&D&C1&C&B1&!B&A1&!A|E&!D1&D&C1&C&B1&!B&A1&!A|E&!D1&D&!C1&C&B1&!B&A1&!A|E&D1&D&!C1&C&B1&!B&A1&!A|E&D1&!D&!C1&C&B1&!B&A1&!A|E&!D1&!D&!C1&C&B1&!B&A1&!A|E&D1&!D&!C1&C&!B1&!B&A1&!A|E&D1&D&!C1&C&!B1&!B&A1&!A|E&!D1&D&!C1&C&!B1&!B&A1&!A|E&!D1&D&C1&C&!B1&!B&A1&!A|E&D1&D&C1&C&!B1&!B&A1&!A|E&D1&!D&C1&C&!B1&!B&A1&!A|E&D1&!D&C1&!C&!B1&!B&A1&!A|E&D1&D&C1&!C&!B1&!B&A1&!A|E&!D1&D&C1&!C&!B1&!B&A1&!A|E&!D1&D&!C1&!C&!B1&!B&A1&!A|E&D1&D&!C1&!C&!B1&!B&A1&!A|E&D1&!D&!C1&!C&!B1&!B&A1&!A|E&D1&!D&!C1&!C&!B1&!B&A1&A|E&D1&D&!C1&!C&!B1&!B&A1&A|E&!D1&D&!C1&!C&!B1&!B&A1&A|E&!D1&D&C1&!C&!B1&!B&A1&A|E&D1&D&C1&!C&!B1&!B&A1&A|E&D1&!D&C1&!C&!B1&!B&A1&A|E&D1&!D&C1&C&!B1&!B&A1&A|E&D1&D&C1&C&!B1&!B&A1&A|E&!D1&D&C1&C&!B1&!B&A1&A|E&!D1&D&!C1&C&!B1&!B&A1&A|E&D1&D&!C1&C&!B1&!B&A1&A|E&D1&!D&!C1&C&!B1&!B&A1&A|E&!D1&!D&!C1&C&B1&!B&A1&A|E&D1&!D&!C1&C&B1&!B&A1&A|E&D1&D&!C1&C&B1&!B&A1&A|E&!D1&D&!C1&C&B1&!B&A1&A|E&!D1&D&C1&C&B1&!B&A1&A|E&D1&D&C1&C&B1&!B&A1&A|E&D1&!D&C1&C&B1&!B&A1&A|E&!D1&!D&C1&C&B1&!B&A1&A|E&!D1&!D&C1&!C&B1&!B&A1&A|E&D1&!D&C1&!C&B1&!B&A1&A|E&D1&D&C1&!C&B1&!B&A1&A|E&!D1&D&C1&!C&B1&!B&A1&A|E&!D1&D&!C1&!C&B1&!B&A1&A|E&D1&D&!C1&!C&B1&!B&A1&A|E&D1&!D&!C1&!C&B1&!B&A1&A|E&D1&!D&!C1&!C&B1&B&A1&A|E&D1&D&!C1&!C&B1&B&A1&A|E&!D1&D&!C1&!C&B1&B&A1&A|E&!D1&D&C1&!C&B1&B&A1&A|E&D1&D&C1&!C&B1&B&A1&A|E&D1&!D&C1&!C&B1&B&A1&A|E&!D1&!D&C1&!C&B1&B&A1&A|E&!D1&!D&C1&C&B1&B&A1&A|E&D1&!D&C1&C&B1&B&A1&A|E&D1&D&C1&C&B1&B&A1&A|E&!D1&D&C1&C&B1&B&A1&A|E&!D1&D&!C1&C&B1&B&A1&A|E&D1&D&!C1&C&B1&B&A1&A|E&D1&!D&!C1&C&B1&B&A1&A|E&!D1&!D&!C1&C&B1&B&A1&A|E&!D1&!D&!C1&C&!B1&B&A1&A|E&D1&!D&!C1&C&!B1&B&A1&A|E&D1&D&!C1&C&!B1&B&A1&A|E&!D1&D&!C1&C&!B1&B&A1&A|E&!D1&D&C1&C&!B1&B&A1&A|E&D1&D&C1&C&!B1&B&A1&A|E&D1&!D&C1&C&!B1&B&A1&A|E&!D1&!D&C1&C&!B1&B&A1&A|E&!D1&!D&C1&!C&!B1&B&A1&A|E&D1&!D&C1&!C&!B1&B&A1&A|E&D1&D&C1&!C&!B1&B&A1&A|E&!D1&D&C1&!C&!B1&B&A1&A|E&!D1&D&!C1&!C&!B1&B&A1&A|E&D1&D&!C1&!C&!B1&B&A1&A|E&D1&!D&!C1&!C&!B1&B&A1&A|E&D1&!D&!C1&!C&!B1&B&!A1&A|E&D1&D&!C1&!C&!B1&B&!A1&A|E&!D1&D&!C1&!C&!B1&B&!A1&A|E&!D1&D&C1&!C&!B1&B&!A1&A|E&D1&D&C1&!C&!B1&B&!A1&A|E&D1&!D&C1&!C&!B1&B&!A1&A|E&!D1&!D&C1&!C&!B1&B&!A1&A|E&!D1&!D&C1&C&!B1&B&!A1&A|E&D1&!D&C1&C&!B1&B&!A1&A|E&D1&D&C1&C&!B1&B&!A1&A|E&!D1&D&C1&C&!B1&B&!A1&A|E&!D1&D&!C1&C&!B1&B&!A1&A|E&D1&D&!C1&C&!B1&B&!A1&A|E&D1&!D&!C1&C&!B1&B&!A1&A|E&!D1&!D&!C1&C&!B1&B&!A1&A|E&!D1&!D&!C1&C&B1&B&!A1&A|E&D1&!D&!C1&C&B1&B&!A1&A|E&D1&D&!C1&C&B1&B&!A1&A|E&!D1&D&!C1&C&B1&B&!A1&A|E&!D1&D&C1&C&B1&B&!A1&A|E&D1&D&C1&C&B1&B&!A1&A|E&D1&!D&C1&C&B1&B&!A1&A|E&!D1&!D&C1&C&B1&B&!A1&A|E&!D1&!D&C1&!C&B1&B&!A1&A|E&D1&!D&C1&!C&B1&B&!A1&A|E&D1&D&C1&!C&B1&B&!A1&A|E&!D1&D&C1&!C&B1&B&!A1&A|E&!D1&D&!C1&!C&B1&B&!A1&A|E&D1&D&!C1&!C&B1&B&!A1&A|E&D1&!D&!C1&!C&B1&B&!A1&A|E&D1&!D&!C1&!C&B1&!B&!A1&A|E&D1&D&!C1&!C&B1&!B&!A1&A|E&!D1&D&!C1&!C&B1&!B&!A1&A|E&!D1&D&C1&!C&B1&!B&!A1&A|E&D1&D&C1&!C&B1&!B&!A1&A|E&D1&!D&C1&!C&B1&!B&!A1&A|E&!D1&!D&C1&!C&B1&!B&!A1&A|E&!D1&!D&C1&C&B1&!B&!A1&A|E&D1&!D&C1&C&B1&!B&!A1&A|E&D1&D&C1&C&B1&!B&!A1&A|E&!D1&D&C1&C&B1&!B&!A1&A|E&!D1&D&!C1&C&B1&!B&!A1&A|E&D1&D&!C1&C&B1&!B&!A1&A|E&D1&!D&!C1&C&B1&!B&!A1&A|E&!D1&!D&!C1&C&B1&!B&!A1&A|E&D1&!D&!C1&C&!B1&!B&!A1&A|E&D1&D&!C1&C&!B1&!B&!A1&A|E&!D1&D&!C1&C&!B1&!B&!A1&A|E&!D1&D&C1&C&!B1&!B&!A1&A|E&D1&D&C1&C&!B1&!B&!A1&A|E&D1&!D&C1&C&!B1&!B&!A1&A|E&D1&!D&C1&!C&!B1&!B&!A1&A|E&D1&D&C1&!C&!B1&!B&!A1&A|E&!D1&D&C1&!C&!B1&!B&!A1&A|E&!D1&D&!C1&!C&!B1&!B&!A1&A|E&D1&D&!C1&!C&!B1&!B&!A1&A|E&D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAOAI22221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAAOI22231 -l OOOAAOI22231 -i E D2 D1 D C1 C B1 B A1 A -o Y -f Y=(!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|!E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|!E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|!E&D2&!D1&D&C1&C&B1&!B&!A1&!A|!E&!D2&D1&D&C1&C&B1&!B&!A1&!A|!E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|!E&D2&D1&!D&C1&C&B1&!B&!A1&!A|!E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|!E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|!E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|!E&D2&!D1&D&C1&!C&B1&B&!A1&!A|!E&!D2&D1&D&C1&!C&B1&B&!A1&!A|!E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|!E&D2&D1&!D&C1&!C&B1&B&!A1&!A|!E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|!E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|!E&D2&!D1&!D&C1&C&B1&B&!A1&!A|!E&D2&D1&!D&C1&C&B1&B&!A1&!A|!E&!D2&D1&!D&C1&C&B1&B&!A1&!A|!E&!D2&D1&D&C1&C&B1&B&!A1&!A|!E&D2&!D1&D&C1&C&B1&B&!A1&!A|!E&!D2&!D1&D&C1&C&B1&B&!A1&!A|!E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|!E&D2&!D1&D&!C1&C&B1&B&!A1&!A|!E&!D2&D1&D&!C1&C&B1&B&!A1&!A|!E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|!E&D2&D1&!D&!C1&C&B1&B&!A1&!A|!E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|!E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|!E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|!E&D2&!D1&D&C1&C&!B1&B&!A1&!A|!E&!D2&D1&D&C1&C&!B1&B&!A1&!A|!E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|!E&D2&D1&!D&C1&C&!B1&B&!A1&!A|!E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|!E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|!E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|!E&D2&!D1&D&!C1&!C&B1&B&A1&!A|!E&!D2&D1&D&!C1&!C&B1&B&A1&!A|!E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|!E&D2&D1&!D&!C1&!C&B1&B&A1&!A|!E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|!E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|!E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|!E&D2&!D1&D&C1&C&!B1&!B&A1&!A|!E&!D2&D1&D&C1&C&!B1&!B&A1&!A|!E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|!E&D2&D1&!D&C1&C&!B1&!B&A1&!A|!E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|!E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|!E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|!E&D2&!D1&D&C1&!C&!B1&!B&A1&A|!E&!D2&D1&D&C1&!C&!B1&!B&A1&A|!E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|!E&D2&D1&!D&C1&!C&!B1&!B&A1&A|!E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|!E&D2&!D1&!D&C1&C&!B1&!B&A1&A|!E&D2&D1&!D&C1&C&!B1&!B&A1&A|!E&!D2&D1&!D&C1&C&!B1&!B&A1&A|!E&!D2&D1&D&C1&C&!B1&!B&A1&A|!E&D2&!D1&D&C1&C&!B1&!B&A1&A|!E&!D2&!D1&D&C1&C&!B1&!B&A1&A|!E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|!E&D2&!D1&D&!C1&C&!B1&!B&A1&A|!E&!D2&D1&D&!C1&C&!B1&!B&A1&A|!E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|!E&D2&D1&!D&!C1&C&!B1&!B&A1&A|!E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|!E&D2&!D1&D&!C1&!C&B1&!B&A1&A|!E&!D2&D1&D&!C1&!C&B1&!B&A1&A|!E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|!E&D2&D1&!D&!C1&!C&B1&!B&A1&A|!E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!E&D2&!D1&!D&!C1&!C&B1&B&A1&A|!E&D2&D1&!D&!C1&!C&B1&B&A1&A|!E&!D2&D1&!D&!C1&!C&B1&B&A1&A|!E&!D2&D1&D&!C1&!C&B1&B&A1&A|!E&D2&!D1&D&!C1&!C&B1&B&A1&A|!E&!D2&!D1&D&!C1&!C&B1&B&A1&A|!E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|!E&D2&!D1&D&!C1&!C&!B1&B&A1&A|!E&!D2&D1&D&!C1&!C&!B1&B&A1&A|!E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|!E&D2&D1&!D&!C1&!C&!B1&B&A1&A|!E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|!E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|!E&D2&!D1&D&!C1&!C&B1&B&!A1&A|!E&!D2&D1&D&!C1&!C&B1&B&!A1&A|!E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|!E&D2&D1&!D&!C1&!C&B1&B&!A1&A|!E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|!E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|!E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|!E&D2&!D1&D&C1&C&!B1&!B&!A1&A|!E&!D2&D1&D&C1&C&!B1&!B&!A1&A|!E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|!E&D2&D1&!D&C1&C&!B1&!B&!A1&A|!E&D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|!E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAAOI22231.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOAI3121 -l OAAOAI3121 -i D C1 C B A2 A1 A -o Y -f Y=!(D&C1&C&!B&!A2&!A1&!A|D&C1&C&B&!A2&!A1&!A|D&!C1&!C&B&A2&!A1&!A|D&C1&!C&B&A2&!A1&!A|D&C1&C&B&A2&!A1&!A|D&!C1&C&B&A2&!A1&!A|D&C1&C&!B&A2&!A1&!A|D&C1&C&!B&A2&A1&!A|D&!C1&C&B&A2&A1&!A|D&C1&C&B&A2&A1&!A|D&C1&!C&B&A2&A1&!A|D&!C1&!C&B&A2&A1&!A|D&!C1&!C&B&!A2&A1&!A|D&C1&!C&B&!A2&A1&!A|D&C1&C&B&!A2&A1&!A|D&!C1&C&B&!A2&A1&!A|D&C1&C&!B&!A2&A1&!A|D&C1&C&!B&!A2&A1&A|D&!C1&C&B&!A2&A1&A|D&C1&C&B&!A2&A1&A|D&C1&!C&B&!A2&A1&A|D&!C1&!C&B&!A2&A1&A|D&!C1&!C&B&A2&A1&A|D&C1&!C&B&A2&A1&A|D&C1&C&B&A2&A1&A|D&!C1&C&B&A2&A1&A|D&C1&C&!B&A2&A1&A|D&C1&C&!B&A2&!A1&A|D&!C1&C&B&A2&!A1&A|D&C1&C&B&A2&!A1&A|D&C1&!C&B&A2&!A1&A|D&!C1&!C&B&A2&!A1&A|D&!C1&!C&B&!A2&!A1&A|D&C1&!C&B&!A2&!A1&A|D&C1&C&B&!A2&!A1&A|D&!C1&C&B&!A2&!A1&A|D&C1&C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOAI3121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOOAOI22231 -l OOAAOOAOI22231 -i E D2 D1 D C1 C B1 B A1 A -o Y -f Y=(!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|!E&D2&D1&D&!C1&C&B1&!B&!A1&!A|!E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|!E&D2&D1&D&C1&!C&B1&!B&!A1&!A|!E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|!E&D2&D1&D&!C1&!C&B1&B&!A1&!A|!E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|!E&D2&!D1&D&C1&!C&B1&B&!A1&!A|!E&D2&D1&D&C1&!C&B1&B&!A1&!A|!E&!D2&D1&D&C1&!C&B1&B&!A1&!A|!E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|!E&D2&D1&!D&C1&!C&B1&B&!A1&!A|!E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|!E&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!E&!D2&!D1&!D&C1&C&B1&B&!A1&!A|!E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|!E&D2&!D1&D&!C1&C&B1&B&!A1&!A|!E&D2&D1&D&!C1&C&B1&B&!A1&!A|!E&!D2&D1&D&!C1&C&B1&B&!A1&!A|!E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|!E&D2&D1&!D&!C1&C&B1&B&!A1&!A|!E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|!E&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|!E&D2&D1&D&!C1&C&!B1&B&!A1&!A|!E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|!E&D2&D1&D&C1&!C&!B1&B&!A1&!A|!E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|!E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|!E&!D2&!D1&!D&C1&C&B1&B&A1&!A|!E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|!E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|!E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|!E&D2&D1&D&!C1&C&!B1&!B&A1&!A|!E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|!E&D2&D1&D&C1&!C&!B1&!B&A1&!A|!E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|!E&D2&D1&D&!C1&!C&!B1&!B&A1&A|!E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|!E&D2&!D1&D&C1&!C&!B1&!B&A1&A|!E&D2&D1&D&C1&!C&!B1&!B&A1&A|!E&!D2&D1&D&C1&!C&!B1&!B&A1&A|!E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|!E&D2&D1&!D&C1&!C&!B1&!B&A1&A|!E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!E&!D2&!D1&!D&C1&C&!B1&!B&A1&A|!E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|!E&D2&!D1&D&!C1&C&!B1&!B&A1&A|!E&D2&D1&D&!C1&C&!B1&!B&A1&A|!E&!D2&D1&D&!C1&C&!B1&!B&A1&A|!E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|!E&D2&D1&!D&!C1&C&!B1&!B&A1&A|!E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|!E&!D2&!D1&!D&C1&C&B1&!B&A1&A|!E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!E&!D2&!D1&!D&C1&!C&B1&B&A1&A|!E&!D2&!D1&!D&C1&C&B1&B&A1&A|!E&!D2&!D1&!D&!C1&C&B1&B&A1&A|!E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|!E&!D2&!D1&!D&C1&C&!B1&B&A1&A|!E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|!E&!D2&!D1&!D&C1&C&B1&B&!A1&A|!E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|!E&D2&D1&D&!C1&C&!B1&!B&!A1&A|!E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|!E&D2&D1&D&C1&!C&!B1&!B&!A1&A|!E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOOAOI22231.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAI2223 -l AAOOAI2223 -i D2 D1 D C1 C B1 B A1 A -o Y -f Y=!(!D2&!D1&D&C1&!C&B1&B&!A1&!A|D2&!D1&D&C1&!C&B1&B&!A1&!A|D2&D1&D&C1&!C&B1&B&!A1&!A|!D2&D1&D&C1&!C&B1&B&!A1&!A|!D2&D1&!D&C1&!C&B1&B&!A1&!A|D2&D1&!D&C1&!C&B1&B&!A1&!A|D2&!D1&!D&C1&!C&B1&B&!A1&!A|D2&!D1&!D&C1&C&B1&B&!A1&!A|D2&D1&!D&C1&C&B1&B&!A1&!A|!D2&D1&!D&C1&C&B1&B&!A1&!A|!D2&D1&D&C1&C&B1&B&!A1&!A|D2&D1&D&C1&C&B1&B&!A1&!A|D2&!D1&D&C1&C&B1&B&!A1&!A|!D2&!D1&D&C1&C&B1&B&!A1&!A|!D2&!D1&D&!C1&C&B1&B&!A1&!A|D2&!D1&D&!C1&C&B1&B&!A1&!A|D2&D1&D&!C1&C&B1&B&!A1&!A|!D2&D1&D&!C1&C&B1&B&!A1&!A|!D2&D1&!D&!C1&C&B1&B&!A1&!A|D2&D1&!D&!C1&C&B1&B&!A1&!A|D2&!D1&!D&!C1&C&B1&B&!A1&!A|D2&!D1&!D&!C1&C&B1&B&A1&!A|D2&D1&!D&!C1&C&B1&B&A1&!A|!D2&D1&!D&!C1&C&B1&B&A1&!A|!D2&D1&D&!C1&C&B1&B&A1&!A|D2&D1&D&!C1&C&B1&B&A1&!A|D2&!D1&D&!C1&C&B1&B&A1&!A|!D2&!D1&D&!C1&C&B1&B&A1&!A|!D2&!D1&D&C1&C&B1&B&A1&!A|D2&!D1&D&C1&C&B1&B&A1&!A|D2&D1&D&C1&C&B1&B&A1&!A|!D2&D1&D&C1&C&B1&B&A1&!A|!D2&D1&!D&C1&C&B1&B&A1&!A|D2&D1&!D&C1&C&B1&B&A1&!A|D2&!D1&!D&C1&C&B1&B&A1&!A|D2&!D1&!D&C1&!C&B1&B&A1&!A|D2&D1&!D&C1&!C&B1&B&A1&!A|!D2&D1&!D&C1&!C&B1&B&A1&!A|!D2&D1&D&C1&!C&B1&B&A1&!A|D2&D1&D&C1&!C&B1&B&A1&!A|D2&!D1&D&C1&!C&B1&B&A1&!A|!D2&!D1&D&C1&!C&B1&B&A1&!A|!D2&!D1&D&C1&!C&!B1&!B&A1&A|D2&!D1&D&C1&!C&!B1&!B&A1&A|D2&D1&D&C1&!C&!B1&!B&A1&A|!D2&D1&D&C1&!C&!B1&!B&A1&A|!D2&D1&!D&C1&!C&!B1&!B&A1&A|D2&D1&!D&C1&!C&!B1&!B&A1&A|D2&!D1&!D&C1&!C&!B1&!B&A1&A|D2&!D1&!D&C1&C&!B1&!B&A1&A|D2&D1&!D&C1&C&!B1&!B&A1&A|!D2&D1&!D&C1&C&!B1&!B&A1&A|!D2&D1&D&C1&C&!B1&!B&A1&A|D2&D1&D&C1&C&!B1&!B&A1&A|D2&!D1&D&C1&C&!B1&!B&A1&A|!D2&!D1&D&C1&C&!B1&!B&A1&A|!D2&!D1&D&!C1&C&!B1&!B&A1&A|D2&!D1&D&!C1&C&!B1&!B&A1&A|D2&D1&D&!C1&C&!B1&!B&A1&A|!D2&D1&D&!C1&C&!B1&!B&A1&A|!D2&D1&!D&!C1&C&!B1&!B&A1&A|D2&D1&!D&!C1&C&!B1&!B&A1&A|D2&!D1&!D&!C1&C&!B1&!B&A1&A|D2&!D1&!D&!C1&C&B1&!B&A1&A|D2&D1&!D&!C1&C&B1&!B&A1&A|!D2&D1&!D&!C1&C&B1&!B&A1&A|!D2&D1&D&!C1&C&B1&!B&A1&A|D2&D1&D&!C1&C&B1&!B&A1&A|D2&!D1&D&!C1&C&B1&!B&A1&A|!D2&!D1&D&!C1&C&B1&!B&A1&A|!D2&!D1&D&C1&C&B1&!B&A1&A|D2&!D1&D&C1&C&B1&!B&A1&A|D2&D1&D&C1&C&B1&!B&A1&A|!D2&D1&D&C1&C&B1&!B&A1&A|!D2&D1&!D&C1&C&B1&!B&A1&A|D2&D1&!D&C1&C&B1&!B&A1&A|D2&!D1&!D&C1&C&B1&!B&A1&A|D2&!D1&!D&C1&!C&B1&!B&A1&A|D2&D1&!D&C1&!C&B1&!B&A1&A|!D2&D1&!D&C1&!C&B1&!B&A1&A|!D2&D1&D&C1&!C&B1&!B&A1&A|D2&D1&D&C1&!C&B1&!B&A1&A|D2&!D1&D&C1&!C&B1&!B&A1&A|!D2&!D1&D&C1&!C&B1&!B&A1&A|!D2&!D1&D&C1&!C&B1&B&A1&A|D2&!D1&D&C1&!C&B1&B&A1&A|D2&D1&D&C1&!C&B1&B&A1&A|!D2&D1&D&C1&!C&B1&B&A1&A|!D2&D1&!D&C1&!C&B1&B&A1&A|D2&D1&!D&C1&!C&B1&B&A1&A|D2&!D1&!D&C1&!C&B1&B&A1&A|D2&!D1&!D&C1&C&B1&B&A1&A|D2&D1&!D&C1&C&B1&B&A1&A|!D2&D1&!D&C1&C&B1&B&A1&A|!D2&D1&D&C1&C&B1&B&A1&A|D2&D1&D&C1&C&B1&B&A1&A|D2&!D1&D&C1&C&B1&B&A1&A|!D2&!D1&D&C1&C&B1&B&A1&A|!D2&!D1&D&!C1&C&B1&B&A1&A|D2&!D1&D&!C1&C&B1&B&A1&A|D2&D1&D&!C1&C&B1&B&A1&A|!D2&D1&D&!C1&C&B1&B&A1&A|!D2&D1&!D&!C1&C&B1&B&A1&A|D2&D1&!D&!C1&C&B1&B&A1&A|D2&!D1&!D&!C1&C&B1&B&A1&A|D2&!D1&!D&!C1&C&!B1&B&A1&A|D2&D1&!D&!C1&C&!B1&B&A1&A|!D2&D1&!D&!C1&C&!B1&B&A1&A|!D2&D1&D&!C1&C&!B1&B&A1&A|D2&D1&D&!C1&C&!B1&B&A1&A|D2&!D1&D&!C1&C&!B1&B&A1&A|!D2&!D1&D&!C1&C&!B1&B&A1&A|!D2&!D1&D&C1&C&!B1&B&A1&A|D2&!D1&D&C1&C&!B1&B&A1&A|D2&D1&D&C1&C&!B1&B&A1&A|!D2&D1&D&C1&C&!B1&B&A1&A|!D2&D1&!D&C1&C&!B1&B&A1&A|D2&D1&!D&C1&C&!B1&B&A1&A|D2&!D1&!D&C1&C&!B1&B&A1&A|D2&!D1&!D&C1&!C&!B1&B&A1&A|D2&D1&!D&C1&!C&!B1&B&A1&A|!D2&D1&!D&C1&!C&!B1&B&A1&A|!D2&D1&D&C1&!C&!B1&B&A1&A|D2&D1&D&C1&!C&!B1&B&A1&A|D2&!D1&D&C1&!C&!B1&B&A1&A|!D2&!D1&D&C1&!C&!B1&B&A1&A|D2&!D1&!D&!C1&C&B1&B&!A1&A|D2&D1&!D&!C1&C&B1&B&!A1&A|!D2&D1&!D&!C1&C&B1&B&!A1&A|!D2&D1&D&!C1&C&B1&B&!A1&A|D2&D1&D&!C1&C&B1&B&!A1&A|D2&!D1&D&!C1&C&B1&B&!A1&A|!D2&!D1&D&!C1&C&B1&B&!A1&A|!D2&!D1&D&C1&C&B1&B&!A1&A|D2&!D1&D&C1&C&B1&B&!A1&A|D2&D1&D&C1&C&B1&B&!A1&A|!D2&D1&D&C1&C&B1&B&!A1&A|!D2&D1&!D&C1&C&B1&B&!A1&A|D2&D1&!D&C1&C&B1&B&!A1&A|D2&!D1&!D&C1&C&B1&B&!A1&A|D2&!D1&!D&C1&!C&B1&B&!A1&A|D2&D1&!D&C1&!C&B1&B&!A1&A|!D2&D1&!D&C1&!C&B1&B&!A1&A|!D2&D1&D&C1&!C&B1&B&!A1&A|D2&D1&D&C1&!C&B1&B&!A1&A|D2&!D1&D&C1&!C&B1&B&!A1&A|!D2&!D1&D&C1&!C&B1&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAI2223.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n NOR3 -l NOR3 -i A2 A1 A -o Y -f Y=(!A2&!A1&!A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist NOR3.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOAOI212211 -l OAAOOAOI212211 -i F E D1 D C1 C B A1 A -o Y -f Y=(!F&!E&!D1&!D&!C1&!C&!B&!A1&!A|!F&E&!D1&!D&!C1&!C&!B&!A1&!A|!F&E&D1&!D&!C1&!C&!B&!A1&!A|!F&!E&D1&!D&!C1&!C&!B&!A1&!A|!F&!E&D1&D&!C1&!C&!B&!A1&!A|!F&E&D1&D&!C1&!C&!B&!A1&!A|!F&E&!D1&D&!C1&!C&!B&!A1&!A|!F&!E&!D1&D&!C1&!C&!B&!A1&!A|!F&!E&!D1&D&C1&!C&!B&!A1&!A|!F&E&!D1&D&C1&!C&!B&!A1&!A|!F&E&D1&D&C1&!C&!B&!A1&!A|!F&!E&D1&D&C1&!C&!B&!A1&!A|!F&!E&D1&!D&C1&!C&!B&!A1&!A|!F&E&D1&!D&C1&!C&!B&!A1&!A|!F&E&!D1&!D&C1&!C&!B&!A1&!A|!F&!E&!D1&!D&C1&!C&!B&!A1&!A|!F&!E&!D1&!D&C1&C&!B&!A1&!A|!F&E&!D1&!D&C1&C&!B&!A1&!A|!F&!E&D1&!D&C1&C&!B&!A1&!A|!F&!E&D1&D&C1&C&!B&!A1&!A|!F&!E&!D1&D&C1&C&!B&!A1&!A|!F&!E&!D1&D&!C1&C&!B&!A1&!A|!F&E&!D1&D&!C1&C&!B&!A1&!A|!F&E&D1&D&!C1&C&!B&!A1&!A|!F&!E&D1&D&!C1&C&!B&!A1&!A|!F&!E&D1&!D&!C1&C&!B&!A1&!A|!F&E&D1&!D&!C1&C&!B&!A1&!A|!F&E&!D1&!D&!C1&C&!B&!A1&!A|!F&!E&!D1&!D&!C1&C&!B&!A1&!A|!F&!E&!D1&!D&!C1&C&B&!A1&!A|!F&E&!D1&!D&!C1&C&B&!A1&!A|!F&E&D1&!D&!C1&C&B&!A1&!A|!F&!E&D1&!D&!C1&C&B&!A1&!A|!F&!E&D1&D&!C1&C&B&!A1&!A|!F&E&D1&D&!C1&C&B&!A1&!A|!F&E&!D1&D&!C1&C&B&!A1&!A|!F&!E&!D1&D&!C1&C&B&!A1&!A|!F&!E&!D1&D&C1&C&B&!A1&!A|!F&!E&D1&D&C1&C&B&!A1&!A|!F&!E&D1&!D&C1&C&B&!A1&!A|!F&E&!D1&!D&C1&C&B&!A1&!A|!F&!E&!D1&!D&C1&C&B&!A1&!A|!F&!E&!D1&!D&C1&!C&B&!A1&!A|!F&E&!D1&!D&C1&!C&B&!A1&!A|!F&E&D1&!D&C1&!C&B&!A1&!A|!F&!E&D1&!D&C1&!C&B&!A1&!A|!F&!E&D1&D&C1&!C&B&!A1&!A|!F&E&D1&D&C1&!C&B&!A1&!A|!F&E&!D1&D&C1&!C&B&!A1&!A|!F&!E&!D1&D&C1&!C&B&!A1&!A|!F&!E&!D1&D&!C1&!C&B&!A1&!A|!F&E&!D1&D&!C1&!C&B&!A1&!A|!F&E&D1&D&!C1&!C&B&!A1&!A|!F&!E&D1&D&!C1&!C&B&!A1&!A|!F&!E&D1&!D&!C1&!C&B&!A1&!A|!F&E&D1&!D&!C1&!C&B&!A1&!A|!F&E&!D1&!D&!C1&!C&B&!A1&!A|!F&!E&!D1&!D&!C1&!C&B&!A1&!A|!F&!E&!D1&!D&!C1&!C&B&A1&!A|!F&E&!D1&!D&!C1&!C&B&A1&!A|!F&!E&D1&!D&!C1&!C&B&A1&!A|!F&!E&D1&D&!C1&!C&B&A1&!A|!F&!E&!D1&D&!C1&!C&B&A1&!A|!F&!E&!D1&D&C1&!C&B&A1&!A|!F&!E&D1&D&C1&!C&B&A1&!A|!F&!E&D1&!D&C1&!C&B&A1&!A|!F&E&!D1&!D&C1&!C&B&A1&!A|!F&!E&!D1&!D&C1&!C&B&A1&!A|!F&!E&!D1&!D&C1&C&B&A1&!A|!F&E&!D1&!D&C1&C&B&A1&!A|!F&!E&D1&!D&C1&C&B&A1&!A|!F&!E&D1&D&C1&C&B&A1&!A|!F&!E&!D1&D&C1&C&B&A1&!A|!F&!E&!D1&D&!C1&C&B&A1&!A|!F&!E&D1&D&!C1&C&B&A1&!A|!F&!E&D1&!D&!C1&C&B&A1&!A|!F&E&!D1&!D&!C1&C&B&A1&!A|!F&!E&!D1&!D&!C1&C&B&A1&!A|!F&!E&!D1&!D&!C1&C&!B&A1&!A|!F&E&!D1&!D&!C1&C&!B&A1&!A|!F&E&D1&!D&!C1&C&!B&A1&!A|!F&!E&D1&!D&!C1&C&!B&A1&!A|!F&!E&D1&D&!C1&C&!B&A1&!A|!F&E&D1&D&!C1&C&!B&A1&!A|!F&E&!D1&D&!C1&C&!B&A1&!A|!F&!E&!D1&D&!C1&C&!B&A1&!A|!F&!E&!D1&D&C1&C&!B&A1&!A|!F&!E&D1&D&C1&C&!B&A1&!A|!F&!E&D1&!D&C1&C&!B&A1&!A|!F&E&!D1&!D&C1&C&!B&A1&!A|!F&!E&!D1&!D&C1&C&!B&A1&!A|!F&!E&!D1&!D&C1&!C&!B&A1&!A|!F&E&!D1&!D&C1&!C&!B&A1&!A|!F&E&D1&!D&C1&!C&!B&A1&!A|!F&!E&D1&!D&C1&!C&!B&A1&!A|!F&!E&D1&D&C1&!C&!B&A1&!A|!F&E&D1&D&C1&!C&!B&A1&!A|!F&E&!D1&D&C1&!C&!B&A1&!A|!F&!E&!D1&D&C1&!C&!B&A1&!A|!F&!E&!D1&D&!C1&!C&!B&A1&!A|!F&E&!D1&D&!C1&!C&!B&A1&!A|!F&E&D1&D&!C1&!C&!B&A1&!A|!F&!E&D1&D&!C1&!C&!B&A1&!A|!F&!E&D1&!D&!C1&!C&!B&A1&!A|!F&E&D1&!D&!C1&!C&!B&A1&!A|!F&E&!D1&!D&!C1&!C&!B&A1&!A|!F&!E&!D1&!D&!C1&!C&!B&A1&!A|!F&!E&!D1&!D&!C1&!C&!B&A1&A|!F&E&!D1&!D&!C1&!C&!B&A1&A|!F&E&D1&!D&!C1&!C&!B&A1&A|!F&!E&D1&!D&!C1&!C&!B&A1&A|!F&!E&D1&D&!C1&!C&!B&A1&A|!F&E&D1&D&!C1&!C&!B&A1&A|!F&E&!D1&D&!C1&!C&!B&A1&A|!F&!E&!D1&D&!C1&!C&!B&A1&A|!F&!E&!D1&D&C1&!C&!B&A1&A|!F&E&!D1&D&C1&!C&!B&A1&A|!F&E&D1&D&C1&!C&!B&A1&A|!F&!E&D1&D&C1&!C&!B&A1&A|!F&!E&D1&!D&C1&!C&!B&A1&A|!F&E&D1&!D&C1&!C&!B&A1&A|!F&E&!D1&!D&C1&!C&!B&A1&A|!F&!E&!D1&!D&C1&!C&!B&A1&A|!F&!E&!D1&!D&C1&C&!B&A1&A|!F&E&!D1&!D&C1&C&!B&A1&A|!F&!E&D1&!D&C1&C&!B&A1&A|!F&!E&D1&D&C1&C&!B&A1&A|!F&!E&!D1&D&C1&C&!B&A1&A|!F&!E&!D1&D&!C1&C&!B&A1&A|!F&E&!D1&D&!C1&C&!B&A1&A|!F&E&D1&D&!C1&C&!B&A1&A|!F&!E&D1&D&!C1&C&!B&A1&A|!F&!E&D1&!D&!C1&C&!B&A1&A|!F&E&D1&!D&!C1&C&!B&A1&A|!F&E&!D1&!D&!C1&C&!B&A1&A|!F&!E&!D1&!D&!C1&C&!B&A1&A|!F&!E&!D1&!D&!C1&C&B&A1&A|!F&E&!D1&!D&!C1&C&B&A1&A|!F&!E&D1&!D&!C1&C&B&A1&A|!F&!E&D1&D&!C1&C&B&A1&A|!F&!E&!D1&D&!C1&C&B&A1&A|!F&!E&!D1&D&C1&C&B&A1&A|!F&!E&D1&D&C1&C&B&A1&A|!F&!E&D1&!D&C1&C&B&A1&A|!F&E&!D1&!D&C1&C&B&A1&A|!F&!E&!D1&!D&C1&C&B&A1&A|!F&!E&!D1&!D&C1&!C&B&A1&A|!F&E&!D1&!D&C1&!C&B&A1&A|!F&!E&D1&!D&C1&!C&B&A1&A|!F&!E&D1&D&C1&!C&B&A1&A|!F&!E&!D1&D&C1&!C&B&A1&A|!F&!E&!D1&D&!C1&!C&B&A1&A|!F&!E&D1&D&!C1&!C&B&A1&A|!F&!E&D1&!D&!C1&!C&B&A1&A|!F&E&!D1&!D&!C1&!C&B&A1&A|!F&!E&!D1&!D&!C1&!C&B&A1&A|!F&!E&!D1&!D&!C1&!C&B&!A1&A|!F&E&!D1&!D&!C1&!C&B&!A1&A|!F&!E&D1&!D&!C1&!C&B&!A1&A|!F&!E&D1&D&!C1&!C&B&!A1&A|!F&!E&!D1&D&!C1&!C&B&!A1&A|!F&!E&!D1&D&C1&!C&B&!A1&A|!F&!E&D1&D&C1&!C&B&!A1&A|!F&!E&D1&!D&C1&!C&B&!A1&A|!F&E&!D1&!D&C1&!C&B&!A1&A|!F&!E&!D1&!D&C1&!C&B&!A1&A|!F&!E&!D1&!D&C1&C&B&!A1&A|!F&E&!D1&!D&C1&C&B&!A1&A|!F&!E&D1&!D&C1&C&B&!A1&A|!F&!E&D1&D&C1&C&B&!A1&A|!F&!E&!D1&D&C1&C&B&!A1&A|!F&!E&!D1&D&!C1&C&B&!A1&A|!F&!E&D1&D&!C1&C&B&!A1&A|!F&!E&D1&!D&!C1&C&B&!A1&A|!F&E&!D1&!D&!C1&C&B&!A1&A|!F&!E&!D1&!D&!C1&C&B&!A1&A|!F&!E&!D1&!D&!C1&C&!B&!A1&A|!F&E&!D1&!D&!C1&C&!B&!A1&A|!F&E&D1&!D&!C1&C&!B&!A1&A|!F&!E&D1&!D&!C1&C&!B&!A1&A|!F&!E&D1&D&!C1&C&!B&!A1&A|!F&E&D1&D&!C1&C&!B&!A1&A|!F&E&!D1&D&!C1&C&!B&!A1&A|!F&!E&!D1&D&!C1&C&!B&!A1&A|!F&!E&!D1&D&C1&C&!B&!A1&A|!F&!E&D1&D&C1&C&!B&!A1&A|!F&!E&D1&!D&C1&C&!B&!A1&A|!F&E&!D1&!D&C1&C&!B&!A1&A|!F&!E&!D1&!D&C1&C&!B&!A1&A|!F&!E&!D1&!D&C1&!C&!B&!A1&A|!F&E&!D1&!D&C1&!C&!B&!A1&A|!F&E&D1&!D&C1&!C&!B&!A1&A|!F&!E&D1&!D&C1&!C&!B&!A1&A|!F&!E&D1&D&C1&!C&!B&!A1&A|!F&E&D1&D&C1&!C&!B&!A1&A|!F&E&!D1&D&C1&!C&!B&!A1&A|!F&!E&!D1&D&C1&!C&!B&!A1&A|!F&!E&!D1&D&!C1&!C&!B&!A1&A|!F&E&!D1&D&!C1&!C&!B&!A1&A|!F&E&D1&D&!C1&!C&!B&!A1&A|!F&!E&D1&D&!C1&!C&!B&!A1&A|!F&!E&D1&!D&!C1&!C&!B&!A1&A|!F&E&D1&!D&!C1&!C&!B&!A1&A|!F&E&!D1&!D&!C1&!C&!B&!A1&A|!F&!E&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOAOI212211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOAI212211 -l AOOAAOAI212211 -i F E D1 D C1 C B A1 A -o Y -f Y=!(F&E&!D1&!D&!C1&!C&!B&!A1&!A|F&E&D1&!D&!C1&!C&!B&!A1&!A|F&!E&D1&D&!C1&!C&!B&!A1&!A|F&E&D1&D&!C1&!C&!B&!A1&!A|F&E&!D1&D&!C1&!C&!B&!A1&!A|F&E&!D1&D&C1&!C&!B&!A1&!A|F&E&D1&D&C1&!C&!B&!A1&!A|F&!E&D1&D&C1&!C&!B&!A1&!A|F&E&D1&!D&C1&!C&!B&!A1&!A|F&E&!D1&!D&C1&!C&!B&!A1&!A|F&E&!D1&!D&C1&C&!B&!A1&!A|F&E&D1&!D&C1&C&!B&!A1&!A|F&!E&D1&D&C1&C&!B&!A1&!A|F&E&D1&D&C1&C&!B&!A1&!A|F&E&!D1&D&C1&C&!B&!A1&!A|F&E&!D1&D&!C1&C&!B&!A1&!A|F&E&D1&D&!C1&C&!B&!A1&!A|F&!E&D1&D&!C1&C&!B&!A1&!A|F&E&D1&!D&!C1&C&!B&!A1&!A|F&E&!D1&!D&!C1&C&!B&!A1&!A|F&!E&!D1&!D&!C1&C&B&!A1&!A|F&E&!D1&!D&!C1&C&B&!A1&!A|F&E&D1&!D&!C1&C&B&!A1&!A|F&!E&D1&!D&!C1&C&B&!A1&!A|F&!E&D1&D&!C1&C&B&!A1&!A|F&E&D1&D&!C1&C&B&!A1&!A|F&E&!D1&D&!C1&C&B&!A1&!A|F&!E&!D1&D&!C1&C&B&!A1&!A|F&!E&!D1&D&C1&C&B&!A1&!A|F&E&!D1&D&C1&C&B&!A1&!A|F&E&D1&D&C1&C&B&!A1&!A|F&!E&D1&D&C1&C&B&!A1&!A|F&!E&D1&!D&C1&C&B&!A1&!A|F&E&D1&!D&C1&C&B&!A1&!A|F&E&!D1&!D&C1&C&B&!A1&!A|F&!E&!D1&!D&C1&C&B&!A1&!A|F&!E&!D1&!D&C1&!C&B&!A1&!A|F&E&!D1&!D&C1&!C&B&!A1&!A|F&E&D1&!D&C1&!C&B&!A1&!A|F&!E&D1&!D&C1&!C&B&!A1&!A|F&!E&D1&D&C1&!C&B&!A1&!A|F&E&D1&D&C1&!C&B&!A1&!A|F&E&!D1&D&C1&!C&B&!A1&!A|F&!E&!D1&D&C1&!C&B&!A1&!A|F&E&!D1&D&!C1&!C&B&!A1&!A|F&E&D1&D&!C1&!C&B&!A1&!A|F&!E&D1&D&!C1&!C&B&!A1&!A|F&E&D1&!D&!C1&!C&B&!A1&!A|F&E&!D1&!D&!C1&!C&B&!A1&!A|F&E&!D1&!D&!C1&!C&B&A1&!A|F&E&D1&!D&!C1&!C&B&A1&!A|F&!E&D1&D&!C1&!C&B&A1&!A|F&E&D1&D&!C1&!C&B&A1&!A|F&E&!D1&D&!C1&!C&B&A1&!A|F&!E&!D1&D&C1&!C&B&A1&!A|F&E&!D1&D&C1&!C&B&A1&!A|F&E&D1&D&C1&!C&B&A1&!A|F&!E&D1&D&C1&!C&B&A1&!A|F&!E&D1&!D&C1&!C&B&A1&!A|F&E&D1&!D&C1&!C&B&A1&!A|F&E&!D1&!D&C1&!C&B&A1&!A|F&!E&!D1&!D&C1&!C&B&A1&!A|F&!E&!D1&!D&C1&C&B&A1&!A|F&E&!D1&!D&C1&C&B&A1&!A|F&E&D1&!D&C1&C&B&A1&!A|F&!E&D1&!D&C1&C&B&A1&!A|F&!E&D1&D&C1&C&B&A1&!A|F&E&D1&D&C1&C&B&A1&!A|F&E&!D1&D&C1&C&B&A1&!A|F&!E&!D1&D&C1&C&B&A1&!A|F&!E&!D1&D&!C1&C&B&A1&!A|F&E&!D1&D&!C1&C&B&A1&!A|F&E&D1&D&!C1&C&B&A1&!A|F&!E&D1&D&!C1&C&B&A1&!A|F&!E&D1&!D&!C1&C&B&A1&!A|F&E&D1&!D&!C1&C&B&A1&!A|F&E&!D1&!D&!C1&C&B&A1&!A|F&!E&!D1&!D&!C1&C&B&A1&!A|F&E&!D1&!D&!C1&C&!B&A1&!A|F&E&D1&!D&!C1&C&!B&A1&!A|F&!E&D1&D&!C1&C&!B&A1&!A|F&E&D1&D&!C1&C&!B&A1&!A|F&E&!D1&D&!C1&C&!B&A1&!A|F&E&!D1&D&C1&C&!B&A1&!A|F&E&D1&D&C1&C&!B&A1&!A|F&!E&D1&D&C1&C&!B&A1&!A|F&E&D1&!D&C1&C&!B&A1&!A|F&E&!D1&!D&C1&C&!B&A1&!A|F&E&!D1&!D&C1&!C&!B&A1&!A|F&E&D1&!D&C1&!C&!B&A1&!A|F&!E&D1&D&C1&!C&!B&A1&!A|F&E&D1&D&C1&!C&!B&A1&!A|F&E&!D1&D&C1&!C&!B&A1&!A|F&E&!D1&D&!C1&!C&!B&A1&!A|F&E&D1&D&!C1&!C&!B&A1&!A|F&!E&D1&D&!C1&!C&!B&A1&!A|F&E&D1&!D&!C1&!C&!B&A1&!A|F&E&!D1&!D&!C1&!C&!B&A1&!A|F&E&!D1&!D&!C1&!C&!B&A1&A|F&E&D1&!D&!C1&!C&!B&A1&A|F&!E&D1&D&!C1&!C&!B&A1&A|F&E&D1&D&!C1&!C&!B&A1&A|F&E&!D1&D&!C1&!C&!B&A1&A|F&!E&!D1&D&C1&!C&!B&A1&A|F&E&!D1&D&C1&!C&!B&A1&A|F&E&D1&D&C1&!C&!B&A1&A|F&!E&D1&D&C1&!C&!B&A1&A|F&!E&D1&!D&C1&!C&!B&A1&A|F&E&D1&!D&C1&!C&!B&A1&A|F&E&!D1&!D&C1&!C&!B&A1&A|F&!E&!D1&!D&C1&!C&!B&A1&A|F&!E&!D1&!D&C1&C&!B&A1&A|F&E&!D1&!D&C1&C&!B&A1&A|F&E&D1&!D&C1&C&!B&A1&A|F&!E&D1&!D&C1&C&!B&A1&A|F&!E&D1&D&C1&C&!B&A1&A|F&E&D1&D&C1&C&!B&A1&A|F&E&!D1&D&C1&C&!B&A1&A|F&!E&!D1&D&C1&C&!B&A1&A|F&!E&!D1&D&!C1&C&!B&A1&A|F&E&!D1&D&!C1&C&!B&A1&A|F&E&D1&D&!C1&C&!B&A1&A|F&!E&D1&D&!C1&C&!B&A1&A|F&!E&D1&!D&!C1&C&!B&A1&A|F&E&D1&!D&!C1&C&!B&A1&A|F&E&!D1&!D&!C1&C&!B&A1&A|F&!E&!D1&!D&!C1&C&!B&A1&A|F&!E&!D1&!D&!C1&C&B&A1&A|F&E&!D1&!D&!C1&C&B&A1&A|F&E&D1&!D&!C1&C&B&A1&A|F&!E&D1&!D&!C1&C&B&A1&A|F&!E&D1&D&!C1&C&B&A1&A|F&E&D1&D&!C1&C&B&A1&A|F&E&!D1&D&!C1&C&B&A1&A|F&!E&!D1&D&!C1&C&B&A1&A|F&!E&!D1&D&C1&C&B&A1&A|F&E&!D1&D&C1&C&B&A1&A|F&E&D1&D&C1&C&B&A1&A|F&!E&D1&D&C1&C&B&A1&A|F&!E&D1&!D&C1&C&B&A1&A|F&E&D1&!D&C1&C&B&A1&A|F&E&!D1&!D&C1&C&B&A1&A|F&!E&!D1&!D&C1&C&B&A1&A|F&!E&!D1&!D&C1&!C&B&A1&A|F&E&!D1&!D&C1&!C&B&A1&A|F&E&D1&!D&C1&!C&B&A1&A|F&!E&D1&!D&C1&!C&B&A1&A|F&!E&D1&D&C1&!C&B&A1&A|F&E&D1&D&C1&!C&B&A1&A|F&E&!D1&D&C1&!C&B&A1&A|F&!E&!D1&D&C1&!C&B&A1&A|F&E&!D1&D&!C1&!C&B&A1&A|F&E&D1&D&!C1&!C&B&A1&A|F&!E&D1&D&!C1&!C&B&A1&A|F&E&D1&!D&!C1&!C&B&A1&A|F&E&!D1&!D&!C1&!C&B&A1&A|F&E&!D1&!D&!C1&!C&B&!A1&A|F&E&D1&!D&!C1&!C&B&!A1&A|F&!E&D1&D&!C1&!C&B&!A1&A|F&E&D1&D&!C1&!C&B&!A1&A|F&E&!D1&D&!C1&!C&B&!A1&A|F&!E&!D1&D&C1&!C&B&!A1&A|F&E&!D1&D&C1&!C&B&!A1&A|F&E&D1&D&C1&!C&B&!A1&A|F&!E&D1&D&C1&!C&B&!A1&A|F&!E&D1&!D&C1&!C&B&!A1&A|F&E&D1&!D&C1&!C&B&!A1&A|F&E&!D1&!D&C1&!C&B&!A1&A|F&!E&!D1&!D&C1&!C&B&!A1&A|F&!E&!D1&!D&C1&C&B&!A1&A|F&E&!D1&!D&C1&C&B&!A1&A|F&E&D1&!D&C1&C&B&!A1&A|F&!E&D1&!D&C1&C&B&!A1&A|F&!E&D1&D&C1&C&B&!A1&A|F&E&D1&D&C1&C&B&!A1&A|F&E&!D1&D&C1&C&B&!A1&A|F&!E&!D1&D&C1&C&B&!A1&A|F&!E&!D1&D&!C1&C&B&!A1&A|F&E&!D1&D&!C1&C&B&!A1&A|F&E&D1&D&!C1&C&B&!A1&A|F&!E&D1&D&!C1&C&B&!A1&A|F&!E&D1&!D&!C1&C&B&!A1&A|F&E&D1&!D&!C1&C&B&!A1&A|F&E&!D1&!D&!C1&C&B&!A1&A|F&!E&!D1&!D&!C1&C&B&!A1&A|F&E&!D1&!D&!C1&C&!B&!A1&A|F&E&D1&!D&!C1&C&!B&!A1&A|F&!E&D1&D&!C1&C&!B&!A1&A|F&E&D1&D&!C1&C&!B&!A1&A|F&E&!D1&D&!C1&C&!B&!A1&A|F&E&!D1&D&C1&C&!B&!A1&A|F&E&D1&D&C1&C&!B&!A1&A|F&!E&D1&D&C1&C&!B&!A1&A|F&E&D1&!D&C1&C&!B&!A1&A|F&E&!D1&!D&C1&C&!B&!A1&A|F&E&!D1&!D&C1&!C&!B&!A1&A|F&E&D1&!D&C1&!C&!B&!A1&A|F&!E&D1&D&C1&!C&!B&!A1&A|F&E&D1&D&C1&!C&!B&!A1&A|F&E&!D1&D&C1&!C&!B&!A1&A|F&E&!D1&D&!C1&!C&!B&!A1&A|F&E&D1&D&!C1&!C&!B&!A1&A|F&!E&D1&D&!C1&!C&!B&!A1&A|F&E&D1&!D&!C1&!C&!B&!A1&A|F&E&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOAI212211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAI3321 -l AAOAI3321 -i D C1 C B2 B1 B A2 A1 A -o Y -f Y=!(D&C1&!C&!B2&!B1&!B&!A2&!A1&!A|D&C1&C&!B2&!B1&!B&!A2&!A1&!A|D&!C1&C&!B2&!B1&!B&!A2&!A1&!A|D&!C1&C&B2&!B1&!B&!A2&!A1&!A|D&C1&C&B2&!B1&!B&!A2&!A1&!A|D&C1&!C&B2&!B1&!B&!A2&!A1&!A|D&C1&!C&B2&B1&!B&!A2&!A1&!A|D&C1&C&B2&B1&!B&!A2&!A1&!A|D&!C1&C&B2&B1&!B&!A2&!A1&!A|D&!C1&C&!B2&B1&!B&!A2&!A1&!A|D&C1&C&!B2&B1&!B&!A2&!A1&!A|D&C1&!C&!B2&B1&!B&!A2&!A1&!A|D&C1&!C&!B2&B1&B&!A2&!A1&!A|D&C1&C&!B2&B1&B&!A2&!A1&!A|D&!C1&C&!B2&B1&B&!A2&!A1&!A|D&!C1&C&B2&B1&B&!A2&!A1&!A|D&C1&C&B2&B1&B&!A2&!A1&!A|D&C1&!C&B2&B1&B&!A2&!A1&!A|D&!C1&!C&B2&B1&B&!A2&!A1&!A|D&C1&!C&B2&!B1&B&!A2&!A1&!A|D&C1&C&B2&!B1&B&!A2&!A1&!A|D&!C1&C&B2&!B1&B&!A2&!A1&!A|D&!C1&C&!B2&!B1&B&!A2&!A1&!A|D&C1&C&!B2&!B1&B&!A2&!A1&!A|D&C1&!C&!B2&!B1&B&!A2&!A1&!A|D&C1&!C&!B2&!B1&B&A2&!A1&!A|D&C1&C&!B2&!B1&B&A2&!A1&!A|D&!C1&C&!B2&!B1&B&A2&!A1&!A|D&!C1&C&B2&!B1&B&A2&!A1&!A|D&C1&C&B2&!B1&B&A2&!A1&!A|D&C1&!C&B2&!B1&B&A2&!A1&!A|D&!C1&!C&B2&B1&B&A2&!A1&!A|D&C1&!C&B2&B1&B&A2&!A1&!A|D&C1&C&B2&B1&B&A2&!A1&!A|D&!C1&C&B2&B1&B&A2&!A1&!A|D&!C1&C&!B2&B1&B&A2&!A1&!A|D&C1&C&!B2&B1&B&A2&!A1&!A|D&C1&!C&!B2&B1&B&A2&!A1&!A|D&C1&!C&!B2&B1&!B&A2&!A1&!A|D&C1&C&!B2&B1&!B&A2&!A1&!A|D&!C1&C&!B2&B1&!B&A2&!A1&!A|D&!C1&C&B2&B1&!B&A2&!A1&!A|D&C1&C&B2&B1&!B&A2&!A1&!A|D&C1&!C&B2&B1&!B&A2&!A1&!A|D&C1&!C&B2&!B1&!B&A2&!A1&!A|D&C1&C&B2&!B1&!B&A2&!A1&!A|D&!C1&C&B2&!B1&!B&A2&!A1&!A|D&!C1&C&!B2&!B1&!B&A2&!A1&!A|D&C1&C&!B2&!B1&!B&A2&!A1&!A|D&C1&!C&!B2&!B1&!B&A2&!A1&!A|D&C1&!C&!B2&!B1&!B&A2&A1&!A|D&C1&C&!B2&!B1&!B&A2&A1&!A|D&!C1&C&!B2&!B1&!B&A2&A1&!A|D&!C1&C&B2&!B1&!B&A2&A1&!A|D&C1&C&B2&!B1&!B&A2&A1&!A|D&C1&!C&B2&!B1&!B&A2&A1&!A|D&C1&!C&B2&B1&!B&A2&A1&!A|D&C1&C&B2&B1&!B&A2&A1&!A|D&!C1&C&B2&B1&!B&A2&A1&!A|D&!C1&C&!B2&B1&!B&A2&A1&!A|D&C1&C&!B2&B1&!B&A2&A1&!A|D&C1&!C&!B2&B1&!B&A2&A1&!A|D&C1&!C&!B2&B1&B&A2&A1&!A|D&C1&C&!B2&B1&B&A2&A1&!A|D&!C1&C&!B2&B1&B&A2&A1&!A|D&!C1&C&B2&B1&B&A2&A1&!A|D&C1&C&B2&B1&B&A2&A1&!A|D&C1&!C&B2&B1&B&A2&A1&!A|D&!C1&!C&B2&B1&B&A2&A1&!A|D&C1&!C&B2&!B1&B&A2&A1&!A|D&C1&C&B2&!B1&B&A2&A1&!A|D&!C1&C&B2&!B1&B&A2&A1&!A|D&!C1&C&!B2&!B1&B&A2&A1&!A|D&C1&C&!B2&!B1&B&A2&A1&!A|D&C1&!C&!B2&!B1&B&A2&A1&!A|D&C1&!C&!B2&!B1&B&!A2&A1&!A|D&C1&C&!B2&!B1&B&!A2&A1&!A|D&!C1&C&!B2&!B1&B&!A2&A1&!A|D&!C1&C&B2&!B1&B&!A2&A1&!A|D&C1&C&B2&!B1&B&!A2&A1&!A|D&C1&!C&B2&!B1&B&!A2&A1&!A|D&!C1&!C&B2&B1&B&!A2&A1&!A|D&C1&!C&B2&B1&B&!A2&A1&!A|D&C1&C&B2&B1&B&!A2&A1&!A|D&!C1&C&B2&B1&B&!A2&A1&!A|D&!C1&C&!B2&B1&B&!A2&A1&!A|D&C1&C&!B2&B1&B&!A2&A1&!A|D&C1&!C&!B2&B1&B&!A2&A1&!A|D&C1&!C&!B2&B1&!B&!A2&A1&!A|D&C1&C&!B2&B1&!B&!A2&A1&!A|D&!C1&C&!B2&B1&!B&!A2&A1&!A|D&!C1&C&B2&B1&!B&!A2&A1&!A|D&C1&C&B2&B1&!B&!A2&A1&!A|D&C1&!C&B2&B1&!B&!A2&A1&!A|D&C1&!C&B2&!B1&!B&!A2&A1&!A|D&C1&C&B2&!B1&!B&!A2&A1&!A|D&!C1&C&B2&!B1&!B&!A2&A1&!A|D&!C1&C&!B2&!B1&!B&!A2&A1&!A|D&C1&C&!B2&!B1&!B&!A2&A1&!A|D&C1&!C&!B2&!B1&!B&!A2&A1&!A|D&C1&!C&!B2&!B1&!B&!A2&A1&A|D&C1&C&!B2&!B1&!B&!A2&A1&A|D&!C1&C&!B2&!B1&!B&!A2&A1&A|D&!C1&C&B2&!B1&!B&!A2&A1&A|D&C1&C&B2&!B1&!B&!A2&A1&A|D&C1&!C&B2&!B1&!B&!A2&A1&A|D&C1&!C&B2&B1&!B&!A2&A1&A|D&C1&C&B2&B1&!B&!A2&A1&A|D&!C1&C&B2&B1&!B&!A2&A1&A|D&!C1&C&!B2&B1&!B&!A2&A1&A|D&C1&C&!B2&B1&!B&!A2&A1&A|D&C1&!C&!B2&B1&!B&!A2&A1&A|D&C1&!C&!B2&B1&B&!A2&A1&A|D&C1&C&!B2&B1&B&!A2&A1&A|D&!C1&C&!B2&B1&B&!A2&A1&A|D&!C1&C&B2&B1&B&!A2&A1&A|D&C1&C&B2&B1&B&!A2&A1&A|D&C1&!C&B2&B1&B&!A2&A1&A|D&!C1&!C&B2&B1&B&!A2&A1&A|D&C1&!C&B2&!B1&B&!A2&A1&A|D&C1&C&B2&!B1&B&!A2&A1&A|D&!C1&C&B2&!B1&B&!A2&A1&A|D&!C1&C&!B2&!B1&B&!A2&A1&A|D&C1&C&!B2&!B1&B&!A2&A1&A|D&C1&!C&!B2&!B1&B&!A2&A1&A|D&!C1&!C&!B2&!B1&B&A2&A1&A|D&C1&!C&!B2&!B1&B&A2&A1&A|D&C1&C&!B2&!B1&B&A2&A1&A|D&!C1&C&!B2&!B1&B&A2&A1&A|D&!C1&C&B2&!B1&B&A2&A1&A|D&C1&C&B2&!B1&B&A2&A1&A|D&C1&!C&B2&!B1&B&A2&A1&A|D&!C1&!C&B2&!B1&B&A2&A1&A|D&!C1&!C&B2&B1&B&A2&A1&A|D&C1&!C&B2&B1&B&A2&A1&A|D&C1&C&B2&B1&B&A2&A1&A|D&!C1&C&B2&B1&B&A2&A1&A|D&!C1&C&!B2&B1&B&A2&A1&A|D&C1&C&!B2&B1&B&A2&A1&A|D&C1&!C&!B2&B1&B&A2&A1&A|D&!C1&!C&!B2&B1&B&A2&A1&A|D&!C1&!C&!B2&B1&!B&A2&A1&A|D&C1&!C&!B2&B1&!B&A2&A1&A|D&C1&C&!B2&B1&!B&A2&A1&A|D&!C1&C&!B2&B1&!B&A2&A1&A|D&!C1&C&B2&B1&!B&A2&A1&A|D&C1&C&B2&B1&!B&A2&A1&A|D&C1&!C&B2&B1&!B&A2&A1&A|D&!C1&!C&B2&B1&!B&A2&A1&A|D&!C1&!C&B2&!B1&!B&A2&A1&A|D&C1&!C&B2&!B1&!B&A2&A1&A|D&C1&C&B2&!B1&!B&A2&A1&A|D&!C1&C&B2&!B1&!B&A2&A1&A|D&!C1&C&!B2&!B1&!B&A2&A1&A|D&C1&C&!B2&!B1&!B&A2&A1&A|D&C1&!C&!B2&!B1&!B&A2&A1&A|D&!C1&!C&!B2&!B1&!B&A2&A1&A|D&C1&!C&!B2&!B1&!B&A2&!A1&A|D&C1&C&!B2&!B1&!B&A2&!A1&A|D&!C1&C&!B2&!B1&!B&A2&!A1&A|D&!C1&C&B2&!B1&!B&A2&!A1&A|D&C1&C&B2&!B1&!B&A2&!A1&A|D&C1&!C&B2&!B1&!B&A2&!A1&A|D&C1&!C&B2&B1&!B&A2&!A1&A|D&C1&C&B2&B1&!B&A2&!A1&A|D&!C1&C&B2&B1&!B&A2&!A1&A|D&!C1&C&!B2&B1&!B&A2&!A1&A|D&C1&C&!B2&B1&!B&A2&!A1&A|D&C1&!C&!B2&B1&!B&A2&!A1&A|D&C1&!C&!B2&B1&B&A2&!A1&A|D&C1&C&!B2&B1&B&A2&!A1&A|D&!C1&C&!B2&B1&B&A2&!A1&A|D&!C1&C&B2&B1&B&A2&!A1&A|D&C1&C&B2&B1&B&A2&!A1&A|D&C1&!C&B2&B1&B&A2&!A1&A|D&!C1&!C&B2&B1&B&A2&!A1&A|D&C1&!C&B2&!B1&B&A2&!A1&A|D&C1&C&B2&!B1&B&A2&!A1&A|D&!C1&C&B2&!B1&B&A2&!A1&A|D&!C1&C&!B2&!B1&B&A2&!A1&A|D&C1&C&!B2&!B1&B&A2&!A1&A|D&C1&!C&!B2&!B1&B&A2&!A1&A|D&C1&!C&!B2&!B1&B&!A2&!A1&A|D&C1&C&!B2&!B1&B&!A2&!A1&A|D&!C1&C&!B2&!B1&B&!A2&!A1&A|D&!C1&C&B2&!B1&B&!A2&!A1&A|D&C1&C&B2&!B1&B&!A2&!A1&A|D&C1&!C&B2&!B1&B&!A2&!A1&A|D&!C1&!C&B2&B1&B&!A2&!A1&A|D&C1&!C&B2&B1&B&!A2&!A1&A|D&C1&C&B2&B1&B&!A2&!A1&A|D&!C1&C&B2&B1&B&!A2&!A1&A|D&!C1&C&!B2&B1&B&!A2&!A1&A|D&C1&C&!B2&B1&B&!A2&!A1&A|D&C1&!C&!B2&B1&B&!A2&!A1&A|D&C1&!C&!B2&B1&!B&!A2&!A1&A|D&C1&C&!B2&B1&!B&!A2&!A1&A|D&!C1&C&!B2&B1&!B&!A2&!A1&A|D&!C1&C&B2&B1&!B&!A2&!A1&A|D&C1&C&B2&B1&!B&!A2&!A1&A|D&C1&!C&B2&B1&!B&!A2&!A1&A|D&C1&!C&B2&!B1&!B&!A2&!A1&A|D&C1&C&B2&!B1&!B&!A2&!A1&A|D&!C1&C&B2&!B1&!B&!A2&!A1&A|D&!C1&C&!B2&!B1&!B&!A2&!A1&A|D&C1&C&!B2&!B1&!B&!A2&!A1&A|D&C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAI3321.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAI2231 -l AAOOAI2231 -i D C2 C1 C B1 B A1 A -o Y -f Y=!(D&C2&!C1&!C&B1&B&!A1&!A|D&C2&C1&!C&B1&B&!A1&!A|D&!C2&C1&!C&B1&B&!A1&!A|D&!C2&C1&C&B1&B&!A1&!A|D&C2&C1&C&B1&B&!A1&!A|D&C2&!C1&C&B1&B&!A1&!A|D&!C2&!C1&C&B1&B&!A1&!A|D&!C2&!C1&C&B1&B&A1&!A|D&C2&!C1&C&B1&B&A1&!A|D&C2&C1&C&B1&B&A1&!A|D&!C2&C1&C&B1&B&A1&!A|D&!C2&C1&!C&B1&B&A1&!A|D&C2&C1&!C&B1&B&A1&!A|D&C2&!C1&!C&B1&B&A1&!A|D&C2&!C1&!C&!B1&!B&A1&A|D&C2&C1&!C&!B1&!B&A1&A|D&!C2&C1&!C&!B1&!B&A1&A|D&!C2&C1&C&!B1&!B&A1&A|D&C2&C1&C&!B1&!B&A1&A|D&C2&!C1&C&!B1&!B&A1&A|D&!C2&!C1&C&!B1&!B&A1&A|D&!C2&!C1&C&B1&!B&A1&A|D&C2&!C1&C&B1&!B&A1&A|D&C2&C1&C&B1&!B&A1&A|D&!C2&C1&C&B1&!B&A1&A|D&!C2&C1&!C&B1&!B&A1&A|D&C2&C1&!C&B1&!B&A1&A|D&C2&!C1&!C&B1&!B&A1&A|D&C2&!C1&!C&B1&B&A1&A|D&C2&C1&!C&B1&B&A1&A|D&!C2&C1&!C&B1&B&A1&A|D&!C2&C1&C&B1&B&A1&A|D&C2&C1&C&B1&B&A1&A|D&C2&!C1&C&B1&B&A1&A|D&!C2&!C1&C&B1&B&A1&A|D&!C2&!C1&C&!B1&B&A1&A|D&C2&!C1&C&!B1&B&A1&A|D&C2&C1&C&!B1&B&A1&A|D&!C2&C1&C&!B1&B&A1&A|D&!C2&C1&!C&!B1&B&A1&A|D&C2&C1&!C&!B1&B&A1&A|D&C2&!C1&!C&!B1&B&A1&A|D&!C2&!C1&C&B1&B&!A1&A|D&C2&!C1&C&B1&B&!A1&A|D&C2&C1&C&B1&B&!A1&A|D&!C2&C1&C&B1&B&!A1&A|D&!C2&C1&!C&B1&B&!A1&A|D&C2&C1&!C&B1&B&!A1&A|D&C2&!C1&!C&B1&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAI2231.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOI2132 -l AOOAAOI2132 -i D1 D C2 C1 C B A1 A -o Y -f Y=(!D1&!D&!C2&!C1&!C&!B&!A1&!A|D1&!D&!C2&!C1&!C&!B&!A1&!A|!D1&D&!C2&!C1&!C&!B&!A1&!A|!D1&D&C2&!C1&!C&!B&!A1&!A|D1&!D&C2&!C1&!C&!B&!A1&!A|!D1&!D&C2&!C1&!C&!B&!A1&!A|!D1&!D&C2&C1&!C&!B&!A1&!A|D1&!D&C2&C1&!C&!B&!A1&!A|!D1&D&C2&C1&!C&!B&!A1&!A|!D1&D&!C2&C1&!C&!B&!A1&!A|D1&!D&!C2&C1&!C&!B&!A1&!A|!D1&!D&!C2&C1&!C&!B&!A1&!A|!D1&!D&!C2&C1&C&!B&!A1&!A|D1&!D&!C2&C1&C&!B&!A1&!A|!D1&D&!C2&C1&C&!B&!A1&!A|!D1&D&C2&C1&C&!B&!A1&!A|D1&!D&C2&C1&C&!B&!A1&!A|!D1&!D&C2&C1&C&!B&!A1&!A|!D1&!D&C2&!C1&C&!B&!A1&!A|D1&!D&C2&!C1&C&!B&!A1&!A|!D1&D&C2&!C1&C&!B&!A1&!A|!D1&D&!C2&!C1&C&!B&!A1&!A|D1&!D&!C2&!C1&C&!B&!A1&!A|!D1&!D&!C2&!C1&C&!B&!A1&!A|!D1&D&!C2&!C1&!C&B&!A1&!A|D1&!D&!C2&!C1&!C&B&!A1&!A|!D1&!D&!C2&!C1&!C&B&!A1&!A|!D1&!D&!C2&!C1&!C&B&A1&!A|D1&!D&!C2&!C1&!C&B&A1&!A|!D1&D&!C2&!C1&!C&B&A1&!A|!D1&!D&!C2&!C1&C&!B&A1&!A|D1&!D&!C2&!C1&C&!B&A1&!A|!D1&D&!C2&!C1&C&!B&A1&!A|!D1&D&C2&!C1&C&!B&A1&!A|D1&!D&C2&!C1&C&!B&A1&!A|!D1&!D&C2&!C1&C&!B&A1&!A|!D1&!D&C2&C1&C&!B&A1&!A|D1&!D&C2&C1&C&!B&A1&!A|!D1&D&C2&C1&C&!B&A1&!A|!D1&D&!C2&C1&C&!B&A1&!A|D1&!D&!C2&C1&C&!B&A1&!A|!D1&!D&!C2&C1&C&!B&A1&!A|!D1&!D&!C2&C1&!C&!B&A1&!A|D1&!D&!C2&C1&!C&!B&A1&!A|!D1&D&!C2&C1&!C&!B&A1&!A|!D1&D&C2&C1&!C&!B&A1&!A|D1&!D&C2&C1&!C&!B&A1&!A|!D1&!D&C2&C1&!C&!B&A1&!A|!D1&!D&C2&!C1&!C&!B&A1&!A|D1&!D&C2&!C1&!C&!B&A1&!A|!D1&D&C2&!C1&!C&!B&A1&!A|!D1&D&!C2&!C1&!C&!B&A1&!A|D1&!D&!C2&!C1&!C&!B&A1&!A|!D1&!D&!C2&!C1&!C&!B&A1&!A|!D1&!D&!C2&!C1&!C&!B&A1&A|D1&!D&!C2&!C1&!C&!B&A1&A|!D1&D&!C2&!C1&!C&!B&A1&A|!D1&D&!C2&!C1&!C&B&A1&A|D1&!D&!C2&!C1&!C&B&A1&A|!D1&!D&!C2&!C1&!C&B&A1&A|!D1&!D&!C2&!C1&!C&B&!A1&A|D1&!D&!C2&!C1&!C&B&!A1&A|!D1&D&!C2&!C1&!C&B&!A1&A|!D1&!D&!C2&!C1&C&!B&!A1&A|D1&!D&!C2&!C1&C&!B&!A1&A|!D1&D&!C2&!C1&C&!B&!A1&A|!D1&D&C2&!C1&C&!B&!A1&A|D1&!D&C2&!C1&C&!B&!A1&A|!D1&!D&C2&!C1&C&!B&!A1&A|!D1&!D&C2&C1&C&!B&!A1&A|D1&!D&C2&C1&C&!B&!A1&A|!D1&D&C2&C1&C&!B&!A1&A|!D1&D&!C2&C1&C&!B&!A1&A|D1&!D&!C2&C1&C&!B&!A1&A|!D1&!D&!C2&C1&C&!B&!A1&A|!D1&!D&!C2&C1&!C&!B&!A1&A|D1&!D&!C2&C1&!C&!B&!A1&A|!D1&D&!C2&C1&!C&!B&!A1&A|!D1&D&C2&C1&!C&!B&!A1&A|D1&!D&C2&C1&!C&!B&!A1&A|!D1&!D&C2&C1&!C&!B&!A1&A|!D1&!D&C2&!C1&!C&!B&!A1&A|D1&!D&C2&!C1&!C&!B&!A1&A|!D1&D&C2&!C1&!C&!B&!A1&A|!D1&D&!C2&!C1&!C&!B&!A1&A|D1&!D&!C2&!C1&!C&!B&!A1&A|!D1&!D&!C2&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOI2132.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAOI3211 -l AAOAOI3211 -i D C B1 B A2 A1 A -o Y -f Y=(!D&!C&!B1&!B&!A2&!A1&!A|!D&C&!B1&!B&!A2&!A1&!A|!D&C&B1&!B&!A2&!A1&!A|!D&!C&B1&!B&!A2&!A1&!A|!D&!C&B1&B&!A2&!A1&!A|!D&C&!B1&B&!A2&!A1&!A|!D&!C&!B1&B&!A2&!A1&!A|!D&!C&!B1&B&A2&!A1&!A|!D&C&!B1&B&A2&!A1&!A|!D&!C&B1&B&A2&!A1&!A|!D&!C&B1&!B&A2&!A1&!A|!D&C&B1&!B&A2&!A1&!A|!D&C&!B1&!B&A2&!A1&!A|!D&!C&!B1&!B&A2&!A1&!A|!D&!C&!B1&!B&A2&A1&!A|!D&C&!B1&!B&A2&A1&!A|!D&C&B1&!B&A2&A1&!A|!D&!C&B1&!B&A2&A1&!A|!D&!C&B1&B&A2&A1&!A|!D&C&!B1&B&A2&A1&!A|!D&!C&!B1&B&A2&A1&!A|!D&!C&!B1&B&!A2&A1&!A|!D&C&!B1&B&!A2&A1&!A|!D&!C&B1&B&!A2&A1&!A|!D&!C&B1&!B&!A2&A1&!A|!D&C&B1&!B&!A2&A1&!A|!D&C&!B1&!B&!A2&A1&!A|!D&!C&!B1&!B&!A2&A1&!A|!D&!C&!B1&!B&!A2&A1&A|!D&C&!B1&!B&!A2&A1&A|!D&C&B1&!B&!A2&A1&A|!D&!C&B1&!B&!A2&A1&A|!D&!C&B1&B&!A2&A1&A|!D&C&!B1&B&!A2&A1&A|!D&!C&!B1&B&!A2&A1&A|!D&!C&!B1&B&A2&A1&A|!D&!C&B1&B&A2&A1&A|!D&!C&B1&!B&A2&A1&A|!D&!C&!B1&!B&A2&A1&A|!D&!C&!B1&!B&A2&!A1&A|!D&C&!B1&!B&A2&!A1&A|!D&C&B1&!B&A2&!A1&A|!D&!C&B1&!B&A2&!A1&A|!D&!C&B1&B&A2&!A1&A|!D&C&!B1&B&A2&!A1&A|!D&!C&!B1&B&A2&!A1&A|!D&!C&!B1&B&!A2&!A1&A|!D&C&!B1&B&!A2&!A1&A|!D&!C&B1&B&!A2&!A1&A|!D&!C&B1&!B&!A2&!A1&A|!D&C&B1&!B&!A2&!A1&A|!D&C&!B1&!B&!A2&!A1&A|!D&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAOI3211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOI2141 -l OAAOI2141 -i D C3 C2 C1 C B A1 A -o Y -f Y=(!D&!C3&!C2&!C1&!C&!B&!A1&!A|!D&C3&!C2&!C1&!C&!B&!A1&!A|!D&C3&C2&!C1&!C&!B&!A1&!A|!D&!C3&C2&!C1&!C&!B&!A1&!A|!D&!C3&C2&C1&!C&!B&!A1&!A|!D&C3&C2&C1&!C&!B&!A1&!A|!D&C3&!C2&C1&!C&!B&!A1&!A|!D&!C3&!C2&C1&!C&!B&!A1&!A|!D&!C3&!C2&C1&C&!B&!A1&!A|!D&C3&!C2&C1&C&!B&!A1&!A|!D&!C3&C2&C1&C&!B&!A1&!A|!D&!C3&C2&!C1&C&!B&!A1&!A|!D&C3&C2&!C1&C&!B&!A1&!A|!D&C3&!C2&!C1&C&!B&!A1&!A|!D&!C3&!C2&!C1&C&!B&!A1&!A|!D&!C3&!C2&!C1&C&B&!A1&!A|!D&C3&!C2&!C1&C&B&!A1&!A|!D&C3&C2&!C1&C&B&!A1&!A|!D&!C3&C2&!C1&C&B&!A1&!A|!D&!C3&C2&C1&C&B&!A1&!A|!D&C3&!C2&C1&C&B&!A1&!A|!D&!C3&!C2&C1&C&B&!A1&!A|!D&!C3&!C2&C1&!C&B&!A1&!A|!D&C3&!C2&C1&!C&B&!A1&!A|!D&C3&C2&C1&!C&B&!A1&!A|!D&!C3&C2&C1&!C&B&!A1&!A|!D&!C3&C2&!C1&!C&B&!A1&!A|!D&C3&C2&!C1&!C&B&!A1&!A|!D&C3&!C2&!C1&!C&B&!A1&!A|!D&!C3&!C2&!C1&!C&B&!A1&!A|!D&!C3&!C2&!C1&C&!B&A1&!A|!D&C3&!C2&!C1&C&!B&A1&!A|!D&C3&C2&!C1&C&!B&A1&!A|!D&!C3&C2&!C1&C&!B&A1&!A|!D&!C3&C2&C1&C&!B&A1&!A|!D&C3&!C2&C1&C&!B&A1&!A|!D&!C3&!C2&C1&C&!B&A1&!A|!D&!C3&!C2&C1&!C&!B&A1&!A|!D&C3&!C2&C1&!C&!B&A1&!A|!D&C3&C2&C1&!C&!B&A1&!A|!D&!C3&C2&C1&!C&!B&A1&!A|!D&!C3&C2&!C1&!C&!B&A1&!A|!D&C3&C2&!C1&!C&!B&A1&!A|!D&C3&!C2&!C1&!C&!B&A1&!A|!D&!C3&!C2&!C1&!C&!B&A1&!A|!D&!C3&!C2&!C1&!C&!B&A1&A|!D&C3&!C2&!C1&!C&!B&A1&A|!D&C3&C2&!C1&!C&!B&A1&A|!D&!C3&C2&!C1&!C&!B&A1&A|!D&!C3&C2&C1&!C&!B&A1&A|!D&C3&C2&C1&!C&!B&A1&A|!D&C3&!C2&C1&!C&!B&A1&A|!D&!C3&!C2&C1&!C&!B&A1&A|!D&!C3&!C2&C1&C&!B&A1&A|!D&C3&!C2&C1&C&!B&A1&A|!D&!C3&C2&C1&C&!B&A1&A|!D&!C3&C2&!C1&C&!B&A1&A|!D&C3&C2&!C1&C&!B&A1&A|!D&C3&!C2&!C1&C&!B&A1&A|!D&!C3&!C2&!C1&C&!B&A1&A|!D&!C3&!C2&!C1&C&!B&!A1&A|!D&C3&!C2&!C1&C&!B&!A1&A|!D&C3&C2&!C1&C&!B&!A1&A|!D&!C3&C2&!C1&C&!B&!A1&A|!D&!C3&C2&C1&C&!B&!A1&A|!D&C3&!C2&C1&C&!B&!A1&A|!D&!C3&!C2&C1&C&!B&!A1&A|!D&!C3&!C2&C1&!C&!B&!A1&A|!D&C3&!C2&C1&!C&!B&!A1&A|!D&C3&C2&C1&!C&!B&!A1&A|!D&!C3&C2&C1&!C&!B&!A1&A|!D&!C3&C2&!C1&!C&!B&!A1&A|!D&C3&C2&!C1&!C&!B&!A1&A|!D&C3&!C2&!C1&!C&!B&!A1&A|!D&!C3&!C2&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOI2141.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOOAOAI221211 -l OOAOOAOAI221211 -i F E D1 D C B1 B A1 A -o Y -f Y=!(F&E&!D1&!D&!C&!B1&!B&!A1&!A|F&E&D1&!D&!C&!B1&!B&!A1&!A|F&E&D1&D&!C&!B1&!B&!A1&!A|F&E&!D1&D&!C&!B1&!B&!A1&!A|F&!E&!D1&D&C&!B1&!B&!A1&!A|F&E&!D1&D&C&!B1&!B&!A1&!A|F&E&D1&D&C&!B1&!B&!A1&!A|F&!E&D1&D&C&!B1&!B&!A1&!A|F&!E&D1&!D&C&!B1&!B&!A1&!A|F&E&D1&!D&C&!B1&!B&!A1&!A|F&E&!D1&!D&C&!B1&!B&!A1&!A|F&E&!D1&!D&C&B1&!B&!A1&!A|F&E&D1&!D&C&B1&!B&!A1&!A|F&!E&D1&!D&C&B1&!B&!A1&!A|F&!E&D1&D&C&B1&!B&!A1&!A|F&E&D1&D&C&B1&!B&!A1&!A|F&E&!D1&D&C&B1&!B&!A1&!A|F&!E&!D1&D&C&B1&!B&!A1&!A|F&E&!D1&D&!C&B1&!B&!A1&!A|F&E&D1&D&!C&B1&!B&!A1&!A|F&E&D1&!D&!C&B1&!B&!A1&!A|F&E&!D1&!D&!C&B1&!B&!A1&!A|F&E&!D1&!D&!C&B1&B&!A1&!A|F&E&D1&!D&!C&B1&B&!A1&!A|F&E&D1&D&!C&B1&B&!A1&!A|F&E&!D1&D&!C&B1&B&!A1&!A|F&!E&!D1&D&C&B1&B&!A1&!A|F&E&!D1&D&C&B1&B&!A1&!A|F&E&D1&D&C&B1&B&!A1&!A|F&!E&D1&D&C&B1&B&!A1&!A|F&!E&D1&!D&C&B1&B&!A1&!A|F&E&D1&!D&C&B1&B&!A1&!A|F&E&!D1&!D&C&B1&B&!A1&!A|F&E&!D1&!D&C&!B1&B&!A1&!A|F&E&D1&!D&C&!B1&B&!A1&!A|F&!E&D1&!D&C&!B1&B&!A1&!A|F&!E&D1&D&C&!B1&B&!A1&!A|F&E&D1&D&C&!B1&B&!A1&!A|F&E&!D1&D&C&!B1&B&!A1&!A|F&!E&!D1&D&C&!B1&B&!A1&!A|F&E&!D1&D&!C&!B1&B&!A1&!A|F&E&D1&D&!C&!B1&B&!A1&!A|F&E&D1&!D&!C&!B1&B&!A1&!A|F&E&!D1&!D&!C&!B1&B&!A1&!A|F&E&!D1&!D&!C&!B1&B&A1&!A|F&E&D1&!D&!C&!B1&B&A1&!A|F&!E&D1&!D&!C&!B1&B&A1&!A|F&!E&D1&D&!C&!B1&B&A1&!A|F&E&D1&D&!C&!B1&B&A1&!A|F&E&!D1&D&!C&!B1&B&A1&!A|F&!E&!D1&D&!C&!B1&B&A1&!A|F&!E&!D1&D&C&!B1&B&A1&!A|F&E&!D1&D&C&!B1&B&A1&!A|F&E&D1&D&C&!B1&B&A1&!A|F&!E&D1&D&C&!B1&B&A1&!A|F&!E&D1&!D&C&!B1&B&A1&!A|F&E&D1&!D&C&!B1&B&A1&!A|F&E&!D1&!D&C&!B1&B&A1&!A|F&E&!D1&!D&C&B1&B&A1&!A|F&E&D1&!D&C&B1&B&A1&!A|F&!E&D1&!D&C&B1&B&A1&!A|F&!E&D1&D&C&B1&B&A1&!A|F&E&D1&D&C&B1&B&A1&!A|F&E&!D1&D&C&B1&B&A1&!A|F&!E&!D1&D&C&B1&B&A1&!A|F&!E&!D1&D&!C&B1&B&A1&!A|F&E&!D1&D&!C&B1&B&A1&!A|F&E&D1&D&!C&B1&B&A1&!A|F&!E&D1&D&!C&B1&B&A1&!A|F&!E&D1&!D&!C&B1&B&A1&!A|F&E&D1&!D&!C&B1&B&A1&!A|F&E&!D1&!D&!C&B1&B&A1&!A|F&E&!D1&!D&!C&B1&!B&A1&!A|F&E&D1&!D&!C&B1&!B&A1&!A|F&!E&D1&!D&!C&B1&!B&A1&!A|F&!E&D1&D&!C&B1&!B&A1&!A|F&E&D1&D&!C&B1&!B&A1&!A|F&E&!D1&D&!C&B1&!B&A1&!A|F&!E&!D1&D&!C&B1&!B&A1&!A|F&!E&!D1&D&C&B1&!B&A1&!A|F&E&!D1&D&C&B1&!B&A1&!A|F&E&D1&D&C&B1&!B&A1&!A|F&!E&D1&D&C&B1&!B&A1&!A|F&!E&D1&!D&C&B1&!B&A1&!A|F&E&D1&!D&C&B1&!B&A1&!A|F&E&!D1&!D&C&B1&!B&A1&!A|F&E&!D1&!D&C&!B1&!B&A1&!A|F&E&D1&!D&C&!B1&!B&A1&!A|F&!E&D1&!D&C&!B1&!B&A1&!A|F&!E&D1&D&C&!B1&!B&A1&!A|F&E&D1&D&C&!B1&!B&A1&!A|F&E&!D1&D&C&!B1&!B&A1&!A|F&!E&!D1&D&C&!B1&!B&A1&!A|F&E&!D1&D&!C&!B1&!B&A1&!A|F&E&D1&D&!C&!B1&!B&A1&!A|F&E&D1&!D&!C&!B1&!B&A1&!A|F&E&!D1&!D&!C&!B1&!B&A1&!A|F&E&!D1&!D&!C&!B1&!B&A1&A|F&E&D1&!D&!C&!B1&!B&A1&A|F&E&D1&D&!C&!B1&!B&A1&A|F&E&!D1&D&!C&!B1&!B&A1&A|F&!E&!D1&D&C&!B1&!B&A1&A|F&E&!D1&D&C&!B1&!B&A1&A|F&E&D1&D&C&!B1&!B&A1&A|F&!E&D1&D&C&!B1&!B&A1&A|F&!E&D1&!D&C&!B1&!B&A1&A|F&E&D1&!D&C&!B1&!B&A1&A|F&E&!D1&!D&C&!B1&!B&A1&A|F&E&!D1&!D&C&B1&!B&A1&A|F&E&D1&!D&C&B1&!B&A1&A|F&!E&D1&!D&C&B1&!B&A1&A|F&!E&D1&D&C&B1&!B&A1&A|F&E&D1&D&C&B1&!B&A1&A|F&E&!D1&D&C&B1&!B&A1&A|F&!E&!D1&D&C&B1&!B&A1&A|F&!E&!D1&D&!C&B1&!B&A1&A|F&E&!D1&D&!C&B1&!B&A1&A|F&E&D1&D&!C&B1&!B&A1&A|F&!E&D1&D&!C&B1&!B&A1&A|F&!E&D1&!D&!C&B1&!B&A1&A|F&E&D1&!D&!C&B1&!B&A1&A|F&E&!D1&!D&!C&B1&!B&A1&A|F&E&!D1&!D&!C&B1&B&A1&A|F&E&D1&!D&!C&B1&B&A1&A|F&!E&D1&!D&!C&B1&B&A1&A|F&!E&D1&D&!C&B1&B&A1&A|F&E&D1&D&!C&B1&B&A1&A|F&E&!D1&D&!C&B1&B&A1&A|F&!E&!D1&D&!C&B1&B&A1&A|F&!E&!D1&D&C&B1&B&A1&A|F&E&!D1&D&C&B1&B&A1&A|F&E&D1&D&C&B1&B&A1&A|F&!E&D1&D&C&B1&B&A1&A|F&!E&D1&!D&C&B1&B&A1&A|F&E&D1&!D&C&B1&B&A1&A|F&E&!D1&!D&C&B1&B&A1&A|F&E&!D1&!D&C&!B1&B&A1&A|F&E&D1&!D&C&!B1&B&A1&A|F&!E&D1&!D&C&!B1&B&A1&A|F&!E&D1&D&C&!B1&B&A1&A|F&E&D1&D&C&!B1&B&A1&A|F&E&!D1&D&C&!B1&B&A1&A|F&!E&!D1&D&C&!B1&B&A1&A|F&!E&!D1&D&!C&!B1&B&A1&A|F&E&!D1&D&!C&!B1&B&A1&A|F&E&D1&D&!C&!B1&B&A1&A|F&!E&D1&D&!C&!B1&B&A1&A|F&!E&D1&!D&!C&!B1&B&A1&A|F&E&D1&!D&!C&!B1&B&A1&A|F&E&!D1&!D&!C&!B1&B&A1&A|F&E&!D1&!D&!C&!B1&B&!A1&A|F&E&D1&!D&!C&!B1&B&!A1&A|F&!E&D1&!D&!C&!B1&B&!A1&A|F&!E&D1&D&!C&!B1&B&!A1&A|F&E&D1&D&!C&!B1&B&!A1&A|F&E&!D1&D&!C&!B1&B&!A1&A|F&!E&!D1&D&!C&!B1&B&!A1&A|F&!E&!D1&D&C&!B1&B&!A1&A|F&E&!D1&D&C&!B1&B&!A1&A|F&E&D1&D&C&!B1&B&!A1&A|F&!E&D1&D&C&!B1&B&!A1&A|F&!E&D1&!D&C&!B1&B&!A1&A|F&E&D1&!D&C&!B1&B&!A1&A|F&E&!D1&!D&C&!B1&B&!A1&A|F&E&!D1&!D&C&B1&B&!A1&A|F&E&D1&!D&C&B1&B&!A1&A|F&!E&D1&!D&C&B1&B&!A1&A|F&!E&D1&D&C&B1&B&!A1&A|F&E&D1&D&C&B1&B&!A1&A|F&E&!D1&D&C&B1&B&!A1&A|F&!E&!D1&D&C&B1&B&!A1&A|F&!E&!D1&D&!C&B1&B&!A1&A|F&E&!D1&D&!C&B1&B&!A1&A|F&E&D1&D&!C&B1&B&!A1&A|F&!E&D1&D&!C&B1&B&!A1&A|F&!E&D1&!D&!C&B1&B&!A1&A|F&E&D1&!D&!C&B1&B&!A1&A|F&E&!D1&!D&!C&B1&B&!A1&A|F&E&!D1&!D&!C&B1&!B&!A1&A|F&E&D1&!D&!C&B1&!B&!A1&A|F&!E&D1&!D&!C&B1&!B&!A1&A|F&!E&D1&D&!C&B1&!B&!A1&A|F&E&D1&D&!C&B1&!B&!A1&A|F&E&!D1&D&!C&B1&!B&!A1&A|F&!E&!D1&D&!C&B1&!B&!A1&A|F&!E&!D1&D&C&B1&!B&!A1&A|F&E&!D1&D&C&B1&!B&!A1&A|F&E&D1&D&C&B1&!B&!A1&A|F&!E&D1&D&C&B1&!B&!A1&A|F&!E&D1&!D&C&B1&!B&!A1&A|F&E&D1&!D&C&B1&!B&!A1&A|F&E&!D1&!D&C&B1&!B&!A1&A|F&E&!D1&!D&C&!B1&!B&!A1&A|F&E&D1&!D&C&!B1&!B&!A1&A|F&!E&D1&!D&C&!B1&!B&!A1&A|F&!E&D1&D&C&!B1&!B&!A1&A|F&E&D1&D&C&!B1&!B&!A1&A|F&E&!D1&D&C&!B1&!B&!A1&A|F&!E&!D1&D&C&!B1&!B&!A1&A|F&E&!D1&D&!C&!B1&!B&!A1&A|F&E&D1&D&!C&!B1&!B&!A1&A|F&E&D1&!D&!C&!B1&!B&!A1&A|F&E&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOOAOAI221211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOAI21231 -l AOOAAOAI21231 -i E D2 D1 D C1 C B A1 A -o Y -f Y=!(E&D2&D1&D&!C1&!C&!B&!A1&!A|E&D2&D1&D&C1&!C&!B&!A1&!A|E&D2&D1&D&C1&C&!B&!A1&!A|E&D2&D1&D&!C1&C&!B&!A1&!A|E&!D2&!D1&!D&!C1&C&B&!A1&!A|E&D2&!D1&!D&!C1&C&B&!A1&!A|E&D2&D1&!D&!C1&C&B&!A1&!A|E&!D2&D1&!D&!C1&C&B&!A1&!A|E&!D2&D1&D&!C1&C&B&!A1&!A|E&D2&D1&D&!C1&C&B&!A1&!A|E&D2&!D1&D&!C1&C&B&!A1&!A|E&!D2&!D1&D&!C1&C&B&!A1&!A|E&!D2&!D1&D&C1&C&B&!A1&!A|E&D2&!D1&D&C1&C&B&!A1&!A|E&D2&D1&D&C1&C&B&!A1&!A|E&!D2&D1&D&C1&C&B&!A1&!A|E&!D2&D1&!D&C1&C&B&!A1&!A|E&D2&D1&!D&C1&C&B&!A1&!A|E&D2&!D1&!D&C1&C&B&!A1&!A|E&!D2&!D1&!D&C1&C&B&!A1&!A|E&!D2&!D1&!D&C1&!C&B&!A1&!A|E&D2&!D1&!D&C1&!C&B&!A1&!A|E&D2&D1&!D&C1&!C&B&!A1&!A|E&!D2&D1&!D&C1&!C&B&!A1&!A|E&!D2&D1&D&C1&!C&B&!A1&!A|E&D2&D1&D&C1&!C&B&!A1&!A|E&D2&!D1&D&C1&!C&B&!A1&!A|E&!D2&!D1&D&C1&!C&B&!A1&!A|E&D2&D1&D&!C1&!C&B&!A1&!A|E&D2&D1&D&!C1&!C&B&A1&!A|E&!D2&!D1&D&C1&!C&B&A1&!A|E&D2&!D1&D&C1&!C&B&A1&!A|E&D2&D1&D&C1&!C&B&A1&!A|E&!D2&D1&D&C1&!C&B&A1&!A|E&!D2&D1&!D&C1&!C&B&A1&!A|E&D2&D1&!D&C1&!C&B&A1&!A|E&D2&!D1&!D&C1&!C&B&A1&!A|E&!D2&!D1&!D&C1&!C&B&A1&!A|E&!D2&!D1&!D&C1&C&B&A1&!A|E&D2&!D1&!D&C1&C&B&A1&!A|E&D2&D1&!D&C1&C&B&A1&!A|E&!D2&D1&!D&C1&C&B&A1&!A|E&!D2&D1&D&C1&C&B&A1&!A|E&D2&D1&D&C1&C&B&A1&!A|E&D2&!D1&D&C1&C&B&A1&!A|E&!D2&!D1&D&C1&C&B&A1&!A|E&!D2&!D1&D&!C1&C&B&A1&!A|E&D2&!D1&D&!C1&C&B&A1&!A|E&D2&D1&D&!C1&C&B&A1&!A|E&!D2&D1&D&!C1&C&B&A1&!A|E&!D2&D1&!D&!C1&C&B&A1&!A|E&D2&D1&!D&!C1&C&B&A1&!A|E&D2&!D1&!D&!C1&C&B&A1&!A|E&!D2&!D1&!D&!C1&C&B&A1&!A|E&D2&D1&D&!C1&C&!B&A1&!A|E&D2&D1&D&C1&C&!B&A1&!A|E&D2&D1&D&C1&!C&!B&A1&!A|E&D2&D1&D&!C1&!C&!B&A1&!A|E&D2&D1&D&!C1&!C&!B&A1&A|E&!D2&!D1&D&C1&!C&!B&A1&A|E&D2&!D1&D&C1&!C&!B&A1&A|E&D2&D1&D&C1&!C&!B&A1&A|E&!D2&D1&D&C1&!C&!B&A1&A|E&!D2&D1&!D&C1&!C&!B&A1&A|E&D2&D1&!D&C1&!C&!B&A1&A|E&D2&!D1&!D&C1&!C&!B&A1&A|E&!D2&!D1&!D&C1&!C&!B&A1&A|E&!D2&!D1&!D&C1&C&!B&A1&A|E&D2&!D1&!D&C1&C&!B&A1&A|E&D2&D1&!D&C1&C&!B&A1&A|E&!D2&D1&!D&C1&C&!B&A1&A|E&!D2&D1&D&C1&C&!B&A1&A|E&D2&D1&D&C1&C&!B&A1&A|E&D2&!D1&D&C1&C&!B&A1&A|E&!D2&!D1&D&C1&C&!B&A1&A|E&!D2&!D1&D&!C1&C&!B&A1&A|E&D2&!D1&D&!C1&C&!B&A1&A|E&D2&D1&D&!C1&C&!B&A1&A|E&!D2&D1&D&!C1&C&!B&A1&A|E&!D2&D1&!D&!C1&C&!B&A1&A|E&D2&D1&!D&!C1&C&!B&A1&A|E&D2&!D1&!D&!C1&C&!B&A1&A|E&!D2&!D1&!D&!C1&C&!B&A1&A|E&!D2&!D1&!D&!C1&C&B&A1&A|E&D2&!D1&!D&!C1&C&B&A1&A|E&D2&D1&!D&!C1&C&B&A1&A|E&!D2&D1&!D&!C1&C&B&A1&A|E&!D2&D1&D&!C1&C&B&A1&A|E&D2&D1&D&!C1&C&B&A1&A|E&D2&!D1&D&!C1&C&B&A1&A|E&!D2&!D1&D&!C1&C&B&A1&A|E&!D2&!D1&D&C1&C&B&A1&A|E&D2&!D1&D&C1&C&B&A1&A|E&D2&D1&D&C1&C&B&A1&A|E&!D2&D1&D&C1&C&B&A1&A|E&!D2&D1&!D&C1&C&B&A1&A|E&D2&D1&!D&C1&C&B&A1&A|E&D2&!D1&!D&C1&C&B&A1&A|E&!D2&!D1&!D&C1&C&B&A1&A|E&!D2&!D1&!D&C1&!C&B&A1&A|E&D2&!D1&!D&C1&!C&B&A1&A|E&D2&D1&!D&C1&!C&B&A1&A|E&!D2&D1&!D&C1&!C&B&A1&A|E&!D2&D1&D&C1&!C&B&A1&A|E&D2&D1&D&C1&!C&B&A1&A|E&D2&!D1&D&C1&!C&B&A1&A|E&!D2&!D1&D&C1&!C&B&A1&A|E&D2&D1&D&!C1&!C&B&A1&A|E&D2&D1&D&!C1&!C&B&!A1&A|E&!D2&!D1&D&C1&!C&B&!A1&A|E&D2&!D1&D&C1&!C&B&!A1&A|E&D2&D1&D&C1&!C&B&!A1&A|E&!D2&D1&D&C1&!C&B&!A1&A|E&!D2&D1&!D&C1&!C&B&!A1&A|E&D2&D1&!D&C1&!C&B&!A1&A|E&D2&!D1&!D&C1&!C&B&!A1&A|E&!D2&!D1&!D&C1&!C&B&!A1&A|E&!D2&!D1&!D&C1&C&B&!A1&A|E&D2&!D1&!D&C1&C&B&!A1&A|E&D2&D1&!D&C1&C&B&!A1&A|E&!D2&D1&!D&C1&C&B&!A1&A|E&!D2&D1&D&C1&C&B&!A1&A|E&D2&D1&D&C1&C&B&!A1&A|E&D2&!D1&D&C1&C&B&!A1&A|E&!D2&!D1&D&C1&C&B&!A1&A|E&!D2&!D1&D&!C1&C&B&!A1&A|E&D2&!D1&D&!C1&C&B&!A1&A|E&D2&D1&D&!C1&C&B&!A1&A|E&!D2&D1&D&!C1&C&B&!A1&A|E&!D2&D1&!D&!C1&C&B&!A1&A|E&D2&D1&!D&!C1&C&B&!A1&A|E&D2&!D1&!D&!C1&C&B&!A1&A|E&!D2&!D1&!D&!C1&C&B&!A1&A|E&D2&D1&D&!C1&C&!B&!A1&A|E&D2&D1&D&C1&C&!B&!A1&A|E&D2&D1&D&C1&!C&!B&!A1&A|E&D2&D1&D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOAI21231.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAI3113 -l OAOOAI3113 -i D2 D1 D C B A2 A1 A -o Y -f Y=(!D2&!D1&!D&!C&!B&!A2&!A1&!A|D2&!D1&!D&!C&!B&!A2&!A1&!A|D2&D1&!D&!C&!B&!A2&!A1&!A|!D2&D1&!D&!C&!B&!A2&!A1&!A|!D2&D1&D&!C&!B&!A2&!A1&!A|D2&D1&D&!C&!B&!A2&!A1&!A|D2&!D1&D&!C&!B&!A2&!A1&!A|!D2&!D1&D&!C&!B&!A2&!A1&!A|!D2&!D1&!D&C&!B&!A2&!A1&!A|!D2&!D1&!D&C&B&!A2&!A1&!A|!D2&!D1&D&!C&B&!A2&!A1&!A|D2&!D1&D&!C&B&!A2&!A1&!A|D2&D1&D&!C&B&!A2&!A1&!A|!D2&D1&D&!C&B&!A2&!A1&!A|!D2&D1&!D&!C&B&!A2&!A1&!A|D2&D1&!D&!C&B&!A2&!A1&!A|D2&!D1&!D&!C&B&!A2&!A1&!A|!D2&!D1&!D&!C&B&!A2&!A1&!A|!D2&!D1&!D&!C&B&A2&!A1&!A|!D2&!D1&!D&C&B&A2&!A1&!A|!D2&!D1&!D&C&!B&A2&!A1&!A|!D2&!D1&D&!C&!B&A2&!A1&!A|D2&!D1&D&!C&!B&A2&!A1&!A|D2&D1&D&!C&!B&A2&!A1&!A|!D2&D1&D&!C&!B&A2&!A1&!A|!D2&D1&!D&!C&!B&A2&!A1&!A|D2&D1&!D&!C&!B&A2&!A1&!A|D2&!D1&!D&!C&!B&A2&!A1&!A|!D2&!D1&!D&!C&!B&A2&!A1&!A|!D2&!D1&!D&!C&!B&A2&A1&!A|D2&!D1&!D&!C&!B&A2&A1&!A|D2&D1&!D&!C&!B&A2&A1&!A|!D2&D1&!D&!C&!B&A2&A1&!A|!D2&D1&D&!C&!B&A2&A1&!A|D2&D1&D&!C&!B&A2&A1&!A|D2&!D1&D&!C&!B&A2&A1&!A|!D2&!D1&D&!C&!B&A2&A1&!A|!D2&!D1&!D&C&!B&A2&A1&!A|!D2&!D1&!D&C&B&A2&A1&!A|!D2&!D1&!D&!C&B&A2&A1&!A|!D2&!D1&!D&!C&B&!A2&A1&!A|!D2&!D1&!D&C&B&!A2&A1&!A|!D2&!D1&!D&C&!B&!A2&A1&!A|!D2&!D1&D&!C&!B&!A2&A1&!A|D2&!D1&D&!C&!B&!A2&A1&!A|D2&D1&D&!C&!B&!A2&A1&!A|!D2&D1&D&!C&!B&!A2&A1&!A|!D2&D1&!D&!C&!B&!A2&A1&!A|D2&D1&!D&!C&!B&!A2&A1&!A|D2&!D1&!D&!C&!B&!A2&A1&!A|!D2&!D1&!D&!C&!B&!A2&A1&!A|!D2&!D1&!D&!C&!B&!A2&A1&A|D2&!D1&!D&!C&!B&!A2&A1&A|D2&D1&!D&!C&!B&!A2&A1&A|!D2&D1&!D&!C&!B&!A2&A1&A|!D2&D1&D&!C&!B&!A2&A1&A|D2&D1&D&!C&!B&!A2&A1&A|D2&!D1&D&!C&!B&!A2&A1&A|!D2&!D1&D&!C&!B&!A2&A1&A|!D2&!D1&!D&C&!B&!A2&A1&A|!D2&!D1&!D&C&B&!A2&A1&A|!D2&!D1&!D&!C&B&!A2&A1&A|!D2&!D1&!D&!C&B&A2&A1&A|!D2&!D1&!D&C&B&A2&A1&A|!D2&!D1&!D&C&!B&A2&A1&A|!D2&!D1&D&!C&!B&A2&A1&A|D2&!D1&D&!C&!B&A2&A1&A|D2&D1&D&!C&!B&A2&A1&A|!D2&D1&D&!C&!B&A2&A1&A|!D2&D1&!D&!C&!B&A2&A1&A|D2&D1&!D&!C&!B&A2&A1&A|D2&!D1&!D&!C&!B&A2&A1&A|!D2&!D1&!D&!C&!B&A2&A1&A|!D2&!D1&!D&!C&!B&A2&!A1&A|D2&!D1&!D&!C&!B&A2&!A1&A|D2&D1&!D&!C&!B&A2&!A1&A|!D2&D1&!D&!C&!B&A2&!A1&A|!D2&D1&D&!C&!B&A2&!A1&A|D2&D1&D&!C&!B&A2&!A1&A|D2&!D1&D&!C&!B&A2&!A1&A|!D2&!D1&D&!C&!B&A2&!A1&A|!D2&!D1&!D&C&!B&A2&!A1&A|!D2&!D1&!D&C&B&A2&!A1&A|!D2&!D1&!D&!C&B&A2&!A1&A|!D2&!D1&!D&!C&B&!A2&!A1&A|!D2&!D1&!D&C&B&!A2&!A1&A|!D2&!D1&!D&C&!B&!A2&!A1&A|!D2&!D1&D&!C&!B&!A2&!A1&A|D2&!D1&D&!C&!B&!A2&!A1&A|D2&D1&D&!C&!B&!A2&!A1&A|!D2&D1&D&!C&!B&!A2&!A1&A|!D2&D1&!D&!C&!B&!A2&!A1&A|D2&D1&!D&!C&!B&!A2&!A1&A|D2&!D1&!D&!C&!B&!A2&!A1&A|!D2&!D1&!D&!C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAI3113.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAI2222 -l AAOAI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=!(D1&D&C1&!C&!B1&!B&!A1&!A|D1&D&C1&C&!B1&!B&!A1&!A|D1&D&!C1&C&!B1&!B&!A1&!A|D1&D&!C1&C&B1&!B&!A1&!A|D1&D&C1&C&B1&!B&!A1&!A|D1&D&C1&!C&B1&!B&!A1&!A|D1&D&!C1&!C&B1&B&!A1&!A|D1&D&C1&!C&B1&B&!A1&!A|D1&D&C1&C&B1&B&!A1&!A|D1&D&!C1&C&B1&B&!A1&!A|D1&D&!C1&C&!B1&B&!A1&!A|D1&D&C1&C&!B1&B&!A1&!A|D1&D&C1&!C&!B1&B&!A1&!A|D1&D&C1&!C&!B1&B&A1&!A|D1&D&C1&C&!B1&B&A1&!A|D1&D&!C1&C&!B1&B&A1&!A|D1&D&!C1&C&B1&B&A1&!A|D1&D&C1&C&B1&B&A1&!A|D1&D&C1&!C&B1&B&A1&!A|D1&D&!C1&!C&B1&B&A1&!A|D1&D&C1&!C&B1&!B&A1&!A|D1&D&C1&C&B1&!B&A1&!A|D1&D&!C1&C&B1&!B&A1&!A|D1&D&!C1&C&!B1&!B&A1&!A|D1&D&C1&C&!B1&!B&A1&!A|D1&D&C1&!C&!B1&!B&A1&!A|D1&D&!C1&!C&!B1&!B&A1&A|D1&D&C1&!C&!B1&!B&A1&A|D1&D&C1&C&!B1&!B&A1&A|D1&D&!C1&C&!B1&!B&A1&A|D1&D&!C1&C&B1&!B&A1&A|D1&D&C1&C&B1&!B&A1&A|D1&D&C1&!C&B1&!B&A1&A|D1&D&!C1&!C&B1&!B&A1&A|D1&D&!C1&!C&B1&B&A1&A|D1&D&C1&!C&B1&B&A1&A|D1&D&C1&C&B1&B&A1&A|D1&D&!C1&C&B1&B&A1&A|D1&D&!C1&C&!B1&B&A1&A|D1&D&C1&C&!B1&B&A1&A|D1&D&C1&!C&!B1&B&A1&A|D1&D&!C1&!C&!B1&B&A1&A|D1&D&C1&!C&!B1&B&!A1&A|D1&D&C1&C&!B1&B&!A1&A|D1&D&!C1&C&!B1&B&!A1&A|D1&D&!C1&C&B1&B&!A1&A|D1&D&C1&C&B1&B&!A1&A|D1&D&C1&!C&B1&B&!A1&A|D1&D&!C1&!C&B1&B&!A1&A|D1&D&C1&!C&B1&!B&!A1&A|D1&D&C1&C&B1&!B&!A1&A|D1&D&!C1&C&B1&!B&!A1&A|D1&D&!C1&C&!B1&!B&!A1&A|D1&D&C1&C&!B1&!B&!A1&A|D1&D&C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAOI2221 -l AAOOAOI2221 -i D C1 C B1 B A1 A -o Y -f Y=(!D&!C1&!C&!B1&!B&!A1&!A|!D&C1&!C&!B1&!B&!A1&!A|!D&C1&C&!B1&!B&!A1&!A|!D&!C1&C&!B1&!B&!A1&!A|!D&!C1&C&B1&!B&!A1&!A|!D&C1&C&B1&!B&!A1&!A|!D&C1&!C&B1&!B&!A1&!A|!D&!C1&!C&B1&!B&!A1&!A|!D&!C1&!C&B1&B&!A1&!A|!D&!C1&C&!B1&B&!A1&!A|!D&C1&C&!B1&B&!A1&!A|!D&C1&!C&!B1&B&!A1&!A|!D&!C1&!C&!B1&B&!A1&!A|!D&!C1&!C&!B1&B&A1&!A|!D&C1&!C&!B1&B&A1&!A|!D&C1&C&!B1&B&A1&!A|!D&!C1&C&!B1&B&A1&!A|!D&!C1&!C&B1&B&A1&!A|!D&!C1&!C&B1&!B&A1&!A|!D&C1&!C&B1&!B&A1&!A|!D&C1&C&B1&!B&A1&!A|!D&!C1&C&B1&!B&A1&!A|!D&!C1&C&!B1&!B&A1&!A|!D&C1&C&!B1&!B&A1&!A|!D&C1&!C&!B1&!B&A1&!A|!D&!C1&!C&!B1&!B&A1&!A|!D&!C1&!C&!B1&!B&A1&A|!D&!C1&!C&B1&!B&A1&A|!D&!C1&!C&B1&B&A1&A|!D&!C1&!C&!B1&B&A1&A|!D&!C1&!C&!B1&B&!A1&A|!D&C1&!C&!B1&B&!A1&A|!D&C1&C&!B1&B&!A1&A|!D&!C1&C&!B1&B&!A1&A|!D&!C1&!C&B1&B&!A1&A|!D&!C1&!C&B1&!B&!A1&A|!D&C1&!C&B1&!B&!A1&A|!D&C1&C&B1&!B&!A1&A|!D&!C1&C&B1&!B&!A1&A|!D&!C1&C&!B1&!B&!A1&A|!D&C1&C&!B1&!B&!A1&A|!D&C1&!C&!B1&!B&!A1&A|!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAOI2221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOOAI21122 -l AOAOOAI21122 -i E1 E D1 D C B A1 A -o Y -f Y=(!E1&!E&!D1&!D&!C&!B&!A1&!A|E1&!E&!D1&!D&!C&!B&!A1&!A|E1&E&!D1&!D&!C&!B&!A1&!A|!E1&E&!D1&!D&!C&!B&!A1&!A|!E1&!E&D1&!D&!C&!B&!A1&!A|!E1&!E&D1&D&!C&!B&!A1&!A|!E1&!E&!D1&D&!C&!B&!A1&!A|!E1&!E&!D1&D&C&!B&!A1&!A|!E1&!E&D1&D&C&!B&!A1&!A|!E1&!E&D1&!D&C&!B&!A1&!A|!E1&E&!D1&!D&C&!B&!A1&!A|E1&E&!D1&!D&C&!B&!A1&!A|E1&!E&!D1&!D&C&!B&!A1&!A|!E1&!E&!D1&!D&C&!B&!A1&!A|!E1&!E&!D1&!D&C&B&!A1&!A|!E1&!E&D1&!D&C&B&!A1&!A|!E1&!E&D1&D&C&B&!A1&!A|!E1&!E&!D1&D&C&B&!A1&!A|!E1&!E&!D1&D&!C&B&!A1&!A|!E1&!E&D1&D&!C&B&!A1&!A|!E1&!E&D1&!D&!C&B&!A1&!A|!E1&E&!D1&!D&!C&B&!A1&!A|E1&E&!D1&!D&!C&B&!A1&!A|E1&!E&!D1&!D&!C&B&!A1&!A|!E1&!E&!D1&!D&!C&B&!A1&!A|!E1&!E&!D1&!D&!C&B&A1&!A|E1&!E&!D1&!D&!C&B&A1&!A|E1&E&!D1&!D&!C&B&A1&!A|!E1&E&!D1&!D&!C&B&A1&!A|!E1&!E&D1&!D&!C&B&A1&!A|!E1&!E&D1&D&!C&B&A1&!A|!E1&!E&!D1&D&!C&B&A1&!A|!E1&!E&!D1&D&C&B&A1&!A|!E1&!E&D1&D&C&B&A1&!A|!E1&!E&D1&!D&C&B&A1&!A|!E1&!E&!D1&!D&C&B&A1&!A|!E1&!E&!D1&!D&C&!B&A1&!A|E1&!E&!D1&!D&C&!B&A1&!A|E1&E&!D1&!D&C&!B&A1&!A|!E1&E&!D1&!D&C&!B&A1&!A|!E1&!E&D1&!D&C&!B&A1&!A|!E1&!E&D1&D&C&!B&A1&!A|!E1&!E&!D1&D&C&!B&A1&!A|!E1&!E&!D1&D&!C&!B&A1&!A|!E1&!E&D1&D&!C&!B&A1&!A|!E1&!E&D1&!D&!C&!B&A1&!A|!E1&E&!D1&!D&!C&!B&A1&!A|E1&E&!D1&!D&!C&!B&A1&!A|E1&!E&!D1&!D&!C&!B&A1&!A|!E1&!E&!D1&!D&!C&!B&A1&!A|!E1&!E&!D1&!D&!C&!B&A1&A|E1&!E&!D1&!D&!C&!B&A1&A|E1&E&!D1&!D&!C&!B&A1&A|!E1&E&!D1&!D&!C&!B&A1&A|!E1&!E&D1&!D&!C&!B&A1&A|!E1&!E&D1&D&!C&!B&A1&A|!E1&!E&!D1&D&!C&!B&A1&A|!E1&!E&!D1&D&C&!B&A1&A|!E1&!E&D1&D&C&!B&A1&A|!E1&!E&D1&!D&C&!B&A1&A|!E1&!E&!D1&!D&C&!B&A1&A|!E1&!E&!D1&!D&C&B&A1&A|!E1&!E&D1&!D&C&B&A1&A|!E1&!E&D1&D&C&B&A1&A|!E1&!E&!D1&D&C&B&A1&A|!E1&!E&!D1&D&!C&B&A1&A|!E1&!E&D1&D&!C&B&A1&A|!E1&!E&D1&!D&!C&B&A1&A|!E1&E&!D1&!D&!C&B&A1&A|E1&E&!D1&!D&!C&B&A1&A|E1&!E&!D1&!D&!C&B&A1&A|!E1&!E&!D1&!D&!C&B&A1&A|!E1&!E&!D1&!D&!C&B&!A1&A|E1&!E&!D1&!D&!C&B&!A1&A|E1&E&!D1&!D&!C&B&!A1&A|!E1&E&!D1&!D&!C&B&!A1&A|!E1&!E&D1&!D&!C&B&!A1&A|!E1&!E&D1&D&!C&B&!A1&A|!E1&!E&!D1&D&!C&B&!A1&A|!E1&!E&!D1&D&C&B&!A1&A|!E1&!E&D1&D&C&B&!A1&A|!E1&!E&D1&!D&C&B&!A1&A|!E1&!E&!D1&!D&C&B&!A1&A|!E1&!E&!D1&!D&C&!B&!A1&A|E1&!E&!D1&!D&C&!B&!A1&A|E1&E&!D1&!D&C&!B&!A1&A|!E1&E&!D1&!D&C&!B&!A1&A|!E1&!E&D1&!D&C&!B&!A1&A|!E1&!E&D1&D&C&!B&!A1&A|!E1&!E&!D1&D&C&!B&!A1&A|!E1&!E&!D1&D&!C&!B&!A1&A|!E1&!E&D1&D&!C&!B&!A1&A|!E1&!E&D1&!D&!C&!B&!A1&A|!E1&E&!D1&!D&!C&!B&!A1&A|E1&E&!D1&!D&!C&!B&!A1&A|E1&!E&!D1&!D&!C&!B&!A1&A|!E1&!E&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOOAI21122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAI2113 -l OAOOAI2113 -i D2 D1 D C B A1 A -o Y -f Y=(!D2&!D1&!D&!C&!B&!A1&!A|D2&!D1&!D&!C&!B&!A1&!A|D2&D1&!D&!C&!B&!A1&!A|!D2&D1&!D&!C&!B&!A1&!A|!D2&D1&D&!C&!B&!A1&!A|D2&D1&D&!C&!B&!A1&!A|D2&!D1&D&!C&!B&!A1&!A|!D2&!D1&D&!C&!B&!A1&!A|!D2&!D1&!D&C&!B&!A1&!A|!D2&!D1&!D&C&B&!A1&!A|!D2&!D1&D&!C&B&!A1&!A|D2&!D1&D&!C&B&!A1&!A|D2&D1&D&!C&B&!A1&!A|!D2&D1&D&!C&B&!A1&!A|!D2&D1&!D&!C&B&!A1&!A|D2&D1&!D&!C&B&!A1&!A|D2&!D1&!D&!C&B&!A1&!A|!D2&!D1&!D&!C&B&!A1&!A|!D2&!D1&!D&!C&B&A1&!A|!D2&!D1&!D&C&B&A1&!A|!D2&!D1&!D&C&!B&A1&!A|!D2&!D1&D&!C&!B&A1&!A|D2&!D1&D&!C&!B&A1&!A|D2&D1&D&!C&!B&A1&!A|!D2&D1&D&!C&!B&A1&!A|!D2&D1&!D&!C&!B&A1&!A|D2&D1&!D&!C&!B&A1&!A|D2&!D1&!D&!C&!B&A1&!A|!D2&!D1&!D&!C&!B&A1&!A|!D2&!D1&!D&!C&!B&A1&A|D2&!D1&!D&!C&!B&A1&A|D2&D1&!D&!C&!B&A1&A|!D2&D1&!D&!C&!B&A1&A|!D2&D1&D&!C&!B&A1&A|D2&D1&D&!C&!B&A1&A|D2&!D1&D&!C&!B&A1&A|!D2&!D1&D&!C&!B&A1&A|!D2&!D1&!D&C&!B&A1&A|!D2&!D1&!D&C&B&A1&A|!D2&!D1&!D&!C&B&A1&A|!D2&!D1&!D&!C&B&!A1&A|!D2&!D1&!D&C&B&!A1&A|!D2&!D1&!D&C&!B&!A1&A|!D2&!D1&D&!C&!B&!A1&A|D2&!D1&D&!C&!B&!A1&A|D2&D1&D&!C&!B&!A1&A|!D2&D1&D&!C&!B&!A1&A|!D2&D1&!D&!C&!B&!A1&A|D2&D1&!D&!C&!B&!A1&A|D2&!D1&!D&!C&!B&!A1&A|!D2&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAI2113.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAAOOAI22222 -l OOOAAOOAI22222 -i E1 E D1 D C1 C B1 B A1 A -o Y -f Y=!(E1&!E&D1&D&!C1&!C&!B1&!B&!A1&!A|E1&E&D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&E&D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&E&D1&D&C1&!C&!B1&!B&!A1&!A|E1&E&D1&D&C1&!C&!B1&!B&!A1&!A|E1&!E&D1&D&C1&!C&!B1&!B&!A1&!A|E1&!E&D1&D&C1&C&!B1&!B&!A1&!A|E1&E&D1&D&C1&C&!B1&!B&!A1&!A|!E1&E&D1&D&C1&C&!B1&!B&!A1&!A|!E1&E&D1&D&!C1&C&!B1&!B&!A1&!A|E1&E&D1&D&!C1&C&!B1&!B&!A1&!A|E1&!E&D1&D&!C1&C&!B1&!B&!A1&!A|E1&!E&D1&D&!C1&C&B1&!B&!A1&!A|E1&E&D1&D&!C1&C&B1&!B&!A1&!A|!E1&E&D1&D&!C1&C&B1&!B&!A1&!A|!E1&E&D1&D&C1&C&B1&!B&!A1&!A|E1&E&D1&D&C1&C&B1&!B&!A1&!A|E1&!E&D1&D&C1&C&B1&!B&!A1&!A|E1&!E&D1&D&C1&!C&B1&!B&!A1&!A|E1&E&D1&D&C1&!C&B1&!B&!A1&!A|!E1&E&D1&D&C1&!C&B1&!B&!A1&!A|!E1&E&D1&D&!C1&!C&B1&!B&!A1&!A|E1&E&D1&D&!C1&!C&B1&!B&!A1&!A|E1&!E&D1&D&!C1&!C&B1&!B&!A1&!A|E1&!E&D1&D&!C1&!C&B1&B&!A1&!A|E1&E&D1&D&!C1&!C&B1&B&!A1&!A|!E1&E&D1&D&!C1&!C&B1&B&!A1&!A|!E1&E&D1&D&C1&!C&B1&B&!A1&!A|E1&E&D1&D&C1&!C&B1&B&!A1&!A|E1&!E&D1&D&C1&!C&B1&B&!A1&!A|E1&!E&D1&D&C1&C&B1&B&!A1&!A|E1&E&D1&D&C1&C&B1&B&!A1&!A|!E1&E&D1&D&C1&C&B1&B&!A1&!A|!E1&E&D1&D&!C1&C&B1&B&!A1&!A|E1&E&D1&D&!C1&C&B1&B&!A1&!A|E1&!E&D1&D&!C1&C&B1&B&!A1&!A|E1&!E&D1&D&!C1&C&!B1&B&!A1&!A|E1&E&D1&D&!C1&C&!B1&B&!A1&!A|!E1&E&D1&D&!C1&C&!B1&B&!A1&!A|!E1&E&D1&D&C1&C&!B1&B&!A1&!A|E1&E&D1&D&C1&C&!B1&B&!A1&!A|E1&!E&D1&D&C1&C&!B1&B&!A1&!A|E1&!E&D1&D&C1&!C&!B1&B&!A1&!A|E1&E&D1&D&C1&!C&!B1&B&!A1&!A|!E1&E&D1&D&C1&!C&!B1&B&!A1&!A|!E1&E&D1&D&!C1&!C&!B1&B&!A1&!A|E1&E&D1&D&!C1&!C&!B1&B&!A1&!A|E1&!E&D1&D&!C1&!C&!B1&B&!A1&!A|E1&!E&D1&D&!C1&!C&!B1&B&A1&!A|E1&E&D1&D&!C1&!C&!B1&B&A1&!A|!E1&E&D1&D&!C1&!C&!B1&B&A1&!A|E1&!E&!D1&D&C1&!C&!B1&B&A1&!A|E1&E&!D1&D&C1&!C&!B1&B&A1&!A|!E1&E&!D1&D&C1&!C&!B1&B&A1&!A|!E1&E&D1&D&C1&!C&!B1&B&A1&!A|E1&E&D1&D&C1&!C&!B1&B&A1&!A|E1&!E&D1&D&C1&!C&!B1&B&A1&!A|E1&!E&D1&!D&C1&!C&!B1&B&A1&!A|E1&E&D1&!D&C1&!C&!B1&B&A1&!A|!E1&E&D1&!D&C1&!C&!B1&B&A1&!A|!E1&E&!D1&!D&C1&!C&!B1&B&A1&!A|E1&E&!D1&!D&C1&!C&!B1&B&A1&!A|E1&!E&!D1&!D&C1&!C&!B1&B&A1&!A|E1&!E&!D1&!D&C1&C&!B1&B&A1&!A|E1&E&!D1&!D&C1&C&!B1&B&A1&!A|!E1&E&!D1&!D&C1&C&!B1&B&A1&!A|!E1&E&D1&!D&C1&C&!B1&B&A1&!A|E1&E&D1&!D&C1&C&!B1&B&A1&!A|E1&!E&D1&!D&C1&C&!B1&B&A1&!A|E1&!E&D1&D&C1&C&!B1&B&A1&!A|E1&E&D1&D&C1&C&!B1&B&A1&!A|!E1&E&D1&D&C1&C&!B1&B&A1&!A|!E1&E&!D1&D&C1&C&!B1&B&A1&!A|E1&E&!D1&D&C1&C&!B1&B&A1&!A|E1&!E&!D1&D&C1&C&!B1&B&A1&!A|E1&!E&!D1&D&!C1&C&!B1&B&A1&!A|E1&E&!D1&D&!C1&C&!B1&B&A1&!A|!E1&E&!D1&D&!C1&C&!B1&B&A1&!A|!E1&E&D1&D&!C1&C&!B1&B&A1&!A|E1&E&D1&D&!C1&C&!B1&B&A1&!A|E1&!E&D1&D&!C1&C&!B1&B&A1&!A|E1&!E&D1&!D&!C1&C&!B1&B&A1&!A|E1&E&D1&!D&!C1&C&!B1&B&A1&!A|!E1&E&D1&!D&!C1&C&!B1&B&A1&!A|!E1&E&!D1&!D&!C1&C&!B1&B&A1&!A|E1&E&!D1&!D&!C1&C&!B1&B&A1&!A|E1&!E&!D1&!D&!C1&C&!B1&B&A1&!A|E1&!E&!D1&!D&!C1&C&B1&B&A1&!A|E1&E&!D1&!D&!C1&C&B1&B&A1&!A|!E1&E&!D1&!D&!C1&C&B1&B&A1&!A|!E1&E&D1&!D&!C1&C&B1&B&A1&!A|E1&E&D1&!D&!C1&C&B1&B&A1&!A|E1&!E&D1&!D&!C1&C&B1&B&A1&!A|E1&!E&D1&D&!C1&C&B1&B&A1&!A|E1&E&D1&D&!C1&C&B1&B&A1&!A|!E1&E&D1&D&!C1&C&B1&B&A1&!A|!E1&E&!D1&D&!C1&C&B1&B&A1&!A|E1&E&!D1&D&!C1&C&B1&B&A1&!A|E1&!E&!D1&D&!C1&C&B1&B&A1&!A|E1&!E&!D1&D&C1&C&B1&B&A1&!A|E1&E&!D1&D&C1&C&B1&B&A1&!A|!E1&E&!D1&D&C1&C&B1&B&A1&!A|!E1&E&D1&D&C1&C&B1&B&A1&!A|E1&E&D1&D&C1&C&B1&B&A1&!A|E1&!E&D1&D&C1&C&B1&B&A1&!A|E1&!E&D1&!D&C1&C&B1&B&A1&!A|E1&E&D1&!D&C1&C&B1&B&A1&!A|!E1&E&D1&!D&C1&C&B1&B&A1&!A|!E1&E&!D1&!D&C1&C&B1&B&A1&!A|E1&E&!D1&!D&C1&C&B1&B&A1&!A|E1&!E&!D1&!D&C1&C&B1&B&A1&!A|E1&!E&!D1&!D&C1&!C&B1&B&A1&!A|E1&E&!D1&!D&C1&!C&B1&B&A1&!A|!E1&E&!D1&!D&C1&!C&B1&B&A1&!A|!E1&E&D1&!D&C1&!C&B1&B&A1&!A|E1&E&D1&!D&C1&!C&B1&B&A1&!A|E1&!E&D1&!D&C1&!C&B1&B&A1&!A|E1&!E&D1&D&C1&!C&B1&B&A1&!A|E1&E&D1&D&C1&!C&B1&B&A1&!A|!E1&E&D1&D&C1&!C&B1&B&A1&!A|!E1&E&!D1&D&C1&!C&B1&B&A1&!A|E1&E&!D1&D&C1&!C&B1&B&A1&!A|E1&!E&!D1&D&C1&!C&B1&B&A1&!A|!E1&E&D1&D&!C1&!C&B1&B&A1&!A|E1&E&D1&D&!C1&!C&B1&B&A1&!A|E1&!E&D1&D&!C1&!C&B1&B&A1&!A|E1&!E&D1&D&!C1&!C&B1&!B&A1&!A|E1&E&D1&D&!C1&!C&B1&!B&A1&!A|!E1&E&D1&D&!C1&!C&B1&!B&A1&!A|E1&!E&!D1&D&C1&!C&B1&!B&A1&!A|E1&E&!D1&D&C1&!C&B1&!B&A1&!A|!E1&E&!D1&D&C1&!C&B1&!B&A1&!A|!E1&E&D1&D&C1&!C&B1&!B&A1&!A|E1&E&D1&D&C1&!C&B1&!B&A1&!A|E1&!E&D1&D&C1&!C&B1&!B&A1&!A|E1&!E&D1&!D&C1&!C&B1&!B&A1&!A|E1&E&D1&!D&C1&!C&B1&!B&A1&!A|!E1&E&D1&!D&C1&!C&B1&!B&A1&!A|!E1&E&!D1&!D&C1&!C&B1&!B&A1&!A|E1&E&!D1&!D&C1&!C&B1&!B&A1&!A|E1&!E&!D1&!D&C1&!C&B1&!B&A1&!A|E1&!E&!D1&!D&C1&C&B1&!B&A1&!A|E1&E&!D1&!D&C1&C&B1&!B&A1&!A|!E1&E&!D1&!D&C1&C&B1&!B&A1&!A|!E1&E&D1&!D&C1&C&B1&!B&A1&!A|E1&E&D1&!D&C1&C&B1&!B&A1&!A|E1&!E&D1&!D&C1&C&B1&!B&A1&!A|E1&!E&D1&D&C1&C&B1&!B&A1&!A|E1&E&D1&D&C1&C&B1&!B&A1&!A|!E1&E&D1&D&C1&C&B1&!B&A1&!A|!E1&E&!D1&D&C1&C&B1&!B&A1&!A|E1&E&!D1&D&C1&C&B1&!B&A1&!A|E1&!E&!D1&D&C1&C&B1&!B&A1&!A|E1&!E&!D1&D&!C1&C&B1&!B&A1&!A|E1&E&!D1&D&!C1&C&B1&!B&A1&!A|!E1&E&!D1&D&!C1&C&B1&!B&A1&!A|!E1&E&D1&D&!C1&C&B1&!B&A1&!A|E1&E&D1&D&!C1&C&B1&!B&A1&!A|E1&!E&D1&D&!C1&C&B1&!B&A1&!A|E1&!E&D1&!D&!C1&C&B1&!B&A1&!A|E1&E&D1&!D&!C1&C&B1&!B&A1&!A|!E1&E&D1&!D&!C1&C&B1&!B&A1&!A|!E1&E&!D1&!D&!C1&C&B1&!B&A1&!A|E1&E&!D1&!D&!C1&C&B1&!B&A1&!A|E1&!E&!D1&!D&!C1&C&B1&!B&A1&!A|E1&!E&D1&D&!C1&C&!B1&!B&A1&!A|E1&E&D1&D&!C1&C&!B1&!B&A1&!A|!E1&E&D1&D&!C1&C&!B1&!B&A1&!A|!E1&E&D1&D&C1&C&!B1&!B&A1&!A|E1&E&D1&D&C1&C&!B1&!B&A1&!A|E1&!E&D1&D&C1&C&!B1&!B&A1&!A|E1&!E&D1&D&C1&!C&!B1&!B&A1&!A|E1&E&D1&D&C1&!C&!B1&!B&A1&!A|!E1&E&D1&D&C1&!C&!B1&!B&A1&!A|!E1&E&D1&D&!C1&!C&!B1&!B&A1&!A|E1&E&D1&D&!C1&!C&!B1&!B&A1&!A|E1&!E&D1&D&!C1&!C&!B1&!B&A1&!A|E1&!E&D1&D&!C1&!C&!B1&!B&A1&A|E1&E&D1&D&!C1&!C&!B1&!B&A1&A|!E1&E&D1&D&!C1&!C&!B1&!B&A1&A|!E1&E&D1&D&C1&!C&!B1&!B&A1&A|E1&E&D1&D&C1&!C&!B1&!B&A1&A|E1&!E&D1&D&C1&!C&!B1&!B&A1&A|E1&!E&D1&D&C1&C&!B1&!B&A1&A|E1&E&D1&D&C1&C&!B1&!B&A1&A|!E1&E&D1&D&C1&C&!B1&!B&A1&A|!E1&E&D1&D&!C1&C&!B1&!B&A1&A|E1&E&D1&D&!C1&C&!B1&!B&A1&A|E1&!E&D1&D&!C1&C&!B1&!B&A1&A|E1&!E&!D1&!D&!C1&C&B1&!B&A1&A|E1&E&!D1&!D&!C1&C&B1&!B&A1&A|!E1&E&!D1&!D&!C1&C&B1&!B&A1&A|!E1&E&D1&!D&!C1&C&B1&!B&A1&A|E1&E&D1&!D&!C1&C&B1&!B&A1&A|E1&!E&D1&!D&!C1&C&B1&!B&A1&A|E1&!E&D1&D&!C1&C&B1&!B&A1&A|E1&E&D1&D&!C1&C&B1&!B&A1&A|!E1&E&D1&D&!C1&C&B1&!B&A1&A|!E1&E&!D1&D&!C1&C&B1&!B&A1&A|E1&E&!D1&D&!C1&C&B1&!B&A1&A|E1&!E&!D1&D&!C1&C&B1&!B&A1&A|E1&!E&!D1&D&C1&C&B1&!B&A1&A|E1&E&!D1&D&C1&C&B1&!B&A1&A|!E1&E&!D1&D&C1&C&B1&!B&A1&A|!E1&E&D1&D&C1&C&B1&!B&A1&A|E1&E&D1&D&C1&C&B1&!B&A1&A|E1&!E&D1&D&C1&C&B1&!B&A1&A|E1&!E&D1&!D&C1&C&B1&!B&A1&A|E1&E&D1&!D&C1&C&B1&!B&A1&A|!E1&E&D1&!D&C1&C&B1&!B&A1&A|!E1&E&!D1&!D&C1&C&B1&!B&A1&A|E1&E&!D1&!D&C1&C&B1&!B&A1&A|E1&!E&!D1&!D&C1&C&B1&!B&A1&A|E1&!E&!D1&!D&C1&!C&B1&!B&A1&A|E1&E&!D1&!D&C1&!C&B1&!B&A1&A|!E1&E&!D1&!D&C1&!C&B1&!B&A1&A|!E1&E&D1&!D&C1&!C&B1&!B&A1&A|E1&E&D1&!D&C1&!C&B1&!B&A1&A|E1&!E&D1&!D&C1&!C&B1&!B&A1&A|E1&!E&D1&D&C1&!C&B1&!B&A1&A|E1&E&D1&D&C1&!C&B1&!B&A1&A|!E1&E&D1&D&C1&!C&B1&!B&A1&A|!E1&E&!D1&D&C1&!C&B1&!B&A1&A|E1&E&!D1&D&C1&!C&B1&!B&A1&A|E1&!E&!D1&D&C1&!C&B1&!B&A1&A|!E1&E&D1&D&!C1&!C&B1&!B&A1&A|E1&E&D1&D&!C1&!C&B1&!B&A1&A|E1&!E&D1&D&!C1&!C&B1&!B&A1&A|E1&!E&D1&D&!C1&!C&B1&B&A1&A|E1&E&D1&D&!C1&!C&B1&B&A1&A|!E1&E&D1&D&!C1&!C&B1&B&A1&A|E1&!E&!D1&D&C1&!C&B1&B&A1&A|E1&E&!D1&D&C1&!C&B1&B&A1&A|!E1&E&!D1&D&C1&!C&B1&B&A1&A|!E1&E&D1&D&C1&!C&B1&B&A1&A|E1&E&D1&D&C1&!C&B1&B&A1&A|E1&!E&D1&D&C1&!C&B1&B&A1&A|E1&!E&D1&!D&C1&!C&B1&B&A1&A|E1&E&D1&!D&C1&!C&B1&B&A1&A|!E1&E&D1&!D&C1&!C&B1&B&A1&A|!E1&E&!D1&!D&C1&!C&B1&B&A1&A|E1&E&!D1&!D&C1&!C&B1&B&A1&A|E1&!E&!D1&!D&C1&!C&B1&B&A1&A|E1&!E&!D1&!D&C1&C&B1&B&A1&A|E1&E&!D1&!D&C1&C&B1&B&A1&A|!E1&E&!D1&!D&C1&C&B1&B&A1&A|!E1&E&D1&!D&C1&C&B1&B&A1&A|E1&E&D1&!D&C1&C&B1&B&A1&A|E1&!E&D1&!D&C1&C&B1&B&A1&A|E1&!E&D1&D&C1&C&B1&B&A1&A|E1&E&D1&D&C1&C&B1&B&A1&A|!E1&E&D1&D&C1&C&B1&B&A1&A|!E1&E&!D1&D&C1&C&B1&B&A1&A|E1&E&!D1&D&C1&C&B1&B&A1&A|E1&!E&!D1&D&C1&C&B1&B&A1&A|E1&!E&!D1&D&!C1&C&B1&B&A1&A|E1&E&!D1&D&!C1&C&B1&B&A1&A|!E1&E&!D1&D&!C1&C&B1&B&A1&A|!E1&E&D1&D&!C1&C&B1&B&A1&A|E1&E&D1&D&!C1&C&B1&B&A1&A|E1&!E&D1&D&!C1&C&B1&B&A1&A|E1&!E&D1&!D&!C1&C&B1&B&A1&A|E1&E&D1&!D&!C1&C&B1&B&A1&A|!E1&E&D1&!D&!C1&C&B1&B&A1&A|!E1&E&!D1&!D&!C1&C&B1&B&A1&A|E1&E&!D1&!D&!C1&C&B1&B&A1&A|E1&!E&!D1&!D&!C1&C&B1&B&A1&A|E1&!E&!D1&!D&!C1&C&!B1&B&A1&A|E1&E&!D1&!D&!C1&C&!B1&B&A1&A|!E1&E&!D1&!D&!C1&C&!B1&B&A1&A|!E1&E&D1&!D&!C1&C&!B1&B&A1&A|E1&E&D1&!D&!C1&C&!B1&B&A1&A|E1&!E&D1&!D&!C1&C&!B1&B&A1&A|E1&!E&D1&D&!C1&C&!B1&B&A1&A|E1&E&D1&D&!C1&C&!B1&B&A1&A|!E1&E&D1&D&!C1&C&!B1&B&A1&A|!E1&E&!D1&D&!C1&C&!B1&B&A1&A|E1&E&!D1&D&!C1&C&!B1&B&A1&A|E1&!E&!D1&D&!C1&C&!B1&B&A1&A|E1&!E&!D1&D&C1&C&!B1&B&A1&A|E1&E&!D1&D&C1&C&!B1&B&A1&A|!E1&E&!D1&D&C1&C&!B1&B&A1&A|!E1&E&D1&D&C1&C&!B1&B&A1&A|E1&E&D1&D&C1&C&!B1&B&A1&A|E1&!E&D1&D&C1&C&!B1&B&A1&A|E1&!E&D1&!D&C1&C&!B1&B&A1&A|E1&E&D1&!D&C1&C&!B1&B&A1&A|!E1&E&D1&!D&C1&C&!B1&B&A1&A|!E1&E&!D1&!D&C1&C&!B1&B&A1&A|E1&E&!D1&!D&C1&C&!B1&B&A1&A|E1&!E&!D1&!D&C1&C&!B1&B&A1&A|E1&!E&!D1&!D&C1&!C&!B1&B&A1&A|E1&E&!D1&!D&C1&!C&!B1&B&A1&A|!E1&E&!D1&!D&C1&!C&!B1&B&A1&A|!E1&E&D1&!D&C1&!C&!B1&B&A1&A|E1&E&D1&!D&C1&!C&!B1&B&A1&A|E1&!E&D1&!D&C1&!C&!B1&B&A1&A|E1&!E&D1&D&C1&!C&!B1&B&A1&A|E1&E&D1&D&C1&!C&!B1&B&A1&A|!E1&E&D1&D&C1&!C&!B1&B&A1&A|!E1&E&!D1&D&C1&!C&!B1&B&A1&A|E1&E&!D1&D&C1&!C&!B1&B&A1&A|E1&!E&!D1&D&C1&!C&!B1&B&A1&A|!E1&E&D1&D&!C1&!C&!B1&B&A1&A|E1&E&D1&D&!C1&!C&!B1&B&A1&A|E1&!E&D1&D&!C1&!C&!B1&B&A1&A|E1&!E&D1&D&!C1&!C&!B1&B&!A1&A|E1&E&D1&D&!C1&!C&!B1&B&!A1&A|!E1&E&D1&D&!C1&!C&!B1&B&!A1&A|E1&!E&!D1&D&C1&!C&!B1&B&!A1&A|E1&E&!D1&D&C1&!C&!B1&B&!A1&A|!E1&E&!D1&D&C1&!C&!B1&B&!A1&A|!E1&E&D1&D&C1&!C&!B1&B&!A1&A|E1&E&D1&D&C1&!C&!B1&B&!A1&A|E1&!E&D1&D&C1&!C&!B1&B&!A1&A|E1&!E&D1&!D&C1&!C&!B1&B&!A1&A|E1&E&D1&!D&C1&!C&!B1&B&!A1&A|!E1&E&D1&!D&C1&!C&!B1&B&!A1&A|!E1&E&!D1&!D&C1&!C&!B1&B&!A1&A|E1&E&!D1&!D&C1&!C&!B1&B&!A1&A|E1&!E&!D1&!D&C1&!C&!B1&B&!A1&A|E1&!E&!D1&!D&C1&C&!B1&B&!A1&A|E1&E&!D1&!D&C1&C&!B1&B&!A1&A|!E1&E&!D1&!D&C1&C&!B1&B&!A1&A|!E1&E&D1&!D&C1&C&!B1&B&!A1&A|E1&E&D1&!D&C1&C&!B1&B&!A1&A|E1&!E&D1&!D&C1&C&!B1&B&!A1&A|E1&!E&D1&D&C1&C&!B1&B&!A1&A|E1&E&D1&D&C1&C&!B1&B&!A1&A|!E1&E&D1&D&C1&C&!B1&B&!A1&A|!E1&E&!D1&D&C1&C&!B1&B&!A1&A|E1&E&!D1&D&C1&C&!B1&B&!A1&A|E1&!E&!D1&D&C1&C&!B1&B&!A1&A|E1&!E&!D1&D&!C1&C&!B1&B&!A1&A|E1&E&!D1&D&!C1&C&!B1&B&!A1&A|!E1&E&!D1&D&!C1&C&!B1&B&!A1&A|!E1&E&D1&D&!C1&C&!B1&B&!A1&A|E1&E&D1&D&!C1&C&!B1&B&!A1&A|E1&!E&D1&D&!C1&C&!B1&B&!A1&A|E1&!E&D1&!D&!C1&C&!B1&B&!A1&A|E1&E&D1&!D&!C1&C&!B1&B&!A1&A|!E1&E&D1&!D&!C1&C&!B1&B&!A1&A|!E1&E&!D1&!D&!C1&C&!B1&B&!A1&A|E1&E&!D1&!D&!C1&C&!B1&B&!A1&A|E1&!E&!D1&!D&!C1&C&!B1&B&!A1&A|E1&!E&!D1&!D&!C1&C&B1&B&!A1&A|E1&E&!D1&!D&!C1&C&B1&B&!A1&A|!E1&E&!D1&!D&!C1&C&B1&B&!A1&A|!E1&E&D1&!D&!C1&C&B1&B&!A1&A|E1&E&D1&!D&!C1&C&B1&B&!A1&A|E1&!E&D1&!D&!C1&C&B1&B&!A1&A|E1&!E&D1&D&!C1&C&B1&B&!A1&A|E1&E&D1&D&!C1&C&B1&B&!A1&A|!E1&E&D1&D&!C1&C&B1&B&!A1&A|!E1&E&!D1&D&!C1&C&B1&B&!A1&A|E1&E&!D1&D&!C1&C&B1&B&!A1&A|E1&!E&!D1&D&!C1&C&B1&B&!A1&A|E1&!E&!D1&D&C1&C&B1&B&!A1&A|E1&E&!D1&D&C1&C&B1&B&!A1&A|!E1&E&!D1&D&C1&C&B1&B&!A1&A|!E1&E&D1&D&C1&C&B1&B&!A1&A|E1&E&D1&D&C1&C&B1&B&!A1&A|E1&!E&D1&D&C1&C&B1&B&!A1&A|E1&!E&D1&!D&C1&C&B1&B&!A1&A|E1&E&D1&!D&C1&C&B1&B&!A1&A|!E1&E&D1&!D&C1&C&B1&B&!A1&A|!E1&E&!D1&!D&C1&C&B1&B&!A1&A|E1&E&!D1&!D&C1&C&B1&B&!A1&A|E1&!E&!D1&!D&C1&C&B1&B&!A1&A|E1&!E&!D1&!D&C1&!C&B1&B&!A1&A|E1&E&!D1&!D&C1&!C&B1&B&!A1&A|!E1&E&!D1&!D&C1&!C&B1&B&!A1&A|!E1&E&D1&!D&C1&!C&B1&B&!A1&A|E1&E&D1&!D&C1&!C&B1&B&!A1&A|E1&!E&D1&!D&C1&!C&B1&B&!A1&A|E1&!E&D1&D&C1&!C&B1&B&!A1&A|E1&E&D1&D&C1&!C&B1&B&!A1&A|!E1&E&D1&D&C1&!C&B1&B&!A1&A|!E1&E&!D1&D&C1&!C&B1&B&!A1&A|E1&E&!D1&D&C1&!C&B1&B&!A1&A|E1&!E&!D1&D&C1&!C&B1&B&!A1&A|!E1&E&D1&D&!C1&!C&B1&B&!A1&A|E1&E&D1&D&!C1&!C&B1&B&!A1&A|E1&!E&D1&D&!C1&!C&B1&B&!A1&A|E1&!E&D1&D&!C1&!C&B1&!B&!A1&A|E1&E&D1&D&!C1&!C&B1&!B&!A1&A|!E1&E&D1&D&!C1&!C&B1&!B&!A1&A|E1&!E&!D1&D&C1&!C&B1&!B&!A1&A|E1&E&!D1&D&C1&!C&B1&!B&!A1&A|!E1&E&!D1&D&C1&!C&B1&!B&!A1&A|!E1&E&D1&D&C1&!C&B1&!B&!A1&A|E1&E&D1&D&C1&!C&B1&!B&!A1&A|E1&!E&D1&D&C1&!C&B1&!B&!A1&A|E1&!E&D1&!D&C1&!C&B1&!B&!A1&A|E1&E&D1&!D&C1&!C&B1&!B&!A1&A|!E1&E&D1&!D&C1&!C&B1&!B&!A1&A|!E1&E&!D1&!D&C1&!C&B1&!B&!A1&A|E1&E&!D1&!D&C1&!C&B1&!B&!A1&A|E1&!E&!D1&!D&C1&!C&B1&!B&!A1&A|E1&!E&!D1&!D&C1&C&B1&!B&!A1&A|E1&E&!D1&!D&C1&C&B1&!B&!A1&A|!E1&E&!D1&!D&C1&C&B1&!B&!A1&A|!E1&E&D1&!D&C1&C&B1&!B&!A1&A|E1&E&D1&!D&C1&C&B1&!B&!A1&A|E1&!E&D1&!D&C1&C&B1&!B&!A1&A|E1&!E&D1&D&C1&C&B1&!B&!A1&A|E1&E&D1&D&C1&C&B1&!B&!A1&A|!E1&E&D1&D&C1&C&B1&!B&!A1&A|!E1&E&!D1&D&C1&C&B1&!B&!A1&A|E1&E&!D1&D&C1&C&B1&!B&!A1&A|E1&!E&!D1&D&C1&C&B1&!B&!A1&A|E1&!E&!D1&D&!C1&C&B1&!B&!A1&A|E1&E&!D1&D&!C1&C&B1&!B&!A1&A|!E1&E&!D1&D&!C1&C&B1&!B&!A1&A|!E1&E&D1&D&!C1&C&B1&!B&!A1&A|E1&E&D1&D&!C1&C&B1&!B&!A1&A|E1&!E&D1&D&!C1&C&B1&!B&!A1&A|E1&!E&D1&!D&!C1&C&B1&!B&!A1&A|E1&E&D1&!D&!C1&C&B1&!B&!A1&A|!E1&E&D1&!D&!C1&C&B1&!B&!A1&A|!E1&E&!D1&!D&!C1&C&B1&!B&!A1&A|E1&E&!D1&!D&!C1&C&B1&!B&!A1&A|E1&!E&!D1&!D&!C1&C&B1&!B&!A1&A|E1&!E&D1&D&!C1&C&!B1&!B&!A1&A|E1&E&D1&D&!C1&C&!B1&!B&!A1&A|!E1&E&D1&D&!C1&C&!B1&!B&!A1&A|!E1&E&D1&D&C1&C&!B1&!B&!A1&A|E1&E&D1&D&C1&C&!B1&!B&!A1&A|E1&!E&D1&D&C1&C&!B1&!B&!A1&A|E1&!E&D1&D&C1&!C&!B1&!B&!A1&A|E1&E&D1&D&C1&!C&!B1&!B&!A1&A|!E1&E&D1&D&C1&!C&!B1&!B&!A1&A|!E1&E&D1&D&!C1&!C&!B1&!B&!A1&A|E1&E&D1&D&!C1&!C&!B1&!B&!A1&A|E1&!E&D1&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAAOOAI22222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOAOI22311 -l OAAOAOI22311 -i E D C2 C1 C B1 B A1 A -o Y -f Y=(!E&!D&!C2&!C1&!C&!B1&!B&!A1&!A|!E&D&!C2&!C1&!C&!B1&!B&!A1&!A|!E&D&C2&!C1&!C&!B1&!B&!A1&!A|!E&!D&C2&!C1&!C&!B1&!B&!A1&!A|!E&!D&C2&C1&!C&!B1&!B&!A1&!A|!E&D&C2&C1&!C&!B1&!B&!A1&!A|!E&D&!C2&C1&!C&!B1&!B&!A1&!A|!E&!D&!C2&C1&!C&!B1&!B&!A1&!A|!E&!D&!C2&C1&C&!B1&!B&!A1&!A|!E&D&!C2&C1&C&!B1&!B&!A1&!A|!E&!D&C2&C1&C&!B1&!B&!A1&!A|!E&!D&C2&!C1&C&!B1&!B&!A1&!A|!E&D&C2&!C1&C&!B1&!B&!A1&!A|!E&D&!C2&!C1&C&!B1&!B&!A1&!A|!E&!D&!C2&!C1&C&!B1&!B&!A1&!A|!E&!D&!C2&!C1&C&B1&!B&!A1&!A|!E&D&!C2&!C1&C&B1&!B&!A1&!A|!E&D&C2&!C1&C&B1&!B&!A1&!A|!E&!D&C2&!C1&C&B1&!B&!A1&!A|!E&!D&C2&C1&C&B1&!B&!A1&!A|!E&D&!C2&C1&C&B1&!B&!A1&!A|!E&!D&!C2&C1&C&B1&!B&!A1&!A|!E&!D&!C2&C1&!C&B1&!B&!A1&!A|!E&D&!C2&C1&!C&B1&!B&!A1&!A|!E&D&C2&C1&!C&B1&!B&!A1&!A|!E&!D&C2&C1&!C&B1&!B&!A1&!A|!E&!D&C2&!C1&!C&B1&!B&!A1&!A|!E&D&C2&!C1&!C&B1&!B&!A1&!A|!E&D&!C2&!C1&!C&B1&!B&!A1&!A|!E&!D&!C2&!C1&!C&B1&!B&!A1&!A|!E&!D&!C2&!C1&!C&B1&B&!A1&!A|!E&D&!C2&!C1&!C&B1&B&!A1&!A|!E&D&C2&!C1&!C&B1&B&!A1&!A|!E&!D&C2&!C1&!C&B1&B&!A1&!A|!E&!D&C2&C1&!C&B1&B&!A1&!A|!E&D&C2&C1&!C&B1&B&!A1&!A|!E&D&!C2&C1&!C&B1&B&!A1&!A|!E&!D&!C2&C1&!C&B1&B&!A1&!A|!E&!D&!C2&C1&C&B1&B&!A1&!A|!E&D&!C2&C1&C&B1&B&!A1&!A|!E&!D&C2&C1&C&B1&B&!A1&!A|!E&!D&C2&!C1&C&B1&B&!A1&!A|!E&D&C2&!C1&C&B1&B&!A1&!A|!E&D&!C2&!C1&C&B1&B&!A1&!A|!E&!D&!C2&!C1&C&B1&B&!A1&!A|!E&!D&!C2&!C1&C&!B1&B&!A1&!A|!E&D&!C2&!C1&C&!B1&B&!A1&!A|!E&D&C2&!C1&C&!B1&B&!A1&!A|!E&!D&C2&!C1&C&!B1&B&!A1&!A|!E&!D&C2&C1&C&!B1&B&!A1&!A|!E&D&!C2&C1&C&!B1&B&!A1&!A|!E&!D&!C2&C1&C&!B1&B&!A1&!A|!E&!D&!C2&C1&!C&!B1&B&!A1&!A|!E&D&!C2&C1&!C&!B1&B&!A1&!A|!E&D&C2&C1&!C&!B1&B&!A1&!A|!E&!D&C2&C1&!C&!B1&B&!A1&!A|!E&!D&C2&!C1&!C&!B1&B&!A1&!A|!E&D&C2&!C1&!C&!B1&B&!A1&!A|!E&D&!C2&!C1&!C&!B1&B&!A1&!A|!E&!D&!C2&!C1&!C&!B1&B&!A1&!A|!E&!D&!C2&!C1&!C&!B1&B&A1&!A|!E&D&!C2&!C1&!C&!B1&B&A1&!A|!E&D&C2&!C1&!C&!B1&B&A1&!A|!E&!D&C2&!C1&!C&!B1&B&A1&!A|!E&!D&C2&C1&!C&!B1&B&A1&!A|!E&D&C2&C1&!C&!B1&B&A1&!A|!E&D&!C2&C1&!C&!B1&B&A1&!A|!E&!D&!C2&C1&!C&!B1&B&A1&!A|!E&!D&!C2&C1&C&!B1&B&A1&!A|!E&D&!C2&C1&C&!B1&B&A1&!A|!E&!D&C2&C1&C&!B1&B&A1&!A|!E&!D&C2&!C1&C&!B1&B&A1&!A|!E&D&C2&!C1&C&!B1&B&A1&!A|!E&D&!C2&!C1&C&!B1&B&A1&!A|!E&!D&!C2&!C1&C&!B1&B&A1&!A|!E&!D&!C2&!C1&C&B1&B&A1&!A|!E&!D&C2&!C1&C&B1&B&A1&!A|!E&!D&C2&C1&C&B1&B&A1&!A|!E&!D&!C2&C1&C&B1&B&A1&!A|!E&!D&!C2&C1&!C&B1&B&A1&!A|!E&!D&C2&C1&!C&B1&B&A1&!A|!E&!D&C2&!C1&!C&B1&B&A1&!A|!E&!D&!C2&!C1&!C&B1&B&A1&!A|!E&!D&!C2&!C1&!C&B1&!B&A1&!A|!E&D&!C2&!C1&!C&B1&!B&A1&!A|!E&D&C2&!C1&!C&B1&!B&A1&!A|!E&!D&C2&!C1&!C&B1&!B&A1&!A|!E&!D&C2&C1&!C&B1&!B&A1&!A|!E&D&C2&C1&!C&B1&!B&A1&!A|!E&D&!C2&C1&!C&B1&!B&A1&!A|!E&!D&!C2&C1&!C&B1&!B&A1&!A|!E&!D&!C2&C1&C&B1&!B&A1&!A|!E&D&!C2&C1&C&B1&!B&A1&!A|!E&!D&C2&C1&C&B1&!B&A1&!A|!E&!D&C2&!C1&C&B1&!B&A1&!A|!E&D&C2&!C1&C&B1&!B&A1&!A|!E&D&!C2&!C1&C&B1&!B&A1&!A|!E&!D&!C2&!C1&C&B1&!B&A1&!A|!E&!D&!C2&!C1&C&!B1&!B&A1&!A|!E&D&!C2&!C1&C&!B1&!B&A1&!A|!E&D&C2&!C1&C&!B1&!B&A1&!A|!E&!D&C2&!C1&C&!B1&!B&A1&!A|!E&!D&C2&C1&C&!B1&!B&A1&!A|!E&D&!C2&C1&C&!B1&!B&A1&!A|!E&!D&!C2&C1&C&!B1&!B&A1&!A|!E&!D&!C2&C1&!C&!B1&!B&A1&!A|!E&D&!C2&C1&!C&!B1&!B&A1&!A|!E&D&C2&C1&!C&!B1&!B&A1&!A|!E&!D&C2&C1&!C&!B1&!B&A1&!A|!E&!D&C2&!C1&!C&!B1&!B&A1&!A|!E&D&C2&!C1&!C&!B1&!B&A1&!A|!E&D&!C2&!C1&!C&!B1&!B&A1&!A|!E&!D&!C2&!C1&!C&!B1&!B&A1&!A|!E&!D&!C2&!C1&!C&!B1&!B&A1&A|!E&D&!C2&!C1&!C&!B1&!B&A1&A|!E&D&C2&!C1&!C&!B1&!B&A1&A|!E&!D&C2&!C1&!C&!B1&!B&A1&A|!E&!D&C2&C1&!C&!B1&!B&A1&A|!E&D&C2&C1&!C&!B1&!B&A1&A|!E&D&!C2&C1&!C&!B1&!B&A1&A|!E&!D&!C2&C1&!C&!B1&!B&A1&A|!E&!D&!C2&C1&C&!B1&!B&A1&A|!E&D&!C2&C1&C&!B1&!B&A1&A|!E&!D&C2&C1&C&!B1&!B&A1&A|!E&!D&C2&!C1&C&!B1&!B&A1&A|!E&D&C2&!C1&C&!B1&!B&A1&A|!E&D&!C2&!C1&C&!B1&!B&A1&A|!E&!D&!C2&!C1&C&!B1&!B&A1&A|!E&!D&!C2&!C1&C&B1&!B&A1&A|!E&D&!C2&!C1&C&B1&!B&A1&A|!E&D&C2&!C1&C&B1&!B&A1&A|!E&!D&C2&!C1&C&B1&!B&A1&A|!E&!D&C2&C1&C&B1&!B&A1&A|!E&D&!C2&C1&C&B1&!B&A1&A|!E&!D&!C2&C1&C&B1&!B&A1&A|!E&!D&!C2&C1&!C&B1&!B&A1&A|!E&D&!C2&C1&!C&B1&!B&A1&A|!E&D&C2&C1&!C&B1&!B&A1&A|!E&!D&C2&C1&!C&B1&!B&A1&A|!E&!D&C2&!C1&!C&B1&!B&A1&A|!E&D&C2&!C1&!C&B1&!B&A1&A|!E&D&!C2&!C1&!C&B1&!B&A1&A|!E&!D&!C2&!C1&!C&B1&!B&A1&A|!E&!D&!C2&!C1&!C&B1&B&A1&A|!E&!D&C2&!C1&!C&B1&B&A1&A|!E&!D&C2&C1&!C&B1&B&A1&A|!E&!D&!C2&C1&!C&B1&B&A1&A|!E&!D&!C2&C1&C&B1&B&A1&A|!E&!D&C2&C1&C&B1&B&A1&A|!E&!D&C2&!C1&C&B1&B&A1&A|!E&!D&!C2&!C1&C&B1&B&A1&A|!E&!D&!C2&!C1&C&!B1&B&A1&A|!E&D&!C2&!C1&C&!B1&B&A1&A|!E&D&C2&!C1&C&!B1&B&A1&A|!E&!D&C2&!C1&C&!B1&B&A1&A|!E&!D&C2&C1&C&!B1&B&A1&A|!E&D&!C2&C1&C&!B1&B&A1&A|!E&!D&!C2&C1&C&!B1&B&A1&A|!E&!D&!C2&C1&!C&!B1&B&A1&A|!E&D&!C2&C1&!C&!B1&B&A1&A|!E&D&C2&C1&!C&!B1&B&A1&A|!E&!D&C2&C1&!C&!B1&B&A1&A|!E&!D&C2&!C1&!C&!B1&B&A1&A|!E&D&C2&!C1&!C&!B1&B&A1&A|!E&D&!C2&!C1&!C&!B1&B&A1&A|!E&!D&!C2&!C1&!C&!B1&B&A1&A|!E&!D&!C2&!C1&!C&!B1&B&!A1&A|!E&D&!C2&!C1&!C&!B1&B&!A1&A|!E&D&C2&!C1&!C&!B1&B&!A1&A|!E&!D&C2&!C1&!C&!B1&B&!A1&A|!E&!D&C2&C1&!C&!B1&B&!A1&A|!E&D&C2&C1&!C&!B1&B&!A1&A|!E&D&!C2&C1&!C&!B1&B&!A1&A|!E&!D&!C2&C1&!C&!B1&B&!A1&A|!E&!D&!C2&C1&C&!B1&B&!A1&A|!E&D&!C2&C1&C&!B1&B&!A1&A|!E&!D&C2&C1&C&!B1&B&!A1&A|!E&!D&C2&!C1&C&!B1&B&!A1&A|!E&D&C2&!C1&C&!B1&B&!A1&A|!E&D&!C2&!C1&C&!B1&B&!A1&A|!E&!D&!C2&!C1&C&!B1&B&!A1&A|!E&!D&!C2&!C1&C&B1&B&!A1&A|!E&!D&C2&!C1&C&B1&B&!A1&A|!E&!D&C2&C1&C&B1&B&!A1&A|!E&!D&!C2&C1&C&B1&B&!A1&A|!E&!D&!C2&C1&!C&B1&B&!A1&A|!E&!D&C2&C1&!C&B1&B&!A1&A|!E&!D&C2&!C1&!C&B1&B&!A1&A|!E&!D&!C2&!C1&!C&B1&B&!A1&A|!E&!D&!C2&!C1&!C&B1&!B&!A1&A|!E&D&!C2&!C1&!C&B1&!B&!A1&A|!E&D&C2&!C1&!C&B1&!B&!A1&A|!E&!D&C2&!C1&!C&B1&!B&!A1&A|!E&!D&C2&C1&!C&B1&!B&!A1&A|!E&D&C2&C1&!C&B1&!B&!A1&A|!E&D&!C2&C1&!C&B1&!B&!A1&A|!E&!D&!C2&C1&!C&B1&!B&!A1&A|!E&!D&!C2&C1&C&B1&!B&!A1&A|!E&D&!C2&C1&C&B1&!B&!A1&A|!E&!D&C2&C1&C&B1&!B&!A1&A|!E&!D&C2&!C1&C&B1&!B&!A1&A|!E&D&C2&!C1&C&B1&!B&!A1&A|!E&D&!C2&!C1&C&B1&!B&!A1&A|!E&!D&!C2&!C1&C&B1&!B&!A1&A|!E&!D&!C2&!C1&C&!B1&!B&!A1&A|!E&D&!C2&!C1&C&!B1&!B&!A1&A|!E&D&C2&!C1&C&!B1&!B&!A1&A|!E&!D&C2&!C1&C&!B1&!B&!A1&A|!E&!D&C2&C1&C&!B1&!B&!A1&A|!E&D&!C2&C1&C&!B1&!B&!A1&A|!E&!D&!C2&C1&C&!B1&!B&!A1&A|!E&!D&!C2&C1&!C&!B1&!B&!A1&A|!E&D&!C2&C1&!C&!B1&!B&!A1&A|!E&D&C2&C1&!C&!B1&!B&!A1&A|!E&!D&C2&C1&!C&!B1&!B&!A1&A|!E&!D&C2&!C1&!C&!B1&!B&!A1&A|!E&D&C2&!C1&!C&!B1&!B&!A1&A|!E&D&!C2&!C1&!C&!B1&!B&!A1&A|!E&!D&!C2&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOAOI22311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOOAOAI222211 -l OOAAOOAOAI222211 -i F E D1 D C1 C B1 B A1 A -o Y -f Y=!(F&E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|F&E&D1&!D&!C1&!C&!B1&!B&!A1&!A|F&E&D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&!D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&!D1&D&C1&!C&!B1&!B&!A1&!A|F&E&D1&D&C1&!C&!B1&!B&!A1&!A|F&E&D1&!D&C1&!C&!B1&!B&!A1&!A|F&E&!D1&!D&C1&!C&!B1&!B&!A1&!A|F&E&!D1&!D&C1&C&!B1&!B&!A1&!A|F&E&D1&!D&C1&C&!B1&!B&!A1&!A|F&!E&D1&!D&C1&C&!B1&!B&!A1&!A|F&!E&D1&D&C1&C&!B1&!B&!A1&!A|F&E&D1&D&C1&C&!B1&!B&!A1&!A|F&E&!D1&D&C1&C&!B1&!B&!A1&!A|F&!E&!D1&D&C1&C&!B1&!B&!A1&!A|F&E&!D1&D&!C1&C&!B1&!B&!A1&!A|F&E&D1&D&!C1&C&!B1&!B&!A1&!A|F&E&D1&!D&!C1&C&!B1&!B&!A1&!A|F&E&!D1&!D&!C1&C&!B1&!B&!A1&!A|F&E&!D1&!D&!C1&C&B1&!B&!A1&!A|F&E&D1&!D&!C1&C&B1&!B&!A1&!A|F&E&D1&D&!C1&C&B1&!B&!A1&!A|F&E&!D1&D&!C1&C&B1&!B&!A1&!A|F&!E&!D1&D&C1&C&B1&!B&!A1&!A|F&E&!D1&D&C1&C&B1&!B&!A1&!A|F&E&D1&D&C1&C&B1&!B&!A1&!A|F&!E&D1&D&C1&C&B1&!B&!A1&!A|F&!E&D1&!D&C1&C&B1&!B&!A1&!A|F&E&D1&!D&C1&C&B1&!B&!A1&!A|F&E&!D1&!D&C1&C&B1&!B&!A1&!A|F&E&!D1&!D&C1&!C&B1&!B&!A1&!A|F&E&D1&!D&C1&!C&B1&!B&!A1&!A|F&E&D1&D&C1&!C&B1&!B&!A1&!A|F&E&!D1&D&C1&!C&B1&!B&!A1&!A|F&E&!D1&D&!C1&!C&B1&!B&!A1&!A|F&E&D1&D&!C1&!C&B1&!B&!A1&!A|F&E&D1&!D&!C1&!C&B1&!B&!A1&!A|F&E&!D1&!D&!C1&!C&B1&!B&!A1&!A|F&E&!D1&!D&!C1&!C&B1&B&!A1&!A|F&E&D1&!D&!C1&!C&B1&B&!A1&!A|F&E&D1&D&!C1&!C&B1&B&!A1&!A|F&E&!D1&D&!C1&!C&B1&B&!A1&!A|F&E&!D1&D&C1&!C&B1&B&!A1&!A|F&E&D1&D&C1&!C&B1&B&!A1&!A|F&E&D1&!D&C1&!C&B1&B&!A1&!A|F&E&!D1&!D&C1&!C&B1&B&!A1&!A|F&E&!D1&!D&C1&C&B1&B&!A1&!A|F&E&D1&!D&C1&C&B1&B&!A1&!A|F&!E&D1&!D&C1&C&B1&B&!A1&!A|F&!E&D1&D&C1&C&B1&B&!A1&!A|F&E&D1&D&C1&C&B1&B&!A1&!A|F&E&!D1&D&C1&C&B1&B&!A1&!A|F&!E&!D1&D&C1&C&B1&B&!A1&!A|F&E&!D1&D&!C1&C&B1&B&!A1&!A|F&E&D1&D&!C1&C&B1&B&!A1&!A|F&E&D1&!D&!C1&C&B1&B&!A1&!A|F&E&!D1&!D&!C1&C&B1&B&!A1&!A|F&E&!D1&!D&!C1&C&!B1&B&!A1&!A|F&E&D1&!D&!C1&C&!B1&B&!A1&!A|F&E&D1&D&!C1&C&!B1&B&!A1&!A|F&E&!D1&D&!C1&C&!B1&B&!A1&!A|F&!E&!D1&D&C1&C&!B1&B&!A1&!A|F&E&!D1&D&C1&C&!B1&B&!A1&!A|F&E&D1&D&C1&C&!B1&B&!A1&!A|F&!E&D1&D&C1&C&!B1&B&!A1&!A|F&!E&D1&!D&C1&C&!B1&B&!A1&!A|F&E&D1&!D&C1&C&!B1&B&!A1&!A|F&E&!D1&!D&C1&C&!B1&B&!A1&!A|F&E&!D1&!D&C1&!C&!B1&B&!A1&!A|F&E&D1&!D&C1&!C&!B1&B&!A1&!A|F&E&D1&D&C1&!C&!B1&B&!A1&!A|F&E&!D1&D&C1&!C&!B1&B&!A1&!A|F&E&!D1&D&!C1&!C&!B1&B&!A1&!A|F&E&D1&D&!C1&!C&!B1&B&!A1&!A|F&E&D1&!D&!C1&!C&!B1&B&!A1&!A|F&E&!D1&!D&!C1&!C&!B1&B&!A1&!A|F&E&!D1&!D&!C1&!C&!B1&B&A1&!A|F&E&D1&!D&!C1&!C&!B1&B&A1&!A|F&!E&D1&!D&!C1&!C&!B1&B&A1&!A|F&!E&D1&D&!C1&!C&!B1&B&A1&!A|F&E&D1&D&!C1&!C&!B1&B&A1&!A|F&E&!D1&D&!C1&!C&!B1&B&A1&!A|F&!E&!D1&D&!C1&!C&!B1&B&A1&!A|F&!E&!D1&D&C1&!C&!B1&B&A1&!A|F&E&!D1&D&C1&!C&!B1&B&A1&!A|F&E&D1&D&C1&!C&!B1&B&A1&!A|F&!E&D1&D&C1&!C&!B1&B&A1&!A|F&!E&D1&!D&C1&!C&!B1&B&A1&!A|F&E&D1&!D&C1&!C&!B1&B&A1&!A|F&E&!D1&!D&C1&!C&!B1&B&A1&!A|F&E&!D1&!D&C1&C&!B1&B&A1&!A|F&E&D1&!D&C1&C&!B1&B&A1&!A|F&!E&D1&!D&C1&C&!B1&B&A1&!A|F&!E&D1&D&C1&C&!B1&B&A1&!A|F&E&D1&D&C1&C&!B1&B&A1&!A|F&E&!D1&D&C1&C&!B1&B&A1&!A|F&!E&!D1&D&C1&C&!B1&B&A1&!A|F&!E&!D1&D&!C1&C&!B1&B&A1&!A|F&E&!D1&D&!C1&C&!B1&B&A1&!A|F&E&D1&D&!C1&C&!B1&B&A1&!A|F&!E&D1&D&!C1&C&!B1&B&A1&!A|F&!E&D1&!D&!C1&C&!B1&B&A1&!A|F&E&D1&!D&!C1&C&!B1&B&A1&!A|F&E&!D1&!D&!C1&C&!B1&B&A1&!A|F&E&!D1&!D&!C1&C&B1&B&A1&!A|F&E&D1&!D&!C1&C&B1&B&A1&!A|F&!E&D1&!D&!C1&C&B1&B&A1&!A|F&!E&D1&D&!C1&C&B1&B&A1&!A|F&E&D1&D&!C1&C&B1&B&A1&!A|F&E&!D1&D&!C1&C&B1&B&A1&!A|F&!E&!D1&D&!C1&C&B1&B&A1&!A|F&!E&!D1&D&C1&C&B1&B&A1&!A|F&E&!D1&D&C1&C&B1&B&A1&!A|F&E&D1&D&C1&C&B1&B&A1&!A|F&!E&D1&D&C1&C&B1&B&A1&!A|F&!E&D1&!D&C1&C&B1&B&A1&!A|F&E&D1&!D&C1&C&B1&B&A1&!A|F&E&!D1&!D&C1&C&B1&B&A1&!A|F&E&!D1&!D&C1&!C&B1&B&A1&!A|F&E&D1&!D&C1&!C&B1&B&A1&!A|F&!E&D1&!D&C1&!C&B1&B&A1&!A|F&!E&D1&D&C1&!C&B1&B&A1&!A|F&E&D1&D&C1&!C&B1&B&A1&!A|F&E&!D1&D&C1&!C&B1&B&A1&!A|F&!E&!D1&D&C1&!C&B1&B&A1&!A|F&!E&!D1&D&!C1&!C&B1&B&A1&!A|F&E&!D1&D&!C1&!C&B1&B&A1&!A|F&E&D1&D&!C1&!C&B1&B&A1&!A|F&!E&D1&D&!C1&!C&B1&B&A1&!A|F&!E&D1&!D&!C1&!C&B1&B&A1&!A|F&E&D1&!D&!C1&!C&B1&B&A1&!A|F&E&!D1&!D&!C1&!C&B1&B&A1&!A|F&E&!D1&!D&!C1&!C&B1&!B&A1&!A|F&E&D1&!D&!C1&!C&B1&!B&A1&!A|F&!E&D1&!D&!C1&!C&B1&!B&A1&!A|F&!E&D1&D&!C1&!C&B1&!B&A1&!A|F&E&D1&D&!C1&!C&B1&!B&A1&!A|F&E&!D1&D&!C1&!C&B1&!B&A1&!A|F&!E&!D1&D&!C1&!C&B1&!B&A1&!A|F&!E&!D1&D&C1&!C&B1&!B&A1&!A|F&E&!D1&D&C1&!C&B1&!B&A1&!A|F&E&D1&D&C1&!C&B1&!B&A1&!A|F&!E&D1&D&C1&!C&B1&!B&A1&!A|F&!E&D1&!D&C1&!C&B1&!B&A1&!A|F&E&D1&!D&C1&!C&B1&!B&A1&!A|F&E&!D1&!D&C1&!C&B1&!B&A1&!A|F&E&!D1&!D&C1&C&B1&!B&A1&!A|F&E&D1&!D&C1&C&B1&!B&A1&!A|F&!E&D1&!D&C1&C&B1&!B&A1&!A|F&!E&D1&D&C1&C&B1&!B&A1&!A|F&E&D1&D&C1&C&B1&!B&A1&!A|F&E&!D1&D&C1&C&B1&!B&A1&!A|F&!E&!D1&D&C1&C&B1&!B&A1&!A|F&!E&!D1&D&!C1&C&B1&!B&A1&!A|F&E&!D1&D&!C1&C&B1&!B&A1&!A|F&E&D1&D&!C1&C&B1&!B&A1&!A|F&!E&D1&D&!C1&C&B1&!B&A1&!A|F&!E&D1&!D&!C1&C&B1&!B&A1&!A|F&E&D1&!D&!C1&C&B1&!B&A1&!A|F&E&!D1&!D&!C1&C&B1&!B&A1&!A|F&E&!D1&!D&!C1&C&!B1&!B&A1&!A|F&E&D1&!D&!C1&C&!B1&!B&A1&!A|F&E&D1&D&!C1&C&!B1&!B&A1&!A|F&E&!D1&D&!C1&C&!B1&!B&A1&!A|F&!E&!D1&D&C1&C&!B1&!B&A1&!A|F&E&!D1&D&C1&C&!B1&!B&A1&!A|F&E&D1&D&C1&C&!B1&!B&A1&!A|F&!E&D1&D&C1&C&!B1&!B&A1&!A|F&!E&D1&!D&C1&C&!B1&!B&A1&!A|F&E&D1&!D&C1&C&!B1&!B&A1&!A|F&E&!D1&!D&C1&C&!B1&!B&A1&!A|F&E&!D1&!D&C1&!C&!B1&!B&A1&!A|F&E&D1&!D&C1&!C&!B1&!B&A1&!A|F&E&D1&D&C1&!C&!B1&!B&A1&!A|F&E&!D1&D&C1&!C&!B1&!B&A1&!A|F&E&!D1&D&!C1&!C&!B1&!B&A1&!A|F&E&D1&D&!C1&!C&!B1&!B&A1&!A|F&E&D1&!D&!C1&!C&!B1&!B&A1&!A|F&E&!D1&!D&!C1&!C&!B1&!B&A1&!A|F&E&!D1&!D&!C1&!C&!B1&!B&A1&A|F&E&D1&!D&!C1&!C&!B1&!B&A1&A|F&E&D1&D&!C1&!C&!B1&!B&A1&A|F&E&!D1&D&!C1&!C&!B1&!B&A1&A|F&E&!D1&D&C1&!C&!B1&!B&A1&A|F&E&D1&D&C1&!C&!B1&!B&A1&A|F&E&D1&!D&C1&!C&!B1&!B&A1&A|F&E&!D1&!D&C1&!C&!B1&!B&A1&A|F&E&!D1&!D&C1&C&!B1&!B&A1&A|F&E&D1&!D&C1&C&!B1&!B&A1&A|F&!E&D1&!D&C1&C&!B1&!B&A1&A|F&!E&D1&D&C1&C&!B1&!B&A1&A|F&E&D1&D&C1&C&!B1&!B&A1&A|F&E&!D1&D&C1&C&!B1&!B&A1&A|F&!E&!D1&D&C1&C&!B1&!B&A1&A|F&E&!D1&D&!C1&C&!B1&!B&A1&A|F&E&D1&D&!C1&C&!B1&!B&A1&A|F&E&D1&!D&!C1&C&!B1&!B&A1&A|F&E&!D1&!D&!C1&C&!B1&!B&A1&A|F&E&!D1&!D&!C1&C&B1&!B&A1&A|F&E&D1&!D&!C1&C&B1&!B&A1&A|F&!E&D1&!D&!C1&C&B1&!B&A1&A|F&!E&D1&D&!C1&C&B1&!B&A1&A|F&E&D1&D&!C1&C&B1&!B&A1&A|F&E&!D1&D&!C1&C&B1&!B&A1&A|F&!E&!D1&D&!C1&C&B1&!B&A1&A|F&!E&!D1&D&C1&C&B1&!B&A1&A|F&E&!D1&D&C1&C&B1&!B&A1&A|F&E&D1&D&C1&C&B1&!B&A1&A|F&!E&D1&D&C1&C&B1&!B&A1&A|F&!E&D1&!D&C1&C&B1&!B&A1&A|F&E&D1&!D&C1&C&B1&!B&A1&A|F&E&!D1&!D&C1&C&B1&!B&A1&A|F&E&!D1&!D&C1&!C&B1&!B&A1&A|F&E&D1&!D&C1&!C&B1&!B&A1&A|F&!E&D1&!D&C1&!C&B1&!B&A1&A|F&!E&D1&D&C1&!C&B1&!B&A1&A|F&E&D1&D&C1&!C&B1&!B&A1&A|F&E&!D1&D&C1&!C&B1&!B&A1&A|F&!E&!D1&D&C1&!C&B1&!B&A1&A|F&!E&!D1&D&!C1&!C&B1&!B&A1&A|F&E&!D1&D&!C1&!C&B1&!B&A1&A|F&E&D1&D&!C1&!C&B1&!B&A1&A|F&!E&D1&D&!C1&!C&B1&!B&A1&A|F&!E&D1&!D&!C1&!C&B1&!B&A1&A|F&E&D1&!D&!C1&!C&B1&!B&A1&A|F&E&!D1&!D&!C1&!C&B1&!B&A1&A|F&E&!D1&!D&!C1&!C&B1&B&A1&A|F&E&D1&!D&!C1&!C&B1&B&A1&A|F&!E&D1&!D&!C1&!C&B1&B&A1&A|F&!E&D1&D&!C1&!C&B1&B&A1&A|F&E&D1&D&!C1&!C&B1&B&A1&A|F&E&!D1&D&!C1&!C&B1&B&A1&A|F&!E&!D1&D&!C1&!C&B1&B&A1&A|F&!E&!D1&D&C1&!C&B1&B&A1&A|F&E&!D1&D&C1&!C&B1&B&A1&A|F&E&D1&D&C1&!C&B1&B&A1&A|F&!E&D1&D&C1&!C&B1&B&A1&A|F&!E&D1&!D&C1&!C&B1&B&A1&A|F&E&D1&!D&C1&!C&B1&B&A1&A|F&E&!D1&!D&C1&!C&B1&B&A1&A|F&E&!D1&!D&C1&C&B1&B&A1&A|F&E&D1&!D&C1&C&B1&B&A1&A|F&!E&D1&!D&C1&C&B1&B&A1&A|F&!E&D1&D&C1&C&B1&B&A1&A|F&E&D1&D&C1&C&B1&B&A1&A|F&E&!D1&D&C1&C&B1&B&A1&A|F&!E&!D1&D&C1&C&B1&B&A1&A|F&!E&!D1&D&!C1&C&B1&B&A1&A|F&E&!D1&D&!C1&C&B1&B&A1&A|F&E&D1&D&!C1&C&B1&B&A1&A|F&!E&D1&D&!C1&C&B1&B&A1&A|F&!E&D1&!D&!C1&C&B1&B&A1&A|F&E&D1&!D&!C1&C&B1&B&A1&A|F&E&!D1&!D&!C1&C&B1&B&A1&A|F&E&!D1&!D&!C1&C&!B1&B&A1&A|F&E&D1&!D&!C1&C&!B1&B&A1&A|F&!E&D1&!D&!C1&C&!B1&B&A1&A|F&!E&D1&D&!C1&C&!B1&B&A1&A|F&E&D1&D&!C1&C&!B1&B&A1&A|F&E&!D1&D&!C1&C&!B1&B&A1&A|F&!E&!D1&D&!C1&C&!B1&B&A1&A|F&!E&!D1&D&C1&C&!B1&B&A1&A|F&E&!D1&D&C1&C&!B1&B&A1&A|F&E&D1&D&C1&C&!B1&B&A1&A|F&!E&D1&D&C1&C&!B1&B&A1&A|F&!E&D1&!D&C1&C&!B1&B&A1&A|F&E&D1&!D&C1&C&!B1&B&A1&A|F&E&!D1&!D&C1&C&!B1&B&A1&A|F&E&!D1&!D&C1&!C&!B1&B&A1&A|F&E&D1&!D&C1&!C&!B1&B&A1&A|F&!E&D1&!D&C1&!C&!B1&B&A1&A|F&!E&D1&D&C1&!C&!B1&B&A1&A|F&E&D1&D&C1&!C&!B1&B&A1&A|F&E&!D1&D&C1&!C&!B1&B&A1&A|F&!E&!D1&D&C1&!C&!B1&B&A1&A|F&!E&!D1&D&!C1&!C&!B1&B&A1&A|F&E&!D1&D&!C1&!C&!B1&B&A1&A|F&E&D1&D&!C1&!C&!B1&B&A1&A|F&!E&D1&D&!C1&!C&!B1&B&A1&A|F&!E&D1&!D&!C1&!C&!B1&B&A1&A|F&E&D1&!D&!C1&!C&!B1&B&A1&A|F&E&!D1&!D&!C1&!C&!B1&B&A1&A|F&E&!D1&!D&!C1&!C&!B1&B&!A1&A|F&E&D1&!D&!C1&!C&!B1&B&!A1&A|F&!E&D1&!D&!C1&!C&!B1&B&!A1&A|F&!E&D1&D&!C1&!C&!B1&B&!A1&A|F&E&D1&D&!C1&!C&!B1&B&!A1&A|F&E&!D1&D&!C1&!C&!B1&B&!A1&A|F&!E&!D1&D&!C1&!C&!B1&B&!A1&A|F&!E&!D1&D&C1&!C&!B1&B&!A1&A|F&E&!D1&D&C1&!C&!B1&B&!A1&A|F&E&D1&D&C1&!C&!B1&B&!A1&A|F&!E&D1&D&C1&!C&!B1&B&!A1&A|F&!E&D1&!D&C1&!C&!B1&B&!A1&A|F&E&D1&!D&C1&!C&!B1&B&!A1&A|F&E&!D1&!D&C1&!C&!B1&B&!A1&A|F&E&!D1&!D&C1&C&!B1&B&!A1&A|F&E&D1&!D&C1&C&!B1&B&!A1&A|F&!E&D1&!D&C1&C&!B1&B&!A1&A|F&!E&D1&D&C1&C&!B1&B&!A1&A|F&E&D1&D&C1&C&!B1&B&!A1&A|F&E&!D1&D&C1&C&!B1&B&!A1&A|F&!E&!D1&D&C1&C&!B1&B&!A1&A|F&!E&!D1&D&!C1&C&!B1&B&!A1&A|F&E&!D1&D&!C1&C&!B1&B&!A1&A|F&E&D1&D&!C1&C&!B1&B&!A1&A|F&!E&D1&D&!C1&C&!B1&B&!A1&A|F&!E&D1&!D&!C1&C&!B1&B&!A1&A|F&E&D1&!D&!C1&C&!B1&B&!A1&A|F&E&!D1&!D&!C1&C&!B1&B&!A1&A|F&E&!D1&!D&!C1&C&B1&B&!A1&A|F&E&D1&!D&!C1&C&B1&B&!A1&A|F&!E&D1&!D&!C1&C&B1&B&!A1&A|F&!E&D1&D&!C1&C&B1&B&!A1&A|F&E&D1&D&!C1&C&B1&B&!A1&A|F&E&!D1&D&!C1&C&B1&B&!A1&A|F&!E&!D1&D&!C1&C&B1&B&!A1&A|F&!E&!D1&D&C1&C&B1&B&!A1&A|F&E&!D1&D&C1&C&B1&B&!A1&A|F&E&D1&D&C1&C&B1&B&!A1&A|F&!E&D1&D&C1&C&B1&B&!A1&A|F&!E&D1&!D&C1&C&B1&B&!A1&A|F&E&D1&!D&C1&C&B1&B&!A1&A|F&E&!D1&!D&C1&C&B1&B&!A1&A|F&E&!D1&!D&C1&!C&B1&B&!A1&A|F&E&D1&!D&C1&!C&B1&B&!A1&A|F&!E&D1&!D&C1&!C&B1&B&!A1&A|F&!E&D1&D&C1&!C&B1&B&!A1&A|F&E&D1&D&C1&!C&B1&B&!A1&A|F&E&!D1&D&C1&!C&B1&B&!A1&A|F&!E&!D1&D&C1&!C&B1&B&!A1&A|F&!E&!D1&D&!C1&!C&B1&B&!A1&A|F&E&!D1&D&!C1&!C&B1&B&!A1&A|F&E&D1&D&!C1&!C&B1&B&!A1&A|F&!E&D1&D&!C1&!C&B1&B&!A1&A|F&!E&D1&!D&!C1&!C&B1&B&!A1&A|F&E&D1&!D&!C1&!C&B1&B&!A1&A|F&E&!D1&!D&!C1&!C&B1&B&!A1&A|F&E&!D1&!D&!C1&!C&B1&!B&!A1&A|F&E&D1&!D&!C1&!C&B1&!B&!A1&A|F&!E&D1&!D&!C1&!C&B1&!B&!A1&A|F&!E&D1&D&!C1&!C&B1&!B&!A1&A|F&E&D1&D&!C1&!C&B1&!B&!A1&A|F&E&!D1&D&!C1&!C&B1&!B&!A1&A|F&!E&!D1&D&!C1&!C&B1&!B&!A1&A|F&!E&!D1&D&C1&!C&B1&!B&!A1&A|F&E&!D1&D&C1&!C&B1&!B&!A1&A|F&E&D1&D&C1&!C&B1&!B&!A1&A|F&!E&D1&D&C1&!C&B1&!B&!A1&A|F&!E&D1&!D&C1&!C&B1&!B&!A1&A|F&E&D1&!D&C1&!C&B1&!B&!A1&A|F&E&!D1&!D&C1&!C&B1&!B&!A1&A|F&E&!D1&!D&C1&C&B1&!B&!A1&A|F&E&D1&!D&C1&C&B1&!B&!A1&A|F&!E&D1&!D&C1&C&B1&!B&!A1&A|F&!E&D1&D&C1&C&B1&!B&!A1&A|F&E&D1&D&C1&C&B1&!B&!A1&A|F&E&!D1&D&C1&C&B1&!B&!A1&A|F&!E&!D1&D&C1&C&B1&!B&!A1&A|F&!E&!D1&D&!C1&C&B1&!B&!A1&A|F&E&!D1&D&!C1&C&B1&!B&!A1&A|F&E&D1&D&!C1&C&B1&!B&!A1&A|F&!E&D1&D&!C1&C&B1&!B&!A1&A|F&!E&D1&!D&!C1&C&B1&!B&!A1&A|F&E&D1&!D&!C1&C&B1&!B&!A1&A|F&E&!D1&!D&!C1&C&B1&!B&!A1&A|F&E&!D1&!D&!C1&C&!B1&!B&!A1&A|F&E&D1&!D&!C1&C&!B1&!B&!A1&A|F&E&D1&D&!C1&C&!B1&!B&!A1&A|F&E&!D1&D&!C1&C&!B1&!B&!A1&A|F&!E&!D1&D&C1&C&!B1&!B&!A1&A|F&E&!D1&D&C1&C&!B1&!B&!A1&A|F&E&D1&D&C1&C&!B1&!B&!A1&A|F&!E&D1&D&C1&C&!B1&!B&!A1&A|F&!E&D1&!D&C1&C&!B1&!B&!A1&A|F&E&D1&!D&C1&C&!B1&!B&!A1&A|F&E&!D1&!D&C1&C&!B1&!B&!A1&A|F&E&!D1&!D&C1&!C&!B1&!B&!A1&A|F&E&D1&!D&C1&!C&!B1&!B&!A1&A|F&E&D1&D&C1&!C&!B1&!B&!A1&A|F&E&!D1&D&C1&!C&!B1&!B&!A1&A|F&E&!D1&D&!C1&!C&!B1&!B&!A1&A|F&E&D1&D&!C1&!C&!B1&!B&!A1&A|F&E&D1&!D&!C1&!C&!B1&!B&!A1&A|F&E&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOOAOAI222211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOI212 -l OAAOI212 -i C1 C B A1 A -o Y -f Y=(!C1&!C&!B&!A1&!A|C1&!C&!B&!A1&!A|!C1&C&!B&!A1&!A|!C1&C&B&!A1&!A|C1&!C&B&!A1&!A|!C1&!C&B&!A1&!A|!C1&C&!B&A1&!A|C1&!C&!B&A1&!A|!C1&!C&!B&A1&!A|!C1&!C&!B&A1&A|C1&!C&!B&A1&A|!C1&C&!B&A1&A|!C1&C&!B&!A1&A|C1&!C&!B&!A1&A|!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOI212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAAOI2132 -l OAAAOI2132 -i D1 D C2 C1 C B A1 A -o Y -f Y=(!D1&!D&!C2&!C1&!C&!B&!A1&!A|D1&!D&!C2&!C1&!C&!B&!A1&!A|!D1&D&!C2&!C1&!C&!B&!A1&!A|!D1&D&C2&!C1&!C&!B&!A1&!A|D1&!D&C2&!C1&!C&!B&!A1&!A|!D1&!D&C2&!C1&!C&!B&!A1&!A|!D1&!D&C2&C1&!C&!B&!A1&!A|D1&!D&C2&C1&!C&!B&!A1&!A|!D1&D&C2&C1&!C&!B&!A1&!A|!D1&D&!C2&C1&!C&!B&!A1&!A|D1&!D&!C2&C1&!C&!B&!A1&!A|!D1&!D&!C2&C1&!C&!B&!A1&!A|!D1&!D&!C2&C1&C&!B&!A1&!A|D1&!D&!C2&C1&C&!B&!A1&!A|!D1&D&!C2&C1&C&!B&!A1&!A|!D1&!D&C2&!C1&C&!B&!A1&!A|D1&!D&C2&!C1&C&!B&!A1&!A|!D1&D&C2&!C1&C&!B&!A1&!A|!D1&D&!C2&!C1&C&!B&!A1&!A|D1&!D&!C2&!C1&C&!B&!A1&!A|!D1&!D&!C2&!C1&C&!B&!A1&!A|!D1&!D&!C2&!C1&C&B&!A1&!A|D1&!D&!C2&!C1&C&B&!A1&!A|!D1&D&!C2&!C1&C&B&!A1&!A|!D1&D&C2&!C1&C&B&!A1&!A|D1&!D&C2&!C1&C&B&!A1&!A|!D1&!D&C2&!C1&C&B&!A1&!A|!D1&D&!C2&C1&C&B&!A1&!A|D1&!D&!C2&C1&C&B&!A1&!A|!D1&!D&!C2&C1&C&B&!A1&!A|!D1&!D&!C2&C1&!C&B&!A1&!A|D1&!D&!C2&C1&!C&B&!A1&!A|!D1&D&!C2&C1&!C&B&!A1&!A|!D1&D&C2&C1&!C&B&!A1&!A|D1&!D&C2&C1&!C&B&!A1&!A|!D1&!D&C2&C1&!C&B&!A1&!A|!D1&!D&C2&!C1&!C&B&!A1&!A|D1&!D&C2&!C1&!C&B&!A1&!A|!D1&D&C2&!C1&!C&B&!A1&!A|!D1&D&!C2&!C1&!C&B&!A1&!A|D1&!D&!C2&!C1&!C&B&!A1&!A|!D1&!D&!C2&!C1&!C&B&!A1&!A|!D1&!D&!C2&!C1&C&!B&A1&!A|D1&!D&!C2&!C1&C&!B&A1&!A|!D1&D&!C2&!C1&C&!B&A1&!A|!D1&D&C2&!C1&C&!B&A1&!A|D1&!D&C2&!C1&C&!B&A1&!A|!D1&!D&C2&!C1&C&!B&A1&!A|!D1&D&!C2&C1&C&!B&A1&!A|D1&!D&!C2&C1&C&!B&A1&!A|!D1&!D&!C2&C1&C&!B&A1&!A|!D1&!D&!C2&C1&!C&!B&A1&!A|D1&!D&!C2&C1&!C&!B&A1&!A|!D1&D&!C2&C1&!C&!B&A1&!A|!D1&D&C2&C1&!C&!B&A1&!A|D1&!D&C2&C1&!C&!B&A1&!A|!D1&!D&C2&C1&!C&!B&A1&!A|!D1&!D&C2&!C1&!C&!B&A1&!A|D1&!D&C2&!C1&!C&!B&A1&!A|!D1&D&C2&!C1&!C&!B&A1&!A|!D1&D&!C2&!C1&!C&!B&A1&!A|D1&!D&!C2&!C1&!C&!B&A1&!A|!D1&!D&!C2&!C1&!C&!B&A1&!A|!D1&!D&!C2&!C1&!C&!B&A1&A|D1&!D&!C2&!C1&!C&!B&A1&A|!D1&D&!C2&!C1&!C&!B&A1&A|!D1&D&C2&!C1&!C&!B&A1&A|D1&!D&C2&!C1&!C&!B&A1&A|!D1&!D&C2&!C1&!C&!B&A1&A|!D1&!D&C2&C1&!C&!B&A1&A|D1&!D&C2&C1&!C&!B&A1&A|!D1&D&C2&C1&!C&!B&A1&A|!D1&D&!C2&C1&!C&!B&A1&A|D1&!D&!C2&C1&!C&!B&A1&A|!D1&!D&!C2&C1&!C&!B&A1&A|!D1&!D&!C2&C1&C&!B&A1&A|D1&!D&!C2&C1&C&!B&A1&A|!D1&D&!C2&C1&C&!B&A1&A|!D1&!D&C2&!C1&C&!B&A1&A|D1&!D&C2&!C1&C&!B&A1&A|!D1&D&C2&!C1&C&!B&A1&A|!D1&D&!C2&!C1&C&!B&A1&A|D1&!D&!C2&!C1&C&!B&A1&A|!D1&!D&!C2&!C1&C&!B&A1&A|!D1&!D&!C2&!C1&C&!B&!A1&A|D1&!D&!C2&!C1&C&!B&!A1&A|!D1&D&!C2&!C1&C&!B&!A1&A|!D1&D&C2&!C1&C&!B&!A1&A|D1&!D&C2&!C1&C&!B&!A1&A|!D1&!D&C2&!C1&C&!B&!A1&A|!D1&D&!C2&C1&C&!B&!A1&A|D1&!D&!C2&C1&C&!B&!A1&A|!D1&!D&!C2&C1&C&!B&!A1&A|!D1&!D&!C2&C1&!C&!B&!A1&A|D1&!D&!C2&C1&!C&!B&!A1&A|!D1&D&!C2&C1&!C&!B&!A1&A|!D1&D&C2&C1&!C&!B&!A1&A|D1&!D&C2&C1&!C&!B&!A1&A|!D1&!D&C2&C1&!C&!B&!A1&A|!D1&!D&C2&!C1&!C&!B&!A1&A|D1&!D&C2&!C1&!C&!B&!A1&A|!D1&D&C2&!C1&!C&!B&!A1&A|!D1&D&!C2&!C1&!C&!B&!A1&A|D1&!D&!C2&!C1&!C&!B&!A1&A|!D1&!D&!C2&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAAOI2132.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAAOI2222 -l OOAAAOI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B1&!B&!A1&!A|D1&!D&!C1&!C&!B1&!B&!A1&!A|!D1&D&!C1&!C&!B1&!B&!A1&!A|!D1&D&C1&!C&!B1&!B&!A1&!A|D1&!D&C1&!C&!B1&!B&!A1&!A|!D1&!D&C1&!C&!B1&!B&!A1&!A|!D1&D&!C1&C&!B1&!B&!A1&!A|D1&!D&!C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&B1&!B&!A1&!A|D1&!D&!C1&C&B1&!B&!A1&!A|!D1&D&!C1&C&B1&!B&!A1&!A|!D1&!D&C1&!C&B1&!B&!A1&!A|D1&!D&C1&!C&B1&!B&!A1&!A|!D1&D&C1&!C&B1&!B&!A1&!A|!D1&D&!C1&!C&B1&!B&!A1&!A|D1&!D&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&B&!A1&!A|D1&!D&!C1&!C&B1&B&!A1&!A|!D1&D&!C1&!C&B1&B&!A1&!A|!D1&D&C1&!C&B1&B&!A1&!A|D1&!D&C1&!C&B1&B&!A1&!A|!D1&!D&C1&!C&B1&B&!A1&!A|!D1&D&!C1&C&B1&B&!A1&!A|D1&!D&!C1&C&B1&B&!A1&!A|!D1&!D&!C1&C&B1&B&!A1&!A|!D1&!D&!C1&C&!B1&B&!A1&!A|D1&!D&!C1&C&!B1&B&!A1&!A|!D1&D&!C1&C&!B1&B&!A1&!A|!D1&!D&C1&!C&!B1&B&!A1&!A|D1&!D&C1&!C&!B1&B&!A1&!A|!D1&D&C1&!C&!B1&B&!A1&!A|!D1&D&!C1&!C&!B1&B&!A1&!A|D1&!D&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&C&!B1&!B&A1&!A|D1&!D&!C1&C&!B1&!B&A1&!A|!D1&D&!C1&C&!B1&!B&A1&!A|!D1&!D&C1&!C&!B1&!B&A1&!A|D1&!D&C1&!C&!B1&!B&A1&!A|!D1&D&C1&!C&!B1&!B&A1&!A|!D1&D&!C1&!C&!B1&!B&A1&!A|D1&!D&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&A|D1&!D&!C1&!C&!B1&!B&A1&A|!D1&D&!C1&!C&!B1&!B&A1&A|!D1&D&C1&!C&!B1&!B&A1&A|D1&!D&C1&!C&!B1&!B&A1&A|!D1&!D&C1&!C&!B1&!B&A1&A|!D1&D&!C1&C&!B1&!B&A1&A|D1&!D&!C1&C&!B1&!B&A1&A|!D1&!D&!C1&C&!B1&!B&A1&A|!D1&!D&!C1&C&!B1&!B&!A1&A|D1&!D&!C1&C&!B1&!B&!A1&A|!D1&D&!C1&C&!B1&!B&!A1&A|!D1&!D&C1&!C&!B1&!B&!A1&A|D1&!D&C1&!C&!B1&!B&!A1&A|!D1&D&C1&!C&!B1&!B&!A1&A|!D1&D&!C1&!C&!B1&!B&!A1&A|D1&!D&!C1&!C&!B1&!B&!A1&A|!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAAOI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOI322 -l OAAOI322 -i C1 C B1 B A2 A1 A -o Y -f Y=!(C1&C&!B1&!B&!A2&!A1&!A|C1&C&B1&!B&!A2&!A1&!A|C1&C&B1&B&!A2&!A1&!A|C1&C&!B1&B&!A2&!A1&!A|C1&C&!B1&B&A2&!A1&!A|!C1&C&B1&B&A2&!A1&!A|C1&C&B1&B&A2&!A1&!A|C1&!C&B1&B&A2&!A1&!A|!C1&!C&B1&B&A2&!A1&!A|C1&C&B1&!B&A2&!A1&!A|C1&C&!B1&!B&A2&!A1&!A|C1&C&!B1&!B&A2&A1&!A|C1&C&B1&!B&A2&A1&!A|!C1&!C&B1&B&A2&A1&!A|C1&!C&B1&B&A2&A1&!A|C1&C&B1&B&A2&A1&!A|!C1&C&B1&B&A2&A1&!A|C1&C&!B1&B&A2&A1&!A|C1&C&!B1&B&!A2&A1&!A|!C1&C&B1&B&!A2&A1&!A|C1&C&B1&B&!A2&A1&!A|C1&!C&B1&B&!A2&A1&!A|!C1&!C&B1&B&!A2&A1&!A|C1&C&B1&!B&!A2&A1&!A|C1&C&!B1&!B&!A2&A1&!A|C1&C&!B1&!B&!A2&A1&A|C1&C&B1&!B&!A2&A1&A|!C1&!C&B1&B&!A2&A1&A|C1&!C&B1&B&!A2&A1&A|C1&C&B1&B&!A2&A1&A|!C1&C&B1&B&!A2&A1&A|C1&C&!B1&B&!A2&A1&A|C1&C&!B1&B&A2&A1&A|!C1&C&B1&B&A2&A1&A|C1&C&B1&B&A2&A1&A|C1&!C&B1&B&A2&A1&A|!C1&!C&B1&B&A2&A1&A|C1&C&B1&!B&A2&A1&A|C1&C&!B1&!B&A2&A1&A|C1&C&!B1&!B&A2&!A1&A|C1&C&B1&!B&A2&!A1&A|!C1&!C&B1&B&A2&!A1&A|C1&!C&B1&B&A2&!A1&A|C1&C&B1&B&A2&!A1&A|!C1&C&B1&B&A2&!A1&A|C1&C&!B1&B&A2&!A1&A|C1&C&!B1&B&!A2&!A1&A|!C1&C&B1&B&!A2&!A1&A|C1&C&B1&B&!A2&!A1&A|C1&!C&B1&B&!A2&!A1&A|!C1&!C&B1&B&!A2&!A1&A|C1&C&B1&!B&!A2&!A1&A|C1&C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOI322.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOOAAOI22222 -l AAAOOAAOI22222 -i E1 E D1 D C1 C B1 B A1 A -o Y -f Y=(!E1&!E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&D1&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D1&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&E&D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D1&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&!D1&D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D1&D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D1&D&C1&!C&!B1&!B&!A1&!A|!E1&E&D1&D&C1&!C&!B1&!B&!A1&!A|E1&!E&D1&D&C1&!C&!B1&!B&!A1&!A|!E1&!E&D1&D&C1&!C&!B1&!B&!A1&!A|!E1&!E&D1&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&E&D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D1&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&!D1&!D&C1&C&!B1&!B&!A1&!A|!E1&E&!D1&!D&C1&C&!B1&!B&!A1&!A|!E1&!E&!D1&D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D1&D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D1&D&!C1&C&!B1&!B&!A1&!A|!E1&E&D1&D&!C1&C&!B1&!B&!A1&!A|E1&!E&D1&D&!C1&C&!B1&!B&!A1&!A|!E1&!E&D1&D&!C1&C&!B1&!B&!A1&!A|!E1&!E&D1&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&E&D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D1&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&!C1&C&B1&!B&!A1&!A|E1&!E&!D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&!D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&D1&!D&!C1&C&B1&!B&!A1&!A|E1&!E&D1&!D&!C1&C&B1&!B&!A1&!A|!E1&!E&D1&!D&!C1&C&B1&!B&!A1&!A|!E1&!E&D1&D&!C1&C&B1&!B&!A1&!A|E1&!E&D1&D&!C1&C&B1&!B&!A1&!A|!E1&E&D1&D&!C1&C&B1&!B&!A1&!A|!E1&E&!D1&D&!C1&C&B1&!B&!A1&!A|E1&!E&!D1&D&!C1&C&B1&!B&!A1&!A|!E1&!E&!D1&D&!C1&C&B1&!B&!A1&!A|!E1&E&!D1&!D&C1&C&B1&!B&!A1&!A|E1&!E&!D1&!D&C1&C&B1&!B&!A1&!A|!E1&!E&!D1&!D&C1&C&B1&!B&!A1&!A|!E1&!E&!D1&!D&C1&!C&B1&!B&!A1&!A|E1&!E&!D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&!D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&D1&!D&C1&!C&B1&!B&!A1&!A|E1&!E&D1&!D&C1&!C&B1&!B&!A1&!A|!E1&!E&D1&!D&C1&!C&B1&!B&!A1&!A|!E1&!E&D1&D&C1&!C&B1&!B&!A1&!A|E1&!E&D1&D&C1&!C&B1&!B&!A1&!A|!E1&E&D1&D&C1&!C&B1&!B&!A1&!A|!E1&E&!D1&D&C1&!C&B1&!B&!A1&!A|E1&!E&!D1&D&C1&!C&B1&!B&!A1&!A|!E1&!E&!D1&D&C1&!C&B1&!B&!A1&!A|!E1&!E&!D1&D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D1&D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D1&D&!C1&!C&B1&!B&!A1&!A|!E1&E&D1&D&!C1&!C&B1&!B&!A1&!A|E1&!E&D1&D&!C1&!C&B1&!B&!A1&!A|!E1&!E&D1&D&!C1&!C&B1&!B&!A1&!A|!E1&!E&D1&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&E&D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D1&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&B1&B&!A1&!A|E1&!E&!D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&!D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&!D1&!D&C1&!C&B1&B&!A1&!A|E1&!E&!D1&!D&C1&!C&B1&B&!A1&!A|!E1&!E&!D1&!D&C1&!C&B1&B&!A1&!A|!E1&!E&!D1&!D&C1&C&B1&B&!A1&!A|E1&!E&!D1&!D&C1&C&B1&B&!A1&!A|!E1&E&!D1&!D&C1&C&B1&B&!A1&!A|!E1&E&!D1&!D&!C1&C&B1&B&!A1&!A|E1&!E&!D1&!D&!C1&C&B1&B&!A1&!A|!E1&!E&!D1&!D&!C1&C&B1&B&!A1&!A|!E1&!E&!D1&!D&!C1&C&!B1&B&!A1&!A|E1&!E&!D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&!D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&D1&!D&!C1&C&!B1&B&!A1&!A|E1&!E&D1&!D&!C1&C&!B1&B&!A1&!A|!E1&!E&D1&!D&!C1&C&!B1&B&!A1&!A|!E1&!E&D1&D&!C1&C&!B1&B&!A1&!A|E1&!E&D1&D&!C1&C&!B1&B&!A1&!A|!E1&E&D1&D&!C1&C&!B1&B&!A1&!A|!E1&E&!D1&D&!C1&C&!B1&B&!A1&!A|E1&!E&!D1&D&!C1&C&!B1&B&!A1&!A|!E1&!E&!D1&D&!C1&C&!B1&B&!A1&!A|!E1&E&!D1&!D&C1&C&!B1&B&!A1&!A|E1&!E&!D1&!D&C1&C&!B1&B&!A1&!A|!E1&!E&!D1&!D&C1&C&!B1&B&!A1&!A|!E1&!E&!D1&!D&C1&!C&!B1&B&!A1&!A|E1&!E&!D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&!D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&D1&!D&C1&!C&!B1&B&!A1&!A|E1&!E&D1&!D&C1&!C&!B1&B&!A1&!A|!E1&!E&D1&!D&C1&!C&!B1&B&!A1&!A|!E1&!E&D1&D&C1&!C&!B1&B&!A1&!A|E1&!E&D1&D&C1&!C&!B1&B&!A1&!A|!E1&E&D1&D&C1&!C&!B1&B&!A1&!A|!E1&E&!D1&D&C1&!C&!B1&B&!A1&!A|E1&!E&!D1&D&C1&!C&!B1&B&!A1&!A|!E1&!E&!D1&D&C1&!C&!B1&B&!A1&!A|!E1&!E&!D1&D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D1&D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D1&D&!C1&!C&!B1&B&!A1&!A|!E1&E&D1&D&!C1&!C&!B1&B&!A1&!A|E1&!E&D1&D&!C1&!C&!B1&B&!A1&!A|!E1&!E&D1&D&!C1&!C&!B1&B&!A1&!A|!E1&!E&D1&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&E&D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D1&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&!D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&!D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&D1&!D&!C1&!C&!B1&B&A1&!A|!E1&!E&D1&!D&!C1&!C&!B1&B&A1&!A|!E1&!E&D1&D&!C1&!C&!B1&B&A1&!A|E1&!E&D1&D&!C1&!C&!B1&B&A1&!A|!E1&E&D1&D&!C1&!C&!B1&B&A1&!A|!E1&E&!D1&D&!C1&!C&!B1&B&A1&!A|E1&!E&!D1&D&!C1&!C&!B1&B&A1&!A|!E1&!E&!D1&D&!C1&!C&!B1&B&A1&!A|!E1&!E&!D1&D&C1&!C&!B1&B&A1&!A|E1&!E&!D1&D&C1&!C&!B1&B&A1&!A|!E1&E&!D1&D&C1&!C&!B1&B&A1&!A|!E1&E&D1&D&C1&!C&!B1&B&A1&!A|E1&!E&D1&D&C1&!C&!B1&B&A1&!A|!E1&!E&D1&D&C1&!C&!B1&B&A1&!A|!E1&!E&D1&!D&C1&!C&!B1&B&A1&!A|E1&!E&D1&!D&C1&!C&!B1&B&A1&!A|!E1&E&D1&!D&C1&!C&!B1&B&A1&!A|!E1&E&!D1&!D&C1&!C&!B1&B&A1&!A|E1&!E&!D1&!D&C1&!C&!B1&B&A1&!A|!E1&!E&!D1&!D&C1&!C&!B1&B&A1&!A|!E1&!E&!D1&!D&C1&C&!B1&B&A1&!A|E1&!E&!D1&!D&C1&C&!B1&B&A1&!A|!E1&E&!D1&!D&C1&C&!B1&B&A1&!A|!E1&!E&!D1&D&!C1&C&!B1&B&A1&!A|E1&!E&!D1&D&!C1&C&!B1&B&A1&!A|!E1&E&!D1&D&!C1&C&!B1&B&A1&!A|!E1&E&D1&D&!C1&C&!B1&B&A1&!A|E1&!E&D1&D&!C1&C&!B1&B&A1&!A|!E1&!E&D1&D&!C1&C&!B1&B&A1&!A|!E1&!E&D1&!D&!C1&C&!B1&B&A1&!A|E1&!E&D1&!D&!C1&C&!B1&B&A1&!A|!E1&E&D1&!D&!C1&C&!B1&B&A1&!A|!E1&E&!D1&!D&!C1&C&!B1&B&A1&!A|E1&!E&!D1&!D&!C1&C&!B1&B&A1&!A|!E1&!E&!D1&!D&!C1&C&!B1&B&A1&!A|!E1&!E&!D1&!D&!C1&C&B1&B&A1&!A|E1&!E&!D1&!D&!C1&C&B1&B&A1&!A|!E1&E&!D1&!D&!C1&C&B1&B&A1&!A|!E1&E&!D1&!D&C1&C&B1&B&A1&!A|E1&!E&!D1&!D&C1&C&B1&B&A1&!A|!E1&!E&!D1&!D&C1&C&B1&B&A1&!A|!E1&!E&!D1&!D&C1&!C&B1&B&A1&!A|E1&!E&!D1&!D&C1&!C&B1&B&A1&!A|!E1&E&!D1&!D&C1&!C&B1&B&A1&!A|!E1&E&!D1&!D&!C1&!C&B1&B&A1&!A|E1&!E&!D1&!D&!C1&!C&B1&B&A1&!A|!E1&!E&!D1&!D&!C1&!C&B1&B&A1&!A|!E1&!E&!D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&!D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&!D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&D1&!D&!C1&!C&B1&!B&A1&!A|!E1&!E&D1&!D&!C1&!C&B1&!B&A1&!A|!E1&!E&D1&D&!C1&!C&B1&!B&A1&!A|E1&!E&D1&D&!C1&!C&B1&!B&A1&!A|!E1&E&D1&D&!C1&!C&B1&!B&A1&!A|!E1&E&!D1&D&!C1&!C&B1&!B&A1&!A|E1&!E&!D1&D&!C1&!C&B1&!B&A1&!A|!E1&!E&!D1&D&!C1&!C&B1&!B&A1&!A|!E1&!E&!D1&D&C1&!C&B1&!B&A1&!A|E1&!E&!D1&D&C1&!C&B1&!B&A1&!A|!E1&E&!D1&D&C1&!C&B1&!B&A1&!A|!E1&E&D1&D&C1&!C&B1&!B&A1&!A|E1&!E&D1&D&C1&!C&B1&!B&A1&!A|!E1&!E&D1&D&C1&!C&B1&!B&A1&!A|!E1&!E&D1&!D&C1&!C&B1&!B&A1&!A|E1&!E&D1&!D&C1&!C&B1&!B&A1&!A|!E1&E&D1&!D&C1&!C&B1&!B&A1&!A|!E1&E&!D1&!D&C1&!C&B1&!B&A1&!A|E1&!E&!D1&!D&C1&!C&B1&!B&A1&!A|!E1&!E&!D1&!D&C1&!C&B1&!B&A1&!A|!E1&!E&!D1&!D&C1&C&B1&!B&A1&!A|E1&!E&!D1&!D&C1&C&B1&!B&A1&!A|!E1&E&!D1&!D&C1&C&B1&!B&A1&!A|!E1&!E&!D1&D&!C1&C&B1&!B&A1&!A|E1&!E&!D1&D&!C1&C&B1&!B&A1&!A|!E1&E&!D1&D&!C1&C&B1&!B&A1&!A|!E1&E&D1&D&!C1&C&B1&!B&A1&!A|E1&!E&D1&D&!C1&C&B1&!B&A1&!A|!E1&!E&D1&D&!C1&C&B1&!B&A1&!A|!E1&!E&D1&!D&!C1&C&B1&!B&A1&!A|E1&!E&D1&!D&!C1&C&B1&!B&A1&!A|!E1&E&D1&!D&!C1&C&B1&!B&A1&!A|!E1&E&!D1&!D&!C1&C&B1&!B&A1&!A|E1&!E&!D1&!D&!C1&C&B1&!B&A1&!A|!E1&!E&!D1&!D&!C1&C&B1&!B&A1&!A|!E1&!E&!D1&!D&!C1&C&!B1&!B&A1&!A|E1&!E&!D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&!D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&D1&!D&!C1&C&!B1&!B&A1&!A|E1&!E&D1&!D&!C1&C&!B1&!B&A1&!A|!E1&!E&D1&!D&!C1&C&!B1&!B&A1&!A|!E1&!E&D1&D&!C1&C&!B1&!B&A1&!A|E1&!E&D1&D&!C1&C&!B1&!B&A1&!A|!E1&E&D1&D&!C1&C&!B1&!B&A1&!A|!E1&E&!D1&D&!C1&C&!B1&!B&A1&!A|E1&!E&!D1&D&!C1&C&!B1&!B&A1&!A|!E1&!E&!D1&D&!C1&C&!B1&!B&A1&!A|!E1&E&!D1&!D&C1&C&!B1&!B&A1&!A|E1&!E&!D1&!D&C1&C&!B1&!B&A1&!A|!E1&!E&!D1&!D&C1&C&!B1&!B&A1&!A|!E1&!E&!D1&!D&C1&!C&!B1&!B&A1&!A|E1&!E&!D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&!D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&D1&!D&C1&!C&!B1&!B&A1&!A|E1&!E&D1&!D&C1&!C&!B1&!B&A1&!A|!E1&!E&D1&!D&C1&!C&!B1&!B&A1&!A|!E1&!E&D1&D&C1&!C&!B1&!B&A1&!A|E1&!E&D1&D&C1&!C&!B1&!B&A1&!A|!E1&E&D1&D&C1&!C&!B1&!B&A1&!A|!E1&E&!D1&D&C1&!C&!B1&!B&A1&!A|E1&!E&!D1&D&C1&!C&!B1&!B&A1&!A|!E1&!E&!D1&D&C1&!C&!B1&!B&A1&!A|!E1&!E&!D1&D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D1&D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D1&D&!C1&!C&!B1&!B&A1&!A|!E1&E&D1&D&!C1&!C&!B1&!B&A1&!A|E1&!E&D1&D&!C1&!C&!B1&!B&A1&!A|!E1&!E&D1&D&!C1&!C&!B1&!B&A1&!A|!E1&!E&D1&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&E&D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D1&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D1&!D&!C1&!C&!B1&!B&A1&A|E1&!E&!D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&!D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&!D1&!D&C1&!C&!B1&!B&A1&A|E1&!E&!D1&!D&C1&!C&!B1&!B&A1&A|!E1&!E&!D1&!D&C1&!C&!B1&!B&A1&A|!E1&!E&!D1&!D&C1&C&!B1&!B&A1&A|E1&!E&!D1&!D&C1&C&!B1&!B&A1&A|!E1&E&!D1&!D&C1&C&!B1&!B&A1&A|!E1&E&!D1&!D&!C1&C&!B1&!B&A1&A|E1&!E&!D1&!D&!C1&C&!B1&!B&A1&A|!E1&!E&!D1&!D&!C1&C&!B1&!B&A1&A|!E1&!E&!D1&!D&!C1&C&B1&!B&A1&A|E1&!E&!D1&!D&!C1&C&B1&!B&A1&A|!E1&E&!D1&!D&!C1&C&B1&!B&A1&A|!E1&E&!D1&!D&C1&C&B1&!B&A1&A|E1&!E&!D1&!D&C1&C&B1&!B&A1&A|!E1&!E&!D1&!D&C1&C&B1&!B&A1&A|!E1&!E&!D1&!D&C1&!C&B1&!B&A1&A|E1&!E&!D1&!D&C1&!C&B1&!B&A1&A|!E1&E&!D1&!D&C1&!C&B1&!B&A1&A|!E1&E&!D1&!D&!C1&!C&B1&!B&A1&A|E1&!E&!D1&!D&!C1&!C&B1&!B&A1&A|!E1&!E&!D1&!D&!C1&!C&B1&!B&A1&A|!E1&!E&!D1&!D&!C1&!C&B1&B&A1&A|E1&!E&!D1&!D&!C1&!C&B1&B&A1&A|!E1&E&!D1&!D&!C1&!C&B1&B&A1&A|!E1&E&!D1&!D&C1&!C&B1&B&A1&A|E1&!E&!D1&!D&C1&!C&B1&B&A1&A|!E1&!E&!D1&!D&C1&!C&B1&B&A1&A|!E1&!E&!D1&!D&C1&C&B1&B&A1&A|E1&!E&!D1&!D&C1&C&B1&B&A1&A|!E1&E&!D1&!D&C1&C&B1&B&A1&A|!E1&E&!D1&!D&!C1&C&B1&B&A1&A|E1&!E&!D1&!D&!C1&C&B1&B&A1&A|!E1&!E&!D1&!D&!C1&C&B1&B&A1&A|!E1&!E&!D1&!D&!C1&C&!B1&B&A1&A|E1&!E&!D1&!D&!C1&C&!B1&B&A1&A|!E1&E&!D1&!D&!C1&C&!B1&B&A1&A|!E1&E&!D1&!D&C1&C&!B1&B&A1&A|E1&!E&!D1&!D&C1&C&!B1&B&A1&A|!E1&!E&!D1&!D&C1&C&!B1&B&A1&A|!E1&!E&!D1&!D&C1&!C&!B1&B&A1&A|E1&!E&!D1&!D&C1&!C&!B1&B&A1&A|!E1&E&!D1&!D&C1&!C&!B1&B&A1&A|!E1&E&!D1&!D&!C1&!C&!B1&B&A1&A|E1&!E&!D1&!D&!C1&!C&!B1&B&A1&A|!E1&!E&!D1&!D&!C1&!C&!B1&B&A1&A|!E1&!E&!D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&!D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&!D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&D1&!D&!C1&!C&!B1&B&!A1&A|!E1&!E&D1&!D&!C1&!C&!B1&B&!A1&A|!E1&!E&D1&D&!C1&!C&!B1&B&!A1&A|E1&!E&D1&D&!C1&!C&!B1&B&!A1&A|!E1&E&D1&D&!C1&!C&!B1&B&!A1&A|!E1&E&!D1&D&!C1&!C&!B1&B&!A1&A|E1&!E&!D1&D&!C1&!C&!B1&B&!A1&A|!E1&!E&!D1&D&!C1&!C&!B1&B&!A1&A|!E1&!E&!D1&D&C1&!C&!B1&B&!A1&A|E1&!E&!D1&D&C1&!C&!B1&B&!A1&A|!E1&E&!D1&D&C1&!C&!B1&B&!A1&A|!E1&E&D1&D&C1&!C&!B1&B&!A1&A|E1&!E&D1&D&C1&!C&!B1&B&!A1&A|!E1&!E&D1&D&C1&!C&!B1&B&!A1&A|!E1&!E&D1&!D&C1&!C&!B1&B&!A1&A|E1&!E&D1&!D&C1&!C&!B1&B&!A1&A|!E1&E&D1&!D&C1&!C&!B1&B&!A1&A|!E1&E&!D1&!D&C1&!C&!B1&B&!A1&A|E1&!E&!D1&!D&C1&!C&!B1&B&!A1&A|!E1&!E&!D1&!D&C1&!C&!B1&B&!A1&A|!E1&!E&!D1&!D&C1&C&!B1&B&!A1&A|E1&!E&!D1&!D&C1&C&!B1&B&!A1&A|!E1&E&!D1&!D&C1&C&!B1&B&!A1&A|!E1&!E&!D1&D&!C1&C&!B1&B&!A1&A|E1&!E&!D1&D&!C1&C&!B1&B&!A1&A|!E1&E&!D1&D&!C1&C&!B1&B&!A1&A|!E1&E&D1&D&!C1&C&!B1&B&!A1&A|E1&!E&D1&D&!C1&C&!B1&B&!A1&A|!E1&!E&D1&D&!C1&C&!B1&B&!A1&A|!E1&!E&D1&!D&!C1&C&!B1&B&!A1&A|E1&!E&D1&!D&!C1&C&!B1&B&!A1&A|!E1&E&D1&!D&!C1&C&!B1&B&!A1&A|!E1&E&!D1&!D&!C1&C&!B1&B&!A1&A|E1&!E&!D1&!D&!C1&C&!B1&B&!A1&A|!E1&!E&!D1&!D&!C1&C&!B1&B&!A1&A|!E1&!E&!D1&!D&!C1&C&B1&B&!A1&A|E1&!E&!D1&!D&!C1&C&B1&B&!A1&A|!E1&E&!D1&!D&!C1&C&B1&B&!A1&A|!E1&E&!D1&!D&C1&C&B1&B&!A1&A|E1&!E&!D1&!D&C1&C&B1&B&!A1&A|!E1&!E&!D1&!D&C1&C&B1&B&!A1&A|!E1&!E&!D1&!D&C1&!C&B1&B&!A1&A|E1&!E&!D1&!D&C1&!C&B1&B&!A1&A|!E1&E&!D1&!D&C1&!C&B1&B&!A1&A|!E1&E&!D1&!D&!C1&!C&B1&B&!A1&A|E1&!E&!D1&!D&!C1&!C&B1&B&!A1&A|!E1&!E&!D1&!D&!C1&!C&B1&B&!A1&A|!E1&!E&!D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&!D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&!D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&D1&!D&!C1&!C&B1&!B&!A1&A|!E1&!E&D1&!D&!C1&!C&B1&!B&!A1&A|!E1&!E&D1&D&!C1&!C&B1&!B&!A1&A|E1&!E&D1&D&!C1&!C&B1&!B&!A1&A|!E1&E&D1&D&!C1&!C&B1&!B&!A1&A|!E1&E&!D1&D&!C1&!C&B1&!B&!A1&A|E1&!E&!D1&D&!C1&!C&B1&!B&!A1&A|!E1&!E&!D1&D&!C1&!C&B1&!B&!A1&A|!E1&!E&!D1&D&C1&!C&B1&!B&!A1&A|E1&!E&!D1&D&C1&!C&B1&!B&!A1&A|!E1&E&!D1&D&C1&!C&B1&!B&!A1&A|!E1&E&D1&D&C1&!C&B1&!B&!A1&A|E1&!E&D1&D&C1&!C&B1&!B&!A1&A|!E1&!E&D1&D&C1&!C&B1&!B&!A1&A|!E1&!E&D1&!D&C1&!C&B1&!B&!A1&A|E1&!E&D1&!D&C1&!C&B1&!B&!A1&A|!E1&E&D1&!D&C1&!C&B1&!B&!A1&A|!E1&E&!D1&!D&C1&!C&B1&!B&!A1&A|E1&!E&!D1&!D&C1&!C&B1&!B&!A1&A|!E1&!E&!D1&!D&C1&!C&B1&!B&!A1&A|!E1&!E&!D1&!D&C1&C&B1&!B&!A1&A|E1&!E&!D1&!D&C1&C&B1&!B&!A1&A|!E1&E&!D1&!D&C1&C&B1&!B&!A1&A|!E1&!E&!D1&D&!C1&C&B1&!B&!A1&A|E1&!E&!D1&D&!C1&C&B1&!B&!A1&A|!E1&E&!D1&D&!C1&C&B1&!B&!A1&A|!E1&E&D1&D&!C1&C&B1&!B&!A1&A|E1&!E&D1&D&!C1&C&B1&!B&!A1&A|!E1&!E&D1&D&!C1&C&B1&!B&!A1&A|!E1&!E&D1&!D&!C1&C&B1&!B&!A1&A|E1&!E&D1&!D&!C1&C&B1&!B&!A1&A|!E1&E&D1&!D&!C1&C&B1&!B&!A1&A|!E1&E&!D1&!D&!C1&C&B1&!B&!A1&A|E1&!E&!D1&!D&!C1&C&B1&!B&!A1&A|!E1&!E&!D1&!D&!C1&C&B1&!B&!A1&A|!E1&!E&!D1&!D&!C1&C&!B1&!B&!A1&A|E1&!E&!D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&!D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&D1&!D&!C1&C&!B1&!B&!A1&A|E1&!E&D1&!D&!C1&C&!B1&!B&!A1&A|!E1&!E&D1&!D&!C1&C&!B1&!B&!A1&A|!E1&!E&D1&D&!C1&C&!B1&!B&!A1&A|E1&!E&D1&D&!C1&C&!B1&!B&!A1&A|!E1&E&D1&D&!C1&C&!B1&!B&!A1&A|!E1&E&!D1&D&!C1&C&!B1&!B&!A1&A|E1&!E&!D1&D&!C1&C&!B1&!B&!A1&A|!E1&!E&!D1&D&!C1&C&!B1&!B&!A1&A|!E1&E&!D1&!D&C1&C&!B1&!B&!A1&A|E1&!E&!D1&!D&C1&C&!B1&!B&!A1&A|!E1&!E&!D1&!D&C1&C&!B1&!B&!A1&A|!E1&!E&!D1&!D&C1&!C&!B1&!B&!A1&A|E1&!E&!D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&!D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&D1&!D&C1&!C&!B1&!B&!A1&A|E1&!E&D1&!D&C1&!C&!B1&!B&!A1&A|!E1&!E&D1&!D&C1&!C&!B1&!B&!A1&A|!E1&!E&D1&D&C1&!C&!B1&!B&!A1&A|E1&!E&D1&D&C1&!C&!B1&!B&!A1&A|!E1&E&D1&D&C1&!C&!B1&!B&!A1&A|!E1&E&!D1&D&C1&!C&!B1&!B&!A1&A|E1&!E&!D1&D&C1&!C&!B1&!B&!A1&A|!E1&!E&!D1&D&C1&!C&!B1&!B&!A1&A|!E1&!E&!D1&D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D1&D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D1&D&!C1&!C&!B1&!B&!A1&A|!E1&E&D1&D&!C1&!C&!B1&!B&!A1&A|E1&!E&D1&D&!C1&!C&!B1&!B&!A1&A|!E1&!E&D1&D&!C1&!C&!B1&!B&!A1&A|!E1&!E&D1&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&E&D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D1&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&!E&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOOAAOI22222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOOAI21232 -l AOOAAOOAI21232 -i E1 E D2 D1 D C1 C B A1 A -o Y -f Y=!(!E1&E&D2&D1&D&!C1&!C&!B&!A1&!A|E1&E&D2&D1&D&!C1&!C&!B&!A1&!A|E1&!E&D2&D1&D&!C1&!C&!B&!A1&!A|E1&!E&D2&D1&D&C1&!C&!B&!A1&!A|E1&E&D2&D1&D&C1&!C&!B&!A1&!A|!E1&E&D2&D1&D&C1&!C&!B&!A1&!A|!E1&E&D2&D1&D&C1&C&!B&!A1&!A|E1&E&D2&D1&D&C1&C&!B&!A1&!A|E1&!E&D2&D1&D&C1&C&!B&!A1&!A|E1&!E&D2&D1&D&!C1&C&!B&!A1&!A|E1&E&D2&D1&D&!C1&C&!B&!A1&!A|!E1&E&D2&D1&D&!C1&C&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&C&B&!A1&!A|E1&E&!D2&!D1&!D&!C1&C&B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&C&B&!A1&!A|!E1&E&D2&!D1&!D&!C1&C&B&!A1&!A|E1&E&D2&!D1&!D&!C1&C&B&!A1&!A|E1&!E&D2&!D1&!D&!C1&C&B&!A1&!A|E1&!E&D2&D1&!D&!C1&C&B&!A1&!A|E1&E&D2&D1&!D&!C1&C&B&!A1&!A|!E1&E&D2&D1&!D&!C1&C&B&!A1&!A|!E1&E&!D2&D1&!D&!C1&C&B&!A1&!A|E1&E&!D2&D1&!D&!C1&C&B&!A1&!A|E1&!E&!D2&D1&!D&!C1&C&B&!A1&!A|E1&!E&!D2&D1&D&!C1&C&B&!A1&!A|E1&E&!D2&D1&D&!C1&C&B&!A1&!A|!E1&E&!D2&D1&D&!C1&C&B&!A1&!A|!E1&E&D2&D1&D&!C1&C&B&!A1&!A|E1&E&D2&D1&D&!C1&C&B&!A1&!A|E1&!E&D2&D1&D&!C1&C&B&!A1&!A|E1&!E&D2&!D1&D&!C1&C&B&!A1&!A|E1&E&D2&!D1&D&!C1&C&B&!A1&!A|!E1&E&D2&!D1&D&!C1&C&B&!A1&!A|!E1&E&!D2&!D1&D&!C1&C&B&!A1&!A|E1&E&!D2&!D1&D&!C1&C&B&!A1&!A|E1&!E&!D2&!D1&D&!C1&C&B&!A1&!A|E1&!E&!D2&!D1&D&C1&C&B&!A1&!A|E1&E&!D2&!D1&D&C1&C&B&!A1&!A|!E1&E&!D2&!D1&D&C1&C&B&!A1&!A|!E1&E&D2&!D1&D&C1&C&B&!A1&!A|E1&E&D2&!D1&D&C1&C&B&!A1&!A|E1&!E&D2&!D1&D&C1&C&B&!A1&!A|E1&!E&D2&D1&D&C1&C&B&!A1&!A|E1&E&D2&D1&D&C1&C&B&!A1&!A|!E1&E&D2&D1&D&C1&C&B&!A1&!A|!E1&E&!D2&D1&D&C1&C&B&!A1&!A|E1&E&!D2&D1&D&C1&C&B&!A1&!A|E1&!E&!D2&D1&D&C1&C&B&!A1&!A|E1&!E&!D2&D1&!D&C1&C&B&!A1&!A|E1&E&!D2&D1&!D&C1&C&B&!A1&!A|!E1&E&!D2&D1&!D&C1&C&B&!A1&!A|!E1&E&D2&D1&!D&C1&C&B&!A1&!A|E1&E&D2&D1&!D&C1&C&B&!A1&!A|E1&!E&D2&D1&!D&C1&C&B&!A1&!A|E1&!E&D2&!D1&!D&C1&C&B&!A1&!A|E1&E&D2&!D1&!D&C1&C&B&!A1&!A|!E1&E&D2&!D1&!D&C1&C&B&!A1&!A|!E1&E&!D2&!D1&!D&C1&C&B&!A1&!A|E1&E&!D2&!D1&!D&C1&C&B&!A1&!A|E1&!E&!D2&!D1&!D&C1&C&B&!A1&!A|E1&!E&!D2&!D1&!D&C1&!C&B&!A1&!A|E1&E&!D2&!D1&!D&C1&!C&B&!A1&!A|!E1&E&!D2&!D1&!D&C1&!C&B&!A1&!A|!E1&E&D2&!D1&!D&C1&!C&B&!A1&!A|E1&E&D2&!D1&!D&C1&!C&B&!A1&!A|E1&!E&D2&!D1&!D&C1&!C&B&!A1&!A|E1&!E&D2&D1&!D&C1&!C&B&!A1&!A|E1&E&D2&D1&!D&C1&!C&B&!A1&!A|!E1&E&D2&D1&!D&C1&!C&B&!A1&!A|!E1&E&!D2&D1&!D&C1&!C&B&!A1&!A|E1&E&!D2&D1&!D&C1&!C&B&!A1&!A|E1&!E&!D2&D1&!D&C1&!C&B&!A1&!A|E1&!E&!D2&D1&D&C1&!C&B&!A1&!A|E1&E&!D2&D1&D&C1&!C&B&!A1&!A|!E1&E&!D2&D1&D&C1&!C&B&!A1&!A|!E1&E&D2&D1&D&C1&!C&B&!A1&!A|E1&E&D2&D1&D&C1&!C&B&!A1&!A|E1&!E&D2&D1&D&C1&!C&B&!A1&!A|E1&!E&D2&!D1&D&C1&!C&B&!A1&!A|E1&E&D2&!D1&D&C1&!C&B&!A1&!A|!E1&E&D2&!D1&D&C1&!C&B&!A1&!A|!E1&E&!D2&!D1&D&C1&!C&B&!A1&!A|E1&E&!D2&!D1&D&C1&!C&B&!A1&!A|E1&!E&!D2&!D1&D&C1&!C&B&!A1&!A|E1&!E&D2&D1&D&!C1&!C&B&!A1&!A|E1&E&D2&D1&D&!C1&!C&B&!A1&!A|!E1&E&D2&D1&D&!C1&!C&B&!A1&!A|!E1&E&D2&D1&D&!C1&!C&B&A1&!A|E1&E&D2&D1&D&!C1&!C&B&A1&!A|E1&!E&D2&D1&D&!C1&!C&B&A1&!A|E1&!E&!D2&!D1&D&C1&!C&B&A1&!A|E1&E&!D2&!D1&D&C1&!C&B&A1&!A|!E1&E&!D2&!D1&D&C1&!C&B&A1&!A|!E1&E&D2&!D1&D&C1&!C&B&A1&!A|E1&E&D2&!D1&D&C1&!C&B&A1&!A|E1&!E&D2&!D1&D&C1&!C&B&A1&!A|E1&!E&D2&D1&D&C1&!C&B&A1&!A|E1&E&D2&D1&D&C1&!C&B&A1&!A|!E1&E&D2&D1&D&C1&!C&B&A1&!A|!E1&E&!D2&D1&D&C1&!C&B&A1&!A|E1&E&!D2&D1&D&C1&!C&B&A1&!A|E1&!E&!D2&D1&D&C1&!C&B&A1&!A|E1&!E&!D2&D1&!D&C1&!C&B&A1&!A|E1&E&!D2&D1&!D&C1&!C&B&A1&!A|!E1&E&!D2&D1&!D&C1&!C&B&A1&!A|!E1&E&D2&D1&!D&C1&!C&B&A1&!A|E1&E&D2&D1&!D&C1&!C&B&A1&!A|E1&!E&D2&D1&!D&C1&!C&B&A1&!A|E1&!E&D2&!D1&!D&C1&!C&B&A1&!A|E1&E&D2&!D1&!D&C1&!C&B&A1&!A|!E1&E&D2&!D1&!D&C1&!C&B&A1&!A|!E1&E&!D2&!D1&!D&C1&!C&B&A1&!A|E1&E&!D2&!D1&!D&C1&!C&B&A1&!A|E1&!E&!D2&!D1&!D&C1&!C&B&A1&!A|E1&!E&!D2&!D1&!D&C1&C&B&A1&!A|E1&E&!D2&!D1&!D&C1&C&B&A1&!A|!E1&E&!D2&!D1&!D&C1&C&B&A1&!A|!E1&E&D2&!D1&!D&C1&C&B&A1&!A|E1&E&D2&!D1&!D&C1&C&B&A1&!A|E1&!E&D2&!D1&!D&C1&C&B&A1&!A|E1&!E&D2&D1&!D&C1&C&B&A1&!A|E1&E&D2&D1&!D&C1&C&B&A1&!A|!E1&E&D2&D1&!D&C1&C&B&A1&!A|!E1&E&!D2&D1&!D&C1&C&B&A1&!A|E1&E&!D2&D1&!D&C1&C&B&A1&!A|E1&!E&!D2&D1&!D&C1&C&B&A1&!A|E1&!E&!D2&D1&D&C1&C&B&A1&!A|E1&E&!D2&D1&D&C1&C&B&A1&!A|!E1&E&!D2&D1&D&C1&C&B&A1&!A|!E1&E&D2&D1&D&C1&C&B&A1&!A|E1&E&D2&D1&D&C1&C&B&A1&!A|E1&!E&D2&D1&D&C1&C&B&A1&!A|E1&!E&D2&!D1&D&C1&C&B&A1&!A|E1&E&D2&!D1&D&C1&C&B&A1&!A|!E1&E&D2&!D1&D&C1&C&B&A1&!A|!E1&E&!D2&!D1&D&C1&C&B&A1&!A|E1&E&!D2&!D1&D&C1&C&B&A1&!A|E1&!E&!D2&!D1&D&C1&C&B&A1&!A|E1&!E&!D2&!D1&D&!C1&C&B&A1&!A|E1&E&!D2&!D1&D&!C1&C&B&A1&!A|!E1&E&!D2&!D1&D&!C1&C&B&A1&!A|!E1&E&D2&!D1&D&!C1&C&B&A1&!A|E1&E&D2&!D1&D&!C1&C&B&A1&!A|E1&!E&D2&!D1&D&!C1&C&B&A1&!A|E1&!E&D2&D1&D&!C1&C&B&A1&!A|E1&E&D2&D1&D&!C1&C&B&A1&!A|!E1&E&D2&D1&D&!C1&C&B&A1&!A|!E1&E&!D2&D1&D&!C1&C&B&A1&!A|E1&E&!D2&D1&D&!C1&C&B&A1&!A|E1&!E&!D2&D1&D&!C1&C&B&A1&!A|E1&!E&!D2&D1&!D&!C1&C&B&A1&!A|E1&E&!D2&D1&!D&!C1&C&B&A1&!A|!E1&E&!D2&D1&!D&!C1&C&B&A1&!A|!E1&E&D2&D1&!D&!C1&C&B&A1&!A|E1&E&D2&D1&!D&!C1&C&B&A1&!A|E1&!E&D2&D1&!D&!C1&C&B&A1&!A|E1&!E&D2&!D1&!D&!C1&C&B&A1&!A|E1&E&D2&!D1&!D&!C1&C&B&A1&!A|!E1&E&D2&!D1&!D&!C1&C&B&A1&!A|!E1&E&!D2&!D1&!D&!C1&C&B&A1&!A|E1&E&!D2&!D1&!D&!C1&C&B&A1&!A|E1&!E&!D2&!D1&!D&!C1&C&B&A1&!A|!E1&E&D2&D1&D&!C1&C&!B&A1&!A|E1&E&D2&D1&D&!C1&C&!B&A1&!A|E1&!E&D2&D1&D&!C1&C&!B&A1&!A|E1&!E&D2&D1&D&C1&C&!B&A1&!A|E1&E&D2&D1&D&C1&C&!B&A1&!A|!E1&E&D2&D1&D&C1&C&!B&A1&!A|!E1&E&D2&D1&D&C1&!C&!B&A1&!A|E1&E&D2&D1&D&C1&!C&!B&A1&!A|E1&!E&D2&D1&D&C1&!C&!B&A1&!A|E1&!E&D2&D1&D&!C1&!C&!B&A1&!A|E1&E&D2&D1&D&!C1&!C&!B&A1&!A|!E1&E&D2&D1&D&!C1&!C&!B&A1&!A|!E1&E&D2&D1&D&!C1&!C&!B&A1&A|E1&E&D2&D1&D&!C1&!C&!B&A1&A|E1&!E&D2&D1&D&!C1&!C&!B&A1&A|E1&!E&!D2&!D1&D&C1&!C&!B&A1&A|E1&E&!D2&!D1&D&C1&!C&!B&A1&A|!E1&E&!D2&!D1&D&C1&!C&!B&A1&A|!E1&E&D2&!D1&D&C1&!C&!B&A1&A|E1&E&D2&!D1&D&C1&!C&!B&A1&A|E1&!E&D2&!D1&D&C1&!C&!B&A1&A|E1&!E&D2&D1&D&C1&!C&!B&A1&A|E1&E&D2&D1&D&C1&!C&!B&A1&A|!E1&E&D2&D1&D&C1&!C&!B&A1&A|!E1&E&!D2&D1&D&C1&!C&!B&A1&A|E1&E&!D2&D1&D&C1&!C&!B&A1&A|E1&!E&!D2&D1&D&C1&!C&!B&A1&A|E1&!E&!D2&D1&!D&C1&!C&!B&A1&A|E1&E&!D2&D1&!D&C1&!C&!B&A1&A|!E1&E&!D2&D1&!D&C1&!C&!B&A1&A|!E1&E&D2&D1&!D&C1&!C&!B&A1&A|E1&E&D2&D1&!D&C1&!C&!B&A1&A|E1&!E&D2&D1&!D&C1&!C&!B&A1&A|E1&!E&D2&!D1&!D&C1&!C&!B&A1&A|E1&E&D2&!D1&!D&C1&!C&!B&A1&A|!E1&E&D2&!D1&!D&C1&!C&!B&A1&A|!E1&E&!D2&!D1&!D&C1&!C&!B&A1&A|E1&E&!D2&!D1&!D&C1&!C&!B&A1&A|E1&!E&!D2&!D1&!D&C1&!C&!B&A1&A|E1&!E&!D2&!D1&!D&C1&C&!B&A1&A|E1&E&!D2&!D1&!D&C1&C&!B&A1&A|!E1&E&!D2&!D1&!D&C1&C&!B&A1&A|!E1&E&D2&!D1&!D&C1&C&!B&A1&A|E1&E&D2&!D1&!D&C1&C&!B&A1&A|E1&!E&D2&!D1&!D&C1&C&!B&A1&A|E1&!E&D2&D1&!D&C1&C&!B&A1&A|E1&E&D2&D1&!D&C1&C&!B&A1&A|!E1&E&D2&D1&!D&C1&C&!B&A1&A|!E1&E&!D2&D1&!D&C1&C&!B&A1&A|E1&E&!D2&D1&!D&C1&C&!B&A1&A|E1&!E&!D2&D1&!D&C1&C&!B&A1&A|E1&!E&!D2&D1&D&C1&C&!B&A1&A|E1&E&!D2&D1&D&C1&C&!B&A1&A|!E1&E&!D2&D1&D&C1&C&!B&A1&A|!E1&E&D2&D1&D&C1&C&!B&A1&A|E1&E&D2&D1&D&C1&C&!B&A1&A|E1&!E&D2&D1&D&C1&C&!B&A1&A|E1&!E&D2&!D1&D&C1&C&!B&A1&A|E1&E&D2&!D1&D&C1&C&!B&A1&A|!E1&E&D2&!D1&D&C1&C&!B&A1&A|!E1&E&!D2&!D1&D&C1&C&!B&A1&A|E1&E&!D2&!D1&D&C1&C&!B&A1&A|E1&!E&!D2&!D1&D&C1&C&!B&A1&A|E1&!E&!D2&!D1&D&!C1&C&!B&A1&A|E1&E&!D2&!D1&D&!C1&C&!B&A1&A|!E1&E&!D2&!D1&D&!C1&C&!B&A1&A|!E1&E&D2&!D1&D&!C1&C&!B&A1&A|E1&E&D2&!D1&D&!C1&C&!B&A1&A|E1&!E&D2&!D1&D&!C1&C&!B&A1&A|E1&!E&D2&D1&D&!C1&C&!B&A1&A|E1&E&D2&D1&D&!C1&C&!B&A1&A|!E1&E&D2&D1&D&!C1&C&!B&A1&A|!E1&E&!D2&D1&D&!C1&C&!B&A1&A|E1&E&!D2&D1&D&!C1&C&!B&A1&A|E1&!E&!D2&D1&D&!C1&C&!B&A1&A|E1&!E&!D2&D1&!D&!C1&C&!B&A1&A|E1&E&!D2&D1&!D&!C1&C&!B&A1&A|!E1&E&!D2&D1&!D&!C1&C&!B&A1&A|!E1&E&D2&D1&!D&!C1&C&!B&A1&A|E1&E&D2&D1&!D&!C1&C&!B&A1&A|E1&!E&D2&D1&!D&!C1&C&!B&A1&A|E1&!E&D2&!D1&!D&!C1&C&!B&A1&A|E1&E&D2&!D1&!D&!C1&C&!B&A1&A|!E1&E&D2&!D1&!D&!C1&C&!B&A1&A|!E1&E&!D2&!D1&!D&!C1&C&!B&A1&A|E1&E&!D2&!D1&!D&!C1&C&!B&A1&A|E1&!E&!D2&!D1&!D&!C1&C&!B&A1&A|E1&!E&!D2&!D1&!D&!C1&C&B&A1&A|E1&E&!D2&!D1&!D&!C1&C&B&A1&A|!E1&E&!D2&!D1&!D&!C1&C&B&A1&A|!E1&E&D2&!D1&!D&!C1&C&B&A1&A|E1&E&D2&!D1&!D&!C1&C&B&A1&A|E1&!E&D2&!D1&!D&!C1&C&B&A1&A|E1&!E&D2&D1&!D&!C1&C&B&A1&A|E1&E&D2&D1&!D&!C1&C&B&A1&A|!E1&E&D2&D1&!D&!C1&C&B&A1&A|!E1&E&!D2&D1&!D&!C1&C&B&A1&A|E1&E&!D2&D1&!D&!C1&C&B&A1&A|E1&!E&!D2&D1&!D&!C1&C&B&A1&A|E1&!E&!D2&D1&D&!C1&C&B&A1&A|E1&E&!D2&D1&D&!C1&C&B&A1&A|!E1&E&!D2&D1&D&!C1&C&B&A1&A|!E1&E&D2&D1&D&!C1&C&B&A1&A|E1&E&D2&D1&D&!C1&C&B&A1&A|E1&!E&D2&D1&D&!C1&C&B&A1&A|E1&!E&D2&!D1&D&!C1&C&B&A1&A|E1&E&D2&!D1&D&!C1&C&B&A1&A|!E1&E&D2&!D1&D&!C1&C&B&A1&A|!E1&E&!D2&!D1&D&!C1&C&B&A1&A|E1&E&!D2&!D1&D&!C1&C&B&A1&A|E1&!E&!D2&!D1&D&!C1&C&B&A1&A|E1&!E&!D2&!D1&D&C1&C&B&A1&A|E1&E&!D2&!D1&D&C1&C&B&A1&A|!E1&E&!D2&!D1&D&C1&C&B&A1&A|!E1&E&D2&!D1&D&C1&C&B&A1&A|E1&E&D2&!D1&D&C1&C&B&A1&A|E1&!E&D2&!D1&D&C1&C&B&A1&A|E1&!E&D2&D1&D&C1&C&B&A1&A|E1&E&D2&D1&D&C1&C&B&A1&A|!E1&E&D2&D1&D&C1&C&B&A1&A|!E1&E&!D2&D1&D&C1&C&B&A1&A|E1&E&!D2&D1&D&C1&C&B&A1&A|E1&!E&!D2&D1&D&C1&C&B&A1&A|E1&!E&!D2&D1&!D&C1&C&B&A1&A|E1&E&!D2&D1&!D&C1&C&B&A1&A|!E1&E&!D2&D1&!D&C1&C&B&A1&A|!E1&E&D2&D1&!D&C1&C&B&A1&A|E1&E&D2&D1&!D&C1&C&B&A1&A|E1&!E&D2&D1&!D&C1&C&B&A1&A|E1&!E&D2&!D1&!D&C1&C&B&A1&A|E1&E&D2&!D1&!D&C1&C&B&A1&A|!E1&E&D2&!D1&!D&C1&C&B&A1&A|!E1&E&!D2&!D1&!D&C1&C&B&A1&A|E1&E&!D2&!D1&!D&C1&C&B&A1&A|E1&!E&!D2&!D1&!D&C1&C&B&A1&A|E1&!E&!D2&!D1&!D&C1&!C&B&A1&A|E1&E&!D2&!D1&!D&C1&!C&B&A1&A|!E1&E&!D2&!D1&!D&C1&!C&B&A1&A|!E1&E&D2&!D1&!D&C1&!C&B&A1&A|E1&E&D2&!D1&!D&C1&!C&B&A1&A|E1&!E&D2&!D1&!D&C1&!C&B&A1&A|E1&!E&D2&D1&!D&C1&!C&B&A1&A|E1&E&D2&D1&!D&C1&!C&B&A1&A|!E1&E&D2&D1&!D&C1&!C&B&A1&A|!E1&E&!D2&D1&!D&C1&!C&B&A1&A|E1&E&!D2&D1&!D&C1&!C&B&A1&A|E1&!E&!D2&D1&!D&C1&!C&B&A1&A|E1&!E&!D2&D1&D&C1&!C&B&A1&A|E1&E&!D2&D1&D&C1&!C&B&A1&A|!E1&E&!D2&D1&D&C1&!C&B&A1&A|!E1&E&D2&D1&D&C1&!C&B&A1&A|E1&E&D2&D1&D&C1&!C&B&A1&A|E1&!E&D2&D1&D&C1&!C&B&A1&A|E1&!E&D2&!D1&D&C1&!C&B&A1&A|E1&E&D2&!D1&D&C1&!C&B&A1&A|!E1&E&D2&!D1&D&C1&!C&B&A1&A|!E1&E&!D2&!D1&D&C1&!C&B&A1&A|E1&E&!D2&!D1&D&C1&!C&B&A1&A|E1&!E&!D2&!D1&D&C1&!C&B&A1&A|E1&!E&D2&D1&D&!C1&!C&B&A1&A|E1&E&D2&D1&D&!C1&!C&B&A1&A|!E1&E&D2&D1&D&!C1&!C&B&A1&A|!E1&E&D2&D1&D&!C1&!C&B&!A1&A|E1&E&D2&D1&D&!C1&!C&B&!A1&A|E1&!E&D2&D1&D&!C1&!C&B&!A1&A|E1&!E&!D2&!D1&D&C1&!C&B&!A1&A|E1&E&!D2&!D1&D&C1&!C&B&!A1&A|!E1&E&!D2&!D1&D&C1&!C&B&!A1&A|!E1&E&D2&!D1&D&C1&!C&B&!A1&A|E1&E&D2&!D1&D&C1&!C&B&!A1&A|E1&!E&D2&!D1&D&C1&!C&B&!A1&A|E1&!E&D2&D1&D&C1&!C&B&!A1&A|E1&E&D2&D1&D&C1&!C&B&!A1&A|!E1&E&D2&D1&D&C1&!C&B&!A1&A|!E1&E&!D2&D1&D&C1&!C&B&!A1&A|E1&E&!D2&D1&D&C1&!C&B&!A1&A|E1&!E&!D2&D1&D&C1&!C&B&!A1&A|E1&!E&!D2&D1&!D&C1&!C&B&!A1&A|E1&E&!D2&D1&!D&C1&!C&B&!A1&A|!E1&E&!D2&D1&!D&C1&!C&B&!A1&A|!E1&E&D2&D1&!D&C1&!C&B&!A1&A|E1&E&D2&D1&!D&C1&!C&B&!A1&A|E1&!E&D2&D1&!D&C1&!C&B&!A1&A|E1&!E&D2&!D1&!D&C1&!C&B&!A1&A|E1&E&D2&!D1&!D&C1&!C&B&!A1&A|!E1&E&D2&!D1&!D&C1&!C&B&!A1&A|!E1&E&!D2&!D1&!D&C1&!C&B&!A1&A|E1&E&!D2&!D1&!D&C1&!C&B&!A1&A|E1&!E&!D2&!D1&!D&C1&!C&B&!A1&A|E1&!E&!D2&!D1&!D&C1&C&B&!A1&A|E1&E&!D2&!D1&!D&C1&C&B&!A1&A|!E1&E&!D2&!D1&!D&C1&C&B&!A1&A|!E1&E&D2&!D1&!D&C1&C&B&!A1&A|E1&E&D2&!D1&!D&C1&C&B&!A1&A|E1&!E&D2&!D1&!D&C1&C&B&!A1&A|E1&!E&D2&D1&!D&C1&C&B&!A1&A|E1&E&D2&D1&!D&C1&C&B&!A1&A|!E1&E&D2&D1&!D&C1&C&B&!A1&A|!E1&E&!D2&D1&!D&C1&C&B&!A1&A|E1&E&!D2&D1&!D&C1&C&B&!A1&A|E1&!E&!D2&D1&!D&C1&C&B&!A1&A|E1&!E&!D2&D1&D&C1&C&B&!A1&A|E1&E&!D2&D1&D&C1&C&B&!A1&A|!E1&E&!D2&D1&D&C1&C&B&!A1&A|!E1&E&D2&D1&D&C1&C&B&!A1&A|E1&E&D2&D1&D&C1&C&B&!A1&A|E1&!E&D2&D1&D&C1&C&B&!A1&A|E1&!E&D2&!D1&D&C1&C&B&!A1&A|E1&E&D2&!D1&D&C1&C&B&!A1&A|!E1&E&D2&!D1&D&C1&C&B&!A1&A|!E1&E&!D2&!D1&D&C1&C&B&!A1&A|E1&E&!D2&!D1&D&C1&C&B&!A1&A|E1&!E&!D2&!D1&D&C1&C&B&!A1&A|E1&!E&!D2&!D1&D&!C1&C&B&!A1&A|E1&E&!D2&!D1&D&!C1&C&B&!A1&A|!E1&E&!D2&!D1&D&!C1&C&B&!A1&A|!E1&E&D2&!D1&D&!C1&C&B&!A1&A|E1&E&D2&!D1&D&!C1&C&B&!A1&A|E1&!E&D2&!D1&D&!C1&C&B&!A1&A|E1&!E&D2&D1&D&!C1&C&B&!A1&A|E1&E&D2&D1&D&!C1&C&B&!A1&A|!E1&E&D2&D1&D&!C1&C&B&!A1&A|!E1&E&!D2&D1&D&!C1&C&B&!A1&A|E1&E&!D2&D1&D&!C1&C&B&!A1&A|E1&!E&!D2&D1&D&!C1&C&B&!A1&A|E1&!E&!D2&D1&!D&!C1&C&B&!A1&A|E1&E&!D2&D1&!D&!C1&C&B&!A1&A|!E1&E&!D2&D1&!D&!C1&C&B&!A1&A|!E1&E&D2&D1&!D&!C1&C&B&!A1&A|E1&E&D2&D1&!D&!C1&C&B&!A1&A|E1&!E&D2&D1&!D&!C1&C&B&!A1&A|E1&!E&D2&!D1&!D&!C1&C&B&!A1&A|E1&E&D2&!D1&!D&!C1&C&B&!A1&A|!E1&E&D2&!D1&!D&!C1&C&B&!A1&A|!E1&E&!D2&!D1&!D&!C1&C&B&!A1&A|E1&E&!D2&!D1&!D&!C1&C&B&!A1&A|E1&!E&!D2&!D1&!D&!C1&C&B&!A1&A|!E1&E&D2&D1&D&!C1&C&!B&!A1&A|E1&E&D2&D1&D&!C1&C&!B&!A1&A|E1&!E&D2&D1&D&!C1&C&!B&!A1&A|E1&!E&D2&D1&D&C1&C&!B&!A1&A|E1&E&D2&D1&D&C1&C&!B&!A1&A|!E1&E&D2&D1&D&C1&C&!B&!A1&A|!E1&E&D2&D1&D&C1&!C&!B&!A1&A|E1&E&D2&D1&D&C1&!C&!B&!A1&A|E1&!E&D2&D1&D&C1&!C&!B&!A1&A|E1&!E&D2&D1&D&!C1&!C&!B&!A1&A|E1&E&D2&D1&D&!C1&!C&!B&!A1&A|!E1&E&D2&D1&D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOOAI21232.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOI31 -l AOI31 -i B A2 A1 A -o Y -f Y=(!B&!A2&!A1&!A|!B&A2&!A1&!A|!B&A2&A1&!A|!B&!A2&A1&!A|!B&!A2&A1&A|!B&A2&!A1&A|!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOI31.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAOAI22211 -l AAOOAOAI22211 -i E D C1 C B1 B A1 A -o Y -f Y=!(E&D&!C1&!C&!B1&!B&!A1&!A|E&D&C1&!C&!B1&!B&!A1&!A|E&D&C1&C&!B1&!B&!A1&!A|E&D&!C1&C&!B1&!B&!A1&!A|E&D&!C1&C&B1&!B&!A1&!A|E&D&C1&C&B1&!B&!A1&!A|E&D&C1&!C&B1&!B&!A1&!A|E&D&!C1&!C&B1&!B&!A1&!A|E&D&!C1&!C&B1&B&!A1&!A|E&D&C1&!C&B1&B&!A1&!A|E&!D&C1&!C&B1&B&!A1&!A|E&!D&C1&C&B1&B&!A1&!A|E&D&C1&C&B1&B&!A1&!A|E&D&!C1&C&B1&B&!A1&!A|E&!D&!C1&C&B1&B&!A1&!A|E&D&!C1&C&!B1&B&!A1&!A|E&D&C1&C&!B1&B&!A1&!A|E&D&C1&!C&!B1&B&!A1&!A|E&D&!C1&!C&!B1&B&!A1&!A|E&D&!C1&!C&!B1&B&A1&!A|E&D&C1&!C&!B1&B&A1&!A|E&D&C1&C&!B1&B&A1&!A|E&D&!C1&C&!B1&B&A1&!A|E&!D&!C1&C&B1&B&A1&!A|E&D&!C1&C&B1&B&A1&!A|E&D&C1&C&B1&B&A1&!A|E&!D&C1&C&B1&B&A1&!A|E&!D&C1&!C&B1&B&A1&!A|E&D&C1&!C&B1&B&A1&!A|E&D&!C1&!C&B1&B&A1&!A|E&D&!C1&!C&B1&!B&A1&!A|E&D&C1&!C&B1&!B&A1&!A|E&D&C1&C&B1&!B&A1&!A|E&D&!C1&C&B1&!B&A1&!A|E&D&!C1&C&!B1&!B&A1&!A|E&D&C1&C&!B1&!B&A1&!A|E&D&C1&!C&!B1&!B&A1&!A|E&D&!C1&!C&!B1&!B&A1&!A|E&D&!C1&!C&!B1&!B&A1&A|E&D&C1&!C&!B1&!B&A1&A|E&!D&C1&!C&!B1&!B&A1&A|E&!D&C1&C&!B1&!B&A1&A|E&D&C1&C&!B1&!B&A1&A|E&D&!C1&C&!B1&!B&A1&A|E&!D&!C1&C&!B1&!B&A1&A|E&!D&!C1&C&B1&!B&A1&A|E&D&!C1&C&B1&!B&A1&A|E&D&C1&C&B1&!B&A1&A|E&!D&C1&C&B1&!B&A1&A|E&!D&C1&!C&B1&!B&A1&A|E&D&C1&!C&B1&!B&A1&A|E&D&!C1&!C&B1&!B&A1&A|E&D&!C1&!C&B1&B&A1&A|E&D&C1&!C&B1&B&A1&A|E&!D&C1&!C&B1&B&A1&A|E&!D&C1&C&B1&B&A1&A|E&D&C1&C&B1&B&A1&A|E&D&!C1&C&B1&B&A1&A|E&!D&!C1&C&B1&B&A1&A|E&!D&!C1&C&!B1&B&A1&A|E&D&!C1&C&!B1&B&A1&A|E&D&C1&C&!B1&B&A1&A|E&!D&C1&C&!B1&B&A1&A|E&!D&C1&!C&!B1&B&A1&A|E&D&C1&!C&!B1&B&A1&A|E&D&!C1&!C&!B1&B&A1&A|E&D&!C1&!C&!B1&B&!A1&A|E&D&C1&!C&!B1&B&!A1&A|E&D&C1&C&!B1&B&!A1&A|E&D&!C1&C&!B1&B&!A1&A|E&!D&!C1&C&B1&B&!A1&A|E&D&!C1&C&B1&B&!A1&A|E&D&C1&C&B1&B&!A1&A|E&!D&C1&C&B1&B&!A1&A|E&!D&C1&!C&B1&B&!A1&A|E&D&C1&!C&B1&B&!A1&A|E&D&!C1&!C&B1&B&!A1&A|E&D&!C1&!C&B1&!B&!A1&A|E&D&C1&!C&B1&!B&!A1&A|E&D&C1&C&B1&!B&!A1&A|E&D&!C1&C&B1&!B&!A1&A|E&D&!C1&C&!B1&!B&!A1&A|E&D&C1&C&!B1&!B&!A1&A|E&D&C1&!C&!B1&!B&!A1&A|E&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAOAI22211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n NAND3 -l NAND3 -i A2 A1 A -o Y -f Y=!(A2&A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist NAND3.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOI322 -l AAAOI322 -i C1 C B1 B A2 A1 A -o Y -f Y=(!C1&!C&!B1&!B&!A2&!A1&!A|C1&!C&!B1&!B&!A2&!A1&!A|!C1&C&!B1&!B&!A2&!A1&!A|!C1&C&B1&!B&!A2&!A1&!A|C1&!C&B1&!B&!A2&!A1&!A|!C1&!C&B1&!B&!A2&!A1&!A|!C1&C&!B1&B&!A2&!A1&!A|C1&!C&!B1&B&!A2&!A1&!A|!C1&!C&!B1&B&!A2&!A1&!A|!C1&!C&!B1&B&A2&!A1&!A|C1&!C&!B1&B&A2&!A1&!A|!C1&C&!B1&B&A2&!A1&!A|!C1&!C&B1&!B&A2&!A1&!A|C1&!C&B1&!B&A2&!A1&!A|!C1&C&B1&!B&A2&!A1&!A|!C1&C&!B1&!B&A2&!A1&!A|C1&!C&!B1&!B&A2&!A1&!A|!C1&!C&!B1&!B&A2&!A1&!A|!C1&!C&!B1&!B&A2&A1&!A|C1&!C&!B1&!B&A2&A1&!A|!C1&C&!B1&!B&A2&A1&!A|!C1&C&B1&!B&A2&A1&!A|C1&!C&B1&!B&A2&A1&!A|!C1&!C&B1&!B&A2&A1&!A|!C1&C&!B1&B&A2&A1&!A|C1&!C&!B1&B&A2&A1&!A|!C1&!C&!B1&B&A2&A1&!A|!C1&!C&!B1&B&!A2&A1&!A|C1&!C&!B1&B&!A2&A1&!A|!C1&C&!B1&B&!A2&A1&!A|!C1&!C&B1&!B&!A2&A1&!A|C1&!C&B1&!B&!A2&A1&!A|!C1&C&B1&!B&!A2&A1&!A|!C1&C&!B1&!B&!A2&A1&!A|C1&!C&!B1&!B&!A2&A1&!A|!C1&!C&!B1&!B&!A2&A1&!A|!C1&!C&!B1&!B&!A2&A1&A|C1&!C&!B1&!B&!A2&A1&A|!C1&C&!B1&!B&!A2&A1&A|!C1&C&B1&!B&!A2&A1&A|C1&!C&B1&!B&!A2&A1&A|!C1&!C&B1&!B&!A2&A1&A|!C1&C&!B1&B&!A2&A1&A|C1&!C&!B1&B&!A2&A1&A|!C1&!C&!B1&B&!A2&A1&A|!C1&!C&!B1&!B&A2&!A1&A|C1&!C&!B1&!B&A2&!A1&A|!C1&C&!B1&!B&A2&!A1&A|!C1&C&B1&!B&A2&!A1&A|C1&!C&B1&!B&A2&!A1&A|!C1&!C&B1&!B&A2&!A1&A|!C1&C&!B1&B&A2&!A1&A|C1&!C&!B1&B&A2&!A1&A|!C1&!C&!B1&B&A2&!A1&A|!C1&!C&!B1&B&!A2&!A1&A|C1&!C&!B1&B&!A2&!A1&A|!C1&C&!B1&B&!A2&!A1&A|!C1&!C&B1&!B&!A2&!A1&A|C1&!C&B1&!B&!A2&!A1&A|!C1&C&B1&!B&!A2&!A1&A|!C1&C&!B1&!B&!A2&!A1&A|C1&!C&!B1&!B&!A2&!A1&A|!C1&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOI322.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAI321 -l AAOAI321 -i C B1 B A2 A1 A -o Y -f Y=!(C&B1&B&!A2&!A1&!A|C&B1&B&A2&!A1&!A|C&B1&B&A2&A1&!A|C&B1&B&!A2&A1&!A|C&B1&B&!A2&A1&A|C&!B1&B&A2&A1&A|C&B1&B&A2&A1&A|C&B1&!B&A2&A1&A|C&!B1&!B&A2&A1&A|C&B1&B&A2&!A1&A|C&B1&B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAI321.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOI21221 -l AOOAAOI21221 -i E D1 D C1 C B A1 A -o Y -f Y=(!E&!D1&!D&!C1&!C&!B&!A1&!A|!E&D1&!D&!C1&!C&!B&!A1&!A|!E&!D1&D&!C1&!C&!B&!A1&!A|!E&!D1&D&C1&!C&!B&!A1&!A|!E&D1&!D&C1&!C&!B&!A1&!A|!E&!D1&!D&C1&!C&!B&!A1&!A|!E&!D1&!D&C1&C&!B&!A1&!A|!E&D1&!D&C1&C&!B&!A1&!A|!E&!D1&D&C1&C&!B&!A1&!A|!E&!D1&D&!C1&C&!B&!A1&!A|!E&D1&!D&!C1&C&!B&!A1&!A|!E&!D1&!D&!C1&C&!B&!A1&!A|!E&!D1&D&!C1&!C&B&!A1&!A|!E&D1&!D&!C1&!C&B&!A1&!A|!E&!D1&!D&!C1&!C&B&!A1&!A|!E&!D1&!D&!C1&!C&B&A1&!A|!E&D1&!D&!C1&!C&B&A1&!A|!E&!D1&D&!C1&!C&B&A1&!A|!E&!D1&!D&!C1&C&!B&A1&!A|!E&D1&!D&!C1&C&!B&A1&!A|!E&!D1&D&!C1&C&!B&A1&!A|!E&!D1&D&C1&C&!B&A1&!A|!E&D1&!D&C1&C&!B&A1&!A|!E&!D1&!D&C1&C&!B&A1&!A|!E&!D1&!D&C1&!C&!B&A1&!A|!E&D1&!D&C1&!C&!B&A1&!A|!E&!D1&D&C1&!C&!B&A1&!A|!E&!D1&D&!C1&!C&!B&A1&!A|!E&D1&!D&!C1&!C&!B&A1&!A|!E&!D1&!D&!C1&!C&!B&A1&!A|!E&!D1&!D&!C1&!C&!B&A1&A|!E&D1&!D&!C1&!C&!B&A1&A|!E&!D1&D&!C1&!C&!B&A1&A|!E&!D1&D&!C1&!C&B&A1&A|!E&D1&!D&!C1&!C&B&A1&A|!E&!D1&!D&!C1&!C&B&A1&A|!E&!D1&!D&!C1&!C&B&!A1&A|!E&D1&!D&!C1&!C&B&!A1&A|!E&!D1&D&!C1&!C&B&!A1&A|!E&!D1&!D&!C1&C&!B&!A1&A|!E&D1&!D&!C1&C&!B&!A1&A|!E&!D1&D&!C1&C&!B&!A1&A|!E&!D1&D&C1&C&!B&!A1&A|!E&D1&!D&C1&C&!B&!A1&A|!E&!D1&!D&C1&C&!B&!A1&A|!E&!D1&!D&C1&!C&!B&!A1&A|!E&D1&!D&C1&!C&!B&!A1&A|!E&!D1&D&C1&!C&!B&!A1&A|!E&!D1&D&!C1&!C&!B&!A1&A|!E&D1&!D&!C1&!C&!B&!A1&A|!E&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOI21221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOOAI21212 -l AOOAOOAI21212 -i E1 E D C1 C B A1 A -o Y -f Y=(!E1&!E&!D&!C1&!C&!B&!A1&!A|E1&!E&!D&!C1&!C&!B&!A1&!A|E1&E&!D&!C1&!C&!B&!A1&!A|!E1&E&!D&!C1&!C&!B&!A1&!A|!E1&!E&D&!C1&!C&!B&!A1&!A|!E1&!E&D&C1&!C&!B&!A1&!A|!E1&E&!D&C1&!C&!B&!A1&!A|E1&E&!D&C1&!C&!B&!A1&!A|E1&!E&!D&C1&!C&!B&!A1&!A|!E1&!E&!D&C1&!C&!B&!A1&!A|!E1&!E&!D&C1&C&!B&!A1&!A|E1&!E&!D&C1&C&!B&!A1&!A|E1&E&!D&C1&C&!B&!A1&!A|!E1&E&!D&C1&C&!B&!A1&!A|!E1&!E&D&C1&C&!B&!A1&!A|!E1&!E&D&!C1&C&!B&!A1&!A|!E1&E&!D&!C1&C&!B&!A1&!A|E1&E&!D&!C1&C&!B&!A1&!A|E1&!E&!D&!C1&C&!B&!A1&!A|!E1&!E&!D&!C1&C&!B&!A1&!A|!E1&!E&!D&!C1&C&B&!A1&!A|!E1&!E&D&!C1&C&B&!A1&!A|!E1&!E&D&C1&C&B&!A1&!A|!E1&!E&!D&C1&C&B&!A1&!A|!E1&!E&!D&C1&!C&B&!A1&!A|!E1&!E&D&C1&!C&B&!A1&!A|!E1&!E&D&!C1&!C&B&!A1&!A|!E1&E&!D&!C1&!C&B&!A1&!A|E1&E&!D&!C1&!C&B&!A1&!A|E1&!E&!D&!C1&!C&B&!A1&!A|!E1&!E&!D&!C1&!C&B&!A1&!A|!E1&!E&!D&!C1&!C&B&A1&!A|E1&!E&!D&!C1&!C&B&A1&!A|E1&E&!D&!C1&!C&B&A1&!A|!E1&E&!D&!C1&!C&B&A1&!A|!E1&!E&D&!C1&!C&B&A1&!A|!E1&!E&D&C1&!C&B&A1&!A|!E1&!E&!D&C1&!C&B&A1&!A|!E1&!E&!D&C1&C&B&A1&!A|!E1&!E&D&C1&C&B&A1&!A|!E1&!E&D&!C1&C&B&A1&!A|!E1&!E&!D&!C1&C&B&A1&!A|!E1&!E&!D&!C1&C&!B&A1&!A|E1&!E&!D&!C1&C&!B&A1&!A|E1&E&!D&!C1&C&!B&A1&!A|!E1&E&!D&!C1&C&!B&A1&!A|!E1&!E&D&!C1&C&!B&A1&!A|!E1&!E&D&C1&C&!B&A1&!A|!E1&E&!D&C1&C&!B&A1&!A|E1&E&!D&C1&C&!B&A1&!A|E1&!E&!D&C1&C&!B&A1&!A|!E1&!E&!D&C1&C&!B&A1&!A|!E1&!E&!D&C1&!C&!B&A1&!A|E1&!E&!D&C1&!C&!B&A1&!A|E1&E&!D&C1&!C&!B&A1&!A|!E1&E&!D&C1&!C&!B&A1&!A|!E1&!E&D&C1&!C&!B&A1&!A|!E1&!E&D&!C1&!C&!B&A1&!A|!E1&E&!D&!C1&!C&!B&A1&!A|E1&E&!D&!C1&!C&!B&A1&!A|E1&!E&!D&!C1&!C&!B&A1&!A|!E1&!E&!D&!C1&!C&!B&A1&!A|!E1&!E&!D&!C1&!C&!B&A1&A|E1&!E&!D&!C1&!C&!B&A1&A|E1&E&!D&!C1&!C&!B&A1&A|!E1&E&!D&!C1&!C&!B&A1&A|!E1&!E&D&!C1&!C&!B&A1&A|!E1&!E&D&C1&!C&!B&A1&A|!E1&!E&!D&C1&!C&!B&A1&A|!E1&!E&!D&C1&C&!B&A1&A|!E1&!E&D&C1&C&!B&A1&A|!E1&!E&D&!C1&C&!B&A1&A|!E1&!E&!D&!C1&C&!B&A1&A|!E1&!E&!D&!C1&C&B&A1&A|!E1&!E&D&!C1&C&B&A1&A|!E1&!E&D&C1&C&B&A1&A|!E1&!E&!D&C1&C&B&A1&A|!E1&!E&!D&C1&!C&B&A1&A|!E1&!E&D&C1&!C&B&A1&A|!E1&!E&D&!C1&!C&B&A1&A|!E1&E&!D&!C1&!C&B&A1&A|E1&E&!D&!C1&!C&B&A1&A|E1&!E&!D&!C1&!C&B&A1&A|!E1&!E&!D&!C1&!C&B&A1&A|!E1&!E&!D&!C1&!C&B&!A1&A|E1&!E&!D&!C1&!C&B&!A1&A|E1&E&!D&!C1&!C&B&!A1&A|!E1&E&!D&!C1&!C&B&!A1&A|!E1&!E&D&!C1&!C&B&!A1&A|!E1&!E&D&C1&!C&B&!A1&A|!E1&!E&!D&C1&!C&B&!A1&A|!E1&!E&!D&C1&C&B&!A1&A|!E1&!E&D&C1&C&B&!A1&A|!E1&!E&D&!C1&C&B&!A1&A|!E1&!E&!D&!C1&C&B&!A1&A|!E1&!E&!D&!C1&C&!B&!A1&A|E1&!E&!D&!C1&C&!B&!A1&A|E1&E&!D&!C1&C&!B&!A1&A|!E1&E&!D&!C1&C&!B&!A1&A|!E1&!E&D&!C1&C&!B&!A1&A|!E1&!E&D&C1&C&!B&!A1&A|!E1&E&!D&C1&C&!B&!A1&A|E1&E&!D&C1&C&!B&!A1&A|E1&!E&!D&C1&C&!B&!A1&A|!E1&!E&!D&C1&C&!B&!A1&A|!E1&!E&!D&C1&!C&!B&!A1&A|E1&!E&!D&C1&!C&!B&!A1&A|E1&E&!D&C1&!C&!B&!A1&A|!E1&E&!D&C1&!C&!B&!A1&A|!E1&!E&D&C1&!C&!B&!A1&A|!E1&!E&D&!C1&!C&!B&!A1&A|!E1&E&!D&!C1&!C&!B&!A1&A|E1&E&!D&!C1&!C&!B&!A1&A|E1&!E&!D&!C1&!C&!B&!A1&A|!E1&!E&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOOAI21212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOI2221 -l OAAOI2221 -i D C1 C B1 B A1 A -o Y -f Y=(!D&!C1&!C&!B1&!B&!A1&!A|!D&C1&!C&!B1&!B&!A1&!A|!D&!C1&C&!B1&!B&!A1&!A|!D&!C1&C&B1&!B&!A1&!A|!D&C1&!C&B1&!B&!A1&!A|!D&!C1&!C&B1&!B&!A1&!A|!D&!C1&!C&B1&B&!A1&!A|!D&C1&!C&B1&B&!A1&!A|!D&!C1&C&B1&B&!A1&!A|!D&!C1&C&!B1&B&!A1&!A|!D&C1&!C&!B1&B&!A1&!A|!D&!C1&!C&!B1&B&!A1&!A|!D&!C1&!C&!B1&B&A1&!A|!D&C1&!C&!B1&B&A1&!A|!D&!C1&C&!B1&B&A1&!A|!D&!C1&!C&B1&!B&A1&!A|!D&C1&!C&B1&!B&A1&!A|!D&!C1&C&B1&!B&A1&!A|!D&!C1&C&!B1&!B&A1&!A|!D&C1&!C&!B1&!B&A1&!A|!D&!C1&!C&!B1&!B&A1&!A|!D&!C1&!C&!B1&!B&A1&A|!D&C1&!C&!B1&!B&A1&A|!D&!C1&C&!B1&!B&A1&A|!D&!C1&C&B1&!B&A1&A|!D&C1&!C&B1&!B&A1&A|!D&!C1&!C&B1&!B&A1&A|!D&!C1&C&!B1&B&A1&A|!D&C1&!C&!B1&B&A1&A|!D&!C1&!C&!B1&B&A1&A|!D&!C1&!C&!B1&B&!A1&A|!D&C1&!C&!B1&B&!A1&A|!D&!C1&C&!B1&B&!A1&A|!D&!C1&!C&B1&!B&!A1&A|!D&C1&!C&B1&!B&!A1&A|!D&!C1&C&B1&!B&!A1&A|!D&!C1&C&!B1&!B&!A1&A|!D&C1&!C&!B1&!B&!A1&A|!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOI2221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAI2221 -l OOOAI2221 -i D C1 C B1 B A1 A -o Y -f Y=!(D&C1&!C&!B1&B&A1&!A|D&C1&C&!B1&B&A1&!A|D&!C1&C&!B1&B&A1&!A|D&!C1&C&B1&B&A1&!A|D&C1&C&B1&B&A1&!A|D&C1&!C&B1&B&A1&!A|D&C1&!C&B1&!B&A1&!A|D&C1&C&B1&!B&A1&!A|D&!C1&C&B1&!B&A1&!A|D&!C1&C&B1&!B&A1&A|D&C1&C&B1&!B&A1&A|D&C1&!C&B1&!B&A1&A|D&C1&!C&B1&B&A1&A|D&C1&C&B1&B&A1&A|D&!C1&C&B1&B&A1&A|D&!C1&C&!B1&B&A1&A|D&C1&C&!B1&B&A1&A|D&C1&!C&!B1&B&A1&A|D&C1&!C&!B1&B&!A1&A|D&C1&C&!B1&B&!A1&A|D&!C1&C&!B1&B&!A1&A|D&!C1&C&B1&B&!A1&A|D&C1&C&B1&B&!A1&A|D&C1&!C&B1&B&!A1&A|D&C1&!C&B1&!B&!A1&A|D&C1&C&B1&!B&!A1&A|D&!C1&C&B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAI2221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n ASYNC2 -l ASYNC2 -i A B -o C CN -f C=!(!A&!B) CN=!(A&B) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist ASYNC2.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAI44 -l OOAI44 -i B3 B2 B1 B A3 A2 A1 A -o Y -f Y=(!B3&!B2&!B1&!B&!A3&!A2&!A1&!A|B3&!B2&!B1&!B&!A3&!A2&!A1&!A|B3&B2&!B1&!B&!A3&!A2&!A1&!A|!B3&B2&!B1&!B&!A3&!A2&!A1&!A|!B3&B2&B1&!B&!A3&!A2&!A1&!A|B3&B2&B1&!B&!A3&!A2&!A1&!A|B3&!B2&B1&!B&!A3&!A2&!A1&!A|!B3&!B2&B1&!B&!A3&!A2&!A1&!A|!B3&!B2&B1&B&!A3&!A2&!A1&!A|B3&!B2&B1&B&!A3&!A2&!A1&!A|B3&B2&B1&B&!A3&!A2&!A1&!A|!B3&B2&B1&B&!A3&!A2&!A1&!A|!B3&B2&!B1&B&!A3&!A2&!A1&!A|B3&B2&!B1&B&!A3&!A2&!A1&!A|B3&!B2&!B1&B&!A3&!A2&!A1&!A|!B3&!B2&!B1&B&!A3&!A2&!A1&!A|!B3&!B2&!B1&!B&A3&!A2&!A1&!A|!B3&!B2&!B1&!B&A3&A2&!A1&!A|!B3&!B2&!B1&!B&!A3&A2&!A1&!A|!B3&!B2&!B1&!B&!A3&A2&A1&!A|!B3&!B2&!B1&!B&A3&A2&A1&!A|!B3&!B2&!B1&!B&A3&!A2&A1&!A|!B3&!B2&!B1&!B&!A3&!A2&A1&!A|!B3&!B2&!B1&!B&!A3&!A2&A1&A|!B3&!B2&!B1&!B&A3&!A2&A1&A|!B3&!B2&!B1&!B&A3&A2&A1&A|!B3&!B2&!B1&!B&!A3&A2&A1&A|!B3&!B2&!B1&!B&!A3&A2&!A1&A|!B3&!B2&!B1&!B&A3&A2&!A1&A|!B3&!B2&!B1&!B&A3&!A2&!A1&A|!B3&!B2&!B1&!B&!A3&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAI44.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAAOI2224 -l OOOAAOI2224 -i D3 D2 D1 D C1 C B1 B A1 A -o Y -f Y=!(D3&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|D3&D2&D1&D&C1&!C&!B1&!B&!A1&!A|D3&D2&D1&D&C1&C&!B1&!B&!A1&!A|D3&D2&D1&D&!C1&C&!B1&!B&!A1&!A|D3&D2&D1&D&!C1&C&B1&!B&!A1&!A|D3&D2&D1&D&C1&C&B1&!B&!A1&!A|D3&D2&D1&D&C1&!C&B1&!B&!A1&!A|D3&D2&D1&D&!C1&!C&B1&!B&!A1&!A|D3&D2&D1&D&!C1&!C&B1&B&!A1&!A|D3&D2&D1&D&C1&!C&B1&B&!A1&!A|D3&D2&D1&D&C1&C&B1&B&!A1&!A|D3&D2&D1&D&!C1&C&B1&B&!A1&!A|D3&D2&D1&D&!C1&C&!B1&B&!A1&!A|D3&D2&D1&D&C1&C&!B1&B&!A1&!A|D3&D2&D1&D&C1&!C&!B1&B&!A1&!A|D3&D2&D1&D&!C1&!C&!B1&B&!A1&!A|D3&D2&D1&D&!C1&!C&!B1&B&A1&!A|!D3&!D2&!D1&D&C1&!C&!B1&B&A1&!A|D3&!D2&!D1&D&C1&!C&!B1&B&A1&!A|D3&D2&!D1&D&C1&!C&!B1&B&A1&!A|!D3&D2&!D1&D&C1&!C&!B1&B&A1&!A|!D3&D2&D1&D&C1&!C&!B1&B&A1&!A|D3&D2&D1&D&C1&!C&!B1&B&A1&!A|D3&!D2&D1&D&C1&!C&!B1&B&A1&!A|!D3&!D2&D1&D&C1&!C&!B1&B&A1&!A|!D3&!D2&D1&!D&C1&!C&!B1&B&A1&!A|D3&!D2&D1&!D&C1&!C&!B1&B&A1&!A|D3&D2&D1&!D&C1&!C&!B1&B&A1&!A|!D3&D2&D1&!D&C1&!C&!B1&B&A1&!A|!D3&D2&!D1&!D&C1&!C&!B1&B&A1&!A|D3&D2&!D1&!D&C1&!C&!B1&B&A1&!A|D3&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!D3&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!D3&!D2&!D1&!D&C1&C&!B1&B&A1&!A|D3&!D2&!D1&!D&C1&C&!B1&B&A1&!A|D3&D2&!D1&!D&C1&C&!B1&B&A1&!A|!D3&D2&!D1&!D&C1&C&!B1&B&A1&!A|!D3&D2&D1&!D&C1&C&!B1&B&A1&!A|D3&D2&D1&!D&C1&C&!B1&B&A1&!A|D3&!D2&D1&!D&C1&C&!B1&B&A1&!A|!D3&!D2&D1&!D&C1&C&!B1&B&A1&!A|!D3&!D2&D1&D&C1&C&!B1&B&A1&!A|D3&!D2&D1&D&C1&C&!B1&B&A1&!A|D3&D2&D1&D&C1&C&!B1&B&A1&!A|!D3&D2&D1&D&C1&C&!B1&B&A1&!A|!D3&D2&!D1&D&C1&C&!B1&B&A1&!A|D3&D2&!D1&D&C1&C&!B1&B&A1&!A|D3&!D2&!D1&D&C1&C&!B1&B&A1&!A|!D3&!D2&!D1&D&C1&C&!B1&B&A1&!A|!D3&!D2&!D1&D&!C1&C&!B1&B&A1&!A|D3&!D2&!D1&D&!C1&C&!B1&B&A1&!A|D3&D2&!D1&D&!C1&C&!B1&B&A1&!A|!D3&D2&!D1&D&!C1&C&!B1&B&A1&!A|!D3&D2&D1&D&!C1&C&!B1&B&A1&!A|D3&D2&D1&D&!C1&C&!B1&B&A1&!A|D3&!D2&D1&D&!C1&C&!B1&B&A1&!A|!D3&!D2&D1&D&!C1&C&!B1&B&A1&!A|!D3&!D2&D1&!D&!C1&C&!B1&B&A1&!A|D3&!D2&D1&!D&!C1&C&!B1&B&A1&!A|D3&D2&D1&!D&!C1&C&!B1&B&A1&!A|!D3&D2&D1&!D&!C1&C&!B1&B&A1&!A|!D3&D2&!D1&!D&!C1&C&!B1&B&A1&!A|D3&D2&!D1&!D&!C1&C&!B1&B&A1&!A|D3&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!D3&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!D3&!D2&!D1&!D&!C1&C&B1&B&A1&!A|D3&!D2&!D1&!D&!C1&C&B1&B&A1&!A|D3&D2&!D1&!D&!C1&C&B1&B&A1&!A|!D3&D2&!D1&!D&!C1&C&B1&B&A1&!A|!D3&D2&D1&!D&!C1&C&B1&B&A1&!A|D3&D2&D1&!D&!C1&C&B1&B&A1&!A|D3&!D2&D1&!D&!C1&C&B1&B&A1&!A|!D3&!D2&D1&!D&!C1&C&B1&B&A1&!A|!D3&!D2&D1&D&!C1&C&B1&B&A1&!A|D3&!D2&D1&D&!C1&C&B1&B&A1&!A|D3&D2&D1&D&!C1&C&B1&B&A1&!A|!D3&D2&D1&D&!C1&C&B1&B&A1&!A|!D3&D2&!D1&D&!C1&C&B1&B&A1&!A|D3&D2&!D1&D&!C1&C&B1&B&A1&!A|D3&!D2&!D1&D&!C1&C&B1&B&A1&!A|!D3&!D2&!D1&D&!C1&C&B1&B&A1&!A|!D3&!D2&!D1&D&C1&C&B1&B&A1&!A|D3&!D2&!D1&D&C1&C&B1&B&A1&!A|D3&D2&!D1&D&C1&C&B1&B&A1&!A|!D3&D2&!D1&D&C1&C&B1&B&A1&!A|!D3&D2&D1&D&C1&C&B1&B&A1&!A|D3&D2&D1&D&C1&C&B1&B&A1&!A|D3&!D2&D1&D&C1&C&B1&B&A1&!A|!D3&!D2&D1&D&C1&C&B1&B&A1&!A|!D3&!D2&D1&!D&C1&C&B1&B&A1&!A|D3&!D2&D1&!D&C1&C&B1&B&A1&!A|D3&D2&D1&!D&C1&C&B1&B&A1&!A|!D3&D2&D1&!D&C1&C&B1&B&A1&!A|!D3&D2&!D1&!D&C1&C&B1&B&A1&!A|D3&D2&!D1&!D&C1&C&B1&B&A1&!A|D3&!D2&!D1&!D&C1&C&B1&B&A1&!A|!D3&!D2&!D1&!D&C1&C&B1&B&A1&!A|!D3&!D2&!D1&!D&C1&!C&B1&B&A1&!A|D3&!D2&!D1&!D&C1&!C&B1&B&A1&!A|D3&D2&!D1&!D&C1&!C&B1&B&A1&!A|!D3&D2&!D1&!D&C1&!C&B1&B&A1&!A|!D3&D2&D1&!D&C1&!C&B1&B&A1&!A|D3&D2&D1&!D&C1&!C&B1&B&A1&!A|D3&!D2&D1&!D&C1&!C&B1&B&A1&!A|!D3&!D2&D1&!D&C1&!C&B1&B&A1&!A|!D3&!D2&D1&D&C1&!C&B1&B&A1&!A|D3&!D2&D1&D&C1&!C&B1&B&A1&!A|D3&D2&D1&D&C1&!C&B1&B&A1&!A|!D3&D2&D1&D&C1&!C&B1&B&A1&!A|!D3&D2&!D1&D&C1&!C&B1&B&A1&!A|D3&D2&!D1&D&C1&!C&B1&B&A1&!A|D3&!D2&!D1&D&C1&!C&B1&B&A1&!A|!D3&!D2&!D1&D&C1&!C&B1&B&A1&!A|D3&D2&D1&D&!C1&!C&B1&B&A1&!A|D3&D2&D1&D&!C1&!C&B1&!B&A1&!A|!D3&!D2&!D1&D&C1&!C&B1&!B&A1&!A|D3&!D2&!D1&D&C1&!C&B1&!B&A1&!A|D3&D2&!D1&D&C1&!C&B1&!B&A1&!A|!D3&D2&!D1&D&C1&!C&B1&!B&A1&!A|!D3&D2&D1&D&C1&!C&B1&!B&A1&!A|D3&D2&D1&D&C1&!C&B1&!B&A1&!A|D3&!D2&D1&D&C1&!C&B1&!B&A1&!A|!D3&!D2&D1&D&C1&!C&B1&!B&A1&!A|!D3&!D2&D1&!D&C1&!C&B1&!B&A1&!A|D3&!D2&D1&!D&C1&!C&B1&!B&A1&!A|D3&D2&D1&!D&C1&!C&B1&!B&A1&!A|!D3&D2&D1&!D&C1&!C&B1&!B&A1&!A|!D3&D2&!D1&!D&C1&!C&B1&!B&A1&!A|D3&D2&!D1&!D&C1&!C&B1&!B&A1&!A|D3&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!D3&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!D3&!D2&!D1&!D&C1&C&B1&!B&A1&!A|D3&!D2&!D1&!D&C1&C&B1&!B&A1&!A|D3&D2&!D1&!D&C1&C&B1&!B&A1&!A|!D3&D2&!D1&!D&C1&C&B1&!B&A1&!A|!D3&D2&D1&!D&C1&C&B1&!B&A1&!A|D3&D2&D1&!D&C1&C&B1&!B&A1&!A|D3&!D2&D1&!D&C1&C&B1&!B&A1&!A|!D3&!D2&D1&!D&C1&C&B1&!B&A1&!A|!D3&!D2&D1&D&C1&C&B1&!B&A1&!A|D3&!D2&D1&D&C1&C&B1&!B&A1&!A|D3&D2&D1&D&C1&C&B1&!B&A1&!A|!D3&D2&D1&D&C1&C&B1&!B&A1&!A|!D3&D2&!D1&D&C1&C&B1&!B&A1&!A|D3&D2&!D1&D&C1&C&B1&!B&A1&!A|D3&!D2&!D1&D&C1&C&B1&!B&A1&!A|!D3&!D2&!D1&D&C1&C&B1&!B&A1&!A|!D3&!D2&!D1&D&!C1&C&B1&!B&A1&!A|D3&!D2&!D1&D&!C1&C&B1&!B&A1&!A|D3&D2&!D1&D&!C1&C&B1&!B&A1&!A|!D3&D2&!D1&D&!C1&C&B1&!B&A1&!A|!D3&D2&D1&D&!C1&C&B1&!B&A1&!A|D3&D2&D1&D&!C1&C&B1&!B&A1&!A|D3&!D2&D1&D&!C1&C&B1&!B&A1&!A|!D3&!D2&D1&D&!C1&C&B1&!B&A1&!A|!D3&!D2&D1&!D&!C1&C&B1&!B&A1&!A|D3&!D2&D1&!D&!C1&C&B1&!B&A1&!A|D3&D2&D1&!D&!C1&C&B1&!B&A1&!A|!D3&D2&D1&!D&!C1&C&B1&!B&A1&!A|!D3&D2&!D1&!D&!C1&C&B1&!B&A1&!A|D3&D2&!D1&!D&!C1&C&B1&!B&A1&!A|D3&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!D3&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|D3&D2&D1&D&!C1&C&!B1&!B&A1&!A|D3&D2&D1&D&C1&C&!B1&!B&A1&!A|D3&D2&D1&D&C1&!C&!B1&!B&A1&!A|D3&D2&D1&D&!C1&!C&!B1&!B&A1&!A|D3&D2&D1&D&!C1&!C&!B1&!B&A1&A|D3&D2&D1&D&C1&!C&!B1&!B&A1&A|D3&D2&D1&D&C1&C&!B1&!B&A1&A|D3&D2&D1&D&!C1&C&!B1&!B&A1&A|!D3&!D2&!D1&!D&!C1&C&B1&!B&A1&A|D3&!D2&!D1&!D&!C1&C&B1&!B&A1&A|D3&D2&!D1&!D&!C1&C&B1&!B&A1&A|!D3&D2&!D1&!D&!C1&C&B1&!B&A1&A|!D3&D2&D1&!D&!C1&C&B1&!B&A1&A|D3&D2&D1&!D&!C1&C&B1&!B&A1&A|D3&!D2&D1&!D&!C1&C&B1&!B&A1&A|!D3&!D2&D1&!D&!C1&C&B1&!B&A1&A|!D3&!D2&D1&D&!C1&C&B1&!B&A1&A|D3&!D2&D1&D&!C1&C&B1&!B&A1&A|D3&D2&D1&D&!C1&C&B1&!B&A1&A|!D3&D2&D1&D&!C1&C&B1&!B&A1&A|!D3&D2&!D1&D&!C1&C&B1&!B&A1&A|D3&D2&!D1&D&!C1&C&B1&!B&A1&A|D3&!D2&!D1&D&!C1&C&B1&!B&A1&A|!D3&!D2&!D1&D&!C1&C&B1&!B&A1&A|!D3&!D2&!D1&D&C1&C&B1&!B&A1&A|D3&!D2&!D1&D&C1&C&B1&!B&A1&A|D3&D2&!D1&D&C1&C&B1&!B&A1&A|!D3&D2&!D1&D&C1&C&B1&!B&A1&A|!D3&D2&D1&D&C1&C&B1&!B&A1&A|D3&D2&D1&D&C1&C&B1&!B&A1&A|D3&!D2&D1&D&C1&C&B1&!B&A1&A|!D3&!D2&D1&D&C1&C&B1&!B&A1&A|!D3&!D2&D1&!D&C1&C&B1&!B&A1&A|D3&!D2&D1&!D&C1&C&B1&!B&A1&A|D3&D2&D1&!D&C1&C&B1&!B&A1&A|!D3&D2&D1&!D&C1&C&B1&!B&A1&A|!D3&D2&!D1&!D&C1&C&B1&!B&A1&A|D3&D2&!D1&!D&C1&C&B1&!B&A1&A|D3&!D2&!D1&!D&C1&C&B1&!B&A1&A|!D3&!D2&!D1&!D&C1&C&B1&!B&A1&A|!D3&!D2&!D1&!D&C1&!C&B1&!B&A1&A|D3&!D2&!D1&!D&C1&!C&B1&!B&A1&A|D3&D2&!D1&!D&C1&!C&B1&!B&A1&A|!D3&D2&!D1&!D&C1&!C&B1&!B&A1&A|!D3&D2&D1&!D&C1&!C&B1&!B&A1&A|D3&D2&D1&!D&C1&!C&B1&!B&A1&A|D3&!D2&D1&!D&C1&!C&B1&!B&A1&A|!D3&!D2&D1&!D&C1&!C&B1&!B&A1&A|!D3&!D2&D1&D&C1&!C&B1&!B&A1&A|D3&!D2&D1&D&C1&!C&B1&!B&A1&A|D3&D2&D1&D&C1&!C&B1&!B&A1&A|!D3&D2&D1&D&C1&!C&B1&!B&A1&A|!D3&D2&!D1&D&C1&!C&B1&!B&A1&A|D3&D2&!D1&D&C1&!C&B1&!B&A1&A|D3&!D2&!D1&D&C1&!C&B1&!B&A1&A|!D3&!D2&!D1&D&C1&!C&B1&!B&A1&A|D3&D2&D1&D&!C1&!C&B1&!B&A1&A|D3&D2&D1&D&!C1&!C&B1&B&A1&A|!D3&!D2&!D1&D&C1&!C&B1&B&A1&A|D3&!D2&!D1&D&C1&!C&B1&B&A1&A|D3&D2&!D1&D&C1&!C&B1&B&A1&A|!D3&D2&!D1&D&C1&!C&B1&B&A1&A|!D3&D2&D1&D&C1&!C&B1&B&A1&A|D3&D2&D1&D&C1&!C&B1&B&A1&A|D3&!D2&D1&D&C1&!C&B1&B&A1&A|!D3&!D2&D1&D&C1&!C&B1&B&A1&A|!D3&!D2&D1&!D&C1&!C&B1&B&A1&A|D3&!D2&D1&!D&C1&!C&B1&B&A1&A|D3&D2&D1&!D&C1&!C&B1&B&A1&A|!D3&D2&D1&!D&C1&!C&B1&B&A1&A|!D3&D2&!D1&!D&C1&!C&B1&B&A1&A|D3&D2&!D1&!D&C1&!C&B1&B&A1&A|D3&!D2&!D1&!D&C1&!C&B1&B&A1&A|!D3&!D2&!D1&!D&C1&!C&B1&B&A1&A|!D3&!D2&!D1&!D&C1&C&B1&B&A1&A|D3&!D2&!D1&!D&C1&C&B1&B&A1&A|D3&D2&!D1&!D&C1&C&B1&B&A1&A|!D3&D2&!D1&!D&C1&C&B1&B&A1&A|!D3&D2&D1&!D&C1&C&B1&B&A1&A|D3&D2&D1&!D&C1&C&B1&B&A1&A|D3&!D2&D1&!D&C1&C&B1&B&A1&A|!D3&!D2&D1&!D&C1&C&B1&B&A1&A|!D3&!D2&D1&D&C1&C&B1&B&A1&A|D3&!D2&D1&D&C1&C&B1&B&A1&A|D3&D2&D1&D&C1&C&B1&B&A1&A|!D3&D2&D1&D&C1&C&B1&B&A1&A|!D3&D2&!D1&D&C1&C&B1&B&A1&A|D3&D2&!D1&D&C1&C&B1&B&A1&A|D3&!D2&!D1&D&C1&C&B1&B&A1&A|!D3&!D2&!D1&D&C1&C&B1&B&A1&A|!D3&!D2&!D1&D&!C1&C&B1&B&A1&A|D3&!D2&!D1&D&!C1&C&B1&B&A1&A|D3&D2&!D1&D&!C1&C&B1&B&A1&A|!D3&D2&!D1&D&!C1&C&B1&B&A1&A|!D3&D2&D1&D&!C1&C&B1&B&A1&A|D3&D2&D1&D&!C1&C&B1&B&A1&A|D3&!D2&D1&D&!C1&C&B1&B&A1&A|!D3&!D2&D1&D&!C1&C&B1&B&A1&A|!D3&!D2&D1&!D&!C1&C&B1&B&A1&A|D3&!D2&D1&!D&!C1&C&B1&B&A1&A|D3&D2&D1&!D&!C1&C&B1&B&A1&A|!D3&D2&D1&!D&!C1&C&B1&B&A1&A|!D3&D2&!D1&!D&!C1&C&B1&B&A1&A|D3&D2&!D1&!D&!C1&C&B1&B&A1&A|D3&!D2&!D1&!D&!C1&C&B1&B&A1&A|!D3&!D2&!D1&!D&!C1&C&B1&B&A1&A|!D3&!D2&!D1&!D&!C1&C&!B1&B&A1&A|D3&!D2&!D1&!D&!C1&C&!B1&B&A1&A|D3&D2&!D1&!D&!C1&C&!B1&B&A1&A|!D3&D2&!D1&!D&!C1&C&!B1&B&A1&A|!D3&D2&D1&!D&!C1&C&!B1&B&A1&A|D3&D2&D1&!D&!C1&C&!B1&B&A1&A|D3&!D2&D1&!D&!C1&C&!B1&B&A1&A|!D3&!D2&D1&!D&!C1&C&!B1&B&A1&A|!D3&!D2&D1&D&!C1&C&!B1&B&A1&A|D3&!D2&D1&D&!C1&C&!B1&B&A1&A|D3&D2&D1&D&!C1&C&!B1&B&A1&A|!D3&D2&D1&D&!C1&C&!B1&B&A1&A|!D3&D2&!D1&D&!C1&C&!B1&B&A1&A|D3&D2&!D1&D&!C1&C&!B1&B&A1&A|D3&!D2&!D1&D&!C1&C&!B1&B&A1&A|!D3&!D2&!D1&D&!C1&C&!B1&B&A1&A|!D3&!D2&!D1&D&C1&C&!B1&B&A1&A|D3&!D2&!D1&D&C1&C&!B1&B&A1&A|D3&D2&!D1&D&C1&C&!B1&B&A1&A|!D3&D2&!D1&D&C1&C&!B1&B&A1&A|!D3&D2&D1&D&C1&C&!B1&B&A1&A|D3&D2&D1&D&C1&C&!B1&B&A1&A|D3&!D2&D1&D&C1&C&!B1&B&A1&A|!D3&!D2&D1&D&C1&C&!B1&B&A1&A|!D3&!D2&D1&!D&C1&C&!B1&B&A1&A|D3&!D2&D1&!D&C1&C&!B1&B&A1&A|D3&D2&D1&!D&C1&C&!B1&B&A1&A|!D3&D2&D1&!D&C1&C&!B1&B&A1&A|!D3&D2&!D1&!D&C1&C&!B1&B&A1&A|D3&D2&!D1&!D&C1&C&!B1&B&A1&A|D3&!D2&!D1&!D&C1&C&!B1&B&A1&A|!D3&!D2&!D1&!D&C1&C&!B1&B&A1&A|!D3&!D2&!D1&!D&C1&!C&!B1&B&A1&A|D3&!D2&!D1&!D&C1&!C&!B1&B&A1&A|D3&D2&!D1&!D&C1&!C&!B1&B&A1&A|!D3&D2&!D1&!D&C1&!C&!B1&B&A1&A|!D3&D2&D1&!D&C1&!C&!B1&B&A1&A|D3&D2&D1&!D&C1&!C&!B1&B&A1&A|D3&!D2&D1&!D&C1&!C&!B1&B&A1&A|!D3&!D2&D1&!D&C1&!C&!B1&B&A1&A|!D3&!D2&D1&D&C1&!C&!B1&B&A1&A|D3&!D2&D1&D&C1&!C&!B1&B&A1&A|D3&D2&D1&D&C1&!C&!B1&B&A1&A|!D3&D2&D1&D&C1&!C&!B1&B&A1&A|!D3&D2&!D1&D&C1&!C&!B1&B&A1&A|D3&D2&!D1&D&C1&!C&!B1&B&A1&A|D3&!D2&!D1&D&C1&!C&!B1&B&A1&A|!D3&!D2&!D1&D&C1&!C&!B1&B&A1&A|D3&D2&D1&D&!C1&!C&!B1&B&A1&A|D3&D2&D1&D&!C1&!C&!B1&B&!A1&A|!D3&!D2&!D1&D&C1&!C&!B1&B&!A1&A|D3&!D2&!D1&D&C1&!C&!B1&B&!A1&A|D3&D2&!D1&D&C1&!C&!B1&B&!A1&A|!D3&D2&!D1&D&C1&!C&!B1&B&!A1&A|!D3&D2&D1&D&C1&!C&!B1&B&!A1&A|D3&D2&D1&D&C1&!C&!B1&B&!A1&A|D3&!D2&D1&D&C1&!C&!B1&B&!A1&A|!D3&!D2&D1&D&C1&!C&!B1&B&!A1&A|!D3&!D2&D1&!D&C1&!C&!B1&B&!A1&A|D3&!D2&D1&!D&C1&!C&!B1&B&!A1&A|D3&D2&D1&!D&C1&!C&!B1&B&!A1&A|!D3&D2&D1&!D&C1&!C&!B1&B&!A1&A|!D3&D2&!D1&!D&C1&!C&!B1&B&!A1&A|D3&D2&!D1&!D&C1&!C&!B1&B&!A1&A|D3&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!D3&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!D3&!D2&!D1&!D&C1&C&!B1&B&!A1&A|D3&!D2&!D1&!D&C1&C&!B1&B&!A1&A|D3&D2&!D1&!D&C1&C&!B1&B&!A1&A|!D3&D2&!D1&!D&C1&C&!B1&B&!A1&A|!D3&D2&D1&!D&C1&C&!B1&B&!A1&A|D3&D2&D1&!D&C1&C&!B1&B&!A1&A|D3&!D2&D1&!D&C1&C&!B1&B&!A1&A|!D3&!D2&D1&!D&C1&C&!B1&B&!A1&A|!D3&!D2&D1&D&C1&C&!B1&B&!A1&A|D3&!D2&D1&D&C1&C&!B1&B&!A1&A|D3&D2&D1&D&C1&C&!B1&B&!A1&A|!D3&D2&D1&D&C1&C&!B1&B&!A1&A|!D3&D2&!D1&D&C1&C&!B1&B&!A1&A|D3&D2&!D1&D&C1&C&!B1&B&!A1&A|D3&!D2&!D1&D&C1&C&!B1&B&!A1&A|!D3&!D2&!D1&D&C1&C&!B1&B&!A1&A|!D3&!D2&!D1&D&!C1&C&!B1&B&!A1&A|D3&!D2&!D1&D&!C1&C&!B1&B&!A1&A|D3&D2&!D1&D&!C1&C&!B1&B&!A1&A|!D3&D2&!D1&D&!C1&C&!B1&B&!A1&A|!D3&D2&D1&D&!C1&C&!B1&B&!A1&A|D3&D2&D1&D&!C1&C&!B1&B&!A1&A|D3&!D2&D1&D&!C1&C&!B1&B&!A1&A|!D3&!D2&D1&D&!C1&C&!B1&B&!A1&A|!D3&!D2&D1&!D&!C1&C&!B1&B&!A1&A|D3&!D2&D1&!D&!C1&C&!B1&B&!A1&A|D3&D2&D1&!D&!C1&C&!B1&B&!A1&A|!D3&D2&D1&!D&!C1&C&!B1&B&!A1&A|!D3&D2&!D1&!D&!C1&C&!B1&B&!A1&A|D3&D2&!D1&!D&!C1&C&!B1&B&!A1&A|D3&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!D3&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!D3&!D2&!D1&!D&!C1&C&B1&B&!A1&A|D3&!D2&!D1&!D&!C1&C&B1&B&!A1&A|D3&D2&!D1&!D&!C1&C&B1&B&!A1&A|!D3&D2&!D1&!D&!C1&C&B1&B&!A1&A|!D3&D2&D1&!D&!C1&C&B1&B&!A1&A|D3&D2&D1&!D&!C1&C&B1&B&!A1&A|D3&!D2&D1&!D&!C1&C&B1&B&!A1&A|!D3&!D2&D1&!D&!C1&C&B1&B&!A1&A|!D3&!D2&D1&D&!C1&C&B1&B&!A1&A|D3&!D2&D1&D&!C1&C&B1&B&!A1&A|D3&D2&D1&D&!C1&C&B1&B&!A1&A|!D3&D2&D1&D&!C1&C&B1&B&!A1&A|!D3&D2&!D1&D&!C1&C&B1&B&!A1&A|D3&D2&!D1&D&!C1&C&B1&B&!A1&A|D3&!D2&!D1&D&!C1&C&B1&B&!A1&A|!D3&!D2&!D1&D&!C1&C&B1&B&!A1&A|!D3&!D2&!D1&D&C1&C&B1&B&!A1&A|D3&!D2&!D1&D&C1&C&B1&B&!A1&A|D3&D2&!D1&D&C1&C&B1&B&!A1&A|!D3&D2&!D1&D&C1&C&B1&B&!A1&A|!D3&D2&D1&D&C1&C&B1&B&!A1&A|D3&D2&D1&D&C1&C&B1&B&!A1&A|D3&!D2&D1&D&C1&C&B1&B&!A1&A|!D3&!D2&D1&D&C1&C&B1&B&!A1&A|!D3&!D2&D1&!D&C1&C&B1&B&!A1&A|D3&!D2&D1&!D&C1&C&B1&B&!A1&A|D3&D2&D1&!D&C1&C&B1&B&!A1&A|!D3&D2&D1&!D&C1&C&B1&B&!A1&A|!D3&D2&!D1&!D&C1&C&B1&B&!A1&A|D3&D2&!D1&!D&C1&C&B1&B&!A1&A|D3&!D2&!D1&!D&C1&C&B1&B&!A1&A|!D3&!D2&!D1&!D&C1&C&B1&B&!A1&A|!D3&!D2&!D1&!D&C1&!C&B1&B&!A1&A|D3&!D2&!D1&!D&C1&!C&B1&B&!A1&A|D3&D2&!D1&!D&C1&!C&B1&B&!A1&A|!D3&D2&!D1&!D&C1&!C&B1&B&!A1&A|!D3&D2&D1&!D&C1&!C&B1&B&!A1&A|D3&D2&D1&!D&C1&!C&B1&B&!A1&A|D3&!D2&D1&!D&C1&!C&B1&B&!A1&A|!D3&!D2&D1&!D&C1&!C&B1&B&!A1&A|!D3&!D2&D1&D&C1&!C&B1&B&!A1&A|D3&!D2&D1&D&C1&!C&B1&B&!A1&A|D3&D2&D1&D&C1&!C&B1&B&!A1&A|!D3&D2&D1&D&C1&!C&B1&B&!A1&A|!D3&D2&!D1&D&C1&!C&B1&B&!A1&A|D3&D2&!D1&D&C1&!C&B1&B&!A1&A|D3&!D2&!D1&D&C1&!C&B1&B&!A1&A|!D3&!D2&!D1&D&C1&!C&B1&B&!A1&A|D3&D2&D1&D&!C1&!C&B1&B&!A1&A|D3&D2&D1&D&!C1&!C&B1&!B&!A1&A|!D3&!D2&!D1&D&C1&!C&B1&!B&!A1&A|D3&!D2&!D1&D&C1&!C&B1&!B&!A1&A|D3&D2&!D1&D&C1&!C&B1&!B&!A1&A|!D3&D2&!D1&D&C1&!C&B1&!B&!A1&A|!D3&D2&D1&D&C1&!C&B1&!B&!A1&A|D3&D2&D1&D&C1&!C&B1&!B&!A1&A|D3&!D2&D1&D&C1&!C&B1&!B&!A1&A|!D3&!D2&D1&D&C1&!C&B1&!B&!A1&A|!D3&!D2&D1&!D&C1&!C&B1&!B&!A1&A|D3&!D2&D1&!D&C1&!C&B1&!B&!A1&A|D3&D2&D1&!D&C1&!C&B1&!B&!A1&A|!D3&D2&D1&!D&C1&!C&B1&!B&!A1&A|!D3&D2&!D1&!D&C1&!C&B1&!B&!A1&A|D3&D2&!D1&!D&C1&!C&B1&!B&!A1&A|D3&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!D3&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!D3&!D2&!D1&!D&C1&C&B1&!B&!A1&A|D3&!D2&!D1&!D&C1&C&B1&!B&!A1&A|D3&D2&!D1&!D&C1&C&B1&!B&!A1&A|!D3&D2&!D1&!D&C1&C&B1&!B&!A1&A|!D3&D2&D1&!D&C1&C&B1&!B&!A1&A|D3&D2&D1&!D&C1&C&B1&!B&!A1&A|D3&!D2&D1&!D&C1&C&B1&!B&!A1&A|!D3&!D2&D1&!D&C1&C&B1&!B&!A1&A|!D3&!D2&D1&D&C1&C&B1&!B&!A1&A|D3&!D2&D1&D&C1&C&B1&!B&!A1&A|D3&D2&D1&D&C1&C&B1&!B&!A1&A|!D3&D2&D1&D&C1&C&B1&!B&!A1&A|!D3&D2&!D1&D&C1&C&B1&!B&!A1&A|D3&D2&!D1&D&C1&C&B1&!B&!A1&A|D3&!D2&!D1&D&C1&C&B1&!B&!A1&A|!D3&!D2&!D1&D&C1&C&B1&!B&!A1&A|!D3&!D2&!D1&D&!C1&C&B1&!B&!A1&A|D3&!D2&!D1&D&!C1&C&B1&!B&!A1&A|D3&D2&!D1&D&!C1&C&B1&!B&!A1&A|!D3&D2&!D1&D&!C1&C&B1&!B&!A1&A|!D3&D2&D1&D&!C1&C&B1&!B&!A1&A|D3&D2&D1&D&!C1&C&B1&!B&!A1&A|D3&!D2&D1&D&!C1&C&B1&!B&!A1&A|!D3&!D2&D1&D&!C1&C&B1&!B&!A1&A|!D3&!D2&D1&!D&!C1&C&B1&!B&!A1&A|D3&!D2&D1&!D&!C1&C&B1&!B&!A1&A|D3&D2&D1&!D&!C1&C&B1&!B&!A1&A|!D3&D2&D1&!D&!C1&C&B1&!B&!A1&A|!D3&D2&!D1&!D&!C1&C&B1&!B&!A1&A|D3&D2&!D1&!D&!C1&C&B1&!B&!A1&A|D3&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!D3&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|D3&D2&D1&D&!C1&C&!B1&!B&!A1&A|D3&D2&D1&D&C1&C&!B1&!B&!A1&A|D3&D2&D1&D&C1&!C&!B1&!B&!A1&A|D3&D2&D1&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAAOI2224.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAI2221 -l AOOAI2221 -i D C1 C B1 B A1 A -o Y -f Y=!(D&!C1&C&B1&!B&!A1&!A|D&C1&C&B1&!B&!A1&!A|D&C1&!C&B1&!B&!A1&!A|D&C1&!C&B1&B&!A1&!A|D&C1&C&B1&B&!A1&!A|D&!C1&C&B1&B&!A1&!A|D&!C1&C&!B1&B&!A1&!A|D&C1&C&!B1&B&!A1&!A|D&C1&!C&!B1&B&!A1&!A|D&C1&!C&!B1&B&A1&!A|D&C1&C&!B1&B&A1&!A|D&!C1&C&!B1&B&A1&!A|D&!C1&C&B1&B&A1&!A|D&C1&C&B1&B&A1&!A|D&C1&!C&B1&B&A1&!A|D&C1&!C&B1&!B&A1&!A|D&C1&C&B1&!B&A1&!A|D&!C1&C&B1&!B&A1&!A|D&C1&!C&!B1&!B&A1&A|D&C1&C&!B1&!B&A1&A|D&!C1&C&!B1&!B&A1&A|D&!C1&C&B1&!B&A1&A|D&C1&C&B1&!B&A1&A|D&C1&!C&B1&!B&A1&A|D&C1&!C&B1&B&A1&A|D&C1&C&B1&B&A1&A|D&!C1&C&B1&B&A1&A|D&!C1&C&!B1&B&A1&A|D&C1&C&!B1&B&A1&A|D&C1&!C&!B1&B&A1&A|D&C1&!C&!B1&B&!A1&A|D&C1&C&!B1&B&!A1&A|D&!C1&C&!B1&B&!A1&A|D&!C1&C&B1&B&!A1&A|D&C1&C&B1&B&!A1&A|D&C1&!C&B1&B&!A1&A|D&C1&!C&B1&!B&!A1&A|D&C1&C&B1&!B&!A1&A|D&!C1&C&B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAI2221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAAAOI22222 -l AAOOAAAOI22222 -i E1 E D1 D C1 C B1 B A1 A -o Y -f Y=(!E1&!E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&D1&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D1&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&!D1&D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D1&D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D1&D&C1&!C&!B1&!B&!A1&!A|!E1&!E&D1&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&E&D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D1&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&!D1&!D&C1&C&!B1&!B&!A1&!A|!E1&E&!D1&!D&C1&C&!B1&!B&!A1&!A|!E1&E&D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&D1&!D&C1&C&!B1&!B&!A1&!A|!E1&!E&D1&!D&C1&C&!B1&!B&!A1&!A|!E1&E&!D1&D&C1&C&!B1&!B&!A1&!A|E1&!E&!D1&D&C1&C&!B1&!B&!A1&!A|!E1&!E&!D1&D&C1&C&!B1&!B&!A1&!A|!E1&!E&!D1&D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D1&D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D1&D&!C1&C&!B1&!B&!A1&!A|!E1&!E&D1&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&E&D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D1&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&!C1&C&B1&!B&!A1&!A|E1&!E&!D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&!D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&D1&!D&!C1&C&B1&!B&!A1&!A|E1&!E&D1&!D&!C1&C&B1&!B&!A1&!A|!E1&!E&D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&!D1&D&!C1&C&B1&!B&!A1&!A|E1&!E&!D1&D&!C1&C&B1&!B&!A1&!A|!E1&!E&!D1&D&!C1&C&B1&!B&!A1&!A|!E1&!E&!D1&D&C1&C&B1&!B&!A1&!A|E1&!E&!D1&D&C1&C&B1&!B&!A1&!A|!E1&E&!D1&D&C1&C&B1&!B&!A1&!A|!E1&!E&D1&!D&C1&C&B1&!B&!A1&!A|E1&!E&D1&!D&C1&C&B1&!B&!A1&!A|!E1&E&D1&!D&C1&C&B1&!B&!A1&!A|!E1&E&!D1&!D&C1&C&B1&!B&!A1&!A|E1&!E&!D1&!D&C1&C&B1&!B&!A1&!A|!E1&!E&!D1&!D&C1&C&B1&!B&!A1&!A|!E1&!E&!D1&!D&C1&!C&B1&!B&!A1&!A|E1&!E&!D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&!D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&D1&!D&C1&!C&B1&!B&!A1&!A|E1&!E&D1&!D&C1&!C&B1&!B&!A1&!A|!E1&!E&D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&!D1&D&C1&!C&B1&!B&!A1&!A|E1&!E&!D1&D&C1&!C&B1&!B&!A1&!A|!E1&!E&!D1&D&C1&!C&B1&!B&!A1&!A|!E1&!E&!D1&D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D1&D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D1&D&!C1&!C&B1&!B&!A1&!A|!E1&!E&D1&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&E&D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D1&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&B1&B&!A1&!A|E1&!E&!D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&!D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&D1&!D&!C1&!C&B1&B&!A1&!A|E1&!E&D1&!D&!C1&!C&B1&B&!A1&!A|!E1&!E&D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&!D1&D&!C1&!C&B1&B&!A1&!A|E1&!E&!D1&D&!C1&!C&B1&B&!A1&!A|!E1&!E&!D1&D&!C1&!C&B1&B&!A1&!A|!E1&!E&!D1&!D&!C1&C&!B1&B&!A1&!A|E1&!E&!D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&!D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&D1&!D&!C1&C&!B1&B&!A1&!A|E1&!E&D1&!D&!C1&C&!B1&B&!A1&!A|!E1&!E&D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&!D1&D&!C1&C&!B1&B&!A1&!A|E1&!E&!D1&D&!C1&C&!B1&B&!A1&!A|!E1&!E&!D1&D&!C1&C&!B1&B&!A1&!A|!E1&!E&!D1&D&C1&C&!B1&B&!A1&!A|E1&!E&!D1&D&C1&C&!B1&B&!A1&!A|!E1&E&!D1&D&C1&C&!B1&B&!A1&!A|!E1&!E&D1&!D&C1&C&!B1&B&!A1&!A|E1&!E&D1&!D&C1&C&!B1&B&!A1&!A|!E1&E&D1&!D&C1&C&!B1&B&!A1&!A|!E1&E&!D1&!D&C1&C&!B1&B&!A1&!A|E1&!E&!D1&!D&C1&C&!B1&B&!A1&!A|!E1&!E&!D1&!D&C1&C&!B1&B&!A1&!A|!E1&!E&!D1&!D&C1&!C&!B1&B&!A1&!A|E1&!E&!D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&!D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&D1&!D&C1&!C&!B1&B&!A1&!A|E1&!E&D1&!D&C1&!C&!B1&B&!A1&!A|!E1&!E&D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&!D1&D&C1&!C&!B1&B&!A1&!A|E1&!E&!D1&D&C1&!C&!B1&B&!A1&!A|!E1&!E&!D1&D&C1&!C&!B1&B&!A1&!A|!E1&!E&!D1&D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D1&D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D1&D&!C1&!C&!B1&B&!A1&!A|!E1&!E&D1&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&E&D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D1&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&!D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&!D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&D1&!D&!C1&!C&!B1&B&A1&!A|!E1&!E&D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&!D1&D&!C1&!C&!B1&B&A1&!A|E1&!E&!D1&D&!C1&!C&!B1&B&A1&!A|!E1&!E&!D1&D&!C1&!C&!B1&B&A1&!A|!E1&!E&!D1&D&C1&!C&!B1&B&A1&!A|E1&!E&!D1&D&C1&!C&!B1&B&A1&!A|!E1&E&!D1&D&C1&!C&!B1&B&A1&!A|!E1&!E&D1&!D&C1&!C&!B1&B&A1&!A|E1&!E&D1&!D&C1&!C&!B1&B&A1&!A|!E1&E&D1&!D&C1&!C&!B1&B&A1&!A|!E1&E&!D1&!D&C1&!C&!B1&B&A1&!A|E1&!E&!D1&!D&C1&!C&!B1&B&A1&!A|!E1&!E&!D1&!D&C1&!C&!B1&B&A1&!A|!E1&!E&!D1&!D&C1&C&!B1&B&A1&!A|E1&!E&!D1&!D&C1&C&!B1&B&A1&!A|!E1&E&!D1&!D&C1&C&!B1&B&A1&!A|!E1&E&D1&!D&C1&C&!B1&B&A1&!A|E1&!E&D1&!D&C1&C&!B1&B&A1&!A|!E1&!E&D1&!D&C1&C&!B1&B&A1&!A|!E1&E&!D1&D&C1&C&!B1&B&A1&!A|E1&!E&!D1&D&C1&C&!B1&B&A1&!A|!E1&!E&!D1&D&C1&C&!B1&B&A1&!A|!E1&!E&!D1&D&!C1&C&!B1&B&A1&!A|E1&!E&!D1&D&!C1&C&!B1&B&A1&!A|!E1&E&!D1&D&!C1&C&!B1&B&A1&!A|!E1&!E&D1&!D&!C1&C&!B1&B&A1&!A|E1&!E&D1&!D&!C1&C&!B1&B&A1&!A|!E1&E&D1&!D&!C1&C&!B1&B&A1&!A|!E1&E&!D1&!D&!C1&C&!B1&B&A1&!A|E1&!E&!D1&!D&!C1&C&!B1&B&A1&!A|!E1&!E&!D1&!D&!C1&C&!B1&B&A1&!A|!E1&!E&!D1&D&!C1&!C&B1&B&A1&!A|E1&!E&!D1&D&!C1&!C&B1&B&A1&!A|!E1&E&!D1&D&!C1&!C&B1&B&A1&!A|!E1&!E&D1&!D&!C1&!C&B1&B&A1&!A|E1&!E&D1&!D&!C1&!C&B1&B&A1&!A|!E1&E&D1&!D&!C1&!C&B1&B&A1&!A|!E1&E&!D1&!D&!C1&!C&B1&B&A1&!A|E1&!E&!D1&!D&!C1&!C&B1&B&A1&!A|!E1&!E&!D1&!D&!C1&!C&B1&B&A1&!A|!E1&!E&!D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&!D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&!D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&D1&!D&!C1&!C&B1&!B&A1&!A|!E1&!E&D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&!D1&D&!C1&!C&B1&!B&A1&!A|E1&!E&!D1&D&!C1&!C&B1&!B&A1&!A|!E1&!E&!D1&D&!C1&!C&B1&!B&A1&!A|!E1&!E&!D1&D&C1&!C&B1&!B&A1&!A|E1&!E&!D1&D&C1&!C&B1&!B&A1&!A|!E1&E&!D1&D&C1&!C&B1&!B&A1&!A|!E1&!E&D1&!D&C1&!C&B1&!B&A1&!A|E1&!E&D1&!D&C1&!C&B1&!B&A1&!A|!E1&E&D1&!D&C1&!C&B1&!B&A1&!A|!E1&E&!D1&!D&C1&!C&B1&!B&A1&!A|E1&!E&!D1&!D&C1&!C&B1&!B&A1&!A|!E1&!E&!D1&!D&C1&!C&B1&!B&A1&!A|!E1&!E&!D1&!D&C1&C&B1&!B&A1&!A|E1&!E&!D1&!D&C1&C&B1&!B&A1&!A|!E1&E&!D1&!D&C1&C&B1&!B&A1&!A|!E1&E&D1&!D&C1&C&B1&!B&A1&!A|E1&!E&D1&!D&C1&C&B1&!B&A1&!A|!E1&!E&D1&!D&C1&C&B1&!B&A1&!A|!E1&E&!D1&D&C1&C&B1&!B&A1&!A|E1&!E&!D1&D&C1&C&B1&!B&A1&!A|!E1&!E&!D1&D&C1&C&B1&!B&A1&!A|!E1&!E&!D1&D&!C1&C&B1&!B&A1&!A|E1&!E&!D1&D&!C1&C&B1&!B&A1&!A|!E1&E&!D1&D&!C1&C&B1&!B&A1&!A|!E1&!E&D1&!D&!C1&C&B1&!B&A1&!A|E1&!E&D1&!D&!C1&C&B1&!B&A1&!A|!E1&E&D1&!D&!C1&C&B1&!B&A1&!A|!E1&E&!D1&!D&!C1&C&B1&!B&A1&!A|E1&!E&!D1&!D&!C1&C&B1&!B&A1&!A|!E1&!E&!D1&!D&!C1&C&B1&!B&A1&!A|!E1&!E&!D1&!D&!C1&C&!B1&!B&A1&!A|E1&!E&!D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&!D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&D1&!D&!C1&C&!B1&!B&A1&!A|E1&!E&D1&!D&!C1&C&!B1&!B&A1&!A|!E1&!E&D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&!D1&D&!C1&C&!B1&!B&A1&!A|E1&!E&!D1&D&!C1&C&!B1&!B&A1&!A|!E1&!E&!D1&D&!C1&C&!B1&!B&A1&!A|!E1&!E&!D1&D&C1&C&!B1&!B&A1&!A|E1&!E&!D1&D&C1&C&!B1&!B&A1&!A|!E1&E&!D1&D&C1&C&!B1&!B&A1&!A|!E1&!E&D1&!D&C1&C&!B1&!B&A1&!A|E1&!E&D1&!D&C1&C&!B1&!B&A1&!A|!E1&E&D1&!D&C1&C&!B1&!B&A1&!A|!E1&E&!D1&!D&C1&C&!B1&!B&A1&!A|E1&!E&!D1&!D&C1&C&!B1&!B&A1&!A|!E1&!E&!D1&!D&C1&C&!B1&!B&A1&!A|!E1&!E&!D1&!D&C1&!C&!B1&!B&A1&!A|E1&!E&!D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&!D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&D1&!D&C1&!C&!B1&!B&A1&!A|E1&!E&D1&!D&C1&!C&!B1&!B&A1&!A|!E1&!E&D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&!D1&D&C1&!C&!B1&!B&A1&!A|E1&!E&!D1&D&C1&!C&!B1&!B&A1&!A|!E1&!E&!D1&D&C1&!C&!B1&!B&A1&!A|!E1&!E&!D1&D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D1&D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D1&D&!C1&!C&!B1&!B&A1&!A|!E1&!E&D1&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&E&D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D1&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D1&!D&!C1&!C&!B1&!B&A1&A|E1&!E&!D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&!D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&D1&!D&!C1&!C&!B1&!B&A1&A|E1&!E&D1&!D&!C1&!C&!B1&!B&A1&A|!E1&!E&D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&!D1&D&!C1&!C&!B1&!B&A1&A|E1&!E&!D1&D&!C1&!C&!B1&!B&A1&A|!E1&!E&!D1&D&!C1&!C&!B1&!B&A1&A|!E1&!E&!D1&D&!C1&!C&B1&!B&A1&A|E1&!E&!D1&D&!C1&!C&B1&!B&A1&A|!E1&E&!D1&D&!C1&!C&B1&!B&A1&A|!E1&!E&D1&!D&!C1&!C&B1&!B&A1&A|E1&!E&D1&!D&!C1&!C&B1&!B&A1&A|!E1&E&D1&!D&!C1&!C&B1&!B&A1&A|!E1&E&!D1&!D&!C1&!C&B1&!B&A1&A|E1&!E&!D1&!D&!C1&!C&B1&!B&A1&A|!E1&!E&!D1&!D&!C1&!C&B1&!B&A1&A|!E1&!E&!D1&!D&!C1&!C&B1&B&A1&A|E1&!E&!D1&!D&!C1&!C&B1&B&A1&A|!E1&E&!D1&!D&!C1&!C&B1&B&A1&A|!E1&E&D1&!D&!C1&!C&B1&B&A1&A|E1&!E&D1&!D&!C1&!C&B1&B&A1&A|!E1&!E&D1&!D&!C1&!C&B1&B&A1&A|!E1&E&!D1&D&!C1&!C&B1&B&A1&A|E1&!E&!D1&D&!C1&!C&B1&B&A1&A|!E1&!E&!D1&D&!C1&!C&B1&B&A1&A|!E1&!E&!D1&D&!C1&!C&!B1&B&A1&A|E1&!E&!D1&D&!C1&!C&!B1&B&A1&A|!E1&E&!D1&D&!C1&!C&!B1&B&A1&A|!E1&!E&D1&!D&!C1&!C&!B1&B&A1&A|E1&!E&D1&!D&!C1&!C&!B1&B&A1&A|!E1&E&D1&!D&!C1&!C&!B1&B&A1&A|!E1&E&!D1&!D&!C1&!C&!B1&B&A1&A|E1&!E&!D1&!D&!C1&!C&!B1&B&A1&A|!E1&!E&!D1&!D&!C1&!C&!B1&B&A1&A|!E1&!E&!D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&!D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&!D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&D1&!D&!C1&!C&!B1&B&!A1&A|!E1&!E&D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&!D1&D&!C1&!C&!B1&B&!A1&A|E1&!E&!D1&D&!C1&!C&!B1&B&!A1&A|!E1&!E&!D1&D&!C1&!C&!B1&B&!A1&A|!E1&!E&!D1&D&C1&!C&!B1&B&!A1&A|E1&!E&!D1&D&C1&!C&!B1&B&!A1&A|!E1&E&!D1&D&C1&!C&!B1&B&!A1&A|!E1&!E&D1&!D&C1&!C&!B1&B&!A1&A|E1&!E&D1&!D&C1&!C&!B1&B&!A1&A|!E1&E&D1&!D&C1&!C&!B1&B&!A1&A|!E1&E&!D1&!D&C1&!C&!B1&B&!A1&A|E1&!E&!D1&!D&C1&!C&!B1&B&!A1&A|!E1&!E&!D1&!D&C1&!C&!B1&B&!A1&A|!E1&!E&!D1&!D&C1&C&!B1&B&!A1&A|E1&!E&!D1&!D&C1&C&!B1&B&!A1&A|!E1&E&!D1&!D&C1&C&!B1&B&!A1&A|!E1&E&D1&!D&C1&C&!B1&B&!A1&A|E1&!E&D1&!D&C1&C&!B1&B&!A1&A|!E1&!E&D1&!D&C1&C&!B1&B&!A1&A|!E1&E&!D1&D&C1&C&!B1&B&!A1&A|E1&!E&!D1&D&C1&C&!B1&B&!A1&A|!E1&!E&!D1&D&C1&C&!B1&B&!A1&A|!E1&!E&!D1&D&!C1&C&!B1&B&!A1&A|E1&!E&!D1&D&!C1&C&!B1&B&!A1&A|!E1&E&!D1&D&!C1&C&!B1&B&!A1&A|!E1&!E&D1&!D&!C1&C&!B1&B&!A1&A|E1&!E&D1&!D&!C1&C&!B1&B&!A1&A|!E1&E&D1&!D&!C1&C&!B1&B&!A1&A|!E1&E&!D1&!D&!C1&C&!B1&B&!A1&A|E1&!E&!D1&!D&!C1&C&!B1&B&!A1&A|!E1&!E&!D1&!D&!C1&C&!B1&B&!A1&A|!E1&!E&!D1&D&!C1&!C&B1&B&!A1&A|E1&!E&!D1&D&!C1&!C&B1&B&!A1&A|!E1&E&!D1&D&!C1&!C&B1&B&!A1&A|!E1&!E&D1&!D&!C1&!C&B1&B&!A1&A|E1&!E&D1&!D&!C1&!C&B1&B&!A1&A|!E1&E&D1&!D&!C1&!C&B1&B&!A1&A|!E1&E&!D1&!D&!C1&!C&B1&B&!A1&A|E1&!E&!D1&!D&!C1&!C&B1&B&!A1&A|!E1&!E&!D1&!D&!C1&!C&B1&B&!A1&A|!E1&!E&!D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&!D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&!D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&D1&!D&!C1&!C&B1&!B&!A1&A|!E1&!E&D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&!D1&D&!C1&!C&B1&!B&!A1&A|E1&!E&!D1&D&!C1&!C&B1&!B&!A1&A|!E1&!E&!D1&D&!C1&!C&B1&!B&!A1&A|!E1&!E&!D1&D&C1&!C&B1&!B&!A1&A|E1&!E&!D1&D&C1&!C&B1&!B&!A1&A|!E1&E&!D1&D&C1&!C&B1&!B&!A1&A|!E1&!E&D1&!D&C1&!C&B1&!B&!A1&A|E1&!E&D1&!D&C1&!C&B1&!B&!A1&A|!E1&E&D1&!D&C1&!C&B1&!B&!A1&A|!E1&E&!D1&!D&C1&!C&B1&!B&!A1&A|E1&!E&!D1&!D&C1&!C&B1&!B&!A1&A|!E1&!E&!D1&!D&C1&!C&B1&!B&!A1&A|!E1&!E&!D1&!D&C1&C&B1&!B&!A1&A|E1&!E&!D1&!D&C1&C&B1&!B&!A1&A|!E1&E&!D1&!D&C1&C&B1&!B&!A1&A|!E1&E&D1&!D&C1&C&B1&!B&!A1&A|E1&!E&D1&!D&C1&C&B1&!B&!A1&A|!E1&!E&D1&!D&C1&C&B1&!B&!A1&A|!E1&E&!D1&D&C1&C&B1&!B&!A1&A|E1&!E&!D1&D&C1&C&B1&!B&!A1&A|!E1&!E&!D1&D&C1&C&B1&!B&!A1&A|!E1&!E&!D1&D&!C1&C&B1&!B&!A1&A|E1&!E&!D1&D&!C1&C&B1&!B&!A1&A|!E1&E&!D1&D&!C1&C&B1&!B&!A1&A|!E1&!E&D1&!D&!C1&C&B1&!B&!A1&A|E1&!E&D1&!D&!C1&C&B1&!B&!A1&A|!E1&E&D1&!D&!C1&C&B1&!B&!A1&A|!E1&E&!D1&!D&!C1&C&B1&!B&!A1&A|E1&!E&!D1&!D&!C1&C&B1&!B&!A1&A|!E1&!E&!D1&!D&!C1&C&B1&!B&!A1&A|!E1&!E&!D1&!D&!C1&C&!B1&!B&!A1&A|E1&!E&!D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&!D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&D1&!D&!C1&C&!B1&!B&!A1&A|E1&!E&D1&!D&!C1&C&!B1&!B&!A1&A|!E1&!E&D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&!D1&D&!C1&C&!B1&!B&!A1&A|E1&!E&!D1&D&!C1&C&!B1&!B&!A1&A|!E1&!E&!D1&D&!C1&C&!B1&!B&!A1&A|!E1&!E&!D1&D&C1&C&!B1&!B&!A1&A|E1&!E&!D1&D&C1&C&!B1&!B&!A1&A|!E1&E&!D1&D&C1&C&!B1&!B&!A1&A|!E1&!E&D1&!D&C1&C&!B1&!B&!A1&A|E1&!E&D1&!D&C1&C&!B1&!B&!A1&A|!E1&E&D1&!D&C1&C&!B1&!B&!A1&A|!E1&E&!D1&!D&C1&C&!B1&!B&!A1&A|E1&!E&!D1&!D&C1&C&!B1&!B&!A1&A|!E1&!E&!D1&!D&C1&C&!B1&!B&!A1&A|!E1&!E&!D1&!D&C1&!C&!B1&!B&!A1&A|E1&!E&!D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&!D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&D1&!D&C1&!C&!B1&!B&!A1&A|E1&!E&D1&!D&C1&!C&!B1&!B&!A1&A|!E1&!E&D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&!D1&D&C1&!C&!B1&!B&!A1&A|E1&!E&!D1&D&C1&!C&!B1&!B&!A1&A|!E1&!E&!D1&D&C1&!C&!B1&!B&!A1&A|!E1&!E&!D1&D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D1&D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D1&D&!C1&!C&!B1&!B&!A1&A|!E1&!E&D1&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&E&D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D1&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&!E&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAAAOI22222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOAOI22211 -l OAAOAOI22211 -i E D C1 C B1 B A1 A -o Y -f Y=(!E&!D&!C1&!C&!B1&!B&!A1&!A|!E&D&!C1&!C&!B1&!B&!A1&!A|!E&D&C1&!C&!B1&!B&!A1&!A|!E&!D&C1&!C&!B1&!B&!A1&!A|!E&!D&C1&C&!B1&!B&!A1&!A|!E&D&!C1&C&!B1&!B&!A1&!A|!E&!D&!C1&C&!B1&!B&!A1&!A|!E&!D&!C1&C&B1&!B&!A1&!A|!E&D&!C1&C&B1&!B&!A1&!A|!E&!D&C1&C&B1&!B&!A1&!A|!E&!D&C1&!C&B1&!B&!A1&!A|!E&D&C1&!C&B1&!B&!A1&!A|!E&D&!C1&!C&B1&!B&!A1&!A|!E&!D&!C1&!C&B1&!B&!A1&!A|!E&!D&!C1&!C&B1&B&!A1&!A|!E&D&!C1&!C&B1&B&!A1&!A|!E&D&C1&!C&B1&B&!A1&!A|!E&!D&C1&!C&B1&B&!A1&!A|!E&!D&C1&C&B1&B&!A1&!A|!E&D&!C1&C&B1&B&!A1&!A|!E&!D&!C1&C&B1&B&!A1&!A|!E&!D&!C1&C&!B1&B&!A1&!A|!E&D&!C1&C&!B1&B&!A1&!A|!E&!D&C1&C&!B1&B&!A1&!A|!E&!D&C1&!C&!B1&B&!A1&!A|!E&D&C1&!C&!B1&B&!A1&!A|!E&D&!C1&!C&!B1&B&!A1&!A|!E&!D&!C1&!C&!B1&B&!A1&!A|!E&!D&!C1&!C&!B1&B&A1&!A|!E&D&!C1&!C&!B1&B&A1&!A|!E&D&C1&!C&!B1&B&A1&!A|!E&!D&C1&!C&!B1&B&A1&!A|!E&!D&C1&C&!B1&B&A1&!A|!E&D&!C1&C&!B1&B&A1&!A|!E&!D&!C1&C&!B1&B&A1&!A|!E&!D&!C1&C&B1&B&A1&!A|!E&!D&C1&C&B1&B&A1&!A|!E&!D&C1&!C&B1&B&A1&!A|!E&!D&!C1&!C&B1&B&A1&!A|!E&!D&!C1&!C&B1&!B&A1&!A|!E&D&!C1&!C&B1&!B&A1&!A|!E&D&C1&!C&B1&!B&A1&!A|!E&!D&C1&!C&B1&!B&A1&!A|!E&!D&C1&C&B1&!B&A1&!A|!E&D&!C1&C&B1&!B&A1&!A|!E&!D&!C1&C&B1&!B&A1&!A|!E&!D&!C1&C&!B1&!B&A1&!A|!E&D&!C1&C&!B1&!B&A1&!A|!E&!D&C1&C&!B1&!B&A1&!A|!E&!D&C1&!C&!B1&!B&A1&!A|!E&D&C1&!C&!B1&!B&A1&!A|!E&D&!C1&!C&!B1&!B&A1&!A|!E&!D&!C1&!C&!B1&!B&A1&!A|!E&!D&!C1&!C&!B1&!B&A1&A|!E&D&!C1&!C&!B1&!B&A1&A|!E&D&C1&!C&!B1&!B&A1&A|!E&!D&C1&!C&!B1&!B&A1&A|!E&!D&C1&C&!B1&!B&A1&A|!E&D&!C1&C&!B1&!B&A1&A|!E&!D&!C1&C&!B1&!B&A1&A|!E&!D&!C1&C&B1&!B&A1&A|!E&D&!C1&C&B1&!B&A1&A|!E&!D&C1&C&B1&!B&A1&A|!E&!D&C1&!C&B1&!B&A1&A|!E&D&C1&!C&B1&!B&A1&A|!E&D&!C1&!C&B1&!B&A1&A|!E&!D&!C1&!C&B1&!B&A1&A|!E&!D&!C1&!C&B1&B&A1&A|!E&!D&C1&!C&B1&B&A1&A|!E&!D&C1&C&B1&B&A1&A|!E&!D&!C1&C&B1&B&A1&A|!E&!D&!C1&C&!B1&B&A1&A|!E&D&!C1&C&!B1&B&A1&A|!E&!D&C1&C&!B1&B&A1&A|!E&!D&C1&!C&!B1&B&A1&A|!E&D&C1&!C&!B1&B&A1&A|!E&D&!C1&!C&!B1&B&A1&A|!E&!D&!C1&!C&!B1&B&A1&A|!E&!D&!C1&!C&!B1&B&!A1&A|!E&D&!C1&!C&!B1&B&!A1&A|!E&D&C1&!C&!B1&B&!A1&A|!E&!D&C1&!C&!B1&B&!A1&A|!E&!D&C1&C&!B1&B&!A1&A|!E&D&!C1&C&!B1&B&!A1&A|!E&!D&!C1&C&!B1&B&!A1&A|!E&!D&!C1&C&B1&B&!A1&A|!E&!D&C1&C&B1&B&!A1&A|!E&!D&C1&!C&B1&B&!A1&A|!E&!D&!C1&!C&B1&B&!A1&A|!E&!D&!C1&!C&B1&!B&!A1&A|!E&D&!C1&!C&B1&!B&!A1&A|!E&D&C1&!C&B1&!B&!A1&A|!E&!D&C1&!C&B1&!B&!A1&A|!E&!D&C1&C&B1&!B&!A1&A|!E&D&!C1&C&B1&!B&!A1&A|!E&!D&!C1&C&B1&!B&!A1&A|!E&!D&!C1&C&!B1&!B&!A1&A|!E&D&!C1&C&!B1&!B&!A1&A|!E&!D&C1&C&!B1&!B&!A1&A|!E&!D&C1&!C&!B1&!B&!A1&A|!E&D&C1&!C&!B1&!B&!A1&A|!E&D&!C1&!C&!B1&!B&!A1&A|!E&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOAOI22211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOOAI2212 -l OOAOOAI2212 -i D1 D C B1 B A1 A -o Y -f Y=(!D1&!D&!C&!B1&!B&!A1&!A|D1&!D&!C&!B1&!B&!A1&!A|D1&D&!C&!B1&!B&!A1&!A|!D1&D&!C&!B1&!B&!A1&!A|!D1&!D&C&!B1&!B&!A1&!A|!D1&!D&C&B1&!B&!A1&!A|!D1&D&!C&B1&!B&!A1&!A|D1&D&!C&B1&!B&!A1&!A|D1&!D&!C&B1&!B&!A1&!A|!D1&!D&!C&B1&!B&!A1&!A|!D1&!D&!C&B1&B&!A1&!A|D1&!D&!C&B1&B&!A1&!A|D1&D&!C&B1&B&!A1&!A|!D1&D&!C&B1&B&!A1&!A|!D1&!D&C&B1&B&!A1&!A|!D1&!D&C&!B1&B&!A1&!A|!D1&D&!C&!B1&B&!A1&!A|D1&D&!C&!B1&B&!A1&!A|D1&!D&!C&!B1&B&!A1&!A|!D1&!D&!C&!B1&B&!A1&!A|!D1&!D&!C&!B1&B&A1&!A|!D1&!D&C&!B1&B&A1&!A|!D1&!D&C&B1&B&A1&!A|!D1&!D&!C&B1&B&A1&!A|!D1&!D&!C&B1&!B&A1&!A|!D1&!D&C&B1&!B&A1&!A|!D1&!D&C&!B1&!B&A1&!A|!D1&D&!C&!B1&!B&A1&!A|D1&D&!C&!B1&!B&A1&!A|D1&!D&!C&!B1&!B&A1&!A|!D1&!D&!C&!B1&!B&A1&!A|!D1&!D&!C&!B1&!B&A1&A|D1&!D&!C&!B1&!B&A1&A|D1&D&!C&!B1&!B&A1&A|!D1&D&!C&!B1&!B&A1&A|!D1&!D&C&!B1&!B&A1&A|!D1&!D&C&B1&!B&A1&A|!D1&!D&!C&B1&!B&A1&A|!D1&!D&!C&B1&B&A1&A|!D1&!D&C&B1&B&A1&A|!D1&!D&C&!B1&B&A1&A|!D1&!D&!C&!B1&B&A1&A|!D1&!D&!C&!B1&B&!A1&A|!D1&!D&C&!B1&B&!A1&A|!D1&!D&C&B1&B&!A1&A|!D1&!D&!C&B1&B&!A1&A|!D1&!D&!C&B1&!B&!A1&A|!D1&!D&C&B1&!B&!A1&A|!D1&!D&C&!B1&!B&!A1&A|!D1&D&!C&!B1&!B&!A1&A|D1&D&!C&!B1&!B&!A1&A|D1&!D&!C&!B1&!B&!A1&A|!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOOAI2212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOOAOAI221311 -l OOAOOAOAI221311 -i F E D2 D1 D C B1 B A1 A -o Y -f Y=!(F&E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|F&E&D2&!D1&!D&!C&!B1&!B&!A1&!A|F&E&D2&D1&!D&!C&!B1&!B&!A1&!A|F&E&!D2&D1&!D&!C&!B1&!B&!A1&!A|F&E&!D2&D1&D&!C&!B1&!B&!A1&!A|F&E&D2&D1&D&!C&!B1&!B&!A1&!A|F&E&D2&!D1&D&!C&!B1&!B&!A1&!A|F&E&!D2&!D1&D&!C&!B1&!B&!A1&!A|F&!E&!D2&!D1&D&C&!B1&!B&!A1&!A|F&E&!D2&!D1&D&C&!B1&!B&!A1&!A|F&E&D2&!D1&D&C&!B1&!B&!A1&!A|F&!E&D2&!D1&D&C&!B1&!B&!A1&!A|F&!E&D2&D1&D&C&!B1&!B&!A1&!A|F&E&D2&D1&D&C&!B1&!B&!A1&!A|F&E&!D2&D1&D&C&!B1&!B&!A1&!A|F&!E&!D2&D1&D&C&!B1&!B&!A1&!A|F&!E&!D2&D1&!D&C&!B1&!B&!A1&!A|F&E&!D2&D1&!D&C&!B1&!B&!A1&!A|F&E&D2&D1&!D&C&!B1&!B&!A1&!A|F&!E&D2&D1&!D&C&!B1&!B&!A1&!A|F&!E&D2&!D1&!D&C&!B1&!B&!A1&!A|F&E&D2&!D1&!D&C&!B1&!B&!A1&!A|F&E&!D2&!D1&!D&C&!B1&!B&!A1&!A|F&E&!D2&!D1&!D&C&B1&!B&!A1&!A|F&E&D2&!D1&!D&C&B1&!B&!A1&!A|F&!E&D2&!D1&!D&C&B1&!B&!A1&!A|F&!E&D2&D1&!D&C&B1&!B&!A1&!A|F&E&D2&D1&!D&C&B1&!B&!A1&!A|F&E&!D2&D1&!D&C&B1&!B&!A1&!A|F&!E&!D2&D1&!D&C&B1&!B&!A1&!A|F&!E&!D2&D1&D&C&B1&!B&!A1&!A|F&E&!D2&D1&D&C&B1&!B&!A1&!A|F&E&D2&D1&D&C&B1&!B&!A1&!A|F&!E&D2&D1&D&C&B1&!B&!A1&!A|F&!E&D2&!D1&D&C&B1&!B&!A1&!A|F&E&D2&!D1&D&C&B1&!B&!A1&!A|F&E&!D2&!D1&D&C&B1&!B&!A1&!A|F&!E&!D2&!D1&D&C&B1&!B&!A1&!A|F&E&!D2&!D1&D&!C&B1&!B&!A1&!A|F&E&D2&!D1&D&!C&B1&!B&!A1&!A|F&E&D2&D1&D&!C&B1&!B&!A1&!A|F&E&!D2&D1&D&!C&B1&!B&!A1&!A|F&E&!D2&D1&!D&!C&B1&!B&!A1&!A|F&E&D2&D1&!D&!C&B1&!B&!A1&!A|F&E&D2&!D1&!D&!C&B1&!B&!A1&!A|F&E&!D2&!D1&!D&!C&B1&!B&!A1&!A|F&E&!D2&!D1&!D&!C&B1&B&!A1&!A|F&E&D2&!D1&!D&!C&B1&B&!A1&!A|F&E&D2&D1&!D&!C&B1&B&!A1&!A|F&E&!D2&D1&!D&!C&B1&B&!A1&!A|F&E&!D2&D1&D&!C&B1&B&!A1&!A|F&E&D2&D1&D&!C&B1&B&!A1&!A|F&E&D2&!D1&D&!C&B1&B&!A1&!A|F&E&!D2&!D1&D&!C&B1&B&!A1&!A|F&!E&!D2&!D1&D&C&B1&B&!A1&!A|F&E&!D2&!D1&D&C&B1&B&!A1&!A|F&E&D2&!D1&D&C&B1&B&!A1&!A|F&!E&D2&!D1&D&C&B1&B&!A1&!A|F&!E&D2&D1&D&C&B1&B&!A1&!A|F&E&D2&D1&D&C&B1&B&!A1&!A|F&E&!D2&D1&D&C&B1&B&!A1&!A|F&!E&!D2&D1&D&C&B1&B&!A1&!A|F&!E&!D2&D1&!D&C&B1&B&!A1&!A|F&E&!D2&D1&!D&C&B1&B&!A1&!A|F&E&D2&D1&!D&C&B1&B&!A1&!A|F&!E&D2&D1&!D&C&B1&B&!A1&!A|F&!E&D2&!D1&!D&C&B1&B&!A1&!A|F&E&D2&!D1&!D&C&B1&B&!A1&!A|F&E&!D2&!D1&!D&C&B1&B&!A1&!A|F&E&!D2&!D1&!D&C&!B1&B&!A1&!A|F&E&D2&!D1&!D&C&!B1&B&!A1&!A|F&!E&D2&!D1&!D&C&!B1&B&!A1&!A|F&!E&D2&D1&!D&C&!B1&B&!A1&!A|F&E&D2&D1&!D&C&!B1&B&!A1&!A|F&E&!D2&D1&!D&C&!B1&B&!A1&!A|F&!E&!D2&D1&!D&C&!B1&B&!A1&!A|F&!E&!D2&D1&D&C&!B1&B&!A1&!A|F&E&!D2&D1&D&C&!B1&B&!A1&!A|F&E&D2&D1&D&C&!B1&B&!A1&!A|F&!E&D2&D1&D&C&!B1&B&!A1&!A|F&!E&D2&!D1&D&C&!B1&B&!A1&!A|F&E&D2&!D1&D&C&!B1&B&!A1&!A|F&E&!D2&!D1&D&C&!B1&B&!A1&!A|F&!E&!D2&!D1&D&C&!B1&B&!A1&!A|F&E&!D2&!D1&D&!C&!B1&B&!A1&!A|F&E&D2&!D1&D&!C&!B1&B&!A1&!A|F&E&D2&D1&D&!C&!B1&B&!A1&!A|F&E&!D2&D1&D&!C&!B1&B&!A1&!A|F&E&!D2&D1&!D&!C&!B1&B&!A1&!A|F&E&D2&D1&!D&!C&!B1&B&!A1&!A|F&E&D2&!D1&!D&!C&!B1&B&!A1&!A|F&E&!D2&!D1&!D&!C&!B1&B&!A1&!A|F&E&!D2&!D1&!D&!C&!B1&B&A1&!A|F&E&D2&!D1&!D&!C&!B1&B&A1&!A|F&!E&D2&!D1&!D&!C&!B1&B&A1&!A|F&!E&D2&D1&!D&!C&!B1&B&A1&!A|F&E&D2&D1&!D&!C&!B1&B&A1&!A|F&E&!D2&D1&!D&!C&!B1&B&A1&!A|F&!E&!D2&D1&!D&!C&!B1&B&A1&!A|F&!E&!D2&D1&D&!C&!B1&B&A1&!A|F&E&!D2&D1&D&!C&!B1&B&A1&!A|F&E&D2&D1&D&!C&!B1&B&A1&!A|F&!E&D2&D1&D&!C&!B1&B&A1&!A|F&!E&D2&!D1&D&!C&!B1&B&A1&!A|F&E&D2&!D1&D&!C&!B1&B&A1&!A|F&E&!D2&!D1&D&!C&!B1&B&A1&!A|F&!E&!D2&!D1&D&!C&!B1&B&A1&!A|F&!E&!D2&!D1&D&C&!B1&B&A1&!A|F&E&!D2&!D1&D&C&!B1&B&A1&!A|F&E&D2&!D1&D&C&!B1&B&A1&!A|F&!E&D2&!D1&D&C&!B1&B&A1&!A|F&!E&D2&D1&D&C&!B1&B&A1&!A|F&E&D2&D1&D&C&!B1&B&A1&!A|F&E&!D2&D1&D&C&!B1&B&A1&!A|F&!E&!D2&D1&D&C&!B1&B&A1&!A|F&!E&!D2&D1&!D&C&!B1&B&A1&!A|F&E&!D2&D1&!D&C&!B1&B&A1&!A|F&E&D2&D1&!D&C&!B1&B&A1&!A|F&!E&D2&D1&!D&C&!B1&B&A1&!A|F&!E&D2&!D1&!D&C&!B1&B&A1&!A|F&E&D2&!D1&!D&C&!B1&B&A1&!A|F&E&!D2&!D1&!D&C&!B1&B&A1&!A|F&E&!D2&!D1&!D&C&B1&B&A1&!A|F&E&D2&!D1&!D&C&B1&B&A1&!A|F&!E&D2&!D1&!D&C&B1&B&A1&!A|F&!E&D2&D1&!D&C&B1&B&A1&!A|F&E&D2&D1&!D&C&B1&B&A1&!A|F&E&!D2&D1&!D&C&B1&B&A1&!A|F&!E&!D2&D1&!D&C&B1&B&A1&!A|F&!E&!D2&D1&D&C&B1&B&A1&!A|F&E&!D2&D1&D&C&B1&B&A1&!A|F&E&D2&D1&D&C&B1&B&A1&!A|F&!E&D2&D1&D&C&B1&B&A1&!A|F&!E&D2&!D1&D&C&B1&B&A1&!A|F&E&D2&!D1&D&C&B1&B&A1&!A|F&E&!D2&!D1&D&C&B1&B&A1&!A|F&!E&!D2&!D1&D&C&B1&B&A1&!A|F&!E&!D2&!D1&D&!C&B1&B&A1&!A|F&E&!D2&!D1&D&!C&B1&B&A1&!A|F&E&D2&!D1&D&!C&B1&B&A1&!A|F&!E&D2&!D1&D&!C&B1&B&A1&!A|F&!E&D2&D1&D&!C&B1&B&A1&!A|F&E&D2&D1&D&!C&B1&B&A1&!A|F&E&!D2&D1&D&!C&B1&B&A1&!A|F&!E&!D2&D1&D&!C&B1&B&A1&!A|F&!E&!D2&D1&!D&!C&B1&B&A1&!A|F&E&!D2&D1&!D&!C&B1&B&A1&!A|F&E&D2&D1&!D&!C&B1&B&A1&!A|F&!E&D2&D1&!D&!C&B1&B&A1&!A|F&!E&D2&!D1&!D&!C&B1&B&A1&!A|F&E&D2&!D1&!D&!C&B1&B&A1&!A|F&E&!D2&!D1&!D&!C&B1&B&A1&!A|F&E&!D2&!D1&!D&!C&B1&!B&A1&!A|F&E&D2&!D1&!D&!C&B1&!B&A1&!A|F&!E&D2&!D1&!D&!C&B1&!B&A1&!A|F&!E&D2&D1&!D&!C&B1&!B&A1&!A|F&E&D2&D1&!D&!C&B1&!B&A1&!A|F&E&!D2&D1&!D&!C&B1&!B&A1&!A|F&!E&!D2&D1&!D&!C&B1&!B&A1&!A|F&!E&!D2&D1&D&!C&B1&!B&A1&!A|F&E&!D2&D1&D&!C&B1&!B&A1&!A|F&E&D2&D1&D&!C&B1&!B&A1&!A|F&!E&D2&D1&D&!C&B1&!B&A1&!A|F&!E&D2&!D1&D&!C&B1&!B&A1&!A|F&E&D2&!D1&D&!C&B1&!B&A1&!A|F&E&!D2&!D1&D&!C&B1&!B&A1&!A|F&!E&!D2&!D1&D&!C&B1&!B&A1&!A|F&!E&!D2&!D1&D&C&B1&!B&A1&!A|F&E&!D2&!D1&D&C&B1&!B&A1&!A|F&E&D2&!D1&D&C&B1&!B&A1&!A|F&!E&D2&!D1&D&C&B1&!B&A1&!A|F&!E&D2&D1&D&C&B1&!B&A1&!A|F&E&D2&D1&D&C&B1&!B&A1&!A|F&E&!D2&D1&D&C&B1&!B&A1&!A|F&!E&!D2&D1&D&C&B1&!B&A1&!A|F&!E&!D2&D1&!D&C&B1&!B&A1&!A|F&E&!D2&D1&!D&C&B1&!B&A1&!A|F&E&D2&D1&!D&C&B1&!B&A1&!A|F&!E&D2&D1&!D&C&B1&!B&A1&!A|F&!E&D2&!D1&!D&C&B1&!B&A1&!A|F&E&D2&!D1&!D&C&B1&!B&A1&!A|F&E&!D2&!D1&!D&C&B1&!B&A1&!A|F&E&!D2&!D1&!D&C&!B1&!B&A1&!A|F&E&D2&!D1&!D&C&!B1&!B&A1&!A|F&!E&D2&!D1&!D&C&!B1&!B&A1&!A|F&!E&D2&D1&!D&C&!B1&!B&A1&!A|F&E&D2&D1&!D&C&!B1&!B&A1&!A|F&E&!D2&D1&!D&C&!B1&!B&A1&!A|F&!E&!D2&D1&!D&C&!B1&!B&A1&!A|F&!E&!D2&D1&D&C&!B1&!B&A1&!A|F&E&!D2&D1&D&C&!B1&!B&A1&!A|F&E&D2&D1&D&C&!B1&!B&A1&!A|F&!E&D2&D1&D&C&!B1&!B&A1&!A|F&!E&D2&!D1&D&C&!B1&!B&A1&!A|F&E&D2&!D1&D&C&!B1&!B&A1&!A|F&E&!D2&!D1&D&C&!B1&!B&A1&!A|F&!E&!D2&!D1&D&C&!B1&!B&A1&!A|F&E&!D2&!D1&D&!C&!B1&!B&A1&!A|F&E&D2&!D1&D&!C&!B1&!B&A1&!A|F&E&D2&D1&D&!C&!B1&!B&A1&!A|F&E&!D2&D1&D&!C&!B1&!B&A1&!A|F&E&!D2&D1&!D&!C&!B1&!B&A1&!A|F&E&D2&D1&!D&!C&!B1&!B&A1&!A|F&E&D2&!D1&!D&!C&!B1&!B&A1&!A|F&E&!D2&!D1&!D&!C&!B1&!B&A1&!A|F&E&!D2&!D1&!D&!C&!B1&!B&A1&A|F&E&D2&!D1&!D&!C&!B1&!B&A1&A|F&E&D2&D1&!D&!C&!B1&!B&A1&A|F&E&!D2&D1&!D&!C&!B1&!B&A1&A|F&E&!D2&D1&D&!C&!B1&!B&A1&A|F&E&D2&D1&D&!C&!B1&!B&A1&A|F&E&D2&!D1&D&!C&!B1&!B&A1&A|F&E&!D2&!D1&D&!C&!B1&!B&A1&A|F&!E&!D2&!D1&D&C&!B1&!B&A1&A|F&E&!D2&!D1&D&C&!B1&!B&A1&A|F&E&D2&!D1&D&C&!B1&!B&A1&A|F&!E&D2&!D1&D&C&!B1&!B&A1&A|F&!E&D2&D1&D&C&!B1&!B&A1&A|F&E&D2&D1&D&C&!B1&!B&A1&A|F&E&!D2&D1&D&C&!B1&!B&A1&A|F&!E&!D2&D1&D&C&!B1&!B&A1&A|F&!E&!D2&D1&!D&C&!B1&!B&A1&A|F&E&!D2&D1&!D&C&!B1&!B&A1&A|F&E&D2&D1&!D&C&!B1&!B&A1&A|F&!E&D2&D1&!D&C&!B1&!B&A1&A|F&!E&D2&!D1&!D&C&!B1&!B&A1&A|F&E&D2&!D1&!D&C&!B1&!B&A1&A|F&E&!D2&!D1&!D&C&!B1&!B&A1&A|F&E&!D2&!D1&!D&C&B1&!B&A1&A|F&E&D2&!D1&!D&C&B1&!B&A1&A|F&!E&D2&!D1&!D&C&B1&!B&A1&A|F&!E&D2&D1&!D&C&B1&!B&A1&A|F&E&D2&D1&!D&C&B1&!B&A1&A|F&E&!D2&D1&!D&C&B1&!B&A1&A|F&!E&!D2&D1&!D&C&B1&!B&A1&A|F&!E&!D2&D1&D&C&B1&!B&A1&A|F&E&!D2&D1&D&C&B1&!B&A1&A|F&E&D2&D1&D&C&B1&!B&A1&A|F&!E&D2&D1&D&C&B1&!B&A1&A|F&!E&D2&!D1&D&C&B1&!B&A1&A|F&E&D2&!D1&D&C&B1&!B&A1&A|F&E&!D2&!D1&D&C&B1&!B&A1&A|F&!E&!D2&!D1&D&C&B1&!B&A1&A|F&!E&!D2&!D1&D&!C&B1&!B&A1&A|F&E&!D2&!D1&D&!C&B1&!B&A1&A|F&E&D2&!D1&D&!C&B1&!B&A1&A|F&!E&D2&!D1&D&!C&B1&!B&A1&A|F&!E&D2&D1&D&!C&B1&!B&A1&A|F&E&D2&D1&D&!C&B1&!B&A1&A|F&E&!D2&D1&D&!C&B1&!B&A1&A|F&!E&!D2&D1&D&!C&B1&!B&A1&A|F&!E&!D2&D1&!D&!C&B1&!B&A1&A|F&E&!D2&D1&!D&!C&B1&!B&A1&A|F&E&D2&D1&!D&!C&B1&!B&A1&A|F&!E&D2&D1&!D&!C&B1&!B&A1&A|F&!E&D2&!D1&!D&!C&B1&!B&A1&A|F&E&D2&!D1&!D&!C&B1&!B&A1&A|F&E&!D2&!D1&!D&!C&B1&!B&A1&A|F&E&!D2&!D1&!D&!C&B1&B&A1&A|F&E&D2&!D1&!D&!C&B1&B&A1&A|F&!E&D2&!D1&!D&!C&B1&B&A1&A|F&!E&D2&D1&!D&!C&B1&B&A1&A|F&E&D2&D1&!D&!C&B1&B&A1&A|F&E&!D2&D1&!D&!C&B1&B&A1&A|F&!E&!D2&D1&!D&!C&B1&B&A1&A|F&!E&!D2&D1&D&!C&B1&B&A1&A|F&E&!D2&D1&D&!C&B1&B&A1&A|F&E&D2&D1&D&!C&B1&B&A1&A|F&!E&D2&D1&D&!C&B1&B&A1&A|F&!E&D2&!D1&D&!C&B1&B&A1&A|F&E&D2&!D1&D&!C&B1&B&A1&A|F&E&!D2&!D1&D&!C&B1&B&A1&A|F&!E&!D2&!D1&D&!C&B1&B&A1&A|F&!E&!D2&!D1&D&C&B1&B&A1&A|F&E&!D2&!D1&D&C&B1&B&A1&A|F&E&D2&!D1&D&C&B1&B&A1&A|F&!E&D2&!D1&D&C&B1&B&A1&A|F&!E&D2&D1&D&C&B1&B&A1&A|F&E&D2&D1&D&C&B1&B&A1&A|F&E&!D2&D1&D&C&B1&B&A1&A|F&!E&!D2&D1&D&C&B1&B&A1&A|F&!E&!D2&D1&!D&C&B1&B&A1&A|F&E&!D2&D1&!D&C&B1&B&A1&A|F&E&D2&D1&!D&C&B1&B&A1&A|F&!E&D2&D1&!D&C&B1&B&A1&A|F&!E&D2&!D1&!D&C&B1&B&A1&A|F&E&D2&!D1&!D&C&B1&B&A1&A|F&E&!D2&!D1&!D&C&B1&B&A1&A|F&E&!D2&!D1&!D&C&!B1&B&A1&A|F&E&D2&!D1&!D&C&!B1&B&A1&A|F&!E&D2&!D1&!D&C&!B1&B&A1&A|F&!E&D2&D1&!D&C&!B1&B&A1&A|F&E&D2&D1&!D&C&!B1&B&A1&A|F&E&!D2&D1&!D&C&!B1&B&A1&A|F&!E&!D2&D1&!D&C&!B1&B&A1&A|F&!E&!D2&D1&D&C&!B1&B&A1&A|F&E&!D2&D1&D&C&!B1&B&A1&A|F&E&D2&D1&D&C&!B1&B&A1&A|F&!E&D2&D1&D&C&!B1&B&A1&A|F&!E&D2&!D1&D&C&!B1&B&A1&A|F&E&D2&!D1&D&C&!B1&B&A1&A|F&E&!D2&!D1&D&C&!B1&B&A1&A|F&!E&!D2&!D1&D&C&!B1&B&A1&A|F&!E&!D2&!D1&D&!C&!B1&B&A1&A|F&E&!D2&!D1&D&!C&!B1&B&A1&A|F&E&D2&!D1&D&!C&!B1&B&A1&A|F&!E&D2&!D1&D&!C&!B1&B&A1&A|F&!E&D2&D1&D&!C&!B1&B&A1&A|F&E&D2&D1&D&!C&!B1&B&A1&A|F&E&!D2&D1&D&!C&!B1&B&A1&A|F&!E&!D2&D1&D&!C&!B1&B&A1&A|F&!E&!D2&D1&!D&!C&!B1&B&A1&A|F&E&!D2&D1&!D&!C&!B1&B&A1&A|F&E&D2&D1&!D&!C&!B1&B&A1&A|F&!E&D2&D1&!D&!C&!B1&B&A1&A|F&!E&D2&!D1&!D&!C&!B1&B&A1&A|F&E&D2&!D1&!D&!C&!B1&B&A1&A|F&E&!D2&!D1&!D&!C&!B1&B&A1&A|F&E&!D2&!D1&!D&!C&!B1&B&!A1&A|F&E&D2&!D1&!D&!C&!B1&B&!A1&A|F&!E&D2&!D1&!D&!C&!B1&B&!A1&A|F&!E&D2&D1&!D&!C&!B1&B&!A1&A|F&E&D2&D1&!D&!C&!B1&B&!A1&A|F&E&!D2&D1&!D&!C&!B1&B&!A1&A|F&!E&!D2&D1&!D&!C&!B1&B&!A1&A|F&!E&!D2&D1&D&!C&!B1&B&!A1&A|F&E&!D2&D1&D&!C&!B1&B&!A1&A|F&E&D2&D1&D&!C&!B1&B&!A1&A|F&!E&D2&D1&D&!C&!B1&B&!A1&A|F&!E&D2&!D1&D&!C&!B1&B&!A1&A|F&E&D2&!D1&D&!C&!B1&B&!A1&A|F&E&!D2&!D1&D&!C&!B1&B&!A1&A|F&!E&!D2&!D1&D&!C&!B1&B&!A1&A|F&!E&!D2&!D1&D&C&!B1&B&!A1&A|F&E&!D2&!D1&D&C&!B1&B&!A1&A|F&E&D2&!D1&D&C&!B1&B&!A1&A|F&!E&D2&!D1&D&C&!B1&B&!A1&A|F&!E&D2&D1&D&C&!B1&B&!A1&A|F&E&D2&D1&D&C&!B1&B&!A1&A|F&E&!D2&D1&D&C&!B1&B&!A1&A|F&!E&!D2&D1&D&C&!B1&B&!A1&A|F&!E&!D2&D1&!D&C&!B1&B&!A1&A|F&E&!D2&D1&!D&C&!B1&B&!A1&A|F&E&D2&D1&!D&C&!B1&B&!A1&A|F&!E&D2&D1&!D&C&!B1&B&!A1&A|F&!E&D2&!D1&!D&C&!B1&B&!A1&A|F&E&D2&!D1&!D&C&!B1&B&!A1&A|F&E&!D2&!D1&!D&C&!B1&B&!A1&A|F&E&!D2&!D1&!D&C&B1&B&!A1&A|F&E&D2&!D1&!D&C&B1&B&!A1&A|F&!E&D2&!D1&!D&C&B1&B&!A1&A|F&!E&D2&D1&!D&C&B1&B&!A1&A|F&E&D2&D1&!D&C&B1&B&!A1&A|F&E&!D2&D1&!D&C&B1&B&!A1&A|F&!E&!D2&D1&!D&C&B1&B&!A1&A|F&!E&!D2&D1&D&C&B1&B&!A1&A|F&E&!D2&D1&D&C&B1&B&!A1&A|F&E&D2&D1&D&C&B1&B&!A1&A|F&!E&D2&D1&D&C&B1&B&!A1&A|F&!E&D2&!D1&D&C&B1&B&!A1&A|F&E&D2&!D1&D&C&B1&B&!A1&A|F&E&!D2&!D1&D&C&B1&B&!A1&A|F&!E&!D2&!D1&D&C&B1&B&!A1&A|F&!E&!D2&!D1&D&!C&B1&B&!A1&A|F&E&!D2&!D1&D&!C&B1&B&!A1&A|F&E&D2&!D1&D&!C&B1&B&!A1&A|F&!E&D2&!D1&D&!C&B1&B&!A1&A|F&!E&D2&D1&D&!C&B1&B&!A1&A|F&E&D2&D1&D&!C&B1&B&!A1&A|F&E&!D2&D1&D&!C&B1&B&!A1&A|F&!E&!D2&D1&D&!C&B1&B&!A1&A|F&!E&!D2&D1&!D&!C&B1&B&!A1&A|F&E&!D2&D1&!D&!C&B1&B&!A1&A|F&E&D2&D1&!D&!C&B1&B&!A1&A|F&!E&D2&D1&!D&!C&B1&B&!A1&A|F&!E&D2&!D1&!D&!C&B1&B&!A1&A|F&E&D2&!D1&!D&!C&B1&B&!A1&A|F&E&!D2&!D1&!D&!C&B1&B&!A1&A|F&E&!D2&!D1&!D&!C&B1&!B&!A1&A|F&E&D2&!D1&!D&!C&B1&!B&!A1&A|F&!E&D2&!D1&!D&!C&B1&!B&!A1&A|F&!E&D2&D1&!D&!C&B1&!B&!A1&A|F&E&D2&D1&!D&!C&B1&!B&!A1&A|F&E&!D2&D1&!D&!C&B1&!B&!A1&A|F&!E&!D2&D1&!D&!C&B1&!B&!A1&A|F&!E&!D2&D1&D&!C&B1&!B&!A1&A|F&E&!D2&D1&D&!C&B1&!B&!A1&A|F&E&D2&D1&D&!C&B1&!B&!A1&A|F&!E&D2&D1&D&!C&B1&!B&!A1&A|F&!E&D2&!D1&D&!C&B1&!B&!A1&A|F&E&D2&!D1&D&!C&B1&!B&!A1&A|F&E&!D2&!D1&D&!C&B1&!B&!A1&A|F&!E&!D2&!D1&D&!C&B1&!B&!A1&A|F&!E&!D2&!D1&D&C&B1&!B&!A1&A|F&E&!D2&!D1&D&C&B1&!B&!A1&A|F&E&D2&!D1&D&C&B1&!B&!A1&A|F&!E&D2&!D1&D&C&B1&!B&!A1&A|F&!E&D2&D1&D&C&B1&!B&!A1&A|F&E&D2&D1&D&C&B1&!B&!A1&A|F&E&!D2&D1&D&C&B1&!B&!A1&A|F&!E&!D2&D1&D&C&B1&!B&!A1&A|F&!E&!D2&D1&!D&C&B1&!B&!A1&A|F&E&!D2&D1&!D&C&B1&!B&!A1&A|F&E&D2&D1&!D&C&B1&!B&!A1&A|F&!E&D2&D1&!D&C&B1&!B&!A1&A|F&!E&D2&!D1&!D&C&B1&!B&!A1&A|F&E&D2&!D1&!D&C&B1&!B&!A1&A|F&E&!D2&!D1&!D&C&B1&!B&!A1&A|F&E&!D2&!D1&!D&C&!B1&!B&!A1&A|F&E&D2&!D1&!D&C&!B1&!B&!A1&A|F&!E&D2&!D1&!D&C&!B1&!B&!A1&A|F&!E&D2&D1&!D&C&!B1&!B&!A1&A|F&E&D2&D1&!D&C&!B1&!B&!A1&A|F&E&!D2&D1&!D&C&!B1&!B&!A1&A|F&!E&!D2&D1&!D&C&!B1&!B&!A1&A|F&!E&!D2&D1&D&C&!B1&!B&!A1&A|F&E&!D2&D1&D&C&!B1&!B&!A1&A|F&E&D2&D1&D&C&!B1&!B&!A1&A|F&!E&D2&D1&D&C&!B1&!B&!A1&A|F&!E&D2&!D1&D&C&!B1&!B&!A1&A|F&E&D2&!D1&D&C&!B1&!B&!A1&A|F&E&!D2&!D1&D&C&!B1&!B&!A1&A|F&!E&!D2&!D1&D&C&!B1&!B&!A1&A|F&E&!D2&!D1&D&!C&!B1&!B&!A1&A|F&E&D2&!D1&D&!C&!B1&!B&!A1&A|F&E&D2&D1&D&!C&!B1&!B&!A1&A|F&E&!D2&D1&D&!C&!B1&!B&!A1&A|F&E&!D2&D1&!D&!C&!B1&!B&!A1&A|F&E&D2&D1&!D&!C&!B1&!B&!A1&A|F&E&D2&!D1&!D&!C&!B1&!B&!A1&A|F&E&!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOOAOAI221311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAI21221 -l OAOOAI21221 -i E D1 D C1 C B A1 A -o Y -f Y=!(E&!D1&D&C1&!C&!B&!A1&!A|E&D1&D&C1&!C&!B&!A1&!A|E&D1&!D&C1&!C&!B&!A1&!A|E&D1&!D&C1&C&!B&!A1&!A|E&D1&D&C1&C&!B&!A1&!A|E&!D1&D&C1&C&!B&!A1&!A|E&!D1&D&!C1&C&!B&!A1&!A|E&D1&D&!C1&C&!B&!A1&!A|E&D1&!D&!C1&C&!B&!A1&!A|E&D1&!D&!C1&C&B&!A1&!A|E&D1&D&!C1&C&B&!A1&!A|E&!D1&D&!C1&C&B&!A1&!A|E&!D1&D&C1&C&B&!A1&!A|E&D1&D&C1&C&B&!A1&!A|E&D1&!D&C1&C&B&!A1&!A|E&D1&!D&C1&!C&B&!A1&!A|E&D1&D&C1&!C&B&!A1&!A|E&!D1&D&C1&!C&B&!A1&!A|E&D1&!D&!C1&!C&B&A1&!A|E&D1&D&!C1&!C&B&A1&!A|E&!D1&D&!C1&!C&B&A1&!A|E&!D1&D&C1&!C&B&A1&!A|E&D1&D&C1&!C&B&A1&!A|E&D1&!D&C1&!C&B&A1&!A|E&D1&!D&C1&C&B&A1&!A|E&D1&D&C1&C&B&A1&!A|E&!D1&D&C1&C&B&A1&!A|E&!D1&D&!C1&C&B&A1&!A|E&D1&D&!C1&C&B&A1&!A|E&D1&!D&!C1&C&B&A1&!A|E&D1&!D&!C1&C&!B&A1&!A|E&D1&D&!C1&C&!B&A1&!A|E&!D1&D&!C1&C&!B&A1&!A|E&!D1&D&C1&C&!B&A1&!A|E&D1&D&C1&C&!B&A1&!A|E&D1&!D&C1&C&!B&A1&!A|E&D1&!D&C1&!C&!B&A1&!A|E&D1&D&C1&!C&!B&A1&!A|E&!D1&D&C1&!C&!B&A1&!A|E&!D1&D&C1&!C&!B&A1&A|E&D1&D&C1&!C&!B&A1&A|E&D1&!D&C1&!C&!B&A1&A|E&D1&!D&C1&C&!B&A1&A|E&D1&D&C1&C&!B&A1&A|E&!D1&D&C1&C&!B&A1&A|E&!D1&D&!C1&C&!B&A1&A|E&D1&D&!C1&C&!B&A1&A|E&D1&!D&!C1&C&!B&A1&A|E&D1&!D&!C1&C&B&A1&A|E&D1&D&!C1&C&B&A1&A|E&!D1&D&!C1&C&B&A1&A|E&!D1&D&C1&C&B&A1&A|E&D1&D&C1&C&B&A1&A|E&D1&!D&C1&C&B&A1&A|E&D1&!D&C1&!C&B&A1&A|E&D1&D&C1&!C&B&A1&A|E&!D1&D&C1&!C&B&A1&A|E&!D1&D&!C1&!C&B&A1&A|E&D1&D&!C1&!C&B&A1&A|E&D1&!D&!C1&!C&B&A1&A|E&D1&!D&!C1&!C&B&!A1&A|E&D1&D&!C1&!C&B&!A1&A|E&!D1&D&!C1&!C&B&!A1&A|E&!D1&D&C1&!C&B&!A1&A|E&D1&D&C1&!C&B&!A1&A|E&D1&!D&C1&!C&B&!A1&A|E&D1&!D&C1&C&B&!A1&A|E&D1&D&C1&C&B&!A1&A|E&!D1&D&C1&C&B&!A1&A|E&!D1&D&!C1&C&B&!A1&A|E&D1&D&!C1&C&B&!A1&A|E&D1&!D&!C1&C&B&!A1&A|E&D1&!D&!C1&C&!B&!A1&A|E&D1&D&!C1&C&!B&!A1&A|E&!D1&D&!C1&C&!B&!A1&A|E&!D1&D&C1&C&!B&!A1&A|E&D1&D&C1&C&!B&!A1&A|E&D1&!D&C1&C&!B&!A1&A|E&D1&!D&C1&!C&!B&!A1&A|E&D1&D&C1&!C&!B&!A1&A|E&!D1&D&C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAI21221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOAI2222 -l AAAOAI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=!(D1&D&C1&C&!B1&!B&!A1&!A|D1&D&C1&C&B1&!B&!A1&!A|D1&D&!C1&!C&B1&B&!A1&!A|D1&D&C1&!C&B1&B&!A1&!A|D1&D&C1&C&B1&B&!A1&!A|D1&D&!C1&C&B1&B&!A1&!A|D1&D&C1&C&!B1&B&!A1&!A|D1&D&C1&C&!B1&B&A1&!A|D1&D&!C1&C&B1&B&A1&!A|D1&D&C1&C&B1&B&A1&!A|D1&D&C1&!C&B1&B&A1&!A|D1&D&!C1&!C&B1&B&A1&!A|D1&D&C1&C&B1&!B&A1&!A|D1&D&C1&C&!B1&!B&A1&!A|D1&D&!C1&!C&!B1&!B&A1&A|D1&D&C1&!C&!B1&!B&A1&A|D1&D&C1&C&!B1&!B&A1&A|D1&D&!C1&C&!B1&!B&A1&A|D1&D&!C1&C&B1&!B&A1&A|D1&D&C1&C&B1&!B&A1&A|D1&D&C1&!C&B1&!B&A1&A|D1&D&!C1&!C&B1&!B&A1&A|D1&D&!C1&!C&B1&B&A1&A|D1&D&C1&!C&B1&B&A1&A|D1&D&C1&C&B1&B&A1&A|D1&D&!C1&C&B1&B&A1&A|D1&D&!C1&C&!B1&B&A1&A|D1&D&C1&C&!B1&B&A1&A|D1&D&C1&!C&!B1&B&A1&A|D1&D&!C1&!C&!B1&B&A1&A|D1&D&C1&C&!B1&B&!A1&A|D1&D&!C1&C&B1&B&!A1&A|D1&D&C1&C&B1&B&!A1&A|D1&D&C1&!C&B1&B&!A1&A|D1&D&!C1&!C&B1&B&!A1&A|D1&D&C1&C&B1&!B&!A1&A|D1&D&C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOAI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n ASYNC3 -l ASYNC3 -i A B -o C CN -f C=!(!A&!B) CN=!(A&B) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist ASYNC3.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOI21141 -l AOAAOI21141 -i E D3 D2 D1 D C B A1 A -o Y -f Y=(!E&!D3&!D2&!D1&!D&!C&!B&!A1&!A|!E&D3&!D2&!D1&!D&!C&!B&!A1&!A|!E&D3&D2&!D1&!D&!C&!B&!A1&!A|!E&!D3&D2&!D1&!D&!C&!B&!A1&!A|!E&!D3&D2&D1&!D&!C&!B&!A1&!A|!E&D3&D2&D1&!D&!C&!B&!A1&!A|!E&D3&!D2&D1&!D&!C&!B&!A1&!A|!E&!D3&!D2&D1&!D&!C&!B&!A1&!A|!E&!D3&!D2&D1&D&!C&!B&!A1&!A|!E&D3&!D2&D1&D&!C&!B&!A1&!A|!E&!D3&D2&D1&D&!C&!B&!A1&!A|!E&!D3&D2&!D1&D&!C&!B&!A1&!A|!E&D3&D2&!D1&D&!C&!B&!A1&!A|!E&D3&!D2&!D1&D&!C&!B&!A1&!A|!E&!D3&!D2&!D1&D&!C&!B&!A1&!A|!E&!D3&!D2&!D1&D&C&!B&!A1&!A|!E&D3&!D2&!D1&D&C&!B&!A1&!A|!E&D3&D2&!D1&D&C&!B&!A1&!A|!E&!D3&D2&!D1&D&C&!B&!A1&!A|!E&!D3&D2&D1&D&C&!B&!A1&!A|!E&D3&!D2&D1&D&C&!B&!A1&!A|!E&!D3&!D2&D1&D&C&!B&!A1&!A|!E&!D3&!D2&D1&!D&C&!B&!A1&!A|!E&D3&!D2&D1&!D&C&!B&!A1&!A|!E&D3&D2&D1&!D&C&!B&!A1&!A|!E&!D3&D2&D1&!D&C&!B&!A1&!A|!E&!D3&D2&!D1&!D&C&!B&!A1&!A|!E&D3&D2&!D1&!D&C&!B&!A1&!A|!E&D3&!D2&!D1&!D&C&!B&!A1&!A|!E&!D3&!D2&!D1&!D&C&!B&!A1&!A|!E&!D3&!D2&!D1&D&!C&B&!A1&!A|!E&D3&!D2&!D1&D&!C&B&!A1&!A|!E&D3&D2&!D1&D&!C&B&!A1&!A|!E&!D3&D2&!D1&D&!C&B&!A1&!A|!E&!D3&D2&D1&D&!C&B&!A1&!A|!E&D3&!D2&D1&D&!C&B&!A1&!A|!E&!D3&!D2&D1&D&!C&B&!A1&!A|!E&!D3&!D2&D1&!D&!C&B&!A1&!A|!E&D3&!D2&D1&!D&!C&B&!A1&!A|!E&D3&D2&D1&!D&!C&B&!A1&!A|!E&!D3&D2&D1&!D&!C&B&!A1&!A|!E&!D3&D2&!D1&!D&!C&B&!A1&!A|!E&D3&D2&!D1&!D&!C&B&!A1&!A|!E&D3&!D2&!D1&!D&!C&B&!A1&!A|!E&!D3&!D2&!D1&!D&!C&B&!A1&!A|!E&!D3&!D2&!D1&!D&!C&B&A1&!A|!E&D3&!D2&!D1&!D&!C&B&A1&!A|!E&D3&D2&!D1&!D&!C&B&A1&!A|!E&!D3&D2&!D1&!D&!C&B&A1&!A|!E&!D3&D2&D1&!D&!C&B&A1&!A|!E&D3&D2&D1&!D&!C&B&A1&!A|!E&D3&!D2&D1&!D&!C&B&A1&!A|!E&!D3&!D2&D1&!D&!C&B&A1&!A|!E&!D3&!D2&D1&D&!C&B&A1&!A|!E&D3&!D2&D1&D&!C&B&A1&!A|!E&!D3&D2&D1&D&!C&B&A1&!A|!E&!D3&D2&!D1&D&!C&B&A1&!A|!E&D3&D2&!D1&D&!C&B&A1&!A|!E&D3&!D2&!D1&D&!C&B&A1&!A|!E&!D3&!D2&!D1&D&!C&B&A1&!A|!E&!D3&!D2&!D1&!D&C&!B&A1&!A|!E&D3&!D2&!D1&!D&C&!B&A1&!A|!E&D3&D2&!D1&!D&C&!B&A1&!A|!E&!D3&D2&!D1&!D&C&!B&A1&!A|!E&!D3&D2&D1&!D&C&!B&A1&!A|!E&D3&D2&D1&!D&C&!B&A1&!A|!E&D3&!D2&D1&!D&C&!B&A1&!A|!E&!D3&!D2&D1&!D&C&!B&A1&!A|!E&!D3&!D2&D1&D&C&!B&A1&!A|!E&D3&!D2&D1&D&C&!B&A1&!A|!E&!D3&D2&D1&D&C&!B&A1&!A|!E&!D3&D2&!D1&D&C&!B&A1&!A|!E&D3&D2&!D1&D&C&!B&A1&!A|!E&D3&!D2&!D1&D&C&!B&A1&!A|!E&!D3&!D2&!D1&D&C&!B&A1&!A|!E&!D3&!D2&!D1&D&!C&!B&A1&!A|!E&D3&!D2&!D1&D&!C&!B&A1&!A|!E&D3&D2&!D1&D&!C&!B&A1&!A|!E&!D3&D2&!D1&D&!C&!B&A1&!A|!E&!D3&D2&D1&D&!C&!B&A1&!A|!E&D3&!D2&D1&D&!C&!B&A1&!A|!E&!D3&!D2&D1&D&!C&!B&A1&!A|!E&!D3&!D2&D1&!D&!C&!B&A1&!A|!E&D3&!D2&D1&!D&!C&!B&A1&!A|!E&D3&D2&D1&!D&!C&!B&A1&!A|!E&!D3&D2&D1&!D&!C&!B&A1&!A|!E&!D3&D2&!D1&!D&!C&!B&A1&!A|!E&D3&D2&!D1&!D&!C&!B&A1&!A|!E&D3&!D2&!D1&!D&!C&!B&A1&!A|!E&!D3&!D2&!D1&!D&!C&!B&A1&!A|!E&!D3&!D2&!D1&!D&!C&!B&A1&A|!E&D3&!D2&!D1&!D&!C&!B&A1&A|!E&D3&D2&!D1&!D&!C&!B&A1&A|!E&!D3&D2&!D1&!D&!C&!B&A1&A|!E&!D3&D2&D1&!D&!C&!B&A1&A|!E&D3&D2&D1&!D&!C&!B&A1&A|!E&D3&!D2&D1&!D&!C&!B&A1&A|!E&!D3&!D2&D1&!D&!C&!B&A1&A|!E&!D3&!D2&D1&D&!C&!B&A1&A|!E&D3&!D2&D1&D&!C&!B&A1&A|!E&!D3&D2&D1&D&!C&!B&A1&A|!E&!D3&D2&!D1&D&!C&!B&A1&A|!E&D3&D2&!D1&D&!C&!B&A1&A|!E&D3&!D2&!D1&D&!C&!B&A1&A|!E&!D3&!D2&!D1&D&!C&!B&A1&A|!E&!D3&!D2&!D1&D&!C&B&A1&A|!E&D3&!D2&!D1&D&!C&B&A1&A|!E&D3&D2&!D1&D&!C&B&A1&A|!E&!D3&D2&!D1&D&!C&B&A1&A|!E&!D3&D2&D1&D&!C&B&A1&A|!E&D3&!D2&D1&D&!C&B&A1&A|!E&!D3&!D2&D1&D&!C&B&A1&A|!E&!D3&!D2&D1&!D&!C&B&A1&A|!E&D3&!D2&D1&!D&!C&B&A1&A|!E&D3&D2&D1&!D&!C&B&A1&A|!E&!D3&D2&D1&!D&!C&B&A1&A|!E&!D3&D2&!D1&!D&!C&B&A1&A|!E&D3&D2&!D1&!D&!C&B&A1&A|!E&D3&!D2&!D1&!D&!C&B&A1&A|!E&!D3&!D2&!D1&!D&!C&B&A1&A|!E&!D3&!D2&!D1&!D&!C&B&!A1&A|!E&D3&!D2&!D1&!D&!C&B&!A1&A|!E&D3&D2&!D1&!D&!C&B&!A1&A|!E&!D3&D2&!D1&!D&!C&B&!A1&A|!E&!D3&D2&D1&!D&!C&B&!A1&A|!E&D3&D2&D1&!D&!C&B&!A1&A|!E&D3&!D2&D1&!D&!C&B&!A1&A|!E&!D3&!D2&D1&!D&!C&B&!A1&A|!E&!D3&!D2&D1&D&!C&B&!A1&A|!E&D3&!D2&D1&D&!C&B&!A1&A|!E&!D3&D2&D1&D&!C&B&!A1&A|!E&!D3&D2&!D1&D&!C&B&!A1&A|!E&D3&D2&!D1&D&!C&B&!A1&A|!E&D3&!D2&!D1&D&!C&B&!A1&A|!E&!D3&!D2&!D1&D&!C&B&!A1&A|!E&!D3&!D2&!D1&!D&C&!B&!A1&A|!E&D3&!D2&!D1&!D&C&!B&!A1&A|!E&D3&D2&!D1&!D&C&!B&!A1&A|!E&!D3&D2&!D1&!D&C&!B&!A1&A|!E&!D3&D2&D1&!D&C&!B&!A1&A|!E&D3&D2&D1&!D&C&!B&!A1&A|!E&D3&!D2&D1&!D&C&!B&!A1&A|!E&!D3&!D2&D1&!D&C&!B&!A1&A|!E&!D3&!D2&D1&D&C&!B&!A1&A|!E&D3&!D2&D1&D&C&!B&!A1&A|!E&!D3&D2&D1&D&C&!B&!A1&A|!E&!D3&D2&!D1&D&C&!B&!A1&A|!E&D3&D2&!D1&D&C&!B&!A1&A|!E&D3&!D2&!D1&D&C&!B&!A1&A|!E&!D3&!D2&!D1&D&C&!B&!A1&A|!E&!D3&!D2&!D1&D&!C&!B&!A1&A|!E&D3&!D2&!D1&D&!C&!B&!A1&A|!E&D3&D2&!D1&D&!C&!B&!A1&A|!E&!D3&D2&!D1&D&!C&!B&!A1&A|!E&!D3&D2&D1&D&!C&!B&!A1&A|!E&D3&!D2&D1&D&!C&!B&!A1&A|!E&!D3&!D2&D1&D&!C&!B&!A1&A|!E&!D3&!D2&D1&!D&!C&!B&!A1&A|!E&D3&!D2&D1&!D&!C&!B&!A1&A|!E&D3&D2&D1&!D&!C&!B&!A1&A|!E&!D3&D2&D1&!D&!C&!B&!A1&A|!E&!D3&D2&!D1&!D&!C&!B&!A1&A|!E&D3&D2&!D1&!D&!C&!B&!A1&A|!E&D3&!D2&!D1&!D&!C&!B&!A1&A|!E&!D3&!D2&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOI21141.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOOAI2222 -l AAOOOAI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=!(!D1&D&C1&!C&B1&B&!A1&!A|D1&D&C1&!C&B1&B&!A1&!A|D1&!D&C1&!C&B1&B&!A1&!A|D1&!D&C1&C&B1&B&!A1&!A|D1&D&C1&C&B1&B&!A1&!A|!D1&D&C1&C&B1&B&!A1&!A|!D1&D&!C1&C&B1&B&!A1&!A|D1&D&!C1&C&B1&B&!A1&!A|D1&!D&!C1&C&B1&B&!A1&!A|D1&!D&!C1&C&B1&B&A1&!A|D1&D&!C1&C&B1&B&A1&!A|!D1&D&!C1&C&B1&B&A1&!A|!D1&D&C1&C&B1&B&A1&!A|D1&D&C1&C&B1&B&A1&!A|D1&!D&C1&C&B1&B&A1&!A|D1&!D&C1&!C&B1&B&A1&!A|D1&D&C1&!C&B1&B&A1&!A|!D1&D&C1&!C&B1&B&A1&!A|!D1&D&C1&!C&!B1&!B&A1&A|D1&D&C1&!C&!B1&!B&A1&A|D1&!D&C1&!C&!B1&!B&A1&A|D1&!D&C1&C&!B1&!B&A1&A|D1&D&C1&C&!B1&!B&A1&A|!D1&D&C1&C&!B1&!B&A1&A|!D1&D&!C1&C&!B1&!B&A1&A|D1&D&!C1&C&!B1&!B&A1&A|D1&!D&!C1&C&!B1&!B&A1&A|D1&!D&!C1&C&B1&!B&A1&A|D1&D&!C1&C&B1&!B&A1&A|!D1&D&!C1&C&B1&!B&A1&A|!D1&D&C1&C&B1&!B&A1&A|D1&D&C1&C&B1&!B&A1&A|D1&!D&C1&C&B1&!B&A1&A|D1&!D&C1&!C&B1&!B&A1&A|D1&D&C1&!C&B1&!B&A1&A|!D1&D&C1&!C&B1&!B&A1&A|!D1&D&C1&!C&B1&B&A1&A|D1&D&C1&!C&B1&B&A1&A|D1&!D&C1&!C&B1&B&A1&A|D1&!D&C1&C&B1&B&A1&A|D1&D&C1&C&B1&B&A1&A|!D1&D&C1&C&B1&B&A1&A|!D1&D&!C1&C&B1&B&A1&A|D1&D&!C1&C&B1&B&A1&A|D1&!D&!C1&C&B1&B&A1&A|D1&!D&!C1&C&!B1&B&A1&A|D1&D&!C1&C&!B1&B&A1&A|!D1&D&!C1&C&!B1&B&A1&A|!D1&D&C1&C&!B1&B&A1&A|D1&D&C1&C&!B1&B&A1&A|D1&!D&C1&C&!B1&B&A1&A|D1&!D&C1&!C&!B1&B&A1&A|D1&D&C1&!C&!B1&B&A1&A|!D1&D&C1&!C&!B1&B&A1&A|D1&!D&!C1&C&B1&B&!A1&A|D1&D&!C1&C&B1&B&!A1&A|!D1&D&!C1&C&B1&B&!A1&A|!D1&D&C1&C&B1&B&!A1&A|D1&D&C1&C&B1&B&!A1&A|D1&!D&C1&C&B1&B&!A1&A|D1&!D&C1&!C&B1&B&!A1&A|D1&D&C1&!C&B1&B&!A1&A|!D1&D&C1&!C&B1&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOOAI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOAOI22211 -l OOAAOAOI22211 -i E D C1 C B1 B A1 A -o Y -f Y=(!E&!D&!C1&!C&!B1&!B&!A1&!A|!E&D&!C1&!C&!B1&!B&!A1&!A|!E&D&C1&!C&!B1&!B&!A1&!A|!E&!D&C1&!C&!B1&!B&!A1&!A|!E&!D&C1&C&!B1&!B&!A1&!A|!E&D&!C1&C&!B1&!B&!A1&!A|!E&!D&!C1&C&!B1&!B&!A1&!A|!E&!D&!C1&C&B1&!B&!A1&!A|!E&D&!C1&C&B1&!B&!A1&!A|!E&!D&C1&C&B1&!B&!A1&!A|!E&!D&C1&!C&B1&!B&!A1&!A|!E&D&C1&!C&B1&!B&!A1&!A|!E&D&!C1&!C&B1&!B&!A1&!A|!E&!D&!C1&!C&B1&!B&!A1&!A|!E&!D&!C1&!C&B1&B&!A1&!A|!E&D&!C1&!C&B1&B&!A1&!A|!E&D&C1&!C&B1&B&!A1&!A|!E&!D&C1&!C&B1&B&!A1&!A|!E&!D&C1&C&B1&B&!A1&!A|!E&D&!C1&C&B1&B&!A1&!A|!E&!D&!C1&C&B1&B&!A1&!A|!E&!D&!C1&C&!B1&B&!A1&!A|!E&D&!C1&C&!B1&B&!A1&!A|!E&!D&C1&C&!B1&B&!A1&!A|!E&!D&C1&!C&!B1&B&!A1&!A|!E&D&C1&!C&!B1&B&!A1&!A|!E&D&!C1&!C&!B1&B&!A1&!A|!E&!D&!C1&!C&!B1&B&!A1&!A|!E&!D&!C1&!C&!B1&B&A1&!A|!E&!D&C1&!C&!B1&B&A1&!A|!E&!D&C1&C&!B1&B&A1&!A|!E&!D&!C1&C&!B1&B&A1&!A|!E&!D&!C1&C&B1&B&A1&!A|!E&!D&C1&C&B1&B&A1&!A|!E&!D&C1&!C&B1&B&A1&!A|!E&!D&!C1&!C&B1&B&A1&!A|!E&!D&!C1&!C&B1&!B&A1&!A|!E&!D&C1&!C&B1&!B&A1&!A|!E&!D&C1&C&B1&!B&A1&!A|!E&!D&!C1&C&B1&!B&A1&!A|!E&!D&!C1&C&!B1&!B&A1&!A|!E&D&!C1&C&!B1&!B&A1&!A|!E&!D&C1&C&!B1&!B&A1&!A|!E&!D&C1&!C&!B1&!B&A1&!A|!E&D&C1&!C&!B1&!B&A1&!A|!E&D&!C1&!C&!B1&!B&A1&!A|!E&!D&!C1&!C&!B1&!B&A1&!A|!E&!D&!C1&!C&!B1&!B&A1&A|!E&D&!C1&!C&!B1&!B&A1&A|!E&D&C1&!C&!B1&!B&A1&A|!E&!D&C1&!C&!B1&!B&A1&A|!E&!D&C1&C&!B1&!B&A1&A|!E&D&!C1&C&!B1&!B&A1&A|!E&!D&!C1&C&!B1&!B&A1&A|!E&!D&!C1&C&B1&!B&A1&A|!E&!D&C1&C&B1&!B&A1&A|!E&!D&C1&!C&B1&!B&A1&A|!E&!D&!C1&!C&B1&!B&A1&A|!E&!D&!C1&!C&B1&B&A1&A|!E&!D&C1&!C&B1&B&A1&A|!E&!D&C1&C&B1&B&A1&A|!E&!D&!C1&C&B1&B&A1&A|!E&!D&!C1&C&!B1&B&A1&A|!E&!D&C1&C&!B1&B&A1&A|!E&!D&C1&!C&!B1&B&A1&A|!E&!D&!C1&!C&!B1&B&A1&A|!E&!D&!C1&!C&!B1&B&!A1&A|!E&!D&C1&!C&!B1&B&!A1&A|!E&!D&C1&C&!B1&B&!A1&A|!E&!D&!C1&C&!B1&B&!A1&A|!E&!D&!C1&C&B1&B&!A1&A|!E&!D&C1&C&B1&B&!A1&A|!E&!D&C1&!C&B1&B&!A1&A|!E&!D&!C1&!C&B1&B&!A1&A|!E&!D&!C1&!C&B1&!B&!A1&A|!E&!D&C1&!C&B1&!B&!A1&A|!E&!D&C1&C&B1&!B&!A1&A|!E&!D&!C1&C&B1&!B&!A1&A|!E&!D&!C1&C&!B1&!B&!A1&A|!E&D&!C1&C&!B1&!B&!A1&A|!E&!D&C1&C&!B1&!B&!A1&A|!E&!D&C1&!C&!B1&!B&!A1&A|!E&D&C1&!C&!B1&!B&!A1&A|!E&D&!C1&!C&!B1&!B&!A1&A|!E&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOAOI22211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAOI22121 -l OAOOAOI22121 -i E D1 D C B1 B A1 A -o Y -f Y=(!E&!D1&!D&!C&!B1&!B&!A1&!A|!E&D1&!D&!C&!B1&!B&!A1&!A|!E&D1&D&!C&!B1&!B&!A1&!A|!E&!D1&D&!C&!B1&!B&!A1&!A|!E&!D1&!D&C&!B1&!B&!A1&!A|!E&!D1&!D&C&B1&!B&!A1&!A|!E&!D1&D&!C&B1&!B&!A1&!A|!E&D1&D&!C&B1&!B&!A1&!A|!E&D1&!D&!C&B1&!B&!A1&!A|!E&!D1&!D&!C&B1&!B&!A1&!A|!E&!D1&!D&!C&B1&B&!A1&!A|!E&D1&!D&!C&B1&B&!A1&!A|!E&D1&D&!C&B1&B&!A1&!A|!E&!D1&D&!C&B1&B&!A1&!A|!E&!D1&!D&C&B1&B&!A1&!A|!E&!D1&!D&C&!B1&B&!A1&!A|!E&!D1&D&!C&!B1&B&!A1&!A|!E&D1&D&!C&!B1&B&!A1&!A|!E&D1&!D&!C&!B1&B&!A1&!A|!E&!D1&!D&!C&!B1&B&!A1&!A|!E&!D1&!D&!C&!B1&B&A1&!A|!E&D1&!D&!C&!B1&B&A1&!A|!E&D1&D&!C&!B1&B&A1&!A|!E&!D1&D&!C&!B1&B&A1&!A|!E&!D1&!D&C&!B1&B&A1&!A|!E&!D1&!D&C&B1&B&A1&!A|!E&!D1&!D&!C&B1&B&A1&!A|!E&!D1&!D&!C&B1&!B&A1&!A|!E&D1&!D&!C&B1&!B&A1&!A|!E&D1&D&!C&B1&!B&A1&!A|!E&!D1&D&!C&B1&!B&A1&!A|!E&!D1&!D&C&B1&!B&A1&!A|!E&!D1&!D&C&!B1&!B&A1&!A|!E&!D1&D&!C&!B1&!B&A1&!A|!E&D1&D&!C&!B1&!B&A1&!A|!E&D1&!D&!C&!B1&!B&A1&!A|!E&!D1&!D&!C&!B1&!B&A1&!A|!E&!D1&!D&!C&!B1&!B&A1&A|!E&D1&!D&!C&!B1&!B&A1&A|!E&D1&D&!C&!B1&!B&A1&A|!E&!D1&D&!C&!B1&!B&A1&A|!E&!D1&!D&C&!B1&!B&A1&A|!E&!D1&!D&C&B1&!B&A1&A|!E&!D1&D&!C&B1&!B&A1&A|!E&D1&D&!C&B1&!B&A1&A|!E&D1&!D&!C&B1&!B&A1&A|!E&!D1&!D&!C&B1&!B&A1&A|!E&!D1&!D&!C&B1&B&A1&A|!E&!D1&!D&C&B1&B&A1&A|!E&!D1&!D&C&!B1&B&A1&A|!E&!D1&D&!C&!B1&B&A1&A|!E&D1&D&!C&!B1&B&A1&A|!E&D1&!D&!C&!B1&B&A1&A|!E&!D1&!D&!C&!B1&B&A1&A|!E&!D1&!D&!C&!B1&B&!A1&A|!E&D1&!D&!C&!B1&B&!A1&A|!E&D1&D&!C&!B1&B&!A1&A|!E&!D1&D&!C&!B1&B&!A1&A|!E&!D1&!D&C&!B1&B&!A1&A|!E&!D1&!D&C&B1&B&!A1&A|!E&!D1&!D&!C&B1&B&!A1&A|!E&!D1&!D&!C&B1&!B&!A1&A|!E&D1&!D&!C&B1&!B&!A1&A|!E&D1&D&!C&B1&!B&!A1&A|!E&!D1&D&!C&B1&!B&!A1&A|!E&!D1&!D&C&B1&!B&!A1&A|!E&!D1&!D&C&!B1&!B&!A1&A|!E&!D1&D&!C&!B1&!B&!A1&A|!E&D1&D&!C&!B1&!B&!A1&A|!E&D1&!D&!C&!B1&!B&!A1&A|!E&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAOI22121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n MUX3 -l MUX3 -i IN0 IN1 IN2 S0 S1 S2 -o Z -f 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist MUX3.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAI2221 -l AAOOAI2221 -i D C1 C B1 B A1 A -o Y -f Y=!(D&C1&!C&B1&B&!A1&!A|D&C1&C&B1&B&!A1&!A|D&!C1&C&B1&B&!A1&!A|D&!C1&C&B1&B&A1&!A|D&C1&C&B1&B&A1&!A|D&C1&!C&B1&B&A1&!A|D&C1&!C&!B1&!B&A1&A|D&C1&C&!B1&!B&A1&A|D&!C1&C&!B1&!B&A1&A|D&!C1&C&B1&!B&A1&A|D&C1&C&B1&!B&A1&A|D&C1&!C&B1&!B&A1&A|D&C1&!C&B1&B&A1&A|D&C1&C&B1&B&A1&A|D&!C1&C&B1&B&A1&A|D&!C1&C&!B1&B&A1&A|D&C1&C&!B1&B&A1&A|D&C1&!C&!B1&B&A1&A|D&!C1&C&B1&B&!A1&A|D&C1&C&B1&B&!A1&A|D&C1&!C&B1&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAI2221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAAOI22122 -l AAOOAAOI22122 -i E1 E D1 D C B1 B A1 A -o Y -f Y=(!E1&!E&!D1&!D&!C&!B1&!B&!A1&!A|E1&!E&!D1&!D&!C&!B1&!B&!A1&!A|!E1&E&!D1&!D&!C&!B1&!B&!A1&!A|!E1&E&D1&!D&!C&!B1&!B&!A1&!A|E1&!E&D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&D1&D&!C&!B1&!B&!A1&!A|E1&!E&D1&D&!C&!B1&!B&!A1&!A|!E1&E&D1&D&!C&!B1&!B&!A1&!A|!E1&E&!D1&D&!C&!B1&!B&!A1&!A|E1&!E&!D1&D&!C&!B1&!B&!A1&!A|!E1&!E&!D1&D&!C&!B1&!B&!A1&!A|!E1&E&!D1&!D&C&!B1&!B&!A1&!A|E1&!E&!D1&!D&C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&C&!B1&!B&!A1&!A|!E1&!E&!D1&!D&C&B1&!B&!A1&!A|E1&!E&!D1&!D&C&B1&!B&!A1&!A|!E1&E&!D1&!D&C&B1&!B&!A1&!A|!E1&!E&!D1&D&!C&B1&!B&!A1&!A|E1&!E&!D1&D&!C&B1&!B&!A1&!A|!E1&E&!D1&D&!C&B1&!B&!A1&!A|!E1&E&D1&D&!C&B1&!B&!A1&!A|E1&!E&D1&D&!C&B1&!B&!A1&!A|!E1&!E&D1&D&!C&B1&!B&!A1&!A|!E1&!E&D1&!D&!C&B1&!B&!A1&!A|E1&!E&D1&!D&!C&B1&!B&!A1&!A|!E1&E&D1&!D&!C&B1&!B&!A1&!A|!E1&E&!D1&!D&!C&B1&!B&!A1&!A|E1&!E&!D1&!D&!C&B1&!B&!A1&!A|!E1&!E&!D1&!D&!C&B1&!B&!A1&!A|!E1&!E&!D1&!D&!C&B1&B&!A1&!A|E1&!E&!D1&!D&!C&B1&B&!A1&!A|!E1&E&!D1&!D&!C&B1&B&!A1&!A|!E1&E&!D1&!D&C&B1&B&!A1&!A|E1&!E&!D1&!D&C&B1&B&!A1&!A|!E1&!E&!D1&!D&C&B1&B&!A1&!A|!E1&!E&!D1&!D&C&!B1&B&!A1&!A|E1&!E&!D1&!D&C&!B1&B&!A1&!A|!E1&E&!D1&!D&C&!B1&B&!A1&!A|!E1&!E&!D1&D&!C&!B1&B&!A1&!A|E1&!E&!D1&D&!C&!B1&B&!A1&!A|!E1&E&!D1&D&!C&!B1&B&!A1&!A|!E1&E&D1&D&!C&!B1&B&!A1&!A|E1&!E&D1&D&!C&!B1&B&!A1&!A|!E1&!E&D1&D&!C&!B1&B&!A1&!A|!E1&!E&D1&!D&!C&!B1&B&!A1&!A|E1&!E&D1&!D&!C&!B1&B&!A1&!A|!E1&E&D1&!D&!C&!B1&B&!A1&!A|!E1&E&!D1&!D&!C&!B1&B&!A1&!A|E1&!E&!D1&!D&!C&!B1&B&!A1&!A|!E1&!E&!D1&!D&!C&!B1&B&!A1&!A|!E1&!E&!D1&!D&!C&!B1&B&A1&!A|E1&!E&!D1&!D&!C&!B1&B&A1&!A|!E1&E&!D1&!D&!C&!B1&B&A1&!A|!E1&E&D1&!D&!C&!B1&B&A1&!A|E1&!E&D1&!D&!C&!B1&B&A1&!A|!E1&!E&D1&!D&!C&!B1&B&A1&!A|!E1&!E&D1&D&!C&!B1&B&A1&!A|E1&!E&D1&D&!C&!B1&B&A1&!A|!E1&E&D1&D&!C&!B1&B&A1&!A|!E1&E&!D1&D&!C&!B1&B&A1&!A|E1&!E&!D1&D&!C&!B1&B&A1&!A|!E1&!E&!D1&D&!C&!B1&B&A1&!A|!E1&E&!D1&!D&C&!B1&B&A1&!A|E1&!E&!D1&!D&C&!B1&B&A1&!A|!E1&!E&!D1&!D&C&!B1&B&A1&!A|!E1&!E&!D1&!D&C&B1&B&A1&!A|E1&!E&!D1&!D&C&B1&B&A1&!A|!E1&E&!D1&!D&C&B1&B&A1&!A|!E1&E&!D1&!D&!C&B1&B&A1&!A|E1&!E&!D1&!D&!C&B1&B&A1&!A|!E1&!E&!D1&!D&!C&B1&B&A1&!A|!E1&!E&!D1&!D&!C&B1&!B&A1&!A|E1&!E&!D1&!D&!C&B1&!B&A1&!A|!E1&E&!D1&!D&!C&B1&!B&A1&!A|!E1&E&D1&!D&!C&B1&!B&A1&!A|E1&!E&D1&!D&!C&B1&!B&A1&!A|!E1&!E&D1&!D&!C&B1&!B&A1&!A|!E1&!E&D1&D&!C&B1&!B&A1&!A|E1&!E&D1&D&!C&B1&!B&A1&!A|!E1&E&D1&D&!C&B1&!B&A1&!A|!E1&E&!D1&D&!C&B1&!B&A1&!A|E1&!E&!D1&D&!C&B1&!B&A1&!A|!E1&!E&!D1&D&!C&B1&!B&A1&!A|!E1&E&!D1&!D&C&B1&!B&A1&!A|E1&!E&!D1&!D&C&B1&!B&A1&!A|!E1&!E&!D1&!D&C&B1&!B&A1&!A|!E1&!E&!D1&!D&C&!B1&!B&A1&!A|E1&!E&!D1&!D&C&!B1&!B&A1&!A|!E1&E&!D1&!D&C&!B1&!B&A1&!A|!E1&!E&!D1&D&!C&!B1&!B&A1&!A|E1&!E&!D1&D&!C&!B1&!B&A1&!A|!E1&E&!D1&D&!C&!B1&!B&A1&!A|!E1&E&D1&D&!C&!B1&!B&A1&!A|E1&!E&D1&D&!C&!B1&!B&A1&!A|!E1&!E&D1&D&!C&!B1&!B&A1&!A|!E1&!E&D1&!D&!C&!B1&!B&A1&!A|E1&!E&D1&!D&!C&!B1&!B&A1&!A|!E1&E&D1&!D&!C&!B1&!B&A1&!A|!E1&E&!D1&!D&!C&!B1&!B&A1&!A|E1&!E&!D1&!D&!C&!B1&!B&A1&!A|!E1&!E&!D1&!D&!C&!B1&!B&A1&!A|!E1&!E&!D1&!D&!C&!B1&!B&A1&A|E1&!E&!D1&!D&!C&!B1&!B&A1&A|!E1&E&!D1&!D&!C&!B1&!B&A1&A|!E1&E&!D1&!D&C&!B1&!B&A1&A|E1&!E&!D1&!D&C&!B1&!B&A1&A|!E1&!E&!D1&!D&C&!B1&!B&A1&A|!E1&!E&!D1&!D&C&B1&!B&A1&A|E1&!E&!D1&!D&C&B1&!B&A1&A|!E1&E&!D1&!D&C&B1&!B&A1&A|!E1&E&!D1&!D&!C&B1&!B&A1&A|E1&!E&!D1&!D&!C&B1&!B&A1&A|!E1&!E&!D1&!D&!C&B1&!B&A1&A|!E1&!E&!D1&!D&!C&B1&B&A1&A|E1&!E&!D1&!D&!C&B1&B&A1&A|!E1&E&!D1&!D&!C&B1&B&A1&A|!E1&E&!D1&!D&C&B1&B&A1&A|E1&!E&!D1&!D&C&B1&B&A1&A|!E1&!E&!D1&!D&C&B1&B&A1&A|!E1&!E&!D1&!D&C&!B1&B&A1&A|E1&!E&!D1&!D&C&!B1&B&A1&A|!E1&E&!D1&!D&C&!B1&B&A1&A|!E1&E&!D1&!D&!C&!B1&B&A1&A|E1&!E&!D1&!D&!C&!B1&B&A1&A|!E1&!E&!D1&!D&!C&!B1&B&A1&A|!E1&!E&!D1&!D&!C&!B1&B&!A1&A|E1&!E&!D1&!D&!C&!B1&B&!A1&A|!E1&E&!D1&!D&!C&!B1&B&!A1&A|!E1&E&D1&!D&!C&!B1&B&!A1&A|E1&!E&D1&!D&!C&!B1&B&!A1&A|!E1&!E&D1&!D&!C&!B1&B&!A1&A|!E1&!E&D1&D&!C&!B1&B&!A1&A|E1&!E&D1&D&!C&!B1&B&!A1&A|!E1&E&D1&D&!C&!B1&B&!A1&A|!E1&E&!D1&D&!C&!B1&B&!A1&A|E1&!E&!D1&D&!C&!B1&B&!A1&A|!E1&!E&!D1&D&!C&!B1&B&!A1&A|!E1&E&!D1&!D&C&!B1&B&!A1&A|E1&!E&!D1&!D&C&!B1&B&!A1&A|!E1&!E&!D1&!D&C&!B1&B&!A1&A|!E1&!E&!D1&!D&C&B1&B&!A1&A|E1&!E&!D1&!D&C&B1&B&!A1&A|!E1&E&!D1&!D&C&B1&B&!A1&A|!E1&E&!D1&!D&!C&B1&B&!A1&A|E1&!E&!D1&!D&!C&B1&B&!A1&A|!E1&!E&!D1&!D&!C&B1&B&!A1&A|!E1&!E&!D1&!D&!C&B1&!B&!A1&A|E1&!E&!D1&!D&!C&B1&!B&!A1&A|!E1&E&!D1&!D&!C&B1&!B&!A1&A|!E1&E&D1&!D&!C&B1&!B&!A1&A|E1&!E&D1&!D&!C&B1&!B&!A1&A|!E1&!E&D1&!D&!C&B1&!B&!A1&A|!E1&!E&D1&D&!C&B1&!B&!A1&A|E1&!E&D1&D&!C&B1&!B&!A1&A|!E1&E&D1&D&!C&B1&!B&!A1&A|!E1&E&!D1&D&!C&B1&!B&!A1&A|E1&!E&!D1&D&!C&B1&!B&!A1&A|!E1&!E&!D1&D&!C&B1&!B&!A1&A|!E1&E&!D1&!D&C&B1&!B&!A1&A|E1&!E&!D1&!D&C&B1&!B&!A1&A|!E1&!E&!D1&!D&C&B1&!B&!A1&A|!E1&!E&!D1&!D&C&!B1&!B&!A1&A|E1&!E&!D1&!D&C&!B1&!B&!A1&A|!E1&E&!D1&!D&C&!B1&!B&!A1&A|!E1&!E&!D1&D&!C&!B1&!B&!A1&A|E1&!E&!D1&D&!C&!B1&!B&!A1&A|!E1&E&!D1&D&!C&!B1&!B&!A1&A|!E1&E&D1&D&!C&!B1&!B&!A1&A|E1&!E&D1&D&!C&!B1&!B&!A1&A|!E1&!E&D1&D&!C&!B1&!B&!A1&A|!E1&!E&D1&!D&!C&!B1&!B&!A1&A|E1&!E&D1&!D&!C&!B1&!B&!A1&A|!E1&E&D1&!D&!C&!B1&!B&!A1&A|!E1&E&!D1&!D&!C&!B1&!B&!A1&A|E1&!E&!D1&!D&!C&!B1&!B&!A1&A|!E1&!E&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAAOI22122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOAI21131 -l AOAAOAI21131 -i E D2 D1 D C B A1 A -o Y -f Y=!(E&D2&D1&D&!C&!B&!A1&!A|E&D2&D1&D&C&!B&!A1&!A|E&!D2&!D1&!D&C&B&!A1&!A|E&D2&!D1&!D&C&B&!A1&!A|E&D2&D1&!D&C&B&!A1&!A|E&!D2&D1&!D&C&B&!A1&!A|E&!D2&D1&D&C&B&!A1&!A|E&D2&D1&D&C&B&!A1&!A|E&D2&!D1&D&C&B&!A1&!A|E&!D2&!D1&D&C&B&!A1&!A|E&D2&D1&D&!C&B&!A1&!A|E&D2&D1&D&!C&B&A1&!A|E&!D2&!D1&D&C&B&A1&!A|E&D2&!D1&D&C&B&A1&!A|E&D2&D1&D&C&B&A1&!A|E&!D2&D1&D&C&B&A1&!A|E&!D2&D1&!D&C&B&A1&!A|E&D2&D1&!D&C&B&A1&!A|E&D2&!D1&!D&C&B&A1&!A|E&!D2&!D1&!D&C&B&A1&!A|E&D2&D1&D&C&!B&A1&!A|E&D2&D1&D&!C&!B&A1&!A|E&D2&D1&D&!C&!B&A1&A|E&!D2&!D1&D&C&!B&A1&A|E&D2&!D1&D&C&!B&A1&A|E&D2&D1&D&C&!B&A1&A|E&!D2&D1&D&C&!B&A1&A|E&!D2&D1&!D&C&!B&A1&A|E&D2&D1&!D&C&!B&A1&A|E&D2&!D1&!D&C&!B&A1&A|E&!D2&!D1&!D&C&!B&A1&A|E&!D2&!D1&!D&C&B&A1&A|E&D2&!D1&!D&C&B&A1&A|E&D2&D1&!D&C&B&A1&A|E&!D2&D1&!D&C&B&A1&A|E&!D2&D1&D&C&B&A1&A|E&D2&D1&D&C&B&A1&A|E&D2&!D1&D&C&B&A1&A|E&!D2&!D1&D&C&B&A1&A|E&D2&D1&D&!C&B&A1&A|E&D2&D1&D&!C&B&!A1&A|E&!D2&!D1&D&C&B&!A1&A|E&D2&!D1&D&C&B&!A1&A|E&D2&D1&D&C&B&!A1&A|E&!D2&D1&D&C&B&!A1&A|E&!D2&D1&!D&C&B&!A1&A|E&D2&D1&!D&C&B&!A1&A|E&D2&!D1&!D&C&B&!A1&A|E&!D2&!D1&!D&C&B&!A1&A|E&D2&D1&D&C&!B&!A1&A|E&D2&D1&D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOAI21131.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOI313 -l OAAOI313 -i C2 C1 C B A2 A1 A -o Y -f Y=(!C2&!C1&!C&!B&!A2&!A1&!A|C2&!C1&!C&!B&!A2&!A1&!A|C2&C1&!C&!B&!A2&!A1&!A|!C2&C1&!C&!B&!A2&!A1&!A|!C2&C1&C&!B&!A2&!A1&!A|C2&!C1&C&!B&!A2&!A1&!A|!C2&!C1&C&!B&!A2&!A1&!A|!C2&!C1&C&B&!A2&!A1&!A|C2&!C1&C&B&!A2&!A1&!A|!C2&C1&C&B&!A2&!A1&!A|!C2&C1&!C&B&!A2&!A1&!A|C2&C1&!C&B&!A2&!A1&!A|C2&!C1&!C&B&!A2&!A1&!A|!C2&!C1&!C&B&!A2&!A1&!A|!C2&!C1&C&!B&A2&!A1&!A|C2&!C1&C&!B&A2&!A1&!A|!C2&C1&C&!B&A2&!A1&!A|!C2&C1&!C&!B&A2&!A1&!A|C2&C1&!C&!B&A2&!A1&!A|C2&!C1&!C&!B&A2&!A1&!A|!C2&!C1&!C&!B&A2&!A1&!A|!C2&!C1&!C&!B&A2&A1&!A|C2&!C1&!C&!B&A2&A1&!A|C2&C1&!C&!B&A2&A1&!A|!C2&C1&!C&!B&A2&A1&!A|!C2&C1&C&!B&A2&A1&!A|C2&!C1&C&!B&A2&A1&!A|!C2&!C1&C&!B&A2&A1&!A|!C2&!C1&C&!B&!A2&A1&!A|C2&!C1&C&!B&!A2&A1&!A|!C2&C1&C&!B&!A2&A1&!A|!C2&C1&!C&!B&!A2&A1&!A|C2&C1&!C&!B&!A2&A1&!A|C2&!C1&!C&!B&!A2&A1&!A|!C2&!C1&!C&!B&!A2&A1&!A|!C2&!C1&!C&!B&!A2&A1&A|C2&!C1&!C&!B&!A2&A1&A|C2&C1&!C&!B&!A2&A1&A|!C2&C1&!C&!B&!A2&A1&A|!C2&C1&C&!B&!A2&A1&A|C2&!C1&C&!B&!A2&A1&A|!C2&!C1&C&!B&!A2&A1&A|!C2&!C1&C&!B&A2&A1&A|C2&!C1&C&!B&A2&A1&A|!C2&C1&C&!B&A2&A1&A|!C2&C1&!C&!B&A2&A1&A|C2&C1&!C&!B&A2&A1&A|C2&!C1&!C&!B&A2&A1&A|!C2&!C1&!C&!B&A2&A1&A|!C2&!C1&!C&!B&A2&!A1&A|C2&!C1&!C&!B&A2&!A1&A|C2&C1&!C&!B&A2&!A1&A|!C2&C1&!C&!B&A2&!A1&A|!C2&C1&C&!B&A2&!A1&A|C2&!C1&C&!B&A2&!A1&A|!C2&!C1&C&!B&A2&!A1&A|!C2&!C1&C&!B&!A2&!A1&A|C2&!C1&C&!B&!A2&!A1&A|!C2&C1&C&!B&!A2&!A1&A|!C2&C1&!C&!B&!A2&!A1&A|C2&C1&!C&!B&!A2&!A1&A|C2&!C1&!C&!B&!A2&!A1&A|!C2&!C1&!C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOI313.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAOI3311 -l AAOAOI3311 -i D C B2 B1 B A2 A1 A -o Y -f Y=(!D&!C&!B2&!B1&!B&!A2&!A1&!A|!D&C&!B2&!B1&!B&!A2&!A1&!A|!D&C&B2&!B1&!B&!A2&!A1&!A|!D&!C&B2&!B1&!B&!A2&!A1&!A|!D&!C&B2&B1&!B&!A2&!A1&!A|!D&C&B2&B1&!B&!A2&!A1&!A|!D&C&!B2&B1&!B&!A2&!A1&!A|!D&!C&!B2&B1&!B&!A2&!A1&!A|!D&!C&!B2&B1&B&!A2&!A1&!A|!D&C&!B2&B1&B&!A2&!A1&!A|!D&!C&B2&B1&B&!A2&!A1&!A|!D&!C&B2&!B1&B&!A2&!A1&!A|!D&C&B2&!B1&B&!A2&!A1&!A|!D&C&!B2&!B1&B&!A2&!A1&!A|!D&!C&!B2&!B1&B&!A2&!A1&!A|!D&!C&!B2&!B1&B&A2&!A1&!A|!D&C&!B2&!B1&B&A2&!A1&!A|!D&C&B2&!B1&B&A2&!A1&!A|!D&!C&B2&!B1&B&A2&!A1&!A|!D&!C&B2&B1&B&A2&!A1&!A|!D&C&!B2&B1&B&A2&!A1&!A|!D&!C&!B2&B1&B&A2&!A1&!A|!D&!C&!B2&B1&!B&A2&!A1&!A|!D&C&!B2&B1&!B&A2&!A1&!A|!D&C&B2&B1&!B&A2&!A1&!A|!D&!C&B2&B1&!B&A2&!A1&!A|!D&!C&B2&!B1&!B&A2&!A1&!A|!D&C&B2&!B1&!B&A2&!A1&!A|!D&C&!B2&!B1&!B&A2&!A1&!A|!D&!C&!B2&!B1&!B&A2&!A1&!A|!D&!C&!B2&!B1&!B&A2&A1&!A|!D&C&!B2&!B1&!B&A2&A1&!A|!D&C&B2&!B1&!B&A2&A1&!A|!D&!C&B2&!B1&!B&A2&A1&!A|!D&!C&B2&B1&!B&A2&A1&!A|!D&C&B2&B1&!B&A2&A1&!A|!D&C&!B2&B1&!B&A2&A1&!A|!D&!C&!B2&B1&!B&A2&A1&!A|!D&!C&!B2&B1&B&A2&A1&!A|!D&C&!B2&B1&B&A2&A1&!A|!D&!C&B2&B1&B&A2&A1&!A|!D&!C&B2&!B1&B&A2&A1&!A|!D&C&B2&!B1&B&A2&A1&!A|!D&C&!B2&!B1&B&A2&A1&!A|!D&!C&!B2&!B1&B&A2&A1&!A|!D&!C&!B2&!B1&B&!A2&A1&!A|!D&C&!B2&!B1&B&!A2&A1&!A|!D&C&B2&!B1&B&!A2&A1&!A|!D&!C&B2&!B1&B&!A2&A1&!A|!D&!C&B2&B1&B&!A2&A1&!A|!D&C&!B2&B1&B&!A2&A1&!A|!D&!C&!B2&B1&B&!A2&A1&!A|!D&!C&!B2&B1&!B&!A2&A1&!A|!D&C&!B2&B1&!B&!A2&A1&!A|!D&C&B2&B1&!B&!A2&A1&!A|!D&!C&B2&B1&!B&!A2&A1&!A|!D&!C&B2&!B1&!B&!A2&A1&!A|!D&C&B2&!B1&!B&!A2&A1&!A|!D&C&!B2&!B1&!B&!A2&A1&!A|!D&!C&!B2&!B1&!B&!A2&A1&!A|!D&!C&!B2&!B1&!B&!A2&A1&A|!D&C&!B2&!B1&!B&!A2&A1&A|!D&C&B2&!B1&!B&!A2&A1&A|!D&!C&B2&!B1&!B&!A2&A1&A|!D&!C&B2&B1&!B&!A2&A1&A|!D&C&B2&B1&!B&!A2&A1&A|!D&C&!B2&B1&!B&!A2&A1&A|!D&!C&!B2&B1&!B&!A2&A1&A|!D&!C&!B2&B1&B&!A2&A1&A|!D&C&!B2&B1&B&!A2&A1&A|!D&!C&B2&B1&B&!A2&A1&A|!D&!C&B2&!B1&B&!A2&A1&A|!D&C&B2&!B1&B&!A2&A1&A|!D&C&!B2&!B1&B&!A2&A1&A|!D&!C&!B2&!B1&B&!A2&A1&A|!D&!C&!B2&!B1&B&A2&A1&A|!D&!C&B2&!B1&B&A2&A1&A|!D&!C&B2&B1&B&A2&A1&A|!D&!C&!B2&B1&B&A2&A1&A|!D&!C&!B2&B1&!B&A2&A1&A|!D&!C&B2&B1&!B&A2&A1&A|!D&!C&B2&!B1&!B&A2&A1&A|!D&!C&!B2&!B1&!B&A2&A1&A|!D&!C&!B2&!B1&!B&A2&!A1&A|!D&C&!B2&!B1&!B&A2&!A1&A|!D&C&B2&!B1&!B&A2&!A1&A|!D&!C&B2&!B1&!B&A2&!A1&A|!D&!C&B2&B1&!B&A2&!A1&A|!D&C&B2&B1&!B&A2&!A1&A|!D&C&!B2&B1&!B&A2&!A1&A|!D&!C&!B2&B1&!B&A2&!A1&A|!D&!C&!B2&B1&B&A2&!A1&A|!D&C&!B2&B1&B&A2&!A1&A|!D&!C&B2&B1&B&A2&!A1&A|!D&!C&B2&!B1&B&A2&!A1&A|!D&C&B2&!B1&B&A2&!A1&A|!D&C&!B2&!B1&B&A2&!A1&A|!D&!C&!B2&!B1&B&A2&!A1&A|!D&!C&!B2&!B1&B&!A2&!A1&A|!D&C&!B2&!B1&B&!A2&!A1&A|!D&C&B2&!B1&B&!A2&!A1&A|!D&!C&B2&!B1&B&!A2&!A1&A|!D&!C&B2&B1&B&!A2&!A1&A|!D&C&!B2&B1&B&!A2&!A1&A|!D&!C&!B2&B1&B&!A2&!A1&A|!D&!C&!B2&B1&!B&!A2&!A1&A|!D&C&!B2&B1&!B&!A2&!A1&A|!D&C&B2&B1&!B&!A2&!A1&A|!D&!C&B2&B1&!B&!A2&!A1&A|!D&!C&B2&!B1&!B&!A2&!A1&A|!D&C&B2&!B1&!B&!A2&!A1&A|!D&C&!B2&!B1&!B&!A2&!A1&A|!D&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAOI3311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOOAOI222211 -l OOAAOOAOI222211 -i F E D1 D C1 C B1 B A1 A -o Y -f Y=(!F&!E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D1&D&!C1&!C&!B1&!B&!A1&!A|!F&E&D1&D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&!D1&D&C1&!C&!B1&!B&!A1&!A|!F&E&!D1&D&C1&!C&!B1&!B&!A1&!A|!F&E&D1&D&C1&!C&!B1&!B&!A1&!A|!F&!E&D1&D&C1&!C&!B1&!B&!A1&!A|!F&!E&D1&!D&C1&!C&!B1&!B&!A1&!A|!F&E&D1&!D&C1&!C&!B1&!B&!A1&!A|!F&E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D1&!D&C1&C&!B1&!B&!A1&!A|!F&E&!D1&!D&C1&C&!B1&!B&!A1&!A|!F&!E&D1&!D&C1&C&!B1&!B&!A1&!A|!F&!E&D1&D&C1&C&!B1&!B&!A1&!A|!F&!E&!D1&D&C1&C&!B1&!B&!A1&!A|!F&!E&!D1&D&!C1&C&!B1&!B&!A1&!A|!F&E&!D1&D&!C1&C&!B1&!B&!A1&!A|!F&E&D1&D&!C1&C&!B1&!B&!A1&!A|!F&!E&D1&D&!C1&C&!B1&!B&!A1&!A|!F&!E&D1&!D&!C1&C&!B1&!B&!A1&!A|!F&E&D1&!D&!C1&C&!B1&!B&!A1&!A|!F&E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D1&!D&!C1&C&B1&!B&!A1&!A|!F&E&!D1&!D&!C1&C&B1&!B&!A1&!A|!F&E&D1&!D&!C1&C&B1&!B&!A1&!A|!F&!E&D1&!D&!C1&C&B1&!B&!A1&!A|!F&!E&D1&D&!C1&C&B1&!B&!A1&!A|!F&E&D1&D&!C1&C&B1&!B&!A1&!A|!F&E&!D1&D&!C1&C&B1&!B&!A1&!A|!F&!E&!D1&D&!C1&C&B1&!B&!A1&!A|!F&!E&!D1&D&C1&C&B1&!B&!A1&!A|!F&!E&D1&D&C1&C&B1&!B&!A1&!A|!F&!E&D1&!D&C1&C&B1&!B&!A1&!A|!F&E&!D1&!D&C1&C&B1&!B&!A1&!A|!F&!E&!D1&!D&C1&C&B1&!B&!A1&!A|!F&!E&!D1&!D&C1&!C&B1&!B&!A1&!A|!F&E&!D1&!D&C1&!C&B1&!B&!A1&!A|!F&E&D1&!D&C1&!C&B1&!B&!A1&!A|!F&!E&D1&!D&C1&!C&B1&!B&!A1&!A|!F&!E&D1&D&C1&!C&B1&!B&!A1&!A|!F&E&D1&D&C1&!C&B1&!B&!A1&!A|!F&E&!D1&D&C1&!C&B1&!B&!A1&!A|!F&!E&!D1&D&C1&!C&B1&!B&!A1&!A|!F&!E&!D1&D&!C1&!C&B1&!B&!A1&!A|!F&E&!D1&D&!C1&!C&B1&!B&!A1&!A|!F&E&D1&D&!C1&!C&B1&!B&!A1&!A|!F&!E&D1&D&!C1&!C&B1&!B&!A1&!A|!F&!E&D1&!D&!C1&!C&B1&!B&!A1&!A|!F&E&D1&!D&!C1&!C&B1&!B&!A1&!A|!F&E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D1&!D&!C1&!C&B1&B&!A1&!A|!F&E&!D1&!D&!C1&!C&B1&B&!A1&!A|!F&E&D1&!D&!C1&!C&B1&B&!A1&!A|!F&!E&D1&!D&!C1&!C&B1&B&!A1&!A|!F&!E&D1&D&!C1&!C&B1&B&!A1&!A|!F&E&D1&D&!C1&!C&B1&B&!A1&!A|!F&E&!D1&D&!C1&!C&B1&B&!A1&!A|!F&!E&!D1&D&!C1&!C&B1&B&!A1&!A|!F&!E&!D1&D&C1&!C&B1&B&!A1&!A|!F&E&!D1&D&C1&!C&B1&B&!A1&!A|!F&E&D1&D&C1&!C&B1&B&!A1&!A|!F&!E&D1&D&C1&!C&B1&B&!A1&!A|!F&!E&D1&!D&C1&!C&B1&B&!A1&!A|!F&E&D1&!D&C1&!C&B1&B&!A1&!A|!F&E&!D1&!D&C1&!C&B1&B&!A1&!A|!F&!E&!D1&!D&C1&!C&B1&B&!A1&!A|!F&!E&!D1&!D&C1&C&B1&B&!A1&!A|!F&E&!D1&!D&C1&C&B1&B&!A1&!A|!F&!E&D1&!D&C1&C&B1&B&!A1&!A|!F&!E&D1&D&C1&C&B1&B&!A1&!A|!F&!E&!D1&D&C1&C&B1&B&!A1&!A|!F&!E&!D1&D&!C1&C&B1&B&!A1&!A|!F&E&!D1&D&!C1&C&B1&B&!A1&!A|!F&E&D1&D&!C1&C&B1&B&!A1&!A|!F&!E&D1&D&!C1&C&B1&B&!A1&!A|!F&!E&D1&!D&!C1&C&B1&B&!A1&!A|!F&E&D1&!D&!C1&C&B1&B&!A1&!A|!F&E&!D1&!D&!C1&C&B1&B&!A1&!A|!F&!E&!D1&!D&!C1&C&B1&B&!A1&!A|!F&!E&!D1&!D&!C1&C&!B1&B&!A1&!A|!F&E&!D1&!D&!C1&C&!B1&B&!A1&!A|!F&E&D1&!D&!C1&C&!B1&B&!A1&!A|!F&!E&D1&!D&!C1&C&!B1&B&!A1&!A|!F&!E&D1&D&!C1&C&!B1&B&!A1&!A|!F&E&D1&D&!C1&C&!B1&B&!A1&!A|!F&E&!D1&D&!C1&C&!B1&B&!A1&!A|!F&!E&!D1&D&!C1&C&!B1&B&!A1&!A|!F&!E&!D1&D&C1&C&!B1&B&!A1&!A|!F&!E&D1&D&C1&C&!B1&B&!A1&!A|!F&!E&D1&!D&C1&C&!B1&B&!A1&!A|!F&E&!D1&!D&C1&C&!B1&B&!A1&!A|!F&!E&!D1&!D&C1&C&!B1&B&!A1&!A|!F&!E&!D1&!D&C1&!C&!B1&B&!A1&!A|!F&E&!D1&!D&C1&!C&!B1&B&!A1&!A|!F&E&D1&!D&C1&!C&!B1&B&!A1&!A|!F&!E&D1&!D&C1&!C&!B1&B&!A1&!A|!F&!E&D1&D&C1&!C&!B1&B&!A1&!A|!F&E&D1&D&C1&!C&!B1&B&!A1&!A|!F&E&!D1&D&C1&!C&!B1&B&!A1&!A|!F&!E&!D1&D&C1&!C&!B1&B&!A1&!A|!F&!E&!D1&D&!C1&!C&!B1&B&!A1&!A|!F&E&!D1&D&!C1&!C&!B1&B&!A1&!A|!F&E&D1&D&!C1&!C&!B1&B&!A1&!A|!F&!E&D1&D&!C1&!C&!B1&B&!A1&!A|!F&!E&D1&!D&!C1&!C&!B1&B&!A1&!A|!F&E&D1&!D&!C1&!C&!B1&B&!A1&!A|!F&E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D1&!D&!C1&!C&!B1&B&A1&!A|!F&E&!D1&!D&!C1&!C&!B1&B&A1&!A|!F&!E&D1&!D&!C1&!C&!B1&B&A1&!A|!F&!E&D1&D&!C1&!C&!B1&B&A1&!A|!F&!E&!D1&D&!C1&!C&!B1&B&A1&!A|!F&!E&!D1&D&C1&!C&!B1&B&A1&!A|!F&!E&D1&D&C1&!C&!B1&B&A1&!A|!F&!E&D1&!D&C1&!C&!B1&B&A1&!A|!F&E&!D1&!D&C1&!C&!B1&B&A1&!A|!F&!E&!D1&!D&C1&!C&!B1&B&A1&!A|!F&!E&!D1&!D&C1&C&!B1&B&A1&!A|!F&E&!D1&!D&C1&C&!B1&B&A1&!A|!F&!E&D1&!D&C1&C&!B1&B&A1&!A|!F&!E&D1&D&C1&C&!B1&B&A1&!A|!F&!E&!D1&D&C1&C&!B1&B&A1&!A|!F&!E&!D1&D&!C1&C&!B1&B&A1&!A|!F&!E&D1&D&!C1&C&!B1&B&A1&!A|!F&!E&D1&!D&!C1&C&!B1&B&A1&!A|!F&E&!D1&!D&!C1&C&!B1&B&A1&!A|!F&!E&!D1&!D&!C1&C&!B1&B&A1&!A|!F&!E&!D1&!D&!C1&C&B1&B&A1&!A|!F&E&!D1&!D&!C1&C&B1&B&A1&!A|!F&!E&D1&!D&!C1&C&B1&B&A1&!A|!F&!E&D1&D&!C1&C&B1&B&A1&!A|!F&!E&!D1&D&!C1&C&B1&B&A1&!A|!F&!E&!D1&D&C1&C&B1&B&A1&!A|!F&!E&D1&D&C1&C&B1&B&A1&!A|!F&!E&D1&!D&C1&C&B1&B&A1&!A|!F&E&!D1&!D&C1&C&B1&B&A1&!A|!F&!E&!D1&!D&C1&C&B1&B&A1&!A|!F&!E&!D1&!D&C1&!C&B1&B&A1&!A|!F&E&!D1&!D&C1&!C&B1&B&A1&!A|!F&!E&D1&!D&C1&!C&B1&B&A1&!A|!F&!E&D1&D&C1&!C&B1&B&A1&!A|!F&!E&!D1&D&C1&!C&B1&B&A1&!A|!F&!E&!D1&D&!C1&!C&B1&B&A1&!A|!F&!E&D1&D&!C1&!C&B1&B&A1&!A|!F&!E&D1&!D&!C1&!C&B1&B&A1&!A|!F&E&!D1&!D&!C1&!C&B1&B&A1&!A|!F&!E&!D1&!D&!C1&!C&B1&B&A1&!A|!F&!E&!D1&!D&!C1&!C&B1&!B&A1&!A|!F&E&!D1&!D&!C1&!C&B1&!B&A1&!A|!F&!E&D1&!D&!C1&!C&B1&!B&A1&!A|!F&!E&D1&D&!C1&!C&B1&!B&A1&!A|!F&!E&!D1&D&!C1&!C&B1&!B&A1&!A|!F&!E&!D1&D&C1&!C&B1&!B&A1&!A|!F&!E&D1&D&C1&!C&B1&!B&A1&!A|!F&!E&D1&!D&C1&!C&B1&!B&A1&!A|!F&E&!D1&!D&C1&!C&B1&!B&A1&!A|!F&!E&!D1&!D&C1&!C&B1&!B&A1&!A|!F&!E&!D1&!D&C1&C&B1&!B&A1&!A|!F&E&!D1&!D&C1&C&B1&!B&A1&!A|!F&!E&D1&!D&C1&C&B1&!B&A1&!A|!F&!E&D1&D&C1&C&B1&!B&A1&!A|!F&!E&!D1&D&C1&C&B1&!B&A1&!A|!F&!E&!D1&D&!C1&C&B1&!B&A1&!A|!F&!E&D1&D&!C1&C&B1&!B&A1&!A|!F&!E&D1&!D&!C1&C&B1&!B&A1&!A|!F&E&!D1&!D&!C1&C&B1&!B&A1&!A|!F&!E&!D1&!D&!C1&C&B1&!B&A1&!A|!F&!E&!D1&!D&!C1&C&!B1&!B&A1&!A|!F&E&!D1&!D&!C1&C&!B1&!B&A1&!A|!F&E&D1&!D&!C1&C&!B1&!B&A1&!A|!F&!E&D1&!D&!C1&C&!B1&!B&A1&!A|!F&!E&D1&D&!C1&C&!B1&!B&A1&!A|!F&E&D1&D&!C1&C&!B1&!B&A1&!A|!F&E&!D1&D&!C1&C&!B1&!B&A1&!A|!F&!E&!D1&D&!C1&C&!B1&!B&A1&!A|!F&!E&!D1&D&C1&C&!B1&!B&A1&!A|!F&!E&D1&D&C1&C&!B1&!B&A1&!A|!F&!E&D1&!D&C1&C&!B1&!B&A1&!A|!F&E&!D1&!D&C1&C&!B1&!B&A1&!A|!F&!E&!D1&!D&C1&C&!B1&!B&A1&!A|!F&!E&!D1&!D&C1&!C&!B1&!B&A1&!A|!F&E&!D1&!D&C1&!C&!B1&!B&A1&!A|!F&E&D1&!D&C1&!C&!B1&!B&A1&!A|!F&!E&D1&!D&C1&!C&!B1&!B&A1&!A|!F&!E&D1&D&C1&!C&!B1&!B&A1&!A|!F&E&D1&D&C1&!C&!B1&!B&A1&!A|!F&E&!D1&D&C1&!C&!B1&!B&A1&!A|!F&!E&!D1&D&C1&!C&!B1&!B&A1&!A|!F&!E&!D1&D&!C1&!C&!B1&!B&A1&!A|!F&E&!D1&D&!C1&!C&!B1&!B&A1&!A|!F&E&D1&D&!C1&!C&!B1&!B&A1&!A|!F&!E&D1&D&!C1&!C&!B1&!B&A1&!A|!F&!E&D1&!D&!C1&!C&!B1&!B&A1&!A|!F&E&D1&!D&!C1&!C&!B1&!B&A1&!A|!F&E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D1&!D&!C1&!C&!B1&!B&A1&A|!F&E&!D1&!D&!C1&!C&!B1&!B&A1&A|!F&E&D1&!D&!C1&!C&!B1&!B&A1&A|!F&!E&D1&!D&!C1&!C&!B1&!B&A1&A|!F&!E&D1&D&!C1&!C&!B1&!B&A1&A|!F&E&D1&D&!C1&!C&!B1&!B&A1&A|!F&E&!D1&D&!C1&!C&!B1&!B&A1&A|!F&!E&!D1&D&!C1&!C&!B1&!B&A1&A|!F&!E&!D1&D&C1&!C&!B1&!B&A1&A|!F&E&!D1&D&C1&!C&!B1&!B&A1&A|!F&E&D1&D&C1&!C&!B1&!B&A1&A|!F&!E&D1&D&C1&!C&!B1&!B&A1&A|!F&!E&D1&!D&C1&!C&!B1&!B&A1&A|!F&E&D1&!D&C1&!C&!B1&!B&A1&A|!F&E&!D1&!D&C1&!C&!B1&!B&A1&A|!F&!E&!D1&!D&C1&!C&!B1&!B&A1&A|!F&!E&!D1&!D&C1&C&!B1&!B&A1&A|!F&E&!D1&!D&C1&C&!B1&!B&A1&A|!F&!E&D1&!D&C1&C&!B1&!B&A1&A|!F&!E&D1&D&C1&C&!B1&!B&A1&A|!F&!E&!D1&D&C1&C&!B1&!B&A1&A|!F&!E&!D1&D&!C1&C&!B1&!B&A1&A|!F&E&!D1&D&!C1&C&!B1&!B&A1&A|!F&E&D1&D&!C1&C&!B1&!B&A1&A|!F&!E&D1&D&!C1&C&!B1&!B&A1&A|!F&!E&D1&!D&!C1&C&!B1&!B&A1&A|!F&E&D1&!D&!C1&C&!B1&!B&A1&A|!F&E&!D1&!D&!C1&C&!B1&!B&A1&A|!F&!E&!D1&!D&!C1&C&!B1&!B&A1&A|!F&!E&!D1&!D&!C1&C&B1&!B&A1&A|!F&E&!D1&!D&!C1&C&B1&!B&A1&A|!F&!E&D1&!D&!C1&C&B1&!B&A1&A|!F&!E&D1&D&!C1&C&B1&!B&A1&A|!F&!E&!D1&D&!C1&C&B1&!B&A1&A|!F&!E&!D1&D&C1&C&B1&!B&A1&A|!F&!E&D1&D&C1&C&B1&!B&A1&A|!F&!E&D1&!D&C1&C&B1&!B&A1&A|!F&E&!D1&!D&C1&C&B1&!B&A1&A|!F&!E&!D1&!D&C1&C&B1&!B&A1&A|!F&!E&!D1&!D&C1&!C&B1&!B&A1&A|!F&E&!D1&!D&C1&!C&B1&!B&A1&A|!F&!E&D1&!D&C1&!C&B1&!B&A1&A|!F&!E&D1&D&C1&!C&B1&!B&A1&A|!F&!E&!D1&D&C1&!C&B1&!B&A1&A|!F&!E&!D1&D&!C1&!C&B1&!B&A1&A|!F&!E&D1&D&!C1&!C&B1&!B&A1&A|!F&!E&D1&!D&!C1&!C&B1&!B&A1&A|!F&E&!D1&!D&!C1&!C&B1&!B&A1&A|!F&!E&!D1&!D&!C1&!C&B1&!B&A1&A|!F&!E&!D1&!D&!C1&!C&B1&B&A1&A|!F&E&!D1&!D&!C1&!C&B1&B&A1&A|!F&!E&D1&!D&!C1&!C&B1&B&A1&A|!F&!E&D1&D&!C1&!C&B1&B&A1&A|!F&!E&!D1&D&!C1&!C&B1&B&A1&A|!F&!E&!D1&D&C1&!C&B1&B&A1&A|!F&!E&D1&D&C1&!C&B1&B&A1&A|!F&!E&D1&!D&C1&!C&B1&B&A1&A|!F&E&!D1&!D&C1&!C&B1&B&A1&A|!F&!E&!D1&!D&C1&!C&B1&B&A1&A|!F&!E&!D1&!D&C1&C&B1&B&A1&A|!F&E&!D1&!D&C1&C&B1&B&A1&A|!F&!E&D1&!D&C1&C&B1&B&A1&A|!F&!E&D1&D&C1&C&B1&B&A1&A|!F&!E&!D1&D&C1&C&B1&B&A1&A|!F&!E&!D1&D&!C1&C&B1&B&A1&A|!F&!E&D1&D&!C1&C&B1&B&A1&A|!F&!E&D1&!D&!C1&C&B1&B&A1&A|!F&E&!D1&!D&!C1&C&B1&B&A1&A|!F&!E&!D1&!D&!C1&C&B1&B&A1&A|!F&!E&!D1&!D&!C1&C&!B1&B&A1&A|!F&E&!D1&!D&!C1&C&!B1&B&A1&A|!F&!E&D1&!D&!C1&C&!B1&B&A1&A|!F&!E&D1&D&!C1&C&!B1&B&A1&A|!F&!E&!D1&D&!C1&C&!B1&B&A1&A|!F&!E&!D1&D&C1&C&!B1&B&A1&A|!F&!E&D1&D&C1&C&!B1&B&A1&A|!F&!E&D1&!D&C1&C&!B1&B&A1&A|!F&E&!D1&!D&C1&C&!B1&B&A1&A|!F&!E&!D1&!D&C1&C&!B1&B&A1&A|!F&!E&!D1&!D&C1&!C&!B1&B&A1&A|!F&E&!D1&!D&C1&!C&!B1&B&A1&A|!F&!E&D1&!D&C1&!C&!B1&B&A1&A|!F&!E&D1&D&C1&!C&!B1&B&A1&A|!F&!E&!D1&D&C1&!C&!B1&B&A1&A|!F&!E&!D1&D&!C1&!C&!B1&B&A1&A|!F&!E&D1&D&!C1&!C&!B1&B&A1&A|!F&!E&D1&!D&!C1&!C&!B1&B&A1&A|!F&E&!D1&!D&!C1&!C&!B1&B&A1&A|!F&!E&!D1&!D&!C1&!C&!B1&B&A1&A|!F&!E&!D1&!D&!C1&!C&!B1&B&!A1&A|!F&E&!D1&!D&!C1&!C&!B1&B&!A1&A|!F&!E&D1&!D&!C1&!C&!B1&B&!A1&A|!F&!E&D1&D&!C1&!C&!B1&B&!A1&A|!F&!E&!D1&D&!C1&!C&!B1&B&!A1&A|!F&!E&!D1&D&C1&!C&!B1&B&!A1&A|!F&!E&D1&D&C1&!C&!B1&B&!A1&A|!F&!E&D1&!D&C1&!C&!B1&B&!A1&A|!F&E&!D1&!D&C1&!C&!B1&B&!A1&A|!F&!E&!D1&!D&C1&!C&!B1&B&!A1&A|!F&!E&!D1&!D&C1&C&!B1&B&!A1&A|!F&E&!D1&!D&C1&C&!B1&B&!A1&A|!F&!E&D1&!D&C1&C&!B1&B&!A1&A|!F&!E&D1&D&C1&C&!B1&B&!A1&A|!F&!E&!D1&D&C1&C&!B1&B&!A1&A|!F&!E&!D1&D&!C1&C&!B1&B&!A1&A|!F&!E&D1&D&!C1&C&!B1&B&!A1&A|!F&!E&D1&!D&!C1&C&!B1&B&!A1&A|!F&E&!D1&!D&!C1&C&!B1&B&!A1&A|!F&!E&!D1&!D&!C1&C&!B1&B&!A1&A|!F&!E&!D1&!D&!C1&C&B1&B&!A1&A|!F&E&!D1&!D&!C1&C&B1&B&!A1&A|!F&!E&D1&!D&!C1&C&B1&B&!A1&A|!F&!E&D1&D&!C1&C&B1&B&!A1&A|!F&!E&!D1&D&!C1&C&B1&B&!A1&A|!F&!E&!D1&D&C1&C&B1&B&!A1&A|!F&!E&D1&D&C1&C&B1&B&!A1&A|!F&!E&D1&!D&C1&C&B1&B&!A1&A|!F&E&!D1&!D&C1&C&B1&B&!A1&A|!F&!E&!D1&!D&C1&C&B1&B&!A1&A|!F&!E&!D1&!D&C1&!C&B1&B&!A1&A|!F&E&!D1&!D&C1&!C&B1&B&!A1&A|!F&!E&D1&!D&C1&!C&B1&B&!A1&A|!F&!E&D1&D&C1&!C&B1&B&!A1&A|!F&!E&!D1&D&C1&!C&B1&B&!A1&A|!F&!E&!D1&D&!C1&!C&B1&B&!A1&A|!F&!E&D1&D&!C1&!C&B1&B&!A1&A|!F&!E&D1&!D&!C1&!C&B1&B&!A1&A|!F&E&!D1&!D&!C1&!C&B1&B&!A1&A|!F&!E&!D1&!D&!C1&!C&B1&B&!A1&A|!F&!E&!D1&!D&!C1&!C&B1&!B&!A1&A|!F&E&!D1&!D&!C1&!C&B1&!B&!A1&A|!F&!E&D1&!D&!C1&!C&B1&!B&!A1&A|!F&!E&D1&D&!C1&!C&B1&!B&!A1&A|!F&!E&!D1&D&!C1&!C&B1&!B&!A1&A|!F&!E&!D1&D&C1&!C&B1&!B&!A1&A|!F&!E&D1&D&C1&!C&B1&!B&!A1&A|!F&!E&D1&!D&C1&!C&B1&!B&!A1&A|!F&E&!D1&!D&C1&!C&B1&!B&!A1&A|!F&!E&!D1&!D&C1&!C&B1&!B&!A1&A|!F&!E&!D1&!D&C1&C&B1&!B&!A1&A|!F&E&!D1&!D&C1&C&B1&!B&!A1&A|!F&!E&D1&!D&C1&C&B1&!B&!A1&A|!F&!E&D1&D&C1&C&B1&!B&!A1&A|!F&!E&!D1&D&C1&C&B1&!B&!A1&A|!F&!E&!D1&D&!C1&C&B1&!B&!A1&A|!F&!E&D1&D&!C1&C&B1&!B&!A1&A|!F&!E&D1&!D&!C1&C&B1&!B&!A1&A|!F&E&!D1&!D&!C1&C&B1&!B&!A1&A|!F&!E&!D1&!D&!C1&C&B1&!B&!A1&A|!F&!E&!D1&!D&!C1&C&!B1&!B&!A1&A|!F&E&!D1&!D&!C1&C&!B1&!B&!A1&A|!F&E&D1&!D&!C1&C&!B1&!B&!A1&A|!F&!E&D1&!D&!C1&C&!B1&!B&!A1&A|!F&!E&D1&D&!C1&C&!B1&!B&!A1&A|!F&E&D1&D&!C1&C&!B1&!B&!A1&A|!F&E&!D1&D&!C1&C&!B1&!B&!A1&A|!F&!E&!D1&D&!C1&C&!B1&!B&!A1&A|!F&!E&!D1&D&C1&C&!B1&!B&!A1&A|!F&!E&D1&D&C1&C&!B1&!B&!A1&A|!F&!E&D1&!D&C1&C&!B1&!B&!A1&A|!F&E&!D1&!D&C1&C&!B1&!B&!A1&A|!F&!E&!D1&!D&C1&C&!B1&!B&!A1&A|!F&!E&!D1&!D&C1&!C&!B1&!B&!A1&A|!F&E&!D1&!D&C1&!C&!B1&!B&!A1&A|!F&E&D1&!D&C1&!C&!B1&!B&!A1&A|!F&!E&D1&!D&C1&!C&!B1&!B&!A1&A|!F&!E&D1&D&C1&!C&!B1&!B&!A1&A|!F&E&D1&D&C1&!C&!B1&!B&!A1&A|!F&E&!D1&D&C1&!C&!B1&!B&!A1&A|!F&!E&!D1&D&C1&!C&!B1&!B&!A1&A|!F&!E&!D1&D&!C1&!C&!B1&!B&!A1&A|!F&E&!D1&D&!C1&!C&!B1&!B&!A1&A|!F&E&D1&D&!C1&!C&!B1&!B&!A1&A|!F&!E&D1&D&!C1&!C&!B1&!B&!A1&A|!F&!E&D1&!D&!C1&!C&!B1&!B&!A1&A|!F&E&D1&!D&!C1&!C&!B1&!B&!A1&A|!F&E&!D1&!D&!C1&!C&!B1&!B&!A1&A|!F&!E&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOOAOI222211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOI21213 -l AOOAAOI21213 -i E2 E1 E D C1 C B A1 A -o Y -f Y=!(E2&E1&E&!D&!C1&!C&!B&!A1&!A|E2&E1&E&D&!C1&!C&!B&!A1&!A|E2&E1&E&D&C1&!C&!B&!A1&!A|E2&E1&E&!D&C1&!C&!B&!A1&!A|E2&E1&E&!D&C1&C&!B&!A1&!A|E2&E1&E&D&C1&C&!B&!A1&!A|E2&E1&E&D&!C1&C&!B&!A1&!A|E2&E1&E&!D&!C1&C&!B&!A1&!A|E2&E1&E&!D&!C1&C&B&!A1&!A|!E2&!E1&E&D&!C1&C&B&!A1&!A|E2&!E1&E&D&!C1&C&B&!A1&!A|E2&E1&E&D&!C1&C&B&!A1&!A|!E2&E1&E&D&!C1&C&B&!A1&!A|!E2&E1&!E&D&!C1&C&B&!A1&!A|E2&E1&!E&D&!C1&C&B&!A1&!A|E2&!E1&!E&D&!C1&C&B&!A1&!A|!E2&!E1&!E&D&!C1&C&B&!A1&!A|!E2&!E1&!E&D&C1&C&B&!A1&!A|E2&!E1&!E&D&C1&C&B&!A1&!A|E2&E1&!E&D&C1&C&B&!A1&!A|!E2&E1&!E&D&C1&C&B&!A1&!A|!E2&E1&E&D&C1&C&B&!A1&!A|E2&E1&E&D&C1&C&B&!A1&!A|E2&!E1&E&D&C1&C&B&!A1&!A|!E2&!E1&E&D&C1&C&B&!A1&!A|E2&E1&E&!D&C1&C&B&!A1&!A|E2&E1&E&!D&C1&!C&B&!A1&!A|!E2&!E1&E&D&C1&!C&B&!A1&!A|E2&!E1&E&D&C1&!C&B&!A1&!A|E2&E1&E&D&C1&!C&B&!A1&!A|!E2&E1&E&D&C1&!C&B&!A1&!A|!E2&E1&!E&D&C1&!C&B&!A1&!A|E2&E1&!E&D&C1&!C&B&!A1&!A|E2&!E1&!E&D&C1&!C&B&!A1&!A|!E2&!E1&!E&D&C1&!C&B&!A1&!A|E2&E1&E&D&!C1&!C&B&!A1&!A|E2&E1&E&!D&!C1&!C&B&!A1&!A|E2&E1&E&!D&!C1&!C&B&A1&!A|E2&E1&E&D&!C1&!C&B&A1&!A|!E2&!E1&!E&D&C1&!C&B&A1&!A|E2&!E1&!E&D&C1&!C&B&A1&!A|E2&E1&!E&D&C1&!C&B&A1&!A|!E2&E1&!E&D&C1&!C&B&A1&!A|!E2&E1&E&D&C1&!C&B&A1&!A|E2&E1&E&D&C1&!C&B&A1&!A|E2&!E1&E&D&C1&!C&B&A1&!A|!E2&!E1&E&D&C1&!C&B&A1&!A|E2&E1&E&!D&C1&!C&B&A1&!A|E2&E1&E&!D&C1&C&B&A1&!A|!E2&!E1&E&D&C1&C&B&A1&!A|E2&!E1&E&D&C1&C&B&A1&!A|E2&E1&E&D&C1&C&B&A1&!A|!E2&E1&E&D&C1&C&B&A1&!A|!E2&E1&!E&D&C1&C&B&A1&!A|E2&E1&!E&D&C1&C&B&A1&!A|E2&!E1&!E&D&C1&C&B&A1&!A|!E2&!E1&!E&D&C1&C&B&A1&!A|!E2&!E1&!E&D&!C1&C&B&A1&!A|E2&!E1&!E&D&!C1&C&B&A1&!A|E2&E1&!E&D&!C1&C&B&A1&!A|!E2&E1&!E&D&!C1&C&B&A1&!A|!E2&E1&E&D&!C1&C&B&A1&!A|E2&E1&E&D&!C1&C&B&A1&!A|E2&!E1&E&D&!C1&C&B&A1&!A|!E2&!E1&E&D&!C1&C&B&A1&!A|E2&E1&E&!D&!C1&C&B&A1&!A|E2&E1&E&!D&!C1&C&!B&A1&!A|E2&E1&E&D&!C1&C&!B&A1&!A|E2&E1&E&D&C1&C&!B&A1&!A|E2&E1&E&!D&C1&C&!B&A1&!A|E2&E1&E&!D&C1&!C&!B&A1&!A|E2&E1&E&D&C1&!C&!B&A1&!A|E2&E1&E&D&!C1&!C&!B&A1&!A|E2&E1&E&!D&!C1&!C&!B&A1&!A|E2&E1&E&!D&!C1&!C&!B&A1&A|E2&E1&E&D&!C1&!C&!B&A1&A|!E2&!E1&!E&D&C1&!C&!B&A1&A|E2&!E1&!E&D&C1&!C&!B&A1&A|E2&E1&!E&D&C1&!C&!B&A1&A|!E2&E1&!E&D&C1&!C&!B&A1&A|!E2&E1&E&D&C1&!C&!B&A1&A|E2&E1&E&D&C1&!C&!B&A1&A|E2&!E1&E&D&C1&!C&!B&A1&A|!E2&!E1&E&D&C1&!C&!B&A1&A|E2&E1&E&!D&C1&!C&!B&A1&A|E2&E1&E&!D&C1&C&!B&A1&A|!E2&!E1&E&D&C1&C&!B&A1&A|E2&!E1&E&D&C1&C&!B&A1&A|E2&E1&E&D&C1&C&!B&A1&A|!E2&E1&E&D&C1&C&!B&A1&A|!E2&E1&!E&D&C1&C&!B&A1&A|E2&E1&!E&D&C1&C&!B&A1&A|E2&!E1&!E&D&C1&C&!B&A1&A|!E2&!E1&!E&D&C1&C&!B&A1&A|!E2&!E1&!E&D&!C1&C&!B&A1&A|E2&!E1&!E&D&!C1&C&!B&A1&A|E2&E1&!E&D&!C1&C&!B&A1&A|!E2&E1&!E&D&!C1&C&!B&A1&A|!E2&E1&E&D&!C1&C&!B&A1&A|E2&E1&E&D&!C1&C&!B&A1&A|E2&!E1&E&D&!C1&C&!B&A1&A|!E2&!E1&E&D&!C1&C&!B&A1&A|E2&E1&E&!D&!C1&C&!B&A1&A|E2&E1&E&!D&!C1&C&B&A1&A|!E2&!E1&E&D&!C1&C&B&A1&A|E2&!E1&E&D&!C1&C&B&A1&A|E2&E1&E&D&!C1&C&B&A1&A|!E2&E1&E&D&!C1&C&B&A1&A|!E2&E1&!E&D&!C1&C&B&A1&A|E2&E1&!E&D&!C1&C&B&A1&A|E2&!E1&!E&D&!C1&C&B&A1&A|!E2&!E1&!E&D&!C1&C&B&A1&A|!E2&!E1&!E&D&C1&C&B&A1&A|E2&!E1&!E&D&C1&C&B&A1&A|E2&E1&!E&D&C1&C&B&A1&A|!E2&E1&!E&D&C1&C&B&A1&A|!E2&E1&E&D&C1&C&B&A1&A|E2&E1&E&D&C1&C&B&A1&A|E2&!E1&E&D&C1&C&B&A1&A|!E2&!E1&E&D&C1&C&B&A1&A|E2&E1&E&!D&C1&C&B&A1&A|E2&E1&E&!D&C1&!C&B&A1&A|!E2&!E1&E&D&C1&!C&B&A1&A|E2&!E1&E&D&C1&!C&B&A1&A|E2&E1&E&D&C1&!C&B&A1&A|!E2&E1&E&D&C1&!C&B&A1&A|!E2&E1&!E&D&C1&!C&B&A1&A|E2&E1&!E&D&C1&!C&B&A1&A|E2&!E1&!E&D&C1&!C&B&A1&A|!E2&!E1&!E&D&C1&!C&B&A1&A|E2&E1&E&D&!C1&!C&B&A1&A|E2&E1&E&!D&!C1&!C&B&A1&A|E2&E1&E&!D&!C1&!C&B&!A1&A|E2&E1&E&D&!C1&!C&B&!A1&A|!E2&!E1&!E&D&C1&!C&B&!A1&A|E2&!E1&!E&D&C1&!C&B&!A1&A|E2&E1&!E&D&C1&!C&B&!A1&A|!E2&E1&!E&D&C1&!C&B&!A1&A|!E2&E1&E&D&C1&!C&B&!A1&A|E2&E1&E&D&C1&!C&B&!A1&A|E2&!E1&E&D&C1&!C&B&!A1&A|!E2&!E1&E&D&C1&!C&B&!A1&A|E2&E1&E&!D&C1&!C&B&!A1&A|E2&E1&E&!D&C1&C&B&!A1&A|!E2&!E1&E&D&C1&C&B&!A1&A|E2&!E1&E&D&C1&C&B&!A1&A|E2&E1&E&D&C1&C&B&!A1&A|!E2&E1&E&D&C1&C&B&!A1&A|!E2&E1&!E&D&C1&C&B&!A1&A|E2&E1&!E&D&C1&C&B&!A1&A|E2&!E1&!E&D&C1&C&B&!A1&A|!E2&!E1&!E&D&C1&C&B&!A1&A|!E2&!E1&!E&D&!C1&C&B&!A1&A|E2&!E1&!E&D&!C1&C&B&!A1&A|E2&E1&!E&D&!C1&C&B&!A1&A|!E2&E1&!E&D&!C1&C&B&!A1&A|!E2&E1&E&D&!C1&C&B&!A1&A|E2&E1&E&D&!C1&C&B&!A1&A|E2&!E1&E&D&!C1&C&B&!A1&A|!E2&!E1&E&D&!C1&C&B&!A1&A|E2&E1&E&!D&!C1&C&B&!A1&A|E2&E1&E&!D&!C1&C&!B&!A1&A|E2&E1&E&D&!C1&C&!B&!A1&A|E2&E1&E&D&C1&C&!B&!A1&A|E2&E1&E&!D&C1&C&!B&!A1&A|E2&E1&E&!D&C1&!C&!B&!A1&A|E2&E1&E&D&C1&!C&!B&!A1&A|E2&E1&E&D&!C1&!C&!B&!A1&A|E2&E1&E&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOI21213.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOI2133 -l AOOAAOI2133 -i D2 D1 D C2 C1 C B A1 A -o Y -f Y=(!D2&!D1&!D&!C2&!C1&!C&!B&!A1&!A|D2&!D1&!D&!C2&!C1&!C&!B&!A1&!A|D2&D1&!D&!C2&!C1&!C&!B&!A1&!A|!D2&D1&!D&!C2&!C1&!C&!B&!A1&!A|!D2&D1&D&!C2&!C1&!C&!B&!A1&!A|D2&!D1&D&!C2&!C1&!C&!B&!A1&!A|!D2&!D1&D&!C2&!C1&!C&!B&!A1&!A|!D2&!D1&D&C2&!C1&!C&!B&!A1&!A|D2&!D1&D&C2&!C1&!C&!B&!A1&!A|!D2&D1&D&C2&!C1&!C&!B&!A1&!A|!D2&D1&!D&C2&!C1&!C&!B&!A1&!A|D2&D1&!D&C2&!C1&!C&!B&!A1&!A|D2&!D1&!D&C2&!C1&!C&!B&!A1&!A|!D2&!D1&!D&C2&!C1&!C&!B&!A1&!A|!D2&!D1&!D&C2&C1&!C&!B&!A1&!A|D2&!D1&!D&C2&C1&!C&!B&!A1&!A|D2&D1&!D&C2&C1&!C&!B&!A1&!A|!D2&D1&!D&C2&C1&!C&!B&!A1&!A|!D2&D1&D&C2&C1&!C&!B&!A1&!A|D2&!D1&D&C2&C1&!C&!B&!A1&!A|!D2&!D1&D&C2&C1&!C&!B&!A1&!A|!D2&!D1&D&!C2&C1&!C&!B&!A1&!A|D2&!D1&D&!C2&C1&!C&!B&!A1&!A|!D2&D1&D&!C2&C1&!C&!B&!A1&!A|!D2&D1&!D&!C2&C1&!C&!B&!A1&!A|D2&D1&!D&!C2&C1&!C&!B&!A1&!A|D2&!D1&!D&!C2&C1&!C&!B&!A1&!A|!D2&!D1&!D&!C2&C1&!C&!B&!A1&!A|!D2&!D1&!D&!C2&C1&C&!B&!A1&!A|D2&!D1&!D&!C2&C1&C&!B&!A1&!A|D2&D1&!D&!C2&C1&C&!B&!A1&!A|!D2&D1&!D&!C2&C1&C&!B&!A1&!A|!D2&D1&D&!C2&C1&C&!B&!A1&!A|D2&!D1&D&!C2&C1&C&!B&!A1&!A|!D2&!D1&D&!C2&C1&C&!B&!A1&!A|!D2&!D1&D&C2&C1&C&!B&!A1&!A|D2&!D1&D&C2&C1&C&!B&!A1&!A|!D2&D1&D&C2&C1&C&!B&!A1&!A|!D2&D1&!D&C2&C1&C&!B&!A1&!A|D2&D1&!D&C2&C1&C&!B&!A1&!A|D2&!D1&!D&C2&C1&C&!B&!A1&!A|!D2&!D1&!D&C2&C1&C&!B&!A1&!A|!D2&!D1&!D&C2&!C1&C&!B&!A1&!A|D2&!D1&!D&C2&!C1&C&!B&!A1&!A|D2&D1&!D&C2&!C1&C&!B&!A1&!A|!D2&D1&!D&C2&!C1&C&!B&!A1&!A|!D2&D1&D&C2&!C1&C&!B&!A1&!A|D2&!D1&D&C2&!C1&C&!B&!A1&!A|!D2&!D1&D&C2&!C1&C&!B&!A1&!A|!D2&!D1&D&!C2&!C1&C&!B&!A1&!A|D2&!D1&D&!C2&!C1&C&!B&!A1&!A|!D2&D1&D&!C2&!C1&C&!B&!A1&!A|!D2&D1&!D&!C2&!C1&C&!B&!A1&!A|D2&D1&!D&!C2&!C1&C&!B&!A1&!A|D2&!D1&!D&!C2&!C1&C&!B&!A1&!A|!D2&!D1&!D&!C2&!C1&C&!B&!A1&!A|!D2&!D1&D&!C2&!C1&!C&B&!A1&!A|D2&!D1&D&!C2&!C1&!C&B&!A1&!A|!D2&D1&D&!C2&!C1&!C&B&!A1&!A|!D2&D1&!D&!C2&!C1&!C&B&!A1&!A|D2&D1&!D&!C2&!C1&!C&B&!A1&!A|D2&!D1&!D&!C2&!C1&!C&B&!A1&!A|!D2&!D1&!D&!C2&!C1&!C&B&!A1&!A|!D2&!D1&!D&!C2&!C1&!C&B&A1&!A|D2&!D1&!D&!C2&!C1&!C&B&A1&!A|D2&D1&!D&!C2&!C1&!C&B&A1&!A|!D2&D1&!D&!C2&!C1&!C&B&A1&!A|!D2&D1&D&!C2&!C1&!C&B&A1&!A|D2&!D1&D&!C2&!C1&!C&B&A1&!A|!D2&!D1&D&!C2&!C1&!C&B&A1&!A|!D2&!D1&!D&!C2&!C1&C&!B&A1&!A|D2&!D1&!D&!C2&!C1&C&!B&A1&!A|D2&D1&!D&!C2&!C1&C&!B&A1&!A|!D2&D1&!D&!C2&!C1&C&!B&A1&!A|!D2&D1&D&!C2&!C1&C&!B&A1&!A|D2&!D1&D&!C2&!C1&C&!B&A1&!A|!D2&!D1&D&!C2&!C1&C&!B&A1&!A|!D2&!D1&D&C2&!C1&C&!B&A1&!A|D2&!D1&D&C2&!C1&C&!B&A1&!A|!D2&D1&D&C2&!C1&C&!B&A1&!A|!D2&D1&!D&C2&!C1&C&!B&A1&!A|D2&D1&!D&C2&!C1&C&!B&A1&!A|D2&!D1&!D&C2&!C1&C&!B&A1&!A|!D2&!D1&!D&C2&!C1&C&!B&A1&!A|!D2&!D1&!D&C2&C1&C&!B&A1&!A|D2&!D1&!D&C2&C1&C&!B&A1&!A|D2&D1&!D&C2&C1&C&!B&A1&!A|!D2&D1&!D&C2&C1&C&!B&A1&!A|!D2&D1&D&C2&C1&C&!B&A1&!A|D2&!D1&D&C2&C1&C&!B&A1&!A|!D2&!D1&D&C2&C1&C&!B&A1&!A|!D2&!D1&D&!C2&C1&C&!B&A1&!A|D2&!D1&D&!C2&C1&C&!B&A1&!A|!D2&D1&D&!C2&C1&C&!B&A1&!A|!D2&D1&!D&!C2&C1&C&!B&A1&!A|D2&D1&!D&!C2&C1&C&!B&A1&!A|D2&!D1&!D&!C2&C1&C&!B&A1&!A|!D2&!D1&!D&!C2&C1&C&!B&A1&!A|!D2&!D1&!D&!C2&C1&!C&!B&A1&!A|D2&!D1&!D&!C2&C1&!C&!B&A1&!A|D2&D1&!D&!C2&C1&!C&!B&A1&!A|!D2&D1&!D&!C2&C1&!C&!B&A1&!A|!D2&D1&D&!C2&C1&!C&!B&A1&!A|D2&!D1&D&!C2&C1&!C&!B&A1&!A|!D2&!D1&D&!C2&C1&!C&!B&A1&!A|!D2&!D1&D&C2&C1&!C&!B&A1&!A|D2&!D1&D&C2&C1&!C&!B&A1&!A|!D2&D1&D&C2&C1&!C&!B&A1&!A|!D2&D1&!D&C2&C1&!C&!B&A1&!A|D2&D1&!D&C2&C1&!C&!B&A1&!A|D2&!D1&!D&C2&C1&!C&!B&A1&!A|!D2&!D1&!D&C2&C1&!C&!B&A1&!A|!D2&!D1&!D&C2&!C1&!C&!B&A1&!A|D2&!D1&!D&C2&!C1&!C&!B&A1&!A|D2&D1&!D&C2&!C1&!C&!B&A1&!A|!D2&D1&!D&C2&!C1&!C&!B&A1&!A|!D2&D1&D&C2&!C1&!C&!B&A1&!A|D2&!D1&D&C2&!C1&!C&!B&A1&!A|!D2&!D1&D&C2&!C1&!C&!B&A1&!A|!D2&!D1&D&!C2&!C1&!C&!B&A1&!A|D2&!D1&D&!C2&!C1&!C&!B&A1&!A|!D2&D1&D&!C2&!C1&!C&!B&A1&!A|!D2&D1&!D&!C2&!C1&!C&!B&A1&!A|D2&D1&!D&!C2&!C1&!C&!B&A1&!A|D2&!D1&!D&!C2&!C1&!C&!B&A1&!A|!D2&!D1&!D&!C2&!C1&!C&!B&A1&!A|!D2&!D1&!D&!C2&!C1&!C&!B&A1&A|D2&!D1&!D&!C2&!C1&!C&!B&A1&A|D2&D1&!D&!C2&!C1&!C&!B&A1&A|!D2&D1&!D&!C2&!C1&!C&!B&A1&A|!D2&D1&D&!C2&!C1&!C&!B&A1&A|D2&!D1&D&!C2&!C1&!C&!B&A1&A|!D2&!D1&D&!C2&!C1&!C&!B&A1&A|!D2&!D1&D&!C2&!C1&!C&B&A1&A|D2&!D1&D&!C2&!C1&!C&B&A1&A|!D2&D1&D&!C2&!C1&!C&B&A1&A|!D2&D1&!D&!C2&!C1&!C&B&A1&A|D2&D1&!D&!C2&!C1&!C&B&A1&A|D2&!D1&!D&!C2&!C1&!C&B&A1&A|!D2&!D1&!D&!C2&!C1&!C&B&A1&A|!D2&!D1&!D&!C2&!C1&!C&B&!A1&A|D2&!D1&!D&!C2&!C1&!C&B&!A1&A|D2&D1&!D&!C2&!C1&!C&B&!A1&A|!D2&D1&!D&!C2&!C1&!C&B&!A1&A|!D2&D1&D&!C2&!C1&!C&B&!A1&A|D2&!D1&D&!C2&!C1&!C&B&!A1&A|!D2&!D1&D&!C2&!C1&!C&B&!A1&A|!D2&!D1&!D&!C2&!C1&C&!B&!A1&A|D2&!D1&!D&!C2&!C1&C&!B&!A1&A|D2&D1&!D&!C2&!C1&C&!B&!A1&A|!D2&D1&!D&!C2&!C1&C&!B&!A1&A|!D2&D1&D&!C2&!C1&C&!B&!A1&A|D2&!D1&D&!C2&!C1&C&!B&!A1&A|!D2&!D1&D&!C2&!C1&C&!B&!A1&A|!D2&!D1&D&C2&!C1&C&!B&!A1&A|D2&!D1&D&C2&!C1&C&!B&!A1&A|!D2&D1&D&C2&!C1&C&!B&!A1&A|!D2&D1&!D&C2&!C1&C&!B&!A1&A|D2&D1&!D&C2&!C1&C&!B&!A1&A|D2&!D1&!D&C2&!C1&C&!B&!A1&A|!D2&!D1&!D&C2&!C1&C&!B&!A1&A|!D2&!D1&!D&C2&C1&C&!B&!A1&A|D2&!D1&!D&C2&C1&C&!B&!A1&A|D2&D1&!D&C2&C1&C&!B&!A1&A|!D2&D1&!D&C2&C1&C&!B&!A1&A|!D2&D1&D&C2&C1&C&!B&!A1&A|D2&!D1&D&C2&C1&C&!B&!A1&A|!D2&!D1&D&C2&C1&C&!B&!A1&A|!D2&!D1&D&!C2&C1&C&!B&!A1&A|D2&!D1&D&!C2&C1&C&!B&!A1&A|!D2&D1&D&!C2&C1&C&!B&!A1&A|!D2&D1&!D&!C2&C1&C&!B&!A1&A|D2&D1&!D&!C2&C1&C&!B&!A1&A|D2&!D1&!D&!C2&C1&C&!B&!A1&A|!D2&!D1&!D&!C2&C1&C&!B&!A1&A|!D2&!D1&!D&!C2&C1&!C&!B&!A1&A|D2&!D1&!D&!C2&C1&!C&!B&!A1&A|D2&D1&!D&!C2&C1&!C&!B&!A1&A|!D2&D1&!D&!C2&C1&!C&!B&!A1&A|!D2&D1&D&!C2&C1&!C&!B&!A1&A|D2&!D1&D&!C2&C1&!C&!B&!A1&A|!D2&!D1&D&!C2&C1&!C&!B&!A1&A|!D2&!D1&D&C2&C1&!C&!B&!A1&A|D2&!D1&D&C2&C1&!C&!B&!A1&A|!D2&D1&D&C2&C1&!C&!B&!A1&A|!D2&D1&!D&C2&C1&!C&!B&!A1&A|D2&D1&!D&C2&C1&!C&!B&!A1&A|D2&!D1&!D&C2&C1&!C&!B&!A1&A|!D2&!D1&!D&C2&C1&!C&!B&!A1&A|!D2&!D1&!D&C2&!C1&!C&!B&!A1&A|D2&!D1&!D&C2&!C1&!C&!B&!A1&A|D2&D1&!D&C2&!C1&!C&!B&!A1&A|!D2&D1&!D&C2&!C1&!C&!B&!A1&A|!D2&D1&D&C2&!C1&!C&!B&!A1&A|D2&!D1&D&C2&!C1&!C&!B&!A1&A|!D2&!D1&D&C2&!C1&!C&!B&!A1&A|!D2&!D1&D&!C2&!C1&!C&!B&!A1&A|D2&!D1&D&!C2&!C1&!C&!B&!A1&A|!D2&D1&D&!C2&!C1&!C&!B&!A1&A|!D2&D1&!D&!C2&!C1&!C&!B&!A1&A|D2&D1&!D&!C2&!C1&!C&!B&!A1&A|D2&!D1&!D&!C2&!C1&!C&!B&!A1&A|!D2&!D1&!D&!C2&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOI2133.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAI231 -l AOAI231 -i C B2 B1 B A1 A -o Y -f Y=!(C&B2&!B1&!B&!A1&!A|C&B2&B1&!B&!A1&!A|C&!B2&B1&!B&!A1&!A|C&!B2&B1&B&!A1&!A|C&B2&B1&B&!A1&!A|C&B2&!B1&B&!A1&!A|C&!B2&!B1&B&!A1&!A|C&!B2&!B1&B&A1&!A|C&B2&!B1&B&A1&!A|C&B2&B1&B&A1&!A|C&!B2&B1&B&A1&!A|C&!B2&B1&!B&A1&!A|C&B2&B1&!B&A1&!A|C&B2&!B1&!B&A1&!A|C&!B2&!B1&!B&A1&A|C&B2&!B1&!B&A1&A|C&B2&B1&!B&A1&A|C&!B2&B1&!B&A1&A|C&!B2&B1&B&A1&A|C&B2&B1&B&A1&A|C&B2&!B1&B&A1&A|C&!B2&!B1&B&A1&A|C&!B2&!B1&B&!A1&A|C&B2&!B1&B&!A1&A|C&B2&B1&B&!A1&A|C&!B2&B1&B&!A1&A|C&!B2&B1&!B&!A1&A|C&B2&B1&!B&!A1&A|C&B2&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAI231.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOI233 -l OAAOI233 -i C2 C1 C B2 B1 B A1 A -o Y -f Y=!(C2&C1&C&!B2&!B1&!B&!A1&!A|C2&C1&C&B2&!B1&!B&!A1&!A|C2&C1&C&B2&B1&!B&!A1&!A|C2&C1&C&!B2&B1&!B&!A1&!A|C2&C1&C&!B2&B1&B&!A1&!A|C2&C1&C&B2&B1&B&!A1&!A|C2&C1&C&B2&!B1&B&!A1&!A|C2&C1&C&!B2&!B1&B&!A1&!A|C2&C1&C&!B2&!B1&B&A1&!A|C2&C1&C&B2&!B1&B&A1&!A|!C2&!C1&!C&B2&B1&B&A1&!A|C2&!C1&!C&B2&B1&B&A1&!A|C2&C1&!C&B2&B1&B&A1&!A|!C2&C1&!C&B2&B1&B&A1&!A|!C2&C1&C&B2&B1&B&A1&!A|C2&C1&C&B2&B1&B&A1&!A|C2&!C1&C&B2&B1&B&A1&!A|!C2&!C1&C&B2&B1&B&A1&!A|C2&C1&C&!B2&B1&B&A1&!A|C2&C1&C&!B2&B1&!B&A1&!A|C2&C1&C&B2&B1&!B&A1&!A|C2&C1&C&B2&!B1&!B&A1&!A|C2&C1&C&!B2&!B1&!B&A1&!A|C2&C1&C&!B2&!B1&!B&A1&A|C2&C1&C&B2&!B1&!B&A1&A|C2&C1&C&B2&B1&!B&A1&A|C2&C1&C&!B2&B1&!B&A1&A|C2&C1&C&!B2&B1&B&A1&A|!C2&!C1&C&B2&B1&B&A1&A|C2&!C1&C&B2&B1&B&A1&A|C2&C1&C&B2&B1&B&A1&A|!C2&C1&C&B2&B1&B&A1&A|!C2&C1&!C&B2&B1&B&A1&A|C2&C1&!C&B2&B1&B&A1&A|C2&!C1&!C&B2&B1&B&A1&A|!C2&!C1&!C&B2&B1&B&A1&A|C2&C1&C&B2&!B1&B&A1&A|C2&C1&C&!B2&!B1&B&A1&A|C2&C1&C&!B2&!B1&B&!A1&A|C2&C1&C&B2&!B1&B&!A1&A|!C2&!C1&!C&B2&B1&B&!A1&A|C2&!C1&!C&B2&B1&B&!A1&A|C2&C1&!C&B2&B1&B&!A1&A|!C2&C1&!C&B2&B1&B&!A1&A|!C2&C1&C&B2&B1&B&!A1&A|C2&C1&C&B2&B1&B&!A1&A|C2&!C1&C&B2&B1&B&!A1&A|!C2&!C1&C&B2&B1&B&!A1&A|C2&C1&C&!B2&B1&B&!A1&A|C2&C1&C&!B2&B1&!B&!A1&A|C2&C1&C&B2&B1&!B&!A1&A|C2&C1&C&B2&!B1&!B&!A1&A|C2&C1&C&!B2&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOI233.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOOAI3212 -l OOAOOAI3212 -i D1 D C B1 B A2 A1 A -o Y -f Y=(!D1&!D&!C&!B1&!B&!A2&!A1&!A|D1&!D&!C&!B1&!B&!A2&!A1&!A|D1&D&!C&!B1&!B&!A2&!A1&!A|!D1&D&!C&!B1&!B&!A2&!A1&!A|!D1&!D&C&!B1&!B&!A2&!A1&!A|!D1&!D&C&B1&!B&!A2&!A1&!A|!D1&D&!C&B1&!B&!A2&!A1&!A|D1&D&!C&B1&!B&!A2&!A1&!A|D1&!D&!C&B1&!B&!A2&!A1&!A|!D1&!D&!C&B1&!B&!A2&!A1&!A|!D1&!D&!C&B1&B&!A2&!A1&!A|D1&!D&!C&B1&B&!A2&!A1&!A|D1&D&!C&B1&B&!A2&!A1&!A|!D1&D&!C&B1&B&!A2&!A1&!A|!D1&!D&C&B1&B&!A2&!A1&!A|!D1&!D&C&!B1&B&!A2&!A1&!A|!D1&D&!C&!B1&B&!A2&!A1&!A|D1&D&!C&!B1&B&!A2&!A1&!A|D1&!D&!C&!B1&B&!A2&!A1&!A|!D1&!D&!C&!B1&B&!A2&!A1&!A|!D1&!D&!C&!B1&B&A2&!A1&!A|!D1&!D&C&!B1&B&A2&!A1&!A|!D1&!D&C&B1&B&A2&!A1&!A|!D1&!D&!C&B1&B&A2&!A1&!A|!D1&!D&!C&B1&!B&A2&!A1&!A|!D1&!D&C&B1&!B&A2&!A1&!A|!D1&!D&C&!B1&!B&A2&!A1&!A|!D1&D&!C&!B1&!B&A2&!A1&!A|D1&D&!C&!B1&!B&A2&!A1&!A|D1&!D&!C&!B1&!B&A2&!A1&!A|!D1&!D&!C&!B1&!B&A2&!A1&!A|!D1&!D&!C&!B1&!B&A2&A1&!A|D1&!D&!C&!B1&!B&A2&A1&!A|D1&D&!C&!B1&!B&A2&A1&!A|!D1&D&!C&!B1&!B&A2&A1&!A|!D1&!D&C&!B1&!B&A2&A1&!A|!D1&!D&C&B1&!B&A2&A1&!A|!D1&!D&!C&B1&!B&A2&A1&!A|!D1&!D&!C&B1&B&A2&A1&!A|!D1&!D&C&B1&B&A2&A1&!A|!D1&!D&C&!B1&B&A2&A1&!A|!D1&!D&!C&!B1&B&A2&A1&!A|!D1&!D&!C&!B1&B&!A2&A1&!A|!D1&!D&C&!B1&B&!A2&A1&!A|!D1&!D&C&B1&B&!A2&A1&!A|!D1&!D&!C&B1&B&!A2&A1&!A|!D1&!D&!C&B1&!B&!A2&A1&!A|!D1&!D&C&B1&!B&!A2&A1&!A|!D1&!D&C&!B1&!B&!A2&A1&!A|!D1&D&!C&!B1&!B&!A2&A1&!A|D1&D&!C&!B1&!B&!A2&A1&!A|D1&!D&!C&!B1&!B&!A2&A1&!A|!D1&!D&!C&!B1&!B&!A2&A1&!A|!D1&!D&!C&!B1&!B&!A2&A1&A|D1&!D&!C&!B1&!B&!A2&A1&A|D1&D&!C&!B1&!B&!A2&A1&A|!D1&D&!C&!B1&!B&!A2&A1&A|!D1&!D&C&!B1&!B&!A2&A1&A|!D1&!D&C&B1&!B&!A2&A1&A|!D1&!D&!C&B1&!B&!A2&A1&A|!D1&!D&!C&B1&B&!A2&A1&A|!D1&!D&C&B1&B&!A2&A1&A|!D1&!D&C&!B1&B&!A2&A1&A|!D1&!D&!C&!B1&B&!A2&A1&A|!D1&!D&!C&!B1&B&A2&A1&A|!D1&!D&C&!B1&B&A2&A1&A|!D1&!D&C&B1&B&A2&A1&A|!D1&!D&!C&B1&B&A2&A1&A|!D1&!D&!C&B1&!B&A2&A1&A|!D1&!D&C&B1&!B&A2&A1&A|!D1&!D&C&!B1&!B&A2&A1&A|!D1&D&!C&!B1&!B&A2&A1&A|D1&D&!C&!B1&!B&A2&A1&A|D1&!D&!C&!B1&!B&A2&A1&A|!D1&!D&!C&!B1&!B&A2&A1&A|!D1&!D&!C&!B1&!B&A2&!A1&A|D1&!D&!C&!B1&!B&A2&!A1&A|D1&D&!C&!B1&!B&A2&!A1&A|!D1&D&!C&!B1&!B&A2&!A1&A|!D1&!D&C&!B1&!B&A2&!A1&A|!D1&!D&C&B1&!B&A2&!A1&A|!D1&!D&!C&B1&!B&A2&!A1&A|!D1&!D&!C&B1&B&A2&!A1&A|!D1&!D&C&B1&B&A2&!A1&A|!D1&!D&C&!B1&B&A2&!A1&A|!D1&!D&!C&!B1&B&A2&!A1&A|!D1&!D&!C&!B1&B&!A2&!A1&A|!D1&!D&C&!B1&B&!A2&!A1&A|!D1&!D&C&B1&B&!A2&!A1&A|!D1&!D&!C&B1&B&!A2&!A1&A|!D1&!D&!C&B1&!B&!A2&!A1&A|!D1&!D&C&B1&!B&!A2&!A1&A|!D1&!D&C&!B1&!B&!A2&!A1&A|!D1&D&!C&!B1&!B&!A2&!A1&A|D1&D&!C&!B1&!B&!A2&!A1&A|D1&!D&!C&!B1&!B&!A2&!A1&A|!D1&!D&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOOAI3212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOOAI2223 -l AAAOOAI2223 -i D2 D1 D C1 C B1 B A1 A -o Y -f Y=(!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|D2&D1&D&!C1&!C&!B1&!B&!A1&!A|D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|D2&!D1&D&C1&!C&!B1&!B&!A1&!A|D2&D1&D&C1&!C&!B1&!B&!A1&!A|!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|D2&D1&!D&C1&!C&!B1&!B&!A1&!A|D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|D2&!D1&D&!C1&C&!B1&!B&!A1&!A|D2&D1&D&!C1&C&!B1&!B&!A1&!A|!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|D2&D1&!D&!C1&C&!B1&!B&!A1&!A|D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|D2&!D1&!D&!C1&C&B1&!B&!A1&!A|D2&D1&!D&!C1&C&B1&!B&!A1&!A|!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!D2&D1&D&!C1&C&B1&!B&!A1&!A|D2&D1&D&!C1&C&B1&!B&!A1&!A|D2&!D1&D&!C1&C&B1&!B&!A1&!A|!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|D2&!D1&!D&C1&!C&B1&!B&!A1&!A|D2&D1&!D&C1&!C&B1&!B&!A1&!A|!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!D2&D1&D&C1&!C&B1&!B&!A1&!A|D2&D1&D&C1&!C&B1&!B&!A1&!A|D2&!D1&D&C1&!C&B1&!B&!A1&!A|!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|D2&!D1&D&!C1&!C&B1&!B&!A1&!A|D2&D1&D&!C1&!C&B1&!B&!A1&!A|!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|D2&D1&!D&!C1&!C&B1&!B&!A1&!A|D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!D2&!D1&!D&C1&C&B1&B&!A1&!A|!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|D2&!D1&!D&!C1&C&!B1&B&!A1&!A|D2&D1&!D&!C1&C&!B1&B&!A1&!A|!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!D2&D1&D&!C1&C&!B1&B&!A1&!A|D2&D1&D&!C1&C&!B1&B&!A1&!A|D2&!D1&D&!C1&C&!B1&B&!A1&!A|!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|D2&!D1&!D&C1&!C&!B1&B&!A1&!A|D2&D1&!D&C1&!C&!B1&B&!A1&!A|!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!D2&D1&D&C1&!C&!B1&B&!A1&!A|D2&D1&D&C1&!C&!B1&B&!A1&!A|D2&!D1&D&C1&!C&!B1&B&!A1&!A|!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|D2&!D1&D&!C1&!C&!B1&B&!A1&!A|D2&D1&D&!C1&!C&!B1&B&!A1&!A|!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|D2&D1&!D&!C1&!C&!B1&B&!A1&!A|D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|D2&!D1&!D&!C1&!C&!B1&B&A1&!A|D2&D1&!D&!C1&!C&!B1&B&A1&!A|!D2&D1&!D&!C1&!C&!B1&B&A1&!A|!D2&D1&D&!C1&!C&!B1&B&A1&!A|D2&D1&D&!C1&!C&!B1&B&A1&!A|D2&!D1&D&!C1&!C&!B1&B&A1&!A|!D2&!D1&D&!C1&!C&!B1&B&A1&!A|!D2&!D1&D&C1&!C&!B1&B&A1&!A|D2&!D1&D&C1&!C&!B1&B&A1&!A|D2&D1&D&C1&!C&!B1&B&A1&!A|!D2&D1&D&C1&!C&!B1&B&A1&!A|!D2&D1&!D&C1&!C&!B1&B&A1&!A|D2&D1&!D&C1&!C&!B1&B&A1&!A|D2&!D1&!D&C1&!C&!B1&B&A1&!A|!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!D2&!D1&!D&C1&C&!B1&B&A1&!A|!D2&!D1&D&!C1&C&!B1&B&A1&!A|D2&!D1&D&!C1&C&!B1&B&A1&!A|D2&D1&D&!C1&C&!B1&B&A1&!A|!D2&D1&D&!C1&C&!B1&B&A1&!A|!D2&D1&!D&!C1&C&!B1&B&A1&!A|D2&D1&!D&!C1&C&!B1&B&A1&!A|D2&!D1&!D&!C1&C&!B1&B&A1&!A|!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!D2&!D1&!D&!C1&C&B1&B&A1&!A|!D2&!D1&!D&C1&C&B1&B&A1&!A|!D2&!D1&!D&C1&!C&B1&B&A1&!A|!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|D2&!D1&!D&!C1&!C&B1&!B&A1&!A|D2&D1&!D&!C1&!C&B1&!B&A1&!A|!D2&D1&!D&!C1&!C&B1&!B&A1&!A|!D2&D1&D&!C1&!C&B1&!B&A1&!A|D2&D1&D&!C1&!C&B1&!B&A1&!A|D2&!D1&D&!C1&!C&B1&!B&A1&!A|!D2&!D1&D&!C1&!C&B1&!B&A1&!A|!D2&!D1&D&C1&!C&B1&!B&A1&!A|D2&!D1&D&C1&!C&B1&!B&A1&!A|D2&D1&D&C1&!C&B1&!B&A1&!A|!D2&D1&D&C1&!C&B1&!B&A1&!A|!D2&D1&!D&C1&!C&B1&!B&A1&!A|D2&D1&!D&C1&!C&B1&!B&A1&!A|D2&!D1&!D&C1&!C&B1&!B&A1&!A|!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!D2&!D1&!D&C1&C&B1&!B&A1&!A|!D2&!D1&D&!C1&C&B1&!B&A1&!A|D2&!D1&D&!C1&C&B1&!B&A1&!A|D2&D1&D&!C1&C&B1&!B&A1&!A|!D2&D1&D&!C1&C&B1&!B&A1&!A|!D2&D1&!D&!C1&C&B1&!B&A1&!A|D2&D1&!D&!C1&C&B1&!B&A1&!A|D2&!D1&!D&!C1&C&B1&!B&A1&!A|!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|D2&!D1&!D&!C1&C&!B1&!B&A1&!A|D2&D1&!D&!C1&C&!B1&!B&A1&!A|!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!D2&D1&D&!C1&C&!B1&!B&A1&!A|D2&D1&D&!C1&C&!B1&!B&A1&!A|D2&!D1&D&!C1&C&!B1&!B&A1&!A|!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|D2&!D1&!D&C1&!C&!B1&!B&A1&!A|D2&D1&!D&C1&!C&!B1&!B&A1&!A|!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!D2&D1&D&C1&!C&!B1&!B&A1&!A|D2&D1&D&C1&!C&!B1&!B&A1&!A|D2&!D1&D&C1&!C&!B1&!B&A1&!A|!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|D2&!D1&D&!C1&!C&!B1&!B&A1&!A|D2&D1&D&!C1&!C&!B1&!B&A1&!A|!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|D2&D1&!D&!C1&!C&!B1&!B&A1&!A|D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!D2&!D1&!D&C1&C&!B1&!B&A1&A|!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!D2&!D1&!D&!C1&C&B1&!B&A1&A|!D2&!D1&!D&C1&C&B1&!B&A1&A|!D2&!D1&!D&C1&!C&B1&!B&A1&A|!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!D2&!D1&!D&!C1&!C&B1&B&A1&A|!D2&!D1&!D&C1&!C&B1&B&A1&A|!D2&!D1&!D&C1&C&B1&B&A1&A|!D2&!D1&!D&!C1&C&B1&B&A1&A|!D2&!D1&!D&!C1&C&!B1&B&A1&A|!D2&!D1&!D&C1&C&!B1&B&A1&A|!D2&!D1&!D&C1&!C&!B1&B&A1&A|!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|D2&!D1&!D&!C1&!C&!B1&B&!A1&A|D2&D1&!D&!C1&!C&!B1&B&!A1&A|!D2&D1&!D&!C1&!C&!B1&B&!A1&A|!D2&D1&D&!C1&!C&!B1&B&!A1&A|D2&D1&D&!C1&!C&!B1&B&!A1&A|D2&!D1&D&!C1&!C&!B1&B&!A1&A|!D2&!D1&D&!C1&!C&!B1&B&!A1&A|!D2&!D1&D&C1&!C&!B1&B&!A1&A|D2&!D1&D&C1&!C&!B1&B&!A1&A|D2&D1&D&C1&!C&!B1&B&!A1&A|!D2&D1&D&C1&!C&!B1&B&!A1&A|!D2&D1&!D&C1&!C&!B1&B&!A1&A|D2&D1&!D&C1&!C&!B1&B&!A1&A|D2&!D1&!D&C1&!C&!B1&B&!A1&A|!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!D2&!D1&!D&C1&C&!B1&B&!A1&A|!D2&!D1&D&!C1&C&!B1&B&!A1&A|D2&!D1&D&!C1&C&!B1&B&!A1&A|D2&D1&D&!C1&C&!B1&B&!A1&A|!D2&D1&D&!C1&C&!B1&B&!A1&A|!D2&D1&!D&!C1&C&!B1&B&!A1&A|D2&D1&!D&!C1&C&!B1&B&!A1&A|D2&!D1&!D&!C1&C&!B1&B&!A1&A|!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!D2&!D1&!D&!C1&C&B1&B&!A1&A|!D2&!D1&!D&C1&C&B1&B&!A1&A|!D2&!D1&!D&C1&!C&B1&B&!A1&A|!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|D2&!D1&!D&!C1&!C&B1&!B&!A1&A|D2&D1&!D&!C1&!C&B1&!B&!A1&A|!D2&D1&!D&!C1&!C&B1&!B&!A1&A|!D2&D1&D&!C1&!C&B1&!B&!A1&A|D2&D1&D&!C1&!C&B1&!B&!A1&A|D2&!D1&D&!C1&!C&B1&!B&!A1&A|!D2&!D1&D&!C1&!C&B1&!B&!A1&A|!D2&!D1&D&C1&!C&B1&!B&!A1&A|D2&!D1&D&C1&!C&B1&!B&!A1&A|D2&D1&D&C1&!C&B1&!B&!A1&A|!D2&D1&D&C1&!C&B1&!B&!A1&A|!D2&D1&!D&C1&!C&B1&!B&!A1&A|D2&D1&!D&C1&!C&B1&!B&!A1&A|D2&!D1&!D&C1&!C&B1&!B&!A1&A|!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!D2&!D1&!D&C1&C&B1&!B&!A1&A|!D2&!D1&D&!C1&C&B1&!B&!A1&A|D2&!D1&D&!C1&C&B1&!B&!A1&A|D2&D1&D&!C1&C&B1&!B&!A1&A|!D2&D1&D&!C1&C&B1&!B&!A1&A|!D2&D1&!D&!C1&C&B1&!B&!A1&A|D2&D1&!D&!C1&C&B1&!B&!A1&A|D2&!D1&!D&!C1&C&B1&!B&!A1&A|!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|D2&!D1&!D&!C1&C&!B1&!B&!A1&A|D2&D1&!D&!C1&C&!B1&!B&!A1&A|!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!D2&D1&D&!C1&C&!B1&!B&!A1&A|D2&D1&D&!C1&C&!B1&!B&!A1&A|D2&!D1&D&!C1&C&!B1&!B&!A1&A|!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|D2&!D1&!D&C1&!C&!B1&!B&!A1&A|D2&D1&!D&C1&!C&!B1&!B&!A1&A|!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!D2&D1&D&C1&!C&!B1&!B&!A1&A|D2&D1&D&C1&!C&!B1&!B&!A1&A|D2&!D1&D&C1&!C&!B1&!B&!A1&A|!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|D2&!D1&D&!C1&!C&!B1&!B&!A1&A|D2&D1&D&!C1&!C&!B1&!B&!A1&A|!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|D2&D1&!D&!C1&!C&!B1&!B&!A1&A|D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOOAI2223.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAOAI22111 -l AAOAOAI22111 -i E D C B1 B A1 A -o Y -f Y=!(E&D&!C&!B1&!B&!A1&!A|E&D&C&!B1&!B&!A1&!A|E&D&C&B1&!B&!A1&!A|E&D&!C&B1&!B&!A1&!A|E&D&!C&B1&B&!A1&!A|E&D&C&B1&B&!A1&!A|E&!D&C&B1&B&!A1&!A|E&D&C&!B1&B&!A1&!A|E&D&!C&!B1&B&!A1&!A|E&D&!C&!B1&B&A1&!A|E&D&C&!B1&B&A1&!A|E&!D&C&B1&B&A1&!A|E&D&C&B1&B&A1&!A|E&D&!C&B1&B&A1&!A|E&D&!C&B1&!B&A1&!A|E&D&C&B1&!B&A1&!A|E&D&C&!B1&!B&A1&!A|E&D&!C&!B1&!B&A1&!A|E&D&!C&!B1&!B&A1&A|E&D&C&!B1&!B&A1&A|E&!D&C&!B1&!B&A1&A|E&!D&C&B1&!B&A1&A|E&D&C&B1&!B&A1&A|E&D&!C&B1&!B&A1&A|E&D&!C&B1&B&A1&A|E&D&C&B1&B&A1&A|E&!D&C&B1&B&A1&A|E&!D&C&!B1&B&A1&A|E&D&C&!B1&B&A1&A|E&D&!C&!B1&B&A1&A|E&D&!C&!B1&B&!A1&A|E&D&C&!B1&B&!A1&A|E&!D&C&B1&B&!A1&A|E&D&C&B1&B&!A1&A|E&D&!C&B1&B&!A1&A|E&D&!C&B1&!B&!A1&A|E&D&C&B1&!B&!A1&A|E&D&C&!B1&!B&!A1&A|E&D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAOAI22111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n vanberkel1991 -l vanberkel1991 -i A B -o C -f C=!(!A&!B) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist vanberkel1991.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAI321 -l OOAI321 -i C B1 B A2 A1 A -o Y -f Y=!(C&!B1&B&A2&!A1&!A|C&B1&B&A2&!A1&!A|C&B1&!B&A2&!A1&!A|C&B1&!B&A2&A1&!A|C&B1&B&A2&A1&!A|C&!B1&B&A2&A1&!A|C&!B1&B&!A2&A1&!A|C&B1&B&!A2&A1&!A|C&B1&!B&!A2&A1&!A|C&B1&!B&!A2&A1&A|C&B1&B&!A2&A1&A|C&!B1&B&!A2&A1&A|C&!B1&B&A2&A1&A|C&B1&B&A2&A1&A|C&B1&!B&A2&A1&A|C&B1&!B&A2&!A1&A|C&B1&B&A2&!A1&A|C&!B1&B&A2&!A1&A|C&!B1&B&!A2&!A1&A|C&B1&B&!A2&!A1&A|C&B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAI321.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOAOI22221 -l OOAAOAOI22221 -i E D1 D C1 C B1 B A1 A -o Y -f Y=(!E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&D1&D&C1&!C&!B1&!B&!A1&!A|!E&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&D1&!D&C1&C&!B1&!B&!A1&!A|!E&!D1&D&C1&C&!B1&!B&!A1&!A|!E&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&D1&D&!C1&C&!B1&!B&!A1&!A|!E&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&D1&!D&!C1&C&B1&!B&!A1&!A|!E&D1&D&!C1&C&B1&!B&!A1&!A|!E&!D1&D&!C1&C&B1&!B&!A1&!A|!E&!D1&D&C1&C&B1&!B&!A1&!A|!E&D1&!D&C1&C&B1&!B&!A1&!A|!E&!D1&!D&C1&C&B1&!B&!A1&!A|!E&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&D1&!D&C1&!C&B1&!B&!A1&!A|!E&D1&D&C1&!C&B1&!B&!A1&!A|!E&!D1&D&C1&!C&B1&!B&!A1&!A|!E&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&D1&D&!C1&!C&B1&!B&!A1&!A|!E&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&D1&!D&!C1&!C&B1&B&!A1&!A|!E&D1&D&!C1&!C&B1&B&!A1&!A|!E&!D1&D&!C1&!C&B1&B&!A1&!A|!E&!D1&D&C1&!C&B1&B&!A1&!A|!E&D1&D&C1&!C&B1&B&!A1&!A|!E&D1&!D&C1&!C&B1&B&!A1&!A|!E&!D1&!D&C1&!C&B1&B&!A1&!A|!E&!D1&!D&C1&C&B1&B&!A1&!A|!E&D1&!D&C1&C&B1&B&!A1&!A|!E&!D1&D&C1&C&B1&B&!A1&!A|!E&!D1&D&!C1&C&B1&B&!A1&!A|!E&D1&D&!C1&C&B1&B&!A1&!A|!E&D1&!D&!C1&C&B1&B&!A1&!A|!E&!D1&!D&!C1&C&B1&B&!A1&!A|!E&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&D1&!D&!C1&C&!B1&B&!A1&!A|!E&D1&D&!C1&C&!B1&B&!A1&!A|!E&!D1&D&!C1&C&!B1&B&!A1&!A|!E&!D1&D&C1&C&!B1&B&!A1&!A|!E&D1&!D&C1&C&!B1&B&!A1&!A|!E&!D1&!D&C1&C&!B1&B&!A1&!A|!E&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&D1&!D&C1&!C&!B1&B&!A1&!A|!E&D1&D&C1&!C&!B1&B&!A1&!A|!E&!D1&D&C1&!C&!B1&B&!A1&!A|!E&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&D1&D&!C1&!C&!B1&B&!A1&!A|!E&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&D1&!D&!C1&!C&!B1&B&A1&!A|!E&!D1&D&!C1&!C&!B1&B&A1&!A|!E&!D1&D&C1&!C&!B1&B&A1&!A|!E&D1&!D&C1&!C&!B1&B&A1&!A|!E&!D1&!D&C1&!C&!B1&B&A1&!A|!E&!D1&!D&C1&C&!B1&B&A1&!A|!E&D1&!D&C1&C&!B1&B&A1&!A|!E&!D1&D&C1&C&!B1&B&A1&!A|!E&!D1&D&!C1&C&!B1&B&A1&!A|!E&D1&!D&!C1&C&!B1&B&A1&!A|!E&!D1&!D&!C1&C&!B1&B&A1&!A|!E&!D1&!D&!C1&C&B1&B&A1&!A|!E&D1&!D&!C1&C&B1&B&A1&!A|!E&!D1&D&!C1&C&B1&B&A1&!A|!E&!D1&D&C1&C&B1&B&A1&!A|!E&D1&!D&C1&C&B1&B&A1&!A|!E&!D1&!D&C1&C&B1&B&A1&!A|!E&!D1&!D&C1&!C&B1&B&A1&!A|!E&D1&!D&C1&!C&B1&B&A1&!A|!E&!D1&D&C1&!C&B1&B&A1&!A|!E&!D1&D&!C1&!C&B1&B&A1&!A|!E&D1&!D&!C1&!C&B1&B&A1&!A|!E&!D1&!D&!C1&!C&B1&B&A1&!A|!E&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&D1&!D&!C1&!C&B1&!B&A1&!A|!E&!D1&D&!C1&!C&B1&!B&A1&!A|!E&!D1&D&C1&!C&B1&!B&A1&!A|!E&D1&!D&C1&!C&B1&!B&A1&!A|!E&!D1&!D&C1&!C&B1&!B&A1&!A|!E&!D1&!D&C1&C&B1&!B&A1&!A|!E&D1&!D&C1&C&B1&!B&A1&!A|!E&!D1&D&C1&C&B1&!B&A1&!A|!E&!D1&D&!C1&C&B1&!B&A1&!A|!E&D1&!D&!C1&C&B1&!B&A1&!A|!E&!D1&!D&!C1&C&B1&!B&A1&!A|!E&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&D1&!D&!C1&C&!B1&!B&A1&!A|!E&D1&D&!C1&C&!B1&!B&A1&!A|!E&!D1&D&!C1&C&!B1&!B&A1&!A|!E&!D1&D&C1&C&!B1&!B&A1&!A|!E&D1&!D&C1&C&!B1&!B&A1&!A|!E&!D1&!D&C1&C&!B1&!B&A1&!A|!E&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&D1&!D&C1&!C&!B1&!B&A1&!A|!E&D1&D&C1&!C&!B1&!B&A1&!A|!E&!D1&D&C1&!C&!B1&!B&A1&!A|!E&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&D1&D&!C1&!C&!B1&!B&A1&!A|!E&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&D1&!D&!C1&!C&!B1&!B&A1&A|!E&D1&D&!C1&!C&!B1&!B&A1&A|!E&!D1&D&!C1&!C&!B1&!B&A1&A|!E&!D1&D&C1&!C&!B1&!B&A1&A|!E&D1&D&C1&!C&!B1&!B&A1&A|!E&D1&!D&C1&!C&!B1&!B&A1&A|!E&!D1&!D&C1&!C&!B1&!B&A1&A|!E&!D1&!D&C1&C&!B1&!B&A1&A|!E&D1&!D&C1&C&!B1&!B&A1&A|!E&!D1&D&C1&C&!B1&!B&A1&A|!E&!D1&D&!C1&C&!B1&!B&A1&A|!E&D1&D&!C1&C&!B1&!B&A1&A|!E&D1&!D&!C1&C&!B1&!B&A1&A|!E&!D1&!D&!C1&C&!B1&!B&A1&A|!E&!D1&!D&!C1&C&B1&!B&A1&A|!E&D1&!D&!C1&C&B1&!B&A1&A|!E&!D1&D&!C1&C&B1&!B&A1&A|!E&!D1&D&C1&C&B1&!B&A1&A|!E&D1&!D&C1&C&B1&!B&A1&A|!E&!D1&!D&C1&C&B1&!B&A1&A|!E&!D1&!D&C1&!C&B1&!B&A1&A|!E&D1&!D&C1&!C&B1&!B&A1&A|!E&!D1&D&C1&!C&B1&!B&A1&A|!E&!D1&D&!C1&!C&B1&!B&A1&A|!E&D1&!D&!C1&!C&B1&!B&A1&A|!E&!D1&!D&!C1&!C&B1&!B&A1&A|!E&!D1&!D&!C1&!C&B1&B&A1&A|!E&D1&!D&!C1&!C&B1&B&A1&A|!E&!D1&D&!C1&!C&B1&B&A1&A|!E&!D1&D&C1&!C&B1&B&A1&A|!E&D1&!D&C1&!C&B1&B&A1&A|!E&!D1&!D&C1&!C&B1&B&A1&A|!E&!D1&!D&C1&C&B1&B&A1&A|!E&D1&!D&C1&C&B1&B&A1&A|!E&!D1&D&C1&C&B1&B&A1&A|!E&!D1&D&!C1&C&B1&B&A1&A|!E&D1&!D&!C1&C&B1&B&A1&A|!E&!D1&!D&!C1&C&B1&B&A1&A|!E&!D1&!D&!C1&C&!B1&B&A1&A|!E&D1&!D&!C1&C&!B1&B&A1&A|!E&!D1&D&!C1&C&!B1&B&A1&A|!E&!D1&D&C1&C&!B1&B&A1&A|!E&D1&!D&C1&C&!B1&B&A1&A|!E&!D1&!D&C1&C&!B1&B&A1&A|!E&!D1&!D&C1&!C&!B1&B&A1&A|!E&D1&!D&C1&!C&!B1&B&A1&A|!E&!D1&D&C1&!C&!B1&B&A1&A|!E&!D1&D&!C1&!C&!B1&B&A1&A|!E&D1&!D&!C1&!C&!B1&B&A1&A|!E&!D1&!D&!C1&!C&!B1&B&A1&A|!E&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&D1&!D&!C1&!C&!B1&B&!A1&A|!E&!D1&D&!C1&!C&!B1&B&!A1&A|!E&!D1&D&C1&!C&!B1&B&!A1&A|!E&D1&!D&C1&!C&!B1&B&!A1&A|!E&!D1&!D&C1&!C&!B1&B&!A1&A|!E&!D1&!D&C1&C&!B1&B&!A1&A|!E&D1&!D&C1&C&!B1&B&!A1&A|!E&!D1&D&C1&C&!B1&B&!A1&A|!E&!D1&D&!C1&C&!B1&B&!A1&A|!E&D1&!D&!C1&C&!B1&B&!A1&A|!E&!D1&!D&!C1&C&!B1&B&!A1&A|!E&!D1&!D&!C1&C&B1&B&!A1&A|!E&D1&!D&!C1&C&B1&B&!A1&A|!E&!D1&D&!C1&C&B1&B&!A1&A|!E&!D1&D&C1&C&B1&B&!A1&A|!E&D1&!D&C1&C&B1&B&!A1&A|!E&!D1&!D&C1&C&B1&B&!A1&A|!E&!D1&!D&C1&!C&B1&B&!A1&A|!E&D1&!D&C1&!C&B1&B&!A1&A|!E&!D1&D&C1&!C&B1&B&!A1&A|!E&!D1&D&!C1&!C&B1&B&!A1&A|!E&D1&!D&!C1&!C&B1&B&!A1&A|!E&!D1&!D&!C1&!C&B1&B&!A1&A|!E&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&D1&!D&!C1&!C&B1&!B&!A1&A|!E&!D1&D&!C1&!C&B1&!B&!A1&A|!E&!D1&D&C1&!C&B1&!B&!A1&A|!E&D1&!D&C1&!C&B1&!B&!A1&A|!E&!D1&!D&C1&!C&B1&!B&!A1&A|!E&!D1&!D&C1&C&B1&!B&!A1&A|!E&D1&!D&C1&C&B1&!B&!A1&A|!E&!D1&D&C1&C&B1&!B&!A1&A|!E&!D1&D&!C1&C&B1&!B&!A1&A|!E&D1&!D&!C1&C&B1&!B&!A1&A|!E&!D1&!D&!C1&C&B1&!B&!A1&A|!E&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&D1&!D&!C1&C&!B1&!B&!A1&A|!E&D1&D&!C1&C&!B1&!B&!A1&A|!E&!D1&D&!C1&C&!B1&!B&!A1&A|!E&!D1&D&C1&C&!B1&!B&!A1&A|!E&D1&!D&C1&C&!B1&!B&!A1&A|!E&!D1&!D&C1&C&!B1&!B&!A1&A|!E&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&D1&!D&C1&!C&!B1&!B&!A1&A|!E&D1&D&C1&!C&!B1&!B&!A1&A|!E&!D1&D&C1&!C&!B1&!B&!A1&A|!E&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&D1&D&!C1&!C&!B1&!B&!A1&A|!E&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOAOI22221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAAOAOI222211 -l AAOOAAOAOI222211 -i F E D1 D C1 C B1 B A1 A -o Y -f Y=(!F&!E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D1&D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&!D1&D&C1&!C&!B1&!B&!A1&!A|!F&E&!D1&D&C1&!C&!B1&!B&!A1&!A|!F&!E&D1&D&C1&!C&!B1&!B&!A1&!A|!F&!E&D1&!D&C1&!C&!B1&!B&!A1&!A|!F&E&D1&!D&C1&!C&!B1&!B&!A1&!A|!F&E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D1&!D&C1&C&!B1&!B&!A1&!A|!F&E&!D1&!D&C1&C&!B1&!B&!A1&!A|!F&E&D1&!D&C1&C&!B1&!B&!A1&!A|!F&!E&D1&!D&C1&C&!B1&!B&!A1&!A|!F&!E&D1&D&C1&C&!B1&!B&!A1&!A|!F&E&!D1&D&C1&C&!B1&!B&!A1&!A|!F&!E&!D1&D&C1&C&!B1&!B&!A1&!A|!F&!E&!D1&D&!C1&C&!B1&!B&!A1&!A|!F&E&!D1&D&!C1&C&!B1&!B&!A1&!A|!F&!E&D1&D&!C1&C&!B1&!B&!A1&!A|!F&!E&D1&!D&!C1&C&!B1&!B&!A1&!A|!F&E&D1&!D&!C1&C&!B1&!B&!A1&!A|!F&E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D1&!D&!C1&C&B1&!B&!A1&!A|!F&E&!D1&!D&!C1&C&B1&!B&!A1&!A|!F&E&D1&!D&!C1&C&B1&!B&!A1&!A|!F&!E&D1&!D&!C1&C&B1&!B&!A1&!A|!F&!E&D1&D&!C1&C&B1&!B&!A1&!A|!F&E&!D1&D&!C1&C&B1&!B&!A1&!A|!F&!E&!D1&D&!C1&C&B1&!B&!A1&!A|!F&!E&!D1&D&C1&C&B1&!B&!A1&!A|!F&E&!D1&D&C1&C&B1&!B&!A1&!A|!F&!E&D1&D&C1&C&B1&!B&!A1&!A|!F&!E&D1&!D&C1&C&B1&!B&!A1&!A|!F&E&D1&!D&C1&C&B1&!B&!A1&!A|!F&E&!D1&!D&C1&C&B1&!B&!A1&!A|!F&!E&!D1&!D&C1&C&B1&!B&!A1&!A|!F&!E&!D1&!D&C1&!C&B1&!B&!A1&!A|!F&E&!D1&!D&C1&!C&B1&!B&!A1&!A|!F&E&D1&!D&C1&!C&B1&!B&!A1&!A|!F&!E&D1&!D&C1&!C&B1&!B&!A1&!A|!F&!E&D1&D&C1&!C&B1&!B&!A1&!A|!F&E&!D1&D&C1&!C&B1&!B&!A1&!A|!F&!E&!D1&D&C1&!C&B1&!B&!A1&!A|!F&!E&!D1&D&!C1&!C&B1&!B&!A1&!A|!F&E&!D1&D&!C1&!C&B1&!B&!A1&!A|!F&!E&D1&D&!C1&!C&B1&!B&!A1&!A|!F&!E&D1&!D&!C1&!C&B1&!B&!A1&!A|!F&E&D1&!D&!C1&!C&B1&!B&!A1&!A|!F&E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D1&!D&!C1&!C&B1&B&!A1&!A|!F&E&!D1&!D&!C1&!C&B1&B&!A1&!A|!F&E&D1&!D&!C1&!C&B1&B&!A1&!A|!F&!E&D1&!D&!C1&!C&B1&B&!A1&!A|!F&!E&D1&D&!C1&!C&B1&B&!A1&!A|!F&E&!D1&D&!C1&!C&B1&B&!A1&!A|!F&!E&!D1&D&!C1&!C&B1&B&!A1&!A|!F&!E&!D1&D&C1&!C&B1&B&!A1&!A|!F&!E&D1&D&C1&!C&B1&B&!A1&!A|!F&!E&D1&!D&C1&!C&B1&B&!A1&!A|!F&!E&!D1&!D&C1&!C&B1&B&!A1&!A|!F&!E&!D1&!D&C1&C&B1&B&!A1&!A|!F&!E&D1&!D&C1&C&B1&B&!A1&!A|!F&!E&D1&D&C1&C&B1&B&!A1&!A|!F&!E&!D1&D&C1&C&B1&B&!A1&!A|!F&!E&!D1&D&!C1&C&B1&B&!A1&!A|!F&!E&D1&D&!C1&C&B1&B&!A1&!A|!F&!E&D1&!D&!C1&C&B1&B&!A1&!A|!F&!E&!D1&!D&!C1&C&B1&B&!A1&!A|!F&!E&!D1&!D&!C1&C&!B1&B&!A1&!A|!F&E&!D1&!D&!C1&C&!B1&B&!A1&!A|!F&E&D1&!D&!C1&C&!B1&B&!A1&!A|!F&!E&D1&!D&!C1&C&!B1&B&!A1&!A|!F&!E&D1&D&!C1&C&!B1&B&!A1&!A|!F&E&!D1&D&!C1&C&!B1&B&!A1&!A|!F&!E&!D1&D&!C1&C&!B1&B&!A1&!A|!F&!E&!D1&D&C1&C&!B1&B&!A1&!A|!F&E&!D1&D&C1&C&!B1&B&!A1&!A|!F&!E&D1&D&C1&C&!B1&B&!A1&!A|!F&!E&D1&!D&C1&C&!B1&B&!A1&!A|!F&E&D1&!D&C1&C&!B1&B&!A1&!A|!F&E&!D1&!D&C1&C&!B1&B&!A1&!A|!F&!E&!D1&!D&C1&C&!B1&B&!A1&!A|!F&!E&!D1&!D&C1&!C&!B1&B&!A1&!A|!F&E&!D1&!D&C1&!C&!B1&B&!A1&!A|!F&E&D1&!D&C1&!C&!B1&B&!A1&!A|!F&!E&D1&!D&C1&!C&!B1&B&!A1&!A|!F&!E&D1&D&C1&!C&!B1&B&!A1&!A|!F&E&!D1&D&C1&!C&!B1&B&!A1&!A|!F&!E&!D1&D&C1&!C&!B1&B&!A1&!A|!F&!E&!D1&D&!C1&!C&!B1&B&!A1&!A|!F&E&!D1&D&!C1&!C&!B1&B&!A1&!A|!F&!E&D1&D&!C1&!C&!B1&B&!A1&!A|!F&!E&D1&!D&!C1&!C&!B1&B&!A1&!A|!F&E&D1&!D&!C1&!C&!B1&B&!A1&!A|!F&E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D1&!D&!C1&!C&!B1&B&A1&!A|!F&E&!D1&!D&!C1&!C&!B1&B&A1&!A|!F&E&D1&!D&!C1&!C&!B1&B&A1&!A|!F&!E&D1&!D&!C1&!C&!B1&B&A1&!A|!F&!E&D1&D&!C1&!C&!B1&B&A1&!A|!F&E&!D1&D&!C1&!C&!B1&B&A1&!A|!F&!E&!D1&D&!C1&!C&!B1&B&A1&!A|!F&!E&!D1&D&C1&!C&!B1&B&A1&!A|!F&E&!D1&D&C1&!C&!B1&B&A1&!A|!F&!E&D1&D&C1&!C&!B1&B&A1&!A|!F&!E&D1&!D&C1&!C&!B1&B&A1&!A|!F&E&D1&!D&C1&!C&!B1&B&A1&!A|!F&E&!D1&!D&C1&!C&!B1&B&A1&!A|!F&!E&!D1&!D&C1&!C&!B1&B&A1&!A|!F&!E&!D1&!D&C1&C&!B1&B&A1&!A|!F&E&!D1&!D&C1&C&!B1&B&A1&!A|!F&E&D1&!D&C1&C&!B1&B&A1&!A|!F&!E&D1&!D&C1&C&!B1&B&A1&!A|!F&!E&D1&D&C1&C&!B1&B&A1&!A|!F&E&!D1&D&C1&C&!B1&B&A1&!A|!F&!E&!D1&D&C1&C&!B1&B&A1&!A|!F&!E&!D1&D&!C1&C&!B1&B&A1&!A|!F&E&!D1&D&!C1&C&!B1&B&A1&!A|!F&!E&D1&D&!C1&C&!B1&B&A1&!A|!F&!E&D1&!D&!C1&C&!B1&B&A1&!A|!F&E&D1&!D&!C1&C&!B1&B&A1&!A|!F&E&!D1&!D&!C1&C&!B1&B&A1&!A|!F&!E&!D1&!D&!C1&C&!B1&B&A1&!A|!F&!E&!D1&!D&!C1&C&B1&B&A1&!A|!F&!E&D1&!D&!C1&C&B1&B&A1&!A|!F&!E&D1&D&!C1&C&B1&B&A1&!A|!F&!E&!D1&D&!C1&C&B1&B&A1&!A|!F&!E&!D1&D&C1&C&B1&B&A1&!A|!F&!E&D1&D&C1&C&B1&B&A1&!A|!F&!E&D1&!D&C1&C&B1&B&A1&!A|!F&!E&!D1&!D&C1&C&B1&B&A1&!A|!F&!E&!D1&!D&C1&!C&B1&B&A1&!A|!F&!E&D1&!D&C1&!C&B1&B&A1&!A|!F&!E&D1&D&C1&!C&B1&B&A1&!A|!F&!E&!D1&D&C1&!C&B1&B&A1&!A|!F&!E&!D1&D&!C1&!C&B1&B&A1&!A|!F&E&!D1&D&!C1&!C&B1&B&A1&!A|!F&!E&D1&D&!C1&!C&B1&B&A1&!A|!F&!E&D1&!D&!C1&!C&B1&B&A1&!A|!F&E&D1&!D&!C1&!C&B1&B&A1&!A|!F&E&!D1&!D&!C1&!C&B1&B&A1&!A|!F&!E&!D1&!D&!C1&!C&B1&B&A1&!A|!F&!E&!D1&!D&!C1&!C&B1&!B&A1&!A|!F&E&!D1&!D&!C1&!C&B1&!B&A1&!A|!F&E&D1&!D&!C1&!C&B1&!B&A1&!A|!F&!E&D1&!D&!C1&!C&B1&!B&A1&!A|!F&!E&D1&D&!C1&!C&B1&!B&A1&!A|!F&E&!D1&D&!C1&!C&B1&!B&A1&!A|!F&!E&!D1&D&!C1&!C&B1&!B&A1&!A|!F&!E&!D1&D&C1&!C&B1&!B&A1&!A|!F&E&!D1&D&C1&!C&B1&!B&A1&!A|!F&!E&D1&D&C1&!C&B1&!B&A1&!A|!F&!E&D1&!D&C1&!C&B1&!B&A1&!A|!F&E&D1&!D&C1&!C&B1&!B&A1&!A|!F&E&!D1&!D&C1&!C&B1&!B&A1&!A|!F&!E&!D1&!D&C1&!C&B1&!B&A1&!A|!F&!E&!D1&!D&C1&C&B1&!B&A1&!A|!F&E&!D1&!D&C1&C&B1&!B&A1&!A|!F&E&D1&!D&C1&C&B1&!B&A1&!A|!F&!E&D1&!D&C1&C&B1&!B&A1&!A|!F&!E&D1&D&C1&C&B1&!B&A1&!A|!F&E&!D1&D&C1&C&B1&!B&A1&!A|!F&!E&!D1&D&C1&C&B1&!B&A1&!A|!F&!E&!D1&D&!C1&C&B1&!B&A1&!A|!F&E&!D1&D&!C1&C&B1&!B&A1&!A|!F&!E&D1&D&!C1&C&B1&!B&A1&!A|!F&!E&D1&!D&!C1&C&B1&!B&A1&!A|!F&E&D1&!D&!C1&C&B1&!B&A1&!A|!F&E&!D1&!D&!C1&C&B1&!B&A1&!A|!F&!E&!D1&!D&!C1&C&B1&!B&A1&!A|!F&!E&!D1&!D&!C1&C&!B1&!B&A1&!A|!F&E&!D1&!D&!C1&C&!B1&!B&A1&!A|!F&E&D1&!D&!C1&C&!B1&!B&A1&!A|!F&!E&D1&!D&!C1&C&!B1&!B&A1&!A|!F&!E&D1&D&!C1&C&!B1&!B&A1&!A|!F&E&!D1&D&!C1&C&!B1&!B&A1&!A|!F&!E&!D1&D&!C1&C&!B1&!B&A1&!A|!F&!E&!D1&D&C1&C&!B1&!B&A1&!A|!F&E&!D1&D&C1&C&!B1&!B&A1&!A|!F&!E&D1&D&C1&C&!B1&!B&A1&!A|!F&!E&D1&!D&C1&C&!B1&!B&A1&!A|!F&E&D1&!D&C1&C&!B1&!B&A1&!A|!F&E&!D1&!D&C1&C&!B1&!B&A1&!A|!F&!E&!D1&!D&C1&C&!B1&!B&A1&!A|!F&!E&!D1&!D&C1&!C&!B1&!B&A1&!A|!F&E&!D1&!D&C1&!C&!B1&!B&A1&!A|!F&E&D1&!D&C1&!C&!B1&!B&A1&!A|!F&!E&D1&!D&C1&!C&!B1&!B&A1&!A|!F&!E&D1&D&C1&!C&!B1&!B&A1&!A|!F&E&!D1&D&C1&!C&!B1&!B&A1&!A|!F&!E&!D1&D&C1&!C&!B1&!B&A1&!A|!F&!E&!D1&D&!C1&!C&!B1&!B&A1&!A|!F&E&!D1&D&!C1&!C&!B1&!B&A1&!A|!F&!E&D1&D&!C1&!C&!B1&!B&A1&!A|!F&!E&D1&!D&!C1&!C&!B1&!B&A1&!A|!F&E&D1&!D&!C1&!C&!B1&!B&A1&!A|!F&E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D1&!D&!C1&!C&!B1&!B&A1&A|!F&E&!D1&!D&!C1&!C&!B1&!B&A1&A|!F&E&D1&!D&!C1&!C&!B1&!B&A1&A|!F&!E&D1&!D&!C1&!C&!B1&!B&A1&A|!F&!E&D1&D&!C1&!C&!B1&!B&A1&A|!F&E&!D1&D&!C1&!C&!B1&!B&A1&A|!F&!E&!D1&D&!C1&!C&!B1&!B&A1&A|!F&!E&!D1&D&C1&!C&!B1&!B&A1&A|!F&!E&D1&D&C1&!C&!B1&!B&A1&A|!F&!E&D1&!D&C1&!C&!B1&!B&A1&A|!F&!E&!D1&!D&C1&!C&!B1&!B&A1&A|!F&!E&!D1&!D&C1&C&!B1&!B&A1&A|!F&!E&D1&!D&C1&C&!B1&!B&A1&A|!F&!E&D1&D&C1&C&!B1&!B&A1&A|!F&!E&!D1&D&C1&C&!B1&!B&A1&A|!F&!E&!D1&D&!C1&C&!B1&!B&A1&A|!F&!E&D1&D&!C1&C&!B1&!B&A1&A|!F&!E&D1&!D&!C1&C&!B1&!B&A1&A|!F&!E&!D1&!D&!C1&C&!B1&!B&A1&A|!F&!E&!D1&!D&!C1&C&B1&!B&A1&A|!F&!E&D1&!D&!C1&C&B1&!B&A1&A|!F&!E&D1&D&!C1&C&B1&!B&A1&A|!F&!E&!D1&D&!C1&C&B1&!B&A1&A|!F&!E&!D1&D&C1&C&B1&!B&A1&A|!F&!E&D1&D&C1&C&B1&!B&A1&A|!F&!E&D1&!D&C1&C&B1&!B&A1&A|!F&!E&!D1&!D&C1&C&B1&!B&A1&A|!F&!E&!D1&!D&C1&!C&B1&!B&A1&A|!F&!E&D1&!D&C1&!C&B1&!B&A1&A|!F&!E&D1&D&C1&!C&B1&!B&A1&A|!F&!E&!D1&D&C1&!C&B1&!B&A1&A|!F&!E&!D1&D&!C1&!C&B1&!B&A1&A|!F&E&!D1&D&!C1&!C&B1&!B&A1&A|!F&!E&D1&D&!C1&!C&B1&!B&A1&A|!F&!E&D1&!D&!C1&!C&B1&!B&A1&A|!F&E&D1&!D&!C1&!C&B1&!B&A1&A|!F&E&!D1&!D&!C1&!C&B1&!B&A1&A|!F&!E&!D1&!D&!C1&!C&B1&!B&A1&A|!F&!E&!D1&!D&!C1&!C&B1&B&A1&A|!F&E&!D1&!D&!C1&!C&B1&B&A1&A|!F&E&D1&!D&!C1&!C&B1&B&A1&A|!F&!E&D1&!D&!C1&!C&B1&B&A1&A|!F&!E&D1&D&!C1&!C&B1&B&A1&A|!F&E&!D1&D&!C1&!C&B1&B&A1&A|!F&!E&!D1&D&!C1&!C&B1&B&A1&A|!F&!E&!D1&D&C1&!C&B1&B&A1&A|!F&!E&D1&D&C1&!C&B1&B&A1&A|!F&!E&D1&!D&C1&!C&B1&B&A1&A|!F&!E&!D1&!D&C1&!C&B1&B&A1&A|!F&!E&!D1&!D&C1&C&B1&B&A1&A|!F&!E&D1&!D&C1&C&B1&B&A1&A|!F&!E&D1&D&C1&C&B1&B&A1&A|!F&!E&!D1&D&C1&C&B1&B&A1&A|!F&!E&!D1&D&!C1&C&B1&B&A1&A|!F&!E&D1&D&!C1&C&B1&B&A1&A|!F&!E&D1&!D&!C1&C&B1&B&A1&A|!F&!E&!D1&!D&!C1&C&B1&B&A1&A|!F&!E&!D1&!D&!C1&C&!B1&B&A1&A|!F&!E&D1&!D&!C1&C&!B1&B&A1&A|!F&!E&D1&D&!C1&C&!B1&B&A1&A|!F&!E&!D1&D&!C1&C&!B1&B&A1&A|!F&!E&!D1&D&C1&C&!B1&B&A1&A|!F&!E&D1&D&C1&C&!B1&B&A1&A|!F&!E&D1&!D&C1&C&!B1&B&A1&A|!F&!E&!D1&!D&C1&C&!B1&B&A1&A|!F&!E&!D1&!D&C1&!C&!B1&B&A1&A|!F&!E&D1&!D&C1&!C&!B1&B&A1&A|!F&!E&D1&D&C1&!C&!B1&B&A1&A|!F&!E&!D1&D&C1&!C&!B1&B&A1&A|!F&!E&!D1&D&!C1&!C&!B1&B&A1&A|!F&E&!D1&D&!C1&!C&!B1&B&A1&A|!F&!E&D1&D&!C1&!C&!B1&B&A1&A|!F&!E&D1&!D&!C1&!C&!B1&B&A1&A|!F&E&D1&!D&!C1&!C&!B1&B&A1&A|!F&E&!D1&!D&!C1&!C&!B1&B&A1&A|!F&!E&!D1&!D&!C1&!C&!B1&B&A1&A|!F&!E&!D1&!D&!C1&!C&!B1&B&!A1&A|!F&E&!D1&!D&!C1&!C&!B1&B&!A1&A|!F&E&D1&!D&!C1&!C&!B1&B&!A1&A|!F&!E&D1&!D&!C1&!C&!B1&B&!A1&A|!F&!E&D1&D&!C1&!C&!B1&B&!A1&A|!F&E&!D1&D&!C1&!C&!B1&B&!A1&A|!F&!E&!D1&D&!C1&!C&!B1&B&!A1&A|!F&!E&!D1&D&C1&!C&!B1&B&!A1&A|!F&E&!D1&D&C1&!C&!B1&B&!A1&A|!F&!E&D1&D&C1&!C&!B1&B&!A1&A|!F&!E&D1&!D&C1&!C&!B1&B&!A1&A|!F&E&D1&!D&C1&!C&!B1&B&!A1&A|!F&E&!D1&!D&C1&!C&!B1&B&!A1&A|!F&!E&!D1&!D&C1&!C&!B1&B&!A1&A|!F&!E&!D1&!D&C1&C&!B1&B&!A1&A|!F&E&!D1&!D&C1&C&!B1&B&!A1&A|!F&E&D1&!D&C1&C&!B1&B&!A1&A|!F&!E&D1&!D&C1&C&!B1&B&!A1&A|!F&!E&D1&D&C1&C&!B1&B&!A1&A|!F&E&!D1&D&C1&C&!B1&B&!A1&A|!F&!E&!D1&D&C1&C&!B1&B&!A1&A|!F&!E&!D1&D&!C1&C&!B1&B&!A1&A|!F&E&!D1&D&!C1&C&!B1&B&!A1&A|!F&!E&D1&D&!C1&C&!B1&B&!A1&A|!F&!E&D1&!D&!C1&C&!B1&B&!A1&A|!F&E&D1&!D&!C1&C&!B1&B&!A1&A|!F&E&!D1&!D&!C1&C&!B1&B&!A1&A|!F&!E&!D1&!D&!C1&C&!B1&B&!A1&A|!F&!E&!D1&!D&!C1&C&B1&B&!A1&A|!F&!E&D1&!D&!C1&C&B1&B&!A1&A|!F&!E&D1&D&!C1&C&B1&B&!A1&A|!F&!E&!D1&D&!C1&C&B1&B&!A1&A|!F&!E&!D1&D&C1&C&B1&B&!A1&A|!F&!E&D1&D&C1&C&B1&B&!A1&A|!F&!E&D1&!D&C1&C&B1&B&!A1&A|!F&!E&!D1&!D&C1&C&B1&B&!A1&A|!F&!E&!D1&!D&C1&!C&B1&B&!A1&A|!F&!E&D1&!D&C1&!C&B1&B&!A1&A|!F&!E&D1&D&C1&!C&B1&B&!A1&A|!F&!E&!D1&D&C1&!C&B1&B&!A1&A|!F&!E&!D1&D&!C1&!C&B1&B&!A1&A|!F&E&!D1&D&!C1&!C&B1&B&!A1&A|!F&!E&D1&D&!C1&!C&B1&B&!A1&A|!F&!E&D1&!D&!C1&!C&B1&B&!A1&A|!F&E&D1&!D&!C1&!C&B1&B&!A1&A|!F&E&!D1&!D&!C1&!C&B1&B&!A1&A|!F&!E&!D1&!D&!C1&!C&B1&B&!A1&A|!F&!E&!D1&!D&!C1&!C&B1&!B&!A1&A|!F&E&!D1&!D&!C1&!C&B1&!B&!A1&A|!F&E&D1&!D&!C1&!C&B1&!B&!A1&A|!F&!E&D1&!D&!C1&!C&B1&!B&!A1&A|!F&!E&D1&D&!C1&!C&B1&!B&!A1&A|!F&E&!D1&D&!C1&!C&B1&!B&!A1&A|!F&!E&!D1&D&!C1&!C&B1&!B&!A1&A|!F&!E&!D1&D&C1&!C&B1&!B&!A1&A|!F&E&!D1&D&C1&!C&B1&!B&!A1&A|!F&!E&D1&D&C1&!C&B1&!B&!A1&A|!F&!E&D1&!D&C1&!C&B1&!B&!A1&A|!F&E&D1&!D&C1&!C&B1&!B&!A1&A|!F&E&!D1&!D&C1&!C&B1&!B&!A1&A|!F&!E&!D1&!D&C1&!C&B1&!B&!A1&A|!F&!E&!D1&!D&C1&C&B1&!B&!A1&A|!F&E&!D1&!D&C1&C&B1&!B&!A1&A|!F&E&D1&!D&C1&C&B1&!B&!A1&A|!F&!E&D1&!D&C1&C&B1&!B&!A1&A|!F&!E&D1&D&C1&C&B1&!B&!A1&A|!F&E&!D1&D&C1&C&B1&!B&!A1&A|!F&!E&!D1&D&C1&C&B1&!B&!A1&A|!F&!E&!D1&D&!C1&C&B1&!B&!A1&A|!F&E&!D1&D&!C1&C&B1&!B&!A1&A|!F&!E&D1&D&!C1&C&B1&!B&!A1&A|!F&!E&D1&!D&!C1&C&B1&!B&!A1&A|!F&E&D1&!D&!C1&C&B1&!B&!A1&A|!F&E&!D1&!D&!C1&C&B1&!B&!A1&A|!F&!E&!D1&!D&!C1&C&B1&!B&!A1&A|!F&!E&!D1&!D&!C1&C&!B1&!B&!A1&A|!F&E&!D1&!D&!C1&C&!B1&!B&!A1&A|!F&E&D1&!D&!C1&C&!B1&!B&!A1&A|!F&!E&D1&!D&!C1&C&!B1&!B&!A1&A|!F&!E&D1&D&!C1&C&!B1&!B&!A1&A|!F&E&!D1&D&!C1&C&!B1&!B&!A1&A|!F&!E&!D1&D&!C1&C&!B1&!B&!A1&A|!F&!E&!D1&D&C1&C&!B1&!B&!A1&A|!F&E&!D1&D&C1&C&!B1&!B&!A1&A|!F&!E&D1&D&C1&C&!B1&!B&!A1&A|!F&!E&D1&!D&C1&C&!B1&!B&!A1&A|!F&E&D1&!D&C1&C&!B1&!B&!A1&A|!F&E&!D1&!D&C1&C&!B1&!B&!A1&A|!F&!E&!D1&!D&C1&C&!B1&!B&!A1&A|!F&!E&!D1&!D&C1&!C&!B1&!B&!A1&A|!F&E&!D1&!D&C1&!C&!B1&!B&!A1&A|!F&E&D1&!D&C1&!C&!B1&!B&!A1&A|!F&!E&D1&!D&C1&!C&!B1&!B&!A1&A|!F&!E&D1&D&C1&!C&!B1&!B&!A1&A|!F&E&!D1&D&C1&!C&!B1&!B&!A1&A|!F&!E&!D1&D&C1&!C&!B1&!B&!A1&A|!F&!E&!D1&D&!C1&!C&!B1&!B&!A1&A|!F&E&!D1&D&!C1&!C&!B1&!B&!A1&A|!F&!E&D1&D&!C1&!C&!B1&!B&!A1&A|!F&!E&D1&!D&!C1&!C&!B1&!B&!A1&A|!F&E&D1&!D&!C1&!C&!B1&!B&!A1&A|!F&E&!D1&!D&!C1&!C&!B1&!B&!A1&A|!F&!E&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAAOAOI222211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOAI3122 -l OAAOAI3122 -i D1 D C1 C B A2 A1 A -o Y -f Y=!(D1&D&C1&C&!B&!A2&!A1&!A|D1&D&C1&C&B&!A2&!A1&!A|D1&D&!C1&!C&B&A2&!A1&!A|D1&D&C1&!C&B&A2&!A1&!A|D1&D&C1&C&B&A2&!A1&!A|D1&D&!C1&C&B&A2&!A1&!A|D1&D&C1&C&!B&A2&!A1&!A|D1&D&C1&C&!B&A2&A1&!A|D1&D&!C1&C&B&A2&A1&!A|D1&D&C1&C&B&A2&A1&!A|D1&D&C1&!C&B&A2&A1&!A|D1&D&!C1&!C&B&A2&A1&!A|D1&D&!C1&!C&B&!A2&A1&!A|D1&D&C1&!C&B&!A2&A1&!A|D1&D&C1&C&B&!A2&A1&!A|D1&D&!C1&C&B&!A2&A1&!A|D1&D&C1&C&!B&!A2&A1&!A|D1&D&C1&C&!B&!A2&A1&A|D1&D&!C1&C&B&!A2&A1&A|D1&D&C1&C&B&!A2&A1&A|D1&D&C1&!C&B&!A2&A1&A|D1&D&!C1&!C&B&!A2&A1&A|D1&D&!C1&!C&B&A2&A1&A|D1&D&C1&!C&B&A2&A1&A|D1&D&C1&C&B&A2&A1&A|D1&D&!C1&C&B&A2&A1&A|D1&D&C1&C&!B&A2&A1&A|D1&D&C1&C&!B&A2&!A1&A|D1&D&!C1&C&B&A2&!A1&A|D1&D&C1&C&B&A2&!A1&A|D1&D&C1&!C&B&A2&!A1&A|D1&D&!C1&!C&B&A2&!A1&A|D1&D&!C1&!C&B&!A2&!A1&A|D1&D&C1&!C&B&!A2&!A1&A|D1&D&C1&C&B&!A2&!A1&A|D1&D&!C1&C&B&!A2&!A1&A|D1&D&C1&C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOAI3122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOAI21212 -l OAAOOAI21212 -i E1 E D C1 C B A1 A -o Y -f Y=!(!E1&E&D&C1&C&!B&!A1&!A|E1&E&D&C1&C&!B&!A1&!A|E1&!E&D&C1&C&!B&!A1&!A|E1&!E&D&C1&C&B&!A1&!A|E1&E&D&C1&C&B&!A1&!A|!E1&E&D&C1&C&B&!A1&!A|!E1&E&D&!C1&!C&B&A1&!A|E1&E&D&!C1&!C&B&A1&!A|E1&!E&D&!C1&!C&B&A1&!A|E1&!E&D&C1&!C&B&A1&!A|E1&E&D&C1&!C&B&A1&!A|!E1&E&D&C1&!C&B&A1&!A|!E1&E&D&C1&C&B&A1&!A|E1&E&D&C1&C&B&A1&!A|E1&!E&D&C1&C&B&A1&!A|E1&!E&D&!C1&C&B&A1&!A|E1&E&D&!C1&C&B&A1&!A|!E1&E&D&!C1&C&B&A1&!A|E1&!E&D&C1&C&!B&A1&!A|E1&E&D&C1&C&!B&A1&!A|!E1&E&D&C1&C&!B&A1&!A|!E1&E&D&C1&C&!B&A1&A|E1&E&D&C1&C&!B&A1&A|E1&!E&D&C1&C&!B&A1&A|!E1&E&D&!C1&C&B&A1&A|E1&E&D&!C1&C&B&A1&A|E1&!E&D&!C1&C&B&A1&A|E1&!E&D&C1&C&B&A1&A|E1&E&D&C1&C&B&A1&A|!E1&E&D&C1&C&B&A1&A|!E1&E&D&C1&!C&B&A1&A|E1&E&D&C1&!C&B&A1&A|E1&!E&D&C1&!C&B&A1&A|E1&!E&D&!C1&!C&B&A1&A|E1&E&D&!C1&!C&B&A1&A|!E1&E&D&!C1&!C&B&A1&A|!E1&E&D&!C1&!C&B&!A1&A|E1&E&D&!C1&!C&B&!A1&A|E1&!E&D&!C1&!C&B&!A1&A|E1&!E&D&C1&!C&B&!A1&A|E1&E&D&C1&!C&B&!A1&A|!E1&E&D&C1&!C&B&!A1&A|!E1&E&D&C1&C&B&!A1&A|E1&E&D&C1&C&B&!A1&A|E1&!E&D&C1&C&B&!A1&A|E1&!E&D&!C1&C&B&!A1&A|E1&E&D&!C1&C&B&!A1&A|!E1&E&D&!C1&C&B&!A1&A|E1&!E&D&C1&C&!B&!A1&A|E1&E&D&C1&C&!B&!A1&A|!E1&E&D&C1&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOAI21212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOAI2221 -l AAAOAI2221 -i D C1 C B1 B A1 A -o Y -f Y=!(D&C1&C&!B1&!B&!A1&!A|D&C1&C&B1&!B&!A1&!A|D&!C1&!C&B1&B&!A1&!A|D&C1&!C&B1&B&!A1&!A|D&C1&C&B1&B&!A1&!A|D&!C1&C&B1&B&!A1&!A|D&C1&C&!B1&B&!A1&!A|D&C1&C&!B1&B&A1&!A|D&!C1&C&B1&B&A1&!A|D&C1&C&B1&B&A1&!A|D&C1&!C&B1&B&A1&!A|D&!C1&!C&B1&B&A1&!A|D&C1&C&B1&!B&A1&!A|D&C1&C&!B1&!B&A1&!A|D&!C1&!C&!B1&!B&A1&A|D&C1&!C&!B1&!B&A1&A|D&C1&C&!B1&!B&A1&A|D&!C1&C&!B1&!B&A1&A|D&!C1&C&B1&!B&A1&A|D&C1&C&B1&!B&A1&A|D&C1&!C&B1&!B&A1&A|D&!C1&!C&B1&!B&A1&A|D&!C1&!C&B1&B&A1&A|D&C1&!C&B1&B&A1&A|D&C1&C&B1&B&A1&A|D&!C1&C&B1&B&A1&A|D&!C1&C&!B1&B&A1&A|D&C1&C&!B1&B&A1&A|D&C1&!C&!B1&B&A1&A|D&!C1&!C&!B1&B&A1&A|D&C1&C&!B1&B&!A1&A|D&!C1&C&B1&B&!A1&A|D&C1&C&B1&B&!A1&A|D&C1&!C&B1&B&!A1&A|D&!C1&!C&B1&B&!A1&A|D&C1&C&B1&!B&!A1&A|D&C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOAI2221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAOAI33311 -l OOOAOAI33311 -i E D C2 C1 C B2 B1 B A2 A1 A -o Y -f Y=!(E&D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|E&D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|E&D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|E&D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|E&D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|E&D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|E&D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|E&D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|E&D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|E&D&C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|E&D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|E&D&!C2&C1&C&B2&!B1&!B&!A2&!A1&!A|E&D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|E&D&C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|E&D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|E&D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|E&D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|E&D&C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|E&D&C2&C1&!C&B2&B1&!B&!A2&!A1&!A|E&D&!C2&C1&!C&B2&B1&!B&!A2&!A1&!A|E&D&!C2&C1&C&B2&B1&!B&!A2&!A1&!A|E&D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|E&D&C2&!C1&C&B2&B1&!B&!A2&!A1&!A|E&D&!C2&!C1&C&B2&B1&!B&!A2&!A1&!A|E&D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|E&D&C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|E&D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|E&D&!C2&C1&C&!B2&B1&!B&!A2&!A1&!A|E&D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|E&D&C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|E&D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|E&D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|E&D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|E&D&C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|E&D&C2&C1&!C&!B2&B1&B&!A2&!A1&!A|E&D&!C2&C1&!C&!B2&B1&B&!A2&!A1&!A|E&D&!C2&C1&C&!B2&B1&B&!A2&!A1&!A|E&D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|E&D&C2&!C1&C&!B2&B1&B&!A2&!A1&!A|E&D&!C2&!C1&C&!B2&B1&B&!A2&!A1&!A|E&D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|E&D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|E&D&C2&C1&C&B2&B1&B&!A2&!A1&!A|E&D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|E&D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|E&D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|E&D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|E&D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|E&D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|E&D&C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|E&D&C2&C1&!C&B2&!B1&B&!A2&!A1&!A|E&D&!C2&C1&!C&B2&!B1&B&!A2&!A1&!A|E&D&!C2&C1&C&B2&!B1&B&!A2&!A1&!A|E&D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|E&D&C2&!C1&C&B2&!B1&B&!A2&!A1&!A|E&D&!C2&!C1&C&B2&!B1&B&!A2&!A1&!A|E&D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|E&D&C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|E&D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|E&D&!C2&C1&C&!B2&!B1&B&!A2&!A1&!A|E&D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|E&D&C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|E&D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|E&D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|E&D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|E&D&C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|E&!D&C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|E&!D&C2&C1&!C&!B2&!B1&B&A2&!A1&!A|E&D&C2&C1&!C&!B2&!B1&B&A2&!A1&!A|E&D&!C2&C1&!C&!B2&!B1&B&A2&!A1&!A|E&!D&!C2&C1&!C&!B2&!B1&B&A2&!A1&!A|E&!D&!C2&C1&C&!B2&!B1&B&A2&!A1&!A|E&D&!C2&C1&C&!B2&!B1&B&A2&!A1&!A|E&D&C2&C1&C&!B2&!B1&B&A2&!A1&!A|E&!D&C2&C1&C&!B2&!B1&B&A2&!A1&!A|E&!D&C2&!C1&C&!B2&!B1&B&A2&!A1&!A|E&D&C2&!C1&C&!B2&!B1&B&A2&!A1&!A|E&D&!C2&!C1&C&!B2&!B1&B&A2&!A1&!A|E&!D&!C2&!C1&C&!B2&!B1&B&A2&!A1&!A|E&!D&!C2&!C1&C&B2&!B1&B&A2&!A1&!A|E&D&!C2&!C1&C&B2&!B1&B&A2&!A1&!A|E&D&C2&!C1&C&B2&!B1&B&A2&!A1&!A|E&!D&C2&!C1&C&B2&!B1&B&A2&!A1&!A|E&!D&C2&C1&C&B2&!B1&B&A2&!A1&!A|E&D&C2&C1&C&B2&!B1&B&A2&!A1&!A|E&D&!C2&C1&C&B2&!B1&B&A2&!A1&!A|E&!D&!C2&C1&C&B2&!B1&B&A2&!A1&!A|E&!D&!C2&C1&!C&B2&!B1&B&A2&!A1&!A|E&D&!C2&C1&!C&B2&!B1&B&A2&!A1&!A|E&D&C2&C1&!C&B2&!B1&B&A2&!A1&!A|E&!D&C2&C1&!C&B2&!B1&B&A2&!A1&!A|E&!D&C2&!C1&!C&B2&!B1&B&A2&!A1&!A|E&D&C2&!C1&!C&B2&!B1&B&A2&!A1&!A|E&D&!C2&!C1&!C&B2&!B1&B&A2&!A1&!A|E&D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|E&D&C2&!C1&!C&B2&B1&B&A2&!A1&!A|E&!D&C2&!C1&!C&B2&B1&B&A2&!A1&!A|E&!D&C2&C1&!C&B2&B1&B&A2&!A1&!A|E&D&C2&C1&!C&B2&B1&B&A2&!A1&!A|E&D&!C2&C1&!C&B2&B1&B&A2&!A1&!A|E&!D&!C2&C1&!C&B2&B1&B&A2&!A1&!A|E&!D&!C2&C1&C&B2&B1&B&A2&!A1&!A|E&D&!C2&C1&C&B2&B1&B&A2&!A1&!A|E&D&C2&C1&C&B2&B1&B&A2&!A1&!A|E&!D&C2&C1&C&B2&B1&B&A2&!A1&!A|E&!D&C2&!C1&C&B2&B1&B&A2&!A1&!A|E&D&C2&!C1&C&B2&B1&B&A2&!A1&!A|E&D&!C2&!C1&C&B2&B1&B&A2&!A1&!A|E&!D&!C2&!C1&C&B2&B1&B&A2&!A1&!A|E&!D&!C2&!C1&C&!B2&B1&B&A2&!A1&!A|E&D&!C2&!C1&C&!B2&B1&B&A2&!A1&!A|E&D&C2&!C1&C&!B2&B1&B&A2&!A1&!A|E&!D&C2&!C1&C&!B2&B1&B&A2&!A1&!A|E&!D&C2&C1&C&!B2&B1&B&A2&!A1&!A|E&D&C2&C1&C&!B2&B1&B&A2&!A1&!A|E&D&!C2&C1&C&!B2&B1&B&A2&!A1&!A|E&!D&!C2&C1&C&!B2&B1&B&A2&!A1&!A|E&!D&!C2&C1&!C&!B2&B1&B&A2&!A1&!A|E&D&!C2&C1&!C&!B2&B1&B&A2&!A1&!A|E&D&C2&C1&!C&!B2&B1&B&A2&!A1&!A|E&!D&C2&C1&!C&!B2&B1&B&A2&!A1&!A|E&!D&C2&!C1&!C&!B2&B1&B&A2&!A1&!A|E&D&C2&!C1&!C&!B2&B1&B&A2&!A1&!A|E&D&!C2&!C1&!C&!B2&B1&B&A2&!A1&!A|E&D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|E&D&C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|E&!D&C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|E&!D&C2&C1&!C&!B2&B1&!B&A2&!A1&!A|E&D&C2&C1&!C&!B2&B1&!B&A2&!A1&!A|E&D&!C2&C1&!C&!B2&B1&!B&A2&!A1&!A|E&!D&!C2&C1&!C&!B2&B1&!B&A2&!A1&!A|E&!D&!C2&C1&C&!B2&B1&!B&A2&!A1&!A|E&D&!C2&C1&C&!B2&B1&!B&A2&!A1&!A|E&D&C2&C1&C&!B2&B1&!B&A2&!A1&!A|E&!D&C2&C1&C&!B2&B1&!B&A2&!A1&!A|E&!D&C2&!C1&C&!B2&B1&!B&A2&!A1&!A|E&D&C2&!C1&C&!B2&B1&!B&A2&!A1&!A|E&D&!C2&!C1&C&!B2&B1&!B&A2&!A1&!A|E&!D&!C2&!C1&C&!B2&B1&!B&A2&!A1&!A|E&!D&!C2&!C1&C&B2&B1&!B&A2&!A1&!A|E&D&!C2&!C1&C&B2&B1&!B&A2&!A1&!A|E&D&C2&!C1&C&B2&B1&!B&A2&!A1&!A|E&!D&C2&!C1&C&B2&B1&!B&A2&!A1&!A|E&!D&C2&C1&C&B2&B1&!B&A2&!A1&!A|E&D&C2&C1&C&B2&B1&!B&A2&!A1&!A|E&D&!C2&C1&C&B2&B1&!B&A2&!A1&!A|E&!D&!C2&C1&C&B2&B1&!B&A2&!A1&!A|E&!D&!C2&C1&!C&B2&B1&!B&A2&!A1&!A|E&D&!C2&C1&!C&B2&B1&!B&A2&!A1&!A|E&D&C2&C1&!C&B2&B1&!B&A2&!A1&!A|E&!D&C2&C1&!C&B2&B1&!B&A2&!A1&!A|E&!D&C2&!C1&!C&B2&B1&!B&A2&!A1&!A|E&D&C2&!C1&!C&B2&B1&!B&A2&!A1&!A|E&D&!C2&!C1&!C&B2&B1&!B&A2&!A1&!A|E&D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|E&D&C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|E&!D&C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|E&!D&C2&C1&!C&B2&!B1&!B&A2&!A1&!A|E&D&C2&C1&!C&B2&!B1&!B&A2&!A1&!A|E&D&!C2&C1&!C&B2&!B1&!B&A2&!A1&!A|E&!D&!C2&C1&!C&B2&!B1&!B&A2&!A1&!A|E&!D&!C2&C1&C&B2&!B1&!B&A2&!A1&!A|E&D&!C2&C1&C&B2&!B1&!B&A2&!A1&!A|E&D&C2&C1&C&B2&!B1&!B&A2&!A1&!A|E&!D&C2&C1&C&B2&!B1&!B&A2&!A1&!A|E&!D&C2&!C1&C&B2&!B1&!B&A2&!A1&!A|E&D&C2&!C1&C&B2&!B1&!B&A2&!A1&!A|E&D&!C2&!C1&C&B2&!B1&!B&A2&!A1&!A|E&!D&!C2&!C1&C&B2&!B1&!B&A2&!A1&!A|E&D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|E&D&C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|E&D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|E&D&!C2&C1&C&!B2&!B1&!B&A2&!A1&!A|E&D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|E&D&C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|E&D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|E&D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|E&D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|E&D&C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|E&D&C2&C1&!C&!B2&!B1&!B&A2&A1&!A|E&D&!C2&C1&!C&!B2&!B1&!B&A2&A1&!A|E&D&!C2&C1&C&!B2&!B1&!B&A2&A1&!A|E&D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|E&D&C2&!C1&C&!B2&!B1&!B&A2&A1&!A|E&D&!C2&!C1&C&!B2&!B1&!B&A2&A1&!A|E&!D&!C2&!C1&C&B2&!B1&!B&A2&A1&!A|E&D&!C2&!C1&C&B2&!B1&!B&A2&A1&!A|E&D&C2&!C1&C&B2&!B1&!B&A2&A1&!A|E&!D&C2&!C1&C&B2&!B1&!B&A2&A1&!A|E&!D&C2&C1&C&B2&!B1&!B&A2&A1&!A|E&D&C2&C1&C&B2&!B1&!B&A2&A1&!A|E&D&!C2&C1&C&B2&!B1&!B&A2&A1&!A|E&!D&!C2&C1&C&B2&!B1&!B&A2&A1&!A|E&!D&!C2&C1&!C&B2&!B1&!B&A2&A1&!A|E&D&!C2&C1&!C&B2&!B1&!B&A2&A1&!A|E&D&C2&C1&!C&B2&!B1&!B&A2&A1&!A|E&!D&C2&C1&!C&B2&!B1&!B&A2&A1&!A|E&!D&C2&!C1&!C&B2&!B1&!B&A2&A1&!A|E&D&C2&!C1&!C&B2&!B1&!B&A2&A1&!A|E&D&!C2&!C1&!C&B2&!B1&!B&A2&A1&!A|E&D&!C2&!C1&!C&B2&B1&!B&A2&A1&!A|E&D&C2&!C1&!C&B2&B1&!B&A2&A1&!A|E&!D&C2&!C1&!C&B2&B1&!B&A2&A1&!A|E&!D&C2&C1&!C&B2&B1&!B&A2&A1&!A|E&D&C2&C1&!C&B2&B1&!B&A2&A1&!A|E&D&!C2&C1&!C&B2&B1&!B&A2&A1&!A|E&!D&!C2&C1&!C&B2&B1&!B&A2&A1&!A|E&!D&!C2&C1&C&B2&B1&!B&A2&A1&!A|E&D&!C2&C1&C&B2&B1&!B&A2&A1&!A|E&D&C2&C1&C&B2&B1&!B&A2&A1&!A|E&!D&C2&C1&C&B2&B1&!B&A2&A1&!A|E&!D&C2&!C1&C&B2&B1&!B&A2&A1&!A|E&D&C2&!C1&C&B2&B1&!B&A2&A1&!A|E&D&!C2&!C1&C&B2&B1&!B&A2&A1&!A|E&!D&!C2&!C1&C&B2&B1&!B&A2&A1&!A|E&!D&!C2&!C1&C&!B2&B1&!B&A2&A1&!A|E&D&!C2&!C1&C&!B2&B1&!B&A2&A1&!A|E&D&C2&!C1&C&!B2&B1&!B&A2&A1&!A|E&!D&C2&!C1&C&!B2&B1&!B&A2&A1&!A|E&!D&C2&C1&C&!B2&B1&!B&A2&A1&!A|E&D&C2&C1&C&!B2&B1&!B&A2&A1&!A|E&D&!C2&C1&C&!B2&B1&!B&A2&A1&!A|E&!D&!C2&C1&C&!B2&B1&!B&A2&A1&!A|E&!D&!C2&C1&!C&!B2&B1&!B&A2&A1&!A|E&D&!C2&C1&!C&!B2&B1&!B&A2&A1&!A|E&D&C2&C1&!C&!B2&B1&!B&A2&A1&!A|E&!D&C2&C1&!C&!B2&B1&!B&A2&A1&!A|E&!D&C2&!C1&!C&!B2&B1&!B&A2&A1&!A|E&D&C2&!C1&!C&!B2&B1&!B&A2&A1&!A|E&D&!C2&!C1&!C&!B2&B1&!B&A2&A1&!A|E&D&!C2&!C1&!C&!B2&B1&B&A2&A1&!A|E&D&C2&!C1&!C&!B2&B1&B&A2&A1&!A|E&!D&C2&!C1&!C&!B2&B1&B&A2&A1&!A|E&!D&C2&C1&!C&!B2&B1&B&A2&A1&!A|E&D&C2&C1&!C&!B2&B1&B&A2&A1&!A|E&D&!C2&C1&!C&!B2&B1&B&A2&A1&!A|E&!D&!C2&C1&!C&!B2&B1&B&A2&A1&!A|E&!D&!C2&C1&C&!B2&B1&B&A2&A1&!A|E&D&!C2&C1&C&!B2&B1&B&A2&A1&!A|E&D&C2&C1&C&!B2&B1&B&A2&A1&!A|E&!D&C2&C1&C&!B2&B1&B&A2&A1&!A|E&!D&C2&!C1&C&!B2&B1&B&A2&A1&!A|E&D&C2&!C1&C&!B2&B1&B&A2&A1&!A|E&D&!C2&!C1&C&!B2&B1&B&A2&A1&!A|E&!D&!C2&!C1&C&!B2&B1&B&A2&A1&!A|E&!D&!C2&!C1&C&B2&B1&B&A2&A1&!A|E&D&!C2&!C1&C&B2&B1&B&A2&A1&!A|E&D&C2&!C1&C&B2&B1&B&A2&A1&!A|E&!D&C2&!C1&C&B2&B1&B&A2&A1&!A|E&!D&C2&C1&C&B2&B1&B&A2&A1&!A|E&D&C2&C1&C&B2&B1&B&A2&A1&!A|E&D&!C2&C1&C&B2&B1&B&A2&A1&!A|E&!D&!C2&C1&C&B2&B1&B&A2&A1&!A|E&!D&!C2&C1&!C&B2&B1&B&A2&A1&!A|E&D&!C2&C1&!C&B2&B1&B&A2&A1&!A|E&D&C2&C1&!C&B2&B1&B&A2&A1&!A|E&!D&C2&C1&!C&B2&B1&B&A2&A1&!A|E&!D&C2&!C1&!C&B2&B1&B&A2&A1&!A|E&D&C2&!C1&!C&B2&B1&B&A2&A1&!A|E&D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|E&D&!C2&!C1&!C&B2&!B1&B&A2&A1&!A|E&D&C2&!C1&!C&B2&!B1&B&A2&A1&!A|E&!D&C2&!C1&!C&B2&!B1&B&A2&A1&!A|E&!D&C2&C1&!C&B2&!B1&B&A2&A1&!A|E&D&C2&C1&!C&B2&!B1&B&A2&A1&!A|E&D&!C2&C1&!C&B2&!B1&B&A2&A1&!A|E&!D&!C2&C1&!C&B2&!B1&B&A2&A1&!A|E&!D&!C2&C1&C&B2&!B1&B&A2&A1&!A|E&D&!C2&C1&C&B2&!B1&B&A2&A1&!A|E&D&C2&C1&C&B2&!B1&B&A2&A1&!A|E&!D&C2&C1&C&B2&!B1&B&A2&A1&!A|E&!D&C2&!C1&C&B2&!B1&B&A2&A1&!A|E&D&C2&!C1&C&B2&!B1&B&A2&A1&!A|E&D&!C2&!C1&C&B2&!B1&B&A2&A1&!A|E&!D&!C2&!C1&C&B2&!B1&B&A2&A1&!A|E&!D&!C2&!C1&C&!B2&!B1&B&A2&A1&!A|E&D&!C2&!C1&C&!B2&!B1&B&A2&A1&!A|E&D&C2&!C1&C&!B2&!B1&B&A2&A1&!A|E&!D&C2&!C1&C&!B2&!B1&B&A2&A1&!A|E&!D&C2&C1&C&!B2&!B1&B&A2&A1&!A|E&D&C2&C1&C&!B2&!B1&B&A2&A1&!A|E&D&!C2&C1&C&!B2&!B1&B&A2&A1&!A|E&!D&!C2&C1&C&!B2&!B1&B&A2&A1&!A|E&!D&!C2&C1&!C&!B2&!B1&B&A2&A1&!A|E&D&!C2&C1&!C&!B2&!B1&B&A2&A1&!A|E&D&C2&C1&!C&!B2&!B1&B&A2&A1&!A|E&!D&C2&C1&!C&!B2&!B1&B&A2&A1&!A|E&!D&C2&!C1&!C&!B2&!B1&B&A2&A1&!A|E&D&C2&!C1&!C&!B2&!B1&B&A2&A1&!A|E&D&!C2&!C1&!C&!B2&!B1&B&A2&A1&!A|E&D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|E&D&C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|E&!D&C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|E&!D&C2&C1&!C&!B2&!B1&B&!A2&A1&!A|E&D&C2&C1&!C&!B2&!B1&B&!A2&A1&!A|E&D&!C2&C1&!C&!B2&!B1&B&!A2&A1&!A|E&!D&!C2&C1&!C&!B2&!B1&B&!A2&A1&!A|E&!D&!C2&C1&C&!B2&!B1&B&!A2&A1&!A|E&D&!C2&C1&C&!B2&!B1&B&!A2&A1&!A|E&D&C2&C1&C&!B2&!B1&B&!A2&A1&!A|E&!D&C2&C1&C&!B2&!B1&B&!A2&A1&!A|E&!D&C2&!C1&C&!B2&!B1&B&!A2&A1&!A|E&D&C2&!C1&C&!B2&!B1&B&!A2&A1&!A|E&D&!C2&!C1&C&!B2&!B1&B&!A2&A1&!A|E&!D&!C2&!C1&C&!B2&!B1&B&!A2&A1&!A|E&!D&!C2&!C1&C&B2&!B1&B&!A2&A1&!A|E&D&!C2&!C1&C&B2&!B1&B&!A2&A1&!A|E&D&C2&!C1&C&B2&!B1&B&!A2&A1&!A|E&!D&C2&!C1&C&B2&!B1&B&!A2&A1&!A|E&!D&C2&C1&C&B2&!B1&B&!A2&A1&!A|E&D&C2&C1&C&B2&!B1&B&!A2&A1&!A|E&D&!C2&C1&C&B2&!B1&B&!A2&A1&!A|E&!D&!C2&C1&C&B2&!B1&B&!A2&A1&!A|E&!D&!C2&C1&!C&B2&!B1&B&!A2&A1&!A|E&D&!C2&C1&!C&B2&!B1&B&!A2&A1&!A|E&D&C2&C1&!C&B2&!B1&B&!A2&A1&!A|E&!D&C2&C1&!C&B2&!B1&B&!A2&A1&!A|E&!D&C2&!C1&!C&B2&!B1&B&!A2&A1&!A|E&D&C2&!C1&!C&B2&!B1&B&!A2&A1&!A|E&D&!C2&!C1&!C&B2&!B1&B&!A2&A1&!A|E&D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|E&D&C2&!C1&!C&B2&B1&B&!A2&A1&!A|E&!D&C2&!C1&!C&B2&B1&B&!A2&A1&!A|E&!D&C2&C1&!C&B2&B1&B&!A2&A1&!A|E&D&C2&C1&!C&B2&B1&B&!A2&A1&!A|E&D&!C2&C1&!C&B2&B1&B&!A2&A1&!A|E&!D&!C2&C1&!C&B2&B1&B&!A2&A1&!A|E&!D&!C2&C1&C&B2&B1&B&!A2&A1&!A|E&D&!C2&C1&C&B2&B1&B&!A2&A1&!A|E&D&C2&C1&C&B2&B1&B&!A2&A1&!A|E&!D&C2&C1&C&B2&B1&B&!A2&A1&!A|E&!D&C2&!C1&C&B2&B1&B&!A2&A1&!A|E&D&C2&!C1&C&B2&B1&B&!A2&A1&!A|E&D&!C2&!C1&C&B2&B1&B&!A2&A1&!A|E&!D&!C2&!C1&C&B2&B1&B&!A2&A1&!A|E&!D&!C2&!C1&C&!B2&B1&B&!A2&A1&!A|E&D&!C2&!C1&C&!B2&B1&B&!A2&A1&!A|E&D&C2&!C1&C&!B2&B1&B&!A2&A1&!A|E&!D&C2&!C1&C&!B2&B1&B&!A2&A1&!A|E&!D&C2&C1&C&!B2&B1&B&!A2&A1&!A|E&D&C2&C1&C&!B2&B1&B&!A2&A1&!A|E&D&!C2&C1&C&!B2&B1&B&!A2&A1&!A|E&!D&!C2&C1&C&!B2&B1&B&!A2&A1&!A|E&!D&!C2&C1&!C&!B2&B1&B&!A2&A1&!A|E&D&!C2&C1&!C&!B2&B1&B&!A2&A1&!A|E&D&C2&C1&!C&!B2&B1&B&!A2&A1&!A|E&!D&C2&C1&!C&!B2&B1&B&!A2&A1&!A|E&!D&C2&!C1&!C&!B2&B1&B&!A2&A1&!A|E&D&C2&!C1&!C&!B2&B1&B&!A2&A1&!A|E&D&!C2&!C1&!C&!B2&B1&B&!A2&A1&!A|E&D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|E&D&C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|E&!D&C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|E&!D&C2&C1&!C&!B2&B1&!B&!A2&A1&!A|E&D&C2&C1&!C&!B2&B1&!B&!A2&A1&!A|E&D&!C2&C1&!C&!B2&B1&!B&!A2&A1&!A|E&!D&!C2&C1&!C&!B2&B1&!B&!A2&A1&!A|E&!D&!C2&C1&C&!B2&B1&!B&!A2&A1&!A|E&D&!C2&C1&C&!B2&B1&!B&!A2&A1&!A|E&D&C2&C1&C&!B2&B1&!B&!A2&A1&!A|E&!D&C2&C1&C&!B2&B1&!B&!A2&A1&!A|E&!D&C2&!C1&C&!B2&B1&!B&!A2&A1&!A|E&D&C2&!C1&C&!B2&B1&!B&!A2&A1&!A|E&D&!C2&!C1&C&!B2&B1&!B&!A2&A1&!A|E&!D&!C2&!C1&C&!B2&B1&!B&!A2&A1&!A|E&!D&!C2&!C1&C&B2&B1&!B&!A2&A1&!A|E&D&!C2&!C1&C&B2&B1&!B&!A2&A1&!A|E&D&C2&!C1&C&B2&B1&!B&!A2&A1&!A|E&!D&C2&!C1&C&B2&B1&!B&!A2&A1&!A|E&!D&C2&C1&C&B2&B1&!B&!A2&A1&!A|E&D&C2&C1&C&B2&B1&!B&!A2&A1&!A|E&D&!C2&C1&C&B2&B1&!B&!A2&A1&!A|E&!D&!C2&C1&C&B2&B1&!B&!A2&A1&!A|E&!D&!C2&C1&!C&B2&B1&!B&!A2&A1&!A|E&D&!C2&C1&!C&B2&B1&!B&!A2&A1&!A|E&D&C2&C1&!C&B2&B1&!B&!A2&A1&!A|E&!D&C2&C1&!C&B2&B1&!B&!A2&A1&!A|E&!D&C2&!C1&!C&B2&B1&!B&!A2&A1&!A|E&D&C2&!C1&!C&B2&B1&!B&!A2&A1&!A|E&D&!C2&!C1&!C&B2&B1&!B&!A2&A1&!A|E&D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|E&D&C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|E&!D&C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|E&!D&C2&C1&!C&B2&!B1&!B&!A2&A1&!A|E&D&C2&C1&!C&B2&!B1&!B&!A2&A1&!A|E&D&!C2&C1&!C&B2&!B1&!B&!A2&A1&!A|E&!D&!C2&C1&!C&B2&!B1&!B&!A2&A1&!A|E&!D&!C2&C1&C&B2&!B1&!B&!A2&A1&!A|E&D&!C2&C1&C&B2&!B1&!B&!A2&A1&!A|E&D&C2&C1&C&B2&!B1&!B&!A2&A1&!A|E&!D&C2&C1&C&B2&!B1&!B&!A2&A1&!A|E&!D&C2&!C1&C&B2&!B1&!B&!A2&A1&!A|E&D&C2&!C1&C&B2&!B1&!B&!A2&A1&!A|E&D&!C2&!C1&C&B2&!B1&!B&!A2&A1&!A|E&!D&!C2&!C1&C&B2&!B1&!B&!A2&A1&!A|E&D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|E&D&C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|E&D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|E&D&!C2&C1&C&!B2&!B1&!B&!A2&A1&!A|E&D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|E&D&C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|E&D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|E&D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|E&D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|E&D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|E&D&C2&C1&!C&!B2&!B1&!B&!A2&A1&A|E&D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&A|E&D&!C2&C1&C&!B2&!B1&!B&!A2&A1&A|E&D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|E&D&C2&!C1&C&!B2&!B1&!B&!A2&A1&A|E&D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&A|E&!D&!C2&!C1&C&B2&!B1&!B&!A2&A1&A|E&D&!C2&!C1&C&B2&!B1&!B&!A2&A1&A|E&D&C2&!C1&C&B2&!B1&!B&!A2&A1&A|E&!D&C2&!C1&C&B2&!B1&!B&!A2&A1&A|E&!D&C2&C1&C&B2&!B1&!B&!A2&A1&A|E&D&C2&C1&C&B2&!B1&!B&!A2&A1&A|E&D&!C2&C1&C&B2&!B1&!B&!A2&A1&A|E&!D&!C2&C1&C&B2&!B1&!B&!A2&A1&A|E&!D&!C2&C1&!C&B2&!B1&!B&!A2&A1&A|E&D&!C2&C1&!C&B2&!B1&!B&!A2&A1&A|E&D&C2&C1&!C&B2&!B1&!B&!A2&A1&A|E&!D&C2&C1&!C&B2&!B1&!B&!A2&A1&A|E&!D&C2&!C1&!C&B2&!B1&!B&!A2&A1&A|E&D&C2&!C1&!C&B2&!B1&!B&!A2&A1&A|E&D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&A|E&D&!C2&!C1&!C&B2&B1&!B&!A2&A1&A|E&D&C2&!C1&!C&B2&B1&!B&!A2&A1&A|E&!D&C2&!C1&!C&B2&B1&!B&!A2&A1&A|E&!D&C2&C1&!C&B2&B1&!B&!A2&A1&A|E&D&C2&C1&!C&B2&B1&!B&!A2&A1&A|E&D&!C2&C1&!C&B2&B1&!B&!A2&A1&A|E&!D&!C2&C1&!C&B2&B1&!B&!A2&A1&A|E&!D&!C2&C1&C&B2&B1&!B&!A2&A1&A|E&D&!C2&C1&C&B2&B1&!B&!A2&A1&A|E&D&C2&C1&C&B2&B1&!B&!A2&A1&A|E&!D&C2&C1&C&B2&B1&!B&!A2&A1&A|E&!D&C2&!C1&C&B2&B1&!B&!A2&A1&A|E&D&C2&!C1&C&B2&B1&!B&!A2&A1&A|E&D&!C2&!C1&C&B2&B1&!B&!A2&A1&A|E&!D&!C2&!C1&C&B2&B1&!B&!A2&A1&A|E&!D&!C2&!C1&C&!B2&B1&!B&!A2&A1&A|E&D&!C2&!C1&C&!B2&B1&!B&!A2&A1&A|E&D&C2&!C1&C&!B2&B1&!B&!A2&A1&A|E&!D&C2&!C1&C&!B2&B1&!B&!A2&A1&A|E&!D&C2&C1&C&!B2&B1&!B&!A2&A1&A|E&D&C2&C1&C&!B2&B1&!B&!A2&A1&A|E&D&!C2&C1&C&!B2&B1&!B&!A2&A1&A|E&!D&!C2&C1&C&!B2&B1&!B&!A2&A1&A|E&!D&!C2&C1&!C&!B2&B1&!B&!A2&A1&A|E&D&!C2&C1&!C&!B2&B1&!B&!A2&A1&A|E&D&C2&C1&!C&!B2&B1&!B&!A2&A1&A|E&!D&C2&C1&!C&!B2&B1&!B&!A2&A1&A|E&!D&C2&!C1&!C&!B2&B1&!B&!A2&A1&A|E&D&C2&!C1&!C&!B2&B1&!B&!A2&A1&A|E&D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&A|E&D&!C2&!C1&!C&!B2&B1&B&!A2&A1&A|E&D&C2&!C1&!C&!B2&B1&B&!A2&A1&A|E&!D&C2&!C1&!C&!B2&B1&B&!A2&A1&A|E&!D&C2&C1&!C&!B2&B1&B&!A2&A1&A|E&D&C2&C1&!C&!B2&B1&B&!A2&A1&A|E&D&!C2&C1&!C&!B2&B1&B&!A2&A1&A|E&!D&!C2&C1&!C&!B2&B1&B&!A2&A1&A|E&!D&!C2&C1&C&!B2&B1&B&!A2&A1&A|E&D&!C2&C1&C&!B2&B1&B&!A2&A1&A|E&D&C2&C1&C&!B2&B1&B&!A2&A1&A|E&!D&C2&C1&C&!B2&B1&B&!A2&A1&A|E&!D&C2&!C1&C&!B2&B1&B&!A2&A1&A|E&D&C2&!C1&C&!B2&B1&B&!A2&A1&A|E&D&!C2&!C1&C&!B2&B1&B&!A2&A1&A|E&!D&!C2&!C1&C&!B2&B1&B&!A2&A1&A|E&!D&!C2&!C1&C&B2&B1&B&!A2&A1&A|E&D&!C2&!C1&C&B2&B1&B&!A2&A1&A|E&D&C2&!C1&C&B2&B1&B&!A2&A1&A|E&!D&C2&!C1&C&B2&B1&B&!A2&A1&A|E&!D&C2&C1&C&B2&B1&B&!A2&A1&A|E&D&C2&C1&C&B2&B1&B&!A2&A1&A|E&D&!C2&C1&C&B2&B1&B&!A2&A1&A|E&!D&!C2&C1&C&B2&B1&B&!A2&A1&A|E&!D&!C2&C1&!C&B2&B1&B&!A2&A1&A|E&D&!C2&C1&!C&B2&B1&B&!A2&A1&A|E&D&C2&C1&!C&B2&B1&B&!A2&A1&A|E&!D&C2&C1&!C&B2&B1&B&!A2&A1&A|E&!D&C2&!C1&!C&B2&B1&B&!A2&A1&A|E&D&C2&!C1&!C&B2&B1&B&!A2&A1&A|E&D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|E&D&!C2&!C1&!C&B2&!B1&B&!A2&A1&A|E&D&C2&!C1&!C&B2&!B1&B&!A2&A1&A|E&!D&C2&!C1&!C&B2&!B1&B&!A2&A1&A|E&!D&C2&C1&!C&B2&!B1&B&!A2&A1&A|E&D&C2&C1&!C&B2&!B1&B&!A2&A1&A|E&D&!C2&C1&!C&B2&!B1&B&!A2&A1&A|E&!D&!C2&C1&!C&B2&!B1&B&!A2&A1&A|E&!D&!C2&C1&C&B2&!B1&B&!A2&A1&A|E&D&!C2&C1&C&B2&!B1&B&!A2&A1&A|E&D&C2&C1&C&B2&!B1&B&!A2&A1&A|E&!D&C2&C1&C&B2&!B1&B&!A2&A1&A|E&!D&C2&!C1&C&B2&!B1&B&!A2&A1&A|E&D&C2&!C1&C&B2&!B1&B&!A2&A1&A|E&D&!C2&!C1&C&B2&!B1&B&!A2&A1&A|E&!D&!C2&!C1&C&B2&!B1&B&!A2&A1&A|E&!D&!C2&!C1&C&!B2&!B1&B&!A2&A1&A|E&D&!C2&!C1&C&!B2&!B1&B&!A2&A1&A|E&D&C2&!C1&C&!B2&!B1&B&!A2&A1&A|E&!D&C2&!C1&C&!B2&!B1&B&!A2&A1&A|E&!D&C2&C1&C&!B2&!B1&B&!A2&A1&A|E&D&C2&C1&C&!B2&!B1&B&!A2&A1&A|E&D&!C2&C1&C&!B2&!B1&B&!A2&A1&A|E&!D&!C2&C1&C&!B2&!B1&B&!A2&A1&A|E&!D&!C2&C1&!C&!B2&!B1&B&!A2&A1&A|E&D&!C2&C1&!C&!B2&!B1&B&!A2&A1&A|E&D&C2&C1&!C&!B2&!B1&B&!A2&A1&A|E&!D&C2&C1&!C&!B2&!B1&B&!A2&A1&A|E&!D&C2&!C1&!C&!B2&!B1&B&!A2&A1&A|E&D&C2&!C1&!C&!B2&!B1&B&!A2&A1&A|E&D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&A|E&D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|E&D&C2&!C1&!C&!B2&!B1&B&A2&A1&A|E&!D&C2&!C1&!C&!B2&!B1&B&A2&A1&A|E&!D&C2&C1&!C&!B2&!B1&B&A2&A1&A|E&D&C2&C1&!C&!B2&!B1&B&A2&A1&A|E&D&!C2&C1&!C&!B2&!B1&B&A2&A1&A|E&!D&!C2&C1&!C&!B2&!B1&B&A2&A1&A|E&!D&!C2&C1&C&!B2&!B1&B&A2&A1&A|E&D&!C2&C1&C&!B2&!B1&B&A2&A1&A|E&D&C2&C1&C&!B2&!B1&B&A2&A1&A|E&!D&C2&C1&C&!B2&!B1&B&A2&A1&A|E&!D&C2&!C1&C&!B2&!B1&B&A2&A1&A|E&D&C2&!C1&C&!B2&!B1&B&A2&A1&A|E&D&!C2&!C1&C&!B2&!B1&B&A2&A1&A|E&!D&!C2&!C1&C&!B2&!B1&B&A2&A1&A|E&!D&!C2&!C1&C&B2&!B1&B&A2&A1&A|E&D&!C2&!C1&C&B2&!B1&B&A2&A1&A|E&D&C2&!C1&C&B2&!B1&B&A2&A1&A|E&!D&C2&!C1&C&B2&!B1&B&A2&A1&A|E&!D&C2&C1&C&B2&!B1&B&A2&A1&A|E&D&C2&C1&C&B2&!B1&B&A2&A1&A|E&D&!C2&C1&C&B2&!B1&B&A2&A1&A|E&!D&!C2&C1&C&B2&!B1&B&A2&A1&A|E&!D&!C2&C1&!C&B2&!B1&B&A2&A1&A|E&D&!C2&C1&!C&B2&!B1&B&A2&A1&A|E&D&C2&C1&!C&B2&!B1&B&A2&A1&A|E&!D&C2&C1&!C&B2&!B1&B&A2&A1&A|E&!D&C2&!C1&!C&B2&!B1&B&A2&A1&A|E&D&C2&!C1&!C&B2&!B1&B&A2&A1&A|E&D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|E&D&!C2&!C1&!C&B2&B1&B&A2&A1&A|E&D&C2&!C1&!C&B2&B1&B&A2&A1&A|E&!D&C2&!C1&!C&B2&B1&B&A2&A1&A|E&!D&C2&C1&!C&B2&B1&B&A2&A1&A|E&D&C2&C1&!C&B2&B1&B&A2&A1&A|E&D&!C2&C1&!C&B2&B1&B&A2&A1&A|E&!D&!C2&C1&!C&B2&B1&B&A2&A1&A|E&!D&!C2&C1&C&B2&B1&B&A2&A1&A|E&D&!C2&C1&C&B2&B1&B&A2&A1&A|E&D&C2&C1&C&B2&B1&B&A2&A1&A|E&!D&C2&C1&C&B2&B1&B&A2&A1&A|E&!D&C2&!C1&C&B2&B1&B&A2&A1&A|E&D&C2&!C1&C&B2&B1&B&A2&A1&A|E&D&!C2&!C1&C&B2&B1&B&A2&A1&A|E&!D&!C2&!C1&C&B2&B1&B&A2&A1&A|E&!D&!C2&!C1&C&!B2&B1&B&A2&A1&A|E&D&!C2&!C1&C&!B2&B1&B&A2&A1&A|E&D&C2&!C1&C&!B2&B1&B&A2&A1&A|E&!D&C2&!C1&C&!B2&B1&B&A2&A1&A|E&!D&C2&C1&C&!B2&B1&B&A2&A1&A|E&D&C2&C1&C&!B2&B1&B&A2&A1&A|E&D&!C2&C1&C&!B2&B1&B&A2&A1&A|E&!D&!C2&C1&C&!B2&B1&B&A2&A1&A|E&!D&!C2&C1&!C&!B2&B1&B&A2&A1&A|E&D&!C2&C1&!C&!B2&B1&B&A2&A1&A|E&D&C2&C1&!C&!B2&B1&B&A2&A1&A|E&!D&C2&C1&!C&!B2&B1&B&A2&A1&A|E&!D&C2&!C1&!C&!B2&B1&B&A2&A1&A|E&D&C2&!C1&!C&!B2&B1&B&A2&A1&A|E&D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|E&D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|E&D&C2&!C1&!C&!B2&B1&!B&A2&A1&A|E&!D&C2&!C1&!C&!B2&B1&!B&A2&A1&A|E&!D&C2&C1&!C&!B2&B1&!B&A2&A1&A|E&D&C2&C1&!C&!B2&B1&!B&A2&A1&A|E&D&!C2&C1&!C&!B2&B1&!B&A2&A1&A|E&!D&!C2&C1&!C&!B2&B1&!B&A2&A1&A|E&!D&!C2&C1&C&!B2&B1&!B&A2&A1&A|E&D&!C2&C1&C&!B2&B1&!B&A2&A1&A|E&D&C2&C1&C&!B2&B1&!B&A2&A1&A|E&!D&C2&C1&C&!B2&B1&!B&A2&A1&A|E&!D&C2&!C1&C&!B2&B1&!B&A2&A1&A|E&D&C2&!C1&C&!B2&B1&!B&A2&A1&A|E&D&!C2&!C1&C&!B2&B1&!B&A2&A1&A|E&!D&!C2&!C1&C&!B2&B1&!B&A2&A1&A|E&!D&!C2&!C1&C&B2&B1&!B&A2&A1&A|E&D&!C2&!C1&C&B2&B1&!B&A2&A1&A|E&D&C2&!C1&C&B2&B1&!B&A2&A1&A|E&!D&C2&!C1&C&B2&B1&!B&A2&A1&A|E&!D&C2&C1&C&B2&B1&!B&A2&A1&A|E&D&C2&C1&C&B2&B1&!B&A2&A1&A|E&D&!C2&C1&C&B2&B1&!B&A2&A1&A|E&!D&!C2&C1&C&B2&B1&!B&A2&A1&A|E&!D&!C2&C1&!C&B2&B1&!B&A2&A1&A|E&D&!C2&C1&!C&B2&B1&!B&A2&A1&A|E&D&C2&C1&!C&B2&B1&!B&A2&A1&A|E&!D&C2&C1&!C&B2&B1&!B&A2&A1&A|E&!D&C2&!C1&!C&B2&B1&!B&A2&A1&A|E&D&C2&!C1&!C&B2&B1&!B&A2&A1&A|E&D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|E&D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|E&D&C2&!C1&!C&B2&!B1&!B&A2&A1&A|E&!D&C2&!C1&!C&B2&!B1&!B&A2&A1&A|E&!D&C2&C1&!C&B2&!B1&!B&A2&A1&A|E&D&C2&C1&!C&B2&!B1&!B&A2&A1&A|E&D&!C2&C1&!C&B2&!B1&!B&A2&A1&A|E&!D&!C2&C1&!C&B2&!B1&!B&A2&A1&A|E&!D&!C2&C1&C&B2&!B1&!B&A2&A1&A|E&D&!C2&C1&C&B2&!B1&!B&A2&A1&A|E&D&C2&C1&C&B2&!B1&!B&A2&A1&A|E&!D&C2&C1&C&B2&!B1&!B&A2&A1&A|E&!D&C2&!C1&C&B2&!B1&!B&A2&A1&A|E&D&C2&!C1&C&B2&!B1&!B&A2&A1&A|E&D&!C2&!C1&C&B2&!B1&!B&A2&A1&A|E&!D&!C2&!C1&C&B2&!B1&!B&A2&A1&A|E&D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|E&D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|E&D&C2&C1&C&!B2&!B1&!B&A2&A1&A|E&D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|E&D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|E&D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|E&D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|E&D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|E&D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|E&D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|E&D&C2&C1&!C&!B2&!B1&!B&A2&!A1&A|E&D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&A|E&D&!C2&C1&C&!B2&!B1&!B&A2&!A1&A|E&D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|E&D&C2&!C1&C&!B2&!B1&!B&A2&!A1&A|E&D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&A|E&!D&!C2&!C1&C&B2&!B1&!B&A2&!A1&A|E&D&!C2&!C1&C&B2&!B1&!B&A2&!A1&A|E&D&C2&!C1&C&B2&!B1&!B&A2&!A1&A|E&!D&C2&!C1&C&B2&!B1&!B&A2&!A1&A|E&!D&C2&C1&C&B2&!B1&!B&A2&!A1&A|E&D&C2&C1&C&B2&!B1&!B&A2&!A1&A|E&D&!C2&C1&C&B2&!B1&!B&A2&!A1&A|E&!D&!C2&C1&C&B2&!B1&!B&A2&!A1&A|E&!D&!C2&C1&!C&B2&!B1&!B&A2&!A1&A|E&D&!C2&C1&!C&B2&!B1&!B&A2&!A1&A|E&D&C2&C1&!C&B2&!B1&!B&A2&!A1&A|E&!D&C2&C1&!C&B2&!B1&!B&A2&!A1&A|E&!D&C2&!C1&!C&B2&!B1&!B&A2&!A1&A|E&D&C2&!C1&!C&B2&!B1&!B&A2&!A1&A|E&D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&A|E&D&!C2&!C1&!C&B2&B1&!B&A2&!A1&A|E&D&C2&!C1&!C&B2&B1&!B&A2&!A1&A|E&!D&C2&!C1&!C&B2&B1&!B&A2&!A1&A|E&!D&C2&C1&!C&B2&B1&!B&A2&!A1&A|E&D&C2&C1&!C&B2&B1&!B&A2&!A1&A|E&D&!C2&C1&!C&B2&B1&!B&A2&!A1&A|E&!D&!C2&C1&!C&B2&B1&!B&A2&!A1&A|E&!D&!C2&C1&C&B2&B1&!B&A2&!A1&A|E&D&!C2&C1&C&B2&B1&!B&A2&!A1&A|E&D&C2&C1&C&B2&B1&!B&A2&!A1&A|E&!D&C2&C1&C&B2&B1&!B&A2&!A1&A|E&!D&C2&!C1&C&B2&B1&!B&A2&!A1&A|E&D&C2&!C1&C&B2&B1&!B&A2&!A1&A|E&D&!C2&!C1&C&B2&B1&!B&A2&!A1&A|E&!D&!C2&!C1&C&B2&B1&!B&A2&!A1&A|E&!D&!C2&!C1&C&!B2&B1&!B&A2&!A1&A|E&D&!C2&!C1&C&!B2&B1&!B&A2&!A1&A|E&D&C2&!C1&C&!B2&B1&!B&A2&!A1&A|E&!D&C2&!C1&C&!B2&B1&!B&A2&!A1&A|E&!D&C2&C1&C&!B2&B1&!B&A2&!A1&A|E&D&C2&C1&C&!B2&B1&!B&A2&!A1&A|E&D&!C2&C1&C&!B2&B1&!B&A2&!A1&A|E&!D&!C2&C1&C&!B2&B1&!B&A2&!A1&A|E&!D&!C2&C1&!C&!B2&B1&!B&A2&!A1&A|E&D&!C2&C1&!C&!B2&B1&!B&A2&!A1&A|E&D&C2&C1&!C&!B2&B1&!B&A2&!A1&A|E&!D&C2&C1&!C&!B2&B1&!B&A2&!A1&A|E&!D&C2&!C1&!C&!B2&B1&!B&A2&!A1&A|E&D&C2&!C1&!C&!B2&B1&!B&A2&!A1&A|E&D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&A|E&D&!C2&!C1&!C&!B2&B1&B&A2&!A1&A|E&D&C2&!C1&!C&!B2&B1&B&A2&!A1&A|E&!D&C2&!C1&!C&!B2&B1&B&A2&!A1&A|E&!D&C2&C1&!C&!B2&B1&B&A2&!A1&A|E&D&C2&C1&!C&!B2&B1&B&A2&!A1&A|E&D&!C2&C1&!C&!B2&B1&B&A2&!A1&A|E&!D&!C2&C1&!C&!B2&B1&B&A2&!A1&A|E&!D&!C2&C1&C&!B2&B1&B&A2&!A1&A|E&D&!C2&C1&C&!B2&B1&B&A2&!A1&A|E&D&C2&C1&C&!B2&B1&B&A2&!A1&A|E&!D&C2&C1&C&!B2&B1&B&A2&!A1&A|E&!D&C2&!C1&C&!B2&B1&B&A2&!A1&A|E&D&C2&!C1&C&!B2&B1&B&A2&!A1&A|E&D&!C2&!C1&C&!B2&B1&B&A2&!A1&A|E&!D&!C2&!C1&C&!B2&B1&B&A2&!A1&A|E&!D&!C2&!C1&C&B2&B1&B&A2&!A1&A|E&D&!C2&!C1&C&B2&B1&B&A2&!A1&A|E&D&C2&!C1&C&B2&B1&B&A2&!A1&A|E&!D&C2&!C1&C&B2&B1&B&A2&!A1&A|E&!D&C2&C1&C&B2&B1&B&A2&!A1&A|E&D&C2&C1&C&B2&B1&B&A2&!A1&A|E&D&!C2&C1&C&B2&B1&B&A2&!A1&A|E&!D&!C2&C1&C&B2&B1&B&A2&!A1&A|E&!D&!C2&C1&!C&B2&B1&B&A2&!A1&A|E&D&!C2&C1&!C&B2&B1&B&A2&!A1&A|E&D&C2&C1&!C&B2&B1&B&A2&!A1&A|E&!D&C2&C1&!C&B2&B1&B&A2&!A1&A|E&!D&C2&!C1&!C&B2&B1&B&A2&!A1&A|E&D&C2&!C1&!C&B2&B1&B&A2&!A1&A|E&D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|E&D&!C2&!C1&!C&B2&!B1&B&A2&!A1&A|E&D&C2&!C1&!C&B2&!B1&B&A2&!A1&A|E&!D&C2&!C1&!C&B2&!B1&B&A2&!A1&A|E&!D&C2&C1&!C&B2&!B1&B&A2&!A1&A|E&D&C2&C1&!C&B2&!B1&B&A2&!A1&A|E&D&!C2&C1&!C&B2&!B1&B&A2&!A1&A|E&!D&!C2&C1&!C&B2&!B1&B&A2&!A1&A|E&!D&!C2&C1&C&B2&!B1&B&A2&!A1&A|E&D&!C2&C1&C&B2&!B1&B&A2&!A1&A|E&D&C2&C1&C&B2&!B1&B&A2&!A1&A|E&!D&C2&C1&C&B2&!B1&B&A2&!A1&A|E&!D&C2&!C1&C&B2&!B1&B&A2&!A1&A|E&D&C2&!C1&C&B2&!B1&B&A2&!A1&A|E&D&!C2&!C1&C&B2&!B1&B&A2&!A1&A|E&!D&!C2&!C1&C&B2&!B1&B&A2&!A1&A|E&!D&!C2&!C1&C&!B2&!B1&B&A2&!A1&A|E&D&!C2&!C1&C&!B2&!B1&B&A2&!A1&A|E&D&C2&!C1&C&!B2&!B1&B&A2&!A1&A|E&!D&C2&!C1&C&!B2&!B1&B&A2&!A1&A|E&!D&C2&C1&C&!B2&!B1&B&A2&!A1&A|E&D&C2&C1&C&!B2&!B1&B&A2&!A1&A|E&D&!C2&C1&C&!B2&!B1&B&A2&!A1&A|E&!D&!C2&C1&C&!B2&!B1&B&A2&!A1&A|E&!D&!C2&C1&!C&!B2&!B1&B&A2&!A1&A|E&D&!C2&C1&!C&!B2&!B1&B&A2&!A1&A|E&D&C2&C1&!C&!B2&!B1&B&A2&!A1&A|E&!D&C2&C1&!C&!B2&!B1&B&A2&!A1&A|E&!D&C2&!C1&!C&!B2&!B1&B&A2&!A1&A|E&D&C2&!C1&!C&!B2&!B1&B&A2&!A1&A|E&D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&A|E&D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|E&D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|E&!D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|E&!D&C2&C1&!C&!B2&!B1&B&!A2&!A1&A|E&D&C2&C1&!C&!B2&!B1&B&!A2&!A1&A|E&D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&A|E&!D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&A|E&!D&!C2&C1&C&!B2&!B1&B&!A2&!A1&A|E&D&!C2&C1&C&!B2&!B1&B&!A2&!A1&A|E&D&C2&C1&C&!B2&!B1&B&!A2&!A1&A|E&!D&C2&C1&C&!B2&!B1&B&!A2&!A1&A|E&!D&C2&!C1&C&!B2&!B1&B&!A2&!A1&A|E&D&C2&!C1&C&!B2&!B1&B&!A2&!A1&A|E&D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&A|E&!D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&A|E&!D&!C2&!C1&C&B2&!B1&B&!A2&!A1&A|E&D&!C2&!C1&C&B2&!B1&B&!A2&!A1&A|E&D&C2&!C1&C&B2&!B1&B&!A2&!A1&A|E&!D&C2&!C1&C&B2&!B1&B&!A2&!A1&A|E&!D&C2&C1&C&B2&!B1&B&!A2&!A1&A|E&D&C2&C1&C&B2&!B1&B&!A2&!A1&A|E&D&!C2&C1&C&B2&!B1&B&!A2&!A1&A|E&!D&!C2&C1&C&B2&!B1&B&!A2&!A1&A|E&!D&!C2&C1&!C&B2&!B1&B&!A2&!A1&A|E&D&!C2&C1&!C&B2&!B1&B&!A2&!A1&A|E&D&C2&C1&!C&B2&!B1&B&!A2&!A1&A|E&!D&C2&C1&!C&B2&!B1&B&!A2&!A1&A|E&!D&C2&!C1&!C&B2&!B1&B&!A2&!A1&A|E&D&C2&!C1&!C&B2&!B1&B&!A2&!A1&A|E&D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&A|E&D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|E&D&C2&!C1&!C&B2&B1&B&!A2&!A1&A|E&!D&C2&!C1&!C&B2&B1&B&!A2&!A1&A|E&!D&C2&C1&!C&B2&B1&B&!A2&!A1&A|E&D&C2&C1&!C&B2&B1&B&!A2&!A1&A|E&D&!C2&C1&!C&B2&B1&B&!A2&!A1&A|E&!D&!C2&C1&!C&B2&B1&B&!A2&!A1&A|E&!D&!C2&C1&C&B2&B1&B&!A2&!A1&A|E&D&!C2&C1&C&B2&B1&B&!A2&!A1&A|E&D&C2&C1&C&B2&B1&B&!A2&!A1&A|E&!D&C2&C1&C&B2&B1&B&!A2&!A1&A|E&!D&C2&!C1&C&B2&B1&B&!A2&!A1&A|E&D&C2&!C1&C&B2&B1&B&!A2&!A1&A|E&D&!C2&!C1&C&B2&B1&B&!A2&!A1&A|E&!D&!C2&!C1&C&B2&B1&B&!A2&!A1&A|E&!D&!C2&!C1&C&!B2&B1&B&!A2&!A1&A|E&D&!C2&!C1&C&!B2&B1&B&!A2&!A1&A|E&D&C2&!C1&C&!B2&B1&B&!A2&!A1&A|E&!D&C2&!C1&C&!B2&B1&B&!A2&!A1&A|E&!D&C2&C1&C&!B2&B1&B&!A2&!A1&A|E&D&C2&C1&C&!B2&B1&B&!A2&!A1&A|E&D&!C2&C1&C&!B2&B1&B&!A2&!A1&A|E&!D&!C2&C1&C&!B2&B1&B&!A2&!A1&A|E&!D&!C2&C1&!C&!B2&B1&B&!A2&!A1&A|E&D&!C2&C1&!C&!B2&B1&B&!A2&!A1&A|E&D&C2&C1&!C&!B2&B1&B&!A2&!A1&A|E&!D&C2&C1&!C&!B2&B1&B&!A2&!A1&A|E&!D&C2&!C1&!C&!B2&B1&B&!A2&!A1&A|E&D&C2&!C1&!C&!B2&B1&B&!A2&!A1&A|E&D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&A|E&D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|E&D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|E&!D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|E&!D&C2&C1&!C&!B2&B1&!B&!A2&!A1&A|E&D&C2&C1&!C&!B2&B1&!B&!A2&!A1&A|E&D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&A|E&!D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&A|E&!D&!C2&C1&C&!B2&B1&!B&!A2&!A1&A|E&D&!C2&C1&C&!B2&B1&!B&!A2&!A1&A|E&D&C2&C1&C&!B2&B1&!B&!A2&!A1&A|E&!D&C2&C1&C&!B2&B1&!B&!A2&!A1&A|E&!D&C2&!C1&C&!B2&B1&!B&!A2&!A1&A|E&D&C2&!C1&C&!B2&B1&!B&!A2&!A1&A|E&D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&A|E&!D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&A|E&!D&!C2&!C1&C&B2&B1&!B&!A2&!A1&A|E&D&!C2&!C1&C&B2&B1&!B&!A2&!A1&A|E&D&C2&!C1&C&B2&B1&!B&!A2&!A1&A|E&!D&C2&!C1&C&B2&B1&!B&!A2&!A1&A|E&!D&C2&C1&C&B2&B1&!B&!A2&!A1&A|E&D&C2&C1&C&B2&B1&!B&!A2&!A1&A|E&D&!C2&C1&C&B2&B1&!B&!A2&!A1&A|E&!D&!C2&C1&C&B2&B1&!B&!A2&!A1&A|E&!D&!C2&C1&!C&B2&B1&!B&!A2&!A1&A|E&D&!C2&C1&!C&B2&B1&!B&!A2&!A1&A|E&D&C2&C1&!C&B2&B1&!B&!A2&!A1&A|E&!D&C2&C1&!C&B2&B1&!B&!A2&!A1&A|E&!D&C2&!C1&!C&B2&B1&!B&!A2&!A1&A|E&D&C2&!C1&!C&B2&B1&!B&!A2&!A1&A|E&D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&A|E&D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|E&D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|E&!D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|E&!D&C2&C1&!C&B2&!B1&!B&!A2&!A1&A|E&D&C2&C1&!C&B2&!B1&!B&!A2&!A1&A|E&D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&A|E&!D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&A|E&!D&!C2&C1&C&B2&!B1&!B&!A2&!A1&A|E&D&!C2&C1&C&B2&!B1&!B&!A2&!A1&A|E&D&C2&C1&C&B2&!B1&!B&!A2&!A1&A|E&!D&C2&C1&C&B2&!B1&!B&!A2&!A1&A|E&!D&C2&!C1&C&B2&!B1&!B&!A2&!A1&A|E&D&C2&!C1&C&B2&!B1&!B&!A2&!A1&A|E&D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&A|E&!D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&A|E&D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|E&D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|E&D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A|E&D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&A|E&D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|E&D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|E&D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|E&D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAOAI33311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOOAI2223 -l OOAAOOAI2223 -i D2 D1 D C1 C B1 B A1 A -o Y -f Y=(!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|D2&D1&D&!C1&!C&!B1&!B&!A1&!A|D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|D2&!D1&D&C1&!C&!B1&!B&!A1&!A|D2&D1&D&C1&!C&!B1&!B&!A1&!A|!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|D2&D1&!D&C1&!C&!B1&!B&!A1&!A|D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|D2&!D1&D&!C1&C&!B1&!B&!A1&!A|D2&D1&D&!C1&C&!B1&!B&!A1&!A|!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|D2&D1&!D&!C1&C&!B1&!B&!A1&!A|D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|D2&!D1&!D&!C1&C&B1&!B&!A1&!A|D2&D1&!D&!C1&C&B1&!B&!A1&!A|!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!D2&D1&D&!C1&C&B1&!B&!A1&!A|D2&D1&D&!C1&C&B1&!B&!A1&!A|D2&!D1&D&!C1&C&B1&!B&!A1&!A|!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|D2&!D1&!D&C1&!C&B1&!B&!A1&!A|D2&D1&!D&C1&!C&B1&!B&!A1&!A|!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!D2&D1&D&C1&!C&B1&!B&!A1&!A|D2&D1&D&C1&!C&B1&!B&!A1&!A|D2&!D1&D&C1&!C&B1&!B&!A1&!A|!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|D2&!D1&D&!C1&!C&B1&!B&!A1&!A|D2&D1&D&!C1&!C&B1&!B&!A1&!A|!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|D2&D1&!D&!C1&!C&B1&!B&!A1&!A|D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|D2&!D1&!D&!C1&!C&B1&B&!A1&!A|D2&D1&!D&!C1&!C&B1&B&!A1&!A|!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!D2&D1&D&!C1&!C&B1&B&!A1&!A|D2&D1&D&!C1&!C&B1&B&!A1&!A|D2&!D1&D&!C1&!C&B1&B&!A1&!A|!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!D2&!D1&D&C1&!C&B1&B&!A1&!A|D2&!D1&D&C1&!C&B1&B&!A1&!A|D2&D1&D&C1&!C&B1&B&!A1&!A|!D2&D1&D&C1&!C&B1&B&!A1&!A|!D2&D1&!D&C1&!C&B1&B&!A1&!A|D2&D1&!D&C1&!C&B1&B&!A1&!A|D2&!D1&!D&C1&!C&B1&B&!A1&!A|!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!D2&!D1&!D&C1&C&B1&B&!A1&!A|!D2&!D1&D&!C1&C&B1&B&!A1&!A|D2&!D1&D&!C1&C&B1&B&!A1&!A|D2&D1&D&!C1&C&B1&B&!A1&!A|!D2&D1&D&!C1&C&B1&B&!A1&!A|!D2&D1&!D&!C1&C&B1&B&!A1&!A|D2&D1&!D&!C1&C&B1&B&!A1&!A|D2&!D1&!D&!C1&C&B1&B&!A1&!A|!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|D2&!D1&!D&!C1&C&!B1&B&!A1&!A|D2&D1&!D&!C1&C&!B1&B&!A1&!A|!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!D2&D1&D&!C1&C&!B1&B&!A1&!A|D2&D1&D&!C1&C&!B1&B&!A1&!A|D2&!D1&D&!C1&C&!B1&B&!A1&!A|!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|D2&!D1&!D&C1&!C&!B1&B&!A1&!A|D2&D1&!D&C1&!C&!B1&B&!A1&!A|!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!D2&D1&D&C1&!C&!B1&B&!A1&!A|D2&D1&D&C1&!C&!B1&B&!A1&!A|D2&!D1&D&C1&!C&!B1&B&!A1&!A|!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|D2&!D1&D&!C1&!C&!B1&B&!A1&!A|D2&D1&D&!C1&!C&!B1&B&!A1&!A|!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|D2&D1&!D&!C1&!C&!B1&B&!A1&!A|D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!D2&!D1&!D&C1&C&!B1&B&A1&!A|!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!D2&!D1&!D&!C1&C&B1&B&A1&!A|!D2&!D1&!D&C1&C&B1&B&A1&!A|!D2&!D1&!D&C1&!C&B1&B&A1&!A|!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!D2&!D1&!D&C1&C&B1&!B&A1&!A|!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|D2&!D1&!D&!C1&C&!B1&!B&A1&!A|D2&D1&!D&!C1&C&!B1&!B&A1&!A|!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!D2&D1&D&!C1&C&!B1&!B&A1&!A|D2&D1&D&!C1&C&!B1&!B&A1&!A|D2&!D1&D&!C1&C&!B1&!B&A1&!A|!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|D2&!D1&!D&C1&!C&!B1&!B&A1&!A|D2&D1&!D&C1&!C&!B1&!B&A1&!A|!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!D2&D1&D&C1&!C&!B1&!B&A1&!A|D2&D1&D&C1&!C&!B1&!B&A1&!A|D2&!D1&D&C1&!C&!B1&!B&A1&!A|!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|D2&!D1&D&!C1&!C&!B1&!B&A1&!A|D2&D1&D&!C1&!C&!B1&!B&A1&!A|!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|D2&D1&!D&!C1&!C&!B1&!B&A1&!A|D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|D2&!D1&!D&!C1&!C&!B1&!B&A1&A|D2&D1&!D&!C1&!C&!B1&!B&A1&A|!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!D2&D1&D&!C1&!C&!B1&!B&A1&A|D2&D1&D&!C1&!C&!B1&!B&A1&A|D2&!D1&D&!C1&!C&!B1&!B&A1&A|!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!D2&!D1&D&C1&!C&!B1&!B&A1&A|D2&!D1&D&C1&!C&!B1&!B&A1&A|D2&D1&D&C1&!C&!B1&!B&A1&A|!D2&D1&D&C1&!C&!B1&!B&A1&A|!D2&D1&!D&C1&!C&!B1&!B&A1&A|D2&D1&!D&C1&!C&!B1&!B&A1&A|D2&!D1&!D&C1&!C&!B1&!B&A1&A|!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!D2&!D1&!D&C1&C&!B1&!B&A1&A|!D2&!D1&D&!C1&C&!B1&!B&A1&A|D2&!D1&D&!C1&C&!B1&!B&A1&A|D2&D1&D&!C1&C&!B1&!B&A1&A|!D2&D1&D&!C1&C&!B1&!B&A1&A|!D2&D1&!D&!C1&C&!B1&!B&A1&A|D2&D1&!D&!C1&C&!B1&!B&A1&A|D2&!D1&!D&!C1&C&!B1&!B&A1&A|!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!D2&!D1&!D&!C1&C&B1&!B&A1&A|!D2&!D1&!D&C1&C&B1&!B&A1&A|!D2&!D1&!D&C1&!C&B1&!B&A1&A|!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!D2&!D1&!D&!C1&!C&B1&B&A1&A|!D2&!D1&!D&C1&!C&B1&B&A1&A|!D2&!D1&!D&C1&C&B1&B&A1&A|!D2&!D1&!D&!C1&C&B1&B&A1&A|!D2&!D1&!D&!C1&C&!B1&B&A1&A|!D2&!D1&!D&C1&C&!B1&B&A1&A|!D2&!D1&!D&C1&!C&!B1&B&A1&A|!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!D2&!D1&!D&C1&C&!B1&B&!A1&A|!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!D2&!D1&!D&!C1&C&B1&B&!A1&A|!D2&!D1&!D&C1&C&B1&B&!A1&A|!D2&!D1&!D&C1&!C&B1&B&!A1&A|!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!D2&!D1&!D&C1&C&B1&!B&!A1&A|!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|D2&!D1&!D&!C1&C&!B1&!B&!A1&A|D2&D1&!D&!C1&C&!B1&!B&!A1&A|!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!D2&D1&D&!C1&C&!B1&!B&!A1&A|D2&D1&D&!C1&C&!B1&!B&!A1&A|D2&!D1&D&!C1&C&!B1&!B&!A1&A|!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|D2&!D1&!D&C1&!C&!B1&!B&!A1&A|D2&D1&!D&C1&!C&!B1&!B&!A1&A|!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!D2&D1&D&C1&!C&!B1&!B&!A1&A|D2&D1&D&C1&!C&!B1&!B&!A1&A|D2&!D1&D&C1&!C&!B1&!B&!A1&A|!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|D2&!D1&D&!C1&!C&!B1&!B&!A1&A|D2&D1&D&!C1&!C&!B1&!B&!A1&A|!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|D2&D1&!D&!C1&!C&!B1&!B&!A1&A|D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOOAI2223.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAOI22121 -l AAOAOI22121 -i E D1 D C B1 B A1 A -o Y -f Y=(!E&!D1&!D&!C&!B1&!B&!A1&!A|!E&D1&!D&!C&!B1&!B&!A1&!A|!E&D1&D&!C&!B1&!B&!A1&!A|!E&!D1&D&!C&!B1&!B&!A1&!A|!E&!D1&D&C&!B1&!B&!A1&!A|!E&D1&!D&C&!B1&!B&!A1&!A|!E&!D1&!D&C&!B1&!B&!A1&!A|!E&!D1&!D&C&B1&!B&!A1&!A|!E&D1&!D&C&B1&!B&!A1&!A|!E&!D1&D&C&B1&!B&!A1&!A|!E&!D1&D&!C&B1&!B&!A1&!A|!E&D1&D&!C&B1&!B&!A1&!A|!E&D1&!D&!C&B1&!B&!A1&!A|!E&!D1&!D&!C&B1&!B&!A1&!A|!E&!D1&!D&!C&B1&B&!A1&!A|!E&D1&!D&!C&B1&B&!A1&!A|!E&!D1&D&!C&B1&B&!A1&!A|!E&!D1&D&C&B1&B&!A1&!A|!E&D1&!D&C&B1&B&!A1&!A|!E&!D1&!D&C&B1&B&!A1&!A|!E&!D1&!D&C&!B1&B&!A1&!A|!E&D1&!D&C&!B1&B&!A1&!A|!E&!D1&D&C&!B1&B&!A1&!A|!E&!D1&D&!C&!B1&B&!A1&!A|!E&D1&D&!C&!B1&B&!A1&!A|!E&D1&!D&!C&!B1&B&!A1&!A|!E&!D1&!D&!C&!B1&B&!A1&!A|!E&!D1&!D&!C&!B1&B&A1&!A|!E&D1&!D&!C&!B1&B&A1&!A|!E&D1&D&!C&!B1&B&A1&!A|!E&!D1&D&!C&!B1&B&A1&!A|!E&!D1&D&C&!B1&B&A1&!A|!E&D1&!D&C&!B1&B&A1&!A|!E&!D1&!D&C&!B1&B&A1&!A|!E&!D1&!D&C&B1&B&A1&!A|!E&D1&!D&C&B1&B&A1&!A|!E&!D1&D&C&B1&B&A1&!A|!E&!D1&D&!C&B1&B&A1&!A|!E&D1&!D&!C&B1&B&A1&!A|!E&!D1&!D&!C&B1&B&A1&!A|!E&!D1&!D&!C&B1&!B&A1&!A|!E&D1&!D&!C&B1&!B&A1&!A|!E&D1&D&!C&B1&!B&A1&!A|!E&!D1&D&!C&B1&!B&A1&!A|!E&!D1&D&C&B1&!B&A1&!A|!E&D1&!D&C&B1&!B&A1&!A|!E&!D1&!D&C&B1&!B&A1&!A|!E&!D1&!D&C&!B1&!B&A1&!A|!E&D1&!D&C&!B1&!B&A1&!A|!E&!D1&D&C&!B1&!B&A1&!A|!E&!D1&D&!C&!B1&!B&A1&!A|!E&D1&D&!C&!B1&!B&A1&!A|!E&D1&!D&!C&!B1&!B&A1&!A|!E&!D1&!D&!C&!B1&!B&A1&!A|!E&!D1&!D&!C&!B1&!B&A1&A|!E&D1&!D&!C&!B1&!B&A1&A|!E&!D1&D&!C&!B1&!B&A1&A|!E&!D1&D&C&!B1&!B&A1&A|!E&D1&!D&C&!B1&!B&A1&A|!E&!D1&!D&C&!B1&!B&A1&A|!E&!D1&!D&C&B1&!B&A1&A|!E&D1&!D&C&B1&!B&A1&A|!E&!D1&D&C&B1&!B&A1&A|!E&!D1&D&!C&B1&!B&A1&A|!E&D1&!D&!C&B1&!B&A1&A|!E&!D1&!D&!C&B1&!B&A1&A|!E&!D1&!D&!C&B1&B&A1&A|!E&D1&!D&!C&B1&B&A1&A|!E&!D1&D&!C&B1&B&A1&A|!E&!D1&D&C&B1&B&A1&A|!E&D1&!D&C&B1&B&A1&A|!E&!D1&!D&C&B1&B&A1&A|!E&!D1&!D&C&!B1&B&A1&A|!E&D1&!D&C&!B1&B&A1&A|!E&!D1&D&C&!B1&B&A1&A|!E&!D1&D&!C&!B1&B&A1&A|!E&D1&!D&!C&!B1&B&A1&A|!E&!D1&!D&!C&!B1&B&A1&A|!E&!D1&!D&!C&!B1&B&!A1&A|!E&D1&!D&!C&!B1&B&!A1&A|!E&D1&D&!C&!B1&B&!A1&A|!E&!D1&D&!C&!B1&B&!A1&A|!E&!D1&D&C&!B1&B&!A1&A|!E&D1&!D&C&!B1&B&!A1&A|!E&!D1&!D&C&!B1&B&!A1&A|!E&!D1&!D&C&B1&B&!A1&A|!E&D1&!D&C&B1&B&!A1&A|!E&!D1&D&C&B1&B&!A1&A|!E&!D1&D&!C&B1&B&!A1&A|!E&D1&!D&!C&B1&B&!A1&A|!E&!D1&!D&!C&B1&B&!A1&A|!E&!D1&!D&!C&B1&!B&!A1&A|!E&D1&!D&!C&B1&!B&!A1&A|!E&D1&D&!C&B1&!B&!A1&A|!E&!D1&D&!C&B1&!B&!A1&A|!E&!D1&D&C&B1&!B&!A1&A|!E&D1&!D&C&B1&!B&!A1&A|!E&!D1&!D&C&B1&!B&!A1&A|!E&!D1&!D&C&!B1&!B&!A1&A|!E&D1&!D&C&!B1&!B&!A1&A|!E&!D1&D&C&!B1&!B&!A1&A|!E&!D1&D&!C&!B1&!B&!A1&A|!E&D1&D&!C&!B1&!B&!A1&A|!E&D1&!D&!C&!B1&!B&!A1&A|!E&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAOI22121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAAOAI22231 -l OOOAAOAI22231 -i E D2 D1 D C1 C B1 B A1 A -o Y -f Y=!(E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|E&D2&D1&D&C1&C&!B1&!B&!A1&!A|E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|E&D2&D1&D&!C1&C&B1&!B&!A1&!A|E&D2&D1&D&C1&C&B1&!B&!A1&!A|E&D2&D1&D&C1&!C&B1&!B&!A1&!A|E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|E&D2&D1&D&!C1&!C&B1&B&!A1&!A|E&D2&D1&D&C1&!C&B1&B&!A1&!A|E&D2&D1&D&C1&C&B1&B&!A1&!A|E&D2&D1&D&!C1&C&B1&B&!A1&!A|E&D2&D1&D&!C1&C&!B1&B&!A1&!A|E&D2&D1&D&C1&C&!B1&B&!A1&!A|E&D2&D1&D&C1&!C&!B1&B&!A1&!A|E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|E&D2&D1&D&!C1&!C&!B1&B&A1&!A|E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|E&D2&!D1&D&C1&!C&!B1&B&A1&!A|E&D2&D1&D&C1&!C&!B1&B&A1&!A|E&!D2&D1&D&C1&!C&!B1&B&A1&!A|E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|E&D2&D1&!D&C1&!C&!B1&B&A1&!A|E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|E&D2&!D1&!D&C1&C&!B1&B&A1&!A|E&D2&D1&!D&C1&C&!B1&B&A1&!A|E&!D2&D1&!D&C1&C&!B1&B&A1&!A|E&!D2&D1&D&C1&C&!B1&B&A1&!A|E&D2&D1&D&C1&C&!B1&B&A1&!A|E&D2&!D1&D&C1&C&!B1&B&A1&!A|E&!D2&!D1&D&C1&C&!B1&B&A1&!A|E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|E&D2&!D1&D&!C1&C&!B1&B&A1&!A|E&D2&D1&D&!C1&C&!B1&B&A1&!A|E&!D2&D1&D&!C1&C&!B1&B&A1&!A|E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|E&D2&D1&!D&!C1&C&!B1&B&A1&!A|E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|E&D2&!D1&!D&!C1&C&B1&B&A1&!A|E&D2&D1&!D&!C1&C&B1&B&A1&!A|E&!D2&D1&!D&!C1&C&B1&B&A1&!A|E&!D2&D1&D&!C1&C&B1&B&A1&!A|E&D2&D1&D&!C1&C&B1&B&A1&!A|E&D2&!D1&D&!C1&C&B1&B&A1&!A|E&!D2&!D1&D&!C1&C&B1&B&A1&!A|E&!D2&!D1&D&C1&C&B1&B&A1&!A|E&D2&!D1&D&C1&C&B1&B&A1&!A|E&D2&D1&D&C1&C&B1&B&A1&!A|E&!D2&D1&D&C1&C&B1&B&A1&!A|E&!D2&D1&!D&C1&C&B1&B&A1&!A|E&D2&D1&!D&C1&C&B1&B&A1&!A|E&D2&!D1&!D&C1&C&B1&B&A1&!A|E&!D2&!D1&!D&C1&C&B1&B&A1&!A|E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|E&D2&!D1&!D&C1&!C&B1&B&A1&!A|E&D2&D1&!D&C1&!C&B1&B&A1&!A|E&!D2&D1&!D&C1&!C&B1&B&A1&!A|E&!D2&D1&D&C1&!C&B1&B&A1&!A|E&D2&D1&D&C1&!C&B1&B&A1&!A|E&D2&!D1&D&C1&!C&B1&B&A1&!A|E&!D2&!D1&D&C1&!C&B1&B&A1&!A|E&D2&D1&D&!C1&!C&B1&B&A1&!A|E&D2&D1&D&!C1&!C&B1&!B&A1&!A|E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|E&D2&!D1&D&C1&!C&B1&!B&A1&!A|E&D2&D1&D&C1&!C&B1&!B&A1&!A|E&!D2&D1&D&C1&!C&B1&!B&A1&!A|E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|E&D2&D1&!D&C1&!C&B1&!B&A1&!A|E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|E&D2&!D1&!D&C1&C&B1&!B&A1&!A|E&D2&D1&!D&C1&C&B1&!B&A1&!A|E&!D2&D1&!D&C1&C&B1&!B&A1&!A|E&!D2&D1&D&C1&C&B1&!B&A1&!A|E&D2&D1&D&C1&C&B1&!B&A1&!A|E&D2&!D1&D&C1&C&B1&!B&A1&!A|E&!D2&!D1&D&C1&C&B1&!B&A1&!A|E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|E&D2&!D1&D&!C1&C&B1&!B&A1&!A|E&D2&D1&D&!C1&C&B1&!B&A1&!A|E&!D2&D1&D&!C1&C&B1&!B&A1&!A|E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|E&D2&D1&!D&!C1&C&B1&!B&A1&!A|E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|E&D2&D1&D&!C1&C&!B1&!B&A1&!A|E&D2&D1&D&C1&C&!B1&!B&A1&!A|E&D2&D1&D&C1&!C&!B1&!B&A1&!A|E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|E&D2&D1&D&!C1&!C&!B1&!B&A1&A|E&D2&D1&D&C1&!C&!B1&!B&A1&A|E&D2&D1&D&C1&C&!B1&!B&A1&A|E&D2&D1&D&!C1&C&!B1&!B&A1&A|E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|E&D2&!D1&!D&!C1&C&B1&!B&A1&A|E&D2&D1&!D&!C1&C&B1&!B&A1&A|E&!D2&D1&!D&!C1&C&B1&!B&A1&A|E&!D2&D1&D&!C1&C&B1&!B&A1&A|E&D2&D1&D&!C1&C&B1&!B&A1&A|E&D2&!D1&D&!C1&C&B1&!B&A1&A|E&!D2&!D1&D&!C1&C&B1&!B&A1&A|E&!D2&!D1&D&C1&C&B1&!B&A1&A|E&D2&!D1&D&C1&C&B1&!B&A1&A|E&D2&D1&D&C1&C&B1&!B&A1&A|E&!D2&D1&D&C1&C&B1&!B&A1&A|E&!D2&D1&!D&C1&C&B1&!B&A1&A|E&D2&D1&!D&C1&C&B1&!B&A1&A|E&D2&!D1&!D&C1&C&B1&!B&A1&A|E&!D2&!D1&!D&C1&C&B1&!B&A1&A|E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|E&D2&!D1&!D&C1&!C&B1&!B&A1&A|E&D2&D1&!D&C1&!C&B1&!B&A1&A|E&!D2&D1&!D&C1&!C&B1&!B&A1&A|E&!D2&D1&D&C1&!C&B1&!B&A1&A|E&D2&D1&D&C1&!C&B1&!B&A1&A|E&D2&!D1&D&C1&!C&B1&!B&A1&A|E&!D2&!D1&D&C1&!C&B1&!B&A1&A|E&D2&D1&D&!C1&!C&B1&!B&A1&A|E&D2&D1&D&!C1&!C&B1&B&A1&A|E&!D2&!D1&D&C1&!C&B1&B&A1&A|E&D2&!D1&D&C1&!C&B1&B&A1&A|E&D2&D1&D&C1&!C&B1&B&A1&A|E&!D2&D1&D&C1&!C&B1&B&A1&A|E&!D2&D1&!D&C1&!C&B1&B&A1&A|E&D2&D1&!D&C1&!C&B1&B&A1&A|E&D2&!D1&!D&C1&!C&B1&B&A1&A|E&!D2&!D1&!D&C1&!C&B1&B&A1&A|E&!D2&!D1&!D&C1&C&B1&B&A1&A|E&D2&!D1&!D&C1&C&B1&B&A1&A|E&D2&D1&!D&C1&C&B1&B&A1&A|E&!D2&D1&!D&C1&C&B1&B&A1&A|E&!D2&D1&D&C1&C&B1&B&A1&A|E&D2&D1&D&C1&C&B1&B&A1&A|E&D2&!D1&D&C1&C&B1&B&A1&A|E&!D2&!D1&D&C1&C&B1&B&A1&A|E&!D2&!D1&D&!C1&C&B1&B&A1&A|E&D2&!D1&D&!C1&C&B1&B&A1&A|E&D2&D1&D&!C1&C&B1&B&A1&A|E&!D2&D1&D&!C1&C&B1&B&A1&A|E&!D2&D1&!D&!C1&C&B1&B&A1&A|E&D2&D1&!D&!C1&C&B1&B&A1&A|E&D2&!D1&!D&!C1&C&B1&B&A1&A|E&!D2&!D1&!D&!C1&C&B1&B&A1&A|E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|E&D2&!D1&!D&!C1&C&!B1&B&A1&A|E&D2&D1&!D&!C1&C&!B1&B&A1&A|E&!D2&D1&!D&!C1&C&!B1&B&A1&A|E&!D2&D1&D&!C1&C&!B1&B&A1&A|E&D2&D1&D&!C1&C&!B1&B&A1&A|E&D2&!D1&D&!C1&C&!B1&B&A1&A|E&!D2&!D1&D&!C1&C&!B1&B&A1&A|E&!D2&!D1&D&C1&C&!B1&B&A1&A|E&D2&!D1&D&C1&C&!B1&B&A1&A|E&D2&D1&D&C1&C&!B1&B&A1&A|E&!D2&D1&D&C1&C&!B1&B&A1&A|E&!D2&D1&!D&C1&C&!B1&B&A1&A|E&D2&D1&!D&C1&C&!B1&B&A1&A|E&D2&!D1&!D&C1&C&!B1&B&A1&A|E&!D2&!D1&!D&C1&C&!B1&B&A1&A|E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|E&D2&!D1&!D&C1&!C&!B1&B&A1&A|E&D2&D1&!D&C1&!C&!B1&B&A1&A|E&!D2&D1&!D&C1&!C&!B1&B&A1&A|E&!D2&D1&D&C1&!C&!B1&B&A1&A|E&D2&D1&D&C1&!C&!B1&B&A1&A|E&D2&!D1&D&C1&!C&!B1&B&A1&A|E&!D2&!D1&D&C1&!C&!B1&B&A1&A|E&D2&D1&D&!C1&!C&!B1&B&A1&A|E&D2&D1&D&!C1&!C&!B1&B&!A1&A|E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|E&D2&!D1&D&C1&!C&!B1&B&!A1&A|E&D2&D1&D&C1&!C&!B1&B&!A1&A|E&!D2&D1&D&C1&!C&!B1&B&!A1&A|E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|E&D2&D1&!D&C1&!C&!B1&B&!A1&A|E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|E&D2&!D1&!D&C1&C&!B1&B&!A1&A|E&D2&D1&!D&C1&C&!B1&B&!A1&A|E&!D2&D1&!D&C1&C&!B1&B&!A1&A|E&!D2&D1&D&C1&C&!B1&B&!A1&A|E&D2&D1&D&C1&C&!B1&B&!A1&A|E&D2&!D1&D&C1&C&!B1&B&!A1&A|E&!D2&!D1&D&C1&C&!B1&B&!A1&A|E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|E&D2&!D1&D&!C1&C&!B1&B&!A1&A|E&D2&D1&D&!C1&C&!B1&B&!A1&A|E&!D2&D1&D&!C1&C&!B1&B&!A1&A|E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|E&D2&D1&!D&!C1&C&!B1&B&!A1&A|E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|E&D2&!D1&!D&!C1&C&B1&B&!A1&A|E&D2&D1&!D&!C1&C&B1&B&!A1&A|E&!D2&D1&!D&!C1&C&B1&B&!A1&A|E&!D2&D1&D&!C1&C&B1&B&!A1&A|E&D2&D1&D&!C1&C&B1&B&!A1&A|E&D2&!D1&D&!C1&C&B1&B&!A1&A|E&!D2&!D1&D&!C1&C&B1&B&!A1&A|E&!D2&!D1&D&C1&C&B1&B&!A1&A|E&D2&!D1&D&C1&C&B1&B&!A1&A|E&D2&D1&D&C1&C&B1&B&!A1&A|E&!D2&D1&D&C1&C&B1&B&!A1&A|E&!D2&D1&!D&C1&C&B1&B&!A1&A|E&D2&D1&!D&C1&C&B1&B&!A1&A|E&D2&!D1&!D&C1&C&B1&B&!A1&A|E&!D2&!D1&!D&C1&C&B1&B&!A1&A|E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|E&D2&!D1&!D&C1&!C&B1&B&!A1&A|E&D2&D1&!D&C1&!C&B1&B&!A1&A|E&!D2&D1&!D&C1&!C&B1&B&!A1&A|E&!D2&D1&D&C1&!C&B1&B&!A1&A|E&D2&D1&D&C1&!C&B1&B&!A1&A|E&D2&!D1&D&C1&!C&B1&B&!A1&A|E&!D2&!D1&D&C1&!C&B1&B&!A1&A|E&D2&D1&D&!C1&!C&B1&B&!A1&A|E&D2&D1&D&!C1&!C&B1&!B&!A1&A|E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|E&D2&!D1&D&C1&!C&B1&!B&!A1&A|E&D2&D1&D&C1&!C&B1&!B&!A1&A|E&!D2&D1&D&C1&!C&B1&!B&!A1&A|E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|E&D2&D1&!D&C1&!C&B1&!B&!A1&A|E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|E&D2&!D1&!D&C1&C&B1&!B&!A1&A|E&D2&D1&!D&C1&C&B1&!B&!A1&A|E&!D2&D1&!D&C1&C&B1&!B&!A1&A|E&!D2&D1&D&C1&C&B1&!B&!A1&A|E&D2&D1&D&C1&C&B1&!B&!A1&A|E&D2&!D1&D&C1&C&B1&!B&!A1&A|E&!D2&!D1&D&C1&C&B1&!B&!A1&A|E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|E&D2&!D1&D&!C1&C&B1&!B&!A1&A|E&D2&D1&D&!C1&C&B1&!B&!A1&A|E&!D2&D1&D&!C1&C&B1&!B&!A1&A|E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|E&D2&D1&!D&!C1&C&B1&!B&!A1&A|E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|E&D2&D1&D&!C1&C&!B1&!B&!A1&A|E&D2&D1&D&C1&C&!B1&!B&!A1&A|E&D2&D1&D&C1&!C&!B1&!B&!A1&A|E&D2&D1&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAAOAI22231.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAOI3331 -l OOOAOI3331 -i D C2 C1 C B2 B1 B A2 A1 A -o Y -f Y=(!D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|!D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D&C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!D&!C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|!D&C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|!D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|!D&C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|!D&C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!D&!C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!D&!C2&C1&C&B2&B1&!B&!A2&!A1&!A|!D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|!D&C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!D&!C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D&C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!D&!C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|!D&C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|!D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|!D&C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|!D&C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!D&!C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!D&!C2&C1&C&!B2&B1&B&!A2&!A1&!A|!D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|!D&C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!D&!C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|!D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|!D&C2&C1&C&B2&B1&B&!A2&!A1&!A|!D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|!D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|!D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|!D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|!D&C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|!D&C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!D&!C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!D&!C2&C1&C&B2&!B1&B&!A2&!A1&!A|!D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|!D&C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!D&!C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D&C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!D&!C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|!D&C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|!D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|!D&!C2&!C1&!C&B2&!B1&B&A2&!A1&!A|!D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|!D&!C2&!C1&!C&!B2&B1&B&A2&!A1&!A|!D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|!D&!C2&!C1&!C&B2&B1&!B&A2&!A1&!A|!D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|!D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D&C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!D&!C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|!D&C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|!D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|!D&C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|!D&C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!D&!C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!D&!C2&C1&C&!B2&!B1&!B&A2&A1&!A|!D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|!D&C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!D&!C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!D&!C2&!C1&!C&B2&!B1&!B&A2&A1&!A|!D&!C2&!C1&!C&B2&B1&!B&A2&A1&!A|!D&!C2&!C1&!C&!B2&B1&!B&A2&A1&!A|!D&!C2&!C1&!C&!B2&B1&B&A2&A1&!A|!D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|!D&!C2&!C1&!C&B2&!B1&B&A2&A1&!A|!D&!C2&!C1&!C&!B2&!B1&B&A2&A1&!A|!D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|!D&!C2&!C1&!C&B2&!B1&B&!A2&A1&!A|!D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|!D&!C2&!C1&!C&!B2&B1&B&!A2&A1&!A|!D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|!D&!C2&!C1&!C&B2&B1&!B&!A2&A1&!A|!D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|!D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D&C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!D&!C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|!D&C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|!D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|!D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|!D&C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!D&!C2&C1&C&!B2&!B1&!B&!A2&A1&A|!D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|!D&C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&A|!D&!C2&!C1&!C&B2&B1&!B&!A2&A1&A|!D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&A|!D&!C2&!C1&!C&!B2&B1&B&!A2&A1&A|!D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|!D&!C2&!C1&!C&B2&!B1&B&!A2&A1&A|!D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&A|!D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|!D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|!D&!C2&!C1&!C&B2&B1&B&A2&A1&A|!D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|!D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|!D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|!D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|!D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|!D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|!D&C2&C1&C&!B2&!B1&!B&A2&A1&A|!D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|!D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|!D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|!D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|!D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|!D&C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!D&!C2&C1&C&!B2&!B1&!B&A2&!A1&A|!D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|!D&C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&A|!D&!C2&!C1&!C&B2&B1&!B&A2&!A1&A|!D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&A|!D&!C2&!C1&!C&!B2&B1&B&A2&!A1&A|!D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|!D&!C2&!C1&!C&B2&!B1&B&A2&!A1&A|!D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&A|!D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|!D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&A|!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|!D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&A|!D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|!D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&A|!D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|!D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|!D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|!D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|!D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAOI3331.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAI23 -l OAI23 -i B2 B1 B A1 A -o Y -f Y=!(B2&B1&B&A1&!A|B2&B1&B&A1&A|B2&B1&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAI23.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOAI2222 -l OOAAOAI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=!(D1&D&C1&C&!B1&!B&!A1&!A|D1&D&C1&C&B1&!B&!A1&!A|D1&D&C1&C&B1&B&!A1&!A|D1&D&C1&C&!B1&B&!A1&!A|D1&D&!C1&!C&!B1&B&A1&!A|D1&D&C1&!C&!B1&B&A1&!A|D1&D&C1&C&!B1&B&A1&!A|D1&D&!C1&C&!B1&B&A1&!A|D1&D&!C1&C&B1&B&A1&!A|D1&D&C1&C&B1&B&A1&!A|D1&D&C1&!C&B1&B&A1&!A|D1&D&!C1&!C&B1&B&A1&!A|D1&D&!C1&!C&B1&!B&A1&!A|D1&D&C1&!C&B1&!B&A1&!A|D1&D&C1&C&B1&!B&A1&!A|D1&D&!C1&C&B1&!B&A1&!A|D1&D&C1&C&!B1&!B&A1&!A|D1&D&C1&C&!B1&!B&A1&A|D1&D&!C1&C&B1&!B&A1&A|D1&D&C1&C&B1&!B&A1&A|D1&D&C1&!C&B1&!B&A1&A|D1&D&!C1&!C&B1&!B&A1&A|D1&D&!C1&!C&B1&B&A1&A|D1&D&C1&!C&B1&B&A1&A|D1&D&C1&C&B1&B&A1&A|D1&D&!C1&C&B1&B&A1&A|D1&D&!C1&C&!B1&B&A1&A|D1&D&C1&C&!B1&B&A1&A|D1&D&C1&!C&!B1&B&A1&A|D1&D&!C1&!C&!B1&B&A1&A|D1&D&!C1&!C&!B1&B&!A1&A|D1&D&C1&!C&!B1&B&!A1&A|D1&D&C1&C&!B1&B&!A1&A|D1&D&!C1&C&!B1&B&!A1&A|D1&D&!C1&C&B1&B&!A1&A|D1&D&C1&C&B1&B&!A1&A|D1&D&C1&!C&B1&B&!A1&A|D1&D&!C1&!C&B1&B&!A1&A|D1&D&!C1&!C&B1&!B&!A1&A|D1&D&C1&!C&B1&!B&!A1&A|D1&D&C1&C&B1&!B&!A1&A|D1&D&!C1&C&B1&!B&!A1&A|D1&D&C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOAI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAI232 -l AOAI232 -i C1 C B2 B1 B A1 A -o Y -f Y=!(C1&C&B2&!B1&!B&!A1&!A|C1&C&B2&B1&!B&!A1&!A|C1&C&!B2&B1&!B&!A1&!A|C1&C&!B2&B1&B&!A1&!A|C1&C&B2&B1&B&!A1&!A|C1&C&B2&!B1&B&!A1&!A|C1&C&!B2&!B1&B&!A1&!A|C1&C&!B2&!B1&B&A1&!A|C1&C&B2&!B1&B&A1&!A|C1&C&B2&B1&B&A1&!A|C1&C&!B2&B1&B&A1&!A|C1&C&!B2&B1&!B&A1&!A|C1&C&B2&B1&!B&A1&!A|C1&C&B2&!B1&!B&A1&!A|C1&C&!B2&!B1&!B&A1&A|C1&C&B2&!B1&!B&A1&A|C1&C&B2&B1&!B&A1&A|C1&C&!B2&B1&!B&A1&A|C1&C&!B2&B1&B&A1&A|C1&C&B2&B1&B&A1&A|C1&C&B2&!B1&B&A1&A|C1&C&!B2&!B1&B&A1&A|C1&C&!B2&!B1&B&!A1&A|C1&C&B2&!B1&B&!A1&A|C1&C&B2&B1&B&!A1&A|C1&C&!B2&B1&B&!A1&A|C1&C&!B2&B1&!B&!A1&A|C1&C&B2&B1&!B&!A1&A|C1&C&B2&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAI232.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAAOI21222 -l AOAAAOI21222 -i E1 E D1 D C1 C B A1 A -o Y -f Y=(!E1&!E&!D1&!D&!C1&!C&!B&!A1&!A|E1&!E&!D1&!D&!C1&!C&!B&!A1&!A|!E1&E&!D1&!D&!C1&!C&!B&!A1&!A|!E1&E&D1&!D&!C1&!C&!B&!A1&!A|E1&!E&D1&!D&!C1&!C&!B&!A1&!A|!E1&!E&D1&!D&!C1&!C&!B&!A1&!A|!E1&E&!D1&D&!C1&!C&!B&!A1&!A|E1&!E&!D1&D&!C1&!C&!B&!A1&!A|!E1&!E&!D1&D&!C1&!C&!B&!A1&!A|!E1&!E&!D1&D&C1&!C&!B&!A1&!A|E1&!E&!D1&D&C1&!C&!B&!A1&!A|!E1&E&!D1&D&C1&!C&!B&!A1&!A|!E1&!E&D1&!D&C1&!C&!B&!A1&!A|E1&!E&D1&!D&C1&!C&!B&!A1&!A|!E1&E&D1&!D&C1&!C&!B&!A1&!A|!E1&E&!D1&!D&C1&!C&!B&!A1&!A|E1&!E&!D1&!D&C1&!C&!B&!A1&!A|!E1&!E&!D1&!D&C1&!C&!B&!A1&!A|!E1&!E&!D1&!D&C1&C&!B&!A1&!A|E1&!E&!D1&!D&C1&C&!B&!A1&!A|!E1&E&!D1&!D&C1&C&!B&!A1&!A|!E1&E&D1&!D&C1&C&!B&!A1&!A|E1&!E&D1&!D&C1&C&!B&!A1&!A|!E1&!E&D1&!D&C1&C&!B&!A1&!A|!E1&E&!D1&D&C1&C&!B&!A1&!A|E1&!E&!D1&D&C1&C&!B&!A1&!A|!E1&!E&!D1&D&C1&C&!B&!A1&!A|!E1&!E&!D1&D&!C1&C&!B&!A1&!A|E1&!E&!D1&D&!C1&C&!B&!A1&!A|!E1&E&!D1&D&!C1&C&!B&!A1&!A|!E1&!E&D1&!D&!C1&C&!B&!A1&!A|E1&!E&D1&!D&!C1&C&!B&!A1&!A|!E1&E&D1&!D&!C1&C&!B&!A1&!A|!E1&E&!D1&!D&!C1&C&!B&!A1&!A|E1&!E&!D1&!D&!C1&C&!B&!A1&!A|!E1&!E&!D1&!D&!C1&C&!B&!A1&!A|!E1&!E&!D1&!D&!C1&C&B&!A1&!A|E1&!E&!D1&!D&!C1&C&B&!A1&!A|!E1&E&!D1&!D&!C1&C&B&!A1&!A|!E1&E&D1&!D&!C1&C&B&!A1&!A|E1&!E&D1&!D&!C1&C&B&!A1&!A|!E1&!E&D1&!D&!C1&C&B&!A1&!A|!E1&E&!D1&D&!C1&C&B&!A1&!A|E1&!E&!D1&D&!C1&C&B&!A1&!A|!E1&!E&!D1&D&!C1&C&B&!A1&!A|!E1&!E&!D1&!D&C1&!C&B&!A1&!A|E1&!E&!D1&!D&C1&!C&B&!A1&!A|!E1&E&!D1&!D&C1&!C&B&!A1&!A|!E1&E&D1&!D&C1&!C&B&!A1&!A|E1&!E&D1&!D&C1&!C&B&!A1&!A|!E1&!E&D1&!D&C1&!C&B&!A1&!A|!E1&E&!D1&D&C1&!C&B&!A1&!A|E1&!E&!D1&D&C1&!C&B&!A1&!A|!E1&!E&!D1&D&C1&!C&B&!A1&!A|!E1&!E&!D1&D&!C1&!C&B&!A1&!A|E1&!E&!D1&D&!C1&!C&B&!A1&!A|!E1&E&!D1&D&!C1&!C&B&!A1&!A|!E1&!E&D1&!D&!C1&!C&B&!A1&!A|E1&!E&D1&!D&!C1&!C&B&!A1&!A|!E1&E&D1&!D&!C1&!C&B&!A1&!A|!E1&E&!D1&!D&!C1&!C&B&!A1&!A|E1&!E&!D1&!D&!C1&!C&B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&B&A1&!A|E1&!E&!D1&!D&!C1&!C&B&A1&!A|!E1&E&!D1&!D&!C1&!C&B&A1&!A|!E1&E&D1&!D&!C1&!C&B&A1&!A|E1&!E&D1&!D&!C1&!C&B&A1&!A|!E1&!E&D1&!D&!C1&!C&B&A1&!A|!E1&E&!D1&D&!C1&!C&B&A1&!A|E1&!E&!D1&D&!C1&!C&B&A1&!A|!E1&!E&!D1&D&!C1&!C&B&A1&!A|!E1&!E&!D1&D&C1&!C&B&A1&!A|E1&!E&!D1&D&C1&!C&B&A1&!A|!E1&E&!D1&D&C1&!C&B&A1&!A|!E1&!E&D1&!D&C1&!C&B&A1&!A|E1&!E&D1&!D&C1&!C&B&A1&!A|!E1&E&D1&!D&C1&!C&B&A1&!A|!E1&E&!D1&!D&C1&!C&B&A1&!A|E1&!E&!D1&!D&C1&!C&B&A1&!A|!E1&!E&!D1&!D&C1&!C&B&A1&!A|!E1&!E&!D1&D&!C1&C&B&A1&!A|E1&!E&!D1&D&!C1&C&B&A1&!A|!E1&E&!D1&D&!C1&C&B&A1&!A|!E1&!E&D1&!D&!C1&C&B&A1&!A|E1&!E&D1&!D&!C1&C&B&A1&!A|!E1&E&D1&!D&!C1&C&B&A1&!A|!E1&E&!D1&!D&!C1&C&B&A1&!A|E1&!E&!D1&!D&!C1&C&B&A1&!A|!E1&!E&!D1&!D&!C1&C&B&A1&!A|!E1&!E&!D1&!D&!C1&C&!B&A1&!A|E1&!E&!D1&!D&!C1&C&!B&A1&!A|!E1&E&!D1&!D&!C1&C&!B&A1&!A|!E1&E&D1&!D&!C1&C&!B&A1&!A|E1&!E&D1&!D&!C1&C&!B&A1&!A|!E1&!E&D1&!D&!C1&C&!B&A1&!A|!E1&E&!D1&D&!C1&C&!B&A1&!A|E1&!E&!D1&D&!C1&C&!B&A1&!A|!E1&!E&!D1&D&!C1&C&!B&A1&!A|!E1&!E&!D1&D&C1&C&!B&A1&!A|E1&!E&!D1&D&C1&C&!B&A1&!A|!E1&E&!D1&D&C1&C&!B&A1&!A|!E1&!E&D1&!D&C1&C&!B&A1&!A|E1&!E&D1&!D&C1&C&!B&A1&!A|!E1&E&D1&!D&C1&C&!B&A1&!A|!E1&E&!D1&!D&C1&C&!B&A1&!A|E1&!E&!D1&!D&C1&C&!B&A1&!A|!E1&!E&!D1&!D&C1&C&!B&A1&!A|!E1&!E&!D1&!D&C1&!C&!B&A1&!A|E1&!E&!D1&!D&C1&!C&!B&A1&!A|!E1&E&!D1&!D&C1&!C&!B&A1&!A|!E1&E&D1&!D&C1&!C&!B&A1&!A|E1&!E&D1&!D&C1&!C&!B&A1&!A|!E1&!E&D1&!D&C1&!C&!B&A1&!A|!E1&E&!D1&D&C1&!C&!B&A1&!A|E1&!E&!D1&D&C1&!C&!B&A1&!A|!E1&!E&!D1&D&C1&!C&!B&A1&!A|!E1&!E&!D1&D&!C1&!C&!B&A1&!A|E1&!E&!D1&D&!C1&!C&!B&A1&!A|!E1&E&!D1&D&!C1&!C&!B&A1&!A|!E1&!E&D1&!D&!C1&!C&!B&A1&!A|E1&!E&D1&!D&!C1&!C&!B&A1&!A|!E1&E&D1&!D&!C1&!C&!B&A1&!A|!E1&E&!D1&!D&!C1&!C&!B&A1&!A|E1&!E&!D1&!D&!C1&!C&!B&A1&!A|!E1&!E&!D1&!D&!C1&!C&!B&A1&!A|!E1&!E&!D1&!D&!C1&!C&!B&A1&A|E1&!E&!D1&!D&!C1&!C&!B&A1&A|!E1&E&!D1&!D&!C1&!C&!B&A1&A|!E1&E&D1&!D&!C1&!C&!B&A1&A|E1&!E&D1&!D&!C1&!C&!B&A1&A|!E1&!E&D1&!D&!C1&!C&!B&A1&A|!E1&E&!D1&D&!C1&!C&!B&A1&A|E1&!E&!D1&D&!C1&!C&!B&A1&A|!E1&!E&!D1&D&!C1&!C&!B&A1&A|!E1&!E&!D1&D&C1&!C&!B&A1&A|E1&!E&!D1&D&C1&!C&!B&A1&A|!E1&E&!D1&D&C1&!C&!B&A1&A|!E1&!E&D1&!D&C1&!C&!B&A1&A|E1&!E&D1&!D&C1&!C&!B&A1&A|!E1&E&D1&!D&C1&!C&!B&A1&A|!E1&E&!D1&!D&C1&!C&!B&A1&A|E1&!E&!D1&!D&C1&!C&!B&A1&A|!E1&!E&!D1&!D&C1&!C&!B&A1&A|!E1&!E&!D1&D&!C1&C&!B&A1&A|E1&!E&!D1&D&!C1&C&!B&A1&A|!E1&E&!D1&D&!C1&C&!B&A1&A|!E1&!E&D1&!D&!C1&C&!B&A1&A|E1&!E&D1&!D&!C1&C&!B&A1&A|!E1&E&D1&!D&!C1&C&!B&A1&A|!E1&E&!D1&!D&!C1&C&!B&A1&A|E1&!E&!D1&!D&!C1&C&!B&A1&A|!E1&!E&!D1&!D&!C1&C&!B&A1&A|!E1&!E&!D1&!D&!C1&C&B&A1&A|E1&!E&!D1&!D&!C1&C&B&A1&A|!E1&E&!D1&!D&!C1&C&B&A1&A|!E1&E&D1&!D&!C1&C&B&A1&A|E1&!E&D1&!D&!C1&C&B&A1&A|!E1&!E&D1&!D&!C1&C&B&A1&A|!E1&E&!D1&D&!C1&C&B&A1&A|E1&!E&!D1&D&!C1&C&B&A1&A|!E1&!E&!D1&D&!C1&C&B&A1&A|!E1&!E&!D1&!D&C1&!C&B&A1&A|E1&!E&!D1&!D&C1&!C&B&A1&A|!E1&E&!D1&!D&C1&!C&B&A1&A|!E1&E&D1&!D&C1&!C&B&A1&A|E1&!E&D1&!D&C1&!C&B&A1&A|!E1&!E&D1&!D&C1&!C&B&A1&A|!E1&E&!D1&D&C1&!C&B&A1&A|E1&!E&!D1&D&C1&!C&B&A1&A|!E1&!E&!D1&D&C1&!C&B&A1&A|!E1&!E&!D1&D&!C1&!C&B&A1&A|E1&!E&!D1&D&!C1&!C&B&A1&A|!E1&E&!D1&D&!C1&!C&B&A1&A|!E1&!E&D1&!D&!C1&!C&B&A1&A|E1&!E&D1&!D&!C1&!C&B&A1&A|!E1&E&D1&!D&!C1&!C&B&A1&A|!E1&E&!D1&!D&!C1&!C&B&A1&A|E1&!E&!D1&!D&!C1&!C&B&A1&A|!E1&!E&!D1&!D&!C1&!C&B&A1&A|!E1&!E&!D1&!D&!C1&!C&B&!A1&A|E1&!E&!D1&!D&!C1&!C&B&!A1&A|!E1&E&!D1&!D&!C1&!C&B&!A1&A|!E1&E&D1&!D&!C1&!C&B&!A1&A|E1&!E&D1&!D&!C1&!C&B&!A1&A|!E1&!E&D1&!D&!C1&!C&B&!A1&A|!E1&E&!D1&D&!C1&!C&B&!A1&A|E1&!E&!D1&D&!C1&!C&B&!A1&A|!E1&!E&!D1&D&!C1&!C&B&!A1&A|!E1&!E&!D1&D&C1&!C&B&!A1&A|E1&!E&!D1&D&C1&!C&B&!A1&A|!E1&E&!D1&D&C1&!C&B&!A1&A|!E1&!E&D1&!D&C1&!C&B&!A1&A|E1&!E&D1&!D&C1&!C&B&!A1&A|!E1&E&D1&!D&C1&!C&B&!A1&A|!E1&E&!D1&!D&C1&!C&B&!A1&A|E1&!E&!D1&!D&C1&!C&B&!A1&A|!E1&!E&!D1&!D&C1&!C&B&!A1&A|!E1&!E&!D1&D&!C1&C&B&!A1&A|E1&!E&!D1&D&!C1&C&B&!A1&A|!E1&E&!D1&D&!C1&C&B&!A1&A|!E1&!E&D1&!D&!C1&C&B&!A1&A|E1&!E&D1&!D&!C1&C&B&!A1&A|!E1&E&D1&!D&!C1&C&B&!A1&A|!E1&E&!D1&!D&!C1&C&B&!A1&A|E1&!E&!D1&!D&!C1&C&B&!A1&A|!E1&!E&!D1&!D&!C1&C&B&!A1&A|!E1&!E&!D1&!D&!C1&C&!B&!A1&A|E1&!E&!D1&!D&!C1&C&!B&!A1&A|!E1&E&!D1&!D&!C1&C&!B&!A1&A|!E1&E&D1&!D&!C1&C&!B&!A1&A|E1&!E&D1&!D&!C1&C&!B&!A1&A|!E1&!E&D1&!D&!C1&C&!B&!A1&A|!E1&E&!D1&D&!C1&C&!B&!A1&A|E1&!E&!D1&D&!C1&C&!B&!A1&A|!E1&!E&!D1&D&!C1&C&!B&!A1&A|!E1&!E&!D1&D&C1&C&!B&!A1&A|E1&!E&!D1&D&C1&C&!B&!A1&A|!E1&E&!D1&D&C1&C&!B&!A1&A|!E1&!E&D1&!D&C1&C&!B&!A1&A|E1&!E&D1&!D&C1&C&!B&!A1&A|!E1&E&D1&!D&C1&C&!B&!A1&A|!E1&E&!D1&!D&C1&C&!B&!A1&A|E1&!E&!D1&!D&C1&C&!B&!A1&A|!E1&!E&!D1&!D&C1&C&!B&!A1&A|!E1&!E&!D1&!D&C1&!C&!B&!A1&A|E1&!E&!D1&!D&C1&!C&!B&!A1&A|!E1&E&!D1&!D&C1&!C&!B&!A1&A|!E1&E&D1&!D&C1&!C&!B&!A1&A|E1&!E&D1&!D&C1&!C&!B&!A1&A|!E1&!E&D1&!D&C1&!C&!B&!A1&A|!E1&E&!D1&D&C1&!C&!B&!A1&A|E1&!E&!D1&D&C1&!C&!B&!A1&A|!E1&!E&!D1&D&C1&!C&!B&!A1&A|!E1&!E&!D1&D&!C1&!C&!B&!A1&A|E1&!E&!D1&D&!C1&!C&!B&!A1&A|!E1&E&!D1&D&!C1&!C&!B&!A1&A|!E1&!E&D1&!D&!C1&!C&!B&!A1&A|E1&!E&D1&!D&!C1&!C&!B&!A1&A|!E1&E&D1&!D&!C1&!C&!B&!A1&A|!E1&E&!D1&!D&!C1&!C&!B&!A1&A|E1&!E&!D1&!D&!C1&!C&!B&!A1&A|!E1&!E&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAAOI21222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAAOAI21221 -l OAAAOAI21221 -i E D1 D C1 C B A1 A -o Y -f Y=!(E&D1&D&!C1&!C&!B&!A1&!A|E&D1&D&C1&!C&!B&!A1&!A|E&!D1&!D&C1&C&!B&!A1&!A|E&D1&!D&C1&C&!B&!A1&!A|E&D1&D&C1&C&!B&!A1&!A|E&!D1&D&C1&C&!B&!A1&!A|E&D1&D&!C1&C&!B&!A1&!A|E&D1&D&!C1&C&B&!A1&!A|E&!D1&D&C1&C&B&!A1&!A|E&D1&D&C1&C&B&!A1&!A|E&D1&!D&C1&C&B&!A1&!A|E&!D1&!D&C1&C&B&!A1&!A|E&D1&D&C1&!C&B&!A1&!A|E&D1&D&!C1&!C&B&!A1&!A|E&!D1&!D&!C1&!C&B&A1&!A|E&D1&!D&!C1&!C&B&A1&!A|E&D1&D&!C1&!C&B&A1&!A|E&!D1&D&!C1&!C&B&A1&!A|E&!D1&D&C1&!C&B&A1&!A|E&D1&D&C1&!C&B&A1&!A|E&D1&!D&C1&!C&B&A1&!A|E&!D1&!D&C1&!C&B&A1&!A|E&!D1&!D&C1&C&B&A1&!A|E&D1&!D&C1&C&B&A1&!A|E&D1&D&C1&C&B&A1&!A|E&!D1&D&C1&C&B&A1&!A|E&!D1&D&!C1&C&B&A1&!A|E&D1&D&!C1&C&B&A1&!A|E&D1&!D&!C1&C&B&A1&!A|E&!D1&!D&!C1&C&B&A1&!A|E&D1&D&!C1&C&!B&A1&!A|E&!D1&D&C1&C&!B&A1&!A|E&D1&D&C1&C&!B&A1&!A|E&D1&!D&C1&C&!B&A1&!A|E&!D1&!D&C1&C&!B&A1&!A|E&D1&D&C1&!C&!B&A1&!A|E&D1&D&!C1&!C&!B&A1&!A|E&D1&D&!C1&!C&!B&A1&A|E&D1&D&C1&!C&!B&A1&A|E&!D1&!D&C1&C&!B&A1&A|E&D1&!D&C1&C&!B&A1&A|E&D1&D&C1&C&!B&A1&A|E&!D1&D&C1&C&!B&A1&A|E&D1&D&!C1&C&!B&A1&A|E&!D1&!D&!C1&C&B&A1&A|E&D1&!D&!C1&C&B&A1&A|E&D1&D&!C1&C&B&A1&A|E&!D1&D&!C1&C&B&A1&A|E&!D1&D&C1&C&B&A1&A|E&D1&D&C1&C&B&A1&A|E&D1&!D&C1&C&B&A1&A|E&!D1&!D&C1&C&B&A1&A|E&!D1&!D&C1&!C&B&A1&A|E&D1&!D&C1&!C&B&A1&A|E&D1&D&C1&!C&B&A1&A|E&!D1&D&C1&!C&B&A1&A|E&!D1&D&!C1&!C&B&A1&A|E&D1&D&!C1&!C&B&A1&A|E&D1&!D&!C1&!C&B&A1&A|E&!D1&!D&!C1&!C&B&A1&A|E&!D1&!D&!C1&!C&B&!A1&A|E&D1&!D&!C1&!C&B&!A1&A|E&D1&D&!C1&!C&B&!A1&A|E&!D1&D&!C1&!C&B&!A1&A|E&!D1&D&C1&!C&B&!A1&A|E&D1&D&C1&!C&B&!A1&A|E&D1&!D&C1&!C&B&!A1&A|E&!D1&!D&C1&!C&B&!A1&A|E&!D1&!D&C1&C&B&!A1&A|E&D1&!D&C1&C&B&!A1&A|E&D1&D&C1&C&B&!A1&A|E&!D1&D&C1&C&B&!A1&A|E&!D1&D&!C1&C&B&!A1&A|E&D1&D&!C1&C&B&!A1&A|E&D1&!D&!C1&C&B&!A1&A|E&!D1&!D&!C1&C&B&!A1&A|E&D1&D&!C1&C&!B&!A1&A|E&!D1&D&C1&C&!B&!A1&A|E&D1&D&C1&C&!B&!A1&A|E&D1&!D&C1&C&!B&!A1&A|E&!D1&!D&C1&C&!B&!A1&A|E&D1&D&C1&!C&!B&!A1&A|E&D1&D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAAOAI21221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOAI2131 -l OAAOAI2131 -i D C2 C1 C B A1 A -o Y -f Y=!(D&C2&C1&C&!B&!A1&!A|D&C2&C1&C&B&!A1&!A|D&!C2&!C1&!C&B&A1&!A|D&C2&!C1&!C&B&A1&!A|D&C2&C1&!C&B&A1&!A|D&!C2&C1&!C&B&A1&!A|D&!C2&C1&C&B&A1&!A|D&C2&C1&C&B&A1&!A|D&C2&!C1&C&B&A1&!A|D&!C2&!C1&C&B&A1&!A|D&C2&C1&C&!B&A1&!A|D&C2&C1&C&!B&A1&A|D&!C2&!C1&C&B&A1&A|D&C2&!C1&C&B&A1&A|D&C2&C1&C&B&A1&A|D&!C2&C1&C&B&A1&A|D&!C2&C1&!C&B&A1&A|D&C2&C1&!C&B&A1&A|D&C2&!C1&!C&B&A1&A|D&!C2&!C1&!C&B&A1&A|D&!C2&!C1&!C&B&!A1&A|D&C2&!C1&!C&B&!A1&A|D&C2&C1&!C&B&!A1&A|D&!C2&C1&!C&B&!A1&A|D&!C2&C1&C&B&!A1&A|D&C2&C1&C&B&!A1&A|D&C2&!C1&C&B&!A1&A|D&!C2&!C1&C&B&!A1&A|D&C2&C1&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOAI2131.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOI22121 -l OOAAOI22121 -i E D1 D C B1 B A1 A -o Y -f Y=(!E&!D1&!D&!C&!B1&!B&!A1&!A|!E&D1&!D&!C&!B1&!B&!A1&!A|!E&!D1&D&!C&!B1&!B&!A1&!A|!E&!D1&D&C&!B1&!B&!A1&!A|!E&D1&!D&C&!B1&!B&!A1&!A|!E&!D1&!D&C&!B1&!B&!A1&!A|!E&!D1&!D&C&B1&!B&!A1&!A|!E&D1&!D&C&B1&!B&!A1&!A|!E&!D1&D&C&B1&!B&!A1&!A|!E&!D1&D&!C&B1&!B&!A1&!A|!E&D1&!D&!C&B1&!B&!A1&!A|!E&!D1&!D&!C&B1&!B&!A1&!A|!E&!D1&!D&!C&B1&B&!A1&!A|!E&D1&!D&!C&B1&B&!A1&!A|!E&!D1&D&!C&B1&B&!A1&!A|!E&!D1&D&C&B1&B&!A1&!A|!E&D1&!D&C&B1&B&!A1&!A|!E&!D1&!D&C&B1&B&!A1&!A|!E&!D1&!D&C&!B1&B&!A1&!A|!E&D1&!D&C&!B1&B&!A1&!A|!E&!D1&D&C&!B1&B&!A1&!A|!E&!D1&D&!C&!B1&B&!A1&!A|!E&D1&!D&!C&!B1&B&!A1&!A|!E&!D1&!D&!C&!B1&B&!A1&!A|!E&!D1&!D&!C&!B1&B&A1&!A|!E&D1&!D&!C&!B1&B&A1&!A|!E&!D1&D&!C&!B1&B&A1&!A|!E&!D1&D&!C&B1&B&A1&!A|!E&D1&!D&!C&B1&B&A1&!A|!E&!D1&!D&!C&B1&B&A1&!A|!E&!D1&!D&!C&B1&!B&A1&!A|!E&D1&!D&!C&B1&!B&A1&!A|!E&!D1&D&!C&B1&!B&A1&!A|!E&!D1&!D&C&!B1&!B&A1&!A|!E&D1&!D&C&!B1&!B&A1&!A|!E&!D1&D&C&!B1&!B&A1&!A|!E&!D1&D&!C&!B1&!B&A1&!A|!E&D1&!D&!C&!B1&!B&A1&!A|!E&!D1&!D&!C&!B1&!B&A1&!A|!E&!D1&!D&!C&!B1&!B&A1&A|!E&D1&!D&!C&!B1&!B&A1&A|!E&!D1&D&!C&!B1&!B&A1&A|!E&!D1&D&C&!B1&!B&A1&A|!E&D1&!D&C&!B1&!B&A1&A|!E&!D1&!D&C&!B1&!B&A1&A|!E&!D1&D&!C&B1&!B&A1&A|!E&D1&!D&!C&B1&!B&A1&A|!E&!D1&!D&!C&B1&!B&A1&A|!E&!D1&!D&!C&B1&B&A1&A|!E&D1&!D&!C&B1&B&A1&A|!E&!D1&D&!C&B1&B&A1&A|!E&!D1&D&!C&!B1&B&A1&A|!E&D1&!D&!C&!B1&B&A1&A|!E&!D1&!D&!C&!B1&B&A1&A|!E&!D1&!D&!C&!B1&B&!A1&A|!E&D1&!D&!C&!B1&B&!A1&A|!E&!D1&D&!C&!B1&B&!A1&A|!E&!D1&D&!C&B1&B&!A1&A|!E&D1&!D&!C&B1&B&!A1&A|!E&!D1&!D&!C&B1&B&!A1&A|!E&!D1&!D&!C&B1&!B&!A1&A|!E&D1&!D&!C&B1&!B&!A1&A|!E&!D1&D&!C&B1&!B&!A1&A|!E&!D1&!D&C&!B1&!B&!A1&A|!E&D1&!D&C&!B1&!B&!A1&A|!E&!D1&D&C&!B1&!B&!A1&A|!E&!D1&D&!C&!B1&!B&!A1&A|!E&D1&!D&!C&!B1&!B&!A1&A|!E&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOI22121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAI422 -l OOOAI422 -i C1 C B1 B A3 A2 A1 A -o Y -f Y=(!C1&!C&!B1&!B&!A3&!A2&!A1&!A|C1&!C&!B1&!B&!A3&!A2&!A1&!A|C1&C&!B1&!B&!A3&!A2&!A1&!A|!C1&C&!B1&!B&!A3&!A2&!A1&!A|!C1&C&B1&!B&!A3&!A2&!A1&!A|C1&C&B1&!B&!A3&!A2&!A1&!A|C1&!C&B1&!B&!A3&!A2&!A1&!A|!C1&!C&B1&!B&!A3&!A2&!A1&!A|!C1&!C&B1&B&!A3&!A2&!A1&!A|C1&!C&B1&B&!A3&!A2&!A1&!A|C1&C&B1&B&!A3&!A2&!A1&!A|!C1&C&B1&B&!A3&!A2&!A1&!A|!C1&C&!B1&B&!A3&!A2&!A1&!A|C1&C&!B1&B&!A3&!A2&!A1&!A|C1&!C&!B1&B&!A3&!A2&!A1&!A|!C1&!C&!B1&B&!A3&!A2&!A1&!A|!C1&!C&!B1&B&A3&!A2&!A1&!A|!C1&!C&B1&B&A3&!A2&!A1&!A|!C1&!C&B1&!B&A3&!A2&!A1&!A|!C1&C&!B1&!B&A3&!A2&!A1&!A|C1&C&!B1&!B&A3&!A2&!A1&!A|C1&!C&!B1&!B&A3&!A2&!A1&!A|!C1&!C&!B1&!B&A3&!A2&!A1&!A|!C1&!C&!B1&!B&A3&A2&!A1&!A|C1&!C&!B1&!B&A3&A2&!A1&!A|C1&C&!B1&!B&A3&A2&!A1&!A|!C1&C&!B1&!B&A3&A2&!A1&!A|!C1&!C&B1&!B&A3&A2&!A1&!A|!C1&!C&B1&B&A3&A2&!A1&!A|!C1&!C&!B1&B&A3&A2&!A1&!A|!C1&!C&!B1&B&!A3&A2&!A1&!A|!C1&!C&B1&B&!A3&A2&!A1&!A|!C1&!C&B1&!B&!A3&A2&!A1&!A|!C1&C&!B1&!B&!A3&A2&!A1&!A|C1&C&!B1&!B&!A3&A2&!A1&!A|C1&!C&!B1&!B&!A3&A2&!A1&!A|!C1&!C&!B1&!B&!A3&A2&!A1&!A|!C1&!C&!B1&!B&!A3&A2&A1&!A|C1&!C&!B1&!B&!A3&A2&A1&!A|C1&C&!B1&!B&!A3&A2&A1&!A|!C1&C&!B1&!B&!A3&A2&A1&!A|!C1&!C&B1&!B&!A3&A2&A1&!A|!C1&!C&B1&B&!A3&A2&A1&!A|!C1&!C&!B1&B&!A3&A2&A1&!A|!C1&!C&!B1&B&A3&A2&A1&!A|!C1&!C&B1&B&A3&A2&A1&!A|!C1&!C&B1&!B&A3&A2&A1&!A|!C1&C&!B1&!B&A3&A2&A1&!A|C1&C&!B1&!B&A3&A2&A1&!A|C1&!C&!B1&!B&A3&A2&A1&!A|!C1&!C&!B1&!B&A3&A2&A1&!A|!C1&!C&!B1&!B&A3&!A2&A1&!A|C1&!C&!B1&!B&A3&!A2&A1&!A|C1&C&!B1&!B&A3&!A2&A1&!A|!C1&C&!B1&!B&A3&!A2&A1&!A|!C1&!C&B1&!B&A3&!A2&A1&!A|!C1&!C&B1&B&A3&!A2&A1&!A|!C1&!C&!B1&B&A3&!A2&A1&!A|!C1&!C&!B1&B&!A3&!A2&A1&!A|!C1&!C&B1&B&!A3&!A2&A1&!A|!C1&!C&B1&!B&!A3&!A2&A1&!A|!C1&C&!B1&!B&!A3&!A2&A1&!A|C1&C&!B1&!B&!A3&!A2&A1&!A|C1&!C&!B1&!B&!A3&!A2&A1&!A|!C1&!C&!B1&!B&!A3&!A2&A1&!A|!C1&!C&!B1&!B&!A3&!A2&A1&A|C1&!C&!B1&!B&!A3&!A2&A1&A|C1&C&!B1&!B&!A3&!A2&A1&A|!C1&C&!B1&!B&!A3&!A2&A1&A|!C1&!C&B1&!B&!A3&!A2&A1&A|!C1&!C&B1&B&!A3&!A2&A1&A|!C1&!C&!B1&B&!A3&!A2&A1&A|!C1&!C&!B1&B&A3&!A2&A1&A|!C1&!C&B1&B&A3&!A2&A1&A|!C1&!C&B1&!B&A3&!A2&A1&A|!C1&C&!B1&!B&A3&!A2&A1&A|C1&C&!B1&!B&A3&!A2&A1&A|C1&!C&!B1&!B&A3&!A2&A1&A|!C1&!C&!B1&!B&A3&!A2&A1&A|!C1&!C&!B1&!B&A3&A2&A1&A|C1&!C&!B1&!B&A3&A2&A1&A|C1&C&!B1&!B&A3&A2&A1&A|!C1&C&!B1&!B&A3&A2&A1&A|!C1&!C&B1&!B&A3&A2&A1&A|!C1&!C&B1&B&A3&A2&A1&A|!C1&!C&!B1&B&A3&A2&A1&A|!C1&!C&!B1&B&!A3&A2&A1&A|!C1&!C&B1&B&!A3&A2&A1&A|!C1&!C&B1&!B&!A3&A2&A1&A|!C1&C&!B1&!B&!A3&A2&A1&A|C1&C&!B1&!B&!A3&A2&A1&A|C1&!C&!B1&!B&!A3&A2&A1&A|!C1&!C&!B1&!B&!A3&A2&A1&A|!C1&!C&!B1&!B&!A3&A2&!A1&A|C1&!C&!B1&!B&!A3&A2&!A1&A|C1&C&!B1&!B&!A3&A2&!A1&A|!C1&C&!B1&!B&!A3&A2&!A1&A|!C1&!C&B1&!B&!A3&A2&!A1&A|!C1&!C&B1&B&!A3&A2&!A1&A|!C1&!C&!B1&B&!A3&A2&!A1&A|!C1&!C&!B1&B&A3&A2&!A1&A|!C1&!C&B1&B&A3&A2&!A1&A|!C1&!C&B1&!B&A3&A2&!A1&A|!C1&C&!B1&!B&A3&A2&!A1&A|C1&C&!B1&!B&A3&A2&!A1&A|C1&!C&!B1&!B&A3&A2&!A1&A|!C1&!C&!B1&!B&A3&A2&!A1&A|!C1&!C&!B1&!B&A3&!A2&!A1&A|C1&!C&!B1&!B&A3&!A2&!A1&A|C1&C&!B1&!B&A3&!A2&!A1&A|!C1&C&!B1&!B&A3&!A2&!A1&A|!C1&!C&B1&!B&A3&!A2&!A1&A|!C1&!C&B1&B&A3&!A2&!A1&A|!C1&!C&!B1&B&A3&!A2&!A1&A|!C1&!C&!B1&B&!A3&!A2&!A1&A|!C1&!C&B1&B&!A3&!A2&!A1&A|!C1&!C&B1&!B&!A3&!A2&!A1&A|!C1&C&!B1&!B&!A3&!A2&!A1&A|C1&C&!B1&!B&!A3&!A2&!A1&A|C1&!C&!B1&!B&!A3&!A2&!A1&A|!C1&!C&!B1&!B&!A3&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAI422.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAI332 -l AOOAI332 -i C1 C B2 B1 B A2 A1 A -o Y -f Y=(!C1&!C&!B2&!B1&!B&!A2&!A1&!A|C1&!C&!B2&!B1&!B&!A2&!A1&!A|C1&C&!B2&!B1&!B&!A2&!A1&!A|!C1&C&!B2&!B1&!B&!A2&!A1&!A|!C1&!C&B2&!B1&!B&!A2&!A1&!A|!C1&!C&B2&B1&!B&!A2&!A1&!A|!C1&!C&!B2&B1&!B&!A2&!A1&!A|!C1&!C&!B2&B1&B&!A2&!A1&!A|!C1&!C&B2&B1&B&!A2&!A1&!A|!C1&!C&B2&!B1&B&!A2&!A1&!A|!C1&!C&!B2&!B1&B&!A2&!A1&!A|!C1&!C&!B2&!B1&B&A2&!A1&!A|!C1&!C&B2&!B1&B&A2&!A1&!A|!C1&!C&B2&B1&B&A2&!A1&!A|!C1&!C&!B2&B1&B&A2&!A1&!A|!C1&!C&!B2&B1&!B&A2&!A1&!A|!C1&!C&B2&B1&!B&A2&!A1&!A|!C1&!C&B2&!B1&!B&A2&!A1&!A|!C1&C&!B2&!B1&!B&A2&!A1&!A|C1&C&!B2&!B1&!B&A2&!A1&!A|C1&!C&!B2&!B1&!B&A2&!A1&!A|!C1&!C&!B2&!B1&!B&A2&!A1&!A|!C1&!C&!B2&!B1&!B&A2&A1&!A|C1&!C&!B2&!B1&!B&A2&A1&!A|C1&C&!B2&!B1&!B&A2&A1&!A|!C1&C&!B2&!B1&!B&A2&A1&!A|!C1&!C&B2&!B1&!B&A2&A1&!A|!C1&!C&B2&B1&!B&A2&A1&!A|!C1&!C&!B2&B1&!B&A2&A1&!A|!C1&!C&!B2&B1&B&A2&A1&!A|!C1&!C&B2&B1&B&A2&A1&!A|!C1&!C&B2&!B1&B&A2&A1&!A|!C1&!C&!B2&!B1&B&A2&A1&!A|!C1&!C&!B2&!B1&B&!A2&A1&!A|!C1&!C&B2&!B1&B&!A2&A1&!A|!C1&!C&B2&B1&B&!A2&A1&!A|!C1&!C&!B2&B1&B&!A2&A1&!A|!C1&!C&!B2&B1&!B&!A2&A1&!A|!C1&!C&B2&B1&!B&!A2&A1&!A|!C1&!C&B2&!B1&!B&!A2&A1&!A|!C1&C&!B2&!B1&!B&!A2&A1&!A|C1&C&!B2&!B1&!B&!A2&A1&!A|C1&!C&!B2&!B1&!B&!A2&A1&!A|!C1&!C&!B2&!B1&!B&!A2&A1&!A|!C1&!C&!B2&!B1&!B&!A2&A1&A|C1&!C&!B2&!B1&!B&!A2&A1&A|C1&C&!B2&!B1&!B&!A2&A1&A|!C1&C&!B2&!B1&!B&!A2&A1&A|!C1&!C&B2&!B1&!B&!A2&A1&A|!C1&!C&B2&B1&!B&!A2&A1&A|!C1&!C&!B2&B1&!B&!A2&A1&A|!C1&!C&!B2&B1&B&!A2&A1&A|!C1&!C&B2&B1&B&!A2&A1&A|!C1&!C&B2&!B1&B&!A2&A1&A|!C1&!C&!B2&!B1&B&!A2&A1&A|!C1&!C&!B2&!B1&B&A2&A1&A|!C1&!C&B2&!B1&B&A2&A1&A|!C1&!C&B2&B1&B&A2&A1&A|!C1&!C&!B2&B1&B&A2&A1&A|!C1&!C&!B2&B1&!B&A2&A1&A|!C1&!C&B2&B1&!B&A2&A1&A|!C1&!C&B2&!B1&!B&A2&A1&A|!C1&!C&!B2&!B1&!B&A2&A1&A|!C1&!C&!B2&!B1&!B&A2&!A1&A|C1&!C&!B2&!B1&!B&A2&!A1&A|C1&C&!B2&!B1&!B&A2&!A1&A|!C1&C&!B2&!B1&!B&A2&!A1&A|!C1&!C&B2&!B1&!B&A2&!A1&A|!C1&!C&B2&B1&!B&A2&!A1&A|!C1&!C&!B2&B1&!B&A2&!A1&A|!C1&!C&!B2&B1&B&A2&!A1&A|!C1&!C&B2&B1&B&A2&!A1&A|!C1&!C&B2&!B1&B&A2&!A1&A|!C1&!C&!B2&!B1&B&A2&!A1&A|!C1&!C&!B2&!B1&B&!A2&!A1&A|!C1&!C&B2&!B1&B&!A2&!A1&A|!C1&!C&B2&B1&B&!A2&!A1&A|!C1&!C&!B2&B1&B&!A2&!A1&A|!C1&!C&!B2&B1&!B&!A2&!A1&A|!C1&!C&B2&B1&!B&!A2&!A1&A|!C1&!C&B2&!B1&!B&!A2&!A1&A|!C1&C&!B2&!B1&!B&!A2&!A1&A|C1&C&!B2&!B1&!B&!A2&!A1&A|C1&!C&!B2&!B1&!B&!A2&!A1&A|!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAI332.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n MARTIN1989 -l MARTIN1989 -i A B -o C -f C=!(!A&!B) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist MARTIN1989.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOAAOI22112 -l OOAOAAOI22112 -i E1 E D C B1 B A1 A -o Y -f Y=(!E1&!E&!D&!C&!B1&!B&!A1&!A|E1&!E&!D&!C&!B1&!B&!A1&!A|!E1&E&!D&!C&!B1&!B&!A1&!A|!E1&E&D&!C&!B1&!B&!A1&!A|E1&!E&D&!C&!B1&!B&!A1&!A|!E1&!E&D&!C&!B1&!B&!A1&!A|!E1&E&!D&C&!B1&!B&!A1&!A|E1&!E&!D&C&!B1&!B&!A1&!A|!E1&!E&!D&C&!B1&!B&!A1&!A|!E1&!E&!D&C&B1&!B&!A1&!A|E1&!E&!D&C&B1&!B&!A1&!A|!E1&E&!D&C&B1&!B&!A1&!A|!E1&!E&D&!C&B1&!B&!A1&!A|E1&!E&D&!C&B1&!B&!A1&!A|!E1&E&D&!C&B1&!B&!A1&!A|!E1&E&!D&!C&B1&!B&!A1&!A|E1&!E&!D&!C&B1&!B&!A1&!A|!E1&!E&!D&!C&B1&!B&!A1&!A|!E1&!E&!D&!C&B1&B&!A1&!A|E1&!E&!D&!C&B1&B&!A1&!A|!E1&E&!D&!C&B1&B&!A1&!A|!E1&E&D&!C&B1&B&!A1&!A|E1&!E&D&!C&B1&B&!A1&!A|!E1&!E&D&!C&B1&B&!A1&!A|!E1&E&!D&C&B1&B&!A1&!A|E1&!E&!D&C&B1&B&!A1&!A|!E1&!E&!D&C&B1&B&!A1&!A|!E1&!E&!D&C&!B1&B&!A1&!A|E1&!E&!D&C&!B1&B&!A1&!A|!E1&E&!D&C&!B1&B&!A1&!A|!E1&!E&D&!C&!B1&B&!A1&!A|E1&!E&D&!C&!B1&B&!A1&!A|!E1&E&D&!C&!B1&B&!A1&!A|!E1&E&!D&!C&!B1&B&!A1&!A|E1&!E&!D&!C&!B1&B&!A1&!A|!E1&!E&!D&!C&!B1&B&!A1&!A|!E1&!E&!D&!C&!B1&B&A1&!A|E1&!E&!D&!C&!B1&B&A1&!A|!E1&E&!D&!C&!B1&B&A1&!A|!E1&E&!D&C&!B1&B&A1&!A|E1&!E&!D&C&!B1&B&A1&!A|!E1&!E&!D&C&!B1&B&A1&!A|!E1&!E&!D&C&B1&B&A1&!A|E1&!E&!D&C&B1&B&A1&!A|!E1&E&!D&C&B1&B&A1&!A|!E1&E&!D&!C&B1&B&A1&!A|E1&!E&!D&!C&B1&B&A1&!A|!E1&!E&!D&!C&B1&B&A1&!A|!E1&!E&!D&!C&B1&!B&A1&!A|E1&!E&!D&!C&B1&!B&A1&!A|!E1&E&!D&!C&B1&!B&A1&!A|!E1&E&!D&C&B1&!B&A1&!A|E1&!E&!D&C&B1&!B&A1&!A|!E1&!E&!D&C&B1&!B&A1&!A|!E1&!E&!D&C&!B1&!B&A1&!A|E1&!E&!D&C&!B1&!B&A1&!A|!E1&E&!D&C&!B1&!B&A1&!A|!E1&!E&D&!C&!B1&!B&A1&!A|E1&!E&D&!C&!B1&!B&A1&!A|!E1&E&D&!C&!B1&!B&A1&!A|!E1&E&!D&!C&!B1&!B&A1&!A|E1&!E&!D&!C&!B1&!B&A1&!A|!E1&!E&!D&!C&!B1&!B&A1&!A|!E1&!E&!D&!C&!B1&!B&A1&A|E1&!E&!D&!C&!B1&!B&A1&A|!E1&E&!D&!C&!B1&!B&A1&A|!E1&E&D&!C&!B1&!B&A1&A|E1&!E&D&!C&!B1&!B&A1&A|!E1&!E&D&!C&!B1&!B&A1&A|!E1&E&!D&C&!B1&!B&A1&A|E1&!E&!D&C&!B1&!B&A1&A|!E1&!E&!D&C&!B1&!B&A1&A|!E1&!E&!D&C&B1&!B&A1&A|E1&!E&!D&C&B1&!B&A1&A|!E1&E&!D&C&B1&!B&A1&A|!E1&E&!D&!C&B1&!B&A1&A|E1&!E&!D&!C&B1&!B&A1&A|!E1&!E&!D&!C&B1&!B&A1&A|!E1&!E&!D&!C&B1&B&A1&A|E1&!E&!D&!C&B1&B&A1&A|!E1&E&!D&!C&B1&B&A1&A|!E1&E&!D&C&B1&B&A1&A|E1&!E&!D&C&B1&B&A1&A|!E1&!E&!D&C&B1&B&A1&A|!E1&!E&!D&C&!B1&B&A1&A|E1&!E&!D&C&!B1&B&A1&A|!E1&E&!D&C&!B1&B&A1&A|!E1&E&!D&!C&!B1&B&A1&A|E1&!E&!D&!C&!B1&B&A1&A|!E1&!E&!D&!C&!B1&B&A1&A|!E1&!E&!D&!C&!B1&B&!A1&A|E1&!E&!D&!C&!B1&B&!A1&A|!E1&E&!D&!C&!B1&B&!A1&A|!E1&E&!D&C&!B1&B&!A1&A|E1&!E&!D&C&!B1&B&!A1&A|!E1&!E&!D&C&!B1&B&!A1&A|!E1&!E&!D&C&B1&B&!A1&A|E1&!E&!D&C&B1&B&!A1&A|!E1&E&!D&C&B1&B&!A1&A|!E1&E&!D&!C&B1&B&!A1&A|E1&!E&!D&!C&B1&B&!A1&A|!E1&!E&!D&!C&B1&B&!A1&A|!E1&!E&!D&!C&B1&!B&!A1&A|E1&!E&!D&!C&B1&!B&!A1&A|!E1&E&!D&!C&B1&!B&!A1&A|!E1&E&!D&C&B1&!B&!A1&A|E1&!E&!D&C&B1&!B&!A1&A|!E1&!E&!D&C&B1&!B&!A1&A|!E1&!E&!D&C&!B1&!B&!A1&A|E1&!E&!D&C&!B1&!B&!A1&A|!E1&E&!D&C&!B1&!B&!A1&A|!E1&!E&D&!C&!B1&!B&!A1&A|E1&!E&D&!C&!B1&!B&!A1&A|!E1&E&D&!C&!B1&!B&!A1&A|!E1&E&!D&!C&!B1&!B&!A1&A|E1&!E&!D&!C&!B1&!B&!A1&A|!E1&!E&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOAAOI22112.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOI221 -l OOAOI221 -i C B1 B A1 A -o Y -f Y=(!C&!B1&!B&!A1&!A|!C&B1&!B&!A1&!A|!C&B1&B&!A1&!A|!C&!B1&B&!A1&!A|!C&!B1&!B&A1&!A|!C&!B1&!B&A1&A|!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOI221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOAI22211 -l OAAOAI22211 -i E D C1 C B1 B A1 A -o Y -f Y=!(E&D&!C1&!C&!B1&!B&!A1&!A|E&D&C1&!C&!B1&!B&!A1&!A|E&!D&C1&C&!B1&!B&!A1&!A|E&D&C1&C&!B1&!B&!A1&!A|E&D&!C1&C&!B1&!B&!A1&!A|E&D&!C1&C&B1&!B&!A1&!A|E&D&C1&C&B1&!B&!A1&!A|E&!D&C1&C&B1&!B&!A1&!A|E&D&C1&!C&B1&!B&!A1&!A|E&D&!C1&!C&B1&!B&!A1&!A|E&D&!C1&!C&B1&B&!A1&!A|E&D&C1&!C&B1&B&!A1&!A|E&!D&C1&C&B1&B&!A1&!A|E&D&C1&C&B1&B&!A1&!A|E&D&!C1&C&B1&B&!A1&!A|E&D&!C1&C&!B1&B&!A1&!A|E&D&C1&C&!B1&B&!A1&!A|E&!D&C1&C&!B1&B&!A1&!A|E&D&C1&!C&!B1&B&!A1&!A|E&D&!C1&!C&!B1&B&!A1&!A|E&D&!C1&!C&!B1&B&A1&!A|E&D&C1&!C&!B1&B&A1&!A|E&!D&C1&C&!B1&B&A1&!A|E&D&C1&C&!B1&B&A1&!A|E&D&!C1&C&!B1&B&A1&!A|E&!D&!C1&C&B1&B&A1&!A|E&D&!C1&C&B1&B&A1&!A|E&D&C1&C&B1&B&A1&!A|E&!D&C1&C&B1&B&A1&!A|E&!D&C1&!C&B1&B&A1&!A|E&D&C1&!C&B1&B&A1&!A|E&D&!C1&!C&B1&B&A1&!A|E&!D&!C1&!C&B1&B&A1&!A|E&D&!C1&!C&B1&!B&A1&!A|E&D&C1&!C&B1&!B&A1&!A|E&!D&C1&C&B1&!B&A1&!A|E&D&C1&C&B1&!B&A1&!A|E&D&!C1&C&B1&!B&A1&!A|E&D&!C1&C&!B1&!B&A1&!A|E&D&C1&C&!B1&!B&A1&!A|E&!D&C1&C&!B1&!B&A1&!A|E&D&C1&!C&!B1&!B&A1&!A|E&D&!C1&!C&!B1&!B&A1&!A|E&D&!C1&!C&!B1&!B&A1&A|E&D&C1&!C&!B1&!B&A1&A|E&!D&C1&C&!B1&!B&A1&A|E&D&C1&C&!B1&!B&A1&A|E&D&!C1&C&!B1&!B&A1&A|E&D&!C1&C&B1&!B&A1&A|E&D&C1&C&B1&!B&A1&A|E&!D&C1&C&B1&!B&A1&A|E&D&C1&!C&B1&!B&A1&A|E&D&!C1&!C&B1&!B&A1&A|E&!D&!C1&!C&B1&B&A1&A|E&D&!C1&!C&B1&B&A1&A|E&D&C1&!C&B1&B&A1&A|E&!D&C1&!C&B1&B&A1&A|E&!D&C1&C&B1&B&A1&A|E&D&C1&C&B1&B&A1&A|E&D&!C1&C&B1&B&A1&A|E&!D&!C1&C&B1&B&A1&A|E&D&!C1&C&!B1&B&A1&A|E&D&C1&C&!B1&B&A1&A|E&!D&C1&C&!B1&B&A1&A|E&D&C1&!C&!B1&B&A1&A|E&D&!C1&!C&!B1&B&A1&A|E&D&!C1&!C&!B1&B&!A1&A|E&D&C1&!C&!B1&B&!A1&A|E&!D&C1&C&!B1&B&!A1&A|E&D&C1&C&!B1&B&!A1&A|E&D&!C1&C&!B1&B&!A1&A|E&!D&!C1&C&B1&B&!A1&A|E&D&!C1&C&B1&B&!A1&A|E&D&C1&C&B1&B&!A1&A|E&!D&C1&C&B1&B&!A1&A|E&!D&C1&!C&B1&B&!A1&A|E&D&C1&!C&B1&B&!A1&A|E&D&!C1&!C&B1&B&!A1&A|E&!D&!C1&!C&B1&B&!A1&A|E&D&!C1&!C&B1&!B&!A1&A|E&D&C1&!C&B1&!B&!A1&A|E&!D&C1&C&B1&!B&!A1&A|E&D&C1&C&B1&!B&!A1&A|E&D&!C1&C&B1&!B&!A1&A|E&D&!C1&C&!B1&!B&!A1&A|E&D&C1&C&!B1&!B&!A1&A|E&!D&C1&C&!B1&!B&!A1&A|E&D&C1&!C&!B1&!B&!A1&A|E&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOAI22211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOAI2222 -l OOAOAI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=!(D1&D&C1&!C&!B1&!B&!A1&!A|D1&D&C1&C&!B1&!B&!A1&!A|D1&D&!C1&C&!B1&!B&!A1&!A|D1&D&!C1&C&B1&!B&!A1&!A|D1&D&C1&C&B1&!B&!A1&!A|D1&D&C1&!C&B1&!B&!A1&!A|D1&D&C1&!C&B1&B&!A1&!A|D1&D&C1&C&B1&B&!A1&!A|D1&D&!C1&C&B1&B&!A1&!A|D1&D&!C1&C&!B1&B&!A1&!A|D1&D&C1&C&!B1&B&!A1&!A|D1&D&C1&!C&!B1&B&!A1&!A|D1&D&!C1&!C&!B1&B&A1&!A|D1&D&C1&!C&!B1&B&A1&!A|D1&D&C1&C&!B1&B&A1&!A|D1&D&!C1&C&!B1&B&A1&!A|D1&D&!C1&C&B1&B&A1&!A|D1&D&C1&C&B1&B&A1&!A|D1&D&C1&!C&B1&B&A1&!A|D1&D&!C1&!C&B1&B&A1&!A|D1&D&!C1&!C&B1&!B&A1&!A|D1&D&C1&!C&B1&!B&A1&!A|D1&D&C1&C&B1&!B&A1&!A|D1&D&!C1&C&B1&!B&A1&!A|D1&D&!C1&C&!B1&!B&A1&!A|D1&D&C1&C&!B1&!B&A1&!A|D1&D&C1&!C&!B1&!B&A1&!A|D1&D&C1&!C&!B1&!B&A1&A|D1&D&C1&C&!B1&!B&A1&A|D1&D&!C1&C&!B1&!B&A1&A|D1&D&!C1&C&B1&!B&A1&A|D1&D&C1&C&B1&!B&A1&A|D1&D&C1&!C&B1&!B&A1&A|D1&D&!C1&!C&B1&!B&A1&A|D1&D&!C1&!C&B1&B&A1&A|D1&D&C1&!C&B1&B&A1&A|D1&D&C1&C&B1&B&A1&A|D1&D&!C1&C&B1&B&A1&A|D1&D&!C1&C&!B1&B&A1&A|D1&D&C1&C&!B1&B&A1&A|D1&D&C1&!C&!B1&B&A1&A|D1&D&!C1&!C&!B1&B&A1&A|D1&D&!C1&!C&!B1&B&!A1&A|D1&D&C1&!C&!B1&B&!A1&A|D1&D&C1&C&!B1&B&!A1&A|D1&D&!C1&C&!B1&B&!A1&A|D1&D&!C1&C&B1&B&!A1&A|D1&D&C1&C&B1&B&!A1&A|D1&D&C1&!C&B1&B&!A1&A|D1&D&!C1&!C&B1&B&!A1&A|D1&D&!C1&!C&B1&!B&!A1&A|D1&D&C1&!C&B1&!B&!A1&A|D1&D&C1&C&B1&!B&!A1&A|D1&D&!C1&C&B1&!B&!A1&A|D1&D&!C1&C&!B1&!B&!A1&A|D1&D&C1&C&!B1&!B&!A1&A|D1&D&C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOAI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAI21141 -l OAOOAI21141 -i E D3 D2 D1 D C B A1 A -o Y -f Y=!(E&!D3&!D2&!D1&D&C&!B&!A1&!A|E&D3&!D2&!D1&D&C&!B&!A1&!A|E&D3&D2&!D1&D&C&!B&!A1&!A|E&!D3&D2&!D1&D&C&!B&!A1&!A|E&!D3&D2&D1&D&C&!B&!A1&!A|E&D3&D2&D1&D&C&!B&!A1&!A|E&D3&!D2&D1&D&C&!B&!A1&!A|E&!D3&!D2&D1&D&C&!B&!A1&!A|E&!D3&!D2&D1&!D&C&!B&!A1&!A|E&D3&!D2&D1&!D&C&!B&!A1&!A|E&D3&D2&D1&!D&C&!B&!A1&!A|E&!D3&D2&D1&!D&C&!B&!A1&!A|E&!D3&D2&!D1&!D&C&!B&!A1&!A|E&D3&D2&!D1&!D&C&!B&!A1&!A|E&D3&!D2&!D1&!D&C&!B&!A1&!A|E&D3&!D2&!D1&!D&C&B&!A1&!A|E&D3&D2&!D1&!D&C&B&!A1&!A|E&!D3&D2&!D1&!D&C&B&!A1&!A|E&!D3&D2&D1&!D&C&B&!A1&!A|E&D3&D2&D1&!D&C&B&!A1&!A|E&D3&!D2&D1&!D&C&B&!A1&!A|E&!D3&!D2&D1&!D&C&B&!A1&!A|E&!D3&!D2&D1&D&C&B&!A1&!A|E&D3&!D2&D1&D&C&B&!A1&!A|E&D3&D2&D1&D&C&B&!A1&!A|E&!D3&D2&D1&D&C&B&!A1&!A|E&!D3&D2&!D1&D&C&B&!A1&!A|E&D3&D2&!D1&D&C&B&!A1&!A|E&D3&!D2&!D1&D&C&B&!A1&!A|E&!D3&!D2&!D1&D&C&B&!A1&!A|E&D3&!D2&!D1&!D&!C&B&A1&!A|E&D3&D2&!D1&!D&!C&B&A1&!A|E&!D3&D2&!D1&!D&!C&B&A1&!A|E&!D3&D2&D1&!D&!C&B&A1&!A|E&D3&D2&D1&!D&!C&B&A1&!A|E&D3&!D2&D1&!D&!C&B&A1&!A|E&!D3&!D2&D1&!D&!C&B&A1&!A|E&!D3&!D2&D1&D&!C&B&A1&!A|E&D3&!D2&D1&D&!C&B&A1&!A|E&D3&D2&D1&D&!C&B&A1&!A|E&!D3&D2&D1&D&!C&B&A1&!A|E&!D3&D2&!D1&D&!C&B&A1&!A|E&D3&D2&!D1&D&!C&B&A1&!A|E&D3&!D2&!D1&D&!C&B&A1&!A|E&!D3&!D2&!D1&D&!C&B&A1&!A|E&!D3&!D2&!D1&D&C&B&A1&!A|E&D3&!D2&!D1&D&C&B&A1&!A|E&D3&D2&!D1&D&C&B&A1&!A|E&!D3&D2&!D1&D&C&B&A1&!A|E&!D3&D2&D1&D&C&B&A1&!A|E&D3&D2&D1&D&C&B&A1&!A|E&D3&!D2&D1&D&C&B&A1&!A|E&!D3&!D2&D1&D&C&B&A1&!A|E&!D3&!D2&D1&!D&C&B&A1&!A|E&D3&!D2&D1&!D&C&B&A1&!A|E&D3&D2&D1&!D&C&B&A1&!A|E&!D3&D2&D1&!D&C&B&A1&!A|E&!D3&D2&!D1&!D&C&B&A1&!A|E&D3&D2&!D1&!D&C&B&A1&!A|E&D3&!D2&!D1&!D&C&B&A1&!A|E&D3&!D2&!D1&!D&C&!B&A1&!A|E&D3&D2&!D1&!D&C&!B&A1&!A|E&!D3&D2&!D1&!D&C&!B&A1&!A|E&!D3&D2&D1&!D&C&!B&A1&!A|E&D3&D2&D1&!D&C&!B&A1&!A|E&D3&!D2&D1&!D&C&!B&A1&!A|E&!D3&!D2&D1&!D&C&!B&A1&!A|E&!D3&!D2&D1&D&C&!B&A1&!A|E&D3&!D2&D1&D&C&!B&A1&!A|E&D3&D2&D1&D&C&!B&A1&!A|E&!D3&D2&D1&D&C&!B&A1&!A|E&!D3&D2&!D1&D&C&!B&A1&!A|E&D3&D2&!D1&D&C&!B&A1&!A|E&D3&!D2&!D1&D&C&!B&A1&!A|E&!D3&!D2&!D1&D&C&!B&A1&!A|E&!D3&!D2&!D1&D&C&!B&A1&A|E&D3&!D2&!D1&D&C&!B&A1&A|E&D3&D2&!D1&D&C&!B&A1&A|E&!D3&D2&!D1&D&C&!B&A1&A|E&!D3&D2&D1&D&C&!B&A1&A|E&D3&D2&D1&D&C&!B&A1&A|E&D3&!D2&D1&D&C&!B&A1&A|E&!D3&!D2&D1&D&C&!B&A1&A|E&!D3&!D2&D1&!D&C&!B&A1&A|E&D3&!D2&D1&!D&C&!B&A1&A|E&D3&D2&D1&!D&C&!B&A1&A|E&!D3&D2&D1&!D&C&!B&A1&A|E&!D3&D2&!D1&!D&C&!B&A1&A|E&D3&D2&!D1&!D&C&!B&A1&A|E&D3&!D2&!D1&!D&C&!B&A1&A|E&D3&!D2&!D1&!D&C&B&A1&A|E&D3&D2&!D1&!D&C&B&A1&A|E&!D3&D2&!D1&!D&C&B&A1&A|E&!D3&D2&D1&!D&C&B&A1&A|E&D3&D2&D1&!D&C&B&A1&A|E&D3&!D2&D1&!D&C&B&A1&A|E&!D3&!D2&D1&!D&C&B&A1&A|E&!D3&!D2&D1&D&C&B&A1&A|E&D3&!D2&D1&D&C&B&A1&A|E&D3&D2&D1&D&C&B&A1&A|E&!D3&D2&D1&D&C&B&A1&A|E&!D3&D2&!D1&D&C&B&A1&A|E&D3&D2&!D1&D&C&B&A1&A|E&D3&!D2&!D1&D&C&B&A1&A|E&!D3&!D2&!D1&D&C&B&A1&A|E&!D3&!D2&!D1&D&!C&B&A1&A|E&D3&!D2&!D1&D&!C&B&A1&A|E&D3&D2&!D1&D&!C&B&A1&A|E&!D3&D2&!D1&D&!C&B&A1&A|E&!D3&D2&D1&D&!C&B&A1&A|E&D3&D2&D1&D&!C&B&A1&A|E&D3&!D2&D1&D&!C&B&A1&A|E&!D3&!D2&D1&D&!C&B&A1&A|E&!D3&!D2&D1&!D&!C&B&A1&A|E&D3&!D2&D1&!D&!C&B&A1&A|E&D3&D2&D1&!D&!C&B&A1&A|E&!D3&D2&D1&!D&!C&B&A1&A|E&!D3&D2&!D1&!D&!C&B&A1&A|E&D3&D2&!D1&!D&!C&B&A1&A|E&D3&!D2&!D1&!D&!C&B&A1&A|E&D3&!D2&!D1&!D&!C&B&!A1&A|E&D3&D2&!D1&!D&!C&B&!A1&A|E&!D3&D2&!D1&!D&!C&B&!A1&A|E&!D3&D2&D1&!D&!C&B&!A1&A|E&D3&D2&D1&!D&!C&B&!A1&A|E&D3&!D2&D1&!D&!C&B&!A1&A|E&!D3&!D2&D1&!D&!C&B&!A1&A|E&!D3&!D2&D1&D&!C&B&!A1&A|E&D3&!D2&D1&D&!C&B&!A1&A|E&D3&D2&D1&D&!C&B&!A1&A|E&!D3&D2&D1&D&!C&B&!A1&A|E&!D3&D2&!D1&D&!C&B&!A1&A|E&D3&D2&!D1&D&!C&B&!A1&A|E&D3&!D2&!D1&D&!C&B&!A1&A|E&!D3&!D2&!D1&D&!C&B&!A1&A|E&!D3&!D2&!D1&D&C&B&!A1&A|E&D3&!D2&!D1&D&C&B&!A1&A|E&D3&D2&!D1&D&C&B&!A1&A|E&!D3&D2&!D1&D&C&B&!A1&A|E&!D3&D2&D1&D&C&B&!A1&A|E&D3&D2&D1&D&C&B&!A1&A|E&D3&!D2&D1&D&C&B&!A1&A|E&!D3&!D2&D1&D&C&B&!A1&A|E&!D3&!D2&D1&!D&C&B&!A1&A|E&D3&!D2&D1&!D&C&B&!A1&A|E&D3&D2&D1&!D&C&B&!A1&A|E&!D3&D2&D1&!D&C&B&!A1&A|E&!D3&D2&!D1&!D&C&B&!A1&A|E&D3&D2&!D1&!D&C&B&!A1&A|E&D3&!D2&!D1&!D&C&B&!A1&A|E&D3&!D2&!D1&!D&C&!B&!A1&A|E&D3&D2&!D1&!D&C&!B&!A1&A|E&!D3&D2&!D1&!D&C&!B&!A1&A|E&!D3&D2&D1&!D&C&!B&!A1&A|E&D3&D2&D1&!D&C&!B&!A1&A|E&D3&!D2&D1&!D&C&!B&!A1&A|E&!D3&!D2&D1&!D&C&!B&!A1&A|E&!D3&!D2&D1&D&C&!B&!A1&A|E&D3&!D2&D1&D&C&!B&!A1&A|E&D3&D2&D1&D&C&!B&!A1&A|E&!D3&D2&D1&D&C&!B&!A1&A|E&!D3&D2&!D1&D&C&!B&!A1&A|E&D3&D2&!D1&D&C&!B&!A1&A|E&D3&!D2&!D1&D&C&!B&!A1&A|E&!D3&!D2&!D1&D&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAI21141.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOI2223 -l AAOAAOI2223 -i D2 D1 D C1 C B1 B A1 A -o Y -f Y=(!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!D2&D1&!D&C1&C&!B1&!B&!A1&!A|!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!D2&D1&!D&C1&C&B1&!B&!A1&!A|D2&!D1&!D&C1&C&B1&!B&!A1&!A|!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!D2&D1&!D&C1&!C&B1&B&!A1&!A|D2&!D1&!D&C1&!C&B1&B&!A1&!A|!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!D2&D1&!D&!C1&C&B1&B&!A1&!A|D2&!D1&!D&!C1&C&B1&B&!A1&!A|!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!D2&D1&!D&C1&C&!B1&B&!A1&!A|D2&!D1&!D&C1&C&!B1&B&!A1&!A|!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!D2&D1&!D&!C1&!C&!B1&B&A1&!A|!D2&D1&!D&C1&!C&!B1&B&A1&!A|D2&!D1&!D&C1&!C&!B1&B&A1&!A|!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!D2&!D1&!D&C1&C&!B1&B&A1&!A|D2&!D1&!D&C1&C&!B1&B&A1&!A|!D2&D1&!D&C1&C&!B1&B&A1&!A|!D2&D1&!D&!C1&C&!B1&B&A1&!A|D2&!D1&!D&!C1&C&!B1&B&A1&!A|!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!D2&!D1&!D&!C1&C&B1&B&A1&!A|D2&!D1&!D&!C1&C&B1&B&A1&!A|!D2&D1&!D&!C1&C&B1&B&A1&!A|!D2&!D1&!D&C1&!C&B1&B&A1&!A|D2&!D1&!D&C1&!C&B1&B&A1&!A|!D2&D1&!D&C1&!C&B1&B&A1&!A|!D2&D1&!D&!C1&!C&B1&B&A1&!A|D2&!D1&!D&!C1&!C&B1&B&A1&!A|!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!D2&D1&!D&!C1&!C&B1&!B&A1&!A|!D2&D1&!D&C1&!C&B1&!B&A1&!A|D2&!D1&!D&C1&!C&B1&!B&A1&!A|!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!D2&!D1&!D&C1&C&B1&!B&A1&!A|D2&!D1&!D&C1&C&B1&!B&A1&!A|!D2&D1&!D&C1&C&B1&!B&A1&!A|!D2&D1&!D&!C1&C&B1&!B&A1&!A|D2&!D1&!D&!C1&C&B1&!B&A1&!A|!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!D2&D1&!D&C1&C&!B1&!B&A1&!A|D2&!D1&!D&C1&C&!B1&!B&A1&!A|!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!D2&D1&!D&C1&!C&!B1&!B&A1&A|D2&!D1&!D&C1&!C&!B1&!B&A1&A|!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!D2&D1&!D&!C1&C&!B1&!B&A1&A|D2&!D1&!D&!C1&C&!B1&!B&A1&A|!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!D2&!D1&!D&!C1&C&B1&!B&A1&A|D2&!D1&!D&!C1&C&B1&!B&A1&A|!D2&D1&!D&!C1&C&B1&!B&A1&A|!D2&!D1&!D&C1&!C&B1&!B&A1&A|D2&!D1&!D&C1&!C&B1&!B&A1&A|!D2&D1&!D&C1&!C&B1&!B&A1&A|!D2&D1&!D&!C1&!C&B1&!B&A1&A|D2&!D1&!D&!C1&!C&B1&!B&A1&A|!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!D2&!D1&!D&!C1&!C&B1&B&A1&A|D2&!D1&!D&!C1&!C&B1&B&A1&A|!D2&D1&!D&!C1&!C&B1&B&A1&A|!D2&D1&!D&C1&!C&B1&B&A1&A|D2&!D1&!D&C1&!C&B1&B&A1&A|!D2&!D1&!D&C1&!C&B1&B&A1&A|!D2&D1&!D&!C1&C&B1&B&A1&A|D2&!D1&!D&!C1&C&B1&B&A1&A|!D2&!D1&!D&!C1&C&B1&B&A1&A|!D2&!D1&!D&!C1&C&!B1&B&A1&A|D2&!D1&!D&!C1&C&!B1&B&A1&A|!D2&D1&!D&!C1&C&!B1&B&A1&A|!D2&!D1&!D&C1&!C&!B1&B&A1&A|D2&!D1&!D&C1&!C&!B1&B&A1&A|!D2&D1&!D&C1&!C&!B1&B&A1&A|!D2&D1&!D&!C1&!C&!B1&B&A1&A|D2&!D1&!D&!C1&!C&!B1&B&A1&A|!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!D2&D1&!D&!C1&!C&!B1&B&!A1&A|!D2&D1&!D&C1&!C&!B1&B&!A1&A|D2&!D1&!D&C1&!C&!B1&B&!A1&A|!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!D2&!D1&!D&C1&C&!B1&B&!A1&A|D2&!D1&!D&C1&C&!B1&B&!A1&A|!D2&D1&!D&C1&C&!B1&B&!A1&A|!D2&D1&!D&!C1&C&!B1&B&!A1&A|D2&!D1&!D&!C1&C&!B1&B&!A1&A|!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!D2&!D1&!D&!C1&C&B1&B&!A1&A|D2&!D1&!D&!C1&C&B1&B&!A1&A|!D2&D1&!D&!C1&C&B1&B&!A1&A|!D2&!D1&!D&C1&!C&B1&B&!A1&A|D2&!D1&!D&C1&!C&B1&B&!A1&A|!D2&D1&!D&C1&!C&B1&B&!A1&A|!D2&D1&!D&!C1&!C&B1&B&!A1&A|D2&!D1&!D&!C1&!C&B1&B&!A1&A|!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!D2&D1&!D&!C1&!C&B1&!B&!A1&A|!D2&D1&!D&C1&!C&B1&!B&!A1&A|D2&!D1&!D&C1&!C&B1&!B&!A1&A|!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!D2&!D1&!D&C1&C&B1&!B&!A1&A|D2&!D1&!D&C1&C&B1&!B&!A1&A|!D2&D1&!D&C1&C&B1&!B&!A1&A|!D2&D1&!D&!C1&C&B1&!B&!A1&A|D2&!D1&!D&!C1&C&B1&!B&!A1&A|!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!D2&D1&!D&C1&C&!B1&!B&!A1&A|D2&!D1&!D&C1&C&!B1&!B&!A1&A|!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOI2223.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOI22221 -l AAOAAOI22221 -i E D1 D C1 C B1 B A1 A -o Y -f Y=(!E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&D1&!D&C1&C&!B1&!B&!A1&!A|!E&!D1&D&C1&C&!B1&!B&!A1&!A|!E&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&D1&!D&!C1&C&B1&!B&!A1&!A|!E&!D1&D&!C1&C&B1&!B&!A1&!A|!E&!D1&D&C1&C&B1&!B&!A1&!A|!E&D1&!D&C1&C&B1&!B&!A1&!A|!E&!D1&!D&C1&C&B1&!B&!A1&!A|!E&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&D1&!D&C1&!C&B1&!B&!A1&!A|!E&!D1&D&C1&!C&B1&!B&!A1&!A|!E&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&D1&!D&!C1&!C&B1&B&!A1&!A|!E&!D1&D&!C1&!C&B1&B&!A1&!A|!E&!D1&D&C1&!C&B1&B&!A1&!A|!E&D1&!D&C1&!C&B1&B&!A1&!A|!E&!D1&!D&C1&!C&B1&B&!A1&!A|!E&!D1&D&!C1&C&B1&B&!A1&!A|!E&D1&!D&!C1&C&B1&B&!A1&!A|!E&!D1&!D&!C1&C&B1&B&!A1&!A|!E&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&D1&!D&!C1&C&!B1&B&!A1&!A|!E&!D1&D&!C1&C&!B1&B&!A1&!A|!E&!D1&D&C1&C&!B1&B&!A1&!A|!E&D1&!D&C1&C&!B1&B&!A1&!A|!E&!D1&!D&C1&C&!B1&B&!A1&!A|!E&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&D1&!D&C1&!C&!B1&B&!A1&!A|!E&!D1&D&C1&!C&!B1&B&!A1&!A|!E&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&D1&!D&!C1&!C&!B1&B&A1&!A|!E&!D1&D&!C1&!C&!B1&B&A1&!A|!E&!D1&D&C1&!C&!B1&B&A1&!A|!E&D1&!D&C1&!C&!B1&B&A1&!A|!E&!D1&!D&C1&!C&!B1&B&A1&!A|!E&!D1&!D&C1&C&!B1&B&A1&!A|!E&D1&!D&C1&C&!B1&B&A1&!A|!E&!D1&D&C1&C&!B1&B&A1&!A|!E&!D1&D&!C1&C&!B1&B&A1&!A|!E&D1&!D&!C1&C&!B1&B&A1&!A|!E&!D1&!D&!C1&C&!B1&B&A1&!A|!E&!D1&!D&!C1&C&B1&B&A1&!A|!E&D1&!D&!C1&C&B1&B&A1&!A|!E&!D1&D&!C1&C&B1&B&A1&!A|!E&!D1&!D&C1&!C&B1&B&A1&!A|!E&D1&!D&C1&!C&B1&B&A1&!A|!E&!D1&D&C1&!C&B1&B&A1&!A|!E&!D1&D&!C1&!C&B1&B&A1&!A|!E&D1&!D&!C1&!C&B1&B&A1&!A|!E&!D1&!D&!C1&!C&B1&B&A1&!A|!E&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&D1&!D&!C1&!C&B1&!B&A1&!A|!E&!D1&D&!C1&!C&B1&!B&A1&!A|!E&!D1&D&C1&!C&B1&!B&A1&!A|!E&D1&!D&C1&!C&B1&!B&A1&!A|!E&!D1&!D&C1&!C&B1&!B&A1&!A|!E&!D1&!D&C1&C&B1&!B&A1&!A|!E&D1&!D&C1&C&B1&!B&A1&!A|!E&!D1&D&C1&C&B1&!B&A1&!A|!E&!D1&D&!C1&C&B1&!B&A1&!A|!E&D1&!D&!C1&C&B1&!B&A1&!A|!E&!D1&!D&!C1&C&B1&!B&A1&!A|!E&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&D1&!D&!C1&C&!B1&!B&A1&!A|!E&!D1&D&!C1&C&!B1&!B&A1&!A|!E&!D1&D&C1&C&!B1&!B&A1&!A|!E&D1&!D&C1&C&!B1&!B&A1&!A|!E&!D1&!D&C1&C&!B1&!B&A1&!A|!E&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&D1&!D&C1&!C&!B1&!B&A1&!A|!E&!D1&D&C1&!C&!B1&!B&A1&!A|!E&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&D1&!D&!C1&!C&!B1&!B&A1&A|!E&!D1&D&!C1&!C&!B1&!B&A1&A|!E&!D1&D&C1&!C&!B1&!B&A1&A|!E&D1&!D&C1&!C&!B1&!B&A1&A|!E&!D1&!D&C1&!C&!B1&!B&A1&A|!E&!D1&D&!C1&C&!B1&!B&A1&A|!E&D1&!D&!C1&C&!B1&!B&A1&A|!E&!D1&!D&!C1&C&!B1&!B&A1&A|!E&!D1&!D&!C1&C&B1&!B&A1&A|!E&D1&!D&!C1&C&B1&!B&A1&A|!E&!D1&D&!C1&C&B1&!B&A1&A|!E&!D1&!D&C1&!C&B1&!B&A1&A|!E&D1&!D&C1&!C&B1&!B&A1&A|!E&!D1&D&C1&!C&B1&!B&A1&A|!E&!D1&D&!C1&!C&B1&!B&A1&A|!E&D1&!D&!C1&!C&B1&!B&A1&A|!E&!D1&!D&!C1&!C&B1&!B&A1&A|!E&!D1&!D&!C1&!C&B1&B&A1&A|!E&D1&!D&!C1&!C&B1&B&A1&A|!E&!D1&D&!C1&!C&B1&B&A1&A|!E&!D1&D&C1&!C&B1&B&A1&A|!E&D1&!D&C1&!C&B1&B&A1&A|!E&!D1&!D&C1&!C&B1&B&A1&A|!E&!D1&D&!C1&C&B1&B&A1&A|!E&D1&!D&!C1&C&B1&B&A1&A|!E&!D1&!D&!C1&C&B1&B&A1&A|!E&!D1&!D&!C1&C&!B1&B&A1&A|!E&D1&!D&!C1&C&!B1&B&A1&A|!E&!D1&D&!C1&C&!B1&B&A1&A|!E&!D1&!D&C1&!C&!B1&B&A1&A|!E&D1&!D&C1&!C&!B1&B&A1&A|!E&!D1&D&C1&!C&!B1&B&A1&A|!E&!D1&D&!C1&!C&!B1&B&A1&A|!E&D1&!D&!C1&!C&!B1&B&A1&A|!E&!D1&!D&!C1&!C&!B1&B&A1&A|!E&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&D1&!D&!C1&!C&!B1&B&!A1&A|!E&!D1&D&!C1&!C&!B1&B&!A1&A|!E&!D1&D&C1&!C&!B1&B&!A1&A|!E&D1&!D&C1&!C&!B1&B&!A1&A|!E&!D1&!D&C1&!C&!B1&B&!A1&A|!E&!D1&!D&C1&C&!B1&B&!A1&A|!E&D1&!D&C1&C&!B1&B&!A1&A|!E&!D1&D&C1&C&!B1&B&!A1&A|!E&!D1&D&!C1&C&!B1&B&!A1&A|!E&D1&!D&!C1&C&!B1&B&!A1&A|!E&!D1&!D&!C1&C&!B1&B&!A1&A|!E&!D1&!D&!C1&C&B1&B&!A1&A|!E&D1&!D&!C1&C&B1&B&!A1&A|!E&!D1&D&!C1&C&B1&B&!A1&A|!E&!D1&!D&C1&!C&B1&B&!A1&A|!E&D1&!D&C1&!C&B1&B&!A1&A|!E&!D1&D&C1&!C&B1&B&!A1&A|!E&!D1&D&!C1&!C&B1&B&!A1&A|!E&D1&!D&!C1&!C&B1&B&!A1&A|!E&!D1&!D&!C1&!C&B1&B&!A1&A|!E&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&D1&!D&!C1&!C&B1&!B&!A1&A|!E&!D1&D&!C1&!C&B1&!B&!A1&A|!E&!D1&D&C1&!C&B1&!B&!A1&A|!E&D1&!D&C1&!C&B1&!B&!A1&A|!E&!D1&!D&C1&!C&B1&!B&!A1&A|!E&!D1&!D&C1&C&B1&!B&!A1&A|!E&D1&!D&C1&C&B1&!B&!A1&A|!E&!D1&D&C1&C&B1&!B&!A1&A|!E&!D1&D&!C1&C&B1&!B&!A1&A|!E&D1&!D&!C1&C&B1&!B&!A1&A|!E&!D1&!D&!C1&C&B1&!B&!A1&A|!E&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&D1&!D&!C1&C&!B1&!B&!A1&A|!E&!D1&D&!C1&C&!B1&!B&!A1&A|!E&!D1&D&C1&C&!B1&!B&!A1&A|!E&D1&!D&C1&C&!B1&!B&!A1&A|!E&!D1&!D&C1&C&!B1&!B&!A1&A|!E&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&D1&!D&C1&!C&!B1&!B&!A1&A|!E&!D1&D&C1&!C&!B1&!B&!A1&A|!E&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOI22221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOAOAI211111 -l OAOAOAI211111 -i F E D C B A1 A -o Y -f Y=!(F&E&!D&!C&!B&!A1&!A|F&E&D&!C&!B&!A1&!A|F&!E&D&C&!B&!A1&!A|F&E&D&C&!B&!A1&!A|F&E&!D&C&!B&!A1&!A|F&E&!D&C&B&!A1&!A|F&E&D&C&B&!A1&!A|F&!E&D&C&B&!A1&!A|F&E&D&!C&B&!A1&!A|F&E&!D&!C&B&!A1&!A|F&E&!D&!C&B&A1&!A|F&E&D&!C&B&A1&!A|F&!E&D&!C&B&A1&!A|F&!E&D&C&B&A1&!A|F&E&D&C&B&A1&!A|F&E&!D&C&B&A1&!A|F&E&!D&C&!B&A1&!A|F&E&D&C&!B&A1&!A|F&!E&D&C&!B&A1&!A|F&E&D&!C&!B&A1&!A|F&E&!D&!C&!B&A1&!A|F&E&!D&!C&!B&A1&A|F&E&D&!C&!B&A1&A|F&!E&D&C&!B&A1&A|F&E&D&C&!B&A1&A|F&E&!D&C&!B&A1&A|F&E&!D&C&B&A1&A|F&E&D&C&B&A1&A|F&!E&D&C&B&A1&A|F&!E&D&!C&B&A1&A|F&E&D&!C&B&A1&A|F&E&!D&!C&B&A1&A|F&E&!D&!C&B&!A1&A|F&E&D&!C&B&!A1&A|F&!E&D&!C&B&!A1&A|F&!E&D&C&B&!A1&A|F&E&D&C&B&!A1&A|F&E&!D&C&B&!A1&A|F&E&!D&C&!B&!A1&A|F&E&D&C&!B&!A1&A|F&!E&D&C&!B&!A1&A|F&E&D&!C&!B&!A1&A|F&E&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOAOAI211111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAAOAI22221 -l AAAAOAI22221 -i E D1 D C1 C B1 B A1 A -o Y -f Y=!(E&D1&D&!C1&!C&!B1&!B&!A1&!A|E&D1&D&C1&!C&!B1&!B&!A1&!A|E&!D1&!D&C1&C&!B1&!B&!A1&!A|E&D1&!D&C1&C&!B1&!B&!A1&!A|E&D1&D&C1&C&!B1&!B&!A1&!A|E&!D1&D&C1&C&!B1&!B&!A1&!A|E&D1&D&!C1&C&!B1&!B&!A1&!A|E&D1&D&!C1&C&B1&!B&!A1&!A|E&!D1&D&C1&C&B1&!B&!A1&!A|E&D1&D&C1&C&B1&!B&!A1&!A|E&D1&!D&C1&C&B1&!B&!A1&!A|E&!D1&!D&C1&C&B1&!B&!A1&!A|E&D1&D&C1&!C&B1&!B&!A1&!A|E&D1&D&!C1&!C&B1&!B&!A1&!A|E&!D1&!D&!C1&!C&B1&B&!A1&!A|E&D1&!D&!C1&!C&B1&B&!A1&!A|E&D1&D&!C1&!C&B1&B&!A1&!A|E&!D1&D&!C1&!C&B1&B&!A1&!A|E&!D1&D&C1&!C&B1&B&!A1&!A|E&D1&D&C1&!C&B1&B&!A1&!A|E&D1&!D&C1&!C&B1&B&!A1&!A|E&!D1&!D&C1&!C&B1&B&!A1&!A|E&!D1&!D&C1&C&B1&B&!A1&!A|E&D1&!D&C1&C&B1&B&!A1&!A|E&D1&D&C1&C&B1&B&!A1&!A|E&!D1&D&C1&C&B1&B&!A1&!A|E&!D1&D&!C1&C&B1&B&!A1&!A|E&D1&D&!C1&C&B1&B&!A1&!A|E&D1&!D&!C1&C&B1&B&!A1&!A|E&!D1&!D&!C1&C&B1&B&!A1&!A|E&D1&D&!C1&C&!B1&B&!A1&!A|E&!D1&D&C1&C&!B1&B&!A1&!A|E&D1&D&C1&C&!B1&B&!A1&!A|E&D1&!D&C1&C&!B1&B&!A1&!A|E&!D1&!D&C1&C&!B1&B&!A1&!A|E&D1&D&C1&!C&!B1&B&!A1&!A|E&D1&D&!C1&!C&!B1&B&!A1&!A|E&D1&D&!C1&!C&!B1&B&A1&!A|E&D1&D&C1&!C&!B1&B&A1&!A|E&!D1&!D&C1&C&!B1&B&A1&!A|E&D1&!D&C1&C&!B1&B&A1&!A|E&D1&D&C1&C&!B1&B&A1&!A|E&!D1&D&C1&C&!B1&B&A1&!A|E&D1&D&!C1&C&!B1&B&A1&!A|E&!D1&!D&!C1&C&B1&B&A1&!A|E&D1&!D&!C1&C&B1&B&A1&!A|E&D1&D&!C1&C&B1&B&A1&!A|E&!D1&D&!C1&C&B1&B&A1&!A|E&!D1&D&C1&C&B1&B&A1&!A|E&D1&D&C1&C&B1&B&A1&!A|E&D1&!D&C1&C&B1&B&A1&!A|E&!D1&!D&C1&C&B1&B&A1&!A|E&!D1&!D&C1&!C&B1&B&A1&!A|E&D1&!D&C1&!C&B1&B&A1&!A|E&D1&D&C1&!C&B1&B&A1&!A|E&!D1&D&C1&!C&B1&B&A1&!A|E&!D1&D&!C1&!C&B1&B&A1&!A|E&D1&D&!C1&!C&B1&B&A1&!A|E&D1&!D&!C1&!C&B1&B&A1&!A|E&!D1&!D&!C1&!C&B1&B&A1&!A|E&D1&D&!C1&!C&B1&!B&A1&!A|E&D1&D&C1&!C&B1&!B&A1&!A|E&!D1&!D&C1&C&B1&!B&A1&!A|E&D1&!D&C1&C&B1&!B&A1&!A|E&D1&D&C1&C&B1&!B&A1&!A|E&!D1&D&C1&C&B1&!B&A1&!A|E&D1&D&!C1&C&B1&!B&A1&!A|E&D1&D&!C1&C&!B1&!B&A1&!A|E&!D1&D&C1&C&!B1&!B&A1&!A|E&D1&D&C1&C&!B1&!B&A1&!A|E&D1&!D&C1&C&!B1&!B&A1&!A|E&!D1&!D&C1&C&!B1&!B&A1&!A|E&D1&D&C1&!C&!B1&!B&A1&!A|E&D1&D&!C1&!C&!B1&!B&A1&!A|E&!D1&!D&!C1&!C&!B1&!B&A1&A|E&D1&!D&!C1&!C&!B1&!B&A1&A|E&D1&D&!C1&!C&!B1&!B&A1&A|E&!D1&D&!C1&!C&!B1&!B&A1&A|E&!D1&D&C1&!C&!B1&!B&A1&A|E&D1&D&C1&!C&!B1&!B&A1&A|E&D1&!D&C1&!C&!B1&!B&A1&A|E&!D1&!D&C1&!C&!B1&!B&A1&A|E&!D1&!D&C1&C&!B1&!B&A1&A|E&D1&!D&C1&C&!B1&!B&A1&A|E&D1&D&C1&C&!B1&!B&A1&A|E&!D1&D&C1&C&!B1&!B&A1&A|E&!D1&D&!C1&C&!B1&!B&A1&A|E&D1&D&!C1&C&!B1&!B&A1&A|E&D1&!D&!C1&C&!B1&!B&A1&A|E&!D1&!D&!C1&C&!B1&!B&A1&A|E&!D1&!D&!C1&C&B1&!B&A1&A|E&D1&!D&!C1&C&B1&!B&A1&A|E&D1&D&!C1&C&B1&!B&A1&A|E&!D1&D&!C1&C&B1&!B&A1&A|E&!D1&D&C1&C&B1&!B&A1&A|E&D1&D&C1&C&B1&!B&A1&A|E&D1&!D&C1&C&B1&!B&A1&A|E&!D1&!D&C1&C&B1&!B&A1&A|E&!D1&!D&C1&!C&B1&!B&A1&A|E&D1&!D&C1&!C&B1&!B&A1&A|E&D1&D&C1&!C&B1&!B&A1&A|E&!D1&D&C1&!C&B1&!B&A1&A|E&!D1&D&!C1&!C&B1&!B&A1&A|E&D1&D&!C1&!C&B1&!B&A1&A|E&D1&!D&!C1&!C&B1&!B&A1&A|E&!D1&!D&!C1&!C&B1&!B&A1&A|E&!D1&!D&!C1&!C&B1&B&A1&A|E&D1&!D&!C1&!C&B1&B&A1&A|E&D1&D&!C1&!C&B1&B&A1&A|E&!D1&D&!C1&!C&B1&B&A1&A|E&!D1&D&C1&!C&B1&B&A1&A|E&D1&D&C1&!C&B1&B&A1&A|E&D1&!D&C1&!C&B1&B&A1&A|E&!D1&!D&C1&!C&B1&B&A1&A|E&!D1&!D&C1&C&B1&B&A1&A|E&D1&!D&C1&C&B1&B&A1&A|E&D1&D&C1&C&B1&B&A1&A|E&!D1&D&C1&C&B1&B&A1&A|E&!D1&D&!C1&C&B1&B&A1&A|E&D1&D&!C1&C&B1&B&A1&A|E&D1&!D&!C1&C&B1&B&A1&A|E&!D1&!D&!C1&C&B1&B&A1&A|E&!D1&!D&!C1&C&!B1&B&A1&A|E&D1&!D&!C1&C&!B1&B&A1&A|E&D1&D&!C1&C&!B1&B&A1&A|E&!D1&D&!C1&C&!B1&B&A1&A|E&!D1&D&C1&C&!B1&B&A1&A|E&D1&D&C1&C&!B1&B&A1&A|E&D1&!D&C1&C&!B1&B&A1&A|E&!D1&!D&C1&C&!B1&B&A1&A|E&!D1&!D&C1&!C&!B1&B&A1&A|E&D1&!D&C1&!C&!B1&B&A1&A|E&D1&D&C1&!C&!B1&B&A1&A|E&!D1&D&C1&!C&!B1&B&A1&A|E&!D1&D&!C1&!C&!B1&B&A1&A|E&D1&D&!C1&!C&!B1&B&A1&A|E&D1&!D&!C1&!C&!B1&B&A1&A|E&!D1&!D&!C1&!C&!B1&B&A1&A|E&D1&D&!C1&!C&!B1&B&!A1&A|E&D1&D&C1&!C&!B1&B&!A1&A|E&!D1&!D&C1&C&!B1&B&!A1&A|E&D1&!D&C1&C&!B1&B&!A1&A|E&D1&D&C1&C&!B1&B&!A1&A|E&!D1&D&C1&C&!B1&B&!A1&A|E&D1&D&!C1&C&!B1&B&!A1&A|E&!D1&!D&!C1&C&B1&B&!A1&A|E&D1&!D&!C1&C&B1&B&!A1&A|E&D1&D&!C1&C&B1&B&!A1&A|E&!D1&D&!C1&C&B1&B&!A1&A|E&!D1&D&C1&C&B1&B&!A1&A|E&D1&D&C1&C&B1&B&!A1&A|E&D1&!D&C1&C&B1&B&!A1&A|E&!D1&!D&C1&C&B1&B&!A1&A|E&!D1&!D&C1&!C&B1&B&!A1&A|E&D1&!D&C1&!C&B1&B&!A1&A|E&D1&D&C1&!C&B1&B&!A1&A|E&!D1&D&C1&!C&B1&B&!A1&A|E&!D1&D&!C1&!C&B1&B&!A1&A|E&D1&D&!C1&!C&B1&B&!A1&A|E&D1&!D&!C1&!C&B1&B&!A1&A|E&!D1&!D&!C1&!C&B1&B&!A1&A|E&D1&D&!C1&!C&B1&!B&!A1&A|E&D1&D&C1&!C&B1&!B&!A1&A|E&!D1&!D&C1&C&B1&!B&!A1&A|E&D1&!D&C1&C&B1&!B&!A1&A|E&D1&D&C1&C&B1&!B&!A1&A|E&!D1&D&C1&C&B1&!B&!A1&A|E&D1&D&!C1&C&B1&!B&!A1&A|E&D1&D&!C1&C&!B1&!B&!A1&A|E&!D1&D&C1&C&!B1&!B&!A1&A|E&D1&D&C1&C&!B1&!B&!A1&A|E&D1&!D&C1&C&!B1&!B&!A1&A|E&!D1&!D&C1&C&!B1&!B&!A1&A|E&D1&D&C1&!C&!B1&!B&!A1&A|E&D1&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAAOAI22221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOI312 -l OAAOI312 -i C1 C B A2 A1 A -o Y -f Y=(!C1&!C&!B&!A2&!A1&!A|C1&!C&!B&!A2&!A1&!A|!C1&C&!B&!A2&!A1&!A|!C1&C&B&!A2&!A1&!A|C1&!C&B&!A2&!A1&!A|!C1&!C&B&!A2&!A1&!A|!C1&C&!B&A2&!A1&!A|C1&!C&!B&A2&!A1&!A|!C1&!C&!B&A2&!A1&!A|!C1&!C&!B&A2&A1&!A|C1&!C&!B&A2&A1&!A|!C1&C&!B&A2&A1&!A|!C1&C&!B&!A2&A1&!A|C1&!C&!B&!A2&A1&!A|!C1&!C&!B&!A2&A1&!A|!C1&!C&!B&!A2&A1&A|C1&!C&!B&!A2&A1&A|!C1&C&!B&!A2&A1&A|!C1&C&!B&A2&A1&A|C1&!C&!B&A2&A1&A|!C1&!C&!B&A2&A1&A|!C1&!C&!B&A2&!A1&A|C1&!C&!B&A2&!A1&A|!C1&C&!B&A2&!A1&A|!C1&C&!B&!A2&!A1&A|C1&!C&!B&!A2&!A1&A|!C1&!C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOI312.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOI21112 -l AOAAOI21112 -i E D1 D C B A1 A -o Y -f Y=(!E&!D1&!D&!C&!B&!A1&!A|!E&D1&!D&!C&!B&!A1&!A|!E&!D1&D&!C&!B&!A1&!A|!E&!D1&D&C&!B&!A1&!A|!E&D1&!D&C&!B&!A1&!A|!E&!D1&!D&C&!B&!A1&!A|!E&!D1&D&!C&B&!A1&!A|!E&D1&!D&!C&B&!A1&!A|!E&!D1&!D&!C&B&!A1&!A|!E&!D1&!D&!C&B&A1&!A|!E&D1&!D&!C&B&A1&!A|!E&!D1&D&!C&B&A1&!A|!E&!D1&!D&C&!B&A1&!A|!E&D1&!D&C&!B&A1&!A|!E&!D1&D&C&!B&A1&!A|!E&!D1&D&!C&!B&A1&!A|!E&D1&!D&!C&!B&A1&!A|!E&!D1&!D&!C&!B&A1&!A|!E&!D1&!D&!C&!B&A1&A|!E&D1&!D&!C&!B&A1&A|!E&!D1&D&!C&!B&A1&A|!E&!D1&D&!C&B&A1&A|!E&D1&!D&!C&B&A1&A|!E&!D1&!D&!C&B&A1&A|!E&!D1&!D&!C&B&!A1&A|!E&D1&!D&!C&B&!A1&A|!E&!D1&D&!C&B&!A1&A|!E&!D1&!D&C&!B&!A1&A|!E&D1&!D&C&!B&!A1&A|!E&!D1&D&C&!B&!A1&A|!E&!D1&D&!C&!B&!A1&A|!E&D1&!D&!C&!B&!A1&A|!E&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOI21112.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAI43 -l OOAI43 -i B2 B1 B A3 A2 A1 A -o Y -f Y=(!B2&!B1&!B&!A3&!A2&!A1&!A|B2&!B1&!B&!A3&!A2&!A1&!A|B2&B1&!B&!A3&!A2&!A1&!A|!B2&B1&!B&!A3&!A2&!A1&!A|!B2&B1&B&!A3&!A2&!A1&!A|B2&B1&B&!A3&!A2&!A1&!A|B2&!B1&B&!A3&!A2&!A1&!A|!B2&!B1&B&!A3&!A2&!A1&!A|!B2&!B1&!B&A3&!A2&!A1&!A|!B2&!B1&!B&A3&A2&!A1&!A|!B2&!B1&!B&!A3&A2&!A1&!A|!B2&!B1&!B&!A3&A2&A1&!A|!B2&!B1&!B&A3&A2&A1&!A|!B2&!B1&!B&A3&!A2&A1&!A|!B2&!B1&!B&!A3&!A2&A1&!A|!B2&!B1&!B&!A3&!A2&A1&A|!B2&!B1&!B&A3&!A2&A1&A|!B2&!B1&!B&A3&A2&A1&A|!B2&!B1&!B&!A3&A2&A1&A|!B2&!B1&!B&!A3&A2&!A1&A|!B2&!B1&!B&A3&A2&!A1&A|!B2&!B1&!B&A3&!A2&!A1&A|!B2&!B1&!B&!A3&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAI43.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAOOAI221112 -l AAOAOOAI221112 -i F1 F E D C B1 B A1 A -o Y -f Y=(!F1&!F&!E&!D&!C&!B1&!B&!A1&!A|F1&!F&!E&!D&!C&!B1&!B&!A1&!A|F1&F&!E&!D&!C&!B1&!B&!A1&!A|!F1&F&!E&!D&!C&!B1&!B&!A1&!A|!F1&!F&E&!D&!C&!B1&!B&!A1&!A|!F1&!F&E&D&!C&!B1&!B&!A1&!A|!F1&F&!E&D&!C&!B1&!B&!A1&!A|F1&F&!E&D&!C&!B1&!B&!A1&!A|F1&!F&!E&D&!C&!B1&!B&!A1&!A|!F1&!F&!E&D&!C&!B1&!B&!A1&!A|!F1&!F&!E&D&C&!B1&!B&!A1&!A|!F1&!F&E&D&C&!B1&!B&!A1&!A|!F1&!F&E&!D&C&!B1&!B&!A1&!A|!F1&F&!E&!D&C&!B1&!B&!A1&!A|F1&F&!E&!D&C&!B1&!B&!A1&!A|F1&!F&!E&!D&C&!B1&!B&!A1&!A|!F1&!F&!E&!D&C&!B1&!B&!A1&!A|!F1&!F&!E&!D&C&B1&!B&!A1&!A|F1&!F&!E&!D&C&B1&!B&!A1&!A|F1&F&!E&!D&C&B1&!B&!A1&!A|!F1&F&!E&!D&C&B1&!B&!A1&!A|!F1&!F&E&!D&C&B1&!B&!A1&!A|!F1&!F&E&D&C&B1&!B&!A1&!A|!F1&!F&!E&D&C&B1&!B&!A1&!A|!F1&!F&!E&D&!C&B1&!B&!A1&!A|F1&!F&!E&D&!C&B1&!B&!A1&!A|F1&F&!E&D&!C&B1&!B&!A1&!A|!F1&F&!E&D&!C&B1&!B&!A1&!A|!F1&!F&E&D&!C&B1&!B&!A1&!A|!F1&!F&E&!D&!C&B1&!B&!A1&!A|!F1&F&!E&!D&!C&B1&!B&!A1&!A|F1&F&!E&!D&!C&B1&!B&!A1&!A|F1&!F&!E&!D&!C&B1&!B&!A1&!A|!F1&!F&!E&!D&!C&B1&!B&!A1&!A|!F1&!F&!E&!D&!C&B1&B&!A1&!A|F1&!F&!E&!D&!C&B1&B&!A1&!A|F1&F&!E&!D&!C&B1&B&!A1&!A|!F1&F&!E&!D&!C&B1&B&!A1&!A|!F1&!F&E&!D&!C&B1&B&!A1&!A|!F1&!F&E&D&!C&B1&B&!A1&!A|!F1&!F&!E&D&!C&B1&B&!A1&!A|!F1&!F&!E&D&C&B1&B&!A1&!A|!F1&!F&E&D&C&B1&B&!A1&!A|!F1&!F&E&!D&C&B1&B&!A1&!A|!F1&F&!E&!D&C&B1&B&!A1&!A|F1&F&!E&!D&C&B1&B&!A1&!A|F1&!F&!E&!D&C&B1&B&!A1&!A|!F1&!F&!E&!D&C&B1&B&!A1&!A|!F1&!F&!E&!D&C&!B1&B&!A1&!A|F1&!F&!E&!D&C&!B1&B&!A1&!A|F1&F&!E&!D&C&!B1&B&!A1&!A|!F1&F&!E&!D&C&!B1&B&!A1&!A|!F1&!F&E&!D&C&!B1&B&!A1&!A|!F1&!F&E&D&C&!B1&B&!A1&!A|!F1&!F&!E&D&C&!B1&B&!A1&!A|!F1&!F&!E&D&!C&!B1&B&!A1&!A|F1&!F&!E&D&!C&!B1&B&!A1&!A|F1&F&!E&D&!C&!B1&B&!A1&!A|!F1&F&!E&D&!C&!B1&B&!A1&!A|!F1&!F&E&D&!C&!B1&B&!A1&!A|!F1&!F&E&!D&!C&!B1&B&!A1&!A|!F1&F&!E&!D&!C&!B1&B&!A1&!A|F1&F&!E&!D&!C&!B1&B&!A1&!A|F1&!F&!E&!D&!C&!B1&B&!A1&!A|!F1&!F&!E&!D&!C&!B1&B&!A1&!A|!F1&!F&!E&!D&!C&!B1&B&A1&!A|F1&!F&!E&!D&!C&!B1&B&A1&!A|F1&F&!E&!D&!C&!B1&B&A1&!A|!F1&F&!E&!D&!C&!B1&B&A1&!A|!F1&!F&E&!D&!C&!B1&B&A1&!A|!F1&!F&E&D&!C&!B1&B&A1&!A|!F1&F&!E&D&!C&!B1&B&A1&!A|F1&F&!E&D&!C&!B1&B&A1&!A|F1&!F&!E&D&!C&!B1&B&A1&!A|!F1&!F&!E&D&!C&!B1&B&A1&!A|!F1&!F&!E&D&C&!B1&B&A1&!A|!F1&!F&E&D&C&!B1&B&A1&!A|!F1&!F&E&!D&C&!B1&B&A1&!A|!F1&F&!E&!D&C&!B1&B&A1&!A|F1&F&!E&!D&C&!B1&B&A1&!A|F1&!F&!E&!D&C&!B1&B&A1&!A|!F1&!F&!E&!D&C&!B1&B&A1&!A|!F1&!F&!E&!D&C&B1&B&A1&!A|F1&!F&!E&!D&C&B1&B&A1&!A|F1&F&!E&!D&C&B1&B&A1&!A|!F1&F&!E&!D&C&B1&B&A1&!A|!F1&!F&E&!D&C&B1&B&A1&!A|!F1&!F&E&D&C&B1&B&A1&!A|!F1&!F&!E&D&C&B1&B&A1&!A|!F1&!F&!E&D&!C&B1&B&A1&!A|!F1&!F&E&D&!C&B1&B&A1&!A|!F1&!F&E&!D&!C&B1&B&A1&!A|!F1&F&!E&!D&!C&B1&B&A1&!A|F1&F&!E&!D&!C&B1&B&A1&!A|F1&!F&!E&!D&!C&B1&B&A1&!A|!F1&!F&!E&!D&!C&B1&B&A1&!A|!F1&!F&!E&!D&!C&B1&!B&A1&!A|F1&!F&!E&!D&!C&B1&!B&A1&!A|F1&F&!E&!D&!C&B1&!B&A1&!A|!F1&F&!E&!D&!C&B1&!B&A1&!A|!F1&!F&E&!D&!C&B1&!B&A1&!A|!F1&!F&E&D&!C&B1&!B&A1&!A|!F1&F&!E&D&!C&B1&!B&A1&!A|F1&F&!E&D&!C&B1&!B&A1&!A|F1&!F&!E&D&!C&B1&!B&A1&!A|!F1&!F&!E&D&!C&B1&!B&A1&!A|!F1&!F&!E&D&C&B1&!B&A1&!A|!F1&!F&E&D&C&B1&!B&A1&!A|!F1&!F&E&!D&C&B1&!B&A1&!A|!F1&F&!E&!D&C&B1&!B&A1&!A|F1&F&!E&!D&C&B1&!B&A1&!A|F1&!F&!E&!D&C&B1&!B&A1&!A|!F1&!F&!E&!D&C&B1&!B&A1&!A|!F1&!F&!E&!D&C&!B1&!B&A1&!A|F1&!F&!E&!D&C&!B1&!B&A1&!A|F1&F&!E&!D&C&!B1&!B&A1&!A|!F1&F&!E&!D&C&!B1&!B&A1&!A|!F1&!F&E&!D&C&!B1&!B&A1&!A|!F1&!F&E&D&C&!B1&!B&A1&!A|!F1&!F&!E&D&C&!B1&!B&A1&!A|!F1&!F&!E&D&!C&!B1&!B&A1&!A|F1&!F&!E&D&!C&!B1&!B&A1&!A|F1&F&!E&D&!C&!B1&!B&A1&!A|!F1&F&!E&D&!C&!B1&!B&A1&!A|!F1&!F&E&D&!C&!B1&!B&A1&!A|!F1&!F&E&!D&!C&!B1&!B&A1&!A|!F1&F&!E&!D&!C&!B1&!B&A1&!A|F1&F&!E&!D&!C&!B1&!B&A1&!A|F1&!F&!E&!D&!C&!B1&!B&A1&!A|!F1&!F&!E&!D&!C&!B1&!B&A1&!A|!F1&!F&!E&!D&!C&!B1&!B&A1&A|F1&!F&!E&!D&!C&!B1&!B&A1&A|F1&F&!E&!D&!C&!B1&!B&A1&A|!F1&F&!E&!D&!C&!B1&!B&A1&A|!F1&!F&E&!D&!C&!B1&!B&A1&A|!F1&!F&E&D&!C&!B1&!B&A1&A|!F1&!F&!E&D&!C&!B1&!B&A1&A|!F1&!F&!E&D&C&!B1&!B&A1&A|!F1&!F&E&D&C&!B1&!B&A1&A|!F1&!F&E&!D&C&!B1&!B&A1&A|!F1&F&!E&!D&C&!B1&!B&A1&A|F1&F&!E&!D&C&!B1&!B&A1&A|F1&!F&!E&!D&C&!B1&!B&A1&A|!F1&!F&!E&!D&C&!B1&!B&A1&A|!F1&!F&!E&!D&C&B1&!B&A1&A|F1&!F&!E&!D&C&B1&!B&A1&A|F1&F&!E&!D&C&B1&!B&A1&A|!F1&F&!E&!D&C&B1&!B&A1&A|!F1&!F&E&!D&C&B1&!B&A1&A|!F1&!F&E&D&C&B1&!B&A1&A|!F1&!F&!E&D&C&B1&!B&A1&A|!F1&!F&!E&D&!C&B1&!B&A1&A|!F1&!F&E&D&!C&B1&!B&A1&A|!F1&!F&E&!D&!C&B1&!B&A1&A|!F1&F&!E&!D&!C&B1&!B&A1&A|F1&F&!E&!D&!C&B1&!B&A1&A|F1&!F&!E&!D&!C&B1&!B&A1&A|!F1&!F&!E&!D&!C&B1&!B&A1&A|!F1&!F&!E&!D&!C&B1&B&A1&A|F1&!F&!E&!D&!C&B1&B&A1&A|F1&F&!E&!D&!C&B1&B&A1&A|!F1&F&!E&!D&!C&B1&B&A1&A|!F1&!F&E&!D&!C&B1&B&A1&A|!F1&!F&E&D&!C&B1&B&A1&A|!F1&!F&!E&D&!C&B1&B&A1&A|!F1&!F&!E&D&C&B1&B&A1&A|!F1&!F&E&D&C&B1&B&A1&A|!F1&!F&E&!D&C&B1&B&A1&A|!F1&F&!E&!D&C&B1&B&A1&A|F1&F&!E&!D&C&B1&B&A1&A|F1&!F&!E&!D&C&B1&B&A1&A|!F1&!F&!E&!D&C&B1&B&A1&A|!F1&!F&!E&!D&C&!B1&B&A1&A|F1&!F&!E&!D&C&!B1&B&A1&A|F1&F&!E&!D&C&!B1&B&A1&A|!F1&F&!E&!D&C&!B1&B&A1&A|!F1&!F&E&!D&C&!B1&B&A1&A|!F1&!F&E&D&C&!B1&B&A1&A|!F1&!F&!E&D&C&!B1&B&A1&A|!F1&!F&!E&D&!C&!B1&B&A1&A|!F1&!F&E&D&!C&!B1&B&A1&A|!F1&!F&E&!D&!C&!B1&B&A1&A|!F1&F&!E&!D&!C&!B1&B&A1&A|F1&F&!E&!D&!C&!B1&B&A1&A|F1&!F&!E&!D&!C&!B1&B&A1&A|!F1&!F&!E&!D&!C&!B1&B&A1&A|!F1&!F&!E&!D&!C&!B1&B&!A1&A|F1&!F&!E&!D&!C&!B1&B&!A1&A|F1&F&!E&!D&!C&!B1&B&!A1&A|!F1&F&!E&!D&!C&!B1&B&!A1&A|!F1&!F&E&!D&!C&!B1&B&!A1&A|!F1&!F&E&D&!C&!B1&B&!A1&A|!F1&F&!E&D&!C&!B1&B&!A1&A|F1&F&!E&D&!C&!B1&B&!A1&A|F1&!F&!E&D&!C&!B1&B&!A1&A|!F1&!F&!E&D&!C&!B1&B&!A1&A|!F1&!F&!E&D&C&!B1&B&!A1&A|!F1&!F&E&D&C&!B1&B&!A1&A|!F1&!F&E&!D&C&!B1&B&!A1&A|!F1&F&!E&!D&C&!B1&B&!A1&A|F1&F&!E&!D&C&!B1&B&!A1&A|F1&!F&!E&!D&C&!B1&B&!A1&A|!F1&!F&!E&!D&C&!B1&B&!A1&A|!F1&!F&!E&!D&C&B1&B&!A1&A|F1&!F&!E&!D&C&B1&B&!A1&A|F1&F&!E&!D&C&B1&B&!A1&A|!F1&F&!E&!D&C&B1&B&!A1&A|!F1&!F&E&!D&C&B1&B&!A1&A|!F1&!F&E&D&C&B1&B&!A1&A|!F1&!F&!E&D&C&B1&B&!A1&A|!F1&!F&!E&D&!C&B1&B&!A1&A|!F1&!F&E&D&!C&B1&B&!A1&A|!F1&!F&E&!D&!C&B1&B&!A1&A|!F1&F&!E&!D&!C&B1&B&!A1&A|F1&F&!E&!D&!C&B1&B&!A1&A|F1&!F&!E&!D&!C&B1&B&!A1&A|!F1&!F&!E&!D&!C&B1&B&!A1&A|!F1&!F&!E&!D&!C&B1&!B&!A1&A|F1&!F&!E&!D&!C&B1&!B&!A1&A|F1&F&!E&!D&!C&B1&!B&!A1&A|!F1&F&!E&!D&!C&B1&!B&!A1&A|!F1&!F&E&!D&!C&B1&!B&!A1&A|!F1&!F&E&D&!C&B1&!B&!A1&A|!F1&F&!E&D&!C&B1&!B&!A1&A|F1&F&!E&D&!C&B1&!B&!A1&A|F1&!F&!E&D&!C&B1&!B&!A1&A|!F1&!F&!E&D&!C&B1&!B&!A1&A|!F1&!F&!E&D&C&B1&!B&!A1&A|!F1&!F&E&D&C&B1&!B&!A1&A|!F1&!F&E&!D&C&B1&!B&!A1&A|!F1&F&!E&!D&C&B1&!B&!A1&A|F1&F&!E&!D&C&B1&!B&!A1&A|F1&!F&!E&!D&C&B1&!B&!A1&A|!F1&!F&!E&!D&C&B1&!B&!A1&A|!F1&!F&!E&!D&C&!B1&!B&!A1&A|F1&!F&!E&!D&C&!B1&!B&!A1&A|F1&F&!E&!D&C&!B1&!B&!A1&A|!F1&F&!E&!D&C&!B1&!B&!A1&A|!F1&!F&E&!D&C&!B1&!B&!A1&A|!F1&!F&E&D&C&!B1&!B&!A1&A|!F1&!F&!E&D&C&!B1&!B&!A1&A|!F1&!F&!E&D&!C&!B1&!B&!A1&A|F1&!F&!E&D&!C&!B1&!B&!A1&A|F1&F&!E&D&!C&!B1&!B&!A1&A|!F1&F&!E&D&!C&!B1&!B&!A1&A|!F1&!F&E&D&!C&!B1&!B&!A1&A|!F1&!F&E&!D&!C&!B1&!B&!A1&A|!F1&F&!E&!D&!C&!B1&!B&!A1&A|F1&F&!E&!D&!C&!B1&!B&!A1&A|F1&!F&!E&!D&!C&!B1&!B&!A1&A|!F1&!F&!E&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAOOAI221112.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAI3312 -l AAOOAI3312 -i D1 D C B2 B1 B A2 A1 A -o Y -f Y=!(!D1&D&C&!B2&!B1&!B&!A2&!A1&!A|D1&D&C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&C&B2&!B1&!B&!A2&!A1&!A|D1&D&C&B2&!B1&!B&!A2&!A1&!A|!D1&D&C&B2&!B1&!B&!A2&!A1&!A|!D1&D&C&B2&B1&!B&!A2&!A1&!A|D1&D&C&B2&B1&!B&!A2&!A1&!A|D1&!D&C&B2&B1&!B&!A2&!A1&!A|D1&!D&C&!B2&B1&!B&!A2&!A1&!A|D1&D&C&!B2&B1&!B&!A2&!A1&!A|!D1&D&C&!B2&B1&!B&!A2&!A1&!A|!D1&D&C&!B2&B1&B&!A2&!A1&!A|D1&D&C&!B2&B1&B&!A2&!A1&!A|D1&!D&C&!B2&B1&B&!A2&!A1&!A|D1&!D&C&B2&B1&B&!A2&!A1&!A|D1&D&C&B2&B1&B&!A2&!A1&!A|!D1&D&C&B2&B1&B&!A2&!A1&!A|!D1&D&!C&B2&B1&B&!A2&!A1&!A|D1&D&!C&B2&B1&B&!A2&!A1&!A|D1&!D&!C&B2&B1&B&!A2&!A1&!A|!D1&D&C&B2&!B1&B&!A2&!A1&!A|D1&D&C&B2&!B1&B&!A2&!A1&!A|D1&!D&C&B2&!B1&B&!A2&!A1&!A|D1&!D&C&!B2&!B1&B&!A2&!A1&!A|D1&D&C&!B2&!B1&B&!A2&!A1&!A|!D1&D&C&!B2&!B1&B&!A2&!A1&!A|!D1&D&C&!B2&!B1&B&A2&!A1&!A|D1&D&C&!B2&!B1&B&A2&!A1&!A|D1&!D&C&!B2&!B1&B&A2&!A1&!A|D1&!D&C&B2&!B1&B&A2&!A1&!A|D1&D&C&B2&!B1&B&A2&!A1&!A|!D1&D&C&B2&!B1&B&A2&!A1&!A|D1&!D&!C&B2&B1&B&A2&!A1&!A|D1&D&!C&B2&B1&B&A2&!A1&!A|!D1&D&!C&B2&B1&B&A2&!A1&!A|!D1&D&C&B2&B1&B&A2&!A1&!A|D1&D&C&B2&B1&B&A2&!A1&!A|D1&!D&C&B2&B1&B&A2&!A1&!A|D1&!D&C&!B2&B1&B&A2&!A1&!A|D1&D&C&!B2&B1&B&A2&!A1&!A|!D1&D&C&!B2&B1&B&A2&!A1&!A|!D1&D&C&!B2&B1&!B&A2&!A1&!A|D1&D&C&!B2&B1&!B&A2&!A1&!A|D1&!D&C&!B2&B1&!B&A2&!A1&!A|D1&!D&C&B2&B1&!B&A2&!A1&!A|D1&D&C&B2&B1&!B&A2&!A1&!A|!D1&D&C&B2&B1&!B&A2&!A1&!A|!D1&D&C&B2&!B1&!B&A2&!A1&!A|D1&D&C&B2&!B1&!B&A2&!A1&!A|D1&!D&C&B2&!B1&!B&A2&!A1&!A|D1&!D&C&!B2&!B1&!B&A2&!A1&!A|D1&D&C&!B2&!B1&!B&A2&!A1&!A|!D1&D&C&!B2&!B1&!B&A2&!A1&!A|!D1&D&C&!B2&!B1&!B&A2&A1&!A|D1&D&C&!B2&!B1&!B&A2&A1&!A|D1&!D&C&!B2&!B1&!B&A2&A1&!A|D1&!D&C&B2&!B1&!B&A2&A1&!A|D1&D&C&B2&!B1&!B&A2&A1&!A|!D1&D&C&B2&!B1&!B&A2&A1&!A|!D1&D&C&B2&B1&!B&A2&A1&!A|D1&D&C&B2&B1&!B&A2&A1&!A|D1&!D&C&B2&B1&!B&A2&A1&!A|D1&!D&C&!B2&B1&!B&A2&A1&!A|D1&D&C&!B2&B1&!B&A2&A1&!A|!D1&D&C&!B2&B1&!B&A2&A1&!A|!D1&D&C&!B2&B1&B&A2&A1&!A|D1&D&C&!B2&B1&B&A2&A1&!A|D1&!D&C&!B2&B1&B&A2&A1&!A|D1&!D&C&B2&B1&B&A2&A1&!A|D1&D&C&B2&B1&B&A2&A1&!A|!D1&D&C&B2&B1&B&A2&A1&!A|!D1&D&!C&B2&B1&B&A2&A1&!A|D1&D&!C&B2&B1&B&A2&A1&!A|D1&!D&!C&B2&B1&B&A2&A1&!A|!D1&D&C&B2&!B1&B&A2&A1&!A|D1&D&C&B2&!B1&B&A2&A1&!A|D1&!D&C&B2&!B1&B&A2&A1&!A|D1&!D&C&!B2&!B1&B&A2&A1&!A|D1&D&C&!B2&!B1&B&A2&A1&!A|!D1&D&C&!B2&!B1&B&A2&A1&!A|!D1&D&C&!B2&!B1&B&!A2&A1&!A|D1&D&C&!B2&!B1&B&!A2&A1&!A|D1&!D&C&!B2&!B1&B&!A2&A1&!A|D1&!D&C&B2&!B1&B&!A2&A1&!A|D1&D&C&B2&!B1&B&!A2&A1&!A|!D1&D&C&B2&!B1&B&!A2&A1&!A|D1&!D&!C&B2&B1&B&!A2&A1&!A|D1&D&!C&B2&B1&B&!A2&A1&!A|!D1&D&!C&B2&B1&B&!A2&A1&!A|!D1&D&C&B2&B1&B&!A2&A1&!A|D1&D&C&B2&B1&B&!A2&A1&!A|D1&!D&C&B2&B1&B&!A2&A1&!A|D1&!D&C&!B2&B1&B&!A2&A1&!A|D1&D&C&!B2&B1&B&!A2&A1&!A|!D1&D&C&!B2&B1&B&!A2&A1&!A|!D1&D&C&!B2&B1&!B&!A2&A1&!A|D1&D&C&!B2&B1&!B&!A2&A1&!A|D1&!D&C&!B2&B1&!B&!A2&A1&!A|D1&!D&C&B2&B1&!B&!A2&A1&!A|D1&D&C&B2&B1&!B&!A2&A1&!A|!D1&D&C&B2&B1&!B&!A2&A1&!A|!D1&D&C&B2&!B1&!B&!A2&A1&!A|D1&D&C&B2&!B1&!B&!A2&A1&!A|D1&!D&C&B2&!B1&!B&!A2&A1&!A|D1&!D&C&!B2&!B1&!B&!A2&A1&!A|D1&D&C&!B2&!B1&!B&!A2&A1&!A|!D1&D&C&!B2&!B1&!B&!A2&A1&!A|!D1&D&C&!B2&!B1&!B&!A2&A1&A|D1&D&C&!B2&!B1&!B&!A2&A1&A|D1&!D&C&!B2&!B1&!B&!A2&A1&A|D1&!D&C&B2&!B1&!B&!A2&A1&A|D1&D&C&B2&!B1&!B&!A2&A1&A|!D1&D&C&B2&!B1&!B&!A2&A1&A|!D1&D&C&B2&B1&!B&!A2&A1&A|D1&D&C&B2&B1&!B&!A2&A1&A|D1&!D&C&B2&B1&!B&!A2&A1&A|D1&!D&C&!B2&B1&!B&!A2&A1&A|D1&D&C&!B2&B1&!B&!A2&A1&A|!D1&D&C&!B2&B1&!B&!A2&A1&A|!D1&D&C&!B2&B1&B&!A2&A1&A|D1&D&C&!B2&B1&B&!A2&A1&A|D1&!D&C&!B2&B1&B&!A2&A1&A|D1&!D&C&B2&B1&B&!A2&A1&A|D1&D&C&B2&B1&B&!A2&A1&A|!D1&D&C&B2&B1&B&!A2&A1&A|!D1&D&!C&B2&B1&B&!A2&A1&A|D1&D&!C&B2&B1&B&!A2&A1&A|D1&!D&!C&B2&B1&B&!A2&A1&A|!D1&D&C&B2&!B1&B&!A2&A1&A|D1&D&C&B2&!B1&B&!A2&A1&A|D1&!D&C&B2&!B1&B&!A2&A1&A|D1&!D&C&!B2&!B1&B&!A2&A1&A|D1&D&C&!B2&!B1&B&!A2&A1&A|!D1&D&C&!B2&!B1&B&!A2&A1&A|D1&!D&!C&!B2&!B1&B&A2&A1&A|D1&D&!C&!B2&!B1&B&A2&A1&A|!D1&D&!C&!B2&!B1&B&A2&A1&A|!D1&D&C&!B2&!B1&B&A2&A1&A|D1&D&C&!B2&!B1&B&A2&A1&A|D1&!D&C&!B2&!B1&B&A2&A1&A|D1&!D&C&B2&!B1&B&A2&A1&A|D1&D&C&B2&!B1&B&A2&A1&A|!D1&D&C&B2&!B1&B&A2&A1&A|!D1&D&!C&B2&!B1&B&A2&A1&A|D1&D&!C&B2&!B1&B&A2&A1&A|D1&!D&!C&B2&!B1&B&A2&A1&A|D1&!D&!C&B2&B1&B&A2&A1&A|D1&D&!C&B2&B1&B&A2&A1&A|!D1&D&!C&B2&B1&B&A2&A1&A|!D1&D&C&B2&B1&B&A2&A1&A|D1&D&C&B2&B1&B&A2&A1&A|D1&!D&C&B2&B1&B&A2&A1&A|D1&!D&C&!B2&B1&B&A2&A1&A|D1&D&C&!B2&B1&B&A2&A1&A|!D1&D&C&!B2&B1&B&A2&A1&A|!D1&D&!C&!B2&B1&B&A2&A1&A|D1&D&!C&!B2&B1&B&A2&A1&A|D1&!D&!C&!B2&B1&B&A2&A1&A|D1&!D&!C&!B2&B1&!B&A2&A1&A|D1&D&!C&!B2&B1&!B&A2&A1&A|!D1&D&!C&!B2&B1&!B&A2&A1&A|!D1&D&C&!B2&B1&!B&A2&A1&A|D1&D&C&!B2&B1&!B&A2&A1&A|D1&!D&C&!B2&B1&!B&A2&A1&A|D1&!D&C&B2&B1&!B&A2&A1&A|D1&D&C&B2&B1&!B&A2&A1&A|!D1&D&C&B2&B1&!B&A2&A1&A|!D1&D&!C&B2&B1&!B&A2&A1&A|D1&D&!C&B2&B1&!B&A2&A1&A|D1&!D&!C&B2&B1&!B&A2&A1&A|D1&!D&!C&B2&!B1&!B&A2&A1&A|D1&D&!C&B2&!B1&!B&A2&A1&A|!D1&D&!C&B2&!B1&!B&A2&A1&A|!D1&D&C&B2&!B1&!B&A2&A1&A|D1&D&C&B2&!B1&!B&A2&A1&A|D1&!D&C&B2&!B1&!B&A2&A1&A|D1&!D&C&!B2&!B1&!B&A2&A1&A|D1&D&C&!B2&!B1&!B&A2&A1&A|!D1&D&C&!B2&!B1&!B&A2&A1&A|!D1&D&!C&!B2&!B1&!B&A2&A1&A|D1&D&!C&!B2&!B1&!B&A2&A1&A|D1&!D&!C&!B2&!B1&!B&A2&A1&A|!D1&D&C&!B2&!B1&!B&A2&!A1&A|D1&D&C&!B2&!B1&!B&A2&!A1&A|D1&!D&C&!B2&!B1&!B&A2&!A1&A|D1&!D&C&B2&!B1&!B&A2&!A1&A|D1&D&C&B2&!B1&!B&A2&!A1&A|!D1&D&C&B2&!B1&!B&A2&!A1&A|!D1&D&C&B2&B1&!B&A2&!A1&A|D1&D&C&B2&B1&!B&A2&!A1&A|D1&!D&C&B2&B1&!B&A2&!A1&A|D1&!D&C&!B2&B1&!B&A2&!A1&A|D1&D&C&!B2&B1&!B&A2&!A1&A|!D1&D&C&!B2&B1&!B&A2&!A1&A|!D1&D&C&!B2&B1&B&A2&!A1&A|D1&D&C&!B2&B1&B&A2&!A1&A|D1&!D&C&!B2&B1&B&A2&!A1&A|D1&!D&C&B2&B1&B&A2&!A1&A|D1&D&C&B2&B1&B&A2&!A1&A|!D1&D&C&B2&B1&B&A2&!A1&A|!D1&D&!C&B2&B1&B&A2&!A1&A|D1&D&!C&B2&B1&B&A2&!A1&A|D1&!D&!C&B2&B1&B&A2&!A1&A|!D1&D&C&B2&!B1&B&A2&!A1&A|D1&D&C&B2&!B1&B&A2&!A1&A|D1&!D&C&B2&!B1&B&A2&!A1&A|D1&!D&C&!B2&!B1&B&A2&!A1&A|D1&D&C&!B2&!B1&B&A2&!A1&A|!D1&D&C&!B2&!B1&B&A2&!A1&A|!D1&D&C&!B2&!B1&B&!A2&!A1&A|D1&D&C&!B2&!B1&B&!A2&!A1&A|D1&!D&C&!B2&!B1&B&!A2&!A1&A|D1&!D&C&B2&!B1&B&!A2&!A1&A|D1&D&C&B2&!B1&B&!A2&!A1&A|!D1&D&C&B2&!B1&B&!A2&!A1&A|D1&!D&!C&B2&B1&B&!A2&!A1&A|D1&D&!C&B2&B1&B&!A2&!A1&A|!D1&D&!C&B2&B1&B&!A2&!A1&A|!D1&D&C&B2&B1&B&!A2&!A1&A|D1&D&C&B2&B1&B&!A2&!A1&A|D1&!D&C&B2&B1&B&!A2&!A1&A|D1&!D&C&!B2&B1&B&!A2&!A1&A|D1&D&C&!B2&B1&B&!A2&!A1&A|!D1&D&C&!B2&B1&B&!A2&!A1&A|!D1&D&C&!B2&B1&!B&!A2&!A1&A|D1&D&C&!B2&B1&!B&!A2&!A1&A|D1&!D&C&!B2&B1&!B&!A2&!A1&A|D1&!D&C&B2&B1&!B&!A2&!A1&A|D1&D&C&B2&B1&!B&!A2&!A1&A|!D1&D&C&B2&B1&!B&!A2&!A1&A|!D1&D&C&B2&!B1&!B&!A2&!A1&A|D1&D&C&B2&!B1&!B&!A2&!A1&A|D1&!D&C&B2&!B1&!B&!A2&!A1&A|D1&!D&C&!B2&!B1&!B&!A2&!A1&A|D1&D&C&!B2&!B1&!B&!A2&!A1&A|!D1&D&C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAI3312.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAAOI22231 -l AAOOAAOI22231 -i E D2 D1 D C1 C B1 B A1 A -o Y -f Y=(!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|!E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|!E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|!E&D2&!D1&D&C1&C&B1&!B&!A1&!A|!E&!D2&D1&D&C1&C&B1&!B&!A1&!A|!E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|!E&D2&D1&!D&C1&C&B1&!B&!A1&!A|!E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|!E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|!E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|!E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|!E&D2&!D1&D&C1&C&!B1&B&!A1&!A|!E&!D2&D1&D&C1&C&!B1&B&!A1&!A|!E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|!E&D2&D1&!D&C1&C&!B1&B&!A1&!A|!E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|!E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|!E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|!E&D2&!D1&D&C1&!C&!B1&B&A1&!A|!E&!D2&D1&D&C1&!C&!B1&B&A1&!A|!E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|!E&D2&D1&!D&C1&!C&!B1&B&A1&!A|!E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|!E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|!E&D2&!D1&!D&C1&C&!B1&B&A1&!A|!E&D2&D1&!D&C1&C&!B1&B&A1&!A|!E&!D2&D1&!D&C1&C&!B1&B&A1&!A|!E&!D2&D1&D&C1&C&!B1&B&A1&!A|!E&D2&!D1&D&C1&C&!B1&B&A1&!A|!E&!D2&!D1&D&C1&C&!B1&B&A1&!A|!E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|!E&D2&!D1&D&!C1&C&!B1&B&A1&!A|!E&!D2&D1&D&!C1&C&!B1&B&A1&!A|!E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|!E&D2&D1&!D&!C1&C&!B1&B&A1&!A|!E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|!E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|!E&D2&!D1&D&!C1&!C&B1&B&A1&!A|!E&!D2&D1&D&!C1&!C&B1&B&A1&!A|!E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|!E&D2&D1&!D&!C1&!C&B1&B&A1&!A|!E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|!E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|!E&D2&!D1&D&C1&!C&B1&!B&A1&!A|!E&!D2&D1&D&C1&!C&B1&!B&A1&!A|!E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|!E&D2&D1&!D&C1&!C&B1&!B&A1&!A|!E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|!E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|!E&D2&!D1&!D&C1&C&B1&!B&A1&!A|!E&D2&D1&!D&C1&C&B1&!B&A1&!A|!E&!D2&D1&!D&C1&C&B1&!B&A1&!A|!E&!D2&D1&D&C1&C&B1&!B&A1&!A|!E&D2&!D1&D&C1&C&B1&!B&A1&!A|!E&!D2&!D1&D&C1&C&B1&!B&A1&!A|!E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|!E&D2&!D1&D&!C1&C&B1&!B&A1&!A|!E&!D2&D1&D&!C1&C&B1&!B&A1&!A|!E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|!E&D2&D1&!D&!C1&C&B1&!B&A1&!A|!E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|!E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|!E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|!E&D2&!D1&D&C1&C&!B1&!B&A1&!A|!E&!D2&D1&D&C1&C&!B1&!B&A1&!A|!E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|!E&D2&D1&!D&C1&C&!B1&!B&A1&!A|!E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|!E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|!E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|!E&D2&!D1&D&!C1&!C&B1&!B&A1&A|!E&!D2&D1&D&!C1&!C&B1&!B&A1&A|!E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|!E&D2&D1&!D&!C1&!C&B1&!B&A1&A|!E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!E&D2&!D1&!D&!C1&!C&B1&B&A1&A|!E&D2&D1&!D&!C1&!C&B1&B&A1&A|!E&!D2&D1&!D&!C1&!C&B1&B&A1&A|!E&!D2&D1&D&!C1&!C&B1&B&A1&A|!E&D2&!D1&D&!C1&!C&B1&B&A1&A|!E&!D2&!D1&D&!C1&!C&B1&B&A1&A|!E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|!E&D2&!D1&D&!C1&!C&!B1&B&A1&A|!E&!D2&D1&D&!C1&!C&!B1&B&A1&A|!E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|!E&D2&D1&!D&!C1&!C&!B1&B&A1&A|!E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|!E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|!E&D2&!D1&D&C1&!C&!B1&B&!A1&A|!E&!D2&D1&D&C1&!C&!B1&B&!A1&A|!E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|!E&D2&D1&!D&C1&!C&!B1&B&!A1&A|!E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|!E&D2&!D1&!D&C1&C&!B1&B&!A1&A|!E&D2&D1&!D&C1&C&!B1&B&!A1&A|!E&!D2&D1&!D&C1&C&!B1&B&!A1&A|!E&!D2&D1&D&C1&C&!B1&B&!A1&A|!E&D2&!D1&D&C1&C&!B1&B&!A1&A|!E&!D2&!D1&D&C1&C&!B1&B&!A1&A|!E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|!E&D2&!D1&D&!C1&C&!B1&B&!A1&A|!E&!D2&D1&D&!C1&C&!B1&B&!A1&A|!E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|!E&D2&D1&!D&!C1&C&!B1&B&!A1&A|!E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|!E&D2&!D1&D&!C1&!C&B1&B&!A1&A|!E&!D2&D1&D&!C1&!C&B1&B&!A1&A|!E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|!E&D2&D1&!D&!C1&!C&B1&B&!A1&A|!E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|!E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|!E&D2&!D1&D&C1&!C&B1&!B&!A1&A|!E&!D2&D1&D&C1&!C&B1&!B&!A1&A|!E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|!E&D2&D1&!D&C1&!C&B1&!B&!A1&A|!E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|!E&D2&!D1&!D&C1&C&B1&!B&!A1&A|!E&D2&D1&!D&C1&C&B1&!B&!A1&A|!E&!D2&D1&!D&C1&C&B1&!B&!A1&A|!E&!D2&D1&D&C1&C&B1&!B&!A1&A|!E&D2&!D1&D&C1&C&B1&!B&!A1&A|!E&!D2&!D1&D&C1&C&B1&!B&!A1&A|!E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|!E&D2&!D1&D&!C1&C&B1&!B&!A1&A|!E&!D2&D1&D&!C1&C&B1&!B&!A1&A|!E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|!E&D2&D1&!D&!C1&C&B1&!B&!A1&A|!E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|!E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|!E&D2&!D1&D&C1&C&!B1&!B&!A1&A|!E&!D2&D1&D&C1&C&!B1&!B&!A1&A|!E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|!E&D2&D1&!D&C1&C&!B1&!B&!A1&A|!E&D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|!E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAAOI22231.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAAOI21132 -l OAOOAAOI21132 -i E1 E D2 D1 D C B A1 A -o Y -f Y=(!E1&!E&!D2&!D1&!D&!C&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C&!B&!A1&!A|!E1&E&D2&!D1&!D&!C&!B&!A1&!A|E1&!E&D2&!D1&!D&!C&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C&!B&!A1&!A|!E1&!E&D2&D1&!D&!C&!B&!A1&!A|E1&!E&D2&D1&!D&!C&!B&!A1&!A|!E1&E&D2&D1&!D&!C&!B&!A1&!A|!E1&E&!D2&D1&!D&!C&!B&!A1&!A|E1&!E&!D2&D1&!D&!C&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C&!B&!A1&!A|!E1&!E&!D2&D1&D&!C&!B&!A1&!A|E1&!E&!D2&D1&D&!C&!B&!A1&!A|!E1&E&!D2&D1&D&!C&!B&!A1&!A|!E1&E&D2&D1&D&!C&!B&!A1&!A|E1&!E&D2&D1&D&!C&!B&!A1&!A|!E1&!E&D2&D1&D&!C&!B&!A1&!A|!E1&!E&D2&!D1&D&!C&!B&!A1&!A|E1&!E&D2&!D1&D&!C&!B&!A1&!A|!E1&E&D2&!D1&D&!C&!B&!A1&!A|!E1&E&!D2&!D1&D&!C&!B&!A1&!A|E1&!E&!D2&!D1&D&!C&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C&!B&!A1&!A|!E1&E&!D2&!D1&!D&C&!B&!A1&!A|E1&!E&!D2&!D1&!D&C&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C&B&!A1&!A|E1&!E&!D2&!D1&!D&C&B&!A1&!A|!E1&E&!D2&!D1&!D&C&B&!A1&!A|!E1&!E&!D2&!D1&D&!C&B&!A1&!A|E1&!E&!D2&!D1&D&!C&B&!A1&!A|!E1&E&!D2&!D1&D&!C&B&!A1&!A|!E1&E&D2&!D1&D&!C&B&!A1&!A|E1&!E&D2&!D1&D&!C&B&!A1&!A|!E1&!E&D2&!D1&D&!C&B&!A1&!A|!E1&!E&D2&D1&D&!C&B&!A1&!A|E1&!E&D2&D1&D&!C&B&!A1&!A|!E1&E&D2&D1&D&!C&B&!A1&!A|!E1&E&!D2&D1&D&!C&B&!A1&!A|E1&!E&!D2&D1&D&!C&B&!A1&!A|!E1&!E&!D2&D1&D&!C&B&!A1&!A|!E1&!E&!D2&D1&!D&!C&B&!A1&!A|E1&!E&!D2&D1&!D&!C&B&!A1&!A|!E1&E&!D2&D1&!D&!C&B&!A1&!A|!E1&E&D2&D1&!D&!C&B&!A1&!A|E1&!E&D2&D1&!D&!C&B&!A1&!A|!E1&!E&D2&D1&!D&!C&B&!A1&!A|!E1&!E&D2&!D1&!D&!C&B&!A1&!A|E1&!E&D2&!D1&!D&!C&B&!A1&!A|!E1&E&D2&!D1&!D&!C&B&!A1&!A|!E1&E&!D2&!D1&!D&!C&B&!A1&!A|E1&!E&!D2&!D1&!D&!C&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C&B&A1&!A|E1&!E&!D2&!D1&!D&!C&B&A1&!A|!E1&E&!D2&!D1&!D&!C&B&A1&!A|!E1&E&!D2&!D1&!D&C&B&A1&!A|E1&!E&!D2&!D1&!D&C&B&A1&!A|!E1&!E&!D2&!D1&!D&C&B&A1&!A|!E1&!E&!D2&!D1&!D&C&!B&A1&!A|E1&!E&!D2&!D1&!D&C&!B&A1&!A|!E1&E&!D2&!D1&!D&C&!B&A1&!A|!E1&!E&!D2&!D1&D&!C&!B&A1&!A|E1&!E&!D2&!D1&D&!C&!B&A1&!A|!E1&E&!D2&!D1&D&!C&!B&A1&!A|!E1&E&D2&!D1&D&!C&!B&A1&!A|E1&!E&D2&!D1&D&!C&!B&A1&!A|!E1&!E&D2&!D1&D&!C&!B&A1&!A|!E1&!E&D2&D1&D&!C&!B&A1&!A|E1&!E&D2&D1&D&!C&!B&A1&!A|!E1&E&D2&D1&D&!C&!B&A1&!A|!E1&E&!D2&D1&D&!C&!B&A1&!A|E1&!E&!D2&D1&D&!C&!B&A1&!A|!E1&!E&!D2&D1&D&!C&!B&A1&!A|!E1&!E&!D2&D1&!D&!C&!B&A1&!A|E1&!E&!D2&D1&!D&!C&!B&A1&!A|!E1&E&!D2&D1&!D&!C&!B&A1&!A|!E1&E&D2&D1&!D&!C&!B&A1&!A|E1&!E&D2&D1&!D&!C&!B&A1&!A|!E1&!E&D2&D1&!D&!C&!B&A1&!A|!E1&!E&D2&!D1&!D&!C&!B&A1&!A|E1&!E&D2&!D1&!D&!C&!B&A1&!A|!E1&E&D2&!D1&!D&!C&!B&A1&!A|!E1&E&!D2&!D1&!D&!C&!B&A1&!A|E1&!E&!D2&!D1&!D&!C&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C&!B&A1&A|E1&!E&!D2&!D1&!D&!C&!B&A1&A|!E1&E&!D2&!D1&!D&!C&!B&A1&A|!E1&E&D2&!D1&!D&!C&!B&A1&A|E1&!E&D2&!D1&!D&!C&!B&A1&A|!E1&!E&D2&!D1&!D&!C&!B&A1&A|!E1&!E&D2&D1&!D&!C&!B&A1&A|E1&!E&D2&D1&!D&!C&!B&A1&A|!E1&E&D2&D1&!D&!C&!B&A1&A|!E1&E&!D2&D1&!D&!C&!B&A1&A|E1&!E&!D2&D1&!D&!C&!B&A1&A|!E1&!E&!D2&D1&!D&!C&!B&A1&A|!E1&!E&!D2&D1&D&!C&!B&A1&A|E1&!E&!D2&D1&D&!C&!B&A1&A|!E1&E&!D2&D1&D&!C&!B&A1&A|!E1&E&D2&D1&D&!C&!B&A1&A|E1&!E&D2&D1&D&!C&!B&A1&A|!E1&!E&D2&D1&D&!C&!B&A1&A|!E1&!E&D2&!D1&D&!C&!B&A1&A|E1&!E&D2&!D1&D&!C&!B&A1&A|!E1&E&D2&!D1&D&!C&!B&A1&A|!E1&E&!D2&!D1&D&!C&!B&A1&A|E1&!E&!D2&!D1&D&!C&!B&A1&A|!E1&!E&!D2&!D1&D&!C&!B&A1&A|!E1&E&!D2&!D1&!D&C&!B&A1&A|E1&!E&!D2&!D1&!D&C&!B&A1&A|!E1&!E&!D2&!D1&!D&C&!B&A1&A|!E1&!E&!D2&!D1&!D&C&B&A1&A|E1&!E&!D2&!D1&!D&C&B&A1&A|!E1&E&!D2&!D1&!D&C&B&A1&A|!E1&E&!D2&!D1&!D&!C&B&A1&A|E1&!E&!D2&!D1&!D&!C&B&A1&A|!E1&!E&!D2&!D1&!D&!C&B&A1&A|!E1&!E&!D2&!D1&!D&!C&B&!A1&A|E1&!E&!D2&!D1&!D&!C&B&!A1&A|!E1&E&!D2&!D1&!D&!C&B&!A1&A|!E1&E&!D2&!D1&!D&C&B&!A1&A|E1&!E&!D2&!D1&!D&C&B&!A1&A|!E1&!E&!D2&!D1&!D&C&B&!A1&A|!E1&!E&!D2&!D1&!D&C&!B&!A1&A|E1&!E&!D2&!D1&!D&C&!B&!A1&A|!E1&E&!D2&!D1&!D&C&!B&!A1&A|!E1&!E&!D2&!D1&D&!C&!B&!A1&A|E1&!E&!D2&!D1&D&!C&!B&!A1&A|!E1&E&!D2&!D1&D&!C&!B&!A1&A|!E1&E&D2&!D1&D&!C&!B&!A1&A|E1&!E&D2&!D1&D&!C&!B&!A1&A|!E1&!E&D2&!D1&D&!C&!B&!A1&A|!E1&!E&D2&D1&D&!C&!B&!A1&A|E1&!E&D2&D1&D&!C&!B&!A1&A|!E1&E&D2&D1&D&!C&!B&!A1&A|!E1&E&!D2&D1&D&!C&!B&!A1&A|E1&!E&!D2&D1&D&!C&!B&!A1&A|!E1&!E&!D2&D1&D&!C&!B&!A1&A|!E1&!E&!D2&D1&!D&!C&!B&!A1&A|E1&!E&!D2&D1&!D&!C&!B&!A1&A|!E1&E&!D2&D1&!D&!C&!B&!A1&A|!E1&E&D2&D1&!D&!C&!B&!A1&A|E1&!E&D2&D1&!D&!C&!B&!A1&A|!E1&!E&D2&D1&!D&!C&!B&!A1&A|!E1&!E&D2&!D1&!D&!C&!B&!A1&A|E1&!E&D2&!D1&!D&!C&!B&!A1&A|!E1&E&D2&!D1&!D&!C&!B&!A1&A|!E1&E&!D2&!D1&!D&!C&!B&!A1&A|E1&!E&!D2&!D1&!D&!C&!B&!A1&A|!E1&!E&!D2&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAAOI21132.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOOAI22231 -l AAAOOAI22231 -i E D2 D1 D C1 C B1 B A1 A -o Y -f Y=!(E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|E&D2&D1&D&C1&C&!B1&!B&!A1&!A|E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|E&D2&!D1&D&C1&C&B1&!B&!A1&!A|E&D2&D1&D&C1&C&B1&!B&!A1&!A|E&!D2&D1&D&C1&C&B1&!B&!A1&!A|E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|E&D2&D1&!D&C1&C&B1&!B&!A1&!A|E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|E&D2&D1&D&!C1&!C&B1&B&!A1&!A|E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|E&!D2&!D1&D&C1&!C&B1&B&!A1&!A|E&D2&!D1&D&C1&!C&B1&B&!A1&!A|E&D2&D1&D&C1&!C&B1&B&!A1&!A|E&!D2&D1&D&C1&!C&B1&B&!A1&!A|E&!D2&D1&!D&C1&!C&B1&B&!A1&!A|E&D2&D1&!D&C1&!C&B1&B&!A1&!A|E&D2&!D1&!D&C1&!C&B1&B&!A1&!A|E&D2&!D1&!D&C1&C&B1&B&!A1&!A|E&D2&D1&!D&C1&C&B1&B&!A1&!A|E&!D2&D1&!D&C1&C&B1&B&!A1&!A|E&!D2&D1&D&C1&C&B1&B&!A1&!A|E&D2&D1&D&C1&C&B1&B&!A1&!A|E&D2&!D1&D&C1&C&B1&B&!A1&!A|E&!D2&!D1&D&C1&C&B1&B&!A1&!A|E&!D2&!D1&D&!C1&C&B1&B&!A1&!A|E&D2&!D1&D&!C1&C&B1&B&!A1&!A|E&D2&D1&D&!C1&C&B1&B&!A1&!A|E&!D2&D1&D&!C1&C&B1&B&!A1&!A|E&!D2&D1&!D&!C1&C&B1&B&!A1&!A|E&D2&D1&!D&!C1&C&B1&B&!A1&!A|E&D2&!D1&!D&!C1&C&B1&B&!A1&!A|E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|E&D2&!D1&D&C1&C&!B1&B&!A1&!A|E&D2&D1&D&C1&C&!B1&B&!A1&!A|E&!D2&D1&D&C1&C&!B1&B&!A1&!A|E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|E&D2&D1&!D&C1&C&!B1&B&!A1&!A|E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|E&D2&!D1&!D&C1&C&!B1&B&A1&!A|E&D2&D1&!D&C1&C&!B1&B&A1&!A|E&!D2&D1&!D&C1&C&!B1&B&A1&!A|E&!D2&D1&D&C1&C&!B1&B&A1&!A|E&D2&D1&D&C1&C&!B1&B&A1&!A|E&D2&!D1&D&C1&C&!B1&B&A1&!A|E&!D2&!D1&D&C1&C&!B1&B&A1&!A|E&D2&!D1&!D&!C1&C&B1&B&A1&!A|E&D2&D1&!D&!C1&C&B1&B&A1&!A|E&!D2&D1&!D&!C1&C&B1&B&A1&!A|E&!D2&D1&D&!C1&C&B1&B&A1&!A|E&D2&D1&D&!C1&C&B1&B&A1&!A|E&D2&!D1&D&!C1&C&B1&B&A1&!A|E&!D2&!D1&D&!C1&C&B1&B&A1&!A|E&!D2&!D1&D&C1&C&B1&B&A1&!A|E&D2&!D1&D&C1&C&B1&B&A1&!A|E&D2&D1&D&C1&C&B1&B&A1&!A|E&!D2&D1&D&C1&C&B1&B&A1&!A|E&!D2&D1&!D&C1&C&B1&B&A1&!A|E&D2&D1&!D&C1&C&B1&B&A1&!A|E&D2&!D1&!D&C1&C&B1&B&A1&!A|E&D2&!D1&!D&C1&!C&B1&B&A1&!A|E&D2&D1&!D&C1&!C&B1&B&A1&!A|E&!D2&D1&!D&C1&!C&B1&B&A1&!A|E&!D2&D1&D&C1&!C&B1&B&A1&!A|E&D2&D1&D&C1&!C&B1&B&A1&!A|E&D2&!D1&D&C1&!C&B1&B&A1&!A|E&!D2&!D1&D&C1&!C&B1&B&A1&!A|E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|E&D2&!D1&D&!C1&!C&B1&B&A1&!A|E&D2&D1&D&!C1&!C&B1&B&A1&!A|E&!D2&D1&D&!C1&!C&B1&B&A1&!A|E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|E&D2&D1&!D&!C1&!C&B1&B&A1&!A|E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|E&D2&!D1&!D&C1&C&B1&!B&A1&!A|E&D2&D1&!D&C1&C&B1&!B&A1&!A|E&!D2&D1&!D&C1&C&B1&!B&A1&!A|E&!D2&D1&D&C1&C&B1&!B&A1&!A|E&D2&D1&D&C1&C&B1&!B&A1&!A|E&D2&!D1&D&C1&C&B1&!B&A1&!A|E&!D2&!D1&D&C1&C&B1&!B&A1&!A|E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|E&D2&!D1&D&C1&C&!B1&!B&A1&!A|E&D2&D1&D&C1&C&!B1&!B&A1&!A|E&!D2&D1&D&C1&C&!B1&!B&A1&!A|E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|E&D2&D1&!D&C1&C&!B1&!B&A1&!A|E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|E&D2&D1&D&!C1&!C&!B1&!B&A1&A|E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|E&!D2&!D1&D&C1&!C&!B1&!B&A1&A|E&D2&!D1&D&C1&!C&!B1&!B&A1&A|E&D2&D1&D&C1&!C&!B1&!B&A1&A|E&!D2&D1&D&C1&!C&!B1&!B&A1&A|E&!D2&D1&!D&C1&!C&!B1&!B&A1&A|E&D2&D1&!D&C1&!C&!B1&!B&A1&A|E&D2&!D1&!D&C1&!C&!B1&!B&A1&A|E&D2&!D1&!D&C1&C&!B1&!B&A1&A|E&D2&D1&!D&C1&C&!B1&!B&A1&A|E&!D2&D1&!D&C1&C&!B1&!B&A1&A|E&!D2&D1&D&C1&C&!B1&!B&A1&A|E&D2&D1&D&C1&C&!B1&!B&A1&A|E&D2&!D1&D&C1&C&!B1&!B&A1&A|E&!D2&!D1&D&C1&C&!B1&!B&A1&A|E&!D2&!D1&D&!C1&C&!B1&!B&A1&A|E&D2&!D1&D&!C1&C&!B1&!B&A1&A|E&D2&D1&D&!C1&C&!B1&!B&A1&A|E&!D2&D1&D&!C1&C&!B1&!B&A1&A|E&!D2&D1&!D&!C1&C&!B1&!B&A1&A|E&D2&D1&!D&!C1&C&!B1&!B&A1&A|E&D2&!D1&!D&!C1&C&!B1&!B&A1&A|E&D2&!D1&!D&!C1&C&B1&!B&A1&A|E&D2&D1&!D&!C1&C&B1&!B&A1&A|E&!D2&D1&!D&!C1&C&B1&!B&A1&A|E&!D2&D1&D&!C1&C&B1&!B&A1&A|E&D2&D1&D&!C1&C&B1&!B&A1&A|E&D2&!D1&D&!C1&C&B1&!B&A1&A|E&!D2&!D1&D&!C1&C&B1&!B&A1&A|E&!D2&!D1&D&C1&C&B1&!B&A1&A|E&D2&!D1&D&C1&C&B1&!B&A1&A|E&D2&D1&D&C1&C&B1&!B&A1&A|E&!D2&D1&D&C1&C&B1&!B&A1&A|E&!D2&D1&!D&C1&C&B1&!B&A1&A|E&D2&D1&!D&C1&C&B1&!B&A1&A|E&D2&!D1&!D&C1&C&B1&!B&A1&A|E&D2&!D1&!D&C1&!C&B1&!B&A1&A|E&D2&D1&!D&C1&!C&B1&!B&A1&A|E&!D2&D1&!D&C1&!C&B1&!B&A1&A|E&!D2&D1&D&C1&!C&B1&!B&A1&A|E&D2&D1&D&C1&!C&B1&!B&A1&A|E&D2&!D1&D&C1&!C&B1&!B&A1&A|E&!D2&!D1&D&C1&!C&B1&!B&A1&A|E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|E&D2&!D1&D&!C1&!C&B1&!B&A1&A|E&D2&D1&D&!C1&!C&B1&!B&A1&A|E&!D2&D1&D&!C1&!C&B1&!B&A1&A|E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|E&D2&D1&!D&!C1&!C&B1&!B&A1&A|E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|E&D2&!D1&!D&!C1&!C&B1&B&A1&A|E&D2&D1&!D&!C1&!C&B1&B&A1&A|E&!D2&D1&!D&!C1&!C&B1&B&A1&A|E&!D2&D1&D&!C1&!C&B1&B&A1&A|E&D2&D1&D&!C1&!C&B1&B&A1&A|E&D2&!D1&D&!C1&!C&B1&B&A1&A|E&!D2&!D1&D&!C1&!C&B1&B&A1&A|E&!D2&!D1&D&C1&!C&B1&B&A1&A|E&D2&!D1&D&C1&!C&B1&B&A1&A|E&D2&D1&D&C1&!C&B1&B&A1&A|E&!D2&D1&D&C1&!C&B1&B&A1&A|E&!D2&D1&!D&C1&!C&B1&B&A1&A|E&D2&D1&!D&C1&!C&B1&B&A1&A|E&D2&!D1&!D&C1&!C&B1&B&A1&A|E&D2&!D1&!D&C1&C&B1&B&A1&A|E&D2&D1&!D&C1&C&B1&B&A1&A|E&!D2&D1&!D&C1&C&B1&B&A1&A|E&!D2&D1&D&C1&C&B1&B&A1&A|E&D2&D1&D&C1&C&B1&B&A1&A|E&D2&!D1&D&C1&C&B1&B&A1&A|E&!D2&!D1&D&C1&C&B1&B&A1&A|E&!D2&!D1&D&!C1&C&B1&B&A1&A|E&D2&!D1&D&!C1&C&B1&B&A1&A|E&D2&D1&D&!C1&C&B1&B&A1&A|E&!D2&D1&D&!C1&C&B1&B&A1&A|E&!D2&D1&!D&!C1&C&B1&B&A1&A|E&D2&D1&!D&!C1&C&B1&B&A1&A|E&D2&!D1&!D&!C1&C&B1&B&A1&A|E&D2&!D1&!D&!C1&C&!B1&B&A1&A|E&D2&D1&!D&!C1&C&!B1&B&A1&A|E&!D2&D1&!D&!C1&C&!B1&B&A1&A|E&!D2&D1&D&!C1&C&!B1&B&A1&A|E&D2&D1&D&!C1&C&!B1&B&A1&A|E&D2&!D1&D&!C1&C&!B1&B&A1&A|E&!D2&!D1&D&!C1&C&!B1&B&A1&A|E&!D2&!D1&D&C1&C&!B1&B&A1&A|E&D2&!D1&D&C1&C&!B1&B&A1&A|E&D2&D1&D&C1&C&!B1&B&A1&A|E&!D2&D1&D&C1&C&!B1&B&A1&A|E&!D2&D1&!D&C1&C&!B1&B&A1&A|E&D2&D1&!D&C1&C&!B1&B&A1&A|E&D2&!D1&!D&C1&C&!B1&B&A1&A|E&D2&!D1&!D&C1&!C&!B1&B&A1&A|E&D2&D1&!D&C1&!C&!B1&B&A1&A|E&!D2&D1&!D&C1&!C&!B1&B&A1&A|E&!D2&D1&D&C1&!C&!B1&B&A1&A|E&D2&D1&D&C1&!C&!B1&B&A1&A|E&D2&!D1&D&C1&!C&!B1&B&A1&A|E&!D2&!D1&D&C1&!C&!B1&B&A1&A|E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|E&D2&!D1&D&!C1&!C&!B1&B&A1&A|E&D2&D1&D&!C1&!C&!B1&B&A1&A|E&!D2&D1&D&!C1&!C&!B1&B&A1&A|E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|E&D2&D1&!D&!C1&!C&!B1&B&A1&A|E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|E&D2&!D1&!D&C1&C&!B1&B&!A1&A|E&D2&D1&!D&C1&C&!B1&B&!A1&A|E&!D2&D1&!D&C1&C&!B1&B&!A1&A|E&!D2&D1&D&C1&C&!B1&B&!A1&A|E&D2&D1&D&C1&C&!B1&B&!A1&A|E&D2&!D1&D&C1&C&!B1&B&!A1&A|E&!D2&!D1&D&C1&C&!B1&B&!A1&A|E&D2&!D1&!D&!C1&C&B1&B&!A1&A|E&D2&D1&!D&!C1&C&B1&B&!A1&A|E&!D2&D1&!D&!C1&C&B1&B&!A1&A|E&!D2&D1&D&!C1&C&B1&B&!A1&A|E&D2&D1&D&!C1&C&B1&B&!A1&A|E&D2&!D1&D&!C1&C&B1&B&!A1&A|E&!D2&!D1&D&!C1&C&B1&B&!A1&A|E&!D2&!D1&D&C1&C&B1&B&!A1&A|E&D2&!D1&D&C1&C&B1&B&!A1&A|E&D2&D1&D&C1&C&B1&B&!A1&A|E&!D2&D1&D&C1&C&B1&B&!A1&A|E&!D2&D1&!D&C1&C&B1&B&!A1&A|E&D2&D1&!D&C1&C&B1&B&!A1&A|E&D2&!D1&!D&C1&C&B1&B&!A1&A|E&D2&!D1&!D&C1&!C&B1&B&!A1&A|E&D2&D1&!D&C1&!C&B1&B&!A1&A|E&!D2&D1&!D&C1&!C&B1&B&!A1&A|E&!D2&D1&D&C1&!C&B1&B&!A1&A|E&D2&D1&D&C1&!C&B1&B&!A1&A|E&D2&!D1&D&C1&!C&B1&B&!A1&A|E&!D2&!D1&D&C1&!C&B1&B&!A1&A|E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|E&D2&!D1&D&!C1&!C&B1&B&!A1&A|E&D2&D1&D&!C1&!C&B1&B&!A1&A|E&!D2&D1&D&!C1&!C&B1&B&!A1&A|E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|E&D2&D1&!D&!C1&!C&B1&B&!A1&A|E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|E&D2&!D1&!D&C1&C&B1&!B&!A1&A|E&D2&D1&!D&C1&C&B1&!B&!A1&A|E&!D2&D1&!D&C1&C&B1&!B&!A1&A|E&!D2&D1&D&C1&C&B1&!B&!A1&A|E&D2&D1&D&C1&C&B1&!B&!A1&A|E&D2&!D1&D&C1&C&B1&!B&!A1&A|E&!D2&!D1&D&C1&C&B1&!B&!A1&A|E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|E&D2&!D1&D&C1&C&!B1&!B&!A1&A|E&D2&D1&D&C1&C&!B1&!B&!A1&A|E&!D2&D1&D&C1&C&!B1&!B&!A1&A|E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|E&D2&D1&!D&C1&C&!B1&!B&!A1&A|E&D2&!D1&!D&C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOOAI22231.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOOAI2224 -l AAAOOAI2224 -i D3 D2 D1 D C1 C B1 B A1 A -o Y -f Y=(!D3&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|D3&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|D3&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!D3&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!D3&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|D3&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|D3&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!D3&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!D3&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|D3&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|D3&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!D3&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!D3&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|D3&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|D3&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!D3&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!D3&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|D3&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|D3&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!D3&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!D3&D2&D1&D&C1&!C&!B1&!B&!A1&!A|D3&D2&D1&D&C1&!C&!B1&!B&!A1&!A|D3&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!D3&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!D3&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|D3&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|D3&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!D3&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!D3&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|D3&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|D3&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!D3&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!D3&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!D3&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|D3&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|D3&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!D3&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!D3&D2&D1&D&!C1&C&!B1&!B&!A1&!A|D3&D2&D1&D&!C1&C&!B1&!B&!A1&!A|D3&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!D3&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!D3&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|D3&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|D3&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!D3&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!D3&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|D3&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|D3&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!D3&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!D3&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|D3&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|D3&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!D3&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!D3&D2&D1&!D&!C1&C&B1&!B&!A1&!A|D3&D2&D1&!D&!C1&C&B1&!B&!A1&!A|D3&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!D3&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!D3&!D2&D1&D&!C1&C&B1&!B&!A1&!A|D3&!D2&D1&D&!C1&C&B1&!B&!A1&!A|D3&D2&D1&D&!C1&C&B1&!B&!A1&!A|!D3&D2&D1&D&!C1&C&B1&!B&!A1&!A|!D3&D2&!D1&D&!C1&C&B1&!B&!A1&!A|D3&D2&!D1&D&!C1&C&B1&!B&!A1&!A|D3&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!D3&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!D3&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!D3&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|D3&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|D3&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!D3&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!D3&D2&D1&!D&C1&!C&B1&!B&!A1&!A|D3&D2&D1&!D&C1&!C&B1&!B&!A1&!A|D3&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!D3&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!D3&!D2&D1&D&C1&!C&B1&!B&!A1&!A|D3&!D2&D1&D&C1&!C&B1&!B&!A1&!A|D3&D2&D1&D&C1&!C&B1&!B&!A1&!A|!D3&D2&D1&D&C1&!C&B1&!B&!A1&!A|!D3&D2&!D1&D&C1&!C&B1&!B&!A1&!A|D3&D2&!D1&D&C1&!C&B1&!B&!A1&!A|D3&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!D3&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!D3&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|D3&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|D3&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!D3&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!D3&D2&D1&D&!C1&!C&B1&!B&!A1&!A|D3&D2&D1&D&!C1&!C&B1&!B&!A1&!A|D3&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!D3&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!D3&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|D3&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|D3&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!D3&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!D3&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|D3&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|D3&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!D3&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!D3&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!D3&!D2&!D1&!D&C1&!C&B1&B&!A1&!A|!D3&!D2&!D1&!D&C1&C&B1&B&!A1&!A|!D3&!D2&!D1&!D&!C1&C&B1&B&!A1&!A|!D3&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|D3&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|D3&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!D3&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!D3&D2&D1&!D&!C1&C&!B1&B&!A1&!A|D3&D2&D1&!D&!C1&C&!B1&B&!A1&!A|D3&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!D3&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!D3&!D2&D1&D&!C1&C&!B1&B&!A1&!A|D3&!D2&D1&D&!C1&C&!B1&B&!A1&!A|D3&D2&D1&D&!C1&C&!B1&B&!A1&!A|!D3&D2&D1&D&!C1&C&!B1&B&!A1&!A|!D3&D2&!D1&D&!C1&C&!B1&B&!A1&!A|D3&D2&!D1&D&!C1&C&!B1&B&!A1&!A|D3&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!D3&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!D3&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!D3&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|D3&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|D3&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!D3&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!D3&D2&D1&!D&C1&!C&!B1&B&!A1&!A|D3&D2&D1&!D&C1&!C&!B1&B&!A1&!A|D3&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!D3&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!D3&!D2&D1&D&C1&!C&!B1&B&!A1&!A|D3&!D2&D1&D&C1&!C&!B1&B&!A1&!A|D3&D2&D1&D&C1&!C&!B1&B&!A1&!A|!D3&D2&D1&D&C1&!C&!B1&B&!A1&!A|!D3&D2&!D1&D&C1&!C&!B1&B&!A1&!A|D3&D2&!D1&D&C1&!C&!B1&B&!A1&!A|D3&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!D3&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!D3&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|D3&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|D3&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!D3&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!D3&D2&D1&D&!C1&!C&!B1&B&!A1&!A|D3&D2&D1&D&!C1&!C&!B1&B&!A1&!A|D3&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!D3&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!D3&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|D3&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|D3&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!D3&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!D3&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|D3&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|D3&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!D3&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!D3&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|D3&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|D3&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!D3&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!D3&D2&D1&!D&!C1&!C&!B1&B&A1&!A|D3&D2&D1&!D&!C1&!C&!B1&B&A1&!A|D3&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|!D3&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|!D3&!D2&D1&D&!C1&!C&!B1&B&A1&!A|D3&!D2&D1&D&!C1&!C&!B1&B&A1&!A|D3&D2&D1&D&!C1&!C&!B1&B&A1&!A|!D3&D2&D1&D&!C1&!C&!B1&B&A1&!A|!D3&D2&!D1&D&!C1&!C&!B1&B&A1&!A|D3&D2&!D1&D&!C1&!C&!B1&B&A1&!A|D3&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|!D3&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|!D3&!D2&!D1&D&C1&!C&!B1&B&A1&!A|D3&!D2&!D1&D&C1&!C&!B1&B&A1&!A|D3&D2&!D1&D&C1&!C&!B1&B&A1&!A|!D3&D2&!D1&D&C1&!C&!B1&B&A1&!A|!D3&D2&D1&D&C1&!C&!B1&B&A1&!A|D3&D2&D1&D&C1&!C&!B1&B&A1&!A|D3&!D2&D1&D&C1&!C&!B1&B&A1&!A|!D3&!D2&D1&D&C1&!C&!B1&B&A1&!A|!D3&!D2&D1&!D&C1&!C&!B1&B&A1&!A|D3&!D2&D1&!D&C1&!C&!B1&B&A1&!A|D3&D2&D1&!D&C1&!C&!B1&B&A1&!A|!D3&D2&D1&!D&C1&!C&!B1&B&A1&!A|!D3&D2&!D1&!D&C1&!C&!B1&B&A1&!A|D3&D2&!D1&!D&C1&!C&!B1&B&A1&!A|D3&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!D3&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!D3&!D2&!D1&!D&C1&C&!B1&B&A1&!A|!D3&!D2&!D1&D&!C1&C&!B1&B&A1&!A|D3&!D2&!D1&D&!C1&C&!B1&B&A1&!A|D3&D2&!D1&D&!C1&C&!B1&B&A1&!A|!D3&D2&!D1&D&!C1&C&!B1&B&A1&!A|!D3&D2&D1&D&!C1&C&!B1&B&A1&!A|D3&D2&D1&D&!C1&C&!B1&B&A1&!A|D3&!D2&D1&D&!C1&C&!B1&B&A1&!A|!D3&!D2&D1&D&!C1&C&!B1&B&A1&!A|!D3&!D2&D1&!D&!C1&C&!B1&B&A1&!A|D3&!D2&D1&!D&!C1&C&!B1&B&A1&!A|D3&D2&D1&!D&!C1&C&!B1&B&A1&!A|!D3&D2&D1&!D&!C1&C&!B1&B&A1&!A|!D3&D2&!D1&!D&!C1&C&!B1&B&A1&!A|D3&D2&!D1&!D&!C1&C&!B1&B&A1&!A|D3&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!D3&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!D3&!D2&!D1&!D&!C1&C&B1&B&A1&!A|!D3&!D2&!D1&!D&C1&C&B1&B&A1&!A|!D3&!D2&!D1&!D&C1&!C&B1&B&A1&!A|!D3&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!D3&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|D3&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|D3&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!D3&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!D3&D2&D1&!D&!C1&!C&B1&!B&A1&!A|D3&D2&D1&!D&!C1&!C&B1&!B&A1&!A|D3&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|!D3&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|!D3&!D2&D1&D&!C1&!C&B1&!B&A1&!A|D3&!D2&D1&D&!C1&!C&B1&!B&A1&!A|D3&D2&D1&D&!C1&!C&B1&!B&A1&!A|!D3&D2&D1&D&!C1&!C&B1&!B&A1&!A|!D3&D2&!D1&D&!C1&!C&B1&!B&A1&!A|D3&D2&!D1&D&!C1&!C&B1&!B&A1&!A|D3&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|!D3&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|!D3&!D2&!D1&D&C1&!C&B1&!B&A1&!A|D3&!D2&!D1&D&C1&!C&B1&!B&A1&!A|D3&D2&!D1&D&C1&!C&B1&!B&A1&!A|!D3&D2&!D1&D&C1&!C&B1&!B&A1&!A|!D3&D2&D1&D&C1&!C&B1&!B&A1&!A|D3&D2&D1&D&C1&!C&B1&!B&A1&!A|D3&!D2&D1&D&C1&!C&B1&!B&A1&!A|!D3&!D2&D1&D&C1&!C&B1&!B&A1&!A|!D3&!D2&D1&!D&C1&!C&B1&!B&A1&!A|D3&!D2&D1&!D&C1&!C&B1&!B&A1&!A|D3&D2&D1&!D&C1&!C&B1&!B&A1&!A|!D3&D2&D1&!D&C1&!C&B1&!B&A1&!A|!D3&D2&!D1&!D&C1&!C&B1&!B&A1&!A|D3&D2&!D1&!D&C1&!C&B1&!B&A1&!A|D3&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!D3&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!D3&!D2&!D1&!D&C1&C&B1&!B&A1&!A|!D3&!D2&!D1&D&!C1&C&B1&!B&A1&!A|D3&!D2&!D1&D&!C1&C&B1&!B&A1&!A|D3&D2&!D1&D&!C1&C&B1&!B&A1&!A|!D3&D2&!D1&D&!C1&C&B1&!B&A1&!A|!D3&D2&D1&D&!C1&C&B1&!B&A1&!A|D3&D2&D1&D&!C1&C&B1&!B&A1&!A|D3&!D2&D1&D&!C1&C&B1&!B&A1&!A|!D3&!D2&D1&D&!C1&C&B1&!B&A1&!A|!D3&!D2&D1&!D&!C1&C&B1&!B&A1&!A|D3&!D2&D1&!D&!C1&C&B1&!B&A1&!A|D3&D2&D1&!D&!C1&C&B1&!B&A1&!A|!D3&D2&D1&!D&!C1&C&B1&!B&A1&!A|!D3&D2&!D1&!D&!C1&C&B1&!B&A1&!A|D3&D2&!D1&!D&!C1&C&B1&!B&A1&!A|D3&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!D3&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!D3&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|D3&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|D3&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!D3&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!D3&D2&D1&!D&!C1&C&!B1&!B&A1&!A|D3&D2&D1&!D&!C1&C&!B1&!B&A1&!A|D3&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!D3&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!D3&!D2&D1&D&!C1&C&!B1&!B&A1&!A|D3&!D2&D1&D&!C1&C&!B1&!B&A1&!A|D3&D2&D1&D&!C1&C&!B1&!B&A1&!A|!D3&D2&D1&D&!C1&C&!B1&!B&A1&!A|!D3&D2&!D1&D&!C1&C&!B1&!B&A1&!A|D3&D2&!D1&D&!C1&C&!B1&!B&A1&!A|D3&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!D3&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!D3&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!D3&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|D3&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|D3&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!D3&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!D3&D2&D1&!D&C1&!C&!B1&!B&A1&!A|D3&D2&D1&!D&C1&!C&!B1&!B&A1&!A|D3&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!D3&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!D3&!D2&D1&D&C1&!C&!B1&!B&A1&!A|D3&!D2&D1&D&C1&!C&!B1&!B&A1&!A|D3&D2&D1&D&C1&!C&!B1&!B&A1&!A|!D3&D2&D1&D&C1&!C&!B1&!B&A1&!A|!D3&D2&!D1&D&C1&!C&!B1&!B&A1&!A|D3&D2&!D1&D&C1&!C&!B1&!B&A1&!A|D3&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!D3&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!D3&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|D3&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|D3&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!D3&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!D3&D2&D1&D&!C1&!C&!B1&!B&A1&!A|D3&D2&D1&D&!C1&!C&!B1&!B&A1&!A|D3&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!D3&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!D3&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|D3&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|D3&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!D3&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!D3&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|D3&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|D3&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!D3&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!D3&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!D3&!D2&!D1&!D&C1&!C&!B1&!B&A1&A|!D3&!D2&!D1&!D&C1&C&!B1&!B&A1&A|!D3&!D2&!D1&!D&!C1&C&!B1&!B&A1&A|!D3&!D2&!D1&!D&!C1&C&B1&!B&A1&A|!D3&!D2&!D1&!D&C1&C&B1&!B&A1&A|!D3&!D2&!D1&!D&C1&!C&B1&!B&A1&A|!D3&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!D3&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!D3&!D2&!D1&!D&C1&!C&B1&B&A1&A|!D3&!D2&!D1&!D&C1&C&B1&B&A1&A|!D3&!D2&!D1&!D&!C1&C&B1&B&A1&A|!D3&!D2&!D1&!D&!C1&C&!B1&B&A1&A|!D3&!D2&!D1&!D&C1&C&!B1&B&A1&A|!D3&!D2&!D1&!D&C1&!C&!B1&B&A1&A|!D3&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!D3&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|D3&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|D3&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!D3&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!D3&D2&D1&!D&!C1&!C&!B1&B&!A1&A|D3&D2&D1&!D&!C1&!C&!B1&B&!A1&A|D3&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|!D3&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|!D3&!D2&D1&D&!C1&!C&!B1&B&!A1&A|D3&!D2&D1&D&!C1&!C&!B1&B&!A1&A|D3&D2&D1&D&!C1&!C&!B1&B&!A1&A|!D3&D2&D1&D&!C1&!C&!B1&B&!A1&A|!D3&D2&!D1&D&!C1&!C&!B1&B&!A1&A|D3&D2&!D1&D&!C1&!C&!B1&B&!A1&A|D3&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|!D3&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|!D3&!D2&!D1&D&C1&!C&!B1&B&!A1&A|D3&!D2&!D1&D&C1&!C&!B1&B&!A1&A|D3&D2&!D1&D&C1&!C&!B1&B&!A1&A|!D3&D2&!D1&D&C1&!C&!B1&B&!A1&A|!D3&D2&D1&D&C1&!C&!B1&B&!A1&A|D3&D2&D1&D&C1&!C&!B1&B&!A1&A|D3&!D2&D1&D&C1&!C&!B1&B&!A1&A|!D3&!D2&D1&D&C1&!C&!B1&B&!A1&A|!D3&!D2&D1&!D&C1&!C&!B1&B&!A1&A|D3&!D2&D1&!D&C1&!C&!B1&B&!A1&A|D3&D2&D1&!D&C1&!C&!B1&B&!A1&A|!D3&D2&D1&!D&C1&!C&!B1&B&!A1&A|!D3&D2&!D1&!D&C1&!C&!B1&B&!A1&A|D3&D2&!D1&!D&C1&!C&!B1&B&!A1&A|D3&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!D3&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!D3&!D2&!D1&!D&C1&C&!B1&B&!A1&A|!D3&!D2&!D1&D&!C1&C&!B1&B&!A1&A|D3&!D2&!D1&D&!C1&C&!B1&B&!A1&A|D3&D2&!D1&D&!C1&C&!B1&B&!A1&A|!D3&D2&!D1&D&!C1&C&!B1&B&!A1&A|!D3&D2&D1&D&!C1&C&!B1&B&!A1&A|D3&D2&D1&D&!C1&C&!B1&B&!A1&A|D3&!D2&D1&D&!C1&C&!B1&B&!A1&A|!D3&!D2&D1&D&!C1&C&!B1&B&!A1&A|!D3&!D2&D1&!D&!C1&C&!B1&B&!A1&A|D3&!D2&D1&!D&!C1&C&!B1&B&!A1&A|D3&D2&D1&!D&!C1&C&!B1&B&!A1&A|!D3&D2&D1&!D&!C1&C&!B1&B&!A1&A|!D3&D2&!D1&!D&!C1&C&!B1&B&!A1&A|D3&D2&!D1&!D&!C1&C&!B1&B&!A1&A|D3&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!D3&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!D3&!D2&!D1&!D&!C1&C&B1&B&!A1&A|!D3&!D2&!D1&!D&C1&C&B1&B&!A1&A|!D3&!D2&!D1&!D&C1&!C&B1&B&!A1&A|!D3&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!D3&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|D3&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|D3&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!D3&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!D3&D2&D1&!D&!C1&!C&B1&!B&!A1&A|D3&D2&D1&!D&!C1&!C&B1&!B&!A1&A|D3&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|!D3&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|!D3&!D2&D1&D&!C1&!C&B1&!B&!A1&A|D3&!D2&D1&D&!C1&!C&B1&!B&!A1&A|D3&D2&D1&D&!C1&!C&B1&!B&!A1&A|!D3&D2&D1&D&!C1&!C&B1&!B&!A1&A|!D3&D2&!D1&D&!C1&!C&B1&!B&!A1&A|D3&D2&!D1&D&!C1&!C&B1&!B&!A1&A|D3&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|!D3&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|!D3&!D2&!D1&D&C1&!C&B1&!B&!A1&A|D3&!D2&!D1&D&C1&!C&B1&!B&!A1&A|D3&D2&!D1&D&C1&!C&B1&!B&!A1&A|!D3&D2&!D1&D&C1&!C&B1&!B&!A1&A|!D3&D2&D1&D&C1&!C&B1&!B&!A1&A|D3&D2&D1&D&C1&!C&B1&!B&!A1&A|D3&!D2&D1&D&C1&!C&B1&!B&!A1&A|!D3&!D2&D1&D&C1&!C&B1&!B&!A1&A|!D3&!D2&D1&!D&C1&!C&B1&!B&!A1&A|D3&!D2&D1&!D&C1&!C&B1&!B&!A1&A|D3&D2&D1&!D&C1&!C&B1&!B&!A1&A|!D3&D2&D1&!D&C1&!C&B1&!B&!A1&A|!D3&D2&!D1&!D&C1&!C&B1&!B&!A1&A|D3&D2&!D1&!D&C1&!C&B1&!B&!A1&A|D3&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!D3&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!D3&!D2&!D1&!D&C1&C&B1&!B&!A1&A|!D3&!D2&!D1&D&!C1&C&B1&!B&!A1&A|D3&!D2&!D1&D&!C1&C&B1&!B&!A1&A|D3&D2&!D1&D&!C1&C&B1&!B&!A1&A|!D3&D2&!D1&D&!C1&C&B1&!B&!A1&A|!D3&D2&D1&D&!C1&C&B1&!B&!A1&A|D3&D2&D1&D&!C1&C&B1&!B&!A1&A|D3&!D2&D1&D&!C1&C&B1&!B&!A1&A|!D3&!D2&D1&D&!C1&C&B1&!B&!A1&A|!D3&!D2&D1&!D&!C1&C&B1&!B&!A1&A|D3&!D2&D1&!D&!C1&C&B1&!B&!A1&A|D3&D2&D1&!D&!C1&C&B1&!B&!A1&A|!D3&D2&D1&!D&!C1&C&B1&!B&!A1&A|!D3&D2&!D1&!D&!C1&C&B1&!B&!A1&A|D3&D2&!D1&!D&!C1&C&B1&!B&!A1&A|D3&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!D3&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!D3&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|D3&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|D3&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!D3&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!D3&D2&D1&!D&!C1&C&!B1&!B&!A1&A|D3&D2&D1&!D&!C1&C&!B1&!B&!A1&A|D3&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!D3&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!D3&!D2&D1&D&!C1&C&!B1&!B&!A1&A|D3&!D2&D1&D&!C1&C&!B1&!B&!A1&A|D3&D2&D1&D&!C1&C&!B1&!B&!A1&A|!D3&D2&D1&D&!C1&C&!B1&!B&!A1&A|!D3&D2&!D1&D&!C1&C&!B1&!B&!A1&A|D3&D2&!D1&D&!C1&C&!B1&!B&!A1&A|D3&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!D3&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!D3&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!D3&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|D3&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|D3&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!D3&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!D3&D2&D1&!D&C1&!C&!B1&!B&!A1&A|D3&D2&D1&!D&C1&!C&!B1&!B&!A1&A|D3&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!D3&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!D3&!D2&D1&D&C1&!C&!B1&!B&!A1&A|D3&!D2&D1&D&C1&!C&!B1&!B&!A1&A|D3&D2&D1&D&C1&!C&!B1&!B&!A1&A|!D3&D2&D1&D&C1&!C&!B1&!B&!A1&A|!D3&D2&!D1&D&C1&!C&!B1&!B&!A1&A|D3&D2&!D1&D&C1&!C&!B1&!B&!A1&A|D3&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!D3&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!D3&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|D3&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|D3&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!D3&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!D3&D2&D1&D&!C1&!C&!B1&!B&!A1&A|D3&D2&D1&D&!C1&!C&!B1&!B&!A1&A|D3&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!D3&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!D3&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|D3&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|D3&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!D3&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!D3&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|D3&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|D3&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!D3&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOOAI2224.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOAOI32211 -l AAAOAOI32211 -i E D C1 C B1 B A2 A1 A -o Y -f Y=(!E&!D&!C1&!C&!B1&!B&!A2&!A1&!A|!E&D&!C1&!C&!B1&!B&!A2&!A1&!A|!E&D&C1&!C&!B1&!B&!A2&!A1&!A|!E&!D&C1&!C&!B1&!B&!A2&!A1&!A|!E&!D&C1&C&!B1&!B&!A2&!A1&!A|!E&D&!C1&C&!B1&!B&!A2&!A1&!A|!E&!D&!C1&C&!B1&!B&!A2&!A1&!A|!E&!D&!C1&C&B1&!B&!A2&!A1&!A|!E&D&!C1&C&B1&!B&!A2&!A1&!A|!E&!D&C1&C&B1&!B&!A2&!A1&!A|!E&!D&C1&!C&B1&!B&!A2&!A1&!A|!E&D&C1&!C&B1&!B&!A2&!A1&!A|!E&D&!C1&!C&B1&!B&!A2&!A1&!A|!E&!D&!C1&!C&B1&!B&!A2&!A1&!A|!E&!D&!C1&!C&B1&B&!A2&!A1&!A|!E&!D&C1&!C&B1&B&!A2&!A1&!A|!E&!D&C1&C&B1&B&!A2&!A1&!A|!E&!D&!C1&C&B1&B&!A2&!A1&!A|!E&!D&!C1&C&!B1&B&!A2&!A1&!A|!E&D&!C1&C&!B1&B&!A2&!A1&!A|!E&!D&C1&C&!B1&B&!A2&!A1&!A|!E&!D&C1&!C&!B1&B&!A2&!A1&!A|!E&D&C1&!C&!B1&B&!A2&!A1&!A|!E&D&!C1&!C&!B1&B&!A2&!A1&!A|!E&!D&!C1&!C&!B1&B&!A2&!A1&!A|!E&!D&!C1&!C&!B1&B&A2&!A1&!A|!E&D&!C1&!C&!B1&B&A2&!A1&!A|!E&D&C1&!C&!B1&B&A2&!A1&!A|!E&!D&C1&!C&!B1&B&A2&!A1&!A|!E&!D&C1&C&!B1&B&A2&!A1&!A|!E&D&!C1&C&!B1&B&A2&!A1&!A|!E&!D&!C1&C&!B1&B&A2&!A1&!A|!E&!D&!C1&C&B1&B&A2&!A1&!A|!E&!D&C1&C&B1&B&A2&!A1&!A|!E&!D&C1&!C&B1&B&A2&!A1&!A|!E&!D&!C1&!C&B1&B&A2&!A1&!A|!E&!D&!C1&!C&B1&!B&A2&!A1&!A|!E&D&!C1&!C&B1&!B&A2&!A1&!A|!E&D&C1&!C&B1&!B&A2&!A1&!A|!E&!D&C1&!C&B1&!B&A2&!A1&!A|!E&!D&C1&C&B1&!B&A2&!A1&!A|!E&D&!C1&C&B1&!B&A2&!A1&!A|!E&!D&!C1&C&B1&!B&A2&!A1&!A|!E&!D&!C1&C&!B1&!B&A2&!A1&!A|!E&D&!C1&C&!B1&!B&A2&!A1&!A|!E&!D&C1&C&!B1&!B&A2&!A1&!A|!E&!D&C1&!C&!B1&!B&A2&!A1&!A|!E&D&C1&!C&!B1&!B&A2&!A1&!A|!E&D&!C1&!C&!B1&!B&A2&!A1&!A|!E&!D&!C1&!C&!B1&!B&A2&!A1&!A|!E&!D&!C1&!C&!B1&!B&A2&A1&!A|!E&D&!C1&!C&!B1&!B&A2&A1&!A|!E&D&C1&!C&!B1&!B&A2&A1&!A|!E&!D&C1&!C&!B1&!B&A2&A1&!A|!E&!D&C1&C&!B1&!B&A2&A1&!A|!E&D&!C1&C&!B1&!B&A2&A1&!A|!E&!D&!C1&C&!B1&!B&A2&A1&!A|!E&!D&!C1&C&B1&!B&A2&A1&!A|!E&D&!C1&C&B1&!B&A2&A1&!A|!E&!D&C1&C&B1&!B&A2&A1&!A|!E&!D&C1&!C&B1&!B&A2&A1&!A|!E&D&C1&!C&B1&!B&A2&A1&!A|!E&D&!C1&!C&B1&!B&A2&A1&!A|!E&!D&!C1&!C&B1&!B&A2&A1&!A|!E&!D&!C1&!C&B1&B&A2&A1&!A|!E&!D&C1&!C&B1&B&A2&A1&!A|!E&!D&C1&C&B1&B&A2&A1&!A|!E&!D&!C1&C&B1&B&A2&A1&!A|!E&!D&!C1&C&!B1&B&A2&A1&!A|!E&D&!C1&C&!B1&B&A2&A1&!A|!E&!D&C1&C&!B1&B&A2&A1&!A|!E&!D&C1&!C&!B1&B&A2&A1&!A|!E&D&C1&!C&!B1&B&A2&A1&!A|!E&D&!C1&!C&!B1&B&A2&A1&!A|!E&!D&!C1&!C&!B1&B&A2&A1&!A|!E&!D&!C1&!C&!B1&B&!A2&A1&!A|!E&D&!C1&!C&!B1&B&!A2&A1&!A|!E&D&C1&!C&!B1&B&!A2&A1&!A|!E&!D&C1&!C&!B1&B&!A2&A1&!A|!E&!D&C1&C&!B1&B&!A2&A1&!A|!E&D&!C1&C&!B1&B&!A2&A1&!A|!E&!D&!C1&C&!B1&B&!A2&A1&!A|!E&!D&!C1&C&B1&B&!A2&A1&!A|!E&!D&C1&C&B1&B&!A2&A1&!A|!E&!D&C1&!C&B1&B&!A2&A1&!A|!E&!D&!C1&!C&B1&B&!A2&A1&!A|!E&!D&!C1&!C&B1&!B&!A2&A1&!A|!E&D&!C1&!C&B1&!B&!A2&A1&!A|!E&D&C1&!C&B1&!B&!A2&A1&!A|!E&!D&C1&!C&B1&!B&!A2&A1&!A|!E&!D&C1&C&B1&!B&!A2&A1&!A|!E&D&!C1&C&B1&!B&!A2&A1&!A|!E&!D&!C1&C&B1&!B&!A2&A1&!A|!E&!D&!C1&C&!B1&!B&!A2&A1&!A|!E&D&!C1&C&!B1&!B&!A2&A1&!A|!E&!D&C1&C&!B1&!B&!A2&A1&!A|!E&!D&C1&!C&!B1&!B&!A2&A1&!A|!E&D&C1&!C&!B1&!B&!A2&A1&!A|!E&D&!C1&!C&!B1&!B&!A2&A1&!A|!E&!D&!C1&!C&!B1&!B&!A2&A1&!A|!E&!D&!C1&!C&!B1&!B&!A2&A1&A|!E&D&!C1&!C&!B1&!B&!A2&A1&A|!E&D&C1&!C&!B1&!B&!A2&A1&A|!E&!D&C1&!C&!B1&!B&!A2&A1&A|!E&!D&C1&C&!B1&!B&!A2&A1&A|!E&D&!C1&C&!B1&!B&!A2&A1&A|!E&!D&!C1&C&!B1&!B&!A2&A1&A|!E&!D&!C1&C&B1&!B&!A2&A1&A|!E&D&!C1&C&B1&!B&!A2&A1&A|!E&!D&C1&C&B1&!B&!A2&A1&A|!E&!D&C1&!C&B1&!B&!A2&A1&A|!E&D&C1&!C&B1&!B&!A2&A1&A|!E&D&!C1&!C&B1&!B&!A2&A1&A|!E&!D&!C1&!C&B1&!B&!A2&A1&A|!E&!D&!C1&!C&B1&B&!A2&A1&A|!E&!D&C1&!C&B1&B&!A2&A1&A|!E&!D&C1&C&B1&B&!A2&A1&A|!E&!D&!C1&C&B1&B&!A2&A1&A|!E&!D&!C1&C&!B1&B&!A2&A1&A|!E&D&!C1&C&!B1&B&!A2&A1&A|!E&!D&C1&C&!B1&B&!A2&A1&A|!E&!D&C1&!C&!B1&B&!A2&A1&A|!E&D&C1&!C&!B1&B&!A2&A1&A|!E&D&!C1&!C&!B1&B&!A2&A1&A|!E&!D&!C1&!C&!B1&B&!A2&A1&A|!E&!D&!C1&!C&!B1&B&A2&A1&A|!E&!D&C1&!C&!B1&B&A2&A1&A|!E&!D&C1&C&!B1&B&A2&A1&A|!E&!D&!C1&C&!B1&B&A2&A1&A|!E&!D&!C1&C&B1&B&A2&A1&A|!E&!D&C1&C&B1&B&A2&A1&A|!E&!D&C1&!C&B1&B&A2&A1&A|!E&!D&!C1&!C&B1&B&A2&A1&A|!E&!D&!C1&!C&B1&!B&A2&A1&A|!E&!D&C1&!C&B1&!B&A2&A1&A|!E&!D&C1&C&B1&!B&A2&A1&A|!E&!D&!C1&C&B1&!B&A2&A1&A|!E&!D&!C1&C&!B1&!B&A2&A1&A|!E&!D&C1&C&!B1&!B&A2&A1&A|!E&!D&C1&!C&!B1&!B&A2&A1&A|!E&!D&!C1&!C&!B1&!B&A2&A1&A|!E&!D&!C1&!C&!B1&!B&A2&!A1&A|!E&D&!C1&!C&!B1&!B&A2&!A1&A|!E&D&C1&!C&!B1&!B&A2&!A1&A|!E&!D&C1&!C&!B1&!B&A2&!A1&A|!E&!D&C1&C&!B1&!B&A2&!A1&A|!E&D&!C1&C&!B1&!B&A2&!A1&A|!E&!D&!C1&C&!B1&!B&A2&!A1&A|!E&!D&!C1&C&B1&!B&A2&!A1&A|!E&D&!C1&C&B1&!B&A2&!A1&A|!E&!D&C1&C&B1&!B&A2&!A1&A|!E&!D&C1&!C&B1&!B&A2&!A1&A|!E&D&C1&!C&B1&!B&A2&!A1&A|!E&D&!C1&!C&B1&!B&A2&!A1&A|!E&!D&!C1&!C&B1&!B&A2&!A1&A|!E&!D&!C1&!C&B1&B&A2&!A1&A|!E&!D&C1&!C&B1&B&A2&!A1&A|!E&!D&C1&C&B1&B&A2&!A1&A|!E&!D&!C1&C&B1&B&A2&!A1&A|!E&!D&!C1&C&!B1&B&A2&!A1&A|!E&D&!C1&C&!B1&B&A2&!A1&A|!E&!D&C1&C&!B1&B&A2&!A1&A|!E&!D&C1&!C&!B1&B&A2&!A1&A|!E&D&C1&!C&!B1&B&A2&!A1&A|!E&D&!C1&!C&!B1&B&A2&!A1&A|!E&!D&!C1&!C&!B1&B&A2&!A1&A|!E&!D&!C1&!C&!B1&B&!A2&!A1&A|!E&D&!C1&!C&!B1&B&!A2&!A1&A|!E&D&C1&!C&!B1&B&!A2&!A1&A|!E&!D&C1&!C&!B1&B&!A2&!A1&A|!E&!D&C1&C&!B1&B&!A2&!A1&A|!E&D&!C1&C&!B1&B&!A2&!A1&A|!E&!D&!C1&C&!B1&B&!A2&!A1&A|!E&!D&!C1&C&B1&B&!A2&!A1&A|!E&!D&C1&C&B1&B&!A2&!A1&A|!E&!D&C1&!C&B1&B&!A2&!A1&A|!E&!D&!C1&!C&B1&B&!A2&!A1&A|!E&!D&!C1&!C&B1&!B&!A2&!A1&A|!E&D&!C1&!C&B1&!B&!A2&!A1&A|!E&D&C1&!C&B1&!B&!A2&!A1&A|!E&!D&C1&!C&B1&!B&!A2&!A1&A|!E&!D&C1&C&B1&!B&!A2&!A1&A|!E&D&!C1&C&B1&!B&!A2&!A1&A|!E&!D&!C1&C&B1&!B&!A2&!A1&A|!E&!D&!C1&C&!B1&!B&!A2&!A1&A|!E&D&!C1&C&!B1&!B&!A2&!A1&A|!E&!D&C1&C&!B1&!B&!A2&!A1&A|!E&!D&C1&!C&!B1&!B&!A2&!A1&A|!E&D&C1&!C&!B1&!B&!A2&!A1&A|!E&D&!C1&!C&!B1&!B&!A2&!A1&A|!E&!D&!C1&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOAOI32211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOAI2121 -l OAOAI2121 -i D C1 C B A1 A -o Y -f Y=!(D&C1&!C&!B&!A1&!A|D&C1&C&!B&!A1&!A|D&!C1&C&!B&!A1&!A|D&!C1&C&B&!A1&!A|D&C1&C&B&!A1&!A|D&C1&!C&B&!A1&!A|D&!C1&!C&B&A1&!A|D&C1&!C&B&A1&!A|D&C1&C&B&A1&!A|D&!C1&C&B&A1&!A|D&!C1&C&!B&A1&!A|D&C1&C&!B&A1&!A|D&C1&!C&!B&A1&!A|D&C1&!C&!B&A1&A|D&C1&C&!B&A1&A|D&!C1&C&!B&A1&A|D&!C1&C&B&A1&A|D&C1&C&B&A1&A|D&C1&!C&B&A1&A|D&!C1&!C&B&A1&A|D&!C1&!C&B&!A1&A|D&C1&!C&B&!A1&A|D&C1&C&B&!A1&A|D&!C1&C&B&!A1&A|D&!C1&C&!B&!A1&A|D&C1&C&!B&!A1&A|D&C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOAI2121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAI212 -l AOAI212 -i C1 C B A1 A -o Y -f Y=!(C1&C&B&!A1&!A|C1&C&B&A1&!A|C1&C&!B&A1&A|C1&C&B&A1&A|C1&C&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAI212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAI331 -l AAOAI331 -i C B2 B1 B A2 A1 A -o Y -f Y=!(C&B2&B1&B&!A2&!A1&!A|C&B2&B1&B&A2&!A1&!A|C&B2&B1&B&A2&A1&!A|C&B2&B1&B&!A2&A1&!A|C&B2&B1&B&!A2&A1&A|C&!B2&!B1&B&A2&A1&A|C&B2&!B1&B&A2&A1&A|C&B2&B1&B&A2&A1&A|C&!B2&B1&B&A2&A1&A|C&!B2&B1&!B&A2&A1&A|C&B2&B1&!B&A2&A1&A|C&B2&!B1&!B&A2&A1&A|C&!B2&!B1&!B&A2&A1&A|C&B2&B1&B&A2&!A1&A|C&B2&B1&B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAI331.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAOAOI221111 -l AAOAOAOI221111 -i F E D C B1 B A1 A -o Y -f Y=(!F&!E&!D&!C&!B1&!B&!A1&!A|!F&E&!D&!C&!B1&!B&!A1&!A|!F&!E&D&!C&!B1&!B&!A1&!A|!F&!E&D&C&!B1&!B&!A1&!A|!F&E&!D&C&!B1&!B&!A1&!A|!F&!E&!D&C&!B1&!B&!A1&!A|!F&!E&!D&C&B1&!B&!A1&!A|!F&E&!D&C&B1&!B&!A1&!A|!F&!E&D&C&B1&!B&!A1&!A|!F&!E&D&!C&B1&!B&!A1&!A|!F&E&!D&!C&B1&!B&!A1&!A|!F&!E&!D&!C&B1&!B&!A1&!A|!F&!E&!D&!C&B1&B&!A1&!A|!F&E&!D&!C&B1&B&!A1&!A|!F&!E&D&!C&B1&B&!A1&!A|!F&!E&D&C&B1&B&!A1&!A|!F&!E&!D&C&B1&B&!A1&!A|!F&!E&!D&C&!B1&B&!A1&!A|!F&E&!D&C&!B1&B&!A1&!A|!F&!E&D&C&!B1&B&!A1&!A|!F&!E&D&!C&!B1&B&!A1&!A|!F&E&!D&!C&!B1&B&!A1&!A|!F&!E&!D&!C&!B1&B&!A1&!A|!F&!E&!D&!C&!B1&B&A1&!A|!F&E&!D&!C&!B1&B&A1&!A|!F&!E&D&!C&!B1&B&A1&!A|!F&!E&D&C&!B1&B&A1&!A|!F&E&!D&C&!B1&B&A1&!A|!F&!E&!D&C&!B1&B&A1&!A|!F&!E&!D&C&B1&B&A1&!A|!F&!E&D&C&B1&B&A1&!A|!F&!E&D&!C&B1&B&A1&!A|!F&E&!D&!C&B1&B&A1&!A|!F&!E&!D&!C&B1&B&A1&!A|!F&!E&!D&!C&B1&!B&A1&!A|!F&E&!D&!C&B1&!B&A1&!A|!F&!E&D&!C&B1&!B&A1&!A|!F&!E&D&C&B1&!B&A1&!A|!F&E&!D&C&B1&!B&A1&!A|!F&!E&!D&C&B1&!B&A1&!A|!F&!E&!D&C&!B1&!B&A1&!A|!F&E&!D&C&!B1&!B&A1&!A|!F&!E&D&C&!B1&!B&A1&!A|!F&!E&D&!C&!B1&!B&A1&!A|!F&E&!D&!C&!B1&!B&A1&!A|!F&!E&!D&!C&!B1&!B&A1&!A|!F&!E&!D&!C&!B1&!B&A1&A|!F&E&!D&!C&!B1&!B&A1&A|!F&!E&D&!C&!B1&!B&A1&A|!F&!E&D&C&!B1&!B&A1&A|!F&!E&!D&C&!B1&!B&A1&A|!F&!E&!D&C&B1&!B&A1&A|!F&!E&D&C&B1&!B&A1&A|!F&!E&D&!C&B1&!B&A1&A|!F&E&!D&!C&B1&!B&A1&A|!F&!E&!D&!C&B1&!B&A1&A|!F&!E&!D&!C&B1&B&A1&A|!F&E&!D&!C&B1&B&A1&A|!F&!E&D&!C&B1&B&A1&A|!F&!E&D&C&B1&B&A1&A|!F&!E&!D&C&B1&B&A1&A|!F&!E&!D&C&!B1&B&A1&A|!F&!E&D&C&!B1&B&A1&A|!F&!E&D&!C&!B1&B&A1&A|!F&E&!D&!C&!B1&B&A1&A|!F&!E&!D&!C&!B1&B&A1&A|!F&!E&!D&!C&!B1&B&!A1&A|!F&E&!D&!C&!B1&B&!A1&A|!F&!E&D&!C&!B1&B&!A1&A|!F&!E&D&C&!B1&B&!A1&A|!F&E&!D&C&!B1&B&!A1&A|!F&!E&!D&C&!B1&B&!A1&A|!F&!E&!D&C&B1&B&!A1&A|!F&!E&D&C&B1&B&!A1&A|!F&!E&D&!C&B1&B&!A1&A|!F&E&!D&!C&B1&B&!A1&A|!F&!E&!D&!C&B1&B&!A1&A|!F&!E&!D&!C&B1&!B&!A1&A|!F&E&!D&!C&B1&!B&!A1&A|!F&!E&D&!C&B1&!B&!A1&A|!F&!E&D&C&B1&!B&!A1&A|!F&E&!D&C&B1&!B&!A1&A|!F&!E&!D&C&B1&!B&!A1&A|!F&!E&!D&C&!B1&!B&!A1&A|!F&E&!D&C&!B1&!B&!A1&A|!F&!E&D&C&!B1&!B&!A1&A|!F&!E&D&!C&!B1&!B&!A1&A|!F&E&!D&!C&!B1&!B&!A1&A|!F&!E&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAOAOI221111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOOAI22132 -l OOAAOOAI22132 -i E1 E D2 D1 D C B1 B A1 A -o Y -f Y=!(!E1&E&D2&D1&D&!C&!B1&!B&!A1&!A|E1&E&D2&D1&D&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&C&!B1&!B&!A1&!A|E1&E&D2&D1&D&C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&C&B1&!B&!A1&!A|E1&E&D2&D1&D&C&B1&!B&!A1&!A|E1&!E&D2&D1&D&C&B1&!B&!A1&!A|E1&!E&D2&D1&D&!C&B1&!B&!A1&!A|E1&E&D2&D1&D&!C&B1&!B&!A1&!A|!E1&E&D2&D1&D&!C&B1&!B&!A1&!A|!E1&E&D2&D1&D&!C&B1&B&!A1&!A|E1&E&D2&D1&D&!C&B1&B&!A1&!A|E1&!E&D2&D1&D&!C&B1&B&!A1&!A|E1&!E&D2&D1&D&C&B1&B&!A1&!A|E1&E&D2&D1&D&C&B1&B&!A1&!A|!E1&E&D2&D1&D&C&B1&B&!A1&!A|!E1&E&D2&D1&D&C&!B1&B&!A1&!A|E1&E&D2&D1&D&C&!B1&B&!A1&!A|E1&!E&D2&D1&D&C&!B1&B&!A1&!A|E1&!E&D2&D1&D&!C&!B1&B&!A1&!A|E1&E&D2&D1&D&!C&!B1&B&!A1&!A|!E1&E&D2&D1&D&!C&!B1&B&!A1&!A|!E1&E&D2&D1&D&!C&!B1&B&A1&!A|E1&E&D2&D1&D&!C&!B1&B&A1&!A|E1&!E&D2&D1&D&!C&!B1&B&A1&!A|E1&!E&!D2&!D1&D&C&!B1&B&A1&!A|E1&E&!D2&!D1&D&C&!B1&B&A1&!A|!E1&E&!D2&!D1&D&C&!B1&B&A1&!A|!E1&E&D2&!D1&D&C&!B1&B&A1&!A|E1&E&D2&!D1&D&C&!B1&B&A1&!A|E1&!E&D2&!D1&D&C&!B1&B&A1&!A|E1&!E&D2&D1&D&C&!B1&B&A1&!A|E1&E&D2&D1&D&C&!B1&B&A1&!A|!E1&E&D2&D1&D&C&!B1&B&A1&!A|!E1&E&!D2&D1&D&C&!B1&B&A1&!A|E1&E&!D2&D1&D&C&!B1&B&A1&!A|E1&!E&!D2&D1&D&C&!B1&B&A1&!A|E1&!E&!D2&D1&!D&C&!B1&B&A1&!A|E1&E&!D2&D1&!D&C&!B1&B&A1&!A|!E1&E&!D2&D1&!D&C&!B1&B&A1&!A|!E1&E&D2&D1&!D&C&!B1&B&A1&!A|E1&E&D2&D1&!D&C&!B1&B&A1&!A|E1&!E&D2&D1&!D&C&!B1&B&A1&!A|E1&!E&D2&!D1&!D&C&!B1&B&A1&!A|E1&E&D2&!D1&!D&C&!B1&B&A1&!A|!E1&E&D2&!D1&!D&C&!B1&B&A1&!A|!E1&E&!D2&!D1&!D&C&!B1&B&A1&!A|E1&E&!D2&!D1&!D&C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&C&B1&B&A1&!A|E1&E&!D2&!D1&!D&C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&C&B1&B&A1&!A|!E1&E&D2&!D1&!D&C&B1&B&A1&!A|E1&E&D2&!D1&!D&C&B1&B&A1&!A|E1&!E&D2&!D1&!D&C&B1&B&A1&!A|E1&!E&D2&D1&!D&C&B1&B&A1&!A|E1&E&D2&D1&!D&C&B1&B&A1&!A|!E1&E&D2&D1&!D&C&B1&B&A1&!A|!E1&E&!D2&D1&!D&C&B1&B&A1&!A|E1&E&!D2&D1&!D&C&B1&B&A1&!A|E1&!E&!D2&D1&!D&C&B1&B&A1&!A|E1&!E&!D2&D1&D&C&B1&B&A1&!A|E1&E&!D2&D1&D&C&B1&B&A1&!A|!E1&E&!D2&D1&D&C&B1&B&A1&!A|!E1&E&D2&D1&D&C&B1&B&A1&!A|E1&E&D2&D1&D&C&B1&B&A1&!A|E1&!E&D2&D1&D&C&B1&B&A1&!A|E1&!E&D2&!D1&D&C&B1&B&A1&!A|E1&E&D2&!D1&D&C&B1&B&A1&!A|!E1&E&D2&!D1&D&C&B1&B&A1&!A|!E1&E&!D2&!D1&D&C&B1&B&A1&!A|E1&E&!D2&!D1&D&C&B1&B&A1&!A|E1&!E&!D2&!D1&D&C&B1&B&A1&!A|E1&!E&D2&D1&D&!C&B1&B&A1&!A|E1&E&D2&D1&D&!C&B1&B&A1&!A|!E1&E&D2&D1&D&!C&B1&B&A1&!A|!E1&E&D2&D1&D&!C&B1&!B&A1&!A|E1&E&D2&D1&D&!C&B1&!B&A1&!A|E1&!E&D2&D1&D&!C&B1&!B&A1&!A|E1&!E&!D2&!D1&D&C&B1&!B&A1&!A|E1&E&!D2&!D1&D&C&B1&!B&A1&!A|!E1&E&!D2&!D1&D&C&B1&!B&A1&!A|!E1&E&D2&!D1&D&C&B1&!B&A1&!A|E1&E&D2&!D1&D&C&B1&!B&A1&!A|E1&!E&D2&!D1&D&C&B1&!B&A1&!A|E1&!E&D2&D1&D&C&B1&!B&A1&!A|E1&E&D2&D1&D&C&B1&!B&A1&!A|!E1&E&D2&D1&D&C&B1&!B&A1&!A|!E1&E&!D2&D1&D&C&B1&!B&A1&!A|E1&E&!D2&D1&D&C&B1&!B&A1&!A|E1&!E&!D2&D1&D&C&B1&!B&A1&!A|E1&!E&!D2&D1&!D&C&B1&!B&A1&!A|E1&E&!D2&D1&!D&C&B1&!B&A1&!A|!E1&E&!D2&D1&!D&C&B1&!B&A1&!A|!E1&E&D2&D1&!D&C&B1&!B&A1&!A|E1&E&D2&D1&!D&C&B1&!B&A1&!A|E1&!E&D2&D1&!D&C&B1&!B&A1&!A|E1&!E&D2&!D1&!D&C&B1&!B&A1&!A|E1&E&D2&!D1&!D&C&B1&!B&A1&!A|!E1&E&D2&!D1&!D&C&B1&!B&A1&!A|!E1&E&!D2&!D1&!D&C&B1&!B&A1&!A|E1&E&!D2&!D1&!D&C&B1&!B&A1&!A|E1&!E&!D2&!D1&!D&C&B1&!B&A1&!A|!E1&E&D2&D1&D&C&!B1&!B&A1&!A|E1&E&D2&D1&D&C&!B1&!B&A1&!A|E1&!E&D2&D1&D&C&!B1&!B&A1&!A|E1&!E&D2&D1&D&!C&!B1&!B&A1&!A|E1&E&D2&D1&D&!C&!B1&!B&A1&!A|!E1&E&D2&D1&D&!C&!B1&!B&A1&!A|!E1&E&D2&D1&D&!C&!B1&!B&A1&A|E1&E&D2&D1&D&!C&!B1&!B&A1&A|E1&!E&D2&D1&D&!C&!B1&!B&A1&A|E1&!E&D2&D1&D&C&!B1&!B&A1&A|E1&E&D2&D1&D&C&!B1&!B&A1&A|!E1&E&D2&D1&D&C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&C&B1&!B&A1&A|E1&E&!D2&!D1&!D&C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&C&B1&!B&A1&A|!E1&E&D2&!D1&!D&C&B1&!B&A1&A|E1&E&D2&!D1&!D&C&B1&!B&A1&A|E1&!E&D2&!D1&!D&C&B1&!B&A1&A|E1&!E&D2&D1&!D&C&B1&!B&A1&A|E1&E&D2&D1&!D&C&B1&!B&A1&A|!E1&E&D2&D1&!D&C&B1&!B&A1&A|!E1&E&!D2&D1&!D&C&B1&!B&A1&A|E1&E&!D2&D1&!D&C&B1&!B&A1&A|E1&!E&!D2&D1&!D&C&B1&!B&A1&A|E1&!E&!D2&D1&D&C&B1&!B&A1&A|E1&E&!D2&D1&D&C&B1&!B&A1&A|!E1&E&!D2&D1&D&C&B1&!B&A1&A|!E1&E&D2&D1&D&C&B1&!B&A1&A|E1&E&D2&D1&D&C&B1&!B&A1&A|E1&!E&D2&D1&D&C&B1&!B&A1&A|E1&!E&D2&!D1&D&C&B1&!B&A1&A|E1&E&D2&!D1&D&C&B1&!B&A1&A|!E1&E&D2&!D1&D&C&B1&!B&A1&A|!E1&E&!D2&!D1&D&C&B1&!B&A1&A|E1&E&!D2&!D1&D&C&B1&!B&A1&A|E1&!E&!D2&!D1&D&C&B1&!B&A1&A|E1&!E&D2&D1&D&!C&B1&!B&A1&A|E1&E&D2&D1&D&!C&B1&!B&A1&A|!E1&E&D2&D1&D&!C&B1&!B&A1&A|!E1&E&D2&D1&D&!C&B1&B&A1&A|E1&E&D2&D1&D&!C&B1&B&A1&A|E1&!E&D2&D1&D&!C&B1&B&A1&A|E1&!E&!D2&!D1&D&C&B1&B&A1&A|E1&E&!D2&!D1&D&C&B1&B&A1&A|!E1&E&!D2&!D1&D&C&B1&B&A1&A|!E1&E&D2&!D1&D&C&B1&B&A1&A|E1&E&D2&!D1&D&C&B1&B&A1&A|E1&!E&D2&!D1&D&C&B1&B&A1&A|E1&!E&D2&D1&D&C&B1&B&A1&A|E1&E&D2&D1&D&C&B1&B&A1&A|!E1&E&D2&D1&D&C&B1&B&A1&A|!E1&E&!D2&D1&D&C&B1&B&A1&A|E1&E&!D2&D1&D&C&B1&B&A1&A|E1&!E&!D2&D1&D&C&B1&B&A1&A|E1&!E&!D2&D1&!D&C&B1&B&A1&A|E1&E&!D2&D1&!D&C&B1&B&A1&A|!E1&E&!D2&D1&!D&C&B1&B&A1&A|!E1&E&D2&D1&!D&C&B1&B&A1&A|E1&E&D2&D1&!D&C&B1&B&A1&A|E1&!E&D2&D1&!D&C&B1&B&A1&A|E1&!E&D2&!D1&!D&C&B1&B&A1&A|E1&E&D2&!D1&!D&C&B1&B&A1&A|!E1&E&D2&!D1&!D&C&B1&B&A1&A|!E1&E&!D2&!D1&!D&C&B1&B&A1&A|E1&E&!D2&!D1&!D&C&B1&B&A1&A|E1&!E&!D2&!D1&!D&C&B1&B&A1&A|E1&!E&!D2&!D1&!D&C&!B1&B&A1&A|E1&E&!D2&!D1&!D&C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&C&!B1&B&A1&A|!E1&E&D2&!D1&!D&C&!B1&B&A1&A|E1&E&D2&!D1&!D&C&!B1&B&A1&A|E1&!E&D2&!D1&!D&C&!B1&B&A1&A|E1&!E&D2&D1&!D&C&!B1&B&A1&A|E1&E&D2&D1&!D&C&!B1&B&A1&A|!E1&E&D2&D1&!D&C&!B1&B&A1&A|!E1&E&!D2&D1&!D&C&!B1&B&A1&A|E1&E&!D2&D1&!D&C&!B1&B&A1&A|E1&!E&!D2&D1&!D&C&!B1&B&A1&A|E1&!E&!D2&D1&D&C&!B1&B&A1&A|E1&E&!D2&D1&D&C&!B1&B&A1&A|!E1&E&!D2&D1&D&C&!B1&B&A1&A|!E1&E&D2&D1&D&C&!B1&B&A1&A|E1&E&D2&D1&D&C&!B1&B&A1&A|E1&!E&D2&D1&D&C&!B1&B&A1&A|E1&!E&D2&!D1&D&C&!B1&B&A1&A|E1&E&D2&!D1&D&C&!B1&B&A1&A|!E1&E&D2&!D1&D&C&!B1&B&A1&A|!E1&E&!D2&!D1&D&C&!B1&B&A1&A|E1&E&!D2&!D1&D&C&!B1&B&A1&A|E1&!E&!D2&!D1&D&C&!B1&B&A1&A|E1&!E&D2&D1&D&!C&!B1&B&A1&A|E1&E&D2&D1&D&!C&!B1&B&A1&A|!E1&E&D2&D1&D&!C&!B1&B&A1&A|!E1&E&D2&D1&D&!C&!B1&B&!A1&A|E1&E&D2&D1&D&!C&!B1&B&!A1&A|E1&!E&D2&D1&D&!C&!B1&B&!A1&A|E1&!E&!D2&!D1&D&C&!B1&B&!A1&A|E1&E&!D2&!D1&D&C&!B1&B&!A1&A|!E1&E&!D2&!D1&D&C&!B1&B&!A1&A|!E1&E&D2&!D1&D&C&!B1&B&!A1&A|E1&E&D2&!D1&D&C&!B1&B&!A1&A|E1&!E&D2&!D1&D&C&!B1&B&!A1&A|E1&!E&D2&D1&D&C&!B1&B&!A1&A|E1&E&D2&D1&D&C&!B1&B&!A1&A|!E1&E&D2&D1&D&C&!B1&B&!A1&A|!E1&E&!D2&D1&D&C&!B1&B&!A1&A|E1&E&!D2&D1&D&C&!B1&B&!A1&A|E1&!E&!D2&D1&D&C&!B1&B&!A1&A|E1&!E&!D2&D1&!D&C&!B1&B&!A1&A|E1&E&!D2&D1&!D&C&!B1&B&!A1&A|!E1&E&!D2&D1&!D&C&!B1&B&!A1&A|!E1&E&D2&D1&!D&C&!B1&B&!A1&A|E1&E&D2&D1&!D&C&!B1&B&!A1&A|E1&!E&D2&D1&!D&C&!B1&B&!A1&A|E1&!E&D2&!D1&!D&C&!B1&B&!A1&A|E1&E&D2&!D1&!D&C&!B1&B&!A1&A|!E1&E&D2&!D1&!D&C&!B1&B&!A1&A|!E1&E&!D2&!D1&!D&C&!B1&B&!A1&A|E1&E&!D2&!D1&!D&C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&C&B1&B&!A1&A|E1&E&!D2&!D1&!D&C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&C&B1&B&!A1&A|!E1&E&D2&!D1&!D&C&B1&B&!A1&A|E1&E&D2&!D1&!D&C&B1&B&!A1&A|E1&!E&D2&!D1&!D&C&B1&B&!A1&A|E1&!E&D2&D1&!D&C&B1&B&!A1&A|E1&E&D2&D1&!D&C&B1&B&!A1&A|!E1&E&D2&D1&!D&C&B1&B&!A1&A|!E1&E&!D2&D1&!D&C&B1&B&!A1&A|E1&E&!D2&D1&!D&C&B1&B&!A1&A|E1&!E&!D2&D1&!D&C&B1&B&!A1&A|E1&!E&!D2&D1&D&C&B1&B&!A1&A|E1&E&!D2&D1&D&C&B1&B&!A1&A|!E1&E&!D2&D1&D&C&B1&B&!A1&A|!E1&E&D2&D1&D&C&B1&B&!A1&A|E1&E&D2&D1&D&C&B1&B&!A1&A|E1&!E&D2&D1&D&C&B1&B&!A1&A|E1&!E&D2&!D1&D&C&B1&B&!A1&A|E1&E&D2&!D1&D&C&B1&B&!A1&A|!E1&E&D2&!D1&D&C&B1&B&!A1&A|!E1&E&!D2&!D1&D&C&B1&B&!A1&A|E1&E&!D2&!D1&D&C&B1&B&!A1&A|E1&!E&!D2&!D1&D&C&B1&B&!A1&A|E1&!E&D2&D1&D&!C&B1&B&!A1&A|E1&E&D2&D1&D&!C&B1&B&!A1&A|!E1&E&D2&D1&D&!C&B1&B&!A1&A|!E1&E&D2&D1&D&!C&B1&!B&!A1&A|E1&E&D2&D1&D&!C&B1&!B&!A1&A|E1&!E&D2&D1&D&!C&B1&!B&!A1&A|E1&!E&!D2&!D1&D&C&B1&!B&!A1&A|E1&E&!D2&!D1&D&C&B1&!B&!A1&A|!E1&E&!D2&!D1&D&C&B1&!B&!A1&A|!E1&E&D2&!D1&D&C&B1&!B&!A1&A|E1&E&D2&!D1&D&C&B1&!B&!A1&A|E1&!E&D2&!D1&D&C&B1&!B&!A1&A|E1&!E&D2&D1&D&C&B1&!B&!A1&A|E1&E&D2&D1&D&C&B1&!B&!A1&A|!E1&E&D2&D1&D&C&B1&!B&!A1&A|!E1&E&!D2&D1&D&C&B1&!B&!A1&A|E1&E&!D2&D1&D&C&B1&!B&!A1&A|E1&!E&!D2&D1&D&C&B1&!B&!A1&A|E1&!E&!D2&D1&!D&C&B1&!B&!A1&A|E1&E&!D2&D1&!D&C&B1&!B&!A1&A|!E1&E&!D2&D1&!D&C&B1&!B&!A1&A|!E1&E&D2&D1&!D&C&B1&!B&!A1&A|E1&E&D2&D1&!D&C&B1&!B&!A1&A|E1&!E&D2&D1&!D&C&B1&!B&!A1&A|E1&!E&D2&!D1&!D&C&B1&!B&!A1&A|E1&E&D2&!D1&!D&C&B1&!B&!A1&A|!E1&E&D2&!D1&!D&C&B1&!B&!A1&A|!E1&E&!D2&!D1&!D&C&B1&!B&!A1&A|E1&E&!D2&!D1&!D&C&B1&!B&!A1&A|E1&!E&!D2&!D1&!D&C&B1&!B&!A1&A|!E1&E&D2&D1&D&C&!B1&!B&!A1&A|E1&E&D2&D1&D&C&!B1&!B&!A1&A|E1&!E&D2&D1&D&C&!B1&!B&!A1&A|E1&!E&D2&D1&D&!C&!B1&!B&!A1&A|E1&E&D2&D1&D&!C&!B1&!B&!A1&A|!E1&E&D2&D1&D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOOAI22132.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOI332 -l AAAOI332 -i C1 C B2 B1 B A2 A1 A -o Y -f Y=!(C1&C&!B2&!B1&!B&!A2&!A1&!A|C1&C&B2&!B1&!B&!A2&!A1&!A|C1&C&B2&B1&!B&!A2&!A1&!A|C1&C&!B2&B1&!B&!A2&!A1&!A|C1&C&!B2&B1&B&!A2&!A1&!A|!C1&C&B2&B1&B&!A2&!A1&!A|C1&C&B2&B1&B&!A2&!A1&!A|C1&!C&B2&B1&B&!A2&!A1&!A|!C1&!C&B2&B1&B&!A2&!A1&!A|C1&C&B2&!B1&B&!A2&!A1&!A|C1&C&!B2&!B1&B&!A2&!A1&!A|C1&C&!B2&!B1&B&A2&!A1&!A|C1&C&B2&!B1&B&A2&!A1&!A|!C1&!C&B2&B1&B&A2&!A1&!A|C1&!C&B2&B1&B&A2&!A1&!A|C1&C&B2&B1&B&A2&!A1&!A|!C1&C&B2&B1&B&A2&!A1&!A|C1&C&!B2&B1&B&A2&!A1&!A|C1&C&!B2&B1&!B&A2&!A1&!A|C1&C&B2&B1&!B&A2&!A1&!A|C1&C&B2&!B1&!B&A2&!A1&!A|C1&C&!B2&!B1&!B&A2&!A1&!A|C1&C&!B2&!B1&!B&A2&A1&!A|C1&C&B2&!B1&!B&A2&A1&!A|C1&C&B2&B1&!B&A2&A1&!A|C1&C&!B2&B1&!B&A2&A1&!A|C1&C&!B2&B1&B&A2&A1&!A|!C1&C&B2&B1&B&A2&A1&!A|C1&C&B2&B1&B&A2&A1&!A|C1&!C&B2&B1&B&A2&A1&!A|!C1&!C&B2&B1&B&A2&A1&!A|C1&C&B2&!B1&B&A2&A1&!A|C1&C&!B2&!B1&B&A2&A1&!A|C1&C&!B2&!B1&B&!A2&A1&!A|C1&C&B2&!B1&B&!A2&A1&!A|!C1&!C&B2&B1&B&!A2&A1&!A|C1&!C&B2&B1&B&!A2&A1&!A|C1&C&B2&B1&B&!A2&A1&!A|!C1&C&B2&B1&B&!A2&A1&!A|C1&C&!B2&B1&B&!A2&A1&!A|C1&C&!B2&B1&!B&!A2&A1&!A|C1&C&B2&B1&!B&!A2&A1&!A|C1&C&B2&!B1&!B&!A2&A1&!A|C1&C&!B2&!B1&!B&!A2&A1&!A|C1&C&!B2&!B1&!B&!A2&A1&A|C1&C&B2&!B1&!B&!A2&A1&A|C1&C&B2&B1&!B&!A2&A1&A|C1&C&!B2&B1&!B&!A2&A1&A|C1&C&!B2&B1&B&!A2&A1&A|!C1&C&B2&B1&B&!A2&A1&A|C1&C&B2&B1&B&!A2&A1&A|C1&!C&B2&B1&B&!A2&A1&A|!C1&!C&B2&B1&B&!A2&A1&A|C1&C&B2&!B1&B&!A2&A1&A|C1&C&!B2&!B1&B&!A2&A1&A|!C1&!C&!B2&!B1&B&A2&A1&A|C1&!C&!B2&!B1&B&A2&A1&A|C1&C&!B2&!B1&B&A2&A1&A|!C1&C&!B2&!B1&B&A2&A1&A|!C1&C&B2&!B1&B&A2&A1&A|C1&C&B2&!B1&B&A2&A1&A|C1&!C&B2&!B1&B&A2&A1&A|!C1&!C&B2&!B1&B&A2&A1&A|!C1&!C&B2&B1&B&A2&A1&A|C1&!C&B2&B1&B&A2&A1&A|C1&C&B2&B1&B&A2&A1&A|!C1&C&B2&B1&B&A2&A1&A|!C1&C&!B2&B1&B&A2&A1&A|C1&C&!B2&B1&B&A2&A1&A|C1&!C&!B2&B1&B&A2&A1&A|!C1&!C&!B2&B1&B&A2&A1&A|!C1&!C&!B2&B1&!B&A2&A1&A|C1&!C&!B2&B1&!B&A2&A1&A|C1&C&!B2&B1&!B&A2&A1&A|!C1&C&!B2&B1&!B&A2&A1&A|!C1&C&B2&B1&!B&A2&A1&A|C1&C&B2&B1&!B&A2&A1&A|C1&!C&B2&B1&!B&A2&A1&A|!C1&!C&B2&B1&!B&A2&A1&A|!C1&!C&B2&!B1&!B&A2&A1&A|C1&!C&B2&!B1&!B&A2&A1&A|C1&C&B2&!B1&!B&A2&A1&A|!C1&C&B2&!B1&!B&A2&A1&A|!C1&C&!B2&!B1&!B&A2&A1&A|C1&C&!B2&!B1&!B&A2&A1&A|C1&!C&!B2&!B1&!B&A2&A1&A|!C1&!C&!B2&!B1&!B&A2&A1&A|C1&C&!B2&!B1&!B&A2&!A1&A|C1&C&B2&!B1&!B&A2&!A1&A|C1&C&B2&B1&!B&A2&!A1&A|C1&C&!B2&B1&!B&A2&!A1&A|C1&C&!B2&B1&B&A2&!A1&A|!C1&C&B2&B1&B&A2&!A1&A|C1&C&B2&B1&B&A2&!A1&A|C1&!C&B2&B1&B&A2&!A1&A|!C1&!C&B2&B1&B&A2&!A1&A|C1&C&B2&!B1&B&A2&!A1&A|C1&C&!B2&!B1&B&A2&!A1&A|C1&C&!B2&!B1&B&!A2&!A1&A|C1&C&B2&!B1&B&!A2&!A1&A|!C1&!C&B2&B1&B&!A2&!A1&A|C1&!C&B2&B1&B&!A2&!A1&A|C1&C&B2&B1&B&!A2&!A1&A|!C1&C&B2&B1&B&!A2&!A1&A|C1&C&!B2&B1&B&!A2&!A1&A|C1&C&!B2&B1&!B&!A2&!A1&A|C1&C&B2&B1&!B&!A2&!A1&A|C1&C&B2&!B1&!B&!A2&!A1&A|C1&C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOI332.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n NOR4 -l NOR4 -i A3 A2 A1 A -o Y -f Y=(!A3&!A2&!A1&!A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist NOR4.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOOAI22132 -l AAOOOAI22132 -i E1 E D2 D1 D C B1 B A1 A -o Y -f Y=!(E1&!E&!D2&!D1&D&C&!B1&!B&!A1&!A|E1&E&!D2&!D1&D&C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&D&C&!B1&!B&!A1&!A|!E1&E&D2&!D1&D&C&!B1&!B&!A1&!A|E1&E&D2&!D1&D&C&!B1&!B&!A1&!A|E1&!E&D2&!D1&D&C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&C&!B1&!B&!A1&!A|E1&E&D2&D1&D&C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&C&!B1&!B&!A1&!A|!E1&E&!D2&D1&D&C&!B1&!B&!A1&!A|E1&E&!D2&D1&D&C&!B1&!B&!A1&!A|E1&!E&!D2&D1&D&C&!B1&!B&!A1&!A|E1&!E&!D2&D1&!D&C&!B1&!B&!A1&!A|E1&E&!D2&D1&!D&C&!B1&!B&!A1&!A|!E1&E&!D2&D1&!D&C&!B1&!B&!A1&!A|!E1&E&D2&D1&!D&C&!B1&!B&!A1&!A|E1&E&D2&D1&!D&C&!B1&!B&!A1&!A|E1&!E&D2&D1&!D&C&!B1&!B&!A1&!A|E1&!E&D2&!D1&!D&C&!B1&!B&!A1&!A|E1&E&D2&!D1&!D&C&!B1&!B&!A1&!A|!E1&E&D2&!D1&!D&C&!B1&!B&!A1&!A|!E1&E&D2&!D1&!D&C&B1&!B&!A1&!A|E1&E&D2&!D1&!D&C&B1&!B&!A1&!A|E1&!E&D2&!D1&!D&C&B1&!B&!A1&!A|E1&!E&D2&D1&!D&C&B1&!B&!A1&!A|E1&E&D2&D1&!D&C&B1&!B&!A1&!A|!E1&E&D2&D1&!D&C&B1&!B&!A1&!A|!E1&E&!D2&D1&!D&C&B1&!B&!A1&!A|E1&E&!D2&D1&!D&C&B1&!B&!A1&!A|E1&!E&!D2&D1&!D&C&B1&!B&!A1&!A|E1&!E&!D2&D1&D&C&B1&!B&!A1&!A|E1&E&!D2&D1&D&C&B1&!B&!A1&!A|!E1&E&!D2&D1&D&C&B1&!B&!A1&!A|!E1&E&D2&D1&D&C&B1&!B&!A1&!A|E1&E&D2&D1&D&C&B1&!B&!A1&!A|E1&!E&D2&D1&D&C&B1&!B&!A1&!A|E1&!E&D2&!D1&D&C&B1&!B&!A1&!A|E1&E&D2&!D1&D&C&B1&!B&!A1&!A|!E1&E&D2&!D1&D&C&B1&!B&!A1&!A|!E1&E&!D2&!D1&D&C&B1&!B&!A1&!A|E1&E&!D2&!D1&D&C&B1&!B&!A1&!A|E1&!E&!D2&!D1&D&C&B1&!B&!A1&!A|!E1&E&D2&!D1&!D&!C&B1&B&!A1&!A|E1&E&D2&!D1&!D&!C&B1&B&!A1&!A|E1&!E&D2&!D1&!D&!C&B1&B&!A1&!A|E1&!E&D2&D1&!D&!C&B1&B&!A1&!A|E1&E&D2&D1&!D&!C&B1&B&!A1&!A|!E1&E&D2&D1&!D&!C&B1&B&!A1&!A|!E1&E&!D2&D1&!D&!C&B1&B&!A1&!A|E1&E&!D2&D1&!D&!C&B1&B&!A1&!A|E1&!E&!D2&D1&!D&!C&B1&B&!A1&!A|E1&!E&!D2&D1&D&!C&B1&B&!A1&!A|E1&E&!D2&D1&D&!C&B1&B&!A1&!A|!E1&E&!D2&D1&D&!C&B1&B&!A1&!A|!E1&E&D2&D1&D&!C&B1&B&!A1&!A|E1&E&D2&D1&D&!C&B1&B&!A1&!A|E1&!E&D2&D1&D&!C&B1&B&!A1&!A|E1&!E&D2&!D1&D&!C&B1&B&!A1&!A|E1&E&D2&!D1&D&!C&B1&B&!A1&!A|!E1&E&D2&!D1&D&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&D&!C&B1&B&!A1&!A|E1&E&!D2&!D1&D&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&D&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&D&C&B1&B&!A1&!A|E1&E&!D2&!D1&D&C&B1&B&!A1&!A|!E1&E&!D2&!D1&D&C&B1&B&!A1&!A|!E1&E&D2&!D1&D&C&B1&B&!A1&!A|E1&E&D2&!D1&D&C&B1&B&!A1&!A|E1&!E&D2&!D1&D&C&B1&B&!A1&!A|E1&!E&D2&D1&D&C&B1&B&!A1&!A|E1&E&D2&D1&D&C&B1&B&!A1&!A|!E1&E&D2&D1&D&C&B1&B&!A1&!A|!E1&E&!D2&D1&D&C&B1&B&!A1&!A|E1&E&!D2&D1&D&C&B1&B&!A1&!A|E1&!E&!D2&D1&D&C&B1&B&!A1&!A|E1&!E&!D2&D1&!D&C&B1&B&!A1&!A|E1&E&!D2&D1&!D&C&B1&B&!A1&!A|!E1&E&!D2&D1&!D&C&B1&B&!A1&!A|!E1&E&D2&D1&!D&C&B1&B&!A1&!A|E1&E&D2&D1&!D&C&B1&B&!A1&!A|E1&!E&D2&D1&!D&C&B1&B&!A1&!A|E1&!E&D2&!D1&!D&C&B1&B&!A1&!A|E1&E&D2&!D1&!D&C&B1&B&!A1&!A|!E1&E&D2&!D1&!D&C&B1&B&!A1&!A|!E1&E&D2&!D1&!D&C&!B1&B&!A1&!A|E1&E&D2&!D1&!D&C&!B1&B&!A1&!A|E1&!E&D2&!D1&!D&C&!B1&B&!A1&!A|E1&!E&D2&D1&!D&C&!B1&B&!A1&!A|E1&E&D2&D1&!D&C&!B1&B&!A1&!A|!E1&E&D2&D1&!D&C&!B1&B&!A1&!A|!E1&E&!D2&D1&!D&C&!B1&B&!A1&!A|E1&E&!D2&D1&!D&C&!B1&B&!A1&!A|E1&!E&!D2&D1&!D&C&!B1&B&!A1&!A|E1&!E&!D2&D1&D&C&!B1&B&!A1&!A|E1&E&!D2&D1&D&C&!B1&B&!A1&!A|!E1&E&!D2&D1&D&C&!B1&B&!A1&!A|!E1&E&D2&D1&D&C&!B1&B&!A1&!A|E1&E&D2&D1&D&C&!B1&B&!A1&!A|E1&!E&D2&D1&D&C&!B1&B&!A1&!A|E1&!E&D2&!D1&D&C&!B1&B&!A1&!A|E1&E&D2&!D1&D&C&!B1&B&!A1&!A|!E1&E&D2&!D1&D&C&!B1&B&!A1&!A|!E1&E&!D2&!D1&D&C&!B1&B&!A1&!A|E1&E&!D2&!D1&D&C&!B1&B&!A1&!A|E1&!E&!D2&!D1&D&C&!B1&B&!A1&!A|E1&!E&!D2&!D1&D&C&!B1&B&A1&!A|E1&E&!D2&!D1&D&C&!B1&B&A1&!A|!E1&E&!D2&!D1&D&C&!B1&B&A1&!A|!E1&E&D2&!D1&D&C&!B1&B&A1&!A|E1&E&D2&!D1&D&C&!B1&B&A1&!A|E1&!E&D2&!D1&D&C&!B1&B&A1&!A|E1&!E&D2&D1&D&C&!B1&B&A1&!A|E1&E&D2&D1&D&C&!B1&B&A1&!A|!E1&E&D2&D1&D&C&!B1&B&A1&!A|!E1&E&!D2&D1&D&C&!B1&B&A1&!A|E1&E&!D2&D1&D&C&!B1&B&A1&!A|E1&!E&!D2&D1&D&C&!B1&B&A1&!A|E1&!E&!D2&D1&!D&C&!B1&B&A1&!A|E1&E&!D2&D1&!D&C&!B1&B&A1&!A|!E1&E&!D2&D1&!D&C&!B1&B&A1&!A|!E1&E&D2&D1&!D&C&!B1&B&A1&!A|E1&E&D2&D1&!D&C&!B1&B&A1&!A|E1&!E&D2&D1&!D&C&!B1&B&A1&!A|E1&!E&D2&!D1&!D&C&!B1&B&A1&!A|E1&E&D2&!D1&!D&C&!B1&B&A1&!A|!E1&E&D2&!D1&!D&C&!B1&B&A1&!A|!E1&E&D2&!D1&!D&C&B1&B&A1&!A|E1&E&D2&!D1&!D&C&B1&B&A1&!A|E1&!E&D2&!D1&!D&C&B1&B&A1&!A|E1&!E&D2&D1&!D&C&B1&B&A1&!A|E1&E&D2&D1&!D&C&B1&B&A1&!A|!E1&E&D2&D1&!D&C&B1&B&A1&!A|!E1&E&!D2&D1&!D&C&B1&B&A1&!A|E1&E&!D2&D1&!D&C&B1&B&A1&!A|E1&!E&!D2&D1&!D&C&B1&B&A1&!A|E1&!E&!D2&D1&D&C&B1&B&A1&!A|E1&E&!D2&D1&D&C&B1&B&A1&!A|!E1&E&!D2&D1&D&C&B1&B&A1&!A|!E1&E&D2&D1&D&C&B1&B&A1&!A|E1&E&D2&D1&D&C&B1&B&A1&!A|E1&!E&D2&D1&D&C&B1&B&A1&!A|E1&!E&D2&!D1&D&C&B1&B&A1&!A|E1&E&D2&!D1&D&C&B1&B&A1&!A|!E1&E&D2&!D1&D&C&B1&B&A1&!A|!E1&E&!D2&!D1&D&C&B1&B&A1&!A|E1&E&!D2&!D1&D&C&B1&B&A1&!A|E1&!E&!D2&!D1&D&C&B1&B&A1&!A|E1&!E&!D2&!D1&D&!C&B1&B&A1&!A|E1&E&!D2&!D1&D&!C&B1&B&A1&!A|!E1&E&!D2&!D1&D&!C&B1&B&A1&!A|!E1&E&D2&!D1&D&!C&B1&B&A1&!A|E1&E&D2&!D1&D&!C&B1&B&A1&!A|E1&!E&D2&!D1&D&!C&B1&B&A1&!A|E1&!E&D2&D1&D&!C&B1&B&A1&!A|E1&E&D2&D1&D&!C&B1&B&A1&!A|!E1&E&D2&D1&D&!C&B1&B&A1&!A|!E1&E&!D2&D1&D&!C&B1&B&A1&!A|E1&E&!D2&D1&D&!C&B1&B&A1&!A|E1&!E&!D2&D1&D&!C&B1&B&A1&!A|E1&!E&!D2&D1&!D&!C&B1&B&A1&!A|E1&E&!D2&D1&!D&!C&B1&B&A1&!A|!E1&E&!D2&D1&!D&!C&B1&B&A1&!A|!E1&E&D2&D1&!D&!C&B1&B&A1&!A|E1&E&D2&D1&!D&!C&B1&B&A1&!A|E1&!E&D2&D1&!D&!C&B1&B&A1&!A|E1&!E&D2&!D1&!D&!C&B1&B&A1&!A|E1&E&D2&!D1&!D&!C&B1&B&A1&!A|!E1&E&D2&!D1&!D&!C&B1&B&A1&!A|E1&!E&!D2&!D1&D&C&B1&!B&A1&!A|E1&E&!D2&!D1&D&C&B1&!B&A1&!A|!E1&E&!D2&!D1&D&C&B1&!B&A1&!A|!E1&E&D2&!D1&D&C&B1&!B&A1&!A|E1&E&D2&!D1&D&C&B1&!B&A1&!A|E1&!E&D2&!D1&D&C&B1&!B&A1&!A|E1&!E&D2&D1&D&C&B1&!B&A1&!A|E1&E&D2&D1&D&C&B1&!B&A1&!A|!E1&E&D2&D1&D&C&B1&!B&A1&!A|!E1&E&!D2&D1&D&C&B1&!B&A1&!A|E1&E&!D2&D1&D&C&B1&!B&A1&!A|E1&!E&!D2&D1&D&C&B1&!B&A1&!A|E1&!E&!D2&D1&!D&C&B1&!B&A1&!A|E1&E&!D2&D1&!D&C&B1&!B&A1&!A|!E1&E&!D2&D1&!D&C&B1&!B&A1&!A|!E1&E&D2&D1&!D&C&B1&!B&A1&!A|E1&E&D2&D1&!D&C&B1&!B&A1&!A|E1&!E&D2&D1&!D&C&B1&!B&A1&!A|E1&!E&D2&!D1&!D&C&B1&!B&A1&!A|E1&E&D2&!D1&!D&C&B1&!B&A1&!A|!E1&E&D2&!D1&!D&C&B1&!B&A1&!A|!E1&E&D2&!D1&!D&C&!B1&!B&A1&!A|E1&E&D2&!D1&!D&C&!B1&!B&A1&!A|E1&!E&D2&!D1&!D&C&!B1&!B&A1&!A|E1&!E&D2&D1&!D&C&!B1&!B&A1&!A|E1&E&D2&D1&!D&C&!B1&!B&A1&!A|!E1&E&D2&D1&!D&C&!B1&!B&A1&!A|!E1&E&!D2&D1&!D&C&!B1&!B&A1&!A|E1&E&!D2&D1&!D&C&!B1&!B&A1&!A|E1&!E&!D2&D1&!D&C&!B1&!B&A1&!A|E1&!E&!D2&D1&D&C&!B1&!B&A1&!A|E1&E&!D2&D1&D&C&!B1&!B&A1&!A|!E1&E&!D2&D1&D&C&!B1&!B&A1&!A|!E1&E&D2&D1&D&C&!B1&!B&A1&!A|E1&E&D2&D1&D&C&!B1&!B&A1&!A|E1&!E&D2&D1&D&C&!B1&!B&A1&!A|E1&!E&D2&!D1&D&C&!B1&!B&A1&!A|E1&E&D2&!D1&D&C&!B1&!B&A1&!A|!E1&E&D2&!D1&D&C&!B1&!B&A1&!A|!E1&E&!D2&!D1&D&C&!B1&!B&A1&!A|E1&E&!D2&!D1&D&C&!B1&!B&A1&!A|E1&!E&!D2&!D1&D&C&!B1&!B&A1&!A|!E1&E&D2&!D1&!D&!C&!B1&!B&A1&A|E1&E&D2&!D1&!D&!C&!B1&!B&A1&A|E1&!E&D2&!D1&!D&!C&!B1&!B&A1&A|E1&!E&D2&D1&!D&!C&!B1&!B&A1&A|E1&E&D2&D1&!D&!C&!B1&!B&A1&A|!E1&E&D2&D1&!D&!C&!B1&!B&A1&A|!E1&E&!D2&D1&!D&!C&!B1&!B&A1&A|E1&E&!D2&D1&!D&!C&!B1&!B&A1&A|E1&!E&!D2&D1&!D&!C&!B1&!B&A1&A|E1&!E&!D2&D1&D&!C&!B1&!B&A1&A|E1&E&!D2&D1&D&!C&!B1&!B&A1&A|!E1&E&!D2&D1&D&!C&!B1&!B&A1&A|!E1&E&D2&D1&D&!C&!B1&!B&A1&A|E1&E&D2&D1&D&!C&!B1&!B&A1&A|E1&!E&D2&D1&D&!C&!B1&!B&A1&A|E1&!E&D2&!D1&D&!C&!B1&!B&A1&A|E1&E&D2&!D1&D&!C&!B1&!B&A1&A|!E1&E&D2&!D1&D&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&D&!C&!B1&!B&A1&A|E1&E&!D2&!D1&D&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&D&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&D&C&!B1&!B&A1&A|E1&E&!D2&!D1&D&C&!B1&!B&A1&A|!E1&E&!D2&!D1&D&C&!B1&!B&A1&A|!E1&E&D2&!D1&D&C&!B1&!B&A1&A|E1&E&D2&!D1&D&C&!B1&!B&A1&A|E1&!E&D2&!D1&D&C&!B1&!B&A1&A|E1&!E&D2&D1&D&C&!B1&!B&A1&A|E1&E&D2&D1&D&C&!B1&!B&A1&A|!E1&E&D2&D1&D&C&!B1&!B&A1&A|!E1&E&!D2&D1&D&C&!B1&!B&A1&A|E1&E&!D2&D1&D&C&!B1&!B&A1&A|E1&!E&!D2&D1&D&C&!B1&!B&A1&A|E1&!E&!D2&D1&!D&C&!B1&!B&A1&A|E1&E&!D2&D1&!D&C&!B1&!B&A1&A|!E1&E&!D2&D1&!D&C&!B1&!B&A1&A|!E1&E&D2&D1&!D&C&!B1&!B&A1&A|E1&E&D2&D1&!D&C&!B1&!B&A1&A|E1&!E&D2&D1&!D&C&!B1&!B&A1&A|E1&!E&D2&!D1&!D&C&!B1&!B&A1&A|E1&E&D2&!D1&!D&C&!B1&!B&A1&A|!E1&E&D2&!D1&!D&C&!B1&!B&A1&A|!E1&E&D2&!D1&!D&C&B1&!B&A1&A|E1&E&D2&!D1&!D&C&B1&!B&A1&A|E1&!E&D2&!D1&!D&C&B1&!B&A1&A|E1&!E&D2&D1&!D&C&B1&!B&A1&A|E1&E&D2&D1&!D&C&B1&!B&A1&A|!E1&E&D2&D1&!D&C&B1&!B&A1&A|!E1&E&!D2&D1&!D&C&B1&!B&A1&A|E1&E&!D2&D1&!D&C&B1&!B&A1&A|E1&!E&!D2&D1&!D&C&B1&!B&A1&A|E1&!E&!D2&D1&D&C&B1&!B&A1&A|E1&E&!D2&D1&D&C&B1&!B&A1&A|!E1&E&!D2&D1&D&C&B1&!B&A1&A|!E1&E&D2&D1&D&C&B1&!B&A1&A|E1&E&D2&D1&D&C&B1&!B&A1&A|E1&!E&D2&D1&D&C&B1&!B&A1&A|E1&!E&D2&!D1&D&C&B1&!B&A1&A|E1&E&D2&!D1&D&C&B1&!B&A1&A|!E1&E&D2&!D1&D&C&B1&!B&A1&A|!E1&E&!D2&!D1&D&C&B1&!B&A1&A|E1&E&!D2&!D1&D&C&B1&!B&A1&A|E1&!E&!D2&!D1&D&C&B1&!B&A1&A|E1&!E&!D2&!D1&D&!C&B1&!B&A1&A|E1&E&!D2&!D1&D&!C&B1&!B&A1&A|!E1&E&!D2&!D1&D&!C&B1&!B&A1&A|!E1&E&D2&!D1&D&!C&B1&!B&A1&A|E1&E&D2&!D1&D&!C&B1&!B&A1&A|E1&!E&D2&!D1&D&!C&B1&!B&A1&A|E1&!E&D2&D1&D&!C&B1&!B&A1&A|E1&E&D2&D1&D&!C&B1&!B&A1&A|!E1&E&D2&D1&D&!C&B1&!B&A1&A|!E1&E&!D2&D1&D&!C&B1&!B&A1&A|E1&E&!D2&D1&D&!C&B1&!B&A1&A|E1&!E&!D2&D1&D&!C&B1&!B&A1&A|E1&!E&!D2&D1&!D&!C&B1&!B&A1&A|E1&E&!D2&D1&!D&!C&B1&!B&A1&A|!E1&E&!D2&D1&!D&!C&B1&!B&A1&A|!E1&E&D2&D1&!D&!C&B1&!B&A1&A|E1&E&D2&D1&!D&!C&B1&!B&A1&A|E1&!E&D2&D1&!D&!C&B1&!B&A1&A|E1&!E&D2&!D1&!D&!C&B1&!B&A1&A|E1&E&D2&!D1&!D&!C&B1&!B&A1&A|!E1&E&D2&!D1&!D&!C&B1&!B&A1&A|!E1&E&D2&!D1&!D&!C&B1&B&A1&A|E1&E&D2&!D1&!D&!C&B1&B&A1&A|E1&!E&D2&!D1&!D&!C&B1&B&A1&A|E1&!E&D2&D1&!D&!C&B1&B&A1&A|E1&E&D2&D1&!D&!C&B1&B&A1&A|!E1&E&D2&D1&!D&!C&B1&B&A1&A|!E1&E&!D2&D1&!D&!C&B1&B&A1&A|E1&E&!D2&D1&!D&!C&B1&B&A1&A|E1&!E&!D2&D1&!D&!C&B1&B&A1&A|E1&!E&!D2&D1&D&!C&B1&B&A1&A|E1&E&!D2&D1&D&!C&B1&B&A1&A|!E1&E&!D2&D1&D&!C&B1&B&A1&A|!E1&E&D2&D1&D&!C&B1&B&A1&A|E1&E&D2&D1&D&!C&B1&B&A1&A|E1&!E&D2&D1&D&!C&B1&B&A1&A|E1&!E&D2&!D1&D&!C&B1&B&A1&A|E1&E&D2&!D1&D&!C&B1&B&A1&A|!E1&E&D2&!D1&D&!C&B1&B&A1&A|!E1&E&!D2&!D1&D&!C&B1&B&A1&A|E1&E&!D2&!D1&D&!C&B1&B&A1&A|E1&!E&!D2&!D1&D&!C&B1&B&A1&A|E1&!E&!D2&!D1&D&C&B1&B&A1&A|E1&E&!D2&!D1&D&C&B1&B&A1&A|!E1&E&!D2&!D1&D&C&B1&B&A1&A|!E1&E&D2&!D1&D&C&B1&B&A1&A|E1&E&D2&!D1&D&C&B1&B&A1&A|E1&!E&D2&!D1&D&C&B1&B&A1&A|E1&!E&D2&D1&D&C&B1&B&A1&A|E1&E&D2&D1&D&C&B1&B&A1&A|!E1&E&D2&D1&D&C&B1&B&A1&A|!E1&E&!D2&D1&D&C&B1&B&A1&A|E1&E&!D2&D1&D&C&B1&B&A1&A|E1&!E&!D2&D1&D&C&B1&B&A1&A|E1&!E&!D2&D1&!D&C&B1&B&A1&A|E1&E&!D2&D1&!D&C&B1&B&A1&A|!E1&E&!D2&D1&!D&C&B1&B&A1&A|!E1&E&D2&D1&!D&C&B1&B&A1&A|E1&E&D2&D1&!D&C&B1&B&A1&A|E1&!E&D2&D1&!D&C&B1&B&A1&A|E1&!E&D2&!D1&!D&C&B1&B&A1&A|E1&E&D2&!D1&!D&C&B1&B&A1&A|!E1&E&D2&!D1&!D&C&B1&B&A1&A|!E1&E&D2&!D1&!D&C&!B1&B&A1&A|E1&E&D2&!D1&!D&C&!B1&B&A1&A|E1&!E&D2&!D1&!D&C&!B1&B&A1&A|E1&!E&D2&D1&!D&C&!B1&B&A1&A|E1&E&D2&D1&!D&C&!B1&B&A1&A|!E1&E&D2&D1&!D&C&!B1&B&A1&A|!E1&E&!D2&D1&!D&C&!B1&B&A1&A|E1&E&!D2&D1&!D&C&!B1&B&A1&A|E1&!E&!D2&D1&!D&C&!B1&B&A1&A|E1&!E&!D2&D1&D&C&!B1&B&A1&A|E1&E&!D2&D1&D&C&!B1&B&A1&A|!E1&E&!D2&D1&D&C&!B1&B&A1&A|!E1&E&D2&D1&D&C&!B1&B&A1&A|E1&E&D2&D1&D&C&!B1&B&A1&A|E1&!E&D2&D1&D&C&!B1&B&A1&A|E1&!E&D2&!D1&D&C&!B1&B&A1&A|E1&E&D2&!D1&D&C&!B1&B&A1&A|!E1&E&D2&!D1&D&C&!B1&B&A1&A|!E1&E&!D2&!D1&D&C&!B1&B&A1&A|E1&E&!D2&!D1&D&C&!B1&B&A1&A|E1&!E&!D2&!D1&D&C&!B1&B&A1&A|E1&!E&!D2&!D1&D&!C&!B1&B&A1&A|E1&E&!D2&!D1&D&!C&!B1&B&A1&A|!E1&E&!D2&!D1&D&!C&!B1&B&A1&A|!E1&E&D2&!D1&D&!C&!B1&B&A1&A|E1&E&D2&!D1&D&!C&!B1&B&A1&A|E1&!E&D2&!D1&D&!C&!B1&B&A1&A|E1&!E&D2&D1&D&!C&!B1&B&A1&A|E1&E&D2&D1&D&!C&!B1&B&A1&A|!E1&E&D2&D1&D&!C&!B1&B&A1&A|!E1&E&!D2&D1&D&!C&!B1&B&A1&A|E1&E&!D2&D1&D&!C&!B1&B&A1&A|E1&!E&!D2&D1&D&!C&!B1&B&A1&A|E1&!E&!D2&D1&!D&!C&!B1&B&A1&A|E1&E&!D2&D1&!D&!C&!B1&B&A1&A|!E1&E&!D2&D1&!D&!C&!B1&B&A1&A|!E1&E&D2&D1&!D&!C&!B1&B&A1&A|E1&E&D2&D1&!D&!C&!B1&B&A1&A|E1&!E&D2&D1&!D&!C&!B1&B&A1&A|E1&!E&D2&!D1&!D&!C&!B1&B&A1&A|E1&E&D2&!D1&!D&!C&!B1&B&A1&A|!E1&E&D2&!D1&!D&!C&!B1&B&A1&A|E1&!E&!D2&!D1&D&C&!B1&B&!A1&A|E1&E&!D2&!D1&D&C&!B1&B&!A1&A|!E1&E&!D2&!D1&D&C&!B1&B&!A1&A|!E1&E&D2&!D1&D&C&!B1&B&!A1&A|E1&E&D2&!D1&D&C&!B1&B&!A1&A|E1&!E&D2&!D1&D&C&!B1&B&!A1&A|E1&!E&D2&D1&D&C&!B1&B&!A1&A|E1&E&D2&D1&D&C&!B1&B&!A1&A|!E1&E&D2&D1&D&C&!B1&B&!A1&A|!E1&E&!D2&D1&D&C&!B1&B&!A1&A|E1&E&!D2&D1&D&C&!B1&B&!A1&A|E1&!E&!D2&D1&D&C&!B1&B&!A1&A|E1&!E&!D2&D1&!D&C&!B1&B&!A1&A|E1&E&!D2&D1&!D&C&!B1&B&!A1&A|!E1&E&!D2&D1&!D&C&!B1&B&!A1&A|!E1&E&D2&D1&!D&C&!B1&B&!A1&A|E1&E&D2&D1&!D&C&!B1&B&!A1&A|E1&!E&D2&D1&!D&C&!B1&B&!A1&A|E1&!E&D2&!D1&!D&C&!B1&B&!A1&A|E1&E&D2&!D1&!D&C&!B1&B&!A1&A|!E1&E&D2&!D1&!D&C&!B1&B&!A1&A|!E1&E&D2&!D1&!D&C&B1&B&!A1&A|E1&E&D2&!D1&!D&C&B1&B&!A1&A|E1&!E&D2&!D1&!D&C&B1&B&!A1&A|E1&!E&D2&D1&!D&C&B1&B&!A1&A|E1&E&D2&D1&!D&C&B1&B&!A1&A|!E1&E&D2&D1&!D&C&B1&B&!A1&A|!E1&E&!D2&D1&!D&C&B1&B&!A1&A|E1&E&!D2&D1&!D&C&B1&B&!A1&A|E1&!E&!D2&D1&!D&C&B1&B&!A1&A|E1&!E&!D2&D1&D&C&B1&B&!A1&A|E1&E&!D2&D1&D&C&B1&B&!A1&A|!E1&E&!D2&D1&D&C&B1&B&!A1&A|!E1&E&D2&D1&D&C&B1&B&!A1&A|E1&E&D2&D1&D&C&B1&B&!A1&A|E1&!E&D2&D1&D&C&B1&B&!A1&A|E1&!E&D2&!D1&D&C&B1&B&!A1&A|E1&E&D2&!D1&D&C&B1&B&!A1&A|!E1&E&D2&!D1&D&C&B1&B&!A1&A|!E1&E&!D2&!D1&D&C&B1&B&!A1&A|E1&E&!D2&!D1&D&C&B1&B&!A1&A|E1&!E&!D2&!D1&D&C&B1&B&!A1&A|E1&!E&!D2&!D1&D&!C&B1&B&!A1&A|E1&E&!D2&!D1&D&!C&B1&B&!A1&A|!E1&E&!D2&!D1&D&!C&B1&B&!A1&A|!E1&E&D2&!D1&D&!C&B1&B&!A1&A|E1&E&D2&!D1&D&!C&B1&B&!A1&A|E1&!E&D2&!D1&D&!C&B1&B&!A1&A|E1&!E&D2&D1&D&!C&B1&B&!A1&A|E1&E&D2&D1&D&!C&B1&B&!A1&A|!E1&E&D2&D1&D&!C&B1&B&!A1&A|!E1&E&!D2&D1&D&!C&B1&B&!A1&A|E1&E&!D2&D1&D&!C&B1&B&!A1&A|E1&!E&!D2&D1&D&!C&B1&B&!A1&A|E1&!E&!D2&D1&!D&!C&B1&B&!A1&A|E1&E&!D2&D1&!D&!C&B1&B&!A1&A|!E1&E&!D2&D1&!D&!C&B1&B&!A1&A|!E1&E&D2&D1&!D&!C&B1&B&!A1&A|E1&E&D2&D1&!D&!C&B1&B&!A1&A|E1&!E&D2&D1&!D&!C&B1&B&!A1&A|E1&!E&D2&!D1&!D&!C&B1&B&!A1&A|E1&E&D2&!D1&!D&!C&B1&B&!A1&A|!E1&E&D2&!D1&!D&!C&B1&B&!A1&A|E1&!E&!D2&!D1&D&C&B1&!B&!A1&A|E1&E&!D2&!D1&D&C&B1&!B&!A1&A|!E1&E&!D2&!D1&D&C&B1&!B&!A1&A|!E1&E&D2&!D1&D&C&B1&!B&!A1&A|E1&E&D2&!D1&D&C&B1&!B&!A1&A|E1&!E&D2&!D1&D&C&B1&!B&!A1&A|E1&!E&D2&D1&D&C&B1&!B&!A1&A|E1&E&D2&D1&D&C&B1&!B&!A1&A|!E1&E&D2&D1&D&C&B1&!B&!A1&A|!E1&E&!D2&D1&D&C&B1&!B&!A1&A|E1&E&!D2&D1&D&C&B1&!B&!A1&A|E1&!E&!D2&D1&D&C&B1&!B&!A1&A|E1&!E&!D2&D1&!D&C&B1&!B&!A1&A|E1&E&!D2&D1&!D&C&B1&!B&!A1&A|!E1&E&!D2&D1&!D&C&B1&!B&!A1&A|!E1&E&D2&D1&!D&C&B1&!B&!A1&A|E1&E&D2&D1&!D&C&B1&!B&!A1&A|E1&!E&D2&D1&!D&C&B1&!B&!A1&A|E1&!E&D2&!D1&!D&C&B1&!B&!A1&A|E1&E&D2&!D1&!D&C&B1&!B&!A1&A|!E1&E&D2&!D1&!D&C&B1&!B&!A1&A|!E1&E&D2&!D1&!D&C&!B1&!B&!A1&A|E1&E&D2&!D1&!D&C&!B1&!B&!A1&A|E1&!E&D2&!D1&!D&C&!B1&!B&!A1&A|E1&!E&D2&D1&!D&C&!B1&!B&!A1&A|E1&E&D2&D1&!D&C&!B1&!B&!A1&A|!E1&E&D2&D1&!D&C&!B1&!B&!A1&A|!E1&E&!D2&D1&!D&C&!B1&!B&!A1&A|E1&E&!D2&D1&!D&C&!B1&!B&!A1&A|E1&!E&!D2&D1&!D&C&!B1&!B&!A1&A|E1&!E&!D2&D1&D&C&!B1&!B&!A1&A|E1&E&!D2&D1&D&C&!B1&!B&!A1&A|!E1&E&!D2&D1&D&C&!B1&!B&!A1&A|!E1&E&D2&D1&D&C&!B1&!B&!A1&A|E1&E&D2&D1&D&C&!B1&!B&!A1&A|E1&!E&D2&D1&D&C&!B1&!B&!A1&A|E1&!E&D2&!D1&D&C&!B1&!B&!A1&A|E1&E&D2&!D1&D&C&!B1&!B&!A1&A|!E1&E&D2&!D1&D&C&!B1&!B&!A1&A|!E1&E&!D2&!D1&D&C&!B1&!B&!A1&A|E1&E&!D2&!D1&D&C&!B1&!B&!A1&A|E1&!E&!D2&!D1&D&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOOAI22132.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAI333 -l OOOAI333 -i C2 C1 C B2 B1 B A2 A1 A -o Y -f Y=(!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!C2&C1&C&B2&B1&!B&!A2&!A1&!A|C2&C1&C&B2&B1&!B&!A2&!A1&!A|C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!C2&C1&C&!B2&B1&B&!A2&!A1&!A|C2&C1&C&!B2&B1&B&!A2&!A1&!A|C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!C2&!C1&C&B2&B1&B&!A2&!A1&!A|C2&!C1&C&B2&B1&B&!A2&!A1&!A|C2&C1&C&B2&B1&B&!A2&!A1&!A|!C2&C1&C&B2&B1&B&!A2&!A1&!A|!C2&C1&!C&B2&B1&B&!A2&!A1&!A|C2&C1&!C&B2&B1&B&!A2&!A1&!A|C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!C2&C1&C&B2&!B1&B&!A2&!A1&!A|C2&C1&C&B2&!B1&B&!A2&!A1&!A|C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|!C2&!C1&!C&B2&!B1&B&A2&!A1&!A|!C2&!C1&!C&B2&B1&B&A2&!A1&!A|!C2&!C1&!C&!B2&B1&B&A2&!A1&!A|!C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|!C2&!C1&!C&B2&B1&!B&A2&!A1&!A|!C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|!C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!C2&C1&C&!B2&!B1&!B&A2&A1&!A|C2&C1&C&!B2&!B1&!B&A2&A1&!A|C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!C2&!C1&!C&B2&!B1&!B&A2&A1&!A|!C2&!C1&!C&B2&B1&!B&A2&A1&!A|!C2&!C1&!C&!B2&B1&!B&A2&A1&!A|!C2&!C1&!C&!B2&B1&B&A2&A1&!A|!C2&!C1&!C&B2&B1&B&A2&A1&!A|!C2&!C1&!C&B2&!B1&B&A2&A1&!A|!C2&!C1&!C&!B2&!B1&B&A2&A1&!A|!C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|!C2&!C1&!C&B2&!B1&B&!A2&A1&!A|!C2&!C1&!C&B2&B1&B&!A2&A1&!A|!C2&!C1&!C&!B2&B1&B&!A2&A1&!A|!C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|!C2&!C1&!C&B2&B1&!B&!A2&A1&!A|!C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|!C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!C2&C1&C&!B2&!B1&!B&!A2&A1&A|C2&C1&C&!B2&!B1&!B&!A2&A1&A|C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!C2&!C1&!C&B2&!B1&!B&!A2&A1&A|!C2&!C1&!C&B2&B1&!B&!A2&A1&A|!C2&!C1&!C&!B2&B1&!B&!A2&A1&A|!C2&!C1&!C&!B2&B1&B&!A2&A1&A|!C2&!C1&!C&B2&B1&B&!A2&A1&A|!C2&!C1&!C&B2&!B1&B&!A2&A1&A|!C2&!C1&!C&!B2&!B1&B&!A2&A1&A|!C2&!C1&!C&!B2&!B1&B&A2&A1&A|!C2&!C1&!C&B2&!B1&B&A2&A1&A|!C2&!C1&!C&B2&B1&B&A2&A1&A|!C2&!C1&!C&!B2&B1&B&A2&A1&A|!C2&!C1&!C&!B2&B1&!B&A2&A1&A|!C2&!C1&!C&B2&B1&!B&A2&A1&A|!C2&!C1&!C&B2&!B1&!B&A2&A1&A|!C2&!C1&C&!B2&!B1&!B&A2&A1&A|C2&!C1&C&!B2&!B1&!B&A2&A1&A|C2&C1&C&!B2&!B1&!B&A2&A1&A|!C2&C1&C&!B2&!B1&!B&A2&A1&A|!C2&C1&!C&!B2&!B1&!B&A2&A1&A|C2&C1&!C&!B2&!B1&!B&A2&A1&A|C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!C2&C1&C&!B2&!B1&!B&A2&!A1&A|C2&C1&C&!B2&!B1&!B&A2&!A1&A|C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!C2&!C1&!C&B2&!B1&!B&A2&!A1&A|!C2&!C1&!C&B2&B1&!B&A2&!A1&A|!C2&!C1&!C&!B2&B1&!B&A2&!A1&A|!C2&!C1&!C&!B2&B1&B&A2&!A1&A|!C2&!C1&!C&B2&B1&B&A2&!A1&A|!C2&!C1&!C&B2&!B1&B&A2&!A1&A|!C2&!C1&!C&!B2&!B1&B&A2&!A1&A|!C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|!C2&!C1&!C&B2&!B1&B&!A2&!A1&A|!C2&!C1&!C&B2&B1&B&!A2&!A1&A|!C2&!C1&!C&!B2&B1&B&!A2&!A1&A|!C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|!C2&!C1&!C&B2&B1&!B&!A2&!A1&A|!C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|!C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAI333.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOI21121 -l AOAAOI21121 -i E D1 D C B A1 A -o Y -f Y=(!E&!D1&!D&!C&!B&!A1&!A|!E&D1&!D&!C&!B&!A1&!A|!E&!D1&D&!C&!B&!A1&!A|!E&!D1&D&C&!B&!A1&!A|!E&D1&!D&C&!B&!A1&!A|!E&!D1&!D&C&!B&!A1&!A|!E&!D1&D&!C&B&!A1&!A|!E&D1&!D&!C&B&!A1&!A|!E&!D1&!D&!C&B&!A1&!A|!E&!D1&!D&!C&B&A1&!A|!E&D1&!D&!C&B&A1&!A|!E&!D1&D&!C&B&A1&!A|!E&!D1&!D&C&!B&A1&!A|!E&D1&!D&C&!B&A1&!A|!E&!D1&D&C&!B&A1&!A|!E&!D1&D&!C&!B&A1&!A|!E&D1&!D&!C&!B&A1&!A|!E&!D1&!D&!C&!B&A1&!A|!E&!D1&!D&!C&!B&A1&A|!E&D1&!D&!C&!B&A1&A|!E&!D1&D&!C&!B&A1&A|!E&!D1&D&!C&B&A1&A|!E&D1&!D&!C&B&A1&A|!E&!D1&!D&!C&B&A1&A|!E&!D1&!D&!C&B&!A1&A|!E&D1&!D&!C&B&!A1&A|!E&!D1&D&!C&B&!A1&A|!E&!D1&!D&C&!B&!A1&A|!E&D1&!D&C&!B&!A1&A|!E&!D1&D&C&!B&!A1&A|!E&!D1&D&!C&!B&!A1&A|!E&D1&!D&!C&!B&!A1&A|!E&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOI21121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOOAI21222 -l AOOAOOAI21222 -i E1 E D1 D C1 C B A1 A -o Y -f Y=(!E1&!E&!D1&!D&!C1&!C&!B&!A1&!A|E1&!E&!D1&!D&!C1&!C&!B&!A1&!A|E1&E&!D1&!D&!C1&!C&!B&!A1&!A|!E1&E&!D1&!D&!C1&!C&!B&!A1&!A|!E1&!E&D1&!D&!C1&!C&!B&!A1&!A|!E1&!E&D1&D&!C1&!C&!B&!A1&!A|!E1&!E&!D1&D&!C1&!C&!B&!A1&!A|!E1&!E&!D1&D&C1&!C&!B&!A1&!A|!E1&!E&D1&D&C1&!C&!B&!A1&!A|!E1&!E&D1&!D&C1&!C&!B&!A1&!A|!E1&E&!D1&!D&C1&!C&!B&!A1&!A|E1&E&!D1&!D&C1&!C&!B&!A1&!A|E1&!E&!D1&!D&C1&!C&!B&!A1&!A|!E1&!E&!D1&!D&C1&!C&!B&!A1&!A|!E1&!E&!D1&!D&C1&C&!B&!A1&!A|E1&!E&!D1&!D&C1&C&!B&!A1&!A|E1&E&!D1&!D&C1&C&!B&!A1&!A|!E1&E&!D1&!D&C1&C&!B&!A1&!A|!E1&!E&D1&!D&C1&C&!B&!A1&!A|!E1&!E&D1&D&C1&C&!B&!A1&!A|!E1&!E&!D1&D&C1&C&!B&!A1&!A|!E1&!E&!D1&D&!C1&C&!B&!A1&!A|!E1&!E&D1&D&!C1&C&!B&!A1&!A|!E1&!E&D1&!D&!C1&C&!B&!A1&!A|!E1&E&!D1&!D&!C1&C&!B&!A1&!A|E1&E&!D1&!D&!C1&C&!B&!A1&!A|E1&!E&!D1&!D&!C1&C&!B&!A1&!A|!E1&!E&!D1&!D&!C1&C&!B&!A1&!A|!E1&!E&!D1&!D&!C1&C&B&!A1&!A|!E1&!E&D1&!D&!C1&C&B&!A1&!A|!E1&!E&D1&D&!C1&C&B&!A1&!A|!E1&!E&!D1&D&!C1&C&B&!A1&!A|!E1&!E&!D1&D&C1&C&B&!A1&!A|!E1&!E&D1&D&C1&C&B&!A1&!A|!E1&!E&D1&!D&C1&C&B&!A1&!A|!E1&!E&!D1&!D&C1&C&B&!A1&!A|!E1&!E&!D1&!D&C1&!C&B&!A1&!A|!E1&!E&D1&!D&C1&!C&B&!A1&!A|!E1&!E&D1&D&C1&!C&B&!A1&!A|!E1&!E&!D1&D&C1&!C&B&!A1&!A|!E1&!E&!D1&D&!C1&!C&B&!A1&!A|!E1&!E&D1&D&!C1&!C&B&!A1&!A|!E1&!E&D1&!D&!C1&!C&B&!A1&!A|!E1&E&!D1&!D&!C1&!C&B&!A1&!A|E1&E&!D1&!D&!C1&!C&B&!A1&!A|E1&!E&!D1&!D&!C1&!C&B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&B&A1&!A|E1&!E&!D1&!D&!C1&!C&B&A1&!A|E1&E&!D1&!D&!C1&!C&B&A1&!A|!E1&E&!D1&!D&!C1&!C&B&A1&!A|!E1&!E&D1&!D&!C1&!C&B&A1&!A|!E1&!E&D1&D&!C1&!C&B&A1&!A|!E1&!E&!D1&D&!C1&!C&B&A1&!A|!E1&!E&!D1&D&C1&!C&B&A1&!A|!E1&!E&D1&D&C1&!C&B&A1&!A|!E1&!E&D1&!D&C1&!C&B&A1&!A|!E1&!E&!D1&!D&C1&!C&B&A1&!A|!E1&!E&!D1&!D&C1&C&B&A1&!A|!E1&!E&D1&!D&C1&C&B&A1&!A|!E1&!E&D1&D&C1&C&B&A1&!A|!E1&!E&!D1&D&C1&C&B&A1&!A|!E1&!E&!D1&D&!C1&C&B&A1&!A|!E1&!E&D1&D&!C1&C&B&A1&!A|!E1&!E&D1&!D&!C1&C&B&A1&!A|!E1&!E&!D1&!D&!C1&C&B&A1&!A|!E1&!E&!D1&!D&!C1&C&!B&A1&!A|E1&!E&!D1&!D&!C1&C&!B&A1&!A|E1&E&!D1&!D&!C1&C&!B&A1&!A|!E1&E&!D1&!D&!C1&C&!B&A1&!A|!E1&!E&D1&!D&!C1&C&!B&A1&!A|!E1&!E&D1&D&!C1&C&!B&A1&!A|!E1&!E&!D1&D&!C1&C&!B&A1&!A|!E1&!E&!D1&D&C1&C&!B&A1&!A|!E1&!E&D1&D&C1&C&!B&A1&!A|!E1&!E&D1&!D&C1&C&!B&A1&!A|!E1&E&!D1&!D&C1&C&!B&A1&!A|E1&E&!D1&!D&C1&C&!B&A1&!A|E1&!E&!D1&!D&C1&C&!B&A1&!A|!E1&!E&!D1&!D&C1&C&!B&A1&!A|!E1&!E&!D1&!D&C1&!C&!B&A1&!A|E1&!E&!D1&!D&C1&!C&!B&A1&!A|E1&E&!D1&!D&C1&!C&!B&A1&!A|!E1&E&!D1&!D&C1&!C&!B&A1&!A|!E1&!E&D1&!D&C1&!C&!B&A1&!A|!E1&!E&D1&D&C1&!C&!B&A1&!A|!E1&!E&!D1&D&C1&!C&!B&A1&!A|!E1&!E&!D1&D&!C1&!C&!B&A1&!A|!E1&!E&D1&D&!C1&!C&!B&A1&!A|!E1&!E&D1&!D&!C1&!C&!B&A1&!A|!E1&E&!D1&!D&!C1&!C&!B&A1&!A|E1&E&!D1&!D&!C1&!C&!B&A1&!A|E1&!E&!D1&!D&!C1&!C&!B&A1&!A|!E1&!E&!D1&!D&!C1&!C&!B&A1&!A|!E1&!E&!D1&!D&!C1&!C&!B&A1&A|E1&!E&!D1&!D&!C1&!C&!B&A1&A|E1&E&!D1&!D&!C1&!C&!B&A1&A|!E1&E&!D1&!D&!C1&!C&!B&A1&A|!E1&!E&D1&!D&!C1&!C&!B&A1&A|!E1&!E&D1&D&!C1&!C&!B&A1&A|!E1&!E&!D1&D&!C1&!C&!B&A1&A|!E1&!E&!D1&D&C1&!C&!B&A1&A|!E1&!E&D1&D&C1&!C&!B&A1&A|!E1&!E&D1&!D&C1&!C&!B&A1&A|!E1&!E&!D1&!D&C1&!C&!B&A1&A|!E1&!E&!D1&!D&C1&C&!B&A1&A|!E1&!E&D1&!D&C1&C&!B&A1&A|!E1&!E&D1&D&C1&C&!B&A1&A|!E1&!E&!D1&D&C1&C&!B&A1&A|!E1&!E&!D1&D&!C1&C&!B&A1&A|!E1&!E&D1&D&!C1&C&!B&A1&A|!E1&!E&D1&!D&!C1&C&!B&A1&A|!E1&!E&!D1&!D&!C1&C&!B&A1&A|!E1&!E&!D1&!D&!C1&C&B&A1&A|!E1&!E&D1&!D&!C1&C&B&A1&A|!E1&!E&D1&D&!C1&C&B&A1&A|!E1&!E&!D1&D&!C1&C&B&A1&A|!E1&!E&!D1&D&C1&C&B&A1&A|!E1&!E&D1&D&C1&C&B&A1&A|!E1&!E&D1&!D&C1&C&B&A1&A|!E1&!E&!D1&!D&C1&C&B&A1&A|!E1&!E&!D1&!D&C1&!C&B&A1&A|!E1&!E&D1&!D&C1&!C&B&A1&A|!E1&!E&D1&D&C1&!C&B&A1&A|!E1&!E&!D1&D&C1&!C&B&A1&A|!E1&!E&!D1&D&!C1&!C&B&A1&A|!E1&!E&D1&D&!C1&!C&B&A1&A|!E1&!E&D1&!D&!C1&!C&B&A1&A|!E1&E&!D1&!D&!C1&!C&B&A1&A|E1&E&!D1&!D&!C1&!C&B&A1&A|E1&!E&!D1&!D&!C1&!C&B&A1&A|!E1&!E&!D1&!D&!C1&!C&B&A1&A|!E1&!E&!D1&!D&!C1&!C&B&!A1&A|E1&!E&!D1&!D&!C1&!C&B&!A1&A|E1&E&!D1&!D&!C1&!C&B&!A1&A|!E1&E&!D1&!D&!C1&!C&B&!A1&A|!E1&!E&D1&!D&!C1&!C&B&!A1&A|!E1&!E&D1&D&!C1&!C&B&!A1&A|!E1&!E&!D1&D&!C1&!C&B&!A1&A|!E1&!E&!D1&D&C1&!C&B&!A1&A|!E1&!E&D1&D&C1&!C&B&!A1&A|!E1&!E&D1&!D&C1&!C&B&!A1&A|!E1&!E&!D1&!D&C1&!C&B&!A1&A|!E1&!E&!D1&!D&C1&C&B&!A1&A|!E1&!E&D1&!D&C1&C&B&!A1&A|!E1&!E&D1&D&C1&C&B&!A1&A|!E1&!E&!D1&D&C1&C&B&!A1&A|!E1&!E&!D1&D&!C1&C&B&!A1&A|!E1&!E&D1&D&!C1&C&B&!A1&A|!E1&!E&D1&!D&!C1&C&B&!A1&A|!E1&!E&!D1&!D&!C1&C&B&!A1&A|!E1&!E&!D1&!D&!C1&C&!B&!A1&A|E1&!E&!D1&!D&!C1&C&!B&!A1&A|E1&E&!D1&!D&!C1&C&!B&!A1&A|!E1&E&!D1&!D&!C1&C&!B&!A1&A|!E1&!E&D1&!D&!C1&C&!B&!A1&A|!E1&!E&D1&D&!C1&C&!B&!A1&A|!E1&!E&!D1&D&!C1&C&!B&!A1&A|!E1&!E&!D1&D&C1&C&!B&!A1&A|!E1&!E&D1&D&C1&C&!B&!A1&A|!E1&!E&D1&!D&C1&C&!B&!A1&A|!E1&E&!D1&!D&C1&C&!B&!A1&A|E1&E&!D1&!D&C1&C&!B&!A1&A|E1&!E&!D1&!D&C1&C&!B&!A1&A|!E1&!E&!D1&!D&C1&C&!B&!A1&A|!E1&!E&!D1&!D&C1&!C&!B&!A1&A|E1&!E&!D1&!D&C1&!C&!B&!A1&A|E1&E&!D1&!D&C1&!C&!B&!A1&A|!E1&E&!D1&!D&C1&!C&!B&!A1&A|!E1&!E&D1&!D&C1&!C&!B&!A1&A|!E1&!E&D1&D&C1&!C&!B&!A1&A|!E1&!E&!D1&D&C1&!C&!B&!A1&A|!E1&!E&!D1&D&!C1&!C&!B&!A1&A|!E1&!E&D1&D&!C1&!C&!B&!A1&A|!E1&!E&D1&!D&!C1&!C&!B&!A1&A|!E1&E&!D1&!D&!C1&!C&!B&!A1&A|E1&E&!D1&!D&!C1&!C&!B&!A1&A|E1&!E&!D1&!D&!C1&!C&!B&!A1&A|!E1&!E&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOOAI21222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOI2222 -l AOOAAOI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B1&!B&!A1&!A|D1&!D&!C1&!C&!B1&!B&!A1&!A|!D1&D&!C1&!C&!B1&!B&!A1&!A|!D1&D&C1&!C&!B1&!B&!A1&!A|D1&!D&C1&!C&!B1&!B&!A1&!A|!D1&!D&C1&!C&!B1&!B&!A1&!A|!D1&!D&C1&C&!B1&!B&!A1&!A|D1&!D&C1&C&!B1&!B&!A1&!A|!D1&D&C1&C&!B1&!B&!A1&!A|!D1&D&!C1&C&!B1&!B&!A1&!A|D1&!D&!C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&!B1&!B&!A1&!A|!D1&D&!C1&!C&B1&!B&!A1&!A|D1&!D&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&B&!A1&!A|D1&!D&!C1&!C&B1&B&!A1&!A|!D1&D&!C1&!C&B1&B&!A1&!A|!D1&D&!C1&!C&!B1&B&!A1&!A|D1&!D&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&A1&!A|D1&!D&!C1&!C&!B1&B&A1&!A|!D1&D&!C1&!C&!B1&B&A1&!A|!D1&D&!C1&!C&B1&B&A1&!A|D1&!D&!C1&!C&B1&B&A1&!A|!D1&!D&!C1&!C&B1&B&A1&!A|!D1&!D&!C1&!C&B1&!B&A1&!A|D1&!D&!C1&!C&B1&!B&A1&!A|!D1&D&!C1&!C&B1&!B&A1&!A|!D1&!D&!C1&C&!B1&!B&A1&!A|D1&!D&!C1&C&!B1&!B&A1&!A|!D1&D&!C1&C&!B1&!B&A1&!A|!D1&D&C1&C&!B1&!B&A1&!A|D1&!D&C1&C&!B1&!B&A1&!A|!D1&!D&C1&C&!B1&!B&A1&!A|!D1&!D&C1&!C&!B1&!B&A1&!A|D1&!D&C1&!C&!B1&!B&A1&!A|!D1&D&C1&!C&!B1&!B&A1&!A|!D1&D&!C1&!C&!B1&!B&A1&!A|D1&!D&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&A|D1&!D&!C1&!C&!B1&!B&A1&A|!D1&D&!C1&!C&!B1&!B&A1&A|!D1&D&!C1&!C&B1&!B&A1&A|D1&!D&!C1&!C&B1&!B&A1&A|!D1&!D&!C1&!C&B1&!B&A1&A|!D1&!D&!C1&!C&B1&B&A1&A|D1&!D&!C1&!C&B1&B&A1&A|!D1&D&!C1&!C&B1&B&A1&A|!D1&D&!C1&!C&!B1&B&A1&A|D1&!D&!C1&!C&!B1&B&A1&A|!D1&!D&!C1&!C&!B1&B&A1&A|!D1&!D&!C1&!C&!B1&B&!A1&A|D1&!D&!C1&!C&!B1&B&!A1&A|!D1&D&!C1&!C&!B1&B&!A1&A|!D1&D&!C1&!C&B1&B&!A1&A|D1&!D&!C1&!C&B1&B&!A1&A|!D1&!D&!C1&!C&B1&B&!A1&A|!D1&!D&!C1&!C&B1&!B&!A1&A|D1&!D&!C1&!C&B1&!B&!A1&A|!D1&D&!C1&!C&B1&!B&!A1&A|!D1&!D&!C1&C&!B1&!B&!A1&A|D1&!D&!C1&C&!B1&!B&!A1&A|!D1&D&!C1&C&!B1&!B&!A1&A|!D1&D&C1&C&!B1&!B&!A1&A|D1&!D&C1&C&!B1&!B&!A1&A|!D1&!D&C1&C&!B1&!B&!A1&A|!D1&!D&C1&!C&!B1&!B&!A1&A|D1&!D&C1&!C&!B1&!B&!A1&A|!D1&D&C1&!C&!B1&!B&!A1&A|!D1&D&!C1&!C&!B1&!B&!A1&A|D1&!D&!C1&!C&!B1&!B&!A1&A|!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAAOAOI222211 -l OOOAAOAOI222211 -i F E D1 D C1 C B1 B A1 A -o Y -f Y=(!F&!E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D1&D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&!D1&D&C1&!C&!B1&!B&!A1&!A|!F&E&!D1&D&C1&!C&!B1&!B&!A1&!A|!F&!E&D1&D&C1&!C&!B1&!B&!A1&!A|!F&!E&D1&!D&C1&!C&!B1&!B&!A1&!A|!F&E&D1&!D&C1&!C&!B1&!B&!A1&!A|!F&E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D1&!D&C1&C&!B1&!B&!A1&!A|!F&E&!D1&!D&C1&C&!B1&!B&!A1&!A|!F&E&D1&!D&C1&C&!B1&!B&!A1&!A|!F&!E&D1&!D&C1&C&!B1&!B&!A1&!A|!F&!E&D1&D&C1&C&!B1&!B&!A1&!A|!F&E&!D1&D&C1&C&!B1&!B&!A1&!A|!F&!E&!D1&D&C1&C&!B1&!B&!A1&!A|!F&!E&!D1&D&!C1&C&!B1&!B&!A1&!A|!F&E&!D1&D&!C1&C&!B1&!B&!A1&!A|!F&!E&D1&D&!C1&C&!B1&!B&!A1&!A|!F&!E&D1&!D&!C1&C&!B1&!B&!A1&!A|!F&E&D1&!D&!C1&C&!B1&!B&!A1&!A|!F&E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D1&!D&!C1&C&B1&!B&!A1&!A|!F&E&!D1&!D&!C1&C&B1&!B&!A1&!A|!F&E&D1&!D&!C1&C&B1&!B&!A1&!A|!F&!E&D1&!D&!C1&C&B1&!B&!A1&!A|!F&!E&D1&D&!C1&C&B1&!B&!A1&!A|!F&E&!D1&D&!C1&C&B1&!B&!A1&!A|!F&!E&!D1&D&!C1&C&B1&!B&!A1&!A|!F&!E&!D1&D&C1&C&B1&!B&!A1&!A|!F&E&!D1&D&C1&C&B1&!B&!A1&!A|!F&!E&D1&D&C1&C&B1&!B&!A1&!A|!F&!E&D1&!D&C1&C&B1&!B&!A1&!A|!F&E&D1&!D&C1&C&B1&!B&!A1&!A|!F&E&!D1&!D&C1&C&B1&!B&!A1&!A|!F&!E&!D1&!D&C1&C&B1&!B&!A1&!A|!F&!E&!D1&!D&C1&!C&B1&!B&!A1&!A|!F&E&!D1&!D&C1&!C&B1&!B&!A1&!A|!F&E&D1&!D&C1&!C&B1&!B&!A1&!A|!F&!E&D1&!D&C1&!C&B1&!B&!A1&!A|!F&!E&D1&D&C1&!C&B1&!B&!A1&!A|!F&E&!D1&D&C1&!C&B1&!B&!A1&!A|!F&!E&!D1&D&C1&!C&B1&!B&!A1&!A|!F&!E&!D1&D&!C1&!C&B1&!B&!A1&!A|!F&E&!D1&D&!C1&!C&B1&!B&!A1&!A|!F&!E&D1&D&!C1&!C&B1&!B&!A1&!A|!F&!E&D1&!D&!C1&!C&B1&!B&!A1&!A|!F&E&D1&!D&!C1&!C&B1&!B&!A1&!A|!F&E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D1&!D&!C1&!C&B1&B&!A1&!A|!F&E&!D1&!D&!C1&!C&B1&B&!A1&!A|!F&E&D1&!D&!C1&!C&B1&B&!A1&!A|!F&!E&D1&!D&!C1&!C&B1&B&!A1&!A|!F&!E&D1&D&!C1&!C&B1&B&!A1&!A|!F&E&!D1&D&!C1&!C&B1&B&!A1&!A|!F&!E&!D1&D&!C1&!C&B1&B&!A1&!A|!F&!E&!D1&D&C1&!C&B1&B&!A1&!A|!F&E&!D1&D&C1&!C&B1&B&!A1&!A|!F&!E&D1&D&C1&!C&B1&B&!A1&!A|!F&!E&D1&!D&C1&!C&B1&B&!A1&!A|!F&E&D1&!D&C1&!C&B1&B&!A1&!A|!F&E&!D1&!D&C1&!C&B1&B&!A1&!A|!F&!E&!D1&!D&C1&!C&B1&B&!A1&!A|!F&!E&!D1&!D&C1&C&B1&B&!A1&!A|!F&E&!D1&!D&C1&C&B1&B&!A1&!A|!F&E&D1&!D&C1&C&B1&B&!A1&!A|!F&!E&D1&!D&C1&C&B1&B&!A1&!A|!F&!E&D1&D&C1&C&B1&B&!A1&!A|!F&E&!D1&D&C1&C&B1&B&!A1&!A|!F&!E&!D1&D&C1&C&B1&B&!A1&!A|!F&!E&!D1&D&!C1&C&B1&B&!A1&!A|!F&E&!D1&D&!C1&C&B1&B&!A1&!A|!F&!E&D1&D&!C1&C&B1&B&!A1&!A|!F&!E&D1&!D&!C1&C&B1&B&!A1&!A|!F&E&D1&!D&!C1&C&B1&B&!A1&!A|!F&E&!D1&!D&!C1&C&B1&B&!A1&!A|!F&!E&!D1&!D&!C1&C&B1&B&!A1&!A|!F&!E&!D1&!D&!C1&C&!B1&B&!A1&!A|!F&E&!D1&!D&!C1&C&!B1&B&!A1&!A|!F&E&D1&!D&!C1&C&!B1&B&!A1&!A|!F&!E&D1&!D&!C1&C&!B1&B&!A1&!A|!F&!E&D1&D&!C1&C&!B1&B&!A1&!A|!F&E&!D1&D&!C1&C&!B1&B&!A1&!A|!F&!E&!D1&D&!C1&C&!B1&B&!A1&!A|!F&!E&!D1&D&C1&C&!B1&B&!A1&!A|!F&E&!D1&D&C1&C&!B1&B&!A1&!A|!F&!E&D1&D&C1&C&!B1&B&!A1&!A|!F&!E&D1&!D&C1&C&!B1&B&!A1&!A|!F&E&D1&!D&C1&C&!B1&B&!A1&!A|!F&E&!D1&!D&C1&C&!B1&B&!A1&!A|!F&!E&!D1&!D&C1&C&!B1&B&!A1&!A|!F&!E&!D1&!D&C1&!C&!B1&B&!A1&!A|!F&E&!D1&!D&C1&!C&!B1&B&!A1&!A|!F&E&D1&!D&C1&!C&!B1&B&!A1&!A|!F&!E&D1&!D&C1&!C&!B1&B&!A1&!A|!F&!E&D1&D&C1&!C&!B1&B&!A1&!A|!F&E&!D1&D&C1&!C&!B1&B&!A1&!A|!F&!E&!D1&D&C1&!C&!B1&B&!A1&!A|!F&!E&!D1&D&!C1&!C&!B1&B&!A1&!A|!F&E&!D1&D&!C1&!C&!B1&B&!A1&!A|!F&!E&D1&D&!C1&!C&!B1&B&!A1&!A|!F&!E&D1&!D&!C1&!C&!B1&B&!A1&!A|!F&E&D1&!D&!C1&!C&!B1&B&!A1&!A|!F&E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D1&!D&!C1&!C&!B1&B&A1&!A|!F&E&!D1&!D&!C1&!C&!B1&B&A1&!A|!F&E&D1&!D&!C1&!C&!B1&B&A1&!A|!F&!E&D1&!D&!C1&!C&!B1&B&A1&!A|!F&!E&D1&D&!C1&!C&!B1&B&A1&!A|!F&E&!D1&D&!C1&!C&!B1&B&A1&!A|!F&!E&!D1&D&!C1&!C&!B1&B&A1&!A|!F&!E&!D1&D&C1&!C&!B1&B&A1&!A|!F&!E&D1&D&C1&!C&!B1&B&A1&!A|!F&!E&D1&!D&C1&!C&!B1&B&A1&!A|!F&!E&!D1&!D&C1&!C&!B1&B&A1&!A|!F&!E&!D1&!D&C1&C&!B1&B&A1&!A|!F&!E&D1&!D&C1&C&!B1&B&A1&!A|!F&!E&D1&D&C1&C&!B1&B&A1&!A|!F&!E&!D1&D&C1&C&!B1&B&A1&!A|!F&!E&!D1&D&!C1&C&!B1&B&A1&!A|!F&!E&D1&D&!C1&C&!B1&B&A1&!A|!F&!E&D1&!D&!C1&C&!B1&B&A1&!A|!F&!E&!D1&!D&!C1&C&!B1&B&A1&!A|!F&!E&!D1&!D&!C1&C&B1&B&A1&!A|!F&!E&D1&!D&!C1&C&B1&B&A1&!A|!F&!E&D1&D&!C1&C&B1&B&A1&!A|!F&!E&!D1&D&!C1&C&B1&B&A1&!A|!F&!E&!D1&D&C1&C&B1&B&A1&!A|!F&!E&D1&D&C1&C&B1&B&A1&!A|!F&!E&D1&!D&C1&C&B1&B&A1&!A|!F&!E&!D1&!D&C1&C&B1&B&A1&!A|!F&!E&!D1&!D&C1&!C&B1&B&A1&!A|!F&!E&D1&!D&C1&!C&B1&B&A1&!A|!F&!E&D1&D&C1&!C&B1&B&A1&!A|!F&!E&!D1&D&C1&!C&B1&B&A1&!A|!F&!E&!D1&D&!C1&!C&B1&B&A1&!A|!F&E&!D1&D&!C1&!C&B1&B&A1&!A|!F&!E&D1&D&!C1&!C&B1&B&A1&!A|!F&!E&D1&!D&!C1&!C&B1&B&A1&!A|!F&E&D1&!D&!C1&!C&B1&B&A1&!A|!F&E&!D1&!D&!C1&!C&B1&B&A1&!A|!F&!E&!D1&!D&!C1&!C&B1&B&A1&!A|!F&!E&!D1&!D&!C1&!C&B1&!B&A1&!A|!F&E&!D1&!D&!C1&!C&B1&!B&A1&!A|!F&E&D1&!D&!C1&!C&B1&!B&A1&!A|!F&!E&D1&!D&!C1&!C&B1&!B&A1&!A|!F&!E&D1&D&!C1&!C&B1&!B&A1&!A|!F&E&!D1&D&!C1&!C&B1&!B&A1&!A|!F&!E&!D1&D&!C1&!C&B1&!B&A1&!A|!F&!E&!D1&D&C1&!C&B1&!B&A1&!A|!F&!E&D1&D&C1&!C&B1&!B&A1&!A|!F&!E&D1&!D&C1&!C&B1&!B&A1&!A|!F&!E&!D1&!D&C1&!C&B1&!B&A1&!A|!F&!E&!D1&!D&C1&C&B1&!B&A1&!A|!F&!E&D1&!D&C1&C&B1&!B&A1&!A|!F&!E&D1&D&C1&C&B1&!B&A1&!A|!F&!E&!D1&D&C1&C&B1&!B&A1&!A|!F&!E&!D1&D&!C1&C&B1&!B&A1&!A|!F&!E&D1&D&!C1&C&B1&!B&A1&!A|!F&!E&D1&!D&!C1&C&B1&!B&A1&!A|!F&!E&!D1&!D&!C1&C&B1&!B&A1&!A|!F&!E&!D1&!D&!C1&C&!B1&!B&A1&!A|!F&E&!D1&!D&!C1&C&!B1&!B&A1&!A|!F&E&D1&!D&!C1&C&!B1&!B&A1&!A|!F&!E&D1&!D&!C1&C&!B1&!B&A1&!A|!F&!E&D1&D&!C1&C&!B1&!B&A1&!A|!F&E&!D1&D&!C1&C&!B1&!B&A1&!A|!F&!E&!D1&D&!C1&C&!B1&!B&A1&!A|!F&!E&!D1&D&C1&C&!B1&!B&A1&!A|!F&E&!D1&D&C1&C&!B1&!B&A1&!A|!F&!E&D1&D&C1&C&!B1&!B&A1&!A|!F&!E&D1&!D&C1&C&!B1&!B&A1&!A|!F&E&D1&!D&C1&C&!B1&!B&A1&!A|!F&E&!D1&!D&C1&C&!B1&!B&A1&!A|!F&!E&!D1&!D&C1&C&!B1&!B&A1&!A|!F&!E&!D1&!D&C1&!C&!B1&!B&A1&!A|!F&E&!D1&!D&C1&!C&!B1&!B&A1&!A|!F&E&D1&!D&C1&!C&!B1&!B&A1&!A|!F&!E&D1&!D&C1&!C&!B1&!B&A1&!A|!F&!E&D1&D&C1&!C&!B1&!B&A1&!A|!F&E&!D1&D&C1&!C&!B1&!B&A1&!A|!F&!E&!D1&D&C1&!C&!B1&!B&A1&!A|!F&!E&!D1&D&!C1&!C&!B1&!B&A1&!A|!F&E&!D1&D&!C1&!C&!B1&!B&A1&!A|!F&!E&D1&D&!C1&!C&!B1&!B&A1&!A|!F&!E&D1&!D&!C1&!C&!B1&!B&A1&!A|!F&E&D1&!D&!C1&!C&!B1&!B&A1&!A|!F&E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D1&!D&!C1&!C&!B1&!B&A1&A|!F&E&!D1&!D&!C1&!C&!B1&!B&A1&A|!F&E&D1&!D&!C1&!C&!B1&!B&A1&A|!F&!E&D1&!D&!C1&!C&!B1&!B&A1&A|!F&!E&D1&D&!C1&!C&!B1&!B&A1&A|!F&E&!D1&D&!C1&!C&!B1&!B&A1&A|!F&!E&!D1&D&!C1&!C&!B1&!B&A1&A|!F&!E&!D1&D&C1&!C&!B1&!B&A1&A|!F&E&!D1&D&C1&!C&!B1&!B&A1&A|!F&!E&D1&D&C1&!C&!B1&!B&A1&A|!F&!E&D1&!D&C1&!C&!B1&!B&A1&A|!F&E&D1&!D&C1&!C&!B1&!B&A1&A|!F&E&!D1&!D&C1&!C&!B1&!B&A1&A|!F&!E&!D1&!D&C1&!C&!B1&!B&A1&A|!F&!E&!D1&!D&C1&C&!B1&!B&A1&A|!F&E&!D1&!D&C1&C&!B1&!B&A1&A|!F&E&D1&!D&C1&C&!B1&!B&A1&A|!F&!E&D1&!D&C1&C&!B1&!B&A1&A|!F&!E&D1&D&C1&C&!B1&!B&A1&A|!F&E&!D1&D&C1&C&!B1&!B&A1&A|!F&!E&!D1&D&C1&C&!B1&!B&A1&A|!F&!E&!D1&D&!C1&C&!B1&!B&A1&A|!F&E&!D1&D&!C1&C&!B1&!B&A1&A|!F&!E&D1&D&!C1&C&!B1&!B&A1&A|!F&!E&D1&!D&!C1&C&!B1&!B&A1&A|!F&E&D1&!D&!C1&C&!B1&!B&A1&A|!F&E&!D1&!D&!C1&C&!B1&!B&A1&A|!F&!E&!D1&!D&!C1&C&!B1&!B&A1&A|!F&!E&!D1&!D&!C1&C&B1&!B&A1&A|!F&!E&D1&!D&!C1&C&B1&!B&A1&A|!F&!E&D1&D&!C1&C&B1&!B&A1&A|!F&!E&!D1&D&!C1&C&B1&!B&A1&A|!F&!E&!D1&D&C1&C&B1&!B&A1&A|!F&!E&D1&D&C1&C&B1&!B&A1&A|!F&!E&D1&!D&C1&C&B1&!B&A1&A|!F&!E&!D1&!D&C1&C&B1&!B&A1&A|!F&!E&!D1&!D&C1&!C&B1&!B&A1&A|!F&!E&D1&!D&C1&!C&B1&!B&A1&A|!F&!E&D1&D&C1&!C&B1&!B&A1&A|!F&!E&!D1&D&C1&!C&B1&!B&A1&A|!F&!E&!D1&D&!C1&!C&B1&!B&A1&A|!F&E&!D1&D&!C1&!C&B1&!B&A1&A|!F&!E&D1&D&!C1&!C&B1&!B&A1&A|!F&!E&D1&!D&!C1&!C&B1&!B&A1&A|!F&E&D1&!D&!C1&!C&B1&!B&A1&A|!F&E&!D1&!D&!C1&!C&B1&!B&A1&A|!F&!E&!D1&!D&!C1&!C&B1&!B&A1&A|!F&!E&!D1&!D&!C1&!C&B1&B&A1&A|!F&E&!D1&!D&!C1&!C&B1&B&A1&A|!F&E&D1&!D&!C1&!C&B1&B&A1&A|!F&!E&D1&!D&!C1&!C&B1&B&A1&A|!F&!E&D1&D&!C1&!C&B1&B&A1&A|!F&E&!D1&D&!C1&!C&B1&B&A1&A|!F&!E&!D1&D&!C1&!C&B1&B&A1&A|!F&!E&!D1&D&C1&!C&B1&B&A1&A|!F&!E&D1&D&C1&!C&B1&B&A1&A|!F&!E&D1&!D&C1&!C&B1&B&A1&A|!F&!E&!D1&!D&C1&!C&B1&B&A1&A|!F&!E&!D1&!D&C1&C&B1&B&A1&A|!F&!E&D1&!D&C1&C&B1&B&A1&A|!F&!E&D1&D&C1&C&B1&B&A1&A|!F&!E&!D1&D&C1&C&B1&B&A1&A|!F&!E&!D1&D&!C1&C&B1&B&A1&A|!F&!E&D1&D&!C1&C&B1&B&A1&A|!F&!E&D1&!D&!C1&C&B1&B&A1&A|!F&!E&!D1&!D&!C1&C&B1&B&A1&A|!F&!E&!D1&!D&!C1&C&!B1&B&A1&A|!F&!E&D1&!D&!C1&C&!B1&B&A1&A|!F&!E&D1&D&!C1&C&!B1&B&A1&A|!F&!E&!D1&D&!C1&C&!B1&B&A1&A|!F&!E&!D1&D&C1&C&!B1&B&A1&A|!F&!E&D1&D&C1&C&!B1&B&A1&A|!F&!E&D1&!D&C1&C&!B1&B&A1&A|!F&!E&!D1&!D&C1&C&!B1&B&A1&A|!F&!E&!D1&!D&C1&!C&!B1&B&A1&A|!F&!E&D1&!D&C1&!C&!B1&B&A1&A|!F&!E&D1&D&C1&!C&!B1&B&A1&A|!F&!E&!D1&D&C1&!C&!B1&B&A1&A|!F&!E&!D1&D&!C1&!C&!B1&B&A1&A|!F&E&!D1&D&!C1&!C&!B1&B&A1&A|!F&!E&D1&D&!C1&!C&!B1&B&A1&A|!F&!E&D1&!D&!C1&!C&!B1&B&A1&A|!F&E&D1&!D&!C1&!C&!B1&B&A1&A|!F&E&!D1&!D&!C1&!C&!B1&B&A1&A|!F&!E&!D1&!D&!C1&!C&!B1&B&A1&A|!F&!E&!D1&!D&!C1&!C&!B1&B&!A1&A|!F&E&!D1&!D&!C1&!C&!B1&B&!A1&A|!F&E&D1&!D&!C1&!C&!B1&B&!A1&A|!F&!E&D1&!D&!C1&!C&!B1&B&!A1&A|!F&!E&D1&D&!C1&!C&!B1&B&!A1&A|!F&E&!D1&D&!C1&!C&!B1&B&!A1&A|!F&!E&!D1&D&!C1&!C&!B1&B&!A1&A|!F&!E&!D1&D&C1&!C&!B1&B&!A1&A|!F&!E&D1&D&C1&!C&!B1&B&!A1&A|!F&!E&D1&!D&C1&!C&!B1&B&!A1&A|!F&!E&!D1&!D&C1&!C&!B1&B&!A1&A|!F&!E&!D1&!D&C1&C&!B1&B&!A1&A|!F&!E&D1&!D&C1&C&!B1&B&!A1&A|!F&!E&D1&D&C1&C&!B1&B&!A1&A|!F&!E&!D1&D&C1&C&!B1&B&!A1&A|!F&!E&!D1&D&!C1&C&!B1&B&!A1&A|!F&!E&D1&D&!C1&C&!B1&B&!A1&A|!F&!E&D1&!D&!C1&C&!B1&B&!A1&A|!F&!E&!D1&!D&!C1&C&!B1&B&!A1&A|!F&!E&!D1&!D&!C1&C&B1&B&!A1&A|!F&!E&D1&!D&!C1&C&B1&B&!A1&A|!F&!E&D1&D&!C1&C&B1&B&!A1&A|!F&!E&!D1&D&!C1&C&B1&B&!A1&A|!F&!E&!D1&D&C1&C&B1&B&!A1&A|!F&!E&D1&D&C1&C&B1&B&!A1&A|!F&!E&D1&!D&C1&C&B1&B&!A1&A|!F&!E&!D1&!D&C1&C&B1&B&!A1&A|!F&!E&!D1&!D&C1&!C&B1&B&!A1&A|!F&!E&D1&!D&C1&!C&B1&B&!A1&A|!F&!E&D1&D&C1&!C&B1&B&!A1&A|!F&!E&!D1&D&C1&!C&B1&B&!A1&A|!F&!E&!D1&D&!C1&!C&B1&B&!A1&A|!F&E&!D1&D&!C1&!C&B1&B&!A1&A|!F&!E&D1&D&!C1&!C&B1&B&!A1&A|!F&!E&D1&!D&!C1&!C&B1&B&!A1&A|!F&E&D1&!D&!C1&!C&B1&B&!A1&A|!F&E&!D1&!D&!C1&!C&B1&B&!A1&A|!F&!E&!D1&!D&!C1&!C&B1&B&!A1&A|!F&!E&!D1&!D&!C1&!C&B1&!B&!A1&A|!F&E&!D1&!D&!C1&!C&B1&!B&!A1&A|!F&E&D1&!D&!C1&!C&B1&!B&!A1&A|!F&!E&D1&!D&!C1&!C&B1&!B&!A1&A|!F&!E&D1&D&!C1&!C&B1&!B&!A1&A|!F&E&!D1&D&!C1&!C&B1&!B&!A1&A|!F&!E&!D1&D&!C1&!C&B1&!B&!A1&A|!F&!E&!D1&D&C1&!C&B1&!B&!A1&A|!F&!E&D1&D&C1&!C&B1&!B&!A1&A|!F&!E&D1&!D&C1&!C&B1&!B&!A1&A|!F&!E&!D1&!D&C1&!C&B1&!B&!A1&A|!F&!E&!D1&!D&C1&C&B1&!B&!A1&A|!F&!E&D1&!D&C1&C&B1&!B&!A1&A|!F&!E&D1&D&C1&C&B1&!B&!A1&A|!F&!E&!D1&D&C1&C&B1&!B&!A1&A|!F&!E&!D1&D&!C1&C&B1&!B&!A1&A|!F&!E&D1&D&!C1&C&B1&!B&!A1&A|!F&!E&D1&!D&!C1&C&B1&!B&!A1&A|!F&!E&!D1&!D&!C1&C&B1&!B&!A1&A|!F&!E&!D1&!D&!C1&C&!B1&!B&!A1&A|!F&E&!D1&!D&!C1&C&!B1&!B&!A1&A|!F&E&D1&!D&!C1&C&!B1&!B&!A1&A|!F&!E&D1&!D&!C1&C&!B1&!B&!A1&A|!F&!E&D1&D&!C1&C&!B1&!B&!A1&A|!F&E&!D1&D&!C1&C&!B1&!B&!A1&A|!F&!E&!D1&D&!C1&C&!B1&!B&!A1&A|!F&!E&!D1&D&C1&C&!B1&!B&!A1&A|!F&E&!D1&D&C1&C&!B1&!B&!A1&A|!F&!E&D1&D&C1&C&!B1&!B&!A1&A|!F&!E&D1&!D&C1&C&!B1&!B&!A1&A|!F&E&D1&!D&C1&C&!B1&!B&!A1&A|!F&E&!D1&!D&C1&C&!B1&!B&!A1&A|!F&!E&!D1&!D&C1&C&!B1&!B&!A1&A|!F&!E&!D1&!D&C1&!C&!B1&!B&!A1&A|!F&E&!D1&!D&C1&!C&!B1&!B&!A1&A|!F&E&D1&!D&C1&!C&!B1&!B&!A1&A|!F&!E&D1&!D&C1&!C&!B1&!B&!A1&A|!F&!E&D1&D&C1&!C&!B1&!B&!A1&A|!F&E&!D1&D&C1&!C&!B1&!B&!A1&A|!F&!E&!D1&D&C1&!C&!B1&!B&!A1&A|!F&!E&!D1&D&!C1&!C&!B1&!B&!A1&A|!F&E&!D1&D&!C1&!C&!B1&!B&!A1&A|!F&!E&D1&D&!C1&!C&!B1&!B&!A1&A|!F&!E&D1&!D&!C1&!C&!B1&!B&!A1&A|!F&E&D1&!D&!C1&!C&!B1&!B&!A1&A|!F&E&!D1&!D&!C1&!C&!B1&!B&!A1&A|!F&!E&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAAOAOI222211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOAI3211 -l OOAOAI3211 -i D C B1 B A2 A1 A -o Y -f Y=!(D&C&!B1&!B&!A2&!A1&!A|D&C&B1&!B&!A2&!A1&!A|D&C&B1&B&!A2&!A1&!A|D&C&!B1&B&!A2&!A1&!A|D&!C&!B1&B&A2&!A1&!A|D&C&!B1&B&A2&!A1&!A|D&C&B1&B&A2&!A1&!A|D&!C&B1&B&A2&!A1&!A|D&!C&B1&!B&A2&!A1&!A|D&C&B1&!B&A2&!A1&!A|D&C&!B1&!B&A2&!A1&!A|D&C&!B1&!B&A2&A1&!A|D&C&B1&!B&A2&A1&!A|D&!C&B1&!B&A2&A1&!A|D&!C&B1&B&A2&A1&!A|D&C&B1&B&A2&A1&!A|D&C&!B1&B&A2&A1&!A|D&!C&!B1&B&A2&A1&!A|D&!C&!B1&B&!A2&A1&!A|D&C&!B1&B&!A2&A1&!A|D&C&B1&B&!A2&A1&!A|D&!C&B1&B&!A2&A1&!A|D&!C&B1&!B&!A2&A1&!A|D&C&B1&!B&!A2&A1&!A|D&C&!B1&!B&!A2&A1&!A|D&C&!B1&!B&!A2&A1&A|D&C&B1&!B&!A2&A1&A|D&!C&B1&!B&!A2&A1&A|D&!C&B1&B&!A2&A1&A|D&C&B1&B&!A2&A1&A|D&C&!B1&B&!A2&A1&A|D&!C&!B1&B&!A2&A1&A|D&!C&!B1&B&A2&A1&A|D&C&!B1&B&A2&A1&A|D&C&B1&B&A2&A1&A|D&!C&B1&B&A2&A1&A|D&!C&B1&!B&A2&A1&A|D&C&B1&!B&A2&A1&A|D&C&!B1&!B&A2&A1&A|D&C&!B1&!B&A2&!A1&A|D&C&B1&!B&A2&!A1&A|D&!C&B1&!B&A2&!A1&A|D&!C&B1&B&A2&!A1&A|D&C&B1&B&A2&!A1&A|D&C&!B1&B&A2&!A1&A|D&!C&!B1&B&A2&!A1&A|D&!C&!B1&B&!A2&!A1&A|D&C&!B1&B&!A2&!A1&A|D&C&B1&B&!A2&!A1&A|D&!C&B1&B&!A2&!A1&A|D&!C&B1&!B&!A2&!A1&A|D&C&B1&!B&!A2&!A1&A|D&C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOAI3211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAI3221 -l OOOAI3221 -i D C1 C B1 B A2 A1 A -o Y -f Y=!(D&C1&!C&!B1&B&A2&!A1&!A|D&C1&C&!B1&B&A2&!A1&!A|D&!C1&C&!B1&B&A2&!A1&!A|D&!C1&C&B1&B&A2&!A1&!A|D&C1&C&B1&B&A2&!A1&!A|D&C1&!C&B1&B&A2&!A1&!A|D&C1&!C&B1&!B&A2&!A1&!A|D&C1&C&B1&!B&A2&!A1&!A|D&!C1&C&B1&!B&A2&!A1&!A|D&!C1&C&B1&!B&A2&A1&!A|D&C1&C&B1&!B&A2&A1&!A|D&C1&!C&B1&!B&A2&A1&!A|D&C1&!C&B1&B&A2&A1&!A|D&C1&C&B1&B&A2&A1&!A|D&!C1&C&B1&B&A2&A1&!A|D&!C1&C&!B1&B&A2&A1&!A|D&C1&C&!B1&B&A2&A1&!A|D&C1&!C&!B1&B&A2&A1&!A|D&C1&!C&!B1&B&!A2&A1&!A|D&C1&C&!B1&B&!A2&A1&!A|D&!C1&C&!B1&B&!A2&A1&!A|D&!C1&C&B1&B&!A2&A1&!A|D&C1&C&B1&B&!A2&A1&!A|D&C1&!C&B1&B&!A2&A1&!A|D&C1&!C&B1&!B&!A2&A1&!A|D&C1&C&B1&!B&!A2&A1&!A|D&!C1&C&B1&!B&!A2&A1&!A|D&!C1&C&B1&!B&!A2&A1&A|D&C1&C&B1&!B&!A2&A1&A|D&C1&!C&B1&!B&!A2&A1&A|D&C1&!C&B1&B&!A2&A1&A|D&C1&C&B1&B&!A2&A1&A|D&!C1&C&B1&B&!A2&A1&A|D&!C1&C&!B1&B&!A2&A1&A|D&C1&C&!B1&B&!A2&A1&A|D&C1&!C&!B1&B&!A2&A1&A|D&C1&!C&!B1&B&A2&A1&A|D&C1&C&!B1&B&A2&A1&A|D&!C1&C&!B1&B&A2&A1&A|D&!C1&C&B1&B&A2&A1&A|D&C1&C&B1&B&A2&A1&A|D&C1&!C&B1&B&A2&A1&A|D&C1&!C&B1&!B&A2&A1&A|D&C1&C&B1&!B&A2&A1&A|D&!C1&C&B1&!B&A2&A1&A|D&!C1&C&B1&!B&A2&!A1&A|D&C1&C&B1&!B&A2&!A1&A|D&C1&!C&B1&!B&A2&!A1&A|D&C1&!C&B1&B&A2&!A1&A|D&C1&C&B1&B&A2&!A1&A|D&!C1&C&B1&B&A2&!A1&A|D&!C1&C&!B1&B&A2&!A1&A|D&C1&C&!B1&B&A2&!A1&A|D&C1&!C&!B1&B&A2&!A1&A|D&C1&!C&!B1&B&!A2&!A1&A|D&C1&C&!B1&B&!A2&!A1&A|D&!C1&C&!B1&B&!A2&!A1&A|D&!C1&C&B1&B&!A2&!A1&A|D&C1&C&B1&B&!A2&!A1&A|D&C1&!C&B1&B&!A2&!A1&A|D&C1&!C&B1&!B&!A2&!A1&A|D&C1&C&B1&!B&!A2&!A1&A|D&!C1&C&B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAI3221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAAOI2222 -l AAOOAAOI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=!(D1&D&!C1&!C&!B1&!B&!A1&!A|D1&D&C1&!C&!B1&!B&!A1&!A|D1&D&C1&C&!B1&!B&!A1&!A|D1&D&!C1&C&!B1&!B&!A1&!A|D1&D&!C1&C&B1&!B&!A1&!A|D1&D&C1&C&B1&!B&!A1&!A|D1&D&C1&!C&B1&!B&!A1&!A|D1&D&!C1&!C&B1&!B&!A1&!A|D1&D&!C1&!C&B1&B&!A1&!A|!D1&D&C1&!C&B1&B&!A1&!A|D1&D&C1&!C&B1&B&!A1&!A|D1&!D&C1&!C&B1&B&!A1&!A|!D1&!D&C1&!C&B1&B&!A1&!A|!D1&!D&C1&C&B1&B&!A1&!A|D1&!D&C1&C&B1&B&!A1&!A|D1&D&C1&C&B1&B&!A1&!A|!D1&D&C1&C&B1&B&!A1&!A|!D1&D&!C1&C&B1&B&!A1&!A|D1&D&!C1&C&B1&B&!A1&!A|D1&!D&!C1&C&B1&B&!A1&!A|!D1&!D&!C1&C&B1&B&!A1&!A|D1&D&!C1&C&!B1&B&!A1&!A|D1&D&C1&C&!B1&B&!A1&!A|D1&D&C1&!C&!B1&B&!A1&!A|D1&D&!C1&!C&!B1&B&!A1&!A|D1&D&!C1&!C&!B1&B&A1&!A|D1&D&C1&!C&!B1&B&A1&!A|D1&D&C1&C&!B1&B&A1&!A|D1&D&!C1&C&!B1&B&A1&!A|!D1&!D&!C1&C&B1&B&A1&!A|D1&!D&!C1&C&B1&B&A1&!A|D1&D&!C1&C&B1&B&A1&!A|!D1&D&!C1&C&B1&B&A1&!A|!D1&D&C1&C&B1&B&A1&!A|D1&D&C1&C&B1&B&A1&!A|D1&!D&C1&C&B1&B&A1&!A|!D1&!D&C1&C&B1&B&A1&!A|!D1&!D&C1&!C&B1&B&A1&!A|D1&!D&C1&!C&B1&B&A1&!A|D1&D&C1&!C&B1&B&A1&!A|!D1&D&C1&!C&B1&B&A1&!A|D1&D&!C1&!C&B1&B&A1&!A|D1&D&!C1&!C&B1&!B&A1&!A|D1&D&C1&!C&B1&!B&A1&!A|D1&D&C1&C&B1&!B&A1&!A|D1&D&!C1&C&B1&!B&A1&!A|D1&D&!C1&C&!B1&!B&A1&!A|D1&D&C1&C&!B1&!B&A1&!A|D1&D&C1&!C&!B1&!B&A1&!A|D1&D&!C1&!C&!B1&!B&A1&!A|D1&D&!C1&!C&!B1&!B&A1&A|!D1&D&C1&!C&!B1&!B&A1&A|D1&D&C1&!C&!B1&!B&A1&A|D1&!D&C1&!C&!B1&!B&A1&A|!D1&!D&C1&!C&!B1&!B&A1&A|!D1&!D&C1&C&!B1&!B&A1&A|D1&!D&C1&C&!B1&!B&A1&A|D1&D&C1&C&!B1&!B&A1&A|!D1&D&C1&C&!B1&!B&A1&A|!D1&D&!C1&C&!B1&!B&A1&A|D1&D&!C1&C&!B1&!B&A1&A|D1&!D&!C1&C&!B1&!B&A1&A|!D1&!D&!C1&C&!B1&!B&A1&A|!D1&!D&!C1&C&B1&!B&A1&A|D1&!D&!C1&C&B1&!B&A1&A|D1&D&!C1&C&B1&!B&A1&A|!D1&D&!C1&C&B1&!B&A1&A|!D1&D&C1&C&B1&!B&A1&A|D1&D&C1&C&B1&!B&A1&A|D1&!D&C1&C&B1&!B&A1&A|!D1&!D&C1&C&B1&!B&A1&A|!D1&!D&C1&!C&B1&!B&A1&A|D1&!D&C1&!C&B1&!B&A1&A|D1&D&C1&!C&B1&!B&A1&A|!D1&D&C1&!C&B1&!B&A1&A|D1&D&!C1&!C&B1&!B&A1&A|D1&D&!C1&!C&B1&B&A1&A|!D1&D&C1&!C&B1&B&A1&A|D1&D&C1&!C&B1&B&A1&A|D1&!D&C1&!C&B1&B&A1&A|!D1&!D&C1&!C&B1&B&A1&A|!D1&!D&C1&C&B1&B&A1&A|D1&!D&C1&C&B1&B&A1&A|D1&D&C1&C&B1&B&A1&A|!D1&D&C1&C&B1&B&A1&A|!D1&D&!C1&C&B1&B&A1&A|D1&D&!C1&C&B1&B&A1&A|D1&!D&!C1&C&B1&B&A1&A|!D1&!D&!C1&C&B1&B&A1&A|!D1&!D&!C1&C&!B1&B&A1&A|D1&!D&!C1&C&!B1&B&A1&A|D1&D&!C1&C&!B1&B&A1&A|!D1&D&!C1&C&!B1&B&A1&A|!D1&D&C1&C&!B1&B&A1&A|D1&D&C1&C&!B1&B&A1&A|D1&!D&C1&C&!B1&B&A1&A|!D1&!D&C1&C&!B1&B&A1&A|!D1&!D&C1&!C&!B1&B&A1&A|D1&!D&C1&!C&!B1&B&A1&A|D1&D&C1&!C&!B1&B&A1&A|!D1&D&C1&!C&!B1&B&A1&A|D1&D&!C1&!C&!B1&B&A1&A|D1&D&!C1&!C&!B1&B&!A1&A|D1&D&C1&!C&!B1&B&!A1&A|D1&D&C1&C&!B1&B&!A1&A|D1&D&!C1&C&!B1&B&!A1&A|!D1&!D&!C1&C&B1&B&!A1&A|D1&!D&!C1&C&B1&B&!A1&A|D1&D&!C1&C&B1&B&!A1&A|!D1&D&!C1&C&B1&B&!A1&A|!D1&D&C1&C&B1&B&!A1&A|D1&D&C1&C&B1&B&!A1&A|D1&!D&C1&C&B1&B&!A1&A|!D1&!D&C1&C&B1&B&!A1&A|!D1&!D&C1&!C&B1&B&!A1&A|D1&!D&C1&!C&B1&B&!A1&A|D1&D&C1&!C&B1&B&!A1&A|!D1&D&C1&!C&B1&B&!A1&A|D1&D&!C1&!C&B1&B&!A1&A|D1&D&!C1&!C&B1&!B&!A1&A|D1&D&C1&!C&B1&!B&!A1&A|D1&D&C1&C&B1&!B&!A1&A|D1&D&!C1&C&B1&!B&!A1&A|D1&D&!C1&C&!B1&!B&!A1&A|D1&D&C1&C&!B1&!B&!A1&A|D1&D&C1&!C&!B1&!B&!A1&A|D1&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAAOI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAI31121 -l OAOOAI31121 -i E D1 D C B A2 A1 A -o Y -f Y=!(E&!D1&D&C&!B&!A2&!A1&!A|E&D1&D&C&!B&!A2&!A1&!A|E&D1&!D&C&!B&!A2&!A1&!A|E&D1&!D&C&B&!A2&!A1&!A|E&D1&D&C&B&!A2&!A1&!A|E&!D1&D&C&B&!A2&!A1&!A|E&D1&!D&!C&B&A2&!A1&!A|E&D1&D&!C&B&A2&!A1&!A|E&!D1&D&!C&B&A2&!A1&!A|E&!D1&D&C&B&A2&!A1&!A|E&D1&D&C&B&A2&!A1&!A|E&D1&!D&C&B&A2&!A1&!A|E&D1&!D&C&!B&A2&!A1&!A|E&D1&D&C&!B&A2&!A1&!A|E&!D1&D&C&!B&A2&!A1&!A|E&!D1&D&C&!B&A2&A1&!A|E&D1&D&C&!B&A2&A1&!A|E&D1&!D&C&!B&A2&A1&!A|E&D1&!D&C&B&A2&A1&!A|E&D1&D&C&B&A2&A1&!A|E&!D1&D&C&B&A2&A1&!A|E&!D1&D&!C&B&A2&A1&!A|E&D1&D&!C&B&A2&A1&!A|E&D1&!D&!C&B&A2&A1&!A|E&D1&!D&!C&B&!A2&A1&!A|E&D1&D&!C&B&!A2&A1&!A|E&!D1&D&!C&B&!A2&A1&!A|E&!D1&D&C&B&!A2&A1&!A|E&D1&D&C&B&!A2&A1&!A|E&D1&!D&C&B&!A2&A1&!A|E&D1&!D&C&!B&!A2&A1&!A|E&D1&D&C&!B&!A2&A1&!A|E&!D1&D&C&!B&!A2&A1&!A|E&!D1&D&C&!B&!A2&A1&A|E&D1&D&C&!B&!A2&A1&A|E&D1&!D&C&!B&!A2&A1&A|E&D1&!D&C&B&!A2&A1&A|E&D1&D&C&B&!A2&A1&A|E&!D1&D&C&B&!A2&A1&A|E&!D1&D&!C&B&!A2&A1&A|E&D1&D&!C&B&!A2&A1&A|E&D1&!D&!C&B&!A2&A1&A|E&D1&!D&!C&B&A2&A1&A|E&D1&D&!C&B&A2&A1&A|E&!D1&D&!C&B&A2&A1&A|E&!D1&D&C&B&A2&A1&A|E&D1&D&C&B&A2&A1&A|E&D1&!D&C&B&A2&A1&A|E&D1&!D&C&!B&A2&A1&A|E&D1&D&C&!B&A2&A1&A|E&!D1&D&C&!B&A2&A1&A|E&!D1&D&C&!B&A2&!A1&A|E&D1&D&C&!B&A2&!A1&A|E&D1&!D&C&!B&A2&!A1&A|E&D1&!D&C&B&A2&!A1&A|E&D1&D&C&B&A2&!A1&A|E&!D1&D&C&B&A2&!A1&A|E&!D1&D&!C&B&A2&!A1&A|E&D1&D&!C&B&A2&!A1&A|E&D1&!D&!C&B&A2&!A1&A|E&D1&!D&!C&B&!A2&!A1&A|E&D1&D&!C&B&!A2&!A1&A|E&!D1&D&!C&B&!A2&!A1&A|E&!D1&D&C&B&!A2&!A1&A|E&D1&D&C&B&!A2&!A1&A|E&D1&!D&C&B&!A2&!A1&A|E&D1&!D&C&!B&!A2&!A1&A|E&D1&D&C&!B&!A2&!A1&A|E&!D1&D&C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAI31121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOAI3211 -l OAOAI3211 -i D C B1 B A2 A1 A -o Y -f Y=!(D&C&!B1&!B&!A2&!A1&!A|D&C&B1&!B&!A2&!A1&!A|D&C&B1&B&!A2&!A1&!A|D&C&!B1&B&!A2&!A1&!A|D&C&!B1&B&A2&!A1&!A|D&C&B1&B&A2&!A1&!A|D&!C&B1&B&A2&!A1&!A|D&C&B1&!B&A2&!A1&!A|D&C&!B1&!B&A2&!A1&!A|D&C&!B1&!B&A2&A1&!A|D&C&B1&!B&A2&A1&!A|D&!C&B1&B&A2&A1&!A|D&C&B1&B&A2&A1&!A|D&C&!B1&B&A2&A1&!A|D&C&!B1&B&!A2&A1&!A|D&C&B1&B&!A2&A1&!A|D&!C&B1&B&!A2&A1&!A|D&C&B1&!B&!A2&A1&!A|D&C&!B1&!B&!A2&A1&!A|D&C&!B1&!B&!A2&A1&A|D&C&B1&!B&!A2&A1&A|D&!C&B1&B&!A2&A1&A|D&C&B1&B&!A2&A1&A|D&C&!B1&B&!A2&A1&A|D&C&!B1&B&A2&A1&A|D&C&B1&B&A2&A1&A|D&!C&B1&B&A2&A1&A|D&C&B1&!B&A2&A1&A|D&C&!B1&!B&A2&A1&A|D&C&!B1&!B&A2&!A1&A|D&C&B1&!B&A2&!A1&A|D&!C&B1&B&A2&!A1&A|D&C&B1&B&A2&!A1&A|D&C&!B1&B&A2&!A1&A|D&C&!B1&B&!A2&!A1&A|D&C&B1&B&!A2&!A1&A|D&!C&B1&B&!A2&!A1&A|D&C&B1&!B&!A2&!A1&A|D&C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOAI3211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOAOI22121 -l OOAOAOI22121 -i E D1 D C B1 B A1 A -o Y -f Y=(!E&!D1&!D&!C&!B1&!B&!A1&!A|!E&D1&!D&!C&!B1&!B&!A1&!A|!E&D1&D&!C&!B1&!B&!A1&!A|!E&!D1&D&!C&!B1&!B&!A1&!A|!E&!D1&D&C&!B1&!B&!A1&!A|!E&D1&!D&C&!B1&!B&!A1&!A|!E&!D1&!D&C&!B1&!B&!A1&!A|!E&!D1&!D&C&B1&!B&!A1&!A|!E&D1&!D&C&B1&!B&!A1&!A|!E&!D1&D&C&B1&!B&!A1&!A|!E&!D1&D&!C&B1&!B&!A1&!A|!E&D1&D&!C&B1&!B&!A1&!A|!E&D1&!D&!C&B1&!B&!A1&!A|!E&!D1&!D&!C&B1&!B&!A1&!A|!E&!D1&!D&!C&B1&B&!A1&!A|!E&D1&!D&!C&B1&B&!A1&!A|!E&D1&D&!C&B1&B&!A1&!A|!E&!D1&D&!C&B1&B&!A1&!A|!E&!D1&D&C&B1&B&!A1&!A|!E&D1&!D&C&B1&B&!A1&!A|!E&!D1&!D&C&B1&B&!A1&!A|!E&!D1&!D&C&!B1&B&!A1&!A|!E&D1&!D&C&!B1&B&!A1&!A|!E&!D1&D&C&!B1&B&!A1&!A|!E&!D1&D&!C&!B1&B&!A1&!A|!E&D1&D&!C&!B1&B&!A1&!A|!E&D1&!D&!C&!B1&B&!A1&!A|!E&!D1&!D&!C&!B1&B&!A1&!A|!E&!D1&!D&!C&!B1&B&A1&!A|!E&D1&!D&!C&!B1&B&A1&!A|!E&!D1&D&!C&!B1&B&A1&!A|!E&!D1&D&C&!B1&B&A1&!A|!E&D1&!D&C&!B1&B&A1&!A|!E&!D1&!D&C&!B1&B&A1&!A|!E&!D1&!D&C&B1&B&A1&!A|!E&D1&!D&C&B1&B&A1&!A|!E&!D1&D&C&B1&B&A1&!A|!E&!D1&D&!C&B1&B&A1&!A|!E&D1&!D&!C&B1&B&A1&!A|!E&!D1&!D&!C&B1&B&A1&!A|!E&!D1&!D&!C&B1&!B&A1&!A|!E&D1&!D&!C&B1&!B&A1&!A|!E&!D1&D&!C&B1&!B&A1&!A|!E&!D1&D&C&B1&!B&A1&!A|!E&D1&!D&C&B1&!B&A1&!A|!E&!D1&!D&C&B1&!B&A1&!A|!E&!D1&!D&C&!B1&!B&A1&!A|!E&D1&!D&C&!B1&!B&A1&!A|!E&!D1&D&C&!B1&!B&A1&!A|!E&!D1&D&!C&!B1&!B&A1&!A|!E&D1&D&!C&!B1&!B&A1&!A|!E&D1&!D&!C&!B1&!B&A1&!A|!E&!D1&!D&!C&!B1&!B&A1&!A|!E&!D1&!D&!C&!B1&!B&A1&A|!E&D1&!D&!C&!B1&!B&A1&A|!E&D1&D&!C&!B1&!B&A1&A|!E&!D1&D&!C&!B1&!B&A1&A|!E&!D1&D&C&!B1&!B&A1&A|!E&D1&!D&C&!B1&!B&A1&A|!E&!D1&!D&C&!B1&!B&A1&A|!E&!D1&!D&C&B1&!B&A1&A|!E&D1&!D&C&B1&!B&A1&A|!E&!D1&D&C&B1&!B&A1&A|!E&!D1&D&!C&B1&!B&A1&A|!E&D1&!D&!C&B1&!B&A1&A|!E&!D1&!D&!C&B1&!B&A1&A|!E&!D1&!D&!C&B1&B&A1&A|!E&D1&!D&!C&B1&B&A1&A|!E&!D1&D&!C&B1&B&A1&A|!E&!D1&D&C&B1&B&A1&A|!E&D1&!D&C&B1&B&A1&A|!E&!D1&!D&C&B1&B&A1&A|!E&!D1&!D&C&!B1&B&A1&A|!E&D1&!D&C&!B1&B&A1&A|!E&!D1&D&C&!B1&B&A1&A|!E&!D1&D&!C&!B1&B&A1&A|!E&D1&!D&!C&!B1&B&A1&A|!E&!D1&!D&!C&!B1&B&A1&A|!E&!D1&!D&!C&!B1&B&!A1&A|!E&D1&!D&!C&!B1&B&!A1&A|!E&!D1&D&!C&!B1&B&!A1&A|!E&!D1&D&C&!B1&B&!A1&A|!E&D1&!D&C&!B1&B&!A1&A|!E&!D1&!D&C&!B1&B&!A1&A|!E&!D1&!D&C&B1&B&!A1&A|!E&D1&!D&C&B1&B&!A1&A|!E&!D1&D&C&B1&B&!A1&A|!E&!D1&D&!C&B1&B&!A1&A|!E&D1&!D&!C&B1&B&!A1&A|!E&!D1&!D&!C&B1&B&!A1&A|!E&!D1&!D&!C&B1&!B&!A1&A|!E&D1&!D&!C&B1&!B&!A1&A|!E&!D1&D&!C&B1&!B&!A1&A|!E&!D1&D&C&B1&!B&!A1&A|!E&D1&!D&C&B1&!B&!A1&A|!E&!D1&!D&C&B1&!B&!A1&A|!E&!D1&!D&C&!B1&!B&!A1&A|!E&D1&!D&C&!B1&!B&!A1&A|!E&!D1&D&C&!B1&!B&!A1&A|!E&!D1&D&!C&!B1&!B&!A1&A|!E&D1&D&!C&!B1&!B&!A1&A|!E&D1&!D&!C&!B1&!B&!A1&A|!E&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOAOI22121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOI21231 -l AOAAOI21231 -i E D2 D1 D C1 C B A1 A -o Y -f Y=(!E&!D2&!D1&!D&!C1&!C&!B&!A1&!A|!E&D2&!D1&!D&!C1&!C&!B&!A1&!A|!E&D2&D1&!D&!C1&!C&!B&!A1&!A|!E&!D2&D1&!D&!C1&!C&!B&!A1&!A|!E&!D2&D1&D&!C1&!C&!B&!A1&!A|!E&D2&!D1&D&!C1&!C&!B&!A1&!A|!E&!D2&!D1&D&!C1&!C&!B&!A1&!A|!E&!D2&!D1&D&C1&!C&!B&!A1&!A|!E&D2&!D1&D&C1&!C&!B&!A1&!A|!E&!D2&D1&D&C1&!C&!B&!A1&!A|!E&!D2&D1&!D&C1&!C&!B&!A1&!A|!E&D2&D1&!D&C1&!C&!B&!A1&!A|!E&D2&!D1&!D&C1&!C&!B&!A1&!A|!E&!D2&!D1&!D&C1&!C&!B&!A1&!A|!E&!D2&!D1&!D&C1&C&!B&!A1&!A|!E&D2&!D1&!D&C1&C&!B&!A1&!A|!E&D2&D1&!D&C1&C&!B&!A1&!A|!E&!D2&D1&!D&C1&C&!B&!A1&!A|!E&!D2&D1&D&C1&C&!B&!A1&!A|!E&D2&!D1&D&C1&C&!B&!A1&!A|!E&!D2&!D1&D&C1&C&!B&!A1&!A|!E&!D2&!D1&D&!C1&C&!B&!A1&!A|!E&D2&!D1&D&!C1&C&!B&!A1&!A|!E&!D2&D1&D&!C1&C&!B&!A1&!A|!E&!D2&D1&!D&!C1&C&!B&!A1&!A|!E&D2&D1&!D&!C1&C&!B&!A1&!A|!E&D2&!D1&!D&!C1&C&!B&!A1&!A|!E&!D2&!D1&!D&!C1&C&!B&!A1&!A|!E&!D2&!D1&!D&!C1&C&B&!A1&!A|!E&D2&!D1&!D&!C1&C&B&!A1&!A|!E&D2&D1&!D&!C1&C&B&!A1&!A|!E&!D2&D1&!D&!C1&C&B&!A1&!A|!E&!D2&D1&D&!C1&C&B&!A1&!A|!E&D2&!D1&D&!C1&C&B&!A1&!A|!E&!D2&!D1&D&!C1&C&B&!A1&!A|!E&!D2&!D1&!D&C1&!C&B&!A1&!A|!E&D2&!D1&!D&C1&!C&B&!A1&!A|!E&D2&D1&!D&C1&!C&B&!A1&!A|!E&!D2&D1&!D&C1&!C&B&!A1&!A|!E&!D2&D1&D&C1&!C&B&!A1&!A|!E&D2&!D1&D&C1&!C&B&!A1&!A|!E&!D2&!D1&D&C1&!C&B&!A1&!A|!E&!D2&!D1&D&!C1&!C&B&!A1&!A|!E&D2&!D1&D&!C1&!C&B&!A1&!A|!E&!D2&D1&D&!C1&!C&B&!A1&!A|!E&!D2&D1&!D&!C1&!C&B&!A1&!A|!E&D2&D1&!D&!C1&!C&B&!A1&!A|!E&D2&!D1&!D&!C1&!C&B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&B&!A1&!A|!E&!D2&!D1&!D&!C1&!C&B&A1&!A|!E&D2&!D1&!D&!C1&!C&B&A1&!A|!E&D2&D1&!D&!C1&!C&B&A1&!A|!E&!D2&D1&!D&!C1&!C&B&A1&!A|!E&!D2&D1&D&!C1&!C&B&A1&!A|!E&D2&!D1&D&!C1&!C&B&A1&!A|!E&!D2&!D1&D&!C1&!C&B&A1&!A|!E&!D2&!D1&D&C1&!C&B&A1&!A|!E&D2&!D1&D&C1&!C&B&A1&!A|!E&!D2&D1&D&C1&!C&B&A1&!A|!E&!D2&D1&!D&C1&!C&B&A1&!A|!E&D2&D1&!D&C1&!C&B&A1&!A|!E&D2&!D1&!D&C1&!C&B&A1&!A|!E&!D2&!D1&!D&C1&!C&B&A1&!A|!E&!D2&!D1&D&!C1&C&B&A1&!A|!E&D2&!D1&D&!C1&C&B&A1&!A|!E&!D2&D1&D&!C1&C&B&A1&!A|!E&!D2&D1&!D&!C1&C&B&A1&!A|!E&D2&D1&!D&!C1&C&B&A1&!A|!E&D2&!D1&!D&!C1&C&B&A1&!A|!E&!D2&!D1&!D&!C1&C&B&A1&!A|!E&!D2&!D1&!D&!C1&C&!B&A1&!A|!E&D2&!D1&!D&!C1&C&!B&A1&!A|!E&D2&D1&!D&!C1&C&!B&A1&!A|!E&!D2&D1&!D&!C1&C&!B&A1&!A|!E&!D2&D1&D&!C1&C&!B&A1&!A|!E&D2&!D1&D&!C1&C&!B&A1&!A|!E&!D2&!D1&D&!C1&C&!B&A1&!A|!E&!D2&!D1&D&C1&C&!B&A1&!A|!E&D2&!D1&D&C1&C&!B&A1&!A|!E&!D2&D1&D&C1&C&!B&A1&!A|!E&!D2&D1&!D&C1&C&!B&A1&!A|!E&D2&D1&!D&C1&C&!B&A1&!A|!E&D2&!D1&!D&C1&C&!B&A1&!A|!E&!D2&!D1&!D&C1&C&!B&A1&!A|!E&!D2&!D1&!D&C1&!C&!B&A1&!A|!E&D2&!D1&!D&C1&!C&!B&A1&!A|!E&D2&D1&!D&C1&!C&!B&A1&!A|!E&!D2&D1&!D&C1&!C&!B&A1&!A|!E&!D2&D1&D&C1&!C&!B&A1&!A|!E&D2&!D1&D&C1&!C&!B&A1&!A|!E&!D2&!D1&D&C1&!C&!B&A1&!A|!E&!D2&!D1&D&!C1&!C&!B&A1&!A|!E&D2&!D1&D&!C1&!C&!B&A1&!A|!E&!D2&D1&D&!C1&!C&!B&A1&!A|!E&!D2&D1&!D&!C1&!C&!B&A1&!A|!E&D2&D1&!D&!C1&!C&!B&A1&!A|!E&D2&!D1&!D&!C1&!C&!B&A1&!A|!E&!D2&!D1&!D&!C1&!C&!B&A1&!A|!E&!D2&!D1&!D&!C1&!C&!B&A1&A|!E&D2&!D1&!D&!C1&!C&!B&A1&A|!E&D2&D1&!D&!C1&!C&!B&A1&A|!E&!D2&D1&!D&!C1&!C&!B&A1&A|!E&!D2&D1&D&!C1&!C&!B&A1&A|!E&D2&!D1&D&!C1&!C&!B&A1&A|!E&!D2&!D1&D&!C1&!C&!B&A1&A|!E&!D2&!D1&D&C1&!C&!B&A1&A|!E&D2&!D1&D&C1&!C&!B&A1&A|!E&!D2&D1&D&C1&!C&!B&A1&A|!E&!D2&D1&!D&C1&!C&!B&A1&A|!E&D2&D1&!D&C1&!C&!B&A1&A|!E&D2&!D1&!D&C1&!C&!B&A1&A|!E&!D2&!D1&!D&C1&!C&!B&A1&A|!E&!D2&!D1&D&!C1&C&!B&A1&A|!E&D2&!D1&D&!C1&C&!B&A1&A|!E&!D2&D1&D&!C1&C&!B&A1&A|!E&!D2&D1&!D&!C1&C&!B&A1&A|!E&D2&D1&!D&!C1&C&!B&A1&A|!E&D2&!D1&!D&!C1&C&!B&A1&A|!E&!D2&!D1&!D&!C1&C&!B&A1&A|!E&!D2&!D1&!D&!C1&C&B&A1&A|!E&D2&!D1&!D&!C1&C&B&A1&A|!E&D2&D1&!D&!C1&C&B&A1&A|!E&!D2&D1&!D&!C1&C&B&A1&A|!E&!D2&D1&D&!C1&C&B&A1&A|!E&D2&!D1&D&!C1&C&B&A1&A|!E&!D2&!D1&D&!C1&C&B&A1&A|!E&!D2&!D1&!D&C1&!C&B&A1&A|!E&D2&!D1&!D&C1&!C&B&A1&A|!E&D2&D1&!D&C1&!C&B&A1&A|!E&!D2&D1&!D&C1&!C&B&A1&A|!E&!D2&D1&D&C1&!C&B&A1&A|!E&D2&!D1&D&C1&!C&B&A1&A|!E&!D2&!D1&D&C1&!C&B&A1&A|!E&!D2&!D1&D&!C1&!C&B&A1&A|!E&D2&!D1&D&!C1&!C&B&A1&A|!E&!D2&D1&D&!C1&!C&B&A1&A|!E&!D2&D1&!D&!C1&!C&B&A1&A|!E&D2&D1&!D&!C1&!C&B&A1&A|!E&D2&!D1&!D&!C1&!C&B&A1&A|!E&!D2&!D1&!D&!C1&!C&B&A1&A|!E&!D2&!D1&!D&!C1&!C&B&!A1&A|!E&D2&!D1&!D&!C1&!C&B&!A1&A|!E&D2&D1&!D&!C1&!C&B&!A1&A|!E&!D2&D1&!D&!C1&!C&B&!A1&A|!E&!D2&D1&D&!C1&!C&B&!A1&A|!E&D2&!D1&D&!C1&!C&B&!A1&A|!E&!D2&!D1&D&!C1&!C&B&!A1&A|!E&!D2&!D1&D&C1&!C&B&!A1&A|!E&D2&!D1&D&C1&!C&B&!A1&A|!E&!D2&D1&D&C1&!C&B&!A1&A|!E&!D2&D1&!D&C1&!C&B&!A1&A|!E&D2&D1&!D&C1&!C&B&!A1&A|!E&D2&!D1&!D&C1&!C&B&!A1&A|!E&!D2&!D1&!D&C1&!C&B&!A1&A|!E&!D2&!D1&D&!C1&C&B&!A1&A|!E&D2&!D1&D&!C1&C&B&!A1&A|!E&!D2&D1&D&!C1&C&B&!A1&A|!E&!D2&D1&!D&!C1&C&B&!A1&A|!E&D2&D1&!D&!C1&C&B&!A1&A|!E&D2&!D1&!D&!C1&C&B&!A1&A|!E&!D2&!D1&!D&!C1&C&B&!A1&A|!E&!D2&!D1&!D&!C1&C&!B&!A1&A|!E&D2&!D1&!D&!C1&C&!B&!A1&A|!E&D2&D1&!D&!C1&C&!B&!A1&A|!E&!D2&D1&!D&!C1&C&!B&!A1&A|!E&!D2&D1&D&!C1&C&!B&!A1&A|!E&D2&!D1&D&!C1&C&!B&!A1&A|!E&!D2&!D1&D&!C1&C&!B&!A1&A|!E&!D2&!D1&D&C1&C&!B&!A1&A|!E&D2&!D1&D&C1&C&!B&!A1&A|!E&!D2&D1&D&C1&C&!B&!A1&A|!E&!D2&D1&!D&C1&C&!B&!A1&A|!E&D2&D1&!D&C1&C&!B&!A1&A|!E&D2&!D1&!D&C1&C&!B&!A1&A|!E&!D2&!D1&!D&C1&C&!B&!A1&A|!E&!D2&!D1&!D&C1&!C&!B&!A1&A|!E&D2&!D1&!D&C1&!C&!B&!A1&A|!E&D2&D1&!D&C1&!C&!B&!A1&A|!E&!D2&D1&!D&C1&!C&!B&!A1&A|!E&!D2&D1&D&C1&!C&!B&!A1&A|!E&D2&!D1&D&C1&!C&!B&!A1&A|!E&!D2&!D1&D&C1&!C&!B&!A1&A|!E&!D2&!D1&D&!C1&!C&!B&!A1&A|!E&D2&!D1&D&!C1&!C&!B&!A1&A|!E&!D2&D1&D&!C1&!C&!B&!A1&A|!E&!D2&D1&!D&!C1&!C&!B&!A1&A|!E&D2&D1&!D&!C1&!C&!B&!A1&A|!E&D2&!D1&!D&!C1&!C&!B&!A1&A|!E&!D2&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOI21231.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOAOI21221 -l OAAOAOI21221 -i E D1 D C1 C B A1 A -o Y -f Y=(!E&!D1&!D&!C1&!C&!B&!A1&!A|!E&D1&!D&!C1&!C&!B&!A1&!A|!E&D1&D&!C1&!C&!B&!A1&!A|!E&!D1&D&!C1&!C&!B&!A1&!A|!E&!D1&D&C1&!C&!B&!A1&!A|!E&D1&D&C1&!C&!B&!A1&!A|!E&D1&!D&C1&!C&!B&!A1&!A|!E&!D1&!D&C1&!C&!B&!A1&!A|!E&!D1&!D&C1&C&!B&!A1&!A|!E&D1&!D&C1&C&!B&!A1&!A|!E&!D1&D&C1&C&!B&!A1&!A|!E&!D1&D&!C1&C&!B&!A1&!A|!E&D1&D&!C1&C&!B&!A1&!A|!E&D1&!D&!C1&C&!B&!A1&!A|!E&!D1&!D&!C1&C&!B&!A1&!A|!E&!D1&!D&!C1&C&B&!A1&!A|!E&D1&!D&!C1&C&B&!A1&!A|!E&D1&D&!C1&C&B&!A1&!A|!E&!D1&D&!C1&C&B&!A1&!A|!E&!D1&D&C1&C&B&!A1&!A|!E&D1&!D&C1&C&B&!A1&!A|!E&!D1&!D&C1&C&B&!A1&!A|!E&!D1&!D&C1&!C&B&!A1&!A|!E&D1&!D&C1&!C&B&!A1&!A|!E&D1&D&C1&!C&B&!A1&!A|!E&!D1&D&C1&!C&B&!A1&!A|!E&!D1&D&!C1&!C&B&!A1&!A|!E&D1&D&!C1&!C&B&!A1&!A|!E&D1&!D&!C1&!C&B&!A1&!A|!E&!D1&!D&!C1&!C&B&!A1&!A|!E&!D1&!D&!C1&!C&B&A1&!A|!E&D1&!D&!C1&!C&B&A1&!A|!E&!D1&D&!C1&!C&B&A1&!A|!E&!D1&D&C1&!C&B&A1&!A|!E&D1&!D&C1&!C&B&A1&!A|!E&!D1&!D&C1&!C&B&A1&!A|!E&!D1&!D&C1&C&B&A1&!A|!E&D1&!D&C1&C&B&A1&!A|!E&!D1&D&C1&C&B&A1&!A|!E&!D1&D&!C1&C&B&A1&!A|!E&D1&!D&!C1&C&B&A1&!A|!E&!D1&!D&!C1&C&B&A1&!A|!E&!D1&!D&!C1&C&!B&A1&!A|!E&D1&!D&!C1&C&!B&A1&!A|!E&D1&D&!C1&C&!B&A1&!A|!E&!D1&D&!C1&C&!B&A1&!A|!E&!D1&D&C1&C&!B&A1&!A|!E&D1&!D&C1&C&!B&A1&!A|!E&!D1&!D&C1&C&!B&A1&!A|!E&!D1&!D&C1&!C&!B&A1&!A|!E&D1&!D&C1&!C&!B&A1&!A|!E&D1&D&C1&!C&!B&A1&!A|!E&!D1&D&C1&!C&!B&A1&!A|!E&!D1&D&!C1&!C&!B&A1&!A|!E&D1&D&!C1&!C&!B&A1&!A|!E&D1&!D&!C1&!C&!B&A1&!A|!E&!D1&!D&!C1&!C&!B&A1&!A|!E&!D1&!D&!C1&!C&!B&A1&A|!E&D1&!D&!C1&!C&!B&A1&A|!E&D1&D&!C1&!C&!B&A1&A|!E&!D1&D&!C1&!C&!B&A1&A|!E&!D1&D&C1&!C&!B&A1&A|!E&D1&D&C1&!C&!B&A1&A|!E&D1&!D&C1&!C&!B&A1&A|!E&!D1&!D&C1&!C&!B&A1&A|!E&!D1&!D&C1&C&!B&A1&A|!E&D1&!D&C1&C&!B&A1&A|!E&!D1&D&C1&C&!B&A1&A|!E&!D1&D&!C1&C&!B&A1&A|!E&D1&D&!C1&C&!B&A1&A|!E&D1&!D&!C1&C&!B&A1&A|!E&!D1&!D&!C1&C&!B&A1&A|!E&!D1&!D&!C1&C&B&A1&A|!E&D1&!D&!C1&C&B&A1&A|!E&!D1&D&!C1&C&B&A1&A|!E&!D1&D&C1&C&B&A1&A|!E&D1&!D&C1&C&B&A1&A|!E&!D1&!D&C1&C&B&A1&A|!E&!D1&!D&C1&!C&B&A1&A|!E&D1&!D&C1&!C&B&A1&A|!E&!D1&D&C1&!C&B&A1&A|!E&!D1&D&!C1&!C&B&A1&A|!E&D1&!D&!C1&!C&B&A1&A|!E&!D1&!D&!C1&!C&B&A1&A|!E&!D1&!D&!C1&!C&B&!A1&A|!E&D1&!D&!C1&!C&B&!A1&A|!E&!D1&D&!C1&!C&B&!A1&A|!E&!D1&D&C1&!C&B&!A1&A|!E&D1&!D&C1&!C&B&!A1&A|!E&!D1&!D&C1&!C&B&!A1&A|!E&!D1&!D&C1&C&B&!A1&A|!E&D1&!D&C1&C&B&!A1&A|!E&!D1&D&C1&C&B&!A1&A|!E&!D1&D&!C1&C&B&!A1&A|!E&D1&!D&!C1&C&B&!A1&A|!E&!D1&!D&!C1&C&B&!A1&A|!E&!D1&!D&!C1&C&!B&!A1&A|!E&D1&!D&!C1&C&!B&!A1&A|!E&D1&D&!C1&C&!B&!A1&A|!E&!D1&D&!C1&C&!B&!A1&A|!E&!D1&D&C1&C&!B&!A1&A|!E&D1&!D&C1&C&!B&!A1&A|!E&!D1&!D&C1&C&!B&!A1&A|!E&!D1&!D&C1&!C&!B&!A1&A|!E&D1&!D&C1&!C&!B&!A1&A|!E&D1&D&C1&!C&!B&!A1&A|!E&!D1&D&C1&!C&!B&!A1&A|!E&!D1&D&!C1&!C&!B&!A1&A|!E&D1&D&!C1&!C&!B&!A1&A|!E&D1&!D&!C1&!C&!B&!A1&A|!E&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOAOI21221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOOAI21312 -l AOOAOOAI21312 -i E1 E D C2 C1 C B A1 A -o Y -f Y=(!E1&!E&!D&!C2&!C1&!C&!B&!A1&!A|E1&!E&!D&!C2&!C1&!C&!B&!A1&!A|E1&E&!D&!C2&!C1&!C&!B&!A1&!A|!E1&E&!D&!C2&!C1&!C&!B&!A1&!A|!E1&!E&D&!C2&!C1&!C&!B&!A1&!A|!E1&!E&D&C2&!C1&!C&!B&!A1&!A|!E1&E&!D&C2&!C1&!C&!B&!A1&!A|E1&E&!D&C2&!C1&!C&!B&!A1&!A|E1&!E&!D&C2&!C1&!C&!B&!A1&!A|!E1&!E&!D&C2&!C1&!C&!B&!A1&!A|!E1&!E&!D&C2&C1&!C&!B&!A1&!A|E1&!E&!D&C2&C1&!C&!B&!A1&!A|E1&E&!D&C2&C1&!C&!B&!A1&!A|!E1&E&!D&C2&C1&!C&!B&!A1&!A|!E1&!E&D&C2&C1&!C&!B&!A1&!A|!E1&!E&D&!C2&C1&!C&!B&!A1&!A|!E1&E&!D&!C2&C1&!C&!B&!A1&!A|E1&E&!D&!C2&C1&!C&!B&!A1&!A|E1&!E&!D&!C2&C1&!C&!B&!A1&!A|!E1&!E&!D&!C2&C1&!C&!B&!A1&!A|!E1&!E&!D&!C2&C1&C&!B&!A1&!A|E1&!E&!D&!C2&C1&C&!B&!A1&!A|E1&E&!D&!C2&C1&C&!B&!A1&!A|!E1&E&!D&!C2&C1&C&!B&!A1&!A|!E1&!E&D&!C2&C1&C&!B&!A1&!A|!E1&!E&D&C2&C1&C&!B&!A1&!A|!E1&E&!D&C2&C1&C&!B&!A1&!A|E1&E&!D&C2&C1&C&!B&!A1&!A|E1&!E&!D&C2&C1&C&!B&!A1&!A|!E1&!E&!D&C2&C1&C&!B&!A1&!A|!E1&!E&!D&C2&!C1&C&!B&!A1&!A|E1&!E&!D&C2&!C1&C&!B&!A1&!A|E1&E&!D&C2&!C1&C&!B&!A1&!A|!E1&E&!D&C2&!C1&C&!B&!A1&!A|!E1&!E&D&C2&!C1&C&!B&!A1&!A|!E1&!E&D&!C2&!C1&C&!B&!A1&!A|!E1&E&!D&!C2&!C1&C&!B&!A1&!A|E1&E&!D&!C2&!C1&C&!B&!A1&!A|E1&!E&!D&!C2&!C1&C&!B&!A1&!A|!E1&!E&!D&!C2&!C1&C&!B&!A1&!A|!E1&!E&!D&!C2&!C1&C&B&!A1&!A|!E1&!E&D&!C2&!C1&C&B&!A1&!A|!E1&!E&D&C2&!C1&C&B&!A1&!A|!E1&!E&!D&C2&!C1&C&B&!A1&!A|!E1&!E&!D&C2&C1&C&B&!A1&!A|!E1&!E&D&C2&C1&C&B&!A1&!A|!E1&!E&D&!C2&C1&C&B&!A1&!A|!E1&!E&!D&!C2&C1&C&B&!A1&!A|!E1&!E&!D&!C2&C1&!C&B&!A1&!A|!E1&!E&D&!C2&C1&!C&B&!A1&!A|!E1&!E&D&C2&C1&!C&B&!A1&!A|!E1&!E&!D&C2&C1&!C&B&!A1&!A|!E1&!E&!D&C2&!C1&!C&B&!A1&!A|!E1&!E&D&C2&!C1&!C&B&!A1&!A|!E1&!E&D&!C2&!C1&!C&B&!A1&!A|!E1&E&!D&!C2&!C1&!C&B&!A1&!A|E1&E&!D&!C2&!C1&!C&B&!A1&!A|E1&!E&!D&!C2&!C1&!C&B&!A1&!A|!E1&!E&!D&!C2&!C1&!C&B&!A1&!A|!E1&!E&!D&!C2&!C1&!C&B&A1&!A|E1&!E&!D&!C2&!C1&!C&B&A1&!A|E1&E&!D&!C2&!C1&!C&B&A1&!A|!E1&E&!D&!C2&!C1&!C&B&A1&!A|!E1&!E&D&!C2&!C1&!C&B&A1&!A|!E1&!E&D&C2&!C1&!C&B&A1&!A|!E1&!E&!D&C2&!C1&!C&B&A1&!A|!E1&!E&!D&C2&C1&!C&B&A1&!A|!E1&!E&D&C2&C1&!C&B&A1&!A|!E1&!E&D&!C2&C1&!C&B&A1&!A|!E1&!E&!D&!C2&C1&!C&B&A1&!A|!E1&!E&!D&!C2&C1&C&B&A1&!A|!E1&!E&D&!C2&C1&C&B&A1&!A|!E1&!E&D&C2&C1&C&B&A1&!A|!E1&!E&!D&C2&C1&C&B&A1&!A|!E1&!E&!D&C2&!C1&C&B&A1&!A|!E1&!E&D&C2&!C1&C&B&A1&!A|!E1&!E&D&!C2&!C1&C&B&A1&!A|!E1&!E&!D&!C2&!C1&C&B&A1&!A|!E1&!E&!D&!C2&!C1&C&!B&A1&!A|E1&!E&!D&!C2&!C1&C&!B&A1&!A|E1&E&!D&!C2&!C1&C&!B&A1&!A|!E1&E&!D&!C2&!C1&C&!B&A1&!A|!E1&!E&D&!C2&!C1&C&!B&A1&!A|!E1&!E&D&C2&!C1&C&!B&A1&!A|!E1&E&!D&C2&!C1&C&!B&A1&!A|E1&E&!D&C2&!C1&C&!B&A1&!A|E1&!E&!D&C2&!C1&C&!B&A1&!A|!E1&!E&!D&C2&!C1&C&!B&A1&!A|!E1&!E&!D&C2&C1&C&!B&A1&!A|E1&!E&!D&C2&C1&C&!B&A1&!A|E1&E&!D&C2&C1&C&!B&A1&!A|!E1&E&!D&C2&C1&C&!B&A1&!A|!E1&!E&D&C2&C1&C&!B&A1&!A|!E1&!E&D&!C2&C1&C&!B&A1&!A|!E1&E&!D&!C2&C1&C&!B&A1&!A|E1&E&!D&!C2&C1&C&!B&A1&!A|E1&!E&!D&!C2&C1&C&!B&A1&!A|!E1&!E&!D&!C2&C1&C&!B&A1&!A|!E1&!E&!D&!C2&C1&!C&!B&A1&!A|E1&!E&!D&!C2&C1&!C&!B&A1&!A|E1&E&!D&!C2&C1&!C&!B&A1&!A|!E1&E&!D&!C2&C1&!C&!B&A1&!A|!E1&!E&D&!C2&C1&!C&!B&A1&!A|!E1&!E&D&C2&C1&!C&!B&A1&!A|!E1&E&!D&C2&C1&!C&!B&A1&!A|E1&E&!D&C2&C1&!C&!B&A1&!A|E1&!E&!D&C2&C1&!C&!B&A1&!A|!E1&!E&!D&C2&C1&!C&!B&A1&!A|!E1&!E&!D&C2&!C1&!C&!B&A1&!A|E1&!E&!D&C2&!C1&!C&!B&A1&!A|E1&E&!D&C2&!C1&!C&!B&A1&!A|!E1&E&!D&C2&!C1&!C&!B&A1&!A|!E1&!E&D&C2&!C1&!C&!B&A1&!A|!E1&!E&D&!C2&!C1&!C&!B&A1&!A|!E1&E&!D&!C2&!C1&!C&!B&A1&!A|E1&E&!D&!C2&!C1&!C&!B&A1&!A|E1&!E&!D&!C2&!C1&!C&!B&A1&!A|!E1&!E&!D&!C2&!C1&!C&!B&A1&!A|!E1&!E&!D&!C2&!C1&!C&!B&A1&A|E1&!E&!D&!C2&!C1&!C&!B&A1&A|E1&E&!D&!C2&!C1&!C&!B&A1&A|!E1&E&!D&!C2&!C1&!C&!B&A1&A|!E1&!E&D&!C2&!C1&!C&!B&A1&A|!E1&!E&D&C2&!C1&!C&!B&A1&A|!E1&!E&!D&C2&!C1&!C&!B&A1&A|!E1&!E&!D&C2&C1&!C&!B&A1&A|!E1&!E&D&C2&C1&!C&!B&A1&A|!E1&!E&D&!C2&C1&!C&!B&A1&A|!E1&!E&!D&!C2&C1&!C&!B&A1&A|!E1&!E&!D&!C2&C1&C&!B&A1&A|!E1&!E&D&!C2&C1&C&!B&A1&A|!E1&!E&D&C2&C1&C&!B&A1&A|!E1&!E&!D&C2&C1&C&!B&A1&A|!E1&!E&!D&C2&!C1&C&!B&A1&A|!E1&!E&D&C2&!C1&C&!B&A1&A|!E1&!E&D&!C2&!C1&C&!B&A1&A|!E1&!E&!D&!C2&!C1&C&!B&A1&A|!E1&!E&!D&!C2&!C1&C&B&A1&A|!E1&!E&D&!C2&!C1&C&B&A1&A|!E1&!E&D&C2&!C1&C&B&A1&A|!E1&!E&!D&C2&!C1&C&B&A1&A|!E1&!E&!D&C2&C1&C&B&A1&A|!E1&!E&D&C2&C1&C&B&A1&A|!E1&!E&D&!C2&C1&C&B&A1&A|!E1&!E&!D&!C2&C1&C&B&A1&A|!E1&!E&!D&!C2&C1&!C&B&A1&A|!E1&!E&D&!C2&C1&!C&B&A1&A|!E1&!E&D&C2&C1&!C&B&A1&A|!E1&!E&!D&C2&C1&!C&B&A1&A|!E1&!E&!D&C2&!C1&!C&B&A1&A|!E1&!E&D&C2&!C1&!C&B&A1&A|!E1&!E&D&!C2&!C1&!C&B&A1&A|!E1&E&!D&!C2&!C1&!C&B&A1&A|E1&E&!D&!C2&!C1&!C&B&A1&A|E1&!E&!D&!C2&!C1&!C&B&A1&A|!E1&!E&!D&!C2&!C1&!C&B&A1&A|!E1&!E&!D&!C2&!C1&!C&B&!A1&A|E1&!E&!D&!C2&!C1&!C&B&!A1&A|E1&E&!D&!C2&!C1&!C&B&!A1&A|!E1&E&!D&!C2&!C1&!C&B&!A1&A|!E1&!E&D&!C2&!C1&!C&B&!A1&A|!E1&!E&D&C2&!C1&!C&B&!A1&A|!E1&!E&!D&C2&!C1&!C&B&!A1&A|!E1&!E&!D&C2&C1&!C&B&!A1&A|!E1&!E&D&C2&C1&!C&B&!A1&A|!E1&!E&D&!C2&C1&!C&B&!A1&A|!E1&!E&!D&!C2&C1&!C&B&!A1&A|!E1&!E&!D&!C2&C1&C&B&!A1&A|!E1&!E&D&!C2&C1&C&B&!A1&A|!E1&!E&D&C2&C1&C&B&!A1&A|!E1&!E&!D&C2&C1&C&B&!A1&A|!E1&!E&!D&C2&!C1&C&B&!A1&A|!E1&!E&D&C2&!C1&C&B&!A1&A|!E1&!E&D&!C2&!C1&C&B&!A1&A|!E1&!E&!D&!C2&!C1&C&B&!A1&A|!E1&!E&!D&!C2&!C1&C&!B&!A1&A|E1&!E&!D&!C2&!C1&C&!B&!A1&A|E1&E&!D&!C2&!C1&C&!B&!A1&A|!E1&E&!D&!C2&!C1&C&!B&!A1&A|!E1&!E&D&!C2&!C1&C&!B&!A1&A|!E1&!E&D&C2&!C1&C&!B&!A1&A|!E1&E&!D&C2&!C1&C&!B&!A1&A|E1&E&!D&C2&!C1&C&!B&!A1&A|E1&!E&!D&C2&!C1&C&!B&!A1&A|!E1&!E&!D&C2&!C1&C&!B&!A1&A|!E1&!E&!D&C2&C1&C&!B&!A1&A|E1&!E&!D&C2&C1&C&!B&!A1&A|E1&E&!D&C2&C1&C&!B&!A1&A|!E1&E&!D&C2&C1&C&!B&!A1&A|!E1&!E&D&C2&C1&C&!B&!A1&A|!E1&!E&D&!C2&C1&C&!B&!A1&A|!E1&E&!D&!C2&C1&C&!B&!A1&A|E1&E&!D&!C2&C1&C&!B&!A1&A|E1&!E&!D&!C2&C1&C&!B&!A1&A|!E1&!E&!D&!C2&C1&C&!B&!A1&A|!E1&!E&!D&!C2&C1&!C&!B&!A1&A|E1&!E&!D&!C2&C1&!C&!B&!A1&A|E1&E&!D&!C2&C1&!C&!B&!A1&A|!E1&E&!D&!C2&C1&!C&!B&!A1&A|!E1&!E&D&!C2&C1&!C&!B&!A1&A|!E1&!E&D&C2&C1&!C&!B&!A1&A|!E1&E&!D&C2&C1&!C&!B&!A1&A|E1&E&!D&C2&C1&!C&!B&!A1&A|E1&!E&!D&C2&C1&!C&!B&!A1&A|!E1&!E&!D&C2&C1&!C&!B&!A1&A|!E1&!E&!D&C2&!C1&!C&!B&!A1&A|E1&!E&!D&C2&!C1&!C&!B&!A1&A|E1&E&!D&C2&!C1&!C&!B&!A1&A|!E1&E&!D&C2&!C1&!C&!B&!A1&A|!E1&!E&D&C2&!C1&!C&!B&!A1&A|!E1&!E&D&!C2&!C1&!C&!B&!A1&A|!E1&E&!D&!C2&!C1&!C&!B&!A1&A|E1&E&!D&!C2&!C1&!C&!B&!A1&A|E1&!E&!D&!C2&!C1&!C&!B&!A1&A|!E1&!E&!D&!C2&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOOAI21312.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOOAOI222211 -l AAAOOAOI222211 -i F E D1 D C1 C B1 B A1 A -o Y -f Y=(!F&!E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!F&!E&D1&D&!C1&!C&!B1&!B&!A1&!A|!F&E&D1&D&!C1&!C&!B1&!B&!A1&!A|!F&E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!F&!E&!D1&D&C1&!C&!B1&!B&!A1&!A|!F&E&!D1&D&C1&!C&!B1&!B&!A1&!A|!F&E&D1&D&C1&!C&!B1&!B&!A1&!A|!F&!E&D1&D&C1&!C&!B1&!B&!A1&!A|!F&!E&D1&!D&C1&!C&!B1&!B&!A1&!A|!F&E&D1&!D&C1&!C&!B1&!B&!A1&!A|!F&E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!F&!E&!D1&!D&C1&C&!B1&!B&!A1&!A|!F&E&!D1&!D&C1&C&!B1&!B&!A1&!A|!F&!E&D1&!D&C1&C&!B1&!B&!A1&!A|!F&!E&D1&D&C1&C&!B1&!B&!A1&!A|!F&!E&!D1&D&C1&C&!B1&!B&!A1&!A|!F&!E&!D1&D&!C1&C&!B1&!B&!A1&!A|!F&E&!D1&D&!C1&C&!B1&!B&!A1&!A|!F&E&D1&D&!C1&C&!B1&!B&!A1&!A|!F&!E&D1&D&!C1&C&!B1&!B&!A1&!A|!F&!E&D1&!D&!C1&C&!B1&!B&!A1&!A|!F&E&D1&!D&!C1&C&!B1&!B&!A1&!A|!F&E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!F&!E&!D1&!D&!C1&C&B1&!B&!A1&!A|!F&E&!D1&!D&!C1&C&B1&!B&!A1&!A|!F&E&D1&!D&!C1&C&B1&!B&!A1&!A|!F&!E&D1&!D&!C1&C&B1&!B&!A1&!A|!F&!E&D1&D&!C1&C&B1&!B&!A1&!A|!F&E&D1&D&!C1&C&B1&!B&!A1&!A|!F&E&!D1&D&!C1&C&B1&!B&!A1&!A|!F&!E&!D1&D&!C1&C&B1&!B&!A1&!A|!F&!E&!D1&D&C1&C&B1&!B&!A1&!A|!F&!E&D1&D&C1&C&B1&!B&!A1&!A|!F&!E&D1&!D&C1&C&B1&!B&!A1&!A|!F&E&!D1&!D&C1&C&B1&!B&!A1&!A|!F&!E&!D1&!D&C1&C&B1&!B&!A1&!A|!F&!E&!D1&!D&C1&!C&B1&!B&!A1&!A|!F&E&!D1&!D&C1&!C&B1&!B&!A1&!A|!F&E&D1&!D&C1&!C&B1&!B&!A1&!A|!F&!E&D1&!D&C1&!C&B1&!B&!A1&!A|!F&!E&D1&D&C1&!C&B1&!B&!A1&!A|!F&E&D1&D&C1&!C&B1&!B&!A1&!A|!F&E&!D1&D&C1&!C&B1&!B&!A1&!A|!F&!E&!D1&D&C1&!C&B1&!B&!A1&!A|!F&!E&!D1&D&!C1&!C&B1&!B&!A1&!A|!F&E&!D1&D&!C1&!C&B1&!B&!A1&!A|!F&E&D1&D&!C1&!C&B1&!B&!A1&!A|!F&!E&D1&D&!C1&!C&B1&!B&!A1&!A|!F&!E&D1&!D&!C1&!C&B1&!B&!A1&!A|!F&E&D1&!D&!C1&!C&B1&!B&!A1&!A|!F&E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!F&!E&!D1&!D&!C1&!C&B1&B&!A1&!A|!F&E&!D1&!D&!C1&!C&B1&B&!A1&!A|!F&!E&D1&!D&!C1&!C&B1&B&!A1&!A|!F&!E&D1&D&!C1&!C&B1&B&!A1&!A|!F&!E&!D1&D&!C1&!C&B1&B&!A1&!A|!F&!E&!D1&D&C1&!C&B1&B&!A1&!A|!F&!E&D1&D&C1&!C&B1&B&!A1&!A|!F&!E&D1&!D&C1&!C&B1&B&!A1&!A|!F&E&!D1&!D&C1&!C&B1&B&!A1&!A|!F&!E&!D1&!D&C1&!C&B1&B&!A1&!A|!F&!E&!D1&!D&C1&C&B1&B&!A1&!A|!F&E&!D1&!D&C1&C&B1&B&!A1&!A|!F&!E&D1&!D&C1&C&B1&B&!A1&!A|!F&!E&D1&D&C1&C&B1&B&!A1&!A|!F&!E&!D1&D&C1&C&B1&B&!A1&!A|!F&!E&!D1&D&!C1&C&B1&B&!A1&!A|!F&!E&D1&D&!C1&C&B1&B&!A1&!A|!F&!E&D1&!D&!C1&C&B1&B&!A1&!A|!F&E&!D1&!D&!C1&C&B1&B&!A1&!A|!F&!E&!D1&!D&!C1&C&B1&B&!A1&!A|!F&!E&!D1&!D&!C1&C&!B1&B&!A1&!A|!F&E&!D1&!D&!C1&C&!B1&B&!A1&!A|!F&E&D1&!D&!C1&C&!B1&B&!A1&!A|!F&!E&D1&!D&!C1&C&!B1&B&!A1&!A|!F&!E&D1&D&!C1&C&!B1&B&!A1&!A|!F&E&D1&D&!C1&C&!B1&B&!A1&!A|!F&E&!D1&D&!C1&C&!B1&B&!A1&!A|!F&!E&!D1&D&!C1&C&!B1&B&!A1&!A|!F&!E&!D1&D&C1&C&!B1&B&!A1&!A|!F&!E&D1&D&C1&C&!B1&B&!A1&!A|!F&!E&D1&!D&C1&C&!B1&B&!A1&!A|!F&E&!D1&!D&C1&C&!B1&B&!A1&!A|!F&!E&!D1&!D&C1&C&!B1&B&!A1&!A|!F&!E&!D1&!D&C1&!C&!B1&B&!A1&!A|!F&E&!D1&!D&C1&!C&!B1&B&!A1&!A|!F&E&D1&!D&C1&!C&!B1&B&!A1&!A|!F&!E&D1&!D&C1&!C&!B1&B&!A1&!A|!F&!E&D1&D&C1&!C&!B1&B&!A1&!A|!F&E&D1&D&C1&!C&!B1&B&!A1&!A|!F&E&!D1&D&C1&!C&!B1&B&!A1&!A|!F&!E&!D1&D&C1&!C&!B1&B&!A1&!A|!F&!E&!D1&D&!C1&!C&!B1&B&!A1&!A|!F&E&!D1&D&!C1&!C&!B1&B&!A1&!A|!F&E&D1&D&!C1&!C&!B1&B&!A1&!A|!F&!E&D1&D&!C1&!C&!B1&B&!A1&!A|!F&!E&D1&!D&!C1&!C&!B1&B&!A1&!A|!F&E&D1&!D&!C1&!C&!B1&B&!A1&!A|!F&E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!F&!E&!D1&!D&!C1&!C&!B1&B&A1&!A|!F&E&!D1&!D&!C1&!C&!B1&B&A1&!A|!F&E&D1&!D&!C1&!C&!B1&B&A1&!A|!F&!E&D1&!D&!C1&!C&!B1&B&A1&!A|!F&!E&D1&D&!C1&!C&!B1&B&A1&!A|!F&E&D1&D&!C1&!C&!B1&B&A1&!A|!F&E&!D1&D&!C1&!C&!B1&B&A1&!A|!F&!E&!D1&D&!C1&!C&!B1&B&A1&!A|!F&!E&!D1&D&C1&!C&!B1&B&A1&!A|!F&E&!D1&D&C1&!C&!B1&B&A1&!A|!F&E&D1&D&C1&!C&!B1&B&A1&!A|!F&!E&D1&D&C1&!C&!B1&B&A1&!A|!F&!E&D1&!D&C1&!C&!B1&B&A1&!A|!F&E&D1&!D&C1&!C&!B1&B&A1&!A|!F&E&!D1&!D&C1&!C&!B1&B&A1&!A|!F&!E&!D1&!D&C1&!C&!B1&B&A1&!A|!F&!E&!D1&!D&C1&C&!B1&B&A1&!A|!F&E&!D1&!D&C1&C&!B1&B&A1&!A|!F&!E&D1&!D&C1&C&!B1&B&A1&!A|!F&!E&D1&D&C1&C&!B1&B&A1&!A|!F&!E&!D1&D&C1&C&!B1&B&A1&!A|!F&!E&!D1&D&!C1&C&!B1&B&A1&!A|!F&E&!D1&D&!C1&C&!B1&B&A1&!A|!F&E&D1&D&!C1&C&!B1&B&A1&!A|!F&!E&D1&D&!C1&C&!B1&B&A1&!A|!F&!E&D1&!D&!C1&C&!B1&B&A1&!A|!F&E&D1&!D&!C1&C&!B1&B&A1&!A|!F&E&!D1&!D&!C1&C&!B1&B&A1&!A|!F&!E&!D1&!D&!C1&C&!B1&B&A1&!A|!F&!E&!D1&!D&!C1&C&B1&B&A1&!A|!F&E&!D1&!D&!C1&C&B1&B&A1&!A|!F&!E&D1&!D&!C1&C&B1&B&A1&!A|!F&!E&D1&D&!C1&C&B1&B&A1&!A|!F&!E&!D1&D&!C1&C&B1&B&A1&!A|!F&!E&!D1&D&C1&C&B1&B&A1&!A|!F&!E&D1&D&C1&C&B1&B&A1&!A|!F&!E&D1&!D&C1&C&B1&B&A1&!A|!F&E&!D1&!D&C1&C&B1&B&A1&!A|!F&!E&!D1&!D&C1&C&B1&B&A1&!A|!F&!E&!D1&!D&C1&!C&B1&B&A1&!A|!F&E&!D1&!D&C1&!C&B1&B&A1&!A|!F&!E&D1&!D&C1&!C&B1&B&A1&!A|!F&!E&D1&D&C1&!C&B1&B&A1&!A|!F&!E&!D1&D&C1&!C&B1&B&A1&!A|!F&!E&!D1&D&!C1&!C&B1&B&A1&!A|!F&!E&D1&D&!C1&!C&B1&B&A1&!A|!F&!E&D1&!D&!C1&!C&B1&B&A1&!A|!F&E&!D1&!D&!C1&!C&B1&B&A1&!A|!F&!E&!D1&!D&!C1&!C&B1&B&A1&!A|!F&!E&!D1&!D&!C1&!C&B1&!B&A1&!A|!F&E&!D1&!D&!C1&!C&B1&!B&A1&!A|!F&E&D1&!D&!C1&!C&B1&!B&A1&!A|!F&!E&D1&!D&!C1&!C&B1&!B&A1&!A|!F&!E&D1&D&!C1&!C&B1&!B&A1&!A|!F&E&D1&D&!C1&!C&B1&!B&A1&!A|!F&E&!D1&D&!C1&!C&B1&!B&A1&!A|!F&!E&!D1&D&!C1&!C&B1&!B&A1&!A|!F&!E&!D1&D&C1&!C&B1&!B&A1&!A|!F&E&!D1&D&C1&!C&B1&!B&A1&!A|!F&E&D1&D&C1&!C&B1&!B&A1&!A|!F&!E&D1&D&C1&!C&B1&!B&A1&!A|!F&!E&D1&!D&C1&!C&B1&!B&A1&!A|!F&E&D1&!D&C1&!C&B1&!B&A1&!A|!F&E&!D1&!D&C1&!C&B1&!B&A1&!A|!F&!E&!D1&!D&C1&!C&B1&!B&A1&!A|!F&!E&!D1&!D&C1&C&B1&!B&A1&!A|!F&E&!D1&!D&C1&C&B1&!B&A1&!A|!F&!E&D1&!D&C1&C&B1&!B&A1&!A|!F&!E&D1&D&C1&C&B1&!B&A1&!A|!F&!E&!D1&D&C1&C&B1&!B&A1&!A|!F&!E&!D1&D&!C1&C&B1&!B&A1&!A|!F&E&!D1&D&!C1&C&B1&!B&A1&!A|!F&E&D1&D&!C1&C&B1&!B&A1&!A|!F&!E&D1&D&!C1&C&B1&!B&A1&!A|!F&!E&D1&!D&!C1&C&B1&!B&A1&!A|!F&E&D1&!D&!C1&C&B1&!B&A1&!A|!F&E&!D1&!D&!C1&C&B1&!B&A1&!A|!F&!E&!D1&!D&!C1&C&B1&!B&A1&!A|!F&!E&!D1&!D&!C1&C&!B1&!B&A1&!A|!F&E&!D1&!D&!C1&C&!B1&!B&A1&!A|!F&E&D1&!D&!C1&C&!B1&!B&A1&!A|!F&!E&D1&!D&!C1&C&!B1&!B&A1&!A|!F&!E&D1&D&!C1&C&!B1&!B&A1&!A|!F&E&D1&D&!C1&C&!B1&!B&A1&!A|!F&E&!D1&D&!C1&C&!B1&!B&A1&!A|!F&!E&!D1&D&!C1&C&!B1&!B&A1&!A|!F&!E&!D1&D&C1&C&!B1&!B&A1&!A|!F&!E&D1&D&C1&C&!B1&!B&A1&!A|!F&!E&D1&!D&C1&C&!B1&!B&A1&!A|!F&E&!D1&!D&C1&C&!B1&!B&A1&!A|!F&!E&!D1&!D&C1&C&!B1&!B&A1&!A|!F&!E&!D1&!D&C1&!C&!B1&!B&A1&!A|!F&E&!D1&!D&C1&!C&!B1&!B&A1&!A|!F&E&D1&!D&C1&!C&!B1&!B&A1&!A|!F&!E&D1&!D&C1&!C&!B1&!B&A1&!A|!F&!E&D1&D&C1&!C&!B1&!B&A1&!A|!F&E&D1&D&C1&!C&!B1&!B&A1&!A|!F&E&!D1&D&C1&!C&!B1&!B&A1&!A|!F&!E&!D1&D&C1&!C&!B1&!B&A1&!A|!F&!E&!D1&D&!C1&!C&!B1&!B&A1&!A|!F&E&!D1&D&!C1&!C&!B1&!B&A1&!A|!F&E&D1&D&!C1&!C&!B1&!B&A1&!A|!F&!E&D1&D&!C1&!C&!B1&!B&A1&!A|!F&!E&D1&!D&!C1&!C&!B1&!B&A1&!A|!F&E&D1&!D&!C1&!C&!B1&!B&A1&!A|!F&E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!F&!E&!D1&!D&!C1&!C&!B1&!B&A1&A|!F&E&!D1&!D&!C1&!C&!B1&!B&A1&A|!F&!E&D1&!D&!C1&!C&!B1&!B&A1&A|!F&!E&D1&D&!C1&!C&!B1&!B&A1&A|!F&!E&!D1&D&!C1&!C&!B1&!B&A1&A|!F&!E&!D1&D&C1&!C&!B1&!B&A1&A|!F&!E&D1&D&C1&!C&!B1&!B&A1&A|!F&!E&D1&!D&C1&!C&!B1&!B&A1&A|!F&E&!D1&!D&C1&!C&!B1&!B&A1&A|!F&!E&!D1&!D&C1&!C&!B1&!B&A1&A|!F&!E&!D1&!D&C1&C&!B1&!B&A1&A|!F&E&!D1&!D&C1&C&!B1&!B&A1&A|!F&!E&D1&!D&C1&C&!B1&!B&A1&A|!F&!E&D1&D&C1&C&!B1&!B&A1&A|!F&!E&!D1&D&C1&C&!B1&!B&A1&A|!F&!E&!D1&D&!C1&C&!B1&!B&A1&A|!F&!E&D1&D&!C1&C&!B1&!B&A1&A|!F&!E&D1&!D&!C1&C&!B1&!B&A1&A|!F&E&!D1&!D&!C1&C&!B1&!B&A1&A|!F&!E&!D1&!D&!C1&C&!B1&!B&A1&A|!F&!E&!D1&!D&!C1&C&B1&!B&A1&A|!F&E&!D1&!D&!C1&C&B1&!B&A1&A|!F&!E&D1&!D&!C1&C&B1&!B&A1&A|!F&!E&D1&D&!C1&C&B1&!B&A1&A|!F&!E&!D1&D&!C1&C&B1&!B&A1&A|!F&!E&!D1&D&C1&C&B1&!B&A1&A|!F&!E&D1&D&C1&C&B1&!B&A1&A|!F&!E&D1&!D&C1&C&B1&!B&A1&A|!F&E&!D1&!D&C1&C&B1&!B&A1&A|!F&!E&!D1&!D&C1&C&B1&!B&A1&A|!F&!E&!D1&!D&C1&!C&B1&!B&A1&A|!F&E&!D1&!D&C1&!C&B1&!B&A1&A|!F&!E&D1&!D&C1&!C&B1&!B&A1&A|!F&!E&D1&D&C1&!C&B1&!B&A1&A|!F&!E&!D1&D&C1&!C&B1&!B&A1&A|!F&!E&!D1&D&!C1&!C&B1&!B&A1&A|!F&!E&D1&D&!C1&!C&B1&!B&A1&A|!F&!E&D1&!D&!C1&!C&B1&!B&A1&A|!F&E&!D1&!D&!C1&!C&B1&!B&A1&A|!F&!E&!D1&!D&!C1&!C&B1&!B&A1&A|!F&!E&!D1&!D&!C1&!C&B1&B&A1&A|!F&E&!D1&!D&!C1&!C&B1&B&A1&A|!F&!E&D1&!D&!C1&!C&B1&B&A1&A|!F&!E&D1&D&!C1&!C&B1&B&A1&A|!F&!E&!D1&D&!C1&!C&B1&B&A1&A|!F&!E&!D1&D&C1&!C&B1&B&A1&A|!F&!E&D1&D&C1&!C&B1&B&A1&A|!F&!E&D1&!D&C1&!C&B1&B&A1&A|!F&E&!D1&!D&C1&!C&B1&B&A1&A|!F&!E&!D1&!D&C1&!C&B1&B&A1&A|!F&!E&!D1&!D&C1&C&B1&B&A1&A|!F&E&!D1&!D&C1&C&B1&B&A1&A|!F&!E&D1&!D&C1&C&B1&B&A1&A|!F&!E&D1&D&C1&C&B1&B&A1&A|!F&!E&!D1&D&C1&C&B1&B&A1&A|!F&!E&!D1&D&!C1&C&B1&B&A1&A|!F&!E&D1&D&!C1&C&B1&B&A1&A|!F&!E&D1&!D&!C1&C&B1&B&A1&A|!F&E&!D1&!D&!C1&C&B1&B&A1&A|!F&!E&!D1&!D&!C1&C&B1&B&A1&A|!F&!E&!D1&!D&!C1&C&!B1&B&A1&A|!F&E&!D1&!D&!C1&C&!B1&B&A1&A|!F&!E&D1&!D&!C1&C&!B1&B&A1&A|!F&!E&D1&D&!C1&C&!B1&B&A1&A|!F&!E&!D1&D&!C1&C&!B1&B&A1&A|!F&!E&!D1&D&C1&C&!B1&B&A1&A|!F&!E&D1&D&C1&C&!B1&B&A1&A|!F&!E&D1&!D&C1&C&!B1&B&A1&A|!F&E&!D1&!D&C1&C&!B1&B&A1&A|!F&!E&!D1&!D&C1&C&!B1&B&A1&A|!F&!E&!D1&!D&C1&!C&!B1&B&A1&A|!F&E&!D1&!D&C1&!C&!B1&B&A1&A|!F&!E&D1&!D&C1&!C&!B1&B&A1&A|!F&!E&D1&D&C1&!C&!B1&B&A1&A|!F&!E&!D1&D&C1&!C&!B1&B&A1&A|!F&!E&!D1&D&!C1&!C&!B1&B&A1&A|!F&!E&D1&D&!C1&!C&!B1&B&A1&A|!F&!E&D1&!D&!C1&!C&!B1&B&A1&A|!F&E&!D1&!D&!C1&!C&!B1&B&A1&A|!F&!E&!D1&!D&!C1&!C&!B1&B&A1&A|!F&!E&!D1&!D&!C1&!C&!B1&B&!A1&A|!F&E&!D1&!D&!C1&!C&!B1&B&!A1&A|!F&E&D1&!D&!C1&!C&!B1&B&!A1&A|!F&!E&D1&!D&!C1&!C&!B1&B&!A1&A|!F&!E&D1&D&!C1&!C&!B1&B&!A1&A|!F&E&D1&D&!C1&!C&!B1&B&!A1&A|!F&E&!D1&D&!C1&!C&!B1&B&!A1&A|!F&!E&!D1&D&!C1&!C&!B1&B&!A1&A|!F&!E&!D1&D&C1&!C&!B1&B&!A1&A|!F&E&!D1&D&C1&!C&!B1&B&!A1&A|!F&E&D1&D&C1&!C&!B1&B&!A1&A|!F&!E&D1&D&C1&!C&!B1&B&!A1&A|!F&!E&D1&!D&C1&!C&!B1&B&!A1&A|!F&E&D1&!D&C1&!C&!B1&B&!A1&A|!F&E&!D1&!D&C1&!C&!B1&B&!A1&A|!F&!E&!D1&!D&C1&!C&!B1&B&!A1&A|!F&!E&!D1&!D&C1&C&!B1&B&!A1&A|!F&E&!D1&!D&C1&C&!B1&B&!A1&A|!F&!E&D1&!D&C1&C&!B1&B&!A1&A|!F&!E&D1&D&C1&C&!B1&B&!A1&A|!F&!E&!D1&D&C1&C&!B1&B&!A1&A|!F&!E&!D1&D&!C1&C&!B1&B&!A1&A|!F&E&!D1&D&!C1&C&!B1&B&!A1&A|!F&E&D1&D&!C1&C&!B1&B&!A1&A|!F&!E&D1&D&!C1&C&!B1&B&!A1&A|!F&!E&D1&!D&!C1&C&!B1&B&!A1&A|!F&E&D1&!D&!C1&C&!B1&B&!A1&A|!F&E&!D1&!D&!C1&C&!B1&B&!A1&A|!F&!E&!D1&!D&!C1&C&!B1&B&!A1&A|!F&!E&!D1&!D&!C1&C&B1&B&!A1&A|!F&E&!D1&!D&!C1&C&B1&B&!A1&A|!F&!E&D1&!D&!C1&C&B1&B&!A1&A|!F&!E&D1&D&!C1&C&B1&B&!A1&A|!F&!E&!D1&D&!C1&C&B1&B&!A1&A|!F&!E&!D1&D&C1&C&B1&B&!A1&A|!F&!E&D1&D&C1&C&B1&B&!A1&A|!F&!E&D1&!D&C1&C&B1&B&!A1&A|!F&E&!D1&!D&C1&C&B1&B&!A1&A|!F&!E&!D1&!D&C1&C&B1&B&!A1&A|!F&!E&!D1&!D&C1&!C&B1&B&!A1&A|!F&E&!D1&!D&C1&!C&B1&B&!A1&A|!F&!E&D1&!D&C1&!C&B1&B&!A1&A|!F&!E&D1&D&C1&!C&B1&B&!A1&A|!F&!E&!D1&D&C1&!C&B1&B&!A1&A|!F&!E&!D1&D&!C1&!C&B1&B&!A1&A|!F&!E&D1&D&!C1&!C&B1&B&!A1&A|!F&!E&D1&!D&!C1&!C&B1&B&!A1&A|!F&E&!D1&!D&!C1&!C&B1&B&!A1&A|!F&!E&!D1&!D&!C1&!C&B1&B&!A1&A|!F&!E&!D1&!D&!C1&!C&B1&!B&!A1&A|!F&E&!D1&!D&!C1&!C&B1&!B&!A1&A|!F&E&D1&!D&!C1&!C&B1&!B&!A1&A|!F&!E&D1&!D&!C1&!C&B1&!B&!A1&A|!F&!E&D1&D&!C1&!C&B1&!B&!A1&A|!F&E&D1&D&!C1&!C&B1&!B&!A1&A|!F&E&!D1&D&!C1&!C&B1&!B&!A1&A|!F&!E&!D1&D&!C1&!C&B1&!B&!A1&A|!F&!E&!D1&D&C1&!C&B1&!B&!A1&A|!F&E&!D1&D&C1&!C&B1&!B&!A1&A|!F&E&D1&D&C1&!C&B1&!B&!A1&A|!F&!E&D1&D&C1&!C&B1&!B&!A1&A|!F&!E&D1&!D&C1&!C&B1&!B&!A1&A|!F&E&D1&!D&C1&!C&B1&!B&!A1&A|!F&E&!D1&!D&C1&!C&B1&!B&!A1&A|!F&!E&!D1&!D&C1&!C&B1&!B&!A1&A|!F&!E&!D1&!D&C1&C&B1&!B&!A1&A|!F&E&!D1&!D&C1&C&B1&!B&!A1&A|!F&!E&D1&!D&C1&C&B1&!B&!A1&A|!F&!E&D1&D&C1&C&B1&!B&!A1&A|!F&!E&!D1&D&C1&C&B1&!B&!A1&A|!F&!E&!D1&D&!C1&C&B1&!B&!A1&A|!F&E&!D1&D&!C1&C&B1&!B&!A1&A|!F&E&D1&D&!C1&C&B1&!B&!A1&A|!F&!E&D1&D&!C1&C&B1&!B&!A1&A|!F&!E&D1&!D&!C1&C&B1&!B&!A1&A|!F&E&D1&!D&!C1&C&B1&!B&!A1&A|!F&E&!D1&!D&!C1&C&B1&!B&!A1&A|!F&!E&!D1&!D&!C1&C&B1&!B&!A1&A|!F&!E&!D1&!D&!C1&C&!B1&!B&!A1&A|!F&E&!D1&!D&!C1&C&!B1&!B&!A1&A|!F&E&D1&!D&!C1&C&!B1&!B&!A1&A|!F&!E&D1&!D&!C1&C&!B1&!B&!A1&A|!F&!E&D1&D&!C1&C&!B1&!B&!A1&A|!F&E&D1&D&!C1&C&!B1&!B&!A1&A|!F&E&!D1&D&!C1&C&!B1&!B&!A1&A|!F&!E&!D1&D&!C1&C&!B1&!B&!A1&A|!F&!E&!D1&D&C1&C&!B1&!B&!A1&A|!F&!E&D1&D&C1&C&!B1&!B&!A1&A|!F&!E&D1&!D&C1&C&!B1&!B&!A1&A|!F&E&!D1&!D&C1&C&!B1&!B&!A1&A|!F&!E&!D1&!D&C1&C&!B1&!B&!A1&A|!F&!E&!D1&!D&C1&!C&!B1&!B&!A1&A|!F&E&!D1&!D&C1&!C&!B1&!B&!A1&A|!F&E&D1&!D&C1&!C&!B1&!B&!A1&A|!F&!E&D1&!D&C1&!C&!B1&!B&!A1&A|!F&!E&D1&D&C1&!C&!B1&!B&!A1&A|!F&E&D1&D&C1&!C&!B1&!B&!A1&A|!F&E&!D1&D&C1&!C&!B1&!B&!A1&A|!F&!E&!D1&D&C1&!C&!B1&!B&!A1&A|!F&!E&!D1&D&!C1&!C&!B1&!B&!A1&A|!F&E&!D1&D&!C1&!C&!B1&!B&!A1&A|!F&E&D1&D&!C1&!C&!B1&!B&!A1&A|!F&!E&D1&D&!C1&!C&!B1&!B&!A1&A|!F&!E&D1&!D&!C1&!C&!B1&!B&!A1&A|!F&E&D1&!D&!C1&!C&!B1&!B&!A1&A|!F&E&!D1&!D&!C1&!C&!B1&!B&!A1&A|!F&!E&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOOAOI222211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAAAOI22232 -l AAOOAAAOI22232 -i E1 E D2 D1 D C1 C B1 B A1 A -o Y -f Y=(!E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&E&D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E1&E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|E1&!E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&D2&D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&E&D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E1&E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&C1&C&!B1&!B&!A1&!A|!E1&!E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E1&E&D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E1&E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|E1&!E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&C1&C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|E1&!E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|!E1&E&!D2&D1&D&C1&C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|E1&!E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E1&E&D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&C1&C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E1&E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|E1&!E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&D2&D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&E&D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|E1&!E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&C&B1&!B&!A1&!A|!E1&!E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|E1&!E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E1&E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|E1&!E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&C&B1&!B&!A1&!A|!E1&!E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|E1&!E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|!E1&E&!D2&D1&D&!C1&C&B1&!B&!A1&!A|!E1&!E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|E1&!E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E1&E&D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E1&E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|E1&!E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|E1&!E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|!E1&E&!D2&!D1&D&C1&C&B1&!B&!A1&!A|!E1&E&D2&!D1&D&C1&C&B1&!B&!A1&!A|E1&!E&D2&!D1&D&C1&C&B1&!B&!A1&!A|!E1&!E&D2&!D1&D&C1&C&B1&!B&!A1&!A|!E1&E&!D2&D1&D&C1&C&B1&!B&!A1&!A|E1&!E&!D2&D1&D&C1&C&B1&!B&!A1&!A|!E1&!E&!D2&D1&D&C1&C&B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|E1&!E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|!E1&E&!D2&D1&!D&C1&C&B1&!B&!A1&!A|!E1&E&D2&D1&!D&C1&C&B1&!B&!A1&!A|E1&!E&D2&D1&!D&C1&C&B1&!B&!A1&!A|!E1&!E&D2&D1&!D&C1&C&B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|E1&!E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E1&E&D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|E1&!E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&C1&!C&B1&!B&!A1&!A|!E1&!E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|E1&!E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E1&E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|E1&!E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|E1&!E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|!E1&E&!D2&D1&D&C1&!C&B1&!B&!A1&!A|!E1&!E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|E1&!E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E1&E&D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E1&E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|E1&!E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E1&E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|E1&!E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E1&!E&D2&!D1&D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&D2&D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&E&D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|E1&!E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&B1&B&!A1&!A|!E1&!E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|E1&!E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E1&E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|E1&!E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&B1&B&!A1&!A|!E1&!E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|E1&!E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|!E1&E&!D2&D1&D&!C1&!C&B1&B&!A1&!A|!E1&!E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|E1&!E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E1&E&D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|E1&!E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&C&!B1&B&!A1&!A|!E1&!E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|E1&!E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E1&E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|E1&!E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&C&!B1&B&!A1&!A|!E1&!E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|E1&!E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|!E1&E&!D2&D1&D&!C1&C&!B1&B&!A1&!A|!E1&!E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|E1&!E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E1&E&D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E1&E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|E1&!E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|E1&!E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|!E1&E&!D2&!D1&D&C1&C&!B1&B&!A1&!A|!E1&E&D2&!D1&D&C1&C&!B1&B&!A1&!A|E1&!E&D2&!D1&D&C1&C&!B1&B&!A1&!A|!E1&!E&D2&!D1&D&C1&C&!B1&B&!A1&!A|!E1&E&!D2&D1&D&C1&C&!B1&B&!A1&!A|E1&!E&!D2&D1&D&C1&C&!B1&B&!A1&!A|!E1&!E&!D2&D1&D&C1&C&!B1&B&!A1&!A|!E1&!E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|E1&!E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|!E1&E&!D2&D1&!D&C1&C&!B1&B&!A1&!A|!E1&E&D2&D1&!D&C1&C&!B1&B&!A1&!A|E1&!E&D2&D1&!D&C1&C&!B1&B&!A1&!A|!E1&!E&D2&D1&!D&C1&C&!B1&B&!A1&!A|!E1&!E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|E1&!E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E1&E&D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|E1&!E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E1&!E&D2&!D1&!D&C1&!C&!B1&B&!A1&!A|!E1&!E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|E1&!E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E1&E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|E1&!E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&D1&!D&C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|E1&!E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|!E1&E&!D2&D1&D&C1&!C&!B1&B&!A1&!A|!E1&!E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|E1&!E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E1&E&D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E1&E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|E1&!E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&D&C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E1&E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|E1&!E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E1&!E&D2&!D1&D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&D2&D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&E&D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&!B1&B&A1&!A|!E1&!E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E1&E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|E1&!E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&!B1&B&A1&!A|!E1&!E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|E1&!E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|!E1&E&!D2&D1&D&!C1&!C&!B1&B&A1&!A|!E1&!E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|E1&!E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E1&E&D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E1&E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|E1&!E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&!B1&B&A1&!A|!E1&!E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|E1&!E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|!E1&E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|!E1&E&D2&!D1&D&C1&!C&!B1&B&A1&!A|E1&!E&D2&!D1&D&C1&!C&!B1&B&A1&!A|!E1&!E&D2&!D1&D&C1&!C&!B1&B&A1&!A|!E1&E&!D2&D1&D&C1&!C&!B1&B&A1&!A|E1&!E&!D2&D1&D&C1&!C&!B1&B&A1&!A|!E1&!E&!D2&D1&D&C1&!C&!B1&B&A1&!A|!E1&!E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|E1&!E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|!E1&E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|!E1&E&D2&D1&!D&C1&!C&!B1&B&A1&!A|E1&!E&D2&D1&!D&C1&!C&!B1&B&A1&!A|!E1&!E&D2&D1&!D&C1&!C&!B1&B&A1&!A|!E1&!E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|E1&!E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|!E1&E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|!E1&E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|!E1&!E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|!E1&E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|!E1&E&D2&!D1&!D&C1&C&!B1&B&A1&!A|E1&!E&D2&!D1&!D&C1&C&!B1&B&A1&!A|!E1&!E&D2&!D1&!D&C1&C&!B1&B&A1&!A|!E1&!E&D2&D1&!D&C1&C&!B1&B&A1&!A|E1&!E&D2&D1&!D&C1&C&!B1&B&A1&!A|!E1&E&D2&D1&!D&C1&C&!B1&B&A1&!A|!E1&E&!D2&D1&!D&C1&C&!B1&B&A1&!A|E1&!E&!D2&D1&!D&C1&C&!B1&B&A1&!A|!E1&!E&!D2&D1&!D&C1&C&!B1&B&A1&!A|!E1&!E&!D2&D1&D&C1&C&!B1&B&A1&!A|E1&!E&!D2&D1&D&C1&C&!B1&B&A1&!A|!E1&E&!D2&D1&D&C1&C&!B1&B&A1&!A|!E1&!E&D2&!D1&D&C1&C&!B1&B&A1&!A|E1&!E&D2&!D1&D&C1&C&!B1&B&A1&!A|!E1&E&D2&!D1&D&C1&C&!B1&B&A1&!A|!E1&E&!D2&!D1&D&C1&C&!B1&B&A1&!A|E1&!E&!D2&!D1&D&C1&C&!B1&B&A1&!A|!E1&!E&!D2&!D1&D&C1&C&!B1&B&A1&!A|!E1&!E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|E1&!E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|!E1&E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|!E1&E&D2&!D1&D&!C1&C&!B1&B&A1&!A|E1&!E&D2&!D1&D&!C1&C&!B1&B&A1&!A|!E1&!E&D2&!D1&D&!C1&C&!B1&B&A1&!A|!E1&E&!D2&D1&D&!C1&C&!B1&B&A1&!A|E1&!E&!D2&D1&D&!C1&C&!B1&B&A1&!A|!E1&!E&!D2&D1&D&!C1&C&!B1&B&A1&!A|!E1&!E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|E1&!E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|!E1&E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|!E1&E&D2&D1&!D&!C1&C&!B1&B&A1&!A|E1&!E&D2&D1&!D&!C1&C&!B1&B&A1&!A|!E1&!E&D2&D1&!D&!C1&C&!B1&B&A1&!A|!E1&!E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|E1&!E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|!E1&E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|!E1&E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|E1&!E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|!E1&E&!D2&!D1&D&!C1&!C&B1&B&A1&!A|!E1&E&D2&!D1&D&!C1&!C&B1&B&A1&!A|E1&!E&D2&!D1&D&!C1&!C&B1&B&A1&!A|!E1&!E&D2&!D1&D&!C1&!C&B1&B&A1&!A|!E1&E&!D2&D1&D&!C1&!C&B1&B&A1&!A|E1&!E&!D2&D1&D&!C1&!C&B1&B&A1&!A|!E1&!E&!D2&D1&D&!C1&!C&B1&B&A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|E1&!E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|!E1&E&!D2&D1&!D&!C1&!C&B1&B&A1&!A|!E1&E&D2&D1&!D&!C1&!C&B1&B&A1&!A|E1&!E&D2&D1&!D&!C1&!C&B1&B&A1&!A|!E1&!E&D2&D1&!D&!C1&!C&B1&B&A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|E1&!E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E1&E&D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&B1&!B&A1&!A|!E1&!E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E1&E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|E1&!E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&B1&!B&A1&!A|!E1&!E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|E1&!E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|!E1&E&!D2&D1&D&!C1&!C&B1&!B&A1&!A|!E1&!E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|E1&!E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E1&E&D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E1&E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|E1&!E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&B1&!B&A1&!A|!E1&!E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|E1&!E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|!E1&E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|!E1&E&D2&!D1&D&C1&!C&B1&!B&A1&!A|E1&!E&D2&!D1&D&C1&!C&B1&!B&A1&!A|!E1&!E&D2&!D1&D&C1&!C&B1&!B&A1&!A|!E1&E&!D2&D1&D&C1&!C&B1&!B&A1&!A|E1&!E&!D2&D1&D&C1&!C&B1&!B&A1&!A|!E1&!E&!D2&D1&D&C1&!C&B1&!B&A1&!A|!E1&!E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|E1&!E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|!E1&E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|!E1&E&D2&D1&!D&C1&!C&B1&!B&A1&!A|E1&!E&D2&D1&!D&C1&!C&B1&!B&A1&!A|!E1&!E&D2&D1&!D&C1&!C&B1&!B&A1&!A|!E1&!E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|E1&!E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|!E1&E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|!E1&E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|E1&!E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|E1&!E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|!E1&E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|!E1&E&D2&!D1&!D&C1&C&B1&!B&A1&!A|E1&!E&D2&!D1&!D&C1&C&B1&!B&A1&!A|!E1&!E&D2&!D1&!D&C1&C&B1&!B&A1&!A|!E1&!E&D2&D1&!D&C1&C&B1&!B&A1&!A|E1&!E&D2&D1&!D&C1&C&B1&!B&A1&!A|!E1&E&D2&D1&!D&C1&C&B1&!B&A1&!A|!E1&E&!D2&D1&!D&C1&C&B1&!B&A1&!A|E1&!E&!D2&D1&!D&C1&C&B1&!B&A1&!A|!E1&!E&!D2&D1&!D&C1&C&B1&!B&A1&!A|!E1&!E&!D2&D1&D&C1&C&B1&!B&A1&!A|E1&!E&!D2&D1&D&C1&C&B1&!B&A1&!A|!E1&E&!D2&D1&D&C1&C&B1&!B&A1&!A|!E1&!E&D2&!D1&D&C1&C&B1&!B&A1&!A|E1&!E&D2&!D1&D&C1&C&B1&!B&A1&!A|!E1&E&D2&!D1&D&C1&C&B1&!B&A1&!A|!E1&E&!D2&!D1&D&C1&C&B1&!B&A1&!A|E1&!E&!D2&!D1&D&C1&C&B1&!B&A1&!A|!E1&!E&!D2&!D1&D&C1&C&B1&!B&A1&!A|!E1&!E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|E1&!E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|!E1&E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|!E1&E&D2&!D1&D&!C1&C&B1&!B&A1&!A|E1&!E&D2&!D1&D&!C1&C&B1&!B&A1&!A|!E1&!E&D2&!D1&D&!C1&C&B1&!B&A1&!A|!E1&E&!D2&D1&D&!C1&C&B1&!B&A1&!A|E1&!E&!D2&D1&D&!C1&C&B1&!B&A1&!A|!E1&!E&!D2&D1&D&!C1&C&B1&!B&A1&!A|!E1&!E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|E1&!E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|!E1&E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|!E1&E&D2&D1&!D&!C1&C&B1&!B&A1&!A|E1&!E&D2&D1&!D&!C1&C&B1&!B&A1&!A|!E1&!E&D2&D1&!D&!C1&C&B1&!B&A1&!A|!E1&!E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|E1&!E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|!E1&E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|!E1&E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|E1&!E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&!D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|E1&!E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E1&!E&D2&!D1&!D&!C1&C&!B1&!B&A1&!A|!E1&!E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|E1&!E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E1&E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|E1&!E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E1&!E&!D2&D1&!D&!C1&C&!B1&!B&A1&!A|!E1&!E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|E1&!E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|!E1&E&!D2&D1&D&!C1&C&!B1&!B&A1&!A|!E1&!E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|E1&!E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E1&E&D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E1&E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|E1&!E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&D&!C1&C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|E1&!E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|!E1&E&!D2&!D1&D&C1&C&!B1&!B&A1&!A|!E1&E&D2&!D1&D&C1&C&!B1&!B&A1&!A|E1&!E&D2&!D1&D&C1&C&!B1&!B&A1&!A|!E1&!E&D2&!D1&D&C1&C&!B1&!B&A1&!A|!E1&E&!D2&D1&D&C1&C&!B1&!B&A1&!A|E1&!E&!D2&D1&D&C1&C&!B1&!B&A1&!A|!E1&!E&!D2&D1&D&C1&C&!B1&!B&A1&!A|!E1&!E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|E1&!E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|!E1&E&!D2&D1&!D&C1&C&!B1&!B&A1&!A|!E1&E&D2&D1&!D&C1&C&!B1&!B&A1&!A|E1&!E&D2&D1&!D&C1&C&!B1&!B&A1&!A|!E1&!E&D2&D1&!D&C1&C&!B1&!B&A1&!A|!E1&!E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|E1&!E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E1&E&D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E1&E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|E1&!E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&C1&C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&!D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|E1&!E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E1&!E&D2&!D1&!D&C1&!C&!B1&!B&A1&!A|!E1&!E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|E1&!E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E1&E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|E1&!E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&D1&!D&C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|E1&!E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|!E1&E&!D2&D1&D&C1&!C&!B1&!B&A1&!A|!E1&!E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|E1&!E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E1&E&D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E1&E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|E1&!E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&D&C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E1&E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|E1&!E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E1&!E&D2&!D1&D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&D2&D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&E&D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&A1&A|!E1&!E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|E1&!E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E1&E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&A1&A|!E1&!E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|E1&!E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|!E1&E&!D2&D1&D&!C1&!C&!B1&!B&A1&A|!E1&!E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|E1&!E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E1&E&D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&A1&A|!E1&!E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|E1&!E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|!E1&E&!D2&!D1&D&!C1&!C&B1&!B&A1&A|!E1&E&D2&!D1&D&!C1&!C&B1&!B&A1&A|E1&!E&D2&!D1&D&!C1&!C&B1&!B&A1&A|!E1&!E&D2&!D1&D&!C1&!C&B1&!B&A1&A|!E1&E&!D2&D1&D&!C1&!C&B1&!B&A1&A|E1&!E&!D2&D1&D&!C1&!C&B1&!B&A1&A|!E1&!E&!D2&D1&D&!C1&!C&B1&!B&A1&A|!E1&!E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|E1&!E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|!E1&E&!D2&D1&!D&!C1&!C&B1&!B&A1&A|!E1&E&D2&D1&!D&!C1&!C&B1&!B&A1&A|E1&!E&D2&D1&!D&!C1&!C&B1&!B&A1&A|!E1&!E&D2&D1&!D&!C1&!C&B1&!B&A1&A|!E1&!E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|E1&!E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E1&E&D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|E1&!E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!E1&E&!D2&!D1&!D&!C1&!C&B1&B&A1&A|!E1&E&D2&!D1&!D&!C1&!C&B1&B&A1&A|E1&!E&D2&!D1&!D&!C1&!C&B1&B&A1&A|!E1&!E&D2&!D1&!D&!C1&!C&B1&B&A1&A|!E1&!E&D2&D1&!D&!C1&!C&B1&B&A1&A|E1&!E&D2&D1&!D&!C1&!C&B1&B&A1&A|!E1&E&D2&D1&!D&!C1&!C&B1&B&A1&A|!E1&E&!D2&D1&!D&!C1&!C&B1&B&A1&A|E1&!E&!D2&D1&!D&!C1&!C&B1&B&A1&A|!E1&!E&!D2&D1&!D&!C1&!C&B1&B&A1&A|!E1&!E&!D2&D1&D&!C1&!C&B1&B&A1&A|E1&!E&!D2&D1&D&!C1&!C&B1&B&A1&A|!E1&E&!D2&D1&D&!C1&!C&B1&B&A1&A|!E1&!E&D2&!D1&D&!C1&!C&B1&B&A1&A|E1&!E&D2&!D1&D&!C1&!C&B1&B&A1&A|!E1&E&D2&!D1&D&!C1&!C&B1&B&A1&A|!E1&E&!D2&!D1&D&!C1&!C&B1&B&A1&A|E1&!E&!D2&!D1&D&!C1&!C&B1&B&A1&A|!E1&!E&!D2&!D1&D&!C1&!C&B1&B&A1&A|!E1&!E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|E1&!E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|!E1&E&!D2&!D1&D&!C1&!C&!B1&B&A1&A|!E1&E&D2&!D1&D&!C1&!C&!B1&B&A1&A|E1&!E&D2&!D1&D&!C1&!C&!B1&B&A1&A|!E1&!E&D2&!D1&D&!C1&!C&!B1&B&A1&A|!E1&E&!D2&D1&D&!C1&!C&!B1&B&A1&A|E1&!E&!D2&D1&D&!C1&!C&!B1&B&A1&A|!E1&!E&!D2&D1&D&!C1&!C&!B1&B&A1&A|!E1&!E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|E1&!E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|!E1&E&!D2&D1&!D&!C1&!C&!B1&B&A1&A|!E1&E&D2&D1&!D&!C1&!C&!B1&B&A1&A|E1&!E&D2&D1&!D&!C1&!C&!B1&B&A1&A|!E1&!E&D2&D1&!D&!C1&!C&!B1&B&A1&A|!E1&!E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|E1&!E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E1&E&D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E1&!E&D2&!D1&!D&!C1&!C&!B1&B&!A1&A|!E1&!E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E1&E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|E1&!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E1&!E&!D2&D1&!D&!C1&!C&!B1&B&!A1&A|!E1&!E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|E1&!E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|!E1&E&!D2&D1&D&!C1&!C&!B1&B&!A1&A|!E1&!E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|E1&!E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E1&E&D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E1&E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|E1&!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E1&!E&!D2&!D1&D&!C1&!C&!B1&B&!A1&A|!E1&!E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|E1&!E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|!E1&E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|!E1&E&D2&!D1&D&C1&!C&!B1&B&!A1&A|E1&!E&D2&!D1&D&C1&!C&!B1&B&!A1&A|!E1&!E&D2&!D1&D&C1&!C&!B1&B&!A1&A|!E1&E&!D2&D1&D&C1&!C&!B1&B&!A1&A|E1&!E&!D2&D1&D&C1&!C&!B1&B&!A1&A|!E1&!E&!D2&D1&D&C1&!C&!B1&B&!A1&A|!E1&!E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|E1&!E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|!E1&E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|!E1&E&D2&D1&!D&C1&!C&!B1&B&!A1&A|E1&!E&D2&D1&!D&C1&!C&!B1&B&!A1&A|!E1&!E&D2&D1&!D&C1&!C&!B1&B&!A1&A|!E1&!E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|E1&!E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|!E1&E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|!E1&E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!E1&!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|!E1&!E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|!E1&E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|!E1&E&D2&!D1&!D&C1&C&!B1&B&!A1&A|E1&!E&D2&!D1&!D&C1&C&!B1&B&!A1&A|!E1&!E&D2&!D1&!D&C1&C&!B1&B&!A1&A|!E1&!E&D2&D1&!D&C1&C&!B1&B&!A1&A|E1&!E&D2&D1&!D&C1&C&!B1&B&!A1&A|!E1&E&D2&D1&!D&C1&C&!B1&B&!A1&A|!E1&E&!D2&D1&!D&C1&C&!B1&B&!A1&A|E1&!E&!D2&D1&!D&C1&C&!B1&B&!A1&A|!E1&!E&!D2&D1&!D&C1&C&!B1&B&!A1&A|!E1&!E&!D2&D1&D&C1&C&!B1&B&!A1&A|E1&!E&!D2&D1&D&C1&C&!B1&B&!A1&A|!E1&E&!D2&D1&D&C1&C&!B1&B&!A1&A|!E1&!E&D2&!D1&D&C1&C&!B1&B&!A1&A|E1&!E&D2&!D1&D&C1&C&!B1&B&!A1&A|!E1&E&D2&!D1&D&C1&C&!B1&B&!A1&A|!E1&E&!D2&!D1&D&C1&C&!B1&B&!A1&A|E1&!E&!D2&!D1&D&C1&C&!B1&B&!A1&A|!E1&!E&!D2&!D1&D&C1&C&!B1&B&!A1&A|!E1&!E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|E1&!E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|!E1&E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|!E1&E&D2&!D1&D&!C1&C&!B1&B&!A1&A|E1&!E&D2&!D1&D&!C1&C&!B1&B&!A1&A|!E1&!E&D2&!D1&D&!C1&C&!B1&B&!A1&A|!E1&E&!D2&D1&D&!C1&C&!B1&B&!A1&A|E1&!E&!D2&D1&D&!C1&C&!B1&B&!A1&A|!E1&!E&!D2&D1&D&!C1&C&!B1&B&!A1&A|!E1&!E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|E1&!E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|!E1&E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|!E1&E&D2&D1&!D&!C1&C&!B1&B&!A1&A|E1&!E&D2&D1&!D&!C1&C&!B1&B&!A1&A|!E1&!E&D2&D1&!D&!C1&C&!B1&B&!A1&A|!E1&!E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|E1&!E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|!E1&E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|!E1&E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|!E1&!E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|E1&!E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|!E1&E&!D2&!D1&D&!C1&!C&B1&B&!A1&A|!E1&E&D2&!D1&D&!C1&!C&B1&B&!A1&A|E1&!E&D2&!D1&D&!C1&!C&B1&B&!A1&A|!E1&!E&D2&!D1&D&!C1&!C&B1&B&!A1&A|!E1&E&!D2&D1&D&!C1&!C&B1&B&!A1&A|E1&!E&!D2&D1&D&!C1&!C&B1&B&!A1&A|!E1&!E&!D2&D1&D&!C1&!C&B1&B&!A1&A|!E1&!E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|E1&!E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|!E1&E&!D2&D1&!D&!C1&!C&B1&B&!A1&A|!E1&E&D2&D1&!D&!C1&!C&B1&B&!A1&A|E1&!E&D2&D1&!D&!C1&!C&B1&B&!A1&A|!E1&!E&D2&D1&!D&!C1&!C&B1&B&!A1&A|!E1&!E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|E1&!E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E1&E&D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|E1&!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&!D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E1&!E&D2&!D1&!D&!C1&!C&B1&!B&!A1&A|!E1&!E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E1&E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|E1&!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E1&!E&!D2&D1&!D&!C1&!C&B1&!B&!A1&A|!E1&!E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|E1&!E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|!E1&E&!D2&D1&D&!C1&!C&B1&!B&!A1&A|!E1&!E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|E1&!E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E1&E&D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E1&E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|E1&!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E1&!E&!D2&!D1&D&!C1&!C&B1&!B&!A1&A|!E1&!E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|E1&!E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|!E1&E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|!E1&E&D2&!D1&D&C1&!C&B1&!B&!A1&A|E1&!E&D2&!D1&D&C1&!C&B1&!B&!A1&A|!E1&!E&D2&!D1&D&C1&!C&B1&!B&!A1&A|!E1&E&!D2&D1&D&C1&!C&B1&!B&!A1&A|E1&!E&!D2&D1&D&C1&!C&B1&!B&!A1&A|!E1&!E&!D2&D1&D&C1&!C&B1&!B&!A1&A|!E1&!E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|E1&!E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|!E1&E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|!E1&E&D2&D1&!D&C1&!C&B1&!B&!A1&A|E1&!E&D2&D1&!D&C1&!C&B1&!B&!A1&A|!E1&!E&D2&D1&!D&C1&!C&B1&!B&!A1&A|!E1&!E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|E1&!E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|!E1&E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|!E1&E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|E1&!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|E1&!E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|!E1&E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|!E1&E&D2&!D1&!D&C1&C&B1&!B&!A1&A|E1&!E&D2&!D1&!D&C1&C&B1&!B&!A1&A|!E1&!E&D2&!D1&!D&C1&C&B1&!B&!A1&A|!E1&!E&D2&D1&!D&C1&C&B1&!B&!A1&A|E1&!E&D2&D1&!D&C1&C&B1&!B&!A1&A|!E1&E&D2&D1&!D&C1&C&B1&!B&!A1&A|!E1&E&!D2&D1&!D&C1&C&B1&!B&!A1&A|E1&!E&!D2&D1&!D&C1&C&B1&!B&!A1&A|!E1&!E&!D2&D1&!D&C1&C&B1&!B&!A1&A|!E1&!E&!D2&D1&D&C1&C&B1&!B&!A1&A|E1&!E&!D2&D1&D&C1&C&B1&!B&!A1&A|!E1&E&!D2&D1&D&C1&C&B1&!B&!A1&A|!E1&!E&D2&!D1&D&C1&C&B1&!B&!A1&A|E1&!E&D2&!D1&D&C1&C&B1&!B&!A1&A|!E1&E&D2&!D1&D&C1&C&B1&!B&!A1&A|!E1&E&!D2&!D1&D&C1&C&B1&!B&!A1&A|E1&!E&!D2&!D1&D&C1&C&B1&!B&!A1&A|!E1&!E&!D2&!D1&D&C1&C&B1&!B&!A1&A|!E1&!E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|E1&!E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|!E1&E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|!E1&E&D2&!D1&D&!C1&C&B1&!B&!A1&A|E1&!E&D2&!D1&D&!C1&C&B1&!B&!A1&A|!E1&!E&D2&!D1&D&!C1&C&B1&!B&!A1&A|!E1&E&!D2&D1&D&!C1&C&B1&!B&!A1&A|E1&!E&!D2&D1&D&!C1&C&B1&!B&!A1&A|!E1&!E&!D2&D1&D&!C1&C&B1&!B&!A1&A|!E1&!E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|E1&!E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|!E1&E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|!E1&E&D2&D1&!D&!C1&C&B1&!B&!A1&A|E1&!E&D2&D1&!D&!C1&C&B1&!B&!A1&A|!E1&!E&D2&D1&!D&!C1&C&B1&!B&!A1&A|!E1&!E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|E1&!E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|!E1&E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|!E1&E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|E1&!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|E1&!E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&!D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|E1&!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E1&!E&D2&!D1&!D&!C1&C&!B1&!B&!A1&A|!E1&!E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|E1&!E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E1&E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|E1&!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E1&!E&!D2&D1&!D&!C1&C&!B1&!B&!A1&A|!E1&!E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|E1&!E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|!E1&E&!D2&D1&D&!C1&C&!B1&!B&!A1&A|!E1&!E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|E1&!E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E1&E&D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E1&E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|E1&!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&D&!C1&C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|E1&!E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|!E1&E&!D2&!D1&D&C1&C&!B1&!B&!A1&A|!E1&E&D2&!D1&D&C1&C&!B1&!B&!A1&A|E1&!E&D2&!D1&D&C1&C&!B1&!B&!A1&A|!E1&!E&D2&!D1&D&C1&C&!B1&!B&!A1&A|!E1&E&!D2&D1&D&C1&C&!B1&!B&!A1&A|E1&!E&!D2&D1&D&C1&C&!B1&!B&!A1&A|!E1&!E&!D2&D1&D&C1&C&!B1&!B&!A1&A|!E1&!E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|E1&!E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|!E1&E&!D2&D1&!D&C1&C&!B1&!B&!A1&A|!E1&E&D2&D1&!D&C1&C&!B1&!B&!A1&A|E1&!E&D2&D1&!D&C1&C&!B1&!B&!A1&A|!E1&!E&D2&D1&!D&C1&C&!B1&!B&!A1&A|!E1&!E&D2&!D1&!D&C1&C&!B1&!B&!A1&A|E1&!E&D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E1&E&D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E1&E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|E1&!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&C1&C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|E1&!E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&!D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|E1&!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E1&!E&D2&!D1&!D&C1&!C&!B1&!B&!A1&A|!E1&!E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|E1&!E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E1&E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|E1&!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E1&!E&!D2&D1&!D&C1&!C&!B1&!B&!A1&A|!E1&!E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|E1&!E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|!E1&E&!D2&D1&D&C1&!C&!B1&!B&!A1&A|!E1&!E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|E1&!E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E1&E&D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E1&E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|E1&!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&D&C1&!C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E1&E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|E1&!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E1&!E&D2&!D1&D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E1&!E&!D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&!E&D2&D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&E&D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAAAOI22232.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOI2222 -l OOAOI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B1&!B&!A1&!A|!D1&!D&C1&!C&!B1&!B&!A1&!A|!D1&!D&C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&B1&!B&!A1&!A|!D1&!D&C1&C&B1&!B&!A1&!A|!D1&!D&C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&B&!A1&!A|!D1&!D&C1&!C&B1&B&!A1&!A|!D1&!D&C1&C&B1&B&!A1&!A|!D1&!D&!C1&C&B1&B&!A1&!A|!D1&!D&!C1&C&!B1&B&!A1&!A|!D1&!D&C1&C&!B1&B&!A1&!A|!D1&!D&C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&A1&!A|!D1&!D&C1&!C&!B1&B&A1&!A|!D1&!D&!C1&C&!B1&B&A1&!A|!D1&!D&!C1&C&B1&B&A1&!A|!D1&!D&C1&!C&B1&B&A1&!A|!D1&!D&!C1&!C&B1&B&A1&!A|!D1&!D&!C1&!C&B1&!B&A1&!A|!D1&!D&C1&!C&B1&!B&A1&!A|!D1&!D&!C1&C&B1&!B&A1&!A|!D1&!D&!C1&C&!B1&!B&A1&!A|!D1&!D&C1&C&!B1&!B&A1&!A|!D1&!D&C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&A|!D1&!D&C1&!C&!B1&!B&A1&A|!D1&!D&C1&C&!B1&!B&A1&A|!D1&!D&!C1&C&!B1&!B&A1&A|!D1&!D&!C1&C&B1&!B&A1&A|!D1&!D&C1&!C&B1&!B&A1&A|!D1&!D&!C1&!C&B1&!B&A1&A|!D1&!D&!C1&!C&B1&B&A1&A|!D1&!D&C1&!C&B1&B&A1&A|!D1&!D&!C1&C&B1&B&A1&A|!D1&!D&!C1&C&!B1&B&A1&A|!D1&!D&C1&!C&!B1&B&A1&A|!D1&!D&!C1&!C&!B1&B&A1&A|!D1&!D&!C1&!C&!B1&B&!A1&A|!D1&!D&C1&!C&!B1&B&!A1&A|!D1&!D&!C1&C&!B1&B&!A1&A|!D1&!D&!C1&C&B1&B&!A1&A|!D1&!D&C1&!C&B1&B&!A1&A|!D1&!D&!C1&!C&B1&B&!A1&A|!D1&!D&!C1&!C&B1&!B&!A1&A|!D1&!D&C1&!C&B1&!B&!A1&A|!D1&!D&!C1&C&B1&!B&!A1&A|!D1&!D&!C1&C&!B1&!B&!A1&A|!D1&!D&C1&C&!B1&!B&!A1&A|!D1&!D&C1&!C&!B1&!B&!A1&A|!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOI2113 -l AOAAOI2113 -i D2 D1 D C B A1 A -o Y -f Y=!(D2&D1&D&!C&!B&!A1&!A|D2&D1&D&C&!B&!A1&!A|!D2&!D1&!D&C&B&!A1&!A|D2&!D1&!D&C&B&!A1&!A|D2&D1&!D&C&B&!A1&!A|!D2&D1&!D&C&B&!A1&!A|!D2&D1&D&C&B&!A1&!A|D2&D1&D&C&B&!A1&!A|D2&!D1&D&C&B&!A1&!A|!D2&!D1&D&C&B&!A1&!A|D2&D1&D&!C&B&!A1&!A|D2&D1&D&!C&B&A1&!A|!D2&!D1&D&C&B&A1&!A|D2&!D1&D&C&B&A1&!A|D2&D1&D&C&B&A1&!A|!D2&D1&D&C&B&A1&!A|!D2&D1&!D&C&B&A1&!A|D2&D1&!D&C&B&A1&!A|D2&!D1&!D&C&B&A1&!A|!D2&!D1&!D&C&B&A1&!A|D2&D1&D&C&!B&A1&!A|D2&D1&D&!C&!B&A1&!A|D2&D1&D&!C&!B&A1&A|!D2&!D1&D&C&!B&A1&A|D2&!D1&D&C&!B&A1&A|D2&D1&D&C&!B&A1&A|!D2&D1&D&C&!B&A1&A|!D2&D1&!D&C&!B&A1&A|D2&D1&!D&C&!B&A1&A|D2&!D1&!D&C&!B&A1&A|!D2&!D1&!D&C&!B&A1&A|!D2&!D1&!D&C&B&A1&A|D2&!D1&!D&C&B&A1&A|D2&D1&!D&C&B&A1&A|!D2&D1&!D&C&B&A1&A|!D2&D1&D&C&B&A1&A|D2&D1&D&C&B&A1&A|D2&!D1&D&C&B&A1&A|!D2&!D1&D&C&B&A1&A|D2&D1&D&!C&B&A1&A|D2&D1&D&!C&B&!A1&A|!D2&!D1&D&C&B&!A1&A|D2&!D1&D&C&B&!A1&A|D2&D1&D&C&B&!A1&A|!D2&D1&D&C&B&!A1&A|!D2&D1&!D&C&B&!A1&A|D2&D1&!D&C&B&!A1&A|D2&!D1&!D&C&B&!A1&A|!D2&!D1&!D&C&B&!A1&A|D2&D1&D&C&!B&!A1&A|D2&D1&D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOI2113.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAOI22311 -l AAOOAOI22311 -i E D C2 C1 C B1 B A1 A -o Y -f Y=(!E&!D&!C2&!C1&!C&!B1&!B&!A1&!A|!E&D&!C2&!C1&!C&!B1&!B&!A1&!A|!E&D&C2&!C1&!C&!B1&!B&!A1&!A|!E&!D&C2&!C1&!C&!B1&!B&!A1&!A|!E&!D&C2&C1&!C&!B1&!B&!A1&!A|!E&D&C2&C1&!C&!B1&!B&!A1&!A|!E&D&!C2&C1&!C&!B1&!B&!A1&!A|!E&!D&!C2&C1&!C&!B1&!B&!A1&!A|!E&!D&!C2&C1&C&!B1&!B&!A1&!A|!E&D&!C2&C1&C&!B1&!B&!A1&!A|!E&D&C2&C1&C&!B1&!B&!A1&!A|!E&!D&C2&C1&C&!B1&!B&!A1&!A|!E&!D&C2&!C1&C&!B1&!B&!A1&!A|!E&D&C2&!C1&C&!B1&!B&!A1&!A|!E&D&!C2&!C1&C&!B1&!B&!A1&!A|!E&!D&!C2&!C1&C&!B1&!B&!A1&!A|!E&!D&!C2&!C1&C&B1&!B&!A1&!A|!E&D&!C2&!C1&C&B1&!B&!A1&!A|!E&D&C2&!C1&C&B1&!B&!A1&!A|!E&!D&C2&!C1&C&B1&!B&!A1&!A|!E&!D&C2&C1&C&B1&!B&!A1&!A|!E&D&C2&C1&C&B1&!B&!A1&!A|!E&D&!C2&C1&C&B1&!B&!A1&!A|!E&!D&!C2&C1&C&B1&!B&!A1&!A|!E&!D&!C2&C1&!C&B1&!B&!A1&!A|!E&D&!C2&C1&!C&B1&!B&!A1&!A|!E&D&C2&C1&!C&B1&!B&!A1&!A|!E&!D&C2&C1&!C&B1&!B&!A1&!A|!E&!D&C2&!C1&!C&B1&!B&!A1&!A|!E&D&C2&!C1&!C&B1&!B&!A1&!A|!E&D&!C2&!C1&!C&B1&!B&!A1&!A|!E&!D&!C2&!C1&!C&B1&!B&!A1&!A|!E&!D&!C2&!C1&!C&B1&B&!A1&!A|!E&D&!C2&!C1&!C&B1&B&!A1&!A|!E&!D&C2&!C1&!C&B1&B&!A1&!A|!E&!D&C2&C1&!C&B1&B&!A1&!A|!E&!D&!C2&C1&!C&B1&B&!A1&!A|!E&!D&!C2&C1&C&B1&B&!A1&!A|!E&!D&C2&C1&C&B1&B&!A1&!A|!E&!D&C2&!C1&C&B1&B&!A1&!A|!E&!D&!C2&!C1&C&B1&B&!A1&!A|!E&!D&!C2&!C1&C&!B1&B&!A1&!A|!E&D&!C2&!C1&C&!B1&B&!A1&!A|!E&D&C2&!C1&C&!B1&B&!A1&!A|!E&!D&C2&!C1&C&!B1&B&!A1&!A|!E&!D&C2&C1&C&!B1&B&!A1&!A|!E&D&C2&C1&C&!B1&B&!A1&!A|!E&D&!C2&C1&C&!B1&B&!A1&!A|!E&!D&!C2&C1&C&!B1&B&!A1&!A|!E&!D&!C2&C1&!C&!B1&B&!A1&!A|!E&D&!C2&C1&!C&!B1&B&!A1&!A|!E&D&C2&C1&!C&!B1&B&!A1&!A|!E&!D&C2&C1&!C&!B1&B&!A1&!A|!E&!D&C2&!C1&!C&!B1&B&!A1&!A|!E&D&C2&!C1&!C&!B1&B&!A1&!A|!E&D&!C2&!C1&!C&!B1&B&!A1&!A|!E&!D&!C2&!C1&!C&!B1&B&!A1&!A|!E&!D&!C2&!C1&!C&!B1&B&A1&!A|!E&D&!C2&!C1&!C&!B1&B&A1&!A|!E&D&C2&!C1&!C&!B1&B&A1&!A|!E&!D&C2&!C1&!C&!B1&B&A1&!A|!E&!D&C2&C1&!C&!B1&B&A1&!A|!E&D&C2&C1&!C&!B1&B&A1&!A|!E&D&!C2&C1&!C&!B1&B&A1&!A|!E&!D&!C2&C1&!C&!B1&B&A1&!A|!E&!D&!C2&C1&C&!B1&B&A1&!A|!E&D&!C2&C1&C&!B1&B&A1&!A|!E&D&C2&C1&C&!B1&B&A1&!A|!E&!D&C2&C1&C&!B1&B&A1&!A|!E&!D&C2&!C1&C&!B1&B&A1&!A|!E&D&C2&!C1&C&!B1&B&A1&!A|!E&D&!C2&!C1&C&!B1&B&A1&!A|!E&!D&!C2&!C1&C&!B1&B&A1&!A|!E&!D&!C2&!C1&C&B1&B&A1&!A|!E&!D&C2&!C1&C&B1&B&A1&!A|!E&!D&C2&C1&C&B1&B&A1&!A|!E&!D&!C2&C1&C&B1&B&A1&!A|!E&!D&!C2&C1&!C&B1&B&A1&!A|!E&!D&C2&C1&!C&B1&B&A1&!A|!E&!D&C2&!C1&!C&B1&B&A1&!A|!E&D&!C2&!C1&!C&B1&B&A1&!A|!E&!D&!C2&!C1&!C&B1&B&A1&!A|!E&!D&!C2&!C1&!C&B1&!B&A1&!A|!E&D&!C2&!C1&!C&B1&!B&A1&!A|!E&D&C2&!C1&!C&B1&!B&A1&!A|!E&!D&C2&!C1&!C&B1&!B&A1&!A|!E&!D&C2&C1&!C&B1&!B&A1&!A|!E&D&C2&C1&!C&B1&!B&A1&!A|!E&D&!C2&C1&!C&B1&!B&A1&!A|!E&!D&!C2&C1&!C&B1&!B&A1&!A|!E&!D&!C2&C1&C&B1&!B&A1&!A|!E&D&!C2&C1&C&B1&!B&A1&!A|!E&D&C2&C1&C&B1&!B&A1&!A|!E&!D&C2&C1&C&B1&!B&A1&!A|!E&!D&C2&!C1&C&B1&!B&A1&!A|!E&D&C2&!C1&C&B1&!B&A1&!A|!E&D&!C2&!C1&C&B1&!B&A1&!A|!E&!D&!C2&!C1&C&B1&!B&A1&!A|!E&!D&!C2&!C1&C&!B1&!B&A1&!A|!E&D&!C2&!C1&C&!B1&!B&A1&!A|!E&D&C2&!C1&C&!B1&!B&A1&!A|!E&!D&C2&!C1&C&!B1&!B&A1&!A|!E&!D&C2&C1&C&!B1&!B&A1&!A|!E&D&C2&C1&C&!B1&!B&A1&!A|!E&D&!C2&C1&C&!B1&!B&A1&!A|!E&!D&!C2&C1&C&!B1&!B&A1&!A|!E&!D&!C2&C1&!C&!B1&!B&A1&!A|!E&D&!C2&C1&!C&!B1&!B&A1&!A|!E&D&C2&C1&!C&!B1&!B&A1&!A|!E&!D&C2&C1&!C&!B1&!B&A1&!A|!E&!D&C2&!C1&!C&!B1&!B&A1&!A|!E&D&C2&!C1&!C&!B1&!B&A1&!A|!E&D&!C2&!C1&!C&!B1&!B&A1&!A|!E&!D&!C2&!C1&!C&!B1&!B&A1&!A|!E&!D&!C2&!C1&!C&!B1&!B&A1&A|!E&D&!C2&!C1&!C&!B1&!B&A1&A|!E&!D&C2&!C1&!C&!B1&!B&A1&A|!E&!D&C2&C1&!C&!B1&!B&A1&A|!E&!D&!C2&C1&!C&!B1&!B&A1&A|!E&!D&!C2&C1&C&!B1&!B&A1&A|!E&!D&C2&C1&C&!B1&!B&A1&A|!E&!D&C2&!C1&C&!B1&!B&A1&A|!E&!D&!C2&!C1&C&!B1&!B&A1&A|!E&!D&!C2&!C1&C&B1&!B&A1&A|!E&!D&C2&!C1&C&B1&!B&A1&A|!E&!D&C2&C1&C&B1&!B&A1&A|!E&!D&!C2&C1&C&B1&!B&A1&A|!E&!D&!C2&C1&!C&B1&!B&A1&A|!E&!D&C2&C1&!C&B1&!B&A1&A|!E&!D&C2&!C1&!C&B1&!B&A1&A|!E&D&!C2&!C1&!C&B1&!B&A1&A|!E&!D&!C2&!C1&!C&B1&!B&A1&A|!E&!D&!C2&!C1&!C&B1&B&A1&A|!E&D&!C2&!C1&!C&B1&B&A1&A|!E&!D&C2&!C1&!C&B1&B&A1&A|!E&!D&C2&C1&!C&B1&B&A1&A|!E&!D&!C2&C1&!C&B1&B&A1&A|!E&!D&!C2&C1&C&B1&B&A1&A|!E&!D&C2&C1&C&B1&B&A1&A|!E&!D&C2&!C1&C&B1&B&A1&A|!E&!D&!C2&!C1&C&B1&B&A1&A|!E&!D&!C2&!C1&C&!B1&B&A1&A|!E&!D&C2&!C1&C&!B1&B&A1&A|!E&!D&C2&C1&C&!B1&B&A1&A|!E&!D&!C2&C1&C&!B1&B&A1&A|!E&!D&!C2&C1&!C&!B1&B&A1&A|!E&!D&C2&C1&!C&!B1&B&A1&A|!E&!D&C2&!C1&!C&!B1&B&A1&A|!E&D&!C2&!C1&!C&!B1&B&A1&A|!E&!D&!C2&!C1&!C&!B1&B&A1&A|!E&!D&!C2&!C1&!C&!B1&B&!A1&A|!E&D&!C2&!C1&!C&!B1&B&!A1&A|!E&D&C2&!C1&!C&!B1&B&!A1&A|!E&!D&C2&!C1&!C&!B1&B&!A1&A|!E&!D&C2&C1&!C&!B1&B&!A1&A|!E&D&C2&C1&!C&!B1&B&!A1&A|!E&D&!C2&C1&!C&!B1&B&!A1&A|!E&!D&!C2&C1&!C&!B1&B&!A1&A|!E&!D&!C2&C1&C&!B1&B&!A1&A|!E&D&!C2&C1&C&!B1&B&!A1&A|!E&D&C2&C1&C&!B1&B&!A1&A|!E&!D&C2&C1&C&!B1&B&!A1&A|!E&!D&C2&!C1&C&!B1&B&!A1&A|!E&D&C2&!C1&C&!B1&B&!A1&A|!E&D&!C2&!C1&C&!B1&B&!A1&A|!E&!D&!C2&!C1&C&!B1&B&!A1&A|!E&!D&!C2&!C1&C&B1&B&!A1&A|!E&!D&C2&!C1&C&B1&B&!A1&A|!E&!D&C2&C1&C&B1&B&!A1&A|!E&!D&!C2&C1&C&B1&B&!A1&A|!E&!D&!C2&C1&!C&B1&B&!A1&A|!E&!D&C2&C1&!C&B1&B&!A1&A|!E&!D&C2&!C1&!C&B1&B&!A1&A|!E&D&!C2&!C1&!C&B1&B&!A1&A|!E&!D&!C2&!C1&!C&B1&B&!A1&A|!E&!D&!C2&!C1&!C&B1&!B&!A1&A|!E&D&!C2&!C1&!C&B1&!B&!A1&A|!E&D&C2&!C1&!C&B1&!B&!A1&A|!E&!D&C2&!C1&!C&B1&!B&!A1&A|!E&!D&C2&C1&!C&B1&!B&!A1&A|!E&D&C2&C1&!C&B1&!B&!A1&A|!E&D&!C2&C1&!C&B1&!B&!A1&A|!E&!D&!C2&C1&!C&B1&!B&!A1&A|!E&!D&!C2&C1&C&B1&!B&!A1&A|!E&D&!C2&C1&C&B1&!B&!A1&A|!E&D&C2&C1&C&B1&!B&!A1&A|!E&!D&C2&C1&C&B1&!B&!A1&A|!E&!D&C2&!C1&C&B1&!B&!A1&A|!E&D&C2&!C1&C&B1&!B&!A1&A|!E&D&!C2&!C1&C&B1&!B&!A1&A|!E&!D&!C2&!C1&C&B1&!B&!A1&A|!E&!D&!C2&!C1&C&!B1&!B&!A1&A|!E&D&!C2&!C1&C&!B1&!B&!A1&A|!E&D&C2&!C1&C&!B1&!B&!A1&A|!E&!D&C2&!C1&C&!B1&!B&!A1&A|!E&!D&C2&C1&C&!B1&!B&!A1&A|!E&D&C2&C1&C&!B1&!B&!A1&A|!E&D&!C2&C1&C&!B1&!B&!A1&A|!E&!D&!C2&C1&C&!B1&!B&!A1&A|!E&!D&!C2&C1&!C&!B1&!B&!A1&A|!E&D&!C2&C1&!C&!B1&!B&!A1&A|!E&D&C2&C1&!C&!B1&!B&!A1&A|!E&!D&C2&C1&!C&!B1&!B&!A1&A|!E&!D&C2&!C1&!C&!B1&!B&!A1&A|!E&D&C2&!C1&!C&!B1&!B&!A1&A|!E&D&!C2&!C1&!C&!B1&!B&!A1&A|!E&!D&!C2&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAOI22311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOI322 -l AAOI322 -i C1 C B1 B A2 A1 A -o Y -f Y=(!C1&!C&!B1&!B&!A2&!A1&!A|!C1&!C&B1&!B&!A2&!A1&!A|!C1&!C&!B1&B&!A2&!A1&!A|!C1&!C&!B1&B&A2&!A1&!A|!C1&!C&B1&!B&A2&!A1&!A|!C1&!C&!B1&!B&A2&!A1&!A|!C1&!C&!B1&!B&A2&A1&!A|!C1&!C&B1&!B&A2&A1&!A|!C1&!C&!B1&B&A2&A1&!A|!C1&!C&!B1&B&!A2&A1&!A|!C1&!C&B1&!B&!A2&A1&!A|!C1&!C&!B1&!B&!A2&A1&!A|!C1&!C&!B1&!B&!A2&A1&A|!C1&!C&B1&!B&!A2&A1&A|!C1&!C&!B1&B&!A2&A1&A|!C1&!C&!B1&!B&A2&!A1&A|!C1&!C&B1&!B&A2&!A1&A|!C1&!C&!B1&B&A2&!A1&A|!C1&!C&!B1&B&!A2&!A1&A|!C1&!C&B1&!B&!A2&!A1&A|!C1&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOI322.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAOI32111 -l AAOAOI32111 -i E D C B1 B A2 A1 A -o Y -f Y=(!E&!D&!C&!B1&!B&!A2&!A1&!A|!E&D&!C&!B1&!B&!A2&!A1&!A|!E&!D&C&!B1&!B&!A2&!A1&!A|!E&!D&C&B1&!B&!A2&!A1&!A|!E&D&!C&B1&!B&!A2&!A1&!A|!E&!D&!C&B1&!B&!A2&!A1&!A|!E&!D&!C&B1&B&!A2&!A1&!A|!E&!D&C&B1&B&!A2&!A1&!A|!E&!D&C&!B1&B&!A2&!A1&!A|!E&D&!C&!B1&B&!A2&!A1&!A|!E&!D&!C&!B1&B&!A2&!A1&!A|!E&!D&!C&!B1&B&A2&!A1&!A|!E&D&!C&!B1&B&A2&!A1&!A|!E&!D&C&!B1&B&A2&!A1&!A|!E&!D&C&B1&B&A2&!A1&!A|!E&!D&!C&B1&B&A2&!A1&!A|!E&!D&!C&B1&!B&A2&!A1&!A|!E&D&!C&B1&!B&A2&!A1&!A|!E&!D&C&B1&!B&A2&!A1&!A|!E&!D&C&!B1&!B&A2&!A1&!A|!E&D&!C&!B1&!B&A2&!A1&!A|!E&!D&!C&!B1&!B&A2&!A1&!A|!E&!D&!C&!B1&!B&A2&A1&!A|!E&D&!C&!B1&!B&A2&A1&!A|!E&!D&C&!B1&!B&A2&A1&!A|!E&!D&C&B1&!B&A2&A1&!A|!E&D&!C&B1&!B&A2&A1&!A|!E&!D&!C&B1&!B&A2&A1&!A|!E&!D&!C&B1&B&A2&A1&!A|!E&!D&C&B1&B&A2&A1&!A|!E&!D&C&!B1&B&A2&A1&!A|!E&D&!C&!B1&B&A2&A1&!A|!E&!D&!C&!B1&B&A2&A1&!A|!E&!D&!C&!B1&B&!A2&A1&!A|!E&D&!C&!B1&B&!A2&A1&!A|!E&!D&C&!B1&B&!A2&A1&!A|!E&!D&C&B1&B&!A2&A1&!A|!E&!D&!C&B1&B&!A2&A1&!A|!E&!D&!C&B1&!B&!A2&A1&!A|!E&D&!C&B1&!B&!A2&A1&!A|!E&!D&C&B1&!B&!A2&A1&!A|!E&!D&C&!B1&!B&!A2&A1&!A|!E&D&!C&!B1&!B&!A2&A1&!A|!E&!D&!C&!B1&!B&!A2&A1&!A|!E&!D&!C&!B1&!B&!A2&A1&A|!E&D&!C&!B1&!B&!A2&A1&A|!E&!D&C&!B1&!B&!A2&A1&A|!E&!D&C&B1&!B&!A2&A1&A|!E&D&!C&B1&!B&!A2&A1&A|!E&!D&!C&B1&!B&!A2&A1&A|!E&!D&!C&B1&B&!A2&A1&A|!E&!D&C&B1&B&!A2&A1&A|!E&!D&C&!B1&B&!A2&A1&A|!E&D&!C&!B1&B&!A2&A1&A|!E&!D&!C&!B1&B&!A2&A1&A|!E&!D&!C&!B1&B&A2&A1&A|!E&!D&C&!B1&B&A2&A1&A|!E&!D&C&B1&B&A2&A1&A|!E&!D&!C&B1&B&A2&A1&A|!E&!D&!C&B1&!B&A2&A1&A|!E&!D&C&B1&!B&A2&A1&A|!E&!D&C&!B1&!B&A2&A1&A|!E&!D&!C&!B1&!B&A2&A1&A|!E&!D&!C&!B1&!B&A2&!A1&A|!E&D&!C&!B1&!B&A2&!A1&A|!E&!D&C&!B1&!B&A2&!A1&A|!E&!D&C&B1&!B&A2&!A1&A|!E&D&!C&B1&!B&A2&!A1&A|!E&!D&!C&B1&!B&A2&!A1&A|!E&!D&!C&B1&B&A2&!A1&A|!E&!D&C&B1&B&A2&!A1&A|!E&!D&C&!B1&B&A2&!A1&A|!E&D&!C&!B1&B&A2&!A1&A|!E&!D&!C&!B1&B&A2&!A1&A|!E&!D&!C&!B1&B&!A2&!A1&A|!E&D&!C&!B1&B&!A2&!A1&A|!E&!D&C&!B1&B&!A2&!A1&A|!E&!D&C&B1&B&!A2&!A1&A|!E&!D&!C&B1&B&!A2&!A1&A|!E&!D&!C&B1&!B&!A2&!A1&A|!E&D&!C&B1&!B&!A2&!A1&A|!E&!D&C&B1&!B&!A2&!A1&A|!E&!D&C&!B1&!B&!A2&!A1&A|!E&D&!C&!B1&!B&!A2&!A1&A|!E&!D&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAOI32111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOI222 -l OAOI222 -i C1 C B1 B A1 A -o Y -f Y=(!C1&!C&!B1&!B&!A1&!A|!C1&!C&B1&!B&!A1&!A|!C1&!C&B1&B&!A1&!A|!C1&!C&!B1&B&!A1&!A|!C1&!C&!B1&B&A1&!A|!C1&!C&B1&!B&A1&!A|!C1&!C&!B1&!B&A1&!A|!C1&!C&!B1&!B&A1&A|!C1&!C&B1&!B&A1&A|!C1&!C&!B1&B&A1&A|!C1&!C&!B1&B&!A1&A|!C1&!C&B1&!B&!A1&A|!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOI222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAI2321 -l AOOAI2321 -i D C1 C B2 B1 B A1 A -o Y -f Y=!(D&!C1&C&B2&!B1&!B&!A1&!A|D&C1&C&B2&!B1&!B&!A1&!A|D&C1&!C&B2&!B1&!B&!A1&!A|D&C1&!C&B2&B1&!B&!A1&!A|D&C1&C&B2&B1&!B&!A1&!A|D&!C1&C&B2&B1&!B&!A1&!A|D&!C1&C&!B2&B1&!B&!A1&!A|D&C1&C&!B2&B1&!B&!A1&!A|D&C1&!C&!B2&B1&!B&!A1&!A|D&C1&!C&!B2&B1&B&!A1&!A|D&C1&C&!B2&B1&B&!A1&!A|D&!C1&C&!B2&B1&B&!A1&!A|D&!C1&C&B2&B1&B&!A1&!A|D&C1&C&B2&B1&B&!A1&!A|D&C1&!C&B2&B1&B&!A1&!A|D&C1&!C&B2&!B1&B&!A1&!A|D&C1&C&B2&!B1&B&!A1&!A|D&!C1&C&B2&!B1&B&!A1&!A|D&!C1&C&!B2&!B1&B&!A1&!A|D&C1&C&!B2&!B1&B&!A1&!A|D&C1&!C&!B2&!B1&B&!A1&!A|D&C1&!C&!B2&!B1&B&A1&!A|D&C1&C&!B2&!B1&B&A1&!A|D&!C1&C&!B2&!B1&B&A1&!A|D&!C1&C&B2&!B1&B&A1&!A|D&C1&C&B2&!B1&B&A1&!A|D&C1&!C&B2&!B1&B&A1&!A|D&C1&!C&B2&B1&B&A1&!A|D&C1&C&B2&B1&B&A1&!A|D&!C1&C&B2&B1&B&A1&!A|D&!C1&C&!B2&B1&B&A1&!A|D&C1&C&!B2&B1&B&A1&!A|D&C1&!C&!B2&B1&B&A1&!A|D&C1&!C&!B2&B1&!B&A1&!A|D&C1&C&!B2&B1&!B&A1&!A|D&!C1&C&!B2&B1&!B&A1&!A|D&!C1&C&B2&B1&!B&A1&!A|D&C1&C&B2&B1&!B&A1&!A|D&C1&!C&B2&B1&!B&A1&!A|D&C1&!C&B2&!B1&!B&A1&!A|D&C1&C&B2&!B1&!B&A1&!A|D&!C1&C&B2&!B1&!B&A1&!A|D&C1&!C&!B2&!B1&!B&A1&A|D&C1&C&!B2&!B1&!B&A1&A|D&!C1&C&!B2&!B1&!B&A1&A|D&!C1&C&B2&!B1&!B&A1&A|D&C1&C&B2&!B1&!B&A1&A|D&C1&!C&B2&!B1&!B&A1&A|D&C1&!C&B2&B1&!B&A1&A|D&C1&C&B2&B1&!B&A1&A|D&!C1&C&B2&B1&!B&A1&A|D&!C1&C&!B2&B1&!B&A1&A|D&C1&C&!B2&B1&!B&A1&A|D&C1&!C&!B2&B1&!B&A1&A|D&C1&!C&!B2&B1&B&A1&A|D&C1&C&!B2&B1&B&A1&A|D&!C1&C&!B2&B1&B&A1&A|D&!C1&C&B2&B1&B&A1&A|D&C1&C&B2&B1&B&A1&A|D&C1&!C&B2&B1&B&A1&A|D&C1&!C&B2&!B1&B&A1&A|D&C1&C&B2&!B1&B&A1&A|D&!C1&C&B2&!B1&B&A1&A|D&!C1&C&!B2&!B1&B&A1&A|D&C1&C&!B2&!B1&B&A1&A|D&C1&!C&!B2&!B1&B&A1&A|D&C1&!C&!B2&!B1&B&!A1&A|D&C1&C&!B2&!B1&B&!A1&A|D&!C1&C&!B2&!B1&B&!A1&A|D&!C1&C&B2&!B1&B&!A1&A|D&C1&C&B2&!B1&B&!A1&A|D&C1&!C&B2&!B1&B&!A1&A|D&C1&!C&B2&B1&B&!A1&A|D&C1&C&B2&B1&B&!A1&A|D&!C1&C&B2&B1&B&!A1&A|D&!C1&C&!B2&B1&B&!A1&A|D&C1&C&!B2&B1&B&!A1&A|D&C1&!C&!B2&B1&B&!A1&A|D&C1&!C&!B2&B1&!B&!A1&A|D&C1&C&!B2&B1&!B&!A1&A|D&!C1&C&!B2&B1&!B&!A1&A|D&!C1&C&B2&B1&!B&!A1&A|D&C1&C&B2&B1&!B&!A1&A|D&C1&!C&B2&B1&!B&!A1&A|D&C1&!C&B2&!B1&!B&!A1&A|D&C1&C&B2&!B1&!B&!A1&A|D&!C1&C&B2&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAI2321.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOI32 -l AOI32 -i B1 B A2 A1 A -o Y -f Y=(!B1&!B&!A2&!A1&!A|!B1&!B&A2&!A1&!A|!B1&!B&A2&A1&!A|!B1&!B&!A2&A1&!A|!B1&!B&!A2&A1&A|!B1&!B&A2&!A1&A|!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOI32.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOAI22131 -l OOAAOAI22131 -i E D2 D1 D C B1 B A1 A -o Y -f Y=!(E&D2&D1&D&!C&!B1&!B&!A1&!A|E&D2&D1&D&C&!B1&!B&!A1&!A|E&D2&D1&D&C&B1&!B&!A1&!A|E&D2&D1&D&!C&B1&!B&!A1&!A|E&D2&D1&D&!C&B1&B&!A1&!A|E&D2&D1&D&C&B1&B&!A1&!A|E&D2&D1&D&C&!B1&B&!A1&!A|E&D2&D1&D&!C&!B1&B&!A1&!A|E&D2&D1&D&!C&!B1&B&A1&!A|E&!D2&!D1&D&C&!B1&B&A1&!A|E&D2&!D1&D&C&!B1&B&A1&!A|E&D2&D1&D&C&!B1&B&A1&!A|E&!D2&D1&D&C&!B1&B&A1&!A|E&!D2&D1&!D&C&!B1&B&A1&!A|E&D2&D1&!D&C&!B1&B&A1&!A|E&D2&!D1&!D&C&!B1&B&A1&!A|E&!D2&!D1&!D&C&!B1&B&A1&!A|E&!D2&!D1&!D&C&B1&B&A1&!A|E&D2&!D1&!D&C&B1&B&A1&!A|E&D2&D1&!D&C&B1&B&A1&!A|E&!D2&D1&!D&C&B1&B&A1&!A|E&!D2&D1&D&C&B1&B&A1&!A|E&D2&D1&D&C&B1&B&A1&!A|E&D2&!D1&D&C&B1&B&A1&!A|E&!D2&!D1&D&C&B1&B&A1&!A|E&D2&D1&D&!C&B1&B&A1&!A|E&D2&D1&D&!C&B1&!B&A1&!A|E&!D2&!D1&D&C&B1&!B&A1&!A|E&D2&!D1&D&C&B1&!B&A1&!A|E&D2&D1&D&C&B1&!B&A1&!A|E&!D2&D1&D&C&B1&!B&A1&!A|E&!D2&D1&!D&C&B1&!B&A1&!A|E&D2&D1&!D&C&B1&!B&A1&!A|E&D2&!D1&!D&C&B1&!B&A1&!A|E&!D2&!D1&!D&C&B1&!B&A1&!A|E&D2&D1&D&C&!B1&!B&A1&!A|E&D2&D1&D&!C&!B1&!B&A1&!A|E&D2&D1&D&!C&!B1&!B&A1&A|E&D2&D1&D&C&!B1&!B&A1&A|E&!D2&!D1&!D&C&B1&!B&A1&A|E&D2&!D1&!D&C&B1&!B&A1&A|E&D2&D1&!D&C&B1&!B&A1&A|E&!D2&D1&!D&C&B1&!B&A1&A|E&!D2&D1&D&C&B1&!B&A1&A|E&D2&D1&D&C&B1&!B&A1&A|E&D2&!D1&D&C&B1&!B&A1&A|E&!D2&!D1&D&C&B1&!B&A1&A|E&D2&D1&D&!C&B1&!B&A1&A|E&D2&D1&D&!C&B1&B&A1&A|E&!D2&!D1&D&C&B1&B&A1&A|E&D2&!D1&D&C&B1&B&A1&A|E&D2&D1&D&C&B1&B&A1&A|E&!D2&D1&D&C&B1&B&A1&A|E&!D2&D1&!D&C&B1&B&A1&A|E&D2&D1&!D&C&B1&B&A1&A|E&D2&!D1&!D&C&B1&B&A1&A|E&!D2&!D1&!D&C&B1&B&A1&A|E&!D2&!D1&!D&C&!B1&B&A1&A|E&D2&!D1&!D&C&!B1&B&A1&A|E&D2&D1&!D&C&!B1&B&A1&A|E&!D2&D1&!D&C&!B1&B&A1&A|E&!D2&D1&D&C&!B1&B&A1&A|E&D2&D1&D&C&!B1&B&A1&A|E&D2&!D1&D&C&!B1&B&A1&A|E&!D2&!D1&D&C&!B1&B&A1&A|E&D2&D1&D&!C&!B1&B&A1&A|E&D2&D1&D&!C&!B1&B&!A1&A|E&!D2&!D1&D&C&!B1&B&!A1&A|E&D2&!D1&D&C&!B1&B&!A1&A|E&D2&D1&D&C&!B1&B&!A1&A|E&!D2&D1&D&C&!B1&B&!A1&A|E&!D2&D1&!D&C&!B1&B&!A1&A|E&D2&D1&!D&C&!B1&B&!A1&A|E&D2&!D1&!D&C&!B1&B&!A1&A|E&!D2&!D1&!D&C&!B1&B&!A1&A|E&!D2&!D1&!D&C&B1&B&!A1&A|E&D2&!D1&!D&C&B1&B&!A1&A|E&D2&D1&!D&C&B1&B&!A1&A|E&!D2&D1&!D&C&B1&B&!A1&A|E&!D2&D1&D&C&B1&B&!A1&A|E&D2&D1&D&C&B1&B&!A1&A|E&D2&!D1&D&C&B1&B&!A1&A|E&!D2&!D1&D&C&B1&B&!A1&A|E&D2&D1&D&!C&B1&B&!A1&A|E&D2&D1&D&!C&B1&!B&!A1&A|E&!D2&!D1&D&C&B1&!B&!A1&A|E&D2&!D1&D&C&B1&!B&!A1&A|E&D2&D1&D&C&B1&!B&!A1&A|E&!D2&D1&D&C&B1&!B&!A1&A|E&!D2&D1&!D&C&B1&!B&!A1&A|E&D2&D1&!D&C&B1&!B&!A1&A|E&D2&!D1&!D&C&B1&!B&!A1&A|E&!D2&!D1&!D&C&B1&!B&!A1&A|E&D2&D1&D&C&!B1&!B&!A1&A|E&D2&D1&D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOAI22131.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAI21 -l OAI21 -i B A1 A -o Y -f Y=!(B&A1&!A|B&A1&A|B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAI21.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAI21121 -l OAOOAI21121 -i E D1 D C B A1 A -o Y -f Y=!(E&!D1&D&C&!B&!A1&!A|E&D1&D&C&!B&!A1&!A|E&D1&!D&C&!B&!A1&!A|E&D1&!D&C&B&!A1&!A|E&D1&D&C&B&!A1&!A|E&!D1&D&C&B&!A1&!A|E&D1&!D&!C&B&A1&!A|E&D1&D&!C&B&A1&!A|E&!D1&D&!C&B&A1&!A|E&!D1&D&C&B&A1&!A|E&D1&D&C&B&A1&!A|E&D1&!D&C&B&A1&!A|E&D1&!D&C&!B&A1&!A|E&D1&D&C&!B&A1&!A|E&!D1&D&C&!B&A1&!A|E&!D1&D&C&!B&A1&A|E&D1&D&C&!B&A1&A|E&D1&!D&C&!B&A1&A|E&D1&!D&C&B&A1&A|E&D1&D&C&B&A1&A|E&!D1&D&C&B&A1&A|E&!D1&D&!C&B&A1&A|E&D1&D&!C&B&A1&A|E&D1&!D&!C&B&A1&A|E&D1&!D&!C&B&!A1&A|E&D1&D&!C&B&!A1&A|E&!D1&D&!C&B&!A1&A|E&!D1&D&C&B&!A1&A|E&D1&D&C&B&!A1&A|E&D1&!D&C&B&!A1&A|E&D1&!D&C&!B&!A1&A|E&D1&D&C&!B&!A1&A|E&!D1&D&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAI21121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOAOI212311 -l OAAOOAOI212311 -i F E D2 D1 D C1 C B A1 A -o Y -f Y=(!F&!E&!D2&!D1&!D&!C1&!C&!B&!A1&!A|!F&E&!D2&!D1&!D&!C1&!C&!B&!A1&!A|!F&E&D2&!D1&!D&!C1&!C&!B&!A1&!A|!F&!E&D2&!D1&!D&!C1&!C&!B&!A1&!A|!F&!E&D2&D1&!D&!C1&!C&!B&!A1&!A|!F&E&D2&D1&!D&!C1&!C&!B&!A1&!A|!F&E&!D2&D1&!D&!C1&!C&!B&!A1&!A|!F&!E&!D2&D1&!D&!C1&!C&!B&!A1&!A|!F&!E&!D2&D1&D&!C1&!C&!B&!A1&!A|!F&E&!D2&D1&D&!C1&!C&!B&!A1&!A|!F&E&D2&D1&D&!C1&!C&!B&!A1&!A|!F&!E&D2&D1&D&!C1&!C&!B&!A1&!A|!F&!E&D2&!D1&D&!C1&!C&!B&!A1&!A|!F&E&D2&!D1&D&!C1&!C&!B&!A1&!A|!F&E&!D2&!D1&D&!C1&!C&!B&!A1&!A|!F&!E&!D2&!D1&D&!C1&!C&!B&!A1&!A|!F&!E&!D2&!D1&D&C1&!C&!B&!A1&!A|!F&E&!D2&!D1&D&C1&!C&!B&!A1&!A|!F&E&D2&!D1&D&C1&!C&!B&!A1&!A|!F&!E&D2&!D1&D&C1&!C&!B&!A1&!A|!F&!E&D2&D1&D&C1&!C&!B&!A1&!A|!F&E&D2&D1&D&C1&!C&!B&!A1&!A|!F&E&!D2&D1&D&C1&!C&!B&!A1&!A|!F&!E&!D2&D1&D&C1&!C&!B&!A1&!A|!F&!E&!D2&D1&!D&C1&!C&!B&!A1&!A|!F&E&!D2&D1&!D&C1&!C&!B&!A1&!A|!F&E&D2&D1&!D&C1&!C&!B&!A1&!A|!F&!E&D2&D1&!D&C1&!C&!B&!A1&!A|!F&!E&D2&!D1&!D&C1&!C&!B&!A1&!A|!F&E&D2&!D1&!D&C1&!C&!B&!A1&!A|!F&E&!D2&!D1&!D&C1&!C&!B&!A1&!A|!F&!E&!D2&!D1&!D&C1&!C&!B&!A1&!A|!F&!E&!D2&!D1&!D&C1&C&!B&!A1&!A|!F&E&!D2&!D1&!D&C1&C&!B&!A1&!A|!F&!E&D2&!D1&!D&C1&C&!B&!A1&!A|!F&!E&D2&D1&!D&C1&C&!B&!A1&!A|!F&!E&!D2&D1&!D&C1&C&!B&!A1&!A|!F&!E&!D2&D1&D&C1&C&!B&!A1&!A|!F&!E&D2&D1&D&C1&C&!B&!A1&!A|!F&!E&D2&!D1&D&C1&C&!B&!A1&!A|!F&!E&!D2&!D1&D&C1&C&!B&!A1&!A|!F&!E&!D2&!D1&D&!C1&C&!B&!A1&!A|!F&E&!D2&!D1&D&!C1&C&!B&!A1&!A|!F&E&D2&!D1&D&!C1&C&!B&!A1&!A|!F&!E&D2&!D1&D&!C1&C&!B&!A1&!A|!F&!E&D2&D1&D&!C1&C&!B&!A1&!A|!F&E&D2&D1&D&!C1&C&!B&!A1&!A|!F&E&!D2&D1&D&!C1&C&!B&!A1&!A|!F&!E&!D2&D1&D&!C1&C&!B&!A1&!A|!F&!E&!D2&D1&!D&!C1&C&!B&!A1&!A|!F&E&!D2&D1&!D&!C1&C&!B&!A1&!A|!F&E&D2&D1&!D&!C1&C&!B&!A1&!A|!F&!E&D2&D1&!D&!C1&C&!B&!A1&!A|!F&!E&D2&!D1&!D&!C1&C&!B&!A1&!A|!F&E&D2&!D1&!D&!C1&C&!B&!A1&!A|!F&E&!D2&!D1&!D&!C1&C&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&C&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&C&B&!A1&!A|!F&E&!D2&!D1&!D&!C1&C&B&!A1&!A|!F&E&D2&!D1&!D&!C1&C&B&!A1&!A|!F&!E&D2&!D1&!D&!C1&C&B&!A1&!A|!F&!E&D2&D1&!D&!C1&C&B&!A1&!A|!F&E&D2&D1&!D&!C1&C&B&!A1&!A|!F&E&!D2&D1&!D&!C1&C&B&!A1&!A|!F&!E&!D2&D1&!D&!C1&C&B&!A1&!A|!F&!E&!D2&D1&D&!C1&C&B&!A1&!A|!F&E&!D2&D1&D&!C1&C&B&!A1&!A|!F&E&D2&D1&D&!C1&C&B&!A1&!A|!F&!E&D2&D1&D&!C1&C&B&!A1&!A|!F&!E&D2&!D1&D&!C1&C&B&!A1&!A|!F&E&D2&!D1&D&!C1&C&B&!A1&!A|!F&E&!D2&!D1&D&!C1&C&B&!A1&!A|!F&!E&!D2&!D1&D&!C1&C&B&!A1&!A|!F&!E&!D2&!D1&D&C1&C&B&!A1&!A|!F&!E&D2&!D1&D&C1&C&B&!A1&!A|!F&!E&D2&D1&D&C1&C&B&!A1&!A|!F&!E&!D2&D1&D&C1&C&B&!A1&!A|!F&!E&!D2&D1&!D&C1&C&B&!A1&!A|!F&!E&D2&D1&!D&C1&C&B&!A1&!A|!F&!E&D2&!D1&!D&C1&C&B&!A1&!A|!F&E&!D2&!D1&!D&C1&C&B&!A1&!A|!F&!E&!D2&!D1&!D&C1&C&B&!A1&!A|!F&!E&!D2&!D1&!D&C1&!C&B&!A1&!A|!F&E&!D2&!D1&!D&C1&!C&B&!A1&!A|!F&E&D2&!D1&!D&C1&!C&B&!A1&!A|!F&!E&D2&!D1&!D&C1&!C&B&!A1&!A|!F&!E&D2&D1&!D&C1&!C&B&!A1&!A|!F&E&D2&D1&!D&C1&!C&B&!A1&!A|!F&E&!D2&D1&!D&C1&!C&B&!A1&!A|!F&!E&!D2&D1&!D&C1&!C&B&!A1&!A|!F&!E&!D2&D1&D&C1&!C&B&!A1&!A|!F&E&!D2&D1&D&C1&!C&B&!A1&!A|!F&E&D2&D1&D&C1&!C&B&!A1&!A|!F&!E&D2&D1&D&C1&!C&B&!A1&!A|!F&!E&D2&!D1&D&C1&!C&B&!A1&!A|!F&E&D2&!D1&D&C1&!C&B&!A1&!A|!F&E&!D2&!D1&D&C1&!C&B&!A1&!A|!F&!E&!D2&!D1&D&C1&!C&B&!A1&!A|!F&!E&!D2&!D1&D&!C1&!C&B&!A1&!A|!F&E&!D2&!D1&D&!C1&!C&B&!A1&!A|!F&E&D2&!D1&D&!C1&!C&B&!A1&!A|!F&!E&D2&!D1&D&!C1&!C&B&!A1&!A|!F&!E&D2&D1&D&!C1&!C&B&!A1&!A|!F&E&D2&D1&D&!C1&!C&B&!A1&!A|!F&E&!D2&D1&D&!C1&!C&B&!A1&!A|!F&!E&!D2&D1&D&!C1&!C&B&!A1&!A|!F&!E&!D2&D1&!D&!C1&!C&B&!A1&!A|!F&E&!D2&D1&!D&!C1&!C&B&!A1&!A|!F&E&D2&D1&!D&!C1&!C&B&!A1&!A|!F&!E&D2&D1&!D&!C1&!C&B&!A1&!A|!F&!E&D2&!D1&!D&!C1&!C&B&!A1&!A|!F&E&D2&!D1&!D&!C1&!C&B&!A1&!A|!F&E&!D2&!D1&!D&!C1&!C&B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&B&A1&!A|!F&E&!D2&!D1&!D&!C1&!C&B&A1&!A|!F&!E&D2&!D1&!D&!C1&!C&B&A1&!A|!F&!E&D2&D1&!D&!C1&!C&B&A1&!A|!F&!E&!D2&D1&!D&!C1&!C&B&A1&!A|!F&!E&!D2&D1&D&!C1&!C&B&A1&!A|!F&!E&D2&D1&D&!C1&!C&B&A1&!A|!F&!E&D2&!D1&D&!C1&!C&B&A1&!A|!F&!E&!D2&!D1&D&!C1&!C&B&A1&!A|!F&!E&!D2&!D1&D&C1&!C&B&A1&!A|!F&!E&D2&!D1&D&C1&!C&B&A1&!A|!F&!E&D2&D1&D&C1&!C&B&A1&!A|!F&!E&!D2&D1&D&C1&!C&B&A1&!A|!F&!E&!D2&D1&!D&C1&!C&B&A1&!A|!F&!E&D2&D1&!D&C1&!C&B&A1&!A|!F&!E&D2&!D1&!D&C1&!C&B&A1&!A|!F&E&!D2&!D1&!D&C1&!C&B&A1&!A|!F&!E&!D2&!D1&!D&C1&!C&B&A1&!A|!F&!E&!D2&!D1&!D&C1&C&B&A1&!A|!F&E&!D2&!D1&!D&C1&C&B&A1&!A|!F&!E&D2&!D1&!D&C1&C&B&A1&!A|!F&!E&D2&D1&!D&C1&C&B&A1&!A|!F&!E&!D2&D1&!D&C1&C&B&A1&!A|!F&!E&!D2&D1&D&C1&C&B&A1&!A|!F&!E&D2&D1&D&C1&C&B&A1&!A|!F&!E&D2&!D1&D&C1&C&B&A1&!A|!F&!E&!D2&!D1&D&C1&C&B&A1&!A|!F&!E&!D2&!D1&D&!C1&C&B&A1&!A|!F&!E&D2&!D1&D&!C1&C&B&A1&!A|!F&!E&D2&D1&D&!C1&C&B&A1&!A|!F&!E&!D2&D1&D&!C1&C&B&A1&!A|!F&!E&!D2&D1&!D&!C1&C&B&A1&!A|!F&!E&D2&D1&!D&!C1&C&B&A1&!A|!F&!E&D2&!D1&!D&!C1&C&B&A1&!A|!F&E&!D2&!D1&!D&!C1&C&B&A1&!A|!F&!E&!D2&!D1&!D&!C1&C&B&A1&!A|!F&!E&!D2&!D1&!D&!C1&C&!B&A1&!A|!F&E&!D2&!D1&!D&!C1&C&!B&A1&!A|!F&E&D2&!D1&!D&!C1&C&!B&A1&!A|!F&!E&D2&!D1&!D&!C1&C&!B&A1&!A|!F&!E&D2&D1&!D&!C1&C&!B&A1&!A|!F&E&D2&D1&!D&!C1&C&!B&A1&!A|!F&E&!D2&D1&!D&!C1&C&!B&A1&!A|!F&!E&!D2&D1&!D&!C1&C&!B&A1&!A|!F&!E&!D2&D1&D&!C1&C&!B&A1&!A|!F&E&!D2&D1&D&!C1&C&!B&A1&!A|!F&E&D2&D1&D&!C1&C&!B&A1&!A|!F&!E&D2&D1&D&!C1&C&!B&A1&!A|!F&!E&D2&!D1&D&!C1&C&!B&A1&!A|!F&E&D2&!D1&D&!C1&C&!B&A1&!A|!F&E&!D2&!D1&D&!C1&C&!B&A1&!A|!F&!E&!D2&!D1&D&!C1&C&!B&A1&!A|!F&!E&!D2&!D1&D&C1&C&!B&A1&!A|!F&!E&D2&!D1&D&C1&C&!B&A1&!A|!F&!E&D2&D1&D&C1&C&!B&A1&!A|!F&!E&!D2&D1&D&C1&C&!B&A1&!A|!F&!E&!D2&D1&!D&C1&C&!B&A1&!A|!F&!E&D2&D1&!D&C1&C&!B&A1&!A|!F&!E&D2&!D1&!D&C1&C&!B&A1&!A|!F&E&!D2&!D1&!D&C1&C&!B&A1&!A|!F&!E&!D2&!D1&!D&C1&C&!B&A1&!A|!F&!E&!D2&!D1&!D&C1&!C&!B&A1&!A|!F&E&!D2&!D1&!D&C1&!C&!B&A1&!A|!F&E&D2&!D1&!D&C1&!C&!B&A1&!A|!F&!E&D2&!D1&!D&C1&!C&!B&A1&!A|!F&!E&D2&D1&!D&C1&!C&!B&A1&!A|!F&E&D2&D1&!D&C1&!C&!B&A1&!A|!F&E&!D2&D1&!D&C1&!C&!B&A1&!A|!F&!E&!D2&D1&!D&C1&!C&!B&A1&!A|!F&!E&!D2&D1&D&C1&!C&!B&A1&!A|!F&E&!D2&D1&D&C1&!C&!B&A1&!A|!F&E&D2&D1&D&C1&!C&!B&A1&!A|!F&!E&D2&D1&D&C1&!C&!B&A1&!A|!F&!E&D2&!D1&D&C1&!C&!B&A1&!A|!F&E&D2&!D1&D&C1&!C&!B&A1&!A|!F&E&!D2&!D1&D&C1&!C&!B&A1&!A|!F&!E&!D2&!D1&D&C1&!C&!B&A1&!A|!F&!E&!D2&!D1&D&!C1&!C&!B&A1&!A|!F&E&!D2&!D1&D&!C1&!C&!B&A1&!A|!F&E&D2&!D1&D&!C1&!C&!B&A1&!A|!F&!E&D2&!D1&D&!C1&!C&!B&A1&!A|!F&!E&D2&D1&D&!C1&!C&!B&A1&!A|!F&E&D2&D1&D&!C1&!C&!B&A1&!A|!F&E&!D2&D1&D&!C1&!C&!B&A1&!A|!F&!E&!D2&D1&D&!C1&!C&!B&A1&!A|!F&!E&!D2&D1&!D&!C1&!C&!B&A1&!A|!F&E&!D2&D1&!D&!C1&!C&!B&A1&!A|!F&E&D2&D1&!D&!C1&!C&!B&A1&!A|!F&!E&D2&D1&!D&!C1&!C&!B&A1&!A|!F&!E&D2&!D1&!D&!C1&!C&!B&A1&!A|!F&E&D2&!D1&!D&!C1&!C&!B&A1&!A|!F&E&!D2&!D1&!D&!C1&!C&!B&A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&!B&A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&!B&A1&A|!F&E&!D2&!D1&!D&!C1&!C&!B&A1&A|!F&E&D2&!D1&!D&!C1&!C&!B&A1&A|!F&!E&D2&!D1&!D&!C1&!C&!B&A1&A|!F&!E&D2&D1&!D&!C1&!C&!B&A1&A|!F&E&D2&D1&!D&!C1&!C&!B&A1&A|!F&E&!D2&D1&!D&!C1&!C&!B&A1&A|!F&!E&!D2&D1&!D&!C1&!C&!B&A1&A|!F&!E&!D2&D1&D&!C1&!C&!B&A1&A|!F&E&!D2&D1&D&!C1&!C&!B&A1&A|!F&E&D2&D1&D&!C1&!C&!B&A1&A|!F&!E&D2&D1&D&!C1&!C&!B&A1&A|!F&!E&D2&!D1&D&!C1&!C&!B&A1&A|!F&E&D2&!D1&D&!C1&!C&!B&A1&A|!F&E&!D2&!D1&D&!C1&!C&!B&A1&A|!F&!E&!D2&!D1&D&!C1&!C&!B&A1&A|!F&!E&!D2&!D1&D&C1&!C&!B&A1&A|!F&E&!D2&!D1&D&C1&!C&!B&A1&A|!F&E&D2&!D1&D&C1&!C&!B&A1&A|!F&!E&D2&!D1&D&C1&!C&!B&A1&A|!F&!E&D2&D1&D&C1&!C&!B&A1&A|!F&E&D2&D1&D&C1&!C&!B&A1&A|!F&E&!D2&D1&D&C1&!C&!B&A1&A|!F&!E&!D2&D1&D&C1&!C&!B&A1&A|!F&!E&!D2&D1&!D&C1&!C&!B&A1&A|!F&E&!D2&D1&!D&C1&!C&!B&A1&A|!F&E&D2&D1&!D&C1&!C&!B&A1&A|!F&!E&D2&D1&!D&C1&!C&!B&A1&A|!F&!E&D2&!D1&!D&C1&!C&!B&A1&A|!F&E&D2&!D1&!D&C1&!C&!B&A1&A|!F&E&!D2&!D1&!D&C1&!C&!B&A1&A|!F&!E&!D2&!D1&!D&C1&!C&!B&A1&A|!F&!E&!D2&!D1&!D&C1&C&!B&A1&A|!F&E&!D2&!D1&!D&C1&C&!B&A1&A|!F&!E&D2&!D1&!D&C1&C&!B&A1&A|!F&!E&D2&D1&!D&C1&C&!B&A1&A|!F&!E&!D2&D1&!D&C1&C&!B&A1&A|!F&!E&!D2&D1&D&C1&C&!B&A1&A|!F&!E&D2&D1&D&C1&C&!B&A1&A|!F&!E&D2&!D1&D&C1&C&!B&A1&A|!F&!E&!D2&!D1&D&C1&C&!B&A1&A|!F&!E&!D2&!D1&D&!C1&C&!B&A1&A|!F&E&!D2&!D1&D&!C1&C&!B&A1&A|!F&E&D2&!D1&D&!C1&C&!B&A1&A|!F&!E&D2&!D1&D&!C1&C&!B&A1&A|!F&!E&D2&D1&D&!C1&C&!B&A1&A|!F&E&D2&D1&D&!C1&C&!B&A1&A|!F&E&!D2&D1&D&!C1&C&!B&A1&A|!F&!E&!D2&D1&D&!C1&C&!B&A1&A|!F&!E&!D2&D1&!D&!C1&C&!B&A1&A|!F&E&!D2&D1&!D&!C1&C&!B&A1&A|!F&E&D2&D1&!D&!C1&C&!B&A1&A|!F&!E&D2&D1&!D&!C1&C&!B&A1&A|!F&!E&D2&!D1&!D&!C1&C&!B&A1&A|!F&E&D2&!D1&!D&!C1&C&!B&A1&A|!F&E&!D2&!D1&!D&!C1&C&!B&A1&A|!F&!E&!D2&!D1&!D&!C1&C&!B&A1&A|!F&!E&!D2&!D1&!D&!C1&C&B&A1&A|!F&E&!D2&!D1&!D&!C1&C&B&A1&A|!F&!E&D2&!D1&!D&!C1&C&B&A1&A|!F&!E&D2&D1&!D&!C1&C&B&A1&A|!F&!E&!D2&D1&!D&!C1&C&B&A1&A|!F&!E&!D2&D1&D&!C1&C&B&A1&A|!F&!E&D2&D1&D&!C1&C&B&A1&A|!F&!E&D2&!D1&D&!C1&C&B&A1&A|!F&!E&!D2&!D1&D&!C1&C&B&A1&A|!F&!E&!D2&!D1&D&C1&C&B&A1&A|!F&!E&D2&!D1&D&C1&C&B&A1&A|!F&!E&D2&D1&D&C1&C&B&A1&A|!F&!E&!D2&D1&D&C1&C&B&A1&A|!F&!E&!D2&D1&!D&C1&C&B&A1&A|!F&!E&D2&D1&!D&C1&C&B&A1&A|!F&!E&D2&!D1&!D&C1&C&B&A1&A|!F&E&!D2&!D1&!D&C1&C&B&A1&A|!F&!E&!D2&!D1&!D&C1&C&B&A1&A|!F&!E&!D2&!D1&!D&C1&!C&B&A1&A|!F&E&!D2&!D1&!D&C1&!C&B&A1&A|!F&!E&D2&!D1&!D&C1&!C&B&A1&A|!F&!E&D2&D1&!D&C1&!C&B&A1&A|!F&!E&!D2&D1&!D&C1&!C&B&A1&A|!F&!E&!D2&D1&D&C1&!C&B&A1&A|!F&!E&D2&D1&D&C1&!C&B&A1&A|!F&!E&D2&!D1&D&C1&!C&B&A1&A|!F&!E&!D2&!D1&D&C1&!C&B&A1&A|!F&!E&!D2&!D1&D&!C1&!C&B&A1&A|!F&!E&D2&!D1&D&!C1&!C&B&A1&A|!F&!E&D2&D1&D&!C1&!C&B&A1&A|!F&!E&!D2&D1&D&!C1&!C&B&A1&A|!F&!E&!D2&D1&!D&!C1&!C&B&A1&A|!F&!E&D2&D1&!D&!C1&!C&B&A1&A|!F&!E&D2&!D1&!D&!C1&!C&B&A1&A|!F&E&!D2&!D1&!D&!C1&!C&B&A1&A|!F&!E&!D2&!D1&!D&!C1&!C&B&A1&A|!F&!E&!D2&!D1&!D&!C1&!C&B&!A1&A|!F&E&!D2&!D1&!D&!C1&!C&B&!A1&A|!F&!E&D2&!D1&!D&!C1&!C&B&!A1&A|!F&!E&D2&D1&!D&!C1&!C&B&!A1&A|!F&!E&!D2&D1&!D&!C1&!C&B&!A1&A|!F&!E&!D2&D1&D&!C1&!C&B&!A1&A|!F&!E&D2&D1&D&!C1&!C&B&!A1&A|!F&!E&D2&!D1&D&!C1&!C&B&!A1&A|!F&!E&!D2&!D1&D&!C1&!C&B&!A1&A|!F&!E&!D2&!D1&D&C1&!C&B&!A1&A|!F&!E&D2&!D1&D&C1&!C&B&!A1&A|!F&!E&D2&D1&D&C1&!C&B&!A1&A|!F&!E&!D2&D1&D&C1&!C&B&!A1&A|!F&!E&!D2&D1&!D&C1&!C&B&!A1&A|!F&!E&D2&D1&!D&C1&!C&B&!A1&A|!F&!E&D2&!D1&!D&C1&!C&B&!A1&A|!F&E&!D2&!D1&!D&C1&!C&B&!A1&A|!F&!E&!D2&!D1&!D&C1&!C&B&!A1&A|!F&!E&!D2&!D1&!D&C1&C&B&!A1&A|!F&E&!D2&!D1&!D&C1&C&B&!A1&A|!F&!E&D2&!D1&!D&C1&C&B&!A1&A|!F&!E&D2&D1&!D&C1&C&B&!A1&A|!F&!E&!D2&D1&!D&C1&C&B&!A1&A|!F&!E&!D2&D1&D&C1&C&B&!A1&A|!F&!E&D2&D1&D&C1&C&B&!A1&A|!F&!E&D2&!D1&D&C1&C&B&!A1&A|!F&!E&!D2&!D1&D&C1&C&B&!A1&A|!F&!E&!D2&!D1&D&!C1&C&B&!A1&A|!F&!E&D2&!D1&D&!C1&C&B&!A1&A|!F&!E&D2&D1&D&!C1&C&B&!A1&A|!F&!E&!D2&D1&D&!C1&C&B&!A1&A|!F&!E&!D2&D1&!D&!C1&C&B&!A1&A|!F&!E&D2&D1&!D&!C1&C&B&!A1&A|!F&!E&D2&!D1&!D&!C1&C&B&!A1&A|!F&E&!D2&!D1&!D&!C1&C&B&!A1&A|!F&!E&!D2&!D1&!D&!C1&C&B&!A1&A|!F&!E&!D2&!D1&!D&!C1&C&!B&!A1&A|!F&E&!D2&!D1&!D&!C1&C&!B&!A1&A|!F&E&D2&!D1&!D&!C1&C&!B&!A1&A|!F&!E&D2&!D1&!D&!C1&C&!B&!A1&A|!F&!E&D2&D1&!D&!C1&C&!B&!A1&A|!F&E&D2&D1&!D&!C1&C&!B&!A1&A|!F&E&!D2&D1&!D&!C1&C&!B&!A1&A|!F&!E&!D2&D1&!D&!C1&C&!B&!A1&A|!F&!E&!D2&D1&D&!C1&C&!B&!A1&A|!F&E&!D2&D1&D&!C1&C&!B&!A1&A|!F&E&D2&D1&D&!C1&C&!B&!A1&A|!F&!E&D2&D1&D&!C1&C&!B&!A1&A|!F&!E&D2&!D1&D&!C1&C&!B&!A1&A|!F&E&D2&!D1&D&!C1&C&!B&!A1&A|!F&E&!D2&!D1&D&!C1&C&!B&!A1&A|!F&!E&!D2&!D1&D&!C1&C&!B&!A1&A|!F&!E&!D2&!D1&D&C1&C&!B&!A1&A|!F&!E&D2&!D1&D&C1&C&!B&!A1&A|!F&!E&D2&D1&D&C1&C&!B&!A1&A|!F&!E&!D2&D1&D&C1&C&!B&!A1&A|!F&!E&!D2&D1&!D&C1&C&!B&!A1&A|!F&!E&D2&D1&!D&C1&C&!B&!A1&A|!F&!E&D2&!D1&!D&C1&C&!B&!A1&A|!F&E&!D2&!D1&!D&C1&C&!B&!A1&A|!F&!E&!D2&!D1&!D&C1&C&!B&!A1&A|!F&!E&!D2&!D1&!D&C1&!C&!B&!A1&A|!F&E&!D2&!D1&!D&C1&!C&!B&!A1&A|!F&E&D2&!D1&!D&C1&!C&!B&!A1&A|!F&!E&D2&!D1&!D&C1&!C&!B&!A1&A|!F&!E&D2&D1&!D&C1&!C&!B&!A1&A|!F&E&D2&D1&!D&C1&!C&!B&!A1&A|!F&E&!D2&D1&!D&C1&!C&!B&!A1&A|!F&!E&!D2&D1&!D&C1&!C&!B&!A1&A|!F&!E&!D2&D1&D&C1&!C&!B&!A1&A|!F&E&!D2&D1&D&C1&!C&!B&!A1&A|!F&E&D2&D1&D&C1&!C&!B&!A1&A|!F&!E&D2&D1&D&C1&!C&!B&!A1&A|!F&!E&D2&!D1&D&C1&!C&!B&!A1&A|!F&E&D2&!D1&D&C1&!C&!B&!A1&A|!F&E&!D2&!D1&D&C1&!C&!B&!A1&A|!F&!E&!D2&!D1&D&C1&!C&!B&!A1&A|!F&!E&!D2&!D1&D&!C1&!C&!B&!A1&A|!F&E&!D2&!D1&D&!C1&!C&!B&!A1&A|!F&E&D2&!D1&D&!C1&!C&!B&!A1&A|!F&!E&D2&!D1&D&!C1&!C&!B&!A1&A|!F&!E&D2&D1&D&!C1&!C&!B&!A1&A|!F&E&D2&D1&D&!C1&!C&!B&!A1&A|!F&E&!D2&D1&D&!C1&!C&!B&!A1&A|!F&!E&!D2&D1&D&!C1&!C&!B&!A1&A|!F&!E&!D2&D1&!D&!C1&!C&!B&!A1&A|!F&E&!D2&D1&!D&!C1&!C&!B&!A1&A|!F&E&D2&D1&!D&!C1&!C&!B&!A1&A|!F&!E&D2&D1&!D&!C1&!C&!B&!A1&A|!F&!E&D2&!D1&!D&!C1&!C&!B&!A1&A|!F&E&D2&!D1&!D&!C1&!C&!B&!A1&A|!F&E&!D2&!D1&!D&!C1&!C&!B&!A1&A|!F&!E&!D2&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOAOI212311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAAOAI222211 -l AAOOAAOAI222211 -i F E D1 D C1 C B1 B A1 A -o Y -f Y=!(F&E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|F&E&D1&!D&!C1&!C&!B1&!B&!A1&!A|F&!E&D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&!D1&D&!C1&!C&!B1&!B&!A1&!A|F&E&!D1&D&C1&!C&!B1&!B&!A1&!A|F&E&D1&D&C1&!C&!B1&!B&!A1&!A|F&!E&D1&D&C1&!C&!B1&!B&!A1&!A|F&E&D1&!D&C1&!C&!B1&!B&!A1&!A|F&E&!D1&!D&C1&!C&!B1&!B&!A1&!A|F&E&!D1&!D&C1&C&!B1&!B&!A1&!A|F&E&D1&!D&C1&C&!B1&!B&!A1&!A|F&!E&D1&D&C1&C&!B1&!B&!A1&!A|F&E&D1&D&C1&C&!B1&!B&!A1&!A|F&E&!D1&D&C1&C&!B1&!B&!A1&!A|F&E&!D1&D&!C1&C&!B1&!B&!A1&!A|F&E&D1&D&!C1&C&!B1&!B&!A1&!A|F&!E&D1&D&!C1&C&!B1&!B&!A1&!A|F&E&D1&!D&!C1&C&!B1&!B&!A1&!A|F&E&!D1&!D&!C1&C&!B1&!B&!A1&!A|F&E&!D1&!D&!C1&C&B1&!B&!A1&!A|F&E&D1&!D&!C1&C&B1&!B&!A1&!A|F&!E&D1&D&!C1&C&B1&!B&!A1&!A|F&E&D1&D&!C1&C&B1&!B&!A1&!A|F&E&!D1&D&!C1&C&B1&!B&!A1&!A|F&E&!D1&D&C1&C&B1&!B&!A1&!A|F&E&D1&D&C1&C&B1&!B&!A1&!A|F&!E&D1&D&C1&C&B1&!B&!A1&!A|F&E&D1&!D&C1&C&B1&!B&!A1&!A|F&E&!D1&!D&C1&C&B1&!B&!A1&!A|F&E&!D1&!D&C1&!C&B1&!B&!A1&!A|F&E&D1&!D&C1&!C&B1&!B&!A1&!A|F&!E&D1&D&C1&!C&B1&!B&!A1&!A|F&E&D1&D&C1&!C&B1&!B&!A1&!A|F&E&!D1&D&C1&!C&B1&!B&!A1&!A|F&E&!D1&D&!C1&!C&B1&!B&!A1&!A|F&E&D1&D&!C1&!C&B1&!B&!A1&!A|F&!E&D1&D&!C1&!C&B1&!B&!A1&!A|F&E&D1&!D&!C1&!C&B1&!B&!A1&!A|F&E&!D1&!D&!C1&!C&B1&!B&!A1&!A|F&E&!D1&!D&!C1&!C&B1&B&!A1&!A|F&E&D1&!D&!C1&!C&B1&B&!A1&!A|F&!E&D1&D&!C1&!C&B1&B&!A1&!A|F&E&D1&D&!C1&!C&B1&B&!A1&!A|F&E&!D1&D&!C1&!C&B1&B&!A1&!A|F&!E&!D1&D&C1&!C&B1&B&!A1&!A|F&E&!D1&D&C1&!C&B1&B&!A1&!A|F&E&D1&D&C1&!C&B1&B&!A1&!A|F&!E&D1&D&C1&!C&B1&B&!A1&!A|F&!E&D1&!D&C1&!C&B1&B&!A1&!A|F&E&D1&!D&C1&!C&B1&B&!A1&!A|F&E&!D1&!D&C1&!C&B1&B&!A1&!A|F&!E&!D1&!D&C1&!C&B1&B&!A1&!A|F&!E&!D1&!D&C1&C&B1&B&!A1&!A|F&E&!D1&!D&C1&C&B1&B&!A1&!A|F&E&D1&!D&C1&C&B1&B&!A1&!A|F&!E&D1&!D&C1&C&B1&B&!A1&!A|F&!E&D1&D&C1&C&B1&B&!A1&!A|F&E&D1&D&C1&C&B1&B&!A1&!A|F&E&!D1&D&C1&C&B1&B&!A1&!A|F&!E&!D1&D&C1&C&B1&B&!A1&!A|F&!E&!D1&D&!C1&C&B1&B&!A1&!A|F&E&!D1&D&!C1&C&B1&B&!A1&!A|F&E&D1&D&!C1&C&B1&B&!A1&!A|F&!E&D1&D&!C1&C&B1&B&!A1&!A|F&!E&D1&!D&!C1&C&B1&B&!A1&!A|F&E&D1&!D&!C1&C&B1&B&!A1&!A|F&E&!D1&!D&!C1&C&B1&B&!A1&!A|F&!E&!D1&!D&!C1&C&B1&B&!A1&!A|F&E&!D1&!D&!C1&C&!B1&B&!A1&!A|F&E&D1&!D&!C1&C&!B1&B&!A1&!A|F&!E&D1&D&!C1&C&!B1&B&!A1&!A|F&E&D1&D&!C1&C&!B1&B&!A1&!A|F&E&!D1&D&!C1&C&!B1&B&!A1&!A|F&E&!D1&D&C1&C&!B1&B&!A1&!A|F&E&D1&D&C1&C&!B1&B&!A1&!A|F&!E&D1&D&C1&C&!B1&B&!A1&!A|F&E&D1&!D&C1&C&!B1&B&!A1&!A|F&E&!D1&!D&C1&C&!B1&B&!A1&!A|F&E&!D1&!D&C1&!C&!B1&B&!A1&!A|F&E&D1&!D&C1&!C&!B1&B&!A1&!A|F&!E&D1&D&C1&!C&!B1&B&!A1&!A|F&E&D1&D&C1&!C&!B1&B&!A1&!A|F&E&!D1&D&C1&!C&!B1&B&!A1&!A|F&E&!D1&D&!C1&!C&!B1&B&!A1&!A|F&E&D1&D&!C1&!C&!B1&B&!A1&!A|F&!E&D1&D&!C1&!C&!B1&B&!A1&!A|F&E&D1&!D&!C1&!C&!B1&B&!A1&!A|F&E&!D1&!D&!C1&!C&!B1&B&!A1&!A|F&E&!D1&!D&!C1&!C&!B1&B&A1&!A|F&E&D1&!D&!C1&!C&!B1&B&A1&!A|F&!E&D1&D&!C1&!C&!B1&B&A1&!A|F&E&D1&D&!C1&!C&!B1&B&A1&!A|F&E&!D1&D&!C1&!C&!B1&B&A1&!A|F&E&!D1&D&C1&!C&!B1&B&A1&!A|F&E&D1&D&C1&!C&!B1&B&A1&!A|F&!E&D1&D&C1&!C&!B1&B&A1&!A|F&E&D1&!D&C1&!C&!B1&B&A1&!A|F&E&!D1&!D&C1&!C&!B1&B&A1&!A|F&E&!D1&!D&C1&C&!B1&B&A1&!A|F&E&D1&!D&C1&C&!B1&B&A1&!A|F&!E&D1&D&C1&C&!B1&B&A1&!A|F&E&D1&D&C1&C&!B1&B&A1&!A|F&E&!D1&D&C1&C&!B1&B&A1&!A|F&E&!D1&D&!C1&C&!B1&B&A1&!A|F&E&D1&D&!C1&C&!B1&B&A1&!A|F&!E&D1&D&!C1&C&!B1&B&A1&!A|F&E&D1&!D&!C1&C&!B1&B&A1&!A|F&E&!D1&!D&!C1&C&!B1&B&A1&!A|F&!E&!D1&!D&!C1&C&B1&B&A1&!A|F&E&!D1&!D&!C1&C&B1&B&A1&!A|F&E&D1&!D&!C1&C&B1&B&A1&!A|F&!E&D1&!D&!C1&C&B1&B&A1&!A|F&!E&D1&D&!C1&C&B1&B&A1&!A|F&E&D1&D&!C1&C&B1&B&A1&!A|F&E&!D1&D&!C1&C&B1&B&A1&!A|F&!E&!D1&D&!C1&C&B1&B&A1&!A|F&!E&!D1&D&C1&C&B1&B&A1&!A|F&E&!D1&D&C1&C&B1&B&A1&!A|F&E&D1&D&C1&C&B1&B&A1&!A|F&!E&D1&D&C1&C&B1&B&A1&!A|F&!E&D1&!D&C1&C&B1&B&A1&!A|F&E&D1&!D&C1&C&B1&B&A1&!A|F&E&!D1&!D&C1&C&B1&B&A1&!A|F&!E&!D1&!D&C1&C&B1&B&A1&!A|F&!E&!D1&!D&C1&!C&B1&B&A1&!A|F&E&!D1&!D&C1&!C&B1&B&A1&!A|F&E&D1&!D&C1&!C&B1&B&A1&!A|F&!E&D1&!D&C1&!C&B1&B&A1&!A|F&!E&D1&D&C1&!C&B1&B&A1&!A|F&E&D1&D&C1&!C&B1&B&A1&!A|F&E&!D1&D&C1&!C&B1&B&A1&!A|F&!E&!D1&D&C1&!C&B1&B&A1&!A|F&E&!D1&D&!C1&!C&B1&B&A1&!A|F&E&D1&D&!C1&!C&B1&B&A1&!A|F&!E&D1&D&!C1&!C&B1&B&A1&!A|F&E&D1&!D&!C1&!C&B1&B&A1&!A|F&E&!D1&!D&!C1&!C&B1&B&A1&!A|F&E&!D1&!D&!C1&!C&B1&!B&A1&!A|F&E&D1&!D&!C1&!C&B1&!B&A1&!A|F&!E&D1&D&!C1&!C&B1&!B&A1&!A|F&E&D1&D&!C1&!C&B1&!B&A1&!A|F&E&!D1&D&!C1&!C&B1&!B&A1&!A|F&E&!D1&D&C1&!C&B1&!B&A1&!A|F&E&D1&D&C1&!C&B1&!B&A1&!A|F&!E&D1&D&C1&!C&B1&!B&A1&!A|F&E&D1&!D&C1&!C&B1&!B&A1&!A|F&E&!D1&!D&C1&!C&B1&!B&A1&!A|F&E&!D1&!D&C1&C&B1&!B&A1&!A|F&E&D1&!D&C1&C&B1&!B&A1&!A|F&!E&D1&D&C1&C&B1&!B&A1&!A|F&E&D1&D&C1&C&B1&!B&A1&!A|F&E&!D1&D&C1&C&B1&!B&A1&!A|F&E&!D1&D&!C1&C&B1&!B&A1&!A|F&E&D1&D&!C1&C&B1&!B&A1&!A|F&!E&D1&D&!C1&C&B1&!B&A1&!A|F&E&D1&!D&!C1&C&B1&!B&A1&!A|F&E&!D1&!D&!C1&C&B1&!B&A1&!A|F&E&!D1&!D&!C1&C&!B1&!B&A1&!A|F&E&D1&!D&!C1&C&!B1&!B&A1&!A|F&!E&D1&D&!C1&C&!B1&!B&A1&!A|F&E&D1&D&!C1&C&!B1&!B&A1&!A|F&E&!D1&D&!C1&C&!B1&!B&A1&!A|F&E&!D1&D&C1&C&!B1&!B&A1&!A|F&E&D1&D&C1&C&!B1&!B&A1&!A|F&!E&D1&D&C1&C&!B1&!B&A1&!A|F&E&D1&!D&C1&C&!B1&!B&A1&!A|F&E&!D1&!D&C1&C&!B1&!B&A1&!A|F&E&!D1&!D&C1&!C&!B1&!B&A1&!A|F&E&D1&!D&C1&!C&!B1&!B&A1&!A|F&!E&D1&D&C1&!C&!B1&!B&A1&!A|F&E&D1&D&C1&!C&!B1&!B&A1&!A|F&E&!D1&D&C1&!C&!B1&!B&A1&!A|F&E&!D1&D&!C1&!C&!B1&!B&A1&!A|F&E&D1&D&!C1&!C&!B1&!B&A1&!A|F&!E&D1&D&!C1&!C&!B1&!B&A1&!A|F&E&D1&!D&!C1&!C&!B1&!B&A1&!A|F&E&!D1&!D&!C1&!C&!B1&!B&A1&!A|F&E&!D1&!D&!C1&!C&!B1&!B&A1&A|F&E&D1&!D&!C1&!C&!B1&!B&A1&A|F&!E&D1&D&!C1&!C&!B1&!B&A1&A|F&E&D1&D&!C1&!C&!B1&!B&A1&A|F&E&!D1&D&!C1&!C&!B1&!B&A1&A|F&!E&!D1&D&C1&!C&!B1&!B&A1&A|F&E&!D1&D&C1&!C&!B1&!B&A1&A|F&E&D1&D&C1&!C&!B1&!B&A1&A|F&!E&D1&D&C1&!C&!B1&!B&A1&A|F&!E&D1&!D&C1&!C&!B1&!B&A1&A|F&E&D1&!D&C1&!C&!B1&!B&A1&A|F&E&!D1&!D&C1&!C&!B1&!B&A1&A|F&!E&!D1&!D&C1&!C&!B1&!B&A1&A|F&!E&!D1&!D&C1&C&!B1&!B&A1&A|F&E&!D1&!D&C1&C&!B1&!B&A1&A|F&E&D1&!D&C1&C&!B1&!B&A1&A|F&!E&D1&!D&C1&C&!B1&!B&A1&A|F&!E&D1&D&C1&C&!B1&!B&A1&A|F&E&D1&D&C1&C&!B1&!B&A1&A|F&E&!D1&D&C1&C&!B1&!B&A1&A|F&!E&!D1&D&C1&C&!B1&!B&A1&A|F&!E&!D1&D&!C1&C&!B1&!B&A1&A|F&E&!D1&D&!C1&C&!B1&!B&A1&A|F&E&D1&D&!C1&C&!B1&!B&A1&A|F&!E&D1&D&!C1&C&!B1&!B&A1&A|F&!E&D1&!D&!C1&C&!B1&!B&A1&A|F&E&D1&!D&!C1&C&!B1&!B&A1&A|F&E&!D1&!D&!C1&C&!B1&!B&A1&A|F&!E&!D1&!D&!C1&C&!B1&!B&A1&A|F&!E&!D1&!D&!C1&C&B1&!B&A1&A|F&E&!D1&!D&!C1&C&B1&!B&A1&A|F&E&D1&!D&!C1&C&B1&!B&A1&A|F&!E&D1&!D&!C1&C&B1&!B&A1&A|F&!E&D1&D&!C1&C&B1&!B&A1&A|F&E&D1&D&!C1&C&B1&!B&A1&A|F&E&!D1&D&!C1&C&B1&!B&A1&A|F&!E&!D1&D&!C1&C&B1&!B&A1&A|F&!E&!D1&D&C1&C&B1&!B&A1&A|F&E&!D1&D&C1&C&B1&!B&A1&A|F&E&D1&D&C1&C&B1&!B&A1&A|F&!E&D1&D&C1&C&B1&!B&A1&A|F&!E&D1&!D&C1&C&B1&!B&A1&A|F&E&D1&!D&C1&C&B1&!B&A1&A|F&E&!D1&!D&C1&C&B1&!B&A1&A|F&!E&!D1&!D&C1&C&B1&!B&A1&A|F&!E&!D1&!D&C1&!C&B1&!B&A1&A|F&E&!D1&!D&C1&!C&B1&!B&A1&A|F&E&D1&!D&C1&!C&B1&!B&A1&A|F&!E&D1&!D&C1&!C&B1&!B&A1&A|F&!E&D1&D&C1&!C&B1&!B&A1&A|F&E&D1&D&C1&!C&B1&!B&A1&A|F&E&!D1&D&C1&!C&B1&!B&A1&A|F&!E&!D1&D&C1&!C&B1&!B&A1&A|F&E&!D1&D&!C1&!C&B1&!B&A1&A|F&E&D1&D&!C1&!C&B1&!B&A1&A|F&!E&D1&D&!C1&!C&B1&!B&A1&A|F&E&D1&!D&!C1&!C&B1&!B&A1&A|F&E&!D1&!D&!C1&!C&B1&!B&A1&A|F&E&!D1&!D&!C1&!C&B1&B&A1&A|F&E&D1&!D&!C1&!C&B1&B&A1&A|F&!E&D1&D&!C1&!C&B1&B&A1&A|F&E&D1&D&!C1&!C&B1&B&A1&A|F&E&!D1&D&!C1&!C&B1&B&A1&A|F&!E&!D1&D&C1&!C&B1&B&A1&A|F&E&!D1&D&C1&!C&B1&B&A1&A|F&E&D1&D&C1&!C&B1&B&A1&A|F&!E&D1&D&C1&!C&B1&B&A1&A|F&!E&D1&!D&C1&!C&B1&B&A1&A|F&E&D1&!D&C1&!C&B1&B&A1&A|F&E&!D1&!D&C1&!C&B1&B&A1&A|F&!E&!D1&!D&C1&!C&B1&B&A1&A|F&!E&!D1&!D&C1&C&B1&B&A1&A|F&E&!D1&!D&C1&C&B1&B&A1&A|F&E&D1&!D&C1&C&B1&B&A1&A|F&!E&D1&!D&C1&C&B1&B&A1&A|F&!E&D1&D&C1&C&B1&B&A1&A|F&E&D1&D&C1&C&B1&B&A1&A|F&E&!D1&D&C1&C&B1&B&A1&A|F&!E&!D1&D&C1&C&B1&B&A1&A|F&!E&!D1&D&!C1&C&B1&B&A1&A|F&E&!D1&D&!C1&C&B1&B&A1&A|F&E&D1&D&!C1&C&B1&B&A1&A|F&!E&D1&D&!C1&C&B1&B&A1&A|F&!E&D1&!D&!C1&C&B1&B&A1&A|F&E&D1&!D&!C1&C&B1&B&A1&A|F&E&!D1&!D&!C1&C&B1&B&A1&A|F&!E&!D1&!D&!C1&C&B1&B&A1&A|F&!E&!D1&!D&!C1&C&!B1&B&A1&A|F&E&!D1&!D&!C1&C&!B1&B&A1&A|F&E&D1&!D&!C1&C&!B1&B&A1&A|F&!E&D1&!D&!C1&C&!B1&B&A1&A|F&!E&D1&D&!C1&C&!B1&B&A1&A|F&E&D1&D&!C1&C&!B1&B&A1&A|F&E&!D1&D&!C1&C&!B1&B&A1&A|F&!E&!D1&D&!C1&C&!B1&B&A1&A|F&!E&!D1&D&C1&C&!B1&B&A1&A|F&E&!D1&D&C1&C&!B1&B&A1&A|F&E&D1&D&C1&C&!B1&B&A1&A|F&!E&D1&D&C1&C&!B1&B&A1&A|F&!E&D1&!D&C1&C&!B1&B&A1&A|F&E&D1&!D&C1&C&!B1&B&A1&A|F&E&!D1&!D&C1&C&!B1&B&A1&A|F&!E&!D1&!D&C1&C&!B1&B&A1&A|F&!E&!D1&!D&C1&!C&!B1&B&A1&A|F&E&!D1&!D&C1&!C&!B1&B&A1&A|F&E&D1&!D&C1&!C&!B1&B&A1&A|F&!E&D1&!D&C1&!C&!B1&B&A1&A|F&!E&D1&D&C1&!C&!B1&B&A1&A|F&E&D1&D&C1&!C&!B1&B&A1&A|F&E&!D1&D&C1&!C&!B1&B&A1&A|F&!E&!D1&D&C1&!C&!B1&B&A1&A|F&E&!D1&D&!C1&!C&!B1&B&A1&A|F&E&D1&D&!C1&!C&!B1&B&A1&A|F&!E&D1&D&!C1&!C&!B1&B&A1&A|F&E&D1&!D&!C1&!C&!B1&B&A1&A|F&E&!D1&!D&!C1&!C&!B1&B&A1&A|F&E&!D1&!D&!C1&!C&!B1&B&!A1&A|F&E&D1&!D&!C1&!C&!B1&B&!A1&A|F&!E&D1&D&!C1&!C&!B1&B&!A1&A|F&E&D1&D&!C1&!C&!B1&B&!A1&A|F&E&!D1&D&!C1&!C&!B1&B&!A1&A|F&E&!D1&D&C1&!C&!B1&B&!A1&A|F&E&D1&D&C1&!C&!B1&B&!A1&A|F&!E&D1&D&C1&!C&!B1&B&!A1&A|F&E&D1&!D&C1&!C&!B1&B&!A1&A|F&E&!D1&!D&C1&!C&!B1&B&!A1&A|F&E&!D1&!D&C1&C&!B1&B&!A1&A|F&E&D1&!D&C1&C&!B1&B&!A1&A|F&!E&D1&D&C1&C&!B1&B&!A1&A|F&E&D1&D&C1&C&!B1&B&!A1&A|F&E&!D1&D&C1&C&!B1&B&!A1&A|F&E&!D1&D&!C1&C&!B1&B&!A1&A|F&E&D1&D&!C1&C&!B1&B&!A1&A|F&!E&D1&D&!C1&C&!B1&B&!A1&A|F&E&D1&!D&!C1&C&!B1&B&!A1&A|F&E&!D1&!D&!C1&C&!B1&B&!A1&A|F&!E&!D1&!D&!C1&C&B1&B&!A1&A|F&E&!D1&!D&!C1&C&B1&B&!A1&A|F&E&D1&!D&!C1&C&B1&B&!A1&A|F&!E&D1&!D&!C1&C&B1&B&!A1&A|F&!E&D1&D&!C1&C&B1&B&!A1&A|F&E&D1&D&!C1&C&B1&B&!A1&A|F&E&!D1&D&!C1&C&B1&B&!A1&A|F&!E&!D1&D&!C1&C&B1&B&!A1&A|F&!E&!D1&D&C1&C&B1&B&!A1&A|F&E&!D1&D&C1&C&B1&B&!A1&A|F&E&D1&D&C1&C&B1&B&!A1&A|F&!E&D1&D&C1&C&B1&B&!A1&A|F&!E&D1&!D&C1&C&B1&B&!A1&A|F&E&D1&!D&C1&C&B1&B&!A1&A|F&E&!D1&!D&C1&C&B1&B&!A1&A|F&!E&!D1&!D&C1&C&B1&B&!A1&A|F&!E&!D1&!D&C1&!C&B1&B&!A1&A|F&E&!D1&!D&C1&!C&B1&B&!A1&A|F&E&D1&!D&C1&!C&B1&B&!A1&A|F&!E&D1&!D&C1&!C&B1&B&!A1&A|F&!E&D1&D&C1&!C&B1&B&!A1&A|F&E&D1&D&C1&!C&B1&B&!A1&A|F&E&!D1&D&C1&!C&B1&B&!A1&A|F&!E&!D1&D&C1&!C&B1&B&!A1&A|F&E&!D1&D&!C1&!C&B1&B&!A1&A|F&E&D1&D&!C1&!C&B1&B&!A1&A|F&!E&D1&D&!C1&!C&B1&B&!A1&A|F&E&D1&!D&!C1&!C&B1&B&!A1&A|F&E&!D1&!D&!C1&!C&B1&B&!A1&A|F&E&!D1&!D&!C1&!C&B1&!B&!A1&A|F&E&D1&!D&!C1&!C&B1&!B&!A1&A|F&!E&D1&D&!C1&!C&B1&!B&!A1&A|F&E&D1&D&!C1&!C&B1&!B&!A1&A|F&E&!D1&D&!C1&!C&B1&!B&!A1&A|F&E&!D1&D&C1&!C&B1&!B&!A1&A|F&E&D1&D&C1&!C&B1&!B&!A1&A|F&!E&D1&D&C1&!C&B1&!B&!A1&A|F&E&D1&!D&C1&!C&B1&!B&!A1&A|F&E&!D1&!D&C1&!C&B1&!B&!A1&A|F&E&!D1&!D&C1&C&B1&!B&!A1&A|F&E&D1&!D&C1&C&B1&!B&!A1&A|F&!E&D1&D&C1&C&B1&!B&!A1&A|F&E&D1&D&C1&C&B1&!B&!A1&A|F&E&!D1&D&C1&C&B1&!B&!A1&A|F&E&!D1&D&!C1&C&B1&!B&!A1&A|F&E&D1&D&!C1&C&B1&!B&!A1&A|F&!E&D1&D&!C1&C&B1&!B&!A1&A|F&E&D1&!D&!C1&C&B1&!B&!A1&A|F&E&!D1&!D&!C1&C&B1&!B&!A1&A|F&E&!D1&!D&!C1&C&!B1&!B&!A1&A|F&E&D1&!D&!C1&C&!B1&!B&!A1&A|F&!E&D1&D&!C1&C&!B1&!B&!A1&A|F&E&D1&D&!C1&C&!B1&!B&!A1&A|F&E&!D1&D&!C1&C&!B1&!B&!A1&A|F&E&!D1&D&C1&C&!B1&!B&!A1&A|F&E&D1&D&C1&C&!B1&!B&!A1&A|F&!E&D1&D&C1&C&!B1&!B&!A1&A|F&E&D1&!D&C1&C&!B1&!B&!A1&A|F&E&!D1&!D&C1&C&!B1&!B&!A1&A|F&E&!D1&!D&C1&!C&!B1&!B&!A1&A|F&E&D1&!D&C1&!C&!B1&!B&!A1&A|F&!E&D1&D&C1&!C&!B1&!B&!A1&A|F&E&D1&D&C1&!C&!B1&!B&!A1&A|F&E&!D1&D&C1&!C&!B1&!B&!A1&A|F&E&!D1&D&!C1&!C&!B1&!B&!A1&A|F&E&D1&D&!C1&!C&!B1&!B&!A1&A|F&!E&D1&D&!C1&!C&!B1&!B&!A1&A|F&E&D1&!D&!C1&!C&!B1&!B&!A1&A|F&E&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAAOAI222211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOAI2221 -l OAAOAI2221 -i D C1 C B1 B A1 A -o Y -f Y=!(D&C1&C&!B1&!B&!A1&!A|D&C1&C&B1&!B&!A1&!A|D&C1&C&B1&B&!A1&!A|D&C1&C&!B1&B&!A1&!A|D&C1&C&!B1&B&A1&!A|D&!C1&C&B1&B&A1&!A|D&C1&C&B1&B&A1&!A|D&C1&!C&B1&B&A1&!A|D&!C1&!C&B1&B&A1&!A|D&C1&C&B1&!B&A1&!A|D&C1&C&!B1&!B&A1&!A|D&C1&C&!B1&!B&A1&A|D&C1&C&B1&!B&A1&A|D&!C1&!C&B1&B&A1&A|D&C1&!C&B1&B&A1&A|D&C1&C&B1&B&A1&A|D&!C1&C&B1&B&A1&A|D&C1&C&!B1&B&A1&A|D&C1&C&!B1&B&!A1&A|D&!C1&C&B1&B&!A1&A|D&C1&C&B1&B&!A1&A|D&C1&!C&B1&B&!A1&A|D&!C1&!C&B1&B&!A1&A|D&C1&C&B1&!B&!A1&A|D&C1&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOAI2221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOI3321 -l AAAOI3321 -i D C1 C B2 B1 B A2 A1 A -o Y -f Y=(!D&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!D&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D&C1&!C&B2&!B1&!B&!A2&!A1&!A|!D&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!D&!C1&!C&B2&B1&!B&!A2&!A1&!A|!D&C1&!C&B2&B1&!B&!A2&!A1&!A|!D&!C1&C&B2&B1&!B&!A2&!A1&!A|!D&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D&C1&!C&!B2&B1&!B&!A2&!A1&!A|!D&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!D&!C1&!C&!B2&B1&B&!A2&!A1&!A|!D&C1&!C&!B2&B1&B&!A2&!A1&!A|!D&!C1&C&!B2&B1&B&!A2&!A1&!A|!D&!C1&!C&B2&!B1&B&!A2&!A1&!A|!D&C1&!C&B2&!B1&B&!A2&!A1&!A|!D&!C1&C&B2&!B1&B&!A2&!A1&!A|!D&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D&C1&!C&!B2&!B1&B&!A2&!A1&!A|!D&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!D&!C1&!C&!B2&!B1&B&A2&!A1&!A|!D&C1&!C&!B2&!B1&B&A2&!A1&!A|!D&!C1&C&!B2&!B1&B&A2&!A1&!A|!D&!C1&C&B2&!B1&B&A2&!A1&!A|!D&C1&!C&B2&!B1&B&A2&!A1&!A|!D&!C1&!C&B2&!B1&B&A2&!A1&!A|!D&!C1&C&!B2&B1&B&A2&!A1&!A|!D&C1&!C&!B2&B1&B&A2&!A1&!A|!D&!C1&!C&!B2&B1&B&A2&!A1&!A|!D&!C1&!C&!B2&B1&!B&A2&!A1&!A|!D&C1&!C&!B2&B1&!B&A2&!A1&!A|!D&!C1&C&!B2&B1&!B&A2&!A1&!A|!D&!C1&C&B2&B1&!B&A2&!A1&!A|!D&C1&!C&B2&B1&!B&A2&!A1&!A|!D&!C1&!C&B2&B1&!B&A2&!A1&!A|!D&!C1&!C&B2&!B1&!B&A2&!A1&!A|!D&C1&!C&B2&!B1&!B&A2&!A1&!A|!D&!C1&C&B2&!B1&!B&A2&!A1&!A|!D&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D&C1&!C&!B2&!B1&!B&A2&!A1&!A|!D&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!D&!C1&!C&!B2&!B1&!B&A2&A1&!A|!D&C1&!C&!B2&!B1&!B&A2&A1&!A|!D&!C1&C&!B2&!B1&!B&A2&A1&!A|!D&!C1&C&B2&!B1&!B&A2&A1&!A|!D&C1&!C&B2&!B1&!B&A2&A1&!A|!D&!C1&!C&B2&!B1&!B&A2&A1&!A|!D&!C1&!C&B2&B1&!B&A2&A1&!A|!D&C1&!C&B2&B1&!B&A2&A1&!A|!D&!C1&C&B2&B1&!B&A2&A1&!A|!D&!C1&C&!B2&B1&!B&A2&A1&!A|!D&C1&!C&!B2&B1&!B&A2&A1&!A|!D&!C1&!C&!B2&B1&!B&A2&A1&!A|!D&!C1&!C&!B2&B1&B&A2&A1&!A|!D&C1&!C&!B2&B1&B&A2&A1&!A|!D&!C1&C&!B2&B1&B&A2&A1&!A|!D&!C1&!C&B2&!B1&B&A2&A1&!A|!D&C1&!C&B2&!B1&B&A2&A1&!A|!D&!C1&C&B2&!B1&B&A2&A1&!A|!D&!C1&C&!B2&!B1&B&A2&A1&!A|!D&C1&!C&!B2&!B1&B&A2&A1&!A|!D&!C1&!C&!B2&!B1&B&A2&A1&!A|!D&!C1&!C&!B2&!B1&B&!A2&A1&!A|!D&C1&!C&!B2&!B1&B&!A2&A1&!A|!D&!C1&C&!B2&!B1&B&!A2&A1&!A|!D&!C1&C&B2&!B1&B&!A2&A1&!A|!D&C1&!C&B2&!B1&B&!A2&A1&!A|!D&!C1&!C&B2&!B1&B&!A2&A1&!A|!D&!C1&C&!B2&B1&B&!A2&A1&!A|!D&C1&!C&!B2&B1&B&!A2&A1&!A|!D&!C1&!C&!B2&B1&B&!A2&A1&!A|!D&!C1&!C&!B2&B1&!B&!A2&A1&!A|!D&C1&!C&!B2&B1&!B&!A2&A1&!A|!D&!C1&C&!B2&B1&!B&!A2&A1&!A|!D&!C1&C&B2&B1&!B&!A2&A1&!A|!D&C1&!C&B2&B1&!B&!A2&A1&!A|!D&!C1&!C&B2&B1&!B&!A2&A1&!A|!D&!C1&!C&B2&!B1&!B&!A2&A1&!A|!D&C1&!C&B2&!B1&!B&!A2&A1&!A|!D&!C1&C&B2&!B1&!B&!A2&A1&!A|!D&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D&C1&!C&!B2&!B1&!B&!A2&A1&!A|!D&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!D&!C1&!C&!B2&!B1&!B&!A2&A1&A|!D&C1&!C&!B2&!B1&!B&!A2&A1&A|!D&!C1&C&!B2&!B1&!B&!A2&A1&A|!D&!C1&C&B2&!B1&!B&!A2&A1&A|!D&C1&!C&B2&!B1&!B&!A2&A1&A|!D&!C1&!C&B2&!B1&!B&!A2&A1&A|!D&!C1&!C&B2&B1&!B&!A2&A1&A|!D&C1&!C&B2&B1&!B&!A2&A1&A|!D&!C1&C&B2&B1&!B&!A2&A1&A|!D&!C1&C&!B2&B1&!B&!A2&A1&A|!D&C1&!C&!B2&B1&!B&!A2&A1&A|!D&!C1&!C&!B2&B1&!B&!A2&A1&A|!D&!C1&!C&!B2&B1&B&!A2&A1&A|!D&C1&!C&!B2&B1&B&!A2&A1&A|!D&!C1&C&!B2&B1&B&!A2&A1&A|!D&!C1&!C&B2&!B1&B&!A2&A1&A|!D&C1&!C&B2&!B1&B&!A2&A1&A|!D&!C1&C&B2&!B1&B&!A2&A1&A|!D&!C1&C&!B2&!B1&B&!A2&A1&A|!D&C1&!C&!B2&!B1&B&!A2&A1&A|!D&!C1&!C&!B2&!B1&B&!A2&A1&A|!D&!C1&!C&!B2&!B1&!B&A2&!A1&A|!D&C1&!C&!B2&!B1&!B&A2&!A1&A|!D&!C1&C&!B2&!B1&!B&A2&!A1&A|!D&!C1&C&B2&!B1&!B&A2&!A1&A|!D&C1&!C&B2&!B1&!B&A2&!A1&A|!D&!C1&!C&B2&!B1&!B&A2&!A1&A|!D&!C1&!C&B2&B1&!B&A2&!A1&A|!D&C1&!C&B2&B1&!B&A2&!A1&A|!D&!C1&C&B2&B1&!B&A2&!A1&A|!D&!C1&C&!B2&B1&!B&A2&!A1&A|!D&C1&!C&!B2&B1&!B&A2&!A1&A|!D&!C1&!C&!B2&B1&!B&A2&!A1&A|!D&!C1&!C&!B2&B1&B&A2&!A1&A|!D&C1&!C&!B2&B1&B&A2&!A1&A|!D&!C1&C&!B2&B1&B&A2&!A1&A|!D&!C1&!C&B2&!B1&B&A2&!A1&A|!D&C1&!C&B2&!B1&B&A2&!A1&A|!D&!C1&C&B2&!B1&B&A2&!A1&A|!D&!C1&C&!B2&!B1&B&A2&!A1&A|!D&C1&!C&!B2&!B1&B&A2&!A1&A|!D&!C1&!C&!B2&!B1&B&A2&!A1&A|!D&!C1&!C&!B2&!B1&B&!A2&!A1&A|!D&C1&!C&!B2&!B1&B&!A2&!A1&A|!D&!C1&C&!B2&!B1&B&!A2&!A1&A|!D&!C1&C&B2&!B1&B&!A2&!A1&A|!D&C1&!C&B2&!B1&B&!A2&!A1&A|!D&!C1&!C&B2&!B1&B&!A2&!A1&A|!D&!C1&C&!B2&B1&B&!A2&!A1&A|!D&C1&!C&!B2&B1&B&!A2&!A1&A|!D&!C1&!C&!B2&B1&B&!A2&!A1&A|!D&!C1&!C&!B2&B1&!B&!A2&!A1&A|!D&C1&!C&!B2&B1&!B&!A2&!A1&A|!D&!C1&C&!B2&B1&!B&!A2&!A1&A|!D&!C1&C&B2&B1&!B&!A2&!A1&A|!D&C1&!C&B2&B1&!B&!A2&!A1&A|!D&!C1&!C&B2&B1&!B&!A2&!A1&A|!D&!C1&!C&B2&!B1&!B&!A2&!A1&A|!D&C1&!C&B2&!B1&!B&!A2&!A1&A|!D&!C1&C&B2&!B1&!B&!A2&!A1&A|!D&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D&C1&!C&!B2&!B1&!B&!A2&!A1&A|!D&!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOI3321.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAI332 -l AAOOAI332 -i C1 C B2 B1 B A2 A1 A -o Y -f Y=!(!C1&C&B2&B1&B&!A2&!A1&!A|C1&C&B2&B1&B&!A2&!A1&!A|C1&!C&B2&B1&B&!A2&!A1&!A|C1&!C&B2&B1&B&A2&!A1&!A|C1&C&B2&B1&B&A2&!A1&!A|!C1&C&B2&B1&B&A2&!A1&!A|!C1&C&B2&B1&B&A2&A1&!A|C1&C&B2&B1&B&A2&A1&!A|C1&!C&B2&B1&B&A2&A1&!A|C1&!C&B2&B1&B&!A2&A1&!A|C1&C&B2&B1&B&!A2&A1&!A|!C1&C&B2&B1&B&!A2&A1&!A|!C1&C&B2&B1&B&!A2&A1&A|C1&C&B2&B1&B&!A2&A1&A|C1&!C&B2&B1&B&!A2&A1&A|C1&!C&!B2&!B1&B&A2&A1&A|C1&C&!B2&!B1&B&A2&A1&A|!C1&C&!B2&!B1&B&A2&A1&A|!C1&C&B2&!B1&B&A2&A1&A|C1&C&B2&!B1&B&A2&A1&A|C1&!C&B2&!B1&B&A2&A1&A|C1&!C&B2&B1&B&A2&A1&A|C1&C&B2&B1&B&A2&A1&A|!C1&C&B2&B1&B&A2&A1&A|!C1&C&!B2&B1&B&A2&A1&A|C1&C&!B2&B1&B&A2&A1&A|C1&!C&!B2&B1&B&A2&A1&A|C1&!C&!B2&B1&!B&A2&A1&A|C1&C&!B2&B1&!B&A2&A1&A|!C1&C&!B2&B1&!B&A2&A1&A|!C1&C&B2&B1&!B&A2&A1&A|C1&C&B2&B1&!B&A2&A1&A|C1&!C&B2&B1&!B&A2&A1&A|C1&!C&B2&!B1&!B&A2&A1&A|C1&C&B2&!B1&!B&A2&A1&A|!C1&C&B2&!B1&!B&A2&A1&A|!C1&C&!B2&!B1&!B&A2&A1&A|C1&C&!B2&!B1&!B&A2&A1&A|C1&!C&!B2&!B1&!B&A2&A1&A|!C1&C&B2&B1&B&A2&!A1&A|C1&C&B2&B1&B&A2&!A1&A|C1&!C&B2&B1&B&A2&!A1&A|C1&!C&B2&B1&B&!A2&!A1&A|C1&C&B2&B1&B&!A2&!A1&A|!C1&C&B2&B1&B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAI332.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAAOI22221 -l AAOOAAOI22221 -i E D1 D C1 C B1 B A1 A -o Y -f Y=(!E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&D1&!D&C1&C&!B1&!B&!A1&!A|!E&!D1&D&C1&C&!B1&!B&!A1&!A|!E&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&D1&!D&!C1&C&B1&!B&!A1&!A|!E&!D1&D&!C1&C&B1&!B&!A1&!A|!E&!D1&D&C1&C&B1&!B&!A1&!A|!E&D1&!D&C1&C&B1&!B&!A1&!A|!E&!D1&!D&C1&C&B1&!B&!A1&!A|!E&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&D1&!D&C1&!C&B1&!B&!A1&!A|!E&!D1&D&C1&!C&B1&!B&!A1&!A|!E&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&D1&!D&!C1&!C&B1&B&!A1&!A|!E&!D1&D&!C1&!C&B1&B&!A1&!A|!E&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&D1&!D&!C1&C&!B1&B&!A1&!A|!E&!D1&D&!C1&C&!B1&B&!A1&!A|!E&!D1&D&C1&C&!B1&B&!A1&!A|!E&D1&!D&C1&C&!B1&B&!A1&!A|!E&!D1&!D&C1&C&!B1&B&!A1&!A|!E&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&D1&!D&C1&!C&!B1&B&!A1&!A|!E&!D1&D&C1&!C&!B1&B&!A1&!A|!E&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&D1&!D&!C1&!C&!B1&B&A1&!A|!E&!D1&D&!C1&!C&!B1&B&A1&!A|!E&!D1&D&C1&!C&!B1&B&A1&!A|!E&D1&!D&C1&!C&!B1&B&A1&!A|!E&!D1&!D&C1&!C&!B1&B&A1&!A|!E&!D1&!D&C1&C&!B1&B&A1&!A|!E&D1&!D&C1&C&!B1&B&A1&!A|!E&!D1&D&C1&C&!B1&B&A1&!A|!E&!D1&D&!C1&C&!B1&B&A1&!A|!E&D1&!D&!C1&C&!B1&B&A1&!A|!E&!D1&!D&!C1&C&!B1&B&A1&!A|!E&!D1&D&!C1&!C&B1&B&A1&!A|!E&D1&!D&!C1&!C&B1&B&A1&!A|!E&!D1&!D&!C1&!C&B1&B&A1&!A|!E&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&D1&!D&!C1&!C&B1&!B&A1&!A|!E&!D1&D&!C1&!C&B1&!B&A1&!A|!E&!D1&D&C1&!C&B1&!B&A1&!A|!E&D1&!D&C1&!C&B1&!B&A1&!A|!E&!D1&!D&C1&!C&B1&!B&A1&!A|!E&!D1&!D&C1&C&B1&!B&A1&!A|!E&D1&!D&C1&C&B1&!B&A1&!A|!E&!D1&D&C1&C&B1&!B&A1&!A|!E&!D1&D&!C1&C&B1&!B&A1&!A|!E&D1&!D&!C1&C&B1&!B&A1&!A|!E&!D1&!D&!C1&C&B1&!B&A1&!A|!E&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&D1&!D&!C1&C&!B1&!B&A1&!A|!E&!D1&D&!C1&C&!B1&!B&A1&!A|!E&!D1&D&C1&C&!B1&!B&A1&!A|!E&D1&!D&C1&C&!B1&!B&A1&!A|!E&!D1&!D&C1&C&!B1&!B&A1&!A|!E&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&D1&!D&C1&!C&!B1&!B&A1&!A|!E&!D1&D&C1&!C&!B1&!B&A1&!A|!E&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&D1&!D&!C1&!C&!B1&!B&A1&A|!E&!D1&D&!C1&!C&!B1&!B&A1&A|!E&!D1&D&!C1&!C&B1&!B&A1&A|!E&D1&!D&!C1&!C&B1&!B&A1&A|!E&!D1&!D&!C1&!C&B1&!B&A1&A|!E&!D1&!D&!C1&!C&B1&B&A1&A|!E&D1&!D&!C1&!C&B1&B&A1&A|!E&!D1&D&!C1&!C&B1&B&A1&A|!E&!D1&D&!C1&!C&!B1&B&A1&A|!E&D1&!D&!C1&!C&!B1&B&A1&A|!E&!D1&!D&!C1&!C&!B1&B&A1&A|!E&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&D1&!D&!C1&!C&!B1&B&!A1&A|!E&!D1&D&!C1&!C&!B1&B&!A1&A|!E&!D1&D&C1&!C&!B1&B&!A1&A|!E&D1&!D&C1&!C&!B1&B&!A1&A|!E&!D1&!D&C1&!C&!B1&B&!A1&A|!E&!D1&!D&C1&C&!B1&B&!A1&A|!E&D1&!D&C1&C&!B1&B&!A1&A|!E&!D1&D&C1&C&!B1&B&!A1&A|!E&!D1&D&!C1&C&!B1&B&!A1&A|!E&D1&!D&!C1&C&!B1&B&!A1&A|!E&!D1&!D&!C1&C&!B1&B&!A1&A|!E&!D1&D&!C1&!C&B1&B&!A1&A|!E&D1&!D&!C1&!C&B1&B&!A1&A|!E&!D1&!D&!C1&!C&B1&B&!A1&A|!E&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&D1&!D&!C1&!C&B1&!B&!A1&A|!E&!D1&D&!C1&!C&B1&!B&!A1&A|!E&!D1&D&C1&!C&B1&!B&!A1&A|!E&D1&!D&C1&!C&B1&!B&!A1&A|!E&!D1&!D&C1&!C&B1&!B&!A1&A|!E&!D1&!D&C1&C&B1&!B&!A1&A|!E&D1&!D&C1&C&B1&!B&!A1&A|!E&!D1&D&C1&C&B1&!B&!A1&A|!E&!D1&D&!C1&C&B1&!B&!A1&A|!E&D1&!D&!C1&C&B1&!B&!A1&A|!E&!D1&!D&!C1&C&B1&!B&!A1&A|!E&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&D1&!D&!C1&C&!B1&!B&!A1&A|!E&!D1&D&!C1&C&!B1&!B&!A1&A|!E&!D1&D&C1&C&!B1&!B&!A1&A|!E&D1&!D&C1&C&!B1&!B&!A1&A|!E&!D1&!D&C1&C&!B1&!B&!A1&A|!E&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&D1&!D&C1&!C&!B1&!B&!A1&A|!E&!D1&D&C1&!C&!B1&!B&!A1&A|!E&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAAOI22221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOAI22311 -l OAAOAI22311 -i E D C2 C1 C B1 B A1 A -o Y -f Y=!(E&D&!C2&!C1&!C&!B1&!B&!A1&!A|E&D&C2&!C1&!C&!B1&!B&!A1&!A|E&D&C2&C1&!C&!B1&!B&!A1&!A|E&D&!C2&C1&!C&!B1&!B&!A1&!A|E&D&!C2&C1&C&!B1&!B&!A1&!A|E&D&C2&C1&C&!B1&!B&!A1&!A|E&!D&C2&C1&C&!B1&!B&!A1&!A|E&D&C2&!C1&C&!B1&!B&!A1&!A|E&D&!C2&!C1&C&!B1&!B&!A1&!A|E&D&!C2&!C1&C&B1&!B&!A1&!A|E&D&C2&!C1&C&B1&!B&!A1&!A|E&!D&C2&C1&C&B1&!B&!A1&!A|E&D&C2&C1&C&B1&!B&!A1&!A|E&D&!C2&C1&C&B1&!B&!A1&!A|E&D&!C2&C1&!C&B1&!B&!A1&!A|E&D&C2&C1&!C&B1&!B&!A1&!A|E&D&C2&!C1&!C&B1&!B&!A1&!A|E&D&!C2&!C1&!C&B1&!B&!A1&!A|E&D&!C2&!C1&!C&B1&B&!A1&!A|E&D&C2&!C1&!C&B1&B&!A1&!A|E&D&C2&C1&!C&B1&B&!A1&!A|E&D&!C2&C1&!C&B1&B&!A1&!A|E&D&!C2&C1&C&B1&B&!A1&!A|E&D&C2&C1&C&B1&B&!A1&!A|E&!D&C2&C1&C&B1&B&!A1&!A|E&D&C2&!C1&C&B1&B&!A1&!A|E&D&!C2&!C1&C&B1&B&!A1&!A|E&D&!C2&!C1&C&!B1&B&!A1&!A|E&D&C2&!C1&C&!B1&B&!A1&!A|E&!D&C2&C1&C&!B1&B&!A1&!A|E&D&C2&C1&C&!B1&B&!A1&!A|E&D&!C2&C1&C&!B1&B&!A1&!A|E&D&!C2&C1&!C&!B1&B&!A1&!A|E&D&C2&C1&!C&!B1&B&!A1&!A|E&D&C2&!C1&!C&!B1&B&!A1&!A|E&D&!C2&!C1&!C&!B1&B&!A1&!A|E&D&!C2&!C1&!C&!B1&B&A1&!A|E&D&C2&!C1&!C&!B1&B&A1&!A|E&D&C2&C1&!C&!B1&B&A1&!A|E&D&!C2&C1&!C&!B1&B&A1&!A|E&D&!C2&C1&C&!B1&B&A1&!A|E&D&C2&C1&C&!B1&B&A1&!A|E&!D&C2&C1&C&!B1&B&A1&!A|E&D&C2&!C1&C&!B1&B&A1&!A|E&D&!C2&!C1&C&!B1&B&A1&!A|E&!D&!C2&!C1&C&B1&B&A1&!A|E&D&!C2&!C1&C&B1&B&A1&!A|E&D&C2&!C1&C&B1&B&A1&!A|E&!D&C2&!C1&C&B1&B&A1&!A|E&!D&C2&C1&C&B1&B&A1&!A|E&D&C2&C1&C&B1&B&A1&!A|E&D&!C2&C1&C&B1&B&A1&!A|E&!D&!C2&C1&C&B1&B&A1&!A|E&!D&!C2&C1&!C&B1&B&A1&!A|E&D&!C2&C1&!C&B1&B&A1&!A|E&D&C2&C1&!C&B1&B&A1&!A|E&!D&C2&C1&!C&B1&B&A1&!A|E&!D&C2&!C1&!C&B1&B&A1&!A|E&D&C2&!C1&!C&B1&B&A1&!A|E&D&!C2&!C1&!C&B1&B&A1&!A|E&!D&!C2&!C1&!C&B1&B&A1&!A|E&D&!C2&!C1&!C&B1&!B&A1&!A|E&D&C2&!C1&!C&B1&!B&A1&!A|E&D&C2&C1&!C&B1&!B&A1&!A|E&D&!C2&C1&!C&B1&!B&A1&!A|E&D&!C2&C1&C&B1&!B&A1&!A|E&D&C2&C1&C&B1&!B&A1&!A|E&!D&C2&C1&C&B1&!B&A1&!A|E&D&C2&!C1&C&B1&!B&A1&!A|E&D&!C2&!C1&C&B1&!B&A1&!A|E&D&!C2&!C1&C&!B1&!B&A1&!A|E&D&C2&!C1&C&!B1&!B&A1&!A|E&!D&C2&C1&C&!B1&!B&A1&!A|E&D&C2&C1&C&!B1&!B&A1&!A|E&D&!C2&C1&C&!B1&!B&A1&!A|E&D&!C2&C1&!C&!B1&!B&A1&!A|E&D&C2&C1&!C&!B1&!B&A1&!A|E&D&C2&!C1&!C&!B1&!B&A1&!A|E&D&!C2&!C1&!C&!B1&!B&A1&!A|E&D&!C2&!C1&!C&!B1&!B&A1&A|E&D&C2&!C1&!C&!B1&!B&A1&A|E&D&C2&C1&!C&!B1&!B&A1&A|E&D&!C2&C1&!C&!B1&!B&A1&A|E&D&!C2&C1&C&!B1&!B&A1&A|E&D&C2&C1&C&!B1&!B&A1&A|E&!D&C2&C1&C&!B1&!B&A1&A|E&D&C2&!C1&C&!B1&!B&A1&A|E&D&!C2&!C1&C&!B1&!B&A1&A|E&D&!C2&!C1&C&B1&!B&A1&A|E&D&C2&!C1&C&B1&!B&A1&A|E&!D&C2&C1&C&B1&!B&A1&A|E&D&C2&C1&C&B1&!B&A1&A|E&D&!C2&C1&C&B1&!B&A1&A|E&D&!C2&C1&!C&B1&!B&A1&A|E&D&C2&C1&!C&B1&!B&A1&A|E&D&C2&!C1&!C&B1&!B&A1&A|E&D&!C2&!C1&!C&B1&!B&A1&A|E&!D&!C2&!C1&!C&B1&B&A1&A|E&D&!C2&!C1&!C&B1&B&A1&A|E&D&C2&!C1&!C&B1&B&A1&A|E&!D&C2&!C1&!C&B1&B&A1&A|E&!D&C2&C1&!C&B1&B&A1&A|E&D&C2&C1&!C&B1&B&A1&A|E&D&!C2&C1&!C&B1&B&A1&A|E&!D&!C2&C1&!C&B1&B&A1&A|E&!D&!C2&C1&C&B1&B&A1&A|E&D&!C2&C1&C&B1&B&A1&A|E&D&C2&C1&C&B1&B&A1&A|E&!D&C2&C1&C&B1&B&A1&A|E&!D&C2&!C1&C&B1&B&A1&A|E&D&C2&!C1&C&B1&B&A1&A|E&D&!C2&!C1&C&B1&B&A1&A|E&!D&!C2&!C1&C&B1&B&A1&A|E&D&!C2&!C1&C&!B1&B&A1&A|E&D&C2&!C1&C&!B1&B&A1&A|E&!D&C2&C1&C&!B1&B&A1&A|E&D&C2&C1&C&!B1&B&A1&A|E&D&!C2&C1&C&!B1&B&A1&A|E&D&!C2&C1&!C&!B1&B&A1&A|E&D&C2&C1&!C&!B1&B&A1&A|E&D&C2&!C1&!C&!B1&B&A1&A|E&D&!C2&!C1&!C&!B1&B&A1&A|E&D&!C2&!C1&!C&!B1&B&!A1&A|E&D&C2&!C1&!C&!B1&B&!A1&A|E&D&C2&C1&!C&!B1&B&!A1&A|E&D&!C2&C1&!C&!B1&B&!A1&A|E&D&!C2&C1&C&!B1&B&!A1&A|E&D&C2&C1&C&!B1&B&!A1&A|E&!D&C2&C1&C&!B1&B&!A1&A|E&D&C2&!C1&C&!B1&B&!A1&A|E&D&!C2&!C1&C&!B1&B&!A1&A|E&!D&!C2&!C1&C&B1&B&!A1&A|E&D&!C2&!C1&C&B1&B&!A1&A|E&D&C2&!C1&C&B1&B&!A1&A|E&!D&C2&!C1&C&B1&B&!A1&A|E&!D&C2&C1&C&B1&B&!A1&A|E&D&C2&C1&C&B1&B&!A1&A|E&D&!C2&C1&C&B1&B&!A1&A|E&!D&!C2&C1&C&B1&B&!A1&A|E&!D&!C2&C1&!C&B1&B&!A1&A|E&D&!C2&C1&!C&B1&B&!A1&A|E&D&C2&C1&!C&B1&B&!A1&A|E&!D&C2&C1&!C&B1&B&!A1&A|E&!D&C2&!C1&!C&B1&B&!A1&A|E&D&C2&!C1&!C&B1&B&!A1&A|E&D&!C2&!C1&!C&B1&B&!A1&A|E&!D&!C2&!C1&!C&B1&B&!A1&A|E&D&!C2&!C1&!C&B1&!B&!A1&A|E&D&C2&!C1&!C&B1&!B&!A1&A|E&D&C2&C1&!C&B1&!B&!A1&A|E&D&!C2&C1&!C&B1&!B&!A1&A|E&D&!C2&C1&C&B1&!B&!A1&A|E&D&C2&C1&C&B1&!B&!A1&A|E&!D&C2&C1&C&B1&!B&!A1&A|E&D&C2&!C1&C&B1&!B&!A1&A|E&D&!C2&!C1&C&B1&!B&!A1&A|E&D&!C2&!C1&C&!B1&!B&!A1&A|E&D&C2&!C1&C&!B1&!B&!A1&A|E&!D&C2&C1&C&!B1&!B&!A1&A|E&D&C2&C1&C&!B1&!B&!A1&A|E&D&!C2&C1&C&!B1&!B&!A1&A|E&D&!C2&C1&!C&!B1&!B&!A1&A|E&D&C2&C1&!C&!B1&!B&!A1&A|E&D&C2&!C1&!C&!B1&!B&!A1&A|E&D&!C2&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOAI22311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOAOI33311 -l AAAOAOI33311 -i E D C2 C1 C B2 B1 B A2 A1 A -o Y -f Y=(!E&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|!E&D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|!E&D&C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|!E&!D&C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|!E&!D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!E&D&!C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!E&!D&!C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!E&!D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&D&C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&!D&C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&!D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&!D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&!D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|!E&D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|!E&D&C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|!E&!D&C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|!E&!D&C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!E&D&C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!E&D&!C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!E&!D&!C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!E&!D&!C2&C1&C&B2&B1&!B&!A2&!A1&!A|!E&D&!C2&C1&C&B2&B1&!B&!A2&!A1&!A|!E&!D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|!E&!D&C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!E&D&C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!E&D&!C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!E&!D&!C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!E&!D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|!E&D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|!E&D&C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|!E&!D&C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|!E&!D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!E&D&!C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!E&!D&!C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!E&!D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&D&C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&!D&C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&!D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&!D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&!D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|!E&D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|!E&D&C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|!E&!D&C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|!E&!D&C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!E&D&C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!E&D&!C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!E&!D&!C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!E&!D&!C2&C1&C&!B2&B1&B&!A2&!A1&!A|!E&D&!C2&C1&C&!B2&B1&B&!A2&!A1&!A|!E&!D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|!E&!D&C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!E&D&C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!E&D&!C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!E&!D&!C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!E&!D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|!E&!D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|!E&!D&C2&C1&C&B2&B1&B&!A2&!A1&!A|!E&!D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|!E&!D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|!E&!D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|!E&!D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!E&!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!E&!D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|!E&D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|!E&D&C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|!E&!D&C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|!E&!D&C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!E&D&C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!E&D&!C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!E&!D&!C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!E&!D&!C2&C1&C&B2&!B1&B&!A2&!A1&!A|!E&D&!C2&C1&C&B2&!B1&B&!A2&!A1&!A|!E&!D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|!E&!D&C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!E&D&C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!E&D&!C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!E&!D&!C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!E&!D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|!E&D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|!E&D&C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|!E&!D&C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|!E&!D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!E&D&!C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!E&!D&!C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!E&!D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&D&C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&!D&C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&!D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&!D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&!D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|!E&D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|!E&D&C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|!E&!D&C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|!E&!D&C2&C1&!C&!B2&!B1&B&A2&!A1&!A|!E&D&C2&C1&!C&!B2&!B1&B&A2&!A1&!A|!E&D&!C2&C1&!C&!B2&!B1&B&A2&!A1&!A|!E&!D&!C2&C1&!C&!B2&!B1&B&A2&!A1&!A|!E&!D&!C2&C1&C&!B2&!B1&B&A2&!A1&!A|!E&D&!C2&C1&C&!B2&!B1&B&A2&!A1&!A|!E&!D&C2&C1&C&!B2&!B1&B&A2&!A1&!A|!E&!D&C2&!C1&C&!B2&!B1&B&A2&!A1&!A|!E&D&C2&!C1&C&!B2&!B1&B&A2&!A1&!A|!E&D&!C2&!C1&C&!B2&!B1&B&A2&!A1&!A|!E&!D&!C2&!C1&C&!B2&!B1&B&A2&!A1&!A|!E&!D&!C2&!C1&C&B2&!B1&B&A2&!A1&!A|!E&D&!C2&!C1&C&B2&!B1&B&A2&!A1&!A|!E&D&C2&!C1&C&B2&!B1&B&A2&!A1&!A|!E&!D&C2&!C1&C&B2&!B1&B&A2&!A1&!A|!E&!D&C2&C1&C&B2&!B1&B&A2&!A1&!A|!E&D&!C2&C1&C&B2&!B1&B&A2&!A1&!A|!E&!D&!C2&C1&C&B2&!B1&B&A2&!A1&!A|!E&!D&!C2&C1&!C&B2&!B1&B&A2&!A1&!A|!E&D&!C2&C1&!C&B2&!B1&B&A2&!A1&!A|!E&D&C2&C1&!C&B2&!B1&B&A2&!A1&!A|!E&!D&C2&C1&!C&B2&!B1&B&A2&!A1&!A|!E&!D&C2&!C1&!C&B2&!B1&B&A2&!A1&!A|!E&D&C2&!C1&!C&B2&!B1&B&A2&!A1&!A|!E&D&!C2&!C1&!C&B2&!B1&B&A2&!A1&!A|!E&!D&!C2&!C1&!C&B2&!B1&B&A2&!A1&!A|!E&!D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|!E&!D&C2&!C1&!C&B2&B1&B&A2&!A1&!A|!E&!D&C2&C1&!C&B2&B1&B&A2&!A1&!A|!E&!D&!C2&C1&!C&B2&B1&B&A2&!A1&!A|!E&!D&!C2&C1&C&B2&B1&B&A2&!A1&!A|!E&!D&C2&C1&C&B2&B1&B&A2&!A1&!A|!E&!D&C2&!C1&C&B2&B1&B&A2&!A1&!A|!E&!D&!C2&!C1&C&B2&B1&B&A2&!A1&!A|!E&!D&!C2&!C1&C&!B2&B1&B&A2&!A1&!A|!E&D&!C2&!C1&C&!B2&B1&B&A2&!A1&!A|!E&D&C2&!C1&C&!B2&B1&B&A2&!A1&!A|!E&!D&C2&!C1&C&!B2&B1&B&A2&!A1&!A|!E&!D&C2&C1&C&!B2&B1&B&A2&!A1&!A|!E&D&!C2&C1&C&!B2&B1&B&A2&!A1&!A|!E&!D&!C2&C1&C&!B2&B1&B&A2&!A1&!A|!E&!D&!C2&C1&!C&!B2&B1&B&A2&!A1&!A|!E&D&!C2&C1&!C&!B2&B1&B&A2&!A1&!A|!E&D&C2&C1&!C&!B2&B1&B&A2&!A1&!A|!E&!D&C2&C1&!C&!B2&B1&B&A2&!A1&!A|!E&!D&C2&!C1&!C&!B2&B1&B&A2&!A1&!A|!E&D&C2&!C1&!C&!B2&B1&B&A2&!A1&!A|!E&D&!C2&!C1&!C&!B2&B1&B&A2&!A1&!A|!E&!D&!C2&!C1&!C&!B2&B1&B&A2&!A1&!A|!E&!D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|!E&D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|!E&D&C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|!E&!D&C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|!E&!D&C2&C1&!C&!B2&B1&!B&A2&!A1&!A|!E&D&C2&C1&!C&!B2&B1&!B&A2&!A1&!A|!E&D&!C2&C1&!C&!B2&B1&!B&A2&!A1&!A|!E&!D&!C2&C1&!C&!B2&B1&!B&A2&!A1&!A|!E&!D&!C2&C1&C&!B2&B1&!B&A2&!A1&!A|!E&D&!C2&C1&C&!B2&B1&!B&A2&!A1&!A|!E&!D&C2&C1&C&!B2&B1&!B&A2&!A1&!A|!E&!D&C2&!C1&C&!B2&B1&!B&A2&!A1&!A|!E&D&C2&!C1&C&!B2&B1&!B&A2&!A1&!A|!E&D&!C2&!C1&C&!B2&B1&!B&A2&!A1&!A|!E&!D&!C2&!C1&C&!B2&B1&!B&A2&!A1&!A|!E&!D&!C2&!C1&C&B2&B1&!B&A2&!A1&!A|!E&D&!C2&!C1&C&B2&B1&!B&A2&!A1&!A|!E&D&C2&!C1&C&B2&B1&!B&A2&!A1&!A|!E&!D&C2&!C1&C&B2&B1&!B&A2&!A1&!A|!E&!D&C2&C1&C&B2&B1&!B&A2&!A1&!A|!E&D&!C2&C1&C&B2&B1&!B&A2&!A1&!A|!E&!D&!C2&C1&C&B2&B1&!B&A2&!A1&!A|!E&!D&!C2&C1&!C&B2&B1&!B&A2&!A1&!A|!E&D&!C2&C1&!C&B2&B1&!B&A2&!A1&!A|!E&D&C2&C1&!C&B2&B1&!B&A2&!A1&!A|!E&!D&C2&C1&!C&B2&B1&!B&A2&!A1&!A|!E&!D&C2&!C1&!C&B2&B1&!B&A2&!A1&!A|!E&D&C2&!C1&!C&B2&B1&!B&A2&!A1&!A|!E&D&!C2&!C1&!C&B2&B1&!B&A2&!A1&!A|!E&!D&!C2&!C1&!C&B2&B1&!B&A2&!A1&!A|!E&!D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|!E&D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|!E&D&C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|!E&!D&C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|!E&!D&C2&C1&!C&B2&!B1&!B&A2&!A1&!A|!E&D&C2&C1&!C&B2&!B1&!B&A2&!A1&!A|!E&D&!C2&C1&!C&B2&!B1&!B&A2&!A1&!A|!E&!D&!C2&C1&!C&B2&!B1&!B&A2&!A1&!A|!E&!D&!C2&C1&C&B2&!B1&!B&A2&!A1&!A|!E&D&!C2&C1&C&B2&!B1&!B&A2&!A1&!A|!E&!D&C2&C1&C&B2&!B1&!B&A2&!A1&!A|!E&!D&C2&!C1&C&B2&!B1&!B&A2&!A1&!A|!E&D&C2&!C1&C&B2&!B1&!B&A2&!A1&!A|!E&D&!C2&!C1&C&B2&!B1&!B&A2&!A1&!A|!E&!D&!C2&!C1&C&B2&!B1&!B&A2&!A1&!A|!E&!D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|!E&D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|!E&D&C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|!E&!D&C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|!E&!D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!E&D&!C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!E&!D&!C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!E&!D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&D&C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&!D&C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&!D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&!D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&!D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|!E&D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|!E&D&C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|!E&!D&C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|!E&!D&C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!E&D&C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!E&D&!C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!E&!D&!C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!E&!D&!C2&C1&C&!B2&!B1&!B&A2&A1&!A|!E&D&!C2&C1&C&!B2&!B1&!B&A2&A1&!A|!E&!D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|!E&!D&C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!E&D&C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!E&D&!C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!E&!D&!C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!E&!D&!C2&!C1&C&B2&!B1&!B&A2&A1&!A|!E&D&!C2&!C1&C&B2&!B1&!B&A2&A1&!A|!E&D&C2&!C1&C&B2&!B1&!B&A2&A1&!A|!E&!D&C2&!C1&C&B2&!B1&!B&A2&A1&!A|!E&!D&C2&C1&C&B2&!B1&!B&A2&A1&!A|!E&D&!C2&C1&C&B2&!B1&!B&A2&A1&!A|!E&!D&!C2&C1&C&B2&!B1&!B&A2&A1&!A|!E&!D&!C2&C1&!C&B2&!B1&!B&A2&A1&!A|!E&D&!C2&C1&!C&B2&!B1&!B&A2&A1&!A|!E&D&C2&C1&!C&B2&!B1&!B&A2&A1&!A|!E&!D&C2&C1&!C&B2&!B1&!B&A2&A1&!A|!E&!D&C2&!C1&!C&B2&!B1&!B&A2&A1&!A|!E&D&C2&!C1&!C&B2&!B1&!B&A2&A1&!A|!E&D&!C2&!C1&!C&B2&!B1&!B&A2&A1&!A|!E&!D&!C2&!C1&!C&B2&!B1&!B&A2&A1&!A|!E&!D&!C2&!C1&!C&B2&B1&!B&A2&A1&!A|!E&D&!C2&!C1&!C&B2&B1&!B&A2&A1&!A|!E&D&C2&!C1&!C&B2&B1&!B&A2&A1&!A|!E&!D&C2&!C1&!C&B2&B1&!B&A2&A1&!A|!E&!D&C2&C1&!C&B2&B1&!B&A2&A1&!A|!E&D&C2&C1&!C&B2&B1&!B&A2&A1&!A|!E&D&!C2&C1&!C&B2&B1&!B&A2&A1&!A|!E&!D&!C2&C1&!C&B2&B1&!B&A2&A1&!A|!E&!D&!C2&C1&C&B2&B1&!B&A2&A1&!A|!E&D&!C2&C1&C&B2&B1&!B&A2&A1&!A|!E&!D&C2&C1&C&B2&B1&!B&A2&A1&!A|!E&!D&C2&!C1&C&B2&B1&!B&A2&A1&!A|!E&D&C2&!C1&C&B2&B1&!B&A2&A1&!A|!E&D&!C2&!C1&C&B2&B1&!B&A2&A1&!A|!E&!D&!C2&!C1&C&B2&B1&!B&A2&A1&!A|!E&!D&!C2&!C1&C&!B2&B1&!B&A2&A1&!A|!E&D&!C2&!C1&C&!B2&B1&!B&A2&A1&!A|!E&D&C2&!C1&C&!B2&B1&!B&A2&A1&!A|!E&!D&C2&!C1&C&!B2&B1&!B&A2&A1&!A|!E&!D&C2&C1&C&!B2&B1&!B&A2&A1&!A|!E&D&!C2&C1&C&!B2&B1&!B&A2&A1&!A|!E&!D&!C2&C1&C&!B2&B1&!B&A2&A1&!A|!E&!D&!C2&C1&!C&!B2&B1&!B&A2&A1&!A|!E&D&!C2&C1&!C&!B2&B1&!B&A2&A1&!A|!E&D&C2&C1&!C&!B2&B1&!B&A2&A1&!A|!E&!D&C2&C1&!C&!B2&B1&!B&A2&A1&!A|!E&!D&C2&!C1&!C&!B2&B1&!B&A2&A1&!A|!E&D&C2&!C1&!C&!B2&B1&!B&A2&A1&!A|!E&D&!C2&!C1&!C&!B2&B1&!B&A2&A1&!A|!E&!D&!C2&!C1&!C&!B2&B1&!B&A2&A1&!A|!E&!D&!C2&!C1&!C&!B2&B1&B&A2&A1&!A|!E&D&!C2&!C1&!C&!B2&B1&B&A2&A1&!A|!E&D&C2&!C1&!C&!B2&B1&B&A2&A1&!A|!E&!D&C2&!C1&!C&!B2&B1&B&A2&A1&!A|!E&!D&C2&C1&!C&!B2&B1&B&A2&A1&!A|!E&D&C2&C1&!C&!B2&B1&B&A2&A1&!A|!E&D&!C2&C1&!C&!B2&B1&B&A2&A1&!A|!E&!D&!C2&C1&!C&!B2&B1&B&A2&A1&!A|!E&!D&!C2&C1&C&!B2&B1&B&A2&A1&!A|!E&D&!C2&C1&C&!B2&B1&B&A2&A1&!A|!E&!D&C2&C1&C&!B2&B1&B&A2&A1&!A|!E&!D&C2&!C1&C&!B2&B1&B&A2&A1&!A|!E&D&C2&!C1&C&!B2&B1&B&A2&A1&!A|!E&D&!C2&!C1&C&!B2&B1&B&A2&A1&!A|!E&!D&!C2&!C1&C&!B2&B1&B&A2&A1&!A|!E&!D&!C2&!C1&C&B2&B1&B&A2&A1&!A|!E&!D&C2&!C1&C&B2&B1&B&A2&A1&!A|!E&!D&C2&C1&C&B2&B1&B&A2&A1&!A|!E&!D&!C2&C1&C&B2&B1&B&A2&A1&!A|!E&!D&!C2&C1&!C&B2&B1&B&A2&A1&!A|!E&!D&C2&C1&!C&B2&B1&B&A2&A1&!A|!E&!D&C2&!C1&!C&B2&B1&B&A2&A1&!A|!E&!D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|!E&!D&!C2&!C1&!C&B2&!B1&B&A2&A1&!A|!E&D&!C2&!C1&!C&B2&!B1&B&A2&A1&!A|!E&D&C2&!C1&!C&B2&!B1&B&A2&A1&!A|!E&!D&C2&!C1&!C&B2&!B1&B&A2&A1&!A|!E&!D&C2&C1&!C&B2&!B1&B&A2&A1&!A|!E&D&C2&C1&!C&B2&!B1&B&A2&A1&!A|!E&D&!C2&C1&!C&B2&!B1&B&A2&A1&!A|!E&!D&!C2&C1&!C&B2&!B1&B&A2&A1&!A|!E&!D&!C2&C1&C&B2&!B1&B&A2&A1&!A|!E&D&!C2&C1&C&B2&!B1&B&A2&A1&!A|!E&!D&C2&C1&C&B2&!B1&B&A2&A1&!A|!E&!D&C2&!C1&C&B2&!B1&B&A2&A1&!A|!E&D&C2&!C1&C&B2&!B1&B&A2&A1&!A|!E&D&!C2&!C1&C&B2&!B1&B&A2&A1&!A|!E&!D&!C2&!C1&C&B2&!B1&B&A2&A1&!A|!E&!D&!C2&!C1&C&!B2&!B1&B&A2&A1&!A|!E&D&!C2&!C1&C&!B2&!B1&B&A2&A1&!A|!E&D&C2&!C1&C&!B2&!B1&B&A2&A1&!A|!E&!D&C2&!C1&C&!B2&!B1&B&A2&A1&!A|!E&!D&C2&C1&C&!B2&!B1&B&A2&A1&!A|!E&D&!C2&C1&C&!B2&!B1&B&A2&A1&!A|!E&!D&!C2&C1&C&!B2&!B1&B&A2&A1&!A|!E&!D&!C2&C1&!C&!B2&!B1&B&A2&A1&!A|!E&D&!C2&C1&!C&!B2&!B1&B&A2&A1&!A|!E&D&C2&C1&!C&!B2&!B1&B&A2&A1&!A|!E&!D&C2&C1&!C&!B2&!B1&B&A2&A1&!A|!E&!D&C2&!C1&!C&!B2&!B1&B&A2&A1&!A|!E&D&C2&!C1&!C&!B2&!B1&B&A2&A1&!A|!E&D&!C2&!C1&!C&!B2&!B1&B&A2&A1&!A|!E&!D&!C2&!C1&!C&!B2&!B1&B&A2&A1&!A|!E&!D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|!E&D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|!E&D&C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|!E&!D&C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|!E&!D&C2&C1&!C&!B2&!B1&B&!A2&A1&!A|!E&D&C2&C1&!C&!B2&!B1&B&!A2&A1&!A|!E&D&!C2&C1&!C&!B2&!B1&B&!A2&A1&!A|!E&!D&!C2&C1&!C&!B2&!B1&B&!A2&A1&!A|!E&!D&!C2&C1&C&!B2&!B1&B&!A2&A1&!A|!E&D&!C2&C1&C&!B2&!B1&B&!A2&A1&!A|!E&!D&C2&C1&C&!B2&!B1&B&!A2&A1&!A|!E&!D&C2&!C1&C&!B2&!B1&B&!A2&A1&!A|!E&D&C2&!C1&C&!B2&!B1&B&!A2&A1&!A|!E&D&!C2&!C1&C&!B2&!B1&B&!A2&A1&!A|!E&!D&!C2&!C1&C&!B2&!B1&B&!A2&A1&!A|!E&!D&!C2&!C1&C&B2&!B1&B&!A2&A1&!A|!E&D&!C2&!C1&C&B2&!B1&B&!A2&A1&!A|!E&D&C2&!C1&C&B2&!B1&B&!A2&A1&!A|!E&!D&C2&!C1&C&B2&!B1&B&!A2&A1&!A|!E&!D&C2&C1&C&B2&!B1&B&!A2&A1&!A|!E&D&!C2&C1&C&B2&!B1&B&!A2&A1&!A|!E&!D&!C2&C1&C&B2&!B1&B&!A2&A1&!A|!E&!D&!C2&C1&!C&B2&!B1&B&!A2&A1&!A|!E&D&!C2&C1&!C&B2&!B1&B&!A2&A1&!A|!E&D&C2&C1&!C&B2&!B1&B&!A2&A1&!A|!E&!D&C2&C1&!C&B2&!B1&B&!A2&A1&!A|!E&!D&C2&!C1&!C&B2&!B1&B&!A2&A1&!A|!E&D&C2&!C1&!C&B2&!B1&B&!A2&A1&!A|!E&D&!C2&!C1&!C&B2&!B1&B&!A2&A1&!A|!E&!D&!C2&!C1&!C&B2&!B1&B&!A2&A1&!A|!E&!D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|!E&!D&C2&!C1&!C&B2&B1&B&!A2&A1&!A|!E&!D&C2&C1&!C&B2&B1&B&!A2&A1&!A|!E&!D&!C2&C1&!C&B2&B1&B&!A2&A1&!A|!E&!D&!C2&C1&C&B2&B1&B&!A2&A1&!A|!E&!D&C2&C1&C&B2&B1&B&!A2&A1&!A|!E&!D&C2&!C1&C&B2&B1&B&!A2&A1&!A|!E&!D&!C2&!C1&C&B2&B1&B&!A2&A1&!A|!E&!D&!C2&!C1&C&!B2&B1&B&!A2&A1&!A|!E&D&!C2&!C1&C&!B2&B1&B&!A2&A1&!A|!E&D&C2&!C1&C&!B2&B1&B&!A2&A1&!A|!E&!D&C2&!C1&C&!B2&B1&B&!A2&A1&!A|!E&!D&C2&C1&C&!B2&B1&B&!A2&A1&!A|!E&D&!C2&C1&C&!B2&B1&B&!A2&A1&!A|!E&!D&!C2&C1&C&!B2&B1&B&!A2&A1&!A|!E&!D&!C2&C1&!C&!B2&B1&B&!A2&A1&!A|!E&D&!C2&C1&!C&!B2&B1&B&!A2&A1&!A|!E&D&C2&C1&!C&!B2&B1&B&!A2&A1&!A|!E&!D&C2&C1&!C&!B2&B1&B&!A2&A1&!A|!E&!D&C2&!C1&!C&!B2&B1&B&!A2&A1&!A|!E&D&C2&!C1&!C&!B2&B1&B&!A2&A1&!A|!E&D&!C2&!C1&!C&!B2&B1&B&!A2&A1&!A|!E&!D&!C2&!C1&!C&!B2&B1&B&!A2&A1&!A|!E&!D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|!E&D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|!E&D&C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|!E&!D&C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|!E&!D&C2&C1&!C&!B2&B1&!B&!A2&A1&!A|!E&D&C2&C1&!C&!B2&B1&!B&!A2&A1&!A|!E&D&!C2&C1&!C&!B2&B1&!B&!A2&A1&!A|!E&!D&!C2&C1&!C&!B2&B1&!B&!A2&A1&!A|!E&!D&!C2&C1&C&!B2&B1&!B&!A2&A1&!A|!E&D&!C2&C1&C&!B2&B1&!B&!A2&A1&!A|!E&!D&C2&C1&C&!B2&B1&!B&!A2&A1&!A|!E&!D&C2&!C1&C&!B2&B1&!B&!A2&A1&!A|!E&D&C2&!C1&C&!B2&B1&!B&!A2&A1&!A|!E&D&!C2&!C1&C&!B2&B1&!B&!A2&A1&!A|!E&!D&!C2&!C1&C&!B2&B1&!B&!A2&A1&!A|!E&!D&!C2&!C1&C&B2&B1&!B&!A2&A1&!A|!E&D&!C2&!C1&C&B2&B1&!B&!A2&A1&!A|!E&D&C2&!C1&C&B2&B1&!B&!A2&A1&!A|!E&!D&C2&!C1&C&B2&B1&!B&!A2&A1&!A|!E&!D&C2&C1&C&B2&B1&!B&!A2&A1&!A|!E&D&!C2&C1&C&B2&B1&!B&!A2&A1&!A|!E&!D&!C2&C1&C&B2&B1&!B&!A2&A1&!A|!E&!D&!C2&C1&!C&B2&B1&!B&!A2&A1&!A|!E&D&!C2&C1&!C&B2&B1&!B&!A2&A1&!A|!E&D&C2&C1&!C&B2&B1&!B&!A2&A1&!A|!E&!D&C2&C1&!C&B2&B1&!B&!A2&A1&!A|!E&!D&C2&!C1&!C&B2&B1&!B&!A2&A1&!A|!E&D&C2&!C1&!C&B2&B1&!B&!A2&A1&!A|!E&D&!C2&!C1&!C&B2&B1&!B&!A2&A1&!A|!E&!D&!C2&!C1&!C&B2&B1&!B&!A2&A1&!A|!E&!D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|!E&D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|!E&D&C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|!E&!D&C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|!E&!D&C2&C1&!C&B2&!B1&!B&!A2&A1&!A|!E&D&C2&C1&!C&B2&!B1&!B&!A2&A1&!A|!E&D&!C2&C1&!C&B2&!B1&!B&!A2&A1&!A|!E&!D&!C2&C1&!C&B2&!B1&!B&!A2&A1&!A|!E&!D&!C2&C1&C&B2&!B1&!B&!A2&A1&!A|!E&D&!C2&C1&C&B2&!B1&!B&!A2&A1&!A|!E&!D&C2&C1&C&B2&!B1&!B&!A2&A1&!A|!E&!D&C2&!C1&C&B2&!B1&!B&!A2&A1&!A|!E&D&C2&!C1&C&B2&!B1&!B&!A2&A1&!A|!E&D&!C2&!C1&C&B2&!B1&!B&!A2&A1&!A|!E&!D&!C2&!C1&C&B2&!B1&!B&!A2&A1&!A|!E&!D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|!E&D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|!E&D&C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|!E&!D&C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|!E&!D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!E&D&!C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!E&!D&!C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!E&!D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&D&C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&!D&C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&!D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|!E&D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|!E&D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|!E&!D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|!E&!D&C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!E&D&C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!E&D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!E&!D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!E&!D&!C2&C1&C&!B2&!B1&!B&!A2&A1&A|!E&D&!C2&C1&C&!B2&!B1&!B&!A2&A1&A|!E&!D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|!E&!D&C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!E&D&C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!E&D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!E&!D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!E&!D&!C2&!C1&C&B2&!B1&!B&!A2&A1&A|!E&D&!C2&!C1&C&B2&!B1&!B&!A2&A1&A|!E&D&C2&!C1&C&B2&!B1&!B&!A2&A1&A|!E&!D&C2&!C1&C&B2&!B1&!B&!A2&A1&A|!E&!D&C2&C1&C&B2&!B1&!B&!A2&A1&A|!E&D&!C2&C1&C&B2&!B1&!B&!A2&A1&A|!E&!D&!C2&C1&C&B2&!B1&!B&!A2&A1&A|!E&!D&!C2&C1&!C&B2&!B1&!B&!A2&A1&A|!E&D&!C2&C1&!C&B2&!B1&!B&!A2&A1&A|!E&D&C2&C1&!C&B2&!B1&!B&!A2&A1&A|!E&!D&C2&C1&!C&B2&!B1&!B&!A2&A1&A|!E&!D&C2&!C1&!C&B2&!B1&!B&!A2&A1&A|!E&D&C2&!C1&!C&B2&!B1&!B&!A2&A1&A|!E&D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&A|!E&!D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&A|!E&!D&!C2&!C1&!C&B2&B1&!B&!A2&A1&A|!E&D&!C2&!C1&!C&B2&B1&!B&!A2&A1&A|!E&D&C2&!C1&!C&B2&B1&!B&!A2&A1&A|!E&!D&C2&!C1&!C&B2&B1&!B&!A2&A1&A|!E&!D&C2&C1&!C&B2&B1&!B&!A2&A1&A|!E&D&C2&C1&!C&B2&B1&!B&!A2&A1&A|!E&D&!C2&C1&!C&B2&B1&!B&!A2&A1&A|!E&!D&!C2&C1&!C&B2&B1&!B&!A2&A1&A|!E&!D&!C2&C1&C&B2&B1&!B&!A2&A1&A|!E&D&!C2&C1&C&B2&B1&!B&!A2&A1&A|!E&!D&C2&C1&C&B2&B1&!B&!A2&A1&A|!E&!D&C2&!C1&C&B2&B1&!B&!A2&A1&A|!E&D&C2&!C1&C&B2&B1&!B&!A2&A1&A|!E&D&!C2&!C1&C&B2&B1&!B&!A2&A1&A|!E&!D&!C2&!C1&C&B2&B1&!B&!A2&A1&A|!E&!D&!C2&!C1&C&!B2&B1&!B&!A2&A1&A|!E&D&!C2&!C1&C&!B2&B1&!B&!A2&A1&A|!E&D&C2&!C1&C&!B2&B1&!B&!A2&A1&A|!E&!D&C2&!C1&C&!B2&B1&!B&!A2&A1&A|!E&!D&C2&C1&C&!B2&B1&!B&!A2&A1&A|!E&D&!C2&C1&C&!B2&B1&!B&!A2&A1&A|!E&!D&!C2&C1&C&!B2&B1&!B&!A2&A1&A|!E&!D&!C2&C1&!C&!B2&B1&!B&!A2&A1&A|!E&D&!C2&C1&!C&!B2&B1&!B&!A2&A1&A|!E&D&C2&C1&!C&!B2&B1&!B&!A2&A1&A|!E&!D&C2&C1&!C&!B2&B1&!B&!A2&A1&A|!E&!D&C2&!C1&!C&!B2&B1&!B&!A2&A1&A|!E&D&C2&!C1&!C&!B2&B1&!B&!A2&A1&A|!E&D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&A|!E&!D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&A|!E&!D&!C2&!C1&!C&!B2&B1&B&!A2&A1&A|!E&D&!C2&!C1&!C&!B2&B1&B&!A2&A1&A|!E&D&C2&!C1&!C&!B2&B1&B&!A2&A1&A|!E&!D&C2&!C1&!C&!B2&B1&B&!A2&A1&A|!E&!D&C2&C1&!C&!B2&B1&B&!A2&A1&A|!E&D&C2&C1&!C&!B2&B1&B&!A2&A1&A|!E&D&!C2&C1&!C&!B2&B1&B&!A2&A1&A|!E&!D&!C2&C1&!C&!B2&B1&B&!A2&A1&A|!E&!D&!C2&C1&C&!B2&B1&B&!A2&A1&A|!E&D&!C2&C1&C&!B2&B1&B&!A2&A1&A|!E&!D&C2&C1&C&!B2&B1&B&!A2&A1&A|!E&!D&C2&!C1&C&!B2&B1&B&!A2&A1&A|!E&D&C2&!C1&C&!B2&B1&B&!A2&A1&A|!E&D&!C2&!C1&C&!B2&B1&B&!A2&A1&A|!E&!D&!C2&!C1&C&!B2&B1&B&!A2&A1&A|!E&!D&!C2&!C1&C&B2&B1&B&!A2&A1&A|!E&!D&C2&!C1&C&B2&B1&B&!A2&A1&A|!E&!D&C2&C1&C&B2&B1&B&!A2&A1&A|!E&!D&!C2&C1&C&B2&B1&B&!A2&A1&A|!E&!D&!C2&C1&!C&B2&B1&B&!A2&A1&A|!E&!D&C2&C1&!C&B2&B1&B&!A2&A1&A|!E&!D&C2&!C1&!C&B2&B1&B&!A2&A1&A|!E&!D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|!E&!D&!C2&!C1&!C&B2&!B1&B&!A2&A1&A|!E&D&!C2&!C1&!C&B2&!B1&B&!A2&A1&A|!E&D&C2&!C1&!C&B2&!B1&B&!A2&A1&A|!E&!D&C2&!C1&!C&B2&!B1&B&!A2&A1&A|!E&!D&C2&C1&!C&B2&!B1&B&!A2&A1&A|!E&D&C2&C1&!C&B2&!B1&B&!A2&A1&A|!E&D&!C2&C1&!C&B2&!B1&B&!A2&A1&A|!E&!D&!C2&C1&!C&B2&!B1&B&!A2&A1&A|!E&!D&!C2&C1&C&B2&!B1&B&!A2&A1&A|!E&D&!C2&C1&C&B2&!B1&B&!A2&A1&A|!E&!D&C2&C1&C&B2&!B1&B&!A2&A1&A|!E&!D&C2&!C1&C&B2&!B1&B&!A2&A1&A|!E&D&C2&!C1&C&B2&!B1&B&!A2&A1&A|!E&D&!C2&!C1&C&B2&!B1&B&!A2&A1&A|!E&!D&!C2&!C1&C&B2&!B1&B&!A2&A1&A|!E&!D&!C2&!C1&C&!B2&!B1&B&!A2&A1&A|!E&D&!C2&!C1&C&!B2&!B1&B&!A2&A1&A|!E&D&C2&!C1&C&!B2&!B1&B&!A2&A1&A|!E&!D&C2&!C1&C&!B2&!B1&B&!A2&A1&A|!E&!D&C2&C1&C&!B2&!B1&B&!A2&A1&A|!E&D&!C2&C1&C&!B2&!B1&B&!A2&A1&A|!E&!D&!C2&C1&C&!B2&!B1&B&!A2&A1&A|!E&!D&!C2&C1&!C&!B2&!B1&B&!A2&A1&A|!E&D&!C2&C1&!C&!B2&!B1&B&!A2&A1&A|!E&D&C2&C1&!C&!B2&!B1&B&!A2&A1&A|!E&!D&C2&C1&!C&!B2&!B1&B&!A2&A1&A|!E&!D&C2&!C1&!C&!B2&!B1&B&!A2&A1&A|!E&D&C2&!C1&!C&!B2&!B1&B&!A2&A1&A|!E&D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&A|!E&!D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&A|!E&!D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|!E&!D&C2&!C1&!C&!B2&!B1&B&A2&A1&A|!E&!D&C2&C1&!C&!B2&!B1&B&A2&A1&A|!E&!D&!C2&C1&!C&!B2&!B1&B&A2&A1&A|!E&!D&!C2&C1&C&!B2&!B1&B&A2&A1&A|!E&!D&C2&C1&C&!B2&!B1&B&A2&A1&A|!E&!D&C2&!C1&C&!B2&!B1&B&A2&A1&A|!E&!D&!C2&!C1&C&!B2&!B1&B&A2&A1&A|!E&!D&!C2&!C1&C&B2&!B1&B&A2&A1&A|!E&!D&C2&!C1&C&B2&!B1&B&A2&A1&A|!E&!D&C2&C1&C&B2&!B1&B&A2&A1&A|!E&!D&!C2&C1&C&B2&!B1&B&A2&A1&A|!E&!D&!C2&C1&!C&B2&!B1&B&A2&A1&A|!E&!D&C2&C1&!C&B2&!B1&B&A2&A1&A|!E&!D&C2&!C1&!C&B2&!B1&B&A2&A1&A|!E&!D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|!E&!D&!C2&!C1&!C&B2&B1&B&A2&A1&A|!E&!D&C2&!C1&!C&B2&B1&B&A2&A1&A|!E&!D&C2&C1&!C&B2&B1&B&A2&A1&A|!E&!D&!C2&C1&!C&B2&B1&B&A2&A1&A|!E&!D&!C2&C1&C&B2&B1&B&A2&A1&A|!E&!D&C2&C1&C&B2&B1&B&A2&A1&A|!E&!D&C2&!C1&C&B2&B1&B&A2&A1&A|!E&!D&!C2&!C1&C&B2&B1&B&A2&A1&A|!E&!D&!C2&!C1&C&!B2&B1&B&A2&A1&A|!E&!D&C2&!C1&C&!B2&B1&B&A2&A1&A|!E&!D&C2&C1&C&!B2&B1&B&A2&A1&A|!E&!D&!C2&C1&C&!B2&B1&B&A2&A1&A|!E&!D&!C2&C1&!C&!B2&B1&B&A2&A1&A|!E&!D&C2&C1&!C&!B2&B1&B&A2&A1&A|!E&!D&C2&!C1&!C&!B2&B1&B&A2&A1&A|!E&!D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|!E&!D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|!E&!D&C2&!C1&!C&!B2&B1&!B&A2&A1&A|!E&!D&C2&C1&!C&!B2&B1&!B&A2&A1&A|!E&!D&!C2&C1&!C&!B2&B1&!B&A2&A1&A|!E&!D&!C2&C1&C&!B2&B1&!B&A2&A1&A|!E&!D&C2&C1&C&!B2&B1&!B&A2&A1&A|!E&!D&C2&!C1&C&!B2&B1&!B&A2&A1&A|!E&!D&!C2&!C1&C&!B2&B1&!B&A2&A1&A|!E&!D&!C2&!C1&C&B2&B1&!B&A2&A1&A|!E&!D&C2&!C1&C&B2&B1&!B&A2&A1&A|!E&!D&C2&C1&C&B2&B1&!B&A2&A1&A|!E&!D&!C2&C1&C&B2&B1&!B&A2&A1&A|!E&!D&!C2&C1&!C&B2&B1&!B&A2&A1&A|!E&!D&C2&C1&!C&B2&B1&!B&A2&A1&A|!E&!D&C2&!C1&!C&B2&B1&!B&A2&A1&A|!E&!D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|!E&!D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|!E&!D&C2&!C1&!C&B2&!B1&!B&A2&A1&A|!E&!D&C2&C1&!C&B2&!B1&!B&A2&A1&A|!E&!D&!C2&C1&!C&B2&!B1&!B&A2&A1&A|!E&!D&!C2&C1&C&B2&!B1&!B&A2&A1&A|!E&!D&C2&C1&C&B2&!B1&!B&A2&A1&A|!E&!D&C2&!C1&C&B2&!B1&!B&A2&A1&A|!E&!D&!C2&!C1&C&B2&!B1&!B&A2&A1&A|!E&!D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|!E&!D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|!E&!D&C2&C1&C&!B2&!B1&!B&A2&A1&A|!E&!D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|!E&!D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|!E&!D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|!E&!D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!E&!D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!E&!D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|!E&D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|!E&D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|!E&!D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|!E&!D&C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!E&D&C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!E&D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!E&!D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!E&!D&!C2&C1&C&!B2&!B1&!B&A2&!A1&A|!E&D&!C2&C1&C&!B2&!B1&!B&A2&!A1&A|!E&!D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|!E&!D&C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!E&D&C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!E&D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!E&!D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!E&!D&!C2&!C1&C&B2&!B1&!B&A2&!A1&A|!E&D&!C2&!C1&C&B2&!B1&!B&A2&!A1&A|!E&D&C2&!C1&C&B2&!B1&!B&A2&!A1&A|!E&!D&C2&!C1&C&B2&!B1&!B&A2&!A1&A|!E&!D&C2&C1&C&B2&!B1&!B&A2&!A1&A|!E&D&!C2&C1&C&B2&!B1&!B&A2&!A1&A|!E&!D&!C2&C1&C&B2&!B1&!B&A2&!A1&A|!E&!D&!C2&C1&!C&B2&!B1&!B&A2&!A1&A|!E&D&!C2&C1&!C&B2&!B1&!B&A2&!A1&A|!E&D&C2&C1&!C&B2&!B1&!B&A2&!A1&A|!E&!D&C2&C1&!C&B2&!B1&!B&A2&!A1&A|!E&!D&C2&!C1&!C&B2&!B1&!B&A2&!A1&A|!E&D&C2&!C1&!C&B2&!B1&!B&A2&!A1&A|!E&D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&A|!E&!D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&A|!E&!D&!C2&!C1&!C&B2&B1&!B&A2&!A1&A|!E&D&!C2&!C1&!C&B2&B1&!B&A2&!A1&A|!E&D&C2&!C1&!C&B2&B1&!B&A2&!A1&A|!E&!D&C2&!C1&!C&B2&B1&!B&A2&!A1&A|!E&!D&C2&C1&!C&B2&B1&!B&A2&!A1&A|!E&D&C2&C1&!C&B2&B1&!B&A2&!A1&A|!E&D&!C2&C1&!C&B2&B1&!B&A2&!A1&A|!E&!D&!C2&C1&!C&B2&B1&!B&A2&!A1&A|!E&!D&!C2&C1&C&B2&B1&!B&A2&!A1&A|!E&D&!C2&C1&C&B2&B1&!B&A2&!A1&A|!E&!D&C2&C1&C&B2&B1&!B&A2&!A1&A|!E&!D&C2&!C1&C&B2&B1&!B&A2&!A1&A|!E&D&C2&!C1&C&B2&B1&!B&A2&!A1&A|!E&D&!C2&!C1&C&B2&B1&!B&A2&!A1&A|!E&!D&!C2&!C1&C&B2&B1&!B&A2&!A1&A|!E&!D&!C2&!C1&C&!B2&B1&!B&A2&!A1&A|!E&D&!C2&!C1&C&!B2&B1&!B&A2&!A1&A|!E&D&C2&!C1&C&!B2&B1&!B&A2&!A1&A|!E&!D&C2&!C1&C&!B2&B1&!B&A2&!A1&A|!E&!D&C2&C1&C&!B2&B1&!B&A2&!A1&A|!E&D&!C2&C1&C&!B2&B1&!B&A2&!A1&A|!E&!D&!C2&C1&C&!B2&B1&!B&A2&!A1&A|!E&!D&!C2&C1&!C&!B2&B1&!B&A2&!A1&A|!E&D&!C2&C1&!C&!B2&B1&!B&A2&!A1&A|!E&D&C2&C1&!C&!B2&B1&!B&A2&!A1&A|!E&!D&C2&C1&!C&!B2&B1&!B&A2&!A1&A|!E&!D&C2&!C1&!C&!B2&B1&!B&A2&!A1&A|!E&D&C2&!C1&!C&!B2&B1&!B&A2&!A1&A|!E&D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&A|!E&!D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&A|!E&!D&!C2&!C1&!C&!B2&B1&B&A2&!A1&A|!E&D&!C2&!C1&!C&!B2&B1&B&A2&!A1&A|!E&D&C2&!C1&!C&!B2&B1&B&A2&!A1&A|!E&!D&C2&!C1&!C&!B2&B1&B&A2&!A1&A|!E&!D&C2&C1&!C&!B2&B1&B&A2&!A1&A|!E&D&C2&C1&!C&!B2&B1&B&A2&!A1&A|!E&D&!C2&C1&!C&!B2&B1&B&A2&!A1&A|!E&!D&!C2&C1&!C&!B2&B1&B&A2&!A1&A|!E&!D&!C2&C1&C&!B2&B1&B&A2&!A1&A|!E&D&!C2&C1&C&!B2&B1&B&A2&!A1&A|!E&!D&C2&C1&C&!B2&B1&B&A2&!A1&A|!E&!D&C2&!C1&C&!B2&B1&B&A2&!A1&A|!E&D&C2&!C1&C&!B2&B1&B&A2&!A1&A|!E&D&!C2&!C1&C&!B2&B1&B&A2&!A1&A|!E&!D&!C2&!C1&C&!B2&B1&B&A2&!A1&A|!E&!D&!C2&!C1&C&B2&B1&B&A2&!A1&A|!E&!D&C2&!C1&C&B2&B1&B&A2&!A1&A|!E&!D&C2&C1&C&B2&B1&B&A2&!A1&A|!E&!D&!C2&C1&C&B2&B1&B&A2&!A1&A|!E&!D&!C2&C1&!C&B2&B1&B&A2&!A1&A|!E&!D&C2&C1&!C&B2&B1&B&A2&!A1&A|!E&!D&C2&!C1&!C&B2&B1&B&A2&!A1&A|!E&!D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|!E&!D&!C2&!C1&!C&B2&!B1&B&A2&!A1&A|!E&D&!C2&!C1&!C&B2&!B1&B&A2&!A1&A|!E&D&C2&!C1&!C&B2&!B1&B&A2&!A1&A|!E&!D&C2&!C1&!C&B2&!B1&B&A2&!A1&A|!E&!D&C2&C1&!C&B2&!B1&B&A2&!A1&A|!E&D&C2&C1&!C&B2&!B1&B&A2&!A1&A|!E&D&!C2&C1&!C&B2&!B1&B&A2&!A1&A|!E&!D&!C2&C1&!C&B2&!B1&B&A2&!A1&A|!E&!D&!C2&C1&C&B2&!B1&B&A2&!A1&A|!E&D&!C2&C1&C&B2&!B1&B&A2&!A1&A|!E&!D&C2&C1&C&B2&!B1&B&A2&!A1&A|!E&!D&C2&!C1&C&B2&!B1&B&A2&!A1&A|!E&D&C2&!C1&C&B2&!B1&B&A2&!A1&A|!E&D&!C2&!C1&C&B2&!B1&B&A2&!A1&A|!E&!D&!C2&!C1&C&B2&!B1&B&A2&!A1&A|!E&!D&!C2&!C1&C&!B2&!B1&B&A2&!A1&A|!E&D&!C2&!C1&C&!B2&!B1&B&A2&!A1&A|!E&D&C2&!C1&C&!B2&!B1&B&A2&!A1&A|!E&!D&C2&!C1&C&!B2&!B1&B&A2&!A1&A|!E&!D&C2&C1&C&!B2&!B1&B&A2&!A1&A|!E&D&!C2&C1&C&!B2&!B1&B&A2&!A1&A|!E&!D&!C2&C1&C&!B2&!B1&B&A2&!A1&A|!E&!D&!C2&C1&!C&!B2&!B1&B&A2&!A1&A|!E&D&!C2&C1&!C&!B2&!B1&B&A2&!A1&A|!E&D&C2&C1&!C&!B2&!B1&B&A2&!A1&A|!E&!D&C2&C1&!C&!B2&!B1&B&A2&!A1&A|!E&!D&C2&!C1&!C&!B2&!B1&B&A2&!A1&A|!E&D&C2&!C1&!C&!B2&!B1&B&A2&!A1&A|!E&D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&A|!E&!D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&A|!E&!D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|!E&D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|!E&D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|!E&!D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|!E&!D&C2&C1&!C&!B2&!B1&B&!A2&!A1&A|!E&D&C2&C1&!C&!B2&!B1&B&!A2&!A1&A|!E&D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&A|!E&!D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&A|!E&!D&!C2&C1&C&!B2&!B1&B&!A2&!A1&A|!E&D&!C2&C1&C&!B2&!B1&B&!A2&!A1&A|!E&!D&C2&C1&C&!B2&!B1&B&!A2&!A1&A|!E&!D&C2&!C1&C&!B2&!B1&B&!A2&!A1&A|!E&D&C2&!C1&C&!B2&!B1&B&!A2&!A1&A|!E&D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&A|!E&!D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&A|!E&!D&!C2&!C1&C&B2&!B1&B&!A2&!A1&A|!E&D&!C2&!C1&C&B2&!B1&B&!A2&!A1&A|!E&D&C2&!C1&C&B2&!B1&B&!A2&!A1&A|!E&!D&C2&!C1&C&B2&!B1&B&!A2&!A1&A|!E&!D&C2&C1&C&B2&!B1&B&!A2&!A1&A|!E&D&!C2&C1&C&B2&!B1&B&!A2&!A1&A|!E&!D&!C2&C1&C&B2&!B1&B&!A2&!A1&A|!E&!D&!C2&C1&!C&B2&!B1&B&!A2&!A1&A|!E&D&!C2&C1&!C&B2&!B1&B&!A2&!A1&A|!E&D&C2&C1&!C&B2&!B1&B&!A2&!A1&A|!E&!D&C2&C1&!C&B2&!B1&B&!A2&!A1&A|!E&!D&C2&!C1&!C&B2&!B1&B&!A2&!A1&A|!E&D&C2&!C1&!C&B2&!B1&B&!A2&!A1&A|!E&D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&A|!E&!D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&A|!E&!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|!E&!D&C2&!C1&!C&B2&B1&B&!A2&!A1&A|!E&!D&C2&C1&!C&B2&B1&B&!A2&!A1&A|!E&!D&!C2&C1&!C&B2&B1&B&!A2&!A1&A|!E&!D&!C2&C1&C&B2&B1&B&!A2&!A1&A|!E&!D&C2&C1&C&B2&B1&B&!A2&!A1&A|!E&!D&C2&!C1&C&B2&B1&B&!A2&!A1&A|!E&!D&!C2&!C1&C&B2&B1&B&!A2&!A1&A|!E&!D&!C2&!C1&C&!B2&B1&B&!A2&!A1&A|!E&D&!C2&!C1&C&!B2&B1&B&!A2&!A1&A|!E&D&C2&!C1&C&!B2&B1&B&!A2&!A1&A|!E&!D&C2&!C1&C&!B2&B1&B&!A2&!A1&A|!E&!D&C2&C1&C&!B2&B1&B&!A2&!A1&A|!E&D&!C2&C1&C&!B2&B1&B&!A2&!A1&A|!E&!D&!C2&C1&C&!B2&B1&B&!A2&!A1&A|!E&!D&!C2&C1&!C&!B2&B1&B&!A2&!A1&A|!E&D&!C2&C1&!C&!B2&B1&B&!A2&!A1&A|!E&D&C2&C1&!C&!B2&B1&B&!A2&!A1&A|!E&!D&C2&C1&!C&!B2&B1&B&!A2&!A1&A|!E&!D&C2&!C1&!C&!B2&B1&B&!A2&!A1&A|!E&D&C2&!C1&!C&!B2&B1&B&!A2&!A1&A|!E&D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&A|!E&!D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&A|!E&!D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|!E&D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|!E&D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|!E&!D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|!E&!D&C2&C1&!C&!B2&B1&!B&!A2&!A1&A|!E&D&C2&C1&!C&!B2&B1&!B&!A2&!A1&A|!E&D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&A|!E&!D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&A|!E&!D&!C2&C1&C&!B2&B1&!B&!A2&!A1&A|!E&D&!C2&C1&C&!B2&B1&!B&!A2&!A1&A|!E&!D&C2&C1&C&!B2&B1&!B&!A2&!A1&A|!E&!D&C2&!C1&C&!B2&B1&!B&!A2&!A1&A|!E&D&C2&!C1&C&!B2&B1&!B&!A2&!A1&A|!E&D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&A|!E&!D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&A|!E&!D&!C2&!C1&C&B2&B1&!B&!A2&!A1&A|!E&D&!C2&!C1&C&B2&B1&!B&!A2&!A1&A|!E&D&C2&!C1&C&B2&B1&!B&!A2&!A1&A|!E&!D&C2&!C1&C&B2&B1&!B&!A2&!A1&A|!E&!D&C2&C1&C&B2&B1&!B&!A2&!A1&A|!E&D&!C2&C1&C&B2&B1&!B&!A2&!A1&A|!E&!D&!C2&C1&C&B2&B1&!B&!A2&!A1&A|!E&!D&!C2&C1&!C&B2&B1&!B&!A2&!A1&A|!E&D&!C2&C1&!C&B2&B1&!B&!A2&!A1&A|!E&D&C2&C1&!C&B2&B1&!B&!A2&!A1&A|!E&!D&C2&C1&!C&B2&B1&!B&!A2&!A1&A|!E&!D&C2&!C1&!C&B2&B1&!B&!A2&!A1&A|!E&D&C2&!C1&!C&B2&B1&!B&!A2&!A1&A|!E&D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&A|!E&!D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&A|!E&!D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|!E&D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|!E&D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|!E&!D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|!E&!D&C2&C1&!C&B2&!B1&!B&!A2&!A1&A|!E&D&C2&C1&!C&B2&!B1&!B&!A2&!A1&A|!E&D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&A|!E&!D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&A|!E&!D&!C2&C1&C&B2&!B1&!B&!A2&!A1&A|!E&D&!C2&C1&C&B2&!B1&!B&!A2&!A1&A|!E&!D&C2&C1&C&B2&!B1&!B&!A2&!A1&A|!E&!D&C2&!C1&C&B2&!B1&!B&!A2&!A1&A|!E&D&C2&!C1&C&B2&!B1&!B&!A2&!A1&A|!E&D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&A|!E&!D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&A|!E&!D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|!E&D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|!E&D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|!E&!D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|!E&!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!E&D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!E&!D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!E&!D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|!E&D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|!E&D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|!E&!D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|!E&!D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|!E&D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|!E&D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|!E&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOAOI33311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOAI22131 -l AAOAAOAI22131 -i E D2 D1 D C B1 B A1 A -o Y -f Y=!(E&D2&D1&D&!C&!B1&!B&!A1&!A|E&D2&D1&D&C&!B1&!B&!A1&!A|E&D2&D1&D&C&B1&!B&!A1&!A|E&D2&D1&D&!C&B1&!B&!A1&!A|E&D2&D1&D&!C&B1&B&!A1&!A|E&!D2&!D1&D&C&B1&B&!A1&!A|E&D2&!D1&D&C&B1&B&!A1&!A|E&D2&D1&D&C&B1&B&!A1&!A|E&!D2&D1&D&C&B1&B&!A1&!A|E&!D2&D1&!D&C&B1&B&!A1&!A|E&D2&D1&!D&C&B1&B&!A1&!A|E&D2&!D1&!D&C&B1&B&!A1&!A|E&!D2&!D1&!D&C&B1&B&!A1&!A|E&D2&D1&D&C&!B1&B&!A1&!A|E&D2&D1&D&!C&!B1&B&!A1&!A|E&D2&D1&D&!C&!B1&B&A1&!A|E&D2&D1&D&C&!B1&B&A1&!A|E&!D2&!D1&!D&C&B1&B&A1&!A|E&D2&!D1&!D&C&B1&B&A1&!A|E&D2&D1&!D&C&B1&B&A1&!A|E&!D2&D1&!D&C&B1&B&A1&!A|E&!D2&D1&D&C&B1&B&A1&!A|E&D2&D1&D&C&B1&B&A1&!A|E&D2&!D1&D&C&B1&B&A1&!A|E&!D2&!D1&D&C&B1&B&A1&!A|E&D2&D1&D&!C&B1&B&A1&!A|E&D2&D1&D&!C&B1&!B&A1&!A|E&D2&D1&D&C&B1&!B&A1&!A|E&D2&D1&D&C&!B1&!B&A1&!A|E&D2&D1&D&!C&!B1&!B&A1&!A|E&D2&D1&D&!C&!B1&!B&A1&A|E&!D2&!D1&D&C&!B1&!B&A1&A|E&D2&!D1&D&C&!B1&!B&A1&A|E&D2&D1&D&C&!B1&!B&A1&A|E&!D2&D1&D&C&!B1&!B&A1&A|E&!D2&D1&!D&C&!B1&!B&A1&A|E&D2&D1&!D&C&!B1&!B&A1&A|E&D2&!D1&!D&C&!B1&!B&A1&A|E&!D2&!D1&!D&C&!B1&!B&A1&A|E&!D2&!D1&!D&C&B1&!B&A1&A|E&D2&!D1&!D&C&B1&!B&A1&A|E&D2&D1&!D&C&B1&!B&A1&A|E&!D2&D1&!D&C&B1&!B&A1&A|E&!D2&D1&D&C&B1&!B&A1&A|E&D2&D1&D&C&B1&!B&A1&A|E&D2&!D1&D&C&B1&!B&A1&A|E&!D2&!D1&D&C&B1&!B&A1&A|E&D2&D1&D&!C&B1&!B&A1&A|E&D2&D1&D&!C&B1&B&A1&A|E&!D2&!D1&D&C&B1&B&A1&A|E&D2&!D1&D&C&B1&B&A1&A|E&D2&D1&D&C&B1&B&A1&A|E&!D2&D1&D&C&B1&B&A1&A|E&!D2&D1&!D&C&B1&B&A1&A|E&D2&D1&!D&C&B1&B&A1&A|E&D2&!D1&!D&C&B1&B&A1&A|E&!D2&!D1&!D&C&B1&B&A1&A|E&!D2&!D1&!D&C&!B1&B&A1&A|E&D2&!D1&!D&C&!B1&B&A1&A|E&D2&D1&!D&C&!B1&B&A1&A|E&!D2&D1&!D&C&!B1&B&A1&A|E&!D2&D1&D&C&!B1&B&A1&A|E&D2&D1&D&C&!B1&B&A1&A|E&D2&!D1&D&C&!B1&B&A1&A|E&!D2&!D1&D&C&!B1&B&A1&A|E&D2&D1&D&!C&!B1&B&A1&A|E&D2&D1&D&!C&!B1&B&!A1&A|E&D2&D1&D&C&!B1&B&!A1&A|E&!D2&!D1&!D&C&B1&B&!A1&A|E&D2&!D1&!D&C&B1&B&!A1&A|E&D2&D1&!D&C&B1&B&!A1&A|E&!D2&D1&!D&C&B1&B&!A1&A|E&!D2&D1&D&C&B1&B&!A1&A|E&D2&D1&D&C&B1&B&!A1&A|E&D2&!D1&D&C&B1&B&!A1&A|E&!D2&!D1&D&C&B1&B&!A1&A|E&D2&D1&D&!C&B1&B&!A1&A|E&D2&D1&D&!C&B1&!B&!A1&A|E&D2&D1&D&C&B1&!B&!A1&A|E&D2&D1&D&C&!B1&!B&!A1&A|E&D2&D1&D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOAI22131.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOI44 -l AAOI44 -i B3 B2 B1 B A3 A2 A1 A -o Y -f Y=!(B3&B2&B1&B&!A3&!A2&!A1&!A|B3&B2&B1&B&A3&!A2&!A1&!A|B3&B2&B1&B&A3&A2&!A1&!A|B3&B2&B1&B&!A3&A2&!A1&!A|B3&B2&B1&B&!A3&A2&A1&!A|B3&B2&B1&B&A3&A2&A1&!A|B3&B2&B1&B&A3&!A2&A1&!A|B3&B2&B1&B&!A3&!A2&A1&!A|B3&B2&B1&B&!A3&!A2&A1&A|B3&B2&B1&B&A3&!A2&A1&A|!B3&!B2&!B1&!B&A3&A2&A1&A|B3&!B2&!B1&!B&A3&A2&A1&A|B3&B2&!B1&!B&A3&A2&A1&A|!B3&B2&!B1&!B&A3&A2&A1&A|!B3&B2&B1&!B&A3&A2&A1&A|B3&B2&B1&!B&A3&A2&A1&A|B3&!B2&B1&!B&A3&A2&A1&A|!B3&!B2&B1&!B&A3&A2&A1&A|!B3&!B2&B1&B&A3&A2&A1&A|B3&!B2&B1&B&A3&A2&A1&A|B3&B2&B1&B&A3&A2&A1&A|!B3&B2&B1&B&A3&A2&A1&A|!B3&B2&!B1&B&A3&A2&A1&A|B3&B2&!B1&B&A3&A2&A1&A|B3&!B2&!B1&B&A3&A2&A1&A|!B3&!B2&!B1&B&A3&A2&A1&A|B3&B2&B1&B&!A3&A2&A1&A|B3&B2&B1&B&!A3&A2&!A1&A|B3&B2&B1&B&A3&A2&!A1&A|B3&B2&B1&B&A3&!A2&!A1&A|B3&B2&B1&B&!A3&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOI44.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAAOOAI3222 -l AAAOOAI3222 -i D1 D C1 C B1 B A2 A1 A -o Y -f Y=!(D1&!D&C1&C&!B1&!B&!A2&!A1&!A|D1&D&C1&C&!B1&!B&!A2&!A1&!A|!D1&D&C1&C&!B1&!B&!A2&!A1&!A|!D1&D&C1&C&B1&!B&!A2&!A1&!A|D1&D&C1&C&B1&!B&!A2&!A1&!A|D1&!D&C1&C&B1&!B&!A2&!A1&!A|D1&!D&!C1&!C&B1&B&!A2&!A1&!A|D1&D&!C1&!C&B1&B&!A2&!A1&!A|!D1&D&!C1&!C&B1&B&!A2&!A1&!A|!D1&D&C1&!C&B1&B&!A2&!A1&!A|D1&D&C1&!C&B1&B&!A2&!A1&!A|D1&!D&C1&!C&B1&B&!A2&!A1&!A|D1&!D&C1&C&B1&B&!A2&!A1&!A|D1&D&C1&C&B1&B&!A2&!A1&!A|!D1&D&C1&C&B1&B&!A2&!A1&!A|!D1&D&!C1&C&B1&B&!A2&!A1&!A|D1&D&!C1&C&B1&B&!A2&!A1&!A|D1&!D&!C1&C&B1&B&!A2&!A1&!A|!D1&D&C1&C&!B1&B&!A2&!A1&!A|D1&D&C1&C&!B1&B&!A2&!A1&!A|D1&!D&C1&C&!B1&B&!A2&!A1&!A|D1&!D&C1&C&!B1&B&A2&!A1&!A|D1&D&C1&C&!B1&B&A2&!A1&!A|!D1&D&C1&C&!B1&B&A2&!A1&!A|D1&!D&!C1&C&B1&B&A2&!A1&!A|D1&D&!C1&C&B1&B&A2&!A1&!A|!D1&D&!C1&C&B1&B&A2&!A1&!A|!D1&D&C1&C&B1&B&A2&!A1&!A|D1&D&C1&C&B1&B&A2&!A1&!A|D1&!D&C1&C&B1&B&A2&!A1&!A|D1&!D&C1&!C&B1&B&A2&!A1&!A|D1&D&C1&!C&B1&B&A2&!A1&!A|!D1&D&C1&!C&B1&B&A2&!A1&!A|!D1&D&!C1&!C&B1&B&A2&!A1&!A|D1&D&!C1&!C&B1&B&A2&!A1&!A|D1&!D&!C1&!C&B1&B&A2&!A1&!A|D1&!D&C1&C&B1&!B&A2&!A1&!A|D1&D&C1&C&B1&!B&A2&!A1&!A|!D1&D&C1&C&B1&!B&A2&!A1&!A|!D1&D&C1&C&!B1&!B&A2&!A1&!A|D1&D&C1&C&!B1&!B&A2&!A1&!A|D1&!D&C1&C&!B1&!B&A2&!A1&!A|D1&!D&C1&C&!B1&!B&A2&A1&!A|D1&D&C1&C&!B1&!B&A2&A1&!A|!D1&D&C1&C&!B1&!B&A2&A1&!A|!D1&D&C1&C&B1&!B&A2&A1&!A|D1&D&C1&C&B1&!B&A2&A1&!A|D1&!D&C1&C&B1&!B&A2&A1&!A|D1&!D&!C1&!C&B1&B&A2&A1&!A|D1&D&!C1&!C&B1&B&A2&A1&!A|!D1&D&!C1&!C&B1&B&A2&A1&!A|!D1&D&C1&!C&B1&B&A2&A1&!A|D1&D&C1&!C&B1&B&A2&A1&!A|D1&!D&C1&!C&B1&B&A2&A1&!A|D1&!D&C1&C&B1&B&A2&A1&!A|D1&D&C1&C&B1&B&A2&A1&!A|!D1&D&C1&C&B1&B&A2&A1&!A|!D1&D&!C1&C&B1&B&A2&A1&!A|D1&D&!C1&C&B1&B&A2&A1&!A|D1&!D&!C1&C&B1&B&A2&A1&!A|!D1&D&C1&C&!B1&B&A2&A1&!A|D1&D&C1&C&!B1&B&A2&A1&!A|D1&!D&C1&C&!B1&B&A2&A1&!A|D1&!D&C1&C&!B1&B&!A2&A1&!A|D1&D&C1&C&!B1&B&!A2&A1&!A|!D1&D&C1&C&!B1&B&!A2&A1&!A|D1&!D&!C1&C&B1&B&!A2&A1&!A|D1&D&!C1&C&B1&B&!A2&A1&!A|!D1&D&!C1&C&B1&B&!A2&A1&!A|!D1&D&C1&C&B1&B&!A2&A1&!A|D1&D&C1&C&B1&B&!A2&A1&!A|D1&!D&C1&C&B1&B&!A2&A1&!A|D1&!D&C1&!C&B1&B&!A2&A1&!A|D1&D&C1&!C&B1&B&!A2&A1&!A|!D1&D&C1&!C&B1&B&!A2&A1&!A|!D1&D&!C1&!C&B1&B&!A2&A1&!A|D1&D&!C1&!C&B1&B&!A2&A1&!A|D1&!D&!C1&!C&B1&B&!A2&A1&!A|D1&!D&C1&C&B1&!B&!A2&A1&!A|D1&D&C1&C&B1&!B&!A2&A1&!A|!D1&D&C1&C&B1&!B&!A2&A1&!A|!D1&D&C1&C&!B1&!B&!A2&A1&!A|D1&D&C1&C&!B1&!B&!A2&A1&!A|D1&!D&C1&C&!B1&!B&!A2&A1&!A|D1&!D&C1&C&!B1&!B&!A2&A1&A|D1&D&C1&C&!B1&!B&!A2&A1&A|!D1&D&C1&C&!B1&!B&!A2&A1&A|!D1&D&C1&C&B1&!B&!A2&A1&A|D1&D&C1&C&B1&!B&!A2&A1&A|D1&!D&C1&C&B1&!B&!A2&A1&A|D1&!D&!C1&!C&B1&B&!A2&A1&A|D1&D&!C1&!C&B1&B&!A2&A1&A|!D1&D&!C1&!C&B1&B&!A2&A1&A|!D1&D&C1&!C&B1&B&!A2&A1&A|D1&D&C1&!C&B1&B&!A2&A1&A|D1&!D&C1&!C&B1&B&!A2&A1&A|D1&!D&C1&C&B1&B&!A2&A1&A|D1&D&C1&C&B1&B&!A2&A1&A|!D1&D&C1&C&B1&B&!A2&A1&A|!D1&D&!C1&C&B1&B&!A2&A1&A|D1&D&!C1&C&B1&B&!A2&A1&A|D1&!D&!C1&C&B1&B&!A2&A1&A|!D1&D&C1&C&!B1&B&!A2&A1&A|D1&D&C1&C&!B1&B&!A2&A1&A|D1&!D&C1&C&!B1&B&!A2&A1&A|D1&!D&!C1&!C&!B1&B&A2&A1&A|D1&D&!C1&!C&!B1&B&A2&A1&A|!D1&D&!C1&!C&!B1&B&A2&A1&A|!D1&D&C1&!C&!B1&B&A2&A1&A|D1&D&C1&!C&!B1&B&A2&A1&A|D1&!D&C1&!C&!B1&B&A2&A1&A|D1&!D&C1&C&!B1&B&A2&A1&A|D1&D&C1&C&!B1&B&A2&A1&A|!D1&D&C1&C&!B1&B&A2&A1&A|!D1&D&!C1&C&!B1&B&A2&A1&A|D1&D&!C1&C&!B1&B&A2&A1&A|D1&!D&!C1&C&!B1&B&A2&A1&A|D1&!D&!C1&C&B1&B&A2&A1&A|D1&D&!C1&C&B1&B&A2&A1&A|!D1&D&!C1&C&B1&B&A2&A1&A|!D1&D&C1&C&B1&B&A2&A1&A|D1&D&C1&C&B1&B&A2&A1&A|D1&!D&C1&C&B1&B&A2&A1&A|D1&!D&C1&!C&B1&B&A2&A1&A|D1&D&C1&!C&B1&B&A2&A1&A|!D1&D&C1&!C&B1&B&A2&A1&A|!D1&D&!C1&!C&B1&B&A2&A1&A|D1&D&!C1&!C&B1&B&A2&A1&A|D1&!D&!C1&!C&B1&B&A2&A1&A|D1&!D&!C1&!C&B1&!B&A2&A1&A|D1&D&!C1&!C&B1&!B&A2&A1&A|!D1&D&!C1&!C&B1&!B&A2&A1&A|!D1&D&C1&!C&B1&!B&A2&A1&A|D1&D&C1&!C&B1&!B&A2&A1&A|D1&!D&C1&!C&B1&!B&A2&A1&A|D1&!D&C1&C&B1&!B&A2&A1&A|D1&D&C1&C&B1&!B&A2&A1&A|!D1&D&C1&C&B1&!B&A2&A1&A|!D1&D&!C1&C&B1&!B&A2&A1&A|D1&D&!C1&C&B1&!B&A2&A1&A|D1&!D&!C1&C&B1&!B&A2&A1&A|D1&!D&!C1&C&!B1&!B&A2&A1&A|D1&D&!C1&C&!B1&!B&A2&A1&A|!D1&D&!C1&C&!B1&!B&A2&A1&A|!D1&D&C1&C&!B1&!B&A2&A1&A|D1&D&C1&C&!B1&!B&A2&A1&A|D1&!D&C1&C&!B1&!B&A2&A1&A|D1&!D&C1&!C&!B1&!B&A2&A1&A|D1&D&C1&!C&!B1&!B&A2&A1&A|!D1&D&C1&!C&!B1&!B&A2&A1&A|!D1&D&!C1&!C&!B1&!B&A2&A1&A|D1&D&!C1&!C&!B1&!B&A2&A1&A|D1&!D&!C1&!C&!B1&!B&A2&A1&A|D1&!D&C1&C&!B1&!B&A2&!A1&A|D1&D&C1&C&!B1&!B&A2&!A1&A|!D1&D&C1&C&!B1&!B&A2&!A1&A|!D1&D&C1&C&B1&!B&A2&!A1&A|D1&D&C1&C&B1&!B&A2&!A1&A|D1&!D&C1&C&B1&!B&A2&!A1&A|D1&!D&!C1&!C&B1&B&A2&!A1&A|D1&D&!C1&!C&B1&B&A2&!A1&A|!D1&D&!C1&!C&B1&B&A2&!A1&A|!D1&D&C1&!C&B1&B&A2&!A1&A|D1&D&C1&!C&B1&B&A2&!A1&A|D1&!D&C1&!C&B1&B&A2&!A1&A|D1&!D&C1&C&B1&B&A2&!A1&A|D1&D&C1&C&B1&B&A2&!A1&A|!D1&D&C1&C&B1&B&A2&!A1&A|!D1&D&!C1&C&B1&B&A2&!A1&A|D1&D&!C1&C&B1&B&A2&!A1&A|D1&!D&!C1&C&B1&B&A2&!A1&A|!D1&D&C1&C&!B1&B&A2&!A1&A|D1&D&C1&C&!B1&B&A2&!A1&A|D1&!D&C1&C&!B1&B&A2&!A1&A|D1&!D&C1&C&!B1&B&!A2&!A1&A|D1&D&C1&C&!B1&B&!A2&!A1&A|!D1&D&C1&C&!B1&B&!A2&!A1&A|D1&!D&!C1&C&B1&B&!A2&!A1&A|D1&D&!C1&C&B1&B&!A2&!A1&A|!D1&D&!C1&C&B1&B&!A2&!A1&A|!D1&D&C1&C&B1&B&!A2&!A1&A|D1&D&C1&C&B1&B&!A2&!A1&A|D1&!D&C1&C&B1&B&!A2&!A1&A|D1&!D&C1&!C&B1&B&!A2&!A1&A|D1&D&C1&!C&B1&B&!A2&!A1&A|!D1&D&C1&!C&B1&B&!A2&!A1&A|!D1&D&!C1&!C&B1&B&!A2&!A1&A|D1&D&!C1&!C&B1&B&!A2&!A1&A|D1&!D&!C1&!C&B1&B&!A2&!A1&A|D1&!D&C1&C&B1&!B&!A2&!A1&A|D1&D&C1&C&B1&!B&!A2&!A1&A|!D1&D&C1&C&B1&!B&!A2&!A1&A|!D1&D&C1&C&!B1&!B&!A2&!A1&A|D1&D&C1&C&!B1&!B&!A2&!A1&A|D1&!D&C1&C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAAOOAI3222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAOI221311 -l AAOOAOI221311 -i F E D2 D1 D C B1 B A1 A -o Y -f Y=(!F&!E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!F&E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!F&E&D2&!D1&!D&!C&!B1&!B&!A1&!A|!F&!E&D2&!D1&!D&!C&!B1&!B&!A1&!A|!F&!E&D2&D1&!D&!C&!B1&!B&!A1&!A|!F&E&D2&D1&!D&!C&!B1&!B&!A1&!A|!F&E&!D2&D1&!D&!C&!B1&!B&!A1&!A|!F&!E&!D2&D1&!D&!C&!B1&!B&!A1&!A|!F&!E&!D2&D1&D&!C&!B1&!B&!A1&!A|!F&E&!D2&D1&D&!C&!B1&!B&!A1&!A|!F&E&D2&D1&D&!C&!B1&!B&!A1&!A|!F&!E&D2&D1&D&!C&!B1&!B&!A1&!A|!F&!E&D2&!D1&D&!C&!B1&!B&!A1&!A|!F&E&D2&!D1&D&!C&!B1&!B&!A1&!A|!F&E&!D2&!D1&D&!C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&D&!C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&D&C&!B1&!B&!A1&!A|!F&!E&D2&!D1&D&C&!B1&!B&!A1&!A|!F&!E&D2&D1&D&C&!B1&!B&!A1&!A|!F&!E&!D2&D1&D&C&!B1&!B&!A1&!A|!F&!E&!D2&D1&!D&C&!B1&!B&!A1&!A|!F&!E&D2&D1&!D&C&!B1&!B&!A1&!A|!F&!E&D2&!D1&!D&C&!B1&!B&!A1&!A|!F&E&!D2&!D1&!D&C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&C&!B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&C&B1&!B&!A1&!A|!F&E&!D2&!D1&!D&C&B1&!B&!A1&!A|!F&!E&D2&!D1&!D&C&B1&!B&!A1&!A|!F&!E&D2&D1&!D&C&B1&!B&!A1&!A|!F&!E&!D2&D1&!D&C&B1&!B&!A1&!A|!F&!E&!D2&D1&D&C&B1&!B&!A1&!A|!F&!E&D2&D1&D&C&B1&!B&!A1&!A|!F&!E&D2&!D1&D&C&B1&!B&!A1&!A|!F&!E&!D2&!D1&D&C&B1&!B&!A1&!A|!F&!E&!D2&!D1&D&!C&B1&!B&!A1&!A|!F&E&!D2&!D1&D&!C&B1&!B&!A1&!A|!F&E&D2&!D1&D&!C&B1&!B&!A1&!A|!F&!E&D2&!D1&D&!C&B1&!B&!A1&!A|!F&!E&D2&D1&D&!C&B1&!B&!A1&!A|!F&E&D2&D1&D&!C&B1&!B&!A1&!A|!F&E&!D2&D1&D&!C&B1&!B&!A1&!A|!F&!E&!D2&D1&D&!C&B1&!B&!A1&!A|!F&!E&!D2&D1&!D&!C&B1&!B&!A1&!A|!F&E&!D2&D1&!D&!C&B1&!B&!A1&!A|!F&E&D2&D1&!D&!C&B1&!B&!A1&!A|!F&!E&D2&D1&!D&!C&B1&!B&!A1&!A|!F&!E&D2&!D1&!D&!C&B1&!B&!A1&!A|!F&E&D2&!D1&!D&!C&B1&!B&!A1&!A|!F&E&!D2&!D1&!D&!C&B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C&B1&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C&B1&B&!A1&!A|!F&E&!D2&!D1&!D&!C&B1&B&!A1&!A|!F&!E&D2&!D1&!D&!C&B1&B&!A1&!A|!F&!E&D2&D1&!D&!C&B1&B&!A1&!A|!F&!E&!D2&D1&!D&!C&B1&B&!A1&!A|!F&!E&!D2&D1&D&!C&B1&B&!A1&!A|!F&!E&D2&D1&D&!C&B1&B&!A1&!A|!F&!E&D2&!D1&D&!C&B1&B&!A1&!A|!F&!E&!D2&!D1&D&!C&B1&B&!A1&!A|!F&!E&!D2&!D1&D&C&B1&B&!A1&!A|!F&!E&D2&!D1&D&C&B1&B&!A1&!A|!F&!E&D2&D1&D&C&B1&B&!A1&!A|!F&!E&!D2&D1&D&C&B1&B&!A1&!A|!F&!E&!D2&D1&!D&C&B1&B&!A1&!A|!F&!E&D2&D1&!D&C&B1&B&!A1&!A|!F&!E&D2&!D1&!D&C&B1&B&!A1&!A|!F&E&!D2&!D1&!D&C&B1&B&!A1&!A|!F&!E&!D2&!D1&!D&C&B1&B&!A1&!A|!F&!E&!D2&!D1&!D&C&!B1&B&!A1&!A|!F&E&!D2&!D1&!D&C&!B1&B&!A1&!A|!F&!E&D2&!D1&!D&C&!B1&B&!A1&!A|!F&!E&D2&D1&!D&C&!B1&B&!A1&!A|!F&!E&!D2&D1&!D&C&!B1&B&!A1&!A|!F&!E&!D2&D1&D&C&!B1&B&!A1&!A|!F&!E&D2&D1&D&C&!B1&B&!A1&!A|!F&!E&D2&!D1&D&C&!B1&B&!A1&!A|!F&!E&!D2&!D1&D&C&!B1&B&!A1&!A|!F&!E&!D2&!D1&D&!C&!B1&B&!A1&!A|!F&E&!D2&!D1&D&!C&!B1&B&!A1&!A|!F&E&D2&!D1&D&!C&!B1&B&!A1&!A|!F&!E&D2&!D1&D&!C&!B1&B&!A1&!A|!F&!E&D2&D1&D&!C&!B1&B&!A1&!A|!F&E&D2&D1&D&!C&!B1&B&!A1&!A|!F&E&!D2&D1&D&!C&!B1&B&!A1&!A|!F&!E&!D2&D1&D&!C&!B1&B&!A1&!A|!F&!E&!D2&D1&!D&!C&!B1&B&!A1&!A|!F&E&!D2&D1&!D&!C&!B1&B&!A1&!A|!F&E&D2&D1&!D&!C&!B1&B&!A1&!A|!F&!E&D2&D1&!D&!C&!B1&B&!A1&!A|!F&!E&D2&!D1&!D&!C&!B1&B&!A1&!A|!F&E&D2&!D1&!D&!C&!B1&B&!A1&!A|!F&E&!D2&!D1&!D&!C&!B1&B&!A1&!A|!F&!E&!D2&!D1&!D&!C&!B1&B&!A1&!A|!F&!E&!D2&!D1&!D&!C&!B1&B&A1&!A|!F&E&!D2&!D1&!D&!C&!B1&B&A1&!A|!F&E&D2&!D1&!D&!C&!B1&B&A1&!A|!F&!E&D2&!D1&!D&!C&!B1&B&A1&!A|!F&!E&D2&D1&!D&!C&!B1&B&A1&!A|!F&E&D2&D1&!D&!C&!B1&B&A1&!A|!F&E&!D2&D1&!D&!C&!B1&B&A1&!A|!F&!E&!D2&D1&!D&!C&!B1&B&A1&!A|!F&!E&!D2&D1&D&!C&!B1&B&A1&!A|!F&E&!D2&D1&D&!C&!B1&B&A1&!A|!F&E&D2&D1&D&!C&!B1&B&A1&!A|!F&!E&D2&D1&D&!C&!B1&B&A1&!A|!F&!E&D2&!D1&D&!C&!B1&B&A1&!A|!F&E&D2&!D1&D&!C&!B1&B&A1&!A|!F&E&!D2&!D1&D&!C&!B1&B&A1&!A|!F&!E&!D2&!D1&D&!C&!B1&B&A1&!A|!F&!E&!D2&!D1&D&C&!B1&B&A1&!A|!F&!E&D2&!D1&D&C&!B1&B&A1&!A|!F&!E&D2&D1&D&C&!B1&B&A1&!A|!F&!E&!D2&D1&D&C&!B1&B&A1&!A|!F&!E&!D2&D1&!D&C&!B1&B&A1&!A|!F&!E&D2&D1&!D&C&!B1&B&A1&!A|!F&!E&D2&!D1&!D&C&!B1&B&A1&!A|!F&E&!D2&!D1&!D&C&!B1&B&A1&!A|!F&!E&!D2&!D1&!D&C&!B1&B&A1&!A|!F&!E&!D2&!D1&!D&C&B1&B&A1&!A|!F&E&!D2&!D1&!D&C&B1&B&A1&!A|!F&!E&D2&!D1&!D&C&B1&B&A1&!A|!F&!E&D2&D1&!D&C&B1&B&A1&!A|!F&!E&!D2&D1&!D&C&B1&B&A1&!A|!F&!E&!D2&D1&D&C&B1&B&A1&!A|!F&!E&D2&D1&D&C&B1&B&A1&!A|!F&!E&D2&!D1&D&C&B1&B&A1&!A|!F&!E&!D2&!D1&D&C&B1&B&A1&!A|!F&!E&!D2&!D1&D&!C&B1&B&A1&!A|!F&!E&D2&!D1&D&!C&B1&B&A1&!A|!F&!E&D2&D1&D&!C&B1&B&A1&!A|!F&!E&!D2&D1&D&!C&B1&B&A1&!A|!F&!E&!D2&D1&!D&!C&B1&B&A1&!A|!F&!E&D2&D1&!D&!C&B1&B&A1&!A|!F&!E&D2&!D1&!D&!C&B1&B&A1&!A|!F&E&!D2&!D1&!D&!C&B1&B&A1&!A|!F&!E&!D2&!D1&!D&!C&B1&B&A1&!A|!F&!E&!D2&!D1&!D&!C&B1&!B&A1&!A|!F&E&!D2&!D1&!D&!C&B1&!B&A1&!A|!F&E&D2&!D1&!D&!C&B1&!B&A1&!A|!F&!E&D2&!D1&!D&!C&B1&!B&A1&!A|!F&!E&D2&D1&!D&!C&B1&!B&A1&!A|!F&E&D2&D1&!D&!C&B1&!B&A1&!A|!F&E&!D2&D1&!D&!C&B1&!B&A1&!A|!F&!E&!D2&D1&!D&!C&B1&!B&A1&!A|!F&!E&!D2&D1&D&!C&B1&!B&A1&!A|!F&E&!D2&D1&D&!C&B1&!B&A1&!A|!F&E&D2&D1&D&!C&B1&!B&A1&!A|!F&!E&D2&D1&D&!C&B1&!B&A1&!A|!F&!E&D2&!D1&D&!C&B1&!B&A1&!A|!F&E&D2&!D1&D&!C&B1&!B&A1&!A|!F&E&!D2&!D1&D&!C&B1&!B&A1&!A|!F&!E&!D2&!D1&D&!C&B1&!B&A1&!A|!F&!E&!D2&!D1&D&C&B1&!B&A1&!A|!F&!E&D2&!D1&D&C&B1&!B&A1&!A|!F&!E&D2&D1&D&C&B1&!B&A1&!A|!F&!E&!D2&D1&D&C&B1&!B&A1&!A|!F&!E&!D2&D1&!D&C&B1&!B&A1&!A|!F&!E&D2&D1&!D&C&B1&!B&A1&!A|!F&!E&D2&!D1&!D&C&B1&!B&A1&!A|!F&E&!D2&!D1&!D&C&B1&!B&A1&!A|!F&!E&!D2&!D1&!D&C&B1&!B&A1&!A|!F&!E&!D2&!D1&!D&C&!B1&!B&A1&!A|!F&E&!D2&!D1&!D&C&!B1&!B&A1&!A|!F&!E&D2&!D1&!D&C&!B1&!B&A1&!A|!F&!E&D2&D1&!D&C&!B1&!B&A1&!A|!F&!E&!D2&D1&!D&C&!B1&!B&A1&!A|!F&!E&!D2&D1&D&C&!B1&!B&A1&!A|!F&!E&D2&D1&D&C&!B1&!B&A1&!A|!F&!E&D2&!D1&D&C&!B1&!B&A1&!A|!F&!E&!D2&!D1&D&C&!B1&!B&A1&!A|!F&!E&!D2&!D1&D&!C&!B1&!B&A1&!A|!F&E&!D2&!D1&D&!C&!B1&!B&A1&!A|!F&E&D2&!D1&D&!C&!B1&!B&A1&!A|!F&!E&D2&!D1&D&!C&!B1&!B&A1&!A|!F&!E&D2&D1&D&!C&!B1&!B&A1&!A|!F&E&D2&D1&D&!C&!B1&!B&A1&!A|!F&E&!D2&D1&D&!C&!B1&!B&A1&!A|!F&!E&!D2&D1&D&!C&!B1&!B&A1&!A|!F&!E&!D2&D1&!D&!C&!B1&!B&A1&!A|!F&E&!D2&D1&!D&!C&!B1&!B&A1&!A|!F&E&D2&D1&!D&!C&!B1&!B&A1&!A|!F&!E&D2&D1&!D&!C&!B1&!B&A1&!A|!F&!E&D2&!D1&!D&!C&!B1&!B&A1&!A|!F&E&D2&!D1&!D&!C&!B1&!B&A1&!A|!F&E&!D2&!D1&!D&!C&!B1&!B&A1&!A|!F&!E&!D2&!D1&!D&!C&!B1&!B&A1&!A|!F&!E&!D2&!D1&!D&!C&!B1&!B&A1&A|!F&E&!D2&!D1&!D&!C&!B1&!B&A1&A|!F&!E&D2&!D1&!D&!C&!B1&!B&A1&A|!F&!E&D2&D1&!D&!C&!B1&!B&A1&A|!F&!E&!D2&D1&!D&!C&!B1&!B&A1&A|!F&!E&!D2&D1&D&!C&!B1&!B&A1&A|!F&!E&D2&D1&D&!C&!B1&!B&A1&A|!F&!E&D2&!D1&D&!C&!B1&!B&A1&A|!F&!E&!D2&!D1&D&!C&!B1&!B&A1&A|!F&!E&!D2&!D1&D&C&!B1&!B&A1&A|!F&!E&D2&!D1&D&C&!B1&!B&A1&A|!F&!E&D2&D1&D&C&!B1&!B&A1&A|!F&!E&!D2&D1&D&C&!B1&!B&A1&A|!F&!E&!D2&D1&!D&C&!B1&!B&A1&A|!F&!E&D2&D1&!D&C&!B1&!B&A1&A|!F&!E&D2&!D1&!D&C&!B1&!B&A1&A|!F&E&!D2&!D1&!D&C&!B1&!B&A1&A|!F&!E&!D2&!D1&!D&C&!B1&!B&A1&A|!F&!E&!D2&!D1&!D&C&B1&!B&A1&A|!F&E&!D2&!D1&!D&C&B1&!B&A1&A|!F&!E&D2&!D1&!D&C&B1&!B&A1&A|!F&!E&D2&D1&!D&C&B1&!B&A1&A|!F&!E&!D2&D1&!D&C&B1&!B&A1&A|!F&!E&!D2&D1&D&C&B1&!B&A1&A|!F&!E&D2&D1&D&C&B1&!B&A1&A|!F&!E&D2&!D1&D&C&B1&!B&A1&A|!F&!E&!D2&!D1&D&C&B1&!B&A1&A|!F&!E&!D2&!D1&D&!C&B1&!B&A1&A|!F&!E&D2&!D1&D&!C&B1&!B&A1&A|!F&!E&D2&D1&D&!C&B1&!B&A1&A|!F&!E&!D2&D1&D&!C&B1&!B&A1&A|!F&!E&!D2&D1&!D&!C&B1&!B&A1&A|!F&!E&D2&D1&!D&!C&B1&!B&A1&A|!F&!E&D2&!D1&!D&!C&B1&!B&A1&A|!F&E&!D2&!D1&!D&!C&B1&!B&A1&A|!F&!E&!D2&!D1&!D&!C&B1&!B&A1&A|!F&!E&!D2&!D1&!D&!C&B1&B&A1&A|!F&E&!D2&!D1&!D&!C&B1&B&A1&A|!F&!E&D2&!D1&!D&!C&B1&B&A1&A|!F&!E&D2&D1&!D&!C&B1&B&A1&A|!F&!E&!D2&D1&!D&!C&B1&B&A1&A|!F&!E&!D2&D1&D&!C&B1&B&A1&A|!F&!E&D2&D1&D&!C&B1&B&A1&A|!F&!E&D2&!D1&D&!C&B1&B&A1&A|!F&!E&!D2&!D1&D&!C&B1&B&A1&A|!F&!E&!D2&!D1&D&C&B1&B&A1&A|!F&!E&D2&!D1&D&C&B1&B&A1&A|!F&!E&D2&D1&D&C&B1&B&A1&A|!F&!E&!D2&D1&D&C&B1&B&A1&A|!F&!E&!D2&D1&!D&C&B1&B&A1&A|!F&!E&D2&D1&!D&C&B1&B&A1&A|!F&!E&D2&!D1&!D&C&B1&B&A1&A|!F&E&!D2&!D1&!D&C&B1&B&A1&A|!F&!E&!D2&!D1&!D&C&B1&B&A1&A|!F&!E&!D2&!D1&!D&C&!B1&B&A1&A|!F&E&!D2&!D1&!D&C&!B1&B&A1&A|!F&!E&D2&!D1&!D&C&!B1&B&A1&A|!F&!E&D2&D1&!D&C&!B1&B&A1&A|!F&!E&!D2&D1&!D&C&!B1&B&A1&A|!F&!E&!D2&D1&D&C&!B1&B&A1&A|!F&!E&D2&D1&D&C&!B1&B&A1&A|!F&!E&D2&!D1&D&C&!B1&B&A1&A|!F&!E&!D2&!D1&D&C&!B1&B&A1&A|!F&!E&!D2&!D1&D&!C&!B1&B&A1&A|!F&!E&D2&!D1&D&!C&!B1&B&A1&A|!F&!E&D2&D1&D&!C&!B1&B&A1&A|!F&!E&!D2&D1&D&!C&!B1&B&A1&A|!F&!E&!D2&D1&!D&!C&!B1&B&A1&A|!F&!E&D2&D1&!D&!C&!B1&B&A1&A|!F&!E&D2&!D1&!D&!C&!B1&B&A1&A|!F&E&!D2&!D1&!D&!C&!B1&B&A1&A|!F&!E&!D2&!D1&!D&!C&!B1&B&A1&A|!F&!E&!D2&!D1&!D&!C&!B1&B&!A1&A|!F&E&!D2&!D1&!D&!C&!B1&B&!A1&A|!F&E&D2&!D1&!D&!C&!B1&B&!A1&A|!F&!E&D2&!D1&!D&!C&!B1&B&!A1&A|!F&!E&D2&D1&!D&!C&!B1&B&!A1&A|!F&E&D2&D1&!D&!C&!B1&B&!A1&A|!F&E&!D2&D1&!D&!C&!B1&B&!A1&A|!F&!E&!D2&D1&!D&!C&!B1&B&!A1&A|!F&!E&!D2&D1&D&!C&!B1&B&!A1&A|!F&E&!D2&D1&D&!C&!B1&B&!A1&A|!F&E&D2&D1&D&!C&!B1&B&!A1&A|!F&!E&D2&D1&D&!C&!B1&B&!A1&A|!F&!E&D2&!D1&D&!C&!B1&B&!A1&A|!F&E&D2&!D1&D&!C&!B1&B&!A1&A|!F&E&!D2&!D1&D&!C&!B1&B&!A1&A|!F&!E&!D2&!D1&D&!C&!B1&B&!A1&A|!F&!E&!D2&!D1&D&C&!B1&B&!A1&A|!F&!E&D2&!D1&D&C&!B1&B&!A1&A|!F&!E&D2&D1&D&C&!B1&B&!A1&A|!F&!E&!D2&D1&D&C&!B1&B&!A1&A|!F&!E&!D2&D1&!D&C&!B1&B&!A1&A|!F&!E&D2&D1&!D&C&!B1&B&!A1&A|!F&!E&D2&!D1&!D&C&!B1&B&!A1&A|!F&E&!D2&!D1&!D&C&!B1&B&!A1&A|!F&!E&!D2&!D1&!D&C&!B1&B&!A1&A|!F&!E&!D2&!D1&!D&C&B1&B&!A1&A|!F&E&!D2&!D1&!D&C&B1&B&!A1&A|!F&!E&D2&!D1&!D&C&B1&B&!A1&A|!F&!E&D2&D1&!D&C&B1&B&!A1&A|!F&!E&!D2&D1&!D&C&B1&B&!A1&A|!F&!E&!D2&D1&D&C&B1&B&!A1&A|!F&!E&D2&D1&D&C&B1&B&!A1&A|!F&!E&D2&!D1&D&C&B1&B&!A1&A|!F&!E&!D2&!D1&D&C&B1&B&!A1&A|!F&!E&!D2&!D1&D&!C&B1&B&!A1&A|!F&!E&D2&!D1&D&!C&B1&B&!A1&A|!F&!E&D2&D1&D&!C&B1&B&!A1&A|!F&!E&!D2&D1&D&!C&B1&B&!A1&A|!F&!E&!D2&D1&!D&!C&B1&B&!A1&A|!F&!E&D2&D1&!D&!C&B1&B&!A1&A|!F&!E&D2&!D1&!D&!C&B1&B&!A1&A|!F&E&!D2&!D1&!D&!C&B1&B&!A1&A|!F&!E&!D2&!D1&!D&!C&B1&B&!A1&A|!F&!E&!D2&!D1&!D&!C&B1&!B&!A1&A|!F&E&!D2&!D1&!D&!C&B1&!B&!A1&A|!F&E&D2&!D1&!D&!C&B1&!B&!A1&A|!F&!E&D2&!D1&!D&!C&B1&!B&!A1&A|!F&!E&D2&D1&!D&!C&B1&!B&!A1&A|!F&E&D2&D1&!D&!C&B1&!B&!A1&A|!F&E&!D2&D1&!D&!C&B1&!B&!A1&A|!F&!E&!D2&D1&!D&!C&B1&!B&!A1&A|!F&!E&!D2&D1&D&!C&B1&!B&!A1&A|!F&E&!D2&D1&D&!C&B1&!B&!A1&A|!F&E&D2&D1&D&!C&B1&!B&!A1&A|!F&!E&D2&D1&D&!C&B1&!B&!A1&A|!F&!E&D2&!D1&D&!C&B1&!B&!A1&A|!F&E&D2&!D1&D&!C&B1&!B&!A1&A|!F&E&!D2&!D1&D&!C&B1&!B&!A1&A|!F&!E&!D2&!D1&D&!C&B1&!B&!A1&A|!F&!E&!D2&!D1&D&C&B1&!B&!A1&A|!F&!E&D2&!D1&D&C&B1&!B&!A1&A|!F&!E&D2&D1&D&C&B1&!B&!A1&A|!F&!E&!D2&D1&D&C&B1&!B&!A1&A|!F&!E&!D2&D1&!D&C&B1&!B&!A1&A|!F&!E&D2&D1&!D&C&B1&!B&!A1&A|!F&!E&D2&!D1&!D&C&B1&!B&!A1&A|!F&E&!D2&!D1&!D&C&B1&!B&!A1&A|!F&!E&!D2&!D1&!D&C&B1&!B&!A1&A|!F&!E&!D2&!D1&!D&C&!B1&!B&!A1&A|!F&E&!D2&!D1&!D&C&!B1&!B&!A1&A|!F&!E&D2&!D1&!D&C&!B1&!B&!A1&A|!F&!E&D2&D1&!D&C&!B1&!B&!A1&A|!F&!E&!D2&D1&!D&C&!B1&!B&!A1&A|!F&!E&!D2&D1&D&C&!B1&!B&!A1&A|!F&!E&D2&D1&D&C&!B1&!B&!A1&A|!F&!E&D2&!D1&D&C&!B1&!B&!A1&A|!F&!E&!D2&!D1&D&C&!B1&!B&!A1&A|!F&!E&!D2&!D1&D&!C&!B1&!B&!A1&A|!F&E&!D2&!D1&D&!C&!B1&!B&!A1&A|!F&E&D2&!D1&D&!C&!B1&!B&!A1&A|!F&!E&D2&!D1&D&!C&!B1&!B&!A1&A|!F&!E&D2&D1&D&!C&!B1&!B&!A1&A|!F&E&D2&D1&D&!C&!B1&!B&!A1&A|!F&E&!D2&D1&D&!C&!B1&!B&!A1&A|!F&!E&!D2&D1&D&!C&!B1&!B&!A1&A|!F&!E&!D2&D1&!D&!C&!B1&!B&!A1&A|!F&E&!D2&D1&!D&!C&!B1&!B&!A1&A|!F&E&D2&D1&!D&!C&!B1&!B&!A1&A|!F&!E&D2&D1&!D&!C&!B1&!B&!A1&A|!F&!E&D2&!D1&!D&!C&!B1&!B&!A1&A|!F&E&D2&!D1&!D&!C&!B1&!B&!A1&A|!F&E&!D2&!D1&!D&!C&!B1&!B&!A1&A|!F&!E&!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAOI221311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAAOI22132 -l OOAAAOI22132 -i E1 E D2 D1 D C B1 B A1 A -o Y -f Y=(!E1&!E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!E1&E&D2&!D1&!D&!C&!B1&!B&!A1&!A|E1&!E&D2&!D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&D2&D1&!D&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&!D&!C&!B1&!B&!A1&!A|!E1&E&D2&D1&!D&!C&!B1&!B&!A1&!A|!E1&E&!D2&D1&!D&!C&!B1&!B&!A1&!A|E1&!E&!D2&D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&D&!C&!B1&!B&!A1&!A|E1&!E&!D2&D1&D&!C&!B1&!B&!A1&!A|!E1&E&!D2&D1&D&!C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&D&!C&!B1&!B&!A1&!A|E1&!E&D2&!D1&D&!C&!B1&!B&!A1&!A|!E1&E&D2&!D1&D&!C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&D&!C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&D&!C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&D&C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&D&C&!B1&!B&!A1&!A|!E1&E&D2&!D1&D&C&!B1&!B&!A1&!A|E1&!E&D2&!D1&D&C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&D&C&!B1&!B&!A1&!A|!E1&E&!D2&D1&D&C&!B1&!B&!A1&!A|E1&!E&!D2&D1&D&C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&D&C&!B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&C&!B1&!B&!A1&!A|E1&!E&!D2&D1&!D&C&!B1&!B&!A1&!A|!E1&E&!D2&D1&!D&C&!B1&!B&!A1&!A|!E1&E&D2&D1&!D&C&!B1&!B&!A1&!A|E1&!E&D2&D1&!D&C&!B1&!B&!A1&!A|!E1&!E&D2&D1&!D&C&!B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&C&!B1&!B&!A1&!A|E1&!E&D2&!D1&!D&C&!B1&!B&!A1&!A|!E1&E&D2&!D1&!D&C&!B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&C&!B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C&!B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&C&B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&C&B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&C&B1&!B&!A1&!A|!E1&E&D2&!D1&!D&C&B1&!B&!A1&!A|E1&!E&D2&!D1&!D&C&B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&C&B1&!B&!A1&!A|!E1&!E&D2&D1&!D&C&B1&!B&!A1&!A|E1&!E&D2&D1&!D&C&B1&!B&!A1&!A|!E1&E&D2&D1&!D&C&B1&!B&!A1&!A|!E1&E&!D2&D1&!D&C&B1&!B&!A1&!A|E1&!E&!D2&D1&!D&C&B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&C&B1&!B&!A1&!A|!E1&!E&!D2&D1&D&C&B1&!B&!A1&!A|E1&!E&!D2&D1&D&C&B1&!B&!A1&!A|!E1&E&!D2&D1&D&C&B1&!B&!A1&!A|!E1&!E&D2&!D1&D&C&B1&!B&!A1&!A|E1&!E&D2&!D1&D&C&B1&!B&!A1&!A|!E1&E&D2&!D1&D&C&B1&!B&!A1&!A|!E1&E&!D2&!D1&D&C&B1&!B&!A1&!A|E1&!E&!D2&!D1&D&C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&D&!C&B1&!B&!A1&!A|E1&!E&!D2&!D1&D&!C&B1&!B&!A1&!A|!E1&E&!D2&!D1&D&!C&B1&!B&!A1&!A|!E1&E&D2&!D1&D&!C&B1&!B&!A1&!A|E1&!E&D2&!D1&D&!C&B1&!B&!A1&!A|!E1&!E&D2&!D1&D&!C&B1&!B&!A1&!A|!E1&E&!D2&D1&D&!C&B1&!B&!A1&!A|E1&!E&!D2&D1&D&!C&B1&!B&!A1&!A|!E1&!E&!D2&D1&D&!C&B1&!B&!A1&!A|!E1&!E&!D2&D1&!D&!C&B1&!B&!A1&!A|E1&!E&!D2&D1&!D&!C&B1&!B&!A1&!A|!E1&E&!D2&D1&!D&!C&B1&!B&!A1&!A|!E1&E&D2&D1&!D&!C&B1&!B&!A1&!A|E1&!E&D2&D1&!D&!C&B1&!B&!A1&!A|!E1&!E&D2&D1&!D&!C&B1&!B&!A1&!A|!E1&!E&D2&!D1&!D&!C&B1&!B&!A1&!A|E1&!E&D2&!D1&!D&!C&B1&!B&!A1&!A|!E1&E&D2&!D1&!D&!C&B1&!B&!A1&!A|!E1&E&!D2&!D1&!D&!C&B1&!B&!A1&!A|E1&!E&!D2&!D1&!D&!C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C&B1&!B&!A1&!A|!E1&!E&!D2&!D1&!D&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&!C&B1&B&!A1&!A|!E1&E&D2&!D1&!D&!C&B1&B&!A1&!A|E1&!E&D2&!D1&!D&!C&B1&B&!A1&!A|!E1&!E&D2&!D1&!D&!C&B1&B&!A1&!A|!E1&!E&D2&D1&!D&!C&B1&B&!A1&!A|E1&!E&D2&D1&!D&!C&B1&B&!A1&!A|!E1&E&D2&D1&!D&!C&B1&B&!A1&!A|!E1&E&!D2&D1&!D&!C&B1&B&!A1&!A|E1&!E&!D2&D1&!D&!C&B1&B&!A1&!A|!E1&!E&!D2&D1&!D&!C&B1&B&!A1&!A|!E1&!E&!D2&D1&D&!C&B1&B&!A1&!A|E1&!E&!D2&D1&D&!C&B1&B&!A1&!A|!E1&E&!D2&D1&D&!C&B1&B&!A1&!A|!E1&!E&D2&!D1&D&!C&B1&B&!A1&!A|E1&!E&D2&!D1&D&!C&B1&B&!A1&!A|!E1&E&D2&!D1&D&!C&B1&B&!A1&!A|!E1&E&!D2&!D1&D&!C&B1&B&!A1&!A|E1&!E&!D2&!D1&D&!C&B1&B&!A1&!A|!E1&!E&!D2&!D1&D&!C&B1&B&!A1&!A|!E1&!E&!D2&!D1&D&C&B1&B&!A1&!A|E1&!E&!D2&!D1&D&C&B1&B&!A1&!A|!E1&E&!D2&!D1&D&C&B1&B&!A1&!A|!E1&E&D2&!D1&D&C&B1&B&!A1&!A|E1&!E&D2&!D1&D&C&B1&B&!A1&!A|!E1&!E&D2&!D1&D&C&B1&B&!A1&!A|!E1&E&!D2&D1&D&C&B1&B&!A1&!A|E1&!E&!D2&D1&D&C&B1&B&!A1&!A|!E1&!E&!D2&D1&D&C&B1&B&!A1&!A|!E1&!E&!D2&D1&!D&C&B1&B&!A1&!A|E1&!E&!D2&D1&!D&C&B1&B&!A1&!A|!E1&E&!D2&D1&!D&C&B1&B&!A1&!A|!E1&E&D2&D1&!D&C&B1&B&!A1&!A|E1&!E&D2&D1&!D&C&B1&B&!A1&!A|!E1&!E&D2&D1&!D&C&B1&B&!A1&!A|!E1&!E&D2&!D1&!D&C&B1&B&!A1&!A|E1&!E&D2&!D1&!D&C&B1&B&!A1&!A|!E1&E&D2&!D1&!D&C&B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C&B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C&B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&C&B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&C&!B1&B&!A1&!A|E1&!E&!D2&!D1&!D&C&!B1&B&!A1&!A|!E1&E&!D2&!D1&!D&C&!B1&B&!A1&!A|!E1&E&D2&!D1&!D&C&!B1&B&!A1&!A|E1&!E&D2&!D1&!D&C&!B1&B&!A1&!A|!E1&!E&D2&!D1&!D&C&!B1&B&!A1&!A|!E1&!E&D2&D1&!D&C&!B1&B&!A1&!A|E1&!E&D2&D1&!D&C&!B1&B&!A1&!A|!E1&E&D2&D1&!D&C&!B1&B&!A1&!A|!E1&E&!D2&D1&!D&C&!B1&B&!A1&!A|E1&!E&!D2&D1&!D&C&!B1&B&!A1&!A|!E1&!E&!D2&D1&!D&C&!B1&B&!A1&!A|!E1&!E&!D2&D1&D&C&!B1&B&!A1&!A|E1&!E&!D2&D1&D&C&!B1&B&!A1&!A|!E1&E&!D2&D1&D&C&!B1&B&!A1&!A|!E1&!E&D2&!D1&D&C&!B1&B&!A1&!A|E1&!E&D2&!D1&D&C&!B1&B&!A1&!A|!E1&E&D2&!D1&D&C&!B1&B&!A1&!A|!E1&E&!D2&!D1&D&C&!B1&B&!A1&!A|E1&!E&!D2&!D1&D&C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&D&C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&D&!C&!B1&B&!A1&!A|E1&!E&!D2&!D1&D&!C&!B1&B&!A1&!A|!E1&E&!D2&!D1&D&!C&!B1&B&!A1&!A|!E1&E&D2&!D1&D&!C&!B1&B&!A1&!A|E1&!E&D2&!D1&D&!C&!B1&B&!A1&!A|!E1&!E&D2&!D1&D&!C&!B1&B&!A1&!A|!E1&E&!D2&D1&D&!C&!B1&B&!A1&!A|E1&!E&!D2&D1&D&!C&!B1&B&!A1&!A|!E1&!E&!D2&D1&D&!C&!B1&B&!A1&!A|!E1&!E&!D2&D1&!D&!C&!B1&B&!A1&!A|E1&!E&!D2&D1&!D&!C&!B1&B&!A1&!A|!E1&E&!D2&D1&!D&!C&!B1&B&!A1&!A|!E1&E&D2&D1&!D&!C&!B1&B&!A1&!A|E1&!E&D2&D1&!D&!C&!B1&B&!A1&!A|!E1&!E&D2&D1&!D&!C&!B1&B&!A1&!A|!E1&!E&D2&!D1&!D&!C&!B1&B&!A1&!A|E1&!E&D2&!D1&!D&!C&!B1&B&!A1&!A|!E1&E&D2&!D1&!D&!C&!B1&B&!A1&!A|!E1&E&!D2&!D1&!D&!C&!B1&B&!A1&!A|E1&!E&!D2&!D1&!D&!C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C&!B1&B&!A1&!A|!E1&!E&!D2&!D1&!D&!C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&!C&!B1&B&A1&!A|!E1&E&!D2&!D1&!D&!C&!B1&B&A1&!A|!E1&E&D2&!D1&!D&!C&!B1&B&A1&!A|E1&!E&D2&!D1&!D&!C&!B1&B&A1&!A|!E1&!E&D2&!D1&!D&!C&!B1&B&A1&!A|!E1&!E&D2&D1&!D&!C&!B1&B&A1&!A|E1&!E&D2&D1&!D&!C&!B1&B&A1&!A|!E1&E&D2&D1&!D&!C&!B1&B&A1&!A|!E1&E&!D2&D1&!D&!C&!B1&B&A1&!A|E1&!E&!D2&D1&!D&!C&!B1&B&A1&!A|!E1&!E&!D2&D1&!D&!C&!B1&B&A1&!A|!E1&!E&!D2&D1&D&!C&!B1&B&A1&!A|E1&!E&!D2&D1&D&!C&!B1&B&A1&!A|!E1&E&!D2&D1&D&!C&!B1&B&A1&!A|!E1&!E&D2&!D1&D&!C&!B1&B&A1&!A|E1&!E&D2&!D1&D&!C&!B1&B&A1&!A|!E1&E&D2&!D1&D&!C&!B1&B&A1&!A|!E1&E&!D2&!D1&D&!C&!B1&B&A1&!A|E1&!E&!D2&!D1&D&!C&!B1&B&A1&!A|!E1&!E&!D2&!D1&D&!C&!B1&B&A1&!A|!E1&!E&!D2&!D1&D&!C&B1&B&A1&!A|E1&!E&!D2&!D1&D&!C&B1&B&A1&!A|!E1&E&!D2&!D1&D&!C&B1&B&A1&!A|!E1&E&D2&!D1&D&!C&B1&B&A1&!A|E1&!E&D2&!D1&D&!C&B1&B&A1&!A|!E1&!E&D2&!D1&D&!C&B1&B&A1&!A|!E1&E&!D2&D1&D&!C&B1&B&A1&!A|E1&!E&!D2&D1&D&!C&B1&B&A1&!A|!E1&!E&!D2&D1&D&!C&B1&B&A1&!A|!E1&!E&!D2&D1&!D&!C&B1&B&A1&!A|E1&!E&!D2&D1&!D&!C&B1&B&A1&!A|!E1&E&!D2&D1&!D&!C&B1&B&A1&!A|!E1&E&D2&D1&!D&!C&B1&B&A1&!A|E1&!E&D2&D1&!D&!C&B1&B&A1&!A|!E1&!E&D2&D1&!D&!C&B1&B&A1&!A|!E1&!E&D2&!D1&!D&!C&B1&B&A1&!A|E1&!E&D2&!D1&!D&!C&B1&B&A1&!A|!E1&E&D2&!D1&!D&!C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&!C&B1&B&A1&!A|E1&!E&!D2&!D1&!D&!C&B1&B&A1&!A|!E1&!E&!D2&!D1&!D&!C&B1&B&A1&!A|!E1&!E&!D2&!D1&!D&!C&B1&!B&A1&!A|E1&!E&!D2&!D1&!D&!C&B1&!B&A1&!A|!E1&E&!D2&!D1&!D&!C&B1&!B&A1&!A|!E1&E&D2&!D1&!D&!C&B1&!B&A1&!A|E1&!E&D2&!D1&!D&!C&B1&!B&A1&!A|!E1&!E&D2&!D1&!D&!C&B1&!B&A1&!A|!E1&!E&D2&D1&!D&!C&B1&!B&A1&!A|E1&!E&D2&D1&!D&!C&B1&!B&A1&!A|!E1&E&D2&D1&!D&!C&B1&!B&A1&!A|!E1&E&!D2&D1&!D&!C&B1&!B&A1&!A|E1&!E&!D2&D1&!D&!C&B1&!B&A1&!A|!E1&!E&!D2&D1&!D&!C&B1&!B&A1&!A|!E1&!E&!D2&D1&D&!C&B1&!B&A1&!A|E1&!E&!D2&D1&D&!C&B1&!B&A1&!A|!E1&E&!D2&D1&D&!C&B1&!B&A1&!A|!E1&!E&D2&!D1&D&!C&B1&!B&A1&!A|E1&!E&D2&!D1&D&!C&B1&!B&A1&!A|!E1&E&D2&!D1&D&!C&B1&!B&A1&!A|!E1&E&!D2&!D1&D&!C&B1&!B&A1&!A|E1&!E&!D2&!D1&D&!C&B1&!B&A1&!A|!E1&!E&!D2&!D1&D&!C&B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&C&!B1&!B&A1&!A|E1&!E&!D2&!D1&!D&C&!B1&!B&A1&!A|!E1&E&!D2&!D1&!D&C&!B1&!B&A1&!A|!E1&E&D2&!D1&!D&C&!B1&!B&A1&!A|E1&!E&D2&!D1&!D&C&!B1&!B&A1&!A|!E1&!E&D2&!D1&!D&C&!B1&!B&A1&!A|!E1&!E&D2&D1&!D&C&!B1&!B&A1&!A|E1&!E&D2&D1&!D&C&!B1&!B&A1&!A|!E1&E&D2&D1&!D&C&!B1&!B&A1&!A|!E1&E&!D2&D1&!D&C&!B1&!B&A1&!A|E1&!E&!D2&D1&!D&C&!B1&!B&A1&!A|!E1&!E&!D2&D1&!D&C&!B1&!B&A1&!A|!E1&!E&!D2&D1&D&C&!B1&!B&A1&!A|E1&!E&!D2&D1&D&C&!B1&!B&A1&!A|!E1&E&!D2&D1&D&C&!B1&!B&A1&!A|!E1&!E&D2&!D1&D&C&!B1&!B&A1&!A|E1&!E&D2&!D1&D&C&!B1&!B&A1&!A|!E1&E&D2&!D1&D&C&!B1&!B&A1&!A|!E1&E&!D2&!D1&D&C&!B1&!B&A1&!A|E1&!E&!D2&!D1&D&C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&D&C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&D&!C&!B1&!B&A1&!A|E1&!E&!D2&!D1&D&!C&!B1&!B&A1&!A|!E1&E&!D2&!D1&D&!C&!B1&!B&A1&!A|!E1&E&D2&!D1&D&!C&!B1&!B&A1&!A|E1&!E&D2&!D1&D&!C&!B1&!B&A1&!A|!E1&!E&D2&!D1&D&!C&!B1&!B&A1&!A|!E1&E&!D2&D1&D&!C&!B1&!B&A1&!A|E1&!E&!D2&D1&D&!C&!B1&!B&A1&!A|!E1&!E&!D2&D1&D&!C&!B1&!B&A1&!A|!E1&!E&!D2&D1&!D&!C&!B1&!B&A1&!A|E1&!E&!D2&D1&!D&!C&!B1&!B&A1&!A|!E1&E&!D2&D1&!D&!C&!B1&!B&A1&!A|!E1&E&D2&D1&!D&!C&!B1&!B&A1&!A|E1&!E&D2&D1&!D&!C&!B1&!B&A1&!A|!E1&!E&D2&D1&!D&!C&!B1&!B&A1&!A|!E1&!E&D2&!D1&!D&!C&!B1&!B&A1&!A|E1&!E&D2&!D1&!D&!C&!B1&!B&A1&!A|!E1&E&D2&!D1&!D&!C&!B1&!B&A1&!A|!E1&E&!D2&!D1&!D&!C&!B1&!B&A1&!A|E1&!E&!D2&!D1&!D&!C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C&!B1&!B&A1&!A|!E1&!E&!D2&!D1&!D&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&!C&!B1&!B&A1&A|!E1&E&D2&!D1&!D&!C&!B1&!B&A1&A|E1&!E&D2&!D1&!D&!C&!B1&!B&A1&A|!E1&!E&D2&!D1&!D&!C&!B1&!B&A1&A|!E1&!E&D2&D1&!D&!C&!B1&!B&A1&A|E1&!E&D2&D1&!D&!C&!B1&!B&A1&A|!E1&E&D2&D1&!D&!C&!B1&!B&A1&A|!E1&E&!D2&D1&!D&!C&!B1&!B&A1&A|E1&!E&!D2&D1&!D&!C&!B1&!B&A1&A|!E1&!E&!D2&D1&!D&!C&!B1&!B&A1&A|!E1&!E&!D2&D1&D&!C&!B1&!B&A1&A|E1&!E&!D2&D1&D&!C&!B1&!B&A1&A|!E1&E&!D2&D1&D&!C&!B1&!B&A1&A|!E1&!E&D2&!D1&D&!C&!B1&!B&A1&A|E1&!E&D2&!D1&D&!C&!B1&!B&A1&A|!E1&E&D2&!D1&D&!C&!B1&!B&A1&A|!E1&E&!D2&!D1&D&!C&!B1&!B&A1&A|E1&!E&!D2&!D1&D&!C&!B1&!B&A1&A|!E1&!E&!D2&!D1&D&!C&!B1&!B&A1&A|!E1&!E&!D2&!D1&D&C&!B1&!B&A1&A|E1&!E&!D2&!D1&D&C&!B1&!B&A1&A|!E1&E&!D2&!D1&D&C&!B1&!B&A1&A|!E1&E&D2&!D1&D&C&!B1&!B&A1&A|E1&!E&D2&!D1&D&C&!B1&!B&A1&A|!E1&!E&D2&!D1&D&C&!B1&!B&A1&A|!E1&E&!D2&D1&D&C&!B1&!B&A1&A|E1&!E&!D2&D1&D&C&!B1&!B&A1&A|!E1&!E&!D2&D1&D&C&!B1&!B&A1&A|!E1&!E&!D2&D1&!D&C&!B1&!B&A1&A|E1&!E&!D2&D1&!D&C&!B1&!B&A1&A|!E1&E&!D2&D1&!D&C&!B1&!B&A1&A|!E1&E&D2&D1&!D&C&!B1&!B&A1&A|E1&!E&D2&D1&!D&C&!B1&!B&A1&A|!E1&!E&D2&D1&!D&C&!B1&!B&A1&A|!E1&!E&D2&!D1&!D&C&!B1&!B&A1&A|E1&!E&D2&!D1&!D&C&!B1&!B&A1&A|!E1&E&D2&!D1&!D&C&!B1&!B&A1&A|!E1&E&!D2&!D1&!D&C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&C&!B1&!B&A1&A|!E1&!E&!D2&!D1&!D&C&!B1&!B&A1&A|!E1&!E&!D2&!D1&D&!C&B1&!B&A1&A|E1&!E&!D2&!D1&D&!C&B1&!B&A1&A|!E1&E&!D2&!D1&D&!C&B1&!B&A1&A|!E1&E&D2&!D1&D&!C&B1&!B&A1&A|E1&!E&D2&!D1&D&!C&B1&!B&A1&A|!E1&!E&D2&!D1&D&!C&B1&!B&A1&A|!E1&E&!D2&D1&D&!C&B1&!B&A1&A|E1&!E&!D2&D1&D&!C&B1&!B&A1&A|!E1&!E&!D2&D1&D&!C&B1&!B&A1&A|!E1&!E&!D2&D1&!D&!C&B1&!B&A1&A|E1&!E&!D2&D1&!D&!C&B1&!B&A1&A|!E1&E&!D2&D1&!D&!C&B1&!B&A1&A|!E1&E&D2&D1&!D&!C&B1&!B&A1&A|E1&!E&D2&D1&!D&!C&B1&!B&A1&A|!E1&!E&D2&D1&!D&!C&B1&!B&A1&A|!E1&!E&D2&!D1&!D&!C&B1&!B&A1&A|E1&!E&D2&!D1&!D&!C&B1&!B&A1&A|!E1&E&D2&!D1&!D&!C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&!C&B1&!B&A1&A|E1&!E&!D2&!D1&!D&!C&B1&!B&A1&A|!E1&!E&!D2&!D1&!D&!C&B1&!B&A1&A|!E1&!E&!D2&!D1&!D&!C&B1&B&A1&A|E1&!E&!D2&!D1&!D&!C&B1&B&A1&A|!E1&E&!D2&!D1&!D&!C&B1&B&A1&A|!E1&E&D2&!D1&!D&!C&B1&B&A1&A|E1&!E&D2&!D1&!D&!C&B1&B&A1&A|!E1&!E&D2&!D1&!D&!C&B1&B&A1&A|!E1&!E&D2&D1&!D&!C&B1&B&A1&A|E1&!E&D2&D1&!D&!C&B1&B&A1&A|!E1&E&D2&D1&!D&!C&B1&B&A1&A|!E1&E&!D2&D1&!D&!C&B1&B&A1&A|E1&!E&!D2&D1&!D&!C&B1&B&A1&A|!E1&!E&!D2&D1&!D&!C&B1&B&A1&A|!E1&!E&!D2&D1&D&!C&B1&B&A1&A|E1&!E&!D2&D1&D&!C&B1&B&A1&A|!E1&E&!D2&D1&D&!C&B1&B&A1&A|!E1&!E&D2&!D1&D&!C&B1&B&A1&A|E1&!E&D2&!D1&D&!C&B1&B&A1&A|!E1&E&D2&!D1&D&!C&B1&B&A1&A|!E1&E&!D2&!D1&D&!C&B1&B&A1&A|E1&!E&!D2&!D1&D&!C&B1&B&A1&A|!E1&!E&!D2&!D1&D&!C&B1&B&A1&A|!E1&!E&!D2&!D1&D&!C&!B1&B&A1&A|E1&!E&!D2&!D1&D&!C&!B1&B&A1&A|!E1&E&!D2&!D1&D&!C&!B1&B&A1&A|!E1&E&D2&!D1&D&!C&!B1&B&A1&A|E1&!E&D2&!D1&D&!C&!B1&B&A1&A|!E1&!E&D2&!D1&D&!C&!B1&B&A1&A|!E1&E&!D2&D1&D&!C&!B1&B&A1&A|E1&!E&!D2&D1&D&!C&!B1&B&A1&A|!E1&!E&!D2&D1&D&!C&!B1&B&A1&A|!E1&!E&!D2&D1&!D&!C&!B1&B&A1&A|E1&!E&!D2&D1&!D&!C&!B1&B&A1&A|!E1&E&!D2&D1&!D&!C&!B1&B&A1&A|!E1&E&D2&D1&!D&!C&!B1&B&A1&A|E1&!E&D2&D1&!D&!C&!B1&B&A1&A|!E1&!E&D2&D1&!D&!C&!B1&B&A1&A|!E1&!E&D2&!D1&!D&!C&!B1&B&A1&A|E1&!E&D2&!D1&!D&!C&!B1&B&A1&A|!E1&E&D2&!D1&!D&!C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&!C&!B1&B&A1&A|E1&!E&!D2&!D1&!D&!C&!B1&B&A1&A|!E1&!E&!D2&!D1&!D&!C&!B1&B&A1&A|!E1&!E&!D2&!D1&!D&!C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&!C&!B1&B&!A1&A|!E1&E&!D2&!D1&!D&!C&!B1&B&!A1&A|!E1&E&D2&!D1&!D&!C&!B1&B&!A1&A|E1&!E&D2&!D1&!D&!C&!B1&B&!A1&A|!E1&!E&D2&!D1&!D&!C&!B1&B&!A1&A|!E1&!E&D2&D1&!D&!C&!B1&B&!A1&A|E1&!E&D2&D1&!D&!C&!B1&B&!A1&A|!E1&E&D2&D1&!D&!C&!B1&B&!A1&A|!E1&E&!D2&D1&!D&!C&!B1&B&!A1&A|E1&!E&!D2&D1&!D&!C&!B1&B&!A1&A|!E1&!E&!D2&D1&!D&!C&!B1&B&!A1&A|!E1&!E&!D2&D1&D&!C&!B1&B&!A1&A|E1&!E&!D2&D1&D&!C&!B1&B&!A1&A|!E1&E&!D2&D1&D&!C&!B1&B&!A1&A|!E1&!E&D2&!D1&D&!C&!B1&B&!A1&A|E1&!E&D2&!D1&D&!C&!B1&B&!A1&A|!E1&E&D2&!D1&D&!C&!B1&B&!A1&A|!E1&E&!D2&!D1&D&!C&!B1&B&!A1&A|E1&!E&!D2&!D1&D&!C&!B1&B&!A1&A|!E1&!E&!D2&!D1&D&!C&!B1&B&!A1&A|!E1&!E&!D2&!D1&D&!C&B1&B&!A1&A|E1&!E&!D2&!D1&D&!C&B1&B&!A1&A|!E1&E&!D2&!D1&D&!C&B1&B&!A1&A|!E1&E&D2&!D1&D&!C&B1&B&!A1&A|E1&!E&D2&!D1&D&!C&B1&B&!A1&A|!E1&!E&D2&!D1&D&!C&B1&B&!A1&A|!E1&E&!D2&D1&D&!C&B1&B&!A1&A|E1&!E&!D2&D1&D&!C&B1&B&!A1&A|!E1&!E&!D2&D1&D&!C&B1&B&!A1&A|!E1&!E&!D2&D1&!D&!C&B1&B&!A1&A|E1&!E&!D2&D1&!D&!C&B1&B&!A1&A|!E1&E&!D2&D1&!D&!C&B1&B&!A1&A|!E1&E&D2&D1&!D&!C&B1&B&!A1&A|E1&!E&D2&D1&!D&!C&B1&B&!A1&A|!E1&!E&D2&D1&!D&!C&B1&B&!A1&A|!E1&!E&D2&!D1&!D&!C&B1&B&!A1&A|E1&!E&D2&!D1&!D&!C&B1&B&!A1&A|!E1&E&D2&!D1&!D&!C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&!C&B1&B&!A1&A|E1&!E&!D2&!D1&!D&!C&B1&B&!A1&A|!E1&!E&!D2&!D1&!D&!C&B1&B&!A1&A|!E1&!E&!D2&!D1&!D&!C&B1&!B&!A1&A|E1&!E&!D2&!D1&!D&!C&B1&!B&!A1&A|!E1&E&!D2&!D1&!D&!C&B1&!B&!A1&A|!E1&E&D2&!D1&!D&!C&B1&!B&!A1&A|E1&!E&D2&!D1&!D&!C&B1&!B&!A1&A|!E1&!E&D2&!D1&!D&!C&B1&!B&!A1&A|!E1&!E&D2&D1&!D&!C&B1&!B&!A1&A|E1&!E&D2&D1&!D&!C&B1&!B&!A1&A|!E1&E&D2&D1&!D&!C&B1&!B&!A1&A|!E1&E&!D2&D1&!D&!C&B1&!B&!A1&A|E1&!E&!D2&D1&!D&!C&B1&!B&!A1&A|!E1&!E&!D2&D1&!D&!C&B1&!B&!A1&A|!E1&!E&!D2&D1&D&!C&B1&!B&!A1&A|E1&!E&!D2&D1&D&!C&B1&!B&!A1&A|!E1&E&!D2&D1&D&!C&B1&!B&!A1&A|!E1&!E&D2&!D1&D&!C&B1&!B&!A1&A|E1&!E&D2&!D1&D&!C&B1&!B&!A1&A|!E1&E&D2&!D1&D&!C&B1&!B&!A1&A|!E1&E&!D2&!D1&D&!C&B1&!B&!A1&A|E1&!E&!D2&!D1&D&!C&B1&!B&!A1&A|!E1&!E&!D2&!D1&D&!C&B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&C&!B1&!B&!A1&A|E1&!E&!D2&!D1&!D&C&!B1&!B&!A1&A|!E1&E&!D2&!D1&!D&C&!B1&!B&!A1&A|!E1&E&D2&!D1&!D&C&!B1&!B&!A1&A|E1&!E&D2&!D1&!D&C&!B1&!B&!A1&A|!E1&!E&D2&!D1&!D&C&!B1&!B&!A1&A|!E1&!E&D2&D1&!D&C&!B1&!B&!A1&A|E1&!E&D2&D1&!D&C&!B1&!B&!A1&A|!E1&E&D2&D1&!D&C&!B1&!B&!A1&A|!E1&E&!D2&D1&!D&C&!B1&!B&!A1&A|E1&!E&!D2&D1&!D&C&!B1&!B&!A1&A|!E1&!E&!D2&D1&!D&C&!B1&!B&!A1&A|!E1&!E&!D2&D1&D&C&!B1&!B&!A1&A|E1&!E&!D2&D1&D&C&!B1&!B&!A1&A|!E1&E&!D2&D1&D&C&!B1&!B&!A1&A|!E1&!E&D2&!D1&D&C&!B1&!B&!A1&A|E1&!E&D2&!D1&D&C&!B1&!B&!A1&A|!E1&E&D2&!D1&D&C&!B1&!B&!A1&A|!E1&E&!D2&!D1&D&C&!B1&!B&!A1&A|E1&!E&!D2&!D1&D&C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&D&C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&D&!C&!B1&!B&!A1&A|E1&!E&!D2&!D1&D&!C&!B1&!B&!A1&A|!E1&E&!D2&!D1&D&!C&!B1&!B&!A1&A|!E1&E&D2&!D1&D&!C&!B1&!B&!A1&A|E1&!E&D2&!D1&D&!C&!B1&!B&!A1&A|!E1&!E&D2&!D1&D&!C&!B1&!B&!A1&A|!E1&E&!D2&D1&D&!C&!B1&!B&!A1&A|E1&!E&!D2&D1&D&!C&!B1&!B&!A1&A|!E1&!E&!D2&D1&D&!C&!B1&!B&!A1&A|!E1&!E&!D2&D1&!D&!C&!B1&!B&!A1&A|E1&!E&!D2&D1&!D&!C&!B1&!B&!A1&A|!E1&E&!D2&D1&!D&!C&!B1&!B&!A1&A|!E1&E&D2&D1&!D&!C&!B1&!B&!A1&A|E1&!E&D2&D1&!D&!C&!B1&!B&!A1&A|!E1&!E&D2&D1&!D&!C&!B1&!B&!A1&A|!E1&!E&D2&!D1&!D&!C&!B1&!B&!A1&A|E1&!E&D2&!D1&!D&!C&!B1&!B&!A1&A|!E1&E&D2&!D1&!D&!C&!B1&!B&!A1&A|!E1&E&!D2&!D1&!D&!C&!B1&!B&!A1&A|E1&!E&!D2&!D1&!D&!C&!B1&!B&!A1&A|!E1&!E&!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAAOI22132.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAOI2222 -l AAOOAOI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B1&!B&!A1&!A|!D1&!D&C1&!C&!B1&!B&!A1&!A|!D1&!D&C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&!B1&!B&!A1&!A|!D1&!D&!C1&C&B1&!B&!A1&!A|!D1&!D&C1&C&B1&!B&!A1&!A|!D1&!D&C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&!B&!A1&!A|!D1&!D&!C1&!C&B1&B&!A1&!A|!D1&!D&!C1&C&!B1&B&!A1&!A|!D1&!D&C1&C&!B1&B&!A1&!A|!D1&!D&C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&!A1&!A|!D1&!D&!C1&!C&!B1&B&A1&!A|!D1&!D&C1&!C&!B1&B&A1&!A|!D1&!D&C1&C&!B1&B&A1&!A|!D1&!D&!C1&C&!B1&B&A1&!A|!D1&!D&!C1&!C&B1&B&A1&!A|!D1&!D&!C1&!C&B1&!B&A1&!A|!D1&!D&C1&!C&B1&!B&A1&!A|!D1&!D&C1&C&B1&!B&A1&!A|!D1&!D&!C1&C&B1&!B&A1&!A|!D1&!D&!C1&C&!B1&!B&A1&!A|!D1&!D&C1&C&!B1&!B&A1&!A|!D1&!D&C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&!A|!D1&!D&!C1&!C&!B1&!B&A1&A|!D1&!D&!C1&!C&B1&!B&A1&A|!D1&!D&!C1&!C&B1&B&A1&A|!D1&!D&!C1&!C&!B1&B&A1&A|!D1&!D&!C1&!C&!B1&B&!A1&A|!D1&!D&C1&!C&!B1&B&!A1&A|!D1&!D&C1&C&!B1&B&!A1&A|!D1&!D&!C1&C&!B1&B&!A1&A|!D1&!D&!C1&!C&B1&B&!A1&A|!D1&!D&!C1&!C&B1&!B&!A1&A|!D1&!D&C1&!C&B1&!B&!A1&A|!D1&!D&C1&C&B1&!B&!A1&A|!D1&!D&!C1&C&B1&!B&!A1&A|!D1&!D&!C1&C&!B1&!B&!A1&A|!D1&!D&C1&C&!B1&!B&!A1&A|!D1&!D&C1&!C&!B1&!B&!A1&A|!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAOI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOI22141 -l OOAAOI22141 -i E D3 D2 D1 D C B1 B A1 A -o Y -f Y=(!E&!D3&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&!C&!B1&!B&!A1&!A|!E&D3&D2&!D1&!D&!C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&!C&!B1&!B&!A1&!A|!E&!D3&D2&D1&!D&!C&!B1&!B&!A1&!A|!E&D3&D2&D1&!D&!C&!B1&!B&!A1&!A|!E&D3&!D2&D1&!D&!C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&!C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&D&!C&!B1&!B&!A1&!A|!E&D3&!D2&D1&D&!C&!B1&!B&!A1&!A|!E&!D3&D2&D1&D&!C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&D&!C&!B1&!B&!A1&!A|!E&D3&D2&!D1&D&!C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&D&!C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&!C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&D&C&!B1&!B&!A1&!A|!E&D3&D2&!D1&D&C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&D&C&!B1&!B&!A1&!A|!E&!D3&D2&D1&D&C&!B1&!B&!A1&!A|!E&D3&!D2&D1&D&C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&D&C&!B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&C&!B1&!B&!A1&!A|!E&D3&!D2&D1&!D&C&!B1&!B&!A1&!A|!E&D3&D2&D1&!D&C&!B1&!B&!A1&!A|!E&!D3&D2&D1&!D&C&!B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&C&!B1&!B&!A1&!A|!E&D3&D2&!D1&!D&C&!B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&C&!B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&C&B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&C&B1&!B&!A1&!A|!E&D3&D2&!D1&!D&C&B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&C&B1&!B&!A1&!A|!E&!D3&D2&D1&!D&C&B1&!B&!A1&!A|!E&D3&D2&D1&!D&C&B1&!B&!A1&!A|!E&D3&!D2&D1&!D&C&B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&C&B1&!B&!A1&!A|!E&!D3&!D2&D1&D&C&B1&!B&!A1&!A|!E&D3&!D2&D1&D&C&B1&!B&!A1&!A|!E&!D3&D2&D1&D&C&B1&!B&!A1&!A|!E&!D3&D2&!D1&D&C&B1&!B&!A1&!A|!E&D3&D2&!D1&D&C&B1&!B&!A1&!A|!E&D3&!D2&!D1&D&C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&D&!C&B1&!B&!A1&!A|!E&D3&!D2&!D1&D&!C&B1&!B&!A1&!A|!E&D3&D2&!D1&D&!C&B1&!B&!A1&!A|!E&!D3&D2&!D1&D&!C&B1&!B&!A1&!A|!E&!D3&D2&D1&D&!C&B1&!B&!A1&!A|!E&D3&!D2&D1&D&!C&B1&!B&!A1&!A|!E&!D3&!D2&D1&D&!C&B1&!B&!A1&!A|!E&!D3&!D2&D1&!D&!C&B1&!B&!A1&!A|!E&D3&!D2&D1&!D&!C&B1&!B&!A1&!A|!E&D3&D2&D1&!D&!C&B1&!B&!A1&!A|!E&!D3&D2&D1&!D&!C&B1&!B&!A1&!A|!E&!D3&D2&!D1&!D&!C&B1&!B&!A1&!A|!E&D3&D2&!D1&!D&!C&B1&!B&!A1&!A|!E&D3&!D2&!D1&!D&!C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&!C&B1&!B&!A1&!A|!E&!D3&!D2&!D1&!D&!C&B1&B&!A1&!A|!E&D3&!D2&!D1&!D&!C&B1&B&!A1&!A|!E&D3&D2&!D1&!D&!C&B1&B&!A1&!A|!E&!D3&D2&!D1&!D&!C&B1&B&!A1&!A|!E&!D3&D2&D1&!D&!C&B1&B&!A1&!A|!E&D3&D2&D1&!D&!C&B1&B&!A1&!A|!E&D3&!D2&D1&!D&!C&B1&B&!A1&!A|!E&!D3&!D2&D1&!D&!C&B1&B&!A1&!A|!E&!D3&!D2&D1&D&!C&B1&B&!A1&!A|!E&D3&!D2&D1&D&!C&B1&B&!A1&!A|!E&!D3&D2&D1&D&!C&B1&B&!A1&!A|!E&!D3&D2&!D1&D&!C&B1&B&!A1&!A|!E&D3&D2&!D1&D&!C&B1&B&!A1&!A|!E&D3&!D2&!D1&D&!C&B1&B&!A1&!A|!E&!D3&!D2&!D1&D&!C&B1&B&!A1&!A|!E&!D3&!D2&!D1&D&C&B1&B&!A1&!A|!E&D3&!D2&!D1&D&C&B1&B&!A1&!A|!E&D3&D2&!D1&D&C&B1&B&!A1&!A|!E&!D3&D2&!D1&D&C&B1&B&!A1&!A|!E&!D3&D2&D1&D&C&B1&B&!A1&!A|!E&D3&!D2&D1&D&C&B1&B&!A1&!A|!E&!D3&!D2&D1&D&C&B1&B&!A1&!A|!E&!D3&!D2&D1&!D&C&B1&B&!A1&!A|!E&D3&!D2&D1&!D&C&B1&B&!A1&!A|!E&D3&D2&D1&!D&C&B1&B&!A1&!A|!E&!D3&D2&D1&!D&C&B1&B&!A1&!A|!E&!D3&D2&!D1&!D&C&B1&B&!A1&!A|!E&D3&D2&!D1&!D&C&B1&B&!A1&!A|!E&D3&!D2&!D1&!D&C&B1&B&!A1&!A|!E&!D3&!D2&!D1&!D&C&B1&B&!A1&!A|!E&!D3&!D2&!D1&!D&C&!B1&B&!A1&!A|!E&D3&!D2&!D1&!D&C&!B1&B&!A1&!A|!E&D3&D2&!D1&!D&C&!B1&B&!A1&!A|!E&!D3&D2&!D1&!D&C&!B1&B&!A1&!A|!E&!D3&D2&D1&!D&C&!B1&B&!A1&!A|!E&D3&D2&D1&!D&C&!B1&B&!A1&!A|!E&D3&!D2&D1&!D&C&!B1&B&!A1&!A|!E&!D3&!D2&D1&!D&C&!B1&B&!A1&!A|!E&!D3&!D2&D1&D&C&!B1&B&!A1&!A|!E&D3&!D2&D1&D&C&!B1&B&!A1&!A|!E&!D3&D2&D1&D&C&!B1&B&!A1&!A|!E&!D3&D2&!D1&D&C&!B1&B&!A1&!A|!E&D3&D2&!D1&D&C&!B1&B&!A1&!A|!E&D3&!D2&!D1&D&C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&D&C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&D&!C&!B1&B&!A1&!A|!E&D3&!D2&!D1&D&!C&!B1&B&!A1&!A|!E&D3&D2&!D1&D&!C&!B1&B&!A1&!A|!E&!D3&D2&!D1&D&!C&!B1&B&!A1&!A|!E&!D3&D2&D1&D&!C&!B1&B&!A1&!A|!E&D3&!D2&D1&D&!C&!B1&B&!A1&!A|!E&!D3&!D2&D1&D&!C&!B1&B&!A1&!A|!E&!D3&!D2&D1&!D&!C&!B1&B&!A1&!A|!E&D3&!D2&D1&!D&!C&!B1&B&!A1&!A|!E&D3&D2&D1&!D&!C&!B1&B&!A1&!A|!E&!D3&D2&D1&!D&!C&!B1&B&!A1&!A|!E&!D3&D2&!D1&!D&!C&!B1&B&!A1&!A|!E&D3&D2&!D1&!D&!C&!B1&B&!A1&!A|!E&D3&!D2&!D1&!D&!C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&!D&!C&!B1&B&!A1&!A|!E&!D3&!D2&!D1&!D&!C&!B1&B&A1&!A|!E&D3&!D2&!D1&!D&!C&!B1&B&A1&!A|!E&D3&D2&!D1&!D&!C&!B1&B&A1&!A|!E&!D3&D2&!D1&!D&!C&!B1&B&A1&!A|!E&!D3&D2&D1&!D&!C&!B1&B&A1&!A|!E&D3&D2&D1&!D&!C&!B1&B&A1&!A|!E&D3&!D2&D1&!D&!C&!B1&B&A1&!A|!E&!D3&!D2&D1&!D&!C&!B1&B&A1&!A|!E&!D3&!D2&D1&D&!C&!B1&B&A1&!A|!E&D3&!D2&D1&D&!C&!B1&B&A1&!A|!E&!D3&D2&D1&D&!C&!B1&B&A1&!A|!E&!D3&D2&!D1&D&!C&!B1&B&A1&!A|!E&D3&D2&!D1&D&!C&!B1&B&A1&!A|!E&D3&!D2&!D1&D&!C&!B1&B&A1&!A|!E&!D3&!D2&!D1&D&!C&!B1&B&A1&!A|!E&!D3&!D2&!D1&D&!C&B1&B&A1&!A|!E&D3&!D2&!D1&D&!C&B1&B&A1&!A|!E&D3&D2&!D1&D&!C&B1&B&A1&!A|!E&!D3&D2&!D1&D&!C&B1&B&A1&!A|!E&!D3&D2&D1&D&!C&B1&B&A1&!A|!E&D3&!D2&D1&D&!C&B1&B&A1&!A|!E&!D3&!D2&D1&D&!C&B1&B&A1&!A|!E&!D3&!D2&D1&!D&!C&B1&B&A1&!A|!E&D3&!D2&D1&!D&!C&B1&B&A1&!A|!E&D3&D2&D1&!D&!C&B1&B&A1&!A|!E&!D3&D2&D1&!D&!C&B1&B&A1&!A|!E&!D3&D2&!D1&!D&!C&B1&B&A1&!A|!E&D3&D2&!D1&!D&!C&B1&B&A1&!A|!E&D3&!D2&!D1&!D&!C&B1&B&A1&!A|!E&!D3&!D2&!D1&!D&!C&B1&B&A1&!A|!E&!D3&!D2&!D1&!D&!C&B1&!B&A1&!A|!E&D3&!D2&!D1&!D&!C&B1&!B&A1&!A|!E&D3&D2&!D1&!D&!C&B1&!B&A1&!A|!E&!D3&D2&!D1&!D&!C&B1&!B&A1&!A|!E&!D3&D2&D1&!D&!C&B1&!B&A1&!A|!E&D3&D2&D1&!D&!C&B1&!B&A1&!A|!E&D3&!D2&D1&!D&!C&B1&!B&A1&!A|!E&!D3&!D2&D1&!D&!C&B1&!B&A1&!A|!E&!D3&!D2&D1&D&!C&B1&!B&A1&!A|!E&D3&!D2&D1&D&!C&B1&!B&A1&!A|!E&!D3&D2&D1&D&!C&B1&!B&A1&!A|!E&!D3&D2&!D1&D&!C&B1&!B&A1&!A|!E&D3&D2&!D1&D&!C&B1&!B&A1&!A|!E&D3&!D2&!D1&D&!C&B1&!B&A1&!A|!E&!D3&!D2&!D1&D&!C&B1&!B&A1&!A|!E&!D3&!D2&!D1&!D&C&!B1&!B&A1&!A|!E&D3&!D2&!D1&!D&C&!B1&!B&A1&!A|!E&D3&D2&!D1&!D&C&!B1&!B&A1&!A|!E&!D3&D2&!D1&!D&C&!B1&!B&A1&!A|!E&!D3&D2&D1&!D&C&!B1&!B&A1&!A|!E&D3&D2&D1&!D&C&!B1&!B&A1&!A|!E&D3&!D2&D1&!D&C&!B1&!B&A1&!A|!E&!D3&!D2&D1&!D&C&!B1&!B&A1&!A|!E&!D3&!D2&D1&D&C&!B1&!B&A1&!A|!E&D3&!D2&D1&D&C&!B1&!B&A1&!A|!E&!D3&D2&D1&D&C&!B1&!B&A1&!A|!E&!D3&D2&!D1&D&C&!B1&!B&A1&!A|!E&D3&D2&!D1&D&C&!B1&!B&A1&!A|!E&D3&!D2&!D1&D&C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&D&C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&D&!C&!B1&!B&A1&!A|!E&D3&!D2&!D1&D&!C&!B1&!B&A1&!A|!E&D3&D2&!D1&D&!C&!B1&!B&A1&!A|!E&!D3&D2&!D1&D&!C&!B1&!B&A1&!A|!E&!D3&D2&D1&D&!C&!B1&!B&A1&!A|!E&D3&!D2&D1&D&!C&!B1&!B&A1&!A|!E&!D3&!D2&D1&D&!C&!B1&!B&A1&!A|!E&!D3&!D2&D1&!D&!C&!B1&!B&A1&!A|!E&D3&!D2&D1&!D&!C&!B1&!B&A1&!A|!E&D3&D2&D1&!D&!C&!B1&!B&A1&!A|!E&!D3&D2&D1&!D&!C&!B1&!B&A1&!A|!E&!D3&D2&!D1&!D&!C&!B1&!B&A1&!A|!E&D3&D2&!D1&!D&!C&!B1&!B&A1&!A|!E&D3&!D2&!D1&!D&!C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&!D&!C&!B1&!B&A1&!A|!E&!D3&!D2&!D1&!D&!C&!B1&!B&A1&A|!E&D3&!D2&!D1&!D&!C&!B1&!B&A1&A|!E&D3&D2&!D1&!D&!C&!B1&!B&A1&A|!E&!D3&D2&!D1&!D&!C&!B1&!B&A1&A|!E&!D3&D2&D1&!D&!C&!B1&!B&A1&A|!E&D3&D2&D1&!D&!C&!B1&!B&A1&A|!E&D3&!D2&D1&!D&!C&!B1&!B&A1&A|!E&!D3&!D2&D1&!D&!C&!B1&!B&A1&A|!E&!D3&!D2&D1&D&!C&!B1&!B&A1&A|!E&D3&!D2&D1&D&!C&!B1&!B&A1&A|!E&!D3&D2&D1&D&!C&!B1&!B&A1&A|!E&!D3&D2&!D1&D&!C&!B1&!B&A1&A|!E&D3&D2&!D1&D&!C&!B1&!B&A1&A|!E&D3&!D2&!D1&D&!C&!B1&!B&A1&A|!E&!D3&!D2&!D1&D&!C&!B1&!B&A1&A|!E&!D3&!D2&!D1&D&C&!B1&!B&A1&A|!E&D3&!D2&!D1&D&C&!B1&!B&A1&A|!E&D3&D2&!D1&D&C&!B1&!B&A1&A|!E&!D3&D2&!D1&D&C&!B1&!B&A1&A|!E&!D3&D2&D1&D&C&!B1&!B&A1&A|!E&D3&!D2&D1&D&C&!B1&!B&A1&A|!E&!D3&!D2&D1&D&C&!B1&!B&A1&A|!E&!D3&!D2&D1&!D&C&!B1&!B&A1&A|!E&D3&!D2&D1&!D&C&!B1&!B&A1&A|!E&D3&D2&D1&!D&C&!B1&!B&A1&A|!E&!D3&D2&D1&!D&C&!B1&!B&A1&A|!E&!D3&D2&!D1&!D&C&!B1&!B&A1&A|!E&D3&D2&!D1&!D&C&!B1&!B&A1&A|!E&D3&!D2&!D1&!D&C&!B1&!B&A1&A|!E&!D3&!D2&!D1&!D&C&!B1&!B&A1&A|!E&!D3&!D2&!D1&D&!C&B1&!B&A1&A|!E&D3&!D2&!D1&D&!C&B1&!B&A1&A|!E&D3&D2&!D1&D&!C&B1&!B&A1&A|!E&!D3&D2&!D1&D&!C&B1&!B&A1&A|!E&!D3&D2&D1&D&!C&B1&!B&A1&A|!E&D3&!D2&D1&D&!C&B1&!B&A1&A|!E&!D3&!D2&D1&D&!C&B1&!B&A1&A|!E&!D3&!D2&D1&!D&!C&B1&!B&A1&A|!E&D3&!D2&D1&!D&!C&B1&!B&A1&A|!E&D3&D2&D1&!D&!C&B1&!B&A1&A|!E&!D3&D2&D1&!D&!C&B1&!B&A1&A|!E&!D3&D2&!D1&!D&!C&B1&!B&A1&A|!E&D3&D2&!D1&!D&!C&B1&!B&A1&A|!E&D3&!D2&!D1&!D&!C&B1&!B&A1&A|!E&!D3&!D2&!D1&!D&!C&B1&!B&A1&A|!E&!D3&!D2&!D1&!D&!C&B1&B&A1&A|!E&D3&!D2&!D1&!D&!C&B1&B&A1&A|!E&D3&D2&!D1&!D&!C&B1&B&A1&A|!E&!D3&D2&!D1&!D&!C&B1&B&A1&A|!E&!D3&D2&D1&!D&!C&B1&B&A1&A|!E&D3&D2&D1&!D&!C&B1&B&A1&A|!E&D3&!D2&D1&!D&!C&B1&B&A1&A|!E&!D3&!D2&D1&!D&!C&B1&B&A1&A|!E&!D3&!D2&D1&D&!C&B1&B&A1&A|!E&D3&!D2&D1&D&!C&B1&B&A1&A|!E&!D3&D2&D1&D&!C&B1&B&A1&A|!E&!D3&D2&!D1&D&!C&B1&B&A1&A|!E&D3&D2&!D1&D&!C&B1&B&A1&A|!E&D3&!D2&!D1&D&!C&B1&B&A1&A|!E&!D3&!D2&!D1&D&!C&B1&B&A1&A|!E&!D3&!D2&!D1&D&!C&!B1&B&A1&A|!E&D3&!D2&!D1&D&!C&!B1&B&A1&A|!E&D3&D2&!D1&D&!C&!B1&B&A1&A|!E&!D3&D2&!D1&D&!C&!B1&B&A1&A|!E&!D3&D2&D1&D&!C&!B1&B&A1&A|!E&D3&!D2&D1&D&!C&!B1&B&A1&A|!E&!D3&!D2&D1&D&!C&!B1&B&A1&A|!E&!D3&!D2&D1&!D&!C&!B1&B&A1&A|!E&D3&!D2&D1&!D&!C&!B1&B&A1&A|!E&D3&D2&D1&!D&!C&!B1&B&A1&A|!E&!D3&D2&D1&!D&!C&!B1&B&A1&A|!E&!D3&D2&!D1&!D&!C&!B1&B&A1&A|!E&D3&D2&!D1&!D&!C&!B1&B&A1&A|!E&D3&!D2&!D1&!D&!C&!B1&B&A1&A|!E&!D3&!D2&!D1&!D&!C&!B1&B&A1&A|!E&!D3&!D2&!D1&!D&!C&!B1&B&!A1&A|!E&D3&!D2&!D1&!D&!C&!B1&B&!A1&A|!E&D3&D2&!D1&!D&!C&!B1&B&!A1&A|!E&!D3&D2&!D1&!D&!C&!B1&B&!A1&A|!E&!D3&D2&D1&!D&!C&!B1&B&!A1&A|!E&D3&D2&D1&!D&!C&!B1&B&!A1&A|!E&D3&!D2&D1&!D&!C&!B1&B&!A1&A|!E&!D3&!D2&D1&!D&!C&!B1&B&!A1&A|!E&!D3&!D2&D1&D&!C&!B1&B&!A1&A|!E&D3&!D2&D1&D&!C&!B1&B&!A1&A|!E&!D3&D2&D1&D&!C&!B1&B&!A1&A|!E&!D3&D2&!D1&D&!C&!B1&B&!A1&A|!E&D3&D2&!D1&D&!C&!B1&B&!A1&A|!E&D3&!D2&!D1&D&!C&!B1&B&!A1&A|!E&!D3&!D2&!D1&D&!C&!B1&B&!A1&A|!E&!D3&!D2&!D1&D&!C&B1&B&!A1&A|!E&D3&!D2&!D1&D&!C&B1&B&!A1&A|!E&D3&D2&!D1&D&!C&B1&B&!A1&A|!E&!D3&D2&!D1&D&!C&B1&B&!A1&A|!E&!D3&D2&D1&D&!C&B1&B&!A1&A|!E&D3&!D2&D1&D&!C&B1&B&!A1&A|!E&!D3&!D2&D1&D&!C&B1&B&!A1&A|!E&!D3&!D2&D1&!D&!C&B1&B&!A1&A|!E&D3&!D2&D1&!D&!C&B1&B&!A1&A|!E&D3&D2&D1&!D&!C&B1&B&!A1&A|!E&!D3&D2&D1&!D&!C&B1&B&!A1&A|!E&!D3&D2&!D1&!D&!C&B1&B&!A1&A|!E&D3&D2&!D1&!D&!C&B1&B&!A1&A|!E&D3&!D2&!D1&!D&!C&B1&B&!A1&A|!E&!D3&!D2&!D1&!D&!C&B1&B&!A1&A|!E&!D3&!D2&!D1&!D&!C&B1&!B&!A1&A|!E&D3&!D2&!D1&!D&!C&B1&!B&!A1&A|!E&D3&D2&!D1&!D&!C&B1&!B&!A1&A|!E&!D3&D2&!D1&!D&!C&B1&!B&!A1&A|!E&!D3&D2&D1&!D&!C&B1&!B&!A1&A|!E&D3&D2&D1&!D&!C&B1&!B&!A1&A|!E&D3&!D2&D1&!D&!C&B1&!B&!A1&A|!E&!D3&!D2&D1&!D&!C&B1&!B&!A1&A|!E&!D3&!D2&D1&D&!C&B1&!B&!A1&A|!E&D3&!D2&D1&D&!C&B1&!B&!A1&A|!E&!D3&D2&D1&D&!C&B1&!B&!A1&A|!E&!D3&D2&!D1&D&!C&B1&!B&!A1&A|!E&D3&D2&!D1&D&!C&B1&!B&!A1&A|!E&D3&!D2&!D1&D&!C&B1&!B&!A1&A|!E&!D3&!D2&!D1&D&!C&B1&!B&!A1&A|!E&!D3&!D2&!D1&!D&C&!B1&!B&!A1&A|!E&D3&!D2&!D1&!D&C&!B1&!B&!A1&A|!E&D3&D2&!D1&!D&C&!B1&!B&!A1&A|!E&!D3&D2&!D1&!D&C&!B1&!B&!A1&A|!E&!D3&D2&D1&!D&C&!B1&!B&!A1&A|!E&D3&D2&D1&!D&C&!B1&!B&!A1&A|!E&D3&!D2&D1&!D&C&!B1&!B&!A1&A|!E&!D3&!D2&D1&!D&C&!B1&!B&!A1&A|!E&!D3&!D2&D1&D&C&!B1&!B&!A1&A|!E&D3&!D2&D1&D&C&!B1&!B&!A1&A|!E&!D3&D2&D1&D&C&!B1&!B&!A1&A|!E&!D3&D2&!D1&D&C&!B1&!B&!A1&A|!E&D3&D2&!D1&D&C&!B1&!B&!A1&A|!E&D3&!D2&!D1&D&C&!B1&!B&!A1&A|!E&!D3&!D2&!D1&D&C&!B1&!B&!A1&A|!E&!D3&!D2&!D1&D&!C&!B1&!B&!A1&A|!E&D3&!D2&!D1&D&!C&!B1&!B&!A1&A|!E&D3&D2&!D1&D&!C&!B1&!B&!A1&A|!E&!D3&D2&!D1&D&!C&!B1&!B&!A1&A|!E&!D3&D2&D1&D&!C&!B1&!B&!A1&A|!E&D3&!D2&D1&D&!C&!B1&!B&!A1&A|!E&!D3&!D2&D1&D&!C&!B1&!B&!A1&A|!E&!D3&!D2&D1&!D&!C&!B1&!B&!A1&A|!E&D3&!D2&D1&!D&!C&!B1&!B&!A1&A|!E&D3&D2&D1&!D&!C&!B1&!B&!A1&A|!E&!D3&D2&D1&!D&!C&!B1&!B&!A1&A|!E&!D3&D2&!D1&!D&!C&!B1&!B&!A1&A|!E&D3&D2&!D1&!D&!C&!B1&!B&!A1&A|!E&D3&!D2&!D1&!D&!C&!B1&!B&!A1&A|!E&!D3&!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOI22141.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAI421 -l OOAI421 -i C B1 B A3 A2 A1 A -o Y -f Y=!(C&!B1&B&A3&!A2&!A1&!A|C&B1&B&A3&!A2&!A1&!A|C&B1&!B&A3&!A2&!A1&!A|C&B1&!B&A3&A2&!A1&!A|C&B1&B&A3&A2&!A1&!A|C&!B1&B&A3&A2&!A1&!A|C&!B1&B&!A3&A2&!A1&!A|C&B1&B&!A3&A2&!A1&!A|C&B1&!B&!A3&A2&!A1&!A|C&B1&!B&!A3&A2&A1&!A|C&B1&B&!A3&A2&A1&!A|C&!B1&B&!A3&A2&A1&!A|C&!B1&B&A3&A2&A1&!A|C&B1&B&A3&A2&A1&!A|C&B1&!B&A3&A2&A1&!A|C&B1&!B&A3&!A2&A1&!A|C&B1&B&A3&!A2&A1&!A|C&!B1&B&A3&!A2&A1&!A|C&!B1&B&!A3&!A2&A1&!A|C&B1&B&!A3&!A2&A1&!A|C&B1&!B&!A3&!A2&A1&!A|C&B1&!B&!A3&!A2&A1&A|C&B1&B&!A3&!A2&A1&A|C&!B1&B&!A3&!A2&A1&A|C&!B1&B&A3&!A2&A1&A|C&B1&B&A3&!A2&A1&A|C&B1&!B&A3&!A2&A1&A|C&B1&!B&A3&A2&A1&A|C&B1&B&A3&A2&A1&A|C&!B1&B&A3&A2&A1&A|C&!B1&B&!A3&A2&A1&A|C&B1&B&!A3&A2&A1&A|C&B1&!B&!A3&A2&A1&A|C&B1&!B&!A3&A2&!A1&A|C&B1&B&!A3&A2&!A1&A|C&!B1&B&!A3&A2&!A1&A|C&!B1&B&A3&A2&!A1&A|C&B1&B&A3&A2&!A1&A|C&B1&!B&A3&A2&!A1&A|C&B1&!B&A3&!A2&!A1&A|C&B1&B&A3&!A2&!A1&A|C&!B1&B&A3&!A2&!A1&A|C&!B1&B&!A3&!A2&!A1&A|C&B1&B&!A3&!A2&!A1&A|C&B1&!B&!A3&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAI421.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOAOOAI211112 -l OAOAOOAI211112 -i F1 F E D C B A1 A -o Y -f Y=(!F1&!F&!E&!D&!C&!B&!A1&!A|F1&!F&!E&!D&!C&!B&!A1&!A|F1&F&!E&!D&!C&!B&!A1&!A|!F1&F&!E&!D&!C&!B&!A1&!A|!F1&!F&E&!D&!C&!B&!A1&!A|!F1&!F&E&D&!C&!B&!A1&!A|!F1&F&!E&D&!C&!B&!A1&!A|F1&F&!E&D&!C&!B&!A1&!A|F1&!F&!E&D&!C&!B&!A1&!A|!F1&!F&!E&D&!C&!B&!A1&!A|!F1&!F&!E&D&C&!B&!A1&!A|!F1&!F&E&D&C&!B&!A1&!A|!F1&!F&E&!D&C&!B&!A1&!A|!F1&F&!E&!D&C&!B&!A1&!A|F1&F&!E&!D&C&!B&!A1&!A|F1&!F&!E&!D&C&!B&!A1&!A|!F1&!F&!E&!D&C&!B&!A1&!A|!F1&!F&!E&!D&C&B&!A1&!A|F1&!F&!E&!D&C&B&!A1&!A|F1&F&!E&!D&C&B&!A1&!A|!F1&F&!E&!D&C&B&!A1&!A|!F1&!F&E&!D&C&B&!A1&!A|!F1&!F&E&D&C&B&!A1&!A|!F1&!F&!E&D&C&B&!A1&!A|!F1&!F&!E&D&!C&B&!A1&!A|F1&!F&!E&D&!C&B&!A1&!A|F1&F&!E&D&!C&B&!A1&!A|!F1&F&!E&D&!C&B&!A1&!A|!F1&!F&E&D&!C&B&!A1&!A|!F1&!F&E&!D&!C&B&!A1&!A|!F1&F&!E&!D&!C&B&!A1&!A|F1&F&!E&!D&!C&B&!A1&!A|F1&!F&!E&!D&!C&B&!A1&!A|!F1&!F&!E&!D&!C&B&!A1&!A|!F1&!F&!E&!D&!C&B&A1&!A|F1&!F&!E&!D&!C&B&A1&!A|F1&F&!E&!D&!C&B&A1&!A|!F1&F&!E&!D&!C&B&A1&!A|!F1&!F&E&!D&!C&B&A1&!A|!F1&!F&E&D&!C&B&A1&!A|!F1&!F&!E&D&!C&B&A1&!A|!F1&!F&!E&D&C&B&A1&!A|!F1&!F&E&D&C&B&A1&!A|!F1&!F&E&!D&C&B&A1&!A|!F1&F&!E&!D&C&B&A1&!A|F1&F&!E&!D&C&B&A1&!A|F1&!F&!E&!D&C&B&A1&!A|!F1&!F&!E&!D&C&B&A1&!A|!F1&!F&!E&!D&C&!B&A1&!A|F1&!F&!E&!D&C&!B&A1&!A|F1&F&!E&!D&C&!B&A1&!A|!F1&F&!E&!D&C&!B&A1&!A|!F1&!F&E&!D&C&!B&A1&!A|!F1&!F&E&D&C&!B&A1&!A|!F1&!F&!E&D&C&!B&A1&!A|!F1&!F&!E&D&!C&!B&A1&!A|F1&!F&!E&D&!C&!B&A1&!A|F1&F&!E&D&!C&!B&A1&!A|!F1&F&!E&D&!C&!B&A1&!A|!F1&!F&E&D&!C&!B&A1&!A|!F1&!F&E&!D&!C&!B&A1&!A|!F1&F&!E&!D&!C&!B&A1&!A|F1&F&!E&!D&!C&!B&A1&!A|F1&!F&!E&!D&!C&!B&A1&!A|!F1&!F&!E&!D&!C&!B&A1&!A|!F1&!F&!E&!D&!C&!B&A1&A|F1&!F&!E&!D&!C&!B&A1&A|F1&F&!E&!D&!C&!B&A1&A|!F1&F&!E&!D&!C&!B&A1&A|!F1&!F&E&!D&!C&!B&A1&A|!F1&!F&E&D&!C&!B&A1&A|!F1&F&!E&D&!C&!B&A1&A|F1&F&!E&D&!C&!B&A1&A|F1&!F&!E&D&!C&!B&A1&A|!F1&!F&!E&D&!C&!B&A1&A|!F1&!F&!E&D&C&!B&A1&A|!F1&!F&E&D&C&!B&A1&A|!F1&!F&E&!D&C&!B&A1&A|!F1&F&!E&!D&C&!B&A1&A|F1&F&!E&!D&C&!B&A1&A|F1&!F&!E&!D&C&!B&A1&A|!F1&!F&!E&!D&C&!B&A1&A|!F1&!F&!E&!D&C&B&A1&A|F1&!F&!E&!D&C&B&A1&A|F1&F&!E&!D&C&B&A1&A|!F1&F&!E&!D&C&B&A1&A|!F1&!F&E&!D&C&B&A1&A|!F1&!F&E&D&C&B&A1&A|!F1&!F&!E&D&C&B&A1&A|!F1&!F&!E&D&!C&B&A1&A|!F1&!F&E&D&!C&B&A1&A|!F1&!F&E&!D&!C&B&A1&A|!F1&F&!E&!D&!C&B&A1&A|F1&F&!E&!D&!C&B&A1&A|F1&!F&!E&!D&!C&B&A1&A|!F1&!F&!E&!D&!C&B&A1&A|!F1&!F&!E&!D&!C&B&!A1&A|F1&!F&!E&!D&!C&B&!A1&A|F1&F&!E&!D&!C&B&!A1&A|!F1&F&!E&!D&!C&B&!A1&A|!F1&!F&E&!D&!C&B&!A1&A|!F1&!F&E&D&!C&B&!A1&A|!F1&!F&!E&D&!C&B&!A1&A|!F1&!F&!E&D&C&B&!A1&A|!F1&!F&E&D&C&B&!A1&A|!F1&!F&E&!D&C&B&!A1&A|!F1&F&!E&!D&C&B&!A1&A|F1&F&!E&!D&C&B&!A1&A|F1&!F&!E&!D&C&B&!A1&A|!F1&!F&!E&!D&C&B&!A1&A|!F1&!F&!E&!D&C&!B&!A1&A|F1&!F&!E&!D&C&!B&!A1&A|F1&F&!E&!D&C&!B&!A1&A|!F1&F&!E&!D&C&!B&!A1&A|!F1&!F&E&!D&C&!B&!A1&A|!F1&!F&E&D&C&!B&!A1&A|!F1&!F&!E&D&C&!B&!A1&A|!F1&!F&!E&D&!C&!B&!A1&A|F1&!F&!E&D&!C&!B&!A1&A|F1&F&!E&D&!C&!B&!A1&A|!F1&F&!E&D&!C&!B&!A1&A|!F1&!F&E&D&!C&!B&!A1&A|!F1&!F&E&!D&!C&!B&!A1&A|!F1&F&!E&!D&!C&!B&!A1&A|F1&F&!E&!D&!C&!B&!A1&A|F1&!F&!E&!D&!C&!B&!A1&A|!F1&!F&!E&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOAOOAI211112.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n NOR2 -l NOR2 -i A1 A -o Y -f Y=(!A1&!A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist NOR2.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAOAI22121 -l AAOAOAI22121 -i E D1 D C B1 B A1 A -o Y -f Y=!(E&D1&!D&!C&!B1&!B&!A1&!A|E&D1&D&!C&!B1&!B&!A1&!A|E&!D1&D&!C&!B1&!B&!A1&!A|E&!D1&D&C&!B1&!B&!A1&!A|E&D1&D&C&!B1&!B&!A1&!A|E&D1&!D&C&!B1&!B&!A1&!A|E&D1&!D&C&B1&!B&!A1&!A|E&D1&D&C&B1&!B&!A1&!A|E&!D1&D&C&B1&!B&!A1&!A|E&!D1&D&!C&B1&!B&!A1&!A|E&D1&D&!C&B1&!B&!A1&!A|E&D1&!D&!C&B1&!B&!A1&!A|E&D1&!D&!C&B1&B&!A1&!A|E&D1&D&!C&B1&B&!A1&!A|E&!D1&D&!C&B1&B&!A1&!A|E&!D1&D&C&B1&B&!A1&!A|E&D1&D&C&B1&B&!A1&!A|E&D1&!D&C&B1&B&!A1&!A|E&!D1&!D&C&B1&B&!A1&!A|E&D1&!D&C&!B1&B&!A1&!A|E&D1&D&C&!B1&B&!A1&!A|E&!D1&D&C&!B1&B&!A1&!A|E&!D1&D&!C&!B1&B&!A1&!A|E&D1&D&!C&!B1&B&!A1&!A|E&D1&!D&!C&!B1&B&!A1&!A|E&D1&!D&!C&!B1&B&A1&!A|E&D1&D&!C&!B1&B&A1&!A|E&!D1&D&!C&!B1&B&A1&!A|E&!D1&D&C&!B1&B&A1&!A|E&D1&D&C&!B1&B&A1&!A|E&D1&!D&C&!B1&B&A1&!A|E&!D1&!D&C&B1&B&A1&!A|E&D1&!D&C&B1&B&A1&!A|E&D1&D&C&B1&B&A1&!A|E&!D1&D&C&B1&B&A1&!A|E&!D1&D&!C&B1&B&A1&!A|E&D1&D&!C&B1&B&A1&!A|E&D1&!D&!C&B1&B&A1&!A|E&D1&!D&!C&B1&!B&A1&!A|E&D1&D&!C&B1&!B&A1&!A|E&!D1&D&!C&B1&!B&A1&!A|E&!D1&D&C&B1&!B&A1&!A|E&D1&D&C&B1&!B&A1&!A|E&D1&!D&C&B1&!B&A1&!A|E&D1&!D&C&!B1&!B&A1&!A|E&D1&D&C&!B1&!B&A1&!A|E&!D1&D&C&!B1&!B&A1&!A|E&!D1&D&!C&!B1&!B&A1&!A|E&D1&D&!C&!B1&!B&A1&!A|E&D1&!D&!C&!B1&!B&A1&!A|E&D1&!D&!C&!B1&!B&A1&A|E&D1&D&!C&!B1&!B&A1&A|E&!D1&D&!C&!B1&!B&A1&A|E&!D1&D&C&!B1&!B&A1&A|E&D1&D&C&!B1&!B&A1&A|E&D1&!D&C&!B1&!B&A1&A|E&!D1&!D&C&!B1&!B&A1&A|E&!D1&!D&C&B1&!B&A1&A|E&D1&!D&C&B1&!B&A1&A|E&D1&D&C&B1&!B&A1&A|E&!D1&D&C&B1&!B&A1&A|E&!D1&D&!C&B1&!B&A1&A|E&D1&D&!C&B1&!B&A1&A|E&D1&!D&!C&B1&!B&A1&A|E&D1&!D&!C&B1&B&A1&A|E&D1&D&!C&B1&B&A1&A|E&!D1&D&!C&B1&B&A1&A|E&!D1&D&C&B1&B&A1&A|E&D1&D&C&B1&B&A1&A|E&D1&!D&C&B1&B&A1&A|E&!D1&!D&C&B1&B&A1&A|E&!D1&!D&C&!B1&B&A1&A|E&D1&!D&C&!B1&B&A1&A|E&D1&D&C&!B1&B&A1&A|E&!D1&D&C&!B1&B&A1&A|E&!D1&D&!C&!B1&B&A1&A|E&D1&D&!C&!B1&B&A1&A|E&D1&!D&!C&!B1&B&A1&A|E&D1&!D&!C&!B1&B&!A1&A|E&D1&D&!C&!B1&B&!A1&A|E&!D1&D&!C&!B1&B&!A1&A|E&!D1&D&C&!B1&B&!A1&A|E&D1&D&C&!B1&B&!A1&A|E&D1&!D&C&!B1&B&!A1&A|E&!D1&!D&C&B1&B&!A1&A|E&D1&!D&C&B1&B&!A1&A|E&D1&D&C&B1&B&!A1&A|E&!D1&D&C&B1&B&!A1&A|E&!D1&D&!C&B1&B&!A1&A|E&D1&D&!C&B1&B&!A1&A|E&D1&!D&!C&B1&B&!A1&A|E&D1&!D&!C&B1&!B&!A1&A|E&D1&D&!C&B1&!B&!A1&A|E&!D1&D&!C&B1&!B&!A1&A|E&!D1&D&C&B1&!B&!A1&A|E&D1&D&C&B1&!B&!A1&A|E&D1&!D&C&B1&!B&!A1&A|E&D1&!D&C&!B1&!B&!A1&A|E&D1&D&C&!B1&!B&!A1&A|E&!D1&D&C&!B1&!B&!A1&A|E&!D1&D&!C&!B1&!B&!A1&A|E&D1&D&!C&!B1&!B&!A1&A|E&D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAOAI22121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAOI3121 -l AOOAOI3121 -i D C1 C B A2 A1 A -o Y -f Y=(!D&!C1&!C&!B&!A2&!A1&!A|!D&C1&!C&!B&!A2&!A1&!A|!D&C1&C&!B&!A2&!A1&!A|!D&!C1&C&!B&!A2&!A1&!A|!D&!C1&!C&B&!A2&!A1&!A|!D&!C1&!C&B&A2&!A1&!A|!D&!C1&C&!B&A2&!A1&!A|!D&C1&C&!B&A2&!A1&!A|!D&C1&!C&!B&A2&!A1&!A|!D&!C1&!C&!B&A2&!A1&!A|!D&!C1&!C&!B&A2&A1&!A|!D&C1&!C&!B&A2&A1&!A|!D&C1&C&!B&A2&A1&!A|!D&!C1&C&!B&A2&A1&!A|!D&!C1&!C&B&A2&A1&!A|!D&!C1&!C&B&!A2&A1&!A|!D&!C1&C&!B&!A2&A1&!A|!D&C1&C&!B&!A2&A1&!A|!D&C1&!C&!B&!A2&A1&!A|!D&!C1&!C&!B&!A2&A1&!A|!D&!C1&!C&!B&!A2&A1&A|!D&C1&!C&!B&!A2&A1&A|!D&C1&C&!B&!A2&A1&A|!D&!C1&C&!B&!A2&A1&A|!D&!C1&!C&B&!A2&A1&A|!D&!C1&!C&B&A2&A1&A|!D&!C1&!C&!B&A2&A1&A|!D&!C1&!C&!B&A2&!A1&A|!D&C1&!C&!B&A2&!A1&A|!D&C1&C&!B&A2&!A1&A|!D&!C1&C&!B&A2&!A1&A|!D&!C1&!C&B&A2&!A1&A|!D&!C1&!C&B&!A2&!A1&A|!D&!C1&C&!B&!A2&!A1&A|!D&C1&C&!B&!A2&!A1&A|!D&C1&!C&!B&!A2&!A1&A|!D&!C1&!C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAOI3121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOI21221 -l AOAAOI21221 -i E D1 D C1 C B A1 A -o Y -f Y=(!E&!D1&!D&!C1&!C&!B&!A1&!A|!E&D1&!D&!C1&!C&!B&!A1&!A|!E&!D1&D&!C1&!C&!B&!A1&!A|!E&!D1&D&C1&!C&!B&!A1&!A|!E&D1&!D&C1&!C&!B&!A1&!A|!E&!D1&!D&C1&!C&!B&!A1&!A|!E&!D1&!D&C1&C&!B&!A1&!A|!E&D1&!D&C1&C&!B&!A1&!A|!E&!D1&D&C1&C&!B&!A1&!A|!E&!D1&D&!C1&C&!B&!A1&!A|!E&D1&!D&!C1&C&!B&!A1&!A|!E&!D1&!D&!C1&C&!B&!A1&!A|!E&!D1&!D&!C1&C&B&!A1&!A|!E&D1&!D&!C1&C&B&!A1&!A|!E&!D1&D&!C1&C&B&!A1&!A|!E&!D1&!D&C1&!C&B&!A1&!A|!E&D1&!D&C1&!C&B&!A1&!A|!E&!D1&D&C1&!C&B&!A1&!A|!E&!D1&D&!C1&!C&B&!A1&!A|!E&D1&!D&!C1&!C&B&!A1&!A|!E&!D1&!D&!C1&!C&B&!A1&!A|!E&!D1&!D&!C1&!C&B&A1&!A|!E&D1&!D&!C1&!C&B&A1&!A|!E&!D1&D&!C1&!C&B&A1&!A|!E&!D1&D&C1&!C&B&A1&!A|!E&D1&!D&C1&!C&B&A1&!A|!E&!D1&!D&C1&!C&B&A1&!A|!E&!D1&D&!C1&C&B&A1&!A|!E&D1&!D&!C1&C&B&A1&!A|!E&!D1&!D&!C1&C&B&A1&!A|!E&!D1&!D&!C1&C&!B&A1&!A|!E&D1&!D&!C1&C&!B&A1&!A|!E&!D1&D&!C1&C&!B&A1&!A|!E&!D1&D&C1&C&!B&A1&!A|!E&D1&!D&C1&C&!B&A1&!A|!E&!D1&!D&C1&C&!B&A1&!A|!E&!D1&!D&C1&!C&!B&A1&!A|!E&D1&!D&C1&!C&!B&A1&!A|!E&!D1&D&C1&!C&!B&A1&!A|!E&!D1&D&!C1&!C&!B&A1&!A|!E&D1&!D&!C1&!C&!B&A1&!A|!E&!D1&!D&!C1&!C&!B&A1&!A|!E&!D1&!D&!C1&!C&!B&A1&A|!E&D1&!D&!C1&!C&!B&A1&A|!E&!D1&D&!C1&!C&!B&A1&A|!E&!D1&D&C1&!C&!B&A1&A|!E&D1&!D&C1&!C&!B&A1&A|!E&!D1&!D&C1&!C&!B&A1&A|!E&!D1&D&!C1&C&!B&A1&A|!E&D1&!D&!C1&C&!B&A1&A|!E&!D1&!D&!C1&C&!B&A1&A|!E&!D1&!D&!C1&C&B&A1&A|!E&D1&!D&!C1&C&B&A1&A|!E&!D1&D&!C1&C&B&A1&A|!E&!D1&!D&C1&!C&B&A1&A|!E&D1&!D&C1&!C&B&A1&A|!E&!D1&D&C1&!C&B&A1&A|!E&!D1&D&!C1&!C&B&A1&A|!E&D1&!D&!C1&!C&B&A1&A|!E&!D1&!D&!C1&!C&B&A1&A|!E&!D1&!D&!C1&!C&B&!A1&A|!E&D1&!D&!C1&!C&B&!A1&A|!E&!D1&D&!C1&!C&B&!A1&A|!E&!D1&D&C1&!C&B&!A1&A|!E&D1&!D&C1&!C&B&!A1&A|!E&!D1&!D&C1&!C&B&!A1&A|!E&!D1&D&!C1&C&B&!A1&A|!E&D1&!D&!C1&C&B&!A1&A|!E&!D1&!D&!C1&C&B&!A1&A|!E&!D1&!D&!C1&C&!B&!A1&A|!E&D1&!D&!C1&C&!B&!A1&A|!E&!D1&D&!C1&C&!B&!A1&A|!E&!D1&D&C1&C&!B&!A1&A|!E&D1&!D&C1&C&!B&!A1&A|!E&!D1&!D&C1&C&!B&!A1&A|!E&!D1&!D&C1&!C&!B&!A1&A|!E&D1&!D&C1&!C&!B&!A1&A|!E&!D1&D&C1&!C&!B&!A1&A|!E&!D1&D&!C1&!C&!B&!A1&A|!E&D1&!D&!C1&!C&!B&!A1&A|!E&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOI21221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOAAOI21222 -l OAAOOAAOI21222 -i E1 E D1 D C1 C B A1 A -o Y -f Y=(!E1&!E&!D1&!D&!C1&!C&!B&!A1&!A|E1&!E&!D1&!D&!C1&!C&!B&!A1&!A|!E1&E&!D1&!D&!C1&!C&!B&!A1&!A|!E1&E&D1&!D&!C1&!C&!B&!A1&!A|E1&!E&D1&!D&!C1&!C&!B&!A1&!A|!E1&!E&D1&!D&!C1&!C&!B&!A1&!A|!E1&!E&D1&D&!C1&!C&!B&!A1&!A|E1&!E&D1&D&!C1&!C&!B&!A1&!A|!E1&E&D1&D&!C1&!C&!B&!A1&!A|!E1&E&!D1&D&!C1&!C&!B&!A1&!A|E1&!E&!D1&D&!C1&!C&!B&!A1&!A|!E1&!E&!D1&D&!C1&!C&!B&!A1&!A|!E1&!E&!D1&D&C1&!C&!B&!A1&!A|E1&!E&!D1&D&C1&!C&!B&!A1&!A|!E1&E&!D1&D&C1&!C&!B&!A1&!A|!E1&E&D1&D&C1&!C&!B&!A1&!A|E1&!E&D1&D&C1&!C&!B&!A1&!A|!E1&!E&D1&D&C1&!C&!B&!A1&!A|!E1&!E&D1&!D&C1&!C&!B&!A1&!A|E1&!E&D1&!D&C1&!C&!B&!A1&!A|!E1&E&D1&!D&C1&!C&!B&!A1&!A|!E1&E&!D1&!D&C1&!C&!B&!A1&!A|E1&!E&!D1&!D&C1&!C&!B&!A1&!A|!E1&!E&!D1&!D&C1&!C&!B&!A1&!A|!E1&!E&!D1&!D&C1&C&!B&!A1&!A|E1&!E&!D1&!D&C1&C&!B&!A1&!A|!E1&E&!D1&!D&C1&C&!B&!A1&!A|!E1&!E&!D1&D&!C1&C&!B&!A1&!A|E1&!E&!D1&D&!C1&C&!B&!A1&!A|!E1&E&!D1&D&!C1&C&!B&!A1&!A|!E1&E&D1&D&!C1&C&!B&!A1&!A|E1&!E&D1&D&!C1&C&!B&!A1&!A|!E1&!E&D1&D&!C1&C&!B&!A1&!A|!E1&!E&D1&!D&!C1&C&!B&!A1&!A|E1&!E&D1&!D&!C1&C&!B&!A1&!A|!E1&E&D1&!D&!C1&C&!B&!A1&!A|!E1&E&!D1&!D&!C1&C&!B&!A1&!A|E1&!E&!D1&!D&!C1&C&!B&!A1&!A|!E1&!E&!D1&!D&!C1&C&!B&!A1&!A|!E1&!E&!D1&!D&!C1&C&B&!A1&!A|E1&!E&!D1&!D&!C1&C&B&!A1&!A|!E1&E&!D1&!D&!C1&C&B&!A1&!A|!E1&E&D1&!D&!C1&C&B&!A1&!A|E1&!E&D1&!D&!C1&C&B&!A1&!A|!E1&!E&D1&!D&!C1&C&B&!A1&!A|!E1&!E&D1&D&!C1&C&B&!A1&!A|E1&!E&D1&D&!C1&C&B&!A1&!A|!E1&E&D1&D&!C1&C&B&!A1&!A|!E1&E&!D1&D&!C1&C&B&!A1&!A|E1&!E&!D1&D&!C1&C&B&!A1&!A|!E1&!E&!D1&D&!C1&C&B&!A1&!A|!E1&E&!D1&!D&C1&C&B&!A1&!A|E1&!E&!D1&!D&C1&C&B&!A1&!A|!E1&!E&!D1&!D&C1&C&B&!A1&!A|!E1&!E&!D1&!D&C1&!C&B&!A1&!A|E1&!E&!D1&!D&C1&!C&B&!A1&!A|!E1&E&!D1&!D&C1&!C&B&!A1&!A|!E1&E&D1&!D&C1&!C&B&!A1&!A|E1&!E&D1&!D&C1&!C&B&!A1&!A|!E1&!E&D1&!D&C1&!C&B&!A1&!A|!E1&!E&D1&D&C1&!C&B&!A1&!A|E1&!E&D1&D&C1&!C&B&!A1&!A|!E1&E&D1&D&C1&!C&B&!A1&!A|!E1&E&!D1&D&C1&!C&B&!A1&!A|E1&!E&!D1&D&C1&!C&B&!A1&!A|!E1&!E&!D1&D&C1&!C&B&!A1&!A|!E1&!E&!D1&D&!C1&!C&B&!A1&!A|E1&!E&!D1&D&!C1&!C&B&!A1&!A|!E1&E&!D1&D&!C1&!C&B&!A1&!A|!E1&E&D1&D&!C1&!C&B&!A1&!A|E1&!E&D1&D&!C1&!C&B&!A1&!A|!E1&!E&D1&D&!C1&!C&B&!A1&!A|!E1&!E&D1&!D&!C1&!C&B&!A1&!A|E1&!E&D1&!D&!C1&!C&B&!A1&!A|!E1&E&D1&!D&!C1&!C&B&!A1&!A|!E1&E&!D1&!D&!C1&!C&B&!A1&!A|E1&!E&!D1&!D&!C1&!C&B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&B&!A1&!A|!E1&!E&!D1&!D&!C1&!C&B&A1&!A|E1&!E&!D1&!D&!C1&!C&B&A1&!A|!E1&E&!D1&!D&!C1&!C&B&A1&!A|!E1&E&!D1&!D&C1&!C&B&A1&!A|E1&!E&!D1&!D&C1&!C&B&A1&!A|!E1&!E&!D1&!D&C1&!C&B&A1&!A|!E1&!E&!D1&!D&C1&C&B&A1&!A|E1&!E&!D1&!D&C1&C&B&A1&!A|!E1&E&!D1&!D&C1&C&B&A1&!A|!E1&E&!D1&!D&!C1&C&B&A1&!A|E1&!E&!D1&!D&!C1&C&B&A1&!A|!E1&!E&!D1&!D&!C1&C&B&A1&!A|!E1&!E&!D1&!D&!C1&C&!B&A1&!A|E1&!E&!D1&!D&!C1&C&!B&A1&!A|!E1&E&!D1&!D&!C1&C&!B&A1&!A|!E1&E&D1&!D&!C1&C&!B&A1&!A|E1&!E&D1&!D&!C1&C&!B&A1&!A|!E1&!E&D1&!D&!C1&C&!B&A1&!A|!E1&!E&D1&D&!C1&C&!B&A1&!A|E1&!E&D1&D&!C1&C&!B&A1&!A|!E1&E&D1&D&!C1&C&!B&A1&!A|!E1&E&!D1&D&!C1&C&!B&A1&!A|E1&!E&!D1&D&!C1&C&!B&A1&!A|!E1&!E&!D1&D&!C1&C&!B&A1&!A|!E1&E&!D1&!D&C1&C&!B&A1&!A|E1&!E&!D1&!D&C1&C&!B&A1&!A|!E1&!E&!D1&!D&C1&C&!B&A1&!A|!E1&!E&!D1&!D&C1&!C&!B&A1&!A|E1&!E&!D1&!D&C1&!C&!B&A1&!A|!E1&E&!D1&!D&C1&!C&!B&A1&!A|!E1&E&D1&!D&C1&!C&!B&A1&!A|E1&!E&D1&!D&C1&!C&!B&A1&!A|!E1&!E&D1&!D&C1&!C&!B&A1&!A|!E1&!E&D1&D&C1&!C&!B&A1&!A|E1&!E&D1&D&C1&!C&!B&A1&!A|!E1&E&D1&D&C1&!C&!B&A1&!A|!E1&E&!D1&D&C1&!C&!B&A1&!A|E1&!E&!D1&D&C1&!C&!B&A1&!A|!E1&!E&!D1&D&C1&!C&!B&A1&!A|!E1&!E&!D1&D&!C1&!C&!B&A1&!A|E1&!E&!D1&D&!C1&!C&!B&A1&!A|!E1&E&!D1&D&!C1&!C&!B&A1&!A|!E1&E&D1&D&!C1&!C&!B&A1&!A|E1&!E&D1&D&!C1&!C&!B&A1&!A|!E1&!E&D1&D&!C1&!C&!B&A1&!A|!E1&!E&D1&!D&!C1&!C&!B&A1&!A|E1&!E&D1&!D&!C1&!C&!B&A1&!A|!E1&E&D1&!D&!C1&!C&!B&A1&!A|!E1&E&!D1&!D&!C1&!C&!B&A1&!A|E1&!E&!D1&!D&!C1&!C&!B&A1&!A|!E1&!E&!D1&!D&!C1&!C&!B&A1&!A|!E1&!E&!D1&!D&!C1&!C&!B&A1&A|E1&!E&!D1&!D&!C1&!C&!B&A1&A|!E1&E&!D1&!D&!C1&!C&!B&A1&A|!E1&E&D1&!D&!C1&!C&!B&A1&A|E1&!E&D1&!D&!C1&!C&!B&A1&A|!E1&!E&D1&!D&!C1&!C&!B&A1&A|!E1&!E&D1&D&!C1&!C&!B&A1&A|E1&!E&D1&D&!C1&!C&!B&A1&A|!E1&E&D1&D&!C1&!C&!B&A1&A|!E1&E&!D1&D&!C1&!C&!B&A1&A|E1&!E&!D1&D&!C1&!C&!B&A1&A|!E1&!E&!D1&D&!C1&!C&!B&A1&A|!E1&!E&!D1&D&C1&!C&!B&A1&A|E1&!E&!D1&D&C1&!C&!B&A1&A|!E1&E&!D1&D&C1&!C&!B&A1&A|!E1&E&D1&D&C1&!C&!B&A1&A|E1&!E&D1&D&C1&!C&!B&A1&A|!E1&!E&D1&D&C1&!C&!B&A1&A|!E1&!E&D1&!D&C1&!C&!B&A1&A|E1&!E&D1&!D&C1&!C&!B&A1&A|!E1&E&D1&!D&C1&!C&!B&A1&A|!E1&E&!D1&!D&C1&!C&!B&A1&A|E1&!E&!D1&!D&C1&!C&!B&A1&A|!E1&!E&!D1&!D&C1&!C&!B&A1&A|!E1&!E&!D1&!D&C1&C&!B&A1&A|E1&!E&!D1&!D&C1&C&!B&A1&A|!E1&E&!D1&!D&C1&C&!B&A1&A|!E1&!E&!D1&D&!C1&C&!B&A1&A|E1&!E&!D1&D&!C1&C&!B&A1&A|!E1&E&!D1&D&!C1&C&!B&A1&A|!E1&E&D1&D&!C1&C&!B&A1&A|E1&!E&D1&D&!C1&C&!B&A1&A|!E1&!E&D1&D&!C1&C&!B&A1&A|!E1&!E&D1&!D&!C1&C&!B&A1&A|E1&!E&D1&!D&!C1&C&!B&A1&A|!E1&E&D1&!D&!C1&C&!B&A1&A|!E1&E&!D1&!D&!C1&C&!B&A1&A|E1&!E&!D1&!D&!C1&C&!B&A1&A|!E1&!E&!D1&!D&!C1&C&!B&A1&A|!E1&!E&!D1&!D&!C1&C&B&A1&A|E1&!E&!D1&!D&!C1&C&B&A1&A|!E1&E&!D1&!D&!C1&C&B&A1&A|!E1&E&!D1&!D&C1&C&B&A1&A|E1&!E&!D1&!D&C1&C&B&A1&A|!E1&!E&!D1&!D&C1&C&B&A1&A|!E1&!E&!D1&!D&C1&!C&B&A1&A|E1&!E&!D1&!D&C1&!C&B&A1&A|!E1&E&!D1&!D&C1&!C&B&A1&A|!E1&E&!D1&!D&!C1&!C&B&A1&A|E1&!E&!D1&!D&!C1&!C&B&A1&A|!E1&!E&!D1&!D&!C1&!C&B&A1&A|!E1&!E&!D1&!D&!C1&!C&B&!A1&A|E1&!E&!D1&!D&!C1&!C&B&!A1&A|!E1&E&!D1&!D&!C1&!C&B&!A1&A|!E1&E&!D1&!D&C1&!C&B&!A1&A|E1&!E&!D1&!D&C1&!C&B&!A1&A|!E1&!E&!D1&!D&C1&!C&B&!A1&A|!E1&!E&!D1&!D&C1&C&B&!A1&A|E1&!E&!D1&!D&C1&C&B&!A1&A|!E1&E&!D1&!D&C1&C&B&!A1&A|!E1&E&!D1&!D&!C1&C&B&!A1&A|E1&!E&!D1&!D&!C1&C&B&!A1&A|!E1&!E&!D1&!D&!C1&C&B&!A1&A|!E1&!E&!D1&!D&!C1&C&!B&!A1&A|E1&!E&!D1&!D&!C1&C&!B&!A1&A|!E1&E&!D1&!D&!C1&C&!B&!A1&A|!E1&E&D1&!D&!C1&C&!B&!A1&A|E1&!E&D1&!D&!C1&C&!B&!A1&A|!E1&!E&D1&!D&!C1&C&!B&!A1&A|!E1&!E&D1&D&!C1&C&!B&!A1&A|E1&!E&D1&D&!C1&C&!B&!A1&A|!E1&E&D1&D&!C1&C&!B&!A1&A|!E1&E&!D1&D&!C1&C&!B&!A1&A|E1&!E&!D1&D&!C1&C&!B&!A1&A|!E1&!E&!D1&D&!C1&C&!B&!A1&A|!E1&E&!D1&!D&C1&C&!B&!A1&A|E1&!E&!D1&!D&C1&C&!B&!A1&A|!E1&!E&!D1&!D&C1&C&!B&!A1&A|!E1&!E&!D1&!D&C1&!C&!B&!A1&A|E1&!E&!D1&!D&C1&!C&!B&!A1&A|!E1&E&!D1&!D&C1&!C&!B&!A1&A|!E1&E&D1&!D&C1&!C&!B&!A1&A|E1&!E&D1&!D&C1&!C&!B&!A1&A|!E1&!E&D1&!D&C1&!C&!B&!A1&A|!E1&!E&D1&D&C1&!C&!B&!A1&A|E1&!E&D1&D&C1&!C&!B&!A1&A|!E1&E&D1&D&C1&!C&!B&!A1&A|!E1&E&!D1&D&C1&!C&!B&!A1&A|E1&!E&!D1&D&C1&!C&!B&!A1&A|!E1&!E&!D1&D&C1&!C&!B&!A1&A|!E1&!E&!D1&D&!C1&!C&!B&!A1&A|E1&!E&!D1&D&!C1&!C&!B&!A1&A|!E1&E&!D1&D&!C1&!C&!B&!A1&A|!E1&E&D1&D&!C1&!C&!B&!A1&A|E1&!E&D1&D&!C1&!C&!B&!A1&A|!E1&!E&D1&D&!C1&!C&!B&!A1&A|!E1&!E&D1&!D&!C1&!C&!B&!A1&A|E1&!E&D1&!D&!C1&!C&!B&!A1&A|!E1&E&D1&!D&!C1&!C&!B&!A1&A|!E1&E&!D1&!D&!C1&!C&!B&!A1&A|E1&!E&!D1&!D&!C1&!C&!B&!A1&A|!E1&!E&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOAAOI21222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOAAOI21122 -l OAOAAOI21122 -i E1 E D1 D C B A1 A -o Y -f Y=!(E1&E&!D1&!D&!C&!B&!A1&!A|E1&E&D1&!D&!C&!B&!A1&!A|E1&E&D1&D&!C&!B&!A1&!A|E1&E&!D1&D&!C&!B&!A1&!A|E1&E&!D1&D&C&!B&!A1&!A|!E1&E&D1&D&C&!B&!A1&!A|E1&E&D1&D&C&!B&!A1&!A|E1&!E&D1&D&C&!B&!A1&!A|!E1&!E&D1&D&C&!B&!A1&!A|E1&E&D1&!D&C&!B&!A1&!A|E1&E&!D1&!D&C&!B&!A1&!A|E1&E&!D1&!D&C&B&!A1&!A|E1&E&D1&!D&C&B&!A1&!A|!E1&!E&D1&D&C&B&!A1&!A|E1&!E&D1&D&C&B&!A1&!A|E1&E&D1&D&C&B&!A1&!A|!E1&E&D1&D&C&B&!A1&!A|E1&E&!D1&D&C&B&!A1&!A|E1&E&!D1&D&!C&B&!A1&!A|E1&E&D1&D&!C&B&!A1&!A|E1&E&D1&!D&!C&B&!A1&!A|E1&E&!D1&!D&!C&B&!A1&!A|E1&E&!D1&!D&!C&B&A1&!A|E1&E&D1&!D&!C&B&A1&!A|!E1&!E&D1&D&!C&B&A1&!A|E1&!E&D1&D&!C&B&A1&!A|E1&E&D1&D&!C&B&A1&!A|!E1&E&D1&D&!C&B&A1&!A|E1&E&!D1&D&!C&B&A1&!A|E1&E&!D1&D&C&B&A1&!A|!E1&E&D1&D&C&B&A1&!A|E1&E&D1&D&C&B&A1&!A|E1&!E&D1&D&C&B&A1&!A|!E1&!E&D1&D&C&B&A1&!A|E1&E&D1&!D&C&B&A1&!A|E1&E&!D1&!D&C&B&A1&!A|E1&E&!D1&!D&C&!B&A1&!A|E1&E&D1&!D&C&!B&A1&!A|!E1&!E&D1&D&C&!B&A1&!A|E1&!E&D1&D&C&!B&A1&!A|E1&E&D1&D&C&!B&A1&!A|!E1&E&D1&D&C&!B&A1&!A|E1&E&!D1&D&C&!B&A1&!A|E1&E&!D1&D&!C&!B&A1&!A|E1&E&D1&D&!C&!B&A1&!A|E1&E&D1&!D&!C&!B&A1&!A|E1&E&!D1&!D&!C&!B&A1&!A|E1&E&!D1&!D&!C&!B&A1&A|E1&E&D1&!D&!C&!B&A1&A|E1&E&D1&D&!C&!B&A1&A|E1&E&!D1&D&!C&!B&A1&A|E1&E&!D1&D&C&!B&A1&A|!E1&E&D1&D&C&!B&A1&A|E1&E&D1&D&C&!B&A1&A|E1&!E&D1&D&C&!B&A1&A|!E1&!E&D1&D&C&!B&A1&A|E1&E&D1&!D&C&!B&A1&A|E1&E&!D1&!D&C&!B&A1&A|E1&E&!D1&!D&C&B&A1&A|E1&E&D1&!D&C&B&A1&A|!E1&!E&D1&D&C&B&A1&A|E1&!E&D1&D&C&B&A1&A|E1&E&D1&D&C&B&A1&A|!E1&E&D1&D&C&B&A1&A|E1&E&!D1&D&C&B&A1&A|E1&E&!D1&D&!C&B&A1&A|!E1&E&D1&D&!C&B&A1&A|E1&E&D1&D&!C&B&A1&A|E1&!E&D1&D&!C&B&A1&A|!E1&!E&D1&D&!C&B&A1&A|E1&E&D1&!D&!C&B&A1&A|E1&E&!D1&!D&!C&B&A1&A|E1&E&!D1&!D&!C&B&!A1&A|E1&E&D1&!D&!C&B&!A1&A|!E1&!E&D1&D&!C&B&!A1&A|E1&!E&D1&D&!C&B&!A1&A|E1&E&D1&D&!C&B&!A1&A|!E1&E&D1&D&!C&B&!A1&A|E1&E&!D1&D&!C&B&!A1&A|E1&E&!D1&D&C&B&!A1&A|!E1&E&D1&D&C&B&!A1&A|E1&E&D1&D&C&B&!A1&A|E1&!E&D1&D&C&B&!A1&A|!E1&!E&D1&D&C&B&!A1&A|E1&E&D1&!D&C&B&!A1&A|E1&E&!D1&!D&C&B&!A1&A|E1&E&!D1&!D&C&!B&!A1&A|E1&E&D1&!D&C&!B&!A1&A|!E1&!E&D1&D&C&!B&!A1&A|E1&!E&D1&D&C&!B&!A1&A|E1&E&D1&D&C&!B&!A1&A|!E1&E&D1&D&C&!B&!A1&A|E1&E&!D1&D&C&!B&!A1&A|E1&E&!D1&D&!C&!B&!A1&A|E1&E&D1&D&!C&!B&!A1&A|E1&E&D1&!D&!C&!B&!A1&A|E1&E&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOAAOI21122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOAAOI211112 -l AOAOAAOI211112 -i F1 F E D C B A1 A -o Y -f Y=!(F1&F&!E&!D&!C&!B&!A1&!A|F1&F&E&!D&!C&!B&!A1&!A|!F1&!F&E&D&!C&!B&!A1&!A|F1&!F&E&D&!C&!B&!A1&!A|F1&F&E&D&!C&!B&!A1&!A|!F1&F&E&D&!C&!B&!A1&!A|F1&F&!E&D&!C&!B&!A1&!A|F1&F&!E&D&C&!B&!A1&!A|!F1&F&E&D&C&!B&!A1&!A|F1&F&E&D&C&!B&!A1&!A|F1&!F&E&D&C&!B&!A1&!A|!F1&!F&E&D&C&!B&!A1&!A|F1&F&E&!D&C&!B&!A1&!A|F1&F&!E&!D&C&!B&!A1&!A|F1&F&!E&!D&C&B&!A1&!A|!F1&F&E&!D&C&B&!A1&!A|F1&F&E&!D&C&B&!A1&!A|F1&!F&E&!D&C&B&!A1&!A|!F1&!F&E&!D&C&B&!A1&!A|!F1&!F&E&D&C&B&!A1&!A|F1&!F&E&D&C&B&!A1&!A|F1&F&E&D&C&B&!A1&!A|!F1&F&E&D&C&B&!A1&!A|F1&F&!E&D&C&B&!A1&!A|F1&F&!E&D&!C&B&!A1&!A|!F1&F&E&D&!C&B&!A1&!A|F1&F&E&D&!C&B&!A1&!A|F1&!F&E&D&!C&B&!A1&!A|!F1&!F&E&D&!C&B&!A1&!A|F1&F&E&!D&!C&B&!A1&!A|F1&F&!E&!D&!C&B&!A1&!A|F1&F&!E&!D&!C&B&A1&!A|F1&F&E&!D&!C&B&A1&!A|!F1&!F&E&D&!C&B&A1&!A|F1&!F&E&D&!C&B&A1&!A|F1&F&E&D&!C&B&A1&!A|!F1&F&E&D&!C&B&A1&!A|F1&F&!E&D&!C&B&A1&!A|F1&F&!E&D&C&B&A1&!A|!F1&F&E&D&C&B&A1&!A|F1&F&E&D&C&B&A1&!A|F1&!F&E&D&C&B&A1&!A|!F1&!F&E&D&C&B&A1&!A|!F1&!F&E&!D&C&B&A1&!A|F1&!F&E&!D&C&B&A1&!A|F1&F&E&!D&C&B&A1&!A|!F1&F&E&!D&C&B&A1&!A|F1&F&!E&!D&C&B&A1&!A|F1&F&!E&!D&C&!B&A1&!A|F1&F&E&!D&C&!B&A1&!A|!F1&!F&E&D&C&!B&A1&!A|F1&!F&E&D&C&!B&A1&!A|F1&F&E&D&C&!B&A1&!A|!F1&F&E&D&C&!B&A1&!A|F1&F&!E&D&C&!B&A1&!A|F1&F&!E&D&!C&!B&A1&!A|!F1&F&E&D&!C&!B&A1&!A|F1&F&E&D&!C&!B&A1&!A|F1&!F&E&D&!C&!B&A1&!A|!F1&!F&E&D&!C&!B&A1&!A|F1&F&E&!D&!C&!B&A1&!A|F1&F&!E&!D&!C&!B&A1&!A|F1&F&!E&!D&!C&!B&A1&A|F1&F&E&!D&!C&!B&A1&A|!F1&!F&E&D&!C&!B&A1&A|F1&!F&E&D&!C&!B&A1&A|F1&F&E&D&!C&!B&A1&A|!F1&F&E&D&!C&!B&A1&A|F1&F&!E&D&!C&!B&A1&A|F1&F&!E&D&C&!B&A1&A|!F1&F&E&D&C&!B&A1&A|F1&F&E&D&C&!B&A1&A|F1&!F&E&D&C&!B&A1&A|!F1&!F&E&D&C&!B&A1&A|!F1&!F&E&!D&C&!B&A1&A|F1&!F&E&!D&C&!B&A1&A|F1&F&E&!D&C&!B&A1&A|!F1&F&E&!D&C&!B&A1&A|F1&F&!E&!D&C&!B&A1&A|F1&F&!E&!D&C&B&A1&A|!F1&F&E&!D&C&B&A1&A|F1&F&E&!D&C&B&A1&A|F1&!F&E&!D&C&B&A1&A|!F1&!F&E&!D&C&B&A1&A|!F1&!F&E&D&C&B&A1&A|F1&!F&E&D&C&B&A1&A|F1&F&E&D&C&B&A1&A|!F1&F&E&D&C&B&A1&A|F1&F&!E&D&C&B&A1&A|F1&F&!E&D&!C&B&A1&A|!F1&F&E&D&!C&B&A1&A|F1&F&E&D&!C&B&A1&A|F1&!F&E&D&!C&B&A1&A|!F1&!F&E&D&!C&B&A1&A|F1&F&E&!D&!C&B&A1&A|F1&F&!E&!D&!C&B&A1&A|F1&F&!E&!D&!C&B&!A1&A|F1&F&E&!D&!C&B&!A1&A|!F1&!F&E&D&!C&B&!A1&A|F1&!F&E&D&!C&B&!A1&A|F1&F&E&D&!C&B&!A1&A|!F1&F&E&D&!C&B&!A1&A|F1&F&!E&D&!C&B&!A1&A|F1&F&!E&D&C&B&!A1&A|!F1&F&E&D&C&B&!A1&A|F1&F&E&D&C&B&!A1&A|F1&!F&E&D&C&B&!A1&A|!F1&!F&E&D&C&B&!A1&A|!F1&!F&E&!D&C&B&!A1&A|F1&!F&E&!D&C&B&!A1&A|F1&F&E&!D&C&B&!A1&A|!F1&F&E&!D&C&B&!A1&A|F1&F&!E&!D&C&B&!A1&A|F1&F&!E&!D&C&!B&!A1&A|F1&F&E&!D&C&!B&!A1&A|!F1&!F&E&D&C&!B&!A1&A|F1&!F&E&D&C&!B&!A1&A|F1&F&E&D&C&!B&!A1&A|!F1&F&E&D&C&!B&!A1&A|F1&F&!E&D&C&!B&!A1&A|F1&F&!E&D&!C&!B&!A1&A|!F1&F&E&D&!C&!B&!A1&A|F1&F&E&D&!C&!B&!A1&A|F1&!F&E&D&!C&!B&!A1&A|!F1&!F&E&D&!C&!B&!A1&A|F1&F&E&!D&!C&!B&!A1&A|F1&F&!E&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOAAOI211112.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAOOAI22212 -l AAOOAOOAI22212 -i E1 E D C1 C B1 B A1 A -o Y -f Y=!(!E1&E&D&!C1&!C&!B1&!B&!A1&!A|E1&E&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D&C1&!C&!B1&!B&!A1&!A|E1&E&D&C1&!C&!B1&!B&!A1&!A|!E1&E&D&C1&!C&!B1&!B&!A1&!A|!E1&E&D&C1&C&!B1&!B&!A1&!A|E1&E&D&C1&C&!B1&!B&!A1&!A|E1&!E&D&C1&C&!B1&!B&!A1&!A|E1&!E&D&!C1&C&!B1&!B&!A1&!A|E1&E&D&!C1&C&!B1&!B&!A1&!A|!E1&E&D&!C1&C&!B1&!B&!A1&!A|!E1&E&D&!C1&C&B1&!B&!A1&!A|E1&E&D&!C1&C&B1&!B&!A1&!A|E1&!E&D&!C1&C&B1&!B&!A1&!A|E1&!E&D&C1&C&B1&!B&!A1&!A|E1&E&D&C1&C&B1&!B&!A1&!A|!E1&E&D&C1&C&B1&!B&!A1&!A|!E1&E&D&C1&!C&B1&!B&!A1&!A|E1&E&D&C1&!C&B1&!B&!A1&!A|E1&!E&D&C1&!C&B1&!B&!A1&!A|E1&!E&D&!C1&!C&B1&!B&!A1&!A|E1&E&D&!C1&!C&B1&!B&!A1&!A|!E1&E&D&!C1&!C&B1&!B&!A1&!A|!E1&E&D&!C1&!C&B1&B&!A1&!A|E1&E&D&!C1&!C&B1&B&!A1&!A|E1&!E&D&!C1&!C&B1&B&!A1&!A|E1&!E&D&C1&!C&B1&B&!A1&!A|E1&E&D&C1&!C&B1&B&!A1&!A|!E1&E&D&C1&!C&B1&B&!A1&!A|!E1&E&!D&C1&!C&B1&B&!A1&!A|E1&E&!D&C1&!C&B1&B&!A1&!A|E1&!E&!D&C1&!C&B1&B&!A1&!A|E1&!E&!D&C1&C&B1&B&!A1&!A|E1&E&!D&C1&C&B1&B&!A1&!A|!E1&E&!D&C1&C&B1&B&!A1&!A|!E1&E&D&C1&C&B1&B&!A1&!A|E1&E&D&C1&C&B1&B&!A1&!A|E1&!E&D&C1&C&B1&B&!A1&!A|E1&!E&D&!C1&C&B1&B&!A1&!A|E1&E&D&!C1&C&B1&B&!A1&!A|!E1&E&D&!C1&C&B1&B&!A1&!A|!E1&E&!D&!C1&C&B1&B&!A1&!A|E1&E&!D&!C1&C&B1&B&!A1&!A|E1&!E&!D&!C1&C&B1&B&!A1&!A|!E1&E&D&!C1&C&!B1&B&!A1&!A|E1&E&D&!C1&C&!B1&B&!A1&!A|E1&!E&D&!C1&C&!B1&B&!A1&!A|E1&!E&D&C1&C&!B1&B&!A1&!A|E1&E&D&C1&C&!B1&B&!A1&!A|!E1&E&D&C1&C&!B1&B&!A1&!A|!E1&E&D&C1&!C&!B1&B&!A1&!A|E1&E&D&C1&!C&!B1&B&!A1&!A|E1&!E&D&C1&!C&!B1&B&!A1&!A|E1&!E&D&!C1&!C&!B1&B&!A1&!A|E1&E&D&!C1&!C&!B1&B&!A1&!A|!E1&E&D&!C1&!C&!B1&B&!A1&!A|!E1&E&D&!C1&!C&!B1&B&A1&!A|E1&E&D&!C1&!C&!B1&B&A1&!A|E1&!E&D&!C1&!C&!B1&B&A1&!A|E1&!E&D&C1&!C&!B1&B&A1&!A|E1&E&D&C1&!C&!B1&B&A1&!A|!E1&E&D&C1&!C&!B1&B&A1&!A|!E1&E&D&C1&C&!B1&B&A1&!A|E1&E&D&C1&C&!B1&B&A1&!A|E1&!E&D&C1&C&!B1&B&A1&!A|E1&!E&D&!C1&C&!B1&B&A1&!A|E1&E&D&!C1&C&!B1&B&A1&!A|!E1&E&D&!C1&C&!B1&B&A1&!A|E1&!E&!D&!C1&C&B1&B&A1&!A|E1&E&!D&!C1&C&B1&B&A1&!A|!E1&E&!D&!C1&C&B1&B&A1&!A|!E1&E&D&!C1&C&B1&B&A1&!A|E1&E&D&!C1&C&B1&B&A1&!A|E1&!E&D&!C1&C&B1&B&A1&!A|E1&!E&D&C1&C&B1&B&A1&!A|E1&E&D&C1&C&B1&B&A1&!A|!E1&E&D&C1&C&B1&B&A1&!A|!E1&E&!D&C1&C&B1&B&A1&!A|E1&E&!D&C1&C&B1&B&A1&!A|E1&!E&!D&C1&C&B1&B&A1&!A|E1&!E&!D&C1&!C&B1&B&A1&!A|E1&E&!D&C1&!C&B1&B&A1&!A|!E1&E&!D&C1&!C&B1&B&A1&!A|!E1&E&D&C1&!C&B1&B&A1&!A|E1&E&D&C1&!C&B1&B&A1&!A|E1&!E&D&C1&!C&B1&B&A1&!A|E1&!E&D&!C1&!C&B1&B&A1&!A|E1&E&D&!C1&!C&B1&B&A1&!A|!E1&E&D&!C1&!C&B1&B&A1&!A|!E1&E&D&!C1&!C&B1&!B&A1&!A|E1&E&D&!C1&!C&B1&!B&A1&!A|E1&!E&D&!C1&!C&B1&!B&A1&!A|E1&!E&D&C1&!C&B1&!B&A1&!A|E1&E&D&C1&!C&B1&!B&A1&!A|!E1&E&D&C1&!C&B1&!B&A1&!A|!E1&E&D&C1&C&B1&!B&A1&!A|E1&E&D&C1&C&B1&!B&A1&!A|E1&!E&D&C1&C&B1&!B&A1&!A|E1&!E&D&!C1&C&B1&!B&A1&!A|E1&E&D&!C1&C&B1&!B&A1&!A|!E1&E&D&!C1&C&B1&!B&A1&!A|!E1&E&D&!C1&C&!B1&!B&A1&!A|E1&E&D&!C1&C&!B1&!B&A1&!A|E1&!E&D&!C1&C&!B1&!B&A1&!A|E1&!E&D&C1&C&!B1&!B&A1&!A|E1&E&D&C1&C&!B1&!B&A1&!A|!E1&E&D&C1&C&!B1&!B&A1&!A|!E1&E&D&C1&!C&!B1&!B&A1&!A|E1&E&D&C1&!C&!B1&!B&A1&!A|E1&!E&D&C1&!C&!B1&!B&A1&!A|E1&!E&D&!C1&!C&!B1&!B&A1&!A|E1&E&D&!C1&!C&!B1&!B&A1&!A|!E1&E&D&!C1&!C&!B1&!B&A1&!A|!E1&E&D&!C1&!C&!B1&!B&A1&A|E1&E&D&!C1&!C&!B1&!B&A1&A|E1&!E&D&!C1&!C&!B1&!B&A1&A|E1&!E&D&C1&!C&!B1&!B&A1&A|E1&E&D&C1&!C&!B1&!B&A1&A|!E1&E&D&C1&!C&!B1&!B&A1&A|!E1&E&!D&C1&!C&!B1&!B&A1&A|E1&E&!D&C1&!C&!B1&!B&A1&A|E1&!E&!D&C1&!C&!B1&!B&A1&A|E1&!E&!D&C1&C&!B1&!B&A1&A|E1&E&!D&C1&C&!B1&!B&A1&A|!E1&E&!D&C1&C&!B1&!B&A1&A|!E1&E&D&C1&C&!B1&!B&A1&A|E1&E&D&C1&C&!B1&!B&A1&A|E1&!E&D&C1&C&!B1&!B&A1&A|E1&!E&D&!C1&C&!B1&!B&A1&A|E1&E&D&!C1&C&!B1&!B&A1&A|!E1&E&D&!C1&C&!B1&!B&A1&A|!E1&E&!D&!C1&C&!B1&!B&A1&A|E1&E&!D&!C1&C&!B1&!B&A1&A|E1&!E&!D&!C1&C&!B1&!B&A1&A|E1&!E&!D&!C1&C&B1&!B&A1&A|E1&E&!D&!C1&C&B1&!B&A1&A|!E1&E&!D&!C1&C&B1&!B&A1&A|!E1&E&D&!C1&C&B1&!B&A1&A|E1&E&D&!C1&C&B1&!B&A1&A|E1&!E&D&!C1&C&B1&!B&A1&A|E1&!E&D&C1&C&B1&!B&A1&A|E1&E&D&C1&C&B1&!B&A1&A|!E1&E&D&C1&C&B1&!B&A1&A|!E1&E&!D&C1&C&B1&!B&A1&A|E1&E&!D&C1&C&B1&!B&A1&A|E1&!E&!D&C1&C&B1&!B&A1&A|E1&!E&!D&C1&!C&B1&!B&A1&A|E1&E&!D&C1&!C&B1&!B&A1&A|!E1&E&!D&C1&!C&B1&!B&A1&A|!E1&E&D&C1&!C&B1&!B&A1&A|E1&E&D&C1&!C&B1&!B&A1&A|E1&!E&D&C1&!C&B1&!B&A1&A|E1&!E&D&!C1&!C&B1&!B&A1&A|E1&E&D&!C1&!C&B1&!B&A1&A|!E1&E&D&!C1&!C&B1&!B&A1&A|!E1&E&D&!C1&!C&B1&B&A1&A|E1&E&D&!C1&!C&B1&B&A1&A|E1&!E&D&!C1&!C&B1&B&A1&A|E1&!E&D&C1&!C&B1&B&A1&A|E1&E&D&C1&!C&B1&B&A1&A|!E1&E&D&C1&!C&B1&B&A1&A|!E1&E&!D&C1&!C&B1&B&A1&A|E1&E&!D&C1&!C&B1&B&A1&A|E1&!E&!D&C1&!C&B1&B&A1&A|E1&!E&!D&C1&C&B1&B&A1&A|E1&E&!D&C1&C&B1&B&A1&A|!E1&E&!D&C1&C&B1&B&A1&A|!E1&E&D&C1&C&B1&B&A1&A|E1&E&D&C1&C&B1&B&A1&A|E1&!E&D&C1&C&B1&B&A1&A|E1&!E&D&!C1&C&B1&B&A1&A|E1&E&D&!C1&C&B1&B&A1&A|!E1&E&D&!C1&C&B1&B&A1&A|!E1&E&!D&!C1&C&B1&B&A1&A|E1&E&!D&!C1&C&B1&B&A1&A|E1&!E&!D&!C1&C&B1&B&A1&A|E1&!E&!D&!C1&C&!B1&B&A1&A|E1&E&!D&!C1&C&!B1&B&A1&A|!E1&E&!D&!C1&C&!B1&B&A1&A|!E1&E&D&!C1&C&!B1&B&A1&A|E1&E&D&!C1&C&!B1&B&A1&A|E1&!E&D&!C1&C&!B1&B&A1&A|E1&!E&D&C1&C&!B1&B&A1&A|E1&E&D&C1&C&!B1&B&A1&A|!E1&E&D&C1&C&!B1&B&A1&A|!E1&E&!D&C1&C&!B1&B&A1&A|E1&E&!D&C1&C&!B1&B&A1&A|E1&!E&!D&C1&C&!B1&B&A1&A|E1&!E&!D&C1&!C&!B1&B&A1&A|E1&E&!D&C1&!C&!B1&B&A1&A|!E1&E&!D&C1&!C&!B1&B&A1&A|!E1&E&D&C1&!C&!B1&B&A1&A|E1&E&D&C1&!C&!B1&B&A1&A|E1&!E&D&C1&!C&!B1&B&A1&A|E1&!E&D&!C1&!C&!B1&B&A1&A|E1&E&D&!C1&!C&!B1&B&A1&A|!E1&E&D&!C1&!C&!B1&B&A1&A|!E1&E&D&!C1&!C&!B1&B&!A1&A|E1&E&D&!C1&!C&!B1&B&!A1&A|E1&!E&D&!C1&!C&!B1&B&!A1&A|E1&!E&D&C1&!C&!B1&B&!A1&A|E1&E&D&C1&!C&!B1&B&!A1&A|!E1&E&D&C1&!C&!B1&B&!A1&A|!E1&E&D&C1&C&!B1&B&!A1&A|E1&E&D&C1&C&!B1&B&!A1&A|E1&!E&D&C1&C&!B1&B&!A1&A|E1&!E&D&!C1&C&!B1&B&!A1&A|E1&E&D&!C1&C&!B1&B&!A1&A|!E1&E&D&!C1&C&!B1&B&!A1&A|E1&!E&!D&!C1&C&B1&B&!A1&A|E1&E&!D&!C1&C&B1&B&!A1&A|!E1&E&!D&!C1&C&B1&B&!A1&A|!E1&E&D&!C1&C&B1&B&!A1&A|E1&E&D&!C1&C&B1&B&!A1&A|E1&!E&D&!C1&C&B1&B&!A1&A|E1&!E&D&C1&C&B1&B&!A1&A|E1&E&D&C1&C&B1&B&!A1&A|!E1&E&D&C1&C&B1&B&!A1&A|!E1&E&!D&C1&C&B1&B&!A1&A|E1&E&!D&C1&C&B1&B&!A1&A|E1&!E&!D&C1&C&B1&B&!A1&A|E1&!E&!D&C1&!C&B1&B&!A1&A|E1&E&!D&C1&!C&B1&B&!A1&A|!E1&E&!D&C1&!C&B1&B&!A1&A|!E1&E&D&C1&!C&B1&B&!A1&A|E1&E&D&C1&!C&B1&B&!A1&A|E1&!E&D&C1&!C&B1&B&!A1&A|E1&!E&D&!C1&!C&B1&B&!A1&A|E1&E&D&!C1&!C&B1&B&!A1&A|!E1&E&D&!C1&!C&B1&B&!A1&A|!E1&E&D&!C1&!C&B1&!B&!A1&A|E1&E&D&!C1&!C&B1&!B&!A1&A|E1&!E&D&!C1&!C&B1&!B&!A1&A|E1&!E&D&C1&!C&B1&!B&!A1&A|E1&E&D&C1&!C&B1&!B&!A1&A|!E1&E&D&C1&!C&B1&!B&!A1&A|!E1&E&D&C1&C&B1&!B&!A1&A|E1&E&D&C1&C&B1&!B&!A1&A|E1&!E&D&C1&C&B1&!B&!A1&A|E1&!E&D&!C1&C&B1&!B&!A1&A|E1&E&D&!C1&C&B1&!B&!A1&A|!E1&E&D&!C1&C&B1&!B&!A1&A|!E1&E&D&!C1&C&!B1&!B&!A1&A|E1&E&D&!C1&C&!B1&!B&!A1&A|E1&!E&D&!C1&C&!B1&!B&!A1&A|E1&!E&D&C1&C&!B1&!B&!A1&A|E1&E&D&C1&C&!B1&!B&!A1&A|!E1&E&D&C1&C&!B1&!B&!A1&A|!E1&E&D&C1&!C&!B1&!B&!A1&A|E1&E&D&C1&!C&!B1&!B&!A1&A|E1&!E&D&C1&!C&!B1&!B&!A1&A|E1&!E&D&!C1&!C&!B1&!B&!A1&A|E1&E&D&!C1&!C&!B1&!B&!A1&A|!E1&E&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAOOAI22212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAOI3321 -l OOOAOI3321 -i D C1 C B2 B1 B A2 A1 A -o Y -f Y=(!D&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D&C1&C&!B2&!B1&!B&!A2&!A1&!A|!D&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!D&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D&C1&C&B2&!B1&!B&!A2&!A1&!A|!D&C1&!C&B2&!B1&!B&!A2&!A1&!A|!D&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!D&!C1&!C&B2&B1&!B&!A2&!A1&!A|!D&C1&!C&B2&B1&!B&!A2&!A1&!A|!D&C1&C&B2&B1&!B&!A2&!A1&!A|!D&!C1&C&B2&B1&!B&!A2&!A1&!A|!D&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D&C1&C&!B2&B1&!B&!A2&!A1&!A|!D&C1&!C&!B2&B1&!B&!A2&!A1&!A|!D&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!D&!C1&!C&!B2&B1&B&!A2&!A1&!A|!D&C1&!C&!B2&B1&B&!A2&!A1&!A|!D&C1&C&!B2&B1&B&!A2&!A1&!A|!D&!C1&C&!B2&B1&B&!A2&!A1&!A|!D&!C1&C&B2&B1&B&!A2&!A1&!A|!D&C1&C&B2&B1&B&!A2&!A1&!A|!D&C1&!C&B2&B1&B&!A2&!A1&!A|!D&!C1&!C&B2&B1&B&!A2&!A1&!A|!D&!C1&!C&B2&!B1&B&!A2&!A1&!A|!D&C1&!C&B2&!B1&B&!A2&!A1&!A|!D&C1&C&B2&!B1&B&!A2&!A1&!A|!D&!C1&C&B2&!B1&B&!A2&!A1&!A|!D&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D&C1&C&!B2&!B1&B&!A2&!A1&!A|!D&C1&!C&!B2&!B1&B&!A2&!A1&!A|!D&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!D&!C1&!C&!B2&!B1&B&A2&!A1&!A|!D&!C1&!C&B2&!B1&B&A2&!A1&!A|!D&!C1&!C&B2&B1&B&A2&!A1&!A|!D&!C1&!C&!B2&B1&B&A2&!A1&!A|!D&!C1&!C&!B2&B1&!B&A2&!A1&!A|!D&!C1&!C&B2&B1&!B&A2&!A1&!A|!D&!C1&!C&B2&!B1&!B&A2&!A1&!A|!D&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D&C1&C&!B2&!B1&!B&A2&!A1&!A|!D&C1&!C&!B2&!B1&!B&A2&!A1&!A|!D&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!D&!C1&!C&!B2&!B1&!B&A2&A1&!A|!D&C1&!C&!B2&!B1&!B&A2&A1&!A|!D&C1&C&!B2&!B1&!B&A2&A1&!A|!D&!C1&C&!B2&!B1&!B&A2&A1&!A|!D&!C1&!C&B2&!B1&!B&A2&A1&!A|!D&!C1&!C&B2&B1&!B&A2&A1&!A|!D&!C1&!C&!B2&B1&!B&A2&A1&!A|!D&!C1&!C&!B2&B1&B&A2&A1&!A|!D&!C1&!C&B2&B1&B&A2&A1&!A|!D&!C1&!C&B2&!B1&B&A2&A1&!A|!D&!C1&!C&!B2&!B1&B&A2&A1&!A|!D&!C1&!C&!B2&!B1&B&!A2&A1&!A|!D&!C1&!C&B2&!B1&B&!A2&A1&!A|!D&!C1&!C&B2&B1&B&!A2&A1&!A|!D&!C1&!C&!B2&B1&B&!A2&A1&!A|!D&!C1&!C&!B2&B1&!B&!A2&A1&!A|!D&!C1&!C&B2&B1&!B&!A2&A1&!A|!D&!C1&!C&B2&!B1&!B&!A2&A1&!A|!D&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D&C1&C&!B2&!B1&!B&!A2&A1&!A|!D&C1&!C&!B2&!B1&!B&!A2&A1&!A|!D&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!D&!C1&!C&!B2&!B1&!B&!A2&A1&A|!D&C1&!C&!B2&!B1&!B&!A2&A1&A|!D&C1&C&!B2&!B1&!B&!A2&A1&A|!D&!C1&C&!B2&!B1&!B&!A2&A1&A|!D&!C1&!C&B2&!B1&!B&!A2&A1&A|!D&!C1&!C&B2&B1&!B&!A2&A1&A|!D&!C1&!C&!B2&B1&!B&!A2&A1&A|!D&!C1&!C&!B2&B1&B&!A2&A1&A|!D&!C1&!C&B2&B1&B&!A2&A1&A|!D&!C1&!C&B2&!B1&B&!A2&A1&A|!D&!C1&!C&!B2&!B1&B&!A2&A1&A|!D&!C1&!C&!B2&!B1&B&A2&A1&A|!D&!C1&!C&B2&!B1&B&A2&A1&A|!D&!C1&!C&B2&B1&B&A2&A1&A|!D&!C1&!C&!B2&B1&B&A2&A1&A|!D&!C1&!C&!B2&B1&!B&A2&A1&A|!D&!C1&!C&B2&B1&!B&A2&A1&A|!D&!C1&!C&B2&!B1&!B&A2&A1&A|!D&!C1&C&!B2&!B1&!B&A2&A1&A|!D&C1&C&!B2&!B1&!B&A2&A1&A|!D&C1&!C&!B2&!B1&!B&A2&A1&A|!D&!C1&!C&!B2&!B1&!B&A2&A1&A|!D&!C1&!C&!B2&!B1&!B&A2&!A1&A|!D&C1&!C&!B2&!B1&!B&A2&!A1&A|!D&C1&C&!B2&!B1&!B&A2&!A1&A|!D&!C1&C&!B2&!B1&!B&A2&!A1&A|!D&!C1&!C&B2&!B1&!B&A2&!A1&A|!D&!C1&!C&B2&B1&!B&A2&!A1&A|!D&!C1&!C&!B2&B1&!B&A2&!A1&A|!D&!C1&!C&!B2&B1&B&A2&!A1&A|!D&!C1&!C&B2&B1&B&A2&!A1&A|!D&!C1&!C&B2&!B1&B&A2&!A1&A|!D&!C1&!C&!B2&!B1&B&A2&!A1&A|!D&!C1&!C&!B2&!B1&B&!A2&!A1&A|!D&!C1&!C&B2&!B1&B&!A2&!A1&A|!D&!C1&!C&B2&B1&B&!A2&!A1&A|!D&!C1&!C&!B2&B1&B&!A2&!A1&A|!D&!C1&!C&!B2&B1&!B&!A2&!A1&A|!D&!C1&!C&B2&B1&!B&!A2&!A1&A|!D&!C1&!C&B2&!B1&!B&!A2&!A1&A|!D&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D&C1&C&!B2&!B1&!B&!A2&!A1&A|!D&C1&!C&!B2&!B1&!B&!A2&!A1&A|!D&!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAOI3321.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOI222 -l OOAAOI222 -i C1 C B1 B A1 A -o Y -f Y=(!C1&!C&!B1&!B&!A1&!A|C1&!C&!B1&!B&!A1&!A|!C1&C&!B1&!B&!A1&!A|!C1&C&B1&!B&!A1&!A|C1&!C&B1&!B&!A1&!A|!C1&!C&B1&!B&!A1&!A|!C1&!C&B1&B&!A1&!A|C1&!C&B1&B&!A1&!A|!C1&C&B1&B&!A1&!A|!C1&C&!B1&B&!A1&!A|C1&!C&!B1&B&!A1&!A|!C1&!C&!B1&B&!A1&!A|!C1&C&!B1&!B&A1&!A|C1&!C&!B1&!B&A1&!A|!C1&!C&!B1&!B&A1&!A|!C1&!C&!B1&!B&A1&A|C1&!C&!B1&!B&A1&A|!C1&C&!B1&!B&A1&A|!C1&C&!B1&!B&!A1&A|C1&!C&!B1&!B&!A1&A|!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOI222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOAOI212311 -l AOOAAOAOI212311 -i F E D2 D1 D C1 C B A1 A -o Y -f Y=(!F&!E&!D2&!D1&!D&!C1&!C&!B&!A1&!A|!F&E&!D2&!D1&!D&!C1&!C&!B&!A1&!A|!F&E&D2&!D1&!D&!C1&!C&!B&!A1&!A|!F&!E&D2&!D1&!D&!C1&!C&!B&!A1&!A|!F&!E&D2&D1&!D&!C1&!C&!B&!A1&!A|!F&E&D2&D1&!D&!C1&!C&!B&!A1&!A|!F&E&!D2&D1&!D&!C1&!C&!B&!A1&!A|!F&!E&!D2&D1&!D&!C1&!C&!B&!A1&!A|!F&!E&!D2&D1&D&!C1&!C&!B&!A1&!A|!F&E&!D2&D1&D&!C1&!C&!B&!A1&!A|!F&!E&D2&D1&D&!C1&!C&!B&!A1&!A|!F&!E&D2&!D1&D&!C1&!C&!B&!A1&!A|!F&E&D2&!D1&D&!C1&!C&!B&!A1&!A|!F&E&!D2&!D1&D&!C1&!C&!B&!A1&!A|!F&!E&!D2&!D1&D&!C1&!C&!B&!A1&!A|!F&!E&!D2&!D1&D&C1&!C&!B&!A1&!A|!F&E&!D2&!D1&D&C1&!C&!B&!A1&!A|!F&E&D2&!D1&D&C1&!C&!B&!A1&!A|!F&!E&D2&!D1&D&C1&!C&!B&!A1&!A|!F&!E&D2&D1&D&C1&!C&!B&!A1&!A|!F&E&!D2&D1&D&C1&!C&!B&!A1&!A|!F&!E&!D2&D1&D&C1&!C&!B&!A1&!A|!F&!E&!D2&D1&!D&C1&!C&!B&!A1&!A|!F&E&!D2&D1&!D&C1&!C&!B&!A1&!A|!F&E&D2&D1&!D&C1&!C&!B&!A1&!A|!F&!E&D2&D1&!D&C1&!C&!B&!A1&!A|!F&!E&D2&!D1&!D&C1&!C&!B&!A1&!A|!F&E&D2&!D1&!D&C1&!C&!B&!A1&!A|!F&E&!D2&!D1&!D&C1&!C&!B&!A1&!A|!F&!E&!D2&!D1&!D&C1&!C&!B&!A1&!A|!F&!E&!D2&!D1&!D&C1&C&!B&!A1&!A|!F&E&!D2&!D1&!D&C1&C&!B&!A1&!A|!F&E&D2&!D1&!D&C1&C&!B&!A1&!A|!F&!E&D2&!D1&!D&C1&C&!B&!A1&!A|!F&!E&D2&D1&!D&C1&C&!B&!A1&!A|!F&E&D2&D1&!D&C1&C&!B&!A1&!A|!F&E&!D2&D1&!D&C1&C&!B&!A1&!A|!F&!E&!D2&D1&!D&C1&C&!B&!A1&!A|!F&!E&!D2&D1&D&C1&C&!B&!A1&!A|!F&E&!D2&D1&D&C1&C&!B&!A1&!A|!F&!E&D2&D1&D&C1&C&!B&!A1&!A|!F&!E&D2&!D1&D&C1&C&!B&!A1&!A|!F&E&D2&!D1&D&C1&C&!B&!A1&!A|!F&E&!D2&!D1&D&C1&C&!B&!A1&!A|!F&!E&!D2&!D1&D&C1&C&!B&!A1&!A|!F&!E&!D2&!D1&D&!C1&C&!B&!A1&!A|!F&E&!D2&!D1&D&!C1&C&!B&!A1&!A|!F&E&D2&!D1&D&!C1&C&!B&!A1&!A|!F&!E&D2&!D1&D&!C1&C&!B&!A1&!A|!F&!E&D2&D1&D&!C1&C&!B&!A1&!A|!F&E&!D2&D1&D&!C1&C&!B&!A1&!A|!F&!E&!D2&D1&D&!C1&C&!B&!A1&!A|!F&!E&!D2&D1&!D&!C1&C&!B&!A1&!A|!F&E&!D2&D1&!D&!C1&C&!B&!A1&!A|!F&E&D2&D1&!D&!C1&C&!B&!A1&!A|!F&!E&D2&D1&!D&!C1&C&!B&!A1&!A|!F&!E&D2&!D1&!D&!C1&C&!B&!A1&!A|!F&E&D2&!D1&!D&!C1&C&!B&!A1&!A|!F&E&!D2&!D1&!D&!C1&C&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&C&!B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&C&B&!A1&!A|!F&!E&D2&!D1&!D&!C1&C&B&!A1&!A|!F&!E&D2&D1&!D&!C1&C&B&!A1&!A|!F&!E&!D2&D1&!D&!C1&C&B&!A1&!A|!F&!E&!D2&D1&D&!C1&C&B&!A1&!A|!F&!E&D2&D1&D&!C1&C&B&!A1&!A|!F&!E&D2&!D1&D&!C1&C&B&!A1&!A|!F&!E&!D2&!D1&D&!C1&C&B&!A1&!A|!F&!E&!D2&!D1&D&C1&C&B&!A1&!A|!F&!E&D2&!D1&D&C1&C&B&!A1&!A|!F&!E&D2&D1&D&C1&C&B&!A1&!A|!F&!E&!D2&D1&D&C1&C&B&!A1&!A|!F&!E&!D2&D1&!D&C1&C&B&!A1&!A|!F&!E&D2&D1&!D&C1&C&B&!A1&!A|!F&!E&D2&!D1&!D&C1&C&B&!A1&!A|!F&!E&!D2&!D1&!D&C1&C&B&!A1&!A|!F&!E&!D2&!D1&!D&C1&!C&B&!A1&!A|!F&!E&D2&!D1&!D&C1&!C&B&!A1&!A|!F&!E&D2&D1&!D&C1&!C&B&!A1&!A|!F&!E&!D2&D1&!D&C1&!C&B&!A1&!A|!F&!E&!D2&D1&D&C1&!C&B&!A1&!A|!F&!E&D2&D1&D&C1&!C&B&!A1&!A|!F&!E&D2&!D1&D&C1&!C&B&!A1&!A|!F&!E&!D2&!D1&D&C1&!C&B&!A1&!A|!F&!E&!D2&!D1&D&!C1&!C&B&!A1&!A|!F&E&!D2&!D1&D&!C1&!C&B&!A1&!A|!F&E&D2&!D1&D&!C1&!C&B&!A1&!A|!F&!E&D2&!D1&D&!C1&!C&B&!A1&!A|!F&!E&D2&D1&D&!C1&!C&B&!A1&!A|!F&E&!D2&D1&D&!C1&!C&B&!A1&!A|!F&!E&!D2&D1&D&!C1&!C&B&!A1&!A|!F&!E&!D2&D1&!D&!C1&!C&B&!A1&!A|!F&E&!D2&D1&!D&!C1&!C&B&!A1&!A|!F&E&D2&D1&!D&!C1&!C&B&!A1&!A|!F&!E&D2&D1&!D&!C1&!C&B&!A1&!A|!F&!E&D2&!D1&!D&!C1&!C&B&!A1&!A|!F&E&D2&!D1&!D&!C1&!C&B&!A1&!A|!F&E&!D2&!D1&!D&!C1&!C&B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&B&!A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&B&A1&!A|!F&E&!D2&!D1&!D&!C1&!C&B&A1&!A|!F&E&D2&!D1&!D&!C1&!C&B&A1&!A|!F&!E&D2&!D1&!D&!C1&!C&B&A1&!A|!F&!E&D2&D1&!D&!C1&!C&B&A1&!A|!F&E&D2&D1&!D&!C1&!C&B&A1&!A|!F&E&!D2&D1&!D&!C1&!C&B&A1&!A|!F&!E&!D2&D1&!D&!C1&!C&B&A1&!A|!F&!E&!D2&D1&D&!C1&!C&B&A1&!A|!F&E&!D2&D1&D&!C1&!C&B&A1&!A|!F&!E&D2&D1&D&!C1&!C&B&A1&!A|!F&!E&D2&!D1&D&!C1&!C&B&A1&!A|!F&E&D2&!D1&D&!C1&!C&B&A1&!A|!F&E&!D2&!D1&D&!C1&!C&B&A1&!A|!F&!E&!D2&!D1&D&!C1&!C&B&A1&!A|!F&!E&!D2&!D1&D&C1&!C&B&A1&!A|!F&!E&D2&!D1&D&C1&!C&B&A1&!A|!F&!E&D2&D1&D&C1&!C&B&A1&!A|!F&!E&!D2&D1&D&C1&!C&B&A1&!A|!F&!E&!D2&D1&!D&C1&!C&B&A1&!A|!F&!E&D2&D1&!D&C1&!C&B&A1&!A|!F&!E&D2&!D1&!D&C1&!C&B&A1&!A|!F&!E&!D2&!D1&!D&C1&!C&B&A1&!A|!F&!E&!D2&!D1&!D&C1&C&B&A1&!A|!F&!E&D2&!D1&!D&C1&C&B&A1&!A|!F&!E&D2&D1&!D&C1&C&B&A1&!A|!F&!E&!D2&D1&!D&C1&C&B&A1&!A|!F&!E&!D2&D1&D&C1&C&B&A1&!A|!F&!E&D2&D1&D&C1&C&B&A1&!A|!F&!E&D2&!D1&D&C1&C&B&A1&!A|!F&!E&!D2&!D1&D&C1&C&B&A1&!A|!F&!E&!D2&!D1&D&!C1&C&B&A1&!A|!F&!E&D2&!D1&D&!C1&C&B&A1&!A|!F&!E&D2&D1&D&!C1&C&B&A1&!A|!F&!E&!D2&D1&D&!C1&C&B&A1&!A|!F&!E&!D2&D1&!D&!C1&C&B&A1&!A|!F&!E&D2&D1&!D&!C1&C&B&A1&!A|!F&!E&D2&!D1&!D&!C1&C&B&A1&!A|!F&!E&!D2&!D1&!D&!C1&C&B&A1&!A|!F&!E&!D2&!D1&!D&!C1&C&!B&A1&!A|!F&E&!D2&!D1&!D&!C1&C&!B&A1&!A|!F&E&D2&!D1&!D&!C1&C&!B&A1&!A|!F&!E&D2&!D1&!D&!C1&C&!B&A1&!A|!F&!E&D2&D1&!D&!C1&C&!B&A1&!A|!F&E&D2&D1&!D&!C1&C&!B&A1&!A|!F&E&!D2&D1&!D&!C1&C&!B&A1&!A|!F&!E&!D2&D1&!D&!C1&C&!B&A1&!A|!F&!E&!D2&D1&D&!C1&C&!B&A1&!A|!F&E&!D2&D1&D&!C1&C&!B&A1&!A|!F&!E&D2&D1&D&!C1&C&!B&A1&!A|!F&!E&D2&!D1&D&!C1&C&!B&A1&!A|!F&E&D2&!D1&D&!C1&C&!B&A1&!A|!F&E&!D2&!D1&D&!C1&C&!B&A1&!A|!F&!E&!D2&!D1&D&!C1&C&!B&A1&!A|!F&!E&!D2&!D1&D&C1&C&!B&A1&!A|!F&E&!D2&!D1&D&C1&C&!B&A1&!A|!F&E&D2&!D1&D&C1&C&!B&A1&!A|!F&!E&D2&!D1&D&C1&C&!B&A1&!A|!F&!E&D2&D1&D&C1&C&!B&A1&!A|!F&E&!D2&D1&D&C1&C&!B&A1&!A|!F&!E&!D2&D1&D&C1&C&!B&A1&!A|!F&!E&!D2&D1&!D&C1&C&!B&A1&!A|!F&E&!D2&D1&!D&C1&C&!B&A1&!A|!F&E&D2&D1&!D&C1&C&!B&A1&!A|!F&!E&D2&D1&!D&C1&C&!B&A1&!A|!F&!E&D2&!D1&!D&C1&C&!B&A1&!A|!F&E&D2&!D1&!D&C1&C&!B&A1&!A|!F&E&!D2&!D1&!D&C1&C&!B&A1&!A|!F&!E&!D2&!D1&!D&C1&C&!B&A1&!A|!F&!E&!D2&!D1&!D&C1&!C&!B&A1&!A|!F&E&!D2&!D1&!D&C1&!C&!B&A1&!A|!F&E&D2&!D1&!D&C1&!C&!B&A1&!A|!F&!E&D2&!D1&!D&C1&!C&!B&A1&!A|!F&!E&D2&D1&!D&C1&!C&!B&A1&!A|!F&E&D2&D1&!D&C1&!C&!B&A1&!A|!F&E&!D2&D1&!D&C1&!C&!B&A1&!A|!F&!E&!D2&D1&!D&C1&!C&!B&A1&!A|!F&!E&!D2&D1&D&C1&!C&!B&A1&!A|!F&E&!D2&D1&D&C1&!C&!B&A1&!A|!F&!E&D2&D1&D&C1&!C&!B&A1&!A|!F&!E&D2&!D1&D&C1&!C&!B&A1&!A|!F&E&D2&!D1&D&C1&!C&!B&A1&!A|!F&E&!D2&!D1&D&C1&!C&!B&A1&!A|!F&!E&!D2&!D1&D&C1&!C&!B&A1&!A|!F&!E&!D2&!D1&D&!C1&!C&!B&A1&!A|!F&E&!D2&!D1&D&!C1&!C&!B&A1&!A|!F&E&D2&!D1&D&!C1&!C&!B&A1&!A|!F&!E&D2&!D1&D&!C1&!C&!B&A1&!A|!F&!E&D2&D1&D&!C1&!C&!B&A1&!A|!F&E&!D2&D1&D&!C1&!C&!B&A1&!A|!F&!E&!D2&D1&D&!C1&!C&!B&A1&!A|!F&!E&!D2&D1&!D&!C1&!C&!B&A1&!A|!F&E&!D2&D1&!D&!C1&!C&!B&A1&!A|!F&E&D2&D1&!D&!C1&!C&!B&A1&!A|!F&!E&D2&D1&!D&!C1&!C&!B&A1&!A|!F&!E&D2&!D1&!D&!C1&!C&!B&A1&!A|!F&E&D2&!D1&!D&!C1&!C&!B&A1&!A|!F&E&!D2&!D1&!D&!C1&!C&!B&A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&!B&A1&!A|!F&!E&!D2&!D1&!D&!C1&!C&!B&A1&A|!F&E&!D2&!D1&!D&!C1&!C&!B&A1&A|!F&E&D2&!D1&!D&!C1&!C&!B&A1&A|!F&!E&D2&!D1&!D&!C1&!C&!B&A1&A|!F&!E&D2&D1&!D&!C1&!C&!B&A1&A|!F&E&D2&D1&!D&!C1&!C&!B&A1&A|!F&E&!D2&D1&!D&!C1&!C&!B&A1&A|!F&!E&!D2&D1&!D&!C1&!C&!B&A1&A|!F&!E&!D2&D1&D&!C1&!C&!B&A1&A|!F&E&!D2&D1&D&!C1&!C&!B&A1&A|!F&!E&D2&D1&D&!C1&!C&!B&A1&A|!F&!E&D2&!D1&D&!C1&!C&!B&A1&A|!F&E&D2&!D1&D&!C1&!C&!B&A1&A|!F&E&!D2&!D1&D&!C1&!C&!B&A1&A|!F&!E&!D2&!D1&D&!C1&!C&!B&A1&A|!F&!E&!D2&!D1&D&C1&!C&!B&A1&A|!F&!E&D2&!D1&D&C1&!C&!B&A1&A|!F&!E&D2&D1&D&C1&!C&!B&A1&A|!F&!E&!D2&D1&D&C1&!C&!B&A1&A|!F&!E&!D2&D1&!D&C1&!C&!B&A1&A|!F&!E&D2&D1&!D&C1&!C&!B&A1&A|!F&!E&D2&!D1&!D&C1&!C&!B&A1&A|!F&!E&!D2&!D1&!D&C1&!C&!B&A1&A|!F&!E&!D2&!D1&!D&C1&C&!B&A1&A|!F&!E&D2&!D1&!D&C1&C&!B&A1&A|!F&!E&D2&D1&!D&C1&C&!B&A1&A|!F&!E&!D2&D1&!D&C1&C&!B&A1&A|!F&!E&!D2&D1&D&C1&C&!B&A1&A|!F&!E&D2&D1&D&C1&C&!B&A1&A|!F&!E&D2&!D1&D&C1&C&!B&A1&A|!F&!E&!D2&!D1&D&C1&C&!B&A1&A|!F&!E&!D2&!D1&D&!C1&C&!B&A1&A|!F&!E&D2&!D1&D&!C1&C&!B&A1&A|!F&!E&D2&D1&D&!C1&C&!B&A1&A|!F&!E&!D2&D1&D&!C1&C&!B&A1&A|!F&!E&!D2&D1&!D&!C1&C&!B&A1&A|!F&!E&D2&D1&!D&!C1&C&!B&A1&A|!F&!E&D2&!D1&!D&!C1&C&!B&A1&A|!F&!E&!D2&!D1&!D&!C1&C&!B&A1&A|!F&!E&!D2&!D1&!D&!C1&C&B&A1&A|!F&!E&D2&!D1&!D&!C1&C&B&A1&A|!F&!E&D2&D1&!D&!C1&C&B&A1&A|!F&!E&!D2&D1&!D&!C1&C&B&A1&A|!F&!E&!D2&D1&D&!C1&C&B&A1&A|!F&!E&D2&D1&D&!C1&C&B&A1&A|!F&!E&D2&!D1&D&!C1&C&B&A1&A|!F&!E&!D2&!D1&D&!C1&C&B&A1&A|!F&!E&!D2&!D1&D&C1&C&B&A1&A|!F&!E&D2&!D1&D&C1&C&B&A1&A|!F&!E&D2&D1&D&C1&C&B&A1&A|!F&!E&!D2&D1&D&C1&C&B&A1&A|!F&!E&!D2&D1&!D&C1&C&B&A1&A|!F&!E&D2&D1&!D&C1&C&B&A1&A|!F&!E&D2&!D1&!D&C1&C&B&A1&A|!F&!E&!D2&!D1&!D&C1&C&B&A1&A|!F&!E&!D2&!D1&!D&C1&!C&B&A1&A|!F&!E&D2&!D1&!D&C1&!C&B&A1&A|!F&!E&D2&D1&!D&C1&!C&B&A1&A|!F&!E&!D2&D1&!D&C1&!C&B&A1&A|!F&!E&!D2&D1&D&C1&!C&B&A1&A|!F&!E&D2&D1&D&C1&!C&B&A1&A|!F&!E&D2&!D1&D&C1&!C&B&A1&A|!F&!E&!D2&!D1&D&C1&!C&B&A1&A|!F&!E&!D2&!D1&D&!C1&!C&B&A1&A|!F&E&!D2&!D1&D&!C1&!C&B&A1&A|!F&E&D2&!D1&D&!C1&!C&B&A1&A|!F&!E&D2&!D1&D&!C1&!C&B&A1&A|!F&!E&D2&D1&D&!C1&!C&B&A1&A|!F&E&!D2&D1&D&!C1&!C&B&A1&A|!F&!E&!D2&D1&D&!C1&!C&B&A1&A|!F&!E&!D2&D1&!D&!C1&!C&B&A1&A|!F&E&!D2&D1&!D&!C1&!C&B&A1&A|!F&E&D2&D1&!D&!C1&!C&B&A1&A|!F&!E&D2&D1&!D&!C1&!C&B&A1&A|!F&!E&D2&!D1&!D&!C1&!C&B&A1&A|!F&E&D2&!D1&!D&!C1&!C&B&A1&A|!F&E&!D2&!D1&!D&!C1&!C&B&A1&A|!F&!E&!D2&!D1&!D&!C1&!C&B&A1&A|!F&!E&!D2&!D1&!D&!C1&!C&B&!A1&A|!F&E&!D2&!D1&!D&!C1&!C&B&!A1&A|!F&E&D2&!D1&!D&!C1&!C&B&!A1&A|!F&!E&D2&!D1&!D&!C1&!C&B&!A1&A|!F&!E&D2&D1&!D&!C1&!C&B&!A1&A|!F&E&D2&D1&!D&!C1&!C&B&!A1&A|!F&E&!D2&D1&!D&!C1&!C&B&!A1&A|!F&!E&!D2&D1&!D&!C1&!C&B&!A1&A|!F&!E&!D2&D1&D&!C1&!C&B&!A1&A|!F&E&!D2&D1&D&!C1&!C&B&!A1&A|!F&!E&D2&D1&D&!C1&!C&B&!A1&A|!F&!E&D2&!D1&D&!C1&!C&B&!A1&A|!F&E&D2&!D1&D&!C1&!C&B&!A1&A|!F&E&!D2&!D1&D&!C1&!C&B&!A1&A|!F&!E&!D2&!D1&D&!C1&!C&B&!A1&A|!F&!E&!D2&!D1&D&C1&!C&B&!A1&A|!F&!E&D2&!D1&D&C1&!C&B&!A1&A|!F&!E&D2&D1&D&C1&!C&B&!A1&A|!F&!E&!D2&D1&D&C1&!C&B&!A1&A|!F&!E&!D2&D1&!D&C1&!C&B&!A1&A|!F&!E&D2&D1&!D&C1&!C&B&!A1&A|!F&!E&D2&!D1&!D&C1&!C&B&!A1&A|!F&!E&!D2&!D1&!D&C1&!C&B&!A1&A|!F&!E&!D2&!D1&!D&C1&C&B&!A1&A|!F&!E&D2&!D1&!D&C1&C&B&!A1&A|!F&!E&D2&D1&!D&C1&C&B&!A1&A|!F&!E&!D2&D1&!D&C1&C&B&!A1&A|!F&!E&!D2&D1&D&C1&C&B&!A1&A|!F&!E&D2&D1&D&C1&C&B&!A1&A|!F&!E&D2&!D1&D&C1&C&B&!A1&A|!F&!E&!D2&!D1&D&C1&C&B&!A1&A|!F&!E&!D2&!D1&D&!C1&C&B&!A1&A|!F&!E&D2&!D1&D&!C1&C&B&!A1&A|!F&!E&D2&D1&D&!C1&C&B&!A1&A|!F&!E&!D2&D1&D&!C1&C&B&!A1&A|!F&!E&!D2&D1&!D&!C1&C&B&!A1&A|!F&!E&D2&D1&!D&!C1&C&B&!A1&A|!F&!E&D2&!D1&!D&!C1&C&B&!A1&A|!F&!E&!D2&!D1&!D&!C1&C&B&!A1&A|!F&!E&!D2&!D1&!D&!C1&C&!B&!A1&A|!F&E&!D2&!D1&!D&!C1&C&!B&!A1&A|!F&E&D2&!D1&!D&!C1&C&!B&!A1&A|!F&!E&D2&!D1&!D&!C1&C&!B&!A1&A|!F&!E&D2&D1&!D&!C1&C&!B&!A1&A|!F&E&D2&D1&!D&!C1&C&!B&!A1&A|!F&E&!D2&D1&!D&!C1&C&!B&!A1&A|!F&!E&!D2&D1&!D&!C1&C&!B&!A1&A|!F&!E&!D2&D1&D&!C1&C&!B&!A1&A|!F&E&!D2&D1&D&!C1&C&!B&!A1&A|!F&!E&D2&D1&D&!C1&C&!B&!A1&A|!F&!E&D2&!D1&D&!C1&C&!B&!A1&A|!F&E&D2&!D1&D&!C1&C&!B&!A1&A|!F&E&!D2&!D1&D&!C1&C&!B&!A1&A|!F&!E&!D2&!D1&D&!C1&C&!B&!A1&A|!F&!E&!D2&!D1&D&C1&C&!B&!A1&A|!F&E&!D2&!D1&D&C1&C&!B&!A1&A|!F&E&D2&!D1&D&C1&C&!B&!A1&A|!F&!E&D2&!D1&D&C1&C&!B&!A1&A|!F&!E&D2&D1&D&C1&C&!B&!A1&A|!F&E&!D2&D1&D&C1&C&!B&!A1&A|!F&!E&!D2&D1&D&C1&C&!B&!A1&A|!F&!E&!D2&D1&!D&C1&C&!B&!A1&A|!F&E&!D2&D1&!D&C1&C&!B&!A1&A|!F&E&D2&D1&!D&C1&C&!B&!A1&A|!F&!E&D2&D1&!D&C1&C&!B&!A1&A|!F&!E&D2&!D1&!D&C1&C&!B&!A1&A|!F&E&D2&!D1&!D&C1&C&!B&!A1&A|!F&E&!D2&!D1&!D&C1&C&!B&!A1&A|!F&!E&!D2&!D1&!D&C1&C&!B&!A1&A|!F&!E&!D2&!D1&!D&C1&!C&!B&!A1&A|!F&E&!D2&!D1&!D&C1&!C&!B&!A1&A|!F&E&D2&!D1&!D&C1&!C&!B&!A1&A|!F&!E&D2&!D1&!D&C1&!C&!B&!A1&A|!F&!E&D2&D1&!D&C1&!C&!B&!A1&A|!F&E&D2&D1&!D&C1&!C&!B&!A1&A|!F&E&!D2&D1&!D&C1&!C&!B&!A1&A|!F&!E&!D2&D1&!D&C1&!C&!B&!A1&A|!F&!E&!D2&D1&D&C1&!C&!B&!A1&A|!F&E&!D2&D1&D&C1&!C&!B&!A1&A|!F&!E&D2&D1&D&C1&!C&!B&!A1&A|!F&!E&D2&!D1&D&C1&!C&!B&!A1&A|!F&E&D2&!D1&D&C1&!C&!B&!A1&A|!F&E&!D2&!D1&D&C1&!C&!B&!A1&A|!F&!E&!D2&!D1&D&C1&!C&!B&!A1&A|!F&!E&!D2&!D1&D&!C1&!C&!B&!A1&A|!F&E&!D2&!D1&D&!C1&!C&!B&!A1&A|!F&E&D2&!D1&D&!C1&!C&!B&!A1&A|!F&!E&D2&!D1&D&!C1&!C&!B&!A1&A|!F&!E&D2&D1&D&!C1&!C&!B&!A1&A|!F&E&!D2&D1&D&!C1&!C&!B&!A1&A|!F&!E&!D2&D1&D&!C1&!C&!B&!A1&A|!F&!E&!D2&D1&!D&!C1&!C&!B&!A1&A|!F&E&!D2&D1&!D&!C1&!C&!B&!A1&A|!F&E&D2&D1&!D&!C1&!C&!B&!A1&A|!F&!E&D2&D1&!D&!C1&!C&!B&!A1&A|!F&!E&D2&!D1&!D&!C1&!C&!B&!A1&A|!F&E&D2&!D1&!D&!C1&!C&!B&!A1&A|!F&E&!D2&!D1&!D&!C1&!C&!B&!A1&A|!F&!E&!D2&!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOAOI212311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOI21131 -l AOAAOI21131 -i E D2 D1 D C B A1 A -o Y -f Y=(!E&!D2&!D1&!D&!C&!B&!A1&!A|!E&D2&!D1&!D&!C&!B&!A1&!A|!E&D2&D1&!D&!C&!B&!A1&!A|!E&!D2&D1&!D&!C&!B&!A1&!A|!E&!D2&D1&D&!C&!B&!A1&!A|!E&D2&!D1&D&!C&!B&!A1&!A|!E&!D2&!D1&D&!C&!B&!A1&!A|!E&!D2&!D1&D&C&!B&!A1&!A|!E&D2&!D1&D&C&!B&!A1&!A|!E&!D2&D1&D&C&!B&!A1&!A|!E&!D2&D1&!D&C&!B&!A1&!A|!E&D2&D1&!D&C&!B&!A1&!A|!E&D2&!D1&!D&C&!B&!A1&!A|!E&!D2&!D1&!D&C&!B&!A1&!A|!E&!D2&!D1&D&!C&B&!A1&!A|!E&D2&!D1&D&!C&B&!A1&!A|!E&!D2&D1&D&!C&B&!A1&!A|!E&!D2&D1&!D&!C&B&!A1&!A|!E&D2&D1&!D&!C&B&!A1&!A|!E&D2&!D1&!D&!C&B&!A1&!A|!E&!D2&!D1&!D&!C&B&!A1&!A|!E&!D2&!D1&!D&!C&B&A1&!A|!E&D2&!D1&!D&!C&B&A1&!A|!E&D2&D1&!D&!C&B&A1&!A|!E&!D2&D1&!D&!C&B&A1&!A|!E&!D2&D1&D&!C&B&A1&!A|!E&D2&!D1&D&!C&B&A1&!A|!E&!D2&!D1&D&!C&B&A1&!A|!E&!D2&!D1&!D&C&!B&A1&!A|!E&D2&!D1&!D&C&!B&A1&!A|!E&D2&D1&!D&C&!B&A1&!A|!E&!D2&D1&!D&C&!B&A1&!A|!E&!D2&D1&D&C&!B&A1&!A|!E&D2&!D1&D&C&!B&A1&!A|!E&!D2&!D1&D&C&!B&A1&!A|!E&!D2&!D1&D&!C&!B&A1&!A|!E&D2&!D1&D&!C&!B&A1&!A|!E&!D2&D1&D&!C&!B&A1&!A|!E&!D2&D1&!D&!C&!B&A1&!A|!E&D2&D1&!D&!C&!B&A1&!A|!E&D2&!D1&!D&!C&!B&A1&!A|!E&!D2&!D1&!D&!C&!B&A1&!A|!E&!D2&!D1&!D&!C&!B&A1&A|!E&D2&!D1&!D&!C&!B&A1&A|!E&D2&D1&!D&!C&!B&A1&A|!E&!D2&D1&!D&!C&!B&A1&A|!E&!D2&D1&D&!C&!B&A1&A|!E&D2&!D1&D&!C&!B&A1&A|!E&!D2&!D1&D&!C&!B&A1&A|!E&!D2&!D1&D&!C&B&A1&A|!E&D2&!D1&D&!C&B&A1&A|!E&!D2&D1&D&!C&B&A1&A|!E&!D2&D1&!D&!C&B&A1&A|!E&D2&D1&!D&!C&B&A1&A|!E&D2&!D1&!D&!C&B&A1&A|!E&!D2&!D1&!D&!C&B&A1&A|!E&!D2&!D1&!D&!C&B&!A1&A|!E&D2&!D1&!D&!C&B&!A1&A|!E&D2&D1&!D&!C&B&!A1&A|!E&!D2&D1&!D&!C&B&!A1&A|!E&!D2&D1&D&!C&B&!A1&A|!E&D2&!D1&D&!C&B&!A1&A|!E&!D2&!D1&D&!C&B&!A1&A|!E&!D2&!D1&!D&C&!B&!A1&A|!E&D2&!D1&!D&C&!B&!A1&A|!E&D2&D1&!D&C&!B&!A1&A|!E&!D2&D1&!D&C&!B&!A1&A|!E&!D2&D1&D&C&!B&!A1&A|!E&D2&!D1&D&C&!B&!A1&A|!E&!D2&!D1&D&C&!B&!A1&A|!E&!D2&!D1&D&!C&!B&!A1&A|!E&D2&!D1&D&!C&!B&!A1&A|!E&!D2&D1&D&!C&!B&!A1&A|!E&!D2&D1&!D&!C&!B&!A1&A|!E&D2&D1&!D&!C&!B&!A1&A|!E&D2&!D1&!D&!C&!B&!A1&A|!E&!D2&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOI21131.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOI43 -l AAOI43 -i B2 B1 B A3 A2 A1 A -o Y -f Y=!(B2&B1&B&!A3&!A2&!A1&!A|B2&B1&B&A3&!A2&!A1&!A|B2&B1&B&A3&A2&!A1&!A|B2&B1&B&!A3&A2&!A1&!A|B2&B1&B&!A3&A2&A1&!A|B2&B1&B&A3&A2&A1&!A|B2&B1&B&A3&!A2&A1&!A|B2&B1&B&!A3&!A2&A1&!A|B2&B1&B&!A3&!A2&A1&A|B2&B1&B&A3&!A2&A1&A|!B2&!B1&!B&A3&A2&A1&A|B2&!B1&!B&A3&A2&A1&A|B2&B1&!B&A3&A2&A1&A|!B2&B1&!B&A3&A2&A1&A|!B2&B1&B&A3&A2&A1&A|B2&B1&B&A3&A2&A1&A|B2&!B1&B&A3&A2&A1&A|!B2&!B1&B&A3&A2&A1&A|B2&B1&B&!A3&A2&A1&A|B2&B1&B&!A3&A2&!A1&A|B2&B1&B&A3&A2&!A1&A|B2&B1&B&A3&!A2&!A1&A|B2&B1&B&!A3&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOI43.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOI3211 -l AOAOI3211 -i D C B1 B A2 A1 A -o Y -f Y=(!D&!C&!B1&!B&!A2&!A1&!A|!D&C&!B1&!B&!A2&!A1&!A|!D&!C&B1&!B&!A2&!A1&!A|!D&!C&B1&B&!A2&!A1&!A|!D&!C&!B1&B&!A2&!A1&!A|!D&!C&!B1&B&A2&!A1&!A|!D&!C&B1&B&A2&!A1&!A|!D&!C&B1&!B&A2&!A1&!A|!D&C&!B1&!B&A2&!A1&!A|!D&!C&!B1&!B&A2&!A1&!A|!D&!C&!B1&!B&A2&A1&!A|!D&C&!B1&!B&A2&A1&!A|!D&!C&B1&!B&A2&A1&!A|!D&!C&B1&B&A2&A1&!A|!D&!C&!B1&B&A2&A1&!A|!D&!C&!B1&B&!A2&A1&!A|!D&!C&B1&B&!A2&A1&!A|!D&!C&B1&!B&!A2&A1&!A|!D&C&!B1&!B&!A2&A1&!A|!D&!C&!B1&!B&!A2&A1&!A|!D&!C&!B1&!B&!A2&A1&A|!D&C&!B1&!B&!A2&A1&A|!D&!C&B1&!B&!A2&A1&A|!D&!C&B1&B&!A2&A1&A|!D&!C&!B1&B&!A2&A1&A|!D&!C&!B1&B&A2&A1&A|!D&!C&B1&B&A2&A1&A|!D&!C&B1&!B&A2&A1&A|!D&!C&!B1&!B&A2&A1&A|!D&!C&!B1&!B&A2&!A1&A|!D&C&!B1&!B&A2&!A1&A|!D&!C&B1&!B&A2&!A1&A|!D&!C&B1&B&A2&!A1&A|!D&!C&!B1&B&A2&!A1&A|!D&!C&!B1&B&!A2&!A1&A|!D&!C&B1&B&!A2&!A1&A|!D&!C&B1&!B&!A2&!A1&A|!D&C&!B1&!B&!A2&!A1&A|!D&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOI3211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAI332 -l OOAI332 -i C1 C B2 B1 B A2 A1 A -o Y -f Y=!(C1&C&!B2&!B1&B&A2&!A1&!A|C1&C&B2&!B1&B&A2&!A1&!A|C1&C&B2&B1&B&A2&!A1&!A|C1&C&!B2&B1&B&A2&!A1&!A|C1&C&!B2&B1&!B&A2&!A1&!A|C1&C&B2&B1&!B&A2&!A1&!A|C1&C&B2&!B1&!B&A2&!A1&!A|C1&C&B2&!B1&!B&A2&A1&!A|C1&C&B2&B1&!B&A2&A1&!A|C1&C&!B2&B1&!B&A2&A1&!A|C1&C&!B2&B1&B&A2&A1&!A|C1&C&B2&B1&B&A2&A1&!A|C1&C&B2&!B1&B&A2&A1&!A|C1&C&!B2&!B1&B&A2&A1&!A|C1&C&!B2&!B1&B&!A2&A1&!A|C1&C&B2&!B1&B&!A2&A1&!A|C1&C&B2&B1&B&!A2&A1&!A|C1&C&!B2&B1&B&!A2&A1&!A|C1&C&!B2&B1&!B&!A2&A1&!A|C1&C&B2&B1&!B&!A2&A1&!A|C1&C&B2&!B1&!B&!A2&A1&!A|C1&C&B2&!B1&!B&!A2&A1&A|C1&C&B2&B1&!B&!A2&A1&A|C1&C&!B2&B1&!B&!A2&A1&A|C1&C&!B2&B1&B&!A2&A1&A|C1&C&B2&B1&B&!A2&A1&A|C1&C&B2&!B1&B&!A2&A1&A|C1&C&!B2&!B1&B&!A2&A1&A|C1&C&!B2&!B1&B&A2&A1&A|C1&C&B2&!B1&B&A2&A1&A|C1&C&B2&B1&B&A2&A1&A|C1&C&!B2&B1&B&A2&A1&A|C1&C&!B2&B1&!B&A2&A1&A|C1&C&B2&B1&!B&A2&A1&A|C1&C&B2&!B1&!B&A2&A1&A|C1&C&B2&!B1&!B&A2&!A1&A|C1&C&B2&B1&!B&A2&!A1&A|C1&C&!B2&B1&!B&A2&!A1&A|C1&C&!B2&B1&B&A2&!A1&A|C1&C&B2&B1&B&A2&!A1&A|C1&C&B2&!B1&B&A2&!A1&A|C1&C&!B2&!B1&B&A2&!A1&A|C1&C&!B2&!B1&B&!A2&!A1&A|C1&C&B2&!B1&B&!A2&!A1&A|C1&C&B2&B1&B&!A2&!A1&A|C1&C&!B2&B1&B&!A2&!A1&A|C1&C&!B2&B1&!B&!A2&!A1&A|C1&C&B2&B1&!B&!A2&!A1&A|C1&C&B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAI332.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n sutherland1989 -l sutherland1989 -i B A -o C -f C= 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist sutherland1989.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOI2222 -l OOAAOI2222 -i D1 D C1 C B1 B A1 A -o Y -f Y=!(D1&D&!C1&!C&!B1&!B&!A1&!A|D1&D&C1&!C&!B1&!B&!A1&!A|D1&D&C1&C&!B1&!B&!A1&!A|D1&D&!C1&C&!B1&!B&!A1&!A|D1&D&!C1&C&B1&!B&!A1&!A|D1&D&C1&C&B1&!B&!A1&!A|D1&D&C1&!C&B1&!B&!A1&!A|D1&D&!C1&!C&B1&!B&!A1&!A|D1&D&!C1&!C&B1&B&!A1&!A|D1&D&C1&!C&B1&B&!A1&!A|D1&D&C1&C&B1&B&!A1&!A|D1&D&!C1&C&B1&B&!A1&!A|D1&D&!C1&C&!B1&B&!A1&!A|D1&D&C1&C&!B1&B&!A1&!A|D1&D&C1&!C&!B1&B&!A1&!A|D1&D&!C1&!C&!B1&B&!A1&!A|D1&D&!C1&!C&!B1&B&A1&!A|D1&D&C1&!C&!B1&B&A1&!A|!D1&!D&C1&C&!B1&B&A1&!A|D1&!D&C1&C&!B1&B&A1&!A|D1&D&C1&C&!B1&B&A1&!A|!D1&D&C1&C&!B1&B&A1&!A|D1&D&!C1&C&!B1&B&A1&!A|D1&D&!C1&C&B1&B&A1&!A|!D1&D&C1&C&B1&B&A1&!A|D1&D&C1&C&B1&B&A1&!A|D1&!D&C1&C&B1&B&A1&!A|!D1&!D&C1&C&B1&B&A1&!A|D1&D&C1&!C&B1&B&A1&!A|D1&D&!C1&!C&B1&B&A1&!A|D1&D&!C1&!C&B1&!B&A1&!A|D1&D&C1&!C&B1&!B&A1&!A|!D1&!D&C1&C&B1&!B&A1&!A|D1&!D&C1&C&B1&!B&A1&!A|D1&D&C1&C&B1&!B&A1&!A|!D1&D&C1&C&B1&!B&A1&!A|D1&D&!C1&C&B1&!B&A1&!A|D1&D&!C1&C&!B1&!B&A1&!A|D1&D&C1&C&!B1&!B&A1&!A|D1&D&C1&!C&!B1&!B&A1&!A|D1&D&!C1&!C&!B1&!B&A1&!A|D1&D&!C1&!C&!B1&!B&A1&A|D1&D&C1&!C&!B1&!B&A1&A|D1&D&C1&C&!B1&!B&A1&A|D1&D&!C1&C&!B1&!B&A1&A|D1&D&!C1&C&B1&!B&A1&A|!D1&D&C1&C&B1&!B&A1&A|D1&D&C1&C&B1&!B&A1&A|D1&!D&C1&C&B1&!B&A1&A|!D1&!D&C1&C&B1&!B&A1&A|D1&D&C1&!C&B1&!B&A1&A|D1&D&!C1&!C&B1&!B&A1&A|D1&D&!C1&!C&B1&B&A1&A|D1&D&C1&!C&B1&B&A1&A|!D1&!D&C1&C&B1&B&A1&A|D1&!D&C1&C&B1&B&A1&A|D1&D&C1&C&B1&B&A1&A|!D1&D&C1&C&B1&B&A1&A|D1&D&!C1&C&B1&B&A1&A|D1&D&!C1&C&!B1&B&A1&A|!D1&D&C1&C&!B1&B&A1&A|D1&D&C1&C&!B1&B&A1&A|D1&!D&C1&C&!B1&B&A1&A|!D1&!D&C1&C&!B1&B&A1&A|D1&D&C1&!C&!B1&B&A1&A|D1&D&!C1&!C&!B1&B&A1&A|D1&D&!C1&!C&!B1&B&!A1&A|D1&D&C1&!C&!B1&B&!A1&A|!D1&!D&C1&C&!B1&B&!A1&A|D1&!D&C1&C&!B1&B&!A1&A|D1&D&C1&C&!B1&B&!A1&A|!D1&D&C1&C&!B1&B&!A1&A|D1&D&!C1&C&!B1&B&!A1&A|D1&D&!C1&C&B1&B&!A1&A|!D1&D&C1&C&B1&B&!A1&A|D1&D&C1&C&B1&B&!A1&A|D1&!D&C1&C&B1&B&!A1&A|!D1&!D&C1&C&B1&B&!A1&A|D1&D&C1&!C&B1&B&!A1&A|D1&D&!C1&!C&B1&B&!A1&A|D1&D&!C1&!C&B1&!B&!A1&A|D1&D&C1&!C&B1&!B&!A1&A|!D1&!D&C1&C&B1&!B&!A1&A|D1&!D&C1&C&B1&!B&!A1&A|D1&D&C1&C&B1&!B&!A1&A|!D1&D&C1&C&B1&!B&!A1&A|D1&D&!C1&C&B1&!B&!A1&A|D1&D&!C1&C&!B1&!B&!A1&A|D1&D&C1&C&!B1&!B&!A1&A|D1&D&C1&!C&!B1&!B&!A1&A|D1&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOI2222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAOI33311 -l OOOAOI33311 -i E D C2 C1 C B2 B1 B A2 A1 A -o Y -f Y=(!E&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!E&!D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|!E&D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|!E&D&C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|!E&!D&C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|!E&!D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!E&D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!E&D&!C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!E&!D&!C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!E&!D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&D&C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&!D&C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&!D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&!D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!E&!D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|!E&D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|!E&D&C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|!E&!D&C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|!E&!D&C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!E&D&C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!E&D&!C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!E&!D&!C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!E&!D&!C2&C1&C&B2&B1&!B&!A2&!A1&!A|!E&D&!C2&C1&C&B2&B1&!B&!A2&!A1&!A|!E&D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|!E&!D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|!E&!D&C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!E&D&C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!E&D&!C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!E&!D&!C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!E&!D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|!E&D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|!E&D&C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|!E&!D&C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|!E&!D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!E&D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!E&D&!C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!E&!D&!C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!E&!D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&D&C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&!D&C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&!D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&!D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!E&!D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|!E&D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|!E&D&C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|!E&!D&C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|!E&!D&C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!E&D&C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!E&D&!C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!E&!D&!C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!E&!D&!C2&C1&C&!B2&B1&B&!A2&!A1&!A|!E&D&!C2&C1&C&!B2&B1&B&!A2&!A1&!A|!E&D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|!E&!D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|!E&!D&C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!E&D&C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!E&D&!C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!E&!D&!C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!E&!D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|!E&D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|!E&D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|!E&!D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|!E&!D&C2&C1&C&B2&B1&B&!A2&!A1&!A|!E&D&C2&C1&C&B2&B1&B&!A2&!A1&!A|!E&D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|!E&!D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|!E&!D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|!E&D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|!E&D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|!E&!D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|!E&!D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!E&D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!E&D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!E&!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!E&!D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|!E&D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|!E&D&C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|!E&!D&C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|!E&!D&C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!E&D&C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!E&D&!C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!E&!D&!C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!E&!D&!C2&C1&C&B2&!B1&B&!A2&!A1&!A|!E&D&!C2&C1&C&B2&!B1&B&!A2&!A1&!A|!E&D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|!E&!D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|!E&!D&C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!E&D&C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!E&D&!C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!E&!D&!C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!E&!D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|!E&D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|!E&D&C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|!E&!D&C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|!E&!D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!E&D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!E&D&!C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!E&!D&!C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!E&!D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&D&C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&!D&C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&!D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&!D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!E&!D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|!E&D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|!E&!D&C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|!E&!D&C2&C1&!C&!B2&!B1&B&A2&!A1&!A|!E&!D&!C2&C1&!C&!B2&!B1&B&A2&!A1&!A|!E&!D&!C2&C1&C&!B2&!B1&B&A2&!A1&!A|!E&!D&C2&C1&C&!B2&!B1&B&A2&!A1&!A|!E&!D&C2&!C1&C&!B2&!B1&B&A2&!A1&!A|!E&!D&!C2&!C1&C&!B2&!B1&B&A2&!A1&!A|!E&!D&!C2&!C1&C&B2&!B1&B&A2&!A1&!A|!E&!D&C2&!C1&C&B2&!B1&B&A2&!A1&!A|!E&!D&C2&C1&C&B2&!B1&B&A2&!A1&!A|!E&!D&!C2&C1&C&B2&!B1&B&A2&!A1&!A|!E&!D&!C2&C1&!C&B2&!B1&B&A2&!A1&!A|!E&!D&C2&C1&!C&B2&!B1&B&A2&!A1&!A|!E&!D&C2&!C1&!C&B2&!B1&B&A2&!A1&!A|!E&D&!C2&!C1&!C&B2&!B1&B&A2&!A1&!A|!E&!D&!C2&!C1&!C&B2&!B1&B&A2&!A1&!A|!E&!D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|!E&D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|!E&!D&C2&!C1&!C&B2&B1&B&A2&!A1&!A|!E&!D&C2&C1&!C&B2&B1&B&A2&!A1&!A|!E&!D&!C2&C1&!C&B2&B1&B&A2&!A1&!A|!E&!D&!C2&C1&C&B2&B1&B&A2&!A1&!A|!E&!D&C2&C1&C&B2&B1&B&A2&!A1&!A|!E&!D&C2&!C1&C&B2&B1&B&A2&!A1&!A|!E&!D&!C2&!C1&C&B2&B1&B&A2&!A1&!A|!E&!D&!C2&!C1&C&!B2&B1&B&A2&!A1&!A|!E&!D&C2&!C1&C&!B2&B1&B&A2&!A1&!A|!E&!D&C2&C1&C&!B2&B1&B&A2&!A1&!A|!E&!D&!C2&C1&C&!B2&B1&B&A2&!A1&!A|!E&!D&!C2&C1&!C&!B2&B1&B&A2&!A1&!A|!E&!D&C2&C1&!C&!B2&B1&B&A2&!A1&!A|!E&!D&C2&!C1&!C&!B2&B1&B&A2&!A1&!A|!E&D&!C2&!C1&!C&!B2&B1&B&A2&!A1&!A|!E&!D&!C2&!C1&!C&!B2&B1&B&A2&!A1&!A|!E&!D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|!E&D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|!E&!D&C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|!E&!D&C2&C1&!C&!B2&B1&!B&A2&!A1&!A|!E&!D&!C2&C1&!C&!B2&B1&!B&A2&!A1&!A|!E&!D&!C2&C1&C&!B2&B1&!B&A2&!A1&!A|!E&!D&C2&C1&C&!B2&B1&!B&A2&!A1&!A|!E&!D&C2&!C1&C&!B2&B1&!B&A2&!A1&!A|!E&!D&!C2&!C1&C&!B2&B1&!B&A2&!A1&!A|!E&!D&!C2&!C1&C&B2&B1&!B&A2&!A1&!A|!E&!D&C2&!C1&C&B2&B1&!B&A2&!A1&!A|!E&!D&C2&C1&C&B2&B1&!B&A2&!A1&!A|!E&!D&!C2&C1&C&B2&B1&!B&A2&!A1&!A|!E&!D&!C2&C1&!C&B2&B1&!B&A2&!A1&!A|!E&!D&C2&C1&!C&B2&B1&!B&A2&!A1&!A|!E&!D&C2&!C1&!C&B2&B1&!B&A2&!A1&!A|!E&D&!C2&!C1&!C&B2&B1&!B&A2&!A1&!A|!E&!D&!C2&!C1&!C&B2&B1&!B&A2&!A1&!A|!E&!D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|!E&D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|!E&!D&C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|!E&!D&C2&C1&!C&B2&!B1&!B&A2&!A1&!A|!E&!D&!C2&C1&!C&B2&!B1&!B&A2&!A1&!A|!E&!D&!C2&C1&C&B2&!B1&!B&A2&!A1&!A|!E&!D&C2&C1&C&B2&!B1&!B&A2&!A1&!A|!E&!D&C2&!C1&C&B2&!B1&!B&A2&!A1&!A|!E&!D&!C2&!C1&C&B2&!B1&!B&A2&!A1&!A|!E&!D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|!E&D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|!E&D&C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|!E&!D&C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|!E&!D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!E&D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!E&D&!C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!E&!D&!C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!E&!D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&D&C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&!D&C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&!D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&!D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!E&!D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|!E&D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|!E&D&C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|!E&!D&C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|!E&!D&C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!E&D&C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!E&D&!C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!E&!D&!C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!E&!D&!C2&C1&C&!B2&!B1&!B&A2&A1&!A|!E&D&!C2&C1&C&!B2&!B1&!B&A2&A1&!A|!E&D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|!E&!D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|!E&!D&C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!E&D&C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!E&D&!C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!E&!D&!C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!E&!D&!C2&!C1&C&B2&!B1&!B&A2&A1&!A|!E&!D&C2&!C1&C&B2&!B1&!B&A2&A1&!A|!E&!D&C2&C1&C&B2&!B1&!B&A2&A1&!A|!E&!D&!C2&C1&C&B2&!B1&!B&A2&A1&!A|!E&!D&!C2&C1&!C&B2&!B1&!B&A2&A1&!A|!E&!D&C2&C1&!C&B2&!B1&!B&A2&A1&!A|!E&!D&C2&!C1&!C&B2&!B1&!B&A2&A1&!A|!E&D&!C2&!C1&!C&B2&!B1&!B&A2&A1&!A|!E&!D&!C2&!C1&!C&B2&!B1&!B&A2&A1&!A|!E&!D&!C2&!C1&!C&B2&B1&!B&A2&A1&!A|!E&D&!C2&!C1&!C&B2&B1&!B&A2&A1&!A|!E&!D&C2&!C1&!C&B2&B1&!B&A2&A1&!A|!E&!D&C2&C1&!C&B2&B1&!B&A2&A1&!A|!E&!D&!C2&C1&!C&B2&B1&!B&A2&A1&!A|!E&!D&!C2&C1&C&B2&B1&!B&A2&A1&!A|!E&!D&C2&C1&C&B2&B1&!B&A2&A1&!A|!E&!D&C2&!C1&C&B2&B1&!B&A2&A1&!A|!E&!D&!C2&!C1&C&B2&B1&!B&A2&A1&!A|!E&!D&!C2&!C1&C&!B2&B1&!B&A2&A1&!A|!E&!D&C2&!C1&C&!B2&B1&!B&A2&A1&!A|!E&!D&C2&C1&C&!B2&B1&!B&A2&A1&!A|!E&!D&!C2&C1&C&!B2&B1&!B&A2&A1&!A|!E&!D&!C2&C1&!C&!B2&B1&!B&A2&A1&!A|!E&!D&C2&C1&!C&!B2&B1&!B&A2&A1&!A|!E&!D&C2&!C1&!C&!B2&B1&!B&A2&A1&!A|!E&D&!C2&!C1&!C&!B2&B1&!B&A2&A1&!A|!E&!D&!C2&!C1&!C&!B2&B1&!B&A2&A1&!A|!E&!D&!C2&!C1&!C&!B2&B1&B&A2&A1&!A|!E&D&!C2&!C1&!C&!B2&B1&B&A2&A1&!A|!E&!D&C2&!C1&!C&!B2&B1&B&A2&A1&!A|!E&!D&C2&C1&!C&!B2&B1&B&A2&A1&!A|!E&!D&!C2&C1&!C&!B2&B1&B&A2&A1&!A|!E&!D&!C2&C1&C&!B2&B1&B&A2&A1&!A|!E&!D&C2&C1&C&!B2&B1&B&A2&A1&!A|!E&!D&C2&!C1&C&!B2&B1&B&A2&A1&!A|!E&!D&!C2&!C1&C&!B2&B1&B&A2&A1&!A|!E&!D&!C2&!C1&C&B2&B1&B&A2&A1&!A|!E&!D&C2&!C1&C&B2&B1&B&A2&A1&!A|!E&!D&C2&C1&C&B2&B1&B&A2&A1&!A|!E&!D&!C2&C1&C&B2&B1&B&A2&A1&!A|!E&!D&!C2&C1&!C&B2&B1&B&A2&A1&!A|!E&!D&C2&C1&!C&B2&B1&B&A2&A1&!A|!E&!D&C2&!C1&!C&B2&B1&B&A2&A1&!A|!E&D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|!E&!D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|!E&!D&!C2&!C1&!C&B2&!B1&B&A2&A1&!A|!E&D&!C2&!C1&!C&B2&!B1&B&A2&A1&!A|!E&!D&C2&!C1&!C&B2&!B1&B&A2&A1&!A|!E&!D&C2&C1&!C&B2&!B1&B&A2&A1&!A|!E&!D&!C2&C1&!C&B2&!B1&B&A2&A1&!A|!E&!D&!C2&C1&C&B2&!B1&B&A2&A1&!A|!E&!D&C2&C1&C&B2&!B1&B&A2&A1&!A|!E&!D&C2&!C1&C&B2&!B1&B&A2&A1&!A|!E&!D&!C2&!C1&C&B2&!B1&B&A2&A1&!A|!E&!D&!C2&!C1&C&!B2&!B1&B&A2&A1&!A|!E&!D&C2&!C1&C&!B2&!B1&B&A2&A1&!A|!E&!D&C2&C1&C&!B2&!B1&B&A2&A1&!A|!E&!D&!C2&C1&C&!B2&!B1&B&A2&A1&!A|!E&!D&!C2&C1&!C&!B2&!B1&B&A2&A1&!A|!E&!D&C2&C1&!C&!B2&!B1&B&A2&A1&!A|!E&!D&C2&!C1&!C&!B2&!B1&B&A2&A1&!A|!E&D&!C2&!C1&!C&!B2&!B1&B&A2&A1&!A|!E&!D&!C2&!C1&!C&!B2&!B1&B&A2&A1&!A|!E&!D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|!E&D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|!E&!D&C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|!E&!D&C2&C1&!C&!B2&!B1&B&!A2&A1&!A|!E&!D&!C2&C1&!C&!B2&!B1&B&!A2&A1&!A|!E&!D&!C2&C1&C&!B2&!B1&B&!A2&A1&!A|!E&!D&C2&C1&C&!B2&!B1&B&!A2&A1&!A|!E&!D&C2&!C1&C&!B2&!B1&B&!A2&A1&!A|!E&!D&!C2&!C1&C&!B2&!B1&B&!A2&A1&!A|!E&!D&!C2&!C1&C&B2&!B1&B&!A2&A1&!A|!E&!D&C2&!C1&C&B2&!B1&B&!A2&A1&!A|!E&!D&C2&C1&C&B2&!B1&B&!A2&A1&!A|!E&!D&!C2&C1&C&B2&!B1&B&!A2&A1&!A|!E&!D&!C2&C1&!C&B2&!B1&B&!A2&A1&!A|!E&!D&C2&C1&!C&B2&!B1&B&!A2&A1&!A|!E&!D&C2&!C1&!C&B2&!B1&B&!A2&A1&!A|!E&D&!C2&!C1&!C&B2&!B1&B&!A2&A1&!A|!E&!D&!C2&!C1&!C&B2&!B1&B&!A2&A1&!A|!E&!D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|!E&D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|!E&!D&C2&!C1&!C&B2&B1&B&!A2&A1&!A|!E&!D&C2&C1&!C&B2&B1&B&!A2&A1&!A|!E&!D&!C2&C1&!C&B2&B1&B&!A2&A1&!A|!E&!D&!C2&C1&C&B2&B1&B&!A2&A1&!A|!E&!D&C2&C1&C&B2&B1&B&!A2&A1&!A|!E&!D&C2&!C1&C&B2&B1&B&!A2&A1&!A|!E&!D&!C2&!C1&C&B2&B1&B&!A2&A1&!A|!E&!D&!C2&!C1&C&!B2&B1&B&!A2&A1&!A|!E&!D&C2&!C1&C&!B2&B1&B&!A2&A1&!A|!E&!D&C2&C1&C&!B2&B1&B&!A2&A1&!A|!E&!D&!C2&C1&C&!B2&B1&B&!A2&A1&!A|!E&!D&!C2&C1&!C&!B2&B1&B&!A2&A1&!A|!E&!D&C2&C1&!C&!B2&B1&B&!A2&A1&!A|!E&!D&C2&!C1&!C&!B2&B1&B&!A2&A1&!A|!E&D&!C2&!C1&!C&!B2&B1&B&!A2&A1&!A|!E&!D&!C2&!C1&!C&!B2&B1&B&!A2&A1&!A|!E&!D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|!E&D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|!E&!D&C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|!E&!D&C2&C1&!C&!B2&B1&!B&!A2&A1&!A|!E&!D&!C2&C1&!C&!B2&B1&!B&!A2&A1&!A|!E&!D&!C2&C1&C&!B2&B1&!B&!A2&A1&!A|!E&!D&C2&C1&C&!B2&B1&!B&!A2&A1&!A|!E&!D&C2&!C1&C&!B2&B1&!B&!A2&A1&!A|!E&!D&!C2&!C1&C&!B2&B1&!B&!A2&A1&!A|!E&!D&!C2&!C1&C&B2&B1&!B&!A2&A1&!A|!E&!D&C2&!C1&C&B2&B1&!B&!A2&A1&!A|!E&!D&C2&C1&C&B2&B1&!B&!A2&A1&!A|!E&!D&!C2&C1&C&B2&B1&!B&!A2&A1&!A|!E&!D&!C2&C1&!C&B2&B1&!B&!A2&A1&!A|!E&!D&C2&C1&!C&B2&B1&!B&!A2&A1&!A|!E&!D&C2&!C1&!C&B2&B1&!B&!A2&A1&!A|!E&D&!C2&!C1&!C&B2&B1&!B&!A2&A1&!A|!E&!D&!C2&!C1&!C&B2&B1&!B&!A2&A1&!A|!E&!D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|!E&D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|!E&!D&C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|!E&!D&C2&C1&!C&B2&!B1&!B&!A2&A1&!A|!E&!D&!C2&C1&!C&B2&!B1&!B&!A2&A1&!A|!E&!D&!C2&C1&C&B2&!B1&!B&!A2&A1&!A|!E&!D&C2&C1&C&B2&!B1&!B&!A2&A1&!A|!E&!D&C2&!C1&C&B2&!B1&!B&!A2&A1&!A|!E&!D&!C2&!C1&C&B2&!B1&!B&!A2&A1&!A|!E&!D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|!E&D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|!E&D&C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|!E&!D&C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|!E&!D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!E&D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!E&D&!C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!E&!D&!C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!E&!D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&D&C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&!D&C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&!D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!E&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|!E&D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|!E&D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|!E&!D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|!E&!D&C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!E&D&C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!E&D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!E&!D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!E&!D&!C2&C1&C&!B2&!B1&!B&!A2&A1&A|!E&D&!C2&C1&C&!B2&!B1&!B&!A2&A1&A|!E&D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|!E&!D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|!E&!D&C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!E&D&C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!E&D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!E&!D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!E&!D&!C2&!C1&C&B2&!B1&!B&!A2&A1&A|!E&!D&C2&!C1&C&B2&!B1&!B&!A2&A1&A|!E&!D&C2&C1&C&B2&!B1&!B&!A2&A1&A|!E&!D&!C2&C1&C&B2&!B1&!B&!A2&A1&A|!E&!D&!C2&C1&!C&B2&!B1&!B&!A2&A1&A|!E&!D&C2&C1&!C&B2&!B1&!B&!A2&A1&A|!E&!D&C2&!C1&!C&B2&!B1&!B&!A2&A1&A|!E&D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&A|!E&!D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&A|!E&!D&!C2&!C1&!C&B2&B1&!B&!A2&A1&A|!E&D&!C2&!C1&!C&B2&B1&!B&!A2&A1&A|!E&!D&C2&!C1&!C&B2&B1&!B&!A2&A1&A|!E&!D&C2&C1&!C&B2&B1&!B&!A2&A1&A|!E&!D&!C2&C1&!C&B2&B1&!B&!A2&A1&A|!E&!D&!C2&C1&C&B2&B1&!B&!A2&A1&A|!E&!D&C2&C1&C&B2&B1&!B&!A2&A1&A|!E&!D&C2&!C1&C&B2&B1&!B&!A2&A1&A|!E&!D&!C2&!C1&C&B2&B1&!B&!A2&A1&A|!E&!D&!C2&!C1&C&!B2&B1&!B&!A2&A1&A|!E&!D&C2&!C1&C&!B2&B1&!B&!A2&A1&A|!E&!D&C2&C1&C&!B2&B1&!B&!A2&A1&A|!E&!D&!C2&C1&C&!B2&B1&!B&!A2&A1&A|!E&!D&!C2&C1&!C&!B2&B1&!B&!A2&A1&A|!E&!D&C2&C1&!C&!B2&B1&!B&!A2&A1&A|!E&!D&C2&!C1&!C&!B2&B1&!B&!A2&A1&A|!E&D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&A|!E&!D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&A|!E&!D&!C2&!C1&!C&!B2&B1&B&!A2&A1&A|!E&D&!C2&!C1&!C&!B2&B1&B&!A2&A1&A|!E&!D&C2&!C1&!C&!B2&B1&B&!A2&A1&A|!E&!D&C2&C1&!C&!B2&B1&B&!A2&A1&A|!E&!D&!C2&C1&!C&!B2&B1&B&!A2&A1&A|!E&!D&!C2&C1&C&!B2&B1&B&!A2&A1&A|!E&!D&C2&C1&C&!B2&B1&B&!A2&A1&A|!E&!D&C2&!C1&C&!B2&B1&B&!A2&A1&A|!E&!D&!C2&!C1&C&!B2&B1&B&!A2&A1&A|!E&!D&!C2&!C1&C&B2&B1&B&!A2&A1&A|!E&!D&C2&!C1&C&B2&B1&B&!A2&A1&A|!E&!D&C2&C1&C&B2&B1&B&!A2&A1&A|!E&!D&!C2&C1&C&B2&B1&B&!A2&A1&A|!E&!D&!C2&C1&!C&B2&B1&B&!A2&A1&A|!E&!D&C2&C1&!C&B2&B1&B&!A2&A1&A|!E&!D&C2&!C1&!C&B2&B1&B&!A2&A1&A|!E&D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|!E&!D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|!E&!D&!C2&!C1&!C&B2&!B1&B&!A2&A1&A|!E&D&!C2&!C1&!C&B2&!B1&B&!A2&A1&A|!E&!D&C2&!C1&!C&B2&!B1&B&!A2&A1&A|!E&!D&C2&C1&!C&B2&!B1&B&!A2&A1&A|!E&!D&!C2&C1&!C&B2&!B1&B&!A2&A1&A|!E&!D&!C2&C1&C&B2&!B1&B&!A2&A1&A|!E&!D&C2&C1&C&B2&!B1&B&!A2&A1&A|!E&!D&C2&!C1&C&B2&!B1&B&!A2&A1&A|!E&!D&!C2&!C1&C&B2&!B1&B&!A2&A1&A|!E&!D&!C2&!C1&C&!B2&!B1&B&!A2&A1&A|!E&!D&C2&!C1&C&!B2&!B1&B&!A2&A1&A|!E&!D&C2&C1&C&!B2&!B1&B&!A2&A1&A|!E&!D&!C2&C1&C&!B2&!B1&B&!A2&A1&A|!E&!D&!C2&C1&!C&!B2&!B1&B&!A2&A1&A|!E&!D&C2&C1&!C&!B2&!B1&B&!A2&A1&A|!E&!D&C2&!C1&!C&!B2&!B1&B&!A2&A1&A|!E&D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&A|!E&!D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&A|!E&!D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|!E&D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|!E&!D&C2&!C1&!C&!B2&!B1&B&A2&A1&A|!E&!D&C2&C1&!C&!B2&!B1&B&A2&A1&A|!E&!D&!C2&C1&!C&!B2&!B1&B&A2&A1&A|!E&!D&!C2&C1&C&!B2&!B1&B&A2&A1&A|!E&!D&C2&C1&C&!B2&!B1&B&A2&A1&A|!E&!D&C2&!C1&C&!B2&!B1&B&A2&A1&A|!E&!D&!C2&!C1&C&!B2&!B1&B&A2&A1&A|!E&!D&!C2&!C1&C&B2&!B1&B&A2&A1&A|!E&!D&C2&!C1&C&B2&!B1&B&A2&A1&A|!E&!D&C2&C1&C&B2&!B1&B&A2&A1&A|!E&!D&!C2&C1&C&B2&!B1&B&A2&A1&A|!E&!D&!C2&C1&!C&B2&!B1&B&A2&A1&A|!E&!D&C2&C1&!C&B2&!B1&B&A2&A1&A|!E&!D&C2&!C1&!C&B2&!B1&B&A2&A1&A|!E&D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|!E&!D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|!E&!D&!C2&!C1&!C&B2&B1&B&A2&A1&A|!E&D&!C2&!C1&!C&B2&B1&B&A2&A1&A|!E&!D&C2&!C1&!C&B2&B1&B&A2&A1&A|!E&!D&C2&C1&!C&B2&B1&B&A2&A1&A|!E&!D&!C2&C1&!C&B2&B1&B&A2&A1&A|!E&!D&!C2&C1&C&B2&B1&B&A2&A1&A|!E&!D&C2&C1&C&B2&B1&B&A2&A1&A|!E&!D&C2&!C1&C&B2&B1&B&A2&A1&A|!E&!D&!C2&!C1&C&B2&B1&B&A2&A1&A|!E&!D&!C2&!C1&C&!B2&B1&B&A2&A1&A|!E&!D&C2&!C1&C&!B2&B1&B&A2&A1&A|!E&!D&C2&C1&C&!B2&B1&B&A2&A1&A|!E&!D&!C2&C1&C&!B2&B1&B&A2&A1&A|!E&!D&!C2&C1&!C&!B2&B1&B&A2&A1&A|!E&!D&C2&C1&!C&!B2&B1&B&A2&A1&A|!E&!D&C2&!C1&!C&!B2&B1&B&A2&A1&A|!E&D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|!E&!D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|!E&!D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|!E&D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|!E&!D&C2&!C1&!C&!B2&B1&!B&A2&A1&A|!E&!D&C2&C1&!C&!B2&B1&!B&A2&A1&A|!E&!D&!C2&C1&!C&!B2&B1&!B&A2&A1&A|!E&!D&!C2&C1&C&!B2&B1&!B&A2&A1&A|!E&!D&C2&C1&C&!B2&B1&!B&A2&A1&A|!E&!D&C2&!C1&C&!B2&B1&!B&A2&A1&A|!E&!D&!C2&!C1&C&!B2&B1&!B&A2&A1&A|!E&!D&!C2&!C1&C&B2&B1&!B&A2&A1&A|!E&!D&C2&!C1&C&B2&B1&!B&A2&A1&A|!E&!D&C2&C1&C&B2&B1&!B&A2&A1&A|!E&!D&!C2&C1&C&B2&B1&!B&A2&A1&A|!E&!D&!C2&C1&!C&B2&B1&!B&A2&A1&A|!E&!D&C2&C1&!C&B2&B1&!B&A2&A1&A|!E&!D&C2&!C1&!C&B2&B1&!B&A2&A1&A|!E&D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|!E&!D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|!E&!D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|!E&D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|!E&!D&C2&!C1&!C&B2&!B1&!B&A2&A1&A|!E&!D&C2&C1&!C&B2&!B1&!B&A2&A1&A|!E&!D&!C2&C1&!C&B2&!B1&!B&A2&A1&A|!E&!D&!C2&C1&C&B2&!B1&!B&A2&A1&A|!E&!D&C2&C1&C&B2&!B1&!B&A2&A1&A|!E&!D&C2&!C1&C&B2&!B1&!B&A2&A1&A|!E&!D&!C2&!C1&C&B2&!B1&!B&A2&A1&A|!E&!D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|!E&D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|!E&D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|!E&!D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|!E&!D&C2&C1&C&!B2&!B1&!B&A2&A1&A|!E&D&C2&C1&C&!B2&!B1&!B&A2&A1&A|!E&D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|!E&!D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|!E&!D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|!E&D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|!E&D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|!E&!D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|!E&!D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!E&D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!E&D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!E&!D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!E&!D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|!E&D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|!E&D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|!E&!D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|!E&!D&C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!E&D&C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!E&D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!E&!D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!E&!D&!C2&C1&C&!B2&!B1&!B&A2&!A1&A|!E&D&!C2&C1&C&!B2&!B1&!B&A2&!A1&A|!E&D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|!E&!D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|!E&!D&C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!E&D&C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!E&D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!E&!D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!E&!D&!C2&!C1&C&B2&!B1&!B&A2&!A1&A|!E&!D&C2&!C1&C&B2&!B1&!B&A2&!A1&A|!E&!D&C2&C1&C&B2&!B1&!B&A2&!A1&A|!E&!D&!C2&C1&C&B2&!B1&!B&A2&!A1&A|!E&!D&!C2&C1&!C&B2&!B1&!B&A2&!A1&A|!E&!D&C2&C1&!C&B2&!B1&!B&A2&!A1&A|!E&!D&C2&!C1&!C&B2&!B1&!B&A2&!A1&A|!E&D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&A|!E&!D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&A|!E&!D&!C2&!C1&!C&B2&B1&!B&A2&!A1&A|!E&D&!C2&!C1&!C&B2&B1&!B&A2&!A1&A|!E&!D&C2&!C1&!C&B2&B1&!B&A2&!A1&A|!E&!D&C2&C1&!C&B2&B1&!B&A2&!A1&A|!E&!D&!C2&C1&!C&B2&B1&!B&A2&!A1&A|!E&!D&!C2&C1&C&B2&B1&!B&A2&!A1&A|!E&!D&C2&C1&C&B2&B1&!B&A2&!A1&A|!E&!D&C2&!C1&C&B2&B1&!B&A2&!A1&A|!E&!D&!C2&!C1&C&B2&B1&!B&A2&!A1&A|!E&!D&!C2&!C1&C&!B2&B1&!B&A2&!A1&A|!E&!D&C2&!C1&C&!B2&B1&!B&A2&!A1&A|!E&!D&C2&C1&C&!B2&B1&!B&A2&!A1&A|!E&!D&!C2&C1&C&!B2&B1&!B&A2&!A1&A|!E&!D&!C2&C1&!C&!B2&B1&!B&A2&!A1&A|!E&!D&C2&C1&!C&!B2&B1&!B&A2&!A1&A|!E&!D&C2&!C1&!C&!B2&B1&!B&A2&!A1&A|!E&D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&A|!E&!D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&A|!E&!D&!C2&!C1&!C&!B2&B1&B&A2&!A1&A|!E&D&!C2&!C1&!C&!B2&B1&B&A2&!A1&A|!E&!D&C2&!C1&!C&!B2&B1&B&A2&!A1&A|!E&!D&C2&C1&!C&!B2&B1&B&A2&!A1&A|!E&!D&!C2&C1&!C&!B2&B1&B&A2&!A1&A|!E&!D&!C2&C1&C&!B2&B1&B&A2&!A1&A|!E&!D&C2&C1&C&!B2&B1&B&A2&!A1&A|!E&!D&C2&!C1&C&!B2&B1&B&A2&!A1&A|!E&!D&!C2&!C1&C&!B2&B1&B&A2&!A1&A|!E&!D&!C2&!C1&C&B2&B1&B&A2&!A1&A|!E&!D&C2&!C1&C&B2&B1&B&A2&!A1&A|!E&!D&C2&C1&C&B2&B1&B&A2&!A1&A|!E&!D&!C2&C1&C&B2&B1&B&A2&!A1&A|!E&!D&!C2&C1&!C&B2&B1&B&A2&!A1&A|!E&!D&C2&C1&!C&B2&B1&B&A2&!A1&A|!E&!D&C2&!C1&!C&B2&B1&B&A2&!A1&A|!E&D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|!E&!D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|!E&!D&!C2&!C1&!C&B2&!B1&B&A2&!A1&A|!E&D&!C2&!C1&!C&B2&!B1&B&A2&!A1&A|!E&!D&C2&!C1&!C&B2&!B1&B&A2&!A1&A|!E&!D&C2&C1&!C&B2&!B1&B&A2&!A1&A|!E&!D&!C2&C1&!C&B2&!B1&B&A2&!A1&A|!E&!D&!C2&C1&C&B2&!B1&B&A2&!A1&A|!E&!D&C2&C1&C&B2&!B1&B&A2&!A1&A|!E&!D&C2&!C1&C&B2&!B1&B&A2&!A1&A|!E&!D&!C2&!C1&C&B2&!B1&B&A2&!A1&A|!E&!D&!C2&!C1&C&!B2&!B1&B&A2&!A1&A|!E&!D&C2&!C1&C&!B2&!B1&B&A2&!A1&A|!E&!D&C2&C1&C&!B2&!B1&B&A2&!A1&A|!E&!D&!C2&C1&C&!B2&!B1&B&A2&!A1&A|!E&!D&!C2&C1&!C&!B2&!B1&B&A2&!A1&A|!E&!D&C2&C1&!C&!B2&!B1&B&A2&!A1&A|!E&!D&C2&!C1&!C&!B2&!B1&B&A2&!A1&A|!E&D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&A|!E&!D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&A|!E&!D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|!E&D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|!E&!D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|!E&!D&C2&C1&!C&!B2&!B1&B&!A2&!A1&A|!E&!D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&A|!E&!D&!C2&C1&C&!B2&!B1&B&!A2&!A1&A|!E&!D&C2&C1&C&!B2&!B1&B&!A2&!A1&A|!E&!D&C2&!C1&C&!B2&!B1&B&!A2&!A1&A|!E&!D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&A|!E&!D&!C2&!C1&C&B2&!B1&B&!A2&!A1&A|!E&!D&C2&!C1&C&B2&!B1&B&!A2&!A1&A|!E&!D&C2&C1&C&B2&!B1&B&!A2&!A1&A|!E&!D&!C2&C1&C&B2&!B1&B&!A2&!A1&A|!E&!D&!C2&C1&!C&B2&!B1&B&!A2&!A1&A|!E&!D&C2&C1&!C&B2&!B1&B&!A2&!A1&A|!E&!D&C2&!C1&!C&B2&!B1&B&!A2&!A1&A|!E&D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&A|!E&!D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&A|!E&!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|!E&D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|!E&!D&C2&!C1&!C&B2&B1&B&!A2&!A1&A|!E&!D&C2&C1&!C&B2&B1&B&!A2&!A1&A|!E&!D&!C2&C1&!C&B2&B1&B&!A2&!A1&A|!E&!D&!C2&C1&C&B2&B1&B&!A2&!A1&A|!E&!D&C2&C1&C&B2&B1&B&!A2&!A1&A|!E&!D&C2&!C1&C&B2&B1&B&!A2&!A1&A|!E&!D&!C2&!C1&C&B2&B1&B&!A2&!A1&A|!E&!D&!C2&!C1&C&!B2&B1&B&!A2&!A1&A|!E&!D&C2&!C1&C&!B2&B1&B&!A2&!A1&A|!E&!D&C2&C1&C&!B2&B1&B&!A2&!A1&A|!E&!D&!C2&C1&C&!B2&B1&B&!A2&!A1&A|!E&!D&!C2&C1&!C&!B2&B1&B&!A2&!A1&A|!E&!D&C2&C1&!C&!B2&B1&B&!A2&!A1&A|!E&!D&C2&!C1&!C&!B2&B1&B&!A2&!A1&A|!E&D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&A|!E&!D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&A|!E&!D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|!E&D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|!E&!D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|!E&!D&C2&C1&!C&!B2&B1&!B&!A2&!A1&A|!E&!D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&A|!E&!D&!C2&C1&C&!B2&B1&!B&!A2&!A1&A|!E&!D&C2&C1&C&!B2&B1&!B&!A2&!A1&A|!E&!D&C2&!C1&C&!B2&B1&!B&!A2&!A1&A|!E&!D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&A|!E&!D&!C2&!C1&C&B2&B1&!B&!A2&!A1&A|!E&!D&C2&!C1&C&B2&B1&!B&!A2&!A1&A|!E&!D&C2&C1&C&B2&B1&!B&!A2&!A1&A|!E&!D&!C2&C1&C&B2&B1&!B&!A2&!A1&A|!E&!D&!C2&C1&!C&B2&B1&!B&!A2&!A1&A|!E&!D&C2&C1&!C&B2&B1&!B&!A2&!A1&A|!E&!D&C2&!C1&!C&B2&B1&!B&!A2&!A1&A|!E&D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&A|!E&!D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&A|!E&!D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|!E&D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|!E&!D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|!E&!D&C2&C1&!C&B2&!B1&!B&!A2&!A1&A|!E&!D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&A|!E&!D&!C2&C1&C&B2&!B1&!B&!A2&!A1&A|!E&!D&C2&C1&C&B2&!B1&!B&!A2&!A1&A|!E&!D&C2&!C1&C&B2&!B1&!B&!A2&!A1&A|!E&!D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&A|!E&!D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|!E&D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|!E&D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|!E&!D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|!E&!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!E&D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!E&D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!E&!D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!E&!D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|!E&D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|!E&D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|!E&!D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|!E&!D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|!E&D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|!E&D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|!E&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAOI33311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOI2214 -l OOAAOI2214 -i D3 D2 D1 D C B1 B A1 A -o Y -f Y=!(D3&D2&D1&D&!C&!B1&!B&!A1&!A|D3&D2&D1&D&C&!B1&!B&!A1&!A|D3&D2&D1&D&C&B1&!B&!A1&!A|D3&D2&D1&D&!C&B1&!B&!A1&!A|D3&D2&D1&D&!C&B1&B&!A1&!A|D3&D2&D1&D&C&B1&B&!A1&!A|D3&D2&D1&D&C&!B1&B&!A1&!A|D3&D2&D1&D&!C&!B1&B&!A1&!A|D3&D2&D1&D&!C&!B1&B&A1&!A|!D3&!D2&!D1&D&C&!B1&B&A1&!A|D3&!D2&!D1&D&C&!B1&B&A1&!A|D3&D2&!D1&D&C&!B1&B&A1&!A|!D3&D2&!D1&D&C&!B1&B&A1&!A|!D3&D2&D1&D&C&!B1&B&A1&!A|D3&D2&D1&D&C&!B1&B&A1&!A|D3&!D2&D1&D&C&!B1&B&A1&!A|!D3&!D2&D1&D&C&!B1&B&A1&!A|!D3&!D2&D1&!D&C&!B1&B&A1&!A|D3&!D2&D1&!D&C&!B1&B&A1&!A|D3&D2&D1&!D&C&!B1&B&A1&!A|!D3&D2&D1&!D&C&!B1&B&A1&!A|!D3&D2&!D1&!D&C&!B1&B&A1&!A|D3&D2&!D1&!D&C&!B1&B&A1&!A|D3&!D2&!D1&!D&C&!B1&B&A1&!A|!D3&!D2&!D1&!D&C&!B1&B&A1&!A|!D3&!D2&!D1&!D&C&B1&B&A1&!A|D3&!D2&!D1&!D&C&B1&B&A1&!A|D3&D2&!D1&!D&C&B1&B&A1&!A|!D3&D2&!D1&!D&C&B1&B&A1&!A|!D3&D2&D1&!D&C&B1&B&A1&!A|D3&D2&D1&!D&C&B1&B&A1&!A|D3&!D2&D1&!D&C&B1&B&A1&!A|!D3&!D2&D1&!D&C&B1&B&A1&!A|!D3&!D2&D1&D&C&B1&B&A1&!A|D3&!D2&D1&D&C&B1&B&A1&!A|D3&D2&D1&D&C&B1&B&A1&!A|!D3&D2&D1&D&C&B1&B&A1&!A|!D3&D2&!D1&D&C&B1&B&A1&!A|D3&D2&!D1&D&C&B1&B&A1&!A|D3&!D2&!D1&D&C&B1&B&A1&!A|!D3&!D2&!D1&D&C&B1&B&A1&!A|D3&D2&D1&D&!C&B1&B&A1&!A|D3&D2&D1&D&!C&B1&!B&A1&!A|!D3&!D2&!D1&D&C&B1&!B&A1&!A|D3&!D2&!D1&D&C&B1&!B&A1&!A|D3&D2&!D1&D&C&B1&!B&A1&!A|!D3&D2&!D1&D&C&B1&!B&A1&!A|!D3&D2&D1&D&C&B1&!B&A1&!A|D3&D2&D1&D&C&B1&!B&A1&!A|D3&!D2&D1&D&C&B1&!B&A1&!A|!D3&!D2&D1&D&C&B1&!B&A1&!A|!D3&!D2&D1&!D&C&B1&!B&A1&!A|D3&!D2&D1&!D&C&B1&!B&A1&!A|D3&D2&D1&!D&C&B1&!B&A1&!A|!D3&D2&D1&!D&C&B1&!B&A1&!A|!D3&D2&!D1&!D&C&B1&!B&A1&!A|D3&D2&!D1&!D&C&B1&!B&A1&!A|D3&!D2&!D1&!D&C&B1&!B&A1&!A|!D3&!D2&!D1&!D&C&B1&!B&A1&!A|D3&D2&D1&D&C&!B1&!B&A1&!A|D3&D2&D1&D&!C&!B1&!B&A1&!A|D3&D2&D1&D&!C&!B1&!B&A1&A|D3&D2&D1&D&C&!B1&!B&A1&A|!D3&!D2&!D1&!D&C&B1&!B&A1&A|D3&!D2&!D1&!D&C&B1&!B&A1&A|D3&D2&!D1&!D&C&B1&!B&A1&A|!D3&D2&!D1&!D&C&B1&!B&A1&A|!D3&D2&D1&!D&C&B1&!B&A1&A|D3&D2&D1&!D&C&B1&!B&A1&A|D3&!D2&D1&!D&C&B1&!B&A1&A|!D3&!D2&D1&!D&C&B1&!B&A1&A|!D3&!D2&D1&D&C&B1&!B&A1&A|D3&!D2&D1&D&C&B1&!B&A1&A|D3&D2&D1&D&C&B1&!B&A1&A|!D3&D2&D1&D&C&B1&!B&A1&A|!D3&D2&!D1&D&C&B1&!B&A1&A|D3&D2&!D1&D&C&B1&!B&A1&A|D3&!D2&!D1&D&C&B1&!B&A1&A|!D3&!D2&!D1&D&C&B1&!B&A1&A|D3&D2&D1&D&!C&B1&!B&A1&A|D3&D2&D1&D&!C&B1&B&A1&A|!D3&!D2&!D1&D&C&B1&B&A1&A|D3&!D2&!D1&D&C&B1&B&A1&A|D3&D2&!D1&D&C&B1&B&A1&A|!D3&D2&!D1&D&C&B1&B&A1&A|!D3&D2&D1&D&C&B1&B&A1&A|D3&D2&D1&D&C&B1&B&A1&A|D3&!D2&D1&D&C&B1&B&A1&A|!D3&!D2&D1&D&C&B1&B&A1&A|!D3&!D2&D1&!D&C&B1&B&A1&A|D3&!D2&D1&!D&C&B1&B&A1&A|D3&D2&D1&!D&C&B1&B&A1&A|!D3&D2&D1&!D&C&B1&B&A1&A|!D3&D2&!D1&!D&C&B1&B&A1&A|D3&D2&!D1&!D&C&B1&B&A1&A|D3&!D2&!D1&!D&C&B1&B&A1&A|!D3&!D2&!D1&!D&C&B1&B&A1&A|!D3&!D2&!D1&!D&C&!B1&B&A1&A|D3&!D2&!D1&!D&C&!B1&B&A1&A|D3&D2&!D1&!D&C&!B1&B&A1&A|!D3&D2&!D1&!D&C&!B1&B&A1&A|!D3&D2&D1&!D&C&!B1&B&A1&A|D3&D2&D1&!D&C&!B1&B&A1&A|D3&!D2&D1&!D&C&!B1&B&A1&A|!D3&!D2&D1&!D&C&!B1&B&A1&A|!D3&!D2&D1&D&C&!B1&B&A1&A|D3&!D2&D1&D&C&!B1&B&A1&A|D3&D2&D1&D&C&!B1&B&A1&A|!D3&D2&D1&D&C&!B1&B&A1&A|!D3&D2&!D1&D&C&!B1&B&A1&A|D3&D2&!D1&D&C&!B1&B&A1&A|D3&!D2&!D1&D&C&!B1&B&A1&A|!D3&!D2&!D1&D&C&!B1&B&A1&A|D3&D2&D1&D&!C&!B1&B&A1&A|D3&D2&D1&D&!C&!B1&B&!A1&A|!D3&!D2&!D1&D&C&!B1&B&!A1&A|D3&!D2&!D1&D&C&!B1&B&!A1&A|D3&D2&!D1&D&C&!B1&B&!A1&A|!D3&D2&!D1&D&C&!B1&B&!A1&A|!D3&D2&D1&D&C&!B1&B&!A1&A|D3&D2&D1&D&C&!B1&B&!A1&A|D3&!D2&D1&D&C&!B1&B&!A1&A|!D3&!D2&D1&D&C&!B1&B&!A1&A|!D3&!D2&D1&!D&C&!B1&B&!A1&A|D3&!D2&D1&!D&C&!B1&B&!A1&A|D3&D2&D1&!D&C&!B1&B&!A1&A|!D3&D2&D1&!D&C&!B1&B&!A1&A|!D3&D2&!D1&!D&C&!B1&B&!A1&A|D3&D2&!D1&!D&C&!B1&B&!A1&A|D3&!D2&!D1&!D&C&!B1&B&!A1&A|!D3&!D2&!D1&!D&C&!B1&B&!A1&A|!D3&!D2&!D1&!D&C&B1&B&!A1&A|D3&!D2&!D1&!D&C&B1&B&!A1&A|D3&D2&!D1&!D&C&B1&B&!A1&A|!D3&D2&!D1&!D&C&B1&B&!A1&A|!D3&D2&D1&!D&C&B1&B&!A1&A|D3&D2&D1&!D&C&B1&B&!A1&A|D3&!D2&D1&!D&C&B1&B&!A1&A|!D3&!D2&D1&!D&C&B1&B&!A1&A|!D3&!D2&D1&D&C&B1&B&!A1&A|D3&!D2&D1&D&C&B1&B&!A1&A|D3&D2&D1&D&C&B1&B&!A1&A|!D3&D2&D1&D&C&B1&B&!A1&A|!D3&D2&!D1&D&C&B1&B&!A1&A|D3&D2&!D1&D&C&B1&B&!A1&A|D3&!D2&!D1&D&C&B1&B&!A1&A|!D3&!D2&!D1&D&C&B1&B&!A1&A|D3&D2&D1&D&!C&B1&B&!A1&A|D3&D2&D1&D&!C&B1&!B&!A1&A|!D3&!D2&!D1&D&C&B1&!B&!A1&A|D3&!D2&!D1&D&C&B1&!B&!A1&A|D3&D2&!D1&D&C&B1&!B&!A1&A|!D3&D2&!D1&D&C&B1&!B&!A1&A|!D3&D2&D1&D&C&B1&!B&!A1&A|D3&D2&D1&D&C&B1&!B&!A1&A|D3&!D2&D1&D&C&B1&!B&!A1&A|!D3&!D2&D1&D&C&B1&!B&!A1&A|!D3&!D2&D1&!D&C&B1&!B&!A1&A|D3&!D2&D1&!D&C&B1&!B&!A1&A|D3&D2&D1&!D&C&B1&!B&!A1&A|!D3&D2&D1&!D&C&B1&!B&!A1&A|!D3&D2&!D1&!D&C&B1&!B&!A1&A|D3&D2&!D1&!D&C&B1&!B&!A1&A|D3&!D2&!D1&!D&C&B1&!B&!A1&A|!D3&!D2&!D1&!D&C&B1&!B&!A1&A|D3&D2&D1&D&C&!B1&!B&!A1&A|D3&D2&D1&D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOI2214.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOOAI22122 -l AAOAAOOAI22122 -i E1 E D1 D C B1 B A1 A -o Y -f Y=!(E1&!E&D1&D&!C&!B1&!B&!A1&!A|E1&E&D1&D&!C&!B1&!B&!A1&!A|!E1&E&D1&D&!C&!B1&!B&!A1&!A|!E1&E&D1&D&C&!B1&!B&!A1&!A|E1&E&D1&D&C&!B1&!B&!A1&!A|E1&!E&D1&D&C&!B1&!B&!A1&!A|E1&!E&D1&D&C&B1&!B&!A1&!A|E1&E&D1&D&C&B1&!B&!A1&!A|!E1&E&D1&D&C&B1&!B&!A1&!A|!E1&E&D1&D&!C&B1&!B&!A1&!A|E1&E&D1&D&!C&B1&!B&!A1&!A|E1&!E&D1&D&!C&B1&!B&!A1&!A|E1&!E&D1&D&!C&B1&B&!A1&!A|E1&E&D1&D&!C&B1&B&!A1&!A|!E1&E&D1&D&!C&B1&B&!A1&!A|E1&!E&!D1&D&C&B1&B&!A1&!A|E1&E&!D1&D&C&B1&B&!A1&!A|!E1&E&!D1&D&C&B1&B&!A1&!A|!E1&E&D1&D&C&B1&B&!A1&!A|E1&E&D1&D&C&B1&B&!A1&!A|E1&!E&D1&D&C&B1&B&!A1&!A|E1&!E&D1&!D&C&B1&B&!A1&!A|E1&E&D1&!D&C&B1&B&!A1&!A|!E1&E&D1&!D&C&B1&B&!A1&!A|!E1&E&!D1&!D&C&B1&B&!A1&!A|E1&E&!D1&!D&C&B1&B&!A1&!A|E1&!E&!D1&!D&C&B1&B&!A1&!A|E1&!E&D1&D&C&!B1&B&!A1&!A|E1&E&D1&D&C&!B1&B&!A1&!A|!E1&E&D1&D&C&!B1&B&!A1&!A|!E1&E&D1&D&!C&!B1&B&!A1&!A|E1&E&D1&D&!C&!B1&B&!A1&!A|E1&!E&D1&D&!C&!B1&B&!A1&!A|E1&!E&D1&D&!C&!B1&B&A1&!A|E1&E&D1&D&!C&!B1&B&A1&!A|!E1&E&D1&D&!C&!B1&B&A1&!A|!E1&E&D1&D&C&!B1&B&A1&!A|E1&E&D1&D&C&!B1&B&A1&!A|E1&!E&D1&D&C&!B1&B&A1&!A|E1&!E&!D1&!D&C&B1&B&A1&!A|E1&E&!D1&!D&C&B1&B&A1&!A|!E1&E&!D1&!D&C&B1&B&A1&!A|!E1&E&D1&!D&C&B1&B&A1&!A|E1&E&D1&!D&C&B1&B&A1&!A|E1&!E&D1&!D&C&B1&B&A1&!A|E1&!E&D1&D&C&B1&B&A1&!A|E1&E&D1&D&C&B1&B&A1&!A|!E1&E&D1&D&C&B1&B&A1&!A|!E1&E&!D1&D&C&B1&B&A1&!A|E1&E&!D1&D&C&B1&B&A1&!A|E1&!E&!D1&D&C&B1&B&A1&!A|!E1&E&D1&D&!C&B1&B&A1&!A|E1&E&D1&D&!C&B1&B&A1&!A|E1&!E&D1&D&!C&B1&B&A1&!A|E1&!E&D1&D&!C&B1&!B&A1&!A|E1&E&D1&D&!C&B1&!B&A1&!A|!E1&E&D1&D&!C&B1&!B&A1&!A|!E1&E&D1&D&C&B1&!B&A1&!A|E1&E&D1&D&C&B1&!B&A1&!A|E1&!E&D1&D&C&B1&!B&A1&!A|E1&!E&D1&D&C&!B1&!B&A1&!A|E1&E&D1&D&C&!B1&!B&A1&!A|!E1&E&D1&D&C&!B1&!B&A1&!A|!E1&E&D1&D&!C&!B1&!B&A1&!A|E1&E&D1&D&!C&!B1&!B&A1&!A|E1&!E&D1&D&!C&!B1&!B&A1&!A|E1&!E&D1&D&!C&!B1&!B&A1&A|E1&E&D1&D&!C&!B1&!B&A1&A|!E1&E&D1&D&!C&!B1&!B&A1&A|E1&!E&!D1&D&C&!B1&!B&A1&A|E1&E&!D1&D&C&!B1&!B&A1&A|!E1&E&!D1&D&C&!B1&!B&A1&A|!E1&E&D1&D&C&!B1&!B&A1&A|E1&E&D1&D&C&!B1&!B&A1&A|E1&!E&D1&D&C&!B1&!B&A1&A|E1&!E&D1&!D&C&!B1&!B&A1&A|E1&E&D1&!D&C&!B1&!B&A1&A|!E1&E&D1&!D&C&!B1&!B&A1&A|!E1&E&!D1&!D&C&!B1&!B&A1&A|E1&E&!D1&!D&C&!B1&!B&A1&A|E1&!E&!D1&!D&C&!B1&!B&A1&A|E1&!E&!D1&!D&C&B1&!B&A1&A|E1&E&!D1&!D&C&B1&!B&A1&A|!E1&E&!D1&!D&C&B1&!B&A1&A|!E1&E&D1&!D&C&B1&!B&A1&A|E1&E&D1&!D&C&B1&!B&A1&A|E1&!E&D1&!D&C&B1&!B&A1&A|E1&!E&D1&D&C&B1&!B&A1&A|E1&E&D1&D&C&B1&!B&A1&A|!E1&E&D1&D&C&B1&!B&A1&A|!E1&E&!D1&D&C&B1&!B&A1&A|E1&E&!D1&D&C&B1&!B&A1&A|E1&!E&!D1&D&C&B1&!B&A1&A|!E1&E&D1&D&!C&B1&!B&A1&A|E1&E&D1&D&!C&B1&!B&A1&A|E1&!E&D1&D&!C&B1&!B&A1&A|E1&!E&D1&D&!C&B1&B&A1&A|E1&E&D1&D&!C&B1&B&A1&A|!E1&E&D1&D&!C&B1&B&A1&A|E1&!E&!D1&D&C&B1&B&A1&A|E1&E&!D1&D&C&B1&B&A1&A|!E1&E&!D1&D&C&B1&B&A1&A|!E1&E&D1&D&C&B1&B&A1&A|E1&E&D1&D&C&B1&B&A1&A|E1&!E&D1&D&C&B1&B&A1&A|E1&!E&D1&!D&C&B1&B&A1&A|E1&E&D1&!D&C&B1&B&A1&A|!E1&E&D1&!D&C&B1&B&A1&A|!E1&E&!D1&!D&C&B1&B&A1&A|E1&E&!D1&!D&C&B1&B&A1&A|E1&!E&!D1&!D&C&B1&B&A1&A|E1&!E&!D1&!D&C&!B1&B&A1&A|E1&E&!D1&!D&C&!B1&B&A1&A|!E1&E&!D1&!D&C&!B1&B&A1&A|!E1&E&D1&!D&C&!B1&B&A1&A|E1&E&D1&!D&C&!B1&B&A1&A|E1&!E&D1&!D&C&!B1&B&A1&A|E1&!E&D1&D&C&!B1&B&A1&A|E1&E&D1&D&C&!B1&B&A1&A|!E1&E&D1&D&C&!B1&B&A1&A|!E1&E&!D1&D&C&!B1&B&A1&A|E1&E&!D1&D&C&!B1&B&A1&A|E1&!E&!D1&D&C&!B1&B&A1&A|!E1&E&D1&D&!C&!B1&B&A1&A|E1&E&D1&D&!C&!B1&B&A1&A|E1&!E&D1&D&!C&!B1&B&A1&A|E1&!E&D1&D&!C&!B1&B&!A1&A|E1&E&D1&D&!C&!B1&B&!A1&A|!E1&E&D1&D&!C&!B1&B&!A1&A|!E1&E&D1&D&C&!B1&B&!A1&A|E1&E&D1&D&C&!B1&B&!A1&A|E1&!E&D1&D&C&!B1&B&!A1&A|E1&!E&!D1&!D&C&B1&B&!A1&A|E1&E&!D1&!D&C&B1&B&!A1&A|!E1&E&!D1&!D&C&B1&B&!A1&A|!E1&E&D1&!D&C&B1&B&!A1&A|E1&E&D1&!D&C&B1&B&!A1&A|E1&!E&D1&!D&C&B1&B&!A1&A|E1&!E&D1&D&C&B1&B&!A1&A|E1&E&D1&D&C&B1&B&!A1&A|!E1&E&D1&D&C&B1&B&!A1&A|!E1&E&!D1&D&C&B1&B&!A1&A|E1&E&!D1&D&C&B1&B&!A1&A|E1&!E&!D1&D&C&B1&B&!A1&A|!E1&E&D1&D&!C&B1&B&!A1&A|E1&E&D1&D&!C&B1&B&!A1&A|E1&!E&D1&D&!C&B1&B&!A1&A|E1&!E&D1&D&!C&B1&!B&!A1&A|E1&E&D1&D&!C&B1&!B&!A1&A|!E1&E&D1&D&!C&B1&!B&!A1&A|!E1&E&D1&D&C&B1&!B&!A1&A|E1&E&D1&D&C&B1&!B&!A1&A|E1&!E&D1&D&C&B1&!B&!A1&A|E1&!E&D1&D&C&!B1&!B&!A1&A|E1&E&D1&D&C&!B1&!B&!A1&A|!E1&E&D1&D&C&!B1&!B&!A1&A|!E1&E&D1&D&!C&!B1&!B&!A1&A|E1&E&D1&D&!C&!B1&!B&!A1&A|E1&!E&D1&D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOOAI22122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOI323 -l OOAAOI323 -i C2 C1 C B1 B A2 A1 A -o Y -f Y=(!C2&!C1&!C&!B1&!B&!A2&!A1&!A|C2&!C1&!C&!B1&!B&!A2&!A1&!A|C2&C1&!C&!B1&!B&!A2&!A1&!A|!C2&C1&!C&!B1&!B&!A2&!A1&!A|!C2&C1&C&!B1&!B&!A2&!A1&!A|C2&!C1&C&!B1&!B&!A2&!A1&!A|!C2&!C1&C&!B1&!B&!A2&!A1&!A|!C2&!C1&C&B1&!B&!A2&!A1&!A|C2&!C1&C&B1&!B&!A2&!A1&!A|!C2&C1&C&B1&!B&!A2&!A1&!A|!C2&C1&!C&B1&!B&!A2&!A1&!A|C2&C1&!C&B1&!B&!A2&!A1&!A|C2&!C1&!C&B1&!B&!A2&!A1&!A|!C2&!C1&!C&B1&!B&!A2&!A1&!A|!C2&!C1&!C&B1&B&!A2&!A1&!A|C2&!C1&!C&B1&B&!A2&!A1&!A|C2&C1&!C&B1&B&!A2&!A1&!A|!C2&C1&!C&B1&B&!A2&!A1&!A|!C2&C1&C&B1&B&!A2&!A1&!A|C2&!C1&C&B1&B&!A2&!A1&!A|!C2&!C1&C&B1&B&!A2&!A1&!A|!C2&!C1&C&!B1&B&!A2&!A1&!A|C2&!C1&C&!B1&B&!A2&!A1&!A|!C2&C1&C&!B1&B&!A2&!A1&!A|!C2&C1&!C&!B1&B&!A2&!A1&!A|C2&C1&!C&!B1&B&!A2&!A1&!A|C2&!C1&!C&!B1&B&!A2&!A1&!A|!C2&!C1&!C&!B1&B&!A2&!A1&!A|!C2&!C1&C&!B1&!B&A2&!A1&!A|C2&!C1&C&!B1&!B&A2&!A1&!A|!C2&C1&C&!B1&!B&A2&!A1&!A|!C2&C1&!C&!B1&!B&A2&!A1&!A|C2&C1&!C&!B1&!B&A2&!A1&!A|C2&!C1&!C&!B1&!B&A2&!A1&!A|!C2&!C1&!C&!B1&!B&A2&!A1&!A|!C2&!C1&!C&!B1&!B&A2&A1&!A|C2&!C1&!C&!B1&!B&A2&A1&!A|C2&C1&!C&!B1&!B&A2&A1&!A|!C2&C1&!C&!B1&!B&A2&A1&!A|!C2&C1&C&!B1&!B&A2&A1&!A|C2&!C1&C&!B1&!B&A2&A1&!A|!C2&!C1&C&!B1&!B&A2&A1&!A|!C2&!C1&C&!B1&!B&!A2&A1&!A|C2&!C1&C&!B1&!B&!A2&A1&!A|!C2&C1&C&!B1&!B&!A2&A1&!A|!C2&C1&!C&!B1&!B&!A2&A1&!A|C2&C1&!C&!B1&!B&!A2&A1&!A|C2&!C1&!C&!B1&!B&!A2&A1&!A|!C2&!C1&!C&!B1&!B&!A2&A1&!A|!C2&!C1&!C&!B1&!B&!A2&A1&A|C2&!C1&!C&!B1&!B&!A2&A1&A|C2&C1&!C&!B1&!B&!A2&A1&A|!C2&C1&!C&!B1&!B&!A2&A1&A|!C2&C1&C&!B1&!B&!A2&A1&A|C2&!C1&C&!B1&!B&!A2&A1&A|!C2&!C1&C&!B1&!B&!A2&A1&A|!C2&!C1&C&!B1&!B&A2&A1&A|C2&!C1&C&!B1&!B&A2&A1&A|!C2&C1&C&!B1&!B&A2&A1&A|!C2&C1&!C&!B1&!B&A2&A1&A|C2&C1&!C&!B1&!B&A2&A1&A|C2&!C1&!C&!B1&!B&A2&A1&A|!C2&!C1&!C&!B1&!B&A2&A1&A|!C2&!C1&!C&!B1&!B&A2&!A1&A|C2&!C1&!C&!B1&!B&A2&!A1&A|C2&C1&!C&!B1&!B&A2&!A1&A|!C2&C1&!C&!B1&!B&A2&!A1&A|!C2&C1&C&!B1&!B&A2&!A1&A|C2&!C1&C&!B1&!B&A2&!A1&A|!C2&!C1&C&!B1&!B&A2&!A1&A|!C2&!C1&C&!B1&!B&!A2&!A1&A|C2&!C1&C&!B1&!B&!A2&!A1&A|!C2&C1&C&!B1&!B&!A2&!A1&A|!C2&C1&!C&!B1&!B&!A2&!A1&A|C2&C1&!C&!B1&!B&!A2&!A1&A|C2&!C1&!C&!B1&!B&!A2&!A1&A|!C2&!C1&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOI323.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAI3212 -l OAOOAI3212 -i D1 D C B1 B A2 A1 A -o Y -f Y=!(!D1&D&C&!B1&!B&!A2&!A1&!A|D1&D&C&!B1&!B&!A2&!A1&!A|D1&!D&C&!B1&!B&!A2&!A1&!A|D1&!D&C&B1&!B&!A2&!A1&!A|D1&D&C&B1&!B&!A2&!A1&!A|!D1&D&C&B1&!B&!A2&!A1&!A|!D1&D&C&B1&B&!A2&!A1&!A|D1&D&C&B1&B&!A2&!A1&!A|D1&!D&C&B1&B&!A2&!A1&!A|D1&!D&C&!B1&B&!A2&!A1&!A|D1&D&C&!B1&B&!A2&!A1&!A|!D1&D&C&!B1&B&!A2&!A1&!A|!D1&D&C&!B1&B&A2&!A1&!A|D1&D&C&!B1&B&A2&!A1&!A|D1&!D&C&!B1&B&A2&!A1&!A|D1&!D&C&B1&B&A2&!A1&!A|D1&D&C&B1&B&A2&!A1&!A|!D1&D&C&B1&B&A2&!A1&!A|!D1&D&!C&B1&B&A2&!A1&!A|D1&D&!C&B1&B&A2&!A1&!A|D1&!D&!C&B1&B&A2&!A1&!A|!D1&D&C&B1&!B&A2&!A1&!A|D1&D&C&B1&!B&A2&!A1&!A|D1&!D&C&B1&!B&A2&!A1&!A|D1&!D&C&!B1&!B&A2&!A1&!A|D1&D&C&!B1&!B&A2&!A1&!A|!D1&D&C&!B1&!B&A2&!A1&!A|!D1&D&C&!B1&!B&A2&A1&!A|D1&D&C&!B1&!B&A2&A1&!A|D1&!D&C&!B1&!B&A2&A1&!A|D1&!D&C&B1&!B&A2&A1&!A|D1&D&C&B1&!B&A2&A1&!A|!D1&D&C&B1&!B&A2&A1&!A|D1&!D&!C&B1&B&A2&A1&!A|D1&D&!C&B1&B&A2&A1&!A|!D1&D&!C&B1&B&A2&A1&!A|!D1&D&C&B1&B&A2&A1&!A|D1&D&C&B1&B&A2&A1&!A|D1&!D&C&B1&B&A2&A1&!A|D1&!D&C&!B1&B&A2&A1&!A|D1&D&C&!B1&B&A2&A1&!A|!D1&D&C&!B1&B&A2&A1&!A|!D1&D&C&!B1&B&!A2&A1&!A|D1&D&C&!B1&B&!A2&A1&!A|D1&!D&C&!B1&B&!A2&A1&!A|D1&!D&C&B1&B&!A2&A1&!A|D1&D&C&B1&B&!A2&A1&!A|!D1&D&C&B1&B&!A2&A1&!A|!D1&D&!C&B1&B&!A2&A1&!A|D1&D&!C&B1&B&!A2&A1&!A|D1&!D&!C&B1&B&!A2&A1&!A|!D1&D&C&B1&!B&!A2&A1&!A|D1&D&C&B1&!B&!A2&A1&!A|D1&!D&C&B1&!B&!A2&A1&!A|D1&!D&C&!B1&!B&!A2&A1&!A|D1&D&C&!B1&!B&!A2&A1&!A|!D1&D&C&!B1&!B&!A2&A1&!A|!D1&D&C&!B1&!B&!A2&A1&A|D1&D&C&!B1&!B&!A2&A1&A|D1&!D&C&!B1&!B&!A2&A1&A|D1&!D&C&B1&!B&!A2&A1&A|D1&D&C&B1&!B&!A2&A1&A|!D1&D&C&B1&!B&!A2&A1&A|D1&!D&!C&B1&B&!A2&A1&A|D1&D&!C&B1&B&!A2&A1&A|!D1&D&!C&B1&B&!A2&A1&A|!D1&D&C&B1&B&!A2&A1&A|D1&D&C&B1&B&!A2&A1&A|D1&!D&C&B1&B&!A2&A1&A|D1&!D&C&!B1&B&!A2&A1&A|D1&D&C&!B1&B&!A2&A1&A|!D1&D&C&!B1&B&!A2&A1&A|!D1&D&C&!B1&B&A2&A1&A|D1&D&C&!B1&B&A2&A1&A|D1&!D&C&!B1&B&A2&A1&A|D1&!D&C&B1&B&A2&A1&A|D1&D&C&B1&B&A2&A1&A|!D1&D&C&B1&B&A2&A1&A|!D1&D&!C&B1&B&A2&A1&A|D1&D&!C&B1&B&A2&A1&A|D1&!D&!C&B1&B&A2&A1&A|!D1&D&C&B1&!B&A2&A1&A|D1&D&C&B1&!B&A2&A1&A|D1&!D&C&B1&!B&A2&A1&A|D1&!D&C&!B1&!B&A2&A1&A|D1&D&C&!B1&!B&A2&A1&A|!D1&D&C&!B1&!B&A2&A1&A|!D1&D&C&!B1&!B&A2&!A1&A|D1&D&C&!B1&!B&A2&!A1&A|D1&!D&C&!B1&!B&A2&!A1&A|D1&!D&C&B1&!B&A2&!A1&A|D1&D&C&B1&!B&A2&!A1&A|!D1&D&C&B1&!B&A2&!A1&A|D1&!D&!C&B1&B&A2&!A1&A|D1&D&!C&B1&B&A2&!A1&A|!D1&D&!C&B1&B&A2&!A1&A|!D1&D&C&B1&B&A2&!A1&A|D1&D&C&B1&B&A2&!A1&A|D1&!D&C&B1&B&A2&!A1&A|D1&!D&C&!B1&B&A2&!A1&A|D1&D&C&!B1&B&A2&!A1&A|!D1&D&C&!B1&B&A2&!A1&A|!D1&D&C&!B1&B&!A2&!A1&A|D1&D&C&!B1&B&!A2&!A1&A|D1&!D&C&!B1&B&!A2&!A1&A|D1&!D&C&B1&B&!A2&!A1&A|D1&D&C&B1&B&!A2&!A1&A|!D1&D&C&B1&B&!A2&!A1&A|!D1&D&!C&B1&B&!A2&!A1&A|D1&D&!C&B1&B&!A2&!A1&A|D1&!D&!C&B1&B&!A2&!A1&A|!D1&D&C&B1&!B&!A2&!A1&A|D1&D&C&B1&!B&!A2&!A1&A|D1&!D&C&B1&!B&!A2&!A1&A|D1&!D&C&!B1&!B&!A2&!A1&A|D1&D&C&!B1&!B&!A2&!A1&A|!D1&D&C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAI3212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAI211 -l AOAI211 -i C B A1 A -o Y -f Y=!(C&B&!A1&!A|C&B&A1&!A|C&!B&A1&A|C&B&A1&A|C&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAI211.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOI22112 -l AAOAAOI22112 -i E1 E D C B1 B A1 A -o Y -f Y=(!E1&!E&!D&!C&!B1&!B&!A1&!A|E1&!E&!D&!C&!B1&!B&!A1&!A|!E1&E&!D&!C&!B1&!B&!A1&!A|!E1&E&D&!C&!B1&!B&!A1&!A|E1&!E&D&!C&!B1&!B&!A1&!A|!E1&!E&D&!C&!B1&!B&!A1&!A|!E1&E&!D&C&!B1&!B&!A1&!A|E1&!E&!D&C&!B1&!B&!A1&!A|!E1&!E&!D&C&!B1&!B&!A1&!A|!E1&!E&!D&C&B1&!B&!A1&!A|E1&!E&!D&C&B1&!B&!A1&!A|!E1&E&!D&C&B1&!B&!A1&!A|!E1&!E&D&!C&B1&!B&!A1&!A|E1&!E&D&!C&B1&!B&!A1&!A|!E1&E&D&!C&B1&!B&!A1&!A|!E1&E&!D&!C&B1&!B&!A1&!A|E1&!E&!D&!C&B1&!B&!A1&!A|!E1&!E&!D&!C&B1&!B&!A1&!A|!E1&!E&!D&!C&B1&B&!A1&!A|E1&!E&!D&!C&B1&B&!A1&!A|!E1&E&!D&!C&B1&B&!A1&!A|!E1&E&!D&C&B1&B&!A1&!A|E1&!E&!D&C&B1&B&!A1&!A|!E1&!E&!D&C&B1&B&!A1&!A|!E1&!E&!D&C&!B1&B&!A1&!A|E1&!E&!D&C&!B1&B&!A1&!A|!E1&E&!D&C&!B1&B&!A1&!A|!E1&!E&D&!C&!B1&B&!A1&!A|E1&!E&D&!C&!B1&B&!A1&!A|!E1&E&D&!C&!B1&B&!A1&!A|!E1&E&!D&!C&!B1&B&!A1&!A|E1&!E&!D&!C&!B1&B&!A1&!A|!E1&!E&!D&!C&!B1&B&!A1&!A|!E1&!E&!D&!C&!B1&B&A1&!A|E1&!E&!D&!C&!B1&B&A1&!A|!E1&E&!D&!C&!B1&B&A1&!A|!E1&E&D&!C&!B1&B&A1&!A|E1&!E&D&!C&!B1&B&A1&!A|!E1&!E&D&!C&!B1&B&A1&!A|!E1&E&!D&C&!B1&B&A1&!A|E1&!E&!D&C&!B1&B&A1&!A|!E1&!E&!D&C&!B1&B&A1&!A|!E1&!E&!D&C&B1&B&A1&!A|E1&!E&!D&C&B1&B&A1&!A|!E1&E&!D&C&B1&B&A1&!A|!E1&E&!D&!C&B1&B&A1&!A|E1&!E&!D&!C&B1&B&A1&!A|!E1&!E&!D&!C&B1&B&A1&!A|!E1&!E&!D&!C&B1&!B&A1&!A|E1&!E&!D&!C&B1&!B&A1&!A|!E1&E&!D&!C&B1&!B&A1&!A|!E1&E&D&!C&B1&!B&A1&!A|E1&!E&D&!C&B1&!B&A1&!A|!E1&!E&D&!C&B1&!B&A1&!A|!E1&E&!D&C&B1&!B&A1&!A|E1&!E&!D&C&B1&!B&A1&!A|!E1&!E&!D&C&B1&!B&A1&!A|!E1&!E&!D&C&!B1&!B&A1&!A|E1&!E&!D&C&!B1&!B&A1&!A|!E1&E&!D&C&!B1&!B&A1&!A|!E1&!E&D&!C&!B1&!B&A1&!A|E1&!E&D&!C&!B1&!B&A1&!A|!E1&E&D&!C&!B1&!B&A1&!A|!E1&E&!D&!C&!B1&!B&A1&!A|E1&!E&!D&!C&!B1&!B&A1&!A|!E1&!E&!D&!C&!B1&!B&A1&!A|!E1&!E&!D&!C&!B1&!B&A1&A|E1&!E&!D&!C&!B1&!B&A1&A|!E1&E&!D&!C&!B1&!B&A1&A|!E1&E&!D&C&!B1&!B&A1&A|E1&!E&!D&C&!B1&!B&A1&A|!E1&!E&!D&C&!B1&!B&A1&A|!E1&!E&!D&C&B1&!B&A1&A|E1&!E&!D&C&B1&!B&A1&A|!E1&E&!D&C&B1&!B&A1&A|!E1&E&!D&!C&B1&!B&A1&A|E1&!E&!D&!C&B1&!B&A1&A|!E1&!E&!D&!C&B1&!B&A1&A|!E1&!E&!D&!C&B1&B&A1&A|E1&!E&!D&!C&B1&B&A1&A|!E1&E&!D&!C&B1&B&A1&A|!E1&E&!D&C&B1&B&A1&A|E1&!E&!D&C&B1&B&A1&A|!E1&!E&!D&C&B1&B&A1&A|!E1&!E&!D&C&!B1&B&A1&A|E1&!E&!D&C&!B1&B&A1&A|!E1&E&!D&C&!B1&B&A1&A|!E1&E&!D&!C&!B1&B&A1&A|E1&!E&!D&!C&!B1&B&A1&A|!E1&!E&!D&!C&!B1&B&A1&A|!E1&!E&!D&!C&!B1&B&!A1&A|E1&!E&!D&!C&!B1&B&!A1&A|!E1&E&!D&!C&!B1&B&!A1&A|!E1&E&D&!C&!B1&B&!A1&A|E1&!E&D&!C&!B1&B&!A1&A|!E1&!E&D&!C&!B1&B&!A1&A|!E1&E&!D&C&!B1&B&!A1&A|E1&!E&!D&C&!B1&B&!A1&A|!E1&!E&!D&C&!B1&B&!A1&A|!E1&!E&!D&C&B1&B&!A1&A|E1&!E&!D&C&B1&B&!A1&A|!E1&E&!D&C&B1&B&!A1&A|!E1&E&!D&!C&B1&B&!A1&A|E1&!E&!D&!C&B1&B&!A1&A|!E1&!E&!D&!C&B1&B&!A1&A|!E1&!E&!D&!C&B1&!B&!A1&A|E1&!E&!D&!C&B1&!B&!A1&A|!E1&E&!D&!C&B1&!B&!A1&A|!E1&E&D&!C&B1&!B&!A1&A|E1&!E&D&!C&B1&!B&!A1&A|!E1&!E&D&!C&B1&!B&!A1&A|!E1&E&!D&C&B1&!B&!A1&A|E1&!E&!D&C&B1&!B&!A1&A|!E1&!E&!D&C&B1&!B&!A1&A|!E1&!E&!D&C&!B1&!B&!A1&A|E1&!E&!D&C&!B1&!B&!A1&A|!E1&E&!D&C&!B1&!B&!A1&A|!E1&!E&D&!C&!B1&!B&!A1&A|E1&!E&D&!C&!B1&!B&!A1&A|!E1&E&D&!C&!B1&!B&!A1&A|!E1&E&!D&!C&!B1&!B&!A1&A|E1&!E&!D&!C&!B1&!B&!A1&A|!E1&!E&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOI22112.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOI42 -l AOI42 -i B1 B A3 A2 A1 A -o Y -f Y=(!B1&!B&!A3&!A2&!A1&!A|!B1&!B&A3&!A2&!A1&!A|!B1&!B&A3&A2&!A1&!A|!B1&!B&!A3&A2&!A1&!A|!B1&!B&!A3&A2&A1&!A|!B1&!B&A3&A2&A1&!A|!B1&!B&A3&!A2&A1&!A|!B1&!B&!A3&!A2&A1&!A|!B1&!B&!A3&!A2&A1&A|!B1&!B&A3&!A2&A1&A|!B1&!B&!A3&A2&A1&A|!B1&!B&!A3&A2&!A1&A|!B1&!B&A3&A2&!A1&A|!B1&!B&A3&!A2&!A1&A|!B1&!B&!A3&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOI42.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOAI2124 -l OAAOOAI2124 -i D3 D2 D1 D C1 C B A1 A -o Y -f Y=!(D3&!D2&!D1&!D&C1&C&!B&!A1&!A|D3&D2&!D1&!D&C1&C&!B&!A1&!A|!D3&D2&!D1&!D&C1&C&!B&!A1&!A|!D3&D2&D1&!D&C1&C&!B&!A1&!A|D3&D2&D1&!D&C1&C&!B&!A1&!A|D3&!D2&D1&!D&C1&C&!B&!A1&!A|!D3&!D2&D1&!D&C1&C&!B&!A1&!A|!D3&!D2&D1&D&C1&C&!B&!A1&!A|D3&!D2&D1&D&C1&C&!B&!A1&!A|D3&D2&D1&D&C1&C&!B&!A1&!A|!D3&D2&D1&D&C1&C&!B&!A1&!A|!D3&D2&!D1&D&C1&C&!B&!A1&!A|D3&D2&!D1&D&C1&C&!B&!A1&!A|D3&!D2&!D1&D&C1&C&!B&!A1&!A|!D3&!D2&!D1&D&C1&C&!B&!A1&!A|!D3&!D2&!D1&D&C1&C&B&!A1&!A|D3&!D2&!D1&D&C1&C&B&!A1&!A|D3&D2&!D1&D&C1&C&B&!A1&!A|!D3&D2&!D1&D&C1&C&B&!A1&!A|!D3&D2&D1&D&C1&C&B&!A1&!A|D3&D2&D1&D&C1&C&B&!A1&!A|D3&!D2&D1&D&C1&C&B&!A1&!A|!D3&!D2&D1&D&C1&C&B&!A1&!A|!D3&!D2&D1&!D&C1&C&B&!A1&!A|D3&!D2&D1&!D&C1&C&B&!A1&!A|D3&D2&D1&!D&C1&C&B&!A1&!A|!D3&D2&D1&!D&C1&C&B&!A1&!A|!D3&D2&!D1&!D&C1&C&B&!A1&!A|D3&D2&!D1&!D&C1&C&B&!A1&!A|D3&!D2&!D1&!D&C1&C&B&!A1&!A|D3&!D2&!D1&!D&!C1&!C&B&A1&!A|D3&D2&!D1&!D&!C1&!C&B&A1&!A|!D3&D2&!D1&!D&!C1&!C&B&A1&!A|!D3&D2&D1&!D&!C1&!C&B&A1&!A|D3&D2&D1&!D&!C1&!C&B&A1&!A|D3&!D2&D1&!D&!C1&!C&B&A1&!A|!D3&!D2&D1&!D&!C1&!C&B&A1&!A|!D3&!D2&D1&D&!C1&!C&B&A1&!A|D3&!D2&D1&D&!C1&!C&B&A1&!A|D3&D2&D1&D&!C1&!C&B&A1&!A|!D3&D2&D1&D&!C1&!C&B&A1&!A|!D3&D2&!D1&D&!C1&!C&B&A1&!A|D3&D2&!D1&D&!C1&!C&B&A1&!A|D3&!D2&!D1&D&!C1&!C&B&A1&!A|!D3&!D2&!D1&D&!C1&!C&B&A1&!A|!D3&!D2&!D1&D&C1&!C&B&A1&!A|D3&!D2&!D1&D&C1&!C&B&A1&!A|D3&D2&!D1&D&C1&!C&B&A1&!A|!D3&D2&!D1&D&C1&!C&B&A1&!A|!D3&D2&D1&D&C1&!C&B&A1&!A|D3&D2&D1&D&C1&!C&B&A1&!A|D3&!D2&D1&D&C1&!C&B&A1&!A|!D3&!D2&D1&D&C1&!C&B&A1&!A|!D3&!D2&D1&!D&C1&!C&B&A1&!A|D3&!D2&D1&!D&C1&!C&B&A1&!A|D3&D2&D1&!D&C1&!C&B&A1&!A|!D3&D2&D1&!D&C1&!C&B&A1&!A|!D3&D2&!D1&!D&C1&!C&B&A1&!A|D3&D2&!D1&!D&C1&!C&B&A1&!A|D3&!D2&!D1&!D&C1&!C&B&A1&!A|D3&!D2&!D1&!D&C1&C&B&A1&!A|D3&D2&!D1&!D&C1&C&B&A1&!A|!D3&D2&!D1&!D&C1&C&B&A1&!A|!D3&D2&D1&!D&C1&C&B&A1&!A|D3&D2&D1&!D&C1&C&B&A1&!A|D3&!D2&D1&!D&C1&C&B&A1&!A|!D3&!D2&D1&!D&C1&C&B&A1&!A|!D3&!D2&D1&D&C1&C&B&A1&!A|D3&!D2&D1&D&C1&C&B&A1&!A|D3&D2&D1&D&C1&C&B&A1&!A|!D3&D2&D1&D&C1&C&B&A1&!A|!D3&D2&!D1&D&C1&C&B&A1&!A|D3&D2&!D1&D&C1&C&B&A1&!A|D3&!D2&!D1&D&C1&C&B&A1&!A|!D3&!D2&!D1&D&C1&C&B&A1&!A|!D3&!D2&!D1&D&!C1&C&B&A1&!A|D3&!D2&!D1&D&!C1&C&B&A1&!A|D3&D2&!D1&D&!C1&C&B&A1&!A|!D3&D2&!D1&D&!C1&C&B&A1&!A|!D3&D2&D1&D&!C1&C&B&A1&!A|D3&D2&D1&D&!C1&C&B&A1&!A|D3&!D2&D1&D&!C1&C&B&A1&!A|!D3&!D2&D1&D&!C1&C&B&A1&!A|!D3&!D2&D1&!D&!C1&C&B&A1&!A|D3&!D2&D1&!D&!C1&C&B&A1&!A|D3&D2&D1&!D&!C1&C&B&A1&!A|!D3&D2&D1&!D&!C1&C&B&A1&!A|!D3&D2&!D1&!D&!C1&C&B&A1&!A|D3&D2&!D1&!D&!C1&C&B&A1&!A|D3&!D2&!D1&!D&!C1&C&B&A1&!A|!D3&!D2&!D1&D&C1&C&!B&A1&!A|D3&!D2&!D1&D&C1&C&!B&A1&!A|D3&D2&!D1&D&C1&C&!B&A1&!A|!D3&D2&!D1&D&C1&C&!B&A1&!A|!D3&D2&D1&D&C1&C&!B&A1&!A|D3&D2&D1&D&C1&C&!B&A1&!A|D3&!D2&D1&D&C1&C&!B&A1&!A|!D3&!D2&D1&D&C1&C&!B&A1&!A|!D3&!D2&D1&!D&C1&C&!B&A1&!A|D3&!D2&D1&!D&C1&C&!B&A1&!A|D3&D2&D1&!D&C1&C&!B&A1&!A|!D3&D2&D1&!D&C1&C&!B&A1&!A|!D3&D2&!D1&!D&C1&C&!B&A1&!A|D3&D2&!D1&!D&C1&C&!B&A1&!A|D3&!D2&!D1&!D&C1&C&!B&A1&!A|D3&!D2&!D1&!D&C1&C&!B&A1&A|D3&D2&!D1&!D&C1&C&!B&A1&A|!D3&D2&!D1&!D&C1&C&!B&A1&A|!D3&D2&D1&!D&C1&C&!B&A1&A|D3&D2&D1&!D&C1&C&!B&A1&A|D3&!D2&D1&!D&C1&C&!B&A1&A|!D3&!D2&D1&!D&C1&C&!B&A1&A|!D3&!D2&D1&D&C1&C&!B&A1&A|D3&!D2&D1&D&C1&C&!B&A1&A|D3&D2&D1&D&C1&C&!B&A1&A|!D3&D2&D1&D&C1&C&!B&A1&A|!D3&D2&!D1&D&C1&C&!B&A1&A|D3&D2&!D1&D&C1&C&!B&A1&A|D3&!D2&!D1&D&C1&C&!B&A1&A|!D3&!D2&!D1&D&C1&C&!B&A1&A|D3&!D2&!D1&!D&!C1&C&B&A1&A|D3&D2&!D1&!D&!C1&C&B&A1&A|!D3&D2&!D1&!D&!C1&C&B&A1&A|!D3&D2&D1&!D&!C1&C&B&A1&A|D3&D2&D1&!D&!C1&C&B&A1&A|D3&!D2&D1&!D&!C1&C&B&A1&A|!D3&!D2&D1&!D&!C1&C&B&A1&A|!D3&!D2&D1&D&!C1&C&B&A1&A|D3&!D2&D1&D&!C1&C&B&A1&A|D3&D2&D1&D&!C1&C&B&A1&A|!D3&D2&D1&D&!C1&C&B&A1&A|!D3&D2&!D1&D&!C1&C&B&A1&A|D3&D2&!D1&D&!C1&C&B&A1&A|D3&!D2&!D1&D&!C1&C&B&A1&A|!D3&!D2&!D1&D&!C1&C&B&A1&A|!D3&!D2&!D1&D&C1&C&B&A1&A|D3&!D2&!D1&D&C1&C&B&A1&A|D3&D2&!D1&D&C1&C&B&A1&A|!D3&D2&!D1&D&C1&C&B&A1&A|!D3&D2&D1&D&C1&C&B&A1&A|D3&D2&D1&D&C1&C&B&A1&A|D3&!D2&D1&D&C1&C&B&A1&A|!D3&!D2&D1&D&C1&C&B&A1&A|!D3&!D2&D1&!D&C1&C&B&A1&A|D3&!D2&D1&!D&C1&C&B&A1&A|D3&D2&D1&!D&C1&C&B&A1&A|!D3&D2&D1&!D&C1&C&B&A1&A|!D3&D2&!D1&!D&C1&C&B&A1&A|D3&D2&!D1&!D&C1&C&B&A1&A|D3&!D2&!D1&!D&C1&C&B&A1&A|D3&!D2&!D1&!D&C1&!C&B&A1&A|D3&D2&!D1&!D&C1&!C&B&A1&A|!D3&D2&!D1&!D&C1&!C&B&A1&A|!D3&D2&D1&!D&C1&!C&B&A1&A|D3&D2&D1&!D&C1&!C&B&A1&A|D3&!D2&D1&!D&C1&!C&B&A1&A|!D3&!D2&D1&!D&C1&!C&B&A1&A|!D3&!D2&D1&D&C1&!C&B&A1&A|D3&!D2&D1&D&C1&!C&B&A1&A|D3&D2&D1&D&C1&!C&B&A1&A|!D3&D2&D1&D&C1&!C&B&A1&A|!D3&D2&!D1&D&C1&!C&B&A1&A|D3&D2&!D1&D&C1&!C&B&A1&A|D3&!D2&!D1&D&C1&!C&B&A1&A|!D3&!D2&!D1&D&C1&!C&B&A1&A|!D3&!D2&!D1&D&!C1&!C&B&A1&A|D3&!D2&!D1&D&!C1&!C&B&A1&A|D3&D2&!D1&D&!C1&!C&B&A1&A|!D3&D2&!D1&D&!C1&!C&B&A1&A|!D3&D2&D1&D&!C1&!C&B&A1&A|D3&D2&D1&D&!C1&!C&B&A1&A|D3&!D2&D1&D&!C1&!C&B&A1&A|!D3&!D2&D1&D&!C1&!C&B&A1&A|!D3&!D2&D1&!D&!C1&!C&B&A1&A|D3&!D2&D1&!D&!C1&!C&B&A1&A|D3&D2&D1&!D&!C1&!C&B&A1&A|!D3&D2&D1&!D&!C1&!C&B&A1&A|!D3&D2&!D1&!D&!C1&!C&B&A1&A|D3&D2&!D1&!D&!C1&!C&B&A1&A|D3&!D2&!D1&!D&!C1&!C&B&A1&A|D3&!D2&!D1&!D&!C1&!C&B&!A1&A|D3&D2&!D1&!D&!C1&!C&B&!A1&A|!D3&D2&!D1&!D&!C1&!C&B&!A1&A|!D3&D2&D1&!D&!C1&!C&B&!A1&A|D3&D2&D1&!D&!C1&!C&B&!A1&A|D3&!D2&D1&!D&!C1&!C&B&!A1&A|!D3&!D2&D1&!D&!C1&!C&B&!A1&A|!D3&!D2&D1&D&!C1&!C&B&!A1&A|D3&!D2&D1&D&!C1&!C&B&!A1&A|D3&D2&D1&D&!C1&!C&B&!A1&A|!D3&D2&D1&D&!C1&!C&B&!A1&A|!D3&D2&!D1&D&!C1&!C&B&!A1&A|D3&D2&!D1&D&!C1&!C&B&!A1&A|D3&!D2&!D1&D&!C1&!C&B&!A1&A|!D3&!D2&!D1&D&!C1&!C&B&!A1&A|!D3&!D2&!D1&D&C1&!C&B&!A1&A|D3&!D2&!D1&D&C1&!C&B&!A1&A|D3&D2&!D1&D&C1&!C&B&!A1&A|!D3&D2&!D1&D&C1&!C&B&!A1&A|!D3&D2&D1&D&C1&!C&B&!A1&A|D3&D2&D1&D&C1&!C&B&!A1&A|D3&!D2&D1&D&C1&!C&B&!A1&A|!D3&!D2&D1&D&C1&!C&B&!A1&A|!D3&!D2&D1&!D&C1&!C&B&!A1&A|D3&!D2&D1&!D&C1&!C&B&!A1&A|D3&D2&D1&!D&C1&!C&B&!A1&A|!D3&D2&D1&!D&C1&!C&B&!A1&A|!D3&D2&!D1&!D&C1&!C&B&!A1&A|D3&D2&!D1&!D&C1&!C&B&!A1&A|D3&!D2&!D1&!D&C1&!C&B&!A1&A|D3&!D2&!D1&!D&C1&C&B&!A1&A|D3&D2&!D1&!D&C1&C&B&!A1&A|!D3&D2&!D1&!D&C1&C&B&!A1&A|!D3&D2&D1&!D&C1&C&B&!A1&A|D3&D2&D1&!D&C1&C&B&!A1&A|D3&!D2&D1&!D&C1&C&B&!A1&A|!D3&!D2&D1&!D&C1&C&B&!A1&A|!D3&!D2&D1&D&C1&C&B&!A1&A|D3&!D2&D1&D&C1&C&B&!A1&A|D3&D2&D1&D&C1&C&B&!A1&A|!D3&D2&D1&D&C1&C&B&!A1&A|!D3&D2&!D1&D&C1&C&B&!A1&A|D3&D2&!D1&D&C1&C&B&!A1&A|D3&!D2&!D1&D&C1&C&B&!A1&A|!D3&!D2&!D1&D&C1&C&B&!A1&A|!D3&!D2&!D1&D&!C1&C&B&!A1&A|D3&!D2&!D1&D&!C1&C&B&!A1&A|D3&D2&!D1&D&!C1&C&B&!A1&A|!D3&D2&!D1&D&!C1&C&B&!A1&A|!D3&D2&D1&D&!C1&C&B&!A1&A|D3&D2&D1&D&!C1&C&B&!A1&A|D3&!D2&D1&D&!C1&C&B&!A1&A|!D3&!D2&D1&D&!C1&C&B&!A1&A|!D3&!D2&D1&!D&!C1&C&B&!A1&A|D3&!D2&D1&!D&!C1&C&B&!A1&A|D3&D2&D1&!D&!C1&C&B&!A1&A|!D3&D2&D1&!D&!C1&C&B&!A1&A|!D3&D2&!D1&!D&!C1&C&B&!A1&A|D3&D2&!D1&!D&!C1&C&B&!A1&A|D3&!D2&!D1&!D&!C1&C&B&!A1&A|!D3&!D2&!D1&D&C1&C&!B&!A1&A|D3&!D2&!D1&D&C1&C&!B&!A1&A|D3&D2&!D1&D&C1&C&!B&!A1&A|!D3&D2&!D1&D&C1&C&!B&!A1&A|!D3&D2&D1&D&C1&C&!B&!A1&A|D3&D2&D1&D&C1&C&!B&!A1&A|D3&!D2&D1&D&C1&C&!B&!A1&A|!D3&!D2&D1&D&C1&C&!B&!A1&A|!D3&!D2&D1&!D&C1&C&!B&!A1&A|D3&!D2&D1&!D&C1&C&!B&!A1&A|D3&D2&D1&!D&C1&C&!B&!A1&A|!D3&D2&D1&!D&C1&C&!B&!A1&A|!D3&D2&!D1&!D&C1&C&!B&!A1&A|D3&D2&!D1&!D&C1&C&!B&!A1&A|D3&!D2&!D1&!D&C1&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOAI2124.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAI224 -l AAOOAI224 -i C3 C2 C1 C B1 B A1 A -o Y -f Y=!(C3&!C2&!C1&!C&B1&B&!A1&!A|C3&C2&!C1&!C&B1&B&!A1&!A|!C3&C2&!C1&!C&B1&B&!A1&!A|!C3&C2&C1&!C&B1&B&!A1&!A|C3&C2&C1&!C&B1&B&!A1&!A|C3&!C2&C1&!C&B1&B&!A1&!A|!C3&!C2&C1&!C&B1&B&!A1&!A|!C3&!C2&C1&C&B1&B&!A1&!A|C3&!C2&C1&C&B1&B&!A1&!A|C3&C2&C1&C&B1&B&!A1&!A|!C3&C2&C1&C&B1&B&!A1&!A|!C3&C2&!C1&C&B1&B&!A1&!A|C3&C2&!C1&C&B1&B&!A1&!A|C3&!C2&!C1&C&B1&B&!A1&!A|!C3&!C2&!C1&C&B1&B&!A1&!A|!C3&!C2&!C1&C&B1&B&A1&!A|C3&!C2&!C1&C&B1&B&A1&!A|C3&C2&!C1&C&B1&B&A1&!A|!C3&C2&!C1&C&B1&B&A1&!A|!C3&C2&C1&C&B1&B&A1&!A|C3&C2&C1&C&B1&B&A1&!A|C3&!C2&C1&C&B1&B&A1&!A|!C3&!C2&C1&C&B1&B&A1&!A|!C3&!C2&C1&!C&B1&B&A1&!A|C3&!C2&C1&!C&B1&B&A1&!A|C3&C2&C1&!C&B1&B&A1&!A|!C3&C2&C1&!C&B1&B&A1&!A|!C3&C2&!C1&!C&B1&B&A1&!A|C3&C2&!C1&!C&B1&B&A1&!A|C3&!C2&!C1&!C&B1&B&A1&!A|C3&!C2&!C1&!C&!B1&!B&A1&A|C3&C2&!C1&!C&!B1&!B&A1&A|!C3&C2&!C1&!C&!B1&!B&A1&A|!C3&C2&C1&!C&!B1&!B&A1&A|C3&C2&C1&!C&!B1&!B&A1&A|C3&!C2&C1&!C&!B1&!B&A1&A|!C3&!C2&C1&!C&!B1&!B&A1&A|!C3&!C2&C1&C&!B1&!B&A1&A|C3&!C2&C1&C&!B1&!B&A1&A|C3&C2&C1&C&!B1&!B&A1&A|!C3&C2&C1&C&!B1&!B&A1&A|!C3&C2&!C1&C&!B1&!B&A1&A|C3&C2&!C1&C&!B1&!B&A1&A|C3&!C2&!C1&C&!B1&!B&A1&A|!C3&!C2&!C1&C&!B1&!B&A1&A|!C3&!C2&!C1&C&B1&!B&A1&A|C3&!C2&!C1&C&B1&!B&A1&A|C3&C2&!C1&C&B1&!B&A1&A|!C3&C2&!C1&C&B1&!B&A1&A|!C3&C2&C1&C&B1&!B&A1&A|C3&C2&C1&C&B1&!B&A1&A|C3&!C2&C1&C&B1&!B&A1&A|!C3&!C2&C1&C&B1&!B&A1&A|!C3&!C2&C1&!C&B1&!B&A1&A|C3&!C2&C1&!C&B1&!B&A1&A|C3&C2&C1&!C&B1&!B&A1&A|!C3&C2&C1&!C&B1&!B&A1&A|!C3&C2&!C1&!C&B1&!B&A1&A|C3&C2&!C1&!C&B1&!B&A1&A|C3&!C2&!C1&!C&B1&!B&A1&A|C3&!C2&!C1&!C&B1&B&A1&A|C3&C2&!C1&!C&B1&B&A1&A|!C3&C2&!C1&!C&B1&B&A1&A|!C3&C2&C1&!C&B1&B&A1&A|C3&C2&C1&!C&B1&B&A1&A|C3&!C2&C1&!C&B1&B&A1&A|!C3&!C2&C1&!C&B1&B&A1&A|!C3&!C2&C1&C&B1&B&A1&A|C3&!C2&C1&C&B1&B&A1&A|C3&C2&C1&C&B1&B&A1&A|!C3&C2&C1&C&B1&B&A1&A|!C3&C2&!C1&C&B1&B&A1&A|C3&C2&!C1&C&B1&B&A1&A|C3&!C2&!C1&C&B1&B&A1&A|!C3&!C2&!C1&C&B1&B&A1&A|!C3&!C2&!C1&C&!B1&B&A1&A|C3&!C2&!C1&C&!B1&B&A1&A|C3&C2&!C1&C&!B1&B&A1&A|!C3&C2&!C1&C&!B1&B&A1&A|!C3&C2&C1&C&!B1&B&A1&A|C3&C2&C1&C&!B1&B&A1&A|C3&!C2&C1&C&!B1&B&A1&A|!C3&!C2&C1&C&!B1&B&A1&A|!C3&!C2&C1&!C&!B1&B&A1&A|C3&!C2&C1&!C&!B1&B&A1&A|C3&C2&C1&!C&!B1&B&A1&A|!C3&C2&C1&!C&!B1&B&A1&A|!C3&C2&!C1&!C&!B1&B&A1&A|C3&C2&!C1&!C&!B1&B&A1&A|C3&!C2&!C1&!C&!B1&B&A1&A|!C3&!C2&!C1&C&B1&B&!A1&A|C3&!C2&!C1&C&B1&B&!A1&A|C3&C2&!C1&C&B1&B&!A1&A|!C3&C2&!C1&C&B1&B&!A1&A|!C3&C2&C1&C&B1&B&!A1&A|C3&C2&C1&C&B1&B&!A1&A|C3&!C2&C1&C&B1&B&!A1&A|!C3&!C2&C1&C&B1&B&!A1&A|!C3&!C2&C1&!C&B1&B&!A1&A|C3&!C2&C1&!C&B1&B&!A1&A|C3&C2&C1&!C&B1&B&!A1&A|!C3&C2&C1&!C&B1&B&!A1&A|!C3&C2&!C1&!C&B1&B&!A1&A|C3&C2&!C1&!C&B1&B&!A1&A|C3&!C2&!C1&!C&B1&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAI224.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOI2131 -l OAAOI2131 -i D C2 C1 C B A1 A -o Y -f Y=(!D&!C2&!C1&!C&!B&!A1&!A|!D&C2&!C1&!C&!B&!A1&!A|!D&C2&C1&!C&!B&!A1&!A|!D&!C2&C1&!C&!B&!A1&!A|!D&!C2&C1&C&!B&!A1&!A|!D&C2&!C1&C&!B&!A1&!A|!D&!C2&!C1&C&!B&!A1&!A|!D&!C2&!C1&C&B&!A1&!A|!D&C2&!C1&C&B&!A1&!A|!D&!C2&C1&C&B&!A1&!A|!D&!C2&C1&!C&B&!A1&!A|!D&C2&C1&!C&B&!A1&!A|!D&C2&!C1&!C&B&!A1&!A|!D&!C2&!C1&!C&B&!A1&!A|!D&!C2&!C1&C&!B&A1&!A|!D&C2&!C1&C&!B&A1&!A|!D&!C2&C1&C&!B&A1&!A|!D&!C2&C1&!C&!B&A1&!A|!D&C2&C1&!C&!B&A1&!A|!D&C2&!C1&!C&!B&A1&!A|!D&!C2&!C1&!C&!B&A1&!A|!D&!C2&!C1&!C&!B&A1&A|!D&C2&!C1&!C&!B&A1&A|!D&C2&C1&!C&!B&A1&A|!D&!C2&C1&!C&!B&A1&A|!D&!C2&C1&C&!B&A1&A|!D&C2&!C1&C&!B&A1&A|!D&!C2&!C1&C&!B&A1&A|!D&!C2&!C1&C&!B&!A1&A|!D&C2&!C1&C&!B&!A1&A|!D&!C2&C1&C&!B&!A1&A|!D&!C2&C1&!C&!B&!A1&A|!D&C2&C1&!C&!B&!A1&A|!D&C2&!C1&!C&!B&!A1&A|!D&!C2&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOI2131.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAI2212 -l AAOAI2212 -i D1 D C B1 B A1 A -o Y -f Y=!(D1&D&C&!B1&!B&!A1&!A|D1&D&C&B1&!B&!A1&!A|D1&D&!C&B1&B&!A1&!A|D1&D&C&B1&B&!A1&!A|D1&D&C&!B1&B&!A1&!A|D1&D&C&!B1&B&A1&!A|D1&D&C&B1&B&A1&!A|D1&D&!C&B1&B&A1&!A|D1&D&C&B1&!B&A1&!A|D1&D&C&!B1&!B&A1&!A|D1&D&!C&!B1&!B&A1&A|D1&D&C&!B1&!B&A1&A|D1&D&C&B1&!B&A1&A|D1&D&!C&B1&!B&A1&A|D1&D&!C&B1&B&A1&A|D1&D&C&B1&B&A1&A|D1&D&C&!B1&B&A1&A|D1&D&!C&!B1&B&A1&A|D1&D&C&!B1&B&!A1&A|D1&D&C&B1&B&!A1&A|D1&D&!C&B1&B&!A1&A|D1&D&C&B1&!B&!A1&A|D1&D&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAI2212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOI323 -l OAAOI323 -i C2 C1 C B1 B A2 A1 A -o Y -f Y=!(C2&C1&C&!B1&!B&!A2&!A1&!A|C2&C1&C&B1&!B&!A2&!A1&!A|C2&C1&C&B1&B&!A2&!A1&!A|C2&C1&C&!B1&B&!A2&!A1&!A|C2&C1&C&!B1&B&A2&!A1&!A|!C2&!C1&C&B1&B&A2&!A1&!A|C2&!C1&C&B1&B&A2&!A1&!A|C2&C1&C&B1&B&A2&!A1&!A|!C2&C1&C&B1&B&A2&!A1&!A|!C2&C1&!C&B1&B&A2&!A1&!A|C2&C1&!C&B1&B&A2&!A1&!A|C2&!C1&!C&B1&B&A2&!A1&!A|!C2&!C1&!C&B1&B&A2&!A1&!A|C2&C1&C&B1&!B&A2&!A1&!A|C2&C1&C&!B1&!B&A2&!A1&!A|C2&C1&C&!B1&!B&A2&A1&!A|C2&C1&C&B1&!B&A2&A1&!A|!C2&!C1&!C&B1&B&A2&A1&!A|C2&!C1&!C&B1&B&A2&A1&!A|C2&C1&!C&B1&B&A2&A1&!A|!C2&C1&!C&B1&B&A2&A1&!A|!C2&C1&C&B1&B&A2&A1&!A|C2&C1&C&B1&B&A2&A1&!A|C2&!C1&C&B1&B&A2&A1&!A|!C2&!C1&C&B1&B&A2&A1&!A|C2&C1&C&!B1&B&A2&A1&!A|C2&C1&C&!B1&B&!A2&A1&!A|!C2&!C1&C&B1&B&!A2&A1&!A|C2&!C1&C&B1&B&!A2&A1&!A|C2&C1&C&B1&B&!A2&A1&!A|!C2&C1&C&B1&B&!A2&A1&!A|!C2&C1&!C&B1&B&!A2&A1&!A|C2&C1&!C&B1&B&!A2&A1&!A|C2&!C1&!C&B1&B&!A2&A1&!A|!C2&!C1&!C&B1&B&!A2&A1&!A|C2&C1&C&B1&!B&!A2&A1&!A|C2&C1&C&!B1&!B&!A2&A1&!A|C2&C1&C&!B1&!B&!A2&A1&A|C2&C1&C&B1&!B&!A2&A1&A|!C2&!C1&!C&B1&B&!A2&A1&A|C2&!C1&!C&B1&B&!A2&A1&A|C2&C1&!C&B1&B&!A2&A1&A|!C2&C1&!C&B1&B&!A2&A1&A|!C2&C1&C&B1&B&!A2&A1&A|C2&C1&C&B1&B&!A2&A1&A|C2&!C1&C&B1&B&!A2&A1&A|!C2&!C1&C&B1&B&!A2&A1&A|C2&C1&C&!B1&B&!A2&A1&A|C2&C1&C&!B1&B&A2&A1&A|!C2&!C1&C&B1&B&A2&A1&A|C2&!C1&C&B1&B&A2&A1&A|C2&C1&C&B1&B&A2&A1&A|!C2&C1&C&B1&B&A2&A1&A|!C2&C1&!C&B1&B&A2&A1&A|C2&C1&!C&B1&B&A2&A1&A|C2&!C1&!C&B1&B&A2&A1&A|!C2&!C1&!C&B1&B&A2&A1&A|C2&C1&C&B1&!B&A2&A1&A|C2&C1&C&!B1&!B&A2&A1&A|C2&C1&C&!B1&!B&A2&!A1&A|C2&C1&C&B1&!B&A2&!A1&A|!C2&!C1&!C&B1&B&A2&!A1&A|C2&!C1&!C&B1&B&A2&!A1&A|C2&C1&!C&B1&B&A2&!A1&A|!C2&C1&!C&B1&B&A2&!A1&A|!C2&C1&C&B1&B&A2&!A1&A|C2&C1&C&B1&B&A2&!A1&A|C2&!C1&C&B1&B&A2&!A1&A|!C2&!C1&C&B1&B&A2&!A1&A|C2&C1&C&!B1&B&A2&!A1&A|C2&C1&C&!B1&B&!A2&!A1&A|!C2&!C1&C&B1&B&!A2&!A1&A|C2&!C1&C&B1&B&!A2&!A1&A|C2&C1&C&B1&B&!A2&!A1&A|!C2&C1&C&B1&B&!A2&!A1&A|!C2&C1&!C&B1&B&!A2&!A1&A|C2&C1&!C&B1&B&!A2&!A1&A|C2&!C1&!C&B1&B&!A2&!A1&A|!C2&!C1&!C&B1&B&!A2&!A1&A|C2&C1&C&B1&!B&!A2&!A1&A|C2&C1&C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOI323.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOI314 -l OAAOI314 -i C3 C2 C1 C B A2 A1 A -o Y -f Y=!(C3&C2&C1&C&!B&!A2&!A1&!A|C3&C2&C1&C&B&!A2&!A1&!A|!C3&!C2&!C1&!C&B&A2&!A1&!A|C3&!C2&!C1&!C&B&A2&!A1&!A|C3&C2&!C1&!C&B&A2&!A1&!A|!C3&C2&!C1&!C&B&A2&!A1&!A|!C3&C2&C1&!C&B&A2&!A1&!A|C3&C2&C1&!C&B&A2&!A1&!A|C3&!C2&C1&!C&B&A2&!A1&!A|!C3&!C2&C1&!C&B&A2&!A1&!A|!C3&!C2&C1&C&B&A2&!A1&!A|C3&!C2&C1&C&B&A2&!A1&!A|C3&C2&C1&C&B&A2&!A1&!A|!C3&C2&C1&C&B&A2&!A1&!A|!C3&C2&!C1&C&B&A2&!A1&!A|C3&C2&!C1&C&B&A2&!A1&!A|C3&!C2&!C1&C&B&A2&!A1&!A|!C3&!C2&!C1&C&B&A2&!A1&!A|C3&C2&C1&C&!B&A2&!A1&!A|C3&C2&C1&C&!B&A2&A1&!A|!C3&!C2&!C1&C&B&A2&A1&!A|C3&!C2&!C1&C&B&A2&A1&!A|C3&C2&!C1&C&B&A2&A1&!A|!C3&C2&!C1&C&B&A2&A1&!A|!C3&C2&C1&C&B&A2&A1&!A|C3&C2&C1&C&B&A2&A1&!A|C3&!C2&C1&C&B&A2&A1&!A|!C3&!C2&C1&C&B&A2&A1&!A|!C3&!C2&C1&!C&B&A2&A1&!A|C3&!C2&C1&!C&B&A2&A1&!A|C3&C2&C1&!C&B&A2&A1&!A|!C3&C2&C1&!C&B&A2&A1&!A|!C3&C2&!C1&!C&B&A2&A1&!A|C3&C2&!C1&!C&B&A2&A1&!A|C3&!C2&!C1&!C&B&A2&A1&!A|!C3&!C2&!C1&!C&B&A2&A1&!A|!C3&!C2&!C1&!C&B&!A2&A1&!A|C3&!C2&!C1&!C&B&!A2&A1&!A|C3&C2&!C1&!C&B&!A2&A1&!A|!C3&C2&!C1&!C&B&!A2&A1&!A|!C3&C2&C1&!C&B&!A2&A1&!A|C3&C2&C1&!C&B&!A2&A1&!A|C3&!C2&C1&!C&B&!A2&A1&!A|!C3&!C2&C1&!C&B&!A2&A1&!A|!C3&!C2&C1&C&B&!A2&A1&!A|C3&!C2&C1&C&B&!A2&A1&!A|C3&C2&C1&C&B&!A2&A1&!A|!C3&C2&C1&C&B&!A2&A1&!A|!C3&C2&!C1&C&B&!A2&A1&!A|C3&C2&!C1&C&B&!A2&A1&!A|C3&!C2&!C1&C&B&!A2&A1&!A|!C3&!C2&!C1&C&B&!A2&A1&!A|C3&C2&C1&C&!B&!A2&A1&!A|C3&C2&C1&C&!B&!A2&A1&A|!C3&!C2&!C1&C&B&!A2&A1&A|C3&!C2&!C1&C&B&!A2&A1&A|C3&C2&!C1&C&B&!A2&A1&A|!C3&C2&!C1&C&B&!A2&A1&A|!C3&C2&C1&C&B&!A2&A1&A|C3&C2&C1&C&B&!A2&A1&A|C3&!C2&C1&C&B&!A2&A1&A|!C3&!C2&C1&C&B&!A2&A1&A|!C3&!C2&C1&!C&B&!A2&A1&A|C3&!C2&C1&!C&B&!A2&A1&A|C3&C2&C1&!C&B&!A2&A1&A|!C3&C2&C1&!C&B&!A2&A1&A|!C3&C2&!C1&!C&B&!A2&A1&A|C3&C2&!C1&!C&B&!A2&A1&A|C3&!C2&!C1&!C&B&!A2&A1&A|!C3&!C2&!C1&!C&B&!A2&A1&A|!C3&!C2&!C1&!C&B&A2&A1&A|C3&!C2&!C1&!C&B&A2&A1&A|C3&C2&!C1&!C&B&A2&A1&A|!C3&C2&!C1&!C&B&A2&A1&A|!C3&C2&C1&!C&B&A2&A1&A|C3&C2&C1&!C&B&A2&A1&A|C3&!C2&C1&!C&B&A2&A1&A|!C3&!C2&C1&!C&B&A2&A1&A|!C3&!C2&C1&C&B&A2&A1&A|C3&!C2&C1&C&B&A2&A1&A|C3&C2&C1&C&B&A2&A1&A|!C3&C2&C1&C&B&A2&A1&A|!C3&C2&!C1&C&B&A2&A1&A|C3&C2&!C1&C&B&A2&A1&A|C3&!C2&!C1&C&B&A2&A1&A|!C3&!C2&!C1&C&B&A2&A1&A|C3&C2&C1&C&!B&A2&A1&A|C3&C2&C1&C&!B&A2&!A1&A|!C3&!C2&!C1&C&B&A2&!A1&A|C3&!C2&!C1&C&B&A2&!A1&A|C3&C2&!C1&C&B&A2&!A1&A|!C3&C2&!C1&C&B&A2&!A1&A|!C3&C2&C1&C&B&A2&!A1&A|C3&C2&C1&C&B&A2&!A1&A|C3&!C2&C1&C&B&A2&!A1&A|!C3&!C2&C1&C&B&A2&!A1&A|!C3&!C2&C1&!C&B&A2&!A1&A|C3&!C2&C1&!C&B&A2&!A1&A|C3&C2&C1&!C&B&A2&!A1&A|!C3&C2&C1&!C&B&A2&!A1&A|!C3&C2&!C1&!C&B&A2&!A1&A|C3&C2&!C1&!C&B&A2&!A1&A|C3&!C2&!C1&!C&B&A2&!A1&A|!C3&!C2&!C1&!C&B&A2&!A1&A|!C3&!C2&!C1&!C&B&!A2&!A1&A|C3&!C2&!C1&!C&B&!A2&!A1&A|C3&C2&!C1&!C&B&!A2&!A1&A|!C3&C2&!C1&!C&B&!A2&!A1&A|!C3&C2&C1&!C&B&!A2&!A1&A|C3&C2&C1&!C&B&!A2&!A1&A|C3&!C2&C1&!C&B&!A2&!A1&A|!C3&!C2&C1&!C&B&!A2&!A1&A|!C3&!C2&C1&C&B&!A2&!A1&A|C3&!C2&C1&C&B&!A2&!A1&A|C3&C2&C1&C&B&!A2&!A1&A|!C3&C2&C1&C&B&!A2&!A1&A|!C3&C2&!C1&C&B&!A2&!A1&A|C3&C2&!C1&C&B&!A2&!A1&A|C3&!C2&!C1&C&B&!A2&!A1&A|!C3&!C2&!C1&C&B&!A2&!A1&A|C3&C2&C1&C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOI314.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOAI3112 -l OAOAI3112 -i D1 D C B A2 A1 A -o Y -f Y=!(D1&D&C&!B&!A2&!A1&!A|D1&D&C&B&!A2&!A1&!A|D1&D&!C&B&A2&!A1&!A|D1&D&C&B&A2&!A1&!A|D1&D&C&!B&A2&!A1&!A|D1&D&C&!B&A2&A1&!A|D1&D&C&B&A2&A1&!A|D1&D&!C&B&A2&A1&!A|D1&D&!C&B&!A2&A1&!A|D1&D&C&B&!A2&A1&!A|D1&D&C&!B&!A2&A1&!A|D1&D&C&!B&!A2&A1&A|D1&D&C&B&!A2&A1&A|D1&D&!C&B&!A2&A1&A|D1&D&!C&B&A2&A1&A|D1&D&C&B&A2&A1&A|D1&D&C&!B&A2&A1&A|D1&D&C&!B&A2&!A1&A|D1&D&C&B&A2&!A1&A|D1&D&!C&B&A2&!A1&A|D1&D&!C&B&!A2&!A1&A|D1&D&C&B&!A2&!A1&A|D1&D&C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOAI3112.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOAI3221 -l OAAOAI3221 -i D C1 C B1 B A2 A1 A -o Y -f Y=!(D&C1&C&!B1&!B&!A2&!A1&!A|D&C1&C&B1&!B&!A2&!A1&!A|D&C1&C&B1&B&!A2&!A1&!A|D&C1&C&!B1&B&!A2&!A1&!A|D&C1&C&!B1&B&A2&!A1&!A|D&!C1&C&B1&B&A2&!A1&!A|D&C1&C&B1&B&A2&!A1&!A|D&C1&!C&B1&B&A2&!A1&!A|D&!C1&!C&B1&B&A2&!A1&!A|D&C1&C&B1&!B&A2&!A1&!A|D&C1&C&!B1&!B&A2&!A1&!A|D&C1&C&!B1&!B&A2&A1&!A|D&C1&C&B1&!B&A2&A1&!A|D&!C1&!C&B1&B&A2&A1&!A|D&C1&!C&B1&B&A2&A1&!A|D&C1&C&B1&B&A2&A1&!A|D&!C1&C&B1&B&A2&A1&!A|D&C1&C&!B1&B&A2&A1&!A|D&C1&C&!B1&B&!A2&A1&!A|D&!C1&C&B1&B&!A2&A1&!A|D&C1&C&B1&B&!A2&A1&!A|D&C1&!C&B1&B&!A2&A1&!A|D&!C1&!C&B1&B&!A2&A1&!A|D&C1&C&B1&!B&!A2&A1&!A|D&C1&C&!B1&!B&!A2&A1&!A|D&C1&C&!B1&!B&!A2&A1&A|D&C1&C&B1&!B&!A2&A1&A|D&!C1&!C&B1&B&!A2&A1&A|D&C1&!C&B1&B&!A2&A1&A|D&C1&C&B1&B&!A2&A1&A|D&!C1&C&B1&B&!A2&A1&A|D&C1&C&!B1&B&!A2&A1&A|D&C1&C&!B1&B&A2&A1&A|D&!C1&C&B1&B&A2&A1&A|D&C1&C&B1&B&A2&A1&A|D&C1&!C&B1&B&A2&A1&A|D&!C1&!C&B1&B&A2&A1&A|D&C1&C&B1&!B&A2&A1&A|D&C1&C&!B1&!B&A2&A1&A|D&C1&C&!B1&!B&A2&!A1&A|D&C1&C&B1&!B&A2&!A1&A|D&!C1&!C&B1&B&A2&!A1&A|D&C1&!C&B1&B&A2&!A1&A|D&C1&C&B1&B&A2&!A1&A|D&!C1&C&B1&B&A2&!A1&A|D&C1&C&!B1&B&A2&!A1&A|D&C1&C&!B1&B&!A2&!A1&A|D&!C1&C&B1&B&!A2&!A1&A|D&C1&C&B1&B&!A2&!A1&A|D&C1&!C&B1&B&!A2&!A1&A|D&!C1&!C&B1&B&!A2&!A1&A|D&C1&C&B1&!B&!A2&!A1&A|D&C1&C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOAI3221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOAOAI222111 -l OOAAOAOAI222111 -i F E D C1 C B1 B A1 A -o Y -f Y=!(F&E&!D&!C1&!C&!B1&!B&!A1&!A|F&E&D&!C1&!C&!B1&!B&!A1&!A|F&E&D&C1&!C&!B1&!B&!A1&!A|F&E&!D&C1&!C&!B1&!B&!A1&!A|F&E&!D&C1&C&!B1&!B&!A1&!A|F&E&D&C1&C&!B1&!B&!A1&!A|F&!E&D&C1&C&!B1&!B&!A1&!A|F&E&D&!C1&C&!B1&!B&!A1&!A|F&E&!D&!C1&C&!B1&!B&!A1&!A|F&E&!D&!C1&C&B1&!B&!A1&!A|F&E&D&!C1&C&B1&!B&!A1&!A|F&!E&D&C1&C&B1&!B&!A1&!A|F&E&D&C1&C&B1&!B&!A1&!A|F&E&!D&C1&C&B1&!B&!A1&!A|F&E&!D&C1&!C&B1&!B&!A1&!A|F&E&D&C1&!C&B1&!B&!A1&!A|F&E&D&!C1&!C&B1&!B&!A1&!A|F&E&!D&!C1&!C&B1&!B&!A1&!A|F&E&!D&!C1&!C&B1&B&!A1&!A|F&E&D&!C1&!C&B1&B&!A1&!A|F&E&D&C1&!C&B1&B&!A1&!A|F&E&!D&C1&!C&B1&B&!A1&!A|F&E&!D&C1&C&B1&B&!A1&!A|F&E&D&C1&C&B1&B&!A1&!A|F&!E&D&C1&C&B1&B&!A1&!A|F&E&D&!C1&C&B1&B&!A1&!A|F&E&!D&!C1&C&B1&B&!A1&!A|F&E&!D&!C1&C&!B1&B&!A1&!A|F&E&D&!C1&C&!B1&B&!A1&!A|F&!E&D&C1&C&!B1&B&!A1&!A|F&E&D&C1&C&!B1&B&!A1&!A|F&E&!D&C1&C&!B1&B&!A1&!A|F&E&!D&C1&!C&!B1&B&!A1&!A|F&E&D&C1&!C&!B1&B&!A1&!A|F&E&D&!C1&!C&!B1&B&!A1&!A|F&E&!D&!C1&!C&!B1&B&!A1&!A|F&E&!D&!C1&!C&!B1&B&A1&!A|F&E&D&!C1&!C&!B1&B&A1&!A|F&!E&D&!C1&!C&!B1&B&A1&!A|F&!E&D&C1&!C&!B1&B&A1&!A|F&E&D&C1&!C&!B1&B&A1&!A|F&E&!D&C1&!C&!B1&B&A1&!A|F&E&!D&C1&C&!B1&B&A1&!A|F&E&D&C1&C&!B1&B&A1&!A|F&!E&D&C1&C&!B1&B&A1&!A|F&!E&D&!C1&C&!B1&B&A1&!A|F&E&D&!C1&C&!B1&B&A1&!A|F&E&!D&!C1&C&!B1&B&A1&!A|F&E&!D&!C1&C&B1&B&A1&!A|F&E&D&!C1&C&B1&B&A1&!A|F&!E&D&!C1&C&B1&B&A1&!A|F&!E&D&C1&C&B1&B&A1&!A|F&E&D&C1&C&B1&B&A1&!A|F&E&!D&C1&C&B1&B&A1&!A|F&E&!D&C1&!C&B1&B&A1&!A|F&E&D&C1&!C&B1&B&A1&!A|F&!E&D&C1&!C&B1&B&A1&!A|F&!E&D&!C1&!C&B1&B&A1&!A|F&E&D&!C1&!C&B1&B&A1&!A|F&E&!D&!C1&!C&B1&B&A1&!A|F&E&!D&!C1&!C&B1&!B&A1&!A|F&E&D&!C1&!C&B1&!B&A1&!A|F&!E&D&!C1&!C&B1&!B&A1&!A|F&!E&D&C1&!C&B1&!B&A1&!A|F&E&D&C1&!C&B1&!B&A1&!A|F&E&!D&C1&!C&B1&!B&A1&!A|F&E&!D&C1&C&B1&!B&A1&!A|F&E&D&C1&C&B1&!B&A1&!A|F&!E&D&C1&C&B1&!B&A1&!A|F&!E&D&!C1&C&B1&!B&A1&!A|F&E&D&!C1&C&B1&!B&A1&!A|F&E&!D&!C1&C&B1&!B&A1&!A|F&E&!D&!C1&C&!B1&!B&A1&!A|F&E&D&!C1&C&!B1&!B&A1&!A|F&!E&D&C1&C&!B1&!B&A1&!A|F&E&D&C1&C&!B1&!B&A1&!A|F&E&!D&C1&C&!B1&!B&A1&!A|F&E&!D&C1&!C&!B1&!B&A1&!A|F&E&D&C1&!C&!B1&!B&A1&!A|F&E&D&!C1&!C&!B1&!B&A1&!A|F&E&!D&!C1&!C&!B1&!B&A1&!A|F&E&!D&!C1&!C&!B1&!B&A1&A|F&E&D&!C1&!C&!B1&!B&A1&A|F&E&D&C1&!C&!B1&!B&A1&A|F&E&!D&C1&!C&!B1&!B&A1&A|F&E&!D&C1&C&!B1&!B&A1&A|F&E&D&C1&C&!B1&!B&A1&A|F&!E&D&C1&C&!B1&!B&A1&A|F&E&D&!C1&C&!B1&!B&A1&A|F&E&!D&!C1&C&!B1&!B&A1&A|F&E&!D&!C1&C&B1&!B&A1&A|F&E&D&!C1&C&B1&!B&A1&A|F&!E&D&!C1&C&B1&!B&A1&A|F&!E&D&C1&C&B1&!B&A1&A|F&E&D&C1&C&B1&!B&A1&A|F&E&!D&C1&C&B1&!B&A1&A|F&E&!D&C1&!C&B1&!B&A1&A|F&E&D&C1&!C&B1&!B&A1&A|F&!E&D&C1&!C&B1&!B&A1&A|F&!E&D&!C1&!C&B1&!B&A1&A|F&E&D&!C1&!C&B1&!B&A1&A|F&E&!D&!C1&!C&B1&!B&A1&A|F&E&!D&!C1&!C&B1&B&A1&A|F&E&D&!C1&!C&B1&B&A1&A|F&!E&D&!C1&!C&B1&B&A1&A|F&!E&D&C1&!C&B1&B&A1&A|F&E&D&C1&!C&B1&B&A1&A|F&E&!D&C1&!C&B1&B&A1&A|F&E&!D&C1&C&B1&B&A1&A|F&E&D&C1&C&B1&B&A1&A|F&!E&D&C1&C&B1&B&A1&A|F&!E&D&!C1&C&B1&B&A1&A|F&E&D&!C1&C&B1&B&A1&A|F&E&!D&!C1&C&B1&B&A1&A|F&E&!D&!C1&C&!B1&B&A1&A|F&E&D&!C1&C&!B1&B&A1&A|F&!E&D&!C1&C&!B1&B&A1&A|F&!E&D&C1&C&!B1&B&A1&A|F&E&D&C1&C&!B1&B&A1&A|F&E&!D&C1&C&!B1&B&A1&A|F&E&!D&C1&!C&!B1&B&A1&A|F&E&D&C1&!C&!B1&B&A1&A|F&!E&D&C1&!C&!B1&B&A1&A|F&!E&D&!C1&!C&!B1&B&A1&A|F&E&D&!C1&!C&!B1&B&A1&A|F&E&!D&!C1&!C&!B1&B&A1&A|F&E&!D&!C1&!C&!B1&B&!A1&A|F&E&D&!C1&!C&!B1&B&!A1&A|F&!E&D&!C1&!C&!B1&B&!A1&A|F&!E&D&C1&!C&!B1&B&!A1&A|F&E&D&C1&!C&!B1&B&!A1&A|F&E&!D&C1&!C&!B1&B&!A1&A|F&E&!D&C1&C&!B1&B&!A1&A|F&E&D&C1&C&!B1&B&!A1&A|F&!E&D&C1&C&!B1&B&!A1&A|F&!E&D&!C1&C&!B1&B&!A1&A|F&E&D&!C1&C&!B1&B&!A1&A|F&E&!D&!C1&C&!B1&B&!A1&A|F&E&!D&!C1&C&B1&B&!A1&A|F&E&D&!C1&C&B1&B&!A1&A|F&!E&D&!C1&C&B1&B&!A1&A|F&!E&D&C1&C&B1&B&!A1&A|F&E&D&C1&C&B1&B&!A1&A|F&E&!D&C1&C&B1&B&!A1&A|F&E&!D&C1&!C&B1&B&!A1&A|F&E&D&C1&!C&B1&B&!A1&A|F&!E&D&C1&!C&B1&B&!A1&A|F&!E&D&!C1&!C&B1&B&!A1&A|F&E&D&!C1&!C&B1&B&!A1&A|F&E&!D&!C1&!C&B1&B&!A1&A|F&E&!D&!C1&!C&B1&!B&!A1&A|F&E&D&!C1&!C&B1&!B&!A1&A|F&!E&D&!C1&!C&B1&!B&!A1&A|F&!E&D&C1&!C&B1&!B&!A1&A|F&E&D&C1&!C&B1&!B&!A1&A|F&E&!D&C1&!C&B1&!B&!A1&A|F&E&!D&C1&C&B1&!B&!A1&A|F&E&D&C1&C&B1&!B&!A1&A|F&!E&D&C1&C&B1&!B&!A1&A|F&!E&D&!C1&C&B1&!B&!A1&A|F&E&D&!C1&C&B1&!B&!A1&A|F&E&!D&!C1&C&B1&!B&!A1&A|F&E&!D&!C1&C&!B1&!B&!A1&A|F&E&D&!C1&C&!B1&!B&!A1&A|F&!E&D&C1&C&!B1&!B&!A1&A|F&E&D&C1&C&!B1&!B&!A1&A|F&E&!D&C1&C&!B1&!B&!A1&A|F&E&!D&C1&!C&!B1&!B&!A1&A|F&E&D&C1&!C&!B1&!B&!A1&A|F&E&D&!C1&!C&!B1&!B&!A1&A|F&E&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOAOAI222111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAAOI2122 -l AOOAAOI2122 -i D1 D C1 C B A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B&!A1&!A|D1&!D&!C1&!C&!B&!A1&!A|!D1&D&!C1&!C&!B&!A1&!A|!D1&D&C1&!C&!B&!A1&!A|D1&!D&C1&!C&!B&!A1&!A|!D1&!D&C1&!C&!B&!A1&!A|!D1&!D&C1&C&!B&!A1&!A|D1&!D&C1&C&!B&!A1&!A|!D1&D&C1&C&!B&!A1&!A|!D1&D&!C1&C&!B&!A1&!A|D1&!D&!C1&C&!B&!A1&!A|!D1&!D&!C1&C&!B&!A1&!A|!D1&D&!C1&!C&B&!A1&!A|D1&!D&!C1&!C&B&!A1&!A|!D1&!D&!C1&!C&B&!A1&!A|!D1&!D&!C1&!C&B&A1&!A|D1&!D&!C1&!C&B&A1&!A|!D1&D&!C1&!C&B&A1&!A|!D1&!D&!C1&C&!B&A1&!A|D1&!D&!C1&C&!B&A1&!A|!D1&D&!C1&C&!B&A1&!A|!D1&D&C1&C&!B&A1&!A|D1&!D&C1&C&!B&A1&!A|!D1&!D&C1&C&!B&A1&!A|!D1&!D&C1&!C&!B&A1&!A|D1&!D&C1&!C&!B&A1&!A|!D1&D&C1&!C&!B&A1&!A|!D1&D&!C1&!C&!B&A1&!A|D1&!D&!C1&!C&!B&A1&!A|!D1&!D&!C1&!C&!B&A1&!A|!D1&!D&!C1&!C&!B&A1&A|D1&!D&!C1&!C&!B&A1&A|!D1&D&!C1&!C&!B&A1&A|!D1&D&!C1&!C&B&A1&A|D1&!D&!C1&!C&B&A1&A|!D1&!D&!C1&!C&B&A1&A|!D1&!D&!C1&!C&B&!A1&A|D1&!D&!C1&!C&B&!A1&A|!D1&D&!C1&!C&B&!A1&A|!D1&!D&!C1&C&!B&!A1&A|D1&!D&!C1&C&!B&!A1&A|!D1&D&!C1&C&!B&!A1&A|!D1&D&C1&C&!B&!A1&A|D1&!D&C1&C&!B&!A1&A|!D1&!D&C1&C&!B&!A1&A|!D1&!D&C1&!C&!B&!A1&A|D1&!D&C1&!C&!B&!A1&A|!D1&D&C1&!C&!B&!A1&A|!D1&D&!C1&!C&!B&!A1&A|D1&!D&!C1&!C&!B&!A1&A|!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAAOI2122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOI2111 -l AOAOI2111 -i D C B A1 A -o Y -f Y=(!D&!C&!B&!A1&!A|!D&C&!B&!A1&!A|!D&!C&B&!A1&!A|!D&!C&B&A1&!A|!D&C&!B&A1&!A|!D&!C&!B&A1&!A|!D&!C&!B&A1&A|!D&!C&B&A1&A|!D&!C&B&!A1&A|!D&C&!B&!A1&A|!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOI2111.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOAOI22311 -l OOAAOAOI22311 -i E D C2 C1 C B1 B A1 A -o Y -f Y=(!E&!D&!C2&!C1&!C&!B1&!B&!A1&!A|!E&D&!C2&!C1&!C&!B1&!B&!A1&!A|!E&D&C2&!C1&!C&!B1&!B&!A1&!A|!E&!D&C2&!C1&!C&!B1&!B&!A1&!A|!E&!D&C2&C1&!C&!B1&!B&!A1&!A|!E&D&C2&C1&!C&!B1&!B&!A1&!A|!E&D&!C2&C1&!C&!B1&!B&!A1&!A|!E&!D&!C2&C1&!C&!B1&!B&!A1&!A|!E&!D&!C2&C1&C&!B1&!B&!A1&!A|!E&D&!C2&C1&C&!B1&!B&!A1&!A|!E&!D&C2&C1&C&!B1&!B&!A1&!A|!E&!D&C2&!C1&C&!B1&!B&!A1&!A|!E&D&C2&!C1&C&!B1&!B&!A1&!A|!E&D&!C2&!C1&C&!B1&!B&!A1&!A|!E&!D&!C2&!C1&C&!B1&!B&!A1&!A|!E&!D&!C2&!C1&C&B1&!B&!A1&!A|!E&D&!C2&!C1&C&B1&!B&!A1&!A|!E&D&C2&!C1&C&B1&!B&!A1&!A|!E&!D&C2&!C1&C&B1&!B&!A1&!A|!E&!D&C2&C1&C&B1&!B&!A1&!A|!E&D&!C2&C1&C&B1&!B&!A1&!A|!E&!D&!C2&C1&C&B1&!B&!A1&!A|!E&!D&!C2&C1&!C&B1&!B&!A1&!A|!E&D&!C2&C1&!C&B1&!B&!A1&!A|!E&D&C2&C1&!C&B1&!B&!A1&!A|!E&!D&C2&C1&!C&B1&!B&!A1&!A|!E&!D&C2&!C1&!C&B1&!B&!A1&!A|!E&D&C2&!C1&!C&B1&!B&!A1&!A|!E&D&!C2&!C1&!C&B1&!B&!A1&!A|!E&!D&!C2&!C1&!C&B1&!B&!A1&!A|!E&!D&!C2&!C1&!C&B1&B&!A1&!A|!E&D&!C2&!C1&!C&B1&B&!A1&!A|!E&D&C2&!C1&!C&B1&B&!A1&!A|!E&!D&C2&!C1&!C&B1&B&!A1&!A|!E&!D&C2&C1&!C&B1&B&!A1&!A|!E&D&C2&C1&!C&B1&B&!A1&!A|!E&D&!C2&C1&!C&B1&B&!A1&!A|!E&!D&!C2&C1&!C&B1&B&!A1&!A|!E&!D&!C2&C1&C&B1&B&!A1&!A|!E&D&!C2&C1&C&B1&B&!A1&!A|!E&!D&C2&C1&C&B1&B&!A1&!A|!E&!D&C2&!C1&C&B1&B&!A1&!A|!E&D&C2&!C1&C&B1&B&!A1&!A|!E&D&!C2&!C1&C&B1&B&!A1&!A|!E&!D&!C2&!C1&C&B1&B&!A1&!A|!E&!D&!C2&!C1&C&!B1&B&!A1&!A|!E&D&!C2&!C1&C&!B1&B&!A1&!A|!E&D&C2&!C1&C&!B1&B&!A1&!A|!E&!D&C2&!C1&C&!B1&B&!A1&!A|!E&!D&C2&C1&C&!B1&B&!A1&!A|!E&D&!C2&C1&C&!B1&B&!A1&!A|!E&!D&!C2&C1&C&!B1&B&!A1&!A|!E&!D&!C2&C1&!C&!B1&B&!A1&!A|!E&D&!C2&C1&!C&!B1&B&!A1&!A|!E&D&C2&C1&!C&!B1&B&!A1&!A|!E&!D&C2&C1&!C&!B1&B&!A1&!A|!E&!D&C2&!C1&!C&!B1&B&!A1&!A|!E&D&C2&!C1&!C&!B1&B&!A1&!A|!E&D&!C2&!C1&!C&!B1&B&!A1&!A|!E&!D&!C2&!C1&!C&!B1&B&!A1&!A|!E&!D&!C2&!C1&!C&!B1&B&A1&!A|!E&!D&C2&!C1&!C&!B1&B&A1&!A|!E&!D&C2&C1&!C&!B1&B&A1&!A|!E&!D&!C2&C1&!C&!B1&B&A1&!A|!E&!D&!C2&C1&C&!B1&B&A1&!A|!E&!D&C2&C1&C&!B1&B&A1&!A|!E&!D&C2&!C1&C&!B1&B&A1&!A|!E&!D&!C2&!C1&C&!B1&B&A1&!A|!E&!D&!C2&!C1&C&B1&B&A1&!A|!E&!D&C2&!C1&C&B1&B&A1&!A|!E&!D&C2&C1&C&B1&B&A1&!A|!E&!D&!C2&C1&C&B1&B&A1&!A|!E&!D&!C2&C1&!C&B1&B&A1&!A|!E&!D&C2&C1&!C&B1&B&A1&!A|!E&!D&C2&!C1&!C&B1&B&A1&!A|!E&!D&!C2&!C1&!C&B1&B&A1&!A|!E&!D&!C2&!C1&!C&B1&!B&A1&!A|!E&!D&C2&!C1&!C&B1&!B&A1&!A|!E&!D&C2&C1&!C&B1&!B&A1&!A|!E&!D&!C2&C1&!C&B1&!B&A1&!A|!E&!D&!C2&C1&C&B1&!B&A1&!A|!E&!D&C2&C1&C&B1&!B&A1&!A|!E&!D&C2&!C1&C&B1&!B&A1&!A|!E&!D&!C2&!C1&C&B1&!B&A1&!A|!E&!D&!C2&!C1&C&!B1&!B&A1&!A|!E&D&!C2&!C1&C&!B1&!B&A1&!A|!E&D&C2&!C1&C&!B1&!B&A1&!A|!E&!D&C2&!C1&C&!B1&!B&A1&!A|!E&!D&C2&C1&C&!B1&!B&A1&!A|!E&D&!C2&C1&C&!B1&!B&A1&!A|!E&!D&!C2&C1&C&!B1&!B&A1&!A|!E&!D&!C2&C1&!C&!B1&!B&A1&!A|!E&D&!C2&C1&!C&!B1&!B&A1&!A|!E&D&C2&C1&!C&!B1&!B&A1&!A|!E&!D&C2&C1&!C&!B1&!B&A1&!A|!E&!D&C2&!C1&!C&!B1&!B&A1&!A|!E&D&C2&!C1&!C&!B1&!B&A1&!A|!E&D&!C2&!C1&!C&!B1&!B&A1&!A|!E&!D&!C2&!C1&!C&!B1&!B&A1&!A|!E&!D&!C2&!C1&!C&!B1&!B&A1&A|!E&D&!C2&!C1&!C&!B1&!B&A1&A|!E&D&C2&!C1&!C&!B1&!B&A1&A|!E&!D&C2&!C1&!C&!B1&!B&A1&A|!E&!D&C2&C1&!C&!B1&!B&A1&A|!E&D&C2&C1&!C&!B1&!B&A1&A|!E&D&!C2&C1&!C&!B1&!B&A1&A|!E&!D&!C2&C1&!C&!B1&!B&A1&A|!E&!D&!C2&C1&C&!B1&!B&A1&A|!E&D&!C2&C1&C&!B1&!B&A1&A|!E&!D&C2&C1&C&!B1&!B&A1&A|!E&!D&C2&!C1&C&!B1&!B&A1&A|!E&D&C2&!C1&C&!B1&!B&A1&A|!E&D&!C2&!C1&C&!B1&!B&A1&A|!E&!D&!C2&!C1&C&!B1&!B&A1&A|!E&!D&!C2&!C1&C&B1&!B&A1&A|!E&!D&C2&!C1&C&B1&!B&A1&A|!E&!D&C2&C1&C&B1&!B&A1&A|!E&!D&!C2&C1&C&B1&!B&A1&A|!E&!D&!C2&C1&!C&B1&!B&A1&A|!E&!D&C2&C1&!C&B1&!B&A1&A|!E&!D&C2&!C1&!C&B1&!B&A1&A|!E&!D&!C2&!C1&!C&B1&!B&A1&A|!E&!D&!C2&!C1&!C&B1&B&A1&A|!E&!D&C2&!C1&!C&B1&B&A1&A|!E&!D&C2&C1&!C&B1&B&A1&A|!E&!D&!C2&C1&!C&B1&B&A1&A|!E&!D&!C2&C1&C&B1&B&A1&A|!E&!D&C2&C1&C&B1&B&A1&A|!E&!D&C2&!C1&C&B1&B&A1&A|!E&!D&!C2&!C1&C&B1&B&A1&A|!E&!D&!C2&!C1&C&!B1&B&A1&A|!E&!D&C2&!C1&C&!B1&B&A1&A|!E&!D&C2&C1&C&!B1&B&A1&A|!E&!D&!C2&C1&C&!B1&B&A1&A|!E&!D&!C2&C1&!C&!B1&B&A1&A|!E&!D&C2&C1&!C&!B1&B&A1&A|!E&!D&C2&!C1&!C&!B1&B&A1&A|!E&!D&!C2&!C1&!C&!B1&B&A1&A|!E&!D&!C2&!C1&!C&!B1&B&!A1&A|!E&!D&C2&!C1&!C&!B1&B&!A1&A|!E&!D&C2&C1&!C&!B1&B&!A1&A|!E&!D&!C2&C1&!C&!B1&B&!A1&A|!E&!D&!C2&C1&C&!B1&B&!A1&A|!E&!D&C2&C1&C&!B1&B&!A1&A|!E&!D&C2&!C1&C&!B1&B&!A1&A|!E&!D&!C2&!C1&C&!B1&B&!A1&A|!E&!D&!C2&!C1&C&B1&B&!A1&A|!E&!D&C2&!C1&C&B1&B&!A1&A|!E&!D&C2&C1&C&B1&B&!A1&A|!E&!D&!C2&C1&C&B1&B&!A1&A|!E&!D&!C2&C1&!C&B1&B&!A1&A|!E&!D&C2&C1&!C&B1&B&!A1&A|!E&!D&C2&!C1&!C&B1&B&!A1&A|!E&!D&!C2&!C1&!C&B1&B&!A1&A|!E&!D&!C2&!C1&!C&B1&!B&!A1&A|!E&!D&C2&!C1&!C&B1&!B&!A1&A|!E&!D&C2&C1&!C&B1&!B&!A1&A|!E&!D&!C2&C1&!C&B1&!B&!A1&A|!E&!D&!C2&C1&C&B1&!B&!A1&A|!E&!D&C2&C1&C&B1&!B&!A1&A|!E&!D&C2&!C1&C&B1&!B&!A1&A|!E&!D&!C2&!C1&C&B1&!B&!A1&A|!E&!D&!C2&!C1&C&!B1&!B&!A1&A|!E&D&!C2&!C1&C&!B1&!B&!A1&A|!E&D&C2&!C1&C&!B1&!B&!A1&A|!E&!D&C2&!C1&C&!B1&!B&!A1&A|!E&!D&C2&C1&C&!B1&!B&!A1&A|!E&D&!C2&C1&C&!B1&!B&!A1&A|!E&!D&!C2&C1&C&!B1&!B&!A1&A|!E&!D&!C2&C1&!C&!B1&!B&!A1&A|!E&D&!C2&C1&!C&!B1&!B&!A1&A|!E&D&C2&C1&!C&!B1&!B&!A1&A|!E&!D&C2&C1&!C&!B1&!B&!A1&A|!E&!D&C2&!C1&!C&!B1&!B&!A1&A|!E&D&C2&!C1&!C&!B1&!B&!A1&A|!E&D&!C2&!C1&!C&!B1&!B&!A1&A|!E&!D&!C2&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOAOI22311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAI213 -l AOOAI213 -i C2 C1 C B A1 A -o Y -f Y=(!C2&!C1&!C&!B&!A1&!A|C2&!C1&!C&!B&!A1&!A|C2&C1&!C&!B&!A1&!A|!C2&C1&!C&!B&!A1&!A|!C2&C1&C&!B&!A1&!A|C2&C1&C&!B&!A1&!A|C2&!C1&C&!B&!A1&!A|!C2&!C1&C&!B&!A1&!A|!C2&!C1&!C&B&!A1&!A|!C2&!C1&!C&B&A1&!A|!C2&!C1&C&!B&A1&!A|C2&!C1&C&!B&A1&!A|C2&C1&C&!B&A1&!A|!C2&C1&C&!B&A1&!A|!C2&C1&!C&!B&A1&!A|C2&C1&!C&!B&A1&!A|C2&!C1&!C&!B&A1&!A|!C2&!C1&!C&!B&A1&!A|!C2&!C1&!C&!B&A1&A|!C2&!C1&!C&B&A1&A|!C2&!C1&!C&B&!A1&A|!C2&!C1&C&!B&!A1&A|C2&!C1&C&!B&!A1&A|C2&C1&C&!B&!A1&A|!C2&C1&C&!B&!A1&A|!C2&C1&!C&!B&!A1&A|C2&C1&!C&!B&!A1&A|C2&!C1&!C&!B&!A1&A|!C2&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAI213.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAOAI221311 -l AAOOAOAI221311 -i F E D2 D1 D C B1 B A1 A -o Y -f Y=!(F&E&!D2&!D1&!D&!C&!B1&!B&!A1&!A|F&E&D2&!D1&!D&!C&!B1&!B&!A1&!A|F&E&D2&D1&!D&!C&!B1&!B&!A1&!A|F&E&!D2&D1&!D&!C&!B1&!B&!A1&!A|F&E&!D2&D1&D&!C&!B1&!B&!A1&!A|F&E&D2&D1&D&!C&!B1&!B&!A1&!A|F&E&D2&!D1&D&!C&!B1&!B&!A1&!A|F&E&!D2&!D1&D&!C&!B1&!B&!A1&!A|F&!E&!D2&!D1&D&C&!B1&!B&!A1&!A|F&E&!D2&!D1&D&C&!B1&!B&!A1&!A|F&E&D2&!D1&D&C&!B1&!B&!A1&!A|F&!E&D2&!D1&D&C&!B1&!B&!A1&!A|F&!E&D2&D1&D&C&!B1&!B&!A1&!A|F&E&D2&D1&D&C&!B1&!B&!A1&!A|F&E&!D2&D1&D&C&!B1&!B&!A1&!A|F&!E&!D2&D1&D&C&!B1&!B&!A1&!A|F&!E&!D2&D1&!D&C&!B1&!B&!A1&!A|F&E&!D2&D1&!D&C&!B1&!B&!A1&!A|F&E&D2&D1&!D&C&!B1&!B&!A1&!A|F&!E&D2&D1&!D&C&!B1&!B&!A1&!A|F&!E&D2&!D1&!D&C&!B1&!B&!A1&!A|F&E&D2&!D1&!D&C&!B1&!B&!A1&!A|F&E&!D2&!D1&!D&C&!B1&!B&!A1&!A|F&E&!D2&!D1&!D&C&B1&!B&!A1&!A|F&E&D2&!D1&!D&C&B1&!B&!A1&!A|F&!E&D2&!D1&!D&C&B1&!B&!A1&!A|F&!E&D2&D1&!D&C&B1&!B&!A1&!A|F&E&D2&D1&!D&C&B1&!B&!A1&!A|F&E&!D2&D1&!D&C&B1&!B&!A1&!A|F&!E&!D2&D1&!D&C&B1&!B&!A1&!A|F&!E&!D2&D1&D&C&B1&!B&!A1&!A|F&E&!D2&D1&D&C&B1&!B&!A1&!A|F&E&D2&D1&D&C&B1&!B&!A1&!A|F&!E&D2&D1&D&C&B1&!B&!A1&!A|F&!E&D2&!D1&D&C&B1&!B&!A1&!A|F&E&D2&!D1&D&C&B1&!B&!A1&!A|F&E&!D2&!D1&D&C&B1&!B&!A1&!A|F&!E&!D2&!D1&D&C&B1&!B&!A1&!A|F&E&!D2&!D1&D&!C&B1&!B&!A1&!A|F&E&D2&!D1&D&!C&B1&!B&!A1&!A|F&E&D2&D1&D&!C&B1&!B&!A1&!A|F&E&!D2&D1&D&!C&B1&!B&!A1&!A|F&E&!D2&D1&!D&!C&B1&!B&!A1&!A|F&E&D2&D1&!D&!C&B1&!B&!A1&!A|F&E&D2&!D1&!D&!C&B1&!B&!A1&!A|F&E&!D2&!D1&!D&!C&B1&!B&!A1&!A|F&E&!D2&!D1&!D&!C&B1&B&!A1&!A|F&E&D2&!D1&!D&!C&B1&B&!A1&!A|F&!E&D2&!D1&!D&!C&B1&B&!A1&!A|F&!E&D2&D1&!D&!C&B1&B&!A1&!A|F&E&D2&D1&!D&!C&B1&B&!A1&!A|F&E&!D2&D1&!D&!C&B1&B&!A1&!A|F&!E&!D2&D1&!D&!C&B1&B&!A1&!A|F&!E&!D2&D1&D&!C&B1&B&!A1&!A|F&E&!D2&D1&D&!C&B1&B&!A1&!A|F&E&D2&D1&D&!C&B1&B&!A1&!A|F&!E&D2&D1&D&!C&B1&B&!A1&!A|F&!E&D2&!D1&D&!C&B1&B&!A1&!A|F&E&D2&!D1&D&!C&B1&B&!A1&!A|F&E&!D2&!D1&D&!C&B1&B&!A1&!A|F&!E&!D2&!D1&D&!C&B1&B&!A1&!A|F&!E&!D2&!D1&D&C&B1&B&!A1&!A|F&E&!D2&!D1&D&C&B1&B&!A1&!A|F&E&D2&!D1&D&C&B1&B&!A1&!A|F&!E&D2&!D1&D&C&B1&B&!A1&!A|F&!E&D2&D1&D&C&B1&B&!A1&!A|F&E&D2&D1&D&C&B1&B&!A1&!A|F&E&!D2&D1&D&C&B1&B&!A1&!A|F&!E&!D2&D1&D&C&B1&B&!A1&!A|F&!E&!D2&D1&!D&C&B1&B&!A1&!A|F&E&!D2&D1&!D&C&B1&B&!A1&!A|F&E&D2&D1&!D&C&B1&B&!A1&!A|F&!E&D2&D1&!D&C&B1&B&!A1&!A|F&!E&D2&!D1&!D&C&B1&B&!A1&!A|F&E&D2&!D1&!D&C&B1&B&!A1&!A|F&E&!D2&!D1&!D&C&B1&B&!A1&!A|F&E&!D2&!D1&!D&C&!B1&B&!A1&!A|F&E&D2&!D1&!D&C&!B1&B&!A1&!A|F&!E&D2&!D1&!D&C&!B1&B&!A1&!A|F&!E&D2&D1&!D&C&!B1&B&!A1&!A|F&E&D2&D1&!D&C&!B1&B&!A1&!A|F&E&!D2&D1&!D&C&!B1&B&!A1&!A|F&!E&!D2&D1&!D&C&!B1&B&!A1&!A|F&!E&!D2&D1&D&C&!B1&B&!A1&!A|F&E&!D2&D1&D&C&!B1&B&!A1&!A|F&E&D2&D1&D&C&!B1&B&!A1&!A|F&!E&D2&D1&D&C&!B1&B&!A1&!A|F&!E&D2&!D1&D&C&!B1&B&!A1&!A|F&E&D2&!D1&D&C&!B1&B&!A1&!A|F&E&!D2&!D1&D&C&!B1&B&!A1&!A|F&!E&!D2&!D1&D&C&!B1&B&!A1&!A|F&E&!D2&!D1&D&!C&!B1&B&!A1&!A|F&E&D2&!D1&D&!C&!B1&B&!A1&!A|F&E&D2&D1&D&!C&!B1&B&!A1&!A|F&E&!D2&D1&D&!C&!B1&B&!A1&!A|F&E&!D2&D1&!D&!C&!B1&B&!A1&!A|F&E&D2&D1&!D&!C&!B1&B&!A1&!A|F&E&D2&!D1&!D&!C&!B1&B&!A1&!A|F&E&!D2&!D1&!D&!C&!B1&B&!A1&!A|F&E&!D2&!D1&!D&!C&!B1&B&A1&!A|F&E&D2&!D1&!D&!C&!B1&B&A1&!A|F&E&D2&D1&!D&!C&!B1&B&A1&!A|F&E&!D2&D1&!D&!C&!B1&B&A1&!A|F&E&!D2&D1&D&!C&!B1&B&A1&!A|F&E&D2&D1&D&!C&!B1&B&A1&!A|F&E&D2&!D1&D&!C&!B1&B&A1&!A|F&E&!D2&!D1&D&!C&!B1&B&A1&!A|F&!E&!D2&!D1&D&C&!B1&B&A1&!A|F&E&!D2&!D1&D&C&!B1&B&A1&!A|F&E&D2&!D1&D&C&!B1&B&A1&!A|F&!E&D2&!D1&D&C&!B1&B&A1&!A|F&!E&D2&D1&D&C&!B1&B&A1&!A|F&E&D2&D1&D&C&!B1&B&A1&!A|F&E&!D2&D1&D&C&!B1&B&A1&!A|F&!E&!D2&D1&D&C&!B1&B&A1&!A|F&!E&!D2&D1&!D&C&!B1&B&A1&!A|F&E&!D2&D1&!D&C&!B1&B&A1&!A|F&E&D2&D1&!D&C&!B1&B&A1&!A|F&!E&D2&D1&!D&C&!B1&B&A1&!A|F&!E&D2&!D1&!D&C&!B1&B&A1&!A|F&E&D2&!D1&!D&C&!B1&B&A1&!A|F&E&!D2&!D1&!D&C&!B1&B&A1&!A|F&E&!D2&!D1&!D&C&B1&B&A1&!A|F&E&D2&!D1&!D&C&B1&B&A1&!A|F&!E&D2&!D1&!D&C&B1&B&A1&!A|F&!E&D2&D1&!D&C&B1&B&A1&!A|F&E&D2&D1&!D&C&B1&B&A1&!A|F&E&!D2&D1&!D&C&B1&B&A1&!A|F&!E&!D2&D1&!D&C&B1&B&A1&!A|F&!E&!D2&D1&D&C&B1&B&A1&!A|F&E&!D2&D1&D&C&B1&B&A1&!A|F&E&D2&D1&D&C&B1&B&A1&!A|F&!E&D2&D1&D&C&B1&B&A1&!A|F&!E&D2&!D1&D&C&B1&B&A1&!A|F&E&D2&!D1&D&C&B1&B&A1&!A|F&E&!D2&!D1&D&C&B1&B&A1&!A|F&!E&!D2&!D1&D&C&B1&B&A1&!A|F&!E&!D2&!D1&D&!C&B1&B&A1&!A|F&E&!D2&!D1&D&!C&B1&B&A1&!A|F&E&D2&!D1&D&!C&B1&B&A1&!A|F&!E&D2&!D1&D&!C&B1&B&A1&!A|F&!E&D2&D1&D&!C&B1&B&A1&!A|F&E&D2&D1&D&!C&B1&B&A1&!A|F&E&!D2&D1&D&!C&B1&B&A1&!A|F&!E&!D2&D1&D&!C&B1&B&A1&!A|F&!E&!D2&D1&!D&!C&B1&B&A1&!A|F&E&!D2&D1&!D&!C&B1&B&A1&!A|F&E&D2&D1&!D&!C&B1&B&A1&!A|F&!E&D2&D1&!D&!C&B1&B&A1&!A|F&!E&D2&!D1&!D&!C&B1&B&A1&!A|F&E&D2&!D1&!D&!C&B1&B&A1&!A|F&E&!D2&!D1&!D&!C&B1&B&A1&!A|F&E&!D2&!D1&!D&!C&B1&!B&A1&!A|F&E&D2&!D1&!D&!C&B1&!B&A1&!A|F&E&D2&D1&!D&!C&B1&!B&A1&!A|F&E&!D2&D1&!D&!C&B1&!B&A1&!A|F&E&!D2&D1&D&!C&B1&!B&A1&!A|F&E&D2&D1&D&!C&B1&!B&A1&!A|F&E&D2&!D1&D&!C&B1&!B&A1&!A|F&E&!D2&!D1&D&!C&B1&!B&A1&!A|F&!E&!D2&!D1&D&C&B1&!B&A1&!A|F&E&!D2&!D1&D&C&B1&!B&A1&!A|F&E&D2&!D1&D&C&B1&!B&A1&!A|F&!E&D2&!D1&D&C&B1&!B&A1&!A|F&!E&D2&D1&D&C&B1&!B&A1&!A|F&E&D2&D1&D&C&B1&!B&A1&!A|F&E&!D2&D1&D&C&B1&!B&A1&!A|F&!E&!D2&D1&D&C&B1&!B&A1&!A|F&!E&!D2&D1&!D&C&B1&!B&A1&!A|F&E&!D2&D1&!D&C&B1&!B&A1&!A|F&E&D2&D1&!D&C&B1&!B&A1&!A|F&!E&D2&D1&!D&C&B1&!B&A1&!A|F&!E&D2&!D1&!D&C&B1&!B&A1&!A|F&E&D2&!D1&!D&C&B1&!B&A1&!A|F&E&!D2&!D1&!D&C&B1&!B&A1&!A|F&E&!D2&!D1&!D&C&!B1&!B&A1&!A|F&E&D2&!D1&!D&C&!B1&!B&A1&!A|F&!E&D2&!D1&!D&C&!B1&!B&A1&!A|F&!E&D2&D1&!D&C&!B1&!B&A1&!A|F&E&D2&D1&!D&C&!B1&!B&A1&!A|F&E&!D2&D1&!D&C&!B1&!B&A1&!A|F&!E&!D2&D1&!D&C&!B1&!B&A1&!A|F&!E&!D2&D1&D&C&!B1&!B&A1&!A|F&E&!D2&D1&D&C&!B1&!B&A1&!A|F&E&D2&D1&D&C&!B1&!B&A1&!A|F&!E&D2&D1&D&C&!B1&!B&A1&!A|F&!E&D2&!D1&D&C&!B1&!B&A1&!A|F&E&D2&!D1&D&C&!B1&!B&A1&!A|F&E&!D2&!D1&D&C&!B1&!B&A1&!A|F&!E&!D2&!D1&D&C&!B1&!B&A1&!A|F&E&!D2&!D1&D&!C&!B1&!B&A1&!A|F&E&D2&!D1&D&!C&!B1&!B&A1&!A|F&E&D2&D1&D&!C&!B1&!B&A1&!A|F&E&!D2&D1&D&!C&!B1&!B&A1&!A|F&E&!D2&D1&!D&!C&!B1&!B&A1&!A|F&E&D2&D1&!D&!C&!B1&!B&A1&!A|F&E&D2&!D1&!D&!C&!B1&!B&A1&!A|F&E&!D2&!D1&!D&!C&!B1&!B&A1&!A|F&E&!D2&!D1&!D&!C&!B1&!B&A1&A|F&E&D2&!D1&!D&!C&!B1&!B&A1&A|F&!E&D2&!D1&!D&!C&!B1&!B&A1&A|F&!E&D2&D1&!D&!C&!B1&!B&A1&A|F&E&D2&D1&!D&!C&!B1&!B&A1&A|F&E&!D2&D1&!D&!C&!B1&!B&A1&A|F&!E&!D2&D1&!D&!C&!B1&!B&A1&A|F&!E&!D2&D1&D&!C&!B1&!B&A1&A|F&E&!D2&D1&D&!C&!B1&!B&A1&A|F&E&D2&D1&D&!C&!B1&!B&A1&A|F&!E&D2&D1&D&!C&!B1&!B&A1&A|F&!E&D2&!D1&D&!C&!B1&!B&A1&A|F&E&D2&!D1&D&!C&!B1&!B&A1&A|F&E&!D2&!D1&D&!C&!B1&!B&A1&A|F&!E&!D2&!D1&D&!C&!B1&!B&A1&A|F&!E&!D2&!D1&D&C&!B1&!B&A1&A|F&E&!D2&!D1&D&C&!B1&!B&A1&A|F&E&D2&!D1&D&C&!B1&!B&A1&A|F&!E&D2&!D1&D&C&!B1&!B&A1&A|F&!E&D2&D1&D&C&!B1&!B&A1&A|F&E&D2&D1&D&C&!B1&!B&A1&A|F&E&!D2&D1&D&C&!B1&!B&A1&A|F&!E&!D2&D1&D&C&!B1&!B&A1&A|F&!E&!D2&D1&!D&C&!B1&!B&A1&A|F&E&!D2&D1&!D&C&!B1&!B&A1&A|F&E&D2&D1&!D&C&!B1&!B&A1&A|F&!E&D2&D1&!D&C&!B1&!B&A1&A|F&!E&D2&!D1&!D&C&!B1&!B&A1&A|F&E&D2&!D1&!D&C&!B1&!B&A1&A|F&E&!D2&!D1&!D&C&!B1&!B&A1&A|F&E&!D2&!D1&!D&C&B1&!B&A1&A|F&E&D2&!D1&!D&C&B1&!B&A1&A|F&!E&D2&!D1&!D&C&B1&!B&A1&A|F&!E&D2&D1&!D&C&B1&!B&A1&A|F&E&D2&D1&!D&C&B1&!B&A1&A|F&E&!D2&D1&!D&C&B1&!B&A1&A|F&!E&!D2&D1&!D&C&B1&!B&A1&A|F&!E&!D2&D1&D&C&B1&!B&A1&A|F&E&!D2&D1&D&C&B1&!B&A1&A|F&E&D2&D1&D&C&B1&!B&A1&A|F&!E&D2&D1&D&C&B1&!B&A1&A|F&!E&D2&!D1&D&C&B1&!B&A1&A|F&E&D2&!D1&D&C&B1&!B&A1&A|F&E&!D2&!D1&D&C&B1&!B&A1&A|F&!E&!D2&!D1&D&C&B1&!B&A1&A|F&!E&!D2&!D1&D&!C&B1&!B&A1&A|F&E&!D2&!D1&D&!C&B1&!B&A1&A|F&E&D2&!D1&D&!C&B1&!B&A1&A|F&!E&D2&!D1&D&!C&B1&!B&A1&A|F&!E&D2&D1&D&!C&B1&!B&A1&A|F&E&D2&D1&D&!C&B1&!B&A1&A|F&E&!D2&D1&D&!C&B1&!B&A1&A|F&!E&!D2&D1&D&!C&B1&!B&A1&A|F&!E&!D2&D1&!D&!C&B1&!B&A1&A|F&E&!D2&D1&!D&!C&B1&!B&A1&A|F&E&D2&D1&!D&!C&B1&!B&A1&A|F&!E&D2&D1&!D&!C&B1&!B&A1&A|F&!E&D2&!D1&!D&!C&B1&!B&A1&A|F&E&D2&!D1&!D&!C&B1&!B&A1&A|F&E&!D2&!D1&!D&!C&B1&!B&A1&A|F&E&!D2&!D1&!D&!C&B1&B&A1&A|F&E&D2&!D1&!D&!C&B1&B&A1&A|F&!E&D2&!D1&!D&!C&B1&B&A1&A|F&!E&D2&D1&!D&!C&B1&B&A1&A|F&E&D2&D1&!D&!C&B1&B&A1&A|F&E&!D2&D1&!D&!C&B1&B&A1&A|F&!E&!D2&D1&!D&!C&B1&B&A1&A|F&!E&!D2&D1&D&!C&B1&B&A1&A|F&E&!D2&D1&D&!C&B1&B&A1&A|F&E&D2&D1&D&!C&B1&B&A1&A|F&!E&D2&D1&D&!C&B1&B&A1&A|F&!E&D2&!D1&D&!C&B1&B&A1&A|F&E&D2&!D1&D&!C&B1&B&A1&A|F&E&!D2&!D1&D&!C&B1&B&A1&A|F&!E&!D2&!D1&D&!C&B1&B&A1&A|F&!E&!D2&!D1&D&C&B1&B&A1&A|F&E&!D2&!D1&D&C&B1&B&A1&A|F&E&D2&!D1&D&C&B1&B&A1&A|F&!E&D2&!D1&D&C&B1&B&A1&A|F&!E&D2&D1&D&C&B1&B&A1&A|F&E&D2&D1&D&C&B1&B&A1&A|F&E&!D2&D1&D&C&B1&B&A1&A|F&!E&!D2&D1&D&C&B1&B&A1&A|F&!E&!D2&D1&!D&C&B1&B&A1&A|F&E&!D2&D1&!D&C&B1&B&A1&A|F&E&D2&D1&!D&C&B1&B&A1&A|F&!E&D2&D1&!D&C&B1&B&A1&A|F&!E&D2&!D1&!D&C&B1&B&A1&A|F&E&D2&!D1&!D&C&B1&B&A1&A|F&E&!D2&!D1&!D&C&B1&B&A1&A|F&E&!D2&!D1&!D&C&!B1&B&A1&A|F&E&D2&!D1&!D&C&!B1&B&A1&A|F&!E&D2&!D1&!D&C&!B1&B&A1&A|F&!E&D2&D1&!D&C&!B1&B&A1&A|F&E&D2&D1&!D&C&!B1&B&A1&A|F&E&!D2&D1&!D&C&!B1&B&A1&A|F&!E&!D2&D1&!D&C&!B1&B&A1&A|F&!E&!D2&D1&D&C&!B1&B&A1&A|F&E&!D2&D1&D&C&!B1&B&A1&A|F&E&D2&D1&D&C&!B1&B&A1&A|F&!E&D2&D1&D&C&!B1&B&A1&A|F&!E&D2&!D1&D&C&!B1&B&A1&A|F&E&D2&!D1&D&C&!B1&B&A1&A|F&E&!D2&!D1&D&C&!B1&B&A1&A|F&!E&!D2&!D1&D&C&!B1&B&A1&A|F&!E&!D2&!D1&D&!C&!B1&B&A1&A|F&E&!D2&!D1&D&!C&!B1&B&A1&A|F&E&D2&!D1&D&!C&!B1&B&A1&A|F&!E&D2&!D1&D&!C&!B1&B&A1&A|F&!E&D2&D1&D&!C&!B1&B&A1&A|F&E&D2&D1&D&!C&!B1&B&A1&A|F&E&!D2&D1&D&!C&!B1&B&A1&A|F&!E&!D2&D1&D&!C&!B1&B&A1&A|F&!E&!D2&D1&!D&!C&!B1&B&A1&A|F&E&!D2&D1&!D&!C&!B1&B&A1&A|F&E&D2&D1&!D&!C&!B1&B&A1&A|F&!E&D2&D1&!D&!C&!B1&B&A1&A|F&!E&D2&!D1&!D&!C&!B1&B&A1&A|F&E&D2&!D1&!D&!C&!B1&B&A1&A|F&E&!D2&!D1&!D&!C&!B1&B&A1&A|F&E&!D2&!D1&!D&!C&!B1&B&!A1&A|F&E&D2&!D1&!D&!C&!B1&B&!A1&A|F&E&D2&D1&!D&!C&!B1&B&!A1&A|F&E&!D2&D1&!D&!C&!B1&B&!A1&A|F&E&!D2&D1&D&!C&!B1&B&!A1&A|F&E&D2&D1&D&!C&!B1&B&!A1&A|F&E&D2&!D1&D&!C&!B1&B&!A1&A|F&E&!D2&!D1&D&!C&!B1&B&!A1&A|F&!E&!D2&!D1&D&C&!B1&B&!A1&A|F&E&!D2&!D1&D&C&!B1&B&!A1&A|F&E&D2&!D1&D&C&!B1&B&!A1&A|F&!E&D2&!D1&D&C&!B1&B&!A1&A|F&!E&D2&D1&D&C&!B1&B&!A1&A|F&E&D2&D1&D&C&!B1&B&!A1&A|F&E&!D2&D1&D&C&!B1&B&!A1&A|F&!E&!D2&D1&D&C&!B1&B&!A1&A|F&!E&!D2&D1&!D&C&!B1&B&!A1&A|F&E&!D2&D1&!D&C&!B1&B&!A1&A|F&E&D2&D1&!D&C&!B1&B&!A1&A|F&!E&D2&D1&!D&C&!B1&B&!A1&A|F&!E&D2&!D1&!D&C&!B1&B&!A1&A|F&E&D2&!D1&!D&C&!B1&B&!A1&A|F&E&!D2&!D1&!D&C&!B1&B&!A1&A|F&E&!D2&!D1&!D&C&B1&B&!A1&A|F&E&D2&!D1&!D&C&B1&B&!A1&A|F&!E&D2&!D1&!D&C&B1&B&!A1&A|F&!E&D2&D1&!D&C&B1&B&!A1&A|F&E&D2&D1&!D&C&B1&B&!A1&A|F&E&!D2&D1&!D&C&B1&B&!A1&A|F&!E&!D2&D1&!D&C&B1&B&!A1&A|F&!E&!D2&D1&D&C&B1&B&!A1&A|F&E&!D2&D1&D&C&B1&B&!A1&A|F&E&D2&D1&D&C&B1&B&!A1&A|F&!E&D2&D1&D&C&B1&B&!A1&A|F&!E&D2&!D1&D&C&B1&B&!A1&A|F&E&D2&!D1&D&C&B1&B&!A1&A|F&E&!D2&!D1&D&C&B1&B&!A1&A|F&!E&!D2&!D1&D&C&B1&B&!A1&A|F&!E&!D2&!D1&D&!C&B1&B&!A1&A|F&E&!D2&!D1&D&!C&B1&B&!A1&A|F&E&D2&!D1&D&!C&B1&B&!A1&A|F&!E&D2&!D1&D&!C&B1&B&!A1&A|F&!E&D2&D1&D&!C&B1&B&!A1&A|F&E&D2&D1&D&!C&B1&B&!A1&A|F&E&!D2&D1&D&!C&B1&B&!A1&A|F&!E&!D2&D1&D&!C&B1&B&!A1&A|F&!E&!D2&D1&!D&!C&B1&B&!A1&A|F&E&!D2&D1&!D&!C&B1&B&!A1&A|F&E&D2&D1&!D&!C&B1&B&!A1&A|F&!E&D2&D1&!D&!C&B1&B&!A1&A|F&!E&D2&!D1&!D&!C&B1&B&!A1&A|F&E&D2&!D1&!D&!C&B1&B&!A1&A|F&E&!D2&!D1&!D&!C&B1&B&!A1&A|F&E&!D2&!D1&!D&!C&B1&!B&!A1&A|F&E&D2&!D1&!D&!C&B1&!B&!A1&A|F&E&D2&D1&!D&!C&B1&!B&!A1&A|F&E&!D2&D1&!D&!C&B1&!B&!A1&A|F&E&!D2&D1&D&!C&B1&!B&!A1&A|F&E&D2&D1&D&!C&B1&!B&!A1&A|F&E&D2&!D1&D&!C&B1&!B&!A1&A|F&E&!D2&!D1&D&!C&B1&!B&!A1&A|F&!E&!D2&!D1&D&C&B1&!B&!A1&A|F&E&!D2&!D1&D&C&B1&!B&!A1&A|F&E&D2&!D1&D&C&B1&!B&!A1&A|F&!E&D2&!D1&D&C&B1&!B&!A1&A|F&!E&D2&D1&D&C&B1&!B&!A1&A|F&E&D2&D1&D&C&B1&!B&!A1&A|F&E&!D2&D1&D&C&B1&!B&!A1&A|F&!E&!D2&D1&D&C&B1&!B&!A1&A|F&!E&!D2&D1&!D&C&B1&!B&!A1&A|F&E&!D2&D1&!D&C&B1&!B&!A1&A|F&E&D2&D1&!D&C&B1&!B&!A1&A|F&!E&D2&D1&!D&C&B1&!B&!A1&A|F&!E&D2&!D1&!D&C&B1&!B&!A1&A|F&E&D2&!D1&!D&C&B1&!B&!A1&A|F&E&!D2&!D1&!D&C&B1&!B&!A1&A|F&E&!D2&!D1&!D&C&!B1&!B&!A1&A|F&E&D2&!D1&!D&C&!B1&!B&!A1&A|F&!E&D2&!D1&!D&C&!B1&!B&!A1&A|F&!E&D2&D1&!D&C&!B1&!B&!A1&A|F&E&D2&D1&!D&C&!B1&!B&!A1&A|F&E&!D2&D1&!D&C&!B1&!B&!A1&A|F&!E&!D2&D1&!D&C&!B1&!B&!A1&A|F&!E&!D2&D1&D&C&!B1&!B&!A1&A|F&E&!D2&D1&D&C&!B1&!B&!A1&A|F&E&D2&D1&D&C&!B1&!B&!A1&A|F&!E&D2&D1&D&C&!B1&!B&!A1&A|F&!E&D2&!D1&D&C&!B1&!B&!A1&A|F&E&D2&!D1&D&C&!B1&!B&!A1&A|F&E&!D2&!D1&D&C&!B1&!B&!A1&A|F&!E&!D2&!D1&D&C&!B1&!B&!A1&A|F&E&!D2&!D1&D&!C&!B1&!B&!A1&A|F&E&D2&!D1&D&!C&!B1&!B&!A1&A|F&E&D2&D1&D&!C&!B1&!B&!A1&A|F&E&!D2&D1&D&!C&!B1&!B&!A1&A|F&E&!D2&D1&!D&!C&!B1&!B&!A1&A|F&E&D2&D1&!D&!C&!B1&!B&!A1&A|F&E&D2&!D1&!D&!C&!B1&!B&!A1&A|F&E&!D2&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAOAI221311.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAAOI2122 -l OAAAOI2122 -i D1 D C1 C B A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B&!A1&!A|D1&!D&!C1&!C&!B&!A1&!A|!D1&D&!C1&!C&!B&!A1&!A|!D1&D&C1&!C&!B&!A1&!A|D1&!D&C1&!C&!B&!A1&!A|!D1&!D&C1&!C&!B&!A1&!A|!D1&D&!C1&C&!B&!A1&!A|D1&!D&!C1&C&!B&!A1&!A|!D1&!D&!C1&C&!B&!A1&!A|!D1&!D&!C1&C&B&!A1&!A|D1&!D&!C1&C&B&!A1&!A|!D1&D&!C1&C&B&!A1&!A|!D1&!D&C1&!C&B&!A1&!A|D1&!D&C1&!C&B&!A1&!A|!D1&D&C1&!C&B&!A1&!A|!D1&D&!C1&!C&B&!A1&!A|D1&!D&!C1&!C&B&!A1&!A|!D1&!D&!C1&!C&B&!A1&!A|!D1&!D&!C1&C&!B&A1&!A|D1&!D&!C1&C&!B&A1&!A|!D1&D&!C1&C&!B&A1&!A|!D1&!D&C1&!C&!B&A1&!A|D1&!D&C1&!C&!B&A1&!A|!D1&D&C1&!C&!B&A1&!A|!D1&D&!C1&!C&!B&A1&!A|D1&!D&!C1&!C&!B&A1&!A|!D1&!D&!C1&!C&!B&A1&!A|!D1&!D&!C1&!C&!B&A1&A|D1&!D&!C1&!C&!B&A1&A|!D1&D&!C1&!C&!B&A1&A|!D1&D&C1&!C&!B&A1&A|D1&!D&C1&!C&!B&A1&A|!D1&!D&C1&!C&!B&A1&A|!D1&D&!C1&C&!B&A1&A|D1&!D&!C1&C&!B&A1&A|!D1&!D&!C1&C&!B&A1&A|!D1&!D&!C1&C&!B&!A1&A|D1&!D&!C1&C&!B&!A1&A|!D1&D&!C1&C&!B&!A1&A|!D1&!D&C1&!C&!B&!A1&A|D1&!D&C1&!C&!B&!A1&A|!D1&D&C1&!C&!B&!A1&A|!D1&D&!C1&!C&!B&!A1&A|D1&!D&!C1&!C&!B&!A1&A|!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAAOI2122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOAAOI211212 -l AOAAOAAOI211212 -i F1 F E D1 D C B A1 A -o Y -f Y=!(F1&F&!E&!D1&!D&!C&!B&!A1&!A|F1&F&E&!D1&!D&!C&!B&!A1&!A|F1&F&E&D1&!D&!C&!B&!A1&!A|F1&F&!E&D1&!D&!C&!B&!A1&!A|F1&F&!E&D1&D&!C&!B&!A1&!A|!F1&F&E&D1&D&!C&!B&!A1&!A|F1&F&E&D1&D&!C&!B&!A1&!A|F1&!F&E&D1&D&!C&!B&!A1&!A|!F1&!F&E&D1&D&!C&!B&!A1&!A|F1&F&E&!D1&D&!C&!B&!A1&!A|F1&F&!E&!D1&D&!C&!B&!A1&!A|F1&F&!E&!D1&D&C&!B&!A1&!A|F1&F&E&!D1&D&C&!B&!A1&!A|!F1&!F&E&D1&D&C&!B&!A1&!A|F1&!F&E&D1&D&C&!B&!A1&!A|F1&F&E&D1&D&C&!B&!A1&!A|!F1&F&E&D1&D&C&!B&!A1&!A|F1&F&!E&D1&D&C&!B&!A1&!A|F1&F&!E&D1&!D&C&!B&!A1&!A|F1&F&E&D1&!D&C&!B&!A1&!A|F1&F&E&!D1&!D&C&!B&!A1&!A|F1&F&!E&!D1&!D&C&!B&!A1&!A|F1&F&!E&!D1&!D&C&B&!A1&!A|!F1&F&E&!D1&!D&C&B&!A1&!A|F1&F&E&!D1&!D&C&B&!A1&!A|F1&!F&E&!D1&!D&C&B&!A1&!A|!F1&!F&E&!D1&!D&C&B&!A1&!A|!F1&!F&E&D1&!D&C&B&!A1&!A|F1&!F&E&D1&!D&C&B&!A1&!A|F1&F&E&D1&!D&C&B&!A1&!A|!F1&F&E&D1&!D&C&B&!A1&!A|F1&F&!E&D1&!D&C&B&!A1&!A|F1&F&!E&D1&D&C&B&!A1&!A|!F1&F&E&D1&D&C&B&!A1&!A|F1&F&E&D1&D&C&B&!A1&!A|F1&!F&E&D1&D&C&B&!A1&!A|!F1&!F&E&D1&D&C&B&!A1&!A|!F1&!F&E&!D1&D&C&B&!A1&!A|F1&!F&E&!D1&D&C&B&!A1&!A|F1&F&E&!D1&D&C&B&!A1&!A|!F1&F&E&!D1&D&C&B&!A1&!A|F1&F&!E&!D1&D&C&B&!A1&!A|F1&F&!E&!D1&D&!C&B&!A1&!A|F1&F&E&!D1&D&!C&B&!A1&!A|!F1&!F&E&D1&D&!C&B&!A1&!A|F1&!F&E&D1&D&!C&B&!A1&!A|F1&F&E&D1&D&!C&B&!A1&!A|!F1&F&E&D1&D&!C&B&!A1&!A|F1&F&!E&D1&D&!C&B&!A1&!A|F1&F&!E&D1&!D&!C&B&!A1&!A|F1&F&E&D1&!D&!C&B&!A1&!A|F1&F&E&!D1&!D&!C&B&!A1&!A|F1&F&!E&!D1&!D&!C&B&!A1&!A|F1&F&!E&!D1&!D&!C&B&A1&!A|F1&F&E&!D1&!D&!C&B&A1&!A|F1&F&E&D1&!D&!C&B&A1&!A|F1&F&!E&D1&!D&!C&B&A1&!A|F1&F&!E&D1&D&!C&B&A1&!A|!F1&F&E&D1&D&!C&B&A1&!A|F1&F&E&D1&D&!C&B&A1&!A|F1&!F&E&D1&D&!C&B&A1&!A|!F1&!F&E&D1&D&!C&B&A1&!A|F1&F&E&!D1&D&!C&B&A1&!A|F1&F&!E&!D1&D&!C&B&A1&!A|F1&F&!E&!D1&D&C&B&A1&!A|!F1&F&E&!D1&D&C&B&A1&!A|F1&F&E&!D1&D&C&B&A1&!A|F1&!F&E&!D1&D&C&B&A1&!A|!F1&!F&E&!D1&D&C&B&A1&!A|!F1&!F&E&D1&D&C&B&A1&!A|F1&!F&E&D1&D&C&B&A1&!A|F1&F&E&D1&D&C&B&A1&!A|!F1&F&E&D1&D&C&B&A1&!A|F1&F&!E&D1&D&C&B&A1&!A|F1&F&!E&D1&!D&C&B&A1&!A|!F1&F&E&D1&!D&C&B&A1&!A|F1&F&E&D1&!D&C&B&A1&!A|F1&!F&E&D1&!D&C&B&A1&!A|!F1&!F&E&D1&!D&C&B&A1&!A|!F1&!F&E&!D1&!D&C&B&A1&!A|F1&!F&E&!D1&!D&C&B&A1&!A|F1&F&E&!D1&!D&C&B&A1&!A|!F1&F&E&!D1&!D&C&B&A1&!A|F1&F&!E&!D1&!D&C&B&A1&!A|F1&F&!E&!D1&!D&C&!B&A1&!A|F1&F&E&!D1&!D&C&!B&A1&!A|F1&F&E&D1&!D&C&!B&A1&!A|F1&F&!E&D1&!D&C&!B&A1&!A|F1&F&!E&D1&D&C&!B&A1&!A|!F1&F&E&D1&D&C&!B&A1&!A|F1&F&E&D1&D&C&!B&A1&!A|F1&!F&E&D1&D&C&!B&A1&!A|!F1&!F&E&D1&D&C&!B&A1&!A|F1&F&E&!D1&D&C&!B&A1&!A|F1&F&!E&!D1&D&C&!B&A1&!A|F1&F&!E&!D1&D&!C&!B&A1&!A|F1&F&E&!D1&D&!C&!B&A1&!A|!F1&!F&E&D1&D&!C&!B&A1&!A|F1&!F&E&D1&D&!C&!B&A1&!A|F1&F&E&D1&D&!C&!B&A1&!A|!F1&F&E&D1&D&!C&!B&A1&!A|F1&F&!E&D1&D&!C&!B&A1&!A|F1&F&!E&D1&!D&!C&!B&A1&!A|F1&F&E&D1&!D&!C&!B&A1&!A|F1&F&E&!D1&!D&!C&!B&A1&!A|F1&F&!E&!D1&!D&!C&!B&A1&!A|F1&F&!E&!D1&!D&!C&!B&A1&A|F1&F&E&!D1&!D&!C&!B&A1&A|F1&F&E&D1&!D&!C&!B&A1&A|F1&F&!E&D1&!D&!C&!B&A1&A|F1&F&!E&D1&D&!C&!B&A1&A|!F1&F&E&D1&D&!C&!B&A1&A|F1&F&E&D1&D&!C&!B&A1&A|F1&!F&E&D1&D&!C&!B&A1&A|!F1&!F&E&D1&D&!C&!B&A1&A|F1&F&E&!D1&D&!C&!B&A1&A|F1&F&!E&!D1&D&!C&!B&A1&A|F1&F&!E&!D1&D&C&!B&A1&A|!F1&F&E&!D1&D&C&!B&A1&A|F1&F&E&!D1&D&C&!B&A1&A|F1&!F&E&!D1&D&C&!B&A1&A|!F1&!F&E&!D1&D&C&!B&A1&A|!F1&!F&E&D1&D&C&!B&A1&A|F1&!F&E&D1&D&C&!B&A1&A|F1&F&E&D1&D&C&!B&A1&A|!F1&F&E&D1&D&C&!B&A1&A|F1&F&!E&D1&D&C&!B&A1&A|F1&F&!E&D1&!D&C&!B&A1&A|!F1&F&E&D1&!D&C&!B&A1&A|F1&F&E&D1&!D&C&!B&A1&A|F1&!F&E&D1&!D&C&!B&A1&A|!F1&!F&E&D1&!D&C&!B&A1&A|!F1&!F&E&!D1&!D&C&!B&A1&A|F1&!F&E&!D1&!D&C&!B&A1&A|F1&F&E&!D1&!D&C&!B&A1&A|!F1&F&E&!D1&!D&C&!B&A1&A|F1&F&!E&!D1&!D&C&!B&A1&A|F1&F&!E&!D1&!D&C&B&A1&A|!F1&F&E&!D1&!D&C&B&A1&A|F1&F&E&!D1&!D&C&B&A1&A|F1&!F&E&!D1&!D&C&B&A1&A|!F1&!F&E&!D1&!D&C&B&A1&A|!F1&!F&E&D1&!D&C&B&A1&A|F1&!F&E&D1&!D&C&B&A1&A|F1&F&E&D1&!D&C&B&A1&A|!F1&F&E&D1&!D&C&B&A1&A|F1&F&!E&D1&!D&C&B&A1&A|F1&F&!E&D1&D&C&B&A1&A|!F1&F&E&D1&D&C&B&A1&A|F1&F&E&D1&D&C&B&A1&A|F1&!F&E&D1&D&C&B&A1&A|!F1&!F&E&D1&D&C&B&A1&A|!F1&!F&E&!D1&D&C&B&A1&A|F1&!F&E&!D1&D&C&B&A1&A|F1&F&E&!D1&D&C&B&A1&A|!F1&F&E&!D1&D&C&B&A1&A|F1&F&!E&!D1&D&C&B&A1&A|F1&F&!E&!D1&D&!C&B&A1&A|F1&F&E&!D1&D&!C&B&A1&A|!F1&!F&E&D1&D&!C&B&A1&A|F1&!F&E&D1&D&!C&B&A1&A|F1&F&E&D1&D&!C&B&A1&A|!F1&F&E&D1&D&!C&B&A1&A|F1&F&!E&D1&D&!C&B&A1&A|F1&F&!E&D1&!D&!C&B&A1&A|F1&F&E&D1&!D&!C&B&A1&A|F1&F&E&!D1&!D&!C&B&A1&A|F1&F&!E&!D1&!D&!C&B&A1&A|F1&F&!E&!D1&!D&!C&B&!A1&A|F1&F&E&!D1&!D&!C&B&!A1&A|F1&F&E&D1&!D&!C&B&!A1&A|F1&F&!E&D1&!D&!C&B&!A1&A|F1&F&!E&D1&D&!C&B&!A1&A|!F1&F&E&D1&D&!C&B&!A1&A|F1&F&E&D1&D&!C&B&!A1&A|F1&!F&E&D1&D&!C&B&!A1&A|!F1&!F&E&D1&D&!C&B&!A1&A|F1&F&E&!D1&D&!C&B&!A1&A|F1&F&!E&!D1&D&!C&B&!A1&A|F1&F&!E&!D1&D&C&B&!A1&A|!F1&F&E&!D1&D&C&B&!A1&A|F1&F&E&!D1&D&C&B&!A1&A|F1&!F&E&!D1&D&C&B&!A1&A|!F1&!F&E&!D1&D&C&B&!A1&A|!F1&!F&E&D1&D&C&B&!A1&A|F1&!F&E&D1&D&C&B&!A1&A|F1&F&E&D1&D&C&B&!A1&A|!F1&F&E&D1&D&C&B&!A1&A|F1&F&!E&D1&D&C&B&!A1&A|F1&F&!E&D1&!D&C&B&!A1&A|!F1&F&E&D1&!D&C&B&!A1&A|F1&F&E&D1&!D&C&B&!A1&A|F1&!F&E&D1&!D&C&B&!A1&A|!F1&!F&E&D1&!D&C&B&!A1&A|!F1&!F&E&!D1&!D&C&B&!A1&A|F1&!F&E&!D1&!D&C&B&!A1&A|F1&F&E&!D1&!D&C&B&!A1&A|!F1&F&E&!D1&!D&C&B&!A1&A|F1&F&!E&!D1&!D&C&B&!A1&A|F1&F&!E&!D1&!D&C&!B&!A1&A|F1&F&E&!D1&!D&C&!B&!A1&A|F1&F&E&D1&!D&C&!B&!A1&A|F1&F&!E&D1&!D&C&!B&!A1&A|F1&F&!E&D1&D&C&!B&!A1&A|!F1&F&E&D1&D&C&!B&!A1&A|F1&F&E&D1&D&C&!B&!A1&A|F1&!F&E&D1&D&C&!B&!A1&A|!F1&!F&E&D1&D&C&!B&!A1&A|F1&F&E&!D1&D&C&!B&!A1&A|F1&F&!E&!D1&D&C&!B&!A1&A|F1&F&!E&!D1&D&!C&!B&!A1&A|F1&F&E&!D1&D&!C&!B&!A1&A|!F1&!F&E&D1&D&!C&!B&!A1&A|F1&!F&E&D1&D&!C&!B&!A1&A|F1&F&E&D1&D&!C&!B&!A1&A|!F1&F&E&D1&D&!C&!B&!A1&A|F1&F&!E&D1&D&!C&!B&!A1&A|F1&F&!E&D1&!D&!C&!B&!A1&A|F1&F&E&D1&!D&!C&!B&!A1&A|F1&F&E&!D1&!D&!C&!B&!A1&A|F1&F&!E&!D1&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOAAOI211212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOI2123 -l AOAAOI2123 -i D2 D1 D C1 C B A1 A -o Y -f Y=!(D2&D1&D&!C1&!C&!B&!A1&!A|D2&D1&D&C1&!C&!B&!A1&!A|D2&D1&D&C1&C&!B&!A1&!A|D2&D1&D&!C1&C&!B&!A1&!A|D2&D1&D&!C1&C&B&!A1&!A|!D2&!D1&D&C1&C&B&!A1&!A|D2&!D1&D&C1&C&B&!A1&!A|D2&D1&D&C1&C&B&!A1&!A|!D2&D1&D&C1&C&B&!A1&!A|!D2&D1&!D&C1&C&B&!A1&!A|D2&D1&!D&C1&C&B&!A1&!A|D2&!D1&!D&C1&C&B&!A1&!A|!D2&!D1&!D&C1&C&B&!A1&!A|D2&D1&D&C1&!C&B&!A1&!A|D2&D1&D&!C1&!C&B&!A1&!A|D2&D1&D&!C1&!C&B&A1&!A|D2&D1&D&C1&!C&B&A1&!A|!D2&!D1&!D&C1&C&B&A1&!A|D2&!D1&!D&C1&C&B&A1&!A|D2&D1&!D&C1&C&B&A1&!A|!D2&D1&!D&C1&C&B&A1&!A|!D2&D1&D&C1&C&B&A1&!A|D2&D1&D&C1&C&B&A1&!A|D2&!D1&D&C1&C&B&A1&!A|!D2&!D1&D&C1&C&B&A1&!A|D2&D1&D&!C1&C&B&A1&!A|D2&D1&D&!C1&C&!B&A1&!A|D2&D1&D&C1&C&!B&A1&!A|D2&D1&D&C1&!C&!B&A1&!A|D2&D1&D&!C1&!C&!B&A1&!A|D2&D1&D&!C1&!C&!B&A1&A|D2&D1&D&C1&!C&!B&A1&A|!D2&!D1&!D&C1&C&!B&A1&A|D2&!D1&!D&C1&C&!B&A1&A|D2&D1&!D&C1&C&!B&A1&A|!D2&D1&!D&C1&C&!B&A1&A|!D2&D1&D&C1&C&!B&A1&A|D2&D1&D&C1&C&!B&A1&A|D2&!D1&D&C1&C&!B&A1&A|!D2&!D1&D&C1&C&!B&A1&A|D2&D1&D&!C1&C&!B&A1&A|D2&D1&D&!C1&C&B&A1&A|!D2&!D1&D&C1&C&B&A1&A|D2&!D1&D&C1&C&B&A1&A|D2&D1&D&C1&C&B&A1&A|!D2&D1&D&C1&C&B&A1&A|!D2&D1&!D&C1&C&B&A1&A|D2&D1&!D&C1&C&B&A1&A|D2&!D1&!D&C1&C&B&A1&A|!D2&!D1&!D&C1&C&B&A1&A|D2&D1&D&C1&!C&B&A1&A|D2&D1&D&!C1&!C&B&A1&A|D2&D1&D&!C1&!C&B&!A1&A|D2&D1&D&C1&!C&B&!A1&A|!D2&!D1&!D&C1&C&B&!A1&A|D2&!D1&!D&C1&C&B&!A1&A|D2&D1&!D&C1&C&B&!A1&A|!D2&D1&!D&C1&C&B&!A1&A|!D2&D1&D&C1&C&B&!A1&A|D2&D1&D&C1&C&B&!A1&A|D2&!D1&D&C1&C&B&!A1&A|!D2&!D1&D&C1&C&B&!A1&A|D2&D1&D&!C1&C&B&!A1&A|D2&D1&D&!C1&C&!B&!A1&A|D2&D1&D&C1&C&!B&!A1&A|D2&D1&D&C1&!C&!B&!A1&A|D2&D1&D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOI2123.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOOAI2122 -l AOOOAI2122 -i D1 D C1 C B A1 A -o Y -f Y=!(D1&!D&!C1&C&B&!A1&!A|D1&D&!C1&C&B&!A1&!A|!D1&D&!C1&C&B&!A1&!A|!D1&D&C1&C&B&!A1&!A|D1&D&C1&C&B&!A1&!A|D1&!D&C1&C&B&!A1&!A|D1&!D&C1&!C&B&!A1&!A|D1&D&C1&!C&B&!A1&!A|!D1&D&C1&!C&B&!A1&!A|!D1&D&C1&!C&B&A1&!A|D1&D&C1&!C&B&A1&!A|D1&!D&C1&!C&B&A1&!A|D1&!D&C1&C&B&A1&!A|D1&D&C1&C&B&A1&!A|!D1&D&C1&C&B&A1&!A|!D1&D&!C1&C&B&A1&!A|D1&D&!C1&C&B&A1&!A|D1&!D&!C1&C&B&A1&!A|!D1&D&C1&!C&!B&A1&A|D1&D&C1&!C&!B&A1&A|D1&!D&C1&!C&!B&A1&A|D1&!D&C1&C&!B&A1&A|D1&D&C1&C&!B&A1&A|!D1&D&C1&C&!B&A1&A|!D1&D&!C1&C&!B&A1&A|D1&D&!C1&C&!B&A1&A|D1&!D&!C1&C&!B&A1&A|D1&!D&!C1&C&B&A1&A|D1&D&!C1&C&B&A1&A|!D1&D&!C1&C&B&A1&A|!D1&D&C1&C&B&A1&A|D1&D&C1&C&B&A1&A|D1&!D&C1&C&B&A1&A|D1&!D&C1&!C&B&A1&A|D1&D&C1&!C&B&A1&A|!D1&D&C1&!C&B&A1&A|!D1&D&C1&!C&B&!A1&A|D1&D&C1&!C&B&!A1&A|D1&!D&C1&!C&B&!A1&A|D1&!D&C1&C&B&!A1&A|D1&D&C1&C&B&!A1&A|!D1&D&C1&C&B&!A1&A|!D1&D&!C1&C&B&!A1&A|D1&D&!C1&C&B&!A1&A|D1&!D&!C1&C&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOOAI2122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOI22113 -l AAOAAOI22113 -i E2 E1 E D C B1 B A1 A -o Y -f Y=!(E2&E1&E&!D&!C&!B1&!B&!A1&!A|E2&E1&E&D&!C&!B1&!B&!A1&!A|!E2&!E1&!E&D&C&!B1&!B&!A1&!A|E2&!E1&!E&D&C&!B1&!B&!A1&!A|E2&E1&!E&D&C&!B1&!B&!A1&!A|!E2&E1&!E&D&C&!B1&!B&!A1&!A|!E2&E1&E&D&C&!B1&!B&!A1&!A|E2&E1&E&D&C&!B1&!B&!A1&!A|E2&!E1&E&D&C&!B1&!B&!A1&!A|!E2&!E1&E&D&C&!B1&!B&!A1&!A|E2&E1&E&!D&C&!B1&!B&!A1&!A|E2&E1&E&!D&C&B1&!B&!A1&!A|!E2&!E1&E&D&C&B1&!B&!A1&!A|E2&!E1&E&D&C&B1&!B&!A1&!A|E2&E1&E&D&C&B1&!B&!A1&!A|!E2&E1&E&D&C&B1&!B&!A1&!A|!E2&E1&!E&D&C&B1&!B&!A1&!A|E2&E1&!E&D&C&B1&!B&!A1&!A|E2&!E1&!E&D&C&B1&!B&!A1&!A|!E2&!E1&!E&D&C&B1&!B&!A1&!A|E2&E1&E&D&!C&B1&!B&!A1&!A|E2&E1&E&!D&!C&B1&!B&!A1&!A|E2&E1&E&!D&!C&B1&B&!A1&!A|!E2&!E1&E&D&!C&B1&B&!A1&!A|E2&!E1&E&D&!C&B1&B&!A1&!A|E2&E1&E&D&!C&B1&B&!A1&!A|!E2&E1&E&D&!C&B1&B&!A1&!A|!E2&E1&!E&D&!C&B1&B&!A1&!A|E2&E1&!E&D&!C&B1&B&!A1&!A|E2&!E1&!E&D&!C&B1&B&!A1&!A|!E2&!E1&!E&D&!C&B1&B&!A1&!A|!E2&!E1&!E&D&C&B1&B&!A1&!A|E2&!E1&!E&D&C&B1&B&!A1&!A|E2&E1&!E&D&C&B1&B&!A1&!A|!E2&E1&!E&D&C&B1&B&!A1&!A|!E2&E1&E&D&C&B1&B&!A1&!A|E2&E1&E&D&C&B1&B&!A1&!A|E2&!E1&E&D&C&B1&B&!A1&!A|!E2&!E1&E&D&C&B1&B&!A1&!A|E2&E1&E&!D&C&B1&B&!A1&!A|E2&E1&E&!D&C&!B1&B&!A1&!A|!E2&!E1&E&D&C&!B1&B&!A1&!A|E2&!E1&E&D&C&!B1&B&!A1&!A|E2&E1&E&D&C&!B1&B&!A1&!A|!E2&E1&E&D&C&!B1&B&!A1&!A|!E2&E1&!E&D&C&!B1&B&!A1&!A|E2&E1&!E&D&C&!B1&B&!A1&!A|E2&!E1&!E&D&C&!B1&B&!A1&!A|!E2&!E1&!E&D&C&!B1&B&!A1&!A|E2&E1&E&D&!C&!B1&B&!A1&!A|E2&E1&E&!D&!C&!B1&B&!A1&!A|E2&E1&E&!D&!C&!B1&B&A1&!A|E2&E1&E&D&!C&!B1&B&A1&!A|!E2&!E1&!E&D&C&!B1&B&A1&!A|E2&!E1&!E&D&C&!B1&B&A1&!A|E2&E1&!E&D&C&!B1&B&A1&!A|!E2&E1&!E&D&C&!B1&B&A1&!A|!E2&E1&E&D&C&!B1&B&A1&!A|E2&E1&E&D&C&!B1&B&A1&!A|E2&!E1&E&D&C&!B1&B&A1&!A|!E2&!E1&E&D&C&!B1&B&A1&!A|E2&E1&E&!D&C&!B1&B&A1&!A|E2&E1&E&!D&C&B1&B&A1&!A|!E2&!E1&E&D&C&B1&B&A1&!A|E2&!E1&E&D&C&B1&B&A1&!A|E2&E1&E&D&C&B1&B&A1&!A|!E2&E1&E&D&C&B1&B&A1&!A|!E2&E1&!E&D&C&B1&B&A1&!A|E2&E1&!E&D&C&B1&B&A1&!A|E2&!E1&!E&D&C&B1&B&A1&!A|!E2&!E1&!E&D&C&B1&B&A1&!A|!E2&!E1&!E&D&!C&B1&B&A1&!A|E2&!E1&!E&D&!C&B1&B&A1&!A|E2&E1&!E&D&!C&B1&B&A1&!A|!E2&E1&!E&D&!C&B1&B&A1&!A|!E2&E1&E&D&!C&B1&B&A1&!A|E2&E1&E&D&!C&B1&B&A1&!A|E2&!E1&E&D&!C&B1&B&A1&!A|!E2&!E1&E&D&!C&B1&B&A1&!A|E2&E1&E&!D&!C&B1&B&A1&!A|E2&E1&E&!D&!C&B1&!B&A1&!A|E2&E1&E&D&!C&B1&!B&A1&!A|!E2&!E1&!E&D&C&B1&!B&A1&!A|E2&!E1&!E&D&C&B1&!B&A1&!A|E2&E1&!E&D&C&B1&!B&A1&!A|!E2&E1&!E&D&C&B1&!B&A1&!A|!E2&E1&E&D&C&B1&!B&A1&!A|E2&E1&E&D&C&B1&!B&A1&!A|E2&!E1&E&D&C&B1&!B&A1&!A|!E2&!E1&E&D&C&B1&!B&A1&!A|E2&E1&E&!D&C&B1&!B&A1&!A|E2&E1&E&!D&C&!B1&!B&A1&!A|!E2&!E1&E&D&C&!B1&!B&A1&!A|E2&!E1&E&D&C&!B1&!B&A1&!A|E2&E1&E&D&C&!B1&!B&A1&!A|!E2&E1&E&D&C&!B1&!B&A1&!A|!E2&E1&!E&D&C&!B1&!B&A1&!A|E2&E1&!E&D&C&!B1&!B&A1&!A|E2&!E1&!E&D&C&!B1&!B&A1&!A|!E2&!E1&!E&D&C&!B1&!B&A1&!A|E2&E1&E&D&!C&!B1&!B&A1&!A|E2&E1&E&!D&!C&!B1&!B&A1&!A|E2&E1&E&!D&!C&!B1&!B&A1&A|!E2&!E1&E&D&!C&!B1&!B&A1&A|E2&!E1&E&D&!C&!B1&!B&A1&A|E2&E1&E&D&!C&!B1&!B&A1&A|!E2&E1&E&D&!C&!B1&!B&A1&A|!E2&E1&!E&D&!C&!B1&!B&A1&A|E2&E1&!E&D&!C&!B1&!B&A1&A|E2&!E1&!E&D&!C&!B1&!B&A1&A|!E2&!E1&!E&D&!C&!B1&!B&A1&A|!E2&!E1&!E&D&C&!B1&!B&A1&A|E2&!E1&!E&D&C&!B1&!B&A1&A|E2&E1&!E&D&C&!B1&!B&A1&A|!E2&E1&!E&D&C&!B1&!B&A1&A|!E2&E1&E&D&C&!B1&!B&A1&A|E2&E1&E&D&C&!B1&!B&A1&A|E2&!E1&E&D&C&!B1&!B&A1&A|!E2&!E1&E&D&C&!B1&!B&A1&A|E2&E1&E&!D&C&!B1&!B&A1&A|E2&E1&E&!D&C&B1&!B&A1&A|!E2&!E1&E&D&C&B1&!B&A1&A|E2&!E1&E&D&C&B1&!B&A1&A|E2&E1&E&D&C&B1&!B&A1&A|!E2&E1&E&D&C&B1&!B&A1&A|!E2&E1&!E&D&C&B1&!B&A1&A|E2&E1&!E&D&C&B1&!B&A1&A|E2&!E1&!E&D&C&B1&!B&A1&A|!E2&!E1&!E&D&C&B1&!B&A1&A|!E2&!E1&!E&D&!C&B1&!B&A1&A|E2&!E1&!E&D&!C&B1&!B&A1&A|E2&E1&!E&D&!C&B1&!B&A1&A|!E2&E1&!E&D&!C&B1&!B&A1&A|!E2&E1&E&D&!C&B1&!B&A1&A|E2&E1&E&D&!C&B1&!B&A1&A|E2&!E1&E&D&!C&B1&!B&A1&A|!E2&!E1&E&D&!C&B1&!B&A1&A|E2&E1&E&!D&!C&B1&!B&A1&A|E2&E1&E&!D&!C&B1&B&A1&A|!E2&!E1&E&D&!C&B1&B&A1&A|E2&!E1&E&D&!C&B1&B&A1&A|E2&E1&E&D&!C&B1&B&A1&A|!E2&E1&E&D&!C&B1&B&A1&A|!E2&E1&!E&D&!C&B1&B&A1&A|E2&E1&!E&D&!C&B1&B&A1&A|E2&!E1&!E&D&!C&B1&B&A1&A|!E2&!E1&!E&D&!C&B1&B&A1&A|!E2&!E1&!E&D&C&B1&B&A1&A|E2&!E1&!E&D&C&B1&B&A1&A|E2&E1&!E&D&C&B1&B&A1&A|!E2&E1&!E&D&C&B1&B&A1&A|!E2&E1&E&D&C&B1&B&A1&A|E2&E1&E&D&C&B1&B&A1&A|E2&!E1&E&D&C&B1&B&A1&A|!E2&!E1&E&D&C&B1&B&A1&A|E2&E1&E&!D&C&B1&B&A1&A|E2&E1&E&!D&C&!B1&B&A1&A|!E2&!E1&E&D&C&!B1&B&A1&A|E2&!E1&E&D&C&!B1&B&A1&A|E2&E1&E&D&C&!B1&B&A1&A|!E2&E1&E&D&C&!B1&B&A1&A|!E2&E1&!E&D&C&!B1&B&A1&A|E2&E1&!E&D&C&!B1&B&A1&A|E2&!E1&!E&D&C&!B1&B&A1&A|!E2&!E1&!E&D&C&!B1&B&A1&A|!E2&!E1&!E&D&!C&!B1&B&A1&A|E2&!E1&!E&D&!C&!B1&B&A1&A|E2&E1&!E&D&!C&!B1&B&A1&A|!E2&E1&!E&D&!C&!B1&B&A1&A|!E2&E1&E&D&!C&!B1&B&A1&A|E2&E1&E&D&!C&!B1&B&A1&A|E2&!E1&E&D&!C&!B1&B&A1&A|!E2&!E1&E&D&!C&!B1&B&A1&A|E2&E1&E&!D&!C&!B1&B&A1&A|E2&E1&E&!D&!C&!B1&B&!A1&A|E2&E1&E&D&!C&!B1&B&!A1&A|!E2&!E1&!E&D&C&!B1&B&!A1&A|E2&!E1&!E&D&C&!B1&B&!A1&A|E2&E1&!E&D&C&!B1&B&!A1&A|!E2&E1&!E&D&C&!B1&B&!A1&A|!E2&E1&E&D&C&!B1&B&!A1&A|E2&E1&E&D&C&!B1&B&!A1&A|E2&!E1&E&D&C&!B1&B&!A1&A|!E2&!E1&E&D&C&!B1&B&!A1&A|E2&E1&E&!D&C&!B1&B&!A1&A|E2&E1&E&!D&C&B1&B&!A1&A|!E2&!E1&E&D&C&B1&B&!A1&A|E2&!E1&E&D&C&B1&B&!A1&A|E2&E1&E&D&C&B1&B&!A1&A|!E2&E1&E&D&C&B1&B&!A1&A|!E2&E1&!E&D&C&B1&B&!A1&A|E2&E1&!E&D&C&B1&B&!A1&A|E2&!E1&!E&D&C&B1&B&!A1&A|!E2&!E1&!E&D&C&B1&B&!A1&A|!E2&!E1&!E&D&!C&B1&B&!A1&A|E2&!E1&!E&D&!C&B1&B&!A1&A|E2&E1&!E&D&!C&B1&B&!A1&A|!E2&E1&!E&D&!C&B1&B&!A1&A|!E2&E1&E&D&!C&B1&B&!A1&A|E2&E1&E&D&!C&B1&B&!A1&A|E2&!E1&E&D&!C&B1&B&!A1&A|!E2&!E1&E&D&!C&B1&B&!A1&A|E2&E1&E&!D&!C&B1&B&!A1&A|E2&E1&E&!D&!C&B1&!B&!A1&A|E2&E1&E&D&!C&B1&!B&!A1&A|!E2&!E1&!E&D&C&B1&!B&!A1&A|E2&!E1&!E&D&C&B1&!B&!A1&A|E2&E1&!E&D&C&B1&!B&!A1&A|!E2&E1&!E&D&C&B1&!B&!A1&A|!E2&E1&E&D&C&B1&!B&!A1&A|E2&E1&E&D&C&B1&!B&!A1&A|E2&!E1&E&D&C&B1&!B&!A1&A|!E2&!E1&E&D&C&B1&!B&!A1&A|E2&E1&E&!D&C&B1&!B&!A1&A|E2&E1&E&!D&C&!B1&!B&!A1&A|!E2&!E1&E&D&C&!B1&!B&!A1&A|E2&!E1&E&D&C&!B1&!B&!A1&A|E2&E1&E&D&C&!B1&!B&!A1&A|!E2&E1&E&D&C&!B1&!B&!A1&A|!E2&E1&!E&D&C&!B1&!B&!A1&A|E2&E1&!E&D&C&!B1&!B&!A1&A|E2&!E1&!E&D&C&!B1&!B&!A1&A|!E2&!E1&!E&D&C&!B1&!B&!A1&A|E2&E1&E&D&!C&!B1&!B&!A1&A|E2&E1&E&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOI22113.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAOI2231 -l AAOOAOI2231 -i D C2 C1 C B1 B A1 A -o Y -f Y=(!D&!C2&!C1&!C&!B1&!B&!A1&!A|!D&C2&!C1&!C&!B1&!B&!A1&!A|!D&C2&C1&!C&!B1&!B&!A1&!A|!D&!C2&C1&!C&!B1&!B&!A1&!A|!D&!C2&C1&C&!B1&!B&!A1&!A|!D&C2&C1&C&!B1&!B&!A1&!A|!D&C2&!C1&C&!B1&!B&!A1&!A|!D&!C2&!C1&C&!B1&!B&!A1&!A|!D&!C2&!C1&C&B1&!B&!A1&!A|!D&C2&!C1&C&B1&!B&!A1&!A|!D&C2&C1&C&B1&!B&!A1&!A|!D&!C2&C1&C&B1&!B&!A1&!A|!D&!C2&C1&!C&B1&!B&!A1&!A|!D&C2&C1&!C&B1&!B&!A1&!A|!D&C2&!C1&!C&B1&!B&!A1&!A|!D&!C2&!C1&!C&B1&!B&!A1&!A|!D&!C2&!C1&!C&B1&B&!A1&!A|!D&!C2&!C1&C&!B1&B&!A1&!A|!D&C2&!C1&C&!B1&B&!A1&!A|!D&C2&C1&C&!B1&B&!A1&!A|!D&!C2&C1&C&!B1&B&!A1&!A|!D&!C2&C1&!C&!B1&B&!A1&!A|!D&C2&C1&!C&!B1&B&!A1&!A|!D&C2&!C1&!C&!B1&B&!A1&!A|!D&!C2&!C1&!C&!B1&B&!A1&!A|!D&!C2&!C1&!C&!B1&B&A1&!A|!D&C2&!C1&!C&!B1&B&A1&!A|!D&C2&C1&!C&!B1&B&A1&!A|!D&!C2&C1&!C&!B1&B&A1&!A|!D&!C2&C1&C&!B1&B&A1&!A|!D&C2&C1&C&!B1&B&A1&!A|!D&C2&!C1&C&!B1&B&A1&!A|!D&!C2&!C1&C&!B1&B&A1&!A|!D&!C2&!C1&!C&B1&B&A1&!A|!D&!C2&!C1&!C&B1&!B&A1&!A|!D&C2&!C1&!C&B1&!B&A1&!A|!D&C2&C1&!C&B1&!B&A1&!A|!D&!C2&C1&!C&B1&!B&A1&!A|!D&!C2&C1&C&B1&!B&A1&!A|!D&C2&C1&C&B1&!B&A1&!A|!D&C2&!C1&C&B1&!B&A1&!A|!D&!C2&!C1&C&B1&!B&A1&!A|!D&!C2&!C1&C&!B1&!B&A1&!A|!D&C2&!C1&C&!B1&!B&A1&!A|!D&C2&C1&C&!B1&!B&A1&!A|!D&!C2&C1&C&!B1&!B&A1&!A|!D&!C2&C1&!C&!B1&!B&A1&!A|!D&C2&C1&!C&!B1&!B&A1&!A|!D&C2&!C1&!C&!B1&!B&A1&!A|!D&!C2&!C1&!C&!B1&!B&A1&!A|!D&!C2&!C1&!C&!B1&!B&A1&A|!D&!C2&!C1&!C&B1&!B&A1&A|!D&!C2&!C1&!C&B1&B&A1&A|!D&!C2&!C1&!C&!B1&B&A1&A|!D&!C2&!C1&!C&!B1&B&!A1&A|!D&C2&!C1&!C&!B1&B&!A1&A|!D&C2&C1&!C&!B1&B&!A1&A|!D&!C2&C1&!C&!B1&B&!A1&A|!D&!C2&C1&C&!B1&B&!A1&A|!D&C2&C1&C&!B1&B&!A1&A|!D&C2&!C1&C&!B1&B&!A1&A|!D&!C2&!C1&C&!B1&B&!A1&A|!D&!C2&!C1&!C&B1&B&!A1&A|!D&!C2&!C1&!C&B1&!B&!A1&A|!D&C2&!C1&!C&B1&!B&!A1&A|!D&C2&C1&!C&B1&!B&!A1&A|!D&!C2&C1&!C&B1&!B&!A1&A|!D&!C2&C1&C&B1&!B&!A1&A|!D&C2&C1&C&B1&!B&!A1&A|!D&C2&!C1&C&B1&!B&!A1&A|!D&!C2&!C1&C&B1&!B&!A1&A|!D&!C2&!C1&C&!B1&!B&!A1&A|!D&C2&!C1&C&!B1&!B&!A1&A|!D&C2&C1&C&!B1&!B&!A1&A|!D&!C2&C1&C&!B1&!B&!A1&A|!D&!C2&C1&!C&!B1&!B&!A1&A|!D&C2&C1&!C&!B1&!B&!A1&A|!D&C2&!C1&!C&!B1&!B&!A1&A|!D&!C2&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAOI2231.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAI2122 -l OAOOAI2122 -i D1 D C1 C B A1 A -o Y -f Y=(!D1&!D&!C1&!C&!B&!A1&!A|D1&!D&!C1&!C&!B&!A1&!A|D1&D&!C1&!C&!B&!A1&!A|!D1&D&!C1&!C&!B&!A1&!A|!D1&!D&C1&!C&!B&!A1&!A|!D1&!D&C1&C&!B&!A1&!A|!D1&!D&!C1&C&!B&!A1&!A|!D1&!D&!C1&C&B&!A1&!A|!D1&!D&C1&C&B&!A1&!A|!D1&!D&C1&!C&B&!A1&!A|!D1&D&!C1&!C&B&!A1&!A|D1&D&!C1&!C&B&!A1&!A|D1&!D&!C1&!C&B&!A1&!A|!D1&!D&!C1&!C&B&!A1&!A|!D1&!D&!C1&!C&B&A1&!A|!D1&!D&C1&!C&B&A1&!A|!D1&!D&C1&C&B&A1&!A|!D1&!D&!C1&C&B&A1&!A|!D1&!D&!C1&C&!B&A1&!A|!D1&!D&C1&C&!B&A1&!A|!D1&!D&C1&!C&!B&A1&!A|!D1&D&!C1&!C&!B&A1&!A|D1&D&!C1&!C&!B&A1&!A|D1&!D&!C1&!C&!B&A1&!A|!D1&!D&!C1&!C&!B&A1&!A|!D1&!D&!C1&!C&!B&A1&A|D1&!D&!C1&!C&!B&A1&A|D1&D&!C1&!C&!B&A1&A|!D1&D&!C1&!C&!B&A1&A|!D1&!D&C1&!C&!B&A1&A|!D1&!D&C1&C&!B&A1&A|!D1&!D&!C1&C&!B&A1&A|!D1&!D&!C1&C&B&A1&A|!D1&!D&C1&C&B&A1&A|!D1&!D&C1&!C&B&A1&A|!D1&!D&!C1&!C&B&A1&A|!D1&!D&!C1&!C&B&!A1&A|!D1&!D&C1&!C&B&!A1&A|!D1&!D&C1&C&B&!A1&A|!D1&!D&!C1&C&B&!A1&A|!D1&!D&!C1&C&!B&!A1&A|!D1&!D&C1&C&!B&!A1&A|!D1&!D&C1&!C&!B&!A1&A|!D1&D&!C1&!C&!B&!A1&A|D1&D&!C1&!C&!B&!A1&A|D1&!D&!C1&!C&!B&!A1&A|!D1&!D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAI2122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAI222 -l OOOAI222 -i C1 C B1 B A1 A -o Y -f Y=!(C1&!C&!B1&B&A1&!A|C1&C&!B1&B&A1&!A|!C1&C&!B1&B&A1&!A|!C1&C&B1&B&A1&!A|C1&C&B1&B&A1&!A|C1&!C&B1&B&A1&!A|C1&!C&B1&!B&A1&!A|C1&C&B1&!B&A1&!A|!C1&C&B1&!B&A1&!A|!C1&C&B1&!B&A1&A|C1&C&B1&!B&A1&A|C1&!C&B1&!B&A1&A|C1&!C&B1&B&A1&A|C1&C&B1&B&A1&A|!C1&C&B1&B&A1&A|!C1&C&!B1&B&A1&A|C1&C&!B1&B&A1&A|C1&!C&!B1&B&A1&A|C1&!C&!B1&B&!A1&A|C1&C&!B1&B&!A1&A|!C1&C&!B1&B&!A1&A|!C1&C&B1&B&!A1&A|C1&C&B1&B&!A1&A|C1&!C&B1&B&!A1&A|C1&!C&B1&!B&!A1&A|C1&C&B1&!B&!A1&A|!C1&C&B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAI222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAAOI3332 -l OOOAAOI3332 -i D1 D C2 C1 C B2 B1 B A2 A1 A -o Y -f Y=(!D1&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|D1&!D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|D1&!D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&D&!C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&D&C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|D1&!D&C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&C2&!C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|D1&!D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&D&C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&D&!C2&C1&C&B2&!B1&!B&!A2&!A1&!A|D1&!D&!C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C2&C1&C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&!D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&D&!C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&D&C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&!D&C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&C2&C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&!D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&D&C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|D1&!D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&!A|!D1&!D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|D1&!D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&D&C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|D1&!D&C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&!D&C2&!C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&!D&C2&C1&!C&B2&B1&!B&!A2&!A1&!A|D1&!D&C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&D&C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&D&!C2&C1&!C&B2&B1&!B&!A2&!A1&!A|D1&!D&!C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&!D&!C2&C1&!C&B2&B1&!B&!A2&!A1&!A|!D1&!D&!C2&C1&C&B2&B1&!B&!A2&!A1&!A|D1&!D&!C2&C1&C&B2&B1&!B&!A2&!A1&!A|!D1&D&!C2&C1&C&B2&B1&!B&!A2&!A1&!A|!D1&D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|D1&!D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|!D1&!D&C2&C1&C&B2&B1&!B&!A2&!A1&!A|!D1&!D&C2&!C1&C&B2&B1&!B&!A2&!A1&!A|D1&!D&C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!D1&D&C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!D1&D&!C2&!C1&C&B2&B1&!B&!A2&!A1&!A|D1&!D&!C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!D1&!D&!C2&!C1&C&B2&B1&!B&!A2&!A1&!A|!D1&!D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|D1&!D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&D&!C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&D&C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|D1&!D&C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&C2&!C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|D1&!D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&D&C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&D&!C2&C1&C&!B2&B1&!B&!A2&!A1&!A|D1&!D&!C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&!C2&C1&C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&!D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&D&!C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&D&C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&!D&C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&C2&C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&!D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&D&C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|D1&!D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&!A|!D1&!D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|D1&!D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&D&C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|D1&!D&C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&!D&C2&!C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&!D&C2&C1&!C&!B2&B1&B&!A2&!A1&!A|D1&!D&C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&D&C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&D&!C2&C1&!C&!B2&B1&B&!A2&!A1&!A|D1&!D&!C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&!D&!C2&C1&!C&!B2&B1&B&!A2&!A1&!A|!D1&!D&!C2&C1&C&!B2&B1&B&!A2&!A1&!A|D1&!D&!C2&C1&C&!B2&B1&B&!A2&!A1&!A|!D1&D&!C2&C1&C&!B2&B1&B&!A2&!A1&!A|!D1&D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|D1&!D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|!D1&!D&C2&C1&C&!B2&B1&B&!A2&!A1&!A|!D1&!D&C2&!C1&C&!B2&B1&B&!A2&!A1&!A|D1&!D&C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!D1&D&C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!D1&D&!C2&!C1&C&!B2&B1&B&!A2&!A1&!A|D1&!D&!C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!D1&!D&!C2&!C1&C&!B2&B1&B&!A2&!A1&!A|!D1&!D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|D1&!D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|!D1&D&!C2&!C1&C&B2&B1&B&!A2&!A1&!A|!D1&D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|D1&!D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|!D1&!D&C2&!C1&C&B2&B1&B&!A2&!A1&!A|!D1&!D&C2&C1&C&B2&B1&B&!A2&!A1&!A|D1&!D&C2&C1&C&B2&B1&B&!A2&!A1&!A|!D1&D&C2&C1&C&B2&B1&B&!A2&!A1&!A|!D1&D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|D1&!D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|!D1&!D&!C2&C1&C&B2&B1&B&!A2&!A1&!A|!D1&!D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|D1&!D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|!D1&D&!C2&C1&!C&B2&B1&B&!A2&!A1&!A|!D1&D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|D1&!D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|!D1&!D&C2&C1&!C&B2&B1&B&!A2&!A1&!A|!D1&!D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|D1&!D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!D1&D&C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!D1&D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|D1&!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!D1&!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&!A|!D1&!D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|D1&!D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&D&C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|D1&!D&C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&!D&C2&!C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&!D&C2&C1&!C&B2&!B1&B&!A2&!A1&!A|D1&!D&C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&D&C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&D&!C2&C1&!C&B2&!B1&B&!A2&!A1&!A|D1&!D&!C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&!D&!C2&C1&!C&B2&!B1&B&!A2&!A1&!A|!D1&!D&!C2&C1&C&B2&!B1&B&!A2&!A1&!A|D1&!D&!C2&C1&C&B2&!B1&B&!A2&!A1&!A|!D1&D&!C2&C1&C&B2&!B1&B&!A2&!A1&!A|!D1&D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|D1&!D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|!D1&!D&C2&C1&C&B2&!B1&B&!A2&!A1&!A|!D1&!D&C2&!C1&C&B2&!B1&B&!A2&!A1&!A|D1&!D&C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!D1&D&C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!D1&D&!C2&!C1&C&B2&!B1&B&!A2&!A1&!A|D1&!D&!C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!D1&!D&!C2&!C1&C&B2&!B1&B&!A2&!A1&!A|!D1&!D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|D1&!D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&D&!C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&D&C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|D1&!D&C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&C2&!C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|D1&!D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&D&C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&D&!C2&C1&C&!B2&!B1&B&!A2&!A1&!A|D1&!D&!C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&!C2&C1&C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&!D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&D&!C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&D&C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&!D&C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&C2&C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&!D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&D&C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|D1&!D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&!A|!D1&!D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|D1&!D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|!D1&D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&!A|!D1&D&!C2&!C1&!C&B2&!B1&B&A2&!A1&!A|D1&!D&!C2&!C1&!C&B2&!B1&B&A2&!A1&!A|!D1&!D&!C2&!C1&!C&B2&!B1&B&A2&!A1&!A|!D1&!D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|D1&!D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|!D1&D&!C2&!C1&!C&B2&B1&B&A2&!A1&!A|!D1&D&!C2&!C1&!C&!B2&B1&B&A2&!A1&!A|D1&!D&!C2&!C1&!C&!B2&B1&B&A2&!A1&!A|!D1&!D&!C2&!C1&!C&!B2&B1&B&A2&!A1&!A|!D1&!D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|D1&!D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|!D1&D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&!A|!D1&D&!C2&!C1&!C&B2&B1&!B&A2&!A1&!A|D1&!D&!C2&!C1&!C&B2&B1&!B&A2&!A1&!A|!D1&!D&!C2&!C1&!C&B2&B1&!B&A2&!A1&!A|!D1&!D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|D1&!D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|!D1&D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&!A|!D1&!D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|D1&!D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&D&C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|D1&!D&C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&C2&!C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|D1&!D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&D&C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&D&!C2&C1&C&!B2&!B1&!B&A2&!A1&!A|D1&!D&!C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&!C2&C1&C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&!D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&D&C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&!D&C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&C2&C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&!D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|D1&!D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&!A|!D1&!D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|D1&!D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&D&C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|D1&!D&C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&!D&C2&!C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&!D&C2&C1&!C&!B2&!B1&!B&A2&A1&!A|D1&!D&C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&D&C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&D&!C2&C1&!C&!B2&!B1&!B&A2&A1&!A|D1&!D&!C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&!D&!C2&C1&!C&!B2&!B1&!B&A2&A1&!A|!D1&!D&!C2&C1&C&!B2&!B1&!B&A2&A1&!A|D1&!D&!C2&C1&C&!B2&!B1&!B&A2&A1&!A|!D1&D&!C2&C1&C&!B2&!B1&!B&A2&A1&!A|!D1&D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|D1&!D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|!D1&!D&C2&C1&C&!B2&!B1&!B&A2&A1&!A|!D1&!D&C2&!C1&C&!B2&!B1&!B&A2&A1&!A|D1&!D&C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!D1&D&C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!D1&D&!C2&!C1&C&!B2&!B1&!B&A2&A1&!A|D1&!D&!C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!D1&!D&!C2&!C1&C&!B2&!B1&!B&A2&A1&!A|!D1&D&!C2&!C1&!C&B2&!B1&!B&A2&A1&!A|D1&!D&!C2&!C1&!C&B2&!B1&!B&A2&A1&!A|!D1&!D&!C2&!C1&!C&B2&!B1&!B&A2&A1&!A|!D1&!D&!C2&!C1&!C&B2&B1&!B&A2&A1&!A|D1&!D&!C2&!C1&!C&B2&B1&!B&A2&A1&!A|!D1&D&!C2&!C1&!C&B2&B1&!B&A2&A1&!A|!D1&D&!C2&!C1&!C&!B2&B1&!B&A2&A1&!A|D1&!D&!C2&!C1&!C&!B2&B1&!B&A2&A1&!A|!D1&!D&!C2&!C1&!C&!B2&B1&!B&A2&A1&!A|!D1&!D&!C2&!C1&!C&!B2&B1&B&A2&A1&!A|D1&!D&!C2&!C1&!C&!B2&B1&B&A2&A1&!A|!D1&D&!C2&!C1&!C&!B2&B1&B&A2&A1&!A|!D1&D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|D1&!D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|!D1&!D&!C2&!C1&!C&B2&B1&B&A2&A1&!A|!D1&!D&!C2&!C1&!C&B2&!B1&B&A2&A1&!A|D1&!D&!C2&!C1&!C&B2&!B1&B&A2&A1&!A|!D1&D&!C2&!C1&!C&B2&!B1&B&A2&A1&!A|!D1&D&!C2&!C1&!C&!B2&!B1&B&A2&A1&!A|D1&!D&!C2&!C1&!C&!B2&!B1&B&A2&A1&!A|!D1&!D&!C2&!C1&!C&!B2&!B1&B&A2&A1&!A|!D1&!D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|D1&!D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|!D1&D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&!A|!D1&D&!C2&!C1&!C&B2&!B1&B&!A2&A1&!A|D1&!D&!C2&!C1&!C&B2&!B1&B&!A2&A1&!A|!D1&!D&!C2&!C1&!C&B2&!B1&B&!A2&A1&!A|!D1&!D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|D1&!D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|!D1&D&!C2&!C1&!C&B2&B1&B&!A2&A1&!A|!D1&D&!C2&!C1&!C&!B2&B1&B&!A2&A1&!A|D1&!D&!C2&!C1&!C&!B2&B1&B&!A2&A1&!A|!D1&!D&!C2&!C1&!C&!B2&B1&B&!A2&A1&!A|!D1&!D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|D1&!D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|!D1&D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&!A|!D1&D&!C2&!C1&!C&B2&B1&!B&!A2&A1&!A|D1&!D&!C2&!C1&!C&B2&B1&!B&!A2&A1&!A|!D1&!D&!C2&!C1&!C&B2&B1&!B&!A2&A1&!A|!D1&!D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|D1&!D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|!D1&D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&!A|!D1&!D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|D1&!D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&D&C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|D1&!D&C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&C2&!C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|D1&!D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&D&C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&D&!C2&C1&C&!B2&!B1&!B&!A2&A1&!A|D1&!D&!C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&!C2&C1&C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&!D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&D&C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&!D&C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&C2&C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&!D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|D1&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&!A|!D1&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|D1&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&D&!C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|D1&!D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&!D&C2&!C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&!D&C2&C1&!C&!B2&!B1&!B&!A2&A1&A|D1&!D&C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&D&C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&A|D1&!D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&!D&!C2&C1&!C&!B2&!B1&!B&!A2&A1&A|!D1&!D&!C2&C1&C&!B2&!B1&!B&!A2&A1&A|D1&!D&!C2&C1&C&!B2&!B1&!B&!A2&A1&A|!D1&D&!C2&C1&C&!B2&!B1&!B&!A2&A1&A|!D1&D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|D1&!D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|!D1&!D&C2&C1&C&!B2&!B1&!B&!A2&A1&A|!D1&!D&C2&!C1&C&!B2&!B1&!B&!A2&A1&A|D1&!D&C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!D1&D&C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!D1&D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&A|D1&!D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!D1&!D&!C2&!C1&C&!B2&!B1&!B&!A2&A1&A|!D1&D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&A|D1&!D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&A|!D1&!D&!C2&!C1&!C&B2&!B1&!B&!A2&A1&A|!D1&!D&!C2&!C1&!C&B2&B1&!B&!A2&A1&A|D1&!D&!C2&!C1&!C&B2&B1&!B&!A2&A1&A|!D1&D&!C2&!C1&!C&B2&B1&!B&!A2&A1&A|!D1&D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&A|D1&!D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&A|!D1&!D&!C2&!C1&!C&!B2&B1&!B&!A2&A1&A|!D1&!D&!C2&!C1&!C&!B2&B1&B&!A2&A1&A|D1&!D&!C2&!C1&!C&!B2&B1&B&!A2&A1&A|!D1&D&!C2&!C1&!C&!B2&B1&B&!A2&A1&A|!D1&D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|D1&!D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|!D1&!D&!C2&!C1&!C&B2&B1&B&!A2&A1&A|!D1&!D&!C2&!C1&!C&B2&!B1&B&!A2&A1&A|D1&!D&!C2&!C1&!C&B2&!B1&B&!A2&A1&A|!D1&D&!C2&!C1&!C&B2&!B1&B&!A2&A1&A|!D1&D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&A|D1&!D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&A|!D1&!D&!C2&!C1&!C&!B2&!B1&B&!A2&A1&A|!D1&!D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|D1&!D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|!D1&D&!C2&!C1&!C&!B2&!B1&B&A2&A1&A|!D1&D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|D1&!D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|!D1&!D&!C2&!C1&!C&B2&!B1&B&A2&A1&A|!D1&!D&!C2&!C1&!C&B2&B1&B&A2&A1&A|D1&!D&!C2&!C1&!C&B2&B1&B&A2&A1&A|!D1&D&!C2&!C1&!C&B2&B1&B&A2&A1&A|!D1&D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|D1&!D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|!D1&!D&!C2&!C1&!C&!B2&B1&B&A2&A1&A|!D1&!D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|D1&!D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|!D1&D&!C2&!C1&!C&!B2&B1&!B&A2&A1&A|!D1&D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|D1&!D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|!D1&!D&!C2&!C1&!C&B2&B1&!B&A2&A1&A|!D1&!D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|D1&!D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|!D1&D&!C2&!C1&!C&B2&!B1&!B&A2&A1&A|!D1&!D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|D1&!D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|!D1&D&!C2&!C1&C&!B2&!B1&!B&A2&A1&A|!D1&D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|D1&!D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|!D1&!D&C2&!C1&C&!B2&!B1&!B&A2&A1&A|!D1&!D&C2&C1&C&!B2&!B1&!B&A2&A1&A|D1&!D&C2&C1&C&!B2&!B1&!B&A2&A1&A|!D1&D&C2&C1&C&!B2&!B1&!B&A2&A1&A|!D1&D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|D1&!D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|!D1&!D&!C2&C1&C&!B2&!B1&!B&A2&A1&A|!D1&!D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|D1&!D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|!D1&D&!C2&C1&!C&!B2&!B1&!B&A2&A1&A|!D1&D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|D1&!D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|!D1&!D&C2&C1&!C&!B2&!B1&!B&A2&A1&A|!D1&!D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|D1&!D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!D1&D&C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!D1&D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|D1&!D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!D1&!D&!C2&!C1&!C&!B2&!B1&!B&A2&A1&A|!D1&!D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|D1&!D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&D&!C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|D1&!D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&!D&C2&!C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&!D&C2&C1&!C&!B2&!B1&!B&A2&!A1&A|D1&!D&C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&D&C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&A|D1&!D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&!D&!C2&C1&!C&!B2&!B1&!B&A2&!A1&A|!D1&!D&!C2&C1&C&!B2&!B1&!B&A2&!A1&A|D1&!D&!C2&C1&C&!B2&!B1&!B&A2&!A1&A|!D1&D&!C2&C1&C&!B2&!B1&!B&A2&!A1&A|!D1&D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|D1&!D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|!D1&!D&C2&C1&C&!B2&!B1&!B&A2&!A1&A|!D1&!D&C2&!C1&C&!B2&!B1&!B&A2&!A1&A|D1&!D&C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!D1&D&C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!D1&D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&A|D1&!D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!D1&!D&!C2&!C1&C&!B2&!B1&!B&A2&!A1&A|!D1&D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&A|D1&!D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&A|!D1&!D&!C2&!C1&!C&B2&!B1&!B&A2&!A1&A|!D1&!D&!C2&!C1&!C&B2&B1&!B&A2&!A1&A|D1&!D&!C2&!C1&!C&B2&B1&!B&A2&!A1&A|!D1&D&!C2&!C1&!C&B2&B1&!B&A2&!A1&A|!D1&D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&A|D1&!D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&A|!D1&!D&!C2&!C1&!C&!B2&B1&!B&A2&!A1&A|!D1&!D&!C2&!C1&!C&!B2&B1&B&A2&!A1&A|D1&!D&!C2&!C1&!C&!B2&B1&B&A2&!A1&A|!D1&D&!C2&!C1&!C&!B2&B1&B&A2&!A1&A|!D1&D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|D1&!D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|!D1&!D&!C2&!C1&!C&B2&B1&B&A2&!A1&A|!D1&!D&!C2&!C1&!C&B2&!B1&B&A2&!A1&A|D1&!D&!C2&!C1&!C&B2&!B1&B&A2&!A1&A|!D1&D&!C2&!C1&!C&B2&!B1&B&A2&!A1&A|!D1&D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&A|D1&!D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&A|!D1&!D&!C2&!C1&!C&!B2&!B1&B&A2&!A1&A|!D1&!D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|D1&!D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|!D1&D&!C2&!C1&!C&!B2&!B1&B&!A2&!A1&A|!D1&D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&A|D1&!D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&A|!D1&!D&!C2&!C1&!C&B2&!B1&B&!A2&!A1&A|!D1&!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|D1&!D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|!D1&D&!C2&!C1&!C&B2&B1&B&!A2&!A1&A|!D1&D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&A|D1&!D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&A|!D1&!D&!C2&!C1&!C&!B2&B1&B&!A2&!A1&A|!D1&!D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|D1&!D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|!D1&D&!C2&!C1&!C&!B2&B1&!B&!A2&!A1&A|!D1&D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&A|D1&!D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&A|!D1&!D&!C2&!C1&!C&B2&B1&!B&!A2&!A1&A|!D1&!D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|D1&!D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|!D1&D&!C2&!C1&!C&B2&!B1&!B&!A2&!A1&A|!D1&!D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|D1&!D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&D&!C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|D1&!D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&C2&!C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A|D1&!D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&D&C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&A|D1&!D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&!C2&C1&C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|D1&!D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&D&!C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|D1&!D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&C2&C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|D1&!D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&D&C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|D1&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A|!D1&!D&!C2&!C1&!C&!B2&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAAOI3332.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOOAOI22121 -l OOAOOAOI22121 -i E D1 D C B1 B A1 A -o Y -f Y=(!E&!D1&!D&!C&!B1&!B&!A1&!A|!E&D1&!D&!C&!B1&!B&!A1&!A|!E&D1&D&!C&!B1&!B&!A1&!A|!E&!D1&D&!C&!B1&!B&!A1&!A|!E&!D1&!D&C&!B1&!B&!A1&!A|!E&!D1&!D&C&B1&!B&!A1&!A|!E&!D1&D&!C&B1&!B&!A1&!A|!E&D1&D&!C&B1&!B&!A1&!A|!E&D1&!D&!C&B1&!B&!A1&!A|!E&!D1&!D&!C&B1&!B&!A1&!A|!E&!D1&!D&!C&B1&B&!A1&!A|!E&D1&!D&!C&B1&B&!A1&!A|!E&D1&D&!C&B1&B&!A1&!A|!E&!D1&D&!C&B1&B&!A1&!A|!E&!D1&!D&C&B1&B&!A1&!A|!E&!D1&!D&C&!B1&B&!A1&!A|!E&!D1&D&!C&!B1&B&!A1&!A|!E&D1&D&!C&!B1&B&!A1&!A|!E&D1&!D&!C&!B1&B&!A1&!A|!E&!D1&!D&!C&!B1&B&!A1&!A|!E&!D1&!D&!C&!B1&B&A1&!A|!E&!D1&!D&C&!B1&B&A1&!A|!E&!D1&!D&C&B1&B&A1&!A|!E&!D1&!D&!C&B1&B&A1&!A|!E&!D1&!D&!C&B1&!B&A1&!A|!E&!D1&!D&C&B1&!B&A1&!A|!E&!D1&!D&C&!B1&!B&A1&!A|!E&!D1&D&!C&!B1&!B&A1&!A|!E&D1&D&!C&!B1&!B&A1&!A|!E&D1&!D&!C&!B1&!B&A1&!A|!E&!D1&!D&!C&!B1&!B&A1&!A|!E&!D1&!D&!C&!B1&!B&A1&A|!E&D1&!D&!C&!B1&!B&A1&A|!E&D1&D&!C&!B1&!B&A1&A|!E&!D1&D&!C&!B1&!B&A1&A|!E&!D1&!D&C&!B1&!B&A1&A|!E&!D1&!D&C&B1&!B&A1&A|!E&!D1&!D&!C&B1&!B&A1&A|!E&!D1&!D&!C&B1&B&A1&A|!E&!D1&!D&C&B1&B&A1&A|!E&!D1&!D&C&!B1&B&A1&A|!E&!D1&!D&!C&!B1&B&A1&A|!E&!D1&!D&!C&!B1&B&!A1&A|!E&!D1&!D&C&!B1&B&!A1&A|!E&!D1&!D&C&B1&B&!A1&A|!E&!D1&!D&!C&B1&B&!A1&A|!E&!D1&!D&!C&B1&!B&!A1&A|!E&!D1&!D&C&B1&!B&!A1&A|!E&!D1&!D&C&!B1&!B&!A1&A|!E&!D1&D&!C&!B1&!B&!A1&A|!E&D1&D&!C&!B1&!B&!A1&A|!E&D1&!D&!C&!B1&!B&!A1&A|!E&!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOOAOI22121.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAI232 -l AOOAI232 -i C1 C B2 B1 B A1 A -o Y -f Y=(!C1&!C&!B2&!B1&!B&!A1&!A|C1&!C&!B2&!B1&!B&!A1&!A|C1&C&!B2&!B1&!B&!A1&!A|!C1&C&!B2&!B1&!B&!A1&!A|!C1&!C&B2&!B1&!B&!A1&!A|!C1&!C&B2&B1&!B&!A1&!A|!C1&!C&!B2&B1&!B&!A1&!A|!C1&!C&!B2&B1&B&!A1&!A|!C1&!C&B2&B1&B&!A1&!A|!C1&!C&B2&!B1&B&!A1&!A|!C1&!C&!B2&!B1&B&!A1&!A|!C1&!C&!B2&!B1&B&A1&!A|!C1&!C&B2&!B1&B&A1&!A|!C1&!C&B2&B1&B&A1&!A|!C1&!C&!B2&B1&B&A1&!A|!C1&!C&!B2&B1&!B&A1&!A|!C1&!C&B2&B1&!B&A1&!A|!C1&!C&B2&!B1&!B&A1&!A|!C1&C&!B2&!B1&!B&A1&!A|C1&C&!B2&!B1&!B&A1&!A|C1&!C&!B2&!B1&!B&A1&!A|!C1&!C&!B2&!B1&!B&A1&!A|!C1&!C&!B2&!B1&!B&A1&A|!C1&!C&B2&!B1&!B&A1&A|!C1&!C&B2&B1&!B&A1&A|!C1&!C&!B2&B1&!B&A1&A|!C1&!C&!B2&B1&B&A1&A|!C1&!C&B2&B1&B&A1&A|!C1&!C&B2&!B1&B&A1&A|!C1&!C&!B2&!B1&B&A1&A|!C1&!C&!B2&!B1&B&!A1&A|!C1&!C&B2&!B1&B&!A1&A|!C1&!C&B2&B1&B&!A1&A|!C1&!C&!B2&B1&B&!A1&A|!C1&!C&!B2&B1&!B&!A1&A|!C1&!C&B2&B1&!B&!A1&A|!C1&!C&B2&!B1&!B&!A1&A|!C1&C&!B2&!B1&!B&!A1&A|C1&C&!B2&!B1&!B&!A1&A|C1&!C&!B2&!B1&!B&!A1&A|!C1&!C&!B2&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAI232.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAAOOAI21241 -l OAAOOAI21241 -i E D3 D2 D1 D C1 C B A1 A -o Y -f Y=!(E&D3&!D2&!D1&!D&C1&C&!B&!A1&!A|E&D3&D2&!D1&!D&C1&C&!B&!A1&!A|E&!D3&D2&!D1&!D&C1&C&!B&!A1&!A|E&!D3&D2&D1&!D&C1&C&!B&!A1&!A|E&D3&D2&D1&!D&C1&C&!B&!A1&!A|E&D3&!D2&D1&!D&C1&C&!B&!A1&!A|E&!D3&!D2&D1&!D&C1&C&!B&!A1&!A|E&!D3&!D2&D1&D&C1&C&!B&!A1&!A|E&D3&!D2&D1&D&C1&C&!B&!A1&!A|E&D3&D2&D1&D&C1&C&!B&!A1&!A|E&!D3&D2&D1&D&C1&C&!B&!A1&!A|E&!D3&D2&!D1&D&C1&C&!B&!A1&!A|E&D3&D2&!D1&D&C1&C&!B&!A1&!A|E&D3&!D2&!D1&D&C1&C&!B&!A1&!A|E&!D3&!D2&!D1&D&C1&C&!B&!A1&!A|E&!D3&!D2&!D1&D&C1&C&B&!A1&!A|E&D3&!D2&!D1&D&C1&C&B&!A1&!A|E&D3&D2&!D1&D&C1&C&B&!A1&!A|E&!D3&D2&!D1&D&C1&C&B&!A1&!A|E&!D3&D2&D1&D&C1&C&B&!A1&!A|E&D3&D2&D1&D&C1&C&B&!A1&!A|E&D3&!D2&D1&D&C1&C&B&!A1&!A|E&!D3&!D2&D1&D&C1&C&B&!A1&!A|E&!D3&!D2&D1&!D&C1&C&B&!A1&!A|E&D3&!D2&D1&!D&C1&C&B&!A1&!A|E&D3&D2&D1&!D&C1&C&B&!A1&!A|E&!D3&D2&D1&!D&C1&C&B&!A1&!A|E&!D3&D2&!D1&!D&C1&C&B&!A1&!A|E&D3&D2&!D1&!D&C1&C&B&!A1&!A|E&D3&!D2&!D1&!D&C1&C&B&!A1&!A|E&D3&!D2&!D1&!D&!C1&!C&B&A1&!A|E&D3&D2&!D1&!D&!C1&!C&B&A1&!A|E&!D3&D2&!D1&!D&!C1&!C&B&A1&!A|E&!D3&D2&D1&!D&!C1&!C&B&A1&!A|E&D3&D2&D1&!D&!C1&!C&B&A1&!A|E&D3&!D2&D1&!D&!C1&!C&B&A1&!A|E&!D3&!D2&D1&!D&!C1&!C&B&A1&!A|E&!D3&!D2&D1&D&!C1&!C&B&A1&!A|E&D3&!D2&D1&D&!C1&!C&B&A1&!A|E&D3&D2&D1&D&!C1&!C&B&A1&!A|E&!D3&D2&D1&D&!C1&!C&B&A1&!A|E&!D3&D2&!D1&D&!C1&!C&B&A1&!A|E&D3&D2&!D1&D&!C1&!C&B&A1&!A|E&D3&!D2&!D1&D&!C1&!C&B&A1&!A|E&!D3&!D2&!D1&D&!C1&!C&B&A1&!A|E&!D3&!D2&!D1&D&C1&!C&B&A1&!A|E&D3&!D2&!D1&D&C1&!C&B&A1&!A|E&D3&D2&!D1&D&C1&!C&B&A1&!A|E&!D3&D2&!D1&D&C1&!C&B&A1&!A|E&!D3&D2&D1&D&C1&!C&B&A1&!A|E&D3&D2&D1&D&C1&!C&B&A1&!A|E&D3&!D2&D1&D&C1&!C&B&A1&!A|E&!D3&!D2&D1&D&C1&!C&B&A1&!A|E&!D3&!D2&D1&!D&C1&!C&B&A1&!A|E&D3&!D2&D1&!D&C1&!C&B&A1&!A|E&D3&D2&D1&!D&C1&!C&B&A1&!A|E&!D3&D2&D1&!D&C1&!C&B&A1&!A|E&!D3&D2&!D1&!D&C1&!C&B&A1&!A|E&D3&D2&!D1&!D&C1&!C&B&A1&!A|E&D3&!D2&!D1&!D&C1&!C&B&A1&!A|E&D3&!D2&!D1&!D&C1&C&B&A1&!A|E&D3&D2&!D1&!D&C1&C&B&A1&!A|E&!D3&D2&!D1&!D&C1&C&B&A1&!A|E&!D3&D2&D1&!D&C1&C&B&A1&!A|E&D3&D2&D1&!D&C1&C&B&A1&!A|E&D3&!D2&D1&!D&C1&C&B&A1&!A|E&!D3&!D2&D1&!D&C1&C&B&A1&!A|E&!D3&!D2&D1&D&C1&C&B&A1&!A|E&D3&!D2&D1&D&C1&C&B&A1&!A|E&D3&D2&D1&D&C1&C&B&A1&!A|E&!D3&D2&D1&D&C1&C&B&A1&!A|E&!D3&D2&!D1&D&C1&C&B&A1&!A|E&D3&D2&!D1&D&C1&C&B&A1&!A|E&D3&!D2&!D1&D&C1&C&B&A1&!A|E&!D3&!D2&!D1&D&C1&C&B&A1&!A|E&!D3&!D2&!D1&D&!C1&C&B&A1&!A|E&D3&!D2&!D1&D&!C1&C&B&A1&!A|E&D3&D2&!D1&D&!C1&C&B&A1&!A|E&!D3&D2&!D1&D&!C1&C&B&A1&!A|E&!D3&D2&D1&D&!C1&C&B&A1&!A|E&D3&D2&D1&D&!C1&C&B&A1&!A|E&D3&!D2&D1&D&!C1&C&B&A1&!A|E&!D3&!D2&D1&D&!C1&C&B&A1&!A|E&!D3&!D2&D1&!D&!C1&C&B&A1&!A|E&D3&!D2&D1&!D&!C1&C&B&A1&!A|E&D3&D2&D1&!D&!C1&C&B&A1&!A|E&!D3&D2&D1&!D&!C1&C&B&A1&!A|E&!D3&D2&!D1&!D&!C1&C&B&A1&!A|E&D3&D2&!D1&!D&!C1&C&B&A1&!A|E&D3&!D2&!D1&!D&!C1&C&B&A1&!A|E&!D3&!D2&!D1&D&C1&C&!B&A1&!A|E&D3&!D2&!D1&D&C1&C&!B&A1&!A|E&D3&D2&!D1&D&C1&C&!B&A1&!A|E&!D3&D2&!D1&D&C1&C&!B&A1&!A|E&!D3&D2&D1&D&C1&C&!B&A1&!A|E&D3&D2&D1&D&C1&C&!B&A1&!A|E&D3&!D2&D1&D&C1&C&!B&A1&!A|E&!D3&!D2&D1&D&C1&C&!B&A1&!A|E&!D3&!D2&D1&!D&C1&C&!B&A1&!A|E&D3&!D2&D1&!D&C1&C&!B&A1&!A|E&D3&D2&D1&!D&C1&C&!B&A1&!A|E&!D3&D2&D1&!D&C1&C&!B&A1&!A|E&!D3&D2&!D1&!D&C1&C&!B&A1&!A|E&D3&D2&!D1&!D&C1&C&!B&A1&!A|E&D3&!D2&!D1&!D&C1&C&!B&A1&!A|E&D3&!D2&!D1&!D&C1&C&!B&A1&A|E&D3&D2&!D1&!D&C1&C&!B&A1&A|E&!D3&D2&!D1&!D&C1&C&!B&A1&A|E&!D3&D2&D1&!D&C1&C&!B&A1&A|E&D3&D2&D1&!D&C1&C&!B&A1&A|E&D3&!D2&D1&!D&C1&C&!B&A1&A|E&!D3&!D2&D1&!D&C1&C&!B&A1&A|E&!D3&!D2&D1&D&C1&C&!B&A1&A|E&D3&!D2&D1&D&C1&C&!B&A1&A|E&D3&D2&D1&D&C1&C&!B&A1&A|E&!D3&D2&D1&D&C1&C&!B&A1&A|E&!D3&D2&!D1&D&C1&C&!B&A1&A|E&D3&D2&!D1&D&C1&C&!B&A1&A|E&D3&!D2&!D1&D&C1&C&!B&A1&A|E&!D3&!D2&!D1&D&C1&C&!B&A1&A|E&D3&!D2&!D1&!D&!C1&C&B&A1&A|E&D3&D2&!D1&!D&!C1&C&B&A1&A|E&!D3&D2&!D1&!D&!C1&C&B&A1&A|E&!D3&D2&D1&!D&!C1&C&B&A1&A|E&D3&D2&D1&!D&!C1&C&B&A1&A|E&D3&!D2&D1&!D&!C1&C&B&A1&A|E&!D3&!D2&D1&!D&!C1&C&B&A1&A|E&!D3&!D2&D1&D&!C1&C&B&A1&A|E&D3&!D2&D1&D&!C1&C&B&A1&A|E&D3&D2&D1&D&!C1&C&B&A1&A|E&!D3&D2&D1&D&!C1&C&B&A1&A|E&!D3&D2&!D1&D&!C1&C&B&A1&A|E&D3&D2&!D1&D&!C1&C&B&A1&A|E&D3&!D2&!D1&D&!C1&C&B&A1&A|E&!D3&!D2&!D1&D&!C1&C&B&A1&A|E&!D3&!D2&!D1&D&C1&C&B&A1&A|E&D3&!D2&!D1&D&C1&C&B&A1&A|E&D3&D2&!D1&D&C1&C&B&A1&A|E&!D3&D2&!D1&D&C1&C&B&A1&A|E&!D3&D2&D1&D&C1&C&B&A1&A|E&D3&D2&D1&D&C1&C&B&A1&A|E&D3&!D2&D1&D&C1&C&B&A1&A|E&!D3&!D2&D1&D&C1&C&B&A1&A|E&!D3&!D2&D1&!D&C1&C&B&A1&A|E&D3&!D2&D1&!D&C1&C&B&A1&A|E&D3&D2&D1&!D&C1&C&B&A1&A|E&!D3&D2&D1&!D&C1&C&B&A1&A|E&!D3&D2&!D1&!D&C1&C&B&A1&A|E&D3&D2&!D1&!D&C1&C&B&A1&A|E&D3&!D2&!D1&!D&C1&C&B&A1&A|E&D3&!D2&!D1&!D&C1&!C&B&A1&A|E&D3&D2&!D1&!D&C1&!C&B&A1&A|E&!D3&D2&!D1&!D&C1&!C&B&A1&A|E&!D3&D2&D1&!D&C1&!C&B&A1&A|E&D3&D2&D1&!D&C1&!C&B&A1&A|E&D3&!D2&D1&!D&C1&!C&B&A1&A|E&!D3&!D2&D1&!D&C1&!C&B&A1&A|E&!D3&!D2&D1&D&C1&!C&B&A1&A|E&D3&!D2&D1&D&C1&!C&B&A1&A|E&D3&D2&D1&D&C1&!C&B&A1&A|E&!D3&D2&D1&D&C1&!C&B&A1&A|E&!D3&D2&!D1&D&C1&!C&B&A1&A|E&D3&D2&!D1&D&C1&!C&B&A1&A|E&D3&!D2&!D1&D&C1&!C&B&A1&A|E&!D3&!D2&!D1&D&C1&!C&B&A1&A|E&!D3&!D2&!D1&D&!C1&!C&B&A1&A|E&D3&!D2&!D1&D&!C1&!C&B&A1&A|E&D3&D2&!D1&D&!C1&!C&B&A1&A|E&!D3&D2&!D1&D&!C1&!C&B&A1&A|E&!D3&D2&D1&D&!C1&!C&B&A1&A|E&D3&D2&D1&D&!C1&!C&B&A1&A|E&D3&!D2&D1&D&!C1&!C&B&A1&A|E&!D3&!D2&D1&D&!C1&!C&B&A1&A|E&!D3&!D2&D1&!D&!C1&!C&B&A1&A|E&D3&!D2&D1&!D&!C1&!C&B&A1&A|E&D3&D2&D1&!D&!C1&!C&B&A1&A|E&!D3&D2&D1&!D&!C1&!C&B&A1&A|E&!D3&D2&!D1&!D&!C1&!C&B&A1&A|E&D3&D2&!D1&!D&!C1&!C&B&A1&A|E&D3&!D2&!D1&!D&!C1&!C&B&A1&A|E&D3&!D2&!D1&!D&!C1&!C&B&!A1&A|E&D3&D2&!D1&!D&!C1&!C&B&!A1&A|E&!D3&D2&!D1&!D&!C1&!C&B&!A1&A|E&!D3&D2&D1&!D&!C1&!C&B&!A1&A|E&D3&D2&D1&!D&!C1&!C&B&!A1&A|E&D3&!D2&D1&!D&!C1&!C&B&!A1&A|E&!D3&!D2&D1&!D&!C1&!C&B&!A1&A|E&!D3&!D2&D1&D&!C1&!C&B&!A1&A|E&D3&!D2&D1&D&!C1&!C&B&!A1&A|E&D3&D2&D1&D&!C1&!C&B&!A1&A|E&!D3&D2&D1&D&!C1&!C&B&!A1&A|E&!D3&D2&!D1&D&!C1&!C&B&!A1&A|E&D3&D2&!D1&D&!C1&!C&B&!A1&A|E&D3&!D2&!D1&D&!C1&!C&B&!A1&A|E&!D3&!D2&!D1&D&!C1&!C&B&!A1&A|E&!D3&!D2&!D1&D&C1&!C&B&!A1&A|E&D3&!D2&!D1&D&C1&!C&B&!A1&A|E&D3&D2&!D1&D&C1&!C&B&!A1&A|E&!D3&D2&!D1&D&C1&!C&B&!A1&A|E&!D3&D2&D1&D&C1&!C&B&!A1&A|E&D3&D2&D1&D&C1&!C&B&!A1&A|E&D3&!D2&D1&D&C1&!C&B&!A1&A|E&!D3&!D2&D1&D&C1&!C&B&!A1&A|E&!D3&!D2&D1&!D&C1&!C&B&!A1&A|E&D3&!D2&D1&!D&C1&!C&B&!A1&A|E&D3&D2&D1&!D&C1&!C&B&!A1&A|E&!D3&D2&D1&!D&C1&!C&B&!A1&A|E&!D3&D2&!D1&!D&C1&!C&B&!A1&A|E&D3&D2&!D1&!D&C1&!C&B&!A1&A|E&D3&!D2&!D1&!D&C1&!C&B&!A1&A|E&D3&!D2&!D1&!D&C1&C&B&!A1&A|E&D3&D2&!D1&!D&C1&C&B&!A1&A|E&!D3&D2&!D1&!D&C1&C&B&!A1&A|E&!D3&D2&D1&!D&C1&C&B&!A1&A|E&D3&D2&D1&!D&C1&C&B&!A1&A|E&D3&!D2&D1&!D&C1&C&B&!A1&A|E&!D3&!D2&D1&!D&C1&C&B&!A1&A|E&!D3&!D2&D1&D&C1&C&B&!A1&A|E&D3&!D2&D1&D&C1&C&B&!A1&A|E&D3&D2&D1&D&C1&C&B&!A1&A|E&!D3&D2&D1&D&C1&C&B&!A1&A|E&!D3&D2&!D1&D&C1&C&B&!A1&A|E&D3&D2&!D1&D&C1&C&B&!A1&A|E&D3&!D2&!D1&D&C1&C&B&!A1&A|E&!D3&!D2&!D1&D&C1&C&B&!A1&A|E&!D3&!D2&!D1&D&!C1&C&B&!A1&A|E&D3&!D2&!D1&D&!C1&C&B&!A1&A|E&D3&D2&!D1&D&!C1&C&B&!A1&A|E&!D3&D2&!D1&D&!C1&C&B&!A1&A|E&!D3&D2&D1&D&!C1&C&B&!A1&A|E&D3&D2&D1&D&!C1&C&B&!A1&A|E&D3&!D2&D1&D&!C1&C&B&!A1&A|E&!D3&!D2&D1&D&!C1&C&B&!A1&A|E&!D3&!D2&D1&!D&!C1&C&B&!A1&A|E&D3&!D2&D1&!D&!C1&C&B&!A1&A|E&D3&D2&D1&!D&!C1&C&B&!A1&A|E&!D3&D2&D1&!D&!C1&C&B&!A1&A|E&!D3&D2&!D1&!D&!C1&C&B&!A1&A|E&D3&D2&!D1&!D&!C1&C&B&!A1&A|E&D3&!D2&!D1&!D&!C1&C&B&!A1&A|E&!D3&!D2&!D1&D&C1&C&!B&!A1&A|E&D3&!D2&!D1&D&C1&C&!B&!A1&A|E&D3&D2&!D1&D&C1&C&!B&!A1&A|E&!D3&D2&!D1&D&C1&C&!B&!A1&A|E&!D3&D2&D1&D&C1&C&!B&!A1&A|E&D3&D2&D1&D&C1&C&!B&!A1&A|E&D3&!D2&D1&D&C1&C&!B&!A1&A|E&!D3&!D2&D1&D&C1&C&!B&!A1&A|E&!D3&!D2&D1&!D&C1&C&!B&!A1&A|E&D3&!D2&D1&!D&C1&C&!B&!A1&A|E&D3&D2&D1&!D&C1&C&!B&!A1&A|E&!D3&D2&D1&!D&C1&C&!B&!A1&A|E&!D3&D2&!D1&!D&C1&C&!B&!A1&A|E&D3&D2&!D1&!D&C1&C&!B&!A1&A|E&D3&!D2&!D1&!D&C1&C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAAOOAI21241.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOOAI2212 -l OAOOAI2212 -i D1 D C B1 B A1 A -o Y -f Y=!(!D1&D&C&!B1&!B&!A1&!A|D1&D&C&!B1&!B&!A1&!A|D1&!D&C&!B1&!B&!A1&!A|D1&!D&C&B1&!B&!A1&!A|D1&D&C&B1&!B&!A1&!A|!D1&D&C&B1&!B&!A1&!A|!D1&D&C&B1&B&!A1&!A|D1&D&C&B1&B&!A1&!A|D1&!D&C&B1&B&!A1&!A|D1&!D&C&!B1&B&!A1&!A|D1&D&C&!B1&B&!A1&!A|!D1&D&C&!B1&B&!A1&!A|!D1&D&C&!B1&B&A1&!A|D1&D&C&!B1&B&A1&!A|D1&!D&C&!B1&B&A1&!A|D1&!D&C&B1&B&A1&!A|D1&D&C&B1&B&A1&!A|!D1&D&C&B1&B&A1&!A|!D1&D&!C&B1&B&A1&!A|D1&D&!C&B1&B&A1&!A|D1&!D&!C&B1&B&A1&!A|!D1&D&C&B1&!B&A1&!A|D1&D&C&B1&!B&A1&!A|D1&!D&C&B1&!B&A1&!A|D1&!D&C&!B1&!B&A1&!A|D1&D&C&!B1&!B&A1&!A|!D1&D&C&!B1&!B&A1&!A|!D1&D&C&!B1&!B&A1&A|D1&D&C&!B1&!B&A1&A|D1&!D&C&!B1&!B&A1&A|D1&!D&C&B1&!B&A1&A|D1&D&C&B1&!B&A1&A|!D1&D&C&B1&!B&A1&A|D1&!D&!C&B1&B&A1&A|D1&D&!C&B1&B&A1&A|!D1&D&!C&B1&B&A1&A|!D1&D&C&B1&B&A1&A|D1&D&C&B1&B&A1&A|D1&!D&C&B1&B&A1&A|D1&!D&C&!B1&B&A1&A|D1&D&C&!B1&B&A1&A|!D1&D&C&!B1&B&A1&A|!D1&D&C&!B1&B&!A1&A|D1&D&C&!B1&B&!A1&A|D1&!D&C&!B1&B&!A1&A|D1&!D&C&B1&B&!A1&A|D1&D&C&B1&B&!A1&A|!D1&D&C&B1&B&!A1&A|!D1&D&!C&B1&B&!A1&A|D1&D&!C&B1&B&!A1&A|D1&!D&!C&B1&B&!A1&A|!D1&D&C&B1&!B&!A1&A|D1&D&C&B1&!B&!A1&A|D1&!D&C&B1&!B&!A1&A|D1&!D&C&!B1&!B&!A1&A|D1&D&C&!B1&!B&!A1&A|!D1&D&C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOOAI2212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOOAOI22221 -l OOAAOOAOI22221 -i E D1 D C1 C B1 B A1 A -o Y -f Y=(!E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&D1&D&C1&!C&!B1&!B&!A1&!A|!E&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&D1&D&!C1&C&!B1&!B&!A1&!A|!E&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&D1&!D&!C1&C&B1&!B&!A1&!A|!E&D1&D&!C1&C&B1&!B&!A1&!A|!E&!D1&D&!C1&C&B1&!B&!A1&!A|!E&!D1&!D&C1&C&B1&!B&!A1&!A|!E&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&D1&!D&C1&!C&B1&!B&!A1&!A|!E&D1&D&C1&!C&B1&!B&!A1&!A|!E&!D1&D&C1&!C&B1&!B&!A1&!A|!E&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&D1&D&!C1&!C&B1&!B&!A1&!A|!E&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&D1&!D&!C1&!C&B1&B&!A1&!A|!E&D1&D&!C1&!C&B1&B&!A1&!A|!E&!D1&D&!C1&!C&B1&B&!A1&!A|!E&!D1&D&C1&!C&B1&B&!A1&!A|!E&D1&D&C1&!C&B1&B&!A1&!A|!E&D1&!D&C1&!C&B1&B&!A1&!A|!E&!D1&!D&C1&!C&B1&B&!A1&!A|!E&!D1&!D&C1&C&B1&B&!A1&!A|!E&!D1&D&!C1&C&B1&B&!A1&!A|!E&D1&D&!C1&C&B1&B&!A1&!A|!E&D1&!D&!C1&C&B1&B&!A1&!A|!E&!D1&!D&!C1&C&B1&B&!A1&!A|!E&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&D1&!D&!C1&C&!B1&B&!A1&!A|!E&D1&D&!C1&C&!B1&B&!A1&!A|!E&!D1&D&!C1&C&!B1&B&!A1&!A|!E&!D1&!D&C1&C&!B1&B&!A1&!A|!E&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&D1&!D&C1&!C&!B1&B&!A1&!A|!E&D1&D&C1&!C&!B1&B&!A1&!A|!E&!D1&D&C1&!C&!B1&B&!A1&!A|!E&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&D1&D&!C1&!C&!B1&B&!A1&!A|!E&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&!D1&!D&C1&!C&!B1&B&A1&!A|!E&!D1&!D&C1&C&!B1&B&A1&!A|!E&!D1&!D&!C1&C&!B1&B&A1&!A|!E&!D1&!D&!C1&C&B1&B&A1&!A|!E&!D1&!D&C1&C&B1&B&A1&!A|!E&!D1&!D&C1&!C&B1&B&A1&!A|!E&!D1&!D&!C1&!C&B1&B&A1&!A|!E&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&!D1&!D&C1&!C&B1&!B&A1&!A|!E&!D1&!D&C1&C&B1&!B&A1&!A|!E&!D1&!D&!C1&C&B1&!B&A1&!A|!E&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&D1&!D&!C1&C&!B1&!B&A1&!A|!E&D1&D&!C1&C&!B1&!B&A1&!A|!E&!D1&D&!C1&C&!B1&!B&A1&!A|!E&!D1&!D&C1&C&!B1&!B&A1&!A|!E&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&D1&!D&C1&!C&!B1&!B&A1&!A|!E&D1&D&C1&!C&!B1&!B&A1&!A|!E&!D1&D&C1&!C&!B1&!B&A1&!A|!E&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&D1&D&!C1&!C&!B1&!B&A1&!A|!E&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&D1&!D&!C1&!C&!B1&!B&A1&A|!E&D1&D&!C1&!C&!B1&!B&A1&A|!E&!D1&D&!C1&!C&!B1&!B&A1&A|!E&!D1&D&C1&!C&!B1&!B&A1&A|!E&D1&D&C1&!C&!B1&!B&A1&A|!E&D1&!D&C1&!C&!B1&!B&A1&A|!E&!D1&!D&C1&!C&!B1&!B&A1&A|!E&!D1&!D&C1&C&!B1&!B&A1&A|!E&!D1&D&!C1&C&!B1&!B&A1&A|!E&D1&D&!C1&C&!B1&!B&A1&A|!E&D1&!D&!C1&C&!B1&!B&A1&A|!E&!D1&!D&!C1&C&!B1&!B&A1&A|!E&!D1&!D&!C1&C&B1&!B&A1&A|!E&!D1&!D&C1&C&B1&!B&A1&A|!E&!D1&!D&C1&!C&B1&!B&A1&A|!E&!D1&!D&!C1&!C&B1&!B&A1&A|!E&!D1&!D&!C1&!C&B1&B&A1&A|!E&!D1&!D&C1&!C&B1&B&A1&A|!E&!D1&!D&C1&C&B1&B&A1&A|!E&!D1&!D&!C1&C&B1&B&A1&A|!E&!D1&!D&!C1&C&!B1&B&A1&A|!E&!D1&!D&C1&C&!B1&B&A1&A|!E&!D1&!D&C1&!C&!B1&B&A1&A|!E&!D1&!D&!C1&!C&!B1&B&A1&A|!E&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&!D1&!D&C1&!C&!B1&B&!A1&A|!E&!D1&!D&C1&C&!B1&B&!A1&A|!E&!D1&!D&!C1&C&!B1&B&!A1&A|!E&!D1&!D&!C1&C&B1&B&!A1&A|!E&!D1&!D&C1&C&B1&B&!A1&A|!E&!D1&!D&C1&!C&B1&B&!A1&A|!E&!D1&!D&!C1&!C&B1&B&!A1&A|!E&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&!D1&!D&C1&!C&B1&!B&!A1&A|!E&!D1&!D&C1&C&B1&!B&!A1&A|!E&!D1&!D&!C1&C&B1&!B&!A1&A|!E&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&D1&!D&!C1&C&!B1&!B&!A1&A|!E&D1&D&!C1&C&!B1&!B&!A1&A|!E&!D1&D&!C1&C&!B1&!B&!A1&A|!E&!D1&!D&C1&C&!B1&!B&!A1&A|!E&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&D1&!D&C1&!C&!B1&!B&!A1&A|!E&D1&D&C1&!C&!B1&!B&!A1&A|!E&!D1&D&C1&!C&!B1&!B&!A1&A|!E&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&D1&D&!C1&!C&!B1&!B&!A1&A|!E&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOOAOI22221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAOAI2122 -l OAOAI2122 -i D1 D C1 C B A1 A -o Y -f Y=!(D1&D&C1&!C&!B&!A1&!A|D1&D&C1&C&!B&!A1&!A|D1&D&!C1&C&!B&!A1&!A|D1&D&!C1&C&B&!A1&!A|D1&D&C1&C&B&!A1&!A|D1&D&C1&!C&B&!A1&!A|D1&D&!C1&!C&B&A1&!A|D1&D&C1&!C&B&A1&!A|D1&D&C1&C&B&A1&!A|D1&D&!C1&C&B&A1&!A|D1&D&!C1&C&!B&A1&!A|D1&D&C1&C&!B&A1&!A|D1&D&C1&!C&!B&A1&!A|D1&D&C1&!C&!B&A1&A|D1&D&C1&C&!B&A1&A|D1&D&!C1&C&!B&A1&A|D1&D&!C1&C&B&A1&A|D1&D&C1&C&B&A1&A|D1&D&C1&!C&B&A1&A|D1&D&!C1&!C&B&A1&A|D1&D&!C1&!C&B&!A1&A|D1&D&C1&!C&B&!A1&A|D1&D&C1&C&B&!A1&A|D1&D&!C1&C&B&!A1&A|D1&D&!C1&C&!B&!A1&A|D1&D&C1&C&!B&!A1&A|D1&D&C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAOAI2122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAAOI223 -l OOAAOI223 -i C2 C1 C B1 B A1 A -o Y -f Y=(!C2&!C1&!C&!B1&!B&!A1&!A|C2&!C1&!C&!B1&!B&!A1&!A|C2&C1&!C&!B1&!B&!A1&!A|!C2&C1&!C&!B1&!B&!A1&!A|!C2&C1&C&!B1&!B&!A1&!A|C2&!C1&C&!B1&!B&!A1&!A|!C2&!C1&C&!B1&!B&!A1&!A|!C2&!C1&C&B1&!B&!A1&!A|C2&!C1&C&B1&!B&!A1&!A|!C2&C1&C&B1&!B&!A1&!A|!C2&C1&!C&B1&!B&!A1&!A|C2&C1&!C&B1&!B&!A1&!A|C2&!C1&!C&B1&!B&!A1&!A|!C2&!C1&!C&B1&!B&!A1&!A|!C2&!C1&!C&B1&B&!A1&!A|C2&!C1&!C&B1&B&!A1&!A|C2&C1&!C&B1&B&!A1&!A|!C2&C1&!C&B1&B&!A1&!A|!C2&C1&C&B1&B&!A1&!A|C2&!C1&C&B1&B&!A1&!A|!C2&!C1&C&B1&B&!A1&!A|!C2&!C1&C&!B1&B&!A1&!A|C2&!C1&C&!B1&B&!A1&!A|!C2&C1&C&!B1&B&!A1&!A|!C2&C1&!C&!B1&B&!A1&!A|C2&C1&!C&!B1&B&!A1&!A|C2&!C1&!C&!B1&B&!A1&!A|!C2&!C1&!C&!B1&B&!A1&!A|!C2&!C1&C&!B1&!B&A1&!A|C2&!C1&C&!B1&!B&A1&!A|!C2&C1&C&!B1&!B&A1&!A|!C2&C1&!C&!B1&!B&A1&!A|C2&C1&!C&!B1&!B&A1&!A|C2&!C1&!C&!B1&!B&A1&!A|!C2&!C1&!C&!B1&!B&A1&!A|!C2&!C1&!C&!B1&!B&A1&A|C2&!C1&!C&!B1&!B&A1&A|C2&C1&!C&!B1&!B&A1&A|!C2&C1&!C&!B1&!B&A1&A|!C2&C1&C&!B1&!B&A1&A|C2&!C1&C&!B1&!B&A1&A|!C2&!C1&C&!B1&!B&A1&A|!C2&!C1&C&!B1&!B&!A1&A|C2&!C1&C&!B1&!B&!A1&A|!C2&C1&C&!B1&!B&!A1&A|!C2&C1&!C&!B1&!B&!A1&A|C2&C1&!C&!B1&!B&!A1&A|C2&!C1&!C&!B1&!B&!A1&A|!C2&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAAOI223.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOAAOI2214 -l AAOAAOI2214 -i D3 D2 D1 D C B1 B A1 A -o Y -f Y=!(D3&D2&D1&D&!C&!B1&!B&!A1&!A|D3&D2&D1&D&C&!B1&!B&!A1&!A|D3&D2&D1&D&C&B1&!B&!A1&!A|D3&D2&D1&D&!C&B1&!B&!A1&!A|D3&D2&D1&D&!C&B1&B&!A1&!A|!D3&!D2&!D1&D&C&B1&B&!A1&!A|D3&!D2&!D1&D&C&B1&B&!A1&!A|D3&D2&!D1&D&C&B1&B&!A1&!A|!D3&D2&!D1&D&C&B1&B&!A1&!A|!D3&D2&D1&D&C&B1&B&!A1&!A|D3&D2&D1&D&C&B1&B&!A1&!A|D3&!D2&D1&D&C&B1&B&!A1&!A|!D3&!D2&D1&D&C&B1&B&!A1&!A|!D3&!D2&D1&!D&C&B1&B&!A1&!A|D3&!D2&D1&!D&C&B1&B&!A1&!A|D3&D2&D1&!D&C&B1&B&!A1&!A|!D3&D2&D1&!D&C&B1&B&!A1&!A|!D3&D2&!D1&!D&C&B1&B&!A1&!A|D3&D2&!D1&!D&C&B1&B&!A1&!A|D3&!D2&!D1&!D&C&B1&B&!A1&!A|!D3&!D2&!D1&!D&C&B1&B&!A1&!A|D3&D2&D1&D&C&!B1&B&!A1&!A|D3&D2&D1&D&!C&!B1&B&!A1&!A|D3&D2&D1&D&!C&!B1&B&A1&!A|D3&D2&D1&D&C&!B1&B&A1&!A|!D3&!D2&!D1&!D&C&B1&B&A1&!A|D3&!D2&!D1&!D&C&B1&B&A1&!A|D3&D2&!D1&!D&C&B1&B&A1&!A|!D3&D2&!D1&!D&C&B1&B&A1&!A|!D3&D2&D1&!D&C&B1&B&A1&!A|D3&D2&D1&!D&C&B1&B&A1&!A|D3&!D2&D1&!D&C&B1&B&A1&!A|!D3&!D2&D1&!D&C&B1&B&A1&!A|!D3&!D2&D1&D&C&B1&B&A1&!A|D3&!D2&D1&D&C&B1&B&A1&!A|D3&D2&D1&D&C&B1&B&A1&!A|!D3&D2&D1&D&C&B1&B&A1&!A|!D3&D2&!D1&D&C&B1&B&A1&!A|D3&D2&!D1&D&C&B1&B&A1&!A|D3&!D2&!D1&D&C&B1&B&A1&!A|!D3&!D2&!D1&D&C&B1&B&A1&!A|D3&D2&D1&D&!C&B1&B&A1&!A|D3&D2&D1&D&!C&B1&!B&A1&!A|D3&D2&D1&D&C&B1&!B&A1&!A|D3&D2&D1&D&C&!B1&!B&A1&!A|D3&D2&D1&D&!C&!B1&!B&A1&!A|D3&D2&D1&D&!C&!B1&!B&A1&A|!D3&!D2&!D1&D&C&!B1&!B&A1&A|D3&!D2&!D1&D&C&!B1&!B&A1&A|D3&D2&!D1&D&C&!B1&!B&A1&A|!D3&D2&!D1&D&C&!B1&!B&A1&A|!D3&D2&D1&D&C&!B1&!B&A1&A|D3&D2&D1&D&C&!B1&!B&A1&A|D3&!D2&D1&D&C&!B1&!B&A1&A|!D3&!D2&D1&D&C&!B1&!B&A1&A|!D3&!D2&D1&!D&C&!B1&!B&A1&A|D3&!D2&D1&!D&C&!B1&!B&A1&A|D3&D2&D1&!D&C&!B1&!B&A1&A|!D3&D2&D1&!D&C&!B1&!B&A1&A|!D3&D2&!D1&!D&C&!B1&!B&A1&A|D3&D2&!D1&!D&C&!B1&!B&A1&A|D3&!D2&!D1&!D&C&!B1&!B&A1&A|!D3&!D2&!D1&!D&C&!B1&!B&A1&A|!D3&!D2&!D1&!D&C&B1&!B&A1&A|D3&!D2&!D1&!D&C&B1&!B&A1&A|D3&D2&!D1&!D&C&B1&!B&A1&A|!D3&D2&!D1&!D&C&B1&!B&A1&A|!D3&D2&D1&!D&C&B1&!B&A1&A|D3&D2&D1&!D&C&B1&!B&A1&A|D3&!D2&D1&!D&C&B1&!B&A1&A|!D3&!D2&D1&!D&C&B1&!B&A1&A|!D3&!D2&D1&D&C&B1&!B&A1&A|D3&!D2&D1&D&C&B1&!B&A1&A|D3&D2&D1&D&C&B1&!B&A1&A|!D3&D2&D1&D&C&B1&!B&A1&A|!D3&D2&!D1&D&C&B1&!B&A1&A|D3&D2&!D1&D&C&B1&!B&A1&A|D3&!D2&!D1&D&C&B1&!B&A1&A|!D3&!D2&!D1&D&C&B1&!B&A1&A|D3&D2&D1&D&!C&B1&!B&A1&A|D3&D2&D1&D&!C&B1&B&A1&A|!D3&!D2&!D1&D&C&B1&B&A1&A|D3&!D2&!D1&D&C&B1&B&A1&A|D3&D2&!D1&D&C&B1&B&A1&A|!D3&D2&!D1&D&C&B1&B&A1&A|!D3&D2&D1&D&C&B1&B&A1&A|D3&D2&D1&D&C&B1&B&A1&A|D3&!D2&D1&D&C&B1&B&A1&A|!D3&!D2&D1&D&C&B1&B&A1&A|!D3&!D2&D1&!D&C&B1&B&A1&A|D3&!D2&D1&!D&C&B1&B&A1&A|D3&D2&D1&!D&C&B1&B&A1&A|!D3&D2&D1&!D&C&B1&B&A1&A|!D3&D2&!D1&!D&C&B1&B&A1&A|D3&D2&!D1&!D&C&B1&B&A1&A|D3&!D2&!D1&!D&C&B1&B&A1&A|!D3&!D2&!D1&!D&C&B1&B&A1&A|!D3&!D2&!D1&!D&C&!B1&B&A1&A|D3&!D2&!D1&!D&C&!B1&B&A1&A|D3&D2&!D1&!D&C&!B1&B&A1&A|!D3&D2&!D1&!D&C&!B1&B&A1&A|!D3&D2&D1&!D&C&!B1&B&A1&A|D3&D2&D1&!D&C&!B1&B&A1&A|D3&!D2&D1&!D&C&!B1&B&A1&A|!D3&!D2&D1&!D&C&!B1&B&A1&A|!D3&!D2&D1&D&C&!B1&B&A1&A|D3&!D2&D1&D&C&!B1&B&A1&A|D3&D2&D1&D&C&!B1&B&A1&A|!D3&D2&D1&D&C&!B1&B&A1&A|!D3&D2&!D1&D&C&!B1&B&A1&A|D3&D2&!D1&D&C&!B1&B&A1&A|D3&!D2&!D1&D&C&!B1&B&A1&A|!D3&!D2&!D1&D&C&!B1&B&A1&A|D3&D2&D1&D&!C&!B1&B&A1&A|D3&D2&D1&D&!C&!B1&B&!A1&A|D3&D2&D1&D&C&!B1&B&!A1&A|!D3&!D2&!D1&!D&C&B1&B&!A1&A|D3&!D2&!D1&!D&C&B1&B&!A1&A|D3&D2&!D1&!D&C&B1&B&!A1&A|!D3&D2&!D1&!D&C&B1&B&!A1&A|!D3&D2&D1&!D&C&B1&B&!A1&A|D3&D2&D1&!D&C&B1&B&!A1&A|D3&!D2&D1&!D&C&B1&B&!A1&A|!D3&!D2&D1&!D&C&B1&B&!A1&A|!D3&!D2&D1&D&C&B1&B&!A1&A|D3&!D2&D1&D&C&B1&B&!A1&A|D3&D2&D1&D&C&B1&B&!A1&A|!D3&D2&D1&D&C&B1&B&!A1&A|!D3&D2&!D1&D&C&B1&B&!A1&A|D3&D2&!D1&D&C&B1&B&!A1&A|D3&!D2&!D1&D&C&B1&B&!A1&A|!D3&!D2&!D1&D&C&B1&B&!A1&A|D3&D2&D1&D&!C&B1&B&!A1&A|D3&D2&D1&D&!C&B1&!B&!A1&A|D3&D2&D1&D&C&B1&!B&!A1&A|D3&D2&D1&D&C&!B1&!B&!A1&A|D3&D2&D1&D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOAAOI2214.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAOI3221 -l AAOOAOI3221 -i D C1 C B1 B A2 A1 A -o Y -f Y=(!D&!C1&!C&!B1&!B&!A2&!A1&!A|!D&C1&!C&!B1&!B&!A2&!A1&!A|!D&C1&C&!B1&!B&!A2&!A1&!A|!D&!C1&C&!B1&!B&!A2&!A1&!A|!D&!C1&C&B1&!B&!A2&!A1&!A|!D&C1&C&B1&!B&!A2&!A1&!A|!D&C1&!C&B1&!B&!A2&!A1&!A|!D&!C1&!C&B1&!B&!A2&!A1&!A|!D&!C1&!C&B1&B&!A2&!A1&!A|!D&!C1&C&!B1&B&!A2&!A1&!A|!D&C1&C&!B1&B&!A2&!A1&!A|!D&C1&!C&!B1&B&!A2&!A1&!A|!D&!C1&!C&!B1&B&!A2&!A1&!A|!D&!C1&!C&!B1&B&A2&!A1&!A|!D&C1&!C&!B1&B&A2&!A1&!A|!D&C1&C&!B1&B&A2&!A1&!A|!D&!C1&C&!B1&B&A2&!A1&!A|!D&!C1&!C&B1&B&A2&!A1&!A|!D&!C1&!C&B1&!B&A2&!A1&!A|!D&C1&!C&B1&!B&A2&!A1&!A|!D&C1&C&B1&!B&A2&!A1&!A|!D&!C1&C&B1&!B&A2&!A1&!A|!D&!C1&C&!B1&!B&A2&!A1&!A|!D&C1&C&!B1&!B&A2&!A1&!A|!D&C1&!C&!B1&!B&A2&!A1&!A|!D&!C1&!C&!B1&!B&A2&!A1&!A|!D&!C1&!C&!B1&!B&A2&A1&!A|!D&C1&!C&!B1&!B&A2&A1&!A|!D&C1&C&!B1&!B&A2&A1&!A|!D&!C1&C&!B1&!B&A2&A1&!A|!D&!C1&C&B1&!B&A2&A1&!A|!D&C1&C&B1&!B&A2&A1&!A|!D&C1&!C&B1&!B&A2&A1&!A|!D&!C1&!C&B1&!B&A2&A1&!A|!D&!C1&!C&B1&B&A2&A1&!A|!D&!C1&C&!B1&B&A2&A1&!A|!D&C1&C&!B1&B&A2&A1&!A|!D&C1&!C&!B1&B&A2&A1&!A|!D&!C1&!C&!B1&B&A2&A1&!A|!D&!C1&!C&!B1&B&!A2&A1&!A|!D&C1&!C&!B1&B&!A2&A1&!A|!D&C1&C&!B1&B&!A2&A1&!A|!D&!C1&C&!B1&B&!A2&A1&!A|!D&!C1&!C&B1&B&!A2&A1&!A|!D&!C1&!C&B1&!B&!A2&A1&!A|!D&C1&!C&B1&!B&!A2&A1&!A|!D&C1&C&B1&!B&!A2&A1&!A|!D&!C1&C&B1&!B&!A2&A1&!A|!D&!C1&C&!B1&!B&!A2&A1&!A|!D&C1&C&!B1&!B&!A2&A1&!A|!D&C1&!C&!B1&!B&!A2&A1&!A|!D&!C1&!C&!B1&!B&!A2&A1&!A|!D&!C1&!C&!B1&!B&!A2&A1&A|!D&C1&!C&!B1&!B&!A2&A1&A|!D&C1&C&!B1&!B&!A2&A1&A|!D&!C1&C&!B1&!B&!A2&A1&A|!D&!C1&C&B1&!B&!A2&A1&A|!D&C1&C&B1&!B&!A2&A1&A|!D&C1&!C&B1&!B&!A2&A1&A|!D&!C1&!C&B1&!B&!A2&A1&A|!D&!C1&!C&B1&B&!A2&A1&A|!D&!C1&C&!B1&B&!A2&A1&A|!D&C1&C&!B1&B&!A2&A1&A|!D&C1&!C&!B1&B&!A2&A1&A|!D&!C1&!C&!B1&B&!A2&A1&A|!D&!C1&!C&!B1&B&A2&A1&A|!D&!C1&!C&B1&B&A2&A1&A|!D&!C1&!C&B1&!B&A2&A1&A|!D&!C1&!C&!B1&!B&A2&A1&A|!D&!C1&!C&!B1&!B&A2&!A1&A|!D&C1&!C&!B1&!B&A2&!A1&A|!D&C1&C&!B1&!B&A2&!A1&A|!D&!C1&C&!B1&!B&A2&!A1&A|!D&!C1&C&B1&!B&A2&!A1&A|!D&C1&C&B1&!B&A2&!A1&A|!D&C1&!C&B1&!B&A2&!A1&A|!D&!C1&!C&B1&!B&A2&!A1&A|!D&!C1&!C&B1&B&A2&!A1&A|!D&!C1&C&!B1&B&A2&!A1&A|!D&C1&C&!B1&B&A2&!A1&A|!D&C1&!C&!B1&B&A2&!A1&A|!D&!C1&!C&!B1&B&A2&!A1&A|!D&!C1&!C&!B1&B&!A2&!A1&A|!D&C1&!C&!B1&B&!A2&!A1&A|!D&C1&C&!B1&B&!A2&!A1&A|!D&!C1&C&!B1&B&!A2&!A1&A|!D&!C1&!C&B1&B&!A2&!A1&A|!D&!C1&!C&B1&!B&!A2&!A1&A|!D&C1&!C&B1&!B&!A2&!A1&A|!D&C1&C&B1&!B&!A2&!A1&A|!D&!C1&C&B1&!B&!A2&!A1&A|!D&!C1&C&!B1&!B&!A2&!A1&A|!D&C1&C&!B1&!B&!A2&!A1&A|!D&C1&!C&!B1&!B&!A2&!A1&A|!D&!C1&!C&!B1&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAOI3221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAOI2212 -l OOAOI2212 -i D1 D C B1 B A1 A -o Y -f Y=(!D1&!D&!C&!B1&!B&!A1&!A|!D1&!D&C&!B1&!B&!A1&!A|!D1&!D&C&B1&!B&!A1&!A|!D1&!D&!C&B1&!B&!A1&!A|!D1&!D&!C&B1&B&!A1&!A|!D1&!D&C&B1&B&!A1&!A|!D1&!D&C&!B1&B&!A1&!A|!D1&!D&!C&!B1&B&!A1&!A|!D1&!D&!C&!B1&B&A1&!A|!D1&!D&!C&B1&B&A1&!A|!D1&!D&!C&B1&!B&A1&!A|!D1&!D&C&!B1&!B&A1&!A|!D1&!D&!C&!B1&!B&A1&!A|!D1&!D&!C&!B1&!B&A1&A|!D1&!D&C&!B1&!B&A1&A|!D1&!D&!C&B1&!B&A1&A|!D1&!D&!C&B1&B&A1&A|!D1&!D&!C&!B1&B&A1&A|!D1&!D&!C&!B1&B&!A1&A|!D1&!D&!C&B1&B&!A1&A|!D1&!D&!C&B1&!B&!A1&A|!D1&!D&C&!B1&!B&!A1&A|!D1&!D&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAOI2212.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOOAAOOAI22232 -l OOOAAOOAI22232 -i E1 E D2 D1 D C1 C B1 B A1 A -o Y -f Y=!(!E1&E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|E1&E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&!C1&!C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|E1&E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&C1&!C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&C1&C&!B1&!B&!A1&!A|E1&E&D2&D1&D&C1&C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&C1&C&!B1&!B&!A1&!A|E1&!E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|E1&E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&!C1&C&!B1&!B&!A1&!A|!E1&E&D2&D1&D&!C1&C&B1&!B&!A1&!A|E1&E&D2&D1&D&!C1&C&B1&!B&!A1&!A|E1&!E&D2&D1&D&!C1&C&B1&!B&!A1&!A|E1&!E&D2&D1&D&C1&C&B1&!B&!A1&!A|E1&E&D2&D1&D&C1&C&B1&!B&!A1&!A|!E1&E&D2&D1&D&C1&C&B1&!B&!A1&!A|!E1&E&D2&D1&D&C1&!C&B1&!B&!A1&!A|E1&E&D2&D1&D&C1&!C&B1&!B&!A1&!A|E1&!E&D2&D1&D&C1&!C&B1&!B&!A1&!A|E1&!E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|E1&E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E1&E&D2&D1&D&!C1&!C&B1&!B&!A1&!A|!E1&E&D2&D1&D&!C1&!C&B1&B&!A1&!A|E1&E&D2&D1&D&!C1&!C&B1&B&!A1&!A|E1&!E&D2&D1&D&!C1&!C&B1&B&!A1&!A|E1&!E&D2&D1&D&C1&!C&B1&B&!A1&!A|E1&E&D2&D1&D&C1&!C&B1&B&!A1&!A|!E1&E&D2&D1&D&C1&!C&B1&B&!A1&!A|!E1&E&D2&D1&D&C1&C&B1&B&!A1&!A|E1&E&D2&D1&D&C1&C&B1&B&!A1&!A|E1&!E&D2&D1&D&C1&C&B1&B&!A1&!A|E1&!E&D2&D1&D&!C1&C&B1&B&!A1&!A|E1&E&D2&D1&D&!C1&C&B1&B&!A1&!A|!E1&E&D2&D1&D&!C1&C&B1&B&!A1&!A|!E1&E&D2&D1&D&!C1&C&!B1&B&!A1&!A|E1&E&D2&D1&D&!C1&C&!B1&B&!A1&!A|E1&!E&D2&D1&D&!C1&C&!B1&B&!A1&!A|E1&!E&D2&D1&D&C1&C&!B1&B&!A1&!A|E1&E&D2&D1&D&C1&C&!B1&B&!A1&!A|!E1&E&D2&D1&D&C1&C&!B1&B&!A1&!A|!E1&E&D2&D1&D&C1&!C&!B1&B&!A1&!A|E1&E&D2&D1&D&C1&!C&!B1&B&!A1&!A|E1&!E&D2&D1&D&C1&!C&!B1&B&!A1&!A|E1&!E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|E1&E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E1&E&D2&D1&D&!C1&!C&!B1&B&!A1&!A|!E1&E&D2&D1&D&!C1&!C&!B1&B&A1&!A|E1&E&D2&D1&D&!C1&!C&!B1&B&A1&!A|E1&!E&D2&D1&D&!C1&!C&!B1&B&A1&!A|E1&!E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|E1&E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|!E1&E&!D2&!D1&D&C1&!C&!B1&B&A1&!A|!E1&E&D2&!D1&D&C1&!C&!B1&B&A1&!A|E1&E&D2&!D1&D&C1&!C&!B1&B&A1&!A|E1&!E&D2&!D1&D&C1&!C&!B1&B&A1&!A|E1&!E&D2&D1&D&C1&!C&!B1&B&A1&!A|E1&E&D2&D1&D&C1&!C&!B1&B&A1&!A|!E1&E&D2&D1&D&C1&!C&!B1&B&A1&!A|!E1&E&!D2&D1&D&C1&!C&!B1&B&A1&!A|E1&E&!D2&D1&D&C1&!C&!B1&B&A1&!A|E1&!E&!D2&D1&D&C1&!C&!B1&B&A1&!A|E1&!E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|E1&E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|!E1&E&!D2&D1&!D&C1&!C&!B1&B&A1&!A|!E1&E&D2&D1&!D&C1&!C&!B1&B&A1&!A|E1&E&D2&D1&!D&C1&!C&!B1&B&A1&!A|E1&!E&D2&D1&!D&C1&!C&!B1&B&A1&!A|E1&!E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|E1&E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|!E1&E&D2&!D1&!D&C1&!C&!B1&B&A1&!A|!E1&E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|E1&E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&C1&!C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|E1&E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|!E1&E&!D2&!D1&!D&C1&C&!B1&B&A1&!A|!E1&E&D2&!D1&!D&C1&C&!B1&B&A1&!A|E1&E&D2&!D1&!D&C1&C&!B1&B&A1&!A|E1&!E&D2&!D1&!D&C1&C&!B1&B&A1&!A|E1&!E&D2&D1&!D&C1&C&!B1&B&A1&!A|E1&E&D2&D1&!D&C1&C&!B1&B&A1&!A|!E1&E&D2&D1&!D&C1&C&!B1&B&A1&!A|!E1&E&!D2&D1&!D&C1&C&!B1&B&A1&!A|E1&E&!D2&D1&!D&C1&C&!B1&B&A1&!A|E1&!E&!D2&D1&!D&C1&C&!B1&B&A1&!A|E1&!E&!D2&D1&D&C1&C&!B1&B&A1&!A|E1&E&!D2&D1&D&C1&C&!B1&B&A1&!A|!E1&E&!D2&D1&D&C1&C&!B1&B&A1&!A|!E1&E&D2&D1&D&C1&C&!B1&B&A1&!A|E1&E&D2&D1&D&C1&C&!B1&B&A1&!A|E1&!E&D2&D1&D&C1&C&!B1&B&A1&!A|E1&!E&D2&!D1&D&C1&C&!B1&B&A1&!A|E1&E&D2&!D1&D&C1&C&!B1&B&A1&!A|!E1&E&D2&!D1&D&C1&C&!B1&B&A1&!A|!E1&E&!D2&!D1&D&C1&C&!B1&B&A1&!A|E1&E&!D2&!D1&D&C1&C&!B1&B&A1&!A|E1&!E&!D2&!D1&D&C1&C&!B1&B&A1&!A|E1&!E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|E1&E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|!E1&E&!D2&!D1&D&!C1&C&!B1&B&A1&!A|!E1&E&D2&!D1&D&!C1&C&!B1&B&A1&!A|E1&E&D2&!D1&D&!C1&C&!B1&B&A1&!A|E1&!E&D2&!D1&D&!C1&C&!B1&B&A1&!A|E1&!E&D2&D1&D&!C1&C&!B1&B&A1&!A|E1&E&D2&D1&D&!C1&C&!B1&B&A1&!A|!E1&E&D2&D1&D&!C1&C&!B1&B&A1&!A|!E1&E&!D2&D1&D&!C1&C&!B1&B&A1&!A|E1&E&!D2&D1&D&!C1&C&!B1&B&A1&!A|E1&!E&!D2&D1&D&!C1&C&!B1&B&A1&!A|E1&!E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|E1&E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|!E1&E&!D2&D1&!D&!C1&C&!B1&B&A1&!A|!E1&E&D2&D1&!D&!C1&C&!B1&B&A1&!A|E1&E&D2&D1&!D&!C1&C&!B1&B&A1&!A|E1&!E&D2&D1&!D&!C1&C&!B1&B&A1&!A|E1&!E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|E1&E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|!E1&E&D2&!D1&!D&!C1&C&!B1&B&A1&!A|!E1&E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|E1&E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&!C1&C&!B1&B&A1&!A|E1&!E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|E1&E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&!C1&C&B1&B&A1&!A|!E1&E&D2&!D1&!D&!C1&C&B1&B&A1&!A|E1&E&D2&!D1&!D&!C1&C&B1&B&A1&!A|E1&!E&D2&!D1&!D&!C1&C&B1&B&A1&!A|E1&!E&D2&D1&!D&!C1&C&B1&B&A1&!A|E1&E&D2&D1&!D&!C1&C&B1&B&A1&!A|!E1&E&D2&D1&!D&!C1&C&B1&B&A1&!A|!E1&E&!D2&D1&!D&!C1&C&B1&B&A1&!A|E1&E&!D2&D1&!D&!C1&C&B1&B&A1&!A|E1&!E&!D2&D1&!D&!C1&C&B1&B&A1&!A|E1&!E&!D2&D1&D&!C1&C&B1&B&A1&!A|E1&E&!D2&D1&D&!C1&C&B1&B&A1&!A|!E1&E&!D2&D1&D&!C1&C&B1&B&A1&!A|!E1&E&D2&D1&D&!C1&C&B1&B&A1&!A|E1&E&D2&D1&D&!C1&C&B1&B&A1&!A|E1&!E&D2&D1&D&!C1&C&B1&B&A1&!A|E1&!E&D2&!D1&D&!C1&C&B1&B&A1&!A|E1&E&D2&!D1&D&!C1&C&B1&B&A1&!A|!E1&E&D2&!D1&D&!C1&C&B1&B&A1&!A|!E1&E&!D2&!D1&D&!C1&C&B1&B&A1&!A|E1&E&!D2&!D1&D&!C1&C&B1&B&A1&!A|E1&!E&!D2&!D1&D&!C1&C&B1&B&A1&!A|E1&!E&!D2&!D1&D&C1&C&B1&B&A1&!A|E1&E&!D2&!D1&D&C1&C&B1&B&A1&!A|!E1&E&!D2&!D1&D&C1&C&B1&B&A1&!A|!E1&E&D2&!D1&D&C1&C&B1&B&A1&!A|E1&E&D2&!D1&D&C1&C&B1&B&A1&!A|E1&!E&D2&!D1&D&C1&C&B1&B&A1&!A|E1&!E&D2&D1&D&C1&C&B1&B&A1&!A|E1&E&D2&D1&D&C1&C&B1&B&A1&!A|!E1&E&D2&D1&D&C1&C&B1&B&A1&!A|!E1&E&!D2&D1&D&C1&C&B1&B&A1&!A|E1&E&!D2&D1&D&C1&C&B1&B&A1&!A|E1&!E&!D2&D1&D&C1&C&B1&B&A1&!A|E1&!E&!D2&D1&!D&C1&C&B1&B&A1&!A|E1&E&!D2&D1&!D&C1&C&B1&B&A1&!A|!E1&E&!D2&D1&!D&C1&C&B1&B&A1&!A|!E1&E&D2&D1&!D&C1&C&B1&B&A1&!A|E1&E&D2&D1&!D&C1&C&B1&B&A1&!A|E1&!E&D2&D1&!D&C1&C&B1&B&A1&!A|E1&!E&D2&!D1&!D&C1&C&B1&B&A1&!A|E1&E&D2&!D1&!D&C1&C&B1&B&A1&!A|!E1&E&D2&!D1&!D&C1&C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&C1&C&B1&B&A1&!A|E1&E&!D2&!D1&!D&C1&C&B1&B&A1&!A|E1&!E&!D2&!D1&!D&C1&C&B1&B&A1&!A|E1&!E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|E1&E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|!E1&E&!D2&!D1&!D&C1&!C&B1&B&A1&!A|!E1&E&D2&!D1&!D&C1&!C&B1&B&A1&!A|E1&E&D2&!D1&!D&C1&!C&B1&B&A1&!A|E1&!E&D2&!D1&!D&C1&!C&B1&B&A1&!A|E1&!E&D2&D1&!D&C1&!C&B1&B&A1&!A|E1&E&D2&D1&!D&C1&!C&B1&B&A1&!A|!E1&E&D2&D1&!D&C1&!C&B1&B&A1&!A|!E1&E&!D2&D1&!D&C1&!C&B1&B&A1&!A|E1&E&!D2&D1&!D&C1&!C&B1&B&A1&!A|E1&!E&!D2&D1&!D&C1&!C&B1&B&A1&!A|E1&!E&!D2&D1&D&C1&!C&B1&B&A1&!A|E1&E&!D2&D1&D&C1&!C&B1&B&A1&!A|!E1&E&!D2&D1&D&C1&!C&B1&B&A1&!A|!E1&E&D2&D1&D&C1&!C&B1&B&A1&!A|E1&E&D2&D1&D&C1&!C&B1&B&A1&!A|E1&!E&D2&D1&D&C1&!C&B1&B&A1&!A|E1&!E&D2&!D1&D&C1&!C&B1&B&A1&!A|E1&E&D2&!D1&D&C1&!C&B1&B&A1&!A|!E1&E&D2&!D1&D&C1&!C&B1&B&A1&!A|!E1&E&!D2&!D1&D&C1&!C&B1&B&A1&!A|E1&E&!D2&!D1&D&C1&!C&B1&B&A1&!A|E1&!E&!D2&!D1&D&C1&!C&B1&B&A1&!A|E1&!E&D2&D1&D&!C1&!C&B1&B&A1&!A|E1&E&D2&D1&D&!C1&!C&B1&B&A1&!A|!E1&E&D2&D1&D&!C1&!C&B1&B&A1&!A|!E1&E&D2&D1&D&!C1&!C&B1&!B&A1&!A|E1&E&D2&D1&D&!C1&!C&B1&!B&A1&!A|E1&!E&D2&D1&D&!C1&!C&B1&!B&A1&!A|E1&!E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|E1&E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|!E1&E&!D2&!D1&D&C1&!C&B1&!B&A1&!A|!E1&E&D2&!D1&D&C1&!C&B1&!B&A1&!A|E1&E&D2&!D1&D&C1&!C&B1&!B&A1&!A|E1&!E&D2&!D1&D&C1&!C&B1&!B&A1&!A|E1&!E&D2&D1&D&C1&!C&B1&!B&A1&!A|E1&E&D2&D1&D&C1&!C&B1&!B&A1&!A|!E1&E&D2&D1&D&C1&!C&B1&!B&A1&!A|!E1&E&!D2&D1&D&C1&!C&B1&!B&A1&!A|E1&E&!D2&D1&D&C1&!C&B1&!B&A1&!A|E1&!E&!D2&D1&D&C1&!C&B1&!B&A1&!A|E1&!E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|E1&E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|!E1&E&!D2&D1&!D&C1&!C&B1&!B&A1&!A|!E1&E&D2&D1&!D&C1&!C&B1&!B&A1&!A|E1&E&D2&D1&!D&C1&!C&B1&!B&A1&!A|E1&!E&D2&D1&!D&C1&!C&B1&!B&A1&!A|E1&!E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|E1&E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|!E1&E&D2&!D1&!D&C1&!C&B1&!B&A1&!A|!E1&E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|E1&E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|E1&!E&!D2&!D1&!D&C1&!C&B1&!B&A1&!A|E1&!E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|E1&E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|!E1&E&!D2&!D1&!D&C1&C&B1&!B&A1&!A|!E1&E&D2&!D1&!D&C1&C&B1&!B&A1&!A|E1&E&D2&!D1&!D&C1&C&B1&!B&A1&!A|E1&!E&D2&!D1&!D&C1&C&B1&!B&A1&!A|E1&!E&D2&D1&!D&C1&C&B1&!B&A1&!A|E1&E&D2&D1&!D&C1&C&B1&!B&A1&!A|!E1&E&D2&D1&!D&C1&C&B1&!B&A1&!A|!E1&E&!D2&D1&!D&C1&C&B1&!B&A1&!A|E1&E&!D2&D1&!D&C1&C&B1&!B&A1&!A|E1&!E&!D2&D1&!D&C1&C&B1&!B&A1&!A|E1&!E&!D2&D1&D&C1&C&B1&!B&A1&!A|E1&E&!D2&D1&D&C1&C&B1&!B&A1&!A|!E1&E&!D2&D1&D&C1&C&B1&!B&A1&!A|!E1&E&D2&D1&D&C1&C&B1&!B&A1&!A|E1&E&D2&D1&D&C1&C&B1&!B&A1&!A|E1&!E&D2&D1&D&C1&C&B1&!B&A1&!A|E1&!E&D2&!D1&D&C1&C&B1&!B&A1&!A|E1&E&D2&!D1&D&C1&C&B1&!B&A1&!A|!E1&E&D2&!D1&D&C1&C&B1&!B&A1&!A|!E1&E&!D2&!D1&D&C1&C&B1&!B&A1&!A|E1&E&!D2&!D1&D&C1&C&B1&!B&A1&!A|E1&!E&!D2&!D1&D&C1&C&B1&!B&A1&!A|E1&!E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|E1&E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|!E1&E&!D2&!D1&D&!C1&C&B1&!B&A1&!A|!E1&E&D2&!D1&D&!C1&C&B1&!B&A1&!A|E1&E&D2&!D1&D&!C1&C&B1&!B&A1&!A|E1&!E&D2&!D1&D&!C1&C&B1&!B&A1&!A|E1&!E&D2&D1&D&!C1&C&B1&!B&A1&!A|E1&E&D2&D1&D&!C1&C&B1&!B&A1&!A|!E1&E&D2&D1&D&!C1&C&B1&!B&A1&!A|!E1&E&!D2&D1&D&!C1&C&B1&!B&A1&!A|E1&E&!D2&D1&D&!C1&C&B1&!B&A1&!A|E1&!E&!D2&D1&D&!C1&C&B1&!B&A1&!A|E1&!E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|E1&E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|!E1&E&!D2&D1&!D&!C1&C&B1&!B&A1&!A|!E1&E&D2&D1&!D&!C1&C&B1&!B&A1&!A|E1&E&D2&D1&!D&!C1&C&B1&!B&A1&!A|E1&!E&D2&D1&!D&!C1&C&B1&!B&A1&!A|E1&!E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|E1&E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|!E1&E&D2&!D1&!D&!C1&C&B1&!B&A1&!A|!E1&E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|E1&E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|E1&!E&!D2&!D1&!D&!C1&C&B1&!B&A1&!A|!E1&E&D2&D1&D&!C1&C&!B1&!B&A1&!A|E1&E&D2&D1&D&!C1&C&!B1&!B&A1&!A|E1&!E&D2&D1&D&!C1&C&!B1&!B&A1&!A|E1&!E&D2&D1&D&C1&C&!B1&!B&A1&!A|E1&E&D2&D1&D&C1&C&!B1&!B&A1&!A|!E1&E&D2&D1&D&C1&C&!B1&!B&A1&!A|!E1&E&D2&D1&D&C1&!C&!B1&!B&A1&!A|E1&E&D2&D1&D&C1&!C&!B1&!B&A1&!A|E1&!E&D2&D1&D&C1&!C&!B1&!B&A1&!A|E1&!E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|E1&E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E1&E&D2&D1&D&!C1&!C&!B1&!B&A1&!A|!E1&E&D2&D1&D&!C1&!C&!B1&!B&A1&A|E1&E&D2&D1&D&!C1&!C&!B1&!B&A1&A|E1&!E&D2&D1&D&!C1&!C&!B1&!B&A1&A|E1&!E&D2&D1&D&C1&!C&!B1&!B&A1&A|E1&E&D2&D1&D&C1&!C&!B1&!B&A1&A|!E1&E&D2&D1&D&C1&!C&!B1&!B&A1&A|!E1&E&D2&D1&D&C1&C&!B1&!B&A1&A|E1&E&D2&D1&D&C1&C&!B1&!B&A1&A|E1&!E&D2&D1&D&C1&C&!B1&!B&A1&A|E1&!E&D2&D1&D&!C1&C&!B1&!B&A1&A|E1&E&D2&D1&D&!C1&C&!B1&!B&A1&A|!E1&E&D2&D1&D&!C1&C&!B1&!B&A1&A|E1&!E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|E1&E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&!C1&C&B1&!B&A1&A|!E1&E&D2&!D1&!D&!C1&C&B1&!B&A1&A|E1&E&D2&!D1&!D&!C1&C&B1&!B&A1&A|E1&!E&D2&!D1&!D&!C1&C&B1&!B&A1&A|E1&!E&D2&D1&!D&!C1&C&B1&!B&A1&A|E1&E&D2&D1&!D&!C1&C&B1&!B&A1&A|!E1&E&D2&D1&!D&!C1&C&B1&!B&A1&A|!E1&E&!D2&D1&!D&!C1&C&B1&!B&A1&A|E1&E&!D2&D1&!D&!C1&C&B1&!B&A1&A|E1&!E&!D2&D1&!D&!C1&C&B1&!B&A1&A|E1&!E&!D2&D1&D&!C1&C&B1&!B&A1&A|E1&E&!D2&D1&D&!C1&C&B1&!B&A1&A|!E1&E&!D2&D1&D&!C1&C&B1&!B&A1&A|!E1&E&D2&D1&D&!C1&C&B1&!B&A1&A|E1&E&D2&D1&D&!C1&C&B1&!B&A1&A|E1&!E&D2&D1&D&!C1&C&B1&!B&A1&A|E1&!E&D2&!D1&D&!C1&C&B1&!B&A1&A|E1&E&D2&!D1&D&!C1&C&B1&!B&A1&A|!E1&E&D2&!D1&D&!C1&C&B1&!B&A1&A|!E1&E&!D2&!D1&D&!C1&C&B1&!B&A1&A|E1&E&!D2&!D1&D&!C1&C&B1&!B&A1&A|E1&!E&!D2&!D1&D&!C1&C&B1&!B&A1&A|E1&!E&!D2&!D1&D&C1&C&B1&!B&A1&A|E1&E&!D2&!D1&D&C1&C&B1&!B&A1&A|!E1&E&!D2&!D1&D&C1&C&B1&!B&A1&A|!E1&E&D2&!D1&D&C1&C&B1&!B&A1&A|E1&E&D2&!D1&D&C1&C&B1&!B&A1&A|E1&!E&D2&!D1&D&C1&C&B1&!B&A1&A|E1&!E&D2&D1&D&C1&C&B1&!B&A1&A|E1&E&D2&D1&D&C1&C&B1&!B&A1&A|!E1&E&D2&D1&D&C1&C&B1&!B&A1&A|!E1&E&!D2&D1&D&C1&C&B1&!B&A1&A|E1&E&!D2&D1&D&C1&C&B1&!B&A1&A|E1&!E&!D2&D1&D&C1&C&B1&!B&A1&A|E1&!E&!D2&D1&!D&C1&C&B1&!B&A1&A|E1&E&!D2&D1&!D&C1&C&B1&!B&A1&A|!E1&E&!D2&D1&!D&C1&C&B1&!B&A1&A|!E1&E&D2&D1&!D&C1&C&B1&!B&A1&A|E1&E&D2&D1&!D&C1&C&B1&!B&A1&A|E1&!E&D2&D1&!D&C1&C&B1&!B&A1&A|E1&!E&D2&!D1&!D&C1&C&B1&!B&A1&A|E1&E&D2&!D1&!D&C1&C&B1&!B&A1&A|!E1&E&D2&!D1&!D&C1&C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&C1&C&B1&!B&A1&A|E1&E&!D2&!D1&!D&C1&C&B1&!B&A1&A|E1&!E&!D2&!D1&!D&C1&C&B1&!B&A1&A|E1&!E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|E1&E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|!E1&E&!D2&!D1&!D&C1&!C&B1&!B&A1&A|!E1&E&D2&!D1&!D&C1&!C&B1&!B&A1&A|E1&E&D2&!D1&!D&C1&!C&B1&!B&A1&A|E1&!E&D2&!D1&!D&C1&!C&B1&!B&A1&A|E1&!E&D2&D1&!D&C1&!C&B1&!B&A1&A|E1&E&D2&D1&!D&C1&!C&B1&!B&A1&A|!E1&E&D2&D1&!D&C1&!C&B1&!B&A1&A|!E1&E&!D2&D1&!D&C1&!C&B1&!B&A1&A|E1&E&!D2&D1&!D&C1&!C&B1&!B&A1&A|E1&!E&!D2&D1&!D&C1&!C&B1&!B&A1&A|E1&!E&!D2&D1&D&C1&!C&B1&!B&A1&A|E1&E&!D2&D1&D&C1&!C&B1&!B&A1&A|!E1&E&!D2&D1&D&C1&!C&B1&!B&A1&A|!E1&E&D2&D1&D&C1&!C&B1&!B&A1&A|E1&E&D2&D1&D&C1&!C&B1&!B&A1&A|E1&!E&D2&D1&D&C1&!C&B1&!B&A1&A|E1&!E&D2&!D1&D&C1&!C&B1&!B&A1&A|E1&E&D2&!D1&D&C1&!C&B1&!B&A1&A|!E1&E&D2&!D1&D&C1&!C&B1&!B&A1&A|!E1&E&!D2&!D1&D&C1&!C&B1&!B&A1&A|E1&E&!D2&!D1&D&C1&!C&B1&!B&A1&A|E1&!E&!D2&!D1&D&C1&!C&B1&!B&A1&A|E1&!E&D2&D1&D&!C1&!C&B1&!B&A1&A|E1&E&D2&D1&D&!C1&!C&B1&!B&A1&A|!E1&E&D2&D1&D&!C1&!C&B1&!B&A1&A|!E1&E&D2&D1&D&!C1&!C&B1&B&A1&A|E1&E&D2&D1&D&!C1&!C&B1&B&A1&A|E1&!E&D2&D1&D&!C1&!C&B1&B&A1&A|E1&!E&!D2&!D1&D&C1&!C&B1&B&A1&A|E1&E&!D2&!D1&D&C1&!C&B1&B&A1&A|!E1&E&!D2&!D1&D&C1&!C&B1&B&A1&A|!E1&E&D2&!D1&D&C1&!C&B1&B&A1&A|E1&E&D2&!D1&D&C1&!C&B1&B&A1&A|E1&!E&D2&!D1&D&C1&!C&B1&B&A1&A|E1&!E&D2&D1&D&C1&!C&B1&B&A1&A|E1&E&D2&D1&D&C1&!C&B1&B&A1&A|!E1&E&D2&D1&D&C1&!C&B1&B&A1&A|!E1&E&!D2&D1&D&C1&!C&B1&B&A1&A|E1&E&!D2&D1&D&C1&!C&B1&B&A1&A|E1&!E&!D2&D1&D&C1&!C&B1&B&A1&A|E1&!E&!D2&D1&!D&C1&!C&B1&B&A1&A|E1&E&!D2&D1&!D&C1&!C&B1&B&A1&A|!E1&E&!D2&D1&!D&C1&!C&B1&B&A1&A|!E1&E&D2&D1&!D&C1&!C&B1&B&A1&A|E1&E&D2&D1&!D&C1&!C&B1&B&A1&A|E1&!E&D2&D1&!D&C1&!C&B1&B&A1&A|E1&!E&D2&!D1&!D&C1&!C&B1&B&A1&A|E1&E&D2&!D1&!D&C1&!C&B1&B&A1&A|!E1&E&D2&!D1&!D&C1&!C&B1&B&A1&A|!E1&E&!D2&!D1&!D&C1&!C&B1&B&A1&A|E1&E&!D2&!D1&!D&C1&!C&B1&B&A1&A|E1&!E&!D2&!D1&!D&C1&!C&B1&B&A1&A|E1&!E&!D2&!D1&!D&C1&C&B1&B&A1&A|E1&E&!D2&!D1&!D&C1&C&B1&B&A1&A|!E1&E&!D2&!D1&!D&C1&C&B1&B&A1&A|!E1&E&D2&!D1&!D&C1&C&B1&B&A1&A|E1&E&D2&!D1&!D&C1&C&B1&B&A1&A|E1&!E&D2&!D1&!D&C1&C&B1&B&A1&A|E1&!E&D2&D1&!D&C1&C&B1&B&A1&A|E1&E&D2&D1&!D&C1&C&B1&B&A1&A|!E1&E&D2&D1&!D&C1&C&B1&B&A1&A|!E1&E&!D2&D1&!D&C1&C&B1&B&A1&A|E1&E&!D2&D1&!D&C1&C&B1&B&A1&A|E1&!E&!D2&D1&!D&C1&C&B1&B&A1&A|E1&!E&!D2&D1&D&C1&C&B1&B&A1&A|E1&E&!D2&D1&D&C1&C&B1&B&A1&A|!E1&E&!D2&D1&D&C1&C&B1&B&A1&A|!E1&E&D2&D1&D&C1&C&B1&B&A1&A|E1&E&D2&D1&D&C1&C&B1&B&A1&A|E1&!E&D2&D1&D&C1&C&B1&B&A1&A|E1&!E&D2&!D1&D&C1&C&B1&B&A1&A|E1&E&D2&!D1&D&C1&C&B1&B&A1&A|!E1&E&D2&!D1&D&C1&C&B1&B&A1&A|!E1&E&!D2&!D1&D&C1&C&B1&B&A1&A|E1&E&!D2&!D1&D&C1&C&B1&B&A1&A|E1&!E&!D2&!D1&D&C1&C&B1&B&A1&A|E1&!E&!D2&!D1&D&!C1&C&B1&B&A1&A|E1&E&!D2&!D1&D&!C1&C&B1&B&A1&A|!E1&E&!D2&!D1&D&!C1&C&B1&B&A1&A|!E1&E&D2&!D1&D&!C1&C&B1&B&A1&A|E1&E&D2&!D1&D&!C1&C&B1&B&A1&A|E1&!E&D2&!D1&D&!C1&C&B1&B&A1&A|E1&!E&D2&D1&D&!C1&C&B1&B&A1&A|E1&E&D2&D1&D&!C1&C&B1&B&A1&A|!E1&E&D2&D1&D&!C1&C&B1&B&A1&A|!E1&E&!D2&D1&D&!C1&C&B1&B&A1&A|E1&E&!D2&D1&D&!C1&C&B1&B&A1&A|E1&!E&!D2&D1&D&!C1&C&B1&B&A1&A|E1&!E&!D2&D1&!D&!C1&C&B1&B&A1&A|E1&E&!D2&D1&!D&!C1&C&B1&B&A1&A|!E1&E&!D2&D1&!D&!C1&C&B1&B&A1&A|!E1&E&D2&D1&!D&!C1&C&B1&B&A1&A|E1&E&D2&D1&!D&!C1&C&B1&B&A1&A|E1&!E&D2&D1&!D&!C1&C&B1&B&A1&A|E1&!E&D2&!D1&!D&!C1&C&B1&B&A1&A|E1&E&D2&!D1&!D&!C1&C&B1&B&A1&A|!E1&E&D2&!D1&!D&!C1&C&B1&B&A1&A|!E1&E&!D2&!D1&!D&!C1&C&B1&B&A1&A|E1&E&!D2&!D1&!D&!C1&C&B1&B&A1&A|E1&!E&!D2&!D1&!D&!C1&C&B1&B&A1&A|E1&!E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|E1&E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&!C1&C&!B1&B&A1&A|!E1&E&D2&!D1&!D&!C1&C&!B1&B&A1&A|E1&E&D2&!D1&!D&!C1&C&!B1&B&A1&A|E1&!E&D2&!D1&!D&!C1&C&!B1&B&A1&A|E1&!E&D2&D1&!D&!C1&C&!B1&B&A1&A|E1&E&D2&D1&!D&!C1&C&!B1&B&A1&A|!E1&E&D2&D1&!D&!C1&C&!B1&B&A1&A|!E1&E&!D2&D1&!D&!C1&C&!B1&B&A1&A|E1&E&!D2&D1&!D&!C1&C&!B1&B&A1&A|E1&!E&!D2&D1&!D&!C1&C&!B1&B&A1&A|E1&!E&!D2&D1&D&!C1&C&!B1&B&A1&A|E1&E&!D2&D1&D&!C1&C&!B1&B&A1&A|!E1&E&!D2&D1&D&!C1&C&!B1&B&A1&A|!E1&E&D2&D1&D&!C1&C&!B1&B&A1&A|E1&E&D2&D1&D&!C1&C&!B1&B&A1&A|E1&!E&D2&D1&D&!C1&C&!B1&B&A1&A|E1&!E&D2&!D1&D&!C1&C&!B1&B&A1&A|E1&E&D2&!D1&D&!C1&C&!B1&B&A1&A|!E1&E&D2&!D1&D&!C1&C&!B1&B&A1&A|!E1&E&!D2&!D1&D&!C1&C&!B1&B&A1&A|E1&E&!D2&!D1&D&!C1&C&!B1&B&A1&A|E1&!E&!D2&!D1&D&!C1&C&!B1&B&A1&A|E1&!E&!D2&!D1&D&C1&C&!B1&B&A1&A|E1&E&!D2&!D1&D&C1&C&!B1&B&A1&A|!E1&E&!D2&!D1&D&C1&C&!B1&B&A1&A|!E1&E&D2&!D1&D&C1&C&!B1&B&A1&A|E1&E&D2&!D1&D&C1&C&!B1&B&A1&A|E1&!E&D2&!D1&D&C1&C&!B1&B&A1&A|E1&!E&D2&D1&D&C1&C&!B1&B&A1&A|E1&E&D2&D1&D&C1&C&!B1&B&A1&A|!E1&E&D2&D1&D&C1&C&!B1&B&A1&A|!E1&E&!D2&D1&D&C1&C&!B1&B&A1&A|E1&E&!D2&D1&D&C1&C&!B1&B&A1&A|E1&!E&!D2&D1&D&C1&C&!B1&B&A1&A|E1&!E&!D2&D1&!D&C1&C&!B1&B&A1&A|E1&E&!D2&D1&!D&C1&C&!B1&B&A1&A|!E1&E&!D2&D1&!D&C1&C&!B1&B&A1&A|!E1&E&D2&D1&!D&C1&C&!B1&B&A1&A|E1&E&D2&D1&!D&C1&C&!B1&B&A1&A|E1&!E&D2&D1&!D&C1&C&!B1&B&A1&A|E1&!E&D2&!D1&!D&C1&C&!B1&B&A1&A|E1&E&D2&!D1&!D&C1&C&!B1&B&A1&A|!E1&E&D2&!D1&!D&C1&C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&C1&C&!B1&B&A1&A|E1&E&!D2&!D1&!D&C1&C&!B1&B&A1&A|E1&!E&!D2&!D1&!D&C1&C&!B1&B&A1&A|E1&!E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|E1&E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|!E1&E&!D2&!D1&!D&C1&!C&!B1&B&A1&A|!E1&E&D2&!D1&!D&C1&!C&!B1&B&A1&A|E1&E&D2&!D1&!D&C1&!C&!B1&B&A1&A|E1&!E&D2&!D1&!D&C1&!C&!B1&B&A1&A|E1&!E&D2&D1&!D&C1&!C&!B1&B&A1&A|E1&E&D2&D1&!D&C1&!C&!B1&B&A1&A|!E1&E&D2&D1&!D&C1&!C&!B1&B&A1&A|!E1&E&!D2&D1&!D&C1&!C&!B1&B&A1&A|E1&E&!D2&D1&!D&C1&!C&!B1&B&A1&A|E1&!E&!D2&D1&!D&C1&!C&!B1&B&A1&A|E1&!E&!D2&D1&D&C1&!C&!B1&B&A1&A|E1&E&!D2&D1&D&C1&!C&!B1&B&A1&A|!E1&E&!D2&D1&D&C1&!C&!B1&B&A1&A|!E1&E&D2&D1&D&C1&!C&!B1&B&A1&A|E1&E&D2&D1&D&C1&!C&!B1&B&A1&A|E1&!E&D2&D1&D&C1&!C&!B1&B&A1&A|E1&!E&D2&!D1&D&C1&!C&!B1&B&A1&A|E1&E&D2&!D1&D&C1&!C&!B1&B&A1&A|!E1&E&D2&!D1&D&C1&!C&!B1&B&A1&A|!E1&E&!D2&!D1&D&C1&!C&!B1&B&A1&A|E1&E&!D2&!D1&D&C1&!C&!B1&B&A1&A|E1&!E&!D2&!D1&D&C1&!C&!B1&B&A1&A|E1&!E&D2&D1&D&!C1&!C&!B1&B&A1&A|E1&E&D2&D1&D&!C1&!C&!B1&B&A1&A|!E1&E&D2&D1&D&!C1&!C&!B1&B&A1&A|!E1&E&D2&D1&D&!C1&!C&!B1&B&!A1&A|E1&E&D2&D1&D&!C1&!C&!B1&B&!A1&A|E1&!E&D2&D1&D&!C1&!C&!B1&B&!A1&A|E1&!E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|E1&E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|!E1&E&!D2&!D1&D&C1&!C&!B1&B&!A1&A|!E1&E&D2&!D1&D&C1&!C&!B1&B&!A1&A|E1&E&D2&!D1&D&C1&!C&!B1&B&!A1&A|E1&!E&D2&!D1&D&C1&!C&!B1&B&!A1&A|E1&!E&D2&D1&D&C1&!C&!B1&B&!A1&A|E1&E&D2&D1&D&C1&!C&!B1&B&!A1&A|!E1&E&D2&D1&D&C1&!C&!B1&B&!A1&A|!E1&E&!D2&D1&D&C1&!C&!B1&B&!A1&A|E1&E&!D2&D1&D&C1&!C&!B1&B&!A1&A|E1&!E&!D2&D1&D&C1&!C&!B1&B&!A1&A|E1&!E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|E1&E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|!E1&E&!D2&D1&!D&C1&!C&!B1&B&!A1&A|!E1&E&D2&D1&!D&C1&!C&!B1&B&!A1&A|E1&E&D2&D1&!D&C1&!C&!B1&B&!A1&A|E1&!E&D2&D1&!D&C1&!C&!B1&B&!A1&A|E1&!E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|E1&E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|!E1&E&D2&!D1&!D&C1&!C&!B1&B&!A1&A|!E1&E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|E1&E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&C1&!C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|E1&E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|!E1&E&!D2&!D1&!D&C1&C&!B1&B&!A1&A|!E1&E&D2&!D1&!D&C1&C&!B1&B&!A1&A|E1&E&D2&!D1&!D&C1&C&!B1&B&!A1&A|E1&!E&D2&!D1&!D&C1&C&!B1&B&!A1&A|E1&!E&D2&D1&!D&C1&C&!B1&B&!A1&A|E1&E&D2&D1&!D&C1&C&!B1&B&!A1&A|!E1&E&D2&D1&!D&C1&C&!B1&B&!A1&A|!E1&E&!D2&D1&!D&C1&C&!B1&B&!A1&A|E1&E&!D2&D1&!D&C1&C&!B1&B&!A1&A|E1&!E&!D2&D1&!D&C1&C&!B1&B&!A1&A|E1&!E&!D2&D1&D&C1&C&!B1&B&!A1&A|E1&E&!D2&D1&D&C1&C&!B1&B&!A1&A|!E1&E&!D2&D1&D&C1&C&!B1&B&!A1&A|!E1&E&D2&D1&D&C1&C&!B1&B&!A1&A|E1&E&D2&D1&D&C1&C&!B1&B&!A1&A|E1&!E&D2&D1&D&C1&C&!B1&B&!A1&A|E1&!E&D2&!D1&D&C1&C&!B1&B&!A1&A|E1&E&D2&!D1&D&C1&C&!B1&B&!A1&A|!E1&E&D2&!D1&D&C1&C&!B1&B&!A1&A|!E1&E&!D2&!D1&D&C1&C&!B1&B&!A1&A|E1&E&!D2&!D1&D&C1&C&!B1&B&!A1&A|E1&!E&!D2&!D1&D&C1&C&!B1&B&!A1&A|E1&!E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|E1&E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|!E1&E&!D2&!D1&D&!C1&C&!B1&B&!A1&A|!E1&E&D2&!D1&D&!C1&C&!B1&B&!A1&A|E1&E&D2&!D1&D&!C1&C&!B1&B&!A1&A|E1&!E&D2&!D1&D&!C1&C&!B1&B&!A1&A|E1&!E&D2&D1&D&!C1&C&!B1&B&!A1&A|E1&E&D2&D1&D&!C1&C&!B1&B&!A1&A|!E1&E&D2&D1&D&!C1&C&!B1&B&!A1&A|!E1&E&!D2&D1&D&!C1&C&!B1&B&!A1&A|E1&E&!D2&D1&D&!C1&C&!B1&B&!A1&A|E1&!E&!D2&D1&D&!C1&C&!B1&B&!A1&A|E1&!E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|E1&E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|!E1&E&!D2&D1&!D&!C1&C&!B1&B&!A1&A|!E1&E&D2&D1&!D&!C1&C&!B1&B&!A1&A|E1&E&D2&D1&!D&!C1&C&!B1&B&!A1&A|E1&!E&D2&D1&!D&!C1&C&!B1&B&!A1&A|E1&!E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|E1&E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|!E1&E&D2&!D1&!D&!C1&C&!B1&B&!A1&A|!E1&E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|E1&E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&!C1&C&!B1&B&!A1&A|E1&!E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|E1&E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&!C1&C&B1&B&!A1&A|!E1&E&D2&!D1&!D&!C1&C&B1&B&!A1&A|E1&E&D2&!D1&!D&!C1&C&B1&B&!A1&A|E1&!E&D2&!D1&!D&!C1&C&B1&B&!A1&A|E1&!E&D2&D1&!D&!C1&C&B1&B&!A1&A|E1&E&D2&D1&!D&!C1&C&B1&B&!A1&A|!E1&E&D2&D1&!D&!C1&C&B1&B&!A1&A|!E1&E&!D2&D1&!D&!C1&C&B1&B&!A1&A|E1&E&!D2&D1&!D&!C1&C&B1&B&!A1&A|E1&!E&!D2&D1&!D&!C1&C&B1&B&!A1&A|E1&!E&!D2&D1&D&!C1&C&B1&B&!A1&A|E1&E&!D2&D1&D&!C1&C&B1&B&!A1&A|!E1&E&!D2&D1&D&!C1&C&B1&B&!A1&A|!E1&E&D2&D1&D&!C1&C&B1&B&!A1&A|E1&E&D2&D1&D&!C1&C&B1&B&!A1&A|E1&!E&D2&D1&D&!C1&C&B1&B&!A1&A|E1&!E&D2&!D1&D&!C1&C&B1&B&!A1&A|E1&E&D2&!D1&D&!C1&C&B1&B&!A1&A|!E1&E&D2&!D1&D&!C1&C&B1&B&!A1&A|!E1&E&!D2&!D1&D&!C1&C&B1&B&!A1&A|E1&E&!D2&!D1&D&!C1&C&B1&B&!A1&A|E1&!E&!D2&!D1&D&!C1&C&B1&B&!A1&A|E1&!E&!D2&!D1&D&C1&C&B1&B&!A1&A|E1&E&!D2&!D1&D&C1&C&B1&B&!A1&A|!E1&E&!D2&!D1&D&C1&C&B1&B&!A1&A|!E1&E&D2&!D1&D&C1&C&B1&B&!A1&A|E1&E&D2&!D1&D&C1&C&B1&B&!A1&A|E1&!E&D2&!D1&D&C1&C&B1&B&!A1&A|E1&!E&D2&D1&D&C1&C&B1&B&!A1&A|E1&E&D2&D1&D&C1&C&B1&B&!A1&A|!E1&E&D2&D1&D&C1&C&B1&B&!A1&A|!E1&E&!D2&D1&D&C1&C&B1&B&!A1&A|E1&E&!D2&D1&D&C1&C&B1&B&!A1&A|E1&!E&!D2&D1&D&C1&C&B1&B&!A1&A|E1&!E&!D2&D1&!D&C1&C&B1&B&!A1&A|E1&E&!D2&D1&!D&C1&C&B1&B&!A1&A|!E1&E&!D2&D1&!D&C1&C&B1&B&!A1&A|!E1&E&D2&D1&!D&C1&C&B1&B&!A1&A|E1&E&D2&D1&!D&C1&C&B1&B&!A1&A|E1&!E&D2&D1&!D&C1&C&B1&B&!A1&A|E1&!E&D2&!D1&!D&C1&C&B1&B&!A1&A|E1&E&D2&!D1&!D&C1&C&B1&B&!A1&A|!E1&E&D2&!D1&!D&C1&C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&C1&C&B1&B&!A1&A|E1&E&!D2&!D1&!D&C1&C&B1&B&!A1&A|E1&!E&!D2&!D1&!D&C1&C&B1&B&!A1&A|E1&!E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|E1&E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|!E1&E&!D2&!D1&!D&C1&!C&B1&B&!A1&A|!E1&E&D2&!D1&!D&C1&!C&B1&B&!A1&A|E1&E&D2&!D1&!D&C1&!C&B1&B&!A1&A|E1&!E&D2&!D1&!D&C1&!C&B1&B&!A1&A|E1&!E&D2&D1&!D&C1&!C&B1&B&!A1&A|E1&E&D2&D1&!D&C1&!C&B1&B&!A1&A|!E1&E&D2&D1&!D&C1&!C&B1&B&!A1&A|!E1&E&!D2&D1&!D&C1&!C&B1&B&!A1&A|E1&E&!D2&D1&!D&C1&!C&B1&B&!A1&A|E1&!E&!D2&D1&!D&C1&!C&B1&B&!A1&A|E1&!E&!D2&D1&D&C1&!C&B1&B&!A1&A|E1&E&!D2&D1&D&C1&!C&B1&B&!A1&A|!E1&E&!D2&D1&D&C1&!C&B1&B&!A1&A|!E1&E&D2&D1&D&C1&!C&B1&B&!A1&A|E1&E&D2&D1&D&C1&!C&B1&B&!A1&A|E1&!E&D2&D1&D&C1&!C&B1&B&!A1&A|E1&!E&D2&!D1&D&C1&!C&B1&B&!A1&A|E1&E&D2&!D1&D&C1&!C&B1&B&!A1&A|!E1&E&D2&!D1&D&C1&!C&B1&B&!A1&A|!E1&E&!D2&!D1&D&C1&!C&B1&B&!A1&A|E1&E&!D2&!D1&D&C1&!C&B1&B&!A1&A|E1&!E&!D2&!D1&D&C1&!C&B1&B&!A1&A|E1&!E&D2&D1&D&!C1&!C&B1&B&!A1&A|E1&E&D2&D1&D&!C1&!C&B1&B&!A1&A|!E1&E&D2&D1&D&!C1&!C&B1&B&!A1&A|!E1&E&D2&D1&D&!C1&!C&B1&!B&!A1&A|E1&E&D2&D1&D&!C1&!C&B1&!B&!A1&A|E1&!E&D2&D1&D&!C1&!C&B1&!B&!A1&A|E1&!E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|E1&E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|!E1&E&!D2&!D1&D&C1&!C&B1&!B&!A1&A|!E1&E&D2&!D1&D&C1&!C&B1&!B&!A1&A|E1&E&D2&!D1&D&C1&!C&B1&!B&!A1&A|E1&!E&D2&!D1&D&C1&!C&B1&!B&!A1&A|E1&!E&D2&D1&D&C1&!C&B1&!B&!A1&A|E1&E&D2&D1&D&C1&!C&B1&!B&!A1&A|!E1&E&D2&D1&D&C1&!C&B1&!B&!A1&A|!E1&E&!D2&D1&D&C1&!C&B1&!B&!A1&A|E1&E&!D2&D1&D&C1&!C&B1&!B&!A1&A|E1&!E&!D2&D1&D&C1&!C&B1&!B&!A1&A|E1&!E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|E1&E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|!E1&E&!D2&D1&!D&C1&!C&B1&!B&!A1&A|!E1&E&D2&D1&!D&C1&!C&B1&!B&!A1&A|E1&E&D2&D1&!D&C1&!C&B1&!B&!A1&A|E1&!E&D2&D1&!D&C1&!C&B1&!B&!A1&A|E1&!E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|E1&E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|!E1&E&D2&!D1&!D&C1&!C&B1&!B&!A1&A|!E1&E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|E1&E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|E1&!E&!D2&!D1&!D&C1&!C&B1&!B&!A1&A|E1&!E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|E1&E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|!E1&E&!D2&!D1&!D&C1&C&B1&!B&!A1&A|!E1&E&D2&!D1&!D&C1&C&B1&!B&!A1&A|E1&E&D2&!D1&!D&C1&C&B1&!B&!A1&A|E1&!E&D2&!D1&!D&C1&C&B1&!B&!A1&A|E1&!E&D2&D1&!D&C1&C&B1&!B&!A1&A|E1&E&D2&D1&!D&C1&C&B1&!B&!A1&A|!E1&E&D2&D1&!D&C1&C&B1&!B&!A1&A|!E1&E&!D2&D1&!D&C1&C&B1&!B&!A1&A|E1&E&!D2&D1&!D&C1&C&B1&!B&!A1&A|E1&!E&!D2&D1&!D&C1&C&B1&!B&!A1&A|E1&!E&!D2&D1&D&C1&C&B1&!B&!A1&A|E1&E&!D2&D1&D&C1&C&B1&!B&!A1&A|!E1&E&!D2&D1&D&C1&C&B1&!B&!A1&A|!E1&E&D2&D1&D&C1&C&B1&!B&!A1&A|E1&E&D2&D1&D&C1&C&B1&!B&!A1&A|E1&!E&D2&D1&D&C1&C&B1&!B&!A1&A|E1&!E&D2&!D1&D&C1&C&B1&!B&!A1&A|E1&E&D2&!D1&D&C1&C&B1&!B&!A1&A|!E1&E&D2&!D1&D&C1&C&B1&!B&!A1&A|!E1&E&!D2&!D1&D&C1&C&B1&!B&!A1&A|E1&E&!D2&!D1&D&C1&C&B1&!B&!A1&A|E1&!E&!D2&!D1&D&C1&C&B1&!B&!A1&A|E1&!E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|E1&E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|!E1&E&!D2&!D1&D&!C1&C&B1&!B&!A1&A|!E1&E&D2&!D1&D&!C1&C&B1&!B&!A1&A|E1&E&D2&!D1&D&!C1&C&B1&!B&!A1&A|E1&!E&D2&!D1&D&!C1&C&B1&!B&!A1&A|E1&!E&D2&D1&D&!C1&C&B1&!B&!A1&A|E1&E&D2&D1&D&!C1&C&B1&!B&!A1&A|!E1&E&D2&D1&D&!C1&C&B1&!B&!A1&A|!E1&E&!D2&D1&D&!C1&C&B1&!B&!A1&A|E1&E&!D2&D1&D&!C1&C&B1&!B&!A1&A|E1&!E&!D2&D1&D&!C1&C&B1&!B&!A1&A|E1&!E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|E1&E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|!E1&E&!D2&D1&!D&!C1&C&B1&!B&!A1&A|!E1&E&D2&D1&!D&!C1&C&B1&!B&!A1&A|E1&E&D2&D1&!D&!C1&C&B1&!B&!A1&A|E1&!E&D2&D1&!D&!C1&C&B1&!B&!A1&A|E1&!E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|E1&E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|!E1&E&D2&!D1&!D&!C1&C&B1&!B&!A1&A|!E1&E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|E1&E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|E1&!E&!D2&!D1&!D&!C1&C&B1&!B&!A1&A|!E1&E&D2&D1&D&!C1&C&!B1&!B&!A1&A|E1&E&D2&D1&D&!C1&C&!B1&!B&!A1&A|E1&!E&D2&D1&D&!C1&C&!B1&!B&!A1&A|E1&!E&D2&D1&D&C1&C&!B1&!B&!A1&A|E1&E&D2&D1&D&C1&C&!B1&!B&!A1&A|!E1&E&D2&D1&D&C1&C&!B1&!B&!A1&A|!E1&E&D2&D1&D&C1&!C&!B1&!B&!A1&A|E1&E&D2&D1&D&C1&!C&!B1&!B&!A1&A|E1&!E&D2&D1&D&C1&!C&!B1&!B&!A1&A|E1&!E&D2&D1&D&!C1&!C&!B1&!B&!A1&A|E1&E&D2&D1&D&!C1&!C&!B1&!B&!A1&A|!E1&E&D2&D1&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOOAAOOAI22232.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OR4 -l OR4 -i A B C D -o Z -f Z=!(!A&!B&!C&!D) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OR4.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOOAOI22221 -l AAOOOAOI22221 -i E D1 D C1 C B1 B A1 A -o Y -f Y=(!E&!D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D1&!D&!C1&!C&!B1&!B&!A1&!A|!E&D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D1&D&!C1&!C&!B1&!B&!A1&!A|!E&!D1&D&C1&!C&!B1&!B&!A1&!A|!E&D1&D&C1&!C&!B1&!B&!A1&!A|!E&D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D1&!D&C1&!C&!B1&!B&!A1&!A|!E&!D1&!D&C1&C&!B1&!B&!A1&!A|!E&D1&!D&C1&C&!B1&!B&!A1&!A|!E&D1&D&C1&C&!B1&!B&!A1&!A|!E&!D1&D&C1&C&!B1&!B&!A1&!A|!E&!D1&D&!C1&C&!B1&!B&!A1&!A|!E&D1&D&!C1&C&!B1&!B&!A1&!A|!E&D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D1&!D&!C1&C&!B1&!B&!A1&!A|!E&!D1&!D&!C1&C&B1&!B&!A1&!A|!E&D1&!D&!C1&C&B1&!B&!A1&!A|!E&D1&D&!C1&C&B1&!B&!A1&!A|!E&!D1&D&!C1&C&B1&!B&!A1&!A|!E&!D1&D&C1&C&B1&!B&!A1&!A|!E&D1&D&C1&C&B1&!B&!A1&!A|!E&D1&!D&C1&C&B1&!B&!A1&!A|!E&!D1&!D&C1&C&B1&!B&!A1&!A|!E&!D1&!D&C1&!C&B1&!B&!A1&!A|!E&D1&!D&C1&!C&B1&!B&!A1&!A|!E&D1&D&C1&!C&B1&!B&!A1&!A|!E&!D1&D&C1&!C&B1&!B&!A1&!A|!E&!D1&D&!C1&!C&B1&!B&!A1&!A|!E&D1&D&!C1&!C&B1&!B&!A1&!A|!E&D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D1&!D&!C1&!C&B1&!B&!A1&!A|!E&!D1&!D&!C1&!C&B1&B&!A1&!A|!E&D1&!D&!C1&!C&B1&B&!A1&!A|!E&D1&D&!C1&!C&B1&B&!A1&!A|!E&!D1&D&!C1&!C&B1&B&!A1&!A|!E&!D1&!D&C1&!C&B1&B&!A1&!A|!E&!D1&!D&C1&C&B1&B&!A1&!A|!E&!D1&!D&!C1&C&B1&B&!A1&!A|!E&!D1&!D&!C1&C&!B1&B&!A1&!A|!E&D1&!D&!C1&C&!B1&B&!A1&!A|!E&D1&D&!C1&C&!B1&B&!A1&!A|!E&!D1&D&!C1&C&!B1&B&!A1&!A|!E&!D1&D&C1&C&!B1&B&!A1&!A|!E&D1&D&C1&C&!B1&B&!A1&!A|!E&D1&!D&C1&C&!B1&B&!A1&!A|!E&!D1&!D&C1&C&!B1&B&!A1&!A|!E&!D1&!D&C1&!C&!B1&B&!A1&!A|!E&D1&!D&C1&!C&!B1&B&!A1&!A|!E&D1&D&C1&!C&!B1&B&!A1&!A|!E&!D1&D&C1&!C&!B1&B&!A1&!A|!E&!D1&D&!C1&!C&!B1&B&!A1&!A|!E&D1&D&!C1&!C&!B1&B&!A1&!A|!E&D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D1&!D&!C1&!C&!B1&B&!A1&!A|!E&!D1&!D&!C1&!C&!B1&B&A1&!A|!E&D1&!D&!C1&!C&!B1&B&A1&!A|!E&D1&D&!C1&!C&!B1&B&A1&!A|!E&!D1&D&!C1&!C&!B1&B&A1&!A|!E&!D1&D&C1&!C&!B1&B&A1&!A|!E&D1&D&C1&!C&!B1&B&A1&!A|!E&D1&!D&C1&!C&!B1&B&A1&!A|!E&!D1&!D&C1&!C&!B1&B&A1&!A|!E&!D1&!D&C1&C&!B1&B&A1&!A|!E&D1&!D&C1&C&!B1&B&A1&!A|!E&D1&D&C1&C&!B1&B&A1&!A|!E&!D1&D&C1&C&!B1&B&A1&!A|!E&!D1&D&!C1&C&!B1&B&A1&!A|!E&D1&D&!C1&C&!B1&B&A1&!A|!E&D1&!D&!C1&C&!B1&B&A1&!A|!E&!D1&!D&!C1&C&!B1&B&A1&!A|!E&!D1&!D&!C1&C&B1&B&A1&!A|!E&!D1&!D&C1&C&B1&B&A1&!A|!E&!D1&!D&C1&!C&B1&B&A1&!A|!E&!D1&D&!C1&!C&B1&B&A1&!A|!E&D1&D&!C1&!C&B1&B&A1&!A|!E&D1&!D&!C1&!C&B1&B&A1&!A|!E&!D1&!D&!C1&!C&B1&B&A1&!A|!E&!D1&!D&!C1&!C&B1&!B&A1&!A|!E&D1&!D&!C1&!C&B1&!B&A1&!A|!E&D1&D&!C1&!C&B1&!B&A1&!A|!E&!D1&D&!C1&!C&B1&!B&A1&!A|!E&!D1&D&C1&!C&B1&!B&A1&!A|!E&D1&D&C1&!C&B1&!B&A1&!A|!E&D1&!D&C1&!C&B1&!B&A1&!A|!E&!D1&!D&C1&!C&B1&!B&A1&!A|!E&!D1&!D&C1&C&B1&!B&A1&!A|!E&D1&!D&C1&C&B1&!B&A1&!A|!E&D1&D&C1&C&B1&!B&A1&!A|!E&!D1&D&C1&C&B1&!B&A1&!A|!E&!D1&D&!C1&C&B1&!B&A1&!A|!E&D1&D&!C1&C&B1&!B&A1&!A|!E&D1&!D&!C1&C&B1&!B&A1&!A|!E&!D1&!D&!C1&C&B1&!B&A1&!A|!E&!D1&!D&!C1&C&!B1&!B&A1&!A|!E&D1&!D&!C1&C&!B1&!B&A1&!A|!E&D1&D&!C1&C&!B1&!B&A1&!A|!E&!D1&D&!C1&C&!B1&!B&A1&!A|!E&!D1&D&C1&C&!B1&!B&A1&!A|!E&D1&D&C1&C&!B1&!B&A1&!A|!E&D1&!D&C1&C&!B1&!B&A1&!A|!E&!D1&!D&C1&C&!B1&!B&A1&!A|!E&!D1&!D&C1&!C&!B1&!B&A1&!A|!E&D1&!D&C1&!C&!B1&!B&A1&!A|!E&D1&D&C1&!C&!B1&!B&A1&!A|!E&!D1&D&C1&!C&!B1&!B&A1&!A|!E&!D1&D&!C1&!C&!B1&!B&A1&!A|!E&D1&D&!C1&!C&!B1&!B&A1&!A|!E&D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D1&!D&!C1&!C&!B1&!B&A1&!A|!E&!D1&!D&!C1&!C&!B1&!B&A1&A|!E&D1&!D&!C1&!C&!B1&!B&A1&A|!E&D1&D&!C1&!C&!B1&!B&A1&A|!E&!D1&D&!C1&!C&!B1&!B&A1&A|!E&!D1&!D&C1&!C&!B1&!B&A1&A|!E&!D1&!D&C1&C&!B1&!B&A1&A|!E&!D1&!D&!C1&C&!B1&!B&A1&A|!E&!D1&!D&!C1&C&B1&!B&A1&A|!E&!D1&!D&C1&C&B1&!B&A1&A|!E&!D1&!D&C1&!C&B1&!B&A1&A|!E&!D1&D&!C1&!C&B1&!B&A1&A|!E&D1&D&!C1&!C&B1&!B&A1&A|!E&D1&!D&!C1&!C&B1&!B&A1&A|!E&!D1&!D&!C1&!C&B1&!B&A1&A|!E&!D1&!D&!C1&!C&B1&B&A1&A|!E&D1&!D&!C1&!C&B1&B&A1&A|!E&D1&D&!C1&!C&B1&B&A1&A|!E&!D1&D&!C1&!C&B1&B&A1&A|!E&!D1&!D&C1&!C&B1&B&A1&A|!E&!D1&!D&C1&C&B1&B&A1&A|!E&!D1&!D&!C1&C&B1&B&A1&A|!E&!D1&!D&!C1&C&!B1&B&A1&A|!E&!D1&!D&C1&C&!B1&B&A1&A|!E&!D1&!D&C1&!C&!B1&B&A1&A|!E&!D1&D&!C1&!C&!B1&B&A1&A|!E&D1&D&!C1&!C&!B1&B&A1&A|!E&D1&!D&!C1&!C&!B1&B&A1&A|!E&!D1&!D&!C1&!C&!B1&B&A1&A|!E&!D1&!D&!C1&!C&!B1&B&!A1&A|!E&D1&!D&!C1&!C&!B1&B&!A1&A|!E&D1&D&!C1&!C&!B1&B&!A1&A|!E&!D1&D&!C1&!C&!B1&B&!A1&A|!E&!D1&D&C1&!C&!B1&B&!A1&A|!E&D1&D&C1&!C&!B1&B&!A1&A|!E&D1&!D&C1&!C&!B1&B&!A1&A|!E&!D1&!D&C1&!C&!B1&B&!A1&A|!E&!D1&!D&C1&C&!B1&B&!A1&A|!E&D1&!D&C1&C&!B1&B&!A1&A|!E&D1&D&C1&C&!B1&B&!A1&A|!E&!D1&D&C1&C&!B1&B&!A1&A|!E&!D1&D&!C1&C&!B1&B&!A1&A|!E&D1&D&!C1&C&!B1&B&!A1&A|!E&D1&!D&!C1&C&!B1&B&!A1&A|!E&!D1&!D&!C1&C&!B1&B&!A1&A|!E&!D1&!D&!C1&C&B1&B&!A1&A|!E&!D1&!D&C1&C&B1&B&!A1&A|!E&!D1&!D&C1&!C&B1&B&!A1&A|!E&!D1&D&!C1&!C&B1&B&!A1&A|!E&D1&D&!C1&!C&B1&B&!A1&A|!E&D1&!D&!C1&!C&B1&B&!A1&A|!E&!D1&!D&!C1&!C&B1&B&!A1&A|!E&!D1&!D&!C1&!C&B1&!B&!A1&A|!E&D1&!D&!C1&!C&B1&!B&!A1&A|!E&D1&D&!C1&!C&B1&!B&!A1&A|!E&!D1&D&!C1&!C&B1&!B&!A1&A|!E&!D1&D&C1&!C&B1&!B&!A1&A|!E&D1&D&C1&!C&B1&!B&!A1&A|!E&D1&!D&C1&!C&B1&!B&!A1&A|!E&!D1&!D&C1&!C&B1&!B&!A1&A|!E&!D1&!D&C1&C&B1&!B&!A1&A|!E&D1&!D&C1&C&B1&!B&!A1&A|!E&D1&D&C1&C&B1&!B&!A1&A|!E&!D1&D&C1&C&B1&!B&!A1&A|!E&!D1&D&!C1&C&B1&!B&!A1&A|!E&D1&D&!C1&C&B1&!B&!A1&A|!E&D1&!D&!C1&C&B1&!B&!A1&A|!E&!D1&!D&!C1&C&B1&!B&!A1&A|!E&!D1&!D&!C1&C&!B1&!B&!A1&A|!E&D1&!D&!C1&C&!B1&!B&!A1&A|!E&D1&D&!C1&C&!B1&!B&!A1&A|!E&!D1&D&!C1&C&!B1&!B&!A1&A|!E&!D1&D&C1&C&!B1&!B&!A1&A|!E&D1&D&C1&C&!B1&!B&!A1&A|!E&D1&!D&C1&C&!B1&!B&!A1&A|!E&!D1&!D&C1&C&!B1&!B&!A1&A|!E&!D1&!D&C1&!C&!B1&!B&!A1&A|!E&D1&!D&C1&!C&!B1&!B&!A1&A|!E&D1&D&C1&!C&!B1&!B&!A1&A|!E&!D1&D&C1&!C&!B1&!B&!A1&A|!E&!D1&D&!C1&!C&!B1&!B&!A1&A|!E&D1&D&!C1&!C&!B1&!B&!A1&A|!E&D1&!D&!C1&!C&!B1&!B&!A1&A|!E&!D1&!D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOOAOI22221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AAOOAAOAI22221 -l AAOOAAOAI22221 -i E D1 D C1 C B1 B A1 A -o Y -f Y=!(E&D1&D&!C1&!C&!B1&!B&!A1&!A|E&D1&D&C1&!C&!B1&!B&!A1&!A|E&D1&D&C1&C&!B1&!B&!A1&!A|E&D1&D&!C1&C&!B1&!B&!A1&!A|E&D1&D&!C1&C&B1&!B&!A1&!A|E&D1&D&C1&C&B1&!B&!A1&!A|E&D1&D&C1&!C&B1&!B&!A1&!A|E&D1&D&!C1&!C&B1&!B&!A1&!A|E&D1&D&!C1&!C&B1&B&!A1&!A|E&!D1&D&C1&!C&B1&B&!A1&!A|E&D1&D&C1&!C&B1&B&!A1&!A|E&D1&!D&C1&!C&B1&B&!A1&!A|E&!D1&!D&C1&!C&B1&B&!A1&!A|E&!D1&!D&C1&C&B1&B&!A1&!A|E&D1&!D&C1&C&B1&B&!A1&!A|E&D1&D&C1&C&B1&B&!A1&!A|E&!D1&D&C1&C&B1&B&!A1&!A|E&!D1&D&!C1&C&B1&B&!A1&!A|E&D1&D&!C1&C&B1&B&!A1&!A|E&D1&!D&!C1&C&B1&B&!A1&!A|E&!D1&!D&!C1&C&B1&B&!A1&!A|E&D1&D&!C1&C&!B1&B&!A1&!A|E&D1&D&C1&C&!B1&B&!A1&!A|E&D1&D&C1&!C&!B1&B&!A1&!A|E&D1&D&!C1&!C&!B1&B&!A1&!A|E&D1&D&!C1&!C&!B1&B&A1&!A|E&D1&D&C1&!C&!B1&B&A1&!A|E&D1&D&C1&C&!B1&B&A1&!A|E&D1&D&!C1&C&!B1&B&A1&!A|E&!D1&!D&!C1&C&B1&B&A1&!A|E&D1&!D&!C1&C&B1&B&A1&!A|E&D1&D&!C1&C&B1&B&A1&!A|E&!D1&D&!C1&C&B1&B&A1&!A|E&!D1&D&C1&C&B1&B&A1&!A|E&D1&D&C1&C&B1&B&A1&!A|E&D1&!D&C1&C&B1&B&A1&!A|E&!D1&!D&C1&C&B1&B&A1&!A|E&!D1&!D&C1&!C&B1&B&A1&!A|E&D1&!D&C1&!C&B1&B&A1&!A|E&D1&D&C1&!C&B1&B&A1&!A|E&!D1&D&C1&!C&B1&B&A1&!A|E&D1&D&!C1&!C&B1&B&A1&!A|E&D1&D&!C1&!C&B1&!B&A1&!A|E&D1&D&C1&!C&B1&!B&A1&!A|E&D1&D&C1&C&B1&!B&A1&!A|E&D1&D&!C1&C&B1&!B&A1&!A|E&D1&D&!C1&C&!B1&!B&A1&!A|E&D1&D&C1&C&!B1&!B&A1&!A|E&D1&D&C1&!C&!B1&!B&A1&!A|E&D1&D&!C1&!C&!B1&!B&A1&!A|E&D1&D&!C1&!C&!B1&!B&A1&A|E&!D1&D&C1&!C&!B1&!B&A1&A|E&D1&D&C1&!C&!B1&!B&A1&A|E&D1&!D&C1&!C&!B1&!B&A1&A|E&!D1&!D&C1&!C&!B1&!B&A1&A|E&!D1&!D&C1&C&!B1&!B&A1&A|E&D1&!D&C1&C&!B1&!B&A1&A|E&D1&D&C1&C&!B1&!B&A1&A|E&!D1&D&C1&C&!B1&!B&A1&A|E&!D1&D&!C1&C&!B1&!B&A1&A|E&D1&D&!C1&C&!B1&!B&A1&A|E&D1&!D&!C1&C&!B1&!B&A1&A|E&!D1&!D&!C1&C&!B1&!B&A1&A|E&!D1&!D&!C1&C&B1&!B&A1&A|E&D1&!D&!C1&C&B1&!B&A1&A|E&D1&D&!C1&C&B1&!B&A1&A|E&!D1&D&!C1&C&B1&!B&A1&A|E&!D1&D&C1&C&B1&!B&A1&A|E&D1&D&C1&C&B1&!B&A1&A|E&D1&!D&C1&C&B1&!B&A1&A|E&!D1&!D&C1&C&B1&!B&A1&A|E&!D1&!D&C1&!C&B1&!B&A1&A|E&D1&!D&C1&!C&B1&!B&A1&A|E&D1&D&C1&!C&B1&!B&A1&A|E&!D1&D&C1&!C&B1&!B&A1&A|E&D1&D&!C1&!C&B1&!B&A1&A|E&D1&D&!C1&!C&B1&B&A1&A|E&!D1&D&C1&!C&B1&B&A1&A|E&D1&D&C1&!C&B1&B&A1&A|E&D1&!D&C1&!C&B1&B&A1&A|E&!D1&!D&C1&!C&B1&B&A1&A|E&!D1&!D&C1&C&B1&B&A1&A|E&D1&!D&C1&C&B1&B&A1&A|E&D1&D&C1&C&B1&B&A1&A|E&!D1&D&C1&C&B1&B&A1&A|E&!D1&D&!C1&C&B1&B&A1&A|E&D1&D&!C1&C&B1&B&A1&A|E&D1&!D&!C1&C&B1&B&A1&A|E&!D1&!D&!C1&C&B1&B&A1&A|E&!D1&!D&!C1&C&!B1&B&A1&A|E&D1&!D&!C1&C&!B1&B&A1&A|E&D1&D&!C1&C&!B1&B&A1&A|E&!D1&D&!C1&C&!B1&B&A1&A|E&!D1&D&C1&C&!B1&B&A1&A|E&D1&D&C1&C&!B1&B&A1&A|E&D1&!D&C1&C&!B1&B&A1&A|E&!D1&!D&C1&C&!B1&B&A1&A|E&!D1&!D&C1&!C&!B1&B&A1&A|E&D1&!D&C1&!C&!B1&B&A1&A|E&D1&D&C1&!C&!B1&B&A1&A|E&!D1&D&C1&!C&!B1&B&A1&A|E&D1&D&!C1&!C&!B1&B&A1&A|E&D1&D&!C1&!C&!B1&B&!A1&A|E&D1&D&C1&!C&!B1&B&!A1&A|E&D1&D&C1&C&!B1&B&!A1&A|E&D1&D&!C1&C&!B1&B&!A1&A|E&!D1&!D&!C1&C&B1&B&!A1&A|E&D1&!D&!C1&C&B1&B&!A1&A|E&D1&D&!C1&C&B1&B&!A1&A|E&!D1&D&!C1&C&B1&B&!A1&A|E&!D1&D&C1&C&B1&B&!A1&A|E&D1&D&C1&C&B1&B&!A1&A|E&D1&!D&C1&C&B1&B&!A1&A|E&!D1&!D&C1&C&B1&B&!A1&A|E&!D1&!D&C1&!C&B1&B&!A1&A|E&D1&!D&C1&!C&B1&B&!A1&A|E&D1&D&C1&!C&B1&B&!A1&A|E&!D1&D&C1&!C&B1&B&!A1&A|E&D1&D&!C1&!C&B1&B&!A1&A|E&D1&D&!C1&!C&B1&!B&!A1&A|E&D1&D&C1&!C&B1&!B&!A1&A|E&D1&D&C1&C&B1&!B&!A1&A|E&D1&D&!C1&C&B1&!B&!A1&A|E&D1&D&!C1&C&!B1&!B&!A1&A|E&D1&D&C1&C&!B1&!B&!A1&A|E&D1&D&C1&!C&!B1&!B&!A1&A|E&D1&D&!C1&!C&!B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AAOOAAOAI22221.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOOAI2132 -l AOOOAI2132 -i D1 D C2 C1 C B A1 A -o Y -f Y=!(D1&!D&!C2&!C1&C&B&!A1&!A|D1&D&!C2&!C1&C&B&!A1&!A|!D1&D&!C2&!C1&C&B&!A1&!A|!D1&D&C2&!C1&C&B&!A1&!A|D1&D&C2&!C1&C&B&!A1&!A|D1&!D&C2&!C1&C&B&!A1&!A|D1&!D&C2&C1&C&B&!A1&!A|D1&D&C2&C1&C&B&!A1&!A|!D1&D&C2&C1&C&B&!A1&!A|!D1&D&!C2&C1&C&B&!A1&!A|D1&D&!C2&C1&C&B&!A1&!A|D1&!D&!C2&C1&C&B&!A1&!A|D1&!D&!C2&C1&!C&B&!A1&!A|D1&D&!C2&C1&!C&B&!A1&!A|!D1&D&!C2&C1&!C&B&!A1&!A|!D1&D&C2&C1&!C&B&!A1&!A|D1&D&C2&C1&!C&B&!A1&!A|D1&!D&C2&C1&!C&B&!A1&!A|D1&!D&C2&!C1&!C&B&!A1&!A|D1&D&C2&!C1&!C&B&!A1&!A|!D1&D&C2&!C1&!C&B&!A1&!A|!D1&D&C2&!C1&!C&B&A1&!A|D1&D&C2&!C1&!C&B&A1&!A|D1&!D&C2&!C1&!C&B&A1&!A|D1&!D&C2&C1&!C&B&A1&!A|D1&D&C2&C1&!C&B&A1&!A|!D1&D&C2&C1&!C&B&A1&!A|!D1&D&!C2&C1&!C&B&A1&!A|D1&D&!C2&C1&!C&B&A1&!A|D1&!D&!C2&C1&!C&B&A1&!A|D1&!D&!C2&C1&C&B&A1&!A|D1&D&!C2&C1&C&B&A1&!A|!D1&D&!C2&C1&C&B&A1&!A|!D1&D&C2&C1&C&B&A1&!A|D1&D&C2&C1&C&B&A1&!A|D1&!D&C2&C1&C&B&A1&!A|D1&!D&C2&!C1&C&B&A1&!A|D1&D&C2&!C1&C&B&A1&!A|!D1&D&C2&!C1&C&B&A1&!A|!D1&D&!C2&!C1&C&B&A1&!A|D1&D&!C2&!C1&C&B&A1&!A|D1&!D&!C2&!C1&C&B&A1&!A|!D1&D&C2&!C1&!C&!B&A1&A|D1&D&C2&!C1&!C&!B&A1&A|D1&!D&C2&!C1&!C&!B&A1&A|D1&!D&C2&C1&!C&!B&A1&A|D1&D&C2&C1&!C&!B&A1&A|!D1&D&C2&C1&!C&!B&A1&A|!D1&D&!C2&C1&!C&!B&A1&A|D1&D&!C2&C1&!C&!B&A1&A|D1&!D&!C2&C1&!C&!B&A1&A|D1&!D&!C2&C1&C&!B&A1&A|D1&D&!C2&C1&C&!B&A1&A|!D1&D&!C2&C1&C&!B&A1&A|!D1&D&C2&C1&C&!B&A1&A|D1&D&C2&C1&C&!B&A1&A|D1&!D&C2&C1&C&!B&A1&A|D1&!D&C2&!C1&C&!B&A1&A|D1&D&C2&!C1&C&!B&A1&A|!D1&D&C2&!C1&C&!B&A1&A|!D1&D&!C2&!C1&C&!B&A1&A|D1&D&!C2&!C1&C&!B&A1&A|D1&!D&!C2&!C1&C&!B&A1&A|D1&!D&!C2&!C1&C&B&A1&A|D1&D&!C2&!C1&C&B&A1&A|!D1&D&!C2&!C1&C&B&A1&A|!D1&D&C2&!C1&C&B&A1&A|D1&D&C2&!C1&C&B&A1&A|D1&!D&C2&!C1&C&B&A1&A|D1&!D&C2&C1&C&B&A1&A|D1&D&C2&C1&C&B&A1&A|!D1&D&C2&C1&C&B&A1&A|!D1&D&!C2&C1&C&B&A1&A|D1&D&!C2&C1&C&B&A1&A|D1&!D&!C2&C1&C&B&A1&A|D1&!D&!C2&C1&!C&B&A1&A|D1&D&!C2&C1&!C&B&A1&A|!D1&D&!C2&C1&!C&B&A1&A|!D1&D&C2&C1&!C&B&A1&A|D1&D&C2&C1&!C&B&A1&A|D1&!D&C2&C1&!C&B&A1&A|D1&!D&C2&!C1&!C&B&A1&A|D1&D&C2&!C1&!C&B&A1&A|!D1&D&C2&!C1&!C&B&A1&A|!D1&D&C2&!C1&!C&B&!A1&A|D1&D&C2&!C1&!C&B&!A1&A|D1&!D&C2&!C1&!C&B&!A1&A|D1&!D&C2&C1&!C&B&!A1&A|D1&D&C2&C1&!C&B&!A1&A|!D1&D&C2&C1&!C&B&!A1&A|!D1&D&!C2&C1&!C&B&!A1&A|D1&D&!C2&C1&!C&B&!A1&A|D1&!D&!C2&C1&!C&B&!A1&A|D1&!D&!C2&C1&C&B&!A1&A|D1&D&!C2&C1&C&B&!A1&A|!D1&D&!C2&C1&C&B&!A1&A|!D1&D&C2&C1&C&B&!A1&A|D1&D&C2&C1&C&B&!A1&A|D1&!D&C2&C1&C&B&!A1&A|D1&!D&C2&!C1&C&B&!A1&A|D1&D&C2&!C1&C&B&!A1&A|!D1&D&C2&!C1&C&B&!A1&A|!D1&D&!C2&!C1&C&B&!A1&A|D1&D&!C2&!C1&C&B&!A1&A|D1&!D&!C2&!C1&C&B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOOAI2132.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOI2122 -l AOAAOI2122 -i D1 D C1 C B A1 A -o Y -f Y=!(D1&D&!C1&!C&!B&!A1&!A|D1&D&C1&!C&!B&!A1&!A|D1&D&C1&C&!B&!A1&!A|D1&D&!C1&C&!B&!A1&!A|D1&D&!C1&C&B&!A1&!A|!D1&D&C1&C&B&!A1&!A|D1&D&C1&C&B&!A1&!A|D1&!D&C1&C&B&!A1&!A|!D1&!D&C1&C&B&!A1&!A|D1&D&C1&!C&B&!A1&!A|D1&D&!C1&!C&B&!A1&!A|D1&D&!C1&!C&B&A1&!A|D1&D&C1&!C&B&A1&!A|!D1&!D&C1&C&B&A1&!A|D1&!D&C1&C&B&A1&!A|D1&D&C1&C&B&A1&!A|!D1&D&C1&C&B&A1&!A|D1&D&!C1&C&B&A1&!A|D1&D&!C1&C&!B&A1&!A|D1&D&C1&C&!B&A1&!A|D1&D&C1&!C&!B&A1&!A|D1&D&!C1&!C&!B&A1&!A|D1&D&!C1&!C&!B&A1&A|D1&D&C1&!C&!B&A1&A|!D1&!D&C1&C&!B&A1&A|D1&!D&C1&C&!B&A1&A|D1&D&C1&C&!B&A1&A|!D1&D&C1&C&!B&A1&A|D1&D&!C1&C&!B&A1&A|D1&D&!C1&C&B&A1&A|!D1&D&C1&C&B&A1&A|D1&D&C1&C&B&A1&A|D1&!D&C1&C&B&A1&A|!D1&!D&C1&C&B&A1&A|D1&D&C1&!C&B&A1&A|D1&D&!C1&!C&B&A1&A|D1&D&!C1&!C&B&!A1&A|D1&D&C1&!C&B&!A1&A|!D1&!D&C1&C&B&!A1&A|D1&!D&C1&C&B&!A1&A|D1&D&C1&C&B&!A1&A|!D1&D&C1&C&B&!A1&A|D1&D&!C1&C&B&!A1&A|D1&D&!C1&C&!B&!A1&A|D1&D&C1&C&!B&!A1&A|D1&D&C1&!C&!B&!A1&A|D1&D&!C1&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOI2122.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OAI32 -l OAI32 -i B1 B A2 A1 A -o Y -f Y=!(B1&B&A2&!A1&!A|B1&B&A2&A1&!A|B1&B&!A2&A1&!A|B1&B&!A2&A1&A|B1&B&A2&A1&A|B1&B&A2&!A1&A|B1&B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OAI32.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n OOAI222 -l OOAI222 -i C1 C B1 B A1 A -o Y -f Y=!(C1&C&!B1&B&A1&!A|C1&C&B1&B&A1&!A|C1&C&B1&!B&A1&!A|C1&C&B1&!B&A1&A|C1&C&B1&B&A1&A|C1&C&!B1&B&A1&A|C1&C&!B1&B&!A1&A|C1&C&B1&B&!A1&A|C1&C&B1&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist OOAI222.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAOAAOI211113 -l AOAOAAOI211113 -i F2 F1 F E D C B A1 A -o Y -f Y=!(F2&F1&F&!E&!D&!C&!B&!A1&!A|F2&F1&F&E&!D&!C&!B&!A1&!A|!F2&!F1&!F&E&D&!C&!B&!A1&!A|F2&!F1&!F&E&D&!C&!B&!A1&!A|F2&F1&!F&E&D&!C&!B&!A1&!A|!F2&F1&!F&E&D&!C&!B&!A1&!A|!F2&F1&F&E&D&!C&!B&!A1&!A|F2&F1&F&E&D&!C&!B&!A1&!A|F2&!F1&F&E&D&!C&!B&!A1&!A|!F2&!F1&F&E&D&!C&!B&!A1&!A|F2&F1&F&!E&D&!C&!B&!A1&!A|F2&F1&F&!E&D&C&!B&!A1&!A|!F2&!F1&F&E&D&C&!B&!A1&!A|F2&!F1&F&E&D&C&!B&!A1&!A|F2&F1&F&E&D&C&!B&!A1&!A|!F2&F1&F&E&D&C&!B&!A1&!A|!F2&F1&!F&E&D&C&!B&!A1&!A|F2&F1&!F&E&D&C&!B&!A1&!A|F2&!F1&!F&E&D&C&!B&!A1&!A|!F2&!F1&!F&E&D&C&!B&!A1&!A|F2&F1&F&E&!D&C&!B&!A1&!A|F2&F1&F&!E&!D&C&!B&!A1&!A|F2&F1&F&!E&!D&C&B&!A1&!A|!F2&!F1&F&E&!D&C&B&!A1&!A|F2&!F1&F&E&!D&C&B&!A1&!A|F2&F1&F&E&!D&C&B&!A1&!A|!F2&F1&F&E&!D&C&B&!A1&!A|!F2&F1&!F&E&!D&C&B&!A1&!A|F2&F1&!F&E&!D&C&B&!A1&!A|F2&!F1&!F&E&!D&C&B&!A1&!A|!F2&!F1&!F&E&!D&C&B&!A1&!A|!F2&!F1&!F&E&D&C&B&!A1&!A|F2&!F1&!F&E&D&C&B&!A1&!A|F2&F1&!F&E&D&C&B&!A1&!A|!F2&F1&!F&E&D&C&B&!A1&!A|!F2&F1&F&E&D&C&B&!A1&!A|F2&F1&F&E&D&C&B&!A1&!A|F2&!F1&F&E&D&C&B&!A1&!A|!F2&!F1&F&E&D&C&B&!A1&!A|F2&F1&F&!E&D&C&B&!A1&!A|F2&F1&F&!E&D&!C&B&!A1&!A|!F2&!F1&F&E&D&!C&B&!A1&!A|F2&!F1&F&E&D&!C&B&!A1&!A|F2&F1&F&E&D&!C&B&!A1&!A|!F2&F1&F&E&D&!C&B&!A1&!A|!F2&F1&!F&E&D&!C&B&!A1&!A|F2&F1&!F&E&D&!C&B&!A1&!A|F2&!F1&!F&E&D&!C&B&!A1&!A|!F2&!F1&!F&E&D&!C&B&!A1&!A|F2&F1&F&E&!D&!C&B&!A1&!A|F2&F1&F&!E&!D&!C&B&!A1&!A|F2&F1&F&!E&!D&!C&B&A1&!A|F2&F1&F&E&!D&!C&B&A1&!A|!F2&!F1&!F&E&D&!C&B&A1&!A|F2&!F1&!F&E&D&!C&B&A1&!A|F2&F1&!F&E&D&!C&B&A1&!A|!F2&F1&!F&E&D&!C&B&A1&!A|!F2&F1&F&E&D&!C&B&A1&!A|F2&F1&F&E&D&!C&B&A1&!A|F2&!F1&F&E&D&!C&B&A1&!A|!F2&!F1&F&E&D&!C&B&A1&!A|F2&F1&F&!E&D&!C&B&A1&!A|F2&F1&F&!E&D&C&B&A1&!A|!F2&!F1&F&E&D&C&B&A1&!A|F2&!F1&F&E&D&C&B&A1&!A|F2&F1&F&E&D&C&B&A1&!A|!F2&F1&F&E&D&C&B&A1&!A|!F2&F1&!F&E&D&C&B&A1&!A|F2&F1&!F&E&D&C&B&A1&!A|F2&!F1&!F&E&D&C&B&A1&!A|!F2&!F1&!F&E&D&C&B&A1&!A|!F2&!F1&!F&E&!D&C&B&A1&!A|F2&!F1&!F&E&!D&C&B&A1&!A|F2&F1&!F&E&!D&C&B&A1&!A|!F2&F1&!F&E&!D&C&B&A1&!A|!F2&F1&F&E&!D&C&B&A1&!A|F2&F1&F&E&!D&C&B&A1&!A|F2&!F1&F&E&!D&C&B&A1&!A|!F2&!F1&F&E&!D&C&B&A1&!A|F2&F1&F&!E&!D&C&B&A1&!A|F2&F1&F&!E&!D&C&!B&A1&!A|F2&F1&F&E&!D&C&!B&A1&!A|!F2&!F1&!F&E&D&C&!B&A1&!A|F2&!F1&!F&E&D&C&!B&A1&!A|F2&F1&!F&E&D&C&!B&A1&!A|!F2&F1&!F&E&D&C&!B&A1&!A|!F2&F1&F&E&D&C&!B&A1&!A|F2&F1&F&E&D&C&!B&A1&!A|F2&!F1&F&E&D&C&!B&A1&!A|!F2&!F1&F&E&D&C&!B&A1&!A|F2&F1&F&!E&D&C&!B&A1&!A|F2&F1&F&!E&D&!C&!B&A1&!A|!F2&!F1&F&E&D&!C&!B&A1&!A|F2&!F1&F&E&D&!C&!B&A1&!A|F2&F1&F&E&D&!C&!B&A1&!A|!F2&F1&F&E&D&!C&!B&A1&!A|!F2&F1&!F&E&D&!C&!B&A1&!A|F2&F1&!F&E&D&!C&!B&A1&!A|F2&!F1&!F&E&D&!C&!B&A1&!A|!F2&!F1&!F&E&D&!C&!B&A1&!A|F2&F1&F&E&!D&!C&!B&A1&!A|F2&F1&F&!E&!D&!C&!B&A1&!A|F2&F1&F&!E&!D&!C&!B&A1&A|F2&F1&F&E&!D&!C&!B&A1&A|!F2&!F1&!F&E&D&!C&!B&A1&A|F2&!F1&!F&E&D&!C&!B&A1&A|F2&F1&!F&E&D&!C&!B&A1&A|!F2&F1&!F&E&D&!C&!B&A1&A|!F2&F1&F&E&D&!C&!B&A1&A|F2&F1&F&E&D&!C&!B&A1&A|F2&!F1&F&E&D&!C&!B&A1&A|!F2&!F1&F&E&D&!C&!B&A1&A|F2&F1&F&!E&D&!C&!B&A1&A|F2&F1&F&!E&D&C&!B&A1&A|!F2&!F1&F&E&D&C&!B&A1&A|F2&!F1&F&E&D&C&!B&A1&A|F2&F1&F&E&D&C&!B&A1&A|!F2&F1&F&E&D&C&!B&A1&A|!F2&F1&!F&E&D&C&!B&A1&A|F2&F1&!F&E&D&C&!B&A1&A|F2&!F1&!F&E&D&C&!B&A1&A|!F2&!F1&!F&E&D&C&!B&A1&A|!F2&!F1&!F&E&!D&C&!B&A1&A|F2&!F1&!F&E&!D&C&!B&A1&A|F2&F1&!F&E&!D&C&!B&A1&A|!F2&F1&!F&E&!D&C&!B&A1&A|!F2&F1&F&E&!D&C&!B&A1&A|F2&F1&F&E&!D&C&!B&A1&A|F2&!F1&F&E&!D&C&!B&A1&A|!F2&!F1&F&E&!D&C&!B&A1&A|F2&F1&F&!E&!D&C&!B&A1&A|F2&F1&F&!E&!D&C&B&A1&A|!F2&!F1&F&E&!D&C&B&A1&A|F2&!F1&F&E&!D&C&B&A1&A|F2&F1&F&E&!D&C&B&A1&A|!F2&F1&F&E&!D&C&B&A1&A|!F2&F1&!F&E&!D&C&B&A1&A|F2&F1&!F&E&!D&C&B&A1&A|F2&!F1&!F&E&!D&C&B&A1&A|!F2&!F1&!F&E&!D&C&B&A1&A|!F2&!F1&!F&E&D&C&B&A1&A|F2&!F1&!F&E&D&C&B&A1&A|F2&F1&!F&E&D&C&B&A1&A|!F2&F1&!F&E&D&C&B&A1&A|!F2&F1&F&E&D&C&B&A1&A|F2&F1&F&E&D&C&B&A1&A|F2&!F1&F&E&D&C&B&A1&A|!F2&!F1&F&E&D&C&B&A1&A|F2&F1&F&!E&D&C&B&A1&A|F2&F1&F&!E&D&!C&B&A1&A|!F2&!F1&F&E&D&!C&B&A1&A|F2&!F1&F&E&D&!C&B&A1&A|F2&F1&F&E&D&!C&B&A1&A|!F2&F1&F&E&D&!C&B&A1&A|!F2&F1&!F&E&D&!C&B&A1&A|F2&F1&!F&E&D&!C&B&A1&A|F2&!F1&!F&E&D&!C&B&A1&A|!F2&!F1&!F&E&D&!C&B&A1&A|F2&F1&F&E&!D&!C&B&A1&A|F2&F1&F&!E&!D&!C&B&A1&A|F2&F1&F&!E&!D&!C&B&!A1&A|F2&F1&F&E&!D&!C&B&!A1&A|!F2&!F1&!F&E&D&!C&B&!A1&A|F2&!F1&!F&E&D&!C&B&!A1&A|F2&F1&!F&E&D&!C&B&!A1&A|!F2&F1&!F&E&D&!C&B&!A1&A|!F2&F1&F&E&D&!C&B&!A1&A|F2&F1&F&E&D&!C&B&!A1&A|F2&!F1&F&E&D&!C&B&!A1&A|!F2&!F1&F&E&D&!C&B&!A1&A|F2&F1&F&!E&D&!C&B&!A1&A|F2&F1&F&!E&D&C&B&!A1&A|!F2&!F1&F&E&D&C&B&!A1&A|F2&!F1&F&E&D&C&B&!A1&A|F2&F1&F&E&D&C&B&!A1&A|!F2&F1&F&E&D&C&B&!A1&A|!F2&F1&!F&E&D&C&B&!A1&A|F2&F1&!F&E&D&C&B&!A1&A|F2&!F1&!F&E&D&C&B&!A1&A|!F2&!F1&!F&E&D&C&B&!A1&A|!F2&!F1&!F&E&!D&C&B&!A1&A|F2&!F1&!F&E&!D&C&B&!A1&A|F2&F1&!F&E&!D&C&B&!A1&A|!F2&F1&!F&E&!D&C&B&!A1&A|!F2&F1&F&E&!D&C&B&!A1&A|F2&F1&F&E&!D&C&B&!A1&A|F2&!F1&F&E&!D&C&B&!A1&A|!F2&!F1&F&E&!D&C&B&!A1&A|F2&F1&F&!E&!D&C&B&!A1&A|F2&F1&F&!E&!D&C&!B&!A1&A|F2&F1&F&E&!D&C&!B&!A1&A|!F2&!F1&!F&E&D&C&!B&!A1&A|F2&!F1&!F&E&D&C&!B&!A1&A|F2&F1&!F&E&D&C&!B&!A1&A|!F2&F1&!F&E&D&C&!B&!A1&A|!F2&F1&F&E&D&C&!B&!A1&A|F2&F1&F&E&D&C&!B&!A1&A|F2&!F1&F&E&D&C&!B&!A1&A|!F2&!F1&F&E&D&C&!B&!A1&A|F2&F1&F&!E&D&C&!B&!A1&A|F2&F1&F&!E&D&!C&!B&!A1&A|!F2&!F1&F&E&D&!C&!B&!A1&A|F2&!F1&F&E&D&!C&!B&!A1&A|F2&F1&F&E&D&!C&!B&!A1&A|!F2&F1&F&E&D&!C&!B&!A1&A|!F2&F1&!F&E&D&!C&!B&!A1&A|F2&F1&!F&E&D&!C&!B&!A1&A|F2&!F1&!F&E&D&!C&!B&!A1&A|!F2&!F1&!F&E&D&!C&!B&!A1&A|F2&F1&F&E&!D&!C&!B&!A1&A|F2&F1&F&!E&!D&!C&!B&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAOAAOI211113.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOAAOI3112 -l AOAAOI3112 -i D1 D C B A2 A1 A -o Y -f Y=!(D1&D&!C&!B&!A2&!A1&!A|D1&D&C&!B&!A2&!A1&!A|!D1&!D&C&B&!A2&!A1&!A|D1&!D&C&B&!A2&!A1&!A|D1&D&C&B&!A2&!A1&!A|!D1&D&C&B&!A2&!A1&!A|D1&D&!C&B&!A2&!A1&!A|D1&D&!C&B&A2&!A1&!A|!D1&D&C&B&A2&!A1&!A|D1&D&C&B&A2&!A1&!A|D1&!D&C&B&A2&!A1&!A|!D1&!D&C&B&A2&!A1&!A|D1&D&C&!B&A2&!A1&!A|D1&D&!C&!B&A2&!A1&!A|D1&D&!C&!B&A2&A1&!A|D1&D&C&!B&A2&A1&!A|!D1&!D&C&B&A2&A1&!A|D1&!D&C&B&A2&A1&!A|D1&D&C&B&A2&A1&!A|!D1&D&C&B&A2&A1&!A|D1&D&!C&B&A2&A1&!A|D1&D&!C&B&!A2&A1&!A|!D1&D&C&B&!A2&A1&!A|D1&D&C&B&!A2&A1&!A|D1&!D&C&B&!A2&A1&!A|!D1&!D&C&B&!A2&A1&!A|D1&D&C&!B&!A2&A1&!A|D1&D&!C&!B&!A2&A1&!A|D1&D&!C&!B&!A2&A1&A|D1&D&C&!B&!A2&A1&A|!D1&!D&C&B&!A2&A1&A|D1&!D&C&B&!A2&A1&A|D1&D&C&B&!A2&A1&A|!D1&D&C&B&!A2&A1&A|D1&D&!C&B&!A2&A1&A|D1&D&!C&B&A2&A1&A|!D1&D&C&B&A2&A1&A|D1&D&C&B&A2&A1&A|D1&!D&C&B&A2&A1&A|!D1&!D&C&B&A2&A1&A|!D1&!D&C&!B&A2&A1&A|D1&!D&C&!B&A2&A1&A|D1&D&C&!B&A2&A1&A|!D1&D&C&!B&A2&A1&A|D1&D&!C&!B&A2&A1&A|D1&D&!C&!B&A2&!A1&A|D1&D&C&!B&A2&!A1&A|!D1&!D&C&B&A2&!A1&A|D1&!D&C&B&A2&!A1&A|D1&D&C&B&A2&!A1&A|!D1&D&C&B&A2&!A1&A|D1&D&!C&B&A2&!A1&A|D1&D&!C&B&!A2&!A1&A|!D1&D&C&B&!A2&!A1&A|D1&D&C&B&!A2&!A1&A|D1&!D&C&B&!A2&!A1&A|!D1&!D&C&B&!A2&!A1&A|D1&D&C&!B&!A2&!A1&A|D1&D&!C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOAAOI3112.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export


## add circuit
add_cell -n AOOAI314 -l AOOAI314 -i C3 C2 C1 C B A2 A1 A -o Y -f Y=(!C3&!C2&!C1&!C&!B&!A2&!A1&!A|C3&!C2&!C1&!C&!B&!A2&!A1&!A|C3&C2&!C1&!C&!B&!A2&!A1&!A|!C3&C2&!C1&!C&!B&!A2&!A1&!A|!C3&C2&C1&!C&!B&!A2&!A1&!A|C3&C2&C1&!C&!B&!A2&!A1&!A|C3&!C2&C1&!C&!B&!A2&!A1&!A|!C3&!C2&C1&!C&!B&!A2&!A1&!A|!C3&!C2&C1&C&!B&!A2&!A1&!A|C3&!C2&C1&C&!B&!A2&!A1&!A|C3&C2&C1&C&!B&!A2&!A1&!A|!C3&C2&C1&C&!B&!A2&!A1&!A|!C3&C2&!C1&C&!B&!A2&!A1&!A|C3&C2&!C1&C&!B&!A2&!A1&!A|C3&!C2&!C1&C&!B&!A2&!A1&!A|!C3&!C2&!C1&C&!B&!A2&!A1&!A|!C3&!C2&!C1&!C&B&!A2&!A1&!A|!C3&!C2&!C1&!C&B&A2&!A1&!A|!C3&!C2&!C1&C&!B&A2&!A1&!A|C3&!C2&!C1&C&!B&A2&!A1&!A|C3&C2&!C1&C&!B&A2&!A1&!A|!C3&C2&!C1&C&!B&A2&!A1&!A|!C3&C2&C1&C&!B&A2&!A1&!A|C3&C2&C1&C&!B&A2&!A1&!A|C3&!C2&C1&C&!B&A2&!A1&!A|!C3&!C2&C1&C&!B&A2&!A1&!A|!C3&!C2&C1&!C&!B&A2&!A1&!A|C3&!C2&C1&!C&!B&A2&!A1&!A|C3&C2&C1&!C&!B&A2&!A1&!A|!C3&C2&C1&!C&!B&A2&!A1&!A|!C3&C2&!C1&!C&!B&A2&!A1&!A|C3&C2&!C1&!C&!B&A2&!A1&!A|C3&!C2&!C1&!C&!B&A2&!A1&!A|!C3&!C2&!C1&!C&!B&A2&!A1&!A|!C3&!C2&!C1&!C&!B&A2&A1&!A|C3&!C2&!C1&!C&!B&A2&A1&!A|C3&C2&!C1&!C&!B&A2&A1&!A|!C3&C2&!C1&!C&!B&A2&A1&!A|!C3&C2&C1&!C&!B&A2&A1&!A|C3&C2&C1&!C&!B&A2&A1&!A|C3&!C2&C1&!C&!B&A2&A1&!A|!C3&!C2&C1&!C&!B&A2&A1&!A|!C3&!C2&C1&C&!B&A2&A1&!A|C3&!C2&C1&C&!B&A2&A1&!A|C3&C2&C1&C&!B&A2&A1&!A|!C3&C2&C1&C&!B&A2&A1&!A|!C3&C2&!C1&C&!B&A2&A1&!A|C3&C2&!C1&C&!B&A2&A1&!A|C3&!C2&!C1&C&!B&A2&A1&!A|!C3&!C2&!C1&C&!B&A2&A1&!A|!C3&!C2&!C1&!C&B&A2&A1&!A|!C3&!C2&!C1&!C&B&!A2&A1&!A|!C3&!C2&!C1&C&!B&!A2&A1&!A|C3&!C2&!C1&C&!B&!A2&A1&!A|C3&C2&!C1&C&!B&!A2&A1&!A|!C3&C2&!C1&C&!B&!A2&A1&!A|!C3&C2&C1&C&!B&!A2&A1&!A|C3&C2&C1&C&!B&!A2&A1&!A|C3&!C2&C1&C&!B&!A2&A1&!A|!C3&!C2&C1&C&!B&!A2&A1&!A|!C3&!C2&C1&!C&!B&!A2&A1&!A|C3&!C2&C1&!C&!B&!A2&A1&!A|C3&C2&C1&!C&!B&!A2&A1&!A|!C3&C2&C1&!C&!B&!A2&A1&!A|!C3&C2&!C1&!C&!B&!A2&A1&!A|C3&C2&!C1&!C&!B&!A2&A1&!A|C3&!C2&!C1&!C&!B&!A2&A1&!A|!C3&!C2&!C1&!C&!B&!A2&A1&!A|!C3&!C2&!C1&!C&!B&!A2&A1&A|C3&!C2&!C1&!C&!B&!A2&A1&A|C3&C2&!C1&!C&!B&!A2&A1&A|!C3&C2&!C1&!C&!B&!A2&A1&A|!C3&C2&C1&!C&!B&!A2&A1&A|C3&C2&C1&!C&!B&!A2&A1&A|C3&!C2&C1&!C&!B&!A2&A1&A|!C3&!C2&C1&!C&!B&!A2&A1&A|!C3&!C2&C1&C&!B&!A2&A1&A|C3&!C2&C1&C&!B&!A2&A1&A|C3&C2&C1&C&!B&!A2&A1&A|!C3&C2&C1&C&!B&!A2&A1&A|!C3&C2&!C1&C&!B&!A2&A1&A|C3&C2&!C1&C&!B&!A2&A1&A|C3&!C2&!C1&C&!B&!A2&A1&A|!C3&!C2&!C1&C&!B&!A2&A1&A|!C3&!C2&!C1&!C&B&!A2&A1&A|!C3&!C2&!C1&!C&B&A2&A1&A|!C3&!C2&!C1&!C&!B&A2&A1&A|!C3&!C2&!C1&!C&!B&A2&!A1&A|C3&!C2&!C1&!C&!B&A2&!A1&A|C3&C2&!C1&!C&!B&A2&!A1&A|!C3&C2&!C1&!C&!B&A2&!A1&A|!C3&C2&C1&!C&!B&A2&!A1&A|C3&C2&C1&!C&!B&A2&!A1&A|C3&!C2&C1&!C&!B&A2&!A1&A|!C3&!C2&C1&!C&!B&A2&!A1&A|!C3&!C2&C1&C&!B&A2&!A1&A|C3&!C2&C1&C&!B&A2&!A1&A|C3&C2&C1&C&!B&A2&!A1&A|!C3&C2&C1&C&!B&A2&!A1&A|!C3&C2&!C1&C&!B&A2&!A1&A|C3&C2&!C1&C&!B&A2&!A1&A|C3&!C2&!C1&C&!B&A2&!A1&A|!C3&!C2&!C1&C&!B&A2&!A1&A|!C3&!C2&!C1&!C&B&A2&!A1&A|!C3&!C2&!C1&!C&B&!A2&!A1&A|!C3&!C2&!C1&C&!B&!A2&!A1&A|C3&!C2&!C1&C&!B&!A2&!A1&A|C3&C2&!C1&C&!B&!A2&!A1&A|!C3&C2&!C1&C&!B&!A2&!A1&A|!C3&C2&C1&C&!B&!A2&!A1&A|C3&C2&C1&C&!B&!A2&!A1&A|C3&!C2&C1&C&!B&!A2&!A1&A|!C3&!C2&C1&C&!B&!A2&!A1&A|!C3&!C2&C1&!C&!B&!A2&!A1&A|C3&!C2&C1&!C&!B&!A2&!A1&A|C3&C2&C1&!C&!B&!A2&!A1&A|!C3&C2&C1&!C&!B&!A2&!A1&A|!C3&C2&!C1&!C&!B&!A2&!A1&A|C3&C2&!C1&!C&!B&!A2&!A1&A|C3&!C2&!C1&!C&!B&!A2&!A1&A|!C3&!C2&!C1&!C&!B&!A2&!A1&A) 
add_slope {0.1 4.9} 
add_load  {0.01 0.49} 
add_area 1
add_netlist AOOAI314.sp
add_model NETLIST/model.sp
add_simulation_timestep auto
characterize
export

exit
